// Dafny 2.3.0.10506
// Command Line Options: /compile:0 /timeLimit:1 /print:boogies/Impl-IndirectionTableImpl.i.dfy.bpl /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy

const $$Language$Dafny: bool;

axiom $$Language$Dafny;

type Ty;

type Bv0 = int;

const unique TBool: Ty;

const unique TChar: Ty;

const unique TInt: Ty;

const unique TReal: Ty;

const unique TORDINAL: Ty;

function TBitvector(int) : Ty;

function TSet(Ty) : Ty;

function TISet(Ty) : Ty;

function TMultiSet(Ty) : Ty;

function TSeq(Ty) : Ty;

function TMap(Ty, Ty) : Ty;

function TIMap(Ty, Ty) : Ty;

function Inv0_TBitvector(Ty) : int;

axiom (forall w: int :: { TBitvector(w) } Inv0_TBitvector(TBitvector(w)) == w);

function Inv0_TSet(Ty) : Ty;

axiom (forall t: Ty :: { TSet(t) } Inv0_TSet(TSet(t)) == t);

function Inv0_TISet(Ty) : Ty;

axiom (forall t: Ty :: { TISet(t) } Inv0_TISet(TISet(t)) == t);

function Inv0_TSeq(Ty) : Ty;

axiom (forall t: Ty :: { TSeq(t) } Inv0_TSeq(TSeq(t)) == t);

function Inv0_TMultiSet(Ty) : Ty;

axiom (forall t: Ty :: { TMultiSet(t) } Inv0_TMultiSet(TMultiSet(t)) == t);

function Inv0_TMap(Ty) : Ty;

function Inv1_TMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv0_TMap(TMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Inv1_TMap(TMap(t, u)) == u);

function Inv0_TIMap(Ty) : Ty;

function Inv1_TIMap(Ty) : Ty;

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv0_TIMap(TIMap(t, u)) == t);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Inv1_TIMap(TIMap(t, u)) == u);

type TyTag;

function Tag(Ty) : TyTag;

const unique TagBool: TyTag;

const unique TagChar: TyTag;

const unique TagInt: TyTag;

const unique TagReal: TyTag;

const unique TagORDINAL: TyTag;

const unique TagSet: TyTag;

const unique TagISet: TyTag;

const unique TagMultiSet: TyTag;

const unique TagSeq: TyTag;

const unique TagMap: TyTag;

const unique TagIMap: TyTag;

const unique TagClass: TyTag;

axiom Tag(TBool) == TagBool;

axiom Tag(TChar) == TagChar;

axiom Tag(TInt) == TagInt;

axiom Tag(TReal) == TagReal;

axiom Tag(TORDINAL) == TagORDINAL;

axiom (forall t: Ty :: { TSet(t) } Tag(TSet(t)) == TagSet);

axiom (forall t: Ty :: { TISet(t) } Tag(TISet(t)) == TagISet);

axiom (forall t: Ty :: { TMultiSet(t) } Tag(TMultiSet(t)) == TagMultiSet);

axiom (forall t: Ty :: { TSeq(t) } Tag(TSeq(t)) == TagSeq);

axiom (forall t: Ty, u: Ty :: { TMap(t, u) } Tag(TMap(t, u)) == TagMap);

axiom (forall t: Ty, u: Ty :: { TIMap(t, u) } Tag(TIMap(t, u)) == TagIMap);

function {:identity} Lit<T>(x: T) : T;

axiom (forall<T> x: T :: {:identity} { Lit(x): T } Lit(x): T == x);

axiom (forall<T> x: T :: { $Box(Lit(x)) } $Box(Lit(x)) == Lit($Box(x)));

function {:identity} LitInt(x: int) : int;

axiom (forall x: int :: {:identity} { LitInt(x): int } LitInt(x): int == x);

axiom (forall x: int :: { $Box(LitInt(x)) } $Box(LitInt(x)) == Lit($Box(x)));

function {:identity} LitReal(x: real) : real;

axiom (forall x: real :: {:identity} { LitReal(x): real } LitReal(x): real == x);

axiom (forall x: real :: { $Box(LitReal(x)) } $Box(LitReal(x)) == Lit($Box(x)));

type char;

function char#FromInt(int) : char;

function char#ToInt(char) : int;

axiom (forall ch: char :: 
  { char#ToInt(ch) } 
  char#FromInt(char#ToInt(ch)) == ch
     && 0 <= char#ToInt(ch)
     && char#ToInt(ch) < 65536);

axiom (forall n: int :: 
  { char#FromInt(n) } 
  0 <= n && n < 65536 ==> char#ToInt(char#FromInt(n)) == n);

function char#Plus(char, char) : char;

function char#Minus(char, char) : char;

axiom (forall a: char, b: char :: 
  { char#Plus(a, b) } 
  char#Plus(a, b) == char#FromInt(char#ToInt(a) + char#ToInt(b)));

axiom (forall a: char, b: char :: 
  { char#Minus(a, b) } 
  char#Minus(a, b) == char#FromInt(char#ToInt(a) - char#ToInt(b)));

type ref;

const null: ref;

function IsTraitParent(classOrTrait: ClassName, traitParent: ClassName) : bool;

type Box;

const $ArbitraryBoxValue: Box;

function $Box<T>(T) : Box;

function $Unbox<T>(Box) : T;

axiom (forall<T> x: T :: { $Box(x) } $Unbox($Box(x)) == x);

axiom (forall bx: Box :: 
  { $IsBox(bx, TInt) } 
  $IsBox(bx, TInt) ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, TInt));

axiom (forall bx: Box :: 
  { $IsBox(bx, TReal) } 
  $IsBox(bx, TReal)
     ==> $Box($Unbox(bx): real) == bx && $Is($Unbox(bx): real, TReal));

axiom (forall bx: Box :: 
  { $IsBox(bx, TBool) } 
  $IsBox(bx, TBool)
     ==> $Box($Unbox(bx): bool) == bx && $Is($Unbox(bx): bool, TBool));

axiom (forall bx: Box :: 
  { $IsBox(bx, TChar) } 
  $IsBox(bx, TChar)
     ==> $Box($Unbox(bx): char) == bx && $Is($Unbox(bx): char, TChar));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSet(t)) } 
  $IsBox(bx, TSet(t))
     ==> $Box($Unbox(bx): Set Box) == bx && $Is($Unbox(bx): Set Box, TSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TISet(t)) } 
  $IsBox(bx, TISet(t))
     ==> $Box($Unbox(bx): ISet Box) == bx && $Is($Unbox(bx): ISet Box, TISet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TMultiSet(t)) } 
  $IsBox(bx, TMultiSet(t))
     ==> $Box($Unbox(bx): MultiSet Box) == bx
       && $Is($Unbox(bx): MultiSet Box, TMultiSet(t)));

axiom (forall bx: Box, t: Ty :: 
  { $IsBox(bx, TSeq(t)) } 
  $IsBox(bx, TSeq(t))
     ==> $Box($Unbox(bx): Seq Box) == bx && $Is($Unbox(bx): Seq Box, TSeq(t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TMap(s, t)) } 
  $IsBox(bx, TMap(s, t))
     ==> $Box($Unbox(bx): Map Box Box) == bx && $Is($Unbox(bx): Map Box Box, TMap(s, t)));

axiom (forall bx: Box, s: Ty, t: Ty :: 
  { $IsBox(bx, TIMap(s, t)) } 
  $IsBox(bx, TIMap(s, t))
     ==> $Box($Unbox(bx): IMap Box Box) == bx
       && $Is($Unbox(bx): IMap Box Box, TIMap(s, t)));

axiom (forall<T> v: T, t: Ty :: 
  { $IsBox($Box(v), t) } 
  $IsBox($Box(v), t) <==> $Is(v, t));

axiom (forall<T> v: T, t: Ty, h: Heap :: 
  { $IsAllocBox($Box(v), t, h) } 
  $IsAllocBox($Box(v), t, h) <==> $IsAlloc(v, t, h));

function $Is<T>(T, Ty) : bool;

function $IsAlloc<T>(T, Ty, Heap) : bool;

function $IsBox<T>(T, Ty) : bool;

function $IsAllocBox<T>(T, Ty, Heap) : bool;

axiom (forall v: int :: { $Is(v, TInt) } $Is(v, TInt));

axiom (forall v: real :: { $Is(v, TReal) } $Is(v, TReal));

axiom (forall v: bool :: { $Is(v, TBool) } $Is(v, TBool));

axiom (forall v: char :: { $Is(v, TChar) } $Is(v, TChar));

axiom (forall v: ORDINAL :: { $Is(v, TORDINAL) } $Is(v, TORDINAL));

axiom (forall h: Heap, v: int :: { $IsAlloc(v, TInt, h) } $IsAlloc(v, TInt, h));

axiom (forall h: Heap, v: real :: { $IsAlloc(v, TReal, h) } $IsAlloc(v, TReal, h));

axiom (forall h: Heap, v: bool :: { $IsAlloc(v, TBool, h) } $IsAlloc(v, TBool, h));

axiom (forall h: Heap, v: char :: { $IsAlloc(v, TChar, h) } $IsAlloc(v, TChar, h));

axiom (forall h: Heap, v: ORDINAL :: 
  { $IsAlloc(v, TORDINAL, h) } 
  $IsAlloc(v, TORDINAL, h));

axiom (forall v: Set Box, t0: Ty :: 
  { $Is(v, TSet(t0)) } 
  $Is(v, TSet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: ISet Box, t0: Ty :: 
  { $Is(v, TISet(t0)) } 
  $Is(v, TISet(t0)) <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0))
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsBox(bx, t0)));

axiom (forall v: MultiSet Box, t0: Ty :: 
  { $Is(v, TMultiSet(t0)) } 
  $Is(v, TMultiSet(t0)) ==> $IsGoodMultiSet(v));

axiom (forall v: Seq Box, t0: Ty :: 
  { $Is(v, TSeq(t0)) } 
  $Is(v, TSeq(t0))
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsBox(Seq#Index(v, i), t0)));

axiom (forall v: Set Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSet(t0), h) } 
  $IsAlloc(v, TSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: ISet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TISet(t0), h) } 
  $IsAlloc(v, TISet(t0), h)
     <==> (forall bx: Box :: { v[bx] } v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: MultiSet Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TMultiSet(t0), h) } 
  $IsAlloc(v, TMultiSet(t0), h)
     <==> (forall bx: Box :: { v[bx] } 0 < v[bx] ==> $IsAllocBox(bx, t0, h)));

axiom (forall v: Seq Box, t0: Ty, h: Heap :: 
  { $IsAlloc(v, TSeq(t0), h) } 
  $IsAlloc(v, TSeq(t0), h)
     <==> (forall i: int :: 
      { Seq#Index(v, i) } 
      0 <= i && i < Seq#Length(v) ==> $IsAllocBox(Seq#Index(v, i), t0, h)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TMap(t0, t1)) } 
  $Is(v, TMap(t0, t1))
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx] ==> $IsBox(Map#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: Map Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TMap(t0, t1), h) } 
  $IsAlloc(v, TMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { Map#Elements(v)[bx] } { Map#Domain(v)[bx] } 
      Map#Domain(v)[bx]
         ==> $IsAllocBox(Map#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty :: 
  { $Is(v, TIMap(t0, t1)) } 
  $Is(v, TIMap(t0, t1))
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx] ==> $IsBox(IMap#Elements(v)[bx], t1) && $IsBox(bx, t0)));

axiom (forall v: IMap Box Box, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(v, TIMap(t0, t1), h) } 
  $IsAlloc(v, TIMap(t0, t1), h)
     <==> (forall bx: Box :: 
      { IMap#Elements(v)[bx] } { IMap#Domain(v)[bx] } 
      IMap#Domain(v)[bx]
         ==> $IsAllocBox(IMap#Elements(v)[bx], t1, h) && $IsAllocBox(bx, t0, h)));

type ClassName;

const unique class._System.int: ClassName;

const unique class._System.bool: ClassName;

const unique class._System.set: ClassName;

const unique class._System.seq: ClassName;

const unique class._System.multiset: ClassName;

function Tclass._System.object?() : Ty;

function dtype(ref) : Ty;

function TypeTuple(a: ClassName, b: ClassName) : ClassName;

function TypeTupleCar(ClassName) : ClassName;

function TypeTupleCdr(ClassName) : ClassName;

axiom (forall a: ClassName, b: ClassName :: 
  { TypeTuple(a, b) } 
  TypeTupleCar(TypeTuple(a, b)) == a && TypeTupleCdr(TypeTuple(a, b)) == b);

type HandleType;

function SetRef_to_SetBox(s: [ref]bool) : Set Box;

axiom (forall s: [ref]bool, bx: Box :: 
  { SetRef_to_SetBox(s)[bx] } 
  SetRef_to_SetBox(s)[bx] == s[$Unbox(bx): ref]);

axiom (forall s: [ref]bool :: 
  { SetRef_to_SetBox(s) } 
  $Is(SetRef_to_SetBox(s), TSet(Tclass._System.object?())));

function Apply1(Ty, Ty, Heap, HandleType, Box) : Box;

type DatatypeType;

type DtCtorId;

function DatatypeCtorId(DatatypeType) : DtCtorId;

function DtRank(DatatypeType) : int;

function BoxRank(Box) : int;

axiom (forall d: DatatypeType :: { BoxRank($Box(d)) } BoxRank($Box(d)) == DtRank(d));

type ORDINAL = Box;

function ORD#IsNat(ORDINAL) : bool;

function ORD#Offset(ORDINAL) : int;

axiom (forall o: ORDINAL :: { ORD#Offset(o) } 0 <= ORD#Offset(o));

function {:inline} ORD#IsLimit(o: ORDINAL) : bool
{
  ORD#Offset(o) == 0
}

function {:inline} ORD#IsSucc(o: ORDINAL) : bool
{
  0 < ORD#Offset(o)
}

function ORD#FromNat(int) : ORDINAL;

axiom (forall n: int :: 
  { ORD#FromNat(n) } 
  0 <= n ==> ORD#IsNat(ORD#FromNat(n)) && ORD#Offset(ORD#FromNat(n)) == n);

axiom (forall o: ORDINAL :: 
  { ORD#Offset(o) } { ORD#IsNat(o) } 
  ORD#IsNat(o) ==> o == ORD#FromNat(ORD#Offset(o)));

function ORD#Less(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p) } 
  (ORD#Less(o, p) ==> o != p)
     && (ORD#IsNat(o) && !ORD#IsNat(p) ==> ORD#Less(o, p))
     && (ORD#IsNat(o) && ORD#IsNat(p)
       ==> ORD#Less(o, p) == (ORD#Offset(o) < ORD#Offset(p)))
     && (ORD#Less(o, p) && ORD#IsNat(p) ==> ORD#IsNat(o)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, o) } 
  ORD#Less(o, p) || o == p || ORD#Less(p, o));

axiom (forall o: ORDINAL, p: ORDINAL, r: ORDINAL :: 
  { ORD#Less(o, p), ORD#Less(p, r) } { ORD#Less(o, p), ORD#Less(o, r) } 
  ORD#Less(o, p) && ORD#Less(p, r) ==> ORD#Less(o, r));

function ORD#LessThanLimit(ORDINAL, ORDINAL) : bool;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#LessThanLimit(o, p) } 
  ORD#LessThanLimit(o, p) == ORD#Less(o, p));

function ORD#Plus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (ORD#IsNat(ORD#Plus(o, p)) ==> ORD#IsNat(o) && ORD#IsNat(p))
     && (ORD#IsNat(p)
       ==> ORD#IsNat(ORD#Plus(o, p)) == ORD#IsNat(o)
         && ORD#Offset(ORD#Plus(o, p)) == ORD#Offset(o) + ORD#Offset(p)));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#Plus(o, p) || ORD#Less(o, ORD#Plus(o, p)))
     && (p == ORD#Plus(o, p) || ORD#Less(p, ORD#Plus(o, p))));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Plus(o, p) } 
  (o == ORD#FromNat(0) ==> ORD#Plus(o, p) == p)
     && (p == ORD#FromNat(0) ==> ORD#Plus(o, p) == o));

function ORD#Minus(ORDINAL, ORDINAL) : ORDINAL;

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> ORD#IsNat(ORD#Minus(o, p)) == ORD#IsNat(o)
       && ORD#Offset(ORD#Minus(o, p)) == ORD#Offset(o) - ORD#Offset(p));

axiom (forall o: ORDINAL, p: ORDINAL :: 
  { ORD#Minus(o, p) } 
  ORD#IsNat(p) && ORD#Offset(p) <= ORD#Offset(o)
     ==> (p == ORD#FromNat(0) && ORD#Minus(o, p) == o)
       || (p != ORD#FromNat(0) && ORD#Less(ORD#Minus(o, p), o)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n
     ==> ORD#Plus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Plus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && m + n <= ORD#Offset(o)
     ==> ORD#Minus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
       == ORD#Minus(o, ORD#FromNat(m + n)));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Minus(ORD#Plus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(n - m))));

axiom (forall o: ORDINAL, m: int, n: int :: 
  { ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n)) } 
  0 <= m && 0 <= n && n <= ORD#Offset(o) + m
     ==> (0 <= m - n
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Minus(o, ORD#FromNat(m - n)))
       && (m - n <= 0
         ==> ORD#Plus(ORD#Minus(o, ORD#FromNat(m)), ORD#FromNat(n))
           == ORD#Plus(o, ORD#FromNat(n - m))));

const $ModuleContextHeight: int;

const $FunctionContextHeight: int;

type LayerType;

const $LZ: LayerType;

function $LS(LayerType) : LayerType;

function AsFuelBottom(LayerType) : LayerType;

function AtLayer<A>([LayerType]A, LayerType) : A;

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, ly) } 
  AtLayer(f, ly) == f[ly]);

axiom (forall<A> f: [LayerType]A, ly: LayerType :: 
  { AtLayer(f, $LS(ly)) } 
  AtLayer(f, $LS(ly)) == AtLayer(f, ly));

type Field _;

function FDim<T>(Field T) : int;

function IndexField(int) : Field Box;

axiom (forall i: int :: { IndexField(i) } FDim(IndexField(i)) == 1);

function IndexField_Inverse<T>(Field T) : int;

axiom (forall i: int :: { IndexField(i) } IndexField_Inverse(IndexField(i)) == i);

function MultiIndexField(Field Box, int) : Field Box;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  FDim(MultiIndexField(f, i)) == FDim(f) + 1);

function MultiIndexField_Inverse0<T>(Field T) : Field T;

function MultiIndexField_Inverse1<T>(Field T) : int;

axiom (forall f: Field Box, i: int :: 
  { MultiIndexField(f, i) } 
  MultiIndexField_Inverse0(MultiIndexField(f, i)) == f
     && MultiIndexField_Inverse1(MultiIndexField(f, i)) == i);

function DeclType<T>(Field T) : ClassName;

type NameFamily;

function DeclName<T>(Field T) : NameFamily;

function FieldOfDecl<alpha>(ClassName, NameFamily) : Field alpha;

axiom (forall<T> cl: ClassName, nm: NameFamily :: 
  { FieldOfDecl(cl, nm): Field T } 
  DeclType(FieldOfDecl(cl, nm): Field T) == cl
     && DeclName(FieldOfDecl(cl, nm): Field T) == nm);

function $IsGhostField<T>(Field T) : bool;

axiom (forall<T> h: Heap, k: Heap, v: T, t: Ty :: 
  { $HeapSucc(h, k), $IsAlloc(v, t, h) } 
  $HeapSucc(h, k) ==> $IsAlloc(v, t, h) ==> $IsAlloc(v, t, k));

axiom (forall h: Heap, k: Heap, bx: Box, t: Ty :: 
  { $HeapSucc(h, k), $IsAllocBox(bx, t, h) } 
  $HeapSucc(h, k) ==> $IsAllocBox(bx, t, h) ==> $IsAllocBox(bx, t, k));

const unique alloc: Field bool;

const unique allocName: NameFamily;

axiom FDim(alloc) == 0 && DeclName(alloc) == allocName && !$IsGhostField(alloc);

function _System.array.Length(a: ref) : int;

axiom (forall o: ref :: 0 <= _System.array.Length(o));

function Int(x: real) : int;

axiom (forall x: real :: { Int(x): int } Int(x): int == int(x));

function Real(x: int) : real;

axiom (forall x: int :: { Real(x): real } Real(x): real == real(x));

axiom (forall i: int :: { Int(Real(i)) } Int(Real(i)) == i);

function {:inline} _System.real.Floor(x: real) : int
{
  Int(x)
}

type Heap = [ref]<alpha>[Field alpha]alpha;

function {:inline} read<alpha>(H: Heap, r: ref, f: Field alpha) : alpha
{
  H[r][f]
}

function {:inline} update<alpha>(H: Heap, r: ref, f: Field alpha, v: alpha) : Heap
{
  H[r := H[r][f := v]]
}

function $IsGoodHeap(Heap) : bool;

function $IsHeapAnchor(Heap) : bool;

var $Heap: Heap where $IsGoodHeap($Heap) && $IsHeapAnchor($Heap);

const $OneHeap: Heap;

axiom $IsGoodHeap($OneHeap);

function $HeapSucc(Heap, Heap) : bool;

axiom (forall<alpha> h: Heap, r: ref, f: Field alpha, x: alpha :: 
  { update(h, r, f, x) } 
  $IsGoodHeap(update(h, r, f, x)) ==> $HeapSucc(h, update(h, r, f, x)));

axiom (forall a: Heap, b: Heap, c: Heap :: 
  { $HeapSucc(a, b), $HeapSucc(b, c) } 
  a != c ==> $HeapSucc(a, b) && $HeapSucc(b, c) ==> $HeapSucc(a, c));

axiom (forall h: Heap, k: Heap :: 
  { $HeapSucc(h, k) } 
  $HeapSucc(h, k)
     ==> (forall o: ref :: { read(k, o, alloc) } read(h, o, alloc) ==> read(k, o, alloc)));

function $HeapSuccGhost(Heap, Heap) : bool;

axiom (forall h: Heap, k: Heap :: 
  { $HeapSuccGhost(h, k) } 
  $HeapSuccGhost(h, k)
     ==> $HeapSucc(h, k)
       && (forall<alpha> o: ref, f: Field alpha :: 
        { read(k, o, f) } 
        !$IsGhostField(f) ==> read(h, o, f) == read(k, o, f)));

type TickType;

var $Tick: TickType;

procedure $YieldHavoc(this: ref, rds: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      $o == this || rds[$Box($o)] || nw[$Box($o)]
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc0(this: ref, rds: Set Box, modi: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> 
      rds[$Box($o)] && !modi[$Box($o)] && $o != this
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f));
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterHavoc1(this: ref, modi: Set Box, nw: Set Box);
  modifies $Heap;
  ensures (forall<alpha> $o: ref, $f: Field alpha :: 
    { read($Heap, $o, $f) } 
    $o != null && read(old($Heap), $o, alloc)
       ==> read($Heap, $o, $f) == read(old($Heap), $o, $f)
         || $o == this
         || modi[$Box($o)]
         || nw[$Box($o)]);
  ensures $HeapSucc(old($Heap), $Heap);



procedure $IterCollectNewObjects(prevHeap: Heap, newHeap: Heap, this: ref, NW: Field (Set Box))
   returns (s: Set Box);
  ensures (forall bx: Box :: 
    { s[bx] } 
    s[bx]
       <==> read(newHeap, this, NW)[bx]
         || (
          $Unbox(bx) != null
           && !read(prevHeap, $Unbox(bx): ref, alloc)
           && read(newHeap, $Unbox(bx): ref, alloc)));



type Set T = [T]bool;

function Set#Card<T>(Set T) : int;

axiom (forall<T> s: Set T :: { Set#Card(s) } 0 <= Set#Card(s));

function Set#Empty<T>() : Set T;

axiom (forall<T> o: T :: { Set#Empty()[o] } !Set#Empty()[o]);

axiom (forall<T> s: Set T :: 
  { Set#Card(s) } 
  (Set#Card(s) == 0 <==> s == Set#Empty())
     && (Set#Card(s) != 0 ==> (exists x: T :: s[x])));

function Set#Singleton<T>(T) : Set T;

axiom (forall<T> r: T :: { Set#Singleton(r) } Set#Singleton(r)[r]);

axiom (forall<T> r: T, o: T :: 
  { Set#Singleton(r)[o] } 
  Set#Singleton(r)[o] <==> r == o);

axiom (forall<T> r: T :: 
  { Set#Card(Set#Singleton(r)) } 
  Set#Card(Set#Singleton(r)) == 1);

function Set#UnionOne<T>(Set T, T) : Set T;

axiom (forall<T> a: Set T, x: T, o: T :: 
  { Set#UnionOne(a, x)[o] } 
  Set#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: Set T, x: T :: { Set#UnionOne(a, x) } Set#UnionOne(a, x)[x]);

axiom (forall<T> a: Set T, x: T, y: T :: 
  { Set#UnionOne(a, x), a[y] } 
  a[y] ==> Set#UnionOne(a, x)[y]);

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a));

axiom (forall<T> a: Set T, x: T :: 
  { Set#Card(Set#UnionOne(a, x)) } 
  !a[x] ==> Set#Card(Set#UnionOne(a, x)) == Set#Card(a) + 1);

function Set#Union<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Union(a, b)[o] } 
  Set#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), a[y] } 
  a[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Union(a, b), b[y] } 
  b[y] ==> Set#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, b) } 
  Set#Disjoint(a, b)
     ==> Set#Difference(Set#Union(a, b), a) == b
       && Set#Difference(Set#Union(a, b), b) == a);

function Set#Intersection<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Intersection(a, b)[o] } 
  Set#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(Set#Union(a, b), b) } 
  Set#Union(Set#Union(a, b), b) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Union(a, Set#Union(a, b)) } 
  Set#Union(a, Set#Union(a, b)) == Set#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(Set#Intersection(a, b), b) } 
  Set#Intersection(Set#Intersection(a, b), b) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Intersection(a, Set#Intersection(a, b)) } 
  Set#Intersection(a, Set#Intersection(a, b)) == Set#Intersection(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Union(a, b)) } { Set#Card(Set#Intersection(a, b)) } 
  Set#Card(Set#Union(a, b)) + Set#Card(Set#Intersection(a, b))
     == Set#Card(a) + Set#Card(b));

function Set#Difference<T>(Set T, Set T) : Set T;

axiom (forall<T> a: Set T, b: Set T, o: T :: 
  { Set#Difference(a, b)[o] } 
  Set#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { Set#Difference(a, b), b[y] } 
  b[y] ==> !Set#Difference(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Card(Set#Difference(a, b)) } 
  Set#Card(Set#Difference(a, b))
         + Set#Card(Set#Difference(b, a))
         + Set#Card(Set#Intersection(a, b))
       == Set#Card(Set#Union(a, b))
     && Set#Card(Set#Difference(a, b)) == Set#Card(a) - Set#Card(Set#Intersection(a, b)));

function Set#Subset<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Subset(a, b) } 
  Set#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function Set#Equal<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Equal(a, b) } 
  Set#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: Set T, b: Set T :: { Set#Equal(a, b) } Set#Equal(a, b) ==> a == b);

function Set#Disjoint<T>(Set T, Set T) : bool;

axiom (forall<T> a: Set T, b: Set T :: 
  { Set#Disjoint(a, b) } 
  Set#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

type ISet T = [T]bool;

function ISet#Empty<T>() : Set T;

axiom (forall<T> o: T :: { ISet#Empty()[o] } !ISet#Empty()[o]);

function ISet#UnionOne<T>(ISet T, T) : ISet T;

axiom (forall<T> a: ISet T, x: T, o: T :: 
  { ISet#UnionOne(a, x)[o] } 
  ISet#UnionOne(a, x)[o] <==> o == x || a[o]);

axiom (forall<T> a: ISet T, x: T :: { ISet#UnionOne(a, x) } ISet#UnionOne(a, x)[x]);

axiom (forall<T> a: ISet T, x: T, y: T :: 
  { ISet#UnionOne(a, x), a[y] } 
  a[y] ==> ISet#UnionOne(a, x)[y]);

function ISet#Union<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Union(a, b)[o] } 
  ISet#Union(a, b)[o] <==> a[o] || b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Union(a, b), a[y] } 
  a[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: Set T, b: Set T, y: T :: 
  { ISet#Union(a, b), b[y] } 
  b[y] ==> ISet#Union(a, b)[y]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(a, b) } 
  ISet#Disjoint(a, b)
     ==> ISet#Difference(ISet#Union(a, b), a) == b
       && ISet#Difference(ISet#Union(a, b), b) == a);

function ISet#Intersection<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Intersection(a, b)[o] } 
  ISet#Intersection(a, b)[o] <==> a[o] && b[o]);

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Union(ISet#Union(a, b), b) } 
  ISet#Union(ISet#Union(a, b), b) == ISet#Union(a, b));

axiom (forall<T> a: Set T, b: Set T :: 
  { ISet#Union(a, ISet#Union(a, b)) } 
  ISet#Union(a, ISet#Union(a, b)) == ISet#Union(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(ISet#Intersection(a, b), b) } 
  ISet#Intersection(ISet#Intersection(a, b), b) == ISet#Intersection(a, b));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Intersection(a, ISet#Intersection(a, b)) } 
  ISet#Intersection(a, ISet#Intersection(a, b)) == ISet#Intersection(a, b));

function ISet#Difference<T>(ISet T, ISet T) : ISet T;

axiom (forall<T> a: ISet T, b: ISet T, o: T :: 
  { ISet#Difference(a, b)[o] } 
  ISet#Difference(a, b)[o] <==> a[o] && !b[o]);

axiom (forall<T> a: ISet T, b: ISet T, y: T :: 
  { ISet#Difference(a, b), b[y] } 
  b[y] ==> !ISet#Difference(a, b)[y]);

function ISet#Subset<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Subset(a, b) } 
  ISet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] ==> b[o]));

function ISet#Equal<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <==> b[o]));

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Equal(a, b) } 
  ISet#Equal(a, b) ==> a == b);

function ISet#Disjoint<T>(ISet T, ISet T) : bool;

axiom (forall<T> a: ISet T, b: ISet T :: 
  { ISet#Disjoint(a, b) } 
  ISet#Disjoint(a, b) <==> (forall o: T :: { a[o] } { b[o] } !a[o] || !b[o]));

function Math#min(a: int, b: int) : int;

axiom (forall a: int, b: int :: { Math#min(a, b) } a <= b <==> Math#min(a, b) == a);

axiom (forall a: int, b: int :: { Math#min(a, b) } b <= a <==> Math#min(a, b) == b);

axiom (forall a: int, b: int :: 
  { Math#min(a, b) } 
  Math#min(a, b) == a || Math#min(a, b) == b);

function Math#clip(a: int) : int;

axiom (forall a: int :: { Math#clip(a) } 0 <= a ==> Math#clip(a) == a);

axiom (forall a: int :: { Math#clip(a) } a < 0 ==> Math#clip(a) == 0);

type MultiSet T = [T]int;

function $IsGoodMultiSet<T>(ms: MultiSet T) : bool;

axiom (forall<T> ms: MultiSet T :: 
  { $IsGoodMultiSet(ms) } 
  $IsGoodMultiSet(ms)
     <==> (forall bx: T :: { ms[bx] } 0 <= ms[bx] && ms[bx] <= MultiSet#Card(ms)));

function MultiSet#Card<T>(MultiSet T) : int;

axiom (forall<T> s: MultiSet T :: { MultiSet#Card(s) } 0 <= MultiSet#Card(s));

axiom (forall<T> s: MultiSet T, x: T, n: int :: 
  { MultiSet#Card(s[x := n]) } 
  0 <= n ==> MultiSet#Card(s[x := n]) == MultiSet#Card(s) - s[x] + n);

function MultiSet#Empty<T>() : MultiSet T;

axiom (forall<T> o: T :: { MultiSet#Empty()[o] } MultiSet#Empty()[o] == 0);

axiom (forall<T> s: MultiSet T :: 
  { MultiSet#Card(s) } 
  (MultiSet#Card(s) == 0 <==> s == MultiSet#Empty())
     && (MultiSet#Card(s) != 0 ==> (exists x: T :: 0 < s[x])));

function MultiSet#Singleton<T>(T) : MultiSet T;

axiom (forall<T> r: T, o: T :: 
  { MultiSet#Singleton(r)[o] } 
  (MultiSet#Singleton(r)[o] == 1 <==> r == o)
     && (MultiSet#Singleton(r)[o] == 0 <==> r != o));

axiom (forall<T> r: T :: 
  { MultiSet#Singleton(r) } 
  MultiSet#Singleton(r) == MultiSet#UnionOne(MultiSet#Empty(), r));

function MultiSet#UnionOne<T>(MultiSet T, T) : MultiSet T;

axiom (forall<T> a: MultiSet T, x: T, o: T :: 
  { MultiSet#UnionOne(a, x)[o] } 
  0 < MultiSet#UnionOne(a, x)[o] <==> o == x || 0 < a[o]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#UnionOne(a, x) } 
  MultiSet#UnionOne(a, x)[x] == a[x] + 1);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  0 < a[y] ==> 0 < MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T, y: T :: 
  { MultiSet#UnionOne(a, x), a[y] } 
  x != y ==> a[y] == MultiSet#UnionOne(a, x)[y]);

axiom (forall<T> a: MultiSet T, x: T :: 
  { MultiSet#Card(MultiSet#UnionOne(a, x)) } 
  MultiSet#Card(MultiSet#UnionOne(a, x)) == MultiSet#Card(a) + 1);

function MultiSet#Union<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Union(a, b)[o] } 
  MultiSet#Union(a, b)[o] == a[o] + b[o]);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Union(a, b)) } 
  MultiSet#Card(MultiSet#Union(a, b)) == MultiSet#Card(a) + MultiSet#Card(b));

function MultiSet#Intersection<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Intersection(a, b)[o] } 
  MultiSet#Intersection(a, b)[o] == Math#min(a[o], b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(MultiSet#Intersection(a, b), b) } 
  MultiSet#Intersection(MultiSet#Intersection(a, b), b)
     == MultiSet#Intersection(a, b));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Intersection(a, MultiSet#Intersection(a, b)) } 
  MultiSet#Intersection(a, MultiSet#Intersection(a, b))
     == MultiSet#Intersection(a, b));

function MultiSet#Difference<T>(MultiSet T, MultiSet T) : MultiSet T;

axiom (forall<T> a: MultiSet T, b: MultiSet T, o: T :: 
  { MultiSet#Difference(a, b)[o] } 
  MultiSet#Difference(a, b)[o] == Math#clip(a[o] - b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T, y: T :: 
  { MultiSet#Difference(a, b), b[y], a[y] } 
  a[y] <= b[y] ==> MultiSet#Difference(a, b)[y] == 0);

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Card(MultiSet#Difference(a, b)) } 
  MultiSet#Card(MultiSet#Difference(a, b))
         + MultiSet#Card(MultiSet#Difference(b, a))
         + 2 * MultiSet#Card(MultiSet#Intersection(a, b))
       == MultiSet#Card(MultiSet#Union(a, b))
     && MultiSet#Card(MultiSet#Difference(a, b))
       == MultiSet#Card(a) - MultiSet#Card(MultiSet#Intersection(a, b)));

function MultiSet#Subset<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Subset(a, b) } 
  MultiSet#Subset(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] <= b[o]));

function MultiSet#Equal<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) <==> (forall o: T :: { a[o] } { b[o] } a[o] == b[o]));

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Equal(a, b) } 
  MultiSet#Equal(a, b) ==> a == b);

function MultiSet#Disjoint<T>(MultiSet T, MultiSet T) : bool;

axiom (forall<T> a: MultiSet T, b: MultiSet T :: 
  { MultiSet#Disjoint(a, b) } 
  MultiSet#Disjoint(a, b)
     <==> (forall o: T :: { a[o] } { b[o] } a[o] == 0 || b[o] == 0));

function MultiSet#FromSet<T>(Set T) : MultiSet T;

axiom (forall<T> s: Set T, a: T :: 
  { MultiSet#FromSet(s)[a] } 
  (MultiSet#FromSet(s)[a] == 0 <==> !s[a])
     && (MultiSet#FromSet(s)[a] == 1 <==> s[a]));

axiom (forall<T> s: Set T :: 
  { MultiSet#Card(MultiSet#FromSet(s)) } 
  MultiSet#Card(MultiSet#FromSet(s)) == Set#Card(s));

function MultiSet#FromSeq<T>(Seq T) : MultiSet T;

axiom (forall<T> s: Seq T :: 
  { MultiSet#FromSeq(s) } 
  $IsGoodMultiSet(MultiSet#FromSeq(s)));

axiom (forall<T> s: Seq T :: 
  { MultiSet#Card(MultiSet#FromSeq(s)) } 
  MultiSet#Card(MultiSet#FromSeq(s)) == Seq#Length(s));

axiom (forall<T> s: Seq T, v: T :: 
  { MultiSet#FromSeq(Seq#Build(s, v)) } 
  MultiSet#FromSeq(Seq#Build(s, v)) == MultiSet#UnionOne(MultiSet#FromSeq(s), v));

axiom (forall<T>  :: 
  MultiSet#FromSeq(Seq#Empty(): Seq T) == MultiSet#Empty(): MultiSet T);

axiom (forall<T> a: Seq T, b: Seq T :: 
  { MultiSet#FromSeq(Seq#Append(a, b)) } 
  MultiSet#FromSeq(Seq#Append(a, b))
     == MultiSet#Union(MultiSet#FromSeq(a), MultiSet#FromSeq(b)));

axiom (forall<T> s: Seq T, i: int, v: T, x: T :: 
  { MultiSet#FromSeq(Seq#Update(s, i, v))[x] } 
  0 <= i && i < Seq#Length(s)
     ==> MultiSet#FromSeq(Seq#Update(s, i, v))[x]
       == MultiSet#Union(MultiSet#Difference(MultiSet#FromSeq(s), MultiSet#Singleton(Seq#Index(s, i))), 
        MultiSet#Singleton(v))[x]);

axiom (forall<T> s: Seq T, x: T :: 
  { MultiSet#FromSeq(s)[x] } 
  (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && x == Seq#Index(s, i))
     <==> 0 < MultiSet#FromSeq(s)[x]);

type Seq _;

function Seq#Length<T>(Seq T) : int;

axiom (forall<T> s: Seq T :: { Seq#Length(s) } 0 <= Seq#Length(s));

function Seq#Empty<T>() : Seq T;

axiom (forall<T>  :: { Seq#Empty(): Seq T } Seq#Length(Seq#Empty(): Seq T) == 0);

axiom (forall<T> s: Seq T :: 
  { Seq#Length(s) } 
  Seq#Length(s) == 0 ==> s == Seq#Empty());

axiom (forall<T> t: Ty :: { $Is(Seq#Empty(): Seq T, t) } $Is(Seq#Empty(): Seq T, t));

function Seq#Singleton<T>(T) : Seq T;

axiom (forall<T> t: T :: 
  { Seq#Length(Seq#Singleton(t)) } 
  Seq#Length(Seq#Singleton(t)) == 1);

function Seq#Build<T>(s: Seq T, val: T) : Seq T;

function Seq#Build_inv0<T>(s: Seq T) : Seq T;

function Seq#Build_inv1<T>(s: Seq T) : T;

axiom (forall<T> s: Seq T, val: T :: 
  { Seq#Build(s, val) } 
  Seq#Build_inv0(Seq#Build(s, val)) == s
     && Seq#Build_inv1(Seq#Build(s, val)) == val);

axiom (forall<T> s: Seq T, v: T :: 
  { Seq#Build(s, v) } 
  Seq#Length(Seq#Build(s, v)) == 1 + Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Index(Seq#Build(s, v), i) } 
  (i == Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == v)
     && (i != Seq#Length(s) ==> Seq#Index(Seq#Build(s, v), i) == Seq#Index(s, i)));

axiom (forall s: Seq Box, bx: Box, t: Ty :: 
  { $Is(Seq#Build(s, bx), TSeq(t)) } 
  $Is(s, TSeq(t)) && $IsBox(bx, t) ==> $Is(Seq#Build(s, bx), TSeq(t)));

function Seq#Create(ty: Ty, heap: Heap, len: int, init: HandleType) : Seq Box;

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType :: 
  { Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) } 
  $IsGoodHeap(heap) && 0 <= len
     ==> Seq#Length(Seq#Create(ty, heap, len, init): Seq Box) == len);

axiom (forall ty: Ty, heap: Heap, len: int, init: HandleType, i: int :: 
  { Seq#Index(Seq#Create(ty, heap, len, init), i) } 
  $IsGoodHeap(heap) && 0 <= i && i < len
     ==> Seq#Index(Seq#Create(ty, heap, len, init), i)
       == Apply1(TInt, TSeq(ty), heap, init, $Box(i)));

function Seq#Append<T>(Seq T, Seq T) : Seq T;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Length(Seq#Append(s0, s1)) } 
  Seq#Length(Seq#Append(s0, s1)) == Seq#Length(s0) + Seq#Length(s1));

axiom (forall s0: Seq Box, s1: Seq Box, t: Ty :: 
  { $Is(Seq#Append(s0, s1), t) } 
  $Is(s0, t) && $Is(s1, t) ==> $Is(Seq#Append(s0, s1), t));

function Seq#Index<T>(Seq T, int) : T;

axiom (forall<T> t: T :: 
  { Seq#Index(Seq#Singleton(t), 0) } 
  Seq#Index(Seq#Singleton(t), 0) == t);

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#Index(Seq#Append(s0, s1), n) } 
  (n < Seq#Length(s0) ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s0, n))
     && (Seq#Length(s0) <= n
       ==> Seq#Index(Seq#Append(s0, s1), n) == Seq#Index(s1, n - Seq#Length(s0))));

function Seq#Update<T>(Seq T, int, T) : Seq T;

axiom (forall<T> s: Seq T, i: int, v: T :: 
  { Seq#Length(Seq#Update(s, i, v)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Length(Seq#Update(s, i, v)) == Seq#Length(s));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Index(Seq#Update(s, i, v), n) } 
  0 <= n && n < Seq#Length(s)
     ==> (i == n ==> Seq#Index(Seq#Update(s, i, v), n) == v)
       && (i != n ==> Seq#Index(Seq#Update(s, i, v), n) == Seq#Index(s, n)));

function Seq#Contains<T>(Seq T, T) : bool;

axiom (forall<T> s: Seq T, x: T :: 
  { Seq#Contains(s, x) } 
  Seq#Contains(s, x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> x: T :: 
  { Seq#Contains(Seq#Empty(), x) } 
  !Seq#Contains(Seq#Empty(), x));

axiom (forall<T> s0: Seq T, s1: Seq T, x: T :: 
  { Seq#Contains(Seq#Append(s0, s1), x) } 
  Seq#Contains(Seq#Append(s0, s1), x)
     <==> Seq#Contains(s0, x) || Seq#Contains(s1, x));

axiom (forall<T> s: Seq T, v: T, x: T :: 
  { Seq#Contains(Seq#Build(s, v), x) } 
  Seq#Contains(Seq#Build(s, v), x) <==> v == x || Seq#Contains(s, x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Take(s, n), x) } 
  Seq#Contains(Seq#Take(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= i && i < n && i < Seq#Length(s) && Seq#Index(s, i) == x));

axiom (forall<T> s: Seq T, n: int, x: T :: 
  { Seq#Contains(Seq#Drop(s, n), x) } 
  Seq#Contains(Seq#Drop(s, n), x)
     <==> (exists i: int :: 
      { Seq#Index(s, i) } 
      0 <= n && n <= i && i < Seq#Length(s) && Seq#Index(s, i) == x));

function Seq#Equal<T>(Seq T, Seq T) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T :: 
  { Seq#Equal(s0, s1) } 
  Seq#Equal(s0, s1)
     <==> Seq#Length(s0) == Seq#Length(s1)
       && (forall j: int :: 
        { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
        0 <= j && j < Seq#Length(s0) ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

axiom (forall<T> a: Seq T, b: Seq T :: { Seq#Equal(a, b) } Seq#Equal(a, b) ==> a == b);

function Seq#SameUntil<T>(Seq T, Seq T, int) : bool;

axiom (forall<T> s0: Seq T, s1: Seq T, n: int :: 
  { Seq#SameUntil(s0, s1, n) } 
  Seq#SameUntil(s0, s1, n)
     <==> (forall j: int :: 
      { Seq#Index(s0, j) } { Seq#Index(s1, j) } 
      0 <= j && j < n ==> Seq#Index(s0, j) == Seq#Index(s1, j)));

function Seq#Take<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Take(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Take(s, n)) == n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Take(s, n), j) } { Seq#Index(s, j), Seq#Take(s, n) } 
  0 <= j && j < n && j < Seq#Length(s)
     ==> Seq#Index(Seq#Take(s, n), j) == Seq#Index(s, j));

function Seq#Drop<T>(s: Seq T, howMany: int) : Seq T;

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Length(Seq#Drop(s, n)) } 
  0 <= n && n <= Seq#Length(s) ==> Seq#Length(Seq#Drop(s, n)) == Seq#Length(s) - n);

axiom (forall<T> s: Seq T, n: int, j: int :: 
  {:weight 25} { Seq#Index(Seq#Drop(s, n), j) } 
  0 <= n && 0 <= j && j < Seq#Length(s) - n
     ==> Seq#Index(Seq#Drop(s, n), j) == Seq#Index(s, j + n));

axiom (forall<T> s: Seq T, n: int, k: int :: 
  {:weight 25} { Seq#Index(s, k), Seq#Drop(s, n) } 
  0 <= n && n <= k && k < Seq#Length(s)
     ==> Seq#Index(Seq#Drop(s, n), k - n) == Seq#Index(s, k));

axiom (forall<T> s: Seq T, t: Seq T, n: int :: 
  { Seq#Take(Seq#Append(s, t), n) } { Seq#Drop(Seq#Append(s, t), n) } 
  n == Seq#Length(s)
     ==> Seq#Take(Seq#Append(s, t), n) == s && Seq#Drop(Seq#Append(s, t), n) == t);

function Seq#FromArray(h: Heap, a: ref) : Seq Box;

axiom (forall h: Heap, a: ref :: 
  { Seq#Length(Seq#FromArray(h, a)) } 
  Seq#Length(Seq#FromArray(h, a)) == _System.array.Length(a));

axiom (forall h: Heap, a: ref :: 
  { Seq#FromArray(h, a) } 
  (forall i: int :: 
    { read(h, a, IndexField(i)) } { Seq#Index(Seq#FromArray(h, a): Seq Box, i) } 
    0 <= i && i < Seq#Length(Seq#FromArray(h, a))
       ==> Seq#Index(Seq#FromArray(h, a), i) == read(h, a, IndexField(i))));

axiom (forall h0: Heap, h1: Heap, a: ref :: 
  { Seq#FromArray(h1, a), $HeapSucc(h0, h1) } 
  $IsGoodHeap(h0) && $IsGoodHeap(h1) && $HeapSucc(h0, h1) && h0[a] == h1[a]
     ==> Seq#FromArray(h0, a) == Seq#FromArray(h1, a));

axiom (forall h: Heap, i: int, v: Box, a: ref :: 
  { Seq#FromArray(update(h, a, IndexField(i), v), a) } 
  0 <= i && i < _System.array.Length(a)
     ==> Seq#FromArray(update(h, a, IndexField(i), v), a)
       == Seq#Update(Seq#FromArray(h, a), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n <= Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Update(Seq#Take(s, n), i, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Take(Seq#Update(s, i, v), n) } 
  n <= i && i < Seq#Length(s)
     ==> Seq#Take(Seq#Update(s, i, v), n) == Seq#Take(s, n));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= n && n <= i && i < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Update(Seq#Drop(s, n), i - n, v));

axiom (forall<T> s: Seq T, i: int, v: T, n: int :: 
  { Seq#Drop(Seq#Update(s, i, v), n) } 
  0 <= i && i < n && n < Seq#Length(s)
     ==> Seq#Drop(Seq#Update(s, i, v), n) == Seq#Drop(s, n));

axiom (forall h: Heap, a: ref, n0: int, n1: int :: 
  { Seq#Take(Seq#FromArray(h, a), n0), Seq#Take(Seq#FromArray(h, a), n1) } 
  n0 + 1 == n1 && 0 <= n0 && n1 <= _System.array.Length(a)
     ==> Seq#Take(Seq#FromArray(h, a), n1)
       == Seq#Build(Seq#Take(Seq#FromArray(h, a), n0), read(h, a, IndexField(n0): Field Box)));

axiom (forall<T> s: Seq T, v: T, n: int :: 
  { Seq#Drop(Seq#Build(s, v), n) } 
  0 <= n && n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Build(s, v), n) == Seq#Build(Seq#Drop(s, n), v));

function Seq#Rank<T>(Seq T) : int;

axiom (forall s: Seq Box, i: int :: 
  { DtRank($Unbox(Seq#Index(s, i)): DatatypeType) } 
  0 <= i && i < Seq#Length(s)
     ==> DtRank($Unbox(Seq#Index(s, i)): DatatypeType) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Drop(s, i)) } 
  0 < i && i <= Seq#Length(s) ==> Seq#Rank(Seq#Drop(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int :: 
  { Seq#Rank(Seq#Take(s, i)) } 
  0 <= i && i < Seq#Length(s) ==> Seq#Rank(Seq#Take(s, i)) < Seq#Rank(s));

axiom (forall<T> s: Seq T, i: int, j: int :: 
  { Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) } 
  0 <= i && i < j && j <= Seq#Length(s)
     ==> Seq#Rank(Seq#Append(Seq#Take(s, i), Seq#Drop(s, j))) < Seq#Rank(s));

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Drop(s, n) } 
  n == 0 ==> Seq#Drop(s, n) == s);

axiom (forall<T> s: Seq T, n: int :: 
  { Seq#Take(s, n) } 
  n == 0 ==> Seq#Take(s, n) == Seq#Empty());

axiom (forall<T> s: Seq T, m: int, n: int :: 
  { Seq#Drop(Seq#Drop(s, m), n) } 
  0 <= m && 0 <= n && m + n <= Seq#Length(s)
     ==> Seq#Drop(Seq#Drop(s, m), n) == Seq#Drop(s, m + n));

type Map _ _;

function Map#Domain<U,V>(Map U V) : Set U;

function Map#Elements<U,V>(Map U V) : [U]V;

function Map#Card<U,V>(Map U V) : int;

axiom (forall<U,V> m: Map U V :: { Map#Card(m) } 0 <= Map#Card(m));

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Domain(m)) } 
  Set#Card(Map#Domain(m)) == Map#Card(m));

function Map#Values<U,V>(Map U V) : Set V;

axiom (forall<U,V> m: Map U V, v: V :: 
  { Map#Values(m)[v] } 
  Map#Values(m)[v]
     == (exists u: U :: 
      { Map#Domain(m)[u] } { Map#Elements(m)[u] } 
      Map#Domain(m)[u] && v == Map#Elements(m)[u]));

function Map#Items<U,V>(Map U V) : Set Box;

function _System.Tuple2._0(DatatypeType) : Box;

function _System.Tuple2._1(DatatypeType) : Box;

axiom (forall<U,V> m: Map U V :: 
  { Set#Card(Map#Items(m)) } 
  Set#Card(Map#Items(m)) == Map#Card(m));

axiom (forall m: Map Box Box, item: Box :: 
  { Map#Items(m)[item] } 
  Map#Items(m)[item]
     <==> Map#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && Map#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function Map#Empty<U,V>() : Map U V;

axiom (forall<U,V> u: U :: 
  { Map#Domain(Map#Empty(): Map U V)[u] } 
  !Map#Domain(Map#Empty(): Map U V)[u]);

axiom (forall<U,V> m: Map U V :: 
  { Map#Card(m) } 
  (Map#Card(m) == 0 <==> m == Map#Empty())
     && (Map#Card(m) != 0 ==> (exists x: U :: Map#Domain(m)[x])));

function Map#Glue<U,V>([U]bool, [U]V, Ty) : Map U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Domain(Map#Glue(a, b, t)) } 
  Map#Domain(Map#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { Map#Elements(Map#Glue(a, b, t)) } 
  Map#Elements(Map#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(Map#Glue(a, b, t), t) } 
  $Is(Map#Glue(a, b, t), t));

function Map#Build<U,V>(Map U V, U, V) : Map U V;

axiom (forall<U,V> m: Map U V, u: U, u': U, v: V :: 
  { Map#Domain(Map#Build(m, u, v))[u'] } { Map#Elements(Map#Build(m, u, v))[u'] } 
  (u' == u
       ==> Map#Domain(Map#Build(m, u, v))[u'] && Map#Elements(Map#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> Map#Domain(Map#Build(m, u, v))[u'] == Map#Domain(m)[u']
         && Map#Elements(Map#Build(m, u, v))[u'] == Map#Elements(m)[u']));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m));

axiom (forall<U,V> m: Map U V, u: U, v: V :: 
  { Map#Card(Map#Build(m, u, v)) } 
  !Map#Domain(m)[u] ==> Map#Card(Map#Build(m, u, v)) == Map#Card(m) + 1);

function Map#Equal<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m')
     <==> (forall u: U :: Map#Domain(m)[u] == Map#Domain(m')[u])
       && (forall u: U :: Map#Domain(m)[u] ==> Map#Elements(m)[u] == Map#Elements(m')[u]));

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Equal(m, m') } 
  Map#Equal(m, m') ==> m == m');

function Map#Disjoint<U,V>(Map U V, Map U V) : bool;

axiom (forall<U,V> m: Map U V, m': Map U V :: 
  { Map#Disjoint(m, m') } 
  Map#Disjoint(m, m')
     <==> (forall o: U :: 
      { Map#Domain(m)[o] } { Map#Domain(m')[o] } 
      !Map#Domain(m)[o] || !Map#Domain(m')[o]));

type IMap _ _;

function IMap#Domain<U,V>(IMap U V) : Set U;

function IMap#Elements<U,V>(IMap U V) : [U]V;

function IMap#Values<U,V>(IMap U V) : Set V;

axiom (forall<U,V> m: IMap U V, v: V :: 
  { IMap#Values(m)[v] } 
  IMap#Values(m)[v]
     == (exists u: U :: 
      { IMap#Domain(m)[u] } { IMap#Elements(m)[u] } 
      IMap#Domain(m)[u] && v == IMap#Elements(m)[u]));

function IMap#Items<U,V>(IMap U V) : Set Box;

axiom (forall m: IMap Box Box, item: Box :: 
  { IMap#Items(m)[item] } 
  IMap#Items(m)[item]
     <==> IMap#Domain(m)[_System.Tuple2._0($Unbox(item))]
       && IMap#Elements(m)[_System.Tuple2._0($Unbox(item))]
         == _System.Tuple2._1($Unbox(item)));

function IMap#Empty<U,V>() : IMap U V;

axiom (forall<U,V> u: U :: 
  { IMap#Domain(IMap#Empty(): IMap U V)[u] } 
  !IMap#Domain(IMap#Empty(): IMap U V)[u]);

function IMap#Glue<U,V>([U]bool, [U]V, Ty) : IMap U V;

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Domain(IMap#Glue(a, b, t)) } 
  IMap#Domain(IMap#Glue(a, b, t)) == a);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { IMap#Elements(IMap#Glue(a, b, t)) } 
  IMap#Elements(IMap#Glue(a, b, t)) == b);

axiom (forall<U,V> a: [U]bool, b: [U]V, t: Ty :: 
  { $Is(IMap#Glue(a, b, t), t) } 
  $Is(IMap#Glue(a, b, t), t));

function IMap#Build<U,V>(IMap U V, U, V) : IMap U V;

axiom (forall<U,V> m: IMap U V, u: U, u': U, v: V :: 
  { IMap#Domain(IMap#Build(m, u, v))[u'] } 
    { IMap#Elements(IMap#Build(m, u, v))[u'] } 
  (u' == u
       ==> IMap#Domain(IMap#Build(m, u, v))[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == v)
     && (u' != u
       ==> IMap#Domain(IMap#Build(m, u, v))[u'] == IMap#Domain(m)[u']
         && IMap#Elements(IMap#Build(m, u, v))[u'] == IMap#Elements(m)[u']));

function IMap#Equal<U,V>(IMap U V, IMap U V) : bool;

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m')
     <==> (forall u: U :: IMap#Domain(m)[u] == IMap#Domain(m')[u])
       && (forall u: U :: 
        IMap#Domain(m)[u] ==> IMap#Elements(m)[u] == IMap#Elements(m')[u]));

axiom (forall<U,V> m: IMap U V, m': IMap U V :: 
  { IMap#Equal(m, m') } 
  IMap#Equal(m, m') ==> m == m');

function INTERNAL_add_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_add_boogie(x, y): int } 
  INTERNAL_add_boogie(x, y): int == x + y);

function INTERNAL_sub_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_sub_boogie(x, y): int } 
  INTERNAL_sub_boogie(x, y): int == x - y);

function INTERNAL_mul_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mul_boogie(x, y): int } 
  INTERNAL_mul_boogie(x, y): int == x * y);

function INTERNAL_div_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_div_boogie(x, y): int } 
  INTERNAL_div_boogie(x, y): int == x div y);

function INTERNAL_mod_boogie(x: int, y: int) : int;

axiom (forall x: int, y: int :: 
  { INTERNAL_mod_boogie(x, y): int } 
  INTERNAL_mod_boogie(x, y): int == x mod y);

function {:never_pattern true} INTERNAL_lt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_lt_boogie(x, y): bool } 
  INTERNAL_lt_boogie(x, y): bool == (x < y));

function {:never_pattern true} INTERNAL_le_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_le_boogie(x, y): bool } 
  INTERNAL_le_boogie(x, y): bool == (x <= y));

function {:never_pattern true} INTERNAL_gt_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_gt_boogie(x, y): bool } 
  INTERNAL_gt_boogie(x, y): bool == (x > y));

function {:never_pattern true} INTERNAL_ge_boogie(x: int, y: int) : bool;

axiom (forall x: int, y: int :: 
  {:never_pattern true} { INTERNAL_ge_boogie(x, y): bool } 
  INTERNAL_ge_boogie(x, y): bool == (x >= y));

function Mul(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mul(x, y): int } Mul(x, y): int == x * y);

function Div(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Div(x, y): int } Div(x, y): int == x div y);

function Mod(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Mod(x, y): int } Mod(x, y): int == x mod y);

function Add(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Add(x, y): int } Add(x, y): int == x + y);

function Sub(x: int, y: int) : int;

axiom (forall x: int, y: int :: { Sub(x, y): int } Sub(x, y): int == x - y);

function _System.__default.rank__is__less__than(A: Ty, B: Ty, a: Box, b: Box) : bool;

axiom (forall A: Ty, B: Ty, a: Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, a, b) ==> BoxRank(a) < BoxRank(b));

axiom (forall A: Ty, B: Ty, a: Box, b: Seq Box :: 
  { _System.__default.rank__is__less__than(A, B, a, $Box(b)), BoxRank(a) } 
    { _System.__default.rank__is__less__than(A, B, a, $Box(b)), Seq#Rank(b) } 
  _System.__default.rank__is__less__than(A, B, a, $Box(b))
     ==> BoxRank(a) < Seq#Rank(b));

axiom (forall A: Ty, B: Ty, a: Seq Box, b: Box :: 
  { _System.__default.rank__is__less__than(A, B, $Box(a), b), Seq#Rank(a) } 
    { _System.__default.rank__is__less__than(A, B, $Box(a), b), BoxRank(b) } 
  _System.__default.rank__is__less__than(A, B, $Box(a), b)
     ==> Seq#Rank(a) < BoxRank(b));

function {:bvbuiltin "bvand"} and_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvor"} or_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvxor"} xor_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvnot"} not_bv64(bv64) : bv64;

function {:bvbuiltin "bvadd"} add_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvsub"} sub_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvmul"} mul_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvudiv"} div_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvurem"} mod_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvult"} lt_bv64(bv64, bv64) : bool;

function {:bvbuiltin "bvule"} le_bv64(bv64, bv64) : bool;

function {:bvbuiltin "bvuge"} ge_bv64(bv64, bv64) : bool;

function {:bvbuiltin "bvugt"} gt_bv64(bv64, bv64) : bool;

function {:bvbuiltin "bvshl"} LeftShift_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "bvlshr"} RightShift_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "ext_rotate_left"} LeftRotate_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "ext_rotate_right"} RightRotate_bv64(bv64, bv64) : bv64;

function {:bvbuiltin "(_ int2bv 64)"} nat_to_bv64(int) : bv64;

function {:bvbuiltin "bv2int"} smt_nat_from_bv64(bv64) : int;

function nat_from_bv64(bv64) : int;

axiom (forall b: bv64 :: 
  { nat_from_bv64(b) } 
  0 <= nat_from_bv64(b)
     && nat_from_bv64(b) < 18446744073709551616
     && nat_from_bv64(b) == smt_nat_from_bv64(b));

function Tclass._System.nat() : Ty;

// Tclass._System.nat Tag
axiom Tag(Tclass._System.nat()) == Tagclass._System.nat;

const unique Tagclass._System.nat: TyTag;

// Box/unbox axiom for Tclass._System.nat
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.nat()) } 
  $IsBox(bx, Tclass._System.nat())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass._System.nat()));

// _System.nat: subset type $Is
axiom (forall x#0: int :: 
  { $Is(x#0, Tclass._System.nat()) } 
  $Is(x#0, Tclass._System.nat()) <==> LitInt(0) <= x#0);

// _System.nat: subset type $IsAlloc
axiom (forall x#0: int, $h: Heap :: 
  { $IsAlloc(x#0, Tclass._System.nat(), $h) } 
  $IsAlloc(x#0, Tclass._System.nat(), $h));

const unique class._System.object?: ClassName;

// Tclass._System.object? Tag
axiom Tag(Tclass._System.object?()) == Tagclass._System.object?;

const unique Tagclass._System.object?: TyTag;

// Box/unbox axiom for Tclass._System.object?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object?()) } 
  $IsBox(bx, Tclass._System.object?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object?()));

// object: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.object?()) } 
  $Is($o, Tclass._System.object?()));

// object: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.object?(), $h) } 
  $IsAlloc($o, Tclass._System.object?(), $h)
     <==> $o == null || read($h, $o, alloc));

function implements$_System.object(Ty) : bool;

function Tclass._System.object() : Ty;

// Tclass._System.object Tag
axiom Tag(Tclass._System.object()) == Tagclass._System.object;

const unique Tagclass._System.object: TyTag;

// Box/unbox axiom for Tclass._System.object
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.object()) } 
  $IsBox(bx, Tclass._System.object())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.object()));

// _System.object: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass._System.object()) } 
  $Is(c#0, Tclass._System.object())
     <==> $Is(c#0, Tclass._System.object?()) && c#0 != null);

// _System.object: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.object(), $h) } 
  $IsAlloc(c#0, Tclass._System.object(), $h)
     <==> $IsAlloc(c#0, Tclass._System.object?(), $h));

const unique class._System.array?: ClassName;

function Tclass._System.array?(Ty) : Ty;

// Tclass._System.array? Tag
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tag(Tclass._System.array?(#$arg)) == Tagclass._System.array?);

const unique Tagclass._System.array?: TyTag;

// Tclass._System.array? injectivity 0
axiom (forall #$arg: Ty :: 
  { Tclass._System.array?(#$arg) } 
  Tclass._System.array?_0(Tclass._System.array?(#$arg)) == #$arg);

function Tclass._System.array?_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array?
axiom (forall #$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array?(#$arg)) } 
  $IsBox(bx, Tclass._System.array?(#$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array?(#$arg)));

// array.: Type axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
     ==> $IsBox(read($h, $o, IndexField($i0)), #$arg));

// array.: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref, $i0: int :: 
  { read($h, $o, IndexField($i0)), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && 
      0 <= $i0
       && $i0 < _System.array.Length($o)
       && read($h, $o, alloc)
     ==> $IsAllocBox(read($h, $o, IndexField($i0)), #$arg, $h));

// array: Class $Is
axiom (forall #$arg: Ty, $o: ref :: 
  { $Is($o, Tclass._System.array?(#$arg)) } 
  $Is($o, Tclass._System.array?(#$arg))
     <==> $o == null || dtype($o) == Tclass._System.array?(#$arg));

// array: Class $IsAlloc
axiom (forall #$arg: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.array?(#$arg), $h) } 
  $IsAlloc($o, Tclass._System.array?(#$arg), $h)
     <==> $o == null || read($h, $o, alloc));

// array.Length: Type axiom
axiom (forall #$arg: Ty, $o: ref :: 
  { _System.array.Length($o), Tclass._System.array?(#$arg) } 
  $o != null && dtype($o) == Tclass._System.array?(#$arg)
     ==> $Is(_System.array.Length($o), TInt));

// array.Length: Allocation axiom
axiom (forall #$arg: Ty, $h: Heap, $o: ref :: 
  { _System.array.Length($o), read($h, $o, alloc), Tclass._System.array?(#$arg) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass._System.array?(#$arg)
       && read($h, $o, alloc)
     ==> $IsAlloc(_System.array.Length($o), TInt, $h));

function Tclass._System.array(Ty) : Ty;

// Tclass._System.array Tag
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tag(Tclass._System.array(_System.array$arg)) == Tagclass._System.array);

const unique Tagclass._System.array: TyTag;

// Tclass._System.array injectivity 0
axiom (forall _System.array$arg: Ty :: 
  { Tclass._System.array(_System.array$arg) } 
  Tclass._System.array_0(Tclass._System.array(_System.array$arg))
     == _System.array$arg);

function Tclass._System.array_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.array
axiom (forall _System.array$arg: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.array(_System.array$arg)) } 
  $IsBox(bx, Tclass._System.array(_System.array$arg))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass._System.array(_System.array$arg)));

// _System.array: subset type $Is
axiom (forall _System.array$arg: Ty, c#0: ref :: 
  { $Is(c#0, Tclass._System.array(_System.array$arg)) } 
  $Is(c#0, Tclass._System.array(_System.array$arg))
     <==> $Is(c#0, Tclass._System.array?(_System.array$arg)) && c#0 != null);

// _System.array: subset type $IsAlloc
axiom (forall _System.array$arg: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h) } 
  $IsAlloc(c#0, Tclass._System.array(_System.array$arg), $h)
     <==> $IsAlloc(c#0, Tclass._System.array?(_System.array$arg), $h));

function Tclass._System.___hFunc0(Ty) : Ty;

// Tclass._System.___hFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tag(Tclass._System.___hFunc0(#$R)) == Tagclass._System.___hFunc0);

const unique Tagclass._System.___hFunc0: TyTag;

// Tclass._System.___hFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hFunc0(#$R) } 
  Tclass._System.___hFunc0_0(Tclass._System.___hFunc0(#$R)) == #$R);

function Tclass._System.___hFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc0(#$R)));

function Handle0([Heap]Box, [Heap]bool, [Heap]Set Box) : HandleType;

function Apply0(Ty, Heap, HandleType) : Box;

function Requires0(Ty, Heap, HandleType) : bool;

function Reads0(Ty, Heap, HandleType) : Set Box;

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Apply0(t0, heap, Handle0(h, r, rd)) } 
  Apply0(t0, heap, Handle0(h, r, rd)) == h[heap]);

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box :: 
  { Requires0(t0, heap, Handle0(h, r, rd)) } 
  r[heap] ==> Requires0(t0, heap, Handle0(h, r, rd)));

axiom (forall t0: Ty, heap: Heap, h: [Heap]Box, r: [Heap]bool, rd: [Heap]Set Box, bx: Box :: 
  { Reads0(t0, heap, Handle0(h, r, rd))[bx] } 
  Reads0(t0, heap, Handle0(h, r, rd))[bx] == rd[heap][bx]);

function {:inline} Requires0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

function {:inline} Reads0#canCall(t0: Ty, heap: Heap, f: HandleType) : bool
{
  true
}

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Reads0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Reads0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads0(t0, h0, f) == Reads0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Requires0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Requires0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires0(t0, h0, f) == Requires0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h0, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// frame axiom for Apply0
axiom (forall t0: Ty, h0: Heap, h1: Heap, f: HandleType :: 
  { $HeapSucc(h0, h1), Apply0(t0, h1, f) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads0(t0, h1, f)[$Box(o)] ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply0(t0, h0, f) == Apply0(t0, h1, f));

// empty-reads property for Reads0 
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Reads0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Reads0(t0, heap, f) } 
  $IsGoodHeap(heap) && $Is(f, Tclass._System.___hFunc0(t0))
     ==> (Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
       <==> Set#Equal(Reads0(t0, heap, f), Set#Empty(): Set Box)));

// empty-reads property for Requires0
axiom (forall t0: Ty, heap: Heap, f: HandleType :: 
  { Requires0(t0, $OneHeap, f), $IsGoodHeap(heap) } { Requires0(t0, heap, f) } 
  $IsGoodHeap(heap)
       && $Is(f, Tclass._System.___hFunc0(t0))
       && Set#Equal(Reads0(t0, $OneHeap, f), Set#Empty(): Set Box)
     ==> Requires0(t0, $OneHeap, f) == Requires0(t0, heap, f));

axiom (forall f: HandleType, t0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
     <==> (forall h: Heap :: 
      { Apply0(t0, h, f) } 
      $IsGoodHeap(h) && Requires0(t0, h, f) ==> $IsBox(Apply0(t0, h, f), t0)));

axiom (forall f: HandleType, t0: Ty, u0: Ty :: 
  { $Is(f, Tclass._System.___hFunc0(t0)), $Is(f, Tclass._System.___hFunc0(u0)) } 
  $Is(f, Tclass._System.___hFunc0(t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t0) } { $IsBox(bx, u0) } 
        $IsBox(bx, t0) ==> $IsBox(bx, u0))
     ==> $Is(f, Tclass._System.___hFunc0(u0)));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc0(t0), h)
       <==> Requires0(t0, h, f)
         ==> (forall r: ref :: 
          { Reads0(t0, h, f)[$Box(r)] } 
          r != null && Reads0(t0, h, f)[$Box(r)] ==> read(h, r, alloc))));

axiom (forall f: HandleType, t0: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc0(t0), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc0(t0), h)
     ==> 
    Requires0(t0, h, f)
     ==> $IsAllocBox(Apply0(t0, h, f), t0, h));

function Tclass._System.___hPartialFunc0(Ty) : Ty;

// Tclass._System.___hPartialFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tag(Tclass._System.___hPartialFunc0(#$R)) == Tagclass._System.___hPartialFunc0);

const unique Tagclass._System.___hPartialFunc0: TyTag;

// Tclass._System.___hPartialFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hPartialFunc0(#$R) } 
  Tclass._System.___hPartialFunc0_0(Tclass._System.___hPartialFunc0(#$R)) == #$R);

function Tclass._System.___hPartialFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc0(#$R)));

// _System._#PartialFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hFunc0(#$R))
       && Set#Equal(Reads0(#$R, $OneHeap, f#0), Set#Empty(): Set Box));

// _System._#PartialFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc0(#$R), $h));

function Tclass._System.___hTotalFunc0(Ty) : Ty;

// Tclass._System.___hTotalFunc0 Tag
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tag(Tclass._System.___hTotalFunc0(#$R)) == Tagclass._System.___hTotalFunc0);

const unique Tagclass._System.___hTotalFunc0: TyTag;

// Tclass._System.___hTotalFunc0 injectivity 0
axiom (forall #$R: Ty :: 
  { Tclass._System.___hTotalFunc0(#$R) } 
  Tclass._System.___hTotalFunc0_0(Tclass._System.___hTotalFunc0(#$R)) == #$R);

function Tclass._System.___hTotalFunc0_0(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc0
axiom (forall #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc0(#$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc0(#$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc0(#$R)));

// _System._#TotalFunc0: subset type $Is
axiom (forall #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc0(#$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc0(#$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc0(#$R)) && Requires0(#$R, $OneHeap, f#0));

// _System._#TotalFunc0: subset type $IsAlloc
axiom (forall #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc0(#$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc0(#$R), $h));

const unique class._System.__default: ClassName;

function Tclass._System.__default() : Ty;

// Tclass._System.__default Tag
axiom Tag(Tclass._System.__default()) == Tagclass._System.__default;

const unique Tagclass._System.__default: TyTag;

// Box/unbox axiom for Tclass._System.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.__default()) } 
  $IsBox(bx, Tclass._System.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass._System.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass._System.__default()) } 
  $Is($o, Tclass._System.__default())
     <==> $o == null || dtype($o) == Tclass._System.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass._System.__default(), $h) } 
  $IsAlloc($o, Tclass._System.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function _System.__default.rank__is__less__than#canCall(#$A: Ty, #$B: Ty, a#0: Box, b#0: Box) : bool;

// consequence axiom for _System.__default.rank__is__less__than
axiom true
   ==> (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
    { _System.__default.rank__is__less__than(#$A, #$B, a#0, b#0) } 
    _System.__default.rank__is__less__than#canCall(#$A, #$B, a#0, b#0)
         || ($IsBox(a#0, #$A) && $IsBox(b#0, #$B))
       ==> true);

function _System.__default.rank__is__less__than#requires(Ty, Ty, Box, Box) : bool;

// #requires axiom for _System.__default.rank__is__less__than
axiom (forall #$A: Ty, #$B: Ty, a#0: Box, b#0: Box :: 
  { _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) } 
  $IsBox(a#0, #$A) && $IsBox(b#0, #$B)
     ==> _System.__default.rank__is__less__than#requires(#$A, #$B, a#0, b#0) == true);

function Tclass._System.___hFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == Tagclass._System.___hFunc2);

const unique Tagclass._System.___hFunc2: TyTag;

// Tclass._System.___hFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_0(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T0);

function Tclass._System.___hFunc2_0(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_1(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$T1);

function Tclass._System.___hFunc2_1(Ty) : Ty;

// Tclass._System.___hFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hFunc2_2(Tclass._System.___hFunc2(#$T0, #$T1, #$R)) == #$R);

function Tclass._System.___hFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc2(#$T0, #$T1, #$R)));

function Handle2([Heap,Box,Box]Box, [Heap,Box,Box]bool, [Heap,Box,Box]Set Box) : HandleType;

function Apply2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Box;

function Requires2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : bool;

function Reads2(Ty, Ty, Ty, Heap, HandleType, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  Apply2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) == h[heap, bx0, bx1]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box :: 
  { Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1) } 
  r[heap, bx0, bx1] ==> Requires2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box]Box, 
    r: [Heap,Box,Box]bool, 
    rd: [Heap,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx: Box :: 
  { Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx] } 
  Reads2(t0, t1, t2, heap, Handle2(h, r, rd), bx0, bx1)[bx]
     == rd[heap, bx0, bx1][bx]);

function {:inline} Requires2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

function {:inline} Reads2#canCall(t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box) : bool
{
  true
}

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Reads2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Reads2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads2(t0, t1, t2, h0, f, bx0, bx1) == Reads2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Requires2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires2(t0, t1, t2, h0, f, bx0, bx1) == Requires2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h0, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// frame axiom for Apply2
axiom (forall t0: Ty, t1: Ty, t2: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { $HeapSucc(h0, h1), Apply2(t0, t1, t2, h1, f, bx0, bx1) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads2(t0, t1, t2, h1, f, bx0, bx1)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply2(t0, t1, t2, h0, f, bx0, bx1) == Apply2(t0, t1, t2, h1, f, bx0, bx1));

// empty-reads property for Reads2 
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Reads2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     ==> (Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
       <==> Set#Equal(Reads2(t0, t1, t2, heap, f, bx0, bx1), Set#Empty(): Set Box)));

// empty-reads property for Requires2
axiom (forall t0: Ty, t1: Ty, t2: Ty, heap: Heap, f: HandleType, bx0: Box, bx1: Box :: 
  { Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1), $IsGoodHeap(heap) } 
    { Requires2(t0, t1, t2, heap, f, bx0, bx1) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && Set#Equal(Reads2(t0, t1, t2, $OneHeap, f, bx0, bx1), Set#Empty(): Set Box)
     ==> Requires2(t0, t1, t2, $OneHeap, f, bx0, bx1)
       == Requires2(t0, t1, t2, heap, f, bx0, bx1));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
     <==> (forall h: Heap, bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, u0: Ty, u1: Ty, u2: Ty :: 
  { $Is(f, Tclass._System.___hFunc2(t0, t1, t2)), $Is(f, Tclass._System.___hFunc2(u0, u1, u2)) } 
  $Is(f, Tclass._System.___hFunc2(t0, t1, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, t2) } { $IsBox(bx, u2) } 
        $IsBox(bx, t2) ==> $IsBox(bx, u2))
     ==> $Is(f, Tclass._System.___hFunc2(u0, u1, u2)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
       <==> (forall bx0: Box, bx1: Box :: 
        { Apply2(t0, t1, t2, h, f, bx0, bx1) } { Reads2(t0, t1, t2, h, f, bx0, bx1) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && Requires2(t0, t1, t2, h, f, bx0, bx1)
           ==> (forall r: ref :: 
            { Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] } 
            r != null && Reads2(t0, t1, t2, h, f, bx0, bx1)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc2(t0, t1, t2), h)
     ==> (forall bx0: Box, bx1: Box :: 
      { Apply2(t0, t1, t2, h, f, bx0, bx1) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && Requires2(t0, t1, t2, h, f, bx0, bx1)
         ==> $IsAllocBox(Apply2(t0, t1, t2, h, f, bx0, bx1), t2, h)));

function Tclass._System.___hPartialFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hPartialFunc2);

const unique Tagclass._System.___hPartialFunc2: TyTag;

// Tclass._System.___hPartialFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_0(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc2_0(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_1(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc2_1(Ty) : Ty;

// Tclass._System.___hPartialFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hPartialFunc2_2(Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hPartialFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)));

// _System._#PartialFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Set#Equal(Reads2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0), Set#Empty(): Set Box)));

// _System._#PartialFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc2(#$T0, #$T1, #$R), $h));

function Tclass._System.___hTotalFunc2(Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc2 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tag(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == Tagclass._System.___hTotalFunc2);

const unique Tagclass._System.___hTotalFunc2: TyTag;

// Tclass._System.___hTotalFunc2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_0(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc2_0(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_1(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc2_1(Ty) : Ty;

// Tclass._System.___hTotalFunc2 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R) } 
  Tclass._System.___hTotalFunc2_2(Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     == #$R);

function Tclass._System.___hTotalFunc2_2(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc2
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)));

// _System._#TotalFunc2: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R))
       && (forall x0#0: Box, x1#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1)
           ==> Requires2(#$T0, #$T1, #$R, $OneHeap, f#0, x0#0, x1#0)));

// _System._#TotalFunc2: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc2(#$T0, #$T1, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc2(#$T0, #$T1, #$R), $h));

// Constructor function declaration
function #_System._tuple#2._#Make2(Box, Box) : DatatypeType;

const unique ##_System._tuple#2._#Make2: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Box, a#0#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#_System._tuple#2._#Make2(a#0#0#0, a#0#1#0))
     == ##_System._tuple#2._#Make2);

function _System.Tuple2.___hMake2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#2._#Make2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d) } 
  _System.Tuple2.___hMake2_q(d)
     ==> (exists a#1#0#0: Box, a#1#1#0: Box :: 
      d == #_System._tuple#2._#Make2(a#1#0#0, a#1#1#0)));

function Tclass._System.Tuple2(Ty, Ty) : Ty;

// Tclass._System.Tuple2 Tag
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tag(Tclass._System.Tuple2(#$T0, #$T1)) == Tagclass._System.Tuple2);

const unique Tagclass._System.Tuple2: TyTag;

// Tclass._System.Tuple2 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_0(Tclass._System.Tuple2(#$T0, #$T1)) == #$T0);

function Tclass._System.Tuple2_0(Ty) : Ty;

// Tclass._System.Tuple2 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty :: 
  { Tclass._System.Tuple2(#$T0, #$T1) } 
  Tclass._System.Tuple2_1(Tclass._System.Tuple2(#$T0, #$T1)) == #$T1);

function Tclass._System.Tuple2_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.Tuple2
axiom (forall #$T0: Ty, #$T1: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $IsBox(bx, Tclass._System.Tuple2(#$T0, #$T1))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple2(#$T0, #$T1)));

// Constructor $Is
axiom (forall #$T0: Ty, #$T1: Ty, a#2#0#0: Box, a#2#1#0: Box :: 
  { $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(#_System._tuple#2._#Make2(a#2#0#0, a#2#1#0), Tclass._System.Tuple2(#$T0, #$T1))
     <==> $IsBox(a#2#0#0, #$T0) && $IsBox(a#2#1#0, #$T1));

// Constructor $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, a#3#0#0: Box, a#3#1#0: Box, $h: Heap :: 
  { $IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
      Tclass._System.Tuple2(#$T0, #$T1), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#_System._tuple#2._#Make2(a#3#0#0, a#3#1#0), 
        Tclass._System.Tuple2(#$T0, #$T1), 
        $h)
       <==> $IsAllocBox(a#3#0#0, #$T0, $h) && $IsAllocBox(a#3#1#0, #$T1, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T0: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._0(d), #$T0, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T1: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._0(d), #$T0, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, #$T1: Ty, $h: Heap :: 
  { $IsAllocBox(_System.Tuple2._1(d), #$T1, $h) } 
  $IsGoodHeap($h)
       && 
      _System.Tuple2.___hMake2_q(d)
       && (exists #$T0: Ty :: 
        { $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h) } 
        $IsAlloc(d, Tclass._System.Tuple2(#$T0, #$T1), $h))
     ==> $IsAllocBox(_System.Tuple2._1(d), #$T1, $h));

// Constructor literal
axiom (forall a#4#0#0: Box, a#4#1#0: Box :: 
  { #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #_System._tuple#2._#Make2(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#_System._tuple#2._#Make2(a#4#0#0, a#4#1#0)));

// Constructor injectivity
axiom (forall a#5#0#0: Box, a#5#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#5#0#0, a#5#1#0) } 
  _System.Tuple2._0(#_System._tuple#2._#Make2(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: Box, a#6#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#6#0#0, a#6#1#0) } 
  BoxRank(a#6#0#0) < DtRank(#_System._tuple#2._#Make2(a#6#0#0, a#6#1#0)));

// Constructor injectivity
axiom (forall a#7#0#0: Box, a#7#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#7#0#0, a#7#1#0) } 
  _System.Tuple2._1(#_System._tuple#2._#Make2(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: Box, a#8#1#0: Box :: 
  { #_System._tuple#2._#Make2(a#8#0#0, a#8#1#0) } 
  BoxRank(a#8#1#0) < DtRank(#_System._tuple#2._#Make2(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#_System.Tuple2(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple2(d) } 
  $IsA#_System.Tuple2(d) ==> _System.Tuple2.___hMake2_q(d));

// Questionmark data type disjunctivity
axiom (forall #$T0: Ty, #$T1: Ty, d: DatatypeType :: 
  { _System.Tuple2.___hMake2_q(d), $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) } 
  $Is(d, Tclass._System.Tuple2(#$T0, #$T1)) ==> _System.Tuple2.___hMake2_q(d));

// Datatype extensional equality declaration
function _System.Tuple2#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#2._#Make2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  true
     ==> (_System.Tuple2#Equal(a, b)
       <==> _System.Tuple2._0(a) == _System.Tuple2._0(b)
         && _System.Tuple2._1(a) == _System.Tuple2._1(b)));

// Datatype extensionality axiom: _System._tuple#2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple2#Equal(a, b) } 
  _System.Tuple2#Equal(a, b) <==> a == b);

const unique class._System.Tuple2: ClassName;

function Tclass._System.___hFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hFunc3);

const unique Tagclass._System.___hFunc3: TyTag;

// Tclass._System.___hFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_0(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hFunc3_0(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_1(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hFunc3_1(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_2(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hFunc3_2(Ty) : Ty;

// Tclass._System.___hFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hFunc3_3(Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R)));

function Handle3([Heap,Box,Box,Box]Box, [Heap,Box,Box,Box]bool, [Heap,Box,Box,Box]Set Box)
   : HandleType;

function Apply3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Box;

function Requires3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : bool;

function Reads3(Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  Apply3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)
     == h[heap, bx0, bx1, bx2]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2) } 
  r[heap, bx0, bx1, bx2]
     ==> Requires3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx: Box :: 
  { Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx] } 
  Reads3(t0, t1, t2, t3, heap, Handle3(h, r, rd), bx0, bx1, bx2)[bx]
     == rd[heap, bx0, bx1, bx2][bx]);

function {:inline} Requires3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

function {:inline} Reads3#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box)
   : bool
{
  true
}

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Reads3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// frame axiom for Apply3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { $HeapSucc(h0, h1), Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply3(t0, t1, t2, t3, h0, f, bx0, bx1, bx2)
       == Apply3(t0, t1, t2, t3, h1, f, bx0, bx1, bx2));

// empty-reads property for Reads3 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     ==> (Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
       <==> Set#Equal(Reads3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2), Set#Empty(): Set Box)));

// empty-reads property for Requires3
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box :: 
  { Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), $IsGoodHeap(heap) } 
    { Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && Set#Equal(Reads3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2), Set#Empty(): Set Box)
     ==> Requires3(t0, t1, t2, t3, $OneHeap, f, bx0, bx1, bx2)
       == Requires3(t0, t1, t2, t3, heap, f, bx0, bx1, bx2));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, u0: Ty, u1: Ty, u2: Ty, u3: Ty :: 
  { $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3)), $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)) } 
  $Is(f, Tclass._System.___hFunc3(t0, t1, t2, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, t3) } { $IsBox(bx, u3) } 
        $IsBox(bx, t3) ==> $IsBox(bx, u3))
     ==> $Is(f, Tclass._System.___hFunc3(u0, u1, u2, u3)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box :: 
        { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
          { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
           ==> (forall r: ref :: 
            { Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)] } 
            r != null && Reads3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc3(t0, t1, t2, t3), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box :: 
      { Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && Requires3(t0, t1, t2, t3, h, f, bx0, bx1, bx2)
         ==> $IsAllocBox(Apply3(t0, t1, t2, t3, h, f, bx0, bx1, bx2), t3, h)));

function Tclass._System.___hPartialFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hPartialFunc3);

const unique Tagclass._System.___hPartialFunc3: TyTag;

// Tclass._System.___hPartialFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_0(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc3_0(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_1(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc3_1(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_2(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc3_2(Ty) : Ty;

// Tclass._System.___hPartialFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hPartialFunc3_3(Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hPartialFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#PartialFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Set#Equal(Reads3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hTotalFunc3(Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc3 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tag(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == Tagclass._System.___hTotalFunc3);

const unique Tagclass._System.___hTotalFunc3: TyTag;

// Tclass._System.___hTotalFunc3 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_0(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc3_0(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_1(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc3_1(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_2(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc3_2(Ty) : Ty;

// Tclass._System.___hTotalFunc3 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R) } 
  Tclass._System.___hTotalFunc3_3(Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     == #$R);

function Tclass._System.___hTotalFunc3_3(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)));

// _System._#TotalFunc3: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box :: 
        $IsBox(x0#0, #$T0) && $IsBox(x1#0, #$T1) && $IsBox(x2#0, #$T2)
           ==> Requires3(#$T0, #$T1, #$T2, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0)));

// _System._#TotalFunc3: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc3(#$T0, #$T1, #$T2, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc3(#$T0, #$T1, #$T2, #$R), $h));

function Tclass._System.___hFunc1(Ty, Ty) : Ty;

// Tclass._System.___hFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hFunc1(#$T0, #$R)) == Tagclass._System.___hFunc1);

const unique Tagclass._System.___hFunc1: TyTag;

// Tclass._System.___hFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_0(Tclass._System.___hFunc1(#$T0, #$R)) == #$T0);

function Tclass._System.___hFunc1_0(Ty) : Ty;

// Tclass._System.___hFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc1(#$T0, #$R) } 
  Tclass._System.___hFunc1_1(Tclass._System.___hFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc1(#$T0, #$R)));

function Handle1([Heap,Box]Box, [Heap,Box]bool, [Heap,Box]Set Box) : HandleType;

function Requires1(Ty, Ty, Heap, HandleType, Box) : bool;

function Reads1(Ty, Ty, Heap, HandleType, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  Apply1(t0, t1, heap, Handle1(h, r, rd), bx0) == h[heap, bx0]);

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box :: 
  { Requires1(t0, t1, heap, Handle1(h, r, rd), bx0) } 
  r[heap, bx0] ==> Requires1(t0, t1, heap, Handle1(h, r, rd), bx0));

axiom (forall t0: Ty, 
    t1: Ty, 
    heap: Heap, 
    h: [Heap,Box]Box, 
    r: [Heap,Box]bool, 
    rd: [Heap,Box]Set Box, 
    bx0: Box, 
    bx: Box :: 
  { Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] } 
  Reads1(t0, t1, heap, Handle1(h, r, rd), bx0)[bx] == rd[heap, bx0][bx]);

function {:inline} Requires1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

function {:inline} Reads1#canCall(t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box) : bool
{
  true
}

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Reads1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Reads1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads1(t0, t1, h0, f, bx0) == Reads1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Requires1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Requires1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires1(t0, t1, h0, f, bx0) == Requires1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h0, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// frame axiom for Apply1
axiom (forall t0: Ty, t1: Ty, h0: Heap, h1: Heap, f: HandleType, bx0: Box :: 
  { $HeapSucc(h0, h1), Apply1(t0, t1, h1, f, bx0) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads1(t0, t1, h1, f, bx0)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply1(t0, t1, h0, f, bx0) == Apply1(t0, t1, h1, f, bx0));

// empty-reads property for Reads1 
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Reads1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Reads1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap) && $IsBox(bx0, t0) && $Is(f, Tclass._System.___hFunc1(t0, t1))
     ==> (Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
       <==> Set#Equal(Reads1(t0, t1, heap, f, bx0), Set#Empty(): Set Box)));

// empty-reads property for Requires1
axiom (forall t0: Ty, t1: Ty, heap: Heap, f: HandleType, bx0: Box :: 
  { Requires1(t0, t1, $OneHeap, f, bx0), $IsGoodHeap(heap) } 
    { Requires1(t0, t1, heap, f, bx0) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $Is(f, Tclass._System.___hFunc1(t0, t1))
       && Set#Equal(Reads1(t0, t1, $OneHeap, f, bx0), Set#Empty(): Set Box)
     ==> Requires1(t0, t1, $OneHeap, f, bx0) == Requires1(t0, t1, heap, f, bx0));

axiom (forall f: HandleType, t0: Ty, t1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
     <==> (forall h: Heap, bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsGoodHeap(h) && $IsBox(bx0, t0) && Requires1(t0, t1, h, f, bx0)
         ==> $IsBox(Apply1(t0, t1, h, f, bx0), t1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, u0: Ty, u1: Ty :: 
  { $Is(f, Tclass._System.___hFunc1(t0, t1)), $Is(f, Tclass._System.___hFunc1(u0, u1)) } 
  $Is(f, Tclass._System.___hFunc1(t0, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, t1) } { $IsBox(bx, u1) } 
        $IsBox(bx, t1) ==> $IsBox(bx, u1))
     ==> $Is(f, Tclass._System.___hFunc1(u0, u1)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
       <==> (forall bx0: Box :: 
        { Apply1(t0, t1, h, f, bx0) } { Reads1(t0, t1, h, f, bx0) } 
        $IsBox(bx0, t0) && $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
           ==> (forall r: ref :: 
            { Reads1(t0, t1, h, f, bx0)[$Box(r)] } 
            r != null && Reads1(t0, t1, h, f, bx0)[$Box(r)] ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc1(t0, t1), h)
     ==> (forall bx0: Box :: 
      { Apply1(t0, t1, h, f, bx0) } 
      $IsAllocBox(bx0, t0, h) && Requires1(t0, t1, h, f, bx0)
         ==> $IsAllocBox(Apply1(t0, t1, h, f, bx0), t1, h)));

function Tclass._System.___hPartialFunc1(Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == Tagclass._System.___hPartialFunc1);

const unique Tagclass._System.___hPartialFunc1: TyTag;

// Tclass._System.___hPartialFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_0(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc1_0(Ty) : Ty;

// Tclass._System.___hPartialFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc1(#$T0, #$R) } 
  Tclass._System.___hPartialFunc1_1(Tclass._System.___hPartialFunc1(#$T0, #$R))
     == #$R);

function Tclass._System.___hPartialFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hPartialFunc1(#$T0, #$R)));

// _System._#PartialFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0)
           ==> Set#Equal(Reads1(#$T0, #$R, $OneHeap, f#0, x0#0), Set#Empty(): Set Box)));

// _System._#PartialFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc1(#$T0, #$R), $h));

function Tclass._System.___hTotalFunc1(Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc1 Tag
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tag(Tclass._System.___hTotalFunc1(#$T0, #$R)) == Tagclass._System.___hTotalFunc1);

const unique Tagclass._System.___hTotalFunc1: TyTag;

// Tclass._System.___hTotalFunc1 injectivity 0
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_0(Tclass._System.___hTotalFunc1(#$T0, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc1_0(Ty) : Ty;

// Tclass._System.___hTotalFunc1 injectivity 1
axiom (forall #$T0: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc1(#$T0, #$R) } 
  Tclass._System.___hTotalFunc1_1(Tclass._System.___hTotalFunc1(#$T0, #$R)) == #$R);

function Tclass._System.___hTotalFunc1_1(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc1
axiom (forall #$T0: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc1(#$T0, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hTotalFunc1(#$T0, #$R)));

// _System._#TotalFunc1: subset type $Is
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R))
       && (forall x0#0: Box :: 
        $IsBox(x0#0, #$T0) ==> Requires1(#$T0, #$R, $OneHeap, f#0, x0#0)));

// _System._#TotalFunc1: subset type $IsAlloc
axiom (forall #$T0: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc1(#$T0, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc1(#$T0, #$R), $h));

function Tclass._System.___hFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hFunc4);

const unique Tagclass._System.___hFunc4: TyTag;

// Tclass._System.___hFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_0(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hFunc4_0(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_1(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hFunc4_1(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_2(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hFunc4_2(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_3(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hFunc4_3(Ty) : Ty;

// Tclass._System.___hFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hFunc4_4(Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

function Handle4([Heap,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Box;

function Requires4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : bool;

function Reads4(Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  Apply4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)
     == h[heap, bx0, bx1, bx2, bx3]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3) } 
  r[heap, bx0, bx1, bx2, bx3]
     ==> Requires4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx: Box :: 
  { Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx] } 
  Reads4(t0, t1, t2, t3, t4, heap, Handle4(h, r, rd), bx0, bx1, bx2, bx3)[bx]
     == rd[heap, bx0, bx1, bx2, bx3][bx]);

function {:inline} Requires4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

function {:inline} Reads4#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box)
   : bool
{
  true
}

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Reads4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// frame axiom for Apply4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { $HeapSucc(h0, h1), Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall<a> o: ref, fld: Field a :: 
        o != null && Reads4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply4(t0, t1, t2, t3, t4, h0, f, bx0, bx1, bx2, bx3)
       == Apply4(t0, t1, t2, t3, t4, h1, f, bx0, bx1, bx2, bx3));

// empty-reads property for Reads4 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     ==> (Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3), Set#Empty(): Set Box)));

// empty-reads property for Requires4
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box :: 
  { Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), $IsGoodHeap(heap) } 
    { Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && Set#Equal(Reads4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3), 
        Set#Empty(): Set Box)
     ==> Requires4(t0, t1, t2, t3, t4, $OneHeap, f, bx0, bx1, bx2, bx3)
       == Requires4(t0, t1, t2, t3, t4, heap, f, bx0, bx1, bx2, bx3));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty :: 
  { $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4)), $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)) } 
  $Is(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, t4) } { $IsBox(bx, u4) } 
        $IsBox(bx, t4) ==> $IsBox(bx, u4))
     ==> $Is(f, Tclass._System.___hFunc4(u0, u1, u2, u3, u4)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
        { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
          { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
           ==> (forall r: ref :: 
            { Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)] } 
            r != null && Reads4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h) } 
  $IsGoodHeap(h) && $IsAlloc(f, Tclass._System.___hFunc4(t0, t1, t2, t3, t4), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box :: 
      { Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && Requires4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3)
         ==> $IsAllocBox(Apply4(t0, t1, t2, t3, t4, h, f, bx0, bx1, bx2, bx3), t4, h)));

function Tclass._System.___hPartialFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hPartialFunc4);

const unique Tagclass._System.___hPartialFunc4: TyTag;

// Tclass._System.___hPartialFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_0(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc4_0(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_1(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc4_1(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_2(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc4_2(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_3(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc4_3(Ty) : Ty;

// Tclass._System.___hPartialFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hPartialFunc4_4(Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hPartialFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#PartialFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Set#Equal(Reads4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hTotalFunc4(Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc4 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tag(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == Tagclass._System.___hTotalFunc4);

const unique Tagclass._System.___hTotalFunc4: TyTag;

// Tclass._System.___hTotalFunc4 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_0(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc4_0(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_1(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc4_1(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_2(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc4_2(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_3(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc4_3(Ty) : Ty;

// Tclass._System.___hTotalFunc4 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R) } 
  Tclass._System.___hTotalFunc4_4(Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     == #$R);

function Tclass._System.___hTotalFunc4_4(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)));

// _System._#TotalFunc4: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
           ==> Requires4(#$T0, #$T1, #$T2, #$T3, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0)));

// _System._#TotalFunc4: subset type $IsAlloc
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$R: Ty, f#0: HandleType, $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc4(#$T0, #$T1, #$T2, #$T3, #$R), $h));

function Tclass._System.___hFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hFunc5);

const unique Tagclass._System.___hFunc5: TyTag;

// Tclass._System.___hFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_0(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hFunc5_0(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_1(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hFunc5_1(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_2(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hFunc5_2(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_3(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hFunc5_3(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_4(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hFunc5_4(Ty) : Ty;

// Tclass._System.___hFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hFunc5_5(Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

function Handle5([Heap,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Box;

function Requires5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : bool;

function Reads5(Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box) : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  Apply5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)
     == h[heap, bx0, bx1, bx2, bx3, bx4]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4) } 
  r[heap, bx0, bx1, bx2, bx3, bx4]
     ==> Requires5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx] } 
  Reads5(t0, t1, t2, t3, t4, t5, heap, Handle5(h, r, rd), bx0, bx1, bx2, bx3, bx4)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4][bx]);

function {:inline} Requires5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

function {:inline} Reads5#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box)
   : bool
{
  true
}

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Reads5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// frame axiom for Apply5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { $HeapSucc(h0, h1), Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply5(t0, t1, t2, t3, t4, t5, h0, f, bx0, bx1, bx2, bx3, bx4)
       == Apply5(t0, t1, t2, t3, t4, t5, h1, f, bx0, bx1, bx2, bx3, bx4));

// empty-reads property for Reads5 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     ==> (Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires5
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box :: 
  { Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), $IsGoodHeap(heap) } 
    { Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && Set#Equal(Reads5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4), 
        Set#Empty(): Set Box)
     ==> Requires5(t0, t1, t2, t3, t4, t5, $OneHeap, f, bx0, bx1, bx2, bx3, bx4)
       == Requires5(t0, t1, t2, t3, t4, t5, heap, f, bx0, bx1, bx2, bx3, bx4));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty :: 
  { $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5)), $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)) } 
  $Is(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, t5) } { $IsBox(bx, u5) } 
        $IsBox(bx, t5) ==> $IsBox(bx, u5))
     ==> $Is(f, Tclass._System.___hFunc5(u0, u1, u2, u3, u4, u5)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
        { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
          { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
           ==> (forall r: ref :: 
            { Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)] } 
            r != null
                 && Reads5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc5(t0, t1, t2, t3, t4, t5), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box :: 
      { Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && Requires5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4)
         ==> $IsAllocBox(Apply5(t0, t1, t2, t3, t4, t5, h, f, bx0, bx1, bx2, bx3, bx4), t5, h)));

function Tclass._System.___hPartialFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hPartialFunc5);

const unique Tagclass._System.___hPartialFunc5: TyTag;

// Tclass._System.___hPartialFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_0(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc5_0(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_1(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc5_1(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_2(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc5_2(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_3(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc5_3(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_4(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc5_4(Ty) : Ty;

// Tclass._System.___hPartialFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hPartialFunc5_5(Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hPartialFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#PartialFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Set#Equal(Reads5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hTotalFunc5(Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc5 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tag(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == Tagclass._System.___hTotalFunc5);

const unique Tagclass._System.___hTotalFunc5: TyTag;

// Tclass._System.___hTotalFunc5 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_0(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc5_0(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_1(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc5_1(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_2(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc5_2(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_3(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc5_3(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_4(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc5_4(Ty) : Ty;

// Tclass._System.___hTotalFunc5 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R) } 
  Tclass._System.___hTotalFunc5_5(Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     == #$R);

function Tclass._System.___hTotalFunc5_5(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)));

// _System._#TotalFunc5: subset type $Is
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$R: Ty, f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
           ==> Requires5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R, $OneHeap, f#0, x0#0, x1#0, x2#0, x3#0, x4#0)));

// _System._#TotalFunc5: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h)
     <==> $IsAlloc(f#0, Tclass._System.___hPartialFunc5(#$T0, #$T1, #$T2, #$T3, #$T4, #$R), $h));

function Tclass._System.___hFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hFunc6);

const unique Tagclass._System.___hFunc6: TyTag;

// Tclass._System.___hFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_0(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hFunc6_0(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_1(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hFunc6_1(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_2(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hFunc6_2(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_3(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hFunc6_3(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_4(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hFunc6_4(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_5(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hFunc6_5(Ty) : Ty;

// Tclass._System.___hFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hFunc6_6(Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

function Handle6([Heap,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Box;

function Requires6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : bool;

function Reads6(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Heap, HandleType, Box, Box, Box, Box, Box, Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  Apply6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5]
     ==> Requires6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx: Box :: 
  { Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx] } 
  Reads6(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      heap, 
      Handle6(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5][bx]);

function {:inline} Requires6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

function {:inline} Reads6#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box)
   : bool
{
  true
}

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Reads6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// frame axiom for Apply6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { $HeapSucc(h0, h1), Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply6(t0, t1, t2, t3, t4, t5, t6, h0, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Apply6(t0, t1, t2, t3, t4, t5, t6, h1, f, bx0, bx1, bx2, bx3, bx4, bx5));

// empty-reads property for Reads6 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     ==> (Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires6
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box :: 
  { Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), $IsGoodHeap(heap) } 
    { Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && Set#Equal(Reads6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5), 
        Set#Empty(): Set Box)
     ==> Requires6(t0, t1, t2, t3, t4, t5, t6, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5)
       == Requires6(t0, t1, t2, t3, t4, t5, t6, heap, f, bx0, bx1, bx2, bx3, bx4, bx5));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty :: 
  { $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6)), $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)) } 
  $Is(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, t6) } { $IsBox(bx, u6) } 
        $IsBox(bx, t6) ==> $IsBox(bx, u6))
     ==> $Is(f, Tclass._System.___hFunc6(u0, u1, u2, u3, u4, u5, u6)));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
        { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
          { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
           ==> (forall r: ref :: 
            { Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)] } 
            r != null
                 && Reads6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc6(t0, t1, t2, t3, t4, t5, t6), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box :: 
      { Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && Requires6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5)
         ==> $IsAllocBox(Apply6(t0, t1, t2, t3, t4, t5, t6, h, f, bx0, bx1, bx2, bx3, bx4, bx5), t6, h)));

function Tclass._System.___hPartialFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hPartialFunc6);

const unique Tagclass._System.___hPartialFunc6: TyTag;

// Tclass._System.___hPartialFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_0(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc6_0(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_1(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc6_1(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_2(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc6_2(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_3(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc6_3(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_4(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc6_4(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_5(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc6_5(Ty) : Ty;

// Tclass._System.___hPartialFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hPartialFunc6_6(Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hPartialFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#PartialFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Set#Equal(Reads6(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h));

function Tclass._System.___hTotalFunc6(Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc6 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tag(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == Tagclass._System.___hTotalFunc6);

const unique Tagclass._System.___hTotalFunc6: TyTag;

// Tclass._System.___hTotalFunc6 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_0(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc6_0(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_1(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc6_1(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_2(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc6_2(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_3(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc6_3(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_4(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc6_4(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_5(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc6_5(Ty) : Ty;

// Tclass._System.___hTotalFunc6 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R) } 
  Tclass._System.___hTotalFunc6_6(Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     == #$R);

function Tclass._System.___hTotalFunc6_6(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$R: Ty, bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)));

// _System._#TotalFunc6: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R)) } 
  $Is(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
     <==> $Is(f#0, Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
           ==> Requires6(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0)));

// _System._#TotalFunc6: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h) } 
  $IsAlloc(f#0, Tclass._System.___hTotalFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc6(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$R), 
      $h));

function Tclass._System.___hFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hFunc7);

const unique Tagclass._System.___hFunc7: TyTag;

// Tclass._System.___hFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_0(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hFunc7_0(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_1(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hFunc7_1(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_2(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hFunc7_2(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_3(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hFunc7_3(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_4(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hFunc7_4(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_5(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hFunc7_5(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_6(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hFunc7_6(Ty) : Ty;

// Tclass._System.___hFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hFunc7_7(Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

function Handle7([Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Box;

function Requires7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : bool;

function Reads7(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  Apply7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6]
     ==> Requires7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx: Box :: 
  { Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx] } 
  Reads7(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      heap, 
      Handle7(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6][bx]);

function {:inline} Requires7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

function {:inline} Reads7#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box)
   : bool
{
  true
}

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Reads7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// frame axiom for Apply7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { $HeapSucc(h0, h1), Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h0, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h1, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

// empty-reads property for Reads7 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     ==> (Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires7
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box :: 
  { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), $IsGoodHeap(heap) } 
    { Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && Set#Equal(Reads7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
        Set#Empty(): Set Box)
     ==> Requires7(t0, t1, t2, t3, t4, t5, t6, t7, $OneHeap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
       == Requires7(t0, t1, t2, t3, t4, t5, t6, t7, heap, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6));

axiom (forall f: HandleType, t0: Ty, t1: Ty, t2: Ty, t3: Ty, t4: Ty, t5: Ty, t6: Ty, t7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
     <==> (forall h: Heap, bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && $IsBox(bx6, t6)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty, 
    u7: Ty :: 
  { $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7)), $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)) } 
  $Is(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u6) } { $IsBox(bx, t6) } 
        $IsBox(bx, u6) ==> $IsBox(bx, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, t7) } { $IsBox(bx, u7) } 
        $IsBox(bx, t7) ==> $IsBox(bx, u7))
     ==> $Is(f, Tclass._System.___hFunc7(u0, u1, u2, u3, u4, u5, u6, u7)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
       <==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
        { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
          { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && 
            $IsBox(bx6, t6)
             && $IsAllocBox(bx6, t6, h)
             && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
           ==> (forall r: ref :: 
            { Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)] } 
            r != null
                 && Reads7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc7(t0, t1, t2, t3, t4, t5, t6, t7), h)
     ==> (forall bx0: Box, bx1: Box, bx2: Box, bx3: Box, bx4: Box, bx5: Box, bx6: Box :: 
      { Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && $IsAllocBox(bx6, t6, h)
           && Requires7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6)
         ==> $IsAllocBox(Apply7(t0, t1, t2, t3, t4, t5, t6, t7, h, f, bx0, bx1, bx2, bx3, bx4, bx5, bx6), 
          t7, 
          h)));

function Tclass._System.___hPartialFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hPartialFunc7);

const unique Tagclass._System.___hPartialFunc7: TyTag;

// Tclass._System.___hPartialFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_0(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc7_0(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_1(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc7_1(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_2(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc7_2(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_3(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc7_3(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_4(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc7_4(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_5(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc7_5(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_6(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hPartialFunc7_6(Ty) : Ty;

// Tclass._System.___hPartialFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hPartialFunc7_7(Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hPartialFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#PartialFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Set#Equal(Reads7(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$T6, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0, 
              x6#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, Tclass._System.___hFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), $h));

function Tclass._System.___hTotalFunc7(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc7 Tag
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tag(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == Tagclass._System.___hTotalFunc7);

const unique Tagclass._System.___hTotalFunc7: TyTag;

// Tclass._System.___hTotalFunc7 injectivity 0
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_0(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc7_0(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 1
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_1(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc7_1(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 2
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_2(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc7_2(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 3
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_3(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc7_3(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 4
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_4(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc7_4(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 5
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_5(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc7_5(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 6
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_6(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$T6);

function Tclass._System.___hTotalFunc7_6(Ty) : Ty;

// Tclass._System.___hTotalFunc7 injectivity 7
axiom (forall #$T0: Ty, #$T1: Ty, #$T2: Ty, #$T3: Ty, #$T4: Ty, #$T5: Ty, #$T6: Ty, #$R: Ty :: 
  { Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R) } 
  Tclass._System.___hTotalFunc7_7(Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     == #$R);

function Tclass._System.___hTotalFunc7_7(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $IsBox(bx, Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)));

// _System._#TotalFunc7: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R))
       && (forall x0#0: Box, x1#0: Box, x2#0: Box, x3#0: Box, x4#0: Box, x5#0: Box, x6#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
           ==> Requires7(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$T6, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0, 
            x6#0)));

// _System._#TotalFunc7: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc7(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$R), 
      $h));

function Tclass._System.___hFunc10(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hFunc10 Tag
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tag(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == Tagclass._System.___hFunc10);

const unique Tagclass._System.___hFunc10: TyTag;

// Tclass._System.___hFunc10 injectivity 0
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_0(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T0);

function Tclass._System.___hFunc10_0(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 1
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_1(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T1);

function Tclass._System.___hFunc10_1(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 2
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_2(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T2);

function Tclass._System.___hFunc10_2(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 3
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_3(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T3);

function Tclass._System.___hFunc10_3(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 4
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_4(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T4);

function Tclass._System.___hFunc10_4(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 5
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_5(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T5);

function Tclass._System.___hFunc10_5(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 6
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_6(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T6);

function Tclass._System.___hFunc10_6(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_7(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T7);

function Tclass._System.___hFunc10_7(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 8
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_8(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T8);

function Tclass._System.___hFunc10_8(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 9
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_9(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T9);

function Tclass._System.___hFunc10_9(Ty) : Ty;

// Tclass._System.___hFunc10 injectivity 10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hFunc10_10(Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$R);

function Tclass._System.___hFunc10_10(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hFunc10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)));

function Handle10([Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box)
   : HandleType;

function Apply10(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Box;

function Requires10(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : bool;

function Reads10(Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Ty, 
    Heap, 
    HandleType, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box, 
    Box)
   : Set Box;

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9)
     == h[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6, bx7, bx8, bx9]);

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  r[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6, bx7, bx8, bx9]
     ==> Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9));

axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    h: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Box, 
    r: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]bool, 
    rd: [Heap,Box,Box,Box,Box,Box,Box,Box,Box,Box,Box]Set Box, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box, 
    bx: Box :: 
  { Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9)[bx] } 
  Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      Handle10(h, r, rd), 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9)[bx]
     == rd[heap, bx0, bx1, bx2, bx3, bx4, bx5, bx6, bx7, bx8, bx9][bx]);

function {:inline} Requires10#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box)
   : bool
{
  true
}

function {:inline} Reads10#canCall(t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box)
   : bool
{
  true
}

// frame axiom for Reads10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h0, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Reads10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h1, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Reads10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Requires10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h0, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Requires10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h1, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Apply10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h0, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// frame axiom for Apply10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h0: Heap, 
    h1: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { $HeapSucc(h0, h1), Apply10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      h1, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $HeapSucc(h0, h1)
       && 
      $IsGoodHeap(h0)
       && $IsGoodHeap(h1)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall<a> o: ref, fld: Field a :: 
        o != null
             && Reads10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h1, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)[$Box(o)]
           ==> read(h0, o, fld) == read(h1, o, fld))
     ==> Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h0, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Apply10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        h1, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

// empty-reads property for Reads10 
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      $OneHeap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9), $IsGoodHeap(heap) } 
    { Reads10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
     ==> (Set#Equal(Reads10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          $OneHeap, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9), 
        Set#Empty(): Set Box)
       <==> Set#Equal(Reads10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          heap, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9), 
        Set#Empty(): Set Box)));

// empty-reads property for Requires10
axiom (forall t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    heap: Heap, 
    f: HandleType, 
    bx0: Box, 
    bx1: Box, 
    bx2: Box, 
    bx3: Box, 
    bx4: Box, 
    bx5: Box, 
    bx6: Box, 
    bx7: Box, 
    bx8: Box, 
    bx9: Box :: 
  { Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      $OneHeap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9), $IsGoodHeap(heap) } 
    { Requires10(t0, 
      t1, 
      t2, 
      t3, 
      t4, 
      t5, 
      t6, 
      t7, 
      t8, 
      t9, 
      t10, 
      heap, 
      f, 
      bx0, 
      bx1, 
      bx2, 
      bx3, 
      bx4, 
      bx5, 
      bx6, 
      bx7, 
      bx8, 
      bx9) } 
  $IsGoodHeap(heap)
       && 
      $IsBox(bx0, t0)
       && $IsBox(bx1, t1)
       && $IsBox(bx2, t2)
       && $IsBox(bx3, t3)
       && $IsBox(bx4, t4)
       && $IsBox(bx5, t5)
       && $IsBox(bx6, t6)
       && $IsBox(bx7, t7)
       && $IsBox(bx8, t8)
       && $IsBox(bx9, t9)
       && $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && Set#Equal(Reads10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          $OneHeap, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9), 
        Set#Empty(): Set Box)
     ==> Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        $OneHeap, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9)
       == Requires10(t0, 
        t1, 
        t2, 
        t3, 
        t4, 
        t5, 
        t6, 
        t7, 
        t8, 
        t9, 
        t10, 
        heap, 
        f, 
        bx0, 
        bx1, 
        bx2, 
        bx3, 
        bx4, 
        bx5, 
        bx6, 
        bx7, 
        bx8, 
        bx9));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty :: 
  { $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10)) } 
  $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
     <==> (forall h: Heap, 
        bx0: Box, 
        bx1: Box, 
        bx2: Box, 
        bx3: Box, 
        bx4: Box, 
        bx5: Box, 
        bx6: Box, 
        bx7: Box, 
        bx8: Box, 
        bx9: Box :: 
      { Apply10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          h, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9) } 
      $IsGoodHeap(h)
           && 
          $IsBox(bx0, t0)
           && $IsBox(bx1, t1)
           && $IsBox(bx2, t2)
           && $IsBox(bx3, t3)
           && $IsBox(bx4, t4)
           && $IsBox(bx5, t5)
           && $IsBox(bx6, t6)
           && $IsBox(bx7, t7)
           && $IsBox(bx8, t8)
           && $IsBox(bx9, t9)
           && Requires10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9)
         ==> $IsBox(Apply10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9), 
          t10)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    u0: Ty, 
    u1: Ty, 
    u2: Ty, 
    u3: Ty, 
    u4: Ty, 
    u5: Ty, 
    u6: Ty, 
    u7: Ty, 
    u8: Ty, 
    u9: Ty, 
    u10: Ty :: 
  { $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10)), $Is(f, Tclass._System.___hFunc10(u0, u1, u2, u3, u4, u5, u6, u7, u8, u9, u10)) } 
  $Is(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10))
       && (forall bx: Box :: 
        { $IsBox(bx, u0) } { $IsBox(bx, t0) } 
        $IsBox(bx, u0) ==> $IsBox(bx, t0))
       && (forall bx: Box :: 
        { $IsBox(bx, u1) } { $IsBox(bx, t1) } 
        $IsBox(bx, u1) ==> $IsBox(bx, t1))
       && (forall bx: Box :: 
        { $IsBox(bx, u2) } { $IsBox(bx, t2) } 
        $IsBox(bx, u2) ==> $IsBox(bx, t2))
       && (forall bx: Box :: 
        { $IsBox(bx, u3) } { $IsBox(bx, t3) } 
        $IsBox(bx, u3) ==> $IsBox(bx, t3))
       && (forall bx: Box :: 
        { $IsBox(bx, u4) } { $IsBox(bx, t4) } 
        $IsBox(bx, u4) ==> $IsBox(bx, t4))
       && (forall bx: Box :: 
        { $IsBox(bx, u5) } { $IsBox(bx, t5) } 
        $IsBox(bx, u5) ==> $IsBox(bx, t5))
       && (forall bx: Box :: 
        { $IsBox(bx, u6) } { $IsBox(bx, t6) } 
        $IsBox(bx, u6) ==> $IsBox(bx, t6))
       && (forall bx: Box :: 
        { $IsBox(bx, u7) } { $IsBox(bx, t7) } 
        $IsBox(bx, u7) ==> $IsBox(bx, t7))
       && (forall bx: Box :: 
        { $IsBox(bx, u8) } { $IsBox(bx, t8) } 
        $IsBox(bx, u8) ==> $IsBox(bx, t8))
       && (forall bx: Box :: 
        { $IsBox(bx, u9) } { $IsBox(bx, t9) } 
        $IsBox(bx, u9) ==> $IsBox(bx, t9))
       && (forall bx: Box :: 
        { $IsBox(bx, t10) } { $IsBox(bx, u10) } 
        $IsBox(bx, t10) ==> $IsBox(bx, u10))
     ==> $Is(f, Tclass._System.___hFunc10(u0, u1, u2, u3, u4, u5, u6, u7, u8, u9, u10)));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h) } 
  $IsGoodHeap(h)
     ==> ($IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h)
       <==> (forall bx0: Box, 
          bx1: Box, 
          bx2: Box, 
          bx3: Box, 
          bx4: Box, 
          bx5: Box, 
          bx6: Box, 
          bx7: Box, 
          bx8: Box, 
          bx9: Box :: 
        { Apply10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9) } 
          { Reads10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9) } 
        $IsBox(bx0, t0)
             && $IsAllocBox(bx0, t0, h)
             && 
            $IsBox(bx1, t1)
             && $IsAllocBox(bx1, t1, h)
             && 
            $IsBox(bx2, t2)
             && $IsAllocBox(bx2, t2, h)
             && 
            $IsBox(bx3, t3)
             && $IsAllocBox(bx3, t3, h)
             && 
            $IsBox(bx4, t4)
             && $IsAllocBox(bx4, t4, h)
             && 
            $IsBox(bx5, t5)
             && $IsAllocBox(bx5, t5, h)
             && 
            $IsBox(bx6, t6)
             && $IsAllocBox(bx6, t6, h)
             && 
            $IsBox(bx7, t7)
             && $IsAllocBox(bx7, t7, h)
             && 
            $IsBox(bx8, t8)
             && $IsAllocBox(bx8, t8, h)
             && 
            $IsBox(bx9, t9)
             && $IsAllocBox(bx9, t9, h)
             && Requires10(t0, 
              t1, 
              t2, 
              t3, 
              t4, 
              t5, 
              t6, 
              t7, 
              t8, 
              t9, 
              t10, 
              h, 
              f, 
              bx0, 
              bx1, 
              bx2, 
              bx3, 
              bx4, 
              bx5, 
              bx6, 
              bx7, 
              bx8, 
              bx9)
           ==> (forall r: ref :: 
            { Reads10(t0, 
                t1, 
                t2, 
                t3, 
                t4, 
                t5, 
                t6, 
                t7, 
                t8, 
                t9, 
                t10, 
                h, 
                f, 
                bx0, 
                bx1, 
                bx2, 
                bx3, 
                bx4, 
                bx5, 
                bx6, 
                bx7, 
                bx8, 
                bx9)[$Box(r)] } 
            r != null
                 && Reads10(t0, 
                  t1, 
                  t2, 
                  t3, 
                  t4, 
                  t5, 
                  t6, 
                  t7, 
                  t8, 
                  t9, 
                  t10, 
                  h, 
                  f, 
                  bx0, 
                  bx1, 
                  bx2, 
                  bx3, 
                  bx4, 
                  bx5, 
                  bx6, 
                  bx7, 
                  bx8, 
                  bx9)[$Box(r)]
               ==> read(h, r, alloc)))));

axiom (forall f: HandleType, 
    t0: Ty, 
    t1: Ty, 
    t2: Ty, 
    t3: Ty, 
    t4: Ty, 
    t5: Ty, 
    t6: Ty, 
    t7: Ty, 
    t8: Ty, 
    t9: Ty, 
    t10: Ty, 
    h: Heap :: 
  { $IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h) } 
  $IsGoodHeap(h)
       && $IsAlloc(f, Tclass._System.___hFunc10(t0, t1, t2, t3, t4, t5, t6, t7, t8, t9, t10), h)
     ==> (forall bx0: Box, 
        bx1: Box, 
        bx2: Box, 
        bx3: Box, 
        bx4: Box, 
        bx5: Box, 
        bx6: Box, 
        bx7: Box, 
        bx8: Box, 
        bx9: Box :: 
      { Apply10(t0, 
          t1, 
          t2, 
          t3, 
          t4, 
          t5, 
          t6, 
          t7, 
          t8, 
          t9, 
          t10, 
          h, 
          f, 
          bx0, 
          bx1, 
          bx2, 
          bx3, 
          bx4, 
          bx5, 
          bx6, 
          bx7, 
          bx8, 
          bx9) } 
      $IsAllocBox(bx0, t0, h)
           && $IsAllocBox(bx1, t1, h)
           && $IsAllocBox(bx2, t2, h)
           && $IsAllocBox(bx3, t3, h)
           && $IsAllocBox(bx4, t4, h)
           && $IsAllocBox(bx5, t5, h)
           && $IsAllocBox(bx6, t6, h)
           && $IsAllocBox(bx7, t7, h)
           && $IsAllocBox(bx8, t8, h)
           && $IsAllocBox(bx9, t9, h)
           && Requires10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9)
         ==> $IsAllocBox(Apply10(t0, 
            t1, 
            t2, 
            t3, 
            t4, 
            t5, 
            t6, 
            t7, 
            t8, 
            t9, 
            t10, 
            h, 
            f, 
            bx0, 
            bx1, 
            bx2, 
            bx3, 
            bx4, 
            bx5, 
            bx6, 
            bx7, 
            bx8, 
            bx9), 
          t10, 
          h)));

function Tclass._System.___hPartialFunc10(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hPartialFunc10 Tag
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tag(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == Tagclass._System.___hPartialFunc10);

const unique Tagclass._System.___hPartialFunc10: TyTag;

// Tclass._System.___hPartialFunc10 injectivity 0
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_0(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T0);

function Tclass._System.___hPartialFunc10_0(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 1
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_1(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T1);

function Tclass._System.___hPartialFunc10_1(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 2
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_2(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T2);

function Tclass._System.___hPartialFunc10_2(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 3
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_3(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T3);

function Tclass._System.___hPartialFunc10_3(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 4
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_4(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T4);

function Tclass._System.___hPartialFunc10_4(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 5
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_5(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T5);

function Tclass._System.___hPartialFunc10_5(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 6
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_6(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T6);

function Tclass._System.___hPartialFunc10_6(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_7(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T7);

function Tclass._System.___hPartialFunc10_7(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 8
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_8(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T8);

function Tclass._System.___hPartialFunc10_8(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 9
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_9(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T9);

function Tclass._System.___hPartialFunc10_9(Ty) : Ty;

// Tclass._System.___hPartialFunc10 injectivity 10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hPartialFunc10_10(Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$R);

function Tclass._System.___hPartialFunc10_10(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hPartialFunc10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)));

// _System._#PartialFunc10: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
       && (forall x0#0: Box, 
          x1#0: Box, 
          x2#0: Box, 
          x3#0: Box, 
          x4#0: Box, 
          x5#0: Box, 
          x6#0: Box, 
          x7#0: Box, 
          x8#0: Box, 
          x9#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
             && $IsBox(x7#0, #$T7)
             && $IsBox(x8#0, #$T8)
             && $IsBox(x9#0, #$T9)
           ==> Set#Equal(Reads10(#$T0, 
              #$T1, 
              #$T2, 
              #$T3, 
              #$T4, 
              #$T5, 
              #$T6, 
              #$T7, 
              #$T8, 
              #$T9, 
              #$R, 
              $OneHeap, 
              f#0, 
              x0#0, 
              x1#0, 
              x2#0, 
              x3#0, 
              x4#0, 
              x5#0, 
              x6#0, 
              x7#0, 
              x8#0, 
              x9#0), 
            Set#Empty(): Set Box)));

// _System._#PartialFunc10: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h));

function Tclass._System.___hTotalFunc10(Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty, Ty) : Ty;

// Tclass._System.___hTotalFunc10 Tag
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tag(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == Tagclass._System.___hTotalFunc10);

const unique Tagclass._System.___hTotalFunc10: TyTag;

// Tclass._System.___hTotalFunc10 injectivity 0
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_0(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T0);

function Tclass._System.___hTotalFunc10_0(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 1
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_1(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T1);

function Tclass._System.___hTotalFunc10_1(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 2
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_2(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T2);

function Tclass._System.___hTotalFunc10_2(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 3
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_3(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T3);

function Tclass._System.___hTotalFunc10_3(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 4
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_4(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T4);

function Tclass._System.___hTotalFunc10_4(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 5
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_5(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T5);

function Tclass._System.___hTotalFunc10_5(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 6
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_6(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T6);

function Tclass._System.___hTotalFunc10_6(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 7
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_7(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T7);

function Tclass._System.___hTotalFunc10_7(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 8
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_8(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T8);

function Tclass._System.___hTotalFunc10_8(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 9
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_9(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$T9);

function Tclass._System.___hTotalFunc10_9(Ty) : Ty;

// Tclass._System.___hTotalFunc10 injectivity 10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty :: 
  { Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R) } 
  Tclass._System.___hTotalFunc10_10(Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     == #$R);

function Tclass._System.___hTotalFunc10_10(Ty) : Ty;

// Box/unbox axiom for Tclass._System.___hTotalFunc10
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    bx: Box :: 
  { $IsBox(bx, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $IsBox(bx, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     ==> $Box($Unbox(bx): HandleType) == bx
       && $Is($Unbox(bx): HandleType, 
        Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)));

// _System._#TotalFunc10: subset type $Is
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType :: 
  { $Is(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R)) } 
  $Is(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
     <==> $Is(f#0, 
        Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R))
       && (forall x0#0: Box, 
          x1#0: Box, 
          x2#0: Box, 
          x3#0: Box, 
          x4#0: Box, 
          x5#0: Box, 
          x6#0: Box, 
          x7#0: Box, 
          x8#0: Box, 
          x9#0: Box :: 
        $IsBox(x0#0, #$T0)
             && $IsBox(x1#0, #$T1)
             && $IsBox(x2#0, #$T2)
             && $IsBox(x3#0, #$T3)
             && $IsBox(x4#0, #$T4)
             && $IsBox(x5#0, #$T5)
             && $IsBox(x6#0, #$T6)
             && $IsBox(x7#0, #$T7)
             && $IsBox(x8#0, #$T8)
             && $IsBox(x9#0, #$T9)
           ==> Requires10(#$T0, 
            #$T1, 
            #$T2, 
            #$T3, 
            #$T4, 
            #$T5, 
            #$T6, 
            #$T7, 
            #$T8, 
            #$T9, 
            #$R, 
            $OneHeap, 
            f#0, 
            x0#0, 
            x1#0, 
            x2#0, 
            x3#0, 
            x4#0, 
            x5#0, 
            x6#0, 
            x7#0, 
            x8#0, 
            x9#0)));

// _System._#TotalFunc10: subset type $IsAlloc
axiom (forall #$T0: Ty, 
    #$T1: Ty, 
    #$T2: Ty, 
    #$T3: Ty, 
    #$T4: Ty, 
    #$T5: Ty, 
    #$T6: Ty, 
    #$T7: Ty, 
    #$T8: Ty, 
    #$T9: Ty, 
    #$R: Ty, 
    f#0: HandleType, 
    $h: Heap :: 
  { $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h) } 
  $IsAlloc(f#0, 
      Tclass._System.___hTotalFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h)
     <==> $IsAlloc(f#0, 
      Tclass._System.___hPartialFunc10(#$T0, #$T1, #$T2, #$T3, #$T4, #$T5, #$T6, #$T7, #$T8, #$T9, #$R), 
      $h));

// Constructor function declaration
function #_System._tuple#0._#Make0() : DatatypeType;

const unique ##_System._tuple#0._#Make0: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#_System._tuple#0._#Make0()) == ##_System._tuple#0._#Make0;

function _System.Tuple0.___hMake0_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d)
     <==> DatatypeCtorId(d) == ##_System._tuple#0._#Make0);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d) } 
  _System.Tuple0.___hMake0_q(d) ==> d == #_System._tuple#0._#Make0());

function Tclass._System.Tuple0() : Ty;

// Tclass._System.Tuple0 Tag
axiom Tag(Tclass._System.Tuple0()) == Tagclass._System.Tuple0;

const unique Tagclass._System.Tuple0: TyTag;

// Box/unbox axiom for Tclass._System.Tuple0
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass._System.Tuple0()) } 
  $IsBox(bx, Tclass._System.Tuple0())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass._System.Tuple0()));

// Constructor $Is
axiom $Is(#_System._tuple#0._#Make0(), Tclass._System.Tuple0());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#_System._tuple#0._#Make0(), Tclass._System.Tuple0(), $h));

// Constructor literal
axiom #_System._tuple#0._#Make0() == Lit(#_System._tuple#0._#Make0());

// Depth-one case-split function
function $IsA#_System.Tuple0(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#_System.Tuple0(d) } 
  $IsA#_System.Tuple0(d) ==> _System.Tuple0.___hMake0_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { _System.Tuple0.___hMake0_q(d), $Is(d, Tclass._System.Tuple0()) } 
  $Is(d, Tclass._System.Tuple0()) ==> _System.Tuple0.___hMake0_q(d));

// Datatype extensional equality declaration
function _System.Tuple0#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #_System._tuple#0._#Make0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  true ==> (_System.Tuple0#Equal(a, b) <==> true));

// Datatype extensionality axiom: _System._tuple#0
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { _System.Tuple0#Equal(a, b) } 
  _System.Tuple0#Equal(a, b) <==> a == b);

const unique class._System.Tuple0: ClassName;

const BaseFuel_Maps._default.MapRemove: LayerType;

const StartFuel_Maps._default.MapRemove: LayerType;

const StartFuelAssert_Maps._default.MapRemove: LayerType;

const BaseFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuel_Maps._default.MapRemoveStrong: LayerType;

const StartFuelAssert_Maps._default.MapRemoveStrong: LayerType;

const BaseFuel_Maps._default.MapRemove1: LayerType;

const StartFuel_Maps._default.MapRemove1: LayerType;

const StartFuelAssert_Maps._default.MapRemove1: LayerType;

const BaseFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuel_Maps._default.MapRemove1Strong: LayerType;

const StartFuelAssert_Maps._default.MapRemove1Strong: LayerType;

const BaseFuel_Maps._default.IMapRemove: LayerType;

const StartFuel_Maps._default.IMapRemove: LayerType;

const StartFuelAssert_Maps._default.IMapRemove: LayerType;

const BaseFuel_Maps._default.IMapRemove1: LayerType;

const StartFuel_Maps._default.IMapRemove1: LayerType;

const StartFuelAssert_Maps._default.IMapRemove1: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuel_Maps._default.MapDisjointUnion: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion: LayerType;

const BaseFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuel_Maps._default.MapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferA: LayerType;

const BaseFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuel_Maps._default.MapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.MapUnionPreferB: LayerType;

const BaseFuel_Maps._default.MapUnion: LayerType;

const StartFuel_Maps._default.MapUnion: LayerType;

const StartFuelAssert_Maps._default.MapUnion: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuel_Maps._default.IMapUnionPreferA: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferA: LayerType;

const BaseFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuel_Maps._default.IMapUnionPreferB: LayerType;

const StartFuelAssert_Maps._default.IMapUnionPreferB: LayerType;

const BaseFuel_Maps._default.IMapUnion: LayerType;

const StartFuel_Maps._default.IMapUnion: LayerType;

const StartFuelAssert_Maps._default.IMapUnion: LayerType;

const BaseFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuel_Maps._default.MapDisjointUnion3: LayerType;

const StartFuelAssert_Maps._default.MapDisjointUnion3: LayerType;

const BaseFuel_Sequences._default.NoDupes: LayerType;

const StartFuel_Sequences._default.NoDupes: LayerType;

const StartFuelAssert_Sequences._default.NoDupes: LayerType;

const BaseFuel_Sequences._default.Range: LayerType;

const StartFuel_Sequences._default.Range: LayerType;

const StartFuelAssert_Sequences._default.Range: LayerType;

const BaseFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuel_Sequences._default.ApplyOpaque: LayerType;

const StartFuelAssert_Sequences._default.ApplyOpaque: LayerType;

const BaseFuel_Sequences._default.remove: LayerType;

const StartFuel_Sequences._default.remove: LayerType;

const StartFuelAssert_Sequences._default.remove: LayerType;

const BaseFuel_Sequences._default.insert: LayerType;

const StartFuel_Sequences._default.insert: LayerType;

const StartFuelAssert_Sequences._default.insert: LayerType;

const BaseFuel_Sequences._default.replace1with2: LayerType;

const StartFuel_Sequences._default.replace1with2: LayerType;

const StartFuelAssert_Sequences._default.replace1with2: LayerType;

const BaseFuel_Sequences._default.replace2with1: LayerType;

const StartFuel_Sequences._default.replace2with1: LayerType;

const StartFuelAssert_Sequences._default.replace2with1: LayerType;

const BaseFuel_Sequences._default.concat: LayerType;

const StartFuel_Sequences._default.concat: LayerType;

const StartFuelAssert_Sequences._default.concat: LayerType;

const BaseFuel_Sequences._default.concat3: LayerType;

const StartFuel_Sequences._default.concat3: LayerType;

const StartFuelAssert_Sequences._default.concat3: LayerType;

const BaseFuel_Sequences._default.concatSeq: LayerType;

const StartFuel_Sequences._default.concatSeq: LayerType;

const StartFuelAssert_Sequences._default.concatSeq: LayerType;

const BaseFuel_Sequences._default.IsPrefix: LayerType;

const StartFuel_Sequences._default.IsPrefix: LayerType;

const StartFuelAssert_Sequences._default.IsPrefix: LayerType;

const BaseFuel_Sequences._default.IsSuffix: LayerType;

const StartFuel_Sequences._default.IsSuffix: LayerType;

const StartFuelAssert_Sequences._default.IsSuffix: LayerType;

const BaseFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuel_Sequences._default.SeqIndexIterate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexIterate: LayerType;

const BaseFuel_Sequences._default.SeqIndex: LayerType;

const StartFuel_Sequences._default.SeqIndex: LayerType;

const StartFuelAssert_Sequences._default.SeqIndex: LayerType;

const BaseFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuel_Sequences._default.SeqOfLength: LayerType;

const StartFuelAssert_Sequences._default.SeqOfLength: LayerType;

const BaseFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuel_Sequences._default.SeqIndexUpdate: LayerType;

const StartFuelAssert_Sequences._default.SeqIndexUpdate: LayerType;

const BaseFuel_Sequences._default.Zip: LayerType;

const StartFuel_Sequences._default.Zip: LayerType;

const StartFuelAssert_Sequences._default.Zip: LayerType;

const BaseFuel_Sequences._default.Unzip: LayerType;

const StartFuel_Sequences._default.Unzip: LayerType;

const StartFuelAssert_Sequences._default.Unzip: LayerType;

const BaseFuel_Sequences._default.FlattenShape: LayerType;

const StartFuel_Sequences._default.FlattenShape: LayerType;

const StartFuelAssert_Sequences._default.FlattenShape: LayerType;

const BaseFuel_Sequences._default.FlattenLength: LayerType;

const StartFuel_Sequences._default.FlattenLength: LayerType;

const StartFuelAssert_Sequences._default.FlattenLength: LayerType;

const BaseFuel_Sequences._default.Flatten: LayerType;

const StartFuel_Sequences._default.Flatten: LayerType;

const StartFuelAssert_Sequences._default.Flatten: LayerType;

const BaseFuel_Sequences._default.fill: LayerType;

const StartFuel_Sequences._default.fill: LayerType;

const StartFuelAssert_Sequences._default.fill: LayerType;

const BaseFuel_SeqComparison._default.lte: LayerType;

const StartFuel_SeqComparison._default.lte: LayerType;

const StartFuelAssert_SeqComparison._default.lte: LayerType;

const BaseFuel_Byte_Order._default.lte: LayerType;

const StartFuel_Byte_Order._default.lte: LayerType;

const StartFuelAssert_Byte_Order._default.lte: LayerType;

const BaseFuel_Byte_Order._default.ltedef: LayerType;

const StartFuel_Byte_Order._default.ltedef: LayerType;

const StartFuelAssert_Byte_Order._default.ltedef: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Byte_Order._default.minimum: LayerType;

const StartFuel_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Byte_Order._default.minimum: LayerType;

const BaseFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Byte_Order._default.maximum: LayerType;

const StartFuel_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Byte_Order._default.maximum: LayerType;

const BaseFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximum: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximum: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted: LayerType;

const BaseFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_PivotsLib._default.CutoffForLeft: LayerType;

const StartFuel_PivotsLib._default.CutoffForLeft: LayerType;

const StartFuelAssert_PivotsLib._default.CutoffForLeft: LayerType;

const BaseFuel_PivotsLib._default.CutoffForRight: LayerType;

const StartFuel_PivotsLib._default.CutoffForRight: LayerType;

const StartFuelAssert_PivotsLib._default.CutoffForRight: LayerType;

const BaseFuel_Multisets._default.Choose: LayerType;

const StartFuel_Multisets._default.Choose: LayerType;

const StartFuelAssert_Multisets._default.Choose: LayerType;

const BaseFuel_Multisets._default.Apply: LayerType;

const StartFuel_Multisets._default.Apply: LayerType;

const StartFuelAssert_Multisets._default.Apply: LayerType;

const BaseFuel_Multisets._default.Fold: LayerType;

const StartFuel_Multisets._default.Fold: LayerType;

const StartFuelAssert_Multisets._default.Fold: LayerType;

const BaseFuel_Multisets._default.IsIdentity: LayerType;

const StartFuel_Multisets._default.IsIdentity: LayerType;

const StartFuelAssert_Multisets._default.IsIdentity: LayerType;

const BaseFuel_Multisets._default.IsCommutative: LayerType;

const StartFuel_Multisets._default.IsCommutative: LayerType;

const StartFuelAssert_Multisets._default.IsCommutative: LayerType;

const BaseFuel_Multisets._default.IsAssociative: LayerType;

const StartFuel_Multisets._default.IsAssociative: LayerType;

const StartFuelAssert_Multisets._default.IsAssociative: LayerType;

const BaseFuel_BucketsLib._default.BucketMapOfSeq: LayerType;

const StartFuel_BucketsLib._default.BucketMapOfSeq: LayerType;

const StartFuelAssert_BucketsLib._default.BucketMapOfSeq: LayerType;

const BaseFuel_BucketsLib._default.B: LayerType;

const StartFuel_BucketsLib._default.B: LayerType;

const StartFuelAssert_BucketsLib._default.B: LayerType;

const BaseFuel_BucketsLib._default.BucketIntersect: LayerType;

const StartFuel_BucketsLib._default.BucketIntersect: LayerType;

const StartFuelAssert_BucketsLib._default.BucketIntersect: LayerType;

const BaseFuel_BucketsLib._default.BucketComplement: LayerType;

const StartFuel_BucketsLib._default.BucketComplement: LayerType;

const StartFuelAssert_BucketsLib._default.BucketComplement: LayerType;

const BaseFuel_BucketsLib._default.Compose: LayerType;

const StartFuel_BucketsLib._default.Compose: LayerType;

const StartFuelAssert_BucketsLib._default.Compose: LayerType;

const BaseFuel_BucketsLib._default.ComposeSeq: LayerType;

const StartFuel_BucketsLib._default.ComposeSeq: LayerType;

const StartFuelAssert_BucketsLib._default.ComposeSeq: LayerType;

const BaseFuel_BucketsLib._default.ClampRange: LayerType;

const StartFuel_BucketsLib._default.ClampRange: LayerType;

const StartFuelAssert_BucketsLib._default.ClampRange: LayerType;

const BaseFuel_BucketsLib._default.ClampStart: LayerType;

const StartFuel_BucketsLib._default.ClampStart: LayerType;

const StartFuelAssert_BucketsLib._default.ClampStart: LayerType;

const BaseFuel_BucketsLib._default.ClampEnd: LayerType;

const StartFuel_BucketsLib._default.ClampEnd: LayerType;

const StartFuelAssert_BucketsLib._default.ClampEnd: LayerType;

const BaseFuel_BucketsLib._default.KeyValueMapOfBucket: LayerType;

const StartFuel_BucketsLib._default.KeyValueMapOfBucket: LayerType;

const StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket: LayerType;

const BaseFuel_BucketsLib._default.SortedSeqOfKeyValueMap: LayerType;

const StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap: LayerType;

const StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap: LayerType;

const BaseFuel_BucketsLib._default.SplitBucketLeft: LayerType;

const StartFuel_BucketsLib._default.SplitBucketLeft: LayerType;

const StartFuelAssert_BucketsLib._default.SplitBucketLeft: LayerType;

const BaseFuel_BucketsLib._default.SplitBucketRight: LayerType;

const StartFuel_BucketsLib._default.SplitBucketRight: LayerType;

const StartFuelAssert_BucketsLib._default.SplitBucketRight: LayerType;

const BaseFuel_BucketsLib._default.SplitBucketInList: LayerType;

const StartFuel_BucketsLib._default.SplitBucketInList: LayerType;

const StartFuelAssert_BucketsLib._default.SplitBucketInList: LayerType;

const BaseFuel_BucketsLib._default.MergeBuckets: LayerType;

const StartFuel_BucketsLib._default.MergeBuckets: LayerType;

const StartFuelAssert_BucketsLib._default.MergeBuckets: LayerType;

const BaseFuel_BucketsLib._default.MergeBucketsInList: LayerType;

const StartFuel_BucketsLib._default.MergeBucketsInList: LayerType;

const StartFuelAssert_BucketsLib._default.MergeBucketsInList: LayerType;

const BaseFuel_BucketWeights._default.WeightKeyMultiset: LayerType;

const StartFuel_BucketWeights._default.WeightKeyMultiset: LayerType;

const StartFuelAssert_BucketWeights._default.WeightKeyMultiset: LayerType;

const BaseFuel_BucketWeights._default.WeightKeySeq: LayerType;

const StartFuel_BucketWeights._default.WeightKeySeq: LayerType;

const StartFuelAssert_BucketWeights._default.WeightKeySeq: LayerType;

const BaseFuel_BucketWeights._default.WeightMessageMultiset: LayerType;

const StartFuel_BucketWeights._default.WeightMessageMultiset: LayerType;

const StartFuelAssert_BucketWeights._default.WeightMessageMultiset: LayerType;

const BaseFuel_BucketWeights._default.WeightMessageSeq: LayerType;

const StartFuel_BucketWeights._default.WeightMessageSeq: LayerType;

const StartFuelAssert_BucketWeights._default.WeightMessageSeq: LayerType;

const BaseFuel_BucketWeights._default.WeightBucketList: LayerType;

const StartFuel_BucketWeights._default.WeightBucketList: LayerType;

const StartFuelAssert_BucketWeights._default.WeightBucketList: LayerType;

const BaseFuel_BucketWeights._default.Image: LayerType;

const StartFuel_BucketWeights._default.Image: LayerType;

const StartFuelAssert_BucketWeights._default.Image: LayerType;

const BaseFuel_PivotBetreeSpec._default.LookupUpperBound: LayerType;

const StartFuel_PivotBetreeSpec._default.LookupUpperBound: LayerType;

const StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound: LayerType;

const BaseFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft: LayerType;

const StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft: LayerType;

const StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft: LayerType;

const BaseFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight: LayerType;

const StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight: LayerType;

const StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight: LayerType;

const BaseFuel_PivotBetreeSpec._default.CutoffNode: LayerType;

const StartFuel_PivotBetreeSpec._default.CutoffNode: LayerType;

const StartFuelAssert_PivotBetreeSpec._default.CutoffNode: LayerType;

const BaseFuel_DiskLayout._default.ValidNodeAddr: LayerType;

const StartFuel_DiskLayout._default.ValidNodeAddr: LayerType;

const StartFuelAssert_DiskLayout._default.ValidNodeAddr: LayerType;

const BaseFuel_DiskLayout._default.ValidJournalLocation: LayerType;

const StartFuel_DiskLayout._default.ValidJournalLocation: LayerType;

const StartFuelAssert_DiskLayout._default.ValidJournalLocation: LayerType;

const BaseFuel_DiskLayout._default.JournalBlockIdx: LayerType;

const StartFuel_DiskLayout._default.JournalBlockIdx: LayerType;

const StartFuelAssert_DiskLayout._default.JournalBlockIdx: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq: LayerType;

const BaseFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq: LayerType;

const BaseFuel_BlockCache._default.OpTransaction: LayerType;

const StartFuel_BlockCache._default.OpTransaction: LayerType;

const StartFuelAssert_BlockCache._default.OpTransaction: LayerType;

const BaseFuel_LruModel._default.distinct: LayerType;

const StartFuel_LruModel._default.distinct: LayerType;

const StartFuelAssert_LruModel._default.distinct: LayerType;

const BaseFuel_LruModel._default.NextOpt: LayerType;

const StartFuel_LruModel._default.NextOpt: LayerType;

const StartFuelAssert_LruModel._default.NextOpt: LayerType;

const BaseFuel_MutableMapModel._default.lshift: LayerType;

const StartFuel_MutableMapModel._default.lshift: LayerType;

const StartFuelAssert_MutableMapModel._default.lshift: LayerType;

const BaseFuel_MutableMapModel._default.rshift: LayerType;

const StartFuel_MutableMapModel._default.rshift: LayerType;

const StartFuelAssert_MutableMapModel._default.rshift: LayerType;

const BaseFuel_MutableMapModel._default.bitnot: LayerType;

const StartFuel_MutableMapModel._default.bitnot: LayerType;

const StartFuelAssert_MutableMapModel._default.bitnot: LayerType;

const BaseFuel_MutableMapModel._default.bitxor: LayerType;

const StartFuel_MutableMapModel._default.bitxor: LayerType;

const StartFuelAssert_MutableMapModel._default.bitxor: LayerType;

const BaseFuel_MutableMapModel._default.hash64: LayerType;

const StartFuel_MutableMapModel._default.hash64: LayerType;

const StartFuelAssert_MutableMapModel._default.hash64: LayerType;

const BaseFuel_MutableMapModel._default.getEmptyWitness: LayerType;

const StartFuel_MutableMapModel._default.getEmptyWitness: LayerType;

const StartFuelAssert_MutableMapModel._default.getEmptyWitness: LayerType;

const BaseFuel_MutableMapModel._default.Probe: LayerType;

const StartFuel_MutableMapModel._default.Probe: LayerType;

const StartFuelAssert_MutableMapModel._default.Probe: LayerType;

const BaseFuel_MutableMapModel._default.FixedSizeInsert: LayerType;

const StartFuel_MutableMapModel._default.FixedSizeInsert: LayerType;

const StartFuelAssert_MutableMapModel._default.FixedSizeInsert: LayerType;

const BaseFuel_MutableMapModel._default.FixedSizeGet: LayerType;

const StartFuel_MutableMapModel._default.FixedSizeGet: LayerType;

const StartFuelAssert_MutableMapModel._default.FixedSizeGet: LayerType;

const BaseFuel_MutableMapModel._default.FixedSizeRemove: LayerType;

const StartFuel_MutableMapModel._default.FixedSizeRemove: LayerType;

const StartFuelAssert_MutableMapModel._default.FixedSizeRemove: LayerType;

const BaseFuel_MutableMapModel._default.Constructor: LayerType;

const StartFuel_MutableMapModel._default.Constructor: LayerType;

const StartFuelAssert_MutableMapModel._default.Constructor: LayerType;

const BaseFuel_MutableMapModel._default.ReallocInternal: LayerType;

const StartFuel_MutableMapModel._default.ReallocInternal: LayerType;

const StartFuelAssert_MutableMapModel._default.ReallocInternal: LayerType;

const BaseFuel_MutableMapModel._default.InsertAndGetOld: LayerType;

const StartFuel_MutableMapModel._default.InsertAndGetOld: LayerType;

const StartFuelAssert_MutableMapModel._default.InsertAndGetOld: LayerType;

const BaseFuel_MutableMapModel._default.Insert: LayerType;

const StartFuel_MutableMapModel._default.Insert: LayerType;

const StartFuelAssert_MutableMapModel._default.Insert: LayerType;

const BaseFuel_MutableMapModel._default.IterStart: LayerType;

const StartFuel_MutableMapModel._default.IterStart: LayerType;

const StartFuelAssert_MutableMapModel._default.IterStart: LayerType;

const BaseFuel_MutableMapModel._default.SimpleIterStart: LayerType;

const StartFuel_MutableMapModel._default.SimpleIterStart: LayerType;

const StartFuelAssert_MutableMapModel._default.SimpleIterStart: LayerType;

const BaseFuel_MutableMapModel._default.IterInc: LayerType;

const StartFuel_MutableMapModel._default.IterInc: LayerType;

const StartFuelAssert_MutableMapModel._default.IterInc: LayerType;

const BaseFuel_MutableMapModel._default.SimpleIterInc: LayerType;

const StartFuel_MutableMapModel._default.SimpleIterInc: LayerType;

const StartFuelAssert_MutableMapModel._default.SimpleIterInc: LayerType;

const BaseFuel_MutableMapModel._default.MaxKey: LayerType;

const StartFuel_MutableMapModel._default.MaxKey: LayerType;

const StartFuelAssert_MutableMapModel._default.MaxKey: LayerType;

const BaseFuel_MutableMapModel._default.UpdateByIter: LayerType;

const StartFuel_MutableMapModel._default.UpdateByIter: LayerType;

const StartFuelAssert_MutableMapModel._default.UpdateByIter: LayerType;

const BaseFuel_MutableMapModel._default.FindSimpleIter: LayerType;

const StartFuel_MutableMapModel._default.FindSimpleIter: LayerType;

const StartFuelAssert_MutableMapModel._default.FindSimpleIter: LayerType;

const BaseFuel_GenericMarshalling._default.ValInGrammar: LayerType;

const StartFuel_GenericMarshalling._default.ValInGrammar: LayerType;

const StartFuelAssert_GenericMarshalling._default.ValInGrammar: LayerType;

const BaseFuel_GenericMarshalling._default.ValidVal: LayerType;

const StartFuel_GenericMarshalling._default.ValidVal: LayerType;

const StartFuelAssert_GenericMarshalling._default.ValidVal: LayerType;

const BaseFuel_GenericMarshalling._default.SeqSum: LayerType;

const StartFuel_GenericMarshalling._default.SeqSum: LayerType;

const StartFuelAssert_GenericMarshalling._default.SeqSum: LayerType;

const BaseFuel_GenericMarshalling._default.SizeOfV: LayerType;

const StartFuel_GenericMarshalling._default.SizeOfV: LayerType;

const StartFuelAssert_GenericMarshalling._default.SizeOfV: LayerType;

const BaseFuel_BitsetLemmas._default.bit: LayerType;

const StartFuel_BitsetLemmas._default.bit: LayerType;

const StartFuelAssert_BitsetLemmas._default.bit: LayerType;

const BaseFuel_BitsetLemmas._default.bit_and: LayerType;

const StartFuel_BitsetLemmas._default.bit_and: LayerType;

const StartFuelAssert_BitsetLemmas._default.bit_and: LayerType;

const BaseFuel_BitsetLemmas._default.bit_or: LayerType;

const StartFuel_BitsetLemmas._default.bit_or: LayerType;

const StartFuelAssert_BitsetLemmas._default.bit_or: LayerType;

const BaseFuel_BitsetLemmas._default.bit_comp: LayerType;

const StartFuel_BitsetLemmas._default.bit_comp: LayerType;

const StartFuelAssert_BitsetLemmas._default.bit_comp: LayerType;

const BaseFuel_BitsetLemmas._default.in_set: LayerType;

const StartFuel_BitsetLemmas._default.in_set: LayerType;

const StartFuelAssert_BitsetLemmas._default.in_set: LayerType;

const BaseFuel_BitsetLemmas._default.set_bit_to_1: LayerType;

const StartFuel_BitsetLemmas._default.set_bit_to_1: LayerType;

const StartFuelAssert_BitsetLemmas._default.set_bit_to_1: LayerType;

const BaseFuel_BitsetLemmas._default.set_bit_to_0: LayerType;

const StartFuel_BitsetLemmas._default.set_bit_to_0: LayerType;

const StartFuelAssert_BitsetLemmas._default.set_bit_to_0: LayerType;

const BaseFuel_BitsetLemmas._default.bit_or_uint64: LayerType;

const StartFuel_BitsetLemmas._default.bit_or_uint64: LayerType;

const StartFuelAssert_BitsetLemmas._default.bit_or_uint64: LayerType;

const BaseFuel_BitsetLemmas._default.in_set_uint64: LayerType;

const StartFuel_BitsetLemmas._default.in_set_uint64: LayerType;

const StartFuelAssert_BitsetLemmas._default.in_set_uint64: LayerType;

const BaseFuel_BitsetLemmas._default.set_bit_to_1_uint64: LayerType;

const StartFuel_BitsetLemmas._default.set_bit_to_1_uint64: LayerType;

const StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64: LayerType;

const BaseFuel_BitsetLemmas._default.set_bit_to_0_uint64: LayerType;

const StartFuel_BitsetLemmas._default.set_bit_to_0_uint64: LayerType;

const StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64: LayerType;

const BaseFuel_BitmapModel._default.BitSet: LayerType;

const StartFuel_BitmapModel._default.BitSet: LayerType;

const StartFuelAssert_BitmapModel._default.BitSet: LayerType;

const BaseFuel_BitmapModel._default.BitUnset: LayerType;

const StartFuel_BitmapModel._default.BitUnset: LayerType;

const StartFuelAssert_BitmapModel._default.BitUnset: LayerType;

const BaseFuel_BitmapModel._default.IsSet: LayerType;

const StartFuel_BitmapModel._default.IsSet: LayerType;

const StartFuelAssert_BitmapModel._default.IsSet: LayerType;

const BaseFuel_BitmapModel._default.EmptyBitmap: LayerType;

const StartFuel_BitmapModel._default.EmptyBitmap: LayerType;

const StartFuelAssert_BitmapModel._default.EmptyBitmap: LayerType;

const BaseFuel_BitmapModel._default.BitAlloc: LayerType;

const StartFuel_BitmapModel._default.BitAlloc: LayerType;

const StartFuelAssert_BitmapModel._default.BitAlloc: LayerType;

const BaseFuel_BitmapModel._default.BitUnion: LayerType;

const StartFuel_BitmapModel._default.BitUnion: LayerType;

const StartFuelAssert_BitmapModel._default.BitUnion: LayerType;

const BaseFuel_BitmapImpl.Bitmap.IPrefix: LayerType;

const StartFuel_BitmapImpl.Bitmap.IPrefix: LayerType;

const StartFuelAssert_BitmapImpl.Bitmap.IPrefix: LayerType;

const BaseFuel_JournalIntervals._default.JournalUpdate: LayerType;

const StartFuel_JournalIntervals._default.JournalUpdate: LayerType;

const StartFuelAssert_JournalIntervals._default.JournalUpdate: LayerType;

const BaseFuel_JournalIntervals._default.CyclicSlice: LayerType;

const StartFuel_JournalIntervals._default.CyclicSlice: LayerType;

const StartFuelAssert_JournalIntervals._default.CyclicSlice: LayerType;

const BaseFuel_Uint32_Order._default.ltedef: LayerType;

const StartFuel_Uint32_Order._default.ltedef: LayerType;

const StartFuelAssert_Uint32_Order._default.ltedef: LayerType;

const BaseFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Uint32_Order._default.NotMinimum: LayerType;

const StartFuel_Uint32_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Uint32_Order._default.NotMinimum: LayerType;

const BaseFuel_Uint32_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Uint32_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Uint32_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Uint32_Order._default.minimum: LayerType;

const StartFuel_Uint32_Order._default.minimum: LayerType;

const StartFuelAssert_Uint32_Order._default.minimum: LayerType;

const BaseFuel_Uint32_Order._default.minimumOpt: LayerType;

const StartFuel_Uint32_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Uint32_Order._default.minimumOpt: LayerType;

const BaseFuel_Uint32_Order._default.maximum: LayerType;

const StartFuel_Uint32_Order._default.maximum: LayerType;

const StartFuelAssert_Uint32_Order._default.maximum: LayerType;

const BaseFuel_Uint32_Order._default.maximumOpt: LayerType;

const StartFuel_Uint32_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Uint32_Order._default.maximumOpt: LayerType;

const BaseFuel_Uint32_Order._default.IsSorted: LayerType;

const StartFuel_Uint32_Order._default.IsSorted: LayerType;

const StartFuelAssert_Uint32_Order._default.IsSorted: LayerType;

const BaseFuel_Uint32_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Uint32_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Uint32_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_PackedStringArray._default.psaSeq: LayerType;

const StartFuel_PackedStringArray._default.psaSeq: LayerType;

const StartFuelAssert_PackedStringArray._default.psaSeq: LayerType;

const BaseFuel_Integer_Order._default.ltedef: LayerType;

const StartFuel_Integer_Order._default.ltedef: LayerType;

const StartFuelAssert_Integer_Order._default.ltedef: LayerType;

const BaseFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte: LayerType;

const BaseFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt: LayerType;

const BaseFuel_Integer_Order._default.NotMinimum: LayerType;

const StartFuel_Integer_Order._default.NotMinimum: LayerType;

const StartFuelAssert_Integer_Order._default.NotMinimum: LayerType;

const BaseFuel_Integer_Order._default.SortedSeqForMap: LayerType;

const StartFuel_Integer_Order._default.SortedSeqForMap: LayerType;

const StartFuelAssert_Integer_Order._default.SortedSeqForMap: LayerType;

const BaseFuel_Integer_Order._default.minimum: LayerType;

const StartFuel_Integer_Order._default.minimum: LayerType;

const StartFuelAssert_Integer_Order._default.minimum: LayerType;

const BaseFuel_Integer_Order._default.minimumOpt: LayerType;

const StartFuel_Integer_Order._default.minimumOpt: LayerType;

const StartFuelAssert_Integer_Order._default.minimumOpt: LayerType;

const BaseFuel_Integer_Order._default.maximum: LayerType;

const StartFuel_Integer_Order._default.maximum: LayerType;

const StartFuelAssert_Integer_Order._default.maximum: LayerType;

const BaseFuel_Integer_Order._default.maximumOpt: LayerType;

const StartFuel_Integer_Order._default.maximumOpt: LayerType;

const StartFuelAssert_Integer_Order._default.maximumOpt: LayerType;

const BaseFuel_Integer_Order._default.IsSorted: LayerType;

const StartFuel_Integer_Order._default.IsSorted: LayerType;

const StartFuelAssert_Integer_Order._default.IsSorted: LayerType;

const BaseFuel_Integer_Order._default.IsStrictlySorted: LayerType;

const StartFuel_Integer_Order._default.IsStrictlySorted: LayerType;

const StartFuelAssert_Integer_Order._default.IsStrictlySorted: LayerType;

const BaseFuel_PackedKV._default.psaSeq_Messages: LayerType;

const StartFuel_PackedKV._default.psaSeq_Messages: LayerType;

const StartFuelAssert_PackedKV._default.psaSeq_Messages: LayerType;

const BaseFuel_Marshalling._default.isStrictlySortedKeySeq: LayerType;

const StartFuel_Marshalling._default.isStrictlySortedKeySeq: LayerType;

const StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq: LayerType;

const BaseFuel_Marshalling._default.valToIndirectionTableMaps: LayerType;

const StartFuel_Marshalling._default.valToIndirectionTableMaps: LayerType;

const StartFuelAssert_Marshalling._default.valToIndirectionTableMaps: LayerType;

const BaseFuel_Marshalling._default.parseSector: LayerType;

const StartFuel_Marshalling._default.parseSector: LayerType;

const StartFuelAssert_Marshalling._default.parseSector: LayerType;

const BaseFuel_Marshalling._default.parseCheckedSector: LayerType;

const StartFuel_Marshalling._default.parseCheckedSector: LayerType;

const StartFuelAssert_Marshalling._default.parseCheckedSector: LayerType;

const BaseFuel_IndirectionTableModel._default.GetEntry: LayerType;

const StartFuel_IndirectionTableModel._default.GetEntry: LayerType;

const StartFuelAssert_IndirectionTableModel._default.GetEntry: LayerType;

const BaseFuel_IndirectionTableModel._default.HasEmptyLoc: LayerType;

const StartFuel_IndirectionTableModel._default.HasEmptyLoc: LayerType;

const StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc: LayerType;

const BaseFuel_IndirectionTableModel._default.AddLocIfPresent: LayerType;

const StartFuel_IndirectionTableModel._default.AddLocIfPresent: LayerType;

const StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent: LayerType;

const BaseFuel_IndirectionTableModel._default.RefcountUpdateInv: LayerType;

const StartFuel_IndirectionTableModel._default.RefcountUpdateInv: LayerType;

const StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv: LayerType;

const BaseFuel_IndirectionTableModel._default.UpdateAndRemoveLoc: LayerType;

const StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc: LayerType;

const StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc: LayerType;

const BaseFuel_IndirectionTableModel._default.RemoveLoc: LayerType;

const StartFuel_IndirectionTableModel._default.RemoveLoc: LayerType;

const StartFuelAssert_IndirectionTableModel._default.RemoveLoc: LayerType;

const BaseFuel_IndirectionTableModel._default.makeGarbageQueue: LayerType;

const StartFuel_IndirectionTableModel._default.makeGarbageQueue: LayerType;

const StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue: LayerType;

const BaseFuel_IndirectionTableModel._default.BitmapInitUpTo: LayerType;

const StartFuel_IndirectionTableModel._default.BitmapInitUpTo: LayerType;

const StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo: LayerType;

const BaseFuel_IndirectionTableModel._default.InitLocBitmap: LayerType;

const StartFuel_IndirectionTableModel._default.InitLocBitmap: LayerType;

const StartFuelAssert_IndirectionTableModel._default.InitLocBitmap: LayerType;

const BaseFuel_IndirectionTableModel._default.FindDeallocable: LayerType;

const StartFuel_IndirectionTableModel._default.FindDeallocable: LayerType;

const StartFuelAssert_IndirectionTableModel._default.FindDeallocable: LayerType;

const BaseFuel_IndirectionTableModel._default.RemoveRef: LayerType;

const StartFuel_IndirectionTableModel._default.RemoveRef: LayerType;

const StartFuelAssert_IndirectionTableModel._default.RemoveRef: LayerType;

const BaseFuel_IndirectionTableModel._default.clone: LayerType;

const StartFuel_IndirectionTableModel._default.clone: LayerType;

const StartFuelAssert_IndirectionTableModel._default.clone: LayerType;

const BaseFuel_IndirectionTableModel._default.FindRefWithNoLoc: LayerType;

const StartFuel_IndirectionTableModel._default.FindRefWithNoLoc: LayerType;

const StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc: LayerType;

const BaseFuel_IndirectionTableModel._default.ConstructorRootOnly: LayerType;

const StartFuel_IndirectionTableModel._default.ConstructorRootOnly: LayerType;

const StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly: LayerType;

const BaseFuel_IndirectionTableModel._default.getRefUpperBound: LayerType;

const StartFuel_IndirectionTableModel._default.getRefUpperBound: LayerType;

const StartFuelAssert_IndirectionTableModel._default.getRefUpperBound: LayerType;

const unique class.IndirectionTableImpl.IndirectionTable?: ClassName;

function Tclass.IndirectionTableImpl.IndirectionTable?() : Ty;

// Tclass.IndirectionTableImpl.IndirectionTable? Tag
axiom Tag(Tclass.IndirectionTableImpl.IndirectionTable?())
   == Tagclass.IndirectionTableImpl.IndirectionTable?;

const unique Tagclass.IndirectionTableImpl.IndirectionTable?: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableImpl.IndirectionTable?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableImpl.IndirectionTable?()) } 
  $IsBox(bx, Tclass.IndirectionTableImpl.IndirectionTable?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.IndirectionTableImpl.IndirectionTable?()));

// IndirectionTable: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.IndirectionTableImpl.IndirectionTable?()) } 
  $Is($o, Tclass.IndirectionTableImpl.IndirectionTable?())
     <==> $o == null || dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?());

// IndirectionTable: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.IndirectionTableImpl.IndirectionTable?(), $h) } 
  $IsAlloc($o, Tclass.IndirectionTableImpl.IndirectionTable?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(IndirectionTableImpl.IndirectionTable.t) == 0
   && FieldOfDecl(class.IndirectionTableImpl.IndirectionTable?, field$t)
     == IndirectionTableImpl.IndirectionTable.t
   && !$IsGhostField(IndirectionTableImpl.IndirectionTable.t);

const IndirectionTableImpl.IndirectionTable.t: Field ref;

function Tclass.IndirectionTableModel.Entry() : Ty;

// Tclass.IndirectionTableModel.Entry Tag
axiom Tag(Tclass.IndirectionTableModel.Entry())
   == Tagclass.IndirectionTableModel.Entry;

const unique Tagclass.IndirectionTableModel.Entry: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableModel.Entry
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableModel.Entry()) } 
  $IsBox(bx, Tclass.IndirectionTableModel.Entry())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.IndirectionTableModel.Entry()));

function Tclass.MutableMap.ResizingHashMap(Ty) : Ty;

// Tclass.MutableMap.ResizingHashMap Tag
axiom (forall MutableMap.ResizingHashMap$V: Ty :: 
  { Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V) } 
  Tag(Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
     == Tagclass.MutableMap.ResizingHashMap);

const unique Tagclass.MutableMap.ResizingHashMap: TyTag;

// Tclass.MutableMap.ResizingHashMap injectivity 0
axiom (forall MutableMap.ResizingHashMap$V: Ty :: 
  { Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V) } 
  Tclass.MutableMap.ResizingHashMap_0(Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
     == MutableMap.ResizingHashMap$V);

function Tclass.MutableMap.ResizingHashMap_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMap.ResizingHashMap
axiom (forall MutableMap.ResizingHashMap$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V)) } 
  $IsBox(bx, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V)));

// IndirectionTable.t: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.t) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
     ==> $Is(read($h, $o, IndirectionTableImpl.IndirectionTable.t), 
      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())));

// IndirectionTable.t: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.t) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, IndirectionTableImpl.IndirectionTable.t), 
      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
      $h));

axiom FDim(IndirectionTableImpl.IndirectionTable.garbageQueue) == 0
   && FieldOfDecl(class.IndirectionTableImpl.IndirectionTable?, field$garbageQueue)
     == IndirectionTableImpl.IndirectionTable.garbageQueue
   && !$IsGhostField(IndirectionTableImpl.IndirectionTable.garbageQueue);

const IndirectionTableImpl.IndirectionTable.garbageQueue: Field ref;

function Tclass.LruImpl.LruImplQueue?() : Ty;

// Tclass.LruImpl.LruImplQueue? Tag
axiom Tag(Tclass.LruImpl.LruImplQueue?()) == Tagclass.LruImpl.LruImplQueue?;

const unique Tagclass.LruImpl.LruImplQueue?: TyTag;

// Box/unbox axiom for Tclass.LruImpl.LruImplQueue?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.LruImpl.LruImplQueue?()) } 
  $IsBox(bx, Tclass.LruImpl.LruImplQueue?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.LruImpl.LruImplQueue?()));

// IndirectionTable.garbageQueue: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.garbageQueue) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
     ==> $Is(read($h, $o, IndirectionTableImpl.IndirectionTable.garbageQueue), 
      Tclass.LruImpl.LruImplQueue?()));

// IndirectionTable.garbageQueue: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.garbageQueue) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, IndirectionTableImpl.IndirectionTable.garbageQueue), 
      Tclass.LruImpl.LruImplQueue?(), 
      $h));

axiom FDim(IndirectionTableImpl.IndirectionTable.refUpperBound) == 0
   && FieldOfDecl(class.IndirectionTableImpl.IndirectionTable?, field$refUpperBound)
     == IndirectionTableImpl.IndirectionTable.refUpperBound
   && !$IsGhostField(IndirectionTableImpl.IndirectionTable.refUpperBound);

const IndirectionTableImpl.IndirectionTable.refUpperBound: Field int;

function Tclass.NativeTypes.uint64() : Ty;

// Tclass.NativeTypes.uint64 Tag
axiom Tag(Tclass.NativeTypes.uint64()) == Tagclass.NativeTypes.uint64;

const unique Tagclass.NativeTypes.uint64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint64()) } 
  $IsBox(bx, Tclass.NativeTypes.uint64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint64()));

// IndirectionTable.refUpperBound: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.refUpperBound) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
     ==> $Is(read($h, $o, IndirectionTableImpl.IndirectionTable.refUpperBound), 
      Tclass.NativeTypes.uint64()));

// IndirectionTable.refUpperBound: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.refUpperBound) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, IndirectionTableImpl.IndirectionTable.refUpperBound), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(IndirectionTableImpl.IndirectionTable.findLoclessIterator) == 0
   && FieldOfDecl(class.IndirectionTableImpl.IndirectionTable?, field$findLoclessIterator)
     == IndirectionTableImpl.IndirectionTable.findLoclessIterator
   && !$IsGhostField(IndirectionTableImpl.IndirectionTable.findLoclessIterator);

const IndirectionTableImpl.IndirectionTable.findLoclessIterator: Field DatatypeType;

function Tclass.MutableMapModel.SimpleIterator() : Ty;

// Tclass.MutableMapModel.SimpleIterator Tag
axiom Tag(Tclass.MutableMapModel.SimpleIterator())
   == Tagclass.MutableMapModel.SimpleIterator;

const unique Tagclass.MutableMapModel.SimpleIterator: TyTag;

// Box/unbox axiom for Tclass.MutableMapModel.SimpleIterator
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.SimpleIterator()) } 
  $IsBox(bx, Tclass.MutableMapModel.SimpleIterator())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MutableMapModel.SimpleIterator()));

function Tclass.Options.Option(Ty) : Ty;

// Tclass.Options.Option Tag
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tag(Tclass.Options.Option(Options.Option$V)) == Tagclass.Options.Option);

const unique Tagclass.Options.Option: TyTag;

// Tclass.Options.Option injectivity 0
axiom (forall Options.Option$V: Ty :: 
  { Tclass.Options.Option(Options.Option$V) } 
  Tclass.Options.Option_0(Tclass.Options.Option(Options.Option$V))
     == Options.Option$V);

function Tclass.Options.Option_0(Ty) : Ty;

// Box/unbox axiom for Tclass.Options.Option
axiom (forall Options.Option$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.Options.Option(Options.Option$V)) } 
  $IsBox(bx, Tclass.Options.Option(Options.Option$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Options.Option(Options.Option$V)));

// IndirectionTable.findLoclessIterator: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.findLoclessIterator) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
     ==> $Is(read($h, $o, IndirectionTableImpl.IndirectionTable.findLoclessIterator), 
      Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator())));

// IndirectionTable.findLoclessIterator: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.findLoclessIterator) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, IndirectionTableImpl.IndirectionTable.findLoclessIterator), 
      Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()), 
      $h));

axiom FDim(IndirectionTableImpl.IndirectionTable.Repr) == 0
   && FieldOfDecl(class.IndirectionTableImpl.IndirectionTable?, field$Repr)
     == IndirectionTableImpl.IndirectionTable.Repr
   && $IsGhostField(IndirectionTableImpl.IndirectionTable.Repr);

const IndirectionTableImpl.IndirectionTable.Repr: Field (Set Box);

// IndirectionTable.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
     ==> $Is(read($h, $o, IndirectionTableImpl.IndirectionTable.Repr), 
      TSet(Tclass._System.object())));

// IndirectionTable.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, IndirectionTableImpl.IndirectionTable.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.IndirectionTableImpl.IndirectionTable?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, IndirectionTableImpl.IndirectionTable.Repr), 
      TSet(Tclass._System.object()), 
      $h));

function Tclass.IndirectionTableImpl.IndirectionTable() : Ty;

// Tclass.IndirectionTableImpl.IndirectionTable Tag
axiom Tag(Tclass.IndirectionTableImpl.IndirectionTable())
   == Tagclass.IndirectionTableImpl.IndirectionTable;

const unique Tagclass.IndirectionTableImpl.IndirectionTable: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableImpl.IndirectionTable
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableImpl.IndirectionTable()) } 
  $IsBox(bx, Tclass.IndirectionTableImpl.IndirectionTable())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.IndirectionTableImpl.IndirectionTable()));

function Tclass.DebugAccumulator.AccRec() : Ty;

// Tclass.DebugAccumulator.AccRec Tag
axiom Tag(Tclass.DebugAccumulator.AccRec()) == Tagclass.DebugAccumulator.AccRec;

const unique Tagclass.DebugAccumulator.AccRec: TyTag;

// Box/unbox axiom for Tclass.DebugAccumulator.AccRec
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DebugAccumulator.AccRec()) } 
  $IsBox(bx, Tclass.DebugAccumulator.AccRec())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DebugAccumulator.AccRec()));

procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.DebugAccumulate(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableImpl.IndirectionTable.DebugAccumulate(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  // user-defined preconditions
  requires Lit(false);
  modifies $Heap, $Tick;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.DebugAccumulate(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap), 
    $_reverifyPost: bool);
  free requires 5 == $FunctionContextHeight;
  // user-defined preconditions
  requires Lit(false);
  modifies $Heap, $Tick;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



axiom FDim(MutableMap.ResizingHashMap.Count) == 0
   && FieldOfDecl(class.MutableMap.ResizingHashMap?, field$Count)
     == MutableMap.ResizingHashMap.Count
   && !$IsGhostField(MutableMap.ResizingHashMap.Count);

implementation Impl$$IndirectionTableImpl.IndirectionTable.DebugAccumulate(this: ref) returns (acc#0: Seq Box, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#0: ref
     where $Is(a#0, Tclass.DebugAccumulator.AccRec())
       && $IsAlloc(a#0, Tclass.DebugAccumulator.AccRec(), $Heap);
  var $nw: ref;
  var count##0: int;
  var unit##0: Seq Box;
  var $rhs##0: Seq Box
     where $Is($rhs##0, TSeq(Tclass.DebugAccumulator.AccRec()))
       && $IsAlloc($rhs##0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap);
  var acc##0: Seq Box;
  var key##0: Seq Box;
  var rec##0: ref;
  var r#0: Seq Box
     where $Is(r#0, TSeq(Tclass.DebugAccumulator.AccRec()))
       && $IsAlloc(r#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap);
  var $rhs##1: Seq Box
     where $Is($rhs##1, TSeq(Tclass.DebugAccumulator.AccRec()))
       && $IsAlloc($rhs##1, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap);
  var index##0: Seq Box;
  var $rhs##2: Seq Box
     where $Is($rhs##2, TSeq(Tclass.DebugAccumulator.AccRec()))
       && $IsAlloc($rhs##2, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap);
  var acc##1: Seq Box;
  var key##1: Seq Box;
  var rec##1: ref;

    // AddMethodImpl: DebugAccumulate, Impl$$IndirectionTableImpl.IndirectionTable.DebugAccumulate
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(54,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(55,11)
    assume true;
    assume DebugAccumulator.__default.EmptyAccumulator#canCall();
    assume DebugAccumulator.__default.EmptyAccumulator#canCall();
    acc#0 := Lit(DebugAccumulator.__default.EmptyAccumulator());
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(55,48)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(56,13)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(56,16)
    // TrCallStmt: Before ProcessCallStmt
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    count##0 := read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Count);
    assume true;
    // ProcessCallStmt: CheckSubrange
    unit##0 := Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(char#FromInt(73))), $Box(char#FromInt(110))), 
                                                        $Box(char#FromInt(100))), 
                                                      $Box(char#FromInt(105))), 
                                                    $Box(char#FromInt(114))), 
                                                  $Box(char#FromInt(101))), 
                                                $Box(char#FromInt(99))), 
                                              $Box(char#FromInt(116))), 
                                            $Box(char#FromInt(105))), 
                                          $Box(char#FromInt(111))), 
                                        $Box(char#FromInt(110))), 
                                      $Box(char#FromInt(84))), 
                                    $Box(char#FromInt(97))), 
                                  $Box(char#FromInt(98))), 
                                $Box(char#FromInt(108))), 
                              $Box(char#FromInt(101))), 
                            $Box(char#FromInt(77))), 
                          $Box(char#FromInt(111))), 
                        $Box(char#FromInt(100))), 
                      $Box(char#FromInt(101))), 
                    $Box(char#FromInt(108))), 
                  $Box(char#FromInt(46))), 
                $Box(char#FromInt(69))), 
              $Box(char#FromInt(110))), 
            $Box(char#FromInt(116))), 
          $Box(char#FromInt(114))), 
        $Box(char#FromInt(121))));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$DebugAccumulator.AccRec.__ctor(count##0, unit##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(56,82)"} true;
    a#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(56,82)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(57,37)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type DebugAccumulator.DebugAccumulator
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    acc##0 := acc#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(char#FromInt(116))));
    assume true;
    // ProcessCallStmt: CheckSubrange
    rec##0 := a#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$DebugAccumulator.__default.AccPut(acc##0, key##0, rec##0);
    // TrCallStmt: After ProcessCallStmt
    acc#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(57,49)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(58,44)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type DebugAccumulator.DebugAccumulator
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$LruImpl.LruImplQueue.DebugAccumulate(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue));
    // TrCallStmt: After ProcessCallStmt
    r#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(58,45)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(59,9)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(59,40)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    index##0 := r#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$DebugAccumulator.AccRec.Index(index##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(59,47)"} true;
    a#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(59,47)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(60,37)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type DebugAccumulator.DebugAccumulator
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    acc##1 := acc#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##1 := Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(char#FromInt(103))), $Box(char#FromInt(97))), 
                          $Box(char#FromInt(114))), 
                        $Box(char#FromInt(98))), 
                      $Box(char#FromInt(97))), 
                    $Box(char#FromInt(103))), 
                  $Box(char#FromInt(101))), 
                $Box(char#FromInt(81))), 
              $Box(char#FromInt(117))), 
            $Box(char#FromInt(101))), 
          $Box(char#FromInt(117))), 
        $Box(char#FromInt(101))));
    assume true;
    // ProcessCallStmt: CheckSubrange
    rec##1 := a#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##2 := Call$$DebugAccumulator.__default.AccPut(acc##1, key##1, rec##1);
    // TrCallStmt: After ProcessCallStmt
    acc#0 := $rhs##2;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(60,60)"} true;
}



// function declaration for IndirectionTableImpl.IndirectionTable.Inv
function IndirectionTableImpl.IndirectionTable.Inv($heap: Heap, this: ref) : bool;

function IndirectionTableImpl.IndirectionTable.Inv#canCall($heap: Heap, this: ref) : bool;

// frame axiom for IndirectionTableImpl.IndirectionTable.Inv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), IndirectionTableImpl.IndirectionTable.Inv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this
             || read($h0, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> IndirectionTableImpl.IndirectionTable.Inv($h0, this)
       == IndirectionTableImpl.IndirectionTable.Inv($h1, this));

// consequence axiom for IndirectionTableImpl.IndirectionTable.Inv
axiom 7 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { IndirectionTableImpl.IndirectionTable.Inv($Heap, this) } 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         || (7 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
           && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
       ==> 
      IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]);

function IndirectionTableImpl.IndirectionTable.Inv#requires(Heap, ref) : bool;

// #requires axiom for IndirectionTableImpl.IndirectionTable.Inv
axiom (forall $Heap: Heap, this: ref :: 
  { IndirectionTableImpl.IndirectionTable.Inv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
       && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap)
     ==> IndirectionTableImpl.IndirectionTable.Inv#requires($Heap, this) == true);

axiom FDim(MutableMap.ResizingHashMap.Repr) == 0
   && FieldOfDecl(class.MutableMap.ResizingHashMap?, field$Repr)
     == MutableMap.ResizingHashMap.Repr
   && $IsGhostField(MutableMap.ResizingHashMap.Repr);

axiom FDim(LruImpl.LruImplQueue.Repr) == 0
   && FieldOfDecl(class.LruImpl.LruImplQueue?, field$Repr)
     == LruImpl.LruImplQueue.Repr
   && $IsGhostField(LruImpl.LruImplQueue.Repr);

axiom FDim(LruImpl.LruImplQueue.Queue) == 0
   && FieldOfDecl(class.LruImpl.LruImplQueue?, field$Queue)
     == LruImpl.LruImplQueue.Queue
   && $IsGhostField(LruImpl.LruImplQueue.Queue);

// definition axiom for IndirectionTableImpl.IndirectionTable.Inv(revealed)
axiom 7 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { IndirectionTableImpl.IndirectionTable.Inv($Heap, this) } 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         || (7 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
           && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
       ==> (!read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
         && (MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
             && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           ==> 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv#canCall($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
         && (
          (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)])
           ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
             && IndirectionTableModel.__default.PredCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
             && (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true)
                 ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && IndirectionTableModel.__default.Graph#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)
                       ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                         && IndirectionTableModel.__default.Locs#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                         && 
                        IndirectionTableModel.__default.ValidPredCounts#canCall(predCounts#0, graph#0)
                         && (IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0)
                           ==> BlockCache.__default.GraphClosed#canCall(graph#0))
                         && (BlockCache.__default.GraphClosed#canCall(graph#0)
                             && BlockCache.__default.GraphClosed(graph#0)
                           ==> (forall ref#0: int :: 
                            { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                              { Map#Domain(graph#0)[$Box(ref#0)] } 
                            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                               ==> 
                              Map#Domain(graph#0)[$Box(ref#0)]
                               ==> Bounds.__default.MaxNumChildren#canCall()))
                         && ((forall ref#0: int :: 
                              { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                                { Map#Domain(graph#0)[$Box(ref#0)] } 
                              LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                                 ==> 
                                Map#Domain(graph#0)[$Box(ref#0)]
                                 ==> Bounds.__default.MaxNumChildren#canCall())
                             && (forall ref#0: int :: 
                              { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                                { Map#Domain(graph#0)[$Box(ref#0)] } 
                              LitInt(0) <= ref#0
                                   && ref#0 < 18446744073709551616
                                   && Map#Domain(graph#0)[$Box(ref#0)]
                                 ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                                   <= LitInt(Bounds.__default.MaxNumChildren()))
                           ==> 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                           ==> (forall ref#1: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                              LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                                 ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                     ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType))
                                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                                         == LitInt(0)
                                     ==> LruModel.__default.I#canCall(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))))
                             && ((forall ref#1: int :: 
                                { LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                                LitInt(0) <= ref#1
                                     && ref#1 < 18446744073709551616
                                     && 
                                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                                       == LitInt(0)
                                   ==> LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#1)])
                               ==> (forall ref#2: int :: 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                                  { LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                                LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                                   ==> LruModel.__default.I#canCall(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))
                                     && (LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                                       ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                         && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                                           ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                             && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                      $Heap, 
                                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType))))))
                         && ((read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                               ==> (forall ref#1: int :: 
                                  { LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                                  LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                                     ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                           && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType))
                                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                      $Heap, 
                                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                                             == LitInt(0)
                                         ==> LruModel.__default.I#canCall(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))))
                                 && ((forall ref#1: int :: 
                                    { LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                                    LitInt(0) <= ref#1
                                         && ref#1 < 18446744073709551616
                                         && 
                                        Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                                           == LitInt(0)
                                       ==> LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#1)])
                                   ==> (forall ref#2: int :: 
                                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                                      { LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                                    LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                                       ==> LruModel.__default.I#canCall(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))
                                         && (LruModel.__default.I(read($Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                              LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                                           ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                             && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                             && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                                               ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                                 && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                                 && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                          $Heap, 
                                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType))))))
                             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                               ==> (forall ref#1: int :: 
                                  { LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                                  LitInt(0) <= ref#1
                                       && ref#1 < 18446744073709551616
                                       && 
                                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                                         == LitInt(0)
                                     ==> LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)])
                                 && (forall ref#2: int :: 
                                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                                    { LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                                  LitInt(0) <= ref#2
                                       && ref#2 < 18446744073709551616
                                       && LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                                         == LitInt(0)))
                           ==> PivotBetreeGraph.__default.Root#canCall()
                             && 
                            MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))
                         && (PivotBetreeGraph.__default.Root#canCall()
                             && 
                            MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                             && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                           ==> IndirectionTableModel.__default.MaxSize#canCall())
                         && ((forall ref#3: int :: 
                            { Map#Domain(graph#0)[$Box(ref#3)] } 
                            LitInt(0) <= ref#3
                                 && ref#3 < 18446744073709551616
                                 && Map#Domain(graph#0)[$Box(ref#3)]
                               ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                           ==> 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                           ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                             && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                             && (MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                               ==> MutableMapModel.SimpleIterator.SimpleIterator_q($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))))))
         && IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           == (
            read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
             && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
             && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
              Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Repr)), 
                (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)
                   else Set#Empty(): Set Box)))
             && !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(this)]
             && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> Set#Disjoint(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)))
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> !read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)[$Box(this)])
             && (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              true
                 && (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  true
                     && (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0)
                         && BlockCache.__default.GraphClosed(graph#0)
                         && (forall ref#0: int :: 
                          { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                            { Map#Domain(graph#0)[$Box(ref#0)] } 
                          LitInt(0) <= ref#0
                               && ref#0 < 18446744073709551616
                               && Map#Domain(graph#0)[$Box(ref#0)]
                             ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                               <= LitInt(Bounds.__default.MaxNumChildren()))
                         && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                           ==> (forall ref#1: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                              LitInt(0) <= ref#1
                                   && ref#1 < 18446744073709551616
                                   && 
                                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                                     == LitInt(0)
                                 ==> LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#1)])
                             && (forall ref#2: int :: 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                                { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                              LitInt(0) <= ref#2
                                   && ref#2 < 18446744073709551616
                                   && LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                                     == LitInt(0)))
                         && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                         && read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                            MutableMap.ResizingHashMap.Count)
                           <= LitInt(IndirectionTableModel.__default.MaxSize())
                         && (forall ref#3: int :: 
                          { Map#Domain(graph#0)[$Box(ref#3)] } 
                          LitInt(0) <= ref#3
                               && ref#3 < 18446744073709551616
                               && Map#Domain(graph#0)[$Box(ref#3)]
                             ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                         && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                           ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                             && (forall r#0: int :: 
                              { Map#Domain(locs#0)[$Box(r#0)] } 
                                { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                              LitInt(0) <= r#0
                                   && r#0 < 18446744073709551616
                                   && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                                 ==> Map#Domain(locs#0)[$Box(r#0)])))))));

procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.Inv(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  free requires 7 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];



function Tclass.MutableMapModel.LinearHashMap(Ty) : Ty;

// Tclass.MutableMapModel.LinearHashMap Tag
axiom (forall MutableMapModel.LinearHashMap$V: Ty :: 
  { Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V) } 
  Tag(Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V))
     == Tagclass.MutableMapModel.LinearHashMap);

const unique Tagclass.MutableMapModel.LinearHashMap: TyTag;

// Tclass.MutableMapModel.LinearHashMap injectivity 0
axiom (forall MutableMapModel.LinearHashMap$V: Ty :: 
  { Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V) } 
  Tclass.MutableMapModel.LinearHashMap_0(Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V))
     == MutableMapModel.LinearHashMap$V);

function Tclass.MutableMapModel.LinearHashMap_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMapModel.LinearHashMap
axiom (forall MutableMapModel.LinearHashMap$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V)) } 
  $IsBox(bx, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V)));

function Tclass.DiskLayout.Location() : Ty;

// Tclass.DiskLayout.Location Tag
axiom Tag(Tclass.DiskLayout.Location()) == Tagclass.DiskLayout.Location;

const unique Tagclass.DiskLayout.Location: TyTag;

// Box/unbox axiom for Tclass.DiskLayout.Location
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DiskLayout.Location()) } 
  $IsBox(bx, Tclass.DiskLayout.Location())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.DiskLayout.Location()));

implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.Inv(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var predCounts#1: Map Box Box;
  var let#0#0#0: Map Box Box;
  var ##t#0: DatatypeType;
  var graph#1: Map Box Box;
  var let#1#0#0: Map Box Box;
  var ##t#1: DatatypeType;
  var locs#1: Map Box Box;
  var let#2#0#0: Map Box Box;
  var ##t#2: DatatypeType;
  var ##predCounts#0: Map Box Box;
  var ##graph#0: Map Box Box;
  var ##graph#1: Map Box Box;
  var ref#4: int;
  var ref#5: int;
  var newtype$check#0: int;
  var ##q#0: Seq Box;
  var ref#6: int;
  var ##q#1: Seq Box;
  var newtype$check#1: int;
  var ref#10: int;
  var ##self#0: DatatypeType;
  var ##it#0: DatatypeType;
  var r#1: int;
  var b$reqreads#1: bool;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;
  var b$reqreads#10: bool;
  var b$reqreads#11: bool;
  var b$reqreads#12: bool;
  var b$reqreads#13: bool;
  var b$reqreads#14: bool;
  var b$reqreads#15: bool;
  var b$reqreads#16: bool;
  var b$reqreads#17: bool;
  var b$reqreads#18: bool;
  var b$reqreads#19: bool;
  var b$reqreads#20: bool;
  var b$reqreads#21: bool;
  var b$reqreads#22: bool;
  var b$reqreads#23: bool;
  var b$reqreads#24: bool;
  var b$reqreads#25: bool;
  var b$reqreads#26: bool;
  var b$reqreads#27: bool;
  var b$reqreads#28: bool;
  var b$reqreads#29: bool;
  var b$reqreads#30: bool;
  var b$reqreads#31: bool;
  var b$reqreads#32: bool;
  var b$reqreads#33: bool;
  var b$reqreads#34: bool;
  var b$reqreads#35: bool;
  var b$reqreads#36: bool;
  var b$reqreads#37: bool;
  var b$reqreads#38: bool;
  var b$reqreads#39: bool;
  var b$reqreads#40: bool;
  var b$reqreads#41: bool;
  var b$reqreads#42: bool;
  var b$reqreads#43: bool;
  var b$reqreads#44: bool;
  var b$reqreads#45: bool;
  var b$reqreads#46: bool;
  var b$reqreads#47: bool;
  var b$reqreads#48: bool;
  var b$reqreads#49: bool;
  var b$reqreads#50: bool;
  var b$reqreads#51: bool;
  var b$reqreads#52: bool;
  var b$reqreads#53: bool;
  var b$reqreads#54: bool;
  var b$reqreads#55: bool;
  var b$reqreads#56: bool;
  var b$reqreads#57: bool;
  var b$reqreads#58: bool;
  var b$reqreads#59: bool;
  var b$reqreads#60: bool;
  var b$reqreads#61: bool;
  var b$reqreads#62: bool;
  var b$reqreads#63: bool;
  var b$reqreads#64: bool;
  var b$reqreads#65: bool;
  var b$reqreads#66: bool;
  var b$reqreads#67: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;
    b$reqreads#10 := true;
    b$reqreads#11 := true;
    b$reqreads#12 := true;
    b$reqreads#13 := true;
    b$reqreads#14 := true;
    b$reqreads#15 := true;
    b$reqreads#16 := true;
    b$reqreads#17 := true;
    b$reqreads#18 := true;
    b$reqreads#19 := true;
    b$reqreads#20 := true;
    b$reqreads#21 := true;
    b$reqreads#22 := true;
    b$reqreads#23 := true;
    b$reqreads#24 := true;
    b$reqreads#25 := true;
    b$reqreads#26 := true;
    b$reqreads#27 := true;
    b$reqreads#28 := true;
    b$reqreads#29 := true;
    b$reqreads#30 := true;
    b$reqreads#31 := true;
    b$reqreads#32 := true;
    b$reqreads#33 := true;
    b$reqreads#34 := true;
    b$reqreads#35 := true;
    b$reqreads#36 := true;
    b$reqreads#37 := true;
    b$reqreads#38 := true;
    b$reqreads#39 := true;
    b$reqreads#40 := true;
    b$reqreads#41 := true;
    b$reqreads#42 := true;
    b$reqreads#43 := true;
    b$reqreads#44 := true;
    b$reqreads#45 := true;
    b$reqreads#46 := true;
    b$reqreads#47 := true;
    b$reqreads#48 := true;
    b$reqreads#49 := true;
    b$reqreads#50 := true;
    b$reqreads#51 := true;
    b$reqreads#52 := true;
    b$reqreads#53 := true;
    b$reqreads#54 := true;
    b$reqreads#55 := true;
    b$reqreads#56 := true;
    b$reqreads#57 := true;
    b$reqreads#58 := true;
    b$reqreads#59 := true;
    b$reqreads#60 := true;
    b$reqreads#61 := true;
    b$reqreads#62 := true;
    b$reqreads#63 := true;
    b$reqreads#64 := true;
    b$reqreads#65 := true;
    b$reqreads#66 := true;
    b$reqreads#67 := true;

    // AddWellformednessCheck for function Inv
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(63,24): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this
           || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    b$reqreads#0 := $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert b$reqreads#0;
    if (*)
    {
        if (*)
        {
            assert this == this
               || (Set#Subset(Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this))), 
                  Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this))))
                 && !Set#Subset(Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this))), 
                  Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(this)))));
            assume this == this || IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
            assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
            assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
        }
        else
        {
            assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
               ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
        }

        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this
               || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
        b$reqreads#1 := $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)])
        {
            b$reqreads#2 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
            b$reqreads#3 := $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))])
        {
            b$reqreads#4 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
            if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
            {
                b$reqreads#5 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                b$reqreads#6 := $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
            }
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]))
        {
            b$reqreads#7 := $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
            b$reqreads#8 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            b$reqreads#9 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.t), MutableMap.ResizingHashMap.Repr];
            b$reqreads#10 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
            if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
            {
                b$reqreads#11 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                b$reqreads#12 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), LruImpl.LruImplQueue.Repr];
            }
            else
            {
            }
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box))))
        {
            b$reqreads#13 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            b$reqreads#14 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.t), MutableMap.ResizingHashMap.Repr];
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)])
        {
            b$reqreads#15 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            b$reqreads#16 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                     || read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
        {
            b$reqreads#17 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
            if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
            {
                b$reqreads#18 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                b$reqreads#19 := (forall<alpha> $o: ref, $f: Field alpha :: 
                  $o != null
                       && read($Heap, $o, alloc)
                       && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                         || read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Repr)[$Box($o)])
                     ==> $_Frame[$o, $f]);
                assume LruImpl.LruImplQueue.Inv#canCall($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue));
            }
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))))
        {
            b$reqreads#20 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
            if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
            {
                b$reqreads#21 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                b$reqreads#22 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), LruImpl.LruImplQueue.Repr];
                b$reqreads#23 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                b$reqreads#24 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.t), MutableMap.ResizingHashMap.Repr];
            }
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> Set#Disjoint(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr))))
        {
            b$reqreads#25 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
            if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
            {
                b$reqreads#26 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                b$reqreads#27 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), LruImpl.LruImplQueue.Repr];
            }
        }

        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> Set#Disjoint(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box(this)]))
        {
            havoc predCounts#1;
            assume $Is(predCounts#1, TMap(Tclass.NativeTypes.uint64(), TInt));
            b$reqreads#28 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            b$reqreads#29 := (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                     || read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            b$reqreads#30 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            assume IndirectionTableModel.__default.PredCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assume let#0#0#0
               == IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && IndirectionTableModel.__default.PredCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            // CheckWellformedWithResult: any expression
            assume $Is(let#0#0#0, TMap(Tclass.NativeTypes.uint64(), TInt));
            assume predCounts#1 == let#0#0#0;
            if (Lit(true))
            {
                havoc graph#1;
                assume $Is(graph#1, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())));
                b$reqreads#31 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                b$reqreads#32 := (forall<alpha> $o: ref, $f: Field alpha :: 
                  $o != null
                       && read($Heap, $o, alloc)
                       && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                         || read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Repr)[$Box($o)])
                     ==> $_Frame[$o, $f]);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                ##t#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                // assume allocatedness for argument to function
                assume $IsAlloc(##t#1, 
                  Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                b$reqreads#33 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                assume IndirectionTableModel.__default.Graph#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                assume let#1#0#0
                   == IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && IndirectionTableModel.__default.Graph#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                // CheckWellformedWithResult: any expression
                assume $Is(let#1#0#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())));
                assume graph#1 == let#1#0#0;
                if (Lit(true))
                {
                    havoc locs#1;
                    assume $Is(locs#1, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()));
                    b$reqreads#34 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    b$reqreads#35 := (forall<alpha> $o: ref, $f: Field alpha :: 
                      $o != null
                           && read($Heap, $o, alloc)
                           && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                             || read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                              MutableMap.ResizingHashMap.Repr)[$Box($o)])
                         ==> $_Frame[$o, $f]);
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    ##t#2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##t#2, 
                      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                      $Heap);
                    b$reqreads#36 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    assume IndirectionTableModel.__default.Locs#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    assume let#2#0#0
                       == IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                       && IndirectionTableModel.__default.Locs#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    // CheckWellformedWithResult: any expression
                    assume $Is(let#2#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()));
                    assume locs#1 == let#2#0#0;
                    ##predCounts#0 := predCounts#1;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt), $Heap);
                    ##graph#0 := graph#1;
                    // assume allocatedness for argument to function
                    assume $IsAlloc(##graph#0, 
                      TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
                      $Heap);
                    b$reqreads#37 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    assume IndirectionTableModel.__default.ValidPredCounts#canCall(predCounts#1, graph#1);
                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))
                    {
                        ##graph#1 := graph#1;
                        // assume allocatedness for argument to function
                        assume $IsAlloc(##graph#1, 
                          TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
                          $Heap);
                        b$reqreads#38 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        assume BlockCache.__default.GraphClosed#canCall(graph#1);
                    }

                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                       && BlockCache.__default.GraphClosed(graph#1))
                    {
                        havoc ref#4;
                        assume LitInt(0) <= ref#4 && ref#4 < 18446744073709551616;
                        // Begin Comprehension WF check
                        if (Map#Domain(graph#1)[$Box(ref#4)])
                        {
                            assert Map#Domain(graph#1)[$Box(ref#4)];
                            b$reqreads#39 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                            assume Bounds.__default.MaxNumChildren#canCall();
                        }

                        // End Comprehension WF check
                    }

                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                       && BlockCache.__default.GraphClosed(graph#1)
                       && (forall ref#8: int :: 
                        { $Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box } 
                          { Map#Domain(graph#1)[$Box(ref#8)] } 
                        LitInt(0) <= ref#8
                             && ref#8 < 18446744073709551616
                             && Map#Domain(graph#1)[$Box(ref#8)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))
                    {
                        b$reqreads#40 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
                        {
                            havoc ref#5;
                            assume LitInt(0) <= ref#5 && ref#5 < 18446744073709551616;
                            // Begin Comprehension WF check
                            b$reqreads#41 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            b$reqreads#42 := (forall<alpha> $o: ref, $f: Field alpha :: 
                              $o != null
                                   && read($Heap, $o, alloc)
                                   && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                                     || read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                                      MutableMap.ResizingHashMap.Repr)[$Box($o)])
                                 ==> $_Frame[$o, $f]);
                            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                            if (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)])
                            {
                                b$reqreads#43 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                b$reqreads#44 := (forall<alpha> $o: ref, $f: Field alpha :: 
                                  $o != null
                                       && read($Heap, $o, alloc)
                                       && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                                         || read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                                          MutableMap.ResizingHashMap.Repr)[$Box($o)])
                                     ==> $_Frame[$o, $f]);
                                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                                assert Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)];
                                assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType);
                                newtype$check#0 := LitInt(0);
                                assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
                            }

                            if (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                                 == LitInt(0))
                            {
                                b$reqreads#45 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                                b$reqreads#46 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), LruImpl.LruImplQueue.Queue];
                                ##q#0 := read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue);
                                // assume allocatedness for argument to function
                                assume $IsAlloc(##q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
                                b$reqreads#47 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                                assume LruModel.__default.I#canCall(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue));
                            }

                            // End Comprehension WF check
                            if ((forall ref#7: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                              LitInt(0) <= ref#7
                                   && ref#7 < 18446744073709551616
                                   && 
                                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                                     == LitInt(0)
                                 ==> LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#7)]))
                            {
                                havoc ref#6;
                                assume LitInt(0) <= ref#6 && ref#6 < 18446744073709551616;
                                // Begin Comprehension WF check
                                b$reqreads#48 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
                                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                                b$reqreads#49 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), LruImpl.LruImplQueue.Queue];
                                ##q#1 := read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue);
                                // assume allocatedness for argument to function
                                assume $IsAlloc(##q#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
                                b$reqreads#50 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                                assume LruModel.__default.I#canCall(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue));
                                if (LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#6)])
                                {
                                    b$reqreads#51 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                                    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                    b$reqreads#52 := (forall<alpha> $o: ref, $f: Field alpha :: 
                                      $o != null
                                           && read($Heap, $o, alloc)
                                           && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                                             || read($Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                                              MutableMap.ResizingHashMap.Repr)[$Box($o)])
                                         ==> $_Frame[$o, $f]);
                                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                                    if (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)])
                                    {
                                        b$reqreads#53 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                                        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                                        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                        b$reqreads#54 := (forall<alpha> $o: ref, $f: Field alpha :: 
                                          $o != null
                                               && read($Heap, $o, alloc)
                                               && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                                                 || read($Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                                                  MutableMap.ResizingHashMap.Repr)[$Box($o)])
                                             ==> $_Frame[$o, $f]);
                                        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                                        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                                        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                                        assert Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)];
                                        assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType);
                                        newtype$check#1 := LitInt(0);
                                        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
                                    }
                                }

                                // End Comprehension WF check
                            }
                        }
                    }

                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                       && BlockCache.__default.GraphClosed(graph#1)
                       && (forall ref#8: int :: 
                        { $Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box } 
                          { Map#Domain(graph#1)[$Box(ref#8)] } 
                        LitInt(0) <= ref#8
                             && ref#8 < 18446744073709551616
                             && Map#Domain(graph#1)[$Box(ref#8)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren()))
                       && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#7: int :: 
                            { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                            LitInt(0) <= ref#7
                                 && ref#7 < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                                   == LitInt(0)
                               ==> LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)])
                           && (forall ref#9: int :: 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)] } 
                              { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#9)] } 
                            LitInt(0) <= ref#9
                                 && ref#9 < 18446744073709551616
                                 && LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#9)]
                               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType)
                                   == LitInt(0))))
                    {
                        b$reqreads#55 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        assume PivotBetreeGraph.__default.Root#canCall();
                        b$reqreads#56 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                        b$reqreads#57 := (forall<alpha> $o: ref, $f: Field alpha :: 
                          $o != null
                               && read($Heap, $o, alloc)
                               && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                                 || read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                                  MutableMap.ResizingHashMap.Repr)[$Box($o)])
                             ==> $_Frame[$o, $f]);
                        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    }

                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                       && BlockCache.__default.GraphClosed(graph#1)
                       && (forall ref#8: int :: 
                        { $Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box } 
                          { Map#Domain(graph#1)[$Box(ref#8)] } 
                        LitInt(0) <= ref#8
                             && ref#8 < 18446744073709551616
                             && Map#Domain(graph#1)[$Box(ref#8)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren()))
                       && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#7: int :: 
                            { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                            LitInt(0) <= ref#7
                                 && ref#7 < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                                   == LitInt(0)
                               ==> LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)])
                           && (forall ref#9: int :: 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)] } 
                              { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#9)] } 
                            LitInt(0) <= ref#9
                                 && ref#9 < 18446744073709551616
                                 && LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#9)]
                               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType)
                                   == LitInt(0)))
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])
                    {
                        b$reqreads#58 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                        b$reqreads#59 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.t), MutableMap.ResizingHashMap.Count];
                        b$reqreads#60 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                        assume IndirectionTableModel.__default.MaxSize#canCall();
                    }

                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                       && BlockCache.__default.GraphClosed(graph#1)
                       && (forall ref#8: int :: 
                        { $Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box } 
                          { Map#Domain(graph#1)[$Box(ref#8)] } 
                        LitInt(0) <= ref#8
                             && ref#8 < 18446744073709551616
                             && Map#Domain(graph#1)[$Box(ref#8)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren()))
                       && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#7: int :: 
                            { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                            LitInt(0) <= ref#7
                                 && ref#7 < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                                   == LitInt(0)
                               ==> LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)])
                           && (forall ref#9: int :: 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)] } 
                              { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#9)] } 
                            LitInt(0) <= ref#9
                                 && ref#9 < 18446744073709551616
                                 && LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#9)]
                               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType)
                                   == LitInt(0)))
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                       && read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))
                    {
                        havoc ref#10;
                        assume LitInt(0) <= ref#10 && ref#10 < 18446744073709551616;
                        // Begin Comprehension WF check
                        if (Map#Domain(graph#1)[$Box(ref#10)])
                        {
                            b$reqreads#61 := $_Frame[this, IndirectionTableImpl.IndirectionTable.refUpperBound];
                        }

                        // End Comprehension WF check
                    }

                    if (IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                       && BlockCache.__default.GraphClosed(graph#1)
                       && (forall ref#8: int :: 
                        { $Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box } 
                          { Map#Domain(graph#1)[$Box(ref#8)] } 
                        LitInt(0) <= ref#8
                             && ref#8 < 18446744073709551616
                             && Map#Domain(graph#1)[$Box(ref#8)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#8)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren()))
                       && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#7: int :: 
                            { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                            LitInt(0) <= ref#7
                                 && ref#7 < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                                   == LitInt(0)
                               ==> LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#7)])
                           && (forall ref#9: int :: 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)] } 
                              { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#9)] } 
                            LitInt(0) <= ref#9
                                 && ref#9 < 18446744073709551616
                                 && LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#9)]
                               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType)
                                   == LitInt(0)))
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                       && read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize())
                       && (forall ref#11: int :: 
                        { Map#Domain(graph#1)[$Box(ref#11)] } 
                        LitInt(0) <= ref#11
                             && ref#11 < 18446744073709551616
                             && Map#Domain(graph#1)[$Box(ref#11)]
                           ==> ref#11 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))
                    {
                        b$reqreads#62 := $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
                        if (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)))
                        {
                            b$reqreads#63 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
                            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            b$reqreads#64 := (forall<alpha> $o: ref, $f: Field alpha :: 
                              $o != null
                                   && read($Heap, $o, alloc)
                                   && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                                     || read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                                      MutableMap.ResizingHashMap.Repr)[$Box($o)])
                                 ==> $_Frame[$o, $f]);
                            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                            b$reqreads#65 := $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
                            assert Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator));
                            ##self#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                            // assume allocatedness for argument to function
                            assume $IsAlloc(##self#0, 
                              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                              $Heap);
                            ##it#0 := $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType;
                            // assume allocatedness for argument to function
                            assume $IsAlloc(##it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
                            b$reqreads#66 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                            assume MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType);
                            if (MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))
                            {
                                havoc r#1;
                                assume LitInt(0) <= r#1 && r#1 < 18446744073709551616;
                                // Begin Comprehension WF check
                                b$reqreads#67 := $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
                                assert Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator));
                                assume MutableMapModel.SimpleIterator.SimpleIterator_q($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType);
                                if (MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)])
                                {
                                }

                                // End Comprehension WF check
                            }
                        }
                    }
                }
            }
        }

        assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           == (
            read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
             && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
             && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
              Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Repr)), 
                (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)
                   else Set#Empty(): Set Box)))
             && !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(this)]
             && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> Set#Disjoint(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)))
             && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> !read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)[$Box(this)])
             && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              true
                 && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  true
                     && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                         && BlockCache.__default.GraphClosed(graph#2)
                         && (forall ref#12: int :: 
                          { $Unbox(Map#Elements(graph#2)[$Box(ref#12)]): Seq Box } 
                            { Map#Domain(graph#2)[$Box(ref#12)] } 
                          LitInt(0) <= ref#12
                               && ref#12 < 18446744073709551616
                               && Map#Domain(graph#2)[$Box(ref#12)]
                             ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#12)]): Seq Box)
                               <= LitInt(Bounds.__default.MaxNumChildren()))
                         && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                           ==> (forall ref#13: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                              LitInt(0) <= ref#13
                                   && ref#13 < 18446744073709551616
                                   && 
                                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                                     == LitInt(0)
                                 ==> LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#13)])
                             && (forall ref#14: int :: 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                                { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                              LitInt(0) <= ref#14
                                   && ref#14 < 18446744073709551616
                                   && LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#14)]
                                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                                     == LitInt(0)))
                         && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                         && read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                            MutableMap.ResizingHashMap.Count)
                           <= LitInt(IndirectionTableModel.__default.MaxSize())
                         && (forall ref#15: int :: 
                          { Map#Domain(graph#2)[$Box(ref#15)] } 
                          LitInt(0) <= ref#15
                               && ref#15 < 18446744073709551616
                               && Map#Domain(graph#2)[$Box(ref#15)]
                             ==> ref#15 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                         && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                           ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                             && (forall r#2: int :: 
                              { Map#Domain(locs#2)[$Box(r#2)] } 
                                { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                              LitInt(0) <= r#2
                                   && r#2 < 18446744073709551616
                                   && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                                 ==> Map#Domain(locs#2)[$Box(r#2)]))))));
        assume (!read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(this)]
             ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
           && (MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
             ==> 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv#canCall($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
           && (
            (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box(this)])
             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && IndirectionTableModel.__default.PredCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
               && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Lit(true)
                   ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                     && IndirectionTableModel.__default.Graph#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                     && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Lit(true)
                         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                           && IndirectionTableModel.__default.Locs#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                           && 
                          IndirectionTableModel.__default.ValidPredCounts#canCall(predCounts#2, graph#2)
                           && (IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                             ==> BlockCache.__default.GraphClosed#canCall(graph#2))
                           && (BlockCache.__default.GraphClosed#canCall(graph#2)
                               && BlockCache.__default.GraphClosed(graph#2)
                             ==> (forall ref#12: int :: 
                              { $Unbox(Map#Elements(graph#2)[$Box(ref#12)]): Seq Box } 
                                { Map#Domain(graph#2)[$Box(ref#12)] } 
                              LitInt(0) <= ref#12 && ref#12 < 18446744073709551616
                                 ==> 
                                Map#Domain(graph#2)[$Box(ref#12)]
                                 ==> Bounds.__default.MaxNumChildren#canCall()))
                           && ((forall ref#12: int :: 
                                { $Unbox(Map#Elements(graph#2)[$Box(ref#12)]): Seq Box } 
                                  { Map#Domain(graph#2)[$Box(ref#12)] } 
                                LitInt(0) <= ref#12 && ref#12 < 18446744073709551616
                                   ==> 
                                  Map#Domain(graph#2)[$Box(ref#12)]
                                   ==> Bounds.__default.MaxNumChildren#canCall())
                               && (forall ref#12: int :: 
                                { $Unbox(Map#Elements(graph#2)[$Box(ref#12)]): Seq Box } 
                                  { Map#Domain(graph#2)[$Box(ref#12)] } 
                                LitInt(0) <= ref#12
                                     && ref#12 < 18446744073709551616
                                     && Map#Domain(graph#2)[$Box(ref#12)]
                                   ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#12)]): Seq Box)
                                     <= LitInt(Bounds.__default.MaxNumChildren()))
                             ==> 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#13: int :: 
                                { LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                                LitInt(0) <= ref#13 && ref#13 < 18446744073709551616
                                   ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                     && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                       ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                         && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                         && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType))
                                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                                           == LitInt(0)
                                       ==> LruModel.__default.I#canCall(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))))
                               && ((forall ref#13: int :: 
                                  { LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                                  LitInt(0) <= ref#13
                                       && ref#13 < 18446744073709551616
                                       && 
                                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                                         == LitInt(0)
                                     ==> LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#13)])
                                 ==> (forall ref#14: int :: 
                                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                                    { LruModel.__default.I(read($Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                                  LitInt(0) <= ref#14 && ref#14 < 18446744073709551616
                                     ==> LruModel.__default.I#canCall(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))
                                       && (LruModel.__default.I(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))[$Box(ref#14)]
                                         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                                             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                               && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                        $Heap, 
                                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType))))))
                           && ((read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                                 ==> (forall ref#13: int :: 
                                    { LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                                    LitInt(0) <= ref#13 && ref#13 < 18446744073709551616
                                       ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                         && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                           ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                             && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                      $Heap, 
                                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType))
                                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                        $Heap, 
                                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                                               == LitInt(0)
                                           ==> LruModel.__default.I#canCall(read($Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                              LruImpl.LruImplQueue.Queue))))
                                   && ((forall ref#13: int :: 
                                      { LruModel.__default.I(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                                      LitInt(0) <= ref#13
                                           && ref#13 < 18446744073709551616
                                           && 
                                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                      $Heap, 
                                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                                             == LitInt(0)
                                         ==> LruModel.__default.I(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))[$Box(ref#13)])
                                     ==> (forall ref#14: int :: 
                                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                                        { LruModel.__default.I(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                                      LitInt(0) <= ref#14 && ref#14 < 18446744073709551616
                                         ==> LruModel.__default.I#canCall(read($Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                              LruImpl.LruImplQueue.Queue))
                                           && (LruModel.__default.I(read($Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                                LruImpl.LruImplQueue.Queue))[$Box(ref#14)]
                                             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                                $Heap, 
                                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                  $Heap, 
                                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                               && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                      $Heap, 
                                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                                                 ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                                                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                      $Heap, 
                                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                                                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                            $Heap, 
                                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType))))))
                               && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                                 ==> (forall ref#13: int :: 
                                    { LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                                    LitInt(0) <= ref#13
                                         && ref#13 < 18446744073709551616
                                         && 
                                        Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                                           == LitInt(0)
                                       ==> LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#13)])
                                   && (forall ref#14: int :: 
                                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                                      { LruModel.__default.I(read($Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                          LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                                    LitInt(0) <= ref#14
                                         && ref#14 < 18446744073709551616
                                         && LruModel.__default.I(read($Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                            LruImpl.LruImplQueue.Queue))[$Box(ref#14)]
                                       ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                                    $Heap, 
                                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                                           == LitInt(0)))
                             ==> PivotBetreeGraph.__default.Root#canCall()
                               && 
                              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))
                           && (PivotBetreeGraph.__default.Root#canCall()
                               && 
                              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                               && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                             ==> IndirectionTableModel.__default.MaxSize#canCall())
                           && ((forall ref#15: int :: 
                              { Map#Domain(graph#2)[$Box(ref#15)] } 
                              LitInt(0) <= ref#15
                                   && ref#15 < 18446744073709551616
                                   && Map#Domain(graph#2)[$Box(ref#15)]
                                 ==> ref#15 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                             ==> 
                            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                               && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                               && (MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                                 ==> MutableMapModel.SimpleIterator.SimpleIterator_q($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))))));
        // CheckWellformedWithResult: any expression
        assume $Is(IndirectionTableImpl.IndirectionTable.Inv($Heap, this), TBool);
        assert b$reqreads#1;
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
        assert b$reqreads#10;
        assert b$reqreads#11;
        assert b$reqreads#12;
        assert b$reqreads#13;
        assert b$reqreads#14;
        assert b$reqreads#15;
        assert b$reqreads#16;
        assert b$reqreads#17;
        assert b$reqreads#18;
        assert b$reqreads#19;
        assert b$reqreads#20;
        assert b$reqreads#21;
        assert b$reqreads#22;
        assert b$reqreads#23;
        assert b$reqreads#24;
        assert b$reqreads#25;
        assert b$reqreads#26;
        assert b$reqreads#27;
        assert b$reqreads#28;
        assert b$reqreads#29;
        assert b$reqreads#30;
        assert b$reqreads#31;
        assert b$reqreads#32;
        assert b$reqreads#33;
        assert b$reqreads#34;
        assert b$reqreads#35;
        assert b$reqreads#36;
        assert b$reqreads#37;
        assert b$reqreads#38;
        assert b$reqreads#39;
        assert b$reqreads#40;
        assert b$reqreads#41;
        assert b$reqreads#42;
        assert b$reqreads#43;
        assert b$reqreads#44;
        assert b$reqreads#45;
        assert b$reqreads#46;
        assert b$reqreads#47;
        assert b$reqreads#48;
        assert b$reqreads#49;
        assert b$reqreads#50;
        assert b$reqreads#51;
        assert b$reqreads#52;
        assert b$reqreads#53;
        assert b$reqreads#54;
        assert b$reqreads#55;
        assert b$reqreads#56;
        assert b$reqreads#57;
        assert b$reqreads#58;
        assert b$reqreads#59;
        assert b$reqreads#60;
        assert b$reqreads#61;
        assert b$reqreads#62;
        assert b$reqreads#63;
        assert b$reqreads#64;
        assert b$reqreads#65;
        assert b$reqreads#66;
        assert b$reqreads#67;
    }
}



// function declaration for IndirectionTableImpl.IndirectionTable.I
function IndirectionTableImpl.IndirectionTable.I($heap: Heap, this: ref) : DatatypeType;

function IndirectionTableImpl.IndirectionTable.I#canCall($heap: Heap, this: ref) : bool;

// frame axiom for IndirectionTableImpl.IndirectionTable.I
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), IndirectionTableImpl.IndirectionTable.I($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this
             || read($h0, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> IndirectionTableImpl.IndirectionTable.I($h0, this)
       == IndirectionTableImpl.IndirectionTable.I($h1, this));

function Tclass.IndirectionTableModel.IndirectionTable() : Ty;

// Tclass.IndirectionTableModel.IndirectionTable Tag
axiom Tag(Tclass.IndirectionTableModel.IndirectionTable())
   == Tagclass.IndirectionTableModel.IndirectionTable;

const unique Tagclass.IndirectionTableModel.IndirectionTable: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableModel.IndirectionTable
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableModel.IndirectionTable()) } 
  $IsBox(bx, Tclass.IndirectionTableModel.IndirectionTable())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.IndirectionTableModel.IndirectionTable()));

// consequence axiom for IndirectionTableImpl.IndirectionTable.I
axiom 8 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { IndirectionTableImpl.IndirectionTable.I($Heap, this) } 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
         || (8 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
           && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap)
           && IndirectionTableImpl.IndirectionTable.Inv($Heap, this))
       ==> IndirectionTableModel.__default.Inv(IndirectionTableImpl.IndirectionTable.I($Heap, this))
         && $Is(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
          Tclass.IndirectionTableModel.IndirectionTable()));

function IndirectionTableImpl.IndirectionTable.I#requires(Heap, ref) : bool;

// #requires axiom for IndirectionTableImpl.IndirectionTable.I
axiom (forall $Heap: Heap, this: ref :: 
  { IndirectionTableImpl.IndirectionTable.I#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
       && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap)
     ==> IndirectionTableImpl.IndirectionTable.I#requires($Heap, this)
       == IndirectionTableImpl.IndirectionTable.Inv($Heap, this));

// definition axiom for IndirectionTableImpl.IndirectionTable.I(revealed)
axiom 8 <= $FunctionContextHeight
   ==> (forall $Heap: Heap, this: ref :: 
    { IndirectionTableImpl.IndirectionTable.I($Heap, this) } 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
         || (8 != $FunctionContextHeight
           && 
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
           && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap)
           && IndirectionTableImpl.IndirectionTable.Inv($Heap, this))
       ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
         && IndirectionTableModel.__default.FromHashMap#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then #Options.Option.Some($Box(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Queue)))
             else #Options.Option.None()), 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound), 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
         && IndirectionTableImpl.IndirectionTable.I($Heap, this)
           == (var res#0 := IndirectionTableModel.__default.FromHashMap(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then #Options.Option.Some($Box(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue)))
                   else #Options.Option.None()), 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound), 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)); 
            res#0));

procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.I(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  free requires 8 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  ensures IndirectionTableModel.__default.Inv(IndirectionTableImpl.IndirectionTable.I($Heap, this));



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.I(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;
  var ##self#0: DatatypeType;
  var res#1: DatatypeType;
  var let#0#0#0: DatatypeType;
  var ##m#0: DatatypeType;
  var ##q#0: DatatypeType;
  var ##refUpperBound#0: int;
  var ##findLoclessIterator#0: DatatypeType;
  var self##0: DatatypeType;
  var b$reqreads#2: bool;
  var b$reqreads#3: bool;
  var b$reqreads#4: bool;
  var b$reqreads#5: bool;
  var b$reqreads#6: bool;
  var b$reqreads#7: bool;
  var b$reqreads#8: bool;
  var b$reqreads#9: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;
    b$reqreads#2 := true;
    b$reqreads#3 := true;
    b$reqreads#4 := true;
    b$reqreads#5 := true;
    b$reqreads#6 := true;
    b$reqreads#7 := true;
    b$reqreads#8 := true;
    b$reqreads#9 := true;

    // AddWellformednessCheck for function I
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(98,23): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> $o == this
           || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == this
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert b$reqreads#0;
    b$reqreads#1 := $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert b$reqreads#1;
    if (*)
    {
        assume $Is(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
          Tclass.IndirectionTableModel.IndirectionTable());
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
              Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Repr)), 
                (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)
                   else Set#Empty(): Set Box)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(this)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> Set#Disjoint(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> !read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)[$Box(this)]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Lit(true)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  BlockCache.__default.GraphClosed(graph#0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#0: int :: 
                    { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                      { Map#Domain(graph#0)[$Box(ref#0)] } 
                    LitInt(0) <= ref#0
                         && ref#0 < 18446744073709551616
                         && Map#Domain(graph#0)[$Box(ref#0)]
                       ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                         <= LitInt(Bounds.__default.MaxNumChildren())))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#1: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                      LitInt(0) <= ref#1
                           && ref#1 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#2: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                      LitInt(0) <= ref#2
                           && ref#2 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                             == LitInt(0)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Count)
                     <= LitInt(IndirectionTableModel.__default.MaxSize()))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#3: int :: 
                    { Map#Domain(graph#0)[$Box(ref#3)] } 
                    LitInt(0) <= ref#3
                         && ref#3 < 18446744073709551616
                         && Map#Domain(graph#0)[$Box(ref#3)]
                       ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> (forall r#0: int :: 
                      { Map#Domain(locs#0)[$Box(r#0)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                      LitInt(0) <= r#0
                           && r#0 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                         ==> Map#Domain(locs#0)[$Box(r#0)]))));
        assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
        assert this == this
           || (Set#Subset(Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(this))), 
              Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(this))))
             && !Set#Subset(Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(this))), 
              Set#Union(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(this)))));
        assume this == this || IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
        assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
        assume IndirectionTableModel.__default.Inv#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assume IndirectionTableModel.__default.Inv(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc)
             ==> $o == this
               || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
        havoc res#1;
        assume $Is(res#1, Tclass.IndirectionTableModel.IndirectionTable());
        b$reqreads#2 := $_Frame[this, IndirectionTableImpl.IndirectionTable.t];
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        b$reqreads#3 := (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.t)
                 || read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
        b$reqreads#4 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
        if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
        {
            b$reqreads#5 := $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
            assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
            b$reqreads#6 := $_Frame[read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), LruImpl.LruImplQueue.Queue];
        }
        else
        {
        }

        b$reqreads#7 := $_Frame[this, IndirectionTableImpl.IndirectionTable.refUpperBound];
        b$reqreads#8 := $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
        ##m#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        // assume allocatedness for argument to function
        assume $IsAlloc(##m#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap);
        ##q#0 := (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then #Options.Option.Some($Box(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Queue)))
           else #Options.Option.None());
        // assume allocatedness for argument to function
        assume $IsAlloc(##q#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), $Heap);
        ##refUpperBound#0 := read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound);
        // assume allocatedness for argument to function
        assume $IsAlloc(##refUpperBound#0, Tclass.NativeTypes.uint64(), $Heap);
        ##findLoclessIterator#0 := read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator);
        // assume allocatedness for argument to function
        assume $IsAlloc(##findLoclessIterator#0, 
          Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()), 
          $Heap);
        b$reqreads#9 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume IndirectionTableModel.__default.FromHashMap#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then #Options.Option.Some($Box(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Queue)))
             else #Options.Option.None()), 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound), 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator));
        assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.FromHashMap(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then #Options.Option.Some($Box(read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Queue)))
               else #Options.Option.None()), 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound), 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)));
        assume let#0#0#0
           == IndirectionTableModel.__default.FromHashMap(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then #Options.Option.Some($Box(read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Queue)))
               else #Options.Option.None()), 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound), 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && IndirectionTableModel.__default.FromHashMap#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then #Options.Option.Some($Box(read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Queue)))
               else #Options.Option.None()), 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound), 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator));
        // CheckWellformedWithResult: any expression
        assume $Is(let#0#0#0, Tclass.IndirectionTableModel.IndirectionTable());
        assume res#1 == let#0#0#0;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(104,39)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        self##0 := res#1;
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableModel.__default.reveal__Inv(self##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(104,43)"} true;
        assume IndirectionTableImpl.IndirectionTable.I($Heap, this) == res#1;
        assume true;
        // CheckWellformedWithResult: any expression
        assume $Is(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
          Tclass.IndirectionTableModel.IndirectionTable());
        assert b$reqreads#2;
        assert b$reqreads#3;
        assert b$reqreads#4;
        assert b$reqreads#5;
        assert b$reqreads#6;
        assert b$reqreads#7;
        assert b$reqreads#8;
        assert b$reqreads#9;
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.Empty(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableImpl.IndirectionTable.Empty()
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.Empty()
   returns (this: ref
       where this != null && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable()), 
    $_reverifyPost: bool);
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#0))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#0: int :: 
              { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                { Map#Domain(graph#0)[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(graph#0)[$Box(ref#0)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#1: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#2: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                LitInt(0) <= ref#2
                     && ref#2 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#3: int :: 
              { Map#Domain(graph#0)[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(graph#0)[$Box(ref#3)]
                 ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#0: int :: 
                { Map#Domain(locs#0)[$Box(r#0)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                LitInt(0) <= r#0
                     && r#0 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                   ==> Map#Domain(locs#0)[$Box(r#0)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.Empty() returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.t: ref;
  var this.garbageQueue: ref;
  var this.refUpperBound: int;
  var this.findLoclessIterator: DatatypeType;
  var this.Repr: Set Box;
  var defass#this.t: bool;
  var $nw: ref;
  var size##0: int;
  var newtype$check#0: int;
  var key##0: int;
  var value##0: Box;
  var newtype$check#1: int;
  var $rhs#0: ref where $Is($rhs#0, Tclass.LruImpl.LruImplQueue?());
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));

    // AddMethodImpl: Empty, Impl$$IndirectionTableImpl.IndirectionTable.Empty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(114,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(114,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(115,14)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(115,17)
    // TrCallStmt: Before ProcessCallStmt
    newtype$check#0 := LitInt(128);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    size##0 := LitInt(128);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$MutableMap.ResizingHashMap.__ctor(Tclass.IndirectionTableModel.Entry(), size##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(115,51)"} true;
    this.t := $nw;
    defass#this.t := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(115,51)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(116,32)
    assume true;
    assume true;
    this.findLoclessIterator := Lit(#Options.Option.None());
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(116,38)"} true;
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(114,5)
    assert defass#this.t;
    assume !read($Heap, this, alloc);
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.t) == this.t;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)
       == this.garbageQueue;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)
       == this.refUpperBound;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)
       == this.findLoclessIterator;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(114,5)
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(119,20)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume PivotBetreeGraph.__default.Root#canCall();
    assume PivotBetreeGraph.__default.Root#canCall();
    // ProcessCallStmt: CheckSubrange
    key##0 := LitInt(PivotBetreeGraph.__default.Root());
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box(Lit(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), Lit(Seq#Empty(): Seq Box), LitInt(1))));
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(119,74)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(120,25)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
    assume true;
    $rhs#0 := null;
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(120,31)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(121,12)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    $rhs#1 := Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr));
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.Repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(121,34)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.RootOnly(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    loc#0: DatatypeType
       where $Is(loc#0, Tclass.DiskLayout.Location())
         && $IsAlloc(loc#0, Tclass.DiskLayout.Location(), $Heap)
         && $IsA#DiskLayout.Location(loc#0));
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.RootOnly(this: ref, loc#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##loc#0: DatatypeType;

    // AddMethodImpl: RootOnly, CheckWellformed$$IndirectionTableImpl.IndirectionTable.RootOnly
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(124,16): initial state"} true;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(125,15): post-state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume (forall $o: ref :: 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#0: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#0)] } 
                LitInt(0) <= ref#0
                     && ref#0 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#0)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#1: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#3: int :: 
                { Map#Domain(graph#0)[$Box(ref#3)] } 
                LitInt(0) <= ref#3
                     && ref#3 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#3)]
                   ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##loc#0 := loc#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##loc#0, Tclass.DiskLayout.Location(), $Heap);
    assume IndirectionTableModel.__default.ConstructorRootOnly#canCall(loc#0);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.ConstructorRootOnly(StartFuel_IndirectionTableModel._default.ConstructorRootOnly, loc#0));
    assume IndirectionTableModel.IndirectionTable#Equal(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
      IndirectionTableModel.__default.ConstructorRootOnly(StartFuel_IndirectionTableModel._default.ConstructorRootOnly, loc#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.RootOnly(loc#0: DatatypeType
       where $Is(loc#0, Tclass.DiskLayout.Location())
         && $IsAlloc(loc#0, Tclass.DiskLayout.Location(), $Heap)
         && $IsA#DiskLayout.Location(loc#0))
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableModel.__default.ConstructorRootOnly(StartFuel_IndirectionTableModel._default.ConstructorRootOnly, loc#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.ConstructorRootOnly#canCall(loc#0);
  ensures IndirectionTableModel.IndirectionTable#Equal(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
    IndirectionTableModel.__default.ConstructorRootOnly(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly, loc#0));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.RootOnly(loc#0: DatatypeType
       where $Is(loc#0, Tclass.DiskLayout.Location())
         && $IsAlloc(loc#0, Tclass.DiskLayout.Location(), $Heap)
         && $IsA#DiskLayout.Location(loc#0))
   returns (this: ref
       where this != null && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable()), 
    $_reverifyPost: bool);
  free requires 10 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#1))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#4: int :: 
              { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                { Map#Domain(graph#1)[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(graph#1)[$Box(ref#4)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#5: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#5)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#6: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                LitInt(0) <= ref#6
                     && ref#6 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#7: int :: 
              { Map#Domain(graph#1)[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && Map#Domain(graph#1)[$Box(ref#7)]
                 ==> ref#7 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#1: int :: 
                { Map#Domain(locs#1)[$Box(r#1)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                LitInt(0) <= r#1
                     && r#1 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                   ==> Map#Domain(locs#1)[$Box(r#1)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableModel.__default.ConstructorRootOnly(StartFuel_IndirectionTableModel._default.ConstructorRootOnly, loc#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.ConstructorRootOnly#canCall(loc#0);
  ensures IndirectionTableModel.IndirectionTable#Equal(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
    IndirectionTableModel.__default.ConstructorRootOnly(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly, loc#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.RootOnly(loc#0: DatatypeType) returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.t: ref;
  var this.garbageQueue: ref;
  var this.refUpperBound: int;
  var this.findLoclessIterator: DatatypeType;
  var this.Repr: Set Box;
  var defass#this.t: bool;
  var $nw: ref;
  var size##0: int;
  var newtype$check#0: int;
  var key##0: int;
  var value##0: Box;
  var newtype$check#1: int;
  var $rhs#0: ref where $Is($rhs#0, Tclass.LruImpl.LruImplQueue?());
  var $rhs#1: int where LitInt(0) <= $rhs#1 && $rhs#1 < 18446744073709551616;
  var $rhs#2: Set Box where $Is($rhs#2, TSet(Tclass._System.object()));

    // AddMethodImpl: RootOnly, Impl$$IndirectionTableImpl.IndirectionTable.RootOnly
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(128,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(128,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(129,14)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(129,17)
    // TrCallStmt: Before ProcessCallStmt
    newtype$check#0 := LitInt(128);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    size##0 := LitInt(128);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$MutableMap.ResizingHashMap.__ctor(Tclass.IndirectionTableModel.Entry(), size##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(129,51)"} true;
    this.t := $nw;
    defass#this.t := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(129,51)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(130,32)
    assume true;
    assume true;
    this.findLoclessIterator := Lit(#Options.Option.None());
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(130,38)"} true;
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(128,5)
    assert defass#this.t;
    assume !read($Heap, this, alloc);
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.t) == this.t;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)
       == this.garbageQueue;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)
       == this.refUpperBound;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)
       == this.findLoclessIterator;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(128,5)
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(132,20)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume PivotBetreeGraph.__default.Root#canCall();
    assume PivotBetreeGraph.__default.Root#canCall();
    // ProcessCallStmt: CheckSubrange
    key##0 := LitInt(PivotBetreeGraph.__default.Root());
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), Lit(Seq#Empty(): Seq Box), LitInt(1)));
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(132,79)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(133,25)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.garbageQueue];
    assume true;
    $rhs#0 := null;
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(133,31)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(134,26)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.refUpperBound];
    assume PivotBetreeGraph.__default.Root#canCall();
    assume PivotBetreeGraph.__default.Root#canCall();
    $rhs#1 := LitInt(PivotBetreeGraph.__default.Root());
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(134,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(135,12)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    $rhs#2 := Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
      read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr));
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.Repr, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(135,34)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(136,55)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__ConstructorRootOnly();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(136,56)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.__ctor(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap));
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableImpl.IndirectionTable.__ctor(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures read($Heap, this, IndirectionTableImpl.IndirectionTable.t) == t#0;
  free ensures true;
  ensures read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) == null;
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.__ctor(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (this: ref
       where this != null && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable()), 
    $_reverifyPost: bool);
  free requires 11 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures read($Heap, this, IndirectionTableImpl.IndirectionTable.t) == t#0;
  free ensures true;
  ensures read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) == null;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.__ctor(t#0: ref) returns (this: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var this.t: ref;
  var this.garbageQueue: ref;
  var this.refUpperBound: int;
  var this.findLoclessIterator: DatatypeType;
  var this.Repr: Set Box;
  var defass#this.t: bool;

    // AddMethodImpl: _ctor, Impl$$IndirectionTableImpl.IndirectionTable.__ctor
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(142,4): initial state"} true;
    $_reverifyPost := false;
    // ----- divided block before new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(142,5)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(143,14)
    assume true;
    assume true;
    this.t := t#0;
    defass#this.t := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(143,17)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(144,25)
    assume true;
    assume true;
    this.garbageQueue := null;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(144,31)"} true;
    // ----- new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(142,5)
    assert defass#this.t;
    assume !read($Heap, this, alloc);
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.t) == this.t;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)
       == this.garbageQueue;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)
       == this.refUpperBound;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)
       == this.findLoclessIterator;
    assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr) == this.Repr;
    $Heap := update($Heap, this, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    // ----- divided block after new; ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(142,5)
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.Clone(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (table#0: ref
       where $Is(table#0, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(table#0, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.Clone(this: ref) returns (table#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;

    // AddMethodImpl: Clone, CheckWellformed$$IndirectionTableImpl.IndirectionTable.Clone
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(147,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc table#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(150,21): post-state"} true;
    assert table#0 != null;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0);
    assert table#0 != null;
    assume (forall $o: ref :: 
      { read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
      read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assert table#0 != null;
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(table#0)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || Set#Equal(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(table#0)), 
              read($Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || !read($Heap, 
          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(table#0)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(table#0)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#0: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#0)] } 
                LitInt(0) <= ref#0
                     && ref#0 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#0)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#1: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#3: int :: 
                { Map#Domain(graph#0)[$Box(ref#3)] } 
                LitInt(0) <= ref#3
                     && ref#3 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#3)]
                   ==> ref#3
                     <= read($Heap, table#0, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, table#0);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, table#0));
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#4)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#5: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#5)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#6: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#7: int :: 
                { Map#Domain(graph#1)[$Box(ref#7)] } 
                LitInt(0) <= ref#7
                     && ref#7 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#7)]
                   ==> ref#7
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.clone#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.clone(StartFuel_IndirectionTableModel._default.clone, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
    assume IndirectionTableModel.IndirectionTable#Equal(IndirectionTableImpl.IndirectionTable.I($Heap, table#0), 
      IndirectionTableModel.__default.clone(StartFuel_IndirectionTableModel._default.clone, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.Clone(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (table#0: ref
       where $Is(table#0, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(table#0, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0);
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableImpl.IndirectionTable.I($Heap, table#0))
     && $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableModel.__default.clone(StartFuel_IndirectionTableModel._default.clone, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, table#0)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.clone#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
  ensures IndirectionTableModel.IndirectionTable#Equal(IndirectionTableImpl.IndirectionTable.I($Heap, table#0), 
    IndirectionTableModel.__default.clone(StartFuelAssert_IndirectionTableModel._default.clone, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.Clone(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (table#0: ref
       where $Is(table#0, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(table#0, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    $_reverifyPost: bool);
  free requires 13 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                 && BlockCache.__default.GraphClosed(graph#2)
                 && (forall ref#8: int :: 
                  { $Unbox(Map#Elements(graph#2)[$Box(ref#8)]): Seq Box } 
                    { Map#Domain(graph#2)[$Box(ref#8)] } 
                  LitInt(0) <= ref#8
                       && ref#8 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#8)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#8)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#9: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#9)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)] } 
                      LitInt(0) <= ref#9
                           && ref#9 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#9)])
                     && (forall ref#10: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                      LitInt(0) <= ref#10
                           && ref#10 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#10)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#11: int :: 
                  { Map#Domain(graph#2)[$Box(ref#11)] } 
                  LitInt(0) <= ref#11
                       && ref#11 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#11)]
                     ==> ref#11 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#2)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#2)[$Box(r#2)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(table#0)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || Set#Equal(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(table#0)), 
            read($Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || !read($Heap, 
        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(table#0)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(table#0)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#3))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#12: int :: 
              { $Unbox(Map#Elements(graph#3)[$Box(ref#12)]): Seq Box } 
                { Map#Domain(graph#3)[$Box(ref#12)] } 
              LitInt(0) <= ref#12
                   && ref#12 < 18446744073709551616
                   && Map#Domain(graph#3)[$Box(ref#12)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#12)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#13: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)] } 
                LitInt(0) <= ref#13
                     && ref#13 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#13)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#13)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#14: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                LitInt(0) <= ref#14
                     && ref#14 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#15: int :: 
              { Map#Domain(graph#3)[$Box(ref#15)] } 
              LitInt(0) <= ref#15
                   && ref#15 < 18446744073709551616
                   && Map#Domain(graph#3)[$Box(ref#15)]
                 ==> ref#15
                   <= read($Heap, table#0, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, table#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, table#0)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#3: int :: 
                { Map#Domain(locs#3)[$Box(r#3)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                LitInt(0) <= r#3
                     && r#3 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                   ==> Map#Domain(locs#3)[$Box(r#3)]))));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
    read($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableImpl.IndirectionTable.I($Heap, table#0))
     && $IsA#IndirectionTableModel.IndirectionTable(IndirectionTableModel.__default.clone(StartFuel_IndirectionTableModel._default.clone, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, table#0)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.clone#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
  ensures IndirectionTableModel.IndirectionTable#Equal(IndirectionTableImpl.IndirectionTable.I($Heap, table#0), 
    IndirectionTableModel.__default.clone(StartFuelAssert_IndirectionTableModel._default.clone, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.Clone(this: ref) returns (table#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#table#0: bool;
  var t0#0: ref
     where $Is(t0#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(t0#0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $nw: ref;
  var t##0: ref;
  var $rhs#0: int where LitInt(0) <= $rhs#0 && $rhs#0 < 18446744073709551616;
  var $rhs#1: DatatypeType
     where $Is($rhs#1, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));
  var $rhs#2: Set Box where $Is($rhs#2, TSet(Tclass._System.object()));

    // AddMethodImpl: Clone, Impl$$IndirectionTableImpl.IndirectionTable.Clone
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(153,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(154,29)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type ResizingHashMap<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Clone(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // TrCallStmt: After ProcessCallStmt
    t0#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(154,30)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(155,13)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(155,16)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##0 := t0#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$IndirectionTableImpl.IndirectionTable.__ctor(t##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(155,39)"} true;
    table#0 := $nw;
    defass#table#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(155,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(156,27)
    assert defass#table#0;
    assert table#0 != null;
    assume true;
    assert $_Frame[table#0, IndirectionTableImpl.IndirectionTable.refUpperBound];
    assume true;
    $rhs#0 := read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound);
    $Heap := update($Heap, table#0, IndirectionTableImpl.IndirectionTable.refUpperBound, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(156,47)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(157,33)
    assert defass#table#0;
    assert table#0 != null;
    assume true;
    assert $_Frame[table#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
    assume true;
    $rhs#1 := Lit(#Options.Option.None());
    $Heap := update($Heap, 
      table#0, 
      IndirectionTableImpl.IndirectionTable.findLoclessIterator, 
      $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(157,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(159,18)
    assert defass#table#0;
    assert table#0 != null;
    assume true;
    assert $_Frame[table#0, IndirectionTableImpl.IndirectionTable.Repr];
    assert defass#table#0;
    assert defass#table#0;
    assert table#0 != null;
    assert read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t) != null;
    assert defass#table#0;
    assert table#0 != null;
    if (read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
    {
        assert defass#table#0;
        assert table#0 != null;
        assert read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    }
    else
    {
    }

    assume true;
    $rhs#2 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(table#0)), 
        read($Heap, 
          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)), 
      (if read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         then read($Heap, 
          read($Heap, table#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)
         else Set#Empty(): Set Box));
    $Heap := update($Heap, table#0, IndirectionTableImpl.IndirectionTable.Repr, $rhs#2);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(159,113)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(160,41)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__clone();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(160,42)"} true;
    assert defass#table#0;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetEntry(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (e#0: DatatypeType
       where $Is(e#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(e#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap));
  free requires 16 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetEntry(this: ref, ref#0: int) returns (e#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##ref#0: int;

    // AddMethodImpl: GetEntry, CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetEntry
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(163,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc e#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(165,14): post-state"} true;
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.GetEntry#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
    assume Options.Option#Equal(e#0, 
      IndirectionTableModel.__default.GetEntry(StartFuel_IndirectionTableModel._default.GetEntry, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this), 
        ref#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.GetEntry(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (e#0: DatatypeType
       where $Is(e#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(e#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(e#0)
     && $IsA#Options.Option(IndirectionTableModel.__default.GetEntry(StartFuel_IndirectionTableModel._default.GetEntry, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this), 
        ref#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.GetEntry#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
  ensures Options.Option#Equal(e#0, 
    IndirectionTableModel.__default.GetEntry(StartFuelAssert_IndirectionTableModel._default.GetEntry, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.GetEntry(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (e#0: DatatypeType
       where $Is(e#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(e#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap), 
    $_reverifyPost: bool);
  free requires 16 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                 && BlockCache.__default.GraphClosed(graph#1)
                 && (forall ref#5: int :: 
                  { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                    { Map#Domain(graph#1)[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#5)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#6: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                      LitInt(0) <= ref#6
                           && ref#6 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#6)])
                     && (forall ref#7: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                      LitInt(0) <= ref#7
                           && ref#7 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#8: int :: 
                  { Map#Domain(graph#1)[$Box(ref#8)] } 
                  LitInt(0) <= ref#8
                       && ref#8 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#8)]
                     ==> ref#8 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#1: int :: 
                      { Map#Domain(locs#1)[$Box(r#1)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                      LitInt(0) <= r#1
                           && r#1 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                         ==> Map#Domain(locs#1)[$Box(r#1)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(e#0)
     && $IsA#Options.Option(IndirectionTableModel.__default.GetEntry(StartFuel_IndirectionTableModel._default.GetEntry, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this), 
        ref#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.GetEntry#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
  ensures Options.Option#Equal(e#0, 
    IndirectionTableModel.__default.GetEntry(StartFuelAssert_IndirectionTableModel._default.GetEntry, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.GetEntry(this: ref, ref#0: int) returns (e#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;

    // AddMethodImpl: GetEntry, Impl$$IndirectionTableImpl.IndirectionTable.GetEntry
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(166,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(167,44)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__GetEntry();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(167,45)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(168,22)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0);
    // TrCallStmt: After ProcessCallStmt
    e#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(168,26)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (b#0: bool);
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc(this: ref, ref#0: int) returns (b#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##ref#0: int;

    // AddMethodImpl: HasEmptyLoc, CheckWellformed$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(171,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc b#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(173,14): post-state"} true;
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.HasEmptyLoc#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
    assume b#0
       == IndirectionTableModel.__default.HasEmptyLoc(StartFuel_IndirectionTableModel._default.HasEmptyLoc, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this), 
        ref#0);
}



procedure Call$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (b#0: bool);
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.HasEmptyLoc#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
  ensures b#0
     == IndirectionTableModel.__default.HasEmptyLoc(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this), 
      ref#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (b#0: bool, $_reverifyPost: bool);
  free requires 17 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                 && BlockCache.__default.GraphClosed(graph#1)
                 && (forall ref#5: int :: 
                  { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                    { Map#Domain(graph#1)[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#5)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#6: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                      LitInt(0) <= ref#6
                           && ref#6 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#6)])
                     && (forall ref#7: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                      LitInt(0) <= ref#7
                           && ref#7 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#8: int :: 
                  { Map#Domain(graph#1)[$Box(ref#8)] } 
                  LitInt(0) <= ref#8
                       && ref#8 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#8)]
                     ==> ref#8 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#1: int :: 
                      { Map#Domain(locs#1)[$Box(r#1)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                      LitInt(0) <= r#1
                           && r#1 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                         ==> Map#Domain(locs#1)[$Box(r#1)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.HasEmptyLoc#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
  ensures b#0
     == IndirectionTableModel.__default.HasEmptyLoc(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this), 
      ref#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc(this: ref, ref#0: int) returns (b#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var entry#0: DatatypeType
     where $Is(entry#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(entry#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;

    // AddMethodImpl: HasEmptyLoc, Impl$$IndirectionTableImpl.IndirectionTable.HasEmptyLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(174,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(175,30)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0);
    // TrCallStmt: After ProcessCallStmt
    entry#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(175,34)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(176,9)
    assume true;
    if (Options.Option.Some_q(entry#0))
    {
        assert Options.Option.Some_q(entry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(entry#0)): DatatypeType);
    }

    assume Options.Option.Some_q(entry#0)
       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(entry#0)): DatatypeType);
    b#0 := Options.Option.Some_q(entry#0)
       && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(entry#0)): DatatypeType));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(176,47)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.RemoveLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap));
  free requires 18 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.RemoveLoc(this: ref, ref#0: int) returns (oldLoc#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var o#0: ref;
  var ##self#1: DatatypeType;
  var ##ref#0: int;

    // AddMethodImpl: RemoveLoc, CheckWellformed$$IndirectionTableImpl.IndirectionTable.RemoveLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(179,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#5: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#5)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#6: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#7: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { Map#Domain(graph#1)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#8)]
                   ==> ref#8 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#0)];
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldLoc#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(185,15): post-state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        if (*)
        {
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
        else
        {
            assume !(o#0 != null && !read(old($Heap), o#0, alloc));
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assume read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        }
    }
    else
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)]
           ==> (o#0 != null && !read(old($Heap), o#0, alloc))
             || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
        { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
         ==> (o#1 != null && !read(old($Heap), o#1, alloc))
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#9: int :: 
                { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                  { Map#Domain(graph#2)[$Box(ref#9)] } 
                LitInt(0) <= ref#9
                     && ref#9 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#9)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#10: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                  LitInt(0) <= ref#10
                       && ref#10 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#11: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                  LitInt(0) <= ref#11
                       && ref#11 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#12: int :: 
                { Map#Domain(graph#2)[$Box(ref#12)] } 
                LitInt(0) <= ref#12
                     && ref#12 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#12)]
                   ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#2: int :: 
                  { Map#Domain(locs#2)[$Box(r#2)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                  LitInt(0) <= r#2
                       && r#2 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                     ==> Map#Domain(locs#2)[$Box(r#2)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#3))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#13: int :: 
                { $Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box } 
                  { Map#Domain(graph#3)[$Box(ref#13)] } 
                LitInt(0) <= ref#13
                     && ref#13 < 18446744073709551616
                     && Map#Domain(graph#3)[$Box(ref#13)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#14: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                  LitInt(0) <= ref#14
                       && ref#14 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#15: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                  LitInt(0) <= ref#15
                       && ref#15 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#15)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#16: int :: 
                { Map#Domain(graph#3)[$Box(ref#16)] } 
                LitInt(0) <= ref#16
                     && ref#16 < 18446744073709551616
                     && Map#Domain(graph#3)[$Box(ref#16)]
                   ==> ref#16
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#3: int :: 
                  { Map#Domain(locs#3)[$Box(r#3)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                  LitInt(0) <= r#3
                       && r#3 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                     ==> Map#Domain(locs#3)[$Box(r#3)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#1 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#1);
    assume IndirectionTableModel.__default.Inv(##self#1);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#1)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#1)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#1));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#1);
    assert {:subsumption 0} Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#1))[$Box(##ref#0)];
    assume Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#1))[$Box(##ref#0)];
    assume IndirectionTableModel.__default.RemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.RemoveLoc(StartFuel_IndirectionTableModel._default.RemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
      IndirectionTableModel.__default.RemoveLoc(StartFuel_IndirectionTableModel._default.RemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.RemoveLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     ==> IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
       || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  requires Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#0)];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.RemoveLoc(StartFuel_IndirectionTableModel._default.RemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.RemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
    IndirectionTableModel.__default.RemoveLoc(StartFuelAssert_IndirectionTableModel._default.RemoveLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.RemoveLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap), 
    $_reverifyPost: bool);
  free requires 18 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4)
                 && BlockCache.__default.GraphClosed(graph#4)
                 && (forall ref#17: int :: 
                  { $Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box } 
                    { Map#Domain(graph#4)[$Box(ref#17)] } 
                  LitInt(0) <= ref#17
                       && ref#17 < 18446744073709551616
                       && Map#Domain(graph#4)[$Box(ref#17)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#18: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#18)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)] } 
                      LitInt(0) <= ref#18
                           && ref#18 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#18)])
                     && (forall ref#19: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                      LitInt(0) <= ref#19
                           && ref#19 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#19)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#20: int :: 
                  { Map#Domain(graph#4)[$Box(ref#20)] } 
                  LitInt(0) <= ref#20
                       && ref#20 < 18446744073709551616
                       && Map#Domain(graph#4)[$Box(ref#20)]
                     ==> ref#20 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#4: int :: 
                      { Map#Domain(locs#4)[$Box(r#4)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                      LitInt(0) <= r#4
                           && r#4 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                         ==> Map#Domain(locs#4)[$Box(r#4)])))));
  free requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && 
    IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  requires Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#0)];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#5, graph#5))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#5))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#21: int :: 
              { $Unbox(Map#Elements(graph#5)[$Box(ref#21)]): Seq Box } 
                { Map#Domain(graph#5)[$Box(ref#21)] } 
              LitInt(0) <= ref#21
                   && ref#21 < 18446744073709551616
                   && Map#Domain(graph#5)[$Box(ref#21)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#5)[$Box(ref#21)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#22: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#22)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)] } 
                LitInt(0) <= ref#22
                     && ref#22 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#22)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#23: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#23)] } 
                LitInt(0) <= ref#23
                     && ref#23 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#23)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#24: int :: 
              { Map#Domain(graph#5)[$Box(ref#24)] } 
              LitInt(0) <= ref#24
                   && ref#24 < 18446744073709551616
                   && Map#Domain(graph#5)[$Box(ref#24)]
                 ==> ref#24 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#5: int :: 
                { Map#Domain(locs#5)[$Box(r#5)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#5)] } 
                LitInt(0) <= r#5
                     && r#5 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#5)]
                   ==> Map#Domain(locs#5)[$Box(r#5)]))));
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.RemoveLoc(StartFuel_IndirectionTableModel._default.RemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.RemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
    IndirectionTableModel.__default.RemoveLoc(StartFuelAssert_IndirectionTableModel._default.RemoveLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.MutableMapModel.IteratorOutput(Ty) : Ty;

// Tclass.MutableMapModel.IteratorOutput Tag
axiom (forall MutableMapModel.IteratorOutput$V: Ty :: 
  { Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V) } 
  Tag(Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V))
     == Tagclass.MutableMapModel.IteratorOutput);

const unique Tagclass.MutableMapModel.IteratorOutput: TyTag;

// Tclass.MutableMapModel.IteratorOutput injectivity 0
axiom (forall MutableMapModel.IteratorOutput$V: Ty :: 
  { Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V) } 
  Tclass.MutableMapModel.IteratorOutput_0(Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V))
     == MutableMapModel.IteratorOutput$V);

function Tclass.MutableMapModel.IteratorOutput_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMapModel.IteratorOutput
axiom (forall MutableMapModel.IteratorOutput$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)) } 
  $IsBox(bx, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, 
        Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)));

implementation Impl$$IndirectionTableImpl.IndirectionTable.RemoveLoc(this: ref, ref#0: int) returns (oldLoc#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc($rhs##0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var key##0: int;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntry#0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##1: DatatypeType
     where $Is($rhs##1, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##1, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0: DatatypeType;
  var predCount#0: int
     where LitInt(0) <= predCount#0 && predCount#0 < 18446744073709551616;
  var succs#0: Seq Box
     where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
  var it##1: DatatypeType;
  var value##0: Box;
  var $rhs#0: DatatypeType
     where $Is($rhs#0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));
  var _v0#0: DatatypeType
     where $Is(_v0#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
          Tclass.Options.Option(Tclass.DiskLayout.Location())))
       && $IsAlloc(_v0#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
          Tclass.Options.Option(Tclass.DiskLayout.Location())), 
        $Heap);
  var ##self#2: DatatypeType;
  var ##ref#1: int;

    // AddMethodImpl: RemoveLoc, Impl$$IndirectionTableImpl.IndirectionTable.RemoveLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(188,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(189,45)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__RemoveLoc();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(189,46)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(191,33)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type SimpleIterator
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0);
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(191,37)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(192,41)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type IteratorOutput<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    it##0 := it#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$MutableMap.ResizingHashMap.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntry#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(192,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(193,21)
    assume true;
    assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    predCount#0 := IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(193,47)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(194,17)
    assume true;
    assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(194,39)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(195,21)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    it##1 := it#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0));
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.UpdateByIter(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##1, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(195,77)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(196,32)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
    assume true;
    $rhs#0 := Lit(#Options.Option.None());
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(196,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(198,14)
    assume true;
    assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    oldLoc#0 := IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(198,34)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(200,12)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
    {
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    }
    else
    {
    }

    assume true;
    $rhs#1 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)), 
      (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         then read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)
         else Set#Empty(): Set Box));
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.Repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(200,103)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(201,19)
    assume true;
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#6, graph#6))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#6))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#25: int :: 
                { $Unbox(Map#Elements(graph#6)[$Box(ref#25)]): Seq Box } 
                  { Map#Domain(graph#6)[$Box(ref#25)] } 
                LitInt(0) <= ref#25
                     && ref#25 < 18446744073709551616
                     && Map#Domain(graph#6)[$Box(ref#25)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#6)[$Box(ref#25)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#26: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#26)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)] } 
                  LitInt(0) <= ref#26
                       && ref#26 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#26)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#27: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#27)] } 
                  LitInt(0) <= ref#27
                       && ref#27 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#27)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#28: int :: 
                { Map#Domain(graph#6)[$Box(ref#28)] } 
                LitInt(0) <= ref#28
                     && ref#28 < 18446744073709551616
                     && Map#Domain(graph#6)[$Box(ref#28)]
                   ==> ref#28
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#6: int :: 
                  { Map#Domain(locs#6)[$Box(r#6)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)] } 
                  LitInt(0) <= r#6
                       && r#6 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)]
                     ==> Map#Domain(locs#6)[$Box(r#6)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#2 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#2, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#1 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#2);
    assume IndirectionTableModel.__default.Inv(##self#2);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#2)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#2)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#2));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#2);
    assert {:subsumption 0} Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#2))[$Box(##ref#1)];
    assume Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#2))[$Box(##ref#1)];
    assume IndirectionTableModel.__default.RemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.RemoveLoc(StartFuel_IndirectionTableModel._default.RemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0));
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
       && IndirectionTableModel.__default.RemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
    _v0#0 := IndirectionTableModel.__default.RemoveLoc(StartFuel_IndirectionTableModel._default.RemoveLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(201,67)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    loc#0: DatatypeType
       where $Is(loc#0, Tclass.DiskLayout.Location())
         && $IsAlloc(loc#0, Tclass.DiskLayout.Location(), $Heap)
         && $IsA#DiskLayout.Location(loc#0))
   returns (added#0: bool);
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent(this: ref, ref#0: int, loc#0: DatatypeType) returns (added#0: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var o#0: ref;
  var ##self#0: DatatypeType;
  var ##ref#0: int;
  var ##loc#0: DatatypeType;

    // AddMethodImpl: AddLocIfPresent, CheckWellformed$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(204,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc added#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(208,15): post-state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        if (*)
        {
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
        else
        {
            assume !(o#0 != null && !read(old($Heap), o#0, alloc));
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assume read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        }
    }
    else
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)]
           ==> (o#0 != null && !read(old($Heap), o#0, alloc))
             || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
        { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
         ==> (o#1 != null && !read(old($Heap), o#1, alloc))
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#5: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#5)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#6: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#7: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { Map#Domain(graph#1)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#8)]
                   ==> ref#8
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    ##loc#0 := loc#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##loc#0, Tclass.DiskLayout.Location(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.AddLocIfPresent#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, loc#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.AddLocIfPresent(StartFuel_IndirectionTableModel._default.AddLocIfPresent, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        loc#0));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(added#0)), 
      IndirectionTableModel.__default.AddLocIfPresent(StartFuel_IndirectionTableModel._default.AddLocIfPresent, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        loc#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    loc#0: DatatypeType
       where $Is(loc#0, Tclass.DiskLayout.Location())
         && $IsAlloc(loc#0, Tclass.DiskLayout.Location(), $Heap)
         && $IsA#DiskLayout.Location(loc#0))
   returns (added#0: bool);
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.AddLocIfPresent(StartFuel_IndirectionTableModel._default.AddLocIfPresent, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        loc#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.AddLocIfPresent#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, loc#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(added#0)), 
    IndirectionTableModel.__default.AddLocIfPresent(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0, 
      loc#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    loc#0: DatatypeType
       where $Is(loc#0, Tclass.DiskLayout.Location())
         && $IsAlloc(loc#0, Tclass.DiskLayout.Location(), $Heap)
         && $IsA#DiskLayout.Location(loc#0))
   returns (added#0: bool, $_reverifyPost: bool);
  free requires 19 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                 && BlockCache.__default.GraphClosed(graph#2)
                 && (forall ref#9: int :: 
                  { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                    { Map#Domain(graph#2)[$Box(ref#9)] } 
                  LitInt(0) <= ref#9
                       && ref#9 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#9)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#10: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                      LitInt(0) <= ref#10
                           && ref#10 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)])
                     && (forall ref#11: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                      LitInt(0) <= ref#11
                           && ref#11 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#12: int :: 
                  { Map#Domain(graph#2)[$Box(ref#12)] } 
                  LitInt(0) <= ref#12
                       && ref#12 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#12)]
                     ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#2)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#2)[$Box(r#2)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#3))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#13: int :: 
              { $Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box } 
                { Map#Domain(graph#3)[$Box(ref#13)] } 
              LitInt(0) <= ref#13
                   && ref#13 < 18446744073709551616
                   && Map#Domain(graph#3)[$Box(ref#13)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#14: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                LitInt(0) <= ref#14
                     && ref#14 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#14)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#15: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                LitInt(0) <= ref#15
                     && ref#15 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#15)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#16: int :: 
              { Map#Domain(graph#3)[$Box(ref#16)] } 
              LitInt(0) <= ref#16
                   && ref#16 < 18446744073709551616
                   && Map#Domain(graph#3)[$Box(ref#16)]
                 ==> ref#16 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#3: int :: 
                { Map#Domain(locs#3)[$Box(r#3)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                LitInt(0) <= r#3
                     && r#3 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                   ==> Map#Domain(locs#3)[$Box(r#3)]))));
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.AddLocIfPresent(StartFuel_IndirectionTableModel._default.AddLocIfPresent, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        loc#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.AddLocIfPresent#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, loc#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(added#0)), 
    IndirectionTableModel.__default.AddLocIfPresent(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0, 
      loc#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent(this: ref, ref#0: int, loc#0: DatatypeType)
   returns (added#0: bool, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc($rhs##0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var key##0: int;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntry#0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##1: DatatypeType
     where $Is($rhs##1, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##1, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0: DatatypeType;
  var ghosty#0_0: bool;
  var self##0_0_0_0: DatatypeType;
  var it##0_0_0_0: DatatypeType;
  var value##0_0_0_0: Box;
  var preserved##0_0_0_0: DatatypeType;
  var it##0_0: DatatypeType;
  var value##0_0: Box;
  var $rhs#0: Set Box where $Is($rhs#0, TSet(Tclass._System.object()));
  var _v1#0: DatatypeType
     where $Is(_v1#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), TBool))
       && $IsAlloc(_v1#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), TBool), 
        $Heap);
  var ##self#1: DatatypeType;
  var ##ref#1: int;
  var ##loc#1: DatatypeType;

    // AddMethodImpl: AddLocIfPresent, Impl$$IndirectionTableImpl.IndirectionTable.AddLocIfPresent
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(211,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(212,51)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__AddLocIfPresent();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(212,52)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(214,38)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type SimpleIterator
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0);
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(214,42)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(215,46)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type IteratorOutput<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    it##0 := it#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$MutableMap.ResizingHashMap.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntry#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(215,49)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(216,13)
    assume true;
    if (MutableMapModel.IteratorOutput.Next_q(oldEntry#0))
    {
        assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    }

    assume MutableMapModel.IteratorOutput.Next_q(oldEntry#0)
       ==> IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
    added#0 := MutableMapModel.IteratorOutput.Next_q(oldEntry#0)
       && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(216,57)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(218,7)
    assume true;
    if (added#0)
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(219,26)
        assume true;
        assume true;
        ghosty#0_0 := Lit(true);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(219,32)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(220,9)
        assume true;
        if (ghosty#0_0)
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(221,11)
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       then read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || !read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> Set#Disjoint(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> !read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#0_0_0, graph#0_0_0))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#0_0_0))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#0_0_0: int :: 
                        { $Unbox(Map#Elements(graph#0_0_0)[$Box(ref#0_0_0)]): Seq Box } 
                          { Map#Domain(graph#0_0_0)[$Box(ref#0_0_0)] } 
                        LitInt(0) <= ref#0_0_0
                             && ref#0_0_0 < 18446744073709551616
                             && Map#Domain(graph#0_0_0)[$Box(ref#0_0_0)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#0_0_0)[$Box(ref#0_0_0)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#0_0_1: int :: 
                          { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_1)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_1)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_1)] } 
                          LitInt(0) <= ref#0_0_1
                               && ref#0_0_1 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_1)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_1)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_1)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#0_0_2: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_2)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_2)] } 
                            { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_2)] } 
                          LitInt(0) <= ref#0_0_2
                               && ref#0_0_2 < 18446744073709551616
                               && LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_2)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_2)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_2)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#0_0_3: int :: 
                        { Map#Domain(graph#0_0_0)[$Box(ref#0_0_3)] } 
                        LitInt(0) <= ref#0_0_3
                             && ref#0_0_3 < 18446744073709551616
                             && Map#Domain(graph#0_0_0)[$Box(ref#0_0_3)]
                           ==> ref#0_0_3
                             <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#0_0_0: int :: 
                          { Map#Domain(locs#0_0_0)[$Box(r#0_0_0)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0_0)] } 
                          LitInt(0) <= r#0_0_0
                               && r#0_0_0 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0_0)]
                             ==> Map#Domain(locs#0_0_0)[$Box(r#0_0_0)]))));
            assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
               && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            if (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
            {
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(222,54)
                // TrCallStmt: Before ProcessCallStmt
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                          read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                            MutableMap.ResizingHashMap.Repr)), 
                        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                           then read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Repr)
                           else Set#Empty(): Set Box)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || !read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)[$Box(this)];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> Set#Disjoint(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Repr), 
                        read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Repr)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> !read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)[$Box(this)]);
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Lit(true));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        Lit(true)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          IndirectionTableModel.__default.ValidPredCounts(predCounts#0_0_0_0, graph#0_0_0_0))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          BlockCache.__default.GraphClosed(graph#0_0_0_0))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          (forall ref#0_0_0_0: int :: 
                            { $Unbox(Map#Elements(graph#0_0_0_0)[$Box(ref#0_0_0_0)]): Seq Box } 
                              { Map#Domain(graph#0_0_0_0)[$Box(ref#0_0_0_0)] } 
                            LitInt(0) <= ref#0_0_0_0
                                 && ref#0_0_0_0 < 18446744073709551616
                                 && Map#Domain(graph#0_0_0_0)[$Box(ref#0_0_0_0)]
                               ==> Seq#Length($Unbox(Map#Elements(graph#0_0_0_0)[$Box(ref#0_0_0_0)]): Seq Box)
                                 <= LitInt(Bounds.__default.MaxNumChildren())))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#0_0_0_1: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_1)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_1)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_1)] } 
                              LitInt(0) <= ref#0_0_0_1
                                   && ref#0_0_0_1 < 18446744073709551616
                                   && 
                                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_1)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_1)]): DatatypeType)
                                     == LitInt(0)
                                 ==> LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_1)]))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#0_0_0_2: int :: 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_2)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_2)] } 
                                { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_2)] } 
                              LitInt(0) <= ref#0_0_0_2
                                   && ref#0_0_0_2 < 18446744073709551616
                                   && LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_2)]
                                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_2)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_2)]): DatatypeType)
                                     == LitInt(0)))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                              MutableMap.ResizingHashMap.Count)
                             <= LitInt(IndirectionTableModel.__default.MaxSize()))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          (forall ref#0_0_0_3: int :: 
                            { Map#Domain(graph#0_0_0_0)[$Box(ref#0_0_0_3)] } 
                            LitInt(0) <= ref#0_0_0_3
                                 && ref#0_0_0_3 < 18446744073709551616
                                 && Map#Domain(graph#0_0_0_0)[$Box(ref#0_0_0_3)]
                               ==> ref#0_0_0_3
                                 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> (forall r#0_0_0_0: int :: 
                              { Map#Domain(locs#0_0_0_0)[$Box(r#0_0_0_0)] } 
                                { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0_0_0)] } 
                              LitInt(0) <= r#0_0_0_0
                                   && r#0_0_0_0 < 18446744073709551616
                                   && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0_0_0)]
                                 ==> Map#Domain(locs#0_0_0_0)[$Box(r#0_0_0_0)]))));
                assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
                assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
                assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                // ProcessCallStmt: CheckSubrange
                self##0_0_0_0 := IndirectionTableModel.IndirectionTable.t(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                assume true;
                // ProcessCallStmt: CheckSubrange
                it##0_0_0_0 := it#0;
                assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
                assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
                assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
                assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
                assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)
                   && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
                // ProcessCallStmt: CheckSubrange
                value##0_0_0_0 := $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), 
                    IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType), 
                    IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                          read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                            MutableMap.ResizingHashMap.Repr)), 
                        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                           then read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Repr)
                           else Set#Empty(): Set Box)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || !read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)[$Box(this)];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> Set#Disjoint(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Repr), 
                        read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Repr)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> !read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)[$Box(this)]);
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Lit(true));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        Lit(true)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          IndirectionTableModel.__default.ValidPredCounts(predCounts#0_0_0_1, graph#0_0_0_1))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          BlockCache.__default.GraphClosed(graph#0_0_0_1))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          (forall ref#0_0_0_4: int :: 
                            { $Unbox(Map#Elements(graph#0_0_0_1)[$Box(ref#0_0_0_4)]): Seq Box } 
                              { Map#Domain(graph#0_0_0_1)[$Box(ref#0_0_0_4)] } 
                            LitInt(0) <= ref#0_0_0_4
                                 && ref#0_0_0_4 < 18446744073709551616
                                 && Map#Domain(graph#0_0_0_1)[$Box(ref#0_0_0_4)]
                               ==> Seq#Length($Unbox(Map#Elements(graph#0_0_0_1)[$Box(ref#0_0_0_4)]): Seq Box)
                                 <= LitInt(Bounds.__default.MaxNumChildren())))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#0_0_0_5: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_5)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_5)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_5)] } 
                              LitInt(0) <= ref#0_0_0_5
                                   && ref#0_0_0_5 < 18446744073709551616
                                   && 
                                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_5)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_5)]): DatatypeType)
                                     == LitInt(0)
                                 ==> LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_5)]))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#0_0_0_6: int :: 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_6)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_6)] } 
                                { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_6)] } 
                              LitInt(0) <= ref#0_0_0_6
                                   && ref#0_0_0_6 < 18446744073709551616
                                   && LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#0_0_0_6)]
                                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_6)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_0_0_6)]): DatatypeType)
                                     == LitInt(0)))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                              MutableMap.ResizingHashMap.Count)
                             <= LitInt(IndirectionTableModel.__default.MaxSize()))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          (forall ref#0_0_0_7: int :: 
                            { Map#Domain(graph#0_0_0_1)[$Box(ref#0_0_0_7)] } 
                            LitInt(0) <= ref#0_0_0_7
                                 && ref#0_0_0_7 < 18446744073709551616
                                 && Map#Domain(graph#0_0_0_1)[$Box(ref#0_0_0_7)]
                               ==> ref#0_0_0_7
                                 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#0_0_0_1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#0_0_0_1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#0_0_0_1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> (forall r#0_0_0_1: int :: 
                              { Map#Domain(locs#0_0_0_1)[$Box(r#0_0_0_1)] } 
                                { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0_0_1)] } 
                              LitInt(0) <= r#0_0_0_1
                                   && r#0_0_0_1 < 18446744073709551616
                                   && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0_0_1)]
                                 ==> Map#Domain(locs#0_0_0_1)[$Box(r#0_0_0_1)]))));
                assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
                assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
                assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                assert Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
                assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                // ProcessCallStmt: CheckSubrange
                preserved##0_0_0_0 := $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(IndirectionTableImpl.IndirectionTable.I($Heap, this)))): DatatypeType;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$MutableMapModel.__default.UpdatePreservesSimpleIter(Tclass.IndirectionTableModel.Entry(), self##0_0_0_0, it##0_0_0_0, value##0_0_0_0, preserved##0_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(222,183)"} true;
            }
            else
            {
            }
        }
        else
        {
        }

        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(226,28)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_0 := it#0;
        assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
        assert MutableMapModel.IteratorOutput.Next_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)
           && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType);
        // ProcessCallStmt: CheckSubrange
        value##0_0 := $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), 
            IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType), 
            IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)));
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)[$Box($o)]
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$MutableMap.ResizingHashMap.UpdateByIter(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##0_0, value##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(226,119)"} true;
    }
    else
    {
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(229,12)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
    {
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    }
    else
    {
    }

    assume true;
    $rhs#0 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)), 
      (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         then read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)
         else Set#Empty(): Set Box));
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.Repr, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(229,103)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(230,19)
    assume true;
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#4))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#17: int :: 
                { $Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box } 
                  { Map#Domain(graph#4)[$Box(ref#17)] } 
                LitInt(0) <= ref#17
                     && ref#17 < 18446744073709551616
                     && Map#Domain(graph#4)[$Box(ref#17)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#18: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#18)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)] } 
                  LitInt(0) <= ref#18
                       && ref#18 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#18)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#19: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                  LitInt(0) <= ref#19
                       && ref#19 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#19)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#20: int :: 
                { Map#Domain(graph#4)[$Box(ref#20)] } 
                LitInt(0) <= ref#20
                     && ref#20 < 18446744073709551616
                     && Map#Domain(graph#4)[$Box(ref#20)]
                   ==> ref#20
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#4: int :: 
                  { Map#Domain(locs#4)[$Box(r#4)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                  LitInt(0) <= r#4
                       && r#4 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                     ==> Map#Domain(locs#4)[$Box(r#4)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#1 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#1 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#1, Tclass.NativeTypes.uint64(), $Heap);
    ##loc#1 := loc#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##loc#1, Tclass.DiskLayout.Location(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#1);
    assume IndirectionTableModel.__default.Inv(##self#1);
    assume IndirectionTableModel.__default.AddLocIfPresent#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, loc#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.AddLocIfPresent(StartFuel_IndirectionTableModel._default.AddLocIfPresent, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        loc#0));
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
       && IndirectionTableModel.__default.AddLocIfPresent#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, loc#0);
    _v1#0 := IndirectionTableModel.__default.AddLocIfPresent(StartFuel_IndirectionTableModel._default.AddLocIfPresent, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0, 
      loc#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(230,78)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.RemoveRef(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap));
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.RemoveRef(this: ref, ref#0: int) returns (oldLoc#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##ref#0: int;
  var o#0: ref;
  var ##self#2: DatatypeType;
  var ##ref#1: int;

    // AddMethodImpl: RemoveRef, CheckWellformed$$IndirectionTableImpl.IndirectionTable.RemoveRef
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(233,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#5: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#5)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#6: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#7: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { Map#Domain(graph#1)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#8)]
                   ==> ref#8 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#1 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    assume IndirectionTableModel.__default.deallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
    assume IndirectionTableModel.__default.deallocable(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldLoc#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(239,15): post-state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        if (*)
        {
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
        else
        {
            assume !(o#0 != null && !read(old($Heap), o#0, alloc));
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assume read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        }
    }
    else
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)]
           ==> (o#0 != null && !read(old($Heap), o#0, alloc))
             || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
        { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
         ==> (o#1 != null && !read(old($Heap), o#1, alloc))
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#9: int :: 
                { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                  { Map#Domain(graph#2)[$Box(ref#9)] } 
                LitInt(0) <= ref#9
                     && ref#9 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#9)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#10: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                  LitInt(0) <= ref#10
                       && ref#10 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#11: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                  LitInt(0) <= ref#11
                       && ref#11 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#12: int :: 
                { Map#Domain(graph#2)[$Box(ref#12)] } 
                LitInt(0) <= ref#12
                     && ref#12 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#12)]
                   ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#2: int :: 
                  { Map#Domain(locs#2)[$Box(r#2)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                  LitInt(0) <= r#2
                       && r#2 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                     ==> Map#Domain(locs#2)[$Box(r#2)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#3))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#13: int :: 
                { $Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box } 
                  { Map#Domain(graph#3)[$Box(ref#13)] } 
                LitInt(0) <= ref#13
                     && ref#13 < 18446744073709551616
                     && Map#Domain(graph#3)[$Box(ref#13)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#14: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                  LitInt(0) <= ref#14
                       && ref#14 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#15: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                  LitInt(0) <= ref#15
                       && ref#15 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#15)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#16: int :: 
                { Map#Domain(graph#3)[$Box(ref#16)] } 
                LitInt(0) <= ref#16
                     && ref#16 < 18446744073709551616
                     && Map#Domain(graph#3)[$Box(ref#16)]
                   ==> ref#16
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#3: int :: 
                  { Map#Domain(locs#3)[$Box(r#3)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                  LitInt(0) <= r#3
                       && r#3 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                     ==> Map#Domain(locs#3)[$Box(r#3)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#2 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#2, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#1 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#1, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#2);
    assume IndirectionTableModel.__default.Inv(##self#2);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#2)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#2)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#2));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#2);
    assert {:subsumption 0} IndirectionTableModel.__default.deallocable#canCall(##self#2, ##ref#1)
       ==> IndirectionTableModel.__default.deallocable(##self#2, ##ref#1)
         || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#2)))[$Box(##ref#1)];
    assert {:subsumption 0} IndirectionTableModel.__default.deallocable#canCall(##self#2, ##ref#1)
       ==> IndirectionTableModel.__default.deallocable(##self#2, ##ref#1)
         || ##ref#1 != PivotBetreeGraph.__default.Root();
    assert {:subsumption 0} IndirectionTableModel.__default.deallocable#canCall(##self#2, ##ref#1)
       ==> IndirectionTableModel.__default.deallocable(##self#2, ##ref#1)
         || (forall r#4: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#2)))[$Box(r#4)]): Seq Box } 
            { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#2)))[$Box(r#4)] } 
          LitInt(0) <= r#4
               && r#4 < 18446744073709551616
               && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#2)))[$Box(r#4)]
             ==> !Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#2)))[$Box(r#4)]): Seq Box, 
              $Box(##ref#1)));
    assume IndirectionTableModel.__default.deallocable(##self#2, ##ref#1);
    assume IndirectionTableModel.__default.RemoveRef#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.RemoveRef(StartFuel_IndirectionTableModel._default.RemoveRef, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
      IndirectionTableModel.__default.RemoveRef(StartFuel_IndirectionTableModel._default.RemoveRef, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.RemoveRef(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     ==> IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
       || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  requires IndirectionTableModel.__default.deallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
     ==> IndirectionTableModel.__default.deallocable(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
       || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#0)];
  requires IndirectionTableModel.__default.deallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
     ==> IndirectionTableModel.__default.deallocable(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
       || ref#0 != PivotBetreeGraph.__default.Root();
  requires IndirectionTableModel.__default.deallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
     ==> IndirectionTableModel.__default.deallocable(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
       || (forall r#5: int :: 
        { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#5)]): Seq Box } 
          { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#5)] } 
        LitInt(0) <= r#5
             && r#5 < 18446744073709551616
             && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#5)]
           ==> !Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#5)]): Seq Box, 
            $Box(ref#0)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.RemoveRef(StartFuel_IndirectionTableModel._default.RemoveRef, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.RemoveRef#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
    IndirectionTableModel.__default.RemoveRef(StartFuelAssert_IndirectionTableModel._default.RemoveRef, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.RemoveRef(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap), 
    $_reverifyPost: bool);
  free requires 26 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4)
                 && BlockCache.__default.GraphClosed(graph#4)
                 && (forall ref#17: int :: 
                  { $Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box } 
                    { Map#Domain(graph#4)[$Box(ref#17)] } 
                  LitInt(0) <= ref#17
                       && ref#17 < 18446744073709551616
                       && Map#Domain(graph#4)[$Box(ref#17)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#18: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#18)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)] } 
                      LitInt(0) <= ref#18
                           && ref#18 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#18)])
                     && (forall ref#19: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                      LitInt(0) <= ref#19
                           && ref#19 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#19)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#20: int :: 
                  { Map#Domain(graph#4)[$Box(ref#20)] } 
                  LitInt(0) <= ref#20
                       && ref#20 < 18446744073709551616
                       && Map#Domain(graph#4)[$Box(ref#20)]
                     ==> ref#20 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#6: int :: 
                      { Map#Domain(locs#4)[$Box(r#6)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)] } 
                      LitInt(0) <= r#6
                           && r#6 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)]
                         ==> Map#Domain(locs#4)[$Box(r#6)])))));
  free requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && 
    IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  free requires IndirectionTableModel.__default.deallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
     && 
    IndirectionTableModel.__default.deallocable(IndirectionTableImpl.IndirectionTable.I($Heap, this), ref#0)
     && 
    Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#0)]
     && ref#0 != PivotBetreeGraph.__default.Root()
     && (forall r#7: int :: 
      { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#7)]): Seq Box } 
        { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#7)] } 
      LitInt(0) <= r#7
           && r#7 < 18446744073709551616
           && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#7)]
         ==> !Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(r#7)]): Seq Box, 
          $Box(ref#0)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#5, graph#5))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#5))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#21: int :: 
              { $Unbox(Map#Elements(graph#5)[$Box(ref#21)]): Seq Box } 
                { Map#Domain(graph#5)[$Box(ref#21)] } 
              LitInt(0) <= ref#21
                   && ref#21 < 18446744073709551616
                   && Map#Domain(graph#5)[$Box(ref#21)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#5)[$Box(ref#21)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#22: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#22)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)] } 
                LitInt(0) <= ref#22
                     && ref#22 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#22)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#23: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#23)] } 
                LitInt(0) <= ref#23
                     && ref#23 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#23)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#24: int :: 
              { Map#Domain(graph#5)[$Box(ref#24)] } 
              LitInt(0) <= ref#24
                   && ref#24 < 18446744073709551616
                   && Map#Domain(graph#5)[$Box(ref#24)]
                 ==> ref#24 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#8: int :: 
                { Map#Domain(locs#5)[$Box(r#8)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#8)] } 
                LitInt(0) <= r#8
                     && r#8 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#8)]
                   ==> Map#Domain(locs#5)[$Box(r#8)]))));
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.RemoveRef(StartFuel_IndirectionTableModel._default.RemoveRef, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.RemoveRef#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
    IndirectionTableModel.__default.RemoveRef(StartFuelAssert_IndirectionTableModel._default.RemoveRef, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.LruImpl.LruImplQueue() : Ty;

// Tclass.LruImpl.LruImplQueue Tag
axiom Tag(Tclass.LruImpl.LruImplQueue()) == Tagclass.LruImpl.LruImplQueue;

const unique Tagclass.LruImpl.LruImplQueue: TyTag;

// Box/unbox axiom for Tclass.LruImpl.LruImplQueue
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.LruImpl.LruImplQueue()) } 
  $IsBox(bx, Tclass.LruImpl.LruImplQueue())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.LruImpl.LruImplQueue()));

implementation Impl$$IndirectionTableImpl.IndirectionTable.RemoveRef(this: ref, ref#0: int) returns (oldLoc#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var t##0: DatatypeType;
  var self##0: DatatypeType;
  var ref##0: int;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntry#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;
  var t##1: DatatypeType;
  var x##0: int;
  var t##2: ref;
  var q##0: ref;
  var changingRef##0: int;
  var newSuccs##0: Seq Box;
  var oldSuccs##0: Seq Box;
  var t##3: DatatypeType;
  var $rhs#0: DatatypeType
     where $Is($rhs#0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));
  var _v2#0: DatatypeType
     where $Is(_v2#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
          Tclass.Options.Option(Tclass.DiskLayout.Location())))
       && $IsAlloc(_v2#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
          Tclass.Options.Option(Tclass.DiskLayout.Location())), 
        $Heap);
  var ##self#3: DatatypeType;
  var ##ref#2: int;

    // AddMethodImpl: RemoveRef, Impl$$IndirectionTableImpl.IndirectionTable.RemoveRef
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(242,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(243,45)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__RemoveRef();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(243,46)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(245,54)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#6, graph#6))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#6))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#25: int :: 
                { $Unbox(Map#Elements(graph#6)[$Box(ref#25)]): Seq Box } 
                  { Map#Domain(graph#6)[$Box(ref#25)] } 
                LitInt(0) <= ref#25
                     && ref#25 < 18446744073709551616
                     && Map#Domain(graph#6)[$Box(ref#25)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#6)[$Box(ref#25)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#26: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#26)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)] } 
                  LitInt(0) <= ref#26
                       && ref#26 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#26)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#27: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#27)] } 
                  LitInt(0) <= ref#27
                       && ref#27 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#27)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#28: int :: 
                { Map#Domain(graph#6)[$Box(ref#28)] } 
                LitInt(0) <= ref#28
                     && ref#28 < 18446744073709551616
                     && Map#Domain(graph#6)[$Box(ref#28)]
                   ==> ref#28 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#9: int :: 
                  { Map#Domain(locs#6)[$Box(r#9)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#9)] } 
                  LitInt(0) <= r#9
                       && r#9 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#9)]
                     ==> Map#Domain(locs#6)[$Box(r#9)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    // ProcessCallStmt: CheckSubrange
    t##0 := IndirectionTableModel.IndirectionTable.t(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(245,60)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(246,48)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#7, graph#7))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#7))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#29: int :: 
                { $Unbox(Map#Elements(graph#7)[$Box(ref#29)]): Seq Box } 
                  { Map#Domain(graph#7)[$Box(ref#29)] } 
                LitInt(0) <= ref#29
                     && ref#29 < 18446744073709551616
                     && Map#Domain(graph#7)[$Box(ref#29)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#7)[$Box(ref#29)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#30: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#30)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)] } 
                  LitInt(0) <= ref#30
                       && ref#30 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#30)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#31: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#31)] } 
                  LitInt(0) <= ref#31
                       && ref#31 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#31)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#32: int :: 
                { Map#Domain(graph#7)[$Box(ref#32)] } 
                LitInt(0) <= ref#32
                     && ref#32 < 18446744073709551616
                     && Map#Domain(graph#7)[$Box(ref#32)]
                   ==> ref#32 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#10: int :: 
                  { Map#Domain(locs#7)[$Box(r#10)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#10)] } 
                  LitInt(0) <= r#10
                       && r#10 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#10)]
                     ==> Map#Domain(locs#7)[$Box(r#10)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    self##0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    assume true;
    // ProcessCallStmt: CheckSubrange
    ref##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.LemmaRemoveRefStuff(self##0, ref##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(246,57)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(248,42)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntry#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(248,46)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(250,54)
    // TrCallStmt: Before ProcessCallStmt
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // ProcessCallStmt: CheckSubrange
    t##1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(250,65)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(252,31)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    x##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             || read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$LruImpl.LruImplQueue.Remove(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), x##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(252,35)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(253,23)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##2 := read($Heap, this, IndirectionTableImpl.IndirectionTable.t);
    assume true;
    // ProcessCallStmt: CheckSubrange
    assert $Is(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
      Tclass.LruImpl.LruImplQueue());
    q##0 := read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue);
    assume true;
    // ProcessCallStmt: CheckSubrange
    changingRef##0 := ref#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    newSuccs##0 := Lit(Seq#Empty(): Seq Box);
    assert Options.Option.Some_q(oldEntry#0);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    // ProcessCallStmt: CheckSubrange
    oldSuccs##0 := IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && (read($Heap, t##2, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             || read($Heap, q##0, LruImpl.LruImplQueue.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t##2, q##0, changingRef##0, newSuccs##0, oldSuccs##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(253,80)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(255,54)
    // TrCallStmt: Before ProcessCallStmt
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // ProcessCallStmt: CheckSubrange
    t##3 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##3);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(255,65)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(257,14)
    assume true;
    if (Options.Option.Some_q(oldEntry#0))
    {
        assert Options.Option.Some_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    }
    else
    {
    }

    assume Options.Option.Some_q(oldEntry#0)
       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    oldLoc#0 := (if Options.Option.Some_q(oldEntry#0)
       then IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
       else #Options.Option.None());
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(257,67)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(258,32)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
    assume true;
    $rhs#0 := Lit(#Options.Option.None());
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(258,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(260,12)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
    {
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    }
    else
    {
    }

    assume true;
    $rhs#1 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)), 
      (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         then read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)
         else Set#Empty(): Set Box));
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.Repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(260,103)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(261,19)
    assume true;
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#8, graph#8))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#8))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#33: int :: 
                { $Unbox(Map#Elements(graph#8)[$Box(ref#33)]): Seq Box } 
                  { Map#Domain(graph#8)[$Box(ref#33)] } 
                LitInt(0) <= ref#33
                     && ref#33 < 18446744073709551616
                     && Map#Domain(graph#8)[$Box(ref#33)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#8)[$Box(ref#33)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#34: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#34)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)] } 
                  LitInt(0) <= ref#34
                       && ref#34 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#34)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#35: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#35)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#35)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#35)] } 
                  LitInt(0) <= ref#35
                       && ref#35 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#35)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#35)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#35)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#36: int :: 
                { Map#Domain(graph#8)[$Box(ref#36)] } 
                LitInt(0) <= ref#36
                     && ref#36 < 18446744073709551616
                     && Map#Domain(graph#8)[$Box(ref#36)]
                   ==> ref#36
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#11: int :: 
                  { Map#Domain(locs#8)[$Box(r#11)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#11)] } 
                  LitInt(0) <= r#11
                       && r#11 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#11)]
                     ==> Map#Domain(locs#8)[$Box(r#11)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#3 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#3, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#2 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#2, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#3);
    assume IndirectionTableModel.__default.Inv(##self#3);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#3)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#3)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#3));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#3);
    assert {:subsumption 0} IndirectionTableModel.__default.deallocable#canCall(##self#3, ##ref#2)
       ==> IndirectionTableModel.__default.deallocable(##self#3, ##ref#2)
         || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#3)))[$Box(##ref#2)];
    assert {:subsumption 0} IndirectionTableModel.__default.deallocable#canCall(##self#3, ##ref#2)
       ==> IndirectionTableModel.__default.deallocable(##self#3, ##ref#2)
         || ##ref#2 != PivotBetreeGraph.__default.Root();
    assert {:subsumption 0} IndirectionTableModel.__default.deallocable#canCall(##self#3, ##ref#2)
       ==> IndirectionTableModel.__default.deallocable(##self#3, ##ref#2)
         || (forall r#12: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#3)))[$Box(r#12)]): Seq Box } 
            { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#3)))[$Box(r#12)] } 
          LitInt(0) <= r#12
               && r#12 < 18446744073709551616
               && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#3)))[$Box(r#12)]
             ==> !Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##self#3)))[$Box(r#12)]): Seq Box, 
              $Box(##ref#2)));
    assume IndirectionTableModel.__default.deallocable(##self#3, ##ref#2);
    assume IndirectionTableModel.__default.RemoveRef#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.RemoveRef(StartFuel_IndirectionTableModel._default.RemoveRef, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0));
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
       && IndirectionTableModel.__default.RemoveRef#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0);
    _v2#0 := IndirectionTableModel.__default.RemoveRef(StartFuel_IndirectionTableModel._default.RemoveRef, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(261,67)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.PredInc(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616);
  free requires 23 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.PredInc(t#0: ref, q#0: ref, ref#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var o#0: ref;
  var o#2: ref;
  var ##t#0: DatatypeType;
  var ##q#0: Seq Box;
  var ##ref#0: int;

    // AddMethodImpl: PredInc, CheckWellformed$$IndirectionTableImpl.IndirectionTable.PredInc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(264,18): initial state"} true;
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert t#0 != null;
    newtype$check#0 := read($Heap, t#0, MutableMap.ResizingHashMap.Count);
    assert LitInt(0) <= newtype$check#0;
    assert LitInt(8) != 0;
    assume read($Heap, t#0, MutableMap.ResizingHashMap.Count)
       < Div(18446744073709551616, LitInt(8));
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assert Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType);
    newtype$check#1 := LitInt(18446744073709551615);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
       < 18446744073709551615;
    assert t#0 != null;
    assert q#0 != null;
    assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr));
    assert t#0 != null;
    assert q#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(273,12): post-state"} true;
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assert t#0 != null;
        assume read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
        if (*)
        {
            assert t#0 != null;
            assert $IsAlloc(t#0, 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assume read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
        }
        else
        {
            assume !read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
    }
    else
    {
        assume read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)]
           ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)]
             || (o#0 != null && !read(old($Heap), o#0, alloc));
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
        { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
           || (o#1 != null && !read(old($Heap), o#1, alloc)));
    havoc o#2;
    assume $Is(o#2, Tclass._System.object());
    if (*)
    {
        assert q#0 != null;
        assume read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
        if (*)
        {
            assert q#0 != null;
            assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
            assume read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
        }
        else
        {
            assume !read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
            assume o#2 != null && !read(old($Heap), o#2, alloc);
        }
    }
    else
    {
        assume read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)]
           ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)]
             || (o#2 != null && !read(old($Heap), o#2, alloc));
    }

    assume (forall o#3: ref :: 
      { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
        { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      $Is(o#3, Tclass._System.object())
           && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
           || (o#3 != null && !read(old($Heap), o#3, alloc)));
    assert t#0 != null;
    assert q#0 != null;
    assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr));
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assert q#0 != null;
    assert t#0 != null;
    assert $IsAlloc(t#0, 
      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
      old($Heap));
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
    assert q#0 != null;
    assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
    ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $Heap);
    ##q#0 := read(old($Heap), q#0, LruImpl.LruImplQueue.Queue);
    // assume allocatedness for argument to function
    assume $IsAlloc(##q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#0)
       < Div(18446744073709551616, LitInt(8));
    assume MutableMapModel.LinearHashMap.count(##t#0)
       < Div(18446744073709551616, LitInt(8));
    assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)];
    assume Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)];
    assert {:subsumption 0} IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)]): DatatypeType)
       < 18446744073709551615;
    assume IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)]): DatatypeType)
       < 18446744073709551615;
    assume IndirectionTableModel.__default.PredInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.PredInc(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
        $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
      IndirectionTableModel.__default.PredInc(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.PredInc(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616);
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires LruImpl.LruImplQueue.Inv($Heap, q#0);
  requires read($Heap, t#0, MutableMap.ResizingHashMap.Count)
     < Div(18446744073709551616, LitInt(8));
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
  requires IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
     < 18446744073709551615;
  requires Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
       ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures true;
  ensures (forall o#3: ref :: 
    { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
    $Is(o#3, Tclass._System.object())
         && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
       ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         || (o#3 != null && !read(old($Heap), o#3, alloc)));
  free ensures true;
  ensures Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free ensures MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  ensures MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.PredInc(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
     && IndirectionTableModel.__default.PredInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
    IndirectionTableModel.__default.PredInc(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.PredInc(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 23 == $FunctionContextHeight;
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires LruImpl.LruImplQueue.Inv($Heap, q#0);
  requires read($Heap, t#0, MutableMap.ResizingHashMap.Count)
     < Div(18446744073709551616, LitInt(8));
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
  requires IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
     < 18446744073709551615;
  requires Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
       ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures true;
  ensures (forall o#3: ref :: 
    { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
    $Is(o#3, Tclass._System.object())
         && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
       ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         || (o#3 != null && !read(old($Heap), o#3, alloc)));
  free ensures true;
  ensures Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free ensures MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  ensures MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.PredInc(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
     && IndirectionTableModel.__default.PredInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
    IndirectionTableModel.__default.PredInc(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.PredInc(t#0: ref, q#0: ref, ref#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var oldEntryOpt#0: DatatypeType
     where $Is(oldEntryOpt#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntryOpt#0, 
        Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, Tclass.IndirectionTableModel.Entry())
       && $IsAlloc(oldEntry#0, Tclass.IndirectionTableModel.Entry(), $Heap);
  var newEntry#0: DatatypeType
     where $Is(newEntry#0, Tclass.IndirectionTableModel.Entry())
       && $IsAlloc(newEntry#0, Tclass.IndirectionTableModel.Entry(), $Heap);
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#predCount#0#0: int;
  var let#1#0#0: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var key##1: int;
  var value##0: Box;
  var newtype$check#4: int;
  var x##0_0: int;

    // AddMethodImpl: PredInc, Impl$$IndirectionTableImpl.IndirectionTable.PredInc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(279,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(280,31)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), t#0, key##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntryOpt#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(280,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(281,20)
    assume true;
    assert Options.Option.Some_q(oldEntryOpt#0);
    assume true;
    oldEntry#0 := $Unbox(Options.Option.value(oldEntryOpt#0)): DatatypeType;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(281,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(282,20)
    assume true;
    havoc dt_update_tmp#0#0;
    assume $Is(dt_update_tmp#0#0, Tclass.IndirectionTableModel.Entry());
    assume let#0#0#0 == oldEntry#0;
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#0#0#0, Tclass.IndirectionTableModel.Entry());
    assume dt_update_tmp#0#0 == let#0#0#0;
    havoc dt_update#predCount#0#0;
    assume LitInt(0) <= dt_update#predCount#0#0
       && dt_update#predCount#0#0 < 18446744073709551616;
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    newtype$check#2 := LitInt(1);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := IndirectionTableModel.Entry.predCount(oldEntry#0) + 1;
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume let#1#0#0 == IndirectionTableModel.Entry.predCount(oldEntry#0) + 1;
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    // CheckWellformedWithResult: any expression
    assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
    assume dt_update#predCount#0#0 == let#1#0#0;
    assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0);
    assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0);
    assume (var dt_update_tmp#0#1 := oldEntry#0; 
      IndirectionTableModel.Entry.Entry_q(oldEntry#0)
         && 
        IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
         && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1));
    newEntry#0 := (var dt_update_tmp#0#1 := oldEntry#0; 
      (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount(oldEntry#0) + 1; 
        #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
          IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
          dt_update#predCount#0#1)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(282,68)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(283,15)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##1 := ref#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box(newEntry#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), t#0, key##1, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(283,29)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(284,7)
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    newtype$check#4 := LitInt(0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    if (IndirectionTableModel.Entry.predCount(oldEntry#0) == LitInt(0))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(285,17)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert q#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        x##0_0 := ref#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == q#0 || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$LruImpl.LruImplQueue.Remove(q#0, x##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(285,21)"} true;
    }
    else
    {
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.PredDec(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616);
  free requires 24 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.PredDec(t#0: ref, q#0: ref, ref#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var newtype$check#1: int;
  var ##q#0: Seq Box;
  var o#0: ref;
  var o#2: ref;
  var ##t#0: DatatypeType;
  var ##q#1: Seq Box;
  var ##ref#0: int;

    // AddMethodImpl: PredDec, CheckWellformed$$IndirectionTableImpl.IndirectionTable.PredDec
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(289,18): initial state"} true;
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert t#0 != null;
    newtype$check#0 := read($Heap, t#0, MutableMap.ResizingHashMap.Count);
    assert LitInt(0) <= newtype$check#0;
    assert LitInt(8) != 0;
    assume read($Heap, t#0, MutableMap.ResizingHashMap.Count)
       < Div(18446744073709551616, LitInt(8));
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assert Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType);
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
       > 0;
    assert t#0 != null;
    assert q#0 != null;
    assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr));
    assert q#0 != null;
    ##q#0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
    // assume allocatedness for argument to function
    assume $IsAlloc(##q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    assume LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue));
    assume Set#Card(LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue)))
       <= LitInt(4294967296);
    assert t#0 != null;
    assert q#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(299,12): post-state"} true;
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assert t#0 != null;
        assume read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
        if (*)
        {
            assert t#0 != null;
            assert $IsAlloc(t#0, 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assume read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
        }
        else
        {
            assume !read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
    }
    else
    {
        assume read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)]
           ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)]
             || (o#0 != null && !read(old($Heap), o#0, alloc));
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
        { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
           || (o#1 != null && !read(old($Heap), o#1, alloc)));
    havoc o#2;
    assume $Is(o#2, Tclass._System.object());
    if (*)
    {
        assert q#0 != null;
        assume read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
        if (*)
        {
            assert q#0 != null;
            assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
            assume read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
        }
        else
        {
            assume !read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
            assume o#2 != null && !read(old($Heap), o#2, alloc);
        }
    }
    else
    {
        assume read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)]
           ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)]
             || (o#2 != null && !read(old($Heap), o#2, alloc));
    }

    assume (forall o#3: ref :: 
      { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
        { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      $Is(o#3, Tclass._System.object())
           && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
           || (o#3 != null && !read(old($Heap), o#3, alloc)));
    assert t#0 != null;
    assert q#0 != null;
    assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr));
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assert q#0 != null;
    assert t#0 != null;
    assert $IsAlloc(t#0, 
      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
      old($Heap));
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
    assert q#0 != null;
    assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
    ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $Heap);
    ##q#1 := read(old($Heap), q#0, LruImpl.LruImplQueue.Queue);
    // assume allocatedness for argument to function
    assume $IsAlloc(##q#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#0)
       < Div(18446744073709551616, LitInt(8));
    assume MutableMapModel.LinearHashMap.count(##t#0)
       < Div(18446744073709551616, LitInt(8));
    assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)];
    assume Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)];
    assert {:subsumption 0} IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)]): DatatypeType)
       > 0;
    assume IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(##ref#0)]): DatatypeType)
       > 0;
    assume IndirectionTableModel.__default.PredDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.PredDec(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
        $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
      IndirectionTableModel.__default.PredDec(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.PredDec(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616);
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires LruImpl.LruImplQueue.Inv($Heap, q#0);
  requires read($Heap, t#0, MutableMap.ResizingHashMap.Count)
     < Div(18446744073709551616, LitInt(8));
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
  requires IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
     > 0;
  requires Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  requires Set#Card(LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue)))
     <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
       ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures true;
  ensures (forall o#3: ref :: 
    { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
    $Is(o#3, Tclass._System.object())
         && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
       ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         || (o#3 != null && !read(old($Heap), o#3, alloc)));
  free ensures true;
  ensures Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free ensures MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  ensures MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.PredDec(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
     && IndirectionTableModel.__default.PredDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
    IndirectionTableModel.__default.PredDec(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.PredDec(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 24 == $FunctionContextHeight;
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires LruImpl.LruImplQueue.Inv($Heap, q#0);
  requires read($Heap, t#0, MutableMap.ResizingHashMap.Count)
     < Div(18446744073709551616, LitInt(8));
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
  requires IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
     > 0;
  requires Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  requires Set#Card(LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue)))
     <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
       ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures true;
  ensures (forall o#3: ref :: 
    { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
    $Is(o#3, Tclass._System.object())
         && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
       ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         || (o#3 != null && !read(old($Heap), o#3, alloc)));
  free ensures true;
  ensures Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free ensures MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  ensures MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.PredDec(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        ref#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
     && IndirectionTableModel.__default.PredDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
    IndirectionTableModel.__default.PredDec(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      ref#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.PredDec(t#0: ref, q#0: ref, ref#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var oldEntryOpt#0: DatatypeType
     where $Is(oldEntryOpt#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntryOpt#0, 
        Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, Tclass.IndirectionTableModel.Entry())
       && $IsAlloc(oldEntry#0, Tclass.IndirectionTableModel.Entry(), $Heap);
  var newEntry#0: DatatypeType
     where $Is(newEntry#0, Tclass.IndirectionTableModel.Entry())
       && $IsAlloc(newEntry#0, Tclass.IndirectionTableModel.Entry(), $Heap);
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#predCount#0#0: int;
  var let#1#0#0: int;
  var newtype$check#2: int;
  var newtype$check#3: int;
  var key##1: int;
  var value##0: Box;
  var newtype$check#4: int;
  var x##0_0: int;

    // AddMethodImpl: PredDec, Impl$$IndirectionTableImpl.IndirectionTable.PredDec
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(305,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(306,31)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), t#0, key##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntryOpt#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(306,35)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(307,20)
    assume true;
    assert Options.Option.Some_q(oldEntryOpt#0);
    assume true;
    oldEntry#0 := $Unbox(Options.Option.value(oldEntryOpt#0)): DatatypeType;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(307,39)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(308,20)
    assume true;
    havoc dt_update_tmp#0#0;
    assume $Is(dt_update_tmp#0#0, Tclass.IndirectionTableModel.Entry());
    assume let#0#0#0 == oldEntry#0;
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#0#0#0, Tclass.IndirectionTableModel.Entry());
    assume dt_update_tmp#0#0 == let#0#0#0;
    havoc dt_update#predCount#0#0;
    assume LitInt(0) <= dt_update#predCount#0#0
       && dt_update#predCount#0#0 < 18446744073709551616;
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    newtype$check#2 := LitInt(1);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    newtype$check#3 := IndirectionTableModel.Entry.predCount(oldEntry#0) - 1;
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume let#1#0#0 == IndirectionTableModel.Entry.predCount(oldEntry#0) - 1;
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    // CheckWellformedWithResult: any expression
    assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
    assume dt_update#predCount#0#0 == let#1#0#0;
    assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0);
    assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0);
    assume (var dt_update_tmp#0#1 := oldEntry#0; 
      IndirectionTableModel.Entry.Entry_q(oldEntry#0)
         && 
        IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
         && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1));
    newEntry#0 := (var dt_update_tmp#0#1 := oldEntry#0; 
      (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount(oldEntry#0) - 1; 
        #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
          IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
          dt_update#predCount#0#1)));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(308,68)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(309,15)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##1 := ref#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box(newEntry#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), t#0, key##1, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(309,29)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(310,7)
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    newtype$check#4 := LitInt(1);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume IndirectionTableModel.Entry.Entry_q(oldEntry#0);
    if (IndirectionTableModel.Entry.predCount(oldEntry#0) == LitInt(1))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(311,14)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert q#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        x##0_0 := ref#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == q#0 || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$LruImpl.LruImplQueue.Use(q#0, x##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(311,18)"} true;
    }
    else
    {
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  free requires 25 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t#0: ref, q#0: ref, changingRef#0: int, newSuccs#0: Seq Box, oldSuccs#0: Seq Box)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##t#0: DatatypeType;
  var ##q#0: Seq Box;
  var ##changingRef#0: int;
  var ##newSuccs#0: Seq Box;
  var ##oldSuccs#0: Seq Box;
  var ##newIdx#0: int;
  var ##oldIdx#0: int;
  var o#0: ref;
  var o#2: ref;
  var newtype$check#0: int;
  var ##t#1: DatatypeType;
  var ##q#1: Seq Box;
  var ##changingRef#1: int;
  var ##newSuccs#1: Seq Box;
  var ##oldSuccs#1: Seq Box;
  var ##idx#0: int;

    // AddMethodImpl: UpdatePredCounts, CheckWellformed$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(315,18): initial state"} true;
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert t#0 != null;
    assert q#0 != null;
    assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr));
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assert q#0 != null;
    ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $Heap);
    ##q#0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
    // assume allocatedness for argument to function
    assume $IsAlloc(##q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##changingRef#0 := changingRef#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##changingRef#0, Tclass.NativeTypes.uint64(), $Heap);
    ##newSuccs#0 := newSuccs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##oldSuccs#0 := oldSuccs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##newIdx#0 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##newIdx#0, TInt, $Heap);
    ##oldIdx#0 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##oldIdx#0, TInt, $Heap);
    assume IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0));
    assume IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0));
    assert t#0 != null;
    assert q#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || 
          read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(323,12): post-state"} true;
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assert t#0 != null;
        assume read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
        if (*)
        {
            assert t#0 != null;
            assert $IsAlloc(t#0, 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assume read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
        }
        else
        {
            assume !read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)];
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
    }
    else
    {
        assume read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)]
           ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#0)]
             || (o#0 != null && !read(old($Heap), o#0, alloc));
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
        { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
           || (o#1 != null && !read(old($Heap), o#1, alloc)));
    havoc o#2;
    assume $Is(o#2, Tclass._System.object());
    if (*)
    {
        assert q#0 != null;
        assume read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
        if (*)
        {
            assert q#0 != null;
            assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
            assume read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
        }
        else
        {
            assume !read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)];
            assume o#2 != null && !read(old($Heap), o#2, alloc);
        }
    }
    else
    {
        assume read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)]
           ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#2)]
             || (o#2 != null && !read(old($Heap), o#2, alloc));
    }

    assume (forall o#3: ref :: 
      { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
        { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      $Is(o#3, Tclass._System.object())
           && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
           || (o#3 != null && !read(old($Heap), o#3, alloc)));
    assert t#0 != null;
    assert q#0 != null;
    assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr));
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assert q#0 != null;
    assert t#0 != null;
    assert $IsAlloc(t#0, 
      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
      old($Heap));
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
    assert q#0 != null;
    assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    ##t#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#1, 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $Heap);
    ##q#1 := read(old($Heap), q#0, LruImpl.LruImplQueue.Queue);
    // assume allocatedness for argument to function
    assume $IsAlloc(##q#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##changingRef#1 := changingRef#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##changingRef#1, Tclass.NativeTypes.uint64(), $Heap);
    ##newSuccs#1 := newSuccs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##newSuccs#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##oldSuccs#1 := oldSuccs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##oldSuccs#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##idx#0 := LitInt(0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##idx#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#1);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (LruModel.__default.WF#canCall(##q#1)
           ==> LruModel.__default.WF(##q#1)
             || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, ##q#1));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || MutableMapModel.LinearHashMap.count(##t#1)
           <= LitInt(IndirectionTableModel.__default.MaxSize());
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || Seq#Length(##oldSuccs#1) <= LitInt(Bounds.__default.MaxNumChildren());
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || Seq#Length(##newSuccs#1) <= LitInt(Bounds.__default.MaxNumChildren());
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (forall ref#0: int :: 
          { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#0)]): Seq Box } 
            { Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#0)] } 
          LitInt(0) <= ref#0
               && ref#0 < 18446744073709551616
               && Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#0)]
             ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#0)]): Seq Box)
               <= LitInt(Bounds.__default.MaxNumChildren()));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || LitInt(0) <= ##idx#0;
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || ##idx#0 <= Seq#Length(##newSuccs#1);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || LitInt(0) <= LitInt(0);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || LitInt(0) <= Seq#Length(##oldSuccs#1);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(##changingRef#1)]
           ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#1))[$Box(##changingRef#1)]): Seq Box, 
            ##newSuccs#1));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (!Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(##changingRef#1)]
           ==> Seq#Equal(##newSuccs#1, Seq#Empty(): Seq Box));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(##t#1), 
            IndirectionTableModel.__default.Graph(##t#1), 
            ##newSuccs#1, 
            ##oldSuccs#1, 
            ##idx#0, 
            LitInt(0))
           ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(##t#1), 
            IndirectionTableModel.__default.Graph(##t#1), 
            ##newSuccs#1, 
            ##oldSuccs#1, 
            ##idx#0, 
            LitInt(0)));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (forall j#0: int :: 
          { $Unbox(Seq#Index(##oldSuccs#1, j#0)): int } 
          LitInt(0) <= j#0 && j#0 < Seq#Length(##oldSuccs#1)
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[Seq#Index(##oldSuccs#1, j#0)]);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(##t#1))
           ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(##t#1))
             || (forall ref#1: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#1)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#1)]
                 ==> (forall succ#0: int :: 
                  { Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(succ#0)] } 
                    { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#1)]): Seq Box, 
                      $Box(succ#0)) } 
                  LitInt(0) <= succ#0
                       && succ#0 < 18446744073709551616
                       && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#1))[$Box(ref#1)]): Seq Box, 
                        $Box(succ#0))
                     ==> Map#Domain(IndirectionTableModel.__default.Graph(##t#1))[$Box(succ#0)])));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (forall ref#2: int :: 
          { LruModel.__default.I(##q#1)[$Box(ref#2)] } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#2)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#2)] } 
          LitInt(0) <= ref#2
               && ref#2 < 18446744073709551616
               && 
              Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#2)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#2)]): DatatypeType)
                 == LitInt(0)
             ==> LruModel.__default.I(##q#1)[$Box(ref#2)]);
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || (forall ref#3: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#3)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#3)] } 
            { LruModel.__default.I(##q#1)[$Box(ref#3)] } 
          LitInt(0) <= ref#3
               && ref#3 < 18446744073709551616
               && LruModel.__default.I(##q#1)[$Box(ref#3)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#3)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#3)]): DatatypeType)
                 == LitInt(0));
    assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#1, ##q#1, ##changingRef#1, ##newSuccs#1, ##oldSuccs#1, ##idx#0, LitInt(0))
       ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          ##t#1, 
          ##q#1, 
          ##changingRef#1, 
          ##newSuccs#1, 
          ##oldSuccs#1, 
          ##idx#0, 
          LitInt(0))
         || Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(PivotBetreeGraph.__default.Root())];
    assume IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
      ##t#1, 
      ##q#1, 
      ##changingRef#1, 
      ##newSuccs#1, 
      ##oldSuccs#1, 
      ##idx#0, 
      LitInt(0));
    assume IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0));
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0)));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
        $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
      IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0)));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires LruImpl.LruImplQueue.Inv($Heap, q#0);
  requires Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (LruModel.__default.WF#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
         ==> LruModel.__default.WF(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
           || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue)));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
         <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (forall ref#4: int :: 
        { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#4)]): Seq Box } 
          { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#4)] } 
        LitInt(0) <= ref#4
             && ref#4 < 18446744073709551616
             && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#4)]
           ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#4)]): Seq Box)
             <= LitInt(Bounds.__default.MaxNumChildren()));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || LitInt(0) <= LitInt(0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || LitInt(0) <= Seq#Length(newSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || LitInt(0) <= LitInt(0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || LitInt(0) <= Seq#Length(oldSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
         ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]): Seq Box, 
          newSuccs#0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (!Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
         ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
          IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
          newSuccs#0, 
          oldSuccs#0, 
          LitInt(0), 
          LitInt(0))
         ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
            IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0), 
            LitInt(0))
           || (forall ref#5: int :: 
            { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#5, 0) } 
              { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#5, 0) } 
              { IndirectionTableModel.__default.IsRoot(ref#5) } 
              { IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
                ref#5) } 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#5)]): int } 
              { Map#Domain(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#5)] } 
            LitInt(0) <= ref#5
                 && ref#5 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#5)]
               ==> $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#5)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
                          ref#5))
                       + IndirectionTableModel.__default.IsRoot(ref#5)
                     - IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#5, LitInt(0))
                   + IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#5, LitInt(0))));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (forall j#1: int :: 
        { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
        LitInt(0) <= j#1 && j#1 < Seq#Length(oldSuccs#0)
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[Seq#Index(oldSuccs#0, j#1)]);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
         ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
           || (forall ref#6: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#6)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#6)] } 
            LitInt(0) <= ref#6
                 && ref#6 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#6)]
               ==> (forall succ#1: int :: 
                { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(succ#1)] } 
                  { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#6)]): Seq Box, 
                    $Box(succ#1)) } 
                LitInt(0) <= succ#1
                     && succ#1 < 18446744073709551616
                     && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#6)]): Seq Box, 
                      $Box(succ#1))
                   ==> Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(succ#1)])));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (forall ref#7: int :: 
        { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#7)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#7)] } 
        LitInt(0) <= ref#7
             && ref#7 < 18446744073709551616
             && 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#7)]
             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#7)]): DatatypeType)
               == LitInt(0)
           ==> LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#7)]);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || (forall ref#8: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#8)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#8)] } 
          { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#8)] } 
        LitInt(0) <= ref#8
             && ref#8 < 18446744073709551616
             && LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#8)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#8)]
             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#8)]): DatatypeType)
               == LitInt(0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
        read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0), 
        LitInt(0))
       || Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
       ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures true;
  ensures (forall o#3: ref :: 
    { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
    $Is(o#3, Tclass._System.object())
         && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
       ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         || (o#3 != null && !read(old($Heap), o#3, alloc)));
  free ensures true;
  ensures Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free ensures MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  ensures MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0)))
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
     && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
    IndirectionTableModel.__default.UpdatePredCountsInc($LS($LS($LZ)), 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 25 == $FunctionContextHeight;
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires LruImpl.LruImplQueue.Inv($Heap, q#0);
  requires Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     && 
    IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
      read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     && 
    MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
     && LruModel.__default.WF(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
     && MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
       <= LitInt(IndirectionTableModel.__default.MaxSize())
     && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
     && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
     && (forall ref#9: int :: 
      { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#9)]): Seq Box } 
        { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#9)] } 
      LitInt(0) <= ref#9
           && ref#9 < 18446744073709551616
           && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#9)]
         ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#9)]): Seq Box)
           <= LitInt(Bounds.__default.MaxNumChildren()))
     && 
    LitInt(0) <= LitInt(0)
     && LitInt(0) <= Seq#Length(newSuccs#0)
     && 
    LitInt(0) <= LitInt(0)
     && LitInt(0) <= Seq#Length(oldSuccs#0)
     && (Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
       ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]): Seq Box, 
        newSuccs#0))
     && (!Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
       ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
     && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0), 
      LitInt(0))
     && (forall j#2: int :: 
      { $Unbox(Seq#Index(oldSuccs#0, j#2)): int } 
      LitInt(0) <= j#2 && j#2 < Seq#Length(oldSuccs#0)
         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[Seq#Index(oldSuccs#0, j#2)])
     && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
     && (forall ref#12: int :: 
      { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#12)] } 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#12)]): DatatypeType } 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#12)] } 
      LitInt(0) <= ref#12
           && ref#12 < 18446744073709551616
           && 
          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#12)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#12)]): DatatypeType)
             == LitInt(0)
         ==> LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#12)])
     && (forall ref#13: int :: 
      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#13)]): DatatypeType } 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#13)] } 
        { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#13)] } 
      LitInt(0) <= ref#13
           && ref#13 < 18446744073709551616
           && LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#13)]
         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#13)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#13)]): DatatypeType)
             == LitInt(0))
     && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
      { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
       ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#1)]
         || (o#1 != null && !read(old($Heap), o#1, alloc)));
  free ensures true;
  ensures (forall o#3: ref :: 
    { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)] } 
    $Is(o#3, Tclass._System.object())
         && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
       ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#3)]
         || (o#3 != null && !read(old($Heap), o#3, alloc)));
  free ensures true;
  ensures Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr));
  free ensures MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  ensures MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
        read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        LitInt(0)))
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && 
    MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
     && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
      $Box(read($Heap, q#0, LruImpl.LruImplQueue.Queue))), 
    IndirectionTableModel.__default.UpdatePredCountsInc($LS($LS($LZ)), 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
      read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      LitInt(0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t#0: ref, q#0: ref, changingRef#0: int, newSuccs#0: Seq Box, oldSuccs#0: Seq Box)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var idx#0: int where LitInt(0) <= idx#0 && idx#0 < 18446744073709551616;
  var newtype$check#1: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var o#4: ref;
  var o#6: ref;
  var ##t#2: DatatypeType;
  var ##q#2: Seq Box;
  var ##changingRef#2: int;
  var ##newSuccs#2: Seq Box;
  var ##oldSuccs#2: Seq Box;
  var ##newIdx#1: int;
  var ##oldIdx#1: int;
  var newtype$check#2: int;
  var ##t#3: DatatypeType;
  var ##q#3: Seq Box;
  var ##changingRef#3: int;
  var ##newSuccs#3: Seq Box;
  var ##oldSuccs#3: Seq Box;
  var ##idx#1: int;
  var ##t#4: DatatypeType;
  var ##q#4: Seq Box;
  var ##changingRef#4: int;
  var ##newSuccs#4: Seq Box;
  var ##oldSuccs#4: Seq Box;
  var ##idx#2: int;
  var newtype$check#3: int;
  var $decr$loop#00: int;
  var t##0_0: DatatypeType;
  var q##0_0: Seq Box;
  var changingRef##0_0: int;
  var newSuccs##0_0: Seq Box;
  var oldSuccs##0_0: Seq Box;
  var idx##0_0: int;
  var t##0_1: ref;
  var q##0_1: ref;
  var ref##0_0: int;
  var newtype$check#0_0: int;
  var newtype$check#0_1: int;
  var idx2#0: int where LitInt(0) <= idx2#0 && idx2#0 < 18446744073709551616;
  var newtype$check#4: int;
  var $PreLoopHeap$loop#1: Heap;
  var $decr_init$loop#10: int;
  var $w$loop#1: bool;
  var o#8: ref;
  var o#10: ref;
  var ##t#5: DatatypeType;
  var ##q#5: Seq Box;
  var ##changingRef#5: int;
  var ##newSuccs#5: Seq Box;
  var ##oldSuccs#5: Seq Box;
  var ##newIdx#2: int;
  var ##oldIdx#2: int;
  var newtype$check#5: int;
  var ##t#6: DatatypeType;
  var ##q#6: Seq Box;
  var ##changingRef#6: int;
  var ##newSuccs#6: Seq Box;
  var ##oldSuccs#6: Seq Box;
  var ##idx#3: int;
  var ##t#7: DatatypeType;
  var ##q#7: Seq Box;
  var ##changingRef#7: int;
  var ##newSuccs#7: Seq Box;
  var ##oldSuccs#7: Seq Box;
  var ##idx#4: int;
  var newtype$check#6: int;
  var $decr$loop#10: int;
  var t##1_0: DatatypeType;
  var q##1_0: Seq Box;
  var changingRef##1_0: int;
  var newSuccs##1_0: Seq Box;
  var oldSuccs##1_0: Seq Box;
  var idx##1_0: int;
  var t##1_1: ref;
  var q##1_1: ref;
  var ref##1_0: int;
  var newtype$check#1_0: int;
  var newtype$check#1_1: int;

    // AddMethodImpl: UpdatePredCounts, Impl$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
           || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(329,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(330,23)
    assume true;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    idx#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(330,26)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(332,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(newSuccs#0) - idx#0;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall o#5: ref :: 
          { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)] } 
            { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)] } 
          $Is(o#5, Tclass._System.object())
               && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)]
             ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)]
               || (o#5 != null && !read(old($Heap), o#5, alloc)));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall o#7: ref :: 
          { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)] } 
            { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)] } 
          $Is(o#7, Tclass._System.object())
               && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)]
             ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)]
               || (o#7 != null && !read(old($Heap), o#7, alloc)));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
          read($Heap, q#0, LruImpl.LruImplQueue.Repr));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
      invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
      free invariant $w$loop#0 ==> LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
      invariant $w$loop#0 ==> LruImpl.LruImplQueue.Inv($Heap, q#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (LruModel.__default.WF#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
             ==> LruModel.__default.WF(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
               || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue)));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize());
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (forall ref#14: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)] } 
            LitInt(0) <= ref#14
                 && ref#14 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)]
               ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)]): Seq Box)
                 <= LitInt(Bounds.__default.MaxNumChildren()));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || LitInt(0) <= idx#0;
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || idx#0 <= Seq#Length(newSuccs#0);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || LitInt(0) <= LitInt(0);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || LitInt(0) <= Seq#Length(oldSuccs#0);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]): Seq Box, 
              newSuccs#0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (!Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0, 
              LitInt(0))
             ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0, 
              LitInt(0)));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (forall j#3: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#3)): int } 
            LitInt(0) <= j#3 && j#3 < Seq#Length(oldSuccs#0)
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[Seq#Index(oldSuccs#0, j#3)]);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
             ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
               || (forall ref#15: int :: 
                { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#15)]): Seq Box } 
                  { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#15)] } 
                LitInt(0) <= ref#15
                     && ref#15 < 18446744073709551616
                     && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#15)]
                   ==> (forall succ#3: int :: 
                    { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(succ#3)] } 
                      { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#15)]): Seq Box, 
                        $Box(succ#3)) } 
                    LitInt(0) <= succ#3
                         && succ#3 < 18446744073709551616
                         && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#15)]): Seq Box, 
                          $Box(succ#3))
                       ==> Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(succ#3)])));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (forall ref#16: int :: 
            { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#16)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)] } 
            LitInt(0) <= ref#16
                 && ref#16 < 18446744073709551616
                 && 
                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)]): DatatypeType)
                   == LitInt(0)
               ==> LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#16)]);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (forall ref#17: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)] } 
              { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#17)] } 
            LitInt(0) <= ref#17
                 && ref#17 < 18446744073709551616
                 && LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#17)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)]): DatatypeType)
                   == LitInt(0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
      free invariant $w$loop#0
         ==> IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           && 
          IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
           && LruModel.__default.WF(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
           && MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && (forall ref#14: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)] } 
            LitInt(0) <= ref#14
                 && ref#14 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)]
               ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#14)]): Seq Box)
                 <= LitInt(Bounds.__default.MaxNumChildren()))
           && 
          LitInt(0) <= idx#0
           && idx#0 <= Seq#Length(newSuccs#0)
           && 
          LitInt(0) <= LitInt(0)
           && LitInt(0) <= Seq#Length(oldSuccs#0)
           && (Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]): Seq Box, 
              newSuccs#0))
           && (!Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
           && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
            IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           && (forall j#3: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#3)): int } 
            LitInt(0) <= j#3 && j#3 < Seq#Length(oldSuccs#0)
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[Seq#Index(oldSuccs#0, j#3)])
           && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
           && (forall ref#16: int :: 
            { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#16)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)] } 
            LitInt(0) <= ref#16
                 && ref#16 < 18446744073709551616
                 && 
                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#16)]): DatatypeType)
                   == LitInt(0)
               ==> LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#16)])
           && (forall ref#17: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)] } 
              { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#17)] } 
            LitInt(0) <= ref#17
                 && ref#17 < 18446744073709551616
                 && LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#17)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#17)]): DatatypeType)
                   == LitInt(0))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
      free invariant $w$loop#0
         ==> $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
              read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              LitInt(0)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
           && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
            read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0);
      invariant $w$loop#0
         ==> _System.Tuple2#Equal(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
            read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0)), 
          IndirectionTableModel.__default.UpdatePredCountsInc($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]
             || 
            read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(newSuccs#0) - idx#0 <= $decr_init$loop#00
         && (Seq#Length(newSuccs#0) - idx#0 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(332,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            havoc o#4;
            assume $Is(o#4, Tclass._System.object());
            // Begin Comprehension WF check
            assert {:subsumption 0} t#0 != null;
            if (read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#4)])
            {
                assert {:subsumption 0} t#0 != null;
                assert $IsAlloc(t#0, 
                  Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
                  old($Heap));
                if (!read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#4)])
                {
                }
            }

            // End Comprehension WF check
            assume true;
            assume (forall o#5: ref :: 
              { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)] } 
                { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)] } 
              $Is(o#5, Tclass._System.object())
                   && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)]
                 ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#5)]
                   || (o#5 != null && !read(old($Heap), o#5, alloc)));
            havoc o#6;
            assume $Is(o#6, Tclass._System.object());
            // Begin Comprehension WF check
            assert {:subsumption 0} q#0 != null;
            if (read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#6)])
            {
                assert {:subsumption 0} q#0 != null;
                assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
                if (!read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#6)])
                {
                }
            }

            // End Comprehension WF check
            assume true;
            assume (forall o#7: ref :: 
              { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)] } 
                { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)] } 
              $Is(o#7, Tclass._System.object())
                   && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)]
                 ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#7)]
                   || (o#7 != null && !read(old($Heap), o#7, alloc)));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} q#0 != null;
            assume true;
            assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
              read($Heap, q#0, LruImpl.LruImplQueue.Repr));
            assert {:subsumption 0} t#0 != null;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assert {:subsumption 0} q#0 != null;
            assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
            assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
            assume LruImpl.LruImplQueue.Inv($Heap, q#0);
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} q#0 != null;
            ##t#2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#2, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#2 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#2, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##changingRef#2 := changingRef#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##changingRef#2, Tclass.NativeTypes.uint64(), $Heap);
            ##newSuccs#2 := newSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newSuccs#2, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##oldSuccs#2 := oldSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldSuccs#2, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##newIdx#1 := idx#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newIdx#1, TInt, $Heap);
            ##oldIdx#1 := LitInt(0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldIdx#1, TInt, $Heap);
            assume IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0, 
              LitInt(0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx#0, 
                LitInt(0));
            assume IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0, 
              LitInt(0));
            assert {:subsumption 0} t#0 != null;
            assert $IsAlloc(t#0, 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
            assert {:subsumption 0} q#0 != null;
            assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
            newtype$check#2 := LitInt(0);
            assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
            ##t#3 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#3, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#3 := read(old($Heap), q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#3, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##changingRef#3 := changingRef#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##changingRef#3, Tclass.NativeTypes.uint64(), $Heap);
            ##newSuccs#3 := newSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newSuccs#3, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##oldSuccs#3 := oldSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldSuccs#3, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##idx#1 := LitInt(0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##idx#1, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#3);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (LruModel.__default.WF#canCall(##q#3)
                   ==> LruModel.__default.WF(##q#3)
                     || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, ##q#3));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || MutableMapModel.LinearHashMap.count(##t#3)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || Seq#Length(##oldSuccs#3) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || Seq#Length(##newSuccs#3) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (forall ref#18: int :: 
                  { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#18)]): Seq Box } 
                    { Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#18)] } 
                  LitInt(0) <= ref#18
                       && ref#18 < 18446744073709551616
                       && Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#18)]
                     ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#18)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || LitInt(0) <= ##idx#1;
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || ##idx#1 <= Seq#Length(##newSuccs#3);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || LitInt(0) <= LitInt(0);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || LitInt(0) <= Seq#Length(##oldSuccs#3);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(##changingRef#3)]
                   ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#3))[$Box(##changingRef#3)]): Seq Box, 
                    ##newSuccs#3));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (!Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(##changingRef#3)]
                   ==> Seq#Equal(##newSuccs#3, Seq#Empty(): Seq Box));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(##t#3), 
                    IndirectionTableModel.__default.Graph(##t#3), 
                    ##newSuccs#3, 
                    ##oldSuccs#3, 
                    ##idx#1, 
                    LitInt(0))
                   ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(##t#3), 
                    IndirectionTableModel.__default.Graph(##t#3), 
                    ##newSuccs#3, 
                    ##oldSuccs#3, 
                    ##idx#1, 
                    LitInt(0)));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (forall j#4: int :: 
                  { $Unbox(Seq#Index(##oldSuccs#3, j#4)): int } 
                  LitInt(0) <= j#4 && j#4 < Seq#Length(##oldSuccs#3)
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[Seq#Index(##oldSuccs#3, j#4)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(##t#3))
                   ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(##t#3))
                     || (forall ref#19: int :: 
                      { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#19)]): Seq Box } 
                        { Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#19)] } 
                      LitInt(0) <= ref#19
                           && ref#19 < 18446744073709551616
                           && Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#19)]
                         ==> (forall succ#4: int :: 
                          { Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(succ#4)] } 
                            { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#19)]): Seq Box, 
                              $Box(succ#4)) } 
                          LitInt(0) <= succ#4
                               && succ#4 < 18446744073709551616
                               && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#3))[$Box(ref#19)]): Seq Box, 
                                $Box(succ#4))
                             ==> Map#Domain(IndirectionTableModel.__default.Graph(##t#3))[$Box(succ#4)])));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (forall ref#20: int :: 
                  { LruModel.__default.I(##q#3)[$Box(ref#20)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#20)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#20)] } 
                  LitInt(0) <= ref#20
                       && ref#20 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#20)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#20)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(##q#3)[$Box(ref#20)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || (forall ref#21: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#21)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#21)] } 
                    { LruModel.__default.I(##q#3)[$Box(ref#21)] } 
                  LitInt(0) <= ref#21
                       && ref#21 < 18446744073709551616
                       && LruModel.__default.I(##q#3)[$Box(ref#21)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#21)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#21)]): DatatypeType)
                         == LitInt(0));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#3, ##q#3, ##changingRef#3, ##newSuccs#3, ##oldSuccs#3, ##idx#1, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#3, 
                  ##q#3, 
                  ##changingRef#3, 
                  ##newSuccs#3, 
                  ##oldSuccs#3, 
                  ##idx#1, 
                  LitInt(0))
                 || Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(PivotBetreeGraph.__default.Root())];
            assume IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
              read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              LitInt(0));
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                LitInt(0)));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} q#0 != null;
            ##t#4 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#4, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#4 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#4, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##changingRef#4 := changingRef#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##changingRef#4, Tclass.NativeTypes.uint64(), $Heap);
            ##newSuccs#4 := newSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newSuccs#4, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##oldSuccs#4 := oldSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldSuccs#4, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##idx#2 := idx#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##idx#2, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#4);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (LruModel.__default.WF#canCall(##q#4)
                   ==> LruModel.__default.WF(##q#4)
                     || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, ##q#4));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || MutableMapModel.LinearHashMap.count(##t#4)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || Seq#Length(##oldSuccs#4) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || Seq#Length(##newSuccs#4) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (forall ref#22: int :: 
                  { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#22)]): Seq Box } 
                    { Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#22)] } 
                  LitInt(0) <= ref#22
                       && ref#22 < 18446744073709551616
                       && Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#22)]
                     ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#22)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || LitInt(0) <= ##idx#2;
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || ##idx#2 <= Seq#Length(##newSuccs#4);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || LitInt(0) <= LitInt(0);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || LitInt(0) <= Seq#Length(##oldSuccs#4);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(##changingRef#4)]
                   ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#4))[$Box(##changingRef#4)]): Seq Box, 
                    ##newSuccs#4));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (!Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(##changingRef#4)]
                   ==> Seq#Equal(##newSuccs#4, Seq#Empty(): Seq Box));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(##t#4), 
                    IndirectionTableModel.__default.Graph(##t#4), 
                    ##newSuccs#4, 
                    ##oldSuccs#4, 
                    ##idx#2, 
                    LitInt(0))
                   ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(##t#4), 
                    IndirectionTableModel.__default.Graph(##t#4), 
                    ##newSuccs#4, 
                    ##oldSuccs#4, 
                    ##idx#2, 
                    LitInt(0)));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (forall j#5: int :: 
                  { $Unbox(Seq#Index(##oldSuccs#4, j#5)): int } 
                  LitInt(0) <= j#5 && j#5 < Seq#Length(##oldSuccs#4)
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[Seq#Index(##oldSuccs#4, j#5)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(##t#4))
                   ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(##t#4))
                     || (forall ref#23: int :: 
                      { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#23)]): Seq Box } 
                        { Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#23)] } 
                      LitInt(0) <= ref#23
                           && ref#23 < 18446744073709551616
                           && Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#23)]
                         ==> (forall succ#5: int :: 
                          { Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(succ#5)] } 
                            { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#23)]): Seq Box, 
                              $Box(succ#5)) } 
                          LitInt(0) <= succ#5
                               && succ#5 < 18446744073709551616
                               && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#4))[$Box(ref#23)]): Seq Box, 
                                $Box(succ#5))
                             ==> Map#Domain(IndirectionTableModel.__default.Graph(##t#4))[$Box(succ#5)])));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (forall ref#24: int :: 
                  { LruModel.__default.I(##q#4)[$Box(ref#24)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#24)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#24)] } 
                  LitInt(0) <= ref#24
                       && ref#24 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#24)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#24)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(##q#4)[$Box(ref#24)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || (forall ref#25: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#25)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#25)] } 
                    { LruModel.__default.I(##q#4)[$Box(ref#25)] } 
                  LitInt(0) <= ref#25
                       && ref#25 < 18446744073709551616
                       && LruModel.__default.I(##q#4)[$Box(ref#25)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#25)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#25)]): DatatypeType)
                         == LitInt(0));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#4, ##q#4, ##changingRef#4, ##newSuccs#4, ##oldSuccs#4, ##idx#2, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#4, 
                  ##q#4, 
                  ##changingRef#4, 
                  ##newSuccs#4, 
                  ##oldSuccs#4, 
                  ##idx#2, 
                  LitInt(0))
                 || Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(PivotBetreeGraph.__default.Root())];
            assume IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0);
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx#0));
            assume $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                  read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                  changingRef#0, 
                  newSuccs#0, 
                  oldSuccs#0, 
                  LitInt(0)))
               && $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                  read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                  changingRef#0, 
                  newSuccs#0, 
                  oldSuccs#0, 
                  idx#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
               && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                LitInt(0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx#0);
            assume _System.Tuple2#Equal(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                LitInt(0)), 
              IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx#0));
            assume true;
            assume false;
        }

        newtype$check#3 := Seq#Length(newSuccs#0);
        assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
        assume true;
        if (Seq#Length(newSuccs#0) <= idx#0)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(newSuccs#0) - idx#0;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(343,60)
        // TrCallStmt: Before ProcessCallStmt
        assert t#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        // ProcessCallStmt: CheckSubrange
        t##0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assert q#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        q##0_0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
        assume true;
        // ProcessCallStmt: CheckSubrange
        changingRef##0_0 := changingRef#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        newSuccs##0_0 := newSuccs#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        oldSuccs##0_0 := oldSuccs#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        idx##0_0 := idx#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableModel.__default.LemmaUpdatePredCountsIncStuff(t##0_0, q##0_0, changingRef##0_0, newSuccs##0_0, oldSuccs##0_0, idx##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(343,120)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(345,16)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        t##0_1 := t#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        q##0_1 := q#0;
        assert 0 <= idx#0 && idx#0 < Seq#Length(newSuccs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        ref##0_0 := $Unbox(Seq#Index(newSuccs#0, idx#0)): int;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && (read($Heap, t##0_1, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 || read($Heap, q##0_1, LruImpl.LruImplQueue.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableImpl.IndirectionTable.PredInc(t##0_1, q##0_1, ref##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(345,36)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(346,13)
        assume true;
        newtype$check#0_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        newtype$check#0_1 := idx#0 + 1;
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assume true;
        idx#0 := idx#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(346,22)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(332,7)
        assert 0 <= $decr$loop#00 || Seq#Length(newSuccs#0) - idx#0 == $decr$loop#00;
        assert Seq#Length(newSuccs#0) - idx#0 < $decr$loop#00;
        assume true;
        assume true;
        assume true;
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0));
        assume $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
              read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              LitInt(0)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
           && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
            read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0);
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(349,24)
    assume true;
    newtype$check#4 := LitInt(0);
    assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
    assume true;
    idx2#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(349,27)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(351,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#1 := $Heap;
    $decr_init$loop#10 := Seq#Length(oldSuccs#0) - idx2#0;
    havoc $w$loop#1;
    while (true)
      free invariant $w$loop#1 ==> true;
      invariant $w$loop#1
         ==> (forall o#9: ref :: 
          { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)] } 
            { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)] } 
          $Is(o#9, Tclass._System.object())
               && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)]
             ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)]
               || (o#9 != null && !read(old($Heap), o#9, alloc)));
      free invariant $w$loop#1 ==> true;
      invariant $w$loop#1
         ==> (forall o#11: ref :: 
          { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)] } 
            { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)] } 
          $Is(o#11, Tclass._System.object())
               && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)]
             ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)]
               || (o#11 != null && !read(old($Heap), o#11, alloc)));
      free invariant $w$loop#1 ==> true;
      invariant $w$loop#1
         ==> Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
          read($Heap, q#0, LruImpl.LruImplQueue.Repr));
      free invariant $w$loop#1
         ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
      invariant $w$loop#1
         ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
      free invariant $w$loop#1 ==> LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
      invariant $w$loop#1 ==> LruImpl.LruImplQueue.Inv($Heap, q#0);
      free invariant $w$loop#1
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0);
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (LruModel.__default.WF#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
             ==> LruModel.__default.WF(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
               || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue)));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize());
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (forall ref#26: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)] } 
            LitInt(0) <= ref#26
                 && ref#26 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)]
               ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)]): Seq Box)
                 <= LitInt(Bounds.__default.MaxNumChildren()));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || LitInt(0) <= Seq#Length(newSuccs#0);
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || Seq#Length(newSuccs#0) <= Seq#Length(newSuccs#0);
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || LitInt(0) <= idx2#0;
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || idx2#0 <= Seq#Length(oldSuccs#0);
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]): Seq Box, 
              newSuccs#0));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (!Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              newSuccs#0, 
              oldSuccs#0, 
              Seq#Length(newSuccs#0), 
              idx2#0)
             ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              newSuccs#0, 
              oldSuccs#0, 
              Seq#Length(newSuccs#0), 
              idx2#0));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (forall j#6: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#6)): int } 
            LitInt(0) <= j#6 && j#6 < Seq#Length(oldSuccs#0)
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[Seq#Index(oldSuccs#0, j#6)]);
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
             ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
               || (forall ref#27: int :: 
                { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#27)]): Seq Box } 
                  { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#27)] } 
                LitInt(0) <= ref#27
                     && ref#27 < 18446744073709551616
                     && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#27)]
                   ==> (forall succ#6: int :: 
                    { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(succ#6)] } 
                      { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#27)]): Seq Box, 
                        $Box(succ#6)) } 
                    LitInt(0) <= succ#6
                         && succ#6 < 18446744073709551616
                         && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#27)]): Seq Box, 
                          $Box(succ#6))
                       ==> Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(succ#6)])));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (forall ref#28: int :: 
            { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#28)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)] } 
            LitInt(0) <= ref#28
                 && ref#28 < 18446744073709551616
                 && 
                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)]): DatatypeType)
                   == LitInt(0)
               ==> LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#28)]);
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || (forall ref#29: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)] } 
              { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#29)] } 
            LitInt(0) <= ref#29
                 && ref#29 < 18446744073709551616
                 && LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#29)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)]): DatatypeType)
                   == LitInt(0));
      invariant $w$loop#1
         ==> 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx2#0)
         ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           || Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
      free invariant $w$loop#1
         ==> IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           && 
          IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
           && LruModel.__default.WF(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
           && MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && (forall ref#26: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)] } 
            LitInt(0) <= ref#26
                 && ref#26 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)]
               ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#26)]): Seq Box)
                 <= LitInt(Bounds.__default.MaxNumChildren()))
           && 
          LitInt(0) <= Seq#Length(newSuccs#0)
           && Seq#Length(newSuccs#0) <= Seq#Length(newSuccs#0)
           && 
          LitInt(0) <= idx2#0
           && idx2#0 <= Seq#Length(oldSuccs#0)
           && (Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]): Seq Box, 
              newSuccs#0))
           && (!Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(changingRef#0)]
             ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
           && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
            IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0)
           && (forall j#6: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#6)): int } 
            LitInt(0) <= j#6 && j#6 < Seq#Length(oldSuccs#0)
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[Seq#Index(oldSuccs#0, j#6)])
           && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
           && (forall ref#28: int :: 
            { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#28)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)] } 
            LitInt(0) <= ref#28
                 && ref#28 < 18446744073709551616
                 && 
                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#28)]): DatatypeType)
                   == LitInt(0)
               ==> LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#28)])
           && (forall ref#29: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)] } 
              { LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#29)] } 
            LitInt(0) <= ref#29
                 && ref#29 < 18446744073709551616
                 && LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue))[$Box(ref#29)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)]
                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#29)]): DatatypeType)
                   == LitInt(0))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
      free invariant $w$loop#1
         ==> $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
              read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              LitInt(0)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx2#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
           && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
            read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.UpdatePredCountsDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx2#0);
      invariant $w$loop#1
         ==> _System.Tuple2#Equal(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
            read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0)), 
          IndirectionTableModel.__default.UpdatePredCountsDec($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx2#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#1[$o]
             || 
            read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             || read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#1, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#1, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#1, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(oldSuccs#0) - idx2#0 <= $decr_init$loop#10
         && (Seq#Length(oldSuccs#0) - idx2#0 == $decr_init$loop#10 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(351,6): after some loop iterations"} true;
        if (!$w$loop#1)
        {
            havoc o#8;
            assume $Is(o#8, Tclass._System.object());
            // Begin Comprehension WF check
            assert {:subsumption 0} t#0 != null;
            if (read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#8)])
            {
                assert {:subsumption 0} t#0 != null;
                assert $IsAlloc(t#0, 
                  Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
                  old($Heap));
                if (!read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#8)])
                {
                }
            }

            // End Comprehension WF check
            assume true;
            assume (forall o#9: ref :: 
              { read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)] } 
                { read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)] } 
              $Is(o#9, Tclass._System.object())
                   && read($Heap, t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)]
                 ==> read(old($Heap), t#0, MutableMap.ResizingHashMap.Repr)[$Box(o#9)]
                   || (o#9 != null && !read(old($Heap), o#9, alloc)));
            havoc o#10;
            assume $Is(o#10, Tclass._System.object());
            // Begin Comprehension WF check
            assert {:subsumption 0} q#0 != null;
            if (read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#10)])
            {
                assert {:subsumption 0} q#0 != null;
                assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
                if (!read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#10)])
                {
                }
            }

            // End Comprehension WF check
            assume true;
            assume (forall o#11: ref :: 
              { read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)] } 
                { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)] } 
              $Is(o#11, Tclass._System.object())
                   && read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)]
                 ==> read(old($Heap), q#0, LruImpl.LruImplQueue.Repr)[$Box(o#11)]
                   || (o#11 != null && !read(old($Heap), o#11, alloc)));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} q#0 != null;
            assume true;
            assume Set#Disjoint(read($Heap, t#0, MutableMap.ResizingHashMap.Repr), 
              read($Heap, q#0, LruImpl.LruImplQueue.Repr));
            assert {:subsumption 0} t#0 != null;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assert {:subsumption 0} q#0 != null;
            assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
            assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
            assume LruImpl.LruImplQueue.Inv($Heap, q#0);
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} q#0 != null;
            ##t#5 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#5, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#5 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#5, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##changingRef#5 := changingRef#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##changingRef#5, Tclass.NativeTypes.uint64(), $Heap);
            ##newSuccs#5 := newSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newSuccs#5, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##oldSuccs#5 := oldSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldSuccs#5, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##newIdx#2 := Seq#Length(newSuccs#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##newIdx#2, TInt, $Heap);
            ##oldIdx#2 := idx2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldIdx#2, TInt, $Heap);
            assume IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              Seq#Length(newSuccs#0), 
              idx2#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                Seq#Length(newSuccs#0), 
                idx2#0);
            assume IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              Seq#Length(newSuccs#0), 
              idx2#0);
            assert {:subsumption 0} t#0 != null;
            assert $IsAlloc(t#0, 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
            assert {:subsumption 0} q#0 != null;
            assert $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), old($Heap));
            newtype$check#5 := LitInt(0);
            assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
            ##t#6 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#6, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#6 := read(old($Heap), q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#6, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##changingRef#6 := changingRef#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##changingRef#6, Tclass.NativeTypes.uint64(), $Heap);
            ##newSuccs#6 := newSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newSuccs#6, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##oldSuccs#6 := oldSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldSuccs#6, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##idx#3 := LitInt(0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##idx#3, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#6);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (LruModel.__default.WF#canCall(##q#6)
                   ==> LruModel.__default.WF(##q#6)
                     || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, ##q#6));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || MutableMapModel.LinearHashMap.count(##t#6)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || Seq#Length(##oldSuccs#6) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || Seq#Length(##newSuccs#6) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (forall ref#30: int :: 
                  { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#30)]): Seq Box } 
                    { Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#30)] } 
                  LitInt(0) <= ref#30
                       && ref#30 < 18446744073709551616
                       && Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#30)]
                     ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#30)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || LitInt(0) <= ##idx#3;
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || ##idx#3 <= Seq#Length(##newSuccs#6);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || LitInt(0) <= LitInt(0);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || LitInt(0) <= Seq#Length(##oldSuccs#6);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(##changingRef#6)]
                   ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#6))[$Box(##changingRef#6)]): Seq Box, 
                    ##newSuccs#6));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (!Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(##changingRef#6)]
                   ==> Seq#Equal(##newSuccs#6, Seq#Empty(): Seq Box));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(##t#6), 
                    IndirectionTableModel.__default.Graph(##t#6), 
                    ##newSuccs#6, 
                    ##oldSuccs#6, 
                    ##idx#3, 
                    LitInt(0))
                   ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(##t#6), 
                    IndirectionTableModel.__default.Graph(##t#6), 
                    ##newSuccs#6, 
                    ##oldSuccs#6, 
                    ##idx#3, 
                    LitInt(0)));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (forall j#7: int :: 
                  { $Unbox(Seq#Index(##oldSuccs#6, j#7)): int } 
                  LitInt(0) <= j#7 && j#7 < Seq#Length(##oldSuccs#6)
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#6))[Seq#Index(##oldSuccs#6, j#7)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(##t#6))
                   ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(##t#6))
                     || (forall ref#31: int :: 
                      { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#31)]): Seq Box } 
                        { Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#31)] } 
                      LitInt(0) <= ref#31
                           && ref#31 < 18446744073709551616
                           && Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#31)]
                         ==> (forall succ#7: int :: 
                          { Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(succ#7)] } 
                            { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#31)]): Seq Box, 
                              $Box(succ#7)) } 
                          LitInt(0) <= succ#7
                               && succ#7 < 18446744073709551616
                               && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#6))[$Box(ref#31)]): Seq Box, 
                                $Box(succ#7))
                             ==> Map#Domain(IndirectionTableModel.__default.Graph(##t#6))[$Box(succ#7)])));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (forall ref#32: int :: 
                  { LruModel.__default.I(##q#6)[$Box(ref#32)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#32)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#32)] } 
                  LitInt(0) <= ref#32
                       && ref#32 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#32)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#32)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(##q#6)[$Box(ref#32)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || (forall ref#33: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#33)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#33)] } 
                    { LruModel.__default.I(##q#6)[$Box(ref#33)] } 
                  LitInt(0) <= ref#33
                       && ref#33 < 18446744073709551616
                       && LruModel.__default.I(##q#6)[$Box(ref#33)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#33)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(ref#33)]): DatatypeType)
                         == LitInt(0));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#6, ##q#6, ##changingRef#6, ##newSuccs#6, ##oldSuccs#6, ##idx#3, LitInt(0))
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#6, 
                  ##q#6, 
                  ##changingRef#6, 
                  ##newSuccs#6, 
                  ##oldSuccs#6, 
                  ##idx#3, 
                  LitInt(0))
                 || Map#Domain(MutableMapModel.LinearHashMap.contents(##t#6))[$Box(PivotBetreeGraph.__default.Root())];
            assume IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
              read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              LitInt(0));
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                LitInt(0)));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} q#0 != null;
            ##t#7 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#7, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#7 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#7, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##changingRef#7 := changingRef#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##changingRef#7, Tclass.NativeTypes.uint64(), $Heap);
            ##newSuccs#7 := newSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##newSuccs#7, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##oldSuccs#7 := oldSuccs#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##oldSuccs#7, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##idx#4 := idx2#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##idx#4, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#7);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (LruModel.__default.WF#canCall(##q#7)
                   ==> LruModel.__default.WF(##q#7)
                     || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, ##q#7));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || MutableMapModel.LinearHashMap.count(##t#7)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || Seq#Length(##oldSuccs#7) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || Seq#Length(##newSuccs#7) <= LitInt(Bounds.__default.MaxNumChildren());
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (forall ref#34: int :: 
                  { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#34)]): Seq Box } 
                    { Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#34)] } 
                  LitInt(0) <= ref#34
                       && ref#34 < 18446744073709551616
                       && Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#34)]
                     ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#34)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || LitInt(0) <= Seq#Length(##newSuccs#7);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || Seq#Length(##newSuccs#7) <= Seq#Length(##newSuccs#7);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || LitInt(0) <= ##idx#4;
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || ##idx#4 <= Seq#Length(##oldSuccs#7);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(##changingRef#7)]
                   ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#7))[$Box(##changingRef#7)]): Seq Box, 
                    ##newSuccs#7));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (!Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(##changingRef#7)]
                   ==> Seq#Equal(##newSuccs#7, Seq#Empty(): Seq Box));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(##t#7), 
                    IndirectionTableModel.__default.Graph(##t#7), 
                    ##newSuccs#7, 
                    ##oldSuccs#7, 
                    Seq#Length(##newSuccs#7), 
                    ##idx#4)
                   ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(##t#7), 
                    IndirectionTableModel.__default.Graph(##t#7), 
                    ##newSuccs#7, 
                    ##oldSuccs#7, 
                    Seq#Length(##newSuccs#7), 
                    ##idx#4));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (forall j#8: int :: 
                  { $Unbox(Seq#Index(##oldSuccs#7, j#8)): int } 
                  LitInt(0) <= j#8 && j#8 < Seq#Length(##oldSuccs#7)
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#7))[Seq#Index(##oldSuccs#7, j#8)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(##t#7))
                   ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(##t#7))
                     || (forall ref#35: int :: 
                      { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#35)]): Seq Box } 
                        { Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#35)] } 
                      LitInt(0) <= ref#35
                           && ref#35 < 18446744073709551616
                           && Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#35)]
                         ==> (forall succ#8: int :: 
                          { Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(succ#8)] } 
                            { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#35)]): Seq Box, 
                              $Box(succ#8)) } 
                          LitInt(0) <= succ#8
                               && succ#8 < 18446744073709551616
                               && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##t#7))[$Box(ref#35)]): Seq Box, 
                                $Box(succ#8))
                             ==> Map#Domain(IndirectionTableModel.__default.Graph(##t#7))[$Box(succ#8)])));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (forall ref#36: int :: 
                  { LruModel.__default.I(##q#7)[$Box(ref#36)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#36)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#36)] } 
                  LitInt(0) <= ref#36
                       && ref#36 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#36)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#36)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(##q#7)[$Box(ref#36)]);
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || (forall ref#37: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#37)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#37)] } 
                    { LruModel.__default.I(##q#7)[$Box(ref#37)] } 
                  LitInt(0) <= ref#37
                       && ref#37 < 18446744073709551616
                       && LruModel.__default.I(##q#7)[$Box(ref#37)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#37)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(ref#37)]): DatatypeType)
                         == LitInt(0));
            assert {:subsumption 0} IndirectionTableModel.__default.RefcountUpdateInv#canCall(##t#7, 
                ##q#7, 
                ##changingRef#7, 
                ##newSuccs#7, 
                ##oldSuccs#7, 
                Seq#Length(##newSuccs#7), 
                ##idx#4)
               ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
                  ##t#7, 
                  ##q#7, 
                  ##changingRef#7, 
                  ##newSuccs#7, 
                  ##oldSuccs#7, 
                  Seq#Length(##newSuccs#7), 
                  ##idx#4)
                 || Map#Domain(MutableMapModel.LinearHashMap.contents(##t#7))[$Box(PivotBetreeGraph.__default.Root())];
            assume IndirectionTableModel.__default.UpdatePredCountsDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx2#0);
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx2#0));
            assume $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                  read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                  changingRef#0, 
                  newSuccs#0, 
                  oldSuccs#0, 
                  LitInt(0)))
               && $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                  read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                  changingRef#0, 
                  newSuccs#0, 
                  oldSuccs#0, 
                  idx2#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
               && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                LitInt(0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.UpdatePredCountsDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx2#0);
            assume _System.Tuple2#Equal(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
                read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                LitInt(0)), 
              IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                changingRef#0, 
                newSuccs#0, 
                oldSuccs#0, 
                idx2#0));
            assume true;
            assume false;
        }

        newtype$check#6 := Seq#Length(oldSuccs#0);
        assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
        assume true;
        if (Seq#Length(oldSuccs#0) <= idx2#0)
        {
            break;
        }

        $decr$loop#10 := Seq#Length(oldSuccs#0) - idx2#0;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(362,60)
        // TrCallStmt: Before ProcessCallStmt
        assert t#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        // ProcessCallStmt: CheckSubrange
        t##1_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assert q#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        q##1_0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
        assume true;
        // ProcessCallStmt: CheckSubrange
        changingRef##1_0 := changingRef#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        newSuccs##1_0 := newSuccs#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        oldSuccs##1_0 := oldSuccs#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        idx##1_0 := idx2#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableModel.__default.LemmaUpdatePredCountsDecStuff(t##1_0, q##1_0, changingRef##1_0, newSuccs##1_0, oldSuccs##1_0, idx##1_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(362,121)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(364,16)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        t##1_1 := t#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        q##1_1 := q#0;
        assert 0 <= idx2#0 && idx2#0 < Seq#Length(oldSuccs#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        ref##1_0 := $Unbox(Seq#Index(oldSuccs#0, idx2#0)): int;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && (read($Heap, t##1_1, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 || read($Heap, q##1_1, LruImpl.LruImplQueue.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableImpl.IndirectionTable.PredDec(t##1_1, q##1_1, ref##1_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(364,37)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(365,14)
        assume true;
        newtype$check#1_0 := LitInt(1);
        assert LitInt(0) <= newtype$check#1_0 && newtype$check#1_0 < 18446744073709551616;
        newtype$check#1_1 := idx2#0 + 1;
        assert LitInt(0) <= newtype$check#1_1 && newtype$check#1_1 < 18446744073709551616;
        assume true;
        idx2#0 := idx2#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(365,24)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(351,7)
        assert 0 <= $decr$loop#10 || Seq#Length(oldSuccs#0) - idx2#0 == $decr$loop#10;
        assert Seq#Length(oldSuccs#0) - idx2#0 < $decr$loop#10;
        assume true;
        assume true;
        assume true;
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.RefcountUpdateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx2#0);
        assume $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
              read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              LitInt(0)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              idx2#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
           && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0), 
            read(old($Heap), q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            LitInt(0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.UpdatePredCountsDec#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx2#0);
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap))
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap));
  free requires 27 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc(this: ref, ref#0: int, succs#0: Seq Box) returns (oldLoc#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##succs#0: Seq Box;
  var ##graph#0: Map Box Box;
  var o#0: ref;
  var ##self#1: DatatypeType;
  var ##ref#0: int;
  var ##succs#1: Seq Box;

    // AddMethodImpl: UpdateAndRemoveLoc, CheckWellformed$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(369,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume Bounds.__default.MaxNumChildren#canCall();
    assume Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren());
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#5: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#5)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#6: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#7: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { Map#Domain(graph#1)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#8)]
                   ==> ref#8 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.__default.MaxSize#canCall();
    assume Map#Card(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       < IndirectionTableModel.__default.MaxSize();
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#9: int :: 
                { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                  { Map#Domain(graph#2)[$Box(ref#9)] } 
                LitInt(0) <= ref#9
                     && ref#9 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#9)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#10: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                  LitInt(0) <= ref#10
                       && ref#10 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#11: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                  LitInt(0) <= ref#11
                       && ref#11 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#12: int :: 
                { Map#Domain(graph#2)[$Box(ref#12)] } 
                LitInt(0) <= ref#12
                     && ref#12 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#12)]
                   ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#2: int :: 
                  { Map#Domain(locs#2)[$Box(r#2)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                  LitInt(0) <= r#2
                       && r#2 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                     ==> Map#Domain(locs#2)[$Box(r#2)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##succs#0 := succs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    ##graph#0 := IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##graph#0, 
      TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
      $Heap);
    assume IndirectionTableModel.__default.SuccsValid#canCall(succs#0, 
      IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    assume IndirectionTableModel.__default.SuccsValid(succs#0, 
      IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc oldLoc#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(377,15): post-state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc o#0;
    assume $Is(o#0, Tclass._System.object());
    if (*)
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        if (*)
        {
            assume o#0 != null && !read(old($Heap), o#0, alloc);
        }
        else
        {
            assume !(o#0 != null && !read(old($Heap), o#0, alloc));
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assume read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
        }
    }
    else
    {
        assume read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)]
           ==> (o#0 != null && !read(old($Heap), o#0, alloc))
             || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#0)];
    }

    assume (forall o#1: ref :: 
      { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
        { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      $Is(o#1, Tclass._System.object())
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
         ==> (o#1 != null && !read(old($Heap), o#1, alloc))
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#3))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#13: int :: 
                { $Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box } 
                  { Map#Domain(graph#3)[$Box(ref#13)] } 
                LitInt(0) <= ref#13
                     && ref#13 < 18446744073709551616
                     && Map#Domain(graph#3)[$Box(ref#13)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#14: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                  LitInt(0) <= ref#14
                       && ref#14 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#14)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#15: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                  LitInt(0) <= ref#15
                       && ref#15 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#15)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#16: int :: 
                { Map#Domain(graph#3)[$Box(ref#16)] } 
                LitInt(0) <= ref#16
                     && ref#16 < 18446744073709551616
                     && Map#Domain(graph#3)[$Box(ref#16)]
                   ==> ref#16 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#3: int :: 
                  { Map#Domain(locs#3)[$Box(r#3)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                  LitInt(0) <= r#3
                       && r#3 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                     ==> Map#Domain(locs#3)[$Box(r#3)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#4))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#17: int :: 
                { $Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box } 
                  { Map#Domain(graph#4)[$Box(ref#17)] } 
                LitInt(0) <= ref#17
                     && ref#17 < 18446744073709551616
                     && Map#Domain(graph#4)[$Box(ref#17)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#18: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#18)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)] } 
                  LitInt(0) <= ref#18
                       && ref#18 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#18)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#19: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                  LitInt(0) <= ref#19
                       && ref#19 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#19)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#20: int :: 
                { Map#Domain(graph#4)[$Box(ref#20)] } 
                LitInt(0) <= ref#20
                     && ref#20 < 18446744073709551616
                     && Map#Domain(graph#4)[$Box(ref#20)]
                   ==> ref#20
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#4: int :: 
                  { Map#Domain(locs#4)[$Box(r#4)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                  LitInt(0) <= r#4
                       && r#4 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                     ==> Map#Domain(locs#4)[$Box(r#4)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#1 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#0 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#0, Tclass.NativeTypes.uint64(), $Heap);
    ##succs#1 := succs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##succs#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#1);
    assume IndirectionTableModel.__default.Inv(##self#1);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#1)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#1)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#1));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#1);
    assert {:subsumption 0} Map#Card(IndirectionTableModel.IndirectionTable.graph(##self#1))
       < IndirectionTableModel.__default.MaxSize();
    assume Map#Card(IndirectionTableModel.IndirectionTable.graph(##self#1))
       < IndirectionTableModel.__default.MaxSize();
    assert {:subsumption 0} Seq#Length(##succs#1) <= LitInt(Bounds.__default.MaxNumChildren());
    assume Seq#Length(##succs#1) <= LitInt(Bounds.__default.MaxNumChildren());
    assert {:subsumption 0} IndirectionTableModel.__default.SuccsValid#canCall(##succs#1, IndirectionTableModel.IndirectionTable.graph(##self#1))
       ==> IndirectionTableModel.__default.SuccsValid(##succs#1, IndirectionTableModel.IndirectionTable.graph(##self#1))
         || (forall ref#21: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#1))[$Box(ref#21)] } 
            { Seq#Contains(##succs#1, $Box(ref#21)) } 
          LitInt(0) <= ref#21
               && ref#21 < 18446744073709551616
               && Seq#Contains(##succs#1, $Box(ref#21))
             ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#1))[$Box(ref#21)]);
    assume IndirectionTableModel.__default.SuccsValid(##succs#1, IndirectionTableModel.IndirectionTable.graph(##self#1));
    assume IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, succs#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        succs#0));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
      IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        succs#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap))
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     ==> IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
       || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  requires Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires Map#Card(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     < IndirectionTableModel.__default.MaxSize();
  requires IndirectionTableModel.__default.SuccsValid#canCall(succs#0, 
      IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> IndirectionTableModel.__default.SuccsValid(succs#0, 
        IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || (forall ref#22: int :: 
        { Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#22)] } 
          { Seq#Contains(succs#0, $Box(ref#22)) } 
        LitInt(0) <= ref#22
             && ref#22 < 18446744073709551616
             && Seq#Contains(succs#0, $Box(ref#22))
           ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#22)]);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        succs#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, succs#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
    IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0, 
      succs#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap))
   returns (oldLoc#0: DatatypeType
       where $Is(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
         && $IsAlloc(oldLoc#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap), 
    $_reverifyPost: bool);
  free requires 27 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#5, graph#5)
                 && BlockCache.__default.GraphClosed(graph#5)
                 && (forall ref#23: int :: 
                  { $Unbox(Map#Elements(graph#5)[$Box(ref#23)]): Seq Box } 
                    { Map#Domain(graph#5)[$Box(ref#23)] } 
                  LitInt(0) <= ref#23
                       && ref#23 < 18446744073709551616
                       && Map#Domain(graph#5)[$Box(ref#23)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#5)[$Box(ref#23)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#24: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#24)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#24)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#24)] } 
                      LitInt(0) <= ref#24
                           && ref#24 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#24)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#24)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#24)])
                     && (forall ref#25: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#25)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#25)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#25)] } 
                      LitInt(0) <= ref#25
                           && ref#25 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#25)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#25)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#25)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#26: int :: 
                  { Map#Domain(graph#5)[$Box(ref#26)] } 
                  LitInt(0) <= ref#26
                       && ref#26 < 18446744073709551616
                       && Map#Domain(graph#5)[$Box(ref#26)]
                     ==> ref#26 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#5: int :: 
                      { Map#Domain(locs#5)[$Box(r#5)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#5)] } 
                      LitInt(0) <= r#5
                           && r#5 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#5)]
                         ==> Map#Domain(locs#5)[$Box(r#5)])))));
  free requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && 
    IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  requires Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires Map#Card(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     < IndirectionTableModel.__default.MaxSize();
  free requires IndirectionTableModel.__default.SuccsValid#canCall(succs#0, 
      IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    IndirectionTableModel.__default.SuccsValid(succs#0, 
      IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && (forall ref#27: int :: 
      { Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#27)] } 
        { Seq#Contains(succs#0, $Box(ref#27)) } 
      LitInt(0) <= ref#27
           && ref#27 < 18446744073709551616
           && Seq#Contains(succs#0, $Box(ref#27))
         ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#27)]);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#6, graph#6))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#6))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#28: int :: 
              { $Unbox(Map#Elements(graph#6)[$Box(ref#28)]): Seq Box } 
                { Map#Domain(graph#6)[$Box(ref#28)] } 
              LitInt(0) <= ref#28
                   && ref#28 < 18446744073709551616
                   && Map#Domain(graph#6)[$Box(ref#28)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#6)[$Box(ref#28)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#29: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#29)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#29)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#29)] } 
                LitInt(0) <= ref#29
                     && ref#29 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#29)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#29)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#29)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#30: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#30)] } 
                LitInt(0) <= ref#30
                     && ref#30 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#30)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#31: int :: 
              { Map#Domain(graph#6)[$Box(ref#31)] } 
              LitInt(0) <= ref#31
                   && ref#31 < 18446744073709551616
                   && Map#Domain(graph#6)[$Box(ref#31)]
                 ==> ref#31 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#6: int :: 
                { Map#Domain(locs#6)[$Box(r#6)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)] } 
                LitInt(0) <= r#6
                     && r#6 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)]
                   ==> Map#Domain(locs#6)[$Box(r#6)]))));
  free ensures true;
  ensures (forall o#1: ref :: 
    { read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
      { read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)] } 
    $Is(o#1, Tclass._System.object())
         && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]
       ==> (o#1 != null && !read(old($Heap), o#1, alloc))
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(o#1)]);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        succs#0))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, succs#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(oldLoc#0)), 
    IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0, 
      succs#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc(this: ref, ref#0: int, succs#0: Seq Box)
   returns (oldLoc#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var t##0: DatatypeType;
  var self##0: DatatypeType;
  var ref##0: int;
  var succs##0: Seq Box;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntry#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;
  var predCount#0: int
     where LitInt(0) <= predCount#0 && predCount#0 < 18446744073709551616;
  var newtype$check#0: int;
  var x##0_0: int;
  var key##1: int;
  var value##0: Box;
  var t##1: DatatypeType;
  var t##2: ref;
  var q##0: ref;
  var changingRef##0: int;
  var newSuccs##0: Seq Box;
  var oldSuccs##0: Seq Box;
  var t##3: DatatypeType;
  var $rhs#1_0: int where LitInt(0) <= $rhs#1_0 && $rhs#1_0 < 18446744073709551616;
  var $rhs#0: DatatypeType
     where $Is($rhs#0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));
  var $rhs#1: Set Box where $Is($rhs#1, TSet(Tclass._System.object()));
  var _v3#0: DatatypeType
     where $Is(_v3#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
          Tclass.Options.Option(Tclass.DiskLayout.Location())))
       && $IsAlloc(_v3#0, 
        Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
          Tclass.Options.Option(Tclass.DiskLayout.Location())), 
        $Heap);
  var ##self#2: DatatypeType;
  var ##ref#1: int;
  var ##succs#2: Seq Box;

    // AddMethodImpl: UpdateAndRemoveLoc, Impl$$IndirectionTableImpl.IndirectionTable.UpdateAndRemoveLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(380,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(381,54)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__UpdateAndRemoveLoc();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(381,55)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(383,54)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#7, graph#7))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#7))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#32: int :: 
                { $Unbox(Map#Elements(graph#7)[$Box(ref#32)]): Seq Box } 
                  { Map#Domain(graph#7)[$Box(ref#32)] } 
                LitInt(0) <= ref#32
                     && ref#32 < 18446744073709551616
                     && Map#Domain(graph#7)[$Box(ref#32)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#7)[$Box(ref#32)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#33: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#33)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#33)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#33)] } 
                  LitInt(0) <= ref#33
                       && ref#33 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#33)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#33)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#33)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#34: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#34)] } 
                  LitInt(0) <= ref#34
                       && ref#34 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#34)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#34)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#35: int :: 
                { Map#Domain(graph#7)[$Box(ref#35)] } 
                LitInt(0) <= ref#35
                     && ref#35 < 18446744073709551616
                     && Map#Domain(graph#7)[$Box(ref#35)]
                   ==> ref#35 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#7: int :: 
                  { Map#Domain(locs#7)[$Box(r#7)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#7)] } 
                  LitInt(0) <= r#7
                       && r#7 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#7)]
                     ==> Map#Domain(locs#7)[$Box(r#7)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    // ProcessCallStmt: CheckSubrange
    t##0 := IndirectionTableModel.IndirectionTable.t(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(383,60)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(384,57)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#8, graph#8))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#8))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#36: int :: 
                { $Unbox(Map#Elements(graph#8)[$Box(ref#36)]): Seq Box } 
                  { Map#Domain(graph#8)[$Box(ref#36)] } 
                LitInt(0) <= ref#36
                     && ref#36 < 18446744073709551616
                     && Map#Domain(graph#8)[$Box(ref#36)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#8)[$Box(ref#36)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#37: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#37)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#37)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#37)] } 
                  LitInt(0) <= ref#37
                       && ref#37 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#37)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#37)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#37)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#38: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#38)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#38)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#38)] } 
                  LitInt(0) <= ref#38
                       && ref#38 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#38)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#38)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#38)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#39: int :: 
                { Map#Domain(graph#8)[$Box(ref#39)] } 
                LitInt(0) <= ref#39
                     && ref#39 < 18446744073709551616
                     && Map#Domain(graph#8)[$Box(ref#39)]
                   ==> ref#39 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#8 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#8 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#8 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#8: int :: 
                  { Map#Domain(locs#8)[$Box(r#8)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#8)] } 
                  LitInt(0) <= r#8
                       && r#8 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#8)]
                     ==> Map#Domain(locs#8)[$Box(r#8)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    // ProcessCallStmt: CheckSubrange
    self##0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    assume true;
    // ProcessCallStmt: CheckSubrange
    ref##0 := ref#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    succs##0 := succs#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.LemmaUpdateAndRemoveLocStuff(self##0, ref##0, succs##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(384,73)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(386,33)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##0 := ref#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntry#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(386,37)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(387,21)
    assume true;
    if (Options.Option.Some_q(oldEntry#0))
    {
        assert Options.Option.Some_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    }
    else
    {
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    }

    assume Options.Option.Some_q(oldEntry#0)
       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    predCount#0 := (if Options.Option.Some_q(oldEntry#0)
       then IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
       else 0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(387,77)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(388,7)
    assume true;
    if (Options.Option.None_q(oldEntry#0))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(389,30)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        x##0_0 := ref#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 || read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$LruImpl.LruImplQueue.Use(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), x##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(389,34)"} true;
    }
    else
    {
    }

    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(391,20)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    // ProcessCallStmt: CheckSubrange
    key##1 := ref#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0));
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), key##1, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(391,77)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(393,54)
    // TrCallStmt: Before ProcessCallStmt
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // ProcessCallStmt: CheckSubrange
    t##1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##1);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(393,65)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(395,23)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    t##2 := read($Heap, this, IndirectionTableImpl.IndirectionTable.t);
    assume true;
    // ProcessCallStmt: CheckSubrange
    assert $Is(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
      Tclass.LruImpl.LruImplQueue());
    q##0 := read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue);
    assume true;
    // ProcessCallStmt: CheckSubrange
    changingRef##0 := ref#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    newSuccs##0 := succs#0;
    if (Options.Option.Some_q(oldEntry#0))
    {
        assert Options.Option.Some_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    }
    else
    {
    }

    assume Options.Option.Some_q(oldEntry#0)
       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    // ProcessCallStmt: CheckSubrange
    oldSuccs##0 := (if Options.Option.Some_q(oldEntry#0)
       then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
       else Seq#Empty(): Seq Box);
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && (read($Heap, t##2, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             || read($Heap, q##0, LruImpl.LruImplQueue.Repr)[$Box($o)])
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableImpl.IndirectionTable.UpdatePredCounts(t##2, q##0, changingRef##0, newSuccs##0, oldSuccs##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(396,62)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(398,54)
    // TrCallStmt: Before ProcessCallStmt
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // ProcessCallStmt: CheckSubrange
    t##3 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##3);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(398,65)"} true;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(402,7)
    assume true;
    if (ref#0 > read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(403,28)
        assume true;
        assert $_Frame[this, IndirectionTableImpl.IndirectionTable.refUpperBound];
        assume true;
        $rhs#1_0 := ref#0;
        $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound, $rhs#1_0);
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(403,33)"} true;
    }
    else
    {
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(406,14)
    assume true;
    if (Options.Option.Some_q(oldEntry#0))
    {
        assert Options.Option.Some_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    }

    if (Options.Option.Some_q(oldEntry#0)
       && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)))
    {
        assert Options.Option.Some_q(oldEntry#0);
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType);
    }
    else
    {
    }

    assume (Options.Option.Some_q(oldEntry#0)
         ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
       && (Options.Option.Some_q(oldEntry#0)
           && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
         ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType));
    oldLoc#0 := (if Options.Option.Some_q(oldEntry#0)
         && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
       then IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
       else #Options.Option.None());
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(406,95)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(407,32)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
    assume true;
    $rhs#0 := Lit(#Options.Option.None());
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator, $rhs#0);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(407,38)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(409,12)
    assume true;
    assert $_Frame[this, IndirectionTableImpl.IndirectionTable.Repr];
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    if (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null)
    {
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    }
    else
    {
    }

    assume true;
    $rhs#1 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)), 
      (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         then read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)
         else Set#Empty(): Set Box));
    $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.Repr, $rhs#1);
    assume $IsGoodHeap($Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(409,103)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(410,19)
    assume true;
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#9, graph#9))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#9))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#40: int :: 
                { $Unbox(Map#Elements(graph#9)[$Box(ref#40)]): Seq Box } 
                  { Map#Domain(graph#9)[$Box(ref#40)] } 
                LitInt(0) <= ref#40
                     && ref#40 < 18446744073709551616
                     && Map#Domain(graph#9)[$Box(ref#40)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#9)[$Box(ref#40)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#41: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#41)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#41)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#41)] } 
                  LitInt(0) <= ref#41
                       && ref#41 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#41)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#41)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#41)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#42: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#42)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#42)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#42)] } 
                  LitInt(0) <= ref#42
                       && ref#42 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#42)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#42)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#42)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#43: int :: 
                { Map#Domain(graph#9)[$Box(ref#43)] } 
                LitInt(0) <= ref#43
                     && ref#43 < 18446744073709551616
                     && Map#Domain(graph#9)[$Box(ref#43)]
                   ==> ref#43
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#9 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#9 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#9 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#9: int :: 
                  { Map#Domain(locs#9)[$Box(r#9)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#9)] } 
                  LitInt(0) <= r#9
                       && r#9 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#9)]
                     ==> Map#Domain(locs#9)[$Box(r#9)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#2 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#2, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    ##ref#1 := ref#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##ref#1, Tclass.NativeTypes.uint64(), $Heap);
    ##succs#2 := succs#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##succs#2, TSeq(Tclass.NativeTypes.uint64()), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#2);
    assume IndirectionTableModel.__default.Inv(##self#2);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#2)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#2)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#2));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#2);
    assert {:subsumption 0} Map#Card(IndirectionTableModel.IndirectionTable.graph(##self#2))
       < IndirectionTableModel.__default.MaxSize();
    assume Map#Card(IndirectionTableModel.IndirectionTable.graph(##self#2))
       < IndirectionTableModel.__default.MaxSize();
    assert {:subsumption 0} Seq#Length(##succs#2) <= LitInt(Bounds.__default.MaxNumChildren());
    assume Seq#Length(##succs#2) <= LitInt(Bounds.__default.MaxNumChildren());
    assert {:subsumption 0} IndirectionTableModel.__default.SuccsValid#canCall(##succs#2, IndirectionTableModel.IndirectionTable.graph(##self#2))
       ==> IndirectionTableModel.__default.SuccsValid(##succs#2, IndirectionTableModel.IndirectionTable.graph(##self#2))
         || (forall ref#44: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#2))[$Box(ref#44)] } 
            { Seq#Contains(##succs#2, $Box(ref#44)) } 
          LitInt(0) <= ref#44
               && ref#44 < 18446744073709551616
               && Seq#Contains(##succs#2, $Box(ref#44))
             ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(##self#2))[$Box(ref#44)]);
    assume IndirectionTableModel.__default.SuccsValid(##succs#2, IndirectionTableModel.IndirectionTable.graph(##self#2));
    assume IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, succs#0);
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
        ref#0, 
        succs#0));
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
       && IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this), ref#0, succs#0);
    _v3#0 := IndirectionTableModel.__default.UpdateAndRemoveLoc(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this), 
      ref#0, 
      succs#0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(410,83)"} true;
}



function Tclass.GenericMarshalling.V() : Ty;

// Tclass.GenericMarshalling.V Tag
axiom Tag(Tclass.GenericMarshalling.V()) == Tagclass.GenericMarshalling.V;

const unique Tagclass.GenericMarshalling.V: TyTag;

// Box/unbox axiom for Tclass.GenericMarshalling.V
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.GenericMarshalling.V()) } 
  $IsBox(bx, Tclass.GenericMarshalling.V())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.GenericMarshalling.V()));

procedure {:_induction a#0} CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap), 
    i#0: int);
  free requires 29 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function IndirectionTableModel.__default.valToHashMap#Handle(LayerType) : HandleType;

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($ly), 
      $fh$0x#0) } 
  Apply1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($ly), 
      $fh$0x#0)
     == $Box(IndirectionTableModel.__default.valToHashMap($ly, $Unbox($fh$0x#0): Seq Box)));

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($ly), 
      $fh$0x#0) } 
  Requires1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($ly), 
      $fh$0x#0)
     == IndirectionTableModel.__default.valToHashMap#requires($ly, $Unbox($fh$0x#0): Seq Box));

axiom (forall $bx: Box, $ly: LayerType, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($ly), 
      $fh$0x#0)[$bx] } 
  Reads1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($ly), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $ly: LayerType, $heap: Heap, $fh$0x#0: Seq Box :: 
  { IndirectionTableModel.__default.valToHashMap($ly, $fh$0x#0), $IsGoodHeap($heap) } 
  IndirectionTableModel.__default.valToHashMap($ly, $fh$0x#0)
     == $Unbox(Apply1(TSeq(Tclass.GenericMarshalling.V()), 
        Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
        $heap, 
        IndirectionTableModel.__default.valToHashMap#Handle($ly), 
        $Box($fh$0x#0))): DatatypeType);

implementation {:_induction a#0} CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a#0: Seq Box, i#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: Seq Box;
  var ##a#0: Seq Box;
  var ##a#1: Seq Box;

    // AddMethodImpl: lemma_valToHashMapNonePrefix, CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(415,17): initial state"} true;
    assert true;
    ##x0#0 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
    assume Requires1#canCall(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $Heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($LS($LZ)), 
      $Box(a#0));
    assume Requires1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $Heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($LS($LZ)), 
      $Box(a#0));
    if (LitInt(0) <= i#0)
    {
    }

    assume LitInt(0) <= i#0 && i#0 <= Seq#Length(a#0);
    assert 0 <= i#0 && i#0 <= Seq#Length(a#0);
    ##a#0 := Seq#Take(a#0, i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
    assert {:subsumption 0} Seq#Length(##a#0) <= LitInt(IndirectionTableModel.__default.MaxSize());
    assume Seq#Length(##a#0) <= LitInt(IndirectionTableModel.__default.MaxSize());
    assert {:subsumption 0} (forall i#1: int :: 
      { $Unbox(Seq#Index(##a#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(##a#0)
         ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
          $Unbox(Seq#Index(##a#0, i#1)): DatatypeType));
    assume (forall i#1: int :: 
      { $Unbox(Seq#Index(##a#0, i#1)): DatatypeType } 
      LitInt(0) <= i#1 && i#1 < Seq#Length(##a#0)
         ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
          $Unbox(Seq#Index(##a#0, i#1)): DatatypeType));
    assert {:subsumption 0} (forall i#2: int :: 
      { $Unbox(Seq#Index(##a#0, i#2)): DatatypeType } 
      LitInt(0) <= i#2 && i#2 < Seq#Length(##a#0)
         ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
          $Unbox(Seq#Index(##a#0, i#2)): DatatypeType, 
          Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                    $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
    assume (forall i#2: int :: 
      { $Unbox(Seq#Index(##a#0, i#2)): DatatypeType } 
      LitInt(0) <= i#2 && i#2 < Seq#Length(##a#0)
         ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          $Unbox(Seq#Index(##a#0, i#2)): DatatypeType, 
          Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                    $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
    assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#0));
    assume Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(a#0, i#0)));
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(419,50): post-state"} true;
    ##a#1 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##a#1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
    assert {:subsumption 0} Seq#Length(##a#1) <= LitInt(IndirectionTableModel.__default.MaxSize());
    assume Seq#Length(##a#1) <= LitInt(IndirectionTableModel.__default.MaxSize());
    assert {:subsumption 0} (forall i#3: int :: 
      { $Unbox(Seq#Index(##a#1, i#3)): DatatypeType } 
      LitInt(0) <= i#3 && i#3 < Seq#Length(##a#1)
         ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
          $Unbox(Seq#Index(##a#1, i#3)): DatatypeType));
    assume (forall i#3: int :: 
      { $Unbox(Seq#Index(##a#1, i#3)): DatatypeType } 
      LitInt(0) <= i#3 && i#3 < Seq#Length(##a#1)
         ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
          $Unbox(Seq#Index(##a#1, i#3)): DatatypeType));
    assert {:subsumption 0} (forall i#4: int :: 
      { $Unbox(Seq#Index(##a#1, i#4)): DatatypeType } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##a#1)
         ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
          $Unbox(Seq#Index(##a#1, i#4)): DatatypeType, 
          Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                    $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
    assume (forall i#4: int :: 
      { $Unbox(Seq#Index(##a#1, i#4)): DatatypeType } 
      LitInt(0) <= i#4 && i#4 < Seq#Length(##a#1)
         ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          $Unbox(Seq#Index(##a#1, i#4)): DatatypeType, 
          Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                    $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
    assume IndirectionTableModel.__default.valToHashMap#canCall(a#0);
    assume Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0));
}



procedure {:_induction a#0} Call$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap), 
    i#0: int);
  // user-defined preconditions
  requires Requires1(TSeq(Tclass.GenericMarshalling.V()), 
    Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
    $Heap, 
    IndirectionTableModel.__default.valToHashMap#Handle($LS($LS($LZ))), 
    $Box(a#0));
  requires LitInt(0) <= i#0;
  requires i#0 <= Seq#Length(a#0);
  requires Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(a#0, i#0)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.__default.valToHashMap#canCall(a#0);
  ensures Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), a#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:_induction a#0} Impl$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap), 
    i#0: int)
   returns ($_reverifyPost: bool);
  free requires 29 == $FunctionContextHeight;
  // user-defined preconditions
  requires Requires1(TSeq(Tclass.GenericMarshalling.V()), 
    Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
    $Heap, 
    IndirectionTableModel.__default.valToHashMap#Handle($LS($LS($LZ))), 
    $Box(a#0));
  requires LitInt(0) <= i#0;
  requires i#0 <= Seq#Length(a#0);
  requires Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(a#0, i#0)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.__default.valToHashMap#canCall(a#0);
  ensures Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), a#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation {:_induction a#0} Impl$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a#0: Seq Box, i#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $initHeapForallStmt#0: Heap;
  var ##a#2: Seq Box;
  var ##run#0: Seq Box;
  var ##run#1: Seq Box;
  var a##0: Seq Box;
  var i##0: int;

    // AddMethodImpl: lemma_valToHashMapNonePrefix, Impl$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(421,4): initial state"} true;
    $initHeapForallStmt#0 := $Heap;
    havoc $Heap, $Tick;
    assume $initHeapForallStmt#0 == $Heap;
    assume (forall $ih#a0#0: Seq Box :: 
      $Is($ih#a0#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Requires1(TSeq(Tclass.GenericMarshalling.V()), 
            Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
            $initHeapForallStmt#0, 
            IndirectionTableModel.__default.valToHashMap#Handle($LS($LZ)), 
            $Box($ih#a0#0))
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length($ih#a0#0)
           && Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take($ih#a0#0, i#0)))
           && 
          0 <= Seq#Length($ih#a0#0) - i#0
           && Seq#Length($ih#a0#0) - i#0 < Seq#Length(a#0) - i#0
         ==> Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), $ih#a0#0)));
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(422,7)
    assume true;
    if (i#0 == Seq#Length(a#0))
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(423,9)
        assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(a#0);
        assume true;
        assert Seq#Equal(Seq#Take(a#0, i#0), a#0);
    }
    else
    {
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(425,9)
        assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(a#0);
        ##a#2 := Seq#Take(a#0, i#0 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#2, TSeq(Tclass.GenericMarshalling.V()), $Heap);
        assert {:subsumption 0} Seq#Length(##a#2) <= LitInt(IndirectionTableModel.__default.MaxSize());
        assert {:subsumption 0} (forall i#5: int :: 
          { $Unbox(Seq#Index(##a#2, i#5)): DatatypeType } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(##a#2)
             ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(##a#2, i#5)): DatatypeType));
        assert {:subsumption 0} (forall i#6: int :: 
          { $Unbox(Seq#Index(##a#2, i#6)): DatatypeType } 
          LitInt(0) <= i#6 && i#6 < Seq#Length(##a#2)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(##a#2, i#6)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
        assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#0 + 1));
        assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#0 + 1));
        if (*)
        {
            // ----- assert statement proof ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(425,9)
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(426,11)
            assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(a#0);
            ##run#0 := Seq#Take(a#0, i#0 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#0) > 0;
            assume Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1));
            assert {:subsumption 0} 0 <= i#0 && i#0 <= Seq#Length(a#0);
            assume Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1));
            assert Seq#Equal(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1)), 
              Seq#Take(a#0, i#0));
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(427,11)
            assert {:subsumption 0} 0 <= i#0 + 1 && i#0 + 1 <= Seq#Length(a#0);
            ##run#1 := Seq#Take(a#0, i#0 + 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##run#1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assert {:subsumption 0} Seq#Length(##run#1) > 0;
            assume Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1));
            assert {:subsumption 0} 0 <= i#0 && i#0 < Seq#Length(a#0);
            assume $IsA#GenericMarshalling.V($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1))): DatatypeType)
               && $IsA#GenericMarshalling.V($Unbox(Seq#Index(a#0, i#0)): DatatypeType)
               && Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1));
            assert GenericMarshalling.V#Equal($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#0 + 1))): DatatypeType, 
              $Unbox(Seq#Index(a#0, i#0)): DatatypeType);
            assert {:subsumption 0} Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(a#0, i#0 + 1)));
            assume false;
        }

        assume Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(a#0, i#0 + 1)));
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(429,37)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0 := a#0;
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##0 := i#0 + 1;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assert 0 <= Seq#Length(a#0) - i#0 || Seq#Length(a##0) - i##0 == Seq#Length(a#0) - i#0;
        assert Seq#Length(a##0) - i##0 < Seq#Length(a#0) - i#0;
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a##0, i##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(429,44)"} true;
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.ValToHashMap(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap))
   returns (s#0: DatatypeType
       where $Is(s#0, 
          Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())))
         && $IsAlloc(s#0, 
          Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())), 
          $Heap));
  free requires 30 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.ValToHashMap(a#0: Seq Box) returns (s#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: Seq Box;
  var ##a#0: Seq Box;
  var ##a#1: Seq Box;
  var newtype$check#0: int;
  var newtype$check#1: int;

    // AddMethodImpl: ValToHashMap, CheckWellformed$$IndirectionTableImpl.IndirectionTable.ValToHashMap
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS($LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar)));
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS($LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar))));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(433,41): initial state"} true;
    assert true;
    ##x0#0 := a#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
    assume Requires1#canCall(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $Heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($LS($LZ)), 
      $Box(a#0));
    assume Requires1(TSeq(Tclass.GenericMarshalling.V()), 
      Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
      $Heap, 
      IndirectionTableModel.__default.valToHashMap#Handle($LS($LZ)), 
      $Box(a#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc s#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(435,20): post-state"} true;
    if (*)
    {
        assume Options.Option.None_q(s#0);
        ##a#0 := a#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
        assert {:subsumption 0} Seq#Length(##a#0) <= LitInt(IndirectionTableModel.__default.MaxSize());
        assume Seq#Length(##a#0) <= LitInt(IndirectionTableModel.__default.MaxSize());
        assert {:subsumption 0} (forall i#0: int :: 
          { $Unbox(Seq#Index(##a#0, i#0)): DatatypeType } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(##a#0)
             ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(##a#0, i#0)): DatatypeType));
        assume (forall i#0: int :: 
          { $Unbox(Seq#Index(##a#0, i#0)): DatatypeType } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(##a#0)
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(##a#0, i#0)): DatatypeType));
        assert {:subsumption 0} (forall i#1: int :: 
          { $Unbox(Seq#Index(##a#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(##a#0)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(##a#0, i#1)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
        assume (forall i#1: int :: 
          { $Unbox(Seq#Index(##a#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(##a#0)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(##a#0, i#1)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
        assume IndirectionTableModel.__default.valToHashMap#canCall(a#0);
        assume Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0));
    }
    else
    {
        assume Options.Option.None_q(s#0)
           ==> Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0));
    }

    if (*)
    {
        assume Options.Option.Some_q(s#0);
        assert Options.Option.Some_q(s#0);
        assert $Unbox(Options.Option.value(s#0)): ref != null;
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          $Unbox(Options.Option.value(s#0)): ref);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          $Unbox(Options.Option.value(s#0)): ref);
    }
    else
    {
        assume Options.Option.Some_q(s#0)
           ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            $Unbox(Options.Option.value(s#0)): ref);
    }

    if (*)
    {
        assume Options.Option.Some_q(s#0);
        assert Options.Option.Some_q(s#0);
        assert $Unbox(Options.Option.value(s#0)): ref != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          $Unbox(Options.Option.value(s#0)): ref);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          $Unbox(Options.Option.value(s#0)): ref);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          $Unbox(Options.Option.value(s#0)): ref);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            $Unbox(Options.Option.value(s#0)): ref));
        ##a#1 := a#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##a#1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
        assert {:subsumption 0} Seq#Length(##a#1) <= LitInt(IndirectionTableModel.__default.MaxSize());
        assume Seq#Length(##a#1) <= LitInt(IndirectionTableModel.__default.MaxSize());
        assert {:subsumption 0} (forall i#2: int :: 
          { $Unbox(Seq#Index(##a#1, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(##a#1)
             ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(##a#1, i#2)): DatatypeType));
        assume (forall i#2: int :: 
          { $Unbox(Seq#Index(##a#1, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(##a#1)
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(##a#1, i#2)): DatatypeType));
        assert {:subsumption 0} (forall i#3: int :: 
          { $Unbox(Seq#Index(##a#1, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(##a#1)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(##a#1, i#3)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
        assume (forall i#3: int :: 
          { $Unbox(Seq#Index(##a#1, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(##a#1)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(##a#1, i#3)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
        assume IndirectionTableModel.__default.valToHashMap#canCall(a#0);
        assume Options.Option#Equal(#Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                $Unbox(Options.Option.value(s#0)): ref))), 
          IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0));
    }
    else
    {
        assume Options.Option.Some_q(s#0)
           ==> Options.Option#Equal(#Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  $Unbox(Options.Option.value(s#0)): ref))), 
            IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0));
    }

    if (*)
    {
        assume Options.Option.Some_q(s#0);
        assert Options.Option.Some_q(s#0);
        assert $Unbox(Options.Option.value(s#0)): ref != null;
        newtype$check#0 := read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count);
        assert LitInt(0) <= newtype$check#0;
        assume read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
           == Seq#Length(a#0);
    }
    else
    {
        assume Options.Option.Some_q(s#0)
           ==> read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
             == Seq#Length(a#0);
    }

    if (*)
    {
        assume Options.Option.Some_q(s#0);
        assert Options.Option.Some_q(s#0);
        assert $Unbox(Options.Option.value(s#0)): ref != null;
        newtype$check#1 := read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count);
        assert LitInt(0) <= newtype$check#1;
        assert LitInt(8) != 0;
        assume read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
           < Div(18446744073709551616, LitInt(8));
    }
    else
    {
        assume Options.Option.Some_q(s#0)
           ==> read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
             < Div(18446744073709551616, LitInt(8));
    }

    if (*)
    {
        assume Options.Option.Some_q(s#0);
        assert Options.Option.Some_q(s#0);
        assume $Unbox(Options.Option.value(s#0)): ref != null
           && !read(old($Heap), $Unbox(Options.Option.value(s#0)): ref, alloc);
        assert Options.Option.Some_q(s#0);
        assert $Unbox(Options.Option.value(s#0)): ref != null;
        assume (forall $o: ref :: 
          { read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
          read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
    }
    else
    {
        assume Options.Option.Some_q(s#0)
           ==> $Unbox(Options.Option.value(s#0)): ref != null
             && !read(old($Heap), $Unbox(Options.Option.value(s#0)): ref, alloc)
             && (forall $o: ref :: 
              { read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
              read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
    }
}



procedure Call$$IndirectionTableImpl.IndirectionTable.ValToHashMap(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap))
   returns (s#0: DatatypeType
       where $Is(s#0, 
          Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())))
         && $IsAlloc(s#0, 
          Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())), 
          $Heap));
  // user-defined preconditions
  requires Requires1(TSeq(Tclass.GenericMarshalling.V()), 
    Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
    $Heap, 
    IndirectionTableModel.__default.valToHashMap#Handle($LS($LS($LZ))), 
    $Box(a#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Options.Option.None_q(s#0)
     ==> IndirectionTableModel.__default.valToHashMap#canCall(a#0);
  ensures Options.Option.None_q(s#0)
     ==> Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), a#0));
  free ensures Options.Option.Some_q(s#0)
     ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      $Unbox(Options.Option.value(s#0)): ref);
  ensures Options.Option.Some_q(s#0)
     ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      $Unbox(Options.Option.value(s#0)): ref);
  free ensures Options.Option.Some_q(s#0)
     ==> $IsA#Options.Option(IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0))
       && 
      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        $Unbox(Options.Option.value(s#0)): ref)
       && IndirectionTableModel.__default.valToHashMap#canCall(a#0);
  ensures Options.Option.Some_q(s#0)
     ==> Options.Option#Equal(#Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            $Unbox(Options.Option.value(s#0)): ref))), 
      IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), a#0));
  free ensures true;
  ensures Options.Option.Some_q(s#0)
     ==> read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
       == Seq#Length(a#0);
  free ensures true;
  ensures Options.Option.Some_q(s#0)
     ==> read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
       < Div(18446744073709551616, LitInt(8));
  free ensures true;
  ensures Options.Option.Some_q(s#0)
     ==> $Unbox(Options.Option.value(s#0)): ref != null
       && !read(old($Heap), $Unbox(Options.Option.value(s#0)): ref, alloc);
  ensures Options.Option.Some_q(s#0)
     ==> (forall $o: ref :: 
      { read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
      read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.ValToHashMap(a#0: Seq Box
       where $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap))
   returns (s#0: DatatypeType
       where $Is(s#0, 
          Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())))
         && $IsAlloc(s#0, 
          Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())), 
          $Heap), 
    $_reverifyPost: bool);
  free requires 30 == $FunctionContextHeight;
  // user-defined preconditions
  requires Requires1(TSeq(Tclass.GenericMarshalling.V()), 
    Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry())), 
    $Heap, 
    IndirectionTableModel.__default.valToHashMap#Handle($LS($LS($LZ))), 
    $Box(a#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures Options.Option.None_q(s#0)
     ==> IndirectionTableModel.__default.valToHashMap#canCall(a#0);
  ensures Options.Option.None_q(s#0)
     ==> Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), a#0));
  free ensures Options.Option.Some_q(s#0)
     ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      $Unbox(Options.Option.value(s#0)): ref);
  ensures Options.Option.Some_q(s#0)
     ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      $Unbox(Options.Option.value(s#0)): ref);
  free ensures Options.Option.Some_q(s#0)
     ==> $IsA#Options.Option(IndirectionTableModel.__default.valToHashMap($LS($LZ), a#0))
       && 
      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        $Unbox(Options.Option.value(s#0)): ref)
       && IndirectionTableModel.__default.valToHashMap#canCall(a#0);
  ensures Options.Option.Some_q(s#0)
     ==> Options.Option#Equal(#Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            $Unbox(Options.Option.value(s#0)): ref))), 
      IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), a#0));
  free ensures true;
  ensures Options.Option.Some_q(s#0)
     ==> read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
       == Seq#Length(a#0);
  free ensures true;
  ensures Options.Option.Some_q(s#0)
     ==> read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Count)
       < Div(18446744073709551616, LitInt(8));
  free ensures true;
  ensures Options.Option.Some_q(s#0)
     ==> $Unbox(Options.Option.value(s#0)): ref != null
       && !read(old($Heap), $Unbox(Options.Option.value(s#0)): ref, alloc);
  ensures Options.Option.Some_q(s#0)
     ==> (forall $o: ref :: 
      { read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
      read($Heap, $Unbox(Options.Option.value(s#0)): ref, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.ValToHashMap(a#0: Seq Box) returns (s#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var i#4: int where LitInt(0) <= i#4 && i#4 < 18446744073709551616;
  var newtype$check#2: int;
  var mutMap#0: ref
     where $Is(mutMap#0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(mutMap#0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $nw: ref;
  var size##0: int;
  var newtype$check#3: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: int;
  var $w$loop#0: bool;
  var ##a#2: Seq Box;
  var newtype$check#4: int;
  var newtype$check#5: int;
  var $decr$loop#00: int;
  var tuple#0_0: DatatypeType
     where $Is(tuple#0_0, Tclass.GenericMarshalling.V())
       && $IsAlloc(tuple#0_0, Tclass.GenericMarshalling.V(), $Heap);
  var ref#0_0: int where LitInt(0) <= ref#0_0 && ref#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var addr#0_0: int where LitInt(0) <= addr#0_0 && addr#0_0 < 18446744073709551616;
  var newtype$check#0_1: int;
  var len#0_0: int where LitInt(0) <= len#0_0 && len#0_0 < 18446744073709551616;
  var newtype$check#0_2: int;
  var succs#0_0: Seq Box
     where $Is(succs#0_0, TSeq(Tclass.NativeTypes.uint64()))
       && $IsAlloc(succs#0_0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
  var newtype$check#0_3: int;
  var graphRef#0_0: DatatypeType
     where $Is(graphRef#0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(graphRef#0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0_0: int;
  var loc#0_0: DatatypeType
     where $Is(loc#0_0, Tclass.DiskLayout.Location())
       && $IsAlloc(loc#0_0, Tclass.DiskLayout.Location(), $Heap);
  var ##val#0_0: DatatypeType;
  var ##val#0_1: DatatypeType;
  var newtype$check#0_4: int;
  var newtype$check#0_5: int;
  var ##run#0_0: Seq Box;
  var newtype$check#0_6: int;
  var newtype$check#0_7: int;
  var ##run#0_1: Seq Box;
  var ##loc#0_0: DatatypeType;
  var newtype$check#0_8: int;
  var a##0_0_0: Seq Box;
  var i##0_0_0: int;
  var newtype$check#0_0_0: int;
  var newtype$check#0_0_1: int;
  var key##0_1: int;
  var value##0_0: Box;
  var newtype$check#0_9: int;
  var newtype$check#0_10: int;
  var newtype$check#0_11: int;

    // AddMethodImpl: ValToHashMap, Impl$$IndirectionTableImpl.IndirectionTable.ValToHashMap
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS($LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar)));
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS($LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar))));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(441,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(442,21)
    assume true;
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    i#4 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(442,24)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(443,18)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(443,21)
    // TrCallStmt: Before ProcessCallStmt
    newtype$check#3 := LitInt(1024);
    assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    size##0 := LitInt(1024);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$MutableMap.ResizingHashMap.__ctor(Tclass.IndirectionTableModel.Entry(), size##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(443,85)"} true;
    mutMap#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(443,85)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(445,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := Seq#Length(a#0) - i#4;
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= i#4;
      invariant $w$loop#0 ==> i#4 <= Seq#Length(a#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
      invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall $o: ref :: 
          { read($Heap, mutMap#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
          read($Heap, mutMap#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
      free invariant $w$loop#0
         ==> $IsA#Options.Option(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(a#0, i#4)))
           && 
          IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#4))
           && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
      invariant $w$loop#0
         ==> Options.Option#Equal(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(a#0, i#4)), 
          #Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0))));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant Seq#Length(a#0) - i#4 <= $decr_init$loop#00
         && (Seq#Length(a#0) - i#4 == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(445,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            if (LitInt(0) <= i#4)
            {
            }

            assume true;
            assume LitInt(0) <= i#4 && i#4 <= Seq#Length(a#0);
            assert {:subsumption 0} mutMap#0 != null;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
            assert {:subsumption 0} mutMap#0 != null;
            assume true;
            assume (forall $o: ref :: 
              { read($Heap, mutMap#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
              read($Heap, mutMap#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
            assert {:subsumption 0} 0 <= i#4 && i#4 <= Seq#Length(a#0);
            ##a#2 := Seq#Take(a#0, i#4);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#2, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assert {:subsumption 0} Seq#Length(##a#2) <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} (forall i#5: int :: 
              { $Unbox(Seq#Index(##a#2, i#5)): DatatypeType } 
              LitInt(0) <= i#5 && i#5 < Seq#Length(##a#2)
                 ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
                  $Unbox(Seq#Index(##a#2, i#5)): DatatypeType));
            assert {:subsumption 0} (forall i#6: int :: 
              { $Unbox(Seq#Index(##a#2, i#6)): DatatypeType } 
              LitInt(0) <= i#6 && i#6 < Seq#Length(##a#2)
                 ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                  $Unbox(Seq#Index(##a#2, i#6)): DatatypeType, 
                  Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
            assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#4));
            assert {:subsumption 0} mutMap#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0));
            assume $IsA#Options.Option(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(a#0, i#4)))
               && 
              IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#4))
               && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
            assume Options.Option#Equal(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(a#0, i#4)), 
              #Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0))));
            newtype$check#4 := Seq#Length(a#0);
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            assume true;
            assume false;
        }

        newtype$check#5 := Seq#Length(a#0);
        assert LitInt(0) <= newtype$check#5 && newtype$check#5 < 18446744073709551616;
        assume true;
        if (Seq#Length(a#0) <= i#4)
        {
            break;
        }

        $decr$loop#00 := Seq#Length(a#0) - i#4;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(451,19)
        assume true;
        assert 0 <= i#4 && i#4 < Seq#Length(a#0);
        assume true;
        tuple#0_0 := $Unbox(Seq#Index(a#0, i#4)): DatatypeType;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(451,25)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(452,17)
        assume true;
        assert GenericMarshalling.V.VTuple_q(tuple#0_0);
        newtype$check#0_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assert 0 <= LitInt(0) && LitInt(0) < Seq#Length(GenericMarshalling.V.t(tuple#0_0));
        assert GenericMarshalling.V.VUint64_q($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(0))): DatatypeType);
        assume true;
        ref#0_0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(0))): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(452,41)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(453,18)
        assume true;
        assert GenericMarshalling.V.VTuple_q(tuple#0_0);
        newtype$check#0_1 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        assert 0 <= LitInt(1) && LitInt(1) < Seq#Length(GenericMarshalling.V.t(tuple#0_0));
        assert GenericMarshalling.V.VUint64_q($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(1))): DatatypeType);
        assume true;
        addr#0_0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(1))): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(453,42)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(454,17)
        assume true;
        assert GenericMarshalling.V.VTuple_q(tuple#0_0);
        newtype$check#0_2 := LitInt(2);
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assert 0 <= LitInt(2) && LitInt(2) < Seq#Length(GenericMarshalling.V.t(tuple#0_0));
        assert GenericMarshalling.V.VUint64_q($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(2))): DatatypeType);
        assume true;
        len#0_0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(2))): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(454,41)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(455,19)
        assume true;
        assert GenericMarshalling.V.VTuple_q(tuple#0_0);
        newtype$check#0_3 := LitInt(3);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        assert 0 <= LitInt(3) && LitInt(3) < Seq#Length(GenericMarshalling.V.t(tuple#0_0));
        assert GenericMarshalling.V.VUint64Array_q($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType);
        assume true;
        succs#0_0 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(455,44)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(456,35)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert mutMap#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        key##0_0 := ref#0_0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), mutMap#0, key##0_0);
        // TrCallStmt: After ProcessCallStmt
        graphRef#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(456,39)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(457,17)
        assume true;
        assume true;
        loc#0_0 := #DiskLayout.Location.Location(addr#0_0, len#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(457,38)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(459,9)
        ##val#0_0 := tuple#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##val#0_0, Tclass.GenericMarshalling.V(), $Heap);
        assume GenericMarshalling.__default.ValidVal#canCall(tuple#0_0);
        assume GenericMarshalling.__default.ValidVal#canCall(tuple#0_0);
        assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, tuple#0_0);
        assume GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, tuple#0_0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(460,9)
        assert GenericMarshalling.V.VTuple_q(tuple#0_0);
        assert {:subsumption 0} 0 <= LitInt(3) && LitInt(3) < Seq#Length(GenericMarshalling.V.t(tuple#0_0));
        ##val#0_1 := $Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType;
        // assume allocatedness for argument to function
        assume $IsAlloc(##val#0_1, Tclass.GenericMarshalling.V(), $Heap);
        assume GenericMarshalling.__default.ValidVal#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType);
        assume GenericMarshalling.__default.ValidVal#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType);
        assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
          $Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType);
        assume GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
          $Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0_0), LitInt(3))): DatatypeType);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(461,9)
        assume true;
        assert Seq#Length(succs#0_0) < 18446744073709551616;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(463,9)
        newtype$check#0_4 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        newtype$check#0_5 := i#4 + 1;
        assert LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#4 + 1 && i#4 + 1 <= Seq#Length(a#0);
        ##run#0_0 := Seq#Take(a#0, i#4 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0_0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
        assert {:subsumption 0} Seq#Length(##run#0_0) > 0;
        assume Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1));
        assert {:subsumption 0} 0 <= i#4 && i#4 <= Seq#Length(a#0);
        assume Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1));
        assert Seq#Equal(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1)), 
          Seq#Take(a#0, i#4));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(464,9)
        newtype$check#0_6 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_6 && newtype$check#0_6 < 18446744073709551616;
        newtype$check#0_7 := i#4 + 1;
        assert LitInt(0) <= newtype$check#0_7 && newtype$check#0_7 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#4 + 1 && i#4 + 1 <= Seq#Length(a#0);
        ##run#0_1 := Seq#Take(a#0, i#4 + 1);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0_1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
        assert {:subsumption 0} Seq#Length(##run#0_1) > 0;
        assume Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1));
        assert {:subsumption 0} 0 <= i#4 && i#4 < Seq#Length(a#0);
        assume $IsA#GenericMarshalling.V($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1))): DatatypeType)
           && $IsA#GenericMarshalling.V($Unbox(Seq#Index(a#0, i#4)): DatatypeType)
           && Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1));
        assert GenericMarshalling.V#Equal($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Seq#Take(a#0, i#4 + 1))): DatatypeType, 
          $Unbox(Seq#Index(a#0, i#4)): DatatypeType);
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(466,9)
        if (!Options.Option.Some_q(graphRef#0_0))
        {
            ##loc#0_0 := loc#0_0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##loc#0_0, Tclass.DiskLayout.Location(), $Heap);
            assume DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0);
        }

        if (!(Options.Option.Some_q(graphRef#0_0)
           || !DiskLayout.__default.ValidNodeLocation(loc#0_0)))
        {
            newtype$check#0_8 := Seq#Length(succs#0_0);
            assert LitInt(0) <= newtype$check#0_8 && newtype$check#0_8 < 18446744073709551616;
            assume Bounds.__default.MaxNumChildrenUint64#canCall();
        }

        assume (!Options.Option.Some_q(graphRef#0_0)
             ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0))
           && (DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0)
               && DiskLayout.__default.ValidNodeLocation(loc#0_0)
             ==> Bounds.__default.MaxNumChildrenUint64#canCall());
        if (Options.Option.Some_q(graphRef#0_0)
           || !DiskLayout.__default.ValidNodeLocation(loc#0_0)
           || Seq#Length(succs#0_0) > Bounds.__default.MaxNumChildrenUint64())
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(468,39)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            // ProcessCallStmt: CheckSubrange
            a##0_0_0 := a#0;
            newtype$check#0_0_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_0 && newtype$check#0_0_0 < 18446744073709551616;
            newtype$check#0_0_1 := i#4 + 1;
            assert LitInt(0) <= newtype$check#0_0_1 && newtype$check#0_0_1 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##0_0_0 := i#4 + 1;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$IndirectionTableImpl.IndirectionTable.lemma__valToHashMapNonePrefix(a##0_0_0, i##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(468,55)"} true;
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(469,11)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(469,11)
            assume true;
            assume true;
            s#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(469,21)"} true;
            return;
        }
        else
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(471,24)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            assert mutMap#0 != null;
            assume true;
            // ProcessCallStmt: CheckSubrange
            key##0_1 := ref#0_0;
            newtype$check#0_9 := LitInt(0);
            assert LitInt(0) <= newtype$check#0_9 && newtype$check#0_9 < 18446744073709551616;
            assume true;
            // ProcessCallStmt: CheckSubrange
            value##0_0 := $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0_0)), succs#0_0, LitInt(0)));
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && read($Heap, mutMap#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), mutMap#0, key##0_1, value##0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(471,78)"} true;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(472,13)
            assume true;
            newtype$check#0_10 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_10 && newtype$check#0_10 < 18446744073709551616;
            newtype$check#0_11 := i#4 + 1;
            assert LitInt(0) <= newtype$check#0_11 && newtype$check#0_11 < 18446744073709551616;
            assume true;
            i#4 := i#4 + 1;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(472,20)"} true;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(445,7)
        assert 0 <= $decr$loop#00 || Seq#Length(a#0) - i#4 == $decr$loop#00;
        assert Seq#Length(a#0) - i#4 < $decr$loop#00;
        assume true;
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
        assume true;
        assume $IsA#Options.Option(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(a#0, i#4)))
           && 
          IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(a#0, i#4))
           && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, mutMap#0);
    }

    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(476,7)
    assert {:subsumption 0} 0 <= i#4 && i#4 <= Seq#Length(a#0);
    assume true;
    assert Seq#Equal(Seq#Take(a#0, i#4), a#0);
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(477,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(477,7)
    assume true;
    assume true;
    s#0 := #Options.Option.Some($Box(mutMap#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(477,25)"} true;
    return;
}



function Tclass.MutableMap.ResizingHashMap?(Ty) : Ty;

// Tclass.MutableMap.ResizingHashMap? Tag
axiom (forall MutableMap.ResizingHashMap$V: Ty :: 
  { Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  Tag(Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V))
     == Tagclass.MutableMap.ResizingHashMap?);

const unique Tagclass.MutableMap.ResizingHashMap?: TyTag;

// Tclass.MutableMap.ResizingHashMap? injectivity 0
axiom (forall MutableMap.ResizingHashMap$V: Ty :: 
  { Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  Tclass.MutableMap.ResizingHashMap?_0(Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V))
     == MutableMap.ResizingHashMap$V);

function Tclass.MutableMap.ResizingHashMap?_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMap.ResizingHashMap?
axiom (forall MutableMap.ResizingHashMap$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)) } 
  $IsBox(bx, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, 
        Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)));

procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (t'#0: ref
       where $Is(t'#0, Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t'#0, 
          Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()), 
          $Heap));
  free requires 31 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts(t#0: ref) returns (t'#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ref#0: int;
  var newtype$check#0: int;
  var ref#2: int;
  var ##t#0: DatatypeType;
  var ##t#1: DatatypeType;

    // AddMethodImpl: ComputeRefCounts, CheckWellformed$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(480,18): initial state"} true;
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    havoc ref#0;
    assume LitInt(0) <= ref#0 && ref#0 < 18446744073709551616;
    if (*)
    {
        assert t#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
        assert t#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assert Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)];
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType);
        newtype$check#0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
        assume IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
           == LitInt(0);
    }
    else
    {
        assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]
           ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#0)]): DatatypeType)
             == LitInt(0);
    }

    assume (forall ref#1: int :: 
      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]): DatatypeType } 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)] } 
      LitInt(0) <= ref#1
           && ref#1 < 18446744073709551616
           && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]
         ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]): DatatypeType)
           == LitInt(0));
    havoc ref#2;
    assume LitInt(0) <= ref#2 && ref#2 < 18446744073709551616;
    if (*)
    {
        assert t#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#2)];
        assert t#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assert Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#2)];
        assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#2)]): DatatypeType);
        assume Bounds.__default.MaxNumChildren#canCall();
        assume Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#2)]): DatatypeType))
           <= LitInt(Bounds.__default.MaxNumChildren());
    }
    else
    {
        assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#2)]
           ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#2)]): DatatypeType))
             <= LitInt(Bounds.__default.MaxNumChildren());
    }

    assume (forall ref#3: int :: 
      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]): DatatypeType } 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)] } 
      LitInt(0) <= ref#3
           && ref#3 < 18446744073709551616
           && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]
         ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]): DatatypeType))
           <= LitInt(Bounds.__default.MaxNumChildren()));
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume IndirectionTableModel.__default.MaxSize#canCall();
    assume MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
       <= LitInt(IndirectionTableModel.__default.MaxSize());
    assume PivotBetreeGraph.__default.Root#canCall();
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc t'#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(487,23): post-state"} true;
    if (*)
    {
        assume t'#0 == null;
        assert t#0 != null;
        assert $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          old($Heap));
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
        ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap);
        assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
        assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
        assert {:subsumption 0} (forall ref#4: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)] } 
          LitInt(0) <= ref#4
               && ref#4 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)]): DatatypeType)
               == LitInt(0));
        assume (forall ref#4: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)] } 
          LitInt(0) <= ref#4
               && ref#4 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#4)]): DatatypeType)
               == LitInt(0));
        assert {:subsumption 0} (forall ref#5: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)] } 
          LitInt(0) <= ref#5
               && ref#5 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)]
             ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)]): DatatypeType))
               <= LitInt(Bounds.__default.MaxNumChildren()));
        assume (forall ref#5: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)] } 
          LitInt(0) <= ref#5
               && ref#5 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)]
             ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(ref#5)]): DatatypeType))
               <= LitInt(Bounds.__default.MaxNumChildren()));
        assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize());
        assume MutableMapModel.LinearHashMap.count(##t#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize());
        assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(PivotBetreeGraph.__default.Root())];
        assume Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0))[$Box(PivotBetreeGraph.__default.Root())];
        assume IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
        assume Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
          #Options.Option.None());
    }
    else
    {
        assume t'#0 == null
           ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
            #Options.Option.None());
    }

    if (*)
    {
        assume t'#0 != null;
        assert t'#0 != null;
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
    }
    else
    {
        assume t'#0 != null
           ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
    }

    if (*)
    {
        assume t'#0 != null;
        assert t#0 != null;
        assert $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          old($Heap));
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
        ##t#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##t#1, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap);
        assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#1);
        assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#1);
        assert {:subsumption 0} (forall ref#6: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)] } 
          LitInt(0) <= ref#6
               && ref#6 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)]): DatatypeType)
               == LitInt(0));
        assume (forall ref#6: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)] } 
          LitInt(0) <= ref#6
               && ref#6 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#6)]): DatatypeType)
               == LitInt(0));
        assert {:subsumption 0} (forall ref#7: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)] } 
          LitInt(0) <= ref#7
               && ref#7 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)]
             ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)]): DatatypeType))
               <= LitInt(Bounds.__default.MaxNumChildren()));
        assume (forall ref#7: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)] } 
          LitInt(0) <= ref#7
               && ref#7 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)]
             ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(ref#7)]): DatatypeType))
               <= LitInt(Bounds.__default.MaxNumChildren()));
        assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#1)
           <= LitInt(IndirectionTableModel.__default.MaxSize());
        assume MutableMapModel.LinearHashMap.count(##t#1)
           <= LitInt(IndirectionTableModel.__default.MaxSize());
        assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(PivotBetreeGraph.__default.Root())];
        assume Map#Domain(MutableMapModel.LinearHashMap.contents(##t#1))[$Box(PivotBetreeGraph.__default.Root())];
        assume IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
        assert t'#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0));
        assume Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
          #Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0))));
    }
    else
    {
        assume t'#0 != null
           ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
            #Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0))));
    }

    if (*)
    {
        assume t'#0 != null;
        assert t'#0 != null;
        assume (forall $o: ref :: 
          { read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
          read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
    }
    else
    {
        assume t'#0 != null
           ==> (forall $o: ref :: 
            { read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
            read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
               ==> $o != null && !read(old($Heap), $o, alloc));
    }
}



procedure Call$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (t'#0: ref
       where $Is(t'#0, Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t'#0, 
          Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()), 
          $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires (forall ref#1: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)] } 
    LitInt(0) <= ref#1
         && ref#1 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]
       ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]): DatatypeType)
         == LitInt(0));
  requires (forall ref#3: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)] } 
    LitInt(0) <= ref#3
         && ref#3 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]
       ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]): DatatypeType))
         <= LitInt(Bounds.__default.MaxNumChildren()));
  requires MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
     <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures t'#0 == null
     ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
       && 
      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
       && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
  ensures t'#0 == null
     ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
      #Options.Option.None());
  free ensures t'#0 != null
     ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
  ensures t'#0 != null
     ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
  free ensures t'#0 != null
     ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
       && 
      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
       && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
       && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
  ensures t'#0 != null
     ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
      #Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0))));
  free ensures true;
  ensures t'#0 != null
     ==> (forall $o: ref :: 
      { read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
      read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (t'#0: ref
       where $Is(t'#0, Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t'#0, 
          Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()), 
          $Heap), 
    $_reverifyPost: bool);
  free requires 31 == $FunctionContextHeight;
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires (forall ref#1: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)] } 
    LitInt(0) <= ref#1
         && ref#1 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]
       ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#1)]): DatatypeType)
         == LitInt(0));
  requires (forall ref#3: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)] } 
    LitInt(0) <= ref#3
         && ref#3 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]
       ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(ref#3)]): DatatypeType))
         <= LitInt(Bounds.__default.MaxNumChildren()));
  requires MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
     <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures t'#0 == null
     ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
       && 
      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
       && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
  ensures t'#0 == null
     ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
      #Options.Option.None());
  free ensures t'#0 != null
     ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
  ensures t'#0 != null
     ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
  free ensures t'#0 != null
     ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
       && 
      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
       && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
       && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0);
  ensures t'#0 != null
     ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
      #Options.Option.Some($Box(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t'#0))));
  free ensures true;
  ensures t'#0 != null
     ==> (forall $o: ref :: 
      { read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
      read($Heap, t'#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



function Tclass.MutableMapModel.Iterator(Ty) : Ty;

// Tclass.MutableMapModel.Iterator Tag
axiom (forall MutableMapModel.Iterator$V: Ty :: 
  { Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V) } 
  Tag(Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V))
     == Tagclass.MutableMapModel.Iterator);

const unique Tagclass.MutableMapModel.Iterator: TyTag;

// Tclass.MutableMapModel.Iterator injectivity 0
axiom (forall MutableMapModel.Iterator$V: Ty :: 
  { Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V) } 
  Tclass.MutableMapModel.Iterator_0(Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V))
     == MutableMapModel.Iterator$V);

function Tclass.MutableMapModel.Iterator_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMapModel.Iterator
axiom (forall MutableMapModel.Iterator$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V)) } 
  $IsBox(bx, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, 
        Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V)));

implementation Impl$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts(t#0: ref) returns (t'#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var t##0: DatatypeType;
  var copy#0: ref
     where $Is(copy#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(copy#0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var t1#0: ref
     where $Is(t1#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(t1#0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: ref
     where $Is($rhs##0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, 
        Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var oldEntryOpt#0: DatatypeType
     where $Is(oldEntryOpt#0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntryOpt#0, 
        Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##1: DatatypeType
     where $Is($rhs##1, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##1, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0: int;
  var oldEntry#0: DatatypeType
     where $Is(oldEntry#0, Tclass.IndirectionTableModel.Entry())
       && $IsAlloc(oldEntry#0, Tclass.IndirectionTableModel.Entry(), $Heap);
  var key##1: int;
  var value##0: Box;
  var dt_update_tmp#0#0: DatatypeType;
  var let#0#0#0: DatatypeType;
  var dt_update#predCount#0#0: int;
  var let#1#0#0: int;
  var newtype$check#1: int;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(it#0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##2: DatatypeType
     where $Is($rhs##2, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##2, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: Box;
  var $w$loop#0: bool;
  var ##t#2: DatatypeType;
  var ##copy#0: DatatypeType;
  var ##it#0: DatatypeType;
  var ##t#3: DatatypeType;
  var ##t#4: DatatypeType;
  var ##copy#1: DatatypeType;
  var ##it#1: DatatypeType;
  var $decr$loop#00: Box;
  var t##0_0: DatatypeType;
  var copy##0_0: DatatypeType;
  var it##0_0: DatatypeType;
  var t##0_1: DatatypeType;
  var copy##0_1: DatatypeType;
  var it##0_1: DatatypeType;
  var t0#0_0: DatatypeType
     where $Is(t0#0_0, 
        Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(t0#0_0, 
        Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var succs#0_0: Seq Box
     where $Is(succs#0_0, TSeq(Tclass.NativeTypes.uint64()))
       && $IsAlloc(succs#0_0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
  var i#0_0: int where LitInt(0) <= i#0_0 && i#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var $PreLoopHeap$loop#0_0: Heap;
  var $decr_init$loop#0_00: int;
  var $w$loop#0_0: bool;
  var ref#0_0: int;
  var ##t#0_0: DatatypeType;
  var ##t#0_1: DatatypeType;
  var ##copy#0_0: DatatypeType;
  var ##it#0_0: DatatypeType;
  var newtype$check#0_1: int;
  var ##t#0_2: DatatypeType;
  var ##succs#0_0: Seq Box;
  var ##i#0_0: int;
  var ##t#0_3: DatatypeType;
  var ##succs#0_1: Seq Box;
  var ##i#0_1: int;
  var newtype$check#0_2: int;
  var $decr$loop#0_00: int;
  var ref#0_0_0: int where LitInt(0) <= ref#0_0_0 && ref#0_0_0 < 18446744073709551616;
  var oldEntry#0_0_0: DatatypeType
     where $Is(oldEntry#0_0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(oldEntry#0_0_0, 
        Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0_0_0: DatatypeType
     where $Is($rhs##0_0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0_0_0: int;
  var newEntry#0_0_0_0: DatatypeType
     where $Is(newEntry#0_0_0_0, Tclass.IndirectionTableModel.Entry())
       && $IsAlloc(newEntry#0_0_0_0, Tclass.IndirectionTableModel.Entry(), $Heap);
  var dt_update_tmp#1#0_0_0_0: DatatypeType;
  var let#0_0_0_0#0#0: DatatypeType;
  var dt_update#predCount#1#0_0_0_0: int;
  var let#0_0_0_1#0#0: int;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var key##0_0_0_0: int;
  var value##0_0_0_0: Box;
  var newtype$check#0_0_0_2: int;
  var newtype$check#0_0_0_3: int;
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0_2: DatatypeType;

    // AddMethodImpl: ComputeRefCounts, Impl$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(491,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(492,64)
    // TrCallStmt: Before ProcessCallStmt
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    // ProcessCallStmt: CheckSubrange
    t##0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateInvInit(t##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(492,70)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(494,16)
    assume true;
    assume true;
    copy#0 := t#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(494,19)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(495,24)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type ResizingHashMap<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.Clone(Tclass.IndirectionTableModel.Entry(), t#0);
    // TrCallStmt: After ProcessCallStmt
    t1#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(495,25)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(497,32)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t1#0 != null;
    assume PivotBetreeGraph.__default.Root#canCall();
    assume PivotBetreeGraph.__default.Root#canCall();
    // ProcessCallStmt: CheckSubrange
    key##0 := LitInt(PivotBetreeGraph.__default.Root());
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##1 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), t1#0, key##0);
    // TrCallStmt: After ProcessCallStmt
    oldEntryOpt#0 := $rhs##1;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(497,44)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(498,20)
    assume true;
    assert Options.Option.Some_q(oldEntryOpt#0);
    assume true;
    oldEntry#0 := $Unbox(Options.Option.value(oldEntryOpt#0)): DatatypeType;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(498,39)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(499,16)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t1#0 != null;
    assume PivotBetreeGraph.__default.Root#canCall();
    assume PivotBetreeGraph.__default.Root#canCall();
    // ProcessCallStmt: CheckSubrange
    key##1 := LitInt(PivotBetreeGraph.__default.Root());
    havoc dt_update_tmp#0#0;
    assume $Is(dt_update_tmp#0#0, Tclass.IndirectionTableModel.Entry());
    assume let#0#0#0 == oldEntry#0;
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#0#0#0, Tclass.IndirectionTableModel.Entry());
    assume dt_update_tmp#0#0 == let#0#0#0;
    havoc dt_update#predCount#0#0;
    assume LitInt(0) <= dt_update#predCount#0#0
       && dt_update#predCount#0#0 < 18446744073709551616;
    newtype$check#1 := LitInt(1);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume let#1#0#0 == LitInt(1);
    assume true;
    // CheckWellformedWithResult: any expression
    assume $Is(let#1#0#0, Tclass.NativeTypes.uint64());
    assume dt_update#predCount#0#0 == let#1#0#0;
    assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0);
    assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0);
    assume (var dt_update_tmp#0#1 := oldEntry#0; 
      IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
         && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1));
    // ProcessCallStmt: CheckSubrange
    value##0 := $Box((var dt_update_tmp#0#1 := oldEntry#0; 
        (var dt_update#predCount#0#1 := LitInt(1); 
          #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
            IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
            dt_update#predCount#0#1))));
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), t1#0, key##1, value##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(499,55)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(501,31)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Iterator<Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert copy#0 != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##2 := Call$$MutableMap.ResizingHashMap.IterStart(Tclass.IndirectionTableModel.Entry(), copy#0);
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##2;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(501,32)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(502,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
      invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
      invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> Set#Disjoint(read($Heap, copy#0, MutableMap.ResizingHashMap.Repr), 
          read($Heap, t1#0, MutableMap.ResizingHashMap.Repr));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall $o: ref :: 
          { read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
          read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
           && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
           && IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (forall ref#8: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#8)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#8)] } 
            LitInt(0) <= ref#8
                 && ref#8 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#8)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#8)]);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (forall ref#9: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#9)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)] } 
            LitInt(0) <= ref#9
                 && ref#9 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)]
               ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#9)]): DatatypeType), 
                IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)]): DatatypeType)));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (forall ref#10: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#10)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)] } 
            LitInt(0) <= ref#10
                 && ref#10 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)]
               ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#10)]): DatatypeType), 
                IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)]): DatatypeType)));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (forall ref#11: int :: 
            { IndirectionTableModel.__default.IsRoot(ref#11) } 
              { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
                ref#11, 
                MutableMapModel.Iterator.s(it#0)) } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#11)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#11)] } 
            LitInt(0) <= ref#11
                 && ref#11 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#11)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#11)]): DatatypeType)
                 == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
                      ref#11, 
                      MutableMapModel.Iterator.s(it#0)))
                   + IndirectionTableModel.__default.IsRoot(ref#11));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (forall ref#12: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)] } 
            LitInt(0) <= ref#12
                 && ref#12 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)]
               ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)]): DatatypeType))
                 <= LitInt(Bounds.__default.MaxNumChildren()));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (forall ref#13: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#13)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#13)] } 
            LitInt(0) <= ref#13
                 && ref#13 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#13)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#13)]);
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || (IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
              MutableMapModel.Iterator.s(it#0))
             ==> IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
                MutableMapModel.Iterator.s(it#0))
               || (forall ref#14: int :: 
                { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#14)]): Seq Box } 
                  { MutableMapModel.Iterator.s(it#0)[$Box(ref#14)] } 
                LitInt(0) <= ref#14
                     && ref#14 < 18446744073709551616
                     && 
                    Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#14)]
                     && MutableMapModel.Iterator.s(it#0)[$Box(ref#14)]
                   ==> (forall i#0: int :: 
                    { $Unbox(Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#14)]): Seq Box, 
                          i#0)): int } 
                    LitInt(0) <= i#0
                         && i#0
                           < Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#14)]): Seq Box)
                       ==> Map#Domain(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#14)]): Seq Box, 
                        i#0)])));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
             == MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
      invariant $w$loop#0
         ==> 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
          it#0)
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           || MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize());
      free invariant $w$loop#0
         ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           && 
          IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0))
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0)
           && (forall ref#8: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#8)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#8)] } 
            LitInt(0) <= ref#8
                 && ref#8 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#8)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#8)])
           && (forall ref#9: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#9)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)] } 
            LitInt(0) <= ref#9
                 && ref#9 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)]
               ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#9)]): DatatypeType), 
                IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#9)]): DatatypeType)))
           && (forall ref#10: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#10)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)] } 
            LitInt(0) <= ref#10
                 && ref#10 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)]
               ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#10)]): DatatypeType), 
                IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#10)]): DatatypeType)))
           && (forall ref#11: int :: 
            { IndirectionTableModel.__default.IsRoot(ref#11) } 
              { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
                ref#11, 
                MutableMapModel.Iterator.s(it#0)) } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#11)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#11)] } 
            LitInt(0) <= ref#11
                 && ref#11 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#11)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#11)]): DatatypeType)
                 == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
                      ref#11, 
                      MutableMapModel.Iterator.s(it#0)))
                   + IndirectionTableModel.__default.IsRoot(ref#11))
           && (forall ref#12: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)] } 
            LitInt(0) <= ref#12
                 && ref#12 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)]
               ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#12)]): DatatypeType))
                 <= LitInt(Bounds.__default.MaxNumChildren()))
           && (forall ref#13: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#13)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#13)] } 
            LitInt(0) <= ref#13
                 && ref#13 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#13)]
               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)))[$Box(ref#13)])
           && IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)), 
            MutableMapModel.Iterator.s(it#0))
           && MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
             == MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0))
           && MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize());
      free invariant $w$loop#0
         ==> PivotBetreeGraph.__default.Root#canCall()
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
      invariant $w$loop#0
         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(PivotBetreeGraph.__default.Root())];
      free invariant $w$loop#0
         ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
           && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
              it#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
           && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
           && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
           && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0);
      invariant $w$loop#0
         ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
          IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00
           || ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr_init$loop#00))
         && (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(502,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assert {:subsumption 0} t1#0 != null;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assert {:subsumption 0} copy#0 != null;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assert {:subsumption 0} copy#0 != null;
            assert {:subsumption 0} t1#0 != null;
            assume true;
            assume Set#Disjoint(read($Heap, copy#0, MutableMap.ResizingHashMap.Repr), 
              read($Heap, t1#0, MutableMap.ResizingHashMap.Repr));
            assert {:subsumption 0} t1#0 != null;
            assume true;
            assume (forall $o: ref :: 
              { read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
              read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
            assert {:subsumption 0} t1#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
            assert {:subsumption 0} copy#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
            ##t#2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#2, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##copy#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##copy#0, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#0 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#0, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
               && IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                it#0);
            assume IndirectionTableModel.__default.ComputeRefCountsIterateInv(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
              it#0);
            assume PivotBetreeGraph.__default.Root#canCall();
            assert {:subsumption 0} t1#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
            assume PivotBetreeGraph.__default.Root#canCall()
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
            assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(PivotBetreeGraph.__default.Root())];
            assert {:subsumption 0} t#0 != null;
            assert $IsAlloc(t#0, 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
            ##t#3 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#3, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#3);
            assert {:subsumption 0} (forall ref#15: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#15)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#15)] } 
              LitInt(0) <= ref#15
                   && ref#15 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#15)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#15)]): DatatypeType)
                   == LitInt(0));
            assert {:subsumption 0} (forall ref#16: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#16)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#16)] } 
              LitInt(0) <= ref#16
                   && ref#16 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#16)]
                 ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(ref#16)]): DatatypeType))
                   <= LitInt(Bounds.__default.MaxNumChildren()));
            assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#3)
               <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#3))[$Box(PivotBetreeGraph.__default.Root())];
            assume IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
            assert {:subsumption 0} t1#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
            assert {:subsumption 0} copy#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
            ##t#4 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#4, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##copy#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##copy#1, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#1 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#1, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#4);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##copy#1);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), ##copy#1, ##it#1);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (forall ref#17: int :: 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#17)] } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#17)] } 
                  LitInt(0) <= ref#17
                       && ref#17 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#17)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#17)]);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (forall ref#18: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#18)]): DatatypeType } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#18)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#18)] } 
                  LitInt(0) <= ref#18
                       && ref#18 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#18)]
                     ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#18)]): DatatypeType), 
                      IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#18)]): DatatypeType)));
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (forall ref#19: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#19)]): DatatypeType } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#19)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#19)] } 
                  LitInt(0) <= ref#19
                       && ref#19 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#19)]
                     ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#19)]): DatatypeType), 
                      IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#19)]): DatatypeType)));
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (forall ref#20: int :: 
                  { IndirectionTableModel.__default.IsRoot(ref#20) } 
                    { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(##copy#1), 
                      ref#20, 
                      MutableMapModel.Iterator.s(##it#1)) } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#20)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#20)] } 
                  LitInt(0) <= ref#20
                       && ref#20 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#20)]
                     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#20)]): DatatypeType)
                       == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(##copy#1), 
                            ref#20, 
                            MutableMapModel.Iterator.s(##it#1)))
                         + IndirectionTableModel.__default.IsRoot(ref#20));
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (forall ref#21: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#21)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#21)] } 
                  LitInt(0) <= ref#21
                       && ref#21 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#21)]
                     ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#21)]): DatatypeType))
                       <= LitInt(Bounds.__default.MaxNumChildren()));
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (forall ref#22: int :: 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#22)] } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#22)] } 
                  LitInt(0) <= ref#22
                       && ref#22 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(ref#22)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#1))[$Box(ref#22)]);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || (IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(##copy#1), 
                    MutableMapModel.Iterator.s(##it#1))
                   ==> IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(##copy#1), 
                      MutableMapModel.Iterator.s(##it#1))
                     || (forall ref#23: int :: 
                      { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#1))[$Box(ref#23)]): Seq Box } 
                        { MutableMapModel.Iterator.s(##it#1)[$Box(ref#23)] } 
                      LitInt(0) <= ref#23
                           && ref#23 < 18446744073709551616
                           && 
                          Map#Domain(IndirectionTableModel.__default.Graph(##copy#1))[$Box(ref#23)]
                           && MutableMapModel.Iterator.s(##it#1)[$Box(ref#23)]
                         ==> (forall i#1: int :: 
                          { $Unbox(Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#1))[$Box(ref#23)]): Seq Box, 
                                i#1)): int } 
                          LitInt(0) <= i#1
                               && i#1
                                 < Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#1))[$Box(ref#23)]): Seq Box)
                             ==> Map#Domain(IndirectionTableModel.__default.Graph(##copy#1))[Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#1))[$Box(ref#23)]): Seq Box, 
                              i#1)])));
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || MutableMapModel.LinearHashMap.count(##t#4)
                   == MutableMapModel.LinearHashMap.count(##copy#1);
            assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#4, ##copy#1, ##it#1)
               ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#4, ##copy#1, ##it#1)
                 || MutableMapModel.LinearHashMap.count(##t#4)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#4))[$Box(PivotBetreeGraph.__default.Root())];
            assume IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
              it#0);
            assume $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
               && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                  it#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
               && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
               && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                it#0);
            assume Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
              IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                it#0));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume false;
        }

        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        if (!MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
        {
            break;
        }

        $decr$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(514,64)
        // TrCallStmt: Before ProcessCallStmt
        assert t1#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        // ProcessCallStmt: CheckSubrange
        t##0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assert copy#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        // ProcessCallStmt: CheckSubrange
        copy##0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_0 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateStuff(t##0_0, copy##0_0, it##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(514,85)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(515,74)
        // TrCallStmt: Before ProcessCallStmt
        assert t1#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        // ProcessCallStmt: CheckSubrange
        t##0_1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assert copy#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        // ProcessCallStmt: CheckSubrange
        copy##0_1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_1 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateValidPredCounts(t##0_1, copy##0_1, it##0_1);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(515,95)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(517,22)
        assume true;
        assert t1#0 != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        t0#0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(517,30)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(519,19)
        assume true;
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType);
        assume MutableMapModel.Iterator.Iterator_q(it#0)
           && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType);
        succs#0_0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(519,40)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(520,23)
        assume true;
        newtype$check#0_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume true;
        i#0_0 := LitInt(0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(520,26)"} true;
        // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(521,9)
        // Assume Fuel Constant
        $PreLoopHeap$loop#0_0 := $Heap;
        $decr_init$loop#0_00 := Seq#Length(succs#0_0) - i#0_0;
        havoc $w$loop#0_0;
        while (true)
          free invariant $w$loop#0_0
             ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
          invariant $w$loop#0_0
             ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
          free invariant $w$loop#0_0
             ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
          invariant $w$loop#0_0
             ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
          free invariant $w$loop#0_0 ==> true;
          invariant $w$loop#0_0
             ==> Set#Disjoint(read($Heap, copy#0, MutableMap.ResizingHashMap.Repr), 
              read($Heap, t1#0, MutableMap.ResizingHashMap.Repr));
          free invariant $w$loop#0_0 ==> true;
          invariant $w$loop#0_0
             ==> (forall $o: ref :: 
              { read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
              read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
          free invariant $w$loop#0_0
             ==> PivotBetreeGraph.__default.Root#canCall()
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
          invariant $w$loop#0_0
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(PivotBetreeGraph.__default.Root())];
          free invariant $w$loop#0_0 ==> true;
          invariant $w$loop#0_0 ==> LitInt(0) <= i#0_0;
          invariant $w$loop#0_0 ==> i#0_0 <= Seq#Length(succs#0_0);
          free invariant $w$loop#0_0 ==> Bounds.__default.MaxNumChildren#canCall();
          invariant $w$loop#0_0
             ==> Seq#Length(succs#0_0) <= LitInt(Bounds.__default.MaxNumChildren());
          free invariant $w$loop#0_0
             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
               && IndirectionTableModel.__default.MaxSize#canCall();
          invariant $w$loop#0_0
             ==> MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
               <= LitInt(IndirectionTableModel.__default.MaxSize());
          free invariant $w$loop#0_0
             ==> (forall ref#0_1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)] } 
              LitInt(0) <= ref#0_1 && ref#0_1 < 18446744073709551616
                 ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]
                     ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType)));
          invariant $w$loop#0_0
             ==> (forall ref#0_1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)] } 
              LitInt(0) <= ref#0_1
                   && ref#0_1 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType)
                   <= 281474976710656 + i#0_0);
          free invariant $w$loop#0_0
             ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
               && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                  t0#0_0, 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                  it#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
               && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
               && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t0#0_0, 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                it#0);
          invariant $w$loop#0_0
             ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
              IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LS($LZ)), 
                t0#0_0, 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                it#0));
          free invariant $w$loop#0_0
             ==> $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t0#0_0, succs#0_0, LitInt(0)))
               && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                  succs#0_0, 
                  i#0_0))
               && 
              IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#0_0, succs#0_0, LitInt(0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                succs#0_0, 
                i#0_0);
          invariant $w$loop#0_0
             ==> Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LS($LZ)), t0#0_0, succs#0_0, LitInt(0)), 
              IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LS($LZ)), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                succs#0_0, 
                i#0_0));
          free invariant (forall $o: ref :: 
            { $Heap[$o] } 
            $o != null && read(old($Heap), $o, alloc)
               ==> $Heap[$o] == $PreLoopHeap$loop#0_0[$o]);
          free invariant $HeapSucc($PreLoopHeap$loop#0_0, $Heap);
          free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
            { read($Heap, $o, $f) } 
            $o != null && read($PreLoopHeap$loop#0_0, $o, alloc)
               ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0_0, $o, $f) || $_Frame[$o, $f]);
          free invariant Seq#Length(succs#0_0) - i#0_0 <= $decr_init$loop#0_00
             && (Seq#Length(succs#0_0) - i#0_0 == $decr_init$loop#0_00 ==> true);
        {
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(521,8): after some loop iterations"} true;
            if (!$w$loop#0_0)
            {
                assert {:subsumption 0} t1#0 != null;
                assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assert {:subsumption 0} copy#0 != null;
                assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
                assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
                assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
                assert {:subsumption 0} copy#0 != null;
                assert {:subsumption 0} t1#0 != null;
                assume true;
                assume Set#Disjoint(read($Heap, copy#0, MutableMap.ResizingHashMap.Repr), 
                  read($Heap, t1#0, MutableMap.ResizingHashMap.Repr));
                assert {:subsumption 0} t1#0 != null;
                assume true;
                assume (forall $o: ref :: 
                  { read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
                  read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                     ==> $o != null && !read(old($Heap), $o, alloc));
                assume PivotBetreeGraph.__default.Root#canCall();
                assert {:subsumption 0} t1#0 != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                assume PivotBetreeGraph.__default.Root#canCall()
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                assume Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(PivotBetreeGraph.__default.Root())];
                if (LitInt(0) <= i#0_0)
                {
                }

                assume true;
                assume LitInt(0) <= i#0_0 && i#0_0 <= Seq#Length(succs#0_0);
                assume Bounds.__default.MaxNumChildren#canCall();
                assume Bounds.__default.MaxNumChildren#canCall();
                assume Seq#Length(succs#0_0) <= LitInt(Bounds.__default.MaxNumChildren());
                assert {:subsumption 0} t1#0 != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                assume IndirectionTableModel.__default.MaxSize#canCall();
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                   && IndirectionTableModel.__default.MaxSize#canCall();
                assume MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
                havoc ref#0_0;
                assume LitInt(0) <= ref#0_0 && ref#0_0 < 18446744073709551616;
                // Begin Comprehension WF check
                assert {:subsumption 0} t1#0 != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                if (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_0)])
                {
                    assert {:subsumption 0} t1#0 != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                    assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_0)];
                    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_0)]): DatatypeType);
                }

                // End Comprehension WF check
                assume (forall ref#0_1: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)] } 
                  LitInt(0) <= ref#0_1 && ref#0_1 < 18446744073709551616
                     ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]
                         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                           && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType)));
                assume (forall ref#0_1: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)] } 
                  LitInt(0) <= ref#0_1
                       && ref#0_1 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]
                     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType)
                       <= 281474976710656 + i#0_0);
                assert {:subsumption 0} t#0 != null;
                assert $IsAlloc(t#0, 
                  Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
                  old($Heap));
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
                ##t#0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##t#0_0, 
                  Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0_0);
                assert {:subsumption 0} (forall ref#0_2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_2)] } 
                  LitInt(0) <= ref#0_2
                       && ref#0_2 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_2)]
                     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_2)]): DatatypeType)
                       == LitInt(0));
                assert {:subsumption 0} (forall ref#0_3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_3)] } 
                  LitInt(0) <= ref#0_3
                       && ref#0_3 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_3)]
                     ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(ref#0_3)]): DatatypeType))
                       <= LitInt(Bounds.__default.MaxNumChildren()));
                assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#0_0)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
                assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_0))[$Box(PivotBetreeGraph.__default.Root())];
                assume IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0));
                assert {:subsumption 0} copy#0 != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0));
                ##t#0_1 := t0#0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##t#0_1, 
                  Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                ##copy#0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##copy#0_0, 
                  Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                ##it#0_0 := it#0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##it#0_0, 
                  Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0_1);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##copy#0_0);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), ##copy#0_0, ##it#0_0);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (forall ref#0_4: int :: 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_4)] } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_4)] } 
                      LitInt(0) <= ref#0_4
                           && ref#0_4 < 18446744073709551616
                           && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_4)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_4)]);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (forall ref#0_5: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_5)]): DatatypeType } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_5)] } 
                      LitInt(0) <= ref#0_5
                           && ref#0_5 < 18446744073709551616
                           && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_5)]
                         ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_5)]): DatatypeType), 
                          IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_5)]): DatatypeType)));
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (forall ref#0_6: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_6)]): DatatypeType } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_6)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_6)] } 
                      LitInt(0) <= ref#0_6
                           && ref#0_6 < 18446744073709551616
                           && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_6)]
                         ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_6)]): DatatypeType), 
                          IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_6)]): DatatypeType)));
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (forall ref#0_7: int :: 
                      { IndirectionTableModel.__default.IsRoot(ref#0_7) } 
                        { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(##copy#0_0), 
                          ref#0_7, 
                          MutableMapModel.Iterator.s(##it#0_0)) } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_7)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_7)] } 
                      LitInt(0) <= ref#0_7
                           && ref#0_7 < 18446744073709551616
                           && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_7)]
                         ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_7)]): DatatypeType)
                           == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(##copy#0_0), 
                                ref#0_7, 
                                MutableMapModel.Iterator.s(##it#0_0)))
                             + IndirectionTableModel.__default.IsRoot(ref#0_7));
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (forall ref#0_8: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_8)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_8)] } 
                      LitInt(0) <= ref#0_8
                           && ref#0_8 < 18446744073709551616
                           && Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_8)]
                         ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_8)]): DatatypeType))
                           <= LitInt(Bounds.__default.MaxNumChildren()));
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (forall ref#0_9: int :: 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_9)] } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_9)] } 
                      LitInt(0) <= ref#0_9
                           && ref#0_9 < 18446744073709551616
                           && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(ref#0_9)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(##copy#0_0))[$Box(ref#0_9)]);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || (IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(##copy#0_0), 
                        MutableMapModel.Iterator.s(##it#0_0))
                       ==> IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(##copy#0_0), 
                          MutableMapModel.Iterator.s(##it#0_0))
                         || (forall ref#0_10: int :: 
                          { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#0_0))[$Box(ref#0_10)]): Seq Box } 
                            { MutableMapModel.Iterator.s(##it#0_0)[$Box(ref#0_10)] } 
                          LitInt(0) <= ref#0_10
                               && ref#0_10 < 18446744073709551616
                               && 
                              Map#Domain(IndirectionTableModel.__default.Graph(##copy#0_0))[$Box(ref#0_10)]
                               && MutableMapModel.Iterator.s(##it#0_0)[$Box(ref#0_10)]
                             ==> (forall i#0_1: int :: 
                              { $Unbox(Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#0_0))[$Box(ref#0_10)]): Seq Box, 
                                    i#0_1)): int } 
                              LitInt(0) <= i#0_1
                                   && i#0_1
                                     < Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#0_0))[$Box(ref#0_10)]): Seq Box)
                                 ==> Map#Domain(IndirectionTableModel.__default.Graph(##copy#0_0))[Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(##copy#0_0))[$Box(ref#0_10)]): Seq Box, 
                                  i#0_1)])));
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || MutableMapModel.LinearHashMap.count(##t#0_1)
                       == MutableMapModel.LinearHashMap.count(##copy#0_0);
                assert {:subsumption 0} IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(##t#0_1, ##copy#0_0, ##it#0_0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(##t#0_1, ##copy#0_0, ##it#0_0)
                     || MutableMapModel.LinearHashMap.count(##t#0_1)
                       <= LitInt(IndirectionTableModel.__default.MaxSize());
                assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_1))[$Box(PivotBetreeGraph.__default.Root())];
                assume IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t0#0_0, 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                  it#0);
                assume $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
                   && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                      t0#0_0, 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                      it#0))
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
                   && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
                   && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t0#0_0, 
                    MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                    it#0);
                assume Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)), 
                  IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                    t0#0_0, 
                    MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                    it#0));
                newtype$check#0_1 := LitInt(0);
                assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
                ##t#0_2 := t0#0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##t#0_2, 
                  Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                ##succs#0_0 := succs#0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##succs#0_0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
                ##i#0_0 := LitInt(0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##i#0_0, Tclass.NativeTypes.uint64(), $Heap);
                assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0_2);
                assert {:subsumption 0} LitInt(0) <= ##i#0_0;
                assert {:subsumption 0} ##i#0_0 <= Seq#Length(##succs#0_0);
                assert {:subsumption 0} Seq#Length(##succs#0_0) <= LitInt(Bounds.__default.MaxNumChildren());
                assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#0_2)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
                assert {:subsumption 0} (forall ref#0_11: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_2))[$Box(ref#0_11)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_2))[$Box(ref#0_11)] } 
                  LitInt(0) <= ref#0_11
                       && ref#0_11 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_2))[$Box(ref#0_11)]
                     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_2))[$Box(ref#0_11)]): DatatypeType)
                       <= 281474976710656 + ##i#0_0);
                assume IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#0_0, succs#0_0, LitInt(0));
                assert {:subsumption 0} t1#0 != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
                ##t#0_3 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
                // assume allocatedness for argument to function
                assume $IsAlloc(##t#0_3, 
                  Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
                  $Heap);
                ##succs#0_1 := succs#0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##succs#0_1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
                ##i#0_1 := i#0_0;
                // assume allocatedness for argument to function
                assume $IsAlloc(##i#0_1, Tclass.NativeTypes.uint64(), $Heap);
                assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0_3);
                assert {:subsumption 0} LitInt(0) <= ##i#0_1;
                assert {:subsumption 0} ##i#0_1 <= Seq#Length(##succs#0_1);
                assert {:subsumption 0} Seq#Length(##succs#0_1) <= LitInt(Bounds.__default.MaxNumChildren());
                assert {:subsumption 0} MutableMapModel.LinearHashMap.count(##t#0_3)
                   <= LitInt(IndirectionTableModel.__default.MaxSize());
                assert {:subsumption 0} (forall ref#0_12: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_3))[$Box(ref#0_12)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_3))[$Box(ref#0_12)] } 
                  LitInt(0) <= ref#0_12
                       && ref#0_12 < 18446744073709551616
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(##t#0_3))[$Box(ref#0_12)]
                     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(##t#0_3))[$Box(ref#0_12)]): DatatypeType)
                       <= 281474976710656 + ##i#0_1);
                assume IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                  succs#0_0, 
                  i#0_0);
                assume $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t0#0_0, succs#0_0, LitInt(0)))
                   && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                      succs#0_0, 
                      i#0_0))
                   && 
                  IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#0_0, succs#0_0, LitInt(0))
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                   && IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                    succs#0_0, 
                    i#0_0);
                assume Options.Option#Equal(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t0#0_0, succs#0_0, LitInt(0)), 
                  IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), 
                    MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                    succs#0_0, 
                    i#0_0));
                assume true;
                assume false;
            }

            newtype$check#0_2 := Seq#Length(succs#0_0);
            assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
            assume true;
            if (Seq#Length(succs#0_0) <= i#0_0)
            {
                break;
            }

            $decr$loop#0_00 := Seq#Length(succs#0_0) - i#0_0;
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(538,19)
            assume true;
            assert 0 <= i#0_0 && i#0_0 < Seq#Length(succs#0_0);
            assume true;
            ref#0_0_0 := $Unbox(Seq#Index(succs#0_0, i#0_0)): int;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(538,29)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(539,33)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<IndirectionTableModel.Entry>
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            assert t1#0 != null;
            assume true;
            // ProcessCallStmt: CheckSubrange
            key##0_0_0 := ref#0_0_0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##0_0_0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), t1#0, key##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            oldEntry#0_0_0 := $rhs##0_0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(539,37)"} true;
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(540,11)
            assume true;
            if (Options.Option.Some_q(oldEntry#0_0_0))
            {
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(541,26)
                assume true;
                havoc dt_update_tmp#1#0_0_0_0;
                assume $Is(dt_update_tmp#1#0_0_0_0, Tclass.IndirectionTableModel.Entry());
                assert Options.Option.Some_q(oldEntry#0_0_0);
                assume let#0_0_0_0#0#0 == $Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType;
                assume true;
                // CheckWellformedWithResult: any expression
                assume $Is(let#0_0_0_0#0#0, Tclass.IndirectionTableModel.Entry());
                assume dt_update_tmp#1#0_0_0_0 == let#0_0_0_0#0#0;
                havoc dt_update#predCount#1#0_0_0_0;
                assume LitInt(0) <= dt_update#predCount#1#0_0_0_0
                   && dt_update#predCount#1#0_0_0_0 < 18446744073709551616;
                assert Options.Option.Some_q(oldEntry#0_0_0);
                assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType);
                newtype$check#0_0_0_0 := LitInt(1);
                assert LitInt(0) <= newtype$check#0_0_0_0
                   && newtype$check#0_0_0_0 < 18446744073709551616;
                newtype$check#0_0_0_1 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType)
                   + 1;
                assert LitInt(0) <= newtype$check#0_0_0_1
                   && newtype$check#0_0_0_1 < 18446744073709551616;
                assume let#0_0_0_1#0#0
                   == IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType)
                     + 1;
                assume IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType);
                // CheckWellformedWithResult: any expression
                assume $Is(let#0_0_0_1#0#0, Tclass.NativeTypes.uint64());
                assume dt_update#predCount#1#0_0_0_0 == let#0_0_0_1#0#0;
                assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#1#0_0_0_0);
                assume IndirectionTableModel.Entry.Entry_q(dt_update_tmp#1#0_0_0_0);
                assume (var dt_update_tmp#1#0_0_0_1 := $Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType; 
                  IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType)
                     && 
                    IndirectionTableModel.Entry.Entry_q(dt_update_tmp#1#0_0_0_1)
                     && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#1#0_0_0_1));
                newEntry#0_0_0_0 := (var dt_update_tmp#1#0_0_0_1 := $Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType; 
                  (var dt_update#predCount#1#0_0_0_1 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0_0_0)): DatatypeType)
                         + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#1#0_0_0_1), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#1#0_0_0_1), 
                      dt_update#predCount#1#0_0_0_1)));
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(541,86)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(542,22)
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                assert t1#0 != null;
                assume true;
                // ProcessCallStmt: CheckSubrange
                key##0_0_0_0 := ref#0_0_0;
                assume true;
                // ProcessCallStmt: CheckSubrange
                value##0_0_0_0 := $Box(newEntry#0_0_0_0);
                assert (forall<alpha> $o: ref, $f: Field alpha :: 
                  $o != null
                       && read($Heap, $o, alloc)
                       && read($Heap, t1#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
                     ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$MutableMap.ResizingHashMap.Insert(Tclass.IndirectionTableModel.Entry(), t1#0, key##0_0_0_0, value##0_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(542,36)"} true;
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(543,15)
                assume true;
                newtype$check#0_0_0_2 := LitInt(1);
                assert LitInt(0) <= newtype$check#0_0_0_2
                   && newtype$check#0_0_0_2 < 18446744073709551616;
                newtype$check#0_0_0_3 := i#0_0 + 1;
                assert LitInt(0) <= newtype$check#0_0_0_3
                   && newtype$check#0_0_0_3 < 18446744073709551616;
                assume true;
                i#0_0 := i#0_0 + 1;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(543,22)"} true;
            }
            else
            {
                // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(545,13)
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(545,13)
                assume true;
                assume true;
                t'#0 := null;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(545,23)"} true;
                return;
            }

            // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(521,9)
            assert 0 <= $decr$loop#0_00 || Seq#Length(succs#0_0) - i#0_0 == $decr$loop#0_00;
            assert Seq#Length(succs#0_0) - i#0_0 < $decr$loop#0_00;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
            assume true;
            assume true;
            assume PivotBetreeGraph.__default.Root#canCall()
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
            assume true;
            assume Bounds.__default.MaxNumChildren#canCall();
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
               && IndirectionTableModel.__default.MaxSize#canCall();
            assume (forall ref#0_1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)] } 
              LitInt(0) <= ref#0_1 && ref#0_1 < 18446744073709551616
                 ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]
                     ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)))[$Box(ref#0_1)]): DatatypeType)));
            assume $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
               && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                  t0#0_0, 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                  it#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
               && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
               && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t0#0_0, 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
                it#0);
            assume $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t0#0_0, succs#0_0, LitInt(0)))
               && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                  succs#0_0, 
                  i#0_0))
               && 
              IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#0_0, succs#0_0, LitInt(0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
               && IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
                succs#0_0, 
                i#0_0);
        }

        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(549,27)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Iterator<Entry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert copy#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_2 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$MutableMap.ResizingHashMap.IterInc(Tclass.IndirectionTableModel.Entry(), copy#0, it##0_2);
        // TrCallStmt: After ProcessCallStmt
        it#0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(549,30)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(502,7)
        assert ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr$loop#00);
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0);
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0);
        assume true;
        assume true;
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
           && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
           && IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0);
        assume PivotBetreeGraph.__default.Root#canCall()
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0));
        assume $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)))
           && $IsA#Options.Option(IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
              it#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0)
           && IndirectionTableModel.__default.ComputeRefCounts#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), old($Heap), t#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0)
           && MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0)
           && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, copy#0), 
            it#0);
    }

    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(552,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(552,7)
    assume true;
    assume true;
    t'#0 := t1#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(552,15)"} true;
    return;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap));
  free requires 32 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue(t#0: ref) returns (q#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##t#0: DatatypeType;

    // AddMethodImpl: MakeGarbageQueue, CheckWellformed$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(555,18): initial state"} true;
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume Map#Card(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
       <= LitInt(4294967296);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc q#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(559,17): post-state"} true;
    assert q#0 != null;
    assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
    assume LruImpl.LruImplQueue.Inv($Heap, q#0);
    assert q#0 != null;
    assume (forall $o: ref :: 
      { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)] } 
      read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
    assert q#0 != null;
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $Heap);
    assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assume IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume Seq#Equal(read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
      IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, 
        MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires Map#Card(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
     <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)] } 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  ensures Seq#Equal(read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
    IndirectionTableModel.__default.makeGarbageQueue(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue, 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (q#0: ref
       where $Is(q#0, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(q#0, Tclass.LruImpl.LruImplQueue(), $Heap), 
    $_reverifyPost: bool);
  free requires 32 == $FunctionContextHeight;
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  requires Map#Card(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
     <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
  ensures LruImpl.LruImplQueue.Inv($Heap, q#0);
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)] } 
    read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  ensures Seq#Equal(read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
    IndirectionTableModel.__default.makeGarbageQueue(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue, 
      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue(t#0: ref) returns (q#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#q#0: bool;
  var $nw: ref;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(it#0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#q#0: bool;
  var $decr_init$loop#00: Box;
  var $w$loop#0: bool;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##it#0: DatatypeType;
  var ##t#1: DatatypeType;
  var ##t#2: DatatypeType;
  var ##q#0: Seq Box;
  var ##it#1: DatatypeType;
  var ##q#1: Seq Box;
  var $decr$loop#00: Box;
  var newtype$check#0_0: int;
  var q##0_0_0: Seq Box;
  var x##0_0_0: int;
  var a##0_0_0: Set Box;
  var ##q#0_0_0: Seq Box;
  var b##0_0_0: Set Box;
  var x##0_0_1: int;
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0_0: DatatypeType;

    // AddMethodImpl: MakeGarbageQueue, Impl$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(562,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(563,52)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__makeGarbageQueue();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(563,53)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(565,9)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(565,12)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$LruImpl.LruImplQueue.__ctor();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(565,37)"} true;
    q#0 := $nw;
    defass#q#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(565,37)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(566,28)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Iterator<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.IterStart(Tclass.IndirectionTableModel.Entry(), t#0);
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(566,29)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(567,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#q#0 := defass#q#0;
    $decr_init$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
      invariant $w$loop#0 ==> LruImpl.LruImplQueue.Inv($Heap, q#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall $o: ref :: 
          { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)] } 
          read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#0
         ==> MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0);
      invariant $w$loop#0
         ==> MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          it#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            it#0);
      invariant $w$loop#0
         ==> Seq#Equal(IndirectionTableModel.__default.makeGarbageQueue(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
          IndirectionTableModel.__default.makeGarbageQueueIterate($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            it#0));
      free invariant $w$loop#0
         ==> LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#0
         ==> Set#Subset(LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue)), 
          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#0
         ==> Map#Card(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
           <= LitInt(4294967296);
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant preLoop$loop#0$defass#q#0 ==> defass#q#0;
      free invariant (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00
           || ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr_init$loop#00))
         && (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(567,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assert defass#q#0;
            assert {:subsumption 0} q#0 != null;
            assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
            assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
            assume LruImpl.LruImplQueue.Inv($Heap, q#0);
            assert defass#q#0;
            assert {:subsumption 0} q#0 != null;
            assume true;
            assume (forall $o: ref :: 
              { read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)] } 
              read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##self#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#0, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##self#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#1, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#0 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#0, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                it#0);
            assume MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              it#0);
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##t#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#1, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#1);
            assume IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert defass#q#0;
            assert {:subsumption 0} q#0 != null;
            ##t#2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#2, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##q#0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            ##it#1 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#1, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#2);
            assert {:subsumption 0} MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), ##t#2, ##it#1);
            assert {:subsumption 0} LruModel.__default.WF#canCall(##q#0)
               ==> LruModel.__default.WF(##q#0)
                 || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, ##q#0);
            assume IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                it#0);
            assume Seq#Equal(IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)), 
              IndirectionTableModel.__default.makeGarbageQueueIterate($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
                it#0));
            assert defass#q#0;
            assert {:subsumption 0} q#0 != null;
            ##q#1 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#1, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            assume LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume Set#Subset(LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue)), 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume Map#Card(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)))
               <= LitInt(4294967296);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume false;
        }

        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        if (!MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
        {
            break;
        }

        $decr$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(578,9)
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType);
        newtype$check#0_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume MutableMapModel.Iterator.Iterator_q(it#0)
           && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType);
        if (IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
           == LitInt(0))
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(579,26)
            // TrCallStmt: Before ProcessCallStmt
            assert defass#q#0;
            assert q#0 != null;
            assume true;
            // ProcessCallStmt: CheckSubrange
            q##0_0_0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            // ProcessCallStmt: CheckSubrange
            x##0_0_0 := MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0));
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$LruModel.__default.LruUse(q##0_0_0, x##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(579,47)"} true;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(581,48)
            // TrCallStmt: Before ProcessCallStmt
            assert defass#q#0;
            assert q#0 != null;
            ##q#0_0_0 := read($Heap, q#0, LruImpl.LruImplQueue.Queue);
            // assume allocatedness for argument to function
            assume $IsAlloc(##q#0_0_0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
            assume LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue));
            assume LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue));
            // ProcessCallStmt: CheckSubrange
            a##0_0_0 := LruModel.__default.I(read($Heap, q#0, LruImpl.LruImplQueue.Queue));
            assert t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            // ProcessCallStmt: CheckSubrange
            b##0_0_0 := Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)));
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$Sets.__default.SetInclusionImpliesSmallerCardinality(Tclass.NativeTypes.uint64(), a##0_0_0, b##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(582,55)"} true;
            // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(583,11)
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert Set#Card(Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))))
               == Map#Card(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)));
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(585,16)
            // TrCallStmt: Before ProcessCallStmt
            assert defass#q#0;
            assume true;
            assert q#0 != null;
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            // ProcessCallStmt: CheckSubrange
            x##0_0_1 := MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0));
            assert (forall<alpha> $o: ref, $f: Field alpha :: 
              $o != null
                   && read($Heap, $o, alloc)
                   && ($o == q#0 || read($Heap, q#0, LruImpl.LruImplQueue.Repr)[$Box($o)])
                 ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$LruImpl.LruImplQueue.Use(q#0, x##0_0_1);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(585,28)"} true;
        }
        else
        {
        }

        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(587,24)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Iterator<IndirectionTableModel.Entry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert t#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_0 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$MutableMap.ResizingHashMap.IterInc(Tclass.IndirectionTableModel.Entry(), t#0, it##0_0);
        // TrCallStmt: After ProcessCallStmt
        it#0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(587,27)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(567,7)
        assert ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr$loop#00);
        assume LruImpl.LruImplQueue.Inv#canCall($Heap, q#0);
        assume true;
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.makeGarbageQueue#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            read($Heap, q#0, LruImpl.LruImplQueue.Queue), 
            it#0);
        assume LruModel.__default.I#canCall(read($Heap, q#0, LruImpl.LruImplQueue.Queue))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    }

    assert defass#q#0;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (r#0: int where LitInt(0) <= r#0 && r#0 < 18446744073709551616);
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound(t#0: ref) returns (r#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##t#0: DatatypeType;

    // AddMethodImpl: ComputeRefUpperBound, CheckWellformed$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(591,18): initial state"} true;
    assert t#0 != null;
    assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc r#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(594,14): post-state"} true;
    assert t#0 != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    ##t#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $Heap);
    assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#0);
    assume IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    assume r#0
       == IndirectionTableModel.__default.computeRefUpperBound(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (r#0: int where LitInt(0) <= r#0 && r#0 < 18446744073709551616);
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  ensures r#0
     == IndirectionTableModel.__default.computeRefUpperBound(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound(t#0: ref
       where $Is(t#0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap))
   returns (r#0: int where LitInt(0) <= r#0 && r#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 33 == $FunctionContextHeight;
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
     && IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  ensures r#0
     == IndirectionTableModel.__default.computeRefUpperBound(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound(t#0: ref) returns (r#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(it#0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var refUpperBound#0: int
     where LitInt(0) <= refUpperBound#0 && refUpperBound#0 < 18446744073709551616;
  var newtype$check#0: int;
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: Box;
  var $w$loop#0: bool;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;
  var ##it#0: DatatypeType;
  var ref#0: int;
  var ##t#1: DatatypeType;
  var ##it#1: DatatypeType;
  var ##refUpperBound#0: int;
  var ##t#2: DatatypeType;
  var $decr$loop#00: Box;
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0_0: DatatypeType;

    // AddMethodImpl: ComputeRefUpperBound, Impl$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(595,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(596,28)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Iterator<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert t#0 != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.IterStart(Tclass.IndirectionTableModel.Entry(), t#0);
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(596,29)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(597,25)
    assume true;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    refUpperBound#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(597,28)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(598,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#0
         ==> MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0);
      invariant $w$loop#0
         ==> MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
          it#0);
      free invariant $w$loop#0 ==> MutableMapModel.Iterator.Iterator_q(it#0);
      invariant $w$loop#0
         ==> (forall ref#1: int :: 
          { MutableMapModel.Iterator.s(it#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && MutableMapModel.Iterator.s(it#0)[$Box(ref#1)]
             ==> ref#1 <= refUpperBound#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0, 
            refUpperBound#0)
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      invariant $w$loop#0
         ==> IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($LS($LZ)), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0, 
            refUpperBound#0)
           == IndirectionTableModel.__default.computeRefUpperBound(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00
           || ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr_init$loop#00))
         && (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(598,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##self#0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#0, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##self#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#1, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#0 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#0, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                it#0);
            assume MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              it#0);
            havoc ref#0;
            assume LitInt(0) <= ref#0 && ref#0 < 18446744073709551616;
            // Begin Comprehension WF check
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            if (MutableMapModel.Iterator.s(it#0)[$Box(ref#0)])
            {
            }

            // End Comprehension WF check
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume (forall ref#1: int :: 
              { MutableMapModel.Iterator.s(it#0)[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && MutableMapModel.Iterator.s(it#0)[$Box(ref#1)]
                 ==> ref#1 <= refUpperBound#0);
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##t#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#1, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#1 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#1, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##refUpperBound#0 := refUpperBound#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##refUpperBound#0, Tclass.NativeTypes.uint64(), $Heap);
            assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#1);
            assert {:subsumption 0} MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), ##t#1, ##it#1);
            assert {:subsumption 0} (forall ref#2: int :: 
              { MutableMapModel.Iterator.s(##it#1)[$Box(ref#2)] } 
              LitInt(0) <= ref#2
                   && ref#2 < 18446744073709551616
                   && MutableMapModel.Iterator.s(##it#1)[$Box(ref#2)]
                 ==> ref#2 <= ##refUpperBound#0);
            assume IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
              it#0, 
              refUpperBound#0);
            assert {:subsumption 0} t#0 != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            ##t#2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#2, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##t#2);
            assume IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                it#0, 
                refUpperBound#0)
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
               && IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($LZ), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
                it#0, 
                refUpperBound#0)
               == IndirectionTableModel.__default.computeRefUpperBound(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume false;
        }

        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        if (!MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
        {
            break;
        }

        $decr$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(606,9)
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        if (MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))
           > refUpperBound#0)
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(607,25)
            assume true;
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            refUpperBound#0 := MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0));
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(607,38)"} true;
        }
        else
        {
        }

        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(609,24)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Iterator<IndirectionTableModel.Entry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert t#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_0 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$MutableMap.ResizingHashMap.IterInc(Tclass.IndirectionTableModel.Entry(), t#0, it##0_0);
        // TrCallStmt: After ProcessCallStmt
        it#0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(609,27)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(598,7)
        assert ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr$loop#00);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0), 
            it#0, 
            refUpperBound#0)
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0)
           && IndirectionTableModel.__default.computeRefUpperBound#canCall(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0));
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(611,9)
    assume true;
    assume true;
    r#0 := refUpperBound#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(611,24)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable(v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap)
         && $IsA#GenericMarshalling.V(v#0))
   returns (s#0: ref
       where $Is(s#0, Tclass.IndirectionTableImpl.IndirectionTable?())
         && $IsAlloc(s#0, Tclass.IndirectionTableImpl.IndirectionTable?(), $Heap));
  free requires 34 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function IndirectionTableModel.__default.valToIndirectionTable#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $fh$0x#0) } 
  Apply1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $fh$0x#0)
     == $Box(IndirectionTableModel.__default.valToIndirectionTable($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $fh$0x#0) } 
  Requires1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $fh$0x#0)
     == IndirectionTableModel.__default.valToIndirectionTable#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: 
  { IndirectionTableModel.__default.valToIndirectionTable($fh$0x#0), $IsGoodHeap($heap) } 
  IndirectionTableModel.__default.valToIndirectionTable($fh$0x#0)
     == $Unbox(Apply1(Tclass.GenericMarshalling.V(), 
        Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
        $heap, 
        IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
        $Box($fh$0x#0))): DatatypeType);

implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable(v#0: DatatypeType) returns (s#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##x0#0: DatatypeType;
  var ##v#0: DatatypeType;
  var ##v#1: DatatypeType;

    // AddMethodImpl: ValToIndirectionTable, CheckWellformed$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(614,18): initial state"} true;
    assert true;
    ##x0#0 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##x0#0, Tclass.GenericMarshalling.V(), $Heap);
    assume Requires1#canCall(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $Heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $Box(v#0));
    assume Requires1(Tclass.GenericMarshalling.V(), 
      Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
      $Heap, 
      IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
      $Box(v#0));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc s#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(617,22): post-state"} true;
    if (*)
    {
        assume s#0 != null;
        assert s#0 != null;
        assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0);
        assume IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0);
    }
    else
    {
        assume s#0 != null ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0);
    }

    if (*)
    {
        assume s#0 != null;
        assert s#0 != null;
        assume (forall $o: ref :: 
          { read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
    }
    else
    {
        assume s#0 != null
           ==> (forall $o: ref :: 
            { read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
               ==> $o != null && !read(old($Heap), $o, alloc));
    }

    if (*)
    {
        assume s#0 == null;
        ##v#0 := v#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##v#0, Tclass.GenericMarshalling.V(), $Heap);
        assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, ##v#0);
        assume GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, ##v#0);
        assert {:subsumption 0} GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
          ##v#0, 
          Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
        assume GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          ##v#0, 
          Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
        assume IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
        assume Options.Option.None_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
    }
    else
    {
        assume s#0 == null
           ==> Options.Option.None_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
    }

    if (*)
    {
        assume s#0 != null;
        ##v#1 := v#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##v#1, Tclass.GenericMarshalling.V(), $Heap);
        assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, ##v#1);
        assume GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, ##v#1);
        assert {:subsumption 0} GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
          ##v#1, 
          Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
        assume GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          ##v#1, 
          Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
        assume IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
        assert s#0 != null;
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(s#0)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || Set#Equal(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr), 
              Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(s#0)), 
                  read($Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Repr)), 
                (if read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then read($Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)
                   else Set#Empty(): Set Box)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || !read($Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(s#0)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> Set#Disjoint(read($Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr), 
                read($Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> !read($Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)[$Box(s#0)]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                Lit(true)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  BlockCache.__default.GraphClosed(graph#0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#0: int :: 
                    { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                      { Map#Domain(graph#0)[$Box(ref#0)] } 
                    LitInt(0) <= ref#0
                         && ref#0 < 18446744073709551616
                         && Map#Domain(graph#0)[$Box(ref#0)]
                       ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                         <= LitInt(Bounds.__default.MaxNumChildren())))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#1: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                      LitInt(0) <= ref#1
                           && ref#1 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#2: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                      LitInt(0) <= ref#2
                           && ref#2 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                             == LitInt(0)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Count)
                     <= LitInt(IndirectionTableModel.__default.MaxSize()))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#3: int :: 
                    { Map#Domain(graph#0)[$Box(ref#3)] } 
                    LitInt(0) <= ref#3
                         && ref#3 < 18446744073709551616
                         && Map#Domain(graph#0)[$Box(ref#3)]
                       ==> ref#3 <= read($Heap, s#0, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
             || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> (forall r#0: int :: 
                      { Map#Domain(locs#0)[$Box(r#0)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                      LitInt(0) <= r#0
                           && r#0 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                         ==> Map#Domain(locs#0)[$Box(r#0)]))));
        assume IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0);
        assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, s#0);
        assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, s#0));
        assume Options.Option#Equal(IndirectionTableModel.__default.valToIndirectionTable(v#0), 
          #Options.Option.Some($Box(IndirectionTableImpl.IndirectionTable.I($Heap, s#0))));
    }
    else
    {
        assume s#0 != null
           ==> Options.Option#Equal(IndirectionTableModel.__default.valToIndirectionTable(v#0), 
            #Options.Option.Some($Box(IndirectionTableImpl.IndirectionTable.I($Heap, s#0))));
    }
}



procedure Call$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable(v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap)
         && $IsA#GenericMarshalling.V(v#0))
   returns (s#0: ref
       where $Is(s#0, Tclass.IndirectionTableImpl.IndirectionTable?())
         && $IsAlloc(s#0, Tclass.IndirectionTableImpl.IndirectionTable?(), $Heap));
  // user-defined preconditions
  requires Requires1(Tclass.GenericMarshalling.V(), 
    Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
    $Heap, 
    IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
    $Box(v#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures s#0 != null ==> IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0);
  ensures s#0 != null ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0);
  free ensures true;
  ensures s#0 != null
     ==> (forall $o: ref :: 
      { read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures s#0 == null
     ==> IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
  ensures s#0 == null
     ==> Options.Option.None_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
  free ensures s#0 != null
     ==> $IsA#Options.Option(IndirectionTableModel.__default.valToIndirectionTable(v#0))
       && 
      IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0)
       && IndirectionTableImpl.IndirectionTable.I#canCall($Heap, s#0);
  ensures s#0 != null
     ==> Options.Option#Equal(IndirectionTableModel.__default.valToIndirectionTable(v#0), 
      #Options.Option.Some($Box(IndirectionTableImpl.IndirectionTable.I($Heap, s#0))));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable(v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap)
         && $IsA#GenericMarshalling.V(v#0))
   returns (s#0: ref
       where $Is(s#0, Tclass.IndirectionTableImpl.IndirectionTable?())
         && $IsAlloc(s#0, Tclass.IndirectionTableImpl.IndirectionTable?(), $Heap), 
    $_reverifyPost: bool);
  free requires 34 == $FunctionContextHeight;
  // user-defined preconditions
  requires Requires1(Tclass.GenericMarshalling.V(), 
    Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable()), 
    $Heap, 
    IndirectionTableModel.__default.valToIndirectionTable#Handle(), 
    $Box(v#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures s#0 != null ==> IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0);
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(s#0)];
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))];
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || Set#Equal(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(s#0)), 
            read($Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || !read($Heap, 
        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(s#0)];
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(s#0)]);
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#1))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#4: int :: 
              { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                { Map#Domain(graph#1)[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(graph#1)[$Box(ref#4)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#5: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#5)]))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#6: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                LitInt(0) <= ref#6
                     && ref#6 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                       == LitInt(0)))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#7: int :: 
              { Map#Domain(graph#1)[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && Map#Domain(graph#1)[$Box(ref#7)]
                 ==> ref#7 <= read($Heap, s#0, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures s#0 != null
     ==> 
    IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, s#0)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, s#0)
       || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#1: int :: 
                { Map#Domain(locs#1)[$Box(r#1)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                LitInt(0) <= r#1
                     && r#1 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                   ==> Map#Domain(locs#1)[$Box(r#1)]))));
  free ensures true;
  ensures s#0 != null
     ==> (forall $o: ref :: 
      { read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)] } 
      read($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
  free ensures s#0 == null
     ==> IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
  ensures s#0 == null
     ==> Options.Option.None_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
  free ensures s#0 != null
     ==> $IsA#Options.Option(IndirectionTableModel.__default.valToIndirectionTable(v#0))
       && 
      IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0)
       && IndirectionTableImpl.IndirectionTable.I#canCall($Heap, s#0);
  ensures s#0 != null
     ==> Options.Option#Equal(IndirectionTableModel.__default.valToIndirectionTable(v#0), 
      #Options.Option.Some($Box(IndirectionTableImpl.IndirectionTable.I($Heap, s#0))));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable(v#0: DatatypeType) returns (s#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var newtype$check#0: int;
  var res#0_0: DatatypeType
     where $Is(res#0_0, 
        Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())))
       && $IsAlloc(res#0_0, 
        Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())), 
        $Heap);
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, 
        Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())))
       && $IsAlloc($rhs##0_0, 
        Tclass.Options.Option(Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry())), 
        $Heap);
  var a##0_0: Seq Box;
  var _mcc#0#0_0_0: ref;
  var t#0_0_0: ref;
  var let#0_0_0#0#0: ref;
  var rootRef#0_0_0: DatatypeType
     where $Is(rootRef#0_0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(rootRef#0_0_0, 
        Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0_0_0: DatatypeType
     where $Is($rhs##0_0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0_0, Tclass.Options.Option(Tclass.IndirectionTableModel.Entry()), $Heap);
  var key##0_0_0: int;
  var t1#0_0_0_0: ref
     where $Is(t1#0_0_0_0, 
        Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(t1#0_0_0_0, 
        Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0_0_0_0: ref
     where $Is($rhs##0_0_0_0, 
        Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0_0_0, 
        Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var t##0_0_0_0: ref;
  var t##0_0_0_0_0: DatatypeType;
  var t##0_0_0_0_1: DatatypeType;
  var t##0_0_0_0_2: DatatypeType;
  var q#0_0_0_0_0: ref
     where $Is(q#0_0_0_0_0, Tclass.LruImpl.LruImplQueue())
       && $IsAlloc(q#0_0_0_0_0, Tclass.LruImpl.LruImplQueue(), $Heap);
  var $rhs##0_0_0_0_0: ref
     where $Is($rhs##0_0_0_0_0, Tclass.LruImpl.LruImplQueue())
       && $IsAlloc($rhs##0_0_0_0_0, Tclass.LruImpl.LruImplQueue(), $Heap);
  var t##0_0_0_0_3: ref;
  var $nw: ref;
  var t##0_0_0_0_4: ref;
  var $rhs#0_0_0_0_0: ref where $Is($rhs#0_0_0_0_0, Tclass.LruImpl.LruImplQueue?());
  var $obj0: ref;
  var $rhs##0_0_0_0_1: int
     where LitInt(0) <= $rhs##0_0_0_0_1 && $rhs##0_0_0_0_1 < 18446744073709551616;
  var t##0_0_0_0_5: ref;
  var $rhs#0_0_0_0_1: DatatypeType
     where $Is($rhs#0_0_0_0_1, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));
  var $rhs#0_0_0_0_2: Set Box where $Is($rhs#0_0_0_0_2, TSet(Tclass._System.object()));

    // AddMethodImpl: ValToIndirectionTable, Impl$$IndirectionTableImpl.IndirectionTable.ValToIndirectionTable
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(621,4): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(622,7)
    assert GenericMarshalling.V.VArray_q(v#0);
    newtype$check#0 := Seq#Length(GenericMarshalling.V.a(v#0));
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume IndirectionTableModel.__default.MaxSizeUint64#canCall();
    assume IndirectionTableModel.__default.MaxSizeUint64#canCall();
    if (Seq#Length(GenericMarshalling.V.a(v#0))
       <= LitInt(IndirectionTableModel.__default.MaxSizeUint64()))
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(623,32)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Option<HashMap>
        // TrCallStmt: Before ProcessCallStmt
        assert GenericMarshalling.V.VArray_q(v#0);
        assume true;
        // ProcessCallStmt: CheckSubrange
        a##0_0 := GenericMarshalling.V.a(v#0);
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$IndirectionTableImpl.IndirectionTable.ValToHashMap(a##0_0);
        // TrCallStmt: After ProcessCallStmt
        res#0_0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(623,36)"} true;
        assume true;
        havoc _mcc#0#0_0_0;
        if (res#0_0 == #Options.Option.None())
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(648,15)
            assume true;
            assume true;
            s#0 := null;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(648,21)"} true;
        }
        else if (res#0_0 == #Options.Option.Some($Box(_mcc#0#0_0_0)))
        {
            assume $Is(_mcc#0#0_0_0, 
                Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()))
               && $IsAlloc(_mcc#0#0_0_0, 
                Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
                $Heap);
            havoc t#0_0_0;
            assume $Is(t#0_0_0, 
                Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()))
               && $IsAlloc(t#0_0_0, 
                Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()), 
                $Heap);
            assume let#0_0_0#0#0 == _mcc#0#0_0_0;
            assume true;
            // CheckWellformedWithResult: any expression
            assume $Is(let#0_0_0#0#0, 
              Tclass.MutableMap.ResizingHashMap?(Tclass.IndirectionTableModel.Entry()));
            assume t#0_0_0 == let#0_0_0#0#0;
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(626,33)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<IndirectionTableModel.Entry>
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            assert t#0_0_0 != null;
            assume PivotBetreeGraph.__default.Root#canCall();
            assume PivotBetreeGraph.__default.Root#canCall();
            // ProcessCallStmt: CheckSubrange
            key##0_0_0 := LitInt(PivotBetreeGraph.__default.Root());
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##0_0_0 := Call$$MutableMap.ResizingHashMap.Get(Tclass.IndirectionTableModel.Entry(), t#0_0_0, key##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            rootRef#0_0_0 := $rhs##0_0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(626,45)"} true;
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(627,13)
            assume true;
            if (Options.Option.Some_q(rootRef#0_0_0))
            {
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(628,41)
                assume true;
                // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type MutableMap.ResizingHashMap?<IndirectionTableModel.Entry>
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                // ProcessCallStmt: CheckSubrange
                assert $Is(t#0_0_0, Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()));
                t##0_0_0_0 := t#0_0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call $rhs##0_0_0_0 := Call$$IndirectionTableImpl.IndirectionTable.ComputeRefCounts(t##0_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                t1#0_0_0_0 := $rhs##0_0_0_0;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(628,43)"} true;
                // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(629,15)
                assume true;
                if (t1#0_0_0_0 != null)
                {
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(630,67)
                    // TrCallStmt: Before ProcessCallStmt
                    assert t1#0_0_0_0 != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0));
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    // ProcessCallStmt: CheckSubrange
                    t##0_0_0_0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$IndirectionTableModel.__default.lemmaMakeGarbageQueueCorrect(t##0_0_0_0_0);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(630,74)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(631,64)
                    // TrCallStmt: Before ProcessCallStmt
                    assert t#0_0_0 != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0_0_0);
                    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t#0_0_0);
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0_0_0);
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0_0_0));
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t#0_0_0);
                    // ProcessCallStmt: CheckSubrange
                    t##0_0_0_0_1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t#0_0_0);
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##0_0_0_0_1);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(631,70)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(632,64)
                    // TrCallStmt: Before ProcessCallStmt
                    assert t1#0_0_0_0 != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0));
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    // ProcessCallStmt: CheckSubrange
                    t##0_0_0_0_2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), $Heap, t1#0_0_0_0);
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##0_0_0_0_2);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(632,71)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(634,42)
                    assume true;
                    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type LruImpl.LruImplQueue
                    // TrCallStmt: Before ProcessCallStmt
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    assert $Is(t1#0_0_0_0, 
                      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()));
                    t##0_0_0_0_3 := t1#0_0_0_0;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call $rhs##0_0_0_0_0 := Call$$IndirectionTableImpl.IndirectionTable.MakeGarbageQueue(t##0_0_0_0_3);
                    // TrCallStmt: After ProcessCallStmt
                    q#0_0_0_0_0 := $rhs##0_0_0_0_0;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(634,45)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(635,19)
                    assume true;
                    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(635,22)
                    // TrCallStmt: Before ProcessCallStmt
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    assert $Is(t1#0_0_0_0, 
                      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()));
                    t##0_0_0_0_4 := t1#0_0_0_0;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call $nw := Call$$IndirectionTableImpl.IndirectionTable.__ctor(t##0_0_0_0_4);
                    // TrCallStmt: After ProcessCallStmt
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(635,45)"} true;
                    s#0 := $nw;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(635,45)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(636,32)
                    assert s#0 != null;
                    assume true;
                    assert $_Frame[s#0, IndirectionTableImpl.IndirectionTable.garbageQueue];
                    assume true;
                    $rhs#0_0_0_0_0 := q#0_0_0_0_0;
                    $Heap := update($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue, $rhs#0_0_0_0_0);
                    assume $IsGoodHeap($Heap);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(636,35)"} true;
                    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(637,56)
                    assert s#0 != null;
                    assume true;
                    $obj0 := s#0;
                    assert $_Frame[$obj0, IndirectionTableImpl.IndirectionTable.refUpperBound];
                    // TrCallStmt: Adding lhs Microsoft.Dafny.MemberSelectExpr with type uint64
                    // TrCallStmt: Before ProcessCallStmt
                    assume true;
                    // ProcessCallStmt: CheckSubrange
                    assert $Is(t1#0_0_0_0, 
                      Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()));
                    t##0_0_0_0_5 := t1#0_0_0_0;
                    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                    // ProcessCallStmt: Make the call
                    call $rhs##0_0_0_0_1 := Call$$IndirectionTableImpl.IndirectionTable.ComputeRefUpperBound(t##0_0_0_0_5);
                    // TrCallStmt: After ProcessCallStmt
                    $Heap := update($Heap, 
                      $obj0, 
                      IndirectionTableImpl.IndirectionTable.refUpperBound, 
                      $rhs##0_0_0_0_1);
                    assume $IsGoodHeap($Heap);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(637,59)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(638,39)
                    assert s#0 != null;
                    assume true;
                    assert $_Frame[s#0, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
                    assume true;
                    $rhs#0_0_0_0_1 := Lit(#Options.Option.None());
                    $Heap := update($Heap, 
                      s#0, 
                      IndirectionTableImpl.IndirectionTable.findLoclessIterator, 
                      $rhs#0_0_0_0_1);
                    assume $IsGoodHeap($Heap);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(638,45)"} true;
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(639,24)
                    assert s#0 != null;
                    assume true;
                    assert $_Frame[s#0, IndirectionTableImpl.IndirectionTable.Repr];
                    assert s#0 != null;
                    assert read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t) != null;
                    assert s#0 != null;
                    assert read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
                    assume true;
                    assert $Is(Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(s#0)), 
                          read($Heap, 
                            read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
                            MutableMap.ResizingHashMap.Repr)), 
                        read($Heap, 
                          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Repr)), 
                      TSet(Tclass._System.object()));
                    $rhs#0_0_0_0_2 := Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(s#0)), 
                        read($Heap, 
                          read($Heap, s#0, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Repr)), 
                      read($Heap, 
                        read($Heap, s#0, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr));
                    $Heap := update($Heap, s#0, IndirectionTableImpl.IndirectionTable.Repr, $rhs#0_0_0_0_2);
                    assume $IsGoodHeap($Heap);
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(639,62)"} true;
                }
                else
                {
                    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(641,19)
                    assume true;
                    assume true;
                    s#0 := null;
                    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(641,25)"} true;
                }
            }
            else
            {
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(644,17)
                assume true;
                assume true;
                s#0 := null;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(644,23)"} true;
            }
        }
        else
        {
            assume false;
        }
    }
    else
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(652,11)
        assume true;
        assume true;
        s#0 := null;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(652,17)"} true;
    }
}



// function declaration for IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize
function IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this: ref) : int;

function IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(this: ref) : bool;

// consequence axiom for IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize
axiom 38 <= $FunctionContextHeight
   ==> (forall this: ref :: 
    { IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this) } 
    IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(this)
         || (38 != $FunctionContextHeight
           && 
          this != null
           && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable()))
       ==> true);

function IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#requires(ref) : bool;

// #requires axiom for IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize
axiom (forall this: ref :: 
  { IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#requires(this) } 
  this != null && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
     ==> IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#requires(this)
       == true);

// definition axiom for IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(revealed)
axiom 38 <= $FunctionContextHeight
   ==> (forall this: ref :: 
    { IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this) } 
    IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(this)
         || (38 != $FunctionContextHeight
           && 
          this != null
           && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable()))
       ==> IndirectionTableModel.__default.MaxSize#canCall()
         && Bounds.__default.MaxNumChildren#canCall()
         && IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this)
           == LitInt(8
               + Mul(LitInt(IndirectionTableModel.__default.MaxSize()), 
                LitInt(8 + 8 + 8 + 8 + Mul(LitInt(Bounds.__default.MaxNumChildren()), LitInt(8))))));

// definition axiom for IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize for all literals(revealed)
axiom 38 <= $FunctionContextHeight
   ==> (forall this: ref :: 
    {:weight 3} { IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(Lit(this)) } 
    IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(Lit(this))
         || (38 != $FunctionContextHeight
           && 
          this != null
           && $Is(this, Tclass.IndirectionTableImpl.IndirectionTable()))
       ==> IndirectionTableModel.__default.MaxSize#canCall()
         && Bounds.__default.MaxNumChildren#canCall()
         && IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(Lit(this))
           == LitInt(8
               + Mul(LitInt(IndirectionTableModel.__default.MaxSize()), 
                LitInt(8 + 8 + 8 + 8 + Mul(LitInt(Bounds.__default.MaxNumChildren()), LitInt(8))))));

procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var b$reqreads#0: bool;
  var b$reqreads#1: bool;

    b$reqreads#0 := true;
    b$reqreads#1 := true;

    // AddWellformednessCheck for function MaxIndirectionTableByteSize
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(656,13): initial state"} true;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    if (*)
    {
        assume false;
    }
    else
    {
        $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
          $o != null && read($Heap, $o, alloc) ==> false);
        b$reqreads#0 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume IndirectionTableModel.__default.MaxSize#canCall();
        b$reqreads#1 := (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        assume Bounds.__default.MaxNumChildren#canCall();
        assume IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this)
           == LitInt(8
               + Mul(LitInt(IndirectionTableModel.__default.MaxSize()), 
                LitInt(8 + 8 + 8 + 8 + Mul(LitInt(Bounds.__default.MaxNumChildren()), LitInt(8)))));
        assume IndirectionTableModel.__default.MaxSize#canCall()
           && Bounds.__default.MaxNumChildren#canCall();
        // CheckWellformedWithResult: any expression
        assume $Is(IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this), TInt);
        assert b$reqreads#0;
        assert b$reqreads#1;
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    a#0: ref
       where $Is(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()), $Heap), 
    i#0: int);
  free requires 36 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array(this: ref, a#0: ref, i#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##t#0: Seq Box;
  var ##val#0: DatatypeType;
  var ##t#1: Seq Box;

    // AddMethodImpl: lemma_SeqSum_prefix_array, CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(660,10): initial state"} true;
    if (0 < i#0)
    {
        assert a#0 != null;
    }

    assume 0 < i#0 && i#0 <= _System.array.Length(a#0);
    havoc $Heap;
    assume old($Heap) == $Heap;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(662,47): post-state"} true;
    assert a#0 != null;
    assert 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
    ##t#0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
    assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1));
    assert a#0 != null;
    assert 0 <= i#0 - 1 && i#0 - 1 < _System.array.Length(a#0);
    ##val#0 := $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##val#0, Tclass.GenericMarshalling.V(), $Heap);
    assume GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType);
    assert a#0 != null;
    assert 0 <= i#0 && i#0 <= _System.array.Length(a#0);
    ##t#1 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##t#1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
    assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
    assume GenericMarshalling.__default.SeqSum(StartFuel_GenericMarshalling._default.SeqSum, 
          Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
         + GenericMarshalling.__default.SizeOfV(StartFuel_GenericMarshalling._default.SizeOfV, 
          $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType)
       == GenericMarshalling.__default.SeqSum(StartFuel_GenericMarshalling._default.SeqSum, 
        Seq#Take(Seq#FromArray($Heap, a#0), i#0));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    a#0: ref
       where $Is(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()), $Heap), 
    i#0: int);
  // user-defined preconditions
  requires 0 < i#0;
  requires i#0 <= _System.array.Length(a#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
     && GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType)
     && GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
  ensures GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
        Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
       + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, 
        $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType)
     == GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
      Seq#Take(Seq#FromArray($Heap, a#0), i#0));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    a#0: ref
       where $Is(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()))
         && $IsAlloc(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()), $Heap), 
    i#0: int)
   returns ($_reverifyPost: bool);
  free requires 36 == $FunctionContextHeight;
  // user-defined preconditions
  requires 0 < i#0;
  requires i#0 <= _System.array.Length(a#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
     && GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType)
     && GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
  ensures GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
        Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
       + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, 
        $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType)
     == GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
      Seq#Take(Seq#FromArray($Heap, a#0), i#0));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array(this: ref, a#0: ref, i#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var s##0: Seq Box;
  var v##0: DatatypeType;

    // AddMethodImpl: lemma_SeqSum_prefix_array, Impl$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(663,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(664,26)
    // TrCallStmt: Before ProcessCallStmt
    assert a#0 != null;
    assert 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    s##0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1);
    assert a#0 != null;
    assert 0 <= i#0 - 1 && i#0 - 1 < _System.array.Length(a#0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    v##0 := $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$GenericMarshalling.__default.lemma__SeqSum__prefix(s##0, v##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(664,43)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(665,7)
    assert a#0 != null;
    assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
    assert a#0 != null;
    assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 < _System.array.Length(a#0);
    assert a#0 != null;
    assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
    assume true;
    assert Seq#Equal(Seq#Append(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1), 
        Seq#Build(Seq#Empty(): Seq Box, read($Heap, a#0, IndexField(i#0 - 1)))), 
      Seq#Take(Seq#FromArray($Heap, a#0), i#0));
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__tuple__size(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616, 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableImpl.IndirectionTable.lemma__tuple__size(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616, 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SizeOfV#canCall(#GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(a#0))), 
            $Box(#GenericMarshalling.V.VUint64(b#0))), 
          $Box(#GenericMarshalling.V.VUint64(c#0))), 
        $Box(#GenericMarshalling.V.VUint64Array(succs#0)))));
  ensures GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, 
      #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(a#0))), 
              $Box(#GenericMarshalling.V.VUint64(b#0))), 
            $Box(#GenericMarshalling.V.VUint64(c#0))), 
          $Box(#GenericMarshalling.V.VUint64Array(succs#0)))))
     == 8 + 8 + 8 + 8 + Mul(Seq#Length(succs#0), LitInt(8));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$IndirectionTableImpl.IndirectionTable.lemma__tuple__size(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap), 
    a#0: int where LitInt(0) <= a#0 && a#0 < 18446744073709551616, 
    b#0: int where LitInt(0) <= b#0 && b#0 < 18446744073709551616, 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap))
   returns ($_reverifyPost: bool);
  free requires 37 == $FunctionContextHeight;
  // user-defined preconditions
  requires Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SizeOfV#canCall(#GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(a#0))), 
            $Box(#GenericMarshalling.V.VUint64(b#0))), 
          $Box(#GenericMarshalling.V.VUint64(c#0))), 
        $Box(#GenericMarshalling.V.VUint64Array(succs#0)))));
  ensures GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, 
      #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(a#0))), 
              $Box(#GenericMarshalling.V.VUint64(b#0))), 
            $Box(#GenericMarshalling.V.VUint64(c#0))), 
          $Box(#GenericMarshalling.V.VUint64Array(succs#0)))))
     == 8 + 8 + 8 + 8 + Mul(Seq#Length(succs#0), LitInt(8));
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$IndirectionTableImpl.IndirectionTable.lemma__tuple__size(this: ref, a#0: int, b#0: int, c#0: int, succs#0: Seq Box)
   returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: lemma_tuple_size, Impl$$IndirectionTableImpl.IndirectionTable.lemma__tuple__size
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS($LS($LS($LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV)))));
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS($LS($LS($LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV))))));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(672,4): initial state"} true;
    $_reverifyPost := false;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__empty(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__empty(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SeqSum#canCall(Lit(Seq#Empty(): Seq Box));
  ensures GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, Lit(Seq#Empty(): Seq Box))
     == LitInt(0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure Impl$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__empty(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns ($_reverifyPost: bool);
  free requires 39 == $FunctionContextHeight;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SeqSum#canCall(Lit(Seq#Empty(): Seq Box));
  ensures GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, Lit(Seq#Empty(): Seq Box))
     == LitInt(0);
  // frame condition
  free ensures old($Heap) == $Heap;



implementation Impl$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__empty(this: ref) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: lemma_SeqSum_empty, Impl$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__empty
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(677,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(678,20)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$GenericMarshalling.__default.reveal__SeqSum();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(678,21)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap), 
    size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616);
  free requires 40 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function Tclass.SectorType.IndirectionTable() : Ty;

// Tclass.SectorType.IndirectionTable Tag
axiom Tag(Tclass.SectorType.IndirectionTable())
   == Tagclass.SectorType.IndirectionTable;

const unique Tagclass.SectorType.IndirectionTable: TyTag;

// Box/unbox axiom for Tclass.SectorType.IndirectionTable
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SectorType.IndirectionTable()) } 
  $IsBox(bx, Tclass.SectorType.IndirectionTable())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.SectorType.IndirectionTable()));

function Tclass.GenericMarshalling.G() : Ty;

// Tclass.GenericMarshalling.G Tag
axiom Tag(Tclass.GenericMarshalling.G()) == Tagclass.GenericMarshalling.G;

const unique Tagclass.GenericMarshalling.G: TyTag;

// Box/unbox axiom for Tclass.GenericMarshalling.G
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.GenericMarshalling.G()) } 
  $IsBox(bx, Tclass.GenericMarshalling.G())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.GenericMarshalling.G()));

implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal(this: ref) returns (v#0: DatatypeType, size#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##indirectionTable#0: DatatypeType;
  var ##val#0: DatatypeType;
  var ##grammar#0: DatatypeType;
  var ##val#1: DatatypeType;
  var ##v#0: DatatypeType;
  var ##v#1: DatatypeType;
  var ##self#1: DatatypeType;
  var ##self#2: DatatypeType;
  var ##val#2: DatatypeType;
  var ##val#3: DatatypeType;

    // AddMethodImpl: indirectionTableToVal, CheckWellformed$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(951,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#0: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#0)] } 
                LitInt(0) <= ref#0
                     && ref#0 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#0)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#1: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#3: int :: 
                { Map#Domain(graph#0)[$Box(ref#3)] } 
                LitInt(0) <= ref#3
                     && ref#3 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#3)]
                   ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    ##indirectionTable#0 := IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##indirectionTable#0, Tclass.SectorType.IndirectionTable(), $Heap);
    assume BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    assume BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc v#0, size#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(955,24): post-state"} true;
    assume IndirectionTableModel.__default.IndirectionTableGrammar#canCall();
    ##val#0 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##val#0, Tclass.GenericMarshalling.V(), $Heap);
    ##grammar#0 := Lit(IndirectionTableModel.__default.IndirectionTableGrammar());
    // assume allocatedness for argument to function
    assume $IsAlloc(##grammar#0, Tclass.GenericMarshalling.G(), $Heap);
    assume GenericMarshalling.__default.ValInGrammar#canCall(v#0, Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
    assume GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
      v#0, 
      Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
    ##val#1 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##val#1, Tclass.GenericMarshalling.V(), $Heap);
    assume GenericMarshalling.__default.ValidVal#canCall(v#0);
    assume GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0);
    ##v#0 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##v#0, Tclass.GenericMarshalling.V(), $Heap);
    assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, ##v#0);
    assume GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, ##v#0);
    assert {:subsumption 0} GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
      ##v#0, 
      Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
    assume GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
      ##v#0, 
      Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
    assume IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
    assume Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
    ##v#1 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##v#1, Tclass.GenericMarshalling.V(), $Heap);
    assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, ##v#1);
    assume GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, ##v#1);
    assert {:subsumption 0} GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
      ##v#1, 
      Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
    assume GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
      ##v#1, 
      Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
    assume IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
    assert Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
    ##self#1 := $Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType;
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType);
    assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#4)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#5: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#5)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#6: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#7: int :: 
                { Map#Domain(graph#1)[$Box(ref#7)] } 
                LitInt(0) <= ref#7
                     && ref#7 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#7)]
                   ==> ref#7 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#2 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#2, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    assume SectorType.IndirectionTable#Equal(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType), 
      IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    ##val#2 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##val#2, Tclass.GenericMarshalling.V(), $Heap);
    assume GenericMarshalling.__default.SizeOfV#canCall(v#0);
    assume IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(this);
    assume GenericMarshalling.__default.SizeOfV(StartFuel_GenericMarshalling._default.SizeOfV, v#0)
       <= LitInt(IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this));
    ##val#3 := v#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##val#3, Tclass.GenericMarshalling.V(), $Heap);
    assume GenericMarshalling.__default.SizeOfV#canCall(v#0);
    assume GenericMarshalling.__default.SizeOfV(StartFuel_GenericMarshalling._default.SizeOfV, v#0)
       == size#0;
}



procedure Call$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap), 
    size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616);
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || (forall loc#0: DatatypeType :: 
        { DiskLayout.__default.ValidNodeLocation(loc#0) } 
          { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#0)] } 
        $Is(loc#0, Tclass.DiskLayout.Location())
             && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#0)]
           ==> DiskLayout.__default.ValidNodeLocation(loc#0));
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
        Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))));
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())];
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
         ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
           || (forall ref#8: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#8)]): Seq Box } 
              { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#8)] } 
            LitInt(0) <= ref#8
                 && ref#8 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#8)]
               ==> (forall succ#0: int :: 
                { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#0)] } 
                  { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#8)]): Seq Box, 
                    $Box(succ#0)) } 
                LitInt(0) <= succ#0
                     && succ#0 < 18446744073709551616
                     && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#8)]): Seq Box, 
                      $Box(succ#0))
                   ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#0)])));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.__default.IndirectionTableGrammar#canCall()
     && GenericMarshalling.__default.ValInGrammar#canCall(v#0, Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
  ensures GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
    v#0, 
    Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
  free ensures GenericMarshalling.__default.ValidVal#canCall(v#0);
  ensures GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, v#0);
  free ensures IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
  ensures Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
  free ensures $IsA#SectorType.IndirectionTable(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType))
     && $IsA#SectorType.IndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0)
     && IndirectionTableModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures SectorType.IndirectionTable#Equal(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType), 
    IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  free ensures GenericMarshalling.__default.SizeOfV#canCall(v#0)
     && IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(this);
  ensures GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, v#0)
     <= LitInt(IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this));
  free ensures GenericMarshalling.__default.SizeOfV#canCall(v#0);
  ensures GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, v#0)
     == size#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap), 
    size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 40 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                 && BlockCache.__default.GraphClosed(graph#2)
                 && (forall ref#9: int :: 
                  { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                    { Map#Domain(graph#2)[$Box(ref#9)] } 
                  LitInt(0) <= ref#9
                       && ref#9 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#9)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#10: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                      LitInt(0) <= ref#10
                           && ref#10 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)])
                     && (forall ref#11: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                      LitInt(0) <= ref#11
                           && ref#11 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#12: int :: 
                  { Map#Domain(graph#2)[$Box(ref#12)] } 
                  LitInt(0) <= ref#12
                       && ref#12 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#12)]
                     ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#2)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#2)[$Box(r#2)])))));
  free requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    (forall loc#1: DatatypeType :: 
      { DiskLayout.__default.ValidNodeLocation(loc#1) } 
        { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#1)] } 
      $Is(loc#1, Tclass.DiskLayout.Location())
           && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#1)]
         ==> DiskLayout.__default.ValidNodeLocation(loc#1))
     && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
      Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))))
     && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())]
     && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.__default.IndirectionTableGrammar#canCall()
     && GenericMarshalling.__default.ValInGrammar#canCall(v#0, Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
  ensures GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
    v#0, 
    Lit(IndirectionTableModel.__default.IndirectionTableGrammar()));
  free ensures GenericMarshalling.__default.ValidVal#canCall(v#0);
  ensures GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, v#0);
  free ensures IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0);
  ensures Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0));
  free ensures $IsA#SectorType.IndirectionTable(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType))
     && $IsA#SectorType.IndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0)
     && IndirectionTableModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures SectorType.IndirectionTable#Equal(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType), 
    IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  free ensures GenericMarshalling.__default.SizeOfV#canCall(v#0)
     && IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize#canCall(this);
  ensures GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, v#0)
     <= LitInt(IndirectionTableImpl.IndirectionTable.MaxIndirectionTableByteSize(this));
  free ensures GenericMarshalling.__default.SizeOfV#canCall(v#0);
  ensures GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, v#0)
     == size#0;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal(this: ref) returns (v#0: DatatypeType, size#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var a#0: ref
     where $Is(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()))
       && $IsAlloc(a#0, Tclass._System.array(Tclass.GenericMarshalling.V()), $Heap);
  var newtype$check#0: int;
  var $nw: ref;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(it#0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var partial#0: Map Box Box
     where $Is(partial#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(partial#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: Box;
  var $w$loop#0: bool;
  var ##self#3: DatatypeType;
  var ##indirectionTable#1: DatatypeType;
  var ##self#4: DatatypeType;
  var ##it#0: DatatypeType;
  var j#0: int;
  var newtype$check#3: int;
  var ##val#4: DatatypeType;
  var j#2: int;
  var newtype$check#4: int;
  var ##val#5: DatatypeType;
  var ##grammar#1: DatatypeType;
  var ##a#0: Seq Box;
  var ##a#1: Seq Box;
  var newtype$check#5: int;
  var r#5: int;
  var ##t#0: Seq Box;
  var $decr$loop#00: Box;
  var ref#0_0: int;
  var locOptGraph#0_0: DatatypeType;
  var let#0_0#0#0: DatatypeType;
  var locOpt#0_0: DatatypeType
     where $Is(locOpt#0_0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
       && $IsAlloc(locOpt#0_0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $Heap);
  var succs#0_0: Seq Box
     where $Is(succs#0_0, TSeq(Tclass.NativeTypes.uint64()))
       && $IsAlloc(succs#0_0, TSeq(Tclass.NativeTypes.uint64()), $Heap);
  var loc#0_0: DatatypeType
     where $Is(loc#0_0, Tclass.DiskLayout.Location())
       && $IsAlloc(loc#0_0, Tclass.DiskLayout.Location(), $Heap);
  var childrenVal#0_0: DatatypeType
     where $Is(childrenVal#0_0, Tclass.GenericMarshalling.V())
       && $IsAlloc(childrenVal#0_0, Tclass.GenericMarshalling.V(), $Heap);
  var ##loc#0_0: DatatypeType;
  var self##0_0: DatatypeType;
  var it##0_0: DatatypeType;
  var ##val#0_0: DatatypeType;
  var ##self#0_0: DatatypeType;
  var ##it#0_0: DatatypeType;
  var vi#0_0: DatatypeType
     where $Is(vi#0_0, Tclass.GenericMarshalling.V())
       && $IsAlloc(vi#0_0, Tclass.GenericMarshalling.V(), $Heap);
  var newtype$check#0_0: int;
  var $rhs#0_0: DatatypeType where $Is($rhs#0_0, Tclass.GenericMarshalling.V());
  var newtype$check#0_1: int;
  var newtype$check#0_2: int;
  var $rhs##0_0: DatatypeType
     where $Is($rhs##0_0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0_1: DatatypeType;
  var newtype$check#0_3: int;
  var newtype$check#0_4: int;
  var ##run#0_0: Seq Box;
  var newtype$check#0_0_0_0: int;
  var newtype$check#0_0_0_1: int;
  var ##t#0_0_0_0: Seq Box;
  var ##val#0_0_0_0: DatatypeType;
  var a##0_0_0_0: int;
  var b##0_0_0_0: int;
  var c##0_0_0_0: int;
  var succs##0_0_0_0: Seq Box;
  var newtype$check#0_0_1_0: int;
  var newtype$check#0_0_1_1: int;
  var ##t#0_0_1_0: Seq Box;
  var newtype$check#0_0_1_2: int;
  var newtype$check#0_0_1_3: int;
  var ##val#0_0_1_0: DatatypeType;
  var newtype$check#0_0_1_4: int;
  var newtype$check#0_0_1_5: int;
  var ##t#0_0_1_1: Seq Box;
  var ##val#0_0_1_1: DatatypeType;
  var ##t#0_0_2_0: Seq Box;
  var a##0_0_2_0: ref;
  var i##0_0_2_0: int;
  var newtype$check#0_0_2_0: int;
  var newtype$check#0_0_2_1: int;
  var ##t#0_0_2_1: Seq Box;
  var newtype$check#0_0_2_2: int;
  var newtype$check#0_0_2_3: int;
  var ##val#0_0_2_0: DatatypeType;
  var ##t#0_0_0: Seq Box;
  var newtype$check#0_5: int;
  var newtype$check#0_6: int;
  var newtype$check#0_7: int;
  var newtype$check#0_8: int;
  var newtype$check#0_9: int;
  var newtype$check#0_10: int;
  var a##0: Set Box;
  var b##0: Set Box;
  var newtype$check#6: int;
  var newtype$check#7: int;

    // AddMethodImpl: indirectionTableToVal, Impl$$IndirectionTableImpl.IndirectionTable.indirectionTableToVal
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(963,4): initial state"} true;
    $_reverifyPost := false;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(964,7)
    assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume IndirectionTableModel.__default.MaxSizeUint64#canCall();
    assume IndirectionTableModel.__default.MaxSizeUint64#canCall();
    assert read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Count)
       <= LitInt(IndirectionTableModel.__default.MaxSizeUint64());
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(965,25)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__empty(this);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(965,26)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(966,23)
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    newtype$check#0 := read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Count);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assert 0
       <= read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Count);
    havoc $nw;
    assume $nw != null
       && dtype($nw) == Tclass._System.array?(Tclass.GenericMarshalling.V());
    assume !read($Heap, $nw, alloc);
    assume _System.array.Length($nw)
       == read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Count);
    $Heap := update($Heap, $nw, alloc, true);
    assume $IsGoodHeap($Heap);
    assume $IsHeapAnchor($Heap);
    a#0 := $nw;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(966,49)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(967,28)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Iterator<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.IterStart(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(967,29)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(968,21)
    assume true;
    newtype$check#1 := LitInt(0);
    assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
    assume true;
    i#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(968,24)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(969,12)
    assume true;
    newtype$check#2 := LitInt(0);
    assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
    assume true;
    size#0 := LitInt(0);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(969,15)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(971,25)
    assume true;
    assume true;
    partial#0 := Lit(Map#Empty(): Map Box Box);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(971,32)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(972,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)];
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> Set#Disjoint(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box(this)]);
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                BlockCache.__default.GraphClosed(graph#3))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (forall ref#14: int :: 
                  { $Unbox(Map#Elements(graph#3)[$Box(ref#14)]): Seq Box } 
                    { Map#Domain(graph#3)[$Box(ref#14)] } 
                  LitInt(0) <= ref#14
                       && ref#14 < 18446744073709551616
                       && Map#Domain(graph#3)[$Box(ref#14)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#14)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren())))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#15: int :: 
                    { LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                    LitInt(0) <= ref#15
                         && ref#15 < 18446744073709551616
                         && 
                        Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                           == LitInt(0)
                       ==> LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#15)]))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#16: int :: 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)] } 
                      { LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#16)] } 
                    LitInt(0) <= ref#16
                         && ref#16 < 18446744073709551616
                         && LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#16)]
                       ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]
                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]): DatatypeType)
                           == LitInt(0)))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize()))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (forall ref#17: int :: 
                  { Map#Domain(graph#3)[$Box(ref#17)] } 
                  LitInt(0) <= ref#17
                       && ref#17 < 18446744073709551616
                       && Map#Domain(graph#3)[$Box(ref#17)]
                     ==> ref#17 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                    MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                    $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> (forall r#3: int :: 
                    { Map#Domain(locs#3)[$Box(r#3)] } 
                      { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                    LitInt(0) <= r#3
                         && r#3 < 18446744073709551616
                         && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                       ==> Map#Domain(locs#3)[$Box(r#3)]))));
      free invariant $w$loop#0
         ==> IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           && 
          IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           && 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> Set#Disjoint(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box(this)])
           && (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            true
               && (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                true
                   && (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3)
                       && BlockCache.__default.GraphClosed(graph#3)
                       && (forall ref#14: int :: 
                        { $Unbox(Map#Elements(graph#3)[$Box(ref#14)]): Seq Box } 
                          { Map#Domain(graph#3)[$Box(ref#14)] } 
                        LitInt(0) <= ref#14
                             && ref#14 < 18446744073709551616
                             && Map#Domain(graph#3)[$Box(ref#14)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#14)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren()))
                       && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#15: int :: 
                            { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                            LitInt(0) <= ref#15
                                 && ref#15 < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                                   == LitInt(0)
                               ==> LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#15)])
                           && (forall ref#16: int :: 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)] } 
                              { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#16)] } 
                            LitInt(0) <= ref#16
                                 && ref#16 < 18446744073709551616
                                 && LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#16)]
                               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]): DatatypeType)
                                   == LitInt(0)))
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                       && read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize())
                       && (forall ref#17: int :: 
                        { Map#Domain(graph#3)[$Box(ref#17)] } 
                        LitInt(0) <= ref#17
                             && ref#17 < 18446744073709551616
                             && Map#Domain(graph#3)[$Box(ref#17)]
                           ==> ref#17 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                       && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                            $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                           && (forall r#3: int :: 
                            { Map#Domain(locs#3)[$Box(r#3)] } 
                              { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                            LitInt(0) <= r#3
                                 && r#3 < 18446744073709551616
                                 && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                               ==> Map#Domain(locs#3)[$Box(r#3)])))));
      free invariant $w$loop#0
         ==> IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
           && BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || (forall loc#2: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#2) } 
              { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#2)] } 
            $Is(loc#2, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#2)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#2));
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
            Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))));
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())];
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
             ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
               || (forall ref#22: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#22)]): Seq Box } 
                  { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#22)] } 
                LitInt(0) <= ref#22
                     && ref#22 < 18446744073709551616
                     && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#22)]
                   ==> (forall succ#2: int :: 
                    { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#2)] } 
                      { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#22)]): Seq Box, 
                        $Box(succ#2)) } 
                    LitInt(0) <= succ#2
                         && succ#2 < 18446744073709551616
                         && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#22)]): Seq Box, 
                          $Box(succ#2))
                       ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#2)])));
      free invariant $w$loop#0
         ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           && 
          BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           && 
          (forall loc#2: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#2) } 
              { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#2)] } 
            $Is(loc#2, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#2)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#2))
           && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
            Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))))
           && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())]
           && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> LitInt(0) <= i#0;
      invariant $w$loop#0 ==> i#0 <= _System.array.Length(a#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0);
      invariant $w$loop#0
         ==> MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
          it#0);
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < i#0
             ==> GenericMarshalling.__default.ValidVal#canCall($Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType));
      invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
             ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
              $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType));
      free invariant $w$loop#0
         ==> (forall j#1: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType));
      free invariant $w$loop#0
         ==> (forall j#3: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType } 
          LitInt(0) <= j#3 && j#3 < 18446744073709551616
             ==> 
            LitInt(0) <= j#3 && j#3 < i#0
             ==> GenericMarshalling.__default.ValInGrammar#canCall($Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
      invariant $w$loop#0
         ==> (forall j#3: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType } 
          LitInt(0) <= j#3 && j#3 < 18446744073709551616 && LitInt(0) <= j#3 && j#3 < i#0
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
      free invariant $w$loop#0
         ==> (forall j#3: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType } 
          LitInt(0) <= j#3 && j#3 < 18446744073709551616 && LitInt(0) <= j#3 && j#3 < i#0
             ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
      free invariant $w$loop#0
         ==> IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
      invariant $w$loop#0
         ==> Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, a#0), i#0)));
      free invariant $w$loop#0
         ==> IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0))
           && MutableMapModel.LinearHashMap.LinearHashMap_q($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)))): DatatypeType);
      invariant $w$loop#0
         ==> Map#Equal(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($LS($LS($LZ)), Seq#Take(Seq#FromArray($Heap, a#0), i#0)))): DatatypeType), 
          partial#0);
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0 ==> Set#Card(Map#Domain(partial#0)) == i#0;
      free invariant $w$loop#0 ==> MutableMapModel.Iterator.Iterator_q(it#0);
      invariant $w$loop#0 ==> Set#Equal(Map#Domain(partial#0), MutableMapModel.Iterator.s(it#0));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
      invariant $w$loop#0
         ==> Set#Subset(Map#Domain(partial#0), 
          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))));
      free invariant $w$loop#0
         ==> (forall r#6: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType } 
            { $Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)] } 
            { Map#Domain(partial#0)[$Box(r#6)] } 
          LitInt(0) <= r#6 && r#6 < 18446744073709551616
             ==> 
            Map#Domain(partial#0)[$Box(r#6)]
             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]
                 ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType))
                   && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                   && 
                  IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
               && ($IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType))
                   && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                   && 
                  IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)
                   && Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                    IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                 ==> IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)));
      invariant $w$loop#0
         ==> (forall r#6: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType } 
            { $Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)] } 
            { Map#Domain(partial#0)[$Box(r#6)] } 
          LitInt(0) <= r#6
               && r#6 < 18446744073709551616
               && Map#Domain(partial#0)[$Box(r#6)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]
               && Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
               && Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)));
      invariant $w$loop#0
         ==> Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))), 
          MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))));
      free invariant $w$loop#0
         ==> MutableMapModel.Iterator.Iterator_q(it#0)
           && Bounds.__default.MaxNumChildren#canCall();
      invariant $w$loop#0
         ==> size#0
           <= Mul(Set#Card(MutableMapModel.Iterator.s(it#0)), 
            LitInt(8 + 8 + 8 + 8 + Mul(LitInt(Bounds.__default.MaxNumChildren()), LitInt(8))));
      free invariant $w$loop#0
         ==> GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
      invariant $w$loop#0
         ==> GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
            Seq#Take(Seq#FromArray($Heap, a#0), i#0))
           == size#0;
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00
           || ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr_init$loop#00))
         && (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(972,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
            assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
            assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       then read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || !read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> Set#Disjoint(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> !read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#4))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#18: int :: 
                        { $Unbox(Map#Elements(graph#4)[$Box(ref#18)]): Seq Box } 
                          { Map#Domain(graph#4)[$Box(ref#18)] } 
                        LitInt(0) <= ref#18
                             && ref#18 < 18446744073709551616
                             && Map#Domain(graph#4)[$Box(ref#18)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#18)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#19: int :: 
                          { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                          LitInt(0) <= ref#19
                               && ref#19 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#19)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#20: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#20)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#20)] } 
                            { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#20)] } 
                          LitInt(0) <= ref#20
                               && ref#20 < 18446744073709551616
                               && LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#20)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#20)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#20)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#21: int :: 
                        { Map#Domain(graph#4)[$Box(ref#21)] } 
                        LitInt(0) <= ref#21
                             && ref#21 < 18446744073709551616
                             && Map#Domain(graph#4)[$Box(ref#21)]
                           ==> ref#21 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#4: int :: 
                          { Map#Domain(locs#4)[$Box(r#4)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                          LitInt(0) <= r#4
                               && r#4 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                             ==> Map#Domain(locs#4)[$Box(r#4)]))));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            ##self#3 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#3, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
            assume IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            ##indirectionTable#1 := IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##indirectionTable#1, Tclass.SectorType.IndirectionTable(), $Heap);
            assume BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
               && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
               && BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assume BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            if (LitInt(0) <= i#0)
            {
                assert {:subsumption 0} a#0 != null;
            }

            assume true;
            assume LitInt(0) <= i#0 && i#0 <= _System.array.Length(a#0);
            assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            ##self#4 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#4, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#0 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#0, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                it#0);
            assume MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0);
            havoc j#0;
            assume LitInt(0) <= j#0 && j#0 < 18446744073709551616;
            // Begin Comprehension WF check
            newtype$check#3 := LitInt(0);
            assert LitInt(0) <= newtype$check#3 && newtype$check#3 < 18446744073709551616;
            if (LitInt(0) <= j#0)
            {
            }

            if (LitInt(0) <= j#0 && j#0 < i#0)
            {
                assert a#0 != null;
                assert {:subsumption 0} 0 <= j#0 && j#0 < _System.array.Length(a#0);
                ##val#4 := $Unbox(read($Heap, a#0, IndexField(j#0))): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##val#4, Tclass.GenericMarshalling.V(), $Heap);
                assume GenericMarshalling.__default.ValidVal#canCall($Unbox(read($Heap, a#0, IndexField(j#0))): DatatypeType);
            }

            // End Comprehension WF check
            assume (forall j#1: int :: 
              { $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616
                 ==> 
                LitInt(0) <= j#1 && j#1 < i#0
                 ==> GenericMarshalling.__default.ValidVal#canCall($Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType));
            assume (forall j#1: int :: 
              { $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType } 
              LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
                 ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                  $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType));
            havoc j#2;
            assume LitInt(0) <= j#2 && j#2 < 18446744073709551616;
            // Begin Comprehension WF check
            newtype$check#4 := LitInt(0);
            assert LitInt(0) <= newtype$check#4 && newtype$check#4 < 18446744073709551616;
            if (LitInt(0) <= j#2)
            {
            }

            if (LitInt(0) <= j#2 && j#2 < i#0)
            {
                assert a#0 != null;
                assert {:subsumption 0} 0 <= j#2 && j#2 < _System.array.Length(a#0);
                ##val#5 := $Unbox(read($Heap, a#0, IndexField(j#2))): DatatypeType;
                // assume allocatedness for argument to function
                assume $IsAlloc(##val#5, Tclass.GenericMarshalling.V(), $Heap);
                ##grammar#1 := Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array()))))));
                // assume allocatedness for argument to function
                assume $IsAlloc(##grammar#1, Tclass.GenericMarshalling.G(), $Heap);
                assume GenericMarshalling.__default.ValInGrammar#canCall($Unbox(read($Heap, a#0, IndexField(j#2))): DatatypeType, 
                  Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64Array())))))));
            }

            // End Comprehension WF check
            assume (forall j#3: int :: 
              { $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType } 
              LitInt(0) <= j#3 && j#3 < 18446744073709551616
                 ==> 
                LitInt(0) <= j#3 && j#3 < i#0
                 ==> GenericMarshalling.__default.ValInGrammar#canCall($Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType, 
                  Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
            assume (forall j#3: int :: 
              { $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType } 
              LitInt(0) <= j#3 && j#3 < 18446744073709551616 && LitInt(0) <= j#3 && j#3 < i#0
                 ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                  $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType, 
                  Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
            assert a#0 != null;
            assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
            ##a#0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assert {:subsumption 0} Seq#Length(##a#0) <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} (forall i#1: int :: 
              { $Unbox(Seq#Index(##a#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(##a#0)
                 ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
                  $Unbox(Seq#Index(##a#0, i#1)): DatatypeType));
            assert {:subsumption 0} (forall i#2: int :: 
              { $Unbox(Seq#Index(##a#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(##a#0)
                 ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                  $Unbox(Seq#Index(##a#0, i#2)): DatatypeType, 
                  Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
            assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)));
            assert a#0 != null;
            assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
            ##a#1 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##a#1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assert {:subsumption 0} Seq#Length(##a#1) <= LitInt(IndirectionTableModel.__default.MaxSize());
            assert {:subsumption 0} (forall i#3: int :: 
              { $Unbox(Seq#Index(##a#1, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < Seq#Length(##a#1)
                 ==> GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
                  $Unbox(Seq#Index(##a#1, i#3)): DatatypeType));
            assert {:subsumption 0} (forall i#4: int :: 
              { $Unbox(Seq#Index(##a#1, i#4)): DatatypeType } 
              LitInt(0) <= i#4 && i#4 < Seq#Length(##a#1)
                 ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                  $Unbox(Seq#Index(##a#1, i#4)): DatatypeType, 
                  Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
            assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assert Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)))): DatatypeType);
            assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0))
               && MutableMapModel.LinearHashMap.LinearHashMap_q($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)))): DatatypeType);
            assume Map#Equal(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)))): DatatypeType), 
              partial#0);
            newtype$check#5 := i#0;
            assert LitInt(0) <= newtype$check#5;
            assume true;
            assume Set#Card(Map#Domain(partial#0)) == i#0;
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume Set#Equal(Map#Domain(partial#0), MutableMapModel.Iterator.s(it#0));
            assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assume Set#Subset(Map#Domain(partial#0), 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))));
            havoc r#5;
            assume LitInt(0) <= r#5 && r#5 < 18446744073709551616;
            // Begin Comprehension WF check
            if (Map#Domain(partial#0)[$Box(r#5)])
            {
                assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                if (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)])
                {
                    assert {:subsumption 0} Map#Domain(partial#0)[$Box(r#5)];
                    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#5)]): DatatypeType);
                    assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)];
                    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)]): DatatypeType);
                }

                if (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)]
                   && Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#5)]): DatatypeType), 
                    IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)]): DatatypeType)))
                {
                    assert {:subsumption 0} Map#Domain(partial#0)[$Box(r#5)];
                    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#5)]): DatatypeType);
                    assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
                    assert {:subsumption 0} Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)];
                    assume IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#5)]): DatatypeType);
                }
            }

            // End Comprehension WF check
            assume (forall r#6: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType } 
                { $Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)] } 
                { Map#Domain(partial#0)[$Box(r#6)] } 
              LitInt(0) <= r#6 && r#6 < 18446744073709551616
                 ==> 
                Map#Domain(partial#0)[$Box(r#6)]
                 ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]
                     ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType))
                       && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                       && 
                      IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                       && 
                      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                   && ($IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType))
                       && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                       && 
                      IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                       && 
                      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)
                       && Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                        IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                     ==> IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                       && 
                      MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)));
            assume (forall r#6: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType } 
                { $Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)] } 
                { Map#Domain(partial#0)[$Box(r#6)] } 
              LitInt(0) <= r#6
                   && r#6 < 18446744073709551616
                   && Map#Domain(partial#0)[$Box(r#6)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]
                   && Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                    IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                   && Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                    IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)));
            assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assert {:subsumption 0} read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert $IsAlloc(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              Tclass.MutableMap.ResizingHashMap(Tclass.IndirectionTableModel.Entry()), 
              old($Heap));
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
               && 
              MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)));
            assume Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))), 
              MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume Bounds.__default.MaxNumChildren#canCall();
            assume MutableMapModel.Iterator.Iterator_q(it#0)
               && Bounds.__default.MaxNumChildren#canCall();
            assume size#0
               <= Mul(Set#Card(MutableMapModel.Iterator.s(it#0)), 
                LitInt(8 + 8 + 8 + 8 + Mul(LitInt(Bounds.__default.MaxNumChildren()), LitInt(8))));
            assert a#0 != null;
            assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
            ##t#0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume GenericMarshalling.__default.SeqSum(StartFuel_GenericMarshalling._default.SeqSum, 
                Seq#Take(Seq#FromArray($Heap, a#0), i#0))
               == size#0;
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume false;
        }

        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        if (!MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
        {
            break;
        }

        $decr$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
        havoc ref#0_0;
        assume LitInt(0) <= ref#0_0 && ref#0_0 < 18446744073709551616;
        havoc locOptGraph#0_0;
        assume $Is(locOptGraph#0_0, Tclass.IndirectionTableModel.Entry())
           && $IsAlloc(locOptGraph#0_0, Tclass.IndirectionTableModel.Entry(), $Heap);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assume let#0_0#0#0
           == #_System._tuple#2._#Make2($Box(MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))), 
            MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0)));
        assume MutableMapModel.Iterator.Iterator_q(it#0)
           && MutableMapModel.Iterator.Iterator_q(it#0);
        // CheckWellformedWithResult: any expression
        assume $Is(let#0_0#0#0, 
          Tclass._System.Tuple2(Tclass.NativeTypes.uint64(), Tclass.IndirectionTableModel.Entry()));
        assume _System.Tuple2.___hMake2_q(let#0_0#0#0);
        assume _System.Tuple2.___hMake2_q(let#0_0#0#0);
        assume #_System._tuple#2._#Make2($Box(ref#0_0), $Box(locOptGraph#0_0)) == let#0_0#0#0;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(996,9)
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
              Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Repr)), 
                (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)
                   else Set#Empty(): Set Box)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(this)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> Set#Disjoint(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> !read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)[$Box(this)]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Lit(true)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  IndirectionTableModel.__default.ValidPredCounts(predCounts#0_0, graph#0_0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  BlockCache.__default.GraphClosed(graph#0_0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#0_1: int :: 
                    { $Unbox(Map#Elements(graph#0_0)[$Box(ref#0_1)]): Seq Box } 
                      { Map#Domain(graph#0_0)[$Box(ref#0_1)] } 
                    LitInt(0) <= ref#0_1
                         && ref#0_1 < 18446744073709551616
                         && Map#Domain(graph#0_0)[$Box(ref#0_1)]
                       ==> Seq#Length($Unbox(Map#Elements(graph#0_0)[$Box(ref#0_1)]): Seq Box)
                         <= LitInt(Bounds.__default.MaxNumChildren())))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#0_2: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#0_2)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)] } 
                      LitInt(0) <= ref#0_2
                           && ref#0_2 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#0_2)]))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#0_3: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_3)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_3)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#0_3)] } 
                      LitInt(0) <= ref#0_3
                           && ref#0_3 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#0_3)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_3)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_3)]): DatatypeType)
                             == LitInt(0)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Count)
                     <= LitInt(IndirectionTableModel.__default.MaxSize()))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#0_4: int :: 
                    { Map#Domain(graph#0_0)[$Box(ref#0_4)] } 
                    LitInt(0) <= ref#0_4
                         && ref#0_4 < 18446744073709551616
                         && Map#Domain(graph#0_0)[$Box(ref#0_4)]
                       ==> ref#0_4
                         <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> (forall r#0_0: int :: 
                      { Map#Domain(locs#0_0)[$Box(r#0_0)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0)] } 
                      LitInt(0) <= r#0_0
                           && r#0_0 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0)]
                         ==> Map#Domain(locs#0_0)[$Box(r#0_0)]))));
        assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
        assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assert Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(ref#0_0)];
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(998,20)
        assume true;
        assume IndirectionTableModel.Entry.Entry_q(locOptGraph#0_0);
        assume IndirectionTableModel.Entry.Entry_q(locOptGraph#0_0);
        locOpt#0_0 := IndirectionTableModel.Entry.loc(locOptGraph#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(998,37)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(999,19)
        assume true;
        assume IndirectionTableModel.Entry.Entry_q(locOptGraph#0_0);
        assume IndirectionTableModel.Entry.Entry_q(locOptGraph#0_0);
        succs#0_0 := IndirectionTableModel.Entry.succs(locOptGraph#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(999,38)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1000,17)
        assume true;
        assert Options.Option.Some_q(locOpt#0_0);
        assume true;
        loc#0_0 := $Unbox(Options.Option.value(locOpt#0_0)): DatatypeType;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1000,31)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1002,25)
        assume true;
        assume true;
        childrenVal#0_0 := #GenericMarshalling.V.VUint64Array(succs#0_0);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1002,46)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1004,9)
        assume Bounds.__default.MaxNumChildren#canCall();
        assume Bounds.__default.MaxNumChildren#canCall();
        assert Seq#Length(succs#0_0) <= LitInt(Bounds.__default.MaxNumChildren());
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1012,9)
        ##loc#0_0 := loc#0_0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##loc#0_0, Tclass.DiskLayout.Location(), $Heap);
        assume DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0);
        assume DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0);
        assert {:subsumption 0} DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0)
           ==> DiskLayout.__default.ValidNodeLocation(loc#0_0)
             || (Lit(true)
               ==> 
              Lit(true)
               ==> DiskLayout.__default.ValidNodeAddr(StartFuelAssert_DiskLayout._default.ValidNodeAddr, 
                DiskLayout.Location.addr(loc#0_0)));
        assert {:subsumption 0} DiskLayout.__default.ValidNodeLocation#canCall(loc#0_0)
           ==> DiskLayout.__default.ValidNodeLocation(loc#0_0)
             || (Lit(true)
               ==> 
              Lit(true)
               ==> DiskLayout.Location.len(loc#0_0)
                 <= LitInt(Bounds.__default.NodeBlockSizeUint64()));
        assume DiskLayout.__default.ValidNodeLocation(loc#0_0);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1018,46)
        // TrCallStmt: Before ProcessCallStmt
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        // ProcessCallStmt: CheckSubrange
        self##0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_0 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$MutableMapModel.__default.LemmaIterIndexLtCount(Tclass.IndirectionTableModel.Entry(), self##0_0, it##0_0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1018,56)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1020,9)
        assume true;
        assert Seq#Length(succs#0_0) < 18446744073709551616;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1021,9)
        assume DiskLayout.Location.Location_q(loc#0_0);
        assume DiskLayout.Location.Location_q(loc#0_0);
        ##val#0_0 := #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(ref#0_0))), 
                $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.addr(loc#0_0)))), 
              $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.len(loc#0_0)))), 
            $Box(childrenVal#0_0)));
        // assume allocatedness for argument to function
        assume $IsAlloc(##val#0_0, Tclass.GenericMarshalling.V(), $Heap);
        assume GenericMarshalling.__default.ValidVal#canCall(#GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(ref#0_0))), 
                  $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.addr(loc#0_0)))), 
                $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.len(loc#0_0)))), 
              $Box(childrenVal#0_0))));
        assume DiskLayout.Location.Location_q(loc#0_0)
           && DiskLayout.Location.Location_q(loc#0_0)
           && GenericMarshalling.__default.ValidVal#canCall(#GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(ref#0_0))), 
                    $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.addr(loc#0_0)))), 
                  $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.len(loc#0_0)))), 
                $Box(childrenVal#0_0))));
        assert {:subsumption 0} GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
          #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(ref#0_0))), 
                  $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.addr(loc#0_0)))), 
                $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.len(loc#0_0)))), 
              $Box(childrenVal#0_0))));
        assume GenericMarshalling.__default.ValidVal(StartFuelAssert_GenericMarshalling._default.ValidVal, 
          #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(ref#0_0))), 
                  $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.addr(loc#0_0)))), 
                $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.len(loc#0_0)))), 
              $Box(childrenVal#0_0))));
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1023,9)
        assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
        ##self#0_0 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        // assume allocatedness for argument to function
        assume $IsAlloc(##self#0_0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap);
        ##it#0_0 := it#0;
        // assume allocatedness for argument to function
        assume $IsAlloc(##it#0_0, 
          Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
          $Heap);
        assert {:subsumption 0} MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), ##self#0_0);
        assert {:subsumption 0} MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), ##self#0_0, ##it#0_0);
        assert {:subsumption 0} MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(##it#0_0));
        assume MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
          it#0);
        assume MutableMapModel.Iterator.Iterator_q(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterInc, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0));
        assume MutableMapModel.Iterator.Iterator_q(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterInc, 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0));
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0)
           && MutableMapModel.Iterator.Iterator_q(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.IterInc, 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0))
           && MutableMapModel.Iterator.Iterator_q(it#0);
        assert {:subsumption 0} Set#Card(MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuelAssert_MutableMapModel._default.IterInc, 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                it#0)))
           == Set#Card(MutableMapModel.Iterator.s(it#0)) + 1;
        assume Set#Card(MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuelAssert_MutableMapModel._default.IterInc, 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                it#0)))
           == Set#Card(MutableMapModel.Iterator.s(it#0)) + 1;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1025,16)
        assume true;
        assume DiskLayout.Location.Location_q(loc#0_0);
        assume DiskLayout.Location.Location_q(loc#0_0);
        assume DiskLayout.Location.Location_q(loc#0_0)
           && DiskLayout.Location.Location_q(loc#0_0);
        vi#0_0 := #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(#GenericMarshalling.V.VUint64(ref#0_0))), 
                $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.addr(loc#0_0)))), 
              $Box(#GenericMarshalling.V.VUint64(DiskLayout.Location.len(loc#0_0)))), 
            $Box(childrenVal#0_0)));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1025,90)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1030,17)
        assume true;
        newtype$check#0_0 := LitInt(0);
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume true;
        partial#0 := Map#Build(partial#0, 
          $Box(ref#0_0), 
          $Box(#IndirectionTableModel.Entry.Entry(locOpt#0_0, succs#0_0, LitInt(0))));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1030,80)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1031,14)
        assert a#0 != null;
        assert 0 <= i#0 && i#0 < _System.array.Length(a#0);
        assume true;
        assert $_Frame[a#0, IndexField(i#0)];
        assume true;
        $rhs#0_0 := vi#0_0;
        $Heap := update($Heap, a#0, IndexField(i#0), $Box($rhs#0_0));
        assume $IsGoodHeap($Heap);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1031,18)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1032,11)
        assume true;
        newtype$check#0_1 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_1 && newtype$check#0_1 < 18446744073709551616;
        newtype$check#0_2 := i#0 + 1;
        assert LitInt(0) <= newtype$check#0_2 && newtype$check#0_2 < 18446744073709551616;
        assume true;
        i#0 := i#0 + 1;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1032,18)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1033,24)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Iterator<IndirectionTableModel.Entry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##0_1 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0_0 := Call$$MutableMap.ResizingHashMap.IterInc(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##0_1);
        // TrCallStmt: After ProcessCallStmt
        it#0 := $rhs##0_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1033,27)"} true;
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1036,9)
        assert a#0 != null;
        newtype$check#0_3 := LitInt(1);
        assert LitInt(0) <= newtype$check#0_3 && newtype$check#0_3 < 18446744073709551616;
        newtype$check#0_4 := i#0 - 1;
        assert LitInt(0) <= newtype$check#0_4 && newtype$check#0_4 < 18446744073709551616;
        assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
        assert a#0 != null;
        assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
        ##run#0_0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##run#0_0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
        assert {:subsumption 0} Seq#Length(##run#0_0) > 0;
        assume Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Seq#Take(Seq#FromArray($Heap, a#0), i#0));
        assume Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Seq#Take(Seq#FromArray($Heap, a#0), i#0));
        assert Seq#Equal(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1), 
          Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Seq#Take(Seq#FromArray($Heap, a#0), i#0)));
        // ----- calc statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
        // Assume Fuel Constant
        if (*)
        {
            // ----- assert wf[initial] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assert a#0 != null;
            assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
            ##t#0_0_0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0_0_0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assume a#0 != null;
            assume {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
            ##t#0_0_2_0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0_0_2_0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
            // ----- Hint0 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1041,38)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            assume true;
            // ProcessCallStmt: CheckSubrange
            a##0_0_2_0 := a#0;
            assume true;
            // ProcessCallStmt: CheckSubrange
            i##0_0_2_0 := i#0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$IndirectionTableImpl.IndirectionTable.lemma__SeqSum__prefix__array(this, a##0_0_2_0, i##0_0_2_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1041,50)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assert a#0 != null;
            newtype$check#0_0_2_0 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_2_0
               && newtype$check#0_0_2_0 < 18446744073709551616;
            newtype$check#0_0_2_1 := i#0 - 1;
            assert LitInt(0) <= newtype$check#0_0_2_1
               && newtype$check#0_0_2_1 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
            ##t#0_0_2_1 := Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0_0_2_1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1));
            assert a#0 != null;
            newtype$check#0_0_2_2 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_2_2
               && newtype$check#0_0_2_2 < 18446744073709551616;
            newtype$check#0_0_2_3 := i#0 - 1;
            assert LitInt(0) <= newtype$check#0_0_2_3
               && newtype$check#0_0_2_3 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 < _System.array.Length(a#0);
            ##val#0_0_2_0 := $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##val#0_0_2_0, Tclass.GenericMarshalling.V(), $Heap);
            assume GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
               && GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType);
            // ----- assert line0 == line1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assert {:subsumption 0} GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
                Seq#Take(Seq#FromArray($Heap, a#0), i#0))
               == GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
                  Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
                 + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, 
                  $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assume a#0 != null;
            newtype$check#0_0_1_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_0_1_0
               && newtype$check#0_0_1_0 < 18446744073709551616;
            newtype$check#0_0_1_1 := i#0 - 1;
            assume LitInt(0) <= newtype$check#0_0_1_1
               && newtype$check#0_0_1_1 < 18446744073709551616;
            assume {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
            ##t#0_0_1_0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0_0_1_0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1));
            assume a#0 != null;
            newtype$check#0_0_1_2 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_0_1_2
               && newtype$check#0_0_1_2 < 18446744073709551616;
            newtype$check#0_0_1_3 := i#0 - 1;
            assume LitInt(0) <= newtype$check#0_0_1_3
               && newtype$check#0_0_1_3 < 18446744073709551616;
            assume {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 < _System.array.Length(a#0);
            ##val#0_0_1_0 := $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType;
            // assume allocatedness for argument to function
            assume $IsAlloc(##val#0_0_1_0, Tclass.GenericMarshalling.V(), $Heap);
            assume GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
               && GenericMarshalling.__default.SizeOfV#canCall($Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType);
            // ----- Hint1 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assert a#0 != null;
            newtype$check#0_0_1_4 := LitInt(1);
            assert LitInt(0) <= newtype$check#0_0_1_4
               && newtype$check#0_0_1_4 < 18446744073709551616;
            newtype$check#0_0_1_5 := i#0 - 1;
            assert LitInt(0) <= newtype$check#0_0_1_5
               && newtype$check#0_0_1_5 < 18446744073709551616;
            assert {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
            ##t#0_0_1_1 := Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0_0_1_1, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1));
            ##val#0_0_1_1 := vi#0_0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##val#0_0_1_1, Tclass.GenericMarshalling.V(), $Heap);
            assume GenericMarshalling.__default.SizeOfV#canCall(vi#0_0);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
               && GenericMarshalling.__default.SizeOfV#canCall(vi#0_0);
            // ----- assert line1 == line2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assert {:subsumption 0} GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
                  Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
                 + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, 
                  $Unbox(read($Heap, a#0, IndexField(i#0 - 1))): DatatypeType)
               == GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
                  Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
                 + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, vi#0_0);
            assume false;
        }
        else if (*)
        {
            // ----- assume wf[lhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assume a#0 != null;
            newtype$check#0_0_0_0 := LitInt(1);
            assume LitInt(0) <= newtype$check#0_0_0_0
               && newtype$check#0_0_0_0 < 18446744073709551616;
            newtype$check#0_0_0_1 := i#0 - 1;
            assume LitInt(0) <= newtype$check#0_0_0_1
               && newtype$check#0_0_0_1 < 18446744073709551616;
            assume {:subsumption 0} 0 <= i#0 - 1 && i#0 - 1 <= _System.array.Length(a#0);
            ##t#0_0_0_0 := Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1);
            // assume allocatedness for argument to function
            assume $IsAlloc(##t#0_0_0_0, TSeq(Tclass.GenericMarshalling.V()), $Heap);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1));
            ##val#0_0_0_0 := vi#0_0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##val#0_0_0_0, Tclass.GenericMarshalling.V(), $Heap);
            assume GenericMarshalling.__default.SizeOfV#canCall(vi#0_0);
            assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
               && GenericMarshalling.__default.SizeOfV#canCall(vi#0_0);
            // ----- Hint2 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1046,29)
            // TrCallStmt: Before ProcessCallStmt
            assume true;
            assume true;
            // ProcessCallStmt: CheckSubrange
            a##0_0_0_0 := ref#0_0;
            assume DiskLayout.Location.Location_q(loc#0_0);
            assume DiskLayout.Location.Location_q(loc#0_0);
            // ProcessCallStmt: CheckSubrange
            b##0_0_0_0 := DiskLayout.Location.addr(loc#0_0);
            assume DiskLayout.Location.Location_q(loc#0_0);
            assume DiskLayout.Location.Location_q(loc#0_0);
            // ProcessCallStmt: CheckSubrange
            c##0_0_0_0 := DiskLayout.Location.len(loc#0_0);
            assume true;
            // ProcessCallStmt: CheckSubrange
            succs##0_0_0_0 := succs#0_0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call Call$$IndirectionTableImpl.IndirectionTable.lemma__tuple__size(this, a##0_0_0_0, b##0_0_0_0, c##0_0_0_0, succs##0_0_0_0);
            // TrCallStmt: After ProcessCallStmt
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1046,59)"} true;
            // ----- assert wf[rhs] ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assume true;
            // ----- assert line2 == line3 ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1038,9)
            assert {:subsumption 0} GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
                  Seq#Take(Seq#FromArray($Heap, a#0), i#0 - 1))
                 + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, vi#0_0)
               == size#0 + 8 + 8 + 8 + 8 + Mul(LitInt(8), Seq#Length(succs#0_0));
            assume false;
        }

        assume GenericMarshalling.__default.SeqSum(StartFuel_GenericMarshalling._default.SeqSum, 
            Seq#Take(Seq#FromArray($Heap, a#0), i#0))
           == size#0 + 8 + 8 + 8 + 8 + Mul(LitInt(8), Seq#Length(succs#0_0));
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1051,14)
        assume true;
        newtype$check#0_5 := LitInt(32);
        assert LitInt(0) <= newtype$check#0_5 && newtype$check#0_5 < 18446744073709551616;
        newtype$check#0_6 := size#0 + 32;
        assert LitInt(0) <= newtype$check#0_6 && newtype$check#0_6 < 18446744073709551616;
        newtype$check#0_7 := LitInt(8);
        assert LitInt(0) <= newtype$check#0_7 && newtype$check#0_7 < 18446744073709551616;
        newtype$check#0_8 := Seq#Length(succs#0_0);
        assert LitInt(0) <= newtype$check#0_8 && newtype$check#0_8 < 18446744073709551616;
        newtype$check#0_9 := Mul(LitInt(8), Seq#Length(succs#0_0));
        assert LitInt(0) <= newtype$check#0_9 && newtype$check#0_9 < 18446744073709551616;
        newtype$check#0_10 := size#0 + 32 + Mul(LitInt(8), Seq#Length(succs#0_0));
        assert LitInt(0) <= newtype$check#0_10 && newtype$check#0_10 < 18446744073709551616;
        assume true;
        size#0 := size#0 + 32 + Mul(LitInt(8), Seq#Length(succs#0_0));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1051,49)"} true;
        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(972,7)
        assert ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr$loop#00);
        assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
        assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
           && BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
        assume true;
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0);
        assume (forall j#1: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616
             ==> 
            LitInt(0) <= j#1 && j#1 < i#0
             ==> GenericMarshalling.__default.ValidVal#canCall($Unbox(read($Heap, a#0, IndexField(j#1))): DatatypeType));
        assume (forall j#3: int :: 
          { $Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType } 
          LitInt(0) <= j#3 && j#3 < 18446744073709551616
             ==> 
            LitInt(0) <= j#3 && j#3 < i#0
             ==> GenericMarshalling.__default.ValInGrammar#canCall($Unbox(read($Heap, a#0, IndexField(j#3))): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));
        assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
        assume IndirectionTableModel.__default.valToHashMap#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0))
           && MutableMapModel.LinearHashMap.LinearHashMap_q($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($LS($LZ), Seq#Take(Seq#FromArray($Heap, a#0), i#0)))): DatatypeType);
        assume true;
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
        assume (forall r#6: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType } 
            { $Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)] } 
            { Map#Domain(partial#0)[$Box(r#6)] } 
          LitInt(0) <= r#6 && r#6 < 18446744073709551616
             ==> 
            Map#Domain(partial#0)[$Box(r#6)]
             ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]
                 ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType))
                   && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                   && 
                  IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
               && ($IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType))
                   && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                   && 
                  IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)
                   && Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType), 
                    IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType))
                 ==> IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(partial#0)[$Box(r#6)]): DatatypeType)
                   && 
                  MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
                   && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(r#6)]): DatatypeType)));
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)))
           && 
          MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)));
        assume MutableMapModel.Iterator.Iterator_q(it#0)
           && Bounds.__default.MaxNumChildren#canCall();
        assume GenericMarshalling.__default.SeqSum#canCall(Seq#Take(Seq#FromArray($Heap, a#0), i#0));
    }

    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1055,56)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    a##0 := Map#Domain(partial#0);
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
       && MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
    // ProcessCallStmt: CheckSubrange
    b##0 := Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$Sets.__default.SetInclusionAndEqualCardinalityImpliesSetEquality(Tclass.NativeTypes.uint64(), a##0, b##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1055,90)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1057,7)
    assert a#0 != null;
    assert {:subsumption 0} 0 <= i#0 && i#0 <= _System.array.Length(a#0);
    assert a#0 != null;
    assume true;
    assert Seq#Equal(Seq#Take(Seq#FromArray($Heap, a#0), i#0), Seq#FromArray($Heap, a#0));
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1058,9)
    assume true;
    assert a#0 != null;
    assume true;
    v#0 := #GenericMarshalling.V.VArray(Seq#FromArray($Heap, a#0));
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1058,24)"} true;
    // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1067,7)
    assume MutableMapModel.Iterator.Iterator_q(it#0);
    assume IndirectionTableModel.__default.MaxSize#canCall();
    assume MutableMapModel.Iterator.Iterator_q(it#0)
       && IndirectionTableModel.__default.MaxSize#canCall();
    assert Set#Card(MutableMapModel.Iterator.s(it#0))
       <= LitInt(IndirectionTableModel.__default.MaxSize());
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1069,12)
    assume true;
    newtype$check#6 := LitInt(8);
    assert LitInt(0) <= newtype$check#6 && newtype$check#6 < 18446744073709551616;
    newtype$check#7 := size#0 + 8;
    assert LitInt(0) <= newtype$check#7 && newtype$check#7 < 18446744073709551616;
    assume true;
    size#0 := size#0 + 8;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1069,22)"} true;
}



function Tclass.BitmapImpl.Bitmap() : Ty;

// Tclass.BitmapImpl.Bitmap Tag
axiom Tag(Tclass.BitmapImpl.Bitmap()) == Tagclass.BitmapImpl.Bitmap;

const unique Tagclass.BitmapImpl.Bitmap: TyTag;

// Box/unbox axiom for Tclass.BitmapImpl.Bitmap
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BitmapImpl.Bitmap()) } 
  $IsBox(bx, Tclass.BitmapImpl.Bitmap())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.BitmapImpl.Bitmap()));

procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    upTo#0: int where LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616);
  free requires 42 == $FunctionContextHeight;
  modifies $Heap, $Tick;



axiom FDim(BitmapImpl.Bitmap.Repr) == 0
   && FieldOfDecl(class.BitmapImpl.Bitmap?, field$Repr) == BitmapImpl.Bitmap.Repr
   && $IsGhostField(BitmapImpl.Bitmap.Repr);

implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm#0: ref, i#0: int, upTo#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##bm#0: Seq Box;
  var newtype$check#0: int;
  var ##bm#1: Seq Box;
  var ##i#0: int;
  var ##upTo#0: int;

    // AddMethodImpl: BitmapInitUpToIterate, CheckWellformed$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1074,18): initial state"} true;
    assert bm#0 != null;
    assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    if (LitInt(0) <= i#0)
    {
    }

    if (LitInt(0) <= i#0 && i#0 <= upTo#0)
    {
        assert bm#0 != null;
        assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
        assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
        assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
        ##bm#0 := BitmapImpl.Bitmap.I($Heap, bm#0);
        // assume allocatedness for argument to function
        assume $IsAlloc(##bm#0, TSeq(TBool), $Heap);
        assume BitmapModel.__default.Len#canCall(BitmapImpl.Bitmap.I($Heap, bm#0));
    }

    assume LitInt(0) <= i#0
       && i#0 <= upTo#0
       && upTo#0 <= BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0));
    assert bm#0 != null;
    newtype$check#0 := upTo#0 - i#0;
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1078,18): post-state"} true;
    assert bm#0 != null;
    assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assert bm#0 != null;
    assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
    assert bm#0 != null;
    assert $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), old($Heap));
    assert {:subsumption 0} BitmapImpl.Bitmap.Inv(old($Heap), bm#0);
    assume BitmapImpl.Bitmap.Inv(old($Heap), bm#0);
    assume BitmapImpl.Bitmap.I#canCall(old($Heap), bm#0);
    ##bm#1 := BitmapImpl.Bitmap.I(old($Heap), bm#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bm#1, TSeq(TBool), $Heap);
    ##i#0 := i#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##i#0, Tclass.NativeTypes.uint64(), $Heap);
    ##upTo#0 := upTo#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##upTo#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} LitInt(0) <= ##i#0;
    assert {:subsumption 0} ##i#0 <= ##upTo#0;
    assert {:subsumption 0} ##upTo#0 <= BitmapModel.__default.Len(##bm#1);
    assume LitInt(0) <= ##i#0
       && ##i#0 <= ##upTo#0
       && ##upTo#0 <= BitmapModel.__default.Len(##bm#1);
    assume IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(BitmapImpl.Bitmap.I(old($Heap), bm#0), i#0, upTo#0);
    assume Seq#Equal(BitmapImpl.Bitmap.I($Heap, bm#0), 
      IndirectionTableModel.__default.BitmapInitUpToIterate($LS($LZ), BitmapImpl.Bitmap.I(old($Heap), bm#0), i#0, upTo#0));
    assert bm#0 != null;
    assert bm#0 != null;
    assert $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), old($Heap));
    assume Set#Equal(read($Heap, bm#0, BitmapImpl.Bitmap.Repr), 
      read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    upTo#0: int where LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616);
  // user-defined preconditions
  requires BitmapImpl.Bitmap.Inv($Heap, bm#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= upTo#0;
  requires upTo#0 <= BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
  ensures BitmapImpl.Bitmap.Inv($Heap, bm#0);
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
     && 
    BitmapImpl.Bitmap.I#canCall(old($Heap), bm#0)
     && IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(BitmapImpl.Bitmap.I(old($Heap), bm#0), i#0, upTo#0);
  ensures Seq#Equal(BitmapImpl.Bitmap.I($Heap, bm#0), 
    IndirectionTableModel.__default.BitmapInitUpToIterate($LS($LS($LZ)), BitmapImpl.Bitmap.I(old($Heap), bm#0), i#0, upTo#0));
  free ensures true;
  ensures Set#Equal(read($Heap, bm#0, BitmapImpl.Bitmap.Repr), 
    read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    i#0: int where LitInt(0) <= i#0 && i#0 < 18446744073709551616, 
    upTo#0: int where LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 42 == $FunctionContextHeight;
  // user-defined preconditions
  requires BitmapImpl.Bitmap.Inv($Heap, bm#0);
  requires LitInt(0) <= i#0;
  requires i#0 <= upTo#0;
  requires upTo#0 <= BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
  ensures BitmapImpl.Bitmap.Inv($Heap, bm#0);
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
     && 
    BitmapImpl.Bitmap.I#canCall(old($Heap), bm#0)
     && IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(BitmapImpl.Bitmap.I(old($Heap), bm#0), i#0, upTo#0);
  ensures Seq#Equal(BitmapImpl.Bitmap.I($Heap, bm#0), 
    IndirectionTableModel.__default.BitmapInitUpToIterate($LS($LS($LZ)), BitmapImpl.Bitmap.I(old($Heap), bm#0), i#0, upTo#0));
  free ensures true;
  ensures Set#Equal(read($Heap, bm#0, BitmapImpl.Bitmap.Repr), 
    read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm#0: ref, i#0: int, upTo#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var c##0: int;
  var bm##0: ref;
  var i##0: int;
  var newtype$check#1: int;
  var newtype$check#2: int;
  var upTo##0: int;

    // AddMethodImpl: BitmapInitUpToIterate, Impl$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1082,4): initial state"} true;
    $_reverifyPost := false;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1083,7)
    assume true;
    if (i#0 == upTo#0)
    {
    }
    else
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1085,15)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert bm#0 != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        c##0 := i#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && ($o == bm#0 || read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)])
             ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call Call$$BitmapImpl.Bitmap.Set(bm#0, c##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1085,17)"} true;
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1086,30)
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        // ProcessCallStmt: CheckSubrange
        bm##0 := bm#0;
        newtype$check#1 := LitInt(1);
        assert LitInt(0) <= newtype$check#1 && newtype$check#1 < 18446744073709551616;
        newtype$check#2 := i#0 + 1;
        assert LitInt(0) <= newtype$check#2 && newtype$check#2 < 18446744073709551616;
        assume true;
        // ProcessCallStmt: CheckSubrange
        i##0 := i#0 + 1;
        assume true;
        // ProcessCallStmt: CheckSubrange
        upTo##0 := upTo#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: 
          $o != null
               && read($Heap, $o, alloc)
               && read($Heap, bm##0, BitmapImpl.Bitmap.Repr)[$Box($o)]
             ==> $_Frame[$o, $f]);
        assert 0 <= upTo#0 - i#0 || upTo##0 - i##0 == upTo#0 - i#0;
        assert upTo##0 - i##0 < upTo#0 - i#0;
        // ProcessCallStmt: Make the call
        call Call$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm##0, i##0, upTo##0);
        // TrCallStmt: After ProcessCallStmt
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1086,44)"} true;
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo(bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    upTo#0: int where LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616);
  free requires 43 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo(bm#0: ref, upTo#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##bm#0: Seq Box;
  var ##bm#1: Seq Box;
  var ##upTo#0: int;

    // AddMethodImpl: BitmapInitUpTo, CheckWellformed$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1090,18): initial state"} true;
    assert bm#0 != null;
    assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assert bm#0 != null;
    assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
    ##bm#0 := BitmapImpl.Bitmap.I($Heap, bm#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bm#0, TSeq(TBool), $Heap);
    assume BitmapModel.__default.Len#canCall(BitmapImpl.Bitmap.I($Heap, bm#0));
    assume upTo#0 <= BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0));
    assert bm#0 != null;
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1094,18): post-state"} true;
    assert bm#0 != null;
    assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assert bm#0 != null;
    assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
    assert bm#0 != null;
    assert $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), old($Heap));
    assert {:subsumption 0} BitmapImpl.Bitmap.Inv(old($Heap), bm#0);
    assume BitmapImpl.Bitmap.Inv(old($Heap), bm#0);
    assume BitmapImpl.Bitmap.I#canCall(old($Heap), bm#0);
    ##bm#1 := BitmapImpl.Bitmap.I(old($Heap), bm#0);
    // assume allocatedness for argument to function
    assume $IsAlloc(##bm#1, TSeq(TBool), $Heap);
    ##upTo#0 := upTo#0;
    // assume allocatedness for argument to function
    assume $IsAlloc(##upTo#0, Tclass.NativeTypes.uint64(), $Heap);
    assert {:subsumption 0} ##upTo#0 <= BitmapModel.__default.Len(##bm#1);
    assume ##upTo#0 <= BitmapModel.__default.Len(##bm#1);
    assume IndirectionTableModel.__default.BitmapInitUpTo#canCall(BitmapImpl.Bitmap.I(old($Heap), bm#0), upTo#0);
    assume Seq#Equal(BitmapImpl.Bitmap.I($Heap, bm#0), 
      IndirectionTableModel.__default.BitmapInitUpTo(StartFuel_IndirectionTableModel._default.BitmapInitUpTo, 
        BitmapImpl.Bitmap.I(old($Heap), bm#0), 
        upTo#0));
    assert bm#0 != null;
    assert bm#0 != null;
    assert $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), old($Heap));
    assume Set#Equal(read($Heap, bm#0, BitmapImpl.Bitmap.Repr), 
      read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo(bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    upTo#0: int where LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616);
  // user-defined preconditions
  requires BitmapImpl.Bitmap.Inv($Heap, bm#0);
  requires upTo#0 <= BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
  ensures BitmapImpl.Bitmap.Inv($Heap, bm#0);
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
     && 
    BitmapImpl.Bitmap.I#canCall(old($Heap), bm#0)
     && IndirectionTableModel.__default.BitmapInitUpTo#canCall(BitmapImpl.Bitmap.I(old($Heap), bm#0), upTo#0);
  ensures Seq#Equal(BitmapImpl.Bitmap.I($Heap, bm#0), 
    IndirectionTableModel.__default.BitmapInitUpTo(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo, 
      BitmapImpl.Bitmap.I(old($Heap), bm#0), 
      upTo#0));
  free ensures true;
  ensures Set#Equal(read($Heap, bm#0, BitmapImpl.Bitmap.Repr), 
    read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo(bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    upTo#0: int where LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616)
   returns ($_reverifyPost: bool);
  free requires 43 == $FunctionContextHeight;
  // user-defined preconditions
  requires BitmapImpl.Bitmap.Inv($Heap, bm#0);
  requires upTo#0 <= BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
  ensures BitmapImpl.Bitmap.Inv($Heap, bm#0);
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
     && 
    BitmapImpl.Bitmap.I#canCall(old($Heap), bm#0)
     && IndirectionTableModel.__default.BitmapInitUpTo#canCall(BitmapImpl.Bitmap.I(old($Heap), bm#0), upTo#0);
  ensures Seq#Equal(BitmapImpl.Bitmap.I($Heap, bm#0), 
    IndirectionTableModel.__default.BitmapInitUpTo(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo, 
      BitmapImpl.Bitmap.I(old($Heap), bm#0), 
      upTo#0));
  free ensures true;
  ensures Set#Equal(read($Heap, bm#0, BitmapImpl.Bitmap.Repr), 
    read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo(bm#0: ref, upTo#0: int) returns ($_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var bm##0: ref;
  var i##0: int;
  var newtype$check#0: int;
  var upTo##0: int;

    // AddMethodImpl: BitmapInitUpTo, Impl$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1097,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1098,50)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__BitmapInitUpTo();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1098,51)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1099,28)
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    // ProcessCallStmt: CheckSubrange
    bm##0 := bm#0;
    newtype$check#0 := LitInt(0);
    assert LitInt(0) <= newtype$check#0 && newtype$check#0 < 18446744073709551616;
    assume true;
    // ProcessCallStmt: CheckSubrange
    i##0 := LitInt(0);
    assume true;
    // ProcessCallStmt: CheckSubrange
    upTo##0 := upTo#0;
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, bm##0, BitmapImpl.Bitmap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableImpl.IndirectionTable.BitmapInitUpToIterate(bm##0, i##0, upTo##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1099,40)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.InitLocBitmap(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (success#0: bool, 
    bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap));
  free requires 44 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.InitLocBitmap(this: ref) returns (success#0: bool, bm#0: ref)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##indirectionTable#0: DatatypeType;
  var ##indirectionTable#1: DatatypeType;

    // AddMethodImpl: InitLocBitmap, CheckWellformed$$IndirectionTableImpl.IndirectionTable.InitLocBitmap
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1102,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#0: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#0)] } 
                LitInt(0) <= ref#0
                     && ref#0 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#0)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#1: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#3: int :: 
                { Map#Domain(graph#0)[$Box(ref#3)] } 
                LitInt(0) <= ref#3
                     && ref#3 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#3)]
                   ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    ##indirectionTable#0 := IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    // assume allocatedness for argument to function
    assume $IsAlloc(##indirectionTable#0, Tclass.SectorType.IndirectionTable(), $Heap);
    assume BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    assume BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc success#0, bm#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1106,18): post-state"} true;
    assert bm#0 != null;
    assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assert bm#0 != null;
    assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
    assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#4)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#5: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#5)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#6: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#7: int :: 
                { Map#Domain(graph#1)[$Box(ref#7)] } 
                LitInt(0) <= ref#7
                     && ref#7 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#7)]
                   ==> ref#7
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##indirectionTable#1 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##indirectionTable#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##indirectionTable#1);
    assume IndirectionTableModel.__default.Inv(##indirectionTable#1);
    assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#1))
       ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#1))
         || (forall loc#0: DatatypeType :: 
          { DiskLayout.__default.ValidNodeLocation(loc#0) } 
            { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(loc#0)] } 
          $Is(loc#0, Tclass.DiskLayout.Location())
               && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(loc#0)]
             ==> DiskLayout.__default.ValidNodeLocation(loc#0));
    assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#1))
       ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#1))
         || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1))), 
          Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#1))));
    assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#1))
       ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#1))
         || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(PivotBetreeGraph.__default.Root())];
    assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#1))
       ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#1))
         || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))
           ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))
             || (forall ref#8: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(ref#8)]): Seq Box } 
                { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(ref#8)] } 
              LitInt(0) <= ref#8
                   && ref#8 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(ref#8)]
                 ==> (forall succ#0: int :: 
                  { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(succ#0)] } 
                    { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(ref#8)]): Seq Box, 
                      $Box(succ#0)) } 
                  LitInt(0) <= succ#0
                       && succ#0 < 18446744073709551616
                       && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(ref#8)]): Seq Box, 
                        $Box(succ#0))
                     ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#1)))[$Box(succ#0)])));
    assume BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#1));
    assume IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(success#0), $Box(BitmapImpl.Bitmap.I($Heap, bm#0))), 
      IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
    assert bm#0 != null;
    assume (forall $o: ref :: 
      { read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)] } 
      read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]
         ==> $o != null && !read(old($Heap), $o, alloc));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.InitLocBitmap(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (success#0: bool, 
    bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || (forall loc#1: DatatypeType :: 
        { DiskLayout.__default.ValidNodeLocation(loc#1) } 
          { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#1)] } 
        $Is(loc#1, Tclass.DiskLayout.Location())
             && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#1)]
           ==> DiskLayout.__default.ValidNodeLocation(loc#1));
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
        Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))));
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())];
  requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
       || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
         ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
           || (forall ref#9: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#9)]): Seq Box } 
              { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#9)] } 
            LitInt(0) <= ref#9
                 && ref#9 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#9)]
               ==> (forall succ#1: int :: 
                { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#1)] } 
                  { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#9)]): Seq Box, 
                    $Box(succ#1)) } 
                LitInt(0) <= succ#1
                     && succ#1 < 18446744073709551616
                     && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#9)]): Seq Box, 
                      $Box(succ#1))
                   ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#1)])));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
  ensures BitmapImpl.Bitmap.Inv($Heap, bm#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
     && 
    BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(success#0), $Box(BitmapImpl.Bitmap.I($Heap, bm#0))), 
    IndirectionTableModel.__default.InitLocBitmap(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)] } 
    read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.InitLocBitmap(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (success#0: bool, 
    bm#0: ref
       where $Is(bm#0, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(bm#0, Tclass.BitmapImpl.Bitmap(), $Heap), 
    $_reverifyPost: bool);
  free requires 44 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                 && BlockCache.__default.GraphClosed(graph#2)
                 && (forall ref#10: int :: 
                  { $Unbox(Map#Elements(graph#2)[$Box(ref#10)]): Seq Box } 
                    { Map#Domain(graph#2)[$Box(ref#10)] } 
                  LitInt(0) <= ref#10
                       && ref#10 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#10)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#10)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#11: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                      LitInt(0) <= ref#11
                           && ref#11 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#11)])
                     && (forall ref#12: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#12)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#12)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#12)] } 
                      LitInt(0) <= ref#12
                           && ref#12 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#12)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#12)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#12)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#13: int :: 
                  { Map#Domain(graph#2)[$Box(ref#13)] } 
                  LitInt(0) <= ref#13
                       && ref#13 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#13)]
                     ==> ref#13 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#2)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#2)[$Box(r#2)])))));
  free requires BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    (forall loc#2: DatatypeType :: 
      { DiskLayout.__default.ValidNodeLocation(loc#2) } 
        { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#2)] } 
      $Is(loc#2, Tclass.DiskLayout.Location())
           && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#2)]
         ==> DiskLayout.__default.ValidNodeLocation(loc#2))
     && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
      Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))))
     && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())]
     && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
  ensures BitmapImpl.Bitmap.Inv($Heap, bm#0);
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
     && 
    BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(success#0), $Box(BitmapImpl.Bitmap.I($Heap, bm#0))), 
    IndirectionTableModel.__default.InitLocBitmap(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)] } 
    read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.InitLocBitmap(this: ref) returns (success#0: bool, bm#0: ref, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var defass#bm#0: bool;
  var $nw: ref;
  var len##0: int;
  var bm##0: ref;
  var upTo##0: int;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(it#0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var preLoop$loop#0$defass#bm#0: bool;
  var $decr_init$loop#00: Box;
  var $w$loop#0: bool;
  var ##self#1: DatatypeType;
  var ##indirectionTable#2: DatatypeType;
  var ##self#2: DatatypeType;
  var ##it#0: DatatypeType;
  var ##bm#0: Seq Box;
  var ##indirectionTable#3: DatatypeType;
  var ##it#1: DatatypeType;
  var ##bm#1: Seq Box;
  var ##indirectionTable#4: DatatypeType;
  var $decr$loop#00: Box;
  var ##self#0_0: DatatypeType;
  var loc#0_0: int where LitInt(0) <= loc#0_0 && loc#0_0 < 18446744073709551616;
  var locIndex#0_0: int
     where LitInt(0) <= locIndex#0_0 && locIndex#0_0 < 18446744073709551616;
  var newtype$check#0_0: int;
  var isSet#0_0_0: bool;
  var $rhs##0_0_0: bool;
  var c##0_0_0: int;
  var $rhs##0_0_0_0: DatatypeType
     where $Is($rhs##0_0_0_0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##0_0_0_0, 
        Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##0_0_0_0: DatatypeType;
  var c##0_0_0_0: int;

    // AddMethodImpl: InitLocBitmap, Impl$$IndirectionTableImpl.IndirectionTable.InitLocBitmap
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1109,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1110,49)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__InitLocBitmap();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1110,50)"} true;
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1112,10)
    assume true;
    // ----- init call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1112,13)
    // TrCallStmt: Before ProcessCallStmt
    assume Bounds.__default.NumBlocksUint64#canCall();
    assume Bounds.__default.NumBlocksUint64#canCall();
    // ProcessCallStmt: CheckSubrange
    len##0 := LitInt(Bounds.__default.NumBlocksUint64());
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $nw := Call$$BitmapImpl.Bitmap.__ctor(len##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1112,52)"} true;
    bm#0 := $nw;
    defass#bm#0 := true;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1112,52)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1113,21)
    // TrCallStmt: Before ProcessCallStmt
    assert defass#bm#0;
    assume true;
    // ProcessCallStmt: CheckSubrange
    bm##0 := bm#0;
    assume Bounds.__default.MinNodeBlockIndexUint64#canCall();
    assume Bounds.__default.MinNodeBlockIndexUint64#canCall();
    // ProcessCallStmt: CheckSubrange
    upTo##0 := LitInt(Bounds.__default.MinNodeBlockIndexUint64());
    assert (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && read($Heap, $o, alloc)
           && read($Heap, bm##0, BitmapImpl.Bitmap.Repr)[$Box($o)]
         ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableImpl.IndirectionTable.BitmapInitUpTo(bm##0, upTo##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1113,51)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1114,28)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type Iterator<IndirectionTableModel.Entry>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$MutableMap.ResizingHashMap.IterStart(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    // TrCallStmt: After ProcessCallStmt
    it#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1114,29)"} true;
    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1115,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    preLoop$loop#0$defass#bm#0 := defass#bm#0;
    $decr_init$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
      invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
      free invariant $w$loop#0
         ==> IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
           && BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || (forall loc#3: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#3) } 
              { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#3)] } 
            $Is(loc#3, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#3)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#3));
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
            Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))));
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())];
      invariant $w$loop#0
         ==> 
        BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
         ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
             ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))
               || (forall ref#19: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#19)]): Seq Box } 
                  { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#19)] } 
                LitInt(0) <= ref#19
                     && ref#19 < 18446744073709551616
                     && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#19)]
                   ==> (forall succ#3: int :: 
                    { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#3)] } 
                      { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#19)]): Seq Box, 
                        $Box(succ#3)) } 
                    LitInt(0) <= succ#3
                         && succ#3 < 18446744073709551616
                         && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(ref#19)]): Seq Box, 
                          $Box(succ#3))
                       ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(succ#3)])));
      free invariant $w$loop#0
         ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           && 
          BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           && 
          (forall loc#3: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#3) } 
              { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#3)] } 
            $Is(loc#3, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(loc#3)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#3))
           && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))), 
            Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)))))
           && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(PivotBetreeGraph.__default.Root())]
           && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
      free invariant $w$loop#0 ==> BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
      invariant $w$loop#0 ==> BitmapImpl.Bitmap.Inv($Heap, bm#0);
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0);
      invariant $w$loop#0
         ==> MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
          it#0);
      free invariant $w$loop#0
         ==> BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
           && BitmapModel.__default.Len#canCall(BitmapImpl.Bitmap.I($Heap, bm#0))
           && Bounds.__default.NumBlocks#canCall();
      invariant $w$loop#0
         ==> BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0))
           == LitInt(Bounds.__default.NumBlocks());
      free invariant $w$loop#0
         ==> $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
              IndirectionTableImpl.IndirectionTable.I($Heap, this), 
              it#0, 
              BitmapImpl.Bitmap.I($Heap, bm#0)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
              IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
           && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
            it#0, 
            BitmapImpl.Bitmap.I($Heap, bm#0))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
      invariant $w$loop#0
         ==> _System.Tuple2#Equal(IndirectionTableModel.__default.InitLocBitmapIterate($LS($LS($LZ)), 
            IndirectionTableImpl.IndirectionTable.I($Heap, this), 
            it#0, 
            BitmapImpl.Bitmap.I($Heap, bm#0)), 
          IndirectionTableModel.__default.InitLocBitmap(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap, 
            IndirectionTableImpl.IndirectionTable.I($Heap, this)));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> (forall $o: ref :: 
          { read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)] } 
          read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]
             ==> $o != null && !read(old($Heap), $o, alloc));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant preLoop$loop#0$defass#bm#0 ==> defass#bm#0;
      free invariant (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00
           || ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr_init$loop#00))
         && (MutableMapModel.Iterator.decreaser(it#0) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1115,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       then read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || !read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> Set#Disjoint(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> !read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#3))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#15: int :: 
                        { $Unbox(Map#Elements(graph#3)[$Box(ref#15)]): Seq Box } 
                          { Map#Domain(graph#3)[$Box(ref#15)] } 
                        LitInt(0) <= ref#15
                             && ref#15 < 18446744073709551616
                             && Map#Domain(graph#3)[$Box(ref#15)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#15)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#16: int :: 
                          { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#16)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)] } 
                          LitInt(0) <= ref#16
                               && ref#16 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#16)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#16)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#17: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#17)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#17)] } 
                            { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#17)] } 
                          LitInt(0) <= ref#17
                               && ref#17 < 18446744073709551616
                               && LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#17)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#17)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#17)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#18: int :: 
                        { Map#Domain(graph#3)[$Box(ref#18)] } 
                        LitInt(0) <= ref#18
                             && ref#18 < 18446744073709551616
                             && Map#Domain(graph#3)[$Box(ref#18)]
                           ==> ref#18 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#3: int :: 
                          { Map#Domain(locs#3)[$Box(r#3)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                          LitInt(0) <= r#3
                               && r#3 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                             ==> Map#Domain(locs#3)[$Box(r#3)]))));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            ##self#1 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
            assume IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            ##indirectionTable#2 := IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            // assume allocatedness for argument to function
            assume $IsAlloc(##indirectionTable#2, Tclass.SectorType.IndirectionTable(), $Heap);
            assume BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
               && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
               && BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assume BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assert defass#bm#0;
            assert {:subsumption 0} bm#0 != null;
            assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
            assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
            assume BitmapImpl.Bitmap.Inv($Heap, bm#0);
            assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            ##self#2 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#2, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#0 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#0, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            assume MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                it#0);
            assume MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0);
            assert defass#bm#0;
            assert {:subsumption 0} bm#0 != null;
            assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
            assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
            ##bm#0 := BitmapImpl.Bitmap.I($Heap, bm#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##bm#0, TSeq(TBool), $Heap);
            assume BitmapModel.__default.Len#canCall(BitmapImpl.Bitmap.I($Heap, bm#0));
            assume Bounds.__default.NumBlocks#canCall();
            assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
               && BitmapModel.__default.Len#canCall(BitmapImpl.Bitmap.I($Heap, bm#0))
               && Bounds.__default.NumBlocks#canCall();
            assume BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, bm#0))
               == LitInt(Bounds.__default.NumBlocks());
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       then read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || !read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> Set#Disjoint(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> !read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#4))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#20: int :: 
                        { $Unbox(Map#Elements(graph#4)[$Box(ref#20)]): Seq Box } 
                          { Map#Domain(graph#4)[$Box(ref#20)] } 
                        LitInt(0) <= ref#20
                             && ref#20 < 18446744073709551616
                             && Map#Domain(graph#4)[$Box(ref#20)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#20)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#21: int :: 
                          { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#21)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#21)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#21)] } 
                          LitInt(0) <= ref#21
                               && ref#21 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#21)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#21)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#21)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#22: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)] } 
                            { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#22)] } 
                          LitInt(0) <= ref#22
                               && ref#22 < 18446744073709551616
                               && LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#22)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#23: int :: 
                        { Map#Domain(graph#4)[$Box(ref#23)] } 
                        LitInt(0) <= ref#23
                             && ref#23 < 18446744073709551616
                             && Map#Domain(graph#4)[$Box(ref#23)]
                           ==> ref#23 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#4: int :: 
                          { Map#Domain(locs#4)[$Box(r#4)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                          LitInt(0) <= r#4
                               && r#4 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                             ==> Map#Domain(locs#4)[$Box(r#4)]))));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assert defass#bm#0;
            assert {:subsumption 0} bm#0 != null;
            assert {:subsumption 0} BitmapImpl.Bitmap.Inv($Heap, bm#0);
            assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0);
            ##indirectionTable#3 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##indirectionTable#3, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
            ##it#1 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#1, 
              Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##bm#1 := BitmapImpl.Bitmap.I($Heap, bm#0);
            // assume allocatedness for argument to function
            assume $IsAlloc(##bm#1, TSeq(TBool), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.Inv(##indirectionTable#3);
            assert {:subsumption 0} MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(##indirectionTable#3), 
              ##it#1);
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#3))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#3))
                 || (forall loc#4: DatatypeType :: 
                  { DiskLayout.__default.ValidNodeLocation(loc#4) } 
                    { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(loc#4)] } 
                  $Is(loc#4, Tclass.DiskLayout.Location())
                       && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(loc#4)]
                     ==> DiskLayout.__default.ValidNodeLocation(loc#4));
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#3))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#3))
                 || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3))), 
                  Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#3))));
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#3))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#3))
                 || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(PivotBetreeGraph.__default.Root())];
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#3))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#3))
                 || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))
                   ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))
                     || (forall ref#24: int :: 
                      { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(ref#24)]): Seq Box } 
                        { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(ref#24)] } 
                      LitInt(0) <= ref#24
                           && ref#24 < 18446744073709551616
                           && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(ref#24)]
                         ==> (forall succ#4: int :: 
                          { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(succ#4)] } 
                            { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(ref#24)]): Seq Box, 
                              $Box(succ#4)) } 
                          LitInt(0) <= succ#4
                               && succ#4 < 18446744073709551616
                               && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(ref#24)]): Seq Box, 
                                $Box(succ#4))
                             ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#3)))[$Box(succ#4)])));
            assert {:subsumption 0} BitmapModel.__default.Len(##bm#1) == LitInt(Bounds.__default.NumBlocks());
            assume IndirectionTableModel.__default.InitLocBitmapIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
              it#0, 
              BitmapImpl.Bitmap.I($Heap, bm#0));
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
                IndirectionTableImpl.IndirectionTable.I($Heap, this), 
                it#0, 
                BitmapImpl.Bitmap.I($Heap, bm#0)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       then read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || !read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> Set#Disjoint(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> !read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#5, graph#5))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#5))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#25: int :: 
                        { $Unbox(Map#Elements(graph#5)[$Box(ref#25)]): Seq Box } 
                          { Map#Domain(graph#5)[$Box(ref#25)] } 
                        LitInt(0) <= ref#25
                             && ref#25 < 18446744073709551616
                             && Map#Domain(graph#5)[$Box(ref#25)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#5)[$Box(ref#25)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#26: int :: 
                          { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#26)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)] } 
                          LitInt(0) <= ref#26
                               && ref#26 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#26)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#27: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)] } 
                            { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#27)] } 
                          LitInt(0) <= ref#27
                               && ref#27 < 18446744073709551616
                               && LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#27)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#28: int :: 
                        { Map#Domain(graph#5)[$Box(ref#28)] } 
                        LitInt(0) <= ref#28
                             && ref#28 < 18446744073709551616
                             && Map#Domain(graph#5)[$Box(ref#28)]
                           ==> ref#28 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#5: int :: 
                          { Map#Domain(locs#5)[$Box(r#5)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#5)] } 
                          LitInt(0) <= r#5
                               && r#5 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#5)]
                             ==> Map#Domain(locs#5)[$Box(r#5)]))));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            ##indirectionTable#4 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##indirectionTable#4, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.Inv(##indirectionTable#4);
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#4))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#4))
                 || (forall loc#5: DatatypeType :: 
                  { DiskLayout.__default.ValidNodeLocation(loc#5) } 
                    { Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(loc#5)] } 
                  $Is(loc#5, Tclass.DiskLayout.Location())
                       && Map#Values(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(loc#5)]
                     ==> DiskLayout.__default.ValidNodeLocation(loc#5));
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#4))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#4))
                 || Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4))), 
                  Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(##indirectionTable#4))));
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#4))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#4))
                 || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(PivotBetreeGraph.__default.Root())];
            assert {:subsumption 0} BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(##indirectionTable#4))
               ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(##indirectionTable#4))
                 || (BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))
                   ==> BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))
                     || (forall ref#29: int :: 
                      { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(ref#29)]): Seq Box } 
                        { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(ref#29)] } 
                      LitInt(0) <= ref#29
                           && ref#29 < 18446744073709551616
                           && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(ref#29)]
                         ==> (forall succ#5: int :: 
                          { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(succ#5)] } 
                            { Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(ref#29)]): Seq Box, 
                              $Box(succ#5)) } 
                          LitInt(0) <= succ#5
                               && succ#5 < 18446744073709551616
                               && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(ref#29)]): Seq Box, 
                                $Box(succ#5))
                             ==> Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(##indirectionTable#4)))[$Box(succ#5)])));
            assume IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
                IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assume $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
                  IndirectionTableImpl.IndirectionTable.I($Heap, this), 
                  it#0, 
                  BitmapImpl.Bitmap.I($Heap, bm#0)))
               && $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
                  IndirectionTableImpl.IndirectionTable.I($Heap, this)))
               && 
              IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
               && BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
               && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
                it#0, 
                BitmapImpl.Bitmap.I($Heap, bm#0))
               && 
              IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
               && IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            assume _System.Tuple2#Equal(IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
                IndirectionTableImpl.IndirectionTable.I($Heap, this), 
                it#0, 
                BitmapImpl.Bitmap.I($Heap, bm#0)), 
              IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
                IndirectionTableImpl.IndirectionTable.I($Heap, this)));
            assert defass#bm#0;
            assert {:subsumption 0} bm#0 != null;
            assume true;
            assume (forall $o: ref :: 
              { read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)] } 
              read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)]
                 ==> $o != null && !read(old($Heap), $o, alloc));
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume MutableMapModel.Iterator.Iterator_q(it#0);
            assume false;
        }

        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        if (!MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
        {
            break;
        }

        $decr$loop#00 := MutableMapModel.Iterator.decreaser(it#0);
        // ----- assert statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1126,9)
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
              Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Repr)), 
                (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   then read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)
                   else Set#Empty(): Set Box)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)[$Box(this)];
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> Set#Disjoint(read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> !read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)[$Box(this)]);
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Lit(true)));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  IndirectionTableModel.__default.ValidPredCounts(predCounts#0_0, graph#0_0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  BlockCache.__default.GraphClosed(graph#0_0))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#0_0: int :: 
                    { $Unbox(Map#Elements(graph#0_0)[$Box(ref#0_0)]): Seq Box } 
                      { Map#Domain(graph#0_0)[$Box(ref#0_0)] } 
                    LitInt(0) <= ref#0_0
                         && ref#0_0 < 18446744073709551616
                         && Map#Domain(graph#0_0)[$Box(ref#0_0)]
                       ==> Seq#Length($Unbox(Map#Elements(graph#0_0)[$Box(ref#0_0)]): Seq Box)
                         <= LitInt(Bounds.__default.MaxNumChildren())))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#0_1: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#0_1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_1)] } 
                      LitInt(0) <= ref#0_1
                           && ref#0_1 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_1)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_1)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#0_1)]))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                     ==> (forall ref#0_2: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#0_2)] } 
                      LitInt(0) <= ref#0_2
                           && ref#0_2 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#0_2)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#0_2)]): DatatypeType)
                             == LitInt(0)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Count)
                     <= LitInt(IndirectionTableModel.__default.MaxSize()))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (forall ref#0_3: int :: 
                    { Map#Domain(graph#0_0)[$Box(ref#0_3)] } 
                    LitInt(0) <= ref#0_3
                         && ref#0_3 < 18446744073709551616
                         && Map#Domain(graph#0_0)[$Box(ref#0_3)]
                       ==> ref#0_3
                         <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
        assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
             || (var predCounts#0_0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var graph#0_0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (var locs#0_0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                     ==> (forall r#0_0: int :: 
                      { Map#Domain(locs#0_0)[$Box(r#0_0)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0)] } 
                      LitInt(0) <= r#0_0
                           && r#0_0 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0_0)]
                         ==> Map#Domain(locs#0_0)[$Box(r#0_0)]))));
        assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
        assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        ##self#0_0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
        // assume allocatedness for argument to function
        assume $IsAlloc(##self#0_0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
        assume IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
        assume SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
        assume MutableMapModel.Iterator.Iterator_q(it#0)
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
           && SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
        assert Map#Domain(SectorType.IndirectionTable.locs(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this))))[$Box(MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0)))];
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1128,25)
        assume true;
        assume MutableMapModel.Iterator.Iterator_q(it#0);
        assert MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
        assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType);
        assert Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType));
        assume DiskLayout.Location.Location_q($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType))): DatatypeType);
        assume MutableMapModel.Iterator.Iterator_q(it#0)
           && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
           && DiskLayout.Location.Location_q($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType))): DatatypeType);
        loc#0_0 := DiskLayout.Location.addr($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType))): DatatypeType);
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1128,55)"} true;
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1129,30)
        assume true;
        assume Bounds.__default.NodeBlockSizeUint64#canCall();
        assert LitInt(Bounds.__default.NodeBlockSizeUint64()) != 0;
        newtype$check#0_0 := Div(loc#0_0, LitInt(Bounds.__default.NodeBlockSizeUint64()));
        assert LitInt(0) <= newtype$check#0_0 && newtype$check#0_0 < 18446744073709551616;
        assume Bounds.__default.NodeBlockSizeUint64#canCall();
        locIndex#0_0 := Div(loc#0_0, LitInt(Bounds.__default.NodeBlockSizeUint64()));
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1129,59)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1130,9)
        assume Bounds.__default.NumBlocksUint64#canCall();
        assume Bounds.__default.NumBlocksUint64#canCall();
        if (locIndex#0_0 < Bounds.__default.NumBlocksUint64())
        {
            // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1131,35)
            assume true;
            // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type bool
            // TrCallStmt: Before ProcessCallStmt
            assert defass#bm#0;
            assume true;
            assert bm#0 != null;
            assume true;
            // ProcessCallStmt: CheckSubrange
            c##0_0_0 := locIndex#0_0;
            assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
            // ProcessCallStmt: Make the call
            call $rhs##0_0_0 := Call$$BitmapImpl.Bitmap.GetIsSet(bm#0, c##0_0_0);
            // TrCallStmt: After ProcessCallStmt
            isSet#0_0_0 := $rhs##0_0_0;
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1131,44)"} true;
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1132,11)
            assume true;
            if (!isSet#0_0_0)
            {
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1133,28)
                assume true;
                // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Iterator<IndirectionTableModel.Entry>
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                assume true;
                // ProcessCallStmt: CheckSubrange
                it##0_0_0_0 := it#0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call $rhs##0_0_0_0 := Call$$MutableMap.ResizingHashMap.IterInc(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##0_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                it#0 := $rhs##0_0_0_0;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1133,31)"} true;
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1134,19)
                // TrCallStmt: Before ProcessCallStmt
                assert defass#bm#0;
                assume true;
                assert bm#0 != null;
                assume true;
                // ProcessCallStmt: CheckSubrange
                c##0_0_0_0 := locIndex#0_0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: 
                  $o != null
                       && read($Heap, $o, alloc)
                       && ($o == bm#0 || read($Heap, bm#0, BitmapImpl.Bitmap.Repr)[$Box($o)])
                     ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call Call$$BitmapImpl.Bitmap.Set(bm#0, c##0_0_0_0);
                // TrCallStmt: After ProcessCallStmt
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1134,28)"} true;
            }
            else
            {
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1136,21)
                assume true;
                assume true;
                success#0 := Lit(false);
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1136,28)"} true;
                // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1137,13)
                assert defass#bm#0;
                return;
            }
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1140,19)
            assume true;
            assume true;
            success#0 := Lit(false);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1140,26)"} true;
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1141,11)
            assert defass#bm#0;
            return;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1115,7)
        assert ORD#Less(MutableMapModel.Iterator.decreaser(it#0), $decr$loop#00);
        assume MutableMap.ResizingHashMap.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.I#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
           && BlockCache.__default.WFCompleteIndirectionTable#canCall(IndirectionTableModel.__default.I(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
        assume BitmapImpl.Bitmap.Inv#canCall($Heap, bm#0);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0);
        assume BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
           && BitmapModel.__default.Len#canCall(BitmapImpl.Bitmap.I($Heap, bm#0))
           && Bounds.__default.NumBlocks#canCall();
        assume $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
              IndirectionTableImpl.IndirectionTable.I($Heap, this), 
              it#0, 
              BitmapImpl.Bitmap.I($Heap, bm#0)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.InitLocBitmap(StartFuel_IndirectionTableModel._default.InitLocBitmap, 
              IndirectionTableImpl.IndirectionTable.I($Heap, this)))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && BitmapImpl.Bitmap.I#canCall($Heap, bm#0)
           && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), 
            it#0, 
            BitmapImpl.Bitmap.I($Heap, bm#0))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.InitLocBitmap#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
        assume true;
    }

    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1145,15)
    assume true;
    assume true;
    success#0 := Lit(true);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1145,21)"} true;
    assert defass#bm#0;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.FindDeallocable(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (ref#0: DatatypeType
       where $Is(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap));
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.FindDeallocable(this: ref) returns (ref#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;
  var ##self#1: DatatypeType;

    // AddMethodImpl: FindDeallocable, CheckWellformed$$IndirectionTableImpl.IndirectionTable.FindDeallocable
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1150,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assume IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc ref#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1153,16): post-state"} true;
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#5: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#5)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#6: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#7: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { Map#Domain(graph#1)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#8)]
                   ==> ref#8 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#1 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#1, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#1);
    assume IndirectionTableModel.__default.Inv(##self#1);
    assert {:subsumption 0} IndirectionTableModel.__default.TrackingGarbage#canCall(##self#1)
       ==> IndirectionTableModel.__default.TrackingGarbage(##self#1)
         || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(##self#1));
    assume IndirectionTableModel.__default.TrackingGarbage(##self#1);
    assume IndirectionTableModel.__default.FindDeallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume Options.Option#Equal(ref#0, 
      IndirectionTableModel.__default.FindDeallocable(StartFuel_IndirectionTableModel._default.FindDeallocable, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this)));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.FindDeallocable(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (ref#0: DatatypeType
       where $Is(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     ==> IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
       || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(ref#0)
     && $IsA#Options.Option(IndirectionTableModel.__default.FindDeallocable(StartFuel_IndirectionTableModel._default.FindDeallocable, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.FindDeallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures Options.Option#Equal(ref#0, 
    IndirectionTableModel.__default.FindDeallocable(StartFuelAssert_IndirectionTableModel._default.FindDeallocable, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.FindDeallocable(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (ref#0: DatatypeType
       where $Is(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap), 
    $_reverifyPost: bool);
  free requires 45 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                 && BlockCache.__default.GraphClosed(graph#2)
                 && (forall ref#9: int :: 
                  { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                    { Map#Domain(graph#2)[$Box(ref#9)] } 
                  LitInt(0) <= ref#9
                       && ref#9 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#9)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#10: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                      LitInt(0) <= ref#10
                           && ref#10 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)])
                     && (forall ref#11: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                      LitInt(0) <= ref#11
                           && ref#11 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#12: int :: 
                  { Map#Domain(graph#2)[$Box(ref#12)] } 
                  LitInt(0) <= ref#12
                       && ref#12 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#12)]
                     ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#2)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#2)[$Box(r#2)])))));
  free requires IndirectionTableModel.__default.TrackingGarbage#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && 
    IndirectionTableModel.__default.TrackingGarbage(IndirectionTableImpl.IndirectionTable.I($Heap, this))
     && Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(ref#0)
     && $IsA#Options.Option(IndirectionTableModel.__default.FindDeallocable(StartFuel_IndirectionTableModel._default.FindDeallocable, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this)))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.FindDeallocable#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures Options.Option#Equal(ref#0, 
    IndirectionTableModel.__default.FindDeallocable(StartFuelAssert_IndirectionTableModel._default.FindDeallocable, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.FindDeallocable(this: ref) returns (ref#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $IsAlloc($rhs##0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap);

    // AddMethodImpl: FindDeallocable, Impl$$IndirectionTableImpl.IndirectionTable.FindDeallocable
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1154,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1155,51)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__FindDeallocable();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1155,52)"} true;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1156,34)
    assume true;
    // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type Option<BT.G.Reference>
    // TrCallStmt: Before ProcessCallStmt
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null;
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call $rhs##0 := Call$$LruImpl.LruImplQueue.NextOpt(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue));
    // TrCallStmt: After ProcessCallStmt
    ref#0 := $rhs##0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1156,35)"} true;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetSize(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616);
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetSize(this: ref) returns (size#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: GetSize, CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetSize
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1159,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc size#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1162,24): post-state"} true;
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#0: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#0)] } 
                LitInt(0) <= ref#0
                     && ref#0 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#0)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#1: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#3: int :: 
                { Map#Domain(graph#0)[$Box(ref#3)] } 
                LitInt(0) <= ref#3
                     && ref#3 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#3)]
                   ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume size#0
       == Map#Card(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.GetSize(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616);
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures size#0
     == Map#Card(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.GetSize(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 46 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                 && BlockCache.__default.GraphClosed(graph#1)
                 && (forall ref#4: int :: 
                  { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                    { Map#Domain(graph#1)[$Box(ref#4)] } 
                  LitInt(0) <= ref#4
                       && ref#4 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#4)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#5: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                      LitInt(0) <= ref#5
                           && ref#5 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#5)])
                     && (forall ref#6: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                      LitInt(0) <= ref#6
                           && ref#6 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#7: int :: 
                  { Map#Domain(graph#1)[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#7)]
                     ==> ref#7 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#1: int :: 
                      { Map#Domain(locs#1)[$Box(r#1)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                      LitInt(0) <= r#1
                           && r#1 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                         ==> Map#Domain(locs#1)[$Box(r#1)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures size#0
     == Map#Card(IndirectionTableModel.IndirectionTable.graph(IndirectionTableImpl.IndirectionTable.I($Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.GetSize(this: ref) returns (size#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var t##0: DatatypeType;

    // AddMethodImpl: GetSize, Impl$$IndirectionTableImpl.IndirectionTable.GetSize
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1163,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1164,54)
    // TrCallStmt: Before ProcessCallStmt
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#2))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { $Unbox(Map#Elements(graph#2)[$Box(ref#8)]): Seq Box } 
                  { Map#Domain(graph#2)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#8)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#8)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#9: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#9)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)] } 
                  LitInt(0) <= ref#9
                       && ref#9 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#9)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#9)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#10: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                  LitInt(0) <= ref#10
                       && ref#10 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#10)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#11: int :: 
                { Map#Domain(graph#2)[$Box(ref#11)] } 
                LitInt(0) <= ref#11
                     && ref#11 < 18446744073709551616
                     && Map#Domain(graph#2)[$Box(ref#11)]
                   ==> ref#11 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#2: int :: 
                  { Map#Domain(locs#2)[$Box(r#2)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                  LitInt(0) <= r#2
                       && r#2 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                     ==> Map#Domain(locs#2)[$Box(r#2)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    // ProcessCallStmt: CheckSubrange
    t##0 := IndirectionTableModel.IndirectionTable.t(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t##0);
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1164,60)"} true;
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1165,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1165,7)
    assume true;
    assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
    assume true;
    size#0 := read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Count);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1165,25)"} true;
    return;
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (ref#0: DatatypeType
       where $Is(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap));
  free requires 47 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc(this: ref) returns (ref#0: DatatypeType)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;

    // AddMethodImpl: FindRefWithNoLoc, CheckWellformed$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1168,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc)
         ==> $Heap[$o] == old($Heap)[$o]
           || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc ref#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1171,15): post-state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assume Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#1: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#1)] } 
                LitInt(0) <= ref#1
                     && ref#1 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#1)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#3: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#3)] } 
                  LitInt(0) <= ref#3
                       && ref#3 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#3)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#3)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#4: int :: 
                { Map#Domain(graph#0)[$Box(ref#4)] } 
                LitInt(0) <= ref#4
                     && ref#4 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#4)]
                   ==> ref#4 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#0: int :: 
                  { Map#Domain(locs#0)[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(locs#0)[$Box(r#0)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                 != null
               then read(old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || !read(old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          old($Heap), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> LruImpl.LruImplQueue.Inv(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> Set#Disjoint(read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read(old($Heap), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
             != null
           ==> !read(old($Heap), 
            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#1))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#5: int :: 
                { $Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box } 
                  { Map#Domain(graph#1)[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#5)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#5)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#6: int :: 
                  { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#6)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                   != null
                 ==> (forall ref#7: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)] } 
                    { LruModel.__default.I(read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && LruModel.__default.I(read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#7)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#8: int :: 
                { Map#Domain(graph#1)[$Box(ref#8)] } 
                LitInt(0) <= ref#8
                     && ref#8 < 18446744073709551616
                     && Map#Domain(graph#1)[$Box(ref#8)]
                   ==> ref#8
                     <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
       ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
         || (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                old($Heap), 
                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#1)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#1)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
    assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
    assume _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(ref#0)), 
      IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (ref#0: DatatypeType
       where $Is(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  free ensures true;
  ensures Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr));
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(ref#0)), 
    IndirectionTableModel.__default.FindRefWithNoLoc(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (ref#0: DatatypeType
       where $Is(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(ref#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap), 
    $_reverifyPost: bool);
  free requires 47 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#2 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#2 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#2 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#2, graph#2)
                 && BlockCache.__default.GraphClosed(graph#2)
                 && (forall ref#9: int :: 
                  { $Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box } 
                    { Map#Domain(graph#2)[$Box(ref#9)] } 
                  LitInt(0) <= ref#9
                       && ref#9 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#9)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#2)[$Box(ref#9)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#10: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)] } 
                      LitInt(0) <= ref#10
                           && ref#10 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#10)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#10)])
                     && (forall ref#11: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#11)] } 
                      LitInt(0) <= ref#11
                           && ref#11 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#11)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#11)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#12: int :: 
                  { Map#Domain(graph#2)[$Box(ref#12)] } 
                  LitInt(0) <= ref#12
                       && ref#12 < 18446744073709551616
                       && Map#Domain(graph#2)[$Box(ref#12)]
                     ==> ref#12 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#2)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#2)[$Box(r#2)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
        Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)), 
          (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             then read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)
             else Set#Empty(): Set Box)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
        MutableMap.ResizingHashMap.Repr)[$Box(this)];
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
        $Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> Set#Disjoint(read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
         ==> !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr)[$Box(this)]);
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        Lit(true));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true)));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            IndirectionTableModel.__default.ValidPredCounts(predCounts#3, graph#3))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            BlockCache.__default.GraphClosed(graph#3))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#13: int :: 
              { $Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box } 
                { Map#Domain(graph#3)[$Box(ref#13)] } 
              LitInt(0) <= ref#13
                   && ref#13 < 18446744073709551616
                   && Map#Domain(graph#3)[$Box(ref#13)]
                 ==> Seq#Length($Unbox(Map#Elements(graph#3)[$Box(ref#13)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren())))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#14: int :: 
                { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#14)] } 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)] } 
                LitInt(0) <= ref#14
                     && ref#14 < 18446744073709551616
                     && 
                    Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#14)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#14)]))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               ==> (forall ref#15: int :: 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType } 
                  { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)] } 
                  { LruModel.__default.I(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Queue))[$Box(ref#15)] } 
                LitInt(0) <= ref#15
                     && ref#15 < 18446744073709551616
                     && LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#15)]
                   ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#15)]): DatatypeType)
                       == LitInt(0)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Count)
               <= LitInt(IndirectionTableModel.__default.MaxSize()))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (forall ref#16: int :: 
              { Map#Domain(graph#3)[$Box(ref#16)] } 
              LitInt(0) <= ref#16
                   && ref#16 < 18446744073709551616
                   && Map#Domain(graph#3)[$Box(ref#16)]
                 ==> ref#16 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
  ensures IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
       || (var predCounts#3 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
        (var graph#3 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var locs#3 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
               ==> (forall r#3: int :: 
                { Map#Domain(locs#3)[$Box(r#3)] } 
                  { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)] } 
                LitInt(0) <= r#3
                     && r#3 < 18446744073709551616
                     && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#3)]
                   ==> Map#Domain(locs#3)[$Box(r#3)]))));
  free ensures true;
  ensures Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr));
  free ensures $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
        IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
     && IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(IndirectionTableImpl.IndirectionTable.I($Heap, this)), $Box(ref#0)), 
    IndirectionTableModel.__default.FindRefWithNoLoc(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc, 
      IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc(this: ref) returns (ref#0: DatatypeType, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var it#0: DatatypeType
     where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var $rhs##0: DatatypeType
     where $Is($rhs##0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc($rhs##0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var $PreLoopHeap$loop#0: Heap;
  var $decr_init$loop#00: Box;
  var $w$loop#0: bool;
  var ##self#1: DatatypeType;
  var ##it#0: DatatypeType;
  var r#5: int;
  var ##self#2: DatatypeType;
  var ##self#3: DatatypeType;
  var ##it#1: DatatypeType;
  var $decr$loop#00: Box;
  var next#1_0: DatatypeType
     where $Is(next#1_0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc(next#1_0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var $rhs##1_0: DatatypeType
     where $Is($rhs##1_0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()))
       && $IsAlloc($rhs##1_0, 
        Tclass.MutableMapModel.IteratorOutput(Tclass.IndirectionTableModel.Entry()), 
        $Heap);
  var it##1_0: DatatypeType;
  var $rhs#1_0_0_0: DatatypeType
     where $Is($rhs#1_0_0_0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));
  var $rhs##1_0_0: DatatypeType
     where $Is($rhs##1_0_0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc($rhs##1_0_0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
  var it##1_0_0: DatatypeType;
  var $rhs#1_0: DatatypeType
     where $Is($rhs#1_0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()));

    // AddMethodImpl: FindRefWithNoLoc, Impl$$IndirectionTableImpl.IndirectionTable.FindRefWithNoLoc
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc)
         ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1174,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1175,52)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__FindRefWithNoLoc();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1175,53)"} true;
    havoc it#0 /* where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
       && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap) */;
    // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1178,7)
    assume true;
    if (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator)))
    {
        // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1179,12)
        assume true;
        assert Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator));
        assume true;
        it#0 := $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1179,44)"} true;
    }
    else
    {
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1181,37)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type MutableMapModel.SimpleIterator
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##0 := Call$$MutableMap.ResizingHashMap.SimpleIterStart(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
        // TrCallStmt: After ProcessCallStmt
        it#0 := $rhs##0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1181,38)"} true;
    }

    // ----- while statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1184,7)
    // Assume Fuel Constant
    $PreLoopHeap$loop#0 := $Heap;
    $decr_init$loop#00 := MutableMapModel.SimpleIterator.decreaser(it#0);
    havoc $w$loop#0;
    while (true)
      free invariant $w$loop#0 ==> IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)];
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> Set#Disjoint(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box(this)]);
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Lit(true)));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                BlockCache.__default.GraphClosed(graph#4))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (forall ref#17: int :: 
                  { $Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box } 
                    { Map#Domain(graph#4)[$Box(ref#17)] } 
                  LitInt(0) <= ref#17
                       && ref#17 < 18446744073709551616
                       && Map#Domain(graph#4)[$Box(ref#17)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren())))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#18: int :: 
                    { LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#18)] } 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)] } 
                    LitInt(0) <= ref#18
                         && ref#18 < 18446744073709551616
                         && 
                        Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]
                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType)
                           == LitInt(0)
                       ==> LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#18)]))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#19: int :: 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                      { LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                    LitInt(0) <= ref#19
                         && ref#19 < 18446744073709551616
                         && LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#19)]
                       ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                           == LitInt(0)))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize()))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                (forall ref#20: int :: 
                  { Map#Domain(graph#4)[$Box(ref#20)] } 
                  LitInt(0) <= ref#20
                       && ref#20 < 18446744073709551616
                       && Map#Domain(graph#4)[$Box(ref#20)]
                     ==> ref#20 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                    MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                    $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
      invariant $w$loop#0
         ==> 
        IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
         ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           || (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> (forall r#4: int :: 
                    { Map#Domain(locs#4)[$Box(r#4)] } 
                      { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                    LitInt(0) <= r#4
                         && r#4 < 18446744073709551616
                         && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                       ==> Map#Domain(locs#4)[$Box(r#4)]))));
      free invariant $w$loop#0
         ==> IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
           && 
          IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
           && 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
           && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
           && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
            Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)), 
              (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 then read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                  LruImpl.LruImplQueue.Repr)
                 else Set#Empty(): Set Box)))
           && !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)[$Box(this)]
           && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> Set#Disjoint(read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)))
           && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
             ==> !read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr)[$Box(this)])
           && (var predCounts#4 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            true
               && (var graph#4 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                true
                   && (var locs#4 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    IndirectionTableModel.__default.ValidPredCounts(predCounts#4, graph#4)
                       && BlockCache.__default.GraphClosed(graph#4)
                       && (forall ref#17: int :: 
                        { $Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box } 
                          { Map#Domain(graph#4)[$Box(ref#17)] } 
                        LitInt(0) <= ref#17
                             && ref#17 < 18446744073709551616
                             && Map#Domain(graph#4)[$Box(ref#17)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#4)[$Box(ref#17)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren()))
                       && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#18: int :: 
                            { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#18)] } 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)] } 
                            LitInt(0) <= ref#18
                                 && ref#18 < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#18)]): DatatypeType)
                                   == LitInt(0)
                               ==> LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#18)])
                           && (forall ref#19: int :: 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType } 
                              { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)] } 
                              { LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#19)] } 
                            LitInt(0) <= ref#19
                                 && ref#19 < 18446744073709551616
                                 && LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#19)]
                               ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]
                                 && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                            $Heap, 
                                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#19)]): DatatypeType)
                                   == LitInt(0)))
                       && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                       && read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize())
                       && (forall ref#20: int :: 
                        { Map#Domain(graph#4)[$Box(ref#20)] } 
                        LitInt(0) <= ref#20
                             && ref#20 < 18446744073709551616
                             && Map#Domain(graph#4)[$Box(ref#20)]
                           ==> ref#20 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                       && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                            $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                           && (forall r#4: int :: 
                            { Map#Domain(locs#4)[$Box(r#4)] } 
                              { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)] } 
                            LitInt(0) <= r#4
                                 && r#4 < 18446744073709551616
                                 && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#4)]
                               ==> Map#Domain(locs#4)[$Box(r#4)])))));
      free invariant $w$loop#0
         ==> MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0);
      invariant $w$loop#0
         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
          it#0);
      free invariant $w$loop#0
         ==> (forall r#7: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)] } 
            { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)] } 
          LitInt(0) <= r#7 && r#7 < 18446744073709551616
             ==> MutableMapModel.SimpleIterator.SimpleIterator_q(it#0)
               && (MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)]
                 ==> IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
      invariant $w$loop#0
         ==> (forall r#7: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)] } 
            { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)] } 
          LitInt(0) <= r#7
               && r#7 < 18446744073709551616
               && MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)]
             ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)]);
      free invariant $w$loop#0
         ==> $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
              IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
           && IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0);
      invariant $w$loop#0
         ==> _System.Tuple2#Equal(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc, 
            IndirectionTableImpl.IndirectionTable.I(old($Heap), this)), 
          IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LS($LZ)), IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0));
      free invariant $w$loop#0 ==> true;
      invariant $w$loop#0
         ==> Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr));
      free invariant (forall $o: ref :: 
        { $Heap[$o] } 
        $o != null && read(old($Heap), $o, alloc)
           ==> $Heap[$o] == $PreLoopHeap$loop#0[$o]
             || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box($o)]);
      free invariant $HeapSucc($PreLoopHeap$loop#0, $Heap);
      free invariant (forall<alpha> $o: ref, $f: Field alpha :: 
        { read($Heap, $o, $f) } 
        $o != null && read($PreLoopHeap$loop#0, $o, alloc)
           ==> read($Heap, $o, $f) == read($PreLoopHeap$loop#0, $o, $f) || $_Frame[$o, $f]);
      free invariant (MutableMapModel.SimpleIterator.decreaser(it#0) == $decr_init$loop#00
           || ORD#Less(MutableMapModel.SimpleIterator.decreaser(it#0), $decr_init$loop#00))
         && (MutableMapModel.SimpleIterator.decreaser(it#0) == $decr_init$loop#00 ==> true);
    {
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1184,6): after some loop iterations"} true;
        if (!$w$loop#0)
        {
            assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
            assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
            assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
            assert {:subsumption 0} read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
            assert {:subsumption 0} MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assume MutableMapModel.LinearHashMap.LinearHashMap_q(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)));
            ##self#1 := MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#1, 
              Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
              $Heap);
            ##it#0 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap);
            assume MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0);
            assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
               && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                it#0);
            assume MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
              it#0);
            havoc r#5;
            assume LitInt(0) <= r#5 && r#5 < 18446744073709551616;
            // Begin Comprehension WF check
            assume MutableMapModel.SimpleIterator.SimpleIterator_q(it#0);
            if (MutableMapModel.SimpleIterator.s(it#0)[$Box(r#5)])
            {
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                          read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                            MutableMap.ResizingHashMap.Repr)), 
                        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                           then read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Repr)
                           else Set#Empty(): Set Box)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || !read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)[$Box(this)];
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> Set#Disjoint(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Repr), 
                        read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Repr)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       ==> !read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)[$Box(this)]);
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Lit(true));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        Lit(true)));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          IndirectionTableModel.__default.ValidPredCounts(predCounts#5, graph#5))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          BlockCache.__default.GraphClosed(graph#5))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          (forall ref#21: int :: 
                            { $Unbox(Map#Elements(graph#5)[$Box(ref#21)]): Seq Box } 
                              { Map#Domain(graph#5)[$Box(ref#21)] } 
                            LitInt(0) <= ref#21
                                 && ref#21 < 18446744073709551616
                                 && Map#Domain(graph#5)[$Box(ref#21)]
                               ==> Seq#Length($Unbox(Map#Elements(graph#5)[$Box(ref#21)]): Seq Box)
                                 <= LitInt(Bounds.__default.MaxNumChildren())))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#22: int :: 
                              { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#22)] } 
                                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)] } 
                              LitInt(0) <= ref#22
                                   && ref#22 < 18446744073709551616
                                   && 
                                  Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#22)]): DatatypeType)
                                     == LitInt(0)
                                 ==> LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#22)]))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                             ==> (forall ref#23: int :: 
                              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]): DatatypeType } 
                                { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)] } 
                                { LruModel.__default.I(read($Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                    LruImpl.LruImplQueue.Queue))[$Box(ref#23)] } 
                              LitInt(0) <= ref#23
                                   && ref#23 < 18446744073709551616
                                   && LruModel.__default.I(read($Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                      LruImpl.LruImplQueue.Queue))[$Box(ref#23)]
                                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                        $Heap, 
                                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]
                                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                              $Heap, 
                                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#23)]): DatatypeType)
                                     == LitInt(0)))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                              MutableMap.ResizingHashMap.Count)
                             <= LitInt(IndirectionTableModel.__default.MaxSize()))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          (forall ref#24: int :: 
                            { Map#Domain(graph#5)[$Box(ref#24)] } 
                            LitInt(0) <= ref#24
                                 && ref#24 < 18446744073709551616
                                 && Map#Domain(graph#5)[$Box(ref#24)]
                               ==> ref#24 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                              MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                              $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
                assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
                   ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                     || (var predCounts#5 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (var graph#5 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                        (var locs#5 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                          Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                             ==> (forall r#6: int :: 
                              { Map#Domain(locs#5)[$Box(r#6)] } 
                                { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)] } 
                              LitInt(0) <= r#6
                                   && r#6 < 18446744073709551616
                                   && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#6)]
                                 ==> Map#Domain(locs#5)[$Box(r#6)]))));
                assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
                assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
                assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            }

            // End Comprehension WF check
            assume (forall r#7: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)] } 
                { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)] } 
              LitInt(0) <= r#7 && r#7 < 18446744073709551616
                 ==> MutableMapModel.SimpleIterator.SimpleIterator_q(it#0)
                   && (MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)]
                     ==> IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
            assume (forall r#7: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)] } 
                { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)] } 
              LitInt(0) <= r#7
                   && r#7 < 18446744073709551616
                   && MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)]
                 ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)]);
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                     != null
                   ==> read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || Set#Equal(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                         != null
                       then read(old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || !read(old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  old($Heap), 
                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                     != null
                   ==> LruImpl.LruImplQueue.Inv(old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                     != null
                   ==> Set#Disjoint(read(old($Heap), 
                      read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read(old($Heap), 
                      read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                     != null
                   ==> !read(old($Heap), 
                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#6, graph#6))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#6))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#25: int :: 
                        { $Unbox(Map#Elements(graph#6)[$Box(ref#25)]): Seq Box } 
                          { Map#Domain(graph#6)[$Box(ref#25)] } 
                        LitInt(0) <= ref#25
                             && ref#25 < 18446744073709551616
                             && Map#Domain(graph#6)[$Box(ref#25)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#6)[$Box(ref#25)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                           != null
                         ==> (forall ref#26: int :: 
                          { LruModel.__default.I(read(old($Heap), 
                                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#26)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    old($Heap), 
                                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)] } 
                          LitInt(0) <= ref#26
                               && ref#26 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    old($Heap), 
                                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          old($Heap), 
                                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#26)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read(old($Heap), 
                                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#26)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue)
                           != null
                         ==> (forall ref#27: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    old($Heap), 
                                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)] } 
                            { LruModel.__default.I(read(old($Heap), 
                                read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#27)] } 
                          LitInt(0) <= ref#27
                               && ref#27 < 18446744073709551616
                               && LruModel.__default.I(read(old($Heap), 
                                  read(old($Heap), this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#27)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    old($Heap), 
                                    read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          old($Heap), 
                                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#27)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      read(old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#28: int :: 
                        { Map#Domain(graph#6)[$Box(ref#28)] } 
                        LitInt(0) <= ref#28
                             && ref#28 < 18446744073709551616
                             && Map#Domain(graph#6)[$Box(ref#28)]
                           ==> ref#28
                             <= read(old($Heap), this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall(old($Heap), this)
               ==> IndirectionTableImpl.IndirectionTable.Inv(old($Heap), this)
                 || (var predCounts#6 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        old($Heap), 
                        read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#6 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          old($Heap), 
                          read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#6 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            old($Heap), 
                            read(old($Heap), this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#8: int :: 
                          { Map#Domain(locs#6)[$Box(r#8)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#8)] } 
                          LitInt(0) <= r#8
                               && r#8 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read(old($Heap), this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#8)]
                             ==> Map#Domain(locs#6)[$Box(r#8)]))));
            assume IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
            ##self#2 := IndirectionTableImpl.IndirectionTable.I(old($Heap), this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#2, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#2);
            assume IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this));
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
                IndirectionTableImpl.IndirectionTable.I(old($Heap), this)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
                  Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                      read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                        MutableMap.ResizingHashMap.Repr)), 
                    (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                       then read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Repr)
                       else Set#Empty(): Set Box)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || !read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Repr)[$Box(this)];
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> Set#Disjoint(read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                      LruImpl.LruImplQueue.Repr), 
                    read($Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                      MutableMap.ResizingHashMap.Repr)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> !read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                    LruImpl.LruImplQueue.Repr)[$Box(this)]);
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  Lit(true));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    Lit(true)));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      IndirectionTableModel.__default.ValidPredCounts(predCounts#7, graph#7))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      BlockCache.__default.GraphClosed(graph#7))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#29: int :: 
                        { $Unbox(Map#Elements(graph#7)[$Box(ref#29)]): Seq Box } 
                          { Map#Domain(graph#7)[$Box(ref#29)] } 
                        LitInt(0) <= ref#29
                             && ref#29 < 18446744073709551616
                             && Map#Domain(graph#7)[$Box(ref#29)]
                           ==> Seq#Length($Unbox(Map#Elements(graph#7)[$Box(ref#29)]): Seq Box)
                             <= LitInt(Bounds.__default.MaxNumChildren())))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#30: int :: 
                          { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#30)] } 
                            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)] } 
                          LitInt(0) <= ref#30
                               && ref#30 < 18446744073709551616
                               && 
                              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#30)]): DatatypeType)
                                 == LitInt(0)
                             ==> LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#30)]))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                         ==> (forall ref#31: int :: 
                          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)]): DatatypeType } 
                            { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)] } 
                            { LruModel.__default.I(read($Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                LruImpl.LruImplQueue.Queue))[$Box(ref#31)] } 
                          LitInt(0) <= ref#31
                               && ref#31 < 18446744073709551616
                               && LruModel.__default.I(read($Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                                  LruImpl.LruImplQueue.Queue))[$Box(ref#31)]
                             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                    $Heap, 
                                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                          $Heap, 
                                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#31)]): DatatypeType)
                                 == LitInt(0)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                          MutableMap.ResizingHashMap.Count)
                         <= LitInt(IndirectionTableModel.__default.MaxSize()))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      (forall ref#32: int :: 
                        { Map#Domain(graph#7)[$Box(ref#32)] } 
                        LitInt(0) <= ref#32
                             && ref#32 < 18446744073709551616
                             && Map#Domain(graph#7)[$Box(ref#32)]
                           ==> ref#32 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                          MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                          $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
            assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
               ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
                 || (var predCounts#7 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                  (var graph#7 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                    (var locs#7 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
                      Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                         ==> (forall r#9: int :: 
                          { Map#Domain(locs#7)[$Box(r#9)] } 
                            { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#9)] } 
                          LitInt(0) <= r#9
                               && r#9 < 18446744073709551616
                               && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#9)]
                             ==> Map#Domain(locs#7)[$Box(r#9)]))));
            assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
            assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
            ##self#3 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
            // assume allocatedness for argument to function
            assume $IsAlloc(##self#3, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
            ##it#1 := it#0;
            // assume allocatedness for argument to function
            assume $IsAlloc(##it#1, Tclass.MutableMapModel.SimpleIterator(), $Heap);
            assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#3);
            assert {:subsumption 0} MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(##self#3), 
              ##it#1);
            assert {:subsumption 0} (forall r#10: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(##self#3))[$Box(r#10)] } 
                { MutableMapModel.SimpleIterator.s(##it#1)[$Box(r#10)] } 
              LitInt(0) <= r#10
                   && r#10 < 18446744073709551616
                   && MutableMapModel.SimpleIterator.s(##it#1)[$Box(r#10)]
                 ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(##self#3))[$Box(r#10)]);
            assume IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0);
            assume _System.Tuple2.___hMake2_q(IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0));
            assume $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
                  IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
               && $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0))
               && 
              IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
               && IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this))
               && 
              IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
               && IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0);
            assume _System.Tuple2#Equal(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
                IndirectionTableImpl.IndirectionTable.I(old($Heap), this)), 
              IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0));
            assert $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), old($Heap));
            assume true;
            assume Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
              read(old($Heap), this, IndirectionTableImpl.IndirectionTable.Repr));
            assume MutableMapModel.SimpleIterator.SimpleIterator_q(it#0);
            assume MutableMapModel.SimpleIterator.SimpleIterator_q(it#0);
            assume false;
        }

        assume true;
        if (!Lit(true))
        {
            break;
        }

        $decr$loop#00 := MutableMapModel.SimpleIterator.decreaser(it#0);
        // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1193,44)
        assume true;
        // TrCallStmt: Adding lhs Microsoft.Dafny.AutoGhostIdentifierExpr with type IteratorOutput<IndirectionTableModel.Entry>
        // TrCallStmt: Before ProcessCallStmt
        assume true;
        assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
        assume true;
        // ProcessCallStmt: CheckSubrange
        it##1_0 := it#0;
        assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
        // ProcessCallStmt: Make the call
        call $rhs##1_0 := Call$$MutableMap.ResizingHashMap.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##1_0);
        // TrCallStmt: After ProcessCallStmt
        next#1_0 := $rhs##1_0;
        assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1193,47)"} true;
        // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1194,9)
        assume true;
        if (MutableMapModel.IteratorOutput.Next_q(next#1_0))
        {
            // ----- if statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1195,11)
            assert MutableMapModel.IteratorOutput.Next_q(next#1_0);
            assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(next#1_0)): DatatypeType);
            assume IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(next#1_0)): DatatypeType);
            if (Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#1_0)): DatatypeType)))
            {
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1196,38)
                assume true;
                assert $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
                assume true;
                $rhs#1_0_0_0 := #Options.Option.Some($Box(it#0));
                $Heap := update($Heap, 
                  this, 
                  IndirectionTableImpl.IndirectionTable.findLoclessIterator, 
                  $rhs#1_0_0_0);
                assume $IsGoodHeap($Heap);
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1196,48)"} true;
                // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1197,13)
                // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1197,13)
                assume true;
                assert MutableMapModel.IteratorOutput.Next_q(next#1_0);
                assume true;
                ref#0 := #Options.Option.Some($Box(MutableMapModel.IteratorOutput.key(next#1_0)));
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1197,33)"} true;
                return;
            }
            else
            {
                // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1199,39)
                assume true;
                // TrCallStmt: Adding lhs Microsoft.Dafny.IdentifierExpr with type MutableMapModel.SimpleIterator
                // TrCallStmt: Before ProcessCallStmt
                assume true;
                assert read($Heap, this, IndirectionTableImpl.IndirectionTable.t) != null;
                assume true;
                // ProcessCallStmt: CheckSubrange
                it##1_0_0 := it#0;
                assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
                // ProcessCallStmt: Make the call
                call $rhs##1_0_0 := Call$$MutableMap.ResizingHashMap.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), read($Heap, this, IndirectionTableImpl.IndirectionTable.t), it##1_0_0);
                // TrCallStmt: After ProcessCallStmt
                it#0 := $rhs##1_0_0;
                assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1199,42)"} true;
            }
        }
        else
        {
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1202,36)
            assume true;
            assert $_Frame[this, IndirectionTableImpl.IndirectionTable.findLoclessIterator];
            assume true;
            $rhs#1_0 := #Options.Option.Some($Box(it#0));
            $Heap := update($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator, $rhs#1_0);
            assume $IsGoodHeap($Heap);
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1202,46)"} true;
            // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1203,11)
            // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1203,11)
            assume true;
            assume true;
            ref#0 := Lit(#Options.Option.None());
            assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1203,21)"} true;
            return;
        }

        // ----- loop termination check ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1184,7)
        assert ORD#Less(MutableMapModel.SimpleIterator.decreaser(it#0), $decr$loop#00);
        assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
        assume MutableMap.ResizingHashMap.I#canCall(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
           && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
            MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
              $Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
            it#0);
        assume (forall r#7: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.locs(IndirectionTableImpl.IndirectionTable.I($Heap, this)))[$Box(r#7)] } 
            { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)] } 
          LitInt(0) <= r#7 && r#7 < 18446744073709551616
             ==> MutableMapModel.SimpleIterator.SimpleIterator_q(it#0)
               && (MutableMapModel.SimpleIterator.s(it#0)[$Box(r#7)]
                 ==> IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this))));
        assume $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLoc(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc, 
              IndirectionTableImpl.IndirectionTable.I(old($Heap), this)))
           && $IsA#_System.Tuple2(IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall(old($Heap), this)
           && IndirectionTableModel.__default.FindRefWithNoLoc#canCall(IndirectionTableImpl.IndirectionTable.I(old($Heap), this))
           && 
          IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
           && IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this), it#0);
        assume true;
    }
}



procedure CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (r#0: int where LitInt(0) <= r#0 && r#0 < 18446744073709551616);
  free requires 48 == $FunctionContextHeight;
  modifies $Heap, $Tick;



implementation CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound(this: ref) returns (r#0: int)
{
  var $_Frame: <beta>[ref,Field beta]bool;
  var ##self#0: DatatypeType;

    // AddMethodImpl: GetRefUpperBound, CheckWellformed$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1208,11): initial state"} true;
    assume IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    havoc $Heap;
    assume (forall $o: ref :: 
      { $Heap[$o] } 
      $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
    assume $HeapSucc(old($Heap), $Heap);
    havoc r#0;
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1210,14): post-state"} true;
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
          Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                MutableMap.ResizingHashMap.Repr)), 
            (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
               then read($Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                LruImpl.LruImplQueue.Repr)
               else Set#Empty(): Set Box)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || !read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)[$Box(this)];
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
          $Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> Set#Disjoint(read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
              LruImpl.LruImplQueue.Repr), 
            read($Heap, 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
              MutableMap.ResizingHashMap.Repr)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           ==> !read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)[$Box(this)]);
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          Lit(true));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            Lit(true)));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              BlockCache.__default.GraphClosed(graph#0))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#0: int :: 
                { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
                  { Map#Domain(graph#0)[$Box(ref#0)] } 
                LitInt(0) <= ref#0
                     && ref#0 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#0)]
                   ==> Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                     <= LitInt(Bounds.__default.MaxNumChildren())))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#1: int :: 
                  { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#1)]))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                 ==> (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                          $Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)] } 
                    { LruModel.__default.I(read($Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                        LruImpl.LruImplQueue.Queue))[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I(read($Heap, 
                          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                          LruImpl.LruImplQueue.Queue))[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                            $Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                  $Heap, 
                                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())])));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              read($Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                  MutableMap.ResizingHashMap.Count)
                 <= LitInt(IndirectionTableModel.__default.MaxSize()))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              (forall ref#3: int :: 
                { Map#Domain(graph#0)[$Box(ref#3)] } 
                LitInt(0) <= ref#3
                     && ref#3 < 18446744073709551616
                     && Map#Domain(graph#0)[$Box(ref#3)]
                   ==> ref#3 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound)))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                  $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType))));
    assert {:subsumption 0} IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
       ==> IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
         || (var predCounts#0 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          (var graph#0 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                  $Heap, 
                  read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
            (var locs#0 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                 ==> (forall r#1: int :: 
                  { Map#Domain(locs#0)[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#1)]
                     ==> Map#Domain(locs#0)[$Box(r#1)]))));
    assume IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
    assume IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this);
    assume IndirectionTableModel.IndirectionTable.IndirectionTable_q(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    ##self#0 := IndirectionTableImpl.IndirectionTable.I($Heap, this);
    // assume allocatedness for argument to function
    assume $IsAlloc(##self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap);
    assert {:subsumption 0} IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.Inv(##self#0);
    assume IndirectionTableModel.__default.getRefUpperBound#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
    assume r#0
       == IndirectionTableModel.__default.getRefUpperBound(StartFuel_IndirectionTableModel._default.getRefUpperBound, 
        IndirectionTableImpl.IndirectionTable.I($Heap, this));
}



procedure Call$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (r#0: int where LitInt(0) <= r#0 && r#0 < 18446744073709551616);
  // user-defined preconditions
  requires IndirectionTableImpl.IndirectionTable.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.getRefUpperBound#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures r#0
     == IndirectionTableModel.__default.getRefUpperBound(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure Impl$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound(this: ref
       where this != null
         && 
        $Is(this, Tclass.IndirectionTableImpl.IndirectionTable())
         && $IsAlloc(this, Tclass.IndirectionTableImpl.IndirectionTable(), $Heap))
   returns (r#0: int where LitInt(0) <= r#0 && r#0 < 18446744073709551616, 
    $_reverifyPost: bool);
  free requires 48 == $FunctionContextHeight;
  // user-defined preconditions
  free requires IndirectionTableImpl.IndirectionTable.Inv#canCall($Heap, this)
     && 
    IndirectionTableImpl.IndirectionTable.Inv($Heap, this)
     && 
    read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(this)]
     && read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.t))]
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr)[$Box(read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue))])
     && Set#Equal(read($Heap, this, IndirectionTableImpl.IndirectionTable.Repr), 
      Set#Union(Set#Union(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
          read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
            MutableMap.ResizingHashMap.Repr)), 
        (if read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
           then read($Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
            LruImpl.LruImplQueue.Repr)
           else Set#Empty(): Set Box)))
     && !read($Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
      MutableMap.ResizingHashMap.Repr)[$Box(this)]
     && MutableMap.ResizingHashMap.Inv(Tclass.IndirectionTableModel.Entry(), 
      $Heap, 
      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> LruImpl.LruImplQueue.Inv($Heap, read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> Set#Disjoint(read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
          LruImpl.LruImplQueue.Repr), 
        read($Heap, 
          read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
          MutableMap.ResizingHashMap.Repr)))
     && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
       ==> !read($Heap, 
        read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
        LruImpl.LruImplQueue.Repr)[$Box(this)])
     && (var predCounts#1 := IndirectionTableModel.__default.PredCounts(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
            $Heap, 
            read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
      true
         && (var graph#1 := IndirectionTableModel.__default.Graph(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                $Heap, 
                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
          true
             && (var locs#1 := IndirectionTableModel.__default.Locs(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                    $Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t))); 
              IndirectionTableModel.__default.ValidPredCounts(predCounts#1, graph#1)
                 && BlockCache.__default.GraphClosed(graph#1)
                 && (forall ref#4: int :: 
                  { $Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box } 
                    { Map#Domain(graph#1)[$Box(ref#4)] } 
                  LitInt(0) <= ref#4
                       && ref#4 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#4)]
                     ==> Seq#Length($Unbox(Map#Elements(graph#1)[$Box(ref#4)]): Seq Box)
                       <= LitInt(Bounds.__default.MaxNumChildren()))
                 && (read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue) != null
                   ==> (forall ref#5: int :: 
                      { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#5)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)] } 
                      LitInt(0) <= ref#5
                           && ref#5 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#5)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#5)])
                     && (forall ref#6: int :: 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                              $Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)] } 
                        { LruModel.__default.I(read($Heap, 
                            read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                            LruImpl.LruImplQueue.Queue))[$Box(ref#6)] } 
                      LitInt(0) <= ref#6
                           && ref#6 < 18446744073709551616
                           && LruModel.__default.I(read($Heap, 
                              read($Heap, this, IndirectionTableImpl.IndirectionTable.garbageQueue), 
                              LruImpl.LruImplQueue.Queue))[$Box(ref#6)]
                         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                $Heap, 
                                read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                                      $Heap, 
                                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(ref#6)]): DatatypeType)
                             == LitInt(0)))
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                      $Heap, 
                      read($Heap, this, IndirectionTableImpl.IndirectionTable.t))))[$Box(PivotBetreeGraph.__default.Root())]
                 && read($Heap, 
                    read($Heap, this, IndirectionTableImpl.IndirectionTable.t), 
                    MutableMap.ResizingHashMap.Count)
                   <= LitInt(IndirectionTableModel.__default.MaxSize())
                 && (forall ref#7: int :: 
                  { Map#Domain(graph#1)[$Box(ref#7)] } 
                  LitInt(0) <= ref#7
                       && ref#7 < 18446744073709551616
                       && Map#Domain(graph#1)[$Box(ref#7)]
                     ==> ref#7 <= read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound))
                 && (Options.Option.Some_q(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))
                   ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                      MutableMap.ResizingHashMap.I(Tclass.IndirectionTableModel.Entry(), 
                        $Heap, 
                        read($Heap, this, IndirectionTableImpl.IndirectionTable.t)), 
                      $Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)
                     && (forall r#2: int :: 
                      { Map#Domain(locs#1)[$Box(r#2)] } 
                        { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)] } 
                      LitInt(0) <= r#2
                           && r#2 < 18446744073709551616
                           && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(read($Heap, this, IndirectionTableImpl.IndirectionTable.findLoclessIterator))): DatatypeType)[$Box(r#2)]
                         ==> Map#Domain(locs#1)[$Box(r#2)])))));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableImpl.IndirectionTable.I#canCall($Heap, this)
     && IndirectionTableModel.__default.getRefUpperBound#canCall(IndirectionTableImpl.IndirectionTable.I($Heap, this));
  ensures r#0
     == IndirectionTableModel.__default.getRefUpperBound(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound, 
      IndirectionTableImpl.IndirectionTable.I($Heap, this));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



implementation Impl$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound(this: ref) returns (r#0: int, $_reverifyPost: bool)
{
  var $_Frame: <beta>[ref,Field beta]bool;

    // AddMethodImpl: GetRefUpperBound, Impl$$IndirectionTableImpl.IndirectionTable.GetRefUpperBound
    // initialize fuel constant
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove)
       == StartFuel_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove)
       == StartFuelAssert_Maps._default.MapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemoveStrong)
       == StartFuel_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemoveStrong)
       == StartFuelAssert_Maps._default.MapRemoveStrong;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1)
       == StartFuel_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1)
       == StartFuelAssert_Maps._default.MapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapRemove1Strong)
       == StartFuel_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapRemove1Strong)
       == StartFuelAssert_Maps._default.MapRemove1Strong;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove)
       == StartFuel_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove)
       == StartFuelAssert_Maps._default.IMapRemove;
    assume AsFuelBottom(StartFuel_Maps._default.IMapRemove1)
       == StartFuel_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapRemove1)
       == StartFuelAssert_Maps._default.IMapRemove1;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion)
       == StartFuel_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion)
       == StartFuelAssert_Maps._default.MapDisjointUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferA)
       == StartFuel_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferA)
       == StartFuelAssert_Maps._default.MapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnionPreferB)
       == StartFuel_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnionPreferB)
       == StartFuelAssert_Maps._default.MapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.MapUnion)
       == StartFuel_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapUnion)
       == StartFuelAssert_Maps._default.MapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferA)
       == StartFuel_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferA)
       == StartFuelAssert_Maps._default.IMapUnionPreferA;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnionPreferB)
       == StartFuel_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnionPreferB)
       == StartFuelAssert_Maps._default.IMapUnionPreferB;
    assume AsFuelBottom(StartFuel_Maps._default.IMapUnion)
       == StartFuel_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuelAssert_Maps._default.IMapUnion)
       == StartFuelAssert_Maps._default.IMapUnion;
    assume AsFuelBottom(StartFuel_Maps._default.MapDisjointUnion3)
       == StartFuel_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuelAssert_Maps._default.MapDisjointUnion3)
       == StartFuelAssert_Maps._default.MapDisjointUnion3;
    assume AsFuelBottom(StartFuel_Sequences._default.NoDupes)
       == StartFuel_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.NoDupes)
       == StartFuelAssert_Sequences._default.NoDupes;
    assume AsFuelBottom(StartFuel_Sequences._default.Range)
       == StartFuel_Sequences._default.Range;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Range)
       == StartFuelAssert_Sequences._default.Range;
    assume AsFuelBottom(StartFuel_Sequences._default.ApplyOpaque)
       == StartFuel_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.ApplyOpaque)
       == StartFuelAssert_Sequences._default.ApplyOpaque;
    assume AsFuelBottom(StartFuel_Sequences._default.remove)
       == StartFuel_Sequences._default.remove;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.remove)
       == StartFuelAssert_Sequences._default.remove;
    assume AsFuelBottom(StartFuel_Sequences._default.insert)
       == StartFuel_Sequences._default.insert;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.insert)
       == StartFuelAssert_Sequences._default.insert;
    assume AsFuelBottom(StartFuel_Sequences._default.replace1with2)
       == StartFuel_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace1with2)
       == StartFuelAssert_Sequences._default.replace1with2;
    assume AsFuelBottom(StartFuel_Sequences._default.replace2with1)
       == StartFuel_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.replace2with1)
       == StartFuelAssert_Sequences._default.replace2with1;
    assume AsFuelBottom(StartFuel_Sequences._default.concat)
       == StartFuel_Sequences._default.concat;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat)
       == StartFuelAssert_Sequences._default.concat;
    assume AsFuelBottom(StartFuel_Sequences._default.concat3)
       == StartFuel_Sequences._default.concat3;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concat3)
       == StartFuelAssert_Sequences._default.concat3;
    assume AsFuelBottom(StartFuel_Sequences._default.concatSeq)
       == StartFuel_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.concatSeq)
       == StartFuelAssert_Sequences._default.concatSeq;
    assume AsFuelBottom(StartFuel_Sequences._default.IsPrefix)
       == StartFuel_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsPrefix)
       == StartFuelAssert_Sequences._default.IsPrefix;
    assume AsFuelBottom(StartFuel_Sequences._default.IsSuffix)
       == StartFuel_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.IsSuffix)
       == StartFuelAssert_Sequences._default.IsSuffix;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexIterate)
       == StartFuel_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexIterate)
       == StartFuelAssert_Sequences._default.SeqIndexIterate;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndex)
       == StartFuel_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndex)
       == StartFuelAssert_Sequences._default.SeqIndex;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqOfLength)
       == StartFuel_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqOfLength)
       == StartFuelAssert_Sequences._default.SeqOfLength;
    assume AsFuelBottom(StartFuel_Sequences._default.SeqIndexUpdate)
       == StartFuel_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.SeqIndexUpdate)
       == StartFuelAssert_Sequences._default.SeqIndexUpdate;
    assume AsFuelBottom(StartFuel_Sequences._default.Zip)
       == StartFuel_Sequences._default.Zip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Zip)
       == StartFuelAssert_Sequences._default.Zip;
    assume AsFuelBottom(StartFuel_Sequences._default.Unzip)
       == StartFuel_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Unzip)
       == StartFuelAssert_Sequences._default.Unzip;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenShape)
       == StartFuel_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenShape)
       == StartFuelAssert_Sequences._default.FlattenShape;
    assume AsFuelBottom(StartFuel_Sequences._default.FlattenLength)
       == StartFuel_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.FlattenLength)
       == StartFuelAssert_Sequences._default.FlattenLength;
    assume AsFuelBottom(StartFuel_Sequences._default.Flatten)
       == StartFuel_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.Flatten)
       == StartFuelAssert_Sequences._default.Flatten;
    assume AsFuelBottom(StartFuel_Sequences._default.fill)
       == StartFuel_Sequences._default.fill;
    assume AsFuelBottom(StartFuelAssert_Sequences._default.fill)
       == StartFuelAssert_Sequences._default.fill;
    assume AsFuelBottom(StartFuel_SeqComparison._default.lte)
       == StartFuel_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuelAssert_SeqComparison._default.lte)
       == StartFuelAssert_SeqComparison._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.lte)
       == StartFuel_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.lte)
       == StartFuelAssert_Byte_Order._default.lte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.ltedef)
       == StartFuel_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.ltedef)
       == StartFuelAssert_Byte_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.NotMinimum)
       == StartFuel_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimum)
       == StartFuel_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimum)
       == StartFuelAssert_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.minimumOpt)
       == StartFuel_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximum)
       == StartFuel_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximum)
       == StartFuelAssert_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Byte_Order._default.maximumOpt)
       == StartFuel_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsSorted)
       == StartFuel_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsSorted)
       == StartFuelAssert_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuel_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuel_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap)
       == StartFuelAssert_Lexicographic_Byte_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimum)
       == StartFuel_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximum)
       == StartFuel_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximum)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuel_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt)
       == StartFuelAssert_Lexicographic_Byte_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted)
       == StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForLeft)
       == StartFuel_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForLeft)
       == StartFuelAssert_PivotsLib._default.CutoffForLeft;
    assume AsFuelBottom(StartFuel_PivotsLib._default.CutoffForRight)
       == StartFuel_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuelAssert_PivotsLib._default.CutoffForRight)
       == StartFuelAssert_PivotsLib._default.CutoffForRight;
    assume AsFuelBottom(StartFuel_Multisets._default.Choose)
       == StartFuel_Multisets._default.Choose;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Choose)
       == StartFuelAssert_Multisets._default.Choose;
    assume AsFuelBottom(StartFuel_Multisets._default.Apply)
       == StartFuel_Multisets._default.Apply;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Apply)
       == StartFuelAssert_Multisets._default.Apply;
    assume AsFuelBottom(StartFuel_Multisets._default.Fold)
       == StartFuel_Multisets._default.Fold;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.Fold)
       == StartFuelAssert_Multisets._default.Fold;
    assume AsFuelBottom(StartFuel_Multisets._default.IsIdentity)
       == StartFuel_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsIdentity)
       == StartFuelAssert_Multisets._default.IsIdentity;
    assume AsFuelBottom(StartFuel_Multisets._default.IsCommutative)
       == StartFuel_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsCommutative)
       == StartFuelAssert_Multisets._default.IsCommutative;
    assume AsFuelBottom(StartFuel_Multisets._default.IsAssociative)
       == StartFuel_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuelAssert_Multisets._default.IsAssociative)
       == StartFuelAssert_Multisets._default.IsAssociative;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketMapOfSeq)
       == StartFuel_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketMapOfSeq)
       == StartFuelAssert_BucketsLib._default.BucketMapOfSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.B) == StartFuel_BucketsLib._default.B;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.B)
       == StartFuelAssert_BucketsLib._default.B;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketIntersect)
       == StartFuel_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketIntersect)
       == StartFuelAssert_BucketsLib._default.BucketIntersect;
    assume AsFuelBottom(StartFuel_BucketsLib._default.BucketComplement)
       == StartFuel_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.BucketComplement)
       == StartFuelAssert_BucketsLib._default.BucketComplement;
    assume AsFuelBottom(StartFuel_BucketsLib._default.Compose)
       == StartFuel_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.Compose)
       == StartFuelAssert_BucketsLib._default.Compose;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ComposeSeq)
       == StartFuel_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ComposeSeq)
       == StartFuelAssert_BucketsLib._default.ComposeSeq;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampRange)
       == StartFuel_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampRange)
       == StartFuelAssert_BucketsLib._default.ClampRange;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampStart)
       == StartFuel_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampStart)
       == StartFuelAssert_BucketsLib._default.ClampStart;
    assume AsFuelBottom(StartFuel_BucketsLib._default.ClampEnd)
       == StartFuel_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.ClampEnd)
       == StartFuelAssert_BucketsLib._default.ClampEnd;
    assume AsFuelBottom(StartFuel_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuel_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket)
       == StartFuelAssert_BucketsLib._default.KeyValueMapOfBucket;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap)
       == StartFuelAssert_BucketsLib._default.SortedSeqOfKeyValueMap;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketLeft)
       == StartFuel_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketLeft)
       == StartFuelAssert_BucketsLib._default.SplitBucketLeft;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketRight)
       == StartFuel_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketRight)
       == StartFuelAssert_BucketsLib._default.SplitBucketRight;
    assume AsFuelBottom(StartFuel_BucketsLib._default.SplitBucketInList)
       == StartFuel_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.SplitBucketInList)
       == StartFuelAssert_BucketsLib._default.SplitBucketInList;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBuckets)
       == StartFuel_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBuckets)
       == StartFuelAssert_BucketsLib._default.MergeBuckets;
    assume AsFuelBottom(StartFuel_BucketsLib._default.MergeBucketsInList)
       == StartFuel_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuelAssert_BucketsLib._default.MergeBucketsInList)
       == StartFuelAssert_BucketsLib._default.MergeBucketsInList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeyMultiset)
       == StartFuel_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeyMultiset)
       == StartFuelAssert_BucketWeights._default.WeightKeyMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightKeySeq)
       == StartFuel_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightKeySeq)
       == StartFuelAssert_BucketWeights._default.WeightKeySeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageMultiset)
       == StartFuel_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageMultiset)
       == StartFuelAssert_BucketWeights._default.WeightMessageMultiset;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightMessageSeq)
       == StartFuel_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightMessageSeq)
       == StartFuelAssert_BucketWeights._default.WeightMessageSeq;
    assume AsFuelBottom(StartFuel_BucketWeights._default.WeightBucketList)
       == StartFuel_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.WeightBucketList)
       == StartFuelAssert_BucketWeights._default.WeightBucketList;
    assume AsFuelBottom(StartFuel_BucketWeights._default.Image)
       == StartFuel_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuelAssert_BucketWeights._default.Image)
       == StartFuelAssert_BucketWeights._default.Image;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuel_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound)
       == StartFuelAssert_PivotBetreeSpec._default.LookupUpperBound;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepLeft;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNodeAndKeepRight;
    assume AsFuelBottom(StartFuel_PivotBetreeSpec._default.CutoffNode)
       == StartFuel_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuelAssert_PivotBetreeSpec._default.CutoffNode)
       == StartFuelAssert_PivotBetreeSpec._default.CutoffNode;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidNodeAddr)
       == StartFuel_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidNodeAddr)
       == StartFuelAssert_DiskLayout._default.ValidNodeAddr;
    assume AsFuelBottom(StartFuel_DiskLayout._default.ValidJournalLocation)
       == StartFuel_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.ValidJournalLocation)
       == StartFuelAssert_DiskLayout._default.ValidJournalLocation;
    assume AsFuelBottom(StartFuel_DiskLayout._default.JournalBlockIdx)
       == StartFuel_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuelAssert_DiskLayout._default.JournalBlockIdx)
       == StartFuelAssert_DiskLayout._default.JournalBlockIdx;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint32_Seq;
    assume AsFuelBottom(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq)
       == StartFuelAssert_NativePackedInts._default.unpack_LittleEndian_Uint64_Seq;
    assume AsFuelBottom(StartFuel_BlockCache._default.OpTransaction)
       == StartFuel_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuelAssert_BlockCache._default.OpTransaction)
       == StartFuelAssert_BlockCache._default.OpTransaction;
    assume AsFuelBottom(StartFuel_LruModel._default.distinct)
       == StartFuel_LruModel._default.distinct;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.distinct)
       == StartFuelAssert_LruModel._default.distinct;
    assume AsFuelBottom(StartFuel_LruModel._default.NextOpt)
       == StartFuel_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuelAssert_LruModel._default.NextOpt)
       == StartFuelAssert_LruModel._default.NextOpt;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.lshift)
       == StartFuel_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.lshift)
       == StartFuelAssert_MutableMapModel._default.lshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.rshift)
       == StartFuel_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.rshift)
       == StartFuelAssert_MutableMapModel._default.rshift;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitnot)
       == StartFuel_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitnot)
       == StartFuelAssert_MutableMapModel._default.bitnot;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.bitxor)
       == StartFuel_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.bitxor)
       == StartFuelAssert_MutableMapModel._default.bitxor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.hash64)
       == StartFuel_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.hash64)
       == StartFuelAssert_MutableMapModel._default.hash64;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.getEmptyWitness)
       == StartFuel_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.getEmptyWitness)
       == StartFuelAssert_MutableMapModel._default.getEmptyWitness;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Probe)
       == StartFuel_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Probe)
       == StartFuelAssert_MutableMapModel._default.Probe;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeInsert)
       == StartFuel_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeInsert)
       == StartFuelAssert_MutableMapModel._default.FixedSizeInsert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeGet)
       == StartFuel_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeGet)
       == StartFuelAssert_MutableMapModel._default.FixedSizeGet;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FixedSizeRemove)
       == StartFuel_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FixedSizeRemove)
       == StartFuelAssert_MutableMapModel._default.FixedSizeRemove;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Constructor)
       == StartFuel_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Constructor)
       == StartFuelAssert_MutableMapModel._default.Constructor;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.ReallocInternal)
       == StartFuel_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.ReallocInternal)
       == StartFuelAssert_MutableMapModel._default.ReallocInternal;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.InsertAndGetOld)
       == StartFuel_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.InsertAndGetOld)
       == StartFuelAssert_MutableMapModel._default.InsertAndGetOld;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.Insert)
       == StartFuel_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.Insert)
       == StartFuelAssert_MutableMapModel._default.Insert;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterStart)
       == StartFuel_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterStart)
       == StartFuelAssert_MutableMapModel._default.IterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterStart)
       == StartFuel_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterStart)
       == StartFuelAssert_MutableMapModel._default.SimpleIterStart;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.IterInc)
       == StartFuel_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.IterInc)
       == StartFuelAssert_MutableMapModel._default.IterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.SimpleIterInc)
       == StartFuel_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.SimpleIterInc)
       == StartFuelAssert_MutableMapModel._default.SimpleIterInc;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.MaxKey)
       == StartFuel_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.MaxKey)
       == StartFuelAssert_MutableMapModel._default.MaxKey;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.UpdateByIter)
       == StartFuel_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.UpdateByIter)
       == StartFuelAssert_MutableMapModel._default.UpdateByIter;
    assume AsFuelBottom(StartFuel_MutableMapModel._default.FindSimpleIter)
       == StartFuel_MutableMapModel._default.FindSimpleIter;
    assume AsFuelBottom(StartFuelAssert_MutableMapModel._default.FindSimpleIter)
       == StartFuelAssert_MutableMapModel._default.FindSimpleIter;
    assume StartFuel_GenericMarshalling._default.ValInGrammar
       == $LS(BaseFuel_GenericMarshalling._default.ValInGrammar);
    assume StartFuelAssert_GenericMarshalling._default.ValInGrammar
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValInGrammar));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValInGrammar)
       == BaseFuel_GenericMarshalling._default.ValInGrammar;
    assume StartFuel_GenericMarshalling._default.ValidVal
       == $LS(BaseFuel_GenericMarshalling._default.ValidVal);
    assume StartFuelAssert_GenericMarshalling._default.ValidVal
       == $LS($LS(BaseFuel_GenericMarshalling._default.ValidVal));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.ValidVal)
       == BaseFuel_GenericMarshalling._default.ValidVal;
    assume AsFuelBottom(StartFuel_GenericMarshalling._default.SeqSum)
       == StartFuel_GenericMarshalling._default.SeqSum;
    assume AsFuelBottom(StartFuelAssert_GenericMarshalling._default.SeqSum)
       == StartFuelAssert_GenericMarshalling._default.SeqSum;
    assume StartFuel_GenericMarshalling._default.SizeOfV
       == $LS(BaseFuel_GenericMarshalling._default.SizeOfV);
    assume StartFuelAssert_GenericMarshalling._default.SizeOfV
       == $LS($LS(BaseFuel_GenericMarshalling._default.SizeOfV));
    assume AsFuelBottom(BaseFuel_GenericMarshalling._default.SizeOfV)
       == BaseFuel_GenericMarshalling._default.SizeOfV;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit)
       == StartFuel_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit)
       == StartFuelAssert_BitsetLemmas._default.bit;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_and)
       == StartFuel_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_and)
       == StartFuelAssert_BitsetLemmas._default.bit_and;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or)
       == StartFuel_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or)
       == StartFuelAssert_BitsetLemmas._default.bit_or;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_comp)
       == StartFuel_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_comp)
       == StartFuelAssert_BitsetLemmas._default.bit_comp;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set)
       == StartFuel_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set)
       == StartFuelAssert_BitsetLemmas._default.in_set;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1)
       == StartFuel_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0)
       == StartFuel_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.bit_or_uint64)
       == StartFuel_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.bit_or_uint64)
       == StartFuelAssert_BitsetLemmas._default.bit_or_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.in_set_uint64)
       == StartFuel_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.in_set_uint64)
       == StartFuelAssert_BitsetLemmas._default.in_set_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_1_uint64;
    assume AsFuelBottom(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuel_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64)
       == StartFuelAssert_BitsetLemmas._default.set_bit_to_0_uint64;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitSet)
       == StartFuel_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitSet)
       == StartFuelAssert_BitmapModel._default.BitSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnset)
       == StartFuel_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnset)
       == StartFuelAssert_BitmapModel._default.BitUnset;
    assume AsFuelBottom(StartFuel_BitmapModel._default.IsSet)
       == StartFuel_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.IsSet)
       == StartFuelAssert_BitmapModel._default.IsSet;
    assume AsFuelBottom(StartFuel_BitmapModel._default.EmptyBitmap)
       == StartFuel_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.EmptyBitmap)
       == StartFuelAssert_BitmapModel._default.EmptyBitmap;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitAlloc)
       == StartFuel_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitAlloc)
       == StartFuelAssert_BitmapModel._default.BitAlloc;
    assume AsFuelBottom(StartFuel_BitmapModel._default.BitUnion)
       == StartFuel_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuelAssert_BitmapModel._default.BitUnion)
       == StartFuelAssert_BitmapModel._default.BitUnion;
    assume AsFuelBottom(StartFuel_BitmapImpl.Bitmap.IPrefix)
       == StartFuel_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuelAssert_BitmapImpl.Bitmap.IPrefix)
       == StartFuelAssert_BitmapImpl.Bitmap.IPrefix;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.JournalUpdate)
       == StartFuel_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.JournalUpdate)
       == StartFuelAssert_JournalIntervals._default.JournalUpdate;
    assume AsFuelBottom(StartFuel_JournalIntervals._default.CyclicSlice)
       == StartFuel_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuelAssert_JournalIntervals._default.CyclicSlice)
       == StartFuelAssert_JournalIntervals._default.CyclicSlice;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.ltedef)
       == StartFuel_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.ltedef)
       == StartFuelAssert_Uint32_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Uint32_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.NotMinimum)
       == StartFuel_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.NotMinimum)
       == StartFuelAssert_Uint32_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.SortedSeqForMap)
       == StartFuel_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.SortedSeqForMap)
       == StartFuelAssert_Uint32_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimum)
       == StartFuel_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimum)
       == StartFuelAssert_Uint32_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.minimumOpt)
       == StartFuel_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.minimumOpt)
       == StartFuelAssert_Uint32_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximum)
       == StartFuel_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximum)
       == StartFuelAssert_Uint32_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.maximumOpt)
       == StartFuel_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.maximumOpt)
       == StartFuelAssert_Uint32_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsSorted)
       == StartFuel_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsSorted)
       == StartFuelAssert_Uint32_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Uint32_Order._default.IsStrictlySorted)
       == StartFuel_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Uint32_Order._default.IsStrictlySorted)
       == StartFuelAssert_Uint32_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedStringArray._default.psaSeq)
       == StartFuel_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuelAssert_PackedStringArray._default.psaSeq)
       == StartFuelAssert_PackedStringArray._default.psaSeq;
    assume AsFuelBottom(StartFuel_Integer_Order._default.ltedef)
       == StartFuel_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.ltedef)
       == StartFuelAssert_Integer_Order._default.ltedef;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGte;
    assume AsFuelBottom(StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuel_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt)
       == StartFuelAssert_Integer_Order._default.binarySearchIndexOfFirstKeyGt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.NotMinimum)
       == StartFuel_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.NotMinimum)
       == StartFuelAssert_Integer_Order._default.NotMinimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.SortedSeqForMap)
       == StartFuel_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.SortedSeqForMap)
       == StartFuelAssert_Integer_Order._default.SortedSeqForMap;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimum)
       == StartFuel_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimum)
       == StartFuelAssert_Integer_Order._default.minimum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.minimumOpt)
       == StartFuel_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.minimumOpt)
       == StartFuelAssert_Integer_Order._default.minimumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximum)
       == StartFuel_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximum)
       == StartFuelAssert_Integer_Order._default.maximum;
    assume AsFuelBottom(StartFuel_Integer_Order._default.maximumOpt)
       == StartFuel_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.maximumOpt)
       == StartFuelAssert_Integer_Order._default.maximumOpt;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsSorted)
       == StartFuel_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsSorted)
       == StartFuelAssert_Integer_Order._default.IsSorted;
    assume AsFuelBottom(StartFuel_Integer_Order._default.IsStrictlySorted)
       == StartFuel_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuelAssert_Integer_Order._default.IsStrictlySorted)
       == StartFuelAssert_Integer_Order._default.IsStrictlySorted;
    assume AsFuelBottom(StartFuel_PackedKV._default.psaSeq_Messages)
       == StartFuel_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuelAssert_PackedKV._default.psaSeq_Messages)
       == StartFuelAssert_PackedKV._default.psaSeq_Messages;
    assume AsFuelBottom(StartFuel_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuel_Marshalling._default.isStrictlySortedKeySeq;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq)
       == StartFuelAssert_Marshalling._default.isStrictlySortedKeySeq;
    assume StartFuel_Marshalling._default.valToIndirectionTableMaps
       == $LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps);
    assume StartFuelAssert_Marshalling._default.valToIndirectionTableMaps
       == $LS($LS(BaseFuel_Marshalling._default.valToIndirectionTableMaps));
    assume AsFuelBottom(BaseFuel_Marshalling._default.valToIndirectionTableMaps)
       == BaseFuel_Marshalling._default.valToIndirectionTableMaps;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseSector)
       == StartFuel_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseSector)
       == StartFuelAssert_Marshalling._default.parseSector;
    assume AsFuelBottom(StartFuel_Marshalling._default.parseCheckedSector)
       == StartFuel_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuelAssert_Marshalling._default.parseCheckedSector)
       == StartFuelAssert_Marshalling._default.parseCheckedSector;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.GetEntry)
       == StartFuel_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.GetEntry)
       == StartFuelAssert_IndirectionTableModel._default.GetEntry;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuel_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc)
       == StartFuelAssert_IndirectionTableModel._default.HasEmptyLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuel_IndirectionTableModel._default.AddLocIfPresent;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent)
       == StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent;
    assume StartFuel_IndirectionTableModel._default.RefcountUpdateInv
       == $LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv);
    assume StartFuelAssert_IndirectionTableModel._default.RefcountUpdateInv
       == $LS($LS(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv));
    assume AsFuelBottom(BaseFuel_IndirectionTableModel._default.RefcountUpdateInv)
       == BaseFuel_IndirectionTableModel._default.RefcountUpdateInv;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveLoc)
       == StartFuel_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveLoc)
       == StartFuelAssert_IndirectionTableModel._default.RemoveLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuel_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue)
       == StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuel_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo)
       == StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.InitLocBitmap)
       == StartFuel_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.InitLocBitmap)
       == StartFuelAssert_IndirectionTableModel._default.InitLocBitmap;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindDeallocable)
       == StartFuel_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindDeallocable)
       == StartFuelAssert_IndirectionTableModel._default.FindDeallocable;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.RemoveRef)
       == StartFuel_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.RemoveRef)
       == StartFuelAssert_IndirectionTableModel._default.RemoveRef;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.clone)
       == StartFuel_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.clone)
       == StartFuelAssert_IndirectionTableModel._default.clone;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuel_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc)
       == StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuel_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly)
       == StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly;
    assume AsFuelBottom(StartFuel_IndirectionTableModel._default.getRefUpperBound)
       == StartFuel_IndirectionTableModel._default.getRefUpperBound;
    assume AsFuelBottom(StartFuelAssert_IndirectionTableModel._default.getRefUpperBound)
       == StartFuelAssert_IndirectionTableModel._default.getRefUpperBound;
    $_Frame := (lambda<alpha> $o: ref, $f: Field alpha :: 
      $o != null && read($Heap, $o, alloc) ==> false);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1211,4): initial state"} true;
    $_reverifyPost := false;
    // ----- call statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1212,52)
    // TrCallStmt: Before ProcessCallStmt
    assert (forall<alpha> $o: ref, $f: Field alpha :: false ==> $_Frame[$o, $f]);
    // ProcessCallStmt: Make the call
    call Call$$IndirectionTableModel.__default.reveal__getRefUpperBound();
    // TrCallStmt: After ProcessCallStmt
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1212,53)"} true;
    // ----- return statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1213,7)
    // ----- assignment statement ----- /home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1213,7)
    assume true;
    assume true;
    r#0 := read($Heap, this, IndirectionTableImpl.IndirectionTable.refUpperBound);
    assume {:captureState "/home/yizhou7/linear-veribetrkv-artifact/veribetrkv-dynamic-frames/Impl/IndirectionTableImpl.i.dfy(1213,31)"} true;
    return;
}



// IndirectionTableImpl.IndirectionTable: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.IndirectionTableImpl.IndirectionTable()) } 
  $Is(c#0, Tclass.IndirectionTableImpl.IndirectionTable())
     <==> $Is(c#0, Tclass.IndirectionTableImpl.IndirectionTable?()) && c#0 != null);

// IndirectionTableImpl.IndirectionTable: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.IndirectionTableImpl.IndirectionTable(), $h) } 
  $IsAlloc(c#0, Tclass.IndirectionTableImpl.IndirectionTable(), $h)
     <==> $IsAlloc(c#0, Tclass.IndirectionTableImpl.IndirectionTable?(), $h));

const unique class.IndirectionTableImpl.__default: ClassName;

function Tclass.IndirectionTableImpl.__default() : Ty;

// Tclass.IndirectionTableImpl.__default Tag
axiom Tag(Tclass.IndirectionTableImpl.__default())
   == Tagclass.IndirectionTableImpl.__default;

const unique Tagclass.IndirectionTableImpl.__default: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableImpl.__default()) } 
  $IsBox(bx, Tclass.IndirectionTableImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.IndirectionTableImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.IndirectionTableImpl.__default()) } 
  $Is($o, Tclass.IndirectionTableImpl.__default())
     <==> $o == null || dtype($o) == Tclass.IndirectionTableImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.IndirectionTableImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.IndirectionTableImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

function Tclass.NativeTypes.sbyte() : Ty;

// Tclass.NativeTypes.sbyte Tag
axiom Tag(Tclass.NativeTypes.sbyte()) == Tagclass.NativeTypes.sbyte;

const unique Tagclass.NativeTypes.sbyte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.sbyte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.sbyte()) } 
  $IsBox(bx, Tclass.NativeTypes.sbyte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.sbyte()));

// NativeTypes.sbyte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.sbyte()) } 
  $Is(i#0, Tclass.NativeTypes.sbyte()) <==> LitInt(0 - 128) <= i#0 && i#0 < 128);

// NativeTypes.sbyte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.sbyte(), $h));

const unique class.NativeTypes.sbyte: ClassName;

function Tclass.NativeTypes.byte() : Ty;

// Tclass.NativeTypes.byte Tag
axiom Tag(Tclass.NativeTypes.byte()) == Tagclass.NativeTypes.byte;

const unique Tagclass.NativeTypes.byte: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.byte
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.byte()) } 
  $IsBox(bx, Tclass.NativeTypes.byte())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.byte()));

// NativeTypes.byte: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.byte()) } 
  $Is(i#0, Tclass.NativeTypes.byte()) <==> LitInt(0) <= i#0 && i#0 < 256);

// NativeTypes.byte: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.byte(), $h));

const unique class.NativeTypes.byte: ClassName;

function Tclass.NativeTypes.int16() : Ty;

// Tclass.NativeTypes.int16 Tag
axiom Tag(Tclass.NativeTypes.int16()) == Tagclass.NativeTypes.int16;

const unique Tagclass.NativeTypes.int16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int16()) } 
  $IsBox(bx, Tclass.NativeTypes.int16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int16()));

// NativeTypes.int16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int16()) } 
  $Is(i#0, Tclass.NativeTypes.int16())
     <==> LitInt(0 - 32768) <= i#0 && i#0 < 32768);

// NativeTypes.int16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int16(), $h));

const unique class.NativeTypes.int16: ClassName;

function Tclass.NativeTypes.uint16() : Ty;

// Tclass.NativeTypes.uint16 Tag
axiom Tag(Tclass.NativeTypes.uint16()) == Tagclass.NativeTypes.uint16;

const unique Tagclass.NativeTypes.uint16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint16()) } 
  $IsBox(bx, Tclass.NativeTypes.uint16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint16()));

// NativeTypes.uint16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint16()) } 
  $Is(i#0, Tclass.NativeTypes.uint16()) <==> LitInt(0) <= i#0 && i#0 < 65536);

// NativeTypes.uint16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint16(), $h));

const unique class.NativeTypes.uint16: ClassName;

function Tclass.NativeTypes.int32() : Ty;

// Tclass.NativeTypes.int32 Tag
axiom Tag(Tclass.NativeTypes.int32()) == Tagclass.NativeTypes.int32;

const unique Tagclass.NativeTypes.int32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int32()) } 
  $IsBox(bx, Tclass.NativeTypes.int32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int32()));

// NativeTypes.int32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int32()) } 
  $Is(i#0, Tclass.NativeTypes.int32())
     <==> LitInt(0 - 2147483648) <= i#0 && i#0 < 2147483648);

// NativeTypes.int32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int32(), $h));

const unique class.NativeTypes.int32: ClassName;

function Tclass.NativeTypes.uint32() : Ty;

// Tclass.NativeTypes.uint32 Tag
axiom Tag(Tclass.NativeTypes.uint32()) == Tagclass.NativeTypes.uint32;

const unique Tagclass.NativeTypes.uint32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.uint32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.uint32()) } 
  $IsBox(bx, Tclass.NativeTypes.uint32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.uint32()));

// NativeTypes.uint32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint32()) } 
  $Is(i#0, Tclass.NativeTypes.uint32()) <==> LitInt(0) <= i#0 && i#0 < 4294967296);

// NativeTypes.uint32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint32(), $h));

const unique class.NativeTypes.uint32: ClassName;

function Tclass.NativeTypes.int64() : Ty;

// Tclass.NativeTypes.int64 Tag
axiom Tag(Tclass.NativeTypes.int64()) == Tagclass.NativeTypes.int64;

const unique Tagclass.NativeTypes.int64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.int64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.int64()) } 
  $IsBox(bx, Tclass.NativeTypes.int64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.int64()));

// NativeTypes.int64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.int64()) } 
  $Is(i#0, Tclass.NativeTypes.int64())
     <==> LitInt(0 - 9223372036854775808) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.int64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.int64(), $h));

const unique class.NativeTypes.int64: ClassName;

// NativeTypes.uint64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.uint64()) } 
  $Is(i#0, Tclass.NativeTypes.uint64())
     <==> LitInt(0) <= i#0 && i#0 < 18446744073709551616);

// NativeTypes.uint64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.uint64(), $h));

const unique class.NativeTypes.uint64: ClassName;

function Tclass.NativeTypes.nat8() : Ty;

// Tclass.NativeTypes.nat8 Tag
axiom Tag(Tclass.NativeTypes.nat8()) == Tagclass.NativeTypes.nat8;

const unique Tagclass.NativeTypes.nat8: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat8
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat8()) } 
  $IsBox(bx, Tclass.NativeTypes.nat8())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat8()));

// NativeTypes.nat8: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat8()) } 
  $Is(i#0, Tclass.NativeTypes.nat8()) <==> LitInt(0) <= i#0 && i#0 < 128);

// NativeTypes.nat8: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat8(), $h));

const unique class.NativeTypes.nat8: ClassName;

function Tclass.NativeTypes.nat16() : Ty;

// Tclass.NativeTypes.nat16 Tag
axiom Tag(Tclass.NativeTypes.nat16()) == Tagclass.NativeTypes.nat16;

const unique Tagclass.NativeTypes.nat16: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat16
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat16()) } 
  $IsBox(bx, Tclass.NativeTypes.nat16())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat16()));

// NativeTypes.nat16: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat16()) } 
  $Is(i#0, Tclass.NativeTypes.nat16()) <==> LitInt(0) <= i#0 && i#0 < 32768);

// NativeTypes.nat16: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat16(), $h));

const unique class.NativeTypes.nat16: ClassName;

function Tclass.NativeTypes.nat32() : Ty;

// Tclass.NativeTypes.nat32 Tag
axiom Tag(Tclass.NativeTypes.nat32()) == Tagclass.NativeTypes.nat32;

const unique Tagclass.NativeTypes.nat32: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat32
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat32()) } 
  $IsBox(bx, Tclass.NativeTypes.nat32())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat32()));

// NativeTypes.nat32: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat32()) } 
  $Is(i#0, Tclass.NativeTypes.nat32()) <==> LitInt(0) <= i#0 && i#0 < 2147483648);

// NativeTypes.nat32: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat32(), $h));

const unique class.NativeTypes.nat32: ClassName;

function Tclass.NativeTypes.nat64() : Ty;

// Tclass.NativeTypes.nat64 Tag
axiom Tag(Tclass.NativeTypes.nat64()) == Tagclass.NativeTypes.nat64;

const unique Tagclass.NativeTypes.nat64: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.nat64
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.nat64()) } 
  $IsBox(bx, Tclass.NativeTypes.nat64())
     ==> $Box($Unbox(bx): int) == bx && $Is($Unbox(bx): int, Tclass.NativeTypes.nat64()));

// NativeTypes.nat64: newtype $Is
axiom (forall i#0: int :: 
  { $Is(i#0, Tclass.NativeTypes.nat64()) } 
  $Is(i#0, Tclass.NativeTypes.nat64())
     <==> LitInt(0) <= i#0 && i#0 < 9223372036854775808);

// NativeTypes.nat64: newtype $IsAlloc
axiom (forall i#0: int, $h: Heap :: 
  { $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h) } 
  $IsAlloc(i#0, Tclass.NativeTypes.nat64(), $h));

const unique class.NativeTypes.nat64: ClassName;

const unique class.NativeTypes.__default: ClassName;

function Tclass.NativeTypes.__default() : Ty;

// Tclass.NativeTypes.__default Tag
axiom Tag(Tclass.NativeTypes.__default()) == Tagclass.NativeTypes.__default;

const unique Tagclass.NativeTypes.__default: TyTag;

// Box/unbox axiom for Tclass.NativeTypes.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeTypes.__default()) } 
  $IsBox(bx, Tclass.NativeTypes.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeTypes.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeTypes.__default()) } 
  $Is($o, Tclass.NativeTypes.__default())
     <==> $o == null || dtype($o) == Tclass.NativeTypes.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeTypes.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeTypes.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeTypes._default.Uint64Size
function NativeTypes.__default.Uint64Size() : int;

function NativeTypes.__default.Uint64Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint64Size()
     && NativeTypes.__default.Uint64Size() < 18446744073709551616;

function NativeTypes.__default.Uint64Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64Size
axiom NativeTypes.__default.Uint64Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint64Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// definition axiom for NativeTypes.__default.Uint64Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint64Size() == LitInt(8);

// function declaration for NativeTypes._default.Uint32Size
function NativeTypes.__default.Uint32Size() : int;

function NativeTypes.__default.Uint32Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint32Size()
     && NativeTypes.__default.Uint32Size() < 18446744073709551616;

function NativeTypes.__default.Uint32Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32Size
axiom NativeTypes.__default.Uint32Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint32Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// definition axiom for NativeTypes.__default.Uint32Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32Size() == LitInt(4);

// function declaration for NativeTypes._default.Uint16Size
function NativeTypes.__default.Uint16Size() : int;

function NativeTypes.__default.Uint16Size#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint16Size
axiom true
   ==> 
  true
   ==> LitInt(0) <= NativeTypes.__default.Uint16Size()
     && NativeTypes.__default.Uint16Size() < 18446744073709551616;

function NativeTypes.__default.Uint16Size#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint16Size
axiom NativeTypes.__default.Uint16Size#requires() == true;

// definition axiom for NativeTypes.__default.Uint16Size(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// definition axiom for NativeTypes.__default.Uint16Size for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint16Size() == LitInt(2);

// function declaration for NativeTypes._default.Uint64UpperBound
function NativeTypes.__default.Uint64UpperBound() : int;

function NativeTypes.__default.Uint64UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint64UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint64UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint64UpperBound
axiom NativeTypes.__default.Uint64UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint64UpperBound(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// definition axiom for NativeTypes.__default.Uint64UpperBound for all literals(revealed)
axiom true
   ==> 
  true
   ==> NativeTypes.__default.Uint64UpperBound() == LitInt(18446744073709551616);

// function declaration for NativeTypes._default.Uint32UpperBound
function NativeTypes.__default.Uint32UpperBound() : int;

function NativeTypes.__default.Uint32UpperBound#canCall() : bool;

// consequence axiom for NativeTypes.__default.Uint32UpperBound
axiom true ==> true ==> true;

function NativeTypes.__default.Uint32UpperBound#requires() : bool;

// #requires axiom for NativeTypes.__default.Uint32UpperBound
axiom NativeTypes.__default.Uint32UpperBound#requires() == true;

// definition axiom for NativeTypes.__default.Uint32UpperBound(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

// definition axiom for NativeTypes.__default.Uint32UpperBound for all literals(revealed)
axiom true ==> true ==> NativeTypes.__default.Uint32UpperBound() == LitInt(4294967296);

const unique class.DebugAccumulator.AccRec?: ClassName;

function Tclass.DebugAccumulator.AccRec?() : Ty;

// Tclass.DebugAccumulator.AccRec? Tag
axiom Tag(Tclass.DebugAccumulator.AccRec?()) == Tagclass.DebugAccumulator.AccRec?;

const unique Tagclass.DebugAccumulator.AccRec?: TyTag;

// Box/unbox axiom for Tclass.DebugAccumulator.AccRec?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DebugAccumulator.AccRec?()) } 
  $IsBox(bx, Tclass.DebugAccumulator.AccRec?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DebugAccumulator.AccRec?()));

// AccRec: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.DebugAccumulator.AccRec?()) } 
  $Is($o, Tclass.DebugAccumulator.AccRec?())
     <==> $o == null || dtype($o) == Tclass.DebugAccumulator.AccRec?());

// AccRec: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.DebugAccumulator.AccRec?(), $h) } 
  $IsAlloc($o, Tclass.DebugAccumulator.AccRec?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(DebugAccumulator.AccRec.key) == 0
   && FieldOfDecl(class.DebugAccumulator.AccRec?, field$key)
     == DebugAccumulator.AccRec.key
   && !$IsGhostField(DebugAccumulator.AccRec.key);

const DebugAccumulator.AccRec.key: Field (Seq Box);

// AccRec.key: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.key) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DebugAccumulator.AccRec?()
     ==> $Is(read($h, $o, DebugAccumulator.AccRec.key), TSeq(TChar)));

// AccRec.key: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.key) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DebugAccumulator.AccRec?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DebugAccumulator.AccRec.key), TSeq(TChar), $h));

axiom FDim(DebugAccumulator.AccRec.count) == 0
   && FieldOfDecl(class.DebugAccumulator.AccRec?, field$count)
     == DebugAccumulator.AccRec.count
   && !$IsGhostField(DebugAccumulator.AccRec.count);

const DebugAccumulator.AccRec.count: Field int;

// AccRec.count: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.count) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DebugAccumulator.AccRec?()
     ==> $Is(read($h, $o, DebugAccumulator.AccRec.count), Tclass.NativeTypes.uint64()));

// AccRec.count: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.count) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DebugAccumulator.AccRec?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DebugAccumulator.AccRec.count), Tclass.NativeTypes.uint64(), $h));

axiom FDim(DebugAccumulator.AccRec.unit) == 0
   && FieldOfDecl(class.DebugAccumulator.AccRec?, field$unit)
     == DebugAccumulator.AccRec.unit
   && !$IsGhostField(DebugAccumulator.AccRec.unit);

const DebugAccumulator.AccRec.unit: Field (Seq Box);

// AccRec.unit: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.unit) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DebugAccumulator.AccRec?()
     ==> $Is(read($h, $o, DebugAccumulator.AccRec.unit), TSeq(TChar)));

// AccRec.unit: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.unit) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DebugAccumulator.AccRec?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DebugAccumulator.AccRec.unit), TSeq(TChar), $h));

axiom FDim(DebugAccumulator.AccRec.index) == 0
   && FieldOfDecl(class.DebugAccumulator.AccRec?, field$index)
     == DebugAccumulator.AccRec.index
   && !$IsGhostField(DebugAccumulator.AccRec.index);

const DebugAccumulator.AccRec.index: Field (Seq Box);

// AccRec.index: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.index) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.DebugAccumulator.AccRec?()
     ==> $Is(read($h, $o, DebugAccumulator.AccRec.index), 
      TSeq(Tclass.DebugAccumulator.AccRec())));

// AccRec.index: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, DebugAccumulator.AccRec.index) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.DebugAccumulator.AccRec?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, DebugAccumulator.AccRec.index), 
      TSeq(Tclass.DebugAccumulator.AccRec()), 
      $h));

procedure CheckWellformed$$DebugAccumulator.AccRec.__ctor(this: ref
       where this != null
         && 
        $Is(this, Tclass.DebugAccumulator.AccRec())
         && $IsAlloc(this, Tclass.DebugAccumulator.AccRec(), $Heap), 
    count#0: int where LitInt(0) <= count#0 && count#0 < 18446744073709551616, 
    unit#0: Seq Box
       where $Is(unit#0, TSeq(TChar)) && $IsAlloc(unit#0, TSeq(TChar), $Heap));
  free requires 2 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$DebugAccumulator.AccRec.__ctor(count#0: int where LitInt(0) <= count#0 && count#0 < 18446744073709551616, 
    unit#0: Seq Box
       where $Is(unit#0, TSeq(TChar)) && $IsAlloc(unit#0, TSeq(TChar), $Heap))
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.DebugAccumulator.AccRec())
         && $IsAlloc(this, Tclass.DebugAccumulator.AccRec(), $Heap));
  modifies $Heap, $Tick;
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$DebugAccumulator.AccRec.Index(this: ref
       where this != null
         && 
        $Is(this, Tclass.DebugAccumulator.AccRec())
         && $IsAlloc(this, Tclass.DebugAccumulator.AccRec(), $Heap), 
    index#0: Seq Box
       where $Is(index#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(index#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$DebugAccumulator.AccRec.Index(index#0: Seq Box
       where $Is(index#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(index#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap))
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.DebugAccumulator.AccRec())
         && $IsAlloc(this, Tclass.DebugAccumulator.AccRec(), $Heap));
  modifies $Heap, $Tick;
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// DebugAccumulator.AccRec: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.DebugAccumulator.AccRec()) } 
  $Is(c#0, Tclass.DebugAccumulator.AccRec())
     <==> $Is(c#0, Tclass.DebugAccumulator.AccRec?()) && c#0 != null);

// DebugAccumulator.AccRec: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.DebugAccumulator.AccRec(), $h) } 
  $IsAlloc(c#0, Tclass.DebugAccumulator.AccRec(), $h)
     <==> $IsAlloc(c#0, Tclass.DebugAccumulator.AccRec?(), $h));

const unique class.DebugAccumulator.__default: ClassName;

function Tclass.DebugAccumulator.__default() : Ty;

// Tclass.DebugAccumulator.__default Tag
axiom Tag(Tclass.DebugAccumulator.__default()) == Tagclass.DebugAccumulator.__default;

const unique Tagclass.DebugAccumulator.__default: TyTag;

// Box/unbox axiom for Tclass.DebugAccumulator.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DebugAccumulator.__default()) } 
  $IsBox(bx, Tclass.DebugAccumulator.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DebugAccumulator.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.DebugAccumulator.__default()) } 
  $Is($o, Tclass.DebugAccumulator.__default())
     <==> $o == null || dtype($o) == Tclass.DebugAccumulator.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.DebugAccumulator.__default(), $h) } 
  $IsAlloc($o, Tclass.DebugAccumulator.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for DebugAccumulator._default.EmptyAccumulator
function DebugAccumulator.__default.EmptyAccumulator() : Seq Box;

function DebugAccumulator.__default.EmptyAccumulator#canCall() : bool;

// consequence axiom for DebugAccumulator.__default.EmptyAccumulator
axiom true
   ==> 
  true
   ==> $Is(DebugAccumulator.__default.EmptyAccumulator(), 
    TSeq(Tclass.DebugAccumulator.AccRec()));

function DebugAccumulator.__default.EmptyAccumulator#requires() : bool;

// #requires axiom for DebugAccumulator.__default.EmptyAccumulator
axiom DebugAccumulator.__default.EmptyAccumulator#requires() == true;

// definition axiom for DebugAccumulator.__default.EmptyAccumulator(revealed)
axiom true
   ==> 
  true
   ==> DebugAccumulator.__default.EmptyAccumulator() == Lit(Seq#Empty(): Seq Box);

// definition axiom for DebugAccumulator.__default.EmptyAccumulator for all literals(revealed)
axiom true
   ==> 
  true
   ==> DebugAccumulator.__default.EmptyAccumulator() == Lit(Seq#Empty(): Seq Box);

procedure CheckWellformed$$DebugAccumulator.__default.AccPut(acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(TChar)) && $IsAlloc(key#0, TSeq(TChar), $Heap), 
    rec#0: ref
       where $Is(rec#0, Tclass.DebugAccumulator.AccRec())
         && $IsAlloc(rec#0, Tclass.DebugAccumulator.AccRec(), $Heap))
   returns (out#0: Seq Box
       where $Is(out#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(out#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  free requires 9 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$DebugAccumulator.__default.AccPut(acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap), 
    key#0: Seq Box
       where $Is(key#0, TSeq(TChar)) && $IsAlloc(key#0, TSeq(TChar), $Heap), 
    rec#0: ref
       where $Is(rec#0, Tclass.DebugAccumulator.AccRec())
         && $IsAlloc(rec#0, Tclass.DebugAccumulator.AccRec(), $Heap))
   returns (out#0: Seq Box
       where $Is(out#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(out#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  // user-defined preconditions
  requires Lit(false);
  modifies $Heap, $Tick;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// Constructor function declaration
function #Options.Option.None() : DatatypeType;

const unique ##Options.Option.None: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#Options.Option.None()) == ##Options.Option.None;

function Options.Option.None_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) <==> DatatypeCtorId(d) == ##Options.Option.None);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.None_q(d) } 
  Options.Option.None_q(d) ==> d == #Options.Option.None());

// Constructor $Is
axiom (forall Options.Option$V: Ty :: 
  { $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.None(), Tclass.Options.Option(Options.Option$V)));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, $h: Heap :: 
  { $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#Options.Option.None(), Tclass.Options.Option(Options.Option$V), $h));

// Constructor literal
axiom #Options.Option.None() == Lit(#Options.Option.None());

// Constructor function declaration
function #Options.Option.Some(Box) : DatatypeType;

const unique ##Options.Option.Some: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: Box :: 
  { #Options.Option.Some(a#5#0#0) } 
  DatatypeCtorId(#Options.Option.Some(a#5#0#0)) == ##Options.Option.Some);

function Options.Option.Some_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d) <==> DatatypeCtorId(d) == ##Options.Option.Some);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Options.Option.Some_q(d) } 
  Options.Option.Some_q(d)
     ==> (exists a#6#0#0: Box :: d == #Options.Option.Some(a#6#0#0)));

// Constructor $Is
axiom (forall Options.Option$V: Ty, a#7#0#0: Box :: 
  { $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V)) } 
  $Is(#Options.Option.Some(a#7#0#0), Tclass.Options.Option(Options.Option$V))
     <==> $IsBox(a#7#0#0, Options.Option$V));

// Constructor $IsAlloc
axiom (forall Options.Option$V: Ty, a#8#0#0: Box, $h: Heap :: 
  { $IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Options.Option.Some(a#8#0#0), Tclass.Options.Option(Options.Option$V), $h)
       <==> $IsAllocBox(a#8#0#0, Options.Option$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, Options.Option$V: Ty, $h: Heap :: 
  { $IsAllocBox(Options.Option.value(d), Options.Option$V, $h) } 
  $IsGoodHeap($h)
       && 
      Options.Option.Some_q(d)
       && $IsAlloc(d, Tclass.Options.Option(Options.Option$V), $h)
     ==> $IsAllocBox(Options.Option.value(d), Options.Option$V, $h));

// Constructor literal
axiom (forall a#9#0#0: Box :: 
  { #Options.Option.Some(Lit(a#9#0#0)) } 
  #Options.Option.Some(Lit(a#9#0#0)) == Lit(#Options.Option.Some(a#9#0#0)));

function Options.Option.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#10#0#0: Box :: 
  { #Options.Option.Some(a#10#0#0) } 
  Options.Option.value(#Options.Option.Some(a#10#0#0)) == a#10#0#0);

// Inductive rank
axiom (forall a#11#0#0: Box :: 
  { #Options.Option.Some(a#11#0#0) } 
  BoxRank(a#11#0#0) < DtRank(#Options.Option.Some(a#11#0#0)));

// Depth-one case-split function
function $IsA#Options.Option(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Options.Option(d) } 
  $IsA#Options.Option(d) ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Questionmark data type disjunctivity
axiom (forall Options.Option$V: Ty, d: DatatypeType :: 
  { Options.Option.Some_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
    { Options.Option.None_q(d), $Is(d, Tclass.Options.Option(Options.Option$V)) } 
  $Is(d, Tclass.Options.Option(Options.Option$V))
     ==> Options.Option.None_q(d) || Options.Option.Some_q(d));

// Datatype extensional equality declaration
function Options.Option#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Options.Option.None
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.None_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.None_q(b) } 
  Options.Option.None_q(a) && Options.Option.None_q(b)
     ==> (Options.Option#Equal(a, b) <==> true));

// Datatype extensional equality definition: #Options.Option.Some
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b), Options.Option.Some_q(a) } 
    { Options.Option#Equal(a, b), Options.Option.Some_q(b) } 
  Options.Option.Some_q(a) && Options.Option.Some_q(b)
     ==> (Options.Option#Equal(a, b)
       <==> Options.Option.value(a) == Options.Option.value(b)));

// Datatype extensionality axiom: Options.Option
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Options.Option#Equal(a, b) } 
  Options.Option#Equal(a, b) <==> a == b);

const unique class.Options.Option: ClassName;

const unique class.Options.__default: ClassName;

function Tclass.Options.__default() : Ty;

// Tclass.Options.__default Tag
axiom Tag(Tclass.Options.__default()) == Tagclass.Options.__default;

const unique Tagclass.Options.__default: TyTag;

// Box/unbox axiom for Tclass.Options.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Options.__default()) } 
  $IsBox(bx, Tclass.Options.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Options.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Options.__default()) } 
  $Is($o, Tclass.Options.__default())
     <==> $o == null || dtype($o) == Tclass.Options.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Options.__default(), $h) } 
  $IsAlloc($o, Tclass.Options.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Options._default.MapOption
function Options.__default.MapOption(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.MapOption#canCall(Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h0, opt#0, f#0)
       == Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $h1, opt#0, f#0));

// consequence axiom for Options.__default.MapOption
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
           <==> Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)))
         && (Options.Option.Some_q(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
           ==> Options.Option.value(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0))
             == Apply1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0)))
         && $Is(Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0), 
          Tclass.Options.Option(Options._default.MapOption$V1)));

function Options.__default.MapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.MapOption
axiom (forall Options._default.MapOption$V0: Ty, 
    Options._default.MapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
     ==> Options.__default.MapOption#requires(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.MapOption$V0, 
          Options._default.MapOption$V1, 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.MapOption(revealed)
axiom true
   ==> (forall Options._default.MapOption$V0: Ty, 
      Options._default.MapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0) } 
    Options.__default.MapOption#canCall(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.MapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.MapOption$V0, Options._default.MapOption$V1))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.MapOption$V0, 
              Options._default.MapOption$V1, 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.MapOption(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, opt#0, f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            #Options.Option.Some(Apply1(Options._default.MapOption$V0, Options._default.MapOption$V1, $Heap, f#0, v#1)))));

// function declaration for Options._default.FlatMapOption
function Options.__default.FlatMapOption(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : DatatypeType;

function Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType)
   : bool;

// frame axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $h1, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $h0, 
          opt#0, 
          f#0)
         || ($Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (if Options.Option.Some_q(opt#0)
             then Reads1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $h0, 
              f#0, 
              Options.Option.value(opt#0))
             else Set#Empty(): Set Box)[$Box($o)]
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h0, 
        opt#0, 
        f#0)
       == Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $h1, 
        opt#0, 
        f#0));

// consequence axiom for Options.__default.FlatMapOption
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.Some_q(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
              Options._default.FlatMapOption$V1, 
              $Heap, 
              opt#0, 
              f#0)))
         && (Options.Option.Some_q(opt#0)
             && Options.Option.Some_q($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType)
           ==> Options.Option.value(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
                Options._default.FlatMapOption$V1, 
                $Heap, 
                opt#0, 
                f#0))
             == Options.Option.value($Unbox(Apply1(Options._default.FlatMapOption$V0, 
                  Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                  $Heap, 
                  f#0, 
                  Options.Option.value(opt#0))): DatatypeType))
         && $Is(Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
            Options._default.FlatMapOption$V1, 
            $Heap, 
            opt#0, 
            f#0), 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)));

function Options.__default.FlatMapOption#requires(Ty, Ty, Heap, DatatypeType, HandleType) : bool;

// #requires axiom for Options.__default.FlatMapOption
axiom (forall Options._default.FlatMapOption$V0: Ty, 
    Options._default.FlatMapOption$V1: Ty, 
    $Heap: Heap, 
    opt#0: DatatypeType, 
    f#0: HandleType :: 
  { Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
      Options._default.FlatMapOption$V1, 
      $Heap, 
      opt#0, 
      f#0) } 
  $IsGoodHeap($Heap)
       && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
       && $Is(f#0, 
        Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1)))
     ==> Options.__default.FlatMapOption#requires(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0)
       == (Options.Option.Some_q(opt#0)
         ==> Requires1(Options._default.FlatMapOption$V0, 
          Tclass.Options.Option(Options._default.FlatMapOption$V1), 
          $Heap, 
          f#0, 
          Options.Option.value(opt#0))));

// definition axiom for Options.__default.FlatMapOption(revealed)
axiom true
   ==> (forall Options._default.FlatMapOption$V0: Ty, 
      Options._default.FlatMapOption$V1: Ty, 
      $Heap: Heap, 
      opt#0: DatatypeType, 
      f#0: HandleType :: 
    { Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
        Options._default.FlatMapOption$V1, 
        $Heap, 
        opt#0, 
        f#0) } 
    Options.__default.FlatMapOption#canCall(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(opt#0, Tclass.Options.Option(Options._default.FlatMapOption$V0))
           && $Is(f#0, 
            Tclass._System.___hFunc1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1)))
           && (Options.Option.Some_q(opt#0)
             ==> Requires1(Options._default.FlatMapOption$V0, 
              Tclass.Options.Option(Options._default.FlatMapOption$V1), 
              $Heap, 
              f#0, 
              Options.Option.value(opt#0))))
       ==> Options.__default.FlatMapOption(Options._default.FlatMapOption$V0, 
          Options._default.FlatMapOption$V1, 
          $Heap, 
          opt#0, 
          f#0)
         == (if Options.Option.None_q(opt#0)
           then #Options.Option.None()
           else (var v#1 := Options.Option.value(opt#0); 
            $Unbox(Apply1(Options._default.FlatMapOption$V0, 
                Tclass.Options.Option(Options._default.FlatMapOption$V1), 
                $Heap, 
                f#0, 
                v#1)): DatatypeType)));

const unique class.Maps.__default: ClassName;

function Tclass.Maps.__default() : Ty;

// Tclass.Maps.__default Tag
axiom Tag(Tclass.Maps.__default()) == Tagclass.Maps.__default;

const unique Tagclass.Maps.__default: TyTag;

// Box/unbox axiom for Tclass.Maps.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Maps.__default()) } 
  $IsBox(bx, Tclass.Maps.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Maps.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Maps.__default()) } 
  $Is($o, Tclass.Maps.__default())
     <==> $o == null || dtype($o) == Tclass.Maps.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Maps.__default(), $h) } 
  $IsAlloc($o, Tclass.Maps.__default(), $h) <==> $o == null || read($h, $o, alloc));

// function declaration for Maps._default.IMapsTo
function Maps.__default.IMapsTo(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsTo
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> true);

function Maps.__default.IMapsTo#requires(Ty, Ty, IMap Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsTo
axiom (forall Maps._default.IMapsTo$K: Ty, 
    Maps._default.IMapsTo$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
       && $IsBox(k#0, Maps._default.IMapsTo$K)
       && $IsBox(v#0, Maps._default.IMapsTo$V)
     ==> Maps.__default.IMapsTo#requires(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.IMapsTo(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, m#0, k#0, v#0)
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.IMapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsTo$K: Ty, 
      Maps._default.IMapsTo$V: Ty, 
      m#0: IMap Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.IMapsTo#canCall(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V))
           && $IsBox(k#0, Maps._default.IMapsTo$K)
           && $IsBox(v#0, Maps._default.IMapsTo$V))
       ==> Maps.__default.IMapsTo(Maps._default.IMapsTo$K, Maps._default.IMapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (IMap#Domain(m#0)[k#0] && IMap#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsTo
function Maps.__default.MapsTo(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

function Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsTo
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> true);

function Maps.__default.MapsTo#requires(Ty, Ty, Map Box Box, Box, Box) : bool;

// #requires axiom for Maps.__default.MapsTo
axiom (forall Maps._default.MapsTo$K: Ty, 
    Maps._default.MapsTo$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box, 
    v#0: Box :: 
  { Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
  $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
       && $IsBox(k#0, Maps._default.MapsTo$K)
       && $IsBox(v#0, Maps._default.MapsTo$V)
     ==> Maps.__default.MapsTo#requires(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
       == true);

// definition axiom for Maps.__default.MapsTo(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, m#0, k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(m#0)[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), k#0, v#0)
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[k#0] == v#0));

// definition axiom for Maps.__default.MapsTo for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsTo$K: Ty, 
      Maps._default.MapsTo$V: Ty, 
      m#0: Map Box Box, 
      k#0: Box, 
      v#0: Box :: 
    {:weight 3} { Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0)) } 
    Maps.__default.MapsTo#canCall(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsTo$K, Maps._default.MapsTo$V))
           && $IsBox(k#0, Maps._default.MapsTo$K)
           && $IsBox(v#0, Maps._default.MapsTo$V))
       ==> Maps.__default.MapsTo(Maps._default.MapsTo$K, Maps._default.MapsTo$V, Lit(m#0), Lit(k#0), Lit(v#0))
         == (Map#Domain(m#0)[k#0] && Map#Elements(Lit(m#0))[Lit(k#0)] == Lit(v#0)));

// function declaration for Maps._default.MapsAgreeOnKey
function Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapsAgreeOnKey
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> true);

function Maps.__default.MapsAgreeOnKey#requires(Ty, Ty, Map Box Box, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapsAgreeOnKey
axiom (forall Maps._default.MapsAgreeOnKey$K: Ty, 
    Maps._default.MapsAgreeOnKey$V: Ty, 
    m#0: Map Box Box, 
    m'#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K)
     ==> Maps.__default.MapsAgreeOnKey#requires(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.MapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(m#0)[k#0] == Map#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        k#0) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          k#0)
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[k#0] == Map#Elements(Lit(m'#0))[k#0])));

// definition axiom for Maps.__default.MapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapsAgreeOnKey$K: Ty, 
      Maps._default.MapsAgreeOnKey$V: Ty, 
      m#0: Map Box Box, 
      m'#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
        Maps._default.MapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.MapsAgreeOnKey#canCall(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $Is(m'#0, TMap(Maps._default.MapsAgreeOnKey$K, Maps._default.MapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.MapsAgreeOnKey$K))
       ==> Maps.__default.MapsAgreeOnKey(Maps._default.MapsAgreeOnKey$K, 
          Maps._default.MapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!Map#Domain(m#0)[k#0] && !Map#Domain(m'#0)[k#0])
           || (
            Map#Domain(m#0)[k#0]
             && Map#Domain(m'#0)[k#0]
             && Map#Elements(Lit(m#0))[Lit(k#0)] == Map#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IMapsAgreeOnKey
function Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

function Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box)
   : bool;

// consequence axiom for Maps.__default.IMapsAgreeOnKey
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> true);

function Maps.__default.IMapsAgreeOnKey#requires(Ty, Ty, IMap Box Box, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapsAgreeOnKey
axiom (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
    Maps._default.IMapsAgreeOnKey$V: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
       && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K)
     ==> Maps.__default.IMapsAgreeOnKey#requires(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapsAgreeOnKey(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V, m#0, m'#0, k#0)
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(m#0)[k#0] == IMap#Elements(m'#0)[k#0])));

// definition axiom for Maps.__default.IMapsAgreeOnKey for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapsAgreeOnKey$K: Ty, 
      Maps._default.IMapsAgreeOnKey$V: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
        Maps._default.IMapsAgreeOnKey$V, 
        Lit(m#0), 
        Lit(m'#0), 
        Lit(k#0)) } 
    Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         || (
          $Is(m#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $Is(m'#0, TIMap(Maps._default.IMapsAgreeOnKey$K, Maps._default.IMapsAgreeOnKey$V))
           && $IsBox(k#0, Maps._default.IMapsAgreeOnKey$K))
       ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IMapsAgreeOnKey$K, 
          Maps._default.IMapsAgreeOnKey$V, 
          Lit(m#0), 
          Lit(m'#0), 
          Lit(k#0))
         == ((!IMap#Domain(m#0)[k#0] && !IMap#Domain(m'#0)[k#0])
           || (
            IMap#Domain(m#0)[k#0]
             && IMap#Domain(m'#0)[k#0]
             && IMap#Elements(Lit(m#0))[Lit(k#0)] == IMap#Elements(Lit(m'#0))[Lit(k#0)])));

// function declaration for Maps._default.IsSubIMap
function Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

function Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubIMap
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> true);

function Maps.__default.IsSubIMap#requires(Ty, Ty, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IsSubIMap
axiom (forall Maps._default.IsSubIMap$K: Ty, 
    Maps._default.IsSubIMap$V: Ty, 
    sub#0: IMap Box Box, 
    sup#0: IMap Box Box :: 
  { Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
  $Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
       && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
     ==> Maps.__default.IsSubIMap#requires(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubIMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
              { IMap#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubIMap$K)
               ==> 
              IMap#Domain(sub#0)[key#0]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0)
           == (ISet#Subset(IMap#Domain(sub#0), IMap#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0) } 
                { IMap#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubIMap$K)
                 ==> 
                IMap#Domain(sub#0)[key#0]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubIMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubIMap$K: Ty, 
      Maps._default.IsSubIMap$V: Ty, 
      sub#0: IMap Box Box, 
      sup#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubIMap#canCall(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V))
           && $Is(sup#0, TIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V)))
       ==> (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
              { IMap#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubIMap$K)
               ==> 
              Lit(IMap#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.IMapsAgreeOnKey#canCall(Maps._default.IsSubIMap$K, 
                Maps._default.IsSubIMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubIMap(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, Lit(sub#0), Lit(sup#0))
           == (ISet#Subset(IMap#Domain(Lit(sub#0)), IMap#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, Maps._default.IsSubIMap$V, sub#0, sup#0, key#1) } 
                { IMap#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubIMap$K)
                 ==> 
                Lit(IMap#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.IMapsAgreeOnKey(Maps._default.IsSubIMap$K, 
                  Maps._default.IsSubIMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.IsSubMap
function Maps.__default.IsSubMap(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

function Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.IsSubMap
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> true);

function Maps.__default.IsSubMap#requires(Ty, Ty, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.IsSubMap
axiom (forall Maps._default.IsSubMap$K: Ty, 
    Maps._default.IsSubMap$V: Ty, 
    sub#0: Map Box Box, 
    sup#0: Map Box Box :: 
  { Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
  $Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
       && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
     ==> Maps.__default.IsSubMap#requires(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
       == true);

// definition axiom for Maps.__default.IsSubMap(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
           ==> (forall key#0: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
              { Map#Domain(sub#0)[key#0] } 
            $IsBox(key#0, Maps._default.IsSubMap$K)
               ==> 
              Map#Domain(sub#0)[key#0]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0)
           == (Set#Subset(Map#Domain(sub#0), Map#Domain(sup#0))
             && (forall key#0: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0) } 
                { Map#Domain(sub#0)[key#0] } 
              $IsBox(key#0, Maps._default.IsSubMap$K)
                 ==> 
                Map#Domain(sub#0)[key#0]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#0))));

// definition axiom for Maps.__default.IsSubMap for all literals(revealed)
axiom true
   ==> (forall Maps._default.IsSubMap$K: Ty, 
      Maps._default.IsSubMap$V: Ty, 
      sub#0: Map Box Box, 
      sup#0: Map Box Box :: 
    {:weight 3} { Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0)) } 
    Maps.__default.IsSubMap#canCall(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
         || ($Is(sub#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V))
           && $Is(sup#0, TMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V)))
       ==> (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
           ==> (forall key#1: Box :: 
            { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
              { Map#Domain(sub#0)[key#1] } 
            $IsBox(key#1, Maps._default.IsSubMap$K)
               ==> 
              Lit(Map#Domain(Lit(sub#0)))[key#1]
               ==> Maps.__default.MapsAgreeOnKey#canCall(Maps._default.IsSubMap$K, 
                Maps._default.IsSubMap$V, 
                Lit(sub#0), 
                Lit(sup#0), 
                key#1)))
         && Maps.__default.IsSubMap(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, Lit(sub#0), Lit(sup#0))
           == (Set#Subset(Map#Domain(Lit(sub#0)), Map#Domain(Lit(sup#0)))
             && (forall key#1: Box :: 
              { Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, Maps._default.IsSubMap$V, sub#0, sup#0, key#1) } 
                { Map#Domain(sub#0)[key#1] } 
              $IsBox(key#1, Maps._default.IsSubMap$K)
                 ==> 
                Lit(Map#Domain(Lit(sub#0)))[key#1]
                 ==> Maps.__default.MapsAgreeOnKey(Maps._default.IsSubMap$K, 
                  Maps._default.IsSubMap$V, 
                  Lit(sub#0), 
                  Lit(sup#0), 
                  key#1))));

// function declaration for Maps._default.MapRemove
function Maps.__default.MapRemove(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
      Maps._default.MapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemove
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> (forall k#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0] } 
            { ks#0[k#0] } 
            { Map#Domain(m#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(m#0)[k#0] && !ks#0[k#0]
             ==> Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#0])
         && (forall k#1: Box :: 
          { ks#0[k#1] } 
            { Map#Domain(m#0)[k#1] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapRemove$K)
             ==> (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> Map#Domain(m#0)[k#1])
               && (Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[k#1]
                 ==> !ks#0[k#1]))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)));

function Maps.__default.MapRemove#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemove
axiom (forall Maps._default.MapRemove$K: Ty, 
    Maps._default.MapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
       && $Is(ks#0, TSet(Maps._default.MapRemove$K))
     ==> Maps.__default.MapRemove#requires(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRemove(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, Maps._default.MapRemove$V, $LS($ly), m#0, ks#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove$K) && Map#Domain(m#0)[$w#1] && !ks#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove$K: Ty, 
      Maps._default.MapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemove(Maps._default.MapRemove$K, 
        Maps._default.MapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemove#canCall(Maps._default.MapRemove$K, Maps._default.MapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V))
           && $Is(ks#0, TSet(Maps._default.MapRemove$K)))
       ==> Maps.__default.MapRemove(Maps._default.MapRemove$K, 
          Maps._default.MapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove$K)
                   && 
                  Map#Domain(m#0)[$w#3]
                   && !Lit(ks#0)[$w#3]), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove$K, Maps._default.MapRemove$V)); 
          m'#1));

// function declaration for Maps._default.MapRemoveStrong
function Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      $LS($ly), 
      m#0, 
      ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
      Maps._default.MapRemoveStrong$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
     == Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.MapRemoveStrong
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)), 
          Set#Difference(Map#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemoveStrong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0), 
          TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V)));

function Maps.__default.MapRemoveStrong#requires(Ty, Ty, LayerType, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRemoveStrong
axiom (forall Maps._default.MapRemoveStrong$K: Ty, 
    Maps._default.MapRemoveStrong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
       && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K))
     ==> Maps.__default.MapRemoveStrong#requires(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, $ly, m#0, ks#0)
       == true);

const MoreFuel_Maps._default.MapRemove0: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        m#0, 
        ks#0) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V, m#0, ks#0)
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove0)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove0))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove0)
           == MoreFuel_Maps._default.MapRemove0
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            m#0, 
            ks#0)
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            m#0, 
            ks#0));

const MoreFuel_Maps._default.MapRemove1: LayerType;

// definition axiom for Maps.__default.MapRemoveStrong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemoveStrong$K: Ty, 
      Maps._default.MapRemoveStrong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
        Maps._default.MapRemoveStrong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.MapRemoveStrong#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRemoveStrong$K, Maps._default.MapRemoveStrong$V))
           && $Is(ks#0, TSet(Maps._default.MapRemoveStrong$K)))
       ==> Maps.__default.MapRemove#canCall(Maps._default.MapRemoveStrong$K, 
          Maps._default.MapRemoveStrong$V, 
          Lit(m#0), 
          Lit(ks#0))
         && 
        StartFuel_Maps._default.MapRemove == $LS(MoreFuel_Maps._default.MapRemove1)
         && StartFuelAssert_Maps._default.MapRemove
           == $LS($LS(MoreFuel_Maps._default.MapRemove1))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove1)
           == MoreFuel_Maps._default.MapRemove1
         && Maps.__default.MapRemoveStrong(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(ks#0))
           == Maps.__default.MapRemove(Maps._default.MapRemoveStrong$K, 
            Maps._default.MapRemoveStrong$V, 
            StartFuel_Maps._default.MapRemove, 
            Lit(m#0), 
            Lit(ks#0)));

// function declaration for Maps._default.MapRemove1
function Maps.__default.MapRemove1(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
      Maps._default.MapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.MapRemove1
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> (forall j#0: Box :: 
          { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { Map#Domain(m#0)[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(m#0)[j#0] && j#0 != k#0
             ==> Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#0])
         && (forall j#1: Box :: 
          { Map#Domain(m#0)[j#1] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1] } 
          $IsBox(j#1, Maps._default.MapRemove1$K)
             ==> (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> Map#Domain(m#0)[j#1])
               && (Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#1]
                 ==> j#1 != k#0))
         && (forall j#2: Box :: 
          { Map#Elements(m#0)[j#2] } 
            { Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
            { Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2] } 
          $IsBox(j#2, Maps._default.MapRemove1$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
             ==> Map#Elements(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))[j#2]
               == Map#Elements(m#0)[j#2])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)))
           <= Set#Card(Map#Domain(m#0))
         && (Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0) - 1)
         && (!Map#Domain(m#0)[k#0]
           ==> Map#Card(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0))
             == Map#Card(m#0))
         && $Is(Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0), 
          TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)));

function Maps.__default.MapRemove1#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1
axiom (forall Maps._default.MapRemove1$K: Ty, 
    Maps._default.MapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
       && $IsBox(k#0, Maps._default.MapRemove1$K)
     ==> Maps.__default.MapRemove1#requires(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.MapRemove1(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), m#0, k#0)
         == (var m'#0 := Map#Glue((lambda $w#1: Box :: 
                $IsBox($w#1, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#1] && $w#1 != k#0), 
              (lambda $w#1: Box :: Map#Elements(m#0)[$w#1]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#0));

// definition axiom for Maps.__default.MapRemove1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, $LS($ly), Lit(m#0), k#0)
         == (var m'#1 := Map#Glue((lambda $w#3: Box :: 
                $IsBox($w#3, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#3] && $w#3 != k#0), 
              (lambda $w#3: Box :: Map#Elements(Lit(m#0))[$w#3]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#1));

// definition axiom for Maps.__default.MapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1$K: Ty, 
      Maps._default.MapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
        Maps._default.MapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V))
           && $IsBox(k#0, Maps._default.MapRemove1$K))
       ==> Maps.__default.MapRemove1(Maps._default.MapRemove1$K, 
          Maps._default.MapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == (var m'#2 := Map#Glue((lambda $w#5: Box :: 
                $IsBox($w#5, Maps._default.MapRemove1$K) && Map#Domain(m#0)[$w#5] && $w#5 != k#0), 
              (lambda $w#5: Box :: Map#Elements(Lit(m#0))[$w#5]), 
              TMap(Maps._default.MapRemove1$K, Maps._default.MapRemove1$V)); 
          m'#2));

// function declaration for Maps._default.MapRemove1Strong
function Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box)
   : Map Box Box;

function Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    m#0: Map Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LS($ly), 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0));

// fuel synonym axiom
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0)
     == Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $LZ, 
      m#0, 
      k#0));

// consequence axiom for Maps.__default.MapRemove1Strong
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Set#Equal(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0)), 
          Set#Difference(Map#Domain(m#0), Set#UnionOne(Set#Empty(): Set Box, k#0)))
         && (forall j#0: Box :: 
          { Map#Elements(m#0)[j#0] } 
            { Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
            { Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0] } 
          $IsBox(j#0, Maps._default.MapRemove1Strong$K)
             ==> 
            Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0))[j#0]
             ==> Map#Elements(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                  Maps._default.MapRemove1Strong$V, 
                  $ly, 
                  m#0, 
                  k#0))[j#0]
               == Map#Elements(m#0)[j#0])
         && Set#Card(Map#Domain(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
                Maps._default.MapRemove1Strong$V, 
                $ly, 
                m#0, 
                k#0)))
           <= Set#Card(Map#Domain(m#0))
         && Map#Card(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
              Maps._default.MapRemove1Strong$V, 
              $ly, 
              m#0, 
              k#0))
           <= Map#Card(m#0)
         && $Is(Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $ly, 
            m#0, 
            k#0), 
          TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V)));

function Maps.__default.MapRemove1Strong#requires(Ty, Ty, LayerType, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapRemove1Strong
axiom (forall Maps._default.MapRemove1Strong$K: Ty, 
    Maps._default.MapRemove1Strong$V: Ty, 
    $ly: LayerType, 
    m#0: Map Box Box, 
    k#0: Box :: 
  { Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
      Maps._default.MapRemove1Strong$V, 
      $ly, 
      m#0, 
      k#0) } 
  $Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
       && $IsBox(k#0, Maps._default.MapRemove1Strong$K)
     ==> Maps.__default.MapRemove1Strong#requires(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $ly, 
        m#0, 
        k#0)
       == true);

const MoreFuel_Maps._default.MapRemove10: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        m#0, 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V, m#0, k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove10)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove10))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove10)
           == MoreFuel_Maps._default.MapRemove10
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            m#0, 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            m#0, 
            k#0));

const MoreFuel_Maps._default.MapRemove11: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        k#0) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          k#0)
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove11)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove11))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove11)
           == MoreFuel_Maps._default.MapRemove11
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            k#0)
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            k#0));

const MoreFuel_Maps._default.MapRemove12: LayerType;

// definition axiom for Maps.__default.MapRemove1Strong for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRemove1Strong$K: Ty, 
      Maps._default.MapRemove1Strong$V: Ty, 
      $ly: LayerType, 
      m#0: Map Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
        Maps._default.MapRemove1Strong$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.MapRemove1Strong#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         || ($Is(m#0, TMap(Maps._default.MapRemove1Strong$K, Maps._default.MapRemove1Strong$V))
           && $IsBox(k#0, Maps._default.MapRemove1Strong$K))
       ==> Maps.__default.MapRemove1#canCall(Maps._default.MapRemove1Strong$K, 
          Maps._default.MapRemove1Strong$V, 
          Lit(m#0), 
          Lit(k#0))
         && 
        StartFuel_Maps._default.MapRemove1 == $LS(MoreFuel_Maps._default.MapRemove12)
         && StartFuelAssert_Maps._default.MapRemove1
           == $LS($LS(MoreFuel_Maps._default.MapRemove12))
         && AsFuelBottom(MoreFuel_Maps._default.MapRemove12)
           == MoreFuel_Maps._default.MapRemove12
         && Maps.__default.MapRemove1Strong(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            $LS($ly), 
            Lit(m#0), 
            Lit(k#0))
           == Maps.__default.MapRemove1(Maps._default.MapRemove1Strong$K, 
            Maps._default.MapRemove1Strong$V, 
            StartFuel_Maps._default.MapRemove1, 
            Lit(m#0), 
            Lit(k#0)));

// function declaration for Maps._default.IMapRemove
function Maps.__default.IMapRemove(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
      Maps._default.IMapRemove$V, 
      AsFuelBottom($ly), 
      m#0, 
      ks#0) } 
  Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
     == Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LZ, m#0, ks#0));

// consequence axiom for Maps.__default.IMapRemove
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)), 
          ISet#Difference(IMap#Domain(m#0), ks#0))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

function Maps.__default.IMapRemove#requires(Ty, Ty, LayerType, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRemove
axiom (forall Maps._default.IMapRemove$K: Ty, 
    Maps._default.IMapRemove$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
       && $Is(ks#0, TISet(Maps._default.IMapRemove$K))
     ==> Maps.__default.IMapRemove#requires(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $ly, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRemove(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, $LS($ly), m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && !ks#0[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// definition axiom for Maps.__default.IMapRemove for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove$K: Ty, 
      Maps._default.IMapRemove$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
        Maps._default.IMapRemove$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(ks#0)) } 
    Maps.__default.IMapRemove#canCall(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V))
           && $Is(ks#0, TISet(Maps._default.IMapRemove$K)))
       ==> Maps.__default.IMapRemove(Maps._default.IMapRemove$K, 
          Maps._default.IMapRemove$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && !Lit(ks#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove$K, Maps._default.IMapRemove$V)));

// function declaration for Maps._default.IMapRemove1
function Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box)
   : IMap Box Box;

function Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    m#0: IMap Box Box, 
    k#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
      Maps._default.IMapRemove1$V, 
      AsFuelBottom($ly), 
      m#0, 
      k#0) } 
  Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
     == Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LZ, m#0, k#0));

// consequence axiom for Maps.__default.IMapRemove1
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)), 
          ISet#Difference(IMap#Domain(m#0), ISet#UnionOne(ISet#Empty(): ISet Box, k#0)))
         && (forall j#0: Box :: 
          { IMap#Elements(m#0)[j#0] } 
            { IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
            { IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0] } 
          $IsBox(j#0, Maps._default.IMapRemove1$K)
             ==> 
            IMap#Domain(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
             ==> IMap#Elements(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0))[j#0]
               == IMap#Elements(m#0)[j#0])
         && $Is(Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

function Maps.__default.IMapRemove1#requires(Ty, Ty, LayerType, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.IMapRemove1
axiom (forall Maps._default.IMapRemove1$K: Ty, 
    Maps._default.IMapRemove1$V: Ty, 
    $ly: LayerType, 
    m#0: IMap Box Box, 
    k#0: Box :: 
  { Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
       && $IsBox(k#0, Maps._default.IMapRemove1$K)
     ==> Maps.__default.IMapRemove1#requires(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $ly, m#0, k#0)
       == true);

// definition axiom for Maps.__default.IMapRemove1(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, m#0, k#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, $LS($ly), m#0, k#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#0]
               && $w#0 != k#0), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// definition axiom for Maps.__default.IMapRemove1 for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRemove1$K: Ty, 
      Maps._default.IMapRemove1$V: Ty, 
      $ly: LayerType, 
      m#0: IMap Box Box, 
      k#0: Box :: 
    {:weight 3} { Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
        Maps._default.IMapRemove1$V, 
        $LS($ly), 
        Lit(m#0), 
        Lit(k#0)) } 
    Maps.__default.IMapRemove1#canCall(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V, Lit(m#0), Lit(k#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V))
           && $IsBox(k#0, Maps._default.IMapRemove1$K))
       ==> Maps.__default.IMapRemove1(Maps._default.IMapRemove1$K, 
          Maps._default.IMapRemove1$V, 
          $LS($ly), 
          Lit(m#0), 
          Lit(k#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRemove1$K)
               && 
              IMap#Domain(m#0)[$w#1]
               && $w#1 != k#0), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRemove1$K, Maps._default.IMapRemove1$V)));

// function declaration for Maps._default.MapRestrict
function Maps.__default.MapRestrict(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : Map Box Box;

function Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box)
   : bool;

// consequence axiom for Maps.__default.MapRestrict
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> $Is(Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

function Maps.__default.MapRestrict#requires(Ty, Ty, Map Box Box, Set Box) : bool;

// #requires axiom for Maps.__default.MapRestrict
axiom (forall Maps._default.MapRestrict$K: Ty, 
    Maps._default.MapRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: Set Box :: 
  { Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
       && $Is(ks#0, TSet(Maps._default.MapRestrict$K))
     ==> Maps.__default.MapRestrict#requires(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapRestrict$K) && ks#0[$w#0] && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// definition axiom for Maps.__default.MapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapRestrict$K: Ty, 
      Maps._default.MapRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: Set Box :: 
    {:weight 3} { Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapRestrict#canCall(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V))
           && $Is(ks#0, TSet(Maps._default.MapRestrict$K)))
       ==> Maps.__default.MapRestrict(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapRestrict$K, Maps._default.MapRestrict$V)));

// function declaration for Maps._default.MapIRestrict
function Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : Map Box Box;

function Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.MapIRestrict
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> $Is(Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0), 
        TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

function Maps.__default.MapIRestrict#requires(Ty, Ty, Map Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.MapIRestrict
axiom (forall Maps._default.MapIRestrict$K: Ty, 
    Maps._default.MapIRestrict$V: Ty, 
    m#0: Map Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
  $Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
       && $Is(ks#0, TISet(Maps._default.MapIRestrict$K))
     ==> Maps.__default.MapIRestrict#requires(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.MapIRestrict(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, m#0, ks#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#0]
               && ks#0[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), ks#0)
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#1]
               && ks#0[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// definition axiom for Maps.__default.MapIRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapIRestrict$K: Ty, 
      Maps._default.MapIRestrict$V: Ty, 
      m#0: Map Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.MapIRestrict#canCall(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V))
           && $Is(ks#0, TISet(Maps._default.MapIRestrict$K)))
       ==> Maps.__default.MapIRestrict(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V, Lit(m#0), Lit(ks#0))
         == Map#Glue((lambda $w#2: Box :: 
            $IsBox($w#2, Maps._default.MapIRestrict$K)
               && 
              Map#Domain(m#0)[$w#2]
               && Lit(ks#0)[$w#2]), 
          (lambda $w#2: Box :: Map#Elements(Lit(m#0))[$w#2]), 
          TMap(Maps._default.MapIRestrict$K, Maps._default.MapIRestrict$V)));

// function declaration for Maps._default.IMapRestrict
function Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : IMap Box Box;

function Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box)
   : bool;

// consequence axiom for Maps.__default.IMapRestrict
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> $Is(Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0), 
        TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

function Maps.__default.IMapRestrict#requires(Ty, Ty, IMap Box Box, ISet Box) : bool;

// #requires axiom for Maps.__default.IMapRestrict
axiom (forall Maps._default.IMapRestrict$K: Ty, 
    Maps._default.IMapRestrict$V: Ty, 
    m#0: IMap Box Box, 
    ks#0: ISet Box :: 
  { Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
  $Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
       && $Is(ks#0, TISet(Maps._default.IMapRestrict$K))
     ==> Maps.__default.IMapRestrict#requires(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
       == true);

// definition axiom for Maps.__default.IMapRestrict(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, m#0, ks#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapRestrict$K)
               && 
              ks#0[$w#0]
               && IMap#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: IMap#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// definition axiom for Maps.__default.IMapRestrict for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapRestrict$K: Ty, 
      Maps._default.IMapRestrict$V: Ty, 
      m#0: IMap Box Box, 
      ks#0: ISet Box :: 
    {:weight 3} { Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0)) } 
    Maps.__default.IMapRestrict#canCall(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         || ($Is(m#0, TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V))
           && $Is(ks#0, TISet(Maps._default.IMapRestrict$K)))
       ==> Maps.__default.IMapRestrict(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V, Lit(m#0), Lit(ks#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapRestrict$K)
               && 
              Lit(ks#0)[$w#1]
               && IMap#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: IMap#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.IMapRestrict$K, Maps._default.IMapRestrict$V)));

// function declaration for Maps._default.MapDisjointUnion
function Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapDisjointUnion
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
              Maps._default.MapDisjointUnion$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                Maps._default.MapDisjointUnion$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
                  Maps._default.MapDisjointUnion$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1])
         && $Is(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
            Maps._default.MapDisjointUnion$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

function Maps.__default.MapDisjointUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion
axiom (forall Maps._default.MapDisjointUnion$U: Ty, 
    Maps._default.MapDisjointUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
      Maps._default.MapDisjointUnion$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
     ==> Maps.__default.MapDisjointUnion#requires(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)));

// definition axiom for Maps.__default.MapDisjointUnion(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          mapa#0, 
          mapb#0)
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0)))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// definition axiom for Maps.__default.MapDisjointUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion$U: Ty, 
      Maps._default.MapDisjointUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
        Maps._default.MapDisjointUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapDisjointUnion#canCall(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || (
          $Is(mapa#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))))
       ==> Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion$U, 
          Maps._default.MapDisjointUnion$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapDisjointUnion$U, Maps._default.MapDisjointUnion$T)));

// function declaration for Maps._default.MapUnionPreferA
function Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferA
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
              Maps._default.MapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapa#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapb#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                Maps._default.MapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferA$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
                  Maps._default.MapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
            Maps._default.MapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

function Maps.__default.MapUnionPreferA#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferA
axiom (forall Maps._default.MapUnionPreferA$U: Ty, 
    Maps._default.MapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
      Maps._default.MapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
     ==> Maps.__default.MapUnionPreferA#requires(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferA$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else Map#Elements(mapb#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// definition axiom for Maps.__default.MapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferA$U: Ty, 
      Maps._default.MapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
        Maps._default.MapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)))
       ==> Maps.__default.MapUnionPreferA(Maps._default.MapUnionPreferA$U, 
          Maps._default.MapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferA$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else Map#Elements(Lit(mapb#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferA$U, Maps._default.MapUnionPreferA$T)));

// function declaration for Maps._default.MapUnionPreferB
function Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.MapUnionPreferB
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
              Maps._default.MapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(mapb#0)[k#0] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { Map#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == Map#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(mapa#0)[k#1] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#1] && !Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == Map#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                Maps._default.MapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { Map#Domain(mapb#0)[k#2] } 
            { Map#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnionPreferB$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && !Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
                  Maps._default.MapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == Map#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
            Maps._default.MapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

function Maps.__default.MapUnionPreferB#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnionPreferB
axiom (forall Maps._default.MapUnionPreferB$U: Ty, 
    Maps._default.MapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
      Maps._default.MapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
     ==> Maps.__default.MapUnionPreferB#requires(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapUnionPreferB$U)
               && (Map#Domain(mapa#0)[$w#0] || Map#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapb#0)[$w#0]
               then Map#Elements(mapb#0)[$w#0]
               else Map#Elements(mapa#0)[$w#0])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// definition axiom for Maps.__default.MapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnionPreferB$U: Ty, 
      Maps._default.MapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
        Maps._default.MapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnionPreferB#canCall(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)))
       ==> Maps.__default.MapUnionPreferB(Maps._default.MapUnionPreferB$U, 
          Maps._default.MapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapUnionPreferB$U)
               && (Lit(Map#Domain(Lit(mapa#0)))[$w#1] || Lit(Map#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapb#0)[$w#1]
               then Map#Elements(Lit(mapb#0))[$w#1]
               else Map#Elements(Lit(mapa#0))[$w#1])), 
          TMap(Maps._default.MapUnionPreferB$U, Maps._default.MapUnionPreferB$T)));

// function declaration for Maps._default.MapUnion
function Maps.__default.MapUnion(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
      Maps._default.MapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.MapUnion
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)), 
          Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#0] && !Map#Domain(mapb#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapb#0)[k#1] && !Map#Domain(mapa#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(mapa#0)[k#2] } 
            { Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { Map#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapUnion$U)
             ==> 
            Map#Domain(mapa#0)[k#2] && Map#Domain(mapb#0)[k#2]
             ==> Map#Elements(mapb#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || Map#Elements(mapa#0)[k#2]
                 == Map#Elements(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0), 
          TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)));

function Maps.__default.MapUnion#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapUnion
axiom (forall Maps._default.MapUnion$U: Ty, 
    Maps._default.MapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box :: 
  { Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
       && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
     ==> Maps.__default.MapUnion#requires(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.MapUnion(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    { Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, mapa#0, mapb#0)
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, Maps._default.MapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.MapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapUnion$U: Ty, 
      Maps._default.MapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapUnion(Maps._default.MapUnion$U, 
        Maps._default.MapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.MapUnion#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T))
           && $Is(mapb#0, TMap(Maps._default.MapUnion$U, Maps._default.MapUnion$T)))
       ==> Maps.__default.MapUnionPreferA#canCall(Maps._default.MapUnion$U, Maps._default.MapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.MapUnion(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.MapUnionPreferA(Maps._default.MapUnion$U, 
            Maps._default.MapUnion$T, 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.IMapUnionPreferA
function Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferA
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
              Maps._default.IMapUnionPreferA$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapa#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapa#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapa#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapb#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapb#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapb#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                Maps._default.IMapUnionPreferA$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferA$U)
             ==> 
            IMap#Domain(mapb#0)[k#2] && !IMap#Domain(mapa#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
                  Maps._default.IMapUnionPreferA$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapb#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
            Maps._default.IMapUnionPreferA$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

function Maps.__default.IMapUnionPreferA#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferA
axiom (forall Maps._default.IMapUnionPreferA$U: Ty, 
    Maps._default.IMapUnionPreferA$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
      Maps._default.IMapUnionPreferA$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
     ==> Maps.__default.IMapUnionPreferA#requires(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferA(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferA$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapa#0)[$w#0]
               then IMap#Elements(mapa#0)[$w#0]
               else IMap#Elements(mapb#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// definition axiom for Maps.__default.IMapUnionPreferA for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferA$U: Ty, 
      Maps._default.IMapUnionPreferA$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
        Maps._default.IMapUnionPreferA$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)))
       ==> Maps.__default.IMapUnionPreferA(Maps._default.IMapUnionPreferA$U, 
          Maps._default.IMapUnionPreferA$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferA$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapa#0)[$w#1]
               then IMap#Elements(Lit(mapa#0))[$w#1]
               else IMap#Elements(Lit(mapb#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferA$U, Maps._default.IMapUnionPreferA$T)));

// function declaration for Maps._default.IMapUnionPreferB
function Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0)
     == Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $LZ, 
      mapa#0, 
      mapb#0));

// consequence axiom for Maps.__default.IMapUnionPreferB
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
              Maps._default.IMapUnionPreferB$T, 
              $ly, 
              mapa#0, 
              mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(mapb#0)[k#0] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#0] } 
            { IMap#Domain(mapb#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#0]
               == IMap#Elements(mapb#0)[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(mapa#0)[k#1] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#1] && !IMap#Domain(mapb#0)[k#1]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#1]
               == IMap#Elements(mapa#0)[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                Maps._default.IMapUnionPreferB$T, 
                $ly, 
                mapa#0, 
                mapb#0))[k#2] } 
            { IMap#Domain(mapb#0)[k#2] } 
            { IMap#Domain(mapa#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnionPreferB$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && !IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
                  Maps._default.IMapUnionPreferB$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0))[k#2]
               == IMap#Elements(mapa#0)[k#2])
         && $Is(Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
            Maps._default.IMapUnionPreferB$T, 
            $ly, 
            mapa#0, 
            mapb#0), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

function Maps.__default.IMapUnionPreferB#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnionPreferB
axiom (forall Maps._default.IMapUnionPreferB$U: Ty, 
    Maps._default.IMapUnionPreferB$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
      Maps._default.IMapUnionPreferB$T, 
      $ly, 
      mapa#0, 
      mapb#0) } 
  $Is(mapa#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
       && $Is(mapb#0, 
        TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
     ==> Maps.__default.IMapUnionPreferB#requires(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $ly, 
        mapa#0, 
        mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnionPreferB(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          mapa#0, 
          mapb#0)
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.IMapUnionPreferB$U)
               && (IMap#Domain(mapa#0)[$w#0] || IMap#Domain(mapb#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if IMap#Domain(mapb#0)[$w#0]
               then IMap#Elements(mapb#0)[$w#0]
               else IMap#Elements(mapa#0)[$w#0])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// definition axiom for Maps.__default.IMapUnionPreferB for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnionPreferB$U: Ty, 
      Maps._default.IMapUnionPreferB$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
        Maps._default.IMapUnionPreferB$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnionPreferB#canCall(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          Lit(mapa#0), 
          Lit(mapb#0))
         || ($Is(mapa#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T))
           && $Is(mapb#0, 
            TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)))
       ==> Maps.__default.IMapUnionPreferB(Maps._default.IMapUnionPreferB$U, 
          Maps._default.IMapUnionPreferB$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.IMapUnionPreferB$U)
               && (Lit(IMap#Domain(Lit(mapa#0)))[$w#1] || Lit(IMap#Domain(Lit(mapb#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if IMap#Domain(mapb#0)[$w#1]
               then IMap#Elements(Lit(mapb#0))[$w#1]
               else IMap#Elements(Lit(mapa#0))[$w#1])), 
          TIMap(Maps._default.IMapUnionPreferB$U, Maps._default.IMapUnionPreferB$T)));

// function declaration for Maps._default.IMapUnion
function Maps.__default.IMapUnion(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : IMap Box Box;

function Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0));

// fuel synonym axiom
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
      Maps._default.IMapUnion$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0) } 
  Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
     == Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LZ, mapa#0, mapb#0));

// consequence axiom for Maps.__default.IMapUnion
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> ISet#Equal(IMap#Domain(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)), 
          ISet#Union(IMap#Domain(mapa#0), IMap#Domain(mapb#0)))
         && (forall k#0: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0] } 
            { IMap#Elements(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#0] && !IMap#Domain(mapb#0)[k#0]
             ==> IMap#Elements(mapa#0)[k#0]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#0])
         && (forall k#1: Box :: 
          { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1] } 
            { IMap#Elements(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapb#0)[k#1] && !IMap#Domain(mapa#0)[k#1]
             ==> IMap#Elements(mapb#0)[k#1]
               == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#1])
         && (forall k#2: Box :: 
          { IMap#Elements(mapa#0)[k#2] } 
            { IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2] } 
            { IMap#Elements(mapb#0)[k#2] } 
          $IsBox(k#2, Maps._default.IMapUnion$U)
             ==> 
            IMap#Domain(mapa#0)[k#2] && IMap#Domain(mapb#0)[k#2]
             ==> IMap#Elements(mapb#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2]
               || IMap#Elements(mapa#0)[k#2]
                 == IMap#Elements(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0))[k#2])
         && $Is(Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0), 
          TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)));

function Maps.__default.IMapUnion#requires(Ty, Ty, LayerType, IMap Box Box, IMap Box Box) : bool;

// #requires axiom for Maps.__default.IMapUnion
axiom (forall Maps._default.IMapUnion$U: Ty, 
    Maps._default.IMapUnion$T: Ty, 
    $ly: LayerType, 
    mapa#0: IMap Box Box, 
    mapb#0: IMap Box Box :: 
  { Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0) } 
  $Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
       && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
     ==> Maps.__default.IMapUnion#requires(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $ly, mapa#0, mapb#0)
       == true);

// definition axiom for Maps.__default.IMapUnion(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, mapa#0, mapb#0)
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, $LS($ly), mapa#0, mapb#0)
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            mapa#0, 
            mapb#0));

// definition axiom for Maps.__default.IMapUnion for all literals(revealed)
axiom true
   ==> (forall Maps._default.IMapUnion$U: Ty, 
      Maps._default.IMapUnion$T: Ty, 
      $ly: LayerType, 
      mapa#0: IMap Box Box, 
      mapb#0: IMap Box Box :: 
    {:weight 3} { Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
        Maps._default.IMapUnion$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0)) } 
    Maps.__default.IMapUnion#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         || ($Is(mapa#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T))
           && $Is(mapb#0, TIMap(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T)))
       ==> Maps.__default.IMapUnionPreferA#canCall(Maps._default.IMapUnion$U, Maps._default.IMapUnion$T, Lit(mapa#0), Lit(mapb#0))
         && Maps.__default.IMapUnion(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            $LS($ly), 
            Lit(mapa#0), 
            Lit(mapb#0))
           == Maps.__default.IMapUnionPreferA(Maps._default.IMapUnion$U, 
            Maps._default.IMapUnion$T, 
            StartFuel_Maps._default.IMapUnionPreferA, 
            Lit(mapa#0), 
            Lit(mapb#0)));

// function declaration for Maps._default.MapDisjointUnion3
function Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : Map Box Box;

function Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LS($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// fuel synonym axiom
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      AsFuelBottom($ly), 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0)
     == Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $LZ, 
      mapa#0, 
      mapb#0, 
      mapc#0));

// consequence axiom for Maps.__default.MapDisjointUnion3
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              $ly, 
              mapa#0, 
              mapb#0, 
              mapc#0)), 
          Set#Union(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
         && (!Set#Equal(Map#Domain(mapa#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapb#0), Set#Empty(): Set Box)
             || !Set#Equal(Map#Domain(mapc#0), Set#Empty(): Set Box)
           ==> !Set#Equal(Map#Domain(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0)), 
            Set#Empty(): Set Box))
         && (forall k#0: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#0] } 
            { Map#Elements(mapa#0)[k#0] } 
            { Map#Domain(mapa#0)[k#0] } 
          $IsBox(k#0, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapa#0)[k#0]
             ==> Map#Elements(mapa#0)[k#0]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#0])
         && (forall k#1: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#1] } 
            { Map#Elements(mapb#0)[k#1] } 
            { Map#Domain(mapb#0)[k#1] } 
          $IsBox(k#1, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapb#0)[k#1]
             ==> Map#Elements(mapb#0)[k#1]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#1])
         && (forall k#2: Box :: 
          { Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                Maps._default.MapDisjointUnion3$T, 
                $ly, 
                mapa#0, 
                mapb#0, 
                mapc#0))[k#2] } 
            { Map#Elements(mapc#0)[k#2] } 
            { Map#Domain(mapc#0)[k#2] } 
          $IsBox(k#2, Maps._default.MapDisjointUnion3$U)
             ==> 
            Map#Domain(mapc#0)[k#2]
             ==> Map#Elements(mapc#0)[k#2]
               == Map#Elements(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
                  Maps._default.MapDisjointUnion3$T, 
                  $ly, 
                  mapa#0, 
                  mapb#0, 
                  mapc#0))[k#2])
         && 
        Map#Equal(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)))
         && Map#Equal(Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            mapa#0, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapb#0, 
              mapc#0)), 
          Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            StartFuel_Maps._default.MapDisjointUnion, 
            Maps.__default.MapDisjointUnion(Maps._default.MapDisjointUnion3$U, 
              Maps._default.MapDisjointUnion3$T, 
              StartFuel_Maps._default.MapDisjointUnion, 
              mapa#0, 
              mapb#0), 
            mapc#0))
         && $Is(Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
            Maps._default.MapDisjointUnion3$T, 
            $ly, 
            mapa#0, 
            mapb#0, 
            mapc#0), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

function Maps.__default.MapDisjointUnion3#requires(Ty, Ty, LayerType, Map Box Box, Map Box Box, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapDisjointUnion3
axiom (forall Maps._default.MapDisjointUnion3$U: Ty, 
    Maps._default.MapDisjointUnion3$T: Ty, 
    $ly: LayerType, 
    mapa#0: Map Box Box, 
    mapb#0: Map Box Box, 
    mapc#0: Map Box Box :: 
  { Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
      Maps._default.MapDisjointUnion3$T, 
      $ly, 
      mapa#0, 
      mapb#0, 
      mapc#0) } 
  $Is(mapa#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapb#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
       && $Is(mapc#0, 
        TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
     ==> Maps.__default.MapDisjointUnion3#requires(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $ly, 
        mapa#0, 
        mapb#0, 
        mapc#0)
       == (
        Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
         && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0))));

// definition axiom for Maps.__default.MapDisjointUnion3(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        mapa#0, 
        mapb#0, 
        mapc#0) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          mapa#0, 
          mapb#0, 
          mapc#0)
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Map#Domain(mapa#0), Map#Domain(mapb#0))
           && Set#Disjoint(Set#Union(Map#Domain(mapa#0), Map#Domain(mapb#0)), Map#Domain(mapc#0)))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          mapa#0, 
          mapb#0, 
          mapc#0)
         == Map#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapDisjointUnion3$U)
               && (
                Map#Domain(mapa#0)[$w#0]
                 || Map#Domain(mapb#0)[$w#0]
                 || Map#Domain(mapc#0)[$w#0])), 
          (lambda $w#0: Box :: 
            (if Map#Domain(mapa#0)[$w#0]
               then Map#Elements(mapa#0)[$w#0]
               else (if Map#Domain(mapb#0)[$w#0]
                 then Map#Elements(mapb#0)[$w#0]
                 else Map#Elements(mapc#0)[$w#0]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// definition axiom for Maps.__default.MapDisjointUnion3 for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapDisjointUnion3$U: Ty, 
      Maps._default.MapDisjointUnion3$T: Ty, 
      $ly: LayerType, 
      mapa#0: Map Box Box, 
      mapb#0: Map Box Box, 
      mapc#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
        Maps._default.MapDisjointUnion3$T, 
        $LS($ly), 
        Lit(mapa#0), 
        Lit(mapb#0), 
        Lit(mapc#0)) } 
    Maps.__default.MapDisjointUnion3#canCall(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         || (
          $Is(mapa#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapb#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && $Is(mapc#0, 
            TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T))
           && 
          Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0)))
           && Set#Disjoint(Set#Union(Map#Domain(Lit(mapa#0)), Map#Domain(Lit(mapb#0))), 
            Map#Domain(Lit(mapc#0))))
       ==> Maps.__default.MapDisjointUnion3(Maps._default.MapDisjointUnion3$U, 
          Maps._default.MapDisjointUnion3$T, 
          $LS($ly), 
          Lit(mapa#0), 
          Lit(mapb#0), 
          Lit(mapc#0))
         == Map#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapDisjointUnion3$U)
               && (
                Lit(Map#Domain(Lit(mapa#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapb#0)))[$w#1]
                 || Lit(Map#Domain(Lit(mapc#0)))[$w#1])), 
          (lambda $w#1: Box :: 
            (if Map#Domain(mapa#0)[$w#1]
               then Map#Elements(Lit(mapa#0))[$w#1]
               else (if Map#Domain(mapb#0)[$w#1]
                 then Map#Elements(Lit(mapb#0))[$w#1]
                 else Map#Elements(Lit(mapc#0))[$w#1]))), 
          TMap(Maps._default.MapDisjointUnion3$U, Maps._default.MapDisjointUnion3$T)));

// function declaration for Maps._default.MapToImap
function Maps.__default.MapToImap(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : IMap Box Box;

function Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box)
   : bool;

// consequence axiom for Maps.__default.MapToImap
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> $Is(Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0), 
        TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

function Maps.__default.MapToImap#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Maps.__default.MapToImap
axiom (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
  { Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
  $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
     ==> Maps.__default.MapToImap#requires(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
       == true);

// definition axiom for Maps.__default.MapToImap(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, m#0)
         == IMap#Glue((lambda $w#0: Box :: 
            $IsBox($w#0, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#0]), 
          (lambda $w#0: Box :: Map#Elements(m#0)[$w#0]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// definition axiom for Maps.__default.MapToImap for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapToImap$K: Ty, Maps._default.MapToImap$V: Ty, m#0: Map Box Box :: 
    {:weight 3} { Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0)) } 
    Maps.__default.MapToImap#canCall(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         || $Is(m#0, TMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V))
       ==> Maps.__default.MapToImap(Maps._default.MapToImap$K, Maps._default.MapToImap$V, Lit(m#0))
         == IMap#Glue((lambda $w#1: Box :: 
            $IsBox($w#1, Maps._default.MapToImap$K) && Map#Domain(m#0)[$w#1]), 
          (lambda $w#1: Box :: Map#Elements(Lit(m#0))[$w#1]), 
          TIMap(Maps._default.MapToImap$K, Maps._default.MapToImap$V)));

// function declaration for Maps._default.MapLookupOption
function Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.MapLookupOption
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> $Is(Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.MapLookupOption$V)));

function Maps.__default.MapLookupOption#requires(Ty, Ty, Map Box Box, Box) : bool;

// #requires axiom for Maps.__default.MapLookupOption
axiom (forall Maps._default.MapLookupOption$K: Ty, 
    Maps._default.MapLookupOption$V: Ty, 
    m#0: Map Box Box, 
    key#0: Box :: 
  { Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
       && $IsBox(key#0, Maps._default.MapLookupOption$K)
     ==> Maps.__default.MapLookupOption#requires(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.MapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V, m#0, key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for decreasing-related literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        key#0) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          key#0)
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.MapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.MapLookupOption$K: Ty, 
      Maps._default.MapLookupOption$V: Ty, 
      m#0: Map Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
        Maps._default.MapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.MapLookupOption#canCall(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TMap(Maps._default.MapLookupOption$K, Maps._default.MapLookupOption$V))
           && $IsBox(key#0, Maps._default.MapLookupOption$K))
       ==> Maps.__default.MapLookupOption(Maps._default.MapLookupOption$K, 
          Maps._default.MapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if Map#Domain(m#0)[key#0]
           then #Options.Option.Some(Map#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

// function declaration for Maps._default.ImapLookupOption
function Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : DatatypeType;

function Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box)
   : bool;

// consequence axiom for Maps.__default.ImapLookupOption
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> $Is(Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0), 
        Tclass.Options.Option(Maps._default.ImapLookupOption$V)));

function Maps.__default.ImapLookupOption#requires(Ty, Ty, IMap Box Box, Box) : bool;

// #requires axiom for Maps.__default.ImapLookupOption
axiom (forall Maps._default.ImapLookupOption$K: Ty, 
    Maps._default.ImapLookupOption$V: Ty, 
    m#0: IMap Box Box, 
    key#0: Box :: 
  { Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
  $Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
       && $IsBox(key#0, Maps._default.ImapLookupOption$K)
     ==> Maps.__default.ImapLookupOption#requires(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
       == true);

// definition axiom for Maps.__default.ImapLookupOption(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V, m#0, key#0)
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(m#0)[key#0])
           else #Options.Option.None()));

// definition axiom for Maps.__default.ImapLookupOption for all literals(revealed)
axiom true
   ==> (forall Maps._default.ImapLookupOption$K: Ty, 
      Maps._default.ImapLookupOption$V: Ty, 
      m#0: IMap Box Box, 
      key#0: Box :: 
    {:weight 3} { Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
        Maps._default.ImapLookupOption$V, 
        Lit(m#0), 
        Lit(key#0)) } 
    Maps.__default.ImapLookupOption#canCall(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         || ($Is(m#0, TIMap(Maps._default.ImapLookupOption$K, Maps._default.ImapLookupOption$V))
           && $IsBox(key#0, Maps._default.ImapLookupOption$K))
       ==> Maps.__default.ImapLookupOption(Maps._default.ImapLookupOption$K, 
          Maps._default.ImapLookupOption$V, 
          Lit(m#0), 
          Lit(key#0))
         == (if IMap#Domain(m#0)[key#0]
           then #Options.Option.Some(IMap#Elements(Lit(m#0))[Lit(key#0)])
           else #Options.Option.None()));

const unique class.Sets.__default: ClassName;

function Tclass.Sets.__default() : Ty;

// Tclass.Sets.__default Tag
axiom Tag(Tclass.Sets.__default()) == Tagclass.Sets.__default;

const unique Tagclass.Sets.__default: TyTag;

// Box/unbox axiom for Tclass.Sets.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sets.__default()) } 
  $IsBox(bx, Tclass.Sets.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Sets.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sets.__default()) } 
  $Is($o, Tclass.Sets.__default())
     <==> $o == null || dtype($o) == Tclass.Sets.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sets.__default(), $h) } 
  $IsAlloc($o, Tclass.Sets.__default(), $h) <==> $o == null || read($h, $o, alloc));

procedure {:opaque} CheckWellformed$$Sets.__default.SetInclusionImpliesSmallerCardinality(Sets._default.SetInclusionImpliesSmallerCardinality$T: Ty, 
    a#0: Set Box
       where $Is(a#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T))
         && $IsAlloc(a#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T), $Heap), 
    b#0: Set Box
       where $Is(b#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T))
         && $IsAlloc(b#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T), $Heap));
  free requires 3 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:opaque} Call$$Sets.__default.SetInclusionImpliesSmallerCardinality(Sets._default.SetInclusionImpliesSmallerCardinality$T: Ty, 
    a#0: Set Box
       where $Is(a#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T))
         && $IsAlloc(a#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T), $Heap), 
    b#0: Set Box
       where $Is(b#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T))
         && $IsAlloc(b#0, TSet(Sets._default.SetInclusionImpliesSmallerCardinality$T), $Heap));
  // user-defined preconditions
  requires Set#Subset(a#0, b#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Card(a#0) <= Set#Card(b#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:opaque} CheckWellformed$$Sets.__default.SetInclusionAndEqualCardinalityImpliesSetEquality(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T: Ty, 
    a#0: Set Box
       where $Is(a#0, TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T))
         && $IsAlloc(a#0, 
          TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T), 
          $Heap), 
    b#0: Set Box
       where $Is(b#0, TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T))
         && $IsAlloc(b#0, 
          TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T), 
          $Heap));
  free requires 5 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:opaque} Call$$Sets.__default.SetInclusionAndEqualCardinalityImpliesSetEquality(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T: Ty, 
    a#0: Set Box
       where $Is(a#0, TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T))
         && $IsAlloc(a#0, 
          TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T), 
          $Heap), 
    b#0: Set Box
       where $Is(b#0, TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T))
         && $IsAlloc(b#0, 
          TSet(Sets._default.SetInclusionAndEqualCardinalityImpliesSetEquality$T), 
          $Heap));
  // user-defined preconditions
  requires Set#Subset(a#0, b#0);
  requires Set#Card(a#0) == Set#Card(b#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures true;
  ensures Set#Equal(a#0, b#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for Sets._default.SetRange
function Sets.__default.SetRange(n#0: int) : Set Box;

function Sets.__default.SetRange#canCall(n#0: int) : bool;

// consequence axiom for Sets.__default.SetRange
axiom true
   ==> (forall n#0: int :: 
    { Sets.__default.SetRange(n#0) } 
    true ==> $Is(Sets.__default.SetRange(n#0), TSet(TInt)));

function Sets.__default.SetRange#requires(int) : bool;

// #requires axiom for Sets.__default.SetRange
axiom (forall n#0: int :: 
  { Sets.__default.SetRange#requires(n#0) } 
  Sets.__default.SetRange#requires(n#0) == true);

// definition axiom for Sets.__default.SetRange(revealed)
axiom true
   ==> (forall n#0: int :: 
    { Sets.__default.SetRange(n#0) } 
    true
       ==> Sets.__default.SetRange(n#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, TInt) && LitInt(0) <= $Unbox($y#0): int && $Unbox($y#0): int < n#0));

// definition axiom for Sets.__default.SetRange for all literals(revealed)
axiom true
   ==> (forall n#0: int :: 
    {:weight 3} { Sets.__default.SetRange(LitInt(n#0)) } 
    true
       ==> Sets.__default.SetRange(LitInt(n#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, TInt) && LitInt(0) <= $Unbox($y#1): int && $Unbox($y#1): int < n#0));

const unique class.Sequences.__default: ClassName;

function Tclass.Sequences.__default() : Ty;

// Tclass.Sequences.__default Tag
axiom Tag(Tclass.Sequences.__default()) == Tagclass.Sequences.__default;

const unique Tagclass.Sequences.__default: TyTag;

// Box/unbox axiom for Tclass.Sequences.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Sequences.__default()) } 
  $IsBox(bx, Tclass.Sequences.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Sequences.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Sequences.__default()) } 
  $Is($o, Tclass.Sequences.__default())
     <==> $o == null || dtype($o) == Tclass.Sequences.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Sequences.__default(), $h) } 
  $IsAlloc($o, Tclass.Sequences.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Sequences._default.Last
function Sequences.__default.Last(Sequences._default.Last$E: Ty, run#0: Seq Box) : Box;

function Sequences.__default.Last#canCall(Sequences._default.Last$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Last
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> $IsBox(Sequences.__default.Last(Sequences._default.Last$E, run#0), 
        Sequences._default.Last$E));

function Sequences.__default.Last#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Last
axiom (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.Last#requires(Sequences._default.Last$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Last$E))
     ==> Sequences.__default.Last#requires(Sequences._default.Last$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.Last(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.Last(Sequences._default.Last$E, run#0) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, run#0)
         == Seq#Index(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.Last for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Last$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0)) } 
    Sequences.__default.Last#canCall(Sequences._default.Last$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.Last$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.Last(Sequences._default.Last$E, Lit(run#0))
         == Seq#Index(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.DropLast
function Sequences.__default.DropLast(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : Seq Box;

function Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.DropLast
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> $Is(Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0), 
        TSeq(Sequences._default.DropLast$E)));

function Sequences.__default.DropLast#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.DropLast
axiom (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
  { Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0) } 
  $Is(run#0, TSeq(Sequences._default.DropLast$E))
     ==> Sequences.__default.DropLast#requires(Sequences._default.DropLast$E, run#0)
       == (Seq#Length(run#0) > 0));

// definition axiom for Sequences.__default.DropLast(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    { Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, run#0)
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(run#0) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, run#0)
         == Seq#Take(run#0, Seq#Length(run#0) - 1));

// definition axiom for Sequences.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall Sequences._default.DropLast$E: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0)) } 
    Sequences.__default.DropLast#canCall(Sequences._default.DropLast$E, Lit(run#0))
         || ($Is(run#0, TSeq(Sequences._default.DropLast$E)) && Seq#Length(Lit(run#0)) > 0)
       ==> Sequences.__default.DropLast(Sequences._default.DropLast$E, Lit(run#0))
         == Seq#Take(Lit(run#0), Seq#Length(Lit(run#0)) - 1));

// function declaration for Sequences._default.Set
function Sequences.__default.Set(Sequences._default.Set$T: Ty, run#0: Seq Box) : Set Box;

function Sequences.__default.Set#canCall(Sequences._default.Set$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.Set
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> $Is(Sequences.__default.Set(Sequences._default.Set$T, run#0), 
        TSet(Sequences._default.Set$T)));

function Sequences.__default.Set#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.Set
axiom (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.Set$T))
     ==> Sequences.__default.Set#requires(Sequences._default.Set$T, run#0) == true);

// definition axiom for Sequences.__default.Set(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.Set(Sequences._default.Set$T, run#0) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.Set$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.Set for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Set$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0)) } 
    Sequences.__default.Set#canCall(Sequences._default.Set$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.Set$T))
       ==> Sequences.__default.Set(Sequences._default.Set$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.Set$T) && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.ISet
function Sequences.__default.ISet(Sequences._default.ISet$T: Ty, run#0: Seq Box) : ISet Box;

function Sequences.__default.ISet#canCall(Sequences._default.ISet$T: Ty, run#0: Seq Box) : bool;

// consequence axiom for Sequences.__default.ISet
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> $Is(Sequences.__default.ISet(Sequences._default.ISet$T, run#0), 
        TISet(Sequences._default.ISet$T)));

function Sequences.__default.ISet#requires(Ty, Seq Box) : bool;

// #requires axiom for Sequences.__default.ISet
axiom (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
  { Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) } 
  $Is(run#0, TSeq(Sequences._default.ISet$T))
     ==> Sequences.__default.ISet#requires(Sequences._default.ISet$T, run#0) == true);

// definition axiom for Sequences.__default.ISet(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    { Sequences.__default.ISet(Sequences._default.ISet$T, run#0) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, run#0)
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, run#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Sequences._default.ISet$T) && MultiSet#FromSeq(run#0)[$y#0] > 0));

// definition axiom for Sequences.__default.ISet for all literals(revealed)
axiom true
   ==> (forall Sequences._default.ISet$T: Ty, run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0)) } 
    Sequences.__default.ISet#canCall(Sequences._default.ISet$T, Lit(run#0))
         || $Is(run#0, TSeq(Sequences._default.ISet$T))
       ==> Sequences.__default.ISet(Sequences._default.ISet$T, Lit(run#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Sequences._default.ISet$T)
             && MultiSet#FromSeq(Lit(run#0))[$y#1] > 0));

// function declaration for Sequences._default.NoDupes
function Sequences.__default.NoDupes(Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box) : bool;

function Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, AsFuelBottom($ly), a#0) } 
  Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0)
     == Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LZ, a#0));

// consequence axiom for Sequences.__default.NoDupes
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $ly, a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> true);

function Sequences.__default.NoDupes#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.NoDupes
axiom (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0) } 
  $Is(a#0, TSeq(Sequences._default.NoDupes$T))
     ==> Sequences.__default.NoDupes#requires(Sequences._default.NoDupes$T, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.NoDupes(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, a#0)
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), a#0)
         == (forall i#0: int, j#0: int :: 
          { Seq#Index(a#0, j#0), Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(a#0)
               && 
              LitInt(0) <= j#0
               && j#0 < Seq#Length(a#0)
               && i#0 != j#0
             ==> Seq#Index(a#0, i#0) != Seq#Index(a#0, j#0)));

// definition axiom for Sequences.__default.NoDupes for all literals(revealed)
axiom true
   ==> (forall Sequences._default.NoDupes$T: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0)) } 
    Sequences.__default.NoDupes#canCall(Sequences._default.NoDupes$T, Lit(a#0))
         || $Is(a#0, TSeq(Sequences._default.NoDupes$T))
       ==> Sequences.__default.NoDupes(Sequences._default.NoDupes$T, $LS($ly), Lit(a#0))
         == (forall i#1: int, j#1: int :: 
          { Seq#Index(a#0, j#1), Seq#Index(a#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(a#0))
               && 
              LitInt(0) <= j#1
               && j#1 < Seq#Length(Lit(a#0))
               && i#1 != j#1
             ==> Seq#Index(Lit(a#0), i#1) != Seq#Index(Lit(a#0), j#1)));

// function declaration for Sequences._default.IndexOf
function Sequences.__default.IndexOf(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : int;

function Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box) : bool;

// consequence axiom for Sequences.__default.IndexOf
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> LitInt(0) <= Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           < Seq#Length(s#0)
         && Seq#Index(s#0, Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0))
           == e#0);

function Sequences.__default.IndexOf#requires(Ty, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.IndexOf
axiom (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
  { Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
       && $IsBox(e#0, Sequences._default.IndexOf$T)
     ==> Sequences.__default.IndexOf#requires(Sequences._default.IndexOf$T, s#0, e#0)
       == Seq#Contains(s#0, e#0));

function $let#0_i(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : int;

function $let#0$canCall(Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box) : bool;

axiom (forall Sequences._default.IndexOf$T: Ty, s: Seq Box, e: Box :: 
  { $let#0_i(Sequences._default.IndexOf$T, s, e) } 
  $let#0$canCall(Sequences._default.IndexOf$T, s, e)
     ==> LitInt(0) <= $let#0_i(Sequences._default.IndexOf$T, s, e)
       && $let#0_i(Sequences._default.IndexOf$T, s, e) < Seq#Length(s)
       && Seq#Index(s, $let#0_i(Sequences._default.IndexOf$T, s, e)) == e);

// definition axiom for Sequences.__default.IndexOf(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, s#0, e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, s#0, e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, s#0, e#0)
           == (var i#0 := $let#0_i(Sequences._default.IndexOf$T, s#0, e#0); i#0));

// definition axiom for Sequences.__default.IndexOf for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), e#0)
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), e#0)
           == (var i#1 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), e#0); i#1));

// definition axiom for Sequences.__default.IndexOf for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IndexOf$T: Ty, $Heap: Heap, s#0: Seq Box, e#0: Box :: 
    {:weight 3} { Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.IndexOf#canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSeq(Sequences._default.IndexOf$T))
           && $IsBox(e#0, Sequences._default.IndexOf$T)
           && Seq#Contains(s#0, e#0))
       ==> $let#0$canCall(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
         && Sequences.__default.IndexOf(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0))
           == (var i#2 := $let#0_i(Sequences._default.IndexOf$T, Lit(s#0), Lit(e#0)); i#2));

// function declaration for Sequences._default.Range
function Sequences.__default.Range($ly: LayerType, n#0: int) : Seq Box;

function Sequences.__default.Range#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range($LS($ly), n#0) } 
  Sequences.__default.Range($LS($ly), n#0) == Sequences.__default.Range($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range(AsFuelBottom($ly), n#0) } 
  Sequences.__default.Range($ly, n#0) == Sequences.__default.Range($LZ, n#0));

// consequence axiom for Sequences.__default.Range
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($ly, n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(Sequences.__default.Range($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> $Unbox(Seq#Index(Sequences.__default.Range($ly, n#0), i#0)): int == i#0)
         && $Is(Sequences.__default.Range($ly, n#0), TSeq(TInt)));

function Sequences.__default.Range#requires(LayerType, int) : bool;

// #requires axiom for Sequences.__default.Range
axiom (forall $ly: LayerType, n#0: int :: 
  { Sequences.__default.Range#requires($ly, n#0) } 
  Sequences.__default.Range#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.Range(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { Sequences.__default.Range($LS($ly), n#0) } 
    Sequences.__default.Range#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> Sequences.__default.Range#canCall(n#0 - 1))
         && Sequences.__default.Range($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(n#0 - 1)))));

// definition axiom for Sequences.__default.Range for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { Sequences.__default.Range($LS($ly), LitInt(n#0)) } 
    Sequences.__default.Range#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.Range#canCall(LitInt(n#0 - 1)))
         && Sequences.__default.Range($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Range($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(n#0 - 1))))));

// function declaration for Sequences._default.Apply
function Sequences.__default.Apply(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Apply#canCall(Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply(Sequences._default.Apply$E, 
      Sequences._default.Apply$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $h0, f#0, run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h0, f#0, run#0)
       == Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Apply
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
                i#2)
               == Apply1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.Apply(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Apply$R)));

function Sequences.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Apply
axiom (forall Sequences._default.Apply$E: Ty, 
    Sequences._default.Apply$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
       && $Is(run#0, TSeq(Sequences._default.Apply$E))
     ==> Sequences.__default.Apply#requires(Sequences._default.Apply$E, Sequences._default.Apply$R, $ly, $Heap, f#0, run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.Apply(revealed)
axiom true
   ==> (forall Sequences._default.Apply$E: Ty, 
      Sequences._default.Apply$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Apply(Sequences._default.Apply$E, 
        Sequences._default.Apply$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.Apply#canCall(Sequences._default.Apply$E, Sequences._default.Apply$R, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.Apply$E, Sequences._default.Apply$R))
           && $Is(run#0, TSeq(Sequences._default.Apply$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Apply#canCall(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $Heap, 
            f#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Apply(Sequences._default.Apply$E, 
            Sequences._default.Apply$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
                Apply1(Sequences._default.Apply$E, 
                  Sequences._default.Apply$R, 
                  $Heap, 
                  f#0, 
                  Seq#Index(run#0, LitInt(0)))), 
              Sequences.__default.Apply(Sequences._default.Apply$E, 
                Sequences._default.Apply$R, 
                $ly, 
                $Heap, 
                f#0, 
                Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.ApplyOpaque
function Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LS($ly), 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      AsFuelBottom($ly), 
      $Heap, 
      f#0, 
      run#0) } 
  Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0)
     == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $LZ, 
      $Heap, 
      f#0, 
      run#0));

// frame axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $h1, 
      f#0, 
      run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $h0, 
          f#0, 
          run#0)
         || ($Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists i#0: int, o#0: ref :: 
            { Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)] } 
            $Is(o#0, Tclass._System.object?())
               && 
              LitInt(0) <= i#0
               && i#0 < Seq#Length(run#0)
               && Reads1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $h0, 
                f#0, 
                Seq#Index(run#0, i#0))[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h0, 
        f#0, 
        run#0)
       == Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $h1, 
        f#0, 
        run#0));

// consequence axiom for Sequences.__default.ApplyOpaque
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#1: int :: 
            { Seq#Index(run#0, i#1) } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#1))))
       ==> Seq#Length(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
              Sequences._default.ApplyOpaque$R, 
              $ly, 
              $Heap, 
              f#0, 
              run#0))
           == Seq#Length(run#0)
         && (forall i#2: int :: 
          { Seq#Index(run#0, i#2) } 
            { Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $ly, 
                $Heap, 
                f#0, 
                run#0), 
              i#2) } 
          true
             ==> 
            LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
             ==> Seq#Index(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
                  Sequences._default.ApplyOpaque$R, 
                  $ly, 
                  $Heap, 
                  f#0, 
                  run#0), 
                i#2)
               == Apply1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#2)))
         && $Is(Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $ly, 
            $Heap, 
            f#0, 
            run#0), 
          TSeq(Sequences._default.ApplyOpaque$R)));

function Sequences.__default.ApplyOpaque#requires(Ty, Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.ApplyOpaque
axiom (forall Sequences._default.ApplyOpaque$E: Ty, 
    Sequences._default.ApplyOpaque$R: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
      Sequences._default.ApplyOpaque$R, 
      $ly, 
      $Heap, 
      f#0, 
      run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
       && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
     ==> Sequences.__default.ApplyOpaque#requires(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $ly, 
        $Heap, 
        f#0, 
        run#0)
       == (forall i#3: int :: 
        { Seq#Index(run#0, i#3) } 
        true
           ==> 
          LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $Heap, 
            f#0, 
            Seq#Index(run#0, i#3))));

// definition axiom for Sequences.__default.ApplyOpaque(revealed)
axiom true
   ==> (forall Sequences._default.ApplyOpaque$E: Ty, 
      Sequences._default.ApplyOpaque$R: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
        Sequences._default.ApplyOpaque$R, 
        $LS($ly), 
        $Heap, 
        f#0, 
        run#0) } 
    Sequences.__default.ApplyOpaque#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hFunc1(Sequences._default.ApplyOpaque$E, Sequences._default.ApplyOpaque$R))
           && $Is(run#0, TSeq(Sequences._default.ApplyOpaque$E))
           && (forall i#3: int :: 
            { Seq#Index(run#0, i#3) } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.ApplyOpaque$E, 
                Sequences._default.ApplyOpaque$R, 
                $Heap, 
                f#0, 
                Seq#Index(run#0, i#3))))
       ==> Sequences.__default.Apply#canCall(Sequences._default.ApplyOpaque$E, 
          Sequences._default.ApplyOpaque$R, 
          $Heap, 
          f#0, 
          run#0)
         && Sequences.__default.ApplyOpaque(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($ly), 
            $Heap, 
            f#0, 
            run#0)
           == Sequences.__default.Apply(Sequences._default.ApplyOpaque$E, 
            Sequences._default.ApplyOpaque$R, 
            $LS($LZ), 
            $Heap, 
            f#0, 
            run#0));

// function declaration for Sequences._default.Filter
function Sequences.__default.Filter(Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box)
   : Seq Box;

function Sequences.__default.Filter#canCall(Sequences._default.Filter$E: Ty, $heap: Heap, f#0: HandleType, run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0));

// fuel synonym axiom
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter(Sequences._default.Filter$E, AsFuelBottom($ly), $Heap, f#0, run#0) } 
  Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
     == Sequences.__default.Filter(Sequences._default.Filter$E, $LZ, $Heap, f#0, run#0));

// frame axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $h0, f#0, run#0)
         || ($Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists _x0#0: Box, _o0#0: ref :: 
            $IsBox(_x0#0, Sequences._default.Filter$E)
               && $Is(_o0#0, Tclass._System.object?())
               && Reads1(Sequences._default.Filter$E, TBool, $h0, f#0, _x0#0)[$Box(_o0#0)]
               && $Box($o) == $Box(_o0#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h0, f#0, run#0)
       == Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $h1, f#0, run#0));

// consequence axiom for Sequences.__default.Filter
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#0))))
       ==> Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
           <= Seq#Length(run#0)
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
              i#1) } 
          LitInt(0) <= i#1
             ==> 
            i#1
                 < Seq#Length(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0))
               && Requires1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))
             ==> $Unbox(Apply1(Sequences._default.Filter$E, 
                TBool, 
                $Heap, 
                f#0, 
                Seq#Index(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
                  i#1))): bool)
         && $Is(Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0), 
          TSeq(Sequences._default.Filter$E)));

function Sequences.__default.Filter#requires(Ty, LayerType, Heap, HandleType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Filter
axiom (forall Sequences._default.Filter$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    run#0: Seq Box :: 
  { Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
       && $Is(run#0, TSeq(Sequences._default.Filter$E))
     ==> Sequences.__default.Filter#requires(Sequences._default.Filter$E, $ly, $Heap, f#0, run#0)
       == (forall i#2: int :: 
        { Seq#Index(run#0, i#2) } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
           ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))));

// definition axiom for Sequences.__default.Filter(revealed)
axiom true
   ==> (forall Sequences._default.Filter$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      run#0: Seq Box :: 
    { Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0) } 
    Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, Tclass._System.___hFunc1(Sequences._default.Filter$E, TBool))
           && $Is(run#0, TSeq(Sequences._default.Filter$E))
           && (forall i#2: int :: 
            { Seq#Index(run#0, i#2) } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(run#0)
               ==> Requires1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, i#2))))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Filter#canCall(Sequences._default.Filter$E, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.Filter(Sequences._default.Filter$E, $LS($ly), $Heap, f#0, run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append((if $Unbox(Apply1(Sequences._default.Filter$E, TBool, $Heap, f#0, Seq#Index(run#0, LitInt(0)))): bool
                 then Seq#Build(Seq#Empty(): Seq Box, Seq#Index(run#0, LitInt(0)))
                 else Seq#Empty(): Seq Box), 
              Sequences.__default.Filter(Sequences._default.Filter$E, $ly, $Heap, f#0, Seq#Drop(run#0, LitInt(1))))));

// function declaration for Sequences._default.FoldLeft
function Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldLeft
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> $IsBox(Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldLeft$A));

function Sequences.__default.FoldLeft#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldLeft
axiom (forall Sequences._default.FoldLeft$A: Ty, 
    Sequences._default.FoldLeft$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
      Sequences._default.FoldLeft$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Sequences._default.FoldLeft$A))
       && $IsBox(init#0, Sequences._default.FoldLeft$A)
       && $Is(run#0, TSeq(Sequences._default.FoldLeft$E))
     ==> Sequences.__default.FoldLeft#requires(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldLeft(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, Sequences._default.FoldLeft$E, f#0, init#0, run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(run#0, LitInt(0))), 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $ly, 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(run#0, LitInt(0))), 
              Seq#Drop(run#0, LitInt(1)))));

// definition axiom for Sequences.__default.FoldLeft for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            f#0, 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              f#0, 
              init#0, 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              f#0, 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                f#0, 
                init#0, 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// definition axiom for Sequences.__default.FoldLeft for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldLeft$A: Ty, 
      Sequences._default.FoldLeft$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
        Sequences._default.FoldLeft$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
          Sequences._default.FoldLeft$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A))
           && $IsBox(init#0, Sequences._default.FoldLeft$A)
           && $Is(run#0, TSeq(Sequences._default.FoldLeft$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldLeft#canCall(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            Lit(f#0), 
            Apply2(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              Sequences._default.FoldLeft$A, 
              $Heap, 
              Lit(f#0), 
              Lit(init#0), 
              Seq#Index(Lit(run#0), LitInt(0))), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
            Sequences._default.FoldLeft$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Sequences.__default.FoldLeft(Sequences._default.FoldLeft$A, 
              Sequences._default.FoldLeft$E, 
              $LS($ly), 
              Lit(f#0), 
              Apply2(Sequences._default.FoldLeft$A, 
                Sequences._default.FoldLeft$E, 
                Sequences._default.FoldLeft$A, 
                $Heap, 
                Lit(f#0), 
                Lit(init#0), 
                Seq#Index(Lit(run#0), LitInt(0))), 
              Lit(Seq#Drop(Lit(run#0), LitInt(1))))));

// function declaration for Sequences._default.FoldRight
function Sequences.__default.FoldRight(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldRight
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> $IsBox(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldRight$A));

function Sequences.__default.FoldRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldRight
axiom (forall Sequences._default.FoldRight$A: Ty, 
    Sequences._default.FoldRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
      Sequences._default.FoldRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Sequences._default.FoldRight$A))
       && $IsBox(init#0, Sequences._default.FoldRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldRight$E))
     ==> Sequences.__default.FoldRight#requires(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Seq#Drop(run#0, LitInt(1))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Seq#Drop(run#0, LitInt(1))), 
              Seq#Index(run#0, LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            f#0, 
            init#0, 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                Sequences._default.FoldRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Seq#Drop(Lit(run#0), LitInt(1)))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// definition axiom for Sequences.__default.FoldRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldRight$A: Ty, 
      Sequences._default.FoldRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
        Sequences._default.FoldRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
          Sequences._default.FoldRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A))
           && $IsBox(init#0, Sequences._default.FoldRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.FoldRight#canCall(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            Lit(f#0), 
            Lit(init#0), 
            Lit(Seq#Drop(Lit(run#0), LitInt(1)))))
         && Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
            Sequences._default.FoldRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldRight$A, 
              Sequences._default.FoldRight$E, 
              Sequences._default.FoldRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldRight(Sequences._default.FoldRight$A, 
                  Sequences._default.FoldRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Seq#Drop(Lit(run#0), LitInt(1))))), 
              Seq#Index(Lit(run#0), LitInt(0)))));

// function declaration for Sequences._default.FoldFromRight
function Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : Box;

function Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LS($ly), 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0));

// fuel synonym axiom
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      AsFuelBottom($ly), 
      f#0, 
      init#0, 
      run#0) } 
  Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0)
     == Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $LZ, 
      f#0, 
      init#0, 
      run#0));

// consequence axiom for Sequences.__default.FoldFromRight
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> $IsBox(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          $ly, 
          f#0, 
          init#0, 
          run#0), 
        Sequences._default.FoldFromRight$A));

function Sequences.__default.FoldFromRight#requires(Ty, Ty, LayerType, HandleType, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.FoldFromRight
axiom (forall Sequences._default.FoldFromRight$A: Ty, 
    Sequences._default.FoldFromRight$E: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    f#0: HandleType, 
    init#0: Box, 
    run#0: Seq Box :: 
  { Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
      Sequences._default.FoldFromRight$E, 
      $ly, 
      f#0, 
      init#0, 
      run#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(f#0, 
        Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Sequences._default.FoldFromRight$A))
       && $IsBox(init#0, Sequences._default.FoldFromRight$A)
       && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E))
     ==> Sequences.__default.FoldFromRight#requires(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $ly, 
        f#0, 
        init#0, 
        run#0)
       == true);

// definition axiom for Sequences.__default.FoldFromRight(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        run#0), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          run#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, run#0)
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, run#0))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            run#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $ly, 
                f#0, 
                init#0, 
                Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, run#0)), 
              Sequences.__default.Last(Sequences._default.FoldFromRight$E, run#0))));

// definition axiom for Sequences.__default.FoldFromRight for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        f#0, 
        init#0, 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          f#0, 
          init#0, 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              f#0, 
              init#0, 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            f#0, 
            init#0, 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              f#0, 
              Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                Sequences._default.FoldFromRight$E, 
                $LS($ly), 
                f#0, 
                init#0, 
                Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0)))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// definition axiom for Sequences.__default.FoldFromRight for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FoldFromRight$A: Ty, 
      Sequences._default.FoldFromRight$E: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      f#0: HandleType, 
      init#0: Box, 
      run#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
        Sequences._default.FoldFromRight$E, 
        $LS($ly), 
        Lit(f#0), 
        Lit(init#0), 
        Lit(run#0)), $IsGoodHeap($Heap) } 
    Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
          Sequences._default.FoldFromRight$E, 
          Lit(f#0), 
          Lit(init#0), 
          Lit(run#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(f#0, 
            Tclass._System.___hTotalFunc2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A))
           && $IsBox(init#0, Sequences._default.FoldFromRight$A)
           && $Is(run#0, TSeq(Sequences._default.FoldFromRight$E)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.FoldFromRight$E, Lit(run#0))
             && Sequences.__default.FoldFromRight#canCall(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Lit(f#0), 
              Lit(init#0), 
              Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))
             && Sequences.__default.Last#canCall(Sequences._default.FoldFromRight$E, Lit(run#0)))
         && Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
            Sequences._default.FoldFromRight$E, 
            $LS($ly), 
            Lit(f#0), 
            Lit(init#0), 
            Lit(run#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then init#0
             else Apply2(Sequences._default.FoldFromRight$A, 
              Sequences._default.FoldFromRight$E, 
              Sequences._default.FoldFromRight$A, 
              $Heap, 
              Lit(f#0), 
              Lit(Sequences.__default.FoldFromRight(Sequences._default.FoldFromRight$A, 
                  Sequences._default.FoldFromRight$E, 
                  $LS($ly), 
                  Lit(f#0), 
                  Lit(init#0), 
                  Lit(Sequences.__default.DropLast(Sequences._default.FoldFromRight$E, Lit(run#0))))), 
              Lit(Sequences.__default.Last(Sequences._default.FoldFromRight$E, Lit(run#0))))));

// function declaration for Sequences._default.remove
function Sequences.__default.remove(Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int)
   : Seq Box;

function Sequences.__default.remove#canCall(Sequences._default.remove$A: Ty, s#0: Seq Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove(Sequences._default.remove$A, AsFuelBottom($ly), s#0, pos#0) } 
  Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0)
     == Sequences.__default.remove(Sequences._default.remove$A, $LZ, s#0, pos#0));

// consequence axiom for Sequences.__default.remove
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1) } 
          pos#0 <= i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), i#1)
               == Seq#Index(s#0, i#1 + 1))
         && $Is(Sequences.__default.remove(Sequences._default.remove$A, $ly, s#0, pos#0), 
          TSeq(Sequences._default.remove$A)));

function Sequences.__default.remove#requires(Ty, LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.remove
axiom (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
  { Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.remove$A))
     ==> Sequences.__default.remove#requires(Sequences._default.remove$A, $ly, s#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.remove(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, s#0, pos#0)
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), s#0, pos#0)
         == Seq#Append(Seq#Take(s#0, pos#0), Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.remove for all literals(revealed)
axiom true
   ==> (forall Sequences._default.remove$A: Ty, $ly: LayerType, s#0: Seq Box, pos#0: int :: 
    {:weight 3} { Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0)) } 
    Sequences.__default.remove#canCall(Sequences._default.remove$A, Lit(s#0), LitInt(pos#0))
         || ($Is(s#0, TSeq(Sequences._default.remove$A))
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.remove(Sequences._default.remove$A, $LS($ly), Lit(s#0), LitInt(pos#0))
         == Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.insert
function Sequences.__default.insert(Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.insert#canCall(Sequences._default.insert$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int) : bool;

// layer synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert(Sequences._default.insert$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.insert(Sequences._default.insert$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.insert
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 <= i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.insert(Sequences._default.insert$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.insert$A)));

function Sequences.__default.insert#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.insert
axiom (forall Sequences._default.insert$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.insert$A))
       && $IsBox(a#0, Sequences._default.insert$A)
     ==> Sequences.__default.insert#requires(Sequences._default.insert$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 <= Seq#Length(s#0)));

// definition axiom for Sequences.__default.insert(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 <= Seq#Length(s#0))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0)));

// definition axiom for Sequences.__default.insert for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// definition axiom for Sequences.__default.insert for all literals(revealed)
axiom true
   ==> (forall Sequences._default.insert$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.insert#canCall(Sequences._default.insert$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.insert$A))
           && $IsBox(a#0, Sequences._default.insert$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && LitInt(pos#0) <= Seq#Length(Lit(s#0)))
       ==> Sequences.__default.insert(Sequences._default.insert$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0))));

// function declaration for Sequences._default.replace1with2
function Sequences.__default.replace1with2(Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A: Ty, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, AsFuelBottom($ly), s#0, a#0, b#0, pos#0) } 
  Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
     == Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LZ, s#0, a#0, b#0, pos#0));

// consequence axiom for Sequences.__default.replace1with2
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Seq#Length(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0))
           == Seq#Length(s#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(s#0, i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0)
             ==> Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
                i#1 + 1)
               == Seq#Index(s#0, i#1))
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0)
           == a#0
         && Seq#Index(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
            pos#0 + 1)
           == b#0
         && $Is(Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0), 
          TSeq(Sequences._default.replace1with2$A)));

function Sequences.__default.replace1with2#requires(Ty, LayerType, Seq Box, Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace1with2
axiom (forall Sequences._default.replace1with2$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    b#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace1with2$A))
       && $IsBox(a#0, Sequences._default.replace1with2$A)
       && $IsBox(b#0, Sequences._default.replace1with2$A)
     ==> Sequences.__default.replace1with2#requires(Sequences._default.replace1with2$A, $ly, s#0, a#0, b#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.replace1with2(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, s#0, a#0, b#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), s#0, a#0, b#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(s#0, pos#0 + 1)));

// definition axiom for Sequences.__default.replace1with2 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), a#0, b#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, $LS($ly), Lit(s#0), a#0, b#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, a#0), b#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// definition axiom for Sequences.__default.replace1with2 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace1with2$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      b#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
        $LS($ly), 
        Lit(s#0), 
        Lit(a#0), 
        Lit(b#0), 
        LitInt(pos#0)) } 
    Sequences.__default.replace1with2#canCall(Sequences._default.replace1with2$A, Lit(s#0), Lit(a#0), Lit(b#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace1with2$A))
           && $IsBox(a#0, Sequences._default.replace1with2$A)
           && $IsBox(b#0, Sequences._default.replace1with2$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.replace1with2(Sequences._default.replace1with2$A, 
          $LS($ly), 
          Lit(s#0), 
          Lit(a#0), 
          Lit(b#0), 
          LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), 
            Seq#Build(Seq#Build(Seq#Empty(): Seq Box, Lit(a#0)), Lit(b#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 1))));

// function declaration for Sequences._default.replace2with1
function Sequences.__default.replace2with1(Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int)
   : Seq Box;

function Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A: Ty, s#0: Seq Box, a#0: Box, pos#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0));

// fuel synonym axiom
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, AsFuelBottom($ly), s#0, a#0, pos#0) } 
  Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
     == Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LZ, s#0, a#0, pos#0));

// consequence axiom for Sequences.__default.replace2with1
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Seq#Length(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0))
           == Seq#Length(s#0) - 1
         && (forall i#0: int :: 
          { Seq#Index(s#0, i#0) } 
            { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < pos#0
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#0)
               == Seq#Index(s#0, i#0))
         && (forall i#1: int :: 
          { Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
              i#1) } 
          true
             ==> 
            pos#0 < i#1 && i#1 < Seq#Length(s#0) - 1
             ==> Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
                i#1)
               == Seq#Index(s#0, i#1 + 1))
         && Seq#Index(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
            pos#0)
           == a#0
         && $Is(Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0), 
          TSeq(Sequences._default.replace2with1$A)));

function Sequences.__default.replace2with1#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.replace2with1
axiom (forall Sequences._default.replace2with1$A: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    a#0: Box, 
    pos#0: int :: 
  { Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0) } 
  $Is(s#0, TSeq(Sequences._default.replace2with1$A))
       && $IsBox(a#0, Sequences._default.replace2with1$A)
     ==> Sequences.__default.replace2with1#requires(Sequences._default.replace2with1$A, $ly, s#0, a#0, pos#0)
       == (LitInt(0) <= pos#0 && pos#0 < Seq#Length(s#0) - 1));

// definition axiom for Sequences.__default.replace2with1(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, s#0, a#0, pos#0)
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= pos#0
           && pos#0 < Seq#Length(s#0) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), s#0, a#0, pos#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, pos#0), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(s#0, pos#0 + 2)));

// definition axiom for Sequences.__default.replace2with1 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), a#0, LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), a#0, LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, a#0)), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// definition axiom for Sequences.__default.replace2with1 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.replace2with1$A: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      a#0: Box, 
      pos#0: int :: 
    {:weight 3} { Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0)) } 
    Sequences.__default.replace2with1#canCall(Sequences._default.replace2with1$A, Lit(s#0), Lit(a#0), LitInt(pos#0))
         || (
          $Is(s#0, TSeq(Sequences._default.replace2with1$A))
           && $IsBox(a#0, Sequences._default.replace2with1$A)
           && 
          LitInt(0) <= LitInt(pos#0)
           && pos#0 < Seq#Length(Lit(s#0)) - 1)
       ==> Sequences.__default.replace2with1(Sequences._default.replace2with1$A, $LS($ly), Lit(s#0), Lit(a#0), LitInt(pos#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(pos#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(a#0))), 
          Seq#Drop(Lit(s#0), LitInt(pos#0 + 2))));

// function declaration for Sequences._default.concat
function Sequences.__default.concat(Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat#canCall(Sequences._default.concat$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat(Sequences._default.concat$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0)
     == Sequences.__default.concat(Sequences._default.concat$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.concat
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Seq#Length(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0))
           == Seq#Length(a#0) + Seq#Length(b#0)
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), i#0))
         && (forall i#1: int :: 
          { Seq#Index(b#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(b#0)
             ==> Seq#Index(b#0, i#1)
               == Seq#Index(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
                Seq#Length(a#0) + i#1))
         && $Is(Sequences.__default.concat(Sequences._default.concat$A, $ly, a#0, b#0), 
          TSeq(Sequences._default.concat$A)));

function Sequences.__default.concat#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat
axiom (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.concat$A))
       && $Is(b#0, TSeq(Sequences._default.concat$A))
     ==> Sequences.__default.concat#requires(Sequences._default.concat$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.concat(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), a#0, b#0)
         == Seq#Append(a#0, b#0));

// definition axiom for Sequences.__default.concat for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.concat#canCall(Sequences._default.concat$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.concat$A))
           && $Is(b#0, TSeq(Sequences._default.concat$A)))
       ==> Sequences.__default.concat(Sequences._default.concat$A, $LS($ly), Lit(a#0), Lit(b#0))
         == Seq#Append(a#0, b#0));

// function declaration for Sequences._default.concat3
function Sequences.__default.concat3(Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box)
   : Seq Box;

function Sequences.__default.concat3#canCall(Sequences._default.concat3$A: Ty, a#0: Seq Box, b#0: Box, c#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0));

// fuel synonym axiom
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3(Sequences._default.concat3$A, AsFuelBottom($ly), a#0, b#0, c#0) } 
  Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
     == Sequences.__default.concat3(Sequences._default.concat3$A, $LZ, a#0, b#0, c#0));

// consequence axiom for Sequences.__default.concat3
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Seq#Length(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0))
           == Seq#Length(a#0) + Seq#Length(c#0) + 1
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
              i#0) } 
            { Seq#Index(a#0, i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
             ==> Seq#Index(a#0, i#0)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                i#0))
         && Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
            Seq#Length(a#0))
           == b#0
         && (forall i#1: int :: 
          { Seq#Index(c#0, i#1) } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < Seq#Length(c#0)
             ==> Seq#Index(c#0, i#1)
               == Seq#Index(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
                Seq#Length(a#0) + 1 + i#1))
         && $Is(Sequences.__default.concat3(Sequences._default.concat3$A, $ly, a#0, b#0, c#0), 
          TSeq(Sequences._default.concat3$A)));

function Sequences.__default.concat3#requires(Ty, LayerType, Seq Box, Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.concat3
axiom (forall Sequences._default.concat3$A: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Box, 
    c#0: Seq Box :: 
  { Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0) } 
  $Is(a#0, TSeq(Sequences._default.concat3$A))
       && $IsBox(b#0, Sequences._default.concat3$A)
       && $Is(c#0, TSeq(Sequences._default.concat3$A))
     ==> Sequences.__default.concat3#requires(Sequences._default.concat3$A, $ly, a#0, b#0, c#0)
       == true);

// definition axiom for Sequences.__default.concat3(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, a#0, b#0, c#0)
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), a#0, b#0, c#0)
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), b#0, Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), b#0, Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, b#0)), c#0));

// definition axiom for Sequences.__default.concat3 for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concat3$A: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Box, 
      c#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0)) } 
    Sequences.__default.concat3#canCall(Sequences._default.concat3$A, Lit(a#0), Lit(b#0), Lit(c#0))
         || (
          $Is(a#0, TSeq(Sequences._default.concat3$A))
           && $IsBox(b#0, Sequences._default.concat3$A)
           && $Is(c#0, TSeq(Sequences._default.concat3$A)))
       ==> Sequences.__default.concat3(Sequences._default.concat3$A, $LS($ly), Lit(a#0), Lit(b#0), Lit(c#0))
         == Seq#Append(Seq#Append(a#0, Seq#Build(Seq#Empty(): Seq Box, Lit(b#0))), c#0));

// function declaration for Sequences._default.concatSeq
function Sequences.__default.concatSeq(Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box) : Seq Box;

function Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A: Ty, a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0));

// fuel synonym axiom
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, AsFuelBottom($ly), a#0) } 
  Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0)
     == Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LZ, a#0));

// consequence axiom for Sequences.__default.concatSeq
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> $Is(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $ly, a#0), 
        TSeq(Sequences._default.concatSeq$A)));

function Sequences.__default.concatSeq#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.concatSeq
axiom (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
  { Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0) } 
  $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
     ==> Sequences.__default.concatSeq#requires(Sequences._default.concatSeq$A, $ly, a#0)
       == true);

// definition axiom for Sequences.__default.concatSeq(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, a#0)
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), a#0)
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), a#0))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), a#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), a#0)): Seq Box)));

// definition axiom for Sequences.__default.concatSeq for all literals(revealed)
axiom true
   ==> (forall Sequences._default.concatSeq$A: Ty, $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0)) } 
    Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, Lit(a#0))
         || $Is(a#0, TSeq(TSeq(Sequences._default.concatSeq$A)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0))
             && Sequences.__default.concatSeq#canCall(Sequences._default.concatSeq$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))
         && Sequences.__default.concatSeq(Sequences._default.concatSeq$A, $LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.concatSeq(Sequences._default.concatSeq$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.concatSeq$A), Lit(a#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.concatSeq$A), Lit(a#0))): Seq Box)));

// function declaration for Sequences._default.IsPrefix
function Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
     == Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsPrefix
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> 
      Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       ==> Seq#Length(a#0) <= Seq#Length(b#0));

function Sequences.__default.IsPrefix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsPrefix
axiom (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsPrefix$A))
       && $Is(b#0, TSeq(Sequences._default.IsPrefix$A))
     ==> Sequences.__default.IsPrefix#requires(Sequences._default.IsPrefix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsPrefix(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Take(b#0, Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsPrefix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsPrefix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsPrefix#canCall(Sequences._default.IsPrefix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsPrefix$A))
           && $Is(b#0, TSeq(Sequences._default.IsPrefix$A)))
       ==> Sequences.__default.IsPrefix(Sequences._default.IsPrefix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Take(Lit(b#0), Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.IsSuffix
function Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box)
   : bool;

function Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A: Ty, a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
     == Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.IsSuffix
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> true);

function Sequences.__default.IsSuffix#requires(Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.IsSuffix
axiom (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.IsSuffix$A))
       && $Is(b#0, TSeq(Sequences._default.IsSuffix$A))
     ==> Sequences.__default.IsSuffix#requires(Sequences._default.IsSuffix$A, $ly, a#0, b#0)
       == true);

// definition axiom for Sequences.__default.IsSuffix(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, a#0, b#0)
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), a#0, b#0)
         == (Seq#Length(a#0) <= Seq#Length(b#0)
           && Seq#Equal(a#0, Seq#Drop(b#0, Seq#Length(b#0) - Seq#Length(a#0)))));

// definition axiom for Sequences.__default.IsSuffix for all literals(revealed)
axiom true
   ==> (forall Sequences._default.IsSuffix$A: Ty, $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.IsSuffix#canCall(Sequences._default.IsSuffix$A, Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Sequences._default.IsSuffix$A))
           && $Is(b#0, TSeq(Sequences._default.IsSuffix$A)))
       ==> Sequences.__default.IsSuffix(Sequences._default.IsSuffix$A, $LS($ly), Lit(a#0), Lit(b#0))
         == (Seq#Length(Lit(a#0)) <= Seq#Length(Lit(b#0))
           && Seq#Equal(a#0, Seq#Drop(Lit(b#0), Seq#Length(Lit(b#0)) - Seq#Length(Lit(a#0))))));

// function declaration for Sequences._default.SeqIndexIterate
function Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : DatatypeType;

function Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A: Ty, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, AsFuelBottom($ly), run#0, needle#0, i#0) } 
  Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
     == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LZ, run#0, needle#0, i#0));

// consequence axiom for Sequences.__default.SeqIndexIterate
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0))
           ==> (forall j#0: int :: 
            { Seq#Index(run#0, j#0) } 
            i#0 <= j#0 && j#0 < Seq#Length(run#0) ==> Seq#Index(run#0, j#0) != needle#0))
         && $Is(Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndexIterate#requires(Ty, LayerType, Seq Box, Box, int) : bool;

// #requires axiom for Sequences.__default.SeqIndexIterate
axiom (forall Sequences._default.SeqIndexIterate$A: Ty, 
    $ly: LayerType, 
    run#0: Seq Box, 
    needle#0: Box, 
    i#0: int :: 
  { Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
       && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
     ==> Sequences.__default.SeqIndexIterate#requires(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(run#0)));

// definition axiom for Sequences.__default.SeqIndexIterate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0)
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(run#0))
       ==> (i#0 != Seq#Length(run#0)
           ==> 
          Seq#Index(run#0, i#0) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, run#0, needle#0, i#0 + 1))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $LS($ly), run#0, needle#0, i#0)
           == (if i#0 == Seq#Length(run#0)
             then #Options.Option.None()
             else (if Seq#Index(run#0, i#0) == needle#0
               then #Options.Option.Some($Box(i#0))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, $ly, run#0, needle#0, i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        needle#0, 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != needle#0
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), needle#0, LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            needle#0, 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == needle#0
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                needle#0, 
                LitInt(i#0 + 1)))));

// definition axiom for Sequences.__default.SeqIndexIterate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexIterate$A: Ty, 
      $ly: LayerType, 
      run#0: Seq Box, 
      needle#0: Box, 
      i#0: int :: 
    {:weight 3} { Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
        $LS($ly), 
        Lit(run#0), 
        Lit(needle#0), 
        LitInt(i#0)) } 
    Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0))
         || (
          $Is(run#0, TSeq(Sequences._default.SeqIndexIterate$A))
           && $IsBox(needle#0, Sequences._default.SeqIndexIterate$A)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(run#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(run#0))
           ==> 
          Seq#Index(Lit(run#0), LitInt(i#0)) != Lit(needle#0)
           ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndexIterate$A, Lit(run#0), Lit(needle#0), LitInt(i#0 + 1)))
         && Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
            $LS($ly), 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(run#0))
             then #Options.Option.None()
             else (if Seq#Index(Lit(run#0), LitInt(i#0)) == Lit(needle#0)
               then #Options.Option.Some($Box(LitInt(i#0)))
               else Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndexIterate$A, 
                $LS($ly), 
                Lit(run#0), 
                Lit(needle#0), 
                LitInt(i#0 + 1)))));

// function declaration for Sequences._default.SeqIndex
function Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box)
   : DatatypeType;

function Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A: Ty, run#0: Seq Box, needle#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, AsFuelBottom($ly), run#0, needle#0) } 
  Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
     == Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LZ, run#0, needle#0));

// consequence axiom for Sequences.__default.SeqIndex
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> (Options.Option.Some_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
             && $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int
               < Seq#Length(run#0)
             && Seq#Index(run#0, 
                $Unbox(Options.Option.value(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))): int)
               == needle#0)
         && (Options.Option.None_q(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0))
           ==> (forall i#0: int :: 
            { Seq#Index(run#0, i#0) } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(run#0)
               ==> Seq#Index(run#0, i#0) != needle#0))
         && $Is(Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $ly, run#0, needle#0), 
          Tclass.Options.Option(TInt)));

function Sequences.__default.SeqIndex#requires(Ty, LayerType, Seq Box, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndex
axiom (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
  { Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Sequences._default.SeqIndex$A))
       && $IsBox(needle#0, Sequences._default.SeqIndex$A)
     ==> Sequences.__default.SeqIndex#requires(Sequences._default.SeqIndex$A, $ly, run#0, needle#0)
       == true);

// definition axiom for Sequences.__default.SeqIndex(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, run#0, needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, run#0, needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), run#0, needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            run#0, 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0)
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), needle#0, LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), needle#0)
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            needle#0, 
            LitInt(0)));

// definition axiom for Sequences.__default.SeqIndex for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndex$A: Ty, $ly: LayerType, run#0: Seq Box, needle#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0)) } 
    Sequences.__default.SeqIndex#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0))
         || ($Is(run#0, TSeq(Sequences._default.SeqIndex$A))
           && $IsBox(needle#0, Sequences._default.SeqIndex$A))
       ==> Sequences.__default.SeqIndexIterate#canCall(Sequences._default.SeqIndex$A, Lit(run#0), Lit(needle#0), LitInt(0))
         && Sequences.__default.SeqIndex(Sequences._default.SeqIndex$A, $LS($ly), Lit(run#0), Lit(needle#0))
           == Sequences.__default.SeqIndexIterate(Sequences._default.SeqIndex$A, 
            StartFuel_Sequences._default.SeqIndexIterate, 
            Lit(run#0), 
            Lit(needle#0), 
            LitInt(0)));

// function declaration for Sequences._default.SeqOfLength
function Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box)
   : Seq Box;

function Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V: Ty, length#0: int, v#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, AsFuelBottom($ly), length#0, v#0) } 
  Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
     == Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LZ, length#0, v#0));

// consequence axiom for Sequences.__default.SeqOfLength
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
           == length#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0))
             ==> Seq#Index(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
                i#0)
               == v#0)
         && $Is(Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0, v#0), 
          TSeq(Sequences._default.SeqOfLength$V)));

function Sequences.__default.SeqOfLength#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqOfLength
axiom (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
  { Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0) } 
  LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V)
     ==> Sequences.__default.SeqOfLength#requires(Sequences._default.SeqOfLength$V, $ly, length#0, v#0)
       == true);

// definition axiom for Sequences.__default.SeqOfLength(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0, v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (length#0 != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, length#0 - 1, v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), length#0, v#0)
           == (if length#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $ly, length#0 - 1, v#0))));

// definition axiom for Sequences.__default.SeqOfLength for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), v#0)
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), v#0))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), v#0)
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, v#0), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), v#0))));

// definition axiom for Sequences.__default.SeqOfLength for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqOfLength$V: Ty, $ly: LayerType, length#0: int, v#0: Box :: 
    {:weight 3} { Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0)) } 
    Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0), Lit(v#0))
         || (LitInt(0) <= length#0 && $IsBox(v#0, Sequences._default.SeqOfLength$V))
       ==> (LitInt(length#0) != LitInt(0)
           ==> Sequences.__default.SeqOfLength#canCall(Sequences._default.SeqOfLength$V, LitInt(length#0 - 1), Lit(v#0)))
         && Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0), Lit(v#0))
           == (if LitInt(length#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Seq#Build(Seq#Empty(): Seq Box, Lit(v#0)), 
              Sequences.__default.SeqOfLength(Sequences._default.SeqOfLength$V, $LS($ly), LitInt(length#0 - 1), Lit(v#0)))));

// function declaration for Sequences._default.SeqIndexUpdate
function Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box)
   : Seq Box;

function Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T: Ty, s#0: Seq Box, i#0: int, t#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, AsFuelBottom($ly), s#0, i#0, t#0) } 
  Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
     == Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LZ, s#0, i#0, t#0));

// consequence axiom for Sequences.__default.SeqIndexUpdate
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Seq#Equal(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          Seq#Update(s#0, i#0, t#0))
         && $Is(Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0), 
          TSeq(Sequences._default.SeqIndexUpdate$T)));

function Sequences.__default.SeqIndexUpdate#requires(Ty, LayerType, Seq Box, int, Box) : bool;

// #requires axiom for Sequences.__default.SeqIndexUpdate
axiom (forall Sequences._default.SeqIndexUpdate$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    i#0: int, 
    t#0: Box :: 
  { Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0) } 
  $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
     ==> Sequences.__default.SeqIndexUpdate#requires(Sequences._default.SeqIndexUpdate$T, $ly, s#0, i#0, t#0)
       == (i#0 + 1 < 18446744073709551616 && LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)));

// definition axiom for Sequences.__default.SeqIndexUpdate(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, s#0, i#0, t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          i#0 + 1 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(s#0))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), s#0, i#0, t#0)
         == Seq#Append(Seq#Append(Seq#Take(s#0, i#0), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(s#0, i#0 + 1)));

// definition axiom for Sequences.__default.SeqIndexUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), t#0)
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), t#0)
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, t#0)), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// definition axiom for Sequences.__default.SeqIndexUpdate for all literals(revealed)
axiom true
   ==> (forall Sequences._default.SeqIndexUpdate$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      i#0: int, 
      t#0: Box :: 
    {:weight 3} { Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0)) } 
    Sequences.__default.SeqIndexUpdate#canCall(Sequences._default.SeqIndexUpdate$T, Lit(s#0), LitInt(i#0), Lit(t#0))
         || (
          $Is(s#0, TSeq(Sequences._default.SeqIndexUpdate$T))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $IsBox(t#0, Sequences._default.SeqIndexUpdate$T)
           && 
          Lit(i#0 + 1 < 18446744073709551616)
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(s#0)))
       ==> Sequences.__default.SeqIndexUpdate(Sequences._default.SeqIndexUpdate$T, $LS($ly), Lit(s#0), LitInt(i#0), Lit(t#0))
         == Seq#Append(Seq#Append(Seq#Take(Lit(s#0), LitInt(i#0)), Seq#Build(Seq#Empty(): Seq Box, Lit(t#0))), 
          Seq#Drop(Lit(s#0), LitInt(i#0 + 1))));

// function declaration for Sequences._default.Zip
function Sequences.__default.Zip(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : Seq Box;

function Sequences.__default.Zip#canCall(Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    a#0: Seq Box, 
    b#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0));

// fuel synonym axiom
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, AsFuelBottom($ly), a#0, b#0) } 
  Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
     == Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LZ, a#0, b#0));

// consequence axiom for Sequences.__default.Zip
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
           == Seq#Length(a#0)
         && (forall i#0: int :: 
          { Seq#Index(b#0, i#0) } 
            { Seq#Index(a#0, i#0) } 
            { $Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                i#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0))
             ==> _System.Tuple2#Equal($Unbox(Seq#Index(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
                  i#0)): DatatypeType, 
              #_System._tuple#2._#Make2(Seq#Index(a#0, i#0), Seq#Index(b#0, i#0))))
         && $Is(Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0), 
          TSeq(Tclass._System.Tuple2(Sequences._default.Zip$A, Sequences._default.Zip$B))));

function Sequences.__default.Zip#requires(Ty, Ty, LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Sequences.__default.Zip
axiom (forall Sequences._default.Zip$A: Ty, 
    Sequences._default.Zip$B: Ty, 
    $ly: LayerType, 
    a#0: Seq Box, 
    b#0: Seq Box :: 
  { Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0) } 
  $Is(a#0, TSeq(Sequences._default.Zip$A))
       && $Is(b#0, TSeq(Sequences._default.Zip$B))
     ==> Sequences.__default.Zip#requires(Sequences._default.Zip$A, Sequences._default.Zip$B, $ly, a#0, b#0)
       == 
      (Seq#Length(a#0)
       == Seq#Length(b#0)));

// definition axiom for Sequences.__default.Zip(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, a#0, b#0)
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(a#0) == Seq#Length(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, b#0)
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
              Sequences.__default.DropLast(Sequences._default.Zip$B, b#0))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, a#0)
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, b#0))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $ly, 
                Sequences.__default.DropLast(Sequences._default.Zip$A, a#0), 
                Sequences.__default.DropLast(Sequences._default.Zip$B, b#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#_System._tuple#2._#Make2(Sequences.__default.Last(Sequences._default.Zip$A, a#0), 
                    Sequences.__default.Last(Sequences._default.Zip$B, b#0)))))));

// definition axiom for Sequences.__default.Zip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Zip$A: Ty, 
      Sequences._default.Zip$B: Ty, 
      $ly: LayerType, 
      a#0: Seq Box, 
      b#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0)) } 
    Sequences.__default.Zip#canCall(Sequences._default.Zip$A, Sequences._default.Zip$B, Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(Sequences._default.Zip$A))
           && $Is(b#0, TSeq(Sequences._default.Zip$B))
           && Seq#Length(Lit(a#0)) == Seq#Length(Lit(b#0)))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.DropLast#canCall(Sequences._default.Zip$B, Lit(b#0))
             && Sequences.__default.Zip#canCall(Sequences._default.Zip$A, 
              Sequences._default.Zip$B, 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
              Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0))))
             && 
            Sequences.__default.Last#canCall(Sequences._default.Zip$A, Lit(a#0))
             && Sequences.__default.Last#canCall(Sequences._default.Zip$B, Lit(b#0)))
         && Sequences.__default.Zip(Sequences._default.Zip$A, Sequences._default.Zip$B, $LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Zip(Sequences._default.Zip$A, 
                Sequences._default.Zip$B, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$A, Lit(a#0))), 
                Lit(Sequences.__default.DropLast(Sequences._default.Zip$B, Lit(b#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#_System._tuple#2._#Make2(Lit(Sequences.__default.Last(Sequences._default.Zip$A, Lit(a#0))), 
                      Lit(Sequences.__default.Last(Sequences._default.Zip$B, Lit(b#0))))))))));

// function declaration for Sequences._default.Unzip
function Sequences.__default.Unzip(Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box)
   : DatatypeType;

function Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A: Ty, Sequences._default.Unzip$B: Ty, z#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0));

// fuel synonym axiom
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, AsFuelBottom($ly), z#0) } 
  Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
     == Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LZ, z#0));

// consequence axiom for Sequences.__default.Unzip
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> Seq#Length($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
         && Seq#Length($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box)
           == Seq#Length(z#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(z#0, i#0)): DatatypeType } 
            { Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
            { Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
              i#0) } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 < Seq#Length(z#0)
             ==> _System.Tuple2#Equal(#_System._tuple#2._#Make2(Seq#Index($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0), 
                Seq#Index($Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0))): Seq Box, 
                  i#0)), 
              $Unbox(Seq#Index(z#0, i#0)): DatatypeType))
         && $Is(Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0), 
          Tclass._System.Tuple2(TSeq(Sequences._default.Unzip$A), TSeq(Sequences._default.Unzip$B))));

function Sequences.__default.Unzip#requires(Ty, Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Unzip
axiom (forall Sequences._default.Unzip$A: Ty, 
    Sequences._default.Unzip$B: Ty, 
    $ly: LayerType, 
    z#0: Seq Box :: 
  { Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0) } 
  $Is(z#0, 
      TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
     ==> Sequences.__default.Unzip#requires(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $ly, z#0)
       == true);

// definition axiom for Sequences.__default.Unzip(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, z#0)
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(z#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                z#0))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType)
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              z#0)
             && _System.Tuple2.___hMake2_q($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  z#0)): DatatypeType))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), z#0)
           == (if Seq#Length(z#0) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#0, b#0 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $ly, 
                      Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                        z#0)))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._0($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType)))), 
                $Box(Seq#Append(b#0, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      _System.Tuple2._1($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                            z#0)): DatatypeType))))))));

// definition axiom for Sequences.__default.Unzip for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Unzip$A: Ty, 
      Sequences._default.Unzip$B: Ty, 
      $ly: LayerType, 
      z#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0)) } 
    Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, Sequences._default.Unzip$B, Lit(z#0))
         || $Is(z#0, 
          TSeq(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B)))
       ==> (Seq#Length(Lit(z#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && Sequences.__default.Unzip#canCall(Sequences._default.Unzip$A, 
              Sequences._default.Unzip$B, 
              Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                  Lit(z#0))))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType))
             && 
            Sequences.__default.Last#canCall(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
              Lit(z#0))
             && _System.Tuple2.___hMake2_q(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                    Lit(z#0))): DatatypeType)))
         && Sequences.__default.Unzip(Sequences._default.Unzip$A, Sequences._default.Unzip$B, $LS($ly), Lit(z#0))
           == (if Seq#Length(Lit(z#0)) == LitInt(0)
             then #_System._tuple#2._#Make2($Box(Lit(Seq#Empty(): Seq Box)), $Box(Lit(Seq#Empty(): Seq Box)))
             else (var a#1, b#1 := $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box, 
                $Unbox(_System.Tuple2._1(Sequences.__default.Unzip(Sequences._default.Unzip$A, 
                      Sequences._default.Unzip$B, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                          Lit(z#0)))))): Seq Box; 
              #_System._tuple#2._#Make2($Box(Seq#Append(a#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._0(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType)))))), 
                $Box(Seq#Append(b#1, 
                    Seq#Build(Seq#Empty(): Seq Box, 
                      Lit(_System.Tuple2._1(Lit($Unbox(Sequences.__default.Last(Tclass._System.Tuple2(Sequences._default.Unzip$A, Sequences._default.Unzip$B), 
                                Lit(z#0))): DatatypeType))))))))));

// function declaration for Sequences._default.FlattenShape
function Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box)
   : Seq Box;

function Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0)
     == Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.FlattenShape
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
           == Seq#Length(seqs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(seqs#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0
                 < Seq#Length(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0))
             ==> $Unbox(Seq#Index(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
                  i#0)): int
               == Seq#Length($Unbox(Seq#Index(seqs#0, i#0)): Seq Box))
         && $Is(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $ly, seqs#0), 
          TSeq(Tclass._System.nat())));

function Sequences.__default.FlattenShape#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenShape
axiom (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
     ==> Sequences.__default.FlattenShape#requires(Sequences._default.FlattenShape$A, $ly, seqs#0)
       == true);

// definition axiom for Sequences.__default.FlattenShape(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0)
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), seqs#0))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), seqs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), seqs#0)): Seq Box))))));

// definition axiom for Sequences.__default.FlattenShape for all literals(revealed)
axiom true
   ==> (forall Sequences._default.FlattenShape$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.FlattenShape$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))
             && Sequences.__default.FlattenShape#canCall(Sequences._default.FlattenShape$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))
         && Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.FlattenShape(Sequences._default.FlattenShape$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Seq#Length(Lit($Unbox(Sequences.__default.Last(TSeq(Sequences._default.FlattenShape$A), Lit(seqs#0))): Seq Box)))))));

// function declaration for Sequences._default.FlattenLength
function Sequences.__default.FlattenLength($ly: LayerType, shape#0: Seq Box) : int;

function Sequences.__default.FlattenLength#canCall(shape#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
  Sequences.__default.FlattenLength($LS($ly), shape#0)
     == Sequences.__default.FlattenLength($ly, shape#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength(AsFuelBottom($ly), shape#0) } 
  Sequences.__default.FlattenLength($ly, shape#0)
     == Sequences.__default.FlattenLength($LZ, shape#0));

// consequence axiom for Sequences.__default.FlattenLength
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($ly, shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) == LitInt(0)
           ==> Sequences.__default.FlattenLength($ly, shape#0) == LitInt(0))
         && LitInt(0) <= Sequences.__default.FlattenLength($ly, shape#0));

function Sequences.__default.FlattenLength#requires(LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.FlattenLength
axiom (forall $ly: LayerType, shape#0: Seq Box :: 
  { Sequences.__default.FlattenLength#requires($ly, shape#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat()))
     ==> Sequences.__default.FlattenLength#requires($ly, shape#0) == true);

// definition axiom for Sequences.__default.FlattenLength(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    { Sequences.__default.FlattenLength($LS($ly), shape#0) } 
    Sequences.__default.FlattenLength#canCall(shape#0)
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(shape#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), shape#0))
         && Sequences.__default.FlattenLength($LS($ly), shape#0)
           == (if Seq#Length(shape#0) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), shape#0)): int));

// definition axiom for Sequences.__default.FlattenLength for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box :: 
    {:weight 3} { Sequences.__default.FlattenLength($LS($ly), Lit(shape#0)) } 
    Sequences.__default.FlattenLength#canCall(Lit(shape#0))
         || $Is(shape#0, TSeq(Tclass._System.nat()))
       ==> (Seq#Length(Lit(shape#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             && Sequences.__default.Last#canCall(Tclass._System.nat(), Lit(shape#0)))
         && Sequences.__default.FlattenLength($LS($ly), Lit(shape#0))
           == (if Seq#Length(Lit(shape#0)) == LitInt(0)
             then 0
             else Sequences.__default.FlattenLength($LS($ly), Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
               + $Unbox(Sequences.__default.Last(Tclass._System.nat(), Lit(shape#0))): int));

// function declaration for Sequences._default.Flatten
function Sequences.__default.Flatten(Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box) : Seq Box;

function Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A: Ty, seqs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0));

// fuel synonym axiom
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten(Sequences._default.Flatten$A, AsFuelBottom($ly), seqs#0) } 
  Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0)
     == Sequences.__default.Flatten(Sequences._default.Flatten$A, $LZ, seqs#0));

// consequence axiom for Sequences.__default.Flatten
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
            Sequences.__default.FlattenShape(Sequences._default.Flatten$A, StartFuel_Sequences._default.FlattenShape, seqs#0))
         && (Seq#Length(seqs#0) == LitInt(0)
           ==> Seq#Length(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0))
             == LitInt(0))
         && $Is(Sequences.__default.Flatten(Sequences._default.Flatten$A, $ly, seqs#0), 
          TSeq(Sequences._default.Flatten$A)));

function Sequences.__default.Flatten#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for Sequences.__default.Flatten
axiom (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
  { Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0) } 
  $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
     ==> Sequences.__default.Flatten#requires(Sequences._default.Flatten$A, $ly, seqs#0)
       == true);

const MoreFuel_Sequences._default.FlattenShape0: LayerType;

// definition axiom for Sequences.__default.Flatten(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, seqs#0)
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(seqs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), seqs#0)
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), seqs#0))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape0)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape0)
           == MoreFuel_Sequences._default.FlattenShape0
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), seqs#0)
           == (if Seq#Length(seqs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $ly, 
                Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), seqs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), seqs#0)): Seq Box)));

const MoreFuel_Sequences._default.FlattenShape1: LayerType;

// definition axiom for Sequences.__default.Flatten for all literals(revealed)
axiom true
   ==> (forall Sequences._default.Flatten$A: Ty, $ly: LayerType, seqs#0: Seq Box :: 
    {:weight 3} { Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0)) } 
    Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, Lit(seqs#0))
         || $Is(seqs#0, TSeq(TSeq(Sequences._default.Flatten$A)))
       ==> (Seq#Length(Lit(seqs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))
             && Sequences.__default.Flatten#canCall(Sequences._default.Flatten$A, 
              Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))))
             && Sequences.__default.Last#canCall(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))
         && 
        StartFuel_Sequences._default.FlattenShape
           == $LS(MoreFuel_Sequences._default.FlattenShape1)
         && StartFuelAssert_Sequences._default.FlattenShape
           == $LS($LS(MoreFuel_Sequences._default.FlattenShape1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenShape1)
           == MoreFuel_Sequences._default.FlattenShape1
         && Sequences.__default.Flatten(Sequences._default.Flatten$A, $LS($ly), Lit(seqs#0))
           == (if Seq#Length(Lit(seqs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.Flatten(Sequences._default.Flatten$A, 
                $LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Sequences._default.Flatten$A), Lit(seqs#0)))), 
              $Unbox(Sequences.__default.Last(TSeq(Sequences._default.Flatten$A), Lit(seqs#0))): Seq Box)));

// function declaration for Sequences._default.FlattenIndex
function Sequences.__default.FlattenIndex(shape#0: Seq Box, i#0: int, j#0: int) : int;

function Sequences.__default.FlattenIndex#canCall(shape#0: Seq Box, i#0: int, j#0: int) : bool;

// consequence axiom for Sequences.__default.FlattenIndex
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> LitInt(0) <= Sequences.__default.FlattenIndex(shape#0, i#0, j#0));

function Sequences.__default.FlattenIndex#requires(Seq Box, int, int) : bool;

// #requires axiom for Sequences.__default.FlattenIndex
axiom (forall shape#0: Seq Box, i#0: int, j#0: int :: 
  { Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0 && LitInt(0) <= j#0
     ==> Sequences.__default.FlattenIndex#requires(shape#0, i#0, j#0)
       == (i#0 < Seq#Length(shape#0) && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int));

// definition axiom for Sequences.__default.FlattenIndex(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    { Sequences.__default.FlattenIndex(shape#0, i#0, j#0) } 
    Sequences.__default.FlattenIndex#canCall(shape#0, i#0, j#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(shape#0)
           && j#0 < $Unbox(Seq#Index(shape#0, i#0)): int)
       ==> Sequences.__default.FlattenLength#canCall(Seq#Take(shape#0, i#0))
         && Sequences.__default.FlattenIndex(shape#0, i#0, j#0)
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Seq#Take(shape#0, i#0))
             + j#0);

// definition axiom for Sequences.__default.FlattenIndex for all literals(revealed)
axiom true
   ==> (forall shape#0: Seq Box, i#0: int, j#0: int :: 
    {:weight 3} { Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0)) } 
    Sequences.__default.FlattenIndex#canCall(Lit(shape#0), LitInt(i#0), LitInt(j#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && LitInt(0) <= j#0
           && 
          i#0 < Seq#Length(Lit(shape#0))
           && j#0 < $Unbox(Seq#Index(Lit(shape#0), LitInt(i#0))): int)
       ==> Sequences.__default.FlattenLength#canCall(Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
         && Sequences.__default.FlattenIndex(Lit(shape#0), LitInt(i#0), LitInt(j#0))
           == Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Seq#Take(Lit(shape#0), LitInt(i#0))))
             + j#0);

// function declaration for Sequences._default.UnflattenIndex
function Sequences.__default.UnflattenIndex($ly: LayerType, shape#0: Seq Box, i#0: int) : DatatypeType;

function Sequences.__default.UnflattenIndex#canCall(shape#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
     == Sequences.__default.UnflattenIndex($ly, shape#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex(AsFuelBottom($ly), shape#0, i#0) } 
  Sequences.__default.UnflattenIndex($ly, shape#0, i#0)
     == Sequences.__default.UnflattenIndex($LZ, shape#0, i#0));

// consequence axiom for Sequences.__default.UnflattenIndex
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($ly, shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> $Is(Sequences.__default.UnflattenIndex($ly, shape#0, i#0), 
        Tclass._System.Tuple2(Tclass._System.nat(), Tclass._System.nat())));

function Sequences.__default.UnflattenIndex#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Sequences.__default.UnflattenIndex
axiom (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
  { Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0) } 
  $Is(shape#0, TSeq(Tclass._System.nat())) && LitInt(0) <= i#0
     ==> Sequences.__default.UnflattenIndex#requires($ly, shape#0, i#0)
       == (i#0
         < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0)));

const MoreFuel_Sequences._default.FlattenLength0: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    { Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0) } 
    Sequences.__default.UnflattenIndex#canCall(shape#0, i#0)
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, shape#0))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
         && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.UnflattenIndex#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), shape#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.DropLast(Tclass._System.nat(), shape#0)))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength0)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength0))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength0)
           == MoreFuel_Sequences._default.FlattenLength0
         && Sequences.__default.UnflattenIndex($LS($ly), shape#0, i#0)
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Sequences.__default.DropLast(Tclass._System.nat(), shape#0))
             then Sequences.__default.UnflattenIndex($ly, Sequences.__default.DropLast(Tclass._System.nat(), shape#0), i#0)
             else #_System._tuple#2._#Make2($Box(Seq#Length(shape#0) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Sequences.__default.DropLast(Tclass._System.nat(), shape#0))))));

const MoreFuel_Sequences._default.FlattenLength1: LayerType;

// definition axiom for Sequences.__default.UnflattenIndex for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, shape#0: Seq Box, i#0: int :: 
    {:weight 3} { Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0)) } 
    Sequences.__default.UnflattenIndex#canCall(Lit(shape#0), LitInt(i#0))
         || (
          $Is(shape#0, TSeq(Tclass._System.nat()))
           && LitInt(0) <= i#0
           && i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, Lit(shape#0)))
       ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
         && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
         && (i#0
             < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.UnflattenIndex#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0)))
         && (Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             <= i#0
           ==> Sequences.__default.DropLast#canCall(Tclass._System.nat(), Lit(shape#0))
             && Sequences.__default.FlattenLength#canCall(Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0)))))
         && 
        StartFuel_Sequences._default.FlattenLength
           == $LS(MoreFuel_Sequences._default.FlattenLength1)
         && StartFuelAssert_Sequences._default.FlattenLength
           == $LS($LS(MoreFuel_Sequences._default.FlattenLength1))
         && AsFuelBottom(MoreFuel_Sequences._default.FlattenLength1)
           == MoreFuel_Sequences._default.FlattenLength1
         && Sequences.__default.UnflattenIndex($LS($ly), Lit(shape#0), LitInt(i#0))
           == (if i#0
               < Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))
             then Sequences.__default.UnflattenIndex($LS($ly), 
              Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))), 
              LitInt(i#0))
             else #_System._tuple#2._#Make2($Box(Seq#Length(Lit(shape#0)) - 1), 
              $Box(i#0
                   - Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                    Lit(Sequences.__default.DropLast(Tclass._System.nat(), Lit(shape#0))))))));

// function declaration for Sequences._default.fill
function Sequences.__default.fill(Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box) : Seq Box;

function Sequences.__default.fill#canCall(Sequences._default.fill$T: Ty, n#0: int, t#0: Box) : bool;

// layer synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0));

// fuel synonym axiom
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill(Sequences._default.fill$T, AsFuelBottom($ly), n#0, t#0) } 
  Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0)
     == Sequences.__default.fill(Sequences._default.fill$T, $LZ, n#0, t#0));

// consequence axiom for Sequences.__default.fill
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> Seq#Length(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0))
           == n#0
         && (forall i#0: int :: 
          { Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < n#0
             ==> Seq#Index(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), i#0)
               == t#0)
         && $Is(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0, t#0), 
          TSeq(Sequences._default.fill$T)));

function Sequences.__default.fill#requires(Ty, LayerType, int, Box) : bool;

// #requires axiom for Sequences.__default.fill
axiom (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
  { Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0) } 
  $IsBox(t#0, Sequences._default.fill$T)
     ==> Sequences.__default.fill#requires(Sequences._default.fill$T, $ly, n#0, t#0)
       == (n#0 >= LitInt(0)));

// definition axiom for Sequences.__default.fill(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0, t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && n#0 >= LitInt(0))
       ==> (n#0 != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, n#0 - 1, t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), n#0, t#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $ly, n#0 - 1, t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for decreasing-related literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), t#0)
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), t#0))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), t#0)
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), t#0), 
              Seq#Build(Seq#Empty(): Seq Box, t#0))));

// definition axiom for Sequences.__default.fill for all literals(revealed)
axiom true
   ==> (forall Sequences._default.fill$T: Ty, $ly: LayerType, n#0: int, t#0: Box :: 
    {:weight 3} { Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0)) } 
    Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0), Lit(t#0))
         || ($IsBox(t#0, Sequences._default.fill$T) && LitInt(n#0) >= LitInt(0))
       ==> (LitInt(n#0) != LitInt(0)
           ==> Sequences.__default.fill#canCall(Sequences._default.fill$T, LitInt(n#0 - 1), Lit(t#0)))
         && Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0), Lit(t#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(Sequences.__default.fill(Sequences._default.fill$T, $LS($ly), LitInt(n#0 - 1), Lit(t#0)), 
              Seq#Build(Seq#Empty(): Seq Box, Lit(t#0)))));

const unique class.ReferenceType.__default: ClassName;

function Tclass.ReferenceType.__default() : Ty;

// Tclass.ReferenceType.__default Tag
axiom Tag(Tclass.ReferenceType.__default()) == Tagclass.ReferenceType.__default;

const unique Tagclass.ReferenceType.__default: TyTag;

// Box/unbox axiom for Tclass.ReferenceType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ReferenceType.__default()) } 
  $IsBox(bx, Tclass.ReferenceType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ReferenceType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ReferenceType.__default()) } 
  $Is($o, Tclass.ReferenceType.__default())
     <==> $o == null || dtype($o) == Tclass.ReferenceType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ReferenceType.__default(), $h) } 
  $IsAlloc($o, Tclass.ReferenceType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ReferenceType._default.Root
function ReferenceType.__default.Root() : int;

function ReferenceType.__default.Root#canCall() : bool;

// consequence axiom for ReferenceType.__default.Root
axiom true
   ==> 
  true
   ==> LitInt(0) <= ReferenceType.__default.Root()
     && ReferenceType.__default.Root() < 18446744073709551616;

function ReferenceType.__default.Root#requires() : bool;

// #requires axiom for ReferenceType.__default.Root
axiom ReferenceType.__default.Root#requires() == true;

// definition axiom for ReferenceType.__default.Root(revealed)
axiom true ==> true ==> ReferenceType.__default.Root() == LitInt(0);

// definition axiom for ReferenceType.__default.Root for all literals(revealed)
axiom true ==> true ==> ReferenceType.__default.Root() == LitInt(0);

// function declaration for ReferenceType._default.toRef
function ReferenceType.__default.toRef(i#0: int) : int;

function ReferenceType.__default.toRef#canCall(i#0: int) : bool;

// consequence axiom for ReferenceType.__default.toRef
axiom true
   ==> (forall i#0: int :: 
    { ReferenceType.__default.toRef(i#0) } 
    ReferenceType.__default.toRef#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> LitInt(0) <= ReferenceType.__default.toRef(i#0)
         && ReferenceType.__default.toRef(i#0) < 18446744073709551616);

function ReferenceType.__default.toRef#requires(int) : bool;

// #requires axiom for ReferenceType.__default.toRef
axiom (forall i#0: int :: 
  { ReferenceType.__default.toRef#requires(i#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> ReferenceType.__default.toRef#requires(i#0) == true);

// definition axiom for ReferenceType.__default.toRef(revealed)
axiom true
   ==> (forall i#0: int :: 
    { ReferenceType.__default.toRef(i#0) } 
    ReferenceType.__default.toRef#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> ReferenceType.__default.toRef(i#0) == i#0);

// definition axiom for ReferenceType.__default.toRef for all literals(revealed)
axiom true
   ==> (forall i#0: int :: 
    {:weight 3} { ReferenceType.__default.toRef(LitInt(i#0)) } 
    ReferenceType.__default.toRef#canCall(LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> ReferenceType.__default.toRef(LitInt(i#0)) == LitInt(i#0));

// function declaration for ReferenceType._default.toUint64
function ReferenceType.__default.toUint64(i#0: int) : int;

function ReferenceType.__default.toUint64#canCall(i#0: int) : bool;

// consequence axiom for ReferenceType.__default.toUint64
axiom true
   ==> (forall i#0: int :: 
    { ReferenceType.__default.toUint64(i#0) } 
    ReferenceType.__default.toUint64#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> LitInt(0) <= ReferenceType.__default.toUint64(i#0)
         && ReferenceType.__default.toUint64(i#0) < 18446744073709551616);

function ReferenceType.__default.toUint64#requires(int) : bool;

// #requires axiom for ReferenceType.__default.toUint64
axiom (forall i#0: int :: 
  { ReferenceType.__default.toUint64#requires(i#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> ReferenceType.__default.toUint64#requires(i#0) == true);

// definition axiom for ReferenceType.__default.toUint64(revealed)
axiom true
   ==> (forall i#0: int :: 
    { ReferenceType.__default.toUint64(i#0) } 
    ReferenceType.__default.toUint64#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> ReferenceType.__default.toUint64(i#0) == i#0);

// definition axiom for ReferenceType.__default.toUint64 for all literals(revealed)
axiom true
   ==> (forall i#0: int :: 
    {:weight 3} { ReferenceType.__default.toUint64(LitInt(i#0)) } 
    ReferenceType.__default.toUint64#canCall(LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> ReferenceType.__default.toUint64(LitInt(i#0)) == LitInt(i#0));

function Tclass.ValueType.Value() : Ty;

// Tclass.ValueType.Value Tag
axiom Tag(Tclass.ValueType.Value()) == Tagclass.ValueType.Value;

const unique Tagclass.ValueType.Value: TyTag;

// Box/unbox axiom for Tclass.ValueType.Value
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.Value()) } 
  $IsBox(bx, Tclass.ValueType.Value())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.ValueType.Value()));

// ValueType.Value: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.ValueType.Value()) } 
  $Is(s#0, Tclass.ValueType.Value())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// ValueType.Value: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.ValueType.Value(), $h) } 
  $IsAlloc(s#0, Tclass.ValueType.Value(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.ValueType.__default: ClassName;

function Tclass.ValueType.__default() : Ty;

// Tclass.ValueType.__default Tag
axiom Tag(Tclass.ValueType.__default()) == Tagclass.ValueType.__default;

const unique Tagclass.ValueType.__default: TyTag;

// Box/unbox axiom for Tclass.ValueType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueType.__default()) } 
  $IsBox(bx, Tclass.ValueType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueType.__default()) } 
  $Is($o, Tclass.ValueType.__default())
     <==> $o == null || dtype($o) == Tclass.ValueType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueType.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueType._default.MaxLen
function ValueType.__default.MaxLen() : int;

function ValueType.__default.MaxLen#canCall() : bool;

// consequence axiom for ValueType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= ValueType.__default.MaxLen()
     && ValueType.__default.MaxLen() < 18446744073709551616;

function ValueType.__default.MaxLen#requires() : bool;

// #requires axiom for ValueType.__default.MaxLen
axiom ValueType.__default.MaxLen#requires() == true;

// definition axiom for ValueType.__default.MaxLen(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// definition axiom for ValueType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> ValueType.__default.MaxLen() == LitInt(1024);

// function declaration for ValueType._default.DefaultValue
function ValueType.__default.DefaultValue() : Seq Box;

function ValueType.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueType.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueType.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueType.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueType.__default.DefaultValue
axiom ValueType.__default.DefaultValue#requires() == true;

// definition axiom for ValueType.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// definition axiom for ValueType.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue() == Lit(Seq#Empty(): Seq Box);

// function declaration for ValueType._default.Len
function ValueType.__default.Len(v#0: Seq Box) : int;

function ValueType.__default.Len#canCall(v#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.Len
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> LitInt(0) <= ValueType.__default.Len(v#0));

function ValueType.__default.Len#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.Len
axiom (forall v#0: Seq Box :: 
  { ValueType.__default.Len#requires(v#0) } 
  $Is(v#0, Tclass.ValueType.Value())
     ==> ValueType.__default.Len#requires(v#0) == true);

// definition axiom for ValueType.__default.Len(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    { ValueType.__default.Len(v#0) } 
    ValueType.__default.Len#canCall(v#0) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(v#0) == Seq#Length(v#0));

// definition axiom for ValueType.__default.Len for all literals(revealed)
axiom true
   ==> (forall v#0: Seq Box :: 
    {:weight 3} { ValueType.__default.Len(Lit(v#0)) } 
    ValueType.__default.Len#canCall(Lit(v#0)) || $Is(v#0, Tclass.ValueType.Value())
       ==> ValueType.__default.Len(Lit(v#0)) == Seq#Length(Lit(v#0)));

// function declaration for ValueType._default.ValidMessageBytestring
function ValueType.__default.ValidMessageBytestring(s#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestring#canCall(s#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestring
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function ValueType.__default.ValidMessageBytestring#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestring
axiom (forall s#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestring#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueType.__default.ValidMessageBytestring#requires(s#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestring(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestring(s#0) } 
    ValueType.__default.ValidMessageBytestring#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(s#0)
           == (Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())));

// definition axiom for ValueType.__default.ValidMessageBytestring for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestring(Lit(s#0)) } 
    ValueType.__default.ValidMessageBytestring#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> ValueType.__default.MaxLen#canCall()
         && ValueType.__default.ValidMessageBytestring(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())));

// function declaration for ValueType._default.ValidMessageBytestrings
function ValueType.__default.ValidMessageBytestrings(strs#0: Seq Box) : bool;

function ValueType.__default.ValidMessageBytestrings#canCall(strs#0: Seq Box) : bool;

// consequence axiom for ValueType.__default.ValidMessageBytestrings
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function ValueType.__default.ValidMessageBytestrings#requires(Seq Box) : bool;

// #requires axiom for ValueType.__default.ValidMessageBytestrings
axiom (forall strs#0: Seq Box :: 
  { ValueType.__default.ValidMessageBytestrings#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueType.__default.ValidMessageBytestrings#requires(strs#0) == true);

// definition axiom for ValueType.__default.ValidMessageBytestrings(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { ValueType.__default.ValidMessageBytestrings(strs#0) } 
    ValueType.__default.ValidMessageBytestrings#canCall(strs#0)
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(strs#0, i#0)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(strs#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(strs#0, i#0)): Seq Box)));

// definition axiom for ValueType.__default.ValidMessageBytestrings for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { ValueType.__default.ValidMessageBytestrings(Lit(strs#0)) } 
    ValueType.__default.ValidMessageBytestrings#canCall(Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
             ==> ValueType.__default.ValidMessageBytestring#canCall($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box))
         && ValueType.__default.ValidMessageBytestrings(Lit(strs#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
               ==> ValueType.__default.ValidMessageBytestring($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box)));

function Tclass.KeyType.Key() : Ty;

// Tclass.KeyType.Key Tag
axiom Tag(Tclass.KeyType.Key()) == Tagclass.KeyType.Key;

const unique Tagclass.KeyType.Key: TyTag;

// Box/unbox axiom for Tclass.KeyType.Key
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.Key()) } 
  $IsBox(bx, Tclass.KeyType.Key())
     ==> $Box($Unbox(bx): Seq Box) == bx
       && $Is($Unbox(bx): Seq Box, Tclass.KeyType.Key()));

// KeyType.Key: subset type $Is
axiom (forall s#0: Seq Box :: 
  { $Is(s#0, Tclass.KeyType.Key()) } 
  $Is(s#0, Tclass.KeyType.Key())
     <==> $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) <= LitInt(1024));

// KeyType.Key: subset type $IsAlloc
axiom (forall s#0: Seq Box, $h: Heap :: 
  { $IsAlloc(s#0, Tclass.KeyType.Key(), $h) } 
  $IsAlloc(s#0, Tclass.KeyType.Key(), $h)
     <==> $IsAlloc(s#0, TSeq(Tclass.NativeTypes.byte()), $h));

const unique class.KeyType.__default: ClassName;

function Tclass.KeyType.__default() : Ty;

// Tclass.KeyType.__default Tag
axiom Tag(Tclass.KeyType.__default()) == Tagclass.KeyType.__default;

const unique Tagclass.KeyType.__default: TyTag;

// Box/unbox axiom for Tclass.KeyType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.KeyType.__default()) } 
  $IsBox(bx, Tclass.KeyType.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.KeyType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.KeyType.__default()) } 
  $Is($o, Tclass.KeyType.__default())
     <==> $o == null || dtype($o) == Tclass.KeyType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.KeyType.__default(), $h) } 
  $IsAlloc($o, Tclass.KeyType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for KeyType._default.MaxLen
function KeyType.__default.MaxLen() : int;

function KeyType.__default.MaxLen#canCall() : bool;

// consequence axiom for KeyType.__default.MaxLen
axiom true
   ==> 
  true
   ==> LitInt(0) <= KeyType.__default.MaxLen()
     && KeyType.__default.MaxLen() < 18446744073709551616;

function KeyType.__default.MaxLen#requires() : bool;

// #requires axiom for KeyType.__default.MaxLen
axiom KeyType.__default.MaxLen#requires() == true;

// definition axiom for KeyType.__default.MaxLen(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

// definition axiom for KeyType.__default.MaxLen for all literals(revealed)
axiom true ==> true ==> KeyType.__default.MaxLen() == LitInt(1024);

// Constructor function declaration
function #UI.RangeStart.SInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#0#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SInclusive(a#0#0#0)) == ##UI.RangeStart.SInclusive);

function UI.RangeStart.SInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SInclusive_q(d) } 
  UI.RangeStart.SInclusive_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #UI.RangeStart.SInclusive(a#1#0#0)));

function Tclass.UI.RangeStart() : Ty;

// Tclass.UI.RangeStart Tag
axiom Tag(Tclass.UI.RangeStart()) == Tagclass.UI.RangeStart;

const unique Tagclass.UI.RangeStart: TyTag;

// Box/unbox axiom for Tclass.UI.RangeStart
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeStart()) } 
  $IsBox(bx, Tclass.UI.RangeStart())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeStart()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SInclusive(a#2#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SInclusive(a#2#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#2#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SInclusive(a#3#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SInclusive(a#3#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(Lit(a#4#0#0)) } 
  #UI.RangeStart.SInclusive(Lit(a#4#0#0))
     == Lit(#UI.RangeStart.SInclusive(a#4#0#0)));

function UI.RangeStart.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #UI.RangeStart.SInclusive(a#5#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SInclusive(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #UI.RangeStart.SExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeStart.SExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#6#0#0) } 
  DatatypeCtorId(#UI.RangeStart.SExclusive(a#6#0#0)) == ##UI.RangeStart.SExclusive);

function UI.RangeStart.SExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.SExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.SExclusive_q(d) } 
  UI.RangeStart.SExclusive_q(d)
     ==> (exists a#7#0#0: Seq Box :: d == #UI.RangeStart.SExclusive(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: Seq Box :: 
  { $Is(#UI.RangeStart.SExclusive(a#8#0#0), Tclass.UI.RangeStart()) } 
  $Is(#UI.RangeStart.SExclusive(a#8#0#0), Tclass.UI.RangeStart())
     <==> $Is(a#8#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.SExclusive(a#9#0#0), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeStart.SExclusive(a#9#0#0), Tclass.UI.RangeStart(), $h)
       <==> $IsAlloc(a#9#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeStart.SExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeStart(), $h)
     ==> $IsAlloc(UI.RangeStart.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#10#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(Lit(a#10#0#0)) } 
  #UI.RangeStart.SExclusive(Lit(a#10#0#0))
     == Lit(#UI.RangeStart.SExclusive(a#10#0#0)));

// Constructor injectivity
axiom (forall a#11#0#0: Seq Box :: 
  { #UI.RangeStart.SExclusive(a#11#0#0) } 
  UI.RangeStart.key(#UI.RangeStart.SExclusive(a#11#0#0)) == a#11#0#0);

// Constructor function declaration
function #UI.RangeStart.NegativeInf() : DatatypeType;

const unique ##UI.RangeStart.NegativeInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeStart.NegativeInf()) == ##UI.RangeStart.NegativeInf;

function UI.RangeStart.NegativeInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d)
     <==> DatatypeCtorId(d) == ##UI.RangeStart.NegativeInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d) } 
  UI.RangeStart.NegativeInf_q(d) ==> d == #UI.RangeStart.NegativeInf());

// Constructor $Is
axiom $Is(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeStart.NegativeInf(), Tclass.UI.RangeStart(), $h));

// Constructor literal
axiom #UI.RangeStart.NegativeInf() == Lit(#UI.RangeStart.NegativeInf());

// Depth-one case-split function
function $IsA#UI.RangeStart(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeStart(d) } 
  $IsA#UI.RangeStart(d)
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeStart.NegativeInf_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SExclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
    { UI.RangeStart.SInclusive_q(d), $Is(d, Tclass.UI.RangeStart()) } 
  $Is(d, Tclass.UI.RangeStart())
     ==> UI.RangeStart.SInclusive_q(d)
       || UI.RangeStart.SExclusive_q(d)
       || UI.RangeStart.NegativeInf_q(d));

// Datatype extensional equality declaration
function UI.RangeStart#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeStart.SInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SInclusive_q(b) } 
  UI.RangeStart.SInclusive_q(a) && UI.RangeStart.SInclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.SExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.SExclusive_q(b) } 
  UI.RangeStart.SExclusive_q(a) && UI.RangeStart.SExclusive_q(b)
     ==> (UI.RangeStart#Equal(a, b)
       <==> Seq#Equal(UI.RangeStart.key(a), UI.RangeStart.key(b))));

// Datatype extensional equality definition: #UI.RangeStart.NegativeInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(a) } 
    { UI.RangeStart#Equal(a, b), UI.RangeStart.NegativeInf_q(b) } 
  UI.RangeStart.NegativeInf_q(a) && UI.RangeStart.NegativeInf_q(b)
     ==> (UI.RangeStart#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeStart
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeStart#Equal(a, b) } 
  UI.RangeStart#Equal(a, b) <==> a == b);

const unique class.UI.RangeStart: ClassName;

// Constructor function declaration
function #UI.RangeEnd.EInclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EInclusive: DtCtorId;

// Constructor identifier
axiom (forall a#17#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#17#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EInclusive(a#17#0#0)) == ##UI.RangeEnd.EInclusive);

function UI.RangeEnd.EInclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EInclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EInclusive_q(d) } 
  UI.RangeEnd.EInclusive_q(d)
     ==> (exists a#18#0#0: Seq Box :: d == #UI.RangeEnd.EInclusive(a#18#0#0)));

function Tclass.UI.RangeEnd() : Ty;

// Tclass.UI.RangeEnd Tag
axiom Tag(Tclass.UI.RangeEnd()) == Tagclass.UI.RangeEnd;

const unique Tagclass.UI.RangeEnd: TyTag;

// Box/unbox axiom for Tclass.UI.RangeEnd
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.RangeEnd()) } 
  $IsBox(bx, Tclass.UI.RangeEnd())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.RangeEnd()));

// Constructor $Is
axiom (forall a#19#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EInclusive(a#19#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EInclusive(a#19#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#19#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#20#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EInclusive(a#20#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EInclusive(a#20#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#20#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EInclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#21#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(Lit(a#21#0#0)) } 
  #UI.RangeEnd.EInclusive(Lit(a#21#0#0)) == Lit(#UI.RangeEnd.EInclusive(a#21#0#0)));

function UI.RangeEnd.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: Seq Box :: 
  { #UI.RangeEnd.EInclusive(a#22#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EInclusive(a#22#0#0)) == a#22#0#0);

// Constructor function declaration
function #UI.RangeEnd.EExclusive(Seq Box) : DatatypeType;

const unique ##UI.RangeEnd.EExclusive: DtCtorId;

// Constructor identifier
axiom (forall a#23#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#23#0#0) } 
  DatatypeCtorId(#UI.RangeEnd.EExclusive(a#23#0#0)) == ##UI.RangeEnd.EExclusive);

function UI.RangeEnd.EExclusive_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.EExclusive);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.EExclusive_q(d) } 
  UI.RangeEnd.EExclusive_q(d)
     ==> (exists a#24#0#0: Seq Box :: d == #UI.RangeEnd.EExclusive(a#24#0#0)));

// Constructor $Is
axiom (forall a#25#0#0: Seq Box :: 
  { $Is(#UI.RangeEnd.EExclusive(a#25#0#0), Tclass.UI.RangeEnd()) } 
  $Is(#UI.RangeEnd.EExclusive(a#25#0#0), Tclass.UI.RangeEnd())
     <==> $Is(a#25#0#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#26#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.EExclusive(a#26#0#0), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.RangeEnd.EExclusive(a#26#0#0), Tclass.UI.RangeEnd(), $h)
       <==> $IsAlloc(a#26#0#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.RangeEnd.EExclusive_q(d)
       && $IsAlloc(d, Tclass.UI.RangeEnd(), $h)
     ==> $IsAlloc(UI.RangeEnd.key(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#27#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(Lit(a#27#0#0)) } 
  #UI.RangeEnd.EExclusive(Lit(a#27#0#0)) == Lit(#UI.RangeEnd.EExclusive(a#27#0#0)));

// Constructor injectivity
axiom (forall a#28#0#0: Seq Box :: 
  { #UI.RangeEnd.EExclusive(a#28#0#0) } 
  UI.RangeEnd.key(#UI.RangeEnd.EExclusive(a#28#0#0)) == a#28#0#0);

// Constructor function declaration
function #UI.RangeEnd.PositiveInf() : DatatypeType;

const unique ##UI.RangeEnd.PositiveInf: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.RangeEnd.PositiveInf()) == ##UI.RangeEnd.PositiveInf;

function UI.RangeEnd.PositiveInf_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) <==> DatatypeCtorId(d) == ##UI.RangeEnd.PositiveInf);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d) } 
  UI.RangeEnd.PositiveInf_q(d) ==> d == #UI.RangeEnd.PositiveInf());

// Constructor $Is
axiom $Is(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#UI.RangeEnd.PositiveInf(), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom #UI.RangeEnd.PositiveInf() == Lit(#UI.RangeEnd.PositiveInf());

// Depth-one case-split function
function $IsA#UI.RangeEnd(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.RangeEnd(d) } 
  $IsA#UI.RangeEnd(d)
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.RangeEnd.PositiveInf_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EExclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
    { UI.RangeEnd.EInclusive_q(d), $Is(d, Tclass.UI.RangeEnd()) } 
  $Is(d, Tclass.UI.RangeEnd())
     ==> UI.RangeEnd.EInclusive_q(d)
       || UI.RangeEnd.EExclusive_q(d)
       || UI.RangeEnd.PositiveInf_q(d));

// Datatype extensional equality declaration
function UI.RangeEnd#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.RangeEnd.EInclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EInclusive_q(b) } 
  UI.RangeEnd.EInclusive_q(a) && UI.RangeEnd.EInclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.EExclusive
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.EExclusive_q(b) } 
  UI.RangeEnd.EExclusive_q(a) && UI.RangeEnd.EExclusive_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> Seq#Equal(UI.RangeEnd.key(a), UI.RangeEnd.key(b))));

// Datatype extensional equality definition: #UI.RangeEnd.PositiveInf
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(a) } 
    { UI.RangeEnd#Equal(a, b), UI.RangeEnd.PositiveInf_q(b) } 
  UI.RangeEnd.PositiveInf_q(a) && UI.RangeEnd.PositiveInf_q(b)
     ==> (UI.RangeEnd#Equal(a, b) <==> true));

// Datatype extensionality axiom: UI.RangeEnd
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.RangeEnd#Equal(a, b) } 
  UI.RangeEnd#Equal(a, b) <==> a == b);

const unique class.UI.RangeEnd: ClassName;

// Constructor function declaration
function #UI.SuccResult.SuccResult(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.SuccResult.SuccResult: DtCtorId;

// Constructor identifier
axiom (forall a#34#0#0: Seq Box, a#34#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#34#0#0, a#34#1#0) } 
  DatatypeCtorId(#UI.SuccResult.SuccResult(a#34#0#0, a#34#1#0))
     == ##UI.SuccResult.SuccResult);

function UI.SuccResult.SuccResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResult.SuccResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d) } 
  UI.SuccResult.SuccResult_q(d)
     ==> (exists a#35#0#0: Seq Box, a#35#1#0: Seq Box :: 
      d == #UI.SuccResult.SuccResult(a#35#0#0, a#35#1#0)));

function Tclass.UI.SuccResult() : Ty;

// Tclass.UI.SuccResult Tag
axiom Tag(Tclass.UI.SuccResult()) == Tagclass.UI.SuccResult;

const unique Tagclass.UI.SuccResult: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResult()) } 
  $IsBox(bx, Tclass.UI.SuccResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResult()));

// Constructor $Is
axiom (forall a#36#0#0: Seq Box, a#36#1#0: Seq Box :: 
  { $Is(#UI.SuccResult.SuccResult(a#36#0#0, a#36#1#0), Tclass.UI.SuccResult()) } 
  $Is(#UI.SuccResult.SuccResult(a#36#0#0, a#36#1#0), Tclass.UI.SuccResult())
     <==> $Is(a#36#0#0, Tclass.KeyType.Key()) && $Is(a#36#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#37#0#0: Seq Box, a#37#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.SuccResult.SuccResult(a#37#0#0, a#37#1#0), Tclass.UI.SuccResult(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResult.SuccResult(a#37#0#0, a#37#1#0), Tclass.UI.SuccResult(), $h)
       <==> $IsAlloc(a#37#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#37#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResult.SuccResult_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResult(), $h)
     ==> $IsAlloc(UI.SuccResult.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#38#0#0: Seq Box, a#38#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(Lit(a#38#0#0), Lit(a#38#1#0)) } 
  #UI.SuccResult.SuccResult(Lit(a#38#0#0), Lit(a#38#1#0))
     == Lit(#UI.SuccResult.SuccResult(a#38#0#0, a#38#1#0)));

function UI.SuccResult.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#39#0#0: Seq Box, a#39#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#39#0#0, a#39#1#0) } 
  UI.SuccResult.key(#UI.SuccResult.SuccResult(a#39#0#0, a#39#1#0)) == a#39#0#0);

function UI.SuccResult.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#40#0#0: Seq Box, a#40#1#0: Seq Box :: 
  { #UI.SuccResult.SuccResult(a#40#0#0, a#40#1#0) } 
  UI.SuccResult.value(#UI.SuccResult.SuccResult(a#40#0#0, a#40#1#0)) == a#40#1#0);

// Depth-one case-split function
function $IsA#UI.SuccResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResult(d) } 
  $IsA#UI.SuccResult(d) ==> UI.SuccResult.SuccResult_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResult.SuccResult_q(d), $Is(d, Tclass.UI.SuccResult()) } 
  $Is(d, Tclass.UI.SuccResult()) ==> UI.SuccResult.SuccResult_q(d));

// Datatype extensional equality declaration
function UI.SuccResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResult.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  true
     ==> (UI.SuccResult#Equal(a, b)
       <==> Seq#Equal(UI.SuccResult.key(a), UI.SuccResult.key(b))
         && Seq#Equal(UI.SuccResult.value(a), UI.SuccResult.value(b))));

// Datatype extensionality axiom: UI.SuccResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResult#Equal(a, b) } 
  UI.SuccResult#Equal(a, b) <==> a == b);

const unique class.UI.SuccResult: ClassName;

// Constructor function declaration
function #UI.SuccResultList.SuccResultList(Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.SuccResultList.SuccResultList: DtCtorId;

// Constructor identifier
axiom (forall a#41#0#0: Seq Box, a#41#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#41#0#0, a#41#1#0) } 
  DatatypeCtorId(#UI.SuccResultList.SuccResultList(a#41#0#0, a#41#1#0))
     == ##UI.SuccResultList.SuccResultList);

function UI.SuccResultList.SuccResultList_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     <==> DatatypeCtorId(d) == ##UI.SuccResultList.SuccResultList);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d) } 
  UI.SuccResultList.SuccResultList_q(d)
     ==> (exists a#42#0#0: Seq Box, a#42#1#0: DatatypeType :: 
      d == #UI.SuccResultList.SuccResultList(a#42#0#0, a#42#1#0)));

function Tclass.UI.SuccResultList() : Ty;

// Tclass.UI.SuccResultList Tag
axiom Tag(Tclass.UI.SuccResultList()) == Tagclass.UI.SuccResultList;

const unique Tagclass.UI.SuccResultList: TyTag;

// Box/unbox axiom for Tclass.UI.SuccResultList
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.SuccResultList()) } 
  $IsBox(bx, Tclass.UI.SuccResultList())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.SuccResultList()));

// Constructor $Is
axiom (forall a#43#0#0: Seq Box, a#43#1#0: DatatypeType :: 
  { $Is(#UI.SuccResultList.SuccResultList(a#43#0#0, a#43#1#0), 
      Tclass.UI.SuccResultList()) } 
  $Is(#UI.SuccResultList.SuccResultList(a#43#0#0, a#43#1#0), 
      Tclass.UI.SuccResultList())
     <==> $Is(a#43#0#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#43#1#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#44#0#0: Seq Box, a#44#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.SuccResultList.SuccResultList(a#44#0#0, a#44#1#0), 
      Tclass.UI.SuccResultList(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.SuccResultList.SuccResultList(a#44#0#0, a#44#1#0), 
        Tclass.UI.SuccResultList(), 
        $h)
       <==> $IsAlloc(a#44#0#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#44#1#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      UI.SuccResultList.SuccResultList_q(d)
       && $IsAlloc(d, Tclass.UI.SuccResultList(), $h)
     ==> $IsAlloc(UI.SuccResultList.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#45#0#0: Seq Box, a#45#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(Lit(a#45#0#0), Lit(a#45#1#0)) } 
  #UI.SuccResultList.SuccResultList(Lit(a#45#0#0), Lit(a#45#1#0))
     == Lit(#UI.SuccResultList.SuccResultList(a#45#0#0, a#45#1#0)));

function UI.SuccResultList.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#46#0#0: Seq Box, a#46#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#46#0#0, a#46#1#0) } 
  UI.SuccResultList.results(#UI.SuccResultList.SuccResultList(a#46#0#0, a#46#1#0))
     == a#46#0#0);

// Inductive seq element rank
axiom (forall a#47#0#0: Seq Box, a#47#1#0: DatatypeType, i: int :: 
  { Seq#Index(a#47#0#0, i), #UI.SuccResultList.SuccResultList(a#47#0#0, a#47#1#0) } 
  0 <= i && i < Seq#Length(a#47#0#0)
     ==> DtRank($Unbox(Seq#Index(a#47#0#0, i)): DatatypeType)
       < DtRank(#UI.SuccResultList.SuccResultList(a#47#0#0, a#47#1#0)));

// Inductive seq rank
axiom (forall a#48#0#0: Seq Box, a#48#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#48#0#0, a#48#1#0) } 
  Seq#Rank(a#48#0#0)
     < DtRank(#UI.SuccResultList.SuccResultList(a#48#0#0, a#48#1#0)));

function UI.SuccResultList.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#49#0#0: Seq Box, a#49#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#49#0#0, a#49#1#0) } 
  UI.SuccResultList.end(#UI.SuccResultList.SuccResultList(a#49#0#0, a#49#1#0))
     == a#49#1#0);

// Inductive rank
axiom (forall a#50#0#0: Seq Box, a#50#1#0: DatatypeType :: 
  { #UI.SuccResultList.SuccResultList(a#50#0#0, a#50#1#0) } 
  DtRank(a#50#1#0) < DtRank(#UI.SuccResultList.SuccResultList(a#50#0#0, a#50#1#0)));

// Depth-one case-split function
function $IsA#UI.SuccResultList(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.SuccResultList(d) } 
  $IsA#UI.SuccResultList(d) ==> UI.SuccResultList.SuccResultList_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.SuccResultList.SuccResultList_q(d), $Is(d, Tclass.UI.SuccResultList()) } 
  $Is(d, Tclass.UI.SuccResultList()) ==> UI.SuccResultList.SuccResultList_q(d));

// Datatype extensional equality declaration
function UI.SuccResultList#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.SuccResultList.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  true
     ==> (UI.SuccResultList#Equal(a, b)
       <==> Seq#Equal(UI.SuccResultList.results(a), UI.SuccResultList.results(b))
         && UI.RangeEnd#Equal(UI.SuccResultList.end(a), UI.SuccResultList.end(b))));

// Datatype extensionality axiom: UI.SuccResultList
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.SuccResultList#Equal(a, b) } 
  UI.SuccResultList#Equal(a, b) <==> a == b);

const unique class.UI.SuccResultList: ClassName;

// Constructor function declaration
function #UI.Op.NoOp() : DatatypeType;

const unique ##UI.Op.NoOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.NoOp()) == ##UI.Op.NoOp;

function UI.Op.NoOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.NoOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.NoOp_q(d) } 
  UI.Op.NoOp_q(d) ==> d == #UI.Op.NoOp());

function Tclass.UI.Op() : Ty;

// Tclass.UI.Op Tag
axiom Tag(Tclass.UI.Op()) == Tagclass.UI.Op;

const unique Tagclass.UI.Op: TyTag;

// Box/unbox axiom for Tclass.UI.Op
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.Op()) } 
  $IsBox(bx, Tclass.UI.Op())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.UI.Op()));

// Constructor $Is
axiom $Is(#UI.Op.NoOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.NoOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.NoOp() == Lit(#UI.Op.NoOp());

// Constructor function declaration
function #UI.Op.SyncOp() : DatatypeType;

const unique ##UI.Op.SyncOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.SyncOp()) == ##UI.Op.SyncOp;

function UI.Op.SyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SyncOp_q(d) } 
  UI.Op.SyncOp_q(d) ==> d == #UI.Op.SyncOp());

// Constructor $Is
axiom $Is(#UI.Op.SyncOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.SyncOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.SyncOp() == Lit(#UI.Op.SyncOp());

// Constructor function declaration
function #UI.Op.CrashOp() : DatatypeType;

const unique ##UI.Op.CrashOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#UI.Op.CrashOp()) == ##UI.Op.CrashOp;

function UI.Op.CrashOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.CrashOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.CrashOp_q(d) } 
  UI.Op.CrashOp_q(d) ==> d == #UI.Op.CrashOp());

// Constructor $Is
axiom $Is(#UI.Op.CrashOp(), Tclass.UI.Op());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#UI.Op.CrashOp(), Tclass.UI.Op(), $h));

// Constructor literal
axiom #UI.Op.CrashOp() == Lit(#UI.Op.CrashOp());

// Constructor function declaration
function #UI.Op.PushSyncOp(int) : DatatypeType;

const unique ##UI.Op.PushSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#66#0#0: int :: 
  { #UI.Op.PushSyncOp(a#66#0#0) } 
  DatatypeCtorId(#UI.Op.PushSyncOp(a#66#0#0)) == ##UI.Op.PushSyncOp);

function UI.Op.PushSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PushSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PushSyncOp_q(d) } 
  UI.Op.PushSyncOp_q(d)
     ==> (exists a#67#0#0: int :: d == #UI.Op.PushSyncOp(a#67#0#0)));

// Constructor $Is
axiom (forall a#68#0#0: int :: 
  { $Is(#UI.Op.PushSyncOp(a#68#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PushSyncOp(a#68#0#0), Tclass.UI.Op()) <==> $Is(a#68#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#69#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PushSyncOp(a#69#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PushSyncOp(a#69#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#69#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PushSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#70#0#0: int :: 
  { #UI.Op.PushSyncOp(LitInt(a#70#0#0)) } 
  #UI.Op.PushSyncOp(LitInt(a#70#0#0)) == Lit(#UI.Op.PushSyncOp(a#70#0#0)));

function UI.Op.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#71#0#0: int :: 
  { #UI.Op.PushSyncOp(a#71#0#0) } 
  UI.Op.id(#UI.Op.PushSyncOp(a#71#0#0)) == a#71#0#0);

// Constructor function declaration
function #UI.Op.PopSyncOp(int) : DatatypeType;

const unique ##UI.Op.PopSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#72#0#0: int :: 
  { #UI.Op.PopSyncOp(a#72#0#0) } 
  DatatypeCtorId(#UI.Op.PopSyncOp(a#72#0#0)) == ##UI.Op.PopSyncOp);

function UI.Op.PopSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PopSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PopSyncOp_q(d) } 
  UI.Op.PopSyncOp_q(d)
     ==> (exists a#73#0#0: int :: d == #UI.Op.PopSyncOp(a#73#0#0)));

// Constructor $Is
axiom (forall a#74#0#0: int :: 
  { $Is(#UI.Op.PopSyncOp(a#74#0#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PopSyncOp(a#74#0#0), Tclass.UI.Op()) <==> $Is(a#74#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#75#0#0: int, $h: Heap :: 
  { $IsAlloc(#UI.Op.PopSyncOp(a#75#0#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PopSyncOp(a#75#0#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#75#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.id(d), TInt, $h) } 
  $IsGoodHeap($h) && UI.Op.PopSyncOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.id(d), TInt, $h));

// Constructor literal
axiom (forall a#76#0#0: int :: 
  { #UI.Op.PopSyncOp(LitInt(a#76#0#0)) } 
  #UI.Op.PopSyncOp(LitInt(a#76#0#0)) == Lit(#UI.Op.PopSyncOp(a#76#0#0)));

// Constructor injectivity
axiom (forall a#77#0#0: int :: 
  { #UI.Op.PopSyncOp(a#77#0#0) } 
  UI.Op.id(#UI.Op.PopSyncOp(a#77#0#0)) == a#77#0#0);

// Constructor function declaration
function #UI.Op.GetOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.GetOp: DtCtorId;

// Constructor identifier
axiom (forall a#78#0#0: Seq Box, a#78#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#78#0#0, a#78#1#0) } 
  DatatypeCtorId(#UI.Op.GetOp(a#78#0#0, a#78#1#0)) == ##UI.Op.GetOp);

function UI.Op.GetOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.GetOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.GetOp_q(d) } 
  UI.Op.GetOp_q(d)
     ==> (exists a#79#0#0: Seq Box, a#79#1#0: Seq Box :: 
      d == #UI.Op.GetOp(a#79#0#0, a#79#1#0)));

// Constructor $Is
axiom (forall a#80#0#0: Seq Box, a#80#1#0: Seq Box :: 
  { $Is(#UI.Op.GetOp(a#80#0#0, a#80#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.GetOp(a#80#0#0, a#80#1#0), Tclass.UI.Op())
     <==> $Is(a#80#0#0, Tclass.KeyType.Key()) && $Is(a#80#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#81#0#0: Seq Box, a#81#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.GetOp(a#81#0#0, a#81#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.GetOp(a#81#0#0, a#81#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#81#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#81#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.GetOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#82#0#0: Seq Box, a#82#1#0: Seq Box :: 
  { #UI.Op.GetOp(Lit(a#82#0#0), Lit(a#82#1#0)) } 
  #UI.Op.GetOp(Lit(a#82#0#0), Lit(a#82#1#0))
     == Lit(#UI.Op.GetOp(a#82#0#0, a#82#1#0)));

function UI.Op.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#83#0#0: Seq Box, a#83#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#83#0#0, a#83#1#0) } 
  UI.Op.key(#UI.Op.GetOp(a#83#0#0, a#83#1#0)) == a#83#0#0);

function UI.Op.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#84#0#0: Seq Box, a#84#1#0: Seq Box :: 
  { #UI.Op.GetOp(a#84#0#0, a#84#1#0) } 
  UI.Op.value(#UI.Op.GetOp(a#84#0#0, a#84#1#0)) == a#84#1#0);

// Constructor function declaration
function #UI.Op.PutOp(Seq Box, Seq Box) : DatatypeType;

const unique ##UI.Op.PutOp: DtCtorId;

// Constructor identifier
axiom (forall a#85#0#0: Seq Box, a#85#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#85#0#0, a#85#1#0) } 
  DatatypeCtorId(#UI.Op.PutOp(a#85#0#0, a#85#1#0)) == ##UI.Op.PutOp);

function UI.Op.PutOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.PutOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.PutOp_q(d) } 
  UI.Op.PutOp_q(d)
     ==> (exists a#86#0#0: Seq Box, a#86#1#0: Seq Box :: 
      d == #UI.Op.PutOp(a#86#0#0, a#86#1#0)));

// Constructor $Is
axiom (forall a#87#0#0: Seq Box, a#87#1#0: Seq Box :: 
  { $Is(#UI.Op.PutOp(a#87#0#0, a#87#1#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.PutOp(a#87#0#0, a#87#1#0), Tclass.UI.Op())
     <==> $Is(a#87#0#0, Tclass.KeyType.Key()) && $Is(a#87#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#88#0#0: Seq Box, a#88#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#UI.Op.PutOp(a#88#0#0, a#88#1#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.PutOp(a#88#0#0, a#88#1#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#88#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#88#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h) && UI.Op.PutOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#89#0#0: Seq Box, a#89#1#0: Seq Box :: 
  { #UI.Op.PutOp(Lit(a#89#0#0), Lit(a#89#1#0)) } 
  #UI.Op.PutOp(Lit(a#89#0#0), Lit(a#89#1#0))
     == Lit(#UI.Op.PutOp(a#89#0#0, a#89#1#0)));

// Constructor injectivity
axiom (forall a#90#0#0: Seq Box, a#90#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#90#0#0, a#90#1#0) } 
  UI.Op.key(#UI.Op.PutOp(a#90#0#0, a#90#1#0)) == a#90#0#0);

// Constructor injectivity
axiom (forall a#91#0#0: Seq Box, a#91#1#0: Seq Box :: 
  { #UI.Op.PutOp(a#91#0#0, a#91#1#0) } 
  UI.Op.value(#UI.Op.PutOp(a#91#0#0, a#91#1#0)) == a#91#1#0);

// Constructor function declaration
function #UI.Op.SuccOp(DatatypeType, Seq Box, DatatypeType) : DatatypeType;

const unique ##UI.Op.SuccOp: DtCtorId;

// Constructor identifier
axiom (forall a#92#0#0: DatatypeType, a#92#1#0: Seq Box, a#92#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#92#0#0, a#92#1#0, a#92#2#0) } 
  DatatypeCtorId(#UI.Op.SuccOp(a#92#0#0, a#92#1#0, a#92#2#0)) == ##UI.Op.SuccOp);

function UI.Op.SuccOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d) <==> DatatypeCtorId(d) == ##UI.Op.SuccOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d) } 
  UI.Op.SuccOp_q(d)
     ==> (exists a#93#0#0: DatatypeType, a#93#1#0: Seq Box, a#93#2#0: DatatypeType :: 
      d == #UI.Op.SuccOp(a#93#0#0, a#93#1#0, a#93#2#0)));

// Constructor $Is
axiom (forall a#94#0#0: DatatypeType, a#94#1#0: Seq Box, a#94#2#0: DatatypeType :: 
  { $Is(#UI.Op.SuccOp(a#94#0#0, a#94#1#0, a#94#2#0), Tclass.UI.Op()) } 
  $Is(#UI.Op.SuccOp(a#94#0#0, a#94#1#0, a#94#2#0), Tclass.UI.Op())
     <==> $Is(a#94#0#0, Tclass.UI.RangeStart())
       && $Is(a#94#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#94#2#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#95#0#0: DatatypeType, a#95#1#0: Seq Box, a#95#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#UI.Op.SuccOp(a#95#0#0, a#95#1#0, a#95#2#0), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#UI.Op.SuccOp(a#95#0#0, a#95#1#0, a#95#2#0), Tclass.UI.Op(), $h)
       <==> $IsAlloc(a#95#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#95#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#95#2#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h) && UI.Op.SuccOp_q(d) && $IsAlloc(d, Tclass.UI.Op(), $h)
     ==> $IsAlloc(UI.Op.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#96#0#0: DatatypeType, a#96#1#0: Seq Box, a#96#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(Lit(a#96#0#0), Lit(a#96#1#0), Lit(a#96#2#0)) } 
  #UI.Op.SuccOp(Lit(a#96#0#0), Lit(a#96#1#0), Lit(a#96#2#0))
     == Lit(#UI.Op.SuccOp(a#96#0#0, a#96#1#0, a#96#2#0)));

function UI.Op.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#97#0#0: DatatypeType, a#97#1#0: Seq Box, a#97#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#97#0#0, a#97#1#0, a#97#2#0) } 
  UI.Op.start(#UI.Op.SuccOp(a#97#0#0, a#97#1#0, a#97#2#0)) == a#97#0#0);

// Inductive rank
axiom (forall a#98#0#0: DatatypeType, a#98#1#0: Seq Box, a#98#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#98#0#0, a#98#1#0, a#98#2#0) } 
  DtRank(a#98#0#0) < DtRank(#UI.Op.SuccOp(a#98#0#0, a#98#1#0, a#98#2#0)));

function UI.Op.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#99#0#0: DatatypeType, a#99#1#0: Seq Box, a#99#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#99#0#0, a#99#1#0, a#99#2#0) } 
  UI.Op.results(#UI.Op.SuccOp(a#99#0#0, a#99#1#0, a#99#2#0)) == a#99#1#0);

// Inductive seq element rank
axiom (forall a#100#0#0: DatatypeType, a#100#1#0: Seq Box, a#100#2#0: DatatypeType, i: int :: 
  { Seq#Index(a#100#1#0, i), #UI.Op.SuccOp(a#100#0#0, a#100#1#0, a#100#2#0) } 
  0 <= i && i < Seq#Length(a#100#1#0)
     ==> DtRank($Unbox(Seq#Index(a#100#1#0, i)): DatatypeType)
       < DtRank(#UI.Op.SuccOp(a#100#0#0, a#100#1#0, a#100#2#0)));

// Inductive seq rank
axiom (forall a#101#0#0: DatatypeType, a#101#1#0: Seq Box, a#101#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#101#0#0, a#101#1#0, a#101#2#0) } 
  Seq#Rank(a#101#1#0) < DtRank(#UI.Op.SuccOp(a#101#0#0, a#101#1#0, a#101#2#0)));

function UI.Op.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#102#0#0: DatatypeType, a#102#1#0: Seq Box, a#102#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#102#0#0, a#102#1#0, a#102#2#0) } 
  UI.Op.end(#UI.Op.SuccOp(a#102#0#0, a#102#1#0, a#102#2#0)) == a#102#2#0);

// Inductive rank
axiom (forall a#103#0#0: DatatypeType, a#103#1#0: Seq Box, a#103#2#0: DatatypeType :: 
  { #UI.Op.SuccOp(a#103#0#0, a#103#1#0, a#103#2#0) } 
  DtRank(a#103#2#0) < DtRank(#UI.Op.SuccOp(a#103#0#0, a#103#1#0, a#103#2#0)));

// Depth-one case-split function
function $IsA#UI.Op(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#UI.Op(d) } 
  $IsA#UI.Op(d)
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { UI.Op.SuccOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PutOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.GetOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PopSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.PushSyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.CrashOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.SyncOp_q(d), $Is(d, Tclass.UI.Op()) } 
    { UI.Op.NoOp_q(d), $Is(d, Tclass.UI.Op()) } 
  $Is(d, Tclass.UI.Op())
     ==> UI.Op.NoOp_q(d)
       || UI.Op.SyncOp_q(d)
       || UI.Op.CrashOp_q(d)
       || UI.Op.PushSyncOp_q(d)
       || UI.Op.PopSyncOp_q(d)
       || UI.Op.GetOp_q(d)
       || UI.Op.PutOp_q(d)
       || UI.Op.SuccOp_q(d));

// Datatype extensional equality declaration
function UI.Op#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #UI.Op.NoOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.NoOp_q(a) } { UI.Op#Equal(a, b), UI.Op.NoOp_q(b) } 
  UI.Op.NoOp_q(a) && UI.Op.NoOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.SyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SyncOp_q(b) } 
  UI.Op.SyncOp_q(a) && UI.Op.SyncOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.CrashOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.CrashOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.CrashOp_q(b) } 
  UI.Op.CrashOp_q(a) && UI.Op.CrashOp_q(b) ==> (UI.Op#Equal(a, b) <==> true));

// Datatype extensional equality definition: #UI.Op.PushSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PushSyncOp_q(b) } 
  UI.Op.PushSyncOp_q(a) && UI.Op.PushSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.PopSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.PopSyncOp_q(b) } 
  UI.Op.PopSyncOp_q(a) && UI.Op.PopSyncOp_q(b)
     ==> (UI.Op#Equal(a, b) <==> UI.Op.id(a) == UI.Op.id(b)));

// Datatype extensional equality definition: #UI.Op.GetOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.GetOp_q(a) } { UI.Op#Equal(a, b), UI.Op.GetOp_q(b) } 
  UI.Op.GetOp_q(a) && UI.Op.GetOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.PutOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.PutOp_q(a) } { UI.Op#Equal(a, b), UI.Op.PutOp_q(b) } 
  UI.Op.PutOp_q(a) && UI.Op.PutOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> Seq#Equal(UI.Op.key(a), UI.Op.key(b))
         && Seq#Equal(UI.Op.value(a), UI.Op.value(b))));

// Datatype extensional equality definition: #UI.Op.SuccOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b), UI.Op.SuccOp_q(a) } 
    { UI.Op#Equal(a, b), UI.Op.SuccOp_q(b) } 
  UI.Op.SuccOp_q(a) && UI.Op.SuccOp_q(b)
     ==> (UI.Op#Equal(a, b)
       <==> UI.RangeStart#Equal(UI.Op.start(a), UI.Op.start(b))
         && Seq#Equal(UI.Op.results(a), UI.Op.results(b))
         && UI.RangeEnd#Equal(UI.Op.end(a), UI.Op.end(b))));

// Datatype extensionality axiom: UI.Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { UI.Op#Equal(a, b) } 
  UI.Op#Equal(a, b) <==> a == b);

const unique class.UI.Op: ClassName;

const unique class.UI.__default: ClassName;

function Tclass.UI.__default() : Ty;

// Tclass.UI.__default Tag
axiom Tag(Tclass.UI.__default()) == Tagclass.UI.__default;

const unique Tagclass.UI.__default: TyTag;

// Box/unbox axiom for Tclass.UI.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.UI.__default()) } 
  $IsBox(bx, Tclass.UI.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.UI.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.UI.__default()) } 
  $Is($o, Tclass.UI.__default())
     <==> $o == null || dtype($o) == Tclass.UI.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.UI.__default(), $h) } 
  $IsAlloc($o, Tclass.UI.__default(), $h) <==> $o == null || read($h, $o, alloc));

const unique class.SeqComparison.__default: ClassName;

function Tclass.SeqComparison.__default() : Ty;

// Tclass.SeqComparison.__default Tag
axiom Tag(Tclass.SeqComparison.__default()) == Tagclass.SeqComparison.__default;

const unique Tagclass.SeqComparison.__default: TyTag;

// Box/unbox axiom for Tclass.SeqComparison.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SeqComparison.__default()) } 
  $IsBox(bx, Tclass.SeqComparison.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SeqComparison.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SeqComparison.__default()) } 
  $Is($o, Tclass.SeqComparison.__default())
     <==> $o == null || dtype($o) == Tclass.SeqComparison.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SeqComparison.__default(), $h) } 
  $IsAlloc($o, Tclass.SeqComparison.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for SeqComparison._default.lte
function SeqComparison.__default.lte($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
  SeqComparison.__default.lte($LS($ly), a#0, b#0)
     == SeqComparison.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  SeqComparison.__default.lte($ly, a#0, b#0)
     == SeqComparison.__default.lte($LZ, a#0, b#0));

// consequence axiom for SeqComparison.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($ly, a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lte
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lte#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lte#requires($ly, a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lte($LS($ly), a#0, b#0) } 
    SeqComparison.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int <= $Unbox(Seq#Index(a#0, LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(a#0, LitInt(0))): int <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(a#0, LitInt(0))): int < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int < $Unbox(Seq#Index(a#0, LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($ly, Seq#Drop(a#0, LitInt(1)), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(b#0) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(b#0, LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(b#0, LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), b#0)
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(b#0) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(b#0, LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(b#0, LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Seq#Drop(b#0, LitInt(1))))))));

// definition axiom for SeqComparison.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> 
          Seq#Length(Lit(b#0)) != LitInt(0)
           ==> 
          $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
           ==> 
          $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
             <= $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
           ==> SeqComparison.__default.lte#canCall(Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))
         && SeqComparison.__default.lte($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then true
             else (if Seq#Length(Lit(b#0)) == LitInt(0)
               then false
               else (if $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   < $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                 then true
                 else (if $Unbox(Seq#Index(Lit(b#0), LitInt(0))): int
                     < $Unbox(Seq#Index(Lit(a#0), LitInt(0))): int
                   then false
                   else SeqComparison.__default.lte($LS($ly), Lit(Seq#Drop(Lit(a#0), LitInt(1))), Lit(Seq#Drop(Lit(b#0), LitInt(1)))))))));

// function declaration for SeqComparison._default.lt
function SeqComparison.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function SeqComparison.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for SeqComparison.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function SeqComparison.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for SeqComparison.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { SeqComparison.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> SeqComparison.__default.lt#requires(a#0, b#0) == true);

// definition axiom for SeqComparison.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { SeqComparison.__default.lt(a#0, b#0) } 
    SeqComparison.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && SeqComparison.__default.lt(a#0, b#0)
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0)
             && !Seq#Equal(a#0, b#0)));

// definition axiom for SeqComparison.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { SeqComparison.__default.lt(Lit(a#0), Lit(b#0)) } 
    SeqComparison.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && SeqComparison.__default.lt(Lit(a#0), Lit(b#0))
           == (SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

// Constructor function declaration
function #MapSpec.Constants.Constants() : DatatypeType;

const unique ##MapSpec.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#MapSpec.Constants.Constants()) == ##MapSpec.Constants.Constants;

function MapSpec.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Constants.Constants_q(d) } 
  MapSpec.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##MapSpec.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Constants.Constants_q(d) } 
  MapSpec.Constants.Constants_q(d) ==> d == #MapSpec.Constants.Constants());

function Tclass.MapSpec.Constants() : Ty;

// Tclass.MapSpec.Constants Tag
axiom Tag(Tclass.MapSpec.Constants()) == Tagclass.MapSpec.Constants;

const unique Tagclass.MapSpec.Constants: TyTag;

// Box/unbox axiom for Tclass.MapSpec.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.Constants()) } 
  $IsBox(bx, Tclass.MapSpec.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MapSpec.Constants()));

// Constructor $Is
axiom $Is(#MapSpec.Constants.Constants(), Tclass.MapSpec.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#MapSpec.Constants.Constants(), Tclass.MapSpec.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#MapSpec.Constants.Constants(), Tclass.MapSpec.Constants(), $h));

// Constructor literal
axiom #MapSpec.Constants.Constants() == Lit(#MapSpec.Constants.Constants());

// Depth-one case-split function
function $IsA#MapSpec.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MapSpec.Constants(d) } 
  $IsA#MapSpec.Constants(d) ==> MapSpec.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MapSpec.Constants.Constants_q(d), $Is(d, Tclass.MapSpec.Constants()) } 
  $Is(d, Tclass.MapSpec.Constants()) ==> MapSpec.Constants.Constants_q(d));

// Datatype extensional equality declaration
function MapSpec.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MapSpec.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Constants#Equal(a, b) } 
  true ==> (MapSpec.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: MapSpec.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Constants#Equal(a, b) } 
  MapSpec.Constants#Equal(a, b) <==> a == b);

const unique class.MapSpec.Constants: ClassName;

// Constructor function declaration
function #MapSpec.Variables.Variables(IMap Box Box) : DatatypeType;

const unique ##MapSpec.Variables.Variables: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: IMap Box Box :: 
  { #MapSpec.Variables.Variables(a#5#0#0) } 
  DatatypeCtorId(#MapSpec.Variables.Variables(a#5#0#0))
     == ##MapSpec.Variables.Variables);

function MapSpec.Variables.Variables_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Variables.Variables_q(d) } 
  MapSpec.Variables.Variables_q(d)
     <==> DatatypeCtorId(d) == ##MapSpec.Variables.Variables);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Variables.Variables_q(d) } 
  MapSpec.Variables.Variables_q(d)
     ==> (exists a#6#0#0: IMap Box Box :: d == #MapSpec.Variables.Variables(a#6#0#0)));

function Tclass.MapSpec.Variables() : Ty;

// Tclass.MapSpec.Variables Tag
axiom Tag(Tclass.MapSpec.Variables()) == Tagclass.MapSpec.Variables;

const unique Tagclass.MapSpec.Variables: TyTag;

// Box/unbox axiom for Tclass.MapSpec.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.Variables()) } 
  $IsBox(bx, Tclass.MapSpec.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MapSpec.Variables()));

// Constructor $Is
axiom (forall a#7#0#0: IMap Box Box :: 
  { $Is(#MapSpec.Variables.Variables(a#7#0#0), Tclass.MapSpec.Variables()) } 
  $Is(#MapSpec.Variables.Variables(a#7#0#0), Tclass.MapSpec.Variables())
     <==> $Is(a#7#0#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

// Constructor $IsAlloc
axiom (forall a#8#0#0: IMap Box Box, $h: Heap :: 
  { $IsAlloc(#MapSpec.Variables.Variables(a#8#0#0), Tclass.MapSpec.Variables(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Variables.Variables(a#8#0#0), Tclass.MapSpec.Variables(), $h)
       <==> $IsAlloc(a#8#0#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Variables.view(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Variables(), $h)
     ==> $IsAlloc(MapSpec.Variables.view(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()), 
      $h));

// Constructor literal
axiom (forall a#9#0#0: IMap Box Box :: 
  { #MapSpec.Variables.Variables(Lit(a#9#0#0)) } 
  #MapSpec.Variables.Variables(Lit(a#9#0#0))
     == Lit(#MapSpec.Variables.Variables(a#9#0#0)));

function MapSpec.Variables.view(DatatypeType) : IMap Box Box;

// Constructor injectivity
axiom (forall a#10#0#0: IMap Box Box :: 
  { #MapSpec.Variables.Variables(a#10#0#0) } 
  MapSpec.Variables.view(#MapSpec.Variables.Variables(a#10#0#0)) == a#10#0#0);

// Inductive map key rank
axiom (forall a#11#0#0: IMap Box Box, d: DatatypeType :: 
  { IMap#Domain(a#11#0#0)[$Box(d)], #MapSpec.Variables.Variables(a#11#0#0) } 
  IMap#Domain(a#11#0#0)[$Box(d)]
     ==> DtRank(d) < DtRank(#MapSpec.Variables.Variables(a#11#0#0)));

// Inductive map value rank
axiom (forall a#12#0#0: IMap Box Box, bx: Box :: 
  { IMap#Domain(a#12#0#0)[bx], #MapSpec.Variables.Variables(a#12#0#0) } 
  IMap#Domain(a#12#0#0)[bx]
     ==> DtRank($Unbox(IMap#Elements(a#12#0#0)[bx]): DatatypeType)
       < DtRank(#MapSpec.Variables.Variables(a#12#0#0)));

// Depth-one case-split function
function $IsA#MapSpec.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MapSpec.Variables(d) } 
  $IsA#MapSpec.Variables(d) ==> MapSpec.Variables.Variables_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MapSpec.Variables.Variables_q(d), $Is(d, Tclass.MapSpec.Variables()) } 
  $Is(d, Tclass.MapSpec.Variables()) ==> MapSpec.Variables.Variables_q(d));

// Datatype extensional equality declaration
function MapSpec.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MapSpec.Variables.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Variables#Equal(a, b) } 
  true
     ==> (MapSpec.Variables#Equal(a, b)
       <==> IMap#Equal(MapSpec.Variables.view(a), MapSpec.Variables.view(b))));

// Datatype extensionality axiom: MapSpec.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Variables#Equal(a, b) } 
  MapSpec.Variables#Equal(a, b) <==> a == b);

const unique class.MapSpec.Variables: ClassName;

// Constructor function declaration
function #MapSpec.Step.QueryStep(Seq Box, Seq Box) : DatatypeType;

const unique ##MapSpec.Step.QueryStep: DtCtorId;

// Constructor identifier
axiom (forall a#13#0#0: Seq Box, a#13#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(a#13#0#0, a#13#1#0) } 
  DatatypeCtorId(#MapSpec.Step.QueryStep(a#13#0#0, a#13#1#0))
     == ##MapSpec.Step.QueryStep);

function MapSpec.Step.QueryStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.QueryStep_q(d) } 
  MapSpec.Step.QueryStep_q(d) <==> DatatypeCtorId(d) == ##MapSpec.Step.QueryStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.QueryStep_q(d) } 
  MapSpec.Step.QueryStep_q(d)
     ==> (exists a#14#0#0: Seq Box, a#14#1#0: Seq Box :: 
      d == #MapSpec.Step.QueryStep(a#14#0#0, a#14#1#0)));

function Tclass.MapSpec.Step() : Ty;

// Tclass.MapSpec.Step Tag
axiom Tag(Tclass.MapSpec.Step()) == Tagclass.MapSpec.Step;

const unique Tagclass.MapSpec.Step: TyTag;

// Box/unbox axiom for Tclass.MapSpec.Step
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.Step()) } 
  $IsBox(bx, Tclass.MapSpec.Step())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MapSpec.Step()));

// Constructor $Is
axiom (forall a#15#0#0: Seq Box, a#15#1#0: Seq Box :: 
  { $Is(#MapSpec.Step.QueryStep(a#15#0#0, a#15#1#0), Tclass.MapSpec.Step()) } 
  $Is(#MapSpec.Step.QueryStep(a#15#0#0, a#15#1#0), Tclass.MapSpec.Step())
     <==> $Is(a#15#0#0, Tclass.KeyType.Key()) && $Is(a#15#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#16#0#0: Seq Box, a#16#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.QueryStep(a#16#0#0, a#16#1#0), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Step.QueryStep(a#16#0#0, a#16#1#0), Tclass.MapSpec.Step(), $h)
       <==> $IsAlloc(a#16#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#16#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.QueryStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.result(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.QueryStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.result(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#17#0#0: Seq Box, a#17#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(Lit(a#17#0#0), Lit(a#17#1#0)) } 
  #MapSpec.Step.QueryStep(Lit(a#17#0#0), Lit(a#17#1#0))
     == Lit(#MapSpec.Step.QueryStep(a#17#0#0, a#17#1#0)));

function MapSpec.Step.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#18#0#0: Seq Box, a#18#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(a#18#0#0, a#18#1#0) } 
  MapSpec.Step.key(#MapSpec.Step.QueryStep(a#18#0#0, a#18#1#0)) == a#18#0#0);

function MapSpec.Step.result(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#19#0#0: Seq Box, a#19#1#0: Seq Box :: 
  { #MapSpec.Step.QueryStep(a#19#0#0, a#19#1#0) } 
  MapSpec.Step.result(#MapSpec.Step.QueryStep(a#19#0#0, a#19#1#0)) == a#19#1#0);

// Constructor function declaration
function #MapSpec.Step.WriteStep(Seq Box, Seq Box) : DatatypeType;

const unique ##MapSpec.Step.WriteStep: DtCtorId;

// Constructor identifier
axiom (forall a#20#0#0: Seq Box, a#20#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(a#20#0#0, a#20#1#0) } 
  DatatypeCtorId(#MapSpec.Step.WriteStep(a#20#0#0, a#20#1#0))
     == ##MapSpec.Step.WriteStep);

function MapSpec.Step.WriteStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.WriteStep_q(d) } 
  MapSpec.Step.WriteStep_q(d) <==> DatatypeCtorId(d) == ##MapSpec.Step.WriteStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.WriteStep_q(d) } 
  MapSpec.Step.WriteStep_q(d)
     ==> (exists a#21#0#0: Seq Box, a#21#1#0: Seq Box :: 
      d == #MapSpec.Step.WriteStep(a#21#0#0, a#21#1#0)));

// Constructor $Is
axiom (forall a#22#0#0: Seq Box, a#22#1#0: Seq Box :: 
  { $Is(#MapSpec.Step.WriteStep(a#22#0#0, a#22#1#0), Tclass.MapSpec.Step()) } 
  $Is(#MapSpec.Step.WriteStep(a#22#0#0, a#22#1#0), Tclass.MapSpec.Step())
     <==> $Is(a#22#0#0, Tclass.KeyType.Key()) && $Is(a#22#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#23#0#0: Seq Box, a#23#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.WriteStep(a#23#0#0, a#23#1#0), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Step.WriteStep(a#23#0#0, a#23#1#0), Tclass.MapSpec.Step(), $h)
       <==> $IsAlloc(a#23#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#23#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.WriteStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.new__value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.WriteStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.new__value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#24#0#0: Seq Box, a#24#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(Lit(a#24#0#0), Lit(a#24#1#0)) } 
  #MapSpec.Step.WriteStep(Lit(a#24#0#0), Lit(a#24#1#0))
     == Lit(#MapSpec.Step.WriteStep(a#24#0#0, a#24#1#0)));

// Constructor injectivity
axiom (forall a#25#0#0: Seq Box, a#25#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(a#25#0#0, a#25#1#0) } 
  MapSpec.Step.key(#MapSpec.Step.WriteStep(a#25#0#0, a#25#1#0)) == a#25#0#0);

function MapSpec.Step.new__value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#26#0#0: Seq Box, a#26#1#0: Seq Box :: 
  { #MapSpec.Step.WriteStep(a#26#0#0, a#26#1#0) } 
  MapSpec.Step.new__value(#MapSpec.Step.WriteStep(a#26#0#0, a#26#1#0)) == a#26#1#0);

// Constructor function declaration
function #MapSpec.Step.SuccStep(DatatypeType, Seq Box, DatatypeType) : DatatypeType;

const unique ##MapSpec.Step.SuccStep: DtCtorId;

// Constructor identifier
axiom (forall a#27#0#0: DatatypeType, a#27#1#0: Seq Box, a#27#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#27#0#0, a#27#1#0, a#27#2#0) } 
  DatatypeCtorId(#MapSpec.Step.SuccStep(a#27#0#0, a#27#1#0, a#27#2#0))
     == ##MapSpec.Step.SuccStep);

function MapSpec.Step.SuccStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.SuccStep_q(d) } 
  MapSpec.Step.SuccStep_q(d) <==> DatatypeCtorId(d) == ##MapSpec.Step.SuccStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.SuccStep_q(d) } 
  MapSpec.Step.SuccStep_q(d)
     ==> (exists a#28#0#0: DatatypeType, a#28#1#0: Seq Box, a#28#2#0: DatatypeType :: 
      d == #MapSpec.Step.SuccStep(a#28#0#0, a#28#1#0, a#28#2#0)));

// Constructor $Is
axiom (forall a#29#0#0: DatatypeType, a#29#1#0: Seq Box, a#29#2#0: DatatypeType :: 
  { $Is(#MapSpec.Step.SuccStep(a#29#0#0, a#29#1#0, a#29#2#0), Tclass.MapSpec.Step()) } 
  $Is(#MapSpec.Step.SuccStep(a#29#0#0, a#29#1#0, a#29#2#0), Tclass.MapSpec.Step())
     <==> $Is(a#29#0#0, Tclass.UI.RangeStart())
       && $Is(a#29#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#29#2#0, Tclass.UI.RangeEnd()));

// Constructor $IsAlloc
axiom (forall a#30#0#0: DatatypeType, a#30#1#0: Seq Box, a#30#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.SuccStep(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MapSpec.Step.SuccStep(a#30#0#0, a#30#1#0, a#30#2#0), Tclass.MapSpec.Step(), $h)
       <==> $IsAlloc(a#30#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#30#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#30#2#0, Tclass.UI.RangeEnd(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.SuccStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.SuccStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MapSpec.Step.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      MapSpec.Step.SuccStep_q(d)
       && $IsAlloc(d, Tclass.MapSpec.Step(), $h)
     ==> $IsAlloc(MapSpec.Step.end(d), Tclass.UI.RangeEnd(), $h));

// Constructor literal
axiom (forall a#31#0#0: DatatypeType, a#31#1#0: Seq Box, a#31#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(Lit(a#31#0#0), Lit(a#31#1#0), Lit(a#31#2#0)) } 
  #MapSpec.Step.SuccStep(Lit(a#31#0#0), Lit(a#31#1#0), Lit(a#31#2#0))
     == Lit(#MapSpec.Step.SuccStep(a#31#0#0, a#31#1#0, a#31#2#0)));

function MapSpec.Step.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#32#0#0: DatatypeType, a#32#1#0: Seq Box, a#32#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#32#0#0, a#32#1#0, a#32#2#0) } 
  MapSpec.Step.start(#MapSpec.Step.SuccStep(a#32#0#0, a#32#1#0, a#32#2#0))
     == a#32#0#0);

// Inductive rank
axiom (forall a#33#0#0: DatatypeType, a#33#1#0: Seq Box, a#33#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#33#0#0, a#33#1#0, a#33#2#0) } 
  DtRank(a#33#0#0) < DtRank(#MapSpec.Step.SuccStep(a#33#0#0, a#33#1#0, a#33#2#0)));

function MapSpec.Step.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#34#0#0: DatatypeType, a#34#1#0: Seq Box, a#34#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#34#0#0, a#34#1#0, a#34#2#0) } 
  MapSpec.Step.results(#MapSpec.Step.SuccStep(a#34#0#0, a#34#1#0, a#34#2#0))
     == a#34#1#0);

// Inductive seq element rank
axiom (forall a#35#0#0: DatatypeType, a#35#1#0: Seq Box, a#35#2#0: DatatypeType, i: int :: 
  { Seq#Index(a#35#1#0, i), #MapSpec.Step.SuccStep(a#35#0#0, a#35#1#0, a#35#2#0) } 
  0 <= i && i < Seq#Length(a#35#1#0)
     ==> DtRank($Unbox(Seq#Index(a#35#1#0, i)): DatatypeType)
       < DtRank(#MapSpec.Step.SuccStep(a#35#0#0, a#35#1#0, a#35#2#0)));

// Inductive seq rank
axiom (forall a#36#0#0: DatatypeType, a#36#1#0: Seq Box, a#36#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#36#0#0, a#36#1#0, a#36#2#0) } 
  Seq#Rank(a#36#1#0)
     < DtRank(#MapSpec.Step.SuccStep(a#36#0#0, a#36#1#0, a#36#2#0)));

function MapSpec.Step.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#37#0#0: DatatypeType, a#37#1#0: Seq Box, a#37#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#37#0#0, a#37#1#0, a#37#2#0) } 
  MapSpec.Step.end(#MapSpec.Step.SuccStep(a#37#0#0, a#37#1#0, a#37#2#0))
     == a#37#2#0);

// Inductive rank
axiom (forall a#38#0#0: DatatypeType, a#38#1#0: Seq Box, a#38#2#0: DatatypeType :: 
  { #MapSpec.Step.SuccStep(a#38#0#0, a#38#1#0, a#38#2#0) } 
  DtRank(a#38#2#0) < DtRank(#MapSpec.Step.SuccStep(a#38#0#0, a#38#1#0, a#38#2#0)));

// Constructor function declaration
function #MapSpec.Step.StutterStep() : DatatypeType;

const unique ##MapSpec.Step.StutterStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#MapSpec.Step.StutterStep()) == ##MapSpec.Step.StutterStep;

function MapSpec.Step.StutterStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.StutterStep_q(d) } 
  MapSpec.Step.StutterStep_q(d)
     <==> DatatypeCtorId(d) == ##MapSpec.Step.StutterStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.StutterStep_q(d) } 
  MapSpec.Step.StutterStep_q(d) ==> d == #MapSpec.Step.StutterStep());

// Constructor $Is
axiom $Is(#MapSpec.Step.StutterStep(), Tclass.MapSpec.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#MapSpec.Step.StutterStep(), Tclass.MapSpec.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#MapSpec.Step.StutterStep(), Tclass.MapSpec.Step(), $h));

// Constructor literal
axiom #MapSpec.Step.StutterStep() == Lit(#MapSpec.Step.StutterStep());

// Depth-one case-split function
function $IsA#MapSpec.Step(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MapSpec.Step(d) } 
  $IsA#MapSpec.Step(d)
     ==> MapSpec.Step.QueryStep_q(d)
       || MapSpec.Step.WriteStep_q(d)
       || MapSpec.Step.SuccStep_q(d)
       || MapSpec.Step.StutterStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MapSpec.Step.StutterStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
    { MapSpec.Step.SuccStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
    { MapSpec.Step.WriteStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
    { MapSpec.Step.QueryStep_q(d), $Is(d, Tclass.MapSpec.Step()) } 
  $Is(d, Tclass.MapSpec.Step())
     ==> MapSpec.Step.QueryStep_q(d)
       || MapSpec.Step.WriteStep_q(d)
       || MapSpec.Step.SuccStep_q(d)
       || MapSpec.Step.StutterStep_q(d));

// Datatype extensional equality declaration
function MapSpec.Step#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MapSpec.Step.QueryStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.QueryStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.QueryStep_q(b) } 
  MapSpec.Step.QueryStep_q(a) && MapSpec.Step.QueryStep_q(b)
     ==> (MapSpec.Step#Equal(a, b)
       <==> Seq#Equal(MapSpec.Step.key(a), MapSpec.Step.key(b))
         && Seq#Equal(MapSpec.Step.result(a), MapSpec.Step.result(b))));

// Datatype extensional equality definition: #MapSpec.Step.WriteStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.WriteStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.WriteStep_q(b) } 
  MapSpec.Step.WriteStep_q(a) && MapSpec.Step.WriteStep_q(b)
     ==> (MapSpec.Step#Equal(a, b)
       <==> Seq#Equal(MapSpec.Step.key(a), MapSpec.Step.key(b))
         && Seq#Equal(MapSpec.Step.new__value(a), MapSpec.Step.new__value(b))));

// Datatype extensional equality definition: #MapSpec.Step.SuccStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.SuccStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.SuccStep_q(b) } 
  MapSpec.Step.SuccStep_q(a) && MapSpec.Step.SuccStep_q(b)
     ==> (MapSpec.Step#Equal(a, b)
       <==> UI.RangeStart#Equal(MapSpec.Step.start(a), MapSpec.Step.start(b))
         && Seq#Equal(MapSpec.Step.results(a), MapSpec.Step.results(b))
         && UI.RangeEnd#Equal(MapSpec.Step.end(a), MapSpec.Step.end(b))));

// Datatype extensional equality definition: #MapSpec.Step.StutterStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b), MapSpec.Step.StutterStep_q(a) } 
    { MapSpec.Step#Equal(a, b), MapSpec.Step.StutterStep_q(b) } 
  MapSpec.Step.StutterStep_q(a) && MapSpec.Step.StutterStep_q(b)
     ==> (MapSpec.Step#Equal(a, b) <==> true));

// Datatype extensionality axiom: MapSpec.Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MapSpec.Step#Equal(a, b) } 
  MapSpec.Step#Equal(a, b) <==> a == b);

const unique class.MapSpec.Step: ClassName;

const unique class.MapSpec.__default: ClassName;

function Tclass.MapSpec.__default() : Ty;

// Tclass.MapSpec.__default Tag
axiom Tag(Tclass.MapSpec.__default()) == Tagclass.MapSpec.__default;

const unique Tagclass.MapSpec.__default: TyTag;

// Box/unbox axiom for Tclass.MapSpec.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MapSpec.__default()) } 
  $IsBox(bx, Tclass.MapSpec.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.MapSpec.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.MapSpec.__default()) } 
  $Is($o, Tclass.MapSpec.__default())
     <==> $o == null || dtype($o) == Tclass.MapSpec.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MapSpec.__default(), $h) } 
  $IsAlloc($o, Tclass.MapSpec.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for MapSpec._default.EmptyValue
function MapSpec.__default.EmptyValue() : Seq Box;

function MapSpec.__default.EmptyValue#canCall() : bool;

// consequence axiom for MapSpec.__default.EmptyValue
axiom true ==> true ==> $Is(MapSpec.__default.EmptyValue(), Tclass.ValueType.Value());

function MapSpec.__default.EmptyValue#requires() : bool;

// #requires axiom for MapSpec.__default.EmptyValue
axiom MapSpec.__default.EmptyValue#requires() == true;

// definition axiom for MapSpec.__default.EmptyValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && MapSpec.__default.EmptyValue() == Lit(ValueType.__default.DefaultValue());

// definition axiom for MapSpec.__default.EmptyValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && MapSpec.__default.EmptyValue() == Lit(ValueType.__default.DefaultValue());

// function declaration for MapSpec._default.ViewComplete
function MapSpec.__default.ViewComplete(view#0: IMap Box Box) : bool;

function MapSpec.__default.ViewComplete#canCall(view#0: IMap Box Box) : bool;

// consequence axiom for MapSpec.__default.ViewComplete
axiom true
   ==> (forall view#0: IMap Box Box :: 
    { MapSpec.__default.ViewComplete(view#0) } 
    MapSpec.__default.ViewComplete#canCall(view#0)
         || $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> true);

function MapSpec.__default.ViewComplete#requires(IMap Box Box) : bool;

// #requires axiom for MapSpec.__default.ViewComplete
axiom (forall view#0: IMap Box Box :: 
  { MapSpec.__default.ViewComplete#requires(view#0) } 
  $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
     ==> MapSpec.__default.ViewComplete#requires(view#0) == true);

// definition axiom for MapSpec.__default.ViewComplete(revealed)
axiom true
   ==> (forall view#0: IMap Box Box :: 
    { MapSpec.__default.ViewComplete(view#0) } 
    MapSpec.__default.ViewComplete#canCall(view#0)
         || $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> MapSpec.__default.ViewComplete(view#0)
         == (forall k#0: Seq Box :: 
          { IMap#Domain(view#0)[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key()) ==> IMap#Domain(view#0)[$Box(k#0)]));

// definition axiom for MapSpec.__default.ViewComplete for all literals(revealed)
axiom true
   ==> (forall view#0: IMap Box Box :: 
    {:weight 3} { MapSpec.__default.ViewComplete(Lit(view#0)) } 
    MapSpec.__default.ViewComplete#canCall(Lit(view#0))
         || $Is(view#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> MapSpec.__default.ViewComplete(Lit(view#0))
         == (forall k#1: Seq Box :: 
          { IMap#Domain(view#0)[$Box(k#1)] } 
          $Is(k#1, Tclass.KeyType.Key()) ==> IMap#Domain(view#0)[$Box(k#1)]));

// function declaration for MapSpec._default.WF
function MapSpec.__default.WF(s#0: DatatypeType) : bool;

function MapSpec.__default.WF#canCall(s#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.WF
axiom true
   ==> (forall s#0: DatatypeType :: 
    { MapSpec.__default.WF(s#0) } 
    MapSpec.__default.WF#canCall(s#0) || $Is(s#0, Tclass.MapSpec.Variables())
       ==> true);

function MapSpec.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for MapSpec.__default.WF
axiom (forall s#0: DatatypeType :: 
  { MapSpec.__default.WF#requires(s#0) } 
  $Is(s#0, Tclass.MapSpec.Variables())
     ==> MapSpec.__default.WF#requires(s#0) == true);

// definition axiom for MapSpec.__default.WF(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    { MapSpec.__default.WF(s#0) } 
    MapSpec.__default.WF#canCall(s#0) || $Is(s#0, Tclass.MapSpec.Variables())
       ==> (Lit(true)
           ==> MapSpec.Variables.Variables_q(s#0)
             && MapSpec.__default.ViewComplete#canCall(MapSpec.Variables.view(s#0)))
         && MapSpec.__default.WF(s#0)
           == (true && MapSpec.__default.ViewComplete(MapSpec.Variables.view(s#0))));

// definition axiom for MapSpec.__default.WF for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.WF(Lit(s#0)) } 
    MapSpec.__default.WF#canCall(Lit(s#0)) || $Is(s#0, Tclass.MapSpec.Variables())
       ==> (Lit(true)
           ==> MapSpec.Variables.Variables_q(Lit(s#0))
             && MapSpec.__default.ViewComplete#canCall(Lit(MapSpec.Variables.view(Lit(s#0)))))
         && MapSpec.__default.WF(Lit(s#0))
           == Lit(true && MapSpec.__default.ViewComplete(Lit(MapSpec.Variables.view(Lit(s#0))))));

// function declaration for MapSpec._default.InDomain
function MapSpec.__default.InDomain(k#0: Seq Box) : bool;

function MapSpec.__default.InDomain#canCall(k#0: Seq Box) : bool;

// consequence axiom for MapSpec.__default.InDomain
axiom true
   ==> (forall k#0: Seq Box :: 
    { MapSpec.__default.InDomain(k#0) } 
    MapSpec.__default.InDomain#canCall(k#0) || $Is(k#0, Tclass.KeyType.Key())
       ==> true);

function MapSpec.__default.InDomain#requires(Seq Box) : bool;

// #requires axiom for MapSpec.__default.InDomain
axiom (forall k#0: Seq Box :: 
  { MapSpec.__default.InDomain#requires(k#0) } 
  $Is(k#0, Tclass.KeyType.Key())
     ==> MapSpec.__default.InDomain#requires(k#0) == true);

// definition axiom for MapSpec.__default.InDomain(revealed)
axiom true
   ==> (forall k#0: Seq Box :: 
    { MapSpec.__default.InDomain(k#0) } 
    MapSpec.__default.InDomain#canCall(k#0) || $Is(k#0, Tclass.KeyType.Key())
       ==> MapSpec.__default.InDomain(k#0) == Lit(true));

// definition axiom for MapSpec.__default.InDomain for all literals(revealed)
axiom true
   ==> (forall k#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.InDomain(Lit(k#0)) } 
    MapSpec.__default.InDomain#canCall(Lit(k#0)) || $Is(k#0, Tclass.KeyType.Key())
       ==> MapSpec.__default.InDomain(Lit(k#0)) == Lit(true));

// function declaration for MapSpec._default.EmptyMap
function MapSpec.__default.EmptyMap() : IMap Box Box;

function MapSpec.__default.EmptyMap#canCall() : bool;

// consequence axiom for MapSpec.__default.EmptyMap
axiom true
   ==> 
  true
   ==> MapSpec.__default.ViewComplete(MapSpec.__default.EmptyMap())
     && $Is(MapSpec.__default.EmptyMap(), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()));

function MapSpec.__default.EmptyMap#requires() : bool;

// #requires axiom for MapSpec.__default.EmptyMap
axiom MapSpec.__default.EmptyMap#requires() == true;

// definition axiom for MapSpec.__default.EmptyMap(revealed)
axiom true
   ==> 
  true
   ==> (forall k#0: Seq Box :: 
      { MapSpec.__default.InDomain(k#0) } 
      $Is(k#0, Tclass.KeyType.Key())
         ==> MapSpec.__default.InDomain#canCall(k#0)
           && (MapSpec.__default.InDomain(k#0) ==> MapSpec.__default.EmptyValue#canCall()))
     && MapSpec.__default.EmptyMap()
       == IMap#Glue((lambda $w#0: Box :: 
          $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
             && MapSpec.__default.InDomain($Unbox($w#0): Seq Box)), 
        (lambda $w#0: Box :: $Box(Lit(MapSpec.__default.EmptyValue()))), 
        TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()));

// definition axiom for MapSpec.__default.EmptyMap for all literals(revealed)
axiom true
   ==> 
  true
   ==> (forall k#0: Seq Box :: 
      { MapSpec.__default.InDomain(k#0) } 
      $Is(k#0, Tclass.KeyType.Key())
         ==> MapSpec.__default.InDomain#canCall(k#0)
           && (MapSpec.__default.InDomain(k#0) ==> MapSpec.__default.EmptyValue#canCall()))
     && MapSpec.__default.EmptyMap()
       == IMap#Glue((lambda $w#1: Box :: 
          $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
             && MapSpec.__default.InDomain($Unbox($w#1): Seq Box)), 
        (lambda $w#1: Box :: $Box(Lit(MapSpec.__default.EmptyValue()))), 
        TIMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()));

// function declaration for MapSpec._default.Init
function MapSpec.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function MapSpec.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Init(k#0, s#0) } 
    MapSpec.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> 
      MapSpec.__default.Init(k#0, s#0)
       ==> MapSpec.__default.WF(s#0));

function MapSpec.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { MapSpec.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables())
     ==> MapSpec.__default.Init#requires(k#0, s#0) == true);

// definition axiom for MapSpec.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Init(k#0, s#0) } 
    MapSpec.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> $IsA#MapSpec.Variables(s#0)
         && MapSpec.__default.EmptyMap#canCall()
         && MapSpec.__default.Init(k#0, s#0)
           == MapSpec.Variables#Equal(s#0, #MapSpec.Variables.Variables(Lit(MapSpec.__default.EmptyMap()))));

// definition axiom for MapSpec.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Init(Lit(k#0), Lit(s#0)) } 
    MapSpec.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> $IsA#MapSpec.Variables(Lit(s#0))
         && MapSpec.__default.EmptyMap#canCall()
         && MapSpec.__default.Init(Lit(k#0), Lit(s#0))
           == MapSpec.Variables#Equal(s#0, #MapSpec.Variables.Variables(Lit(MapSpec.__default.EmptyMap()))));

// function declaration for MapSpec._default.Query
function MapSpec.__default.Query(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    result#0: Seq Box)
   : bool;

function MapSpec.__default.Query#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    result#0: Seq Box)
   : bool;

// consequence axiom for MapSpec.__default.Query
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    { MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#0, result#0) } 
    MapSpec.__default.Query#canCall(k#0, s#0, s'#0, uiop#0, key#0, result#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> true);

function MapSpec.__default.Query#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for MapSpec.__default.Query
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    result#0: Seq Box :: 
  { MapSpec.__default.Query#requires(k#0, s#0, s'#0, uiop#0, key#0, result#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(result#0, Tclass.ValueType.Value())
     ==> MapSpec.__default.Query#requires(k#0, s#0, s'#0, uiop#0, key#0, result#0)
       == true);

// definition axiom for MapSpec.__default.Query(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    { MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#0, result#0) } 
    MapSpec.__default.Query#canCall(k#0, s#0, s'#0, uiop#0, key#0, result#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(uiop#0)
         && (UI.Op#Equal(uiop#0, #UI.Op.GetOp(key#0, result#0))
           ==> MapSpec.__default.WF#canCall(s#0))
         && (MapSpec.__default.WF#canCall(s#0) && MapSpec.__default.WF(s#0)
           ==> MapSpec.Variables.Variables_q(s#0))
         && (MapSpec.Variables.Variables_q(s#0)
             && result#0
               == $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box
           ==> $IsA#MapSpec.Variables(s'#0) && $IsA#MapSpec.Variables(s#0))
         && MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#0, result#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.GetOp(key#0, result#0))
             && MapSpec.__default.WF(s#0)
             && result#0
               == $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box
             && MapSpec.Variables#Equal(s'#0, s#0)));

// definition axiom for MapSpec.__default.Query for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), result#0) } 
    MapSpec.__default.Query#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), result#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), result#0))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s#0)))
         && (MapSpec.Variables.Variables_q(Lit(s#0))
             && result#0
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), result#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), result#0))
             && MapSpec.__default.WF(Lit(s#0))
             && result#0
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
             && MapSpec.Variables#Equal(s'#0, s#0)));

// definition axiom for MapSpec.__default.Query for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      result#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(result#0)) } 
    MapSpec.__default.Query#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(result#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(result#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), Lit(result#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s#0)))
         && (MapSpec.Variables.Variables_q(Lit(s#0))
             && Lit(result#0)
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(result#0))
           == (
            UI.Op#Equal(uiop#0, #UI.Op.GetOp(Lit(key#0), Lit(result#0)))
             && MapSpec.__default.WF(Lit(s#0))
             && Lit(result#0)
               == $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(Lit(key#0))]): Seq Box
             && MapSpec.Variables#Equal(s'#0, s#0)));

// function declaration for MapSpec._default.LowerBound
function MapSpec.__default.LowerBound(start#0: DatatypeType, key#0: Seq Box) : bool;

function MapSpec.__default.LowerBound#canCall(start#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for MapSpec.__default.LowerBound
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box :: 
    { MapSpec.__default.LowerBound(start#0, key#0) } 
    MapSpec.__default.LowerBound#canCall(start#0, key#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> true);

function MapSpec.__default.LowerBound#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for MapSpec.__default.LowerBound
axiom (forall start#0: DatatypeType, key#0: Seq Box :: 
  { MapSpec.__default.LowerBound#requires(start#0, key#0) } 
  $Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key())
     ==> MapSpec.__default.LowerBound#requires(start#0, key#0) == true);

// definition axiom for MapSpec.__default.LowerBound(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box :: 
    { MapSpec.__default.LowerBound(start#0, key#0) } 
    MapSpec.__default.LowerBound#canCall(start#0, key#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (UI.RangeStart.SInclusive_q(start#0)
           ==> SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), key#0))
         && (SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), key#0)
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, UI.RangeStart.key(start#0), key#0)
           ==> 
          UI.RangeStart.SExclusive_q(start#0)
           ==> SeqComparison.__default.lt#canCall(UI.RangeStart.key(start#0), key#0))
         && MapSpec.__default.LowerBound(start#0, key#0)
           == ((UI.RangeStart.SInclusive_q(start#0)
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, UI.RangeStart.key(start#0), key#0))
             && (UI.RangeStart.SExclusive_q(start#0)
               ==> SeqComparison.__default.lt(UI.RangeStart.key(start#0), key#0))));

// definition axiom for MapSpec.__default.LowerBound for all literals(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0)) } 
    MapSpec.__default.LowerBound#canCall(Lit(start#0), Lit(key#0))
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Lit(UI.RangeStart.SInclusive_q(Lit(start#0)))
           ==> SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0)))
         && (SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              Lit(UI.RangeStart.key(Lit(start#0))), 
              Lit(key#0))
           ==> 
          Lit(UI.RangeStart.SExclusive_q(Lit(start#0)))
           ==> SeqComparison.__default.lt#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0)))
         && MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0))
           == ((UI.RangeStart.SInclusive_q(Lit(start#0))
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                Lit(UI.RangeStart.key(Lit(start#0))), 
                Lit(key#0)))
             && (UI.RangeStart.SExclusive_q(Lit(start#0))
               ==> SeqComparison.__default.lt(Lit(UI.RangeStart.key(Lit(start#0))), Lit(key#0)))));

// function declaration for MapSpec._default.UpperBound
function MapSpec.__default.UpperBound(key#0: Seq Box, end#0: DatatypeType) : bool;

function MapSpec.__default.UpperBound#canCall(key#0: Seq Box, end#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.UpperBound
axiom true
   ==> (forall key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.UpperBound(key#0, end#0) } 
    MapSpec.__default.UpperBound#canCall(key#0, end#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.UpperBound#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.UpperBound
axiom (forall key#0: Seq Box, end#0: DatatypeType :: 
  { MapSpec.__default.UpperBound#requires(key#0, end#0) } 
  $Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.UpperBound#requires(key#0, end#0) == true);

// definition axiom for MapSpec.__default.UpperBound(revealed)
axiom true
   ==> (forall key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.UpperBound(key#0, end#0) } 
    MapSpec.__default.UpperBound#canCall(key#0, end#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (UI.RangeEnd.EInclusive_q(end#0)
           ==> SeqComparison.__default.lte#canCall(key#0, UI.RangeEnd.key(end#0)))
         && (SeqComparison.__default.lte#canCall(key#0, UI.RangeEnd.key(end#0))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, key#0, UI.RangeEnd.key(end#0))
           ==> 
          UI.RangeEnd.EExclusive_q(end#0)
           ==> SeqComparison.__default.lt#canCall(key#0, UI.RangeEnd.key(end#0)))
         && MapSpec.__default.UpperBound(key#0, end#0)
           == ((UI.RangeEnd.EInclusive_q(end#0)
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, key#0, UI.RangeEnd.key(end#0)))
             && (UI.RangeEnd.EExclusive_q(end#0)
               ==> SeqComparison.__default.lt(key#0, UI.RangeEnd.key(end#0)))));

// definition axiom for MapSpec.__default.UpperBound for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box, end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.UpperBound(Lit(key#0), Lit(end#0)) } 
    MapSpec.__default.UpperBound#canCall(Lit(key#0), Lit(end#0))
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (Lit(UI.RangeEnd.EInclusive_q(Lit(end#0)))
           ==> SeqComparison.__default.lte#canCall(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && (SeqComparison.__default.lte#canCall(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0))))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              Lit(key#0), 
              Lit(UI.RangeEnd.key(Lit(end#0))))
           ==> 
          Lit(UI.RangeEnd.EExclusive_q(Lit(end#0)))
           ==> SeqComparison.__default.lt#canCall(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && MapSpec.__default.UpperBound(Lit(key#0), Lit(end#0))
           == ((UI.RangeEnd.EInclusive_q(Lit(end#0))
               ==> SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                Lit(key#0), 
                Lit(UI.RangeEnd.key(Lit(end#0)))))
             && (UI.RangeEnd.EExclusive_q(Lit(end#0))
               ==> SeqComparison.__default.lt(Lit(key#0), Lit(UI.RangeEnd.key(Lit(end#0)))))));

// function declaration for MapSpec._default.InRange
function MapSpec.__default.InRange(start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType) : bool;

function MapSpec.__default.InRange#canCall(start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.InRange
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.InRange(start#0, key#0, end#0) } 
    MapSpec.__default.InRange#canCall(start#0, key#0, end#0)
         || (
          $Is(start#0, Tclass.UI.RangeStart())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.InRange#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.InRange
axiom (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
  { MapSpec.__default.InRange#requires(start#0, key#0, end#0) } 
  $Is(start#0, Tclass.UI.RangeStart())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.InRange#requires(start#0, key#0, end#0) == true);

// definition axiom for MapSpec.__default.InRange(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
    { MapSpec.__default.InRange(start#0, key#0, end#0) } 
    MapSpec.__default.InRange#canCall(start#0, key#0, end#0)
         || (
          $Is(start#0, Tclass.UI.RangeStart())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> MapSpec.__default.LowerBound#canCall(start#0, key#0)
         && (MapSpec.__default.LowerBound(start#0, key#0)
           ==> MapSpec.__default.UpperBound#canCall(key#0, end#0))
         && MapSpec.__default.InRange(start#0, key#0, end#0)
           == (MapSpec.__default.LowerBound(start#0, key#0)
             && MapSpec.__default.UpperBound(key#0, end#0)));

// definition axiom for MapSpec.__default.InRange for all literals(revealed)
axiom true
   ==> (forall start#0: DatatypeType, key#0: Seq Box, end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.InRange(Lit(start#0), Lit(key#0), Lit(end#0)) } 
    MapSpec.__default.InRange#canCall(Lit(start#0), Lit(key#0), Lit(end#0))
         || (
          $Is(start#0, Tclass.UI.RangeStart())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> MapSpec.__default.LowerBound#canCall(Lit(start#0), Lit(key#0))
         && (Lit(MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0)))
           ==> MapSpec.__default.UpperBound#canCall(Lit(key#0), Lit(end#0)))
         && MapSpec.__default.InRange(Lit(start#0), Lit(key#0), Lit(end#0))
           == Lit(MapSpec.__default.LowerBound(Lit(start#0), Lit(key#0))
               && MapSpec.__default.UpperBound(Lit(key#0), Lit(end#0))));

// function declaration for MapSpec._default.NonEmptyRange
function MapSpec.__default.NonEmptyRange(start#0: DatatypeType, end#0: DatatypeType) : bool;

function MapSpec.__default.NonEmptyRange#canCall(start#0: DatatypeType, end#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.NonEmptyRange
axiom true
   ==> (forall start#0: DatatypeType, end#0: DatatypeType :: 
    { MapSpec.__default.NonEmptyRange(start#0, end#0) } 
    MapSpec.__default.NonEmptyRange#canCall(start#0, end#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.NonEmptyRange#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.NonEmptyRange
axiom (forall start#0: DatatypeType, end#0: DatatypeType :: 
  { MapSpec.__default.NonEmptyRange#requires(start#0, end#0) } 
  $Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.NonEmptyRange#requires(start#0, end#0) == true);

// definition axiom for MapSpec.__default.NonEmptyRange(revealed)
axiom true
   ==> (forall start#0: DatatypeType, end#0: DatatypeType :: 
    { MapSpec.__default.NonEmptyRange(start#0, end#0) } 
    MapSpec.__default.NonEmptyRange#canCall(start#0, end#0)
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (!UI.RangeEnd.PositiveInf_q(end#0)
           ==> 
          UI.RangeEnd.EInclusive_q(end#0)
           ==> SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0)))
         && ((UI.RangeEnd.EInclusive_q(end#0)
               ==> SeqComparison.__default.lte#canCall(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0)))
             && !
            (
            UI.RangeStart.SInclusive_q(start#0)
             && UI.RangeEnd.EInclusive_q(end#0)
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              UI.RangeStart.key(start#0), 
              UI.RangeEnd.key(end#0)))
           ==> SeqComparison.__default.lt#canCall(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0)))
         && MapSpec.__default.NonEmptyRange(start#0, end#0)
           == (
            UI.RangeStart.NegativeInf_q(start#0)
             || UI.RangeEnd.PositiveInf_q(end#0)
             || (
              UI.RangeStart.SInclusive_q(start#0)
               && UI.RangeEnd.EInclusive_q(end#0)
               && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                UI.RangeStart.key(start#0), 
                UI.RangeEnd.key(end#0)))
             || SeqComparison.__default.lt(UI.RangeStart.key(start#0), UI.RangeEnd.key(end#0))));

// definition axiom for MapSpec.__default.NonEmptyRange for all literals(revealed)
axiom true
   ==> (forall start#0: DatatypeType, end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0)) } 
    MapSpec.__default.NonEmptyRange#canCall(Lit(start#0), Lit(end#0))
         || ($Is(start#0, Tclass.UI.RangeStart()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (!Lit(UI.RangeEnd.PositiveInf_q(Lit(end#0)))
           ==> 
          Lit(UI.RangeEnd.EInclusive_q(Lit(end#0)))
           ==> SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && ((Lit(UI.RangeEnd.EInclusive_q(Lit(end#0)))
               ==> SeqComparison.__default.lte#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0)))))
             && !
            (
            UI.RangeStart.SInclusive_q(Lit(start#0))
             && UI.RangeEnd.EInclusive_q(Lit(end#0))
             && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
              Lit(UI.RangeStart.key(Lit(start#0))), 
              Lit(UI.RangeEnd.key(Lit(end#0)))))
           ==> SeqComparison.__default.lt#canCall(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0)))))
         && MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0))
           == (
            UI.RangeStart.NegativeInf_q(Lit(start#0))
             || UI.RangeEnd.PositiveInf_q(Lit(end#0))
             || (
              UI.RangeStart.SInclusive_q(Lit(start#0))
               && UI.RangeEnd.EInclusive_q(Lit(end#0))
               && SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, 
                Lit(UI.RangeStart.key(Lit(start#0))), 
                Lit(UI.RangeEnd.key(Lit(end#0)))))
             || SeqComparison.__default.lt(Lit(UI.RangeStart.key(Lit(start#0))), Lit(UI.RangeEnd.key(Lit(end#0))))));

// function declaration for MapSpec._default.Succ
function MapSpec.__default.Succ(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    start#0: DatatypeType, 
    results#0: Seq Box, 
    end#0: DatatypeType)
   : bool;

function MapSpec.__default.Succ#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    start#0: DatatypeType, 
    results#0: Seq Box, 
    end#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.Succ
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      start#0: DatatypeType, 
      results#0: Seq Box, 
      end#0: DatatypeType :: 
    { MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0) } 
    MapSpec.__default.Succ#canCall(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> true);

function MapSpec.__default.Succ#requires(DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    Seq Box, 
    DatatypeType)
   : bool;

// #requires axiom for MapSpec.__default.Succ
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    start#0: DatatypeType, 
    results#0: Seq Box, 
    end#0: DatatypeType :: 
  { MapSpec.__default.Succ#requires(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(start#0, Tclass.UI.RangeStart())
       && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(end#0, Tclass.UI.RangeEnd())
     ==> MapSpec.__default.Succ#requires(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
       == true);

// definition axiom for MapSpec.__default.Succ(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      start#0: DatatypeType, 
      results#0: Seq Box, 
      end#0: DatatypeType :: 
    { MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0) } 
    MapSpec.__default.Succ#canCall(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> $IsA#UI.Op(uiop#0)
         && (UI.Op#Equal(uiop#0, #UI.Op.SuccOp(start#0, results#0, end#0))
           ==> MapSpec.__default.WF#canCall(s#0))
         && (MapSpec.__default.WF#canCall(s#0) && MapSpec.__default.WF(s#0)
           ==> $IsA#MapSpec.Variables(s'#0) && $IsA#MapSpec.Variables(s#0))
         && ($IsA#MapSpec.Variables(s'#0)
             && $IsA#MapSpec.Variables(s#0)
             && MapSpec.Variables#Equal(s'#0, s#0)
           ==> MapSpec.__default.NonEmptyRange#canCall(start#0, end#0))
         && (MapSpec.__default.NonEmptyRange#canCall(start#0, end#0)
             && MapSpec.__default.NonEmptyRange(start#0, end#0)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(results#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(results#0)
               ==> MapSpec.Variables.Variables_q(s#0)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#0)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#0)): DatatypeType)))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(results#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(results#0)
                 ==> MapSpec.Variables.Variables_q(s#0)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#0)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#0)): DatatypeType))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(results#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(results#0)
                 ==> $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#0)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(results#0, i#0)): DatatypeType))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(results#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(results#0)
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#1)): DatatypeType)
                 && MapSpec.__default.EmptyValue#canCall()))
         && ((forall i#1: int :: 
              { $Unbox(Seq#Index(results#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(results#0)
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#1)): DatatypeType)
                   && MapSpec.__default.EmptyValue#canCall())
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(results#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(results#0)
                 ==> UI.SuccResult.value($Unbox(Seq#Index(results#0, i#1)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(results#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(results#0)
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#2)): DatatypeType)
                 && MapSpec.__default.InRange#canCall(start#0, 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, i#2)): DatatypeType), 
                  end#0)))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(results#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(results#0)
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#2)): DatatypeType)
                   && MapSpec.__default.InRange#canCall(start#0, 
                    UI.SuccResult.key($Unbox(Seq#Index(results#0, i#2)): DatatypeType), 
                    end#0))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(results#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(results#0)
                 ==> MapSpec.__default.InRange(start#0, 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, i#2)): DatatypeType), 
                  end#0))
           ==> (forall i#3: int, j#0: int :: 
            { $Unbox(Seq#Index(results#0, j#0)): DatatypeType, $Unbox(Seq#Index(results#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < j#0 && j#0 < Seq#Length(results#0)
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#3)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, j#0)): DatatypeType)
                 && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#3)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, j#0)): DatatypeType))))
         && ((forall i#3: int, j#0: int :: 
              { $Unbox(Seq#Index(results#0, j#0)): DatatypeType, $Unbox(Seq#Index(results#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < j#0 && j#0 < Seq#Length(results#0)
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#3)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, j#0)): DatatypeType)
                   && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#3)): DatatypeType), 
                    UI.SuccResult.key($Unbox(Seq#Index(results#0, j#0)): DatatypeType)))
             && (forall i#3: int, j#0: int :: 
              { $Unbox(Seq#Index(results#0, j#0)): DatatypeType, $Unbox(Seq#Index(results#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < j#0 && j#0 < Seq#Length(results#0)
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#3)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, j#0)): DatatypeType)))
           ==> (forall key#0: Seq Box :: 
            { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box } 
              { MapSpec.__default.InRange(start#0, key#0, end#0) } 
            $Is(key#0, Tclass.KeyType.Key())
               ==> MapSpec.__default.InRange#canCall(start#0, key#0, end#0)
                 && (MapSpec.__default.InRange(start#0, key#0, end#0)
                   ==> MapSpec.Variables.Variables_q(s#0) && MapSpec.__default.EmptyValue#canCall())
                 && (MapSpec.__default.InRange(start#0, key#0, end#0)
                     && $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box
                       != MapSpec.__default.EmptyValue()
                   ==> (forall i#4: int :: 
                    { $Unbox(Seq#Index(results#0, i#4)): DatatypeType } 
                    i#4 < Seq#Length(results#0)
                       ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(results#0, i#4)): DatatypeType)))))
         && MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.SuccOp(start#0, results#0, end#0))
             && MapSpec.__default.WF(s#0)
             && MapSpec.Variables#Equal(s'#0, s#0)
             && MapSpec.__default.NonEmptyRange(start#0, end#0)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(results#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(results#0)
                 ==> $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#0)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(results#0, i#0)): DatatypeType))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(results#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(results#0)
                 ==> UI.SuccResult.value($Unbox(Seq#Index(results#0, i#1)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(results#0, i#2)): DatatypeType } 
              LitInt(0) <= i#2 && i#2 < Seq#Length(results#0)
                 ==> MapSpec.__default.InRange(start#0, 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, i#2)): DatatypeType), 
                  end#0))
             && (forall i#3: int, j#0: int :: 
              { $Unbox(Seq#Index(results#0, j#0)): DatatypeType, $Unbox(Seq#Index(results#0, i#3)): DatatypeType } 
              LitInt(0) <= i#3 && i#3 < j#0 && j#0 < Seq#Length(results#0)
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#3)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(results#0, j#0)): DatatypeType)))
             && (forall key#0: Seq Box :: 
              { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box } 
                { MapSpec.__default.InRange(start#0, key#0, end#0) } 
              $Is(key#0, Tclass.KeyType.Key())
                   && 
                  MapSpec.__default.InRange(start#0, key#0, end#0)
                   && $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#0)]): Seq Box
                     != MapSpec.__default.EmptyValue()
                 ==> (exists i#4: int :: 
                  { $Unbox(Seq#Index(results#0, i#4)): DatatypeType } 
                  LitInt(0) <= i#4
                     && i#4 < Seq#Length(results#0)
                     && Seq#Equal(UI.SuccResult.key($Unbox(Seq#Index(results#0, i#4)): DatatypeType), key#0)))));

// definition axiom for MapSpec.__default.Succ for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      start#0: DatatypeType, 
      results#0: Seq Box, 
      end#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Succ(Lit(k#0), 
        Lit(s#0), 
        Lit(s'#0), 
        Lit(uiop#0), 
        Lit(start#0), 
        Lit(results#0), 
        Lit(end#0)) } 
    MapSpec.__default.Succ#canCall(Lit(k#0), 
          Lit(s#0), 
          Lit(s'#0), 
          Lit(uiop#0), 
          Lit(start#0), 
          Lit(results#0), 
          Lit(end#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(results#0, TSeq(Tclass.UI.SuccResult()))
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.SuccOp(Lit(start#0), Lit(results#0), Lit(end#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && ($IsA#MapSpec.Variables(Lit(s'#0))
             && $IsA#MapSpec.Variables(Lit(s#0))
             && MapSpec.Variables#Equal(s'#0, s#0)
           ==> MapSpec.__default.NonEmptyRange#canCall(Lit(start#0), Lit(end#0)))
         && (MapSpec.__default.NonEmptyRange#canCall(Lit(start#0), Lit(end#0))
             && Lit(MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0)))
           ==> (forall i#5: int :: 
            { $Unbox(Seq#Index(results#0, i#5)): DatatypeType } 
            LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(results#0))
               ==> MapSpec.Variables.Variables_q(Lit(s#0))
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType)))
         && ((forall i#5: int :: 
              { $Unbox(Seq#Index(results#0, i#5)): DatatypeType } 
              LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(results#0))
                 ==> MapSpec.Variables.Variables_q(Lit(s#0))
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType))
             && (forall i#5: int :: 
              { $Unbox(Seq#Index(results#0, i#5)): DatatypeType } 
              LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(results#0))
                 ==> $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType))
           ==> (forall i#6: int :: 
            { $Unbox(Seq#Index(results#0, i#6)): DatatypeType } 
            LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(results#0))
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#6)): DatatypeType)
                 && MapSpec.__default.EmptyValue#canCall()))
         && ((forall i#6: int :: 
              { $Unbox(Seq#Index(results#0, i#6)): DatatypeType } 
              LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#6)): DatatypeType)
                   && MapSpec.__default.EmptyValue#canCall())
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(results#0, i#6)): DatatypeType } 
              LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#6)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
           ==> (forall i#7: int :: 
            { $Unbox(Seq#Index(results#0, i#7)): DatatypeType } 
            LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(results#0))
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#7)): DatatypeType)
                 && MapSpec.__default.InRange#canCall(Lit(start#0), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#7)): DatatypeType), 
                  Lit(end#0))))
         && ((forall i#7: int :: 
              { $Unbox(Seq#Index(results#0, i#7)): DatatypeType } 
              LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#7)): DatatypeType)
                   && MapSpec.__default.InRange#canCall(Lit(start#0), 
                    UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#7)): DatatypeType), 
                    Lit(end#0)))
             && (forall i#7: int :: 
              { $Unbox(Seq#Index(results#0, i#7)): DatatypeType } 
              LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(results#0))
                 ==> MapSpec.__default.InRange(Lit(start#0), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#7)): DatatypeType), 
                  Lit(end#0)))
           ==> (forall i#8: int, j#1: int :: 
            { $Unbox(Seq#Index(results#0, j#1)): DatatypeType, $Unbox(Seq#Index(results#0, i#8)): DatatypeType } 
            LitInt(0) <= i#8 && i#8 < j#1 && j#1 < Seq#Length(Lit(results#0))
               ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#8)): DatatypeType)
                 && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), j#1)): DatatypeType)
                 && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#8)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#1)): DatatypeType))))
         && ((forall i#8: int, j#1: int :: 
              { $Unbox(Seq#Index(results#0, j#1)): DatatypeType, $Unbox(Seq#Index(results#0, i#8)): DatatypeType } 
              LitInt(0) <= i#8 && i#8 < j#1 && j#1 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#8)): DatatypeType)
                   && UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), j#1)): DatatypeType)
                   && SeqComparison.__default.lt#canCall(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#8)): DatatypeType), 
                    UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#1)): DatatypeType)))
             && (forall i#8: int, j#1: int :: 
              { $Unbox(Seq#Index(results#0, j#1)): DatatypeType, $Unbox(Seq#Index(results#0, i#8)): DatatypeType } 
              LitInt(0) <= i#8 && i#8 < j#1 && j#1 < Seq#Length(Lit(results#0))
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#8)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#1)): DatatypeType)))
           ==> (forall key#1: Seq Box :: 
            { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#1)]): Seq Box } 
              { MapSpec.__default.InRange(start#0, key#1, end#0) } 
            $Is(key#1, Tclass.KeyType.Key())
               ==> MapSpec.__default.InRange#canCall(Lit(start#0), key#1, Lit(end#0))
                 && (MapSpec.__default.InRange(Lit(start#0), key#1, Lit(end#0))
                   ==> MapSpec.Variables.Variables_q(Lit(s#0))
                     && MapSpec.__default.EmptyValue#canCall())
                 && (MapSpec.__default.InRange(Lit(start#0), key#1, Lit(end#0))
                     && $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(key#1)]): Seq Box
                       != MapSpec.__default.EmptyValue()
                   ==> (forall i#9: int :: 
                    { $Unbox(Seq#Index(results#0, i#9)): DatatypeType } 
                    i#9 < Seq#Length(Lit(results#0))
                       ==> UI.SuccResult.SuccResult_q($Unbox(Seq#Index(Lit(results#0), i#9)): DatatypeType)))))
         && MapSpec.__default.Succ(Lit(k#0), 
            Lit(s#0), 
            Lit(s'#0), 
            Lit(uiop#0), 
            Lit(start#0), 
            Lit(results#0), 
            Lit(end#0))
           == (
            UI.Op#Equal(uiop#0, #UI.Op.SuccOp(Lit(start#0), Lit(results#0), Lit(end#0)))
             && MapSpec.__default.WF(Lit(s#0))
             && MapSpec.Variables#Equal(s'#0, s#0)
             && MapSpec.__default.NonEmptyRange(Lit(start#0), Lit(end#0))
             && (forall i#5: int :: 
              { $Unbox(Seq#Index(results#0, i#5)): DatatypeType } 
              LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(results#0))
                 ==> $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType))]): Seq Box
                   == UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#5)): DatatypeType))
             && (forall i#6: int :: 
              { $Unbox(Seq#Index(results#0, i#6)): DatatypeType } 
              LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(results#0))
                 ==> UI.SuccResult.value($Unbox(Seq#Index(Lit(results#0), i#6)): DatatypeType)
                   != MapSpec.__default.EmptyValue())
             && (forall i#7: int :: 
              { $Unbox(Seq#Index(results#0, i#7)): DatatypeType } 
              LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(results#0))
                 ==> MapSpec.__default.InRange(Lit(start#0), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#7)): DatatypeType), 
                  Lit(end#0)))
             && (forall i#8: int, j#1: int :: 
              { $Unbox(Seq#Index(results#0, j#1)): DatatypeType, $Unbox(Seq#Index(results#0, i#8)): DatatypeType } 
              LitInt(0) <= i#8 && i#8 < j#1 && j#1 < Seq#Length(Lit(results#0))
                 ==> SeqComparison.__default.lt(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#8)): DatatypeType), 
                  UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), j#1)): DatatypeType)))
             && (forall key#1: Seq Box :: 
              { $Unbox(IMap#Elements(MapSpec.Variables.view(s#0))[$Box(key#1)]): Seq Box } 
                { MapSpec.__default.InRange(start#0, key#1, end#0) } 
              $Is(key#1, Tclass.KeyType.Key())
                   && 
                  MapSpec.__default.InRange(Lit(start#0), key#1, Lit(end#0))
                   && $Unbox(IMap#Elements(Lit(MapSpec.Variables.view(Lit(s#0))))[$Box(key#1)]): Seq Box
                     != MapSpec.__default.EmptyValue()
                 ==> (exists i#9: int :: 
                  { $Unbox(Seq#Index(results#0, i#9)): DatatypeType } 
                  LitInt(0) <= i#9
                     && i#9 < Seq#Length(Lit(results#0))
                     && Seq#Equal(UI.SuccResult.key($Unbox(Seq#Index(Lit(results#0), i#9)): DatatypeType), key#1)))));

// function declaration for MapSpec._default.Write
function MapSpec.__default.Write(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    new_value#0: Seq Box)
   : bool;

function MapSpec.__default.Write#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    new_value#0: Seq Box)
   : bool;

// consequence axiom for MapSpec.__default.Write
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    { MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0) } 
    MapSpec.__default.Write#canCall(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> 
      MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
       ==> MapSpec.__default.WF(s'#0));

function MapSpec.__default.Write#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for MapSpec.__default.Write
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    key#0: Seq Box, 
    new_value#0: Seq Box :: 
  { MapSpec.__default.Write#requires(k#0, s#0, s'#0, uiop#0, key#0, new_value#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(new_value#0, Tclass.ValueType.Value())
     ==> MapSpec.__default.Write#requires(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
       == true);

// definition axiom for MapSpec.__default.Write(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    { MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0) } 
    MapSpec.__default.Write#canCall(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(uiop#0)
         && (UI.Op#Equal(uiop#0, #UI.Op.PutOp(key#0, new_value#0))
           ==> MapSpec.__default.WF#canCall(s#0))
         && (MapSpec.__default.WF#canCall(s#0) && MapSpec.__default.WF(s#0)
           ==> MapSpec.__default.WF#canCall(s'#0))
         && (MapSpec.__default.WF#canCall(s'#0) && MapSpec.__default.WF(s'#0)
           ==> MapSpec.Variables.Variables_q(s'#0) && MapSpec.Variables.Variables_q(s#0))
         && MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#0, new_value#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.PutOp(key#0, new_value#0))
             && MapSpec.__default.WF(s#0)
             && MapSpec.__default.WF(s'#0)
             && IMap#Equal(MapSpec.Variables.view(s'#0), 
              IMap#Build(MapSpec.Variables.view(s#0), $Box(key#0), $Box(new_value#0)))));

// definition axiom for MapSpec.__default.Write for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), new_value#0) } 
    MapSpec.__default.Write#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), new_value#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), new_value#0))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s'#0)))
         && (MapSpec.__default.WF#canCall(Lit(s'#0)) && Lit(MapSpec.__default.WF(Lit(s'#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s'#0))
             && MapSpec.Variables.Variables_q(Lit(s#0)))
         && MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), new_value#0)
           == (
            UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), new_value#0))
             && MapSpec.__default.WF(Lit(s#0))
             && MapSpec.__default.WF(Lit(s'#0))
             && IMap#Equal(MapSpec.Variables.view(Lit(s'#0)), 
              IMap#Build(Lit(MapSpec.Variables.view(Lit(s#0))), $Box(Lit(key#0)), $Box(new_value#0)))));

// definition axiom for MapSpec.__default.Write for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      key#0: Seq Box, 
      new_value#0: Seq Box :: 
    {:weight 3} { MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(new_value#0)) } 
    MapSpec.__default.Write#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(new_value#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(new_value#0, Tclass.ValueType.Value()))
       ==> $IsA#UI.Op(Lit(uiop#0))
         && (UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), Lit(new_value#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s#0)))
         && (MapSpec.__default.WF#canCall(Lit(s#0)) && Lit(MapSpec.__default.WF(Lit(s#0)))
           ==> MapSpec.__default.WF#canCall(Lit(s'#0)))
         && (MapSpec.__default.WF#canCall(Lit(s'#0)) && Lit(MapSpec.__default.WF(Lit(s'#0)))
           ==> MapSpec.Variables.Variables_q(Lit(s'#0))
             && MapSpec.Variables.Variables_q(Lit(s#0)))
         && MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(key#0), Lit(new_value#0))
           == (
            UI.Op#Equal(uiop#0, #UI.Op.PutOp(Lit(key#0), Lit(new_value#0)))
             && MapSpec.__default.WF(Lit(s#0))
             && MapSpec.__default.WF(Lit(s'#0))
             && IMap#Equal(MapSpec.Variables.view(Lit(s'#0)), 
              IMap#Build(Lit(MapSpec.Variables.view(Lit(s#0))), $Box(Lit(key#0)), $Box(Lit(new_value#0))))));

// function declaration for MapSpec._default.Stutter
function MapSpec.__default.Stutter(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

function MapSpec.__default.Stutter#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.Stutter
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Stutter#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> true);

function MapSpec.__default.Stutter#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Stutter
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
  { MapSpec.__default.Stutter#requires(k#0, s#0, s'#0, uiop#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
     ==> MapSpec.__default.Stutter#requires(k#0, s#0, s'#0, uiop#0) == true);

// definition axiom for MapSpec.__default.Stutter(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Stutter#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (UI.Op.NoOp_q(uiop#0)
           ==> $IsA#MapSpec.Variables(s'#0) && $IsA#MapSpec.Variables(s#0))
         && MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0)
           == (UI.Op.NoOp_q(uiop#0) && MapSpec.Variables#Equal(s'#0, s#0)));

// definition axiom for MapSpec.__default.Stutter for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0)) } 
    MapSpec.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (Lit(UI.Op.NoOp_q(Lit(uiop#0)))
           ==> $IsA#MapSpec.Variables(Lit(s'#0)) && $IsA#MapSpec.Variables(Lit(s#0)))
         && MapSpec.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
           == (UI.Op.NoOp_q(Lit(uiop#0)) && MapSpec.Variables#Equal(s'#0, s#0)));

// function declaration for MapSpec._default.NextStep
function MapSpec.__default.NextStep(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

function MapSpec.__default.NextStep#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.NextStep
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0) } 
    MapSpec.__default.NextStep#canCall(k#0, s#0, s'#0, uiop#0, step#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(step#0, Tclass.MapSpec.Step()))
       ==> true);

function MapSpec.__default.NextStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.NextStep
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    uiop#0: DatatypeType, 
    step#0: DatatypeType :: 
  { MapSpec.__default.NextStep#requires(k#0, s#0, s'#0, uiop#0, step#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
       && $Is(step#0, Tclass.MapSpec.Step())
     ==> MapSpec.__default.NextStep#requires(k#0, s#0, s'#0, uiop#0, step#0) == true);

// definition axiom for MapSpec.__default.NextStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0) } 
    MapSpec.__default.NextStep#canCall(k#0, s#0, s'#0, uiop#0, step#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(step#0, Tclass.MapSpec.Step()))
       ==> (MapSpec.Step.QueryStep_q(step#0)
           ==> (var result#0 := MapSpec.Step.result(step#0); 
            (var key#0 := MapSpec.Step.key(step#0); 
              MapSpec.__default.Query#canCall(k#0, s#0, s'#0, uiop#0, key#0, result#0))))
         && (!MapSpec.Step.QueryStep_q(step#0)
           ==> (MapSpec.Step.WriteStep_q(step#0)
               ==> (var new_value#0 := MapSpec.Step.new__value(step#0); 
                (var key#1 := MapSpec.Step.key(step#0); 
                  MapSpec.__default.Write#canCall(k#0, s#0, s'#0, uiop#0, key#1, new_value#0))))
             && (!MapSpec.Step.WriteStep_q(step#0)
               ==> (MapSpec.Step.SuccStep_q(step#0)
                   ==> (var end#0 := MapSpec.Step.end(step#0); 
                    (var results#0 := MapSpec.Step.results(step#0); 
                      (var start#0 := MapSpec.Step.start(step#0); 
                        MapSpec.__default.Succ#canCall(k#0, s#0, s'#0, uiop#0, start#0, results#0, end#0)))))
                 && (!MapSpec.Step.SuccStep_q(step#0)
                   ==> MapSpec.__default.Stutter#canCall(k#0, s#0, s'#0, uiop#0))))
         && MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0)
           == (if MapSpec.Step.QueryStep_q(step#0)
             then (var result#1 := MapSpec.Step.result(step#0); 
              (var key#2 := MapSpec.Step.key(step#0); 
                MapSpec.__default.Query(k#0, s#0, s'#0, uiop#0, key#2, result#1)))
             else (if MapSpec.Step.WriteStep_q(step#0)
               then (var new_value#1 := MapSpec.Step.new__value(step#0); 
                (var key#3 := MapSpec.Step.key(step#0); 
                  MapSpec.__default.Write(k#0, s#0, s'#0, uiop#0, key#3, new_value#1)))
               else (if MapSpec.Step.SuccStep_q(step#0)
                 then (var end#1 := MapSpec.Step.end(step#0); 
                  (var results#1 := MapSpec.Step.results(step#0); 
                    (var start#1 := MapSpec.Step.start(step#0); 
                      MapSpec.__default.Succ(k#0, s#0, s'#0, uiop#0, start#1, results#1, end#1))))
                 else MapSpec.__default.Stutter(k#0, s#0, s'#0, uiop#0)))));

// definition axiom for MapSpec.__default.NextStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      uiop#0: DatatypeType, 
      step#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(step#0)) } 
    MapSpec.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op())
           && $Is(step#0, Tclass.MapSpec.Step()))
       ==> (Lit(MapSpec.Step.QueryStep_q(Lit(step#0)))
           ==> (var result#2 := Lit(MapSpec.Step.result(Lit(step#0))); 
            (var key#4 := Lit(MapSpec.Step.key(Lit(step#0))); 
              MapSpec.__default.Query#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#4, result#2))))
         && (!Lit(MapSpec.Step.QueryStep_q(Lit(step#0)))
           ==> (Lit(MapSpec.Step.WriteStep_q(Lit(step#0)))
               ==> (var new_value#2 := Lit(MapSpec.Step.new__value(Lit(step#0))); 
                (var key#5 := Lit(MapSpec.Step.key(Lit(step#0))); 
                  MapSpec.__default.Write#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#5, new_value#2))))
             && (!Lit(MapSpec.Step.WriteStep_q(Lit(step#0)))
               ==> (Lit(MapSpec.Step.SuccStep_q(Lit(step#0)))
                   ==> (var end#2 := Lit(MapSpec.Step.end(Lit(step#0))); 
                    (var results#2 := Lit(MapSpec.Step.results(Lit(step#0))); 
                      (var start#2 := Lit(MapSpec.Step.start(Lit(step#0))); 
                        MapSpec.__default.Succ#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), start#2, results#2, end#2)))))
                 && (!Lit(MapSpec.Step.SuccStep_q(Lit(step#0)))
                   ==> MapSpec.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0)))))
         && MapSpec.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), Lit(step#0))
           == (if MapSpec.Step.QueryStep_q(Lit(step#0))
             then (var result#3 := Lit(MapSpec.Step.result(Lit(step#0))); 
              (var key#6 := Lit(MapSpec.Step.key(Lit(step#0))); 
                Lit(MapSpec.__default.Query(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#6, result#3))))
             else (if MapSpec.Step.WriteStep_q(Lit(step#0))
               then (var new_value#3 := Lit(MapSpec.Step.new__value(Lit(step#0))); 
                (var key#7 := Lit(MapSpec.Step.key(Lit(step#0))); 
                  Lit(MapSpec.__default.Write(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), key#7, new_value#3))))
               else (if MapSpec.Step.SuccStep_q(Lit(step#0))
                 then (var end#3 := Lit(MapSpec.Step.end(Lit(step#0))); 
                  (var results#3 := Lit(MapSpec.Step.results(Lit(step#0))); 
                    (var start#3 := Lit(MapSpec.Step.start(Lit(step#0))); 
                      Lit(MapSpec.__default.Succ(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), start#3, results#3, end#3)))))
                 else MapSpec.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))))));

// function declaration for MapSpec._default.Next
function MapSpec.__default.Next(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

function MapSpec.__default.Next#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType)
   : bool;

// consequence axiom for MapSpec.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Next(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Next#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> true);

function MapSpec.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Next
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
  { MapSpec.__default.Next#requires(k#0, s#0, s'#0, uiop#0) } 
  $Is(k#0, Tclass.MapSpec.Constants())
       && $Is(s#0, Tclass.MapSpec.Variables())
       && $Is(s'#0, Tclass.MapSpec.Variables())
       && $Is(uiop#0, Tclass.UI.Op())
     ==> MapSpec.__default.Next#requires(k#0, s#0, s'#0, uiop#0) == true);

// definition axiom for MapSpec.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    { MapSpec.__default.Next(k#0, s#0, s'#0, uiop#0) } 
    MapSpec.__default.Next#canCall(k#0, s#0, s'#0, uiop#0)
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (forall step#0: DatatypeType :: 
          { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0) } 
          $Is(step#0, Tclass.MapSpec.Step())
             ==> MapSpec.__default.NextStep#canCall(k#0, s#0, s'#0, uiop#0, step#0))
         && MapSpec.__default.Next(k#0, s#0, s'#0, uiop#0)
           == (exists step#0: DatatypeType :: 
            { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0) } 
            $Is(step#0, Tclass.MapSpec.Step())
               && MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#0)));

// definition axiom for MapSpec.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, uiop#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0)) } 
    MapSpec.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
         || (
          $Is(k#0, Tclass.MapSpec.Constants())
           && $Is(s#0, Tclass.MapSpec.Variables())
           && $Is(s'#0, Tclass.MapSpec.Variables())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (forall step#1: DatatypeType :: 
          { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#1) } 
          $Is(step#1, Tclass.MapSpec.Step())
             ==> MapSpec.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), step#1))
         && MapSpec.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0))
           == (exists step#1: DatatypeType :: 
            { MapSpec.__default.NextStep(k#0, s#0, s'#0, uiop#0, step#1) } 
            $Is(step#1, Tclass.MapSpec.Step())
               && MapSpec.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(uiop#0), step#1)));

// function declaration for MapSpec._default.Inv
function MapSpec.__default.Inv(k#0: DatatypeType, s#0: DatatypeType) : bool;

function MapSpec.__default.Inv#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for MapSpec.__default.Inv
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Inv(k#0, s#0) } 
    MapSpec.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> true);

function MapSpec.__default.Inv#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for MapSpec.__default.Inv
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { MapSpec.__default.Inv#requires(k#0, s#0) } 
  $Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables())
     ==> MapSpec.__default.Inv#requires(k#0, s#0) == true);

// definition axiom for MapSpec.__default.Inv(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { MapSpec.__default.Inv(k#0, s#0) } 
    MapSpec.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> MapSpec.__default.WF#canCall(s#0)
         && MapSpec.__default.Inv(k#0, s#0) == MapSpec.__default.WF(s#0));

// definition axiom for MapSpec.__default.Inv for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { MapSpec.__default.Inv(Lit(k#0), Lit(s#0)) } 
    MapSpec.__default.Inv#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.MapSpec.Constants()) && $Is(s#0, Tclass.MapSpec.Variables()))
       ==> MapSpec.__default.WF#canCall(Lit(s#0))
         && MapSpec.__default.Inv(Lit(k#0), Lit(s#0)) == Lit(MapSpec.__default.WF(Lit(s#0))));

// Constructor function declaration
function #ValueMessage.Delta.NoDelta() : DatatypeType;

const unique ##ValueMessage.Delta.NoDelta: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ValueMessage.Delta.NoDelta()) == ##ValueMessage.Delta.NoDelta;

function ValueMessage.Delta.NoDelta_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d) } 
  ValueMessage.Delta.NoDelta_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Delta.NoDelta);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d) } 
  ValueMessage.Delta.NoDelta_q(d) ==> d == #ValueMessage.Delta.NoDelta());

function Tclass.ValueMessage.Delta() : Ty;

// Tclass.ValueMessage.Delta Tag
axiom Tag(Tclass.ValueMessage.Delta()) == Tagclass.ValueMessage.Delta;

const unique Tagclass.ValueMessage.Delta: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Delta
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Delta()) } 
  $IsBox(bx, Tclass.ValueMessage.Delta())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Delta()));

// Constructor $Is
axiom $Is(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#ValueMessage.Delta.NoDelta(), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom #ValueMessage.Delta.NoDelta() == Lit(#ValueMessage.Delta.NoDelta());

// Depth-one case-split function
function $IsA#ValueMessage.Delta(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Delta(d) } 
  $IsA#ValueMessage.Delta(d) ==> ValueMessage.Delta.NoDelta_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Delta.NoDelta_q(d), $Is(d, Tclass.ValueMessage.Delta()) } 
  $Is(d, Tclass.ValueMessage.Delta()) ==> ValueMessage.Delta.NoDelta_q(d));

// Datatype extensional equality declaration
function ValueMessage.Delta#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Delta.NoDelta
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Delta#Equal(a, b) } 
  true ==> (ValueMessage.Delta#Equal(a, b) <==> true));

// Datatype extensionality axiom: ValueMessage.Delta
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Delta#Equal(a, b) } 
  ValueMessage.Delta#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Delta: ClassName;

const unique class.ValueMessage.__default: ClassName;

function Tclass.ValueMessage.__default() : Ty;

// Tclass.ValueMessage.__default Tag
axiom Tag(Tclass.ValueMessage.__default()) == Tagclass.ValueMessage.__default;

const unique Tagclass.ValueMessage.__default: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.__default()) } 
  $IsBox(bx, Tclass.ValueMessage.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.ValueMessage.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ValueMessage.__default()) } 
  $Is($o, Tclass.ValueMessage.__default())
     <==> $o == null || dtype($o) == Tclass.ValueMessage.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ValueMessage.__default(), $h) } 
  $IsAlloc($o, Tclass.ValueMessage.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ValueMessage._default.NopDelta
function ValueMessage.__default.NopDelta() : DatatypeType;

function ValueMessage.__default.NopDelta#canCall() : bool;

// consequence axiom for ValueMessage.__default.NopDelta
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.NopDelta(), Tclass.ValueMessage.Delta());

function ValueMessage.__default.NopDelta#requires() : bool;

// #requires axiom for ValueMessage.__default.NopDelta
axiom ValueMessage.__default.NopDelta#requires() == true;

// definition axiom for ValueMessage.__default.NopDelta(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta() == Lit(#ValueMessage.Delta.NoDelta());

// definition axiom for ValueMessage.__default.NopDelta for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta() == Lit(#ValueMessage.Delta.NoDelta());

// function declaration for ValueMessage._default.DefaultValue
function ValueMessage.__default.DefaultValue() : Seq Box;

function ValueMessage.__default.DefaultValue#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefaultValue
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefaultValue(), Tclass.ValueType.Value());

function ValueMessage.__default.DefaultValue#requires() : bool;

// #requires axiom for ValueMessage.__default.DefaultValue
axiom ValueMessage.__default.DefaultValue#requires() == true;

// definition axiom for ValueMessage.__default.DefaultValue(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefaultValue() == Lit(ValueType.__default.DefaultValue());

// definition axiom for ValueMessage.__default.DefaultValue for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueType.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefaultValue() == Lit(ValueType.__default.DefaultValue());

// function declaration for ValueMessage._default.CombineDeltas
function ValueMessage.__default.CombineDeltas(newdelta#0: DatatypeType, olddelta#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.CombineDeltas#canCall(newdelta#0: DatatypeType, olddelta#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.CombineDeltas
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> (ValueMessage.Delta#Equal(newdelta#0, ValueMessage.__default.NopDelta())
           ==> ValueMessage.Delta#Equal(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), olddelta#0))
         && (ValueMessage.Delta#Equal(olddelta#0, ValueMessage.__default.NopDelta())
           ==> ValueMessage.Delta#Equal(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), newdelta#0))
         && $Is(ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0), 
          Tclass.ValueMessage.Delta()));

function ValueMessage.__default.CombineDeltas#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.CombineDeltas
axiom (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
  { ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) } 
  $Is(newdelta#0, Tclass.ValueMessage.Delta())
       && $Is(olddelta#0, Tclass.ValueMessage.Delta())
     ==> ValueMessage.__default.CombineDeltas#requires(newdelta#0, olddelta#0) == true);

// definition axiom for ValueMessage.__default.CombineDeltas(revealed)
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    { ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0) } 
    ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> ValueMessage.__default.CombineDeltas(newdelta#0, olddelta#0)
         == Lit(#ValueMessage.Delta.NoDelta()));

// definition axiom for ValueMessage.__default.CombineDeltas for all literals(revealed)
axiom true
   ==> (forall newdelta#0: DatatypeType, olddelta#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.CombineDeltas(Lit(newdelta#0), Lit(olddelta#0)) } 
    ValueMessage.__default.CombineDeltas#canCall(Lit(newdelta#0), Lit(olddelta#0))
         || ($Is(newdelta#0, Tclass.ValueMessage.Delta())
           && $Is(olddelta#0, Tclass.ValueMessage.Delta()))
       ==> ValueMessage.__default.CombineDeltas(Lit(newdelta#0), Lit(olddelta#0))
         == Lit(#ValueMessage.Delta.NoDelta()));

// function declaration for ValueMessage._default.ApplyDelta
function ValueMessage.__default.ApplyDelta(delta#0: DatatypeType, value#0: Seq Box) : Seq Box;

function ValueMessage.__default.ApplyDelta#canCall(delta#0: DatatypeType, value#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.ApplyDelta
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> (ValueMessage.Delta#Equal(delta#0, ValueMessage.__default.NopDelta())
           ==> Seq#Equal(ValueMessage.__default.ApplyDelta(delta#0, value#0), value#0))
         && $Is(ValueMessage.__default.ApplyDelta(delta#0, value#0), Tclass.ValueType.Value()));

function ValueMessage.__default.ApplyDelta#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.ApplyDelta
axiom (forall delta#0: DatatypeType, value#0: Seq Box :: 
  { ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) } 
  $Is(delta#0, Tclass.ValueMessage.Delta())
       && $Is(value#0, Tclass.ValueType.Value())
     ==> ValueMessage.__default.ApplyDelta#requires(delta#0, value#0) == true);

// definition axiom for ValueMessage.__default.ApplyDelta(revealed)
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    { ValueMessage.__default.ApplyDelta(delta#0, value#0) } 
    ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0)
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> ValueMessage.__default.ApplyDelta(delta#0, value#0) == value#0);

// definition axiom for ValueMessage.__default.ApplyDelta for all literals(revealed)
axiom true
   ==> (forall delta#0: DatatypeType, value#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.ApplyDelta(Lit(delta#0), Lit(value#0)) } 
    ValueMessage.__default.ApplyDelta#canCall(Lit(delta#0), Lit(value#0))
         || ($Is(delta#0, Tclass.ValueMessage.Delta())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> ValueMessage.__default.ApplyDelta(Lit(delta#0), Lit(value#0)) == Lit(value#0));

// function declaration for ValueMessage._default.bytestring_to_Message
function ValueMessage.__default.bytestring__to__Message(s#0: Seq Box) : DatatypeType;

function ValueMessage.__default.bytestring__to__Message#canCall(s#0: Seq Box) : bool;

function Tclass.ValueMessage.Message() : Ty;

// Tclass.ValueMessage.Message Tag
axiom Tag(Tclass.ValueMessage.Message()) == Tagclass.ValueMessage.Message;

const unique Tagclass.ValueMessage.Message: TyTag;

// Box/unbox axiom for Tclass.ValueMessage.Message
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ValueMessage.Message()) } 
  $IsBox(bx, Tclass.ValueMessage.Message())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ValueMessage.Message()));

// consequence axiom for ValueMessage.__default.bytestring__to__Message
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> $Is(ValueMessage.__default.bytestring__to__Message(s#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.bytestring__to__Message#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestring__to__Message
axiom (forall s#0: Seq Box :: 
  { ValueMessage.__default.bytestring__to__Message#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> ValueMessage.__default.bytestring__to__Message#requires(s#0)
       == (Seq#Length(s#0) < 4294967296));

// definition axiom for ValueMessage.__default.bytestring__to__Message(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { ValueMessage.__default.bytestring__to__Message(s#0) } 
    ValueMessage.__default.bytestring__to__Message#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) < 4294967296)
       ==> ValueType.__default.MaxLen#canCall()
         && (LitInt(ValueType.__default.MaxLen()) < Seq#Length(s#0)
           ==> ValueType.__default.DefaultValue#canCall())
         && ValueMessage.__default.bytestring__to__Message(s#0)
           == (if Seq#Length(s#0) <= LitInt(ValueType.__default.MaxLen())
             then #ValueMessage.Message.Define(s#0)
             else #ValueMessage.Message.Define(Lit(ValueType.__default.DefaultValue()))));

// definition axiom for ValueMessage.__default.bytestring__to__Message for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.bytestring__to__Message(Lit(s#0)) } 
    ValueMessage.__default.bytestring__to__Message#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) < 4294967296)
       ==> ValueType.__default.MaxLen#canCall()
         && (LitInt(ValueType.__default.MaxLen()) < Seq#Length(Lit(s#0))
           ==> ValueType.__default.DefaultValue#canCall())
         && ValueMessage.__default.bytestring__to__Message(Lit(s#0))
           == (if Seq#Length(Lit(s#0)) <= LitInt(ValueType.__default.MaxLen())
             then #ValueMessage.Message.Define(Lit(s#0))
             else #ValueMessage.Message.Define(Lit(ValueType.__default.DefaultValue()))));

// function declaration for ValueMessage._default.EncodableMessage
function ValueMessage.__default.EncodableMessage(msg#0: DatatypeType) : bool;

function ValueMessage.__default.EncodableMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> true);

function ValueMessage.__default.EncodableMessage#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessage
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.EncodableMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.EncodableMessage#requires(msg#0) == true);

// definition axiom for ValueMessage.__default.EncodableMessage(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.EncodableMessage(msg#0) } 
    ValueMessage.__default.EncodableMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.EncodableMessage(msg#0)
         == (true && ValueMessage.Message.Define_q(msg#0)));

// definition axiom for ValueMessage.__default.EncodableMessage for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.EncodableMessage(Lit(msg#0)) } 
    ValueMessage.__default.EncodableMessage#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.EncodableMessage(Lit(msg#0))
         == Lit(true && ValueMessage.Message.Define_q(Lit(msg#0))));

// function declaration for ValueMessage._default.EncodableMessageSeq
function ValueMessage.__default.EncodableMessageSeq(msgs#0: Seq Box) : bool;

function ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for ValueMessage.__default.EncodableMessageSeq
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function ValueMessage.__default.EncodableMessageSeq#requires(Seq Box) : bool;

// #requires axiom for ValueMessage.__default.EncodableMessageSeq
axiom (forall msgs#0: Seq Box :: 
  { ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.EncodableMessageSeq#requires(msgs#0) == true);

// definition axiom for ValueMessage.__default.EncodableMessageSeq(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { ValueMessage.__default.EncodableMessageSeq(msgs#0) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Lit(true)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(msgs#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(msgs#0)
               ==> ValueMessage.__default.EncodableMessage#canCall($Unbox(Seq#Index(msgs#0, i#0)): DatatypeType)))
         && ValueMessage.__default.EncodableMessageSeq(msgs#0)
           == (true
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(msgs#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(msgs#0)
                 ==> ValueMessage.__default.EncodableMessage($Unbox(Seq#Index(msgs#0, i#0)): DatatypeType))));

// definition axiom for ValueMessage.__default.EncodableMessageSeq for all literals(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0)) } 
    ValueMessage.__default.EncodableMessageSeq#canCall(Lit(msgs#0))
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Lit(true)
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(msgs#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(msgs#0))
               ==> ValueMessage.__default.EncodableMessage#canCall($Unbox(Seq#Index(Lit(msgs#0), i#1)): DatatypeType)))
         && ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0))
           == (true
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(msgs#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(msgs#0))
                 ==> ValueMessage.__default.EncodableMessage($Unbox(Seq#Index(Lit(msgs#0), i#1)): DatatypeType))));

// function declaration for ValueMessage._default.Message_to_bytestring
function ValueMessage.__default.Message__to__bytestring(msg#0: DatatypeType) : Seq Box;

function ValueMessage.__default.Message__to__bytestring#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Message__to__bytestring
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> $Is(ValueMessage.__default.Message__to__bytestring(msg#0), 
        TSeq(Tclass.NativeTypes.byte())));

function ValueMessage.__default.Message__to__bytestring#requires(DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Message__to__bytestring
axiom (forall msg#0: DatatypeType :: 
  { ValueMessage.__default.Message__to__bytestring#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Message__to__bytestring#requires(msg#0)
       == ValueMessage.Message.Define_q(msg#0));

// definition axiom for ValueMessage.__default.Message__to__bytestring(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { ValueMessage.__default.Message__to__bytestring(msg#0) } 
    ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && ValueMessage.Message.Define_q(msg#0))
       ==> ValueMessage.__default.Message__to__bytestring(msg#0)
         == ValueMessage.Message.value(msg#0));

// definition axiom for ValueMessage.__default.Message__to__bytestring for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Message__to__bytestring(Lit(msg#0)) } 
    ValueMessage.__default.Message__to__bytestring#canCall(Lit(msg#0))
         || ($Is(msg#0, Tclass.ValueMessage.Message())
           && Lit(ValueMessage.Message.Define_q(Lit(msg#0))))
       ==> ValueMessage.__default.Message__to__bytestring(Lit(msg#0))
         == Lit(ValueMessage.Message.value(Lit(msg#0))));

// function declaration for ValueMessage._default.messageSeq_to_bytestringSeq
function ValueMessage.__default.messageSeq__to__bytestringSeq($ly: LayerType, msgs#0: Seq Box) : Seq Box;

function ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq(AsFuelBottom($ly), msgs#0) } 
  ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0)
     == ValueMessage.__default.messageSeq__to__bytestringSeq($LZ, msgs#0));

// consequence axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
           == Seq#Length(msgs#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(msgs#0, i#0)): DatatypeType } 
            { $Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0))
             ==> Seq#Equal($Unbox(Seq#Index(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), i#0)): Seq Box, 
              ValueMessage.__default.Message__to__bytestring($Unbox(Seq#Index(msgs#0, i#0)): DatatypeType)))
         && $Is(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, msgs#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function ValueMessage.__default.messageSeq__to__bytestringSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.messageSeq__to__bytestringSeq
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> ValueMessage.__default.messageSeq__to__bytestringSeq#requires($ly, msgs#0)
       == ValueMessage.__default.EncodableMessageSeq(msgs#0));

// definition axiom for ValueMessage.__default.messageSeq__to__bytestringSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(msgs#0)
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && ValueMessage.__default.EncodableMessageSeq(msgs#0))
       ==> (Seq#Length(msgs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0))
             && 
            Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && ValueMessage.__default.Message__to__bytestring#canCall($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)): DatatypeType))
         && ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), msgs#0)
           == (if Seq#Length(msgs#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.messageSeq__to__bytestringSeq($ly, Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.Message__to__bytestring($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)): DatatypeType))))));

// definition axiom for ValueMessage.__default.messageSeq__to__bytestringSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), Lit(msgs#0)) } 
    ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Lit(msgs#0))
         || ($Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Lit(ValueMessage.__default.EncodableMessageSeq(Lit(msgs#0))))
       ==> (Seq#Length(Lit(msgs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && ValueMessage.__default.messageSeq__to__bytestringSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && ValueMessage.__default.Message__to__bytestring#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType)))
         && ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), Lit(msgs#0))
           == (if Seq#Length(Lit(msgs#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.messageSeq__to__bytestringSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.Message__to__bytestring(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType))))))));

// function declaration for ValueMessage._default.bytestringSeq_to_MessageSeq
function ValueMessage.__default.bytestringSeq__to__MessageSeq($ly: LayerType, strings#0: Seq Box) : Seq Box;

function ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq(AsFuelBottom($ly), strings#0) } 
  ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0)
     == ValueMessage.__default.bytestringSeq__to__MessageSeq($LZ, strings#0));

// consequence axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(strings#0, i#0)): Seq Box } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#0)): Seq Box) < 4294967296))
       ==> Seq#Length(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0))
           == Seq#Length(strings#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(strings#0, i#1)): Seq Box } 
            { $Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(strings#0)
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), i#1)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message($Unbox(Seq#Index(strings#0, i#1)): Seq Box)))
         && $Is(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, strings#0), 
          TSeq(Tclass.ValueMessage.Message())));

function ValueMessage.__default.bytestringSeq__to__MessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq
axiom (forall $ly: LayerType, strings#0: Seq Box :: 
  { ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0) } 
  $Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> ValueMessage.__default.bytestringSeq__to__MessageSeq#requires($ly, strings#0)
       == (forall i#2: int :: 
        { $Unbox(Seq#Index(strings#0, i#2)): Seq Box } 
        LitInt(0) <= i#2 && i#2 < Seq#Length(strings#0)
           ==> Seq#Length($Unbox(Seq#Index(strings#0, i#2)): Seq Box) < 4294967296));

// definition axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(strings#0)
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(strings#0, i#2)): Seq Box } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(strings#0)
               ==> Seq#Length($Unbox(Seq#Index(strings#0, i#2)): Seq Box) < 4294967296))
       ==> (Seq#Length(strings#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strings#0)
             && ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strings#0))
             && 
            Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strings#0)
             && ValueMessage.__default.bytestring__to__Message#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strings#0)): Seq Box))
         && ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), strings#0)
           == (if Seq#Length(strings#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.bytestringSeq__to__MessageSeq($ly, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strings#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.bytestring__to__Message($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strings#0)): Seq Box))))));

// definition axiom for ValueMessage.__default.bytestringSeq__to__MessageSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, strings#0: Seq Box :: 
    {:weight 3} { ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), Lit(strings#0)) } 
    ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Lit(strings#0))
         || ($Is(strings#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(strings#0, i#3)): Seq Box } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(strings#0))
               ==> Seq#Length($Unbox(Seq#Index(Lit(strings#0), i#3)): Seq Box) < 4294967296))
       ==> (Seq#Length(Lit(strings#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))
             && ValueMessage.__default.bytestringSeq__to__MessageSeq#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))))
             && 
            Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))
             && ValueMessage.__default.bytestring__to__Message#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))): Seq Box)))
         && ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), Lit(strings#0))
           == (if Seq#Length(Lit(strings#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(ValueMessage.__default.bytestringSeq__to__MessageSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.bytestring__to__Message(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strings#0))): Seq Box))))))));

// function declaration for ValueMessage._default.Merge
function ValueMessage.__default.Merge(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : DatatypeType;

function ValueMessage.__default.Merge#canCall(newmessage#0: DatatypeType, oldmessage#0: DatatypeType) : bool;

// consequence axiom for ValueMessage.__default.Merge
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> $Is(ValueMessage.__default.Merge(newmessage#0, oldmessage#0), 
        Tclass.ValueMessage.Message()));

function ValueMessage.__default.Merge#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ValueMessage.__default.Merge
axiom (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
  { ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) } 
  $Is(newmessage#0, Tclass.ValueMessage.Message())
       && $Is(oldmessage#0, Tclass.ValueMessage.Message())
     ==> ValueMessage.__default.Merge#requires(newmessage#0, oldmessage#0) == true);

// definition axiom for ValueMessage.__default.Merge(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    { ValueMessage.__default.Merge(newmessage#0, oldmessage#0) } 
    ValueMessage.__default.Merge#canCall(newmessage#0, oldmessage#0)
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
         && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0))))
         && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
           ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
             && (ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var value#0 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var delta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#0, value#0))))
             && (!ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               ==> _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                 && (var olddelta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  _System.Tuple2.___hMake2_q(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))
                     && (var newdelta#0 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#0, olddelta#0)))))
         && ValueMessage.__default.Merge(newmessage#0, oldmessage#0)
           == (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
             then (var newvalue#1 := ValueMessage.Message.value($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
              #ValueMessage.Message.Define(newvalue#1))
             else (if ValueMessage.Message.Define_q($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType)
               then (var value#1 := ValueMessage.Message.value($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var delta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Define(ValueMessage.__default.ApplyDelta(delta#1, value#1))))
               else (var olddelta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._1(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                (var newdelta#1 := ValueMessage.Message.delta($Unbox(_System.Tuple2._0(#_System._tuple#2._#Make2($Box(newmessage#0), $Box(oldmessage#0)))): DatatypeType); 
                  #ValueMessage.Message.Update(ValueMessage.__default.CombineDeltas(newdelta#1, olddelta#1)))))));

// definition axiom for ValueMessage.__default.Merge for all literals(revealed)
axiom true
   ==> (forall newmessage#0: DatatypeType, oldmessage#0: DatatypeType :: 
    {:weight 3} { ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0)) } 
    ValueMessage.__default.Merge#canCall(Lit(newmessage#0), Lit(oldmessage#0))
         || ($Is(newmessage#0, Tclass.ValueMessage.Message())
           && $Is(oldmessage#0, Tclass.ValueMessage.Message()))
       ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
         && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0))))))
         && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
           ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
             && (Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var value#2 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var delta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.ApplyDelta#canCall(delta#2, value#2))))
             && (!Lit(ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType)))
               ==> _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                 && (var olddelta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  _System.Tuple2.___hMake2_q(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))
                     && (var newdelta#2 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                      ValueMessage.__default.CombineDeltas#canCall(newdelta#2, olddelta#2)))))
         && ValueMessage.__default.Merge(Lit(newmessage#0), Lit(oldmessage#0))
           == (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
             then (var newvalue#3 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
              Lit(#ValueMessage.Message.Define(newvalue#3)))
             else (if ValueMessage.Message.Define_q(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))
               then (var value#3 := Lit(ValueMessage.Message.value(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var delta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.ApplyDelta(delta#3, value#3))))))
               else (var olddelta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._1(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                (var newdelta#3 := Lit(ValueMessage.Message.delta(Lit($Unbox(_System.Tuple2._0(Lit(#_System._tuple#2._#Make2($Box(Lit(newmessage#0)), $Box(Lit(oldmessage#0)))))): DatatypeType))); 
                  Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.CombineDeltas(newdelta#3, olddelta#3)))))))));

// function declaration for ValueMessage._default.IdentityMessage
function ValueMessage.__default.IdentityMessage() : DatatypeType;

function ValueMessage.__default.IdentityMessage#canCall() : bool;

// consequence axiom for ValueMessage.__default.IdentityMessage
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.IdentityMessage(), Tclass.ValueMessage.Message());

function ValueMessage.__default.IdentityMessage#requires() : bool;

// #requires axiom for ValueMessage.__default.IdentityMessage
axiom ValueMessage.__default.IdentityMessage#requires() == true;

// definition axiom for ValueMessage.__default.IdentityMessage(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta())));

// definition axiom for ValueMessage.__default.IdentityMessage for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.NopDelta#canCall()
     && ValueMessage.__default.IdentityMessage()
       == Lit(#ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta())));

// function declaration for ValueMessage._default.DefineDefault
function ValueMessage.__default.DefineDefault() : DatatypeType;

function ValueMessage.__default.DefineDefault#canCall() : bool;

// consequence axiom for ValueMessage.__default.DefineDefault
axiom true
   ==> 
  true
   ==> $Is(ValueMessage.__default.DefineDefault(), Tclass.ValueMessage.Message());

function ValueMessage.__default.DefineDefault#requires() : bool;

// #requires axiom for ValueMessage.__default.DefineDefault
axiom ValueMessage.__default.DefineDefault#requires() == true;

// definition axiom for ValueMessage.__default.DefineDefault(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.DefaultValue())));

// definition axiom for ValueMessage.__default.DefineDefault for all literals(revealed)
axiom true
   ==> 
  true
   ==> ValueMessage.__default.DefaultValue#canCall()
     && ValueMessage.__default.DefineDefault()
       == Lit(#ValueMessage.Message.Define(Lit(ValueMessage.__default.DefaultValue())));

// Constructor function declaration
function #ValueMessage.Message.Define(Seq Box) : DatatypeType;

const unique ##ValueMessage.Message.Define: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#0#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Define(a#0#0#0))
     == ##ValueMessage.Message.Define);

function ValueMessage.Message.Define_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Define);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Define_q(d) } 
  ValueMessage.Message.Define_q(d)
     ==> (exists a#1#0#0: Seq Box :: d == #ValueMessage.Message.Define(a#1#0#0)));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box :: 
  { $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Define(a#2#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#2#0#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Define(a#3#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Define_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(Lit(a#4#0#0)) } 
  #ValueMessage.Message.Define(Lit(a#4#0#0))
     == Lit(#ValueMessage.Message.Define(a#4#0#0)));

function ValueMessage.Message.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box :: 
  { #ValueMessage.Message.Define(a#5#0#0) } 
  ValueMessage.Message.value(#ValueMessage.Message.Define(a#5#0#0)) == a#5#0#0);

// Constructor function declaration
function #ValueMessage.Message.Update(DatatypeType) : DatatypeType;

const unique ##ValueMessage.Message.Update: DtCtorId;

// Constructor identifier
axiom (forall a#6#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#6#0#0) } 
  DatatypeCtorId(#ValueMessage.Message.Update(a#6#0#0))
     == ##ValueMessage.Message.Update);

function ValueMessage.Message.Update_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     <==> DatatypeCtorId(d) == ##ValueMessage.Message.Update);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d) } 
  ValueMessage.Message.Update_q(d)
     ==> (exists a#7#0#0: DatatypeType :: d == #ValueMessage.Message.Update(a#7#0#0)));

// Constructor $Is
axiom (forall a#8#0#0: DatatypeType :: 
  { $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message()) } 
  $Is(#ValueMessage.Message.Update(a#8#0#0), Tclass.ValueMessage.Message())
     <==> $Is(a#8#0#0, Tclass.ValueMessage.Delta()));

// Constructor $IsAlloc
axiom (forall a#9#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ValueMessage.Message.Update(a#9#0#0), Tclass.ValueMessage.Message(), $h)
       <==> $IsAlloc(a#9#0#0, Tclass.ValueMessage.Delta(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h) } 
  $IsGoodHeap($h)
       && 
      ValueMessage.Message.Update_q(d)
       && $IsAlloc(d, Tclass.ValueMessage.Message(), $h)
     ==> $IsAlloc(ValueMessage.Message.delta(d), Tclass.ValueMessage.Delta(), $h));

// Constructor literal
axiom (forall a#10#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(Lit(a#10#0#0)) } 
  #ValueMessage.Message.Update(Lit(a#10#0#0))
     == Lit(#ValueMessage.Message.Update(a#10#0#0)));

function ValueMessage.Message.delta(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#11#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#11#0#0) } 
  ValueMessage.Message.delta(#ValueMessage.Message.Update(a#11#0#0)) == a#11#0#0);

// Inductive rank
axiom (forall a#12#0#0: DatatypeType :: 
  { #ValueMessage.Message.Update(a#12#0#0) } 
  DtRank(a#12#0#0) < DtRank(#ValueMessage.Message.Update(a#12#0#0)));

// Depth-one case-split function
function $IsA#ValueMessage.Message(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ValueMessage.Message(d) } 
  $IsA#ValueMessage.Message(d)
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ValueMessage.Message.Update_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
    { ValueMessage.Message.Define_q(d), $Is(d, Tclass.ValueMessage.Message()) } 
  $Is(d, Tclass.ValueMessage.Message())
     ==> ValueMessage.Message.Define_q(d) || ValueMessage.Message.Update_q(d));

// Datatype extensional equality declaration
function ValueMessage.Message#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ValueMessage.Message.Define
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Define_q(b) } 
  ValueMessage.Message.Define_q(a) && ValueMessage.Message.Define_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> Seq#Equal(ValueMessage.Message.value(a), ValueMessage.Message.value(b))));

// Datatype extensional equality definition: #ValueMessage.Message.Update
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(a) } 
    { ValueMessage.Message#Equal(a, b), ValueMessage.Message.Update_q(b) } 
  ValueMessage.Message.Update_q(a) && ValueMessage.Message.Update_q(b)
     ==> (ValueMessage.Message#Equal(a, b)
       <==> ValueMessage.Delta#Equal(ValueMessage.Message.delta(a), ValueMessage.Message.delta(b))));

// Datatype extensionality axiom: ValueMessage.Message
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ValueMessage.Message#Equal(a, b) } 
  ValueMessage.Message#Equal(a, b) <==> a == b);

const unique class.ValueMessage.Message: ClassName;

// Constructor function declaration
function #BetreeGraph.Node.Node(IMap Box Box, IMap Box Box) : DatatypeType;

const unique ##BetreeGraph.Node.Node: DtCtorId;

// Constructor identifier
axiom (forall a#13#0#0: IMap Box Box, a#13#1#0: IMap Box Box :: 
  { #BetreeGraph.Node.Node(a#13#0#0, a#13#1#0) } 
  DatatypeCtorId(#BetreeGraph.Node.Node(a#13#0#0, a#13#1#0))
     == ##BetreeGraph.Node.Node);

function BetreeGraph.Node.Node_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Node.Node_q(d) } 
  BetreeGraph.Node.Node_q(d) <==> DatatypeCtorId(d) == ##BetreeGraph.Node.Node);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Node.Node_q(d) } 
  BetreeGraph.Node.Node_q(d)
     ==> (exists a#14#0#0: IMap Box Box, a#14#1#0: IMap Box Box :: 
      d == #BetreeGraph.Node.Node(a#14#0#0, a#14#1#0)));

function Tclass.BetreeGraph.Node() : Ty;

// Tclass.BetreeGraph.Node Tag
axiom Tag(Tclass.BetreeGraph.Node()) == Tagclass.BetreeGraph.Node;

const unique Tagclass.BetreeGraph.Node: TyTag;

// Box/unbox axiom for Tclass.BetreeGraph.Node
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BetreeGraph.Node()) } 
  $IsBox(bx, Tclass.BetreeGraph.Node())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BetreeGraph.Node()));

// Constructor $Is
axiom (forall a#15#0#0: IMap Box Box, a#15#1#0: IMap Box Box :: 
  { $Is(#BetreeGraph.Node.Node(a#15#0#0, a#15#1#0), Tclass.BetreeGraph.Node()) } 
  $Is(#BetreeGraph.Node.Node(a#15#0#0, a#15#1#0), Tclass.BetreeGraph.Node())
     <==> $Is(a#15#0#0, TIMap(Tclass.KeyType.Key(), Tclass.NativeTypes.uint64()))
       && $Is(a#15#1#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

// Constructor $IsAlloc
axiom (forall a#16#0#0: IMap Box Box, a#16#1#0: IMap Box Box, $h: Heap :: 
  { $IsAlloc(#BetreeGraph.Node.Node(a#16#0#0, a#16#1#0), Tclass.BetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BetreeGraph.Node.Node(a#16#0#0, a#16#1#0), Tclass.BetreeGraph.Node(), $h)
       <==> $IsAlloc(a#16#0#0, TIMap(Tclass.KeyType.Key(), Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#16#1#0, TIMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.Node.children(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.Node.Node_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.Node(), $h)
     ==> $IsAlloc(BetreeGraph.Node.children(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.Node.buffer(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.Node.Node_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.Node(), $h)
     ==> $IsAlloc(BetreeGraph.Node.buffer(d), 
      TIMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), 
      $h));

// Constructor literal
axiom (forall a#17#0#0: IMap Box Box, a#17#1#0: IMap Box Box :: 
  { #BetreeGraph.Node.Node(Lit(a#17#0#0), Lit(a#17#1#0)) } 
  #BetreeGraph.Node.Node(Lit(a#17#0#0), Lit(a#17#1#0))
     == Lit(#BetreeGraph.Node.Node(a#17#0#0, a#17#1#0)));

function BetreeGraph.Node.children(DatatypeType) : IMap Box Box;

// Constructor injectivity
axiom (forall a#18#0#0: IMap Box Box, a#18#1#0: IMap Box Box :: 
  { #BetreeGraph.Node.Node(a#18#0#0, a#18#1#0) } 
  BetreeGraph.Node.children(#BetreeGraph.Node.Node(a#18#0#0, a#18#1#0))
     == a#18#0#0);

// Inductive map key rank
axiom (forall a#19#0#0: IMap Box Box, a#19#1#0: IMap Box Box, d: DatatypeType :: 
  { IMap#Domain(a#19#0#0)[$Box(d)], #BetreeGraph.Node.Node(a#19#0#0, a#19#1#0) } 
  IMap#Domain(a#19#0#0)[$Box(d)]
     ==> DtRank(d) < DtRank(#BetreeGraph.Node.Node(a#19#0#0, a#19#1#0)));

// Inductive map value rank
axiom (forall a#20#0#0: IMap Box Box, a#20#1#0: IMap Box Box, bx: Box :: 
  { IMap#Domain(a#20#0#0)[bx], #BetreeGraph.Node.Node(a#20#0#0, a#20#1#0) } 
  IMap#Domain(a#20#0#0)[bx]
     ==> DtRank($Unbox(IMap#Elements(a#20#0#0)[bx]): DatatypeType)
       < DtRank(#BetreeGraph.Node.Node(a#20#0#0, a#20#1#0)));

function BetreeGraph.Node.buffer(DatatypeType) : IMap Box Box;

// Constructor injectivity
axiom (forall a#21#0#0: IMap Box Box, a#21#1#0: IMap Box Box :: 
  { #BetreeGraph.Node.Node(a#21#0#0, a#21#1#0) } 
  BetreeGraph.Node.buffer(#BetreeGraph.Node.Node(a#21#0#0, a#21#1#0)) == a#21#1#0);

// Inductive map key rank
axiom (forall a#22#0#0: IMap Box Box, a#22#1#0: IMap Box Box, d: DatatypeType :: 
  { IMap#Domain(a#22#1#0)[$Box(d)], #BetreeGraph.Node.Node(a#22#0#0, a#22#1#0) } 
  IMap#Domain(a#22#1#0)[$Box(d)]
     ==> DtRank(d) < DtRank(#BetreeGraph.Node.Node(a#22#0#0, a#22#1#0)));

// Inductive map value rank
axiom (forall a#23#0#0: IMap Box Box, a#23#1#0: IMap Box Box, bx: Box :: 
  { IMap#Domain(a#23#1#0)[bx], #BetreeGraph.Node.Node(a#23#0#0, a#23#1#0) } 
  IMap#Domain(a#23#1#0)[bx]
     ==> DtRank($Unbox(IMap#Elements(a#23#1#0)[bx]): DatatypeType)
       < DtRank(#BetreeGraph.Node.Node(a#23#0#0, a#23#1#0)));

// Depth-one case-split function
function $IsA#BetreeGraph.Node(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BetreeGraph.Node(d) } 
  $IsA#BetreeGraph.Node(d) ==> BetreeGraph.Node.Node_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Node.Node_q(d), $Is(d, Tclass.BetreeGraph.Node()) } 
  $Is(d, Tclass.BetreeGraph.Node()) ==> BetreeGraph.Node.Node_q(d));

// Datatype extensional equality declaration
function BetreeGraph.Node#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BetreeGraph.Node.Node
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.Node#Equal(a, b) } 
  true
     ==> (BetreeGraph.Node#Equal(a, b)
       <==> IMap#Equal(BetreeGraph.Node.children(a), BetreeGraph.Node.children(b))
         && IMap#Equal(BetreeGraph.Node.buffer(a), BetreeGraph.Node.buffer(b))));

// Datatype extensionality axiom: BetreeGraph.Node
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.Node#Equal(a, b) } 
  BetreeGraph.Node#Equal(a, b) <==> a == b);

const unique class.BetreeGraph.Node: ClassName;

const unique class.BetreeGraph.__default: ClassName;

function Tclass.BetreeGraph.__default() : Ty;

// Tclass.BetreeGraph.__default Tag
axiom Tag(Tclass.BetreeGraph.__default()) == Tagclass.BetreeGraph.__default;

const unique Tagclass.BetreeGraph.__default: TyTag;

// Box/unbox axiom for Tclass.BetreeGraph.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BetreeGraph.__default()) } 
  $IsBox(bx, Tclass.BetreeGraph.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BetreeGraph.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BetreeGraph.__default()) } 
  $Is($o, Tclass.BetreeGraph.__default())
     <==> $o == null || dtype($o) == Tclass.BetreeGraph.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BetreeGraph.__default(), $h) } 
  $IsAlloc($o, Tclass.BetreeGraph.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BetreeGraph._default.Successors
function BetreeGraph.__default.Successors(node#0: DatatypeType) : ISet Box;

function BetreeGraph.__default.Successors#canCall(node#0: DatatypeType) : bool;

// consequence axiom for BetreeGraph.__default.Successors
axiom true
   ==> (forall node#0: DatatypeType :: 
    { BetreeGraph.__default.Successors(node#0) } 
    BetreeGraph.__default.Successors#canCall(node#0)
         || $Is(node#0, Tclass.BetreeGraph.Node())
       ==> $Is(BetreeGraph.__default.Successors(node#0), TISet(Tclass.NativeTypes.uint64())));

function BetreeGraph.__default.Successors#requires(DatatypeType) : bool;

// #requires axiom for BetreeGraph.__default.Successors
axiom (forall node#0: DatatypeType :: 
  { BetreeGraph.__default.Successors#requires(node#0) } 
  $Is(node#0, Tclass.BetreeGraph.Node())
     ==> BetreeGraph.__default.Successors#requires(node#0) == true);

// definition axiom for BetreeGraph.__default.Successors(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    { BetreeGraph.__default.Successors(node#0) } 
    BetreeGraph.__default.Successors#canCall(node#0)
         || $Is(node#0, Tclass.BetreeGraph.Node())
       ==> (forall k#0: Seq Box :: 
          { $Unbox(IMap#Elements(BetreeGraph.Node.children(node#0))[$Box(k#0)]): int } 
            { IMap#Domain(BetreeGraph.Node.children(node#0))[$Box(k#0)] } 
          $Is(k#0, TSeq(Tclass.NativeTypes.byte()))
             ==> BetreeGraph.Node.Node_q(node#0)
               && (IMap#Domain(BetreeGraph.Node.children(node#0))[$Box(k#0)]
                 ==> BetreeGraph.Node.Node_q(node#0)))
         && BetreeGraph.__default.Successors(node#0)
           == (lambda $y#0: Box :: 
            (exists k#0: Seq Box :: 
              { $Unbox(IMap#Elements(BetreeGraph.Node.children(node#0))[$Box(k#0)]): int } 
                { IMap#Domain(BetreeGraph.Node.children(node#0))[$Box(k#0)] } 
              $Is(k#0, TSeq(Tclass.NativeTypes.byte()))
                 && IMap#Domain(BetreeGraph.Node.children(node#0))[$Box(k#0)]
                 && $y#0 == IMap#Elements(BetreeGraph.Node.children(node#0))[$Box(k#0)])));

// definition axiom for BetreeGraph.__default.Successors for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    {:weight 3} { BetreeGraph.__default.Successors(Lit(node#0)) } 
    BetreeGraph.__default.Successors#canCall(Lit(node#0))
         || $Is(node#0, Tclass.BetreeGraph.Node())
       ==> (forall k#1: Seq Box :: 
          { $Unbox(IMap#Elements(BetreeGraph.Node.children(node#0))[$Box(k#1)]): int } 
            { IMap#Domain(BetreeGraph.Node.children(node#0))[$Box(k#1)] } 
          $Is(k#1, TSeq(Tclass.NativeTypes.byte()))
             ==> BetreeGraph.Node.Node_q(Lit(node#0))
               && (IMap#Domain(BetreeGraph.Node.children(Lit(node#0)))[$Box(k#1)]
                 ==> BetreeGraph.Node.Node_q(Lit(node#0))))
         && BetreeGraph.__default.Successors(Lit(node#0))
           == (lambda $y#1: Box :: 
            (exists k#1: Seq Box :: 
              { $Unbox(IMap#Elements(BetreeGraph.Node.children(node#0))[$Box(k#1)]): int } 
                { IMap#Domain(BetreeGraph.Node.children(node#0))[$Box(k#1)] } 
              $Is(k#1, TSeq(Tclass.NativeTypes.byte()))
                 && IMap#Domain(BetreeGraph.Node.children(Lit(node#0)))[$Box(k#1)]
                 && $y#1 == IMap#Elements(Lit(BetreeGraph.Node.children(Lit(node#0))))[$Box(k#1)])));

// function declaration for BetreeGraph._default.Root
function BetreeGraph.__default.Root() : int;

function BetreeGraph.__default.Root#canCall() : bool;

// consequence axiom for BetreeGraph.__default.Root
axiom true
   ==> 
  true
   ==> LitInt(0) <= BetreeGraph.__default.Root()
     && BetreeGraph.__default.Root() < 18446744073709551616;

function BetreeGraph.__default.Root#requires() : bool;

// #requires axiom for BetreeGraph.__default.Root
axiom BetreeGraph.__default.Root#requires() == true;

// definition axiom for BetreeGraph.__default.Root(revealed)
axiom true
   ==> 
  true
   ==> ReferenceType.__default.Root#canCall()
     && BetreeGraph.__default.Root() == LitInt(ReferenceType.__default.Root());

// definition axiom for BetreeGraph.__default.Root for all literals(revealed)
axiom true
   ==> 
  true
   ==> ReferenceType.__default.Root#canCall()
     && BetreeGraph.__default.Root() == LitInt(ReferenceType.__default.Root());

// function declaration for BetreeGraph._default.IsClosed
function BetreeGraph.__default.IsClosed(g#0: IMap Box Box) : bool;

function BetreeGraph.__default.IsClosed#canCall(g#0: IMap Box Box) : bool;

// consequence axiom for BetreeGraph.__default.IsClosed
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { BetreeGraph.__default.IsClosed(g#0) } 
    BetreeGraph.__default.IsClosed#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       ==> true);

function BetreeGraph.__default.IsClosed#requires(IMap Box Box) : bool;

// #requires axiom for BetreeGraph.__default.IsClosed
axiom (forall g#0: IMap Box Box :: 
  { BetreeGraph.__default.IsClosed#requires(g#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
     ==> BetreeGraph.__default.IsClosed#requires(g#0) == true);

// definition axiom for BetreeGraph.__default.IsClosed(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { BetreeGraph.__default.IsClosed(g#0) } 
    BetreeGraph.__default.IsClosed#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       ==> (forall ref#0: int :: 
          { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
            { IMap#Domain(g#0)[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            IMap#Domain(g#0)[$Box(ref#0)]
             ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType))
         && BetreeGraph.__default.IsClosed(g#0)
           == (forall ref#0: int :: 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
              { IMap#Domain(g#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> 
              IMap#Domain(g#0)[$Box(ref#0)]
               ==> ISet#Subset(BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType), 
                IMap#Domain(g#0))));

// definition axiom for BetreeGraph.__default.IsClosed for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    {:weight 3} { BetreeGraph.__default.IsClosed(Lit(g#0)) } 
    BetreeGraph.__default.IsClosed#canCall(Lit(g#0))
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       ==> (forall ref#1: int :: 
          { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
            { IMap#Domain(g#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            IMap#Domain(g#0)[$Box(ref#1)]
             ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType))
         && BetreeGraph.__default.IsClosed(Lit(g#0))
           == (forall ref#1: int :: 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
              { IMap#Domain(g#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> 
              IMap#Domain(g#0)[$Box(ref#1)]
               ==> ISet#Subset(BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType), 
                IMap#Domain(Lit(g#0)))));

// function declaration for BetreeGraph._default.IsPath
function BetreeGraph.__default.IsPath(g#0: IMap Box Box, path#0: Seq Box) : bool;

function BetreeGraph.__default.IsPath#canCall(g#0: IMap Box Box, path#0: Seq Box) : bool;

// consequence axiom for BetreeGraph.__default.IsPath
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { BetreeGraph.__default.IsPath(g#0, path#0) } 
    BetreeGraph.__default.IsPath#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function BetreeGraph.__default.IsPath#requires(IMap Box Box, Seq Box) : bool;

// #requires axiom for BetreeGraph.__default.IsPath
axiom (forall g#0: IMap Box Box, path#0: Seq Box :: 
  { BetreeGraph.__default.IsPath#requires(g#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> BetreeGraph.__default.IsPath#requires(g#0, path#0) == true);

// definition axiom for BetreeGraph.__default.IsPath(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { BetreeGraph.__default.IsPath(g#0, path#0) } 
    BetreeGraph.__default.IsPath#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> ((forall i#0: int :: 
            { $Unbox(Seq#Index(path#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(path#0) - 1
               ==> IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
           ==> (forall i#1: int, _t#0#0: int :: 
            { $Unbox(Seq#Index(path#0, i#1)): int, $Unbox(Seq#Index(path#0, _t#0#0)): int } 
            _t#0#0 == i#1 + 1
               ==> 
              i#1 < Seq#Length(path#0) - 1
               ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[Seq#Index(path#0, i#1)]): DatatypeType)))
         && BetreeGraph.__default.IsPath(g#0, path#0)
           == ((forall i#0: int :: 
              { $Unbox(Seq#Index(path#0, i#0)): int } 
              true
                 ==> 
                LitInt(0) <= i#0 && i#0 < Seq#Length(path#0) - 1
                 ==> IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
             && (forall i#1: int, _t#0#0: int :: 
              { $Unbox(Seq#Index(path#0, i#1)): int, $Unbox(Seq#Index(path#0, _t#0#0)): int } 
              _t#0#0 == i#1 + 1
                 ==> 
                LitInt(0) <= i#1 && i#1 < Seq#Length(path#0) - 1
                 ==> BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[Seq#Index(path#0, i#1)]): DatatypeType)[Seq#Index(path#0, _t#0#0)])));

// definition axiom for BetreeGraph.__default.IsPath for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.IsPath(g#0, Lit(path#0)) } 
    BetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> ((forall i#2: int :: 
            { $Unbox(Seq#Index(path#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
               ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#2)])
           ==> (forall i#3: int, _t#0#1: int :: 
            { $Unbox(Seq#Index(path#0, i#3)): int, $Unbox(Seq#Index(path#0, _t#0#1)): int } 
            _t#0#1 == i#3 + 1
               ==> 
              i#3 < Seq#Length(Lit(path#0)) - 1
               ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[Seq#Index(Lit(path#0), i#3)]): DatatypeType)))
         && BetreeGraph.__default.IsPath(g#0, Lit(path#0))
           == ((forall i#2: int :: 
              { $Unbox(Seq#Index(path#0, i#2)): int } 
              true
                 ==> 
                LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
                 ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#2)])
             && (forall i#3: int, _t#0#1: int :: 
              { $Unbox(Seq#Index(path#0, i#3)): int, $Unbox(Seq#Index(path#0, _t#0#1)): int } 
              _t#0#1 == i#3 + 1
                 ==> 
                LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(path#0)) - 1
                 ==> BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[Seq#Index(Lit(path#0), i#3)]): DatatypeType)[Seq#Index(Lit(path#0), _t#0#1)])));

// definition axiom for BetreeGraph.__default.IsPath for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0)) } 
    BetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> ((forall i#4: int :: 
            { $Unbox(Seq#Index(path#0, i#4)): int } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(Lit(path#0)) - 1
               ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#4)])
           ==> (forall i#5: int, _t#0#2: int :: 
            { $Unbox(Seq#Index(path#0, i#5)): int, $Unbox(Seq#Index(path#0, _t#0#2)): int } 
            _t#0#2 == i#5 + 1
               ==> 
              i#5 < Seq#Length(Lit(path#0)) - 1
               ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[Seq#Index(Lit(path#0), i#5)]): DatatypeType)))
         && BetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
           == ((forall i#4: int :: 
              { $Unbox(Seq#Index(path#0, i#4)): int } 
              true
                 ==> 
                LitInt(0) <= i#4 && i#4 < Seq#Length(Lit(path#0)) - 1
                 ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#4)])
             && (forall i#5: int, _t#0#2: int :: 
              { $Unbox(Seq#Index(path#0, i#5)): int, $Unbox(Seq#Index(path#0, _t#0#2)): int } 
              _t#0#2 == i#5 + 1
                 ==> 
                LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(path#0)) - 1
                 ==> BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[Seq#Index(Lit(path#0), i#5)]): DatatypeType)[Seq#Index(Lit(path#0), _t#0#2)])));

// function declaration for BetreeGraph._default.IsCycle
function BetreeGraph.__default.IsCycle(g#0: IMap Box Box, path#0: Seq Box) : bool;

function BetreeGraph.__default.IsCycle#canCall(g#0: IMap Box Box, path#0: Seq Box) : bool;

// consequence axiom for BetreeGraph.__default.IsCycle
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { BetreeGraph.__default.IsCycle(g#0, path#0) } 
    BetreeGraph.__default.IsCycle#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function BetreeGraph.__default.IsCycle#requires(IMap Box Box, Seq Box) : bool;

// #requires axiom for BetreeGraph.__default.IsCycle
axiom (forall g#0: IMap Box Box, path#0: Seq Box :: 
  { BetreeGraph.__default.IsCycle#requires(g#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> BetreeGraph.__default.IsCycle#requires(g#0, path#0) == true);

// definition axiom for BetreeGraph.__default.IsCycle(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { BetreeGraph.__default.IsCycle(g#0, path#0) } 
    BetreeGraph.__default.IsCycle#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(g#0, path#0)
         && (0 < Seq#Length(path#0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0))
         && (Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)
             && BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]): DatatypeType))
         && BetreeGraph.__default.IsCycle(g#0, path#0)
           == (
            BetreeGraph.__default.IsPath(g#0, path#0)
             && 0 < Seq#Length(path#0)
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
             && BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]): DatatypeType)[Seq#Index(path#0, LitInt(0))]));

// definition axiom for BetreeGraph.__default.IsCycle for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.IsCycle(g#0, Lit(path#0)) } 
    BetreeGraph.__default.IsCycle#canCall(g#0, Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         && (0 < Seq#Length(Lit(path#0))
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && (Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType))
         && BetreeGraph.__default.IsCycle(g#0, Lit(path#0))
           == (
            BetreeGraph.__default.IsPath(g#0, Lit(path#0))
             && 0 < Seq#Length(Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
             && BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType)[Seq#Index(Lit(path#0), LitInt(0))]));

// definition axiom for BetreeGraph.__default.IsCycle for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.IsCycle(Lit(g#0), Lit(path#0)) } 
    BetreeGraph.__default.IsCycle#canCall(Lit(g#0), Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         && (0 < Seq#Length(Lit(path#0))
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && (Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType))
         && BetreeGraph.__default.IsCycle(Lit(g#0), Lit(path#0))
           == (
            BetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
             && 0 < Seq#Length(Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
             && BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType)[Seq#Index(Lit(path#0), LitInt(0))]));

// function declaration for BetreeGraph._default.IsSimple
function BetreeGraph.__default.IsSimple(g#0: IMap Box Box, path#0: Seq Box) : bool;

function BetreeGraph.__default.IsSimple#canCall(g#0: IMap Box Box, path#0: Seq Box) : bool;

// consequence axiom for BetreeGraph.__default.IsSimple
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { BetreeGraph.__default.IsSimple(g#0, path#0) } 
    BetreeGraph.__default.IsSimple#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function BetreeGraph.__default.IsSimple#requires(IMap Box Box, Seq Box) : bool;

// #requires axiom for BetreeGraph.__default.IsSimple
axiom (forall g#0: IMap Box Box, path#0: Seq Box :: 
  { BetreeGraph.__default.IsSimple#requires(g#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> BetreeGraph.__default.IsSimple#requires(g#0, path#0) == true);

// definition axiom for BetreeGraph.__default.IsSimple(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { BetreeGraph.__default.IsSimple(g#0, path#0) } 
    BetreeGraph.__default.IsSimple#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(g#0, path#0)
         && BetreeGraph.__default.IsSimple(g#0, path#0)
           == (BetreeGraph.__default.IsPath(g#0, path#0)
             && (forall i#0: int, j#0: int :: 
              { $Unbox(Seq#Index(path#0, j#0)): int, $Unbox(Seq#Index(path#0, i#0)): int } 
              true
                 ==> 
                LitInt(0) <= i#0
                   && i#0 < Seq#Length(path#0)
                   && 
                  LitInt(0) <= j#0
                   && j#0 < Seq#Length(path#0)
                   && i#0 != j#0
                 ==> $Unbox(Seq#Index(path#0, i#0)): int != $Unbox(Seq#Index(path#0, j#0)): int)));

// definition axiom for BetreeGraph.__default.IsSimple for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.IsSimple(g#0, Lit(path#0)) } 
    BetreeGraph.__default.IsSimple#canCall(g#0, Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         && BetreeGraph.__default.IsSimple(g#0, Lit(path#0))
           == (BetreeGraph.__default.IsPath(g#0, Lit(path#0))
             && (forall i#1: int, j#1: int :: 
              { $Unbox(Seq#Index(path#0, j#1)): int, $Unbox(Seq#Index(path#0, i#1)): int } 
              true
                 ==> 
                LitInt(0) <= i#1
                   && i#1 < Seq#Length(Lit(path#0))
                   && 
                  LitInt(0) <= j#1
                   && j#1 < Seq#Length(Lit(path#0))
                   && i#1 != j#1
                 ==> $Unbox(Seq#Index(Lit(path#0), i#1)): int
                   != $Unbox(Seq#Index(Lit(path#0), j#1)): int)));

// definition axiom for BetreeGraph.__default.IsSimple for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.IsSimple(Lit(g#0), Lit(path#0)) } 
    BetreeGraph.__default.IsSimple#canCall(Lit(g#0), Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         && BetreeGraph.__default.IsSimple(Lit(g#0), Lit(path#0))
           == (BetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
             && (forall i#2: int, j#2: int :: 
              { $Unbox(Seq#Index(path#0, j#2)): int, $Unbox(Seq#Index(path#0, i#2)): int } 
              true
                 ==> 
                LitInt(0) <= i#2
                   && i#2 < Seq#Length(Lit(path#0))
                   && 
                  LitInt(0) <= j#2
                   && j#2 < Seq#Length(Lit(path#0))
                   && i#2 != j#2
                 ==> $Unbox(Seq#Index(Lit(path#0), i#2)): int
                   != $Unbox(Seq#Index(Lit(path#0), j#2)): int)));

// function declaration for BetreeGraph._default.IsAcyclic
function BetreeGraph.__default.IsAcyclic(g#0: IMap Box Box) : bool;

function BetreeGraph.__default.IsAcyclic#canCall(g#0: IMap Box Box) : bool;

// consequence axiom for BetreeGraph.__default.IsAcyclic
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { BetreeGraph.__default.IsAcyclic(g#0) } 
    BetreeGraph.__default.IsAcyclic#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       ==> true);

function BetreeGraph.__default.IsAcyclic#requires(IMap Box Box) : bool;

// #requires axiom for BetreeGraph.__default.IsAcyclic
axiom (forall g#0: IMap Box Box :: 
  { BetreeGraph.__default.IsAcyclic#requires(g#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
     ==> BetreeGraph.__default.IsAcyclic#requires(g#0) == true);

// definition axiom for BetreeGraph.__default.IsAcyclic(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { BetreeGraph.__default.IsAcyclic(g#0) } 
    BetreeGraph.__default.IsAcyclic#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       ==> (forall path#0: Seq Box :: 
          { BetreeGraph.__default.IsCycle(g#0, path#0) } 
            { BetreeGraph.__default.IsPath(g#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.IsPath#canCall(g#0, path#0)
               && (BetreeGraph.__default.IsPath(g#0, path#0)
                 ==> BetreeGraph.__default.IsCycle#canCall(g#0, path#0)))
         && BetreeGraph.__default.IsAcyclic(g#0)
           == (forall path#0: Seq Box :: 
            { BetreeGraph.__default.IsCycle(g#0, path#0) } 
              { BetreeGraph.__default.IsPath(g#0, path#0) } 
            $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              BetreeGraph.__default.IsPath(g#0, path#0)
               ==> !BetreeGraph.__default.IsCycle(g#0, path#0)));

// definition axiom for BetreeGraph.__default.IsAcyclic for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    {:weight 3} { BetreeGraph.__default.IsAcyclic(Lit(g#0)) } 
    BetreeGraph.__default.IsAcyclic#canCall(Lit(g#0))
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       ==> (forall path#1: Seq Box :: 
          { BetreeGraph.__default.IsCycle(g#0, path#1) } 
            { BetreeGraph.__default.IsPath(g#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.IsPath#canCall(Lit(g#0), path#1)
               && (BetreeGraph.__default.IsPath(Lit(g#0), path#1)
                 ==> BetreeGraph.__default.IsCycle#canCall(Lit(g#0), path#1)))
         && BetreeGraph.__default.IsAcyclic(Lit(g#0))
           == (forall path#1: Seq Box :: 
            { BetreeGraph.__default.IsCycle(g#0, path#1) } 
              { BetreeGraph.__default.IsPath(g#0, path#1) } 
            $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              BetreeGraph.__default.IsPath(Lit(g#0), path#1)
               ==> !BetreeGraph.__default.IsCycle(Lit(g#0), path#1)));

// function declaration for BetreeGraph._default.IsPathFromTo
function BetreeGraph.__default.IsPathFromTo(g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int) : bool;

function BetreeGraph.__default.IsPathFromTo#canCall(g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int) : bool;

// consequence axiom for BetreeGraph.__default.IsPathFromTo
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    { BetreeGraph.__default.IsPathFromTo(g#0, path#0, start#0, end#0) } 
    BetreeGraph.__default.IsPathFromTo#canCall(g#0, path#0, start#0, end#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> true);

function BetreeGraph.__default.IsPathFromTo#requires(IMap Box Box, Seq Box, int, int) : bool;

// #requires axiom for BetreeGraph.__default.IsPathFromTo
axiom (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
  { BetreeGraph.__default.IsPathFromTo#requires(g#0, path#0, start#0, end#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= end#0
       && end#0 < 18446744073709551616
     ==> BetreeGraph.__default.IsPathFromTo#requires(g#0, path#0, start#0, end#0) == true);

// definition axiom for BetreeGraph.__default.IsPathFromTo(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    { BetreeGraph.__default.IsPathFromTo(g#0, path#0, start#0, end#0) } 
    BetreeGraph.__default.IsPathFromTo#canCall(g#0, path#0, start#0, end#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> BetreeGraph.__default.IsPath#canCall(g#0, path#0)
         && ($Unbox(Seq#Index(path#0, LitInt(0))): int == start#0
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0))
         && BetreeGraph.__default.IsPathFromTo(g#0, path#0, start#0, end#0)
           == (
            BetreeGraph.__default.IsPath(g#0, path#0)
             && 1 < Seq#Length(path#0)
             && $Unbox(Seq#Index(path#0, LitInt(0))): int == start#0
             && $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int
               == end#0));

// definition axiom for BetreeGraph.__default.IsPathFromTo for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    {:weight 3} { BetreeGraph.__default.IsPathFromTo(g#0, Lit(path#0), start#0, end#0) } 
    BetreeGraph.__default.IsPathFromTo#canCall(g#0, Lit(path#0), start#0, end#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> BetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == start#0
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && BetreeGraph.__default.IsPathFromTo(g#0, Lit(path#0), start#0, end#0)
           == (
            BetreeGraph.__default.IsPath(g#0, Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == start#0
             && LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int)
               == end#0));

// definition axiom for BetreeGraph.__default.IsPathFromTo for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    {:weight 3} { BetreeGraph.__default.IsPathFromTo(Lit(g#0), Lit(path#0), LitInt(start#0), LitInt(end#0)) } 
    BetreeGraph.__default.IsPathFromTo#canCall(Lit(g#0), Lit(path#0), LitInt(start#0), LitInt(end#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> BetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(start#0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && BetreeGraph.__default.IsPathFromTo(Lit(g#0), Lit(path#0), LitInt(start#0), LitInt(end#0))
           == (
            BetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(start#0)
             && LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int)
               == LitInt(end#0)));

// function declaration for BetreeGraph._default.ReachableReferences
function BetreeGraph.__default.ReachableReferences(g#0: IMap Box Box, p#0: int) : ISet Box;

function BetreeGraph.__default.ReachableReferences#canCall(g#0: IMap Box Box, p#0: int) : bool;

// consequence axiom for BetreeGraph.__default.ReachableReferences
axiom true
   ==> (forall g#0: IMap Box Box, p#0: int :: 
    { BetreeGraph.__default.ReachableReferences(g#0, p#0) } 
    BetreeGraph.__default.ReachableReferences#canCall(g#0, p#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> $Is(BetreeGraph.__default.ReachableReferences(g#0, p#0), 
        TISet(Tclass.NativeTypes.uint64())));

function BetreeGraph.__default.ReachableReferences#requires(IMap Box Box, int) : bool;

// #requires axiom for BetreeGraph.__default.ReachableReferences
axiom (forall g#0: IMap Box Box, p#0: int :: 
  { BetreeGraph.__default.ReachableReferences#requires(g#0, p#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
     ==> BetreeGraph.__default.ReachableReferences#requires(g#0, p#0) == true);

// definition axiom for BetreeGraph.__default.ReachableReferences(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, p#0: int :: 
    { BetreeGraph.__default.ReachableReferences(g#0, p#0) } 
    BetreeGraph.__default.ReachableReferences#canCall(g#0, p#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#0: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
            { $Unbox(Seq#Index(path#0, 0)): int } 
            { Seq#Length(path#0) } 
            { BetreeGraph.__default.IsPath(g#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.IsPath#canCall(g#0, path#0)
               && (BetreeGraph.__default.IsPath(g#0, path#0)
                   && 1 < Seq#Length(path#0)
                   && $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)))
         && BetreeGraph.__default.ReachableReferences(g#0, p#0)
           == (lambda $y#0: Box :: 
            (exists path#0: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
                { $Unbox(Seq#Index(path#0, 0)): int } 
                { Seq#Length(path#0) } 
                { BetreeGraph.__default.IsPath(g#0, path#0) } 
              $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
                 && 
                BetreeGraph.__default.IsPath(g#0, path#0)
                 && 1 < Seq#Length(path#0)
                 && $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
                 && $y#0 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0))));

// definition axiom for BetreeGraph.__default.ReachableReferences for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, p#0: int :: 
    {:weight 3} { BetreeGraph.__default.ReachableReferences(Lit(g#0), LitInt(p#0)) } 
    BetreeGraph.__default.ReachableReferences#canCall(Lit(g#0), LitInt(p#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#1: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
            { $Unbox(Seq#Index(path#1, 0)): int } 
            { Seq#Length(path#1) } 
            { BetreeGraph.__default.IsPath(g#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.IsPath#canCall(Lit(g#0), path#1)
               && (BetreeGraph.__default.IsPath(Lit(g#0), path#1)
                   && 1 < Seq#Length(path#1)
                   && $Unbox(Seq#Index(path#1, LitInt(0))): int == LitInt(p#0)
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#1)))
         && BetreeGraph.__default.ReachableReferences(Lit(g#0), LitInt(p#0))
           == (lambda $y#1: Box :: 
            (exists path#1: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
                { $Unbox(Seq#Index(path#1, 0)): int } 
                { Seq#Length(path#1) } 
                { BetreeGraph.__default.IsPath(g#0, path#1) } 
              $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
                 && 
                BetreeGraph.__default.IsPath(Lit(g#0), path#1)
                 && 1 < Seq#Length(path#1)
                 && $Unbox(Seq#Index(path#1, LitInt(0))): int == LitInt(p#0)
                 && $y#1 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1))));

// function declaration for BetreeGraph._default.NewPath
function BetreeGraph.__default.NewPath(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box) : bool;

function BetreeGraph.__default.NewPath#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box) : bool;

// consequence axiom for BetreeGraph.__default.NewPath
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
    BetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, path#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function BetreeGraph.__default.NewPath#requires(IMap Box Box, IMap Box Box, int, Seq Box) : bool;

// #requires axiom for BetreeGraph.__default.NewPath
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
  { BetreeGraph.__default.NewPath#requires(g#0, g'#0, p#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> BetreeGraph.__default.NewPath#requires(g#0, g'#0, p#0, path#0) == true);

// definition axiom for BetreeGraph.__default.NewPath(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
    BetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, path#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(g'#0, path#0)
         && ((forall i#0: int :: 
            { $Unbox(Seq#Index(path#0, i#0)): int } 
            true
               ==> 
              0 < i#0 && i#0 < Seq#Length(path#0) - 1
               ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                 && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0))
         && BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0)
           == (
            BetreeGraph.__default.IsPath(g'#0, path#0)
             && 1 < Seq#Length(path#0)
             && $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(path#0, i#0)): int } 
              true
                 ==> 
                0 < i#0 && i#0 < Seq#Length(path#0) - 1
                 ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                   && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]));

// definition axiom for BetreeGraph.__default.NewPath for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, Lit(path#0)) } 
    BetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, Lit(path#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(g'#0, Lit(path#0))
         && ((forall i#1: int :: 
            { $Unbox(Seq#Index(path#0, i#1)): int } 
            true
               ==> 
              0 < i#1 && i#1 < Seq#Length(Lit(path#0)) - 1
               ==> IMap#Domain(g'#0)[Seq#Index(Lit(path#0), i#1)]
                 && !IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#1)])
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && BetreeGraph.__default.NewPath(g#0, g'#0, p#0, Lit(path#0))
           == (
            BetreeGraph.__default.IsPath(g'#0, Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == p#0
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(path#0, i#1)): int } 
              true
                 ==> 
                0 < i#1 && i#1 < Seq#Length(Lit(path#0)) - 1
                 ==> IMap#Domain(g'#0)[Seq#Index(Lit(path#0), i#1)]
                   && !IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#1)])
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]));

// definition axiom for BetreeGraph.__default.NewPath for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0)) } 
    BetreeGraph.__default.NewPath#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> BetreeGraph.__default.IsPath#canCall(Lit(g'#0), Lit(path#0))
         && ((forall i#2: int :: 
            { $Unbox(Seq#Index(path#0, i#2)): int } 
            true
               ==> 
              0 < i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
               ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(Lit(path#0), i#2)]
                 && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(Lit(path#0), i#2)])
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && BetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
           == (
            BetreeGraph.__default.IsPath(Lit(g'#0), Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(p#0)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(path#0, i#2)): int } 
              true
                 ==> 
                0 < i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
                 ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(Lit(path#0), i#2)]
                   && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(Lit(path#0), i#2)])
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]));

// function declaration for BetreeGraph._default.NewlyReachableReferences
function BetreeGraph.__default.NewlyReachableReferences(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : ISet Box;

function BetreeGraph.__default.NewlyReachableReferences#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : bool;

// consequence axiom for BetreeGraph.__default.NewlyReachableReferences
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { BetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0) } 
    BetreeGraph.__default.NewlyReachableReferences#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> $Is(BetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0), 
        TISet(Tclass.NativeTypes.uint64())));

function BetreeGraph.__default.NewlyReachableReferences#requires(IMap Box Box, IMap Box Box, int) : bool;

// #requires axiom for BetreeGraph.__default.NewlyReachableReferences
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
  { BetreeGraph.__default.NewlyReachableReferences#requires(g#0, g'#0, p#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
     ==> BetreeGraph.__default.NewlyReachableReferences#requires(g#0, g'#0, p#0) == true);

// definition axiom for BetreeGraph.__default.NewlyReachableReferences(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { BetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0) } 
    BetreeGraph.__default.NewlyReachableReferences#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#0: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
            { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, path#0)
               && (BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0)
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)))
         && BetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0)
           == (lambda $y#0: Box :: 
            (exists path#0: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
                { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
              $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
                 && BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0)
                 && $y#0 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0))));

// definition axiom for BetreeGraph.__default.NewlyReachableReferences for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    {:weight 3} { BetreeGraph.__default.NewlyReachableReferences(Lit(g#0), Lit(g'#0), LitInt(p#0)) } 
    BetreeGraph.__default.NewlyReachableReferences#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#1: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
            { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.NewPath#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), path#1)
               && (BetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), path#1)
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#1)))
         && BetreeGraph.__default.NewlyReachableReferences(Lit(g#0), Lit(g'#0), LitInt(p#0))
           == (lambda $y#1: Box :: 
            (exists path#1: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
                { BetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#1) } 
              $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
                 && BetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), path#1)
                 && $y#1 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1))));

// function declaration for BetreeGraph._default.EditIsLocal
function BetreeGraph.__default.EditIsLocal(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : bool;

function BetreeGraph.__default.EditIsLocal#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : bool;

// consequence axiom for BetreeGraph.__default.EditIsLocal
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0) } 
    BetreeGraph.__default.EditIsLocal#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> true);

function BetreeGraph.__default.EditIsLocal#requires(IMap Box Box, IMap Box Box, int) : bool;

// #requires axiom for BetreeGraph.__default.EditIsLocal
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
  { BetreeGraph.__default.EditIsLocal#requires(g#0, g'#0, p#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
     ==> BetreeGraph.__default.EditIsLocal#requires(g#0, g'#0, p#0) == true);

// definition axiom for BetreeGraph.__default.EditIsLocal(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0) } 
    BetreeGraph.__default.EditIsLocal#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall ref#0: int :: 
          { $Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType } 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            IMap#Domain(g#0)[$Box(ref#0)] && IMap#Domain(g'#0)[$Box(ref#0)] && ref#0 != p#0
             ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType)
               && BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType))
         && ((forall ref#0: int :: 
            { $Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType } 
              { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> 
              IMap#Domain(g#0)[$Box(ref#0)] && IMap#Domain(g'#0)[$Box(ref#0)] && ref#0 != p#0
               ==> ISet#Equal(BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType), 
                BetreeGraph.__default.Successors($Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType)))
           ==> BetreeGraph.__default.NewlyReachableReferences#canCall(g#0, g'#0, p#0)
             && BetreeGraph.__default.ReachableReferences#canCall(g#0, p#0))
         && BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           == ((forall ref#0: int :: 
              { $Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType } 
                { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
              LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                 ==> 
                IMap#Domain(g#0)[$Box(ref#0)] && IMap#Domain(g'#0)[$Box(ref#0)] && ref#0 != p#0
                 ==> ISet#Equal(BetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType), 
                  BetreeGraph.__default.Successors($Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType)))
             && ISet#Subset(BetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0), 
              BetreeGraph.__default.ReachableReferences(g#0, p#0))));

// definition axiom for BetreeGraph.__default.EditIsLocal for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    {:weight 3} { BetreeGraph.__default.EditIsLocal(Lit(g#0), Lit(g'#0), LitInt(p#0)) } 
    BetreeGraph.__default.EditIsLocal#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall ref#1: int :: 
          { $Unbox(IMap#Elements(g'#0)[$Box(ref#1)]): DatatypeType } 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            Lit(IMap#Domain(Lit(g#0)))[$Box(ref#1)]
               && Lit(IMap#Domain(Lit(g'#0)))[$Box(ref#1)]
               && ref#1 != LitInt(p#0)
             ==> BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType)
               && BetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g'#0))[$Box(ref#1)]): DatatypeType))
         && ((forall ref#1: int :: 
            { $Unbox(IMap#Elements(g'#0)[$Box(ref#1)]): DatatypeType } 
              { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> 
              Lit(IMap#Domain(Lit(g#0)))[$Box(ref#1)]
                 && Lit(IMap#Domain(Lit(g'#0)))[$Box(ref#1)]
                 && ref#1 != LitInt(p#0)
               ==> ISet#Equal(BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType), 
                BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g'#0))[$Box(ref#1)]): DatatypeType)))
           ==> BetreeGraph.__default.NewlyReachableReferences#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0))
             && BetreeGraph.__default.ReachableReferences#canCall(Lit(g#0), LitInt(p#0)))
         && BetreeGraph.__default.EditIsLocal(Lit(g#0), Lit(g'#0), LitInt(p#0))
           == ((forall ref#1: int :: 
              { $Unbox(IMap#Elements(g'#0)[$Box(ref#1)]): DatatypeType } 
                { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
              LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                 ==> 
                Lit(IMap#Domain(Lit(g#0)))[$Box(ref#1)]
                   && Lit(IMap#Domain(Lit(g'#0)))[$Box(ref#1)]
                   && ref#1 != LitInt(p#0)
                 ==> ISet#Equal(BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType), 
                  BetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g'#0))[$Box(ref#1)]): DatatypeType)))
             && ISet#Subset(BetreeGraph.__default.NewlyReachableReferences(Lit(g#0), Lit(g'#0), LitInt(p#0)), 
              BetreeGraph.__default.ReachableReferences(Lit(g#0), LitInt(p#0)))));

// function declaration for BetreeGraph._default.NewNodesAreCycleFree
function BetreeGraph.__default.NewNodesAreCycleFree(g#0: IMap Box Box, g'#0: IMap Box Box) : bool;

function BetreeGraph.__default.NewNodesAreCycleFree#canCall(g#0: IMap Box Box, g'#0: IMap Box Box) : bool;

// consequence axiom for BetreeGraph.__default.NewNodesAreCycleFree
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
    { BetreeGraph.__default.NewNodesAreCycleFree(g#0, g'#0) } 
    BetreeGraph.__default.NewNodesAreCycleFree#canCall(g#0, g'#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node())))
       ==> true);

function BetreeGraph.__default.NewNodesAreCycleFree#requires(IMap Box Box, IMap Box Box) : bool;

// #requires axiom for BetreeGraph.__default.NewNodesAreCycleFree
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
  { BetreeGraph.__default.NewNodesAreCycleFree#requires(g#0, g'#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
     ==> BetreeGraph.__default.NewNodesAreCycleFree#requires(g#0, g'#0) == true);

// definition axiom for BetreeGraph.__default.NewNodesAreCycleFree(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
    { BetreeGraph.__default.NewNodesAreCycleFree(g#0, g'#0) } 
    BetreeGraph.__default.NewNodesAreCycleFree#canCall(g#0, g'#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node())))
       ==> (forall path#0: Seq Box :: 
          { BetreeGraph.__default.IsCycle(g'#0, path#0) } 
            { Seq#Length(path#0) } 
            { BetreeGraph.__default.IsPath(g'#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.IsPath#canCall(g'#0, path#0)
               && ((forall i#0: int :: 
                  { $Unbox(Seq#Index(path#0, i#0)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#0 && i#0 < Seq#Length(path#0)
                     ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                       && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
                 ==> BetreeGraph.__default.IsCycle#canCall(g'#0, path#0)))
         && BetreeGraph.__default.NewNodesAreCycleFree(g#0, g'#0)
           == (forall path#0: Seq Box :: 
            { BetreeGraph.__default.IsCycle(g'#0, path#0) } 
              { Seq#Length(path#0) } 
              { BetreeGraph.__default.IsPath(g'#0, path#0) } 
            $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              BetreeGraph.__default.IsPath(g'#0, path#0)
                 && (forall i#0: int :: 
                  { $Unbox(Seq#Index(path#0, i#0)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#0 && i#0 < Seq#Length(path#0)
                     ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                       && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
               ==> !BetreeGraph.__default.IsCycle(g'#0, path#0)));

// definition axiom for BetreeGraph.__default.NewNodesAreCycleFree for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
    {:weight 3} { BetreeGraph.__default.NewNodesAreCycleFree(Lit(g#0), Lit(g'#0)) } 
    BetreeGraph.__default.NewNodesAreCycleFree#canCall(Lit(g#0), Lit(g'#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node())))
       ==> (forall path#1: Seq Box :: 
          { BetreeGraph.__default.IsCycle(g'#0, path#1) } 
            { Seq#Length(path#1) } 
            { BetreeGraph.__default.IsPath(g'#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> BetreeGraph.__default.IsPath#canCall(Lit(g'#0), path#1)
               && ((forall i#1: int :: 
                  { $Unbox(Seq#Index(path#1, i#1)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#1 && i#1 < Seq#Length(path#1)
                     ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(path#1, i#1)]
                       && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(path#1, i#1)])
                 ==> BetreeGraph.__default.IsCycle#canCall(Lit(g'#0), path#1)))
         && BetreeGraph.__default.NewNodesAreCycleFree(Lit(g#0), Lit(g'#0))
           == (forall path#1: Seq Box :: 
            { BetreeGraph.__default.IsCycle(g'#0, path#1) } 
              { Seq#Length(path#1) } 
              { BetreeGraph.__default.IsPath(g'#0, path#1) } 
            $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              BetreeGraph.__default.IsPath(Lit(g'#0), path#1)
                 && (forall i#1: int :: 
                  { $Unbox(Seq#Index(path#1, i#1)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#1 && i#1 < Seq#Length(path#1)
                     ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(path#1, i#1)]
                       && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(path#1, i#1)])
               ==> !BetreeGraph.__default.IsCycle(Lit(g'#0), path#1)));

// function declaration for BetreeGraph._default.FirstInGraph
function BetreeGraph.__default.FirstInGraph($ly: LayerType, path#0: Seq Box, g#0: IMap Box Box) : int;

function BetreeGraph.__default.FirstInGraph#canCall(path#0: Seq Box, g#0: IMap Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
  { BetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0) } 
  BetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0)
     == BetreeGraph.__default.FirstInGraph($ly, path#0, g#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
  { BetreeGraph.__default.FirstInGraph(AsFuelBottom($ly), path#0, g#0) } 
  BetreeGraph.__default.FirstInGraph($ly, path#0, g#0)
     == BetreeGraph.__default.FirstInGraph($LZ, path#0, g#0));

// consequence axiom for BetreeGraph.__default.FirstInGraph
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    { BetreeGraph.__default.FirstInGraph($ly, path#0, g#0) } 
    BetreeGraph.__default.FirstInGraph#canCall(path#0, g#0)
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && (exists i#0: int :: 
            { $Unbox(Seq#Index(path#0, i#0)): int } 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(path#0)
               && IMap#Domain(g#0)[Seq#Index(path#0, i#0)]))
       ==> LitInt(0) <= BetreeGraph.__default.FirstInGraph($ly, path#0, g#0)
         && BetreeGraph.__default.FirstInGraph($ly, path#0, g#0) < Seq#Length(path#0)
         && IMap#Domain(g#0)[Seq#Index(path#0, BetreeGraph.__default.FirstInGraph($ly, path#0, g#0))]
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(path#0, i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1 && i#1 < BetreeGraph.__default.FirstInGraph($ly, path#0, g#0)
             ==> !IMap#Domain(g#0)[Seq#Index(path#0, i#1)]));

function BetreeGraph.__default.FirstInGraph#requires(LayerType, Seq Box, IMap Box Box) : bool;

// #requires axiom for BetreeGraph.__default.FirstInGraph
axiom (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
  { BetreeGraph.__default.FirstInGraph#requires($ly, path#0, g#0) } 
  $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
     ==> BetreeGraph.__default.FirstInGraph#requires($ly, path#0, g#0)
       == (exists i#2: int :: 
        { $Unbox(Seq#Index(path#0, i#2)): int } 
        LitInt(0) <= i#2
           && i#2 < Seq#Length(path#0)
           && IMap#Domain(g#0)[Seq#Index(path#0, i#2)]));

// definition axiom for BetreeGraph.__default.FirstInGraph(revealed)
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    { BetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0) } 
    BetreeGraph.__default.FirstInGraph#canCall(path#0, g#0)
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && (exists i#2: int :: 
            { $Unbox(Seq#Index(path#0, i#2)): int } 
            LitInt(0) <= i#2
               && i#2 < Seq#Length(path#0)
               && IMap#Domain(g#0)[Seq#Index(path#0, i#2)]))
       ==> (!IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
           ==> BetreeGraph.__default.FirstInGraph#canCall(Seq#Drop(path#0, LitInt(1)), g#0))
         && BetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0)
           == (if IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
             then 0
             else 1 + BetreeGraph.__default.FirstInGraph($ly, Seq#Drop(path#0, LitInt(1)), g#0)));

// definition axiom for BetreeGraph.__default.FirstInGraph for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    {:weight 3} { BetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), g#0) } 
    BetreeGraph.__default.FirstInGraph#canCall(Lit(path#0), g#0)
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && (exists i#3: int :: 
            { $Unbox(Seq#Index(path#0, i#3)): int } 
            LitInt(0) <= i#3
               && i#3 < Seq#Length(Lit(path#0))
               && IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#3)]))
       ==> (!IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
           ==> BetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0))
         && BetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), g#0)
           == (if IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
             then 0
             else 1
               + BetreeGraph.__default.FirstInGraph($LS($ly), Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0)));

// definition axiom for BetreeGraph.__default.FirstInGraph for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    {:weight 3} { BetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), Lit(g#0)) } 
    BetreeGraph.__default.FirstInGraph#canCall(Lit(path#0), Lit(g#0))
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && (exists i#4: int :: 
            { $Unbox(Seq#Index(path#0, i#4)): int } 
            LitInt(0) <= i#4
               && i#4 < Seq#Length(Lit(path#0))
               && IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#4)]))
       ==> (!IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
           ==> BetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0)))
         && BetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), Lit(g#0))
           == (if IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
             then 0
             else 1
               + BetreeGraph.__default.FirstInGraph($LS($ly), Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))));

// function declaration for BetreeGraph._default.UndoLocalEdit
function BetreeGraph.__default.UndoLocalEdit($ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box)
   : Seq Box;

function BetreeGraph.__default.UndoLocalEdit#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
  { BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0) } 
  BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0)
     == BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
  { BetreeGraph.__default.UndoLocalEdit(AsFuelBottom($ly), g#0, g'#0, p#0, path#0) } 
  BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0)
     == BetreeGraph.__default.UndoLocalEdit($LZ, g#0, g'#0, p#0, path#0));

// consequence axiom for BetreeGraph.__default.UndoLocalEdit
axiom true
   ==> (forall $ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    { BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0) } 
    BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, path#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          BetreeGraph.__default.IsClosed(g#0)
           && 1 < Seq#Length(path#0)
           && IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
           && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
           && BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           && BetreeGraph.__default.IsPath(g'#0, path#0))
       ==> BetreeGraph.__default.IsPathFromTo(g#0, 
          BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0), 
          $Unbox(Seq#Index(path#0, LitInt(0))): int, 
          $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int)
         && $Is(BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function BetreeGraph.__default.UndoLocalEdit#requires(LayerType, IMap Box Box, IMap Box Box, int, Seq Box) : bool;

// #requires axiom for BetreeGraph.__default.UndoLocalEdit
axiom (forall $ly: LayerType, 
    $Heap: Heap, 
    g#0: IMap Box Box, 
    g'#0: IMap Box Box, 
    p#0: int, 
    path#0: Seq Box :: 
  { BetreeGraph.__default.UndoLocalEdit#requires($ly, g#0, g'#0, p#0, path#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> BetreeGraph.__default.UndoLocalEdit#requires($ly, g#0, g'#0, p#0, path#0)
       == (
        BetreeGraph.__default.IsClosed(g#0)
         && 1 < Seq#Length(path#0)
         && IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
         && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
         && BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
         && BetreeGraph.__default.IsPath(g'#0, path#0)));

function $let#4_replacement(g: IMap Box Box, path: Seq Box, wit: Seq Box) : Seq Box;

function $let#4$canCall(g: IMap Box Box, path: Seq Box, wit: Seq Box) : bool;

axiom (forall g: IMap Box Box, path: Seq Box, wit: Seq Box :: 
  { $let#4_replacement(g, path, wit) } 
  $let#4$canCall(g, path, wit)
     ==> $Is($let#4_replacement(g, path, wit), TSeq(Tclass.NativeTypes.uint64()))
       && BetreeGraph.__default.IsPathFromTo(g, 
        $let#4_replacement(g, path, wit), 
        $Unbox(Seq#Index(path, LitInt(0))): int, 
        $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), wit)): int));

// definition axiom for BetreeGraph.__default.UndoLocalEdit(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      g#0: IMap Box Box, 
      g'#0: IMap Box Box, 
      p#0: int, 
      path#0: Seq Box :: 
    { BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0), $IsGoodHeap($Heap) } 
    BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, path#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          BetreeGraph.__default.IsClosed(g#0)
           && 1 < Seq#Length(path#0)
           && IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
           && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
           && BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           && BetreeGraph.__default.IsPath(g'#0, path#0))
       ==> ($Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
           ==> BetreeGraph.__default.FirstInGraph#canCall(Seq#Drop(path#0, LitInt(1)), g#0)
             && (var len#0 := 1
                   + BetreeGraph.__default.FirstInGraph($LS($LZ), Seq#Drop(path#0, LitInt(1)), g#0); 
              (var wit#1 := Seq#Take(path#0, len#0 + 1); 
                $let#4$canCall(g#0, path#0, wit#1)
                   && (len#0 < Seq#Length(path#0) - 1
                     ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), $let#4_replacement(g#0, path#0, wit#1))
                       && BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Seq#Drop(path#0, len#0))))))
         && ($Unbox(Seq#Index(path#0, LitInt(0))): int != p#0
           ==> 
          Seq#Length(path#0) != LitInt(2)
           ==> BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Seq#Drop(path#0, LitInt(1))))
         && BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0)
           == (if $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
             then (var len#0 := 1
                   + BetreeGraph.__default.FirstInGraph($LS($LZ), Seq#Drop(path#0, LitInt(1)), g#0); 
              (var wit#1 := Seq#Take(path#0, len#0 + 1); 
                (var replacement#0 := $let#4_replacement(g#0, path#0, wit#1); 
                  (if len#0 < Seq#Length(path#0) - 1
                     then Seq#Append(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), replacement#0), 
                      BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, Seq#Drop(path#0, len#0)))
                     else replacement#0))))
             else (if Seq#Length(path#0) == LitInt(2)
               then path#0
               else Seq#Append(Seq#Take(path#0, LitInt(1)), 
                BetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, Seq#Drop(path#0, LitInt(1)))))));

// definition axiom for BetreeGraph.__default.UndoLocalEdit for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      g#0: IMap Box Box, 
      g'#0: IMap Box Box, 
      p#0: int, 
      path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Lit(path#0)), $IsGoodHeap($Heap) } 
    BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Lit(path#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          BetreeGraph.__default.IsClosed(g#0)
           && 1 < Seq#Length(Lit(path#0))
           && IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
           && IMap#Domain(g#0)[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]
           && BetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           && BetreeGraph.__default.IsPath(g'#0, Lit(path#0)))
       ==> ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == p#0
           ==> BetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0)
             && (var len#1 := 1
                   + BetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0); 
              (var wit#2 := Seq#Take(Lit(path#0), len#1 + 1); 
                $let#4$canCall(g#0, Lit(path#0), wit#2)
                   && (len#1 < Seq#Length(Lit(path#0)) - 1
                     ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), $let#4_replacement(g#0, Lit(path#0), wit#2))
                       && BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Seq#Drop(Lit(path#0), len#1))))))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int != p#0
           ==> 
          Seq#Length(Lit(path#0)) != LitInt(2)
           ==> BetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Lit(Seq#Drop(Lit(path#0), LitInt(1)))))
         && BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Lit(path#0))
           == (if $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == p#0
             then (var len#1 := 1
                   + BetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0); 
              (var wit#2 := Seq#Take(Lit(path#0), len#1 + 1); 
                (var replacement#1 := $let#4_replacement(g#0, Lit(path#0), wit#2); 
                  (if len#1 < Seq#Length(Lit(path#0)) - 1
                     then Seq#Append(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), replacement#1), 
                      BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Seq#Drop(Lit(path#0), len#1)))
                     else replacement#1))))
             else (if Seq#Length(Lit(path#0)) == LitInt(2)
               then path#0
               else Seq#Append(Seq#Take(Lit(path#0), LitInt(1)), 
                BetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Lit(Seq#Drop(Lit(path#0), LitInt(1))))))));

// definition axiom for BetreeGraph.__default.UndoLocalEdit for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      g#0: IMap Box Box, 
      g'#0: IMap Box Box, 
      p#0: int, 
      path#0: Seq Box :: 
    {:weight 3} { BetreeGraph.__default.UndoLocalEdit($LS($ly), Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0)), $IsGoodHeap($Heap) } 
    BetreeGraph.__default.UndoLocalEdit#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.BetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          Lit(BetreeGraph.__default.IsClosed(Lit(g#0)))
           && 1 < Seq#Length(Lit(path#0))
           && Lit(IMap#Domain(Lit(g#0)))[Seq#Index(Lit(path#0), LitInt(0))]
           && Lit(IMap#Domain(Lit(g#0)))[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]
           && Lit(BetreeGraph.__default.EditIsLocal(Lit(g#0), Lit(g'#0), LitInt(p#0)))
           && Lit(BetreeGraph.__default.IsPath(Lit(g'#0), Lit(path#0))))
       ==> ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(p#0)
           ==> BetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))
             && (var len#2 := LitInt(1
                     + BetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))); 
              (var wit#3 := Seq#Take(Lit(path#0), len#2 + 1); 
                $let#4$canCall(Lit(g#0), Lit(path#0), wit#3)
                   && (len#2 < Seq#Length(Lit(path#0)) - 1
                     ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), $let#4_replacement(Lit(g#0), Lit(path#0), wit#3))
                       && BetreeGraph.__default.UndoLocalEdit#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Seq#Drop(Lit(path#0), len#2))))))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int != LitInt(p#0)
           ==> 
          Seq#Length(Lit(path#0)) != LitInt(2)
           ==> BetreeGraph.__default.UndoLocalEdit#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(Seq#Drop(Lit(path#0), LitInt(1)))))
         && BetreeGraph.__default.UndoLocalEdit($LS($ly), Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
           == (if $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(p#0)
             then (var len#2 := LitInt(1
                     + BetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))); 
              (var wit#3 := Lit(Seq#Take(Lit(path#0), LitInt(len#2 + 1))); 
                (var replacement#2 := $let#4_replacement(Lit(g#0), Lit(path#0), wit#3); 
                  (if len#2 < Seq#Length(Lit(path#0)) - 1
                     then Seq#Append(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), replacement#2), 
                      BetreeGraph.__default.UndoLocalEdit($LS($ly), Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(Seq#Drop(Lit(path#0), len#2))))
                     else replacement#2))))
             else (if Seq#Length(Lit(path#0)) == LitInt(2)
               then path#0
               else Seq#Append(Seq#Take(Lit(path#0), LitInt(1)), 
                BetreeGraph.__default.UndoLocalEdit($LS($ly), 
                  Lit(g#0), 
                  Lit(g'#0), 
                  LitInt(p#0), 
                  Lit(Seq#Drop(Lit(path#0), LitInt(1))))))));

// Constructor function declaration
function #BetreeGraph.Op.AllocOp(int, DatatypeType) : DatatypeType;

const unique ##BetreeGraph.Op.AllocOp: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: DatatypeType :: 
  { #BetreeGraph.Op.AllocOp(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#BetreeGraph.Op.AllocOp(a#0#0#0, a#0#1#0))
     == ##BetreeGraph.Op.AllocOp);

function BetreeGraph.Op.AllocOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Op.AllocOp_q(d) } 
  BetreeGraph.Op.AllocOp_q(d) <==> DatatypeCtorId(d) == ##BetreeGraph.Op.AllocOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Op.AllocOp_q(d) } 
  BetreeGraph.Op.AllocOp_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: DatatypeType :: 
      d == #BetreeGraph.Op.AllocOp(a#1#0#0, a#1#1#0)));

function Tclass.BetreeGraph.Op() : Ty;

// Tclass.BetreeGraph.Op Tag
axiom Tag(Tclass.BetreeGraph.Op()) == Tagclass.BetreeGraph.Op;

const unique Tagclass.BetreeGraph.Op: TyTag;

// Box/unbox axiom for Tclass.BetreeGraph.Op
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BetreeGraph.Op()) } 
  $IsBox(bx, Tclass.BetreeGraph.Op())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BetreeGraph.Op()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: DatatypeType :: 
  { $Is(#BetreeGraph.Op.AllocOp(a#2#0#0, a#2#1#0), Tclass.BetreeGraph.Op()) } 
  $Is(#BetreeGraph.Op.AllocOp(a#2#0#0, a#2#1#0), Tclass.BetreeGraph.Op())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.BetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BetreeGraph.Op.AllocOp(a#3#0#0, a#3#1#0), Tclass.BetreeGraph.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BetreeGraph.Op.AllocOp(a#3#0#0, a#3#1#0), Tclass.BetreeGraph.Op(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.BetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.Op.AllocOp_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.Op(), $h)
     ==> $IsAlloc(BetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.Op.node(d), Tclass.BetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.Op.AllocOp_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.Op(), $h)
     ==> $IsAlloc(BetreeGraph.Op.node(d), Tclass.BetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: DatatypeType :: 
  { #BetreeGraph.Op.AllocOp(LitInt(a#4#0#0), Lit(a#4#1#0)) } 
  #BetreeGraph.Op.AllocOp(LitInt(a#4#0#0), Lit(a#4#1#0))
     == Lit(#BetreeGraph.Op.AllocOp(a#4#0#0, a#4#1#0)));

function BetreeGraph.Op.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: DatatypeType :: 
  { #BetreeGraph.Op.AllocOp(a#5#0#0, a#5#1#0) } 
  BetreeGraph.Op.ref(#BetreeGraph.Op.AllocOp(a#5#0#0, a#5#1#0)) == a#5#0#0);

function BetreeGraph.Op.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: DatatypeType :: 
  { #BetreeGraph.Op.AllocOp(a#6#0#0, a#6#1#0) } 
  BetreeGraph.Op.node(#BetreeGraph.Op.AllocOp(a#6#0#0, a#6#1#0)) == a#6#1#0);

// Inductive rank
axiom (forall a#7#0#0: int, a#7#1#0: DatatypeType :: 
  { #BetreeGraph.Op.AllocOp(a#7#0#0, a#7#1#0) } 
  DtRank(a#7#1#0) < DtRank(#BetreeGraph.Op.AllocOp(a#7#0#0, a#7#1#0)));

// Constructor function declaration
function #BetreeGraph.Op.WriteOp(int, DatatypeType) : DatatypeType;

const unique ##BetreeGraph.Op.WriteOp: DtCtorId;

// Constructor identifier
axiom (forall a#8#0#0: int, a#8#1#0: DatatypeType :: 
  { #BetreeGraph.Op.WriteOp(a#8#0#0, a#8#1#0) } 
  DatatypeCtorId(#BetreeGraph.Op.WriteOp(a#8#0#0, a#8#1#0))
     == ##BetreeGraph.Op.WriteOp);

function BetreeGraph.Op.WriteOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Op.WriteOp_q(d) } 
  BetreeGraph.Op.WriteOp_q(d) <==> DatatypeCtorId(d) == ##BetreeGraph.Op.WriteOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Op.WriteOp_q(d) } 
  BetreeGraph.Op.WriteOp_q(d)
     ==> (exists a#9#0#0: int, a#9#1#0: DatatypeType :: 
      d == #BetreeGraph.Op.WriteOp(a#9#0#0, a#9#1#0)));

// Constructor $Is
axiom (forall a#10#0#0: int, a#10#1#0: DatatypeType :: 
  { $Is(#BetreeGraph.Op.WriteOp(a#10#0#0, a#10#1#0), Tclass.BetreeGraph.Op()) } 
  $Is(#BetreeGraph.Op.WriteOp(a#10#0#0, a#10#1#0), Tclass.BetreeGraph.Op())
     <==> $Is(a#10#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#10#1#0, Tclass.BetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#11#0#0: int, a#11#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BetreeGraph.Op.WriteOp(a#11#0#0, a#11#1#0), Tclass.BetreeGraph.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BetreeGraph.Op.WriteOp(a#11#0#0, a#11#1#0), Tclass.BetreeGraph.Op(), $h)
       <==> $IsAlloc(a#11#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#11#1#0, Tclass.BetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.Op.WriteOp_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.Op(), $h)
     ==> $IsAlloc(BetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.Op.node(d), Tclass.BetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.Op.WriteOp_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.Op(), $h)
     ==> $IsAlloc(BetreeGraph.Op.node(d), Tclass.BetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#12#0#0: int, a#12#1#0: DatatypeType :: 
  { #BetreeGraph.Op.WriteOp(LitInt(a#12#0#0), Lit(a#12#1#0)) } 
  #BetreeGraph.Op.WriteOp(LitInt(a#12#0#0), Lit(a#12#1#0))
     == Lit(#BetreeGraph.Op.WriteOp(a#12#0#0, a#12#1#0)));

// Constructor injectivity
axiom (forall a#13#0#0: int, a#13#1#0: DatatypeType :: 
  { #BetreeGraph.Op.WriteOp(a#13#0#0, a#13#1#0) } 
  BetreeGraph.Op.ref(#BetreeGraph.Op.WriteOp(a#13#0#0, a#13#1#0)) == a#13#0#0);

// Constructor injectivity
axiom (forall a#14#0#0: int, a#14#1#0: DatatypeType :: 
  { #BetreeGraph.Op.WriteOp(a#14#0#0, a#14#1#0) } 
  BetreeGraph.Op.node(#BetreeGraph.Op.WriteOp(a#14#0#0, a#14#1#0)) == a#14#1#0);

// Inductive rank
axiom (forall a#15#0#0: int, a#15#1#0: DatatypeType :: 
  { #BetreeGraph.Op.WriteOp(a#15#0#0, a#15#1#0) } 
  DtRank(a#15#1#0) < DtRank(#BetreeGraph.Op.WriteOp(a#15#0#0, a#15#1#0)));

// Depth-one case-split function
function $IsA#BetreeGraph.Op(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BetreeGraph.Op(d) } 
  $IsA#BetreeGraph.Op(d)
     ==> BetreeGraph.Op.AllocOp_q(d) || BetreeGraph.Op.WriteOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BetreeGraph.Op.WriteOp_q(d), $Is(d, Tclass.BetreeGraph.Op()) } 
    { BetreeGraph.Op.AllocOp_q(d), $Is(d, Tclass.BetreeGraph.Op()) } 
  $Is(d, Tclass.BetreeGraph.Op())
     ==> BetreeGraph.Op.AllocOp_q(d) || BetreeGraph.Op.WriteOp_q(d));

// Datatype extensional equality declaration
function BetreeGraph.Op#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BetreeGraph.Op.AllocOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.Op#Equal(a, b), BetreeGraph.Op.AllocOp_q(a) } 
    { BetreeGraph.Op#Equal(a, b), BetreeGraph.Op.AllocOp_q(b) } 
  BetreeGraph.Op.AllocOp_q(a) && BetreeGraph.Op.AllocOp_q(b)
     ==> (BetreeGraph.Op#Equal(a, b)
       <==> BetreeGraph.Op.ref(a) == BetreeGraph.Op.ref(b)
         && BetreeGraph.Node#Equal(BetreeGraph.Op.node(a), BetreeGraph.Op.node(b))));

// Datatype extensional equality definition: #BetreeGraph.Op.WriteOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.Op#Equal(a, b), BetreeGraph.Op.WriteOp_q(a) } 
    { BetreeGraph.Op#Equal(a, b), BetreeGraph.Op.WriteOp_q(b) } 
  BetreeGraph.Op.WriteOp_q(a) && BetreeGraph.Op.WriteOp_q(b)
     ==> (BetreeGraph.Op#Equal(a, b)
       <==> BetreeGraph.Op.ref(a) == BetreeGraph.Op.ref(b)
         && BetreeGraph.Node#Equal(BetreeGraph.Op.node(a), BetreeGraph.Op.node(b))));

// Datatype extensionality axiom: BetreeGraph.Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.Op#Equal(a, b) } 
  BetreeGraph.Op#Equal(a, b) <==> a == b);

const unique class.BetreeGraph.Op: ClassName;

// Constructor function declaration
function #BetreeGraph.ReadOp.ReadOp(int, DatatypeType) : DatatypeType;

const unique ##BetreeGraph.ReadOp.ReadOp: DtCtorId;

// Constructor identifier
axiom (forall a#16#0#0: int, a#16#1#0: DatatypeType :: 
  { #BetreeGraph.ReadOp.ReadOp(a#16#0#0, a#16#1#0) } 
  DatatypeCtorId(#BetreeGraph.ReadOp.ReadOp(a#16#0#0, a#16#1#0))
     == ##BetreeGraph.ReadOp.ReadOp);

function BetreeGraph.ReadOp.ReadOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BetreeGraph.ReadOp.ReadOp_q(d) } 
  BetreeGraph.ReadOp.ReadOp_q(d)
     <==> DatatypeCtorId(d) == ##BetreeGraph.ReadOp.ReadOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BetreeGraph.ReadOp.ReadOp_q(d) } 
  BetreeGraph.ReadOp.ReadOp_q(d)
     ==> (exists a#17#0#0: int, a#17#1#0: DatatypeType :: 
      d == #BetreeGraph.ReadOp.ReadOp(a#17#0#0, a#17#1#0)));

function Tclass.BetreeGraph.ReadOp() : Ty;

// Tclass.BetreeGraph.ReadOp Tag
axiom Tag(Tclass.BetreeGraph.ReadOp()) == Tagclass.BetreeGraph.ReadOp;

const unique Tagclass.BetreeGraph.ReadOp: TyTag;

// Box/unbox axiom for Tclass.BetreeGraph.ReadOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BetreeGraph.ReadOp()) } 
  $IsBox(bx, Tclass.BetreeGraph.ReadOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BetreeGraph.ReadOp()));

// Constructor $Is
axiom (forall a#18#0#0: int, a#18#1#0: DatatypeType :: 
  { $Is(#BetreeGraph.ReadOp.ReadOp(a#18#0#0, a#18#1#0), Tclass.BetreeGraph.ReadOp()) } 
  $Is(#BetreeGraph.ReadOp.ReadOp(a#18#0#0, a#18#1#0), Tclass.BetreeGraph.ReadOp())
     <==> $Is(a#18#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#18#1#0, Tclass.BetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#19#0#0: int, a#19#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BetreeGraph.ReadOp.ReadOp(a#19#0#0, a#19#1#0), Tclass.BetreeGraph.ReadOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BetreeGraph.ReadOp.ReadOp(a#19#0#0, a#19#1#0), Tclass.BetreeGraph.ReadOp(), $h)
       <==> $IsAlloc(a#19#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#19#1#0, Tclass.BetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.ReadOp.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.ReadOp.ReadOp_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.ReadOp(), $h)
     ==> $IsAlloc(BetreeGraph.ReadOp.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BetreeGraph.ReadOp.node(d), Tclass.BetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      BetreeGraph.ReadOp.ReadOp_q(d)
       && $IsAlloc(d, Tclass.BetreeGraph.ReadOp(), $h)
     ==> $IsAlloc(BetreeGraph.ReadOp.node(d), Tclass.BetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#20#0#0: int, a#20#1#0: DatatypeType :: 
  { #BetreeGraph.ReadOp.ReadOp(LitInt(a#20#0#0), Lit(a#20#1#0)) } 
  #BetreeGraph.ReadOp.ReadOp(LitInt(a#20#0#0), Lit(a#20#1#0))
     == Lit(#BetreeGraph.ReadOp.ReadOp(a#20#0#0, a#20#1#0)));

function BetreeGraph.ReadOp.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#21#0#0: int, a#21#1#0: DatatypeType :: 
  { #BetreeGraph.ReadOp.ReadOp(a#21#0#0, a#21#1#0) } 
  BetreeGraph.ReadOp.ref(#BetreeGraph.ReadOp.ReadOp(a#21#0#0, a#21#1#0))
     == a#21#0#0);

function BetreeGraph.ReadOp.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#22#0#0: int, a#22#1#0: DatatypeType :: 
  { #BetreeGraph.ReadOp.ReadOp(a#22#0#0, a#22#1#0) } 
  BetreeGraph.ReadOp.node(#BetreeGraph.ReadOp.ReadOp(a#22#0#0, a#22#1#0))
     == a#22#1#0);

// Inductive rank
axiom (forall a#23#0#0: int, a#23#1#0: DatatypeType :: 
  { #BetreeGraph.ReadOp.ReadOp(a#23#0#0, a#23#1#0) } 
  DtRank(a#23#1#0) < DtRank(#BetreeGraph.ReadOp.ReadOp(a#23#0#0, a#23#1#0)));

// Depth-one case-split function
function $IsA#BetreeGraph.ReadOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BetreeGraph.ReadOp(d) } 
  $IsA#BetreeGraph.ReadOp(d) ==> BetreeGraph.ReadOp.ReadOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BetreeGraph.ReadOp.ReadOp_q(d), $Is(d, Tclass.BetreeGraph.ReadOp()) } 
  $Is(d, Tclass.BetreeGraph.ReadOp()) ==> BetreeGraph.ReadOp.ReadOp_q(d));

// Datatype extensional equality declaration
function BetreeGraph.ReadOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BetreeGraph.ReadOp.ReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.ReadOp#Equal(a, b) } 
  true
     ==> (BetreeGraph.ReadOp#Equal(a, b)
       <==> BetreeGraph.ReadOp.ref(a) == BetreeGraph.ReadOp.ref(b)
         && BetreeGraph.Node#Equal(BetreeGraph.ReadOp.node(a), BetreeGraph.ReadOp.node(b))));

// Datatype extensionality axiom: BetreeGraph.ReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BetreeGraph.ReadOp#Equal(a, b) } 
  BetreeGraph.ReadOp#Equal(a, b) <==> a == b);

const unique class.BetreeGraph.ReadOp: ClassName;

const unique class.NativeArrays.__default: ClassName;

function Tclass.NativeArrays.__default() : Ty;

// Tclass.NativeArrays.__default Tag
axiom Tag(Tclass.NativeArrays.__default()) == Tagclass.NativeArrays.__default;

const unique Tagclass.NativeArrays.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArrays.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArrays.__default()) } 
  $IsBox(bx, Tclass.NativeArrays.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArrays.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArrays.__default()) } 
  $Is($o, Tclass.NativeArrays.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArrays.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArrays.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArrays.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique class.Byte__Order.__default: ClassName;

function Tclass.Byte__Order.__default() : Ty;

// Tclass.Byte__Order.__default Tag
axiom Tag(Tclass.Byte__Order.__default()) == Tagclass.Byte__Order.__default;

const unique Tagclass.Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Byte__Order.__default()) } 
  $Is($o, Tclass.Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Byte_Order._default.SomeElement
function Byte__Order.__default.SomeElement() : int;

function Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Byte__Order.__default.SomeElement()
     && Byte__Order.__default.SomeElement() < 256;

function Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Byte__Order.__default.SomeElement
axiom Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Byte__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Byte__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Byte__Order.__default.SomeElement() == LitInt(0);

// function declaration for Byte_Order._default.lte
function Byte__Order.__default.lte($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
  Byte__Order.__default.lte($LS($ly), a#0, b#0)
     == Byte__Order.__default.lte($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.lte($ly, a#0, b#0)
     == Byte__Order.__default.lte($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.lte
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($ly, a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (forall a#1: int, b#1: int, c#0: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, c#0), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#1, c#0) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#1, c#0), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, b#1) } 
          LitInt(0) <= a#1
               && a#1 < 256
               && 
              LitInt(0) <= b#1
               && b#1 < 256
               && 
              LitInt(0) <= c#0
               && c#0 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, b#1)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#1, c#0)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#1, c#0))
         && Byte__Order.__default.lte($ly, a#0, b#0)
           == Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
           || Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0))
         && (Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#0, b#0)
             && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#2: int, b#2: int, c#1: int :: 
          { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, c#1), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#2, c#1) } 
            { Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#2, c#1), Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, b#2) } 
          LitInt(0) <= a#2
               && a#2 < 256
               && 
              LitInt(0) <= b#2
               && b#2 < 256
               && 
              LitInt(0) <= c#1
               && c#1 < 256
             ==> 
            Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, b#2)
               && Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, b#2, c#1)
             ==> Byte__Order.__default.ltedef(StartFuel_Byte_Order._default.ltedef, a#2, c#1)));

function Byte__Order.__default.lte#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.lte
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.lte#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lte#requires($ly, a#0, b#0) == true);

const MoreFuel_Byte_Order._default.ltedef0: LayerType;

// definition axiom for Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.lte($LS($ly), a#0, b#0) } 
    Byte__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef0)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef0))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef0)
           == MoreFuel_Byte_Order._default.ltedef0
         && Byte__Order.__default.lte($LS($ly), a#0, b#0) == (a#0 <= b#0));

const MoreFuel_Byte_Order._default.ltedef1: LayerType;

// definition axiom for Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> StartFuel_Byte_Order._default.ltedef
           == $LS(MoreFuel_Byte_Order._default.ltedef1)
         && StartFuelAssert_Byte_Order._default.ltedef
           == $LS($LS(MoreFuel_Byte_Order._default.ltedef1))
         && AsFuelBottom(MoreFuel_Byte_Order._default.ltedef1)
           == MoreFuel_Byte_Order._default.ltedef1
         && Byte__Order.__default.lte($LS($ly), LitInt(a#0), LitInt(b#0))
           == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.ltedef
function Byte__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Byte__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Byte__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Byte__Order.__default.ltedef($ly, a#0, b#0)
     == Byte__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Byte__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($ly, a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Byte__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Byte__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Byte__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Byte_Order._default.LargestLte
function Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted0: LayerType;

// definition axiom for Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted0)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted0)
           == MoreFuel_Byte_Order._default.IsSorted0
         && Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted1: LayerType;

// definition axiom for Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted1)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted1)
           == MoreFuel_Byte_Order._default.IsSorted1
         && Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.LargestLt
function Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Byte__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0 && i#0 <= Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted2: LayerType;

// definition axiom for Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              needle#0, 
              $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted2)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted2)
           == MoreFuel_Byte_Order._default.IsSorted2
         && Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                needle#0, 
                $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Byte_Order._default.IsSorted3: LayerType;

// definition axiom for Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Byte__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(needle#0), 
              $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted3)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted3)
           == MoreFuel_Byte_Order._default.IsSorted3
         && Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt(needle#0), 
                $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Byte_Order._default.IndexOfFirstGte
function Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted4: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted4)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted4)
           == MoreFuel_Byte_Order._default.IsSorted4
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted5: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted5)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted5)
           == MoreFuel_Byte_Order._default.IsSorted5
         && Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              key#0, 
              $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              LitInt(key#0), 
              $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lt($Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.IndexOfFirstGt
function Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 256
     ==> Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Byte_Order._default.IsSorted6: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), run#0)
             && Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
              needle#0)
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), run#0)
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0)))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted6)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted6)
           == MoreFuel_Byte_Order._default.IsSorted6
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Byte__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.byte(), run#0), needle#0))));

const MoreFuel_Byte_Order._default.IsSorted7: LayerType;

// definition axiom for Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 256
           && Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
             && Byte__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.byte(), Lit(run#0))
                 && Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Byte_Order._default.IsSorted7)
         && StartFuelAssert_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Byte_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Byte_Order._default.IsSorted7)
           == MoreFuel_Byte_Order._default.IsSorted7
         && Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.byte(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.byte(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, 
              key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, $Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, 
                  key#0)
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
              $Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, 
              LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Byte__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, 
                  LitInt(key#0))
                 ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                  $Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, 
                  LitInt(key#0))
                 then Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> LitInt(0)
           <= Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Byte_Order._default.SetAllLte
function Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#0: int, y#0: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#0, y#0) } 
            { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
             ==> 
            b#0[$Box(y#0)]
             ==> Byte__Order.__default.lte#canCall(x#0, y#0))
         && Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#0, y#0) } 
              { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#0, y#0)));

// definition axiom for Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#1: int, y#1: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#1, y#1) } 
            { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Byte__Order.__default.lte#canCall(x#1, y#1))
         && Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#1, y#1) } 
              { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, x#1, y#1)));

// function declaration for Byte_Order._default.SetAllLt
function Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> true);

function Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#0: int, y#0: int :: 
          { Byte__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
             ==> 
            b#0[$Box(y#0)]
             ==> Byte__Order.__default.lt#canCall(x#0, y#0))
         && Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Byte__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 256 && LitInt(0) <= y#0 && y#0 < 256
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Byte__Order.__default.lt(x#0, y#0)));

// definition axiom for Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSet(Tclass.NativeTypes.byte())))
       ==> (forall x#1: int, y#1: int :: 
          { Byte__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Byte__Order.__default.lt#canCall(x#1, y#1))
         && Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Byte__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 256 && LitInt(0) <= y#1 && y#1 < 256
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Byte__Order.__default.lt(x#1, y#1)));

// function declaration for Byte_Order._default.NotMinimum
function Byte__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Byte__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Byte__Order.__default.NotMinimum($ly, a#0)
     == Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($ly, a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> true);

function Byte__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 256
     ==> Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Byte__Order.__default.NotMinimum#canCall(a#0) || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#0: int :: 
          { Byte__Order.__default.lt(b#0, a#0) } 
          LitInt(0) <= b#0 && b#0 < 256 ==> Byte__Order.__default.lt#canCall(b#0, a#0))
         && Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: int :: 
            { Byte__Order.__default.lt(b#0, a#0) } 
            LitInt(0) <= b#0 && b#0 < 256 && Byte__Order.__default.lt(b#0, a#0)));

// definition axiom for Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Byte__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 256)
       ==> (forall b#1: int :: 
          { Byte__Order.__default.lt(b#1, a#0) } 
          LitInt(0) <= b#1 && b#1 < 256
             ==> Byte__Order.__default.lt#canCall(b#1, LitInt(a#0)))
         && Byte__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#1: int :: 
            { Byte__Order.__default.lt(b#1, a#0) } 
            LitInt(0) <= b#1 && b#1 < 256 && Byte__Order.__default.lt(b#1, LitInt(a#0))));

// function declaration for Byte_Order._default.MapPivotedUnion
function Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)));

function Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.MapPivotedUnion
axiom (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 256
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
     ==> Byte__Order.__default.MapPivotedUnion#requires(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: int :: 
          { Byte__Order.__default.lt(k#0, pivot#0) } 
          LitInt(0) <= k#0 && k#0 < 256 ==> Byte__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#0): int, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#3): int, pivot#0))); 
          (forall k#1: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#1) } 
              LitInt(0) <= k#1 && k#1 < 256
                 ==> Byte__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#1): int)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#2): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#4): int, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, $Unbox($y#5): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Byte__Order.__default.MapPivotedUnion#canCall(Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 256
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: int :: 
          { Byte__Order.__default.lt(k#2, pivot#0) } 
          LitInt(0) <= k#2 && k#2 < 256
             ==> Byte__Order.__default.lt#canCall(k#2, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
          Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.byte())
               && Byte__Order.__default.lt($Unbox($y#6): int, LitInt(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lt($Unbox($y#9): int, LitInt(pivot#0)))); 
          (forall k#3: int :: 
              { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, pivot#0, k#3) } 
              LitInt(0) <= k#3 && k#3 < 256
                 ==> Byte__Order.__default.lte#canCall(LitInt(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.byte(), 
              Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, Tclass.NativeTypes.byte())
                   && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#7): int)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#8): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Byte__Order.__default.MapPivotedUnion(Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, Tclass.NativeTypes.byte())
                     && Byte__Order.__default.lt($Unbox($y#10): int, LitInt(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, Tclass.NativeTypes.byte())
                       && Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(pivot#0), $Unbox($y#11): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.byte(), 
                Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Byte_Order._default.SetSuccessor
function Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#8_next(m: Set Box, key: int) : int;

function $let#8$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#8_next(m, key) } 
  $let#8$canCall(m, key)
     ==> LitInt(0) <= $let#8_next(m, key)
       && $let#8_next(m, key) < 256
       && 
      m[$Box($let#8_next(m, key))]
       && Byte__Order.__default.lt(key, $let#8_next(m, key))
       && (forall other#1: int :: 
        { Byte__Order.__default.lt($let#8_next(m, key), other#1) } 
          { Byte__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        LitInt(0) <= other#1 && other#1 < 256
           ==> 
          m[$Box(other#1)]
             && other#1 != $let#8_next(m, key)
             && Byte__Order.__default.lt(key, other#1)
           ==> Byte__Order.__default.lt($let#8_next(m, key), other#1)));

// definition axiom for Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#0: int :: 
          { Byte__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
          LitInt(0) <= next#0 && next#0 < 256
             ==> (m#0[$Box(next#0)] ==> Byte__Order.__default.lt#canCall(key#0, next#0))
               && (Byte__Order.__default.lt#canCall(key#0, next#0)
                   && Byte__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: int :: 
                  { Byte__Order.__default.lt(next#0, other#0) } 
                    { Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 256
                     ==> (other#0 != next#0 ==> Byte__Order.__default.lt#canCall(key#0, other#0))
                       && (Byte__Order.__default.lt#canCall(key#0, other#0)
                           && Byte__Order.__default.lt(key#0, other#0)
                         ==> Byte__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: int :: 
            { Byte__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
            LitInt(0) <= next#0
               && next#0 < 256
               && 
              m#0[$Box(next#0)]
               && Byte__Order.__default.lt(key#0, next#0)
               && (forall other#0: int :: 
                { Byte__Order.__default.lt(next#0, other#0) } 
                  { Byte__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                LitInt(0) <= other#0 && other#0 < 256
                   ==> 
                  m#0[$Box(other#0)]
                     && other#0 != next#0
                     && Byte__Order.__default.lt(key#0, other#0)
                   ==> Byte__Order.__default.lt(next#0, other#0)))
           ==> $let#8$canCall(m#0, key#0))
         && Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: int :: 
              { Byte__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
              LitInt(0) <= next#0
                 && next#0 < 256
                 && 
                m#0[$Box(next#0)]
                 && Byte__Order.__default.lt(key#0, next#0)
                 && (forall other#0: int :: 
                  { Byte__Order.__default.lt(next#0, other#0) } 
                    { Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 256
                     ==> 
                    m#0[$Box(other#0)]
                       && other#0 != next#0
                       && Byte__Order.__default.lt(key#0, other#0)
                     ==> Byte__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#8_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> (forall next#2: int :: 
          { Byte__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
          LitInt(0) <= next#2 && next#2 < 256
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), next#2))
               && (Byte__Order.__default.lt#canCall(LitInt(key#0), next#2)
                   && Byte__Order.__default.lt(LitInt(key#0), next#2)
                 ==> (forall other#2: int :: 
                  { Byte__Order.__default.lt(next#2, other#2) } 
                    { Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 256
                     ==> (other#2 != next#2 ==> Byte__Order.__default.lt#canCall(LitInt(key#0), other#2))
                       && (Byte__Order.__default.lt#canCall(LitInt(key#0), other#2)
                           && Byte__Order.__default.lt(LitInt(key#0), other#2)
                         ==> Byte__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: int :: 
            { Byte__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
            LitInt(0) <= next#2
               && next#2 < 256
               && 
              Lit(m#0)[$Box(next#2)]
               && Byte__Order.__default.lt(LitInt(key#0), next#2)
               && (forall other#2: int :: 
                { Byte__Order.__default.lt(next#2, other#2) } 
                  { Byte__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                LitInt(0) <= other#2 && other#2 < 256
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && other#2 != next#2
                     && Byte__Order.__default.lt(LitInt(key#0), other#2)
                   ==> Byte__Order.__default.lt(next#2, other#2)))
           ==> $let#8$canCall(Lit(m#0), LitInt(key#0)))
         && Byte__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#2: int :: 
              { Byte__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
              LitInt(0) <= next#2
                 && next#2 < 256
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Byte__Order.__default.lt(LitInt(key#0), next#2)
                 && (forall other#2: int :: 
                  { Byte__Order.__default.lt(next#2, other#2) } 
                    { Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 256
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && other#2 != next#2
                       && Byte__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Byte__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#8_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Byte_Order._default.MapSuccessor
function Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> $Is(Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Byte__Order.__default.MapSuccessor
axiom (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 256
     ==> Byte__Order.__default.MapSuccessor#requires(Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.MapSuccessor#canCall(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Byte__Order.__default.MapSuccessor(Byte_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Byte_Order._default.SeqSuccessor
function Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> $Is(Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256
     ==> Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Byte__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.byte())) && LitInt(0) <= key#0 && key#0 < 256)
       ==> Byte__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#2)), 
          LitInt(key#0))
         && Byte__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Byte__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, Tclass.NativeTypes.byte()) && Seq#Contains(m#0, $y#3)), 
            LitInt(key#0)));

// function declaration for Byte_Order._default.SortedSeqForMap
function Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Byte__Order.__default.SortedSeqForMap
axiom (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V))
     ==> Byte__Order.__default.SortedSeqForMap#requires(Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: int :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                         == key#0
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: int :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                       == key#0
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Byte__Order.__default.SortedSeqForMap#canCall(Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.byte(), Byte_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
            Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                  Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: int :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 256
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                         == key#1
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Byte__Order.__default.SortedSeqForMap(Byte_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Byte__Order.__default.IsStrictlySorted(StartFuel_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.byte(), 
                    Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: int :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 256
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                       == key#1
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Byte_Order._default.minimum
function Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum($LS($ly), s#0) } 
  Byte__Order.__default.minimum($LS($ly), s#0)
     == Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimum($ly, s#0)
     == Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimum($ly, s#0) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#0: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, Byte__Order.__default.minimum($ly, s#0), y#0))
         && 
        LitInt(0) <= Byte__Order.__default.minimum($ly, s#0)
         && Byte__Order.__default.minimum($ly, s#0) < 256);

function Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#11_a(s: Set Box) : int;

function $let#11$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#11_a(s) } 
  $let#11$canCall(s)
     ==> LitInt(0) <= $let#11_a(s) && $let#11_a(s) < 256 && s[$Box($let#11_a(s))]);

// definition axiom for Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#11$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#11_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Byte__Order.__default.minimum($ly, s'#0); 
                Byte__Order.__default.lt#canCall($let#11_a(s#0), m'#0)))
         && Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#11_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Byte__Order.__default.minimum($ly, s'#1); 
                  (if Byte__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#11$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#11_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Byte__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Byte__Order.__default.minimum($LS($ly), s'#2); 
                Byte__Order.__default.lt#canCall($let#11_a(Lit(s#0)), m'#2)))
         && Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#11_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Byte__Order.__default.minimum($LS($ly), s'#3); 
                  (if Byte__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Byte_Order._default.minimumOpt
function Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.minimumOpt($ly, s#0)
     == Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($ly, s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Options.Option.value(Byte__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0)))
         && (Options.Option.None_q(Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(s#0))
         && Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, s#0)))));

// definition axiom for Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.minimum(StartFuel_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Byte_Order._default.maximum
function Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum($LS($ly), s#0) } 
  Byte__Order.__default.maximum($LS($ly), s#0)
     == Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximum($ly, s#0)
     == Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximum($ly, s#0) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.byte())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#0: int :: 
          { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#0, Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
             ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, y#0, Byte__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Byte__Order.__default.maximum($ly, s#0)
         && Byte__Order.__default.maximum($ly, s#0) < 256);

function Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximum#requires($ly, s#0) == (Set#Card(s#0) >= LitInt(1)));

function $let#14_a(s: Set Box) : int;

function $let#14$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#14_a(s) } 
  $let#14$canCall(s)
     ==> LitInt(0) <= $let#14_a(s) && $let#14_a(s) < 256 && s[$Box($let#14_a(s))]);

// definition axiom for Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#14$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#14_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Byte__Order.__default.maximum($ly, s'#0); 
                Byte__Order.__default.lt#canCall(m'#0, $let#14_a(s#0))))
         && Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#14_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Byte__Order.__default.maximum($ly, s'#1); 
                  (if Byte__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.byte()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#14$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#14_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Byte__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Byte__Order.__default.maximum($LS($ly), s'#2); 
                Byte__Order.__default.lt#canCall(m'#2, $let#14_a(Lit(s#0)))))
         && Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#14_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Byte__Order.__default.maximum($LS($ly), s'#3); 
                  (if Byte__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Byte_Order._default.maximumOpt
function Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Byte__Order.__default.maximumOpt($ly, s#0)
     == Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($ly, s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#0, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 256 && s#0[$Box(y#0)]
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                y#0, 
                $Unbox(Options.Option.value(Byte__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.byte())));

function Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(s#0))
         && Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, s#0)))));

// definition axiom for Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.byte()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Byte__Order.__default.maximum(StartFuel_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Byte_Order._default.lt
function Byte__Order.__default.lt(a#0: int, b#0: int) : bool;

function Byte__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> true);

function Byte__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.lt(a#0, b#0) } 
    Byte__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.lt(a#0, b#0)
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             && a#0 != b#0));

// definition axiom for Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == (Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             && a#0 != b#0));

// function declaration for Byte_Order._default.Min
function Byte__Order.__default.Min(a#0: int, b#0: int) : int;

function Byte__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Min(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0) < 256);

function Byte__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Min(a#0, b#0) } 
    Byte__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Min(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then a#0
             else b#0));

// definition axiom for Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then a#0
             else b#0));

// function declaration for Byte_Order._default.Max
function Byte__Order.__default.Max(a#0: int, b#0: int) : int;

function Byte__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Byte__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> LitInt(0) <= Byte__Order.__default.Max(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0) < 256);

function Byte__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Byte__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Byte__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256
     ==> Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Byte__Order.__default.Max(a#0, b#0) } 
    Byte__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(a#0, b#0)
         && Byte__Order.__default.Max(a#0, b#0)
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, a#0, b#0)
             then b#0
             else a#0));

// definition axiom for Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Byte__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 256 && LitInt(0) <= b#0 && b#0 < 256)
       ==> Byte__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Byte__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, LitInt(a#0), LitInt(b#0))
             then b#0
             else a#0));

// function declaration for Byte_Order._default.IsSorted
function Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsSorted($ly, run#0)
     == Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($ly, run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0) ==> Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1) ==> Byte__Order.__default.IsSorted($ly, run#0)));

function Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(run#0, i#0)): int, 
                $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lte(StartFuel_Byte_Order._default.lte, 
                $Unbox(Seq#Index(Lit(run#0), i#1)): int, 
                $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Byte_Order._default.IsStrictlySortedInternal
function Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Byte_Order._default.IsStrictlySorted
function Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Byte__Order.__default.IsSorted(StartFuel_Byte_Order._default.IsSorted, run#0)));

function Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

const unique class.Lexicographic__Byte__Order.__default: ClassName;

function Tclass.Lexicographic__Byte__Order.__default() : Ty;

// Tclass.Lexicographic__Byte__Order.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order.__default())
   == Tagclass.Lexicographic__Byte__Order.__default;

const unique Tagclass.Lexicographic__Byte__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Lexicographic_Byte_Order._default.SomeElement
function Lexicographic__Byte__Order.__default.SomeElement() : Seq Box;

function Lexicographic__Byte__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> $Is(Lexicographic__Byte__Order.__default.SomeElement(), 
    TSeq(Tclass.NativeTypes.byte()));

function Lexicographic__Byte__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SomeElement
axiom Lexicographic__Byte__Order.__default.SomeElement#requires() == true;

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// definition axiom for Lexicographic__Byte__Order.__default.SomeElement for all literals(revealed)
axiom true
   ==> 
  true
   ==> Lexicographic__Byte__Order.__default.SomeElement() == Lit(Seq#Empty(): Seq Box);

// function declaration for Lexicographic_Byte_Order._default.lte
function Lexicographic__Byte__Order.__default.lte(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lte#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lte
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (forall a#1: Seq Box, b#1: Seq Box, c#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#1, c#0), Lexicographic__Byte__Order.__default.ltedef(b#1, c#0) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#1, c#0), Lexicographic__Byte__Order.__default.ltedef(a#1, b#1) } 
          $Is(a#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#1, b#1)
               && Lexicographic__Byte__Order.__default.ltedef(b#1, c#0)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#1, c#0))
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           || Lexicographic__Byte__Order.__default.ltedef(b#0, a#0))
         && (Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
             && Lexicographic__Byte__Order.__default.ltedef(b#0, a#0)
           ==> Seq#Equal(a#0, b#0))
         && (forall a#2: Seq Box, b#2: Seq Box, c#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.ltedef(a#2, c#1), Lexicographic__Byte__Order.__default.ltedef(b#2, c#1) } 
            { Lexicographic__Byte__Order.__default.ltedef(b#2, c#1), Lexicographic__Byte__Order.__default.ltedef(a#2, b#2) } 
          $Is(a#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(b#2, TSeq(Tclass.NativeTypes.byte()))
               && $Is(c#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lexicographic__Byte__Order.__default.ltedef(a#2, b#2)
               && Lexicographic__Byte__Order.__default.ltedef(b#2, c#1)
             ==> Lexicographic__Byte__Order.__default.ltedef(a#2, c#1)));

function Lexicographic__Byte__Order.__default.lte#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lte
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lte(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.ltedef
function Lexicographic__Byte__Order.__default.ltedef(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.ltedef#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.ltedef
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.ltedef#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.ltedef
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.ltedef#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.ltedef(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.ltedef(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.ltedef(a#0, b#0)
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, a#0, b#0));

// definition axiom for Lexicographic__Byte__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.ltedef#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> SeqComparison.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.ltedef(Lit(a#0), Lit(b#0))
           == SeqComparison.__default.lte(StartFuel_SeqComparison._default.lte, Lit(a#0), Lit(b#0)));

// function declaration for Lexicographic_Byte_Order._default.LargestLte
function Lexicographic__Byte__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0)
               <= Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLte($ly, run#0, needle#0))): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted0: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted0)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted0)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted0
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted1: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted1)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted1)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted1
         && Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lt(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

// function declaration for Lexicographic_Byte_Order._default.LargestLt
function Lexicographic__Byte__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1)
           <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
         && Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
           < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          true
             ==> 
            Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1
               < Seq#Length(run#0)
             && Seq#Equal($Unbox(Seq#Index(run#0, Lexicographic__Byte__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): Seq Box, 
              needle#0)));

function Lexicographic__Byte__Order.__default.LargestLt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted2: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted2)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted2)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted2
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted3: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box))
           ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted3)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted3)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted3
         && Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Lexicographic__Byte__Order.__default.lte(Lit(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): Seq Box)
             then 0 - 1
             else 1
               + Lexicographic__Byte__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), Lit(needle#0))));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGte
function Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
                 <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted4: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted4)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted4)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted4
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted5: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted5)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted5)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted5
         && Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGteIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lte(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGte
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.IndexOfFirstGt
function Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Lexicographic__Byte__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): Seq Box))
         && LitInt(0)
           <= Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted6: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
             && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
              needle#0)
             && (!Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), run#0)
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), needle#0)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted6)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted6)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted6
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), run#0)): Seq Box, 
                needle#0)
               then Seq#Length(run#0)
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($ly, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), run#0), 
                needle#0))));

const MoreFuel_Lexicographic_Byte_Order._default.IsSorted7: LayerType;

// definition axiom for Lexicographic__Byte__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0)) } 
    Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), Lit(needle#0))
         || (
          $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(needle#0, TSeq(Tclass.NativeTypes.byte()))
           && Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
             && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
              Lit(needle#0))
             && (!Lit(Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                  Lit(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))
                 && Lexicographic__Byte__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                  Lit(needle#0))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsSorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted7)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsSorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsSorted7)
           == MoreFuel_Lexicographic_Byte_Order._default.IsSorted7
         && Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), Lit(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))): Seq Box), 
                Lit(needle#0))
               then Seq#Length(Lit(run#0))
               else Lexicographic__Byte__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(run#0))), 
                Lit(needle#0)))));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGtIter
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box))));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): Seq Box, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): Seq Box)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): Seq Box, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): Seq Box, key#0)
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): Seq Box, key#0)
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box, lo#0: int, hi#0: int :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): Seq Box, Lit(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): Seq Box)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
               && (Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0)))
               && (!Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): Seq Box, Lit(key#0))
                 ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2))))
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): Seq Box, Lit(key#0))
                 then Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), mid#2, LitInt(hi#0))
                 else Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), Lit(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Lexicographic_Byte_Order._default.binarySearchIndexOfFirstKeyGt
function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: Seq Box) : int;

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> LitInt(0)
           <= Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             > 0
           ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
                   - 1)): Seq Box, 
            key#0))
         && (Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Lexicographic__Byte__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): Seq Box)));

function Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), Lit(key#0))
         || ($Is(s#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), Lit(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Lexicographic_Byte_Order._default.SetAllLte
function Lexicographic__Byte__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#0: Seq Box, y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#0, y#0) } 
            { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#0, y#0))
         && Lexicographic__Byte__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: Seq Box, y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#0, y#0) } 
              { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lte(x#0, y#0)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#1: Seq Box, y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(x#1, y#1) } 
            { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lte#canCall(x#1, y#1))
         && Lexicographic__Byte__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: Seq Box, y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(x#1, y#1) } 
              { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lte(x#1, y#1)));

// function declaration for Lexicographic_Byte_Order._default.SetAllLt
function Lexicographic__Byte__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> true);

function Lexicographic__Byte__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#0: Seq Box, y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#0, y#0) } 
            { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            b#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#0, y#0))
         && Lexicographic__Byte__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: Seq Box, y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#0, y#0) } 
              { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            $Is(x#0, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lt(x#0, y#0)));

// definition axiom for Lexicographic__Byte__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(b#0, TSet(TSeq(Tclass.NativeTypes.byte()))))
       ==> (forall x#1: Seq Box, y#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(x#1, y#1) } 
            { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
               && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Lexicographic__Byte__Order.__default.lt#canCall(x#1, y#1))
         && Lexicographic__Byte__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: Seq Box, y#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(x#1, y#1) } 
              { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            $Is(x#1, TSeq(Tclass.NativeTypes.byte()))
                 && $Is(y#1, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Lexicographic__Byte__Order.__default.lt(x#1, y#1)));

// function declaration for Lexicographic_Byte_Order._default.NotMinimum
function Lexicographic__Byte__Order.__default.NotMinimum($ly: LayerType, a#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0)
     == Lexicographic__Byte__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($ly, a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function Lexicographic__Byte__Order.__default.NotMinimum#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#0, a#0) } 
          $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#0, a#0))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#0, a#0) } 
            $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#0, a#0)));

// definition axiom for Lexicographic__Byte__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0)) } 
    Lexicographic__Byte__Order.__default.NotMinimum#canCall(Lit(a#0))
         || $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (forall b#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(b#1, a#0) } 
          $Is(b#1, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(b#1, Lit(a#0)))
         && Lexicographic__Byte__Order.__default.NotMinimum($LS($ly), Lit(a#0))
           == (exists b#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(b#1, a#0) } 
            $Is(b#1, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt(b#1, Lit(a#0))));

// function declaration for Lexicographic_Byte_Order._default.MapPivotedUnion
function Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : Map Box Box;

function Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0), 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value)));

function Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion
axiom (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: Seq Box, 
    right#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
      left#0, 
      pivot#0, 
      right#0) } 
  $Is(left#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
       && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(right#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
     ==> Lexicographic__Byte__Order.__default.MapPivotedUnion#requires(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        left#0, 
        pivot#0, 
        right#0) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          pivot#0, 
          right#0)
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#0, pivot#0) } 
          $Is(k#0, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#0): Seq Box, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#3): Seq Box, pivot#0))); 
          (forall k#1: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#1) } 
              $Is(k#1, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#1): Seq Box)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#2): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            left#0, 
            pivot#0, 
            right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#4): Seq Box, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#5): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Lexicographic__Byte__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: Seq Box, 
      right#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        Lit(pivot#0), 
        Lit(right#0)) } 
    Lexicographic__Byte__Order.__default.MapPivotedUnion#canCall(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          Lit(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value))
           && $Is(pivot#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(right#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#2, pivot#0) } 
          $Is(k#2, TSeq(Tclass.NativeTypes.byte()))
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#2, Lit(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, TSeq(Tclass.NativeTypes.byte()))
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#6): Seq Box, Lit(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lt($Unbox($y#9): Seq Box, Lit(pivot#0)))); 
          (forall k#3: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lte(pivot#0, k#3) } 
              $Is(k#3, TSeq(Tclass.NativeTypes.byte()))
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, TSeq(Tclass.NativeTypes.byte()))
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#7): Seq Box)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#8): Seq Box))); 
              Maps.__default.MapDisjointUnion#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Lexicographic__Byte__Order.__default.MapPivotedUnion(Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            Lit(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, TSeq(Tclass.NativeTypes.byte()))
                     && Lexicographic__Byte__Order.__default.lt($Unbox($y#10): Seq Box, Lit(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, TSeq(Tclass.NativeTypes.byte()))
                       && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#11): Seq Box))); 
              Maps.__default.MapDisjointUnion(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Lexicographic_Byte_Order._default.SetSuccessor
function Lexicographic__Byte__Order.__default.SetSuccessor(m#0: Set Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SetSuccessor#requires(Set Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#17_next(m: Set Box, key: Seq Box) : Seq Box;

function $let#17$canCall(m: Set Box, key: Seq Box) : bool;

axiom (forall m: Set Box, key: Seq Box :: 
  { $let#17_next(m, key) } 
  $let#17$canCall(m, key)
     ==> $Is($let#17_next(m, key), TSeq(Tclass.NativeTypes.byte()))
       && 
      m[$Box($let#17_next(m, key))]
       && Lexicographic__Byte__Order.__default.lt(key, $let#17_next(m, key))
       && (forall other#1: Seq Box :: 
        { Lexicographic__Byte__Order.__default.lt($let#17_next(m, key), other#1) } 
          { Lexicographic__Byte__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        $Is(other#1, TSeq(Tclass.NativeTypes.byte()))
           ==> 
          m[$Box(other#1)]
             && !Seq#Equal(other#1, $let#17_next(m, key))
             && Lexicographic__Byte__Order.__default.lt(key, other#1)
           ==> Lexicographic__Byte__Order.__default.lt($let#17_next(m, key), other#1)));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#0) } 
            { m#0[$Box(next#0)] } 
          $Is(next#0, TSeq(Tclass.NativeTypes.byte()))
             ==> (m#0[$Box(next#0)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#0))
               && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, next#0)
                   && Lexicographic__Byte__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#0, other#0) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  $Is(other#0, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#0, next#0)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#0))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(key#0, other#0)
                           && Lexicographic__Byte__Order.__default.lt(key#0, other#0)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#0) } 
              { m#0[$Box(next#0)] } 
            $Is(next#0, TSeq(Tclass.NativeTypes.byte()))
               && 
              m#0[$Box(next#0)]
               && Lexicographic__Byte__Order.__default.lt(key#0, next#0)
               && (forall other#0: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#0, other#0) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                $Is(other#0, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  m#0[$Box(other#0)]
                     && !Seq#Equal(other#0, next#0)
                     && Lexicographic__Byte__Order.__default.lt(key#0, other#0)
                   ==> Lexicographic__Byte__Order.__default.lt(next#0, other#0)))
           ==> $let#17$canCall(m#0, key#0))
         && Lexicographic__Byte__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#0) } 
                { m#0[$Box(next#0)] } 
              $Is(next#0, TSeq(Tclass.NativeTypes.byte()))
                 && 
                m#0[$Box(next#0)]
                 && Lexicographic__Byte__Order.__default.lt(key#0, next#0)
                 && (forall other#0: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#0, other#0) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  $Is(other#0, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    m#0[$Box(other#0)]
                       && !Seq#Equal(other#0, next#0)
                       && Lexicographic__Byte__Order.__default.lt(key#0, other#0)
                     ==> Lexicographic__Byte__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#17_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Lexicographic__Byte__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(m#0), Lit(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> (forall next#2: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, next#2) } 
            { m#0[$Box(next#2)] } 
          $Is(next#2, TSeq(Tclass.NativeTypes.byte()))
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#2))
               && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), next#2)
                   && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#2)
                 ==> (forall other#2: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#2, other#2) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  $Is(other#2, TSeq(Tclass.NativeTypes.byte()))
                     ==> (!Seq#Equal(other#2, next#2)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#2))
                       && (Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), other#2)
                           && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#2)
                         ==> Lexicographic__Byte__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#0, next#2) } 
              { m#0[$Box(next#2)] } 
            $Is(next#2, TSeq(Tclass.NativeTypes.byte()))
               && 
              Lit(m#0)[$Box(next#2)]
               && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#2)
               && (forall other#2: Seq Box :: 
                { Lexicographic__Byte__Order.__default.lt(next#2, other#2) } 
                  { Lexicographic__Byte__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                $Is(other#2, TSeq(Tclass.NativeTypes.byte()))
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && !Seq#Equal(other#2, next#2)
                     && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#2)
                   ==> Lexicographic__Byte__Order.__default.lt(next#2, other#2)))
           ==> $let#17$canCall(Lit(m#0), Lit(key#0)))
         && Lexicographic__Byte__Order.__default.SetSuccessor(Lit(m#0), Lit(key#0))
           == (if (exists next#2: Seq Box :: 
              { Lexicographic__Byte__Order.__default.lt(key#0, next#2) } 
                { m#0[$Box(next#2)] } 
              $Is(next#2, TSeq(Tclass.NativeTypes.byte()))
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Lexicographic__Byte__Order.__default.lt(Lit(key#0), next#2)
                 && (forall other#2: Seq Box :: 
                  { Lexicographic__Byte__Order.__default.lt(next#2, other#2) } 
                    { Lexicographic__Byte__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  $Is(other#2, TSeq(Tclass.NativeTypes.byte()))
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && !Seq#Equal(other#2, next#2)
                       && Lexicographic__Byte__Order.__default.lt(Lit(key#0), other#2)
                     ==> Lexicographic__Byte__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#17_next(Lit(m#0), Lit(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Lexicographic_Byte_Order._default.MapSuccessor
function Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : DatatypeType;

function Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box)
   : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.MapSuccessor#requires(Ty, Map Box Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.MapSuccessor
axiom (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
    m#0: Map Box Box, 
    key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.MapSuccessor$V))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.MapSuccessor#requires(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Lexicographic__Byte__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.MapSuccessor$V: Ty, 
      m#0: Map Box Box, 
      key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.MapSuccessor#canCall(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
         || ($Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.MapSuccessor$V))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), Lit(key#0))
         && Lexicographic__Byte__Order.__default.MapSuccessor(Lexicographic_Byte_Order._default.MapSuccessor$V, Lit(m#0), Lit(key#0))
           == Lit(Lexicographic__Byte__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), Lit(key#0))));

// function declaration for Lexicographic_Byte_Order._default.SeqSuccessor
function Lexicographic__Byte__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: Seq Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.SeqSuccessor#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Lexicographic__Byte__Order.__default.SeqSuccessor(m#0, key#0)
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Lexicographic__Byte__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0)) } 
    Lexicographic__Byte__Order.__default.SeqSuccessor#canCall(Lit(m#0), Lit(key#0))
         || ($Is(m#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#2)), 
          Lit(key#0))
         && Lexicographic__Byte__Order.__default.SeqSuccessor(Lit(m#0), Lit(key#0))
           == Lexicographic__Byte__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, TSeq(Tclass.NativeTypes.byte())) && Seq#Contains(m#0, $y#3)), 
            Lit(key#0)));

// function declaration for Lexicographic_Byte_Order._default.SortedSeqForMap
function Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> true);

function Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap
axiom (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, 
        TMap(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V))
     ==> Lexicographic__Byte__Order.__default.SortedSeqForMap#requires(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): Seq Box, 
                        key#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): Seq Box, 
                      key#0)
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Lexicographic__Byte__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Lexicographic_Byte_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
        $LS($ly), 
        Lit(s#0), 
        Lit(m#0)) } 
    Lexicographic__Byte__Order.__default.SortedSeqForMap#canCall(Lexicographic_Byte_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, 
            TMap(TSeq(Tclass.NativeTypes.byte()), 
              Lexicographic_Byte_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TSeq(Tclass.NativeTypes.byte()), 
          Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
          Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
            Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                  Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: Seq Box :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): Seq Box, 
                        key#1)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Lexicographic__Byte__Order.__default.SortedSeqForMap(Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
            $LS($ly), 
            Lit(s#0), 
            Lit(m#0))
           == (
            Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TSeq(Tclass.NativeTypes.byte()), 
                    Lexicographic_Byte_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: Seq Box :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && Seq#Equal($Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): Seq Box, 
                      key#1)
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Lexicographic_Byte_Order._default.minimum
function Lexicographic__Byte__Order.__default.minimum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimum($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.minimum($ly, s#0))]
         && (forall y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lte(Lexicographic__Byte__Order.__default.minimum($ly, s#0), y#0))
         && $Is(Lexicographic__Byte__Order.__default.minimum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#20_a(s: Set Box) : Seq Box;

function $let#20$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#20_a(s) } 
  $let#20$canCall(s)
     ==> $Is($let#20_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#20_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#20$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#20_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Lexicographic__Byte__Order.__default.minimum($ly, s'#0); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#20_a(s#0), m'#0)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#20_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Lexicographic__Byte__Order.__default.minimum($ly, s'#1); 
                  (if Lexicographic__Byte__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Lexicographic__Byte__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#20$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#20_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#2); 
                Lexicographic__Byte__Order.__default.lt#canCall($let#20_a(Lit(s#0)), m'#2)))
         && Lexicographic__Byte__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#20_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Lexicographic__Byte__Order.__default.minimum($LS($ly), s'#3); 
                  (if Lexicographic__Byte__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Lexicographic_Byte_Order._default.minimumOpt
function Lexicographic__Byte__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))): Seq Box, 
                y#0)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.minimum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.minimum(StartFuel_Lexicographic_Byte_Order._default.minimum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.maximum
function Lexicographic__Byte__Order.__default.maximum($ly: LayerType, s#0: Set Box) : Seq Box;

function Lexicographic__Byte__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximum($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximum($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte()))) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Lexicographic__Byte__Order.__default.maximum($ly, s#0))]
         && (forall y#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(y#0, Lexicographic__Byte__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
             ==> Lexicographic__Byte__Order.__default.lte(y#0, Lexicographic__Byte__Order.__default.maximum($ly, s#0)))
         && $Is(Lexicographic__Byte__Order.__default.maximum($ly, s#0), 
          TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#23_a(s: Set Box) : Seq Box;

function $let#23$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#23_a(s) } 
  $let#23$canCall(s)
     ==> $Is($let#23_a(s), TSeq(Tclass.NativeTypes.byte())) && s[$Box($let#23_a(s))]);

// definition axiom for Lexicographic__Byte__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#23$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#23_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Lexicographic__Byte__Order.__default.maximum($ly, s'#0); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#0, $let#23_a(s#0))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#23_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Lexicographic__Byte__Order.__default.maximum($ly, s'#1); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Lexicographic__Byte__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#23$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#23_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Lexicographic__Byte__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#2); 
                Lexicographic__Byte__Order.__default.lt#canCall(m'#2, $let#23_a(Lit(s#0)))))
         && Lexicographic__Byte__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#23_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Lexicographic__Byte__Order.__default.maximum($LS($ly), s'#3); 
                  (if Lexicographic__Byte__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Lexicographic_Byte_Order._default.maximumOpt
function Lexicographic__Byte__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0)
     == Lexicographic__Byte__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box) } 
              { s#0[$Box(y#0)] } 
            $Is(y#0, TSeq(Tclass.NativeTypes.byte())) && s#0[$Box(y#0)]
               ==> Lexicographic__Byte__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))): Seq Box)))
         && (Options.Option.None_q(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Lexicographic__Byte__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(TSeq(Tclass.NativeTypes.byte()))));

function Lexicographic__Byte__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(s#0))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, s#0)))));

// definition axiom for Lexicographic__Byte__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(TSeq(Tclass.NativeTypes.byte())))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Lit(s#0)))
         && Lexicographic__Byte__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(s#0))))));

// function declaration for Lexicographic_Byte_Order._default.lt
function Lexicographic__Byte__Order.__default.lt(a#0: Seq Box, b#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.lt#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.lt
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.lt#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.lt
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.lt(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.lt#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.lt(a#0, b#0)
           == (Lexicographic__Byte__Order.__default.lte(a#0, b#0) && !Seq#Equal(a#0, b#0)));

// definition axiom for Lexicographic__Byte__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.lt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.lt(Lit(a#0), Lit(b#0))
           == (Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             && !Seq#Equal(a#0, b#0)));

// function declaration for Lexicographic_Byte_Order._default.Min
function Lexicographic__Byte__Order.__default.Min(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Min#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Min
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Min(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Min#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Min
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Min(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Min#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Min(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Lexicographic__Byte__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Min#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Min(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then a#0
             else b#0));

// function declaration for Lexicographic_Byte_Order._default.Max
function Lexicographic__Byte__Order.__default.Max(a#0: Seq Box, b#0: Seq Box) : Seq Box;

function Lexicographic__Byte__Order.__default.Max#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.Max
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> $Is(Lexicographic__Byte__Order.__default.Max(a#0, b#0), 
        TSeq(Tclass.NativeTypes.byte())));

function Lexicographic__Byte__Order.__default.Max#requires(Seq Box, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.Max
axiom (forall a#0: Seq Box, b#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) } 
  $Is(a#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(b#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Lexicographic__Byte__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.Max(a#0, b#0) } 
    Lexicographic__Byte__Order.__default.Max#canCall(a#0, b#0)
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(a#0, b#0)
         && Lexicographic__Byte__Order.__default.Max(a#0, b#0)
           == (if Lexicographic__Byte__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Lexicographic__Byte__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0)) } 
    Lexicographic__Byte__Order.__default.Max#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(b#0, TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(a#0), Lit(b#0))
         && Lexicographic__Byte__Order.__default.Max(Lit(a#0), Lit(b#0))
           == (if Lexicographic__Byte__Order.__default.lte(Lit(a#0), Lit(b#0))
             then b#0
             else a#0));

// function declaration for Lexicographic_Byte_Order._default.IsSorted
function Lexicographic__Byte__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsSorted($ly, run#0)));

function Lexicographic__Byte__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          j#0 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySortedInternal
function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#requires(run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
          j#0 < Seq#Length(run#0)
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): Seq Box, $Unbox(Seq#Index(run#0, i#0)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): Seq Box, $Unbox(Seq#Index(run#0, j#0)): Seq Box)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
              $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box))
         && Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): Seq Box, $Unbox(Seq#Index(run#0, i#1)): Seq Box } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): Seq Box, 
                $Unbox(Seq#Index(Lit(run#0), j#1)): Seq Box)));

// function declaration for Lexicographic_Byte_Order._default.IsStrictlySorted
function Lexicographic__Byte__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
     == Lexicographic__Byte__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0))
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Lexicographic__Byte__Order.__default.IsSorted(StartFuel_Lexicographic_Byte_Order._default.IsSorted, run#0)));

function Lexicographic__Byte__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#requires($ly, run#0)
       == true);

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Lexicographic__Byte__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Lexicographic__Byte__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

const unique class.Lexicographic__Byte__Order__Impl.__default: ClassName;

function Tclass.Lexicographic__Byte__Order__Impl.__default() : Ty;

// Tclass.Lexicographic__Byte__Order__Impl.__default Tag
axiom Tag(Tclass.Lexicographic__Byte__Order__Impl.__default())
   == Tagclass.Lexicographic__Byte__Order__Impl.__default;

const unique Tagclass.Lexicographic__Byte__Order__Impl.__default: TyTag;

// Box/unbox axiom for Tclass.Lexicographic__Byte__Order__Impl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $IsBox(bx, Tclass.Lexicographic__Byte__Order__Impl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Lexicographic__Byte__Order__Impl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default()) } 
  $Is($o, Tclass.Lexicographic__Byte__Order__Impl.__default())
     <==> $o == null || dtype($o) == Tclass.Lexicographic__Byte__Order__Impl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h) } 
  $IsAlloc($o, Tclass.Lexicographic__Byte__Order__Impl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique class.PivotsLib.__default: ClassName;

function Tclass.PivotsLib.__default() : Ty;

// Tclass.PivotsLib.__default Tag
axiom Tag(Tclass.PivotsLib.__default()) == Tagclass.PivotsLib.__default;

const unique Tagclass.PivotsLib.__default: TyTag;

// Box/unbox axiom for Tclass.PivotsLib.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotsLib.__default()) } 
  $IsBox(bx, Tclass.PivotsLib.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PivotsLib.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PivotsLib.__default()) } 
  $Is($o, Tclass.PivotsLib.__default())
     <==> $o == null || dtype($o) == Tclass.PivotsLib.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PivotsLib.__default(), $h) } 
  $IsAlloc($o, Tclass.PivotsLib.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PivotsLib._default.WFPivots
function PivotsLib.__default.WFPivots(pt#0: Seq Box) : bool;

function PivotsLib.__default.WFPivots#canCall(pt#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.WFPivots
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.WFPivots(pt#0) } 
    PivotsLib.__default.WFPivots#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> true);

function PivotsLib.__default.WFPivots#requires(Seq Box) : bool;

// #requires axiom for PivotsLib.__default.WFPivots
axiom (forall pt#0: Seq Box :: 
  { PivotsLib.__default.WFPivots#requires(pt#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotsLib.__default.WFPivots#requires(pt#0) == true);

// definition axiom for PivotsLib.__default.WFPivots(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.WFPivots(pt#0) } 
    PivotsLib.__default.WFPivots#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(pt#0)
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, pt#0)
           ==> 
          Seq#Length(pt#0) > 0
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall($Unbox(Seq#Index(pt#0, LitInt(0))): Seq Box))
         && PivotsLib.__default.WFPivots(pt#0)
           == (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, pt#0)
             && (Seq#Length(pt#0) > 0
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, 
                $Unbox(Seq#Index(pt#0, LitInt(0))): Seq Box))));

// definition axiom for PivotsLib.__default.WFPivots for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.WFPivots(Lit(pt#0)) } 
    PivotsLib.__default.WFPivots#canCall(Lit(pt#0))
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(pt#0))
         && (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, Lit(pt#0))
           ==> 
          Seq#Length(Lit(pt#0)) > 0
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall($Unbox(Seq#Index(Lit(pt#0), LitInt(0))): Seq Box))
         && PivotsLib.__default.WFPivots(Lit(pt#0))
           == (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, Lit(pt#0))
             && (Seq#Length(Lit(pt#0)) > 0
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, 
                $Unbox(Seq#Index(Lit(pt#0), LitInt(0))): Seq Box))));

// function declaration for PivotsLib._default.NumBuckets
function PivotsLib.__default.NumBuckets(pt#0: Seq Box) : int;

function PivotsLib.__default.NumBuckets#canCall(pt#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.NumBuckets
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.NumBuckets(pt#0) } 
    PivotsLib.__default.NumBuckets#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> true);

function PivotsLib.__default.NumBuckets#requires(Seq Box) : bool;

// #requires axiom for PivotsLib.__default.NumBuckets
axiom (forall pt#0: Seq Box :: 
  { PivotsLib.__default.NumBuckets#requires(pt#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotsLib.__default.NumBuckets#requires(pt#0) == true);

// definition axiom for PivotsLib.__default.NumBuckets(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    { PivotsLib.__default.NumBuckets(pt#0) } 
    PivotsLib.__default.NumBuckets#canCall(pt#0)
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> PivotsLib.__default.NumBuckets(pt#0) == Seq#Length(pt#0) + 1);

// definition axiom for PivotsLib.__default.NumBuckets for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.NumBuckets(Lit(pt#0)) } 
    PivotsLib.__default.NumBuckets#canCall(Lit(pt#0))
         || $Is(pt#0, TSeq(Tclass.KeyType.Key()))
       ==> PivotsLib.__default.NumBuckets(Lit(pt#0)) == Seq#Length(Lit(pt#0)) + 1);

// function declaration for PivotsLib._default.Route
function PivotsLib.__default.Route(pt#0: Seq Box, key#0: Seq Box) : int;

function PivotsLib.__default.Route#canCall(pt#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.Route
axiom true
   ==> (forall pt#0: Seq Box, key#0: Seq Box :: 
    { PivotsLib.__default.Route(pt#0, key#0) } 
    PivotsLib.__default.Route#canCall(pt#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> LitInt(0) <= PivotsLib.__default.Route(pt#0, key#0)
         && PivotsLib.__default.Route(pt#0, key#0) < PivotsLib.__default.NumBuckets(pt#0));

function PivotsLib.__default.Route#requires(Seq Box, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.Route
axiom (forall pt#0: Seq Box, key#0: Seq Box :: 
  { PivotsLib.__default.Route#requires(pt#0, key#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.Route#requires(pt#0, key#0)
       == PivotsLib.__default.WFPivots(pt#0));

// definition axiom for PivotsLib.__default.Route(revealed)
axiom true
   ==> (forall pt#0: Seq Box, key#0: Seq Box :: 
    { PivotsLib.__default.Route(pt#0, key#0) } 
    PivotsLib.__default.Route#canCall(pt#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(pt#0, key#0)
         && PivotsLib.__default.Route(pt#0, key#0)
           == Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), pt#0, key#0) + 1);

// definition axiom for PivotsLib.__default.Route for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.Route(Lit(pt#0), Lit(key#0)) } 
    PivotsLib.__default.Route#canCall(Lit(pt#0), Lit(key#0))
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pt#0))))
       ==> Lexicographic__Byte__Order.__default.LargestLte#canCall(Lit(pt#0), Lit(key#0))
         && PivotsLib.__default.Route(Lit(pt#0), Lit(key#0))
           == LitInt(Lexicographic__Byte__Order.__default.LargestLte($LS($LZ), Lit(pt#0), Lit(key#0))
               + 1));

// function declaration for PivotsLib._default.PivotInsertable
function PivotsLib.__default.PivotInsertable(pt#0: Seq Box, idx#0: int, key#0: Seq Box) : bool;

function PivotsLib.__default.PivotInsertable#canCall(pt#0: Seq Box, idx#0: int, key#0: Seq Box) : bool;

// consequence axiom for PivotsLib.__default.PivotInsertable
axiom true
   ==> (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
    { PivotsLib.__default.PivotInsertable(pt#0, idx#0, key#0) } 
    PivotsLib.__default.PivotInsertable#canCall(pt#0, idx#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> true);

function PivotsLib.__default.PivotInsertable#requires(Seq Box, int, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.PivotInsertable
axiom (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
  { PivotsLib.__default.PivotInsertable#requires(pt#0, idx#0, key#0) } 
  $Is(pt#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.PivotInsertable#requires(pt#0, idx#0, key#0)
       == PivotsLib.__default.WFPivots(pt#0));

// definition axiom for PivotsLib.__default.PivotInsertable(revealed)
axiom true
   ==> (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
    { PivotsLib.__default.PivotInsertable(pt#0, idx#0, key#0) } 
    PivotsLib.__default.PivotInsertable#canCall(pt#0, idx#0, key#0)
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pt#0))
       ==> (idx#0 <= Seq#Length(pt#0) ==> PivotsLib.__default.Route#canCall(pt#0, key#0))
         && (
          (idx#0 > 0
           ==> !Seq#Equal(key#0, $Unbox(Seq#Index(pt#0, idx#0 - 1)): Seq Box))
           ==> 
          idx#0 == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall(key#0))
         && PivotsLib.__default.PivotInsertable(pt#0, idx#0, key#0)
           == (
            LitInt(0) <= idx#0
             && idx#0 <= Seq#Length(pt#0)
             && PivotsLib.__default.Route(pt#0, key#0) == idx#0
             && (idx#0 > 0 ==> !Seq#Equal(key#0, $Unbox(Seq#Index(pt#0, idx#0 - 1)): Seq Box))
             && (idx#0 == LitInt(0)
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, key#0))));

// definition axiom for PivotsLib.__default.PivotInsertable for all literals(revealed)
axiom true
   ==> (forall pt#0: Seq Box, idx#0: int, key#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.PivotInsertable(Lit(pt#0), LitInt(idx#0), Lit(key#0)) } 
    PivotsLib.__default.PivotInsertable#canCall(Lit(pt#0), LitInt(idx#0), Lit(key#0))
         || (
          $Is(pt#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pt#0))))
       ==> (LitInt(idx#0) <= Seq#Length(Lit(pt#0))
           ==> PivotsLib.__default.Route#canCall(Lit(pt#0), Lit(key#0)))
         && (
          (idx#0 > 0
           ==> !Seq#Equal(key#0, $Unbox(Seq#Index(Lit(pt#0), LitInt(idx#0 - 1))): Seq Box))
           ==> 
          LitInt(idx#0) == LitInt(0)
           ==> Lexicographic__Byte__Order.__default.NotMinimum#canCall(Lit(key#0)))
         && PivotsLib.__default.PivotInsertable(Lit(pt#0), LitInt(idx#0), Lit(key#0))
           == (
            LitInt(0) <= LitInt(idx#0)
             && LitInt(idx#0) <= Seq#Length(Lit(pt#0))
             && LitInt(PivotsLib.__default.Route(Lit(pt#0), Lit(key#0))) == LitInt(idx#0)
             && (idx#0 > 0
               ==> !Seq#Equal(key#0, $Unbox(Seq#Index(Lit(pt#0), LitInt(idx#0 - 1))): Seq Box))
             && (LitInt(idx#0) == LitInt(0)
               ==> Lexicographic__Byte__Order.__default.NotMinimum(StartFuel_Lexicographic_Byte_Order._default.NotMinimum, Lit(key#0)))));

// function declaration for PivotsLib._default.CutoffForLeft
function PivotsLib.__default.CutoffForLeft($ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box) : int;

function PivotsLib.__default.CutoffForLeft#canCall(pivots#0: Seq Box, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForLeft(AsFuelBottom($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForLeft($LZ, pivots#0, pivot#0));

// consequence axiom for PivotsLib.__default.CutoffForLeft
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForLeft#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> LitInt(0) <= PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
           <= Seq#Length(pivots#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(pivots#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0)
             ==> Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(pivots#0, i#0)): Seq Box, pivot#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
          PivotsLib.__default.CutoffForLeft($ly, pivots#0, pivot#0) <= i#1
               && i#1 < Seq#Length(pivots#0)
             ==> Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox(Seq#Index(pivots#0, i#1)): Seq Box)));

function PivotsLib.__default.CutoffForLeft#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.CutoffForLeft
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForLeft#requires($ly, pivots#0, pivot#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key())) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.CutoffForLeft#requires($ly, pivots#0, pivot#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for PivotsLib.__default.CutoffForLeft(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForLeft#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForLeft($LS($ly), pivots#0, pivot#0)
           == Lexicographic__Byte__Order.__default.LargestLt($LS($LZ), pivots#0, pivot#0) + 1);

// definition axiom for PivotsLib.__default.CutoffForLeft for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.CutoffForLeft($LS($ly), Lit(pivots#0), Lit(pivot#0)) } 
    PivotsLib.__default.CutoffForLeft#canCall(Lit(pivots#0), Lit(pivot#0))
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> Lexicographic__Byte__Order.__default.LargestLt#canCall(Lit(pivots#0), Lit(pivot#0))
         && PivotsLib.__default.CutoffForLeft($LS($ly), Lit(pivots#0), Lit(pivot#0))
           == LitInt(Lexicographic__Byte__Order.__default.LargestLt($LS($LZ), Lit(pivots#0), Lit(pivot#0))
               + 1));

// function declaration for PivotsLib._default.CutoffForRight
function PivotsLib.__default.CutoffForRight($ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box) : int;

function PivotsLib.__default.CutoffForRight#canCall(pivots#0: Seq Box, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForRight(AsFuelBottom($ly), pivots#0, pivot#0) } 
  PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
     == PivotsLib.__default.CutoffForRight($LZ, pivots#0, pivot#0));

// consequence axiom for PivotsLib.__default.CutoffForRight
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForRight#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> LitInt(0) <= PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
           <= Seq#Length(pivots#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(pivots#0, i#0)): Seq Box } 
          LitInt(0) <= i#0
               && i#0 < PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0)
             ==> Lexicographic__Byte__Order.__default.lte($Unbox(Seq#Index(pivots#0, i#0)): Seq Box, pivot#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(pivots#0, i#1)): Seq Box } 
          PivotsLib.__default.CutoffForRight($ly, pivots#0, pivot#0) <= i#1
               && i#1 < Seq#Length(pivots#0)
             ==> Lexicographic__Byte__Order.__default.lt(pivot#0, $Unbox(Seq#Index(pivots#0, i#1)): Seq Box)));

function PivotsLib.__default.CutoffForRight#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PivotsLib.__default.CutoffForRight
axiom (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
  { PivotsLib.__default.CutoffForRight#requires($ly, pivots#0, pivot#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key())) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> PivotsLib.__default.CutoffForRight#requires($ly, pivots#0, pivot#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for PivotsLib.__default.CutoffForRight(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    { PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0) } 
    PivotsLib.__default.CutoffForRight#canCall(pivots#0, pivot#0)
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> PivotsLib.__default.Route#canCall(pivots#0, pivot#0)
         && PivotsLib.__default.CutoffForRight($LS($ly), pivots#0, pivot#0)
           == PivotsLib.__default.Route(pivots#0, pivot#0));

// definition axiom for PivotsLib.__default.CutoffForRight for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, pivots#0: Seq Box, pivot#0: Seq Box :: 
    {:weight 3} { PivotsLib.__default.CutoffForRight($LS($ly), Lit(pivots#0), Lit(pivot#0)) } 
    PivotsLib.__default.CutoffForRight#canCall(Lit(pivots#0), Lit(pivot#0))
         || (
          $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), Lit(pivot#0))
         && PivotsLib.__default.CutoffForRight($LS($ly), Lit(pivots#0), Lit(pivot#0))
           == LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(pivot#0))));

// function declaration for PivotsLib._default.PivotTableBucketKeySet
function PivotsLib.__default.PivotTableBucketKeySet(pivots#0: Seq Box, i#0: int) : ISet Box;

function PivotsLib.__default.PivotTableBucketKeySet#canCall(pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for PivotsLib.__default.PivotTableBucketKeySet
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0) } 
    PivotsLib.__default.PivotTableBucketKeySet#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0), 
        TISet(Tclass.KeyType.Key())));

function PivotsLib.__default.PivotTableBucketKeySet#requires(Seq Box, int) : bool;

// #requires axiom for PivotsLib.__default.PivotTableBucketKeySet
axiom (forall pivots#0: Seq Box, i#0: int :: 
  { PivotsLib.__default.PivotTableBucketKeySet#requires(pivots#0, i#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotsLib.__default.PivotTableBucketKeySet#requires(pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for PivotsLib.__default.PivotTableBucketKeySet(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0) } 
    PivotsLib.__default.PivotTableBucketKeySet#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall key#0: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(pivots#0, key#0))
         && PivotsLib.__default.PivotTableBucketKeySet(pivots#0, i#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(pivots#0, $Unbox($y#0): Seq Box) == i#0));

// definition axiom for PivotsLib.__default.PivotTableBucketKeySet for all literals(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { PivotsLib.__default.PivotTableBucketKeySet(Lit(pivots#0), LitInt(i#0)) } 
    PivotsLib.__default.PivotTableBucketKeySet#canCall(Lit(pivots#0), LitInt(i#0))
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall key#1: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, key#1) } 
          $Is(key#1, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#1))
         && PivotsLib.__default.PivotTableBucketKeySet(Lit(pivots#0), LitInt(i#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($y#1): Seq Box) == LitInt(i#0)));

const unique class.Multisets.__default: ClassName;

function Tclass.Multisets.__default() : Ty;

// Tclass.Multisets.__default Tag
axiom Tag(Tclass.Multisets.__default()) == Tagclass.Multisets.__default;

const unique Tagclass.Multisets.__default: TyTag;

// Box/unbox axiom for Tclass.Multisets.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Multisets.__default()) } 
  $IsBox(bx, Tclass.Multisets.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Multisets.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Multisets.__default()) } 
  $Is($o, Tclass.Multisets.__default())
     <==> $o == null || dtype($o) == Tclass.Multisets.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Multisets.__default(), $h) } 
  $IsAlloc($o, Tclass.Multisets.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Multisets._default.Choose
function Multisets.__default.Choose(Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box) : Box;

function Multisets.__default.Choose#canCall(Multisets._default.Choose$A: Ty, s#0: MultiSet Box) : bool;

// layer synonym axiom
axiom (forall Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box :: 
  { Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0) } 
  Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0)
     == Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0));

// fuel synonym axiom
axiom (forall Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box :: 
  { Multisets.__default.Choose(Multisets._default.Choose$A, AsFuelBottom($ly), s#0) } 
  Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0)
     == Multisets.__default.Choose(Multisets._default.Choose$A, $LZ, s#0));

// consequence axiom for Multisets.__default.Choose
axiom true
   ==> (forall Multisets._default.Choose$A: Ty, $ly: LayerType, s#0: MultiSet Box :: 
    { Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0) } 
    Multisets.__default.Choose#canCall(Multisets._default.Choose$A, s#0)
         || ($Is(s#0, TMultiSet(Multisets._default.Choose$A)) && 0 < MultiSet#Card(s#0))
       ==> s#0[Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0)] > 0
         && $IsBox(Multisets.__default.Choose(Multisets._default.Choose$A, $ly, s#0), 
          Multisets._default.Choose$A));

function Multisets.__default.Choose#requires(Ty, LayerType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.Choose
axiom (forall Multisets._default.Choose$A: Ty, $ly: LayerType, $Heap: Heap, s#0: MultiSet Box :: 
  { Multisets.__default.Choose#requires(Multisets._default.Choose$A, $ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TMultiSet(Multisets._default.Choose$A))
     ==> Multisets.__default.Choose#requires(Multisets._default.Choose$A, $ly, s#0)
       == (0 < MultiSet#Card(s#0)));

function $let#26_a(Multisets._default.Choose$A: Ty, s: MultiSet Box) : Box;

function $let#26$canCall(Multisets._default.Choose$A: Ty, s: MultiSet Box) : bool;

axiom (forall Multisets._default.Choose$A: Ty, s: MultiSet Box :: 
  { $let#26_a(Multisets._default.Choose$A, s) } 
  $let#26$canCall(Multisets._default.Choose$A, s)
     ==> s[$let#26_a(Multisets._default.Choose$A, s)] > 0);

// definition axiom for Multisets.__default.Choose(revealed)
axiom true
   ==> (forall Multisets._default.Choose$A: Ty, $ly: LayerType, $Heap: Heap, s#0: MultiSet Box :: 
    { Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0), $IsGoodHeap($Heap) } 
    Multisets.__default.Choose#canCall(Multisets._default.Choose$A, s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TMultiSet(Multisets._default.Choose$A))
           && 0 < MultiSet#Card(s#0))
       ==> $let#26$canCall(Multisets._default.Choose$A, s#0)
         && Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), s#0)
           == (var a#0 := $let#26_a(Multisets._default.Choose$A, s#0); a#0));

// definition axiom for Multisets.__default.Choose for all literals(revealed)
axiom true
   ==> (forall Multisets._default.Choose$A: Ty, $ly: LayerType, $Heap: Heap, s#0: MultiSet Box :: 
    {:weight 3} { Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.Choose#canCall(Multisets._default.Choose$A, Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TMultiSet(Multisets._default.Choose$A))
           && 0 < MultiSet#Card(Lit(s#0)))
       ==> $let#26$canCall(Multisets._default.Choose$A, Lit(s#0))
         && Multisets.__default.Choose(Multisets._default.Choose$A, $LS($ly), Lit(s#0))
           == (var a#1 := $let#26_a(Multisets._default.Choose$A, Lit(s#0)); a#1));

// function declaration for Multisets._default.Apply
function Multisets.__default.Apply(Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box)
   : MultiSet Box;

function Multisets.__default.Apply#canCall(Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Apply(Multisets._default.Apply$A, 
      Multisets._default.Apply$B, 
      $LS($ly), 
      $Heap, 
      fn#0, 
      s#0) } 
  Multisets.__default.Apply(Multisets._default.Apply$A, 
      Multisets._default.Apply$B, 
      $LS($ly), 
      $Heap, 
      fn#0, 
      s#0)
     == Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0));

// fuel synonym axiom
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Apply(Multisets._default.Apply$A, 
      Multisets._default.Apply$B, 
      AsFuelBottom($ly), 
      $Heap, 
      fn#0, 
      s#0) } 
  Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0)
     == Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $LZ, $Heap, fn#0, s#0));

// frame axiom for Multisets.__default.Apply
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $h1, fn#0, s#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.Apply#canCall(Multisets._default.Apply$A, Multisets._default.Apply$B, $h0, fn#0, s#0)
         || ($Is(fn#0, 
            Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
           && $Is(s#0, TMultiSet(Multisets._default.Apply$A))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, o#0: ref :: 
            { Reads1(Multisets._default.Apply$A, Multisets._default.Apply$B, $h0, fn#0, x#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.Apply$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              s#0[x#0] > 0
               && Reads1(Multisets._default.Apply$A, Multisets._default.Apply$B, $h0, fn#0, x#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $h0, fn#0, s#0)
       == Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $h1, fn#0, s#0));

// consequence axiom for Multisets.__default.Apply
axiom true
   ==> (forall Multisets._default.Apply$A: Ty, 
      Multisets._default.Apply$B: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      fn#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0) } 
    Multisets.__default.Apply#canCall(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(fn#0, 
            Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
           && $Is(s#0, TMultiSet(Multisets._default.Apply$A))
           && (forall x#1: Box :: 
            { Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#1) } 
              { s#0[x#1] } 
            $IsBox(x#1, Multisets._default.Apply$A) && s#0[x#1] > 0
               ==> Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#1)))
       ==> MultiSet#Card(Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0))
           == MultiSet#Card(s#0)
         && $Is(Multisets.__default.Apply(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0), 
          TMultiSet(Multisets._default.Apply$B)));

function Multisets.__default.Apply#requires(Ty, Ty, LayerType, Heap, HandleType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.Apply
axiom (forall Multisets._default.Apply$A: Ty, 
    Multisets._default.Apply$B: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    fn#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Apply#requires(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0) } 
  $IsGoodHeap($Heap)
       && $Is(fn#0, 
        Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
       && $Is(s#0, TMultiSet(Multisets._default.Apply$A))
     ==> Multisets.__default.Apply#requires(Multisets._default.Apply$A, Multisets._default.Apply$B, $ly, $Heap, fn#0, s#0)
       == (forall x#2: Box :: 
        { Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#2) } 
          { s#0[x#2] } 
        $IsBox(x#2, Multisets._default.Apply$A) && s#0[x#2] > 0
           ==> Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#2)));

// definition axiom for Multisets.__default.Apply(revealed)
axiom true
   ==> (forall Multisets._default.Apply$A: Ty, 
      Multisets._default.Apply$B: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      fn#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Apply(Multisets._default.Apply$A, 
        Multisets._default.Apply$B, 
        $LS($ly), 
        $Heap, 
        fn#0, 
        s#0) } 
    Multisets.__default.Apply#canCall(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(fn#0, 
            Tclass._System.___hFunc1(Multisets._default.Apply$A, Multisets._default.Apply$B))
           && $Is(s#0, TMultiSet(Multisets._default.Apply$A))
           && (forall x#2: Box :: 
            { Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#2) } 
              { s#0[x#2] } 
            $IsBox(x#2, Multisets._default.Apply$A) && s#0[x#2] > 0
               ==> Requires1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#2)))
       ==> (MultiSet#Card(s#0) != LitInt(0)
           ==> Multisets.__default.Choose#canCall(Multisets._default.Apply$A, s#0)
             && (var x#3 := Multisets.__default.Choose(Multisets._default.Apply$A, StartFuel_Multisets._default.Choose, s#0); 
              Multisets.__default.Apply#canCall(Multisets._default.Apply$A, 
                Multisets._default.Apply$B, 
                $Heap, 
                fn#0, 
                MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, x#3)))))
         && Multisets.__default.Apply(Multisets._default.Apply$A, 
            Multisets._default.Apply$B, 
            $LS($ly), 
            $Heap, 
            fn#0, 
            s#0)
           == (if MultiSet#Card(s#0) == LitInt(0)
             then MultiSet#Empty(): MultiSet Box
             else (var x#3 := Multisets.__default.Choose(Multisets._default.Apply$A, StartFuel_Multisets._default.Choose, s#0); 
              MultiSet#Union(MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, 
                  Apply1(Multisets._default.Apply$A, Multisets._default.Apply$B, $Heap, fn#0, x#3)), 
                Multisets.__default.Apply(Multisets._default.Apply$A, 
                  Multisets._default.Apply$B, 
                  $ly, 
                  $Heap, 
                  fn#0, 
                  MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, x#3)))))));

// function declaration for Multisets._default.Foldable
function Multisets.__default.Foldable(Multisets._default.Foldable$A: Ty, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

function Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A: Ty, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

// frame axiom for Multisets.__default.Foldable
axiom (forall Multisets._default.Foldable$A: Ty, 
    $h0: Heap, 
    $h1: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.Foldable(Multisets._default.Foldable$A, $h1, zero#0, add#0, inv#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A, $h0, zero#0, add#0, inv#0)
         || (
          $IsBox(zero#0, Multisets._default.Foldable$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.Foldable$A)
               && $IsBox(y#0, Multisets._default.Foldable$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.Foldable(Multisets._default.Foldable$A, $h0, zero#0, add#0, inv#0)
       == Multisets.__default.Foldable(Multisets._default.Foldable$A, $h1, zero#0, add#0, inv#0));

// consequence axiom for Multisets.__default.Foldable
axiom true
   ==> (forall Multisets._default.Foldable$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.Foldable(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0) } 
    Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Foldable$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool)))
       ==> true);

function Multisets.__default.Foldable#requires(Ty, Heap, Box, HandleType, HandleType) : bool;

// #requires axiom for Multisets.__default.Foldable
axiom (forall Multisets._default.Foldable$A: Ty, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.Foldable#requires(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0) } 
  $IsGoodHeap($Heap)
       && $IsBox(zero#0, Multisets._default.Foldable$A)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
          Multisets._default.Foldable$A, 
          Multisets._default.Foldable$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool))
     ==> Multisets.__default.Foldable#requires(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
       == true);

// definition axiom for Multisets.__default.Foldable(revealed)
axiom true
   ==> (forall Multisets._default.Foldable$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.Foldable(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0) } 
    Multisets.__default.Foldable#canCall(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Foldable$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A, 
              Multisets._default.Foldable$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Foldable$A, TBool)))
       ==> ($Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, zero#0)): bool
           ==> (forall x#1: Box, y#1: Box :: 
            { Requires2(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $Heap, 
                add#0, 
                x#1, 
                y#1) } 
              { $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#1)): bool, $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#1)): bool } 
            $IsBox(x#1, Multisets._default.Foldable$A)
                 && $IsBox(y#1, Multisets._default.Foldable$A)
               ==> 
              $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#1)): bool
                 && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#1)): bool
               ==> Requires2#canCall(Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                Multisets._default.Foldable$A, 
                $Heap, 
                add#0, 
                x#1, 
                y#1)))
         && Multisets.__default.Foldable(Multisets._default.Foldable$A, $Heap, zero#0, add#0, inv#0)
           == ($Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, zero#0)): bool
             && 
            (forall x#1: Box, y#1: Box :: 
              { Requires2(Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  $Heap, 
                  add#0, 
                  x#1, 
                  y#1) } 
                { $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#1)): bool, $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#1)): bool } 
              $IsBox(x#1, Multisets._default.Foldable$A)
                   && $IsBox(y#1, Multisets._default.Foldable$A)
                   && 
                  $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#1)): bool
                   && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#1)): bool
                 ==> Requires2(Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  $Heap, 
                  add#0, 
                  x#1, 
                  y#1))
             && (forall x#2: Box, y#2: Box :: 
              { Apply2(Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  Multisets._default.Foldable$A, 
                  $Heap, 
                  add#0, 
                  x#2, 
                  y#2) } 
              $IsBox(x#2, Multisets._default.Foldable$A)
                   && $IsBox(y#2, Multisets._default.Foldable$A)
                   && 
                  $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, x#2)): bool
                   && $Unbox(Apply1(Multisets._default.Foldable$A, TBool, $Heap, inv#0, y#2)): bool
                 ==> $Unbox(Apply1(Multisets._default.Foldable$A, 
                    TBool, 
                    $Heap, 
                    inv#0, 
                    Apply2(Multisets._default.Foldable$A, 
                      Multisets._default.Foldable$A, 
                      Multisets._default.Foldable$A, 
                      $Heap, 
                      add#0, 
                      x#2, 
                      y#2))): bool)));

// function declaration for Multisets._default.Fold
function Multisets.__default.Fold(Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box)
   : Box;

function Multisets.__default.Fold#canCall(Multisets._default.Fold$A: Ty, 
    $heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0) } 
  Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0)
     == Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0));

// fuel synonym axiom
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Fold(Multisets._default.Fold$A, AsFuelBottom($ly), $Heap, zero#0, add#0, inv#0, s#0) } 
  Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0)
     == Multisets.__default.Fold(Multisets._default.Fold$A, $LZ, $Heap, zero#0, add#0, inv#0, s#0));

// frame axiom for Multisets.__default.Fold
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $h1, zero#0, add#0, inv#0, s#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.Fold#canCall(Multisets._default.Fold$A, $h0, zero#0, add#0, inv#0, s#0)
         || (
          $IsBox(zero#0, Multisets._default.Fold$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
           && $Is(s#0, TMultiSet(Multisets._default.Fold$A))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.Fold$A)
               && $IsBox(y#0, Multisets._default.Fold$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.Fold$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.Fold$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $h0, zero#0, add#0, inv#0, s#0)
       == Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $h1, zero#0, add#0, inv#0, s#0));

// consequence axiom for Multisets.__default.Fold
axiom true
   ==> (forall Multisets._default.Fold$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0) } 
    Multisets.__default.Fold#canCall(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Fold$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
           && $Is(s#0, TMultiSet(Multisets._default.Fold$A))
           && 
          Multisets.__default.Foldable(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0)
           && (forall x#1: Box :: 
            { $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#1)): bool } 
              { s#0[x#1] } 
            $IsBox(x#1, Multisets._default.Fold$A) && s#0[x#1] > 0
               ==> $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#1)): bool))
       ==> (MultiSet#Card(s#0) == LitInt(0)
           ==> Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0)
             == zero#0)
         && $Unbox(Apply1(Multisets._default.Fold$A, 
            TBool, 
            $Heap, 
            inv#0, 
            Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0))): bool
         && $IsBox(Multisets.__default.Fold(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0), 
          Multisets._default.Fold$A));

function Multisets.__default.Fold#requires(Ty, LayerType, Heap, Box, HandleType, HandleType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.Fold
axiom (forall Multisets._default.Fold$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    inv#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.Fold#requires(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0) } 
  $IsGoodHeap($Heap)
       && $IsBox(zero#0, Multisets._default.Fold$A)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
       && $Is(s#0, TMultiSet(Multisets._default.Fold$A))
     ==> Multisets.__default.Fold#requires(Multisets._default.Fold$A, $ly, $Heap, zero#0, add#0, inv#0, s#0)
       == (Multisets.__default.Foldable(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0)
         && (forall x#2: Box :: 
          { $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#2)): bool } 
            { s#0[x#2] } 
          $IsBox(x#2, Multisets._default.Fold$A) && s#0[x#2] > 0
             ==> $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#2)): bool)));

// definition axiom for Multisets.__default.Fold(revealed)
axiom true
   ==> (forall Multisets._default.Fold$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      inv#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0) } 
    Multisets.__default.Fold#canCall(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.Fold$A)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.Fold$A, Multisets._default.Fold$A, Multisets._default.Fold$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.Fold$A, TBool))
           && $Is(s#0, TMultiSet(Multisets._default.Fold$A))
           && 
          Multisets.__default.Foldable(Multisets._default.Fold$A, $Heap, zero#0, add#0, inv#0)
           && (forall x#2: Box :: 
            { $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#2)): bool } 
              { s#0[x#2] } 
            $IsBox(x#2, Multisets._default.Fold$A) && s#0[x#2] > 0
               ==> $Unbox(Apply1(Multisets._default.Fold$A, TBool, $Heap, inv#0, x#2)): bool))
       ==> (MultiSet#Card(s#0) != LitInt(0)
           ==> Multisets.__default.Choose#canCall(Multisets._default.Fold$A, s#0)
             && (var a#0 := Multisets.__default.Choose(Multisets._default.Fold$A, StartFuel_Multisets._default.Choose, s#0); 
              Multisets.__default.Fold#canCall(Multisets._default.Fold$A, 
                $Heap, 
                zero#0, 
                add#0, 
                inv#0, 
                MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, a#0)))))
         && Multisets.__default.Fold(Multisets._default.Fold$A, $LS($ly), $Heap, zero#0, add#0, inv#0, s#0)
           == (if MultiSet#Card(s#0) == LitInt(0)
             then zero#0
             else (var a#0 := Multisets.__default.Choose(Multisets._default.Fold$A, StartFuel_Multisets._default.Choose, s#0); 
              Apply2(Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                Multisets._default.Fold$A, 
                $Heap, 
                add#0, 
                a#0, 
                Multisets.__default.Fold(Multisets._default.Fold$A, 
                  $ly, 
                  $Heap, 
                  zero#0, 
                  add#0, 
                  inv#0, 
                  MultiSet#Difference(s#0, MultiSet#UnionOne(MultiSet#Empty(): MultiSet Box, a#0)))))));

// function declaration for Multisets._default.FoldSimple
function Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A: Ty, 
    zero#0: Box, 
    add#0: HandleType, 
    s#0: MultiSet Box)
   : Box;

function Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A: Ty, 
    zero#0: Box, 
    add#0: HandleType, 
    s#0: MultiSet Box)
   : bool;

// consequence axiom for Multisets.__default.FoldSimple
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
         || (
          $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> (MultiSet#Card(s#0) == LitInt(0)
           ==> Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
             == zero#0)
         && $IsBox(Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0), 
          Multisets._default.FoldSimple$A));

function Multisets.__default.FoldSimple#requires(Ty, Box, HandleType, MultiSet Box) : bool;

// #requires axiom for Multisets.__default.FoldSimple
axiom (forall Multisets._default.FoldSimple$A: Ty, 
    $Heap: Heap, 
    zero#0: Box, 
    add#0: HandleType, 
    s#0: MultiSet Box :: 
  { Multisets.__default.FoldSimple#requires(Multisets._default.FoldSimple$A, zero#0, add#0, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $IsBox(zero#0, Multisets._default.FoldSimple$A)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
          Multisets._default.FoldSimple$A, 
          Multisets._default.FoldSimple$A))
       && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A))
     ==> Multisets.__default.FoldSimple#requires(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
       == true);

// definition axiom for Multisets.__default.FoldSimple(revealed)
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0), $IsGoodHeap($Heap) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> Multisets.__default.Fold#canCall(Multisets._default.FoldSimple$A, 
          $Heap, 
          zero#0, 
          add#0, 
          Lit(AtLayer((lambda $l#1#ly#0: LayerType :: 
                Handle1((lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    $IsBox($l#1#x#0, Multisets._default.FoldSimple$A)), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), 
              $LS($LZ))), 
          s#0)
         && Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, s#0)
           == Multisets.__default.Fold(Multisets._default.FoldSimple$A, 
            StartFuel_Multisets._default.Fold, 
            $Heap, 
            zero#0, 
            add#0, 
            Lit(AtLayer((lambda $l#2#ly#0: LayerType :: 
                  Handle1((lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      $IsBox($l#2#x#0, Multisets._default.FoldSimple$A)), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), 
                $LS($LZ))), 
            s#0));

// definition axiom for Multisets.__default.FoldSimple for decreasing-related literals(revealed)
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    {:weight 3} { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, Lit(s#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, zero#0, add#0, Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> Multisets.__default.Fold#canCall(Multisets._default.FoldSimple$A, 
          $Heap, 
          zero#0, 
          add#0, 
          Lit(AtLayer((lambda $l#4#ly#0: LayerType :: 
                Handle1((lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    $IsBox($l#4#x#0, Multisets._default.FoldSimple$A)), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), 
              $LS($LZ))), 
          Lit(s#0))
         && Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, zero#0, add#0, Lit(s#0))
           == Multisets.__default.Fold(Multisets._default.FoldSimple$A, 
            StartFuel_Multisets._default.Fold, 
            $Heap, 
            zero#0, 
            add#0, 
            Lit(AtLayer((lambda $l#5#ly#0: LayerType :: 
                  Handle1((lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      $IsBox($l#5#x#0, Multisets._default.FoldSimple$A)), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), 
                $LS($LZ))), 
            Lit(s#0)));

// definition axiom for Multisets.__default.FoldSimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.FoldSimple$A: Ty, 
      $Heap: Heap, 
      zero#0: Box, 
      add#0: HandleType, 
      s#0: MultiSet Box :: 
    {:weight 3} { Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, Lit(zero#0), Lit(add#0), Lit(s#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.FoldSimple#canCall(Multisets._default.FoldSimple$A, Lit(zero#0), Lit(add#0), Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $IsBox(zero#0, Multisets._default.FoldSimple$A)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A, 
              Multisets._default.FoldSimple$A))
           && $Is(s#0, TMultiSet(Multisets._default.FoldSimple$A)))
       ==> Multisets.__default.Fold#canCall(Multisets._default.FoldSimple$A, 
          $Heap, 
          Lit(zero#0), 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#7#ly#0: LayerType :: 
                Handle1((lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    $IsBox($l#7#x#0, Multisets._default.FoldSimple$A)), 
                  (lambda $l#7#heap#0: Heap, $l#7#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#7#o#0: ref :: false))))), 
              $LS($LZ))), 
          Lit(s#0))
         && Multisets.__default.FoldSimple(Multisets._default.FoldSimple$A, Lit(zero#0), Lit(add#0), Lit(s#0))
           == Multisets.__default.Fold(Multisets._default.FoldSimple$A, 
            StartFuel_Multisets._default.Fold, 
            $Heap, 
            Lit(zero#0), 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#8#ly#0: LayerType :: 
                  Handle1((lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      $IsBox($l#8#x#0, Multisets._default.FoldSimple$A)), 
                    (lambda $l#8#heap#0: Heap, $l#8#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#8#o#0: ref :: false))))), 
                $LS($LZ))), 
            Lit(s#0)));

// function declaration for Multisets._default.IsIdentity
function Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box)
   : bool;

function Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A: Ty, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0) } 
  Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0)
     == Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0));

// fuel synonym axiom
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, AsFuelBottom($ly), $Heap, add#0, inv#0, zero#0) } 
  Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0)
     == Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LZ, $Heap, add#0, inv#0, zero#0));

// frame axiom for Multisets.__default.IsIdentity
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $h1, add#0, inv#0, zero#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A, $h0, add#0, inv#0, zero#0)
         || (
          $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
           && $IsBox(zero#0, Multisets._default.IsIdentity$A)))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.IsIdentity$A)
               && $IsBox(y#0, Multisets._default.IsIdentity$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                Multisets._default.IsIdentity$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $h0, add#0, inv#0, zero#0)
       == Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $h1, add#0, inv#0, zero#0));

// consequence axiom for Multisets.__default.IsIdentity
axiom true
   ==> (forall Multisets._default.IsIdentity$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType, 
      zero#0: Box :: 
    { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0) } 
    Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A, $Heap, add#0, inv#0, zero#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
           && $IsBox(zero#0, Multisets._default.IsIdentity$A))
       ==> true);

function Multisets.__default.IsIdentity#requires(Ty, LayerType, Heap, HandleType, HandleType, Box) : bool;

// #requires axiom for Multisets.__default.IsIdentity
axiom (forall Multisets._default.IsIdentity$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentity#requires(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
          Multisets._default.IsIdentity$A, 
          Multisets._default.IsIdentity$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
       && $IsBox(zero#0, Multisets._default.IsIdentity$A)
     ==> Multisets.__default.IsIdentity#requires(Multisets._default.IsIdentity$A, $ly, $Heap, add#0, inv#0, zero#0)
       == true);

// definition axiom for Multisets.__default.IsIdentity(revealed)
axiom true
   ==> (forall Multisets._default.IsIdentity$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType, 
      zero#0: Box :: 
    { Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0) } 
    Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentity$A, $Heap, add#0, inv#0, zero#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A, 
              Multisets._default.IsIdentity$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsIdentity$A, TBool))
           && $IsBox(zero#0, Multisets._default.IsIdentity$A))
       ==> Multisets.__default.Foldable#canCall(Multisets._default.IsIdentity$A, $Heap, zero#0, add#0, inv#0)
         && Multisets.__default.IsIdentity(Multisets._default.IsIdentity$A, $LS($ly), $Heap, add#0, inv#0, zero#0)
           == (Multisets.__default.Foldable(Multisets._default.IsIdentity$A, $Heap, zero#0, add#0, inv#0)
             && (forall a#0: Box :: 
              { Apply2(Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  $Heap, 
                  add#0, 
                  a#0, 
                  zero#0) } 
                { Apply2(Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  Multisets._default.IsIdentity$A, 
                  $Heap, 
                  add#0, 
                  zero#0, 
                  a#0) } 
                { $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $Heap, inv#0, a#0)): bool } 
              $IsBox(a#0, Multisets._default.IsIdentity$A)
                   && $Unbox(Apply1(Multisets._default.IsIdentity$A, TBool, $Heap, inv#0, a#0)): bool
                 ==> Apply2(Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      $Heap, 
                      add#0, 
                      zero#0, 
                      a#0)
                     == Apply2(Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      $Heap, 
                      add#0, 
                      a#0, 
                      zero#0)
                   && Apply2(Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      Multisets._default.IsIdentity$A, 
                      $Heap, 
                      add#0, 
                      a#0, 
                      zero#0)
                     == a#0)));

// function declaration for Multisets._default.IsCommutative
function Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

function Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A: Ty, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0)
     == Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0));

// fuel synonym axiom
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, AsFuelBottom($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0)
     == Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LZ, $Heap, add#0, inv#0));

// frame axiom for Multisets.__default.IsCommutative
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $h1, add#0, inv#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A, $h0, add#0, inv#0)
         || ($Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.IsCommutative$A)
               && $IsBox(y#0, Multisets._default.IsCommutative$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $h0, add#0, inv#0)
       == Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $h1, add#0, inv#0));

// consequence axiom for Multisets.__default.IsCommutative
axiom true
   ==> (forall Multisets._default.IsCommutative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0) } 
    Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))
           && (forall x#1: Box, y#1: Box :: 
            { Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#1, 
                y#1) } 
              { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#1)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#1)): bool } 
            $IsBox(x#1, Multisets._default.IsCommutative$A)
                 && $IsBox(y#1, Multisets._default.IsCommutative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#1)): bool
                 && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#1)): bool
               ==> Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#1, 
                y#1)))
       ==> true);

function Multisets.__default.IsCommutative#requires(Ty, LayerType, Heap, HandleType, HandleType) : bool;

// #requires axiom for Multisets.__default.IsCommutative
axiom (forall Multisets._default.IsCommutative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsCommutative#requires(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
          Multisets._default.IsCommutative$A, 
          Multisets._default.IsCommutative$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))
     ==> Multisets.__default.IsCommutative#requires(Multisets._default.IsCommutative$A, $ly, $Heap, add#0, inv#0)
       == (forall x#2: Box, y#2: Box :: 
        { Requires2(Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            $Heap, 
            add#0, 
            x#2, 
            y#2) } 
          { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#2)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#2)): bool } 
        $IsBox(x#2, Multisets._default.IsCommutative$A)
             && $IsBox(y#2, Multisets._default.IsCommutative$A)
             && 
            $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#2)): bool
             && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#2)): bool
           ==> Requires2(Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            Multisets._default.IsCommutative$A, 
            $Heap, 
            add#0, 
            x#2, 
            y#2)));

// definition axiom for Multisets.__default.IsCommutative(revealed)
axiom true
   ==> (forall Multisets._default.IsCommutative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0) } 
    Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsCommutative$A, TBool))
           && (forall x#2: Box, y#2: Box :: 
            { Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#2, 
                y#2) } 
              { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#2)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#2)): bool } 
            $IsBox(x#2, Multisets._default.IsCommutative$A)
                 && $IsBox(y#2, Multisets._default.IsCommutative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, x#2)): bool
                 && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, y#2)): bool
               ==> Requires2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                x#2, 
                y#2)))
       ==> Multisets.__default.IsCommutative(Multisets._default.IsCommutative$A, $LS($ly), $Heap, add#0, inv#0)
         == (forall a#0: Box, b#0: Box :: 
          { Apply2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              $Heap, 
              add#0, 
              b#0, 
              a#0) } 
            { Apply2(Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              Multisets._default.IsCommutative$A, 
              $Heap, 
              add#0, 
              a#0, 
              b#0) } 
            { $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, b#0)): bool, $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, a#0)): bool } 
          $IsBox(a#0, Multisets._default.IsCommutative$A)
               && $IsBox(b#0, Multisets._default.IsCommutative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, a#0)): bool
               && $Unbox(Apply1(Multisets._default.IsCommutative$A, TBool, $Heap, inv#0, b#0)): bool
             ==> Apply2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                a#0, 
                b#0)
               == Apply2(Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                Multisets._default.IsCommutative$A, 
                $Heap, 
                add#0, 
                b#0, 
                a#0)));

// function declaration for Multisets._default.IsAssociative
function Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

function Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A: Ty, 
    $heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType)
   : bool;

// layer synonym axiom
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0)
     == Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0));

// fuel synonym axiom
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, AsFuelBottom($ly), $Heap, add#0, inv#0) } 
  Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0)
     == Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LZ, $Heap, add#0, inv#0));

// frame axiom for Multisets.__default.IsAssociative
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $h0: Heap, 
    $h1: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $h1, add#0, inv#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A, $h0, add#0, inv#0)
         || ($Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && (exists x#0: Box, y#0: Box, o#0: ref :: 
            { Reads2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)] } 
            $IsBox(x#0, Multisets._default.IsAssociative$A)
               && $IsBox(y#0, Multisets._default.IsAssociative$A)
               && $Is(o#0, Tclass._System.object?())
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $h0, inv#0, x#0)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $h0, inv#0, y#0)): bool
               && Reads2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $h0, 
                add#0, 
                x#0, 
                y#0)[$Box(o#0)]
               && $Box($o) == $Box(o#0))
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $h0, add#0, inv#0)
       == Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $h1, add#0, inv#0));

// consequence axiom for Multisets.__default.IsAssociative
axiom true
   ==> (forall Multisets._default.IsAssociative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0) } 
    Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))
           && 
          (forall x#1: Box, y#1: Box :: 
            { Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#1, 
                y#1) } 
              { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#1)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#1)): bool } 
            $IsBox(x#1, Multisets._default.IsAssociative$A)
                 && $IsBox(y#1, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#1)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#1)): bool
               ==> Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#1, 
                y#1))
           && (forall x#2: Box, y#2: Box :: 
            { Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#2, 
                y#2) } 
            $IsBox(x#2, Multisets._default.IsAssociative$A)
                 && $IsBox(y#2, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#2)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#2)): bool
               ==> $Unbox(Apply1(Multisets._default.IsAssociative$A, 
                  TBool, 
                  $Heap, 
                  inv#0, 
                  Apply2(Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    $Heap, 
                    add#0, 
                    x#2, 
                    y#2))): bool))
       ==> true);

function Multisets.__default.IsAssociative#requires(Ty, LayerType, Heap, HandleType, HandleType) : bool;

// #requires axiom for Multisets.__default.IsAssociative
axiom (forall Multisets._default.IsAssociative$A: Ty, 
    $ly: LayerType, 
    $Heap: Heap, 
    add#0: HandleType, 
    inv#0: HandleType :: 
  { Multisets.__default.IsAssociative#requires(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
          Multisets._default.IsAssociative$A, 
          Multisets._default.IsAssociative$A))
       && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))
     ==> Multisets.__default.IsAssociative#requires(Multisets._default.IsAssociative$A, $ly, $Heap, add#0, inv#0)
       == ((forall x#3: Box, y#3: Box :: 
          { Requires2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              x#3, 
              y#3) } 
            { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#3)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#3)): bool } 
          $IsBox(x#3, Multisets._default.IsAssociative$A)
               && $IsBox(y#3, Multisets._default.IsAssociative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#3)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#3)): bool
             ==> Requires2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              x#3, 
              y#3))
         && (forall x#4: Box, y#4: Box :: 
          { Apply2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              x#4, 
              y#4) } 
          $IsBox(x#4, Multisets._default.IsAssociative$A)
               && $IsBox(y#4, Multisets._default.IsAssociative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#4)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#4)): bool
             ==> $Unbox(Apply1(Multisets._default.IsAssociative$A, 
                TBool, 
                $Heap, 
                inv#0, 
                Apply2(Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  $Heap, 
                  add#0, 
                  x#4, 
                  y#4))): bool)));

// definition axiom for Multisets.__default.IsAssociative(revealed)
axiom true
   ==> (forall Multisets._default.IsAssociative$A: Ty, 
      $ly: LayerType, 
      $Heap: Heap, 
      add#0: HandleType, 
      inv#0: HandleType :: 
    { Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0) } 
    Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociative$A, $Heap, add#0, inv#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hFunc2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A))
           && $Is(inv#0, Tclass._System.___hTotalFunc1(Multisets._default.IsAssociative$A, TBool))
           && 
          (forall x#3: Box, y#3: Box :: 
            { Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#3, 
                y#3) } 
              { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#3)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#3)): bool } 
            $IsBox(x#3, Multisets._default.IsAssociative$A)
                 && $IsBox(y#3, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#3)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#3)): bool
               ==> Requires2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#3, 
                y#3))
           && (forall x#4: Box, y#4: Box :: 
            { Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                x#4, 
                y#4) } 
            $IsBox(x#4, Multisets._default.IsAssociative$A)
                 && $IsBox(y#4, Multisets._default.IsAssociative$A)
                 && 
                $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, x#4)): bool
                 && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, y#4)): bool
               ==> $Unbox(Apply1(Multisets._default.IsAssociative$A, 
                  TBool, 
                  $Heap, 
                  inv#0, 
                  Apply2(Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    Multisets._default.IsAssociative$A, 
                    $Heap, 
                    add#0, 
                    x#4, 
                    y#4))): bool))
       ==> Multisets.__default.IsAssociative(Multisets._default.IsAssociative$A, $LS($ly), $Heap, add#0, inv#0)
         == (forall a#0: Box, b#0: Box, c#0: Box :: 
          { Apply2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              a#0, 
              Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                b#0, 
                c#0)) } 
            { Apply2(Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              Multisets._default.IsAssociative$A, 
              $Heap, 
              add#0, 
              Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                a#0, 
                b#0), 
              c#0) } 
            { $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, c#0)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, b#0)): bool, $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, a#0)): bool } 
          $IsBox(a#0, Multisets._default.IsAssociative$A)
               && $IsBox(b#0, Multisets._default.IsAssociative$A)
               && $IsBox(c#0, Multisets._default.IsAssociative$A)
               && 
              $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, a#0)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, b#0)): bool
               && $Unbox(Apply1(Multisets._default.IsAssociative$A, TBool, $Heap, inv#0, c#0)): bool
             ==> Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                Apply2(Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  $Heap, 
                  add#0, 
                  a#0, 
                  b#0), 
                c#0)
               == Apply2(Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                Multisets._default.IsAssociative$A, 
                $Heap, 
                add#0, 
                a#0, 
                Apply2(Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  Multisets._default.IsAssociative$A, 
                  $Heap, 
                  add#0, 
                  b#0, 
                  c#0))));

// function declaration for Multisets._default.IsIdentitySimple
function Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A: Ty, add#0: HandleType, zero#0: Box)
   : bool;

function Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A: Ty, add#0: HandleType, zero#0: Box)
   : bool;

// consequence axiom for Multisets.__default.IsIdentitySimple
axiom true
   ==> (forall Multisets._default.IsIdentitySimple$A: Ty, add#0: HandleType, zero#0: Box :: 
    { Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, add#0, zero#0) } 
    Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
         || ($Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A))
           && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A))
       ==> true);

function Multisets.__default.IsIdentitySimple#requires(Ty, HandleType, Box) : bool;

// #requires axiom for Multisets.__default.IsIdentitySimple
axiom (forall Multisets._default.IsIdentitySimple$A: Ty, 
    $Heap: Heap, 
    add#0: HandleType, 
    zero#0: Box :: 
  { Multisets.__default.IsIdentitySimple#requires(Multisets._default.IsIdentitySimple$A, add#0, zero#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
          Multisets._default.IsIdentitySimple$A, 
          Multisets._default.IsIdentitySimple$A))
       && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A)
     ==> Multisets.__default.IsIdentitySimple#requires(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
       == true);

// definition axiom for Multisets.__default.IsIdentitySimple(revealed)
axiom true
   ==> (forall Multisets._default.IsIdentitySimple$A: Ty, 
      $Heap: Heap, 
      add#0: HandleType, 
      zero#0: Box :: 
    { Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, add#0, zero#0), $IsGoodHeap($Heap) } 
    Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A))
           && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A))
       ==> Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentitySimple$A, 
          $Heap, 
          add#0, 
          Lit(AtLayer((lambda $l#1#ly#0: LayerType :: 
                Handle1((lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    $IsBox($l#1#x#0, Multisets._default.IsIdentitySimple$A)), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), 
              $LS($LZ))), 
          zero#0)
         && Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, add#0, zero#0)
           == Multisets.__default.IsIdentity(Multisets._default.IsIdentitySimple$A, 
            StartFuel_Multisets._default.IsIdentity, 
            $Heap, 
            add#0, 
            Lit(AtLayer((lambda $l#2#ly#0: LayerType :: 
                  Handle1((lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      $IsBox($l#2#x#0, Multisets._default.IsIdentitySimple$A)), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), 
                $LS($LZ))), 
            zero#0));

// definition axiom for Multisets.__default.IsIdentitySimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.IsIdentitySimple$A: Ty, 
      $Heap: Heap, 
      add#0: HandleType, 
      zero#0: Box :: 
    {:weight 3} { Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, Lit(add#0), Lit(zero#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.IsIdentitySimple#canCall(Multisets._default.IsIdentitySimple$A, Lit(add#0), Lit(zero#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A, 
              Multisets._default.IsIdentitySimple$A))
           && $IsBox(zero#0, Multisets._default.IsIdentitySimple$A))
       ==> Multisets.__default.IsIdentity#canCall(Multisets._default.IsIdentitySimple$A, 
          $Heap, 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#4#ly#0: LayerType :: 
                Handle1((lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    $IsBox($l#4#x#0, Multisets._default.IsIdentitySimple$A)), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), 
              $LS($LZ))), 
          Lit(zero#0))
         && Multisets.__default.IsIdentitySimple(Multisets._default.IsIdentitySimple$A, Lit(add#0), Lit(zero#0))
           == Multisets.__default.IsIdentity(Multisets._default.IsIdentitySimple$A, 
            StartFuel_Multisets._default.IsIdentity, 
            $Heap, 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#5#ly#0: LayerType :: 
                  Handle1((lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      $IsBox($l#5#x#0, Multisets._default.IsIdentitySimple$A)), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), 
                $LS($LZ))), 
            Lit(zero#0)));

// function declaration for Multisets._default.IsCommutativeSimple
function Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A: Ty, add#0: HandleType) : bool;

function Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A: Ty, add#0: HandleType) : bool;

// consequence axiom for Multisets.__default.IsCommutativeSimple
axiom true
   ==> (forall Multisets._default.IsCommutativeSimple$A: Ty, add#0: HandleType :: 
    { Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, add#0) } 
    Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A, add#0)
         || $Is(add#0, 
          Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
            Multisets._default.IsCommutativeSimple$A, 
            Multisets._default.IsCommutativeSimple$A))
       ==> true);

function Multisets.__default.IsCommutativeSimple#requires(Ty, HandleType) : bool;

// #requires axiom for Multisets.__default.IsCommutativeSimple
axiom (forall Multisets._default.IsCommutativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
  { Multisets.__default.IsCommutativeSimple#requires(Multisets._default.IsCommutativeSimple$A, add#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
          Multisets._default.IsCommutativeSimple$A, 
          Multisets._default.IsCommutativeSimple$A))
     ==> Multisets.__default.IsCommutativeSimple#requires(Multisets._default.IsCommutativeSimple$A, add#0)
       == true);

// definition axiom for Multisets.__default.IsCommutativeSimple(revealed)
axiom true
   ==> (forall Multisets._default.IsCommutativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    { Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, add#0), $IsGoodHeap($Heap) } 
    Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A, add#0)
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A)))
       ==> Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutativeSimple$A, 
          $Heap, 
          add#0, 
          Lit(AtLayer((lambda $l#1#ly#0: LayerType :: 
                Handle1((lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    $IsBox($l#1#x#0, Multisets._default.IsCommutativeSimple$A)), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, add#0)
           == Multisets.__default.IsCommutative(Multisets._default.IsCommutativeSimple$A, 
            StartFuel_Multisets._default.IsCommutative, 
            $Heap, 
            add#0, 
            Lit(AtLayer((lambda $l#2#ly#0: LayerType :: 
                  Handle1((lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      $IsBox($l#2#x#0, Multisets._default.IsCommutativeSimple$A)), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), 
                $LS($LZ)))));

// definition axiom for Multisets.__default.IsCommutativeSimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.IsCommutativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    {:weight 3} { Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, Lit(add#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.IsCommutativeSimple#canCall(Multisets._default.IsCommutativeSimple$A, Lit(add#0))
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A, 
              Multisets._default.IsCommutativeSimple$A)))
       ==> Multisets.__default.IsCommutative#canCall(Multisets._default.IsCommutativeSimple$A, 
          $Heap, 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#4#ly#0: LayerType :: 
                Handle1((lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    $IsBox($l#4#x#0, Multisets._default.IsCommutativeSimple$A)), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsCommutativeSimple(Multisets._default.IsCommutativeSimple$A, Lit(add#0))
           == Multisets.__default.IsCommutative(Multisets._default.IsCommutativeSimple$A, 
            StartFuel_Multisets._default.IsCommutative, 
            $Heap, 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#5#ly#0: LayerType :: 
                  Handle1((lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      $IsBox($l#5#x#0, Multisets._default.IsCommutativeSimple$A)), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), 
                $LS($LZ)))));

// function declaration for Multisets._default.IsAssociativeSimple
function Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A: Ty, add#0: HandleType) : bool;

function Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A: Ty, add#0: HandleType) : bool;

// consequence axiom for Multisets.__default.IsAssociativeSimple
axiom true
   ==> (forall Multisets._default.IsAssociativeSimple$A: Ty, add#0: HandleType :: 
    { Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, add#0) } 
    Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A, add#0)
         || $Is(add#0, 
          Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
            Multisets._default.IsAssociativeSimple$A, 
            Multisets._default.IsAssociativeSimple$A))
       ==> true);

function Multisets.__default.IsAssociativeSimple#requires(Ty, HandleType) : bool;

// #requires axiom for Multisets.__default.IsAssociativeSimple
axiom (forall Multisets._default.IsAssociativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
  { Multisets.__default.IsAssociativeSimple#requires(Multisets._default.IsAssociativeSimple$A, add#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(add#0, 
        Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
          Multisets._default.IsAssociativeSimple$A, 
          Multisets._default.IsAssociativeSimple$A))
     ==> Multisets.__default.IsAssociativeSimple#requires(Multisets._default.IsAssociativeSimple$A, add#0)
       == true);

// definition axiom for Multisets.__default.IsAssociativeSimple(revealed)
axiom true
   ==> (forall Multisets._default.IsAssociativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    { Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, add#0), $IsGoodHeap($Heap) } 
    Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A, add#0)
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A)))
       ==> Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociativeSimple$A, 
          $Heap, 
          add#0, 
          Lit(AtLayer((lambda $l#1#ly#0: LayerType :: 
                Handle1((lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    $IsBox($l#1#x#0, Multisets._default.IsAssociativeSimple$A)), 
                  (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, add#0)
           == Multisets.__default.IsAssociative(Multisets._default.IsAssociativeSimple$A, 
            StartFuel_Multisets._default.IsAssociative, 
            $Heap, 
            add#0, 
            Lit(AtLayer((lambda $l#2#ly#0: LayerType :: 
                  Handle1((lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      $IsBox($l#2#x#0, Multisets._default.IsAssociativeSimple$A)), 
                    (lambda $l#2#heap#0: Heap, $l#2#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#2#o#0: ref :: false))))), 
                $LS($LZ)))));

// definition axiom for Multisets.__default.IsAssociativeSimple for all literals(revealed)
axiom true
   ==> (forall Multisets._default.IsAssociativeSimple$A: Ty, $Heap: Heap, add#0: HandleType :: 
    {:weight 3} { Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, Lit(add#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.IsAssociativeSimple#canCall(Multisets._default.IsAssociativeSimple$A, Lit(add#0))
         || ($IsGoodHeap($Heap)
           && $Is(add#0, 
            Tclass._System.___hTotalFunc2(Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A, 
              Multisets._default.IsAssociativeSimple$A)))
       ==> Multisets.__default.IsAssociative#canCall(Multisets._default.IsAssociativeSimple$A, 
          $Heap, 
          Lit(add#0), 
          Lit(AtLayer((lambda $l#4#ly#0: LayerType :: 
                Handle1((lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: $Box(Lit(true))), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    $IsBox($l#4#x#0, Multisets._default.IsAssociativeSimple$A)), 
                  (lambda $l#4#heap#0: Heap, $l#4#x#0: Box :: 
                    SetRef_to_SetBox((lambda $l#4#o#0: ref :: false))))), 
              $LS($LZ))))
         && Multisets.__default.IsAssociativeSimple(Multisets._default.IsAssociativeSimple$A, Lit(add#0))
           == Multisets.__default.IsAssociative(Multisets._default.IsAssociativeSimple$A, 
            StartFuel_Multisets._default.IsAssociative, 
            $Heap, 
            Lit(add#0), 
            Lit(AtLayer((lambda $l#5#ly#0: LayerType :: 
                  Handle1((lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: $Box(Lit(true))), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      $IsBox($l#5#x#0, Multisets._default.IsAssociativeSimple$A)), 
                    (lambda $l#5#heap#0: Heap, $l#5#x#0: Box :: 
                      SetRef_to_SetBox((lambda $l#5#o#0: ref :: false))))), 
                $LS($LZ)))));

// function declaration for Multisets._default.AddNat
function Multisets.__default.AddNat(x#0: int, y#0: int) : int;

function Multisets.__default.AddNat#canCall(x#0: int, y#0: int) : bool;

// consequence axiom for Multisets.__default.AddNat
axiom true
   ==> (forall x#0: int, y#0: int :: 
    { Multisets.__default.AddNat(x#0, y#0) } 
    Multisets.__default.AddNat#canCall(x#0, y#0)
         || (LitInt(0) <= x#0 && LitInt(0) <= y#0)
       ==> LitInt(0) <= Multisets.__default.AddNat(x#0, y#0));

function Multisets.__default.AddNat#requires(int, int) : bool;

// #requires axiom for Multisets.__default.AddNat
axiom (forall x#0: int, y#0: int :: 
  { Multisets.__default.AddNat#requires(x#0, y#0) } 
  LitInt(0) <= x#0 && LitInt(0) <= y#0
     ==> Multisets.__default.AddNat#requires(x#0, y#0) == true);

// definition axiom for Multisets.__default.AddNat(revealed)
axiom true
   ==> (forall x#0: int, y#0: int :: 
    { Multisets.__default.AddNat(x#0, y#0) } 
    Multisets.__default.AddNat#canCall(x#0, y#0)
         || (LitInt(0) <= x#0 && LitInt(0) <= y#0)
       ==> Multisets.__default.AddNat(x#0, y#0) == x#0 + y#0);

// definition axiom for Multisets.__default.AddNat for all literals(revealed)
axiom true
   ==> (forall x#0: int, y#0: int :: 
    {:weight 3} { Multisets.__default.AddNat(LitInt(x#0), LitInt(y#0)) } 
    Multisets.__default.AddNat#canCall(LitInt(x#0), LitInt(y#0))
         || (LitInt(0) <= x#0 && LitInt(0) <= y#0)
       ==> Multisets.__default.AddNat(LitInt(x#0), LitInt(y#0)) == LitInt(x#0 + y#0));

// function declaration for Multisets._default.ValueMultisetFn
function Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A: Ty, 
    Multisets._default.ValueMultisetFn$B: Ty, 
    m#0: Map Box Box)
   : HandleType;

function Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A: Ty, 
    Multisets._default.ValueMultisetFn$B: Ty, 
    m#0: Map Box Box)
   : bool;

// consequence axiom for Multisets.__default.ValueMultisetFn
axiom true
   ==> (forall Multisets._default.ValueMultisetFn$A: Ty, 
      Multisets._default.ValueMultisetFn$B: Ty, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0) } 
    Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
       ==> $Is(Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0), 
        Tclass._System.___hFunc1(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B)));

function Multisets.__default.ValueMultisetFn#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Multisets.__default.ValueMultisetFn
axiom (forall Multisets._default.ValueMultisetFn$A: Ty, 
    Multisets._default.ValueMultisetFn$B: Ty, 
    m#0: Map Box Box :: 
  { Multisets.__default.ValueMultisetFn#requires(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0) } 
  $Is(m#0, 
      TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
     ==> Multisets.__default.ValueMultisetFn#requires(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
       == true);

// definition axiom for Multisets.__default.ValueMultisetFn(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultisetFn$A: Ty, 
      Multisets._default.ValueMultisetFn$B: Ty, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0) } 
    Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
       ==> Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B, m#0)
         == Lit(AtLayer((lambda $l#1#ly#0: LayerType :: 
              Handle1((lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: Map#Elements(m#0)[$l#1#x#0]), 
                (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                  $IsBox($l#1#x#0, Multisets._default.ValueMultisetFn$A)
                     && Map#Domain(m#0)[$l#1#x#0]), 
                (lambda $l#1#heap#0: Heap, $l#1#x#0: Box :: 
                  SetRef_to_SetBox((lambda $l#1#o#0: ref :: false))))), 
            $LS($LZ))));

// definition axiom for Multisets.__default.ValueMultisetFn for all literals(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultisetFn$A: Ty, 
      Multisets._default.ValueMultisetFn$B: Ty, 
      m#0: Map Box Box :: 
    {:weight 3} { Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, 
        Multisets._default.ValueMultisetFn$B, 
        Lit(m#0)) } 
    Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultisetFn$A, 
          Multisets._default.ValueMultisetFn$B, 
          Lit(m#0))
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultisetFn$A, Multisets._default.ValueMultisetFn$B))
       ==> Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultisetFn$A, 
          Multisets._default.ValueMultisetFn$B, 
          Lit(m#0))
         == Lit(AtLayer((lambda $l#3#ly#0: LayerType :: 
              Handle1((lambda $l#3#heap#0: Heap, $l#3#x#0: Box :: Map#Elements(Lit(m#0))[$l#3#x#0]), 
                (lambda $l#3#heap#0: Heap, $l#3#x#0: Box :: 
                  $IsBox($l#3#x#0, Multisets._default.ValueMultisetFn$A)
                     && Map#Domain(m#0)[$l#3#x#0]), 
                (lambda $l#3#heap#0: Heap, $l#3#x#0: Box :: 
                  SetRef_to_SetBox((lambda $l#3#o#0: ref :: false))))), 
            $LS($LZ))));

// function declaration for Multisets._default.ValueMultiset
function Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A: Ty, 
    Multisets._default.ValueMultiset$B: Ty, 
    m#0: Map Box Box)
   : MultiSet Box;

function Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A: Ty, 
    Multisets._default.ValueMultiset$B: Ty, 
    m#0: Map Box Box)
   : bool;

// consequence axiom for Multisets.__default.ValueMultiset
axiom true
   ==> (forall Multisets._default.ValueMultiset$A: Ty, 
      Multisets._default.ValueMultiset$B: Ty, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0) } 
    Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
         || $Is(m#0, 
          TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B))
       ==> $Is(Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), 
        TMultiSet(Multisets._default.ValueMultiset$B)));

function Multisets.__default.ValueMultiset#requires(Ty, Ty, Map Box Box) : bool;

// #requires axiom for Multisets.__default.ValueMultiset
axiom (forall Multisets._default.ValueMultiset$A: Ty, 
    Multisets._default.ValueMultiset$B: Ty, 
    $Heap: Heap, 
    m#0: Map Box Box :: 
  { Multisets.__default.ValueMultiset#requires(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, 
        TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B))
     ==> Multisets.__default.ValueMultiset#requires(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
       == true);

// definition axiom for Multisets.__default.ValueMultiset(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultiset$A: Ty, 
      Multisets._default.ValueMultiset$B: Ty, 
      $Heap: Heap, 
      m#0: Map Box Box :: 
    { Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), $IsGoodHeap($Heap) } 
    Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
         || ($IsGoodHeap($Heap)
           && $Is(m#0, 
            TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B)))
       ==> Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
         && Multisets.__default.Apply#canCall(Multisets._default.ValueMultiset$A, 
          Multisets._default.ValueMultiset$B, 
          $Heap, 
          Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), 
          MultiSet#FromSet(Map#Domain(m#0)))
         && Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0)
           == Multisets.__default.Apply(Multisets._default.ValueMultiset$A, 
            Multisets._default.ValueMultiset$B, 
            StartFuel_Multisets._default.Apply, 
            $Heap, 
            Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, m#0), 
            MultiSet#FromSet(Map#Domain(m#0))));

// definition axiom for Multisets.__default.ValueMultiset for all literals(revealed)
axiom true
   ==> (forall Multisets._default.ValueMultiset$A: Ty, 
      Multisets._default.ValueMultiset$B: Ty, 
      $Heap: Heap, 
      m#0: Map Box Box :: 
    {:weight 3} { Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0)), $IsGoodHeap($Heap) } 
    Multisets.__default.ValueMultiset#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))
         || ($IsGoodHeap($Heap)
           && $Is(m#0, 
            TMap(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B)))
       ==> Multisets.__default.ValueMultisetFn#canCall(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))
         && Multisets.__default.Apply#canCall(Multisets._default.ValueMultiset$A, 
          Multisets._default.ValueMultiset$B, 
          $Heap, 
          Lit(Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))), 
          MultiSet#FromSet(Lit(Map#Domain(Lit(m#0)))))
         && Multisets.__default.ValueMultiset(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))
           == Multisets.__default.Apply(Multisets._default.ValueMultiset$A, 
            Multisets._default.ValueMultiset$B, 
            StartFuel_Multisets._default.Apply, 
            $Heap, 
            Lit(Multisets.__default.ValueMultisetFn(Multisets._default.ValueMultiset$A, Multisets._default.ValueMultiset$B, Lit(m#0))), 
            MultiSet#FromSet(Lit(Map#Domain(Lit(m#0))))));

// Constructor function declaration
function #BucketsLib.Bucket.BucketMapWithSeq(Map Box Box, Seq Box, Seq Box) : DatatypeType;

const unique ##BucketsLib.Bucket.BucketMapWithSeq: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Map Box Box, a#0#1#0: Seq Box, a#0#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#BucketsLib.Bucket.BucketMapWithSeq(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##BucketsLib.Bucket.BucketMapWithSeq);

function BucketsLib.Bucket.BucketMapWithSeq_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BucketsLib.Bucket.BucketMapWithSeq_q(d) } 
  BucketsLib.Bucket.BucketMapWithSeq_q(d)
     <==> DatatypeCtorId(d) == ##BucketsLib.Bucket.BucketMapWithSeq);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BucketsLib.Bucket.BucketMapWithSeq_q(d) } 
  BucketsLib.Bucket.BucketMapWithSeq_q(d)
     ==> (exists a#1#0#0: Map Box Box, a#1#1#0: Seq Box, a#1#2#0: Seq Box :: 
      d == #BucketsLib.Bucket.BucketMapWithSeq(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.BucketsLib.Bucket() : Ty;

// Tclass.BucketsLib.Bucket Tag
axiom Tag(Tclass.BucketsLib.Bucket()) == Tagclass.BucketsLib.Bucket;

const unique Tagclass.BucketsLib.Bucket: TyTag;

// Box/unbox axiom for Tclass.BucketsLib.Bucket
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketsLib.Bucket()) } 
  $IsBox(bx, Tclass.BucketsLib.Bucket())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BucketsLib.Bucket()));

// Constructor $Is
axiom (forall a#2#0#0: Map Box Box, a#2#1#0: Seq Box, a#2#2#0: Seq Box :: 
  { $Is(#BucketsLib.Bucket.BucketMapWithSeq(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketsLib.Bucket()) } 
  $Is(#BucketsLib.Bucket.BucketMapWithSeq(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.BucketsLib.Bucket())
     <==> $Is(a#2#0#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       && $Is(a#2#1#0, TSeq(Tclass.KeyType.Key()))
       && $Is(a#2#2#0, TSeq(Tclass.ValueMessage.Message())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Map Box Box, a#3#1#0: Seq Box, a#3#2#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#BucketsLib.Bucket.BucketMapWithSeq(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.BucketsLib.Bucket(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BucketsLib.Bucket.BucketMapWithSeq(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.BucketsLib.Bucket(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.KeyType.Key()), $h)
         && $IsAlloc(a#3#2#0, TSeq(Tclass.ValueMessage.Message()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketsLib.Bucket.b(d), 
      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BucketsLib.Bucket.BucketMapWithSeq_q(d)
       && $IsAlloc(d, Tclass.BucketsLib.Bucket(), $h)
     ==> $IsAlloc(BucketsLib.Bucket.b(d), 
      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketsLib.Bucket.keys(d), TSeq(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketsLib.Bucket.BucketMapWithSeq_q(d)
       && $IsAlloc(d, Tclass.BucketsLib.Bucket(), $h)
     ==> $IsAlloc(BucketsLib.Bucket.keys(d), TSeq(Tclass.KeyType.Key()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BucketsLib.Bucket.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h) } 
  $IsGoodHeap($h)
       && 
      BucketsLib.Bucket.BucketMapWithSeq_q(d)
       && $IsAlloc(d, Tclass.BucketsLib.Bucket(), $h)
     ==> $IsAlloc(BucketsLib.Bucket.msgs(d), TSeq(Tclass.ValueMessage.Message()), $h));

// Constructor literal
axiom (forall a#4#0#0: Map Box Box, a#4#1#0: Seq Box, a#4#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0)) } 
  #BucketsLib.Bucket.BucketMapWithSeq(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0))
     == Lit(#BucketsLib.Bucket.BucketMapWithSeq(a#4#0#0, a#4#1#0, a#4#2#0)));

function BucketsLib.Bucket.b(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#5#0#0: Map Box Box, a#5#1#0: Seq Box, a#5#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#5#0#0, a#5#1#0, a#5#2#0) } 
  BucketsLib.Bucket.b(#BucketsLib.Bucket.BucketMapWithSeq(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive map key rank
axiom (forall a#6#0#0: Map Box Box, a#6#1#0: Seq Box, a#6#2#0: Seq Box, d: DatatypeType :: 
  { Map#Domain(a#6#0#0)[$Box(d)], #BucketsLib.Bucket.BucketMapWithSeq(a#6#0#0, a#6#1#0, a#6#2#0) } 
  Map#Domain(a#6#0#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#6#0#0, a#6#1#0, a#6#2#0)));

// Inductive map value rank
axiom (forall a#7#0#0: Map Box Box, a#7#1#0: Seq Box, a#7#2#0: Seq Box, bx: Box :: 
  { Map#Domain(a#7#0#0)[bx], #BucketsLib.Bucket.BucketMapWithSeq(a#7#0#0, a#7#1#0, a#7#2#0) } 
  Map#Domain(a#7#0#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#7#0#0)[bx]): DatatypeType)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#7#0#0, a#7#1#0, a#7#2#0)));

function BucketsLib.Bucket.keys(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Map Box Box, a#8#1#0: Seq Box, a#8#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#8#0#0, a#8#1#0, a#8#2#0) } 
  BucketsLib.Bucket.keys(#BucketsLib.Bucket.BucketMapWithSeq(a#8#0#0, a#8#1#0, a#8#2#0))
     == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Map Box Box, a#9#1#0: Seq Box, a#9#2#0: Seq Box, i: int :: 
  { Seq#Index(a#9#1#0, i), #BucketsLib.Bucket.BucketMapWithSeq(a#9#0#0, a#9#1#0, a#9#2#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#9#0#0, a#9#1#0, a#9#2#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Map Box Box, a#10#1#0: Seq Box, a#10#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#10#0#0, a#10#1#0, a#10#2#0) } 
  Seq#Rank(a#10#1#0)
     < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#10#0#0, a#10#1#0, a#10#2#0)));

function BucketsLib.Bucket.msgs(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#11#0#0: Map Box Box, a#11#1#0: Seq Box, a#11#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#11#0#0, a#11#1#0, a#11#2#0) } 
  BucketsLib.Bucket.msgs(#BucketsLib.Bucket.BucketMapWithSeq(a#11#0#0, a#11#1#0, a#11#2#0))
     == a#11#2#0);

// Inductive seq element rank
axiom (forall a#12#0#0: Map Box Box, a#12#1#0: Seq Box, a#12#2#0: Seq Box, i: int :: 
  { Seq#Index(a#12#2#0, i), #BucketsLib.Bucket.BucketMapWithSeq(a#12#0#0, a#12#1#0, a#12#2#0) } 
  0 <= i && i < Seq#Length(a#12#2#0)
     ==> DtRank($Unbox(Seq#Index(a#12#2#0, i)): DatatypeType)
       < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#12#0#0, a#12#1#0, a#12#2#0)));

// Inductive seq rank
axiom (forall a#13#0#0: Map Box Box, a#13#1#0: Seq Box, a#13#2#0: Seq Box :: 
  { #BucketsLib.Bucket.BucketMapWithSeq(a#13#0#0, a#13#1#0, a#13#2#0) } 
  Seq#Rank(a#13#2#0)
     < DtRank(#BucketsLib.Bucket.BucketMapWithSeq(a#13#0#0, a#13#1#0, a#13#2#0)));

// Depth-one case-split function
function $IsA#BucketsLib.Bucket(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BucketsLib.Bucket(d) } 
  $IsA#BucketsLib.Bucket(d) ==> BucketsLib.Bucket.BucketMapWithSeq_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BucketsLib.Bucket.BucketMapWithSeq_q(d), $Is(d, Tclass.BucketsLib.Bucket()) } 
  $Is(d, Tclass.BucketsLib.Bucket()) ==> BucketsLib.Bucket.BucketMapWithSeq_q(d));

// Datatype extensional equality declaration
function BucketsLib.Bucket#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BucketsLib.Bucket.BucketMapWithSeq
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketsLib.Bucket#Equal(a, b) } 
  true
     ==> (BucketsLib.Bucket#Equal(a, b)
       <==> Map#Equal(BucketsLib.Bucket.b(a), BucketsLib.Bucket.b(b))
         && Seq#Equal(BucketsLib.Bucket.keys(a), BucketsLib.Bucket.keys(b))
         && Seq#Equal(BucketsLib.Bucket.msgs(a), BucketsLib.Bucket.msgs(b))));

// Datatype extensionality axiom: BucketsLib.Bucket
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BucketsLib.Bucket#Equal(a, b) } 
  BucketsLib.Bucket#Equal(a, b) <==> a == b);

const unique class.BucketsLib.Bucket: ClassName;

const unique class.BucketsLib.__default: ClassName;

function Tclass.BucketsLib.__default() : Ty;

// Tclass.BucketsLib.__default Tag
axiom Tag(Tclass.BucketsLib.__default()) == Tagclass.BucketsLib.__default;

const unique Tagclass.BucketsLib.__default: TyTag;

// Box/unbox axiom for Tclass.BucketsLib.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketsLib.__default()) } 
  $IsBox(bx, Tclass.BucketsLib.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BucketsLib.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BucketsLib.__default()) } 
  $Is($o, Tclass.BucketsLib.__default())
     <==> $o == null || dtype($o) == Tclass.BucketsLib.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BucketsLib.__default(), $h) } 
  $IsAlloc($o, Tclass.BucketsLib.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BucketsLib._default.maximumKey
function BucketsLib.__default.maximumKey(b#0: Set Box) : DatatypeType;

function BucketsLib.__default.maximumKey#canCall(b#0: Set Box) : bool;

// consequence axiom for BucketsLib.__default.maximumKey
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.maximumKey(b#0) } 
    BucketsLib.__default.maximumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.maximumKey(b#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function BucketsLib.__default.maximumKey#requires(Set Box) : bool;

// #requires axiom for BucketsLib.__default.maximumKey
axiom (forall b#0: Set Box :: 
  { BucketsLib.__default.maximumKey#requires(b#0) } 
  $Is(b#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.maximumKey#requires(b#0) == true);

// definition axiom for BucketsLib.__default.maximumKey(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.maximumKey(b#0) } 
    BucketsLib.__default.maximumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(b#0)
         && BucketsLib.__default.maximumKey(b#0)
           == (var m#0 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, b#0); 
            (if Options.Option.Some_q(m#0)
               then (var k#0 := $Unbox(Options.Option.value(m#0)): Seq Box; 
                #Options.Option.Some($Box(k#0)))
               else #Options.Option.None())));

// definition axiom for BucketsLib.__default.maximumKey for all literals(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.maximumKey(Lit(b#0)) } 
    BucketsLib.__default.maximumKey#canCall(Lit(b#0))
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(b#0))
         && BucketsLib.__default.maximumKey(Lit(b#0))
           == (var m#1 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, Lit(b#0)); 
            (if Options.Option.Some_q(m#1)
               then (var k#1 := $Unbox(Options.Option.value(m#1)): Seq Box; 
                #Options.Option.Some($Box(k#1)))
               else #Options.Option.None())));

// function declaration for BucketsLib._default.minimumKey
function BucketsLib.__default.minimumKey(b#0: Set Box) : DatatypeType;

function BucketsLib.__default.minimumKey#canCall(b#0: Set Box) : bool;

// consequence axiom for BucketsLib.__default.minimumKey
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.minimumKey(b#0) } 
    BucketsLib.__default.minimumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.minimumKey(b#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function BucketsLib.__default.minimumKey#requires(Set Box) : bool;

// #requires axiom for BucketsLib.__default.minimumKey
axiom (forall b#0: Set Box :: 
  { BucketsLib.__default.minimumKey#requires(b#0) } 
  $Is(b#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.minimumKey#requires(b#0) == true);

// definition axiom for BucketsLib.__default.minimumKey(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    { BucketsLib.__default.minimumKey(b#0) } 
    BucketsLib.__default.minimumKey#canCall(b#0)
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.minimumOpt#canCall(b#0)
         && BucketsLib.__default.minimumKey(b#0)
           == (var m#0 := Lexicographic__Byte__Order.__default.minimumOpt(StartFuel_Lexicographic_Byte_Order._default.minimumOpt, b#0); 
            (if Options.Option.Some_q(m#0)
               then (var k#0 := $Unbox(Options.Option.value(m#0)): Seq Box; 
                #Options.Option.Some($Box(k#0)))
               else #Options.Option.None())));

// definition axiom for BucketsLib.__default.minimumKey for all literals(revealed)
axiom true
   ==> (forall b#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.minimumKey(Lit(b#0)) } 
    BucketsLib.__default.minimumKey#canCall(Lit(b#0))
         || $Is(b#0, TSet(Tclass.KeyType.Key()))
       ==> Lexicographic__Byte__Order.__default.minimumOpt#canCall(Lit(b#0))
         && BucketsLib.__default.minimumKey(Lit(b#0))
           == (var m#1 := Lexicographic__Byte__Order.__default.minimumOpt(StartFuel_Lexicographic_Byte_Order._default.minimumOpt, Lit(b#0)); 
            (if Options.Option.Some_q(m#1)
               then (var k#1 := $Unbox(Options.Option.value(m#1)): Seq Box; 
                #Options.Option.Some($Box(k#1)))
               else #Options.Option.None())));

// function declaration for BucketsLib._default.BucketMapOfSeq
function BucketsLib.__default.BucketMapOfSeq($ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box) : Map Box Box;

function BucketsLib.__default.BucketMapOfSeq#canCall(keys#0: Seq Box, msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0) } 
  BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0)
     == BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketMapOfSeq(AsFuelBottom($ly), keys#0, msgs#0) } 
  BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0)
     == BucketsLib.__default.BucketMapOfSeq($LZ, keys#0, msgs#0));

// consequence axiom for BucketsLib.__default.BucketMapOfSeq
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0) } 
    BucketsLib.__default.BucketMapOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> Set#Equal(Map#Domain(BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0)), 
          Sequences.__default.Set(Tclass.KeyType.Key(), keys#0))
         && Set#Subset(Map#Values(BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0)), 
          Sequences.__default.Set(Tclass.ValueMessage.Message(), msgs#0))
         && $Is(BucketsLib.__default.BucketMapOfSeq($ly, keys#0, msgs#0), 
          TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function BucketsLib.__default.BucketMapOfSeq#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketMapOfSeq
axiom (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketMapOfSeq#requires($ly, keys#0, msgs#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.BucketMapOfSeq#requires($ly, keys#0, msgs#0)
       == 
      (Seq#Length(keys#0)
       == Seq#Length(msgs#0)));

// definition axiom for BucketsLib.__default.BucketMapOfSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0) } 
    BucketsLib.__default.BucketMapOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> (Seq#Length(keys#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), keys#0)
             && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), msgs#0)
             && BucketsLib.__default.BucketMapOfSeq#canCall(Sequences.__default.DropLast(Tclass.KeyType.Key(), keys#0), 
              Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), keys#0)
             && Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), msgs#0))
         && BucketsLib.__default.BucketMapOfSeq($LS($ly), keys#0, msgs#0)
           == (if Seq#Length(keys#0) == LitInt(0)
             then Map#Empty(): Map Box Box
             else (var r'#0 := BucketsLib.__default.BucketMapOfSeq($ly, 
                  Sequences.__default.DropLast(Tclass.KeyType.Key(), keys#0), 
                  Sequences.__default.DropLast(Tclass.ValueMessage.Message(), msgs#0)); 
              (var r#0 := Map#Build(r'#0, 
                    Sequences.__default.Last(Tclass.KeyType.Key(), keys#0), 
                    Sequences.__default.Last(Tclass.ValueMessage.Message(), msgs#0)); 
                r#0))));

// definition axiom for BucketsLib.__default.BucketMapOfSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, msgs#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketMapOfSeq($LS($ly), Lit(keys#0), Lit(msgs#0)) } 
    BucketsLib.__default.BucketMapOfSeq#canCall(Lit(keys#0), Lit(msgs#0))
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(Lit(keys#0)) == Seq#Length(Lit(msgs#0)))
       ==> (Seq#Length(Lit(keys#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(keys#0))
             && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0))
             && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(keys#0))), 
              Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(keys#0))
             && Sequences.__default.Last#canCall(Tclass.ValueMessage.Message(), Lit(msgs#0)))
         && BucketsLib.__default.BucketMapOfSeq($LS($ly), Lit(keys#0), Lit(msgs#0))
           == (if Seq#Length(Lit(keys#0)) == LitInt(0)
             then Map#Empty(): Map Box Box
             else (var r'#1 := BucketsLib.__default.BucketMapOfSeq($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(keys#0))), 
                  Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(msgs#0)))); 
              (var r#1 := Map#Build(r'#1, 
                    $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(keys#0))): Seq Box)), 
                    $Box(Lit($Unbox(Sequences.__default.Last(Tclass.ValueMessage.Message(), Lit(msgs#0))): DatatypeType))); 
                r#1))));

// function declaration for BucketsLib._default.BucketOfSeq
function BucketsLib.__default.BucketOfSeq(keys#0: Seq Box, msgs#0: Seq Box) : DatatypeType;

function BucketsLib.__default.BucketOfSeq#canCall(keys#0: Seq Box, msgs#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketOfSeq
axiom true
   ==> (forall keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketOfSeq(keys#0, msgs#0) } 
    BucketsLib.__default.BucketOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> $Is(BucketsLib.__default.BucketOfSeq(keys#0, msgs#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketOfSeq#requires(Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketOfSeq
axiom (forall keys#0: Seq Box, msgs#0: Seq Box :: 
  { BucketsLib.__default.BucketOfSeq#requires(keys#0, msgs#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.BucketOfSeq#requires(keys#0, msgs#0)
       == 
      (Seq#Length(keys#0)
       == Seq#Length(msgs#0)));

// definition axiom for BucketsLib.__default.BucketOfSeq(revealed)
axiom true
   ==> (forall keys#0: Seq Box, msgs#0: Seq Box :: 
    { BucketsLib.__default.BucketOfSeq(keys#0, msgs#0) } 
    BucketsLib.__default.BucketOfSeq#canCall(keys#0, msgs#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(keys#0) == Seq#Length(msgs#0))
       ==> BucketsLib.__default.BucketMapOfSeq#canCall(keys#0, msgs#0)
         && BucketsLib.__default.BucketOfSeq(keys#0, msgs#0)
           == #BucketsLib.Bucket.BucketMapWithSeq(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, keys#0, msgs#0), 
            keys#0, 
            msgs#0));

// definition axiom for BucketsLib.__default.BucketOfSeq for all literals(revealed)
axiom true
   ==> (forall keys#0: Seq Box, msgs#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketOfSeq(Lit(keys#0), Lit(msgs#0)) } 
    BucketsLib.__default.BucketOfSeq#canCall(Lit(keys#0), Lit(msgs#0))
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
           && Seq#Length(Lit(keys#0)) == Seq#Length(Lit(msgs#0)))
       ==> BucketsLib.__default.BucketMapOfSeq#canCall(Lit(keys#0), Lit(msgs#0))
         && BucketsLib.__default.BucketOfSeq(Lit(keys#0), Lit(msgs#0))
           == #BucketsLib.Bucket.BucketMapWithSeq(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, Lit(keys#0), Lit(msgs#0)), 
            Lit(keys#0), 
            Lit(msgs#0)));

// function declaration for BucketsLib._default.WFBucketMap
function BucketsLib.__default.WFBucketMap(bucket#0: Map Box Box) : bool;

function BucketsLib.__default.WFBucketMap#canCall(bucket#0: Map Box Box) : bool;

// consequence axiom for BucketsLib.__default.WFBucketMap
axiom true
   ==> (forall bucket#0: Map Box Box :: 
    { BucketsLib.__default.WFBucketMap(bucket#0) } 
    BucketsLib.__default.WFBucketMap#canCall(bucket#0)
         || $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> true);

function BucketsLib.__default.WFBucketMap#requires(Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.WFBucketMap
axiom (forall bucket#0: Map Box Box :: 
  { BucketsLib.__default.WFBucketMap#requires(bucket#0) } 
  $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.WFBucketMap#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.WFBucketMap(revealed)
axiom true
   ==> (forall bucket#0: Map Box Box :: 
    { BucketsLib.__default.WFBucketMap(bucket#0) } 
    BucketsLib.__default.WFBucketMap#canCall(bucket#0)
         || $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(bucket#0)[$Box(key#0)]): DatatypeType } 
            { Map#Domain(bucket#0)[$Box(key#0)] } 
          $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Map#Domain(bucket#0)[$Box(key#0)]
             ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(bucket#0)[$Box(key#0)]): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFBucketMap(bucket#0)
           == (forall key#0: Seq Box :: 
            { $Unbox(Map#Elements(bucket#0)[$Box(key#0)]): DatatypeType } 
              { Map#Domain(bucket#0)[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte())) && Map#Domain(bucket#0)[$Box(key#0)]
               ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(bucket#0)[$Box(key#0)]): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// definition axiom for BucketsLib.__default.WFBucketMap for all literals(revealed)
axiom true
   ==> (forall bucket#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.WFBucketMap(Lit(bucket#0)) } 
    BucketsLib.__default.WFBucketMap#canCall(Lit(bucket#0))
         || $Is(bucket#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (forall key#1: Seq Box :: 
          { $Unbox(Map#Elements(bucket#0)[$Box(key#1)]): DatatypeType } 
            { Map#Domain(bucket#0)[$Box(key#1)] } 
          $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
             ==> 
            Map#Domain(bucket#0)[$Box(key#1)]
             ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(Lit(bucket#0))[$Box(key#1)]): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFBucketMap(Lit(bucket#0))
           == (forall key#1: Seq Box :: 
            { $Unbox(Map#Elements(bucket#0)[$Box(key#1)]): DatatypeType } 
              { Map#Domain(bucket#0)[$Box(key#1)] } 
            $Is(key#1, TSeq(Tclass.NativeTypes.byte())) && Map#Domain(bucket#0)[$Box(key#1)]
               ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(Lit(bucket#0))[$Box(key#1)]): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// function declaration for BucketsLib._default.WFMessageSeq
function BucketsLib.__default.WFMessageSeq(messages#0: Seq Box) : bool;

function BucketsLib.__default.WFMessageSeq#canCall(messages#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.WFMessageSeq
axiom true
   ==> (forall messages#0: Seq Box :: 
    { BucketsLib.__default.WFMessageSeq(messages#0) } 
    BucketsLib.__default.WFMessageSeq#canCall(messages#0)
         || $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
       ==> true);

function BucketsLib.__default.WFMessageSeq#requires(Seq Box) : bool;

// #requires axiom for BucketsLib.__default.WFMessageSeq
axiom (forall messages#0: Seq Box :: 
  { BucketsLib.__default.WFMessageSeq#requires(messages#0) } 
  $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.WFMessageSeq#requires(messages#0) == true);

// definition axiom for BucketsLib.__default.WFMessageSeq(revealed)
axiom true
   ==> (forall messages#0: Seq Box :: 
    { BucketsLib.__default.WFMessageSeq(messages#0) } 
    BucketsLib.__default.WFMessageSeq#canCall(messages#0)
         || $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(messages#0, i#0)): DatatypeType } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(messages#0)
             ==> $IsA#ValueMessage.Message($Unbox(Seq#Index(messages#0, i#0)): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFMessageSeq(messages#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(messages#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(messages#0)
               ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(messages#0, i#0)): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// definition axiom for BucketsLib.__default.WFMessageSeq for all literals(revealed)
axiom true
   ==> (forall messages#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.WFMessageSeq(Lit(messages#0)) } 
    BucketsLib.__default.WFMessageSeq#canCall(Lit(messages#0))
         || $Is(messages#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(messages#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(messages#0))
             ==> $IsA#ValueMessage.Message($Unbox(Seq#Index(Lit(messages#0), i#1)): DatatypeType)
               && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
               && ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.WFMessageSeq(Lit(messages#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(messages#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(messages#0))
               ==> !ValueMessage.Message#Equal($Unbox(Seq#Index(Lit(messages#0), i#1)): DatatypeType, 
                ValueMessage.__default.IdentityMessage())));

// function declaration for BucketsLib._default.PreWFBucket
function BucketsLib.__default.PreWFBucket(bucket#0: DatatypeType) : bool;

function BucketsLib.__default.PreWFBucket#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.PreWFBucket
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.PreWFBucket(bucket#0) } 
    BucketsLib.__default.PreWFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> true);

function BucketsLib.__default.PreWFBucket#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.PreWFBucket
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.PreWFBucket#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.PreWFBucket#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.PreWFBucket(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.PreWFBucket(bucket#0) } 
    BucketsLib.__default.PreWFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Seq#Length(BucketsLib.Bucket.keys(bucket#0))
             == Seq#Length(BucketsLib.Bucket.msgs(bucket#0))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.BucketMapOfSeq#canCall(BucketsLib.Bucket.keys(bucket#0), BucketsLib.Bucket.msgs(bucket#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
         && BucketsLib.__default.PreWFBucket(bucket#0)
           == (Seq#Length(BucketsLib.Bucket.keys(bucket#0))
               == Seq#Length(BucketsLib.Bucket.msgs(bucket#0))
             && Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
                BucketsLib.Bucket.keys(bucket#0), 
                BucketsLib.Bucket.msgs(bucket#0)), 
              BucketsLib.Bucket.b(bucket#0))));

// definition axiom for BucketsLib.__default.PreWFBucket for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.PreWFBucket(Lit(bucket#0)) } 
    BucketsLib.__default.PreWFBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
             == Seq#Length(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), 
              Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
         && BucketsLib.__default.PreWFBucket(Lit(bucket#0))
           == (Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
               == Seq#Length(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
             && Map#Equal(BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
                Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), 
                Lit(BucketsLib.Bucket.msgs(Lit(bucket#0)))), 
              BucketsLib.Bucket.b(Lit(bucket#0)))));

// function declaration for BucketsLib._default.WFBucket
function BucketsLib.__default.WFBucket(bucket#0: DatatypeType) : bool;

function BucketsLib.__default.WFBucket#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.WFBucket
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.WFBucket(bucket#0) } 
    BucketsLib.__default.WFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> true);

function BucketsLib.__default.WFBucket#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.WFBucket
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.WFBucket#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.WFBucket#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.WFBucket(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.WFBucket(bucket#0) } 
    BucketsLib.__default.WFBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.__default.PreWFBucket#canCall(bucket#0)
         && (BucketsLib.__default.PreWFBucket(bucket#0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(bucket#0)))
         && (BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.WFBucketMap#canCall(BucketsLib.Bucket.b(bucket#0))
             && BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.WFMessageSeq#canCall(BucketsLib.Bucket.msgs(bucket#0)))
         && BucketsLib.__default.WFBucket(bucket#0)
           == (
            BucketsLib.__default.PreWFBucket(bucket#0)
             && BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
             && BucketsLib.__default.WFMessageSeq(BucketsLib.Bucket.msgs(bucket#0))));

// definition axiom for BucketsLib.__default.WFBucket for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.WFBucket(Lit(bucket#0)) } 
    BucketsLib.__default.WFBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.__default.PreWFBucket#canCall(Lit(bucket#0))
         && (Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0)))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.WFBucketMap#canCall(Lit(BucketsLib.Bucket.b(Lit(bucket#0)))))
         && (BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.WFBucketMap#canCall(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))
             && Lit(BucketsLib.__default.WFBucketMap(Lit(BucketsLib.Bucket.b(Lit(bucket#0)))))
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.WFMessageSeq#canCall(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0)))))
         && BucketsLib.__default.WFBucket(Lit(bucket#0))
           == Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0))
               && BucketsLib.__default.WFBucketMap(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))
               && BucketsLib.__default.WFMessageSeq(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))));

// function declaration for BucketsLib._default.BucketWellMarshalled
function BucketsLib.__default.BucketWellMarshalled(bucket#0: DatatypeType) : bool;

function BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketWellMarshalled
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketWellMarshalled(bucket#0) } 
    BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> true);

function BucketsLib.__default.BucketWellMarshalled#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketWellMarshalled
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.BucketWellMarshalled#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.BucketWellMarshalled#requires(bucket#0) == true);

// definition axiom for BucketsLib.__default.BucketWellMarshalled(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketWellMarshalled(bucket#0) } 
    BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(BucketsLib.Bucket.keys(bucket#0))
         && BucketsLib.__default.BucketWellMarshalled(bucket#0)
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            BucketsLib.Bucket.keys(bucket#0)));

// definition axiom for BucketsLib.__default.BucketWellMarshalled for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)) } 
    BucketsLib.__default.BucketWellMarshalled#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0))
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))));

// function declaration for BucketsLib._default.BucketListWellMarshalled
function BucketsLib.__default.BucketListWellMarshalled(blist#0: Seq Box) : bool;

function BucketsLib.__default.BucketListWellMarshalled#canCall(blist#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketListWellMarshalled
axiom true
   ==> (forall blist#0: Seq Box :: 
    { BucketsLib.__default.BucketListWellMarshalled(blist#0) } 
    BucketsLib.__default.BucketListWellMarshalled#canCall(blist#0)
         || $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> true);

function BucketsLib.__default.BucketListWellMarshalled#requires(Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketListWellMarshalled
axiom (forall blist#0: Seq Box :: 
  { BucketsLib.__default.BucketListWellMarshalled#requires(blist#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.BucketListWellMarshalled#requires(blist#0) == true);

// definition axiom for BucketsLib.__default.BucketListWellMarshalled(revealed)
axiom true
   ==> (forall blist#0: Seq Box :: 
    { BucketsLib.__default.BucketListWellMarshalled(blist#0) } 
    BucketsLib.__default.BucketListWellMarshalled#canCall(blist#0)
         || $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(blist#0, i#0)): DatatypeType } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(blist#0)
             ==> BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(blist#0, i#0)): DatatypeType))
         && BucketsLib.__default.BucketListWellMarshalled(blist#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(blist#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(blist#0)
               ==> BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(blist#0, i#0)): DatatypeType)));

// definition axiom for BucketsLib.__default.BucketListWellMarshalled for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketListWellMarshalled(Lit(blist#0)) } 
    BucketsLib.__default.BucketListWellMarshalled#canCall(Lit(blist#0))
         || $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(blist#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(blist#0))
             ==> BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType))
         && BucketsLib.__default.BucketListWellMarshalled(Lit(blist#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(blist#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(blist#0))
               ==> BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType)));

// function declaration for BucketsLib._default.BInternal
function BucketsLib.__default.BInternal($ly: LayerType, m#0: Map Box Box) : DatatypeType;

function BucketsLib.__default.BInternal#canCall(m#0: Map Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.BInternal($LS($ly), m#0) } 
  BucketsLib.__default.BInternal($LS($ly), m#0)
     == BucketsLib.__default.BInternal($ly, m#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.BInternal(AsFuelBottom($ly), m#0) } 
  BucketsLib.__default.BInternal($ly, m#0)
     == BucketsLib.__default.BInternal($LZ, m#0));

// consequence axiom for BucketsLib.__default.BInternal
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.BInternal($ly, m#0) } 
    BucketsLib.__default.BInternal#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> Map#Equal(BucketsLib.Bucket.b(BucketsLib.__default.BInternal($ly, m#0)), m#0)
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.BInternal($ly, m#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.BInternal($ly, m#0)))
         && $Is(BucketsLib.__default.BInternal($ly, m#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BInternal#requires(LayerType, Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.BInternal
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.BInternal#requires($ly, m#0) } 
  $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.BInternal#requires($ly, m#0) == true);

// definition axiom for BucketsLib.__default.BInternal(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.BInternal($LS($ly), m#0) } 
    BucketsLib.__default.BInternal#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (Set#Card(Map#Domain(m#0)) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Map#Domain(m#0))
             && (var maxkey#0 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Map#Domain(m#0)); 
              Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueMessage.Message(), 
                  m#0, 
                  $Box(maxkey#0))
                 && (var subm#0 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      m#0, 
                      $Box(maxkey#0)); 
                  BucketsLib.__default.BInternal#canCall(subm#0)
                     && (var subbucket#0 := BucketsLib.__default.BInternal($ly, subm#0); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#0)
                         && BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#0)))))
         && BucketsLib.__default.BInternal($LS($ly), m#0)
           == (if Set#Card(Map#Domain(m#0)) == LitInt(0)
             then #BucketsLib.Bucket.BucketMapWithSeq(m#0, Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))
             else (var maxkey#0 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Map#Domain(m#0)); 
              (var maxmsg#0 := $Unbox(Map#Elements(m#0)[$Box(maxkey#0)]): DatatypeType; 
                (var subm#0 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      m#0, 
                      $Box(maxkey#0)); 
                  (var subbucket#0 := BucketsLib.__default.BInternal($ly, subm#0); 
                    #BucketsLib.Bucket.BucketMapWithSeq(m#0, 
                      Seq#Append(BucketsLib.Bucket.keys(subbucket#0), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxkey#0))), 
                      Seq#Append(BucketsLib.Bucket.msgs(subbucket#0), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxmsg#0))))))))));

// definition axiom for BucketsLib.__default.BInternal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.BInternal($LS($ly), Lit(m#0)) } 
    BucketsLib.__default.BInternal#canCall(Lit(m#0))
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> (Set#Card(Lit(Map#Domain(Lit(m#0)))) != LitInt(0)
           ==> Lexicographic__Byte__Order.__default.maximum#canCall(Lit(Map#Domain(Lit(m#0))))
             && (var maxkey#1 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(Map#Domain(Lit(m#0)))); 
              Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueMessage.Message(), 
                  Lit(m#0), 
                  $Box(maxkey#1))
                 && (var subm#1 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(m#0), 
                      $Box(maxkey#1)); 
                  BucketsLib.__default.BInternal#canCall(subm#1)
                     && (var subbucket#1 := BucketsLib.__default.BInternal($LS($ly), subm#1); 
                      BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#1)
                         && BucketsLib.Bucket.BucketMapWithSeq_q(subbucket#1)))))
         && BucketsLib.__default.BInternal($LS($ly), Lit(m#0))
           == (if Set#Card(Lit(Map#Domain(Lit(m#0)))) == LitInt(0)
             then #BucketsLib.Bucket.BucketMapWithSeq(Lit(m#0), Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box))
             else (var maxkey#1 := Lexicographic__Byte__Order.__default.maximum(StartFuel_Lexicographic_Byte_Order._default.maximum, Lit(Map#Domain(Lit(m#0)))); 
              (var maxmsg#1 := $Unbox(Map#Elements(Lit(m#0))[$Box(maxkey#1)]): DatatypeType; 
                (var subm#1 := Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                      Tclass.ValueMessage.Message(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(m#0), 
                      $Box(maxkey#1)); 
                  (var subbucket#1 := BucketsLib.__default.BInternal($LS($ly), subm#1); 
                    #BucketsLib.Bucket.BucketMapWithSeq(Lit(m#0), 
                      Seq#Append(BucketsLib.Bucket.keys(subbucket#1), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxkey#1))), 
                      Seq#Append(BucketsLib.Bucket.msgs(subbucket#1), 
                        Seq#Build(Seq#Empty(): Seq Box, $Box(maxmsg#1))))))))));

// function declaration for BucketsLib._default.B
function BucketsLib.__default.B($ly: LayerType, m#0: Map Box Box) : DatatypeType;

function BucketsLib.__default.B#canCall(m#0: Map Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.B($LS($ly), m#0) } 
  BucketsLib.__default.B($LS($ly), m#0) == BucketsLib.__default.B($ly, m#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.B(AsFuelBottom($ly), m#0) } 
  BucketsLib.__default.B($ly, m#0) == BucketsLib.__default.B($LZ, m#0));

// consequence axiom for BucketsLib.__default.B
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.B($ly, m#0) } 
    BucketsLib.__default.B#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> Map#Equal(BucketsLib.Bucket.b(BucketsLib.__default.B($ly, m#0)), m#0)
         && BucketsLib.__default.PreWFBucket(BucketsLib.__default.B($ly, m#0))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.B($ly, m#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.B($ly, m#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.B($ly, m#0)))
         && (BucketsLib.__default.WFBucketMap(m#0)
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.B($ly, m#0)))
         && $Is(BucketsLib.__default.B($ly, m#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.B#requires(LayerType, Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.B
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.B#requires($ly, m#0) } 
  $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
     ==> BucketsLib.__default.B#requires($ly, m#0) == true);

// definition axiom for BucketsLib.__default.B(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.B($LS($ly), m#0) } 
    BucketsLib.__default.B#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.WFBucketMap#canCall(m#0)
         && (BucketsLib.__default.WFBucketMap(m#0)
           ==> BucketsLib.__default.BInternal#canCall(m#0))
         && (!BucketsLib.__default.WFBucketMap(m#0)
           ==> BucketsLib.__default.BInternal#canCall(m#0))
         && BucketsLib.__default.B($LS($ly), m#0)
           == (if BucketsLib.__default.WFBucketMap(m#0)
             then BucketsLib.__default.BInternal($LS($LZ), m#0)
             else BucketsLib.__default.BInternal($LS($LZ), m#0)));

// definition axiom for BucketsLib.__default.B for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.B($LS($ly), Lit(m#0)) } 
    BucketsLib.__default.B#canCall(Lit(m#0))
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.WFBucketMap#canCall(Lit(m#0))
         && (Lit(BucketsLib.__default.WFBucketMap(Lit(m#0)))
           ==> BucketsLib.__default.BInternal#canCall(Lit(m#0)))
         && (!Lit(BucketsLib.__default.WFBucketMap(Lit(m#0)))
           ==> BucketsLib.__default.BInternal#canCall(Lit(m#0)))
         && BucketsLib.__default.B($LS($ly), Lit(m#0))
           == (if BucketsLib.__default.WFBucketMap(Lit(m#0))
             then BucketsLib.__default.BInternal($LS($LZ), Lit(m#0))
             else BucketsLib.__default.BInternal($LS($LZ), Lit(m#0))));

// function declaration for BucketsLib._default.EmptyBucket
function BucketsLib.__default.EmptyBucket() : DatatypeType;

function BucketsLib.__default.EmptyBucket#canCall() : bool;

// consequence axiom for BucketsLib.__default.EmptyBucket
axiom true
   ==> 
  true
   ==> BucketsLib.Bucket#Equal(BucketsLib.__default.EmptyBucket(), 
      BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)))
     && BucketsLib.__default.WFBucket(BucketsLib.__default.EmptyBucket())
     && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.EmptyBucket())
     && $Is(BucketsLib.__default.EmptyBucket(), Tclass.BucketsLib.Bucket());

function BucketsLib.__default.EmptyBucket#requires() : bool;

// #requires axiom for BucketsLib.__default.EmptyBucket
axiom BucketsLib.__default.EmptyBucket#requires() == true;

// definition axiom for BucketsLib.__default.EmptyBucket(revealed)
axiom true
   ==> 
  true
   ==> BucketsLib.__default.EmptyBucket()
     == (var b#0 := Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(Map#Empty(): Map Box Box), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box))); 
      b#0);

// definition axiom for BucketsLib.__default.EmptyBucket for all literals(revealed)
axiom true
   ==> 
  true
   ==> BucketsLib.__default.EmptyBucket()
     == (var b#1 := Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(Map#Empty(): Map Box Box), 
            Lit(Seq#Empty(): Seq Box), 
            Lit(Seq#Empty(): Seq Box))); 
      b#1);

// function declaration for BucketsLib._default.SingletonBucket
function BucketsLib.__default.SingletonBucket(key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.SingletonBucket#canCall(key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.SingletonBucket
axiom true
   ==> (forall key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.SingletonBucket(key#0, msg#0) } 
    BucketsLib.__default.SingletonBucket#canCall(key#0, msg#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.PreWFBucket(BucketsLib.__default.SingletonBucket(key#0, msg#0))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SingletonBucket(key#0, msg#0))
         && (!ValueMessage.Message#Equal(msg#0, ValueMessage.__default.IdentityMessage())
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.SingletonBucket(key#0, msg#0)))
         && $Is(BucketsLib.__default.SingletonBucket(key#0, msg#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.SingletonBucket#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.SingletonBucket
axiom (forall key#0: Seq Box, msg#0: DatatypeType :: 
  { BucketsLib.__default.SingletonBucket#requires(key#0, msg#0) } 
  $Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketsLib.__default.SingletonBucket#requires(key#0, msg#0) == true);

// definition axiom for BucketsLib.__default.SingletonBucket(revealed)
axiom true
   ==> (forall key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.SingletonBucket(key#0, msg#0) } 
    BucketsLib.__default.SingletonBucket#canCall(key#0, msg#0)
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.SingletonBucket(key#0, msg#0)
         == #BucketsLib.Bucket.BucketMapWithSeq(Map#Build(Map#Empty(): Map Box Box, $Box(key#0), $Box(msg#0)), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(key#0)), 
          Seq#Build(Seq#Empty(): Seq Box, $Box(msg#0))));

// definition axiom for BucketsLib.__default.SingletonBucket for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.SingletonBucket(Lit(key#0), Lit(msg#0)) } 
    BucketsLib.__default.SingletonBucket#canCall(Lit(key#0), Lit(msg#0))
         || ($Is(key#0, Tclass.KeyType.Key()) && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.SingletonBucket(Lit(key#0), Lit(msg#0))
         == Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(Map#Build(Map#Empty(): Map Box Box, $Box(Lit(key#0)), $Box(Lit(msg#0)))), 
            Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(key#0)))), 
            Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(msg#0)))))));

// function declaration for BucketsLib._default.BucketDropLast
function BucketsLib.__default.BucketDropLast(bucket#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.BucketDropLast#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketDropLast
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketDropLast(bucket#0) } 
    BucketsLib.__default.BucketDropLast#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0)
           && 0 < Seq#Length(BucketsLib.Bucket.keys(bucket#0)))
       ==> $Is(BucketsLib.__default.BucketDropLast(bucket#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketDropLast#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketDropLast
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.BucketDropLast#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.BucketDropLast#requires(bucket#0)
       == (
        BucketsLib.__default.PreWFBucket(bucket#0)
         && BucketsLib.__default.BucketWellMarshalled(bucket#0)
         && 0 < Seq#Length(BucketsLib.Bucket.keys(bucket#0))));

// definition axiom for BucketsLib.__default.BucketDropLast(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.BucketDropLast(bucket#0) } 
    BucketsLib.__default.BucketDropLast#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0)
           && 0 < Seq#Length(BucketsLib.Bucket.keys(bucket#0)))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Sequences.__default.Last#canCall(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0))
         && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          BucketsLib.Bucket.b(bucket#0), 
          Sequences.__default.Last(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0)))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), BucketsLib.Bucket.msgs(bucket#0))
         && BucketsLib.__default.BucketDropLast(bucket#0)
           == (var submap#0 := Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapRemove1, 
                BucketsLib.Bucket.b(bucket#0), 
                Sequences.__default.Last(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0))); 
            #BucketsLib.Bucket.BucketMapWithSeq(submap#0, 
              Sequences.__default.DropLast(Tclass.KeyType.Key(), BucketsLib.Bucket.keys(bucket#0)), 
              Sequences.__default.DropLast(Tclass.ValueMessage.Message(), BucketsLib.Bucket.msgs(bucket#0)))));

// definition axiom for BucketsLib.__default.BucketDropLast for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketDropLast(Lit(bucket#0)) } 
    BucketsLib.__default.BucketDropLast#canCall(Lit(bucket#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && 
          Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0)))
           && Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)))
           && 0 < Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
          $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))): Seq Box)))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && Sequences.__default.DropLast#canCall(Tclass.ValueMessage.Message(), Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
         && BucketsLib.__default.BucketDropLast(Lit(bucket#0))
           == (var submap#1 := Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapRemove1, 
                Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                $Box(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))): Seq Box))); 
            #BucketsLib.Bucket.BucketMapWithSeq(submap#1, 
              Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))), 
              Lit(Sequences.__default.DropLast(Tclass.ValueMessage.Message(), Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))))));

// function declaration for BucketsLib._default.WFBucketAt
function BucketsLib.__default.WFBucketAt(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : bool;

function BucketsLib.__default.WFBucketAt#canCall(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketsLib.__default.WFBucketAt
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.WFBucketAt(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.WFBucketAt#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> true);

function BucketsLib.__default.WFBucketAt#requires(DatatypeType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.WFBucketAt
axiom (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
  { BucketsLib.__default.WFBucketAt#requires(bucket#0, pivots#0, i#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.WFBucketAt#requires(bucket#0, pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.WFBucketAt(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.WFBucketAt(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.WFBucketAt#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> BucketsLib.__default.WFBucket#canCall(bucket#0)
         && (BucketsLib.__default.WFBucket(bucket#0)
           ==> (forall key#0: Seq Box :: 
            { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType)
                     && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                     && 
                    BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                     && ValueMessage.__default.IdentityMessage#canCall())))
         && ((forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                     ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType)
                       && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                       && 
                      BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                       && ValueMessage.__default.IdentityMessage#canCall()))
             && (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
           ==> (forall key#1: Seq Box :: 
            { PivotsLib.__default.Route(pivots#0, key#1) } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
            $Is(key#1, Tclass.KeyType.Key())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                   ==> PivotsLib.__default.Route#canCall(pivots#0, key#1))))
         && BucketsLib.__default.WFBucketAt(bucket#0, pivots#0, i#0)
           == (
            BucketsLib.__default.WFBucket(bucket#0)
             && (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
             && (forall key#1: Seq Box :: 
              { PivotsLib.__default.Route(pivots#0, key#1) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
              $Is(key#1, Tclass.KeyType.Key())
                   && Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                 ==> PivotsLib.__default.Route(pivots#0, key#1) == i#0)));

// definition axiom for BucketsLib.__default.WFBucketAt for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketsLib.__default.WFBucketAt(Lit(bucket#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.WFBucketAt#canCall(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> BucketsLib.__default.WFBucket#canCall(Lit(bucket#0))
         && (Lit(BucketsLib.__default.WFBucket(Lit(bucket#0)))
           ==> (forall key#2: Seq Box :: 
            { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)]): DatatypeType } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)] } 
            $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#2)]
                   ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#2)]): DatatypeType)
                     && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                     && 
                    BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                     && ValueMessage.__default.IdentityMessage#canCall())))
         && ((forall key#2: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)] } 
              $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#2)]
                     ==> $IsA#ValueMessage.Message($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#2)]): DatatypeType)
                       && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                       && 
                      BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                       && ValueMessage.__default.IdentityMessage#canCall()))
             && (forall key#2: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)] } 
              $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#2)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#2)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
           ==> (forall key#3: Seq Box :: 
            { PivotsLib.__default.Route(pivots#0, key#3) } 
              { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#3)] } 
            $Is(key#3, Tclass.KeyType.Key())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#3)]
                   ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#3))))
         && BucketsLib.__default.WFBucketAt(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
           == (
            BucketsLib.__default.WFBucket(Lit(bucket#0))
             && (forall key#2: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)]): DatatypeType } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#2)] } 
              $Is(key#2, TSeq(Tclass.NativeTypes.byte()))
                   && Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#2)]
                 ==> !ValueMessage.Message#Equal($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#2)]): DatatypeType, 
                  ValueMessage.__default.IdentityMessage()))
             && (forall key#3: Seq Box :: 
              { PivotsLib.__default.Route(pivots#0, key#3) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#3)] } 
              $Is(key#3, Tclass.KeyType.Key())
                   && Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#3)]
                 ==> PivotsLib.__default.Route(Lit(pivots#0), key#3) == LitInt(i#0))));

// function declaration for BucketsLib._default.WFBucketList
function BucketsLib.__default.WFBucketList(blist#0: Seq Box, pivots#0: Seq Box) : bool;

function BucketsLib.__default.WFBucketList#canCall(blist#0: Seq Box, pivots#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.WFBucketList
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketList(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketList#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> true);

function BucketsLib.__default.WFBucketList#requires(Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.WFBucketList
axiom (forall blist#0: Seq Box, pivots#0: Seq Box :: 
  { BucketsLib.__default.WFBucketList#requires(blist#0, pivots#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.WFBucketList#requires(blist#0, pivots#0) == true);

// definition axiom for BucketsLib.__default.WFBucketList(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketList(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketList#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> PivotsLib.__default.WFPivots#canCall(pivots#0)
         && (Seq#Length(blist#0) == Seq#Length(pivots#0) + 1
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(blist#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(blist#0)
               ==> BucketsLib.__default.WFBucket#canCall($Unbox(Seq#Index(blist#0, i#0)): DatatypeType)))
         && BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           == (
            PivotsLib.__default.WFPivots(pivots#0)
             && Seq#Length(blist#0) == Seq#Length(pivots#0) + 1
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(blist#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(blist#0)
                 ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(blist#0, i#0)): DatatypeType))));

// definition axiom for BucketsLib.__default.WFBucketList for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)) } 
    BucketsLib.__default.WFBucketList#canCall(Lit(blist#0), Lit(pivots#0))
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> PivotsLib.__default.WFPivots#canCall(Lit(pivots#0))
         && (Seq#Length(Lit(blist#0)) == Seq#Length(Lit(pivots#0)) + 1
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(blist#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(blist#0))
               ==> BucketsLib.__default.WFBucket#canCall($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType)))
         && BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))
           == (
            PivotsLib.__default.WFPivots(Lit(pivots#0))
             && Seq#Length(Lit(blist#0)) == Seq#Length(Lit(pivots#0)) + 1
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(blist#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(blist#0))
                 ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType))));

// function declaration for BucketsLib._default.WFBucketListProper
function BucketsLib.__default.WFBucketListProper(blist#0: Seq Box, pivots#0: Seq Box) : bool;

function BucketsLib.__default.WFBucketListProper#canCall(blist#0: Seq Box, pivots#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.WFBucketListProper
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketListProper(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketListProper#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> true);

function BucketsLib.__default.WFBucketListProper#requires(Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.WFBucketListProper
axiom (forall blist#0: Seq Box, pivots#0: Seq Box :: 
  { BucketsLib.__default.WFBucketListProper#requires(blist#0, pivots#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.WFBucketListProper#requires(blist#0, pivots#0) == true);

// definition axiom for BucketsLib.__default.WFBucketListProper(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.WFBucketListProper(blist#0, pivots#0) } 
    BucketsLib.__default.WFBucketListProper#canCall(blist#0, pivots#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.WFBucketList#canCall(blist#0, pivots#0)
         && (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(blist#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(blist#0)
               ==> BucketsLib.__default.WFBucketAt#canCall($Unbox(Seq#Index(blist#0, i#0)): DatatypeType, pivots#0, i#0)))
         && BucketsLib.__default.WFBucketListProper(blist#0, pivots#0)
           == (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(blist#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(blist#0)
                 ==> BucketsLib.__default.WFBucketAt($Unbox(Seq#Index(blist#0, i#0)): DatatypeType, pivots#0, i#0))));

// definition axiom for BucketsLib.__default.WFBucketListProper for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.WFBucketListProper(Lit(blist#0), Lit(pivots#0)) } 
    BucketsLib.__default.WFBucketListProper#canCall(Lit(blist#0), Lit(pivots#0))
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.WFBucketList#canCall(Lit(blist#0), Lit(pivots#0))
         && (Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(blist#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(blist#0))
               ==> BucketsLib.__default.WFBucketAt#canCall($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType, Lit(pivots#0), i#1)))
         && BucketsLib.__default.WFBucketListProper(Lit(blist#0), Lit(pivots#0))
           == (BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(blist#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(blist#0))
                 ==> BucketsLib.__default.WFBucketAt($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType, Lit(pivots#0), i#1))));

// function declaration for BucketsLib._default.BucketGet
function BucketsLib.__default.BucketGet(bucket#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.BucketGet#canCall(bucket#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketGet
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketGet(bucket#0, key#0) } 
    BucketsLib.__default.BucketGet#canCall(bucket#0, key#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.BucketGet(bucket#0, key#0), Tclass.ValueMessage.Message()));

function BucketsLib.__default.BucketGet#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketGet
axiom (forall bucket#0: DatatypeType, key#0: Seq Box :: 
  { BucketsLib.__default.BucketGet#requires(bucket#0, key#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.BucketGet#requires(bucket#0, key#0) == true);

// definition axiom for BucketsLib.__default.BucketGet(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketGet(bucket#0, key#0) } 
    BucketsLib.__default.BucketGet#canCall(bucket#0, key#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
         && (!Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
           ==> ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.BucketGet(bucket#0, key#0)
           == (if Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
             then $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType
             else ValueMessage.__default.IdentityMessage()));

// definition axiom for BucketsLib.__default.BucketGet for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0)) } 
    BucketsLib.__default.BucketGet#canCall(Lit(bucket#0), Lit(key#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
         && (!Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
           ==> ValueMessage.__default.IdentityMessage#canCall())
         && BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))
           == (if Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
             then $Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(Lit(key#0))]): DatatypeType
             else ValueMessage.__default.IdentityMessage()));

// function declaration for BucketsLib._default.BucketListGet
function BucketsLib.__default.BucketListGet(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.BucketListGet#canCall(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketListGet
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0) } 
    BucketsLib.__default.BucketListGet#canCall(blist#0, pivots#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> $Is(BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0), 
        Tclass.ValueMessage.Message()));

function BucketsLib.__default.BucketListGet#requires(Seq Box, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketListGet
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.BucketListGet#requires(blist#0, pivots#0, key#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.BucketListGet#requires(blist#0, pivots#0, key#0)
       == BucketsLib.__default.WFBucketList(blist#0, pivots#0));

// definition axiom for BucketsLib.__default.BucketListGet(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0) } 
    BucketsLib.__default.BucketListGet#canCall(blist#0, pivots#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> PivotsLib.__default.Route#canCall(pivots#0, key#0)
         && BucketsLib.__default.BucketGet#canCall($Unbox(Seq#Index(blist#0, PivotsLib.__default.Route(pivots#0, key#0))): DatatypeType, 
          key#0)
         && BucketsLib.__default.BucketListGet(blist#0, pivots#0, key#0)
           == BucketsLib.__default.BucketGet($Unbox(Seq#Index(blist#0, PivotsLib.__default.Route(pivots#0, key#0))): DatatypeType, 
            key#0));

// definition axiom for BucketsLib.__default.BucketListGet for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketListGet(Lit(blist#0), Lit(pivots#0), Lit(key#0)) } 
    BucketsLib.__default.BucketListGet#canCall(Lit(blist#0), Lit(pivots#0), Lit(key#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))))
       ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), Lit(key#0))
         && BucketsLib.__default.BucketGet#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))))): DatatypeType, 
          Lit(key#0))
         && BucketsLib.__default.BucketListGet(Lit(blist#0), Lit(pivots#0), Lit(key#0))
           == BucketsLib.__default.BucketGet($Unbox(Seq#Index(Lit(blist#0), LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))))): DatatypeType, 
            Lit(key#0)));

// function declaration for BucketsLib._default.BucketInsert
function BucketsLib.__default.BucketInsert(bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.BucketInsert#canCall(bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketInsert
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0) } 
    BucketsLib.__default.BucketInsert#canCall(bucket#0, key#0, msg#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> $Is(BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0), 
        Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketInsert#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketInsert
axiom (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
  { BucketsLib.__default.BucketInsert#requires(bucket#0, key#0, msg#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketsLib.__default.BucketInsert#requires(bucket#0, key#0, msg#0) == true);

// definition axiom for BucketsLib.__default.BucketInsert(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0) } 
    BucketsLib.__default.BucketInsert#canCall(bucket#0, key#0, msg#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.BucketGet#canCall(bucket#0, key#0)
         && ValueMessage.__default.Merge#canCall(msg#0, BucketsLib.__default.BucketGet(bucket#0, key#0))
         && (var mergedMsg#0 := ValueMessage.__default.Merge(msg#0, BucketsLib.__default.BucketGet(bucket#0, key#0)); 
          $IsA#ValueMessage.Message(mergedMsg#0)
             && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
             && ValueMessage.__default.IdentityMessage#canCall()
             && (ValueMessage.Message#Equal(mergedMsg#0, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  BucketsLib.Bucket.b(bucket#0), 
                  $Box(key#0))
                 && BucketsLib.__default.B#canCall(Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                    Tclass.ValueMessage.Message(), 
                    StartFuel_Maps._default.MapRemove1, 
                    BucketsLib.Bucket.b(bucket#0), 
                    $Box(key#0))))
             && (!ValueMessage.Message#Equal(mergedMsg#0, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                 && BucketsLib.__default.B#canCall(Map#Build(BucketsLib.Bucket.b(bucket#0), $Box(key#0), $Box(mergedMsg#0)))))
         && BucketsLib.__default.BucketInsert(bucket#0, key#0, msg#0)
           == (var mergedMsg#0 := ValueMessage.__default.Merge(msg#0, BucketsLib.__default.BucketGet(bucket#0, key#0)); 
            (if ValueMessage.Message#Equal(mergedMsg#0, ValueMessage.__default.IdentityMessage())
               then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  StartFuel_Maps._default.MapRemove1, 
                  BucketsLib.Bucket.b(bucket#0), 
                  $Box(key#0)))
               else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Map#Build(BucketsLib.Bucket.b(bucket#0), $Box(key#0), $Box(mergedMsg#0))))));

// definition axiom for BucketsLib.__default.BucketInsert for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketInsert(Lit(bucket#0), Lit(key#0), Lit(msg#0)) } 
    BucketsLib.__default.BucketInsert#canCall(Lit(bucket#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message()))
       ==> BucketsLib.__default.BucketGet#canCall(Lit(bucket#0), Lit(key#0))
         && ValueMessage.__default.Merge#canCall(Lit(msg#0), Lit(BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))))
         && (var mergedMsg#1 := Lit(ValueMessage.__default.Merge(Lit(msg#0), Lit(BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))))); 
          $IsA#ValueMessage.Message(mergedMsg#1)
             && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
             && ValueMessage.__default.IdentityMessage#canCall()
             && (ValueMessage.Message#Equal(mergedMsg#1, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                  $Box(Lit(key#0)))
                 && BucketsLib.__default.B#canCall(Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                    Tclass.ValueMessage.Message(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                    $Box(Lit(key#0)))))
             && (!ValueMessage.Message#Equal(mergedMsg#1, ValueMessage.__default.IdentityMessage())
               ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                 && BucketsLib.__default.B#canCall(Map#Build(Lit(BucketsLib.Bucket.b(Lit(bucket#0))), $Box(Lit(key#0)), $Box(mergedMsg#1)))))
         && BucketsLib.__default.BucketInsert(Lit(bucket#0), Lit(key#0), Lit(msg#0))
           == (var mergedMsg#1 := Lit(ValueMessage.__default.Merge(Lit(msg#0), Lit(BucketsLib.__default.BucketGet(Lit(bucket#0), Lit(key#0))))); 
            (if ValueMessage.Message#Equal(mergedMsg#1, ValueMessage.__default.IdentityMessage())
               then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Maps.__default.MapRemove1(Tclass.KeyType.Key(), 
                  Tclass.ValueMessage.Message(), 
                  StartFuel_Maps._default.MapRemove1, 
                  Lit(BucketsLib.Bucket.b(Lit(bucket#0))), 
                  $Box(Lit(key#0))))
               else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                Map#Build(Lit(BucketsLib.Bucket.b(Lit(bucket#0))), $Box(Lit(key#0)), $Box(mergedMsg#1))))));

// function declaration for BucketsLib._default.BucketListInsert
function BucketsLib.__default.BucketListInsert(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType)
   : Seq Box;

function BucketsLib.__default.BucketListInsert#canCall(blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketListInsert
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0) } 
    BucketsLib.__default.BucketListInsert#canCall(blist#0, pivots#0, key#0, msg#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> $Is(BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.BucketListInsert#requires(Seq Box, Seq Box, Seq Box, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketListInsert
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
  { BucketsLib.__default.BucketListInsert#requires(blist#0, pivots#0, key#0, msg#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketsLib.__default.BucketListInsert#requires(blist#0, pivots#0, key#0, msg#0)
       == BucketsLib.__default.WFBucketList(blist#0, pivots#0));

// definition axiom for BucketsLib.__default.BucketListInsert(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
    { BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0) } 
    BucketsLib.__default.BucketListInsert#canCall(blist#0, pivots#0, key#0, msg#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && BucketsLib.__default.WFBucketList(blist#0, pivots#0))
       ==> PivotsLib.__default.Route#canCall(pivots#0, key#0)
         && (var i#0 := PivotsLib.__default.Route(pivots#0, key#0); 
          BucketsLib.__default.BucketInsert#canCall($Unbox(Seq#Index(blist#0, i#0)): DatatypeType, key#0, msg#0))
         && BucketsLib.__default.BucketListInsert(blist#0, pivots#0, key#0, msg#0)
           == (var i#0 := PivotsLib.__default.Route(pivots#0, key#0); 
            Seq#Update(blist#0, 
              i#0, 
              $Box(BucketsLib.__default.BucketInsert($Unbox(Seq#Index(blist#0, i#0)): DatatypeType, key#0, msg#0)))));

// definition axiom for BucketsLib.__default.BucketListInsert for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketListInsert(Lit(blist#0), Lit(pivots#0), Lit(key#0), Lit(msg#0)) } 
    BucketsLib.__default.BucketListInsert#canCall(Lit(blist#0), Lit(pivots#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0))))
       ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), Lit(key#0))
         && (var i#1 := LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))); 
          BucketsLib.__default.BucketInsert#canCall($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType, Lit(key#0), Lit(msg#0)))
         && BucketsLib.__default.BucketListInsert(Lit(blist#0), Lit(pivots#0), Lit(key#0), Lit(msg#0))
           == (var i#1 := LitInt(PivotsLib.__default.Route(Lit(pivots#0), Lit(key#0))); 
            Seq#Update(Lit(blist#0), 
              i#1, 
              $Box(BucketsLib.__default.BucketInsert($Unbox(Seq#Index(Lit(blist#0), i#1)): DatatypeType, Lit(key#0), Lit(msg#0))))));

// function declaration for BucketsLib._default.BucketListItemFlush
function BucketsLib.__default.BucketListItemFlush(parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int)
   : DatatypeType;

function BucketsLib.__default.BucketListItemFlush#canCall(parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int)
   : bool;

// consequence axiom for BucketsLib.__default.BucketListItemFlush
axiom true
   ==> (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListItemFlush#canCall(parent#0, child#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(child#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0), 
        Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketListItemFlush#requires(DatatypeType, DatatypeType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.BucketListItemFlush
axiom (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
  { BucketsLib.__default.BucketListItemFlush#requires(parent#0, child#0, pivots#0, i#0) } 
  $Is(parent#0, Tclass.BucketsLib.Bucket())
       && $Is(child#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketListItemFlush#requires(parent#0, child#0, pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.BucketListItemFlush(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListItemFlush#canCall(parent#0, child#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(child#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(child#0, key#0) } 
            { BucketsLib.__default.BucketGet(parent#0, key#0) } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(child#0)
               && BucketsLib.Bucket.BucketMapWithSeq_q(parent#0)
               && (Map#Domain(BucketsLib.Bucket.b(child#0))[$Box(key#0)]
                   || Map#Domain(BucketsLib.Bucket.b(parent#0))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(pivots#0, key#0))
               && (PivotsLib.__default.Route#canCall(pivots#0, key#0)
                   && PivotsLib.__default.Route(pivots#0, key#0) == i#0
                 ==> $IsA#ValueMessage.Message(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, key#0), 
                      BucketsLib.__default.BucketGet(child#0, key#0)))
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && 
                  BucketsLib.__default.BucketGet#canCall(parent#0, key#0)
                   && BucketsLib.__default.BucketGet#canCall(child#0, key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(parent#0, key#0), 
                    BucketsLib.__default.BucketGet(child#0, key#0))
                   && ValueMessage.__default.IdentityMessage#canCall())
               && ((Map#Domain(BucketsLib.Bucket.b(child#0))[$Box(key#0)]
                     || Map#Domain(BucketsLib.Bucket.b(parent#0))[$Box(key#0)])
                   && PivotsLib.__default.Route(pivots#0, key#0) == i#0
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, key#0), 
                      BucketsLib.__default.BucketGet(child#0, key#0)), 
                    ValueMessage.__default.IdentityMessage())
                 ==> BucketsLib.__default.BucketGet#canCall(parent#0, key#0)
                   && BucketsLib.__default.BucketGet#canCall(child#0, key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(parent#0, key#0), 
                    BucketsLib.__default.BucketGet(child#0, key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                (Map#Domain(BucketsLib.Bucket.b(child#0))[$w#0]
                   || Map#Domain(BucketsLib.Bucket.b(parent#0))[$w#0])
                 && PivotsLib.__default.Route(pivots#0, $Unbox($w#0): Seq Box) == i#0
                 && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#0): Seq Box), 
                    BucketsLib.__default.BucketGet(child#0, $Unbox($w#0): Seq Box)), 
                  ValueMessage.__default.IdentityMessage())), 
            (lambda $w#0: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#0): Seq Box), 
                  BucketsLib.__default.BucketGet(child#0, $Unbox($w#0): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketListItemFlush(parent#0, child#0, pivots#0, i#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  (Map#Domain(BucketsLib.Bucket.b(child#0))[$w#1]
                     || Map#Domain(BucketsLib.Bucket.b(parent#0))[$w#1])
                   && PivotsLib.__default.Route(pivots#0, $Unbox($w#1): Seq Box) == i#0
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#1): Seq Box), 
                      BucketsLib.__default.BucketGet(child#0, $Unbox($w#1): Seq Box)), 
                    ValueMessage.__default.IdentityMessage())), 
              (lambda $w#1: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(parent#0, $Unbox($w#1): Seq Box), 
                    BucketsLib.__default.BucketGet(child#0, $Unbox($w#1): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.BucketListItemFlush for all literals(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, child#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketsLib.__default.BucketListItemFlush(Lit(parent#0), Lit(child#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.BucketListItemFlush#canCall(Lit(parent#0), Lit(child#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(child#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(child#0, key#0) } 
            { BucketsLib.__default.BucketGet(parent#0, key#0) } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(child#0))
               && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(parent#0))
               && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$Box(key#0)]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#0))
               && (PivotsLib.__default.Route#canCall(Lit(pivots#0), key#0)
                   && PivotsLib.__default.Route(Lit(pivots#0), key#0) == LitInt(i#0)
                 ==> $IsA#ValueMessage.Message(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                      BucketsLib.__default.BucketGet(Lit(child#0), key#0)))
                   && $IsA#ValueMessage.Message(Lit(ValueMessage.__default.IdentityMessage()))
                   && 
                  BucketsLib.__default.BucketGet#canCall(Lit(parent#0), key#0)
                   && BucketsLib.__default.BucketGet#canCall(Lit(child#0), key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                    BucketsLib.__default.BucketGet(Lit(child#0), key#0))
                   && ValueMessage.__default.IdentityMessage#canCall())
               && ((Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$Box(key#0)]
                     || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$Box(key#0)])
                   && PivotsLib.__default.Route(Lit(pivots#0), key#0) == LitInt(i#0)
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                      BucketsLib.__default.BucketGet(Lit(child#0), key#0)), 
                    ValueMessage.__default.IdentityMessage())
                 ==> BucketsLib.__default.BucketGet#canCall(Lit(parent#0), key#0)
                   && BucketsLib.__default.BucketGet#canCall(Lit(child#0), key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(Lit(parent#0), key#0), 
                    BucketsLib.__default.BucketGet(Lit(child#0), key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$w#2]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$w#2])
                 && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#2): Seq Box) == LitInt(i#0)
                 && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#2): Seq Box), 
                    BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#2): Seq Box)), 
                  ValueMessage.__default.IdentityMessage())), 
            (lambda $w#2: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#2): Seq Box), 
                  BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#2): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketListItemFlush(Lit(parent#0), Lit(child#0), Lit(pivots#0), LitInt(i#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(child#0)))))[$w#3]
                     || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(parent#0)))))[$w#3])
                   && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#3): Seq Box) == LitInt(i#0)
                   && !ValueMessage.Message#Equal(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#3): Seq Box), 
                      BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#3): Seq Box)), 
                    ValueMessage.__default.IdentityMessage())), 
              (lambda $w#3: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(parent#0), $Unbox($w#3): Seq Box), 
                    BucketsLib.__default.BucketGet(Lit(child#0), $Unbox($w#3): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketListFlushPartial
function BucketsLib.__default.BucketListFlushPartial($ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int)
   : Seq Box;

function BucketsLib.__default.BucketListFlushPartial#canCall(parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int :: 
  { BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0) } 
  BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0)
     == BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int :: 
  { BucketsLib.__default.BucketListFlushPartial(AsFuelBottom($ly), parent#0, children#0, pivots#0, i#0) } 
  BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0)
     == BucketsLib.__default.BucketListFlushPartial($LZ, parent#0, children#0, pivots#0, i#0));

// consequence axiom for BucketsLib.__default.BucketListFlushPartial
axiom true
   ==> (forall $ly: LayerType, 
      parent#0: DatatypeType, 
      children#0: Seq Box, 
      pivots#0: Seq Box, 
      i#0: int :: 
    { BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          PivotsLib.__default.WFPivots(pivots#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(children#0))
       ==> Seq#Length(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0))
           == i#0
         && (forall h#0: int :: 
          { $Unbox(Seq#Index(children#0, h#0)): DatatypeType } 
            { $Unbox(Seq#Index(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0), 
                h#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= h#0 && h#0 < i#0
             ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0), 
                  h#0)): DatatypeType, 
              BucketsLib.__default.BucketListItemFlush(parent#0, $Unbox(Seq#Index(children#0, h#0)): DatatypeType, pivots#0, h#0)))
         && $Is(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.BucketListFlushPartial#requires(LayerType, DatatypeType, Seq Box, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.BucketListFlushPartial
axiom (forall $ly: LayerType, 
    parent#0: DatatypeType, 
    children#0: Seq Box, 
    pivots#0: Seq Box, 
    i#0: int :: 
  { BucketsLib.__default.BucketListFlushPartial#requires($ly, parent#0, children#0, pivots#0, i#0) } 
  $Is(parent#0, Tclass.BucketsLib.Bucket())
       && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketListFlushPartial#requires($ly, parent#0, children#0, pivots#0, i#0)
       == (PivotsLib.__default.WFPivots(pivots#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(children#0)));

// definition axiom for BucketsLib.__default.BucketListFlushPartial(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      parent#0: DatatypeType, 
      children#0: Seq Box, 
      pivots#0: Seq Box, 
      i#0: int :: 
    { BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0) } 
    BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, i#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          PivotsLib.__default.WFPivots(pivots#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(children#0))
       ==> (i#0 != LitInt(0)
           ==> BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, i#0 - 1)
             && BucketsLib.__default.BucketListItemFlush#canCall(parent#0, 
              $Unbox(Seq#Index(children#0, i#0 - 1)): DatatypeType, 
              pivots#0, 
              i#0 - 1))
         && BucketsLib.__default.BucketListFlushPartial($LS($ly), parent#0, children#0, pivots#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.BucketListFlushPartial($ly, parent#0, children#0, pivots#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.BucketListItemFlush(parent#0, 
                    $Unbox(Seq#Index(children#0, i#0 - 1)): DatatypeType, 
                    pivots#0, 
                    i#0 - 1))))));

// definition axiom for BucketsLib.__default.BucketListFlushPartial for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      parent#0: DatatypeType, 
      children#0: Seq Box, 
      pivots#0: Seq Box, 
      i#0: int :: 
    {:weight 3} { BucketsLib.__default.BucketListFlushPartial($LS($ly), Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.BucketListFlushPartial#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          Lit(PivotsLib.__default.WFPivots(Lit(pivots#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(children#0)))
       ==> (LitInt(i#0) != LitInt(0)
           ==> BucketsLib.__default.BucketListFlushPartial#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0 - 1))
             && BucketsLib.__default.BucketListItemFlush#canCall(Lit(parent#0), 
              $Unbox(Seq#Index(Lit(children#0), LitInt(i#0 - 1))): DatatypeType, 
              Lit(pivots#0), 
              LitInt(i#0 - 1)))
         && BucketsLib.__default.BucketListFlushPartial($LS($ly), Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.BucketListFlushPartial($LS($ly), Lit(parent#0), Lit(children#0), Lit(pivots#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.BucketListItemFlush(Lit(parent#0), 
                    $Unbox(Seq#Index(Lit(children#0), LitInt(i#0 - 1))): DatatypeType, 
                    Lit(pivots#0), 
                    LitInt(i#0 - 1)))))));

// function declaration for BucketsLib._default.BucketListFlush
function BucketsLib.__default.BucketListFlush(parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box) : Seq Box;

function BucketsLib.__default.BucketListFlush#canCall(parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketListFlush
axiom true
   ==> (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0) } 
    BucketsLib.__default.BucketListFlush#canCall(parent#0, children#0, pivots#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> Seq#Length(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0))
           == Seq#Length(children#0)
         && BucketsLib.__default.BucketListWellMarshalled(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0))
         && (forall h#0: int :: 
          { $Unbox(Seq#Index(children#0, h#0)): DatatypeType } 
            { $Unbox(Seq#Index(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0), h#0)): DatatypeType } 
          true
             ==> 
            LitInt(0) <= h#0
               && h#0
                 < Seq#Length(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0))
             ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0), h#0)): DatatypeType, 
              BucketsLib.__default.BucketListItemFlush(parent#0, $Unbox(Seq#Index(children#0, h#0)): DatatypeType, pivots#0, h#0)))
         && $Is(BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.BucketListFlush#requires(DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketListFlush
axiom (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
  { BucketsLib.__default.BucketListFlush#requires(parent#0, children#0, pivots#0) } 
  $Is(parent#0, Tclass.BucketsLib.Bucket())
       && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketListFlush#requires(parent#0, children#0, pivots#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.BucketListFlush(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
    { BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0) } 
    BucketsLib.__default.BucketListFlush#canCall(parent#0, children#0, pivots#0)
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> BucketsLib.__default.BucketListFlushPartial#canCall(parent#0, children#0, pivots#0, Seq#Length(children#0))
         && BucketsLib.__default.BucketListFlush(parent#0, children#0, pivots#0)
           == BucketsLib.__default.BucketListFlushPartial($LS($LZ), parent#0, children#0, pivots#0, Seq#Length(children#0)));

// definition axiom for BucketsLib.__default.BucketListFlush for all literals(revealed)
axiom true
   ==> (forall parent#0: DatatypeType, children#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketListFlush(Lit(parent#0), Lit(children#0), Lit(pivots#0)) } 
    BucketsLib.__default.BucketListFlush#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0))
         || (
          $Is(parent#0, Tclass.BucketsLib.Bucket())
           && $Is(children#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> BucketsLib.__default.BucketListFlushPartial#canCall(Lit(parent#0), Lit(children#0), Lit(pivots#0), Seq#Length(Lit(children#0)))
         && BucketsLib.__default.BucketListFlush(Lit(parent#0), Lit(children#0), Lit(pivots#0))
           == BucketsLib.__default.BucketListFlushPartial($LS($LZ), 
            Lit(parent#0), 
            Lit(children#0), 
            Lit(pivots#0), 
            Seq#Length(Lit(children#0))));

// function declaration for BucketsLib._default.JoinBucketList
function BucketsLib.__default.JoinBucketList($ly: LayerType, buckets#0: Seq Box) : DatatypeType;

function BucketsLib.__default.JoinBucketList#canCall(buckets#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.JoinBucketList($LS($ly), buckets#0) } 
  BucketsLib.__default.JoinBucketList($LS($ly), buckets#0)
     == BucketsLib.__default.JoinBucketList($ly, buckets#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.JoinBucketList(AsFuelBottom($ly), buckets#0) } 
  BucketsLib.__default.JoinBucketList($ly, buckets#0)
     == BucketsLib.__default.JoinBucketList($LZ, buckets#0));

// consequence axiom for BucketsLib.__default.JoinBucketList
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.JoinBucketList($ly, buckets#0) } 
    BucketsLib.__default.JoinBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.PreWFBucket(BucketsLib.__default.JoinBucketList($ly, buckets#0))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.JoinBucketList($ly, buckets#0))
         && ((forall i#0: int :: 
            { $Unbox(Seq#Index(buckets#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(buckets#0)
               ==> BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b($Unbox(Seq#Index(buckets#0, i#0)): DatatypeType)))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.JoinBucketList($ly, buckets#0)))
         && $Is(BucketsLib.__default.JoinBucketList($ly, buckets#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.JoinBucketList#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.JoinBucketList
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.JoinBucketList#requires($ly, buckets#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.JoinBucketList#requires($ly, buckets#0) == true);

// definition axiom for BucketsLib.__default.JoinBucketList(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.JoinBucketList($LS($ly), buckets#0) } 
    BucketsLib.__default.JoinBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(buckets#0) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.JoinBucketList#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0)))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.Bucket.BucketMapWithSeq_q($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)
             && Maps.__default.MapUnion#canCall(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              BucketsLib.Bucket.b(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))), 
              BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))
             && BucketsLib.__default.B#canCall(Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                BucketsLib.Bucket.b(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))), 
                BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))))
         && BucketsLib.__default.JoinBucketList($LS($ly), buckets#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
              Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                BucketsLib.Bucket.b(BucketsLib.__default.JoinBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))), 
                BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)))));

// definition axiom for BucketsLib.__default.JoinBucketList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.JoinBucketList($LS($ly), Lit(buckets#0)) } 
    BucketsLib.__default.JoinBucketList#canCall(Lit(buckets#0))
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(Lit(buckets#0)) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.JoinBucketList#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))
             && Maps.__default.MapUnion#canCall(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              Lit(BucketsLib.Bucket.b(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))), 
              Lit(BucketsLib.Bucket.b(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))))
             && BucketsLib.__default.B#canCall(Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                Lit(BucketsLib.Bucket.b(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                        Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))), 
                Lit(BucketsLib.Bucket.b(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))))))
         && BucketsLib.__default.JoinBucketList($LS($ly), Lit(buckets#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
              Maps.__default.MapUnion(Tclass.KeyType.Key(), 
                Tclass.ValueMessage.Message(), 
                StartFuel_Maps._default.MapUnion, 
                Lit(BucketsLib.Bucket.b(Lit(BucketsLib.__default.JoinBucketList($LS($ly), 
                        Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))))), 
                Lit(BucketsLib.Bucket.b(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType)))))));

// function declaration for BucketsLib._default.SplitBucketOnPivots
function BucketsLib.__default.SplitBucketOnPivots($ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0: DatatypeType, pivots#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0) } 
  BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0)
     == BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketOnPivots(AsFuelBottom($ly), bucket#0, pivots#0) } 
  BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0)
     == BucketsLib.__default.SplitBucketOnPivots($LZ, bucket#0, pivots#0));

// consequence axiom for BucketsLib.__default.SplitBucketOnPivots
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0, pivots#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
           == Seq#Length(pivots#0) + 1
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#0)): DatatypeType } 
          LitInt(0) <= i#0
               && i#0
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> BucketsLib.__default.PreWFBucket($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#0)): DatatypeType))
         && BucketsLib.__default.BucketListWellMarshalled(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#1)): DatatypeType } 
          LitInt(0) <= i#1
               && i#1
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> Set#Subset(Map#Domain(BucketsLib.Bucket.b($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#1)): DatatypeType)), 
              Map#Domain(BucketsLib.Bucket.b(bucket#0))))
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#2)): DatatypeType } 
          LitInt(0) <= i#2
               && i#2
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> Set#Subset(Map#Values(BucketsLib.Bucket.b($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#2)): DatatypeType)), 
              Map#Values(BucketsLib.Bucket.b(bucket#0))))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#3)): DatatypeType } 
          LitInt(0) <= i#3
               && i#3
                 < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
             ==> Seq#Length(BucketsLib.Bucket.keys($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#3)): DatatypeType))
               == Seq#Length(BucketsLib.Bucket.msgs($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#3)): DatatypeType)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> (forall i#4: int :: 
            { $Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#4)): DatatypeType } 
            LitInt(0) <= i#4
                 && i#4
                   < Seq#Length(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0))
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), i#4)): DatatypeType)))
         && $Is(BucketsLib.__default.SplitBucketOnPivots($ly, bucket#0, pivots#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketOnPivots#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketOnPivots
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketOnPivots#requires($ly, bucket#0, pivots#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.SplitBucketOnPivots#requires($ly, bucket#0, pivots#0)
       == true);

// definition axiom for BucketsLib.__default.SplitBucketOnPivots(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0, pivots#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(pivots#0) == LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.B#canCall(BucketsLib.Bucket.b(bucket#0)))
         && (Seq#Length(pivots#0) != LitInt(0)
           ==> (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, Tclass.KeyType.Key())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                     ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
                       && Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                       && Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
             && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
                  $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                     && 
                    Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                     && Lexicographic__Byte__Order.__default.lt($Unbox($w#0): Seq Box, 
                      $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)), 
                (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
                TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
             && (var l#0 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#3: Box :: 
                      $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#3]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#3): Seq Box, 
                          $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)), 
                    (lambda $w#3: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#3]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (forall key#1: Seq Box :: 
                  { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]): DatatypeType } 
                    { Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1) } 
                    { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
                  $Is(key#1, Tclass.KeyType.Key())
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                         ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
                           && Lexicographic__Byte__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1))
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                           && Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1)
                         ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
                 && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#1: Box :: 
                      $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                         && Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, 
                          $Unbox($w#1): Seq Box)), 
                    (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
                 && 
                Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), pivots#0)
                 && BucketsLib.__default.SplitBucketOnPivots#canCall(l#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0))))
         && BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, pivots#0)
           == (if Seq#Length(pivots#0) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, BucketsLib.Bucket.b(bucket#0))))
             else (var l#0 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#4: Box :: 
                      $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#4]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#4): Seq Box, 
                          $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box)), 
                    (lambda $w#4: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#4]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (var r#0 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                    Map#Glue((lambda $w#5: Box :: 
                        $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                           && 
                          Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#5]
                           && Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, 
                            $Unbox($w#5): Seq Box)), 
                      (lambda $w#5: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#5]), 
                      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
                Seq#Append(BucketsLib.__default.SplitBucketOnPivots($ly, l#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0)), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(r#0)))))));

// definition axiom for BucketsLib.__default.SplitBucketOnPivots for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, Lit(pivots#0)) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(bucket#0, Lit(pivots#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(Lit(pivots#0)) == LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.__default.B#canCall(BucketsLib.Bucket.b(bucket#0)))
         && (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, Tclass.KeyType.Key())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                     ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                       && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
                   && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                       && Lexicographic__Byte__Order.__default.lt(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
             && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#6: Box :: 
                  $Is($Unbox($w#6): Seq Box, Tclass.KeyType.Key())
                     && 
                    Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#6]
                     && Lexicographic__Byte__Order.__default.lt($Unbox($w#6): Seq Box, 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                (lambda $w#6: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#6]), 
                TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
             && (var l#1 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#9: Box :: 
                      $Is($Unbox($w#9): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#9]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#9): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#9: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#9]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (forall key#1: Seq Box :: 
                  { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]): DatatypeType } 
                    { Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1) } 
                    { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
                  $Is(key#1, Tclass.KeyType.Key())
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                         ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                           && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1))
                       && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1)
                         ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
                 && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#7: Box :: 
                      $Is($Unbox($w#7): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#7]
                         && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                          $Unbox($w#7): Seq Box)), 
                    (lambda $w#7: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#7]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
                 && 
                Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                 && BucketsLib.__default.SplitBucketOnPivots#canCall(l#1, Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))))
         && BucketsLib.__default.SplitBucketOnPivots($LS($ly), bucket#0, Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, BucketsLib.Bucket.b(bucket#0))))
             else (var l#1 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#10: Box :: 
                      $Is($Unbox($w#10): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#10]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#10): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#10: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#10]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (var r#1 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                    Map#Glue((lambda $w#11: Box :: 
                        $Is($Unbox($w#11): Seq Box, Tclass.KeyType.Key())
                           && 
                          Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#11]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            $Unbox($w#11): Seq Box)), 
                      (lambda $w#11: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#11]), 
                      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
                Seq#Append(BucketsLib.__default.SplitBucketOnPivots($LS($ly), 
                    l#1, 
                    Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(r#1)))))));

// definition axiom for BucketsLib.__default.SplitBucketOnPivots for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivots#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketOnPivots($LS($ly), Lit(bucket#0), Lit(pivots#0)) } 
    BucketsLib.__default.SplitBucketOnPivots#canCall(Lit(bucket#0), Lit(pivots#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key())))
       ==> (Seq#Length(Lit(pivots#0)) == LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.__default.B#canCall(Lit(BucketsLib.Bucket.b(Lit(bucket#0)))))
         && (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> (forall key#0: Seq Box :: 
              { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
                { Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box) } 
                { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
              $Is(key#0, Tclass.KeyType.Key())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                     ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                       && Lexicographic__Byte__Order.__default.lt#canCall(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
                   && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                       && Lexicographic__Byte__Order.__default.lt(key#0, 
                        Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
             && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#12: Box :: 
                  $Is($Unbox($w#12): Seq Box, Tclass.KeyType.Key())
                     && 
                    Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#12]
                     && Lexicographic__Byte__Order.__default.lt($Unbox($w#12): Seq Box, 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                (lambda $w#12: Box :: 
                  Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#12]), 
                TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
             && (var l#2 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#15: Box :: 
                      $Is($Unbox($w#15): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#15]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#15): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#15: Box :: 
                      Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#15]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (forall key#1: Seq Box :: 
                  { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)]): DatatypeType } 
                    { Lexicographic__Byte__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box, key#1) } 
                    { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#1)] } 
                  $Is(key#1, Tclass.KeyType.Key())
                     ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                       && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#1)]
                         ==> Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                           && Lexicographic__Byte__Order.__default.lte#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1))
                       && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#1)]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            key#1)
                         ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
                 && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#13: Box :: 
                      $Is($Unbox($w#13): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#13]
                         && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                          $Unbox($w#13): Seq Box)), 
                    (lambda $w#13: Box :: 
                      Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#13]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
                 && 
                Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
                 && BucketsLib.__default.SplitBucketOnPivots#canCall(l#2, Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))))
         && BucketsLib.__default.SplitBucketOnPivots($LS($ly), Lit(bucket#0), Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(BucketsLib.Bucket.b(Lit(bucket#0))))))
             else (var l#2 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                  Map#Glue((lambda $w#16: Box :: 
                      $Is($Unbox($w#16): Seq Box, Tclass.KeyType.Key())
                         && 
                        Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#16]
                         && Lexicographic__Byte__Order.__default.lt($Unbox($w#16): Seq Box, 
                          Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))), 
                    (lambda $w#16: Box :: 
                      Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#16]), 
                    TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
              (var r#2 := BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
                    Map#Glue((lambda $w#17: Box :: 
                        $Is($Unbox($w#17): Seq Box, Tclass.KeyType.Key())
                           && 
                          Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#17]
                           && Lexicographic__Byte__Order.__default.lte(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box), 
                            $Unbox($w#17): Seq Box)), 
                      (lambda $w#17: Box :: 
                        Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#17]), 
                      TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))); 
                Seq#Append(BucketsLib.__default.SplitBucketOnPivots($LS($ly), 
                    l#2, 
                    Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(r#2)))))));

// function declaration for BucketsLib._default.ClampToSlot
function BucketsLib.__default.ClampToSlot(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : DatatypeType;

function BucketsLib.__default.ClampToSlot#canCall(bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketsLib.__default.ClampToSlot
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.ClampToSlot#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0), 
        Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampToSlot#requires(DatatypeType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.ClampToSlot
axiom (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
  { BucketsLib.__default.ClampToSlot#requires(bucket#0, pivots#0, i#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.ClampToSlot#requires(bucket#0, pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketsLib.__default.ClampToSlot(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    { BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0) } 
    BucketsLib.__default.ClampToSlot#canCall(bucket#0, pivots#0, i#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(pivots#0, key#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && PivotsLib.__default.Route(pivots#0, key#0) == i#0
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && PivotsLib.__default.Route(pivots#0, $Unbox($w#0): Seq Box) == i#0), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampToSlot(bucket#0, pivots#0, i#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && PivotsLib.__default.Route(pivots#0, $Unbox($w#1): Seq Box) == i#0), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampToSlot for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketsLib.__default.ClampToSlot(Lit(bucket#0), Lit(pivots#0), LitInt(i#0)) } 
    BucketsLib.__default.ClampToSlot#canCall(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { PivotsLib.__default.Route(pivots#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), key#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && PivotsLib.__default.Route(Lit(pivots#0), key#0) == LitInt(i#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#2): Seq Box) == LitInt(i#0)), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampToSlot(Lit(bucket#0), Lit(pivots#0), LitInt(i#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($w#3): Seq Box) == LitInt(i#0)), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketIntersect
function BucketsLib.__default.BucketIntersect($ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box) : DatatypeType;

function BucketsLib.__default.BucketIntersect#canCall(bucket#0: DatatypeType, keys#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0)
     == BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketIntersect(AsFuelBottom($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0)
     == BucketsLib.__default.BucketIntersect($LZ, bucket#0, keys#0));

// consequence axiom for BucketsLib.__default.BucketIntersect
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0) } 
    BucketsLib.__default.BucketIntersect#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0))
         && $Is(BucketsLib.__default.BucketIntersect($ly, bucket#0, keys#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketIntersect#requires(LayerType, DatatypeType, Set Box) : bool;

// #requires axiom for BucketsLib.__default.BucketIntersect
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketIntersect#requires($ly, bucket#0, keys#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(keys#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketIntersect#requires($ly, bucket#0, keys#0) == true);

// definition axiom for BucketsLib.__default.BucketIntersect(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0) } 
    BucketsLib.__default.BucketIntersect#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] && keys#0[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && keys#0[$w#0]), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketIntersect($LS($ly), bucket#0, keys#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && keys#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.BucketIntersect for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.BucketIntersect($LS($ly), Lit(bucket#0), Lit(keys#0)) } 
    BucketsLib.__default.BucketIntersect#canCall(Lit(bucket#0), Lit(keys#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && Lit(keys#0)[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && Lit(keys#0)[$w#2]), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketIntersect($LS($ly), Lit(bucket#0), Lit(keys#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && Lit(keys#0)[$w#3]), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketComplement
function BucketsLib.__default.BucketComplement($ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box) : DatatypeType;

function BucketsLib.__default.BucketComplement#canCall(bucket#0: DatatypeType, keys#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0)
     == BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketComplement(AsFuelBottom($ly), bucket#0, keys#0) } 
  BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0)
     == BucketsLib.__default.BucketComplement($LZ, bucket#0, keys#0));

// consequence axiom for BucketsLib.__default.BucketComplement
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0) } 
    BucketsLib.__default.BucketComplement#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0))
         && $Is(BucketsLib.__default.BucketComplement($ly, bucket#0, keys#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.BucketComplement#requires(LayerType, DatatypeType, Set Box) : bool;

// #requires axiom for BucketsLib.__default.BucketComplement
axiom (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
  { BucketsLib.__default.BucketComplement#requires($ly, bucket#0, keys#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(keys#0, TSet(Tclass.KeyType.Key()))
     ==> BucketsLib.__default.BucketComplement#requires($ly, bucket#0, keys#0) == true);

// definition axiom for BucketsLib.__default.BucketComplement(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    { BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0) } 
    BucketsLib.__default.BucketComplement#canCall(bucket#0, keys#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] && !keys#0[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && !keys#0[$w#0]), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketComplement($LS($ly), bucket#0, keys#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && !keys#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.BucketComplement for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, keys#0: Set Box :: 
    {:weight 3} { BucketsLib.__default.BucketComplement($LS($ly), Lit(bucket#0), Lit(keys#0)) } 
    BucketsLib.__default.BucketComplement#canCall(Lit(bucket#0), Lit(keys#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(keys#0, TSet(Tclass.KeyType.Key())))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { keys#0[$Box(key#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && !Lit(keys#0)[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && !Lit(keys#0)[$w#2]), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.BucketComplement($LS($ly), Lit(bucket#0), Lit(keys#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && !Lit(keys#0)[$w#3]), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.BucketsEquivalentForKey
function BucketsLib.__default.BucketsEquivalentForKey(a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box) : bool;

function BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.BucketsEquivalentForKey
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0) } 
    BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0, b#0, key#0)
         || (
          $Is(a#0, Tclass.BucketsLib.Bucket())
           && $Is(b#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> true);

function BucketsLib.__default.BucketsEquivalentForKey#requires(DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.BucketsEquivalentForKey
axiom (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
  { BucketsLib.__default.BucketsEquivalentForKey#requires(a#0, b#0, key#0) } 
  $Is(a#0, Tclass.BucketsLib.Bucket())
       && $Is(b#0, Tclass.BucketsLib.Bucket())
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.BucketsEquivalentForKey#requires(a#0, b#0, key#0) == true);

// definition axiom for BucketsLib.__default.BucketsEquivalentForKey(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0) } 
    BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0, b#0, key#0)
         || (
          $Is(a#0, Tclass.BucketsLib.Bucket())
           && $Is(b#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $IsA#ValueMessage.Message(BucketsLib.__default.BucketGet(a#0, key#0))
         && $IsA#ValueMessage.Message(BucketsLib.__default.BucketGet(b#0, key#0))
         && 
        BucketsLib.__default.BucketGet#canCall(a#0, key#0)
         && BucketsLib.__default.BucketGet#canCall(b#0, key#0)
         && BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0)
           == ValueMessage.Message#Equal(BucketsLib.__default.BucketGet(a#0, key#0), 
            BucketsLib.__default.BucketGet(b#0, key#0)));

// definition axiom for BucketsLib.__default.BucketsEquivalentForKey for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.BucketsEquivalentForKey(Lit(a#0), Lit(b#0), Lit(key#0)) } 
    BucketsLib.__default.BucketsEquivalentForKey#canCall(Lit(a#0), Lit(b#0), Lit(key#0))
         || (
          $Is(a#0, Tclass.BucketsLib.Bucket())
           && $Is(b#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $IsA#ValueMessage.Message(Lit(BucketsLib.__default.BucketGet(Lit(a#0), Lit(key#0))))
         && $IsA#ValueMessage.Message(Lit(BucketsLib.__default.BucketGet(Lit(b#0), Lit(key#0))))
         && 
        BucketsLib.__default.BucketGet#canCall(Lit(a#0), Lit(key#0))
         && BucketsLib.__default.BucketGet#canCall(Lit(b#0), Lit(key#0))
         && BucketsLib.__default.BucketsEquivalentForKey(Lit(a#0), Lit(b#0), Lit(key#0))
           == ValueMessage.Message#Equal(BucketsLib.__default.BucketGet(Lit(a#0), Lit(key#0)), 
            BucketsLib.__default.BucketGet(Lit(b#0), Lit(key#0))));

// function declaration for BucketsLib._default.BucketsEquivalent
function BucketsLib.__default.BucketsEquivalent(a#0: DatatypeType, b#0: DatatypeType) : bool;

function BucketsLib.__default.BucketsEquivalent#canCall(a#0: DatatypeType, b#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.BucketsEquivalent
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { BucketsLib.__default.BucketsEquivalent(a#0, b#0) } 
    BucketsLib.__default.BucketsEquivalent#canCall(a#0, b#0)
         || ($Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket()))
       ==> true);

function BucketsLib.__default.BucketsEquivalent#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.BucketsEquivalent
axiom (forall a#0: DatatypeType, b#0: DatatypeType :: 
  { BucketsLib.__default.BucketsEquivalent#requires(a#0, b#0) } 
  $Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.BucketsEquivalent#requires(a#0, b#0) == true);

// definition axiom for BucketsLib.__default.BucketsEquivalent(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { BucketsLib.__default.BucketsEquivalent(a#0, b#0) } 
    BucketsLib.__default.BucketsEquivalent#canCall(a#0, b#0)
         || ($Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.__default.BucketsEquivalentForKey#canCall(a#0, b#0, key#0))
         && BucketsLib.__default.BucketsEquivalent(a#0, b#0)
           == (forall key#0: Seq Box :: 
            { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0) } 
            $Is(key#0, Tclass.KeyType.Key())
               ==> BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#0)));

// definition axiom for BucketsLib.__default.BucketsEquivalent for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.BucketsEquivalent(Lit(a#0), Lit(b#0)) } 
    BucketsLib.__default.BucketsEquivalent#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, Tclass.BucketsLib.Bucket()) && $Is(b#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#1: Seq Box :: 
          { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#1) } 
          $Is(key#1, Tclass.KeyType.Key())
             ==> BucketsLib.__default.BucketsEquivalentForKey#canCall(Lit(a#0), Lit(b#0), key#1))
         && BucketsLib.__default.BucketsEquivalent(Lit(a#0), Lit(b#0))
           == (forall key#1: Seq Box :: 
            { BucketsLib.__default.BucketsEquivalentForKey(a#0, b#0, key#1) } 
            $Is(key#1, Tclass.KeyType.Key())
               ==> BucketsLib.__default.BucketsEquivalentForKey(Lit(a#0), Lit(b#0), key#1)));

// function declaration for BucketsLib._default.Compose
function BucketsLib.__default.Compose($ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.Compose#canCall(top#0: DatatypeType, bot#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
  { BucketsLib.__default.Compose($LS($ly), top#0, bot#0) } 
  BucketsLib.__default.Compose($LS($ly), top#0, bot#0)
     == BucketsLib.__default.Compose($ly, top#0, bot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
  { BucketsLib.__default.Compose(AsFuelBottom($ly), top#0, bot#0) } 
  BucketsLib.__default.Compose($ly, top#0, bot#0)
     == BucketsLib.__default.Compose($LZ, top#0, bot#0));

// consequence axiom for BucketsLib.__default.Compose
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
    { BucketsLib.__default.Compose($ly, top#0, bot#0) } 
    BucketsLib.__default.Compose#canCall(top#0, bot#0)
         || ($Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bot#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.Compose($ly, top#0, bot#0))
         && $Is(BucketsLib.__default.Compose($ly, top#0, bot#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.Compose#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.Compose
axiom (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
  { BucketsLib.__default.Compose#requires($ly, top#0, bot#0) } 
  $Is(top#0, Tclass.BucketsLib.Bucket()) && $Is(bot#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.Compose#requires($ly, top#0, bot#0) == true);

// definition axiom for BucketsLib.__default.Compose(revealed)
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
    { BucketsLib.__default.Compose($LS($ly), top#0, bot#0) } 
    BucketsLib.__default.Compose#canCall(top#0, bot#0)
         || ($Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bot#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(bot#0, key#0) } 
            { BucketsLib.__default.BucketGet(top#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(top#0)
               && BucketsLib.Bucket.BucketMapWithSeq_q(bot#0)
               && (Map#Domain(BucketsLib.Bucket.b(top#0))[$Box(key#0)]
                   || Map#Domain(BucketsLib.Bucket.b(bot#0))[$Box(key#0)]
                 ==> BucketsLib.__default.BucketGet#canCall(top#0, key#0)
                   && BucketsLib.__default.BucketGet#canCall(bot#0, key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(top#0, key#0), 
                    BucketsLib.__default.BucketGet(bot#0, key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && (Map#Domain(BucketsLib.Bucket.b(top#0))[$w#0]
                   || Map#Domain(BucketsLib.Bucket.b(bot#0))[$w#0])), 
            (lambda $w#0: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(top#0, $Unbox($w#0): Seq Box), 
                  BucketsLib.__default.BucketGet(bot#0, $Unbox($w#0): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.Compose($LS($ly), top#0, bot#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && (Map#Domain(BucketsLib.Bucket.b(top#0))[$w#1]
                     || Map#Domain(BucketsLib.Bucket.b(bot#0))[$w#1])), 
              (lambda $w#1: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(top#0, $Unbox($w#1): Seq Box), 
                    BucketsLib.__default.BucketGet(bot#0, $Unbox($w#1): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.Compose for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, top#0: DatatypeType, bot#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.Compose($LS($ly), Lit(top#0), Lit(bot#0)) } 
    BucketsLib.__default.Compose#canCall(Lit(top#0), Lit(bot#0))
         || ($Is(top#0, Tclass.BucketsLib.Bucket())
           && $Is(bot#0, Tclass.BucketsLib.Bucket()))
       ==> (forall key#0: Seq Box :: 
          { BucketsLib.__default.BucketGet(bot#0, key#0) } 
            { BucketsLib.__default.BucketGet(top#0, key#0) } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(top#0))
               && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bot#0))
               && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(top#0)))))[$Box(key#0)]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(bot#0)))))[$Box(key#0)]
                 ==> BucketsLib.__default.BucketGet#canCall(Lit(top#0), key#0)
                   && BucketsLib.__default.BucketGet#canCall(Lit(bot#0), key#0)
                   && ValueMessage.__default.Merge#canCall(BucketsLib.__default.BucketGet(Lit(top#0), key#0), 
                    BucketsLib.__default.BucketGet(Lit(bot#0), key#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(top#0)))))[$w#2]
                   || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(bot#0)))))[$w#2])), 
            (lambda $w#2: Box :: 
              $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(top#0), $Unbox($w#2): Seq Box), 
                  BucketsLib.__default.BucketGet(Lit(bot#0), $Unbox($w#2): Seq Box)))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.Compose($LS($ly), Lit(top#0), Lit(bot#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && (Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(top#0)))))[$w#3]
                     || Lit(Map#Domain(Lit(BucketsLib.Bucket.b(Lit(bot#0)))))[$w#3])), 
              (lambda $w#3: Box :: 
                $Box(ValueMessage.__default.Merge(BucketsLib.__default.BucketGet(Lit(top#0), $Unbox($w#3): Seq Box), 
                    BucketsLib.__default.BucketGet(Lit(bot#0), $Unbox($w#3): Seq Box)))), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.ComposeSeq
function BucketsLib.__default.ComposeSeq($ly: LayerType, buckets#0: Seq Box) : DatatypeType;

function BucketsLib.__default.ComposeSeq#canCall(buckets#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.ComposeSeq($LS($ly), buckets#0) } 
  BucketsLib.__default.ComposeSeq($LS($ly), buckets#0)
     == BucketsLib.__default.ComposeSeq($ly, buckets#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.ComposeSeq(AsFuelBottom($ly), buckets#0) } 
  BucketsLib.__default.ComposeSeq($ly, buckets#0)
     == BucketsLib.__default.ComposeSeq($LZ, buckets#0));

// consequence axiom for BucketsLib.__default.ComposeSeq
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.ComposeSeq($ly, buckets#0) } 
    BucketsLib.__default.ComposeSeq#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ComposeSeq($ly, buckets#0))
         && $Is(BucketsLib.__default.ComposeSeq($ly, buckets#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ComposeSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.ComposeSeq
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketsLib.__default.ComposeSeq#requires($ly, buckets#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.ComposeSeq#requires($ly, buckets#0) == true);

// definition axiom for BucketsLib.__default.ComposeSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketsLib.__default.ComposeSeq($LS($ly), buckets#0) } 
    BucketsLib.__default.ComposeSeq#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(buckets#0) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.ComposeSeq#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
             && Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.Compose#canCall(BucketsLib.__default.ComposeSeq($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0)), 
              $Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))
         && BucketsLib.__default.ComposeSeq($LS($ly), buckets#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, 
              BucketsLib.__default.ComposeSeq($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0)), 
              $Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)));

// definition axiom for BucketsLib.__default.ComposeSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.ComposeSeq($LS($ly), Lit(buckets#0)) } 
    BucketsLib.__default.ComposeSeq#canCall(Lit(buckets#0))
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(Lit(buckets#0)) == LitInt(0)
           ==> BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.ComposeSeq#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
             && Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.Compose#canCall(BucketsLib.__default.ComposeSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0)))), 
              Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType)))
         && BucketsLib.__default.ComposeSeq($LS($ly), Lit(buckets#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))
             else BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, 
              BucketsLib.__default.ComposeSeq($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0)))), 
              Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))));

// function declaration for BucketsLib._default.FlushEquivalentParentChild
function BucketsLib.__default.FlushEquivalentParentChild(oldparent#0: DatatypeType, 
    oldchild#0: DatatypeType, 
    newparent#0: DatatypeType, 
    newchild#0: DatatypeType)
   : bool;

function BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0: DatatypeType, 
    oldchild#0: DatatypeType, 
    newparent#0: DatatypeType, 
    newchild#0: DatatypeType)
   : bool;

// consequence axiom for BucketsLib.__default.FlushEquivalentParentChild
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchild#0: DatatypeType, 
      newparent#0: DatatypeType, 
      newchild#0: DatatypeType :: 
    { BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, oldchild#0, newparent#0, newchild#0) } 
    BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0, oldchild#0, newparent#0, newchild#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchild#0, Tclass.BucketsLib.Bucket()))
       ==> true);

function BucketsLib.__default.FlushEquivalentParentChild#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.FlushEquivalentParentChild
axiom (forall oldparent#0: DatatypeType, 
    oldchild#0: DatatypeType, 
    newparent#0: DatatypeType, 
    newchild#0: DatatypeType :: 
  { BucketsLib.__default.FlushEquivalentParentChild#requires(oldparent#0, oldchild#0, newparent#0, newchild#0) } 
  $Is(oldparent#0, Tclass.BucketsLib.Bucket())
       && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
       && $Is(newparent#0, Tclass.BucketsLib.Bucket())
       && $Is(newchild#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.FlushEquivalentParentChild#requires(oldparent#0, oldchild#0, newparent#0, newchild#0)
       == true);

// definition axiom for BucketsLib.__default.FlushEquivalentParentChild(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchild#0: DatatypeType, 
      newparent#0: DatatypeType, 
      newchild#0: DatatypeType :: 
    { BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, oldchild#0, newparent#0, newchild#0) } 
    BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0, oldchild#0, newparent#0, newchild#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchild#0, Tclass.BucketsLib.Bucket()))
       ==> $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, oldparent#0, oldchild#0))
         && $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, newparent#0, newchild#0))
         && 
        BucketsLib.__default.Compose#canCall(oldparent#0, oldchild#0)
         && BucketsLib.__default.Compose#canCall(newparent#0, newchild#0)
         && BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, oldchild#0, newparent#0, newchild#0)
           == BucketsLib.Bucket#Equal(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, oldparent#0, oldchild#0), 
            BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, newparent#0, newchild#0)));

// definition axiom for BucketsLib.__default.FlushEquivalentParentChild for all literals(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchild#0: DatatypeType, 
      newparent#0: DatatypeType, 
      newchild#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.FlushEquivalentParentChild(Lit(oldparent#0), Lit(oldchild#0), Lit(newparent#0), Lit(newchild#0)) } 
    BucketsLib.__default.FlushEquivalentParentChild#canCall(Lit(oldparent#0), Lit(oldchild#0), Lit(newparent#0), Lit(newchild#0))
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchild#0, Tclass.BucketsLib.Bucket())
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchild#0, Tclass.BucketsLib.Bucket()))
       ==> $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(oldparent#0), Lit(oldchild#0)))
         && $IsA#BucketsLib.Bucket(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(newparent#0), Lit(newchild#0)))
         && 
        BucketsLib.__default.Compose#canCall(Lit(oldparent#0), Lit(oldchild#0))
         && BucketsLib.__default.Compose#canCall(Lit(newparent#0), Lit(newchild#0))
         && BucketsLib.__default.FlushEquivalentParentChild(Lit(oldparent#0), Lit(oldchild#0), Lit(newparent#0), Lit(newchild#0))
           == BucketsLib.Bucket#Equal(BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(oldparent#0), Lit(oldchild#0)), 
            BucketsLib.__default.Compose(StartFuel_BucketsLib._default.Compose, Lit(newparent#0), Lit(newchild#0))));

// function declaration for BucketsLib._default.FlushEquivalent
function BucketsLib.__default.FlushEquivalent(oldparent#0: DatatypeType, 
    oldchildren#0: Seq Box, 
    newparent#0: DatatypeType, 
    newchildren#0: Seq Box)
   : bool;

function BucketsLib.__default.FlushEquivalent#canCall(oldparent#0: DatatypeType, 
    oldchildren#0: Seq Box, 
    newparent#0: DatatypeType, 
    newchildren#0: Seq Box)
   : bool;

// consequence axiom for BucketsLib.__default.FlushEquivalent
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchildren#0: Seq Box, 
      newparent#0: DatatypeType, 
      newchildren#0: Seq Box :: 
    { BucketsLib.__default.FlushEquivalent(oldparent#0, oldchildren#0, newparent#0, newchildren#0) } 
    BucketsLib.__default.FlushEquivalent#canCall(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket())))
       ==> true);

function BucketsLib.__default.FlushEquivalent#requires(DatatypeType, Seq Box, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.FlushEquivalent
axiom (forall oldparent#0: DatatypeType, 
    oldchildren#0: Seq Box, 
    newparent#0: DatatypeType, 
    newchildren#0: Seq Box :: 
  { BucketsLib.__default.FlushEquivalent#requires(oldparent#0, oldchildren#0, newparent#0, newchildren#0) } 
  $Is(oldparent#0, Tclass.BucketsLib.Bucket())
       && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(newparent#0, Tclass.BucketsLib.Bucket())
       && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.FlushEquivalent#requires(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
       == true);

// definition axiom for BucketsLib.__default.FlushEquivalent(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchildren#0: Seq Box, 
      newparent#0: DatatypeType, 
      newchildren#0: Seq Box :: 
    { BucketsLib.__default.FlushEquivalent(oldparent#0, oldchildren#0, newparent#0, newchildren#0) } 
    BucketsLib.__default.FlushEquivalent#canCall(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket())))
       ==> (Seq#Length(oldchildren#0) == Seq#Length(newchildren#0)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(newchildren#0, i#0)): DatatypeType } 
              { $Unbox(Seq#Index(oldchildren#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(oldchildren#0)
               ==> BucketsLib.__default.FlushEquivalentParentChild#canCall(oldparent#0, 
                $Unbox(Seq#Index(oldchildren#0, i#0)): DatatypeType, 
                newparent#0, 
                $Unbox(Seq#Index(newchildren#0, i#0)): DatatypeType)))
         && BucketsLib.__default.FlushEquivalent(oldparent#0, oldchildren#0, newparent#0, newchildren#0)
           == (Seq#Length(oldchildren#0) == Seq#Length(newchildren#0)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(newchildren#0, i#0)): DatatypeType } 
                { $Unbox(Seq#Index(oldchildren#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(oldchildren#0)
                 ==> BucketsLib.__default.FlushEquivalentParentChild(oldparent#0, 
                  $Unbox(Seq#Index(oldchildren#0, i#0)): DatatypeType, 
                  newparent#0, 
                  $Unbox(Seq#Index(newchildren#0, i#0)): DatatypeType))));

// definition axiom for BucketsLib.__default.FlushEquivalent for all literals(revealed)
axiom true
   ==> (forall oldparent#0: DatatypeType, 
      oldchildren#0: Seq Box, 
      newparent#0: DatatypeType, 
      newchildren#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.FlushEquivalent(Lit(oldparent#0), Lit(oldchildren#0), Lit(newparent#0), Lit(newchildren#0)) } 
    BucketsLib.__default.FlushEquivalent#canCall(Lit(oldparent#0), Lit(oldchildren#0), Lit(newparent#0), Lit(newchildren#0))
         || (
          $Is(oldparent#0, Tclass.BucketsLib.Bucket())
           && $Is(oldchildren#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(newparent#0, Tclass.BucketsLib.Bucket())
           && $Is(newchildren#0, TSeq(Tclass.BucketsLib.Bucket())))
       ==> (Seq#Length(Lit(oldchildren#0)) == Seq#Length(Lit(newchildren#0))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(newchildren#0, i#1)): DatatypeType } 
              { $Unbox(Seq#Index(oldchildren#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(oldchildren#0))
               ==> BucketsLib.__default.FlushEquivalentParentChild#canCall(Lit(oldparent#0), 
                $Unbox(Seq#Index(Lit(oldchildren#0), i#1)): DatatypeType, 
                Lit(newparent#0), 
                $Unbox(Seq#Index(Lit(newchildren#0), i#1)): DatatypeType)))
         && BucketsLib.__default.FlushEquivalent(Lit(oldparent#0), Lit(oldchildren#0), Lit(newparent#0), Lit(newchildren#0))
           == (Seq#Length(Lit(oldchildren#0)) == Seq#Length(Lit(newchildren#0))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(newchildren#0, i#1)): DatatypeType } 
                { $Unbox(Seq#Index(oldchildren#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(oldchildren#0))
                 ==> BucketsLib.__default.FlushEquivalentParentChild(Lit(oldparent#0), 
                  $Unbox(Seq#Index(Lit(oldchildren#0), i#1)): DatatypeType, 
                  Lit(newparent#0), 
                  $Unbox(Seq#Index(Lit(newchildren#0), i#1)): DatatypeType))));

// function declaration for BucketsLib._default.InterpretBucketStack
function BucketsLib.__default.InterpretBucketStack($ly: LayerType, buckets#0: Seq Box, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.InterpretBucketStack#canCall(buckets#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0) } 
  BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0)
     == BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.InterpretBucketStack(AsFuelBottom($ly), buckets#0, key#0) } 
  BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0)
     == BucketsLib.__default.InterpretBucketStack($LZ, buckets#0, key#0));

// consequence axiom for BucketsLib.__default.InterpretBucketStack
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0) } 
    BucketsLib.__default.InterpretBucketStack#canCall(buckets#0, key#0)
         || ($Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> $Is(BucketsLib.__default.InterpretBucketStack($ly, buckets#0, key#0), 
        Tclass.ValueMessage.Message()));

function BucketsLib.__default.InterpretBucketStack#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.InterpretBucketStack
axiom (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.InterpretBucketStack#requires($ly, buckets#0, key#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.InterpretBucketStack#requires($ly, buckets#0, key#0)
       == true);

// definition axiom for BucketsLib.__default.InterpretBucketStack(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0) } 
    BucketsLib.__default.InterpretBucketStack#canCall(buckets#0, key#0)
         || ($Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(buckets#0) == LitInt(0)
           ==> ValueMessage.__default.NopDelta#canCall())
         && (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.InterpretBucketStack#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0), key#0)
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketsLib.__default.BucketGet#canCall($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType, 
              key#0)
             && ValueMessage.__default.Merge#canCall(BucketsLib.__default.InterpretBucketStack($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0), key#0), 
              BucketsLib.__default.BucketGet($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType, 
                key#0)))
         && BucketsLib.__default.InterpretBucketStack($LS($ly), buckets#0, key#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then #ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta()))
             else ValueMessage.__default.Merge(BucketsLib.__default.InterpretBucketStack($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0), key#0), 
              BucketsLib.__default.BucketGet($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType, 
                key#0))));

// definition axiom for BucketsLib.__default.InterpretBucketStack for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.InterpretBucketStack($LS($ly), Lit(buckets#0), Lit(key#0)) } 
    BucketsLib.__default.InterpretBucketStack#canCall(Lit(buckets#0), Lit(key#0))
         || ($Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(buckets#0)) == LitInt(0)
           ==> ValueMessage.__default.NopDelta#canCall())
         && (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.InterpretBucketStack#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))), 
              Lit(key#0))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketsLib.__default.BucketGet#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType), 
              Lit(key#0))
             && ValueMessage.__default.Merge#canCall(Lit(BucketsLib.__default.InterpretBucketStack($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))), 
                  Lit(key#0))), 
              Lit(BucketsLib.__default.BucketGet(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType), 
                  Lit(key#0)))))
         && BucketsLib.__default.InterpretBucketStack($LS($ly), Lit(buckets#0), Lit(key#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then #ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta()))
             else ValueMessage.__default.Merge(Lit(BucketsLib.__default.InterpretBucketStack($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))), 
                  Lit(key#0))), 
              Lit(BucketsLib.__default.BucketGet(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType), 
                  Lit(key#0))))));

// function declaration for BucketsLib._default.ClampRange
function BucketsLib.__default.ClampRange($ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType)
   : DatatypeType;

function BucketsLib.__default.ClampRange#canCall(bucket#0: DatatypeType, start#0: DatatypeType, end#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType :: 
  { BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0) } 
  BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0)
     == BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType :: 
  { BucketsLib.__default.ClampRange(AsFuelBottom($ly), bucket#0, start#0, end#0) } 
  BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0)
     == BucketsLib.__default.ClampRange($LZ, bucket#0, start#0, end#0));

// consequence axiom for BucketsLib.__default.ClampRange
axiom true
   ==> (forall $ly: LayerType, 
      bucket#0: DatatypeType, 
      start#0: DatatypeType, 
      end#0: DatatypeType :: 
    { BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0) } 
    BucketsLib.__default.ClampRange#canCall(bucket#0, start#0, end#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0))
         && $Is(BucketsLib.__default.ClampRange($ly, bucket#0, start#0, end#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampRange#requires(LayerType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.ClampRange
axiom (forall $ly: LayerType, 
    bucket#0: DatatypeType, 
    start#0: DatatypeType, 
    end#0: DatatypeType :: 
  { BucketsLib.__default.ClampRange#requires($ly, bucket#0, start#0, end#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(start#0, Tclass.UI.RangeStart())
       && $Is(end#0, Tclass.UI.RangeEnd())
     ==> BucketsLib.__default.ClampRange#requires($ly, bucket#0, start#0, end#0) == true);

// definition axiom for BucketsLib.__default.ClampRange(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      bucket#0: DatatypeType, 
      start#0: DatatypeType, 
      end#0: DatatypeType :: 
    { BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0) } 
    BucketsLib.__default.ClampRange#canCall(bucket#0, start#0, end#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.InRange(start#0, key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> MapSpec.__default.InRange#canCall(start#0, key#0, end#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && MapSpec.__default.InRange(start#0, key#0, end#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && MapSpec.__default.InRange(start#0, $Unbox($w#0): Seq Box, end#0)), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampRange($LS($ly), bucket#0, start#0, end#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && MapSpec.__default.InRange(start#0, $Unbox($w#1): Seq Box, end#0)), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampRange for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      bucket#0: DatatypeType, 
      start#0: DatatypeType, 
      end#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.ClampRange($LS($ly), Lit(bucket#0), Lit(start#0), Lit(end#0)) } 
    BucketsLib.__default.ClampRange#canCall(Lit(bucket#0), Lit(start#0), Lit(end#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart())
           && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.InRange(start#0, key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> MapSpec.__default.InRange#canCall(Lit(start#0), key#0, Lit(end#0)))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && MapSpec.__default.InRange(Lit(start#0), key#0, Lit(end#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && MapSpec.__default.InRange(Lit(start#0), $Unbox($w#2): Seq Box, Lit(end#0))), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampRange($LS($ly), Lit(bucket#0), Lit(start#0), Lit(end#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && MapSpec.__default.InRange(Lit(start#0), $Unbox($w#3): Seq Box, Lit(end#0))), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.ClampStart
function BucketsLib.__default.ClampStart($ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.ClampStart#canCall(bucket#0: DatatypeType, start#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
  { BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0) } 
  BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0)
     == BucketsLib.__default.ClampStart($ly, bucket#0, start#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
  { BucketsLib.__default.ClampStart(AsFuelBottom($ly), bucket#0, start#0) } 
  BucketsLib.__default.ClampStart($ly, bucket#0, start#0)
     == BucketsLib.__default.ClampStart($LZ, bucket#0, start#0));

// consequence axiom for BucketsLib.__default.ClampStart
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
    { BucketsLib.__default.ClampStart($ly, bucket#0, start#0) } 
    BucketsLib.__default.ClampStart#canCall(bucket#0, start#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ClampStart($ly, bucket#0, start#0))
         && $Is(BucketsLib.__default.ClampStart($ly, bucket#0, start#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampStart#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.ClampStart
axiom (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
  { BucketsLib.__default.ClampStart#requires($ly, bucket#0, start#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(start#0, Tclass.UI.RangeStart())
     ==> BucketsLib.__default.ClampStart#requires($ly, bucket#0, start#0) == true);

// definition axiom for BucketsLib.__default.ClampStart(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
    { BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0) } 
    BucketsLib.__default.ClampStart#canCall(bucket#0, start#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.LowerBound(start#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> MapSpec.__default.LowerBound#canCall(start#0, key#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && MapSpec.__default.LowerBound(start#0, key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && MapSpec.__default.LowerBound(start#0, $Unbox($w#0): Seq Box)), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampStart($LS($ly), bucket#0, start#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && MapSpec.__default.LowerBound(start#0, $Unbox($w#1): Seq Box)), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampStart for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, start#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.ClampStart($LS($ly), Lit(bucket#0), Lit(start#0)) } 
    BucketsLib.__default.ClampStart#canCall(Lit(bucket#0), Lit(start#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(start#0, Tclass.UI.RangeStart()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.LowerBound(start#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> MapSpec.__default.LowerBound#canCall(Lit(start#0), key#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && MapSpec.__default.LowerBound(Lit(start#0), key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && MapSpec.__default.LowerBound(Lit(start#0), $Unbox($w#2): Seq Box)), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampStart($LS($ly), Lit(bucket#0), Lit(start#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && MapSpec.__default.LowerBound(Lit(start#0), $Unbox($w#3): Seq Box)), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.ClampEnd
function BucketsLib.__default.ClampEnd($ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.ClampEnd#canCall(bucket#0: DatatypeType, end#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
  { BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0) } 
  BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0)
     == BucketsLib.__default.ClampEnd($ly, bucket#0, end#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
  { BucketsLib.__default.ClampEnd(AsFuelBottom($ly), bucket#0, end#0) } 
  BucketsLib.__default.ClampEnd($ly, bucket#0, end#0)
     == BucketsLib.__default.ClampEnd($LZ, bucket#0, end#0));

// consequence axiom for BucketsLib.__default.ClampEnd
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
    { BucketsLib.__default.ClampEnd($ly, bucket#0, end#0) } 
    BucketsLib.__default.ClampEnd#canCall(bucket#0, end#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.ClampEnd($ly, bucket#0, end#0))
         && $Is(BucketsLib.__default.ClampEnd($ly, bucket#0, end#0), Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.ClampEnd#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.ClampEnd
axiom (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
  { BucketsLib.__default.ClampEnd#requires($ly, bucket#0, end#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd())
     ==> BucketsLib.__default.ClampEnd#requires($ly, bucket#0, end#0) == true);

// definition axiom for BucketsLib.__default.ClampEnd(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
    { BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0) } 
    BucketsLib.__default.ClampEnd#canCall(bucket#0, end#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.UpperBound(key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> MapSpec.__default.UpperBound#canCall(key#0, end#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && MapSpec.__default.UpperBound(key#0, end#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && MapSpec.__default.UpperBound($Unbox($w#0): Seq Box, end#0)), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampEnd($LS($ly), bucket#0, end#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && MapSpec.__default.UpperBound($Unbox($w#1): Seq Box, end#0)), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.ClampEnd for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, end#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.ClampEnd($LS($ly), Lit(bucket#0), Lit(end#0)) } 
    BucketsLib.__default.ClampEnd#canCall(Lit(bucket#0), Lit(end#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(end#0, Tclass.UI.RangeEnd()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { MapSpec.__default.UpperBound(key#0, end#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> MapSpec.__default.UpperBound#canCall(key#0, Lit(end#0)))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && MapSpec.__default.UpperBound(key#0, Lit(end#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && MapSpec.__default.UpperBound($Unbox($w#2): Seq Box, Lit(end#0))), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.ClampEnd($LS($ly), Lit(bucket#0), Lit(end#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && MapSpec.__default.UpperBound($Unbox($w#3): Seq Box, Lit(end#0))), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.KeyValueMapOfBucket
function BucketsLib.__default.KeyValueMapOfBucket($ly: LayerType, bucket#0: DatatypeType) : Map Box Box;

function BucketsLib.__default.KeyValueMapOfBucket#canCall(bucket#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType :: 
  { BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0) } 
  BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0)
     == BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType :: 
  { BucketsLib.__default.KeyValueMapOfBucket(AsFuelBottom($ly), bucket#0) } 
  BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0)
     == BucketsLib.__default.KeyValueMapOfBucket($LZ, bucket#0));

// consequence axiom for BucketsLib.__default.KeyValueMapOfBucket
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType :: 
    { BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0) } 
    BucketsLib.__default.KeyValueMapOfBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> $Is(BucketsLib.__default.KeyValueMapOfBucket($ly, bucket#0), 
        TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

function BucketsLib.__default.KeyValueMapOfBucket#requires(LayerType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.KeyValueMapOfBucket
axiom (forall $ly: LayerType, bucket#0: DatatypeType :: 
  { BucketsLib.__default.KeyValueMapOfBucket#requires($ly, bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.KeyValueMapOfBucket#requires($ly, bucket#0) == true);

// definition axiom for BucketsLib.__default.KeyValueMapOfBucket(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType :: 
    { BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0) } 
    BucketsLib.__default.KeyValueMapOfBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))
                   && ValueMessage.__default.DefaultValue#canCall())
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                        Lit(ValueMessage.__default.DefineDefault()))), 
                    ValueMessage.__default.DefaultValue())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))
         && BucketsLib.__default.KeyValueMapOfBucket($LS($ly), bucket#0)
           == Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]): DatatypeType, 
                      Lit(ValueMessage.__default.DefineDefault()))), 
                  ValueMessage.__default.DefaultValue())), 
            (lambda $w#0: Box :: 
              $Box(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

// definition axiom for BucketsLib.__default.KeyValueMapOfBucket for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.KeyValueMapOfBucket($LS($ly), Lit(bucket#0)) } 
    BucketsLib.__default.KeyValueMapOfBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))
                   && ValueMessage.__default.DefaultValue#canCall())
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#0)]): DatatypeType, 
                        Lit(ValueMessage.__default.DefineDefault()))), 
                    ValueMessage.__default.DefaultValue())
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
                   && ValueMessage.__default.DefineDefault#canCall()
                   && ValueMessage.__default.Merge#canCall($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(key#0)]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))
         && BucketsLib.__default.KeyValueMapOfBucket($LS($ly), Lit(bucket#0))
           == Map#Glue((lambda $w#1: Box :: 
              $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#1]
                 && !Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#1]): DatatypeType, 
                      Lit(ValueMessage.__default.DefineDefault()))), 
                  ValueMessage.__default.DefaultValue())), 
            (lambda $w#1: Box :: 
              $Box(ValueMessage.Message.value(ValueMessage.__default.Merge($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#1]): DatatypeType, 
                    Lit(ValueMessage.__default.DefineDefault()))))), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value())));

// function declaration for BucketsLib._default.SortedSeqOfKeyValueMap
function BucketsLib.__default.SortedSeqOfKeyValueMap($ly: LayerType, m#0: Map Box Box) : Seq Box;

function BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(m#0: Map Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0) } 
  BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0)
     == BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.SortedSeqOfKeyValueMap(AsFuelBottom($ly), m#0) } 
  BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0)
     == BucketsLib.__default.SortedSeqOfKeyValueMap($LZ, m#0));

// consequence axiom for BucketsLib.__default.SortedSeqOfKeyValueMap
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0) } 
    BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> $Is(BucketsLib.__default.SortedSeqOfKeyValueMap($ly, m#0), 
        TSeq(Tclass.UI.SuccResult())));

function BucketsLib.__default.SortedSeqOfKeyValueMap#requires(LayerType, Map Box Box) : bool;

// #requires axiom for BucketsLib.__default.SortedSeqOfKeyValueMap
axiom (forall $ly: LayerType, m#0: Map Box Box :: 
  { BucketsLib.__default.SortedSeqOfKeyValueMap#requires($ly, m#0) } 
  $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
     ==> BucketsLib.__default.SortedSeqOfKeyValueMap#requires($ly, m#0) == true);

// definition axiom for BucketsLib.__default.SortedSeqOfKeyValueMap(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    { BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0) } 
    BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(m#0)
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(Map#Domain(m#0))
         && (var max#0 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, Map#Domain(m#0)); 
          !Options.Option.None_q(max#0)
             ==> Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueType.Value(), 
                m#0, 
                Options.Option.value(max#0))
               && BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueType.Value(), 
                  StartFuel_Maps._default.MapRemove1, 
                  m#0, 
                  Options.Option.value(max#0))))
         && BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), m#0)
           == (var max#0 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, Map#Domain(m#0)); 
            (if Options.Option.None_q(max#0)
               then Seq#Empty(): Seq Box
               else Seq#Append(BucketsLib.__default.SortedSeqOfKeyValueMap($ly, 
                  Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                    Tclass.ValueType.Value(), 
                    StartFuel_Maps._default.MapRemove1, 
                    m#0, 
                    Options.Option.value(max#0))), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(#UI.SuccResult.SuccResult($Unbox(Options.Option.value(max#0)): Seq Box, 
                      $Unbox(Map#Elements(m#0)[Options.Option.value(max#0)]): Seq Box)))))));

// definition axiom for BucketsLib.__default.SortedSeqOfKeyValueMap for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, m#0: Map Box Box :: 
    {:weight 3} { BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), Lit(m#0)) } 
    BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(Lit(m#0))
         || $Is(m#0, TMap(Tclass.KeyType.Key(), Tclass.ValueType.Value()))
       ==> Lexicographic__Byte__Order.__default.maximumOpt#canCall(Lit(Map#Domain(Lit(m#0))))
         && (var max#1 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, 
              Lit(Map#Domain(Lit(m#0)))); 
          !Options.Option.None_q(max#1)
             ==> Maps.__default.MapRemove1#canCall(TSeq(Tclass.NativeTypes.byte()), 
                Tclass.ValueType.Value(), 
                Lit(m#0), 
                Options.Option.value(max#1))
               && BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                  Tclass.ValueType.Value(), 
                  StartFuel_Maps._default.MapRemove1, 
                  Lit(m#0), 
                  Options.Option.value(max#1))))
         && BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), Lit(m#0))
           == (var max#1 := Lexicographic__Byte__Order.__default.maximumOpt(StartFuel_Lexicographic_Byte_Order._default.maximumOpt, 
                Lit(Map#Domain(Lit(m#0)))); 
            (if Options.Option.None_q(max#1)
               then Seq#Empty(): Seq Box
               else Seq#Append(BucketsLib.__default.SortedSeqOfKeyValueMap($LS($ly), 
                  Maps.__default.MapRemove1(TSeq(Tclass.NativeTypes.byte()), 
                    Tclass.ValueType.Value(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(m#0), 
                    Options.Option.value(max#1))), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(#UI.SuccResult.SuccResult($Unbox(Options.Option.value(max#1)): Seq Box, 
                      $Unbox(Map#Elements(Lit(m#0))[Options.Option.value(max#1)]): Seq Box)))))));

// function declaration for BucketsLib._default.SplitBucketLeft
function BucketsLib.__default.SplitBucketLeft($ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box) : DatatypeType;

function BucketsLib.__default.SplitBucketLeft#canCall(bucket#0: DatatypeType, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketLeft(AsFuelBottom($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketLeft($LZ, bucket#0, pivot#0));

// consequence axiom for BucketsLib.__default.SplitBucketLeft
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketLeft#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0)))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0))
         && $Is(BucketsLib.__default.SplitBucketLeft($ly, bucket#0, pivot#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.SplitBucketLeft#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketLeft
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketLeft#requires($ly, bucket#0, pivot#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketLeft#requires($ly, bucket#0, pivot#0) == true);

// definition axiom for BucketsLib.__default.SplitBucketLeft(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketLeft#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lt(key#0, pivot#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, pivot#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lt(key#0, pivot#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && Lexicographic__Byte__Order.__default.lt($Unbox($w#0): Seq Box, pivot#0)), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketLeft($LS($ly), bucket#0, pivot#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && Lexicographic__Byte__Order.__default.lt($Unbox($w#1): Seq Box, pivot#0)), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.SplitBucketLeft for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketLeft($LS($ly), Lit(bucket#0), Lit(pivot#0)) } 
    BucketsLib.__default.SplitBucketLeft#canCall(Lit(bucket#0), Lit(pivot#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lt(key#0, pivot#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lt#canCall(key#0, Lit(pivot#0)))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lt(key#0, Lit(pivot#0))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && Lexicographic__Byte__Order.__default.lt($Unbox($w#2): Seq Box, Lit(pivot#0))), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketLeft($LS($ly), Lit(bucket#0), Lit(pivot#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && Lexicographic__Byte__Order.__default.lt($Unbox($w#3): Seq Box, Lit(pivot#0))), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.SplitBucketRight
function BucketsLib.__default.SplitBucketRight($ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box) : DatatypeType;

function BucketsLib.__default.SplitBucketRight#canCall(bucket#0: DatatypeType, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketRight(AsFuelBottom($ly), bucket#0, pivot#0) } 
  BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)
     == BucketsLib.__default.SplitBucketRight($LZ, bucket#0, pivot#0));

// consequence axiom for BucketsLib.__default.SplitBucketRight
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketRight#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0)))
         && BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0))
         && $Is(BucketsLib.__default.SplitBucketRight($ly, bucket#0, pivot#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.SplitBucketRight#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketRight
axiom (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketRight#requires($ly, bucket#0, pivot#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketRight#requires($ly, bucket#0, pivot#0) == true);

// definition axiom for BucketsLib.__default.SplitBucketRight(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0) } 
    BucketsLib.__default.SplitBucketRight#canCall(bucket#0, pivot#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lte(pivot#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, key#0))
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($w#0): Seq Box)), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketRight($LS($ly), bucket#0, pivot#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($w#1): Seq Box)), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketsLib.__default.SplitBucketRight for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, pivot#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketRight($LS($ly), Lit(bucket#0), Lit(pivot#0)) } 
    BucketsLib.__default.SplitBucketRight#canCall(Lit(bucket#0), Lit(pivot#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(pivot#0, Tclass.KeyType.Key()))
       ==> (forall key#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType } 
            { Lexicographic__Byte__Order.__default.lte(pivot#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)] } 
          $Is(key#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                 ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), key#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), key#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($w#2): Seq Box)), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketsLib.__default.SplitBucketRight($LS($ly), Lit(bucket#0), Lit(pivot#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($w#3): Seq Box)), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketsLib._default.SplitBucketListLeft
function BucketsLib.__default.SplitBucketListLeft(blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketListLeft#canCall(blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.SplitBucketListLeft
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0) } 
    BucketsLib.__default.SplitBucketListLeft#canCall(blist#0, pivots#0, cLeft#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, pivots#0, key#0)
             == cLeft#0)
       ==> $Is(BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketListLeft#requires(Seq Box, Seq Box, int, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketListLeft
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketListLeft#requires(blist#0, pivots#0, cLeft#0, key#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketListLeft#requires(blist#0, pivots#0, cLeft#0, key#0)
       == (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
         && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, pivots#0, key#0)
           == cLeft#0));

// definition axiom for BucketsLib.__default.SplitBucketListLeft(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0) } 
    BucketsLib.__default.SplitBucketListLeft#canCall(blist#0, pivots#0, cLeft#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, pivots#0, key#0)
             == cLeft#0)
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(blist#0, cLeft#0)): DatatypeType, key#0)
         && BucketsLib.__default.SplitBucketListLeft(blist#0, pivots#0, cLeft#0, key#0)
           == Seq#Append(Seq#Take(blist#0, cLeft#0), 
            Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                  $Unbox(Seq#Index(blist#0, cLeft#0)): DatatypeType, 
                  key#0)))));

// definition axiom for BucketsLib.__default.SplitBucketListLeft for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cLeft#0: int, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketListLeft(Lit(blist#0), Lit(pivots#0), LitInt(cLeft#0), Lit(key#0)) } 
    BucketsLib.__default.SplitBucketListLeft#canCall(Lit(blist#0), Lit(pivots#0), LitInt(cLeft#0), Lit(key#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)))
           && PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, Lit(pivots#0), Lit(key#0))
             == LitInt(cLeft#0))
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(cLeft#0))): DatatypeType, Lit(key#0))
         && BucketsLib.__default.SplitBucketListLeft(Lit(blist#0), Lit(pivots#0), LitInt(cLeft#0), Lit(key#0))
           == Seq#Append(Seq#Take(Lit(blist#0), LitInt(cLeft#0)), 
            Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                  $Unbox(Seq#Index(Lit(blist#0), LitInt(cLeft#0))): DatatypeType, 
                  Lit(key#0))))));

// function declaration for BucketsLib._default.SplitBucketListRight
function BucketsLib.__default.SplitBucketListRight(blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketListRight#canCall(blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.SplitBucketListRight
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0) } 
    BucketsLib.__default.SplitBucketListRight#canCall(blist#0, pivots#0, cRight#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, pivots#0, key#0)
             == cRight#0)
       ==> $Is(BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketListRight#requires(Seq Box, Seq Box, int, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketListRight
axiom (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketListRight#requires(blist#0, pivots#0, cRight#0, key#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketListRight#requires(blist#0, pivots#0, cRight#0, key#0)
       == (BucketsLib.__default.WFBucketList(blist#0, pivots#0)
         && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, pivots#0, key#0)
           == cRight#0));

// definition axiom for BucketsLib.__default.SplitBucketListRight(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0) } 
    BucketsLib.__default.SplitBucketListRight#canCall(blist#0, pivots#0, cRight#0, key#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.WFBucketList(blist#0, pivots#0)
           && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, pivots#0, key#0)
             == cRight#0)
       ==> BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(blist#0, cRight#0)): DatatypeType, key#0)
         && BucketsLib.__default.SplitBucketListRight(blist#0, pivots#0, cRight#0, key#0)
           == Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                  $Unbox(Seq#Index(blist#0, cRight#0)): DatatypeType, 
                  key#0))), 
            Seq#Drop(blist#0, cRight#0 + 1)));

// definition axiom for BucketsLib.__default.SplitBucketListRight for all literals(revealed)
axiom true
   ==> (forall blist#0: Seq Box, pivots#0: Seq Box, cRight#0: int, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketListRight(Lit(blist#0), Lit(pivots#0), LitInt(cRight#0), Lit(key#0)) } 
    BucketsLib.__default.SplitBucketListRight#canCall(Lit(blist#0), Lit(pivots#0), LitInt(cRight#0), Lit(key#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Lit(BucketsLib.__default.WFBucketList(Lit(blist#0), Lit(pivots#0)))
           && PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, Lit(pivots#0), Lit(key#0))
             == LitInt(cRight#0))
       ==> BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(cRight#0))): DatatypeType, Lit(key#0))
         && BucketsLib.__default.SplitBucketListRight(Lit(blist#0), Lit(pivots#0), LitInt(cRight#0), Lit(key#0))
           == Seq#Append(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                  $Unbox(Seq#Index(Lit(blist#0), LitInt(cRight#0))): DatatypeType, 
                  Lit(key#0)))), 
            Seq#Drop(Lit(blist#0), LitInt(cRight#0 + 1))));

// function declaration for BucketsLib._default.SplitBucketInList
function BucketsLib.__default.SplitBucketInList($ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box) : Seq Box;

function BucketsLib.__default.SplitBucketInList#canCall(blist#0: Seq Box, slot#0: int, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0) } 
  BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0)
     == BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketInList(AsFuelBottom($ly), blist#0, slot#0, pivot#0) } 
  BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0)
     == BucketsLib.__default.SplitBucketInList($LZ, blist#0, slot#0, pivot#0));

// consequence axiom for BucketsLib.__default.SplitBucketInList
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0) } 
    BucketsLib.__default.SplitBucketInList#canCall(blist#0, slot#0, pivot#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0))
       ==> $Is(BucketsLib.__default.SplitBucketInList($ly, blist#0, slot#0, pivot#0), 
        TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.SplitBucketInList#requires(LayerType, Seq Box, int, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.SplitBucketInList
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
  { BucketsLib.__default.SplitBucketInList#requires($ly, blist#0, slot#0, pivot#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.SplitBucketInList#requires($ly, blist#0, slot#0, pivot#0)
       == (LitInt(0) <= slot#0 && slot#0 < Seq#Length(blist#0)));

// definition axiom for BucketsLib.__default.SplitBucketInList(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
    { BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0) } 
    BucketsLib.__default.SplitBucketInList#canCall(blist#0, slot#0, pivot#0)
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0))
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, pivot#0)
         && BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, pivot#0)
         && Sequences.__default.replace1with2#canCall(Tclass.BucketsLib.Bucket(), 
          blist#0, 
          $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
              $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
              pivot#0)), 
          $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
              $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
              pivot#0)), 
          slot#0)
         && BucketsLib.__default.SplitBucketInList($LS($ly), blist#0, slot#0, pivot#0)
           == Sequences.__default.replace1with2(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace1with2, 
            blist#0, 
            $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
                pivot#0)), 
            $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
                pivot#0)), 
            slot#0));

// definition axiom for BucketsLib.__default.SplitBucketInList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int, pivot#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.SplitBucketInList($LS($ly), Lit(blist#0), LitInt(slot#0), Lit(pivot#0)) } 
    BucketsLib.__default.SplitBucketInList#canCall(Lit(blist#0), LitInt(slot#0), Lit(pivot#0))
         || (
          $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= LitInt(slot#0)
           && slot#0 < Seq#Length(Lit(blist#0)))
       ==> BucketsLib.__default.SplitBucketLeft#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, Lit(pivot#0))
         && BucketsLib.__default.SplitBucketRight#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, Lit(pivot#0))
         && Sequences.__default.replace1with2#canCall(Tclass.BucketsLib.Bucket(), 
          Lit(blist#0), 
          $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
              Lit(pivot#0))), 
          $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
              Lit(pivot#0))), 
          LitInt(slot#0))
         && BucketsLib.__default.SplitBucketInList($LS($ly), Lit(blist#0), LitInt(slot#0), Lit(pivot#0))
           == Sequences.__default.replace1with2(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace1with2, 
            Lit(blist#0), 
            $Box(BucketsLib.__default.SplitBucketLeft(StartFuel_BucketsLib._default.SplitBucketLeft, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
                Lit(pivot#0))), 
            $Box(BucketsLib.__default.SplitBucketRight(StartFuel_BucketsLib._default.SplitBucketRight, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
                Lit(pivot#0))), 
            LitInt(slot#0)));

// function declaration for BucketsLib._default.MergeBuckets
function BucketsLib.__default.MergeBuckets($ly: LayerType, left#0: DatatypeType, right#0: DatatypeType) : DatatypeType;

function BucketsLib.__default.MergeBuckets#canCall(left#0: DatatypeType, right#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
  { BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0) } 
  BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0)
     == BucketsLib.__default.MergeBuckets($ly, left#0, right#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
  { BucketsLib.__default.MergeBuckets(AsFuelBottom($ly), left#0, right#0) } 
  BucketsLib.__default.MergeBuckets($ly, left#0, right#0)
     == BucketsLib.__default.MergeBuckets($LZ, left#0, right#0));

// consequence axiom for BucketsLib.__default.MergeBuckets
axiom true
   ==> (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
    { BucketsLib.__default.MergeBuckets($ly, left#0, right#0) } 
    BucketsLib.__default.MergeBuckets#canCall(left#0, right#0)
         || ($Is(left#0, Tclass.BucketsLib.Bucket())
           && $Is(right#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketsLib.__default.MergeBuckets($ly, left#0, right#0))
         && BucketsLib.__default.PreWFBucket(BucketsLib.__default.MergeBuckets($ly, left#0, right#0))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(left#0))
             && BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(right#0))
           ==> BucketsLib.__default.WFBucket(BucketsLib.__default.MergeBuckets($ly, left#0, right#0)))
         && $Is(BucketsLib.__default.MergeBuckets($ly, left#0, right#0), 
          Tclass.BucketsLib.Bucket()));

function BucketsLib.__default.MergeBuckets#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.MergeBuckets
axiom (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
  { BucketsLib.__default.MergeBuckets#requires($ly, left#0, right#0) } 
  $Is(left#0, Tclass.BucketsLib.Bucket())
       && $Is(right#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.MergeBuckets#requires($ly, left#0, right#0) == true);

// definition axiom for BucketsLib.__default.MergeBuckets(revealed)
axiom true
   ==> (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
    { BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0) } 
    BucketsLib.__default.MergeBuckets#canCall(left#0, right#0)
         || ($Is(left#0, Tclass.BucketsLib.Bucket())
           && $Is(right#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(left#0)
         && BucketsLib.Bucket.BucketMapWithSeq_q(right#0)
         && Maps.__default.MapUnionPreferA#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          BucketsLib.Bucket.b(left#0), 
          BucketsLib.Bucket.b(right#0))
         && BucketsLib.__default.B#canCall(Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
            Tclass.ValueMessage.Message(), 
            StartFuel_Maps._default.MapUnionPreferA, 
            BucketsLib.Bucket.b(left#0), 
            BucketsLib.Bucket.b(right#0)))
         && BucketsLib.__default.MergeBuckets($LS($ly), left#0, right#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              StartFuel_Maps._default.MapUnionPreferA, 
              BucketsLib.Bucket.b(left#0), 
              BucketsLib.Bucket.b(right#0))));

// definition axiom for BucketsLib.__default.MergeBuckets for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, left#0: DatatypeType, right#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.MergeBuckets($LS($ly), Lit(left#0), Lit(right#0)) } 
    BucketsLib.__default.MergeBuckets#canCall(Lit(left#0), Lit(right#0))
         || ($Is(left#0, Tclass.BucketsLib.Bucket())
           && $Is(right#0, Tclass.BucketsLib.Bucket()))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(left#0))
         && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(right#0))
         && Maps.__default.MapUnionPreferA#canCall(Tclass.KeyType.Key(), 
          Tclass.ValueMessage.Message(), 
          Lit(BucketsLib.Bucket.b(Lit(left#0))), 
          Lit(BucketsLib.Bucket.b(Lit(right#0))))
         && BucketsLib.__default.B#canCall(Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
            Tclass.ValueMessage.Message(), 
            StartFuel_Maps._default.MapUnionPreferA, 
            Lit(BucketsLib.Bucket.b(Lit(left#0))), 
            Lit(BucketsLib.Bucket.b(Lit(right#0)))))
         && BucketsLib.__default.MergeBuckets($LS($ly), Lit(left#0), Lit(right#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Maps.__default.MapUnionPreferA(Tclass.KeyType.Key(), 
              Tclass.ValueMessage.Message(), 
              StartFuel_Maps._default.MapUnionPreferA, 
              Lit(BucketsLib.Bucket.b(Lit(left#0))), 
              Lit(BucketsLib.Bucket.b(Lit(right#0))))));

// function declaration for BucketsLib._default.MergeBucketsInList
function BucketsLib.__default.MergeBucketsInList($ly: LayerType, blist#0: Seq Box, slot#0: int) : Seq Box;

function BucketsLib.__default.MergeBucketsInList#canCall(blist#0: Seq Box, slot#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
  { BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0) } 
  BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0)
     == BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
  { BucketsLib.__default.MergeBucketsInList(AsFuelBottom($ly), blist#0, slot#0) } 
  BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0)
     == BucketsLib.__default.MergeBucketsInList($LZ, blist#0, slot#0));

// consequence axiom for BucketsLib.__default.MergeBucketsInList
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
    { BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0) } 
    BucketsLib.__default.MergeBucketsInList#canCall(blist#0, slot#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0) - 1)
       ==> Seq#Length(BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0))
           == Seq#Length(blist#0) - 1
         && BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0), slot#0)): DatatypeType)
         && $Is(BucketsLib.__default.MergeBucketsInList($ly, blist#0, slot#0), 
          TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.MergeBucketsInList#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BucketsLib.__default.MergeBucketsInList
axiom (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
  { BucketsLib.__default.MergeBucketsInList#requires($ly, blist#0, slot#0) } 
  $Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketsLib.__default.MergeBucketsInList#requires($ly, blist#0, slot#0)
       == (LitInt(0) <= slot#0 && slot#0 < Seq#Length(blist#0) - 1));

// definition axiom for BucketsLib.__default.MergeBucketsInList(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
    { BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0) } 
    BucketsLib.__default.MergeBucketsInList#canCall(blist#0, slot#0)
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          LitInt(0) <= slot#0
           && slot#0 < Seq#Length(blist#0) - 1)
       ==> BucketsLib.__default.MergeBuckets#canCall($Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
          $Unbox(Seq#Index(blist#0, slot#0 + 1)): DatatypeType)
         && Sequences.__default.replace2with1#canCall(Tclass.BucketsLib.Bucket(), 
          blist#0, 
          $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
              $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
              $Unbox(Seq#Index(blist#0, slot#0 + 1)): DatatypeType)), 
          slot#0)
         && BucketsLib.__default.MergeBucketsInList($LS($ly), blist#0, slot#0)
           == Sequences.__default.replace2with1(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace2with1, 
            blist#0, 
            $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
                $Unbox(Seq#Index(blist#0, slot#0)): DatatypeType, 
                $Unbox(Seq#Index(blist#0, slot#0 + 1)): DatatypeType)), 
            slot#0));

// definition axiom for BucketsLib.__default.MergeBucketsInList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, blist#0: Seq Box, slot#0: int :: 
    {:weight 3} { BucketsLib.__default.MergeBucketsInList($LS($ly), Lit(blist#0), LitInt(slot#0)) } 
    BucketsLib.__default.MergeBucketsInList#canCall(Lit(blist#0), LitInt(slot#0))
         || ($Is(blist#0, TSeq(Tclass.BucketsLib.Bucket()))
           && 
          LitInt(0) <= LitInt(slot#0)
           && slot#0 < Seq#Length(Lit(blist#0)) - 1)
       ==> BucketsLib.__default.MergeBuckets#canCall($Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
          $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0 + 1))): DatatypeType)
         && Sequences.__default.replace2with1#canCall(Tclass.BucketsLib.Bucket(), 
          Lit(blist#0), 
          $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
              $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0 + 1))): DatatypeType)), 
          LitInt(slot#0))
         && BucketsLib.__default.MergeBucketsInList($LS($ly), Lit(blist#0), LitInt(slot#0))
           == Sequences.__default.replace2with1(Tclass.BucketsLib.Bucket(), 
            StartFuel_Sequences._default.replace2with1, 
            Lit(blist#0), 
            $Box(BucketsLib.__default.MergeBuckets(StartFuel_BucketsLib._default.MergeBuckets, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0))): DatatypeType, 
                $Unbox(Seq#Index(Lit(blist#0), LitInt(slot#0 + 1))): DatatypeType)), 
            LitInt(slot#0)));

// function declaration for BucketsLib._default.emptyList
function BucketsLib.__default.emptyList($ly: LayerType, n#0: int) : Seq Box;

function BucketsLib.__default.emptyList#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { BucketsLib.__default.emptyList($LS($ly), n#0) } 
  BucketsLib.__default.emptyList($LS($ly), n#0)
     == BucketsLib.__default.emptyList($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { BucketsLib.__default.emptyList(AsFuelBottom($ly), n#0) } 
  BucketsLib.__default.emptyList($ly, n#0)
     == BucketsLib.__default.emptyList($LZ, n#0));

// consequence axiom for BucketsLib.__default.emptyList
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { BucketsLib.__default.emptyList($ly, n#0) } 
    BucketsLib.__default.emptyList#canCall(n#0) || n#0 >= LitInt(0)
       ==> Seq#Length(BucketsLib.__default.emptyList($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(BucketsLib.__default.emptyList($ly, n#0), i#0)): DatatypeType } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(BucketsLib.__default.emptyList($ly, n#0))
             ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(BucketsLib.__default.emptyList($ly, n#0), i#0)): DatatypeType, 
              BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))))
         && $Is(BucketsLib.__default.emptyList($ly, n#0), TSeq(Tclass.BucketsLib.Bucket())));

function BucketsLib.__default.emptyList#requires(LayerType, int) : bool;

// #requires axiom for BucketsLib.__default.emptyList
axiom (forall $ly: LayerType, n#0: int :: 
  { BucketsLib.__default.emptyList#requires($ly, n#0) } 
  BucketsLib.__default.emptyList#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for BucketsLib.__default.emptyList(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { BucketsLib.__default.emptyList($LS($ly), n#0) } 
    BucketsLib.__default.emptyList#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0)
           ==> BucketsLib.__default.emptyList#canCall(n#0 - 1)
             && BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && BucketsLib.__default.emptyList($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.emptyList($ly, n#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)))))));

// definition axiom for BucketsLib.__default.emptyList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { BucketsLib.__default.emptyList($LS($ly), LitInt(n#0)) } 
    BucketsLib.__default.emptyList#canCall(LitInt(n#0)) || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> BucketsLib.__default.emptyList#canCall(LitInt(n#0 - 1))
             && BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box)))
         && BucketsLib.__default.emptyList($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BucketsLib.__default.emptyList($LS($ly), LitInt(n#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box)))))));

// function declaration for BucketsLib._default.binarySearch
function BucketsLib.__default.binarySearch($ly: LayerType, keys#0: Seq Box, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.binarySearch#canCall(keys#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0) } 
  BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0)
     == BucketsLib.__default.binarySearch($ly, keys#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.binarySearch(AsFuelBottom($ly), keys#0, key#0) } 
  BucketsLib.__default.binarySearch($ly, keys#0, key#0)
     == BucketsLib.__default.binarySearch($LZ, keys#0, key#0));

// consequence axiom for BucketsLib.__default.binarySearch
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.binarySearch($ly, keys#0, key#0) } 
    BucketsLib.__default.binarySearch#canCall(keys#0, key#0)
         || ($Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0)
           ==> 
          Options.Option.None_q(BucketsLib.__default.binarySearch($ly, keys#0, key#0))
           ==> !Seq#Contains(keys#0, $Box(key#0)))
         && (Options.Option.Some_q(BucketsLib.__default.binarySearch($ly, keys#0, key#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(BucketsLib.__default.binarySearch($ly, keys#0, key#0))): int
             && $Unbox(Options.Option.value(BucketsLib.__default.binarySearch($ly, keys#0, key#0))): int
               < Seq#Length(keys#0)
             && Seq#Equal(key#0, 
              $Unbox(Seq#Index(keys#0, 
                  $Unbox(Options.Option.value(BucketsLib.__default.binarySearch($ly, keys#0, key#0))): int)): Seq Box))
         && $Is(BucketsLib.__default.binarySearch($ly, keys#0, key#0), 
          Tclass.Options.Option(Tclass._System.nat())));

function BucketsLib.__default.binarySearch#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.binarySearch
axiom (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
  { BucketsLib.__default.binarySearch#requires($ly, keys#0, key#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.binarySearch#requires($ly, keys#0, key#0) == true);

// definition axiom for BucketsLib.__default.binarySearch(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
    { BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0) } 
    BucketsLib.__default.binarySearch#canCall(keys#0, key#0)
         || ($Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(keys#0) != LitInt(0)
           ==> (var mid#0 := Div(Seq#Length(keys#0), LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall(key#0, $Unbox(Seq#Index(keys#0, mid#0)): Seq Box)
               && (Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(keys#0, mid#0)): Seq Box)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Take(keys#0, mid#0), key#0))
               && (!Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(keys#0, mid#0)): Seq Box)
                 ==> 
                !Seq#Equal($Unbox(Seq#Index(keys#0, mid#0)): Seq Box, key#0)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Drop(keys#0, mid#0 + 1), key#0))))
         && BucketsLib.__default.binarySearch($LS($ly), keys#0, key#0)
           == (if Seq#Length(keys#0) == LitInt(0)
             then #Options.Option.None()
             else (var mid#0 := Div(Seq#Length(keys#0), LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt(key#0, $Unbox(Seq#Index(keys#0, mid#0)): Seq Box)
                 then BucketsLib.__default.binarySearch($ly, Seq#Take(keys#0, mid#0), key#0)
                 else (if Seq#Equal($Unbox(Seq#Index(keys#0, mid#0)): Seq Box, key#0)
                   then #Options.Option.Some($Box(mid#0))
                   else (var sub#0 := BucketsLib.__default.binarySearch($ly, Seq#Drop(keys#0, mid#0 + 1), key#0); 
                    (if Options.Option.Some_q(sub#0)
                       then #Options.Option.Some($Box(mid#0 + 1 + $Unbox(Options.Option.value(sub#0)): int))
                       else #Options.Option.None())))))));

// definition axiom for BucketsLib.__default.binarySearch for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.binarySearch($LS($ly), Lit(keys#0), Lit(key#0)) } 
    BucketsLib.__default.binarySearch#canCall(Lit(keys#0), Lit(key#0))
         || ($Is(keys#0, TSeq(Tclass.KeyType.Key())) && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(keys#0)) != LitInt(0)
           ==> (var mid#1 := Div(Seq#Length(Lit(keys#0)), LitInt(2)); 
            Lexicographic__Byte__Order.__default.lt#canCall(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#1)): Seq Box)
               && (Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#1)): Seq Box)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Take(Lit(keys#0), mid#1), Lit(key#0)))
               && (!Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#1)): Seq Box)
                 ==> 
                !Seq#Equal($Unbox(Seq#Index(Lit(keys#0), mid#1)): Seq Box, key#0)
                 ==> BucketsLib.__default.binarySearch#canCall(Seq#Drop(Lit(keys#0), mid#1 + 1), Lit(key#0)))))
         && BucketsLib.__default.binarySearch($LS($ly), Lit(keys#0), Lit(key#0))
           == (if Seq#Length(Lit(keys#0)) == LitInt(0)
             then #Options.Option.None()
             else (var mid#1 := Div(Seq#Length(Lit(keys#0)), LitInt(2)); 
              (if Lexicographic__Byte__Order.__default.lt(Lit(key#0), $Unbox(Seq#Index(Lit(keys#0), mid#1)): Seq Box)
                 then BucketsLib.__default.binarySearch($LS($ly), Seq#Take(Lit(keys#0), mid#1), Lit(key#0))
                 else (if Seq#Equal($Unbox(Seq#Index(Lit(keys#0), mid#1)): Seq Box, key#0)
                   then #Options.Option.Some($Box(mid#1))
                   else (var sub#1 := BucketsLib.__default.binarySearch($LS($ly), Seq#Drop(Lit(keys#0), mid#1 + 1), Lit(key#0)); 
                    (if Options.Option.Some_q(sub#1)
                       then #Options.Option.Some($Box(mid#1 + 1 + $Unbox(Options.Option.value(sub#1)): int))
                       else #Options.Option.None())))))));

// function declaration for BucketsLib._default.bucketBinarySearchLookup
function BucketsLib.__default.bucketBinarySearchLookup(bucket#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function BucketsLib.__default.bucketBinarySearchLookup#canCall(bucket#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketsLib.__default.bucketBinarySearchLookup
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0) } 
    BucketsLib.__default.bucketBinarySearchLookup#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> (BucketsLib.__default.BucketWellMarshalled(bucket#0)
           ==> 
          Options.Option.None_q(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0))
           ==> !Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)])
         && (BucketsLib.__default.BucketWellMarshalled(bucket#0)
           ==> 
          Options.Option.Some_q(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0))
           ==> Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
             && ValueMessage.Message#Equal($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType, 
              $Unbox(Options.Option.value(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0))): DatatypeType))
         && $Is(BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0), 
          Tclass.Options.Option(Tclass.ValueMessage.Message())));

function BucketsLib.__default.bucketBinarySearchLookup#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for BucketsLib.__default.bucketBinarySearchLookup
axiom (forall bucket#0: DatatypeType, key#0: Seq Box :: 
  { BucketsLib.__default.bucketBinarySearchLookup#requires(bucket#0, key#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketsLib.__default.bucketBinarySearchLookup#requires(bucket#0, key#0)
       == BucketsLib.__default.WFBucket(bucket#0));

// definition axiom for BucketsLib.__default.bucketBinarySearchLookup(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0) } 
    BucketsLib.__default.bucketBinarySearchLookup#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketsLib.__default.binarySearch#canCall(BucketsLib.Bucket.keys(bucket#0), key#0)
         && (var i#0 := BucketsLib.__default.binarySearch($LS($LZ), BucketsLib.Bucket.keys(bucket#0), key#0); 
          Options.Option.Some_q(i#0)
             ==> BucketsLib.__default.BucketWellMarshalled#canCall(bucket#0)
               && (BucketsLib.__default.BucketWellMarshalled(bucket#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
               && (!BucketsLib.__default.BucketWellMarshalled(bucket#0)
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.bucketBinarySearchLookup(bucket#0, key#0)
           == (var i#0 := BucketsLib.__default.binarySearch($LS($LZ), BucketsLib.Bucket.keys(bucket#0), key#0); 
            (if Options.Option.Some_q(i#0)
               then (if BucketsLib.__default.BucketWellMarshalled(bucket#0)
                 then #Options.Option.Some(Seq#Index(BucketsLib.Bucket.msgs(bucket#0), $Unbox(Options.Option.value(i#0)): int))
                 else #Options.Option.Some(Seq#Index(BucketsLib.Bucket.msgs(bucket#0), $Unbox(Options.Option.value(i#0)): int)))
               else #Options.Option.None())));

// definition axiom for BucketsLib.__default.bucketBinarySearchLookup for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketsLib.__default.bucketBinarySearchLookup(Lit(bucket#0), Lit(key#0)) } 
    BucketsLib.__default.bucketBinarySearchLookup#canCall(Lit(bucket#0), Lit(key#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(BucketsLib.__default.WFBucket(Lit(bucket#0))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketsLib.__default.binarySearch#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), Lit(key#0))
         && (var i#1 := Lit(BucketsLib.__default.binarySearch($LS($LZ), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), Lit(key#0))); 
          Options.Option.Some_q(i#1)
             ==> BucketsLib.__default.BucketWellMarshalled#canCall(Lit(bucket#0))
               && (Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
               && (!Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0)))
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.bucketBinarySearchLookup(Lit(bucket#0), Lit(key#0))
           == (var i#1 := Lit(BucketsLib.__default.binarySearch($LS($LZ), Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), Lit(key#0))); 
            (if Options.Option.Some_q(i#1)
               then (if BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0))
                 then #Options.Option.Some(Seq#Index(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))), 
                    LitInt($Unbox(Options.Option.value(i#1)): int)))
                 else #Options.Option.Some(Seq#Index(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))), 
                    LitInt($Unbox(Options.Option.value(i#1)): int))))
               else #Options.Option.None())));

// function declaration for BucketsLib._default.getMiddleKey
function BucketsLib.__default.getMiddleKey(bucket#0: DatatypeType) : Seq Box;

function BucketsLib.__default.getMiddleKey#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketsLib.__default.getMiddleKey
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.getMiddleKey(bucket#0) } 
    BucketsLib.__default.getMiddleKey#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> $Is(BucketsLib.__default.getMiddleKey(bucket#0), Tclass.KeyType.Key()));

function BucketsLib.__default.getMiddleKey#requires(DatatypeType) : bool;

// #requires axiom for BucketsLib.__default.getMiddleKey
axiom (forall bucket#0: DatatypeType :: 
  { BucketsLib.__default.getMiddleKey#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketsLib.__default.getMiddleKey#requires(bucket#0)
       == BucketsLib.__default.WFBucket(bucket#0));

// definition axiom for BucketsLib.__default.getMiddleKey(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketsLib.__default.getMiddleKey(bucket#0) } 
    BucketsLib.__default.getMiddleKey#canCall(bucket#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && BucketsLib.__default.WFBucket(bucket#0))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Seq#Length(BucketsLib.Bucket.keys(bucket#0)) != LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0))
         && BucketsLib.__default.getMiddleKey(bucket#0)
           == (if Seq#Length(BucketsLib.Bucket.keys(bucket#0)) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
             else (var key#0 := $Unbox(Seq#Index(BucketsLib.Bucket.keys(bucket#0), 
                    Div(Seq#Length(BucketsLib.Bucket.keys(bucket#0)), LitInt(2)))): Seq Box; 
              (if Seq#Length(key#0) == LitInt(0)
                 then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
                 else key#0))));

// definition axiom for BucketsLib.__default.getMiddleKey for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketsLib.__default.getMiddleKey(Lit(bucket#0)) } 
    BucketsLib.__default.getMiddleKey#canCall(Lit(bucket#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && Lit(BucketsLib.__default.WFBucket(Lit(bucket#0))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))) != LitInt(0)
           ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0)))
         && BucketsLib.__default.getMiddleKey(Lit(bucket#0))
           == (if Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))) == LitInt(0)
             then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
             else (var key#1 := $Unbox(Seq#Index(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))), 
                    Div(Seq#Length(Lit(BucketsLib.Bucket.keys(Lit(bucket#0)))), LitInt(2)))): Seq Box; 
              (if Seq#Length(key#1) == LitInt(0)
                 then Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(0)))
                 else key#1))));

// Constructor function declaration
function #PivotBetreeGraph.Node.Node(Seq Box, DatatypeType, Seq Box) : DatatypeType;

const unique ##PivotBetreeGraph.Node.Node: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: DatatypeType, a#0#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#PivotBetreeGraph.Node.Node(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##PivotBetreeGraph.Node.Node);

function PivotBetreeGraph.Node.Node_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Node.Node_q(d) } 
  PivotBetreeGraph.Node.Node_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeGraph.Node.Node);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Node.Node_q(d) } 
  PivotBetreeGraph.Node.Node_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: DatatypeType, a#1#2#0: Seq Box :: 
      d == #PivotBetreeGraph.Node.Node(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.PivotBetreeGraph.Node() : Ty;

// Tclass.PivotBetreeGraph.Node Tag
axiom Tag(Tclass.PivotBetreeGraph.Node()) == Tagclass.PivotBetreeGraph.Node;

const unique Tagclass.PivotBetreeGraph.Node: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeGraph.Node
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeGraph.Node()) } 
  $IsBox(bx, Tclass.PivotBetreeGraph.Node())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeGraph.Node()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: DatatypeType, a#2#2#0: Seq Box :: 
  { $Is(#PivotBetreeGraph.Node.Node(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.PivotBetreeGraph.Node()) } 
  $Is(#PivotBetreeGraph.Node.Node(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.PivotBetreeGraph.Node())
     <==> $Is(a#2#0#0, TSeq(Tclass.KeyType.Key()))
       && $Is(a#2#1#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())))
       && $Is(a#2#2#0, TSeq(Tclass.BucketsLib.Bucket())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: DatatypeType, a#3#2#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#PivotBetreeGraph.Node.Node(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.PivotBetreeGraph.Node(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeGraph.Node.Node(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.PivotBetreeGraph.Node(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TSeq(Tclass.KeyType.Key()), $h)
         && $IsAlloc(a#3#1#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), $h)
         && $IsAlloc(a#3#2#0, TSeq(Tclass.BucketsLib.Bucket()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Node.pivotTable(d), TSeq(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Node.Node_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Node(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Node.pivotTable(d), TSeq(Tclass.KeyType.Key()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Node.children(d), 
      Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Node.Node_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Node(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Node.children(d), 
      Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Node.buckets(d), TSeq(Tclass.BucketsLib.Bucket()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Node.Node_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Node(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Node.buckets(d), TSeq(Tclass.BucketsLib.Bucket()), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: DatatypeType, a#4#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0)) } 
  #PivotBetreeGraph.Node.Node(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0))
     == Lit(#PivotBetreeGraph.Node.Node(a#4#0#0, a#4#1#0, a#4#2#0)));

function PivotBetreeGraph.Node.pivotTable(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: DatatypeType, a#5#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#5#0#0, a#5#1#0, a#5#2#0) } 
  PivotBetreeGraph.Node.pivotTable(#PivotBetreeGraph.Node.Node(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive seq element rank
axiom (forall a#6#0#0: Seq Box, a#6#1#0: DatatypeType, a#6#2#0: Seq Box, i: int :: 
  { Seq#Index(a#6#0#0, i), #PivotBetreeGraph.Node.Node(a#6#0#0, a#6#1#0, a#6#2#0) } 
  0 <= i && i < Seq#Length(a#6#0#0)
     ==> DtRank($Unbox(Seq#Index(a#6#0#0, i)): DatatypeType)
       < DtRank(#PivotBetreeGraph.Node.Node(a#6#0#0, a#6#1#0, a#6#2#0)));

// Inductive seq rank
axiom (forall a#7#0#0: Seq Box, a#7#1#0: DatatypeType, a#7#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#7#0#0, a#7#1#0, a#7#2#0) } 
  Seq#Rank(a#7#0#0)
     < DtRank(#PivotBetreeGraph.Node.Node(a#7#0#0, a#7#1#0, a#7#2#0)));

function PivotBetreeGraph.Node.children(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#8#0#0: Seq Box, a#8#1#0: DatatypeType, a#8#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#8#0#0, a#8#1#0, a#8#2#0) } 
  PivotBetreeGraph.Node.children(#PivotBetreeGraph.Node.Node(a#8#0#0, a#8#1#0, a#8#2#0))
     == a#8#1#0);

// Inductive rank
axiom (forall a#9#0#0: Seq Box, a#9#1#0: DatatypeType, a#9#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#9#0#0, a#9#1#0, a#9#2#0) } 
  DtRank(a#9#1#0) < DtRank(#PivotBetreeGraph.Node.Node(a#9#0#0, a#9#1#0, a#9#2#0)));

function PivotBetreeGraph.Node.buckets(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#10#0#0: Seq Box, a#10#1#0: DatatypeType, a#10#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#10#0#0, a#10#1#0, a#10#2#0) } 
  PivotBetreeGraph.Node.buckets(#PivotBetreeGraph.Node.Node(a#10#0#0, a#10#1#0, a#10#2#0))
     == a#10#2#0);

// Inductive seq element rank
axiom (forall a#11#0#0: Seq Box, a#11#1#0: DatatypeType, a#11#2#0: Seq Box, i: int :: 
  { Seq#Index(a#11#2#0, i), #PivotBetreeGraph.Node.Node(a#11#0#0, a#11#1#0, a#11#2#0) } 
  0 <= i && i < Seq#Length(a#11#2#0)
     ==> DtRank($Unbox(Seq#Index(a#11#2#0, i)): DatatypeType)
       < DtRank(#PivotBetreeGraph.Node.Node(a#11#0#0, a#11#1#0, a#11#2#0)));

// Inductive seq rank
axiom (forall a#12#0#0: Seq Box, a#12#1#0: DatatypeType, a#12#2#0: Seq Box :: 
  { #PivotBetreeGraph.Node.Node(a#12#0#0, a#12#1#0, a#12#2#0) } 
  Seq#Rank(a#12#2#0)
     < DtRank(#PivotBetreeGraph.Node.Node(a#12#0#0, a#12#1#0, a#12#2#0)));

// Depth-one case-split function
function $IsA#PivotBetreeGraph.Node(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeGraph.Node(d) } 
  $IsA#PivotBetreeGraph.Node(d) ==> PivotBetreeGraph.Node.Node_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Node.Node_q(d), $Is(d, Tclass.PivotBetreeGraph.Node()) } 
  $Is(d, Tclass.PivotBetreeGraph.Node()) ==> PivotBetreeGraph.Node.Node_q(d));

// Datatype extensional equality declaration
function PivotBetreeGraph.Node#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeGraph.Node.Node
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.Node#Equal(a, b) } 
  true
     ==> (PivotBetreeGraph.Node#Equal(a, b)
       <==> Seq#Equal(PivotBetreeGraph.Node.pivotTable(a), PivotBetreeGraph.Node.pivotTable(b))
         && Options.Option#Equal(PivotBetreeGraph.Node.children(a), PivotBetreeGraph.Node.children(b))
         && Seq#Equal(PivotBetreeGraph.Node.buckets(a), PivotBetreeGraph.Node.buckets(b))));

// Datatype extensionality axiom: PivotBetreeGraph.Node
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.Node#Equal(a, b) } 
  PivotBetreeGraph.Node#Equal(a, b) <==> a == b);

const unique class.PivotBetreeGraph.Node: ClassName;

const unique class.PivotBetreeGraph.__default: ClassName;

function Tclass.PivotBetreeGraph.__default() : Ty;

// Tclass.PivotBetreeGraph.__default Tag
axiom Tag(Tclass.PivotBetreeGraph.__default()) == Tagclass.PivotBetreeGraph.__default;

const unique Tagclass.PivotBetreeGraph.__default: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeGraph.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeGraph.__default()) } 
  $IsBox(bx, Tclass.PivotBetreeGraph.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PivotBetreeGraph.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PivotBetreeGraph.__default()) } 
  $Is($o, Tclass.PivotBetreeGraph.__default())
     <==> $o == null || dtype($o) == Tclass.PivotBetreeGraph.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PivotBetreeGraph.__default(), $h) } 
  $IsAlloc($o, Tclass.PivotBetreeGraph.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PivotBetreeGraph._default.Successors
function PivotBetreeGraph.__default.Successors(node#0: DatatypeType) : ISet Box;

function PivotBetreeGraph.__default.Successors#canCall(node#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeGraph.__default.Successors
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeGraph.__default.Successors(node#0) } 
    PivotBetreeGraph.__default.Successors#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> $Is(PivotBetreeGraph.__default.Successors(node#0), 
        TISet(Tclass.NativeTypes.uint64())));

function PivotBetreeGraph.__default.Successors#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeGraph.__default.Successors
axiom (forall node#0: DatatypeType :: 
  { PivotBetreeGraph.__default.Successors#requires(node#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
     ==> PivotBetreeGraph.__default.Successors#requires(node#0) == true);

// definition axiom for PivotBetreeGraph.__default.Successors(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeGraph.__default.Successors(node#0) } 
    PivotBetreeGraph.__default.Successors#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                  i#0)): int } 
            (LitInt(0) <= i#0 ==> PivotBetreeGraph.Node.Node_q(node#0))
               && (LitInt(0) <= i#0
                   && i#0
                     < Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box)
                 ==> PivotBetreeGraph.Node.Node_q(node#0))))
         && PivotBetreeGraph.__default.Successors(node#0)
           == (if Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
             then (lambda $y#0: Box :: 
              (exists i#0: int :: 
                { $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                      i#0)): int } 
                LitInt(0) <= i#0
                   && i#0
                     < Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box)
                   && $y#0
                     == Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                      i#0)))
             else ISet#Empty(): ISet Box));

// definition axiom for PivotBetreeGraph.__default.Successors for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    {:weight 3} { PivotBetreeGraph.__default.Successors(Lit(node#0)) } 
    PivotBetreeGraph.__default.Successors#canCall(Lit(node#0))
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0)))))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                  i#1)): int } 
            (LitInt(0) <= i#1 ==> PivotBetreeGraph.Node.Node_q(Lit(node#0)))
               && (LitInt(0) <= i#1
                   && i#1
                     < Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box))
                 ==> PivotBetreeGraph.Node.Node_q(Lit(node#0)))))
         && PivotBetreeGraph.__default.Successors(Lit(node#0))
           == (if Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))
             then (lambda $y#1: Box :: 
              (exists i#1: int :: 
                { $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                      i#1)): int } 
                LitInt(0) <= i#1
                   && i#1
                     < Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box))
                   && $y#1
                     == Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box), 
                      i#1)))
             else ISet#Empty(): ISet Box));

// function declaration for PivotBetreeGraph._default.Root
function PivotBetreeGraph.__default.Root() : int;

function PivotBetreeGraph.__default.Root#canCall() : bool;

// consequence axiom for PivotBetreeGraph.__default.Root
axiom true
   ==> 
  true
   ==> LitInt(0) <= PivotBetreeGraph.__default.Root()
     && PivotBetreeGraph.__default.Root() < 18446744073709551616;

function PivotBetreeGraph.__default.Root#requires() : bool;

// #requires axiom for PivotBetreeGraph.__default.Root
axiom PivotBetreeGraph.__default.Root#requires() == true;

// definition axiom for PivotBetreeGraph.__default.Root(revealed)
axiom true
   ==> 
  true
   ==> ReferenceType.__default.Root#canCall()
     && PivotBetreeGraph.__default.Root() == LitInt(ReferenceType.__default.Root());

// definition axiom for PivotBetreeGraph.__default.Root for all literals(revealed)
axiom true
   ==> 
  true
   ==> ReferenceType.__default.Root#canCall()
     && PivotBetreeGraph.__default.Root() == LitInt(ReferenceType.__default.Root());

// function declaration for PivotBetreeGraph._default.IsClosed
function PivotBetreeGraph.__default.IsClosed(g#0: IMap Box Box) : bool;

function PivotBetreeGraph.__default.IsClosed#canCall(g#0: IMap Box Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.IsClosed
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.IsClosed(g#0) } 
    PivotBetreeGraph.__default.IsClosed#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       ==> true);

function PivotBetreeGraph.__default.IsClosed#requires(IMap Box Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.IsClosed
axiom (forall g#0: IMap Box Box :: 
  { PivotBetreeGraph.__default.IsClosed#requires(g#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
     ==> PivotBetreeGraph.__default.IsClosed#requires(g#0) == true);

// definition axiom for PivotBetreeGraph.__default.IsClosed(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.IsClosed(g#0) } 
    PivotBetreeGraph.__default.IsClosed#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       ==> (forall ref#0: int :: 
          { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
            { IMap#Domain(g#0)[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            IMap#Domain(g#0)[$Box(ref#0)]
             ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType))
         && PivotBetreeGraph.__default.IsClosed(g#0)
           == (forall ref#0: int :: 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
              { IMap#Domain(g#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> 
              IMap#Domain(g#0)[$Box(ref#0)]
               ==> ISet#Subset(PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType), 
                IMap#Domain(g#0))));

// definition axiom for PivotBetreeGraph.__default.IsClosed for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsClosed(Lit(g#0)) } 
    PivotBetreeGraph.__default.IsClosed#canCall(Lit(g#0))
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       ==> (forall ref#1: int :: 
          { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
            { IMap#Domain(g#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            IMap#Domain(g#0)[$Box(ref#1)]
             ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType))
         && PivotBetreeGraph.__default.IsClosed(Lit(g#0))
           == (forall ref#1: int :: 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
              { IMap#Domain(g#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> 
              IMap#Domain(g#0)[$Box(ref#1)]
               ==> ISet#Subset(PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType), 
                IMap#Domain(Lit(g#0)))));

// function declaration for PivotBetreeGraph._default.IsPath
function PivotBetreeGraph.__default.IsPath(g#0: IMap Box Box, path#0: Seq Box) : bool;

function PivotBetreeGraph.__default.IsPath#canCall(g#0: IMap Box Box, path#0: Seq Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.IsPath
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.IsPath(g#0, path#0) } 
    PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function PivotBetreeGraph.__default.IsPath#requires(IMap Box Box, Seq Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.IsPath
axiom (forall g#0: IMap Box Box, path#0: Seq Box :: 
  { PivotBetreeGraph.__default.IsPath#requires(g#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> PivotBetreeGraph.__default.IsPath#requires(g#0, path#0) == true);

// definition axiom for PivotBetreeGraph.__default.IsPath(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.IsPath(g#0, path#0) } 
    PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> ((forall i#0: int :: 
            { $Unbox(Seq#Index(path#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(path#0) - 1
               ==> IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
           ==> (forall i#1: int, _t#0#0: int :: 
            { $Unbox(Seq#Index(path#0, i#1)): int, $Unbox(Seq#Index(path#0, _t#0#0)): int } 
            _t#0#0 == i#1 + 1
               ==> 
              i#1 < Seq#Length(path#0) - 1
               ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[Seq#Index(path#0, i#1)]): DatatypeType)))
         && PivotBetreeGraph.__default.IsPath(g#0, path#0)
           == ((forall i#0: int :: 
              { $Unbox(Seq#Index(path#0, i#0)): int } 
              true
                 ==> 
                LitInt(0) <= i#0 && i#0 < Seq#Length(path#0) - 1
                 ==> IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
             && (forall i#1: int, _t#0#0: int :: 
              { $Unbox(Seq#Index(path#0, i#1)): int, $Unbox(Seq#Index(path#0, _t#0#0)): int } 
              _t#0#0 == i#1 + 1
                 ==> 
                LitInt(0) <= i#1 && i#1 < Seq#Length(path#0) - 1
                 ==> PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[Seq#Index(path#0, i#1)]): DatatypeType)[Seq#Index(path#0, _t#0#0)])));

// definition axiom for PivotBetreeGraph.__default.IsPath for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsPath(g#0, Lit(path#0)) } 
    PivotBetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> ((forall i#2: int :: 
            { $Unbox(Seq#Index(path#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
               ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#2)])
           ==> (forall i#3: int, _t#0#1: int :: 
            { $Unbox(Seq#Index(path#0, i#3)): int, $Unbox(Seq#Index(path#0, _t#0#1)): int } 
            _t#0#1 == i#3 + 1
               ==> 
              i#3 < Seq#Length(Lit(path#0)) - 1
               ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[Seq#Index(Lit(path#0), i#3)]): DatatypeType)))
         && PivotBetreeGraph.__default.IsPath(g#0, Lit(path#0))
           == ((forall i#2: int :: 
              { $Unbox(Seq#Index(path#0, i#2)): int } 
              true
                 ==> 
                LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
                 ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#2)])
             && (forall i#3: int, _t#0#1: int :: 
              { $Unbox(Seq#Index(path#0, i#3)): int, $Unbox(Seq#Index(path#0, _t#0#1)): int } 
              _t#0#1 == i#3 + 1
                 ==> 
                LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(path#0)) - 1
                 ==> PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[Seq#Index(Lit(path#0), i#3)]): DatatypeType)[Seq#Index(Lit(path#0), _t#0#1)])));

// definition axiom for PivotBetreeGraph.__default.IsPath for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0)) } 
    PivotBetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> ((forall i#4: int :: 
            { $Unbox(Seq#Index(path#0, i#4)): int } 
            true
               ==> 
              LitInt(0) <= i#4 && i#4 < Seq#Length(Lit(path#0)) - 1
               ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#4)])
           ==> (forall i#5: int, _t#0#2: int :: 
            { $Unbox(Seq#Index(path#0, i#5)): int, $Unbox(Seq#Index(path#0, _t#0#2)): int } 
            _t#0#2 == i#5 + 1
               ==> 
              i#5 < Seq#Length(Lit(path#0)) - 1
               ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[Seq#Index(Lit(path#0), i#5)]): DatatypeType)))
         && PivotBetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
           == ((forall i#4: int :: 
              { $Unbox(Seq#Index(path#0, i#4)): int } 
              true
                 ==> 
                LitInt(0) <= i#4 && i#4 < Seq#Length(Lit(path#0)) - 1
                 ==> IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#4)])
             && (forall i#5: int, _t#0#2: int :: 
              { $Unbox(Seq#Index(path#0, i#5)): int, $Unbox(Seq#Index(path#0, _t#0#2)): int } 
              _t#0#2 == i#5 + 1
                 ==> 
                LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(path#0)) - 1
                 ==> PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[Seq#Index(Lit(path#0), i#5)]): DatatypeType)[Seq#Index(Lit(path#0), _t#0#2)])));

// function declaration for PivotBetreeGraph._default.IsCycle
function PivotBetreeGraph.__default.IsCycle(g#0: IMap Box Box, path#0: Seq Box) : bool;

function PivotBetreeGraph.__default.IsCycle#canCall(g#0: IMap Box Box, path#0: Seq Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.IsCycle
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.IsCycle(g#0, path#0) } 
    PivotBetreeGraph.__default.IsCycle#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function PivotBetreeGraph.__default.IsCycle#requires(IMap Box Box, Seq Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.IsCycle
axiom (forall g#0: IMap Box Box, path#0: Seq Box :: 
  { PivotBetreeGraph.__default.IsCycle#requires(g#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> PivotBetreeGraph.__default.IsCycle#requires(g#0, path#0) == true);

// definition axiom for PivotBetreeGraph.__default.IsCycle(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.IsCycle(g#0, path#0) } 
    PivotBetreeGraph.__default.IsCycle#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
         && (0 < Seq#Length(path#0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0))
         && (Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)
             && PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]): DatatypeType))
         && PivotBetreeGraph.__default.IsCycle(g#0, path#0)
           == (
            PivotBetreeGraph.__default.IsPath(g#0, path#0)
             && 0 < Seq#Length(path#0)
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
             && PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]): DatatypeType)[Seq#Index(path#0, LitInt(0))]));

// definition axiom for PivotBetreeGraph.__default.IsCycle for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsCycle(g#0, Lit(path#0)) } 
    PivotBetreeGraph.__default.IsCycle#canCall(g#0, Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         && (0 < Seq#Length(Lit(path#0))
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && (Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType))
         && PivotBetreeGraph.__default.IsCycle(g#0, Lit(path#0))
           == (
            PivotBetreeGraph.__default.IsPath(g#0, Lit(path#0))
             && 0 < Seq#Length(Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
             && PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType)[Seq#Index(Lit(path#0), LitInt(0))]));

// definition axiom for PivotBetreeGraph.__default.IsCycle for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsCycle(Lit(g#0), Lit(path#0)) } 
    PivotBetreeGraph.__default.IsCycle#canCall(Lit(g#0), Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         && (0 < Seq#Length(Lit(path#0))
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && (Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0))
             && PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType))
         && PivotBetreeGraph.__default.IsCycle(Lit(g#0), Lit(path#0))
           == (
            PivotBetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
             && 0 < Seq#Length(Lit(path#0))
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]
             && PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]): DatatypeType)[Seq#Index(Lit(path#0), LitInt(0))]));

// function declaration for PivotBetreeGraph._default.IsSimple
function PivotBetreeGraph.__default.IsSimple(g#0: IMap Box Box, path#0: Seq Box) : bool;

function PivotBetreeGraph.__default.IsSimple#canCall(g#0: IMap Box Box, path#0: Seq Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.IsSimple
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.IsSimple(g#0, path#0) } 
    PivotBetreeGraph.__default.IsSimple#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function PivotBetreeGraph.__default.IsSimple#requires(IMap Box Box, Seq Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.IsSimple
axiom (forall g#0: IMap Box Box, path#0: Seq Box :: 
  { PivotBetreeGraph.__default.IsSimple#requires(g#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> PivotBetreeGraph.__default.IsSimple#requires(g#0, path#0) == true);

// definition axiom for PivotBetreeGraph.__default.IsSimple(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.IsSimple(g#0, path#0) } 
    PivotBetreeGraph.__default.IsSimple#canCall(g#0, path#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
         && PivotBetreeGraph.__default.IsSimple(g#0, path#0)
           == (PivotBetreeGraph.__default.IsPath(g#0, path#0)
             && (forall i#0: int, j#0: int :: 
              { $Unbox(Seq#Index(path#0, j#0)): int, $Unbox(Seq#Index(path#0, i#0)): int } 
              true
                 ==> 
                LitInt(0) <= i#0
                   && i#0 < Seq#Length(path#0)
                   && 
                  LitInt(0) <= j#0
                   && j#0 < Seq#Length(path#0)
                   && i#0 != j#0
                 ==> $Unbox(Seq#Index(path#0, i#0)): int != $Unbox(Seq#Index(path#0, j#0)): int)));

// definition axiom for PivotBetreeGraph.__default.IsSimple for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsSimple(g#0, Lit(path#0)) } 
    PivotBetreeGraph.__default.IsSimple#canCall(g#0, Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         && PivotBetreeGraph.__default.IsSimple(g#0, Lit(path#0))
           == (PivotBetreeGraph.__default.IsPath(g#0, Lit(path#0))
             && (forall i#1: int, j#1: int :: 
              { $Unbox(Seq#Index(path#0, j#1)): int, $Unbox(Seq#Index(path#0, i#1)): int } 
              true
                 ==> 
                LitInt(0) <= i#1
                   && i#1 < Seq#Length(Lit(path#0))
                   && 
                  LitInt(0) <= j#1
                   && j#1 < Seq#Length(Lit(path#0))
                   && i#1 != j#1
                 ==> $Unbox(Seq#Index(Lit(path#0), i#1)): int
                   != $Unbox(Seq#Index(Lit(path#0), j#1)): int)));

// definition axiom for PivotBetreeGraph.__default.IsSimple for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsSimple(Lit(g#0), Lit(path#0)) } 
    PivotBetreeGraph.__default.IsSimple#canCall(Lit(g#0), Lit(path#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         && PivotBetreeGraph.__default.IsSimple(Lit(g#0), Lit(path#0))
           == (PivotBetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
             && (forall i#2: int, j#2: int :: 
              { $Unbox(Seq#Index(path#0, j#2)): int, $Unbox(Seq#Index(path#0, i#2)): int } 
              true
                 ==> 
                LitInt(0) <= i#2
                   && i#2 < Seq#Length(Lit(path#0))
                   && 
                  LitInt(0) <= j#2
                   && j#2 < Seq#Length(Lit(path#0))
                   && i#2 != j#2
                 ==> $Unbox(Seq#Index(Lit(path#0), i#2)): int
                   != $Unbox(Seq#Index(Lit(path#0), j#2)): int)));

// function declaration for PivotBetreeGraph._default.IsAcyclic
function PivotBetreeGraph.__default.IsAcyclic(g#0: IMap Box Box) : bool;

function PivotBetreeGraph.__default.IsAcyclic#canCall(g#0: IMap Box Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.IsAcyclic
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.IsAcyclic(g#0) } 
    PivotBetreeGraph.__default.IsAcyclic#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       ==> true);

function PivotBetreeGraph.__default.IsAcyclic#requires(IMap Box Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.IsAcyclic
axiom (forall g#0: IMap Box Box :: 
  { PivotBetreeGraph.__default.IsAcyclic#requires(g#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
     ==> PivotBetreeGraph.__default.IsAcyclic#requires(g#0) == true);

// definition axiom for PivotBetreeGraph.__default.IsAcyclic(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.IsAcyclic(g#0) } 
    PivotBetreeGraph.__default.IsAcyclic#canCall(g#0)
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       ==> (forall path#0: Seq Box :: 
          { PivotBetreeGraph.__default.IsCycle(g#0, path#0) } 
            { PivotBetreeGraph.__default.IsPath(g#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
               && (PivotBetreeGraph.__default.IsPath(g#0, path#0)
                 ==> PivotBetreeGraph.__default.IsCycle#canCall(g#0, path#0)))
         && PivotBetreeGraph.__default.IsAcyclic(g#0)
           == (forall path#0: Seq Box :: 
            { PivotBetreeGraph.__default.IsCycle(g#0, path#0) } 
              { PivotBetreeGraph.__default.IsPath(g#0, path#0) } 
            $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              PivotBetreeGraph.__default.IsPath(g#0, path#0)
               ==> !PivotBetreeGraph.__default.IsCycle(g#0, path#0)));

// definition axiom for PivotBetreeGraph.__default.IsAcyclic for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box :: 
    {:weight 3} { PivotBetreeGraph.__default.IsAcyclic(Lit(g#0)) } 
    PivotBetreeGraph.__default.IsAcyclic#canCall(Lit(g#0))
         || $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       ==> (forall path#1: Seq Box :: 
          { PivotBetreeGraph.__default.IsCycle(g#0, path#1) } 
            { PivotBetreeGraph.__default.IsPath(g#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g#0), path#1)
               && (PivotBetreeGraph.__default.IsPath(Lit(g#0), path#1)
                 ==> PivotBetreeGraph.__default.IsCycle#canCall(Lit(g#0), path#1)))
         && PivotBetreeGraph.__default.IsAcyclic(Lit(g#0))
           == (forall path#1: Seq Box :: 
            { PivotBetreeGraph.__default.IsCycle(g#0, path#1) } 
              { PivotBetreeGraph.__default.IsPath(g#0, path#1) } 
            $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              PivotBetreeGraph.__default.IsPath(Lit(g#0), path#1)
               ==> !PivotBetreeGraph.__default.IsCycle(Lit(g#0), path#1)));

// function declaration for PivotBetreeGraph._default.IsPathFromTo
function PivotBetreeGraph.__default.IsPathFromTo(g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int) : bool;

function PivotBetreeGraph.__default.IsPathFromTo#canCall(g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int) : bool;

// consequence axiom for PivotBetreeGraph.__default.IsPathFromTo
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    { PivotBetreeGraph.__default.IsPathFromTo(g#0, path#0, start#0, end#0) } 
    PivotBetreeGraph.__default.IsPathFromTo#canCall(g#0, path#0, start#0, end#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> true);

function PivotBetreeGraph.__default.IsPathFromTo#requires(IMap Box Box, Seq Box, int, int) : bool;

// #requires axiom for PivotBetreeGraph.__default.IsPathFromTo
axiom (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
  { PivotBetreeGraph.__default.IsPathFromTo#requires(g#0, path#0, start#0, end#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= end#0
       && end#0 < 18446744073709551616
     ==> PivotBetreeGraph.__default.IsPathFromTo#requires(g#0, path#0, start#0, end#0)
       == true);

// definition axiom for PivotBetreeGraph.__default.IsPathFromTo(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    { PivotBetreeGraph.__default.IsPathFromTo(g#0, path#0, start#0, end#0) } 
    PivotBetreeGraph.__default.IsPathFromTo#canCall(g#0, path#0, start#0, end#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
         && ($Unbox(Seq#Index(path#0, LitInt(0))): int == start#0
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0))
         && PivotBetreeGraph.__default.IsPathFromTo(g#0, path#0, start#0, end#0)
           == (
            PivotBetreeGraph.__default.IsPath(g#0, path#0)
             && 1 < Seq#Length(path#0)
             && $Unbox(Seq#Index(path#0, LitInt(0))): int == start#0
             && $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int
               == end#0));

// definition axiom for PivotBetreeGraph.__default.IsPathFromTo for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    {:weight 3} { PivotBetreeGraph.__default.IsPathFromTo(g#0, Lit(path#0), start#0, end#0) } 
    PivotBetreeGraph.__default.IsPathFromTo#canCall(g#0, Lit(path#0), start#0, end#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, Lit(path#0))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == start#0
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && PivotBetreeGraph.__default.IsPathFromTo(g#0, Lit(path#0), start#0, end#0)
           == (
            PivotBetreeGraph.__default.IsPath(g#0, Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == start#0
             && LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int)
               == end#0));

// definition axiom for PivotBetreeGraph.__default.IsPathFromTo for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, path#0: Seq Box, start#0: int, end#0: int :: 
    {:weight 3} { PivotBetreeGraph.__default.IsPathFromTo(Lit(g#0), Lit(path#0), LitInt(start#0), LitInt(end#0)) } 
    PivotBetreeGraph.__default.IsPathFromTo#canCall(Lit(g#0), Lit(path#0), LitInt(start#0), LitInt(end#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= end#0
           && end#0 < 18446744073709551616)
       ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g#0), Lit(path#0))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(start#0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && PivotBetreeGraph.__default.IsPathFromTo(Lit(g#0), Lit(path#0), LitInt(start#0), LitInt(end#0))
           == (
            PivotBetreeGraph.__default.IsPath(Lit(g#0), Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(start#0)
             && LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int)
               == LitInt(end#0)));

// function declaration for PivotBetreeGraph._default.ReachableReferences
function PivotBetreeGraph.__default.ReachableReferences(g#0: IMap Box Box, p#0: int) : ISet Box;

function PivotBetreeGraph.__default.ReachableReferences#canCall(g#0: IMap Box Box, p#0: int) : bool;

// consequence axiom for PivotBetreeGraph.__default.ReachableReferences
axiom true
   ==> (forall g#0: IMap Box Box, p#0: int :: 
    { PivotBetreeGraph.__default.ReachableReferences(g#0, p#0) } 
    PivotBetreeGraph.__default.ReachableReferences#canCall(g#0, p#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> $Is(PivotBetreeGraph.__default.ReachableReferences(g#0, p#0), 
        TISet(Tclass.NativeTypes.uint64())));

function PivotBetreeGraph.__default.ReachableReferences#requires(IMap Box Box, int) : bool;

// #requires axiom for PivotBetreeGraph.__default.ReachableReferences
axiom (forall g#0: IMap Box Box, p#0: int :: 
  { PivotBetreeGraph.__default.ReachableReferences#requires(g#0, p#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
     ==> PivotBetreeGraph.__default.ReachableReferences#requires(g#0, p#0) == true);

// definition axiom for PivotBetreeGraph.__default.ReachableReferences(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, p#0: int :: 
    { PivotBetreeGraph.__default.ReachableReferences(g#0, p#0) } 
    PivotBetreeGraph.__default.ReachableReferences#canCall(g#0, p#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#0: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
            { $Unbox(Seq#Index(path#0, 0)): int } 
            { Seq#Length(path#0) } 
            { PivotBetreeGraph.__default.IsPath(g#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.IsPath#canCall(g#0, path#0)
               && (PivotBetreeGraph.__default.IsPath(g#0, path#0)
                   && 1 < Seq#Length(path#0)
                   && $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)))
         && PivotBetreeGraph.__default.ReachableReferences(g#0, p#0)
           == (lambda $y#0: Box :: 
            (exists path#0: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
                { $Unbox(Seq#Index(path#0, 0)): int } 
                { Seq#Length(path#0) } 
                { PivotBetreeGraph.__default.IsPath(g#0, path#0) } 
              $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
                 && 
                PivotBetreeGraph.__default.IsPath(g#0, path#0)
                 && 1 < Seq#Length(path#0)
                 && $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
                 && $y#0 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0))));

// definition axiom for PivotBetreeGraph.__default.ReachableReferences for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, p#0: int :: 
    {:weight 3} { PivotBetreeGraph.__default.ReachableReferences(Lit(g#0), LitInt(p#0)) } 
    PivotBetreeGraph.__default.ReachableReferences#canCall(Lit(g#0), LitInt(p#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#1: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
            { $Unbox(Seq#Index(path#1, 0)): int } 
            { Seq#Length(path#1) } 
            { PivotBetreeGraph.__default.IsPath(g#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g#0), path#1)
               && (PivotBetreeGraph.__default.IsPath(Lit(g#0), path#1)
                   && 1 < Seq#Length(path#1)
                   && $Unbox(Seq#Index(path#1, LitInt(0))): int == LitInt(p#0)
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#1)))
         && PivotBetreeGraph.__default.ReachableReferences(Lit(g#0), LitInt(p#0))
           == (lambda $y#1: Box :: 
            (exists path#1: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
                { $Unbox(Seq#Index(path#1, 0)): int } 
                { Seq#Length(path#1) } 
                { PivotBetreeGraph.__default.IsPath(g#0, path#1) } 
              $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
                 && 
                PivotBetreeGraph.__default.IsPath(Lit(g#0), path#1)
                 && 1 < Seq#Length(path#1)
                 && $Unbox(Seq#Index(path#1, LitInt(0))): int == LitInt(p#0)
                 && $y#1 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1))));

// function declaration for PivotBetreeGraph._default.NewPath
function PivotBetreeGraph.__default.NewPath(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box) : bool;

function PivotBetreeGraph.__default.NewPath#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.NewPath
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
    PivotBetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, path#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function PivotBetreeGraph.__default.NewPath#requires(IMap Box Box, IMap Box Box, int, Seq Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.NewPath
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
  { PivotBetreeGraph.__default.NewPath#requires(g#0, g'#0, p#0, path#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> PivotBetreeGraph.__default.NewPath#requires(g#0, g'#0, p#0, path#0) == true);

// definition axiom for PivotBetreeGraph.__default.NewPath(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
    PivotBetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, path#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(g'#0, path#0)
         && ((forall i#0: int :: 
            { $Unbox(Seq#Index(path#0, i#0)): int } 
            true
               ==> 
              0 < i#0 && i#0 < Seq#Length(path#0) - 1
               ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                 && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0))
         && PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0)
           == (
            PivotBetreeGraph.__default.IsPath(g'#0, path#0)
             && 1 < Seq#Length(path#0)
             && $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(path#0, i#0)): int } 
              true
                 ==> 
                0 < i#0 && i#0 < Seq#Length(path#0) - 1
                 ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                   && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]));

// definition axiom for PivotBetreeGraph.__default.NewPath for decreasing-related literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, Lit(path#0)) } 
    PivotBetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, Lit(path#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(g'#0, Lit(path#0))
         && ((forall i#1: int :: 
            { $Unbox(Seq#Index(path#0, i#1)): int } 
            true
               ==> 
              0 < i#1 && i#1 < Seq#Length(Lit(path#0)) - 1
               ==> IMap#Domain(g'#0)[Seq#Index(Lit(path#0), i#1)]
                 && !IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#1)])
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, Lit(path#0))
           == (
            PivotBetreeGraph.__default.IsPath(g'#0, Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == p#0
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(path#0, i#1)): int } 
              true
                 ==> 
                0 < i#1 && i#1 < Seq#Length(Lit(path#0)) - 1
                 ==> IMap#Domain(g'#0)[Seq#Index(Lit(path#0), i#1)]
                   && !IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#1)])
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]));

// definition axiom for PivotBetreeGraph.__default.NewPath for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0)) } 
    PivotBetreeGraph.__default.NewPath#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g'#0), Lit(path#0))
         && ((forall i#2: int :: 
            { $Unbox(Seq#Index(path#0, i#2)): int } 
            true
               ==> 
              0 < i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
               ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(Lit(path#0), i#2)]
                 && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(Lit(path#0), i#2)])
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(path#0)))
         && PivotBetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
           == (
            PivotBetreeGraph.__default.IsPath(Lit(g'#0), Lit(path#0))
             && 1 < Seq#Length(Lit(path#0))
             && $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(p#0)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(path#0, i#2)): int } 
              true
                 ==> 
                0 < i#2 && i#2 < Seq#Length(Lit(path#0)) - 1
                 ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(Lit(path#0), i#2)]
                   && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(Lit(path#0), i#2)])
             && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))]));

// function declaration for PivotBetreeGraph._default.NewlyReachableReferences
function PivotBetreeGraph.__default.NewlyReachableReferences(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : ISet Box;

function PivotBetreeGraph.__default.NewlyReachableReferences#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : bool;

// consequence axiom for PivotBetreeGraph.__default.NewlyReachableReferences
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { PivotBetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0) } 
    PivotBetreeGraph.__default.NewlyReachableReferences#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> $Is(PivotBetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0), 
        TISet(Tclass.NativeTypes.uint64())));

function PivotBetreeGraph.__default.NewlyReachableReferences#requires(IMap Box Box, IMap Box Box, int) : bool;

// #requires axiom for PivotBetreeGraph.__default.NewlyReachableReferences
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
  { PivotBetreeGraph.__default.NewlyReachableReferences#requires(g#0, g'#0, p#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
     ==> PivotBetreeGraph.__default.NewlyReachableReferences#requires(g#0, g'#0, p#0)
       == true);

// definition axiom for PivotBetreeGraph.__default.NewlyReachableReferences(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { PivotBetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0) } 
    PivotBetreeGraph.__default.NewlyReachableReferences#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#0: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
            { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.NewPath#canCall(g#0, g'#0, p#0, path#0)
               && (PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0)
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#0)))
         && PivotBetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0)
           == (lambda $y#0: Box :: 
            (exists path#0: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int } 
                { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0) } 
              $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
                 && PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#0)
                 && $y#0 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0))));

// definition axiom for PivotBetreeGraph.__default.NewlyReachableReferences for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    {:weight 3} { PivotBetreeGraph.__default.NewlyReachableReferences(Lit(g#0), Lit(g'#0), LitInt(p#0)) } 
    PivotBetreeGraph.__default.NewlyReachableReferences#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall path#1: Seq Box :: 
          { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
            { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.NewPath#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), path#1)
               && (PivotBetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), path#1)
                 ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), path#1)))
         && PivotBetreeGraph.__default.NewlyReachableReferences(Lit(g#0), Lit(g'#0), LitInt(p#0))
           == (lambda $y#1: Box :: 
            (exists path#1: Seq Box :: 
              { $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1)): int } 
                { PivotBetreeGraph.__default.NewPath(g#0, g'#0, p#0, path#1) } 
              $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
                 && PivotBetreeGraph.__default.NewPath(Lit(g#0), Lit(g'#0), LitInt(p#0), path#1)
                 && $y#1 == Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#1))));

// function declaration for PivotBetreeGraph._default.EditIsLocal
function PivotBetreeGraph.__default.EditIsLocal(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : bool;

function PivotBetreeGraph.__default.EditIsLocal#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int) : bool;

// consequence axiom for PivotBetreeGraph.__default.EditIsLocal
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0) } 
    PivotBetreeGraph.__default.EditIsLocal#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> true);

function PivotBetreeGraph.__default.EditIsLocal#requires(IMap Box Box, IMap Box Box, int) : bool;

// #requires axiom for PivotBetreeGraph.__default.EditIsLocal
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
  { PivotBetreeGraph.__default.EditIsLocal#requires(g#0, g'#0, p#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
     ==> PivotBetreeGraph.__default.EditIsLocal#requires(g#0, g'#0, p#0) == true);

// definition axiom for PivotBetreeGraph.__default.EditIsLocal(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    { PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0) } 
    PivotBetreeGraph.__default.EditIsLocal#canCall(g#0, g'#0, p#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall ref#0: int :: 
          { $Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType } 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            IMap#Domain(g#0)[$Box(ref#0)] && IMap#Domain(g'#0)[$Box(ref#0)] && ref#0 != p#0
             ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType)
               && PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType))
         && ((forall ref#0: int :: 
            { $Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType } 
              { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> 
              IMap#Domain(g#0)[$Box(ref#0)] && IMap#Domain(g'#0)[$Box(ref#0)] && ref#0 != p#0
               ==> ISet#Equal(PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType), 
                PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType)))
           ==> PivotBetreeGraph.__default.NewlyReachableReferences#canCall(g#0, g'#0, p#0)
             && PivotBetreeGraph.__default.ReachableReferences#canCall(g#0, p#0))
         && PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           == ((forall ref#0: int :: 
              { $Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType } 
                { $Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType } 
              LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                 ==> 
                IMap#Domain(g#0)[$Box(ref#0)] && IMap#Domain(g'#0)[$Box(ref#0)] && ref#0 != p#0
                 ==> ISet#Equal(PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g#0)[$Box(ref#0)]): DatatypeType), 
                  PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(g'#0)[$Box(ref#0)]): DatatypeType)))
             && ISet#Subset(PivotBetreeGraph.__default.NewlyReachableReferences(g#0, g'#0, p#0), 
              PivotBetreeGraph.__default.ReachableReferences(g#0, p#0))));

// definition axiom for PivotBetreeGraph.__default.EditIsLocal for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int :: 
    {:weight 3} { PivotBetreeGraph.__default.EditIsLocal(Lit(g#0), Lit(g'#0), LitInt(p#0)) } 
    PivotBetreeGraph.__default.EditIsLocal#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0))
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616)
       ==> (forall ref#1: int :: 
          { $Unbox(IMap#Elements(g'#0)[$Box(ref#1)]): DatatypeType } 
            { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            Lit(IMap#Domain(Lit(g#0)))[$Box(ref#1)]
               && Lit(IMap#Domain(Lit(g'#0)))[$Box(ref#1)]
               && ref#1 != LitInt(p#0)
             ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType)
               && PivotBetreeGraph.__default.Successors#canCall($Unbox(IMap#Elements(Lit(g'#0))[$Box(ref#1)]): DatatypeType))
         && ((forall ref#1: int :: 
            { $Unbox(IMap#Elements(g'#0)[$Box(ref#1)]): DatatypeType } 
              { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> 
              Lit(IMap#Domain(Lit(g#0)))[$Box(ref#1)]
                 && Lit(IMap#Domain(Lit(g'#0)))[$Box(ref#1)]
                 && ref#1 != LitInt(p#0)
               ==> ISet#Equal(PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType), 
                PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g'#0))[$Box(ref#1)]): DatatypeType)))
           ==> PivotBetreeGraph.__default.NewlyReachableReferences#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0))
             && PivotBetreeGraph.__default.ReachableReferences#canCall(Lit(g#0), LitInt(p#0)))
         && PivotBetreeGraph.__default.EditIsLocal(Lit(g#0), Lit(g'#0), LitInt(p#0))
           == ((forall ref#1: int :: 
              { $Unbox(IMap#Elements(g'#0)[$Box(ref#1)]): DatatypeType } 
                { $Unbox(IMap#Elements(g#0)[$Box(ref#1)]): DatatypeType } 
              LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                 ==> 
                Lit(IMap#Domain(Lit(g#0)))[$Box(ref#1)]
                   && Lit(IMap#Domain(Lit(g'#0)))[$Box(ref#1)]
                   && ref#1 != LitInt(p#0)
                 ==> ISet#Equal(PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g#0))[$Box(ref#1)]): DatatypeType), 
                  PivotBetreeGraph.__default.Successors($Unbox(IMap#Elements(Lit(g'#0))[$Box(ref#1)]): DatatypeType)))
             && ISet#Subset(PivotBetreeGraph.__default.NewlyReachableReferences(Lit(g#0), Lit(g'#0), LitInt(p#0)), 
              PivotBetreeGraph.__default.ReachableReferences(Lit(g#0), LitInt(p#0)))));

// function declaration for PivotBetreeGraph._default.NewNodesAreCycleFree
function PivotBetreeGraph.__default.NewNodesAreCycleFree(g#0: IMap Box Box, g'#0: IMap Box Box) : bool;

function PivotBetreeGraph.__default.NewNodesAreCycleFree#canCall(g#0: IMap Box Box, g'#0: IMap Box Box) : bool;

// consequence axiom for PivotBetreeGraph.__default.NewNodesAreCycleFree
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.NewNodesAreCycleFree(g#0, g'#0) } 
    PivotBetreeGraph.__default.NewNodesAreCycleFree#canCall(g#0, g'#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())))
       ==> true);

function PivotBetreeGraph.__default.NewNodesAreCycleFree#requires(IMap Box Box, IMap Box Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.NewNodesAreCycleFree
axiom (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
  { PivotBetreeGraph.__default.NewNodesAreCycleFree#requires(g#0, g'#0) } 
  $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
     ==> PivotBetreeGraph.__default.NewNodesAreCycleFree#requires(g#0, g'#0) == true);

// definition axiom for PivotBetreeGraph.__default.NewNodesAreCycleFree(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.NewNodesAreCycleFree(g#0, g'#0) } 
    PivotBetreeGraph.__default.NewNodesAreCycleFree#canCall(g#0, g'#0)
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())))
       ==> (forall path#0: Seq Box :: 
          { PivotBetreeGraph.__default.IsCycle(g'#0, path#0) } 
            { Seq#Length(path#0) } 
            { PivotBetreeGraph.__default.IsPath(g'#0, path#0) } 
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.IsPath#canCall(g'#0, path#0)
               && ((forall i#0: int :: 
                  { $Unbox(Seq#Index(path#0, i#0)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#0 && i#0 < Seq#Length(path#0)
                     ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                       && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
                 ==> PivotBetreeGraph.__default.IsCycle#canCall(g'#0, path#0)))
         && PivotBetreeGraph.__default.NewNodesAreCycleFree(g#0, g'#0)
           == (forall path#0: Seq Box :: 
            { PivotBetreeGraph.__default.IsCycle(g'#0, path#0) } 
              { Seq#Length(path#0) } 
              { PivotBetreeGraph.__default.IsPath(g'#0, path#0) } 
            $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              PivotBetreeGraph.__default.IsPath(g'#0, path#0)
                 && (forall i#0: int :: 
                  { $Unbox(Seq#Index(path#0, i#0)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#0 && i#0 < Seq#Length(path#0)
                     ==> IMap#Domain(g'#0)[Seq#Index(path#0, i#0)]
                       && !IMap#Domain(g#0)[Seq#Index(path#0, i#0)])
               ==> !PivotBetreeGraph.__default.IsCycle(g'#0, path#0)));

// definition axiom for PivotBetreeGraph.__default.NewNodesAreCycleFree for all literals(revealed)
axiom true
   ==> (forall g#0: IMap Box Box, g'#0: IMap Box Box :: 
    {:weight 3} { PivotBetreeGraph.__default.NewNodesAreCycleFree(Lit(g#0), Lit(g'#0)) } 
    PivotBetreeGraph.__default.NewNodesAreCycleFree#canCall(Lit(g#0), Lit(g'#0))
         || ($Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())))
       ==> (forall path#1: Seq Box :: 
          { PivotBetreeGraph.__default.IsCycle(g'#0, path#1) } 
            { Seq#Length(path#1) } 
            { PivotBetreeGraph.__default.IsPath(g'#0, path#1) } 
          $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
             ==> PivotBetreeGraph.__default.IsPath#canCall(Lit(g'#0), path#1)
               && ((forall i#1: int :: 
                  { $Unbox(Seq#Index(path#1, i#1)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#1 && i#1 < Seq#Length(path#1)
                     ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(path#1, i#1)]
                       && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(path#1, i#1)])
                 ==> PivotBetreeGraph.__default.IsCycle#canCall(Lit(g'#0), path#1)))
         && PivotBetreeGraph.__default.NewNodesAreCycleFree(Lit(g#0), Lit(g'#0))
           == (forall path#1: Seq Box :: 
            { PivotBetreeGraph.__default.IsCycle(g'#0, path#1) } 
              { Seq#Length(path#1) } 
              { PivotBetreeGraph.__default.IsPath(g'#0, path#1) } 
            $Is(path#1, TSeq(Tclass.NativeTypes.uint64()))
               ==> 
              PivotBetreeGraph.__default.IsPath(Lit(g'#0), path#1)
                 && (forall i#1: int :: 
                  { $Unbox(Seq#Index(path#1, i#1)): int } 
                  true
                     ==> 
                    LitInt(0) <= i#1 && i#1 < Seq#Length(path#1)
                     ==> Lit(IMap#Domain(Lit(g'#0)))[Seq#Index(path#1, i#1)]
                       && !Lit(IMap#Domain(Lit(g#0)))[Seq#Index(path#1, i#1)])
               ==> !PivotBetreeGraph.__default.IsCycle(Lit(g'#0), path#1)));

// function declaration for PivotBetreeGraph._default.FirstInGraph
function PivotBetreeGraph.__default.FirstInGraph($ly: LayerType, path#0: Seq Box, g#0: IMap Box Box) : int;

function PivotBetreeGraph.__default.FirstInGraph#canCall(path#0: Seq Box, g#0: IMap Box Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
  { PivotBetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0) } 
  PivotBetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0)
     == PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
  { PivotBetreeGraph.__default.FirstInGraph(AsFuelBottom($ly), path#0, g#0) } 
  PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0)
     == PivotBetreeGraph.__default.FirstInGraph($LZ, path#0, g#0));

// consequence axiom for PivotBetreeGraph.__default.FirstInGraph
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0) } 
    PivotBetreeGraph.__default.FirstInGraph#canCall(path#0, g#0)
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && (exists i#0: int :: 
            { $Unbox(Seq#Index(path#0, i#0)): int } 
            LitInt(0) <= i#0
               && i#0 < Seq#Length(path#0)
               && IMap#Domain(g#0)[Seq#Index(path#0, i#0)]))
       ==> LitInt(0) <= PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0)
         && PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0) < Seq#Length(path#0)
         && IMap#Domain(g#0)[Seq#Index(path#0, PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0))]
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(path#0, i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1 < PivotBetreeGraph.__default.FirstInGraph($ly, path#0, g#0)
             ==> !IMap#Domain(g#0)[Seq#Index(path#0, i#1)]));

function PivotBetreeGraph.__default.FirstInGraph#requires(LayerType, Seq Box, IMap Box Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.FirstInGraph
axiom (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
  { PivotBetreeGraph.__default.FirstInGraph#requires($ly, path#0, g#0) } 
  $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
     ==> PivotBetreeGraph.__default.FirstInGraph#requires($ly, path#0, g#0)
       == (exists i#2: int :: 
        { $Unbox(Seq#Index(path#0, i#2)): int } 
        LitInt(0) <= i#2
           && i#2 < Seq#Length(path#0)
           && IMap#Domain(g#0)[Seq#Index(path#0, i#2)]));

// definition axiom for PivotBetreeGraph.__default.FirstInGraph(revealed)
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    { PivotBetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0) } 
    PivotBetreeGraph.__default.FirstInGraph#canCall(path#0, g#0)
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && (exists i#2: int :: 
            { $Unbox(Seq#Index(path#0, i#2)): int } 
            LitInt(0) <= i#2
               && i#2 < Seq#Length(path#0)
               && IMap#Domain(g#0)[Seq#Index(path#0, i#2)]))
       ==> (!IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
           ==> PivotBetreeGraph.__default.FirstInGraph#canCall(Seq#Drop(path#0, LitInt(1)), g#0))
         && PivotBetreeGraph.__default.FirstInGraph($LS($ly), path#0, g#0)
           == (if IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
             then 0
             else 1
               + PivotBetreeGraph.__default.FirstInGraph($ly, Seq#Drop(path#0, LitInt(1)), g#0)));

// definition axiom for PivotBetreeGraph.__default.FirstInGraph for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    {:weight 3} { PivotBetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), g#0) } 
    PivotBetreeGraph.__default.FirstInGraph#canCall(Lit(path#0), g#0)
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && (exists i#3: int :: 
            { $Unbox(Seq#Index(path#0, i#3)): int } 
            LitInt(0) <= i#3
               && i#3 < Seq#Length(Lit(path#0))
               && IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#3)]))
       ==> (!IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
           ==> PivotBetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0))
         && PivotBetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), g#0)
           == (if IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
             then 0
             else 1
               + PivotBetreeGraph.__default.FirstInGraph($LS($ly), Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0)));

// definition axiom for PivotBetreeGraph.__default.FirstInGraph for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, path#0: Seq Box, g#0: IMap Box Box :: 
    {:weight 3} { PivotBetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), Lit(g#0)) } 
    PivotBetreeGraph.__default.FirstInGraph#canCall(Lit(path#0), Lit(g#0))
         || (
          $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && (exists i#4: int :: 
            { $Unbox(Seq#Index(path#0, i#4)): int } 
            LitInt(0) <= i#4
               && i#4 < Seq#Length(Lit(path#0))
               && IMap#Domain(g#0)[Seq#Index(Lit(path#0), i#4)]))
       ==> (!IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
           ==> PivotBetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0)))
         && PivotBetreeGraph.__default.FirstInGraph($LS($ly), Lit(path#0), Lit(g#0))
           == (if IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
             then 0
             else 1
               + PivotBetreeGraph.__default.FirstInGraph($LS($ly), Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))));

// function declaration for PivotBetreeGraph._default.UndoLocalEdit
function PivotBetreeGraph.__default.UndoLocalEdit($ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box)
   : Seq Box;

function PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
  { PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0) } 
  PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0)
     == PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
  { PivotBetreeGraph.__default.UndoLocalEdit(AsFuelBottom($ly), g#0, g'#0, p#0, path#0) } 
  PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0)
     == PivotBetreeGraph.__default.UndoLocalEdit($LZ, g#0, g'#0, p#0, path#0));

// consequence axiom for PivotBetreeGraph.__default.UndoLocalEdit
axiom true
   ==> (forall $ly: LayerType, g#0: IMap Box Box, g'#0: IMap Box Box, p#0: int, path#0: Seq Box :: 
    { PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0) } 
    PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, path#0)
         || (
          $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          PivotBetreeGraph.__default.IsClosed(g#0)
           && 1 < Seq#Length(path#0)
           && IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
           && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
           && PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           && PivotBetreeGraph.__default.IsPath(g'#0, path#0))
       ==> PivotBetreeGraph.__default.IsPathFromTo(g#0, 
          PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0), 
          $Unbox(Seq#Index(path#0, LitInt(0))): int, 
          $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)): int)
         && $Is(PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, path#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function PivotBetreeGraph.__default.UndoLocalEdit#requires(LayerType, IMap Box Box, IMap Box Box, int, Seq Box) : bool;

// #requires axiom for PivotBetreeGraph.__default.UndoLocalEdit
axiom (forall $ly: LayerType, 
    $Heap: Heap, 
    g#0: IMap Box Box, 
    g'#0: IMap Box Box, 
    p#0: int, 
    path#0: Seq Box :: 
  { PivotBetreeGraph.__default.UndoLocalEdit#requires($ly, g#0, g'#0, p#0, path#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && 
      LitInt(0) <= p#0
       && p#0 < 18446744073709551616
       && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> PivotBetreeGraph.__default.UndoLocalEdit#requires($ly, g#0, g'#0, p#0, path#0)
       == (
        PivotBetreeGraph.__default.IsClosed(g#0)
         && 1 < Seq#Length(path#0)
         && IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
         && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
         && PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
         && PivotBetreeGraph.__default.IsPath(g'#0, path#0)));

function $let#29_replacement(g: IMap Box Box, path: Seq Box, wit: Seq Box) : Seq Box;

function $let#29$canCall(g: IMap Box Box, path: Seq Box, wit: Seq Box) : bool;

axiom (forall g: IMap Box Box, path: Seq Box, wit: Seq Box :: 
  { $let#29_replacement(g, path, wit) } 
  $let#29$canCall(g, path, wit)
     ==> $Is($let#29_replacement(g, path, wit), TSeq(Tclass.NativeTypes.uint64()))
       && PivotBetreeGraph.__default.IsPathFromTo(g, 
        $let#29_replacement(g, path, wit), 
        $Unbox(Seq#Index(path, LitInt(0))): int, 
        $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), wit)): int));

// definition axiom for PivotBetreeGraph.__default.UndoLocalEdit(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      g#0: IMap Box Box, 
      g'#0: IMap Box Box, 
      p#0: int, 
      path#0: Seq Box :: 
    { PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0), $IsGoodHeap($Heap) } 
    PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, path#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          PivotBetreeGraph.__default.IsClosed(g#0)
           && 1 < Seq#Length(path#0)
           && IMap#Domain(g#0)[Seq#Index(path#0, LitInt(0))]
           && IMap#Domain(g#0)[Sequences.__default.Last(Tclass.NativeTypes.uint64(), path#0)]
           && PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           && PivotBetreeGraph.__default.IsPath(g'#0, path#0))
       ==> ($Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
           ==> PivotBetreeGraph.__default.FirstInGraph#canCall(Seq#Drop(path#0, LitInt(1)), g#0)
             && (var len#0 := 1
                   + PivotBetreeGraph.__default.FirstInGraph($LS($LZ), Seq#Drop(path#0, LitInt(1)), g#0); 
              (var wit#1 := Seq#Take(path#0, len#0 + 1); 
                $let#29$canCall(g#0, path#0, wit#1)
                   && (len#0 < Seq#Length(path#0) - 1
                     ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), $let#29_replacement(g#0, path#0, wit#1))
                       && PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Seq#Drop(path#0, len#0))))))
         && ($Unbox(Seq#Index(path#0, LitInt(0))): int != p#0
           ==> 
          Seq#Length(path#0) != LitInt(2)
           ==> PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Seq#Drop(path#0, LitInt(1))))
         && PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, path#0)
           == (if $Unbox(Seq#Index(path#0, LitInt(0))): int == p#0
             then (var len#0 := 1
                   + PivotBetreeGraph.__default.FirstInGraph($LS($LZ), Seq#Drop(path#0, LitInt(1)), g#0); 
              (var wit#1 := Seq#Take(path#0, len#0 + 1); 
                (var replacement#0 := $let#29_replacement(g#0, path#0, wit#1); 
                  (if len#0 < Seq#Length(path#0) - 1
                     then Seq#Append(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), replacement#0), 
                      PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, Seq#Drop(path#0, len#0)))
                     else replacement#0))))
             else (if Seq#Length(path#0) == LitInt(2)
               then path#0
               else Seq#Append(Seq#Take(path#0, LitInt(1)), 
                PivotBetreeGraph.__default.UndoLocalEdit($ly, g#0, g'#0, p#0, Seq#Drop(path#0, LitInt(1)))))));

// definition axiom for PivotBetreeGraph.__default.UndoLocalEdit for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      g#0: IMap Box Box, 
      g'#0: IMap Box Box, 
      p#0: int, 
      path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Lit(path#0)), $IsGoodHeap($Heap) } 
    PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Lit(path#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          PivotBetreeGraph.__default.IsClosed(g#0)
           && 1 < Seq#Length(Lit(path#0))
           && IMap#Domain(g#0)[Seq#Index(Lit(path#0), LitInt(0))]
           && IMap#Domain(g#0)[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]
           && PivotBetreeGraph.__default.EditIsLocal(g#0, g'#0, p#0)
           && PivotBetreeGraph.__default.IsPath(g'#0, Lit(path#0)))
       ==> ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == p#0
           ==> PivotBetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0)
             && (var len#1 := 1
                   + PivotBetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0); 
              (var wit#2 := Seq#Take(Lit(path#0), len#1 + 1); 
                $let#29$canCall(g#0, Lit(path#0), wit#2)
                   && (len#1 < Seq#Length(Lit(path#0)) - 1
                     ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), $let#29_replacement(g#0, Lit(path#0), wit#2))
                       && PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Seq#Drop(Lit(path#0), len#1))))))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int != p#0
           ==> 
          Seq#Length(Lit(path#0)) != LitInt(2)
           ==> PivotBetreeGraph.__default.UndoLocalEdit#canCall(g#0, g'#0, p#0, Lit(Seq#Drop(Lit(path#0), LitInt(1)))))
         && PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Lit(path#0))
           == (if $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == p#0
             then (var len#1 := 1
                   + PivotBetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), g#0); 
              (var wit#2 := Seq#Take(Lit(path#0), len#1 + 1); 
                (var replacement#1 := $let#29_replacement(g#0, Lit(path#0), wit#2); 
                  (if len#1 < Seq#Length(Lit(path#0)) - 1
                     then Seq#Append(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), replacement#1), 
                      PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Seq#Drop(Lit(path#0), len#1)))
                     else replacement#1))))
             else (if Seq#Length(Lit(path#0)) == LitInt(2)
               then path#0
               else Seq#Append(Seq#Take(Lit(path#0), LitInt(1)), 
                PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), g#0, g'#0, p#0, Lit(Seq#Drop(Lit(path#0), LitInt(1))))))));

// definition axiom for PivotBetreeGraph.__default.UndoLocalEdit for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      $Heap: Heap, 
      g#0: IMap Box Box, 
      g'#0: IMap Box Box, 
      p#0: int, 
      path#0: Seq Box :: 
    {:weight 3} { PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0)), $IsGoodHeap($Heap) } 
    PivotBetreeGraph.__default.UndoLocalEdit#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(g#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(g'#0, TIMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && 
          LitInt(0) <= p#0
           && p#0 < 18446744073709551616
           && $Is(path#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          Lit(PivotBetreeGraph.__default.IsClosed(Lit(g#0)))
           && 1 < Seq#Length(Lit(path#0))
           && Lit(IMap#Domain(Lit(g#0)))[Seq#Index(Lit(path#0), LitInt(0))]
           && Lit(IMap#Domain(Lit(g#0)))[$Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(path#0))): int))]
           && Lit(PivotBetreeGraph.__default.EditIsLocal(Lit(g#0), Lit(g'#0), LitInt(p#0)))
           && Lit(PivotBetreeGraph.__default.IsPath(Lit(g'#0), Lit(path#0))))
       ==> ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(p#0)
           ==> PivotBetreeGraph.__default.FirstInGraph#canCall(Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))
             && (var len#2 := LitInt(1
                     + PivotBetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))); 
              (var wit#3 := Seq#Take(Lit(path#0), len#2 + 1); 
                $let#29$canCall(Lit(g#0), Lit(path#0), wit#3)
                   && (len#2 < Seq#Length(Lit(path#0)) - 1
                     ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), $let#29_replacement(Lit(g#0), Lit(path#0), wit#3))
                       && PivotBetreeGraph.__default.UndoLocalEdit#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Seq#Drop(Lit(path#0), len#2))))))
         && ($Unbox(Seq#Index(Lit(path#0), LitInt(0))): int != LitInt(p#0)
           ==> 
          Seq#Length(Lit(path#0)) != LitInt(2)
           ==> PivotBetreeGraph.__default.UndoLocalEdit#canCall(Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(Seq#Drop(Lit(path#0), LitInt(1)))))
         && PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(path#0))
           == (if $Unbox(Seq#Index(Lit(path#0), LitInt(0))): int == LitInt(p#0)
             then (var len#2 := LitInt(1
                     + PivotBetreeGraph.__default.FirstInGraph($LS($LZ), Lit(Seq#Drop(Lit(path#0), LitInt(1))), Lit(g#0))); 
              (var wit#3 := Lit(Seq#Take(Lit(path#0), LitInt(len#2 + 1))); 
                (var replacement#2 := $let#29_replacement(Lit(g#0), Lit(path#0), wit#3); 
                  (if len#2 < Seq#Length(Lit(path#0)) - 1
                     then Seq#Append(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), replacement#2), 
                      PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), Lit(g#0), Lit(g'#0), LitInt(p#0), Lit(Seq#Drop(Lit(path#0), len#2))))
                     else replacement#2))))
             else (if Seq#Length(Lit(path#0)) == LitInt(2)
               then path#0
               else Seq#Append(Seq#Take(Lit(path#0), LitInt(1)), 
                PivotBetreeGraph.__default.UndoLocalEdit($LS($ly), 
                  Lit(g#0), 
                  Lit(g'#0), 
                  LitInt(p#0), 
                  Lit(Seq#Drop(Lit(path#0), LitInt(1))))))));

// Constructor function declaration
function #PivotBetreeGraph.Op.AllocOp(int, DatatypeType) : DatatypeType;

const unique ##PivotBetreeGraph.Op.AllocOp: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.AllocOp(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#PivotBetreeGraph.Op.AllocOp(a#0#0#0, a#0#1#0))
     == ##PivotBetreeGraph.Op.AllocOp);

function PivotBetreeGraph.Op.AllocOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Op.AllocOp_q(d) } 
  PivotBetreeGraph.Op.AllocOp_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeGraph.Op.AllocOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Op.AllocOp_q(d) } 
  PivotBetreeGraph.Op.AllocOp_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: DatatypeType :: 
      d == #PivotBetreeGraph.Op.AllocOp(a#1#0#0, a#1#1#0)));

function Tclass.PivotBetreeGraph.Op() : Ty;

// Tclass.PivotBetreeGraph.Op Tag
axiom Tag(Tclass.PivotBetreeGraph.Op()) == Tagclass.PivotBetreeGraph.Op;

const unique Tagclass.PivotBetreeGraph.Op: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeGraph.Op
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeGraph.Op()) } 
  $IsBox(bx, Tclass.PivotBetreeGraph.Op())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeGraph.Op()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: DatatypeType :: 
  { $Is(#PivotBetreeGraph.Op.AllocOp(a#2#0#0, a#2#1#0), Tclass.PivotBetreeGraph.Op()) } 
  $Is(#PivotBetreeGraph.Op.AllocOp(a#2#0#0, a#2#1#0), Tclass.PivotBetreeGraph.Op())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.PivotBetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeGraph.Op.AllocOp(a#3#0#0, a#3#1#0), Tclass.PivotBetreeGraph.Op(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeGraph.Op.AllocOp(a#3#0#0, a#3#1#0), Tclass.PivotBetreeGraph.Op(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.PivotBetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Op.AllocOp_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Op(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Op.node(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Op.AllocOp_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Op(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Op.node(d), Tclass.PivotBetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.AllocOp(LitInt(a#4#0#0), Lit(a#4#1#0)) } 
  #PivotBetreeGraph.Op.AllocOp(LitInt(a#4#0#0), Lit(a#4#1#0))
     == Lit(#PivotBetreeGraph.Op.AllocOp(a#4#0#0, a#4#1#0)));

function PivotBetreeGraph.Op.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.AllocOp(a#5#0#0, a#5#1#0) } 
  PivotBetreeGraph.Op.ref(#PivotBetreeGraph.Op.AllocOp(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function PivotBetreeGraph.Op.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.AllocOp(a#6#0#0, a#6#1#0) } 
  PivotBetreeGraph.Op.node(#PivotBetreeGraph.Op.AllocOp(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Inductive rank
axiom (forall a#7#0#0: int, a#7#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.AllocOp(a#7#0#0, a#7#1#0) } 
  DtRank(a#7#1#0) < DtRank(#PivotBetreeGraph.Op.AllocOp(a#7#0#0, a#7#1#0)));

// Constructor function declaration
function #PivotBetreeGraph.Op.WriteOp(int, DatatypeType) : DatatypeType;

const unique ##PivotBetreeGraph.Op.WriteOp: DtCtorId;

// Constructor identifier
axiom (forall a#8#0#0: int, a#8#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.WriteOp(a#8#0#0, a#8#1#0) } 
  DatatypeCtorId(#PivotBetreeGraph.Op.WriteOp(a#8#0#0, a#8#1#0))
     == ##PivotBetreeGraph.Op.WriteOp);

function PivotBetreeGraph.Op.WriteOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Op.WriteOp_q(d) } 
  PivotBetreeGraph.Op.WriteOp_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeGraph.Op.WriteOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Op.WriteOp_q(d) } 
  PivotBetreeGraph.Op.WriteOp_q(d)
     ==> (exists a#9#0#0: int, a#9#1#0: DatatypeType :: 
      d == #PivotBetreeGraph.Op.WriteOp(a#9#0#0, a#9#1#0)));

// Constructor $Is
axiom (forall a#10#0#0: int, a#10#1#0: DatatypeType :: 
  { $Is(#PivotBetreeGraph.Op.WriteOp(a#10#0#0, a#10#1#0), Tclass.PivotBetreeGraph.Op()) } 
  $Is(#PivotBetreeGraph.Op.WriteOp(a#10#0#0, a#10#1#0), Tclass.PivotBetreeGraph.Op())
     <==> $Is(a#10#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#10#1#0, Tclass.PivotBetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#11#0#0: int, a#11#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeGraph.Op.WriteOp(a#11#0#0, a#11#1#0), 
      Tclass.PivotBetreeGraph.Op(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeGraph.Op.WriteOp(a#11#0#0, a#11#1#0), 
        Tclass.PivotBetreeGraph.Op(), 
        $h)
       <==> $IsAlloc(a#11#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#11#1#0, Tclass.PivotBetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Op.WriteOp_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Op(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Op.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.Op.node(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.Op.WriteOp_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.Op(), $h)
     ==> $IsAlloc(PivotBetreeGraph.Op.node(d), Tclass.PivotBetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#12#0#0: int, a#12#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.WriteOp(LitInt(a#12#0#0), Lit(a#12#1#0)) } 
  #PivotBetreeGraph.Op.WriteOp(LitInt(a#12#0#0), Lit(a#12#1#0))
     == Lit(#PivotBetreeGraph.Op.WriteOp(a#12#0#0, a#12#1#0)));

// Constructor injectivity
axiom (forall a#13#0#0: int, a#13#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.WriteOp(a#13#0#0, a#13#1#0) } 
  PivotBetreeGraph.Op.ref(#PivotBetreeGraph.Op.WriteOp(a#13#0#0, a#13#1#0))
     == a#13#0#0);

// Constructor injectivity
axiom (forall a#14#0#0: int, a#14#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.WriteOp(a#14#0#0, a#14#1#0) } 
  PivotBetreeGraph.Op.node(#PivotBetreeGraph.Op.WriteOp(a#14#0#0, a#14#1#0))
     == a#14#1#0);

// Inductive rank
axiom (forall a#15#0#0: int, a#15#1#0: DatatypeType :: 
  { #PivotBetreeGraph.Op.WriteOp(a#15#0#0, a#15#1#0) } 
  DtRank(a#15#1#0) < DtRank(#PivotBetreeGraph.Op.WriteOp(a#15#0#0, a#15#1#0)));

// Depth-one case-split function
function $IsA#PivotBetreeGraph.Op(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeGraph.Op(d) } 
  $IsA#PivotBetreeGraph.Op(d)
     ==> PivotBetreeGraph.Op.AllocOp_q(d) || PivotBetreeGraph.Op.WriteOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.Op.WriteOp_q(d), $Is(d, Tclass.PivotBetreeGraph.Op()) } 
    { PivotBetreeGraph.Op.AllocOp_q(d), $Is(d, Tclass.PivotBetreeGraph.Op()) } 
  $Is(d, Tclass.PivotBetreeGraph.Op())
     ==> PivotBetreeGraph.Op.AllocOp_q(d) || PivotBetreeGraph.Op.WriteOp_q(d));

// Datatype extensional equality declaration
function PivotBetreeGraph.Op#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeGraph.Op.AllocOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.Op#Equal(a, b), PivotBetreeGraph.Op.AllocOp_q(a) } 
    { PivotBetreeGraph.Op#Equal(a, b), PivotBetreeGraph.Op.AllocOp_q(b) } 
  PivotBetreeGraph.Op.AllocOp_q(a) && PivotBetreeGraph.Op.AllocOp_q(b)
     ==> (PivotBetreeGraph.Op#Equal(a, b)
       <==> PivotBetreeGraph.Op.ref(a) == PivotBetreeGraph.Op.ref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeGraph.Op.node(a), PivotBetreeGraph.Op.node(b))));

// Datatype extensional equality definition: #PivotBetreeGraph.Op.WriteOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.Op#Equal(a, b), PivotBetreeGraph.Op.WriteOp_q(a) } 
    { PivotBetreeGraph.Op#Equal(a, b), PivotBetreeGraph.Op.WriteOp_q(b) } 
  PivotBetreeGraph.Op.WriteOp_q(a) && PivotBetreeGraph.Op.WriteOp_q(b)
     ==> (PivotBetreeGraph.Op#Equal(a, b)
       <==> PivotBetreeGraph.Op.ref(a) == PivotBetreeGraph.Op.ref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeGraph.Op.node(a), PivotBetreeGraph.Op.node(b))));

// Datatype extensionality axiom: PivotBetreeGraph.Op
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.Op#Equal(a, b) } 
  PivotBetreeGraph.Op#Equal(a, b) <==> a == b);

const unique class.PivotBetreeGraph.Op: ClassName;

// Constructor function declaration
function #PivotBetreeGraph.ReadOp.ReadOp(int, DatatypeType) : DatatypeType;

const unique ##PivotBetreeGraph.ReadOp.ReadOp: DtCtorId;

// Constructor identifier
axiom (forall a#16#0#0: int, a#16#1#0: DatatypeType :: 
  { #PivotBetreeGraph.ReadOp.ReadOp(a#16#0#0, a#16#1#0) } 
  DatatypeCtorId(#PivotBetreeGraph.ReadOp.ReadOp(a#16#0#0, a#16#1#0))
     == ##PivotBetreeGraph.ReadOp.ReadOp);

function PivotBetreeGraph.ReadOp.ReadOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.ReadOp.ReadOp_q(d) } 
  PivotBetreeGraph.ReadOp.ReadOp_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeGraph.ReadOp.ReadOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.ReadOp.ReadOp_q(d) } 
  PivotBetreeGraph.ReadOp.ReadOp_q(d)
     ==> (exists a#17#0#0: int, a#17#1#0: DatatypeType :: 
      d == #PivotBetreeGraph.ReadOp.ReadOp(a#17#0#0, a#17#1#0)));

function Tclass.PivotBetreeGraph.ReadOp() : Ty;

// Tclass.PivotBetreeGraph.ReadOp Tag
axiom Tag(Tclass.PivotBetreeGraph.ReadOp()) == Tagclass.PivotBetreeGraph.ReadOp;

const unique Tagclass.PivotBetreeGraph.ReadOp: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeGraph.ReadOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeGraph.ReadOp()) } 
  $IsBox(bx, Tclass.PivotBetreeGraph.ReadOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeGraph.ReadOp()));

// Constructor $Is
axiom (forall a#18#0#0: int, a#18#1#0: DatatypeType :: 
  { $Is(#PivotBetreeGraph.ReadOp.ReadOp(a#18#0#0, a#18#1#0), 
      Tclass.PivotBetreeGraph.ReadOp()) } 
  $Is(#PivotBetreeGraph.ReadOp.ReadOp(a#18#0#0, a#18#1#0), 
      Tclass.PivotBetreeGraph.ReadOp())
     <==> $Is(a#18#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#18#1#0, Tclass.PivotBetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#19#0#0: int, a#19#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeGraph.ReadOp.ReadOp(a#19#0#0, a#19#1#0), 
      Tclass.PivotBetreeGraph.ReadOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeGraph.ReadOp.ReadOp(a#19#0#0, a#19#1#0), 
        Tclass.PivotBetreeGraph.ReadOp(), 
        $h)
       <==> $IsAlloc(a#19#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#19#1#0, Tclass.PivotBetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.ReadOp.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.ReadOp.ReadOp_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.ReadOp(), $h)
     ==> $IsAlloc(PivotBetreeGraph.ReadOp.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeGraph.ReadOp.node(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeGraph.ReadOp.ReadOp_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeGraph.ReadOp(), $h)
     ==> $IsAlloc(PivotBetreeGraph.ReadOp.node(d), Tclass.PivotBetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#20#0#0: int, a#20#1#0: DatatypeType :: 
  { #PivotBetreeGraph.ReadOp.ReadOp(LitInt(a#20#0#0), Lit(a#20#1#0)) } 
  #PivotBetreeGraph.ReadOp.ReadOp(LitInt(a#20#0#0), Lit(a#20#1#0))
     == Lit(#PivotBetreeGraph.ReadOp.ReadOp(a#20#0#0, a#20#1#0)));

function PivotBetreeGraph.ReadOp.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#21#0#0: int, a#21#1#0: DatatypeType :: 
  { #PivotBetreeGraph.ReadOp.ReadOp(a#21#0#0, a#21#1#0) } 
  PivotBetreeGraph.ReadOp.ref(#PivotBetreeGraph.ReadOp.ReadOp(a#21#0#0, a#21#1#0))
     == a#21#0#0);

function PivotBetreeGraph.ReadOp.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#22#0#0: int, a#22#1#0: DatatypeType :: 
  { #PivotBetreeGraph.ReadOp.ReadOp(a#22#0#0, a#22#1#0) } 
  PivotBetreeGraph.ReadOp.node(#PivotBetreeGraph.ReadOp.ReadOp(a#22#0#0, a#22#1#0))
     == a#22#1#0);

// Inductive rank
axiom (forall a#23#0#0: int, a#23#1#0: DatatypeType :: 
  { #PivotBetreeGraph.ReadOp.ReadOp(a#23#0#0, a#23#1#0) } 
  DtRank(a#23#1#0) < DtRank(#PivotBetreeGraph.ReadOp.ReadOp(a#23#0#0, a#23#1#0)));

// Depth-one case-split function
function $IsA#PivotBetreeGraph.ReadOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeGraph.ReadOp(d) } 
  $IsA#PivotBetreeGraph.ReadOp(d) ==> PivotBetreeGraph.ReadOp.ReadOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeGraph.ReadOp.ReadOp_q(d), $Is(d, Tclass.PivotBetreeGraph.ReadOp()) } 
  $Is(d, Tclass.PivotBetreeGraph.ReadOp()) ==> PivotBetreeGraph.ReadOp.ReadOp_q(d));

// Datatype extensional equality declaration
function PivotBetreeGraph.ReadOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeGraph.ReadOp.ReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.ReadOp#Equal(a, b) } 
  true
     ==> (PivotBetreeGraph.ReadOp#Equal(a, b)
       <==> PivotBetreeGraph.ReadOp.ref(a) == PivotBetreeGraph.ReadOp.ref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeGraph.ReadOp.node(a), PivotBetreeGraph.ReadOp.node(b))));

// Datatype extensionality axiom: PivotBetreeGraph.ReadOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeGraph.ReadOp#Equal(a, b) } 
  PivotBetreeGraph.ReadOp#Equal(a, b) <==> a == b);

const unique class.PivotBetreeGraph.ReadOp: ClassName;

const unique class.Bounds.__default: ClassName;

function Tclass.Bounds.__default() : Ty;

// Tclass.Bounds.__default Tag
axiom Tag(Tclass.Bounds.__default()) == Tagclass.Bounds.__default;

const unique Tagclass.Bounds.__default: TyTag;

// Box/unbox axiom for Tclass.Bounds.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Bounds.__default()) } 
  $IsBox(bx, Tclass.Bounds.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Bounds.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Bounds.__default()) } 
  $Is($o, Tclass.Bounds.__default())
     <==> $o == null || dtype($o) == Tclass.Bounds.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Bounds.__default(), $h) } 
  $IsAlloc($o, Tclass.Bounds.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Bounds._default.NodeBlockSizeUint64
function Bounds.__default.NodeBlockSizeUint64() : int;

function Bounds.__default.NodeBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.NodeBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.NodeBlockSizeUint64()
     && Bounds.__default.NodeBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.NodeBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.NodeBlockSizeUint64
axiom Bounds.__default.NodeBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.NodeBlockSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)));

// definition axiom for Bounds.__default.NodeBlockSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)));

// function declaration for Bounds._default.MinNodeBlockIndexUint64
function Bounds.__default.MinNodeBlockIndexUint64() : int;

function Bounds.__default.MinNodeBlockIndexUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MinNodeBlockIndexUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MinNodeBlockIndexUint64()
     && Bounds.__default.MinNodeBlockIndexUint64() < 18446744073709551616;

function Bounds.__default.MinNodeBlockIndexUint64#requires() : bool;

// #requires axiom for Bounds.__default.MinNodeBlockIndexUint64
axiom Bounds.__default.MinNodeBlockIndexUint64#requires() == true;

// definition axiom for Bounds.__default.MinNodeBlockIndexUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && 
    Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.MinNodeBlockIndexUint64()
       == LitInt(Div(Mul(LitInt(2), LitInt(Bounds.__default.SuperblockSizeUint64()))
               + Mul(LitInt(Bounds.__default.DiskNumJournalBlocksUint64()), 
                LitInt(Bounds.__default.JournalBlockSizeUint64()))
               + Mul(LitInt(2), LitInt(Bounds.__default.IndirectionTableBlockSizeUint64()))
               + Bounds.__default.NodeBlockSizeUint64()
             - 1, 
          LitInt(Bounds.__default.NodeBlockSizeUint64())));

// definition axiom for Bounds.__default.MinNodeBlockIndexUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && 
    Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.MinNodeBlockIndexUint64()
       == LitInt(Div(Mul(LitInt(2), LitInt(Bounds.__default.SuperblockSizeUint64()))
               + Mul(LitInt(Bounds.__default.DiskNumJournalBlocksUint64()), 
                LitInt(Bounds.__default.JournalBlockSizeUint64()))
               + Mul(LitInt(2), LitInt(Bounds.__default.IndirectionTableBlockSizeUint64()))
               + Bounds.__default.NodeBlockSizeUint64()
             - 1, 
          LitInt(Bounds.__default.NodeBlockSizeUint64())));

// function declaration for Bounds._default.SuperblockSizeUint64
function Bounds.__default.SuperblockSizeUint64() : int;

function Bounds.__default.SuperblockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.SuperblockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.SuperblockSizeUint64()
     && Bounds.__default.SuperblockSizeUint64() < 18446744073709551616;

function Bounds.__default.SuperblockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.SuperblockSizeUint64
axiom Bounds.__default.SuperblockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.SuperblockSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.SuperblockSizeUint64() == LitInt(4096);

// definition axiom for Bounds.__default.SuperblockSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.SuperblockSizeUint64() == LitInt(4096);

// function declaration for Bounds._default.JournalBlockSizeUint64
function Bounds.__default.JournalBlockSizeUint64() : int;

function Bounds.__default.JournalBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.JournalBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.JournalBlockSizeUint64()
     && Bounds.__default.JournalBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.JournalBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.JournalBlockSizeUint64
axiom Bounds.__default.JournalBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.JournalBlockSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.JournalBlockSizeUint64() == LitInt(4096);

// definition axiom for Bounds.__default.JournalBlockSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.JournalBlockSizeUint64() == LitInt(4096);

// function declaration for Bounds._default.DiskNumJournalBlocksUint64
function Bounds.__default.DiskNumJournalBlocksUint64() : int;

function Bounds.__default.DiskNumJournalBlocksUint64#canCall() : bool;

// consequence axiom for Bounds.__default.DiskNumJournalBlocksUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.DiskNumJournalBlocksUint64()
     && Bounds.__default.DiskNumJournalBlocksUint64() < 18446744073709551616;

function Bounds.__default.DiskNumJournalBlocksUint64#requires() : bool;

// #requires axiom for Bounds.__default.DiskNumJournalBlocksUint64
axiom Bounds.__default.DiskNumJournalBlocksUint64#requires() == true;

// definition axiom for Bounds.__default.DiskNumJournalBlocksUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64()
     == LitInt(Mul(LitInt(64), LitInt(1024)));

// definition axiom for Bounds.__default.DiskNumJournalBlocksUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64()
     == LitInt(Mul(LitInt(64), LitInt(1024)));

// function declaration for Bounds._default.IndirectionTableBlockSizeUint64
function Bounds.__default.IndirectionTableBlockSizeUint64() : int;

function Bounds.__default.IndirectionTableBlockSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableBlockSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.IndirectionTableBlockSizeUint64()
     && Bounds.__default.IndirectionTableBlockSizeUint64() < 18446744073709551616;

function Bounds.__default.IndirectionTableBlockSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableBlockSizeUint64
axiom Bounds.__default.IndirectionTableBlockSizeUint64#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableBlockSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(24), LitInt(1024))), LitInt(1024)));

// definition axiom for Bounds.__default.IndirectionTableBlockSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(24), LitInt(1024))), LitInt(1024)));

// function declaration for Bounds._default.LargestBlockSizeOfAnyTypeUint64
function Bounds.__default.LargestBlockSizeOfAnyTypeUint64() : int;

function Bounds.__default.LargestBlockSizeOfAnyTypeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64
axiom true
   ==> 
  true
   ==> LitInt(Bounds.__default.IndirectionTableBlockSizeUint64())
       <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && LitInt(Bounds.__default.NodeBlockSizeUint64())
       <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && 
    LitInt(0) <= Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64() < 18446744073709551616;

function Bounds.__default.LargestBlockSizeOfAnyTypeUint64#requires() : bool;

// #requires axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64
axiom Bounds.__default.LargestBlockSizeOfAnyTypeUint64#requires() == true;

// definition axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for Bounds.__default.LargestBlockSizeOfAnyTypeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.LargestBlockSizeOfAnyTypeUint64()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for Bounds._default.MaxTotalBucketWeightUint64
function Bounds.__default.MaxTotalBucketWeightUint64() : int;

function Bounds.__default.MaxTotalBucketWeightUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxTotalBucketWeightUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxTotalBucketWeightUint64()
     && Bounds.__default.MaxTotalBucketWeightUint64() < 18446744073709551616;

function Bounds.__default.MaxTotalBucketWeightUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxTotalBucketWeightUint64
axiom Bounds.__default.MaxTotalBucketWeightUint64#requires() == true;

// definition axiom for Bounds.__default.MaxTotalBucketWeightUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)) - 65536);

// definition axiom for Bounds.__default.MaxTotalBucketWeightUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64()
     == LitInt(Mul(LitInt(Mul(LitInt(2), LitInt(1024))), LitInt(1024)) - 65536);

// function declaration for Bounds._default.MaxCacheSizeUint64
function Bounds.__default.MaxCacheSizeUint64() : int;

function Bounds.__default.MaxCacheSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxCacheSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxCacheSizeUint64()
     && Bounds.__default.MaxCacheSizeUint64() < 18446744073709551616;

function Bounds.__default.MaxCacheSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxCacheSizeUint64
axiom Bounds.__default.MaxCacheSizeUint64#requires() == true;

// definition axiom for Bounds.__default.MaxCacheSizeUint64(revealed)
axiom true ==> true ==> Bounds.__default.MaxCacheSizeUint64() == LitInt(100);

// definition axiom for Bounds.__default.MaxCacheSizeUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.MaxCacheSizeUint64() == LitInt(100);

// function declaration for Bounds._default.MaxNumChildrenUint64
function Bounds.__default.MaxNumChildrenUint64() : int;

function Bounds.__default.MaxNumChildrenUint64#canCall() : bool;

// consequence axiom for Bounds.__default.MaxNumChildrenUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.MaxNumChildrenUint64()
     && Bounds.__default.MaxNumChildrenUint64() < 18446744073709551616;

function Bounds.__default.MaxNumChildrenUint64#requires() : bool;

// #requires axiom for Bounds.__default.MaxNumChildrenUint64
axiom Bounds.__default.MaxNumChildrenUint64#requires() == true;

// definition axiom for Bounds.__default.MaxNumChildrenUint64(revealed)
axiom true ==> true ==> Bounds.__default.MaxNumChildrenUint64() == LitInt(8);

// definition axiom for Bounds.__default.MaxNumChildrenUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.MaxNumChildrenUint64() == LitInt(8);

// function declaration for Bounds._default.FlushTriggerWeightUint64
function Bounds.__default.FlushTriggerWeightUint64() : int;

function Bounds.__default.FlushTriggerWeightUint64#canCall() : bool;

// consequence axiom for Bounds.__default.FlushTriggerWeightUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.FlushTriggerWeightUint64()
     && Bounds.__default.FlushTriggerWeightUint64() < 18446744073709551616;

function Bounds.__default.FlushTriggerWeightUint64#requires() : bool;

// #requires axiom for Bounds.__default.FlushTriggerWeightUint64
axiom Bounds.__default.FlushTriggerWeightUint64#requires() == true;

// definition axiom for Bounds.__default.FlushTriggerWeightUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeightUint64()
       == LitInt(Div(Bounds.__default.MaxTotalBucketWeightUint64(), LitInt(8)));

// definition axiom for Bounds.__default.FlushTriggerWeightUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeightUint64()
       == LitInt(Div(Bounds.__default.MaxTotalBucketWeightUint64(), LitInt(8)));

// function declaration for Bounds._default.NumBlocksUint64
function Bounds.__default.NumBlocksUint64() : int;

function Bounds.__default.NumBlocksUint64#canCall() : bool;

// consequence axiom for Bounds.__default.NumBlocksUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.NumBlocksUint64()
     && Bounds.__default.NumBlocksUint64() < 18446744073709551616;

function Bounds.__default.NumBlocksUint64#requires() : bool;

// #requires axiom for Bounds.__default.NumBlocksUint64
axiom Bounds.__default.NumBlocksUint64#requires() == true;

// definition axiom for Bounds.__default.NumBlocksUint64(revealed)
axiom true ==> true ==> Bounds.__default.NumBlocksUint64() == LitInt(1048576);

// definition axiom for Bounds.__default.NumBlocksUint64 for all literals(revealed)
axiom true ==> true ==> Bounds.__default.NumBlocksUint64() == LitInt(1048576);

// function declaration for Bounds._default.IndirectionTableMaxSizeUint64
function Bounds.__default.IndirectionTableMaxSizeUint64() : int;

function Bounds.__default.IndirectionTableMaxSizeUint64#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableMaxSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= Bounds.__default.IndirectionTableMaxSizeUint64()
     && Bounds.__default.IndirectionTableMaxSizeUint64() < 18446744073709551616;

function Bounds.__default.IndirectionTableMaxSizeUint64#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableMaxSizeUint64
axiom Bounds.__default.IndirectionTableMaxSizeUint64#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableMaxSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64() == LitInt(4294967296);

// definition axiom for Bounds.__default.IndirectionTableMaxSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64() == LitInt(4294967296);

// function declaration for Bounds._default.SuperblockSize
function Bounds.__default.SuperblockSize() : int;

function Bounds.__default.SuperblockSize#canCall() : bool;

// consequence axiom for Bounds.__default.SuperblockSize
axiom true ==> true ==> true;

function Bounds.__default.SuperblockSize#requires() : bool;

// #requires axiom for Bounds.__default.SuperblockSize
axiom Bounds.__default.SuperblockSize#requires() == true;

// definition axiom for Bounds.__default.SuperblockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && Bounds.__default.SuperblockSize()
       == LitInt(Bounds.__default.SuperblockSizeUint64());

// definition axiom for Bounds.__default.SuperblockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.SuperblockSizeUint64#canCall()
     && Bounds.__default.SuperblockSize()
       == LitInt(Bounds.__default.SuperblockSizeUint64());

// function declaration for Bounds._default.IndirectionTableBlockSize
function Bounds.__default.IndirectionTableBlockSize() : int;

function Bounds.__default.IndirectionTableBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableBlockSize
axiom true ==> true ==> true;

function Bounds.__default.IndirectionTableBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableBlockSize
axiom Bounds.__default.IndirectionTableBlockSize#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSize()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for Bounds.__default.IndirectionTableBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && Bounds.__default.IndirectionTableBlockSize()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for Bounds._default.NodeBlockSize
function Bounds.__default.NodeBlockSize() : int;

function Bounds.__default.NodeBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.NodeBlockSize
axiom true ==> true ==> true;

function Bounds.__default.NodeBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.NodeBlockSize
axiom Bounds.__default.NodeBlockSize#requires() == true;

// definition axiom for Bounds.__default.NodeBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSize()
       == LitInt(Bounds.__default.NodeBlockSizeUint64());

// definition axiom for Bounds.__default.NodeBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NodeBlockSizeUint64#canCall()
     && Bounds.__default.NodeBlockSize()
       == LitInt(Bounds.__default.NodeBlockSizeUint64());

// function declaration for Bounds._default.MinNodeBlockIndex
function Bounds.__default.MinNodeBlockIndex() : int;

function Bounds.__default.MinNodeBlockIndex#canCall() : bool;

// consequence axiom for Bounds.__default.MinNodeBlockIndex
axiom true ==> true ==> true;

function Bounds.__default.MinNodeBlockIndex#requires() : bool;

// #requires axiom for Bounds.__default.MinNodeBlockIndex
axiom Bounds.__default.MinNodeBlockIndex#requires() == true;

// definition axiom for Bounds.__default.MinNodeBlockIndex(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MinNodeBlockIndexUint64#canCall()
     && Bounds.__default.MinNodeBlockIndex()
       == LitInt(Bounds.__default.MinNodeBlockIndexUint64());

// definition axiom for Bounds.__default.MinNodeBlockIndex for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MinNodeBlockIndexUint64#canCall()
     && Bounds.__default.MinNodeBlockIndex()
       == LitInt(Bounds.__default.MinNodeBlockIndexUint64());

// function declaration for Bounds._default.MaxNumChildren
function Bounds.__default.MaxNumChildren() : int;

function Bounds.__default.MaxNumChildren#canCall() : bool;

// consequence axiom for Bounds.__default.MaxNumChildren
axiom true ==> true ==> true;

function Bounds.__default.MaxNumChildren#requires() : bool;

// #requires axiom for Bounds.__default.MaxNumChildren
axiom Bounds.__default.MaxNumChildren#requires() == true;

// definition axiom for Bounds.__default.MaxNumChildren(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxNumChildrenUint64#canCall()
     && Bounds.__default.MaxNumChildren()
       == LitInt(Bounds.__default.MaxNumChildrenUint64());

// definition axiom for Bounds.__default.MaxNumChildren for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxNumChildrenUint64#canCall()
     && Bounds.__default.MaxNumChildren()
       == LitInt(Bounds.__default.MaxNumChildrenUint64());

// function declaration for Bounds._default.MaxTotalBucketWeight
function Bounds.__default.MaxTotalBucketWeight() : int;

function Bounds.__default.MaxTotalBucketWeight#canCall() : bool;

// consequence axiom for Bounds.__default.MaxTotalBucketWeight
axiom true ==> true ==> true;

function Bounds.__default.MaxTotalBucketWeight#requires() : bool;

// #requires axiom for Bounds.__default.MaxTotalBucketWeight
axiom Bounds.__default.MaxTotalBucketWeight#requires() == true;

// definition axiom for Bounds.__default.MaxTotalBucketWeight(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.MaxTotalBucketWeight()
       == LitInt(Bounds.__default.MaxTotalBucketWeightUint64());

// definition axiom for Bounds.__default.MaxTotalBucketWeight for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxTotalBucketWeightUint64#canCall()
     && Bounds.__default.MaxTotalBucketWeight()
       == LitInt(Bounds.__default.MaxTotalBucketWeightUint64());

// function declaration for Bounds._default.MaxCacheSize
function Bounds.__default.MaxCacheSize() : int;

function Bounds.__default.MaxCacheSize#canCall() : bool;

// consequence axiom for Bounds.__default.MaxCacheSize
axiom true ==> true ==> true;

function Bounds.__default.MaxCacheSize#requires() : bool;

// #requires axiom for Bounds.__default.MaxCacheSize
axiom Bounds.__default.MaxCacheSize#requires() == true;

// definition axiom for Bounds.__default.MaxCacheSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxCacheSizeUint64#canCall()
     && Bounds.__default.MaxCacheSize() == LitInt(Bounds.__default.MaxCacheSizeUint64());

// definition axiom for Bounds.__default.MaxCacheSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.MaxCacheSizeUint64#canCall()
     && Bounds.__default.MaxCacheSize() == LitInt(Bounds.__default.MaxCacheSizeUint64());

// function declaration for Bounds._default.FlushTriggerWeight
function Bounds.__default.FlushTriggerWeight() : int;

function Bounds.__default.FlushTriggerWeight#canCall() : bool;

// consequence axiom for Bounds.__default.FlushTriggerWeight
axiom true ==> true ==> true;

function Bounds.__default.FlushTriggerWeight#requires() : bool;

// #requires axiom for Bounds.__default.FlushTriggerWeight
axiom Bounds.__default.FlushTriggerWeight#requires() == true;

// definition axiom for Bounds.__default.FlushTriggerWeight(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.FlushTriggerWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeight()
       == LitInt(Bounds.__default.FlushTriggerWeightUint64());

// definition axiom for Bounds.__default.FlushTriggerWeight for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.FlushTriggerWeightUint64#canCall()
     && Bounds.__default.FlushTriggerWeight()
       == LitInt(Bounds.__default.FlushTriggerWeightUint64());

// function declaration for Bounds._default.NumBlocks
function Bounds.__default.NumBlocks() : int;

function Bounds.__default.NumBlocks#canCall() : bool;

// consequence axiom for Bounds.__default.NumBlocks
axiom true ==> true ==> true;

function Bounds.__default.NumBlocks#requires() : bool;

// #requires axiom for Bounds.__default.NumBlocks
axiom Bounds.__default.NumBlocks#requires() == true;

// definition axiom for Bounds.__default.NumBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NumBlocksUint64#canCall()
     && Bounds.__default.NumBlocks() == LitInt(Bounds.__default.NumBlocksUint64());

// definition axiom for Bounds.__default.NumBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.NumBlocksUint64#canCall()
     && Bounds.__default.NumBlocks() == LitInt(Bounds.__default.NumBlocksUint64());

// function declaration for Bounds._default.IndirectionTableMaxSize
function Bounds.__default.IndirectionTableMaxSize() : int;

function Bounds.__default.IndirectionTableMaxSize#canCall() : bool;

// consequence axiom for Bounds.__default.IndirectionTableMaxSize
axiom true ==> true ==> true;

function Bounds.__default.IndirectionTableMaxSize#requires() : bool;

// #requires axiom for Bounds.__default.IndirectionTableMaxSize
axiom Bounds.__default.IndirectionTableMaxSize#requires() == true;

// definition axiom for Bounds.__default.IndirectionTableMaxSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && Bounds.__default.IndirectionTableMaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// definition axiom for Bounds.__default.IndirectionTableMaxSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && Bounds.__default.IndirectionTableMaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// function declaration for Bounds._default.JournalBlockSize
function Bounds.__default.JournalBlockSize() : int;

function Bounds.__default.JournalBlockSize#canCall() : bool;

// consequence axiom for Bounds.__default.JournalBlockSize
axiom true ==> true ==> true;

function Bounds.__default.JournalBlockSize#requires() : bool;

// #requires axiom for Bounds.__default.JournalBlockSize
axiom Bounds.__default.JournalBlockSize#requires() == true;

// definition axiom for Bounds.__default.JournalBlockSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.JournalBlockSize()
       == LitInt(Bounds.__default.JournalBlockSizeUint64());

// definition axiom for Bounds.__default.JournalBlockSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.JournalBlockSizeUint64#canCall()
     && Bounds.__default.JournalBlockSize()
       == LitInt(Bounds.__default.JournalBlockSizeUint64());

// function declaration for Bounds._default.DiskNumJournalBlocks
function Bounds.__default.DiskNumJournalBlocks() : int;

function Bounds.__default.DiskNumJournalBlocks#canCall() : bool;

// consequence axiom for Bounds.__default.DiskNumJournalBlocks
axiom true ==> true ==> true;

function Bounds.__default.DiskNumJournalBlocks#requires() : bool;

// #requires axiom for Bounds.__default.DiskNumJournalBlocks
axiom Bounds.__default.DiskNumJournalBlocks#requires() == true;

// definition axiom for Bounds.__default.DiskNumJournalBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.DiskNumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// definition axiom for Bounds.__default.DiskNumJournalBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && Bounds.__default.DiskNumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

const unique class.BucketWeights.__default: ClassName;

function Tclass.BucketWeights.__default() : Ty;

// Tclass.BucketWeights.__default Tag
axiom Tag(Tclass.BucketWeights.__default()) == Tagclass.BucketWeights.__default;

const unique Tagclass.BucketWeights.__default: TyTag;

// Box/unbox axiom for Tclass.BucketWeights.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BucketWeights.__default()) } 
  $IsBox(bx, Tclass.BucketWeights.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BucketWeights.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BucketWeights.__default()) } 
  $Is($o, Tclass.BucketWeights.__default())
     <==> $o == null || dtype($o) == Tclass.BucketWeights.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BucketWeights.__default(), $h) } 
  $IsAlloc($o, Tclass.BucketWeights.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BucketWeights._default.WeightKey
function BucketWeights.__default.WeightKey(key#0: Seq Box) : int;

function BucketWeights.__default.WeightKey#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightKey
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKey(key#0) } 
    BucketWeights.__default.WeightKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKey(key#0) >= LitInt(0)
         && LitInt(0) <= BucketWeights.__default.WeightKey(key#0));

function BucketWeights.__default.WeightKey#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKey
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.WeightKey#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.WeightKey#requires(key#0) == true);

// definition axiom for BucketWeights.__default.WeightKey(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKey(key#0) } 
    BucketWeights.__default.WeightKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKey(key#0) == 4 + Seq#Length(key#0));

// definition axiom for BucketWeights.__default.WeightKey for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKey(Lit(key#0)) } 
    BucketWeights.__default.WeightKey#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKey(Lit(key#0)) == 4 + Seq#Length(Lit(key#0)));

// function declaration for BucketWeights._default.WeightMessage
function BucketWeights.__default.WeightMessage(msg#0: DatatypeType) : int;

function BucketWeights.__default.WeightMessage#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for BucketWeights.__default.WeightMessage
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessage(msg#0) } 
    BucketWeights.__default.WeightMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessage(msg#0) >= LitInt(0)
         && LitInt(0) <= BucketWeights.__default.WeightMessage(msg#0));

function BucketWeights.__default.WeightMessage#requires(DatatypeType) : bool;

// #requires axiom for BucketWeights.__default.WeightMessage
axiom (forall msg#0: DatatypeType :: 
  { BucketWeights.__default.WeightMessage#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketWeights.__default.WeightMessage#requires(msg#0) == true);

// definition axiom for BucketWeights.__default.WeightMessage(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessage(msg#0) } 
    BucketWeights.__default.WeightMessage#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> (ValueMessage.Message.Define_q(msg#0)
           ==> (var value#0 := ValueMessage.Message.value(msg#0); 
            ValueType.__default.Len#canCall(value#0)))
         && BucketWeights.__default.WeightMessage(msg#0)
           == (if ValueMessage.Message.Define_q(msg#0)
             then (var value#1 := ValueMessage.Message.value(msg#0); 
              4 + ValueType.__default.Len(value#1))
             else (var delta#1 := ValueMessage.Message.delta(msg#0); LitInt(0))));

// definition axiom for BucketWeights.__default.WeightMessage for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { BucketWeights.__default.WeightMessage(Lit(msg#0)) } 
    BucketWeights.__default.WeightMessage#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> (Lit(ValueMessage.Message.Define_q(Lit(msg#0)))
           ==> (var value#2 := Lit(ValueMessage.Message.value(Lit(msg#0))); 
            ValueType.__default.Len#canCall(value#2)))
         && BucketWeights.__default.WeightMessage(Lit(msg#0))
           == (if ValueMessage.Message.Define_q(Lit(msg#0))
             then (var value#3 := Lit(ValueMessage.Message.value(Lit(msg#0))); 
              LitInt(4 + ValueType.__default.Len(value#3)))
             else (var delta#3 := Lit(ValueMessage.Message.delta(Lit(msg#0))); LitInt(0))));

// function declaration for BucketWeights._default.WeightKeyUint64
function BucketWeights.__default.WeightKeyUint64(key#0: Seq Box) : int;

function BucketWeights.__default.WeightKeyUint64#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightKeyUint64
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyUint64(key#0) } 
    BucketWeights.__default.WeightKeyUint64#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKeyUint64(key#0)
           == BucketWeights.__default.WeightKey(key#0)
         && 
        LitInt(0) <= BucketWeights.__default.WeightKeyUint64(key#0)
         && BucketWeights.__default.WeightKeyUint64(key#0) < 18446744073709551616);

function BucketWeights.__default.WeightKeyUint64#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeyUint64
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.WeightKeyUint64#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.WeightKeyUint64#requires(key#0) == true);

// definition axiom for BucketWeights.__default.WeightKeyUint64(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyUint64(key#0) } 
    BucketWeights.__default.WeightKeyUint64#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKeyUint64(key#0) == 4 + Seq#Length(key#0));

// definition axiom for BucketWeights.__default.WeightKeyUint64 for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeyUint64(Lit(key#0)) } 
    BucketWeights.__default.WeightKeyUint64#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.WeightKeyUint64(Lit(key#0))
         == 4 + Seq#Length(Lit(key#0)));

// function declaration for BucketWeights._default.WeightMessageUint64
function BucketWeights.__default.WeightMessageUint64(msg#0: DatatypeType) : int;

function BucketWeights.__default.WeightMessageUint64#canCall(msg#0: DatatypeType) : bool;

// consequence axiom for BucketWeights.__default.WeightMessageUint64
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessageUint64(msg#0) } 
    BucketWeights.__default.WeightMessageUint64#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessageUint64(msg#0)
           == BucketWeights.__default.WeightMessage(msg#0)
         && 
        LitInt(0) <= BucketWeights.__default.WeightMessageUint64(msg#0)
         && BucketWeights.__default.WeightMessageUint64(msg#0) < 18446744073709551616);

function BucketWeights.__default.WeightMessageUint64#requires(DatatypeType) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageUint64
axiom (forall msg#0: DatatypeType :: 
  { BucketWeights.__default.WeightMessageUint64#requires(msg#0) } 
  $Is(msg#0, Tclass.ValueMessage.Message())
     ==> BucketWeights.__default.WeightMessageUint64#requires(msg#0) == true);

// definition axiom for BucketWeights.__default.WeightMessageUint64(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    { BucketWeights.__default.WeightMessageUint64(msg#0) } 
    BucketWeights.__default.WeightMessageUint64#canCall(msg#0)
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessageUint64(msg#0)
         == (if ValueMessage.Message.Define_q(msg#0)
           then (var value#1 := ValueMessage.Message.value(msg#0); 4 + Seq#Length(value#1))
           else (var delta#1 := ValueMessage.Message.delta(msg#0); LitInt(0))));

// definition axiom for BucketWeights.__default.WeightMessageUint64 for all literals(revealed)
axiom true
   ==> (forall msg#0: DatatypeType :: 
    {:weight 3} { BucketWeights.__default.WeightMessageUint64(Lit(msg#0)) } 
    BucketWeights.__default.WeightMessageUint64#canCall(Lit(msg#0))
         || $Is(msg#0, Tclass.ValueMessage.Message())
       ==> BucketWeights.__default.WeightMessageUint64(Lit(msg#0))
         == (if ValueMessage.Message.Define_q(Lit(msg#0))
           then (var value#3 := Lit(ValueMessage.Message.value(Lit(msg#0))); 
            4 + Seq#Length(value#3))
           else (var delta#3 := Lit(ValueMessage.Message.delta(Lit(msg#0))); LitInt(0))));

// function declaration for BucketWeights._default.WeightKeyMultiset
function BucketWeights.__default.WeightKeyMultiset($ly: LayerType, keys#0: MultiSet Box) : int;

function BucketWeights.__default.WeightKeyMultiset#canCall(keys#0: MultiSet Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: MultiSet Box :: 
  { BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0) } 
  BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0)
     == BucketWeights.__default.WeightKeyMultiset($ly, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: MultiSet Box :: 
  { BucketWeights.__default.WeightKeyMultiset(AsFuelBottom($ly), keys#0) } 
  BucketWeights.__default.WeightKeyMultiset($ly, keys#0)
     == BucketWeights.__default.WeightKeyMultiset($LZ, keys#0));

// consequence axiom for BucketWeights.__default.WeightKeyMultiset
axiom true
   ==> (forall $ly: LayerType, keys#0: MultiSet Box :: 
    { BucketWeights.__default.WeightKeyMultiset($ly, keys#0) } 
    BucketWeights.__default.WeightKeyMultiset#canCall(keys#0)
         || $Is(keys#0, TMultiSet(Tclass.KeyType.Key()))
       ==> (MultiSet#Card(keys#0) == LitInt(0)
           ==> BucketWeights.__default.WeightKeyMultiset($ly, keys#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightKeyMultiset($ly, keys#0));

function BucketWeights.__default.WeightKeyMultiset#requires(LayerType, MultiSet Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeyMultiset
axiom (forall $ly: LayerType, $Heap: Heap, keys#0: MultiSet Box :: 
  { BucketWeights.__default.WeightKeyMultiset#requires($ly, keys#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(keys#0, TMultiSet(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.WeightKeyMultiset#requires($ly, keys#0) == true);

function BucketWeights.__default.WeightKey#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0) } 
  Apply1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)
     == $Box(BucketWeights.__default.WeightKey($Unbox($fh$0x#0): Seq Box)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0) } 
  Requires1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)
     == BucketWeights.__default.WeightKey#requires($Unbox($fh$0x#0): Seq Box));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.KeyType.Key(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightKey#Handle(), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: Seq Box :: 
  { BucketWeights.__default.WeightKey($fh$0x#0), $IsGoodHeap($heap) } 
  BucketWeights.__default.WeightKey($fh$0x#0)
     == $Unbox(Apply1(Tclass.KeyType.Key(), 
        Tclass._System.nat(), 
        $heap, 
        BucketWeights.__default.WeightKey#Handle(), 
        $Box($fh$0x#0))): int);

function Multisets.__default.AddNat#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Apply2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Apply2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == $Box(Multisets.__default.AddNat($Unbox($fh$0x#0): int, $Unbox($fh$0x#1): int)));

axiom (forall $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Requires2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1) } 
  Requires2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)
     == Multisets.__default.AddNat#requires($Unbox($fh$0x#0): int, $Unbox($fh$0x#1): int));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box, $fh$0x#1: Box :: 
  { Reads2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx] } 
  Reads2(Tclass._System.nat(), 
      Tclass._System.nat(), 
      Tclass._System.nat(), 
      $heap, 
      Multisets.__default.AddNat#Handle(), 
      $fh$0x#0, 
      $fh$0x#1)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: int, $fh$0x#1: int :: 
  { Multisets.__default.AddNat($fh$0x#0, $fh$0x#1), $IsGoodHeap($heap) } 
  Multisets.__default.AddNat($fh$0x#0, $fh$0x#1)
     == $Unbox(Apply2(Tclass._System.nat(), 
        Tclass._System.nat(), 
        Tclass._System.nat(), 
        $heap, 
        Multisets.__default.AddNat#Handle(), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1))): int);

// definition axiom for BucketWeights.__default.WeightKeyMultiset(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: MultiSet Box :: 
    { BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeyMultiset#canCall(keys#0)
         || ($IsGoodHeap($Heap) && $Is(keys#0, TMultiSet(Tclass.KeyType.Key())))
       ==> Multisets.__default.Apply#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          keys#0)
         && (var weights#0 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              keys#0); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#0))
         && BucketWeights.__default.WeightKeyMultiset($LS($ly), keys#0)
           == (var weights#0 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                keys#0); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightKeyMultiset for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: MultiSet Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeyMultiset($LS($ly), Lit(keys#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeyMultiset#canCall(Lit(keys#0))
         || ($IsGoodHeap($Heap) && $Is(keys#0, TMultiSet(Tclass.KeyType.Key())))
       ==> Multisets.__default.Apply#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          Lit(keys#0))
         && (var weights#1 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              Lit(keys#0)); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#1))
         && BucketWeights.__default.WeightKeyMultiset($LS($ly), Lit(keys#0))
           == (var weights#1 := Multisets.__default.Apply(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                Lit(keys#0)); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightKeySeq
function BucketWeights.__default.WeightKeySeq($ly: LayerType, keys#0: Seq Box) : int;

function BucketWeights.__default.WeightKeySeq#canCall(keys#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeySeq($LS($ly), keys#0) } 
  BucketWeights.__default.WeightKeySeq($LS($ly), keys#0)
     == BucketWeights.__default.WeightKeySeq($ly, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeySeq(AsFuelBottom($ly), keys#0) } 
  BucketWeights.__default.WeightKeySeq($ly, keys#0)
     == BucketWeights.__default.WeightKeySeq($LZ, keys#0));

// consequence axiom for BucketWeights.__default.WeightKeySeq
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeySeq($ly, keys#0) } 
    BucketWeights.__default.WeightKeySeq#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> LitInt(0) <= BucketWeights.__default.WeightKeySeq($ly, keys#0));

function BucketWeights.__default.WeightKeySeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeySeq
axiom (forall $ly: LayerType, $Heap: Heap, keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeySeq#requires($ly, keys#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(keys#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.WeightKeySeq#requires($ly, keys#0) == true);

// definition axiom for BucketWeights.__default.WeightKeySeq(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeySeq($LS($ly), keys#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeySeq#canCall(keys#0)
         || ($IsGoodHeap($Heap) && $Is(keys#0, TSeq(Tclass.KeyType.Key())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          keys#0)
         && (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              keys#0); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#0))
         && BucketWeights.__default.WeightKeySeq($LS($ly), keys#0)
           == (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                keys#0); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightKeySeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, keys#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeySeq($LS($ly), Lit(keys#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightKeySeq#canCall(Lit(keys#0))
         || ($IsGoodHeap($Heap) && $Is(keys#0, TSeq(Tclass.KeyType.Key())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.KeyType.Key(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightKey#Handle(), 
          Lit(keys#0))
         && (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightKey#Handle(), 
              Lit(keys#0)); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#1))
         && BucketWeights.__default.WeightKeySeq($LS($ly), Lit(keys#0))
           == (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.KeyType.Key(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightKey#Handle(), 
                Lit(keys#0)); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightMessageMultiset
function BucketWeights.__default.WeightMessageMultiset($ly: LayerType, msgs#0: MultiSet Box) : int;

function BucketWeights.__default.WeightMessageMultiset#canCall(msgs#0: MultiSet Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: MultiSet Box :: 
  { BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0)
     == BucketWeights.__default.WeightMessageMultiset($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: MultiSet Box :: 
  { BucketWeights.__default.WeightMessageMultiset(AsFuelBottom($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageMultiset($ly, msgs#0)
     == BucketWeights.__default.WeightMessageMultiset($LZ, msgs#0));

// consequence axiom for BucketWeights.__default.WeightMessageMultiset
axiom true
   ==> (forall $ly: LayerType, msgs#0: MultiSet Box :: 
    { BucketWeights.__default.WeightMessageMultiset($ly, msgs#0) } 
    BucketWeights.__default.WeightMessageMultiset#canCall(msgs#0)
         || $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message()))
       ==> (MultiSet#Card(msgs#0) == LitInt(0)
           ==> BucketWeights.__default.WeightMessageMultiset($ly, msgs#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightMessageMultiset($ly, msgs#0));

function BucketWeights.__default.WeightMessageMultiset#requires(LayerType, MultiSet Box) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageMultiset
axiom (forall $ly: LayerType, $Heap: Heap, msgs#0: MultiSet Box :: 
  { BucketWeights.__default.WeightMessageMultiset#requires($ly, msgs#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message()))
     ==> BucketWeights.__default.WeightMessageMultiset#requires($ly, msgs#0) == true);

function BucketWeights.__default.WeightMessage#Handle() : HandleType;

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Apply1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0) } 
  Apply1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)
     == $Box(BucketWeights.__default.WeightMessage($Unbox($fh$0x#0): DatatypeType)));

axiom (forall $heap: Heap, $fh$0x#0: Box :: 
  { Requires1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0) } 
  Requires1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)
     == BucketWeights.__default.WeightMessage#requires($Unbox($fh$0x#0): DatatypeType));

axiom (forall $bx: Box, $heap: Heap, $fh$0x#0: Box :: 
  { Reads1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)[$bx] } 
  Reads1(Tclass.ValueMessage.Message(), 
      Tclass._System.nat(), 
      $heap, 
      BucketWeights.__default.WeightMessage#Handle(), 
      $fh$0x#0)[$bx]
     == false);

axiom (forall $heap: Heap, $fh$0x#0: DatatypeType :: 
  { BucketWeights.__default.WeightMessage($fh$0x#0), $IsGoodHeap($heap) } 
  BucketWeights.__default.WeightMessage($fh$0x#0)
     == $Unbox(Apply1(Tclass.ValueMessage.Message(), 
        Tclass._System.nat(), 
        $heap, 
        BucketWeights.__default.WeightMessage#Handle(), 
        $Box($fh$0x#0))): int);

// definition axiom for BucketWeights.__default.WeightMessageMultiset(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: MultiSet Box :: 
    { BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageMultiset#canCall(msgs#0)
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message())))
       ==> Multisets.__default.Apply#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          msgs#0)
         && (var weights#0 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              msgs#0); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#0))
         && BucketWeights.__default.WeightMessageMultiset($LS($ly), msgs#0)
           == (var weights#0 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                msgs#0); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightMessageMultiset for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: MultiSet Box :: 
    {:weight 3} { BucketWeights.__default.WeightMessageMultiset($LS($ly), Lit(msgs#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageMultiset#canCall(Lit(msgs#0))
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TMultiSet(Tclass.ValueMessage.Message())))
       ==> Multisets.__default.Apply#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          Lit(msgs#0))
         && (var weights#1 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Multisets._default.Apply, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              Lit(msgs#0)); 
          Multisets.__default.FoldSimple#canCall(Tclass._System.nat(), 
            $Box(LitInt(0)), 
            Multisets.__default.AddNat#Handle(), 
            weights#1))
         && BucketWeights.__default.WeightMessageMultiset($LS($ly), Lit(msgs#0))
           == (var weights#1 := Multisets.__default.Apply(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Multisets._default.Apply, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                Lit(msgs#0)); 
            $Unbox(Multisets.__default.FoldSimple(Tclass._System.nat(), 
                $Box(LitInt(0)), 
                Multisets.__default.AddNat#Handle(), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightMessageSeq
function BucketWeights.__default.WeightMessageSeq($ly: LayerType, msgs#0: Seq Box) : int;

function BucketWeights.__default.WeightMessageSeq#canCall(msgs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0)
     == BucketWeights.__default.WeightMessageSeq($ly, msgs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageSeq(AsFuelBottom($ly), msgs#0) } 
  BucketWeights.__default.WeightMessageSeq($ly, msgs#0)
     == BucketWeights.__default.WeightMessageSeq($LZ, msgs#0));

// consequence axiom for BucketWeights.__default.WeightMessageSeq
axiom true
   ==> (forall $ly: LayerType, msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageSeq($ly, msgs#0) } 
    BucketWeights.__default.WeightMessageSeq#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> LitInt(0) <= BucketWeights.__default.WeightMessageSeq($ly, msgs#0));

function BucketWeights.__default.WeightMessageSeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageSeq
axiom (forall $ly: LayerType, $Heap: Heap, msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageSeq#requires($ly, msgs#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketWeights.__default.WeightMessageSeq#requires($ly, msgs#0) == true);

// definition axiom for BucketWeights.__default.WeightMessageSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageSeq#canCall(msgs#0)
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          msgs#0)
         && (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              msgs#0); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#0))
         && BucketWeights.__default.WeightMessageSeq($LS($ly), msgs#0)
           == (var weights#0 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                msgs#0); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#0)): int));

// definition axiom for BucketWeights.__default.WeightMessageSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, msgs#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightMessageSeq($LS($ly), Lit(msgs#0)), $IsGoodHeap($Heap) } 
    BucketWeights.__default.WeightMessageSeq#canCall(Lit(msgs#0))
         || ($IsGoodHeap($Heap) && $Is(msgs#0, TSeq(Tclass.ValueMessage.Message())))
       ==> Sequences.__default.ApplyOpaque#canCall(Tclass.ValueMessage.Message(), 
          Tclass._System.nat(), 
          $Heap, 
          BucketWeights.__default.WeightMessage#Handle(), 
          Lit(msgs#0))
         && (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
              Tclass._System.nat(), 
              StartFuel_Sequences._default.ApplyOpaque, 
              $Heap, 
              BucketWeights.__default.WeightMessage#Handle(), 
              Lit(msgs#0)); 
          Sequences.__default.FoldFromRight#canCall(Tclass._System.nat(), 
            Tclass._System.nat(), 
            Multisets.__default.AddNat#Handle(), 
            $Box(LitInt(0)), 
            weights#1))
         && BucketWeights.__default.WeightMessageSeq($LS($ly), Lit(msgs#0))
           == (var weights#1 := Sequences.__default.ApplyOpaque(Tclass.ValueMessage.Message(), 
                Tclass._System.nat(), 
                StartFuel_Sequences._default.ApplyOpaque, 
                $Heap, 
                BucketWeights.__default.WeightMessage#Handle(), 
                Lit(msgs#0)); 
            $Unbox(Sequences.__default.FoldFromRight(Tclass._System.nat(), 
                Tclass._System.nat(), 
                $LS($LZ), 
                Multisets.__default.AddNat#Handle(), 
                $Box(LitInt(0)), 
                weights#1)): int));

// function declaration for BucketWeights._default.WeightKeyList
function BucketWeights.__default.WeightKeyList(keys#0: Seq Box) : int;

function BucketWeights.__default.WeightKeyList#canCall(keys#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightKeyList
axiom true
   ==> (forall keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyList(keys#0) } 
    BucketWeights.__default.WeightKeyList#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> (Seq#Length(keys#0) == LitInt(0)
           ==> BucketWeights.__default.WeightKeyList(keys#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightKeyList(keys#0));

function BucketWeights.__default.WeightKeyList#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightKeyList
axiom (forall keys#0: Seq Box :: 
  { BucketWeights.__default.WeightKeyList#requires(keys#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.WeightKeyList#requires(keys#0) == true);

// definition axiom for BucketWeights.__default.WeightKeyList(revealed)
axiom true
   ==> (forall keys#0: Seq Box :: 
    { BucketWeights.__default.WeightKeyList(keys#0) } 
    BucketWeights.__default.WeightKeyList#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> BucketWeights.__default.WeightKeyMultiset#canCall(MultiSet#FromSeq(keys#0))
         && BucketWeights.__default.WeightKeyList(keys#0)
           == BucketWeights.__default.WeightKeyMultiset(StartFuel_BucketWeights._default.WeightKeyMultiset, MultiSet#FromSeq(keys#0)));

// definition axiom for BucketWeights.__default.WeightKeyList for all literals(revealed)
axiom true
   ==> (forall keys#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightKeyList(Lit(keys#0)) } 
    BucketWeights.__default.WeightKeyList#canCall(Lit(keys#0))
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> BucketWeights.__default.WeightKeyMultiset#canCall(MultiSet#FromSeq(Lit(keys#0)))
         && BucketWeights.__default.WeightKeyList(Lit(keys#0))
           == BucketWeights.__default.WeightKeyMultiset(StartFuel_BucketWeights._default.WeightKeyMultiset, 
            MultiSet#FromSeq(Lit(keys#0))));

// function declaration for BucketWeights._default.WeightMessageList
function BucketWeights.__default.WeightMessageList(msgs#0: Seq Box) : int;

function BucketWeights.__default.WeightMessageList#canCall(msgs#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightMessageList
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageList(msgs#0) } 
    BucketWeights.__default.WeightMessageList#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> (Seq#Length(msgs#0) == LitInt(0)
           ==> BucketWeights.__default.WeightMessageList(msgs#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightMessageList(msgs#0));

function BucketWeights.__default.WeightMessageList#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightMessageList
axiom (forall msgs#0: Seq Box :: 
  { BucketWeights.__default.WeightMessageList#requires(msgs#0) } 
  $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
     ==> BucketWeights.__default.WeightMessageList#requires(msgs#0) == true);

// definition axiom for BucketWeights.__default.WeightMessageList(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    { BucketWeights.__default.WeightMessageList(msgs#0) } 
    BucketWeights.__default.WeightMessageList#canCall(msgs#0)
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> BucketWeights.__default.WeightMessageMultiset#canCall(MultiSet#FromSeq(msgs#0))
         && BucketWeights.__default.WeightMessageList(msgs#0)
           == BucketWeights.__default.WeightMessageMultiset(StartFuel_BucketWeights._default.WeightMessageMultiset, MultiSet#FromSeq(msgs#0)));

// definition axiom for BucketWeights.__default.WeightMessageList for all literals(revealed)
axiom true
   ==> (forall msgs#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightMessageList(Lit(msgs#0)) } 
    BucketWeights.__default.WeightMessageList#canCall(Lit(msgs#0))
         || $Is(msgs#0, TSeq(Tclass.ValueMessage.Message()))
       ==> BucketWeights.__default.WeightMessageMultiset#canCall(MultiSet#FromSeq(Lit(msgs#0)))
         && BucketWeights.__default.WeightMessageList(Lit(msgs#0))
           == BucketWeights.__default.WeightMessageMultiset(StartFuel_BucketWeights._default.WeightMessageMultiset, 
            MultiSet#FromSeq(Lit(msgs#0))));

// function declaration for BucketWeights._default.WeightBucket
function BucketWeights.__default.WeightBucket(bucket#0: DatatypeType) : int;

function BucketWeights.__default.WeightBucket#canCall(bucket#0: DatatypeType) : bool;

// consequence axiom for BucketWeights.__default.WeightBucket
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketWeights.__default.WeightBucket(bucket#0) } 
    BucketWeights.__default.WeightBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> (Seq#Length(BucketsLib.Bucket.keys(bucket#0))
               == Seq#Length(BucketsLib.Bucket.msgs(bucket#0))
             && Seq#Length(BucketsLib.Bucket.msgs(bucket#0)) == LitInt(0)
           ==> BucketWeights.__default.WeightBucket(bucket#0) == LitInt(0))
         && LitInt(0) <= BucketWeights.__default.WeightBucket(bucket#0));

function BucketWeights.__default.WeightBucket#requires(DatatypeType) : bool;

// #requires axiom for BucketWeights.__default.WeightBucket
axiom (forall bucket#0: DatatypeType :: 
  { BucketWeights.__default.WeightBucket#requires(bucket#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
     ==> BucketWeights.__default.WeightBucket#requires(bucket#0) == true);

// definition axiom for BucketWeights.__default.WeightBucket(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    { BucketWeights.__default.WeightBucket(bucket#0) } 
    BucketWeights.__default.WeightBucket#canCall(bucket#0)
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketWeights.__default.WeightKeyList#canCall(BucketsLib.Bucket.keys(bucket#0))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && BucketWeights.__default.WeightMessageList#canCall(BucketsLib.Bucket.msgs(bucket#0))
         && BucketWeights.__default.WeightBucket(bucket#0)
           == BucketWeights.__default.WeightKeyList(BucketsLib.Bucket.keys(bucket#0))
             + BucketWeights.__default.WeightMessageList(BucketsLib.Bucket.msgs(bucket#0)));

// definition axiom for BucketWeights.__default.WeightBucket for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType :: 
    {:weight 3} { BucketWeights.__default.WeightBucket(Lit(bucket#0)) } 
    BucketWeights.__default.WeightBucket#canCall(Lit(bucket#0))
         || $Is(bucket#0, Tclass.BucketsLib.Bucket())
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketWeights.__default.WeightKeyList#canCall(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
         && 
        BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && BucketWeights.__default.WeightMessageList#canCall(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))
         && BucketWeights.__default.WeightBucket(Lit(bucket#0))
           == LitInt(BucketWeights.__default.WeightKeyList(Lit(BucketsLib.Bucket.keys(Lit(bucket#0))))
               + BucketWeights.__default.WeightMessageList(Lit(BucketsLib.Bucket.msgs(Lit(bucket#0))))));

// function declaration for BucketWeights._default.WeightBucketList
function BucketWeights.__default.WeightBucketList($ly: LayerType, buckets#0: Seq Box) : int;

function BucketWeights.__default.WeightBucketList#canCall(buckets#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketWeights.__default.WeightBucketList($LS($ly), buckets#0) } 
  BucketWeights.__default.WeightBucketList($LS($ly), buckets#0)
     == BucketWeights.__default.WeightBucketList($ly, buckets#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketWeights.__default.WeightBucketList(AsFuelBottom($ly), buckets#0) } 
  BucketWeights.__default.WeightBucketList($ly, buckets#0)
     == BucketWeights.__default.WeightBucketList($LZ, buckets#0));

// consequence axiom for BucketWeights.__default.WeightBucketList
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketWeights.__default.WeightBucketList($ly, buckets#0) } 
    BucketWeights.__default.WeightBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> LitInt(0) <= BucketWeights.__default.WeightBucketList($ly, buckets#0));

function BucketWeights.__default.WeightBucketList#requires(LayerType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightBucketList
axiom (forall $ly: LayerType, buckets#0: Seq Box :: 
  { BucketWeights.__default.WeightBucketList#requires($ly, buckets#0) } 
  $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
     ==> BucketWeights.__default.WeightBucketList#requires($ly, buckets#0) == true);

// definition axiom for BucketWeights.__default.WeightBucketList(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    { BucketWeights.__default.WeightBucketList($LS($ly), buckets#0) } 
    BucketWeights.__default.WeightBucketList#canCall(buckets#0)
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(buckets#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketWeights.__default.WeightBucketList#canCall(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), buckets#0)
             && BucketWeights.__default.WeightBucket#canCall($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType))
         && BucketWeights.__default.WeightBucketList($LS($ly), buckets#0)
           == (if Seq#Length(buckets#0) == LitInt(0)
             then 0
             else BucketWeights.__default.WeightBucketList($ly, Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), buckets#0))
               + BucketWeights.__default.WeightBucket($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), buckets#0)): DatatypeType)));

// definition axiom for BucketWeights.__default.WeightBucketList for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, buckets#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightBucketList($LS($ly), Lit(buckets#0)) } 
    BucketWeights.__default.WeightBucketList#canCall(Lit(buckets#0))
         || $Is(buckets#0, TSeq(Tclass.BucketsLib.Bucket()))
       ==> (Seq#Length(Lit(buckets#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.BucketsLib.Bucket(), Lit(buckets#0))
             && BucketWeights.__default.WeightBucket#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType)))
         && BucketWeights.__default.WeightBucketList($LS($ly), Lit(buckets#0))
           == (if Seq#Length(Lit(buckets#0)) == LitInt(0)
             then 0
             else BucketWeights.__default.WeightBucketList($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.BucketsLib.Bucket(), Lit(buckets#0))))
               + BucketWeights.__default.WeightBucket(Lit($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), Lit(buckets#0))): DatatypeType))));

// function declaration for BucketWeights._default.AllKeys
function BucketWeights.__default.AllKeys() : ISet Box;

function BucketWeights.__default.AllKeys#canCall() : bool;

// consequence axiom for BucketWeights.__default.AllKeys
axiom true
   ==> 
  true
   ==> $Is(BucketWeights.__default.AllKeys(), TISet(Tclass.KeyType.Key()));

function BucketWeights.__default.AllKeys#requires() : bool;

// #requires axiom for BucketWeights.__default.AllKeys
axiom BucketWeights.__default.AllKeys#requires() == true;

// definition axiom for BucketWeights.__default.AllKeys(revealed)
axiom true
   ==> 
  true
   ==> BucketWeights.__default.AllKeys()
     == (lambda $y#0: Box :: $IsBox($y#0, Tclass.KeyType.Key()) && Lit(true));

// definition axiom for BucketWeights.__default.AllKeys for all literals(revealed)
axiom true
   ==> 
  true
   ==> BucketWeights.__default.AllKeys()
     == (lambda $y#1: Box :: $IsBox($y#1, Tclass.KeyType.Key()) && Lit(true));

// function declaration for BucketWeights._default.IncludeKey
function BucketWeights.__default.IncludeKey(key#0: Seq Box) : ISet Box;

function BucketWeights.__default.IncludeKey#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.IncludeKey
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.IncludeKey(key#0) } 
    BucketWeights.__default.IncludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.IncludeKey(key#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.IncludeKey#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.IncludeKey
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.IncludeKey#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.IncludeKey#requires(key#0) == true);

// definition axiom for BucketWeights.__default.IncludeKey(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.IncludeKey(key#0) } 
    BucketWeights.__default.IncludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.IncludeKey(key#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Tclass.KeyType.Key()) && Seq#Equal($Unbox($y#0): Seq Box, key#0)));

// definition axiom for BucketWeights.__default.IncludeKey for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.IncludeKey(Lit(key#0)) } 
    BucketWeights.__default.IncludeKey#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.IncludeKey(Lit(key#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Tclass.KeyType.Key()) && Seq#Equal($Unbox($y#1): Seq Box, key#0)));

// function declaration for BucketWeights._default.ExcludeKey
function BucketWeights.__default.ExcludeKey(key#0: Seq Box) : ISet Box;

function BucketWeights.__default.ExcludeKey#canCall(key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.ExcludeKey
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.ExcludeKey(key#0) } 
    BucketWeights.__default.ExcludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.ExcludeKey(key#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.ExcludeKey#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.ExcludeKey
axiom (forall key#0: Seq Box :: 
  { BucketWeights.__default.ExcludeKey#requires(key#0) } 
  $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.ExcludeKey#requires(key#0) == true);

// definition axiom for BucketWeights.__default.ExcludeKey(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    { BucketWeights.__default.ExcludeKey(key#0) } 
    BucketWeights.__default.ExcludeKey#canCall(key#0)
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.ExcludeKey(key#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Tclass.KeyType.Key()) && !Seq#Equal($Unbox($y#0): Seq Box, key#0)));

// definition axiom for BucketWeights.__default.ExcludeKey for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.ExcludeKey(Lit(key#0)) } 
    BucketWeights.__default.ExcludeKey#canCall(Lit(key#0))
         || $Is(key#0, Tclass.KeyType.Key())
       ==> BucketWeights.__default.ExcludeKey(Lit(key#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Tclass.KeyType.Key()) && !Seq#Equal($Unbox($y#1): Seq Box, key#0)));

// function declaration for BucketWeights._default.Image
function BucketWeights.__default.Image($ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box) : DatatypeType;

function BucketWeights.__default.Image#canCall(bucket#0: DatatypeType, filter#0: ISet Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
  { BucketWeights.__default.Image($LS($ly), bucket#0, filter#0) } 
  BucketWeights.__default.Image($LS($ly), bucket#0, filter#0)
     == BucketWeights.__default.Image($ly, bucket#0, filter#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
  { BucketWeights.__default.Image(AsFuelBottom($ly), bucket#0, filter#0) } 
  BucketWeights.__default.Image($ly, bucket#0, filter#0)
     == BucketWeights.__default.Image($LZ, bucket#0, filter#0));

// consequence axiom for BucketWeights.__default.Image
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    { BucketWeights.__default.Image($ly, bucket#0, filter#0) } 
    BucketWeights.__default.Image#canCall(bucket#0, filter#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> BucketsLib.__default.BucketWellMarshalled(BucketWeights.__default.Image($ly, bucket#0, filter#0))
         && BucketsLib.__default.PreWFBucket(BucketWeights.__default.Image($ly, bucket#0, filter#0))
         && Seq#Length(BucketsLib.Bucket.keys(BucketWeights.__default.Image($ly, bucket#0, filter#0)))
           == Seq#Length(BucketsLib.Bucket.msgs(BucketWeights.__default.Image($ly, bucket#0, filter#0)))
         && (BucketsLib.__default.WFBucketMap(BucketsLib.Bucket.b(bucket#0))
           ==> BucketsLib.__default.WFBucket(BucketWeights.__default.Image($ly, bucket#0, filter#0)))
         && $Is(BucketWeights.__default.Image($ly, bucket#0, filter#0), 
          Tclass.BucketsLib.Bucket()));

function BucketWeights.__default.Image#requires(LayerType, DatatypeType, ISet Box) : bool;

// #requires axiom for BucketWeights.__default.Image
axiom (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
  { BucketWeights.__default.Image#requires($ly, bucket#0, filter#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket())
       && $Is(filter#0, TISet(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.Image#requires($ly, bucket#0, filter#0) == true);

// definition axiom for BucketWeights.__default.Image(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    { BucketWeights.__default.Image($LS($ly), bucket#0, filter#0) } 
    BucketWeights.__default.Image#canCall(bucket#0, filter#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> (forall k#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)]): DatatypeType } 
            { filter#0[$Box(k#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
               && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] && filter#0[$Box(k#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#0: Box :: 
              $Is($Unbox($w#0): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#0]
                 && filter#0[$w#0]), 
            (lambda $w#0: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#0]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketWeights.__default.Image($LS($ly), bucket#0, filter#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#1: Box :: 
                $Is($Unbox($w#1): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(bucket#0))[$w#1]
                   && filter#0[$w#1]), 
              (lambda $w#1: Box :: Map#Elements(BucketsLib.Bucket.b(bucket#0))[$w#1]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketWeights.__default.Image for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    {:weight 3} { BucketWeights.__default.Image($LS($ly), Lit(bucket#0), filter#0) } 
    BucketWeights.__default.Image#canCall(Lit(bucket#0), filter#0)
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> (forall k#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)]): DatatypeType } 
            { filter#0[$Box(k#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(k#0)] && filter#0[$Box(k#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#2: Box :: 
              $Is($Unbox($w#2): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#2]
                 && filter#0[$w#2]), 
            (lambda $w#2: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#2]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketWeights.__default.Image($LS($ly), Lit(bucket#0), filter#0)
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#3: Box :: 
                $Is($Unbox($w#3): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#3]
                   && filter#0[$w#3]), 
              (lambda $w#3: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#3]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// definition axiom for BucketWeights.__default.Image for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bucket#0: DatatypeType, filter#0: ISet Box :: 
    {:weight 3} { BucketWeights.__default.Image($LS($ly), Lit(bucket#0), Lit(filter#0)) } 
    BucketWeights.__default.Image#canCall(Lit(bucket#0), Lit(filter#0))
         || ($Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(filter#0, TISet(Tclass.KeyType.Key())))
       ==> (forall k#0: Seq Box :: 
          { $Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)]): DatatypeType } 
            { filter#0[$Box(k#0)] } 
            { Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(k#0)] } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
               && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(k#0)]
                   && Lit(filter#0)[$Box(k#0)]
                 ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))))
         && BucketsLib.__default.B#canCall(Map#Glue((lambda $w#4: Box :: 
              $Is($Unbox($w#4): Seq Box, Tclass.KeyType.Key())
                 && 
                Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#4]
                 && Lit(filter#0)[$w#4]), 
            (lambda $w#4: Box :: 
              Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#4]), 
            TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())))
         && BucketWeights.__default.Image($LS($ly), Lit(bucket#0), Lit(filter#0))
           == BucketsLib.__default.B(StartFuel_BucketsLib._default.B, 
            Map#Glue((lambda $w#5: Box :: 
                $Is($Unbox($w#5): Seq Box, Tclass.KeyType.Key())
                   && 
                  Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$w#5]
                   && Lit(filter#0)[$w#5]), 
              (lambda $w#5: Box :: 
                Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$w#5]), 
              TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message()))));

// function declaration for BucketWeights._default.WeightOneKey
function BucketWeights.__default.WeightOneKey(bucket#0: DatatypeType, key#0: Seq Box) : int;

function BucketWeights.__default.WeightOneKey#canCall(bucket#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.WeightOneKey
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketWeights.__default.WeightOneKey(bucket#0, key#0) } 
    BucketWeights.__default.WeightOneKey#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0))
       ==> true);

function BucketWeights.__default.WeightOneKey#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for BucketWeights.__default.WeightOneKey
axiom (forall bucket#0: DatatypeType, key#0: Seq Box :: 
  { BucketWeights.__default.WeightOneKey#requires(bucket#0, key#0) } 
  $Is(bucket#0, Tclass.BucketsLib.Bucket()) && $Is(key#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.WeightOneKey#requires(bucket#0, key#0)
       == (BucketsLib.__default.PreWFBucket(bucket#0)
         && BucketsLib.__default.BucketWellMarshalled(bucket#0)));

// definition axiom for BucketWeights.__default.WeightOneKey(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    { BucketWeights.__default.WeightOneKey(bucket#0, key#0) } 
    BucketWeights.__default.WeightOneKey#canCall(bucket#0, key#0)
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          BucketsLib.__default.PreWFBucket(bucket#0)
           && BucketsLib.__default.BucketWellMarshalled(bucket#0))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
         && (Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
           ==> BucketWeights.__default.WeightKey#canCall(key#0)
             && 
            BucketsLib.Bucket.BucketMapWithSeq_q(bucket#0)
             && BucketWeights.__default.WeightMessage#canCall($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType))
         && BucketWeights.__default.WeightOneKey(bucket#0, key#0)
           == (if Map#Domain(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]
             then BucketWeights.__default.WeightKey(key#0)
               + BucketWeights.__default.WeightMessage($Unbox(Map#Elements(BucketsLib.Bucket.b(bucket#0))[$Box(key#0)]): DatatypeType)
             else 0));

// definition axiom for BucketWeights.__default.WeightOneKey for all literals(revealed)
axiom true
   ==> (forall bucket#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.WeightOneKey(Lit(bucket#0), Lit(key#0)) } 
    BucketWeights.__default.WeightOneKey#canCall(Lit(bucket#0), Lit(key#0))
         || (
          $Is(bucket#0, Tclass.BucketsLib.Bucket())
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Lit(BucketsLib.__default.PreWFBucket(Lit(bucket#0)))
           && Lit(BucketsLib.__default.BucketWellMarshalled(Lit(bucket#0))))
       ==> BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
         && (Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
           ==> BucketWeights.__default.WeightKey#canCall(Lit(key#0))
             && 
            BucketsLib.Bucket.BucketMapWithSeq_q(Lit(bucket#0))
             && BucketWeights.__default.WeightMessage#canCall($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(Lit(key#0))]): DatatypeType))
         && BucketWeights.__default.WeightOneKey(Lit(bucket#0), Lit(key#0))
           == (if Map#Domain(BucketsLib.Bucket.b(Lit(bucket#0)))[$Box(key#0)]
             then BucketWeights.__default.WeightKey(Lit(key#0))
               + BucketWeights.__default.WeightMessage($Unbox(Map#Elements(Lit(BucketsLib.Bucket.b(Lit(bucket#0))))[$Box(Lit(key#0))]): DatatypeType)
             else 0));

// function declaration for BucketWeights._default.ILeftKeys
function BucketWeights.__default.ILeftKeys(pivot#0: Seq Box) : ISet Box;

function BucketWeights.__default.ILeftKeys#canCall(pivot#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.ILeftKeys
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.ILeftKeys(pivot#0) } 
    BucketWeights.__default.ILeftKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.ILeftKeys(pivot#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.ILeftKeys#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.ILeftKeys
axiom (forall pivot#0: Seq Box :: 
  { BucketWeights.__default.ILeftKeys#requires(pivot#0) } 
  $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.ILeftKeys#requires(pivot#0) == true);

// definition axiom for BucketWeights.__default.ILeftKeys(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.ILeftKeys(pivot#0) } 
    BucketWeights.__default.ILeftKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#0, pivot#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#0, pivot#0))
         && BucketWeights.__default.ILeftKeys(pivot#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#0): Seq Box, pivot#0)));

// definition axiom for BucketWeights.__default.ILeftKeys for all literals(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.ILeftKeys(Lit(pivot#0)) } 
    BucketWeights.__default.ILeftKeys#canCall(Lit(pivot#0))
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(k#1, pivot#0) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lt#canCall(k#1, Lit(pivot#0)))
         && BucketWeights.__default.ILeftKeys(Lit(pivot#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lt($Unbox($y#1): Seq Box, Lit(pivot#0))));

// function declaration for BucketWeights._default.IRightKeys
function BucketWeights.__default.IRightKeys(pivot#0: Seq Box) : ISet Box;

function BucketWeights.__default.IRightKeys#canCall(pivot#0: Seq Box) : bool;

// consequence axiom for BucketWeights.__default.IRightKeys
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.IRightKeys(pivot#0) } 
    BucketWeights.__default.IRightKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> $Is(BucketWeights.__default.IRightKeys(pivot#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.IRightKeys#requires(Seq Box) : bool;

// #requires axiom for BucketWeights.__default.IRightKeys
axiom (forall pivot#0: Seq Box :: 
  { BucketWeights.__default.IRightKeys#requires(pivot#0) } 
  $Is(pivot#0, Tclass.KeyType.Key())
     ==> BucketWeights.__default.IRightKeys#requires(pivot#0) == true);

// definition axiom for BucketWeights.__default.IRightKeys(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    { BucketWeights.__default.IRightKeys(pivot#0) } 
    BucketWeights.__default.IRightKeys#canCall(pivot#0)
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(pivot#0, k#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lte#canCall(pivot#0, k#0))
         && BucketWeights.__default.IRightKeys(pivot#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lte(pivot#0, $Unbox($y#0): Seq Box)));

// definition axiom for BucketWeights.__default.IRightKeys for all literals(revealed)
axiom true
   ==> (forall pivot#0: Seq Box :: 
    {:weight 3} { BucketWeights.__default.IRightKeys(Lit(pivot#0)) } 
    BucketWeights.__default.IRightKeys#canCall(Lit(pivot#0))
         || $Is(pivot#0, Tclass.KeyType.Key())
       ==> (forall k#1: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(pivot#0, k#1) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> Lexicographic__Byte__Order.__default.lte#canCall(Lit(pivot#0), k#1))
         && BucketWeights.__default.IRightKeys(Lit(pivot#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && Lexicographic__Byte__Order.__default.lte(Lit(pivot#0), $Unbox($y#1): Seq Box)));

// function declaration for BucketWeights._default.RouteRange
function BucketWeights.__default.RouteRange(pivots#0: Seq Box, i#0: int) : ISet Box;

function BucketWeights.__default.RouteRange#canCall(pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketWeights.__default.RouteRange
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRange(pivots#0, i#0) } 
    BucketWeights.__default.RouteRange#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketWeights.__default.RouteRange(pivots#0, i#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.RouteRange#requires(Seq Box, int) : bool;

// #requires axiom for BucketWeights.__default.RouteRange
axiom (forall pivots#0: Seq Box, i#0: int :: 
  { BucketWeights.__default.RouteRange#requires(pivots#0, i#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.RouteRange#requires(pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketWeights.__default.RouteRange(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRange(pivots#0, i#0) } 
    BucketWeights.__default.RouteRange#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall k#0: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(pivots#0, k#0))
         && BucketWeights.__default.RouteRange(pivots#0, i#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(pivots#0, $Unbox($y#0): Seq Box) == i#0));

// definition axiom for BucketWeights.__default.RouteRange for all literals(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketWeights.__default.RouteRange(Lit(pivots#0), LitInt(i#0)) } 
    BucketWeights.__default.RouteRange#canCall(Lit(pivots#0), LitInt(i#0))
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall k#1: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#1) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), k#1))
         && BucketWeights.__default.RouteRange(Lit(pivots#0), LitInt(i#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($y#1): Seq Box) == LitInt(i#0)));

// function declaration for BucketWeights._default.RouteRanges
function BucketWeights.__default.RouteRanges(pivots#0: Seq Box, i#0: int) : ISet Box;

function BucketWeights.__default.RouteRanges#canCall(pivots#0: Seq Box, i#0: int) : bool;

// consequence axiom for BucketWeights.__default.RouteRanges
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRanges(pivots#0, i#0) } 
    BucketWeights.__default.RouteRanges#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(BucketWeights.__default.RouteRanges(pivots#0, i#0), TISet(Tclass.KeyType.Key())));

function BucketWeights.__default.RouteRanges#requires(Seq Box, int) : bool;

// #requires axiom for BucketWeights.__default.RouteRanges
axiom (forall pivots#0: Seq Box, i#0: int :: 
  { BucketWeights.__default.RouteRanges#requires(pivots#0, i#0) } 
  $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> BucketWeights.__default.RouteRanges#requires(pivots#0, i#0)
       == PivotsLib.__default.WFPivots(pivots#0));

// definition axiom for BucketWeights.__default.RouteRanges(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    { BucketWeights.__default.RouteRanges(pivots#0, i#0) } 
    BucketWeights.__default.RouteRanges#canCall(pivots#0, i#0)
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> (forall k#0: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#0) } 
          $Is(k#0, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(pivots#0, k#0))
         && BucketWeights.__default.RouteRanges(pivots#0, i#0)
           == (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(pivots#0, $Unbox($y#0): Seq Box) < i#0));

// definition axiom for BucketWeights.__default.RouteRanges for all literals(revealed)
axiom true
   ==> (forall pivots#0: Seq Box, i#0: int :: 
    {:weight 3} { BucketWeights.__default.RouteRanges(Lit(pivots#0), LitInt(i#0)) } 
    BucketWeights.__default.RouteRanges#canCall(Lit(pivots#0), LitInt(i#0))
         || ($Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> (forall k#1: Seq Box :: 
          { PivotsLib.__default.Route(pivots#0, k#1) } 
          $Is(k#1, Tclass.KeyType.Key())
             ==> PivotsLib.__default.Route#canCall(Lit(pivots#0), k#1))
         && BucketWeights.__default.RouteRanges(Lit(pivots#0), LitInt(i#0))
           == (lambda $y#1: Box :: 
            $IsBox($y#1, Tclass.KeyType.Key())
               && PivotsLib.__default.Route(Lit(pivots#0), $Unbox($y#1): Seq Box) < i#0));

// Constructor function declaration
function #PivotBetreeSpec.LookupQuery.LookupQuery(Seq Box, Seq Box, Seq Box) : DatatypeType;

const unique ##PivotBetreeSpec.LookupQuery.LookupQuery: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: Seq Box, a#0#2#0: Seq Box :: 
  { #PivotBetreeSpec.LookupQuery.LookupQuery(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#PivotBetreeSpec.LookupQuery.LookupQuery(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##PivotBetreeSpec.LookupQuery.LookupQuery);

function PivotBetreeSpec.LookupQuery.LookupQuery_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.LookupQuery.LookupQuery_q(d) } 
  PivotBetreeSpec.LookupQuery.LookupQuery_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.LookupQuery.LookupQuery);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.LookupQuery.LookupQuery_q(d) } 
  PivotBetreeSpec.LookupQuery.LookupQuery_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: Seq Box, a#1#2#0: Seq Box :: 
      d == #PivotBetreeSpec.LookupQuery.LookupQuery(a#1#0#0, a#1#1#0, a#1#2#0)));

function Tclass.PivotBetreeSpec.LookupQuery() : Ty;

// Tclass.PivotBetreeSpec.LookupQuery Tag
axiom Tag(Tclass.PivotBetreeSpec.LookupQuery())
   == Tagclass.PivotBetreeSpec.LookupQuery;

const unique Tagclass.PivotBetreeSpec.LookupQuery: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.LookupQuery
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.LookupQuery()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.LookupQuery())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.LookupQuery()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: Seq Box, a#2#2#0: Seq Box :: 
  { $Is(#PivotBetreeSpec.LookupQuery.LookupQuery(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.PivotBetreeSpec.LookupQuery()) } 
  $Is(#PivotBetreeSpec.LookupQuery.LookupQuery(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.PivotBetreeSpec.LookupQuery())
     <==> $Is(a#2#0#0, Tclass.KeyType.Key())
       && $Is(a#2#1#0, Tclass.ValueType.Value())
       && $Is(a#2#2#0, TSeq(Tclass.PivotBetreeGraph.ReadOp())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: Seq Box, a#3#2#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.LookupQuery.LookupQuery(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.PivotBetreeSpec.LookupQuery(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.LookupQuery.LookupQuery(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.PivotBetreeSpec.LookupQuery(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#3#1#0, Tclass.ValueType.Value(), $h)
         && $IsAlloc(a#3#2#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.LookupQuery.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.LookupQuery.LookupQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.LookupQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.LookupQuery.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.LookupQuery.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.LookupQuery.LookupQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.LookupQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.LookupQuery.value(d), Tclass.ValueType.Value(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.LookupQuery.lookup(d), 
      TSeq(Tclass.PivotBetreeGraph.ReadOp()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.LookupQuery.LookupQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.LookupQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.LookupQuery.lookup(d), 
      TSeq(Tclass.PivotBetreeGraph.ReadOp()), 
      $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: Seq Box, a#4#2#0: Seq Box :: 
  { #PivotBetreeSpec.LookupQuery.LookupQuery(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0)) } 
  #PivotBetreeSpec.LookupQuery.LookupQuery(Lit(a#4#0#0), Lit(a#4#1#0), Lit(a#4#2#0))
     == Lit(#PivotBetreeSpec.LookupQuery.LookupQuery(a#4#0#0, a#4#1#0, a#4#2#0)));

function PivotBetreeSpec.LookupQuery.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: Seq Box, a#5#2#0: Seq Box :: 
  { #PivotBetreeSpec.LookupQuery.LookupQuery(a#5#0#0, a#5#1#0, a#5#2#0) } 
  PivotBetreeSpec.LookupQuery.key(#PivotBetreeSpec.LookupQuery.LookupQuery(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

function PivotBetreeSpec.LookupQuery.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#6#0#0: Seq Box, a#6#1#0: Seq Box, a#6#2#0: Seq Box :: 
  { #PivotBetreeSpec.LookupQuery.LookupQuery(a#6#0#0, a#6#1#0, a#6#2#0) } 
  PivotBetreeSpec.LookupQuery.value(#PivotBetreeSpec.LookupQuery.LookupQuery(a#6#0#0, a#6#1#0, a#6#2#0))
     == a#6#1#0);

function PivotBetreeSpec.LookupQuery.lookup(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#7#0#0: Seq Box, a#7#1#0: Seq Box, a#7#2#0: Seq Box :: 
  { #PivotBetreeSpec.LookupQuery.LookupQuery(a#7#0#0, a#7#1#0, a#7#2#0) } 
  PivotBetreeSpec.LookupQuery.lookup(#PivotBetreeSpec.LookupQuery.LookupQuery(a#7#0#0, a#7#1#0, a#7#2#0))
     == a#7#2#0);

// Inductive seq element rank
axiom (forall a#8#0#0: Seq Box, a#8#1#0: Seq Box, a#8#2#0: Seq Box, i: int :: 
  { Seq#Index(a#8#2#0, i), #PivotBetreeSpec.LookupQuery.LookupQuery(a#8#0#0, a#8#1#0, a#8#2#0) } 
  0 <= i && i < Seq#Length(a#8#2#0)
     ==> DtRank($Unbox(Seq#Index(a#8#2#0, i)): DatatypeType)
       < DtRank(#PivotBetreeSpec.LookupQuery.LookupQuery(a#8#0#0, a#8#1#0, a#8#2#0)));

// Inductive seq rank
axiom (forall a#9#0#0: Seq Box, a#9#1#0: Seq Box, a#9#2#0: Seq Box :: 
  { #PivotBetreeSpec.LookupQuery.LookupQuery(a#9#0#0, a#9#1#0, a#9#2#0) } 
  Seq#Rank(a#9#2#0)
     < DtRank(#PivotBetreeSpec.LookupQuery.LookupQuery(a#9#0#0, a#9#1#0, a#9#2#0)));

// Depth-one case-split function
function $IsA#PivotBetreeSpec.LookupQuery(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.LookupQuery(d) } 
  $IsA#PivotBetreeSpec.LookupQuery(d)
     ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.LookupQuery.LookupQuery_q(d), $Is(d, Tclass.PivotBetreeSpec.LookupQuery()) } 
  $Is(d, Tclass.PivotBetreeSpec.LookupQuery())
     ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.LookupQuery#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.LookupQuery.LookupQuery
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.LookupQuery#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.LookupQuery#Equal(a, b)
       <==> Seq#Equal(PivotBetreeSpec.LookupQuery.key(a), PivotBetreeSpec.LookupQuery.key(b))
         && Seq#Equal(PivotBetreeSpec.LookupQuery.value(a), PivotBetreeSpec.LookupQuery.value(b))
         && Seq#Equal(PivotBetreeSpec.LookupQuery.lookup(a), PivotBetreeSpec.LookupQuery.lookup(b))));

// Datatype extensionality axiom: PivotBetreeSpec.LookupQuery
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.LookupQuery#Equal(a, b) } 
  PivotBetreeSpec.LookupQuery#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.LookupQuery: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.SuccQuery.SuccQuery(DatatypeType, Seq Box, DatatypeType, Seq Box, Seq Box) : DatatypeType;

const unique ##PivotBetreeSpec.SuccQuery.SuccQuery: DtCtorId;

// Constructor identifier
axiom (forall a#10#0#0: DatatypeType, 
    a#10#1#0: Seq Box, 
    a#10#2#0: DatatypeType, 
    a#10#3#0: Seq Box, 
    a#10#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0) } 
  DatatypeCtorId(#PivotBetreeSpec.SuccQuery.SuccQuery(a#10#0#0, a#10#1#0, a#10#2#0, a#10#3#0, a#10#4#0))
     == ##PivotBetreeSpec.SuccQuery.SuccQuery);

function PivotBetreeSpec.SuccQuery.SuccQuery_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.SuccQuery.SuccQuery_q(d) } 
  PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.SuccQuery.SuccQuery);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.SuccQuery.SuccQuery_q(d) } 
  PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
     ==> (exists a#11#0#0: DatatypeType, 
        a#11#1#0: Seq Box, 
        a#11#2#0: DatatypeType, 
        a#11#3#0: Seq Box, 
        a#11#4#0: Seq Box :: 
      d
         == #PivotBetreeSpec.SuccQuery.SuccQuery(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0)));

function Tclass.PivotBetreeSpec.SuccQuery() : Ty;

// Tclass.PivotBetreeSpec.SuccQuery Tag
axiom Tag(Tclass.PivotBetreeSpec.SuccQuery()) == Tagclass.PivotBetreeSpec.SuccQuery;

const unique Tagclass.PivotBetreeSpec.SuccQuery: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.SuccQuery
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.SuccQuery()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.SuccQuery())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.SuccQuery()));

// Constructor $Is
axiom (forall a#12#0#0: DatatypeType, 
    a#12#1#0: Seq Box, 
    a#12#2#0: DatatypeType, 
    a#12#3#0: Seq Box, 
    a#12#4#0: Seq Box :: 
  { $Is(#PivotBetreeSpec.SuccQuery.SuccQuery(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0), 
      Tclass.PivotBetreeSpec.SuccQuery()) } 
  $Is(#PivotBetreeSpec.SuccQuery.SuccQuery(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0), 
      Tclass.PivotBetreeSpec.SuccQuery())
     <==> $Is(a#12#0#0, Tclass.UI.RangeStart())
       && $Is(a#12#1#0, TSeq(Tclass.UI.SuccResult()))
       && $Is(a#12#2#0, Tclass.UI.RangeEnd())
       && $Is(a#12#3#0, TSeq(Tclass.BucketsLib.Bucket()))
       && $Is(a#12#4#0, TSeq(Tclass.PivotBetreeGraph.ReadOp())));

// Constructor $IsAlloc
axiom (forall a#13#0#0: DatatypeType, 
    a#13#1#0: Seq Box, 
    a#13#2#0: DatatypeType, 
    a#13#3#0: Seq Box, 
    a#13#4#0: Seq Box, 
    $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.SuccQuery.SuccQuery(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0), 
      Tclass.PivotBetreeSpec.SuccQuery(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.SuccQuery.SuccQuery(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0), 
        Tclass.PivotBetreeSpec.SuccQuery(), 
        $h)
       <==> $IsAlloc(a#13#0#0, Tclass.UI.RangeStart(), $h)
         && $IsAlloc(a#13#1#0, TSeq(Tclass.UI.SuccResult()), $h)
         && $IsAlloc(a#13#2#0, Tclass.UI.RangeEnd(), $h)
         && $IsAlloc(a#13#3#0, TSeq(Tclass.BucketsLib.Bucket()), $h)
         && $IsAlloc(a#13#4#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.SuccQuery.start(d), Tclass.UI.RangeStart(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.SuccQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.SuccQuery.start(d), Tclass.UI.RangeStart(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.SuccQuery.results(d), TSeq(Tclass.UI.SuccResult()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.SuccQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.SuccQuery.results(d), TSeq(Tclass.UI.SuccResult()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.SuccQuery.end(d), Tclass.UI.RangeEnd(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.SuccQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.SuccQuery.end(d), Tclass.UI.RangeEnd(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.SuccQuery.buckets(d), TSeq(Tclass.BucketsLib.Bucket()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.SuccQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.SuccQuery.buckets(d), TSeq(Tclass.BucketsLib.Bucket()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.SuccQuery.lookup(d), TSeq(Tclass.PivotBetreeGraph.ReadOp()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.SuccQuery.SuccQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.SuccQuery(), $h)
     ==> $IsAlloc(PivotBetreeSpec.SuccQuery.lookup(d), TSeq(Tclass.PivotBetreeGraph.ReadOp()), $h));

// Constructor literal
axiom (forall a#14#0#0: DatatypeType, 
    a#14#1#0: Seq Box, 
    a#14#2#0: DatatypeType, 
    a#14#3#0: Seq Box, 
    a#14#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(Lit(a#14#0#0), Lit(a#14#1#0), Lit(a#14#2#0), Lit(a#14#3#0), Lit(a#14#4#0)) } 
  #PivotBetreeSpec.SuccQuery.SuccQuery(Lit(a#14#0#0), Lit(a#14#1#0), Lit(a#14#2#0), Lit(a#14#3#0), Lit(a#14#4#0))
     == Lit(#PivotBetreeSpec.SuccQuery.SuccQuery(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0)));

function PivotBetreeSpec.SuccQuery.start(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#15#0#0: DatatypeType, 
    a#15#1#0: Seq Box, 
    a#15#2#0: DatatypeType, 
    a#15#3#0: Seq Box, 
    a#15#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0) } 
  PivotBetreeSpec.SuccQuery.start(#PivotBetreeSpec.SuccQuery.SuccQuery(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0))
     == a#15#0#0);

// Inductive rank
axiom (forall a#16#0#0: DatatypeType, 
    a#16#1#0: Seq Box, 
    a#16#2#0: DatatypeType, 
    a#16#3#0: Seq Box, 
    a#16#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0) } 
  DtRank(a#16#0#0)
     < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0)));

function PivotBetreeSpec.SuccQuery.results(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#17#0#0: DatatypeType, 
    a#17#1#0: Seq Box, 
    a#17#2#0: DatatypeType, 
    a#17#3#0: Seq Box, 
    a#17#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0) } 
  PivotBetreeSpec.SuccQuery.results(#PivotBetreeSpec.SuccQuery.SuccQuery(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0))
     == a#17#1#0);

// Inductive seq element rank
axiom (forall a#18#0#0: DatatypeType, 
    a#18#1#0: Seq Box, 
    a#18#2#0: DatatypeType, 
    a#18#3#0: Seq Box, 
    a#18#4#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#18#1#0, i), #PivotBetreeSpec.SuccQuery.SuccQuery(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0) } 
  0 <= i && i < Seq#Length(a#18#1#0)
     ==> DtRank($Unbox(Seq#Index(a#18#1#0, i)): DatatypeType)
       < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0)));

// Inductive seq rank
axiom (forall a#19#0#0: DatatypeType, 
    a#19#1#0: Seq Box, 
    a#19#2#0: DatatypeType, 
    a#19#3#0: Seq Box, 
    a#19#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0) } 
  Seq#Rank(a#19#1#0)
     < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0)));

function PivotBetreeSpec.SuccQuery.end(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#20#0#0: DatatypeType, 
    a#20#1#0: Seq Box, 
    a#20#2#0: DatatypeType, 
    a#20#3#0: Seq Box, 
    a#20#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0, a#20#4#0) } 
  PivotBetreeSpec.SuccQuery.end(#PivotBetreeSpec.SuccQuery.SuccQuery(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0, a#20#4#0))
     == a#20#2#0);

// Inductive rank
axiom (forall a#21#0#0: DatatypeType, 
    a#21#1#0: Seq Box, 
    a#21#2#0: DatatypeType, 
    a#21#3#0: Seq Box, 
    a#21#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0) } 
  DtRank(a#21#2#0)
     < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0)));

function PivotBetreeSpec.SuccQuery.buckets(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: DatatypeType, 
    a#22#1#0: Seq Box, 
    a#22#2#0: DatatypeType, 
    a#22#3#0: Seq Box, 
    a#22#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0) } 
  PivotBetreeSpec.SuccQuery.buckets(#PivotBetreeSpec.SuccQuery.SuccQuery(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0))
     == a#22#3#0);

// Inductive seq element rank
axiom (forall a#23#0#0: DatatypeType, 
    a#23#1#0: Seq Box, 
    a#23#2#0: DatatypeType, 
    a#23#3#0: Seq Box, 
    a#23#4#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#23#3#0, i), #PivotBetreeSpec.SuccQuery.SuccQuery(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0) } 
  0 <= i && i < Seq#Length(a#23#3#0)
     ==> DtRank($Unbox(Seq#Index(a#23#3#0, i)): DatatypeType)
       < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0)));

// Inductive seq rank
axiom (forall a#24#0#0: DatatypeType, 
    a#24#1#0: Seq Box, 
    a#24#2#0: DatatypeType, 
    a#24#3#0: Seq Box, 
    a#24#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0) } 
  Seq#Rank(a#24#3#0)
     < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0)));

function PivotBetreeSpec.SuccQuery.lookup(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#25#0#0: DatatypeType, 
    a#25#1#0: Seq Box, 
    a#25#2#0: DatatypeType, 
    a#25#3#0: Seq Box, 
    a#25#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0) } 
  PivotBetreeSpec.SuccQuery.lookup(#PivotBetreeSpec.SuccQuery.SuccQuery(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0))
     == a#25#4#0);

// Inductive seq element rank
axiom (forall a#26#0#0: DatatypeType, 
    a#26#1#0: Seq Box, 
    a#26#2#0: DatatypeType, 
    a#26#3#0: Seq Box, 
    a#26#4#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#26#4#0, i), #PivotBetreeSpec.SuccQuery.SuccQuery(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0) } 
  0 <= i && i < Seq#Length(a#26#4#0)
     ==> DtRank($Unbox(Seq#Index(a#26#4#0, i)): DatatypeType)
       < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0)));

// Inductive seq rank
axiom (forall a#27#0#0: DatatypeType, 
    a#27#1#0: Seq Box, 
    a#27#2#0: DatatypeType, 
    a#27#3#0: Seq Box, 
    a#27#4#0: Seq Box :: 
  { #PivotBetreeSpec.SuccQuery.SuccQuery(a#27#0#0, a#27#1#0, a#27#2#0, a#27#3#0, a#27#4#0) } 
  Seq#Rank(a#27#4#0)
     < DtRank(#PivotBetreeSpec.SuccQuery.SuccQuery(a#27#0#0, a#27#1#0, a#27#2#0, a#27#3#0, a#27#4#0)));

// Depth-one case-split function
function $IsA#PivotBetreeSpec.SuccQuery(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.SuccQuery(d) } 
  $IsA#PivotBetreeSpec.SuccQuery(d) ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.SuccQuery.SuccQuery_q(d), $Is(d, Tclass.PivotBetreeSpec.SuccQuery()) } 
  $Is(d, Tclass.PivotBetreeSpec.SuccQuery())
     ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.SuccQuery#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.SuccQuery.SuccQuery
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.SuccQuery#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.SuccQuery#Equal(a, b)
       <==> UI.RangeStart#Equal(PivotBetreeSpec.SuccQuery.start(a), PivotBetreeSpec.SuccQuery.start(b))
         && Seq#Equal(PivotBetreeSpec.SuccQuery.results(a), PivotBetreeSpec.SuccQuery.results(b))
         && UI.RangeEnd#Equal(PivotBetreeSpec.SuccQuery.end(a), PivotBetreeSpec.SuccQuery.end(b))
         && Seq#Equal(PivotBetreeSpec.SuccQuery.buckets(a), PivotBetreeSpec.SuccQuery.buckets(b))
         && Seq#Equal(PivotBetreeSpec.SuccQuery.lookup(a), PivotBetreeSpec.SuccQuery.lookup(b))));

// Datatype extensionality axiom: PivotBetreeSpec.SuccQuery
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.SuccQuery#Equal(a, b) } 
  PivotBetreeSpec.SuccQuery#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.SuccQuery: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.MessageInsertion.MessageInsertion(Seq Box, DatatypeType, DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.MessageInsertion.MessageInsertion: DtCtorId;

// Constructor identifier
axiom (forall a#28#0#0: Seq Box, a#28#1#0: DatatypeType, a#28#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#28#0#0, a#28#1#0, a#28#2#0) } 
  DatatypeCtorId(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#28#0#0, a#28#1#0, a#28#2#0))
     == ##PivotBetreeSpec.MessageInsertion.MessageInsertion);

function PivotBetreeSpec.MessageInsertion.MessageInsertion_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d) } 
  PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.MessageInsertion.MessageInsertion);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d) } 
  PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d)
     ==> (exists a#29#0#0: Seq Box, a#29#1#0: DatatypeType, a#29#2#0: DatatypeType :: 
      d
         == #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#29#0#0, a#29#1#0, a#29#2#0)));

function Tclass.PivotBetreeSpec.MessageInsertion() : Ty;

// Tclass.PivotBetreeSpec.MessageInsertion Tag
axiom Tag(Tclass.PivotBetreeSpec.MessageInsertion())
   == Tagclass.PivotBetreeSpec.MessageInsertion;

const unique Tagclass.PivotBetreeSpec.MessageInsertion: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.MessageInsertion
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.MessageInsertion()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.MessageInsertion())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.MessageInsertion()));

// Constructor $Is
axiom (forall a#30#0#0: Seq Box, a#30#1#0: DatatypeType, a#30#2#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#30#0#0, a#30#1#0, a#30#2#0), 
      Tclass.PivotBetreeSpec.MessageInsertion()) } 
  $Is(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#30#0#0, a#30#1#0, a#30#2#0), 
      Tclass.PivotBetreeSpec.MessageInsertion())
     <==> $Is(a#30#0#0, Tclass.KeyType.Key())
       && $Is(a#30#1#0, Tclass.ValueMessage.Message())
       && $Is(a#30#2#0, Tclass.PivotBetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#31#0#0: Seq Box, a#31#1#0: DatatypeType, a#31#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#31#0#0, a#31#1#0, a#31#2#0), 
      Tclass.PivotBetreeSpec.MessageInsertion(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#31#0#0, a#31#1#0, a#31#2#0), 
        Tclass.PivotBetreeSpec.MessageInsertion(), 
        $h)
       <==> $IsAlloc(a#31#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#31#1#0, Tclass.ValueMessage.Message(), $h)
         && $IsAlloc(a#31#2#0, Tclass.PivotBetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.MessageInsertion.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.MessageInsertion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.MessageInsertion.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.MessageInsertion.msg(d), Tclass.ValueMessage.Message(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.MessageInsertion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.MessageInsertion.msg(d), Tclass.ValueMessage.Message(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.MessageInsertion.oldroot(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.MessageInsertion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.MessageInsertion.oldroot(d), Tclass.PivotBetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#32#0#0: Seq Box, a#32#1#0: DatatypeType, a#32#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(Lit(a#32#0#0), Lit(a#32#1#0), Lit(a#32#2#0)) } 
  #PivotBetreeSpec.MessageInsertion.MessageInsertion(Lit(a#32#0#0), Lit(a#32#1#0), Lit(a#32#2#0))
     == Lit(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#32#0#0, a#32#1#0, a#32#2#0)));

function PivotBetreeSpec.MessageInsertion.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#33#0#0: Seq Box, a#33#1#0: DatatypeType, a#33#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#33#0#0, a#33#1#0, a#33#2#0) } 
  PivotBetreeSpec.MessageInsertion.key(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#33#0#0, a#33#1#0, a#33#2#0))
     == a#33#0#0);

function PivotBetreeSpec.MessageInsertion.msg(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#34#0#0: Seq Box, a#34#1#0: DatatypeType, a#34#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#34#0#0, a#34#1#0, a#34#2#0) } 
  PivotBetreeSpec.MessageInsertion.msg(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#34#0#0, a#34#1#0, a#34#2#0))
     == a#34#1#0);

// Inductive rank
axiom (forall a#35#0#0: Seq Box, a#35#1#0: DatatypeType, a#35#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#35#0#0, a#35#1#0, a#35#2#0) } 
  DtRank(a#35#1#0)
     < DtRank(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#35#0#0, a#35#1#0, a#35#2#0)));

function PivotBetreeSpec.MessageInsertion.oldroot(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#36#0#0: Seq Box, a#36#1#0: DatatypeType, a#36#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#36#0#0, a#36#1#0, a#36#2#0) } 
  PivotBetreeSpec.MessageInsertion.oldroot(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#36#0#0, a#36#1#0, a#36#2#0))
     == a#36#2#0);

// Inductive rank
axiom (forall a#37#0#0: Seq Box, a#37#1#0: DatatypeType, a#37#2#0: DatatypeType :: 
  { #PivotBetreeSpec.MessageInsertion.MessageInsertion(a#37#0#0, a#37#1#0, a#37#2#0) } 
  DtRank(a#37#2#0)
     < DtRank(#PivotBetreeSpec.MessageInsertion.MessageInsertion(a#37#0#0, a#37#1#0, a#37#2#0)));

// Depth-one case-split function
function $IsA#PivotBetreeSpec.MessageInsertion(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.MessageInsertion(d) } 
  $IsA#PivotBetreeSpec.MessageInsertion(d)
     ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d), $Is(d, Tclass.PivotBetreeSpec.MessageInsertion()) } 
  $Is(d, Tclass.PivotBetreeSpec.MessageInsertion())
     ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.MessageInsertion#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.MessageInsertion.MessageInsertion
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.MessageInsertion#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.MessageInsertion#Equal(a, b)
       <==> Seq#Equal(PivotBetreeSpec.MessageInsertion.key(a), PivotBetreeSpec.MessageInsertion.key(b))
         && ValueMessage.Message#Equal(PivotBetreeSpec.MessageInsertion.msg(a), PivotBetreeSpec.MessageInsertion.msg(b))
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.MessageInsertion.oldroot(a), 
          PivotBetreeSpec.MessageInsertion.oldroot(b))));

// Datatype extensionality axiom: PivotBetreeSpec.MessageInsertion
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.MessageInsertion#Equal(a, b) } 
  PivotBetreeSpec.MessageInsertion#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.MessageInsertion: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.NodeFlush.NodeFlush(int, 
    DatatypeType, 
    int, 
    DatatypeType, 
    int, 
    DatatypeType, 
    int, 
    Set Box, 
    DatatypeType, 
    Seq Box)
   : DatatypeType;

const unique ##PivotBetreeSpec.NodeFlush.NodeFlush: DtCtorId;

// Constructor identifier
axiom (forall a#38#0#0: int, 
    a#38#1#0: DatatypeType, 
    a#38#2#0: int, 
    a#38#3#0: DatatypeType, 
    a#38#4#0: int, 
    a#38#5#0: DatatypeType, 
    a#38#6#0: int, 
    a#38#7#0: Set Box, 
    a#38#8#0: DatatypeType, 
    a#38#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#38#0#0, 
      a#38#1#0, 
      a#38#2#0, 
      a#38#3#0, 
      a#38#4#0, 
      a#38#5#0, 
      a#38#6#0, 
      a#38#7#0, 
      a#38#8#0, 
      a#38#9#0) } 
  DatatypeCtorId(#PivotBetreeSpec.NodeFlush.NodeFlush(a#38#0#0, 
        a#38#1#0, 
        a#38#2#0, 
        a#38#3#0, 
        a#38#4#0, 
        a#38#5#0, 
        a#38#6#0, 
        a#38#7#0, 
        a#38#8#0, 
        a#38#9#0))
     == ##PivotBetreeSpec.NodeFlush.NodeFlush);

function PivotBetreeSpec.NodeFlush.NodeFlush_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.NodeFlush.NodeFlush_q(d) } 
  PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.NodeFlush.NodeFlush);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.NodeFlush.NodeFlush_q(d) } 
  PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
     ==> (exists a#39#0#0: int, 
        a#39#1#0: DatatypeType, 
        a#39#2#0: int, 
        a#39#3#0: DatatypeType, 
        a#39#4#0: int, 
        a#39#5#0: DatatypeType, 
        a#39#6#0: int, 
        a#39#7#0: Set Box, 
        a#39#8#0: DatatypeType, 
        a#39#9#0: Seq Box :: 
      d
         == #PivotBetreeSpec.NodeFlush.NodeFlush(a#39#0#0, 
          a#39#1#0, 
          a#39#2#0, 
          a#39#3#0, 
          a#39#4#0, 
          a#39#5#0, 
          a#39#6#0, 
          a#39#7#0, 
          a#39#8#0, 
          a#39#9#0)));

function Tclass.PivotBetreeSpec.NodeFlush() : Ty;

// Tclass.PivotBetreeSpec.NodeFlush Tag
axiom Tag(Tclass.PivotBetreeSpec.NodeFlush()) == Tagclass.PivotBetreeSpec.NodeFlush;

const unique Tagclass.PivotBetreeSpec.NodeFlush: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.NodeFlush
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.NodeFlush()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.NodeFlush())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.NodeFlush()));

// Constructor $Is
axiom (forall a#40#0#0: int, 
    a#40#1#0: DatatypeType, 
    a#40#2#0: int, 
    a#40#3#0: DatatypeType, 
    a#40#4#0: int, 
    a#40#5#0: DatatypeType, 
    a#40#6#0: int, 
    a#40#7#0: Set Box, 
    a#40#8#0: DatatypeType, 
    a#40#9#0: Seq Box :: 
  { $Is(#PivotBetreeSpec.NodeFlush.NodeFlush(a#40#0#0, 
        a#40#1#0, 
        a#40#2#0, 
        a#40#3#0, 
        a#40#4#0, 
        a#40#5#0, 
        a#40#6#0, 
        a#40#7#0, 
        a#40#8#0, 
        a#40#9#0), 
      Tclass.PivotBetreeSpec.NodeFlush()) } 
  $Is(#PivotBetreeSpec.NodeFlush.NodeFlush(a#40#0#0, 
        a#40#1#0, 
        a#40#2#0, 
        a#40#3#0, 
        a#40#4#0, 
        a#40#5#0, 
        a#40#6#0, 
        a#40#7#0, 
        a#40#8#0, 
        a#40#9#0), 
      Tclass.PivotBetreeSpec.NodeFlush())
     <==> $Is(a#40#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#40#1#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#40#2#0, Tclass.NativeTypes.uint64())
       && $Is(a#40#3#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#40#4#0, Tclass.NativeTypes.uint64())
       && $Is(a#40#5#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#40#6#0, TInt)
       && $Is(a#40#7#0, TSet(Tclass.KeyType.Key()))
       && $Is(a#40#8#0, Tclass.BucketsLib.Bucket())
       && $Is(a#40#9#0, TSeq(Tclass.BucketsLib.Bucket())));

// Constructor $IsAlloc
axiom (forall a#41#0#0: int, 
    a#41#1#0: DatatypeType, 
    a#41#2#0: int, 
    a#41#3#0: DatatypeType, 
    a#41#4#0: int, 
    a#41#5#0: DatatypeType, 
    a#41#6#0: int, 
    a#41#7#0: Set Box, 
    a#41#8#0: DatatypeType, 
    a#41#9#0: Seq Box, 
    $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.NodeFlush.NodeFlush(a#41#0#0, 
        a#41#1#0, 
        a#41#2#0, 
        a#41#3#0, 
        a#41#4#0, 
        a#41#5#0, 
        a#41#6#0, 
        a#41#7#0, 
        a#41#8#0, 
        a#41#9#0), 
      Tclass.PivotBetreeSpec.NodeFlush(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.NodeFlush.NodeFlush(a#41#0#0, 
          a#41#1#0, 
          a#41#2#0, 
          a#41#3#0, 
          a#41#4#0, 
          a#41#5#0, 
          a#41#6#0, 
          a#41#7#0, 
          a#41#8#0, 
          a#41#9#0), 
        Tclass.PivotBetreeSpec.NodeFlush(), 
        $h)
       <==> $IsAlloc(a#41#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#41#1#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#41#2#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#41#3#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#41#4#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#41#5#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#41#6#0, TInt, $h)
         && $IsAlloc(a#41#7#0, TSet(Tclass.KeyType.Key()), $h)
         && $IsAlloc(a#41#8#0, Tclass.BucketsLib.Bucket(), $h)
         && $IsAlloc(a#41#9#0, TSeq(Tclass.BucketsLib.Bucket()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.parentref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.parentref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.parent(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.parent(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.childref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.childref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.child(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.child(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.newchildref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.newchildref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.newchild(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.newchild(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.slotIndex(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.slotIndex(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.keys(d), TSet(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.keys(d), TSet(Tclass.KeyType.Key()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.newParentBucket(d), Tclass.BucketsLib.Bucket(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.newParentBucket(d), Tclass.BucketsLib.Bucket(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFlush.newChildBuckets(d), 
      TSeq(Tclass.BucketsLib.Bucket()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFlush.NodeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFlush(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFlush.newChildBuckets(d), 
      TSeq(Tclass.BucketsLib.Bucket()), 
      $h));

// Constructor literal
axiom (forall a#42#0#0: int, 
    a#42#1#0: DatatypeType, 
    a#42#2#0: int, 
    a#42#3#0: DatatypeType, 
    a#42#4#0: int, 
    a#42#5#0: DatatypeType, 
    a#42#6#0: int, 
    a#42#7#0: Set Box, 
    a#42#8#0: DatatypeType, 
    a#42#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(LitInt(a#42#0#0), 
      Lit(a#42#1#0), 
      LitInt(a#42#2#0), 
      Lit(a#42#3#0), 
      LitInt(a#42#4#0), 
      Lit(a#42#5#0), 
      LitInt(a#42#6#0), 
      Lit(a#42#7#0), 
      Lit(a#42#8#0), 
      Lit(a#42#9#0)) } 
  #PivotBetreeSpec.NodeFlush.NodeFlush(LitInt(a#42#0#0), 
      Lit(a#42#1#0), 
      LitInt(a#42#2#0), 
      Lit(a#42#3#0), 
      LitInt(a#42#4#0), 
      Lit(a#42#5#0), 
      LitInt(a#42#6#0), 
      Lit(a#42#7#0), 
      Lit(a#42#8#0), 
      Lit(a#42#9#0))
     == Lit(#PivotBetreeSpec.NodeFlush.NodeFlush(a#42#0#0, 
        a#42#1#0, 
        a#42#2#0, 
        a#42#3#0, 
        a#42#4#0, 
        a#42#5#0, 
        a#42#6#0, 
        a#42#7#0, 
        a#42#8#0, 
        a#42#9#0)));

function PivotBetreeSpec.NodeFlush.parentref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#43#0#0: int, 
    a#43#1#0: DatatypeType, 
    a#43#2#0: int, 
    a#43#3#0: DatatypeType, 
    a#43#4#0: int, 
    a#43#5#0: DatatypeType, 
    a#43#6#0: int, 
    a#43#7#0: Set Box, 
    a#43#8#0: DatatypeType, 
    a#43#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#43#0#0, 
      a#43#1#0, 
      a#43#2#0, 
      a#43#3#0, 
      a#43#4#0, 
      a#43#5#0, 
      a#43#6#0, 
      a#43#7#0, 
      a#43#8#0, 
      a#43#9#0) } 
  PivotBetreeSpec.NodeFlush.parentref(#PivotBetreeSpec.NodeFlush.NodeFlush(a#43#0#0, 
        a#43#1#0, 
        a#43#2#0, 
        a#43#3#0, 
        a#43#4#0, 
        a#43#5#0, 
        a#43#6#0, 
        a#43#7#0, 
        a#43#8#0, 
        a#43#9#0))
     == a#43#0#0);

function PivotBetreeSpec.NodeFlush.parent(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#44#0#0: int, 
    a#44#1#0: DatatypeType, 
    a#44#2#0: int, 
    a#44#3#0: DatatypeType, 
    a#44#4#0: int, 
    a#44#5#0: DatatypeType, 
    a#44#6#0: int, 
    a#44#7#0: Set Box, 
    a#44#8#0: DatatypeType, 
    a#44#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#44#0#0, 
      a#44#1#0, 
      a#44#2#0, 
      a#44#3#0, 
      a#44#4#0, 
      a#44#5#0, 
      a#44#6#0, 
      a#44#7#0, 
      a#44#8#0, 
      a#44#9#0) } 
  PivotBetreeSpec.NodeFlush.parent(#PivotBetreeSpec.NodeFlush.NodeFlush(a#44#0#0, 
        a#44#1#0, 
        a#44#2#0, 
        a#44#3#0, 
        a#44#4#0, 
        a#44#5#0, 
        a#44#6#0, 
        a#44#7#0, 
        a#44#8#0, 
        a#44#9#0))
     == a#44#1#0);

// Inductive rank
axiom (forall a#45#0#0: int, 
    a#45#1#0: DatatypeType, 
    a#45#2#0: int, 
    a#45#3#0: DatatypeType, 
    a#45#4#0: int, 
    a#45#5#0: DatatypeType, 
    a#45#6#0: int, 
    a#45#7#0: Set Box, 
    a#45#8#0: DatatypeType, 
    a#45#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#45#0#0, 
      a#45#1#0, 
      a#45#2#0, 
      a#45#3#0, 
      a#45#4#0, 
      a#45#5#0, 
      a#45#6#0, 
      a#45#7#0, 
      a#45#8#0, 
      a#45#9#0) } 
  DtRank(a#45#1#0)
     < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#45#0#0, 
        a#45#1#0, 
        a#45#2#0, 
        a#45#3#0, 
        a#45#4#0, 
        a#45#5#0, 
        a#45#6#0, 
        a#45#7#0, 
        a#45#8#0, 
        a#45#9#0)));

function PivotBetreeSpec.NodeFlush.childref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#46#0#0: int, 
    a#46#1#0: DatatypeType, 
    a#46#2#0: int, 
    a#46#3#0: DatatypeType, 
    a#46#4#0: int, 
    a#46#5#0: DatatypeType, 
    a#46#6#0: int, 
    a#46#7#0: Set Box, 
    a#46#8#0: DatatypeType, 
    a#46#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#46#0#0, 
      a#46#1#0, 
      a#46#2#0, 
      a#46#3#0, 
      a#46#4#0, 
      a#46#5#0, 
      a#46#6#0, 
      a#46#7#0, 
      a#46#8#0, 
      a#46#9#0) } 
  PivotBetreeSpec.NodeFlush.childref(#PivotBetreeSpec.NodeFlush.NodeFlush(a#46#0#0, 
        a#46#1#0, 
        a#46#2#0, 
        a#46#3#0, 
        a#46#4#0, 
        a#46#5#0, 
        a#46#6#0, 
        a#46#7#0, 
        a#46#8#0, 
        a#46#9#0))
     == a#46#2#0);

function PivotBetreeSpec.NodeFlush.child(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#47#0#0: int, 
    a#47#1#0: DatatypeType, 
    a#47#2#0: int, 
    a#47#3#0: DatatypeType, 
    a#47#4#0: int, 
    a#47#5#0: DatatypeType, 
    a#47#6#0: int, 
    a#47#7#0: Set Box, 
    a#47#8#0: DatatypeType, 
    a#47#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#47#0#0, 
      a#47#1#0, 
      a#47#2#0, 
      a#47#3#0, 
      a#47#4#0, 
      a#47#5#0, 
      a#47#6#0, 
      a#47#7#0, 
      a#47#8#0, 
      a#47#9#0) } 
  PivotBetreeSpec.NodeFlush.child(#PivotBetreeSpec.NodeFlush.NodeFlush(a#47#0#0, 
        a#47#1#0, 
        a#47#2#0, 
        a#47#3#0, 
        a#47#4#0, 
        a#47#5#0, 
        a#47#6#0, 
        a#47#7#0, 
        a#47#8#0, 
        a#47#9#0))
     == a#47#3#0);

// Inductive rank
axiom (forall a#48#0#0: int, 
    a#48#1#0: DatatypeType, 
    a#48#2#0: int, 
    a#48#3#0: DatatypeType, 
    a#48#4#0: int, 
    a#48#5#0: DatatypeType, 
    a#48#6#0: int, 
    a#48#7#0: Set Box, 
    a#48#8#0: DatatypeType, 
    a#48#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#48#0#0, 
      a#48#1#0, 
      a#48#2#0, 
      a#48#3#0, 
      a#48#4#0, 
      a#48#5#0, 
      a#48#6#0, 
      a#48#7#0, 
      a#48#8#0, 
      a#48#9#0) } 
  DtRank(a#48#3#0)
     < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#48#0#0, 
        a#48#1#0, 
        a#48#2#0, 
        a#48#3#0, 
        a#48#4#0, 
        a#48#5#0, 
        a#48#6#0, 
        a#48#7#0, 
        a#48#8#0, 
        a#48#9#0)));

function PivotBetreeSpec.NodeFlush.newchildref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#49#0#0: int, 
    a#49#1#0: DatatypeType, 
    a#49#2#0: int, 
    a#49#3#0: DatatypeType, 
    a#49#4#0: int, 
    a#49#5#0: DatatypeType, 
    a#49#6#0: int, 
    a#49#7#0: Set Box, 
    a#49#8#0: DatatypeType, 
    a#49#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#49#0#0, 
      a#49#1#0, 
      a#49#2#0, 
      a#49#3#0, 
      a#49#4#0, 
      a#49#5#0, 
      a#49#6#0, 
      a#49#7#0, 
      a#49#8#0, 
      a#49#9#0) } 
  PivotBetreeSpec.NodeFlush.newchildref(#PivotBetreeSpec.NodeFlush.NodeFlush(a#49#0#0, 
        a#49#1#0, 
        a#49#2#0, 
        a#49#3#0, 
        a#49#4#0, 
        a#49#5#0, 
        a#49#6#0, 
        a#49#7#0, 
        a#49#8#0, 
        a#49#9#0))
     == a#49#4#0);

function PivotBetreeSpec.NodeFlush.newchild(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#50#0#0: int, 
    a#50#1#0: DatatypeType, 
    a#50#2#0: int, 
    a#50#3#0: DatatypeType, 
    a#50#4#0: int, 
    a#50#5#0: DatatypeType, 
    a#50#6#0: int, 
    a#50#7#0: Set Box, 
    a#50#8#0: DatatypeType, 
    a#50#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#50#0#0, 
      a#50#1#0, 
      a#50#2#0, 
      a#50#3#0, 
      a#50#4#0, 
      a#50#5#0, 
      a#50#6#0, 
      a#50#7#0, 
      a#50#8#0, 
      a#50#9#0) } 
  PivotBetreeSpec.NodeFlush.newchild(#PivotBetreeSpec.NodeFlush.NodeFlush(a#50#0#0, 
        a#50#1#0, 
        a#50#2#0, 
        a#50#3#0, 
        a#50#4#0, 
        a#50#5#0, 
        a#50#6#0, 
        a#50#7#0, 
        a#50#8#0, 
        a#50#9#0))
     == a#50#5#0);

// Inductive rank
axiom (forall a#51#0#0: int, 
    a#51#1#0: DatatypeType, 
    a#51#2#0: int, 
    a#51#3#0: DatatypeType, 
    a#51#4#0: int, 
    a#51#5#0: DatatypeType, 
    a#51#6#0: int, 
    a#51#7#0: Set Box, 
    a#51#8#0: DatatypeType, 
    a#51#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#51#0#0, 
      a#51#1#0, 
      a#51#2#0, 
      a#51#3#0, 
      a#51#4#0, 
      a#51#5#0, 
      a#51#6#0, 
      a#51#7#0, 
      a#51#8#0, 
      a#51#9#0) } 
  DtRank(a#51#5#0)
     < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#51#0#0, 
        a#51#1#0, 
        a#51#2#0, 
        a#51#3#0, 
        a#51#4#0, 
        a#51#5#0, 
        a#51#6#0, 
        a#51#7#0, 
        a#51#8#0, 
        a#51#9#0)));

function PivotBetreeSpec.NodeFlush.slotIndex(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#52#0#0: int, 
    a#52#1#0: DatatypeType, 
    a#52#2#0: int, 
    a#52#3#0: DatatypeType, 
    a#52#4#0: int, 
    a#52#5#0: DatatypeType, 
    a#52#6#0: int, 
    a#52#7#0: Set Box, 
    a#52#8#0: DatatypeType, 
    a#52#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#52#0#0, 
      a#52#1#0, 
      a#52#2#0, 
      a#52#3#0, 
      a#52#4#0, 
      a#52#5#0, 
      a#52#6#0, 
      a#52#7#0, 
      a#52#8#0, 
      a#52#9#0) } 
  PivotBetreeSpec.NodeFlush.slotIndex(#PivotBetreeSpec.NodeFlush.NodeFlush(a#52#0#0, 
        a#52#1#0, 
        a#52#2#0, 
        a#52#3#0, 
        a#52#4#0, 
        a#52#5#0, 
        a#52#6#0, 
        a#52#7#0, 
        a#52#8#0, 
        a#52#9#0))
     == a#52#6#0);

function PivotBetreeSpec.NodeFlush.keys(DatatypeType) : Set Box;

// Constructor injectivity
axiom (forall a#53#0#0: int, 
    a#53#1#0: DatatypeType, 
    a#53#2#0: int, 
    a#53#3#0: DatatypeType, 
    a#53#4#0: int, 
    a#53#5#0: DatatypeType, 
    a#53#6#0: int, 
    a#53#7#0: Set Box, 
    a#53#8#0: DatatypeType, 
    a#53#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#53#0#0, 
      a#53#1#0, 
      a#53#2#0, 
      a#53#3#0, 
      a#53#4#0, 
      a#53#5#0, 
      a#53#6#0, 
      a#53#7#0, 
      a#53#8#0, 
      a#53#9#0) } 
  PivotBetreeSpec.NodeFlush.keys(#PivotBetreeSpec.NodeFlush.NodeFlush(a#53#0#0, 
        a#53#1#0, 
        a#53#2#0, 
        a#53#3#0, 
        a#53#4#0, 
        a#53#5#0, 
        a#53#6#0, 
        a#53#7#0, 
        a#53#8#0, 
        a#53#9#0))
     == a#53#7#0);

// Inductive set element rank
axiom (forall a#54#0#0: int, 
    a#54#1#0: DatatypeType, 
    a#54#2#0: int, 
    a#54#3#0: DatatypeType, 
    a#54#4#0: int, 
    a#54#5#0: DatatypeType, 
    a#54#6#0: int, 
    a#54#7#0: Set Box, 
    a#54#8#0: DatatypeType, 
    a#54#9#0: Seq Box, 
    d: DatatypeType :: 
  { a#54#7#0[$Box(d)], #PivotBetreeSpec.NodeFlush.NodeFlush(a#54#0#0, 
      a#54#1#0, 
      a#54#2#0, 
      a#54#3#0, 
      a#54#4#0, 
      a#54#5#0, 
      a#54#6#0, 
      a#54#7#0, 
      a#54#8#0, 
      a#54#9#0) } 
  a#54#7#0[$Box(d)]
     ==> DtRank(d)
       < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#54#0#0, 
          a#54#1#0, 
          a#54#2#0, 
          a#54#3#0, 
          a#54#4#0, 
          a#54#5#0, 
          a#54#6#0, 
          a#54#7#0, 
          a#54#8#0, 
          a#54#9#0)));

function PivotBetreeSpec.NodeFlush.newParentBucket(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#55#0#0: int, 
    a#55#1#0: DatatypeType, 
    a#55#2#0: int, 
    a#55#3#0: DatatypeType, 
    a#55#4#0: int, 
    a#55#5#0: DatatypeType, 
    a#55#6#0: int, 
    a#55#7#0: Set Box, 
    a#55#8#0: DatatypeType, 
    a#55#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#55#0#0, 
      a#55#1#0, 
      a#55#2#0, 
      a#55#3#0, 
      a#55#4#0, 
      a#55#5#0, 
      a#55#6#0, 
      a#55#7#0, 
      a#55#8#0, 
      a#55#9#0) } 
  PivotBetreeSpec.NodeFlush.newParentBucket(#PivotBetreeSpec.NodeFlush.NodeFlush(a#55#0#0, 
        a#55#1#0, 
        a#55#2#0, 
        a#55#3#0, 
        a#55#4#0, 
        a#55#5#0, 
        a#55#6#0, 
        a#55#7#0, 
        a#55#8#0, 
        a#55#9#0))
     == a#55#8#0);

// Inductive rank
axiom (forall a#56#0#0: int, 
    a#56#1#0: DatatypeType, 
    a#56#2#0: int, 
    a#56#3#0: DatatypeType, 
    a#56#4#0: int, 
    a#56#5#0: DatatypeType, 
    a#56#6#0: int, 
    a#56#7#0: Set Box, 
    a#56#8#0: DatatypeType, 
    a#56#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#56#0#0, 
      a#56#1#0, 
      a#56#2#0, 
      a#56#3#0, 
      a#56#4#0, 
      a#56#5#0, 
      a#56#6#0, 
      a#56#7#0, 
      a#56#8#0, 
      a#56#9#0) } 
  DtRank(a#56#8#0)
     < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#56#0#0, 
        a#56#1#0, 
        a#56#2#0, 
        a#56#3#0, 
        a#56#4#0, 
        a#56#5#0, 
        a#56#6#0, 
        a#56#7#0, 
        a#56#8#0, 
        a#56#9#0)));

function PivotBetreeSpec.NodeFlush.newChildBuckets(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#57#0#0: int, 
    a#57#1#0: DatatypeType, 
    a#57#2#0: int, 
    a#57#3#0: DatatypeType, 
    a#57#4#0: int, 
    a#57#5#0: DatatypeType, 
    a#57#6#0: int, 
    a#57#7#0: Set Box, 
    a#57#8#0: DatatypeType, 
    a#57#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#57#0#0, 
      a#57#1#0, 
      a#57#2#0, 
      a#57#3#0, 
      a#57#4#0, 
      a#57#5#0, 
      a#57#6#0, 
      a#57#7#0, 
      a#57#8#0, 
      a#57#9#0) } 
  PivotBetreeSpec.NodeFlush.newChildBuckets(#PivotBetreeSpec.NodeFlush.NodeFlush(a#57#0#0, 
        a#57#1#0, 
        a#57#2#0, 
        a#57#3#0, 
        a#57#4#0, 
        a#57#5#0, 
        a#57#6#0, 
        a#57#7#0, 
        a#57#8#0, 
        a#57#9#0))
     == a#57#9#0);

// Inductive seq element rank
axiom (forall a#58#0#0: int, 
    a#58#1#0: DatatypeType, 
    a#58#2#0: int, 
    a#58#3#0: DatatypeType, 
    a#58#4#0: int, 
    a#58#5#0: DatatypeType, 
    a#58#6#0: int, 
    a#58#7#0: Set Box, 
    a#58#8#0: DatatypeType, 
    a#58#9#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#58#9#0, i), #PivotBetreeSpec.NodeFlush.NodeFlush(a#58#0#0, 
      a#58#1#0, 
      a#58#2#0, 
      a#58#3#0, 
      a#58#4#0, 
      a#58#5#0, 
      a#58#6#0, 
      a#58#7#0, 
      a#58#8#0, 
      a#58#9#0) } 
  0 <= i && i < Seq#Length(a#58#9#0)
     ==> DtRank($Unbox(Seq#Index(a#58#9#0, i)): DatatypeType)
       < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#58#0#0, 
          a#58#1#0, 
          a#58#2#0, 
          a#58#3#0, 
          a#58#4#0, 
          a#58#5#0, 
          a#58#6#0, 
          a#58#7#0, 
          a#58#8#0, 
          a#58#9#0)));

// Inductive seq rank
axiom (forall a#59#0#0: int, 
    a#59#1#0: DatatypeType, 
    a#59#2#0: int, 
    a#59#3#0: DatatypeType, 
    a#59#4#0: int, 
    a#59#5#0: DatatypeType, 
    a#59#6#0: int, 
    a#59#7#0: Set Box, 
    a#59#8#0: DatatypeType, 
    a#59#9#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFlush.NodeFlush(a#59#0#0, 
      a#59#1#0, 
      a#59#2#0, 
      a#59#3#0, 
      a#59#4#0, 
      a#59#5#0, 
      a#59#6#0, 
      a#59#7#0, 
      a#59#8#0, 
      a#59#9#0) } 
  Seq#Rank(a#59#9#0)
     < DtRank(#PivotBetreeSpec.NodeFlush.NodeFlush(a#59#0#0, 
        a#59#1#0, 
        a#59#2#0, 
        a#59#3#0, 
        a#59#4#0, 
        a#59#5#0, 
        a#59#6#0, 
        a#59#7#0, 
        a#59#8#0, 
        a#59#9#0)));

// Depth-one case-split function
function $IsA#PivotBetreeSpec.NodeFlush(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.NodeFlush(d) } 
  $IsA#PivotBetreeSpec.NodeFlush(d) ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.NodeFlush.NodeFlush_q(d), $Is(d, Tclass.PivotBetreeSpec.NodeFlush()) } 
  $Is(d, Tclass.PivotBetreeSpec.NodeFlush())
     ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.NodeFlush#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.NodeFlush.NodeFlush
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.NodeFlush#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.NodeFlush#Equal(a, b)
       <==> PivotBetreeSpec.NodeFlush.parentref(a) == PivotBetreeSpec.NodeFlush.parentref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFlush.parent(a), PivotBetreeSpec.NodeFlush.parent(b))
         && PivotBetreeSpec.NodeFlush.childref(a) == PivotBetreeSpec.NodeFlush.childref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFlush.child(a), PivotBetreeSpec.NodeFlush.child(b))
         && PivotBetreeSpec.NodeFlush.newchildref(a)
           == PivotBetreeSpec.NodeFlush.newchildref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFlush.newchild(a), PivotBetreeSpec.NodeFlush.newchild(b))
         && PivotBetreeSpec.NodeFlush.slotIndex(a) == PivotBetreeSpec.NodeFlush.slotIndex(b)
         && Set#Equal(PivotBetreeSpec.NodeFlush.keys(a), PivotBetreeSpec.NodeFlush.keys(b))
         && BucketsLib.Bucket#Equal(PivotBetreeSpec.NodeFlush.newParentBucket(a), 
          PivotBetreeSpec.NodeFlush.newParentBucket(b))
         && Seq#Equal(PivotBetreeSpec.NodeFlush.newChildBuckets(a), 
          PivotBetreeSpec.NodeFlush.newChildBuckets(b))));

// Datatype extensionality axiom: PivotBetreeSpec.NodeFlush
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.NodeFlush#Equal(a, b) } 
  PivotBetreeSpec.NodeFlush#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.NodeFlush: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.RootGrowth.RootGrowth(DatatypeType, int) : DatatypeType;

const unique ##PivotBetreeSpec.RootGrowth.RootGrowth: DtCtorId;

// Constructor identifier
axiom (forall a#60#0#0: DatatypeType, a#60#1#0: int :: 
  { #PivotBetreeSpec.RootGrowth.RootGrowth(a#60#0#0, a#60#1#0) } 
  DatatypeCtorId(#PivotBetreeSpec.RootGrowth.RootGrowth(a#60#0#0, a#60#1#0))
     == ##PivotBetreeSpec.RootGrowth.RootGrowth);

function PivotBetreeSpec.RootGrowth.RootGrowth_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.RootGrowth.RootGrowth_q(d) } 
  PivotBetreeSpec.RootGrowth.RootGrowth_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.RootGrowth.RootGrowth);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.RootGrowth.RootGrowth_q(d) } 
  PivotBetreeSpec.RootGrowth.RootGrowth_q(d)
     ==> (exists a#61#0#0: DatatypeType, a#61#1#0: int :: 
      d == #PivotBetreeSpec.RootGrowth.RootGrowth(a#61#0#0, a#61#1#0)));

function Tclass.PivotBetreeSpec.RootGrowth() : Ty;

// Tclass.PivotBetreeSpec.RootGrowth Tag
axiom Tag(Tclass.PivotBetreeSpec.RootGrowth()) == Tagclass.PivotBetreeSpec.RootGrowth;

const unique Tagclass.PivotBetreeSpec.RootGrowth: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.RootGrowth
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.RootGrowth()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.RootGrowth())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.RootGrowth()));

// Constructor $Is
axiom (forall a#62#0#0: DatatypeType, a#62#1#0: int :: 
  { $Is(#PivotBetreeSpec.RootGrowth.RootGrowth(a#62#0#0, a#62#1#0), 
      Tclass.PivotBetreeSpec.RootGrowth()) } 
  $Is(#PivotBetreeSpec.RootGrowth.RootGrowth(a#62#0#0, a#62#1#0), 
      Tclass.PivotBetreeSpec.RootGrowth())
     <==> $Is(a#62#0#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#62#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#63#0#0: DatatypeType, a#63#1#0: int, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.RootGrowth.RootGrowth(a#63#0#0, a#63#1#0), 
      Tclass.PivotBetreeSpec.RootGrowth(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.RootGrowth.RootGrowth(a#63#0#0, a#63#1#0), 
        Tclass.PivotBetreeSpec.RootGrowth(), 
        $h)
       <==> $IsAlloc(a#63#0#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#63#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.RootGrowth.oldroot(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.RootGrowth.RootGrowth_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.RootGrowth(), $h)
     ==> $IsAlloc(PivotBetreeSpec.RootGrowth.oldroot(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.RootGrowth.newchildref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.RootGrowth.RootGrowth_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.RootGrowth(), $h)
     ==> $IsAlloc(PivotBetreeSpec.RootGrowth.newchildref(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#64#0#0: DatatypeType, a#64#1#0: int :: 
  { #PivotBetreeSpec.RootGrowth.RootGrowth(Lit(a#64#0#0), LitInt(a#64#1#0)) } 
  #PivotBetreeSpec.RootGrowth.RootGrowth(Lit(a#64#0#0), LitInt(a#64#1#0))
     == Lit(#PivotBetreeSpec.RootGrowth.RootGrowth(a#64#0#0, a#64#1#0)));

function PivotBetreeSpec.RootGrowth.oldroot(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#65#0#0: DatatypeType, a#65#1#0: int :: 
  { #PivotBetreeSpec.RootGrowth.RootGrowth(a#65#0#0, a#65#1#0) } 
  PivotBetreeSpec.RootGrowth.oldroot(#PivotBetreeSpec.RootGrowth.RootGrowth(a#65#0#0, a#65#1#0))
     == a#65#0#0);

// Inductive rank
axiom (forall a#66#0#0: DatatypeType, a#66#1#0: int :: 
  { #PivotBetreeSpec.RootGrowth.RootGrowth(a#66#0#0, a#66#1#0) } 
  DtRank(a#66#0#0)
     < DtRank(#PivotBetreeSpec.RootGrowth.RootGrowth(a#66#0#0, a#66#1#0)));

function PivotBetreeSpec.RootGrowth.newchildref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#67#0#0: DatatypeType, a#67#1#0: int :: 
  { #PivotBetreeSpec.RootGrowth.RootGrowth(a#67#0#0, a#67#1#0) } 
  PivotBetreeSpec.RootGrowth.newchildref(#PivotBetreeSpec.RootGrowth.RootGrowth(a#67#0#0, a#67#1#0))
     == a#67#1#0);

// Depth-one case-split function
function $IsA#PivotBetreeSpec.RootGrowth(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.RootGrowth(d) } 
  $IsA#PivotBetreeSpec.RootGrowth(d)
     ==> PivotBetreeSpec.RootGrowth.RootGrowth_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.RootGrowth.RootGrowth_q(d), $Is(d, Tclass.PivotBetreeSpec.RootGrowth()) } 
  $Is(d, Tclass.PivotBetreeSpec.RootGrowth())
     ==> PivotBetreeSpec.RootGrowth.RootGrowth_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.RootGrowth#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.RootGrowth.RootGrowth
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.RootGrowth#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.RootGrowth#Equal(a, b)
       <==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.RootGrowth.oldroot(a), PivotBetreeSpec.RootGrowth.oldroot(b))
         && PivotBetreeSpec.RootGrowth.newchildref(a)
           == PivotBetreeSpec.RootGrowth.newchildref(b)));

// Datatype extensionality axiom: PivotBetreeSpec.RootGrowth
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.RootGrowth#Equal(a, b) } 
  PivotBetreeSpec.RootGrowth#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.RootGrowth: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.NodeFusion.NodeFusion(int, 
    int, 
    int, 
    int, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    int, 
    int, 
    Seq Box)
   : DatatypeType;

const unique ##PivotBetreeSpec.NodeFusion.NodeFusion: DtCtorId;

// Constructor identifier
axiom (forall a#68#0#0: int, 
    a#68#1#0: int, 
    a#68#2#0: int, 
    a#68#3#0: int, 
    a#68#4#0: DatatypeType, 
    a#68#5#0: DatatypeType, 
    a#68#6#0: DatatypeType, 
    a#68#7#0: DatatypeType, 
    a#68#8#0: DatatypeType, 
    a#68#9#0: int, 
    a#68#10#0: int, 
    a#68#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#68#0#0, 
      a#68#1#0, 
      a#68#2#0, 
      a#68#3#0, 
      a#68#4#0, 
      a#68#5#0, 
      a#68#6#0, 
      a#68#7#0, 
      a#68#8#0, 
      a#68#9#0, 
      a#68#10#0, 
      a#68#11#0) } 
  DatatypeCtorId(#PivotBetreeSpec.NodeFusion.NodeFusion(a#68#0#0, 
        a#68#1#0, 
        a#68#2#0, 
        a#68#3#0, 
        a#68#4#0, 
        a#68#5#0, 
        a#68#6#0, 
        a#68#7#0, 
        a#68#8#0, 
        a#68#9#0, 
        a#68#10#0, 
        a#68#11#0))
     == ##PivotBetreeSpec.NodeFusion.NodeFusion);

function PivotBetreeSpec.NodeFusion.NodeFusion_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.NodeFusion.NodeFusion_q(d) } 
  PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.NodeFusion.NodeFusion);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.NodeFusion.NodeFusion_q(d) } 
  PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
     ==> (exists a#69#0#0: int, 
        a#69#1#0: int, 
        a#69#2#0: int, 
        a#69#3#0: int, 
        a#69#4#0: DatatypeType, 
        a#69#5#0: DatatypeType, 
        a#69#6#0: DatatypeType, 
        a#69#7#0: DatatypeType, 
        a#69#8#0: DatatypeType, 
        a#69#9#0: int, 
        a#69#10#0: int, 
        a#69#11#0: Seq Box :: 
      d
         == #PivotBetreeSpec.NodeFusion.NodeFusion(a#69#0#0, 
          a#69#1#0, 
          a#69#2#0, 
          a#69#3#0, 
          a#69#4#0, 
          a#69#5#0, 
          a#69#6#0, 
          a#69#7#0, 
          a#69#8#0, 
          a#69#9#0, 
          a#69#10#0, 
          a#69#11#0)));

function Tclass.PivotBetreeSpec.NodeFusion() : Ty;

// Tclass.PivotBetreeSpec.NodeFusion Tag
axiom Tag(Tclass.PivotBetreeSpec.NodeFusion()) == Tagclass.PivotBetreeSpec.NodeFusion;

const unique Tagclass.PivotBetreeSpec.NodeFusion: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.NodeFusion
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.NodeFusion()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.NodeFusion())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.NodeFusion()));

// Constructor $Is
axiom (forall a#70#0#0: int, 
    a#70#1#0: int, 
    a#70#2#0: int, 
    a#70#3#0: int, 
    a#70#4#0: DatatypeType, 
    a#70#5#0: DatatypeType, 
    a#70#6#0: DatatypeType, 
    a#70#7#0: DatatypeType, 
    a#70#8#0: DatatypeType, 
    a#70#9#0: int, 
    a#70#10#0: int, 
    a#70#11#0: Seq Box :: 
  { $Is(#PivotBetreeSpec.NodeFusion.NodeFusion(a#70#0#0, 
        a#70#1#0, 
        a#70#2#0, 
        a#70#3#0, 
        a#70#4#0, 
        a#70#5#0, 
        a#70#6#0, 
        a#70#7#0, 
        a#70#8#0, 
        a#70#9#0, 
        a#70#10#0, 
        a#70#11#0), 
      Tclass.PivotBetreeSpec.NodeFusion()) } 
  $Is(#PivotBetreeSpec.NodeFusion.NodeFusion(a#70#0#0, 
        a#70#1#0, 
        a#70#2#0, 
        a#70#3#0, 
        a#70#4#0, 
        a#70#5#0, 
        a#70#6#0, 
        a#70#7#0, 
        a#70#8#0, 
        a#70#9#0, 
        a#70#10#0, 
        a#70#11#0), 
      Tclass.PivotBetreeSpec.NodeFusion())
     <==> $Is(a#70#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#70#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#70#2#0, Tclass.NativeTypes.uint64())
       && $Is(a#70#3#0, Tclass.NativeTypes.uint64())
       && $Is(a#70#4#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#70#5#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#70#6#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#70#7#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#70#8#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#70#9#0, TInt)
       && $Is(a#70#10#0, TInt)
       && $Is(a#70#11#0, Tclass.KeyType.Key()));

// Constructor $IsAlloc
axiom (forall a#71#0#0: int, 
    a#71#1#0: int, 
    a#71#2#0: int, 
    a#71#3#0: int, 
    a#71#4#0: DatatypeType, 
    a#71#5#0: DatatypeType, 
    a#71#6#0: DatatypeType, 
    a#71#7#0: DatatypeType, 
    a#71#8#0: DatatypeType, 
    a#71#9#0: int, 
    a#71#10#0: int, 
    a#71#11#0: Seq Box, 
    $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.NodeFusion.NodeFusion(a#71#0#0, 
        a#71#1#0, 
        a#71#2#0, 
        a#71#3#0, 
        a#71#4#0, 
        a#71#5#0, 
        a#71#6#0, 
        a#71#7#0, 
        a#71#8#0, 
        a#71#9#0, 
        a#71#10#0, 
        a#71#11#0), 
      Tclass.PivotBetreeSpec.NodeFusion(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.NodeFusion.NodeFusion(a#71#0#0, 
          a#71#1#0, 
          a#71#2#0, 
          a#71#3#0, 
          a#71#4#0, 
          a#71#5#0, 
          a#71#6#0, 
          a#71#7#0, 
          a#71#8#0, 
          a#71#9#0, 
          a#71#10#0, 
          a#71#11#0), 
        Tclass.PivotBetreeSpec.NodeFusion(), 
        $h)
       <==> $IsAlloc(a#71#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#71#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#71#2#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#71#3#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#71#4#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#71#5#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#71#6#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#71#7#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#71#8#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#71#9#0, TInt, $h)
         && $IsAlloc(a#71#10#0, TInt, $h)
         && $IsAlloc(a#71#11#0, Tclass.KeyType.Key(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.parentref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.parentref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.fused__childref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.fused__childref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.left__childref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.left__childref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.right__childref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.right__childref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.fused__parent(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.fused__parent(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.split__parent(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.split__parent(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.fused__child(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.fused__child(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.left__child(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.left__child(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.right__child(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.right__child(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.slot__idx(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.slot__idx(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.num__children__left(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.num__children__left(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.NodeFusion.pivot(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.NodeFusion.NodeFusion_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.NodeFusion(), $h)
     ==> $IsAlloc(PivotBetreeSpec.NodeFusion.pivot(d), Tclass.KeyType.Key(), $h));

// Constructor literal
axiom (forall a#72#0#0: int, 
    a#72#1#0: int, 
    a#72#2#0: int, 
    a#72#3#0: int, 
    a#72#4#0: DatatypeType, 
    a#72#5#0: DatatypeType, 
    a#72#6#0: DatatypeType, 
    a#72#7#0: DatatypeType, 
    a#72#8#0: DatatypeType, 
    a#72#9#0: int, 
    a#72#10#0: int, 
    a#72#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(LitInt(a#72#0#0), 
      LitInt(a#72#1#0), 
      LitInt(a#72#2#0), 
      LitInt(a#72#3#0), 
      Lit(a#72#4#0), 
      Lit(a#72#5#0), 
      Lit(a#72#6#0), 
      Lit(a#72#7#0), 
      Lit(a#72#8#0), 
      LitInt(a#72#9#0), 
      LitInt(a#72#10#0), 
      Lit(a#72#11#0)) } 
  #PivotBetreeSpec.NodeFusion.NodeFusion(LitInt(a#72#0#0), 
      LitInt(a#72#1#0), 
      LitInt(a#72#2#0), 
      LitInt(a#72#3#0), 
      Lit(a#72#4#0), 
      Lit(a#72#5#0), 
      Lit(a#72#6#0), 
      Lit(a#72#7#0), 
      Lit(a#72#8#0), 
      LitInt(a#72#9#0), 
      LitInt(a#72#10#0), 
      Lit(a#72#11#0))
     == Lit(#PivotBetreeSpec.NodeFusion.NodeFusion(a#72#0#0, 
        a#72#1#0, 
        a#72#2#0, 
        a#72#3#0, 
        a#72#4#0, 
        a#72#5#0, 
        a#72#6#0, 
        a#72#7#0, 
        a#72#8#0, 
        a#72#9#0, 
        a#72#10#0, 
        a#72#11#0)));

function PivotBetreeSpec.NodeFusion.parentref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#73#0#0: int, 
    a#73#1#0: int, 
    a#73#2#0: int, 
    a#73#3#0: int, 
    a#73#4#0: DatatypeType, 
    a#73#5#0: DatatypeType, 
    a#73#6#0: DatatypeType, 
    a#73#7#0: DatatypeType, 
    a#73#8#0: DatatypeType, 
    a#73#9#0: int, 
    a#73#10#0: int, 
    a#73#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#73#0#0, 
      a#73#1#0, 
      a#73#2#0, 
      a#73#3#0, 
      a#73#4#0, 
      a#73#5#0, 
      a#73#6#0, 
      a#73#7#0, 
      a#73#8#0, 
      a#73#9#0, 
      a#73#10#0, 
      a#73#11#0) } 
  PivotBetreeSpec.NodeFusion.parentref(#PivotBetreeSpec.NodeFusion.NodeFusion(a#73#0#0, 
        a#73#1#0, 
        a#73#2#0, 
        a#73#3#0, 
        a#73#4#0, 
        a#73#5#0, 
        a#73#6#0, 
        a#73#7#0, 
        a#73#8#0, 
        a#73#9#0, 
        a#73#10#0, 
        a#73#11#0))
     == a#73#0#0);

function PivotBetreeSpec.NodeFusion.fused__childref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#74#0#0: int, 
    a#74#1#0: int, 
    a#74#2#0: int, 
    a#74#3#0: int, 
    a#74#4#0: DatatypeType, 
    a#74#5#0: DatatypeType, 
    a#74#6#0: DatatypeType, 
    a#74#7#0: DatatypeType, 
    a#74#8#0: DatatypeType, 
    a#74#9#0: int, 
    a#74#10#0: int, 
    a#74#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#74#0#0, 
      a#74#1#0, 
      a#74#2#0, 
      a#74#3#0, 
      a#74#4#0, 
      a#74#5#0, 
      a#74#6#0, 
      a#74#7#0, 
      a#74#8#0, 
      a#74#9#0, 
      a#74#10#0, 
      a#74#11#0) } 
  PivotBetreeSpec.NodeFusion.fused__childref(#PivotBetreeSpec.NodeFusion.NodeFusion(a#74#0#0, 
        a#74#1#0, 
        a#74#2#0, 
        a#74#3#0, 
        a#74#4#0, 
        a#74#5#0, 
        a#74#6#0, 
        a#74#7#0, 
        a#74#8#0, 
        a#74#9#0, 
        a#74#10#0, 
        a#74#11#0))
     == a#74#1#0);

function PivotBetreeSpec.NodeFusion.left__childref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#75#0#0: int, 
    a#75#1#0: int, 
    a#75#2#0: int, 
    a#75#3#0: int, 
    a#75#4#0: DatatypeType, 
    a#75#5#0: DatatypeType, 
    a#75#6#0: DatatypeType, 
    a#75#7#0: DatatypeType, 
    a#75#8#0: DatatypeType, 
    a#75#9#0: int, 
    a#75#10#0: int, 
    a#75#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#75#0#0, 
      a#75#1#0, 
      a#75#2#0, 
      a#75#3#0, 
      a#75#4#0, 
      a#75#5#0, 
      a#75#6#0, 
      a#75#7#0, 
      a#75#8#0, 
      a#75#9#0, 
      a#75#10#0, 
      a#75#11#0) } 
  PivotBetreeSpec.NodeFusion.left__childref(#PivotBetreeSpec.NodeFusion.NodeFusion(a#75#0#0, 
        a#75#1#0, 
        a#75#2#0, 
        a#75#3#0, 
        a#75#4#0, 
        a#75#5#0, 
        a#75#6#0, 
        a#75#7#0, 
        a#75#8#0, 
        a#75#9#0, 
        a#75#10#0, 
        a#75#11#0))
     == a#75#2#0);

function PivotBetreeSpec.NodeFusion.right__childref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#76#0#0: int, 
    a#76#1#0: int, 
    a#76#2#0: int, 
    a#76#3#0: int, 
    a#76#4#0: DatatypeType, 
    a#76#5#0: DatatypeType, 
    a#76#6#0: DatatypeType, 
    a#76#7#0: DatatypeType, 
    a#76#8#0: DatatypeType, 
    a#76#9#0: int, 
    a#76#10#0: int, 
    a#76#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#76#0#0, 
      a#76#1#0, 
      a#76#2#0, 
      a#76#3#0, 
      a#76#4#0, 
      a#76#5#0, 
      a#76#6#0, 
      a#76#7#0, 
      a#76#8#0, 
      a#76#9#0, 
      a#76#10#0, 
      a#76#11#0) } 
  PivotBetreeSpec.NodeFusion.right__childref(#PivotBetreeSpec.NodeFusion.NodeFusion(a#76#0#0, 
        a#76#1#0, 
        a#76#2#0, 
        a#76#3#0, 
        a#76#4#0, 
        a#76#5#0, 
        a#76#6#0, 
        a#76#7#0, 
        a#76#8#0, 
        a#76#9#0, 
        a#76#10#0, 
        a#76#11#0))
     == a#76#3#0);

function PivotBetreeSpec.NodeFusion.fused__parent(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#77#0#0: int, 
    a#77#1#0: int, 
    a#77#2#0: int, 
    a#77#3#0: int, 
    a#77#4#0: DatatypeType, 
    a#77#5#0: DatatypeType, 
    a#77#6#0: DatatypeType, 
    a#77#7#0: DatatypeType, 
    a#77#8#0: DatatypeType, 
    a#77#9#0: int, 
    a#77#10#0: int, 
    a#77#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#77#0#0, 
      a#77#1#0, 
      a#77#2#0, 
      a#77#3#0, 
      a#77#4#0, 
      a#77#5#0, 
      a#77#6#0, 
      a#77#7#0, 
      a#77#8#0, 
      a#77#9#0, 
      a#77#10#0, 
      a#77#11#0) } 
  PivotBetreeSpec.NodeFusion.fused__parent(#PivotBetreeSpec.NodeFusion.NodeFusion(a#77#0#0, 
        a#77#1#0, 
        a#77#2#0, 
        a#77#3#0, 
        a#77#4#0, 
        a#77#5#0, 
        a#77#6#0, 
        a#77#7#0, 
        a#77#8#0, 
        a#77#9#0, 
        a#77#10#0, 
        a#77#11#0))
     == a#77#4#0);

// Inductive rank
axiom (forall a#78#0#0: int, 
    a#78#1#0: int, 
    a#78#2#0: int, 
    a#78#3#0: int, 
    a#78#4#0: DatatypeType, 
    a#78#5#0: DatatypeType, 
    a#78#6#0: DatatypeType, 
    a#78#7#0: DatatypeType, 
    a#78#8#0: DatatypeType, 
    a#78#9#0: int, 
    a#78#10#0: int, 
    a#78#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#78#0#0, 
      a#78#1#0, 
      a#78#2#0, 
      a#78#3#0, 
      a#78#4#0, 
      a#78#5#0, 
      a#78#6#0, 
      a#78#7#0, 
      a#78#8#0, 
      a#78#9#0, 
      a#78#10#0, 
      a#78#11#0) } 
  DtRank(a#78#4#0)
     < DtRank(#PivotBetreeSpec.NodeFusion.NodeFusion(a#78#0#0, 
        a#78#1#0, 
        a#78#2#0, 
        a#78#3#0, 
        a#78#4#0, 
        a#78#5#0, 
        a#78#6#0, 
        a#78#7#0, 
        a#78#8#0, 
        a#78#9#0, 
        a#78#10#0, 
        a#78#11#0)));

function PivotBetreeSpec.NodeFusion.split__parent(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#79#0#0: int, 
    a#79#1#0: int, 
    a#79#2#0: int, 
    a#79#3#0: int, 
    a#79#4#0: DatatypeType, 
    a#79#5#0: DatatypeType, 
    a#79#6#0: DatatypeType, 
    a#79#7#0: DatatypeType, 
    a#79#8#0: DatatypeType, 
    a#79#9#0: int, 
    a#79#10#0: int, 
    a#79#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#79#0#0, 
      a#79#1#0, 
      a#79#2#0, 
      a#79#3#0, 
      a#79#4#0, 
      a#79#5#0, 
      a#79#6#0, 
      a#79#7#0, 
      a#79#8#0, 
      a#79#9#0, 
      a#79#10#0, 
      a#79#11#0) } 
  PivotBetreeSpec.NodeFusion.split__parent(#PivotBetreeSpec.NodeFusion.NodeFusion(a#79#0#0, 
        a#79#1#0, 
        a#79#2#0, 
        a#79#3#0, 
        a#79#4#0, 
        a#79#5#0, 
        a#79#6#0, 
        a#79#7#0, 
        a#79#8#0, 
        a#79#9#0, 
        a#79#10#0, 
        a#79#11#0))
     == a#79#5#0);

// Inductive rank
axiom (forall a#80#0#0: int, 
    a#80#1#0: int, 
    a#80#2#0: int, 
    a#80#3#0: int, 
    a#80#4#0: DatatypeType, 
    a#80#5#0: DatatypeType, 
    a#80#6#0: DatatypeType, 
    a#80#7#0: DatatypeType, 
    a#80#8#0: DatatypeType, 
    a#80#9#0: int, 
    a#80#10#0: int, 
    a#80#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#80#0#0, 
      a#80#1#0, 
      a#80#2#0, 
      a#80#3#0, 
      a#80#4#0, 
      a#80#5#0, 
      a#80#6#0, 
      a#80#7#0, 
      a#80#8#0, 
      a#80#9#0, 
      a#80#10#0, 
      a#80#11#0) } 
  DtRank(a#80#5#0)
     < DtRank(#PivotBetreeSpec.NodeFusion.NodeFusion(a#80#0#0, 
        a#80#1#0, 
        a#80#2#0, 
        a#80#3#0, 
        a#80#4#0, 
        a#80#5#0, 
        a#80#6#0, 
        a#80#7#0, 
        a#80#8#0, 
        a#80#9#0, 
        a#80#10#0, 
        a#80#11#0)));

function PivotBetreeSpec.NodeFusion.fused__child(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#81#0#0: int, 
    a#81#1#0: int, 
    a#81#2#0: int, 
    a#81#3#0: int, 
    a#81#4#0: DatatypeType, 
    a#81#5#0: DatatypeType, 
    a#81#6#0: DatatypeType, 
    a#81#7#0: DatatypeType, 
    a#81#8#0: DatatypeType, 
    a#81#9#0: int, 
    a#81#10#0: int, 
    a#81#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#81#0#0, 
      a#81#1#0, 
      a#81#2#0, 
      a#81#3#0, 
      a#81#4#0, 
      a#81#5#0, 
      a#81#6#0, 
      a#81#7#0, 
      a#81#8#0, 
      a#81#9#0, 
      a#81#10#0, 
      a#81#11#0) } 
  PivotBetreeSpec.NodeFusion.fused__child(#PivotBetreeSpec.NodeFusion.NodeFusion(a#81#0#0, 
        a#81#1#0, 
        a#81#2#0, 
        a#81#3#0, 
        a#81#4#0, 
        a#81#5#0, 
        a#81#6#0, 
        a#81#7#0, 
        a#81#8#0, 
        a#81#9#0, 
        a#81#10#0, 
        a#81#11#0))
     == a#81#6#0);

// Inductive rank
axiom (forall a#82#0#0: int, 
    a#82#1#0: int, 
    a#82#2#0: int, 
    a#82#3#0: int, 
    a#82#4#0: DatatypeType, 
    a#82#5#0: DatatypeType, 
    a#82#6#0: DatatypeType, 
    a#82#7#0: DatatypeType, 
    a#82#8#0: DatatypeType, 
    a#82#9#0: int, 
    a#82#10#0: int, 
    a#82#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#82#0#0, 
      a#82#1#0, 
      a#82#2#0, 
      a#82#3#0, 
      a#82#4#0, 
      a#82#5#0, 
      a#82#6#0, 
      a#82#7#0, 
      a#82#8#0, 
      a#82#9#0, 
      a#82#10#0, 
      a#82#11#0) } 
  DtRank(a#82#6#0)
     < DtRank(#PivotBetreeSpec.NodeFusion.NodeFusion(a#82#0#0, 
        a#82#1#0, 
        a#82#2#0, 
        a#82#3#0, 
        a#82#4#0, 
        a#82#5#0, 
        a#82#6#0, 
        a#82#7#0, 
        a#82#8#0, 
        a#82#9#0, 
        a#82#10#0, 
        a#82#11#0)));

function PivotBetreeSpec.NodeFusion.left__child(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#83#0#0: int, 
    a#83#1#0: int, 
    a#83#2#0: int, 
    a#83#3#0: int, 
    a#83#4#0: DatatypeType, 
    a#83#5#0: DatatypeType, 
    a#83#6#0: DatatypeType, 
    a#83#7#0: DatatypeType, 
    a#83#8#0: DatatypeType, 
    a#83#9#0: int, 
    a#83#10#0: int, 
    a#83#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#83#0#0, 
      a#83#1#0, 
      a#83#2#0, 
      a#83#3#0, 
      a#83#4#0, 
      a#83#5#0, 
      a#83#6#0, 
      a#83#7#0, 
      a#83#8#0, 
      a#83#9#0, 
      a#83#10#0, 
      a#83#11#0) } 
  PivotBetreeSpec.NodeFusion.left__child(#PivotBetreeSpec.NodeFusion.NodeFusion(a#83#0#0, 
        a#83#1#0, 
        a#83#2#0, 
        a#83#3#0, 
        a#83#4#0, 
        a#83#5#0, 
        a#83#6#0, 
        a#83#7#0, 
        a#83#8#0, 
        a#83#9#0, 
        a#83#10#0, 
        a#83#11#0))
     == a#83#7#0);

// Inductive rank
axiom (forall a#84#0#0: int, 
    a#84#1#0: int, 
    a#84#2#0: int, 
    a#84#3#0: int, 
    a#84#4#0: DatatypeType, 
    a#84#5#0: DatatypeType, 
    a#84#6#0: DatatypeType, 
    a#84#7#0: DatatypeType, 
    a#84#8#0: DatatypeType, 
    a#84#9#0: int, 
    a#84#10#0: int, 
    a#84#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#84#0#0, 
      a#84#1#0, 
      a#84#2#0, 
      a#84#3#0, 
      a#84#4#0, 
      a#84#5#0, 
      a#84#6#0, 
      a#84#7#0, 
      a#84#8#0, 
      a#84#9#0, 
      a#84#10#0, 
      a#84#11#0) } 
  DtRank(a#84#7#0)
     < DtRank(#PivotBetreeSpec.NodeFusion.NodeFusion(a#84#0#0, 
        a#84#1#0, 
        a#84#2#0, 
        a#84#3#0, 
        a#84#4#0, 
        a#84#5#0, 
        a#84#6#0, 
        a#84#7#0, 
        a#84#8#0, 
        a#84#9#0, 
        a#84#10#0, 
        a#84#11#0)));

function PivotBetreeSpec.NodeFusion.right__child(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#85#0#0: int, 
    a#85#1#0: int, 
    a#85#2#0: int, 
    a#85#3#0: int, 
    a#85#4#0: DatatypeType, 
    a#85#5#0: DatatypeType, 
    a#85#6#0: DatatypeType, 
    a#85#7#0: DatatypeType, 
    a#85#8#0: DatatypeType, 
    a#85#9#0: int, 
    a#85#10#0: int, 
    a#85#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#85#0#0, 
      a#85#1#0, 
      a#85#2#0, 
      a#85#3#0, 
      a#85#4#0, 
      a#85#5#0, 
      a#85#6#0, 
      a#85#7#0, 
      a#85#8#0, 
      a#85#9#0, 
      a#85#10#0, 
      a#85#11#0) } 
  PivotBetreeSpec.NodeFusion.right__child(#PivotBetreeSpec.NodeFusion.NodeFusion(a#85#0#0, 
        a#85#1#0, 
        a#85#2#0, 
        a#85#3#0, 
        a#85#4#0, 
        a#85#5#0, 
        a#85#6#0, 
        a#85#7#0, 
        a#85#8#0, 
        a#85#9#0, 
        a#85#10#0, 
        a#85#11#0))
     == a#85#8#0);

// Inductive rank
axiom (forall a#86#0#0: int, 
    a#86#1#0: int, 
    a#86#2#0: int, 
    a#86#3#0: int, 
    a#86#4#0: DatatypeType, 
    a#86#5#0: DatatypeType, 
    a#86#6#0: DatatypeType, 
    a#86#7#0: DatatypeType, 
    a#86#8#0: DatatypeType, 
    a#86#9#0: int, 
    a#86#10#0: int, 
    a#86#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#86#0#0, 
      a#86#1#0, 
      a#86#2#0, 
      a#86#3#0, 
      a#86#4#0, 
      a#86#5#0, 
      a#86#6#0, 
      a#86#7#0, 
      a#86#8#0, 
      a#86#9#0, 
      a#86#10#0, 
      a#86#11#0) } 
  DtRank(a#86#8#0)
     < DtRank(#PivotBetreeSpec.NodeFusion.NodeFusion(a#86#0#0, 
        a#86#1#0, 
        a#86#2#0, 
        a#86#3#0, 
        a#86#4#0, 
        a#86#5#0, 
        a#86#6#0, 
        a#86#7#0, 
        a#86#8#0, 
        a#86#9#0, 
        a#86#10#0, 
        a#86#11#0)));

function PivotBetreeSpec.NodeFusion.slot__idx(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#87#0#0: int, 
    a#87#1#0: int, 
    a#87#2#0: int, 
    a#87#3#0: int, 
    a#87#4#0: DatatypeType, 
    a#87#5#0: DatatypeType, 
    a#87#6#0: DatatypeType, 
    a#87#7#0: DatatypeType, 
    a#87#8#0: DatatypeType, 
    a#87#9#0: int, 
    a#87#10#0: int, 
    a#87#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#87#0#0, 
      a#87#1#0, 
      a#87#2#0, 
      a#87#3#0, 
      a#87#4#0, 
      a#87#5#0, 
      a#87#6#0, 
      a#87#7#0, 
      a#87#8#0, 
      a#87#9#0, 
      a#87#10#0, 
      a#87#11#0) } 
  PivotBetreeSpec.NodeFusion.slot__idx(#PivotBetreeSpec.NodeFusion.NodeFusion(a#87#0#0, 
        a#87#1#0, 
        a#87#2#0, 
        a#87#3#0, 
        a#87#4#0, 
        a#87#5#0, 
        a#87#6#0, 
        a#87#7#0, 
        a#87#8#0, 
        a#87#9#0, 
        a#87#10#0, 
        a#87#11#0))
     == a#87#9#0);

function PivotBetreeSpec.NodeFusion.num__children__left(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#88#0#0: int, 
    a#88#1#0: int, 
    a#88#2#0: int, 
    a#88#3#0: int, 
    a#88#4#0: DatatypeType, 
    a#88#5#0: DatatypeType, 
    a#88#6#0: DatatypeType, 
    a#88#7#0: DatatypeType, 
    a#88#8#0: DatatypeType, 
    a#88#9#0: int, 
    a#88#10#0: int, 
    a#88#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#88#0#0, 
      a#88#1#0, 
      a#88#2#0, 
      a#88#3#0, 
      a#88#4#0, 
      a#88#5#0, 
      a#88#6#0, 
      a#88#7#0, 
      a#88#8#0, 
      a#88#9#0, 
      a#88#10#0, 
      a#88#11#0) } 
  PivotBetreeSpec.NodeFusion.num__children__left(#PivotBetreeSpec.NodeFusion.NodeFusion(a#88#0#0, 
        a#88#1#0, 
        a#88#2#0, 
        a#88#3#0, 
        a#88#4#0, 
        a#88#5#0, 
        a#88#6#0, 
        a#88#7#0, 
        a#88#8#0, 
        a#88#9#0, 
        a#88#10#0, 
        a#88#11#0))
     == a#88#10#0);

function PivotBetreeSpec.NodeFusion.pivot(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#89#0#0: int, 
    a#89#1#0: int, 
    a#89#2#0: int, 
    a#89#3#0: int, 
    a#89#4#0: DatatypeType, 
    a#89#5#0: DatatypeType, 
    a#89#6#0: DatatypeType, 
    a#89#7#0: DatatypeType, 
    a#89#8#0: DatatypeType, 
    a#89#9#0: int, 
    a#89#10#0: int, 
    a#89#11#0: Seq Box :: 
  { #PivotBetreeSpec.NodeFusion.NodeFusion(a#89#0#0, 
      a#89#1#0, 
      a#89#2#0, 
      a#89#3#0, 
      a#89#4#0, 
      a#89#5#0, 
      a#89#6#0, 
      a#89#7#0, 
      a#89#8#0, 
      a#89#9#0, 
      a#89#10#0, 
      a#89#11#0) } 
  PivotBetreeSpec.NodeFusion.pivot(#PivotBetreeSpec.NodeFusion.NodeFusion(a#89#0#0, 
        a#89#1#0, 
        a#89#2#0, 
        a#89#3#0, 
        a#89#4#0, 
        a#89#5#0, 
        a#89#6#0, 
        a#89#7#0, 
        a#89#8#0, 
        a#89#9#0, 
        a#89#10#0, 
        a#89#11#0))
     == a#89#11#0);

// Depth-one case-split function
function $IsA#PivotBetreeSpec.NodeFusion(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.NodeFusion(d) } 
  $IsA#PivotBetreeSpec.NodeFusion(d)
     ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.NodeFusion.NodeFusion_q(d), $Is(d, Tclass.PivotBetreeSpec.NodeFusion()) } 
  $Is(d, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.NodeFusion#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.NodeFusion.NodeFusion
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.NodeFusion#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.NodeFusion#Equal(a, b)
       <==> PivotBetreeSpec.NodeFusion.parentref(a)
           == PivotBetreeSpec.NodeFusion.parentref(b)
         && PivotBetreeSpec.NodeFusion.fused__childref(a)
           == PivotBetreeSpec.NodeFusion.fused__childref(b)
         && PivotBetreeSpec.NodeFusion.left__childref(a)
           == PivotBetreeSpec.NodeFusion.left__childref(b)
         && PivotBetreeSpec.NodeFusion.right__childref(a)
           == PivotBetreeSpec.NodeFusion.right__childref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__parent(a), 
          PivotBetreeSpec.NodeFusion.fused__parent(b))
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.split__parent(a), 
          PivotBetreeSpec.NodeFusion.split__parent(b))
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__child(a), 
          PivotBetreeSpec.NodeFusion.fused__child(b))
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(a), 
          PivotBetreeSpec.NodeFusion.left__child(b))
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.right__child(a), 
          PivotBetreeSpec.NodeFusion.right__child(b))
         && PivotBetreeSpec.NodeFusion.slot__idx(a)
           == PivotBetreeSpec.NodeFusion.slot__idx(b)
         && PivotBetreeSpec.NodeFusion.num__children__left(a)
           == PivotBetreeSpec.NodeFusion.num__children__left(b)
         && Seq#Equal(PivotBetreeSpec.NodeFusion.pivot(a), PivotBetreeSpec.NodeFusion.pivot(b))));

// Datatype extensionality axiom: PivotBetreeSpec.NodeFusion
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.NodeFusion#Equal(a, b) } 
  PivotBetreeSpec.NodeFusion#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.NodeFusion: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.Repivot.Repivot(int, DatatypeType, Seq Box) : DatatypeType;

const unique ##PivotBetreeSpec.Repivot.Repivot: DtCtorId;

// Constructor identifier
axiom (forall a#90#0#0: int, a#90#1#0: DatatypeType, a#90#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(a#90#0#0, a#90#1#0, a#90#2#0) } 
  DatatypeCtorId(#PivotBetreeSpec.Repivot.Repivot(a#90#0#0, a#90#1#0, a#90#2#0))
     == ##PivotBetreeSpec.Repivot.Repivot);

function PivotBetreeSpec.Repivot.Repivot_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.Repivot.Repivot_q(d) } 
  PivotBetreeSpec.Repivot.Repivot_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.Repivot.Repivot);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.Repivot.Repivot_q(d) } 
  PivotBetreeSpec.Repivot.Repivot_q(d)
     ==> (exists a#91#0#0: int, a#91#1#0: DatatypeType, a#91#2#0: Seq Box :: 
      d == #PivotBetreeSpec.Repivot.Repivot(a#91#0#0, a#91#1#0, a#91#2#0)));

function Tclass.PivotBetreeSpec.Repivot() : Ty;

// Tclass.PivotBetreeSpec.Repivot Tag
axiom Tag(Tclass.PivotBetreeSpec.Repivot()) == Tagclass.PivotBetreeSpec.Repivot;

const unique Tagclass.PivotBetreeSpec.Repivot: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.Repivot
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.Repivot()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.Repivot())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.Repivot()));

// Constructor $Is
axiom (forall a#92#0#0: int, a#92#1#0: DatatypeType, a#92#2#0: Seq Box :: 
  { $Is(#PivotBetreeSpec.Repivot.Repivot(a#92#0#0, a#92#1#0, a#92#2#0), 
      Tclass.PivotBetreeSpec.Repivot()) } 
  $Is(#PivotBetreeSpec.Repivot.Repivot(a#92#0#0, a#92#1#0, a#92#2#0), 
      Tclass.PivotBetreeSpec.Repivot())
     <==> $Is(a#92#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#92#1#0, Tclass.PivotBetreeGraph.Node())
       && $Is(a#92#2#0, TSeq(Tclass.KeyType.Key())));

// Constructor $IsAlloc
axiom (forall a#93#0#0: int, a#93#1#0: DatatypeType, a#93#2#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.Repivot.Repivot(a#93#0#0, a#93#1#0, a#93#2#0), 
      Tclass.PivotBetreeSpec.Repivot(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.Repivot.Repivot(a#93#0#0, a#93#1#0, a#93#2#0), 
        Tclass.PivotBetreeSpec.Repivot(), 
        $h)
       <==> $IsAlloc(a#93#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#93#1#0, Tclass.PivotBetreeGraph.Node(), $h)
         && $IsAlloc(a#93#2#0, TSeq(Tclass.KeyType.Key()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.Repivot.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.Repivot.Repivot_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.Repivot(), $h)
     ==> $IsAlloc(PivotBetreeSpec.Repivot.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.Repivot.leaf(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.Repivot.Repivot_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.Repivot(), $h)
     ==> $IsAlloc(PivotBetreeSpec.Repivot.leaf(d), Tclass.PivotBetreeGraph.Node(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.Repivot.pivots(d), TSeq(Tclass.KeyType.Key()), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.Repivot.Repivot_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.Repivot(), $h)
     ==> $IsAlloc(PivotBetreeSpec.Repivot.pivots(d), TSeq(Tclass.KeyType.Key()), $h));

// Constructor literal
axiom (forall a#94#0#0: int, a#94#1#0: DatatypeType, a#94#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(LitInt(a#94#0#0), Lit(a#94#1#0), Lit(a#94#2#0)) } 
  #PivotBetreeSpec.Repivot.Repivot(LitInt(a#94#0#0), Lit(a#94#1#0), Lit(a#94#2#0))
     == Lit(#PivotBetreeSpec.Repivot.Repivot(a#94#0#0, a#94#1#0, a#94#2#0)));

function PivotBetreeSpec.Repivot.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#95#0#0: int, a#95#1#0: DatatypeType, a#95#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(a#95#0#0, a#95#1#0, a#95#2#0) } 
  PivotBetreeSpec.Repivot.ref(#PivotBetreeSpec.Repivot.Repivot(a#95#0#0, a#95#1#0, a#95#2#0))
     == a#95#0#0);

function PivotBetreeSpec.Repivot.leaf(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#96#0#0: int, a#96#1#0: DatatypeType, a#96#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(a#96#0#0, a#96#1#0, a#96#2#0) } 
  PivotBetreeSpec.Repivot.leaf(#PivotBetreeSpec.Repivot.Repivot(a#96#0#0, a#96#1#0, a#96#2#0))
     == a#96#1#0);

// Inductive rank
axiom (forall a#97#0#0: int, a#97#1#0: DatatypeType, a#97#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(a#97#0#0, a#97#1#0, a#97#2#0) } 
  DtRank(a#97#1#0)
     < DtRank(#PivotBetreeSpec.Repivot.Repivot(a#97#0#0, a#97#1#0, a#97#2#0)));

function PivotBetreeSpec.Repivot.pivots(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#98#0#0: int, a#98#1#0: DatatypeType, a#98#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(a#98#0#0, a#98#1#0, a#98#2#0) } 
  PivotBetreeSpec.Repivot.pivots(#PivotBetreeSpec.Repivot.Repivot(a#98#0#0, a#98#1#0, a#98#2#0))
     == a#98#2#0);

// Inductive seq element rank
axiom (forall a#99#0#0: int, a#99#1#0: DatatypeType, a#99#2#0: Seq Box, i: int :: 
  { Seq#Index(a#99#2#0, i), #PivotBetreeSpec.Repivot.Repivot(a#99#0#0, a#99#1#0, a#99#2#0) } 
  0 <= i && i < Seq#Length(a#99#2#0)
     ==> DtRank($Unbox(Seq#Index(a#99#2#0, i)): DatatypeType)
       < DtRank(#PivotBetreeSpec.Repivot.Repivot(a#99#0#0, a#99#1#0, a#99#2#0)));

// Inductive seq rank
axiom (forall a#100#0#0: int, a#100#1#0: DatatypeType, a#100#2#0: Seq Box :: 
  { #PivotBetreeSpec.Repivot.Repivot(a#100#0#0, a#100#1#0, a#100#2#0) } 
  Seq#Rank(a#100#2#0)
     < DtRank(#PivotBetreeSpec.Repivot.Repivot(a#100#0#0, a#100#1#0, a#100#2#0)));

// Depth-one case-split function
function $IsA#PivotBetreeSpec.Repivot(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.Repivot(d) } 
  $IsA#PivotBetreeSpec.Repivot(d) ==> PivotBetreeSpec.Repivot.Repivot_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.Repivot.Repivot_q(d), $Is(d, Tclass.PivotBetreeSpec.Repivot()) } 
  $Is(d, Tclass.PivotBetreeSpec.Repivot())
     ==> PivotBetreeSpec.Repivot.Repivot_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.Repivot#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.Repivot.Repivot
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.Repivot#Equal(a, b) } 
  true
     ==> (PivotBetreeSpec.Repivot#Equal(a, b)
       <==> PivotBetreeSpec.Repivot.ref(a) == PivotBetreeSpec.Repivot.ref(b)
         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.Repivot.leaf(a), PivotBetreeSpec.Repivot.leaf(b))
         && Seq#Equal(PivotBetreeSpec.Repivot.pivots(a), PivotBetreeSpec.Repivot.pivots(b))));

// Datatype extensionality axiom: PivotBetreeSpec.Repivot
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.Repivot#Equal(a, b) } 
  PivotBetreeSpec.Repivot#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.Repivot: ClassName;

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeQuery(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeQuery: DtCtorId;

// Constructor identifier
axiom (forall a#101#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeQuery(a#101#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#101#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeQuery);

function PivotBetreeSpec.BetreeStep.BetreeQuery_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeQuery_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeQuery_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeQuery);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeQuery_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeQuery_q(d)
     ==> (exists a#102#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeQuery(a#102#0#0)));

function Tclass.PivotBetreeSpec.BetreeStep() : Ty;

// Tclass.PivotBetreeSpec.BetreeStep Tag
axiom Tag(Tclass.PivotBetreeSpec.BetreeStep()) == Tagclass.PivotBetreeSpec.BetreeStep;

const unique Tagclass.PivotBetreeSpec.BetreeStep: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.BetreeStep
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.BetreeStep()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.BetreeStep())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PivotBetreeSpec.BetreeStep()));

// Constructor $Is
axiom (forall a#103#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#103#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#103#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#103#0#0, Tclass.PivotBetreeSpec.LookupQuery()));

// Constructor $IsAlloc
axiom (forall a#104#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#104#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#104#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#104#0#0, Tclass.PivotBetreeSpec.LookupQuery(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.q(d), Tclass.PivotBetreeSpec.LookupQuery(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.q(d), Tclass.PivotBetreeSpec.LookupQuery(), $h));

// Constructor literal
axiom (forall a#105#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeQuery(Lit(a#105#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeQuery(Lit(a#105#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#105#0#0)));

function PivotBetreeSpec.BetreeStep.q(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#106#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeQuery(a#106#0#0) } 
  PivotBetreeSpec.BetreeStep.q(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#106#0#0))
     == a#106#0#0);

// Inductive rank
axiom (forall a#107#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeQuery(a#107#0#0) } 
  DtRank(a#107#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeQuery(a#107#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeSuccQuery: DtCtorId;

// Constructor identifier
axiom (forall a#108#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#108#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#108#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeSuccQuery);

function PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeSuccQuery);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d)
     ==> (exists a#109#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#109#0#0)));

// Constructor $Is
axiom (forall a#110#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#110#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#110#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#110#0#0, Tclass.PivotBetreeSpec.SuccQuery()));

// Constructor $IsAlloc
axiom (forall a#111#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#111#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#111#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#111#0#0, Tclass.PivotBetreeSpec.SuccQuery(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.sq(d), Tclass.PivotBetreeSpec.SuccQuery(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.sq(d), Tclass.PivotBetreeSpec.SuccQuery(), $h));

// Constructor literal
axiom (forall a#112#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(Lit(a#112#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(Lit(a#112#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#112#0#0)));

function PivotBetreeSpec.BetreeStep.sq(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#113#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#113#0#0) } 
  PivotBetreeSpec.BetreeStep.sq(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#113#0#0))
     == a#113#0#0);

// Inductive rank
axiom (forall a#114#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#114#0#0) } 
  DtRank(a#114#0#0)
     < DtRank(#PivotBetreeSpec.BetreeStep.BetreeSuccQuery(a#114#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeInsert(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeInsert: DtCtorId;

// Constructor identifier
axiom (forall a#115#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeInsert(a#115#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#115#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeInsert);

function PivotBetreeSpec.BetreeStep.BetreeInsert_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeInsert_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeInsert_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeInsert);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeInsert_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeInsert_q(d)
     ==> (exists a#116#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeInsert(a#116#0#0)));

// Constructor $Is
axiom (forall a#117#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#117#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#117#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#117#0#0, Tclass.PivotBetreeSpec.MessageInsertion()));

// Constructor $IsAlloc
axiom (forall a#118#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#118#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#118#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#118#0#0, Tclass.PivotBetreeSpec.MessageInsertion(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.ins(d), Tclass.PivotBetreeSpec.MessageInsertion(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeInsert_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.ins(d), Tclass.PivotBetreeSpec.MessageInsertion(), $h));

// Constructor literal
axiom (forall a#119#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeInsert(Lit(a#119#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeInsert(Lit(a#119#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#119#0#0)));

function PivotBetreeSpec.BetreeStep.ins(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#120#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeInsert(a#120#0#0) } 
  PivotBetreeSpec.BetreeStep.ins(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#120#0#0))
     == a#120#0#0);

// Inductive rank
axiom (forall a#121#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeInsert(a#121#0#0) } 
  DtRank(a#121#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeInsert(a#121#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeFlush(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeFlush: DtCtorId;

// Constructor identifier
axiom (forall a#122#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeFlush(a#122#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#122#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeFlush);

function PivotBetreeSpec.BetreeStep.BetreeFlush_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeFlush_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeFlush_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeFlush);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeFlush_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeFlush_q(d)
     ==> (exists a#123#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeFlush(a#123#0#0)));

// Constructor $Is
axiom (forall a#124#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#124#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#124#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#124#0#0, Tclass.PivotBetreeSpec.NodeFlush()));

// Constructor $IsAlloc
axiom (forall a#125#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#125#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#125#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#125#0#0, Tclass.PivotBetreeSpec.NodeFlush(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.flush(d), Tclass.PivotBetreeSpec.NodeFlush(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeFlush_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.flush(d), Tclass.PivotBetreeSpec.NodeFlush(), $h));

// Constructor literal
axiom (forall a#126#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeFlush(Lit(a#126#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeFlush(Lit(a#126#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#126#0#0)));

function PivotBetreeSpec.BetreeStep.flush(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#127#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeFlush(a#127#0#0) } 
  PivotBetreeSpec.BetreeStep.flush(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#127#0#0))
     == a#127#0#0);

// Inductive rank
axiom (forall a#128#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeFlush(a#128#0#0) } 
  DtRank(a#128#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeFlush(a#128#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeGrow(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeGrow: DtCtorId;

// Constructor identifier
axiom (forall a#129#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeGrow(a#129#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#129#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeGrow);

function PivotBetreeSpec.BetreeStep.BetreeGrow_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeGrow_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeGrow_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeGrow);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeGrow_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeGrow_q(d)
     ==> (exists a#130#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeGrow(a#130#0#0)));

// Constructor $Is
axiom (forall a#131#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#131#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#131#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#131#0#0, Tclass.PivotBetreeSpec.RootGrowth()));

// Constructor $IsAlloc
axiom (forall a#132#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#132#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#132#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#132#0#0, Tclass.PivotBetreeSpec.RootGrowth(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.growth(d), Tclass.PivotBetreeSpec.RootGrowth(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeGrow_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.growth(d), Tclass.PivotBetreeSpec.RootGrowth(), $h));

// Constructor literal
axiom (forall a#133#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeGrow(Lit(a#133#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeGrow(Lit(a#133#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#133#0#0)));

function PivotBetreeSpec.BetreeStep.growth(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#134#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeGrow(a#134#0#0) } 
  PivotBetreeSpec.BetreeStep.growth(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#134#0#0))
     == a#134#0#0);

// Inductive rank
axiom (forall a#135#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeGrow(a#135#0#0) } 
  DtRank(a#135#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeGrow(a#135#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeSplit(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeSplit: DtCtorId;

// Constructor identifier
axiom (forall a#136#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSplit(a#136#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#136#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeSplit);

function PivotBetreeSpec.BetreeStep.BetreeSplit_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeSplit_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeSplit_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeSplit);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeSplit_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeSplit_q(d)
     ==> (exists a#137#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeSplit(a#137#0#0)));

// Constructor $Is
axiom (forall a#138#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#138#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#138#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#138#0#0, Tclass.PivotBetreeSpec.NodeFusion()));

// Constructor $IsAlloc
axiom (forall a#139#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#139#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#139#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#139#0#0, Tclass.PivotBetreeSpec.NodeFusion(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.fusion(d), Tclass.PivotBetreeSpec.NodeFusion(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeSplit_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.fusion(d), Tclass.PivotBetreeSpec.NodeFusion(), $h));

// Constructor literal
axiom (forall a#140#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSplit(Lit(a#140#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeSplit(Lit(a#140#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#140#0#0)));

function PivotBetreeSpec.BetreeStep.fusion(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#141#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSplit(a#141#0#0) } 
  PivotBetreeSpec.BetreeStep.fusion(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#141#0#0))
     == a#141#0#0);

// Inductive rank
axiom (forall a#142#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeSplit(a#142#0#0) } 
  DtRank(a#142#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeSplit(a#142#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeMerge(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeMerge: DtCtorId;

// Constructor identifier
axiom (forall a#143#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeMerge(a#143#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#143#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeMerge);

function PivotBetreeSpec.BetreeStep.BetreeMerge_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeMerge_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeMerge_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeMerge);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeMerge_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeMerge_q(d)
     ==> (exists a#144#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeMerge(a#144#0#0)));

// Constructor $Is
axiom (forall a#145#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#145#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#145#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#145#0#0, Tclass.PivotBetreeSpec.NodeFusion()));

// Constructor $IsAlloc
axiom (forall a#146#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#146#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#146#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#146#0#0, Tclass.PivotBetreeSpec.NodeFusion(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.fusion(d), Tclass.PivotBetreeSpec.NodeFusion(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeMerge_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.fusion(d), Tclass.PivotBetreeSpec.NodeFusion(), $h));

// Constructor literal
axiom (forall a#147#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeMerge(Lit(a#147#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeMerge(Lit(a#147#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#147#0#0)));

// Constructor injectivity
axiom (forall a#148#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeMerge(a#148#0#0) } 
  PivotBetreeSpec.BetreeStep.fusion(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#148#0#0))
     == a#148#0#0);

// Inductive rank
axiom (forall a#149#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeMerge(a#149#0#0) } 
  DtRank(a#149#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeMerge(a#149#0#0)));

// Constructor function declaration
function #PivotBetreeSpec.BetreeStep.BetreeRepivot(DatatypeType) : DatatypeType;

const unique ##PivotBetreeSpec.BetreeStep.BetreeRepivot: DtCtorId;

// Constructor identifier
axiom (forall a#150#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeRepivot(a#150#0#0) } 
  DatatypeCtorId(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#150#0#0))
     == ##PivotBetreeSpec.BetreeStep.BetreeRepivot);

function PivotBetreeSpec.BetreeStep.BetreeRepivot_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d)
     <==> DatatypeCtorId(d) == ##PivotBetreeSpec.BetreeStep.BetreeRepivot);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d) } 
  PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d)
     ==> (exists a#151#0#0: DatatypeType :: 
      d == #PivotBetreeSpec.BetreeStep.BetreeRepivot(a#151#0#0)));

// Constructor $Is
axiom (forall a#152#0#0: DatatypeType :: 
  { $Is(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#152#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#152#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep())
     <==> $Is(a#152#0#0, Tclass.PivotBetreeSpec.Repivot()));

// Constructor $IsAlloc
axiom (forall a#153#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#153#0#0), 
      Tclass.PivotBetreeSpec.BetreeStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#153#0#0), 
        Tclass.PivotBetreeSpec.BetreeStep(), 
        $h)
       <==> $IsAlloc(a#153#0#0, Tclass.PivotBetreeSpec.Repivot(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PivotBetreeSpec.BetreeStep.repivot(d), Tclass.PivotBetreeSpec.Repivot(), $h) } 
  $IsGoodHeap($h)
       && 
      PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d)
       && $IsAlloc(d, Tclass.PivotBetreeSpec.BetreeStep(), $h)
     ==> $IsAlloc(PivotBetreeSpec.BetreeStep.repivot(d), Tclass.PivotBetreeSpec.Repivot(), $h));

// Constructor literal
axiom (forall a#154#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeRepivot(Lit(a#154#0#0)) } 
  #PivotBetreeSpec.BetreeStep.BetreeRepivot(Lit(a#154#0#0))
     == Lit(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#154#0#0)));

function PivotBetreeSpec.BetreeStep.repivot(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#155#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeRepivot(a#155#0#0) } 
  PivotBetreeSpec.BetreeStep.repivot(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#155#0#0))
     == a#155#0#0);

// Inductive rank
axiom (forall a#156#0#0: DatatypeType :: 
  { #PivotBetreeSpec.BetreeStep.BetreeRepivot(a#156#0#0) } 
  DtRank(a#156#0#0) < DtRank(#PivotBetreeSpec.BetreeStep.BetreeRepivot(a#156#0#0)));

// Depth-one case-split function
function $IsA#PivotBetreeSpec.BetreeStep(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PivotBetreeSpec.BetreeStep(d) } 
  $IsA#PivotBetreeSpec.BetreeStep(d)
     ==> PivotBetreeSpec.BetreeStep.BetreeQuery_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeInsert_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeFlush_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeGrow_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeSplit_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeMerge_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeMerge_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeSplit_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeGrow_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeFlush_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeInsert_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
    { PivotBetreeSpec.BetreeStep.BetreeQuery_q(d), $Is(d, Tclass.PivotBetreeSpec.BetreeStep()) } 
  $Is(d, Tclass.PivotBetreeSpec.BetreeStep())
     ==> PivotBetreeSpec.BetreeStep.BetreeQuery_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeInsert_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeFlush_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeGrow_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeSplit_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeMerge_q(d)
       || PivotBetreeSpec.BetreeStep.BetreeRepivot_q(d));

// Datatype extensional equality declaration
function PivotBetreeSpec.BetreeStep#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeQuery
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeQuery_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeQuery_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeQuery_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeQuery_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.LookupQuery#Equal(PivotBetreeSpec.BetreeStep.q(a), PivotBetreeSpec.BetreeStep.q(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeSuccQuery
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.SuccQuery#Equal(PivotBetreeSpec.BetreeStep.sq(a), PivotBetreeSpec.BetreeStep.sq(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeInsert
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeInsert_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeInsert_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeInsert_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeInsert_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.MessageInsertion#Equal(PivotBetreeSpec.BetreeStep.ins(a), PivotBetreeSpec.BetreeStep.ins(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeFlush
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeFlush_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeFlush_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeFlush_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeFlush_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.NodeFlush#Equal(PivotBetreeSpec.BetreeStep.flush(a), PivotBetreeSpec.BetreeStep.flush(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeGrow
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeGrow_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeGrow_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeGrow_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeGrow_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.RootGrowth#Equal(PivotBetreeSpec.BetreeStep.growth(a), PivotBetreeSpec.BetreeStep.growth(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeSplit
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeSplit_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeSplit_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeSplit_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeSplit_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.NodeFusion#Equal(PivotBetreeSpec.BetreeStep.fusion(a), PivotBetreeSpec.BetreeStep.fusion(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeMerge
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeMerge_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeMerge_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeMerge_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeMerge_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.NodeFusion#Equal(PivotBetreeSpec.BetreeStep.fusion(a), PivotBetreeSpec.BetreeStep.fusion(b))));

// Datatype extensional equality definition: #PivotBetreeSpec.BetreeStep.BetreeRepivot
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeRepivot_q(a) } 
    { PivotBetreeSpec.BetreeStep#Equal(a, b), PivotBetreeSpec.BetreeStep.BetreeRepivot_q(b) } 
  PivotBetreeSpec.BetreeStep.BetreeRepivot_q(a)
       && PivotBetreeSpec.BetreeStep.BetreeRepivot_q(b)
     ==> (PivotBetreeSpec.BetreeStep#Equal(a, b)
       <==> PivotBetreeSpec.Repivot#Equal(PivotBetreeSpec.BetreeStep.repivot(a), PivotBetreeSpec.BetreeStep.repivot(b))));

// Datatype extensionality axiom: PivotBetreeSpec.BetreeStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PivotBetreeSpec.BetreeStep#Equal(a, b) } 
  PivotBetreeSpec.BetreeStep#Equal(a, b) <==> a == b);

const unique class.PivotBetreeSpec.BetreeStep: ClassName;

const unique class.PivotBetreeSpec.__default: ClassName;

function Tclass.PivotBetreeSpec.__default() : Ty;

// Tclass.PivotBetreeSpec.__default Tag
axiom Tag(Tclass.PivotBetreeSpec.__default()) == Tagclass.PivotBetreeSpec.__default;

const unique Tagclass.PivotBetreeSpec.__default: TyTag;

// Box/unbox axiom for Tclass.PivotBetreeSpec.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PivotBetreeSpec.__default()) } 
  $IsBox(bx, Tclass.PivotBetreeSpec.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PivotBetreeSpec.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PivotBetreeSpec.__default()) } 
  $Is($o, Tclass.PivotBetreeSpec.__default())
     <==> $o == null || dtype($o) == Tclass.PivotBetreeSpec.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PivotBetreeSpec.__default(), $h) } 
  $IsAlloc($o, Tclass.PivotBetreeSpec.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PivotBetreeSpec._default.BoundedNode
function PivotBetreeSpec.__default.BoundedNode(node#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.BoundedNode#canCall(node#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.BoundedNode
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BoundedNode(node#0) } 
    PivotBetreeSpec.__default.BoundedNode#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> true);

function PivotBetreeSpec.__default.BoundedNode#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.BoundedNode
axiom (forall node#0: DatatypeType :: 
  { PivotBetreeSpec.__default.BoundedNode#requires(node#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
     ==> PivotBetreeSpec.__default.BoundedNode#requires(node#0) == true);

// definition axiom for PivotBetreeSpec.__default.BoundedNode(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BoundedNode(node#0) } 
    PivotBetreeSpec.__default.BoundedNode#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && Bounds.__default.MaxNumChildren#canCall()
         && (Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
             <= LitInt(Bounds.__default.MaxNumChildren())
           ==> PivotBetreeGraph.Node.Node_q(node#0)
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeGraph.Node.buckets(node#0))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && PivotBetreeSpec.__default.BoundedNode(node#0)
           == (Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
               <= LitInt(Bounds.__default.MaxNumChildren())
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                PivotBetreeGraph.Node.buckets(node#0))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())));

// definition axiom for PivotBetreeSpec.__default.BoundedNode for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.BoundedNode(Lit(node#0)) } 
    PivotBetreeSpec.__default.BoundedNode#canCall(Lit(node#0))
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && Bounds.__default.MaxNumChildren#canCall()
         && (Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
             <= LitInt(Bounds.__default.MaxNumChildren())
           ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && PivotBetreeSpec.__default.BoundedNode(Lit(node#0))
           == (Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
               <= LitInt(Bounds.__default.MaxNumChildren())
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())));

// function declaration for PivotBetreeSpec._default.WFNode
function PivotBetreeSpec.__default.WFNode(node#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.WFNode#canCall(node#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.WFNode
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeSpec.__default.WFNode(node#0) } 
    PivotBetreeSpec.__default.WFNode#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> true);

function PivotBetreeSpec.__default.WFNode#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.WFNode
axiom (forall node#0: DatatypeType :: 
  { PivotBetreeSpec.__default.WFNode#requires(node#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
     ==> PivotBetreeSpec.__default.WFNode#requires(node#0) == true);

// definition axiom for PivotBetreeSpec.__default.WFNode(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeSpec.__default.WFNode(node#0) } 
    PivotBetreeSpec.__default.WFNode#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && PivotsLib.__default.NumBuckets#canCall(PivotBetreeGraph.Node.pivotTable(node#0))
         && PivotBetreeGraph.Node.Node_q(node#0)
         && (PivotsLib.__default.NumBuckets(PivotBetreeGraph.Node.pivotTable(node#0))
             == Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
           ==> PivotBetreeGraph.Node.Node_q(node#0)
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
               ==> PivotBetreeGraph.Node.Node_q(node#0) && PivotBetreeGraph.Node.Node_q(node#0)))
         && (PivotBetreeGraph.Node.Node_q(node#0)
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
               ==> PivotBetreeGraph.Node.Node_q(node#0) && PivotBetreeGraph.Node.Node_q(node#0))
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
               ==> Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
                 == Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box))
           ==> PivotBetreeGraph.Node.Node_q(node#0)
             && PivotsLib.__default.WFPivots#canCall(PivotBetreeGraph.Node.pivotTable(node#0)))
         && (PivotBetreeGraph.Node.Node_q(node#0)
             && PivotsLib.__default.WFPivots#canCall(PivotBetreeGraph.Node.pivotTable(node#0))
             && PivotsLib.__default.WFPivots(PivotBetreeGraph.Node.pivotTable(node#0))
           ==> PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.WFBucketList#canCall(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0)))
         && (PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.WFBucketList#canCall(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0))
             && BucketsLib.__default.WFBucketList(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0))
           ==> PivotBetreeSpec.__default.BoundedNode#canCall(node#0))
         && PivotBetreeSpec.__default.WFNode(node#0)
           == (
            PivotsLib.__default.NumBuckets(PivotBetreeGraph.Node.pivotTable(node#0))
               == Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
               ==> Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
                 == Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box))
             && PivotsLib.__default.WFPivots(PivotBetreeGraph.Node.pivotTable(node#0))
             && BucketsLib.__default.WFBucketList(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0))
             && PivotBetreeSpec.__default.BoundedNode(node#0)));

// definition axiom for PivotBetreeSpec.__default.WFNode for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.WFNode(Lit(node#0)) } 
    PivotBetreeSpec.__default.WFNode#canCall(Lit(node#0))
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && PivotsLib.__default.NumBuckets#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
         && PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && (LitInt(PivotsLib.__default.NumBuckets(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
             == Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
           ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0)))))
               ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(node#0))))
         && (PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0)))))
               ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(node#0)))
             && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))
               ==> Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
                 == Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box)))
           ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotsLib.__default.WFPivots#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
         && (PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotsLib.__default.WFPivots#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
             && Lit(PivotsLib.__default.WFPivots(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
           ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.WFBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
         && (PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.WFBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
             && Lit(BucketsLib.__default.WFBucketList(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
           ==> PivotBetreeSpec.__default.BoundedNode#canCall(Lit(node#0)))
         && PivotBetreeSpec.__default.WFNode(Lit(node#0))
           == (
            LitInt(PivotsLib.__default.NumBuckets(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
               == Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
             && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))
               ==> Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))
                 == Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box)))
             && PivotsLib.__default.WFPivots(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
             && BucketsLib.__default.WFBucketList(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
             && PivotBetreeSpec.__default.BoundedNode(Lit(node#0))));

// function declaration for PivotBetreeSpec._default.InvNode
function PivotBetreeSpec.__default.InvNode(node#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.InvNode#canCall(node#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.InvNode
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeSpec.__default.InvNode(node#0) } 
    PivotBetreeSpec.__default.InvNode#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> true);

function PivotBetreeSpec.__default.InvNode#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.InvNode
axiom (forall node#0: DatatypeType :: 
  { PivotBetreeSpec.__default.InvNode#requires(node#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
     ==> PivotBetreeSpec.__default.InvNode#requires(node#0) == true);

// definition axiom for PivotBetreeSpec.__default.InvNode(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    { PivotBetreeSpec.__default.InvNode(node#0) } 
    PivotBetreeSpec.__default.InvNode#canCall(node#0)
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeSpec.__default.WFNode#canCall(node#0)
         && (PivotBetreeSpec.__default.WFNode(node#0)
           ==> PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.WFBucketListProper#canCall(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0)))
         && (PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.WFBucketListProper#canCall(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0))
             && BucketsLib.__default.WFBucketListProper(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0))
           ==> PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.BucketListWellMarshalled#canCall(PivotBetreeGraph.Node.buckets(node#0)))
         && PivotBetreeSpec.__default.InvNode(node#0)
           == (
            PivotBetreeSpec.__default.WFNode(node#0)
             && BucketsLib.__default.WFBucketListProper(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0))
             && BucketsLib.__default.BucketListWellMarshalled(PivotBetreeGraph.Node.buckets(node#0))));

// definition axiom for PivotBetreeSpec.__default.InvNode for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.InvNode(Lit(node#0)) } 
    PivotBetreeSpec.__default.InvNode#canCall(Lit(node#0))
         || $Is(node#0, Tclass.PivotBetreeGraph.Node())
       ==> PivotBetreeSpec.__default.WFNode#canCall(Lit(node#0))
         && (Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0)))
           ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.WFBucketListProper#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
         && (PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.WFBucketListProper#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
             && Lit(BucketsLib.__default.WFBucketListProper(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0)))))
           ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.BucketListWellMarshalled#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0)))))
         && PivotBetreeSpec.__default.InvNode(Lit(node#0))
           == Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0))
               && BucketsLib.__default.WFBucketListProper(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
               && BucketsLib.__default.BucketListWellMarshalled(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))))));

// function declaration for PivotBetreeSpec._default.AddMessageToNode
function PivotBetreeSpec.__default.AddMessageToNode(node#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function PivotBetreeSpec.__default.AddMessageToNode#canCall(node#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.AddMessageToNode
axiom true
   ==> (forall node#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { PivotBetreeSpec.__default.AddMessageToNode(node#0, key#0, msg#0) } 
    PivotBetreeSpec.__default.AddMessageToNode#canCall(node#0, key#0, msg#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> $Is(PivotBetreeSpec.__default.AddMessageToNode(node#0, key#0, msg#0), 
        Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.AddMessageToNode#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.AddMessageToNode
axiom (forall node#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
  { PivotBetreeSpec.__default.AddMessageToNode#requires(node#0, key#0, msg#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> PivotBetreeSpec.__default.AddMessageToNode#requires(node#0, key#0, msg#0)
       == PivotBetreeSpec.__default.WFNode(node#0));

// definition axiom for PivotBetreeSpec.__default.AddMessageToNode(revealed)
axiom true
   ==> (forall node#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { PivotBetreeSpec.__default.AddMessageToNode(node#0, key#0, msg#0) } 
    PivotBetreeSpec.__default.AddMessageToNode#canCall(node#0, key#0, msg#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> (var dt_update_tmp#0#0 := node#0; 
          PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.BucketListInsert#canCall(PivotBetreeGraph.Node.buckets(node#0), 
              PivotBetreeGraph.Node.pivotTable(node#0), 
              key#0, 
              msg#0)
             && 
            PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#0)
             && PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#0))
         && PivotBetreeSpec.__default.AddMessageToNode(node#0, key#0, msg#0)
           == (var newnode#0 := (var dt_update_tmp#0#0 := node#0; 
                (var dt_update#buckets#0#0 := BucketsLib.__default.BucketListInsert(PivotBetreeGraph.Node.buckets(node#0), 
                      PivotBetreeGraph.Node.pivotTable(node#0), 
                      key#0, 
                      msg#0); 
                  #PivotBetreeGraph.Node.Node(PivotBetreeGraph.Node.pivotTable(dt_update_tmp#0#0), 
                    PivotBetreeGraph.Node.children(dt_update_tmp#0#0), 
                    dt_update#buckets#0#0))); 
            newnode#0));

// definition axiom for PivotBetreeSpec.__default.AddMessageToNode for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.AddMessageToNode(Lit(node#0), Lit(key#0), Lit(msg#0)) } 
    PivotBetreeSpec.__default.AddMessageToNode#canCall(Lit(node#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0))))
       ==> (var dt_update_tmp#0#1 := Lit(node#0); 
          PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.BucketListInsert#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              Lit(key#0), 
              Lit(msg#0))
             && 
            PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#1)
             && PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#1))
         && PivotBetreeSpec.__default.AddMessageToNode(Lit(node#0), Lit(key#0), Lit(msg#0))
           == (var newnode#1 := (var dt_update_tmp#0#1 := Lit(node#0); 
                (var dt_update#buckets#0#1 := Lit(BucketsLib.__default.BucketListInsert(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                        Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
                        Lit(key#0), 
                        Lit(msg#0))); 
                  Lit(#PivotBetreeGraph.Node.Node(Lit(PivotBetreeGraph.Node.pivotTable(dt_update_tmp#0#1)), 
                      Lit(PivotBetreeGraph.Node.children(dt_update_tmp#0#1)), 
                      dt_update#buckets#0#1)))); 
            newnode#1));

// function declaration for PivotBetreeSpec._default.AddMessagesToNode
function PivotBetreeSpec.__default.AddMessagesToNode(node#0: DatatypeType, msgs#0: DatatypeType) : DatatypeType;

function PivotBetreeSpec.__default.AddMessagesToNode#canCall(node#0: DatatypeType, msgs#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.AddMessagesToNode
axiom true
   ==> (forall node#0: DatatypeType, msgs#0: DatatypeType :: 
    { PivotBetreeSpec.__default.AddMessagesToNode(node#0, msgs#0) } 
    PivotBetreeSpec.__default.AddMessagesToNode#canCall(node#0, msgs#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(msgs#0, Tclass.BucketsLib.Bucket())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> $Is(PivotBetreeSpec.__default.AddMessagesToNode(node#0, msgs#0), 
        Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.AddMessagesToNode#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.AddMessagesToNode
axiom (forall node#0: DatatypeType, msgs#0: DatatypeType :: 
  { PivotBetreeSpec.__default.AddMessagesToNode#requires(node#0, msgs#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
       && $Is(msgs#0, Tclass.BucketsLib.Bucket())
     ==> PivotBetreeSpec.__default.AddMessagesToNode#requires(node#0, msgs#0)
       == PivotBetreeSpec.__default.WFNode(node#0));

// definition axiom for PivotBetreeSpec.__default.AddMessagesToNode(revealed)
axiom true
   ==> (forall node#0: DatatypeType, msgs#0: DatatypeType :: 
    { PivotBetreeSpec.__default.AddMessagesToNode(node#0, msgs#0) } 
    PivotBetreeSpec.__default.AddMessagesToNode#canCall(node#0, msgs#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(msgs#0, Tclass.BucketsLib.Bucket())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && PivotBetreeGraph.Node.Node_q(node#0)
         && 
        PivotBetreeGraph.Node.Node_q(node#0)
         && PivotBetreeGraph.Node.Node_q(node#0)
         && BucketsLib.__default.BucketListFlush#canCall(msgs#0, 
          PivotBetreeGraph.Node.buckets(node#0), 
          PivotBetreeGraph.Node.pivotTable(node#0))
         && PivotBetreeSpec.__default.AddMessagesToNode(node#0, msgs#0)
           == #PivotBetreeGraph.Node.Node(PivotBetreeGraph.Node.pivotTable(node#0), 
            PivotBetreeGraph.Node.children(node#0), 
            BucketsLib.__default.BucketListFlush(msgs#0, 
              PivotBetreeGraph.Node.buckets(node#0), 
              PivotBetreeGraph.Node.pivotTable(node#0))));

// definition axiom for PivotBetreeSpec.__default.AddMessagesToNode for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, msgs#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.AddMessagesToNode(Lit(node#0), Lit(msgs#0)) } 
    PivotBetreeSpec.__default.AddMessagesToNode#canCall(Lit(node#0), Lit(msgs#0))
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(msgs#0, Tclass.BucketsLib.Bucket())
           && Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && BucketsLib.__default.BucketListFlush#canCall(Lit(msgs#0), 
          Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
          Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))
         && PivotBetreeSpec.__default.AddMessagesToNode(Lit(node#0), Lit(msgs#0))
           == Lit(#PivotBetreeGraph.Node.Node(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.children(Lit(node#0))), 
              Lit(BucketsLib.__default.BucketListFlush(Lit(msgs#0), 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                  Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))))));

// function declaration for PivotBetreeSpec._default.BufferIsDefining
function PivotBetreeSpec.__default.BufferIsDefining(entry#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.BufferIsDefining#canCall(entry#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.BufferIsDefining
axiom true
   ==> (forall entry#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BufferIsDefining(entry#0) } 
    PivotBetreeSpec.__default.BufferIsDefining#canCall(entry#0)
         || $Is(entry#0, Tclass.ValueMessage.Message())
       ==> true);

function PivotBetreeSpec.__default.BufferIsDefining#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.BufferIsDefining
axiom (forall entry#0: DatatypeType :: 
  { PivotBetreeSpec.__default.BufferIsDefining#requires(entry#0) } 
  $Is(entry#0, Tclass.ValueMessage.Message())
     ==> PivotBetreeSpec.__default.BufferIsDefining#requires(entry#0) == true);

// definition axiom for PivotBetreeSpec.__default.BufferIsDefining(revealed)
axiom true
   ==> (forall entry#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BufferIsDefining(entry#0) } 
    PivotBetreeSpec.__default.BufferIsDefining#canCall(entry#0)
         || $Is(entry#0, Tclass.ValueMessage.Message())
       ==> PivotBetreeSpec.__default.BufferIsDefining(entry#0)
         == (true && ValueMessage.Message.Define_q(entry#0)));

// definition axiom for PivotBetreeSpec.__default.BufferIsDefining for all literals(revealed)
axiom true
   ==> (forall entry#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.BufferIsDefining(Lit(entry#0)) } 
    PivotBetreeSpec.__default.BufferIsDefining#canCall(Lit(entry#0))
         || $Is(entry#0, Tclass.ValueMessage.Message())
       ==> PivotBetreeSpec.__default.BufferIsDefining(Lit(entry#0))
         == Lit(true && ValueMessage.Message.Define_q(Lit(entry#0))));

// function declaration for PivotBetreeSpec._default.BufferDefinesValue
function PivotBetreeSpec.__default.BufferDefinesValue(log#0: DatatypeType, value#0: Seq Box) : bool;

function PivotBetreeSpec.__default.BufferDefinesValue#canCall(log#0: DatatypeType, value#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.BufferDefinesValue
axiom true
   ==> (forall log#0: DatatypeType, value#0: Seq Box :: 
    { PivotBetreeSpec.__default.BufferDefinesValue(log#0, value#0) } 
    PivotBetreeSpec.__default.BufferDefinesValue#canCall(log#0, value#0)
         || ($Is(log#0, Tclass.ValueMessage.Message())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> true);

function PivotBetreeSpec.__default.BufferDefinesValue#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.BufferDefinesValue
axiom (forall log#0: DatatypeType, value#0: Seq Box :: 
  { PivotBetreeSpec.__default.BufferDefinesValue#requires(log#0, value#0) } 
  $Is(log#0, Tclass.ValueMessage.Message())
       && $Is(value#0, Tclass.ValueType.Value())
     ==> PivotBetreeSpec.__default.BufferDefinesValue#requires(log#0, value#0) == true);

// definition axiom for PivotBetreeSpec.__default.BufferDefinesValue(revealed)
axiom true
   ==> (forall log#0: DatatypeType, value#0: Seq Box :: 
    { PivotBetreeSpec.__default.BufferDefinesValue(log#0, value#0) } 
    PivotBetreeSpec.__default.BufferDefinesValue#canCall(log#0, value#0)
         || ($Is(log#0, Tclass.ValueMessage.Message())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> PivotBetreeSpec.__default.BufferIsDefining#canCall(log#0)
         && PivotBetreeSpec.__default.BufferDefinesValue(log#0, value#0)
           == (PivotBetreeSpec.__default.BufferIsDefining(log#0)
             && Seq#Equal(ValueMessage.Message.value(log#0), value#0)));

// definition axiom for PivotBetreeSpec.__default.BufferDefinesValue for all literals(revealed)
axiom true
   ==> (forall log#0: DatatypeType, value#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.BufferDefinesValue(Lit(log#0), Lit(value#0)) } 
    PivotBetreeSpec.__default.BufferDefinesValue#canCall(Lit(log#0), Lit(value#0))
         || ($Is(log#0, Tclass.ValueMessage.Message())
           && $Is(value#0, Tclass.ValueType.Value()))
       ==> PivotBetreeSpec.__default.BufferIsDefining#canCall(Lit(log#0))
         && PivotBetreeSpec.__default.BufferDefinesValue(Lit(log#0), Lit(value#0))
           == (PivotBetreeSpec.__default.BufferIsDefining(Lit(log#0))
             && Seq#Equal(ValueMessage.Message.value(Lit(log#0)), value#0)));

// function declaration for PivotBetreeSpec._default.ValidLayerIndex
function PivotBetreeSpec.__default.ValidLayerIndex(lookup#0: Seq Box, idx#0: int) : bool;

function PivotBetreeSpec.__default.ValidLayerIndex#canCall(lookup#0: Seq Box, idx#0: int) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidLayerIndex
axiom true
   ==> (forall lookup#0: Seq Box, idx#0: int :: 
    { PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0) } 
    PivotBetreeSpec.__default.ValidLayerIndex#canCall(lookup#0, idx#0)
         || $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       ==> true);

function PivotBetreeSpec.__default.ValidLayerIndex#requires(Seq Box, int) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidLayerIndex
axiom (forall lookup#0: Seq Box, idx#0: int :: 
  { PivotBetreeSpec.__default.ValidLayerIndex#requires(lookup#0, idx#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
     ==> PivotBetreeSpec.__default.ValidLayerIndex#requires(lookup#0, idx#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidLayerIndex(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, idx#0: int :: 
    { PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0) } 
    PivotBetreeSpec.__default.ValidLayerIndex#canCall(lookup#0, idx#0)
         || $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       ==> PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0)
         == (true && LitInt(0) <= idx#0 && idx#0 < Seq#Length(lookup#0)));

// definition axiom for PivotBetreeSpec.__default.ValidLayerIndex for all literals(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, idx#0: int :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidLayerIndex(Lit(lookup#0), LitInt(idx#0)) } 
    PivotBetreeSpec.__default.ValidLayerIndex#canCall(Lit(lookup#0), LitInt(idx#0))
         || $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       ==> PivotBetreeSpec.__default.ValidLayerIndex(Lit(lookup#0), LitInt(idx#0))
         == (true && LitInt(0) <= LitInt(idx#0) && idx#0 < Seq#Length(Lit(lookup#0))));

// function declaration for PivotBetreeSpec._default.LookupVisitsWFNodes
function PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0: Seq Box) : bool;

function PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(lookup#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.LookupVisitsWFNodes
axiom true
   ==> (forall lookup#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0) } 
    PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(lookup#0)
         || $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       ==> true);

function PivotBetreeSpec.__default.LookupVisitsWFNodes#requires(Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.LookupVisitsWFNodes
axiom (forall lookup#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupVisitsWFNodes#requires(lookup#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
     ==> PivotBetreeSpec.__default.LookupVisitsWFNodes#requires(lookup#0) == true);

// definition axiom for PivotBetreeSpec.__default.LookupVisitsWFNodes(revealed)
axiom true
   ==> (forall lookup#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0) } 
    PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(lookup#0)
         || $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(lookup#0, i#0)): DatatypeType } 
          i#0 < Seq#Length(lookup#0)
             ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)
               && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)))
         && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(lookup#0, i#0)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(lookup#0)
               ==> PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType))));

// definition axiom for PivotBetreeSpec.__default.LookupVisitsWFNodes for all literals(revealed)
axiom true
   ==> (forall lookup#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0)) } 
    PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(Lit(lookup#0))
         || $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(lookup#0, i#1)): DatatypeType } 
          i#1 < Seq#Length(Lit(lookup#0))
             ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)
               && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)))
         && PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(lookup#0, i#1)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(lookup#0))
               ==> PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType))));

// function declaration for PivotBetreeSpec._default.LookupVisitsWellMarshalledBuckets
function PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(lookup#0: Seq Box, key#0: Seq Box) : bool;

function PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#canCall(lookup#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(lookup#0, key#0) } 
    PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> true);

function PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#requires(Seq Box, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets
axiom (forall lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#requires(lookup#0, key#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#requires(lookup#0, key#0)
       == PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0));

// definition axiom for PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(lookup#0, key#0) } 
    PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> (forall i#0: int :: 
          { $Unbox(Seq#Index(lookup#0, i#0)): DatatypeType } 
          i#0 < Seq#Length(lookup#0)
             ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)
               && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType))
               && 
              PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)
               && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType))
               && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)), 
                key#0)
               && BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)), 
                    PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)), 
                      key#0))): DatatypeType))
         && PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(lookup#0, key#0)
           == (forall i#0: int :: 
            { $Unbox(Seq#Index(lookup#0, i#0)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(lookup#0)
               ==> BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)), 
                    PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, i#0)): DatatypeType)), 
                      key#0))): DatatypeType)));

// definition axiom for PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets for all literals(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(Lit(lookup#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#canCall(Lit(lookup#0), Lit(key#0))
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))))
       ==> (forall i#1: int :: 
          { $Unbox(Seq#Index(lookup#0, i#1)): DatatypeType } 
          i#1 < Seq#Length(Lit(lookup#0))
             ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)
               && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType))
               && 
              PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)
               && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType))
               && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)), 
                Lit(key#0))
               && BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)), 
                    PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)), 
                      Lit(key#0)))): DatatypeType))
         && PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(Lit(lookup#0), Lit(key#0))
           == (forall i#1: int :: 
            { $Unbox(Seq#Index(lookup#0, i#1)): DatatypeType } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(lookup#0))
               ==> BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)), 
                    PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), i#1)): DatatypeType)), 
                      Lit(key#0)))): DatatypeType)));

// function declaration for PivotBetreeSpec._default.LookupFollowsChildRefAtLayer
function PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0: Seq Box, lookup#0: Seq Box, idx#0: int) : bool;

function PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#canCall(key#0: Seq Box, lookup#0: Seq Box, idx#0: int) : bool;

// consequence axiom for PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer
axiom true
   ==> (forall key#0: Seq Box, lookup#0: Seq Box, idx#0: int :: 
    { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#0) } 
    PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#canCall(key#0, lookup#0, idx#0)
         || (
          $Is(key#0, Tclass.KeyType.Key())
           && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && 
          PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0)
           && idx#0 < Seq#Length(lookup#0) - 1
           && PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)))
       ==> true);

function PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#requires(Seq Box, Seq Box, int) : bool;

// #requires axiom for PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer
axiom (forall key#0: Seq Box, lookup#0: Seq Box, idx#0: int :: 
  { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#requires(key#0, lookup#0, idx#0) } 
  $Is(key#0, Tclass.KeyType.Key())
       && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
     ==> PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#requires(key#0, lookup#0, idx#0)
       == (
        PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0)
         && idx#0 < Seq#Length(lookup#0) - 1
         && PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType))));

// definition axiom for PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(revealed)
axiom true
   ==> (forall key#0: Seq Box, lookup#0: Seq Box, idx#0: int :: 
    { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#0) } 
    PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#canCall(key#0, lookup#0, idx#0)
         || (
          $Is(key#0, Tclass.KeyType.Key())
           && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && 
          PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0)
           && idx#0 < Seq#Length(lookup#0) - 1
           && PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)))
       ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType))
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)))
           ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType))
             && 
            PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType))
             && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)), 
              key#0)
             && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, idx#0 + 1)): DatatypeType))
         && PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#0)
           == (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)))
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)))): Seq Box, 
                  PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(lookup#0, idx#0)): DatatypeType)), 
                    key#0))): int
               == PivotBetreeGraph.ReadOp.ref($Unbox(Seq#Index(lookup#0, idx#0 + 1)): DatatypeType)));

// definition axiom for PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box, lookup#0: Seq Box, idx#0: int :: 
    {:weight 3} { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(Lit(key#0), Lit(lookup#0), LitInt(idx#0)) } 
    PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#canCall(Lit(key#0), Lit(lookup#0), LitInt(idx#0))
         || (
          $Is(key#0, Tclass.KeyType.Key())
           && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && 
          Lit(PivotBetreeSpec.__default.ValidLayerIndex(Lit(lookup#0), LitInt(idx#0)))
           && idx#0 < Seq#Length(Lit(lookup#0)) - 1
           && PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)))
       ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType))
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)))
           ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType))
             && 
            PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType))
             && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)), 
              Lit(key#0))
             && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0 + 1))): DatatypeType))
         && PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(Lit(key#0), Lit(lookup#0), LitInt(idx#0))
           == (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)))
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)))): Seq Box, 
                  PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0))): DatatypeType)), 
                    Lit(key#0)))): int
               == PivotBetreeGraph.ReadOp.ref($Unbox(Seq#Index(Lit(lookup#0), LitInt(idx#0 + 1))): DatatypeType)));

// function declaration for PivotBetreeSpec._default.LookupFollowsChildRefs
function PivotBetreeSpec.__default.LookupFollowsChildRefs(key#0: Seq Box, lookup#0: Seq Box) : bool;

function PivotBetreeSpec.__default.LookupFollowsChildRefs#canCall(key#0: Seq Box, lookup#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.LookupFollowsChildRefs
axiom true
   ==> (forall key#0: Seq Box, lookup#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupFollowsChildRefs(key#0, lookup#0) } 
    PivotBetreeSpec.__default.LookupFollowsChildRefs#canCall(key#0, lookup#0)
         || (
          $Is(key#0, Tclass.KeyType.Key())
           && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> true);

function PivotBetreeSpec.__default.LookupFollowsChildRefs#requires(Seq Box, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.LookupFollowsChildRefs
axiom (forall key#0: Seq Box, lookup#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupFollowsChildRefs#requires(key#0, lookup#0) } 
  $Is(key#0, Tclass.KeyType.Key())
       && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
     ==> PivotBetreeSpec.__default.LookupFollowsChildRefs#requires(key#0, lookup#0)
       == PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0));

// definition axiom for PivotBetreeSpec.__default.LookupFollowsChildRefs(revealed)
axiom true
   ==> (forall key#0: Seq Box, lookup#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupFollowsChildRefs(key#0, lookup#0) } 
    PivotBetreeSpec.__default.LookupFollowsChildRefs#canCall(key#0, lookup#0)
         || (
          $Is(key#0, Tclass.KeyType.Key())
           && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> (Lit(true)
           ==> (forall idx#0: int :: 
            { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#0) } 
              { PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0) } 
            PivotBetreeSpec.__default.ValidLayerIndex#canCall(lookup#0, idx#0)
               && (idx#0 < Seq#Length(lookup#0) - 1
                 ==> PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#canCall(key#0, lookup#0, idx#0))))
         && PivotBetreeSpec.__default.LookupFollowsChildRefs(key#0, lookup#0)
           == (true
             && (forall idx#0: int :: 
              { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#0) } 
                { PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0) } 
              true
                 ==> 
                PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#0)
                   && idx#0 < Seq#Length(lookup#0) - 1
                 ==> PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#0))));

// definition axiom for PivotBetreeSpec.__default.LookupFollowsChildRefs for all literals(revealed)
axiom true
   ==> (forall key#0: Seq Box, lookup#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.LookupFollowsChildRefs(Lit(key#0), Lit(lookup#0)) } 
    PivotBetreeSpec.__default.LookupFollowsChildRefs#canCall(Lit(key#0), Lit(lookup#0))
         || (
          $Is(key#0, Tclass.KeyType.Key())
           && $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && Lit(PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))))
       ==> (Lit(true)
           ==> (forall idx#1: int :: 
            { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#1) } 
              { PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#1) } 
            PivotBetreeSpec.__default.ValidLayerIndex#canCall(Lit(lookup#0), idx#1)
               && (idx#1 < Seq#Length(Lit(lookup#0)) - 1
                 ==> PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer#canCall(Lit(key#0), Lit(lookup#0), idx#1))))
         && PivotBetreeSpec.__default.LookupFollowsChildRefs(Lit(key#0), Lit(lookup#0))
           == (true
             && (forall idx#1: int :: 
              { PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(key#0, lookup#0, idx#1) } 
                { PivotBetreeSpec.__default.ValidLayerIndex(lookup#0, idx#1) } 
              true
                 ==> 
                PivotBetreeSpec.__default.ValidLayerIndex(Lit(lookup#0), idx#1)
                   && idx#1 < Seq#Length(Lit(lookup#0)) - 1
                 ==> PivotBetreeSpec.__default.LookupFollowsChildRefAtLayer(Lit(key#0), Lit(lookup#0), idx#1))));

// function declaration for PivotBetreeSpec._default.NodeLookup
function PivotBetreeSpec.__default.NodeLookup(node#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.NodeLookup#canCall(node#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.NodeLookup
axiom true
   ==> (forall node#0: DatatypeType, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.NodeLookup(node#0, key#0) } 
    PivotBetreeSpec.__default.NodeLookup#canCall(node#0, key#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucketList(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0)))
       ==> $Is(PivotBetreeSpec.__default.NodeLookup(node#0, key#0), 
        Tclass.ValueMessage.Message()));

function PivotBetreeSpec.__default.NodeLookup#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.NodeLookup
axiom (forall node#0: DatatypeType, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.NodeLookup#requires(node#0, key#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node()) && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.NodeLookup#requires(node#0, key#0)
       == BucketsLib.__default.WFBucketList(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0)));

// definition axiom for PivotBetreeSpec.__default.NodeLookup(revealed)
axiom true
   ==> (forall node#0: DatatypeType, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.NodeLookup(node#0, key#0) } 
    PivotBetreeSpec.__default.NodeLookup#canCall(node#0, key#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(key#0, Tclass.KeyType.Key())
           && BucketsLib.__default.WFBucketList(PivotBetreeGraph.Node.buckets(node#0), PivotBetreeGraph.Node.pivotTable(node#0)))
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && PivotBetreeGraph.Node.Node_q(node#0)
         && BucketsLib.__default.BucketListGet#canCall(PivotBetreeGraph.Node.buckets(node#0), 
          PivotBetreeGraph.Node.pivotTable(node#0), 
          key#0)
         && PivotBetreeSpec.__default.NodeLookup(node#0, key#0)
           == BucketsLib.__default.BucketListGet(PivotBetreeGraph.Node.buckets(node#0), 
            PivotBetreeGraph.Node.pivotTable(node#0), 
            key#0));

// definition axiom for PivotBetreeSpec.__default.NodeLookup for all literals(revealed)
axiom true
   ==> (forall node#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.NodeLookup(Lit(node#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.NodeLookup#canCall(Lit(node#0), Lit(key#0))
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(BucketsLib.__default.WFBucketList(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && BucketsLib.__default.BucketListGet#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
          Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
          Lit(key#0))
         && PivotBetreeSpec.__default.NodeLookup(Lit(node#0), Lit(key#0))
           == Lit(BucketsLib.__default.BucketListGet(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              Lit(key#0))));

// function declaration for PivotBetreeSpec._default.InterpretLookup
function PivotBetreeSpec.__default.InterpretLookup($ly: LayerType, lookup#0: Seq Box, key#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.InterpretLookup#canCall(lookup#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.InterpretLookup($LS($ly), lookup#0, key#0) } 
  PivotBetreeSpec.__default.InterpretLookup($LS($ly), lookup#0, key#0)
     == PivotBetreeSpec.__default.InterpretLookup($ly, lookup#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.InterpretLookup(AsFuelBottom($ly), lookup#0, key#0) } 
  PivotBetreeSpec.__default.InterpretLookup($ly, lookup#0, key#0)
     == PivotBetreeSpec.__default.InterpretLookup($LZ, lookup#0, key#0));

// consequence axiom for PivotBetreeSpec.__default.InterpretLookup
axiom true
   ==> (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.InterpretLookup($ly, lookup#0, key#0) } 
    PivotBetreeSpec.__default.InterpretLookup#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> $Is(PivotBetreeSpec.__default.InterpretLookup($ly, lookup#0, key#0), 
        Tclass.ValueMessage.Message()));

function PivotBetreeSpec.__default.InterpretLookup#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.InterpretLookup
axiom (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.InterpretLookup#requires($ly, lookup#0, key#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.InterpretLookup#requires($ly, lookup#0, key#0)
       == PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0));

// definition axiom for PivotBetreeSpec.__default.InterpretLookup(revealed)
axiom true
   ==> (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.InterpretLookup($LS($ly), lookup#0, key#0) } 
    PivotBetreeSpec.__default.InterpretLookup#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> (Seq#Length(lookup#0) == LitInt(0)
           ==> ValueMessage.__default.NopDelta#canCall())
         && (Seq#Length(lookup#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)
             && PivotBetreeSpec.__default.InterpretLookup#canCall(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), lookup#0), key#0)
             && 
            Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)
             && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType)
             && PivotBetreeSpec.__default.NodeLookup#canCall(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType), 
              key#0)
             && ValueMessage.__default.Merge#canCall(PivotBetreeSpec.__default.InterpretLookup($ly, 
                Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), lookup#0), 
                key#0), 
              PivotBetreeSpec.__default.NodeLookup(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType), 
                key#0)))
         && PivotBetreeSpec.__default.InterpretLookup($LS($ly), lookup#0, key#0)
           == (if Seq#Length(lookup#0) == LitInt(0)
             then #ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta()))
             else ValueMessage.__default.Merge(PivotBetreeSpec.__default.InterpretLookup($ly, 
                Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), lookup#0), 
                key#0), 
              PivotBetreeSpec.__default.NodeLookup(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType), 
                key#0))));

// definition axiom for PivotBetreeSpec.__default.InterpretLookup for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.InterpretLookup($LS($ly), Lit(lookup#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.InterpretLookup#canCall(Lit(lookup#0), Lit(key#0))
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))))
       ==> (Seq#Length(Lit(lookup#0)) == LitInt(0)
           ==> ValueMessage.__default.NopDelta#canCall())
         && (Seq#Length(Lit(lookup#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))
             && PivotBetreeSpec.__default.InterpretLookup#canCall(Lit(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))), 
              Lit(key#0))
             && 
            Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))
             && PivotBetreeGraph.ReadOp.ReadOp_q(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))
             && PivotBetreeSpec.__default.NodeLookup#canCall(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))), 
              Lit(key#0))
             && ValueMessage.__default.Merge#canCall(Lit(PivotBetreeSpec.__default.InterpretLookup($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))), 
                  Lit(key#0))), 
              Lit(PivotBetreeSpec.__default.NodeLookup(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))), 
                  Lit(key#0)))))
         && PivotBetreeSpec.__default.InterpretLookup($LS($ly), Lit(lookup#0), Lit(key#0))
           == (if Seq#Length(Lit(lookup#0)) == LitInt(0)
             then #ValueMessage.Message.Update(Lit(ValueMessage.__default.NopDelta()))
             else ValueMessage.__default.Merge(Lit(PivotBetreeSpec.__default.InterpretLookup($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))), 
                  Lit(key#0))), 
              Lit(PivotBetreeSpec.__default.NodeLookup(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))), 
                  Lit(key#0))))));

// function declaration for PivotBetreeSpec._default.InterpretLookupAccountingForLeaf
function PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(lookup#0: Seq Box, key#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#canCall(lookup#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(lookup#0, key#0) } 
    PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Seq#Length(lookup#0) > 0
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> $Is(PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(lookup#0, key#0), 
        Tclass.ValueMessage.Message()));

function PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#requires(Seq Box, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf
axiom (forall lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#requires(lookup#0, key#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#requires(lookup#0, key#0)
       == (Seq#Length(lookup#0) > 0
         && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0)));

// definition axiom for PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(lookup#0, key#0) } 
    PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Seq#Length(lookup#0) > 0
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)
         && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType))
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType)))
           ==> PivotBetreeSpec.__default.InterpretLookup#canCall(lookup#0, key#0))
         && (!Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType)))
           ==> PivotBetreeSpec.__default.InterpretLookup#canCall(lookup#0, key#0)
             && ValueMessage.__default.DefineDefault#canCall()
             && ValueMessage.__default.Merge#canCall(PivotBetreeSpec.__default.InterpretLookup($LS($LZ), lookup#0, key#0), 
              Lit(ValueMessage.__default.DefineDefault())))
         && PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(lookup#0, key#0)
           == (if Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType)))
             then PivotBetreeSpec.__default.InterpretLookup($LS($LZ), lookup#0, key#0)
             else ValueMessage.__default.Merge(PivotBetreeSpec.__default.InterpretLookup($LS($LZ), lookup#0, key#0), 
              Lit(ValueMessage.__default.DefineDefault()))));

// definition axiom for PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf for all literals(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(Lit(lookup#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#canCall(Lit(lookup#0), Lit(key#0))
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && 
          Seq#Length(Lit(lookup#0)) > 0
           && Lit(PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))))
       ==> Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))
         && PivotBetreeGraph.ReadOp.ReadOp_q(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))
         && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))))
         && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType)))))))
           ==> PivotBetreeSpec.__default.InterpretLookup#canCall(Lit(lookup#0), Lit(key#0)))
         && (!Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType)))))))
           ==> PivotBetreeSpec.__default.InterpretLookup#canCall(Lit(lookup#0), Lit(key#0))
             && ValueMessage.__default.DefineDefault#canCall()
             && ValueMessage.__default.Merge#canCall(Lit(PivotBetreeSpec.__default.InterpretLookup($LS($LZ), Lit(lookup#0), Lit(key#0))), 
              Lit(ValueMessage.__default.DefineDefault())))
         && PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(Lit(lookup#0), Lit(key#0))
           == (if Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType))))))
             then PivotBetreeSpec.__default.InterpretLookup($LS($LZ), Lit(lookup#0), Lit(key#0))
             else ValueMessage.__default.Merge(Lit(PivotBetreeSpec.__default.InterpretLookup($LS($LZ), Lit(lookup#0), Lit(key#0))), 
              Lit(ValueMessage.__default.DefineDefault()))));

// function declaration for PivotBetreeSpec._default.WFLookupForKey
function PivotBetreeSpec.__default.WFLookupForKey(lookup#0: Seq Box, key#0: Seq Box) : bool;

function PivotBetreeSpec.__default.WFLookupForKey#canCall(lookup#0: Seq Box, key#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.WFLookupForKey
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.WFLookupForKey(lookup#0, key#0) } 
    PivotBetreeSpec.__default.WFLookupForKey#canCall(lookup#0, key#0)
         || ($Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> true);

function PivotBetreeSpec.__default.WFLookupForKey#requires(Seq Box, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.WFLookupForKey
axiom (forall lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.WFLookupForKey#requires(lookup#0, key#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.WFLookupForKey#requires(lookup#0, key#0) == true);

// definition axiom for PivotBetreeSpec.__default.WFLookupForKey(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.WFLookupForKey(lookup#0, key#0) } 
    PivotBetreeSpec.__default.WFLookupForKey#canCall(lookup#0, key#0)
         || ($Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(lookup#0) > 0
           ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, LitInt(0))): DatatypeType)
             && PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(lookup#0, LitInt(0))): DatatypeType)
             && PivotBetreeGraph.__default.Root#canCall()
             && PivotBetreeGraph.ReadOp.ref($Unbox(Seq#Index(lookup#0, LitInt(0))): DatatypeType)
               == LitInt(PivotBetreeGraph.__default.Root())
           ==> PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(lookup#0))
         && (PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(lookup#0)
             && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0)
           ==> PivotBetreeSpec.__default.LookupFollowsChildRefs#canCall(key#0, lookup#0))
         && PivotBetreeSpec.__default.WFLookupForKey(lookup#0, key#0)
           == (
            Seq#Length(lookup#0) > 0
             && PivotBetreeGraph.ReadOp.ref($Unbox(Seq#Index(lookup#0, LitInt(0))): DatatypeType)
               == LitInt(PivotBetreeGraph.__default.Root())
             && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0)
             && PivotBetreeSpec.__default.LookupFollowsChildRefs(key#0, lookup#0)));

// definition axiom for PivotBetreeSpec.__default.WFLookupForKey for all literals(revealed)
axiom true
   ==> (forall lookup#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.WFLookupForKey(Lit(lookup#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.WFLookupForKey#canCall(Lit(lookup#0), Lit(key#0))
         || ($Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(lookup#0)) > 0
           ==> PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), LitInt(0))): DatatypeType)
             && PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(lookup#0), LitInt(0))): DatatypeType)
             && PivotBetreeGraph.__default.Root#canCall()
             && PivotBetreeGraph.ReadOp.ref($Unbox(Seq#Index(Lit(lookup#0), LitInt(0))): DatatypeType)
               == LitInt(PivotBetreeGraph.__default.Root())
           ==> PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(Lit(lookup#0)))
         && (PivotBetreeSpec.__default.LookupVisitsWFNodes#canCall(Lit(lookup#0))
             && Lit(PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0)))
           ==> PivotBetreeSpec.__default.LookupFollowsChildRefs#canCall(Lit(key#0), Lit(lookup#0)))
         && PivotBetreeSpec.__default.WFLookupForKey(Lit(lookup#0), Lit(key#0))
           == (
            Seq#Length(Lit(lookup#0)) > 0
             && PivotBetreeGraph.ReadOp.ref($Unbox(Seq#Index(Lit(lookup#0), LitInt(0))): DatatypeType)
               == LitInt(PivotBetreeGraph.__default.Root())
             && PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))
             && PivotBetreeSpec.__default.LookupFollowsChildRefs(Lit(key#0), Lit(lookup#0))));

// function declaration for PivotBetreeSpec._default.ValidQuery
function PivotBetreeSpec.__default.ValidQuery(q#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidQuery#canCall(q#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidQuery
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidQuery(q#0) } 
    PivotBetreeSpec.__default.ValidQuery#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> true);

function PivotBetreeSpec.__default.ValidQuery#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidQuery
axiom (forall q#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidQuery#requires(q#0) } 
  $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
     ==> PivotBetreeSpec.__default.ValidQuery#requires(q#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidQuery(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidQuery(q#0) } 
    PivotBetreeSpec.__default.ValidQuery#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
         && PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
         && PivotBetreeSpec.__default.WFLookupForKey#canCall(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
         && (PivotBetreeSpec.__default.WFLookupForKey(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
           ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
             && PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
             && PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#canCall(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
             && (PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
               ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
                 && PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
                 && PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#canCall(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
                 && PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
                 && PivotBetreeSpec.__default.BufferDefinesValue#canCall(PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0)), 
                  PivotBetreeSpec.LookupQuery.value(q#0))))
         && PivotBetreeSpec.__default.ValidQuery(q#0)
           == (PivotBetreeSpec.__default.WFLookupForKey(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
             && (PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0))
               ==> PivotBetreeSpec.__default.BufferDefinesValue(PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(PivotBetreeSpec.LookupQuery.lookup(q#0), PivotBetreeSpec.LookupQuery.key(q#0)), 
                PivotBetreeSpec.LookupQuery.value(q#0)))));

// definition axiom for PivotBetreeSpec.__default.ValidQuery for all literals(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidQuery(Lit(q#0)) } 
    PivotBetreeSpec.__default.ValidQuery#canCall(Lit(q#0))
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
         && PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
         && PivotBetreeSpec.__default.WFLookupForKey#canCall(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
          Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))
         && (Lit(PivotBetreeSpec.__default.WFLookupForKey(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
              Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0)))))
           ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
             && PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
             && PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets#canCall(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
              Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))
             && (Lit(PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
                  Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0)))))
               ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
                 && PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
                 && PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf#canCall(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
                  Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))
                 && PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
                 && PivotBetreeSpec.__default.BufferDefinesValue#canCall(Lit(PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
                      Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))), 
                  Lit(PivotBetreeSpec.LookupQuery.value(Lit(q#0))))))
         && PivotBetreeSpec.__default.ValidQuery(Lit(q#0))
           == Lit(PivotBetreeSpec.__default.WFLookupForKey(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
                Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))
               && (PivotBetreeSpec.__default.LookupVisitsWellMarshalledBuckets(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
                  Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))
                 ==> PivotBetreeSpec.__default.BufferDefinesValue(Lit(PivotBetreeSpec.__default.InterpretLookupAccountingForLeaf(Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))), 
                      Lit(PivotBetreeSpec.LookupQuery.key(Lit(q#0))))), 
                  Lit(PivotBetreeSpec.LookupQuery.value(Lit(q#0)))))));

// function declaration for PivotBetreeSpec._default.QueryReads
function PivotBetreeSpec.__default.QueryReads(q#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.QueryReads#canCall(q#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.QueryReads
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.QueryReads(q#0) } 
    PivotBetreeSpec.__default.QueryReads#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> $Is(PivotBetreeSpec.__default.QueryReads(q#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.QueryReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.QueryReads
axiom (forall q#0: DatatypeType :: 
  { PivotBetreeSpec.__default.QueryReads#requires(q#0) } 
  $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
     ==> PivotBetreeSpec.__default.QueryReads#requires(q#0) == true);

// definition axiom for PivotBetreeSpec.__default.QueryReads(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.QueryReads(q#0) } 
    PivotBetreeSpec.__default.QueryReads#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
         && PivotBetreeSpec.__default.QueryReads(q#0)
           == PivotBetreeSpec.LookupQuery.lookup(q#0));

// definition axiom for PivotBetreeSpec.__default.QueryReads for all literals(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.QueryReads(Lit(q#0)) } 
    PivotBetreeSpec.__default.QueryReads#canCall(Lit(q#0))
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> PivotBetreeSpec.LookupQuery.LookupQuery_q(Lit(q#0))
         && PivotBetreeSpec.__default.QueryReads(Lit(q#0))
           == Lit(PivotBetreeSpec.LookupQuery.lookup(Lit(q#0))));

// function declaration for PivotBetreeSpec._default.QueryOps
function PivotBetreeSpec.__default.QueryOps(q#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.QueryOps#canCall(q#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.QueryOps
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.QueryOps(q#0) } 
    PivotBetreeSpec.__default.QueryOps#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> $Is(PivotBetreeSpec.__default.QueryOps(q#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.QueryOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.QueryOps
axiom (forall q#0: DatatypeType :: 
  { PivotBetreeSpec.__default.QueryOps#requires(q#0) } 
  $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
     ==> PivotBetreeSpec.__default.QueryOps#requires(q#0) == true);

// definition axiom for PivotBetreeSpec.__default.QueryOps(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.QueryOps(q#0) } 
    PivotBetreeSpec.__default.QueryOps#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> PivotBetreeSpec.__default.QueryOps(q#0) == Lit(Seq#Empty(): Seq Box));

// definition axiom for PivotBetreeSpec.__default.QueryOps for all literals(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.QueryOps(Lit(q#0)) } 
    PivotBetreeSpec.__default.QueryOps#canCall(Lit(q#0))
         || $Is(q#0, Tclass.PivotBetreeSpec.LookupQuery())
       ==> PivotBetreeSpec.__default.QueryOps(Lit(q#0)) == Lit(Seq#Empty(): Seq Box));

// function declaration for PivotBetreeSpec._default.LookupUpperBoundAtLayer
function PivotBetreeSpec.__default.LookupUpperBoundAtLayer(layer#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.LookupUpperBoundAtLayer#canCall(layer#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.LookupUpperBoundAtLayer
axiom true
   ==> (forall layer#0: DatatypeType, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupUpperBoundAtLayer(layer#0, key#0) } 
    PivotBetreeSpec.__default.LookupUpperBoundAtLayer#canCall(layer#0, key#0)
         || (
          $Is(layer#0, Tclass.PivotBetreeGraph.ReadOp())
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node(layer#0)))
       ==> $Is(PivotBetreeSpec.__default.LookupUpperBoundAtLayer(layer#0, key#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function PivotBetreeSpec.__default.LookupUpperBoundAtLayer#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.LookupUpperBoundAtLayer
axiom (forall layer#0: DatatypeType, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupUpperBoundAtLayer#requires(layer#0, key#0) } 
  $Is(layer#0, Tclass.PivotBetreeGraph.ReadOp())
       && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.LookupUpperBoundAtLayer#requires(layer#0, key#0)
       == PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node(layer#0)));

// definition axiom for PivotBetreeSpec.__default.LookupUpperBoundAtLayer(revealed)
axiom true
   ==> (forall layer#0: DatatypeType, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupUpperBoundAtLayer(layer#0, key#0) } 
    PivotBetreeSpec.__default.LookupUpperBoundAtLayer#canCall(layer#0, key#0)
         || (
          $Is(layer#0, Tclass.PivotBetreeGraph.ReadOp())
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.WFNode(PivotBetreeGraph.ReadOp.node(layer#0)))
       ==> PivotBetreeGraph.ReadOp.ReadOp_q(layer#0)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node(layer#0))
         && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node(layer#0)), key#0)
         && (var r#0 := PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node(layer#0)), key#0); 
          PivotBetreeGraph.ReadOp.ReadOp_q(layer#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node(layer#0))
             && (r#0
                 < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node(layer#0)))
               ==> PivotBetreeGraph.ReadOp.ReadOp_q(layer#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node(layer#0))))
         && PivotBetreeSpec.__default.LookupUpperBoundAtLayer(layer#0, key#0)
           == (var r#0 := PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node(layer#0)), key#0); 
            (if r#0
                 < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node(layer#0)))
               then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node(layer#0)), r#0))
               else #Options.Option.None())));

// definition axiom for PivotBetreeSpec.__default.LookupUpperBoundAtLayer for all literals(revealed)
axiom true
   ==> (forall layer#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.LookupUpperBoundAtLayer(Lit(layer#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.LookupUpperBoundAtLayer#canCall(Lit(layer#0), Lit(key#0))
         || (
          $Is(layer#0, Tclass.PivotBetreeGraph.ReadOp())
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))))
       ==> PivotBetreeGraph.ReadOp.ReadOp_q(Lit(layer#0))
         && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))
         && PivotsLib.__default.Route#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))), 
          Lit(key#0))
         && (var r#1 := LitInt(PivotsLib.__default.Route(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))), 
                Lit(key#0))); 
          PivotBetreeGraph.ReadOp.ReadOp_q(Lit(layer#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))
             && (r#1
                 < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))))
               ==> PivotBetreeGraph.ReadOp.ReadOp_q(Lit(layer#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))))
         && PivotBetreeSpec.__default.LookupUpperBoundAtLayer(Lit(layer#0), Lit(key#0))
           == (var r#1 := LitInt(PivotsLib.__default.Route(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))), 
                  Lit(key#0))); 
            (if r#1
                 < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))))
               then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeGraph.ReadOp.node(Lit(layer#0))))), 
                  r#1))
               else #Options.Option.None())));

// function declaration for PivotBetreeSpec._default.OptionKeyMin
function PivotBetreeSpec.__default.OptionKeyMin(k1#0: DatatypeType, k2#0: DatatypeType) : DatatypeType;

function PivotBetreeSpec.__default.OptionKeyMin#canCall(k1#0: DatatypeType, k2#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.OptionKeyMin
axiom true
   ==> (forall k1#0: DatatypeType, k2#0: DatatypeType :: 
    { PivotBetreeSpec.__default.OptionKeyMin(k1#0, k2#0) } 
    PivotBetreeSpec.__default.OptionKeyMin#canCall(k1#0, k2#0)
         || ($Is(k1#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && $Is(k2#0, Tclass.Options.Option(Tclass.KeyType.Key())))
       ==> $Is(PivotBetreeSpec.__default.OptionKeyMin(k1#0, k2#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function PivotBetreeSpec.__default.OptionKeyMin#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.OptionKeyMin
axiom (forall k1#0: DatatypeType, k2#0: DatatypeType :: 
  { PivotBetreeSpec.__default.OptionKeyMin#requires(k1#0, k2#0) } 
  $Is(k1#0, Tclass.Options.Option(Tclass.KeyType.Key()))
       && $Is(k2#0, Tclass.Options.Option(Tclass.KeyType.Key()))
     ==> PivotBetreeSpec.__default.OptionKeyMin#requires(k1#0, k2#0) == true);

// definition axiom for PivotBetreeSpec.__default.OptionKeyMin(revealed)
axiom true
   ==> (forall k1#0: DatatypeType, k2#0: DatatypeType :: 
    { PivotBetreeSpec.__default.OptionKeyMin(k1#0, k2#0) } 
    PivotBetreeSpec.__default.OptionKeyMin#canCall(k1#0, k2#0)
         || ($Is(k1#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && $Is(k2#0, Tclass.Options.Option(Tclass.KeyType.Key())))
       ==> (!Options.Option.None_q(k1#0)
           ==> 
          !Options.Option.None_q(k2#0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Options.Option.value(k1#0)): Seq Box, 
            $Unbox(Options.Option.value(k2#0)): Seq Box))
         && PivotBetreeSpec.__default.OptionKeyMin(k1#0, k2#0)
           == (if Options.Option.None_q(k1#0)
             then k2#0
             else (var key1#1 := $Unbox(Options.Option.value(k1#0)): Seq Box; 
              (if Options.Option.None_q(k2#0)
                 then k1#0
                 else (var key2#1 := $Unbox(Options.Option.value(k2#0)): Seq Box; 
                  (if Lexicographic__Byte__Order.__default.lt($Unbox(Options.Option.value(k1#0)): Seq Box, 
                      $Unbox(Options.Option.value(k2#0)): Seq Box)
                     then #Options.Option.Some(Options.Option.value(k1#0))
                     else #Options.Option.Some(Options.Option.value(k2#0))))))));

// definition axiom for PivotBetreeSpec.__default.OptionKeyMin for all literals(revealed)
axiom true
   ==> (forall k1#0: DatatypeType, k2#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.OptionKeyMin(Lit(k1#0), Lit(k2#0)) } 
    PivotBetreeSpec.__default.OptionKeyMin#canCall(Lit(k1#0), Lit(k2#0))
         || ($Is(k1#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && $Is(k2#0, Tclass.Options.Option(Tclass.KeyType.Key())))
       ==> (!Lit(Options.Option.None_q(Lit(k1#0)))
           ==> 
          !Lit(Options.Option.None_q(Lit(k2#0)))
           ==> Lexicographic__Byte__Order.__default.lt#canCall(Lit($Unbox(Options.Option.value(Lit(k1#0))): Seq Box), 
            Lit($Unbox(Options.Option.value(Lit(k2#0))): Seq Box)))
         && PivotBetreeSpec.__default.OptionKeyMin(Lit(k1#0), Lit(k2#0))
           == (if Options.Option.None_q(Lit(k1#0))
             then k2#0
             else (var key1#3 := Lit($Unbox(Options.Option.value(Lit(k1#0))): Seq Box); 
              (if Options.Option.None_q(Lit(k2#0))
                 then k1#0
                 else (var key2#3 := Lit($Unbox(Options.Option.value(Lit(k2#0))): Seq Box); 
                  (if Lexicographic__Byte__Order.__default.lt(Lit($Unbox(Options.Option.value(Lit(k1#0))): Seq Box), 
                      Lit($Unbox(Options.Option.value(Lit(k2#0))): Seq Box))
                     then #Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(k1#0))): Seq Box)))
                     else #Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(k2#0))): Seq Box)))))))));

// function declaration for PivotBetreeSpec._default.LookupUpperBound
function PivotBetreeSpec.__default.LookupUpperBound($ly: LayerType, lookup#0: Seq Box, key#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.LookupUpperBound#canCall(lookup#0: Seq Box, key#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupUpperBound($LS($ly), lookup#0, key#0) } 
  PivotBetreeSpec.__default.LookupUpperBound($LS($ly), lookup#0, key#0)
     == PivotBetreeSpec.__default.LookupUpperBound($ly, lookup#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupUpperBound(AsFuelBottom($ly), lookup#0, key#0) } 
  PivotBetreeSpec.__default.LookupUpperBound($ly, lookup#0, key#0)
     == PivotBetreeSpec.__default.LookupUpperBound($LZ, lookup#0, key#0));

// consequence axiom for PivotBetreeSpec.__default.LookupUpperBound
axiom true
   ==> (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupUpperBound($ly, lookup#0, key#0) } 
    PivotBetreeSpec.__default.LookupUpperBound#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> $Is(PivotBetreeSpec.__default.LookupUpperBound($ly, lookup#0, key#0), 
        Tclass.Options.Option(Tclass.KeyType.Key())));

function PivotBetreeSpec.__default.LookupUpperBound#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.LookupUpperBound
axiom (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
  { PivotBetreeSpec.__default.LookupUpperBound#requires($ly, lookup#0, key#0) } 
  $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
       && $Is(key#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.LookupUpperBound#requires($ly, lookup#0, key#0)
       == PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0));

// definition axiom for PivotBetreeSpec.__default.LookupUpperBound(revealed)
axiom true
   ==> (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
    { PivotBetreeSpec.__default.LookupUpperBound($LS($ly), lookup#0, key#0) } 
    PivotBetreeSpec.__default.LookupUpperBound#canCall(lookup#0, key#0)
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.LookupVisitsWFNodes(lookup#0))
       ==> (!Seq#Equal(lookup#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)
             && PivotBetreeSpec.__default.LookupUpperBound#canCall(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), lookup#0), key#0)
             && 
            Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)
             && PivotBetreeSpec.__default.LookupUpperBoundAtLayer#canCall($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType, 
              key#0)
             && PivotBetreeSpec.__default.OptionKeyMin#canCall(PivotBetreeSpec.__default.LookupUpperBound($ly, 
                Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), lookup#0), 
                key#0), 
              PivotBetreeSpec.__default.LookupUpperBoundAtLayer($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType, 
                key#0)))
         && PivotBetreeSpec.__default.LookupUpperBound($LS($ly), lookup#0, key#0)
           == (if Seq#Equal(lookup#0, Seq#Empty(): Seq Box)
             then #Options.Option.None()
             else PivotBetreeSpec.__default.OptionKeyMin(PivotBetreeSpec.__default.LookupUpperBound($ly, 
                Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), lookup#0), 
                key#0), 
              PivotBetreeSpec.__default.LookupUpperBoundAtLayer($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), lookup#0)): DatatypeType, 
                key#0))));

// definition axiom for PivotBetreeSpec.__default.LookupUpperBound for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, lookup#0: Seq Box, key#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.LookupUpperBound($LS($ly), Lit(lookup#0), Lit(key#0)) } 
    PivotBetreeSpec.__default.LookupUpperBound#canCall(Lit(lookup#0), Lit(key#0))
         || (
          $Is(lookup#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
           && $Is(key#0, Tclass.KeyType.Key())
           && Lit(PivotBetreeSpec.__default.LookupVisitsWFNodes(Lit(lookup#0))))
       ==> (!Seq#Equal(lookup#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))
             && PivotBetreeSpec.__default.LookupUpperBound#canCall(Lit(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))), 
              Lit(key#0))
             && 
            Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))
             && PivotBetreeSpec.__default.LookupUpperBoundAtLayer#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType), 
              Lit(key#0))
             && PivotBetreeSpec.__default.OptionKeyMin#canCall(PivotBetreeSpec.__default.LookupUpperBound($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))), 
                Lit(key#0)), 
              Lit(PivotBetreeSpec.__default.LookupUpperBoundAtLayer(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType), 
                  Lit(key#0)))))
         && PivotBetreeSpec.__default.LookupUpperBound($LS($ly), Lit(lookup#0), Lit(key#0))
           == (if Seq#Equal(lookup#0, Seq#Empty(): Seq Box)
             then #Options.Option.None()
             else PivotBetreeSpec.__default.OptionKeyMin(PivotBetreeSpec.__default.LookupUpperBound($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))), 
                Lit(key#0)), 
              Lit(PivotBetreeSpec.__default.LookupUpperBoundAtLayer(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), Lit(lookup#0))): DatatypeType), 
                  Lit(key#0))))));

// function declaration for PivotBetreeSpec._default.BufferDefinesEmptyValue
function PivotBetreeSpec.__default.BufferDefinesEmptyValue(m#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.BufferDefinesEmptyValue#canCall(m#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.BufferDefinesEmptyValue
axiom true
   ==> (forall m#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BufferDefinesEmptyValue(m#0) } 
    PivotBetreeSpec.__default.BufferDefinesEmptyValue#canCall(m#0)
         || $Is(m#0, Tclass.ValueMessage.Message())
       ==> true);

function PivotBetreeSpec.__default.BufferDefinesEmptyValue#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.BufferDefinesEmptyValue
axiom (forall m#0: DatatypeType :: 
  { PivotBetreeSpec.__default.BufferDefinesEmptyValue#requires(m#0) } 
  $Is(m#0, Tclass.ValueMessage.Message())
     ==> PivotBetreeSpec.__default.BufferDefinesEmptyValue#requires(m#0) == true);

// definition axiom for PivotBetreeSpec.__default.BufferDefinesEmptyValue(revealed)
axiom true
   ==> (forall m#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BufferDefinesEmptyValue(m#0) } 
    PivotBetreeSpec.__default.BufferDefinesEmptyValue#canCall(m#0)
         || $Is(m#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.DefineDefault#canCall()
         && ValueMessage.__default.Merge#canCall(m#0, Lit(ValueMessage.__default.DefineDefault()))
         && ValueMessage.__default.DefaultValue#canCall()
         && PivotBetreeSpec.__default.BufferDefinesEmptyValue(m#0)
           == Seq#Equal(ValueMessage.Message.value(ValueMessage.__default.Merge(m#0, Lit(ValueMessage.__default.DefineDefault()))), 
            ValueMessage.__default.DefaultValue()));

// definition axiom for PivotBetreeSpec.__default.BufferDefinesEmptyValue for all literals(revealed)
axiom true
   ==> (forall m#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.BufferDefinesEmptyValue(Lit(m#0)) } 
    PivotBetreeSpec.__default.BufferDefinesEmptyValue#canCall(Lit(m#0))
         || $Is(m#0, Tclass.ValueMessage.Message())
       ==> ValueMessage.__default.DefineDefault#canCall()
         && ValueMessage.__default.Merge#canCall(Lit(m#0), Lit(ValueMessage.__default.DefineDefault()))
         && ValueMessage.__default.DefaultValue#canCall()
         && PivotBetreeSpec.__default.BufferDefinesEmptyValue(Lit(m#0))
           == Seq#Equal(ValueMessage.Message.value(Lit(ValueMessage.__default.Merge(Lit(m#0), Lit(ValueMessage.__default.DefineDefault())))), 
            ValueMessage.__default.DefaultValue()));

// function declaration for PivotBetreeSpec._default.ValidSuccQuery
function PivotBetreeSpec.__default.ValidSuccQuery(sq#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidSuccQuery#canCall(sq#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidSuccQuery
axiom true
   ==> (forall sq#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidSuccQuery(sq#0) } 
    PivotBetreeSpec.__default.ValidSuccQuery#canCall(sq#0)
         || $Is(sq#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> true);

function PivotBetreeSpec.__default.ValidSuccQuery#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidSuccQuery
axiom (forall sq#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidSuccQuery#requires(sq#0) } 
  $Is(sq#0, Tclass.PivotBetreeSpec.SuccQuery())
     ==> PivotBetreeSpec.__default.ValidSuccQuery#requires(sq#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidSuccQuery(revealed)
axiom true
   ==> (forall sq#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidSuccQuery(sq#0) } 
    PivotBetreeSpec.__default.ValidSuccQuery#canCall(sq#0)
         || $Is(sq#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> (Lit(true)
           ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
             && (!UI.RangeStart.NegativeInf_q(PivotBetreeSpec.SuccQuery.start(sq#0))
               ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0))
             && (var startKey#0 := (if UI.RangeStart.NegativeInf_q(PivotBetreeSpec.SuccQuery.start(sq#0))
                   then Seq#Empty(): Seq Box
                   else UI.RangeStart.key(PivotBetreeSpec.SuccQuery.start(sq#0))); 
              PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                 && PivotBetreeSpec.__default.WFLookupForKey#canCall(PivotBetreeSpec.SuccQuery.lookup(sq#0), startKey#0)
                 && (PivotBetreeSpec.__default.WFLookupForKey(PivotBetreeSpec.SuccQuery.lookup(sq#0), startKey#0)
                   ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                     && PivotBetreeSpec.__default.LookupUpperBound#canCall(PivotBetreeSpec.SuccQuery.lookup(sq#0), startKey#0)
                     && (var lookupUpperBound#0 := PivotBetreeSpec.__default.LookupUpperBound(StartFuel_PivotBetreeSpec._default.LookupUpperBound, 
                          PivotBetreeSpec.SuccQuery.lookup(sq#0), 
                          startKey#0); 
                      PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                         && Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), PivotBetreeSpec.SuccQuery.lookup(sq#0))
                         && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), PivotBetreeSpec.SuccQuery.lookup(sq#0))): DatatypeType)
                         && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), PivotBetreeSpec.SuccQuery.lookup(sq#0))): DatatypeType))
                         && (Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), PivotBetreeSpec.SuccQuery.lookup(sq#0))): DatatypeType)))
                           ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                             && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0))
                         && (PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                             && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                             && Seq#Length(PivotBetreeSpec.SuccQuery.lookup(sq#0))
                               == Seq#Length(PivotBetreeSpec.SuccQuery.buckets(sq#0))
                           ==> (forall i#0: int :: 
                            { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType } 
                              { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType } 
                            (LitInt(0) <= i#0 ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0))
                               && (LitInt(0) <= i#0 && i#0 < Seq#Length(PivotBetreeSpec.SuccQuery.lookup(sq#0))
                                 ==> $IsA#BucketsLib.Bucket($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType)
                                   && $IsA#BucketsLib.Bucket($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                        PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                          startKey#0))): DatatypeType)
                                   && 
                                  PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                   && 
                                  PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                   && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)
                                   && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType))
                                   && 
                                  PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                   && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)
                                   && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType))
                                   && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                    startKey#0))))
                         && ((forall i#0: int :: 
                              { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType } 
                                { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType } 
                              (LitInt(0) <= i#0 ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0))
                                 && (LitInt(0) <= i#0 && i#0 < Seq#Length(PivotBetreeSpec.SuccQuery.lookup(sq#0))
                                   ==> $IsA#BucketsLib.Bucket($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType)
                                     && $IsA#BucketsLib.Bucket($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                          PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                            startKey#0))): DatatypeType)
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)
                                     && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType))
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)
                                     && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType))
                                     && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                      startKey#0)))
                             && (forall i#0: int :: 
                              { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType } 
                                { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType } 
                              LitInt(0) <= i#0 && i#0 < Seq#Length(PivotBetreeSpec.SuccQuery.lookup(sq#0))
                                 ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType, 
                                  $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                      PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                        startKey#0))): DatatypeType))
                           ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                             && BucketsLib.__default.BucketListWellMarshalled#canCall(PivotBetreeSpec.SuccQuery.buckets(sq#0))
                             && (BucketsLib.__default.BucketListWellMarshalled(PivotBetreeSpec.SuccQuery.buckets(sq#0))
                               ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                 && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                 && MapSpec.__default.NonEmptyRange#canCall(PivotBetreeSpec.SuccQuery.start(sq#0), PivotBetreeSpec.SuccQuery.end(sq#0))
                                 && (MapSpec.__default.NonEmptyRange(PivotBetreeSpec.SuccQuery.start(sq#0), PivotBetreeSpec.SuccQuery.end(sq#0))
                                   ==> 
                                  Options.Option.Some_q(lookupUpperBound#0)
                                   ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && MapSpec.__default.UpperBound#canCall($Unbox(Options.Option.value(lookupUpperBound#0)): Seq Box, 
                                      PivotBetreeSpec.SuccQuery.end(sq#0)))
                                 && ((Options.Option.Some_q(lookupUpperBound#0)
                                       ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                         && MapSpec.__default.UpperBound#canCall($Unbox(Options.Option.value(lookupUpperBound#0)): Seq Box, 
                                          PivotBetreeSpec.SuccQuery.end(sq#0)))
                                     && (Options.Option.Some_q(lookupUpperBound#0)
                                       ==> !MapSpec.__default.UpperBound($Unbox(Options.Option.value(lookupUpperBound#0)): Seq Box, 
                                        PivotBetreeSpec.SuccQuery.end(sq#0)))
                                   ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && BucketsLib.__default.ComposeSeq#canCall(PivotBetreeSpec.SuccQuery.buckets(sq#0))
                                     && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                                     && BucketsLib.__default.ClampRange#canCall(BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                        PivotBetreeSpec.SuccQuery.buckets(sq#0)), 
                                      PivotBetreeSpec.SuccQuery.start(sq#0), 
                                      PivotBetreeSpec.SuccQuery.end(sq#0))
                                     && BucketsLib.__default.KeyValueMapOfBucket#canCall(BucketsLib.__default.ClampRange(StartFuel_BucketsLib._default.ClampRange, 
                                        BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                          PivotBetreeSpec.SuccQuery.buckets(sq#0)), 
                                        PivotBetreeSpec.SuccQuery.start(sq#0), 
                                        PivotBetreeSpec.SuccQuery.end(sq#0)))
                                     && BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(BucketsLib.__default.KeyValueMapOfBucket(StartFuel_BucketsLib._default.KeyValueMapOfBucket, 
                                        BucketsLib.__default.ClampRange(StartFuel_BucketsLib._default.ClampRange, 
                                          BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                            PivotBetreeSpec.SuccQuery.buckets(sq#0)), 
                                          PivotBetreeSpec.SuccQuery.start(sq#0), 
                                          PivotBetreeSpec.SuccQuery.end(sq#0)))))))))))
         && PivotBetreeSpec.__default.ValidSuccQuery(sq#0)
           == (true
             && (var startKey#0 := (if UI.RangeStart.NegativeInf_q(PivotBetreeSpec.SuccQuery.start(sq#0))
                   then Seq#Empty(): Seq Box
                   else UI.RangeStart.key(PivotBetreeSpec.SuccQuery.start(sq#0))); 
              PivotBetreeSpec.__default.WFLookupForKey(PivotBetreeSpec.SuccQuery.lookup(sq#0), startKey#0)
                 && (var lookupUpperBound#0 := PivotBetreeSpec.__default.LookupUpperBound(StartFuel_PivotBetreeSpec._default.LookupUpperBound, 
                      PivotBetreeSpec.SuccQuery.lookup(sq#0), 
                      startKey#0); 
                  Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeGraph.ReadOp.node($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), PivotBetreeSpec.SuccQuery.lookup(sq#0))): DatatypeType)))
                     && Seq#Length(PivotBetreeSpec.SuccQuery.lookup(sq#0))
                       == Seq#Length(PivotBetreeSpec.SuccQuery.buckets(sq#0))
                     && (forall i#0: int :: 
                      { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType } 
                        { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType } 
                      LitInt(0) <= i#0 && i#0 < Seq#Length(PivotBetreeSpec.SuccQuery.lookup(sq#0))
                         ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#0)): DatatypeType, 
                          $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                              PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#0)): DatatypeType)), 
                                startKey#0))): DatatypeType))
                     && (BucketsLib.__default.BucketListWellMarshalled(PivotBetreeSpec.SuccQuery.buckets(sq#0))
                       ==> MapSpec.__default.NonEmptyRange(PivotBetreeSpec.SuccQuery.start(sq#0), PivotBetreeSpec.SuccQuery.end(sq#0))
                         && (Options.Option.Some_q(lookupUpperBound#0)
                           ==> !MapSpec.__default.UpperBound($Unbox(Options.Option.value(lookupUpperBound#0)): Seq Box, 
                            PivotBetreeSpec.SuccQuery.end(sq#0)))
                         && Seq#Equal(PivotBetreeSpec.SuccQuery.results(sq#0), 
                          BucketsLib.__default.SortedSeqOfKeyValueMap(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap, 
                            BucketsLib.__default.KeyValueMapOfBucket(StartFuel_BucketsLib._default.KeyValueMapOfBucket, 
                              BucketsLib.__default.ClampRange(StartFuel_BucketsLib._default.ClampRange, 
                                BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                  PivotBetreeSpec.SuccQuery.buckets(sq#0)), 
                                PivotBetreeSpec.SuccQuery.start(sq#0), 
                                PivotBetreeSpec.SuccQuery.end(sq#0))))))))));

// definition axiom for PivotBetreeSpec.__default.ValidSuccQuery for all literals(revealed)
axiom true
   ==> (forall sq#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidSuccQuery(Lit(sq#0)) } 
    PivotBetreeSpec.__default.ValidSuccQuery#canCall(Lit(sq#0))
         || $Is(sq#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> (Lit(true)
           ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
             && (!Lit(UI.RangeStart.NegativeInf_q(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0)))))
               ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0)))
             && (var startKey#1 := (if UI.RangeStart.NegativeInf_q(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))))
                   then Seq#Empty(): Seq Box
                   else UI.RangeStart.key(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))))); 
              PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                 && PivotBetreeSpec.__default.WFLookupForKey#canCall(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), startKey#1)
                 && (PivotBetreeSpec.__default.WFLookupForKey(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), startKey#1)
                   ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                     && PivotBetreeSpec.__default.LookupUpperBound#canCall(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), startKey#1)
                     && (var lookupUpperBound#1 := PivotBetreeSpec.__default.LookupUpperBound(StartFuel_PivotBetreeSpec._default.LookupUpperBound, 
                          Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), 
                          startKey#1); 
                      PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                         && Sequences.__default.Last#canCall(Tclass.PivotBetreeGraph.ReadOp(), 
                          Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                         && PivotBetreeGraph.ReadOp.ReadOp_q(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), 
                                Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))): DatatypeType))
                         && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), 
                                    Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))): DatatypeType))))
                         && (Lit(Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), 
                                            Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))): DatatypeType)))))))
                           ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                             && PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0)))
                         && (PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                             && PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                             && Seq#Length(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                               == Seq#Length(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))))
                           ==> (forall i#1: int :: 
                            { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#1)): DatatypeType } 
                              { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#1)): DatatypeType } 
                            (LitInt(0) <= i#1 ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0)))
                               && (LitInt(0) <= i#1
                                   && i#1 < Seq#Length(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                                 ==> $IsA#BucketsLib.Bucket($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))), i#1)): DatatypeType)
                                   && $IsA#BucketsLib.Bucket($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                        PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                          startKey#1))): DatatypeType)
                                   && 
                                  PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                   && 
                                  PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                   && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)
                                   && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType))
                                   && 
                                  PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                   && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)
                                   && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType))
                                   && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                    startKey#1))))
                         && ((forall i#1: int :: 
                              { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#1)): DatatypeType } 
                                { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#1)): DatatypeType } 
                              (LitInt(0) <= i#1 ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0)))
                                 && (LitInt(0) <= i#1
                                     && i#1 < Seq#Length(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                                   ==> $IsA#BucketsLib.Bucket($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))), i#1)): DatatypeType)
                                     && $IsA#BucketsLib.Bucket($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                          PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                            startKey#1))): DatatypeType)
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)
                                     && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType))
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && PivotBetreeGraph.ReadOp.ReadOp_q($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)
                                     && PivotBetreeGraph.Node.Node_q(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType))
                                     && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                      startKey#1)))
                             && (forall i#1: int :: 
                              { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#1)): DatatypeType } 
                                { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#1)): DatatypeType } 
                              LitInt(0) <= i#1
                                   && i#1 < Seq#Length(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                                 ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))), i#1)): DatatypeType, 
                                  $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                      PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                        startKey#1))): DatatypeType))
                           ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                             && BucketsLib.__default.BucketListWellMarshalled#canCall(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))))
                             && (Lit(BucketsLib.__default.BucketListWellMarshalled(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0)))))
                               ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                 && PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                 && MapSpec.__default.NonEmptyRange#canCall(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                                  Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0))))
                                 && (Lit(MapSpec.__default.NonEmptyRange(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                                      Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))
                                   ==> 
                                  Options.Option.Some_q(lookupUpperBound#1)
                                   ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && MapSpec.__default.UpperBound#canCall($Unbox(Options.Option.value(lookupUpperBound#1)): Seq Box, 
                                      Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))
                                 && ((Options.Option.Some_q(lookupUpperBound#1)
                                       ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                         && MapSpec.__default.UpperBound#canCall($Unbox(Options.Option.value(lookupUpperBound#1)): Seq Box, 
                                          Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))
                                     && (Options.Option.Some_q(lookupUpperBound#1)
                                       ==> !MapSpec.__default.UpperBound($Unbox(Options.Option.value(lookupUpperBound#1)): Seq Box, 
                                        Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))
                                   ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && 
                                    PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && BucketsLib.__default.ComposeSeq#canCall(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))))
                                     && PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(sq#0))
                                     && BucketsLib.__default.ClampRange#canCall(BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                        Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0)))), 
                                      Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                                      Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0))))
                                     && BucketsLib.__default.KeyValueMapOfBucket#canCall(BucketsLib.__default.ClampRange(StartFuel_BucketsLib._default.ClampRange, 
                                        BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                          Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0)))), 
                                        Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                                        Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))
                                     && BucketsLib.__default.SortedSeqOfKeyValueMap#canCall(BucketsLib.__default.KeyValueMapOfBucket(StartFuel_BucketsLib._default.KeyValueMapOfBucket, 
                                        BucketsLib.__default.ClampRange(StartFuel_BucketsLib._default.ClampRange, 
                                          BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                            Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0)))), 
                                          Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                                          Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))))))))))
         && PivotBetreeSpec.__default.ValidSuccQuery(Lit(sq#0))
           == (true
             && (var startKey#1 := (if UI.RangeStart.NegativeInf_q(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))))
                   then Seq#Empty(): Seq Box
                   else UI.RangeStart.key(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))))); 
              PivotBetreeSpec.__default.WFLookupForKey(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), startKey#1)
                 && (var lookupUpperBound#1 := PivotBetreeSpec.__default.LookupUpperBound(StartFuel_PivotBetreeSpec._default.LookupUpperBound, 
                      Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), 
                      startKey#1); 
                  Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeGraph.ReadOp.node(Lit($Unbox(Sequences.__default.Last(Tclass.PivotBetreeGraph.ReadOp(), 
                                    Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))): DatatypeType))))))
                     && Seq#Length(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                       == Seq#Length(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))))
                     && (forall i#1: int :: 
                      { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.lookup(sq#0), i#1)): DatatypeType } 
                        { $Unbox(Seq#Index(PivotBetreeSpec.SuccQuery.buckets(sq#0), i#1)): DatatypeType } 
                      LitInt(0) <= i#1
                           && i#1 < Seq#Length(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))))
                         ==> BucketsLib.Bucket#Equal($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))), i#1)): DatatypeType, 
                          $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                              PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeGraph.ReadOp.node($Unbox(Seq#Index(Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(sq#0))), i#1)): DatatypeType)), 
                                startKey#1))): DatatypeType))
                     && (BucketsLib.__default.BucketListWellMarshalled(Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0))))
                       ==> MapSpec.__default.NonEmptyRange(Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                          Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0))))
                         && (Options.Option.Some_q(lookupUpperBound#1)
                           ==> !MapSpec.__default.UpperBound($Unbox(Options.Option.value(lookupUpperBound#1)): Seq Box, 
                            Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0)))))
                         && Seq#Equal(PivotBetreeSpec.SuccQuery.results(Lit(sq#0)), 
                          BucketsLib.__default.SortedSeqOfKeyValueMap(StartFuel_BucketsLib._default.SortedSeqOfKeyValueMap, 
                            BucketsLib.__default.KeyValueMapOfBucket(StartFuel_BucketsLib._default.KeyValueMapOfBucket, 
                              BucketsLib.__default.ClampRange(StartFuel_BucketsLib._default.ClampRange, 
                                BucketsLib.__default.ComposeSeq(StartFuel_BucketsLib._default.ComposeSeq, 
                                  Lit(PivotBetreeSpec.SuccQuery.buckets(Lit(sq#0)))), 
                                Lit(PivotBetreeSpec.SuccQuery.start(Lit(sq#0))), 
                                Lit(PivotBetreeSpec.SuccQuery.end(Lit(sq#0))))))))))));

// function declaration for PivotBetreeSpec._default.SuccQueryReads
function PivotBetreeSpec.__default.SuccQueryReads(q#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.SuccQueryReads#canCall(q#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.SuccQueryReads
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SuccQueryReads(q#0) } 
    PivotBetreeSpec.__default.SuccQueryReads#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> $Is(PivotBetreeSpec.__default.SuccQueryReads(q#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.SuccQueryReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.SuccQueryReads
axiom (forall q#0: DatatypeType :: 
  { PivotBetreeSpec.__default.SuccQueryReads#requires(q#0) } 
  $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
     ==> PivotBetreeSpec.__default.SuccQueryReads#requires(q#0) == true);

// definition axiom for PivotBetreeSpec.__default.SuccQueryReads(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SuccQueryReads(q#0) } 
    PivotBetreeSpec.__default.SuccQueryReads#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(q#0)
         && PivotBetreeSpec.__default.SuccQueryReads(q#0)
           == PivotBetreeSpec.SuccQuery.lookup(q#0));

// definition axiom for PivotBetreeSpec.__default.SuccQueryReads for all literals(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.SuccQueryReads(Lit(q#0)) } 
    PivotBetreeSpec.__default.SuccQueryReads#canCall(Lit(q#0))
         || $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> PivotBetreeSpec.SuccQuery.SuccQuery_q(Lit(q#0))
         && PivotBetreeSpec.__default.SuccQueryReads(Lit(q#0))
           == Lit(PivotBetreeSpec.SuccQuery.lookup(Lit(q#0))));

// function declaration for PivotBetreeSpec._default.SuccQueryOps
function PivotBetreeSpec.__default.SuccQueryOps(q#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.SuccQueryOps#canCall(q#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.SuccQueryOps
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SuccQueryOps(q#0) } 
    PivotBetreeSpec.__default.SuccQueryOps#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> $Is(PivotBetreeSpec.__default.SuccQueryOps(q#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.SuccQueryOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.SuccQueryOps
axiom (forall q#0: DatatypeType :: 
  { PivotBetreeSpec.__default.SuccQueryOps#requires(q#0) } 
  $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
     ==> PivotBetreeSpec.__default.SuccQueryOps#requires(q#0) == true);

// definition axiom for PivotBetreeSpec.__default.SuccQueryOps(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SuccQueryOps(q#0) } 
    PivotBetreeSpec.__default.SuccQueryOps#canCall(q#0)
         || $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> PivotBetreeSpec.__default.SuccQueryOps(q#0) == Lit(Seq#Empty(): Seq Box));

// definition axiom for PivotBetreeSpec.__default.SuccQueryOps for all literals(revealed)
axiom true
   ==> (forall q#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.SuccQueryOps(Lit(q#0)) } 
    PivotBetreeSpec.__default.SuccQueryOps#canCall(Lit(q#0))
         || $Is(q#0, Tclass.PivotBetreeSpec.SuccQuery())
       ==> PivotBetreeSpec.__default.SuccQueryOps(Lit(q#0)) == Lit(Seq#Empty(): Seq Box));

// function declaration for PivotBetreeSpec._default.ValidInsertion
function PivotBetreeSpec.__default.ValidInsertion(ins#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidInsertion#canCall(ins#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidInsertion
axiom true
   ==> (forall ins#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidInsertion(ins#0) } 
    PivotBetreeSpec.__default.ValidInsertion#canCall(ins#0)
         || $Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
       ==> true);

function PivotBetreeSpec.__default.ValidInsertion#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidInsertion
axiom (forall ins#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidInsertion#requires(ins#0) } 
  $Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
     ==> PivotBetreeSpec.__default.ValidInsertion#requires(ins#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidInsertion(revealed)
axiom true
   ==> (forall ins#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidInsertion(ins#0) } 
    PivotBetreeSpec.__default.ValidInsertion#canCall(ins#0)
         || $Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
       ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
         && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.MessageInsertion.oldroot(ins#0))
         && (PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.MessageInsertion.oldroot(ins#0))
           ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.MessageInsertion.oldroot(ins#0))
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.MessageInsertion.oldroot(ins#0)))
             && 
            PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
             && BucketWeights.__default.WeightKey#canCall(PivotBetreeSpec.MessageInsertion.key(ins#0))
             && 
            PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
             && BucketWeights.__default.WeightMessage#canCall(PivotBetreeSpec.MessageInsertion.msg(ins#0))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && PivotBetreeSpec.__default.ValidInsertion(ins#0)
           == (PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.MessageInsertion.oldroot(ins#0))
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.MessageInsertion.oldroot(ins#0)))
                 + BucketWeights.__default.WeightKey(PivotBetreeSpec.MessageInsertion.key(ins#0))
                 + BucketWeights.__default.WeightMessage(PivotBetreeSpec.MessageInsertion.msg(ins#0))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())));

// definition axiom for PivotBetreeSpec.__default.ValidInsertion for all literals(revealed)
axiom true
   ==> (forall ins#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidInsertion(Lit(ins#0)) } 
    PivotBetreeSpec.__default.ValidInsertion#canCall(Lit(ins#0))
         || $Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
       ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
         && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))))
         && (Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0)))))
           ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))))))
             && 
            PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
             && BucketWeights.__default.WeightKey#canCall(Lit(PivotBetreeSpec.MessageInsertion.key(Lit(ins#0))))
             && 
            PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
             && BucketWeights.__default.WeightMessage#canCall(Lit(PivotBetreeSpec.MessageInsertion.msg(Lit(ins#0))))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && PivotBetreeSpec.__default.ValidInsertion(Lit(ins#0))
           == (PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))))
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))))))
                 + BucketWeights.__default.WeightKey(Lit(PivotBetreeSpec.MessageInsertion.key(Lit(ins#0))))
                 + BucketWeights.__default.WeightMessage(Lit(PivotBetreeSpec.MessageInsertion.msg(Lit(ins#0))))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())));

// function declaration for PivotBetreeSpec._default.InsertionReads
function PivotBetreeSpec.__default.InsertionReads(ins#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.InsertionReads#canCall(ins#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.InsertionReads
axiom true
   ==> (forall ins#0: DatatypeType :: 
    { PivotBetreeSpec.__default.InsertionReads(ins#0) } 
    PivotBetreeSpec.__default.InsertionReads#canCall(ins#0)
         || ($Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
           && PivotBetreeSpec.__default.ValidInsertion(ins#0))
       ==> $Is(PivotBetreeSpec.__default.InsertionReads(ins#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.InsertionReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.InsertionReads
axiom (forall ins#0: DatatypeType :: 
  { PivotBetreeSpec.__default.InsertionReads#requires(ins#0) } 
  $Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
     ==> PivotBetreeSpec.__default.InsertionReads#requires(ins#0)
       == PivotBetreeSpec.__default.ValidInsertion(ins#0));

// definition axiom for PivotBetreeSpec.__default.InsertionReads(revealed)
axiom true
   ==> (forall ins#0: DatatypeType :: 
    { PivotBetreeSpec.__default.InsertionReads(ins#0) } 
    PivotBetreeSpec.__default.InsertionReads#canCall(ins#0)
         || ($Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
           && PivotBetreeSpec.__default.ValidInsertion(ins#0))
       ==> PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
         && PivotBetreeSpec.__default.InsertionReads(ins#0)
           == Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeGraph.__default.Root()), 
                PivotBetreeSpec.MessageInsertion.oldroot(ins#0)))));

// definition axiom for PivotBetreeSpec.__default.InsertionReads for all literals(revealed)
axiom true
   ==> (forall ins#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.InsertionReads(Lit(ins#0)) } 
    PivotBetreeSpec.__default.InsertionReads#canCall(Lit(ins#0))
         || ($Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
           && Lit(PivotBetreeSpec.__default.ValidInsertion(Lit(ins#0))))
       ==> PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
         && PivotBetreeSpec.__default.InsertionReads(Lit(ins#0))
           == Lit(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeGraph.__default.Root()), 
                    Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0)))))))));

// function declaration for PivotBetreeSpec._default.InsertionOps
function PivotBetreeSpec.__default.InsertionOps(ins#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.InsertionOps#canCall(ins#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.InsertionOps
axiom true
   ==> (forall ins#0: DatatypeType :: 
    { PivotBetreeSpec.__default.InsertionOps(ins#0) } 
    PivotBetreeSpec.__default.InsertionOps#canCall(ins#0)
         || ($Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
           && PivotBetreeSpec.__default.ValidInsertion(ins#0))
       ==> $Is(PivotBetreeSpec.__default.InsertionOps(ins#0), 
        TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.InsertionOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.InsertionOps
axiom (forall ins#0: DatatypeType :: 
  { PivotBetreeSpec.__default.InsertionOps#requires(ins#0) } 
  $Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
     ==> PivotBetreeSpec.__default.InsertionOps#requires(ins#0)
       == PivotBetreeSpec.__default.ValidInsertion(ins#0));

// definition axiom for PivotBetreeSpec.__default.InsertionOps(revealed)
axiom true
   ==> (forall ins#0: DatatypeType :: 
    { PivotBetreeSpec.__default.InsertionOps(ins#0) } 
    PivotBetreeSpec.__default.InsertionOps#canCall(ins#0)
         || ($Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
           && PivotBetreeSpec.__default.ValidInsertion(ins#0))
       ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
         && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
         && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
         && PivotBetreeSpec.__default.AddMessageToNode#canCall(PivotBetreeSpec.MessageInsertion.oldroot(ins#0), 
          PivotBetreeSpec.MessageInsertion.key(ins#0), 
          PivotBetreeSpec.MessageInsertion.msg(ins#0))
         && PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.__default.InsertionOps(ins#0)
           == (var newroot#0 := PivotBetreeSpec.__default.AddMessageToNode(PivotBetreeSpec.MessageInsertion.oldroot(ins#0), 
                PivotBetreeSpec.MessageInsertion.key(ins#0), 
                PivotBetreeSpec.MessageInsertion.msg(ins#0)); 
            (var writeop#0 := #PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeGraph.__default.Root()), newroot#0); 
              Seq#Build(Seq#Empty(): Seq Box, $Box(writeop#0)))));

// definition axiom for PivotBetreeSpec.__default.InsertionOps for all literals(revealed)
axiom true
   ==> (forall ins#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.InsertionOps(Lit(ins#0)) } 
    PivotBetreeSpec.__default.InsertionOps#canCall(Lit(ins#0))
         || ($Is(ins#0, Tclass.PivotBetreeSpec.MessageInsertion())
           && Lit(PivotBetreeSpec.__default.ValidInsertion(Lit(ins#0))))
       ==> PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
         && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
         && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(Lit(ins#0))
         && PivotBetreeSpec.__default.AddMessageToNode#canCall(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))), 
          Lit(PivotBetreeSpec.MessageInsertion.key(Lit(ins#0))), 
          Lit(PivotBetreeSpec.MessageInsertion.msg(Lit(ins#0))))
         && PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.__default.InsertionOps(Lit(ins#0))
           == (var newroot#1 := Lit(PivotBetreeSpec.__default.AddMessageToNode(Lit(PivotBetreeSpec.MessageInsertion.oldroot(Lit(ins#0))), 
                  Lit(PivotBetreeSpec.MessageInsertion.key(Lit(ins#0))), 
                  Lit(PivotBetreeSpec.MessageInsertion.msg(Lit(ins#0))))); 
            (var writeop#1 := Lit(#PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeGraph.__default.Root()), newroot#1)); 
              Lit(Seq#Build(Seq#Empty(): Seq Box, $Box(writeop#1))))));

// function declaration for PivotBetreeSpec._default.ValidFlush
function PivotBetreeSpec.__default.ValidFlush(f#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidFlush#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidFlush
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidFlush(f#0) } 
    PivotBetreeSpec.__default.ValidFlush#canCall(f#0)
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
       ==> true);

function PivotBetreeSpec.__default.ValidFlush#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidFlush
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidFlush#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
     ==> PivotBetreeSpec.__default.ValidFlush#requires(f#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidFlush(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidFlush(f#0) } 
    PivotBetreeSpec.__default.ValidFlush#canCall(f#0)
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
       ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFlush.parent(f#0))
         && (PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFlush.parent(f#0))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFlush.child(f#0)))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFlush.child(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFlush.child(f#0))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && (LitInt(0) <= PivotBetreeSpec.NodeFlush.slotIndex(f#0)
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && (LitInt(0) <= PivotBetreeSpec.NodeFlush.slotIndex(f#0)
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0)))
             && 
            LitInt(0) <= PivotBetreeSpec.NodeFlush.slotIndex(f#0)
             && PivotBetreeSpec.NodeFlush.slotIndex(f#0)
               < Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0)))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
             && Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFlush.parent(f#0)))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFlush.parent(f#0)))): Seq Box, 
                  PivotBetreeSpec.NodeFlush.slotIndex(f#0))): int
               == PivotBetreeSpec.NodeFlush.childref(f#0)
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
             && BucketsLib.__default.WFBucketList#canCall(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0), 
              PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
             && BucketsLib.__default.WFBucketList#canCall(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0), 
              PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))
             && BucketsLib.__default.WFBucketList(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0), 
              PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketsLib.__default.WFBucket#canCall(PivotBetreeSpec.NodeFlush.newParentBucket(f#0)))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketsLib.__default.WFBucket#canCall(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
             && BucketsLib.__default.WFBucket(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0))
             && Bounds.__default.MaxTotalBucketWeight#canCall()
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                PivotBetreeSpec.NodeFlush.newChildBuckets(f#0))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketWeights.__default.WeightBucket#canCall(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                  PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketWeights.__default.WeightBucket#canCall(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                  PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType)
             && BucketWeights.__default.WeightBucket(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
               <= BucketWeights.__default.WeightBucket($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                    PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType)
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
             && BucketsLib.__default.BucketListWellMarshalled#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)))
             && (BucketsLib.__default.BucketListWellMarshalled(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)))
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                      PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType))
             && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                      PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType)
                 && BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                      PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType)
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
                 && BucketsLib.__default.WFBucketListProper#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)), 
                  PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0))))
             && (PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
                 && BucketsLib.__default.WFBucketListProper#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)), 
                  PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))
                 && BucketsLib.__default.WFBucketListProper(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)), 
                  PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))
               ==> $IsA#BucketsLib.Bucket(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
                 && $IsA#BucketsLib.Bucket(BucketsLib.__default.BucketComplement(StartFuel_BucketsLib._default.BucketComplement, 
                    $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                        PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                    PivotBetreeSpec.NodeFlush.keys(f#0)))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                 && BucketsLib.__default.BucketComplement#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                      PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                  PivotBetreeSpec.NodeFlush.keys(f#0))
                 && (BucketsLib.Bucket#Equal(PivotBetreeSpec.NodeFlush.newParentBucket(f#0), 
                    BucketsLib.__default.BucketComplement(StartFuel_BucketsLib._default.BucketComplement, 
                      $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                          PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                      PivotBetreeSpec.NodeFlush.keys(f#0)))
                   ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                     && 
                    PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                     && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
                     && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                     && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                     && BucketsLib.__default.BucketIntersect#canCall($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                          PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                      PivotBetreeSpec.NodeFlush.keys(f#0))
                     && 
                    PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                     && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
                     && 
                    PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
                     && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.child(f#0))
                     && BucketsLib.__default.BucketListFlush#canCall(BucketsLib.__default.BucketIntersect(StartFuel_BucketsLib._default.BucketIntersect, 
                        $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                            PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                        PivotBetreeSpec.NodeFlush.keys(f#0)), 
                      PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)), 
                      PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0))))))
         && PivotBetreeSpec.__default.ValidFlush(f#0)
           == (
            PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFlush.parent(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFlush.child(f#0))
             && 
            LitInt(0) <= PivotBetreeSpec.NodeFlush.slotIndex(f#0)
             && PivotBetreeSpec.NodeFlush.slotIndex(f#0)
               < Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)))
             && Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFlush.parent(f#0)))
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFlush.parent(f#0)))): Seq Box, 
                  PivotBetreeSpec.NodeFlush.slotIndex(f#0))): int
               == PivotBetreeSpec.NodeFlush.childref(f#0)
             && BucketsLib.__default.WFBucketList(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0), 
              PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))
             && BucketsLib.__default.WFBucket(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                PivotBetreeSpec.NodeFlush.newChildBuckets(f#0))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
             && BucketWeights.__default.WeightBucket(PivotBetreeSpec.NodeFlush.newParentBucket(f#0))
               <= BucketWeights.__default.WeightBucket($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                    PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType)
             && (BucketsLib.__default.BucketListWellMarshalled(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)))
                 && BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                      PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType)
                 && BucketsLib.__default.WFBucketListProper(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)), 
                  PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))
               ==> BucketsLib.Bucket#Equal(PivotBetreeSpec.NodeFlush.newParentBucket(f#0), 
                  BucketsLib.__default.BucketComplement(StartFuel_BucketsLib._default.BucketComplement, 
                    $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                        PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                    PivotBetreeSpec.NodeFlush.keys(f#0)))
                 && Seq#Equal(PivotBetreeSpec.NodeFlush.newChildBuckets(f#0), 
                  BucketsLib.__default.BucketListFlush(BucketsLib.__default.BucketIntersect(StartFuel_BucketsLib._default.BucketIntersect, 
                      $Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                          PivotBetreeSpec.NodeFlush.slotIndex(f#0))): DatatypeType, 
                      PivotBetreeSpec.NodeFlush.keys(f#0)), 
                    PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.child(f#0)), 
                    PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.child(f#0)))))));

// definition axiom for PivotBetreeSpec.__default.ValidFlush for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidFlush(Lit(f#0)) } 
    PivotBetreeSpec.__default.ValidFlush#canCall(Lit(f#0))
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
       ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
         && (Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
             && Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && (LitInt(0) <= LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0)))
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && (LitInt(0) <= LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0)))
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0)))))
             && 
            LitInt(0) <= LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0)))
             && PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))
               < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
             && Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0)))))))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0)))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))): Seq Box), 
                  LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): int
               == LitInt(PivotBetreeSpec.NodeFlush.childref(Lit(f#0)))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
             && BucketsLib.__default.WFBucketList#canCall(Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
             && BucketsLib.__default.WFBucketList#canCall(Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))
             && Lit(BucketsLib.__default.WFBucketList(Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))), 
                Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketsLib.__default.WFBucket#canCall(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketsLib.__default.WFBucket#canCall(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0))))
             && Lit(BucketsLib.__default.WFBucket(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))))
             && Bounds.__default.MaxTotalBucketWeight#canCall()
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketWeights.__default.WeightBucket#canCall(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType))
         && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketWeights.__default.WeightBucket#canCall(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && BucketWeights.__default.WeightBucket#canCall($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType)
             && LitInt(BucketWeights.__default.WeightBucket(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)))))
               <= BucketWeights.__default.WeightBucket($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                    LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType)
           ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
             && BucketsLib.__default.BucketListWellMarshalled#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))
             && (Lit(BucketsLib.__default.BucketListWellMarshalled(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType))
             && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && BucketsLib.__default.BucketWellMarshalled#canCall($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType)
                 && BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType)
               ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
                 && BucketsLib.__default.WFBucketListProper#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))), 
                  Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))
             && (PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
                 && BucketsLib.__default.WFBucketListProper#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))), 
                  Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))
                 && Lit(BucketsLib.__default.WFBucketListProper(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))), 
                    Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))
               ==> $IsA#BucketsLib.Bucket(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0))))
                 && $IsA#BucketsLib.Bucket(BucketsLib.__default.BucketComplement(StartFuel_BucketsLib._default.BucketComplement, 
                    $Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                        LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                    Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0)))))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                 && BucketsLib.__default.BucketComplement#canCall($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                  Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0))))
                 && (BucketsLib.Bucket#Equal(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)), 
                    BucketsLib.__default.BucketComplement(StartFuel_BucketsLib._default.BucketComplement, 
                      $Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                          LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                      Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0)))))
                   ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                     && 
                    PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                     && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
                     && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                     && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                     && BucketsLib.__default.BucketIntersect#canCall($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                          LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                      Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0))))
                     && 
                    PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                     && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
                     && 
                    PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
                     && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
                     && BucketsLib.__default.BucketListFlush#canCall(BucketsLib.__default.BucketIntersect(StartFuel_BucketsLib._default.BucketIntersect, 
                        $Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                            LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                        Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0)))), 
                      Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))), 
                      Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))))
         && PivotBetreeSpec.__default.ValidFlush(Lit(f#0))
           == (
            PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
             && PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))
             && 
            LitInt(0) <= LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0)))
             && PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))
               < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))
             && Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))
             && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))): Seq Box), 
                  LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): int
               == LitInt(PivotBetreeSpec.NodeFlush.childref(Lit(f#0)))
             && BucketsLib.__default.WFBucketList(Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))
             && BucketsLib.__default.WFBucket(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0))))
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
             && LitInt(BucketWeights.__default.WeightBucket(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)))))
               <= BucketWeights.__default.WeightBucket($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                    LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType)
             && (BucketsLib.__default.BucketListWellMarshalled(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))
                 && BucketsLib.__default.BucketWellMarshalled($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType)
                 && BucketsLib.__default.WFBucketListProper(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))), 
                  Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))
               ==> BucketsLib.Bucket#Equal(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)), 
                  BucketsLib.__default.BucketComplement(StartFuel_BucketsLib._default.BucketComplement, 
                    $Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                        LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                    Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0)))))
                 && Seq#Equal(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0)), 
                  BucketsLib.__default.BucketListFlush(BucketsLib.__default.BucketIntersect(StartFuel_BucketsLib._default.BucketIntersect, 
                      $Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                          LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))))): DatatypeType, 
                      Lit(PivotBetreeSpec.NodeFlush.keys(Lit(f#0)))), 
                    Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))), 
                    Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))))))))));

// function declaration for PivotBetreeSpec._default.FlushReads
function PivotBetreeSpec.__default.FlushReads(f#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.FlushReads#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.FlushReads
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.FlushReads(f#0) } 
    PivotBetreeSpec.__default.FlushReads#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
           && PivotBetreeSpec.__default.ValidFlush(f#0))
       ==> $Is(PivotBetreeSpec.__default.FlushReads(f#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.FlushReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.FlushReads
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.FlushReads#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
     ==> PivotBetreeSpec.__default.FlushReads#requires(f#0)
       == PivotBetreeSpec.__default.ValidFlush(f#0));

// definition axiom for PivotBetreeSpec.__default.FlushReads(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.FlushReads(f#0) } 
    PivotBetreeSpec.__default.FlushReads#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
           && PivotBetreeSpec.__default.ValidFlush(f#0))
       ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.__default.FlushReads(f#0)
           == Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFlush.parentref(f#0), PivotBetreeSpec.NodeFlush.parent(f#0)))), 
            $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFlush.childref(f#0), PivotBetreeSpec.NodeFlush.child(f#0)))));

// definition axiom for PivotBetreeSpec.__default.FlushReads for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.FlushReads(Lit(f#0)) } 
    PivotBetreeSpec.__default.FlushReads#canCall(Lit(f#0))
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
           && Lit(PivotBetreeSpec.__default.ValidFlush(Lit(f#0))))
       ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.__default.FlushReads(Lit(f#0))
           == Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFlush.parentref(Lit(f#0))), 
                      Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))), 
              $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFlush.childref(Lit(f#0))), 
                    Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0)))))))));

// function declaration for PivotBetreeSpec._default.FlushOps
function PivotBetreeSpec.__default.FlushOps(f#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.FlushOps#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.FlushOps
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.FlushOps(f#0) } 
    PivotBetreeSpec.__default.FlushOps#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
           && PivotBetreeSpec.__default.ValidFlush(f#0))
       ==> $Is(PivotBetreeSpec.__default.FlushOps(f#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.FlushOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.FlushOps
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.FlushOps#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
     ==> PivotBetreeSpec.__default.FlushOps#requires(f#0)
       == PivotBetreeSpec.__default.ValidFlush(f#0));

// definition axiom for PivotBetreeSpec.__default.FlushOps(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.FlushOps(f#0) } 
    PivotBetreeSpec.__default.FlushOps#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
           && PivotBetreeSpec.__default.ValidFlush(f#0))
       ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFlush.parent(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && (var dt_update_tmp#0#0 := PivotBetreeSpec.NodeFlush.child(f#0); 
          PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
             && 
            PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#0)
             && PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#0))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(f#0)
         && PivotBetreeSpec.__default.FlushOps(f#0)
           == (var newparent#0 := #PivotBetreeGraph.Node.Node(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                #Options.Option.Some($Box(Seq#Update($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFlush.parent(f#0)))): Seq Box, 
                      PivotBetreeSpec.NodeFlush.slotIndex(f#0), 
                      $Box(PivotBetreeSpec.NodeFlush.newchildref(f#0))))), 
                Seq#Update(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFlush.parent(f#0)), 
                  PivotBetreeSpec.NodeFlush.slotIndex(f#0), 
                  $Box(PivotBetreeSpec.NodeFlush.newParentBucket(f#0)))); 
            (var newchild#0 := (var dt_update_tmp#0#0 := PivotBetreeSpec.NodeFlush.child(f#0); 
                  (var dt_update#buckets#0#0 := PivotBetreeSpec.NodeFlush.newChildBuckets(f#0); 
                    #PivotBetreeGraph.Node.Node(PivotBetreeGraph.Node.pivotTable(dt_update_tmp#0#0), 
                      PivotBetreeGraph.Node.children(dt_update_tmp#0#0), 
                      dt_update#buckets#0#0))); 
              (var allocop#0 := #PivotBetreeGraph.Op.AllocOp(PivotBetreeSpec.NodeFlush.newchildref(f#0), newchild#0); 
                (var writeop#0 := #PivotBetreeGraph.Op.WriteOp(PivotBetreeSpec.NodeFlush.parentref(f#0), newparent#0); 
                  Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(allocop#0)), $Box(writeop#0)))))));

// definition axiom for PivotBetreeSpec.__default.FlushOps for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.FlushOps(Lit(f#0)) } 
    PivotBetreeSpec.__default.FlushOps#canCall(Lit(f#0))
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFlush())
           && Lit(PivotBetreeSpec.__default.ValidFlush(Lit(f#0))))
       ==> PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && (var dt_update_tmp#0#1 := Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))); 
          PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
             && 
            PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#1)
             && PivotBetreeGraph.Node.Node_q(dt_update_tmp#0#1))
         && 
        PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.NodeFlush.NodeFlush_q(Lit(f#0))
         && PivotBetreeSpec.__default.FlushOps(Lit(f#0))
           == (var newparent#1 := #PivotBetreeGraph.Node.Node(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                #Options.Option.Some($Box(Seq#Update(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))))): Seq Box), 
                      LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))), 
                      $Box(LitInt(PivotBetreeSpec.NodeFlush.newchildref(Lit(f#0))))))), 
                Seq#Update(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFlush.parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFlush.slotIndex(Lit(f#0))), 
                  $Box(Lit(PivotBetreeSpec.NodeFlush.newParentBucket(Lit(f#0)))))); 
            (var newchild#1 := (var dt_update_tmp#0#1 := Lit(PivotBetreeSpec.NodeFlush.child(Lit(f#0))); 
                  (var dt_update#buckets#0#1 := Lit(PivotBetreeSpec.NodeFlush.newChildBuckets(Lit(f#0))); 
                    Lit(#PivotBetreeGraph.Node.Node(Lit(PivotBetreeGraph.Node.pivotTable(dt_update_tmp#0#1)), 
                        Lit(PivotBetreeGraph.Node.children(dt_update_tmp#0#1)), 
                        dt_update#buckets#0#1)))); 
              (var allocop#1 := #PivotBetreeGraph.Op.AllocOp(LitInt(PivotBetreeSpec.NodeFlush.newchildref(Lit(f#0))), newchild#1); 
                (var writeop#1 := #PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeSpec.NodeFlush.parentref(Lit(f#0))), newparent#1); 
                  Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(allocop#1)), $Box(writeop#1)))))));

// function declaration for PivotBetreeSpec._default.ValidGrow
function PivotBetreeSpec.__default.ValidGrow(growth#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidGrow#canCall(growth#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidGrow
axiom true
   ==> (forall growth#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidGrow(growth#0) } 
    PivotBetreeSpec.__default.ValidGrow#canCall(growth#0)
         || $Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
       ==> true);

function PivotBetreeSpec.__default.ValidGrow#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidGrow
axiom (forall growth#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidGrow#requires(growth#0) } 
  $Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
     ==> PivotBetreeSpec.__default.ValidGrow#requires(growth#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidGrow(revealed)
axiom true
   ==> (forall growth#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidGrow(growth#0) } 
    PivotBetreeSpec.__default.ValidGrow#canCall(growth#0)
         || $Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
       ==> PivotBetreeSpec.RootGrowth.RootGrowth_q(growth#0)
         && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.RootGrowth.oldroot(growth#0))
         && PivotBetreeSpec.__default.ValidGrow(growth#0)
           == PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.RootGrowth.oldroot(growth#0)));

// definition axiom for PivotBetreeSpec.__default.ValidGrow for all literals(revealed)
axiom true
   ==> (forall growth#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidGrow(Lit(growth#0)) } 
    PivotBetreeSpec.__default.ValidGrow#canCall(Lit(growth#0))
         || $Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
       ==> PivotBetreeSpec.RootGrowth.RootGrowth_q(Lit(growth#0))
         && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.RootGrowth.oldroot(Lit(growth#0))))
         && PivotBetreeSpec.__default.ValidGrow(Lit(growth#0))
           == Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.RootGrowth.oldroot(Lit(growth#0))))));

// function declaration for PivotBetreeSpec._default.GrowReads
function PivotBetreeSpec.__default.GrowReads(growth#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.GrowReads#canCall(growth#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.GrowReads
axiom true
   ==> (forall growth#0: DatatypeType :: 
    { PivotBetreeSpec.__default.GrowReads(growth#0) } 
    PivotBetreeSpec.__default.GrowReads#canCall(growth#0)
         || ($Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
           && PivotBetreeSpec.__default.ValidGrow(growth#0))
       ==> $Is(PivotBetreeSpec.__default.GrowReads(growth#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.GrowReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.GrowReads
axiom (forall growth#0: DatatypeType :: 
  { PivotBetreeSpec.__default.GrowReads#requires(growth#0) } 
  $Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
     ==> PivotBetreeSpec.__default.GrowReads#requires(growth#0)
       == PivotBetreeSpec.__default.ValidGrow(growth#0));

// definition axiom for PivotBetreeSpec.__default.GrowReads(revealed)
axiom true
   ==> (forall growth#0: DatatypeType :: 
    { PivotBetreeSpec.__default.GrowReads(growth#0) } 
    PivotBetreeSpec.__default.GrowReads#canCall(growth#0)
         || ($Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
           && PivotBetreeSpec.__default.ValidGrow(growth#0))
       ==> PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.RootGrowth.RootGrowth_q(growth#0)
         && PivotBetreeSpec.__default.GrowReads(growth#0)
           == Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeGraph.__default.Root()), 
                PivotBetreeSpec.RootGrowth.oldroot(growth#0)))));

// definition axiom for PivotBetreeSpec.__default.GrowReads for all literals(revealed)
axiom true
   ==> (forall growth#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.GrowReads(Lit(growth#0)) } 
    PivotBetreeSpec.__default.GrowReads#canCall(Lit(growth#0))
         || ($Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
           && Lit(PivotBetreeSpec.__default.ValidGrow(Lit(growth#0))))
       ==> PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.RootGrowth.RootGrowth_q(Lit(growth#0))
         && PivotBetreeSpec.__default.GrowReads(Lit(growth#0))
           == Lit(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeGraph.__default.Root()), 
                    Lit(PivotBetreeSpec.RootGrowth.oldroot(Lit(growth#0)))))))));

// function declaration for PivotBetreeSpec._default.GrowOps
function PivotBetreeSpec.__default.GrowOps(growth#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.GrowOps#canCall(growth#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.GrowOps
axiom true
   ==> (forall growth#0: DatatypeType :: 
    { PivotBetreeSpec.__default.GrowOps(growth#0) } 
    PivotBetreeSpec.__default.GrowOps#canCall(growth#0)
         || ($Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
           && PivotBetreeSpec.__default.ValidGrow(growth#0))
       ==> $Is(PivotBetreeSpec.__default.GrowOps(growth#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.GrowOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.GrowOps
axiom (forall growth#0: DatatypeType :: 
  { PivotBetreeSpec.__default.GrowOps#requires(growth#0) } 
  $Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
     ==> PivotBetreeSpec.__default.GrowOps#requires(growth#0)
       == PivotBetreeSpec.__default.ValidGrow(growth#0));

// definition axiom for PivotBetreeSpec.__default.GrowOps(revealed)
axiom true
   ==> (forall growth#0: DatatypeType :: 
    { PivotBetreeSpec.__default.GrowOps(growth#0) } 
    PivotBetreeSpec.__default.GrowOps#canCall(growth#0)
         || ($Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
           && PivotBetreeSpec.__default.ValidGrow(growth#0))
       ==> PivotBetreeSpec.RootGrowth.RootGrowth_q(growth#0)
         && BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box))
         && 
        PivotBetreeSpec.RootGrowth.RootGrowth_q(growth#0)
         && PivotBetreeSpec.RootGrowth.RootGrowth_q(growth#0)
         && PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.__default.GrowOps(growth#0)
           == (var newroot#0 := #PivotBetreeGraph.Node.Node(Lit(Seq#Empty(): Seq Box), 
                #Options.Option.Some($Box(Seq#Build(Seq#Empty(): Seq Box, $Box(PivotBetreeSpec.RootGrowth.newchildref(growth#0))))), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))))); 
            (var allocop#0 := #PivotBetreeGraph.Op.AllocOp(PivotBetreeSpec.RootGrowth.newchildref(growth#0), 
                  PivotBetreeSpec.RootGrowth.oldroot(growth#0)); 
              (var writeop#0 := #PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeGraph.__default.Root()), newroot#0); 
                Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(allocop#0)), $Box(writeop#0))))));

// definition axiom for PivotBetreeSpec.__default.GrowOps for all literals(revealed)
axiom true
   ==> (forall growth#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.GrowOps(Lit(growth#0)) } 
    PivotBetreeSpec.__default.GrowOps#canCall(Lit(growth#0))
         || ($Is(growth#0, Tclass.PivotBetreeSpec.RootGrowth())
           && Lit(PivotBetreeSpec.__default.ValidGrow(Lit(growth#0))))
       ==> PivotBetreeSpec.RootGrowth.RootGrowth_q(Lit(growth#0))
         && BucketsLib.__default.B#canCall(Lit(Map#Empty(): Map Box Box))
         && 
        PivotBetreeSpec.RootGrowth.RootGrowth_q(Lit(growth#0))
         && PivotBetreeSpec.RootGrowth.RootGrowth_q(Lit(growth#0))
         && PivotBetreeGraph.__default.Root#canCall()
         && PivotBetreeSpec.__default.GrowOps(Lit(growth#0))
           == (var newroot#1 := #PivotBetreeGraph.Node.Node(Lit(Seq#Empty(): Seq Box), 
                Lit(#Options.Option.Some($Box(Lit(Seq#Build(Seq#Empty(): Seq Box, 
                          $Box(LitInt(PivotBetreeSpec.RootGrowth.newchildref(Lit(growth#0))))))))), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(BucketsLib.__default.B(StartFuel_BucketsLib._default.B, Lit(Map#Empty(): Map Box Box))))); 
            (var allocop#1 := Lit(#PivotBetreeGraph.Op.AllocOp(LitInt(PivotBetreeSpec.RootGrowth.newchildref(Lit(growth#0))), 
                    Lit(PivotBetreeSpec.RootGrowth.oldroot(Lit(growth#0))))); 
              (var writeop#1 := #PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeGraph.__default.Root()), newroot#1); 
                Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(allocop#1)), $Box(writeop#1))))));

// function declaration for PivotBetreeSpec._default.CutoffNodeAndKeepLeft
function PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(node#0: DatatypeType, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
  { PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LS($ly), node#0, pivot#0) } 
  PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LS($ly), node#0, pivot#0)
     == PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
  { PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(AsFuelBottom($ly), node#0, pivot#0) } 
  PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)
     == PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LZ, node#0, pivot#0));

// consequence axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepLeft
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
    { PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0) } 
    PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(node#0, pivot#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
           <==> Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0))))
         && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0))
         && (Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)))
             > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), 
                PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)))): Seq Box, 
            pivot#0))
         && (forall key#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lt(key#0, pivot#0) } 
            { Map#Domain(BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                    PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)))): DatatypeType))[$Box(key#0)] } 
          $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               && Map#Domain(BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                      PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)))): DatatypeType))[$Box(key#0)]
             ==> Lexicographic__Byte__Order.__default.lt(key#0, pivot#0))
         && ISet#Subset(PivotBetreeGraph.__default.Successors(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)), 
          PivotBetreeGraph.__default.Successors(node#0))
         && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)))
           <= BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            PivotBetreeGraph.Node.buckets(node#0))
         && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0)))
           <= Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
         && $Is(PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($ly, node#0, pivot#0), 
          Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepLeft
axiom (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
  { PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#requires($ly, node#0, pivot#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
       && $Is(pivot#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#requires($ly, node#0, pivot#0)
       == PivotBetreeSpec.__default.WFNode(node#0));

const MoreFuel_BucketsLib._default.SplitBucketLeft0: LayerType;

// definition axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
    { PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LS($ly), node#0, pivot#0) } 
    PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(node#0, pivot#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && PivotsLib.__default.CutoffForLeft#canCall(PivotBetreeGraph.Node.pivotTable(node#0), pivot#0)
         && (var cLeft#0 := PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, 
              PivotBetreeGraph.Node.pivotTable(node#0), 
              pivot#0); 
          PivotBetreeGraph.Node.Node_q(node#0)
             && 
            PivotBetreeGraph.Node.Node_q(node#0)
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
               ==> PivotBetreeGraph.Node.Node_q(node#0))
             && 
            PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.SplitBucketListLeft#canCall(PivotBetreeGraph.Node.buckets(node#0), 
              PivotBetreeGraph.Node.pivotTable(node#0), 
              cLeft#0, 
              pivot#0))
         && 
        StartFuel_BucketsLib._default.SplitBucketLeft
           == $LS(MoreFuel_BucketsLib._default.SplitBucketLeft0)
         && StartFuelAssert_BucketsLib._default.SplitBucketLeft
           == $LS($LS(MoreFuel_BucketsLib._default.SplitBucketLeft0))
         && AsFuelBottom(MoreFuel_BucketsLib._default.SplitBucketLeft0)
           == MoreFuel_BucketsLib._default.SplitBucketLeft0
         && PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LS($ly), node#0, pivot#0)
           == (var cLeft#0 := PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, 
                PivotBetreeGraph.Node.pivotTable(node#0), 
                pivot#0); 
            (var leftPivots#0 := Seq#Take(PivotBetreeGraph.Node.pivotTable(node#0), cLeft#0); 
              (var leftChildren#0 := (if Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
                     then #Options.Option.Some($Box(Seq#Take($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                          cLeft#0 + 1)))
                     else #Options.Option.None()); 
                (var leftBuckets#0 := BucketsLib.__default.SplitBucketListLeft(PivotBetreeGraph.Node.buckets(node#0), 
                      PivotBetreeGraph.Node.pivotTable(node#0), 
                      cLeft#0, 
                      pivot#0); 
                  #PivotBetreeGraph.Node.Node(leftPivots#0, leftChildren#0, leftBuckets#0))))));

const MoreFuel_BucketsLib._default.SplitBucketLeft1: LayerType;

// definition axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepLeft for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LS($ly), Lit(node#0), Lit(pivot#0)) } 
    PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(Lit(node#0), Lit(pivot#0))
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && PivotsLib.__default.CutoffForLeft#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), Lit(pivot#0))
         && (var cLeft#1 := PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              Lit(pivot#0)); 
          PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && 
            PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0)))))
               ==> PivotBetreeGraph.Node.Node_q(Lit(node#0)))
             && 
            PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.SplitBucketListLeft#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              cLeft#1, 
              Lit(pivot#0)))
         && 
        StartFuel_BucketsLib._default.SplitBucketLeft
           == $LS(MoreFuel_BucketsLib._default.SplitBucketLeft1)
         && StartFuelAssert_BucketsLib._default.SplitBucketLeft
           == $LS($LS(MoreFuel_BucketsLib._default.SplitBucketLeft1))
         && AsFuelBottom(MoreFuel_BucketsLib._default.SplitBucketLeft1)
           == MoreFuel_BucketsLib._default.SplitBucketLeft1
         && PivotBetreeSpec.__default.CutoffNodeAndKeepLeft($LS($ly), Lit(node#0), Lit(pivot#0))
           == (var cLeft#1 := PivotsLib.__default.CutoffForLeft(StartFuel_PivotsLib._default.CutoffForLeft, 
                Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
                Lit(pivot#0)); 
            (var leftPivots#1 := Seq#Take(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), cLeft#1); 
              (var leftChildren#1 := (if Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))
                     then #Options.Option.Some($Box(Seq#Take(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box), 
                          cLeft#1 + 1)))
                     else #Options.Option.None()); 
                (var leftBuckets#1 := BucketsLib.__default.SplitBucketListLeft(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                      Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
                      cLeft#1, 
                      Lit(pivot#0)); 
                  #PivotBetreeGraph.Node.Node(leftPivots#1, leftChildren#1, leftBuckets#1))))));

// function declaration for PivotBetreeSpec._default.CutoffNodeAndKeepRight
function PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(node#0: DatatypeType, pivot#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
  { PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LS($ly), node#0, pivot#0) } 
  PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LS($ly), node#0, pivot#0)
     == PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
  { PivotBetreeSpec.__default.CutoffNodeAndKeepRight(AsFuelBottom($ly), node#0, pivot#0) } 
  PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)
     == PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LZ, node#0, pivot#0));

// consequence axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepRight
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
    { PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0) } 
    PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(node#0, pivot#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
           <==> Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0))))
         && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0))
         && (Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)))
             > 0
           ==> Lexicographic__Byte__Order.__default.lt(pivot#0, 
            $Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)), 
                LitInt(0))): Seq Box))
         && (forall key#0: Seq Box :: 
          { Lexicographic__Byte__Order.__default.lte(pivot#0, key#0) } 
            { Map#Domain(BucketsLib.Bucket.b($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)), 
                    0)): DatatypeType))[$Box(key#0)] } 
          $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
               && Map#Domain(BucketsLib.Bucket.b($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)), 
                      LitInt(0))): DatatypeType))[$Box(key#0)]
             ==> Lexicographic__Byte__Order.__default.lte(pivot#0, key#0))
         && ISet#Subset(PivotBetreeGraph.__default.Successors(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)), 
          PivotBetreeGraph.__default.Successors(node#0))
         && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)))
           <= BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            PivotBetreeGraph.Node.buckets(node#0))
         && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0)))
           <= Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
         && $Is(PivotBetreeSpec.__default.CutoffNodeAndKeepRight($ly, node#0, pivot#0), 
          Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.CutoffNodeAndKeepRight#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepRight
axiom (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
  { PivotBetreeSpec.__default.CutoffNodeAndKeepRight#requires($ly, node#0, pivot#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
       && $Is(pivot#0, Tclass.KeyType.Key())
     ==> PivotBetreeSpec.__default.CutoffNodeAndKeepRight#requires($ly, node#0, pivot#0)
       == PivotBetreeSpec.__default.WFNode(node#0));

const MoreFuel_BucketsLib._default.SplitBucketRight0: LayerType;

// definition axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepRight(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
    { PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LS($ly), node#0, pivot#0) } 
    PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(node#0, pivot#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> PivotBetreeGraph.Node.Node_q(node#0)
         && PivotsLib.__default.CutoffForRight#canCall(PivotBetreeGraph.Node.pivotTable(node#0), pivot#0)
         && (var cRight#0 := PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, 
              PivotBetreeGraph.Node.pivotTable(node#0), 
              pivot#0); 
          PivotBetreeGraph.Node.Node_q(node#0)
             && 
            PivotBetreeGraph.Node.Node_q(node#0)
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
               ==> PivotBetreeGraph.Node.Node_q(node#0))
             && 
            PivotBetreeGraph.Node.Node_q(node#0)
             && PivotBetreeGraph.Node.Node_q(node#0)
             && BucketsLib.__default.SplitBucketListRight#canCall(PivotBetreeGraph.Node.buckets(node#0), 
              PivotBetreeGraph.Node.pivotTable(node#0), 
              cRight#0, 
              pivot#0))
         && 
        StartFuel_BucketsLib._default.SplitBucketRight
           == $LS(MoreFuel_BucketsLib._default.SplitBucketRight0)
         && StartFuelAssert_BucketsLib._default.SplitBucketRight
           == $LS($LS(MoreFuel_BucketsLib._default.SplitBucketRight0))
         && AsFuelBottom(MoreFuel_BucketsLib._default.SplitBucketRight0)
           == MoreFuel_BucketsLib._default.SplitBucketRight0
         && PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LS($ly), node#0, pivot#0)
           == (var cRight#0 := PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, 
                PivotBetreeGraph.Node.pivotTable(node#0), 
                pivot#0); 
            (var rightPivots#0 := Seq#Drop(PivotBetreeGraph.Node.pivotTable(node#0), cRight#0); 
              (var rightChildren#0 := (if Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
                     then #Options.Option.Some($Box(Seq#Drop($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(node#0))): Seq Box, 
                          cRight#0)))
                     else #Options.Option.None()); 
                (var rightBuckets#0 := BucketsLib.__default.SplitBucketListRight(PivotBetreeGraph.Node.buckets(node#0), 
                      PivotBetreeGraph.Node.pivotTable(node#0), 
                      cRight#0, 
                      pivot#0); 
                  #PivotBetreeGraph.Node.Node(rightPivots#0, rightChildren#0, rightBuckets#0))))));

const MoreFuel_BucketsLib._default.SplitBucketRight1: LayerType;

// definition axiom for PivotBetreeSpec.__default.CutoffNodeAndKeepRight for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, node#0: DatatypeType, pivot#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LS($ly), Lit(node#0), Lit(pivot#0)) } 
    PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(Lit(node#0), Lit(pivot#0))
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(node#0))
         && PivotsLib.__default.CutoffForRight#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), Lit(pivot#0))
         && (var cRight#1 := PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              Lit(pivot#0)); 
          PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && 
            PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0)))))
               ==> PivotBetreeGraph.Node.Node_q(Lit(node#0)))
             && 
            PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && PivotBetreeGraph.Node.Node_q(Lit(node#0))
             && BucketsLib.__default.SplitBucketListRight#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
              cRight#1, 
              Lit(pivot#0)))
         && 
        StartFuel_BucketsLib._default.SplitBucketRight
           == $LS(MoreFuel_BucketsLib._default.SplitBucketRight1)
         && StartFuelAssert_BucketsLib._default.SplitBucketRight
           == $LS($LS(MoreFuel_BucketsLib._default.SplitBucketRight1))
         && AsFuelBottom(MoreFuel_BucketsLib._default.SplitBucketRight1)
           == MoreFuel_BucketsLib._default.SplitBucketRight1
         && PivotBetreeSpec.__default.CutoffNodeAndKeepRight($LS($ly), Lit(node#0), Lit(pivot#0))
           == (var cRight#1 := PivotsLib.__default.CutoffForRight(StartFuel_PivotsLib._default.CutoffForRight, 
                Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
                Lit(pivot#0)); 
            (var rightPivots#1 := Seq#Drop(Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), cRight#1); 
              (var rightChildren#1 := (if Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))
                     then #Options.Option.Some($Box(Seq#Drop(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(node#0))))): Seq Box), 
                          cRight#1)))
                     else #Options.Option.None()); 
                (var rightBuckets#1 := BucketsLib.__default.SplitBucketListRight(Lit(PivotBetreeGraph.Node.buckets(Lit(node#0))), 
                      Lit(PivotBetreeGraph.Node.pivotTable(Lit(node#0))), 
                      cRight#1, 
                      Lit(pivot#0)); 
                  #PivotBetreeGraph.Node.Node(rightPivots#1, rightChildren#1, rightBuckets#1))))));

// function declaration for PivotBetreeSpec._default.CutoffNode
function PivotBetreeSpec.__default.CutoffNode($ly: LayerType, 
    node#0: DatatypeType, 
    lpivot#0: DatatypeType, 
    rpivot#0: DatatypeType)
   : DatatypeType;

function PivotBetreeSpec.__default.CutoffNode#canCall(node#0: DatatypeType, lpivot#0: DatatypeType, rpivot#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    node#0: DatatypeType, 
    lpivot#0: DatatypeType, 
    rpivot#0: DatatypeType :: 
  { PivotBetreeSpec.__default.CutoffNode($LS($ly), node#0, lpivot#0, rpivot#0) } 
  PivotBetreeSpec.__default.CutoffNode($LS($ly), node#0, lpivot#0, rpivot#0)
     == PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    node#0: DatatypeType, 
    lpivot#0: DatatypeType, 
    rpivot#0: DatatypeType :: 
  { PivotBetreeSpec.__default.CutoffNode(AsFuelBottom($ly), node#0, lpivot#0, rpivot#0) } 
  PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)
     == PivotBetreeSpec.__default.CutoffNode($LZ, node#0, lpivot#0, rpivot#0));

// consequence axiom for PivotBetreeSpec.__default.CutoffNode
axiom true
   ==> (forall $ly: LayerType, 
      node#0: DatatypeType, 
      lpivot#0: DatatypeType, 
      rpivot#0: DatatypeType :: 
    { PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0) } 
    PivotBetreeSpec.__default.CutoffNode#canCall(node#0, lpivot#0, rpivot#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(lpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && $Is(rpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> (Options.Option.Some_q(PivotBetreeGraph.Node.children(node#0))
           <==> Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0))))
         && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0))
         && (Options.Option.Some_q(lpivot#0)
             && Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))
               > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Options.Option.value(lpivot#0)): Seq Box, 
            $Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)), 
                LitInt(0))): Seq Box))
         && (Options.Option.Some_q(rpivot#0)
             && Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))
               > 0
           ==> Lexicographic__Byte__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), 
                PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))): Seq Box, 
            $Unbox(Options.Option.value(rpivot#0)): Seq Box))
         && (Options.Option.Some_q(lpivot#0)
           ==> (forall key#0: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(lpivot#0)): Seq Box, key#0) } 
              { Map#Domain(BucketsLib.Bucket.b($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)), 
                      0)): DatatypeType))[$Box(key#0)] } 
            $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
                 && Map#Domain(BucketsLib.Bucket.b($Unbox(Seq#Index(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)), 
                        LitInt(0))): DatatypeType))[$Box(key#0)]
               ==> Lexicographic__Byte__Order.__default.lte($Unbox(Options.Option.value(lpivot#0)): Seq Box, key#0)))
         && (Options.Option.Some_q(rpivot#0)
           ==> (forall key#1: Seq Box :: 
            { Lexicographic__Byte__Order.__default.lt(key#1, $Unbox(Options.Option.value(rpivot#0)): Seq Box) } 
              { Map#Domain(BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                      PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))): DatatypeType))[$Box(key#1)] } 
            $Is(key#1, TSeq(Tclass.NativeTypes.byte()))
                 && Map#Domain(BucketsLib.Bucket.b($Unbox(Sequences.__default.Last(Tclass.BucketsLib.Bucket(), 
                        PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))): DatatypeType))[$Box(key#1)]
               ==> Lexicographic__Byte__Order.__default.lt(key#1, $Unbox(Options.Option.value(rpivot#0)): Seq Box)))
         && ISet#Subset(PivotBetreeGraph.__default.Successors(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)), 
          PivotBetreeGraph.__default.Successors(node#0))
         && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))
           <= BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
            PivotBetreeGraph.Node.buckets(node#0))
         && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0)))
           <= Seq#Length(PivotBetreeGraph.Node.buckets(node#0))
         && $Is(PivotBetreeSpec.__default.CutoffNode($ly, node#0, lpivot#0, rpivot#0), 
          Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.CutoffNode#requires(LayerType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.CutoffNode
axiom (forall $ly: LayerType, 
    node#0: DatatypeType, 
    lpivot#0: DatatypeType, 
    rpivot#0: DatatypeType :: 
  { PivotBetreeSpec.__default.CutoffNode#requires($ly, node#0, lpivot#0, rpivot#0) } 
  $Is(node#0, Tclass.PivotBetreeGraph.Node())
       && $Is(lpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
       && $Is(rpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
     ==> PivotBetreeSpec.__default.CutoffNode#requires($ly, node#0, lpivot#0, rpivot#0)
       == PivotBetreeSpec.__default.WFNode(node#0));

// definition axiom for PivotBetreeSpec.__default.CutoffNode(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      node#0: DatatypeType, 
      lpivot#0: DatatypeType, 
      rpivot#0: DatatypeType :: 
    { PivotBetreeSpec.__default.CutoffNode($LS($ly), node#0, lpivot#0, rpivot#0) } 
    PivotBetreeSpec.__default.CutoffNode#canCall(node#0, lpivot#0, rpivot#0)
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(lpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && $Is(rpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && PivotBetreeSpec.__default.WFNode(node#0))
       ==> (Options.Option.None_q(lpivot#0)
           ==> 
          !Options.Option.None_q(rpivot#0)
           ==> (var rpivot#1 := $Unbox(Options.Option.value(rpivot#0)): Seq Box; 
            PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(node#0, rpivot#1)))
         && (!Options.Option.None_q(lpivot#0)
           ==> (var lpivot#1 := $Unbox(Options.Option.value(lpivot#0)): Seq Box; 
            (Options.Option.None_q(rpivot#0)
                 ==> PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(node#0, lpivot#1))
               && (!Options.Option.None_q(rpivot#0)
                 ==> (var rpivot#2 := $Unbox(Options.Option.value(rpivot#0)): Seq Box; 
                  PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(node#0, rpivot#2)
                     && (var node1#0 := PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft, node#0, rpivot#2); 
                      PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(node1#0, lpivot#1))))))
         && PivotBetreeSpec.__default.CutoffNode($LS($ly), node#0, lpivot#0, rpivot#0)
           == (if Options.Option.None_q(lpivot#0)
             then (if Options.Option.None_q(rpivot#0)
               then node#0
               else (var rpivot#3 := $Unbox(Options.Option.value(rpivot#0)): Seq Box; 
                PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft, node#0, rpivot#3)))
             else (var lpivot#2 := $Unbox(Options.Option.value(lpivot#0)): Seq Box; 
              (if Options.Option.None_q(rpivot#0)
                 then PivotBetreeSpec.__default.CutoffNodeAndKeepRight(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight, node#0, lpivot#2)
                 else (var rpivot#4 := $Unbox(Options.Option.value(rpivot#0)): Seq Box; 
                  (var node1#1 := PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft, node#0, rpivot#4); 
                    (var node'#1 := PivotBetreeSpec.__default.CutoffNodeAndKeepRight(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight, node1#1, lpivot#2); 
                      node'#1)))))));

// definition axiom for PivotBetreeSpec.__default.CutoffNode for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      node#0: DatatypeType, 
      lpivot#0: DatatypeType, 
      rpivot#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.CutoffNode($LS($ly), Lit(node#0), Lit(lpivot#0), Lit(rpivot#0)) } 
    PivotBetreeSpec.__default.CutoffNode#canCall(Lit(node#0), Lit(lpivot#0), Lit(rpivot#0))
         || (
          $Is(node#0, Tclass.PivotBetreeGraph.Node())
           && $Is(lpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && $Is(rpivot#0, Tclass.Options.Option(Tclass.KeyType.Key()))
           && Lit(PivotBetreeSpec.__default.WFNode(Lit(node#0))))
       ==> (Lit(Options.Option.None_q(Lit(lpivot#0)))
           ==> 
          !Lit(Options.Option.None_q(Lit(rpivot#0)))
           ==> (var rpivot#5 := Lit($Unbox(Options.Option.value(Lit(rpivot#0))): Seq Box); 
            PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(Lit(node#0), rpivot#5)))
         && (!Lit(Options.Option.None_q(Lit(lpivot#0)))
           ==> (var lpivot#3 := Lit($Unbox(Options.Option.value(Lit(lpivot#0))): Seq Box); 
            (Lit(Options.Option.None_q(Lit(rpivot#0)))
                 ==> PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(Lit(node#0), lpivot#3))
               && (!Lit(Options.Option.None_q(Lit(rpivot#0)))
                 ==> (var rpivot#6 := Lit($Unbox(Options.Option.value(Lit(rpivot#0))): Seq Box); 
                  PivotBetreeSpec.__default.CutoffNodeAndKeepLeft#canCall(Lit(node#0), rpivot#6)
                     && (var node1#2 := PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft, Lit(node#0), rpivot#6); 
                      PivotBetreeSpec.__default.CutoffNodeAndKeepRight#canCall(node1#2, lpivot#3))))))
         && PivotBetreeSpec.__default.CutoffNode($LS($ly), Lit(node#0), Lit(lpivot#0), Lit(rpivot#0))
           == (if Options.Option.None_q(Lit(lpivot#0))
             then (if Options.Option.None_q(Lit(rpivot#0))
               then node#0
               else (var rpivot#7 := Lit($Unbox(Options.Option.value(Lit(rpivot#0))): Seq Box); 
                PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft, Lit(node#0), rpivot#7)))
             else (var lpivot#4 := Lit($Unbox(Options.Option.value(Lit(lpivot#0))): Seq Box); 
              (if Options.Option.None_q(Lit(rpivot#0))
                 then PivotBetreeSpec.__default.CutoffNodeAndKeepRight(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight, Lit(node#0), lpivot#4)
                 else (var rpivot#8 := Lit($Unbox(Options.Option.value(Lit(rpivot#0))): Seq Box); 
                  (var node1#3 := PivotBetreeSpec.__default.CutoffNodeAndKeepLeft(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepLeft, Lit(node#0), rpivot#8); 
                    (var node'#3 := PivotBetreeSpec.__default.CutoffNodeAndKeepRight(StartFuel_PivotBetreeSpec._default.CutoffNodeAndKeepRight, node1#3, lpivot#4); 
                      node'#3)))))));

// function declaration for PivotBetreeSpec._default.SplitChildLeft
function PivotBetreeSpec.__default.SplitChildLeft(child#0: DatatypeType, num_children_left#0: int) : DatatypeType;

function PivotBetreeSpec.__default.SplitChildLeft#canCall(child#0: DatatypeType, num_children_left#0: int) : bool;

// consequence axiom for PivotBetreeSpec.__default.SplitChildLeft
axiom true
   ==> (forall child#0: DatatypeType, num_children_left#0: int :: 
    { PivotBetreeSpec.__default.SplitChildLeft(child#0, num_children_left#0) } 
    PivotBetreeSpec.__default.SplitChildLeft#canCall(child#0, num_children_left#0)
         || ($Is(child#0, Tclass.PivotBetreeGraph.Node())
           && 
          LitInt(0) <= num_children_left#0 - 1
           && num_children_left#0 - 1 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(child#0))
           && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
             ==> LitInt(0) <= num_children_left#0
               && num_children_left#0
                 <= Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box))
           && 
          LitInt(0) <= num_children_left#0
           && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.buckets(child#0)))
       ==> $Is(PivotBetreeSpec.__default.SplitChildLeft(child#0, num_children_left#0), 
        Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.SplitChildLeft#requires(DatatypeType, int) : bool;

// #requires axiom for PivotBetreeSpec.__default.SplitChildLeft
axiom (forall child#0: DatatypeType, num_children_left#0: int :: 
  { PivotBetreeSpec.__default.SplitChildLeft#requires(child#0, num_children_left#0) } 
  $Is(child#0, Tclass.PivotBetreeGraph.Node())
     ==> PivotBetreeSpec.__default.SplitChildLeft#requires(child#0, num_children_left#0)
       == (
        LitInt(0) <= num_children_left#0 - 1
         && num_children_left#0 - 1 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(child#0))
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
           ==> LitInt(0) <= num_children_left#0
             && num_children_left#0
               <= Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box))
         && 
        LitInt(0) <= num_children_left#0
         && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.buckets(child#0))));

// definition axiom for PivotBetreeSpec.__default.SplitChildLeft(revealed)
axiom true
   ==> (forall child#0: DatatypeType, num_children_left#0: int :: 
    { PivotBetreeSpec.__default.SplitChildLeft(child#0, num_children_left#0) } 
    PivotBetreeSpec.__default.SplitChildLeft#canCall(child#0, num_children_left#0)
         || ($Is(child#0, Tclass.PivotBetreeGraph.Node())
           && 
          LitInt(0) <= num_children_left#0 - 1
           && num_children_left#0 - 1 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(child#0))
           && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
             ==> LitInt(0) <= num_children_left#0
               && num_children_left#0
                 <= Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box))
           && 
          LitInt(0) <= num_children_left#0
           && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.buckets(child#0)))
       ==> PivotBetreeGraph.Node.Node_q(child#0)
         && 
        PivotBetreeGraph.Node.Node_q(child#0)
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
           ==> PivotBetreeGraph.Node.Node_q(child#0))
         && PivotBetreeGraph.Node.Node_q(child#0)
         && PivotBetreeSpec.__default.SplitChildLeft(child#0, num_children_left#0)
           == #PivotBetreeGraph.Node.Node(Seq#Take(PivotBetreeGraph.Node.pivotTable(child#0), num_children_left#0 - 1), 
            (if Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
               then #Options.Option.Some($Box(Seq#Take($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box, 
                    num_children_left#0)))
               else #Options.Option.None()), 
            Seq#Take(PivotBetreeGraph.Node.buckets(child#0), num_children_left#0)));

// definition axiom for PivotBetreeSpec.__default.SplitChildLeft for all literals(revealed)
axiom true
   ==> (forall child#0: DatatypeType, num_children_left#0: int :: 
    {:weight 3} { PivotBetreeSpec.__default.SplitChildLeft(Lit(child#0), LitInt(num_children_left#0)) } 
    PivotBetreeSpec.__default.SplitChildLeft#canCall(Lit(child#0), LitInt(num_children_left#0))
         || ($Is(child#0, Tclass.PivotBetreeGraph.Node())
           && 
          LitInt(0) <= LitInt(num_children_left#0 - 1)
           && LitInt(num_children_left#0 - 1)
             <= Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(child#0))))
           && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))
             ==> LitInt(0) <= LitInt(num_children_left#0)
               && LitInt(num_children_left#0)
                 <= Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))): Seq Box)))
           && 
          LitInt(0) <= LitInt(num_children_left#0)
           && LitInt(num_children_left#0)
             <= Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(child#0)))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(child#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(child#0))
         && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(child#0)))))
           ==> PivotBetreeGraph.Node.Node_q(Lit(child#0)))
         && PivotBetreeGraph.Node.Node_q(Lit(child#0))
         && PivotBetreeSpec.__default.SplitChildLeft(Lit(child#0), LitInt(num_children_left#0))
           == #PivotBetreeGraph.Node.Node(Lit(Seq#Take(Lit(PivotBetreeGraph.Node.pivotTable(Lit(child#0))), 
                LitInt(num_children_left#0 - 1))), 
            (if Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))
               then #Options.Option.Some($Box(Lit(Seq#Take(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))): Seq Box), 
                      LitInt(num_children_left#0)))))
               else #Options.Option.None()), 
            Lit(Seq#Take(Lit(PivotBetreeGraph.Node.buckets(Lit(child#0))), LitInt(num_children_left#0)))));

// function declaration for PivotBetreeSpec._default.SplitChildRight
function PivotBetreeSpec.__default.SplitChildRight(child#0: DatatypeType, num_children_left#0: int) : DatatypeType;

function PivotBetreeSpec.__default.SplitChildRight#canCall(child#0: DatatypeType, num_children_left#0: int) : bool;

// consequence axiom for PivotBetreeSpec.__default.SplitChildRight
axiom true
   ==> (forall child#0: DatatypeType, num_children_left#0: int :: 
    { PivotBetreeSpec.__default.SplitChildRight(child#0, num_children_left#0) } 
    PivotBetreeSpec.__default.SplitChildRight#canCall(child#0, num_children_left#0)
         || ($Is(child#0, Tclass.PivotBetreeGraph.Node())
           && 
          LitInt(0) <= num_children_left#0
           && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(child#0))
           && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
             ==> LitInt(0) <= num_children_left#0
               && num_children_left#0
                 <= Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box))
           && 
          LitInt(0) <= num_children_left#0
           && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.buckets(child#0)))
       ==> $Is(PivotBetreeSpec.__default.SplitChildRight(child#0, num_children_left#0), 
        Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.SplitChildRight#requires(DatatypeType, int) : bool;

// #requires axiom for PivotBetreeSpec.__default.SplitChildRight
axiom (forall child#0: DatatypeType, num_children_left#0: int :: 
  { PivotBetreeSpec.__default.SplitChildRight#requires(child#0, num_children_left#0) } 
  $Is(child#0, Tclass.PivotBetreeGraph.Node())
     ==> PivotBetreeSpec.__default.SplitChildRight#requires(child#0, num_children_left#0)
       == (
        LitInt(0) <= num_children_left#0
         && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(child#0))
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
           ==> LitInt(0) <= num_children_left#0
             && num_children_left#0
               <= Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box))
         && 
        LitInt(0) <= num_children_left#0
         && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.buckets(child#0))));

// definition axiom for PivotBetreeSpec.__default.SplitChildRight(revealed)
axiom true
   ==> (forall child#0: DatatypeType, num_children_left#0: int :: 
    { PivotBetreeSpec.__default.SplitChildRight(child#0, num_children_left#0) } 
    PivotBetreeSpec.__default.SplitChildRight#canCall(child#0, num_children_left#0)
         || ($Is(child#0, Tclass.PivotBetreeGraph.Node())
           && 
          LitInt(0) <= num_children_left#0
           && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(child#0))
           && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
             ==> LitInt(0) <= num_children_left#0
               && num_children_left#0
                 <= Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box))
           && 
          LitInt(0) <= num_children_left#0
           && num_children_left#0 <= Seq#Length(PivotBetreeGraph.Node.buckets(child#0)))
       ==> PivotBetreeGraph.Node.Node_q(child#0)
         && 
        PivotBetreeGraph.Node.Node_q(child#0)
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
           ==> PivotBetreeGraph.Node.Node_q(child#0))
         && PivotBetreeGraph.Node.Node_q(child#0)
         && PivotBetreeSpec.__default.SplitChildRight(child#0, num_children_left#0)
           == #PivotBetreeGraph.Node.Node(Seq#Drop(PivotBetreeGraph.Node.pivotTable(child#0), num_children_left#0), 
            (if Options.Option.Some_q(PivotBetreeGraph.Node.children(child#0))
               then #Options.Option.Some($Box(Seq#Drop($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(child#0))): Seq Box, 
                    num_children_left#0)))
               else #Options.Option.None()), 
            Seq#Drop(PivotBetreeGraph.Node.buckets(child#0), num_children_left#0)));

// definition axiom for PivotBetreeSpec.__default.SplitChildRight for all literals(revealed)
axiom true
   ==> (forall child#0: DatatypeType, num_children_left#0: int :: 
    {:weight 3} { PivotBetreeSpec.__default.SplitChildRight(Lit(child#0), LitInt(num_children_left#0)) } 
    PivotBetreeSpec.__default.SplitChildRight#canCall(Lit(child#0), LitInt(num_children_left#0))
         || ($Is(child#0, Tclass.PivotBetreeGraph.Node())
           && 
          LitInt(0) <= LitInt(num_children_left#0)
           && LitInt(num_children_left#0)
             <= Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(child#0))))
           && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))
             ==> LitInt(0) <= LitInt(num_children_left#0)
               && LitInt(num_children_left#0)
                 <= Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))): Seq Box)))
           && 
          LitInt(0) <= LitInt(num_children_left#0)
           && LitInt(num_children_left#0)
             <= Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(child#0)))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(child#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(child#0))
         && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(child#0)))))
           ==> PivotBetreeGraph.Node.Node_q(Lit(child#0)))
         && PivotBetreeGraph.Node.Node_q(Lit(child#0))
         && PivotBetreeSpec.__default.SplitChildRight(Lit(child#0), LitInt(num_children_left#0))
           == #PivotBetreeGraph.Node.Node(Lit(Seq#Drop(Lit(PivotBetreeGraph.Node.pivotTable(Lit(child#0))), LitInt(num_children_left#0))), 
            (if Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))
               then #Options.Option.Some($Box(Lit(Seq#Drop(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(child#0))))): Seq Box), 
                      LitInt(num_children_left#0)))))
               else #Options.Option.None()), 
            Lit(Seq#Drop(Lit(PivotBetreeGraph.Node.buckets(Lit(child#0))), LitInt(num_children_left#0)))));

// function declaration for PivotBetreeSpec._default.SplitParent
function PivotBetreeSpec.__default.SplitParent(fused_parent#0: DatatypeType, 
    pivot#0: Seq Box, 
    slot_idx#0: int, 
    left_childref#0: int, 
    right_childref#0: int)
   : DatatypeType;

function PivotBetreeSpec.__default.SplitParent#canCall(fused_parent#0: DatatypeType, 
    pivot#0: Seq Box, 
    slot_idx#0: int, 
    left_childref#0: int, 
    right_childref#0: int)
   : bool;

// consequence axiom for PivotBetreeSpec.__default.SplitParent
axiom true
   ==> (forall fused_parent#0: DatatypeType, 
      pivot#0: Seq Box, 
      slot_idx#0: int, 
      left_childref#0: int, 
      right_childref#0: int :: 
    { PivotBetreeSpec.__default.SplitParent(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0) } 
    PivotBetreeSpec.__default.SplitParent#canCall(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0)
         || (
          $Is(fused_parent#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= left_childref#0
           && left_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= right_childref#0
           && right_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= slot_idx#0
           && slot_idx#0 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(fused_parent#0))
           && Options.Option.Some_q(PivotBetreeGraph.Node.children(fused_parent#0))
           && (Options.Option.Some_q(PivotBetreeGraph.Node.children(fused_parent#0))
             ==> LitInt(0) <= slot_idx#0
               && slot_idx#0
                 < Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(fused_parent#0))): Seq Box))
           && 
          LitInt(0) <= slot_idx#0
           && slot_idx#0 < Seq#Length(PivotBetreeGraph.Node.buckets(fused_parent#0)))
       ==> $Is(PivotBetreeSpec.__default.SplitParent(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0), 
        Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.SplitParent#requires(DatatypeType, Seq Box, int, int, int) : bool;

// #requires axiom for PivotBetreeSpec.__default.SplitParent
axiom (forall fused_parent#0: DatatypeType, 
    pivot#0: Seq Box, 
    slot_idx#0: int, 
    left_childref#0: int, 
    right_childref#0: int :: 
  { PivotBetreeSpec.__default.SplitParent#requires(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0) } 
  $Is(fused_parent#0, Tclass.PivotBetreeGraph.Node())
       && $Is(pivot#0, Tclass.KeyType.Key())
       && 
      LitInt(0) <= left_childref#0
       && left_childref#0 < 18446744073709551616
       && 
      LitInt(0) <= right_childref#0
       && right_childref#0 < 18446744073709551616
     ==> PivotBetreeSpec.__default.SplitParent#requires(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0)
       == (
        LitInt(0) <= slot_idx#0
         && slot_idx#0 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(fused_parent#0))
         && Options.Option.Some_q(PivotBetreeGraph.Node.children(fused_parent#0))
         && (Options.Option.Some_q(PivotBetreeGraph.Node.children(fused_parent#0))
           ==> LitInt(0) <= slot_idx#0
             && slot_idx#0
               < Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(fused_parent#0))): Seq Box))
         && 
        LitInt(0) <= slot_idx#0
         && slot_idx#0 < Seq#Length(PivotBetreeGraph.Node.buckets(fused_parent#0))));

// definition axiom for PivotBetreeSpec.__default.SplitParent(revealed)
axiom true
   ==> (forall fused_parent#0: DatatypeType, 
      pivot#0: Seq Box, 
      slot_idx#0: int, 
      left_childref#0: int, 
      right_childref#0: int :: 
    { PivotBetreeSpec.__default.SplitParent(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0) } 
    PivotBetreeSpec.__default.SplitParent#canCall(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0)
         || (
          $Is(fused_parent#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= left_childref#0
           && left_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= right_childref#0
           && right_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= slot_idx#0
           && slot_idx#0 <= Seq#Length(PivotBetreeGraph.Node.pivotTable(fused_parent#0))
           && Options.Option.Some_q(PivotBetreeGraph.Node.children(fused_parent#0))
           && (Options.Option.Some_q(PivotBetreeGraph.Node.children(fused_parent#0))
             ==> LitInt(0) <= slot_idx#0
               && slot_idx#0
                 < Seq#Length($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(fused_parent#0))): Seq Box))
           && 
          LitInt(0) <= slot_idx#0
           && slot_idx#0 < Seq#Length(PivotBetreeGraph.Node.buckets(fused_parent#0)))
       ==> PivotBetreeGraph.Node.Node_q(fused_parent#0)
         && Sequences.__default.insert#canCall(Tclass.KeyType.Key(), 
          PivotBetreeGraph.Node.pivotTable(fused_parent#0), 
          $Box(pivot#0), 
          slot_idx#0)
         && 
        PivotBetreeGraph.Node.Node_q(fused_parent#0)
         && Sequences.__default.replace1with2#canCall(Tclass.NativeTypes.uint64(), 
          $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(fused_parent#0))): Seq Box, 
          $Box(left_childref#0), 
          $Box(right_childref#0), 
          slot_idx#0)
         && 
        PivotBetreeGraph.Node.Node_q(fused_parent#0)
         && BucketsLib.__default.SplitBucketInList#canCall(PivotBetreeGraph.Node.buckets(fused_parent#0), slot_idx#0, pivot#0)
         && PivotBetreeSpec.__default.SplitParent(fused_parent#0, pivot#0, slot_idx#0, left_childref#0, right_childref#0)
           == #PivotBetreeGraph.Node.Node(Sequences.__default.insert(Tclass.KeyType.Key(), 
              StartFuel_Sequences._default.insert, 
              PivotBetreeGraph.Node.pivotTable(fused_parent#0), 
              $Box(pivot#0), 
              slot_idx#0), 
            #Options.Option.Some($Box(Sequences.__default.replace1with2(Tclass.NativeTypes.uint64(), 
                  StartFuel_Sequences._default.replace1with2, 
                  $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(fused_parent#0))): Seq Box, 
                  $Box(left_childref#0), 
                  $Box(right_childref#0), 
                  slot_idx#0))), 
            BucketsLib.__default.SplitBucketInList(StartFuel_BucketsLib._default.SplitBucketInList, 
              PivotBetreeGraph.Node.buckets(fused_parent#0), 
              slot_idx#0, 
              pivot#0)));

// definition axiom for PivotBetreeSpec.__default.SplitParent for decreasing-related literals(revealed)
axiom true
   ==> (forall fused_parent#0: DatatypeType, 
      pivot#0: Seq Box, 
      slot_idx#0: int, 
      left_childref#0: int, 
      right_childref#0: int :: 
    {:weight 3} { PivotBetreeSpec.__default.SplitParent(Lit(fused_parent#0), 
        Lit(pivot#0), 
        LitInt(slot_idx#0), 
        left_childref#0, 
        right_childref#0) } 
    PivotBetreeSpec.__default.SplitParent#canCall(Lit(fused_parent#0), 
          Lit(pivot#0), 
          LitInt(slot_idx#0), 
          left_childref#0, 
          right_childref#0)
         || (
          $Is(fused_parent#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= left_childref#0
           && left_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= right_childref#0
           && right_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(slot_idx#0)
           && LitInt(slot_idx#0)
             <= Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(fused_parent#0))))
           && Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0)))))
           && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))
             ==> LitInt(0) <= LitInt(slot_idx#0)
               && slot_idx#0
                 < Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))): Seq Box)))
           && 
          LitInt(0) <= LitInt(slot_idx#0)
           && slot_idx#0 < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(fused_parent#0)))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(fused_parent#0))
         && Sequences.__default.insert#canCall(Tclass.KeyType.Key(), 
          Lit(PivotBetreeGraph.Node.pivotTable(Lit(fused_parent#0))), 
          $Box(Lit(pivot#0)), 
          LitInt(slot_idx#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(fused_parent#0))
         && Sequences.__default.replace1with2#canCall(Tclass.NativeTypes.uint64(), 
          Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))): Seq Box), 
          $Box(left_childref#0), 
          $Box(right_childref#0), 
          LitInt(slot_idx#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(fused_parent#0))
         && BucketsLib.__default.SplitBucketInList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(fused_parent#0))), 
          LitInt(slot_idx#0), 
          Lit(pivot#0))
         && PivotBetreeSpec.__default.SplitParent(Lit(fused_parent#0), 
            Lit(pivot#0), 
            LitInt(slot_idx#0), 
            left_childref#0, 
            right_childref#0)
           == #PivotBetreeGraph.Node.Node(Sequences.__default.insert(Tclass.KeyType.Key(), 
              StartFuel_Sequences._default.insert, 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(fused_parent#0))), 
              $Box(Lit(pivot#0)), 
              LitInt(slot_idx#0)), 
            #Options.Option.Some($Box(Sequences.__default.replace1with2(Tclass.NativeTypes.uint64(), 
                  StartFuel_Sequences._default.replace1with2, 
                  Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))): Seq Box), 
                  $Box(left_childref#0), 
                  $Box(right_childref#0), 
                  LitInt(slot_idx#0)))), 
            BucketsLib.__default.SplitBucketInList(StartFuel_BucketsLib._default.SplitBucketInList, 
              Lit(PivotBetreeGraph.Node.buckets(Lit(fused_parent#0))), 
              LitInt(slot_idx#0), 
              Lit(pivot#0))));

// definition axiom for PivotBetreeSpec.__default.SplitParent for all literals(revealed)
axiom true
   ==> (forall fused_parent#0: DatatypeType, 
      pivot#0: Seq Box, 
      slot_idx#0: int, 
      left_childref#0: int, 
      right_childref#0: int :: 
    {:weight 3} { PivotBetreeSpec.__default.SplitParent(Lit(fused_parent#0), 
        Lit(pivot#0), 
        LitInt(slot_idx#0), 
        LitInt(left_childref#0), 
        LitInt(right_childref#0)) } 
    PivotBetreeSpec.__default.SplitParent#canCall(Lit(fused_parent#0), 
          Lit(pivot#0), 
          LitInt(slot_idx#0), 
          LitInt(left_childref#0), 
          LitInt(right_childref#0))
         || (
          $Is(fused_parent#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivot#0, Tclass.KeyType.Key())
           && 
          LitInt(0) <= left_childref#0
           && left_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= right_childref#0
           && right_childref#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(slot_idx#0)
           && LitInt(slot_idx#0)
             <= Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(fused_parent#0))))
           && Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0)))))
           && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))
             ==> LitInt(0) <= LitInt(slot_idx#0)
               && slot_idx#0
                 < Seq#Length(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))): Seq Box)))
           && 
          LitInt(0) <= LitInt(slot_idx#0)
           && slot_idx#0 < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(fused_parent#0)))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(fused_parent#0))
         && Sequences.__default.insert#canCall(Tclass.KeyType.Key(), 
          Lit(PivotBetreeGraph.Node.pivotTable(Lit(fused_parent#0))), 
          $Box(Lit(pivot#0)), 
          LitInt(slot_idx#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(fused_parent#0))
         && Sequences.__default.replace1with2#canCall(Tclass.NativeTypes.uint64(), 
          Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))): Seq Box), 
          $Box(LitInt(left_childref#0)), 
          $Box(LitInt(right_childref#0)), 
          LitInt(slot_idx#0))
         && 
        PivotBetreeGraph.Node.Node_q(Lit(fused_parent#0))
         && BucketsLib.__default.SplitBucketInList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(fused_parent#0))), 
          LitInt(slot_idx#0), 
          Lit(pivot#0))
         && PivotBetreeSpec.__default.SplitParent(Lit(fused_parent#0), 
            Lit(pivot#0), 
            LitInt(slot_idx#0), 
            LitInt(left_childref#0), 
            LitInt(right_childref#0))
           == #PivotBetreeGraph.Node.Node(Sequences.__default.insert(Tclass.KeyType.Key(), 
              StartFuel_Sequences._default.insert, 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(fused_parent#0))), 
              $Box(Lit(pivot#0)), 
              LitInt(slot_idx#0)), 
            #Options.Option.Some($Box(Sequences.__default.replace1with2(Tclass.NativeTypes.uint64(), 
                  StartFuel_Sequences._default.replace1with2, 
                  Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(fused_parent#0))))): Seq Box), 
                  $Box(LitInt(left_childref#0)), 
                  $Box(LitInt(right_childref#0)), 
                  LitInt(slot_idx#0)))), 
            BucketsLib.__default.SplitBucketInList(StartFuel_BucketsLib._default.SplitBucketInList, 
              Lit(PivotBetreeGraph.Node.buckets(Lit(fused_parent#0))), 
              LitInt(slot_idx#0), 
              Lit(pivot#0))));

// function declaration for PivotBetreeSpec._default.ValidSplit
function PivotBetreeSpec.__default.ValidSplit(f#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidSplit#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidSplit
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidSplit(f#0) } 
    PivotBetreeSpec.__default.ValidSplit#canCall(f#0)
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
       ==> true);

function PivotBetreeSpec.__default.ValidSplit#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidSplit
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidSplit#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.__default.ValidSplit#requires(f#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidSplit(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidSplit(f#0) } 
    PivotBetreeSpec.__default.ValidSplit#canCall(f#0)
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
         && (PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.fused__child(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.fused__child(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.fused__child(f#0))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
             && Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
             && 
            LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
             && PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               < Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
             && Bounds.__default.MaxNumChildren#canCall())
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
             && Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
               <= LitInt(Bounds.__default.MaxNumChildren() - 1)
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (PivotBetreeSpec.NodeFusion.slot__idx(f#0) > 0
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
             && (var lbound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0) > 0
                   then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                      PivotBetreeSpec.NodeFusion.slot__idx(f#0) - 1))
                   else #Options.Option.None()); 
              Lit(true)
                 ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                   && 
                  PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                   && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                   && (PivotBetreeSpec.NodeFusion.slot__idx(f#0)
                       < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
                     ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                       && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                       && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
                   && (var ubound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0)
                           < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
                         then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                            PivotBetreeSpec.NodeFusion.slot__idx(f#0)))
                         else #Options.Option.None()); 
                    Lit(true)
                       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                         && PivotBetreeSpec.__default.CutoffNode#canCall(PivotBetreeSpec.NodeFusion.fused__child(f#0), lbound#0, ubound#0)
                         && (var child#0 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                              PivotBetreeSpec.NodeFusion.fused__child(f#0), 
                              lbound#0, 
                              ubound#0); 
                          PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                             && (LitInt(1) <= PivotBetreeSpec.NodeFusion.num__children__left(f#0)
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeGraph.Node.Node_q(child#0))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeGraph.Node.Node_q(child#0)
                                 && PivotBetreeSpec.NodeFusion.num__children__left(f#0)
                                   < Seq#Length(PivotBetreeGraph.Node.buckets(child#0))
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))): Seq Box, 
                                      PivotBetreeSpec.NodeFusion.slot__idx(f#0))): int
                                   == PivotBetreeSpec.NodeFusion.fused__childref(f#0)
                               ==> PivotBetreeGraph.Node.Node_q(child#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
                             && (PivotBetreeGraph.Node.Node_q(child#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && Seq#Equal($Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(child#0), 
                                      PivotBetreeSpec.NodeFusion.num__children__left(f#0) - 1)): Seq Box, 
                                  PivotBetreeSpec.NodeFusion.pivot(f#0))
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                                  PivotBetreeSpec.NodeFusion.pivot(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotsLib.__default.Route#canCall(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                                  PivotBetreeSpec.NodeFusion.pivot(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                                    PivotBetreeSpec.NodeFusion.pivot(f#0))
                                   == PivotBetreeSpec.NodeFusion.slot__idx(f#0)
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                                     == PivotBetreeSpec.NodeFusion.right__childref(f#0)
                                   ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.left__child(f#0))
                                     && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.right__child(f#0))
                                     && 
                                    PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                     && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                                     == PivotBetreeSpec.NodeFusion.right__childref(f#0)
                                   ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.left__child(f#0))
                                     && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.right__child(f#0))
                                     && 
                                    PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                     && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
                                 && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                                     == PivotBetreeSpec.NodeFusion.right__childref(f#0)
                                   ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                                    PivotBetreeSpec.NodeFusion.right__child(f#0)))
                               ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.split__parent(f#0))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitParent(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
                                    PivotBetreeSpec.NodeFusion.pivot(f#0), 
                                    PivotBetreeSpec.NodeFusion.slot__idx(f#0), 
                                    PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                                    PivotBetreeSpec.NodeFusion.right__childref(f#0)))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.__default.SplitParent#canCall(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
                                  PivotBetreeSpec.NodeFusion.pivot(f#0), 
                                  PivotBetreeSpec.NodeFusion.slot__idx(f#0), 
                                  PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                                  PivotBetreeSpec.NodeFusion.right__childref(f#0)))
                             && ($IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.split__parent(f#0))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitParent(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
                                    PivotBetreeSpec.NodeFusion.pivot(f#0), 
                                    PivotBetreeSpec.NodeFusion.slot__idx(f#0), 
                                    PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                                    PivotBetreeSpec.NodeFusion.right__childref(f#0)))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.__default.SplitParent#canCall(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
                                  PivotBetreeSpec.NodeFusion.pivot(f#0), 
                                  PivotBetreeSpec.NodeFusion.slot__idx(f#0), 
                                  PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                                  PivotBetreeSpec.NodeFusion.right__childref(f#0))
                                 && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.split__parent(f#0), 
                                  PivotBetreeSpec.__default.SplitParent(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
                                    PivotBetreeSpec.NodeFusion.pivot(f#0), 
                                    PivotBetreeSpec.NodeFusion.slot__idx(f#0), 
                                    PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                                    PivotBetreeSpec.NodeFusion.right__childref(f#0)))
                               ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.left__child(f#0))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitChildLeft(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.__default.SplitChildLeft#canCall(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))
                             && ($IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.left__child(f#0))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitChildLeft(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.__default.SplitChildLeft#canCall(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0))
                                 && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                                  PivotBetreeSpec.__default.SplitChildLeft(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))
                               ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.right__child(f#0))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitChildRight(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                 && PivotBetreeSpec.__default.SplitChildRight#canCall(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))))))
         && PivotBetreeSpec.__default.ValidSplit(f#0)
           == (
            PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.fused__child(f#0))
             && Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
             && 
            LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
             && PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               < Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
             && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
               <= LitInt(Bounds.__default.MaxNumChildren() - 1)
             && (var lbound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0) > 0
                   then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                      PivotBetreeSpec.NodeFusion.slot__idx(f#0) - 1))
                   else #Options.Option.None()); 
              true
                 && (var ubound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0)
                         < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))
                       then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                          PivotBetreeSpec.NodeFusion.slot__idx(f#0)))
                       else #Options.Option.None()); 
                  true
                     && (var child#0 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                          PivotBetreeSpec.NodeFusion.fused__child(f#0), 
                          lbound#0, 
                          ubound#0); 
                      LitInt(1) <= PivotBetreeSpec.NodeFusion.num__children__left(f#0)
                         && PivotBetreeSpec.NodeFusion.num__children__left(f#0)
                           < Seq#Length(PivotBetreeGraph.Node.buckets(child#0))
                         && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.fused__parent(f#0)))): Seq Box, 
                              PivotBetreeSpec.NodeFusion.slot__idx(f#0))): int
                           == PivotBetreeSpec.NodeFusion.fused__childref(f#0)
                         && Seq#Equal($Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(child#0), 
                              PivotBetreeSpec.NodeFusion.num__children__left(f#0) - 1)): Seq Box, 
                          PivotBetreeSpec.NodeFusion.pivot(f#0))
                         && PivotsLib.__default.Route(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.fused__parent(f#0)), 
                            PivotBetreeSpec.NodeFusion.pivot(f#0))
                           == PivotBetreeSpec.NodeFusion.slot__idx(f#0)
                         && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                             == PivotBetreeSpec.NodeFusion.right__childref(f#0)
                           ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                            PivotBetreeSpec.NodeFusion.right__child(f#0)))
                         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.split__parent(f#0), 
                          PivotBetreeSpec.__default.SplitParent(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
                            PivotBetreeSpec.NodeFusion.pivot(f#0), 
                            PivotBetreeSpec.NodeFusion.slot__idx(f#0), 
                            PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                            PivotBetreeSpec.NodeFusion.right__childref(f#0)))
                         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                          PivotBetreeSpec.__default.SplitChildLeft(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0)))
                         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.right__child(f#0), 
                          PivotBetreeSpec.__default.SplitChildRight(child#0, PivotBetreeSpec.NodeFusion.num__children__left(f#0))))))));

// definition axiom for PivotBetreeSpec.__default.ValidSplit for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidSplit(Lit(f#0)) } 
    PivotBetreeSpec.__default.ValidSplit#canCall(Lit(f#0))
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
         && (Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))))
             && Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
             && Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)))))
             && 
            LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
             && PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
               < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
             && Bounds.__default.MaxNumChildren#canCall())
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
             && Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
               <= LitInt(Bounds.__default.MaxNumChildren() - 1)
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (Lit(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) > 0)
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
             && (var lbound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) > 0
                   then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) - 1)))
                   else #Options.Option.None()); 
              Lit(true)
                 ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                   && 
                  PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                   && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                   && (PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
                       < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
                     ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                       && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                       && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
                   && (var ubound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
                           < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
                         then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                            LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))))
                         else #Options.Option.None()); 
                    Lit(true)
                       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                         && PivotBetreeSpec.__default.CutoffNode#canCall(Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))), lbound#1, ubound#1)
                         && (var child#1 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                              Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))), 
                              lbound#1, 
                              ubound#1); 
                          PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                             && (LitInt(1) <= LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeGraph.Node.Node_q(child#1))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeGraph.Node.Node_q(child#1)
                                 && PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0))
                                   < Seq#Length(PivotBetreeGraph.Node.buckets(child#1))
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))): Seq Box), 
                                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))): int
                                   == LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0)))
                               ==> PivotBetreeGraph.Node.Node_q(child#1)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
                             && (PivotBetreeGraph.Node.Node_q(child#1)
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && Seq#Equal($Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(child#1), 
                                      LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)) - 1))): Seq Box, 
                                  PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotsLib.__default.Route#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                                  Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotsLib.__default.Route#canCall(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                                  Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && LitInt(PivotsLib.__default.Route(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                                      Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))))
                                   == LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
                               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                                     == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
                                   ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
                                     && $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                                     && 
                                    PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                     && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))))
                             && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                                     == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
                                   ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
                                     && $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                                     && 
                                    PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                     && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
                                 && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                                     == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
                                   ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)), 
                                    PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                               ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
                                 && $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.__default.SplitParent(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))), 
                                      Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))), 
                                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))), 
                                      LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                                      LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0))))))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.__default.SplitParent#canCall(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))), 
                                  Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))), 
                                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))), 
                                  LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                                  LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))))
                             && ($IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
                                 && $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.__default.SplitParent(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))), 
                                      Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))), 
                                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))), 
                                      LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                                      LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0))))))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.__default.SplitParent#canCall(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))), 
                                  Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))), 
                                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))), 
                                  LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                                  LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0))))
                                 && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)), 
                                  PivotBetreeSpec.__default.SplitParent(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))), 
                                    Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))), 
                                    LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))), 
                                    LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                                    LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))))
                               ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitChildLeft(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.__default.SplitChildLeft#canCall(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))
                             && ($IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitChildLeft(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.__default.SplitChildLeft#canCall(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0))))
                                 && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)), 
                                  PivotBetreeSpec.__default.SplitChildLeft(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))
                               ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.__default.SplitChildRight(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && 
                                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                 && PivotBetreeSpec.__default.SplitChildRight#canCall(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))))))
         && PivotBetreeSpec.__default.ValidSplit(Lit(f#0))
           == (
            PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
             && PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))))
             && Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
             && 
            LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
             && PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
               < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
             && Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
               <= LitInt(Bounds.__default.MaxNumChildren() - 1)
             && (var lbound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) > 0
                   then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) - 1)))
                   else #Options.Option.None()); 
              true
                 && (var ubound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
                         < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))
                       then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                          LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))))
                       else #Options.Option.None()); 
                  true
                     && (var child#1 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                          Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))), 
                          lbound#1, 
                          ubound#1); 
                      LitInt(1) <= LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))
                         && PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0))
                           < Seq#Length(PivotBetreeGraph.Node.buckets(child#1))
                         && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))): Seq Box), 
                              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))): int
                           == LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0)))
                         && Seq#Equal($Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(child#1), 
                              LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)) - 1))): Seq Box, 
                          PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))
                         && LitInt(PivotsLib.__default.Route(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))), 
                              Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))))
                           == LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
                         && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                             == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
                           ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)), 
                            PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)), 
                          PivotBetreeSpec.__default.SplitParent(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))), 
                            Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))), 
                            LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))), 
                            LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                            LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))))
                         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)), 
                          PivotBetreeSpec.__default.SplitChildLeft(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))))
                         && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)), 
                          PivotBetreeSpec.__default.SplitChildRight(child#1, LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0))))))))));

// function declaration for PivotBetreeSpec._default.SplitReads
function PivotBetreeSpec.__default.SplitReads(f#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.SplitReads#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.SplitReads
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SplitReads(f#0) } 
    PivotBetreeSpec.__default.SplitReads#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidSplit(f#0))
       ==> $Is(PivotBetreeSpec.__default.SplitReads(f#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.SplitReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.SplitReads
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.SplitReads#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.__default.SplitReads#requires(f#0)
       == PivotBetreeSpec.__default.ValidSplit(f#0));

// definition axiom for PivotBetreeSpec.__default.SplitReads(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SplitReads(f#0) } 
    PivotBetreeSpec.__default.SplitReads#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidSplit(f#0))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.__default.SplitReads(f#0)
           == Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFusion.parentref(f#0), 
                  PivotBetreeSpec.NodeFusion.fused__parent(f#0)))), 
            $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFusion.fused__childref(f#0), 
                PivotBetreeSpec.NodeFusion.fused__child(f#0)))));

// definition axiom for PivotBetreeSpec.__default.SplitReads for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.SplitReads(Lit(f#0)) } 
    PivotBetreeSpec.__default.SplitReads#canCall(Lit(f#0))
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && Lit(PivotBetreeSpec.__default.ValidSplit(Lit(f#0))))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.__default.SplitReads(Lit(f#0))
           == Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFusion.parentref(Lit(f#0))), 
                      Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))))), 
              $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0))), 
                    Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0)))))))));

// function declaration for PivotBetreeSpec._default.SplitOps
function PivotBetreeSpec.__default.SplitOps(f#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.SplitOps#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.SplitOps
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SplitOps(f#0) } 
    PivotBetreeSpec.__default.SplitOps#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidSplit(f#0))
       ==> $Is(PivotBetreeSpec.__default.SplitOps(f#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.SplitOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.SplitOps
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.SplitOps#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.__default.SplitOps#requires(f#0)
       == PivotBetreeSpec.__default.ValidSplit(f#0));

// definition axiom for PivotBetreeSpec.__default.SplitOps(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.SplitOps(f#0) } 
    PivotBetreeSpec.__default.SplitOps#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidSplit(f#0))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.__default.SplitOps(f#0)
           == Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#PivotBetreeGraph.Op.AllocOp(PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                    PivotBetreeSpec.NodeFusion.left__child(f#0)))), 
              $Box(#PivotBetreeGraph.Op.AllocOp(PivotBetreeSpec.NodeFusion.right__childref(f#0), 
                  PivotBetreeSpec.NodeFusion.right__child(f#0)))), 
            $Box(#PivotBetreeGraph.Op.WriteOp(PivotBetreeSpec.NodeFusion.parentref(f#0), 
                PivotBetreeSpec.NodeFusion.split__parent(f#0)))));

// definition axiom for PivotBetreeSpec.__default.SplitOps for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.SplitOps(Lit(f#0)) } 
    PivotBetreeSpec.__default.SplitOps#canCall(Lit(f#0))
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && Lit(PivotBetreeSpec.__default.ValidSplit(Lit(f#0))))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.__default.SplitOps(Lit(f#0))
           == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(Lit(#PivotBetreeGraph.Op.AllocOp(LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                        Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))), 
                $Box(Lit(#PivotBetreeGraph.Op.AllocOp(LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0))), 
                      Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))), 
              $Box(Lit(#PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeSpec.NodeFusion.parentref(Lit(f#0))), 
                    Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)))))))));

// function declaration for PivotBetreeSpec._default.ValidMerge
function PivotBetreeSpec.__default.ValidMerge(f#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidMerge#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidMerge
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidMerge(f#0) } 
    PivotBetreeSpec.__default.ValidMerge#canCall(f#0)
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
       ==> true);

function PivotBetreeSpec.__default.ValidMerge#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidMerge
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidMerge#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.__default.ValidMerge#requires(f#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidMerge(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidMerge(f#0) } 
    PivotBetreeSpec.__default.ValidMerge#canCall(f#0)
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.split__parent(f#0))
         && (PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.split__parent(f#0))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.left__child(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.left__child(f#0))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.right__child(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.NodeFusion.right__child(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.right__child(f#0))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
             && 
            LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
             && PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               < Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
                 - 1
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && PivotBetreeSpec.NodeFusion.num__children__left(f#0)
               == Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && Seq#Equal($Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0))): Seq Box, 
              PivotBetreeSpec.NodeFusion.pivot(f#0))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0))): int
               == PivotBetreeSpec.NodeFusion.left__childref(f#0)
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1)): int
               == PivotBetreeSpec.NodeFusion.right__childref(f#0)
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0))
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.right__child(f#0)))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0))
             && BucketWeights.__default.WeightBucketList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.right__child(f#0)))
             && Bounds.__default.MaxTotalBucketWeight#canCall()
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.right__child(f#0)))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0))
             && Bounds.__default.MaxNumChildren#canCall())
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0))
             && Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
                 + Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.right__child(f#0)))
               <= LitInt(Bounds.__default.MaxNumChildren())
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                 == PivotBetreeSpec.NodeFusion.right__childref(f#0)
               ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.left__child(f#0))
                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.right__child(f#0))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                 == PivotBetreeSpec.NodeFusion.right__childref(f#0)
               ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.left__child(f#0))
                 && $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.right__child(f#0))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
             && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                 == PivotBetreeSpec.NodeFusion.right__childref(f#0)
               ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                PivotBetreeSpec.NodeFusion.right__child(f#0)))
           ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && Sequences.__default.remove#canCall(Tclass.KeyType.Key(), 
              PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
              PivotBetreeSpec.NodeFusion.slot__idx(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && Sequences.__default.replace2with1#canCall(Tclass.NativeTypes.uint64(), 
              $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
              $Box(PivotBetreeSpec.NodeFusion.fused__childref(f#0)), 
              PivotBetreeSpec.NodeFusion.slot__idx(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && BucketsLib.__default.MergeBucketsInList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
              PivotBetreeSpec.NodeFusion.slot__idx(f#0)))
         && ($IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.fused__parent(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && Sequences.__default.remove#canCall(Tclass.KeyType.Key(), 
              PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
              PivotBetreeSpec.NodeFusion.slot__idx(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && Sequences.__default.replace2with1#canCall(Tclass.NativeTypes.uint64(), 
              $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
              $Box(PivotBetreeSpec.NodeFusion.fused__childref(f#0)), 
              PivotBetreeSpec.NodeFusion.slot__idx(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && BucketsLib.__default.MergeBucketsInList#canCall(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
              PivotBetreeSpec.NodeFusion.slot__idx(f#0))
             && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
              #PivotBetreeGraph.Node.Node(Sequences.__default.remove(Tclass.KeyType.Key(), 
                  StartFuel_Sequences._default.remove, 
                  PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0)), 
                #Options.Option.Some($Box(Sequences.__default.replace2with1(Tclass.NativeTypes.uint64(), 
                      StartFuel_Sequences._default.replace2with1, 
                      $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
                      $Box(PivotBetreeSpec.NodeFusion.fused__childref(f#0)), 
                      PivotBetreeSpec.NodeFusion.slot__idx(f#0)))), 
                BucketsLib.__default.MergeBucketsInList(StartFuel_BucketsLib._default.MergeBucketsInList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0)))
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.right__child(f#0))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && (Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && (Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.right__child(f#0)))
             && (Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.right__child(f#0))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
             && (PivotBetreeSpec.NodeFusion.slot__idx(f#0) > 0
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                 && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
             && (var lbound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0) > 0
                   then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                      PivotBetreeSpec.NodeFusion.slot__idx(f#0) - 1))
                   else #Options.Option.None()); 
              Lit(true)
                 ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                   && 
                  PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                   && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
                   && (PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1
                       < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
                     ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                       && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.NodeFusion.split__parent(f#0))
                       && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0))
                   && (var ubound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1
                           < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
                         then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                            PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1))
                         else #Options.Option.None()); 
                    Lit(true)
                       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                         && PivotBetreeSpec.__default.CutoffNode#canCall(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                          lbound#0, 
                          #Options.Option.Some($Box(PivotBetreeSpec.NodeFusion.pivot(f#0))))
                         && (var left#0 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                              PivotBetreeSpec.NodeFusion.left__child(f#0), 
                              lbound#0, 
                              #Options.Option.Some($Box(PivotBetreeSpec.NodeFusion.pivot(f#0)))); 
                          Lit(true)
                             ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                               && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                               && PivotBetreeSpec.__default.CutoffNode#canCall(PivotBetreeSpec.NodeFusion.right__child(f#0), 
                                #Options.Option.Some($Box(PivotBetreeSpec.NodeFusion.pivot(f#0))), 
                                ubound#0)
                               && (var right#0 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                                    PivotBetreeSpec.NodeFusion.right__child(f#0), 
                                    #Options.Option.Some($Box(PivotBetreeSpec.NodeFusion.pivot(f#0))), 
                                    ubound#0); 
                                Lit(true)
                                   ==> $IsA#PivotBetreeGraph.Node(PivotBetreeSpec.NodeFusion.fused__child(f#0))
                                     && 
                                    PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                     && 
                                    PivotBetreeGraph.Node.Node_q(left#0)
                                     && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
                                     && PivotBetreeGraph.Node.Node_q(right#0)
                                     && Sequences.__default.concat3#canCall(Tclass.KeyType.Key(), 
                                      PivotBetreeGraph.Node.pivotTable(left#0), 
                                      $Box(PivotBetreeSpec.NodeFusion.pivot(f#0)), 
                                      PivotBetreeGraph.Node.pivotTable(right#0))
                                     && 
                                    PivotBetreeGraph.Node.Node_q(left#0)
                                     && (Options.Option.Some_q(PivotBetreeGraph.Node.children(left#0))
                                       ==> PivotBetreeGraph.Node.Node_q(left#0) && PivotBetreeGraph.Node.Node_q(right#0))
                                     && 
                                    PivotBetreeGraph.Node.Node_q(left#0)
                                     && PivotBetreeGraph.Node.Node_q(right#0))))))
         && PivotBetreeSpec.__default.ValidMerge(f#0)
           == (
            PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.split__parent(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.left__child(f#0))
             && PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.NodeFusion.right__child(f#0))
             && 
            LitInt(0) <= PivotBetreeSpec.NodeFusion.slot__idx(f#0)
             && PivotBetreeSpec.NodeFusion.slot__idx(f#0)
               < Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
                 - 1
             && PivotBetreeSpec.NodeFusion.num__children__left(f#0)
               == Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
             && Seq#Equal($Unbox(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0))): Seq Box, 
              PivotBetreeSpec.NodeFusion.pivot(f#0))
             && Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0))): int
               == PivotBetreeSpec.NodeFusion.left__childref(f#0)
             && $Unbox(Seq#Index($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1)): int
               == PivotBetreeSpec.NodeFusion.right__childref(f#0)
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.right__child(f#0)))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
             && Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.left__child(f#0)))
                 + Seq#Length(PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.right__child(f#0)))
               <= LitInt(Bounds.__default.MaxNumChildren())
             && (PivotBetreeSpec.NodeFusion.left__childref(f#0)
                 == PivotBetreeSpec.NodeFusion.right__childref(f#0)
               ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(f#0), 
                PivotBetreeSpec.NodeFusion.right__child(f#0)))
             && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__parent(f#0), 
              #PivotBetreeGraph.Node.Node(Sequences.__default.remove(Tclass.KeyType.Key(), 
                  StartFuel_Sequences._default.remove, 
                  PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0)), 
                #Options.Option.Some($Box(Sequences.__default.replace2with1(Tclass.NativeTypes.uint64(), 
                      StartFuel_Sequences._default.replace2with1, 
                      $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.split__parent(f#0)))): Seq Box, 
                      $Box(PivotBetreeSpec.NodeFusion.fused__childref(f#0)), 
                      PivotBetreeSpec.NodeFusion.slot__idx(f#0)))), 
                BucketsLib.__default.MergeBucketsInList(StartFuel_BucketsLib._default.MergeBucketsInList, 
                  PivotBetreeGraph.Node.buckets(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                  PivotBetreeSpec.NodeFusion.slot__idx(f#0))))
             && (Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> Options.Option.Some_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.right__child(f#0))))
             && (Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.left__child(f#0)))
               ==> Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.NodeFusion.right__child(f#0))))
             && (var lbound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0) > 0
                   then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                      PivotBetreeSpec.NodeFusion.slot__idx(f#0) - 1))
                   else #Options.Option.None()); 
              true
                 && (var ubound#0 := (if PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1
                         < Seq#Length(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)))
                       then #Options.Option.Some(Seq#Index(PivotBetreeGraph.Node.pivotTable(PivotBetreeSpec.NodeFusion.split__parent(f#0)), 
                          PivotBetreeSpec.NodeFusion.slot__idx(f#0) + 1))
                       else #Options.Option.None()); 
                  true
                     && (var left#0 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                          PivotBetreeSpec.NodeFusion.left__child(f#0), 
                          lbound#0, 
                          #Options.Option.Some($Box(PivotBetreeSpec.NodeFusion.pivot(f#0)))); 
                      true
                         && (var right#0 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                              PivotBetreeSpec.NodeFusion.right__child(f#0), 
                              #Options.Option.Some($Box(PivotBetreeSpec.NodeFusion.pivot(f#0))), 
                              ubound#0); 
                          true
                             && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__child(f#0), 
                              #PivotBetreeGraph.Node.Node(Sequences.__default.concat3(Tclass.KeyType.Key(), 
                                  StartFuel_Sequences._default.concat3, 
                                  PivotBetreeGraph.Node.pivotTable(left#0), 
                                  $Box(PivotBetreeSpec.NodeFusion.pivot(f#0)), 
                                  PivotBetreeGraph.Node.pivotTable(right#0)), 
                                (if Options.Option.Some_q(PivotBetreeGraph.Node.children(left#0))
                                   then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(left#0))): Seq Box, 
                                        $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(right#0))): Seq Box)))
                                   else #Options.Option.None()), 
                                Seq#Append(PivotBetreeGraph.Node.buckets(left#0), PivotBetreeGraph.Node.buckets(right#0))))))))));

// definition axiom for PivotBetreeSpec.__default.ValidMerge for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidMerge(Lit(f#0)) } 
    PivotBetreeSpec.__default.ValidMerge#canCall(Lit(f#0))
         || $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
         && (Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)))))
             && 
            LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
             && PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
               < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
                 - 1
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))
               == Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && Seq#Equal($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))): Seq Box, 
              PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0)))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))): int
               == LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1))): int
               == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
             && Bounds.__default.MaxTotalBucketWeight#canCall())
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && BucketWeights.__default.WeightBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
             && Bounds.__default.MaxTotalBucketWeight#canCall()
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && Bounds.__default.MaxNumChildren#canCall())
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
                 + Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
               <= LitInt(Bounds.__default.MaxNumChildren())
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                 == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
               ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
                 && $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                 == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
               ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
                 && $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
                 && 
                PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
             && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                 == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
               ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)), 
                PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
           ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && Sequences.__default.remove#canCall(Tclass.KeyType.Key(), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && Sequences.__default.replace2with1#canCall(Tclass.NativeTypes.uint64(), 
              Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
              $Box(LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0)))), 
              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && BucketsLib.__default.MergeBucketsInList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))))
         && ($IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && Sequences.__default.remove#canCall(Tclass.KeyType.Key(), 
              Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && Sequences.__default.replace2with1#canCall(Tclass.NativeTypes.uint64(), 
              Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
              $Box(LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0)))), 
              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))
             && 
            PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && BucketsLib.__default.MergeBucketsInList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
              LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))
             && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)), 
              #PivotBetreeGraph.Node.Node(Sequences.__default.remove(Tclass.KeyType.Key(), 
                  StartFuel_Sequences._default.remove, 
                  Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))), 
                #Options.Option.Some($Box(Sequences.__default.replace2with1(Tclass.NativeTypes.uint64(), 
                      StartFuel_Sequences._default.replace2with1, 
                      Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
                      $Box(LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0)))), 
                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))))), 
                BucketsLib.__default.MergeBucketsInList(StartFuel_BucketsLib._default.MergeBucketsInList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && (Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))
             && Lit(Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
                 ==> Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && (Lit(Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
         && (PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && (Lit(Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)))))))
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))
             && Lit(Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
                 ==> Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))))
           ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
             && (Lit(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) > 0)
               ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                 && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
                 && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
             && (var lbound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) > 0
                   then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) - 1)))
                   else #Options.Option.None()); 
              Lit(true)
                 ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                   && 
                  PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                   && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
                   && (PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1
                       < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
                     ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                       && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
                       && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0)))
                   && (var ubound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1
                           < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
                         then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                            LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1)))
                         else #Options.Option.None()); 
                    Lit(true)
                       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                         && PivotBetreeSpec.__default.CutoffNode#canCall(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))), 
                          lbound#1, 
                          Lit(#Options.Option.Some($Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))))))
                         && (var left#1 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                              Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))), 
                              lbound#1, 
                              Lit(#Options.Option.Some($Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))))))); 
                          Lit(true)
                             ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                               && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                               && PivotBetreeSpec.__default.CutoffNode#canCall(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))), 
                                Lit(#Options.Option.Some($Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))))), 
                                ubound#1)
                               && (var right#1 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                                    Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))), 
                                    Lit(#Options.Option.Some($Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))))), 
                                    ubound#1); 
                                Lit(true)
                                   ==> $IsA#PivotBetreeGraph.Node(Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))))
                                     && 
                                    PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                     && 
                                    PivotBetreeGraph.Node.Node_q(left#1)
                                     && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
                                     && PivotBetreeGraph.Node.Node_q(right#1)
                                     && Sequences.__default.concat3#canCall(Tclass.KeyType.Key(), 
                                      PivotBetreeGraph.Node.pivotTable(left#1), 
                                      $Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))), 
                                      PivotBetreeGraph.Node.pivotTable(right#1))
                                     && 
                                    PivotBetreeGraph.Node.Node_q(left#1)
                                     && (Options.Option.Some_q(PivotBetreeGraph.Node.children(left#1))
                                       ==> PivotBetreeGraph.Node.Node_q(left#1) && PivotBetreeGraph.Node.Node_q(right#1))
                                     && 
                                    PivotBetreeGraph.Node.Node_q(left#1)
                                     && PivotBetreeGraph.Node.Node_q(right#1))))))
         && PivotBetreeSpec.__default.ValidMerge(Lit(f#0))
           == (
            PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))
             && PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))
             && PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && 
            LitInt(0) <= LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))
             && PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))
               < Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
                 - 1
             && LitInt(PivotBetreeSpec.NodeFusion.num__children__left(Lit(f#0)))
               == Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
             && Seq#Equal($Unbox(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))): Seq Box, 
              PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))
             && Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
             && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))): int
               == LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
             && $Unbox(Seq#Index(Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1))): int
               == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
             && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
                 + BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
               <= LitInt(Bounds.__default.MaxTotalBucketWeight())
             && Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
                 + Seq#Length(Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))))
               <= LitInt(Bounds.__default.MaxNumChildren())
             && (LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0)))
                 == LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0)))
               ==> PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0)), 
                PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))))
             && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)), 
              #PivotBetreeGraph.Node.Node(Sequences.__default.remove(Tclass.KeyType.Key(), 
                  StartFuel_Sequences._default.remove, 
                  Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))), 
                #Options.Option.Some($Box(Sequences.__default.replace2with1(Tclass.NativeTypes.uint64(), 
                      StartFuel_Sequences._default.replace2with1, 
                      Lit($Unbox(Options.Option.value(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))): Seq Box), 
                      $Box(LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0)))), 
                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)))))), 
                BucketsLib.__default.MergeBucketsInList(StartFuel_BucketsLib._default.MergeBucketsInList, 
                  Lit(PivotBetreeGraph.Node.buckets(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                  LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0))))))
             && (Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
               ==> Options.Option.Some_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))))
             && (Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))
               ==> Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))))
             && (var lbound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) > 0
                   then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                      LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) - 1)))
                   else #Options.Option.None()); 
              true
                 && (var ubound#1 := (if PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1
                         < Seq#Length(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))
                       then #Options.Option.Some(Seq#Index(Lit(PivotBetreeGraph.Node.pivotTable(Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))), 
                          LitInt(PivotBetreeSpec.NodeFusion.slot__idx(Lit(f#0)) + 1)))
                       else #Options.Option.None()); 
                  true
                     && (var left#1 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                          Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))), 
                          lbound#1, 
                          Lit(#Options.Option.Some($Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0))))))); 
                      true
                         && (var right#1 := PivotBetreeSpec.__default.CutoffNode(StartFuel_PivotBetreeSpec._default.CutoffNode, 
                              Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0))), 
                              Lit(#Options.Option.Some($Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))))), 
                              ubound#1); 
                          true
                             && PivotBetreeGraph.Node#Equal(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0)), 
                              #PivotBetreeGraph.Node.Node(Sequences.__default.concat3(Tclass.KeyType.Key(), 
                                  StartFuel_Sequences._default.concat3, 
                                  PivotBetreeGraph.Node.pivotTable(left#1), 
                                  $Box(Lit(PivotBetreeSpec.NodeFusion.pivot(Lit(f#0)))), 
                                  PivotBetreeGraph.Node.pivotTable(right#1)), 
                                (if Options.Option.Some_q(PivotBetreeGraph.Node.children(left#1))
                                   then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(PivotBetreeGraph.Node.children(left#1))): Seq Box, 
                                        $Unbox(Options.Option.value(PivotBetreeGraph.Node.children(right#1))): Seq Box)))
                                   else #Options.Option.None()), 
                                Seq#Append(PivotBetreeGraph.Node.buckets(left#1), PivotBetreeGraph.Node.buckets(right#1))))))))));

// function declaration for PivotBetreeSpec._default.MergeReads
function PivotBetreeSpec.__default.MergeReads(f#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.MergeReads#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.MergeReads
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.MergeReads(f#0) } 
    PivotBetreeSpec.__default.MergeReads#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidMerge(f#0))
       ==> $Is(PivotBetreeSpec.__default.MergeReads(f#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.MergeReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.MergeReads
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.MergeReads#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.__default.MergeReads#requires(f#0)
       == PivotBetreeSpec.__default.ValidMerge(f#0));

// definition axiom for PivotBetreeSpec.__default.MergeReads(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.MergeReads(f#0) } 
    PivotBetreeSpec.__default.MergeReads#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidMerge(f#0))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.__default.MergeReads(f#0)
           == Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFusion.parentref(f#0), 
                    PivotBetreeSpec.NodeFusion.split__parent(f#0)))), 
              $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFusion.left__childref(f#0), 
                  PivotBetreeSpec.NodeFusion.left__child(f#0)))), 
            $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.NodeFusion.right__childref(f#0), 
                PivotBetreeSpec.NodeFusion.right__child(f#0)))));

// definition axiom for PivotBetreeSpec.__default.MergeReads for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.MergeReads(Lit(f#0)) } 
    PivotBetreeSpec.__default.MergeReads#canCall(Lit(f#0))
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && Lit(PivotBetreeSpec.__default.ValidMerge(Lit(f#0))))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.__default.MergeReads(Lit(f#0))
           == Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFusion.parentref(Lit(f#0))), 
                        Lit(PivotBetreeSpec.NodeFusion.split__parent(Lit(f#0))))))), 
                $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFusion.left__childref(Lit(f#0))), 
                      Lit(PivotBetreeSpec.NodeFusion.left__child(Lit(f#0))))))), 
              $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.NodeFusion.right__childref(Lit(f#0))), 
                    Lit(PivotBetreeSpec.NodeFusion.right__child(Lit(f#0)))))))));

// function declaration for PivotBetreeSpec._default.MergeOps
function PivotBetreeSpec.__default.MergeOps(f#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.MergeOps#canCall(f#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.MergeOps
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.MergeOps(f#0) } 
    PivotBetreeSpec.__default.MergeOps#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidMerge(f#0))
       ==> $Is(PivotBetreeSpec.__default.MergeOps(f#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.MergeOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.MergeOps
axiom (forall f#0: DatatypeType :: 
  { PivotBetreeSpec.__default.MergeOps#requires(f#0) } 
  $Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
     ==> PivotBetreeSpec.__default.MergeOps#requires(f#0)
       == PivotBetreeSpec.__default.ValidMerge(f#0));

// definition axiom for PivotBetreeSpec.__default.MergeOps(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    { PivotBetreeSpec.__default.MergeOps(f#0) } 
    PivotBetreeSpec.__default.MergeOps#canCall(f#0)
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && PivotBetreeSpec.__default.ValidMerge(f#0))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(f#0)
         && PivotBetreeSpec.__default.MergeOps(f#0)
           == Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(#PivotBetreeGraph.Op.AllocOp(PivotBetreeSpec.NodeFusion.fused__childref(f#0), 
                  PivotBetreeSpec.NodeFusion.fused__child(f#0)))), 
            $Box(#PivotBetreeGraph.Op.WriteOp(PivotBetreeSpec.NodeFusion.parentref(f#0), 
                PivotBetreeSpec.NodeFusion.fused__parent(f#0)))));

// definition axiom for PivotBetreeSpec.__default.MergeOps for all literals(revealed)
axiom true
   ==> (forall f#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.MergeOps(Lit(f#0)) } 
    PivotBetreeSpec.__default.MergeOps#canCall(Lit(f#0))
         || ($Is(f#0, Tclass.PivotBetreeSpec.NodeFusion())
           && Lit(PivotBetreeSpec.__default.ValidMerge(Lit(f#0))))
       ==> PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && 
        PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.NodeFusion.NodeFusion_q(Lit(f#0))
         && PivotBetreeSpec.__default.MergeOps(Lit(f#0))
           == Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(#PivotBetreeGraph.Op.AllocOp(LitInt(PivotBetreeSpec.NodeFusion.fused__childref(Lit(f#0))), 
                      Lit(PivotBetreeSpec.NodeFusion.fused__child(Lit(f#0))))))), 
              $Box(Lit(#PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeSpec.NodeFusion.parentref(Lit(f#0))), 
                    Lit(PivotBetreeSpec.NodeFusion.fused__parent(Lit(f#0)))))))));

// function declaration for PivotBetreeSpec._default.ValidRepivot
function PivotBetreeSpec.__default.ValidRepivot(r#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidRepivot#canCall(r#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidRepivot
axiom true
   ==> (forall r#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidRepivot(r#0) } 
    PivotBetreeSpec.__default.ValidRepivot#canCall(r#0)
         || $Is(r#0, Tclass.PivotBetreeSpec.Repivot())
       ==> true);

function PivotBetreeSpec.__default.ValidRepivot#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidRepivot
axiom (forall r#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidRepivot#requires(r#0) } 
  $Is(r#0, Tclass.PivotBetreeSpec.Repivot())
     ==> PivotBetreeSpec.__default.ValidRepivot#requires(r#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidRepivot(revealed)
axiom true
   ==> (forall r#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidRepivot(r#0) } 
    PivotBetreeSpec.__default.ValidRepivot#canCall(r#0)
         || $Is(r#0, Tclass.PivotBetreeSpec.Repivot())
       ==> PivotBetreeSpec.Repivot.Repivot_q(r#0)
         && PivotBetreeSpec.__default.WFNode#canCall(PivotBetreeSpec.Repivot.leaf(r#0))
         && (PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.Repivot.leaf(r#0))
           ==> PivotBetreeSpec.Repivot.Repivot_q(r#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.Repivot.leaf(r#0)))
         && (PivotBetreeSpec.Repivot.Repivot_q(r#0)
             && PivotBetreeGraph.Node.Node_q(PivotBetreeSpec.Repivot.leaf(r#0))
             && Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.Repivot.leaf(r#0)))
           ==> PivotBetreeSpec.Repivot.Repivot_q(r#0)
             && PivotsLib.__default.WFPivots#canCall(PivotBetreeSpec.Repivot.pivots(r#0)))
         && (PivotBetreeSpec.Repivot.Repivot_q(r#0)
             && PivotsLib.__default.WFPivots#canCall(PivotBetreeSpec.Repivot.pivots(r#0))
             && PivotsLib.__default.WFPivots(PivotBetreeSpec.Repivot.pivots(r#0))
           ==> PivotBetreeSpec.Repivot.Repivot_q(r#0)
             && Bounds.__default.MaxNumChildren#canCall())
         && PivotBetreeSpec.__default.ValidRepivot(r#0)
           == (
            PivotBetreeSpec.__default.WFNode(PivotBetreeSpec.Repivot.leaf(r#0))
             && Options.Option.None_q(PivotBetreeGraph.Node.children(PivotBetreeSpec.Repivot.leaf(r#0)))
             && PivotsLib.__default.WFPivots(PivotBetreeSpec.Repivot.pivots(r#0))
             && Seq#Length(PivotBetreeSpec.Repivot.pivots(r#0))
               <= LitInt(Bounds.__default.MaxNumChildren() - 1)));

// definition axiom for PivotBetreeSpec.__default.ValidRepivot for all literals(revealed)
axiom true
   ==> (forall r#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidRepivot(Lit(r#0)) } 
    PivotBetreeSpec.__default.ValidRepivot#canCall(Lit(r#0))
         || $Is(r#0, Tclass.PivotBetreeSpec.Repivot())
       ==> PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
         && PivotBetreeSpec.__default.WFNode#canCall(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0))))
         && (Lit(PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0)))))
           ==> PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0)))))
         && (PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
             && PivotBetreeGraph.Node.Node_q(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0))))
             && Lit(Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0)))))))
           ==> PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
             && PivotsLib.__default.WFPivots#canCall(Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0)))))
         && (PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
             && PivotsLib.__default.WFPivots#canCall(Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0))))
             && Lit(PivotsLib.__default.WFPivots(Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0)))))
           ==> PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
             && Bounds.__default.MaxNumChildren#canCall())
         && PivotBetreeSpec.__default.ValidRepivot(Lit(r#0))
           == (
            PivotBetreeSpec.__default.WFNode(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0))))
             && Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0))))))
             && PivotsLib.__default.WFPivots(Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0))))
             && Seq#Length(Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0))))
               <= LitInt(Bounds.__default.MaxNumChildren() - 1)));

// function declaration for PivotBetreeSpec._default.RepivotReads
function PivotBetreeSpec.__default.RepivotReads(r#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.RepivotReads#canCall(r#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.RepivotReads
axiom true
   ==> (forall r#0: DatatypeType :: 
    { PivotBetreeSpec.__default.RepivotReads(r#0) } 
    PivotBetreeSpec.__default.RepivotReads#canCall(r#0)
         || ($Is(r#0, Tclass.PivotBetreeSpec.Repivot())
           && PivotBetreeSpec.__default.ValidRepivot(r#0))
       ==> $Is(PivotBetreeSpec.__default.RepivotReads(r#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.RepivotReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.RepivotReads
axiom (forall r#0: DatatypeType :: 
  { PivotBetreeSpec.__default.RepivotReads#requires(r#0) } 
  $Is(r#0, Tclass.PivotBetreeSpec.Repivot())
     ==> PivotBetreeSpec.__default.RepivotReads#requires(r#0)
       == PivotBetreeSpec.__default.ValidRepivot(r#0));

// definition axiom for PivotBetreeSpec.__default.RepivotReads(revealed)
axiom true
   ==> (forall r#0: DatatypeType :: 
    { PivotBetreeSpec.__default.RepivotReads(r#0) } 
    PivotBetreeSpec.__default.RepivotReads#canCall(r#0)
         || ($Is(r#0, Tclass.PivotBetreeSpec.Repivot())
           && PivotBetreeSpec.__default.ValidRepivot(r#0))
       ==> PivotBetreeSpec.Repivot.Repivot_q(r#0)
         && PivotBetreeSpec.Repivot.Repivot_q(r#0)
         && PivotBetreeSpec.__default.RepivotReads(r#0)
           == Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#PivotBetreeGraph.ReadOp.ReadOp(PivotBetreeSpec.Repivot.ref(r#0), PivotBetreeSpec.Repivot.leaf(r#0)))));

// definition axiom for PivotBetreeSpec.__default.RepivotReads for all literals(revealed)
axiom true
   ==> (forall r#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.RepivotReads(Lit(r#0)) } 
    PivotBetreeSpec.__default.RepivotReads#canCall(Lit(r#0))
         || ($Is(r#0, Tclass.PivotBetreeSpec.Repivot())
           && Lit(PivotBetreeSpec.__default.ValidRepivot(Lit(r#0))))
       ==> PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
         && PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
         && PivotBetreeSpec.__default.RepivotReads(Lit(r#0))
           == Lit(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(Lit(#PivotBetreeGraph.ReadOp.ReadOp(LitInt(PivotBetreeSpec.Repivot.ref(Lit(r#0))), 
                    Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0)))))))));

// function declaration for PivotBetreeSpec._default.ApplyRepivot
function PivotBetreeSpec.__default.ApplyRepivot(leaf#0: DatatypeType, pivots#0: Seq Box) : DatatypeType;

function PivotBetreeSpec.__default.ApplyRepivot#canCall(leaf#0: DatatypeType, pivots#0: Seq Box) : bool;

// consequence axiom for PivotBetreeSpec.__default.ApplyRepivot
axiom true
   ==> (forall leaf#0: DatatypeType, pivots#0: Seq Box :: 
    { PivotBetreeSpec.__default.ApplyRepivot(leaf#0, pivots#0) } 
    PivotBetreeSpec.__default.ApplyRepivot#canCall(leaf#0, pivots#0)
         || (
          $Is(leaf#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          PivotBetreeSpec.__default.WFNode(leaf#0)
           && Options.Option.None_q(PivotBetreeGraph.Node.children(leaf#0))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> $Is(PivotBetreeSpec.__default.ApplyRepivot(leaf#0, pivots#0), 
        Tclass.PivotBetreeGraph.Node()));

function PivotBetreeSpec.__default.ApplyRepivot#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PivotBetreeSpec.__default.ApplyRepivot
axiom (forall leaf#0: DatatypeType, pivots#0: Seq Box :: 
  { PivotBetreeSpec.__default.ApplyRepivot#requires(leaf#0, pivots#0) } 
  $Is(leaf#0, Tclass.PivotBetreeGraph.Node())
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> PivotBetreeSpec.__default.ApplyRepivot#requires(leaf#0, pivots#0)
       == (
        PivotBetreeSpec.__default.WFNode(leaf#0)
         && Options.Option.None_q(PivotBetreeGraph.Node.children(leaf#0))
         && PivotsLib.__default.WFPivots(pivots#0)));

// definition axiom for PivotBetreeSpec.__default.ApplyRepivot(revealed)
axiom true
   ==> (forall leaf#0: DatatypeType, pivots#0: Seq Box :: 
    { PivotBetreeSpec.__default.ApplyRepivot(leaf#0, pivots#0) } 
    PivotBetreeSpec.__default.ApplyRepivot#canCall(leaf#0, pivots#0)
         || (
          $Is(leaf#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          PivotBetreeSpec.__default.WFNode(leaf#0)
           && Options.Option.None_q(PivotBetreeGraph.Node.children(leaf#0))
           && PivotsLib.__default.WFPivots(pivots#0))
       ==> PivotBetreeGraph.Node.Node_q(leaf#0)
         && BucketsLib.__default.JoinBucketList#canCall(PivotBetreeGraph.Node.buckets(leaf#0))
         && BucketsLib.__default.SplitBucketOnPivots#canCall(BucketsLib.__default.JoinBucketList($LS($LZ), PivotBetreeGraph.Node.buckets(leaf#0)), 
          pivots#0)
         && PivotBetreeSpec.__default.ApplyRepivot(leaf#0, pivots#0)
           == #PivotBetreeGraph.Node.Node(pivots#0, 
            Lit(#Options.Option.None()), 
            BucketsLib.__default.SplitBucketOnPivots($LS($LZ), 
              BucketsLib.__default.JoinBucketList($LS($LZ), PivotBetreeGraph.Node.buckets(leaf#0)), 
              pivots#0)));

// definition axiom for PivotBetreeSpec.__default.ApplyRepivot for all literals(revealed)
axiom true
   ==> (forall leaf#0: DatatypeType, pivots#0: Seq Box :: 
    {:weight 3} { PivotBetreeSpec.__default.ApplyRepivot(Lit(leaf#0), Lit(pivots#0)) } 
    PivotBetreeSpec.__default.ApplyRepivot#canCall(Lit(leaf#0), Lit(pivots#0))
         || (
          $Is(leaf#0, Tclass.PivotBetreeGraph.Node())
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && 
          Lit(PivotBetreeSpec.__default.WFNode(Lit(leaf#0)))
           && Lit(Options.Option.None_q(Lit(PivotBetreeGraph.Node.children(Lit(leaf#0)))))
           && Lit(PivotsLib.__default.WFPivots(Lit(pivots#0))))
       ==> PivotBetreeGraph.Node.Node_q(Lit(leaf#0))
         && BucketsLib.__default.JoinBucketList#canCall(Lit(PivotBetreeGraph.Node.buckets(Lit(leaf#0))))
         && BucketsLib.__default.SplitBucketOnPivots#canCall(Lit(BucketsLib.__default.JoinBucketList($LS($LZ), Lit(PivotBetreeGraph.Node.buckets(Lit(leaf#0))))), 
          Lit(pivots#0))
         && PivotBetreeSpec.__default.ApplyRepivot(Lit(leaf#0), Lit(pivots#0))
           == Lit(#PivotBetreeGraph.Node.Node(Lit(pivots#0), 
              Lit(#Options.Option.None()), 
              Lit(BucketsLib.__default.SplitBucketOnPivots($LS($LZ), 
                  Lit(BucketsLib.__default.JoinBucketList($LS($LZ), Lit(PivotBetreeGraph.Node.buckets(Lit(leaf#0))))), 
                  Lit(pivots#0))))));

// function declaration for PivotBetreeSpec._default.RepivotOps
function PivotBetreeSpec.__default.RepivotOps(r#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.RepivotOps#canCall(r#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.RepivotOps
axiom true
   ==> (forall r#0: DatatypeType :: 
    { PivotBetreeSpec.__default.RepivotOps(r#0) } 
    PivotBetreeSpec.__default.RepivotOps#canCall(r#0)
         || ($Is(r#0, Tclass.PivotBetreeSpec.Repivot())
           && PivotBetreeSpec.__default.ValidRepivot(r#0))
       ==> $Is(PivotBetreeSpec.__default.RepivotOps(r#0), TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.RepivotOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.RepivotOps
axiom (forall r#0: DatatypeType :: 
  { PivotBetreeSpec.__default.RepivotOps#requires(r#0) } 
  $Is(r#0, Tclass.PivotBetreeSpec.Repivot())
     ==> PivotBetreeSpec.__default.RepivotOps#requires(r#0)
       == PivotBetreeSpec.__default.ValidRepivot(r#0));

// definition axiom for PivotBetreeSpec.__default.RepivotOps(revealed)
axiom true
   ==> (forall r#0: DatatypeType :: 
    { PivotBetreeSpec.__default.RepivotOps(r#0) } 
    PivotBetreeSpec.__default.RepivotOps#canCall(r#0)
         || ($Is(r#0, Tclass.PivotBetreeSpec.Repivot())
           && PivotBetreeSpec.__default.ValidRepivot(r#0))
       ==> PivotBetreeSpec.Repivot.Repivot_q(r#0)
         && 
        PivotBetreeSpec.Repivot.Repivot_q(r#0)
         && PivotBetreeSpec.Repivot.Repivot_q(r#0)
         && PivotBetreeSpec.__default.ApplyRepivot#canCall(PivotBetreeSpec.Repivot.leaf(r#0), PivotBetreeSpec.Repivot.pivots(r#0))
         && PivotBetreeSpec.__default.RepivotOps(r#0)
           == Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#PivotBetreeGraph.Op.WriteOp(PivotBetreeSpec.Repivot.ref(r#0), 
                PivotBetreeSpec.__default.ApplyRepivot(PivotBetreeSpec.Repivot.leaf(r#0), PivotBetreeSpec.Repivot.pivots(r#0))))));

// definition axiom for PivotBetreeSpec.__default.RepivotOps for all literals(revealed)
axiom true
   ==> (forall r#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.RepivotOps(Lit(r#0)) } 
    PivotBetreeSpec.__default.RepivotOps#canCall(Lit(r#0))
         || ($Is(r#0, Tclass.PivotBetreeSpec.Repivot())
           && Lit(PivotBetreeSpec.__default.ValidRepivot(Lit(r#0))))
       ==> PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
         && 
        PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
         && PivotBetreeSpec.Repivot.Repivot_q(Lit(r#0))
         && PivotBetreeSpec.__default.ApplyRepivot#canCall(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0))), 
          Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0))))
         && PivotBetreeSpec.__default.RepivotOps(Lit(r#0))
           == Lit(Seq#Build(Seq#Empty(): Seq Box, 
              $Box(Lit(#PivotBetreeGraph.Op.WriteOp(LitInt(PivotBetreeSpec.Repivot.ref(Lit(r#0))), 
                    Lit(PivotBetreeSpec.__default.ApplyRepivot(Lit(PivotBetreeSpec.Repivot.leaf(Lit(r#0))), 
                        Lit(PivotBetreeSpec.Repivot.pivots(Lit(r#0)))))))))));

// function declaration for PivotBetreeSpec._default.ValidBetreeStep
function PivotBetreeSpec.__default.ValidBetreeStep(step#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.ValidBetreeStep#canCall(step#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.ValidBetreeStep
axiom true
   ==> (forall step#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidBetreeStep(step#0) } 
    PivotBetreeSpec.__default.ValidBetreeStep#canCall(step#0)
         || $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
       ==> true);

function PivotBetreeSpec.__default.ValidBetreeStep#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.ValidBetreeStep
axiom (forall step#0: DatatypeType :: 
  { PivotBetreeSpec.__default.ValidBetreeStep#requires(step#0) } 
  $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
     ==> PivotBetreeSpec.__default.ValidBetreeStep#requires(step#0) == true);

// definition axiom for PivotBetreeSpec.__default.ValidBetreeStep(revealed)
axiom true
   ==> (forall step#0: DatatypeType :: 
    { PivotBetreeSpec.__default.ValidBetreeStep(step#0) } 
    PivotBetreeSpec.__default.ValidBetreeStep#canCall(step#0)
         || $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
       ==> (PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (var q#0 := PivotBetreeSpec.BetreeStep.q(step#0); 
            PivotBetreeSpec.__default.ValidQuery#canCall(q#0)))
         && (!PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (var sq#0 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                PivotBetreeSpec.__default.ValidSuccQuery#canCall(sq#0)))
             && (!PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                   ==> (var ins#0 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                    PivotBetreeSpec.__default.ValidInsertion#canCall(ins#0)))
                 && (!PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                   ==> (PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                       ==> (var flush#0 := PivotBetreeSpec.BetreeStep.flush(step#0); 
                        PivotBetreeSpec.__default.ValidFlush#canCall(flush#0)))
                     && (!PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                       ==> (PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                           ==> (var growth#0 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                            PivotBetreeSpec.__default.ValidGrow#canCall(growth#0)))
                         && (!PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                           ==> (PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                               ==> (var fusion#0 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                                PivotBetreeSpec.__default.ValidSplit#canCall(fusion#0)))
                             && (!PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                               ==> (PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                                   ==> (var fusion#1 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                                    PivotBetreeSpec.__default.ValidMerge#canCall(fusion#1)))
                                 && (!PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                                   ==> (var r#0 := PivotBetreeSpec.BetreeStep.repivot(step#0); 
                                    PivotBetreeSpec.__default.ValidRepivot#canCall(r#0)))))))))
         && PivotBetreeSpec.__default.ValidBetreeStep(step#0)
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
             then (var q#1 := PivotBetreeSpec.BetreeStep.q(step#0); 
              PivotBetreeSpec.__default.ValidQuery(q#1))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               then (var sq#1 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                PivotBetreeSpec.__default.ValidSuccQuery(sq#1))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                 then (var ins#1 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                  PivotBetreeSpec.__default.ValidInsertion(ins#1))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                   then (var flush#1 := PivotBetreeSpec.BetreeStep.flush(step#0); 
                    PivotBetreeSpec.__default.ValidFlush(flush#1))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                     then (var growth#1 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                      PivotBetreeSpec.__default.ValidGrow(growth#1))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                       then (var fusion#2 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                        PivotBetreeSpec.__default.ValidSplit(fusion#2))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                         then (var fusion#3 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                          PivotBetreeSpec.__default.ValidMerge(fusion#3))
                         else (var r#1 := PivotBetreeSpec.BetreeStep.repivot(step#0); 
                          PivotBetreeSpec.__default.ValidRepivot(r#1))))))))));

// definition axiom for PivotBetreeSpec.__default.ValidBetreeStep for all literals(revealed)
axiom true
   ==> (forall step#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.ValidBetreeStep(Lit(step#0)) } 
    PivotBetreeSpec.__default.ValidBetreeStep#canCall(Lit(step#0))
         || $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (var q#2 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
            PivotBetreeSpec.__default.ValidQuery#canCall(q#2)))
         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (var sq#2 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                PivotBetreeSpec.__default.ValidSuccQuery#canCall(sq#2)))
             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
                   ==> (var ins#2 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                    PivotBetreeSpec.__default.ValidInsertion#canCall(ins#2)))
                 && (!Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
                   ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0)))
                       ==> (var flush#2 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                        PivotBetreeSpec.__default.ValidFlush#canCall(flush#2)))
                     && (!Lit(PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0)))
                       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0)))
                           ==> (var growth#2 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                            PivotBetreeSpec.__default.ValidGrow#canCall(growth#2)))
                         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0)))
                           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0)))
                               ==> (var fusion#4 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                                PivotBetreeSpec.__default.ValidSplit#canCall(fusion#4)))
                             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0)))
                               ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0)))
                                   ==> (var fusion#5 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                                    PivotBetreeSpec.__default.ValidMerge#canCall(fusion#5)))
                                 && (!Lit(PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0)))
                                   ==> (var r#2 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                                    PivotBetreeSpec.__default.ValidRepivot#canCall(r#2)))))))))
         && PivotBetreeSpec.__default.ValidBetreeStep(Lit(step#0))
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0))
             then (var q#3 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
              Lit(PivotBetreeSpec.__default.ValidQuery(q#3)))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0))
               then (var sq#3 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                Lit(PivotBetreeSpec.__default.ValidSuccQuery(sq#3)))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0))
                 then (var ins#3 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                  Lit(PivotBetreeSpec.__default.ValidInsertion(ins#3)))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0))
                   then (var flush#3 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                    Lit(PivotBetreeSpec.__default.ValidFlush(flush#3)))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0))
                     then (var growth#3 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                      Lit(PivotBetreeSpec.__default.ValidGrow(growth#3)))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0))
                       then (var fusion#6 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                        Lit(PivotBetreeSpec.__default.ValidSplit(fusion#6)))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0))
                         then (var fusion#7 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                          Lit(PivotBetreeSpec.__default.ValidMerge(fusion#7)))
                         else (var r#3 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                          Lit(PivotBetreeSpec.__default.ValidRepivot(r#3)))))))))));

// function declaration for PivotBetreeSpec._default.BetreeStepReads
function PivotBetreeSpec.__default.BetreeStepReads(step#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.BetreeStepReads#canCall(step#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.BetreeStepReads
axiom true
   ==> (forall step#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BetreeStepReads(step#0) } 
    PivotBetreeSpec.__default.BetreeStepReads#canCall(step#0)
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && PivotBetreeSpec.__default.ValidBetreeStep(step#0))
       ==> $Is(PivotBetreeSpec.__default.BetreeStepReads(step#0), 
        TSeq(Tclass.PivotBetreeGraph.ReadOp())));

function PivotBetreeSpec.__default.BetreeStepReads#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.BetreeStepReads
axiom (forall step#0: DatatypeType :: 
  { PivotBetreeSpec.__default.BetreeStepReads#requires(step#0) } 
  $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
     ==> PivotBetreeSpec.__default.BetreeStepReads#requires(step#0)
       == PivotBetreeSpec.__default.ValidBetreeStep(step#0));

// definition axiom for PivotBetreeSpec.__default.BetreeStepReads(revealed)
axiom true
   ==> (forall step#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BetreeStepReads(step#0) } 
    PivotBetreeSpec.__default.BetreeStepReads#canCall(step#0)
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && PivotBetreeSpec.__default.ValidBetreeStep(step#0))
       ==> (PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (var q#0 := PivotBetreeSpec.BetreeStep.q(step#0); 
            PivotBetreeSpec.__default.QueryReads#canCall(q#0)))
         && (!PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (var sq#0 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                PivotBetreeSpec.__default.SuccQueryReads#canCall(sq#0)))
             && (!PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                   ==> (var ins#0 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                    PivotBetreeSpec.__default.InsertionReads#canCall(ins#0)))
                 && (!PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                   ==> (PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                       ==> (var flush#0 := PivotBetreeSpec.BetreeStep.flush(step#0); 
                        PivotBetreeSpec.__default.FlushReads#canCall(flush#0)))
                     && (!PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                       ==> (PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                           ==> (var growth#0 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                            PivotBetreeSpec.__default.GrowReads#canCall(growth#0)))
                         && (!PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                           ==> (PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                               ==> (var fusion#0 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                                PivotBetreeSpec.__default.SplitReads#canCall(fusion#0)))
                             && (!PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                               ==> (PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                                   ==> (var fusion#1 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                                    PivotBetreeSpec.__default.MergeReads#canCall(fusion#1)))
                                 && (!PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                                   ==> (var r#0 := PivotBetreeSpec.BetreeStep.repivot(step#0); 
                                    PivotBetreeSpec.__default.RepivotReads#canCall(r#0)))))))))
         && PivotBetreeSpec.__default.BetreeStepReads(step#0)
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
             then (var q#1 := PivotBetreeSpec.BetreeStep.q(step#0); 
              PivotBetreeSpec.__default.QueryReads(q#1))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               then (var sq#1 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                PivotBetreeSpec.__default.SuccQueryReads(sq#1))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                 then (var ins#1 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                  PivotBetreeSpec.__default.InsertionReads(ins#1))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                   then (var flush#1 := PivotBetreeSpec.BetreeStep.flush(step#0); 
                    PivotBetreeSpec.__default.FlushReads(flush#1))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                     then (var growth#1 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                      PivotBetreeSpec.__default.GrowReads(growth#1))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                       then (var fusion#2 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                        PivotBetreeSpec.__default.SplitReads(fusion#2))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                         then (var fusion#3 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                          PivotBetreeSpec.__default.MergeReads(fusion#3))
                         else (var r#1 := PivotBetreeSpec.BetreeStep.repivot(step#0); 
                          PivotBetreeSpec.__default.RepivotReads(r#1))))))))));

// definition axiom for PivotBetreeSpec.__default.BetreeStepReads for all literals(revealed)
axiom true
   ==> (forall step#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.BetreeStepReads(Lit(step#0)) } 
    PivotBetreeSpec.__default.BetreeStepReads#canCall(Lit(step#0))
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && Lit(PivotBetreeSpec.__default.ValidBetreeStep(Lit(step#0))))
       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (var q#2 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
            PivotBetreeSpec.__default.QueryReads#canCall(q#2)))
         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (var sq#2 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                PivotBetreeSpec.__default.SuccQueryReads#canCall(sq#2)))
             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
                   ==> (var ins#2 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                    PivotBetreeSpec.__default.InsertionReads#canCall(ins#2)))
                 && (!Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
                   ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0)))
                       ==> (var flush#2 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                        PivotBetreeSpec.__default.FlushReads#canCall(flush#2)))
                     && (!Lit(PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0)))
                       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0)))
                           ==> (var growth#2 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                            PivotBetreeSpec.__default.GrowReads#canCall(growth#2)))
                         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0)))
                           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0)))
                               ==> (var fusion#4 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                                PivotBetreeSpec.__default.SplitReads#canCall(fusion#4)))
                             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0)))
                               ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0)))
                                   ==> (var fusion#5 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                                    PivotBetreeSpec.__default.MergeReads#canCall(fusion#5)))
                                 && (!Lit(PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0)))
                                   ==> (var r#2 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                                    PivotBetreeSpec.__default.RepivotReads#canCall(r#2)))))))))
         && PivotBetreeSpec.__default.BetreeStepReads(Lit(step#0))
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0))
             then (var q#3 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
              Lit(PivotBetreeSpec.__default.QueryReads(q#3)))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0))
               then (var sq#3 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                Lit(PivotBetreeSpec.__default.SuccQueryReads(sq#3)))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0))
                 then (var ins#3 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                  Lit(PivotBetreeSpec.__default.InsertionReads(ins#3)))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0))
                   then (var flush#3 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                    Lit(PivotBetreeSpec.__default.FlushReads(flush#3)))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0))
                     then (var growth#3 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                      Lit(PivotBetreeSpec.__default.GrowReads(growth#3)))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0))
                       then (var fusion#6 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                        Lit(PivotBetreeSpec.__default.SplitReads(fusion#6)))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0))
                         then (var fusion#7 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                          Lit(PivotBetreeSpec.__default.MergeReads(fusion#7)))
                         else (var r#3 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                          Lit(PivotBetreeSpec.__default.RepivotReads(r#3)))))))))));

// function declaration for PivotBetreeSpec._default.BetreeStepOps
function PivotBetreeSpec.__default.BetreeStepOps(step#0: DatatypeType) : Seq Box;

function PivotBetreeSpec.__default.BetreeStepOps#canCall(step#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.BetreeStepOps
axiom true
   ==> (forall step#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BetreeStepOps(step#0) } 
    PivotBetreeSpec.__default.BetreeStepOps#canCall(step#0)
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && PivotBetreeSpec.__default.ValidBetreeStep(step#0))
       ==> $Is(PivotBetreeSpec.__default.BetreeStepOps(step#0), 
        TSeq(Tclass.PivotBetreeGraph.Op())));

function PivotBetreeSpec.__default.BetreeStepOps#requires(DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.BetreeStepOps
axiom (forall step#0: DatatypeType :: 
  { PivotBetreeSpec.__default.BetreeStepOps#requires(step#0) } 
  $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
     ==> PivotBetreeSpec.__default.BetreeStepOps#requires(step#0)
       == PivotBetreeSpec.__default.ValidBetreeStep(step#0));

// definition axiom for PivotBetreeSpec.__default.BetreeStepOps(revealed)
axiom true
   ==> (forall step#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BetreeStepOps(step#0) } 
    PivotBetreeSpec.__default.BetreeStepOps#canCall(step#0)
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && PivotBetreeSpec.__default.ValidBetreeStep(step#0))
       ==> (PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (var q#0 := PivotBetreeSpec.BetreeStep.q(step#0); 
            PivotBetreeSpec.__default.QueryOps#canCall(q#0)))
         && (!PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (var sq#0 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                PivotBetreeSpec.__default.SuccQueryOps#canCall(sq#0)))
             && (!PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                   ==> (var ins#0 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                    PivotBetreeSpec.__default.InsertionOps#canCall(ins#0)))
                 && (!PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                   ==> (PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                       ==> (var flush#0 := PivotBetreeSpec.BetreeStep.flush(step#0); 
                        PivotBetreeSpec.__default.FlushOps#canCall(flush#0)))
                     && (!PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                       ==> (PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                           ==> (var growth#0 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                            PivotBetreeSpec.__default.GrowOps#canCall(growth#0)))
                         && (!PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                           ==> (PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                               ==> (var fusion#0 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                                PivotBetreeSpec.__default.SplitOps#canCall(fusion#0)))
                             && (!PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                               ==> (PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                                   ==> (var fusion#1 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                                    PivotBetreeSpec.__default.MergeOps#canCall(fusion#1)))
                                 && (!PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                                   ==> (var r#0 := PivotBetreeSpec.BetreeStep.repivot(step#0); 
                                    PivotBetreeSpec.__default.RepivotOps#canCall(r#0)))))))))
         && PivotBetreeSpec.__default.BetreeStepOps(step#0)
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
             then (var q#1 := PivotBetreeSpec.BetreeStep.q(step#0); 
              PivotBetreeSpec.__default.QueryOps(q#1))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               then (var sq#1 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                PivotBetreeSpec.__default.SuccQueryOps(sq#1))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                 then (var ins#1 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                  PivotBetreeSpec.__default.InsertionOps(ins#1))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                   then (var flush#1 := PivotBetreeSpec.BetreeStep.flush(step#0); 
                    PivotBetreeSpec.__default.FlushOps(flush#1))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                     then (var growth#1 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                      PivotBetreeSpec.__default.GrowOps(growth#1))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                       then (var fusion#2 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                        PivotBetreeSpec.__default.SplitOps(fusion#2))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                         then (var fusion#3 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                          PivotBetreeSpec.__default.MergeOps(fusion#3))
                         else (var r#1 := PivotBetreeSpec.BetreeStep.repivot(step#0); 
                          PivotBetreeSpec.__default.RepivotOps(r#1))))))))));

// definition axiom for PivotBetreeSpec.__default.BetreeStepOps for all literals(revealed)
axiom true
   ==> (forall step#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.BetreeStepOps(Lit(step#0)) } 
    PivotBetreeSpec.__default.BetreeStepOps#canCall(Lit(step#0))
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && Lit(PivotBetreeSpec.__default.ValidBetreeStep(Lit(step#0))))
       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (var q#2 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
            PivotBetreeSpec.__default.QueryOps#canCall(q#2)))
         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (var sq#2 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                PivotBetreeSpec.__default.SuccQueryOps#canCall(sq#2)))
             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
                   ==> (var ins#2 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                    PivotBetreeSpec.__default.InsertionOps#canCall(ins#2)))
                 && (!Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
                   ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0)))
                       ==> (var flush#2 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                        PivotBetreeSpec.__default.FlushOps#canCall(flush#2)))
                     && (!Lit(PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0)))
                       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0)))
                           ==> (var growth#2 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                            PivotBetreeSpec.__default.GrowOps#canCall(growth#2)))
                         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0)))
                           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0)))
                               ==> (var fusion#4 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                                PivotBetreeSpec.__default.SplitOps#canCall(fusion#4)))
                             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0)))
                               ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0)))
                                   ==> (var fusion#5 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                                    PivotBetreeSpec.__default.MergeOps#canCall(fusion#5)))
                                 && (!Lit(PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0)))
                                   ==> (var r#2 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                                    PivotBetreeSpec.__default.RepivotOps#canCall(r#2)))))))))
         && PivotBetreeSpec.__default.BetreeStepOps(Lit(step#0))
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0))
             then (var q#3 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
              Lit(PivotBetreeSpec.__default.QueryOps(q#3)))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0))
               then (var sq#3 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                Lit(PivotBetreeSpec.__default.SuccQueryOps(sq#3)))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0))
                 then (var ins#3 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                  Lit(PivotBetreeSpec.__default.InsertionOps(ins#3)))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0))
                   then (var flush#3 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                    Lit(PivotBetreeSpec.__default.FlushOps(flush#3)))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0))
                     then (var growth#3 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                      Lit(PivotBetreeSpec.__default.GrowOps(growth#3)))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0))
                       then (var fusion#6 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                        Lit(PivotBetreeSpec.__default.SplitOps(fusion#6)))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0))
                         then (var fusion#7 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                          Lit(PivotBetreeSpec.__default.MergeOps(fusion#7)))
                         else (var r#3 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                          Lit(PivotBetreeSpec.__default.RepivotOps(r#3)))))))))));

// function declaration for PivotBetreeSpec._default.BetreeStepUI
function PivotBetreeSpec.__default.BetreeStepUI(step#0: DatatypeType, uiop#0: DatatypeType) : bool;

function PivotBetreeSpec.__default.BetreeStepUI#canCall(step#0: DatatypeType, uiop#0: DatatypeType) : bool;

// consequence axiom for PivotBetreeSpec.__default.BetreeStepUI
axiom true
   ==> (forall step#0: DatatypeType, uiop#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BetreeStepUI(step#0, uiop#0) } 
    PivotBetreeSpec.__default.BetreeStepUI#canCall(step#0, uiop#0)
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> true);

function PivotBetreeSpec.__default.BetreeStepUI#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for PivotBetreeSpec.__default.BetreeStepUI
axiom (forall step#0: DatatypeType, uiop#0: DatatypeType :: 
  { PivotBetreeSpec.__default.BetreeStepUI#requires(step#0, uiop#0) } 
  $Is(step#0, Tclass.PivotBetreeSpec.BetreeStep()) && $Is(uiop#0, Tclass.UI.Op())
     ==> PivotBetreeSpec.__default.BetreeStepUI#requires(step#0, uiop#0) == true);

// definition axiom for PivotBetreeSpec.__default.BetreeStepUI(revealed)
axiom true
   ==> (forall step#0: DatatypeType, uiop#0: DatatypeType :: 
    { PivotBetreeSpec.__default.BetreeStepUI(step#0, uiop#0) } 
    PivotBetreeSpec.__default.BetreeStepUI#canCall(step#0, uiop#0)
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (var q#0 := PivotBetreeSpec.BetreeStep.q(step#0); 
            $IsA#UI.Op(uiop#0)
               && 
              PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)
               && PivotBetreeSpec.LookupQuery.LookupQuery_q(q#0)))
         && (!PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
           ==> (PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> (var sq#0 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                $IsA#UI.Op(uiop#0)
                   && 
                  PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                   && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)
                   && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#0)))
             && (!PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               ==> 
              PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
               ==> (var ins#0 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
                   && (ValueMessage.Message.Define_q(PivotBetreeSpec.MessageInsertion.msg(ins#0))
                     ==> $IsA#UI.Op(uiop#0)
                       && 
                      PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)
                       && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#0)))))
         && PivotBetreeSpec.__default.BetreeStepUI(step#0, uiop#0)
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(step#0)
             then (var q#1 := PivotBetreeSpec.BetreeStep.q(step#0); 
              UI.Op#Equal(uiop#0, 
                #UI.Op.GetOp(PivotBetreeSpec.LookupQuery.key(q#1), PivotBetreeSpec.LookupQuery.value(q#1))))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(step#0)
               then (var sq#1 := PivotBetreeSpec.BetreeStep.sq(step#0); 
                UI.Op#Equal(uiop#0, 
                  #UI.Op.SuccOp(PivotBetreeSpec.SuccQuery.start(sq#1), 
                    PivotBetreeSpec.SuccQuery.results(sq#1), 
                    PivotBetreeSpec.SuccQuery.end(sq#1))))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(step#0)
                 then (var ins#1 := PivotBetreeSpec.BetreeStep.ins(step#0); 
                  ValueMessage.Message.Define_q(PivotBetreeSpec.MessageInsertion.msg(ins#1))
                     && UI.Op#Equal(uiop#0, 
                      #UI.Op.PutOp(PivotBetreeSpec.MessageInsertion.key(ins#1), 
                        ValueMessage.Message.value(PivotBetreeSpec.MessageInsertion.msg(ins#1)))))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(step#0)
                   then (var flush#1 := PivotBetreeSpec.BetreeStep.flush(step#0); UI.Op.NoOp_q(uiop#0))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(step#0)
                     then (var growth#1 := PivotBetreeSpec.BetreeStep.growth(step#0); 
                      UI.Op.NoOp_q(uiop#0))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(step#0)
                       then (var fusion#2 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                        UI.Op.NoOp_q(uiop#0))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(step#0)
                         then (var fusion#3 := PivotBetreeSpec.BetreeStep.fusion(step#0); 
                          UI.Op.NoOp_q(uiop#0))
                         else (var r#1 := PivotBetreeSpec.BetreeStep.repivot(step#0); UI.Op.NoOp_q(uiop#0))))))))));

// definition axiom for PivotBetreeSpec.__default.BetreeStepUI for all literals(revealed)
axiom true
   ==> (forall step#0: DatatypeType, uiop#0: DatatypeType :: 
    {:weight 3} { PivotBetreeSpec.__default.BetreeStepUI(Lit(step#0), Lit(uiop#0)) } 
    PivotBetreeSpec.__default.BetreeStepUI#canCall(Lit(step#0), Lit(uiop#0))
         || ($Is(step#0, Tclass.PivotBetreeSpec.BetreeStep())
           && $Is(uiop#0, Tclass.UI.Op()))
       ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (var q#2 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
            $IsA#UI.Op(Lit(uiop#0))
               && 
              PivotBetreeSpec.LookupQuery.LookupQuery_q(q#2)
               && PivotBetreeSpec.LookupQuery.LookupQuery_q(q#2)))
         && (!Lit(PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0)))
           ==> (Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> (var sq#2 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                $IsA#UI.Op(Lit(uiop#0))
                   && 
                  PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#2)
                   && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#2)
                   && PivotBetreeSpec.SuccQuery.SuccQuery_q(sq#2)))
             && (!Lit(PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0)))
               ==> 
              Lit(PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0)))
               ==> (var ins#2 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#2)
                   && (ValueMessage.Message.Define_q(PivotBetreeSpec.MessageInsertion.msg(ins#2))
                     ==> $IsA#UI.Op(Lit(uiop#0))
                       && 
                      PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#2)
                       && PivotBetreeSpec.MessageInsertion.MessageInsertion_q(ins#2)))))
         && PivotBetreeSpec.__default.BetreeStepUI(Lit(step#0), Lit(uiop#0))
           == (if PivotBetreeSpec.BetreeStep.BetreeQuery_q(Lit(step#0))
             then (var q#3 := Lit(PivotBetreeSpec.BetreeStep.q(Lit(step#0))); 
              UI.Op#Equal(uiop#0, 
                #UI.Op.GetOp(Lit(PivotBetreeSpec.LookupQuery.key(q#3)), 
                  Lit(PivotBetreeSpec.LookupQuery.value(q#3)))))
             else (if PivotBetreeSpec.BetreeStep.BetreeSuccQuery_q(Lit(step#0))
               then (var sq#3 := Lit(PivotBetreeSpec.BetreeStep.sq(Lit(step#0))); 
                UI.Op#Equal(uiop#0, 
                  #UI.Op.SuccOp(Lit(PivotBetreeSpec.SuccQuery.start(sq#3)), 
                    Lit(PivotBetreeSpec.SuccQuery.results(sq#3)), 
                    Lit(PivotBetreeSpec.SuccQuery.end(sq#3)))))
               else (if PivotBetreeSpec.BetreeStep.BetreeInsert_q(Lit(step#0))
                 then (var ins#3 := Lit(PivotBetreeSpec.BetreeStep.ins(Lit(step#0))); 
                  ValueMessage.Message.Define_q(Lit(PivotBetreeSpec.MessageInsertion.msg(ins#3)))
                     && UI.Op#Equal(uiop#0, 
                      #UI.Op.PutOp(Lit(PivotBetreeSpec.MessageInsertion.key(ins#3)), 
                        Lit(ValueMessage.Message.value(Lit(PivotBetreeSpec.MessageInsertion.msg(ins#3)))))))
                 else (if PivotBetreeSpec.BetreeStep.BetreeFlush_q(Lit(step#0))
                   then (var flush#3 := Lit(PivotBetreeSpec.BetreeStep.flush(Lit(step#0))); 
                    Lit(UI.Op.NoOp_q(Lit(uiop#0))))
                   else (if PivotBetreeSpec.BetreeStep.BetreeGrow_q(Lit(step#0))
                     then (var growth#3 := Lit(PivotBetreeSpec.BetreeStep.growth(Lit(step#0))); 
                      Lit(UI.Op.NoOp_q(Lit(uiop#0))))
                     else (if PivotBetreeSpec.BetreeStep.BetreeSplit_q(Lit(step#0))
                       then (var fusion#6 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                        Lit(UI.Op.NoOp_q(Lit(uiop#0))))
                       else (if PivotBetreeSpec.BetreeStep.BetreeMerge_q(Lit(step#0))
                         then (var fusion#7 := Lit(PivotBetreeSpec.BetreeStep.fusion(Lit(step#0))); 
                          Lit(UI.Op.NoOp_q(Lit(uiop#0))))
                         else (var r#3 := Lit(PivotBetreeSpec.BetreeStep.repivot(Lit(step#0))); 
                          Lit(UI.Op.NoOp_q(Lit(uiop#0))))))))))));

// Constructor function declaration
function #DiskLayout.Location.Location(int, int) : DatatypeType;

const unique ##DiskLayout.Location.Location: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #DiskLayout.Location.Location(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#DiskLayout.Location.Location(a#0#0#0, a#0#1#0))
     == ##DiskLayout.Location.Location);

function DiskLayout.Location.Location_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { DiskLayout.Location.Location_q(d) } 
  DiskLayout.Location.Location_q(d)
     <==> DatatypeCtorId(d) == ##DiskLayout.Location.Location);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { DiskLayout.Location.Location_q(d) } 
  DiskLayout.Location.Location_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #DiskLayout.Location.Location(a#1#0#0, a#1#1#0)));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#DiskLayout.Location.Location(a#2#0#0, a#2#1#0), Tclass.DiskLayout.Location()) } 
  $Is(#DiskLayout.Location.Location(a#2#0#0, a#2#1#0), Tclass.DiskLayout.Location())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#DiskLayout.Location.Location(a#3#0#0, a#3#1#0), 
      Tclass.DiskLayout.Location(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#DiskLayout.Location.Location(a#3#0#0, a#3#1#0), 
        Tclass.DiskLayout.Location(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DiskLayout.Location.addr(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DiskLayout.Location.Location_q(d)
       && $IsAlloc(d, Tclass.DiskLayout.Location(), $h)
     ==> $IsAlloc(DiskLayout.Location.addr(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(DiskLayout.Location.len(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      DiskLayout.Location.Location_q(d)
       && $IsAlloc(d, Tclass.DiskLayout.Location(), $h)
     ==> $IsAlloc(DiskLayout.Location.len(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #DiskLayout.Location.Location(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #DiskLayout.Location.Location(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#DiskLayout.Location.Location(a#4#0#0, a#4#1#0)));

function DiskLayout.Location.addr(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #DiskLayout.Location.Location(a#5#0#0, a#5#1#0) } 
  DiskLayout.Location.addr(#DiskLayout.Location.Location(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function DiskLayout.Location.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #DiskLayout.Location.Location(a#6#0#0, a#6#1#0) } 
  DiskLayout.Location.len(#DiskLayout.Location.Location(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Depth-one case-split function
function $IsA#DiskLayout.Location(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#DiskLayout.Location(d) } 
  $IsA#DiskLayout.Location(d) ==> DiskLayout.Location.Location_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { DiskLayout.Location.Location_q(d), $Is(d, Tclass.DiskLayout.Location()) } 
  $Is(d, Tclass.DiskLayout.Location()) ==> DiskLayout.Location.Location_q(d));

// Datatype extensional equality declaration
function DiskLayout.Location#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #DiskLayout.Location.Location
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DiskLayout.Location#Equal(a, b) } 
  true
     ==> (DiskLayout.Location#Equal(a, b)
       <==> DiskLayout.Location.addr(a) == DiskLayout.Location.addr(b)
         && DiskLayout.Location.len(a) == DiskLayout.Location.len(b)));

// Datatype extensionality axiom: DiskLayout.Location
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { DiskLayout.Location#Equal(a, b) } 
  DiskLayout.Location#Equal(a, b) <==> a == b);

const unique class.DiskLayout.Location: ClassName;

const unique class.DiskLayout.__default: ClassName;

function Tclass.DiskLayout.__default() : Ty;

// Tclass.DiskLayout.__default Tag
axiom Tag(Tclass.DiskLayout.__default()) == Tagclass.DiskLayout.__default;

const unique Tagclass.DiskLayout.__default: TyTag;

// Box/unbox axiom for Tclass.DiskLayout.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.DiskLayout.__default()) } 
  $IsBox(bx, Tclass.DiskLayout.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.DiskLayout.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.DiskLayout.__default()) } 
  $Is($o, Tclass.DiskLayout.__default())
     <==> $o == null || dtype($o) == Tclass.DiskLayout.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.DiskLayout.__default(), $h) } 
  $IsAlloc($o, Tclass.DiskLayout.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for DiskLayout._default.NumJournalBlocks
function DiskLayout.__default.NumJournalBlocks() : int;

function DiskLayout.__default.NumJournalBlocks#canCall() : bool;

// consequence axiom for DiskLayout.__default.NumJournalBlocks
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.NumJournalBlocks()
     && DiskLayout.__default.NumJournalBlocks() < 18446744073709551616;

function DiskLayout.__default.NumJournalBlocks#requires() : bool;

// #requires axiom for DiskLayout.__default.NumJournalBlocks
axiom DiskLayout.__default.NumJournalBlocks#requires() == true;

// definition axiom for DiskLayout.__default.NumJournalBlocks(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && DiskLayout.__default.NumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// definition axiom for DiskLayout.__default.NumJournalBlocks for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.DiskNumJournalBlocksUint64#canCall()
     && DiskLayout.__default.NumJournalBlocks()
       == LitInt(Bounds.__default.DiskNumJournalBlocksUint64());

// function declaration for DiskLayout._default.IndirectionTableMaxLength
function DiskLayout.__default.IndirectionTableMaxLength() : int;

function DiskLayout.__default.IndirectionTableMaxLength#canCall() : bool;

// consequence axiom for DiskLayout.__default.IndirectionTableMaxLength
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.IndirectionTableMaxLength()
     && DiskLayout.__default.IndirectionTableMaxLength() < 18446744073709551616;

function DiskLayout.__default.IndirectionTableMaxLength#requires() : bool;

// #requires axiom for DiskLayout.__default.IndirectionTableMaxLength
axiom DiskLayout.__default.IndirectionTableMaxLength#requires() == true;

// definition axiom for DiskLayout.__default.IndirectionTableMaxLength(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// definition axiom for DiskLayout.__default.IndirectionTableMaxLength for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableBlockSizeUint64#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength()
       == LitInt(Bounds.__default.IndirectionTableBlockSizeUint64());

// function declaration for DiskLayout._default.IndirectionTable1Addr
function DiskLayout.__default.IndirectionTable1Addr() : int;

function DiskLayout.__default.IndirectionTable1Addr#canCall() : bool;

// consequence axiom for DiskLayout.__default.IndirectionTable1Addr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.IndirectionTable1Addr()
     && DiskLayout.__default.IndirectionTable1Addr() < 18446744073709551616;

function DiskLayout.__default.IndirectionTable1Addr#requires() : bool;

// #requires axiom for DiskLayout.__default.IndirectionTable1Addr
axiom DiskLayout.__default.IndirectionTable1Addr#requires() == true;

// definition axiom for DiskLayout.__default.IndirectionTable1Addr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.IndirectionTable1Addr()
       == LitInt(Mul(LitInt(2), LitInt(4096))
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// definition axiom for DiskLayout.__default.IndirectionTable1Addr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.IndirectionTable1Addr()
       == LitInt(Mul(LitInt(2), LitInt(4096))
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// function declaration for DiskLayout._default.IndirectionTable2Addr
function DiskLayout.__default.IndirectionTable2Addr() : int;

function DiskLayout.__default.IndirectionTable2Addr#canCall() : bool;

// consequence axiom for DiskLayout.__default.IndirectionTable2Addr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.IndirectionTable2Addr()
     && DiskLayout.__default.IndirectionTable2Addr() < 18446744073709551616;

function DiskLayout.__default.IndirectionTable2Addr#requires() : bool;

// #requires axiom for DiskLayout.__default.IndirectionTable2Addr
axiom DiskLayout.__default.IndirectionTable2Addr#requires() == true;

// definition axiom for DiskLayout.__default.IndirectionTable2Addr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength#canCall()
     && DiskLayout.__default.IndirectionTable2Addr()
       == LitInt(DiskLayout.__default.IndirectionTable1Addr()
           + DiskLayout.__default.IndirectionTableMaxLength());

// definition axiom for DiskLayout.__default.IndirectionTable2Addr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
     && DiskLayout.__default.IndirectionTableMaxLength#canCall()
     && DiskLayout.__default.IndirectionTable2Addr()
       == LitInt(DiskLayout.__default.IndirectionTable1Addr()
           + DiskLayout.__default.IndirectionTableMaxLength());

// function declaration for DiskLayout._default.JournalStartAddr
function DiskLayout.__default.JournalStartAddr() : int;

function DiskLayout.__default.JournalStartAddr#canCall() : bool;

// consequence axiom for DiskLayout.__default.JournalStartAddr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.JournalStartAddr()
     && DiskLayout.__default.JournalStartAddr() < 18446744073709551616;

function DiskLayout.__default.JournalStartAddr#requires() : bool;

// #requires axiom for DiskLayout.__default.JournalStartAddr
axiom DiskLayout.__default.JournalStartAddr#requires() == true;

// definition axiom for DiskLayout.__default.JournalStartAddr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr() == LitInt(Mul(LitInt(2), LitInt(4096)));

// definition axiom for DiskLayout.__default.JournalStartAddr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr() == LitInt(Mul(LitInt(2), LitInt(4096)));

// function declaration for DiskLayout._default.JournalEndAddr
function DiskLayout.__default.JournalEndAddr() : int;

function DiskLayout.__default.JournalEndAddr#canCall() : bool;

// consequence axiom for DiskLayout.__default.JournalEndAddr
axiom true
   ==> 
  true
   ==> LitInt(0) <= DiskLayout.__default.JournalEndAddr()
     && DiskLayout.__default.JournalEndAddr() < 18446744073709551616;

function DiskLayout.__default.JournalEndAddr#requires() : bool;

// #requires axiom for DiskLayout.__default.JournalEndAddr
axiom DiskLayout.__default.JournalEndAddr#requires() == true;

// definition axiom for DiskLayout.__default.JournalEndAddr(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr#canCall()
     && DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.JournalEndAddr()
       == LitInt(DiskLayout.__default.JournalStartAddr()
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// definition axiom for DiskLayout.__default.JournalEndAddr for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.JournalStartAddr#canCall()
     && DiskLayout.__default.NumJournalBlocks#canCall()
     && DiskLayout.__default.JournalEndAddr()
       == LitInt(DiskLayout.__default.JournalStartAddr()
           + Mul(LitInt(DiskLayout.__default.NumJournalBlocks()), LitInt(4096)));

// function declaration for DiskLayout._default.JournalPoint
function DiskLayout.__default.JournalPoint(point#0: int) : int;

function DiskLayout.__default.JournalPoint#canCall(point#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalPoint
axiom true
   ==> (forall point#0: int :: 
    { DiskLayout.__default.JournalPoint(point#0) } 
    DiskLayout.__default.JournalPoint#canCall(point#0)
         || (
          LitInt(0) <= point#0
           && point#0 < 18446744073709551616
           && point#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> LitInt(0) <= DiskLayout.__default.JournalPoint(point#0)
         && DiskLayout.__default.JournalPoint(point#0) < 18446744073709551616);

function DiskLayout.__default.JournalPoint#requires(int) : bool;

// #requires axiom for DiskLayout.__default.JournalPoint
axiom (forall point#0: int :: 
  { DiskLayout.__default.JournalPoint#requires(point#0) } 
  LitInt(0) <= point#0 && point#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalPoint#requires(point#0)
       == (point#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.JournalPoint(revealed)
axiom true
   ==> (forall point#0: int :: 
    { DiskLayout.__default.JournalPoint(point#0) } 
    DiskLayout.__default.JournalPoint#canCall(point#0)
         || (
          LitInt(0) <= point#0
           && point#0 < 18446744073709551616
           && point#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalStartAddr#canCall()
         && DiskLayout.__default.JournalPoint(point#0)
           == DiskLayout.__default.JournalStartAddr() + Mul(point#0, LitInt(4096)));

// definition axiom for DiskLayout.__default.JournalPoint for all literals(revealed)
axiom true
   ==> (forall point#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalPoint(LitInt(point#0)) } 
    DiskLayout.__default.JournalPoint#canCall(LitInt(point#0))
         || (
          LitInt(0) <= point#0
           && point#0 < 18446744073709551616
           && LitInt(point#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalStartAddr#canCall()
         && DiskLayout.__default.JournalPoint(LitInt(point#0))
           == LitInt(DiskLayout.__default.JournalStartAddr() + Mul(LitInt(point#0), LitInt(4096))));

// function declaration for DiskLayout._default.ValidIndirectionTableAddr
function DiskLayout.__default.ValidIndirectionTableAddr(addr#0: int) : bool;

function DiskLayout.__default.ValidIndirectionTableAddr#canCall(addr#0: int) : bool;

// consequence axiom for DiskLayout.__default.ValidIndirectionTableAddr
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.ValidIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.ValidIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> true);

function DiskLayout.__default.ValidIndirectionTableAddr#requires(int) : bool;

// #requires axiom for DiskLayout.__default.ValidIndirectionTableAddr
axiom (forall addr#0: int :: 
  { DiskLayout.__default.ValidIndirectionTableAddr#requires(addr#0) } 
  LitInt(0) <= addr#0 && addr#0 < 18446744073709551616
     ==> DiskLayout.__default.ValidIndirectionTableAddr#requires(addr#0) == true);

// definition axiom for DiskLayout.__default.ValidIndirectionTableAddr(revealed)
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.ValidIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.ValidIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> (Lit(true)
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
             && (addr#0 != LitInt(DiskLayout.__default.IndirectionTable1Addr())
               ==> DiskLayout.__default.IndirectionTable2Addr#canCall()))
         && DiskLayout.__default.ValidIndirectionTableAddr(addr#0)
           == (true
             && (addr#0 == LitInt(DiskLayout.__default.IndirectionTable1Addr())
               || addr#0 == LitInt(DiskLayout.__default.IndirectionTable2Addr()))));

// definition axiom for DiskLayout.__default.ValidIndirectionTableAddr for all literals(revealed)
axiom true
   ==> (forall addr#0: int :: 
    {:weight 3} { DiskLayout.__default.ValidIndirectionTableAddr(LitInt(addr#0)) } 
    DiskLayout.__default.ValidIndirectionTableAddr#canCall(LitInt(addr#0))
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> (Lit(true)
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
             && (LitInt(addr#0) != LitInt(DiskLayout.__default.IndirectionTable1Addr())
               ==> DiskLayout.__default.IndirectionTable2Addr#canCall()))
         && DiskLayout.__default.ValidIndirectionTableAddr(LitInt(addr#0))
           == (true
             && (LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable1Addr())
               || LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable2Addr()))));

// function declaration for DiskLayout._default.ValidNodeAddr
function DiskLayout.__default.ValidNodeAddr($ly: LayerType, addr#0: int) : bool;

function DiskLayout.__default.ValidNodeAddr#canCall(addr#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, addr#0: int :: 
  { DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0) } 
  DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0)
     == DiskLayout.__default.ValidNodeAddr($ly, addr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, addr#0: int :: 
  { DiskLayout.__default.ValidNodeAddr(AsFuelBottom($ly), addr#0) } 
  DiskLayout.__default.ValidNodeAddr($ly, addr#0)
     == DiskLayout.__default.ValidNodeAddr($LZ, addr#0));

// consequence axiom for DiskLayout.__default.ValidNodeAddr
axiom true
   ==> (forall $ly: LayerType, addr#0: int :: 
    { DiskLayout.__default.ValidNodeAddr($ly, addr#0) } 
    DiskLayout.__default.ValidNodeAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> true);

function DiskLayout.__default.ValidNodeAddr#requires(LayerType, int) : bool;

// #requires axiom for DiskLayout.__default.ValidNodeAddr
axiom (forall $ly: LayerType, addr#0: int :: 
  { DiskLayout.__default.ValidNodeAddr#requires($ly, addr#0) } 
  LitInt(0) <= addr#0 && addr#0 < 18446744073709551616
     ==> DiskLayout.__default.ValidNodeAddr#requires($ly, addr#0) == true);

// definition axiom for DiskLayout.__default.ValidNodeAddr(revealed)
axiom true
   ==> (forall $ly: LayerType, addr#0: int :: 
    { DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0) } 
    DiskLayout.__default.ValidNodeAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> Bounds.__default.NodeBlockSizeUint64#canCall()
         && (Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64())) == LitInt(0)
           ==> Bounds.__default.NodeBlockSizeUint64#canCall()
             && Bounds.__default.MinNodeBlockIndexUint64#canCall())
         && DiskLayout.__default.ValidNodeAddr($LS($ly), addr#0)
           == (Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64())) == LitInt(0)
             && addr#0
               >= LitInt(Mul(LitInt(Bounds.__default.NodeBlockSizeUint64()), 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())))));

// definition axiom for DiskLayout.__default.ValidNodeAddr for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, addr#0: int :: 
    {:weight 3} { DiskLayout.__default.ValidNodeAddr($LS($ly), LitInt(addr#0)) } 
    DiskLayout.__default.ValidNodeAddr#canCall(LitInt(addr#0))
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> Bounds.__default.NodeBlockSizeUint64#canCall()
         && (LitInt(Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64()))) == LitInt(0)
           ==> Bounds.__default.NodeBlockSizeUint64#canCall()
             && Bounds.__default.MinNodeBlockIndexUint64#canCall())
         && DiskLayout.__default.ValidNodeAddr($LS($ly), LitInt(addr#0))
           == (LitInt(Mod(addr#0, LitInt(Bounds.__default.NodeBlockSizeUint64()))) == LitInt(0)
             && LitInt(addr#0)
               >= LitInt(Mul(LitInt(Bounds.__default.NodeBlockSizeUint64()), 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())))));

// function declaration for DiskLayout._default.ValidJournalLocation
function DiskLayout.__default.ValidJournalLocation($ly: LayerType, loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidJournalLocation#canCall(loc#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0) } 
  DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0)
     == DiskLayout.__default.ValidJournalLocation($ly, loc#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidJournalLocation(AsFuelBottom($ly), loc#0) } 
  DiskLayout.__default.ValidJournalLocation($ly, loc#0)
     == DiskLayout.__default.ValidJournalLocation($LZ, loc#0));

// consequence axiom for DiskLayout.__default.ValidJournalLocation
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidJournalLocation($ly, loc#0) } 
    DiskLayout.__default.ValidJournalLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> true);

function DiskLayout.__default.ValidJournalLocation#requires(LayerType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidJournalLocation
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidJournalLocation#requires($ly, loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidJournalLocation#requires($ly, loc#0) == true);

// definition axiom for DiskLayout.__default.ValidJournalLocation(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0) } 
    DiskLayout.__default.ValidJournalLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(loc#0)
         && (Mod(DiskLayout.Location.addr(loc#0), LitInt(4096)) == LitInt(0)
           ==> DiskLayout.Location.Location_q(loc#0))
         && (DiskLayout.Location.Location_q(loc#0)
             && Mod(DiskLayout.Location.len(loc#0), LitInt(4096)) == LitInt(0)
           ==> DiskLayout.Location.Location_q(loc#0))
         && (DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.addr(loc#0) >= LitInt(Mul(LitInt(2), LitInt(4096)))
           ==> DiskLayout.Location.Location_q(loc#0)
             && (LitInt(0)
                 <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (DiskLayout.Location.Location_q(loc#0)
             && (LitInt(0)
                 <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
             && Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
           ==> DiskLayout.Location.Location_q(loc#0) && DiskLayout.Location.Location_q(loc#0))
         && (DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.addr(loc#0)
               <= 18446744073709551615 - DiskLayout.Location.len(loc#0)
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.ValidJournalLocation($LS($ly), loc#0)
           == (
            Mod(DiskLayout.Location.addr(loc#0), LitInt(4096)) == LitInt(0)
             && Mod(DiskLayout.Location.len(loc#0), LitInt(4096)) == LitInt(0)
             && DiskLayout.Location.addr(loc#0) >= LitInt(Mul(LitInt(2), LitInt(4096)))
             && 
            LitInt(0)
               <= Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
             && Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
             && DiskLayout.Location.addr(loc#0)
               <= 18446744073709551615 - DiskLayout.Location.len(loc#0)
             && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               <= LitInt(Mul(LitInt(2 + DiskLayout.__default.NumJournalBlocks()), LitInt(4096)))));

// definition axiom for DiskLayout.__default.ValidJournalLocation for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidJournalLocation($LS($ly), Lit(loc#0)) } 
    DiskLayout.__default.ValidJournalLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && (LitInt(Mod(DiskLayout.Location.addr(Lit(loc#0)), LitInt(4096))) == LitInt(0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0)))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && LitInt(Mod(DiskLayout.Location.len(Lit(loc#0)), LitInt(4096))) == LitInt(0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0)))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               >= LitInt(Mul(LitInt(2), LitInt(4096)))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && (LitInt(0)
                 <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                    LitInt(4096)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && (LitInt(0)
                 <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                    LitInt(4096)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                  LitInt(4096)))
             && Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0)))
         && (DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               <= LitInt(18446744073709551615 - DiskLayout.Location.len(Lit(loc#0)))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.ValidJournalLocation($LS($ly), Lit(loc#0))
           == (
            LitInt(Mod(DiskLayout.Location.addr(Lit(loc#0)), LitInt(4096))) == LitInt(0)
             && LitInt(Mod(DiskLayout.Location.len(Lit(loc#0)), LitInt(4096))) == LitInt(0)
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               >= LitInt(Mul(LitInt(2), LitInt(4096)))
             && 
            LitInt(0)
               <= LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                  LitInt(4096)))
             && Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
                LitInt(4096))
               < DiskLayout.__default.NumJournalBlocks()
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               <= LitInt(18446744073709551615 - DiskLayout.Location.len(Lit(loc#0)))
             && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               <= LitInt(Mul(LitInt(2 + DiskLayout.__default.NumJournalBlocks()), LitInt(4096)))));

// function declaration for DiskLayout._default.ValidIndirectionTableLocation
function DiskLayout.__default.ValidIndirectionTableLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidIndirectionTableLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidIndirectionTableLocation(loc#0) } 
    DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> 
      DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
       ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0));

function DiskLayout.__default.ValidIndirectionTableLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidIndirectionTableLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidIndirectionTableLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidIndirectionTableLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidIndirectionTableLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidIndirectionTableLocation(loc#0) } 
    DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.__default.ValidIndirectionTableAddr#canCall(DiskLayout.Location.addr(loc#0))
         && (DiskLayout.__default.ValidIndirectionTableAddr(DiskLayout.Location.addr(loc#0))
           ==> DiskLayout.Location.Location_q(loc#0)
             && (0 < DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.IndirectionTableMaxLength#canCall()))
         && DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
           == (DiskLayout.__default.ValidIndirectionTableAddr(DiskLayout.Location.addr(loc#0))
             && 
            0 < DiskLayout.Location.len(loc#0)
             && DiskLayout.Location.len(loc#0)
               <= LitInt(DiskLayout.__default.IndirectionTableMaxLength())));

// definition axiom for DiskLayout.__default.ValidIndirectionTableLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.__default.ValidIndirectionTableAddr#canCall(LitInt(DiskLayout.Location.addr(Lit(loc#0))))
         && (Lit(DiskLayout.__default.ValidIndirectionTableAddr(LitInt(DiskLayout.Location.addr(Lit(loc#0)))))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && (Lit(0 < DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.IndirectionTableMaxLength#canCall()))
         && DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0))
           == (DiskLayout.__default.ValidIndirectionTableAddr(LitInt(DiskLayout.Location.addr(Lit(loc#0))))
             && 
            0 < DiskLayout.Location.len(Lit(loc#0))
             && LitInt(DiskLayout.Location.len(Lit(loc#0)))
               <= LitInt(DiskLayout.__default.IndirectionTableMaxLength())));

// function declaration for DiskLayout._default.ValidNodeLocation
function DiskLayout.__default.ValidNodeLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidNodeLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidNodeLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidNodeLocation(loc#0) } 
    DiskLayout.__default.ValidNodeLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> (DiskLayout.__default.ValidNodeLocation(loc#0)
           ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
         && (DiskLayout.__default.ValidNodeLocation(loc#0)
           ==> !DiskLayout.__default.ValidIndirectionTableLocation(loc#0)));

function DiskLayout.__default.ValidNodeLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidNodeLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidNodeLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidNodeLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidNodeLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidNodeLocation(loc#0) } 
    DiskLayout.__default.ValidNodeLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.__default.ValidNodeAddr#canCall(DiskLayout.Location.addr(loc#0))
         && (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, DiskLayout.Location.addr(loc#0))
           ==> DiskLayout.Location.Location_q(loc#0)
             && Bounds.__default.NodeBlockSizeUint64#canCall())
         && DiskLayout.__default.ValidNodeLocation(loc#0)
           == (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, DiskLayout.Location.addr(loc#0))
             && DiskLayout.Location.len(loc#0) <= LitInt(Bounds.__default.NodeBlockSizeUint64())));

// definition axiom for DiskLayout.__default.ValidNodeLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidNodeLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidNodeLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.__default.ValidNodeAddr#canCall(LitInt(DiskLayout.Location.addr(Lit(loc#0))))
         && (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, 
            LitInt(DiskLayout.Location.addr(Lit(loc#0))))
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && Bounds.__default.NodeBlockSizeUint64#canCall())
         && DiskLayout.__default.ValidNodeLocation(Lit(loc#0))
           == (DiskLayout.__default.ValidNodeAddr(StartFuel_DiskLayout._default.ValidNodeAddr, 
              LitInt(DiskLayout.Location.addr(Lit(loc#0))))
             && LitInt(DiskLayout.Location.len(Lit(loc#0)))
               <= LitInt(Bounds.__default.NodeBlockSizeUint64())));

// function declaration for DiskLayout._default.Superblock1Location
function DiskLayout.__default.Superblock1Location() : DatatypeType;

function DiskLayout.__default.Superblock1Location#canCall() : bool;

// consequence axiom for DiskLayout.__default.Superblock1Location
axiom true
   ==> 
  true
   ==> !Lit(DiskLayout.__default.ValidNodeLocation(Lit(DiskLayout.__default.Superblock1Location())))
     && !Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(DiskLayout.__default.Superblock1Location())))
     && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, 
      Lit(DiskLayout.__default.Superblock1Location()))
     && $Is(DiskLayout.__default.Superblock1Location(), Tclass.DiskLayout.Location());

function DiskLayout.__default.Superblock1Location#requires() : bool;

// #requires axiom for DiskLayout.__default.Superblock1Location
axiom DiskLayout.__default.Superblock1Location#requires() == true;

// definition axiom for DiskLayout.__default.Superblock1Location(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock1Location()
     == Lit(#DiskLayout.Location.Location(LitInt(0), LitInt(4096)));

// definition axiom for DiskLayout.__default.Superblock1Location for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock1Location()
     == Lit(#DiskLayout.Location.Location(LitInt(0), LitInt(4096)));

// function declaration for DiskLayout._default.Superblock2Location
function DiskLayout.__default.Superblock2Location() : DatatypeType;

function DiskLayout.__default.Superblock2Location#canCall() : bool;

// consequence axiom for DiskLayout.__default.Superblock2Location
axiom true
   ==> 
  true
   ==> !Lit(DiskLayout.__default.ValidNodeLocation(Lit(DiskLayout.__default.Superblock2Location())))
     && !Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(DiskLayout.__default.Superblock2Location())))
     && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, 
      Lit(DiskLayout.__default.Superblock2Location()))
     && $Is(DiskLayout.__default.Superblock2Location(), Tclass.DiskLayout.Location());

function DiskLayout.__default.Superblock2Location#requires() : bool;

// #requires axiom for DiskLayout.__default.Superblock2Location
axiom DiskLayout.__default.Superblock2Location#requires() == true;

// definition axiom for DiskLayout.__default.Superblock2Location(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock2Location()
     == Lit(#DiskLayout.Location.Location(LitInt(4096), LitInt(4096)));

// definition axiom for DiskLayout.__default.Superblock2Location for all literals(revealed)
axiom true
   ==> 
  true
   ==> DiskLayout.__default.Superblock2Location()
     == Lit(#DiskLayout.Location.Location(LitInt(4096), LitInt(4096)));

// function declaration for DiskLayout._default.ValidSuperblock1Location
function DiskLayout.__default.ValidSuperblock1Location(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidSuperblock1Location
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock1Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> (DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
         && (DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> !DiskLayout.__default.ValidIndirectionTableLocation(loc#0))
         && (DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> !DiskLayout.__default.ValidNodeLocation(loc#0)));

function DiskLayout.__default.ValidSuperblock1Location#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidSuperblock1Location
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidSuperblock1Location#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidSuperblock1Location#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidSuperblock1Location(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock1Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(loc#0)
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && DiskLayout.__default.ValidSuperblock1Location(loc#0)
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location()));

// definition axiom for DiskLayout.__default.ValidSuperblock1Location for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0)) } 
    DiskLayout.__default.ValidSuperblock1Location#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(Lit(loc#0))
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0))
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location()));

// function declaration for DiskLayout._default.ValidSuperblock2Location
function DiskLayout.__default.ValidSuperblock2Location(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidSuperblock2Location
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock2Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> (DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
         && (DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> !DiskLayout.__default.ValidIndirectionTableLocation(loc#0))
         && (DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> !DiskLayout.__default.ValidNodeLocation(loc#0)));

function DiskLayout.__default.ValidSuperblock2Location#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidSuperblock2Location
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidSuperblock2Location#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidSuperblock2Location#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidSuperblock2Location(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblock2Location(loc#0) } 
    DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(loc#0)
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
         && DiskLayout.__default.Superblock2Location#canCall()
         && DiskLayout.__default.ValidSuperblock2Location(loc#0)
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location()));

// definition axiom for DiskLayout.__default.ValidSuperblock2Location for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0)) } 
    DiskLayout.__default.ValidSuperblock2Location#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(Lit(loc#0))
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
         && DiskLayout.__default.Superblock2Location#canCall()
         && DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0))
           == DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location()));

// function declaration for DiskLayout._default.ValidSuperblockLocation
function DiskLayout.__default.ValidSuperblockLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidSuperblockLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidSuperblockLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblockLocation(loc#0) } 
    DiskLayout.__default.ValidSuperblockLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> 
      DiskLayout.__default.ValidSuperblockLocation(loc#0)
       ==> DiskLayout.__default.ValidSuperblock1Location(loc#0)
         || DiskLayout.__default.ValidSuperblock2Location(loc#0));

function DiskLayout.__default.ValidSuperblockLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidSuperblockLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidSuperblockLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidSuperblockLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidSuperblockLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidSuperblockLocation(loc#0) } 
    DiskLayout.__default.ValidSuperblockLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(loc#0)
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && (!DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
           ==> $IsA#DiskLayout.Location(loc#0)
             && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
             && DiskLayout.__default.Superblock2Location#canCall())
         && DiskLayout.__default.ValidSuperblockLocation(loc#0)
           == (DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
             || DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location())));

// definition axiom for DiskLayout.__default.ValidSuperblockLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidSuperblockLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidSuperblockLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> $IsA#DiskLayout.Location(Lit(loc#0))
         && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock1Location()))
         && DiskLayout.__default.Superblock1Location#canCall()
         && (!DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
           ==> $IsA#DiskLayout.Location(Lit(loc#0))
             && $IsA#DiskLayout.Location(Lit(DiskLayout.__default.Superblock2Location()))
             && DiskLayout.__default.Superblock2Location#canCall())
         && DiskLayout.__default.ValidSuperblockLocation(Lit(loc#0))
           == (DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock1Location())
             || DiskLayout.Location#Equal(loc#0, DiskLayout.__default.Superblock2Location())));

// function declaration for DiskLayout._default.ValidLocation
function DiskLayout.__default.ValidLocation(loc#0: DatatypeType) : bool;

function DiskLayout.__default.ValidLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.ValidLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidLocation(loc#0) } 
    DiskLayout.__default.ValidLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> true);

function DiskLayout.__default.ValidLocation#requires(DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.ValidLocation
axiom (forall loc#0: DatatypeType :: 
  { DiskLayout.__default.ValidLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.ValidLocation#requires(loc#0) == true);

// definition axiom for DiskLayout.__default.ValidLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { DiskLayout.__default.ValidLocation(loc#0) } 
    DiskLayout.__default.ValidLocation#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.__default.ValidSuperblock1Location#canCall(loc#0)
         && (!DiskLayout.__default.ValidSuperblock1Location(loc#0)
           ==> DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0))
         && (DiskLayout.__default.ValidSuperblock2Location#canCall(loc#0)
             && !DiskLayout.__default.ValidSuperblock2Location(loc#0)
           ==> DiskLayout.__default.ValidJournalLocation#canCall(loc#0))
         && (DiskLayout.__default.ValidJournalLocation#canCall(loc#0)
             && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0)
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
             && !DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
           ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0))
         && DiskLayout.__default.ValidLocation(loc#0)
           == (
            DiskLayout.__default.ValidSuperblock1Location(loc#0)
             || DiskLayout.__default.ValidSuperblock2Location(loc#0)
             || DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0)
             || DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
             || DiskLayout.__default.ValidNodeLocation(loc#0)));

// definition axiom for DiskLayout.__default.ValidLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.ValidLocation(Lit(loc#0)) } 
    DiskLayout.__default.ValidLocation#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> DiskLayout.__default.ValidSuperblock1Location#canCall(Lit(loc#0))
         && (!Lit(DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0)))
           ==> DiskLayout.__default.ValidSuperblock2Location#canCall(Lit(loc#0)))
         && (DiskLayout.__default.ValidSuperblock2Location#canCall(Lit(loc#0))
             && !Lit(DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0)))
           ==> DiskLayout.__default.ValidJournalLocation#canCall(Lit(loc#0)))
         && (DiskLayout.__default.ValidJournalLocation#canCall(Lit(loc#0))
             && !DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(loc#0)))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(loc#0))
             && !Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0)))
           ==> DiskLayout.__default.ValidNodeLocation#canCall(Lit(loc#0)))
         && DiskLayout.__default.ValidLocation(Lit(loc#0))
           == (
            DiskLayout.__default.ValidSuperblock1Location(Lit(loc#0))
             || DiskLayout.__default.ValidSuperblock2Location(Lit(loc#0))
             || DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0))
             || DiskLayout.__default.ValidIndirectionTableLocation(Lit(loc#0))
             || DiskLayout.__default.ValidNodeLocation(Lit(loc#0))));

// function declaration for DiskLayout._default.overlap
function DiskLayout.__default.overlap(loc#0: DatatypeType, loc'#0: DatatypeType) : bool;

function DiskLayout.__default.overlap#canCall(loc#0: DatatypeType, loc'#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.overlap
axiom true
   ==> (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
    { DiskLayout.__default.overlap(loc#0, loc'#0) } 
    DiskLayout.__default.overlap#canCall(loc#0, loc'#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(loc'#0, Tclass.DiskLayout.Location()))
       ==> true);

function DiskLayout.__default.overlap#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.overlap
axiom (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
  { DiskLayout.__default.overlap#requires(loc#0, loc'#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && $Is(loc'#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.overlap#requires(loc#0, loc'#0) == true);

// definition axiom for DiskLayout.__default.overlap(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
    { DiskLayout.__default.overlap(loc#0, loc'#0) } 
    DiskLayout.__default.overlap#canCall(loc#0, loc'#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(loc'#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.Location.Location_q(loc#0)
         && DiskLayout.Location.Location_q(loc'#0)
         && (DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
             > DiskLayout.Location.addr(loc'#0)
           ==> DiskLayout.Location.Location_q(loc'#0)
             && DiskLayout.Location.Location_q(loc'#0)
             && DiskLayout.Location.Location_q(loc#0))
         && DiskLayout.__default.overlap(loc#0, loc'#0)
           == (DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               > DiskLayout.Location.addr(loc'#0)
             && DiskLayout.Location.addr(loc'#0) + DiskLayout.Location.len(loc'#0)
               > DiskLayout.Location.addr(loc#0)));

// definition axiom for DiskLayout.__default.overlap for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, loc'#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.overlap(Lit(loc#0), Lit(loc'#0)) } 
    DiskLayout.__default.overlap#canCall(Lit(loc#0), Lit(loc'#0))
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(loc'#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.Location.Location_q(Lit(loc#0))
         && DiskLayout.Location.Location_q(Lit(loc'#0))
         && (Lit(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0))
               > DiskLayout.Location.addr(Lit(loc'#0)))
           ==> DiskLayout.Location.Location_q(Lit(loc'#0))
             && DiskLayout.Location.Location_q(Lit(loc'#0))
             && DiskLayout.Location.Location_q(Lit(loc#0)))
         && DiskLayout.__default.overlap(Lit(loc#0), Lit(loc'#0))
           == Lit(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0))
                 > DiskLayout.Location.addr(Lit(loc'#0))
               && DiskLayout.Location.addr(Lit(loc'#0)) + DiskLayout.Location.len(Lit(loc'#0))
                 > DiskLayout.Location.addr(Lit(loc#0))));

// function declaration for DiskLayout._default.JournalRangeLocation
function DiskLayout.__default.JournalRangeLocation(start#0: int, len#0: int) : DatatypeType;

function DiskLayout.__default.JournalRangeLocation#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalRangeLocation
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalRangeLocation(start#0, len#0) } 
    DiskLayout.__default.JournalRangeLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, 
          DiskLayout.__default.JournalRangeLocation(start#0, len#0))
         && $Is(DiskLayout.__default.JournalRangeLocation(start#0, len#0), 
          Tclass.DiskLayout.Location()));

function DiskLayout.__default.JournalRangeLocation#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalRangeLocation
axiom (forall start#0: int, len#0: int :: 
  { DiskLayout.__default.JournalRangeLocation#requires(start#0, len#0) } 
  LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalRangeLocation#requires(start#0, len#0)
       == (start#0 < DiskLayout.__default.NumJournalBlocks()
         && start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

const MoreFuel_DiskLayout._default.ValidJournalLocation0: LayerType;

// definition axiom for DiskLayout.__default.JournalRangeLocation(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalRangeLocation(start#0, len#0) } 
    DiskLayout.__default.JournalRangeLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalPoint#canCall(start#0)
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation0)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation0))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation0)
           == MoreFuel_DiskLayout._default.ValidJournalLocation0
         && DiskLayout.__default.JournalRangeLocation(start#0, len#0)
           == #DiskLayout.Location.Location(DiskLayout.__default.JournalPoint(start#0), Mul(len#0, LitInt(4096))));

const MoreFuel_DiskLayout._default.ValidJournalLocation1: LayerType;

// definition axiom for DiskLayout.__default.JournalRangeLocation for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalRangeLocation(LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.JournalRangeLocation#canCall(LitInt(start#0), LitInt(len#0))
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Lit(start#0 < DiskLayout.__default.NumJournalBlocks())
           && LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation1)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation1))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation1)
           == MoreFuel_DiskLayout._default.ValidJournalLocation1
         && DiskLayout.__default.JournalRangeLocation(LitInt(start#0), LitInt(len#0))
           == Lit(#DiskLayout.Location.Location(LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0))), 
              LitInt(Mul(LitInt(len#0), LitInt(4096))))));

// function declaration for DiskLayout._default.locContainedInCircularJournalRange
function DiskLayout.__default.locContainedInCircularJournalRange(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

function DiskLayout.__default.locContainedInCircularJournalRange#canCall(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.locContainedInCircularJournalRange
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locContainedInCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locContainedInCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> true);

function DiskLayout.__default.locContainedInCircularJournalRange#requires(DatatypeType, int, int) : bool;

// #requires axiom for DiskLayout.__default.locContainedInCircularJournalRange
axiom (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
  { DiskLayout.__default.locContainedInCircularJournalRange#requires(loc#0, start#0, len#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.locContainedInCircularJournalRange#requires(loc#0, start#0, len#0)
       == (
        LitInt(0) <= start#0
         && start#0 < DiskLayout.__default.NumJournalBlocks()
         && 
        LitInt(0) <= len#0
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.locContainedInCircularJournalRange(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locContainedInCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locContainedInCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(start#0)
             && (DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0)))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < start#0 + len#0
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(start#0)
             && (DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   < DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
                 && (DiskLayout.Location.addr(loc#0)
                     >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                   ==> DiskLayout.Location.Location_q(loc#0)
                     && DiskLayout.Location.Location_q(loc#0)
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))))
         && DiskLayout.__default.locContainedInCircularJournalRange(loc#0, start#0, len#0)
           == (if start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
               && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                 <= DiskLayout.__default.JournalPoint(start#0 + len#0)
             else (DiskLayout.Location.addr(loc#0) >= DiskLayout.__default.JournalPoint(start#0)
                 && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks()))))
               || (DiskLayout.Location.addr(loc#0)
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                   <= DiskLayout.__default.JournalPoint(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))));

// definition axiom for DiskLayout.__default.locContainedInCircularJournalRange for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.locContainedInCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.locContainedInCircularJournalRange#canCall(Lit(loc#0), LitInt(start#0), LitInt(len#0))
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
             && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0))))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < LitInt(start#0 + len#0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
             && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   < LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
                 && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                     >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                   ==> DiskLayout.Location.Location_q(Lit(loc#0))
                     && DiskLayout.Location.Location_q(Lit(loc#0))
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())))))
         && DiskLayout.__default.locContainedInCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0))
           == (if LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0)))
             else (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
                 && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks()))))
               || (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))))));

// function declaration for DiskLayout._default.locDisjointFromCircularJournalRange
function DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

function DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(loc#0: DatatypeType, start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.locDisjointFromCircularJournalRange
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> true);

function DiskLayout.__default.locDisjointFromCircularJournalRange#requires(DatatypeType, int, int) : bool;

// #requires axiom for DiskLayout.__default.locDisjointFromCircularJournalRange
axiom (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
  { DiskLayout.__default.locDisjointFromCircularJournalRange#requires(loc#0, start#0, len#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && 
      LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.locDisjointFromCircularJournalRange#requires(loc#0, start#0, len#0)
       == (
        LitInt(0) <= start#0
         && start#0 < DiskLayout.__default.NumJournalBlocks()
         && 
        LitInt(0) <= len#0
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.locDisjointFromCircularJournalRange(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    { DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0, start#0, len#0) } 
    DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(loc#0, start#0, len#0)
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= start#0
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= len#0
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(start#0)
             && (DiskLayout.__default.JournalPoint(start#0)
                 < DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0)))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < start#0 + len#0
           ==> DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.Location.Location_q(loc#0)
             && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
             && (LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 < DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   > DiskLayout.Location.addr(loc#0)
               ==> DiskLayout.Location.Location_q(loc#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())
                 && (DiskLayout.Location.addr(loc#0)
                     >= DiskLayout.__default.JournalPoint(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())
                   ==> DiskLayout.Location.Location_q(loc#0)
                     && DiskLayout.Location.Location_q(loc#0)
                     && DiskLayout.__default.JournalPoint#canCall(start#0))))
         && DiskLayout.__default.locDisjointFromCircularJournalRange(loc#0, start#0, len#0)
           == (if start#0 + len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                 <= DiskLayout.__default.JournalPoint(start#0)
               || DiskLayout.Location.addr(loc#0)
                 >= DiskLayout.__default.JournalPoint(start#0 + len#0)
             else DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
               || DiskLayout.Location.addr(loc#0)
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
               || (DiskLayout.Location.addr(loc#0)
                   >= DiskLayout.__default.JournalPoint(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())
                 && DiskLayout.Location.addr(loc#0) + DiskLayout.Location.len(loc#0)
                   <= DiskLayout.__default.JournalPoint(start#0))));

// definition axiom for DiskLayout.__default.locDisjointFromCircularJournalRange for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.locDisjointFromCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.locDisjointFromCircularJournalRange#canCall(Lit(loc#0), LitInt(start#0), LitInt(len#0))
         || (
          $Is(loc#0, Tclass.DiskLayout.Location())
           && 
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(start#0)
           && start#0 < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= LitInt(len#0)
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0))
             && (LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
                 < LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0))))
         && (LitInt(DiskLayout.__default.NumJournalBlocks()) < LitInt(start#0 + len#0)
           ==> DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.Location.Location_q(Lit(loc#0))
             && DiskLayout.__default.JournalPoint#canCall(LitInt(0))
             && (LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
                 < LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks())))
             && (DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(DiskLayout.__default.NumJournalBlocks()))
                 && LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
                   > LitInt(DiskLayout.Location.addr(Lit(loc#0)))
               ==> DiskLayout.Location.Location_q(Lit(loc#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks()))
                 && (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                     >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())))
                   ==> DiskLayout.Location.Location_q(Lit(loc#0))
                     && DiskLayout.Location.Location_q(Lit(loc#0))
                     && DiskLayout.__default.JournalPoint#canCall(LitInt(start#0)))))
         && DiskLayout.__default.locDisjointFromCircularJournalRange(Lit(loc#0), LitInt(start#0), LitInt(len#0))
           == (if LitInt(start#0 + len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0)))
               || LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0)))
             else LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                 <= LitInt(DiskLayout.__default.JournalPoint(LitInt(0)))
               || LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                 >= LitInt(DiskLayout.__default.JournalPoint(LitInt(DiskLayout.__default.NumJournalBlocks())))
               || (LitInt(DiskLayout.Location.addr(Lit(loc#0)))
                   >= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0 + len#0 - DiskLayout.__default.NumJournalBlocks())))
                 && LitInt(DiskLayout.Location.addr(Lit(loc#0)) + DiskLayout.Location.len(Lit(loc#0)))
                   <= LitInt(DiskLayout.__default.JournalPoint(LitInt(start#0))))));

// function declaration for DiskLayout._default.JournalPosAdd
function DiskLayout.__default.JournalPosAdd(start#0: int, span#0: int) : int;

function DiskLayout.__default.JournalPosAdd#canCall(start#0: int, span#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalPosAdd
axiom true
   ==> (forall start#0: int, span#0: int :: 
    { DiskLayout.__default.JournalPosAdd(start#0, span#0) } 
    true ==> true);

function DiskLayout.__default.JournalPosAdd#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalPosAdd
axiom (forall start#0: int, span#0: int :: 
  { DiskLayout.__default.JournalPosAdd#requires(start#0, span#0) } 
  DiskLayout.__default.JournalPosAdd#requires(start#0, span#0) == true);

// definition axiom for DiskLayout.__default.JournalPosAdd(revealed)
axiom true
   ==> (forall start#0: int, span#0: int :: 
    { DiskLayout.__default.JournalPosAdd(start#0, span#0) } 
    true
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (start#0 + span#0 >= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.JournalPosAdd(start#0, span#0)
           == (if start#0 + span#0 >= LitInt(DiskLayout.__default.NumJournalBlocks())
             then start#0 + span#0 - DiskLayout.__default.NumJournalBlocks()
             else start#0 + span#0));

// definition axiom for DiskLayout.__default.JournalPosAdd for all literals(revealed)
axiom true
   ==> (forall start#0: int, span#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalPosAdd(LitInt(start#0), LitInt(span#0)) } 
    true
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(start#0 + span#0) >= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && DiskLayout.__default.JournalPosAdd(LitInt(start#0), LitInt(span#0))
           == (if LitInt(start#0 + span#0) >= LitInt(DiskLayout.__default.NumJournalBlocks())
             then start#0 + span#0 - DiskLayout.__default.NumJournalBlocks()
             else start#0 + span#0));

// function declaration for DiskLayout._default.JournalFrontLocation
function DiskLayout.__default.JournalFrontLocation(start#0: int, len#0: int) : DatatypeType;

function DiskLayout.__default.JournalFrontLocation#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalFrontLocation
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalFrontLocation(start#0, len#0) } 
    DiskLayout.__default.JournalFrontLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && start#0 < DiskLayout.__default.NumJournalBlocks())
       ==> $Is(DiskLayout.__default.JournalFrontLocation(start#0, len#0), 
        Tclass.Options.Option(Tclass.DiskLayout.Location())));

function DiskLayout.__default.JournalFrontLocation#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalFrontLocation
axiom (forall start#0: int, len#0: int :: 
  { DiskLayout.__default.JournalFrontLocation#requires(start#0, len#0) } 
  LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalFrontLocation#requires(start#0, len#0)
       == (start#0 < DiskLayout.__default.NumJournalBlocks()));

// definition axiom for DiskLayout.__default.JournalFrontLocation(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalFrontLocation(start#0, len#0) } 
    DiskLayout.__default.JournalFrontLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && start#0 < DiskLayout.__default.NumJournalBlocks())
       ==> (len#0 != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks() - start#0 < len#0
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && DiskLayout.__default.JournalRangeLocation#canCall(start#0, 
              (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
                 then len#0
                 else DiskLayout.__default.NumJournalBlocks() - start#0)))
         && DiskLayout.__default.JournalFrontLocation(start#0, len#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.None()
             else #Options.Option.Some($Box(DiskLayout.__default.JournalRangeLocation(start#0, 
                  (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
                     then len#0
                     else DiskLayout.__default.NumJournalBlocks() - start#0))))));

// definition axiom for DiskLayout.__default.JournalFrontLocation for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalFrontLocation(LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.JournalFrontLocation#canCall(LitInt(start#0), LitInt(len#0))
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && Lit(start#0 < DiskLayout.__default.NumJournalBlocks()))
       ==> (LitInt(len#0) != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(DiskLayout.__default.NumJournalBlocks() - start#0) < LitInt(len#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && DiskLayout.__default.JournalRangeLocation#canCall(LitInt(start#0), 
              (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
                 then len#0
                 else DiskLayout.__default.NumJournalBlocks() - start#0)))
         && DiskLayout.__default.JournalFrontLocation(LitInt(start#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.None()
             else #Options.Option.Some($Box(DiskLayout.__default.JournalRangeLocation(LitInt(start#0), 
                  (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
                     then len#0
                     else DiskLayout.__default.NumJournalBlocks() - start#0))))));

// function declaration for DiskLayout._default.JournalBackLocation
function DiskLayout.__default.JournalBackLocation(start#0: int, len#0: int) : DatatypeType;

function DiskLayout.__default.JournalBackLocation#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for DiskLayout.__default.JournalBackLocation
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalBackLocation(start#0, len#0) } 
    DiskLayout.__default.JournalBackLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> $Is(DiskLayout.__default.JournalBackLocation(start#0, len#0), 
        Tclass.Options.Option(Tclass.DiskLayout.Location())));

function DiskLayout.__default.JournalBackLocation#requires(int, int) : bool;

// #requires axiom for DiskLayout.__default.JournalBackLocation
axiom (forall start#0: int, len#0: int :: 
  { DiskLayout.__default.JournalBackLocation#requires(start#0, len#0) } 
  LitInt(0) <= start#0
       && start#0 < 18446744073709551616
       && 
      LitInt(0) <= len#0
       && len#0 < 18446744073709551616
     ==> DiskLayout.__default.JournalBackLocation#requires(start#0, len#0)
       == (start#0 < DiskLayout.__default.NumJournalBlocks()
         && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for DiskLayout.__default.JournalBackLocation(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { DiskLayout.__default.JournalBackLocation(start#0, len#0) } 
    DiskLayout.__default.JournalBackLocation#canCall(start#0, len#0)
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          start#0 < DiskLayout.__default.NumJournalBlocks()
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (len#0 != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks() - start#0 < len#0
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalRangeLocation#canCall(LitInt(0), len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0))))
         && DiskLayout.__default.JournalBackLocation(start#0, len#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.None()
             else (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
               then #Options.Option.None()
               else #Options.Option.Some($Box(DiskLayout.__default.JournalRangeLocation(LitInt(0), len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))));

// definition axiom for DiskLayout.__default.JournalBackLocation for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { DiskLayout.__default.JournalBackLocation(LitInt(start#0), LitInt(len#0)) } 
    DiskLayout.__default.JournalBackLocation#canCall(LitInt(start#0), LitInt(len#0))
         || (
          LitInt(0) <= start#0
           && start#0 < 18446744073709551616
           && 
          LitInt(0) <= len#0
           && len#0 < 18446744073709551616
           && 
          Lit(start#0 < DiskLayout.__default.NumJournalBlocks())
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (LitInt(len#0) != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(DiskLayout.__default.NumJournalBlocks() - start#0) < LitInt(len#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && DiskLayout.__default.JournalRangeLocation#canCall(LitInt(0), LitInt(len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))
         && DiskLayout.__default.JournalBackLocation(LitInt(start#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.None()
             else (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
               then #Options.Option.None()
               else #Options.Option.Some($Box(Lit(DiskLayout.__default.JournalRangeLocation(LitInt(0), LitInt(len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))))));

// function declaration for DiskLayout._default.LocationSub
function DiskLayout.__default.LocationSub(loc1#0: DatatypeType, loc2#0: DatatypeType) : bool;

function DiskLayout.__default.LocationSub#canCall(loc1#0: DatatypeType, loc2#0: DatatypeType) : bool;

// consequence axiom for DiskLayout.__default.LocationSub
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    { DiskLayout.__default.LocationSub(loc1#0, loc2#0) } 
    DiskLayout.__default.LocationSub#canCall(loc1#0, loc2#0)
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> true);

function DiskLayout.__default.LocationSub#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.LocationSub
axiom (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
  { DiskLayout.__default.LocationSub#requires(loc1#0, loc2#0) } 
  $Is(loc1#0, Tclass.DiskLayout.Location())
       && $Is(loc2#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.LocationSub#requires(loc1#0, loc2#0) == true);

// definition axiom for DiskLayout.__default.LocationSub(revealed)
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    { DiskLayout.__default.LocationSub(loc1#0, loc2#0) } 
    DiskLayout.__default.LocationSub#canCall(loc1#0, loc2#0)
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(loc1#0)
         && DiskLayout.Location.Location_q(loc2#0)
         && (DiskLayout.Location.addr(loc1#0) >= DiskLayout.Location.addr(loc2#0)
           ==> DiskLayout.Location.Location_q(loc1#0)
             && DiskLayout.Location.Location_q(loc1#0)
             && 
            DiskLayout.Location.Location_q(loc2#0)
             && DiskLayout.Location.Location_q(loc2#0))
         && DiskLayout.__default.LocationSub(loc1#0, loc2#0)
           == (DiskLayout.Location.addr(loc1#0) >= DiskLayout.Location.addr(loc2#0)
             && DiskLayout.Location.addr(loc1#0) + DiskLayout.Location.len(loc1#0)
               <= DiskLayout.Location.addr(loc2#0) + DiskLayout.Location.len(loc2#0)));

// definition axiom for DiskLayout.__default.LocationSub for all literals(revealed)
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.LocationSub(Lit(loc1#0), Lit(loc2#0)) } 
    DiskLayout.__default.LocationSub#canCall(Lit(loc1#0), Lit(loc2#0))
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(Lit(loc1#0))
         && DiskLayout.Location.Location_q(Lit(loc2#0))
         && (LitInt(DiskLayout.Location.addr(Lit(loc1#0)))
             >= LitInt(DiskLayout.Location.addr(Lit(loc2#0)))
           ==> DiskLayout.Location.Location_q(Lit(loc1#0))
             && DiskLayout.Location.Location_q(Lit(loc1#0))
             && 
            DiskLayout.Location.Location_q(Lit(loc2#0))
             && DiskLayout.Location.Location_q(Lit(loc2#0)))
         && DiskLayout.__default.LocationSub(Lit(loc1#0), Lit(loc2#0))
           == (LitInt(DiskLayout.Location.addr(Lit(loc1#0)))
               >= LitInt(DiskLayout.Location.addr(Lit(loc2#0)))
             && LitInt(DiskLayout.Location.addr(Lit(loc1#0)) + DiskLayout.Location.len(Lit(loc1#0)))
               <= LitInt(DiskLayout.Location.addr(Lit(loc2#0)) + DiskLayout.Location.len(Lit(loc2#0)))));

// function declaration for DiskLayout._default.JournalBlockIdx
function DiskLayout.__default.JournalBlockIdx($ly: LayerType, loc#0: DatatypeType) : int;

function DiskLayout.__default.JournalBlockIdx#canCall(loc#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0) } 
  DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0)
     == DiskLayout.__default.JournalBlockIdx($ly, loc#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.JournalBlockIdx(AsFuelBottom($ly), loc#0) } 
  DiskLayout.__default.JournalBlockIdx($ly, loc#0)
     == DiskLayout.__default.JournalBlockIdx($LZ, loc#0));

// consequence axiom for DiskLayout.__default.JournalBlockIdx
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.JournalBlockIdx($ly, loc#0) } 
    DiskLayout.__default.JournalBlockIdx#canCall(loc#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
       ==> LitInt(0) <= DiskLayout.__default.JournalBlockIdx($ly, loc#0)
         && DiskLayout.__default.JournalBlockIdx($ly, loc#0)
           < DiskLayout.__default.NumJournalBlocks()
         && DiskLayout.Location.addr(loc#0)
           == DiskLayout.__default.JournalPoint(DiskLayout.__default.JournalBlockIdx($ly, loc#0)));

function DiskLayout.__default.JournalBlockIdx#requires(LayerType, DatatypeType) : bool;

// #requires axiom for DiskLayout.__default.JournalBlockIdx
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { DiskLayout.__default.JournalBlockIdx#requires($ly, loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> DiskLayout.__default.JournalBlockIdx#requires($ly, loc#0)
       == DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0));

const MoreFuel_DiskLayout._default.ValidJournalLocation2: LayerType;

// definition axiom for DiskLayout.__default.JournalBlockIdx(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0) } 
    DiskLayout.__default.JournalBlockIdx#canCall(loc#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
       ==> DiskLayout.Location.Location_q(loc#0)
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation2)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation2))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation2)
           == MoreFuel_DiskLayout._default.ValidJournalLocation2
         && DiskLayout.__default.JournalBlockIdx($LS($ly), loc#0)
           == Div(DiskLayout.Location.addr(loc#0) - Mul(LitInt(2), LitInt(4096)), LitInt(4096)));

const MoreFuel_DiskLayout._default.ValidJournalLocation3: LayerType;

// definition axiom for DiskLayout.__default.JournalBlockIdx for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    {:weight 3} { DiskLayout.__default.JournalBlockIdx($LS($ly), Lit(loc#0)) } 
    DiskLayout.__default.JournalBlockIdx#canCall(Lit(loc#0))
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0)))
       ==> DiskLayout.Location.Location_q(Lit(loc#0))
         && 
        StartFuel_DiskLayout._default.ValidJournalLocation
           == $LS(MoreFuel_DiskLayout._default.ValidJournalLocation3)
         && StartFuelAssert_DiskLayout._default.ValidJournalLocation
           == $LS($LS(MoreFuel_DiskLayout._default.ValidJournalLocation3))
         && AsFuelBottom(MoreFuel_DiskLayout._default.ValidJournalLocation3)
           == MoreFuel_DiskLayout._default.ValidJournalLocation3
         && DiskLayout.__default.JournalBlockIdx($LS($ly), Lit(loc#0))
           == LitInt(Div(DiskLayout.Location.addr(Lit(loc#0)) - Mul(LitInt(2), LitInt(4096)), 
              LitInt(4096))));

// function declaration for DiskLayout._default.otherIndirectionTableAddr
function DiskLayout.__default.otherIndirectionTableAddr(addr#0: int) : int;

function DiskLayout.__default.otherIndirectionTableAddr#canCall(addr#0: int) : bool;

// consequence axiom for DiskLayout.__default.otherIndirectionTableAddr
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.otherIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.otherIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> LitInt(0) <= DiskLayout.__default.otherIndirectionTableAddr(addr#0)
         && DiskLayout.__default.otherIndirectionTableAddr(addr#0) < 18446744073709551616);

function DiskLayout.__default.otherIndirectionTableAddr#requires(int) : bool;

// #requires axiom for DiskLayout.__default.otherIndirectionTableAddr
axiom (forall addr#0: int :: 
  { DiskLayout.__default.otherIndirectionTableAddr#requires(addr#0) } 
  LitInt(0) <= addr#0 && addr#0 < 18446744073709551616
     ==> DiskLayout.__default.otherIndirectionTableAddr#requires(addr#0) == true);

// definition axiom for DiskLayout.__default.otherIndirectionTableAddr(revealed)
axiom true
   ==> (forall addr#0: int :: 
    { DiskLayout.__default.otherIndirectionTableAddr(addr#0) } 
    DiskLayout.__default.otherIndirectionTableAddr#canCall(addr#0)
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
         && (addr#0 == LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable2Addr#canCall())
         && (addr#0 != LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall())
         && DiskLayout.__default.otherIndirectionTableAddr(addr#0)
           == (if addr#0 == LitInt(DiskLayout.__default.IndirectionTable1Addr())
             then DiskLayout.__default.IndirectionTable2Addr()
             else DiskLayout.__default.IndirectionTable1Addr()));

// definition axiom for DiskLayout.__default.otherIndirectionTableAddr for all literals(revealed)
axiom true
   ==> (forall addr#0: int :: 
    {:weight 3} { DiskLayout.__default.otherIndirectionTableAddr(LitInt(addr#0)) } 
    DiskLayout.__default.otherIndirectionTableAddr#canCall(LitInt(addr#0))
         || (LitInt(0) <= addr#0 && addr#0 < 18446744073709551616)
       ==> DiskLayout.__default.IndirectionTable1Addr#canCall()
         && (LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable2Addr#canCall())
         && (LitInt(addr#0) != LitInt(DiskLayout.__default.IndirectionTable1Addr())
           ==> DiskLayout.__default.IndirectionTable1Addr#canCall())
         && DiskLayout.__default.otherIndirectionTableAddr(LitInt(addr#0))
           == (if LitInt(addr#0) == LitInt(DiskLayout.__default.IndirectionTable1Addr())
             then DiskLayout.__default.IndirectionTable2Addr()
             else DiskLayout.__default.IndirectionTable1Addr()));

// Constructor function declaration
function #Journal.JournalEntry.JournalInsert(Seq Box, Seq Box) : DatatypeType;

const unique ##Journal.JournalEntry.JournalInsert: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#Journal.JournalEntry.JournalInsert(a#0#0#0, a#0#1#0))
     == ##Journal.JournalEntry.JournalInsert);

function Journal.JournalEntry.JournalInsert_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d) } 
  Journal.JournalEntry.JournalInsert_q(d)
     <==> DatatypeCtorId(d) == ##Journal.JournalEntry.JournalInsert);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d) } 
  Journal.JournalEntry.JournalInsert_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: Seq Box :: 
      d == #Journal.JournalEntry.JournalInsert(a#1#0#0, a#1#1#0)));

function Tclass.Journal.JournalEntry() : Ty;

// Tclass.Journal.JournalEntry Tag
axiom Tag(Tclass.Journal.JournalEntry()) == Tagclass.Journal.JournalEntry;

const unique Tagclass.Journal.JournalEntry: TyTag;

// Box/unbox axiom for Tclass.Journal.JournalEntry
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Journal.JournalEntry()) } 
  $IsBox(bx, Tclass.Journal.JournalEntry())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.Journal.JournalEntry()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: Seq Box :: 
  { $Is(#Journal.JournalEntry.JournalInsert(a#2#0#0, a#2#1#0), 
      Tclass.Journal.JournalEntry()) } 
  $Is(#Journal.JournalEntry.JournalInsert(a#2#0#0, a#2#1#0), 
      Tclass.Journal.JournalEntry())
     <==> $Is(a#2#0#0, Tclass.KeyType.Key()) && $Is(a#2#1#0, Tclass.ValueType.Value()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#Journal.JournalEntry.JournalInsert(a#3#0#0, a#3#1#0), 
      Tclass.Journal.JournalEntry(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#Journal.JournalEntry.JournalInsert(a#3#0#0, a#3#1#0), 
        Tclass.Journal.JournalEntry(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.KeyType.Key(), $h)
         && $IsAlloc(a#3#1#0, Tclass.ValueType.Value(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(Journal.JournalEntry.key(d), Tclass.KeyType.Key(), $h) } 
  $IsGoodHeap($h)
       && 
      Journal.JournalEntry.JournalInsert_q(d)
       && $IsAlloc(d, Tclass.Journal.JournalEntry(), $h)
     ==> $IsAlloc(Journal.JournalEntry.key(d), Tclass.KeyType.Key(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(Journal.JournalEntry.value(d), Tclass.ValueType.Value(), $h) } 
  $IsGoodHeap($h)
       && 
      Journal.JournalEntry.JournalInsert_q(d)
       && $IsAlloc(d, Tclass.Journal.JournalEntry(), $h)
     ==> $IsAlloc(Journal.JournalEntry.value(d), Tclass.ValueType.Value(), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #Journal.JournalEntry.JournalInsert(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#Journal.JournalEntry.JournalInsert(a#4#0#0, a#4#1#0)));

function Journal.JournalEntry.key(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#5#0#0, a#5#1#0) } 
  Journal.JournalEntry.key(#Journal.JournalEntry.JournalInsert(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function Journal.JournalEntry.value(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#6#0#0: Seq Box, a#6#1#0: Seq Box :: 
  { #Journal.JournalEntry.JournalInsert(a#6#0#0, a#6#1#0) } 
  Journal.JournalEntry.value(#Journal.JournalEntry.JournalInsert(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Depth-one case-split function
function $IsA#Journal.JournalEntry(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#Journal.JournalEntry(d) } 
  $IsA#Journal.JournalEntry(d) ==> Journal.JournalEntry.JournalInsert_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { Journal.JournalEntry.JournalInsert_q(d), $Is(d, Tclass.Journal.JournalEntry()) } 
  $Is(d, Tclass.Journal.JournalEntry())
     ==> Journal.JournalEntry.JournalInsert_q(d));

// Datatype extensional equality declaration
function Journal.JournalEntry#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #Journal.JournalEntry.JournalInsert
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Journal.JournalEntry#Equal(a, b) } 
  true
     ==> (Journal.JournalEntry#Equal(a, b)
       <==> Seq#Equal(Journal.JournalEntry.key(a), Journal.JournalEntry.key(b))
         && Seq#Equal(Journal.JournalEntry.value(a), Journal.JournalEntry.value(b))));

// Datatype extensionality axiom: Journal.JournalEntry
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { Journal.JournalEntry#Equal(a, b) } 
  Journal.JournalEntry#Equal(a, b) <==> a == b);

const unique class.Journal.JournalEntry: ClassName;

const unique class.Journal.__default: ClassName;

function Tclass.Journal.__default() : Ty;

// Tclass.Journal.__default Tag
axiom Tag(Tclass.Journal.__default()) == Tagclass.Journal.__default;

const unique Tagclass.Journal.__default: TyTag;

// Box/unbox axiom for Tclass.Journal.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Journal.__default()) } 
  $IsBox(bx, Tclass.Journal.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Journal.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Journal.__default()) } 
  $Is($o, Tclass.Journal.__default())
     <==> $o == null || dtype($o) == Tclass.Journal.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Journal.__default(), $h) } 
  $IsAlloc($o, Tclass.Journal.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Journal._default.JournalEntriesForUIOp
function Journal.__default.JournalEntriesForUIOp(uiop#0: DatatypeType) : Seq Box;

function Journal.__default.JournalEntriesForUIOp#canCall(uiop#0: DatatypeType) : bool;

// consequence axiom for Journal.__default.JournalEntriesForUIOp
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    { Journal.__default.JournalEntriesForUIOp(uiop#0) } 
    Journal.__default.JournalEntriesForUIOp#canCall(uiop#0)
         || $Is(uiop#0, Tclass.UI.Op())
       ==> $Is(Journal.__default.JournalEntriesForUIOp(uiop#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function Journal.__default.JournalEntriesForUIOp#requires(DatatypeType) : bool;

// #requires axiom for Journal.__default.JournalEntriesForUIOp
axiom (forall uiop#0: DatatypeType :: 
  { Journal.__default.JournalEntriesForUIOp#requires(uiop#0) } 
  $Is(uiop#0, Tclass.UI.Op())
     ==> Journal.__default.JournalEntriesForUIOp#requires(uiop#0) == true);

// definition axiom for Journal.__default.JournalEntriesForUIOp(revealed)
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    { Journal.__default.JournalEntriesForUIOp(uiop#0) } 
    Journal.__default.JournalEntriesForUIOp#canCall(uiop#0)
         || $Is(uiop#0, Tclass.UI.Op())
       ==> Journal.__default.JournalEntriesForUIOp(uiop#0)
         == (if UI.Op.PutOp_q(uiop#0)
           then Seq#Build(Seq#Empty(): Seq Box, 
            $Box(#Journal.JournalEntry.JournalInsert(UI.Op.key(uiop#0), UI.Op.value(uiop#0))))
           else Seq#Empty(): Seq Box));

// definition axiom for Journal.__default.JournalEntriesForUIOp for all literals(revealed)
axiom true
   ==> (forall uiop#0: DatatypeType :: 
    {:weight 3} { Journal.__default.JournalEntriesForUIOp(Lit(uiop#0)) } 
    Journal.__default.JournalEntriesForUIOp#canCall(Lit(uiop#0))
         || $Is(uiop#0, Tclass.UI.Op())
       ==> Journal.__default.JournalEntriesForUIOp(Lit(uiop#0))
         == (if UI.Op.PutOp_q(Lit(uiop#0))
           then Seq#Build(Seq#Empty(): Seq Box, 
            $Box(Lit(#Journal.JournalEntry.JournalInsert(Lit(UI.Op.key(Lit(uiop#0))), Lit(UI.Op.value(Lit(uiop#0)))))))
           else Seq#Empty(): Seq Box));

// function declaration for Journal._default.JournalEntriesForUIOps
function Journal.__default.JournalEntriesForUIOps($ly: LayerType, uiops#0: Seq Box) : Seq Box;

function Journal.__default.JournalEntriesForUIOps#canCall(uiops#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0) } 
  Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0)
     == Journal.__default.JournalEntriesForUIOps($ly, uiops#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps(AsFuelBottom($ly), uiops#0) } 
  Journal.__default.JournalEntriesForUIOps($ly, uiops#0)
     == Journal.__default.JournalEntriesForUIOps($LZ, uiops#0));

// consequence axiom for Journal.__default.JournalEntriesForUIOps
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    { Journal.__default.JournalEntriesForUIOps($ly, uiops#0) } 
    Journal.__default.JournalEntriesForUIOps#canCall(uiops#0)
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> $Is(Journal.__default.JournalEntriesForUIOps($ly, uiops#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function Journal.__default.JournalEntriesForUIOps#requires(LayerType, Seq Box) : bool;

// #requires axiom for Journal.__default.JournalEntriesForUIOps
axiom (forall $ly: LayerType, uiops#0: Seq Box :: 
  { Journal.__default.JournalEntriesForUIOps#requires($ly, uiops#0) } 
  $Is(uiops#0, TSeq(Tclass.UI.Op()))
     ==> Journal.__default.JournalEntriesForUIOps#requires($ly, uiops#0) == true);

// definition axiom for Journal.__default.JournalEntriesForUIOps(revealed)
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    { Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0) } 
    Journal.__default.JournalEntriesForUIOps#canCall(uiops#0)
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> (!Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.UI.Op(), uiops#0)
             && Journal.__default.JournalEntriesForUIOps#canCall(Sequences.__default.DropLast(Tclass.UI.Op(), uiops#0))
             && 
            Sequences.__default.Last#canCall(Tclass.UI.Op(), uiops#0)
             && Journal.__default.JournalEntriesForUIOp#canCall($Unbox(Sequences.__default.Last(Tclass.UI.Op(), uiops#0)): DatatypeType))
         && Journal.__default.JournalEntriesForUIOps($LS($ly), uiops#0)
           == (if Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(Journal.__default.JournalEntriesForUIOps($ly, Sequences.__default.DropLast(Tclass.UI.Op(), uiops#0)), 
              Journal.__default.JournalEntriesForUIOp($Unbox(Sequences.__default.Last(Tclass.UI.Op(), uiops#0)): DatatypeType))));

// definition axiom for Journal.__default.JournalEntriesForUIOps for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, uiops#0: Seq Box :: 
    {:weight 3} { Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(uiops#0)) } 
    Journal.__default.JournalEntriesForUIOps#canCall(Lit(uiops#0))
         || $Is(uiops#0, TSeq(Tclass.UI.Op()))
       ==> (!Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.UI.Op(), Lit(uiops#0))
             && Journal.__default.JournalEntriesForUIOps#canCall(Lit(Sequences.__default.DropLast(Tclass.UI.Op(), Lit(uiops#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.UI.Op(), Lit(uiops#0))
             && Journal.__default.JournalEntriesForUIOp#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.UI.Op(), Lit(uiops#0))): DatatypeType)))
         && Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(uiops#0))
           == (if Seq#Equal(uiops#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(Journal.__default.JournalEntriesForUIOps($LS($ly), Lit(Sequences.__default.DropLast(Tclass.UI.Op(), Lit(uiops#0)))), 
              Journal.__default.JournalEntriesForUIOp(Lit($Unbox(Sequences.__default.Last(Tclass.UI.Op(), Lit(uiops#0))): DatatypeType)))));

const unique class.NativePackedInts.__default: ClassName;

function Tclass.NativePackedInts.__default() : Ty;

// Tclass.NativePackedInts.__default Tag
axiom Tag(Tclass.NativePackedInts.__default()) == Tagclass.NativePackedInts.__default;

const unique Tagclass.NativePackedInts.__default: TyTag;

// Box/unbox axiom for Tclass.NativePackedInts.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativePackedInts.__default()) } 
  $IsBox(bx, Tclass.NativePackedInts.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativePackedInts.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativePackedInts.__default()) } 
  $Is($o, Tclass.NativePackedInts.__default())
     <==> $o == null || dtype($o) == Tclass.NativePackedInts.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativePackedInts.__default(), $h) } 
  $IsAlloc($o, Tclass.NativePackedInts.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32
function NativePackedInts.__default.unpack__LittleEndian__Uint32($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint32($ly, s#0) < 4294967296);

function NativePackedInts.__default.unpack__LittleEndian__Uint32#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(4)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(4))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint32($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64
function NativePackedInts.__default.unpack__LittleEndian__Uint64($ly: LayerType, s#0: Seq Box) : int;

function NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64(AsFuelBottom($ly), s#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64($LZ, s#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> LitInt(0) <= NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
         && NativePackedInts.__default.unpack__LittleEndian__Uint64($ly, s#0)
           < 18446744073709551616);

function NativePackedInts.__default.unpack__LittleEndian__Uint64#requires(LayerType, Seq Box) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64#requires($ly, s#0)
       == 
      (Seq#Length(s#0)
       == LitInt(8)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(s#0) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), s#0)
         == $Unbox(Seq#Index(s#0, LitInt(0))): int
           + Mul($Unbox(Seq#Index(s#0, LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(s#0, LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(s#0, LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(s#0, LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(s#0, LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(s#0, LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(s#0, LitInt(7))): int, LitInt(72057594037927936)));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.byte())) && Seq#Length(Lit(s#0)) == LitInt(8))
       ==> NativePackedInts.__default.unpack__LittleEndian__Uint64($LS($ly), Lit(s#0))
         == $Unbox(Seq#Index(Lit(s#0), LitInt(0))): int
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(1))): int, LitInt(256))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(2))): int, LitInt(65536))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(3))): int, LitInt(16777216))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(4))): int, LitInt(4294967296))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(5))): int, LitInt(1099511627776))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(6))): int, LitInt(281474976710656))
           + Mul($Unbox(Seq#Index(Lit(s#0), LitInt(7))): int, LitInt(72057594037927936)));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint32_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), i#0) + 4), Mul(LitInt(4), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(4))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(4)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($ly, Seq#Take(packed#0, Mul(LitInt(4), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(4), len#0)), Mul(LitInt(4), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(4))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint32#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint32__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint32(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint32, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(4), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(4), LitInt(len#0 - 1)))))))))));

// function declaration for NativePackedInts._default.unpack_LittleEndian_Uint64_Seq
function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly: LayerType, packed#0: Seq Box, len#0: int) : Seq Box;

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0: Seq Box, len#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(AsFuelBottom($ly), packed#0, len#0) } 
  NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0)
     == NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LZ, packed#0, len#0));

// consequence axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> Seq#Length(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0))
           == len#0
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                i#0)): int } 
          LitInt(0) <= i#0 && i#0 < len#0
             ==> $Unbox(Seq#Index(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
                  i#0)): int
               == NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), i#0) + 8), Mul(LitInt(8), i#0))))
         && $Is(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, packed#0, len#0), 
          TSeq(Tclass.NativeTypes.uint64())));

function NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq
axiom (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
  { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0) } 
  $Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
     ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#requires($ly, packed#0, len#0)
       == 
      (Seq#Length(packed#0)
       == Mul(len#0, LitInt(8))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(packed#0, len#0)
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(packed#0) == Mul(len#0, LitInt(8)))
       ==> (len#0 != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1)
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), packed#0, len#0)
           == (if len#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($ly, Seq#Take(packed#0, Mul(LitInt(8), len#0 - 1)), len#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Seq#Drop(Seq#Take(packed#0, Mul(LitInt(8), len#0)), Mul(LitInt(8), len#0 - 1))))))));

// definition axiom for NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, packed#0: Seq Box, len#0: int :: 
    {:weight 3} { NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0)) } 
    NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(packed#0), LitInt(len#0))
         || ($Is(packed#0, TSeq(Tclass.NativeTypes.byte()))
           && Seq#Length(Lit(packed#0)) == LitInt(Mul(LitInt(len#0), LitInt(8))))
       ==> (LitInt(len#0) != LitInt(0)
           ==> NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq#canCall(Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
              LitInt(len#0 - 1))
             && NativePackedInts.__default.unpack__LittleEndian__Uint64#canCall(Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                  LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))
         && NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), Lit(packed#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(NativePackedInts.__default.unpack__LittleEndian__Uint64__Seq($LS($ly), 
                Lit(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0 - 1))))), 
                LitInt(len#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(NativePackedInts.__default.unpack__LittleEndian__Uint64(StartFuel_NativePackedInts._default.unpack_LittleEndian_Uint64, 
                    Lit(Seq#Drop(Seq#Take(Lit(packed#0), LitInt(Mul(LitInt(8), LitInt(len#0)))), 
                        LitInt(Mul(LitInt(8), LitInt(len#0 - 1)))))))))));

const #$JournalBlock: Ty;

const unique class.JournalRanges.__default: ClassName;

function Tclass.JournalRanges.__default() : Ty;

// Tclass.JournalRanges.__default Tag
axiom Tag(Tclass.JournalRanges.__default()) == Tagclass.JournalRanges.__default;

const unique Tagclass.JournalRanges.__default: TyTag;

// Box/unbox axiom for Tclass.JournalRanges.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalRanges.__default()) } 
  $IsBox(bx, Tclass.JournalRanges.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalRanges.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalRanges.__default()) } 
  $Is($o, Tclass.JournalRanges.__default())
     <==> $o == null || dtype($o) == Tclass.JournalRanges.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalRanges.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalRanges.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalRanges._default.JournalRangeLen
function JournalRanges.__default.JournalRangeLen(jr#0: Seq Box) : int;

function JournalRanges.__default.JournalRangeLen#canCall(jr#0: Seq Box) : bool;

function Tclass.JournalRanges.JournalBlock() : Ty;

// Tclass.JournalRanges.JournalBlock Tag
axiom Tag(Tclass.JournalRanges.JournalBlock()) == Tagclass.JournalRanges.JournalBlock;

const unique Tagclass.JournalRanges.JournalBlock: TyTag;

// consequence axiom for JournalRanges.__default.JournalRangeLen
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeLen(jr#0) } 
    JournalRanges.__default.JournalRangeLen#canCall(jr#0)
         || $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       ==> JournalRanges.__default.JournalRangeLen(jr#0) >= LitInt(0));

function JournalRanges.__default.JournalRangeLen#requires(Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeLen
axiom (forall jr#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeLen#requires(jr#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.JournalRangeLen#requires(jr#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeLen(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeLen(jr#0) } 
    JournalRanges.__default.JournalRangeLen#canCall(jr#0)
         || $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       ==> JournalRanges.__default.JournalRangeLen(jr#0) == Seq#Length(jr#0));

// definition axiom for JournalRanges.__default.JournalRangeLen for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeLen(Lit(jr#0)) } 
    JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0))
         || $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       ==> JournalRanges.__default.JournalRangeLen(Lit(jr#0)) == Seq#Length(Lit(jr#0)));

// function declaration for JournalRanges._default.JournalRangePrefix
function JournalRanges.__default.JournalRangePrefix(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalRangePrefix#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalRangePrefix
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangePrefix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangePrefix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeLen(JournalRanges.__default.JournalRangePrefix(jr#0, i#0))
           == i#0
         && $Is(JournalRanges.__default.JournalRangePrefix(jr#0, i#0), 
          TSeq(Tclass.JournalRanges.JournalBlock())));

function JournalRanges.__default.JournalRangePrefix#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalRangePrefix
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalRangePrefix#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.JournalRangePrefix#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0)));

// function declaration for JournalRanges._default.JournalRangeSuffix
function JournalRanges.__default.JournalRangeSuffix(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalRangeSuffix#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeSuffix
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalRangeSuffix(jr#0, i#0) } 
    JournalRanges.__default.JournalRangeSuffix#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          LitInt(0) <= i#0
           && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalRangeLen(JournalRanges.__default.JournalRangeSuffix(jr#0, i#0))
           == JournalRanges.__default.JournalRangeLen(jr#0) - i#0
         && $Is(JournalRanges.__default.JournalRangeSuffix(jr#0, i#0), 
          TSeq(Tclass.JournalRanges.JournalBlock())));

function JournalRanges.__default.JournalRangeSuffix#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeSuffix
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalRangeSuffix#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.JournalRangeSuffix#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= JournalRanges.__default.JournalRangeLen(jr#0)));

// function declaration for JournalRanges._default.JournalRangeConcat
function JournalRanges.__default.JournalRangeConcat(jr1#0: Seq Box, jr2#0: Seq Box) : Seq Box;

function JournalRanges.__default.JournalRangeConcat#canCall(jr1#0: Seq Box, jr2#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeConcat
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0) } 
    JournalRanges.__default.JournalRangeConcat#canCall(jr1#0, jr2#0)
         || ($Is(jr1#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && $Is(jr2#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> $Is(JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0), 
        TSeq(Tclass.JournalRanges.JournalBlock())));

function JournalRanges.__default.JournalRangeConcat#requires(Seq Box, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeConcat
axiom (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeConcat#requires(jr1#0, jr2#0) } 
  $Is(jr1#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       && $Is(jr2#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.JournalRangeConcat#requires(jr1#0, jr2#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeConcat(revealed)
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0) } 
    JournalRanges.__default.JournalRangeConcat#canCall(jr1#0, jr2#0)
         || ($Is(jr1#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && $Is(jr2#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> JournalRanges.__default.JournalRangeConcat(jr1#0, jr2#0)
         == Seq#Append(jr1#0, jr2#0));

// definition axiom for JournalRanges.__default.JournalRangeConcat for all literals(revealed)
axiom true
   ==> (forall jr1#0: Seq Box, jr2#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeConcat(Lit(jr1#0), Lit(jr2#0)) } 
    JournalRanges.__default.JournalRangeConcat#canCall(Lit(jr1#0), Lit(jr2#0))
         || ($Is(jr1#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && $Is(jr2#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> JournalRanges.__default.JournalRangeConcat(Lit(jr1#0), Lit(jr2#0))
         == Seq#Append(jr1#0, jr2#0));

// function declaration for JournalRanges._default.JournalRangeEmpty
function JournalRanges.__default.JournalRangeEmpty() : Seq Box;

function JournalRanges.__default.JournalRangeEmpty#canCall() : bool;

// consequence axiom for JournalRanges.__default.JournalRangeEmpty
axiom true
   ==> 
  true
   ==> $Is(JournalRanges.__default.JournalRangeEmpty(), 
    TSeq(Tclass.JournalRanges.JournalBlock()));

function JournalRanges.__default.JournalRangeEmpty#requires() : bool;

// #requires axiom for JournalRanges.__default.JournalRangeEmpty
axiom JournalRanges.__default.JournalRangeEmpty#requires() == true;

// definition axiom for JournalRanges.__default.JournalRangeEmpty(revealed)
axiom true
   ==> 
  true
   ==> JournalRanges.__default.JournalRangeEmpty() == Lit(Seq#Empty(): Seq Box);

// definition axiom for JournalRanges.__default.JournalRangeEmpty for all literals(revealed)
axiom true
   ==> 
  true
   ==> JournalRanges.__default.JournalRangeEmpty() == Lit(Seq#Empty(): Seq Box);

// function declaration for JournalRanges._default.JournalBlocks
function JournalRanges.__default.JournalBlocks(jr#0: Seq Box) : Seq Box;

function JournalRanges.__default.JournalBlocks#canCall(jr#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalBlocks
axiom true
   ==> (forall jr#0: Seq Box :: 
    { JournalRanges.__default.JournalBlocks(jr#0) } 
    JournalRanges.__default.JournalBlocks#canCall(jr#0)
         || $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       ==> Seq#Length(JournalRanges.__default.JournalBlocks(jr#0))
           == JournalRanges.__default.JournalRangeLen(jr#0)
         && $Is(JournalRanges.__default.JournalBlocks(jr#0), 
          TSeq(TSeq(Tclass.JournalRanges.JournalBlock()))));

function JournalRanges.__default.JournalBlocks#requires(Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalBlocks
axiom (forall jr#0: Seq Box :: 
  { JournalRanges.__default.JournalBlocks#requires(jr#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.JournalBlocks#requires(jr#0) == true);

// function declaration for JournalRanges._default.JournalBlockGet
function JournalRanges.__default.JournalBlockGet(jr#0: Seq Box, i#0: int) : Seq Box;

function JournalRanges.__default.JournalBlockGet#canCall(jr#0: Seq Box, i#0: int) : bool;

// consequence axiom for JournalRanges.__default.JournalBlockGet
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlockGet(jr#0, i#0) } 
    JournalRanges.__default.JournalBlockGet#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          LitInt(0) <= i#0
           && i#0 < JournalRanges.__default.JournalRangeLen(jr#0))
       ==> $Is(JournalRanges.__default.JournalBlockGet(jr#0, i#0), 
        TSeq(Tclass.JournalRanges.JournalBlock())));

function JournalRanges.__default.JournalBlockGet#requires(Seq Box, int) : bool;

// #requires axiom for JournalRanges.__default.JournalBlockGet
axiom (forall jr#0: Seq Box, i#0: int :: 
  { JournalRanges.__default.JournalBlockGet#requires(jr#0, i#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.JournalBlockGet#requires(jr#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < JournalRanges.__default.JournalRangeLen(jr#0)));

// definition axiom for JournalRanges.__default.JournalBlockGet(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    { JournalRanges.__default.JournalBlockGet(jr#0, i#0) } 
    JournalRanges.__default.JournalBlockGet#canCall(jr#0, i#0)
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          LitInt(0) <= i#0
           && i#0 < JournalRanges.__default.JournalRangeLen(jr#0))
       ==> JournalRanges.__default.JournalBlocks#canCall(jr#0)
         && JournalRanges.__default.JournalBlockGet(jr#0, i#0)
           == $Unbox(Seq#Index(JournalRanges.__default.JournalBlocks(jr#0), i#0)): Seq Box);

// definition axiom for JournalRanges.__default.JournalBlockGet for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalRanges.__default.JournalBlockGet(Lit(jr#0), LitInt(i#0)) } 
    JournalRanges.__default.JournalBlockGet#canCall(Lit(jr#0), LitInt(i#0))
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < JournalRanges.__default.JournalRangeLen(Lit(jr#0)))
       ==> JournalRanges.__default.JournalBlocks#canCall(Lit(jr#0))
         && JournalRanges.__default.JournalBlockGet(Lit(jr#0), LitInt(i#0))
           == $Unbox(Seq#Index(JournalRanges.__default.JournalBlocks(Lit(jr#0)), LitInt(i#0))): Seq Box);

// function declaration for JournalRanges._default.parseJournalRange
function JournalRanges.__default.parseJournalRange($ly: LayerType, jr#0: Seq Box) : DatatypeType;

function JournalRanges.__default.parseJournalRange#canCall(jr#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange($LS($ly), jr#0) } 
  JournalRanges.__default.parseJournalRange($LS($ly), jr#0)
     == JournalRanges.__default.parseJournalRange($ly, jr#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange(AsFuelBottom($ly), jr#0) } 
  JournalRanges.__default.parseJournalRange($ly, jr#0)
     == JournalRanges.__default.parseJournalRange($LZ, jr#0));

// consequence axiom for JournalRanges.__default.parseJournalRange
axiom true
   ==> (forall $ly: LayerType, jr#0: Seq Box :: 
    { JournalRanges.__default.parseJournalRange($ly, jr#0) } 
    JournalRanges.__default.parseJournalRange#canCall(jr#0)
         || $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       ==> $Is(JournalRanges.__default.parseJournalRange($ly, jr#0), 
        Tclass.Options.Option(TSeq(Tclass.Journal.JournalEntry()))));

function JournalRanges.__default.parseJournalRange#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.parseJournalRange
axiom (forall $ly: LayerType, jr#0: Seq Box :: 
  { JournalRanges.__default.parseJournalRange#requires($ly, jr#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalRanges.__default.parseJournalRange#requires($ly, jr#0) == true);

// function declaration for JournalRanges._default.JournalRangeParses
function JournalRanges.__default.JournalRangeParses(jr#0: Seq Box, jes#0: Seq Box) : bool;

function JournalRanges.__default.JournalRangeParses#canCall(jr#0: Seq Box, jes#0: Seq Box) : bool;

// consequence axiom for JournalRanges.__default.JournalRangeParses
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeParses(jr#0, jes#0) } 
    JournalRanges.__default.JournalRangeParses#canCall(jr#0, jes#0)
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> true);

function JournalRanges.__default.JournalRangeParses#requires(Seq Box, Seq Box) : bool;

// #requires axiom for JournalRanges.__default.JournalRangeParses
axiom (forall jr#0: Seq Box, jes#0: Seq Box :: 
  { JournalRanges.__default.JournalRangeParses#requires(jr#0, jes#0) } 
  $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
       && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry()))
     ==> JournalRanges.__default.JournalRangeParses#requires(jr#0, jes#0) == true);

// definition axiom for JournalRanges.__default.JournalRangeParses(revealed)
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    { JournalRanges.__default.JournalRangeParses(jr#0, jes#0) } 
    JournalRanges.__default.JournalRangeParses#canCall(jr#0, jes#0)
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0))
         && JournalRanges.__default.parseJournalRange#canCall(jr#0)
         && JournalRanges.__default.JournalRangeParses(jr#0, jes#0)
           == Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), jr#0), 
            #Options.Option.Some($Box(jes#0))));

// definition axiom for JournalRanges.__default.JournalRangeParses for all literals(revealed)
axiom true
   ==> (forall jr#0: Seq Box, jes#0: Seq Box :: 
    {:weight 3} { JournalRanges.__default.JournalRangeParses(Lit(jr#0), Lit(jes#0)) } 
    JournalRanges.__default.JournalRangeParses#canCall(Lit(jr#0), Lit(jes#0))
         || ($Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && $Is(jes#0, TSeq(Tclass.Journal.JournalEntry())))
       ==> $IsA#Options.Option(JournalRanges.__default.parseJournalRange($LS($LZ), Lit(jr#0)))
         && JournalRanges.__default.parseJournalRange#canCall(Lit(jr#0))
         && JournalRanges.__default.JournalRangeParses(Lit(jr#0), Lit(jes#0))
           == Options.Option#Equal(JournalRanges.__default.parseJournalRange($LS($LZ), Lit(jr#0)), 
            #Options.Option.Some($Box(Lit(jes#0)))));

// Constructor function declaration
function #SectorType.Superblock.Superblock(int, int, int, DatatypeType) : DatatypeType;

const unique ##SectorType.Superblock.Superblock: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int, a#0#2#0: int, a#0#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0) } 
  DatatypeCtorId(#SectorType.Superblock.Superblock(a#0#0#0, a#0#1#0, a#0#2#0, a#0#3#0))
     == ##SectorType.Superblock.Superblock);

function SectorType.Superblock.Superblock_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { SectorType.Superblock.Superblock_q(d) } 
  SectorType.Superblock.Superblock_q(d)
     <==> DatatypeCtorId(d) == ##SectorType.Superblock.Superblock);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { SectorType.Superblock.Superblock_q(d) } 
  SectorType.Superblock.Superblock_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int, a#1#2#0: int, a#1#3#0: DatatypeType :: 
      d == #SectorType.Superblock.Superblock(a#1#0#0, a#1#1#0, a#1#2#0, a#1#3#0)));

function Tclass.SectorType.Superblock() : Ty;

// Tclass.SectorType.Superblock Tag
axiom Tag(Tclass.SectorType.Superblock()) == Tagclass.SectorType.Superblock;

const unique Tagclass.SectorType.Superblock: TyTag;

// Box/unbox axiom for Tclass.SectorType.Superblock
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SectorType.Superblock()) } 
  $IsBox(bx, Tclass.SectorType.Superblock())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.SectorType.Superblock()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int, a#2#2#0: int, a#2#3#0: DatatypeType :: 
  { $Is(#SectorType.Superblock.Superblock(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), 
      Tclass.SectorType.Superblock()) } 
  $Is(#SectorType.Superblock.Superblock(a#2#0#0, a#2#1#0, a#2#2#0, a#2#3#0), 
      Tclass.SectorType.Superblock())
     <==> $Is(a#2#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#2#0, Tclass.NativeTypes.uint64())
       && $Is(a#2#3#0, Tclass.DiskLayout.Location()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, a#3#2#0: int, a#3#3#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#SectorType.Superblock.Superblock(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0), 
      Tclass.SectorType.Superblock(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#SectorType.Superblock.Superblock(a#3#0#0, a#3#1#0, a#3#2#0, a#3#3#0), 
        Tclass.SectorType.Superblock(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#2#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#3#3#0, Tclass.DiskLayout.Location(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Superblock.counter(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Superblock.Superblock_q(d)
       && $IsAlloc(d, Tclass.SectorType.Superblock(), $h)
     ==> $IsAlloc(SectorType.Superblock.counter(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Superblock.journalStart(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Superblock.Superblock_q(d)
       && $IsAlloc(d, Tclass.SectorType.Superblock(), $h)
     ==> $IsAlloc(SectorType.Superblock.journalStart(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Superblock.journalLen(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Superblock.Superblock_q(d)
       && $IsAlloc(d, Tclass.SectorType.Superblock(), $h)
     ==> $IsAlloc(SectorType.Superblock.journalLen(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Superblock.indirectionTableLoc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Superblock.Superblock_q(d)
       && $IsAlloc(d, Tclass.SectorType.Superblock(), $h)
     ==> $IsAlloc(SectorType.Superblock.indirectionTableLoc(d), Tclass.DiskLayout.Location(), $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int, a#4#2#0: int, a#4#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(LitInt(a#4#0#0), LitInt(a#4#1#0), LitInt(a#4#2#0), Lit(a#4#3#0)) } 
  #SectorType.Superblock.Superblock(LitInt(a#4#0#0), LitInt(a#4#1#0), LitInt(a#4#2#0), Lit(a#4#3#0))
     == Lit(#SectorType.Superblock.Superblock(a#4#0#0, a#4#1#0, a#4#2#0, a#4#3#0)));

function SectorType.Superblock.counter(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int, a#5#2#0: int, a#5#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0) } 
  SectorType.Superblock.counter(#SectorType.Superblock.Superblock(a#5#0#0, a#5#1#0, a#5#2#0, a#5#3#0))
     == a#5#0#0);

function SectorType.Superblock.journalStart(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int, a#6#2#0: int, a#6#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0) } 
  SectorType.Superblock.journalStart(#SectorType.Superblock.Superblock(a#6#0#0, a#6#1#0, a#6#2#0, a#6#3#0))
     == a#6#1#0);

function SectorType.Superblock.journalLen(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#7#0#0: int, a#7#1#0: int, a#7#2#0: int, a#7#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0) } 
  SectorType.Superblock.journalLen(#SectorType.Superblock.Superblock(a#7#0#0, a#7#1#0, a#7#2#0, a#7#3#0))
     == a#7#2#0);

function SectorType.Superblock.indirectionTableLoc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#8#0#0: int, a#8#1#0: int, a#8#2#0: int, a#8#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0) } 
  SectorType.Superblock.indirectionTableLoc(#SectorType.Superblock.Superblock(a#8#0#0, a#8#1#0, a#8#2#0, a#8#3#0))
     == a#8#3#0);

// Inductive rank
axiom (forall a#9#0#0: int, a#9#1#0: int, a#9#2#0: int, a#9#3#0: DatatypeType :: 
  { #SectorType.Superblock.Superblock(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0) } 
  DtRank(a#9#3#0)
     < DtRank(#SectorType.Superblock.Superblock(a#9#0#0, a#9#1#0, a#9#2#0, a#9#3#0)));

// Depth-one case-split function
function $IsA#SectorType.Superblock(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#SectorType.Superblock(d) } 
  $IsA#SectorType.Superblock(d) ==> SectorType.Superblock.Superblock_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { SectorType.Superblock.Superblock_q(d), $Is(d, Tclass.SectorType.Superblock()) } 
  $Is(d, Tclass.SectorType.Superblock()) ==> SectorType.Superblock.Superblock_q(d));

// Datatype extensional equality declaration
function SectorType.Superblock#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #SectorType.Superblock.Superblock
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.Superblock#Equal(a, b) } 
  true
     ==> (SectorType.Superblock#Equal(a, b)
       <==> SectorType.Superblock.counter(a) == SectorType.Superblock.counter(b)
         && SectorType.Superblock.journalStart(a) == SectorType.Superblock.journalStart(b)
         && SectorType.Superblock.journalLen(a) == SectorType.Superblock.journalLen(b)
         && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(a), 
          SectorType.Superblock.indirectionTableLoc(b))));

// Datatype extensionality axiom: SectorType.Superblock
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.Superblock#Equal(a, b) } 
  SectorType.Superblock#Equal(a, b) <==> a == b);

const unique class.SectorType.Superblock: ClassName;

// Constructor function declaration
function #SectorType.IndirectionTable.IndirectionTable(Map Box Box, Map Box Box) : DatatypeType;

const unique ##SectorType.IndirectionTable.IndirectionTable: DtCtorId;

// Constructor identifier
axiom (forall a#10#0#0: Map Box Box, a#10#1#0: Map Box Box :: 
  { #SectorType.IndirectionTable.IndirectionTable(a#10#0#0, a#10#1#0) } 
  DatatypeCtorId(#SectorType.IndirectionTable.IndirectionTable(a#10#0#0, a#10#1#0))
     == ##SectorType.IndirectionTable.IndirectionTable);

function SectorType.IndirectionTable.IndirectionTable_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { SectorType.IndirectionTable.IndirectionTable_q(d) } 
  SectorType.IndirectionTable.IndirectionTable_q(d)
     <==> DatatypeCtorId(d) == ##SectorType.IndirectionTable.IndirectionTable);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { SectorType.IndirectionTable.IndirectionTable_q(d) } 
  SectorType.IndirectionTable.IndirectionTable_q(d)
     ==> (exists a#11#0#0: Map Box Box, a#11#1#0: Map Box Box :: 
      d == #SectorType.IndirectionTable.IndirectionTable(a#11#0#0, a#11#1#0)));

// Constructor $Is
axiom (forall a#12#0#0: Map Box Box, a#12#1#0: Map Box Box :: 
  { $Is(#SectorType.IndirectionTable.IndirectionTable(a#12#0#0, a#12#1#0), 
      Tclass.SectorType.IndirectionTable()) } 
  $Is(#SectorType.IndirectionTable.IndirectionTable(a#12#0#0, a#12#1#0), 
      Tclass.SectorType.IndirectionTable())
     <==> $Is(a#12#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
       && $Is(a#12#1#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))));

// Constructor $IsAlloc
axiom (forall a#13#0#0: Map Box Box, a#13#1#0: Map Box Box, $h: Heap :: 
  { $IsAlloc(#SectorType.IndirectionTable.IndirectionTable(a#13#0#0, a#13#1#0), 
      Tclass.SectorType.IndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#SectorType.IndirectionTable.IndirectionTable(a#13#0#0, a#13#1#0), 
        Tclass.SectorType.IndirectionTable(), 
        $h)
       <==> $IsAlloc(a#13#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#13#1#0, 
          TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
          $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.IndirectionTable.locs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.SectorType.IndirectionTable(), $h)
     ==> $IsAlloc(SectorType.IndirectionTable.locs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.IndirectionTable.graph(d), 
      TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.SectorType.IndirectionTable(), $h)
     ==> $IsAlloc(SectorType.IndirectionTable.graph(d), 
      TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
      $h));

// Constructor literal
axiom (forall a#14#0#0: Map Box Box, a#14#1#0: Map Box Box :: 
  { #SectorType.IndirectionTable.IndirectionTable(Lit(a#14#0#0), Lit(a#14#1#0)) } 
  #SectorType.IndirectionTable.IndirectionTable(Lit(a#14#0#0), Lit(a#14#1#0))
     == Lit(#SectorType.IndirectionTable.IndirectionTable(a#14#0#0, a#14#1#0)));

function SectorType.IndirectionTable.locs(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#15#0#0: Map Box Box, a#15#1#0: Map Box Box :: 
  { #SectorType.IndirectionTable.IndirectionTable(a#15#0#0, a#15#1#0) } 
  SectorType.IndirectionTable.locs(#SectorType.IndirectionTable.IndirectionTable(a#15#0#0, a#15#1#0))
     == a#15#0#0);

// Inductive map key rank
axiom (forall a#16#0#0: Map Box Box, a#16#1#0: Map Box Box, d: DatatypeType :: 
  { Map#Domain(a#16#0#0)[$Box(d)], #SectorType.IndirectionTable.IndirectionTable(a#16#0#0, a#16#1#0) } 
  Map#Domain(a#16#0#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#SectorType.IndirectionTable.IndirectionTable(a#16#0#0, a#16#1#0)));

// Inductive map value rank
axiom (forall a#17#0#0: Map Box Box, a#17#1#0: Map Box Box, bx: Box :: 
  { Map#Domain(a#17#0#0)[bx], #SectorType.IndirectionTable.IndirectionTable(a#17#0#0, a#17#1#0) } 
  Map#Domain(a#17#0#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#17#0#0)[bx]): DatatypeType)
       < DtRank(#SectorType.IndirectionTable.IndirectionTable(a#17#0#0, a#17#1#0)));

function SectorType.IndirectionTable.graph(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#18#0#0: Map Box Box, a#18#1#0: Map Box Box :: 
  { #SectorType.IndirectionTable.IndirectionTable(a#18#0#0, a#18#1#0) } 
  SectorType.IndirectionTable.graph(#SectorType.IndirectionTable.IndirectionTable(a#18#0#0, a#18#1#0))
     == a#18#1#0);

// Inductive map key rank
axiom (forall a#19#0#0: Map Box Box, a#19#1#0: Map Box Box, d: DatatypeType :: 
  { Map#Domain(a#19#1#0)[$Box(d)], #SectorType.IndirectionTable.IndirectionTable(a#19#0#0, a#19#1#0) } 
  Map#Domain(a#19#1#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#SectorType.IndirectionTable.IndirectionTable(a#19#0#0, a#19#1#0)));

// Inductive map value rank
axiom (forall a#20#0#0: Map Box Box, a#20#1#0: Map Box Box, bx: Box :: 
  { Map#Domain(a#20#1#0)[bx], #SectorType.IndirectionTable.IndirectionTable(a#20#0#0, a#20#1#0) } 
  Map#Domain(a#20#1#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#20#1#0)[bx]): DatatypeType)
       < DtRank(#SectorType.IndirectionTable.IndirectionTable(a#20#0#0, a#20#1#0)));

// Depth-one case-split function
function $IsA#SectorType.IndirectionTable(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#SectorType.IndirectionTable(d) } 
  $IsA#SectorType.IndirectionTable(d)
     ==> SectorType.IndirectionTable.IndirectionTable_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { SectorType.IndirectionTable.IndirectionTable_q(d), $Is(d, Tclass.SectorType.IndirectionTable()) } 
  $Is(d, Tclass.SectorType.IndirectionTable())
     ==> SectorType.IndirectionTable.IndirectionTable_q(d));

// Datatype extensional equality declaration
function SectorType.IndirectionTable#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #SectorType.IndirectionTable.IndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.IndirectionTable#Equal(a, b) } 
  true
     ==> (SectorType.IndirectionTable#Equal(a, b)
       <==> Map#Equal(SectorType.IndirectionTable.locs(a), SectorType.IndirectionTable.locs(b))
         && Map#Equal(SectorType.IndirectionTable.graph(a), SectorType.IndirectionTable.graph(b))));

// Datatype extensionality axiom: SectorType.IndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.IndirectionTable#Equal(a, b) } 
  SectorType.IndirectionTable#Equal(a, b) <==> a == b);

const unique class.SectorType.IndirectionTable: ClassName;

// Constructor function declaration
function #SectorType.Sector.SectorSuperblock(DatatypeType) : DatatypeType;

const unique ##SectorType.Sector.SectorSuperblock: DtCtorId;

// Constructor identifier
axiom (forall a#21#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorSuperblock(a#21#0#0) } 
  DatatypeCtorId(#SectorType.Sector.SectorSuperblock(a#21#0#0))
     == ##SectorType.Sector.SectorSuperblock);

function SectorType.Sector.SectorSuperblock_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorSuperblock_q(d) } 
  SectorType.Sector.SectorSuperblock_q(d)
     <==> DatatypeCtorId(d) == ##SectorType.Sector.SectorSuperblock);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorSuperblock_q(d) } 
  SectorType.Sector.SectorSuperblock_q(d)
     ==> (exists a#22#0#0: DatatypeType :: 
      d == #SectorType.Sector.SectorSuperblock(a#22#0#0)));

function Tclass.SectorType.Sector() : Ty;

// Tclass.SectorType.Sector Tag
axiom Tag(Tclass.SectorType.Sector()) == Tagclass.SectorType.Sector;

const unique Tagclass.SectorType.Sector: TyTag;

// Box/unbox axiom for Tclass.SectorType.Sector
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SectorType.Sector()) } 
  $IsBox(bx, Tclass.SectorType.Sector())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.SectorType.Sector()));

// Constructor $Is
axiom (forall a#23#0#0: DatatypeType :: 
  { $Is(#SectorType.Sector.SectorSuperblock(a#23#0#0), Tclass.SectorType.Sector()) } 
  $Is(#SectorType.Sector.SectorSuperblock(a#23#0#0), Tclass.SectorType.Sector())
     <==> $Is(a#23#0#0, Tclass.SectorType.Superblock()));

// Constructor $IsAlloc
axiom (forall a#24#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#SectorType.Sector.SectorSuperblock(a#24#0#0), Tclass.SectorType.Sector(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#SectorType.Sector.SectorSuperblock(a#24#0#0), Tclass.SectorType.Sector(), $h)
       <==> $IsAlloc(a#24#0#0, Tclass.SectorType.Superblock(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Sector.superblock(d), Tclass.SectorType.Superblock(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Sector.SectorSuperblock_q(d)
       && $IsAlloc(d, Tclass.SectorType.Sector(), $h)
     ==> $IsAlloc(SectorType.Sector.superblock(d), Tclass.SectorType.Superblock(), $h));

// Constructor literal
axiom (forall a#25#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorSuperblock(Lit(a#25#0#0)) } 
  #SectorType.Sector.SectorSuperblock(Lit(a#25#0#0))
     == Lit(#SectorType.Sector.SectorSuperblock(a#25#0#0)));

function SectorType.Sector.superblock(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#26#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorSuperblock(a#26#0#0) } 
  SectorType.Sector.superblock(#SectorType.Sector.SectorSuperblock(a#26#0#0))
     == a#26#0#0);

// Inductive rank
axiom (forall a#27#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorSuperblock(a#27#0#0) } 
  DtRank(a#27#0#0) < DtRank(#SectorType.Sector.SectorSuperblock(a#27#0#0)));

// Constructor function declaration
function #SectorType.Sector.SectorNode(DatatypeType) : DatatypeType;

const unique ##SectorType.Sector.SectorNode: DtCtorId;

// Constructor identifier
axiom (forall a#28#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorNode(a#28#0#0) } 
  DatatypeCtorId(#SectorType.Sector.SectorNode(a#28#0#0))
     == ##SectorType.Sector.SectorNode);

function SectorType.Sector.SectorNode_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorNode_q(d) } 
  SectorType.Sector.SectorNode_q(d)
     <==> DatatypeCtorId(d) == ##SectorType.Sector.SectorNode);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorNode_q(d) } 
  SectorType.Sector.SectorNode_q(d)
     ==> (exists a#29#0#0: DatatypeType :: d == #SectorType.Sector.SectorNode(a#29#0#0)));

// Constructor $Is
axiom (forall a#30#0#0: DatatypeType :: 
  { $Is(#SectorType.Sector.SectorNode(a#30#0#0), Tclass.SectorType.Sector()) } 
  $Is(#SectorType.Sector.SectorNode(a#30#0#0), Tclass.SectorType.Sector())
     <==> $Is(a#30#0#0, Tclass.PivotBetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#31#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#SectorType.Sector.SectorNode(a#31#0#0), Tclass.SectorType.Sector(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#SectorType.Sector.SectorNode(a#31#0#0), Tclass.SectorType.Sector(), $h)
       <==> $IsAlloc(a#31#0#0, Tclass.PivotBetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Sector.node(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Sector.SectorNode_q(d)
       && $IsAlloc(d, Tclass.SectorType.Sector(), $h)
     ==> $IsAlloc(SectorType.Sector.node(d), Tclass.PivotBetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#32#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorNode(Lit(a#32#0#0)) } 
  #SectorType.Sector.SectorNode(Lit(a#32#0#0))
     == Lit(#SectorType.Sector.SectorNode(a#32#0#0)));

function SectorType.Sector.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#33#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorNode(a#33#0#0) } 
  SectorType.Sector.node(#SectorType.Sector.SectorNode(a#33#0#0)) == a#33#0#0);

// Inductive rank
axiom (forall a#34#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorNode(a#34#0#0) } 
  DtRank(a#34#0#0) < DtRank(#SectorType.Sector.SectorNode(a#34#0#0)));

// Constructor function declaration
function #SectorType.Sector.SectorIndirectionTable(DatatypeType) : DatatypeType;

const unique ##SectorType.Sector.SectorIndirectionTable: DtCtorId;

// Constructor identifier
axiom (forall a#35#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorIndirectionTable(a#35#0#0) } 
  DatatypeCtorId(#SectorType.Sector.SectorIndirectionTable(a#35#0#0))
     == ##SectorType.Sector.SectorIndirectionTable);

function SectorType.Sector.SectorIndirectionTable_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorIndirectionTable_q(d) } 
  SectorType.Sector.SectorIndirectionTable_q(d)
     <==> DatatypeCtorId(d) == ##SectorType.Sector.SectorIndirectionTable);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorIndirectionTable_q(d) } 
  SectorType.Sector.SectorIndirectionTable_q(d)
     ==> (exists a#36#0#0: DatatypeType :: 
      d == #SectorType.Sector.SectorIndirectionTable(a#36#0#0)));

// Constructor $Is
axiom (forall a#37#0#0: DatatypeType :: 
  { $Is(#SectorType.Sector.SectorIndirectionTable(a#37#0#0), Tclass.SectorType.Sector()) } 
  $Is(#SectorType.Sector.SectorIndirectionTable(a#37#0#0), Tclass.SectorType.Sector())
     <==> $Is(a#37#0#0, Tclass.SectorType.IndirectionTable()));

// Constructor $IsAlloc
axiom (forall a#38#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#SectorType.Sector.SectorIndirectionTable(a#38#0#0), 
      Tclass.SectorType.Sector(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#SectorType.Sector.SectorIndirectionTable(a#38#0#0), 
        Tclass.SectorType.Sector(), 
        $h)
       <==> $IsAlloc(a#38#0#0, Tclass.SectorType.IndirectionTable(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(SectorType.Sector.indirectionTable(d), Tclass.SectorType.IndirectionTable(), $h) } 
  $IsGoodHeap($h)
       && 
      SectorType.Sector.SectorIndirectionTable_q(d)
       && $IsAlloc(d, Tclass.SectorType.Sector(), $h)
     ==> $IsAlloc(SectorType.Sector.indirectionTable(d), Tclass.SectorType.IndirectionTable(), $h));

// Constructor literal
axiom (forall a#39#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorIndirectionTable(Lit(a#39#0#0)) } 
  #SectorType.Sector.SectorIndirectionTable(Lit(a#39#0#0))
     == Lit(#SectorType.Sector.SectorIndirectionTable(a#39#0#0)));

function SectorType.Sector.indirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#40#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorIndirectionTable(a#40#0#0) } 
  SectorType.Sector.indirectionTable(#SectorType.Sector.SectorIndirectionTable(a#40#0#0))
     == a#40#0#0);

// Inductive rank
axiom (forall a#41#0#0: DatatypeType :: 
  { #SectorType.Sector.SectorIndirectionTable(a#41#0#0) } 
  DtRank(a#41#0#0) < DtRank(#SectorType.Sector.SectorIndirectionTable(a#41#0#0)));

// Depth-one case-split function
function $IsA#SectorType.Sector(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#SectorType.Sector(d) } 
  $IsA#SectorType.Sector(d)
     ==> SectorType.Sector.SectorSuperblock_q(d)
       || SectorType.Sector.SectorNode_q(d)
       || SectorType.Sector.SectorIndirectionTable_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { SectorType.Sector.SectorIndirectionTable_q(d), $Is(d, Tclass.SectorType.Sector()) } 
    { SectorType.Sector.SectorNode_q(d), $Is(d, Tclass.SectorType.Sector()) } 
    { SectorType.Sector.SectorSuperblock_q(d), $Is(d, Tclass.SectorType.Sector()) } 
  $Is(d, Tclass.SectorType.Sector())
     ==> SectorType.Sector.SectorSuperblock_q(d)
       || SectorType.Sector.SectorNode_q(d)
       || SectorType.Sector.SectorIndirectionTable_q(d));

// Datatype extensional equality declaration
function SectorType.Sector#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #SectorType.Sector.SectorSuperblock
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.Sector#Equal(a, b), SectorType.Sector.SectorSuperblock_q(a) } 
    { SectorType.Sector#Equal(a, b), SectorType.Sector.SectorSuperblock_q(b) } 
  SectorType.Sector.SectorSuperblock_q(a)
       && SectorType.Sector.SectorSuperblock_q(b)
     ==> (SectorType.Sector#Equal(a, b)
       <==> SectorType.Superblock#Equal(SectorType.Sector.superblock(a), SectorType.Sector.superblock(b))));

// Datatype extensional equality definition: #SectorType.Sector.SectorNode
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.Sector#Equal(a, b), SectorType.Sector.SectorNode_q(a) } 
    { SectorType.Sector#Equal(a, b), SectorType.Sector.SectorNode_q(b) } 
  SectorType.Sector.SectorNode_q(a) && SectorType.Sector.SectorNode_q(b)
     ==> (SectorType.Sector#Equal(a, b)
       <==> PivotBetreeGraph.Node#Equal(SectorType.Sector.node(a), SectorType.Sector.node(b))));

// Datatype extensional equality definition: #SectorType.Sector.SectorIndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.Sector#Equal(a, b), SectorType.Sector.SectorIndirectionTable_q(a) } 
    { SectorType.Sector#Equal(a, b), SectorType.Sector.SectorIndirectionTable_q(b) } 
  SectorType.Sector.SectorIndirectionTable_q(a)
       && SectorType.Sector.SectorIndirectionTable_q(b)
     ==> (SectorType.Sector#Equal(a, b)
       <==> SectorType.IndirectionTable#Equal(SectorType.Sector.indirectionTable(a), SectorType.Sector.indirectionTable(b))));

// Datatype extensionality axiom: SectorType.Sector
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { SectorType.Sector#Equal(a, b) } 
  SectorType.Sector#Equal(a, b) <==> a == b);

const unique class.SectorType.Sector: ClassName;

const unique class.SectorType.__default: ClassName;

function Tclass.SectorType.__default() : Ty;

// Tclass.SectorType.__default Tag
axiom Tag(Tclass.SectorType.__default()) == Tagclass.SectorType.__default;

const unique Tagclass.SectorType.__default: TyTag;

// Box/unbox axiom for Tclass.SectorType.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SectorType.__default()) } 
  $IsBox(bx, Tclass.SectorType.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SectorType.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SectorType.__default()) } 
  $Is($o, Tclass.SectorType.__default())
     <==> $o == null || dtype($o) == Tclass.SectorType.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SectorType.__default(), $h) } 
  $IsAlloc($o, Tclass.SectorType.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// Constructor function declaration
function #ViewOp.VOp.StatesInternalOp() : DatatypeType;

const unique ##ViewOp.VOp.StatesInternalOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ViewOp.VOp.StatesInternalOp()) == ##ViewOp.VOp.StatesInternalOp;

function ViewOp.VOp.StatesInternalOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.StatesInternalOp_q(d) } 
  ViewOp.VOp.StatesInternalOp_q(d)
     <==> DatatypeCtorId(d) == ##ViewOp.VOp.StatesInternalOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.StatesInternalOp_q(d) } 
  ViewOp.VOp.StatesInternalOp_q(d) ==> d == #ViewOp.VOp.StatesInternalOp());

function Tclass.ViewOp.VOp() : Ty;

// Tclass.ViewOp.VOp Tag
axiom Tag(Tclass.ViewOp.VOp()) == Tagclass.ViewOp.VOp;

const unique Tagclass.ViewOp.VOp: TyTag;

// Box/unbox axiom for Tclass.ViewOp.VOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ViewOp.VOp()) } 
  $IsBox(bx, Tclass.ViewOp.VOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.ViewOp.VOp()));

// Constructor $Is
axiom $Is(#ViewOp.VOp.StatesInternalOp(), Tclass.ViewOp.VOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.StatesInternalOp(), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#ViewOp.VOp.StatesInternalOp(), Tclass.ViewOp.VOp(), $h));

// Constructor literal
axiom #ViewOp.VOp.StatesInternalOp() == Lit(#ViewOp.VOp.StatesInternalOp());

// Constructor function declaration
function #ViewOp.VOp.JournalInternalOp() : DatatypeType;

const unique ##ViewOp.VOp.JournalInternalOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ViewOp.VOp.JournalInternalOp())
   == ##ViewOp.VOp.JournalInternalOp;

function ViewOp.VOp.JournalInternalOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.JournalInternalOp_q(d) } 
  ViewOp.VOp.JournalInternalOp_q(d)
     <==> DatatypeCtorId(d) == ##ViewOp.VOp.JournalInternalOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.JournalInternalOp_q(d) } 
  ViewOp.VOp.JournalInternalOp_q(d) ==> d == #ViewOp.VOp.JournalInternalOp());

// Constructor $Is
axiom $Is(#ViewOp.VOp.JournalInternalOp(), Tclass.ViewOp.VOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.JournalInternalOp(), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#ViewOp.VOp.JournalInternalOp(), Tclass.ViewOp.VOp(), $h));

// Constructor literal
axiom #ViewOp.VOp.JournalInternalOp() == Lit(#ViewOp.VOp.JournalInternalOp());

// Constructor function declaration
function #ViewOp.VOp.AdvanceOp(DatatypeType, bool) : DatatypeType;

const unique ##ViewOp.VOp.AdvanceOp: DtCtorId;

// Constructor identifier
axiom (forall a#52#0#0: DatatypeType, a#52#1#0: bool :: 
  { #ViewOp.VOp.AdvanceOp(a#52#0#0, a#52#1#0) } 
  DatatypeCtorId(#ViewOp.VOp.AdvanceOp(a#52#0#0, a#52#1#0))
     == ##ViewOp.VOp.AdvanceOp);

function ViewOp.VOp.AdvanceOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.AdvanceOp_q(d) } 
  ViewOp.VOp.AdvanceOp_q(d) <==> DatatypeCtorId(d) == ##ViewOp.VOp.AdvanceOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.AdvanceOp_q(d) } 
  ViewOp.VOp.AdvanceOp_q(d)
     ==> (exists a#53#0#0: DatatypeType, a#53#1#0: bool :: 
      d == #ViewOp.VOp.AdvanceOp(a#53#0#0, a#53#1#0)));

// Constructor $Is
axiom (forall a#54#0#0: DatatypeType, a#54#1#0: bool :: 
  { $Is(#ViewOp.VOp.AdvanceOp(a#54#0#0, a#54#1#0), Tclass.ViewOp.VOp()) } 
  $Is(#ViewOp.VOp.AdvanceOp(a#54#0#0, a#54#1#0), Tclass.ViewOp.VOp())
     <==> $Is(a#54#0#0, Tclass.UI.Op()) && $Is(a#54#1#0, TBool));

// Constructor $IsAlloc
axiom (forall a#55#0#0: DatatypeType, a#55#1#0: bool, $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.AdvanceOp(a#55#0#0, a#55#1#0), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ViewOp.VOp.AdvanceOp(a#55#0#0, a#55#1#0), Tclass.ViewOp.VOp(), $h)
       <==> $IsAlloc(a#55#0#0, Tclass.UI.Op(), $h) && $IsAlloc(a#55#1#0, TBool, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ViewOp.VOp.uiop(d), Tclass.UI.Op(), $h) } 
  $IsGoodHeap($h)
       && 
      ViewOp.VOp.AdvanceOp_q(d)
       && $IsAlloc(d, Tclass.ViewOp.VOp(), $h)
     ==> $IsAlloc(ViewOp.VOp.uiop(d), Tclass.UI.Op(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ViewOp.VOp.replay(d), TBool, $h) } 
  $IsGoodHeap($h)
       && 
      ViewOp.VOp.AdvanceOp_q(d)
       && $IsAlloc(d, Tclass.ViewOp.VOp(), $h)
     ==> $IsAlloc(ViewOp.VOp.replay(d), TBool, $h));

// Constructor literal
axiom (forall a#56#0#0: DatatypeType, a#56#1#0: bool :: 
  { #ViewOp.VOp.AdvanceOp(Lit(a#56#0#0), Lit(a#56#1#0)) } 
  #ViewOp.VOp.AdvanceOp(Lit(a#56#0#0), Lit(a#56#1#0))
     == Lit(#ViewOp.VOp.AdvanceOp(a#56#0#0, a#56#1#0)));

function ViewOp.VOp.uiop(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#57#0#0: DatatypeType, a#57#1#0: bool :: 
  { #ViewOp.VOp.AdvanceOp(a#57#0#0, a#57#1#0) } 
  ViewOp.VOp.uiop(#ViewOp.VOp.AdvanceOp(a#57#0#0, a#57#1#0)) == a#57#0#0);

// Inductive rank
axiom (forall a#58#0#0: DatatypeType, a#58#1#0: bool :: 
  { #ViewOp.VOp.AdvanceOp(a#58#0#0, a#58#1#0) } 
  DtRank(a#58#0#0) < DtRank(#ViewOp.VOp.AdvanceOp(a#58#0#0, a#58#1#0)));

function ViewOp.VOp.replay(DatatypeType) : bool;

// Constructor injectivity
axiom (forall a#59#0#0: DatatypeType, a#59#1#0: bool :: 
  { #ViewOp.VOp.AdvanceOp(a#59#0#0, a#59#1#0) } 
  ViewOp.VOp.replay(#ViewOp.VOp.AdvanceOp(a#59#0#0, a#59#1#0)) == a#59#1#0);

// Constructor function declaration
function #ViewOp.VOp.SendPersistentLocOp(DatatypeType) : DatatypeType;

const unique ##ViewOp.VOp.SendPersistentLocOp: DtCtorId;

// Constructor identifier
axiom (forall a#60#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendPersistentLocOp(a#60#0#0) } 
  DatatypeCtorId(#ViewOp.VOp.SendPersistentLocOp(a#60#0#0))
     == ##ViewOp.VOp.SendPersistentLocOp);

function ViewOp.VOp.SendPersistentLocOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.SendPersistentLocOp_q(d) } 
  ViewOp.VOp.SendPersistentLocOp_q(d)
     <==> DatatypeCtorId(d) == ##ViewOp.VOp.SendPersistentLocOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.SendPersistentLocOp_q(d) } 
  ViewOp.VOp.SendPersistentLocOp_q(d)
     ==> (exists a#61#0#0: DatatypeType :: 
      d == #ViewOp.VOp.SendPersistentLocOp(a#61#0#0)));

// Constructor $Is
axiom (forall a#62#0#0: DatatypeType :: 
  { $Is(#ViewOp.VOp.SendPersistentLocOp(a#62#0#0), Tclass.ViewOp.VOp()) } 
  $Is(#ViewOp.VOp.SendPersistentLocOp(a#62#0#0), Tclass.ViewOp.VOp())
     <==> $Is(a#62#0#0, Tclass.DiskLayout.Location()));

// Constructor $IsAlloc
axiom (forall a#63#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.SendPersistentLocOp(a#63#0#0), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ViewOp.VOp.SendPersistentLocOp(a#63#0#0), Tclass.ViewOp.VOp(), $h)
       <==> $IsAlloc(a#63#0#0, Tclass.DiskLayout.Location(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ViewOp.VOp.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      ViewOp.VOp.SendPersistentLocOp_q(d)
       && $IsAlloc(d, Tclass.ViewOp.VOp(), $h)
     ==> $IsAlloc(ViewOp.VOp.loc(d), Tclass.DiskLayout.Location(), $h));

// Constructor literal
axiom (forall a#64#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendPersistentLocOp(Lit(a#64#0#0)) } 
  #ViewOp.VOp.SendPersistentLocOp(Lit(a#64#0#0))
     == Lit(#ViewOp.VOp.SendPersistentLocOp(a#64#0#0)));

function ViewOp.VOp.loc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#65#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendPersistentLocOp(a#65#0#0) } 
  ViewOp.VOp.loc(#ViewOp.VOp.SendPersistentLocOp(a#65#0#0)) == a#65#0#0);

// Inductive rank
axiom (forall a#66#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendPersistentLocOp(a#66#0#0) } 
  DtRank(a#66#0#0) < DtRank(#ViewOp.VOp.SendPersistentLocOp(a#66#0#0)));

// Constructor function declaration
function #ViewOp.VOp.FreezeOp() : DatatypeType;

const unique ##ViewOp.VOp.FreezeOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ViewOp.VOp.FreezeOp()) == ##ViewOp.VOp.FreezeOp;

function ViewOp.VOp.FreezeOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.FreezeOp_q(d) } 
  ViewOp.VOp.FreezeOp_q(d) <==> DatatypeCtorId(d) == ##ViewOp.VOp.FreezeOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.FreezeOp_q(d) } 
  ViewOp.VOp.FreezeOp_q(d) ==> d == #ViewOp.VOp.FreezeOp());

// Constructor $Is
axiom $Is(#ViewOp.VOp.FreezeOp(), Tclass.ViewOp.VOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.FreezeOp(), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#ViewOp.VOp.FreezeOp(), Tclass.ViewOp.VOp(), $h));

// Constructor literal
axiom #ViewOp.VOp.FreezeOp() == Lit(#ViewOp.VOp.FreezeOp());

// Constructor function declaration
function #ViewOp.VOp.SendFrozenLocOp(DatatypeType) : DatatypeType;

const unique ##ViewOp.VOp.SendFrozenLocOp: DtCtorId;

// Constructor identifier
axiom (forall a#72#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendFrozenLocOp(a#72#0#0) } 
  DatatypeCtorId(#ViewOp.VOp.SendFrozenLocOp(a#72#0#0))
     == ##ViewOp.VOp.SendFrozenLocOp);

function ViewOp.VOp.SendFrozenLocOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.SendFrozenLocOp_q(d) } 
  ViewOp.VOp.SendFrozenLocOp_q(d)
     <==> DatatypeCtorId(d) == ##ViewOp.VOp.SendFrozenLocOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.SendFrozenLocOp_q(d) } 
  ViewOp.VOp.SendFrozenLocOp_q(d)
     ==> (exists a#73#0#0: DatatypeType :: d == #ViewOp.VOp.SendFrozenLocOp(a#73#0#0)));

// Constructor $Is
axiom (forall a#74#0#0: DatatypeType :: 
  { $Is(#ViewOp.VOp.SendFrozenLocOp(a#74#0#0), Tclass.ViewOp.VOp()) } 
  $Is(#ViewOp.VOp.SendFrozenLocOp(a#74#0#0), Tclass.ViewOp.VOp())
     <==> $Is(a#74#0#0, Tclass.DiskLayout.Location()));

// Constructor $IsAlloc
axiom (forall a#75#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.SendFrozenLocOp(a#75#0#0), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ViewOp.VOp.SendFrozenLocOp(a#75#0#0), Tclass.ViewOp.VOp(), $h)
       <==> $IsAlloc(a#75#0#0, Tclass.DiskLayout.Location(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ViewOp.VOp.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      ViewOp.VOp.SendFrozenLocOp_q(d)
       && $IsAlloc(d, Tclass.ViewOp.VOp(), $h)
     ==> $IsAlloc(ViewOp.VOp.loc(d), Tclass.DiskLayout.Location(), $h));

// Constructor literal
axiom (forall a#76#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendFrozenLocOp(Lit(a#76#0#0)) } 
  #ViewOp.VOp.SendFrozenLocOp(Lit(a#76#0#0))
     == Lit(#ViewOp.VOp.SendFrozenLocOp(a#76#0#0)));

// Constructor injectivity
axiom (forall a#77#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendFrozenLocOp(a#77#0#0) } 
  ViewOp.VOp.loc(#ViewOp.VOp.SendFrozenLocOp(a#77#0#0)) == a#77#0#0);

// Inductive rank
axiom (forall a#78#0#0: DatatypeType :: 
  { #ViewOp.VOp.SendFrozenLocOp(a#78#0#0) } 
  DtRank(a#78#0#0) < DtRank(#ViewOp.VOp.SendFrozenLocOp(a#78#0#0)));

// Constructor function declaration
function #ViewOp.VOp.CleanUpOp() : DatatypeType;

const unique ##ViewOp.VOp.CleanUpOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ViewOp.VOp.CleanUpOp()) == ##ViewOp.VOp.CleanUpOp;

function ViewOp.VOp.CleanUpOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.CleanUpOp_q(d) } 
  ViewOp.VOp.CleanUpOp_q(d) <==> DatatypeCtorId(d) == ##ViewOp.VOp.CleanUpOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.CleanUpOp_q(d) } 
  ViewOp.VOp.CleanUpOp_q(d) ==> d == #ViewOp.VOp.CleanUpOp());

// Constructor $Is
axiom $Is(#ViewOp.VOp.CleanUpOp(), Tclass.ViewOp.VOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.CleanUpOp(), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#ViewOp.VOp.CleanUpOp(), Tclass.ViewOp.VOp(), $h));

// Constructor literal
axiom #ViewOp.VOp.CleanUpOp() == Lit(#ViewOp.VOp.CleanUpOp());

// Constructor function declaration
function #ViewOp.VOp.CrashOp() : DatatypeType;

const unique ##ViewOp.VOp.CrashOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#ViewOp.VOp.CrashOp()) == ##ViewOp.VOp.CrashOp;

function ViewOp.VOp.CrashOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.CrashOp_q(d) } 
  ViewOp.VOp.CrashOp_q(d) <==> DatatypeCtorId(d) == ##ViewOp.VOp.CrashOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.CrashOp_q(d) } 
  ViewOp.VOp.CrashOp_q(d) ==> d == #ViewOp.VOp.CrashOp());

// Constructor $Is
axiom $Is(#ViewOp.VOp.CrashOp(), Tclass.ViewOp.VOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.CrashOp(), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h) ==> $IsAlloc(#ViewOp.VOp.CrashOp(), Tclass.ViewOp.VOp(), $h));

// Constructor literal
axiom #ViewOp.VOp.CrashOp() == Lit(#ViewOp.VOp.CrashOp());

// Constructor function declaration
function #ViewOp.VOp.PushSyncOp(int) : DatatypeType;

const unique ##ViewOp.VOp.PushSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#89#0#0: int :: 
  { #ViewOp.VOp.PushSyncOp(a#89#0#0) } 
  DatatypeCtorId(#ViewOp.VOp.PushSyncOp(a#89#0#0)) == ##ViewOp.VOp.PushSyncOp);

function ViewOp.VOp.PushSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.PushSyncOp_q(d) } 
  ViewOp.VOp.PushSyncOp_q(d) <==> DatatypeCtorId(d) == ##ViewOp.VOp.PushSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.PushSyncOp_q(d) } 
  ViewOp.VOp.PushSyncOp_q(d)
     ==> (exists a#90#0#0: int :: d == #ViewOp.VOp.PushSyncOp(a#90#0#0)));

// Constructor $Is
axiom (forall a#91#0#0: int :: 
  { $Is(#ViewOp.VOp.PushSyncOp(a#91#0#0), Tclass.ViewOp.VOp()) } 
  $Is(#ViewOp.VOp.PushSyncOp(a#91#0#0), Tclass.ViewOp.VOp())
     <==> $Is(a#91#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#92#0#0: int, $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.PushSyncOp(a#92#0#0), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ViewOp.VOp.PushSyncOp(a#92#0#0), Tclass.ViewOp.VOp(), $h)
       <==> $IsAlloc(a#92#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ViewOp.VOp.id(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      ViewOp.VOp.PushSyncOp_q(d)
       && $IsAlloc(d, Tclass.ViewOp.VOp(), $h)
     ==> $IsAlloc(ViewOp.VOp.id(d), TInt, $h));

// Constructor literal
axiom (forall a#93#0#0: int :: 
  { #ViewOp.VOp.PushSyncOp(LitInt(a#93#0#0)) } 
  #ViewOp.VOp.PushSyncOp(LitInt(a#93#0#0))
     == Lit(#ViewOp.VOp.PushSyncOp(a#93#0#0)));

function ViewOp.VOp.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#94#0#0: int :: 
  { #ViewOp.VOp.PushSyncOp(a#94#0#0) } 
  ViewOp.VOp.id(#ViewOp.VOp.PushSyncOp(a#94#0#0)) == a#94#0#0);

// Constructor function declaration
function #ViewOp.VOp.PopSyncOp(int) : DatatypeType;

const unique ##ViewOp.VOp.PopSyncOp: DtCtorId;

// Constructor identifier
axiom (forall a#95#0#0: int :: 
  { #ViewOp.VOp.PopSyncOp(a#95#0#0) } 
  DatatypeCtorId(#ViewOp.VOp.PopSyncOp(a#95#0#0)) == ##ViewOp.VOp.PopSyncOp);

function ViewOp.VOp.PopSyncOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.PopSyncOp_q(d) } 
  ViewOp.VOp.PopSyncOp_q(d) <==> DatatypeCtorId(d) == ##ViewOp.VOp.PopSyncOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.PopSyncOp_q(d) } 
  ViewOp.VOp.PopSyncOp_q(d)
     ==> (exists a#96#0#0: int :: d == #ViewOp.VOp.PopSyncOp(a#96#0#0)));

// Constructor $Is
axiom (forall a#97#0#0: int :: 
  { $Is(#ViewOp.VOp.PopSyncOp(a#97#0#0), Tclass.ViewOp.VOp()) } 
  $Is(#ViewOp.VOp.PopSyncOp(a#97#0#0), Tclass.ViewOp.VOp())
     <==> $Is(a#97#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#98#0#0: int, $h: Heap :: 
  { $IsAlloc(#ViewOp.VOp.PopSyncOp(a#98#0#0), Tclass.ViewOp.VOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#ViewOp.VOp.PopSyncOp(a#98#0#0), Tclass.ViewOp.VOp(), $h)
       <==> $IsAlloc(a#98#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(ViewOp.VOp.id(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      ViewOp.VOp.PopSyncOp_q(d)
       && $IsAlloc(d, Tclass.ViewOp.VOp(), $h)
     ==> $IsAlloc(ViewOp.VOp.id(d), TInt, $h));

// Constructor literal
axiom (forall a#99#0#0: int :: 
  { #ViewOp.VOp.PopSyncOp(LitInt(a#99#0#0)) } 
  #ViewOp.VOp.PopSyncOp(LitInt(a#99#0#0)) == Lit(#ViewOp.VOp.PopSyncOp(a#99#0#0)));

// Constructor injectivity
axiom (forall a#100#0#0: int :: 
  { #ViewOp.VOp.PopSyncOp(a#100#0#0) } 
  ViewOp.VOp.id(#ViewOp.VOp.PopSyncOp(a#100#0#0)) == a#100#0#0);

// Depth-one case-split function
function $IsA#ViewOp.VOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#ViewOp.VOp(d) } 
  $IsA#ViewOp.VOp(d)
     ==> ViewOp.VOp.StatesInternalOp_q(d)
       || ViewOp.VOp.JournalInternalOp_q(d)
       || ViewOp.VOp.AdvanceOp_q(d)
       || ViewOp.VOp.SendPersistentLocOp_q(d)
       || ViewOp.VOp.FreezeOp_q(d)
       || ViewOp.VOp.SendFrozenLocOp_q(d)
       || ViewOp.VOp.CleanUpOp_q(d)
       || ViewOp.VOp.CrashOp_q(d)
       || ViewOp.VOp.PushSyncOp_q(d)
       || ViewOp.VOp.PopSyncOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { ViewOp.VOp.PopSyncOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.PushSyncOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.CrashOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.CleanUpOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.SendFrozenLocOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.FreezeOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.SendPersistentLocOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.AdvanceOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.JournalInternalOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
    { ViewOp.VOp.StatesInternalOp_q(d), $Is(d, Tclass.ViewOp.VOp()) } 
  $Is(d, Tclass.ViewOp.VOp())
     ==> ViewOp.VOp.StatesInternalOp_q(d)
       || ViewOp.VOp.JournalInternalOp_q(d)
       || ViewOp.VOp.AdvanceOp_q(d)
       || ViewOp.VOp.SendPersistentLocOp_q(d)
       || ViewOp.VOp.FreezeOp_q(d)
       || ViewOp.VOp.SendFrozenLocOp_q(d)
       || ViewOp.VOp.CleanUpOp_q(d)
       || ViewOp.VOp.CrashOp_q(d)
       || ViewOp.VOp.PushSyncOp_q(d)
       || ViewOp.VOp.PopSyncOp_q(d));

// Datatype extensional equality declaration
function ViewOp.VOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #ViewOp.VOp.StatesInternalOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.StatesInternalOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.StatesInternalOp_q(b) } 
  ViewOp.VOp.StatesInternalOp_q(a) && ViewOp.VOp.StatesInternalOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> true));

// Datatype extensional equality definition: #ViewOp.VOp.JournalInternalOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.JournalInternalOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.JournalInternalOp_q(b) } 
  ViewOp.VOp.JournalInternalOp_q(a) && ViewOp.VOp.JournalInternalOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> true));

// Datatype extensional equality definition: #ViewOp.VOp.AdvanceOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.AdvanceOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.AdvanceOp_q(b) } 
  ViewOp.VOp.AdvanceOp_q(a) && ViewOp.VOp.AdvanceOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b)
       <==> UI.Op#Equal(ViewOp.VOp.uiop(a), ViewOp.VOp.uiop(b))
         && ViewOp.VOp.replay(a) == ViewOp.VOp.replay(b)));

// Datatype extensional equality definition: #ViewOp.VOp.SendPersistentLocOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.SendPersistentLocOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.SendPersistentLocOp_q(b) } 
  ViewOp.VOp.SendPersistentLocOp_q(a) && ViewOp.VOp.SendPersistentLocOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b)
       <==> DiskLayout.Location#Equal(ViewOp.VOp.loc(a), ViewOp.VOp.loc(b))));

// Datatype extensional equality definition: #ViewOp.VOp.FreezeOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.FreezeOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.FreezeOp_q(b) } 
  ViewOp.VOp.FreezeOp_q(a) && ViewOp.VOp.FreezeOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> true));

// Datatype extensional equality definition: #ViewOp.VOp.SendFrozenLocOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.SendFrozenLocOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.SendFrozenLocOp_q(b) } 
  ViewOp.VOp.SendFrozenLocOp_q(a) && ViewOp.VOp.SendFrozenLocOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b)
       <==> DiskLayout.Location#Equal(ViewOp.VOp.loc(a), ViewOp.VOp.loc(b))));

// Datatype extensional equality definition: #ViewOp.VOp.CleanUpOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.CleanUpOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.CleanUpOp_q(b) } 
  ViewOp.VOp.CleanUpOp_q(a) && ViewOp.VOp.CleanUpOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> true));

// Datatype extensional equality definition: #ViewOp.VOp.CrashOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.CrashOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.CrashOp_q(b) } 
  ViewOp.VOp.CrashOp_q(a) && ViewOp.VOp.CrashOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> true));

// Datatype extensional equality definition: #ViewOp.VOp.PushSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.PushSyncOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.PushSyncOp_q(b) } 
  ViewOp.VOp.PushSyncOp_q(a) && ViewOp.VOp.PushSyncOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> ViewOp.VOp.id(a) == ViewOp.VOp.id(b)));

// Datatype extensional equality definition: #ViewOp.VOp.PopSyncOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b), ViewOp.VOp.PopSyncOp_q(a) } 
    { ViewOp.VOp#Equal(a, b), ViewOp.VOp.PopSyncOp_q(b) } 
  ViewOp.VOp.PopSyncOp_q(a) && ViewOp.VOp.PopSyncOp_q(b)
     ==> (ViewOp.VOp#Equal(a, b) <==> ViewOp.VOp.id(a) == ViewOp.VOp.id(b)));

// Datatype extensionality axiom: ViewOp.VOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { ViewOp.VOp#Equal(a, b) } 
  ViewOp.VOp#Equal(a, b) <==> a == b);

const unique class.ViewOp.VOp: ClassName;

const unique class.ViewOp.__default: ClassName;

function Tclass.ViewOp.__default() : Ty;

// Tclass.ViewOp.__default Tag
axiom Tag(Tclass.ViewOp.__default()) == Tagclass.ViewOp.__default;

const unique Tagclass.ViewOp.__default: TyTag;

// Box/unbox axiom for Tclass.ViewOp.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.ViewOp.__default()) } 
  $IsBox(bx, Tclass.ViewOp.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.ViewOp.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.ViewOp.__default()) } 
  $Is($o, Tclass.ViewOp.__default())
     <==> $o == null || dtype($o) == Tclass.ViewOp.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.ViewOp.__default(), $h) } 
  $IsAlloc($o, Tclass.ViewOp.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for ViewOp._default.VOpAgreesUIOp
function ViewOp.__default.VOpAgreesUIOp(vop#0: DatatypeType, uiop#0: DatatypeType) : bool;

function ViewOp.__default.VOpAgreesUIOp#canCall(vop#0: DatatypeType, uiop#0: DatatypeType) : bool;

// consequence axiom for ViewOp.__default.VOpAgreesUIOp
axiom true
   ==> (forall vop#0: DatatypeType, uiop#0: DatatypeType :: 
    { ViewOp.__default.VOpAgreesUIOp(vop#0, uiop#0) } 
    ViewOp.__default.VOpAgreesUIOp#canCall(vop#0, uiop#0)
         || ($Is(vop#0, Tclass.ViewOp.VOp()) && $Is(uiop#0, Tclass.UI.Op()))
       ==> true);

function ViewOp.__default.VOpAgreesUIOp#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for ViewOp.__default.VOpAgreesUIOp
axiom (forall vop#0: DatatypeType, uiop#0: DatatypeType :: 
  { ViewOp.__default.VOpAgreesUIOp#requires(vop#0, uiop#0) } 
  $Is(vop#0, Tclass.ViewOp.VOp()) && $Is(uiop#0, Tclass.UI.Op())
     ==> ViewOp.__default.VOpAgreesUIOp#requires(vop#0, uiop#0) == true);

// definition axiom for ViewOp.__default.VOpAgreesUIOp(revealed)
axiom true
   ==> (forall vop#0: DatatypeType, uiop#0: DatatypeType :: 
    { ViewOp.__default.VOpAgreesUIOp(vop#0, uiop#0) } 
    ViewOp.__default.VOpAgreesUIOp#canCall(vop#0, uiop#0)
         || ($Is(vop#0, Tclass.ViewOp.VOp()) && $Is(uiop#0, Tclass.UI.Op()))
       ==> (UI.Op.NoOp_q(uiop#0)
           ==> 
          ViewOp.VOp.AdvanceOp_q(vop#0)
           ==> 
          UI.Op.NoOp_q(uiop#0)
           ==> 
          !ViewOp.VOp.replay(vop#0)
           ==> $IsA#UI.Op(uiop#0) && $IsA#UI.Op(ViewOp.VOp.uiop(vop#0)))
         && ViewOp.__default.VOpAgreesUIOp(vop#0, uiop#0)
           == (
            (ViewOp.VOp.SendPersistentLocOp_q(vop#0) ==> UI.Op.NoOp_q(uiop#0))
             && (ViewOp.VOp.AdvanceOp_q(vop#0)
               ==> (ViewOp.VOp.replay(vop#0) ==> UI.Op.NoOp_q(uiop#0))
                 && (!ViewOp.VOp.replay(vop#0) ==> UI.Op#Equal(uiop#0, ViewOp.VOp.uiop(vop#0))))
             && (ViewOp.VOp.CrashOp_q(vop#0) ==> UI.Op.CrashOp_q(uiop#0))
             && (ViewOp.VOp.FreezeOp_q(vop#0) ==> UI.Op.NoOp_q(uiop#0))
             && (ViewOp.VOp.StatesInternalOp_q(vop#0) ==> UI.Op.NoOp_q(uiop#0))
             && (ViewOp.VOp.JournalInternalOp_q(vop#0) ==> UI.Op.NoOp_q(uiop#0))
             && (ViewOp.VOp.SendFrozenLocOp_q(vop#0) ==> UI.Op.NoOp_q(uiop#0))
             && (ViewOp.VOp.CleanUpOp_q(vop#0) ==> UI.Op.NoOp_q(uiop#0))
             && (ViewOp.VOp.PushSyncOp_q(vop#0)
               ==> UI.Op.PushSyncOp_q(uiop#0) && UI.Op.id(uiop#0) == ViewOp.VOp.id(vop#0))
             && (ViewOp.VOp.PopSyncOp_q(vop#0)
               ==> UI.Op.PopSyncOp_q(uiop#0) && UI.Op.id(uiop#0) == ViewOp.VOp.id(vop#0))));

// definition axiom for ViewOp.__default.VOpAgreesUIOp for all literals(revealed)
axiom true
   ==> (forall vop#0: DatatypeType, uiop#0: DatatypeType :: 
    {:weight 3} { ViewOp.__default.VOpAgreesUIOp(Lit(vop#0), Lit(uiop#0)) } 
    ViewOp.__default.VOpAgreesUIOp#canCall(Lit(vop#0), Lit(uiop#0))
         || ($Is(vop#0, Tclass.ViewOp.VOp()) && $Is(uiop#0, Tclass.UI.Op()))
       ==> (Lit(UI.Op.NoOp_q(Lit(uiop#0)))
           ==> 
          Lit(ViewOp.VOp.AdvanceOp_q(Lit(vop#0)))
           ==> 
          Lit(UI.Op.NoOp_q(Lit(uiop#0)))
           ==> 
          !Lit(ViewOp.VOp.replay(Lit(vop#0)))
           ==> $IsA#UI.Op(Lit(uiop#0)) && $IsA#UI.Op(Lit(ViewOp.VOp.uiop(Lit(vop#0)))))
         && ViewOp.__default.VOpAgreesUIOp(Lit(vop#0), Lit(uiop#0))
           == (
            (ViewOp.VOp.SendPersistentLocOp_q(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.AdvanceOp_q(Lit(vop#0))
               ==> (ViewOp.VOp.replay(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
                 && (!Lit(ViewOp.VOp.replay(Lit(vop#0)))
                   ==> UI.Op#Equal(uiop#0, ViewOp.VOp.uiop(Lit(vop#0)))))
             && (ViewOp.VOp.CrashOp_q(Lit(vop#0)) ==> UI.Op.CrashOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.FreezeOp_q(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.StatesInternalOp_q(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.JournalInternalOp_q(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.SendFrozenLocOp_q(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.CleanUpOp_q(Lit(vop#0)) ==> UI.Op.NoOp_q(Lit(uiop#0)))
             && (ViewOp.VOp.PushSyncOp_q(Lit(vop#0))
               ==> UI.Op.PushSyncOp_q(Lit(uiop#0))
                 && LitInt(UI.Op.id(Lit(uiop#0))) == LitInt(ViewOp.VOp.id(Lit(vop#0))))
             && (ViewOp.VOp.PopSyncOp_q(Lit(vop#0))
               ==> UI.Op.PopSyncOp_q(Lit(uiop#0))
                 && LitInt(UI.Op.id(Lit(uiop#0))) == LitInt(ViewOp.VOp.id(Lit(vop#0))))));

// Constructor function declaration
function #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(DatatypeType, DatatypeType) : DatatypeType;

const unique ##BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#0#0#0, a#0#1#0))
     == ##BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable);

function BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d) } 
  BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d)
     <==> DatatypeCtorId(d)
       == ##BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d) } 
  BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: DatatypeType :: 
      d
         == #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#1#0#0, a#1#1#0)));

function Tclass.BlockDisk.ReqWriteIndirectionTable() : Ty;

// Tclass.BlockDisk.ReqWriteIndirectionTable Tag
axiom Tag(Tclass.BlockDisk.ReqWriteIndirectionTable())
   == Tagclass.BlockDisk.ReqWriteIndirectionTable;

const unique Tagclass.BlockDisk.ReqWriteIndirectionTable: TyTag;

// Box/unbox axiom for Tclass.BlockDisk.ReqWriteIndirectionTable
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockDisk.ReqWriteIndirectionTable()) } 
  $IsBox(bx, Tclass.BlockDisk.ReqWriteIndirectionTable())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockDisk.ReqWriteIndirectionTable()));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType :: 
  { $Is(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#2#0#0, a#2#1#0), 
      Tclass.BlockDisk.ReqWriteIndirectionTable()) } 
  $Is(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#2#0#0, a#2#1#0), 
      Tclass.BlockDisk.ReqWriteIndirectionTable())
     <==> $Is(a#2#0#0, Tclass.DiskLayout.Location())
       && $Is(a#2#1#0, Tclass.SectorType.IndirectionTable()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#3#0#0, a#3#1#0), 
      Tclass.BlockDisk.ReqWriteIndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#3#0#0, a#3#1#0), 
        Tclass.BlockDisk.ReqWriteIndirectionTable(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.DiskLayout.Location(), $h)
         && $IsAlloc(a#3#1#0, Tclass.SectorType.IndirectionTable(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.ReqWriteIndirectionTable.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.ReqWriteIndirectionTable(), $h)
     ==> $IsAlloc(BlockDisk.ReqWriteIndirectionTable.loc(d), Tclass.DiskLayout.Location(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.ReqWriteIndirectionTable.indirectionTable(d), 
      Tclass.SectorType.IndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.ReqWriteIndirectionTable(), $h)
     ==> $IsAlloc(BlockDisk.ReqWriteIndirectionTable.indirectionTable(d), 
      Tclass.SectorType.IndirectionTable(), 
      $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#4#0#0, a#4#1#0)));

function BlockDisk.ReqWriteIndirectionTable.loc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#5#0#0, a#5#1#0) } 
  BlockDisk.ReqWriteIndirectionTable.loc(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#5#0#0, a#5#1#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#6#0#0, a#6#1#0) } 
  DtRank(a#6#0#0)
     < DtRank(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#6#0#0, a#6#1#0)));

function BlockDisk.ReqWriteIndirectionTable.indirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#7#0#0, a#7#1#0) } 
  BlockDisk.ReqWriteIndirectionTable.indirectionTable(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#7#0#0, a#7#1#0))
     == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#8#0#0, a#8#1#0) } 
  DtRank(a#8#1#0)
     < DtRank(#BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#BlockDisk.ReqWriteIndirectionTable(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockDisk.ReqWriteIndirectionTable(d) } 
  $IsA#BlockDisk.ReqWriteIndirectionTable(d)
     ==> BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d), $Is(d, Tclass.BlockDisk.ReqWriteIndirectionTable()) } 
  $Is(d, Tclass.BlockDisk.ReqWriteIndirectionTable())
     ==> BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(d));

// Datatype extensional equality declaration
function BlockDisk.ReqWriteIndirectionTable#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.ReqWriteIndirectionTable#Equal(a, b) } 
  true
     ==> (BlockDisk.ReqWriteIndirectionTable#Equal(a, b)
       <==> DiskLayout.Location#Equal(BlockDisk.ReqWriteIndirectionTable.loc(a), 
          BlockDisk.ReqWriteIndirectionTable.loc(b))
         && SectorType.IndirectionTable#Equal(BlockDisk.ReqWriteIndirectionTable.indirectionTable(a), 
          BlockDisk.ReqWriteIndirectionTable.indirectionTable(b))));

// Datatype extensionality axiom: BlockDisk.ReqWriteIndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.ReqWriteIndirectionTable#Equal(a, b) } 
  BlockDisk.ReqWriteIndirectionTable#Equal(a, b) <==> a == b);

const unique class.BlockDisk.ReqWriteIndirectionTable: ClassName;

// Constructor function declaration
function #BlockDisk.ReqWriteNode.ReqWriteNode(DatatypeType, DatatypeType) : DatatypeType;

const unique ##BlockDisk.ReqWriteNode.ReqWriteNode: DtCtorId;

// Constructor identifier
axiom (forall a#9#0#0: DatatypeType, a#9#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteNode.ReqWriteNode(a#9#0#0, a#9#1#0) } 
  DatatypeCtorId(#BlockDisk.ReqWriteNode.ReqWriteNode(a#9#0#0, a#9#1#0))
     == ##BlockDisk.ReqWriteNode.ReqWriteNode);

function BlockDisk.ReqWriteNode.ReqWriteNode_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.ReqWriteNode.ReqWriteNode_q(d) } 
  BlockDisk.ReqWriteNode.ReqWriteNode_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.ReqWriteNode.ReqWriteNode);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.ReqWriteNode.ReqWriteNode_q(d) } 
  BlockDisk.ReqWriteNode.ReqWriteNode_q(d)
     ==> (exists a#10#0#0: DatatypeType, a#10#1#0: DatatypeType :: 
      d == #BlockDisk.ReqWriteNode.ReqWriteNode(a#10#0#0, a#10#1#0)));

function Tclass.BlockDisk.ReqWriteNode() : Ty;

// Tclass.BlockDisk.ReqWriteNode Tag
axiom Tag(Tclass.BlockDisk.ReqWriteNode()) == Tagclass.BlockDisk.ReqWriteNode;

const unique Tagclass.BlockDisk.ReqWriteNode: TyTag;

// Box/unbox axiom for Tclass.BlockDisk.ReqWriteNode
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockDisk.ReqWriteNode()) } 
  $IsBox(bx, Tclass.BlockDisk.ReqWriteNode())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockDisk.ReqWriteNode()));

// Constructor $Is
axiom (forall a#11#0#0: DatatypeType, a#11#1#0: DatatypeType :: 
  { $Is(#BlockDisk.ReqWriteNode.ReqWriteNode(a#11#0#0, a#11#1#0), 
      Tclass.BlockDisk.ReqWriteNode()) } 
  $Is(#BlockDisk.ReqWriteNode.ReqWriteNode(a#11#0#0, a#11#1#0), 
      Tclass.BlockDisk.ReqWriteNode())
     <==> $Is(a#11#0#0, Tclass.DiskLayout.Location())
       && $Is(a#11#1#0, Tclass.PivotBetreeGraph.Node()));

// Constructor $IsAlloc
axiom (forall a#12#0#0: DatatypeType, a#12#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.ReqWriteNode.ReqWriteNode(a#12#0#0, a#12#1#0), 
      Tclass.BlockDisk.ReqWriteNode(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.ReqWriteNode.ReqWriteNode(a#12#0#0, a#12#1#0), 
        Tclass.BlockDisk.ReqWriteNode(), 
        $h)
       <==> $IsAlloc(a#12#0#0, Tclass.DiskLayout.Location(), $h)
         && $IsAlloc(a#12#1#0, Tclass.PivotBetreeGraph.Node(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.ReqWriteNode.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.ReqWriteNode.ReqWriteNode_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.ReqWriteNode(), $h)
     ==> $IsAlloc(BlockDisk.ReqWriteNode.loc(d), Tclass.DiskLayout.Location(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.ReqWriteNode.node(d), Tclass.PivotBetreeGraph.Node(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.ReqWriteNode.ReqWriteNode_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.ReqWriteNode(), $h)
     ==> $IsAlloc(BlockDisk.ReqWriteNode.node(d), Tclass.PivotBetreeGraph.Node(), $h));

// Constructor literal
axiom (forall a#13#0#0: DatatypeType, a#13#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteNode.ReqWriteNode(Lit(a#13#0#0), Lit(a#13#1#0)) } 
  #BlockDisk.ReqWriteNode.ReqWriteNode(Lit(a#13#0#0), Lit(a#13#1#0))
     == Lit(#BlockDisk.ReqWriteNode.ReqWriteNode(a#13#0#0, a#13#1#0)));

function BlockDisk.ReqWriteNode.loc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#14#0#0: DatatypeType, a#14#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteNode.ReqWriteNode(a#14#0#0, a#14#1#0) } 
  BlockDisk.ReqWriteNode.loc(#BlockDisk.ReqWriteNode.ReqWriteNode(a#14#0#0, a#14#1#0))
     == a#14#0#0);

// Inductive rank
axiom (forall a#15#0#0: DatatypeType, a#15#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteNode.ReqWriteNode(a#15#0#0, a#15#1#0) } 
  DtRank(a#15#0#0)
     < DtRank(#BlockDisk.ReqWriteNode.ReqWriteNode(a#15#0#0, a#15#1#0)));

function BlockDisk.ReqWriteNode.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#16#0#0: DatatypeType, a#16#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteNode.ReqWriteNode(a#16#0#0, a#16#1#0) } 
  BlockDisk.ReqWriteNode.node(#BlockDisk.ReqWriteNode.ReqWriteNode(a#16#0#0, a#16#1#0))
     == a#16#1#0);

// Inductive rank
axiom (forall a#17#0#0: DatatypeType, a#17#1#0: DatatypeType :: 
  { #BlockDisk.ReqWriteNode.ReqWriteNode(a#17#0#0, a#17#1#0) } 
  DtRank(a#17#1#0)
     < DtRank(#BlockDisk.ReqWriteNode.ReqWriteNode(a#17#0#0, a#17#1#0)));

// Depth-one case-split function
function $IsA#BlockDisk.ReqWriteNode(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockDisk.ReqWriteNode(d) } 
  $IsA#BlockDisk.ReqWriteNode(d) ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockDisk.ReqWriteNode.ReqWriteNode_q(d), $Is(d, Tclass.BlockDisk.ReqWriteNode()) } 
  $Is(d, Tclass.BlockDisk.ReqWriteNode())
     ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(d));

// Datatype extensional equality declaration
function BlockDisk.ReqWriteNode#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockDisk.ReqWriteNode.ReqWriteNode
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.ReqWriteNode#Equal(a, b) } 
  true
     ==> (BlockDisk.ReqWriteNode#Equal(a, b)
       <==> DiskLayout.Location#Equal(BlockDisk.ReqWriteNode.loc(a), BlockDisk.ReqWriteNode.loc(b))
         && PivotBetreeGraph.Node#Equal(BlockDisk.ReqWriteNode.node(a), BlockDisk.ReqWriteNode.node(b))));

// Datatype extensionality axiom: BlockDisk.ReqWriteNode
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.ReqWriteNode#Equal(a, b) } 
  BlockDisk.ReqWriteNode#Equal(a, b) <==> a == b);

const unique class.BlockDisk.ReqWriteNode: ClassName;

// Constructor function declaration
function #BlockDisk.DiskOp.ReqReadIndirectionTableOp(int, DatatypeType) : DatatypeType;

const unique ##BlockDisk.DiskOp.ReqReadIndirectionTableOp: DtCtorId;

// Constructor identifier
axiom (forall a#18#0#0: int, a#18#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#18#0#0, a#18#1#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#18#0#0, a#18#1#0))
     == ##BlockDisk.DiskOp.ReqReadIndirectionTableOp);

function BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.ReqReadIndirectionTableOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d)
     ==> (exists a#19#0#0: int, a#19#1#0: DatatypeType :: 
      d == #BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#19#0#0, a#19#1#0)));

function Tclass.BlockDisk.DiskOp() : Ty;

// Tclass.BlockDisk.DiskOp Tag
axiom Tag(Tclass.BlockDisk.DiskOp()) == Tagclass.BlockDisk.DiskOp;

const unique Tagclass.BlockDisk.DiskOp: TyTag;

// Box/unbox axiom for Tclass.BlockDisk.DiskOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockDisk.DiskOp()) } 
  $IsBox(bx, Tclass.BlockDisk.DiskOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockDisk.DiskOp()));

// Constructor $Is
axiom (forall a#20#0#0: int, a#20#1#0: DatatypeType :: 
  { $Is(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#20#0#0, a#20#1#0), 
      Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#20#0#0, a#20#1#0), 
      Tclass.BlockDisk.DiskOp())
     <==> $Is(a#20#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#20#1#0, Tclass.DiskLayout.Location()));

// Constructor $IsAlloc
axiom (forall a#21#0#0: int, a#21#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#21#0#0, a#21#1#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#21#0#0, a#21#1#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#21#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#21#1#0, Tclass.DiskLayout.Location(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.loc(d), Tclass.DiskLayout.Location(), $h));

// Constructor literal
axiom (forall a#22#0#0: int, a#22#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadIndirectionTableOp(LitInt(a#22#0#0), Lit(a#22#1#0)) } 
  #BlockDisk.DiskOp.ReqReadIndirectionTableOp(LitInt(a#22#0#0), Lit(a#22#1#0))
     == Lit(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#22#0#0, a#22#1#0)));

function BlockDisk.DiskOp.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#23#0#0: int, a#23#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#23#0#0, a#23#1#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#23#0#0, a#23#1#0))
     == a#23#0#0);

function BlockDisk.DiskOp.loc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#24#0#0: int, a#24#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#24#0#0, a#24#1#0) } 
  BlockDisk.DiskOp.loc(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#24#0#0, a#24#1#0))
     == a#24#1#0);

// Inductive rank
axiom (forall a#25#0#0: int, a#25#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#25#0#0, a#25#1#0) } 
  DtRank(a#25#1#0)
     < DtRank(#BlockDisk.DiskOp.ReqReadIndirectionTableOp(a#25#0#0, a#25#1#0)));

// Constructor function declaration
function #BlockDisk.DiskOp.ReqReadNodeOp(int, DatatypeType) : DatatypeType;

const unique ##BlockDisk.DiskOp.ReqReadNodeOp: DtCtorId;

// Constructor identifier
axiom (forall a#26#0#0: int, a#26#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadNodeOp(a#26#0#0, a#26#1#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.ReqReadNodeOp(a#26#0#0, a#26#1#0))
     == ##BlockDisk.DiskOp.ReqReadNodeOp);

function BlockDisk.DiskOp.ReqReadNodeOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqReadNodeOp_q(d) } 
  BlockDisk.DiskOp.ReqReadNodeOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.ReqReadNodeOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqReadNodeOp_q(d) } 
  BlockDisk.DiskOp.ReqReadNodeOp_q(d)
     ==> (exists a#27#0#0: int, a#27#1#0: DatatypeType :: 
      d == #BlockDisk.DiskOp.ReqReadNodeOp(a#27#0#0, a#27#1#0)));

// Constructor $Is
axiom (forall a#28#0#0: int, a#28#1#0: DatatypeType :: 
  { $Is(#BlockDisk.DiskOp.ReqReadNodeOp(a#28#0#0, a#28#1#0), Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.ReqReadNodeOp(a#28#0#0, a#28#1#0), Tclass.BlockDisk.DiskOp())
     <==> $Is(a#28#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#28#1#0, Tclass.DiskLayout.Location()));

// Constructor $IsAlloc
axiom (forall a#29#0#0: int, a#29#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.ReqReadNodeOp(a#29#0#0, a#29#1#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.ReqReadNodeOp(a#29#0#0, a#29#1#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#29#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#29#1#0, Tclass.DiskLayout.Location(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqReadNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqReadNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.loc(d), Tclass.DiskLayout.Location(), $h));

// Constructor literal
axiom (forall a#30#0#0: int, a#30#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadNodeOp(LitInt(a#30#0#0), Lit(a#30#1#0)) } 
  #BlockDisk.DiskOp.ReqReadNodeOp(LitInt(a#30#0#0), Lit(a#30#1#0))
     == Lit(#BlockDisk.DiskOp.ReqReadNodeOp(a#30#0#0, a#30#1#0)));

// Constructor injectivity
axiom (forall a#31#0#0: int, a#31#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadNodeOp(a#31#0#0, a#31#1#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.ReqReadNodeOp(a#31#0#0, a#31#1#0))
     == a#31#0#0);

// Constructor injectivity
axiom (forall a#32#0#0: int, a#32#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadNodeOp(a#32#0#0, a#32#1#0) } 
  BlockDisk.DiskOp.loc(#BlockDisk.DiskOp.ReqReadNodeOp(a#32#0#0, a#32#1#0))
     == a#32#1#0);

// Inductive rank
axiom (forall a#33#0#0: int, a#33#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqReadNodeOp(a#33#0#0, a#33#1#0) } 
  DtRank(a#33#1#0) < DtRank(#BlockDisk.DiskOp.ReqReadNodeOp(a#33#0#0, a#33#1#0)));

// Constructor function declaration
function #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(int, DatatypeType) : DatatypeType;

const unique ##BlockDisk.DiskOp.ReqWriteIndirectionTableOp: DtCtorId;

// Constructor identifier
axiom (forall a#34#0#0: int, a#34#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#34#0#0, a#34#1#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#34#0#0, a#34#1#0))
     == ##BlockDisk.DiskOp.ReqWriteIndirectionTableOp);

function BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.ReqWriteIndirectionTableOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d)
     ==> (exists a#35#0#0: int, a#35#1#0: DatatypeType :: 
      d == #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#35#0#0, a#35#1#0)));

// Constructor $Is
axiom (forall a#36#0#0: int, a#36#1#0: DatatypeType :: 
  { $Is(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#36#0#0, a#36#1#0), 
      Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#36#0#0, a#36#1#0), 
      Tclass.BlockDisk.DiskOp())
     <==> $Is(a#36#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#36#1#0, Tclass.BlockDisk.ReqWriteIndirectionTable()));

// Constructor $IsAlloc
axiom (forall a#37#0#0: int, a#37#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#37#0#0, a#37#1#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#37#0#0, a#37#1#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#37#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#37#1#0, Tclass.BlockDisk.ReqWriteIndirectionTable(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.reqWriteIndirectionTable(d), 
      Tclass.BlockDisk.ReqWriteIndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.reqWriteIndirectionTable(d), 
      Tclass.BlockDisk.ReqWriteIndirectionTable(), 
      $h));

// Constructor literal
axiom (forall a#38#0#0: int, a#38#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(LitInt(a#38#0#0), Lit(a#38#1#0)) } 
  #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(LitInt(a#38#0#0), Lit(a#38#1#0))
     == Lit(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#38#0#0, a#38#1#0)));

// Constructor injectivity
axiom (forall a#39#0#0: int, a#39#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#39#0#0, a#39#1#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#39#0#0, a#39#1#0))
     == a#39#0#0);

function BlockDisk.DiskOp.reqWriteIndirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#40#0#0: int, a#40#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#40#0#0, a#40#1#0) } 
  BlockDisk.DiskOp.reqWriteIndirectionTable(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#40#0#0, a#40#1#0))
     == a#40#1#0);

// Inductive rank
axiom (forall a#41#0#0: int, a#41#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#41#0#0, a#41#1#0) } 
  DtRank(a#41#1#0)
     < DtRank(#BlockDisk.DiskOp.ReqWriteIndirectionTableOp(a#41#0#0, a#41#1#0)));

// Constructor function declaration
function #BlockDisk.DiskOp.ReqWriteNodeOp(int, DatatypeType) : DatatypeType;

const unique ##BlockDisk.DiskOp.ReqWriteNodeOp: DtCtorId;

// Constructor identifier
axiom (forall a#42#0#0: int, a#42#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteNodeOp(a#42#0#0, a#42#1#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.ReqWriteNodeOp(a#42#0#0, a#42#1#0))
     == ##BlockDisk.DiskOp.ReqWriteNodeOp);

function BlockDisk.DiskOp.ReqWriteNodeOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqWriteNodeOp_q(d) } 
  BlockDisk.DiskOp.ReqWriteNodeOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.ReqWriteNodeOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.ReqWriteNodeOp_q(d) } 
  BlockDisk.DiskOp.ReqWriteNodeOp_q(d)
     ==> (exists a#43#0#0: int, a#43#1#0: DatatypeType :: 
      d == #BlockDisk.DiskOp.ReqWriteNodeOp(a#43#0#0, a#43#1#0)));

// Constructor $Is
axiom (forall a#44#0#0: int, a#44#1#0: DatatypeType :: 
  { $Is(#BlockDisk.DiskOp.ReqWriteNodeOp(a#44#0#0, a#44#1#0), Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.ReqWriteNodeOp(a#44#0#0, a#44#1#0), Tclass.BlockDisk.DiskOp())
     <==> $Is(a#44#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#44#1#0, Tclass.BlockDisk.ReqWriteNode()));

// Constructor $IsAlloc
axiom (forall a#45#0#0: int, a#45#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.ReqWriteNodeOp(a#45#0#0, a#45#1#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.ReqWriteNodeOp(a#45#0#0, a#45#1#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#45#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#45#1#0, Tclass.BlockDisk.ReqWriteNode(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqWriteNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.reqWriteNode(d), Tclass.BlockDisk.ReqWriteNode(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.ReqWriteNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.reqWriteNode(d), Tclass.BlockDisk.ReqWriteNode(), $h));

// Constructor literal
axiom (forall a#46#0#0: int, a#46#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteNodeOp(LitInt(a#46#0#0), Lit(a#46#1#0)) } 
  #BlockDisk.DiskOp.ReqWriteNodeOp(LitInt(a#46#0#0), Lit(a#46#1#0))
     == Lit(#BlockDisk.DiskOp.ReqWriteNodeOp(a#46#0#0, a#46#1#0)));

// Constructor injectivity
axiom (forall a#47#0#0: int, a#47#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteNodeOp(a#47#0#0, a#47#1#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.ReqWriteNodeOp(a#47#0#0, a#47#1#0))
     == a#47#0#0);

function BlockDisk.DiskOp.reqWriteNode(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#48#0#0: int, a#48#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteNodeOp(a#48#0#0, a#48#1#0) } 
  BlockDisk.DiskOp.reqWriteNode(#BlockDisk.DiskOp.ReqWriteNodeOp(a#48#0#0, a#48#1#0))
     == a#48#1#0);

// Inductive rank
axiom (forall a#49#0#0: int, a#49#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.ReqWriteNodeOp(a#49#0#0, a#49#1#0) } 
  DtRank(a#49#1#0) < DtRank(#BlockDisk.DiskOp.ReqWriteNodeOp(a#49#0#0, a#49#1#0)));

// Constructor function declaration
function #BlockDisk.DiskOp.RespReadIndirectionTableOp(int, DatatypeType) : DatatypeType;

const unique ##BlockDisk.DiskOp.RespReadIndirectionTableOp: DtCtorId;

// Constructor identifier
axiom (forall a#50#0#0: int, a#50#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadIndirectionTableOp(a#50#0#0, a#50#1#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#50#0#0, a#50#1#0))
     == ##BlockDisk.DiskOp.RespReadIndirectionTableOp);

function BlockDisk.DiskOp.RespReadIndirectionTableOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.RespReadIndirectionTableOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d)
     ==> (exists a#51#0#0: int, a#51#1#0: DatatypeType :: 
      d == #BlockDisk.DiskOp.RespReadIndirectionTableOp(a#51#0#0, a#51#1#0)));

// Constructor $Is
axiom (forall a#52#0#0: int, a#52#1#0: DatatypeType :: 
  { $Is(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#52#0#0, a#52#1#0), 
      Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#52#0#0, a#52#1#0), 
      Tclass.BlockDisk.DiskOp())
     <==> $Is(a#52#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#52#1#0, Tclass.Options.Option(Tclass.SectorType.IndirectionTable())));

// Constructor $IsAlloc
axiom (forall a#53#0#0: int, a#53#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#53#0#0, a#53#1#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#53#0#0, a#53#1#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#53#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#53#1#0, Tclass.Options.Option(Tclass.SectorType.IndirectionTable()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.indirectionTable(d), 
      Tclass.Options.Option(Tclass.SectorType.IndirectionTable()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.indirectionTable(d), 
      Tclass.Options.Option(Tclass.SectorType.IndirectionTable()), 
      $h));

// Constructor literal
axiom (forall a#54#0#0: int, a#54#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadIndirectionTableOp(LitInt(a#54#0#0), Lit(a#54#1#0)) } 
  #BlockDisk.DiskOp.RespReadIndirectionTableOp(LitInt(a#54#0#0), Lit(a#54#1#0))
     == Lit(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#54#0#0, a#54#1#0)));

// Constructor injectivity
axiom (forall a#55#0#0: int, a#55#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadIndirectionTableOp(a#55#0#0, a#55#1#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#55#0#0, a#55#1#0))
     == a#55#0#0);

function BlockDisk.DiskOp.indirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#56#0#0: int, a#56#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadIndirectionTableOp(a#56#0#0, a#56#1#0) } 
  BlockDisk.DiskOp.indirectionTable(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#56#0#0, a#56#1#0))
     == a#56#1#0);

// Inductive rank
axiom (forall a#57#0#0: int, a#57#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadIndirectionTableOp(a#57#0#0, a#57#1#0) } 
  DtRank(a#57#1#0)
     < DtRank(#BlockDisk.DiskOp.RespReadIndirectionTableOp(a#57#0#0, a#57#1#0)));

// Constructor function declaration
function #BlockDisk.DiskOp.RespReadNodeOp(int, DatatypeType) : DatatypeType;

const unique ##BlockDisk.DiskOp.RespReadNodeOp: DtCtorId;

// Constructor identifier
axiom (forall a#58#0#0: int, a#58#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadNodeOp(a#58#0#0, a#58#1#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.RespReadNodeOp(a#58#0#0, a#58#1#0))
     == ##BlockDisk.DiskOp.RespReadNodeOp);

function BlockDisk.DiskOp.RespReadNodeOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespReadNodeOp_q(d) } 
  BlockDisk.DiskOp.RespReadNodeOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.RespReadNodeOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespReadNodeOp_q(d) } 
  BlockDisk.DiskOp.RespReadNodeOp_q(d)
     ==> (exists a#59#0#0: int, a#59#1#0: DatatypeType :: 
      d == #BlockDisk.DiskOp.RespReadNodeOp(a#59#0#0, a#59#1#0)));

// Constructor $Is
axiom (forall a#60#0#0: int, a#60#1#0: DatatypeType :: 
  { $Is(#BlockDisk.DiskOp.RespReadNodeOp(a#60#0#0, a#60#1#0), Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.RespReadNodeOp(a#60#0#0, a#60#1#0), Tclass.BlockDisk.DiskOp())
     <==> $Is(a#60#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#60#1#0, Tclass.Options.Option(Tclass.PivotBetreeGraph.Node())));

// Constructor $IsAlloc
axiom (forall a#61#0#0: int, a#61#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.RespReadNodeOp(a#61#0#0, a#61#1#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.RespReadNodeOp(a#61#0#0, a#61#1#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#61#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#61#1#0, Tclass.Options.Option(Tclass.PivotBetreeGraph.Node()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.RespReadNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.node(d), 
      Tclass.Options.Option(Tclass.PivotBetreeGraph.Node()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.RespReadNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.node(d), 
      Tclass.Options.Option(Tclass.PivotBetreeGraph.Node()), 
      $h));

// Constructor literal
axiom (forall a#62#0#0: int, a#62#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadNodeOp(LitInt(a#62#0#0), Lit(a#62#1#0)) } 
  #BlockDisk.DiskOp.RespReadNodeOp(LitInt(a#62#0#0), Lit(a#62#1#0))
     == Lit(#BlockDisk.DiskOp.RespReadNodeOp(a#62#0#0, a#62#1#0)));

// Constructor injectivity
axiom (forall a#63#0#0: int, a#63#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadNodeOp(a#63#0#0, a#63#1#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.RespReadNodeOp(a#63#0#0, a#63#1#0))
     == a#63#0#0);

function BlockDisk.DiskOp.node(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#64#0#0: int, a#64#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadNodeOp(a#64#0#0, a#64#1#0) } 
  BlockDisk.DiskOp.node(#BlockDisk.DiskOp.RespReadNodeOp(a#64#0#0, a#64#1#0))
     == a#64#1#0);

// Inductive rank
axiom (forall a#65#0#0: int, a#65#1#0: DatatypeType :: 
  { #BlockDisk.DiskOp.RespReadNodeOp(a#65#0#0, a#65#1#0) } 
  DtRank(a#65#1#0) < DtRank(#BlockDisk.DiskOp.RespReadNodeOp(a#65#0#0, a#65#1#0)));

// Constructor function declaration
function #BlockDisk.DiskOp.RespWriteIndirectionTableOp(int) : DatatypeType;

const unique ##BlockDisk.DiskOp.RespWriteIndirectionTableOp: DtCtorId;

// Constructor identifier
axiom (forall a#66#0#0: int :: 
  { #BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#66#0#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#66#0#0))
     == ##BlockDisk.DiskOp.RespWriteIndirectionTableOp);

function BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.RespWriteIndirectionTableOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d) } 
  BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d)
     ==> (exists a#67#0#0: int :: 
      d == #BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#67#0#0)));

// Constructor $Is
axiom (forall a#68#0#0: int :: 
  { $Is(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#68#0#0), 
      Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#68#0#0), 
      Tclass.BlockDisk.DiskOp())
     <==> $Is(a#68#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#69#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#69#0#0), 
      Tclass.BlockDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#69#0#0), 
        Tclass.BlockDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#69#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#70#0#0: int :: 
  { #BlockDisk.DiskOp.RespWriteIndirectionTableOp(LitInt(a#70#0#0)) } 
  #BlockDisk.DiskOp.RespWriteIndirectionTableOp(LitInt(a#70#0#0))
     == Lit(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#70#0#0)));

// Constructor injectivity
axiom (forall a#71#0#0: int :: 
  { #BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#71#0#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.RespWriteIndirectionTableOp(a#71#0#0))
     == a#71#0#0);

// Constructor function declaration
function #BlockDisk.DiskOp.RespWriteNodeOp(int) : DatatypeType;

const unique ##BlockDisk.DiskOp.RespWriteNodeOp: DtCtorId;

// Constructor identifier
axiom (forall a#72#0#0: int :: 
  { #BlockDisk.DiskOp.RespWriteNodeOp(a#72#0#0) } 
  DatatypeCtorId(#BlockDisk.DiskOp.RespWriteNodeOp(a#72#0#0))
     == ##BlockDisk.DiskOp.RespWriteNodeOp);

function BlockDisk.DiskOp.RespWriteNodeOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespWriteNodeOp_q(d) } 
  BlockDisk.DiskOp.RespWriteNodeOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.RespWriteNodeOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.RespWriteNodeOp_q(d) } 
  BlockDisk.DiskOp.RespWriteNodeOp_q(d)
     ==> (exists a#73#0#0: int :: d == #BlockDisk.DiskOp.RespWriteNodeOp(a#73#0#0)));

// Constructor $Is
axiom (forall a#74#0#0: int :: 
  { $Is(#BlockDisk.DiskOp.RespWriteNodeOp(a#74#0#0), Tclass.BlockDisk.DiskOp()) } 
  $Is(#BlockDisk.DiskOp.RespWriteNodeOp(a#74#0#0), Tclass.BlockDisk.DiskOp())
     <==> $Is(a#74#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#75#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.RespWriteNodeOp(a#75#0#0), Tclass.BlockDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.DiskOp.RespWriteNodeOp(a#75#0#0), Tclass.BlockDisk.DiskOp(), $h)
       <==> $IsAlloc(a#75#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.DiskOp.RespWriteNodeOp_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.DiskOp(), $h)
     ==> $IsAlloc(BlockDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#76#0#0: int :: 
  { #BlockDisk.DiskOp.RespWriteNodeOp(LitInt(a#76#0#0)) } 
  #BlockDisk.DiskOp.RespWriteNodeOp(LitInt(a#76#0#0))
     == Lit(#BlockDisk.DiskOp.RespWriteNodeOp(a#76#0#0)));

// Constructor injectivity
axiom (forall a#77#0#0: int :: 
  { #BlockDisk.DiskOp.RespWriteNodeOp(a#77#0#0) } 
  BlockDisk.DiskOp.id(#BlockDisk.DiskOp.RespWriteNodeOp(a#77#0#0)) == a#77#0#0);

// Constructor function declaration
function #BlockDisk.DiskOp.NoDiskOp() : DatatypeType;

const unique ##BlockDisk.DiskOp.NoDiskOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockDisk.DiskOp.NoDiskOp()) == ##BlockDisk.DiskOp.NoDiskOp;

function BlockDisk.DiskOp.NoDiskOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.NoDiskOp_q(d) } 
  BlockDisk.DiskOp.NoDiskOp_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.DiskOp.NoDiskOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.NoDiskOp_q(d) } 
  BlockDisk.DiskOp.NoDiskOp_q(d) ==> d == #BlockDisk.DiskOp.NoDiskOp());

// Constructor $Is
axiom $Is(#BlockDisk.DiskOp.NoDiskOp(), Tclass.BlockDisk.DiskOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockDisk.DiskOp.NoDiskOp(), Tclass.BlockDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockDisk.DiskOp.NoDiskOp(), Tclass.BlockDisk.DiskOp(), $h));

// Constructor literal
axiom #BlockDisk.DiskOp.NoDiskOp() == Lit(#BlockDisk.DiskOp.NoDiskOp());

// Depth-one case-split function
function $IsA#BlockDisk.DiskOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockDisk.DiskOp(d) } 
  $IsA#BlockDisk.DiskOp(d)
     ==> BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.ReqReadNodeOp_q(d)
       || BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.ReqWriteNodeOp_q(d)
       || BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.RespReadNodeOp_q(d)
       || BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.RespWriteNodeOp_q(d)
       || BlockDisk.DiskOp.NoDiskOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockDisk.DiskOp.NoDiskOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.RespWriteNodeOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.RespReadNodeOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.ReqWriteNodeOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.ReqReadNodeOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
    { BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d), $Is(d, Tclass.BlockDisk.DiskOp()) } 
  $Is(d, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.ReqReadNodeOp_q(d)
       || BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.ReqWriteNodeOp_q(d)
       || BlockDisk.DiskOp.RespReadIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.RespReadNodeOp_q(d)
       || BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(d)
       || BlockDisk.DiskOp.RespWriteNodeOp_q(d)
       || BlockDisk.DiskOp.NoDiskOp_q(d));

// Datatype extensional equality declaration
function BlockDisk.DiskOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockDisk.DiskOp.ReqReadIndirectionTableOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(b) } 
  BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(a)
       && BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)
         && DiskLayout.Location#Equal(BlockDisk.DiskOp.loc(a), BlockDisk.DiskOp.loc(b))));

// Datatype extensional equality definition: #BlockDisk.DiskOp.ReqReadNodeOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqReadNodeOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqReadNodeOp_q(b) } 
  BlockDisk.DiskOp.ReqReadNodeOp_q(a) && BlockDisk.DiskOp.ReqReadNodeOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)
         && DiskLayout.Location#Equal(BlockDisk.DiskOp.loc(a), BlockDisk.DiskOp.loc(b))));

// Datatype extensional equality definition: #BlockDisk.DiskOp.ReqWriteIndirectionTableOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(b) } 
  BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(a)
       && BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)
         && BlockDisk.ReqWriteIndirectionTable#Equal(BlockDisk.DiskOp.reqWriteIndirectionTable(a), 
          BlockDisk.DiskOp.reqWriteIndirectionTable(b))));

// Datatype extensional equality definition: #BlockDisk.DiskOp.ReqWriteNodeOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqWriteNodeOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.ReqWriteNodeOp_q(b) } 
  BlockDisk.DiskOp.ReqWriteNodeOp_q(a) && BlockDisk.DiskOp.ReqWriteNodeOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)
         && BlockDisk.ReqWriteNode#Equal(BlockDisk.DiskOp.reqWriteNode(a), BlockDisk.DiskOp.reqWriteNode(b))));

// Datatype extensional equality definition: #BlockDisk.DiskOp.RespReadIndirectionTableOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespReadIndirectionTableOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespReadIndirectionTableOp_q(b) } 
  BlockDisk.DiskOp.RespReadIndirectionTableOp_q(a)
       && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)
         && Options.Option#Equal(BlockDisk.DiskOp.indirectionTable(a), BlockDisk.DiskOp.indirectionTable(b))));

// Datatype extensional equality definition: #BlockDisk.DiskOp.RespReadNodeOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespReadNodeOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespReadNodeOp_q(b) } 
  BlockDisk.DiskOp.RespReadNodeOp_q(a) && BlockDisk.DiskOp.RespReadNodeOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)
         && Options.Option#Equal(BlockDisk.DiskOp.node(a), BlockDisk.DiskOp.node(b))));

// Datatype extensional equality definition: #BlockDisk.DiskOp.RespWriteIndirectionTableOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(b) } 
  BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(a)
       && BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)));

// Datatype extensional equality definition: #BlockDisk.DiskOp.RespWriteNodeOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespWriteNodeOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.RespWriteNodeOp_q(b) } 
  BlockDisk.DiskOp.RespWriteNodeOp_q(a) && BlockDisk.DiskOp.RespWriteNodeOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b)
       <==> BlockDisk.DiskOp.id(a) == BlockDisk.DiskOp.id(b)));

// Datatype extensional equality definition: #BlockDisk.DiskOp.NoDiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.NoDiskOp_q(a) } 
    { BlockDisk.DiskOp#Equal(a, b), BlockDisk.DiskOp.NoDiskOp_q(b) } 
  BlockDisk.DiskOp.NoDiskOp_q(a) && BlockDisk.DiskOp.NoDiskOp_q(b)
     ==> (BlockDisk.DiskOp#Equal(a, b) <==> true));

// Datatype extensionality axiom: BlockDisk.DiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.DiskOp#Equal(a, b) } 
  BlockDisk.DiskOp#Equal(a, b) <==> a == b);

const unique class.BlockDisk.DiskOp: ClassName;

// Constructor function declaration
function #BlockDisk.Constants.Constants() : DatatypeType;

const unique ##BlockDisk.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockDisk.Constants.Constants())
   == ##BlockDisk.Constants.Constants;

function BlockDisk.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.Constants.Constants_q(d) } 
  BlockDisk.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.Constants.Constants_q(d) } 
  BlockDisk.Constants.Constants_q(d) ==> d == #BlockDisk.Constants.Constants());

function Tclass.BlockDisk.Constants() : Ty;

// Tclass.BlockDisk.Constants Tag
axiom Tag(Tclass.BlockDisk.Constants()) == Tagclass.BlockDisk.Constants;

const unique Tagclass.BlockDisk.Constants: TyTag;

// Box/unbox axiom for Tclass.BlockDisk.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockDisk.Constants()) } 
  $IsBox(bx, Tclass.BlockDisk.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockDisk.Constants()));

// Constructor $Is
axiom $Is(#BlockDisk.Constants.Constants(), Tclass.BlockDisk.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockDisk.Constants.Constants(), Tclass.BlockDisk.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockDisk.Constants.Constants(), Tclass.BlockDisk.Constants(), $h));

// Constructor literal
axiom #BlockDisk.Constants.Constants() == Lit(#BlockDisk.Constants.Constants());

// Depth-one case-split function
function $IsA#BlockDisk.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockDisk.Constants(d) } 
  $IsA#BlockDisk.Constants(d) ==> BlockDisk.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockDisk.Constants.Constants_q(d), $Is(d, Tclass.BlockDisk.Constants()) } 
  $Is(d, Tclass.BlockDisk.Constants()) ==> BlockDisk.Constants.Constants_q(d));

// Datatype extensional equality declaration
function BlockDisk.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockDisk.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.Constants#Equal(a, b) } 
  true ==> (BlockDisk.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: BlockDisk.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.Constants#Equal(a, b) } 
  BlockDisk.Constants#Equal(a, b) <==> a == b);

const unique class.BlockDisk.Constants: ClassName;

// Constructor function declaration
function #BlockDisk.Variables.Variables(Map Box Box, Map Box Box, Map Box Box, Map Box Box, IMap Box Box, IMap Box Box)
   : DatatypeType;

const unique ##BlockDisk.Variables.Variables: DtCtorId;

// Constructor identifier
axiom (forall a#88#0#0: Map Box Box, 
    a#88#1#0: Map Box Box, 
    a#88#2#0: Map Box Box, 
    a#88#3#0: Map Box Box, 
    a#88#4#0: IMap Box Box, 
    a#88#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0, a#88#5#0) } 
  DatatypeCtorId(#BlockDisk.Variables.Variables(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0, a#88#5#0))
     == ##BlockDisk.Variables.Variables);

function BlockDisk.Variables.Variables_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockDisk.Variables.Variables_q(d) } 
  BlockDisk.Variables.Variables_q(d)
     <==> DatatypeCtorId(d) == ##BlockDisk.Variables.Variables);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockDisk.Variables.Variables_q(d) } 
  BlockDisk.Variables.Variables_q(d)
     ==> (exists a#89#0#0: Map Box Box, 
        a#89#1#0: Map Box Box, 
        a#89#2#0: Map Box Box, 
        a#89#3#0: Map Box Box, 
        a#89#4#0: IMap Box Box, 
        a#89#5#0: IMap Box Box :: 
      d
         == #BlockDisk.Variables.Variables(a#89#0#0, a#89#1#0, a#89#2#0, a#89#3#0, a#89#4#0, a#89#5#0)));

function Tclass.BlockDisk.Variables() : Ty;

// Tclass.BlockDisk.Variables Tag
axiom Tag(Tclass.BlockDisk.Variables()) == Tagclass.BlockDisk.Variables;

const unique Tagclass.BlockDisk.Variables: TyTag;

// Box/unbox axiom for Tclass.BlockDisk.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockDisk.Variables()) } 
  $IsBox(bx, Tclass.BlockDisk.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockDisk.Variables()));

// Constructor $Is
axiom (forall a#90#0#0: Map Box Box, 
    a#90#1#0: Map Box Box, 
    a#90#2#0: Map Box Box, 
    a#90#3#0: Map Box Box, 
    a#90#4#0: IMap Box Box, 
    a#90#5#0: IMap Box Box :: 
  { $Is(#BlockDisk.Variables.Variables(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0, a#90#5#0), 
      Tclass.BlockDisk.Variables()) } 
  $Is(#BlockDisk.Variables.Variables(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0, a#90#5#0), 
      Tclass.BlockDisk.Variables())
     <==> $Is(a#90#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
       && $Is(a#90#1#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
       && $Is(a#90#2#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
       && $Is(a#90#3#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
       && $Is(a#90#4#0, 
        TIMap(Tclass.DiskLayout.Location(), Tclass.SectorType.IndirectionTable()))
       && $Is(a#90#5#0, TIMap(Tclass.DiskLayout.Location(), Tclass.PivotBetreeGraph.Node())));

// Constructor $IsAlloc
axiom (forall a#91#0#0: Map Box Box, 
    a#91#1#0: Map Box Box, 
    a#91#2#0: Map Box Box, 
    a#91#3#0: Map Box Box, 
    a#91#4#0: IMap Box Box, 
    a#91#5#0: IMap Box Box, 
    $h: Heap :: 
  { $IsAlloc(#BlockDisk.Variables.Variables(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0, a#91#5#0), 
      Tclass.BlockDisk.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockDisk.Variables.Variables(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0, a#91#5#0), 
        Tclass.BlockDisk.Variables(), 
        $h)
       <==> $IsAlloc(a#91#0#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#91#1#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#91#2#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#91#3#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#91#4#0, 
          TIMap(Tclass.DiskLayout.Location(), Tclass.SectorType.IndirectionTable()), 
          $h)
         && $IsAlloc(a#91#5#0, 
          TIMap(Tclass.DiskLayout.Location(), Tclass.PivotBetreeGraph.Node()), 
          $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.Variables.reqReadIndirectionTables(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.Variables(), $h)
     ==> $IsAlloc(BlockDisk.Variables.reqReadIndirectionTables(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.Variables.reqReadNodes(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.Variables(), $h)
     ==> $IsAlloc(BlockDisk.Variables.reqReadNodes(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.Variables.reqWriteIndirectionTables(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.Variables(), $h)
     ==> $IsAlloc(BlockDisk.Variables.reqWriteIndirectionTables(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.Variables.reqWriteNodes(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.Variables(), $h)
     ==> $IsAlloc(BlockDisk.Variables.reqWriteNodes(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.Variables.indirectionTables(d), 
      TIMap(Tclass.DiskLayout.Location(), Tclass.SectorType.IndirectionTable()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.Variables(), $h)
     ==> $IsAlloc(BlockDisk.Variables.indirectionTables(d), 
      TIMap(Tclass.DiskLayout.Location(), Tclass.SectorType.IndirectionTable()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockDisk.Variables.nodes(d), 
      TIMap(Tclass.DiskLayout.Location(), Tclass.PivotBetreeGraph.Node()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.BlockDisk.Variables(), $h)
     ==> $IsAlloc(BlockDisk.Variables.nodes(d), 
      TIMap(Tclass.DiskLayout.Location(), Tclass.PivotBetreeGraph.Node()), 
      $h));

// Constructor literal
axiom (forall a#92#0#0: Map Box Box, 
    a#92#1#0: Map Box Box, 
    a#92#2#0: Map Box Box, 
    a#92#3#0: Map Box Box, 
    a#92#4#0: IMap Box Box, 
    a#92#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(Lit(a#92#0#0), 
      Lit(a#92#1#0), 
      Lit(a#92#2#0), 
      Lit(a#92#3#0), 
      Lit(a#92#4#0), 
      Lit(a#92#5#0)) } 
  #BlockDisk.Variables.Variables(Lit(a#92#0#0), 
      Lit(a#92#1#0), 
      Lit(a#92#2#0), 
      Lit(a#92#3#0), 
      Lit(a#92#4#0), 
      Lit(a#92#5#0))
     == Lit(#BlockDisk.Variables.Variables(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0, a#92#5#0)));

function BlockDisk.Variables.reqReadIndirectionTables(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#93#0#0: Map Box Box, 
    a#93#1#0: Map Box Box, 
    a#93#2#0: Map Box Box, 
    a#93#3#0: Map Box Box, 
    a#93#4#0: IMap Box Box, 
    a#93#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0, a#93#5#0) } 
  BlockDisk.Variables.reqReadIndirectionTables(#BlockDisk.Variables.Variables(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0, a#93#5#0))
     == a#93#0#0);

// Inductive map key rank
axiom (forall a#94#0#0: Map Box Box, 
    a#94#1#0: Map Box Box, 
    a#94#2#0: Map Box Box, 
    a#94#3#0: Map Box Box, 
    a#94#4#0: IMap Box Box, 
    a#94#5#0: IMap Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#94#0#0)[$Box(d)], #BlockDisk.Variables.Variables(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0, a#94#5#0) } 
  Map#Domain(a#94#0#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockDisk.Variables.Variables(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0, a#94#5#0)));

// Inductive map value rank
axiom (forall a#95#0#0: Map Box Box, 
    a#95#1#0: Map Box Box, 
    a#95#2#0: Map Box Box, 
    a#95#3#0: Map Box Box, 
    a#95#4#0: IMap Box Box, 
    a#95#5#0: IMap Box Box, 
    bx: Box :: 
  { Map#Domain(a#95#0#0)[bx], #BlockDisk.Variables.Variables(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0, a#95#5#0) } 
  Map#Domain(a#95#0#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#95#0#0)[bx]): DatatypeType)
       < DtRank(#BlockDisk.Variables.Variables(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0, a#95#5#0)));

function BlockDisk.Variables.reqReadNodes(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#96#0#0: Map Box Box, 
    a#96#1#0: Map Box Box, 
    a#96#2#0: Map Box Box, 
    a#96#3#0: Map Box Box, 
    a#96#4#0: IMap Box Box, 
    a#96#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0, a#96#5#0) } 
  BlockDisk.Variables.reqReadNodes(#BlockDisk.Variables.Variables(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0, a#96#5#0))
     == a#96#1#0);

// Inductive map key rank
axiom (forall a#97#0#0: Map Box Box, 
    a#97#1#0: Map Box Box, 
    a#97#2#0: Map Box Box, 
    a#97#3#0: Map Box Box, 
    a#97#4#0: IMap Box Box, 
    a#97#5#0: IMap Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#97#1#0)[$Box(d)], #BlockDisk.Variables.Variables(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0, a#97#5#0) } 
  Map#Domain(a#97#1#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockDisk.Variables.Variables(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0, a#97#5#0)));

// Inductive map value rank
axiom (forall a#98#0#0: Map Box Box, 
    a#98#1#0: Map Box Box, 
    a#98#2#0: Map Box Box, 
    a#98#3#0: Map Box Box, 
    a#98#4#0: IMap Box Box, 
    a#98#5#0: IMap Box Box, 
    bx: Box :: 
  { Map#Domain(a#98#1#0)[bx], #BlockDisk.Variables.Variables(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0, a#98#5#0) } 
  Map#Domain(a#98#1#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#98#1#0)[bx]): DatatypeType)
       < DtRank(#BlockDisk.Variables.Variables(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0, a#98#5#0)));

function BlockDisk.Variables.reqWriteIndirectionTables(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#99#0#0: Map Box Box, 
    a#99#1#0: Map Box Box, 
    a#99#2#0: Map Box Box, 
    a#99#3#0: Map Box Box, 
    a#99#4#0: IMap Box Box, 
    a#99#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0, a#99#5#0) } 
  BlockDisk.Variables.reqWriteIndirectionTables(#BlockDisk.Variables.Variables(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0, a#99#5#0))
     == a#99#2#0);

// Inductive map key rank
axiom (forall a#100#0#0: Map Box Box, 
    a#100#1#0: Map Box Box, 
    a#100#2#0: Map Box Box, 
    a#100#3#0: Map Box Box, 
    a#100#4#0: IMap Box Box, 
    a#100#5#0: IMap Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#100#2#0)[$Box(d)], #BlockDisk.Variables.Variables(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0, a#100#5#0) } 
  Map#Domain(a#100#2#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockDisk.Variables.Variables(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0, a#100#5#0)));

// Inductive map value rank
axiom (forall a#101#0#0: Map Box Box, 
    a#101#1#0: Map Box Box, 
    a#101#2#0: Map Box Box, 
    a#101#3#0: Map Box Box, 
    a#101#4#0: IMap Box Box, 
    a#101#5#0: IMap Box Box, 
    bx: Box :: 
  { Map#Domain(a#101#2#0)[bx], #BlockDisk.Variables.Variables(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0, a#101#5#0) } 
  Map#Domain(a#101#2#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#101#2#0)[bx]): DatatypeType)
       < DtRank(#BlockDisk.Variables.Variables(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0, a#101#5#0)));

function BlockDisk.Variables.reqWriteNodes(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#102#0#0: Map Box Box, 
    a#102#1#0: Map Box Box, 
    a#102#2#0: Map Box Box, 
    a#102#3#0: Map Box Box, 
    a#102#4#0: IMap Box Box, 
    a#102#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0, a#102#5#0) } 
  BlockDisk.Variables.reqWriteNodes(#BlockDisk.Variables.Variables(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0, a#102#5#0))
     == a#102#3#0);

// Inductive map key rank
axiom (forall a#103#0#0: Map Box Box, 
    a#103#1#0: Map Box Box, 
    a#103#2#0: Map Box Box, 
    a#103#3#0: Map Box Box, 
    a#103#4#0: IMap Box Box, 
    a#103#5#0: IMap Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#103#3#0)[$Box(d)], #BlockDisk.Variables.Variables(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0, a#103#5#0) } 
  Map#Domain(a#103#3#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockDisk.Variables.Variables(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0, a#103#5#0)));

// Inductive map value rank
axiom (forall a#104#0#0: Map Box Box, 
    a#104#1#0: Map Box Box, 
    a#104#2#0: Map Box Box, 
    a#104#3#0: Map Box Box, 
    a#104#4#0: IMap Box Box, 
    a#104#5#0: IMap Box Box, 
    bx: Box :: 
  { Map#Domain(a#104#3#0)[bx], #BlockDisk.Variables.Variables(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0, a#104#5#0) } 
  Map#Domain(a#104#3#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#104#3#0)[bx]): DatatypeType)
       < DtRank(#BlockDisk.Variables.Variables(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0, a#104#5#0)));

function BlockDisk.Variables.indirectionTables(DatatypeType) : IMap Box Box;

// Constructor injectivity
axiom (forall a#105#0#0: Map Box Box, 
    a#105#1#0: Map Box Box, 
    a#105#2#0: Map Box Box, 
    a#105#3#0: Map Box Box, 
    a#105#4#0: IMap Box Box, 
    a#105#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#105#0#0, a#105#1#0, a#105#2#0, a#105#3#0, a#105#4#0, a#105#5#0) } 
  BlockDisk.Variables.indirectionTables(#BlockDisk.Variables.Variables(a#105#0#0, a#105#1#0, a#105#2#0, a#105#3#0, a#105#4#0, a#105#5#0))
     == a#105#4#0);

// Inductive map key rank
axiom (forall a#106#0#0: Map Box Box, 
    a#106#1#0: Map Box Box, 
    a#106#2#0: Map Box Box, 
    a#106#3#0: Map Box Box, 
    a#106#4#0: IMap Box Box, 
    a#106#5#0: IMap Box Box, 
    d: DatatypeType :: 
  { IMap#Domain(a#106#4#0)[$Box(d)], #BlockDisk.Variables.Variables(a#106#0#0, a#106#1#0, a#106#2#0, a#106#3#0, a#106#4#0, a#106#5#0) } 
  IMap#Domain(a#106#4#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockDisk.Variables.Variables(a#106#0#0, a#106#1#0, a#106#2#0, a#106#3#0, a#106#4#0, a#106#5#0)));

// Inductive map value rank
axiom (forall a#107#0#0: Map Box Box, 
    a#107#1#0: Map Box Box, 
    a#107#2#0: Map Box Box, 
    a#107#3#0: Map Box Box, 
    a#107#4#0: IMap Box Box, 
    a#107#5#0: IMap Box Box, 
    bx: Box :: 
  { IMap#Domain(a#107#4#0)[bx], #BlockDisk.Variables.Variables(a#107#0#0, a#107#1#0, a#107#2#0, a#107#3#0, a#107#4#0, a#107#5#0) } 
  IMap#Domain(a#107#4#0)[bx]
     ==> DtRank($Unbox(IMap#Elements(a#107#4#0)[bx]): DatatypeType)
       < DtRank(#BlockDisk.Variables.Variables(a#107#0#0, a#107#1#0, a#107#2#0, a#107#3#0, a#107#4#0, a#107#5#0)));

function BlockDisk.Variables.nodes(DatatypeType) : IMap Box Box;

// Constructor injectivity
axiom (forall a#108#0#0: Map Box Box, 
    a#108#1#0: Map Box Box, 
    a#108#2#0: Map Box Box, 
    a#108#3#0: Map Box Box, 
    a#108#4#0: IMap Box Box, 
    a#108#5#0: IMap Box Box :: 
  { #BlockDisk.Variables.Variables(a#108#0#0, a#108#1#0, a#108#2#0, a#108#3#0, a#108#4#0, a#108#5#0) } 
  BlockDisk.Variables.nodes(#BlockDisk.Variables.Variables(a#108#0#0, a#108#1#0, a#108#2#0, a#108#3#0, a#108#4#0, a#108#5#0))
     == a#108#5#0);

// Inductive map key rank
axiom (forall a#109#0#0: Map Box Box, 
    a#109#1#0: Map Box Box, 
    a#109#2#0: Map Box Box, 
    a#109#3#0: Map Box Box, 
    a#109#4#0: IMap Box Box, 
    a#109#5#0: IMap Box Box, 
    d: DatatypeType :: 
  { IMap#Domain(a#109#5#0)[$Box(d)], #BlockDisk.Variables.Variables(a#109#0#0, a#109#1#0, a#109#2#0, a#109#3#0, a#109#4#0, a#109#5#0) } 
  IMap#Domain(a#109#5#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockDisk.Variables.Variables(a#109#0#0, a#109#1#0, a#109#2#0, a#109#3#0, a#109#4#0, a#109#5#0)));

// Inductive map value rank
axiom (forall a#110#0#0: Map Box Box, 
    a#110#1#0: Map Box Box, 
    a#110#2#0: Map Box Box, 
    a#110#3#0: Map Box Box, 
    a#110#4#0: IMap Box Box, 
    a#110#5#0: IMap Box Box, 
    bx: Box :: 
  { IMap#Domain(a#110#5#0)[bx], #BlockDisk.Variables.Variables(a#110#0#0, a#110#1#0, a#110#2#0, a#110#3#0, a#110#4#0, a#110#5#0) } 
  IMap#Domain(a#110#5#0)[bx]
     ==> DtRank($Unbox(IMap#Elements(a#110#5#0)[bx]): DatatypeType)
       < DtRank(#BlockDisk.Variables.Variables(a#110#0#0, a#110#1#0, a#110#2#0, a#110#3#0, a#110#4#0, a#110#5#0)));

// Depth-one case-split function
function $IsA#BlockDisk.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockDisk.Variables(d) } 
  $IsA#BlockDisk.Variables(d) ==> BlockDisk.Variables.Variables_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockDisk.Variables.Variables_q(d), $Is(d, Tclass.BlockDisk.Variables()) } 
  $Is(d, Tclass.BlockDisk.Variables()) ==> BlockDisk.Variables.Variables_q(d));

// Datatype extensional equality declaration
function BlockDisk.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockDisk.Variables.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.Variables#Equal(a, b) } 
  true
     ==> (BlockDisk.Variables#Equal(a, b)
       <==> Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(a), 
          BlockDisk.Variables.reqReadIndirectionTables(b))
         && Map#Equal(BlockDisk.Variables.reqReadNodes(a), BlockDisk.Variables.reqReadNodes(b))
         && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(a), 
          BlockDisk.Variables.reqWriteIndirectionTables(b))
         && Map#Equal(BlockDisk.Variables.reqWriteNodes(a), BlockDisk.Variables.reqWriteNodes(b))
         && IMap#Equal(BlockDisk.Variables.indirectionTables(a), 
          BlockDisk.Variables.indirectionTables(b))
         && IMap#Equal(BlockDisk.Variables.nodes(a), BlockDisk.Variables.nodes(b))));

// Datatype extensionality axiom: BlockDisk.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockDisk.Variables#Equal(a, b) } 
  BlockDisk.Variables#Equal(a, b) <==> a == b);

const unique class.BlockDisk.Variables: ClassName;

const unique class.BlockDisk.__default: ClassName;

function Tclass.BlockDisk.__default() : Ty;

// Tclass.BlockDisk.__default Tag
axiom Tag(Tclass.BlockDisk.__default()) == Tagclass.BlockDisk.__default;

const unique Tagclass.BlockDisk.__default: TyTag;

// Box/unbox axiom for Tclass.BlockDisk.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockDisk.__default()) } 
  $IsBox(bx, Tclass.BlockDisk.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BlockDisk.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BlockDisk.__default()) } 
  $Is($o, Tclass.BlockDisk.__default())
     <==> $o == null || dtype($o) == Tclass.BlockDisk.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BlockDisk.__default(), $h) } 
  $IsAlloc($o, Tclass.BlockDisk.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BlockDisk._default.Init
function BlockDisk.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function BlockDisk.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for BlockDisk.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockDisk.__default.Init(k#0, s#0) } 
    BlockDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables()))
       ==> true);

function BlockDisk.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { BlockDisk.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants()) && $Is(s#0, Tclass.BlockDisk.Variables())
     ==> BlockDisk.__default.Init#requires(k#0, s#0) == true);

// definition axiom for BlockDisk.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockDisk.__default.Init(k#0, s#0) } 
    BlockDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables()))
       ==> BlockDisk.Variables.Variables_q(s#0)
         && (Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(s#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && Map#Equal(BlockDisk.Variables.reqReadNodes(s#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(s#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && BlockDisk.__default.Init(k#0, s#0)
           == (
            Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqReadNodes(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(s#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteNodes(s#0), Map#Empty(): Map Box Box)));

// definition axiom for BlockDisk.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.Init(Lit(k#0), Lit(s#0)) } 
    BlockDisk.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables()))
       ==> BlockDisk.Variables.Variables_q(Lit(s#0))
         && (Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(BlockDisk.Variables.reqReadNodes(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)), 
              Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && BlockDisk.__default.Init(Lit(k#0), Lit(s#0))
           == (
            Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqReadNodes(Lit(s#0)), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)), 
              Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteNodes(Lit(s#0)), Map#Empty(): Map Box Box)));

// function declaration for BlockDisk._default.RecvReadIndirectionTable
function BlockDisk.__default.RecvReadIndirectionTable(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.RecvReadIndirectionTable#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.RecvReadIndirectionTable
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvReadIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.RecvReadIndirectionTable#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.RecvReadIndirectionTable
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.RecvReadIndirectionTable#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.RecvReadIndirectionTable#requires(k#0, s#0, s'#0, dop#0)
       == true);

// definition axiom for BlockDisk.__default.RecvReadIndirectionTable(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvReadIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && !Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> $IsA#BlockDisk.Variables(s'#0)
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(Map#Build(BlockDisk.Variables.reqReadIndirectionTables(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0)), 
                    $Box(BlockDisk.DiskOp.loc(dop#0))), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              BlockDisk.Variables.Variables_q(s#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && BlockDisk.__default.RecvReadIndirectionTable(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(dop#0)
             && !Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(Map#Build(BlockDisk.Variables.reqReadIndirectionTables(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0)), 
                    $Box(BlockDisk.DiskOp.loc(dop#0))), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))));

// definition axiom for BlockDisk.__default.RecvReadIndirectionTable for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.RecvReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.RecvReadIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#BlockDisk.Variables(Lit(s'#0))
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Map#Build(Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                    $Box(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              BlockDisk.Variables.Variables_q(Lit(s#0))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && BlockDisk.__default.RecvReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(Lit(dop#0))
             && !Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Map#Build(Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                    $Box(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))));

// function declaration for BlockDisk._default.RecvReadNode
function BlockDisk.__default.RecvReadNode(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.RecvReadNode#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.RecvReadNode
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvReadNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvReadNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.RecvReadNode#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.RecvReadNode
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.RecvReadNode#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.RecvReadNode#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for BlockDisk.__default.RecvReadNode(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvReadNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvReadNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && !Map#Domain(BlockDisk.Variables.reqReadNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> $IsA#BlockDisk.Variables(s'#0)
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                  Map#Build(BlockDisk.Variables.reqReadNodes(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0)), 
                    $Box(BlockDisk.DiskOp.loc(dop#0))), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(s#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && BlockDisk.__default.RecvReadNode(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
             && !Map#Domain(BlockDisk.Variables.reqReadNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                  Map#Build(BlockDisk.Variables.reqReadNodes(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0)), 
                    $Box(BlockDisk.DiskOp.loc(dop#0))), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))));

// definition axiom for BlockDisk.__default.RecvReadNode for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.RecvReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.RecvReadNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(BlockDisk.Variables.reqReadNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#BlockDisk.Variables(Lit(s'#0))
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                  Map#Build(Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                    $Box(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(Lit(s#0))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && BlockDisk.__default.RecvReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0))
             && !Map#Domain(BlockDisk.Variables.reqReadNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                  Map#Build(Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                    $Box(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))));

// function declaration for BlockDisk._default.DiskMapUpdate
function BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T: Ty, 
    disk#0: IMap Box Box, 
    disk'#0: IMap Box Box, 
    updateLoc#0: DatatypeType, 
    t#0: Box)
   : bool;

function BlockDisk.__default.DiskMapUpdate#canCall(BlockDisk._default.DiskMapUpdate$T: Ty, 
    disk#0: IMap Box Box, 
    disk'#0: IMap Box Box, 
    updateLoc#0: DatatypeType, 
    t#0: Box)
   : bool;

// consequence axiom for BlockDisk.__default.DiskMapUpdate
axiom true
   ==> (forall BlockDisk._default.DiskMapUpdate$T: Ty, 
      disk#0: IMap Box Box, 
      disk'#0: IMap Box Box, 
      updateLoc#0: DatatypeType, 
      t#0: Box :: 
    { BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0) } 
    BlockDisk.__default.DiskMapUpdate#canCall(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0)
         || (
          $Is(disk#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(disk'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(updateLoc#0, Tclass.DiskLayout.Location())
           && $IsBox(t#0, BlockDisk._default.DiskMapUpdate$T))
       ==> true);

function BlockDisk.__default.DiskMapUpdate#requires(Ty, IMap Box Box, IMap Box Box, DatatypeType, Box) : bool;

// #requires axiom for BlockDisk.__default.DiskMapUpdate
axiom (forall BlockDisk._default.DiskMapUpdate$T: Ty, 
    disk#0: IMap Box Box, 
    disk'#0: IMap Box Box, 
    updateLoc#0: DatatypeType, 
    t#0: Box :: 
  { BlockDisk.__default.DiskMapUpdate#requires(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0) } 
  $Is(disk#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
       && $Is(disk'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
       && $Is(updateLoc#0, Tclass.DiskLayout.Location())
       && $IsBox(t#0, BlockDisk._default.DiskMapUpdate$T)
     ==> BlockDisk.__default.DiskMapUpdate#requires(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0)
       == true);

// definition axiom for BlockDisk.__default.DiskMapUpdate(revealed)
axiom true
   ==> (forall BlockDisk._default.DiskMapUpdate$T: Ty, 
      disk#0: IMap Box Box, 
      disk'#0: IMap Box Box, 
      updateLoc#0: DatatypeType, 
      t#0: Box :: 
    { BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0) } 
    BlockDisk.__default.DiskMapUpdate#canCall(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0)
         || (
          $Is(disk#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(disk'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(updateLoc#0, Tclass.DiskLayout.Location())
           && $IsBox(t#0, BlockDisk._default.DiskMapUpdate$T))
       ==> (IMap#Elements(disk'#0)[$Box(updateLoc#0)] == t#0
           ==> (forall loc#0: DatatypeType :: 
            { IMap#Elements(disk#0)[$Box(loc#0)] } 
              { IMap#Elements(disk'#0)[$Box(loc#0)] } 
              { IMap#Domain(disk'#0)[$Box(loc#0)] } 
              { DiskLayout.__default.overlap(loc#0, updateLoc#0) } 
              { IMap#Domain(disk#0)[$Box(loc#0)] } 
            $Is(loc#0, Tclass.DiskLayout.Location())
               ==> 
              IMap#Domain(disk#0)[$Box(loc#0)]
               ==> DiskLayout.__default.overlap#canCall(loc#0, updateLoc#0)))
         && BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, updateLoc#0, t#0)
           == (
            IMap#Domain(disk'#0)[$Box(updateLoc#0)]
             && IMap#Elements(disk'#0)[$Box(updateLoc#0)] == t#0
             && (forall loc#0: DatatypeType :: 
              { IMap#Elements(disk#0)[$Box(loc#0)] } 
                { IMap#Elements(disk'#0)[$Box(loc#0)] } 
                { IMap#Domain(disk'#0)[$Box(loc#0)] } 
                { DiskLayout.__default.overlap(loc#0, updateLoc#0) } 
                { IMap#Domain(disk#0)[$Box(loc#0)] } 
              $Is(loc#0, Tclass.DiskLayout.Location())
                   && 
                  IMap#Domain(disk#0)[$Box(loc#0)]
                   && !DiskLayout.__default.overlap(loc#0, updateLoc#0)
                 ==> IMap#Domain(disk'#0)[$Box(loc#0)]
                   && IMap#Elements(disk'#0)[$Box(loc#0)] == IMap#Elements(disk#0)[$Box(loc#0)])));

// definition axiom for BlockDisk.__default.DiskMapUpdate for decreasing-related literals(revealed)
axiom true
   ==> (forall BlockDisk._default.DiskMapUpdate$T: Ty, 
      disk#0: IMap Box Box, 
      disk'#0: IMap Box Box, 
      updateLoc#0: DatatypeType, 
      t#0: Box :: 
    {:weight 3} { BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, Lit(updateLoc#0), t#0) } 
    BlockDisk.__default.DiskMapUpdate#canCall(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, Lit(updateLoc#0), t#0)
         || (
          $Is(disk#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(disk'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(updateLoc#0, Tclass.DiskLayout.Location())
           && $IsBox(t#0, BlockDisk._default.DiskMapUpdate$T))
       ==> (IMap#Elements(disk'#0)[$Box(Lit(updateLoc#0))] == t#0
           ==> (forall loc#1: DatatypeType :: 
            { IMap#Elements(disk#0)[$Box(loc#1)] } 
              { IMap#Elements(disk'#0)[$Box(loc#1)] } 
              { IMap#Domain(disk'#0)[$Box(loc#1)] } 
              { DiskLayout.__default.overlap(loc#1, updateLoc#0) } 
              { IMap#Domain(disk#0)[$Box(loc#1)] } 
            $Is(loc#1, Tclass.DiskLayout.Location())
               ==> 
              IMap#Domain(disk#0)[$Box(loc#1)]
               ==> DiskLayout.__default.overlap#canCall(loc#1, Lit(updateLoc#0))))
         && BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, disk#0, disk'#0, Lit(updateLoc#0), t#0)
           == (
            IMap#Domain(disk'#0)[$Box(updateLoc#0)]
             && IMap#Elements(disk'#0)[$Box(Lit(updateLoc#0))] == t#0
             && (forall loc#1: DatatypeType :: 
              { IMap#Elements(disk#0)[$Box(loc#1)] } 
                { IMap#Elements(disk'#0)[$Box(loc#1)] } 
                { IMap#Domain(disk'#0)[$Box(loc#1)] } 
                { DiskLayout.__default.overlap(loc#1, updateLoc#0) } 
                { IMap#Domain(disk#0)[$Box(loc#1)] } 
              $Is(loc#1, Tclass.DiskLayout.Location())
                   && 
                  IMap#Domain(disk#0)[$Box(loc#1)]
                   && !DiskLayout.__default.overlap(loc#1, Lit(updateLoc#0))
                 ==> IMap#Domain(disk'#0)[$Box(loc#1)]
                   && IMap#Elements(disk'#0)[$Box(loc#1)] == IMap#Elements(disk#0)[$Box(loc#1)])));

// definition axiom for BlockDisk.__default.DiskMapUpdate for all literals(revealed)
axiom true
   ==> (forall BlockDisk._default.DiskMapUpdate$T: Ty, 
      disk#0: IMap Box Box, 
      disk'#0: IMap Box Box, 
      updateLoc#0: DatatypeType, 
      t#0: Box :: 
    {:weight 3} { BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, 
        Lit(disk#0), 
        Lit(disk'#0), 
        Lit(updateLoc#0), 
        Lit(t#0)) } 
    BlockDisk.__default.DiskMapUpdate#canCall(BlockDisk._default.DiskMapUpdate$T, 
          Lit(disk#0), 
          Lit(disk'#0), 
          Lit(updateLoc#0), 
          Lit(t#0))
         || (
          $Is(disk#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(disk'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.DiskMapUpdate$T))
           && $Is(updateLoc#0, Tclass.DiskLayout.Location())
           && $IsBox(t#0, BlockDisk._default.DiskMapUpdate$T))
       ==> (IMap#Elements(Lit(disk'#0))[$Box(Lit(updateLoc#0))] == Lit(t#0)
           ==> (forall loc#2: DatatypeType :: 
            { IMap#Elements(disk#0)[$Box(loc#2)] } 
              { IMap#Elements(disk'#0)[$Box(loc#2)] } 
              { IMap#Domain(disk'#0)[$Box(loc#2)] } 
              { DiskLayout.__default.overlap(loc#2, updateLoc#0) } 
              { IMap#Domain(disk#0)[$Box(loc#2)] } 
            $Is(loc#2, Tclass.DiskLayout.Location())
               ==> 
              IMap#Domain(disk#0)[$Box(loc#2)]
               ==> DiskLayout.__default.overlap#canCall(loc#2, Lit(updateLoc#0))))
         && BlockDisk.__default.DiskMapUpdate(BlockDisk._default.DiskMapUpdate$T, 
            Lit(disk#0), 
            Lit(disk'#0), 
            Lit(updateLoc#0), 
            Lit(t#0))
           == (
            IMap#Domain(disk'#0)[$Box(updateLoc#0)]
             && IMap#Elements(Lit(disk'#0))[$Box(Lit(updateLoc#0))] == Lit(t#0)
             && (forall loc#2: DatatypeType :: 
              { IMap#Elements(disk#0)[$Box(loc#2)] } 
                { IMap#Elements(disk'#0)[$Box(loc#2)] } 
                { IMap#Domain(disk'#0)[$Box(loc#2)] } 
                { DiskLayout.__default.overlap(loc#2, updateLoc#0) } 
                { IMap#Domain(disk#0)[$Box(loc#2)] } 
              $Is(loc#2, Tclass.DiskLayout.Location())
                   && 
                  IMap#Domain(disk#0)[$Box(loc#2)]
                   && !DiskLayout.__default.overlap(loc#2, Lit(updateLoc#0))
                 ==> IMap#Domain(disk'#0)[$Box(loc#2)]
                   && IMap#Elements(Lit(disk'#0))[$Box(loc#2)]
                     == IMap#Elements(Lit(disk#0))[$Box(loc#2)])));

// function declaration for BlockDisk._default.RecvWriteIndirectionTable
function BlockDisk.__default.RecvWriteIndirectionTable(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.RecvWriteIndirectionTable#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.RecvWriteIndirectionTable
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvWriteIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.RecvWriteIndirectionTable#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.RecvWriteIndirectionTable
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.RecvWriteIndirectionTable#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.RecvWriteIndirectionTable#requires(k#0, s#0, s'#0, dop#0)
       == true);

// definition axiom for BlockDisk.__default.RecvWriteIndirectionTable(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvWriteIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && !Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)), 
              $Box(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))))
         && (BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)), 
              $Box(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))))
             && BlockDisk.__default.DiskMapUpdate(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)), 
              $Box(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))))
           ==> $IsA#BlockDisk.Variables(s'#0)
             && $IsA#BlockDisk.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                    #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                      Map#Build(BlockDisk.Variables.reqWriteIndirectionTables(s#0), 
                        $Box(BlockDisk.DiskOp.id(dop#0)), 
                        $Box(BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))), 
                      BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.nodes(dt_update_tmp#0#0))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.indirectionTables(s'#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#1#0))))
             && 
            (var dt_update_tmp#0#0 := s#0; 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && 
                BlockDisk.Variables.Variables_q(s#0)
                 && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0))
             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                  #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                    BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                    Map#Build(BlockDisk.Variables.reqWriteIndirectionTables(s#0), 
                      $Box(BlockDisk.DiskOp.id(dop#0)), 
                      $Box(BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))), 
                    BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                    BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                    BlockDisk.Variables.nodes(dt_update_tmp#0#0))); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(s'#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)))
         && BlockDisk.__default.RecvWriteIndirectionTable(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
             && !Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockDisk.__default.DiskMapUpdate(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)), 
              $Box(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))))
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                    #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                      Map#Build(BlockDisk.Variables.reqWriteIndirectionTables(s#0), 
                        $Box(BlockDisk.DiskOp.id(dop#0)), 
                        $Box(BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))), 
                      BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.nodes(dt_update_tmp#0#0))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.indirectionTables(s'#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#1#0))))));

// definition axiom for BlockDisk.__default.RecvWriteIndirectionTable for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.RecvWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.RecvWriteIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.SectorType.IndirectionTable(), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
              Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))), 
              $Box(Lit(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
             && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.SectorType.IndirectionTable(), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
              Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))), 
              $Box(Lit(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0)))))))
             && Lit(BlockDisk.__default.DiskMapUpdate(Tclass.SectorType.IndirectionTable(), 
                Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
                Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))), 
                $Box(Lit(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))))
           ==> $IsA#BlockDisk.Variables(Lit(s'#0))
             && $IsA#BlockDisk.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                    #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                      Map#Build(Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))), 
                        $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                        $Box(Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))), 
                      Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#1), 
                  Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
                  BlockDisk.Variables.nodes(dt_update_tmp#1#1))))
             && 
            (var dt_update_tmp#0#1 := Lit(s#0); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && 
                BlockDisk.Variables.Variables_q(Lit(s#0))
                 && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1))
             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                  #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                    Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                    Map#Build(Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))), 
                    Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                    Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                    Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(Lit(s'#0))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)))
         && BlockDisk.__default.RecvWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0))
             && !Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockDisk.__default.DiskMapUpdate(Tclass.SectorType.IndirectionTable(), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
              Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))), 
              $Box(Lit(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0)))))))
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                    #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                      Map#Build(Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))), 
                        $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                        $Box(Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))), 
                      Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#1), 
                  Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
                  BlockDisk.Variables.nodes(dt_update_tmp#1#1))))));

// function declaration for BlockDisk._default.RecvWriteNode
function BlockDisk.__default.RecvWriteNode(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.RecvWriteNode#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.RecvWriteNode
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvWriteNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvWriteNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.RecvWriteNode#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.RecvWriteNode
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.RecvWriteNode#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.RecvWriteNode#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for BlockDisk.__default.RecvWriteNode(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.RecvWriteNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.RecvWriteNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && !Map#Domain(BlockDisk.Variables.reqWriteNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.PivotBetreeGraph.Node(), 
              BlockDisk.Variables.nodes(s#0), 
              BlockDisk.Variables.nodes(s'#0), 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)), 
              $Box(BlockDisk.ReqWriteNode.node(BlockDisk.DiskOp.reqWriteNode(dop#0)))))
         && (BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.PivotBetreeGraph.Node(), 
              BlockDisk.Variables.nodes(s#0), 
              BlockDisk.Variables.nodes(s'#0), 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)), 
              $Box(BlockDisk.ReqWriteNode.node(BlockDisk.DiskOp.reqWriteNode(dop#0))))
             && BlockDisk.__default.DiskMapUpdate(Tclass.PivotBetreeGraph.Node(), 
              BlockDisk.Variables.nodes(s#0), 
              BlockDisk.Variables.nodes(s'#0), 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)), 
              $Box(BlockDisk.ReqWriteNode.node(BlockDisk.DiskOp.reqWriteNode(dop#0))))
           ==> $IsA#BlockDisk.Variables(s'#0)
             && $IsA#BlockDisk.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                    #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                      Map#Build(BlockDisk.Variables.reqWriteNodes(s#0), 
                        $Box(BlockDisk.DiskOp.id(dop#0)), 
                        $Box(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))), 
                      BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.nodes(dt_update_tmp#0#0))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.nodes(s'#0))))
             && 
            (var dt_update_tmp#0#0 := s#0; 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && 
                BlockDisk.Variables.Variables_q(s#0)
                 && BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0))
             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                  #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                    BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                    BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                    Map#Build(BlockDisk.Variables.reqWriteNodes(s#0), 
                      $Box(BlockDisk.DiskOp.id(dop#0)), 
                      $Box(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))), 
                    BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                    BlockDisk.Variables.nodes(dt_update_tmp#0#0))); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && BlockDisk.Variables.Variables_q(s'#0)))
         && BlockDisk.__default.RecvWriteNode(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
             && !Map#Domain(BlockDisk.Variables.reqWriteNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockDisk.__default.DiskMapUpdate(Tclass.PivotBetreeGraph.Node(), 
              BlockDisk.Variables.nodes(s#0), 
              BlockDisk.Variables.nodes(s'#0), 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)), 
              $Box(BlockDisk.ReqWriteNode.node(BlockDisk.DiskOp.reqWriteNode(dop#0))))
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                    #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                      Map#Build(BlockDisk.Variables.reqWriteNodes(s#0), 
                        $Box(BlockDisk.DiskOp.id(dop#0)), 
                        $Box(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))), 
                      BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.nodes(dt_update_tmp#0#0))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#1#0), 
                  BlockDisk.Variables.nodes(s'#0))))));

// definition axiom for BlockDisk.__default.RecvWriteNode for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.RecvWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.RecvWriteNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(BlockDisk.Variables.reqWriteNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
              Lit(BlockDisk.Variables.nodes(Lit(s'#0))), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))), 
              $Box(Lit(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockDisk.__default.DiskMapUpdate#canCall(Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
              Lit(BlockDisk.Variables.nodes(Lit(s'#0))), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))), 
              $Box(Lit(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
             && Lit(BlockDisk.__default.DiskMapUpdate(Tclass.PivotBetreeGraph.Node(), 
                Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                Lit(BlockDisk.Variables.nodes(Lit(s'#0))), 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))), 
                $Box(Lit(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))))
           ==> $IsA#BlockDisk.Variables(Lit(s'#0))
             && $IsA#BlockDisk.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                    #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                      Map#Build(Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))), 
                        $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                        $Box(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))), 
                      Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#1), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#1#1), 
                  Lit(BlockDisk.Variables.nodes(Lit(s'#0))))))
             && 
            (var dt_update_tmp#0#1 := Lit(s#0); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && 
                BlockDisk.Variables.Variables_q(Lit(s#0))
                 && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1))
             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                  #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                    Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                    Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                    Map#Build(Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))), 
                    Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                    Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && BlockDisk.Variables.Variables_q(Lit(s'#0))))
         && BlockDisk.__default.RecvWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0))
             && !Map#Domain(BlockDisk.Variables.reqWriteNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockDisk.__default.DiskMapUpdate(Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
              Lit(BlockDisk.Variables.nodes(Lit(s'#0))), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))), 
              $Box(Lit(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                    #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                      Map#Build(Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))), 
                        $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                        $Box(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))), 
                      Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))); 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#1#1), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#1#1), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#1#1), 
                  Lit(BlockDisk.Variables.nodes(Lit(s'#0))))))));

// function declaration for BlockDisk._default.AckReadIndirectionTable
function BlockDisk.__default.AckReadIndirectionTable(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.AckReadIndirectionTable#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.AckReadIndirectionTable
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckReadIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.AckReadIndirectionTable#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.AckReadIndirectionTable
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.AckReadIndirectionTable#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.AckReadIndirectionTable#requires(k#0, s#0, s'#0, dop#0)
       == true);

// definition axiom for BlockDisk.__default.AckReadIndirectionTable(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckReadIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> BlockDisk.Variables.Variables_q(s#0)
             && (var loc#0 := $Unbox(Map#Elements(BlockDisk.Variables.reqReadIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType; 
              (Options.Option.Some_q(BlockDisk.DiskOp.indirectionTable(dop#0))
                   ==> $IsA#Options.Option(BlockDisk.DiskOp.indirectionTable(dop#0))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.SectorType.IndirectionTable(), 
                        BlockDisk.Variables.indirectionTables(s#0), 
                        $Box(loc#0)))
                     && 
                    BlockDisk.Variables.Variables_q(s#0)
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.SectorType.IndirectionTable(), 
                      BlockDisk.Variables.indirectionTables(s#0), 
                      $Box(loc#0)))
                 && ($IsA#Options.Option(BlockDisk.DiskOp.indirectionTable(dop#0))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.SectorType.IndirectionTable(), 
                        BlockDisk.Variables.indirectionTables(s#0), 
                        $Box(loc#0)))
                     && 
                    BlockDisk.Variables.Variables_q(s#0)
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.SectorType.IndirectionTable(), 
                      BlockDisk.Variables.indirectionTables(s#0), 
                      $Box(loc#0))
                     && Options.Option#Equal(BlockDisk.DiskOp.indirectionTable(dop#0), 
                      Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.SectorType.IndirectionTable(), 
                        BlockDisk.Variables.indirectionTables(s#0), 
                        $Box(loc#0)))
                   ==> $IsA#BlockDisk.Variables(s'#0)
                     && $IsA#BlockDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                        #BlockDisk.Variables.Variables(Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                            Tclass.DiskLayout.Location(), 
                            StartFuel_Maps._default.MapRemove1, 
                            BlockDisk.Variables.reqReadIndirectionTables(s#0), 
                            $Box(BlockDisk.DiskOp.id(dop#0))), 
                          BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                          BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                          BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                          BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                          BlockDisk.Variables.nodes(dt_update_tmp#0#0))))
                     && (var dt_update_tmp#0#0 := s#0; 
                      BlockDisk.Variables.Variables_q(s#0)
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.DiskLayout.Location(), 
                          BlockDisk.Variables.reqReadIndirectionTables(s#0), 
                          $Box(BlockDisk.DiskOp.id(dop#0)))
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)))))
         && BlockDisk.__default.AckReadIndirectionTable(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
             && Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && (var loc#0 := $Unbox(Map#Elements(BlockDisk.Variables.reqReadIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType; 
              (Options.Option.Some_q(BlockDisk.DiskOp.indirectionTable(dop#0))
                   ==> Options.Option#Equal(BlockDisk.DiskOp.indirectionTable(dop#0), 
                    Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                      Tclass.SectorType.IndirectionTable(), 
                      BlockDisk.Variables.indirectionTables(s#0), 
                      $Box(loc#0))))
                 && BlockDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #BlockDisk.Variables.Variables(Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                        Tclass.DiskLayout.Location(), 
                        StartFuel_Maps._default.MapRemove1, 
                        BlockDisk.Variables.reqReadIndirectionTables(s#0), 
                        $Box(BlockDisk.DiskOp.id(dop#0))), 
                      BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.nodes(dt_update_tmp#0#0)))))));

// definition axiom for BlockDisk.__default.AckReadIndirectionTable for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.AckReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.AckReadIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> BlockDisk.Variables.Variables_q(Lit(s#0))
             && (var loc#1 := $Unbox(Map#Elements(Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType; 
              (Lit(Options.Option.Some_q(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0)))))
                   ==> $IsA#Options.Option(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.SectorType.IndirectionTable(), 
                        Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                        $Box(loc#1)))
                     && 
                    BlockDisk.Variables.Variables_q(Lit(s#0))
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.SectorType.IndirectionTable(), 
                      Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                      $Box(loc#1)))
                 && ($IsA#Options.Option(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.SectorType.IndirectionTable(), 
                        Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                        $Box(loc#1)))
                     && 
                    BlockDisk.Variables.Variables_q(Lit(s#0))
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.SectorType.IndirectionTable(), 
                      Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                      $Box(loc#1))
                     && Options.Option#Equal(BlockDisk.DiskOp.indirectionTable(Lit(dop#0)), 
                      Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.SectorType.IndirectionTable(), 
                        Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                        $Box(loc#1)))
                   ==> $IsA#BlockDisk.Variables(Lit(s'#0))
                     && $IsA#BlockDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                        #BlockDisk.Variables.Variables(Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                            Tclass.DiskLayout.Location(), 
                            StartFuel_Maps._default.MapRemove1, 
                            Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))), 
                            $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                          Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))
                     && (var dt_update_tmp#0#1 := Lit(s#0); 
                      BlockDisk.Variables.Variables_q(Lit(s#0))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.DiskLayout.Location(), 
                          Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))), 
                          $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)))))
         && BlockDisk.__default.AckReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0))
             && Map#Domain(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && (var loc#1 := $Unbox(Map#Elements(Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType; 
              (Options.Option.Some_q(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))
                   ==> Options.Option#Equal(BlockDisk.DiskOp.indirectionTable(Lit(dop#0)), 
                    Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                      Tclass.SectorType.IndirectionTable(), 
                      Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                      $Box(loc#1))))
                 && BlockDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    #BlockDisk.Variables.Variables(Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                        Tclass.DiskLayout.Location(), 
                        StartFuel_Maps._default.MapRemove1, 
                        Lit(BlockDisk.Variables.reqReadIndirectionTables(Lit(s#0))), 
                        $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                      Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1))))))));

// function declaration for BlockDisk._default.AckReadNode
function BlockDisk.__default.AckReadNode(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.AckReadNode#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.AckReadNode
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckReadNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckReadNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.AckReadNode#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.AckReadNode
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.AckReadNode#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.AckReadNode#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for BlockDisk.__default.AckReadNode(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckReadNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckReadNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && Map#Domain(BlockDisk.Variables.reqReadNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> BlockDisk.Variables.Variables_q(s#0)
             && (var loc#0 := $Unbox(Map#Elements(BlockDisk.Variables.reqReadNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType; 
              (Options.Option.Some_q(BlockDisk.DiskOp.node(dop#0))
                   ==> $IsA#Options.Option(BlockDisk.DiskOp.node(dop#0))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.PivotBetreeGraph.Node(), 
                        BlockDisk.Variables.nodes(s#0), 
                        $Box(loc#0)))
                     && 
                    BlockDisk.Variables.Variables_q(s#0)
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      BlockDisk.Variables.nodes(s#0), 
                      $Box(loc#0)))
                 && ($IsA#Options.Option(BlockDisk.DiskOp.node(dop#0))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.PivotBetreeGraph.Node(), 
                        BlockDisk.Variables.nodes(s#0), 
                        $Box(loc#0)))
                     && 
                    BlockDisk.Variables.Variables_q(s#0)
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      BlockDisk.Variables.nodes(s#0), 
                      $Box(loc#0))
                     && Options.Option#Equal(BlockDisk.DiskOp.node(dop#0), 
                      Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.PivotBetreeGraph.Node(), 
                        BlockDisk.Variables.nodes(s#0), 
                        $Box(loc#0)))
                   ==> $IsA#BlockDisk.Variables(s'#0)
                     && $IsA#BlockDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                        #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                          Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                            Tclass.DiskLayout.Location(), 
                            StartFuel_Maps._default.MapRemove1, 
                            BlockDisk.Variables.reqReadNodes(s#0), 
                            $Box(BlockDisk.DiskOp.id(dop#0))), 
                          BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                          BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                          BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                          BlockDisk.Variables.nodes(dt_update_tmp#0#0))))
                     && (var dt_update_tmp#0#0 := s#0; 
                      BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && 
                        BlockDisk.Variables.Variables_q(s#0)
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.DiskLayout.Location(), 
                          BlockDisk.Variables.reqReadNodes(s#0), 
                          $Box(BlockDisk.DiskOp.id(dop#0)))
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)))))
         && BlockDisk.__default.AckReadNode(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
             && Map#Domain(BlockDisk.Variables.reqReadNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && (var loc#0 := $Unbox(Map#Elements(BlockDisk.Variables.reqReadNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType; 
              (Options.Option.Some_q(BlockDisk.DiskOp.node(dop#0))
                   ==> Options.Option#Equal(BlockDisk.DiskOp.node(dop#0), 
                    Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      BlockDisk.Variables.nodes(s#0), 
                      $Box(loc#0))))
                 && BlockDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                      Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                        Tclass.DiskLayout.Location(), 
                        StartFuel_Maps._default.MapRemove1, 
                        BlockDisk.Variables.reqReadNodes(s#0), 
                        $Box(BlockDisk.DiskOp.id(dop#0))), 
                      BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                      BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                      BlockDisk.Variables.nodes(dt_update_tmp#0#0)))))));

// definition axiom for BlockDisk.__default.AckReadNode for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.AckReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.AckReadNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(BlockDisk.Variables.reqReadNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> BlockDisk.Variables.Variables_q(Lit(s#0))
             && (var loc#1 := $Unbox(Map#Elements(Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType; 
              (Lit(Options.Option.Some_q(Lit(BlockDisk.DiskOp.node(Lit(dop#0)))))
                   ==> $IsA#Options.Option(Lit(BlockDisk.DiskOp.node(Lit(dop#0))))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.PivotBetreeGraph.Node(), 
                        Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                        $Box(loc#1)))
                     && 
                    BlockDisk.Variables.Variables_q(Lit(s#0))
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                      $Box(loc#1)))
                 && ($IsA#Options.Option(Lit(BlockDisk.DiskOp.node(Lit(dop#0))))
                     && $IsA#Options.Option(Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.PivotBetreeGraph.Node(), 
                        Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                        $Box(loc#1)))
                     && 
                    BlockDisk.Variables.Variables_q(Lit(s#0))
                     && Maps.__default.ImapLookupOption#canCall(Tclass.DiskLayout.Location(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                      $Box(loc#1))
                     && Options.Option#Equal(BlockDisk.DiskOp.node(Lit(dop#0)), 
                      Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                        Tclass.PivotBetreeGraph.Node(), 
                        Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                        $Box(loc#1)))
                   ==> $IsA#BlockDisk.Variables(Lit(s'#0))
                     && $IsA#BlockDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                        #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                          Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                            Tclass.DiskLayout.Location(), 
                            StartFuel_Maps._default.MapRemove1, 
                            Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))), 
                            $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                          Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                          Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))
                     && (var dt_update_tmp#0#1 := Lit(s#0); 
                      BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && 
                        BlockDisk.Variables.Variables_q(Lit(s#0))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.DiskLayout.Location(), 
                          Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))), 
                          $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)))))
         && BlockDisk.__default.AckReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0))
             && Map#Domain(BlockDisk.Variables.reqReadNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && (var loc#1 := $Unbox(Map#Elements(Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType; 
              (Options.Option.Some_q(Lit(BlockDisk.DiskOp.node(Lit(dop#0))))
                   ==> Options.Option#Equal(BlockDisk.DiskOp.node(Lit(dop#0)), 
                    Maps.__default.ImapLookupOption(Tclass.DiskLayout.Location(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
                      $Box(loc#1))))
                 && BlockDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                      Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                        Tclass.DiskLayout.Location(), 
                        StartFuel_Maps._default.MapRemove1, 
                        Lit(BlockDisk.Variables.reqReadNodes(Lit(s#0))), 
                        $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                      Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                      Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1))))))));

// function declaration for BlockDisk._default.AckWriteIndirectionTable
function BlockDisk.__default.AckWriteIndirectionTable(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.AckWriteIndirectionTable#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.AckWriteIndirectionTable
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckWriteIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.AckWriteIndirectionTable#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.AckWriteIndirectionTable
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.AckWriteIndirectionTable#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.AckWriteIndirectionTable#requires(k#0, s#0, s'#0, dop#0)
       == true);

// definition axiom for BlockDisk.__default.AckWriteIndirectionTable(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckWriteIndirectionTable(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> $IsA#BlockDisk.Variables(s'#0)
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    BlockDisk.Variables.reqWriteIndirectionTables(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0))), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && 
                BlockDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.DiskLayout.Location(), 
                  BlockDisk.Variables.reqWriteIndirectionTables(s#0), 
                  $Box(BlockDisk.DiskOp.id(dop#0)))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && BlockDisk.__default.AckWriteIndirectionTable(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
             && Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    BlockDisk.Variables.reqWriteIndirectionTables(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0))), 
                  BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))));

// definition axiom for BlockDisk.__default.AckWriteIndirectionTable for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.AckWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.AckWriteIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#BlockDisk.Variables(Lit(s'#0))
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && 
                BlockDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.DiskLayout.Location(), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))), 
                  $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && BlockDisk.__default.AckWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0))
             && Map#Domain(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.reqWriteNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))));

// function declaration for BlockDisk._default.AckWriteNode
function BlockDisk.__default.AckWriteNode(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.AckWriteNode#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.AckWriteNode
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckWriteNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckWriteNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.AckWriteNode#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.AckWriteNode
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.AckWriteNode#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.AckWriteNode#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for BlockDisk.__default.AckWriteNode(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.AckWriteNode(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.AckWriteNode#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
           ==> BlockDisk.Variables.Variables_q(s#0))
         && (BlockDisk.Variables.Variables_q(s#0)
             && Map#Domain(BlockDisk.Variables.reqWriteNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> $IsA#BlockDisk.Variables(s'#0)
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    BlockDisk.Variables.reqWriteNodes(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0))), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && 
                BlockDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.DiskLayout.Location(), 
                  BlockDisk.Variables.reqWriteNodes(s#0), 
                  $Box(BlockDisk.DiskOp.id(dop#0)))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && BlockDisk.__default.AckWriteNode(k#0, s#0, s'#0, dop#0)
           == (
            BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
             && Map#Domain(BlockDisk.Variables.reqWriteNodes(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                #BlockDisk.Variables.Variables(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#0), 
                  BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#0), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    BlockDisk.Variables.reqWriteNodes(s#0), 
                    $Box(BlockDisk.DiskOp.id(dop#0))), 
                  BlockDisk.Variables.indirectionTables(dt_update_tmp#0#0), 
                  BlockDisk.Variables.nodes(dt_update_tmp#0#0))))));

// definition axiom for BlockDisk.__default.AckWriteNode for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.AckWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.AckWriteNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(BlockDisk.Variables.reqWriteNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#BlockDisk.Variables(Lit(s'#0))
             && $IsA#BlockDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && 
                BlockDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.DiskLayout.Location(), 
                  Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))), 
                  $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && BlockDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && BlockDisk.__default.AckWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0))
             && Map#Domain(BlockDisk.Variables.reqWriteNodes(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                #BlockDisk.Variables.Variables(Lit(BlockDisk.Variables.reqReadIndirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqReadNodes(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.reqWriteIndirectionTables(dt_update_tmp#0#1)), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.DiskLayout.Location(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))), 
                    $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))), 
                  Lit(BlockDisk.Variables.indirectionTables(dt_update_tmp#0#1)), 
                  Lit(BlockDisk.Variables.nodes(dt_update_tmp#0#1)))))));

// function declaration for BlockDisk._default.Stutter
function BlockDisk.__default.Stutter(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.Stutter#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.Stutter
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.Stutter#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.Stutter
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for BlockDisk.__default.Stutter(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> $IsA#BlockDisk.Variables(s'#0) && $IsA#BlockDisk.Variables(s#0))
         && BlockDisk.__default.Stutter(k#0, s#0, s'#0, dop#0)
           == (BlockDisk.DiskOp.NoDiskOp_q(dop#0) && BlockDisk.Variables#Equal(s'#0, s#0)));

// definition axiom for BlockDisk.__default.Stutter for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> $IsA#BlockDisk.Variables(Lit(s'#0)) && $IsA#BlockDisk.Variables(Lit(s#0)))
         && BlockDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && BlockDisk.Variables#Equal(s'#0, s#0)));

// function declaration for BlockDisk._default.Next
function BlockDisk.__default.Next(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function BlockDisk.__default.Next#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for BlockDisk.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> true);

function BlockDisk.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.Next
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { BlockDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
     ==> BlockDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for BlockDisk.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { BlockDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    BlockDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(dop#0)
           ==> BlockDisk.__default.RecvReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
         && (BlockDisk.__default.RecvReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0)
             && BlockDisk.__default.RecvReadIndirectionTable(k#0, s#0, s'#0, dop#0)
           ==> 
          BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
           ==> BlockDisk.__default.RecvReadNode#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
               ==> BlockDisk.__default.RecvReadNode#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
               ==> BlockDisk.__default.RecvReadNode(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
           ==> BlockDisk.__default.RecvWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.RecvWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.RecvWriteIndirectionTable(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
           ==> BlockDisk.__default.RecvWriteNode#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
               ==> BlockDisk.__default.RecvWriteNode#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
               ==> BlockDisk.__default.RecvWriteNode(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
           ==> BlockDisk.__default.AckReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.AckReadIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.AckReadIndirectionTable(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
           ==> BlockDisk.__default.AckReadNode#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
               ==> BlockDisk.__default.AckReadNode#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
               ==> BlockDisk.__default.AckReadNode(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
           ==> BlockDisk.__default.AckWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.AckWriteIndirectionTable#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.AckWriteIndirectionTable(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
           ==> BlockDisk.__default.AckWriteNode#canCall(k#0, s#0, s'#0, dop#0))
         && ((BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
               ==> BlockDisk.__default.AckWriteNode#canCall(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
               ==> BlockDisk.__default.AckWriteNode(k#0, s#0, s'#0, dop#0))
           ==> 
          BlockDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> BlockDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0))
         && BlockDisk.__default.Next(k#0, s#0, s'#0, dop#0)
           == (
            (BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.RecvReadIndirectionTable(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
               ==> BlockDisk.__default.RecvReadNode(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.RecvWriteIndirectionTable(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
               ==> BlockDisk.__default.RecvWriteNode(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.AckReadIndirectionTable(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
               ==> BlockDisk.__default.AckReadNode(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
               ==> BlockDisk.__default.AckWriteIndirectionTable(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
               ==> BlockDisk.__default.AckWriteNode(k#0, s#0, s'#0, dop#0))
             && (BlockDisk.DiskOp.NoDiskOp_q(dop#0)
               ==> BlockDisk.__default.Stutter(k#0, s#0, s'#0, dop#0))));

// definition axiom for BlockDisk.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    BlockDisk.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp()))
       ==> (Lit(BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.RecvReadIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && (BlockDisk.__default.RecvReadIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
             && Lit(BlockDisk.__default.RecvReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.RecvReadNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.RecvReadNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.RecvWriteIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.RecvWriteIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.RecvWriteNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.RecvWriteNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.AckReadIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.AckReadIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.AckReadNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.AckReadNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.AckWriteIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.AckWriteIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.AckWriteNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0)))
               ==> BlockDisk.__default.AckWriteNode#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> BlockDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && BlockDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == Lit((BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.RecvWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckReadIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckReadNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckWriteIndirectionTable(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.AckWriteNode(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
                 ==> BlockDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))));

// function declaration for BlockDisk._default.UntouchedLoc
function BlockDisk.__default.UntouchedLoc(loc#0: DatatypeType, reqs#0: Map Box Box) : bool;

function BlockDisk.__default.UntouchedLoc#canCall(loc#0: DatatypeType, reqs#0: Map Box Box) : bool;

// consequence axiom for BlockDisk.__default.UntouchedLoc
axiom true
   ==> (forall loc#0: DatatypeType, reqs#0: Map Box Box :: 
    { BlockDisk.__default.UntouchedLoc(loc#0, reqs#0) } 
    BlockDisk.__default.UntouchedLoc#canCall(loc#0, reqs#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> true);

function BlockDisk.__default.UntouchedLoc#requires(DatatypeType, Map Box Box) : bool;

// #requires axiom for BlockDisk.__default.UntouchedLoc
axiom (forall loc#0: DatatypeType, reqs#0: Map Box Box :: 
  { BlockDisk.__default.UntouchedLoc#requires(loc#0, reqs#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
       && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
     ==> BlockDisk.__default.UntouchedLoc#requires(loc#0, reqs#0) == true);

// definition axiom for BlockDisk.__default.UntouchedLoc(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, reqs#0: Map Box Box :: 
    { BlockDisk.__default.UntouchedLoc(loc#0, reqs#0) } 
    BlockDisk.__default.UntouchedLoc#canCall(loc#0, reqs#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(reqs#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(reqs#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(reqs#0)[$Box(id#0)]
             ==> DiskLayout.__default.overlap#canCall(loc#0, $Unbox(Map#Elements(reqs#0)[$Box(id#0)]): DatatypeType))
         && BlockDisk.__default.UntouchedLoc(loc#0, reqs#0)
           == (forall id#0: int :: 
            { $Unbox(Map#Elements(reqs#0)[$Box(id#0)]): DatatypeType } 
              { Map#Domain(reqs#0)[$Box(id#0)] } 
            LitInt(0) <= id#0
                 && id#0 < 18446744073709551616
                 && Map#Domain(reqs#0)[$Box(id#0)]
               ==> !DiskLayout.__default.overlap(loc#0, $Unbox(Map#Elements(reqs#0)[$Box(id#0)]): DatatypeType)));

// definition axiom for BlockDisk.__default.UntouchedLoc for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType, reqs#0: Map Box Box :: 
    {:weight 3} { BlockDisk.__default.UntouchedLoc(Lit(loc#0), Lit(reqs#0)) } 
    BlockDisk.__default.UntouchedLoc#canCall(Lit(loc#0), Lit(reqs#0))
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> (forall id#1: int :: 
          { $Unbox(Map#Elements(reqs#0)[$Box(id#1)]): DatatypeType } 
            { Map#Domain(reqs#0)[$Box(id#1)] } 
          LitInt(0) <= id#1 && id#1 < 18446744073709551616
             ==> 
            Map#Domain(reqs#0)[$Box(id#1)]
             ==> DiskLayout.__default.overlap#canCall(Lit(loc#0), $Unbox(Map#Elements(Lit(reqs#0))[$Box(id#1)]): DatatypeType))
         && BlockDisk.__default.UntouchedLoc(Lit(loc#0), Lit(reqs#0))
           == (forall id#1: int :: 
            { $Unbox(Map#Elements(reqs#0)[$Box(id#1)]): DatatypeType } 
              { Map#Domain(reqs#0)[$Box(id#1)] } 
            LitInt(0) <= id#1
                 && id#1 < 18446744073709551616
                 && Map#Domain(reqs#0)[$Box(id#1)]
               ==> !DiskLayout.__default.overlap(Lit(loc#0), $Unbox(Map#Elements(Lit(reqs#0))[$Box(id#1)]): DatatypeType)));

// function declaration for BlockDisk._default.havocMap
function BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    reqs#0: Map Box Box)
   : bool;

function BlockDisk.__default.havocMap#canCall(BlockDisk._default.havocMap$T: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    reqs#0: Map Box Box)
   : bool;

// consequence axiom for BlockDisk.__default.havocMap
axiom true
   ==> (forall BlockDisk._default.havocMap$T: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      reqs#0: Map Box Box :: 
    { BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0) } 
    BlockDisk.__default.havocMap#canCall(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0)
         || (
          $Is(m#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(m'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> true);

function BlockDisk.__default.havocMap#requires(Ty, IMap Box Box, IMap Box Box, Map Box Box) : bool;

// #requires axiom for BlockDisk.__default.havocMap
axiom (forall BlockDisk._default.havocMap$T: Ty, 
    m#0: IMap Box Box, 
    m'#0: IMap Box Box, 
    reqs#0: Map Box Box :: 
  { BlockDisk.__default.havocMap#requires(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0) } 
  $Is(m#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
       && $Is(m'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
       && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
     ==> BlockDisk.__default.havocMap#requires(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0)
       == true);

// definition axiom for BlockDisk.__default.havocMap(revealed)
axiom true
   ==> (forall BlockDisk._default.havocMap$T: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      reqs#0: Map Box Box :: 
    { BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0) } 
    BlockDisk.__default.havocMap#canCall(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0)
         || (
          $Is(m#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(m'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> (forall loc#0: DatatypeType :: 
          { IMap#Elements(m#0)[$Box(loc#0)] } 
            { IMap#Elements(m'#0)[$Box(loc#0)] } 
            { IMap#Domain(m'#0)[$Box(loc#0)] } 
            { BlockDisk.__default.UntouchedLoc(loc#0, reqs#0) } 
            { IMap#Domain(m#0)[$Box(loc#0)] } 
          $Is(loc#0, Tclass.DiskLayout.Location())
             ==> 
            IMap#Domain(m#0)[$Box(loc#0)]
             ==> BlockDisk.__default.UntouchedLoc#canCall(loc#0, reqs#0)
               && (IMap#Domain(m'#0)[$Box(loc#0)]
                 ==> BlockDisk.__default.UntouchedLoc#canCall(loc#0, reqs#0)))
         && BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, m#0, m'#0, reqs#0)
           == (forall loc#0: DatatypeType :: 
            { IMap#Elements(m#0)[$Box(loc#0)] } 
              { IMap#Elements(m'#0)[$Box(loc#0)] } 
              { IMap#Domain(m'#0)[$Box(loc#0)] } 
              { BlockDisk.__default.UntouchedLoc(loc#0, reqs#0) } 
              { IMap#Domain(m#0)[$Box(loc#0)] } 
            $Is(loc#0, Tclass.DiskLayout.Location()) && IMap#Domain(m#0)[$Box(loc#0)]
               ==> (BlockDisk.__default.UntouchedLoc(loc#0, reqs#0)
                   ==> IMap#Domain(m'#0)[$Box(loc#0)])
                 && (BlockDisk.__default.UntouchedLoc(loc#0, reqs#0)
                   ==> IMap#Elements(m'#0)[$Box(loc#0)] == IMap#Elements(m#0)[$Box(loc#0)])));

// definition axiom for BlockDisk.__default.havocMap for decreasing-related literals(revealed)
axiom true
   ==> (forall BlockDisk._default.havocMap$T: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      reqs#0: Map Box Box :: 
    {:weight 3} { BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, m#0, m'#0, Lit(reqs#0)) } 
    BlockDisk.__default.havocMap#canCall(BlockDisk._default.havocMap$T, m#0, m'#0, Lit(reqs#0))
         || (
          $Is(m#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(m'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> (forall loc#1: DatatypeType :: 
          { IMap#Elements(m#0)[$Box(loc#1)] } 
            { IMap#Elements(m'#0)[$Box(loc#1)] } 
            { IMap#Domain(m'#0)[$Box(loc#1)] } 
            { BlockDisk.__default.UntouchedLoc(loc#1, reqs#0) } 
            { IMap#Domain(m#0)[$Box(loc#1)] } 
          $Is(loc#1, Tclass.DiskLayout.Location())
             ==> 
            IMap#Domain(m#0)[$Box(loc#1)]
             ==> BlockDisk.__default.UntouchedLoc#canCall(loc#1, Lit(reqs#0))
               && (IMap#Domain(m'#0)[$Box(loc#1)]
                 ==> BlockDisk.__default.UntouchedLoc#canCall(loc#1, Lit(reqs#0))))
         && BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, m#0, m'#0, Lit(reqs#0))
           == (forall loc#1: DatatypeType :: 
            { IMap#Elements(m#0)[$Box(loc#1)] } 
              { IMap#Elements(m'#0)[$Box(loc#1)] } 
              { IMap#Domain(m'#0)[$Box(loc#1)] } 
              { BlockDisk.__default.UntouchedLoc(loc#1, reqs#0) } 
              { IMap#Domain(m#0)[$Box(loc#1)] } 
            $Is(loc#1, Tclass.DiskLayout.Location()) && IMap#Domain(m#0)[$Box(loc#1)]
               ==> (BlockDisk.__default.UntouchedLoc(loc#1, Lit(reqs#0))
                   ==> IMap#Domain(m'#0)[$Box(loc#1)])
                 && (BlockDisk.__default.UntouchedLoc(loc#1, Lit(reqs#0))
                   ==> IMap#Elements(m'#0)[$Box(loc#1)] == IMap#Elements(m#0)[$Box(loc#1)])));

// definition axiom for BlockDisk.__default.havocMap for all literals(revealed)
axiom true
   ==> (forall BlockDisk._default.havocMap$T: Ty, 
      m#0: IMap Box Box, 
      m'#0: IMap Box Box, 
      reqs#0: Map Box Box :: 
    {:weight 3} { BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, Lit(m#0), Lit(m'#0), Lit(reqs#0)) } 
    BlockDisk.__default.havocMap#canCall(BlockDisk._default.havocMap$T, Lit(m#0), Lit(m'#0), Lit(reqs#0))
         || (
          $Is(m#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(m'#0, TIMap(Tclass.DiskLayout.Location(), BlockDisk._default.havocMap$T))
           && $Is(reqs#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())))
       ==> (forall loc#2: DatatypeType :: 
          { IMap#Elements(m#0)[$Box(loc#2)] } 
            { IMap#Elements(m'#0)[$Box(loc#2)] } 
            { IMap#Domain(m'#0)[$Box(loc#2)] } 
            { BlockDisk.__default.UntouchedLoc(loc#2, reqs#0) } 
            { IMap#Domain(m#0)[$Box(loc#2)] } 
          $Is(loc#2, Tclass.DiskLayout.Location())
             ==> 
            IMap#Domain(m#0)[$Box(loc#2)]
             ==> BlockDisk.__default.UntouchedLoc#canCall(loc#2, Lit(reqs#0))
               && (IMap#Domain(m'#0)[$Box(loc#2)]
                 ==> BlockDisk.__default.UntouchedLoc#canCall(loc#2, Lit(reqs#0))))
         && BlockDisk.__default.havocMap(BlockDisk._default.havocMap$T, Lit(m#0), Lit(m'#0), Lit(reqs#0))
           == (forall loc#2: DatatypeType :: 
            { IMap#Elements(m#0)[$Box(loc#2)] } 
              { IMap#Elements(m'#0)[$Box(loc#2)] } 
              { IMap#Domain(m'#0)[$Box(loc#2)] } 
              { BlockDisk.__default.UntouchedLoc(loc#2, reqs#0) } 
              { IMap#Domain(m#0)[$Box(loc#2)] } 
            $Is(loc#2, Tclass.DiskLayout.Location()) && IMap#Domain(m#0)[$Box(loc#2)]
               ==> (BlockDisk.__default.UntouchedLoc(loc#2, Lit(reqs#0))
                   ==> IMap#Domain(m'#0)[$Box(loc#2)])
                 && (BlockDisk.__default.UntouchedLoc(loc#2, Lit(reqs#0))
                   ==> IMap#Elements(Lit(m'#0))[$Box(loc#2)] == IMap#Elements(Lit(m#0))[$Box(loc#2)])));

// function declaration for BlockDisk._default.Crash
function BlockDisk.__default.Crash(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function BlockDisk.__default.Crash#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for BlockDisk.__default.Crash
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { BlockDisk.__default.Crash(k#0, s#0, s'#0) } 
    BlockDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables()))
       ==> true);

function BlockDisk.__default.Crash#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockDisk.__default.Crash
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { BlockDisk.__default.Crash#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.BlockDisk.Constants())
       && $Is(s#0, Tclass.BlockDisk.Variables())
       && $Is(s'#0, Tclass.BlockDisk.Variables())
     ==> BlockDisk.__default.Crash#requires(k#0, s#0, s'#0) == true);

// definition axiom for BlockDisk.__default.Crash(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { BlockDisk.__default.Crash(k#0, s#0, s'#0) } 
    BlockDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables()))
       ==> BlockDisk.Variables.Variables_q(s'#0)
         && (Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(s'#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s'#0))
         && (BlockDisk.Variables.Variables_q(s'#0)
             && Map#Equal(BlockDisk.Variables.reqReadNodes(s'#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s'#0))
         && (BlockDisk.Variables.Variables_q(s'#0)
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(s'#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s'#0))
         && (BlockDisk.Variables.Variables_q(s'#0)
             && Map#Equal(BlockDisk.Variables.reqWriteNodes(s'#0), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.__default.havocMap#canCall(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.Variables.reqWriteIndirectionTables(s#0)))
         && (BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.__default.havocMap#canCall(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.Variables.reqWriteIndirectionTables(s#0))
             && BlockDisk.__default.havocMap(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.Variables.reqWriteIndirectionTables(s#0))
           ==> BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.Variables.Variables_q(s'#0)
             && BlockDisk.Variables.Variables_q(s#0)
             && BlockDisk.__default.havocMap#canCall(Tclass.PivotBetreeGraph.Node(), 
              BlockDisk.Variables.nodes(s#0), 
              BlockDisk.Variables.nodes(s'#0), 
              BlockDisk.Variables.reqWriteNodes(s#0)))
         && BlockDisk.__default.Crash(k#0, s#0, s'#0)
           == (
            Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(s'#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqReadNodes(s'#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(s'#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteNodes(s'#0), Map#Empty(): Map Box Box)
             && BlockDisk.__default.havocMap(Tclass.SectorType.IndirectionTable(), 
              BlockDisk.Variables.indirectionTables(s#0), 
              BlockDisk.Variables.indirectionTables(s'#0), 
              BlockDisk.Variables.reqWriteIndirectionTables(s#0))
             && BlockDisk.__default.havocMap(Tclass.PivotBetreeGraph.Node(), 
              BlockDisk.Variables.nodes(s#0), 
              BlockDisk.Variables.nodes(s'#0), 
              BlockDisk.Variables.reqWriteNodes(s#0))));

// definition axiom for BlockDisk.__default.Crash for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { BlockDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    BlockDisk.__default.Crash#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.BlockDisk.Constants())
           && $Is(s#0, Tclass.BlockDisk.Variables())
           && $Is(s'#0, Tclass.BlockDisk.Variables()))
       ==> BlockDisk.Variables.Variables_q(Lit(s'#0))
         && (Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(Lit(s'#0)), 
            Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s'#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s'#0))
             && Map#Equal(BlockDisk.Variables.reqReadNodes(Lit(s'#0)), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s'#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s'#0))
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s'#0)), 
              Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s'#0)))
         && (BlockDisk.Variables.Variables_q(Lit(s'#0))
             && Map#Equal(BlockDisk.Variables.reqWriteNodes(Lit(s'#0)), Map#Empty(): Map Box Box)
           ==> BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.__default.havocMap#canCall(Tclass.SectorType.IndirectionTable(), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
              Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)))))
         && (BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.__default.havocMap#canCall(Tclass.SectorType.IndirectionTable(), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
              Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))))
             && Lit(BlockDisk.__default.havocMap(Tclass.SectorType.IndirectionTable(), 
                Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
                Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
                Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0)))))
           ==> BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.Variables.Variables_q(Lit(s'#0))
             && BlockDisk.Variables.Variables_q(Lit(s#0))
             && BlockDisk.__default.havocMap#canCall(Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
              Lit(BlockDisk.Variables.nodes(Lit(s'#0))), 
              Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0)))))
         && BlockDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0))
           == (
            Map#Equal(BlockDisk.Variables.reqReadIndirectionTables(Lit(s'#0)), 
              Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqReadNodes(Lit(s'#0)), Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s'#0)), 
              Map#Empty(): Map Box Box)
             && Map#Equal(BlockDisk.Variables.reqWriteNodes(Lit(s'#0)), Map#Empty(): Map Box Box)
             && BlockDisk.__default.havocMap(Tclass.SectorType.IndirectionTable(), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s#0))), 
              Lit(BlockDisk.Variables.indirectionTables(Lit(s'#0))), 
              Lit(BlockDisk.Variables.reqWriteIndirectionTables(Lit(s#0))))
             && BlockDisk.__default.havocMap(Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockDisk.Variables.nodes(Lit(s#0))), 
              Lit(BlockDisk.Variables.nodes(Lit(s'#0))), 
              Lit(BlockDisk.Variables.reqWriteNodes(Lit(s#0))))));

// Constructor function declaration
function #BlockCache.Constants.Constants() : DatatypeType;

const unique ##BlockCache.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Constants.Constants())
   == ##BlockCache.Constants.Constants;

function BlockCache.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Constants.Constants_q(d) } 
  BlockCache.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Constants.Constants_q(d) } 
  BlockCache.Constants.Constants_q(d) ==> d == #BlockCache.Constants.Constants());

function Tclass.BlockCache.Constants() : Ty;

// Tclass.BlockCache.Constants Tag
axiom Tag(Tclass.BlockCache.Constants()) == Tagclass.BlockCache.Constants;

const unique Tagclass.BlockCache.Constants: TyTag;

// Box/unbox axiom for Tclass.BlockCache.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockCache.Constants()) } 
  $IsBox(bx, Tclass.BlockCache.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockCache.Constants()));

// Constructor $Is
axiom $Is(#BlockCache.Constants.Constants(), Tclass.BlockCache.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Constants.Constants(), Tclass.BlockCache.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Constants.Constants(), Tclass.BlockCache.Constants(), $h));

// Constructor literal
axiom #BlockCache.Constants.Constants() == Lit(#BlockCache.Constants.Constants());

// Depth-one case-split function
function $IsA#BlockCache.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockCache.Constants(d) } 
  $IsA#BlockCache.Constants(d) ==> BlockCache.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockCache.Constants.Constants_q(d), $Is(d, Tclass.BlockCache.Constants()) } 
  $Is(d, Tclass.BlockCache.Constants()) ==> BlockCache.Constants.Constants_q(d));

// Datatype extensional equality declaration
function BlockCache.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockCache.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Constants#Equal(a, b) } 
  true ==> (BlockCache.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: BlockCache.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Constants#Equal(a, b) } 
  BlockCache.Constants#Equal(a, b) <==> a == b);

const unique class.BlockCache.Constants: ClassName;

// Constructor function declaration
function #BlockCache.OutstandingWrite.OutstandingWrite(int, DatatypeType) : DatatypeType;

const unique ##BlockCache.OutstandingWrite.OutstandingWrite: DtCtorId;

// Constructor identifier
axiom (forall a#5#0#0: int, a#5#1#0: DatatypeType :: 
  { #BlockCache.OutstandingWrite.OutstandingWrite(a#5#0#0, a#5#1#0) } 
  DatatypeCtorId(#BlockCache.OutstandingWrite.OutstandingWrite(a#5#0#0, a#5#1#0))
     == ##BlockCache.OutstandingWrite.OutstandingWrite);

function BlockCache.OutstandingWrite.OutstandingWrite_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.OutstandingWrite.OutstandingWrite_q(d) } 
  BlockCache.OutstandingWrite.OutstandingWrite_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.OutstandingWrite.OutstandingWrite);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.OutstandingWrite.OutstandingWrite_q(d) } 
  BlockCache.OutstandingWrite.OutstandingWrite_q(d)
     ==> (exists a#6#0#0: int, a#6#1#0: DatatypeType :: 
      d == #BlockCache.OutstandingWrite.OutstandingWrite(a#6#0#0, a#6#1#0)));

function Tclass.BlockCache.OutstandingWrite() : Ty;

// Tclass.BlockCache.OutstandingWrite Tag
axiom Tag(Tclass.BlockCache.OutstandingWrite())
   == Tagclass.BlockCache.OutstandingWrite;

const unique Tagclass.BlockCache.OutstandingWrite: TyTag;

// Box/unbox axiom for Tclass.BlockCache.OutstandingWrite
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockCache.OutstandingWrite()) } 
  $IsBox(bx, Tclass.BlockCache.OutstandingWrite())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockCache.OutstandingWrite()));

// Constructor $Is
axiom (forall a#7#0#0: int, a#7#1#0: DatatypeType :: 
  { $Is(#BlockCache.OutstandingWrite.OutstandingWrite(a#7#0#0, a#7#1#0), 
      Tclass.BlockCache.OutstandingWrite()) } 
  $Is(#BlockCache.OutstandingWrite.OutstandingWrite(a#7#0#0, a#7#1#0), 
      Tclass.BlockCache.OutstandingWrite())
     <==> $Is(a#7#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#7#1#0, Tclass.DiskLayout.Location()));

// Constructor $IsAlloc
axiom (forall a#8#0#0: int, a#8#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockCache.OutstandingWrite.OutstandingWrite(a#8#0#0, a#8#1#0), 
      Tclass.BlockCache.OutstandingWrite(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.OutstandingWrite.OutstandingWrite(a#8#0#0, a#8#1#0), 
        Tclass.BlockCache.OutstandingWrite(), 
        $h)
       <==> $IsAlloc(a#8#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#8#1#0, Tclass.DiskLayout.Location(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.OutstandingWrite.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.OutstandingWrite.OutstandingWrite_q(d)
       && $IsAlloc(d, Tclass.BlockCache.OutstandingWrite(), $h)
     ==> $IsAlloc(BlockCache.OutstandingWrite.ref(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.OutstandingWrite.loc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.OutstandingWrite.OutstandingWrite_q(d)
       && $IsAlloc(d, Tclass.BlockCache.OutstandingWrite(), $h)
     ==> $IsAlloc(BlockCache.OutstandingWrite.loc(d), Tclass.DiskLayout.Location(), $h));

// Constructor literal
axiom (forall a#9#0#0: int, a#9#1#0: DatatypeType :: 
  { #BlockCache.OutstandingWrite.OutstandingWrite(LitInt(a#9#0#0), Lit(a#9#1#0)) } 
  #BlockCache.OutstandingWrite.OutstandingWrite(LitInt(a#9#0#0), Lit(a#9#1#0))
     == Lit(#BlockCache.OutstandingWrite.OutstandingWrite(a#9#0#0, a#9#1#0)));

function BlockCache.OutstandingWrite.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#10#0#0: int, a#10#1#0: DatatypeType :: 
  { #BlockCache.OutstandingWrite.OutstandingWrite(a#10#0#0, a#10#1#0) } 
  BlockCache.OutstandingWrite.ref(#BlockCache.OutstandingWrite.OutstandingWrite(a#10#0#0, a#10#1#0))
     == a#10#0#0);

function BlockCache.OutstandingWrite.loc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#11#0#0: int, a#11#1#0: DatatypeType :: 
  { #BlockCache.OutstandingWrite.OutstandingWrite(a#11#0#0, a#11#1#0) } 
  BlockCache.OutstandingWrite.loc(#BlockCache.OutstandingWrite.OutstandingWrite(a#11#0#0, a#11#1#0))
     == a#11#1#0);

// Inductive rank
axiom (forall a#12#0#0: int, a#12#1#0: DatatypeType :: 
  { #BlockCache.OutstandingWrite.OutstandingWrite(a#12#0#0, a#12#1#0) } 
  DtRank(a#12#1#0)
     < DtRank(#BlockCache.OutstandingWrite.OutstandingWrite(a#12#0#0, a#12#1#0)));

// Depth-one case-split function
function $IsA#BlockCache.OutstandingWrite(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockCache.OutstandingWrite(d) } 
  $IsA#BlockCache.OutstandingWrite(d)
     ==> BlockCache.OutstandingWrite.OutstandingWrite_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockCache.OutstandingWrite.OutstandingWrite_q(d), $Is(d, Tclass.BlockCache.OutstandingWrite()) } 
  $Is(d, Tclass.BlockCache.OutstandingWrite())
     ==> BlockCache.OutstandingWrite.OutstandingWrite_q(d));

// Datatype extensional equality declaration
function BlockCache.OutstandingWrite#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockCache.OutstandingWrite.OutstandingWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.OutstandingWrite#Equal(a, b) } 
  true
     ==> (BlockCache.OutstandingWrite#Equal(a, b)
       <==> BlockCache.OutstandingWrite.ref(a) == BlockCache.OutstandingWrite.ref(b)
         && DiskLayout.Location#Equal(BlockCache.OutstandingWrite.loc(a), BlockCache.OutstandingWrite.loc(b))));

// Datatype extensionality axiom: BlockCache.OutstandingWrite
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.OutstandingWrite#Equal(a, b) } 
  BlockCache.OutstandingWrite#Equal(a, b) <==> a == b);

const unique class.BlockCache.OutstandingWrite: ClassName;

// Constructor function declaration
function #BlockCache.OutstandingRead.OutstandingRead(int) : DatatypeType;

const unique ##BlockCache.OutstandingRead.OutstandingRead: DtCtorId;

// Constructor identifier
axiom (forall a#13#0#0: int :: 
  { #BlockCache.OutstandingRead.OutstandingRead(a#13#0#0) } 
  DatatypeCtorId(#BlockCache.OutstandingRead.OutstandingRead(a#13#0#0))
     == ##BlockCache.OutstandingRead.OutstandingRead);

function BlockCache.OutstandingRead.OutstandingRead_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.OutstandingRead.OutstandingRead_q(d) } 
  BlockCache.OutstandingRead.OutstandingRead_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.OutstandingRead.OutstandingRead);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.OutstandingRead.OutstandingRead_q(d) } 
  BlockCache.OutstandingRead.OutstandingRead_q(d)
     ==> (exists a#14#0#0: int :: 
      d == #BlockCache.OutstandingRead.OutstandingRead(a#14#0#0)));

function Tclass.BlockCache.OutstandingRead() : Ty;

// Tclass.BlockCache.OutstandingRead Tag
axiom Tag(Tclass.BlockCache.OutstandingRead()) == Tagclass.BlockCache.OutstandingRead;

const unique Tagclass.BlockCache.OutstandingRead: TyTag;

// Box/unbox axiom for Tclass.BlockCache.OutstandingRead
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockCache.OutstandingRead()) } 
  $IsBox(bx, Tclass.BlockCache.OutstandingRead())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockCache.OutstandingRead()));

// Constructor $Is
axiom (forall a#15#0#0: int :: 
  { $Is(#BlockCache.OutstandingRead.OutstandingRead(a#15#0#0), 
      Tclass.BlockCache.OutstandingRead()) } 
  $Is(#BlockCache.OutstandingRead.OutstandingRead(a#15#0#0), 
      Tclass.BlockCache.OutstandingRead())
     <==> $Is(a#15#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#16#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockCache.OutstandingRead.OutstandingRead(a#16#0#0), 
      Tclass.BlockCache.OutstandingRead(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.OutstandingRead.OutstandingRead(a#16#0#0), 
        Tclass.BlockCache.OutstandingRead(), 
        $h)
       <==> $IsAlloc(a#16#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.OutstandingRead.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.OutstandingRead.OutstandingRead_q(d)
       && $IsAlloc(d, Tclass.BlockCache.OutstandingRead(), $h)
     ==> $IsAlloc(BlockCache.OutstandingRead.ref(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#17#0#0: int :: 
  { #BlockCache.OutstandingRead.OutstandingRead(LitInt(a#17#0#0)) } 
  #BlockCache.OutstandingRead.OutstandingRead(LitInt(a#17#0#0))
     == Lit(#BlockCache.OutstandingRead.OutstandingRead(a#17#0#0)));

function BlockCache.OutstandingRead.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#18#0#0: int :: 
  { #BlockCache.OutstandingRead.OutstandingRead(a#18#0#0) } 
  BlockCache.OutstandingRead.ref(#BlockCache.OutstandingRead.OutstandingRead(a#18#0#0))
     == a#18#0#0);

// Depth-one case-split function
function $IsA#BlockCache.OutstandingRead(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockCache.OutstandingRead(d) } 
  $IsA#BlockCache.OutstandingRead(d)
     ==> BlockCache.OutstandingRead.OutstandingRead_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockCache.OutstandingRead.OutstandingRead_q(d), $Is(d, Tclass.BlockCache.OutstandingRead()) } 
  $Is(d, Tclass.BlockCache.OutstandingRead())
     ==> BlockCache.OutstandingRead.OutstandingRead_q(d));

// Datatype extensional equality declaration
function BlockCache.OutstandingRead#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockCache.OutstandingRead.OutstandingRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.OutstandingRead#Equal(a, b) } 
  true
     ==> (BlockCache.OutstandingRead#Equal(a, b)
       <==> BlockCache.OutstandingRead.ref(a) == BlockCache.OutstandingRead.ref(b)));

// Datatype extensionality axiom: BlockCache.OutstandingRead
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.OutstandingRead#Equal(a, b) } 
  BlockCache.OutstandingRead#Equal(a, b) <==> a == b);

const unique class.BlockCache.OutstandingRead: ClassName;

// Constructor function declaration
function #BlockCache.Variables.Ready(DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    Map Box Box, 
    Map Box Box, 
    Map Box Box)
   : DatatypeType;

const unique ##BlockCache.Variables.Ready: DtCtorId;

// Constructor identifier
axiom (forall a#19#0#0: DatatypeType, 
    a#19#1#0: DatatypeType, 
    a#19#2#0: DatatypeType, 
    a#19#3#0: DatatypeType, 
    a#19#4#0: DatatypeType, 
    a#19#5#0: DatatypeType, 
    a#19#6#0: Map Box Box, 
    a#19#7#0: Map Box Box, 
    a#19#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#19#0#0, 
      a#19#1#0, 
      a#19#2#0, 
      a#19#3#0, 
      a#19#4#0, 
      a#19#5#0, 
      a#19#6#0, 
      a#19#7#0, 
      a#19#8#0) } 
  DatatypeCtorId(#BlockCache.Variables.Ready(a#19#0#0, 
        a#19#1#0, 
        a#19#2#0, 
        a#19#3#0, 
        a#19#4#0, 
        a#19#5#0, 
        a#19#6#0, 
        a#19#7#0, 
        a#19#8#0))
     == ##BlockCache.Variables.Ready);

function BlockCache.Variables.Ready_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.Ready_q(d) } 
  BlockCache.Variables.Ready_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Variables.Ready);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.Ready_q(d) } 
  BlockCache.Variables.Ready_q(d)
     ==> (exists a#20#0#0: DatatypeType, 
        a#20#1#0: DatatypeType, 
        a#20#2#0: DatatypeType, 
        a#20#3#0: DatatypeType, 
        a#20#4#0: DatatypeType, 
        a#20#5#0: DatatypeType, 
        a#20#6#0: Map Box Box, 
        a#20#7#0: Map Box Box, 
        a#20#8#0: Map Box Box :: 
      d
         == #BlockCache.Variables.Ready(a#20#0#0, 
          a#20#1#0, 
          a#20#2#0, 
          a#20#3#0, 
          a#20#4#0, 
          a#20#5#0, 
          a#20#6#0, 
          a#20#7#0, 
          a#20#8#0)));

function Tclass.BlockCache.Variables() : Ty;

// Tclass.BlockCache.Variables Tag
axiom Tag(Tclass.BlockCache.Variables()) == Tagclass.BlockCache.Variables;

const unique Tagclass.BlockCache.Variables: TyTag;

// Box/unbox axiom for Tclass.BlockCache.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockCache.Variables()) } 
  $IsBox(bx, Tclass.BlockCache.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockCache.Variables()));

// Constructor $Is
axiom (forall a#21#0#0: DatatypeType, 
    a#21#1#0: DatatypeType, 
    a#21#2#0: DatatypeType, 
    a#21#3#0: DatatypeType, 
    a#21#4#0: DatatypeType, 
    a#21#5#0: DatatypeType, 
    a#21#6#0: Map Box Box, 
    a#21#7#0: Map Box Box, 
    a#21#8#0: Map Box Box :: 
  { $Is(#BlockCache.Variables.Ready(a#21#0#0, 
        a#21#1#0, 
        a#21#2#0, 
        a#21#3#0, 
        a#21#4#0, 
        a#21#5#0, 
        a#21#6#0, 
        a#21#7#0, 
        a#21#8#0), 
      Tclass.BlockCache.Variables()) } 
  $Is(#BlockCache.Variables.Ready(a#21#0#0, 
        a#21#1#0, 
        a#21#2#0, 
        a#21#3#0, 
        a#21#4#0, 
        a#21#5#0, 
        a#21#6#0, 
        a#21#7#0, 
        a#21#8#0), 
      Tclass.BlockCache.Variables())
     <==> $Is(a#21#0#0, Tclass.SectorType.IndirectionTable())
       && $Is(a#21#1#0, Tclass.Options.Option(Tclass.SectorType.IndirectionTable()))
       && $Is(a#21#2#0, Tclass.SectorType.IndirectionTable())
       && $Is(a#21#3#0, Tclass.DiskLayout.Location())
       && $Is(a#21#4#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
       && $Is(a#21#5#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#21#6#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       && $Is(a#21#7#0, TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
       && $Is(a#21#8#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())));

// Constructor $IsAlloc
axiom (forall a#22#0#0: DatatypeType, 
    a#22#1#0: DatatypeType, 
    a#22#2#0: DatatypeType, 
    a#22#3#0: DatatypeType, 
    a#22#4#0: DatatypeType, 
    a#22#5#0: DatatypeType, 
    a#22#6#0: Map Box Box, 
    a#22#7#0: Map Box Box, 
    a#22#8#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#BlockCache.Variables.Ready(a#22#0#0, 
        a#22#1#0, 
        a#22#2#0, 
        a#22#3#0, 
        a#22#4#0, 
        a#22#5#0, 
        a#22#6#0, 
        a#22#7#0, 
        a#22#8#0), 
      Tclass.BlockCache.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Variables.Ready(a#22#0#0, 
          a#22#1#0, 
          a#22#2#0, 
          a#22#3#0, 
          a#22#4#0, 
          a#22#5#0, 
          a#22#6#0, 
          a#22#7#0, 
          a#22#8#0), 
        Tclass.BlockCache.Variables(), 
        $h)
       <==> $IsAlloc(a#22#0#0, Tclass.SectorType.IndirectionTable(), $h)
         && $IsAlloc(a#22#1#0, Tclass.Options.Option(Tclass.SectorType.IndirectionTable()), $h)
         && $IsAlloc(a#22#2#0, Tclass.SectorType.IndirectionTable(), $h)
         && $IsAlloc(a#22#3#0, Tclass.DiskLayout.Location(), $h)
         && $IsAlloc(a#22#4#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#22#5#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#22#6#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()), 
          $h)
         && $IsAlloc(a#22#7#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()), 
          $h)
         && $IsAlloc(a#22#8#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.persistentIndirectionTable(d), 
      Tclass.SectorType.IndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.persistentIndirectionTable(d), 
      Tclass.SectorType.IndirectionTable(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.frozenIndirectionTable(d), 
      Tclass.Options.Option(Tclass.SectorType.IndirectionTable()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.frozenIndirectionTable(d), 
      Tclass.Options.Option(Tclass.SectorType.IndirectionTable()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.ephemeralIndirectionTable(d), 
      Tclass.SectorType.IndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.ephemeralIndirectionTable(d), 
      Tclass.SectorType.IndirectionTable(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.persistentIndirectionTableLoc(d), 
      Tclass.DiskLayout.Location(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.persistentIndirectionTableLoc(d), 
      Tclass.DiskLayout.Location(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.frozenIndirectionTableLoc(d), 
      Tclass.Options.Option(Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.frozenIndirectionTableLoc(d), 
      Tclass.Options.Option(Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.outstandingIndirectionTableWrite(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.outstandingIndirectionTableWrite(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.outstandingBlockWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.outstandingBlockWrites(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.outstandingBlockReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.outstandingBlockReads(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.cache(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.cache(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()), 
      $h));

// Constructor literal
axiom (forall a#23#0#0: DatatypeType, 
    a#23#1#0: DatatypeType, 
    a#23#2#0: DatatypeType, 
    a#23#3#0: DatatypeType, 
    a#23#4#0: DatatypeType, 
    a#23#5#0: DatatypeType, 
    a#23#6#0: Map Box Box, 
    a#23#7#0: Map Box Box, 
    a#23#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(Lit(a#23#0#0), 
      Lit(a#23#1#0), 
      Lit(a#23#2#0), 
      Lit(a#23#3#0), 
      Lit(a#23#4#0), 
      Lit(a#23#5#0), 
      Lit(a#23#6#0), 
      Lit(a#23#7#0), 
      Lit(a#23#8#0)) } 
  #BlockCache.Variables.Ready(Lit(a#23#0#0), 
      Lit(a#23#1#0), 
      Lit(a#23#2#0), 
      Lit(a#23#3#0), 
      Lit(a#23#4#0), 
      Lit(a#23#5#0), 
      Lit(a#23#6#0), 
      Lit(a#23#7#0), 
      Lit(a#23#8#0))
     == Lit(#BlockCache.Variables.Ready(a#23#0#0, 
        a#23#1#0, 
        a#23#2#0, 
        a#23#3#0, 
        a#23#4#0, 
        a#23#5#0, 
        a#23#6#0, 
        a#23#7#0, 
        a#23#8#0)));

function BlockCache.Variables.persistentIndirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#24#0#0: DatatypeType, 
    a#24#1#0: DatatypeType, 
    a#24#2#0: DatatypeType, 
    a#24#3#0: DatatypeType, 
    a#24#4#0: DatatypeType, 
    a#24#5#0: DatatypeType, 
    a#24#6#0: Map Box Box, 
    a#24#7#0: Map Box Box, 
    a#24#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#24#0#0, 
      a#24#1#0, 
      a#24#2#0, 
      a#24#3#0, 
      a#24#4#0, 
      a#24#5#0, 
      a#24#6#0, 
      a#24#7#0, 
      a#24#8#0) } 
  BlockCache.Variables.persistentIndirectionTable(#BlockCache.Variables.Ready(a#24#0#0, 
        a#24#1#0, 
        a#24#2#0, 
        a#24#3#0, 
        a#24#4#0, 
        a#24#5#0, 
        a#24#6#0, 
        a#24#7#0, 
        a#24#8#0))
     == a#24#0#0);

// Inductive rank
axiom (forall a#25#0#0: DatatypeType, 
    a#25#1#0: DatatypeType, 
    a#25#2#0: DatatypeType, 
    a#25#3#0: DatatypeType, 
    a#25#4#0: DatatypeType, 
    a#25#5#0: DatatypeType, 
    a#25#6#0: Map Box Box, 
    a#25#7#0: Map Box Box, 
    a#25#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#25#0#0, 
      a#25#1#0, 
      a#25#2#0, 
      a#25#3#0, 
      a#25#4#0, 
      a#25#5#0, 
      a#25#6#0, 
      a#25#7#0, 
      a#25#8#0) } 
  DtRank(a#25#0#0)
     < DtRank(#BlockCache.Variables.Ready(a#25#0#0, 
        a#25#1#0, 
        a#25#2#0, 
        a#25#3#0, 
        a#25#4#0, 
        a#25#5#0, 
        a#25#6#0, 
        a#25#7#0, 
        a#25#8#0)));

function BlockCache.Variables.frozenIndirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#26#0#0: DatatypeType, 
    a#26#1#0: DatatypeType, 
    a#26#2#0: DatatypeType, 
    a#26#3#0: DatatypeType, 
    a#26#4#0: DatatypeType, 
    a#26#5#0: DatatypeType, 
    a#26#6#0: Map Box Box, 
    a#26#7#0: Map Box Box, 
    a#26#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#26#0#0, 
      a#26#1#0, 
      a#26#2#0, 
      a#26#3#0, 
      a#26#4#0, 
      a#26#5#0, 
      a#26#6#0, 
      a#26#7#0, 
      a#26#8#0) } 
  BlockCache.Variables.frozenIndirectionTable(#BlockCache.Variables.Ready(a#26#0#0, 
        a#26#1#0, 
        a#26#2#0, 
        a#26#3#0, 
        a#26#4#0, 
        a#26#5#0, 
        a#26#6#0, 
        a#26#7#0, 
        a#26#8#0))
     == a#26#1#0);

// Inductive rank
axiom (forall a#27#0#0: DatatypeType, 
    a#27#1#0: DatatypeType, 
    a#27#2#0: DatatypeType, 
    a#27#3#0: DatatypeType, 
    a#27#4#0: DatatypeType, 
    a#27#5#0: DatatypeType, 
    a#27#6#0: Map Box Box, 
    a#27#7#0: Map Box Box, 
    a#27#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#27#0#0, 
      a#27#1#0, 
      a#27#2#0, 
      a#27#3#0, 
      a#27#4#0, 
      a#27#5#0, 
      a#27#6#0, 
      a#27#7#0, 
      a#27#8#0) } 
  DtRank(a#27#1#0)
     < DtRank(#BlockCache.Variables.Ready(a#27#0#0, 
        a#27#1#0, 
        a#27#2#0, 
        a#27#3#0, 
        a#27#4#0, 
        a#27#5#0, 
        a#27#6#0, 
        a#27#7#0, 
        a#27#8#0)));

function BlockCache.Variables.ephemeralIndirectionTable(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#28#0#0: DatatypeType, 
    a#28#1#0: DatatypeType, 
    a#28#2#0: DatatypeType, 
    a#28#3#0: DatatypeType, 
    a#28#4#0: DatatypeType, 
    a#28#5#0: DatatypeType, 
    a#28#6#0: Map Box Box, 
    a#28#7#0: Map Box Box, 
    a#28#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#28#0#0, 
      a#28#1#0, 
      a#28#2#0, 
      a#28#3#0, 
      a#28#4#0, 
      a#28#5#0, 
      a#28#6#0, 
      a#28#7#0, 
      a#28#8#0) } 
  BlockCache.Variables.ephemeralIndirectionTable(#BlockCache.Variables.Ready(a#28#0#0, 
        a#28#1#0, 
        a#28#2#0, 
        a#28#3#0, 
        a#28#4#0, 
        a#28#5#0, 
        a#28#6#0, 
        a#28#7#0, 
        a#28#8#0))
     == a#28#2#0);

// Inductive rank
axiom (forall a#29#0#0: DatatypeType, 
    a#29#1#0: DatatypeType, 
    a#29#2#0: DatatypeType, 
    a#29#3#0: DatatypeType, 
    a#29#4#0: DatatypeType, 
    a#29#5#0: DatatypeType, 
    a#29#6#0: Map Box Box, 
    a#29#7#0: Map Box Box, 
    a#29#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#29#0#0, 
      a#29#1#0, 
      a#29#2#0, 
      a#29#3#0, 
      a#29#4#0, 
      a#29#5#0, 
      a#29#6#0, 
      a#29#7#0, 
      a#29#8#0) } 
  DtRank(a#29#2#0)
     < DtRank(#BlockCache.Variables.Ready(a#29#0#0, 
        a#29#1#0, 
        a#29#2#0, 
        a#29#3#0, 
        a#29#4#0, 
        a#29#5#0, 
        a#29#6#0, 
        a#29#7#0, 
        a#29#8#0)));

function BlockCache.Variables.persistentIndirectionTableLoc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#30#0#0: DatatypeType, 
    a#30#1#0: DatatypeType, 
    a#30#2#0: DatatypeType, 
    a#30#3#0: DatatypeType, 
    a#30#4#0: DatatypeType, 
    a#30#5#0: DatatypeType, 
    a#30#6#0: Map Box Box, 
    a#30#7#0: Map Box Box, 
    a#30#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#30#0#0, 
      a#30#1#0, 
      a#30#2#0, 
      a#30#3#0, 
      a#30#4#0, 
      a#30#5#0, 
      a#30#6#0, 
      a#30#7#0, 
      a#30#8#0) } 
  BlockCache.Variables.persistentIndirectionTableLoc(#BlockCache.Variables.Ready(a#30#0#0, 
        a#30#1#0, 
        a#30#2#0, 
        a#30#3#0, 
        a#30#4#0, 
        a#30#5#0, 
        a#30#6#0, 
        a#30#7#0, 
        a#30#8#0))
     == a#30#3#0);

// Inductive rank
axiom (forall a#31#0#0: DatatypeType, 
    a#31#1#0: DatatypeType, 
    a#31#2#0: DatatypeType, 
    a#31#3#0: DatatypeType, 
    a#31#4#0: DatatypeType, 
    a#31#5#0: DatatypeType, 
    a#31#6#0: Map Box Box, 
    a#31#7#0: Map Box Box, 
    a#31#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#31#0#0, 
      a#31#1#0, 
      a#31#2#0, 
      a#31#3#0, 
      a#31#4#0, 
      a#31#5#0, 
      a#31#6#0, 
      a#31#7#0, 
      a#31#8#0) } 
  DtRank(a#31#3#0)
     < DtRank(#BlockCache.Variables.Ready(a#31#0#0, 
        a#31#1#0, 
        a#31#2#0, 
        a#31#3#0, 
        a#31#4#0, 
        a#31#5#0, 
        a#31#6#0, 
        a#31#7#0, 
        a#31#8#0)));

function BlockCache.Variables.frozenIndirectionTableLoc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#32#0#0: DatatypeType, 
    a#32#1#0: DatatypeType, 
    a#32#2#0: DatatypeType, 
    a#32#3#0: DatatypeType, 
    a#32#4#0: DatatypeType, 
    a#32#5#0: DatatypeType, 
    a#32#6#0: Map Box Box, 
    a#32#7#0: Map Box Box, 
    a#32#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#32#0#0, 
      a#32#1#0, 
      a#32#2#0, 
      a#32#3#0, 
      a#32#4#0, 
      a#32#5#0, 
      a#32#6#0, 
      a#32#7#0, 
      a#32#8#0) } 
  BlockCache.Variables.frozenIndirectionTableLoc(#BlockCache.Variables.Ready(a#32#0#0, 
        a#32#1#0, 
        a#32#2#0, 
        a#32#3#0, 
        a#32#4#0, 
        a#32#5#0, 
        a#32#6#0, 
        a#32#7#0, 
        a#32#8#0))
     == a#32#4#0);

// Inductive rank
axiom (forall a#33#0#0: DatatypeType, 
    a#33#1#0: DatatypeType, 
    a#33#2#0: DatatypeType, 
    a#33#3#0: DatatypeType, 
    a#33#4#0: DatatypeType, 
    a#33#5#0: DatatypeType, 
    a#33#6#0: Map Box Box, 
    a#33#7#0: Map Box Box, 
    a#33#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#33#0#0, 
      a#33#1#0, 
      a#33#2#0, 
      a#33#3#0, 
      a#33#4#0, 
      a#33#5#0, 
      a#33#6#0, 
      a#33#7#0, 
      a#33#8#0) } 
  DtRank(a#33#4#0)
     < DtRank(#BlockCache.Variables.Ready(a#33#0#0, 
        a#33#1#0, 
        a#33#2#0, 
        a#33#3#0, 
        a#33#4#0, 
        a#33#5#0, 
        a#33#6#0, 
        a#33#7#0, 
        a#33#8#0)));

function BlockCache.Variables.outstandingIndirectionTableWrite(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#34#0#0: DatatypeType, 
    a#34#1#0: DatatypeType, 
    a#34#2#0: DatatypeType, 
    a#34#3#0: DatatypeType, 
    a#34#4#0: DatatypeType, 
    a#34#5#0: DatatypeType, 
    a#34#6#0: Map Box Box, 
    a#34#7#0: Map Box Box, 
    a#34#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#34#0#0, 
      a#34#1#0, 
      a#34#2#0, 
      a#34#3#0, 
      a#34#4#0, 
      a#34#5#0, 
      a#34#6#0, 
      a#34#7#0, 
      a#34#8#0) } 
  BlockCache.Variables.outstandingIndirectionTableWrite(#BlockCache.Variables.Ready(a#34#0#0, 
        a#34#1#0, 
        a#34#2#0, 
        a#34#3#0, 
        a#34#4#0, 
        a#34#5#0, 
        a#34#6#0, 
        a#34#7#0, 
        a#34#8#0))
     == a#34#5#0);

// Inductive rank
axiom (forall a#35#0#0: DatatypeType, 
    a#35#1#0: DatatypeType, 
    a#35#2#0: DatatypeType, 
    a#35#3#0: DatatypeType, 
    a#35#4#0: DatatypeType, 
    a#35#5#0: DatatypeType, 
    a#35#6#0: Map Box Box, 
    a#35#7#0: Map Box Box, 
    a#35#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#35#0#0, 
      a#35#1#0, 
      a#35#2#0, 
      a#35#3#0, 
      a#35#4#0, 
      a#35#5#0, 
      a#35#6#0, 
      a#35#7#0, 
      a#35#8#0) } 
  DtRank(a#35#5#0)
     < DtRank(#BlockCache.Variables.Ready(a#35#0#0, 
        a#35#1#0, 
        a#35#2#0, 
        a#35#3#0, 
        a#35#4#0, 
        a#35#5#0, 
        a#35#6#0, 
        a#35#7#0, 
        a#35#8#0)));

function BlockCache.Variables.outstandingBlockWrites(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#36#0#0: DatatypeType, 
    a#36#1#0: DatatypeType, 
    a#36#2#0: DatatypeType, 
    a#36#3#0: DatatypeType, 
    a#36#4#0: DatatypeType, 
    a#36#5#0: DatatypeType, 
    a#36#6#0: Map Box Box, 
    a#36#7#0: Map Box Box, 
    a#36#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#36#0#0, 
      a#36#1#0, 
      a#36#2#0, 
      a#36#3#0, 
      a#36#4#0, 
      a#36#5#0, 
      a#36#6#0, 
      a#36#7#0, 
      a#36#8#0) } 
  BlockCache.Variables.outstandingBlockWrites(#BlockCache.Variables.Ready(a#36#0#0, 
        a#36#1#0, 
        a#36#2#0, 
        a#36#3#0, 
        a#36#4#0, 
        a#36#5#0, 
        a#36#6#0, 
        a#36#7#0, 
        a#36#8#0))
     == a#36#6#0);

// Inductive map key rank
axiom (forall a#37#0#0: DatatypeType, 
    a#37#1#0: DatatypeType, 
    a#37#2#0: DatatypeType, 
    a#37#3#0: DatatypeType, 
    a#37#4#0: DatatypeType, 
    a#37#5#0: DatatypeType, 
    a#37#6#0: Map Box Box, 
    a#37#7#0: Map Box Box, 
    a#37#8#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#37#6#0)[$Box(d)], #BlockCache.Variables.Ready(a#37#0#0, 
      a#37#1#0, 
      a#37#2#0, 
      a#37#3#0, 
      a#37#4#0, 
      a#37#5#0, 
      a#37#6#0, 
      a#37#7#0, 
      a#37#8#0) } 
  Map#Domain(a#37#6#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockCache.Variables.Ready(a#37#0#0, 
          a#37#1#0, 
          a#37#2#0, 
          a#37#3#0, 
          a#37#4#0, 
          a#37#5#0, 
          a#37#6#0, 
          a#37#7#0, 
          a#37#8#0)));

// Inductive map value rank
axiom (forall a#38#0#0: DatatypeType, 
    a#38#1#0: DatatypeType, 
    a#38#2#0: DatatypeType, 
    a#38#3#0: DatatypeType, 
    a#38#4#0: DatatypeType, 
    a#38#5#0: DatatypeType, 
    a#38#6#0: Map Box Box, 
    a#38#7#0: Map Box Box, 
    a#38#8#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#38#6#0)[bx], #BlockCache.Variables.Ready(a#38#0#0, 
      a#38#1#0, 
      a#38#2#0, 
      a#38#3#0, 
      a#38#4#0, 
      a#38#5#0, 
      a#38#6#0, 
      a#38#7#0, 
      a#38#8#0) } 
  Map#Domain(a#38#6#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#38#6#0)[bx]): DatatypeType)
       < DtRank(#BlockCache.Variables.Ready(a#38#0#0, 
          a#38#1#0, 
          a#38#2#0, 
          a#38#3#0, 
          a#38#4#0, 
          a#38#5#0, 
          a#38#6#0, 
          a#38#7#0, 
          a#38#8#0)));

function BlockCache.Variables.outstandingBlockReads(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#39#0#0: DatatypeType, 
    a#39#1#0: DatatypeType, 
    a#39#2#0: DatatypeType, 
    a#39#3#0: DatatypeType, 
    a#39#4#0: DatatypeType, 
    a#39#5#0: DatatypeType, 
    a#39#6#0: Map Box Box, 
    a#39#7#0: Map Box Box, 
    a#39#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#39#0#0, 
      a#39#1#0, 
      a#39#2#0, 
      a#39#3#0, 
      a#39#4#0, 
      a#39#5#0, 
      a#39#6#0, 
      a#39#7#0, 
      a#39#8#0) } 
  BlockCache.Variables.outstandingBlockReads(#BlockCache.Variables.Ready(a#39#0#0, 
        a#39#1#0, 
        a#39#2#0, 
        a#39#3#0, 
        a#39#4#0, 
        a#39#5#0, 
        a#39#6#0, 
        a#39#7#0, 
        a#39#8#0))
     == a#39#7#0);

// Inductive map key rank
axiom (forall a#40#0#0: DatatypeType, 
    a#40#1#0: DatatypeType, 
    a#40#2#0: DatatypeType, 
    a#40#3#0: DatatypeType, 
    a#40#4#0: DatatypeType, 
    a#40#5#0: DatatypeType, 
    a#40#6#0: Map Box Box, 
    a#40#7#0: Map Box Box, 
    a#40#8#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#40#7#0)[$Box(d)], #BlockCache.Variables.Ready(a#40#0#0, 
      a#40#1#0, 
      a#40#2#0, 
      a#40#3#0, 
      a#40#4#0, 
      a#40#5#0, 
      a#40#6#0, 
      a#40#7#0, 
      a#40#8#0) } 
  Map#Domain(a#40#7#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockCache.Variables.Ready(a#40#0#0, 
          a#40#1#0, 
          a#40#2#0, 
          a#40#3#0, 
          a#40#4#0, 
          a#40#5#0, 
          a#40#6#0, 
          a#40#7#0, 
          a#40#8#0)));

// Inductive map value rank
axiom (forall a#41#0#0: DatatypeType, 
    a#41#1#0: DatatypeType, 
    a#41#2#0: DatatypeType, 
    a#41#3#0: DatatypeType, 
    a#41#4#0: DatatypeType, 
    a#41#5#0: DatatypeType, 
    a#41#6#0: Map Box Box, 
    a#41#7#0: Map Box Box, 
    a#41#8#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#41#7#0)[bx], #BlockCache.Variables.Ready(a#41#0#0, 
      a#41#1#0, 
      a#41#2#0, 
      a#41#3#0, 
      a#41#4#0, 
      a#41#5#0, 
      a#41#6#0, 
      a#41#7#0, 
      a#41#8#0) } 
  Map#Domain(a#41#7#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#41#7#0)[bx]): DatatypeType)
       < DtRank(#BlockCache.Variables.Ready(a#41#0#0, 
          a#41#1#0, 
          a#41#2#0, 
          a#41#3#0, 
          a#41#4#0, 
          a#41#5#0, 
          a#41#6#0, 
          a#41#7#0, 
          a#41#8#0)));

function BlockCache.Variables.cache(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#42#0#0: DatatypeType, 
    a#42#1#0: DatatypeType, 
    a#42#2#0: DatatypeType, 
    a#42#3#0: DatatypeType, 
    a#42#4#0: DatatypeType, 
    a#42#5#0: DatatypeType, 
    a#42#6#0: Map Box Box, 
    a#42#7#0: Map Box Box, 
    a#42#8#0: Map Box Box :: 
  { #BlockCache.Variables.Ready(a#42#0#0, 
      a#42#1#0, 
      a#42#2#0, 
      a#42#3#0, 
      a#42#4#0, 
      a#42#5#0, 
      a#42#6#0, 
      a#42#7#0, 
      a#42#8#0) } 
  BlockCache.Variables.cache(#BlockCache.Variables.Ready(a#42#0#0, 
        a#42#1#0, 
        a#42#2#0, 
        a#42#3#0, 
        a#42#4#0, 
        a#42#5#0, 
        a#42#6#0, 
        a#42#7#0, 
        a#42#8#0))
     == a#42#8#0);

// Inductive map key rank
axiom (forall a#43#0#0: DatatypeType, 
    a#43#1#0: DatatypeType, 
    a#43#2#0: DatatypeType, 
    a#43#3#0: DatatypeType, 
    a#43#4#0: DatatypeType, 
    a#43#5#0: DatatypeType, 
    a#43#6#0: Map Box Box, 
    a#43#7#0: Map Box Box, 
    a#43#8#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#43#8#0)[$Box(d)], #BlockCache.Variables.Ready(a#43#0#0, 
      a#43#1#0, 
      a#43#2#0, 
      a#43#3#0, 
      a#43#4#0, 
      a#43#5#0, 
      a#43#6#0, 
      a#43#7#0, 
      a#43#8#0) } 
  Map#Domain(a#43#8#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#BlockCache.Variables.Ready(a#43#0#0, 
          a#43#1#0, 
          a#43#2#0, 
          a#43#3#0, 
          a#43#4#0, 
          a#43#5#0, 
          a#43#6#0, 
          a#43#7#0, 
          a#43#8#0)));

// Inductive map value rank
axiom (forall a#44#0#0: DatatypeType, 
    a#44#1#0: DatatypeType, 
    a#44#2#0: DatatypeType, 
    a#44#3#0: DatatypeType, 
    a#44#4#0: DatatypeType, 
    a#44#5#0: DatatypeType, 
    a#44#6#0: Map Box Box, 
    a#44#7#0: Map Box Box, 
    a#44#8#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#44#8#0)[bx], #BlockCache.Variables.Ready(a#44#0#0, 
      a#44#1#0, 
      a#44#2#0, 
      a#44#3#0, 
      a#44#4#0, 
      a#44#5#0, 
      a#44#6#0, 
      a#44#7#0, 
      a#44#8#0) } 
  Map#Domain(a#44#8#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#44#8#0)[bx]): DatatypeType)
       < DtRank(#BlockCache.Variables.Ready(a#44#0#0, 
          a#44#1#0, 
          a#44#2#0, 
          a#44#3#0, 
          a#44#4#0, 
          a#44#5#0, 
          a#44#6#0, 
          a#44#7#0, 
          a#44#8#0)));

// Constructor function declaration
function #BlockCache.Variables.LoadingIndirectionTable(DatatypeType, DatatypeType) : DatatypeType;

const unique ##BlockCache.Variables.LoadingIndirectionTable: DtCtorId;

// Constructor identifier
axiom (forall a#45#0#0: DatatypeType, a#45#1#0: DatatypeType :: 
  { #BlockCache.Variables.LoadingIndirectionTable(a#45#0#0, a#45#1#0) } 
  DatatypeCtorId(#BlockCache.Variables.LoadingIndirectionTable(a#45#0#0, a#45#1#0))
     == ##BlockCache.Variables.LoadingIndirectionTable);

function BlockCache.Variables.LoadingIndirectionTable_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.LoadingIndirectionTable_q(d) } 
  BlockCache.Variables.LoadingIndirectionTable_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Variables.LoadingIndirectionTable);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.LoadingIndirectionTable_q(d) } 
  BlockCache.Variables.LoadingIndirectionTable_q(d)
     ==> (exists a#46#0#0: DatatypeType, a#46#1#0: DatatypeType :: 
      d == #BlockCache.Variables.LoadingIndirectionTable(a#46#0#0, a#46#1#0)));

// Constructor $Is
axiom (forall a#47#0#0: DatatypeType, a#47#1#0: DatatypeType :: 
  { $Is(#BlockCache.Variables.LoadingIndirectionTable(a#47#0#0, a#47#1#0), 
      Tclass.BlockCache.Variables()) } 
  $Is(#BlockCache.Variables.LoadingIndirectionTable(a#47#0#0, a#47#1#0), 
      Tclass.BlockCache.Variables())
     <==> $Is(a#47#0#0, Tclass.DiskLayout.Location())
       && $Is(a#47#1#0, Tclass.Options.Option(Tclass.NativeTypes.uint64())));

// Constructor $IsAlloc
axiom (forall a#48#0#0: DatatypeType, a#48#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#BlockCache.Variables.LoadingIndirectionTable(a#48#0#0, a#48#1#0), 
      Tclass.BlockCache.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Variables.LoadingIndirectionTable(a#48#0#0, a#48#1#0), 
        Tclass.BlockCache.Variables(), 
        $h)
       <==> $IsAlloc(a#48#0#0, Tclass.DiskLayout.Location(), $h)
         && $IsAlloc(a#48#1#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.indirectionTableLoc(d), Tclass.DiskLayout.Location(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.LoadingIndirectionTable_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.indirectionTableLoc(d), Tclass.DiskLayout.Location(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Variables.indirectionTableRead(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Variables.LoadingIndirectionTable_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Variables(), $h)
     ==> $IsAlloc(BlockCache.Variables.indirectionTableRead(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Constructor literal
axiom (forall a#49#0#0: DatatypeType, a#49#1#0: DatatypeType :: 
  { #BlockCache.Variables.LoadingIndirectionTable(Lit(a#49#0#0), Lit(a#49#1#0)) } 
  #BlockCache.Variables.LoadingIndirectionTable(Lit(a#49#0#0), Lit(a#49#1#0))
     == Lit(#BlockCache.Variables.LoadingIndirectionTable(a#49#0#0, a#49#1#0)));

function BlockCache.Variables.indirectionTableLoc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#50#0#0: DatatypeType, a#50#1#0: DatatypeType :: 
  { #BlockCache.Variables.LoadingIndirectionTable(a#50#0#0, a#50#1#0) } 
  BlockCache.Variables.indirectionTableLoc(#BlockCache.Variables.LoadingIndirectionTable(a#50#0#0, a#50#1#0))
     == a#50#0#0);

// Inductive rank
axiom (forall a#51#0#0: DatatypeType, a#51#1#0: DatatypeType :: 
  { #BlockCache.Variables.LoadingIndirectionTable(a#51#0#0, a#51#1#0) } 
  DtRank(a#51#0#0)
     < DtRank(#BlockCache.Variables.LoadingIndirectionTable(a#51#0#0, a#51#1#0)));

function BlockCache.Variables.indirectionTableRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#52#0#0: DatatypeType, a#52#1#0: DatatypeType :: 
  { #BlockCache.Variables.LoadingIndirectionTable(a#52#0#0, a#52#1#0) } 
  BlockCache.Variables.indirectionTableRead(#BlockCache.Variables.LoadingIndirectionTable(a#52#0#0, a#52#1#0))
     == a#52#1#0);

// Inductive rank
axiom (forall a#53#0#0: DatatypeType, a#53#1#0: DatatypeType :: 
  { #BlockCache.Variables.LoadingIndirectionTable(a#53#0#0, a#53#1#0) } 
  DtRank(a#53#1#0)
     < DtRank(#BlockCache.Variables.LoadingIndirectionTable(a#53#0#0, a#53#1#0)));

// Constructor function declaration
function #BlockCache.Variables.Unready() : DatatypeType;

const unique ##BlockCache.Variables.Unready: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Variables.Unready())
   == ##BlockCache.Variables.Unready;

function BlockCache.Variables.Unready_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.Unready_q(d) } 
  BlockCache.Variables.Unready_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Variables.Unready);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.Unready_q(d) } 
  BlockCache.Variables.Unready_q(d) ==> d == #BlockCache.Variables.Unready());

// Constructor $Is
axiom $Is(#BlockCache.Variables.Unready(), Tclass.BlockCache.Variables());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Variables.Unready(), Tclass.BlockCache.Variables(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Variables.Unready(), Tclass.BlockCache.Variables(), $h));

// Constructor literal
axiom #BlockCache.Variables.Unready() == Lit(#BlockCache.Variables.Unready());

// Depth-one case-split function
function $IsA#BlockCache.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockCache.Variables(d) } 
  $IsA#BlockCache.Variables(d)
     ==> BlockCache.Variables.Ready_q(d)
       || BlockCache.Variables.LoadingIndirectionTable_q(d)
       || BlockCache.Variables.Unready_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockCache.Variables.Unready_q(d), $Is(d, Tclass.BlockCache.Variables()) } 
    { BlockCache.Variables.LoadingIndirectionTable_q(d), $Is(d, Tclass.BlockCache.Variables()) } 
    { BlockCache.Variables.Ready_q(d), $Is(d, Tclass.BlockCache.Variables()) } 
  $Is(d, Tclass.BlockCache.Variables())
     ==> BlockCache.Variables.Ready_q(d)
       || BlockCache.Variables.LoadingIndirectionTable_q(d)
       || BlockCache.Variables.Unready_q(d));

// Datatype extensional equality declaration
function BlockCache.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockCache.Variables.Ready
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Variables#Equal(a, b), BlockCache.Variables.Ready_q(a) } 
    { BlockCache.Variables#Equal(a, b), BlockCache.Variables.Ready_q(b) } 
  BlockCache.Variables.Ready_q(a) && BlockCache.Variables.Ready_q(b)
     ==> (BlockCache.Variables#Equal(a, b)
       <==> SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(a), 
          BlockCache.Variables.persistentIndirectionTable(b))
         && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(a), 
          BlockCache.Variables.frozenIndirectionTable(b))
         && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(a), 
          BlockCache.Variables.ephemeralIndirectionTable(b))
         && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(a), 
          BlockCache.Variables.persistentIndirectionTableLoc(b))
         && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(a), 
          BlockCache.Variables.frozenIndirectionTableLoc(b))
         && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(a), 
          BlockCache.Variables.outstandingIndirectionTableWrite(b))
         && Map#Equal(BlockCache.Variables.outstandingBlockWrites(a), 
          BlockCache.Variables.outstandingBlockWrites(b))
         && Map#Equal(BlockCache.Variables.outstandingBlockReads(a), 
          BlockCache.Variables.outstandingBlockReads(b))
         && Map#Equal(BlockCache.Variables.cache(a), BlockCache.Variables.cache(b))));

// Datatype extensional equality definition: #BlockCache.Variables.LoadingIndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Variables#Equal(a, b), BlockCache.Variables.LoadingIndirectionTable_q(a) } 
    { BlockCache.Variables#Equal(a, b), BlockCache.Variables.LoadingIndirectionTable_q(b) } 
  BlockCache.Variables.LoadingIndirectionTable_q(a)
       && BlockCache.Variables.LoadingIndirectionTable_q(b)
     ==> (BlockCache.Variables#Equal(a, b)
       <==> DiskLayout.Location#Equal(BlockCache.Variables.indirectionTableLoc(a), 
          BlockCache.Variables.indirectionTableLoc(b))
         && Options.Option#Equal(BlockCache.Variables.indirectionTableRead(a), 
          BlockCache.Variables.indirectionTableRead(b))));

// Datatype extensional equality definition: #BlockCache.Variables.Unready
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Variables#Equal(a, b), BlockCache.Variables.Unready_q(a) } 
    { BlockCache.Variables#Equal(a, b), BlockCache.Variables.Unready_q(b) } 
  BlockCache.Variables.Unready_q(a) && BlockCache.Variables.Unready_q(b)
     ==> (BlockCache.Variables#Equal(a, b) <==> true));

// Datatype extensionality axiom: BlockCache.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Variables#Equal(a, b) } 
  BlockCache.Variables#Equal(a, b) <==> a == b);

const unique class.BlockCache.Variables: ClassName;

// Constructor function declaration
function #BlockCache.Step.WriteBackNodeReqStep(int) : DatatypeType;

const unique ##BlockCache.Step.WriteBackNodeReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#59#0#0: int :: 
  { #BlockCache.Step.WriteBackNodeReqStep(a#59#0#0) } 
  DatatypeCtorId(#BlockCache.Step.WriteBackNodeReqStep(a#59#0#0))
     == ##BlockCache.Step.WriteBackNodeReqStep);

function BlockCache.Step.WriteBackNodeReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackNodeReqStep_q(d) } 
  BlockCache.Step.WriteBackNodeReqStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.WriteBackNodeReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackNodeReqStep_q(d) } 
  BlockCache.Step.WriteBackNodeReqStep_q(d)
     ==> (exists a#60#0#0: int :: d == #BlockCache.Step.WriteBackNodeReqStep(a#60#0#0)));

function Tclass.BlockCache.Step() : Ty;

// Tclass.BlockCache.Step Tag
axiom Tag(Tclass.BlockCache.Step()) == Tagclass.BlockCache.Step;

const unique Tagclass.BlockCache.Step: TyTag;

// Box/unbox axiom for Tclass.BlockCache.Step
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockCache.Step()) } 
  $IsBox(bx, Tclass.BlockCache.Step())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.BlockCache.Step()));

// Constructor $Is
axiom (forall a#61#0#0: int :: 
  { $Is(#BlockCache.Step.WriteBackNodeReqStep(a#61#0#0), Tclass.BlockCache.Step()) } 
  $Is(#BlockCache.Step.WriteBackNodeReqStep(a#61#0#0), Tclass.BlockCache.Step())
     <==> $Is(a#61#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#62#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.WriteBackNodeReqStep(a#62#0#0), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Step.WriteBackNodeReqStep(a#62#0#0), Tclass.BlockCache.Step(), $h)
       <==> $IsAlloc(a#62#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Step.WriteBackNodeReqStep_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Step(), $h)
     ==> $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#63#0#0: int :: 
  { #BlockCache.Step.WriteBackNodeReqStep(LitInt(a#63#0#0)) } 
  #BlockCache.Step.WriteBackNodeReqStep(LitInt(a#63#0#0))
     == Lit(#BlockCache.Step.WriteBackNodeReqStep(a#63#0#0)));

function BlockCache.Step.ref(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#64#0#0: int :: 
  { #BlockCache.Step.WriteBackNodeReqStep(a#64#0#0) } 
  BlockCache.Step.ref(#BlockCache.Step.WriteBackNodeReqStep(a#64#0#0)) == a#64#0#0);

// Constructor function declaration
function #BlockCache.Step.WriteBackNodeRespStep() : DatatypeType;

const unique ##BlockCache.Step.WriteBackNodeRespStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.WriteBackNodeRespStep())
   == ##BlockCache.Step.WriteBackNodeRespStep;

function BlockCache.Step.WriteBackNodeRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackNodeRespStep_q(d) } 
  BlockCache.Step.WriteBackNodeRespStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.WriteBackNodeRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackNodeRespStep_q(d) } 
  BlockCache.Step.WriteBackNodeRespStep_q(d)
     ==> d == #BlockCache.Step.WriteBackNodeRespStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.WriteBackNodeRespStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.WriteBackNodeRespStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.WriteBackNodeRespStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.WriteBackNodeRespStep()
   == Lit(#BlockCache.Step.WriteBackNodeRespStep());

// Constructor function declaration
function #BlockCache.Step.WriteBackIndirectionTableReqStep() : DatatypeType;

const unique ##BlockCache.Step.WriteBackIndirectionTableReqStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.WriteBackIndirectionTableReqStep())
   == ##BlockCache.Step.WriteBackIndirectionTableReqStep;

function BlockCache.Step.WriteBackIndirectionTableReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackIndirectionTableReqStep_q(d) } 
  BlockCache.Step.WriteBackIndirectionTableReqStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.WriteBackIndirectionTableReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackIndirectionTableReqStep_q(d) } 
  BlockCache.Step.WriteBackIndirectionTableReqStep_q(d)
     ==> d == #BlockCache.Step.WriteBackIndirectionTableReqStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.WriteBackIndirectionTableReqStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.WriteBackIndirectionTableReqStep(), 
      Tclass.BlockCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.WriteBackIndirectionTableReqStep(), 
      Tclass.BlockCache.Step(), 
      $h));

// Constructor literal
axiom #BlockCache.Step.WriteBackIndirectionTableReqStep()
   == Lit(#BlockCache.Step.WriteBackIndirectionTableReqStep());

// Constructor function declaration
function #BlockCache.Step.WriteBackIndirectionTableRespStep() : DatatypeType;

const unique ##BlockCache.Step.WriteBackIndirectionTableRespStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.WriteBackIndirectionTableRespStep())
   == ##BlockCache.Step.WriteBackIndirectionTableRespStep;

function BlockCache.Step.WriteBackIndirectionTableRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackIndirectionTableRespStep_q(d) } 
  BlockCache.Step.WriteBackIndirectionTableRespStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.WriteBackIndirectionTableRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.WriteBackIndirectionTableRespStep_q(d) } 
  BlockCache.Step.WriteBackIndirectionTableRespStep_q(d)
     ==> d == #BlockCache.Step.WriteBackIndirectionTableRespStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.WriteBackIndirectionTableRespStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.WriteBackIndirectionTableRespStep(), 
      Tclass.BlockCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.WriteBackIndirectionTableRespStep(), 
      Tclass.BlockCache.Step(), 
      $h));

// Constructor literal
axiom #BlockCache.Step.WriteBackIndirectionTableRespStep()
   == Lit(#BlockCache.Step.WriteBackIndirectionTableRespStep());

// Constructor function declaration
function #BlockCache.Step.UnallocStep(int) : DatatypeType;

const unique ##BlockCache.Step.UnallocStep: DtCtorId;

// Constructor identifier
axiom (forall a#80#0#0: int :: 
  { #BlockCache.Step.UnallocStep(a#80#0#0) } 
  DatatypeCtorId(#BlockCache.Step.UnallocStep(a#80#0#0))
     == ##BlockCache.Step.UnallocStep);

function BlockCache.Step.UnallocStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.UnallocStep_q(d) } 
  BlockCache.Step.UnallocStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.UnallocStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.UnallocStep_q(d) } 
  BlockCache.Step.UnallocStep_q(d)
     ==> (exists a#81#0#0: int :: d == #BlockCache.Step.UnallocStep(a#81#0#0)));

// Constructor $Is
axiom (forall a#82#0#0: int :: 
  { $Is(#BlockCache.Step.UnallocStep(a#82#0#0), Tclass.BlockCache.Step()) } 
  $Is(#BlockCache.Step.UnallocStep(a#82#0#0), Tclass.BlockCache.Step())
     <==> $Is(a#82#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#83#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.UnallocStep(a#83#0#0), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Step.UnallocStep(a#83#0#0), Tclass.BlockCache.Step(), $h)
       <==> $IsAlloc(a#83#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Step.UnallocStep_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Step(), $h)
     ==> $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#84#0#0: int :: 
  { #BlockCache.Step.UnallocStep(LitInt(a#84#0#0)) } 
  #BlockCache.Step.UnallocStep(LitInt(a#84#0#0))
     == Lit(#BlockCache.Step.UnallocStep(a#84#0#0)));

// Constructor injectivity
axiom (forall a#85#0#0: int :: 
  { #BlockCache.Step.UnallocStep(a#85#0#0) } 
  BlockCache.Step.ref(#BlockCache.Step.UnallocStep(a#85#0#0)) == a#85#0#0);

// Constructor function declaration
function #BlockCache.Step.PageInNodeReqStep(int) : DatatypeType;

const unique ##BlockCache.Step.PageInNodeReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#86#0#0: int :: 
  { #BlockCache.Step.PageInNodeReqStep(a#86#0#0) } 
  DatatypeCtorId(#BlockCache.Step.PageInNodeReqStep(a#86#0#0))
     == ##BlockCache.Step.PageInNodeReqStep);

function BlockCache.Step.PageInNodeReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInNodeReqStep_q(d) } 
  BlockCache.Step.PageInNodeReqStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.PageInNodeReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInNodeReqStep_q(d) } 
  BlockCache.Step.PageInNodeReqStep_q(d)
     ==> (exists a#87#0#0: int :: d == #BlockCache.Step.PageInNodeReqStep(a#87#0#0)));

// Constructor $Is
axiom (forall a#88#0#0: int :: 
  { $Is(#BlockCache.Step.PageInNodeReqStep(a#88#0#0), Tclass.BlockCache.Step()) } 
  $Is(#BlockCache.Step.PageInNodeReqStep(a#88#0#0), Tclass.BlockCache.Step())
     <==> $Is(a#88#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#89#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.PageInNodeReqStep(a#89#0#0), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Step.PageInNodeReqStep(a#89#0#0), Tclass.BlockCache.Step(), $h)
       <==> $IsAlloc(a#89#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Step.PageInNodeReqStep_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Step(), $h)
     ==> $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#90#0#0: int :: 
  { #BlockCache.Step.PageInNodeReqStep(LitInt(a#90#0#0)) } 
  #BlockCache.Step.PageInNodeReqStep(LitInt(a#90#0#0))
     == Lit(#BlockCache.Step.PageInNodeReqStep(a#90#0#0)));

// Constructor injectivity
axiom (forall a#91#0#0: int :: 
  { #BlockCache.Step.PageInNodeReqStep(a#91#0#0) } 
  BlockCache.Step.ref(#BlockCache.Step.PageInNodeReqStep(a#91#0#0)) == a#91#0#0);

// Constructor function declaration
function #BlockCache.Step.PageInNodeRespStep() : DatatypeType;

const unique ##BlockCache.Step.PageInNodeRespStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.PageInNodeRespStep())
   == ##BlockCache.Step.PageInNodeRespStep;

function BlockCache.Step.PageInNodeRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInNodeRespStep_q(d) } 
  BlockCache.Step.PageInNodeRespStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.PageInNodeRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInNodeRespStep_q(d) } 
  BlockCache.Step.PageInNodeRespStep_q(d)
     ==> d == #BlockCache.Step.PageInNodeRespStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.PageInNodeRespStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.PageInNodeRespStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.PageInNodeRespStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.PageInNodeRespStep()
   == Lit(#BlockCache.Step.PageInNodeRespStep());

// Constructor function declaration
function #BlockCache.Step.PageInIndirectionTableReqStep() : DatatypeType;

const unique ##BlockCache.Step.PageInIndirectionTableReqStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.PageInIndirectionTableReqStep())
   == ##BlockCache.Step.PageInIndirectionTableReqStep;

function BlockCache.Step.PageInIndirectionTableReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInIndirectionTableReqStep_q(d) } 
  BlockCache.Step.PageInIndirectionTableReqStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.PageInIndirectionTableReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInIndirectionTableReqStep_q(d) } 
  BlockCache.Step.PageInIndirectionTableReqStep_q(d)
     ==> d == #BlockCache.Step.PageInIndirectionTableReqStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.PageInIndirectionTableReqStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.PageInIndirectionTableReqStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.PageInIndirectionTableReqStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.PageInIndirectionTableReqStep()
   == Lit(#BlockCache.Step.PageInIndirectionTableReqStep());

// Constructor function declaration
function #BlockCache.Step.PageInIndirectionTableRespStep() : DatatypeType;

const unique ##BlockCache.Step.PageInIndirectionTableRespStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.PageInIndirectionTableRespStep())
   == ##BlockCache.Step.PageInIndirectionTableRespStep;

function BlockCache.Step.PageInIndirectionTableRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInIndirectionTableRespStep_q(d) } 
  BlockCache.Step.PageInIndirectionTableRespStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.PageInIndirectionTableRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.PageInIndirectionTableRespStep_q(d) } 
  BlockCache.Step.PageInIndirectionTableRespStep_q(d)
     ==> d == #BlockCache.Step.PageInIndirectionTableRespStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.PageInIndirectionTableRespStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.PageInIndirectionTableRespStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.PageInIndirectionTableRespStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.PageInIndirectionTableRespStep()
   == Lit(#BlockCache.Step.PageInIndirectionTableRespStep());

// Constructor function declaration
function #BlockCache.Step.ReceiveLocStep() : DatatypeType;

const unique ##BlockCache.Step.ReceiveLocStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.ReceiveLocStep())
   == ##BlockCache.Step.ReceiveLocStep;

function BlockCache.Step.ReceiveLocStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.ReceiveLocStep_q(d) } 
  BlockCache.Step.ReceiveLocStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.ReceiveLocStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.ReceiveLocStep_q(d) } 
  BlockCache.Step.ReceiveLocStep_q(d) ==> d == #BlockCache.Step.ReceiveLocStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.ReceiveLocStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.ReceiveLocStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.ReceiveLocStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.ReceiveLocStep() == Lit(#BlockCache.Step.ReceiveLocStep());

// Constructor function declaration
function #BlockCache.Step.EvictStep(int) : DatatypeType;

const unique ##BlockCache.Step.EvictStep: DtCtorId;

// Constructor identifier
axiom (forall a#112#0#0: int :: 
  { #BlockCache.Step.EvictStep(a#112#0#0) } 
  DatatypeCtorId(#BlockCache.Step.EvictStep(a#112#0#0))
     == ##BlockCache.Step.EvictStep);

function BlockCache.Step.EvictStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.EvictStep_q(d) } 
  BlockCache.Step.EvictStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.EvictStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.EvictStep_q(d) } 
  BlockCache.Step.EvictStep_q(d)
     ==> (exists a#113#0#0: int :: d == #BlockCache.Step.EvictStep(a#113#0#0)));

// Constructor $Is
axiom (forall a#114#0#0: int :: 
  { $Is(#BlockCache.Step.EvictStep(a#114#0#0), Tclass.BlockCache.Step()) } 
  $Is(#BlockCache.Step.EvictStep(a#114#0#0), Tclass.BlockCache.Step())
     <==> $Is(a#114#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#115#0#0: int, $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.EvictStep(a#115#0#0), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Step.EvictStep(a#115#0#0), Tclass.BlockCache.Step(), $h)
       <==> $IsAlloc(a#115#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Step.EvictStep_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Step(), $h)
     ==> $IsAlloc(BlockCache.Step.ref(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#116#0#0: int :: 
  { #BlockCache.Step.EvictStep(LitInt(a#116#0#0)) } 
  #BlockCache.Step.EvictStep(LitInt(a#116#0#0))
     == Lit(#BlockCache.Step.EvictStep(a#116#0#0)));

// Constructor injectivity
axiom (forall a#117#0#0: int :: 
  { #BlockCache.Step.EvictStep(a#117#0#0) } 
  BlockCache.Step.ref(#BlockCache.Step.EvictStep(a#117#0#0)) == a#117#0#0);

// Constructor function declaration
function #BlockCache.Step.FreezeStep() : DatatypeType;

const unique ##BlockCache.Step.FreezeStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.FreezeStep()) == ##BlockCache.Step.FreezeStep;

function BlockCache.Step.FreezeStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.FreezeStep_q(d) } 
  BlockCache.Step.FreezeStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.FreezeStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.FreezeStep_q(d) } 
  BlockCache.Step.FreezeStep_q(d) ==> d == #BlockCache.Step.FreezeStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.FreezeStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.FreezeStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.FreezeStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.FreezeStep() == Lit(#BlockCache.Step.FreezeStep());

// Constructor function declaration
function #BlockCache.Step.CleanUpStep() : DatatypeType;

const unique ##BlockCache.Step.CleanUpStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.CleanUpStep()) == ##BlockCache.Step.CleanUpStep;

function BlockCache.Step.CleanUpStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.CleanUpStep_q(d) } 
  BlockCache.Step.CleanUpStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.CleanUpStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.CleanUpStep_q(d) } 
  BlockCache.Step.CleanUpStep_q(d) ==> d == #BlockCache.Step.CleanUpStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.CleanUpStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.CleanUpStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.CleanUpStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.CleanUpStep() == Lit(#BlockCache.Step.CleanUpStep());

// Constructor function declaration
function #BlockCache.Step.NoOpStep() : DatatypeType;

const unique ##BlockCache.Step.NoOpStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#BlockCache.Step.NoOpStep()) == ##BlockCache.Step.NoOpStep;

function BlockCache.Step.NoOpStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.NoOpStep_q(d) } 
  BlockCache.Step.NoOpStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.NoOpStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.NoOpStep_q(d) } 
  BlockCache.Step.NoOpStep_q(d) ==> d == #BlockCache.Step.NoOpStep());

// Constructor $Is
axiom $Is(#BlockCache.Step.NoOpStep(), Tclass.BlockCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.NoOpStep(), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#BlockCache.Step.NoOpStep(), Tclass.BlockCache.Step(), $h));

// Constructor literal
axiom #BlockCache.Step.NoOpStep() == Lit(#BlockCache.Step.NoOpStep());

// Constructor function declaration
function #BlockCache.Step.TransactionStep(Seq Box) : DatatypeType;

const unique ##BlockCache.Step.TransactionStep: DtCtorId;

// Constructor identifier
axiom (forall a#133#0#0: Seq Box :: 
  { #BlockCache.Step.TransactionStep(a#133#0#0) } 
  DatatypeCtorId(#BlockCache.Step.TransactionStep(a#133#0#0))
     == ##BlockCache.Step.TransactionStep);

function BlockCache.Step.TransactionStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.TransactionStep_q(d) } 
  BlockCache.Step.TransactionStep_q(d)
     <==> DatatypeCtorId(d) == ##BlockCache.Step.TransactionStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.TransactionStep_q(d) } 
  BlockCache.Step.TransactionStep_q(d)
     ==> (exists a#134#0#0: Seq Box :: d == #BlockCache.Step.TransactionStep(a#134#0#0)));

// Constructor $Is
axiom (forall a#135#0#0: Seq Box :: 
  { $Is(#BlockCache.Step.TransactionStep(a#135#0#0), Tclass.BlockCache.Step()) } 
  $Is(#BlockCache.Step.TransactionStep(a#135#0#0), Tclass.BlockCache.Step())
     <==> $Is(a#135#0#0, TSeq(Tclass.PivotBetreeGraph.Op())));

// Constructor $IsAlloc
axiom (forall a#136#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#BlockCache.Step.TransactionStep(a#136#0#0), Tclass.BlockCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#BlockCache.Step.TransactionStep(a#136#0#0), Tclass.BlockCache.Step(), $h)
       <==> $IsAlloc(a#136#0#0, TSeq(Tclass.PivotBetreeGraph.Op()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(BlockCache.Step.ops(d), TSeq(Tclass.PivotBetreeGraph.Op()), $h) } 
  $IsGoodHeap($h)
       && 
      BlockCache.Step.TransactionStep_q(d)
       && $IsAlloc(d, Tclass.BlockCache.Step(), $h)
     ==> $IsAlloc(BlockCache.Step.ops(d), TSeq(Tclass.PivotBetreeGraph.Op()), $h));

// Constructor literal
axiom (forall a#137#0#0: Seq Box :: 
  { #BlockCache.Step.TransactionStep(Lit(a#137#0#0)) } 
  #BlockCache.Step.TransactionStep(Lit(a#137#0#0))
     == Lit(#BlockCache.Step.TransactionStep(a#137#0#0)));

function BlockCache.Step.ops(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#138#0#0: Seq Box :: 
  { #BlockCache.Step.TransactionStep(a#138#0#0) } 
  BlockCache.Step.ops(#BlockCache.Step.TransactionStep(a#138#0#0)) == a#138#0#0);

// Inductive seq element rank
axiom (forall a#139#0#0: Seq Box, i: int :: 
  { Seq#Index(a#139#0#0, i), #BlockCache.Step.TransactionStep(a#139#0#0) } 
  0 <= i && i < Seq#Length(a#139#0#0)
     ==> DtRank($Unbox(Seq#Index(a#139#0#0, i)): DatatypeType)
       < DtRank(#BlockCache.Step.TransactionStep(a#139#0#0)));

// Inductive seq rank
axiom (forall a#140#0#0: Seq Box :: 
  { #BlockCache.Step.TransactionStep(a#140#0#0) } 
  Seq#Rank(a#140#0#0) < DtRank(#BlockCache.Step.TransactionStep(a#140#0#0)));

// Depth-one case-split function
function $IsA#BlockCache.Step(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#BlockCache.Step(d) } 
  $IsA#BlockCache.Step(d)
     ==> BlockCache.Step.WriteBackNodeReqStep_q(d)
       || BlockCache.Step.WriteBackNodeRespStep_q(d)
       || BlockCache.Step.WriteBackIndirectionTableReqStep_q(d)
       || BlockCache.Step.WriteBackIndirectionTableRespStep_q(d)
       || BlockCache.Step.UnallocStep_q(d)
       || BlockCache.Step.PageInNodeReqStep_q(d)
       || BlockCache.Step.PageInNodeRespStep_q(d)
       || BlockCache.Step.PageInIndirectionTableReqStep_q(d)
       || BlockCache.Step.PageInIndirectionTableRespStep_q(d)
       || BlockCache.Step.ReceiveLocStep_q(d)
       || BlockCache.Step.EvictStep_q(d)
       || BlockCache.Step.FreezeStep_q(d)
       || BlockCache.Step.CleanUpStep_q(d)
       || BlockCache.Step.NoOpStep_q(d)
       || BlockCache.Step.TransactionStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { BlockCache.Step.TransactionStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.NoOpStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.CleanUpStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.FreezeStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.EvictStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.ReceiveLocStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.PageInIndirectionTableRespStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.PageInIndirectionTableReqStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.PageInNodeRespStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.PageInNodeReqStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.UnallocStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.WriteBackIndirectionTableRespStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.WriteBackIndirectionTableReqStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.WriteBackNodeRespStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
    { BlockCache.Step.WriteBackNodeReqStep_q(d), $Is(d, Tclass.BlockCache.Step()) } 
  $Is(d, Tclass.BlockCache.Step())
     ==> BlockCache.Step.WriteBackNodeReqStep_q(d)
       || BlockCache.Step.WriteBackNodeRespStep_q(d)
       || BlockCache.Step.WriteBackIndirectionTableReqStep_q(d)
       || BlockCache.Step.WriteBackIndirectionTableRespStep_q(d)
       || BlockCache.Step.UnallocStep_q(d)
       || BlockCache.Step.PageInNodeReqStep_q(d)
       || BlockCache.Step.PageInNodeRespStep_q(d)
       || BlockCache.Step.PageInIndirectionTableReqStep_q(d)
       || BlockCache.Step.PageInIndirectionTableRespStep_q(d)
       || BlockCache.Step.ReceiveLocStep_q(d)
       || BlockCache.Step.EvictStep_q(d)
       || BlockCache.Step.FreezeStep_q(d)
       || BlockCache.Step.CleanUpStep_q(d)
       || BlockCache.Step.NoOpStep_q(d)
       || BlockCache.Step.TransactionStep_q(d));

// Datatype extensional equality declaration
function BlockCache.Step#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #BlockCache.Step.WriteBackNodeReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackNodeReqStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackNodeReqStep_q(b) } 
  BlockCache.Step.WriteBackNodeReqStep_q(a)
       && BlockCache.Step.WriteBackNodeReqStep_q(b)
     ==> (BlockCache.Step#Equal(a, b)
       <==> BlockCache.Step.ref(a) == BlockCache.Step.ref(b)));

// Datatype extensional equality definition: #BlockCache.Step.WriteBackNodeRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackNodeRespStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackNodeRespStep_q(b) } 
  BlockCache.Step.WriteBackNodeRespStep_q(a)
       && BlockCache.Step.WriteBackNodeRespStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.WriteBackIndirectionTableReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackIndirectionTableReqStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackIndirectionTableReqStep_q(b) } 
  BlockCache.Step.WriteBackIndirectionTableReqStep_q(a)
       && BlockCache.Step.WriteBackIndirectionTableReqStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.WriteBackIndirectionTableRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackIndirectionTableRespStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.WriteBackIndirectionTableRespStep_q(b) } 
  BlockCache.Step.WriteBackIndirectionTableRespStep_q(a)
       && BlockCache.Step.WriteBackIndirectionTableRespStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.UnallocStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.UnallocStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.UnallocStep_q(b) } 
  BlockCache.Step.UnallocStep_q(a) && BlockCache.Step.UnallocStep_q(b)
     ==> (BlockCache.Step#Equal(a, b)
       <==> BlockCache.Step.ref(a) == BlockCache.Step.ref(b)));

// Datatype extensional equality definition: #BlockCache.Step.PageInNodeReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInNodeReqStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInNodeReqStep_q(b) } 
  BlockCache.Step.PageInNodeReqStep_q(a) && BlockCache.Step.PageInNodeReqStep_q(b)
     ==> (BlockCache.Step#Equal(a, b)
       <==> BlockCache.Step.ref(a) == BlockCache.Step.ref(b)));

// Datatype extensional equality definition: #BlockCache.Step.PageInNodeRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInNodeRespStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInNodeRespStep_q(b) } 
  BlockCache.Step.PageInNodeRespStep_q(a)
       && BlockCache.Step.PageInNodeRespStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.PageInIndirectionTableReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInIndirectionTableReqStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInIndirectionTableReqStep_q(b) } 
  BlockCache.Step.PageInIndirectionTableReqStep_q(a)
       && BlockCache.Step.PageInIndirectionTableReqStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.PageInIndirectionTableRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInIndirectionTableRespStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.PageInIndirectionTableRespStep_q(b) } 
  BlockCache.Step.PageInIndirectionTableRespStep_q(a)
       && BlockCache.Step.PageInIndirectionTableRespStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.ReceiveLocStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.ReceiveLocStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.ReceiveLocStep_q(b) } 
  BlockCache.Step.ReceiveLocStep_q(a) && BlockCache.Step.ReceiveLocStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.EvictStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.EvictStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.EvictStep_q(b) } 
  BlockCache.Step.EvictStep_q(a) && BlockCache.Step.EvictStep_q(b)
     ==> (BlockCache.Step#Equal(a, b)
       <==> BlockCache.Step.ref(a) == BlockCache.Step.ref(b)));

// Datatype extensional equality definition: #BlockCache.Step.FreezeStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.FreezeStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.FreezeStep_q(b) } 
  BlockCache.Step.FreezeStep_q(a) && BlockCache.Step.FreezeStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.CleanUpStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.CleanUpStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.CleanUpStep_q(b) } 
  BlockCache.Step.CleanUpStep_q(a) && BlockCache.Step.CleanUpStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.NoOpStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.NoOpStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.NoOpStep_q(b) } 
  BlockCache.Step.NoOpStep_q(a) && BlockCache.Step.NoOpStep_q(b)
     ==> (BlockCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #BlockCache.Step.TransactionStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b), BlockCache.Step.TransactionStep_q(a) } 
    { BlockCache.Step#Equal(a, b), BlockCache.Step.TransactionStep_q(b) } 
  BlockCache.Step.TransactionStep_q(a) && BlockCache.Step.TransactionStep_q(b)
     ==> (BlockCache.Step#Equal(a, b)
       <==> Seq#Equal(BlockCache.Step.ops(a), BlockCache.Step.ops(b))));

// Datatype extensionality axiom: BlockCache.Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { BlockCache.Step#Equal(a, b) } 
  BlockCache.Step#Equal(a, b) <==> a == b);

const unique class.BlockCache.Step: ClassName;

const unique class.BlockCache.__default: ClassName;

function Tclass.BlockCache.__default() : Ty;

// Tclass.BlockCache.__default Tag
axiom Tag(Tclass.BlockCache.__default()) == Tagclass.BlockCache.__default;

const unique Tagclass.BlockCache.__default: TyTag;

// Box/unbox axiom for Tclass.BlockCache.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BlockCache.__default()) } 
  $IsBox(bx, Tclass.BlockCache.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BlockCache.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BlockCache.__default()) } 
  $Is($o, Tclass.BlockCache.__default())
     <==> $o == null || dtype($o) == Tclass.BlockCache.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BlockCache.__default(), $h) } 
  $IsAlloc($o, Tclass.BlockCache.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BlockCache._default.IsAllocated
function BlockCache.__default.IsAllocated(s#0: DatatypeType, ref#0: int) : bool;

function BlockCache.__default.IsAllocated#canCall(s#0: DatatypeType, ref#0: int) : bool;

// consequence axiom for BlockCache.__default.IsAllocated
axiom true
   ==> (forall s#0: DatatypeType, ref#0: int :: 
    { BlockCache.__default.IsAllocated(s#0, ref#0) } 
    BlockCache.__default.IsAllocated#canCall(s#0, ref#0)
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && BlockCache.Variables.Ready_q(s#0))
       ==> true);

function BlockCache.__default.IsAllocated#requires(DatatypeType, int) : bool;

// #requires axiom for BlockCache.__default.IsAllocated
axiom (forall s#0: DatatypeType, ref#0: int :: 
  { BlockCache.__default.IsAllocated#requires(s#0, ref#0) } 
  $Is(s#0, Tclass.BlockCache.Variables())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.IsAllocated#requires(s#0, ref#0)
       == BlockCache.Variables.Ready_q(s#0));

// definition axiom for BlockCache.__default.IsAllocated(revealed)
axiom true
   ==> (forall s#0: DatatypeType, ref#0: int :: 
    { BlockCache.__default.IsAllocated(s#0, ref#0) } 
    BlockCache.__default.IsAllocated#canCall(s#0, ref#0)
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && BlockCache.Variables.Ready_q(s#0))
       ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
         && BlockCache.__default.IsAllocated(s#0, ref#0)
           == Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]);

// definition axiom for BlockCache.__default.IsAllocated for decreasing-related literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType, ref#0: int :: 
    {:weight 3} { BlockCache.__default.IsAllocated(Lit(s#0), ref#0) } 
    BlockCache.__default.IsAllocated#canCall(Lit(s#0), ref#0)
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && Lit(BlockCache.Variables.Ready_q(Lit(s#0))))
       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
         && BlockCache.__default.IsAllocated(Lit(s#0), ref#0)
           == Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]);

// definition axiom for BlockCache.__default.IsAllocated for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType, ref#0: int :: 
    {:weight 3} { BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0)) } 
    BlockCache.__default.IsAllocated#canCall(Lit(s#0), LitInt(ref#0))
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && Lit(BlockCache.Variables.Ready_q(Lit(s#0))))
       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
         && BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0))
           == Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]);

// function declaration for BlockCache._default.GraphClosed
function BlockCache.__default.GraphClosed(graph#0: Map Box Box) : bool;

function BlockCache.__default.GraphClosed#canCall(graph#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.GraphClosed
axiom true
   ==> (forall graph#0: Map Box Box :: 
    { BlockCache.__default.GraphClosed(graph#0) } 
    BlockCache.__default.GraphClosed#canCall(graph#0)
         || $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function BlockCache.__default.GraphClosed#requires(Map Box Box) : bool;

// #requires axiom for BlockCache.__default.GraphClosed
axiom (forall graph#0: Map Box Box :: 
  { BlockCache.__default.GraphClosed#requires(graph#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
     ==> BlockCache.__default.GraphClosed#requires(graph#0) == true);

// definition axiom for BlockCache.__default.GraphClosed(revealed)
axiom true
   ==> (forall graph#0: Map Box Box :: 
    { BlockCache.__default.GraphClosed(graph#0) } 
    BlockCache.__default.GraphClosed#canCall(graph#0)
         || $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       ==> BlockCache.__default.GraphClosed(graph#0)
         == (forall ref#0: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(ref#0)] } 
          LitInt(0) <= ref#0
               && ref#0 < 18446744073709551616
               && Map#Domain(graph#0)[$Box(ref#0)]
             ==> (forall succ#0: int :: 
              { Map#Domain(graph#0)[$Box(succ#0)] } 
                { Seq#Contains($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box, $Box(succ#0)) } 
              LitInt(0) <= succ#0
                   && succ#0 < 18446744073709551616
                   && Seq#Contains($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box, $Box(succ#0))
                 ==> Map#Domain(graph#0)[$Box(succ#0)])));

// definition axiom for BlockCache.__default.GraphClosed for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.GraphClosed(Lit(graph#0)) } 
    BlockCache.__default.GraphClosed#canCall(Lit(graph#0))
         || $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       ==> BlockCache.__default.GraphClosed(Lit(graph#0))
         == (forall ref#1: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && Map#Domain(graph#0)[$Box(ref#1)]
             ==> (forall succ#1: int :: 
              { Map#Domain(graph#0)[$Box(succ#1)] } 
                { Seq#Contains($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box, $Box(succ#1)) } 
              LitInt(0) <= succ#1
                   && succ#1 < 18446744073709551616
                   && Seq#Contains($Unbox(Map#Elements(Lit(graph#0))[$Box(ref#1)]): Seq Box, $Box(succ#1))
                 ==> Map#Domain(graph#0)[$Box(succ#1)])));

// function declaration for BlockCache._default.WFCompleteIndirectionTable
function BlockCache.__default.WFCompleteIndirectionTable(indirectionTable#0: DatatypeType) : bool;

function BlockCache.__default.WFCompleteIndirectionTable#canCall(indirectionTable#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.WFCompleteIndirectionTable
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.WFCompleteIndirectionTable(indirectionTable#0) } 
    BlockCache.__default.WFCompleteIndirectionTable#canCall(indirectionTable#0)
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> true);

function BlockCache.__default.WFCompleteIndirectionTable#requires(DatatypeType) : bool;

// #requires axiom for BlockCache.__default.WFCompleteIndirectionTable
axiom (forall indirectionTable#0: DatatypeType :: 
  { BlockCache.__default.WFCompleteIndirectionTable#requires(indirectionTable#0) } 
  $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
     ==> BlockCache.__default.WFCompleteIndirectionTable#requires(indirectionTable#0)
       == true);

// definition axiom for BlockCache.__default.WFCompleteIndirectionTable(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.WFCompleteIndirectionTable(indirectionTable#0) } 
    BlockCache.__default.WFCompleteIndirectionTable#canCall(indirectionTable#0)
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> (forall loc#0: DatatypeType :: 
          { DiskLayout.__default.ValidNodeLocation(loc#0) } 
            { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)] } 
          $Is(loc#0, Tclass.DiskLayout.Location())
             ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
               && (Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)]
                 ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0)))
         && ((forall loc#0: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#0) } 
              { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)] } 
            $Is(loc#0, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && (SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0)), 
              Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0)))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && (PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(PivotBetreeGraph.__default.Root())]
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(indirectionTable#0)))
         && BlockCache.__default.WFCompleteIndirectionTable(indirectionTable#0)
           == (
            (forall loc#0: DatatypeType :: 
              { DiskLayout.__default.ValidNodeLocation(loc#0) } 
                { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)] } 
              $Is(loc#0, Tclass.DiskLayout.Location())
                   && Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)]
                 ==> DiskLayout.__default.ValidNodeLocation(loc#0))
             && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0)), 
              Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0)))
             && Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(PivotBetreeGraph.__default.Root())]
             && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(indirectionTable#0))));

// definition axiom for BlockCache.__default.WFCompleteIndirectionTable for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.WFCompleteIndirectionTable(Lit(indirectionTable#0)) } 
    BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit(indirectionTable#0))
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> (forall loc#1: DatatypeType :: 
          { DiskLayout.__default.ValidNodeLocation(loc#1) } 
            { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#1)] } 
          $Is(loc#1, Tclass.DiskLayout.Location())
             ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
               && (Lit(Map#Values(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))[$Box(loc#1)]
                 ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#1)))
         && ((forall loc#1: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#1) } 
              { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#1)] } 
            $Is(loc#1, Tclass.DiskLayout.Location())
                 && Lit(Map#Values(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))[$Box(loc#1)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#1))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && Set#Equal(Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))), 
              Map#Domain(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(PivotBetreeGraph.__default.Root())]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))))
         && BlockCache.__default.WFCompleteIndirectionTable(Lit(indirectionTable#0))
           == (
            (forall loc#1: DatatypeType :: 
              { DiskLayout.__default.ValidNodeLocation(loc#1) } 
                { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#1)] } 
              $Is(loc#1, Tclass.DiskLayout.Location())
                   && Lit(Map#Values(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))[$Box(loc#1)]
                 ==> DiskLayout.__default.ValidNodeLocation(loc#1))
             && Set#Equal(Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))), 
              Map#Domain(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(PivotBetreeGraph.__default.Root())]
             && BlockCache.__default.GraphClosed(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0))))));

// function declaration for BlockCache._default.WFIndirectionTable
function BlockCache.__default.WFIndirectionTable(indirectionTable#0: DatatypeType) : bool;

function BlockCache.__default.WFIndirectionTable#canCall(indirectionTable#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.WFIndirectionTable
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.WFIndirectionTable(indirectionTable#0) } 
    BlockCache.__default.WFIndirectionTable#canCall(indirectionTable#0)
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> true);

function BlockCache.__default.WFIndirectionTable#requires(DatatypeType) : bool;

// #requires axiom for BlockCache.__default.WFIndirectionTable
axiom (forall indirectionTable#0: DatatypeType :: 
  { BlockCache.__default.WFIndirectionTable#requires(indirectionTable#0) } 
  $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
     ==> BlockCache.__default.WFIndirectionTable#requires(indirectionTable#0) == true);

// definition axiom for BlockCache.__default.WFIndirectionTable(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.WFIndirectionTable(indirectionTable#0) } 
    BlockCache.__default.WFIndirectionTable#canCall(indirectionTable#0)
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> (forall loc#0: DatatypeType :: 
          { DiskLayout.__default.ValidNodeLocation(loc#0) } 
            { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)] } 
          $Is(loc#0, Tclass.DiskLayout.Location())
             ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
               && (Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)]
                 ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0)))
         && ((forall loc#0: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#0) } 
              { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)] } 
            $Is(loc#0, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && (SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && Set#Subset(Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0)), 
              Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0)))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && (PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(PivotBetreeGraph.__default.Root())]
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(indirectionTable#0)))
         && BlockCache.__default.WFIndirectionTable(indirectionTable#0)
           == (
            (forall loc#0: DatatypeType :: 
              { DiskLayout.__default.ValidNodeLocation(loc#0) } 
                { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)] } 
              $Is(loc#0, Tclass.DiskLayout.Location())
                   && Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#0)]
                 ==> DiskLayout.__default.ValidNodeLocation(loc#0))
             && Set#Subset(Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0)), 
              Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0)))
             && Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(PivotBetreeGraph.__default.Root())]
             && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(indirectionTable#0))));

// definition axiom for BlockCache.__default.WFIndirectionTable for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.WFIndirectionTable(Lit(indirectionTable#0)) } 
    BlockCache.__default.WFIndirectionTable#canCall(Lit(indirectionTable#0))
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> (forall loc#1: DatatypeType :: 
          { DiskLayout.__default.ValidNodeLocation(loc#1) } 
            { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#1)] } 
          $Is(loc#1, Tclass.DiskLayout.Location())
             ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
               && (Lit(Map#Values(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))[$Box(loc#1)]
                 ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#1)))
         && ((forall loc#1: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(loc#1) } 
              { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#1)] } 
            $Is(loc#1, Tclass.DiskLayout.Location())
                 && Lit(Map#Values(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))[$Box(loc#1)]
               ==> DiskLayout.__default.ValidNodeLocation(loc#1))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && Set#Subset(Map#Domain(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))), 
              Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (PivotBetreeGraph.__default.Root#canCall()
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(PivotBetreeGraph.__default.Root())]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))))
         && BlockCache.__default.WFIndirectionTable(Lit(indirectionTable#0))
           == (
            (forall loc#1: DatatypeType :: 
              { DiskLayout.__default.ValidNodeLocation(loc#1) } 
                { Map#Values(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(loc#1)] } 
              $Is(loc#1, Tclass.DiskLayout.Location())
                   && Lit(Map#Values(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))))[$Box(loc#1)]
                 ==> DiskLayout.__default.ValidNodeLocation(loc#1))
             && Set#Subset(Map#Domain(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))), 
              Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(PivotBetreeGraph.__default.Root())]
             && BlockCache.__default.GraphClosed(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0))))));

// function declaration for BlockCache._default.ValidAllocation
function BlockCache.__default.ValidAllocation(s#0: DatatypeType, loc#0: DatatypeType) : bool;

function BlockCache.__default.ValidAllocation#canCall(s#0: DatatypeType, loc#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.ValidAllocation
axiom true
   ==> (forall s#0: DatatypeType, loc#0: DatatypeType :: 
    { BlockCache.__default.ValidAllocation(s#0, loc#0) } 
    BlockCache.__default.ValidAllocation#canCall(s#0, loc#0)
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(loc#0, Tclass.DiskLayout.Location())
           && BlockCache.Variables.Ready_q(s#0))
       ==> true);

function BlockCache.__default.ValidAllocation#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.ValidAllocation
axiom (forall s#0: DatatypeType, loc#0: DatatypeType :: 
  { BlockCache.__default.ValidAllocation#requires(s#0, loc#0) } 
  $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(loc#0, Tclass.DiskLayout.Location())
     ==> BlockCache.__default.ValidAllocation#requires(s#0, loc#0)
       == BlockCache.Variables.Ready_q(s#0));

// definition axiom for BlockCache.__default.ValidAllocation(revealed)
axiom true
   ==> (forall s#0: DatatypeType, loc#0: DatatypeType :: 
    { BlockCache.__default.ValidAllocation(s#0, loc#0) } 
    BlockCache.__default.ValidAllocation#canCall(s#0, loc#0)
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(loc#0, Tclass.DiskLayout.Location())
           && BlockCache.Variables.Ready_q(s#0))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.persistentIndirectionTable(s#0))
               && (Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]
                 ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.persistentIndirectionTable(s#0))
                   && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType)
                   && DiskLayout.Location.Location_q(loc#0)))
         && ((forall ref#0: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]
               ==> DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType)
                 != DiskLayout.Location.addr(loc#0))
           ==> (forall ref#1: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                 && (Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType)
                     && DiskLayout.Location.Location_q(loc#0))))
         && ((forall ref#1: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)] } 
              LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                 ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                   && (Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]
                     ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                       && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType)
                       && DiskLayout.Location.Location_q(loc#0)))
             && (forall ref#1: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType)
                   != DiskLayout.Location.addr(loc#0))
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> (forall ref#2: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)] } 
            LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && (Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType)
                     && DiskLayout.Location.Location_q(loc#0))))
         && ((Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> (forall ref#2: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType } 
                  { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)] } 
                LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                   ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                     && (Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]
                       ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                         && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType)
                         && DiskLayout.Location.Location_q(loc#0))))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> (forall ref#2: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType } 
                  { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)] } 
                LitInt(0) <= ref#2
                     && ref#2 < 18446744073709551616
                     && Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]
                   ==> DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType)
                     != DiskLayout.Location.addr(loc#0)))
           ==> (forall id#0: int :: 
            { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType } 
              { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)] } 
            LitInt(0) <= id#0 && id#0 < 18446744073709551616
               ==> 
              Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]
               ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)
                 && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType))
                 && DiskLayout.Location.Location_q(loc#0)))
         && BlockCache.__default.ValidAllocation(s#0, loc#0)
           == (
            (forall ref#0: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType)
                   != DiskLayout.Location.addr(loc#0))
             && (forall ref#1: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType)
                   != DiskLayout.Location.addr(loc#0))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> (forall ref#2: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType } 
                  { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)] } 
                LitInt(0) <= ref#2
                     && ref#2 < 18446744073709551616
                     && Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]
                   ==> DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#2)]): DatatypeType)
                     != DiskLayout.Location.addr(loc#0)))
             && (forall id#0: int :: 
              { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType } 
                { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)] } 
              LitInt(0) <= id#0
                   && id#0 < 18446744073709551616
                   && Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]
                 ==> DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType))
                   != DiskLayout.Location.addr(loc#0))));

// definition axiom for BlockCache.__default.ValidAllocation for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType, loc#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.ValidAllocation(Lit(s#0), Lit(loc#0)) } 
    BlockCache.__default.ValidAllocation#canCall(Lit(s#0), Lit(loc#0))
         || (
          $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(loc#0, Tclass.DiskLayout.Location())
           && Lit(BlockCache.Variables.Ready_q(Lit(s#0))))
       ==> (forall ref#3: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#3)]): DatatypeType } 
            { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#3)] } 
          LitInt(0) <= ref#3 && ref#3 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
               && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))[$Box(ref#3)]
                 ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
                   && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))))[$Box(ref#3)]): DatatypeType)
                   && DiskLayout.Location.Location_q(Lit(loc#0))))
         && ((forall ref#3: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#3)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#3)] } 
            LitInt(0) <= ref#3
                 && ref#3 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))[$Box(ref#3)]
               ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))))[$Box(ref#3)]): DatatypeType)
                 != DiskLayout.Location.addr(Lit(loc#0)))
           ==> (forall ref#4: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)] } 
            LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                 && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#4)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#4)]): DatatypeType)
                     && DiskLayout.Location.Location_q(Lit(loc#0)))))
         && ((forall ref#4: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)] } 
              LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
                 ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                   && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#4)]
                     ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                       && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#4)]): DatatypeType)
                       && DiskLayout.Location.Location_q(Lit(loc#0))))
             && (forall ref#4: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#4)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#4)]): DatatypeType)
                   != DiskLayout.Location.addr(Lit(loc#0)))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> (forall ref#5: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)] } 
            LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && (Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#5)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))[$Box(ref#5)]): DatatypeType)
                     && DiskLayout.Location.Location_q(Lit(loc#0)))))
         && ((Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> (forall ref#5: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)]): DatatypeType } 
                  { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)] } 
                LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                     && (Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#5)]
                       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                         && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))[$Box(ref#5)]): DatatypeType)
                         && DiskLayout.Location.Location_q(Lit(loc#0)))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> (forall ref#5: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)]): DatatypeType } 
                  { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#5)]
                   ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))[$Box(ref#5)]): DatatypeType)
                     != DiskLayout.Location.addr(Lit(loc#0))))
           ==> (forall id#1: int :: 
            { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)]): DatatypeType } 
              { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)] } 
            LitInt(0) <= id#1 && id#1 < 18446744073709551616
               ==> 
              Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(id#1)]
               ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)
                 && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType))
                 && DiskLayout.Location.Location_q(Lit(loc#0))))
         && BlockCache.__default.ValidAllocation(Lit(s#0), Lit(loc#0))
           == (
            (forall ref#3: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#3)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.persistentIndirectionTable(s#0)))[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))[$Box(ref#3)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))))[$Box(ref#3)]): DatatypeType)
                   != DiskLayout.Location.addr(Lit(loc#0)))
             && (forall ref#4: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#4)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#4)]): DatatypeType)
                   != DiskLayout.Location.addr(Lit(loc#0)))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> (forall ref#5: int :: 
                { $Unbox(Map#Elements(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)]): DatatypeType } 
                  { Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#5)] } 
                LitInt(0) <= ref#5
                     && ref#5 < 18446744073709551616
                     && Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#5)]
                   ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))[$Box(ref#5)]): DatatypeType)
                     != DiskLayout.Location.addr(Lit(loc#0))))
             && (forall id#1: int :: 
              { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)]): DatatypeType } 
                { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)] } 
              LitInt(0) <= id#1
                   && id#1 < 18446744073709551616
                   && Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(id#1)]
                 ==> DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType))
                   != DiskLayout.Location.addr(Lit(loc#0)))));

// function declaration for BlockCache._default.assignRefToLocation
function BlockCache.__default.assignRefToLocation(indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType)
   : DatatypeType;

function BlockCache.__default.assignRefToLocation#canCall(indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.assignRefToLocation
axiom true
   ==> (forall indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    { BlockCache.__default.assignRefToLocation(indirectionTable#0, ref#0, loc#0) } 
    BlockCache.__default.assignRefToLocation#canCall(indirectionTable#0, ref#0, loc#0)
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location()))
       ==> $Is(BlockCache.__default.assignRefToLocation(indirectionTable#0, ref#0, loc#0), 
        Tclass.SectorType.IndirectionTable()));

function BlockCache.__default.assignRefToLocation#requires(DatatypeType, int, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.assignRefToLocation
axiom (forall indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
  { BlockCache.__default.assignRefToLocation#requires(indirectionTable#0, ref#0, loc#0) } 
  $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
       && $Is(loc#0, Tclass.DiskLayout.Location())
     ==> BlockCache.__default.assignRefToLocation#requires(indirectionTable#0, ref#0, loc#0)
       == true);

// definition axiom for BlockCache.__default.assignRefToLocation(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    { BlockCache.__default.assignRefToLocation(indirectionTable#0, ref#0, loc#0) } 
    BlockCache.__default.assignRefToLocation#canCall(indirectionTable#0, ref#0, loc#0)
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location()))
       ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
         && (Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && (Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(ref#0)]
             && !Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && (!(Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(ref#0)]
             && !Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)])
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
         && BlockCache.__default.assignRefToLocation(indirectionTable#0, ref#0, loc#0)
           == #SectorType.IndirectionTable.IndirectionTable((if Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0))[$Box(ref#0)]
                 && !Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
               then Map#Build(SectorType.IndirectionTable.locs(indirectionTable#0), $Box(ref#0), $Box(loc#0))
               else SectorType.IndirectionTable.locs(indirectionTable#0)), 
            SectorType.IndirectionTable.graph(indirectionTable#0)));

// definition axiom for BlockCache.__default.assignRefToLocation for decreasing-related literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.assignRefToLocation(Lit(indirectionTable#0), ref#0, Lit(loc#0)) } 
    BlockCache.__default.assignRefToLocation#canCall(Lit(indirectionTable#0), ref#0, Lit(loc#0))
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location()))
       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && (Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
             && !Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (!(Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
             && !Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#0)])
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && BlockCache.__default.assignRefToLocation(Lit(indirectionTable#0), ref#0, Lit(loc#0))
           == #SectorType.IndirectionTable.IndirectionTable((if Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
                 && !Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#0)]
               then Map#Build(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))), 
                $Box(ref#0), 
                $Box(Lit(loc#0)))
               else SectorType.IndirectionTable.locs(Lit(indirectionTable#0))), 
            Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))));

// definition axiom for BlockCache.__default.assignRefToLocation for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.assignRefToLocation(Lit(indirectionTable#0), LitInt(ref#0), Lit(loc#0)) } 
    BlockCache.__default.assignRefToLocation#canCall(Lit(indirectionTable#0), LitInt(ref#0), Lit(loc#0))
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location()))
       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && (Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
             && !Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && (!(Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
             && !Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#0)])
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && BlockCache.__default.assignRefToLocation(Lit(indirectionTable#0), LitInt(ref#0), Lit(loc#0))
           == #SectorType.IndirectionTable.IndirectionTable((if Map#Domain(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))[$Box(ref#0)]
                 && !Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#0)]
               then Map#Build(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))), 
                $Box(LitInt(ref#0)), 
                $Box(Lit(loc#0)))
               else SectorType.IndirectionTable.locs(Lit(indirectionTable#0))), 
            Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))));

// function declaration for BlockCache._default.OutstandingBlockReadsDoesNotHaveRef
function BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(outstandingBlockReads#0: Map Box Box, ref#0: int) : bool;

function BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(outstandingBlockReads#0: Map Box Box, ref#0: int) : bool;

// consequence axiom for BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box, ref#0: int :: 
    { BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(outstandingBlockReads#0, ref#0) } 
    BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(outstandingBlockReads#0, ref#0)
         || ($Is(outstandingBlockReads#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#requires(Map Box Box, int) : bool;

// #requires axiom for BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef
axiom (forall outstandingBlockReads#0: Map Box Box, ref#0: int :: 
  { BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#requires(outstandingBlockReads#0, ref#0) } 
  $Is(outstandingBlockReads#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#requires(outstandingBlockReads#0, ref#0)
       == true);

// definition axiom for BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(revealed)
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box, ref#0: int :: 
    { BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(outstandingBlockReads#0, ref#0) } 
    BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(outstandingBlockReads#0, ref#0)
         || ($Is(outstandingBlockReads#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (forall reqId#0: int :: 
          { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#0)]): DatatypeType } 
            { Map#Domain(outstandingBlockReads#0)[$Box(reqId#0)] } 
          LitInt(0) <= reqId#0 && reqId#0 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockReads#0)[$Box(reqId#0)]
             ==> BlockCache.OutstandingRead.OutstandingRead_q($Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#0)]): DatatypeType))
         && BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(outstandingBlockReads#0, ref#0)
           == (forall reqId#0: int :: 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#0)]): DatatypeType } 
              { Map#Domain(outstandingBlockReads#0)[$Box(reqId#0)] } 
            LitInt(0) <= reqId#0
                 && reqId#0 < 18446744073709551616
                 && Map#Domain(outstandingBlockReads#0)[$Box(reqId#0)]
               ==> BlockCache.OutstandingRead.ref($Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#0)]): DatatypeType)
                 != ref#0));

// definition axiom for BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef for decreasing-related literals(revealed)
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box, ref#0: int :: 
    {:weight 3} { BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(Lit(outstandingBlockReads#0), ref#0) } 
    BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(Lit(outstandingBlockReads#0), ref#0)
         || ($Is(outstandingBlockReads#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (forall reqId#1: int :: 
          { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#1)]): DatatypeType } 
            { Map#Domain(outstandingBlockReads#0)[$Box(reqId#1)] } 
          LitInt(0) <= reqId#1 && reqId#1 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockReads#0)[$Box(reqId#1)]
             ==> BlockCache.OutstandingRead.OutstandingRead_q($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(reqId#1)]): DatatypeType))
         && BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(Lit(outstandingBlockReads#0), ref#0)
           == (forall reqId#1: int :: 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#1)]): DatatypeType } 
              { Map#Domain(outstandingBlockReads#0)[$Box(reqId#1)] } 
            LitInt(0) <= reqId#1
                 && reqId#1 < 18446744073709551616
                 && Map#Domain(outstandingBlockReads#0)[$Box(reqId#1)]
               ==> BlockCache.OutstandingRead.ref($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(reqId#1)]): DatatypeType)
                 != ref#0));

// definition axiom for BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef for all literals(revealed)
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box, ref#0: int :: 
    {:weight 3} { BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(Lit(outstandingBlockReads#0), LitInt(ref#0)) } 
    BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(Lit(outstandingBlockReads#0), LitInt(ref#0))
         || ($Is(outstandingBlockReads#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (forall reqId#2: int :: 
          { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#2)]): DatatypeType } 
            { Map#Domain(outstandingBlockReads#0)[$Box(reqId#2)] } 
          LitInt(0) <= reqId#2 && reqId#2 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockReads#0)[$Box(reqId#2)]
             ==> BlockCache.OutstandingRead.OutstandingRead_q($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(reqId#2)]): DatatypeType))
         && BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(Lit(outstandingBlockReads#0), LitInt(ref#0))
           == (forall reqId#2: int :: 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(reqId#2)]): DatatypeType } 
              { Map#Domain(outstandingBlockReads#0)[$Box(reqId#2)] } 
            LitInt(0) <= reqId#2
                 && reqId#2 < 18446744073709551616
                 && Map#Domain(outstandingBlockReads#0)[$Box(reqId#2)]
               ==> BlockCache.OutstandingRead.ref($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(reqId#2)]): DatatypeType)
                 != ref#0));

// function declaration for BlockCache._default.WriteBackNodeReq
function BlockCache.__default.WriteBackNodeReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

function BlockCache.__default.WriteBackNodeReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

// consequence axiom for BlockCache.__default.WriteBackNodeReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.WriteBackNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.WriteBackNodeReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function BlockCache.__default.WriteBackNodeReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for BlockCache.__default.WriteBackNodeReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int :: 
  { BlockCache.__default.WriteBackNodeReq#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.WriteBackNodeReq#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
       == true);

// definition axiom for BlockCache.__default.WriteBackNodeReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.WriteBackNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.WriteBackNodeReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && DiskLayout.__default.ValidNodeLocation#canCall(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
         && (BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && DiskLayout.__default.ValidNodeLocation#canCall(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
             && DiskLayout.__default.ValidNodeLocation(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
           ==> $IsA#PivotBetreeGraph.Node(BlockDisk.ReqWriteNode.node(BlockDisk.DiskOp.reqWriteNode(dop#0)))
             && $IsA#PivotBetreeGraph.Node($Unbox(Map#Elements(BlockCache.Variables.cache(s#0))[$Box(ref#0)]): DatatypeType)
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0)))
         && (BlockCache.Variables.Ready_q(s'#0)
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0)))
         && (Options.Option.None_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockCache.__default.ValidAllocation#canCall(s#0, BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
         && (BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockCache.__default.ValidAllocation#canCall(s#0, BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
             && BlockCache.__default.ValidAllocation(s#0, BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.__default.assignRefToLocation(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
                ref#0, 
                BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockCache.__default.assignRefToLocation#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
              ref#0, 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
         && ($IsA#SectorType.IndirectionTable(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.__default.assignRefToLocation(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
                ref#0, 
                BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockCache.__default.assignRefToLocation#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
              ref#0, 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(s'#0), 
              BlockCache.__default.assignRefToLocation(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
                ref#0, 
                BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0))
             && BlockCache.__default.assignRefToLocation#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType, 
              ref#0, 
              BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
         && (Map#Equal(BlockCache.Variables.cache(s'#0), BlockCache.Variables.cache(s#0))
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(BlockDisk.DiskOp.reqWriteNode(dop#0)))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
            BlockCache.Variables.outstandingBlockReads(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0), 
              BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s#0)))
         && BlockCache.__default.WriteBackNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.ReqWriteNodeOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
             && DiskLayout.__default.ValidNodeLocation(BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
             && PivotBetreeGraph.Node#Equal(BlockDisk.ReqWriteNode.node(BlockDisk.DiskOp.reqWriteNode(dop#0)), 
              $Unbox(Map#Elements(BlockCache.Variables.cache(s#0))[$Box(ref#0)]): DatatypeType)
             && BlockCache.Variables.Ready_q(s'#0)
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
             && Options.Option.None_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && BlockCache.__default.ValidAllocation(s#0, BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(s'#0), 
              BlockCache.__default.assignRefToLocation(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
                ref#0, 
                BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
                #Options.Option.Some($Box(BlockCache.__default.assignRefToLocation($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType, 
                      ref#0, 
                      BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0)))))))
             && (Options.Option.None_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> Options.Option.None_q(BlockCache.Variables.frozenIndirectionTable(s'#0)))
             && Map#Equal(BlockCache.Variables.cache(s'#0), BlockCache.Variables.cache(s#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(s'#0), 
              Map#Build(BlockCache.Variables.outstandingBlockWrites(s#0), 
                $Box(BlockDisk.DiskOp.id(dop#0)), 
                $Box(#BlockCache.OutstandingWrite.OutstandingWrite(ref#0, BlockDisk.ReqWriteNode.loc(BlockDisk.DiskOp.reqWriteNode(dop#0))))))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
              BlockCache.Variables.outstandingBlockReads(s#0))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0), 
              BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(s'#0), 
              BlockCache.Variables.persistentIndirectionTableLoc(s#0))));

// definition axiom for BlockCache.__default.WriteBackNodeReq for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.WriteBackNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0) } 
    BlockCache.__default.WriteBackNodeReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && DiskLayout.__default.ValidNodeLocation#canCall(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && (BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && DiskLayout.__default.ValidNodeLocation#canCall(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && Lit(DiskLayout.__default.ValidNodeLocation(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
           ==> $IsA#PivotBetreeGraph.Node(Lit(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && $IsA#PivotBetreeGraph.Node($Unbox(Map#Elements(Lit(BlockCache.Variables.cache(Lit(s#0))))[$Box(ref#0)]): DatatypeType)
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))
         && (Lit(BlockCache.Variables.Ready_q(Lit(s'#0)))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && (Lit(Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.ValidAllocation#canCall(Lit(s#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && (BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.ValidAllocation#canCall(Lit(s#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && Lit(BlockCache.__default.ValidAllocation(Lit(s#0), 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                ref#0, 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.assignRefToLocation#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              ref#0, 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                ref#0, 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.assignRefToLocation#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              ref#0, 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)), 
              BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                ref#0, 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.assignRefToLocation#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
              ref#0, 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && (Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), BlockCache.Variables.cache(Lit(s#0)))
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.WriteBackNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && DiskLayout.__default.ValidNodeLocation(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && PivotBetreeGraph.Node#Equal(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))), 
              $Unbox(Map#Elements(Lit(BlockCache.Variables.cache(Lit(s#0))))[$Box(ref#0)]): DatatypeType)
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && BlockCache.__default.ValidAllocation(Lit(s#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)), 
              BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                ref#0, 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
                #Options.Option.Some($Box(BlockCache.__default.assignRefToLocation(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
                      ref#0, 
                      Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))))))
             && (Options.Option.None_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> Options.Option.None_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)))))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), BlockCache.Variables.cache(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              Map#Build(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))), 
                $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                $Box(#BlockCache.OutstandingWrite.OutstandingWrite(ref#0, 
                    Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// definition axiom for BlockCache.__default.WriteBackNodeReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.WriteBackNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0)) } 
    BlockCache.__default.WriteBackNodeReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && DiskLayout.__default.ValidNodeLocation#canCall(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && (BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && DiskLayout.__default.ValidNodeLocation#canCall(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && Lit(DiskLayout.__default.ValidNodeLocation(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
           ==> $IsA#PivotBetreeGraph.Node(Lit(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && $IsA#PivotBetreeGraph.Node($Unbox(Map#Elements(Lit(BlockCache.Variables.cache(Lit(s#0))))[$Box(LitInt(ref#0))]): DatatypeType)
             && BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))
         && (Lit(BlockCache.Variables.Ready_q(Lit(s'#0)))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && (Lit(Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.ValidAllocation#canCall(Lit(s#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && (BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.ValidAllocation#canCall(Lit(s#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && Lit(BlockCache.__default.ValidAllocation(Lit(s#0), 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                  LitInt(ref#0), 
                  Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.assignRefToLocation#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              LitInt(ref#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                  LitInt(ref#0), 
                  Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.assignRefToLocation#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              LitInt(ref#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)), 
              BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                LitInt(ref#0), 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && 
            BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))
             && BlockCache.__default.assignRefToLocation#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
              LitInt(ref#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
         && (Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), BlockCache.Variables.cache(Lit(s#0)))
           ==> BlockDisk.ReqWriteNode.ReqWriteNode_q(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.WriteBackNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.ReqWriteNodeOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && DiskLayout.__default.ValidNodeLocation(Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && PivotBetreeGraph.Node#Equal(BlockDisk.ReqWriteNode.node(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))), 
              $Unbox(Map#Elements(Lit(BlockCache.Variables.cache(Lit(s#0))))[$Box(LitInt(ref#0))]): DatatypeType)
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && BlockCache.__default.ValidAllocation(Lit(s#0), 
              Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)), 
              BlockCache.__default.assignRefToLocation(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                LitInt(ref#0), 
                Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
                #Options.Option.Some($Box(Lit(BlockCache.__default.assignRefToLocation(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
                        LitInt(ref#0), 
                        Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0)))))))))))
             && (Options.Option.None_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> Options.Option.None_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)))))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), BlockCache.Variables.cache(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              Map#Build(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))), 
                $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                $Box(Lit(#BlockCache.OutstandingWrite.OutstandingWrite(LitInt(ref#0), 
                      Lit(BlockDisk.ReqWriteNode.loc(Lit(BlockDisk.DiskOp.reqWriteNode(Lit(dop#0))))))))))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// function declaration for BlockCache._default.WriteBackNodeResp
function BlockCache.__default.WriteBackNodeResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.WriteBackNodeResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.WriteBackNodeResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.WriteBackNodeResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.WriteBackNodeResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.WriteBackNodeResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.WriteBackNodeResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.WriteBackNodeResp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.WriteBackNodeResp#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for BlockCache.__default.WriteBackNodeResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.WriteBackNodeResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.WriteBackNodeResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingBlockWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.BlockCache.OutstandingWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      BlockCache.Variables.outstandingBlockWrites(s#0), 
                      $Box(BlockDisk.DiskOp.id(dop#0))); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                    dt_update#outstandingBlockWrites#0#0, 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                    BlockCache.Variables.cache(dt_update_tmp#0#0)))))
             && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.BlockCache.OutstandingWrite(), 
              BlockCache.Variables.outstandingBlockWrites(s#0), 
              $Box(BlockDisk.DiskOp.id(dop#0))))
         && BlockCache.__default.WriteBackNodeResp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingBlockWrites#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.BlockCache.OutstandingWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      BlockCache.Variables.outstandingBlockWrites(s#0), 
                      $Box(BlockDisk.DiskOp.id(dop#0))); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                    dt_update#outstandingBlockWrites#0#0, 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                    BlockCache.Variables.cache(dt_update_tmp#0#0)))))));

// definition axiom for BlockCache.__default.WriteBackNodeResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.WriteBackNodeResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.WriteBackNodeResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingBlockWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.BlockCache.OutstandingWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                    dt_update#outstandingBlockWrites#0#1, 
                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.cache(dt_update_tmp#0#1))))))
             && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.BlockCache.OutstandingWrite(), 
              Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))), 
              $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))))
         && BlockCache.__default.WriteBackNodeResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingBlockWrites#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.BlockCache.OutstandingWrite(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                    dt_update#outstandingBlockWrites#0#1, 
                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.cache(dt_update_tmp#0#1))))))));

// function declaration for BlockCache._default.WriteBackIndirectionTableReq
function BlockCache.__default.WriteBackIndirectionTableReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.WriteBackIndirectionTableReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.WriteBackIndirectionTableReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.WriteBackIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.WriteBackIndirectionTableReq#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.WriteBackIndirectionTableReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.WriteBackIndirectionTableReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.WriteBackIndirectionTableReq#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.WriteBackIndirectionTableReq#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for BlockCache.__default.WriteBackIndirectionTableReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.WriteBackIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.WriteBackIndirectionTableReq#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
             && (var loc#0 := BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)); 
              DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#0)
                 && (DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
                   ==> $IsA#SectorType.IndirectionTable(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))
                     && $IsA#SectorType.IndirectionTable($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                     && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))
                 && ($IsA#SectorType.IndirectionTable(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)))
                     && $IsA#SectorType.IndirectionTable($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                     && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0))
                     && SectorType.IndirectionTable#Equal(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)), 
                      $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                   ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                     && SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
                 && (Options.Option.None_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
                   ==> DiskLayout.__default.overlap#canCall(loc#0, BlockCache.Variables.persistentIndirectionTableLoc(s#0)))
                 && (DiskLayout.__default.overlap#canCall(loc#0, BlockCache.Variables.persistentIndirectionTableLoc(s#0))
                     && !DiskLayout.__default.overlap(loc#0, BlockCache.Variables.persistentIndirectionTableLoc(s#0))
                   ==> $IsA#BlockCache.Variables(s'#0)
                     && $IsA#BlockCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#outstandingIndirectionTableWrite#0#0 := #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))); 
                              #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                                dt_update#outstandingIndirectionTableWrite#0#0, 
                                BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                                BlockCache.Variables.cache(dt_update_tmp#0#0)))); 
                        (var dt_update#frozenIndirectionTableLoc#0#0 := #Options.Option.Some($Box(loc#0)); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#0), 
                            dt_update#frozenIndirectionTableLoc#0#0, 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#0), 
                            BlockCache.Variables.cache(dt_update_tmp#1#0))))))))
         && BlockCache.__default.WriteBackIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
             && (var loc#0 := BlockDisk.ReqWriteIndirectionTable.loc(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)); 
              DiskLayout.__default.ValidIndirectionTableLocation(loc#0)
                 && SectorType.IndirectionTable#Equal(BlockDisk.ReqWriteIndirectionTable.indirectionTable(BlockDisk.DiskOp.reqWriteIndirectionTable(dop#0)), 
                  $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && Set#Subset(Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)), 
                  Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)))
                 && Map#Equal(BlockCache.Variables.outstandingBlockWrites(s#0), Map#Empty(): Map Box Box)
                 && Options.Option.None_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
                 && !DiskLayout.__default.overlap(loc#0, BlockCache.Variables.persistentIndirectionTableLoc(s#0))
                 && BlockCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#outstandingIndirectionTableWrite#0#0 := #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                            BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                            dt_update#outstandingIndirectionTableWrite#0#0, 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                            BlockCache.Variables.cache(dt_update_tmp#0#0)))); 
                    (var dt_update#frozenIndirectionTableLoc#0#0 := #Options.Option.Some($Box(loc#0)); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                        BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#0), 
                        dt_update#frozenIndirectionTableLoc#0#0, 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#0), 
                        BlockCache.Variables.cache(dt_update_tmp#1#0))))))));

// definition axiom for BlockCache.__default.WriteBackIndirectionTableReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.WriteBackIndirectionTableReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.WriteBackIndirectionTableReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
             && (var loc#1 := Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))); 
              DiskLayout.__default.ValidIndirectionTableLocation#canCall(loc#1)
                 && (DiskLayout.__default.ValidIndirectionTableLocation(loc#1)
                   ==> $IsA#SectorType.IndirectionTable(Lit(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))
                     && $IsA#SectorType.IndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                     && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0)))))
                 && ($IsA#SectorType.IndirectionTable(Lit(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))))
                     && $IsA#SectorType.IndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                     && BlockDisk.ReqWriteIndirectionTable.ReqWriteIndirectionTable_q(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))
                     && SectorType.IndirectionTable#Equal(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0)))), 
                      $Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                     && SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
                 && (Lit(Options.Option.None_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
                   ==> DiskLayout.__default.overlap#canCall(loc#1, Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
                 && (DiskLayout.__default.overlap#canCall(loc#1, Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0))))
                     && !DiskLayout.__default.overlap(loc#1, Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0))))
                   ==> $IsA#BlockCache.Variables(Lit(s'#0))
                     && $IsA#BlockCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#outstandingIndirectionTableWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))); 
                              Lit(#BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                                  dt_update#outstandingIndirectionTableWrite#0#1, 
                                  Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))); 
                        (var dt_update#frozenIndirectionTableLoc#0#1 := #Options.Option.Some($Box(loc#1)); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#1), 
                            dt_update#frozenIndirectionTableLoc#0#1, 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#1), 
                            BlockCache.Variables.cache(dt_update_tmp#1#1))))))))
         && BlockCache.__default.WriteBackIndirectionTableReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.ReqWriteIndirectionTableOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && (var loc#1 := Lit(BlockDisk.ReqWriteIndirectionTable.loc(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0))))); 
              DiskLayout.__default.ValidIndirectionTableLocation(loc#1)
                 && SectorType.IndirectionTable#Equal(BlockDisk.ReqWriteIndirectionTable.indirectionTable(Lit(BlockDisk.DiskOp.reqWriteIndirectionTable(Lit(dop#0)))), 
                  $Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)
                 && Set#Subset(Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))), 
                  Map#Domain(Lit(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))))
                 && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)), Map#Empty(): Map Box Box)
                 && Options.Option.None_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
                 && !Lit(DiskLayout.__default.overlap(loc#1, Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
                 && BlockCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#outstandingIndirectionTableWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))); 
                          Lit(#BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                              Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                              Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                              Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                              Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                              dt_update#outstandingIndirectionTableWrite#0#1, 
                              Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                              Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                              Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))); 
                    (var dt_update#frozenIndirectionTableLoc#0#1 := Lit(#Options.Option.Some($Box(loc#1))); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                        BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#1), 
                        dt_update#frozenIndirectionTableLoc#0#1, 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#1), 
                        BlockCache.Variables.cache(dt_update_tmp#1#1))))))));

// function declaration for BlockCache._default.WriteBackIndirectionTableResp
function BlockCache.__default.WriteBackIndirectionTableResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.WriteBackIndirectionTableResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.WriteBackIndirectionTableResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.WriteBackIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.WriteBackIndirectionTableResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.WriteBackIndirectionTableResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.WriteBackIndirectionTableResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.WriteBackIndirectionTableResp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.WriteBackIndirectionTableResp#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for BlockCache.__default.WriteBackIndirectionTableResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.WriteBackIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.WriteBackIndirectionTableResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (ViewOp.VOp.SendFrozenLocOp_q(vop#0)
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
         && (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s#0), 
              #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))))
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingIndirectionTableWrite#0#0 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    dt_update#outstandingIndirectionTableWrite#0#0, 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                    BlockCache.Variables.cache(dt_update_tmp#0#0))))))
         && BlockCache.__default.WriteBackIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            BlockCache.Variables.Ready_q(s#0)
             && ViewOp.VOp.SendFrozenLocOp_q(vop#0)
             && Options.Option#Equal(#Options.Option.Some($Box(ViewOp.VOp.loc(vop#0))), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s#0), 
              #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingIndirectionTableWrite#0#0 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    dt_update#outstandingIndirectionTableWrite#0#0, 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                    BlockCache.Variables.cache(dt_update_tmp#0#0)))))));

// definition axiom for BlockCache.__default.WriteBackIndirectionTableResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.WriteBackIndirectionTableResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.WriteBackIndirectionTableResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(ViewOp.VOp.SendFrozenLocOp_q(Lit(vop#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && (Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)), 
              #Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))))
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingIndirectionTableWrite#0#1 := Lit(#Options.Option.None()); 
                  Lit(#BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                      dt_update#outstandingIndirectionTableWrite#0#1, 
                      Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.cache(dt_update_tmp#0#1))))))))
         && BlockCache.__default.WriteBackIndirectionTableResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            BlockCache.Variables.Ready_q(Lit(s#0))
             && ViewOp.VOp.SendFrozenLocOp_q(Lit(vop#0))
             && Options.Option#Equal(#Options.Option.Some($Box(Lit(ViewOp.VOp.loc(Lit(vop#0))))), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)), 
              #Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingIndirectionTableWrite#0#1 := Lit(#Options.Option.None()); 
                  Lit(#BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                      dt_update#outstandingIndirectionTableWrite#0#1, 
                      Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                      Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))))));

// function declaration for BlockCache._default.NoPredecessors
function BlockCache.__default.NoPredecessors(graph#0: Map Box Box, ref#0: int) : bool;

function BlockCache.__default.NoPredecessors#canCall(graph#0: Map Box Box, ref#0: int) : bool;

// consequence axiom for BlockCache.__default.NoPredecessors
axiom true
   ==> (forall graph#0: Map Box Box, ref#0: int :: 
    { BlockCache.__default.NoPredecessors(graph#0, ref#0) } 
    BlockCache.__default.NoPredecessors#canCall(graph#0, ref#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function BlockCache.__default.NoPredecessors#requires(Map Box Box, int) : bool;

// #requires axiom for BlockCache.__default.NoPredecessors
axiom (forall graph#0: Map Box Box, ref#0: int :: 
  { BlockCache.__default.NoPredecessors#requires(graph#0, ref#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.NoPredecessors#requires(graph#0, ref#0) == true);

// definition axiom for BlockCache.__default.NoPredecessors(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, ref#0: int :: 
    { BlockCache.__default.NoPredecessors(graph#0, ref#0) } 
    BlockCache.__default.NoPredecessors#canCall(graph#0, ref#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> BlockCache.__default.NoPredecessors(graph#0, ref#0)
         == (forall r#0: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(r#0)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(r#0)] } 
          LitInt(0) <= r#0 && r#0 < 18446744073709551616 && Map#Domain(graph#0)[$Box(r#0)]
             ==> !Seq#Contains($Unbox(Map#Elements(graph#0)[$Box(r#0)]): Seq Box, $Box(ref#0))));

// definition axiom for BlockCache.__default.NoPredecessors for decreasing-related literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, ref#0: int :: 
    {:weight 3} { BlockCache.__default.NoPredecessors(Lit(graph#0), ref#0) } 
    BlockCache.__default.NoPredecessors#canCall(Lit(graph#0), ref#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> BlockCache.__default.NoPredecessors(Lit(graph#0), ref#0)
         == (forall r#1: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(r#1)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(r#1)] } 
          LitInt(0) <= r#1 && r#1 < 18446744073709551616 && Map#Domain(graph#0)[$Box(r#1)]
             ==> !Seq#Contains($Unbox(Map#Elements(Lit(graph#0))[$Box(r#1)]): Seq Box, $Box(ref#0))));

// definition axiom for BlockCache.__default.NoPredecessors for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, ref#0: int :: 
    {:weight 3} { BlockCache.__default.NoPredecessors(Lit(graph#0), LitInt(ref#0)) } 
    BlockCache.__default.NoPredecessors#canCall(Lit(graph#0), LitInt(ref#0))
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> BlockCache.__default.NoPredecessors(Lit(graph#0), LitInt(ref#0))
         == (forall r#2: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(r#2)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(r#2)] } 
          LitInt(0) <= r#2 && r#2 < 18446744073709551616 && Map#Domain(graph#0)[$Box(r#2)]
             ==> !Seq#Contains($Unbox(Map#Elements(Lit(graph#0))[$Box(r#2)]): Seq Box, $Box(ref#0))));

// function declaration for BlockCache._default.Unalloc
function BlockCache.__default.Unalloc(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

function BlockCache.__default.Unalloc#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

// consequence axiom for BlockCache.__default.Unalloc
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.Unalloc(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.Unalloc#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function BlockCache.__default.Unalloc#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for BlockCache.__default.Unalloc
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int :: 
  { BlockCache.__default.Unalloc#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.Unalloc#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
       == true);

// definition axiom for BlockCache.__default.Unalloc(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.Unalloc(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.Unalloc#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (BlockCache.Variables.Ready_q(s#0)
           ==> BlockCache.__default.IsAllocated#canCall(s#0, ref#0))
         && (BlockCache.__default.IsAllocated#canCall(s#0, ref#0)
             && BlockCache.__default.IsAllocated(s#0, ref#0)
           ==> PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.__default.Root#canCall()
             && ref#0 != PivotBetreeGraph.__default.Root()
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.NoPredecessors#canCall(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              ref#0))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.NoPredecessors#canCall(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              ref#0)
             && BlockCache.__default.NoPredecessors(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              ref#0)
           ==> (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && (SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)))
         && (BlockCache.Variables.Ready_q(s'#0)
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0)))
         && ($IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
            Tclass.PivotBetreeGraph.Node(), 
            BlockCache.Variables.cache(s#0), 
            Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              BlockCache.Variables.cache(s#0), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(BlockCache.Variables.cache(s'#0), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.PivotBetreeGraph.Node(), 
                StartFuel_Maps._default.MapRemove, 
                BlockCache.Variables.cache(s#0), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              TSeq(Tclass.NativeTypes.uint64()), 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              TSeq(Tclass.NativeTypes.uint64()), 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove, 
                SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
         && (Map#Equal(BlockCache.Variables.outstandingBlockWrites(s'#0), 
            BlockCache.Variables.outstandingBlockWrites(s#0))
           ==> BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(BlockCache.Variables.outstandingBlockReads(s#0), ref#0))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
            BlockCache.Variables.outstandingBlockReads(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
              BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s#0)))
         && BlockCache.__default.Unalloc(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
           == (
            ViewOp.VOp.AdvanceOp_q(vop#0)
             && UI.Op.NoOp_q(ViewOp.VOp.uiop(vop#0))
             && BlockDisk.DiskOp.NoDiskOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && BlockCache.__default.IsAllocated(s#0, ref#0)
             && ref#0 != PivotBetreeGraph.__default.Root()
             && BlockCache.__default.NoPredecessors(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              ref#0)
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)])
             && BlockCache.Variables.Ready_q(s'#0)
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
             && Map#Equal(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && Map#Equal(BlockCache.Variables.cache(s'#0), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.PivotBetreeGraph.Node(), 
                StartFuel_Maps._default.MapRemove, 
                BlockCache.Variables.cache(s#0), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && Map#Equal(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove, 
                SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0), 
              BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(s'#0), 
              BlockCache.Variables.outstandingBlockWrites(s#0))
             && BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(BlockCache.Variables.outstandingBlockReads(s#0), ref#0)
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
              BlockCache.Variables.outstandingBlockReads(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
              BlockCache.Variables.frozenIndirectionTable(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(s'#0), 
              BlockCache.Variables.persistentIndirectionTableLoc(s#0))));

// definition axiom for BlockCache.__default.Unalloc for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.Unalloc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0) } 
    BlockCache.__default.Unalloc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> BlockCache.__default.IsAllocated#canCall(Lit(s#0), ref#0))
         && (BlockCache.__default.IsAllocated#canCall(Lit(s#0), ref#0)
             && BlockCache.__default.IsAllocated(Lit(s#0), ref#0)
           ==> PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.__default.Root#canCall()
             && ref#0 != PivotBetreeGraph.__default.Root()
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.NoPredecessors#canCall(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              ref#0))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.NoPredecessors#canCall(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              ref#0)
             && BlockCache.__default.NoPredecessors(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              ref#0)
           ==> (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && (Lit(BlockCache.Variables.Ready_q(Lit(s'#0)))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
            Tclass.PivotBetreeGraph.Node(), 
            Lit(BlockCache.Variables.cache(Lit(s#0))), 
            Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.PivotBetreeGraph.Node(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(BlockCache.Variables.cache(Lit(s#0))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              TSeq(Tclass.NativeTypes.uint64()), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              TSeq(Tclass.NativeTypes.uint64()), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
           ==> BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), ref#0))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Unalloc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
           == (
            ViewOp.VOp.AdvanceOp_q(Lit(vop#0))
             && UI.Op.NoOp_q(Lit(ViewOp.VOp.uiop(Lit(vop#0))))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockCache.__default.IsAllocated(Lit(s#0), ref#0)
             && ref#0 != PivotBetreeGraph.__default.Root()
             && BlockCache.__default.NoPredecessors(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              ref#0)
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.PivotBetreeGraph.Node(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(BlockCache.Variables.cache(Lit(s#0))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
             && BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), ref#0)
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// definition axiom for BlockCache.__default.Unalloc for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.Unalloc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0)) } 
    BlockCache.__default.Unalloc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> BlockCache.__default.IsAllocated#canCall(Lit(s#0), LitInt(ref#0)))
         && (BlockCache.__default.IsAllocated#canCall(Lit(s#0), LitInt(ref#0))
             && Lit(BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0)))
           ==> PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.__default.Root#canCall()
             && Lit(ref#0 != PivotBetreeGraph.__default.Root())
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.NoPredecessors#canCall(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              LitInt(ref#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.NoPredecessors#canCall(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              LitInt(ref#0))
             && Lit(BlockCache.__default.NoPredecessors(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                LitInt(ref#0)))
           ==> (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && (Lit(BlockCache.Variables.Ready_q(Lit(s'#0)))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0)))))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
           ==> Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
            Tclass.PivotBetreeGraph.Node(), 
            Lit(BlockCache.Variables.cache(Lit(s#0))), 
            Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
         && (Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0)))))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.PivotBetreeGraph.Node(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(BlockCache.Variables.cache(Lit(s#0))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              TSeq(Tclass.NativeTypes.uint64()), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              TSeq(Tclass.NativeTypes.uint64()), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0)))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
           ==> BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef#canCall(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), LitInt(ref#0)))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Unalloc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
           == (
            ViewOp.VOp.AdvanceOp_q(Lit(vop#0))
             && UI.Op.NoOp_q(Lit(ViewOp.VOp.uiop(Lit(vop#0))))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0))
             && ref#0 != PivotBetreeGraph.__default.Root()
             && BlockCache.__default.NoPredecessors(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              LitInt(ref#0))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.PivotBetreeGraph.Node(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(BlockCache.Variables.cache(Lit(s#0))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
             && BlockCache.__default.OutstandingBlockReadsDoesNotHaveRef(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), LitInt(ref#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// function declaration for BlockCache._default.PageInNodeReq
function BlockCache.__default.PageInNodeReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

function BlockCache.__default.PageInNodeReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

// consequence axiom for BlockCache.__default.PageInNodeReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.PageInNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.PageInNodeReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function BlockCache.__default.PageInNodeReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for BlockCache.__default.PageInNodeReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int :: 
  { BlockCache.__default.PageInNodeReq#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.PageInNodeReq#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
       == true);

// definition axiom for BlockCache.__default.PageInNodeReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.PageInNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.PageInNodeReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (BlockCache.Variables.Ready_q(s#0)
           ==> BlockCache.__default.IsAllocated#canCall(s#0, ref#0))
         && (BlockCache.__default.IsAllocated#canCall(s#0, ref#0)
             && BlockCache.__default.IsAllocated(s#0, ref#0)
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (!Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
           ==> $IsA#DiskLayout.Location($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType)
             && $IsA#DiskLayout.Location(BlockDisk.DiskOp.loc(dop#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (!Map#Values(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))]
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingBlockReads#0#0 := Map#Build(BlockCache.Variables.outstandingBlockReads(s#0), 
                      $Box(BlockDisk.DiskOp.id(dop#0)), 
                      $Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                    dt_update#outstandingBlockReads#0#0, 
                    BlockCache.Variables.cache(dt_update_tmp#0#0))))))
         && BlockCache.__default.PageInNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.ReqReadNodeOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && BlockCache.__default.IsAllocated(s#0, ref#0)
             && Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
             && !Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
             && DiskLayout.Location#Equal($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType, 
              BlockDisk.DiskOp.loc(dop#0))
             && !Map#Values(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))]
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingBlockReads#0#0 := Map#Build(BlockCache.Variables.outstandingBlockReads(s#0), 
                      $Box(BlockDisk.DiskOp.id(dop#0)), 
                      $Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                    dt_update#outstandingBlockReads#0#0, 
                    BlockCache.Variables.cache(dt_update_tmp#0#0)))))));

// definition axiom for BlockCache.__default.PageInNodeReq for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.PageInNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0) } 
    BlockCache.__default.PageInNodeReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> BlockCache.__default.IsAllocated#canCall(Lit(s#0), ref#0))
         && (BlockCache.__default.IsAllocated#canCall(Lit(s#0), ref#0)
             && BlockCache.__default.IsAllocated(Lit(s#0), ref#0)
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (!Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> $IsA#DiskLayout.Location($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#0)]): DatatypeType)
             && $IsA#DiskLayout.Location(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (!Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))))[$Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))]
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingBlockReads#0#1 := Map#Build(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                    dt_update#outstandingBlockReads#0#1, 
                    Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))))
         && BlockCache.__default.PageInNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockCache.__default.IsAllocated(Lit(s#0), ref#0)
             && Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
             && !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && DiskLayout.Location#Equal($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#0)]): DatatypeType, 
              BlockDisk.DiskOp.loc(Lit(dop#0)))
             && !Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))))[$Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))]
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingBlockReads#0#1 := Map#Build(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(#BlockCache.OutstandingRead.OutstandingRead(ref#0))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                    dt_update#outstandingBlockReads#0#1, 
                    Lit(BlockCache.Variables.cache(dt_update_tmp#0#1))))))));

// definition axiom for BlockCache.__default.PageInNodeReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.PageInNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0)) } 
    BlockCache.__default.PageInNodeReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> BlockCache.__default.IsAllocated#canCall(Lit(s#0), LitInt(ref#0)))
         && (BlockCache.__default.IsAllocated#canCall(Lit(s#0), LitInt(ref#0))
             && Lit(BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (!Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> $IsA#DiskLayout.Location($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(LitInt(ref#0))]): DatatypeType)
             && $IsA#DiskLayout.Location(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (!Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))))[$Box(Lit(#BlockCache.OutstandingRead.OutstandingRead(LitInt(ref#0))))]
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#2 := Lit(s#0); 
                (var dt_update#outstandingBlockReads#0#2 := Map#Build(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(#BlockCache.OutstandingRead.OutstandingRead(LitInt(ref#0))))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#2)), 
                    dt_update#outstandingBlockReads#0#2, 
                    Lit(BlockCache.Variables.cache(dt_update_tmp#0#2)))))))
         && BlockCache.__default.PageInNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.ReqReadNodeOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0))
             && Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
             && !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && DiskLayout.Location#Equal($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(LitInt(ref#0))]): DatatypeType, 
              BlockDisk.DiskOp.loc(Lit(dop#0)))
             && !Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))))[$Box(Lit(#BlockCache.OutstandingRead.OutstandingRead(LitInt(ref#0))))]
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#2 := Lit(s#0); 
                (var dt_update#outstandingBlockReads#0#2 := Map#Build(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                      $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))), 
                      $Box(Lit(#BlockCache.OutstandingRead.OutstandingRead(LitInt(ref#0))))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#2)), 
                    dt_update#outstandingBlockReads#0#2, 
                    Lit(BlockCache.Variables.cache(dt_update_tmp#0#2))))))));

// function declaration for BlockCache._default.PageInNodeResp
function BlockCache.__default.PageInNodeResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.PageInNodeResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.PageInNodeResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.PageInNodeResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.PageInNodeResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.PageInNodeResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.PageInNodeResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.PageInNodeResp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.PageInNodeResp#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for BlockCache.__default.PageInNodeResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.PageInNodeResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.PageInNodeResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Map#Domain(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
           ==> BlockCache.OutstandingRead.OutstandingRead_q($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType)
             && (var ref#0 := BlockCache.OutstandingRead.ref($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType); 
              Options.Option.Some_q(BlockDisk.DiskOp.node(dop#0))
                 ==> (var block#0 := $Unbox(Options.Option.value(BlockDisk.DiskOp.node(dop#0))): DatatypeType; 
                  SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                     && (Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                       ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                         && PivotBetreeGraph.__default.Successors#canCall(block#0))
                     && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                         && PivotBetreeGraph.__default.Successors#canCall(block#0)
                         && ISet#Equal((lambda $y#0: Box :: 
                            $IsBox($y#0, Tclass.NativeTypes.uint64())
                               && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): Seq Box, 
                                $y#0)), 
                          PivotBetreeGraph.__default.Successors(block#0))
                       ==> $IsA#BlockCache.Variables(s'#0)
                         && $IsA#BlockCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#cache#0#0 := Map#Build(BlockCache.Variables.cache(s#0), $Box(ref#0), $Box(block#0)); 
                                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                                    dt_update#cache#0#0))); 
                            (var dt_update#outstandingBlockReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.BlockCache.OutstandingRead(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  BlockCache.Variables.outstandingBlockReads(s#0), 
                                  $Box(BlockDisk.DiskOp.id(dop#0))); 
                              #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                                BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                                BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                                BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#0), 
                                BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#0), 
                                BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                                BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                                dt_update#outstandingBlockReads#0#0, 
                                BlockCache.Variables.cache(dt_update_tmp#1#0)))))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.BlockCache.OutstandingRead(), 
                          BlockCache.Variables.outstandingBlockReads(s#0), 
                          $Box(BlockDisk.DiskOp.id(dop#0)))))))
         && BlockCache.__default.PageInNodeResp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.RespReadNodeOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && Map#Domain(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]
             && (var ref#0 := BlockCache.OutstandingRead.ref($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockReads(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))]): DatatypeType); 
              !Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
                 && Options.Option.Some_q(BlockDisk.DiskOp.node(dop#0))
                 && (var block#0 := $Unbox(Options.Option.value(BlockDisk.DiskOp.node(dop#0))): DatatypeType; 
                  Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                     && ISet#Equal((lambda $y#1: Box :: 
                        $IsBox($y#1, Tclass.NativeTypes.uint64())
                           && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): Seq Box, 
                            $y#1)), 
                      PivotBetreeGraph.__default.Successors(block#0))
                     && BlockCache.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#cache#0#0 := Map#Build(BlockCache.Variables.cache(s#0), $Box(ref#0), $Box(block#0)); 
                              #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                                dt_update#cache#0#0))); 
                        (var dt_update#outstandingBlockReads#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                              Tclass.BlockCache.OutstandingRead(), 
                              StartFuel_Maps._default.MapRemove1, 
                              BlockCache.Variables.outstandingBlockReads(s#0), 
                              $Box(BlockDisk.DiskOp.id(dop#0))); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#0), 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                            dt_update#outstandingBlockReads#0#0, 
                            BlockCache.Variables.cache(dt_update_tmp#1#0)))))))));

// definition axiom for BlockCache.__default.PageInNodeResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.PageInNodeResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.PageInNodeResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Map#Domain(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
           ==> BlockCache.OutstandingRead.OutstandingRead_q($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType)
             && (var ref#1 := BlockCache.OutstandingRead.ref($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType); 
              Lit(Options.Option.Some_q(Lit(BlockDisk.DiskOp.node(Lit(dop#0)))))
                 ==> (var block#1 := Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.node(Lit(dop#0))))): DatatypeType); 
                  SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                     && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#1)]
                       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                         && PivotBetreeGraph.__default.Successors#canCall(block#1))
                     && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                         && PivotBetreeGraph.__default.Successors#canCall(block#1)
                         && ISet#Equal((lambda $y#2: Box :: 
                            $IsBox($y#2, Tclass.NativeTypes.uint64())
                               && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#1)]): Seq Box, 
                                $y#2)), 
                          PivotBetreeGraph.__default.Successors(block#1))
                       ==> $IsA#BlockCache.Variables(Lit(s'#0))
                         && $IsA#BlockCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#cache#0#1 := Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), $Box(ref#1), $Box(block#1)); 
                                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                                    dt_update#cache#0#1))); 
                            (var dt_update#outstandingBlockReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                                  Tclass.BlockCache.OutstandingRead(), 
                                  StartFuel_Maps._default.MapRemove1, 
                                  Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                                  $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))); 
                              #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                                BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                                BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                                BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#1), 
                                BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#1), 
                                BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                                BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                                dt_update#outstandingBlockReads#0#1, 
                                BlockCache.Variables.cache(dt_update_tmp#1#1)))))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.BlockCache.OutstandingRead(), 
                          Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                          $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))))))
         && BlockCache.__default.PageInNodeResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))]
             && (var ref#1 := BlockCache.OutstandingRead.ref($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))))[$Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType); 
              !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#1)]
                 && Options.Option.Some_q(Lit(BlockDisk.DiskOp.node(Lit(dop#0))))
                 && (var block#1 := Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.node(Lit(dop#0))))): DatatypeType); 
                  Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#1)]
                     && ISet#Equal((lambda $y#3: Box :: 
                        $IsBox($y#3, Tclass.NativeTypes.uint64())
                           && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#1)]): Seq Box, 
                            $y#3)), 
                      PivotBetreeGraph.__default.Successors(block#1))
                     && BlockCache.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#cache#0#1 := Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), $Box(ref#1), $Box(block#1)); 
                              #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                                Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                                dt_update#cache#0#1))); 
                        (var dt_update#outstandingBlockReads#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                              Tclass.BlockCache.OutstandingRead(), 
                              StartFuel_Maps._default.MapRemove1, 
                              Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))), 
                              $Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#1), 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                            dt_update#outstandingBlockReads#0#1, 
                            BlockCache.Variables.cache(dt_update_tmp#1#1)))))))));

// function declaration for BlockCache._default.PageInIndirectionTableReq
function BlockCache.__default.PageInIndirectionTableReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.PageInIndirectionTableReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.PageInIndirectionTableReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.PageInIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.PageInIndirectionTableReq#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.PageInIndirectionTableReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.PageInIndirectionTableReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.PageInIndirectionTableReq#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.PageInIndirectionTableReq#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for BlockCache.__default.PageInIndirectionTableReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.PageInIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.PageInIndirectionTableReq#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Options.Option.None_q(BlockCache.Variables.indirectionTableRead(s#0))
           ==> $IsA#DiskLayout.Location(BlockDisk.DiskOp.loc(dop#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.indirectionTableLoc(s#0)))
         && ($IsA#DiskLayout.Location(BlockDisk.DiskOp.loc(dop#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.indirectionTableLoc(s#0))
             && DiskLayout.Location#Equal(BlockDisk.DiskOp.loc(dop#0), BlockCache.Variables.indirectionTableLoc(s#0))
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#indirectionTableRead#0#0 := #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))); 
                  #BlockCache.Variables.LoadingIndirectionTable(BlockCache.Variables.indirectionTableLoc(dt_update_tmp#0#0), 
                    dt_update#indirectionTableRead#0#0)))))
         && BlockCache.__default.PageInIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(dop#0)
             && BlockCache.Variables.LoadingIndirectionTable_q(s#0)
             && Options.Option.None_q(BlockCache.Variables.indirectionTableRead(s#0))
             && DiskLayout.Location#Equal(BlockDisk.DiskOp.loc(dop#0), BlockCache.Variables.indirectionTableLoc(s#0))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#indirectionTableRead#0#0 := #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))); 
                  #BlockCache.Variables.LoadingIndirectionTable(BlockCache.Variables.indirectionTableLoc(dt_update_tmp#0#0), 
                    dt_update#indirectionTableRead#0#0))))));

// definition axiom for BlockCache.__default.PageInIndirectionTableReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.PageInIndirectionTableReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.PageInIndirectionTableReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(Options.Option.None_q(Lit(BlockCache.Variables.indirectionTableRead(Lit(s#0)))))
           ==> $IsA#DiskLayout.Location(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s#0)))))
         && ($IsA#DiskLayout.Location(Lit(BlockDisk.DiskOp.loc(Lit(dop#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s#0))))
             && DiskLayout.Location#Equal(BlockDisk.DiskOp.loc(Lit(dop#0)), 
              BlockCache.Variables.indirectionTableLoc(Lit(s#0)))
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#indirectionTableRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))); 
                  Lit(#BlockCache.Variables.LoadingIndirectionTable(Lit(BlockCache.Variables.indirectionTableLoc(dt_update_tmp#0#1)), 
                      dt_update#indirectionTableRead#0#1))))))
         && BlockCache.__default.PageInIndirectionTableReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.ReqReadIndirectionTableOp_q(Lit(dop#0))
             && BlockCache.Variables.LoadingIndirectionTable_q(Lit(s#0))
             && Options.Option.None_q(Lit(BlockCache.Variables.indirectionTableRead(Lit(s#0))))
             && DiskLayout.Location#Equal(BlockDisk.DiskOp.loc(Lit(dop#0)), 
              BlockCache.Variables.indirectionTableLoc(Lit(s#0)))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#indirectionTableRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0)))))); 
                  Lit(#BlockCache.Variables.LoadingIndirectionTable(Lit(BlockCache.Variables.indirectionTableLoc(dt_update_tmp#0#1)), 
                      dt_update#indirectionTableRead#0#1)))))));

// function declaration for BlockCache._default.PageInIndirectionTableResp
function BlockCache.__default.PageInIndirectionTableResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.PageInIndirectionTableResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.PageInIndirectionTableResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.PageInIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.PageInIndirectionTableResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.PageInIndirectionTableResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.PageInIndirectionTableResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.PageInIndirectionTableResp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.PageInIndirectionTableResp#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for BlockCache.__default.PageInIndirectionTableResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.PageInIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.PageInIndirectionTableResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Options.Option.Some_q(BlockDisk.DiskOp.indirectionTable(dop#0))
           ==> BlockCache.__default.WFCompleteIndirectionTable#canCall($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType))
         && (BlockCache.__default.WFCompleteIndirectionTable#canCall($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && BlockCache.__default.WFCompleteIndirectionTable($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
           ==> BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType))
         && (BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
           ==> $IsA#Options.Option(BlockCache.Variables.indirectionTableRead(s#0)))
         && (BlockCache.Variables.Ready_q(s'#0)
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType))
         && ($IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              $Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), #Options.Option.None())
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType))
         && ($IsA#SectorType.IndirectionTable(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(s'#0), 
              $Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
           ==> $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.indirectionTableLoc(s#0)))
         && ($IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.indirectionTableLoc(s#0))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(s'#0), 
              BlockCache.Variables.indirectionTableLoc(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), #Options.Option.None())
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0)))
         && BlockCache.__default.PageInIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0)
             && BlockCache.Variables.LoadingIndirectionTable_q(s#0)
             && Options.Option.Some_q(BlockDisk.DiskOp.indirectionTable(dop#0))
             && BlockCache.__default.WFCompleteIndirectionTable($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap($Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && Options.Option#Equal(BlockCache.Variables.indirectionTableRead(s#0), 
              #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))))
             && BlockCache.Variables.Ready_q(s'#0)
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              $Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), #Options.Option.None())
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(s'#0), 
              $Unbox(Options.Option.value(BlockDisk.DiskOp.indirectionTable(dop#0))): DatatypeType)
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(s'#0), 
              BlockCache.Variables.indirectionTableLoc(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), #Options.Option.None())
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0), 
              #Options.Option.None())
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(s'#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), Map#Empty(): Map Box Box)
             && Map#Equal(BlockCache.Variables.cache(s'#0), Map#Empty(): Map Box Box)));

// definition axiom for BlockCache.__default.PageInIndirectionTableResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.PageInIndirectionTableResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.PageInIndirectionTableResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(Options.Option.Some_q(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0)))))
           ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)))
         && (BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType))
             && Lit(BlockCache.__default.WFCompleteIndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)))
           ==> BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)))
         && (BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType))
             && Lit(BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.indirectionTableRead(Lit(s#0)))))
         && (Lit(BlockCache.Variables.Ready_q(Lit(s'#0)))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              $Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), #Options.Option.None())
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)), 
              $Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s#0)))))
         && ($IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s#0))))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.indirectionTableLoc(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              #Options.Option.None())
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)))))
         && BlockCache.__default.PageInIndirectionTableResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0))
             && BlockCache.Variables.LoadingIndirectionTable_q(Lit(s#0))
             && Options.Option.Some_q(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))
             && BlockCache.__default.WFCompleteIndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType))
             && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(Lit($Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType))
             && Options.Option#Equal(BlockCache.Variables.indirectionTableRead(Lit(s#0)), 
              #Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))))
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              $Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), #Options.Option.None())
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)), 
              $Unbox(Options.Option.value(Lit(BlockDisk.DiskOp.indirectionTable(Lit(dop#0))))): DatatypeType)
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.indirectionTableLoc(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              #Options.Option.None())
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              #Options.Option.None())
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), Map#Empty(): Map Box Box)
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), Map#Empty(): Map Box Box)
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), Map#Empty(): Map Box Box)));

// function declaration for BlockCache._default.ReceiveLoc
function BlockCache.__default.ReceiveLoc(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.ReceiveLoc#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.ReceiveLoc
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.ReceiveLoc(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.ReceiveLoc#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.ReceiveLoc#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.ReceiveLoc
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.ReceiveLoc#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.ReceiveLoc#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for BlockCache.__default.ReceiveLoc(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.ReceiveLoc(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.ReceiveLoc#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (ViewOp.VOp.SendPersistentLocOp_q(vop#0)
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(ViewOp.VOp.loc(vop#0)))
         && (Options.Option.None_q(BlockCache.Variables.indirectionTableRead(s'#0))
           ==> $IsA#DiskLayout.Location(BlockCache.Variables.indirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(ViewOp.VOp.loc(vop#0)))
         && BlockCache.__default.ReceiveLoc(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            BlockDisk.DiskOp.NoDiskOp_q(dop#0)
             && ViewOp.VOp.SendPersistentLocOp_q(vop#0)
             && DiskLayout.__default.ValidIndirectionTableLocation(ViewOp.VOp.loc(vop#0))
             && BlockCache.Variables.Unready_q(s#0)
             && BlockCache.Variables.LoadingIndirectionTable_q(s'#0)
             && Options.Option.None_q(BlockCache.Variables.indirectionTableRead(s'#0))
             && DiskLayout.Location#Equal(BlockCache.Variables.indirectionTableLoc(s'#0), ViewOp.VOp.loc(vop#0))));

// definition axiom for BlockCache.__default.ReceiveLoc for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.ReceiveLoc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.ReceiveLoc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(ViewOp.VOp.SendPersistentLocOp_q(Lit(vop#0)))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(ViewOp.VOp.loc(Lit(vop#0)))))
         && (Lit(Options.Option.None_q(Lit(BlockCache.Variables.indirectionTableRead(Lit(s'#0)))))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(ViewOp.VOp.loc(Lit(vop#0)))))
         && BlockCache.__default.ReceiveLoc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && ViewOp.VOp.SendPersistentLocOp_q(Lit(vop#0))
             && DiskLayout.__default.ValidIndirectionTableLocation(Lit(ViewOp.VOp.loc(Lit(vop#0))))
             && BlockCache.Variables.Unready_q(Lit(s#0))
             && BlockCache.Variables.LoadingIndirectionTable_q(Lit(s'#0))
             && Options.Option.None_q(Lit(BlockCache.Variables.indirectionTableRead(Lit(s'#0))))
             && DiskLayout.Location#Equal(BlockCache.Variables.indirectionTableLoc(Lit(s'#0)), ViewOp.VOp.loc(Lit(vop#0)))));

// function declaration for BlockCache._default.Evict
function BlockCache.__default.Evict(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

function BlockCache.__default.Evict#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int)
   : bool;

// consequence axiom for BlockCache.__default.Evict
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.Evict(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.Evict#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function BlockCache.__default.Evict#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for BlockCache.__default.Evict
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ref#0: int :: 
  { BlockCache.__default.Evict#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> BlockCache.__default.Evict#requires(k#0, s#0, s'#0, dop#0, vop#0, ref#0) == true);

// definition axiom for BlockCache.__default.Evict(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    { BlockCache.__default.Evict(k#0, s#0, s'#0, dop#0, vop#0, ref#0) } 
    BlockCache.__default.Evict#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && (Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                 && (Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && (Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                 && (Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))))
             && (Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                 && !Map#Values(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(#BlockCache.OutstandingWrite.OutstandingWrite(ref#0, 
                    $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType))])
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
             && (Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)))
         && ((Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && (Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> 
              Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)])
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#cache#0#0 := Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      StartFuel_Maps._default.MapRemove, 
                      BlockCache.Variables.cache(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                    dt_update#cache#0#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              BlockCache.Variables.cache(s#0), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && BlockCache.__default.Evict(k#0, s#0, s'#0, dop#0, vop#0, ref#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(vop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && BlockDisk.DiskOp.NoDiskOp_q(dop#0)
             && Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
             && (Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                 && !Map#Values(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(#BlockCache.OutstandingWrite.OutstandingWrite(ref#0, 
                    $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType))])
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> 
              Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)])
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#cache#0#0 := Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      StartFuel_Maps._default.MapRemove, 
                      BlockCache.Variables.cache(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                    dt_update#cache#0#0))))));

// definition axiom for BlockCache.__default.Evict for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.Evict(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0) } 
    BlockCache.__default.Evict#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                 && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                 && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                 && !Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))[$Box(#BlockCache.OutstandingWrite.OutstandingWrite(ref#0, 
                    $Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#0)]): DatatypeType))])
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && ((Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && (Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> 
              Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#cache#0#1 := Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      StartFuel_Maps._default.MapRemove, 
                      Lit(BlockCache.Variables.cache(Lit(s#0))), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                    dt_update#cache#0#1))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && BlockCache.__default.Evict(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#0)
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                 && !Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))[$Box(#BlockCache.OutstandingWrite.OutstandingWrite(ref#0, 
                    $Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#0)]): DatatypeType))])
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> 
              Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#cache#0#1 := Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      StartFuel_Maps._default.MapRemove, 
                      Lit(BlockCache.Variables.cache(Lit(s#0))), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                    dt_update#cache#0#1))))));

// definition axiom for BlockCache.__default.Evict for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ref#0: int :: 
    {:weight 3} { BlockCache.__default.Evict(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0)) } 
    BlockCache.__default.Evict#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> (Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                 && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                 && (Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                 && !Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))[$Box(#BlockCache.OutstandingWrite.OutstandingWrite(LitInt(ref#0), 
                    $Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(LitInt(ref#0))]): DatatypeType))])
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && ((Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && (Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
                   ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> 
              Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#0#2 := Lit(s#0); 
                (var dt_update#cache#0#2 := Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      StartFuel_Maps._default.MapRemove, 
                      Lit(BlockCache.Variables.cache(Lit(s#0))), 
                      Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#2)), 
                    dt_update#cache#0#2))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
         && BlockCache.__default.Evict(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(ref#0))
           == (
            ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
                 && !Lit(Map#Values(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))[$Box(#BlockCache.OutstandingWrite.OutstandingWrite(LitInt(ref#0), 
                    $Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(LitInt(ref#0))]): DatatypeType))])
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> 
              Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#2 := Lit(s#0); 
                (var dt_update#cache#0#2 := Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                      Tclass.PivotBetreeGraph.Node(), 
                      StartFuel_Maps._default.MapRemove, 
                      Lit(BlockCache.Variables.cache(Lit(s#0))), 
                      Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))); 
                  #BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#2)), 
                    Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#2)), 
                    dt_update#cache#0#2))))));

// function declaration for BlockCache._default.Freeze
function BlockCache.__default.Freeze(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.Freeze#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.Freeze
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.Freeze#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.Freeze#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.Freeze
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.Freeze#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.Freeze#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for BlockCache.__default.Freeze(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.Freeze#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Options.Option.None_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#frozenIndirectionTable#0#0 := #Options.Option.Some($Box(BlockCache.Variables.ephemeralIndirectionTable(s#0))); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                        dt_update#frozenIndirectionTable#0#0, 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                        BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                        BlockCache.Variables.cache(dt_update_tmp#0#0)))); 
                (var dt_update#frozenIndirectionTableLoc#0#0 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#0), 
                    dt_update#frozenIndirectionTableLoc#0#0, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#0), 
                    BlockCache.Variables.cache(dt_update_tmp#1#0))))))
         && BlockCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.FreezeOp_q(vop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && BlockDisk.DiskOp.NoDiskOp_q(dop#0)
             && Options.Option.None_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#frozenIndirectionTable#0#0 := #Options.Option.Some($Box(BlockCache.Variables.ephemeralIndirectionTable(s#0))); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#0), 
                        dt_update#frozenIndirectionTable#0#0, 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                        BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                        BlockCache.Variables.cache(dt_update_tmp#0#0)))); 
                (var dt_update#frozenIndirectionTableLoc#0#0 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#0), 
                    dt_update#frozenIndirectionTableLoc#0#0, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#0), 
                    BlockCache.Variables.cache(dt_update_tmp#1#0)))))));

// definition axiom for BlockCache.__default.Freeze for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Freeze(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.Freeze#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#frozenIndirectionTable#0#1 := Lit(#Options.Option.Some($Box(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))); 
                      Lit(#BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                          dt_update#frozenIndirectionTable#0#1, 
                          Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))); 
                (var dt_update#frozenIndirectionTableLoc#0#1 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#1), 
                    dt_update#frozenIndirectionTableLoc#0#1, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#1), 
                    BlockCache.Variables.cache(dt_update_tmp#1#1))))))
         && BlockCache.__default.Freeze(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.FreezeOp_q(Lit(vop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#frozenIndirectionTable#0#1 := Lit(#Options.Option.Some($Box(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))); 
                      Lit(#BlockCache.Variables.Ready(Lit(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#0#1)), 
                          dt_update#frozenIndirectionTable#0#1, 
                          Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                          Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))); 
                (var dt_update#frozenIndirectionTableLoc#0#1 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#1#1), 
                    dt_update#frozenIndirectionTableLoc#0#1, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#1), 
                    BlockCache.Variables.cache(dt_update_tmp#1#1)))))));

// function declaration for BlockCache._default.CleanUp
function BlockCache.__default.CleanUp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.CleanUp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.CleanUp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.CleanUp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.CleanUp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.CleanUp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.CleanUp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.CleanUp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.CleanUp#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for BlockCache.__default.CleanUp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.CleanUp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.CleanUp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> $IsA#BlockCache.Variables(s'#0)
             && $IsA#BlockCache.Variables((var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#persistentIndirectionTable#0#0 := $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType; 
                              #BlockCache.Variables.Ready(dt_update#persistentIndirectionTable#0#0, 
                                BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                                BlockCache.Variables.cache(dt_update_tmp#0#0)))); 
                        (var dt_update#persistentIndirectionTableLoc#0#0 := $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType; 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                            dt_update#persistentIndirectionTableLoc#0#0, 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#0), 
                            BlockCache.Variables.cache(dt_update_tmp#1#0)))); 
                    (var dt_update#frozenIndirectionTable#0#0 := Lit(#Options.Option.None()); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#2#0), 
                        dt_update#frozenIndirectionTable#0#0, 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#2#0), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#2#0), 
                        BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#2#0), 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#2#0), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#2#0), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#2#0), 
                        BlockCache.Variables.cache(dt_update_tmp#2#0)))); 
                (var dt_update#frozenIndirectionTableLoc#0#0 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#3#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#3#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#3#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#3#0), 
                    dt_update#frozenIndirectionTableLoc#0#0, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#3#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#3#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#3#0), 
                    BlockCache.Variables.cache(dt_update_tmp#3#0))))))
         && BlockCache.__default.CleanUp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.CleanUpOp_q(vop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && BlockDisk.DiskOp.NoDiskOp_q(dop#0)
             && Options.Option.None_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#persistentIndirectionTable#0#0 := $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType; 
                              #BlockCache.Variables.Ready(dt_update#persistentIndirectionTable#0#0, 
                                BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#0), 
                                BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#0), 
                                BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#0), 
                                BlockCache.Variables.cache(dt_update_tmp#0#0)))); 
                        (var dt_update#persistentIndirectionTableLoc#0#0 := $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType; 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#0), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#0), 
                            dt_update#persistentIndirectionTableLoc#0#0, 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#0), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#0), 
                            BlockCache.Variables.cache(dt_update_tmp#1#0)))); 
                    (var dt_update#frozenIndirectionTable#0#0 := Lit(#Options.Option.None()); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#2#0), 
                        dt_update#frozenIndirectionTable#0#0, 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#2#0), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#2#0), 
                        BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#2#0), 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#2#0), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#2#0), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#2#0), 
                        BlockCache.Variables.cache(dt_update_tmp#2#0)))); 
                (var dt_update#frozenIndirectionTableLoc#0#0 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#3#0), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#3#0), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#3#0), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#3#0), 
                    dt_update#frozenIndirectionTableLoc#0#0, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#3#0), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#3#0), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#3#0), 
                    BlockCache.Variables.cache(dt_update_tmp#3#0)))))));

// definition axiom for BlockCache.__default.CleanUp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.CleanUp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.CleanUp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> $IsA#BlockCache.Variables(Lit(s'#0))
             && $IsA#BlockCache.Variables((var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#persistentIndirectionTable#0#1 := Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType); 
                              Lit(#BlockCache.Variables.Ready(dt_update#persistentIndirectionTable#0#1, 
                                  Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))); 
                        (var dt_update#persistentIndirectionTableLoc#0#1 := Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                            dt_update#persistentIndirectionTableLoc#0#1, 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#1), 
                            BlockCache.Variables.cache(dt_update_tmp#1#1)))); 
                    (var dt_update#frozenIndirectionTable#0#1 := Lit(#Options.Option.None()); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#2#1), 
                        dt_update#frozenIndirectionTable#0#1, 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#2#1), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#2#1), 
                        BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#2#1), 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#2#1), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#2#1), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#2#1), 
                        BlockCache.Variables.cache(dt_update_tmp#2#1)))); 
                (var dt_update#frozenIndirectionTableLoc#0#1 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#3#1), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#3#1), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#3#1), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#3#1), 
                    dt_update#frozenIndirectionTableLoc#0#1, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#3#1), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#3#1), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#3#1), 
                    BlockCache.Variables.cache(dt_update_tmp#3#1))))))
         && BlockCache.__default.CleanUp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.CleanUpOp_q(Lit(vop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && Options.Option.None_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
             && Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && BlockCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#persistentIndirectionTable#0#1 := Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType); 
                              Lit(#BlockCache.Variables.Ready(dt_update#persistentIndirectionTable#0#1, 
                                  Lit(BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.outstandingBlockReads(dt_update_tmp#0#1)), 
                                  Lit(BlockCache.Variables.cache(dt_update_tmp#0#1)))))); 
                        (var dt_update#persistentIndirectionTableLoc#0#1 := Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType); 
                          #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#1#1), 
                            BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#1#1), 
                            dt_update#persistentIndirectionTableLoc#0#1, 
                            BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#1#1), 
                            BlockCache.Variables.outstandingBlockReads(dt_update_tmp#1#1), 
                            BlockCache.Variables.cache(dt_update_tmp#1#1)))); 
                    (var dt_update#frozenIndirectionTable#0#1 := Lit(#Options.Option.None()); 
                      #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#2#1), 
                        dt_update#frozenIndirectionTable#0#1, 
                        BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#2#1), 
                        BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#2#1), 
                        BlockCache.Variables.frozenIndirectionTableLoc(dt_update_tmp#2#1), 
                        BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#2#1), 
                        BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#2#1), 
                        BlockCache.Variables.outstandingBlockReads(dt_update_tmp#2#1), 
                        BlockCache.Variables.cache(dt_update_tmp#2#1)))); 
                (var dt_update#frozenIndirectionTableLoc#0#1 := Lit(#Options.Option.None()); 
                  #BlockCache.Variables.Ready(BlockCache.Variables.persistentIndirectionTable(dt_update_tmp#3#1), 
                    BlockCache.Variables.frozenIndirectionTable(dt_update_tmp#3#1), 
                    BlockCache.Variables.ephemeralIndirectionTable(dt_update_tmp#3#1), 
                    BlockCache.Variables.persistentIndirectionTableLoc(dt_update_tmp#3#1), 
                    dt_update#frozenIndirectionTableLoc#0#1, 
                    BlockCache.Variables.outstandingIndirectionTableWrite(dt_update_tmp#3#1), 
                    BlockCache.Variables.outstandingBlockWrites(dt_update_tmp#3#1), 
                    BlockCache.Variables.outstandingBlockReads(dt_update_tmp#3#1), 
                    BlockCache.Variables.cache(dt_update_tmp#3#1)))))));

// function declaration for BlockCache._default.NoOp
function BlockCache.__default.NoOp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.NoOp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.NoOp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.NoOp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.NoOp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.NoOp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.NoOp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.NoOp#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for BlockCache.__default.NoOp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.NoOp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (ViewOp.VOp.PopSyncOp_q(vop#0)
           ==> 
          !(true && BlockDisk.DiskOp.RespReadNodeOp_q(dop#0))
           ==> 
          BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
           ==> 
          BlockCache.Variables.Ready_q(s#0)
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
         && ((!(true && BlockDisk.DiskOp.RespReadNodeOp_q(dop#0))
               ==> 
              BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
               ==> 
              BlockCache.Variables.Ready_q(s#0)
               ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
             && (
              BlockDisk.DiskOp.NoDiskOp_q(dop#0)
               || (true && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0))
               || (true && BlockDisk.DiskOp.RespReadNodeOp_q(dop#0))
               || (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
                 && !
                (BlockCache.Variables.Ready_q(s#0)
                 && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s#0), 
                  #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))))))
               || (BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
                 && !
                (BlockCache.Variables.Ready_q(s#0)
                 && Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))])))
           ==> $IsA#BlockCache.Variables(s'#0) && $IsA#BlockCache.Variables(s#0))
         && BlockCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            (
              ViewOp.VOp.StatesInternalOp_q(vop#0)
               || ViewOp.VOp.JournalInternalOp_q(vop#0)
               || ViewOp.VOp.PushSyncOp_q(vop#0)
               || ViewOp.VOp.PopSyncOp_q(vop#0))
             && (
              BlockDisk.DiskOp.NoDiskOp_q(dop#0)
               || (true && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(dop#0))
               || (true && BlockDisk.DiskOp.RespReadNodeOp_q(dop#0))
               || (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(dop#0)
                 && !
                (BlockCache.Variables.Ready_q(s#0)
                 && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s#0), 
                  #Options.Option.Some($Box(BlockDisk.DiskOp.id(dop#0))))))
               || (BlockDisk.DiskOp.RespWriteNodeOp_q(dop#0)
                 && !
                (BlockCache.Variables.Ready_q(s#0)
                 && Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(BlockDisk.DiskOp.id(dop#0))])))
             && BlockCache.Variables#Equal(s'#0, s#0)));

// definition axiom for BlockCache.__default.NoOp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.NoOp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.NoOp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(ViewOp.VOp.PopSyncOp_q(Lit(vop#0)))
           ==> 
          !Lit(true && BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
           ==> 
          Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0)))
           ==> 
          Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && ((!Lit(true && BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
               ==> 
              Lit(BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0)))
               ==> 
              Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
               ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
             && (
              BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
               || (true && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0)))
               || (true && BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
               || (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0))
                 && !
                (BlockCache.Variables.Ready_q(Lit(s#0))
                 && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))))))
               || (BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0))
                 && !
                (BlockCache.Variables.Ready_q(Lit(s#0))
                 && Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))])))
           ==> $IsA#BlockCache.Variables(Lit(s'#0)) && $IsA#BlockCache.Variables(Lit(s#0)))
         && BlockCache.__default.NoOp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            (
              ViewOp.VOp.StatesInternalOp_q(Lit(vop#0))
               || ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
               || ViewOp.VOp.PushSyncOp_q(Lit(vop#0))
               || ViewOp.VOp.PopSyncOp_q(Lit(vop#0)))
             && (
              BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
               || (true && BlockDisk.DiskOp.RespReadIndirectionTableOp_q(Lit(dop#0)))
               || (true && BlockDisk.DiskOp.RespReadNodeOp_q(Lit(dop#0)))
               || (BlockDisk.DiskOp.RespWriteIndirectionTableOp_q(Lit(dop#0))
                 && !
                (BlockCache.Variables.Ready_q(Lit(s#0))
                 && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(BlockDisk.DiskOp.id(Lit(dop#0))))))))
               || (BlockDisk.DiskOp.RespWriteNodeOp_q(Lit(dop#0))
                 && !
                (BlockCache.Variables.Ready_q(Lit(s#0))
                 && Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(BlockDisk.DiskOp.id(Lit(dop#0)))])))
             && BlockCache.Variables#Equal(s'#0, s#0)));

// function declaration for BlockCache._default.BlockPointsToValidReferences
function BlockCache.__default.BlockPointsToValidReferences(block#0: DatatypeType, graph#0: Map Box Box) : bool;

function BlockCache.__default.BlockPointsToValidReferences#canCall(block#0: DatatypeType, graph#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.BlockPointsToValidReferences
axiom true
   ==> (forall block#0: DatatypeType, graph#0: Map Box Box :: 
    { BlockCache.__default.BlockPointsToValidReferences(block#0, graph#0) } 
    BlockCache.__default.BlockPointsToValidReferences#canCall(block#0, graph#0)
         || ($Is(block#0, Tclass.PivotBetreeGraph.Node())
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> true);

function BlockCache.__default.BlockPointsToValidReferences#requires(DatatypeType, Map Box Box) : bool;

// #requires axiom for BlockCache.__default.BlockPointsToValidReferences
axiom (forall block#0: DatatypeType, graph#0: Map Box Box :: 
  { BlockCache.__default.BlockPointsToValidReferences#requires(block#0, graph#0) } 
  $Is(block#0, Tclass.PivotBetreeGraph.Node())
       && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
     ==> BlockCache.__default.BlockPointsToValidReferences#requires(block#0, graph#0)
       == true);

// definition axiom for BlockCache.__default.BlockPointsToValidReferences(revealed)
axiom true
   ==> (forall block#0: DatatypeType, graph#0: Map Box Box :: 
    { BlockCache.__default.BlockPointsToValidReferences(block#0, graph#0) } 
    BlockCache.__default.BlockPointsToValidReferences#canCall(block#0, graph#0)
         || ($Is(block#0, Tclass.PivotBetreeGraph.Node())
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> PivotBetreeGraph.__default.Successors#canCall(block#0)
         && BlockCache.__default.BlockPointsToValidReferences(block#0, graph#0)
           == (forall ref#0: int :: 
            { Map#Domain(graph#0)[$Box(ref#0)] } 
              { PivotBetreeGraph.__default.Successors(block#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && PivotBetreeGraph.__default.Successors(block#0)[$Box(ref#0)]
               ==> Map#Domain(graph#0)[$Box(ref#0)]));

// definition axiom for BlockCache.__default.BlockPointsToValidReferences for all literals(revealed)
axiom true
   ==> (forall block#0: DatatypeType, graph#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), Lit(graph#0)) } 
    BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), Lit(graph#0))
         || ($Is(block#0, Tclass.PivotBetreeGraph.Node())
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> PivotBetreeGraph.__default.Successors#canCall(Lit(block#0))
         && BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), Lit(graph#0))
           == (forall ref#1: int :: 
            { Map#Domain(graph#0)[$Box(ref#1)] } 
              { PivotBetreeGraph.__default.Successors(block#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Lit(PivotBetreeGraph.__default.Successors(Lit(block#0)))[$Box(ref#1)]
               ==> Map#Domain(graph#0)[$Box(ref#1)]));

// function declaration for BlockCache._default.Dirty
function BlockCache.__default.Dirty(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ref#0: int, 
    block#0: DatatypeType)
   : bool;

function BlockCache.__default.Dirty#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ref#0: int, 
    block#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.Dirty
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    { BlockCache.__default.Dirty(k#0, s#0, s'#0, ref#0, block#0) } 
    BlockCache.__default.Dirty#canCall(k#0, s#0, s'#0, ref#0, block#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> true);

function BlockCache.__default.Dirty#requires(DatatypeType, DatatypeType, DatatypeType, int, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.Dirty
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ref#0: int, 
    block#0: DatatypeType :: 
  { BlockCache.__default.Dirty#requires(k#0, s#0, s'#0, ref#0, block#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
       && $Is(block#0, Tclass.PivotBetreeGraph.Node())
     ==> BlockCache.__default.Dirty#requires(k#0, s#0, s'#0, ref#0, block#0) == true);

// definition axiom for BlockCache.__default.Dirty(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    { BlockCache.__default.Dirty(k#0, s#0, s'#0, ref#0, block#0) } 
    BlockCache.__default.Dirty#canCall(k#0, s#0, s'#0, ref#0, block#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> (Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (Map#Equal(BlockCache.Variables.cache(s'#0), 
            Map#Build(BlockCache.Variables.cache(s#0), $Box(ref#0), $Box(block#0)))
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0)))
         && ($IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && BlockCache.__default.BlockPointsToValidReferences(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
           ==> (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && (SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)))
         && ((Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && (SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)])
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && Map#Equal(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Map#Build(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                $Box(ref#0), 
                Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && PivotBetreeGraph.__default.Successors#canCall(block#0))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && PivotBetreeGraph.__default.Successors#canCall(block#0)
             && ISet#Equal((lambda $y#0: Box :: 
                $IsBox($y#0, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]): Seq Box, 
                    $y#0)), 
              PivotBetreeGraph.__default.Successors(block#0))
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
            BlockCache.Variables.outstandingBlockReads(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
              BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s#0)))
         && BlockCache.__default.Dirty(k#0, s#0, s'#0, ref#0, block#0)
           == (
            BlockCache.Variables.Ready_q(s#0)
             && Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
             && BlockCache.Variables.Ready_q(s'#0)
             && Map#Equal(BlockCache.Variables.cache(s'#0), 
              Map#Build(BlockCache.Variables.cache(s#0), $Box(ref#0), $Box(block#0)))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
             && Map#Equal(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && BlockCache.__default.BlockPointsToValidReferences(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))[$Box(ref#0)])
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]
             && Map#Equal(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Map#Build(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                $Box(ref#0), 
                Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]))
             && ISet#Equal((lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]): Seq Box, 
                    $y#1)), 
              PivotBetreeGraph.__default.Successors(block#0))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0), 
              BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(s'#0), 
              BlockCache.Variables.outstandingBlockWrites(s#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
              BlockCache.Variables.outstandingBlockReads(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
              BlockCache.Variables.frozenIndirectionTable(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(s'#0), 
              BlockCache.Variables.persistentIndirectionTableLoc(s#0))));

// definition axiom for BlockCache.__default.Dirty for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Dirty(Lit(k#0), Lit(s#0), Lit(s'#0), ref#0, Lit(block#0)) } 
    BlockCache.__default.Dirty#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), ref#0, Lit(block#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> (Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
            Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), $Box(ref#0), $Box(Lit(block#0))))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Lit(BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
           ==> (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && ((Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(ref#0), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0))
             && ISet#Equal((lambda $y#2: Box :: 
                $IsBox($y#2, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]): Seq Box, 
                    $y#2)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Dirty(Lit(k#0), Lit(s#0), Lit(s'#0), ref#0, Lit(block#0))
           == (
            BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), $Box(ref#0), $Box(Lit(block#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Set#UnionOne(Set#Empty(): Set Box, $Box(ref#0))))
             && BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(ref#0), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]))
             && ISet#Equal((lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]): Seq Box, 
                    $y#3)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// definition axiom for BlockCache.__default.Dirty for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Dirty(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(ref#0), Lit(block#0)) } 
    BlockCache.__default.Dirty#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(ref#0), Lit(block#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> (Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
            Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), 
              $Box(LitInt(ref#0)), 
              $Box(Lit(block#0))))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Maps.__default.MapRemove#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.DiskLayout.Location(), 
              Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
              Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0)))))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Lit(BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
           ==> (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && ((Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> SectorType.IndirectionTable.IndirectionTable_q(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(LitInt(ref#0)), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0))
             && ISet#Equal((lambda $y#4: Box :: 
                $IsBox($y#4, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]): Seq Box, 
                    $y#4)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Dirty(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(ref#0), Lit(block#0))
           == (
            BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#0)]
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), 
                $Box(LitInt(ref#0)), 
                $Box(Lit(block#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Maps.__default.MapRemove(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove, 
                Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                Lit(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(ref#0))))))
             && BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)]
               ==> Map#Domain(SectorType.IndirectionTable.locs(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))[$Box(ref#0)])
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(LitInt(ref#0)), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]))
             && ISet#Equal((lambda $y#5: Box :: 
                $IsBox($y#5, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]): Seq Box, 
                    $y#5)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// function declaration for BlockCache._default.Alloc
function BlockCache.__default.Alloc(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ref#0: int, 
    block#0: DatatypeType)
   : bool;

function BlockCache.__default.Alloc#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ref#0: int, 
    block#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.Alloc
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    { BlockCache.__default.Alloc(k#0, s#0, s'#0, ref#0, block#0) } 
    BlockCache.__default.Alloc#canCall(k#0, s#0, s'#0, ref#0, block#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> true);

function BlockCache.__default.Alloc#requires(DatatypeType, DatatypeType, DatatypeType, int, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.Alloc
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ref#0: int, 
    block#0: DatatypeType :: 
  { BlockCache.__default.Alloc#requires(k#0, s#0, s'#0, ref#0, block#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
       && $Is(block#0, Tclass.PivotBetreeGraph.Node())
     ==> BlockCache.__default.Alloc#requires(k#0, s#0, s'#0, ref#0, block#0) == true);

// definition axiom for BlockCache.__default.Alloc(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    { BlockCache.__default.Alloc(k#0, s#0, s'#0, ref#0, block#0) } 
    BlockCache.__default.Alloc#canCall(k#0, s#0, s'#0, ref#0, block#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> (!Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
           ==> BlockCache.__default.IsAllocated#canCall(s#0, ref#0))
         && (Map#Equal(BlockCache.Variables.cache(s'#0), 
            Map#Build(BlockCache.Variables.cache(s#0), $Box(ref#0), $Box(block#0)))
           ==> $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0)))
         && ($IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s'#0))
             && $IsA#SectorType.IndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Map#Equal(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && BlockCache.__default.BlockPointsToValidReferences(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && Map#Equal(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Map#Build(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                $Box(ref#0), 
                Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && PivotBetreeGraph.__default.Successors#canCall(block#0))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s'#0))
             && PivotBetreeGraph.__default.Successors#canCall(block#0)
             && ISet#Equal((lambda $y#0: Box :: 
                $IsBox($y#0, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]): Seq Box, 
                    $y#0)), 
              PivotBetreeGraph.__default.Successors(block#0))
           ==> $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.outstandingIndirectionTableWrite(s#0)))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
            BlockCache.Variables.outstandingBlockReads(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTable(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
              BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
         && ($IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s'#0))
             && $IsA#Options.Option(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s'#0))
             && $IsA#DiskLayout.Location(BlockCache.Variables.persistentIndirectionTableLoc(s#0)))
         && BlockCache.__default.Alloc(k#0, s#0, s'#0, ref#0, block#0)
           == (
            BlockCache.Variables.Ready_q(s#0)
             && !Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
             && !BlockCache.__default.IsAllocated(s#0, ref#0)
             && BlockCache.Variables.Ready_q(s'#0)
             && Map#Equal(BlockCache.Variables.cache(s'#0), 
              Map#Build(BlockCache.Variables.cache(s#0), $Box(ref#0), $Box(block#0)))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(s'#0), 
              BlockCache.Variables.persistentIndirectionTable(s#0))
             && Map#Equal(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && BlockCache.__default.BlockPointsToValidReferences(block#0, 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]
             && Map#Equal(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)), 
              Map#Build(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)), 
                $Box(ref#0), 
                Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]))
             && ISet#Equal((lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s'#0)))[$Box(ref#0)]): Seq Box, 
                    $y#1)), 
              PivotBetreeGraph.__default.Successors(block#0))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(s'#0), 
              BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(s'#0), 
              BlockCache.Variables.outstandingBlockWrites(s#0))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(s'#0), 
              BlockCache.Variables.outstandingBlockReads(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(s'#0), 
              BlockCache.Variables.frozenIndirectionTable(s#0))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(s'#0), 
              BlockCache.Variables.frozenIndirectionTableLoc(s#0))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(s'#0), 
              BlockCache.Variables.persistentIndirectionTableLoc(s#0))));

// definition axiom for BlockCache.__default.Alloc for decreasing-related literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Alloc(Lit(k#0), Lit(s#0), Lit(s'#0), ref#0, Lit(block#0)) } 
    BlockCache.__default.Alloc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), ref#0, Lit(block#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> (!Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> BlockCache.__default.IsAllocated#canCall(Lit(s#0), ref#0))
         && (Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
            Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), $Box(ref#0), $Box(Lit(block#0))))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Lit(BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(ref#0), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0))
             && ISet#Equal((lambda $y#2: Box :: 
                $IsBox($y#2, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]): Seq Box, 
                    $y#2)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Alloc(Lit(k#0), Lit(s#0), Lit(s'#0), ref#0, Lit(block#0))
           == (
            BlockCache.Variables.Ready_q(Lit(s#0))
             && !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && !BlockCache.__default.IsAllocated(Lit(s#0), ref#0)
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), $Box(ref#0), $Box(Lit(block#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
             && BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(ref#0), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]))
             && ISet#Equal((lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(ref#0)]): Seq Box, 
                    $y#3)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// definition axiom for BlockCache.__default.Alloc for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ref#0: int, 
      block#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Alloc(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(ref#0), Lit(block#0)) } 
    BlockCache.__default.Alloc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(ref#0), Lit(block#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(block#0, Tclass.PivotBetreeGraph.Node()))
       ==> (!Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
           ==> BlockCache.__default.IsAllocated#canCall(Lit(s#0), LitInt(ref#0)))
         && (Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
            Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), 
              $Box(LitInt(ref#0)), 
              $Box(Lit(block#0))))
           ==> $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && ($IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0))))
             && $IsA#SectorType.IndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.BlockPointsToValidReferences#canCall(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Lit(BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && 
            SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(LitInt(ref#0)), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0)))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))
             && PivotBetreeGraph.__default.Successors#canCall(Lit(block#0))
             && ISet#Equal((lambda $y#4: Box :: 
                $IsBox($y#4, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]): Seq Box, 
                    $y#4)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))))
         && (Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
            BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
         && ($IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0))))
             && $IsA#Options.Option(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
           ==> $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0))))
             && $IsA#DiskLayout.Location(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Alloc(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(ref#0), Lit(block#0))
           == (
            BlockCache.Variables.Ready_q(Lit(s#0))
             && !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#0)]
             && !Lit(BlockCache.__default.IsAllocated(Lit(s#0), LitInt(ref#0)))
             && BlockCache.Variables.Ready_q(Lit(s'#0))
             && Map#Equal(BlockCache.Variables.cache(Lit(s'#0)), 
              Map#Build(Lit(BlockCache.Variables.cache(Lit(s#0))), 
                $Box(LitInt(ref#0)), 
                $Box(Lit(block#0))))
             && SectorType.IndirectionTable#Equal(BlockCache.Variables.persistentIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))
             && Map#Equal(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
             && BlockCache.__default.BlockPointsToValidReferences(Lit(block#0), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))))[$Box(ref#0)]
             && Map#Equal(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0)))), 
              Map#Build(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))), 
                $Box(LitInt(ref#0)), 
                Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]))
             && ISet#Equal((lambda $y#5: Box :: 
                $IsBox($y#5, Tclass.NativeTypes.uint64())
                   && Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s'#0))))))[$Box(LitInt(ref#0))]): Seq Box, 
                    $y#5)), 
              PivotBetreeGraph.__default.Successors(Lit(block#0)))
             && Options.Option#Equal(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s'#0)), 
              BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockWrites(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))
             && Map#Equal(BlockCache.Variables.outstandingBlockReads(Lit(s'#0)), 
              BlockCache.Variables.outstandingBlockReads(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTable(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))
             && Options.Option#Equal(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))
             && DiskLayout.Location#Equal(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s'#0)), 
              BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))));

// function declaration for BlockCache._default.ReadStep
function BlockCache.__default.ReadStep(k#0: DatatypeType, s#0: DatatypeType, op#0: DatatypeType) : bool;

function BlockCache.__default.ReadStep#canCall(k#0: DatatypeType, s#0: DatatypeType, op#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.ReadStep
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, op#0: DatatypeType :: 
    { BlockCache.__default.ReadStep(k#0, s#0, op#0) } 
    BlockCache.__default.ReadStep#canCall(k#0, s#0, op#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(op#0, Tclass.PivotBetreeGraph.ReadOp()))
       ==> true);

function BlockCache.__default.ReadStep#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.ReadStep
axiom (forall k#0: DatatypeType, s#0: DatatypeType, op#0: DatatypeType :: 
  { BlockCache.__default.ReadStep#requires(k#0, s#0, op#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(op#0, Tclass.PivotBetreeGraph.ReadOp())
     ==> BlockCache.__default.ReadStep#requires(k#0, s#0, op#0) == true);

// definition axiom for BlockCache.__default.ReadStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, op#0: DatatypeType :: 
    { BlockCache.__default.ReadStep(k#0, s#0, op#0) } 
    BlockCache.__default.ReadStep#canCall(k#0, s#0, op#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(op#0, Tclass.PivotBetreeGraph.ReadOp()))
       ==> (BlockCache.Variables.Ready_q(s#0)
           ==> PivotBetreeGraph.ReadOp.ReadOp_q(op#0)
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (PivotBetreeGraph.ReadOp.ReadOp_q(op#0)
             && SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(PivotBetreeGraph.ReadOp.ref(op#0))]
           ==> PivotBetreeGraph.ReadOp.ReadOp_q(op#0)
             && PivotBetreeGraph.ReadOp.ReadOp_q(op#0)
             && Maps.__default.MapsTo#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              BlockCache.Variables.cache(s#0), 
              $Box(PivotBetreeGraph.ReadOp.ref(op#0)), 
              $Box(PivotBetreeGraph.ReadOp.node(op#0))))
         && BlockCache.__default.ReadStep(k#0, s#0, op#0)
           == (
            BlockCache.Variables.Ready_q(s#0)
             && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(PivotBetreeGraph.ReadOp.ref(op#0))]
             && Maps.__default.MapsTo(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              BlockCache.Variables.cache(s#0), 
              $Box(PivotBetreeGraph.ReadOp.ref(op#0)), 
              $Box(PivotBetreeGraph.ReadOp.node(op#0)))));

// definition axiom for BlockCache.__default.ReadStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, op#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.ReadStep(Lit(k#0), Lit(s#0), Lit(op#0)) } 
    BlockCache.__default.ReadStep#canCall(Lit(k#0), Lit(s#0), Lit(op#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(op#0, Tclass.PivotBetreeGraph.ReadOp()))
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> PivotBetreeGraph.ReadOp.ReadOp_q(Lit(op#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (PivotBetreeGraph.ReadOp.ReadOp_q(Lit(op#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(PivotBetreeGraph.ReadOp.ref(Lit(op#0)))]
           ==> PivotBetreeGraph.ReadOp.ReadOp_q(Lit(op#0))
             && PivotBetreeGraph.ReadOp.ReadOp_q(Lit(op#0))
             && Maps.__default.MapsTo#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockCache.Variables.cache(Lit(s#0))), 
              $Box(LitInt(PivotBetreeGraph.ReadOp.ref(Lit(op#0)))), 
              $Box(Lit(PivotBetreeGraph.ReadOp.node(Lit(op#0))))))
         && BlockCache.__default.ReadStep(Lit(k#0), Lit(s#0), Lit(op#0))
           == (
            BlockCache.Variables.Ready_q(Lit(s#0))
             && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(PivotBetreeGraph.ReadOp.ref(Lit(op#0)))]
             && Maps.__default.MapsTo(Tclass.NativeTypes.uint64(), 
              Tclass.PivotBetreeGraph.Node(), 
              Lit(BlockCache.Variables.cache(Lit(s#0))), 
              $Box(LitInt(PivotBetreeGraph.ReadOp.ref(Lit(op#0)))), 
              $Box(Lit(PivotBetreeGraph.ReadOp.node(Lit(op#0)))))));

// function declaration for BlockCache._default.OpStep
function BlockCache.__default.OpStep(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, op#0: DatatypeType)
   : bool;

function BlockCache.__default.OpStep#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, op#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.OpStep
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, op#0: DatatypeType :: 
    { BlockCache.__default.OpStep(k#0, s#0, s'#0, op#0) } 
    BlockCache.__default.OpStep#canCall(k#0, s#0, s'#0, op#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(op#0, Tclass.PivotBetreeGraph.Op()))
       ==> true);

function BlockCache.__default.OpStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.OpStep
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, op#0: DatatypeType :: 
  { BlockCache.__default.OpStep#requires(k#0, s#0, s'#0, op#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(op#0, Tclass.PivotBetreeGraph.Op())
     ==> BlockCache.__default.OpStep#requires(k#0, s#0, s'#0, op#0) == true);

// definition axiom for BlockCache.__default.OpStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, op#0: DatatypeType :: 
    { BlockCache.__default.OpStep(k#0, s#0, s'#0, op#0) } 
    BlockCache.__default.OpStep#canCall(k#0, s#0, s'#0, op#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(op#0, Tclass.PivotBetreeGraph.Op()))
       ==> (PivotBetreeGraph.Op.AllocOp_q(op#0)
           ==> (PivotBetreeGraph.Op.AllocOp_q(op#0) || PivotBetreeGraph.Op.WriteOp_q(op#0))
             && (var block#0 := PivotBetreeGraph.Op.node(op#0); 
              (PivotBetreeGraph.Op.AllocOp_q(op#0) || PivotBetreeGraph.Op.WriteOp_q(op#0))
                 && (var ref#0 := PivotBetreeGraph.Op.ref(op#0); 
                  BlockCache.__default.Alloc#canCall(k#0, s#0, s'#0, ref#0, block#0))))
         && (!PivotBetreeGraph.Op.AllocOp_q(op#0)
           ==> (PivotBetreeGraph.Op.AllocOp_q(op#0) || PivotBetreeGraph.Op.WriteOp_q(op#0))
             && (var block#1 := PivotBetreeGraph.Op.node(op#0); 
              (PivotBetreeGraph.Op.AllocOp_q(op#0) || PivotBetreeGraph.Op.WriteOp_q(op#0))
                 && (var ref#1 := PivotBetreeGraph.Op.ref(op#0); 
                  BlockCache.__default.Dirty#canCall(k#0, s#0, s'#0, ref#1, block#1))))
         && BlockCache.__default.OpStep(k#0, s#0, s'#0, op#0)
           == (if PivotBetreeGraph.Op.AllocOp_q(op#0)
             then (var block#2 := PivotBetreeGraph.Op.node(op#0); 
              (var ref#2 := PivotBetreeGraph.Op.ref(op#0); 
                BlockCache.__default.Alloc(k#0, s#0, s'#0, ref#2, block#2)))
             else (var block#3 := PivotBetreeGraph.Op.node(op#0); 
              (var ref#3 := PivotBetreeGraph.Op.ref(op#0); 
                BlockCache.__default.Dirty(k#0, s#0, s'#0, ref#3, block#3)))));

// definition axiom for BlockCache.__default.OpStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, op#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.OpStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(op#0)) } 
    BlockCache.__default.OpStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(op#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(op#0, Tclass.PivotBetreeGraph.Op()))
       ==> (Lit(PivotBetreeGraph.Op.AllocOp_q(Lit(op#0)))
           ==> (PivotBetreeGraph.Op.AllocOp_q(Lit(op#0))
               || PivotBetreeGraph.Op.WriteOp_q(Lit(op#0)))
             && (var block#4 := Lit(PivotBetreeGraph.Op.node(Lit(op#0))); 
              (PivotBetreeGraph.Op.AllocOp_q(Lit(op#0))
                   || PivotBetreeGraph.Op.WriteOp_q(Lit(op#0)))
                 && (var ref#4 := LitInt(PivotBetreeGraph.Op.ref(Lit(op#0))); 
                  BlockCache.__default.Alloc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), ref#4, block#4))))
         && (!Lit(PivotBetreeGraph.Op.AllocOp_q(Lit(op#0)))
           ==> (PivotBetreeGraph.Op.AllocOp_q(Lit(op#0))
               || PivotBetreeGraph.Op.WriteOp_q(Lit(op#0)))
             && (var block#5 := Lit(PivotBetreeGraph.Op.node(Lit(op#0))); 
              (PivotBetreeGraph.Op.AllocOp_q(Lit(op#0))
                   || PivotBetreeGraph.Op.WriteOp_q(Lit(op#0)))
                 && (var ref#5 := LitInt(PivotBetreeGraph.Op.ref(Lit(op#0))); 
                  BlockCache.__default.Dirty#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), ref#5, block#5))))
         && BlockCache.__default.OpStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(op#0))
           == (if PivotBetreeGraph.Op.AllocOp_q(Lit(op#0))
             then (var block#6 := Lit(PivotBetreeGraph.Op.node(Lit(op#0))); 
              (var ref#6 := LitInt(PivotBetreeGraph.Op.ref(Lit(op#0))); 
                Lit(BlockCache.__default.Alloc(Lit(k#0), Lit(s#0), Lit(s'#0), ref#6, block#6))))
             else (var block#7 := Lit(PivotBetreeGraph.Op.node(Lit(op#0))); 
              (var ref#7 := LitInt(PivotBetreeGraph.Op.ref(Lit(op#0))); 
                Lit(BlockCache.__default.Dirty(Lit(k#0), Lit(s#0), Lit(s'#0), ref#7, block#7))))));

// function declaration for BlockCache._default.Transaction
function BlockCache.__default.Transaction(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ops#0: Seq Box)
   : bool;

function BlockCache.__default.Transaction#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ops#0: Seq Box)
   : bool;

// consequence axiom for BlockCache.__default.Transaction
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ops#0: Seq Box :: 
    { BlockCache.__default.Transaction(k#0, s#0, s'#0, dop#0, vop#0, ops#0) } 
    BlockCache.__default.Transaction#canCall(k#0, s#0, s'#0, dop#0, vop#0, ops#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op())))
       ==> true);

function BlockCache.__default.Transaction#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, Seq Box)
   : bool;

// #requires axiom for BlockCache.__default.Transaction
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    ops#0: Seq Box :: 
  { BlockCache.__default.Transaction#requires(k#0, s#0, s'#0, dop#0, vop#0, ops#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op()))
     ==> BlockCache.__default.Transaction#requires(k#0, s#0, s'#0, dop#0, vop#0, ops#0)
       == true);

// definition axiom for BlockCache.__default.Transaction(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ops#0: Seq Box :: 
    { BlockCache.__default.Transaction(k#0, s#0, s'#0, dop#0, vop#0, ops#0) } 
    BlockCache.__default.Transaction#canCall(k#0, s#0, s'#0, dop#0, vop#0, ops#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op())))
       ==> (BlockCache.Variables.Ready_q(s#0)
           ==> BlockCache.__default.OpTransaction#canCall(k#0, s#0, s'#0, ops#0))
         && BlockCache.__default.Transaction(k#0, s#0, s'#0, dop#0, vop#0, ops#0)
           == (
            ViewOp.VOp.AdvanceOp_q(vop#0)
             && BlockDisk.DiskOp.NoDiskOp_q(dop#0)
             && BlockCache.Variables.Ready_q(s#0)
             && BlockCache.__default.OpTransaction(StartFuel_BlockCache._default.OpTransaction, k#0, s#0, s'#0, ops#0)));

// definition axiom for BlockCache.__default.Transaction for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      ops#0: Seq Box :: 
    {:weight 3} { BlockCache.__default.Transaction(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(ops#0)) } 
    BlockCache.__default.Transaction#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(ops#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op())))
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> BlockCache.__default.OpTransaction#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0)))
         && BlockCache.__default.Transaction(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(ops#0))
           == (
            ViewOp.VOp.AdvanceOp_q(Lit(vop#0))
             && BlockDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && BlockCache.Variables.Ready_q(Lit(s#0))
             && BlockCache.__default.OpTransaction(StartFuel_BlockCache._default.OpTransaction, 
              Lit(k#0), 
              Lit(s#0), 
              Lit(s'#0), 
              Lit(ops#0))));

// function declaration for BlockCache._default.Init
function BlockCache.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function BlockCache.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.Init(k#0, s#0) } 
    BlockCache.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables()))
       ==> true);

function BlockCache.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { BlockCache.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
     ==> BlockCache.__default.Init#requires(k#0, s#0) == true);

// definition axiom for BlockCache.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.Init(k#0, s#0) } 
    BlockCache.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables()))
       ==> $IsA#BlockCache.Variables(s#0)
         && BlockCache.__default.Init(k#0, s#0)
           == BlockCache.Variables#Equal(s#0, #BlockCache.Variables.Unready()));

// definition axiom for BlockCache.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Init(Lit(k#0), Lit(s#0)) } 
    BlockCache.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables()))
       ==> $IsA#BlockCache.Variables(Lit(s#0))
         && BlockCache.__default.Init(Lit(k#0), Lit(s#0))
           == BlockCache.Variables#Equal(s#0, #BlockCache.Variables.Unready()));

// function declaration for BlockCache._default.NextStep
function BlockCache.__default.NextStep(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

function BlockCache.__default.NextStep#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.NextStep
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
    BlockCache.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, vop#0, step#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(step#0, Tclass.BlockCache.Step()))
       ==> true);

function BlockCache.__default.NextStep#requires(DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType)
   : bool;

// #requires axiom for BlockCache.__default.NextStep
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    step#0: DatatypeType :: 
  { BlockCache.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && $Is(step#0, Tclass.BlockCache.Step())
     ==> BlockCache.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, vop#0, step#0)
       == true);

// definition axiom for BlockCache.__default.NextStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
    BlockCache.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, vop#0, step#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(step#0, Tclass.BlockCache.Step()))
       ==> (BlockCache.Step.WriteBackNodeReqStep_q(step#0)
           ==> (var ref#0 := BlockCache.Step.ref(step#0); 
            BlockCache.__default.WriteBackNodeReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#0)))
         && (!BlockCache.Step.WriteBackNodeReqStep_q(step#0)
           ==> (BlockCache.Step.WriteBackNodeRespStep_q(step#0)
               ==> BlockCache.__default.WriteBackNodeResp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
             && (!BlockCache.Step.WriteBackNodeRespStep_q(step#0)
               ==> (BlockCache.Step.WriteBackIndirectionTableReqStep_q(step#0)
                   ==> BlockCache.__default.WriteBackIndirectionTableReq#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                 && (!BlockCache.Step.WriteBackIndirectionTableReqStep_q(step#0)
                   ==> (BlockCache.Step.WriteBackIndirectionTableRespStep_q(step#0)
                       ==> BlockCache.__default.WriteBackIndirectionTableResp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                     && (!BlockCache.Step.WriteBackIndirectionTableRespStep_q(step#0)
                       ==> (BlockCache.Step.UnallocStep_q(step#0)
                           ==> (var ref#1 := BlockCache.Step.ref(step#0); 
                            BlockCache.__default.Unalloc#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#1)))
                         && (!BlockCache.Step.UnallocStep_q(step#0)
                           ==> (BlockCache.Step.PageInNodeReqStep_q(step#0)
                               ==> (var ref#2 := BlockCache.Step.ref(step#0); 
                                BlockCache.__default.PageInNodeReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#2)))
                             && (!BlockCache.Step.PageInNodeReqStep_q(step#0)
                               ==> (BlockCache.Step.PageInNodeRespStep_q(step#0)
                                   ==> BlockCache.__default.PageInNodeResp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                 && (!BlockCache.Step.PageInNodeRespStep_q(step#0)
                                   ==> (BlockCache.Step.PageInIndirectionTableReqStep_q(step#0)
                                       ==> BlockCache.__default.PageInIndirectionTableReq#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                     && (!BlockCache.Step.PageInIndirectionTableReqStep_q(step#0)
                                       ==> (BlockCache.Step.PageInIndirectionTableRespStep_q(step#0)
                                           ==> BlockCache.__default.PageInIndirectionTableResp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                         && (!BlockCache.Step.PageInIndirectionTableRespStep_q(step#0)
                                           ==> (BlockCache.Step.ReceiveLocStep_q(step#0)
                                               ==> BlockCache.__default.ReceiveLoc#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                             && (!BlockCache.Step.ReceiveLocStep_q(step#0)
                                               ==> (BlockCache.Step.EvictStep_q(step#0)
                                                   ==> (var ref#3 := BlockCache.Step.ref(step#0); 
                                                    BlockCache.__default.Evict#canCall(k#0, s#0, s'#0, dop#0, vop#0, ref#3)))
                                                 && (!BlockCache.Step.EvictStep_q(step#0)
                                                   ==> (BlockCache.Step.FreezeStep_q(step#0)
                                                       ==> BlockCache.__default.Freeze#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                     && (!BlockCache.Step.FreezeStep_q(step#0)
                                                       ==> (BlockCache.Step.CleanUpStep_q(step#0)
                                                           ==> BlockCache.__default.CleanUp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                         && (!BlockCache.Step.CleanUpStep_q(step#0)
                                                           ==> (BlockCache.Step.NoOpStep_q(step#0)
                                                               ==> BlockCache.__default.NoOp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                             && (!BlockCache.Step.NoOpStep_q(step#0)
                                                               ==> (var ops#0 := BlockCache.Step.ops(step#0); 
                                                                BlockCache.__default.Transaction#canCall(k#0, s#0, s'#0, dop#0, vop#0, ops#0))))))))))))))))
         && BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0)
           == (if BlockCache.Step.WriteBackNodeReqStep_q(step#0)
             then (var ref#4 := BlockCache.Step.ref(step#0); 
              BlockCache.__default.WriteBackNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#4))
             else (if BlockCache.Step.WriteBackNodeRespStep_q(step#0)
               then BlockCache.__default.WriteBackNodeResp(k#0, s#0, s'#0, dop#0, vop#0)
               else (if BlockCache.Step.WriteBackIndirectionTableReqStep_q(step#0)
                 then BlockCache.__default.WriteBackIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0)
                 else (if BlockCache.Step.WriteBackIndirectionTableRespStep_q(step#0)
                   then BlockCache.__default.WriteBackIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0)
                   else (if BlockCache.Step.UnallocStep_q(step#0)
                     then (var ref#5 := BlockCache.Step.ref(step#0); 
                      BlockCache.__default.Unalloc(k#0, s#0, s'#0, dop#0, vop#0, ref#5))
                     else (if BlockCache.Step.PageInNodeReqStep_q(step#0)
                       then (var ref#6 := BlockCache.Step.ref(step#0); 
                        BlockCache.__default.PageInNodeReq(k#0, s#0, s'#0, dop#0, vop#0, ref#6))
                       else (if BlockCache.Step.PageInNodeRespStep_q(step#0)
                         then BlockCache.__default.PageInNodeResp(k#0, s#0, s'#0, dop#0, vop#0)
                         else (if BlockCache.Step.PageInIndirectionTableReqStep_q(step#0)
                           then BlockCache.__default.PageInIndirectionTableReq(k#0, s#0, s'#0, dop#0, vop#0)
                           else (if BlockCache.Step.PageInIndirectionTableRespStep_q(step#0)
                             then BlockCache.__default.PageInIndirectionTableResp(k#0, s#0, s'#0, dop#0, vop#0)
                             else (if BlockCache.Step.ReceiveLocStep_q(step#0)
                               then BlockCache.__default.ReceiveLoc(k#0, s#0, s'#0, dop#0, vop#0)
                               else (if BlockCache.Step.EvictStep_q(step#0)
                                 then (var ref#7 := BlockCache.Step.ref(step#0); 
                                  BlockCache.__default.Evict(k#0, s#0, s'#0, dop#0, vop#0, ref#7))
                                 else (if BlockCache.Step.FreezeStep_q(step#0)
                                   then BlockCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0)
                                   else (if BlockCache.Step.CleanUpStep_q(step#0)
                                     then BlockCache.__default.CleanUp(k#0, s#0, s'#0, dop#0, vop#0)
                                     else (if BlockCache.Step.NoOpStep_q(step#0)
                                       then BlockCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0)
                                       else (var ops#1 := BlockCache.Step.ops(step#0); 
                                        BlockCache.__default.Transaction(k#0, s#0, s'#0, dop#0, vop#0, ops#1)))))))))))))))));

// definition axiom for BlockCache.__default.NextStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      step#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(step#0)) } 
    BlockCache.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(step#0, Tclass.BlockCache.Step()))
       ==> (Lit(BlockCache.Step.WriteBackNodeReqStep_q(Lit(step#0)))
           ==> (var ref#8 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
            BlockCache.__default.WriteBackNodeReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#8)))
         && (!Lit(BlockCache.Step.WriteBackNodeReqStep_q(Lit(step#0)))
           ==> (Lit(BlockCache.Step.WriteBackNodeRespStep_q(Lit(step#0)))
               ==> BlockCache.__default.WriteBackNodeResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
             && (!Lit(BlockCache.Step.WriteBackNodeRespStep_q(Lit(step#0)))
               ==> (Lit(BlockCache.Step.WriteBackIndirectionTableReqStep_q(Lit(step#0)))
                   ==> BlockCache.__default.WriteBackIndirectionTableReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                 && (!Lit(BlockCache.Step.WriteBackIndirectionTableReqStep_q(Lit(step#0)))
                   ==> (Lit(BlockCache.Step.WriteBackIndirectionTableRespStep_q(Lit(step#0)))
                       ==> BlockCache.__default.WriteBackIndirectionTableResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                     && (!Lit(BlockCache.Step.WriteBackIndirectionTableRespStep_q(Lit(step#0)))
                       ==> (Lit(BlockCache.Step.UnallocStep_q(Lit(step#0)))
                           ==> (var ref#9 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
                            BlockCache.__default.Unalloc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#9)))
                         && (!Lit(BlockCache.Step.UnallocStep_q(Lit(step#0)))
                           ==> (Lit(BlockCache.Step.PageInNodeReqStep_q(Lit(step#0)))
                               ==> (var ref#10 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
                                BlockCache.__default.PageInNodeReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#10)))
                             && (!Lit(BlockCache.Step.PageInNodeReqStep_q(Lit(step#0)))
                               ==> (Lit(BlockCache.Step.PageInNodeRespStep_q(Lit(step#0)))
                                   ==> BlockCache.__default.PageInNodeResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                 && (!Lit(BlockCache.Step.PageInNodeRespStep_q(Lit(step#0)))
                                   ==> (Lit(BlockCache.Step.PageInIndirectionTableReqStep_q(Lit(step#0)))
                                       ==> BlockCache.__default.PageInIndirectionTableReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                     && (!Lit(BlockCache.Step.PageInIndirectionTableReqStep_q(Lit(step#0)))
                                       ==> (Lit(BlockCache.Step.PageInIndirectionTableRespStep_q(Lit(step#0)))
                                           ==> BlockCache.__default.PageInIndirectionTableResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                         && (!Lit(BlockCache.Step.PageInIndirectionTableRespStep_q(Lit(step#0)))
                                           ==> (Lit(BlockCache.Step.ReceiveLocStep_q(Lit(step#0)))
                                               ==> BlockCache.__default.ReceiveLoc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                             && (!Lit(BlockCache.Step.ReceiveLocStep_q(Lit(step#0)))
                                               ==> (Lit(BlockCache.Step.EvictStep_q(Lit(step#0)))
                                                   ==> (var ref#11 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
                                                    BlockCache.__default.Evict#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#11)))
                                                 && (!Lit(BlockCache.Step.EvictStep_q(Lit(step#0)))
                                                   ==> (Lit(BlockCache.Step.FreezeStep_q(Lit(step#0)))
                                                       ==> BlockCache.__default.Freeze#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                     && (!Lit(BlockCache.Step.FreezeStep_q(Lit(step#0)))
                                                       ==> (Lit(BlockCache.Step.CleanUpStep_q(Lit(step#0)))
                                                           ==> BlockCache.__default.CleanUp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                         && (!Lit(BlockCache.Step.CleanUpStep_q(Lit(step#0)))
                                                           ==> (Lit(BlockCache.Step.NoOpStep_q(Lit(step#0)))
                                                               ==> BlockCache.__default.NoOp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                             && (!Lit(BlockCache.Step.NoOpStep_q(Lit(step#0)))
                                                               ==> (var ops#2 := Lit(BlockCache.Step.ops(Lit(step#0))); 
                                                                BlockCache.__default.Transaction#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ops#2))))))))))))))))
         && BlockCache.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(step#0))
           == (if BlockCache.Step.WriteBackNodeReqStep_q(Lit(step#0))
             then (var ref#12 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
              Lit(BlockCache.__default.WriteBackNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#12)))
             else (if BlockCache.Step.WriteBackNodeRespStep_q(Lit(step#0))
               then BlockCache.__default.WriteBackNodeResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
               else (if BlockCache.Step.WriteBackIndirectionTableReqStep_q(Lit(step#0))
                 then BlockCache.__default.WriteBackIndirectionTableReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                 else (if BlockCache.Step.WriteBackIndirectionTableRespStep_q(Lit(step#0))
                   then BlockCache.__default.WriteBackIndirectionTableResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                   else (if BlockCache.Step.UnallocStep_q(Lit(step#0))
                     then (var ref#13 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
                      Lit(BlockCache.__default.Unalloc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#13)))
                     else (if BlockCache.Step.PageInNodeReqStep_q(Lit(step#0))
                       then (var ref#14 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
                        Lit(BlockCache.__default.PageInNodeReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#14)))
                       else (if BlockCache.Step.PageInNodeRespStep_q(Lit(step#0))
                         then BlockCache.__default.PageInNodeResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                         else (if BlockCache.Step.PageInIndirectionTableReqStep_q(Lit(step#0))
                           then BlockCache.__default.PageInIndirectionTableReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                           else (if BlockCache.Step.PageInIndirectionTableRespStep_q(Lit(step#0))
                             then BlockCache.__default.PageInIndirectionTableResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                             else (if BlockCache.Step.ReceiveLocStep_q(Lit(step#0))
                               then BlockCache.__default.ReceiveLoc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                               else (if BlockCache.Step.EvictStep_q(Lit(step#0))
                                 then (var ref#15 := LitInt(BlockCache.Step.ref(Lit(step#0))); 
                                  Lit(BlockCache.__default.Evict(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ref#15)))
                                 else (if BlockCache.Step.FreezeStep_q(Lit(step#0))
                                   then BlockCache.__default.Freeze(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                   else (if BlockCache.Step.CleanUpStep_q(Lit(step#0))
                                     then BlockCache.__default.CleanUp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                     else (if BlockCache.Step.NoOpStep_q(Lit(step#0))
                                       then BlockCache.__default.NoOp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                       else (var ops#3 := Lit(BlockCache.Step.ops(Lit(step#0))); 
                                        Lit(BlockCache.__default.Transaction(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), ops#3))))))))))))))))));

// function declaration for BlockCache._default.Next
function BlockCache.__default.Next(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function BlockCache.__default.Next#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for BlockCache.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.Next(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.Next#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function BlockCache.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.Next
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { BlockCache.__default.Next#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(dop#0, Tclass.BlockDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> BlockCache.__default.Next#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for BlockCache.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { BlockCache.__default.Next(k#0, s#0, s'#0, dop#0, vop#0) } 
    BlockCache.__default.Next#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (forall step#0: DatatypeType :: 
          { BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
          $Is(step#0, Tclass.BlockCache.Step())
             ==> BlockCache.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, vop#0, step#0))
         && BlockCache.__default.Next(k#0, s#0, s'#0, dop#0, vop#0)
           == (exists step#0: DatatypeType :: 
            { BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
            $Is(step#0, Tclass.BlockCache.Step())
               && BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0)));

// definition axiom for BlockCache.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    BlockCache.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(dop#0, Tclass.BlockDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (forall step#1: DatatypeType :: 
          { BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#1) } 
          $Is(step#1, Tclass.BlockCache.Step())
             ==> BlockCache.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), step#1))
         && BlockCache.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (exists step#1: DatatypeType :: 
            { BlockCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#1) } 
            $Is(step#1, Tclass.BlockCache.Step())
               && BlockCache.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), step#1)));

// function declaration for BlockCache._default.CacheConsistentWithSuccessors
function BlockCache.__default.CacheConsistentWithSuccessors(cache#0: Map Box Box, graph#0: Map Box Box) : bool;

function BlockCache.__default.CacheConsistentWithSuccessors#canCall(cache#0: Map Box Box, graph#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.CacheConsistentWithSuccessors
axiom true
   ==> (forall cache#0: Map Box Box, graph#0: Map Box Box :: 
    { BlockCache.__default.CacheConsistentWithSuccessors(cache#0, graph#0) } 
    BlockCache.__default.CacheConsistentWithSuccessors#canCall(cache#0, graph#0)
         || ($Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> true);

function BlockCache.__default.CacheConsistentWithSuccessors#requires(Map Box Box, Map Box Box) : bool;

// #requires axiom for BlockCache.__default.CacheConsistentWithSuccessors
axiom (forall cache#0: Map Box Box, graph#0: Map Box Box :: 
  { BlockCache.__default.CacheConsistentWithSuccessors#requires(cache#0, graph#0) } 
  $Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
       && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
     ==> BlockCache.__default.CacheConsistentWithSuccessors#requires(cache#0, graph#0)
       == true);

// definition axiom for BlockCache.__default.CacheConsistentWithSuccessors(revealed)
axiom true
   ==> (forall cache#0: Map Box Box, graph#0: Map Box Box :: 
    { BlockCache.__default.CacheConsistentWithSuccessors(cache#0, graph#0) } 
    BlockCache.__default.CacheConsistentWithSuccessors#canCall(cache#0, graph#0)
         || ($Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(cache#0)[$Box(ref#0)]): DatatypeType } 
            { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(ref#0)] } 
            { Map#Domain(cache#0)[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            Map#Domain(cache#0)[$Box(ref#0)] && Map#Domain(graph#0)[$Box(ref#0)]
             ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(Map#Elements(cache#0)[$Box(ref#0)]): DatatypeType))
         && BlockCache.__default.CacheConsistentWithSuccessors(cache#0, graph#0)
           == (forall ref#0: int :: 
            { $Unbox(Map#Elements(cache#0)[$Box(ref#0)]): DatatypeType } 
              { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
              { Map#Domain(graph#0)[$Box(ref#0)] } 
              { Map#Domain(cache#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && 
                Map#Domain(cache#0)[$Box(ref#0)]
                 && Map#Domain(graph#0)[$Box(ref#0)]
               ==> ISet#Equal((lambda $y#0: Box :: 
                  $IsBox($y#0, Tclass.NativeTypes.uint64())
                     && Seq#Contains($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box, $y#0)), 
                PivotBetreeGraph.__default.Successors($Unbox(Map#Elements(cache#0)[$Box(ref#0)]): DatatypeType))));

// definition axiom for BlockCache.__default.CacheConsistentWithSuccessors for all literals(revealed)
axiom true
   ==> (forall cache#0: Map Box Box, graph#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.CacheConsistentWithSuccessors(Lit(cache#0), Lit(graph#0)) } 
    BlockCache.__default.CacheConsistentWithSuccessors#canCall(Lit(cache#0), Lit(graph#0))
         || ($Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> (forall ref#1: int :: 
          { $Unbox(Map#Elements(cache#0)[$Box(ref#1)]): DatatypeType } 
            { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
            { Map#Domain(graph#0)[$Box(ref#1)] } 
            { Map#Domain(cache#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            Map#Domain(cache#0)[$Box(ref#1)] && Map#Domain(graph#0)[$Box(ref#1)]
             ==> PivotBetreeGraph.__default.Successors#canCall($Unbox(Map#Elements(Lit(cache#0))[$Box(ref#1)]): DatatypeType))
         && BlockCache.__default.CacheConsistentWithSuccessors(Lit(cache#0), Lit(graph#0))
           == (forall ref#1: int :: 
            { $Unbox(Map#Elements(cache#0)[$Box(ref#1)]): DatatypeType } 
              { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
              { Map#Domain(graph#0)[$Box(ref#1)] } 
              { Map#Domain(cache#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && 
                Map#Domain(cache#0)[$Box(ref#1)]
                 && Map#Domain(graph#0)[$Box(ref#1)]
               ==> ISet#Equal((lambda $y#1: Box :: 
                  $IsBox($y#1, Tclass.NativeTypes.uint64())
                     && Seq#Contains($Unbox(Map#Elements(Lit(graph#0))[$Box(ref#1)]): Seq Box, $y#1)), 
                PivotBetreeGraph.__default.Successors($Unbox(Map#Elements(Lit(cache#0))[$Box(ref#1)]): DatatypeType))));

// function declaration for BlockCache._default.IndirectionTableCacheConsistent
function BlockCache.__default.IndirectionTableCacheConsistent(indirectionTable#0: DatatypeType, cache#0: Map Box Box) : bool;

function BlockCache.__default.IndirectionTableCacheConsistent#canCall(indirectionTable#0: DatatypeType, cache#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.IndirectionTableCacheConsistent
axiom true
   ==> (forall indirectionTable#0: DatatypeType, cache#0: Map Box Box :: 
    { BlockCache.__default.IndirectionTableCacheConsistent(indirectionTable#0, cache#0) } 
    BlockCache.__default.IndirectionTableCacheConsistent#canCall(indirectionTable#0, cache#0)
         || ($Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && $Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())))
       ==> true);

function BlockCache.__default.IndirectionTableCacheConsistent#requires(DatatypeType, Map Box Box) : bool;

// #requires axiom for BlockCache.__default.IndirectionTableCacheConsistent
axiom (forall indirectionTable#0: DatatypeType, cache#0: Map Box Box :: 
  { BlockCache.__default.IndirectionTableCacheConsistent#requires(indirectionTable#0, cache#0) } 
  $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       && $Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node()))
     ==> BlockCache.__default.IndirectionTableCacheConsistent#requires(indirectionTable#0, cache#0)
       == true);

// definition axiom for BlockCache.__default.IndirectionTableCacheConsistent(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, cache#0: Map Box Box :: 
    { BlockCache.__default.IndirectionTableCacheConsistent(indirectionTable#0, cache#0) } 
    BlockCache.__default.IndirectionTableCacheConsistent#canCall(indirectionTable#0, cache#0)
         || ($Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && $Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())))
       ==> (Lit(true)
           ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
             && SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
         && BlockCache.__default.IndirectionTableCacheConsistent(indirectionTable#0, cache#0)
           == (true
             && Set#Subset(Map#Domain(SectorType.IndirectionTable.graph(indirectionTable#0)), 
              Set#Union(Map#Domain(cache#0), 
                Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))))));

// definition axiom for BlockCache.__default.IndirectionTableCacheConsistent for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, cache#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.IndirectionTableCacheConsistent(Lit(indirectionTable#0), Lit(cache#0)) } 
    BlockCache.__default.IndirectionTableCacheConsistent#canCall(Lit(indirectionTable#0), Lit(cache#0))
         || ($Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && $Is(cache#0, TMap(Tclass.NativeTypes.uint64(), Tclass.PivotBetreeGraph.Node())))
       ==> (Lit(true)
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
             && SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
         && BlockCache.__default.IndirectionTableCacheConsistent(Lit(indirectionTable#0), Lit(cache#0))
           == (true
             && Set#Subset(Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(indirectionTable#0)))), 
              Set#Union(Map#Domain(Lit(cache#0)), 
                Map#Domain(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))))));

// function declaration for BlockCache._default.EphemeralTableEntriesInCacheOrNotBeingWritten
function BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(k#0: DatatypeType, s#0: DatatypeType) : bool;

function BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(k#0, s#0) } 
    BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && 
          BlockCache.Variables.Ready_q(s#0)
           && BlockCache.__default.IndirectionTableCacheConsistent(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
            BlockCache.Variables.cache(s#0)))
       ==> true);

function BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#requires(k#0, s#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
     ==> BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#requires(k#0, s#0)
       == (BlockCache.Variables.Ready_q(s#0)
         && BlockCache.__default.IndirectionTableCacheConsistent(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
          BlockCache.Variables.cache(s#0))));

// definition axiom for BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(k#0, s#0) } 
    BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && 
          BlockCache.Variables.Ready_q(s#0)
           && BlockCache.__default.IndirectionTableCacheConsistent(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
            BlockCache.Variables.cache(s#0)))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)] } 
            { Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
               && (Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
                 ==> 
                !Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
                 ==> (forall id#0: int :: 
                  { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType } 
                    { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)] } 
                  LitInt(0) <= id#0 && id#0 < 18446744073709551616
                     ==> 
                    Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]
                     ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)
                       && (BlockCache.OutstandingWrite.ref($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)
                           == ref#0
                         ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)
                           && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType))
                           && 
                          SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
                           && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType)))))
         && BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(k#0, s#0)
           == (forall ref#0: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)] } 
              { Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]
               ==> 
              !Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#0)]
               ==> (forall id#0: int :: 
                { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType } 
                  { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)] } 
                LitInt(0) <= id#0
                     && id#0 < 18446744073709551616
                     && Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]
                   ==> BlockCache.OutstandingWrite.ref($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)
                       != ref#0
                     || DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType))
                       != DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#0)]): DatatypeType))));

// definition axiom for BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(Lit(k#0), Lit(s#0)) } 
    BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(Lit(k#0), Lit(s#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && 
          Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           && Lit(BlockCache.__default.IndirectionTableCacheConsistent(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              Lit(BlockCache.Variables.cache(Lit(s#0))))))
       ==> (forall ref#1: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType } 
            { Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#1)] } 
            { Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
               && (Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#1)]
                 ==> 
                !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#1)]
                 ==> (forall id#1: int :: 
                  { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)]): DatatypeType } 
                    { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)] } 
                  LitInt(0) <= id#1 && id#1 < 18446744073709551616
                     ==> 
                    Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(id#1)]
                     ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)
                       && (BlockCache.OutstandingWrite.ref($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)
                           == ref#1
                         ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)
                           && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType))
                           && 
                          SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
                           && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#1)]): DatatypeType)))))
         && BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(Lit(k#0), Lit(s#0))
           == (forall ref#1: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(BlockCache.Variables.cache(s#0))[$Box(ref#1)] } 
              { Map#Domain(SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))[$Box(ref#1)]
               ==> 
              !Map#Domain(BlockCache.Variables.cache(Lit(s#0)))[$Box(ref#1)]
               ==> (forall id#1: int :: 
                { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)]): DatatypeType } 
                  { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)] } 
                LitInt(0) <= id#1
                     && id#1 < 18446744073709551616
                     && Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(id#1)]
                   ==> BlockCache.OutstandingWrite.ref($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)
                       != ref#1
                     || DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType))
                       != DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))[$Box(ref#1)]): DatatypeType))));

// function declaration for BlockCache._default.OutstandingReadRefsUnique
function BlockCache.__default.OutstandingReadRefsUnique(outstandingBlockReads#0: Map Box Box) : bool;

function BlockCache.__default.OutstandingReadRefsUnique#canCall(outstandingBlockReads#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.OutstandingReadRefsUnique
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box :: 
    { BlockCache.__default.OutstandingReadRefsUnique(outstandingBlockReads#0) } 
    BlockCache.__default.OutstandingReadRefsUnique#canCall(outstandingBlockReads#0)
         || $Is(outstandingBlockReads#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
       ==> true);

function BlockCache.__default.OutstandingReadRefsUnique#requires(Map Box Box) : bool;

// #requires axiom for BlockCache.__default.OutstandingReadRefsUnique
axiom (forall outstandingBlockReads#0: Map Box Box :: 
  { BlockCache.__default.OutstandingReadRefsUnique#requires(outstandingBlockReads#0) } 
  $Is(outstandingBlockReads#0, 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
     ==> BlockCache.__default.OutstandingReadRefsUnique#requires(outstandingBlockReads#0)
       == true);

// definition axiom for BlockCache.__default.OutstandingReadRefsUnique(revealed)
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box :: 
    { BlockCache.__default.OutstandingReadRefsUnique(outstandingBlockReads#0) } 
    BlockCache.__default.OutstandingReadRefsUnique#canCall(outstandingBlockReads#0)
         || $Is(outstandingBlockReads#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
       ==> (forall id1#0: int, id2#0: int :: 
          { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#0)]): DatatypeType, $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#0)]): DatatypeType } 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#0)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id1#0)] } 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#0)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id2#0)] } 
            { Map#Domain(outstandingBlockReads#0)[$Box(id2#0)], Map#Domain(outstandingBlockReads#0)[$Box(id1#0)] } 
          LitInt(0) <= id1#0
               && id1#0 < 18446744073709551616
               && 
              LitInt(0) <= id2#0
               && id2#0 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockReads#0)[$Box(id2#0)]
             ==> $IsA#BlockCache.OutstandingRead($Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#0)]): DatatypeType)
               && $IsA#BlockCache.OutstandingRead($Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#0)]): DatatypeType))
         && BlockCache.__default.OutstandingReadRefsUnique(outstandingBlockReads#0)
           == (forall id1#0: int, id2#0: int :: 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#0)]): DatatypeType, $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#0)]): DatatypeType } 
              { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#0)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id1#0)] } 
              { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#0)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id2#0)] } 
              { Map#Domain(outstandingBlockReads#0)[$Box(id2#0)], Map#Domain(outstandingBlockReads#0)[$Box(id1#0)] } 
            LitInt(0) <= id1#0
                 && id1#0 < 18446744073709551616
                 && 
                LitInt(0) <= id2#0
                 && id2#0 < 18446744073709551616
                 && 
                Map#Domain(outstandingBlockReads#0)[$Box(id1#0)]
                 && Map#Domain(outstandingBlockReads#0)[$Box(id2#0)]
                 && BlockCache.OutstandingRead#Equal($Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#0)]): DatatypeType, 
                  $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#0)]): DatatypeType)
               ==> id1#0 == id2#0));

// definition axiom for BlockCache.__default.OutstandingReadRefsUnique for all literals(revealed)
axiom true
   ==> (forall outstandingBlockReads#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.OutstandingReadRefsUnique(Lit(outstandingBlockReads#0)) } 
    BlockCache.__default.OutstandingReadRefsUnique#canCall(Lit(outstandingBlockReads#0))
         || $Is(outstandingBlockReads#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingRead()))
       ==> (forall id1#1: int, id2#1: int :: 
          { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#1)]): DatatypeType, $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#1)]): DatatypeType } 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#1)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id1#1)] } 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#1)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id2#1)] } 
            { Map#Domain(outstandingBlockReads#0)[$Box(id2#1)], Map#Domain(outstandingBlockReads#0)[$Box(id1#1)] } 
          LitInt(0) <= id1#1
               && id1#1 < 18446744073709551616
               && 
              LitInt(0) <= id2#1
               && id2#1 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockReads#0)[$Box(id2#1)]
             ==> $IsA#BlockCache.OutstandingRead($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(id1#1)]): DatatypeType)
               && $IsA#BlockCache.OutstandingRead($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(id2#1)]): DatatypeType))
         && BlockCache.__default.OutstandingReadRefsUnique(Lit(outstandingBlockReads#0))
           == (forall id1#1: int, id2#1: int :: 
            { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#1)]): DatatypeType, $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#1)]): DatatypeType } 
              { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id2#1)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id1#1)] } 
              { $Unbox(Map#Elements(outstandingBlockReads#0)[$Box(id1#1)]): DatatypeType, Map#Domain(outstandingBlockReads#0)[$Box(id2#1)] } 
              { Map#Domain(outstandingBlockReads#0)[$Box(id2#1)], Map#Domain(outstandingBlockReads#0)[$Box(id1#1)] } 
            LitInt(0) <= id1#1
                 && id1#1 < 18446744073709551616
                 && 
                LitInt(0) <= id2#1
                 && id2#1 < 18446744073709551616
                 && 
                Map#Domain(outstandingBlockReads#0)[$Box(id1#1)]
                 && Map#Domain(outstandingBlockReads#0)[$Box(id2#1)]
                 && BlockCache.OutstandingRead#Equal($Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(id1#1)]): DatatypeType, 
                  $Unbox(Map#Elements(Lit(outstandingBlockReads#0))[$Box(id2#1)]): DatatypeType)
               ==> id1#1 == id2#1));

// function declaration for BlockCache._default.OverlappingImpliesEq
function BlockCache.__default.OverlappingImpliesEq(loc1#0: DatatypeType, loc2#0: DatatypeType) : bool;

function BlockCache.__default.OverlappingImpliesEq#canCall(loc1#0: DatatypeType, loc2#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.OverlappingImpliesEq
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    { BlockCache.__default.OverlappingImpliesEq(loc1#0, loc2#0) } 
    BlockCache.__default.OverlappingImpliesEq#canCall(loc1#0, loc2#0)
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> true);

function BlockCache.__default.OverlappingImpliesEq#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.OverlappingImpliesEq
axiom (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
  { BlockCache.__default.OverlappingImpliesEq#requires(loc1#0, loc2#0) } 
  $Is(loc1#0, Tclass.DiskLayout.Location())
       && $Is(loc2#0, Tclass.DiskLayout.Location())
     ==> BlockCache.__default.OverlappingImpliesEq#requires(loc1#0, loc2#0) == true);

// definition axiom for BlockCache.__default.OverlappingImpliesEq(revealed)
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    { BlockCache.__default.OverlappingImpliesEq(loc1#0, loc2#0) } 
    BlockCache.__default.OverlappingImpliesEq#canCall(loc1#0, loc2#0)
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(loc1#0)
         && DiskLayout.Location.Location_q(loc2#0)
         && (DiskLayout.Location.addr(loc1#0) == DiskLayout.Location.addr(loc2#0)
           ==> $IsA#DiskLayout.Location(loc1#0) && $IsA#DiskLayout.Location(loc2#0))
         && BlockCache.__default.OverlappingImpliesEq(loc1#0, loc2#0)
           == (DiskLayout.Location.addr(loc1#0) == DiskLayout.Location.addr(loc2#0)
             ==> DiskLayout.Location#Equal(loc1#0, loc2#0)));

// definition axiom for BlockCache.__default.OverlappingImpliesEq for all literals(revealed)
axiom true
   ==> (forall loc1#0: DatatypeType, loc2#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.OverlappingImpliesEq(Lit(loc1#0), Lit(loc2#0)) } 
    BlockCache.__default.OverlappingImpliesEq#canCall(Lit(loc1#0), Lit(loc2#0))
         || ($Is(loc1#0, Tclass.DiskLayout.Location())
           && $Is(loc2#0, Tclass.DiskLayout.Location()))
       ==> DiskLayout.Location.Location_q(Lit(loc1#0))
         && DiskLayout.Location.Location_q(Lit(loc2#0))
         && (LitInt(DiskLayout.Location.addr(Lit(loc1#0)))
             == LitInt(DiskLayout.Location.addr(Lit(loc2#0)))
           ==> $IsA#DiskLayout.Location(Lit(loc1#0)) && $IsA#DiskLayout.Location(Lit(loc2#0)))
         && BlockCache.__default.OverlappingImpliesEq(Lit(loc1#0), Lit(loc2#0))
           == (LitInt(DiskLayout.Location.addr(Lit(loc1#0)))
               == LitInt(DiskLayout.Location.addr(Lit(loc2#0)))
             ==> DiskLayout.Location#Equal(loc1#0, loc2#0)));

// function declaration for BlockCache._default.OverlappingWritesEqForIndirectionTable
function BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0: DatatypeType, s#0: DatatypeType, indirectionTable#0: DatatypeType) : bool;

function BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0: DatatypeType, s#0: DatatypeType, indirectionTable#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.OverlappingWritesEqForIndirectionTable
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, indirectionTable#0) } 
    BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, s#0, indirectionTable#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && BlockCache.Variables.Ready_q(s#0))
       ==> true);

function BlockCache.__default.OverlappingWritesEqForIndirectionTable#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.OverlappingWritesEqForIndirectionTable
axiom (forall k#0: DatatypeType, s#0: DatatypeType, indirectionTable#0: DatatypeType :: 
  { BlockCache.__default.OverlappingWritesEqForIndirectionTable#requires(k#0, s#0, indirectionTable#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
     ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#requires(k#0, s#0, indirectionTable#0)
       == BlockCache.Variables.Ready_q(s#0));

// definition axiom for BlockCache.__default.OverlappingWritesEqForIndirectionTable(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, indirectionTable#0) } 
    BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, s#0, indirectionTable#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && BlockCache.Variables.Ready_q(s#0))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
               && (Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
                 ==> (forall id#0: int :: 
                  { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType } 
                    { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)] } 
                  LitInt(0) <= id#0 && id#0 < 18446744073709551616
                     ==> 
                    Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]
                     ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                       && BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)
                       && BlockCache.__default.OverlappingImpliesEq#canCall($Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType, 
                        BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)))))
         && BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, indirectionTable#0)
           == (forall ref#0: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
               ==> (forall id#0: int :: 
                { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType } 
                  { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)] } 
                LitInt(0) <= id#0
                     && id#0 < 18446744073709551616
                     && Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]
                   ==> BlockCache.__default.OverlappingImpliesEq($Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType, 
                    BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#0)]): DatatypeType)))));

// definition axiom for BlockCache.__default.OverlappingWritesEqForIndirectionTable for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, indirectionTable#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), Lit(s#0), Lit(indirectionTable#0)) } 
    BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(Lit(k#0), Lit(s#0), Lit(indirectionTable#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && Lit(BlockCache.Variables.Ready_q(Lit(s#0))))
       ==> (forall ref#1: int :: 
          { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)]): DatatypeType } 
            { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
               && (Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#1)]
                 ==> (forall id#1: int :: 
                  { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)]): DatatypeType } 
                    { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)] } 
                  LitInt(0) <= id#1 && id#1 < 18446744073709551616
                     ==> 
                    Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(id#1)]
                     ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                       && BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)
                       && BlockCache.__default.OverlappingImpliesEq#canCall($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(ref#1)]): DatatypeType, 
                        BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)))))
         && BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), Lit(s#0), Lit(indirectionTable#0))
           == (forall ref#1: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#1)]
               ==> (forall id#1: int :: 
                { $Unbox(Map#Elements(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)]): DatatypeType } 
                  { Map#Domain(BlockCache.Variables.outstandingBlockWrites(s#0))[$Box(id#1)] } 
                LitInt(0) <= id#1
                     && id#1 < 18446744073709551616
                     && Map#Domain(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))[$Box(id#1)]
                   ==> BlockCache.__default.OverlappingImpliesEq($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(ref#1)]): DatatypeType, 
                    BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))[$Box(id#1)]): DatatypeType)))));

// function declaration for BlockCache._default.LocationsForDifferentRefsDontOverlap
function BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0: DatatypeType, r1#0: int, r2#0: int) : bool;

function BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0: DatatypeType, r1#0: int, r2#0: int) : bool;

// consequence axiom for BlockCache.__default.LocationsForDifferentRefsDontOverlap
axiom true
   ==> (forall indirectionTable#0: DatatypeType, r1#0: int, r2#0: int :: 
    { BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#0, r2#0) } 
    BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0, r1#0, r2#0)
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= r1#0
           && r1#0 < 18446744073709551616
           && 
          LitInt(0) <= r2#0
           && r2#0 < 18446744073709551616
           && 
          Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]
           && Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)])
       ==> true);

function BlockCache.__default.LocationsForDifferentRefsDontOverlap#requires(DatatypeType, int, int) : bool;

// #requires axiom for BlockCache.__default.LocationsForDifferentRefsDontOverlap
axiom (forall indirectionTable#0: DatatypeType, r1#0: int, r2#0: int :: 
  { BlockCache.__default.LocationsForDifferentRefsDontOverlap#requires(indirectionTable#0, r1#0, r2#0) } 
  $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       && 
      LitInt(0) <= r1#0
       && r1#0 < 18446744073709551616
       && 
      LitInt(0) <= r2#0
       && r2#0 < 18446744073709551616
     ==> BlockCache.__default.LocationsForDifferentRefsDontOverlap#requires(indirectionTable#0, r1#0, r2#0)
       == (Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]
         && Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)]));

// definition axiom for BlockCache.__default.LocationsForDifferentRefsDontOverlap(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, r1#0: int, r2#0: int :: 
    { BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#0, r2#0) } 
    BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0, r1#0, r2#0)
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= r1#0
           && r1#0 < 18446744073709551616
           && 
          LitInt(0) <= r2#0
           && r2#0 < 18446744073709551616
           && 
          Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]
           && Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)])
       ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
         && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]): DatatypeType)
         && 
        SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
         && DiskLayout.Location.Location_q($Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)]): DatatypeType)
         && BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#0, r2#0)
           == (DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]): DatatypeType)
               == DiskLayout.Location.addr($Unbox(Map#Elements(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)]): DatatypeType)
             ==> r1#0 == r2#0));

// definition axiom for BlockCache.__default.LocationsForDifferentRefsDontOverlap for decreasing-related literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, r1#0: int, r2#0: int :: 
    {:weight 3} { BlockCache.__default.LocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0), r1#0, r2#0) } 
    BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(Lit(indirectionTable#0), r1#0, r2#0)
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= r1#0
           && r1#0 < 18446744073709551616
           && 
          LitInt(0) <= r2#0
           && r2#0 < 18446744073709551616
           && 
          Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r1#0)]
           && Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r2#0)])
       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(r1#0)]): DatatypeType)
         && 
        SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(r2#0)]): DatatypeType)
         && BlockCache.__default.LocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0), r1#0, r2#0)
           == (DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(r1#0)]): DatatypeType)
               == DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(r2#0)]): DatatypeType)
             ==> r1#0 == r2#0));

// definition axiom for BlockCache.__default.LocationsForDifferentRefsDontOverlap for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, r1#0: int, r2#0: int :: 
    {:weight 3} { BlockCache.__default.LocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0), LitInt(r1#0), LitInt(r2#0)) } 
    BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(Lit(indirectionTable#0), LitInt(r1#0), LitInt(r2#0))
         || (
          $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
           && 
          LitInt(0) <= r1#0
           && r1#0 < 18446744073709551616
           && 
          LitInt(0) <= r2#0
           && r2#0 < 18446744073709551616
           && 
          Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r1#0)]
           && Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r2#0)])
       ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(LitInt(r1#0))]): DatatypeType)
         && 
        SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
         && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(LitInt(r2#0))]): DatatypeType)
         && BlockCache.__default.LocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0), LitInt(r1#0), LitInt(r2#0))
           == (DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(LitInt(r1#0))]): DatatypeType)
               == DiskLayout.Location.addr($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(LitInt(r2#0))]): DatatypeType)
             ==> LitInt(r1#0) == LitInt(r2#0)));

// function declaration for BlockCache._default.AllLocationsForDifferentRefsDontOverlap
function BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(indirectionTable#0: DatatypeType) : bool;

function BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.AllLocationsForDifferentRefsDontOverlap
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(indirectionTable#0) } 
    BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0)
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> true);

function BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#requires(DatatypeType) : bool;

// #requires axiom for BlockCache.__default.AllLocationsForDifferentRefsDontOverlap
axiom (forall indirectionTable#0: DatatypeType :: 
  { BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#requires(indirectionTable#0) } 
  $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
     ==> BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#requires(indirectionTable#0)
       == true);

// definition axiom for BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    { BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(indirectionTable#0) } 
    BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0)
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> (forall r1#0: int, r2#0: int :: 
          { BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#0, r2#0) } 
            { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)], Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)] } 
          LitInt(0) <= r1#0
               && r1#0 < 18446744073709551616
               && 
              LitInt(0) <= r2#0
               && r2#0 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0)
               && (Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]
                 ==> SectorType.IndirectionTable.IndirectionTable_q(indirectionTable#0))
               && (Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]
                   && Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)]
                 ==> BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(indirectionTable#0, r1#0, r2#0)))
         && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(indirectionTable#0)
           == (forall r1#0: int, r2#0: int :: 
            { BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#0, r2#0) } 
              { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)], Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)] } 
            LitInt(0) <= r1#0
                 && r1#0 < 18446744073709551616
                 && 
                LitInt(0) <= r2#0
                 && r2#0 < 18446744073709551616
                 && 
                Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#0)]
                 && Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#0)]
               ==> BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#0, r2#0)));

// definition axiom for BlockCache.__default.AllLocationsForDifferentRefsDontOverlap for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0)) } 
    BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(Lit(indirectionTable#0))
         || $Is(indirectionTable#0, Tclass.SectorType.IndirectionTable())
       ==> (forall r1#1: int, r2#1: int :: 
          { BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#1, r2#1) } 
            { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#1)], Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#1)] } 
          LitInt(0) <= r1#1
               && r1#1 < 18446744073709551616
               && 
              LitInt(0) <= r2#1
               && r2#1 < 18446744073709551616
             ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
               && (Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r1#1)]
                 ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0)))
               && (Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r1#1)]
                   && Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r2#1)]
                 ==> BlockCache.__default.LocationsForDifferentRefsDontOverlap#canCall(Lit(indirectionTable#0), r1#1, r2#1)))
         && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0))
           == (forall r1#1: int, r2#1: int :: 
            { BlockCache.__default.LocationsForDifferentRefsDontOverlap(indirectionTable#0, r1#1, r2#1) } 
              { Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r2#1)], Map#Domain(SectorType.IndirectionTable.locs(indirectionTable#0))[$Box(r1#1)] } 
            LitInt(0) <= r1#1
                 && r1#1 < 18446744073709551616
                 && 
                LitInt(0) <= r2#1
                 && r2#1 < 18446744073709551616
                 && 
                Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r1#1)]
                 && Map#Domain(SectorType.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(r2#1)]
               ==> BlockCache.__default.LocationsForDifferentRefsDontOverlap(Lit(indirectionTable#0), r1#1, r2#1)));

// function declaration for BlockCache._default.OutstandingWriteValidNodeLocation
function BlockCache.__default.OutstandingWriteValidNodeLocation(outstandingBlockWrites#0: Map Box Box) : bool;

function BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(outstandingBlockWrites#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.OutstandingWriteValidNodeLocation
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box :: 
    { BlockCache.__default.OutstandingWriteValidNodeLocation(outstandingBlockWrites#0) } 
    BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(outstandingBlockWrites#0)
         || $Is(outstandingBlockWrites#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       ==> true);

function BlockCache.__default.OutstandingWriteValidNodeLocation#requires(Map Box Box) : bool;

// #requires axiom for BlockCache.__default.OutstandingWriteValidNodeLocation
axiom (forall outstandingBlockWrites#0: Map Box Box :: 
  { BlockCache.__default.OutstandingWriteValidNodeLocation#requires(outstandingBlockWrites#0) } 
  $Is(outstandingBlockWrites#0, 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
     ==> BlockCache.__default.OutstandingWriteValidNodeLocation#requires(outstandingBlockWrites#0)
       == true);

// definition axiom for BlockCache.__default.OutstandingWriteValidNodeLocation(revealed)
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box :: 
    { BlockCache.__default.OutstandingWriteValidNodeLocation(outstandingBlockWrites#0) } 
    BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(outstandingBlockWrites#0)
         || $Is(outstandingBlockWrites#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(outstandingBlockWrites#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockWrites#0)[$Box(id#0)]
             ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#0)]): DatatypeType)
               && DiskLayout.__default.ValidNodeLocation#canCall(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#0)]): DatatypeType)))
         && BlockCache.__default.OutstandingWriteValidNodeLocation(outstandingBlockWrites#0)
           == (forall id#0: int :: 
            { $Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#0)]): DatatypeType } 
              { Map#Domain(outstandingBlockWrites#0)[$Box(id#0)] } 
            LitInt(0) <= id#0
                 && id#0 < 18446744073709551616
                 && Map#Domain(outstandingBlockWrites#0)[$Box(id#0)]
               ==> DiskLayout.__default.ValidNodeLocation(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#0)]): DatatypeType))));

// definition axiom for BlockCache.__default.OutstandingWriteValidNodeLocation for all literals(revealed)
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.OutstandingWriteValidNodeLocation(Lit(outstandingBlockWrites#0)) } 
    BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(Lit(outstandingBlockWrites#0))
         || $Is(outstandingBlockWrites#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       ==> (forall id#1: int :: 
          { $Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#1)]): DatatypeType } 
            { Map#Domain(outstandingBlockWrites#0)[$Box(id#1)] } 
          LitInt(0) <= id#1 && id#1 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockWrites#0)[$Box(id#1)]
             ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(id#1)]): DatatypeType)
               && DiskLayout.__default.ValidNodeLocation#canCall(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(id#1)]): DatatypeType)))
         && BlockCache.__default.OutstandingWriteValidNodeLocation(Lit(outstandingBlockWrites#0))
           == (forall id#1: int :: 
            { $Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id#1)]): DatatypeType } 
              { Map#Domain(outstandingBlockWrites#0)[$Box(id#1)] } 
            LitInt(0) <= id#1
                 && id#1 < 18446744073709551616
                 && Map#Domain(outstandingBlockWrites#0)[$Box(id#1)]
               ==> DiskLayout.__default.ValidNodeLocation(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(id#1)]): DatatypeType))));

// function declaration for BlockCache._default.OutstandingBlockWritesDontOverlap
function BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0: Map Box Box, id1#0: int, id2#0: int) : bool;

function BlockCache.__default.OutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0: Map Box Box, id1#0: int, id2#0: int) : bool;

// consequence axiom for BlockCache.__default.OutstandingBlockWritesDontOverlap
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box, id1#0: int, id2#0: int :: 
    { BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#0, id2#0) } 
    BlockCache.__default.OutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0, id1#0, id2#0)
         || (
          $Is(outstandingBlockWrites#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
           && 
          LitInt(0) <= id1#0
           && id1#0 < 18446744073709551616
           && 
          LitInt(0) <= id2#0
           && id2#0 < 18446744073709551616
           && 
          Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)]
           && Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)])
       ==> true);

function BlockCache.__default.OutstandingBlockWritesDontOverlap#requires(Map Box Box, int, int) : bool;

// #requires axiom for BlockCache.__default.OutstandingBlockWritesDontOverlap
axiom (forall outstandingBlockWrites#0: Map Box Box, id1#0: int, id2#0: int :: 
  { BlockCache.__default.OutstandingBlockWritesDontOverlap#requires(outstandingBlockWrites#0, id1#0, id2#0) } 
  $Is(outstandingBlockWrites#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       && 
      LitInt(0) <= id1#0
       && id1#0 < 18446744073709551616
       && 
      LitInt(0) <= id2#0
       && id2#0 < 18446744073709551616
     ==> BlockCache.__default.OutstandingBlockWritesDontOverlap#requires(outstandingBlockWrites#0, id1#0, id2#0)
       == (Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)]
         && Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)]));

// definition axiom for BlockCache.__default.OutstandingBlockWritesDontOverlap(revealed)
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box, id1#0: int, id2#0: int :: 
    { BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#0, id2#0) } 
    BlockCache.__default.OutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0, id1#0, id2#0)
         || (
          $Is(outstandingBlockWrites#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
           && 
          LitInt(0) <= id1#0
           && id1#0 < 18446744073709551616
           && 
          LitInt(0) <= id2#0
           && id2#0 < 18446744073709551616
           && 
          Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)]
           && Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)])
       ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id1#0)]): DatatypeType)
         && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id1#0)]): DatatypeType))
         && 
        BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id2#0)]): DatatypeType)
         && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id2#0)]): DatatypeType))
         && BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#0, id2#0)
           == (DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id1#0)]): DatatypeType))
               == DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(outstandingBlockWrites#0)[$Box(id2#0)]): DatatypeType))
             ==> id1#0 == id2#0));

// definition axiom for BlockCache.__default.OutstandingBlockWritesDontOverlap for all literals(revealed)
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box, id1#0: int, id2#0: int :: 
    {:weight 3} { BlockCache.__default.OutstandingBlockWritesDontOverlap(Lit(outstandingBlockWrites#0), LitInt(id1#0), LitInt(id2#0)) } 
    BlockCache.__default.OutstandingBlockWritesDontOverlap#canCall(Lit(outstandingBlockWrites#0), LitInt(id1#0), LitInt(id2#0))
         || (
          $Is(outstandingBlockWrites#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
           && 
          LitInt(0) <= id1#0
           && id1#0 < 18446744073709551616
           && 
          LitInt(0) <= id2#0
           && id2#0 < 18446744073709551616
           && 
          Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)]
           && Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)])
       ==> BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(LitInt(id1#0))]): DatatypeType)
         && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(LitInt(id1#0))]): DatatypeType))
         && 
        BlockCache.OutstandingWrite.OutstandingWrite_q($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(LitInt(id2#0))]): DatatypeType)
         && DiskLayout.Location.Location_q(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(LitInt(id2#0))]): DatatypeType))
         && BlockCache.__default.OutstandingBlockWritesDontOverlap(Lit(outstandingBlockWrites#0), LitInt(id1#0), LitInt(id2#0))
           == (DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(LitInt(id1#0))]): DatatypeType))
               == DiskLayout.Location.addr(BlockCache.OutstandingWrite.loc($Unbox(Map#Elements(Lit(outstandingBlockWrites#0))[$Box(LitInt(id2#0))]): DatatypeType))
             ==> LitInt(id1#0) == LitInt(id2#0)));

// function declaration for BlockCache._default.AllOutstandingBlockWritesDontOverlap
function BlockCache.__default.AllOutstandingBlockWritesDontOverlap(outstandingBlockWrites#0: Map Box Box) : bool;

function BlockCache.__default.AllOutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0: Map Box Box) : bool;

// consequence axiom for BlockCache.__default.AllOutstandingBlockWritesDontOverlap
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box :: 
    { BlockCache.__default.AllOutstandingBlockWritesDontOverlap(outstandingBlockWrites#0) } 
    BlockCache.__default.AllOutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0)
         || $Is(outstandingBlockWrites#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       ==> true);

function BlockCache.__default.AllOutstandingBlockWritesDontOverlap#requires(Map Box Box) : bool;

// #requires axiom for BlockCache.__default.AllOutstandingBlockWritesDontOverlap
axiom (forall outstandingBlockWrites#0: Map Box Box :: 
  { BlockCache.__default.AllOutstandingBlockWritesDontOverlap#requires(outstandingBlockWrites#0) } 
  $Is(outstandingBlockWrites#0, 
      TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
     ==> BlockCache.__default.AllOutstandingBlockWritesDontOverlap#requires(outstandingBlockWrites#0)
       == true);

// definition axiom for BlockCache.__default.AllOutstandingBlockWritesDontOverlap(revealed)
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box :: 
    { BlockCache.__default.AllOutstandingBlockWritesDontOverlap(outstandingBlockWrites#0) } 
    BlockCache.__default.AllOutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0)
         || $Is(outstandingBlockWrites#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       ==> (forall id1#0: int, id2#0: int :: 
          { BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#0, id2#0) } 
            { Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)], Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)] } 
          LitInt(0) <= id1#0
               && id1#0 < 18446744073709551616
               && 
              LitInt(0) <= id2#0
               && id2#0 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)]
               && Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)]
             ==> BlockCache.__default.OutstandingBlockWritesDontOverlap#canCall(outstandingBlockWrites#0, id1#0, id2#0))
         && BlockCache.__default.AllOutstandingBlockWritesDontOverlap(outstandingBlockWrites#0)
           == (forall id1#0: int, id2#0: int :: 
            { BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#0, id2#0) } 
              { Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)], Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)] } 
            LitInt(0) <= id1#0
                 && id1#0 < 18446744073709551616
                 && 
                LitInt(0) <= id2#0
                 && id2#0 < 18446744073709551616
                 && 
                Map#Domain(outstandingBlockWrites#0)[$Box(id1#0)]
                 && Map#Domain(outstandingBlockWrites#0)[$Box(id2#0)]
               ==> BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#0, id2#0)));

// definition axiom for BlockCache.__default.AllOutstandingBlockWritesDontOverlap for all literals(revealed)
axiom true
   ==> (forall outstandingBlockWrites#0: Map Box Box :: 
    {:weight 3} { BlockCache.__default.AllOutstandingBlockWritesDontOverlap(Lit(outstandingBlockWrites#0)) } 
    BlockCache.__default.AllOutstandingBlockWritesDontOverlap#canCall(Lit(outstandingBlockWrites#0))
         || $Is(outstandingBlockWrites#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.BlockCache.OutstandingWrite()))
       ==> (forall id1#1: int, id2#1: int :: 
          { BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#1, id2#1) } 
            { Map#Domain(outstandingBlockWrites#0)[$Box(id2#1)], Map#Domain(outstandingBlockWrites#0)[$Box(id1#1)] } 
          LitInt(0) <= id1#1
               && id1#1 < 18446744073709551616
               && 
              LitInt(0) <= id2#1
               && id2#1 < 18446744073709551616
             ==> 
            Map#Domain(outstandingBlockWrites#0)[$Box(id1#1)]
               && Map#Domain(outstandingBlockWrites#0)[$Box(id2#1)]
             ==> BlockCache.__default.OutstandingBlockWritesDontOverlap#canCall(Lit(outstandingBlockWrites#0), id1#1, id2#1))
         && BlockCache.__default.AllOutstandingBlockWritesDontOverlap(Lit(outstandingBlockWrites#0))
           == (forall id1#1: int, id2#1: int :: 
            { BlockCache.__default.OutstandingBlockWritesDontOverlap(outstandingBlockWrites#0, id1#1, id2#1) } 
              { Map#Domain(outstandingBlockWrites#0)[$Box(id2#1)], Map#Domain(outstandingBlockWrites#0)[$Box(id1#1)] } 
            LitInt(0) <= id1#1
                 && id1#1 < 18446744073709551616
                 && 
                LitInt(0) <= id2#1
                 && id2#1 < 18446744073709551616
                 && 
                Map#Domain(outstandingBlockWrites#0)[$Box(id1#1)]
                 && Map#Domain(outstandingBlockWrites#0)[$Box(id2#1)]
               ==> BlockCache.__default.OutstandingBlockWritesDontOverlap(Lit(outstandingBlockWrites#0), id1#1, id2#1)));

// function declaration for BlockCache._default.InvReady
function BlockCache.__default.InvReady(k#0: DatatypeType, s#0: DatatypeType) : bool;

function BlockCache.__default.InvReady#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.InvReady
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.InvReady(k#0, s#0) } 
    BlockCache.__default.InvReady#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && BlockCache.Variables.Ready_q(s#0))
       ==> true);

function BlockCache.__default.InvReady#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.InvReady
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { BlockCache.__default.InvReady#requires(k#0, s#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
     ==> BlockCache.__default.InvReady#requires(k#0, s#0)
       == BlockCache.Variables.Ready_q(s#0));

// definition axiom for BlockCache.__default.InvReady(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.InvReady(k#0, s#0) } 
    BlockCache.__default.InvReady#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && BlockCache.Variables.Ready_q(s#0))
       ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(BlockCache.Variables.persistentIndirectionTable(s#0))
         && (BlockCache.__default.WFCompleteIndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0))
           ==> BlockCache.__default.WFIndirectionTable#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (BlockCache.__default.WFIndirectionTable#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.WFIndirectionTable(BlockCache.Variables.ephemeralIndirectionTable(s#0))
           ==> BlockCache.__default.IndirectionTableCacheConsistent#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
            BlockCache.Variables.cache(s#0)))
         && (BlockCache.__default.IndirectionTableCacheConsistent#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
              BlockCache.Variables.cache(s#0))
             && BlockCache.__default.IndirectionTableCacheConsistent(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
              BlockCache.Variables.cache(s#0))
           ==> SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.CacheConsistentWithSuccessors#canCall(BlockCache.Variables.cache(s#0), 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0))))
         && (SectorType.IndirectionTable.IndirectionTable_q(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.CacheConsistentWithSuccessors#canCall(BlockCache.Variables.cache(s#0), 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && BlockCache.__default.CacheConsistentWithSuccessors(BlockCache.Variables.cache(s#0), 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
           ==> BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(k#0, s#0))
         && (BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(k#0, s#0)
             && BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(k#0, s#0)
           ==> BlockCache.__default.OutstandingReadRefsUnique#canCall(BlockCache.Variables.outstandingBlockReads(s#0)))
         && (BlockCache.__default.OutstandingReadRefsUnique#canCall(BlockCache.Variables.outstandingBlockReads(s#0))
             && BlockCache.__default.OutstandingReadRefsUnique(BlockCache.Variables.outstandingBlockReads(s#0))
           ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, s#0, BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, s#0, BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, BlockCache.Variables.ephemeralIndirectionTable(s#0))
           ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, s#0, BlockCache.Variables.persistentIndirectionTable(s#0)))
         && (BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, s#0, BlockCache.Variables.persistentIndirectionTable(s#0))
             && BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, BlockCache.Variables.persistentIndirectionTable(s#0))
           ==> BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(BlockCache.Variables.outstandingBlockWrites(s#0)))
         && (BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(BlockCache.Variables.outstandingBlockWrites(s#0))
             && BlockCache.__default.OutstandingWriteValidNodeLocation(BlockCache.Variables.outstandingBlockWrites(s#0))
           ==> BlockCache.__default.AllOutstandingBlockWritesDontOverlap#canCall(BlockCache.Variables.outstandingBlockWrites(s#0)))
         && (
          (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0)))
           ==> BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
         && (BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(BlockCache.Variables.ephemeralIndirectionTable(s#0))
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> BlockCache.__default.WFIndirectionTable#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
             && (BlockCache.__default.WFIndirectionTable($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
               ==> BlockCache.__default.IndirectionTableCacheConsistent#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType, 
                BlockCache.Variables.cache(s#0)))
             && (BlockCache.__default.IndirectionTableCacheConsistent#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType, 
                  BlockCache.Variables.cache(s#0))
                 && BlockCache.__default.IndirectionTableCacheConsistent($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType, 
                  BlockCache.Variables.cache(s#0))
               ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(k#0, 
                s#0, 
                $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)))
         && (
          (Options.Option.Some_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
           ==> true
             && Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
           ==> BlockCache.__default.WFCompleteIndirectionTable#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
         && ((Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
               ==> 
              Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> BlockCache.__default.WFCompleteIndirectionTable#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
               ==> Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
                 && BlockCache.__default.WFCompleteIndirectionTable($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(BlockCache.Variables.persistentIndirectionTableLoc(s#0)))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(BlockCache.Variables.persistentIndirectionTableLoc(s#0))
             && DiskLayout.__default.ValidIndirectionTableLocation(BlockCache.Variables.persistentIndirectionTableLoc(s#0))
           ==> 
          Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType)
             && (DiskLayout.__default.ValidIndirectionTableLocation($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType)
               ==> DiskLayout.__default.overlap#canCall($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType, 
                BlockCache.Variables.persistentIndirectionTableLoc(s#0))))
         && BlockCache.__default.InvReady(k#0, s#0)
           == (
            BlockCache.__default.WFCompleteIndirectionTable(BlockCache.Variables.persistentIndirectionTable(s#0))
             && BlockCache.__default.WFIndirectionTable(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.IndirectionTableCacheConsistent(BlockCache.Variables.ephemeralIndirectionTable(s#0), 
              BlockCache.Variables.cache(s#0))
             && BlockCache.__default.CacheConsistentWithSuccessors(BlockCache.Variables.cache(s#0), 
              SectorType.IndirectionTable.graph(BlockCache.Variables.ephemeralIndirectionTable(s#0)))
             && BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(k#0, s#0)
             && BlockCache.__default.OutstandingReadRefsUnique(BlockCache.Variables.outstandingBlockReads(s#0))
             && BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, s#0, BlockCache.Variables.persistentIndirectionTable(s#0))
             && BlockCache.__default.OutstandingWriteValidNodeLocation(BlockCache.Variables.outstandingBlockWrites(s#0))
             && BlockCache.__default.AllOutstandingBlockWritesDontOverlap(BlockCache.Variables.outstandingBlockWrites(s#0))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
               ==> Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0)))
             && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(BlockCache.Variables.ephemeralIndirectionTable(s#0))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
               ==> BlockCache.__default.WFIndirectionTable($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType)
                 && BlockCache.__default.IndirectionTableCacheConsistent($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType, 
                  BlockCache.Variables.cache(s#0))
                 && BlockCache.__default.OverlappingWritesEqForIndirectionTable(k#0, 
                  s#0, 
                  $Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && (Options.Option.Some_q(BlockCache.Variables.outstandingIndirectionTableWrite(s#0))
               ==> true
                 && Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0)))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
               ==> Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTable(s#0))
                 && BlockCache.__default.WFCompleteIndirectionTable($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTable(s#0))): DatatypeType))
             && DiskLayout.__default.ValidIndirectionTableLocation(BlockCache.Variables.persistentIndirectionTableLoc(s#0))
             && (Options.Option.Some_q(BlockCache.Variables.frozenIndirectionTableLoc(s#0))
               ==> DiskLayout.__default.ValidIndirectionTableLocation($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType)
                 && !DiskLayout.__default.overlap($Unbox(Options.Option.value(BlockCache.Variables.frozenIndirectionTableLoc(s#0))): DatatypeType, 
                  BlockCache.Variables.persistentIndirectionTableLoc(s#0)))));

// definition axiom for BlockCache.__default.InvReady for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.InvReady(Lit(k#0), Lit(s#0)) } 
    BlockCache.__default.InvReady#canCall(Lit(k#0), Lit(s#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && Lit(BlockCache.Variables.Ready_q(Lit(s#0))))
       ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
         && (Lit(BlockCache.__default.WFCompleteIndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.WFIndirectionTable#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (BlockCache.__default.WFIndirectionTable#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Lit(BlockCache.__default.WFIndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.IndirectionTableCacheConsistent#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
            Lit(BlockCache.Variables.cache(Lit(s#0)))))
         && (BlockCache.__default.IndirectionTableCacheConsistent#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              Lit(BlockCache.Variables.cache(Lit(s#0))))
             && Lit(BlockCache.__default.IndirectionTableCacheConsistent(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
                Lit(BlockCache.Variables.cache(Lit(s#0)))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.CacheConsistentWithSuccessors#canCall(Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.CacheConsistentWithSuccessors#canCall(Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && Lit(BlockCache.__default.CacheConsistentWithSuccessors(Lit(BlockCache.Variables.cache(Lit(s#0))), 
                Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))))
           ==> BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(Lit(k#0), Lit(s#0)))
         && (BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten#canCall(Lit(k#0), Lit(s#0))
             && Lit(BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(Lit(k#0), Lit(s#0)))
           ==> BlockCache.__default.OutstandingReadRefsUnique#canCall(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))))
         && (BlockCache.__default.OutstandingReadRefsUnique#canCall(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))))
             && Lit(BlockCache.__default.OutstandingReadRefsUnique(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0)))))
           ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(Lit(k#0), 
            Lit(s#0), 
            Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(Lit(k#0), 
              Lit(s#0), 
              Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Lit(BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), 
                Lit(s#0), 
                Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(Lit(k#0), 
            Lit(s#0), 
            Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
         && (BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(Lit(k#0), 
              Lit(s#0), 
              Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && Lit(BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), 
                Lit(s#0), 
                Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))
         && (BlockCache.__default.OutstandingWriteValidNodeLocation#canCall(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))
             && Lit(BlockCache.__default.OutstandingWriteValidNodeLocation(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))
           ==> BlockCache.__default.AllOutstandingBlockWritesDontOverlap#canCall(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0)))))
         && (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
         && (BlockCache.__default.AllLocationsForDifferentRefsDontOverlap#canCall(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && Lit(BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0)))))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.WFIndirectionTable#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
             && (Lit(BlockCache.__default.WFIndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
               ==> BlockCache.__default.IndirectionTableCacheConsistent#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
                Lit(BlockCache.Variables.cache(Lit(s#0)))))
             && (BlockCache.__default.IndirectionTableCacheConsistent#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
                  Lit(BlockCache.Variables.cache(Lit(s#0))))
                 && Lit(BlockCache.__default.IndirectionTableCacheConsistent(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
                    Lit(BlockCache.Variables.cache(Lit(s#0)))))
               ==> BlockCache.__default.OverlappingWritesEqForIndirectionTable#canCall(Lit(k#0), 
                Lit(s#0), 
                Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))))
         && (Lit(Options.Option.Some_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
               ==> true
                 && Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
           ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
         && ((Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
               ==> 
              Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
               ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
                 ==> Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                   && BlockCache.__default.WFCompleteIndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0))))
             && Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0)))))
           ==> 
          Lit(Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType))
             && (Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType)))
               ==> DiskLayout.__default.overlap#canCall(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType), 
                Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0))))))
         && BlockCache.__default.InvReady(Lit(k#0), Lit(s#0))
           == (
            BlockCache.__default.WFCompleteIndirectionTable(Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && BlockCache.__default.WFIndirectionTable(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.IndirectionTableCacheConsistent(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))), 
              Lit(BlockCache.Variables.cache(Lit(s#0))))
             && BlockCache.__default.CacheConsistentWithSuccessors(Lit(BlockCache.Variables.cache(Lit(s#0))), 
              Lit(SectorType.IndirectionTable.graph(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))))
             && BlockCache.__default.EphemeralTableEntriesInCacheOrNotBeingWritten(Lit(k#0), Lit(s#0))
             && BlockCache.__default.OutstandingReadRefsUnique(Lit(BlockCache.Variables.outstandingBlockReads(Lit(s#0))))
             && BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), 
              Lit(s#0), 
              Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), 
              Lit(s#0), 
              Lit(BlockCache.Variables.persistentIndirectionTable(Lit(s#0))))
             && BlockCache.__default.OutstandingWriteValidNodeLocation(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))
             && BlockCache.__default.AllOutstandingBlockWritesDontOverlap(Lit(BlockCache.Variables.outstandingBlockWrites(Lit(s#0))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0)))))
             && BlockCache.__default.AllLocationsForDifferentRefsDontOverlap(Lit(BlockCache.Variables.ephemeralIndirectionTable(Lit(s#0))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
               ==> BlockCache.__default.WFIndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType))
                 && BlockCache.__default.IndirectionTableCacheConsistent(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType), 
                  Lit(BlockCache.Variables.cache(Lit(s#0))))
                 && BlockCache.__default.OverlappingWritesEqForIndirectionTable(Lit(k#0), 
                  Lit(s#0), 
                  Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.outstandingIndirectionTableWrite(Lit(s#0))))
               ==> true
                 && Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0)))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))
                 && BlockCache.__default.WFCompleteIndirectionTable(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTable(Lit(s#0))))): DatatypeType)))
             && DiskLayout.__default.ValidIndirectionTableLocation(Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0))))
             && (Options.Option.Some_q(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))
               ==> DiskLayout.__default.ValidIndirectionTableLocation(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType))
                 && !Lit(DiskLayout.__default.overlap(Lit($Unbox(Options.Option.value(Lit(BlockCache.Variables.frozenIndirectionTableLoc(Lit(s#0))))): DatatypeType), 
                    Lit(BlockCache.Variables.persistentIndirectionTableLoc(Lit(s#0))))))));

// function declaration for BlockCache._default.Inv
function BlockCache.__default.Inv(k#0: DatatypeType, s#0: DatatypeType) : bool;

function BlockCache.__default.Inv#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for BlockCache.__default.Inv
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.Inv(k#0, s#0) } 
    BlockCache.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables()))
       ==> true);

function BlockCache.__default.Inv#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for BlockCache.__default.Inv
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { BlockCache.__default.Inv#requires(k#0, s#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
     ==> BlockCache.__default.Inv#requires(k#0, s#0) == true);

// definition axiom for BlockCache.__default.Inv(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { BlockCache.__default.Inv(k#0, s#0) } 
    BlockCache.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables()))
       ==> (BlockCache.Variables.Ready_q(s#0)
           ==> BlockCache.__default.InvReady#canCall(k#0, s#0))
         && (BlockCache.__default.InvReady#canCall(k#0, s#0)
             && BlockCache.__default.InvReady(k#0, s#0)
           ==> 
          BlockCache.Variables.LoadingIndirectionTable_q(s#0)
           ==> 
          Lit(true)
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(BlockCache.Variables.indirectionTableLoc(s#0)))
         && BlockCache.__default.Inv(k#0, s#0)
           == ((BlockCache.Variables.Ready_q(s#0) ==> BlockCache.__default.InvReady(k#0, s#0))
             && (BlockCache.Variables.LoadingIndirectionTable_q(s#0)
               ==> true
                 && DiskLayout.__default.ValidIndirectionTableLocation(BlockCache.Variables.indirectionTableLoc(s#0)))));

// definition axiom for BlockCache.__default.Inv for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { BlockCache.__default.Inv(Lit(k#0), Lit(s#0)) } 
    BlockCache.__default.Inv#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables()))
       ==> (Lit(BlockCache.Variables.Ready_q(Lit(s#0)))
           ==> BlockCache.__default.InvReady#canCall(Lit(k#0), Lit(s#0)))
         && (BlockCache.__default.InvReady#canCall(Lit(k#0), Lit(s#0))
             && Lit(BlockCache.__default.InvReady(Lit(k#0), Lit(s#0)))
           ==> 
          Lit(BlockCache.Variables.LoadingIndirectionTable_q(Lit(s#0)))
           ==> 
          Lit(true)
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s#0)))))
         && BlockCache.__default.Inv(Lit(k#0), Lit(s#0))
           == Lit((BlockCache.Variables.Ready_q(Lit(s#0))
                 ==> BlockCache.__default.InvReady(Lit(k#0), Lit(s#0)))
               && (BlockCache.Variables.LoadingIndirectionTable_q(Lit(s#0))
                 ==> true
                   && DiskLayout.__default.ValidIndirectionTableLocation(Lit(BlockCache.Variables.indirectionTableLoc(Lit(s#0)))))));

// function declaration for BlockCache._default.Reads
function BlockCache.__default.Reads(k#0: DatatypeType, s#0: DatatypeType, ops#0: Seq Box) : bool;

function BlockCache.__default.Reads#canCall(k#0: DatatypeType, s#0: DatatypeType, ops#0: Seq Box) : bool;

// consequence axiom for BlockCache.__default.Reads
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, ops#0: Seq Box :: 
    { BlockCache.__default.Reads(k#0, s#0, ops#0) } 
    BlockCache.__default.Reads#canCall(k#0, s#0, ops#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.ReadOp())))
       ==> (BlockCache.__default.Reads(k#0, s#0, ops#0) && 0 < Seq#Length(ops#0)
           ==> BlockCache.__default.ReadStep(k#0, s#0, $Unbox(Seq#Index(ops#0, LitInt(0))): DatatypeType))
         && (BlockCache.__default.Reads(k#0, s#0, ops#0) && 1 < Seq#Length(ops#0)
           ==> BlockCache.__default.ReadStep(k#0, s#0, $Unbox(Seq#Index(ops#0, LitInt(1))): DatatypeType))
         && (BlockCache.__default.Reads(k#0, s#0, ops#0) && 2 < Seq#Length(ops#0)
           ==> BlockCache.__default.ReadStep(k#0, s#0, $Unbox(Seq#Index(ops#0, LitInt(2))): DatatypeType)));

function BlockCache.__default.Reads#requires(DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for BlockCache.__default.Reads
axiom (forall k#0: DatatypeType, s#0: DatatypeType, ops#0: Seq Box :: 
  { BlockCache.__default.Reads#requires(k#0, s#0, ops#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.ReadOp()))
     ==> BlockCache.__default.Reads#requires(k#0, s#0, ops#0) == true);

// definition axiom for BlockCache.__default.Reads(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, ops#0: Seq Box :: 
    { BlockCache.__default.Reads(k#0, s#0, ops#0) } 
    BlockCache.__default.Reads#canCall(k#0, s#0, ops#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.ReadOp())))
       ==> (forall op#0: DatatypeType :: 
          { BlockCache.__default.ReadStep(k#0, s#0, op#0) } 
            { Seq#Contains(ops#0, $Box(op#0)) } 
          $Is(op#0, Tclass.PivotBetreeGraph.ReadOp())
             ==> 
            Seq#Contains(ops#0, $Box(op#0))
             ==> BlockCache.__default.ReadStep#canCall(k#0, s#0, op#0))
         && BlockCache.__default.Reads(k#0, s#0, ops#0)
           == (forall op#0: DatatypeType :: 
            { BlockCache.__default.ReadStep(k#0, s#0, op#0) } 
              { Seq#Contains(ops#0, $Box(op#0)) } 
            $Is(op#0, Tclass.PivotBetreeGraph.ReadOp())
               ==> 
              Seq#Contains(ops#0, $Box(op#0))
               ==> BlockCache.__default.ReadStep(k#0, s#0, op#0)));

// definition axiom for BlockCache.__default.Reads for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, ops#0: Seq Box :: 
    {:weight 3} { BlockCache.__default.Reads(Lit(k#0), Lit(s#0), Lit(ops#0)) } 
    BlockCache.__default.Reads#canCall(Lit(k#0), Lit(s#0), Lit(ops#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.ReadOp())))
       ==> (forall op#1: DatatypeType :: 
          { BlockCache.__default.ReadStep(k#0, s#0, op#1) } 
            { Seq#Contains(ops#0, $Box(op#1)) } 
          $Is(op#1, Tclass.PivotBetreeGraph.ReadOp())
             ==> 
            Seq#Contains(ops#0, $Box(op#1))
             ==> BlockCache.__default.ReadStep#canCall(Lit(k#0), Lit(s#0), op#1))
         && BlockCache.__default.Reads(Lit(k#0), Lit(s#0), Lit(ops#0))
           == (forall op#1: DatatypeType :: 
            { BlockCache.__default.ReadStep(k#0, s#0, op#1) } 
              { Seq#Contains(ops#0, $Box(op#1)) } 
            $Is(op#1, Tclass.PivotBetreeGraph.ReadOp())
               ==> 
              Seq#Contains(ops#0, $Box(op#1))
               ==> BlockCache.__default.ReadStep(Lit(k#0), Lit(s#0), op#1)));

// function declaration for BlockCache._default.IsStatePath
function BlockCache.__default.IsStatePath(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box, 
    path#0: Seq Box)
   : bool;

function BlockCache.__default.IsStatePath#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box, 
    path#0: Seq Box)
   : bool;

// consequence axiom for BlockCache.__default.IsStatePath
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ops#0: Seq Box, 
      path#0: Seq Box :: 
    { BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#0) } 
    BlockCache.__default.IsStatePath#canCall(k#0, s#0, s'#0, ops#0, path#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op()))
           && $Is(path#0, TSeq(Tclass.BlockCache.Variables())))
       ==> true);

function BlockCache.__default.IsStatePath#requires(DatatypeType, DatatypeType, DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for BlockCache.__default.IsStatePath
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box, 
    path#0: Seq Box :: 
  { BlockCache.__default.IsStatePath#requires(k#0, s#0, s'#0, ops#0, path#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op()))
       && $Is(path#0, TSeq(Tclass.BlockCache.Variables()))
     ==> BlockCache.__default.IsStatePath#requires(k#0, s#0, s'#0, ops#0, path#0) == true);

// definition axiom for BlockCache.__default.IsStatePath(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ops#0: Seq Box, 
      path#0: Seq Box :: 
    { BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#0) } 
    BlockCache.__default.IsStatePath#canCall(k#0, s#0, s'#0, ops#0, path#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op()))
           && $Is(path#0, TSeq(Tclass.BlockCache.Variables())))
       ==> (Seq#Length(path#0) == Seq#Length(ops#0) + 1
           ==> $IsA#BlockCache.Variables($Unbox(Seq#Index(path#0, LitInt(0))): DatatypeType)
             && $IsA#BlockCache.Variables(s#0))
         && ($IsA#BlockCache.Variables($Unbox(Seq#Index(path#0, LitInt(0))): DatatypeType)
             && $IsA#BlockCache.Variables(s#0)
             && BlockCache.Variables#Equal($Unbox(Seq#Index(path#0, LitInt(0))): DatatypeType, s#0)
           ==> $IsA#BlockCache.Variables($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), path#0)): DatatypeType)
             && $IsA#BlockCache.Variables(s'#0)
             && Sequences.__default.Last#canCall(Tclass.BlockCache.Variables(), path#0))
         && ($IsA#BlockCache.Variables($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), path#0)): DatatypeType)
             && $IsA#BlockCache.Variables(s'#0)
             && Sequences.__default.Last#canCall(Tclass.BlockCache.Variables(), path#0)
             && BlockCache.Variables#Equal($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), path#0)): DatatypeType, 
              s'#0)
           ==> (forall i#0: int, _t#0#0: int :: 
            { $Unbox(Seq#Index(ops#0, i#0)): DatatypeType, $Unbox(Seq#Index(path#0, _t#0#0)): DatatypeType } 
              { $Unbox(Seq#Index(path#0, _t#0#0)): DatatypeType, $Unbox(Seq#Index(path#0, i#0)): DatatypeType } 
            _t#0#0 == i#0 + 1
               ==> 
              i#0 < Seq#Length(ops#0)
               ==> BlockCache.__default.OpStep#canCall(k#0, 
                $Unbox(Seq#Index(path#0, i#0)): DatatypeType, 
                $Unbox(Seq#Index(path#0, _t#0#0)): DatatypeType, 
                $Unbox(Seq#Index(ops#0, i#0)): DatatypeType)))
         && BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#0)
           == (
            Seq#Length(path#0) == Seq#Length(ops#0) + 1
             && BlockCache.Variables#Equal($Unbox(Seq#Index(path#0, LitInt(0))): DatatypeType, s#0)
             && BlockCache.Variables#Equal($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), path#0)): DatatypeType, 
              s'#0)
             && (forall i#0: int, _t#0#0: int :: 
              { $Unbox(Seq#Index(ops#0, i#0)): DatatypeType, $Unbox(Seq#Index(path#0, _t#0#0)): DatatypeType } 
                { $Unbox(Seq#Index(path#0, _t#0#0)): DatatypeType, $Unbox(Seq#Index(path#0, i#0)): DatatypeType } 
              _t#0#0 == i#0 + 1
                 ==> 
                LitInt(0) <= i#0 && i#0 < Seq#Length(ops#0)
                 ==> BlockCache.__default.OpStep(k#0, 
                  $Unbox(Seq#Index(path#0, i#0)): DatatypeType, 
                  $Unbox(Seq#Index(path#0, _t#0#0)): DatatypeType, 
                  $Unbox(Seq#Index(ops#0, i#0)): DatatypeType))));

// definition axiom for BlockCache.__default.IsStatePath for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ops#0: Seq Box, 
      path#0: Seq Box :: 
    {:weight 3} { BlockCache.__default.IsStatePath(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0), Lit(path#0)) } 
    BlockCache.__default.IsStatePath#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0), Lit(path#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op()))
           && $Is(path#0, TSeq(Tclass.BlockCache.Variables())))
       ==> (Seq#Length(Lit(path#0)) == Seq#Length(Lit(ops#0)) + 1
           ==> $IsA#BlockCache.Variables($Unbox(Seq#Index(Lit(path#0), LitInt(0))): DatatypeType)
             && $IsA#BlockCache.Variables(Lit(s#0)))
         && ($IsA#BlockCache.Variables($Unbox(Seq#Index(Lit(path#0), LitInt(0))): DatatypeType)
             && $IsA#BlockCache.Variables(Lit(s#0))
             && BlockCache.Variables#Equal($Unbox(Seq#Index(Lit(path#0), LitInt(0))): DatatypeType, s#0)
           ==> $IsA#BlockCache.Variables(Lit($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), Lit(path#0))): DatatypeType))
             && $IsA#BlockCache.Variables(Lit(s'#0))
             && Sequences.__default.Last#canCall(Tclass.BlockCache.Variables(), Lit(path#0)))
         && ($IsA#BlockCache.Variables(Lit($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), Lit(path#0))): DatatypeType))
             && $IsA#BlockCache.Variables(Lit(s'#0))
             && Sequences.__default.Last#canCall(Tclass.BlockCache.Variables(), Lit(path#0))
             && BlockCache.Variables#Equal($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), Lit(path#0))): DatatypeType, 
              s'#0)
           ==> (forall i#1: int, _t#0#1: int :: 
            { $Unbox(Seq#Index(ops#0, i#1)): DatatypeType, $Unbox(Seq#Index(path#0, _t#0#1)): DatatypeType } 
              { $Unbox(Seq#Index(path#0, _t#0#1)): DatatypeType, $Unbox(Seq#Index(path#0, i#1)): DatatypeType } 
            _t#0#1 == i#1 + 1
               ==> 
              i#1 < Seq#Length(Lit(ops#0))
               ==> BlockCache.__default.OpStep#canCall(Lit(k#0), 
                $Unbox(Seq#Index(Lit(path#0), i#1)): DatatypeType, 
                $Unbox(Seq#Index(Lit(path#0), _t#0#1)): DatatypeType, 
                $Unbox(Seq#Index(Lit(ops#0), i#1)): DatatypeType)))
         && BlockCache.__default.IsStatePath(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0), Lit(path#0))
           == (
            Seq#Length(Lit(path#0)) == Seq#Length(Lit(ops#0)) + 1
             && BlockCache.Variables#Equal($Unbox(Seq#Index(Lit(path#0), LitInt(0))): DatatypeType, s#0)
             && BlockCache.Variables#Equal($Unbox(Sequences.__default.Last(Tclass.BlockCache.Variables(), Lit(path#0))): DatatypeType, 
              s'#0)
             && (forall i#1: int, _t#0#1: int :: 
              { $Unbox(Seq#Index(ops#0, i#1)): DatatypeType, $Unbox(Seq#Index(path#0, _t#0#1)): DatatypeType } 
                { $Unbox(Seq#Index(path#0, _t#0#1)): DatatypeType, $Unbox(Seq#Index(path#0, i#1)): DatatypeType } 
              _t#0#1 == i#1 + 1
                 ==> 
                LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(ops#0))
                 ==> BlockCache.__default.OpStep(Lit(k#0), 
                  $Unbox(Seq#Index(Lit(path#0), i#1)): DatatypeType, 
                  $Unbox(Seq#Index(Lit(path#0), _t#0#1)): DatatypeType, 
                  $Unbox(Seq#Index(Lit(ops#0), i#1)): DatatypeType))));

// function declaration for BlockCache._default.OpTransaction
function BlockCache.__default.OpTransaction($ly: LayerType, 
    k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box)
   : bool;

function BlockCache.__default.OpTransaction#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, ops#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box :: 
  { BlockCache.__default.OpTransaction($LS($ly), k#0, s#0, s'#0, ops#0) } 
  BlockCache.__default.OpTransaction($LS($ly), k#0, s#0, s'#0, ops#0)
     == BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box :: 
  { BlockCache.__default.OpTransaction(AsFuelBottom($ly), k#0, s#0, s'#0, ops#0) } 
  BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0)
     == BlockCache.__default.OpTransaction($LZ, k#0, s#0, s'#0, ops#0));

// consequence axiom for BlockCache.__default.OpTransaction
axiom true
   ==> (forall $ly: LayerType, 
      k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ops#0: Seq Box :: 
    { BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0) } 
    BlockCache.__default.OpTransaction#canCall(k#0, s#0, s'#0, ops#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op())))
       ==> (BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0)
             && Seq#Length(ops#0) == LitInt(1)
           ==> true
             && BlockCache.__default.OpStep(k#0, s#0, s'#0, $Unbox(Seq#Index(ops#0, LitInt(0))): DatatypeType))
         && (BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0)
             && Seq#Length(ops#0) == LitInt(2)
           ==> (exists sint#0: DatatypeType :: 
            { BlockCache.__default.OpStep(k#0, sint#0, s'#0, $Unbox(Seq#Index(ops#0, 1)): DatatypeType) } 
              { BlockCache.__default.OpStep(k#0, s#0, sint#0, $Unbox(Seq#Index(ops#0, 0)): DatatypeType) } 
            $Is(sint#0, Tclass.BlockCache.Variables())
               && 
              BlockCache.__default.OpStep(k#0, s#0, sint#0, $Unbox(Seq#Index(ops#0, LitInt(0))): DatatypeType)
               && BlockCache.__default.OpStep(k#0, sint#0, s'#0, $Unbox(Seq#Index(ops#0, LitInt(1))): DatatypeType)))
         && (BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0)
             && Seq#Length(ops#0) == LitInt(3)
           ==> (exists sint#1: DatatypeType, sint'#0: DatatypeType :: 
            { BlockCache.__default.OpStep(k#0, sint'#0, s'#0, $Unbox(Seq#Index(ops#0, 2)): DatatypeType), BlockCache.__default.OpStep(k#0, s#0, sint#1, $Unbox(Seq#Index(ops#0, 0)): DatatypeType) } 
              { BlockCache.__default.OpStep(k#0, sint#1, sint'#0, $Unbox(Seq#Index(ops#0, 1)): DatatypeType) } 
            $Is(sint#1, Tclass.BlockCache.Variables())
               && $Is(sint'#0, Tclass.BlockCache.Variables())
               && 
              BlockCache.__default.OpStep(k#0, s#0, sint#1, $Unbox(Seq#Index(ops#0, LitInt(0))): DatatypeType)
               && BlockCache.__default.OpStep(k#0, sint#1, sint'#0, $Unbox(Seq#Index(ops#0, LitInt(1))): DatatypeType)
               && BlockCache.__default.OpStep(k#0, sint'#0, s'#0, $Unbox(Seq#Index(ops#0, LitInt(2))): DatatypeType)))
         && (Seq#Length(ops#0) == LitInt(1)
             && BlockCache.__default.OpStep(k#0, s#0, s'#0, $Unbox(Seq#Index(ops#0, LitInt(0))): DatatypeType)
           ==> BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0))
         && (BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0)
             && Seq#Length(ops#0) == LitInt(0)
           ==> BlockCache.Variables#Equal(s#0, s'#0))
         && (Seq#Length(ops#0) == LitInt(0) && BlockCache.Variables#Equal(s#0, s'#0)
           ==> BlockCache.__default.OpTransaction($ly, k#0, s#0, s'#0, ops#0)));

function BlockCache.__default.OpTransaction#requires(LayerType, DatatypeType, DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for BlockCache.__default.OpTransaction
axiom (forall $ly: LayerType, 
    k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    ops#0: Seq Box :: 
  { BlockCache.__default.OpTransaction#requires($ly, k#0, s#0, s'#0, ops#0) } 
  $Is(k#0, Tclass.BlockCache.Constants())
       && $Is(s#0, Tclass.BlockCache.Variables())
       && $Is(s'#0, Tclass.BlockCache.Variables())
       && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op()))
     ==> BlockCache.__default.OpTransaction#requires($ly, k#0, s#0, s'#0, ops#0) == true);

// definition axiom for BlockCache.__default.OpTransaction(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ops#0: Seq Box :: 
    { BlockCache.__default.OpTransaction($LS($ly), k#0, s#0, s'#0, ops#0) } 
    BlockCache.__default.OpTransaction#canCall(k#0, s#0, s'#0, ops#0)
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op())))
       ==> (Lit(true)
           ==> (forall path#0: Seq Box :: 
            { BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#0) } 
            $Is(path#0, TSeq(Tclass.BlockCache.Variables()))
               ==> BlockCache.__default.IsStatePath#canCall(k#0, s#0, s'#0, ops#0, path#0)))
         && BlockCache.__default.OpTransaction($LS($ly), k#0, s#0, s'#0, ops#0)
           == (true
             && (exists path#0: Seq Box :: 
              { BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#0) } 
              $Is(path#0, TSeq(Tclass.BlockCache.Variables()))
                 && BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#0))));

// definition axiom for BlockCache.__default.OpTransaction for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      ops#0: Seq Box :: 
    {:weight 3} { BlockCache.__default.OpTransaction($LS($ly), Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0)) } 
    BlockCache.__default.OpTransaction#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0))
         || (
          $Is(k#0, Tclass.BlockCache.Constants())
           && $Is(s#0, Tclass.BlockCache.Variables())
           && $Is(s'#0, Tclass.BlockCache.Variables())
           && $Is(ops#0, TSeq(Tclass.PivotBetreeGraph.Op())))
       ==> (Lit(true)
           ==> (forall path#1: Seq Box :: 
            { BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#1) } 
            $Is(path#1, TSeq(Tclass.BlockCache.Variables()))
               ==> BlockCache.__default.IsStatePath#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0), path#1)))
         && BlockCache.__default.OpTransaction($LS($ly), Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0))
           == (true
             && (exists path#1: Seq Box :: 
              { BlockCache.__default.IsStatePath(k#0, s#0, s'#0, ops#0, path#1) } 
              $Is(path#1, TSeq(Tclass.BlockCache.Variables()))
                 && BlockCache.__default.IsStatePath(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(ops#0), path#1))));

const unique class.LruModel.__default: ClassName;

function Tclass.LruModel.__default() : Ty;

// Tclass.LruModel.__default Tag
axiom Tag(Tclass.LruModel.__default()) == Tagclass.LruModel.__default;

const unique Tagclass.LruModel.__default: TyTag;

// Box/unbox axiom for Tclass.LruModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.LruModel.__default()) } 
  $IsBox(bx, Tclass.LruModel.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.LruModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.LruModel.__default()) } 
  $Is($o, Tclass.LruModel.__default())
     <==> $o == null || dtype($o) == Tclass.LruModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.LruModel.__default(), $h) } 
  $IsAlloc($o, Tclass.LruModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for LruModel._default.distinct
function LruModel.__default.distinct($ly: LayerType, q#0: Seq Box) : bool;

function LruModel.__default.distinct#canCall(q#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, q#0: Seq Box :: 
  { LruModel.__default.distinct($LS($ly), q#0) } 
  LruModel.__default.distinct($LS($ly), q#0)
     == LruModel.__default.distinct($ly, q#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, q#0: Seq Box :: 
  { LruModel.__default.distinct(AsFuelBottom($ly), q#0) } 
  LruModel.__default.distinct($ly, q#0) == LruModel.__default.distinct($LZ, q#0));

// consequence axiom for LruModel.__default.distinct
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box :: 
    { LruModel.__default.distinct($ly, q#0) } 
    LruModel.__default.distinct#canCall(q#0)
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> true);

function LruModel.__default.distinct#requires(LayerType, Seq Box) : bool;

// #requires axiom for LruModel.__default.distinct
axiom (forall $ly: LayerType, q#0: Seq Box :: 
  { LruModel.__default.distinct#requires($ly, q#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> LruModel.__default.distinct#requires($ly, q#0) == true);

// definition axiom for LruModel.__default.distinct(revealed)
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box :: 
    { LruModel.__default.distinct($LS($ly), q#0) } 
    LruModel.__default.distinct#canCall(q#0)
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.distinct($LS($ly), q#0)
         == (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(q#0, j#0)): int, $Unbox(Seq#Index(q#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Seq#Length(q#0)
               && 
              LitInt(0) <= j#0
               && j#0 < Seq#Length(q#0)
               && i#0 != j#0
             ==> $Unbox(Seq#Index(q#0, i#0)): int != $Unbox(Seq#Index(q#0, j#0)): int));

// definition axiom for LruModel.__default.distinct for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box :: 
    {:weight 3} { LruModel.__default.distinct($LS($ly), Lit(q#0)) } 
    LruModel.__default.distinct#canCall(Lit(q#0))
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.distinct($LS($ly), Lit(q#0))
         == (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(q#0, j#1)): int, $Unbox(Seq#Index(q#0, i#1)): int } 
          LitInt(0) <= i#1
               && i#1 < Seq#Length(Lit(q#0))
               && 
              LitInt(0) <= j#1
               && j#1 < Seq#Length(Lit(q#0))
               && i#1 != j#1
             ==> $Unbox(Seq#Index(Lit(q#0), i#1)): int != $Unbox(Seq#Index(Lit(q#0), j#1)): int));

// function declaration for LruModel._default.WF
function LruModel.__default.WF(q#0: Seq Box) : bool;

function LruModel.__default.WF#canCall(q#0: Seq Box) : bool;

// consequence axiom for LruModel.__default.WF
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.WF(q#0) } 
    LruModel.__default.WF#canCall(q#0)
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> true);

function LruModel.__default.WF#requires(Seq Box) : bool;

// #requires axiom for LruModel.__default.WF
axiom (forall q#0: Seq Box :: 
  { LruModel.__default.WF#requires(q#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> LruModel.__default.WF#requires(q#0) == true);

// definition axiom for LruModel.__default.WF(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.WF(q#0) } 
    LruModel.__default.WF#canCall(q#0)
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.distinct#canCall(q#0)
         && LruModel.__default.WF(q#0)
           == LruModel.__default.distinct(StartFuel_LruModel._default.distinct, q#0));

// definition axiom for LruModel.__default.WF for all literals(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    {:weight 3} { LruModel.__default.WF(Lit(q#0)) } 
    LruModel.__default.WF#canCall(Lit(q#0))
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.distinct#canCall(Lit(q#0))
         && LruModel.__default.WF(Lit(q#0))
           == LruModel.__default.distinct(StartFuel_LruModel._default.distinct, Lit(q#0)));

// function declaration for LruModel._default.I
function LruModel.__default.I(q#0: Seq Box) : Set Box;

function LruModel.__default.I#canCall(q#0: Seq Box) : bool;

// consequence axiom for LruModel.__default.I
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.I(q#0) } 
    LruModel.__default.I#canCall(q#0) || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> $Is(LruModel.__default.I(q#0), TSet(Tclass.NativeTypes.uint64())));

function LruModel.__default.I#requires(Seq Box) : bool;

// #requires axiom for LruModel.__default.I
axiom (forall q#0: Seq Box :: 
  { LruModel.__default.I#requires(q#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> LruModel.__default.I#requires(q#0) == true);

// definition axiom for LruModel.__default.I(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.I(q#0) } 
    LruModel.__default.I#canCall(q#0) || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.I(q#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, Tclass.NativeTypes.uint64()) && Seq#Contains(q#0, $y#0)));

// definition axiom for LruModel.__default.I for all literals(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    {:weight 3} { LruModel.__default.I(Lit(q#0)) } 
    LruModel.__default.I#canCall(Lit(q#0))
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.I(Lit(q#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, Tclass.NativeTypes.uint64()) && Seq#Contains(q#0, $y#1)));

// function declaration for LruModel._default.Empty
function LruModel.__default.Empty() : Seq Box;

function LruModel.__default.Empty#canCall() : bool;

// consequence axiom for LruModel.__default.Empty
axiom true
   ==> 
  true
   ==> Set#Equal(LruModel.__default.I(LruModel.__default.Empty()), Set#Empty(): Set Box)
     && LruModel.__default.WF(LruModel.__default.Empty())
     && $Is(LruModel.__default.Empty(), TSeq(Tclass.NativeTypes.uint64()));

function LruModel.__default.Empty#requires() : bool;

// #requires axiom for LruModel.__default.Empty
axiom LruModel.__default.Empty#requires() == true;

const MoreFuel_LruModel._default.distinct0: LayerType;

// definition axiom for LruModel.__default.Empty(revealed)
axiom true
   ==> 
  true
   ==> StartFuel_LruModel._default.distinct
       == $LS(MoreFuel_LruModel._default.distinct0)
     && StartFuelAssert_LruModel._default.distinct
       == $LS($LS(MoreFuel_LruModel._default.distinct0))
     && AsFuelBottom(MoreFuel_LruModel._default.distinct0)
       == MoreFuel_LruModel._default.distinct0
     && LruModel.__default.Empty() == Lit(Seq#Empty(): Seq Box);

const MoreFuel_LruModel._default.distinct1: LayerType;

// definition axiom for LruModel.__default.Empty for all literals(revealed)
axiom true
   ==> 
  true
   ==> StartFuel_LruModel._default.distinct
       == $LS(MoreFuel_LruModel._default.distinct1)
     && StartFuelAssert_LruModel._default.distinct
       == $LS($LS(MoreFuel_LruModel._default.distinct1))
     && AsFuelBottom(MoreFuel_LruModel._default.distinct1)
       == MoreFuel_LruModel._default.distinct1
     && LruModel.__default.Empty() == Lit(Seq#Empty(): Seq Box);

// function declaration for LruModel._default.Remove
function LruModel.__default.Remove($ly: LayerType, q#0: Seq Box, x#0: int) : Seq Box;

function LruModel.__default.Remove#canCall(q#0: Seq Box, x#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, q#0: Seq Box, x#0: int :: 
  { LruModel.__default.Remove($LS($ly), q#0, x#0) } 
  LruModel.__default.Remove($LS($ly), q#0, x#0)
     == LruModel.__default.Remove($ly, q#0, x#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, q#0: Seq Box, x#0: int :: 
  { LruModel.__default.Remove(AsFuelBottom($ly), q#0, x#0) } 
  LruModel.__default.Remove($ly, q#0, x#0)
     == LruModel.__default.Remove($LZ, q#0, x#0));

// consequence axiom for LruModel.__default.Remove
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box, x#0: int :: 
    { LruModel.__default.Remove($ly, q#0, x#0) } 
    LruModel.__default.Remove#canCall(q#0, x#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616)
       ==> $Is(LruModel.__default.Remove($ly, q#0, x#0), TSeq(Tclass.NativeTypes.uint64())));

function LruModel.__default.Remove#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for LruModel.__default.Remove
axiom (forall $ly: LayerType, q#0: Seq Box, x#0: int :: 
  { LruModel.__default.Remove#requires($ly, q#0, x#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= x#0
       && x#0 < 18446744073709551616
     ==> LruModel.__default.Remove#requires($ly, q#0, x#0) == true);

// definition axiom for LruModel.__default.Remove(revealed)
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box, x#0: int :: 
    { LruModel.__default.Remove($LS($ly), q#0, x#0) } 
    LruModel.__default.Remove#canCall(q#0, x#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616)
       ==> (Seq#Length(q#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), q#0)
             && ($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), q#0)): int == x#0
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), q#0)
                 && LruModel.__default.Remove#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), q#0), x#0))
             && ($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), q#0)): int != x#0
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), q#0)
                 && LruModel.__default.Remove#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), q#0), x#0)
                 && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), q#0)))
         && LruModel.__default.Remove($LS($ly), q#0, x#0)
           == (if Seq#Length(q#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else (if $Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), q#0)): int == x#0
               then LruModel.__default.Remove($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), q#0), x#0)
               else Seq#Append(LruModel.__default.Remove($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), q#0), x#0), 
                Seq#Build(Seq#Empty(): Seq Box, Sequences.__default.Last(Tclass.NativeTypes.uint64(), q#0))))));

// definition axiom for LruModel.__default.Remove for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box, x#0: int :: 
    {:weight 3} { LruModel.__default.Remove($LS($ly), Lit(q#0), LitInt(x#0)) } 
    LruModel.__default.Remove#canCall(Lit(q#0), LitInt(x#0))
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616)
       ==> (Seq#Length(Lit(q#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(q#0))
             && (LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(q#0))): int)
                 == LitInt(x#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), Lit(q#0))
                 && LruModel.__default.Remove#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(q#0))), 
                  LitInt(x#0)))
             && (LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(q#0))): int)
                 != LitInt(x#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint64(), Lit(q#0))
                 && LruModel.__default.Remove#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(q#0))), 
                  LitInt(x#0))
                 && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint64(), Lit(q#0))))
         && LruModel.__default.Remove($LS($ly), Lit(q#0), LitInt(x#0))
           == (if Seq#Length(Lit(q#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else (if LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(q#0))): int)
                 == LitInt(x#0)
               then LruModel.__default.Remove($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(q#0))), 
                LitInt(x#0))
               else Seq#Append(LruModel.__default.Remove($LS($ly), 
                  Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint64(), Lit(q#0))), 
                  LitInt(x#0)), 
                Seq#Build(Seq#Empty(): Seq Box, 
                  $Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint64(), Lit(q#0))): int)))))));

// function declaration for LruModel._default.Use
function LruModel.__default.Use(q#0: Seq Box, x#0: int) : Seq Box;

function LruModel.__default.Use#canCall(q#0: Seq Box, x#0: int) : bool;

// consequence axiom for LruModel.__default.Use
axiom true
   ==> (forall q#0: Seq Box, x#0: int :: 
    { LruModel.__default.Use(q#0, x#0) } 
    LruModel.__default.Use#canCall(q#0, x#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616)
       ==> $Is(LruModel.__default.Use(q#0, x#0), TSeq(Tclass.NativeTypes.uint64())));

function LruModel.__default.Use#requires(Seq Box, int) : bool;

// #requires axiom for LruModel.__default.Use
axiom (forall q#0: Seq Box, x#0: int :: 
  { LruModel.__default.Use#requires(q#0, x#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= x#0
       && x#0 < 18446744073709551616
     ==> LruModel.__default.Use#requires(q#0, x#0) == true);

// definition axiom for LruModel.__default.Use(revealed)
axiom true
   ==> (forall q#0: Seq Box, x#0: int :: 
    { LruModel.__default.Use(q#0, x#0) } 
    LruModel.__default.Use#canCall(q#0, x#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616)
       ==> LruModel.__default.Remove#canCall(q#0, x#0)
         && LruModel.__default.Use(q#0, x#0)
           == Seq#Append(LruModel.__default.Remove($LS($LZ), q#0, x#0), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(x#0))));

// definition axiom for LruModel.__default.Use for all literals(revealed)
axiom true
   ==> (forall q#0: Seq Box, x#0: int :: 
    {:weight 3} { LruModel.__default.Use(Lit(q#0), LitInt(x#0)) } 
    LruModel.__default.Use#canCall(Lit(q#0), LitInt(x#0))
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= x#0
           && x#0 < 18446744073709551616)
       ==> LruModel.__default.Remove#canCall(Lit(q#0), LitInt(x#0))
         && LruModel.__default.Use(Lit(q#0), LitInt(x#0))
           == Seq#Append(LruModel.__default.Remove($LS($LZ), Lit(q#0), LitInt(x#0)), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(LitInt(x#0)))));

// function declaration for LruModel._default.Next
function LruModel.__default.Next(q#0: Seq Box) : int;

function LruModel.__default.Next#canCall(q#0: Seq Box) : bool;

// consequence axiom for LruModel.__default.Next
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.Next(q#0) } 
    LruModel.__default.Next#canCall(q#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && Set#Card(LruModel.__default.I(q#0)) > 0)
       ==> LruModel.__default.I(q#0)[$Box(LruModel.__default.Next(q#0))]
         && 
        LitInt(0) <= LruModel.__default.Next(q#0)
         && LruModel.__default.Next(q#0) < 18446744073709551616);

function LruModel.__default.Next#requires(Seq Box) : bool;

// #requires axiom for LruModel.__default.Next
axiom (forall q#0: Seq Box :: 
  { LruModel.__default.Next#requires(q#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> LruModel.__default.Next#requires(q#0)
       == (Set#Card(LruModel.__default.I(q#0)) > 0));

// definition axiom for LruModel.__default.Next(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.Next(q#0) } 
    LruModel.__default.Next#canCall(q#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && Set#Card(LruModel.__default.I(q#0)) > 0)
       ==> LruModel.__default.Next(q#0) == $Unbox(Seq#Index(q#0, LitInt(0))): int);

// definition axiom for LruModel.__default.Next for all literals(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    {:weight 3} { LruModel.__default.Next(Lit(q#0)) } 
    LruModel.__default.Next#canCall(Lit(q#0))
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && Set#Card(Lit(LruModel.__default.I(Lit(q#0)))) > 0)
       ==> LruModel.__default.Next(Lit(q#0)) == $Unbox(Seq#Index(Lit(q#0), LitInt(0))): int);

// function declaration for LruModel._default.NextOpt
function LruModel.__default.NextOpt($ly: LayerType, q#0: Seq Box) : DatatypeType;

function LruModel.__default.NextOpt#canCall(q#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, q#0: Seq Box :: 
  { LruModel.__default.NextOpt($LS($ly), q#0) } 
  LruModel.__default.NextOpt($LS($ly), q#0)
     == LruModel.__default.NextOpt($ly, q#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, q#0: Seq Box :: 
  { LruModel.__default.NextOpt(AsFuelBottom($ly), q#0) } 
  LruModel.__default.NextOpt($ly, q#0) == LruModel.__default.NextOpt($LZ, q#0));

// consequence axiom for LruModel.__default.NextOpt
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box :: 
    { LruModel.__default.NextOpt($ly, q#0) } 
    LruModel.__default.NextOpt#canCall(q#0)
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> (Options.Option.Some_q(LruModel.__default.NextOpt($ly, q#0))
           ==> LruModel.__default.I(q#0)[Options.Option.value(LruModel.__default.NextOpt($ly, q#0))])
         && (Options.Option.None_q(LruModel.__default.NextOpt($ly, q#0))
           ==> Set#Equal(LruModel.__default.I(q#0), Set#Empty(): Set Box))
         && $Is(LruModel.__default.NextOpt($ly, q#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function LruModel.__default.NextOpt#requires(LayerType, Seq Box) : bool;

// #requires axiom for LruModel.__default.NextOpt
axiom (forall $ly: LayerType, q#0: Seq Box :: 
  { LruModel.__default.NextOpt#requires($ly, q#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> LruModel.__default.NextOpt#requires($ly, q#0) == true);

// definition axiom for LruModel.__default.NextOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box :: 
    { LruModel.__default.NextOpt($LS($ly), q#0) } 
    LruModel.__default.NextOpt#canCall(q#0)
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.NextOpt($LS($ly), q#0)
         == (if Seq#Equal(q#0, Seq#Empty(): Seq Box)
           then #Options.Option.None()
           else #Options.Option.Some(Seq#Index(q#0, LitInt(0)))));

// definition axiom for LruModel.__default.NextOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, q#0: Seq Box :: 
    {:weight 3} { LruModel.__default.NextOpt($LS($ly), Lit(q#0)) } 
    LruModel.__default.NextOpt#canCall(Lit(q#0))
         || $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       ==> LruModel.__default.NextOpt($LS($ly), Lit(q#0))
         == (if Seq#Equal(q#0, Seq#Empty(): Seq Box)
           then #Options.Option.None()
           else #Options.Option.Some(Seq#Index(Lit(q#0), LitInt(0)))));

// function declaration for LruModel._default.Pop
function LruModel.__default.Pop(q#0: Seq Box) : DatatypeType;

function LruModel.__default.Pop#canCall(q#0: Seq Box) : bool;

// consequence axiom for LruModel.__default.Pop
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.Pop(q#0) } 
    LruModel.__default.Pop#canCall(q#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && Set#Card(LruModel.__default.I(q#0)) > 0)
       ==> $Is(LruModel.__default.Pop(q#0), 
        Tclass._System.Tuple2(TSeq(Tclass.NativeTypes.uint64()), Tclass.NativeTypes.uint64())));

function LruModel.__default.Pop#requires(Seq Box) : bool;

// #requires axiom for LruModel.__default.Pop
axiom (forall q#0: Seq Box :: 
  { LruModel.__default.Pop#requires(q#0) } 
  $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> LruModel.__default.Pop#requires(q#0)
       == (Set#Card(LruModel.__default.I(q#0)) > 0));

// definition axiom for LruModel.__default.Pop(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    { LruModel.__default.Pop(q#0) } 
    LruModel.__default.Pop#canCall(q#0)
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && Set#Card(LruModel.__default.I(q#0)) > 0)
       ==> LruModel.__default.Pop(q#0)
         == #_System._tuple#2._#Make2($Box(Seq#Drop(q#0, LitInt(1))), Seq#Index(q#0, LitInt(0))));

// definition axiom for LruModel.__default.Pop for all literals(revealed)
axiom true
   ==> (forall q#0: Seq Box :: 
    {:weight 3} { LruModel.__default.Pop(Lit(q#0)) } 
    LruModel.__default.Pop#canCall(Lit(q#0))
         || ($Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && Set#Card(Lit(LruModel.__default.I(Lit(q#0)))) > 0)
       ==> LruModel.__default.Pop(Lit(q#0))
         == #_System._tuple#2._#Make2($Box(Lit(Seq#Drop(Lit(q#0), LitInt(1)))), Seq#Index(Lit(q#0), LitInt(0))));

procedure CheckWellformed$$LruModel.__default.LruUse(q#0: Seq Box
       where $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    x#0: int where LitInt(0) <= x#0 && x#0 < 18446744073709551616);
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$LruModel.__default.LruUse(q#0: Seq Box
       where $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    x#0: int where LitInt(0) <= x#0 && x#0 < 18446744073709551616);
  // user-defined preconditions
  requires LruModel.__default.WF#canCall(q#0)
     ==> LruModel.__default.WF(q#0)
       || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, q#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LruModel.__default.Use#canCall(q#0, x#0)
     && LruModel.__default.WF#canCall(LruModel.__default.Use(q#0, x#0));
  free ensures LruModel.__default.WF#canCall(LruModel.__default.Use(q#0, x#0))
     && 
    LruModel.__default.WF(LruModel.__default.Use(q#0, x#0))
     && $Is(LruModel.__default.Use(q#0, x#0), TSeq(Tclass.NativeTypes.uint64()))
     && LruModel.__default.distinct(StartFuel_LruModel._default.distinct, LruModel.__default.Use(q#0, x#0));
  free ensures LruModel.__default.Use#canCall(q#0, x#0)
     && LruModel.__default.I#canCall(LruModel.__default.Use(q#0, x#0))
     && LruModel.__default.I#canCall(q#0);
  ensures Set#Equal(LruModel.__default.I(LruModel.__default.Use(q#0, x#0)), 
    Set#Union(LruModel.__default.I(q#0), Set#UnionOne(Set#Empty(): Set Box, $Box(x#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



const unique class.SetBijectivity.__default: ClassName;

function Tclass.SetBijectivity.__default() : Ty;

// Tclass.SetBijectivity.__default Tag
axiom Tag(Tclass.SetBijectivity.__default()) == Tagclass.SetBijectivity.__default;

const unique Tagclass.SetBijectivity.__default: TyTag;

// Box/unbox axiom for Tclass.SetBijectivity.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.SetBijectivity.__default()) } 
  $IsBox(bx, Tclass.SetBijectivity.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.SetBijectivity.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.SetBijectivity.__default()) } 
  $Is($o, Tclass.SetBijectivity.__default())
     <==> $o == null || dtype($o) == Tclass.SetBijectivity.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.SetBijectivity.__default(), $h) } 
  $IsAlloc($o, Tclass.SetBijectivity.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique class.NativeArithmetic.__default: ClassName;

function Tclass.NativeArithmetic.__default() : Ty;

// Tclass.NativeArithmetic.__default Tag
axiom Tag(Tclass.NativeArithmetic.__default()) == Tagclass.NativeArithmetic.__default;

const unique Tagclass.NativeArithmetic.__default: TyTag;

// Box/unbox axiom for Tclass.NativeArithmetic.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.NativeArithmetic.__default()) } 
  $IsBox(bx, Tclass.NativeArithmetic.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.NativeArithmetic.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.NativeArithmetic.__default()) } 
  $Is($o, Tclass.NativeArithmetic.__default())
     <==> $o == null || dtype($o) == Tclass.NativeArithmetic.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.NativeArithmetic.__default(), $h) } 
  $IsAlloc($o, Tclass.NativeArithmetic.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for NativeArithmetic._default.u64add
function NativeArithmetic.__default.u64add(a#0: int, b#0: int) : int;

function NativeArithmetic.__default.u64add#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for NativeArithmetic.__default.u64add
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { NativeArithmetic.__default.u64add(a#0, b#0) } 
    NativeArithmetic.__default.u64add#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> NativeArithmetic.__default.u64add(a#0, b#0)
           == (if a#0 + b#0 < 18446744073709551616
             then a#0 + b#0
             else a#0 + b#0 - 18446744073709551616)
         && 
        LitInt(0) <= NativeArithmetic.__default.u64add(a#0, b#0)
         && NativeArithmetic.__default.u64add(a#0, b#0) < 18446744073709551616);

function NativeArithmetic.__default.u64add#requires(int, int) : bool;

// #requires axiom for NativeArithmetic.__default.u64add
axiom (forall a#0: int, b#0: int :: 
  { NativeArithmetic.__default.u64add#requires(a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> NativeArithmetic.__default.u64add#requires(a#0, b#0) == true);

// Constructor function declaration
function #MutableMapModel.Slot.Slot(int) : DatatypeType;

const unique ##MutableMapModel.Slot.Slot: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int :: 
  { #MutableMapModel.Slot.Slot(a#0#0#0) } 
  DatatypeCtorId(#MutableMapModel.Slot.Slot(a#0#0#0))
     == ##MutableMapModel.Slot.Slot);

function MutableMapModel.Slot.Slot_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Slot.Slot_q(d) } 
  MutableMapModel.Slot.Slot_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.Slot.Slot);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Slot.Slot_q(d) } 
  MutableMapModel.Slot.Slot_q(d)
     ==> (exists a#1#0#0: int :: d == #MutableMapModel.Slot.Slot(a#1#0#0)));

function Tclass.MutableMapModel.Slot() : Ty;

// Tclass.MutableMapModel.Slot Tag
axiom Tag(Tclass.MutableMapModel.Slot()) == Tagclass.MutableMapModel.Slot;

const unique Tagclass.MutableMapModel.Slot: TyTag;

// Box/unbox axiom for Tclass.MutableMapModel.Slot
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.Slot()) } 
  $IsBox(bx, Tclass.MutableMapModel.Slot())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MutableMapModel.Slot()));

// Constructor $Is
axiom (forall a#2#0#0: int :: 
  { $Is(#MutableMapModel.Slot.Slot(a#2#0#0), Tclass.MutableMapModel.Slot()) } 
  $Is(#MutableMapModel.Slot.Slot(a#2#0#0), Tclass.MutableMapModel.Slot())
     <==> $Is(a#2#0#0, Tclass._System.nat()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.Slot.Slot(a#3#0#0), Tclass.MutableMapModel.Slot(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.Slot.Slot(a#3#0#0), Tclass.MutableMapModel.Slot(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass._System.nat(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Slot.slot(d), Tclass._System.nat(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Slot.Slot_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.Slot(), $h)
     ==> $IsAlloc(MutableMapModel.Slot.slot(d), Tclass._System.nat(), $h));

// Constructor literal
axiom (forall a#4#0#0: int :: 
  { #MutableMapModel.Slot.Slot(LitInt(a#4#0#0)) } 
  #MutableMapModel.Slot.Slot(LitInt(a#4#0#0))
     == Lit(#MutableMapModel.Slot.Slot(a#4#0#0)));

function MutableMapModel.Slot.slot(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int :: 
  { #MutableMapModel.Slot.Slot(a#5#0#0) } 
  MutableMapModel.Slot.slot(#MutableMapModel.Slot.Slot(a#5#0#0)) == a#5#0#0);

// Depth-one case-split function
function $IsA#MutableMapModel.Slot(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.Slot(d) } 
  $IsA#MutableMapModel.Slot(d) ==> MutableMapModel.Slot.Slot_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Slot.Slot_q(d), $Is(d, Tclass.MutableMapModel.Slot()) } 
  $Is(d, Tclass.MutableMapModel.Slot()) ==> MutableMapModel.Slot.Slot_q(d));

// Datatype extensional equality declaration
function MutableMapModel.Slot#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.Slot.Slot
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Slot#Equal(a, b) } 
  true
     ==> (MutableMapModel.Slot#Equal(a, b)
       <==> MutableMapModel.Slot.slot(a) == MutableMapModel.Slot.slot(b)));

// Datatype extensionality axiom: MutableMapModel.Slot
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Slot#Equal(a, b) } 
  MutableMapModel.Slot#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.Slot: ClassName;

// Constructor function declaration
function #MutableMapModel.Item.Empty() : DatatypeType;

const unique ##MutableMapModel.Item.Empty: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#MutableMapModel.Item.Empty()) == ##MutableMapModel.Item.Empty;

function MutableMapModel.Item.Empty_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Item.Empty_q(d) } 
  MutableMapModel.Item.Empty_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.Item.Empty);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Item.Empty_q(d) } 
  MutableMapModel.Item.Empty_q(d) ==> d == #MutableMapModel.Item.Empty());

function Tclass.MutableMapModel.Item(Ty) : Ty;

// Tclass.MutableMapModel.Item Tag
axiom (forall MutableMapModel.Item$V: Ty :: 
  { Tclass.MutableMapModel.Item(MutableMapModel.Item$V) } 
  Tag(Tclass.MutableMapModel.Item(MutableMapModel.Item$V))
     == Tagclass.MutableMapModel.Item);

const unique Tagclass.MutableMapModel.Item: TyTag;

// Tclass.MutableMapModel.Item injectivity 0
axiom (forall MutableMapModel.Item$V: Ty :: 
  { Tclass.MutableMapModel.Item(MutableMapModel.Item$V) } 
  Tclass.MutableMapModel.Item_0(Tclass.MutableMapModel.Item(MutableMapModel.Item$V))
     == MutableMapModel.Item$V);

function Tclass.MutableMapModel.Item_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMapModel.Item
axiom (forall MutableMapModel.Item$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
  $IsBox(bx, Tclass.MutableMapModel.Item(MutableMapModel.Item$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.MutableMapModel.Item(MutableMapModel.Item$V)));

// Constructor $Is
axiom (forall MutableMapModel.Item$V: Ty :: 
  { $Is(#MutableMapModel.Item.Empty(), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
  $Is(#MutableMapModel.Item.Empty(), 
    Tclass.MutableMapModel.Item(MutableMapModel.Item$V)));

// Constructor $IsAlloc
axiom (forall MutableMapModel.Item$V: Ty, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.Item.Empty(), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#MutableMapModel.Item.Empty(), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V), 
      $h));

// Constructor literal
axiom #MutableMapModel.Item.Empty() == Lit(#MutableMapModel.Item.Empty());

// Constructor function declaration
function #MutableMapModel.Item.Entry(int, Box) : DatatypeType;

const unique ##MutableMapModel.Item.Entry: DtCtorId;

// Constructor identifier
axiom (forall a#11#0#0: int, a#11#1#0: Box :: 
  { #MutableMapModel.Item.Entry(a#11#0#0, a#11#1#0) } 
  DatatypeCtorId(#MutableMapModel.Item.Entry(a#11#0#0, a#11#1#0))
     == ##MutableMapModel.Item.Entry);

function MutableMapModel.Item.Entry_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Item.Entry_q(d) } 
  MutableMapModel.Item.Entry_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.Item.Entry);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Item.Entry_q(d) } 
  MutableMapModel.Item.Entry_q(d)
     ==> (exists a#12#0#0: int, a#12#1#0: Box :: 
      d == #MutableMapModel.Item.Entry(a#12#0#0, a#12#1#0)));

// Constructor $Is
axiom (forall MutableMapModel.Item$V: Ty, a#13#0#0: int, a#13#1#0: Box :: 
  { $Is(#MutableMapModel.Item.Entry(a#13#0#0, a#13#1#0), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
  $Is(#MutableMapModel.Item.Entry(a#13#0#0, a#13#1#0), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V))
     <==> $Is(a#13#0#0, Tclass.NativeTypes.uint64())
       && $IsBox(a#13#1#0, MutableMapModel.Item$V));

// Constructor $IsAlloc
axiom (forall MutableMapModel.Item$V: Ty, a#14#0#0: int, a#14#1#0: Box, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.Item.Entry(a#14#0#0, a#14#1#0), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.Item.Entry(a#14#0#0, a#14#1#0), 
        Tclass.MutableMapModel.Item(MutableMapModel.Item$V), 
        $h)
       <==> $IsAlloc(a#14#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAllocBox(a#14#1#0, MutableMapModel.Item$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Item.key(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Item.Entry_q(d)
       && (exists MutableMapModel.Item$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V), $h))
     ==> $IsAlloc(MutableMapModel.Item.key(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.Item$V: Ty, $h: Heap :: 
  { $IsAllocBox(MutableMapModel.Item.value(d), MutableMapModel.Item$V, $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Item.Entry_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V), $h)
     ==> $IsAllocBox(MutableMapModel.Item.value(d), MutableMapModel.Item$V, $h));

// Constructor literal
axiom (forall a#15#0#0: int, a#15#1#0: Box :: 
  { #MutableMapModel.Item.Entry(LitInt(a#15#0#0), Lit(a#15#1#0)) } 
  #MutableMapModel.Item.Entry(LitInt(a#15#0#0), Lit(a#15#1#0))
     == Lit(#MutableMapModel.Item.Entry(a#15#0#0, a#15#1#0)));

function MutableMapModel.Item.key(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#16#0#0: int, a#16#1#0: Box :: 
  { #MutableMapModel.Item.Entry(a#16#0#0, a#16#1#0) } 
  MutableMapModel.Item.key(#MutableMapModel.Item.Entry(a#16#0#0, a#16#1#0))
     == a#16#0#0);

function MutableMapModel.Item.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#17#0#0: int, a#17#1#0: Box :: 
  { #MutableMapModel.Item.Entry(a#17#0#0, a#17#1#0) } 
  MutableMapModel.Item.value(#MutableMapModel.Item.Entry(a#17#0#0, a#17#1#0))
     == a#17#1#0);

// Inductive rank
axiom (forall a#18#0#0: int, a#18#1#0: Box :: 
  { #MutableMapModel.Item.Entry(a#18#0#0, a#18#1#0) } 
  BoxRank(a#18#1#0) < DtRank(#MutableMapModel.Item.Entry(a#18#0#0, a#18#1#0)));

// Constructor function declaration
function #MutableMapModel.Item.Tombstone(int) : DatatypeType;

const unique ##MutableMapModel.Item.Tombstone: DtCtorId;

// Constructor identifier
axiom (forall a#19#0#0: int :: 
  { #MutableMapModel.Item.Tombstone(a#19#0#0) } 
  DatatypeCtorId(#MutableMapModel.Item.Tombstone(a#19#0#0))
     == ##MutableMapModel.Item.Tombstone);

function MutableMapModel.Item.Tombstone_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Item.Tombstone_q(d) } 
  MutableMapModel.Item.Tombstone_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.Item.Tombstone);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Item.Tombstone_q(d) } 
  MutableMapModel.Item.Tombstone_q(d)
     ==> (exists a#20#0#0: int :: d == #MutableMapModel.Item.Tombstone(a#20#0#0)));

// Constructor $Is
axiom (forall MutableMapModel.Item$V: Ty, a#21#0#0: int :: 
  { $Is(#MutableMapModel.Item.Tombstone(a#21#0#0), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
  $Is(#MutableMapModel.Item.Tombstone(a#21#0#0), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V))
     <==> $Is(a#21#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall MutableMapModel.Item$V: Ty, a#22#0#0: int, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.Item.Tombstone(a#22#0#0), 
      Tclass.MutableMapModel.Item(MutableMapModel.Item$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.Item.Tombstone(a#22#0#0), 
        Tclass.MutableMapModel.Item(MutableMapModel.Item$V), 
        $h)
       <==> $IsAlloc(a#22#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Item.key(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Item.Tombstone_q(d)
       && (exists MutableMapModel.Item$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V), $h))
     ==> $IsAlloc(MutableMapModel.Item.key(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#23#0#0: int :: 
  { #MutableMapModel.Item.Tombstone(LitInt(a#23#0#0)) } 
  #MutableMapModel.Item.Tombstone(LitInt(a#23#0#0))
     == Lit(#MutableMapModel.Item.Tombstone(a#23#0#0)));

// Constructor injectivity
axiom (forall a#24#0#0: int :: 
  { #MutableMapModel.Item.Tombstone(a#24#0#0) } 
  MutableMapModel.Item.key(#MutableMapModel.Item.Tombstone(a#24#0#0)) == a#24#0#0);

// Depth-one case-split function
function $IsA#MutableMapModel.Item(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.Item(d) } 
  $IsA#MutableMapModel.Item(d)
     ==> MutableMapModel.Item.Empty_q(d)
       || MutableMapModel.Item.Entry_q(d)
       || MutableMapModel.Item.Tombstone_q(d));

// Questionmark data type disjunctivity
axiom (forall MutableMapModel.Item$V: Ty, d: DatatypeType :: 
  { MutableMapModel.Item.Tombstone_q(d), $Is(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
    { MutableMapModel.Item.Entry_q(d), $Is(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
    { MutableMapModel.Item.Empty_q(d), $Is(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V)) } 
  $Is(d, Tclass.MutableMapModel.Item(MutableMapModel.Item$V))
     ==> MutableMapModel.Item.Empty_q(d)
       || MutableMapModel.Item.Entry_q(d)
       || MutableMapModel.Item.Tombstone_q(d));

// Datatype extensional equality declaration
function MutableMapModel.Item#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.Item.Empty
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Item#Equal(a, b), MutableMapModel.Item.Empty_q(a) } 
    { MutableMapModel.Item#Equal(a, b), MutableMapModel.Item.Empty_q(b) } 
  MutableMapModel.Item.Empty_q(a) && MutableMapModel.Item.Empty_q(b)
     ==> (MutableMapModel.Item#Equal(a, b) <==> true));

// Datatype extensional equality definition: #MutableMapModel.Item.Entry
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Item#Equal(a, b), MutableMapModel.Item.Entry_q(a) } 
    { MutableMapModel.Item#Equal(a, b), MutableMapModel.Item.Entry_q(b) } 
  MutableMapModel.Item.Entry_q(a) && MutableMapModel.Item.Entry_q(b)
     ==> (MutableMapModel.Item#Equal(a, b)
       <==> MutableMapModel.Item.key(a) == MutableMapModel.Item.key(b)
         && MutableMapModel.Item.value(a) == MutableMapModel.Item.value(b)));

// Datatype extensional equality definition: #MutableMapModel.Item.Tombstone
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Item#Equal(a, b), MutableMapModel.Item.Tombstone_q(a) } 
    { MutableMapModel.Item#Equal(a, b), MutableMapModel.Item.Tombstone_q(b) } 
  MutableMapModel.Item.Tombstone_q(a) && MutableMapModel.Item.Tombstone_q(b)
     ==> (MutableMapModel.Item#Equal(a, b)
       <==> MutableMapModel.Item.key(a) == MutableMapModel.Item.key(b)));

// Datatype extensionality axiom: MutableMapModel.Item
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Item#Equal(a, b) } 
  MutableMapModel.Item#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.Item: ClassName;

// Constructor function declaration
function #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Seq Box, int, Map Box Box) : DatatypeType;

const unique ##MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap: DtCtorId;

// Constructor identifier
axiom (forall a#25#0#0: Seq Box, a#25#1#0: int, a#25#2#0: Map Box Box :: 
  { #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#25#0#0, a#25#1#0, a#25#2#0) } 
  DatatypeCtorId(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#25#0#0, a#25#1#0, a#25#2#0))
     == ##MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap);

function MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d) } 
  MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d)
     <==> DatatypeCtorId(d)
       == ##MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d) } 
  MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d)
     ==> (exists a#26#0#0: Seq Box, a#26#1#0: int, a#26#2#0: Map Box Box :: 
      d
         == #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#26#0#0, a#26#1#0, a#26#2#0)));

function Tclass.MutableMapModel.FixedSizeLinearHashMap(Ty) : Ty;

// Tclass.MutableMapModel.FixedSizeLinearHashMap Tag
axiom (forall MutableMapModel.FixedSizeLinearHashMap$V: Ty :: 
  { Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V) } 
  Tag(Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V))
     == Tagclass.MutableMapModel.FixedSizeLinearHashMap);

const unique Tagclass.MutableMapModel.FixedSizeLinearHashMap: TyTag;

// Tclass.MutableMapModel.FixedSizeLinearHashMap injectivity 0
axiom (forall MutableMapModel.FixedSizeLinearHashMap$V: Ty :: 
  { Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V) } 
  Tclass.MutableMapModel.FixedSizeLinearHashMap_0(Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V))
     == MutableMapModel.FixedSizeLinearHashMap$V);

function Tclass.MutableMapModel.FixedSizeLinearHashMap_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMapModel.FixedSizeLinearHashMap
axiom (forall MutableMapModel.FixedSizeLinearHashMap$V: Ty, bx: Box :: 
  { $IsBox(bx, 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V)) } 
  $IsBox(bx, 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V)));

// Constructor $Is
axiom (forall MutableMapModel.FixedSizeLinearHashMap$V: Ty, 
    a#27#0#0: Seq Box, 
    a#27#1#0: int, 
    a#27#2#0: Map Box Box :: 
  { $Is(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#27#0#0, a#27#1#0, a#27#2#0), 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V)) } 
  $Is(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#27#0#0, a#27#1#0, a#27#2#0), 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V))
     <==> $Is(a#27#0#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel.FixedSizeLinearHashMap$V)))
       && $Is(a#27#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#27#2#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel.FixedSizeLinearHashMap$V))));

// Constructor $IsAlloc
axiom (forall MutableMapModel.FixedSizeLinearHashMap$V: Ty, 
    a#28#0#0: Seq Box, 
    a#28#1#0: int, 
    a#28#2#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#28#0#0, a#28#1#0, a#28#2#0), 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#28#0#0, a#28#1#0, a#28#2#0), 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V), 
        $h)
       <==> $IsAlloc(a#28#0#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel.FixedSizeLinearHashMap$V)), 
          $h)
         && $IsAlloc(a#28#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#28#2#0, 
          TMap(Tclass.NativeTypes.uint64(), 
            Tclass.Options.Option(MutableMapModel.FixedSizeLinearHashMap$V)), 
          $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.FixedSizeLinearHashMap$V: Ty, $h: Heap :: 
  { $IsAlloc(MutableMapModel.FixedSizeLinearHashMap.storage(d), 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel.FixedSizeLinearHashMap$V)), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d)
       && $IsAlloc(d, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V), 
        $h)
     ==> $IsAlloc(MutableMapModel.FixedSizeLinearHashMap.storage(d), 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel.FixedSizeLinearHashMap$V)), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.FixedSizeLinearHashMap.count(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d)
       && (exists MutableMapModel.FixedSizeLinearHashMap$V: Ty :: 
        { $IsAlloc(d, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V), 
            $h) } 
        $IsAlloc(d, 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V), 
          $h))
     ==> $IsAlloc(MutableMapModel.FixedSizeLinearHashMap.count(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.FixedSizeLinearHashMap$V: Ty, $h: Heap :: 
  { $IsAlloc(MutableMapModel.FixedSizeLinearHashMap.contents(d), 
      TMap(Tclass.NativeTypes.uint64(), 
        Tclass.Options.Option(MutableMapModel.FixedSizeLinearHashMap$V)), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d)
       && $IsAlloc(d, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V), 
        $h)
     ==> $IsAlloc(MutableMapModel.FixedSizeLinearHashMap.contents(d), 
      TMap(Tclass.NativeTypes.uint64(), 
        Tclass.Options.Option(MutableMapModel.FixedSizeLinearHashMap$V)), 
      $h));

// Constructor literal
axiom (forall a#29#0#0: Seq Box, a#29#1#0: int, a#29#2#0: Map Box Box :: 
  { #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Lit(a#29#0#0), LitInt(a#29#1#0), Lit(a#29#2#0)) } 
  #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Lit(a#29#0#0), LitInt(a#29#1#0), Lit(a#29#2#0))
     == Lit(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#29#0#0, a#29#1#0, a#29#2#0)));

function MutableMapModel.FixedSizeLinearHashMap.storage(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#30#0#0: Seq Box, a#30#1#0: int, a#30#2#0: Map Box Box :: 
  { #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#30#0#0, a#30#1#0, a#30#2#0) } 
  MutableMapModel.FixedSizeLinearHashMap.storage(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#30#0#0, a#30#1#0, a#30#2#0))
     == a#30#0#0);

// Inductive seq element rank
axiom (forall a#31#0#0: Seq Box, a#31#1#0: int, a#31#2#0: Map Box Box, i: int :: 
  { Seq#Index(a#31#0#0, i), #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#31#0#0, a#31#1#0, a#31#2#0) } 
  0 <= i && i < Seq#Length(a#31#0#0)
     ==> DtRank($Unbox(Seq#Index(a#31#0#0, i)): DatatypeType)
       < DtRank(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#31#0#0, a#31#1#0, a#31#2#0)));

// Inductive seq rank
axiom (forall a#32#0#0: Seq Box, a#32#1#0: int, a#32#2#0: Map Box Box :: 
  { #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#32#0#0, a#32#1#0, a#32#2#0) } 
  Seq#Rank(a#32#0#0)
     < DtRank(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#32#0#0, a#32#1#0, a#32#2#0)));

function MutableMapModel.FixedSizeLinearHashMap.count(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#33#0#0: Seq Box, a#33#1#0: int, a#33#2#0: Map Box Box :: 
  { #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#33#0#0, a#33#1#0, a#33#2#0) } 
  MutableMapModel.FixedSizeLinearHashMap.count(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#33#0#0, a#33#1#0, a#33#2#0))
     == a#33#1#0);

function MutableMapModel.FixedSizeLinearHashMap.contents(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#34#0#0: Seq Box, a#34#1#0: int, a#34#2#0: Map Box Box :: 
  { #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#34#0#0, a#34#1#0, a#34#2#0) } 
  MutableMapModel.FixedSizeLinearHashMap.contents(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#34#0#0, a#34#1#0, a#34#2#0))
     == a#34#2#0);

// Inductive map key rank
axiom (forall a#35#0#0: Seq Box, a#35#1#0: int, a#35#2#0: Map Box Box, d: DatatypeType :: 
  { Map#Domain(a#35#2#0)[$Box(d)], #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#35#0#0, a#35#1#0, a#35#2#0) } 
  Map#Domain(a#35#2#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#35#0#0, a#35#1#0, a#35#2#0)));

// Inductive map value rank
axiom (forall a#36#0#0: Seq Box, a#36#1#0: int, a#36#2#0: Map Box Box, bx: Box :: 
  { Map#Domain(a#36#2#0)[bx], #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#36#0#0, a#36#1#0, a#36#2#0) } 
  Map#Domain(a#36#2#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#36#2#0)[bx]): DatatypeType)
       < DtRank(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(a#36#0#0, a#36#1#0, a#36#2#0)));

// Depth-one case-split function
function $IsA#MutableMapModel.FixedSizeLinearHashMap(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.FixedSizeLinearHashMap(d) } 
  $IsA#MutableMapModel.FixedSizeLinearHashMap(d)
     ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d));

// Questionmark data type disjunctivity
axiom (forall MutableMapModel.FixedSizeLinearHashMap$V: Ty, d: DatatypeType :: 
  { MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d), $Is(d, 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V)) } 
  $Is(d, 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.FixedSizeLinearHashMap$V))
     ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(d));

// Datatype extensional equality declaration
function MutableMapModel.FixedSizeLinearHashMap#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.FixedSizeLinearHashMap#Equal(a, b) } 
  true
     ==> (MutableMapModel.FixedSizeLinearHashMap#Equal(a, b)
       <==> Seq#Equal(MutableMapModel.FixedSizeLinearHashMap.storage(a), 
          MutableMapModel.FixedSizeLinearHashMap.storage(b))
         && MutableMapModel.FixedSizeLinearHashMap.count(a)
           == MutableMapModel.FixedSizeLinearHashMap.count(b)
         && Map#Equal(MutableMapModel.FixedSizeLinearHashMap.contents(a), 
          MutableMapModel.FixedSizeLinearHashMap.contents(b))));

// Datatype extensionality axiom: MutableMapModel.FixedSizeLinearHashMap
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.FixedSizeLinearHashMap#Equal(a, b) } 
  MutableMapModel.FixedSizeLinearHashMap#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.FixedSizeLinearHashMap: ClassName;

// Constructor function declaration
function #MutableMapModel.ProbeResult.ProbeResult(int, int, int) : DatatypeType;

const unique ##MutableMapModel.ProbeResult.ProbeResult: DtCtorId;

// Constructor identifier
axiom (forall a#37#0#0: int, a#37#1#0: int, a#37#2#0: int :: 
  { #MutableMapModel.ProbeResult.ProbeResult(a#37#0#0, a#37#1#0, a#37#2#0) } 
  DatatypeCtorId(#MutableMapModel.ProbeResult.ProbeResult(a#37#0#0, a#37#1#0, a#37#2#0))
     == ##MutableMapModel.ProbeResult.ProbeResult);

function MutableMapModel.ProbeResult.ProbeResult_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.ProbeResult.ProbeResult_q(d) } 
  MutableMapModel.ProbeResult.ProbeResult_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.ProbeResult.ProbeResult);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.ProbeResult.ProbeResult_q(d) } 
  MutableMapModel.ProbeResult.ProbeResult_q(d)
     ==> (exists a#38#0#0: int, a#38#1#0: int, a#38#2#0: int :: 
      d == #MutableMapModel.ProbeResult.ProbeResult(a#38#0#0, a#38#1#0, a#38#2#0)));

function Tclass.MutableMapModel.ProbeResult(Ty) : Ty;

// Tclass.MutableMapModel.ProbeResult Tag
axiom (forall MutableMapModel.ProbeResult$V: Ty :: 
  { Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V) } 
  Tag(Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V))
     == Tagclass.MutableMapModel.ProbeResult);

const unique Tagclass.MutableMapModel.ProbeResult: TyTag;

// Tclass.MutableMapModel.ProbeResult injectivity 0
axiom (forall MutableMapModel.ProbeResult$V: Ty :: 
  { Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V) } 
  Tclass.MutableMapModel.ProbeResult_0(Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V))
     == MutableMapModel.ProbeResult$V);

function Tclass.MutableMapModel.ProbeResult_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMapModel.ProbeResult
axiom (forall MutableMapModel.ProbeResult$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V)) } 
  $IsBox(bx, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V))
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, 
        Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V)));

// Constructor $Is
axiom (forall MutableMapModel.ProbeResult$V: Ty, a#39#0#0: int, a#39#1#0: int, a#39#2#0: int :: 
  { $Is(#MutableMapModel.ProbeResult.ProbeResult(a#39#0#0, a#39#1#0, a#39#2#0), 
      Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V)) } 
  $Is(#MutableMapModel.ProbeResult.ProbeResult(a#39#0#0, a#39#1#0, a#39#2#0), 
      Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V))
     <==> $Is(a#39#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#39#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#39#2#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall MutableMapModel.ProbeResult$V: Ty, 
    a#40#0#0: int, 
    a#40#1#0: int, 
    a#40#2#0: int, 
    $h: Heap :: 
  { $IsAlloc(#MutableMapModel.ProbeResult.ProbeResult(a#40#0#0, a#40#1#0, a#40#2#0), 
      Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.ProbeResult.ProbeResult(a#40#0#0, a#40#1#0, a#40#2#0), 
        Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), 
        $h)
       <==> $IsAlloc(a#40#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#40#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#40#2#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.ProbeResult.slotIdx(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.ProbeResult.ProbeResult_q(d)
       && (exists MutableMapModel.ProbeResult$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), $h))
     ==> $IsAlloc(MutableMapModel.ProbeResult.slotIdx(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.ProbeResult.startSlotIdx(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.ProbeResult.ProbeResult_q(d)
       && (exists MutableMapModel.ProbeResult$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), $h))
     ==> $IsAlloc(MutableMapModel.ProbeResult.startSlotIdx(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.ProbeResult.ghostSkips(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.ProbeResult.ProbeResult_q(d)
       && (exists MutableMapModel.ProbeResult$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V), $h))
     ==> $IsAlloc(MutableMapModel.ProbeResult.ghostSkips(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#41#0#0: int, a#41#1#0: int, a#41#2#0: int :: 
  { #MutableMapModel.ProbeResult.ProbeResult(LitInt(a#41#0#0), LitInt(a#41#1#0), LitInt(a#41#2#0)) } 
  #MutableMapModel.ProbeResult.ProbeResult(LitInt(a#41#0#0), LitInt(a#41#1#0), LitInt(a#41#2#0))
     == Lit(#MutableMapModel.ProbeResult.ProbeResult(a#41#0#0, a#41#1#0, a#41#2#0)));

function MutableMapModel.ProbeResult.slotIdx(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#42#0#0: int, a#42#1#0: int, a#42#2#0: int :: 
  { #MutableMapModel.ProbeResult.ProbeResult(a#42#0#0, a#42#1#0, a#42#2#0) } 
  MutableMapModel.ProbeResult.slotIdx(#MutableMapModel.ProbeResult.ProbeResult(a#42#0#0, a#42#1#0, a#42#2#0))
     == a#42#0#0);

function MutableMapModel.ProbeResult.startSlotIdx(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#43#0#0: int, a#43#1#0: int, a#43#2#0: int :: 
  { #MutableMapModel.ProbeResult.ProbeResult(a#43#0#0, a#43#1#0, a#43#2#0) } 
  MutableMapModel.ProbeResult.startSlotIdx(#MutableMapModel.ProbeResult.ProbeResult(a#43#0#0, a#43#1#0, a#43#2#0))
     == a#43#1#0);

function MutableMapModel.ProbeResult.ghostSkips(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#44#0#0: int, a#44#1#0: int, a#44#2#0: int :: 
  { #MutableMapModel.ProbeResult.ProbeResult(a#44#0#0, a#44#1#0, a#44#2#0) } 
  MutableMapModel.ProbeResult.ghostSkips(#MutableMapModel.ProbeResult.ProbeResult(a#44#0#0, a#44#1#0, a#44#2#0))
     == a#44#2#0);

// Depth-one case-split function
function $IsA#MutableMapModel.ProbeResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.ProbeResult(d) } 
  $IsA#MutableMapModel.ProbeResult(d)
     ==> MutableMapModel.ProbeResult.ProbeResult_q(d));

// Questionmark data type disjunctivity
axiom (forall MutableMapModel.ProbeResult$V: Ty, d: DatatypeType :: 
  { MutableMapModel.ProbeResult.ProbeResult_q(d), $Is(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V)) } 
  $Is(d, Tclass.MutableMapModel.ProbeResult(MutableMapModel.ProbeResult$V))
     ==> MutableMapModel.ProbeResult.ProbeResult_q(d));

// Datatype extensional equality declaration
function MutableMapModel.ProbeResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.ProbeResult.ProbeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.ProbeResult#Equal(a, b) } 
  true
     ==> (MutableMapModel.ProbeResult#Equal(a, b)
       <==> MutableMapModel.ProbeResult.slotIdx(a) == MutableMapModel.ProbeResult.slotIdx(b)
         && MutableMapModel.ProbeResult.startSlotIdx(a)
           == MutableMapModel.ProbeResult.startSlotIdx(b)
         && MutableMapModel.ProbeResult.ghostSkips(a)
           == MutableMapModel.ProbeResult.ghostSkips(b)));

// Datatype extensionality axiom: MutableMapModel.ProbeResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.ProbeResult#Equal(a, b) } 
  MutableMapModel.ProbeResult#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.ProbeResult: ClassName;

// Constructor function declaration
function #MutableMapModel.LinearHashMap.LinearHashMap(DatatypeType, int, Map Box Box) : DatatypeType;

const unique ##MutableMapModel.LinearHashMap.LinearHashMap: DtCtorId;

// Constructor identifier
axiom (forall a#45#0#0: DatatypeType, a#45#1#0: int, a#45#2#0: Map Box Box :: 
  { #MutableMapModel.LinearHashMap.LinearHashMap(a#45#0#0, a#45#1#0, a#45#2#0) } 
  DatatypeCtorId(#MutableMapModel.LinearHashMap.LinearHashMap(a#45#0#0, a#45#1#0, a#45#2#0))
     == ##MutableMapModel.LinearHashMap.LinearHashMap);

function MutableMapModel.LinearHashMap.LinearHashMap_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.LinearHashMap.LinearHashMap_q(d) } 
  MutableMapModel.LinearHashMap.LinearHashMap_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.LinearHashMap.LinearHashMap);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.LinearHashMap.LinearHashMap_q(d) } 
  MutableMapModel.LinearHashMap.LinearHashMap_q(d)
     ==> (exists a#46#0#0: DatatypeType, a#46#1#0: int, a#46#2#0: Map Box Box :: 
      d == #MutableMapModel.LinearHashMap.LinearHashMap(a#46#0#0, a#46#1#0, a#46#2#0)));

// Constructor $Is
axiom (forall MutableMapModel.LinearHashMap$V: Ty, 
    a#47#0#0: DatatypeType, 
    a#47#1#0: int, 
    a#47#2#0: Map Box Box :: 
  { $Is(#MutableMapModel.LinearHashMap.LinearHashMap(a#47#0#0, a#47#1#0, a#47#2#0), 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V)) } 
  $Is(#MutableMapModel.LinearHashMap.LinearHashMap(a#47#0#0, a#47#1#0, a#47#2#0), 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V))
     <==> $Is(a#47#0#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.LinearHashMap$V))
       && $Is(a#47#1#0, Tclass.NativeTypes.uint64())
       && $Is(a#47#2#0, TMap(Tclass.NativeTypes.uint64(), MutableMapModel.LinearHashMap$V)));

// Constructor $IsAlloc
axiom (forall MutableMapModel.LinearHashMap$V: Ty, 
    a#48#0#0: DatatypeType, 
    a#48#1#0: int, 
    a#48#2#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#MutableMapModel.LinearHashMap.LinearHashMap(a#48#0#0, a#48#1#0, a#48#2#0), 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.LinearHashMap.LinearHashMap(a#48#0#0, a#48#1#0, a#48#2#0), 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V), 
        $h)
       <==> $IsAlloc(a#48#0#0, 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.LinearHashMap$V), 
          $h)
         && $IsAlloc(a#48#1#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#48#2#0, TMap(Tclass.NativeTypes.uint64(), MutableMapModel.LinearHashMap$V), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.LinearHashMap$V: Ty, $h: Heap :: 
  { $IsAlloc(MutableMapModel.LinearHashMap.underlying(d), 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.LinearHashMap$V), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.LinearHashMap.LinearHashMap_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V), $h)
     ==> $IsAlloc(MutableMapModel.LinearHashMap.underlying(d), 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel.LinearHashMap$V), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.LinearHashMap.count(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.LinearHashMap.LinearHashMap_q(d)
       && (exists MutableMapModel.LinearHashMap$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V), $h))
     ==> $IsAlloc(MutableMapModel.LinearHashMap.count(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.LinearHashMap$V: Ty, $h: Heap :: 
  { $IsAlloc(MutableMapModel.LinearHashMap.contents(d), 
      TMap(Tclass.NativeTypes.uint64(), MutableMapModel.LinearHashMap$V), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.LinearHashMap.LinearHashMap_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V), $h)
     ==> $IsAlloc(MutableMapModel.LinearHashMap.contents(d), 
      TMap(Tclass.NativeTypes.uint64(), MutableMapModel.LinearHashMap$V), 
      $h));

// Constructor literal
axiom (forall a#49#0#0: DatatypeType, a#49#1#0: int, a#49#2#0: Map Box Box :: 
  { #MutableMapModel.LinearHashMap.LinearHashMap(Lit(a#49#0#0), LitInt(a#49#1#0), Lit(a#49#2#0)) } 
  #MutableMapModel.LinearHashMap.LinearHashMap(Lit(a#49#0#0), LitInt(a#49#1#0), Lit(a#49#2#0))
     == Lit(#MutableMapModel.LinearHashMap.LinearHashMap(a#49#0#0, a#49#1#0, a#49#2#0)));

function MutableMapModel.LinearHashMap.underlying(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#50#0#0: DatatypeType, a#50#1#0: int, a#50#2#0: Map Box Box :: 
  { #MutableMapModel.LinearHashMap.LinearHashMap(a#50#0#0, a#50#1#0, a#50#2#0) } 
  MutableMapModel.LinearHashMap.underlying(#MutableMapModel.LinearHashMap.LinearHashMap(a#50#0#0, a#50#1#0, a#50#2#0))
     == a#50#0#0);

// Inductive rank
axiom (forall a#51#0#0: DatatypeType, a#51#1#0: int, a#51#2#0: Map Box Box :: 
  { #MutableMapModel.LinearHashMap.LinearHashMap(a#51#0#0, a#51#1#0, a#51#2#0) } 
  DtRank(a#51#0#0)
     < DtRank(#MutableMapModel.LinearHashMap.LinearHashMap(a#51#0#0, a#51#1#0, a#51#2#0)));

function MutableMapModel.LinearHashMap.count(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#52#0#0: DatatypeType, a#52#1#0: int, a#52#2#0: Map Box Box :: 
  { #MutableMapModel.LinearHashMap.LinearHashMap(a#52#0#0, a#52#1#0, a#52#2#0) } 
  MutableMapModel.LinearHashMap.count(#MutableMapModel.LinearHashMap.LinearHashMap(a#52#0#0, a#52#1#0, a#52#2#0))
     == a#52#1#0);

function MutableMapModel.LinearHashMap.contents(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#53#0#0: DatatypeType, a#53#1#0: int, a#53#2#0: Map Box Box :: 
  { #MutableMapModel.LinearHashMap.LinearHashMap(a#53#0#0, a#53#1#0, a#53#2#0) } 
  MutableMapModel.LinearHashMap.contents(#MutableMapModel.LinearHashMap.LinearHashMap(a#53#0#0, a#53#1#0, a#53#2#0))
     == a#53#2#0);

// Inductive map key rank
axiom (forall a#54#0#0: DatatypeType, a#54#1#0: int, a#54#2#0: Map Box Box, d: DatatypeType :: 
  { Map#Domain(a#54#2#0)[$Box(d)], #MutableMapModel.LinearHashMap.LinearHashMap(a#54#0#0, a#54#1#0, a#54#2#0) } 
  Map#Domain(a#54#2#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#MutableMapModel.LinearHashMap.LinearHashMap(a#54#0#0, a#54#1#0, a#54#2#0)));

// Inductive map value rank
axiom (forall a#55#0#0: DatatypeType, a#55#1#0: int, a#55#2#0: Map Box Box, bx: Box :: 
  { Map#Domain(a#55#2#0)[bx], #MutableMapModel.LinearHashMap.LinearHashMap(a#55#0#0, a#55#1#0, a#55#2#0) } 
  Map#Domain(a#55#2#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#55#2#0)[bx]): DatatypeType)
       < DtRank(#MutableMapModel.LinearHashMap.LinearHashMap(a#55#0#0, a#55#1#0, a#55#2#0)));

// Depth-one case-split function
function $IsA#MutableMapModel.LinearHashMap(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.LinearHashMap(d) } 
  $IsA#MutableMapModel.LinearHashMap(d)
     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(d));

// Questionmark data type disjunctivity
axiom (forall MutableMapModel.LinearHashMap$V: Ty, d: DatatypeType :: 
  { MutableMapModel.LinearHashMap.LinearHashMap_q(d), $Is(d, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V)) } 
  $Is(d, Tclass.MutableMapModel.LinearHashMap(MutableMapModel.LinearHashMap$V))
     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(d));

// Datatype extensional equality declaration
function MutableMapModel.LinearHashMap#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.LinearHashMap.LinearHashMap
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.LinearHashMap#Equal(a, b) } 
  true
     ==> (MutableMapModel.LinearHashMap#Equal(a, b)
       <==> MutableMapModel.FixedSizeLinearHashMap#Equal(MutableMapModel.LinearHashMap.underlying(a), 
          MutableMapModel.LinearHashMap.underlying(b))
         && MutableMapModel.LinearHashMap.count(a) == MutableMapModel.LinearHashMap.count(b)
         && Map#Equal(MutableMapModel.LinearHashMap.contents(a), 
          MutableMapModel.LinearHashMap.contents(b))));

// Datatype extensionality axiom: MutableMapModel.LinearHashMap
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.LinearHashMap#Equal(a, b) } 
  MutableMapModel.LinearHashMap#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.LinearHashMap: ClassName;

// Constructor function declaration
function #MutableMapModel.IteratorOutput.Next(int, Box) : DatatypeType;

const unique ##MutableMapModel.IteratorOutput.Next: DtCtorId;

// Constructor identifier
axiom (forall a#56#0#0: int, a#56#1#0: Box :: 
  { #MutableMapModel.IteratorOutput.Next(a#56#0#0, a#56#1#0) } 
  DatatypeCtorId(#MutableMapModel.IteratorOutput.Next(a#56#0#0, a#56#1#0))
     == ##MutableMapModel.IteratorOutput.Next);

function MutableMapModel.IteratorOutput.Next_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.IteratorOutput.Next_q(d) } 
  MutableMapModel.IteratorOutput.Next_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.IteratorOutput.Next);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.IteratorOutput.Next_q(d) } 
  MutableMapModel.IteratorOutput.Next_q(d)
     ==> (exists a#57#0#0: int, a#57#1#0: Box :: 
      d == #MutableMapModel.IteratorOutput.Next(a#57#0#0, a#57#1#0)));

// Constructor $Is
axiom (forall MutableMapModel.IteratorOutput$V: Ty, a#58#0#0: int, a#58#1#0: Box :: 
  { $Is(#MutableMapModel.IteratorOutput.Next(a#58#0#0, a#58#1#0), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)) } 
  $Is(#MutableMapModel.IteratorOutput.Next(a#58#0#0, a#58#1#0), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V))
     <==> $Is(a#58#0#0, Tclass.NativeTypes.uint64())
       && $IsBox(a#58#1#0, MutableMapModel.IteratorOutput$V));

// Constructor $IsAlloc
axiom (forall MutableMapModel.IteratorOutput$V: Ty, a#59#0#0: int, a#59#1#0: Box, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.IteratorOutput.Next(a#59#0#0, a#59#1#0), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.IteratorOutput.Next(a#59#0#0, a#59#1#0), 
        Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), 
        $h)
       <==> $IsAlloc(a#59#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAllocBox(a#59#1#0, MutableMapModel.IteratorOutput$V, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.IteratorOutput.key(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.IteratorOutput.Next_q(d)
       && (exists MutableMapModel.IteratorOutput$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), $h))
     ==> $IsAlloc(MutableMapModel.IteratorOutput.key(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.IteratorOutput$V: Ty, $h: Heap :: 
  { $IsAllocBox(MutableMapModel.IteratorOutput.value(d), MutableMapModel.IteratorOutput$V, $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.IteratorOutput.Next_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), $h)
     ==> $IsAllocBox(MutableMapModel.IteratorOutput.value(d), MutableMapModel.IteratorOutput$V, $h));

// Constructor literal
axiom (forall a#60#0#0: int, a#60#1#0: Box :: 
  { #MutableMapModel.IteratorOutput.Next(LitInt(a#60#0#0), Lit(a#60#1#0)) } 
  #MutableMapModel.IteratorOutput.Next(LitInt(a#60#0#0), Lit(a#60#1#0))
     == Lit(#MutableMapModel.IteratorOutput.Next(a#60#0#0, a#60#1#0)));

function MutableMapModel.IteratorOutput.key(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#61#0#0: int, a#61#1#0: Box :: 
  { #MutableMapModel.IteratorOutput.Next(a#61#0#0, a#61#1#0) } 
  MutableMapModel.IteratorOutput.key(#MutableMapModel.IteratorOutput.Next(a#61#0#0, a#61#1#0))
     == a#61#0#0);

function MutableMapModel.IteratorOutput.value(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#62#0#0: int, a#62#1#0: Box :: 
  { #MutableMapModel.IteratorOutput.Next(a#62#0#0, a#62#1#0) } 
  MutableMapModel.IteratorOutput.value(#MutableMapModel.IteratorOutput.Next(a#62#0#0, a#62#1#0))
     == a#62#1#0);

// Inductive rank
axiom (forall a#63#0#0: int, a#63#1#0: Box :: 
  { #MutableMapModel.IteratorOutput.Next(a#63#0#0, a#63#1#0) } 
  BoxRank(a#63#1#0)
     < DtRank(#MutableMapModel.IteratorOutput.Next(a#63#0#0, a#63#1#0)));

// Constructor function declaration
function #MutableMapModel.IteratorOutput.Done() : DatatypeType;

const unique ##MutableMapModel.IteratorOutput.Done: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#MutableMapModel.IteratorOutput.Done())
   == ##MutableMapModel.IteratorOutput.Done;

function MutableMapModel.IteratorOutput.Done_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.IteratorOutput.Done_q(d) } 
  MutableMapModel.IteratorOutput.Done_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.IteratorOutput.Done);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.IteratorOutput.Done_q(d) } 
  MutableMapModel.IteratorOutput.Done_q(d)
     ==> d == #MutableMapModel.IteratorOutput.Done());

// Constructor $Is
axiom (forall MutableMapModel.IteratorOutput$V: Ty :: 
  { $Is(#MutableMapModel.IteratorOutput.Done(), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)) } 
  $Is(#MutableMapModel.IteratorOutput.Done(), 
    Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)));

// Constructor $IsAlloc
axiom (forall MutableMapModel.IteratorOutput$V: Ty, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.IteratorOutput.Done(), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#MutableMapModel.IteratorOutput.Done(), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V), 
      $h));

// Constructor literal
axiom #MutableMapModel.IteratorOutput.Done()
   == Lit(#MutableMapModel.IteratorOutput.Done());

// Depth-one case-split function
function $IsA#MutableMapModel.IteratorOutput(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.IteratorOutput(d) } 
  $IsA#MutableMapModel.IteratorOutput(d)
     ==> MutableMapModel.IteratorOutput.Next_q(d)
       || MutableMapModel.IteratorOutput.Done_q(d));

// Questionmark data type disjunctivity
axiom (forall MutableMapModel.IteratorOutput$V: Ty, d: DatatypeType :: 
  { MutableMapModel.IteratorOutput.Done_q(d), $Is(d, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)) } 
    { MutableMapModel.IteratorOutput.Next_q(d), $Is(d, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V)) } 
  $Is(d, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.IteratorOutput$V))
     ==> MutableMapModel.IteratorOutput.Next_q(d)
       || MutableMapModel.IteratorOutput.Done_q(d));

// Datatype extensional equality declaration
function MutableMapModel.IteratorOutput#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.IteratorOutput.Next
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.IteratorOutput#Equal(a, b), MutableMapModel.IteratorOutput.Next_q(a) } 
    { MutableMapModel.IteratorOutput#Equal(a, b), MutableMapModel.IteratorOutput.Next_q(b) } 
  MutableMapModel.IteratorOutput.Next_q(a)
       && MutableMapModel.IteratorOutput.Next_q(b)
     ==> (MutableMapModel.IteratorOutput#Equal(a, b)
       <==> MutableMapModel.IteratorOutput.key(a) == MutableMapModel.IteratorOutput.key(b)
         && MutableMapModel.IteratorOutput.value(a)
           == MutableMapModel.IteratorOutput.value(b)));

// Datatype extensional equality definition: #MutableMapModel.IteratorOutput.Done
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.IteratorOutput#Equal(a, b), MutableMapModel.IteratorOutput.Done_q(a) } 
    { MutableMapModel.IteratorOutput#Equal(a, b), MutableMapModel.IteratorOutput.Done_q(b) } 
  MutableMapModel.IteratorOutput.Done_q(a)
       && MutableMapModel.IteratorOutput.Done_q(b)
     ==> (MutableMapModel.IteratorOutput#Equal(a, b) <==> true));

// Datatype extensionality axiom: MutableMapModel.IteratorOutput
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.IteratorOutput#Equal(a, b) } 
  MutableMapModel.IteratorOutput#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.IteratorOutput: ClassName;

// Constructor function declaration
function #MutableMapModel.Iterator.Iterator(int, Set Box, Box, DatatypeType) : DatatypeType;

const unique ##MutableMapModel.Iterator.Iterator: DtCtorId;

// Constructor identifier
axiom (forall a#69#0#0: int, a#69#1#0: Set Box, a#69#2#0: Box, a#69#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(a#69#0#0, a#69#1#0, a#69#2#0, a#69#3#0) } 
  DatatypeCtorId(#MutableMapModel.Iterator.Iterator(a#69#0#0, a#69#1#0, a#69#2#0, a#69#3#0))
     == ##MutableMapModel.Iterator.Iterator);

function MutableMapModel.Iterator.Iterator_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Iterator.Iterator_q(d) } 
  MutableMapModel.Iterator.Iterator_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.Iterator.Iterator);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.Iterator.Iterator_q(d) } 
  MutableMapModel.Iterator.Iterator_q(d)
     ==> (exists a#70#0#0: int, a#70#1#0: Set Box, a#70#2#0: Box, a#70#3#0: DatatypeType :: 
      d == #MutableMapModel.Iterator.Iterator(a#70#0#0, a#70#1#0, a#70#2#0, a#70#3#0)));

// Constructor $Is
axiom (forall MutableMapModel.Iterator$V: Ty, 
    a#71#0#0: int, 
    a#71#1#0: Set Box, 
    a#71#2#0: Box, 
    a#71#3#0: DatatypeType :: 
  { $Is(#MutableMapModel.Iterator.Iterator(a#71#0#0, a#71#1#0, a#71#2#0, a#71#3#0), 
      Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V)) } 
  $Is(#MutableMapModel.Iterator.Iterator(a#71#0#0, a#71#1#0, a#71#2#0, a#71#3#0), 
      Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V))
     <==> $Is(a#71#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#71#1#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(a#71#2#0, TORDINAL)
       && $Is(a#71#3#0, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.Iterator$V)));

// Constructor $IsAlloc
axiom (forall MutableMapModel.Iterator$V: Ty, 
    a#72#0#0: int, 
    a#72#1#0: Set Box, 
    a#72#2#0: Box, 
    a#72#3#0: DatatypeType, 
    $h: Heap :: 
  { $IsAlloc(#MutableMapModel.Iterator.Iterator(a#72#0#0, a#72#1#0, a#72#2#0, a#72#3#0), 
      Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.Iterator.Iterator(a#72#0#0, a#72#1#0, a#72#2#0, a#72#3#0), 
        Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), 
        $h)
       <==> $IsAlloc(a#72#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#72#1#0, TSet(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#72#2#0, TORDINAL, $h)
         && $IsAlloc(a#72#3#0, Tclass.MutableMapModel.IteratorOutput(MutableMapModel.Iterator$V), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Iterator.i(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Iterator.Iterator_q(d)
       && (exists MutableMapModel.Iterator$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h))
     ==> $IsAlloc(MutableMapModel.Iterator.i(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Iterator.s(d), TSet(Tclass.NativeTypes.uint64()), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Iterator.Iterator_q(d)
       && (exists MutableMapModel.Iterator$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h))
     ==> $IsAlloc(MutableMapModel.Iterator.s(d), TSet(Tclass.NativeTypes.uint64()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Iterator.decreaser(d), TORDINAL, $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Iterator.Iterator_q(d)
       && (exists MutableMapModel.Iterator$V: Ty :: 
        { $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h) } 
        $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h))
     ==> $IsAlloc(MutableMapModel.Iterator.decreaser(d), TORDINAL, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, MutableMapModel.Iterator$V: Ty, $h: Heap :: 
  { $IsAlloc(MutableMapModel.Iterator.next(d), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.Iterator$V), 
      $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.Iterator.Iterator_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V), $h)
     ==> $IsAlloc(MutableMapModel.Iterator.next(d), 
      Tclass.MutableMapModel.IteratorOutput(MutableMapModel.Iterator$V), 
      $h));

// Constructor literal
axiom (forall a#73#0#0: int, a#73#1#0: Set Box, a#73#2#0: Box, a#73#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(LitInt(a#73#0#0), Lit(a#73#1#0), Lit(a#73#2#0), Lit(a#73#3#0)) } 
  #MutableMapModel.Iterator.Iterator(LitInt(a#73#0#0), Lit(a#73#1#0), Lit(a#73#2#0), Lit(a#73#3#0))
     == Lit(#MutableMapModel.Iterator.Iterator(a#73#0#0, a#73#1#0, a#73#2#0, a#73#3#0)));

function MutableMapModel.Iterator.i(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#74#0#0: int, a#74#1#0: Set Box, a#74#2#0: Box, a#74#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(a#74#0#0, a#74#1#0, a#74#2#0, a#74#3#0) } 
  MutableMapModel.Iterator.i(#MutableMapModel.Iterator.Iterator(a#74#0#0, a#74#1#0, a#74#2#0, a#74#3#0))
     == a#74#0#0);

function MutableMapModel.Iterator.s(DatatypeType) : Set Box;

// Constructor injectivity
axiom (forall a#75#0#0: int, a#75#1#0: Set Box, a#75#2#0: Box, a#75#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(a#75#0#0, a#75#1#0, a#75#2#0, a#75#3#0) } 
  MutableMapModel.Iterator.s(#MutableMapModel.Iterator.Iterator(a#75#0#0, a#75#1#0, a#75#2#0, a#75#3#0))
     == a#75#1#0);

// Inductive set element rank
axiom (forall a#76#0#0: int, 
    a#76#1#0: Set Box, 
    a#76#2#0: Box, 
    a#76#3#0: DatatypeType, 
    d: DatatypeType :: 
  { a#76#1#0[$Box(d)], #MutableMapModel.Iterator.Iterator(a#76#0#0, a#76#1#0, a#76#2#0, a#76#3#0) } 
  a#76#1#0[$Box(d)]
     ==> DtRank(d)
       < DtRank(#MutableMapModel.Iterator.Iterator(a#76#0#0, a#76#1#0, a#76#2#0, a#76#3#0)));

function MutableMapModel.Iterator.decreaser(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#77#0#0: int, a#77#1#0: Set Box, a#77#2#0: Box, a#77#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(a#77#0#0, a#77#1#0, a#77#2#0, a#77#3#0) } 
  MutableMapModel.Iterator.decreaser(#MutableMapModel.Iterator.Iterator(a#77#0#0, a#77#1#0, a#77#2#0, a#77#3#0))
     == a#77#2#0);

function MutableMapModel.Iterator.next(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#78#0#0: int, a#78#1#0: Set Box, a#78#2#0: Box, a#78#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(a#78#0#0, a#78#1#0, a#78#2#0, a#78#3#0) } 
  MutableMapModel.Iterator.next(#MutableMapModel.Iterator.Iterator(a#78#0#0, a#78#1#0, a#78#2#0, a#78#3#0))
     == a#78#3#0);

// Inductive rank
axiom (forall a#79#0#0: int, a#79#1#0: Set Box, a#79#2#0: Box, a#79#3#0: DatatypeType :: 
  { #MutableMapModel.Iterator.Iterator(a#79#0#0, a#79#1#0, a#79#2#0, a#79#3#0) } 
  DtRank(a#79#3#0)
     < DtRank(#MutableMapModel.Iterator.Iterator(a#79#0#0, a#79#1#0, a#79#2#0, a#79#3#0)));

// Depth-one case-split function
function $IsA#MutableMapModel.Iterator(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.Iterator(d) } 
  $IsA#MutableMapModel.Iterator(d) ==> MutableMapModel.Iterator.Iterator_q(d));

// Questionmark data type disjunctivity
axiom (forall MutableMapModel.Iterator$V: Ty, d: DatatypeType :: 
  { MutableMapModel.Iterator.Iterator_q(d), $Is(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V)) } 
  $Is(d, Tclass.MutableMapModel.Iterator(MutableMapModel.Iterator$V))
     ==> MutableMapModel.Iterator.Iterator_q(d));

// Datatype extensional equality declaration
function MutableMapModel.Iterator#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.Iterator.Iterator
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Iterator#Equal(a, b) } 
  true
     ==> (MutableMapModel.Iterator#Equal(a, b)
       <==> MutableMapModel.Iterator.i(a) == MutableMapModel.Iterator.i(b)
         && Set#Equal(MutableMapModel.Iterator.s(a), MutableMapModel.Iterator.s(b))
         && MutableMapModel.Iterator.decreaser(a) == MutableMapModel.Iterator.decreaser(b)
         && MutableMapModel.IteratorOutput#Equal(MutableMapModel.Iterator.next(a), MutableMapModel.Iterator.next(b))));

// Datatype extensionality axiom: MutableMapModel.Iterator
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.Iterator#Equal(a, b) } 
  MutableMapModel.Iterator#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.Iterator: ClassName;

// Constructor function declaration
function #MutableMapModel.SimpleIterator.SimpleIterator(int, Set Box, Box) : DatatypeType;

const unique ##MutableMapModel.SimpleIterator.SimpleIterator: DtCtorId;

// Constructor identifier
axiom (forall a#80#0#0: int, a#80#1#0: Set Box, a#80#2#0: Box :: 
  { #MutableMapModel.SimpleIterator.SimpleIterator(a#80#0#0, a#80#1#0, a#80#2#0) } 
  DatatypeCtorId(#MutableMapModel.SimpleIterator.SimpleIterator(a#80#0#0, a#80#1#0, a#80#2#0))
     == ##MutableMapModel.SimpleIterator.SimpleIterator);

function MutableMapModel.SimpleIterator.SimpleIterator_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { MutableMapModel.SimpleIterator.SimpleIterator_q(d) } 
  MutableMapModel.SimpleIterator.SimpleIterator_q(d)
     <==> DatatypeCtorId(d) == ##MutableMapModel.SimpleIterator.SimpleIterator);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { MutableMapModel.SimpleIterator.SimpleIterator_q(d) } 
  MutableMapModel.SimpleIterator.SimpleIterator_q(d)
     ==> (exists a#81#0#0: int, a#81#1#0: Set Box, a#81#2#0: Box :: 
      d
         == #MutableMapModel.SimpleIterator.SimpleIterator(a#81#0#0, a#81#1#0, a#81#2#0)));

// Constructor $Is
axiom (forall a#82#0#0: int, a#82#1#0: Set Box, a#82#2#0: Box :: 
  { $Is(#MutableMapModel.SimpleIterator.SimpleIterator(a#82#0#0, a#82#1#0, a#82#2#0), 
      Tclass.MutableMapModel.SimpleIterator()) } 
  $Is(#MutableMapModel.SimpleIterator.SimpleIterator(a#82#0#0, a#82#1#0, a#82#2#0), 
      Tclass.MutableMapModel.SimpleIterator())
     <==> $Is(a#82#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#82#1#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(a#82#2#0, TORDINAL));

// Constructor $IsAlloc
axiom (forall a#83#0#0: int, a#83#1#0: Set Box, a#83#2#0: Box, $h: Heap :: 
  { $IsAlloc(#MutableMapModel.SimpleIterator.SimpleIterator(a#83#0#0, a#83#1#0, a#83#2#0), 
      Tclass.MutableMapModel.SimpleIterator(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#MutableMapModel.SimpleIterator.SimpleIterator(a#83#0#0, a#83#1#0, a#83#2#0), 
        Tclass.MutableMapModel.SimpleIterator(), 
        $h)
       <==> $IsAlloc(a#83#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#83#1#0, TSet(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#83#2#0, TORDINAL, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.SimpleIterator.i(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.SimpleIterator.SimpleIterator_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.SimpleIterator(), $h)
     ==> $IsAlloc(MutableMapModel.SimpleIterator.i(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.SimpleIterator.s(d), TSet(Tclass.NativeTypes.uint64()), $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.SimpleIterator.SimpleIterator_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.SimpleIterator(), $h)
     ==> $IsAlloc(MutableMapModel.SimpleIterator.s(d), TSet(Tclass.NativeTypes.uint64()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(MutableMapModel.SimpleIterator.decreaser(d), TORDINAL, $h) } 
  $IsGoodHeap($h)
       && 
      MutableMapModel.SimpleIterator.SimpleIterator_q(d)
       && $IsAlloc(d, Tclass.MutableMapModel.SimpleIterator(), $h)
     ==> $IsAlloc(MutableMapModel.SimpleIterator.decreaser(d), TORDINAL, $h));

// Constructor literal
axiom (forall a#84#0#0: int, a#84#1#0: Set Box, a#84#2#0: Box :: 
  { #MutableMapModel.SimpleIterator.SimpleIterator(LitInt(a#84#0#0), Lit(a#84#1#0), Lit(a#84#2#0)) } 
  #MutableMapModel.SimpleIterator.SimpleIterator(LitInt(a#84#0#0), Lit(a#84#1#0), Lit(a#84#2#0))
     == Lit(#MutableMapModel.SimpleIterator.SimpleIterator(a#84#0#0, a#84#1#0, a#84#2#0)));

function MutableMapModel.SimpleIterator.i(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#85#0#0: int, a#85#1#0: Set Box, a#85#2#0: Box :: 
  { #MutableMapModel.SimpleIterator.SimpleIterator(a#85#0#0, a#85#1#0, a#85#2#0) } 
  MutableMapModel.SimpleIterator.i(#MutableMapModel.SimpleIterator.SimpleIterator(a#85#0#0, a#85#1#0, a#85#2#0))
     == a#85#0#0);

function MutableMapModel.SimpleIterator.s(DatatypeType) : Set Box;

// Constructor injectivity
axiom (forall a#86#0#0: int, a#86#1#0: Set Box, a#86#2#0: Box :: 
  { #MutableMapModel.SimpleIterator.SimpleIterator(a#86#0#0, a#86#1#0, a#86#2#0) } 
  MutableMapModel.SimpleIterator.s(#MutableMapModel.SimpleIterator.SimpleIterator(a#86#0#0, a#86#1#0, a#86#2#0))
     == a#86#1#0);

// Inductive set element rank
axiom (forall a#87#0#0: int, a#87#1#0: Set Box, a#87#2#0: Box, d: DatatypeType :: 
  { a#87#1#0[$Box(d)], #MutableMapModel.SimpleIterator.SimpleIterator(a#87#0#0, a#87#1#0, a#87#2#0) } 
  a#87#1#0[$Box(d)]
     ==> DtRank(d)
       < DtRank(#MutableMapModel.SimpleIterator.SimpleIterator(a#87#0#0, a#87#1#0, a#87#2#0)));

function MutableMapModel.SimpleIterator.decreaser(DatatypeType) : Box;

// Constructor injectivity
axiom (forall a#88#0#0: int, a#88#1#0: Set Box, a#88#2#0: Box :: 
  { #MutableMapModel.SimpleIterator.SimpleIterator(a#88#0#0, a#88#1#0, a#88#2#0) } 
  MutableMapModel.SimpleIterator.decreaser(#MutableMapModel.SimpleIterator.SimpleIterator(a#88#0#0, a#88#1#0, a#88#2#0))
     == a#88#2#0);

// Depth-one case-split function
function $IsA#MutableMapModel.SimpleIterator(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#MutableMapModel.SimpleIterator(d) } 
  $IsA#MutableMapModel.SimpleIterator(d)
     ==> MutableMapModel.SimpleIterator.SimpleIterator_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { MutableMapModel.SimpleIterator.SimpleIterator_q(d), $Is(d, Tclass.MutableMapModel.SimpleIterator()) } 
  $Is(d, Tclass.MutableMapModel.SimpleIterator())
     ==> MutableMapModel.SimpleIterator.SimpleIterator_q(d));

// Datatype extensional equality declaration
function MutableMapModel.SimpleIterator#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #MutableMapModel.SimpleIterator.SimpleIterator
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.SimpleIterator#Equal(a, b) } 
  true
     ==> (MutableMapModel.SimpleIterator#Equal(a, b)
       <==> MutableMapModel.SimpleIterator.i(a) == MutableMapModel.SimpleIterator.i(b)
         && Set#Equal(MutableMapModel.SimpleIterator.s(a), MutableMapModel.SimpleIterator.s(b))
         && MutableMapModel.SimpleIterator.decreaser(a)
           == MutableMapModel.SimpleIterator.decreaser(b)));

// Datatype extensionality axiom: MutableMapModel.SimpleIterator
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { MutableMapModel.SimpleIterator#Equal(a, b) } 
  MutableMapModel.SimpleIterator#Equal(a, b) <==> a == b);

const unique class.MutableMapModel.SimpleIterator: ClassName;

const unique class.MutableMapModel.__default: ClassName;

function Tclass.MutableMapModel.__default() : Ty;

// Tclass.MutableMapModel.__default Tag
axiom Tag(Tclass.MutableMapModel.__default()) == Tagclass.MutableMapModel.__default;

const unique Tagclass.MutableMapModel.__default: TyTag;

// Box/unbox axiom for Tclass.MutableMapModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MutableMapModel.__default()) } 
  $IsBox(bx, Tclass.MutableMapModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.MutableMapModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.MutableMapModel.__default()) } 
  $Is($o, Tclass.MutableMapModel.__default())
     <==> $o == null || dtype($o) == Tclass.MutableMapModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MutableMapModel.__default(), $h) } 
  $IsAlloc($o, Tclass.MutableMapModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for MutableMapModel._default.lshift
function MutableMapModel.__default.lshift($ly: LayerType, a#0: int, b#0: int) : int;

function MutableMapModel.__default.lshift#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.lshift($LS($ly), a#0, b#0) } 
  MutableMapModel.__default.lshift($LS($ly), a#0, b#0)
     == MutableMapModel.__default.lshift($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.lshift(AsFuelBottom($ly), a#0, b#0) } 
  MutableMapModel.__default.lshift($ly, a#0, b#0)
     == MutableMapModel.__default.lshift($LZ, a#0, b#0));

// consequence axiom for MutableMapModel.__default.lshift
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { MutableMapModel.__default.lshift($ly, a#0, b#0) } 
    MutableMapModel.__default.lshift#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 4294967296
           && 
          LitInt(0) <= b#0
           && b#0 < 64)
       ==> LitInt(0) <= MutableMapModel.__default.lshift($ly, a#0, b#0)
         && MutableMapModel.__default.lshift($ly, a#0, b#0) < 18446744073709551616);

function MutableMapModel.__default.lshift#requires(LayerType, int, int) : bool;

// #requires axiom for MutableMapModel.__default.lshift
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.lshift#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 4294967296
     ==> MutableMapModel.__default.lshift#requires($ly, a#0, b#0)
       == (LitInt(0) <= b#0 && b#0 < 64));

// definition axiom for MutableMapModel.__default.lshift(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { MutableMapModel.__default.lshift($LS($ly), a#0, b#0) } 
    MutableMapModel.__default.lshift#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 4294967296
           && 
          LitInt(0) <= b#0
           && b#0 < 64)
       ==> MutableMapModel.__default.lshift($LS($ly), a#0, b#0)
         == nat_from_bv64(LeftShift_bv64(nat_to_bv64(a#0), nat_to_bv64(b#0))));

// definition axiom for MutableMapModel.__default.lshift for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { MutableMapModel.__default.lshift($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    MutableMapModel.__default.lshift#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 4294967296
           && 
          LitInt(0) <= LitInt(b#0)
           && b#0 < 64)
       ==> MutableMapModel.__default.lshift($LS($ly), LitInt(a#0), LitInt(b#0))
         == nat_from_bv64(LeftShift_bv64(nat_to_bv64(LitInt(a#0)), nat_to_bv64(b#0))));

// function declaration for MutableMapModel._default.rshift
function MutableMapModel.__default.rshift($ly: LayerType, a#0: int, b#0: int) : int;

function MutableMapModel.__default.rshift#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.rshift($LS($ly), a#0, b#0) } 
  MutableMapModel.__default.rshift($LS($ly), a#0, b#0)
     == MutableMapModel.__default.rshift($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.rshift(AsFuelBottom($ly), a#0, b#0) } 
  MutableMapModel.__default.rshift($ly, a#0, b#0)
     == MutableMapModel.__default.rshift($LZ, a#0, b#0));

// consequence axiom for MutableMapModel.__default.rshift
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { MutableMapModel.__default.rshift($ly, a#0, b#0) } 
    MutableMapModel.__default.rshift#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 4294967296
           && 
          LitInt(0) <= b#0
           && b#0 < 64)
       ==> LitInt(0) <= MutableMapModel.__default.rshift($ly, a#0, b#0)
         && MutableMapModel.__default.rshift($ly, a#0, b#0) < 18446744073709551616);

function MutableMapModel.__default.rshift#requires(LayerType, int, int) : bool;

// #requires axiom for MutableMapModel.__default.rshift
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.rshift#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 4294967296
     ==> MutableMapModel.__default.rshift#requires($ly, a#0, b#0)
       == (LitInt(0) <= b#0 && b#0 < 64));

// definition axiom for MutableMapModel.__default.rshift(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { MutableMapModel.__default.rshift($LS($ly), a#0, b#0) } 
    MutableMapModel.__default.rshift#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 4294967296
           && 
          LitInt(0) <= b#0
           && b#0 < 64)
       ==> MutableMapModel.__default.rshift($LS($ly), a#0, b#0)
         == nat_from_bv64(RightShift_bv64(nat_to_bv64(a#0), nat_to_bv64(b#0))));

// definition axiom for MutableMapModel.__default.rshift for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { MutableMapModel.__default.rshift($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    MutableMapModel.__default.rshift#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 4294967296
           && 
          LitInt(0) <= LitInt(b#0)
           && b#0 < 64)
       ==> MutableMapModel.__default.rshift($LS($ly), LitInt(a#0), LitInt(b#0))
         == nat_from_bv64(RightShift_bv64(nat_to_bv64(LitInt(a#0)), nat_to_bv64(b#0))));

// function declaration for MutableMapModel._default.bitnot
function MutableMapModel.__default.bitnot($ly: LayerType, a#0: int) : int;

function MutableMapModel.__default.bitnot#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { MutableMapModel.__default.bitnot($LS($ly), a#0) } 
  MutableMapModel.__default.bitnot($LS($ly), a#0)
     == MutableMapModel.__default.bitnot($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { MutableMapModel.__default.bitnot(AsFuelBottom($ly), a#0) } 
  MutableMapModel.__default.bitnot($ly, a#0)
     == MutableMapModel.__default.bitnot($LZ, a#0));

// consequence axiom for MutableMapModel.__default.bitnot
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { MutableMapModel.__default.bitnot($ly, a#0) } 
    MutableMapModel.__default.bitnot#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 18446744073709551616)
       ==> LitInt(0) <= MutableMapModel.__default.bitnot($ly, a#0)
         && MutableMapModel.__default.bitnot($ly, a#0) < 18446744073709551616);

function MutableMapModel.__default.bitnot#requires(LayerType, int) : bool;

// #requires axiom for MutableMapModel.__default.bitnot
axiom (forall $ly: LayerType, a#0: int :: 
  { MutableMapModel.__default.bitnot#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 18446744073709551616
     ==> MutableMapModel.__default.bitnot#requires($ly, a#0) == true);

// definition axiom for MutableMapModel.__default.bitnot(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { MutableMapModel.__default.bitnot($LS($ly), a#0) } 
    MutableMapModel.__default.bitnot#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 18446744073709551616)
       ==> MutableMapModel.__default.bitnot($LS($ly), a#0)
         == nat_from_bv64(xor_bv64(nat_to_bv64(a#0), 18446744073709551615bv64)));

// definition axiom for MutableMapModel.__default.bitnot for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { MutableMapModel.__default.bitnot($LS($ly), LitInt(a#0)) } 
    MutableMapModel.__default.bitnot#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 18446744073709551616)
       ==> MutableMapModel.__default.bitnot($LS($ly), LitInt(a#0))
         == nat_from_bv64(xor_bv64(nat_to_bv64(LitInt(a#0)), 18446744073709551615bv64)));

// function declaration for MutableMapModel._default.bitxor
function MutableMapModel.__default.bitxor($ly: LayerType, a#0: int, b#0: int) : int;

function MutableMapModel.__default.bitxor#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.bitxor($LS($ly), a#0, b#0) } 
  MutableMapModel.__default.bitxor($LS($ly), a#0, b#0)
     == MutableMapModel.__default.bitxor($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.bitxor(AsFuelBottom($ly), a#0, b#0) } 
  MutableMapModel.__default.bitxor($ly, a#0, b#0)
     == MutableMapModel.__default.bitxor($LZ, a#0, b#0));

// consequence axiom for MutableMapModel.__default.bitxor
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { MutableMapModel.__default.bitxor($ly, a#0, b#0) } 
    MutableMapModel.__default.bitxor#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> LitInt(0) <= MutableMapModel.__default.bitxor($ly, a#0, b#0)
         && MutableMapModel.__default.bitxor($ly, a#0, b#0) < 18446744073709551616);

function MutableMapModel.__default.bitxor#requires(LayerType, int, int) : bool;

// #requires axiom for MutableMapModel.__default.bitxor
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { MutableMapModel.__default.bitxor#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> MutableMapModel.__default.bitxor#requires($ly, a#0, b#0) == true);

// definition axiom for MutableMapModel.__default.bitxor(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { MutableMapModel.__default.bitxor($LS($ly), a#0, b#0) } 
    MutableMapModel.__default.bitxor#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> MutableMapModel.__default.bitxor($LS($ly), a#0, b#0)
         == nat_from_bv64(xor_bv64(nat_to_bv64(a#0), nat_to_bv64(b#0))));

// definition axiom for MutableMapModel.__default.bitxor for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { MutableMapModel.__default.bitxor($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    MutableMapModel.__default.bitxor#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> MutableMapModel.__default.bitxor($LS($ly), LitInt(a#0), LitInt(b#0))
         == nat_from_bv64(xor_bv64(nat_to_bv64(LitInt(a#0)), nat_to_bv64(LitInt(b#0)))));

// function declaration for MutableMapModel._default.hash64
function MutableMapModel.__default.hash64($ly: LayerType, k#0: int) : int;

function MutableMapModel.__default.hash64#canCall(k#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, k#0: int :: 
  { MutableMapModel.__default.hash64($LS($ly), k#0) } 
  MutableMapModel.__default.hash64($LS($ly), k#0)
     == MutableMapModel.__default.hash64($ly, k#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, k#0: int :: 
  { MutableMapModel.__default.hash64(AsFuelBottom($ly), k#0) } 
  MutableMapModel.__default.hash64($ly, k#0)
     == MutableMapModel.__default.hash64($LZ, k#0));

// consequence axiom for MutableMapModel.__default.hash64
axiom true
   ==> (forall $ly: LayerType, k#0: int :: 
    { MutableMapModel.__default.hash64($ly, k#0) } 
    MutableMapModel.__default.hash64#canCall(k#0)
         || (LitInt(0) <= k#0 && k#0 < 18446744073709551616)
       ==> LitInt(0) <= MutableMapModel.__default.hash64($ly, k#0)
         && MutableMapModel.__default.hash64($ly, k#0) < 18446744073709551616);

function MutableMapModel.__default.hash64#requires(LayerType, int) : bool;

// #requires axiom for MutableMapModel.__default.hash64
axiom (forall $ly: LayerType, k#0: int :: 
  { MutableMapModel.__default.hash64#requires($ly, k#0) } 
  LitInt(0) <= k#0 && k#0 < 18446744073709551616
     ==> MutableMapModel.__default.hash64#requires($ly, k#0) == true);

// definition axiom for MutableMapModel.__default.hash64(revealed)
axiom true
   ==> (forall $ly: LayerType, k#0: int :: 
    { MutableMapModel.__default.hash64($LS($ly), k#0) } 
    MutableMapModel.__default.hash64#canCall(k#0)
         || (LitInt(0) <= k#0 && k#0 < 18446744073709551616)
       ==> MutableMapModel.__default.bitnot#canCall(k#0)
         && MutableMapModel.__default.lshift#canCall(k#0, LitInt(21))
         && NativeArithmetic.__default.u64add#canCall(MutableMapModel.__default.bitnot(StartFuel_MutableMapModel._default.bitnot, k#0), 
          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k#0, LitInt(21)))
         && (var k0#0 := NativeArithmetic.__default.u64add(MutableMapModel.__default.bitnot(StartFuel_MutableMapModel._default.bitnot, k#0), 
              MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k#0, LitInt(21))); 
          MutableMapModel.__default.rshift#canCall(k0#0, LitInt(24))
             && MutableMapModel.__default.bitxor#canCall(k0#0, 
              MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k0#0, LitInt(24)))
             && (var k1#0 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                  k0#0, 
                  MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k0#0, LitInt(24))); 
              MutableMapModel.__default.lshift#canCall(k1#0, LitInt(3))
                 && NativeArithmetic.__default.u64add#canCall(k1#0, 
                  MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(3)))
                 && MutableMapModel.__default.lshift#canCall(k1#0, LitInt(8))
                 && NativeArithmetic.__default.u64add#canCall(NativeArithmetic.__default.u64add(k1#0, 
                    MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(3))), 
                  MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(8)))
                 && (var k2#0 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k1#0, 
                        MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(3))), 
                      MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(8))); 
                  MutableMapModel.__default.rshift#canCall(k2#0, LitInt(14))
                     && MutableMapModel.__default.bitxor#canCall(k2#0, 
                      MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k2#0, LitInt(14)))
                     && (var k3#0 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                          k2#0, 
                          MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k2#0, LitInt(14))); 
                      MutableMapModel.__default.lshift#canCall(k3#0, LitInt(2))
                         && NativeArithmetic.__default.u64add#canCall(k3#0, 
                          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(2)))
                         && MutableMapModel.__default.lshift#canCall(k3#0, LitInt(4))
                         && NativeArithmetic.__default.u64add#canCall(NativeArithmetic.__default.u64add(k3#0, 
                            MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(2))), 
                          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(4)))
                         && (var k4#0 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k3#0, 
                                MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(2))), 
                              MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(4))); 
                          MutableMapModel.__default.rshift#canCall(k4#0, LitInt(28))
                             && MutableMapModel.__default.bitxor#canCall(k4#0, 
                              MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k4#0, LitInt(28)))
                             && (var k5#0 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                                  k4#0, 
                                  MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k4#0, LitInt(28))); 
                              MutableMapModel.__default.lshift#canCall(k5#0, LitInt(31))
                                 && NativeArithmetic.__default.u64add#canCall(k5#0, 
                                  MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k5#0, LitInt(31)))))))))
         && MutableMapModel.__default.hash64($LS($ly), k#0)
           == (var k0#0 := NativeArithmetic.__default.u64add(MutableMapModel.__default.bitnot(StartFuel_MutableMapModel._default.bitnot, k#0), 
                MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k#0, LitInt(21))); 
            (var k1#0 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                  k0#0, 
                  MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k0#0, LitInt(24))); 
              (var k2#0 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k1#0, 
                      MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(3))), 
                    MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#0, LitInt(8))); 
                (var k3#0 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                      k2#0, 
                      MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k2#0, LitInt(14))); 
                  (var k4#0 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k3#0, 
                          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(2))), 
                        MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#0, LitInt(4))); 
                    (var k5#0 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                          k4#0, 
                          MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k4#0, LitInt(28))); 
                      (var k6#0 := NativeArithmetic.__default.u64add(k5#0, 
                            MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k5#0, LitInt(31))); 
                        k6#0))))))));

// definition axiom for MutableMapModel.__default.hash64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, k#0: int :: 
    {:weight 3} { MutableMapModel.__default.hash64($LS($ly), LitInt(k#0)) } 
    MutableMapModel.__default.hash64#canCall(LitInt(k#0))
         || (LitInt(0) <= k#0 && k#0 < 18446744073709551616)
       ==> MutableMapModel.__default.bitnot#canCall(LitInt(k#0))
         && MutableMapModel.__default.lshift#canCall(LitInt(k#0), LitInt(21))
         && NativeArithmetic.__default.u64add#canCall(MutableMapModel.__default.bitnot(StartFuel_MutableMapModel._default.bitnot, LitInt(k#0)), 
          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, LitInt(k#0), LitInt(21)))
         && (var k0#1 := NativeArithmetic.__default.u64add(MutableMapModel.__default.bitnot(StartFuel_MutableMapModel._default.bitnot, LitInt(k#0)), 
              MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, LitInt(k#0), LitInt(21))); 
          MutableMapModel.__default.rshift#canCall(k0#1, LitInt(24))
             && MutableMapModel.__default.bitxor#canCall(k0#1, 
              MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k0#1, LitInt(24)))
             && (var k1#1 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                  k0#1, 
                  MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k0#1, LitInt(24))); 
              MutableMapModel.__default.lshift#canCall(k1#1, LitInt(3))
                 && NativeArithmetic.__default.u64add#canCall(k1#1, 
                  MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(3)))
                 && MutableMapModel.__default.lshift#canCall(k1#1, LitInt(8))
                 && NativeArithmetic.__default.u64add#canCall(NativeArithmetic.__default.u64add(k1#1, 
                    MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(3))), 
                  MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(8)))
                 && (var k2#1 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k1#1, 
                        MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(3))), 
                      MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(8))); 
                  MutableMapModel.__default.rshift#canCall(k2#1, LitInt(14))
                     && MutableMapModel.__default.bitxor#canCall(k2#1, 
                      MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k2#1, LitInt(14)))
                     && (var k3#1 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                          k2#1, 
                          MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k2#1, LitInt(14))); 
                      MutableMapModel.__default.lshift#canCall(k3#1, LitInt(2))
                         && NativeArithmetic.__default.u64add#canCall(k3#1, 
                          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(2)))
                         && MutableMapModel.__default.lshift#canCall(k3#1, LitInt(4))
                         && NativeArithmetic.__default.u64add#canCall(NativeArithmetic.__default.u64add(k3#1, 
                            MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(2))), 
                          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(4)))
                         && (var k4#1 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k3#1, 
                                MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(2))), 
                              MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(4))); 
                          MutableMapModel.__default.rshift#canCall(k4#1, LitInt(28))
                             && MutableMapModel.__default.bitxor#canCall(k4#1, 
                              MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k4#1, LitInt(28)))
                             && (var k5#1 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                                  k4#1, 
                                  MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k4#1, LitInt(28))); 
                              MutableMapModel.__default.lshift#canCall(k5#1, LitInt(31))
                                 && NativeArithmetic.__default.u64add#canCall(k5#1, 
                                  MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k5#1, LitInt(31)))))))))
         && MutableMapModel.__default.hash64($LS($ly), LitInt(k#0))
           == (var k0#1 := NativeArithmetic.__default.u64add(MutableMapModel.__default.bitnot(StartFuel_MutableMapModel._default.bitnot, LitInt(k#0)), 
                MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, LitInt(k#0), LitInt(21))); 
            (var k1#1 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                  k0#1, 
                  MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k0#1, LitInt(24))); 
              (var k2#1 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k1#1, 
                      MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(3))), 
                    MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k1#1, LitInt(8))); 
                (var k3#1 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                      k2#1, 
                      MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k2#1, LitInt(14))); 
                  (var k4#1 := NativeArithmetic.__default.u64add(NativeArithmetic.__default.u64add(k3#1, 
                          MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(2))), 
                        MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k3#1, LitInt(4))); 
                    (var k5#1 := MutableMapModel.__default.bitxor(StartFuel_MutableMapModel._default.bitxor, 
                          k4#1, 
                          MutableMapModel.__default.rshift(StartFuel_MutableMapModel._default.rshift, k4#1, LitInt(28))); 
                      (var k6#1 := NativeArithmetic.__default.u64add(k5#1, 
                            MutableMapModel.__default.lshift(StartFuel_MutableMapModel._default.lshift, k5#1, LitInt(31))); 
                        k6#1))))))));

// function declaration for MutableMapModel._default.ValidSlot
function MutableMapModel.__default.ValidSlot(elementsLength#0: int, slot#0: DatatypeType) : bool;

function MutableMapModel.__default.ValidSlot#canCall(elementsLength#0: int, slot#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.ValidSlot
axiom true
   ==> (forall elementsLength#0: int, slot#0: DatatypeType :: 
    { MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0) } 
    MutableMapModel.__default.ValidSlot#canCall(elementsLength#0, slot#0)
         || (LitInt(0) <= elementsLength#0 && $Is(slot#0, Tclass.MutableMapModel.Slot()))
       ==> true);

function MutableMapModel.__default.ValidSlot#requires(int, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.ValidSlot
axiom (forall elementsLength#0: int, slot#0: DatatypeType :: 
  { MutableMapModel.__default.ValidSlot#requires(elementsLength#0, slot#0) } 
  LitInt(0) <= elementsLength#0 && $Is(slot#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.ValidSlot#requires(elementsLength#0, slot#0) == true);

// definition axiom for MutableMapModel.__default.ValidSlot(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot#0: DatatypeType :: 
    { MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0) } 
    MutableMapModel.__default.ValidSlot#canCall(elementsLength#0, slot#0)
         || (LitInt(0) <= elementsLength#0 && $Is(slot#0, Tclass.MutableMapModel.Slot()))
       ==> MutableMapModel.Slot.Slot_q(slot#0)
         && MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0)
           == (MutableMapModel.Slot.slot(slot#0) < elementsLength#0));

// definition axiom for MutableMapModel.__default.ValidSlot for all literals(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(slot#0)) } 
    MutableMapModel.__default.ValidSlot#canCall(LitInt(elementsLength#0), Lit(slot#0))
         || (LitInt(0) <= elementsLength#0 && $Is(slot#0, Tclass.MutableMapModel.Slot()))
       ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))
         && MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(slot#0))
           == Lit(MutableMapModel.Slot.slot(Lit(slot#0)) < elementsLength#0));

// function declaration for MutableMapModel._default.ValidElements
function MutableMapModel.__default.ValidElements(MutableMapModel._default.ValidElements$V: Ty, elements#0: Seq Box) : bool;

function MutableMapModel.__default.ValidElements#canCall(MutableMapModel._default.ValidElements$V: Ty, elements#0: Seq Box) : bool;

// consequence axiom for MutableMapModel.__default.ValidElements
axiom true
   ==> (forall MutableMapModel._default.ValidElements$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.ValidElements(MutableMapModel._default.ValidElements$V, elements#0) } 
    MutableMapModel.__default.ValidElements#canCall(MutableMapModel._default.ValidElements$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ValidElements$V)))
       ==> true);

function MutableMapModel.__default.ValidElements#requires(Ty, Seq Box) : bool;

// #requires axiom for MutableMapModel.__default.ValidElements
axiom (forall MutableMapModel._default.ValidElements$V: Ty, elements#0: Seq Box :: 
  { MutableMapModel.__default.ValidElements#requires(MutableMapModel._default.ValidElements$V, elements#0) } 
  $Is(elements#0, 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ValidElements$V)))
     ==> MutableMapModel.__default.ValidElements#requires(MutableMapModel._default.ValidElements$V, elements#0)
       == true);

// definition axiom for MutableMapModel.__default.ValidElements(revealed)
axiom true
   ==> (forall MutableMapModel._default.ValidElements$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.ValidElements(MutableMapModel._default.ValidElements$V, elements#0) } 
    MutableMapModel.__default.ValidElements#canCall(MutableMapModel._default.ValidElements$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ValidElements$V)))
       ==> MutableMapModel.__default.ValidElements(MutableMapModel._default.ValidElements$V, elements#0)
         == (true
           && 
          0 < Seq#Length(elements#0)
           && Seq#Length(elements#0) < 18446744073709551616));

// definition axiom for MutableMapModel.__default.ValidElements for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ValidElements$V: Ty, elements#0: Seq Box :: 
    {:weight 3} { MutableMapModel.__default.ValidElements(MutableMapModel._default.ValidElements$V, Lit(elements#0)) } 
    MutableMapModel.__default.ValidElements#canCall(MutableMapModel._default.ValidElements$V, Lit(elements#0))
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ValidElements$V)))
       ==> MutableMapModel.__default.ValidElements(MutableMapModel._default.ValidElements$V, Lit(elements#0))
         == (true
           && 
          0 < Seq#Length(Lit(elements#0))
           && Seq#Length(Lit(elements#0)) < 18446744073709551616));

// function declaration for MutableMapModel._default.SlotForKey
function MutableMapModel.__default.SlotForKey(elementsLength#0: int, key#0: int) : DatatypeType;

function MutableMapModel.__default.SlotForKey#canCall(elementsLength#0: int, key#0: int) : bool;

// consequence axiom for MutableMapModel.__default.SlotForKey
axiom true
   ==> (forall elementsLength#0: int, key#0: int :: 
    { MutableMapModel.__default.SlotForKey(elementsLength#0, key#0) } 
    MutableMapModel.__default.SlotForKey#canCall(elementsLength#0, key#0)
         || (
          LitInt(0) <= elementsLength#0
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 0 < elementsLength#0)
       ==> MutableMapModel.__default.ValidSlot(elementsLength#0, MutableMapModel.__default.SlotForKey(elementsLength#0, key#0))
         && $Is(MutableMapModel.__default.SlotForKey(elementsLength#0, key#0), 
          Tclass.MutableMapModel.Slot()));

function MutableMapModel.__default.SlotForKey#requires(int, int) : bool;

// #requires axiom for MutableMapModel.__default.SlotForKey
axiom (forall elementsLength#0: int, key#0: int :: 
  { MutableMapModel.__default.SlotForKey#requires(elementsLength#0, key#0) } 
  LitInt(0) <= elementsLength#0
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.SlotForKey#requires(elementsLength#0, key#0)
       == (0 < elementsLength#0));

// definition axiom for MutableMapModel.__default.SlotForKey(revealed)
axiom true
   ==> (forall elementsLength#0: int, key#0: int :: 
    { MutableMapModel.__default.SlotForKey(elementsLength#0, key#0) } 
    MutableMapModel.__default.SlotForKey#canCall(elementsLength#0, key#0)
         || (
          LitInt(0) <= elementsLength#0
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 0 < elementsLength#0)
       ==> MutableMapModel.__default.hash64#canCall(key#0)
         && MutableMapModel.__default.SlotForKey(elementsLength#0, key#0)
           == (var h#0 := MutableMapModel.__default.hash64(StartFuel_MutableMapModel._default.hash64, key#0); 
            #MutableMapModel.Slot.Slot(Mod(h#0, elementsLength#0))));

// definition axiom for MutableMapModel.__default.SlotForKey for all literals(revealed)
axiom true
   ==> (forall elementsLength#0: int, key#0: int :: 
    {:weight 3} { MutableMapModel.__default.SlotForKey(LitInt(elementsLength#0), LitInt(key#0)) } 
    MutableMapModel.__default.SlotForKey#canCall(LitInt(elementsLength#0), LitInt(key#0))
         || (
          LitInt(0) <= elementsLength#0
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(0 < elementsLength#0))
       ==> MutableMapModel.__default.hash64#canCall(LitInt(key#0))
         && MutableMapModel.__default.SlotForKey(LitInt(elementsLength#0), LitInt(key#0))
           == (var h#1 := MutableMapModel.__default.hash64(StartFuel_MutableMapModel._default.hash64, LitInt(key#0)); 
            #MutableMapModel.Slot.Slot(Mod(h#1, LitInt(elementsLength#0)))));

// function declaration for MutableMapModel._default.Uint64SlotForKey
function MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V: Ty, 
    self#0: DatatypeType, 
    key#0: int)
   : int;

function MutableMapModel.__default.Uint64SlotForKey#canCall(MutableMapModel._default.Uint64SlotForKey$V: Ty, 
    self#0: DatatypeType, 
    key#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.Uint64SlotForKey
axiom true
   ==> (forall MutableMapModel._default.Uint64SlotForKey$V: Ty, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0) } 
    MutableMapModel.__default.Uint64SlotForKey#canCall(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Uint64SlotForKey$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           && Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
             < 18446744073709551616)
       ==> MutableMapModel.__default.ValidSlot(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)), 
          #MutableMapModel.Slot.Slot(MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)))
         && MutableMapModel.Slot#Equal(#MutableMapModel.Slot.Slot(MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)), 
          MutableMapModel.__default.SlotForKey(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)), key#0))
         && 
        LitInt(0)
           <= MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)
         && MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)
           < 18446744073709551616);

function MutableMapModel.__default.Uint64SlotForKey#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.Uint64SlotForKey
axiom (forall MutableMapModel._default.Uint64SlotForKey$V: Ty, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.Uint64SlotForKey#requires(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Uint64SlotForKey$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.Uint64SlotForKey#requires(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)
       == (0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
         && Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           < 18446744073709551616));

// definition axiom for MutableMapModel.__default.Uint64SlotForKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.Uint64SlotForKey$V: Ty, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0) } 
    MutableMapModel.__default.Uint64SlotForKey#canCall(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Uint64SlotForKey$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           && Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
             < 18446744073709551616)
       ==> MutableMapModel.__default.hash64#canCall(key#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, self#0, key#0)
           == (var h#0 := MutableMapModel.__default.hash64(StartFuel_MutableMapModel._default.hash64, key#0); 
            Mod(h#0, Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))));

// definition axiom for MutableMapModel.__default.Uint64SlotForKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Uint64SlotForKey$V: Ty, 
      self#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.Uint64SlotForKey#canCall(MutableMapModel._default.Uint64SlotForKey$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Uint64SlotForKey$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          0 < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
           && Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
             < 18446744073709551616)
       ==> MutableMapModel.__default.hash64#canCall(LitInt(key#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Uint64SlotForKey$V, Lit(self#0), LitInt(key#0))
           == (var h#1 := MutableMapModel.__default.hash64(StartFuel_MutableMapModel._default.hash64, LitInt(key#0)); 
            Mod(h#1, 
              Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))))));

// function declaration for MutableMapModel._default.SlotSuccessor
function MutableMapModel.__default.SlotSuccessor(elementsLength#0: int, slot#0: DatatypeType) : DatatypeType;

function MutableMapModel.__default.SlotSuccessor#canCall(elementsLength#0: int, slot#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.SlotSuccessor
axiom true
   ==> (forall elementsLength#0: int, slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotSuccessor(elementsLength#0, slot#0) } 
    MutableMapModel.__default.SlotSuccessor#canCall(elementsLength#0, slot#0)
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0))
       ==> MutableMapModel.__default.ValidSlot(elementsLength#0, 
          MutableMapModel.__default.SlotSuccessor(elementsLength#0, slot#0))
         && $Is(MutableMapModel.__default.SlotSuccessor(elementsLength#0, slot#0), 
          Tclass.MutableMapModel.Slot()));

function MutableMapModel.__default.SlotSuccessor#requires(int, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SlotSuccessor
axiom (forall elementsLength#0: int, slot#0: DatatypeType :: 
  { MutableMapModel.__default.SlotSuccessor#requires(elementsLength#0, slot#0) } 
  LitInt(0) <= elementsLength#0 && $Is(slot#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.SlotSuccessor#requires(elementsLength#0, slot#0)
       == MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0));

// definition axiom for MutableMapModel.__default.SlotSuccessor(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotSuccessor(elementsLength#0, slot#0) } 
    MutableMapModel.__default.SlotSuccessor#canCall(elementsLength#0, slot#0)
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0))
       ==> MutableMapModel.Slot.Slot_q(slot#0)
         && (MutableMapModel.Slot.slot(slot#0) != elementsLength#0 - 1
           ==> MutableMapModel.Slot.Slot_q(slot#0))
         && MutableMapModel.__default.SlotSuccessor(elementsLength#0, slot#0)
           == #MutableMapModel.Slot.Slot((if MutableMapModel.Slot.slot(slot#0) == elementsLength#0 - 1
               then 0
               else MutableMapModel.Slot.slot(slot#0) + 1)));

// definition axiom for MutableMapModel.__default.SlotSuccessor for all literals(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SlotSuccessor(LitInt(elementsLength#0), Lit(slot#0)) } 
    MutableMapModel.__default.SlotSuccessor#canCall(LitInt(elementsLength#0), Lit(slot#0))
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && Lit(MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(slot#0))))
       ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))
         && (LitInt(MutableMapModel.Slot.slot(Lit(slot#0))) != LitInt(elementsLength#0 - 1)
           ==> MutableMapModel.Slot.Slot_q(Lit(slot#0)))
         && MutableMapModel.__default.SlotSuccessor(LitInt(elementsLength#0), Lit(slot#0))
           == #MutableMapModel.Slot.Slot((if LitInt(MutableMapModel.Slot.slot(Lit(slot#0))) == LitInt(elementsLength#0 - 1)
               then 0
               else MutableMapModel.Slot.slot(Lit(slot#0)) + 1)));

// function declaration for MutableMapModel._default.KthSlotSuccessor
function MutableMapModel.__default.KthSlotSuccessor($ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int)
   : DatatypeType;

function MutableMapModel.__default.KthSlotSuccessor#canCall(elementsLength#0: int, slot#0: DatatypeType, k#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int :: 
  { MutableMapModel.__default.KthSlotSuccessor($LS($ly), elementsLength#0, slot#0, k#0) } 
  MutableMapModel.__default.KthSlotSuccessor($LS($ly), elementsLength#0, slot#0, k#0)
     == MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int :: 
  { MutableMapModel.__default.KthSlotSuccessor(AsFuelBottom($ly), elementsLength#0, slot#0, k#0) } 
  MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0)
     == MutableMapModel.__default.KthSlotSuccessor($LZ, elementsLength#0, slot#0, k#0));

// consequence axiom for MutableMapModel.__default.KthSlotSuccessor
axiom true
   ==> (forall $ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int :: 
    { MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0) } 
    MutableMapModel.__default.KthSlotSuccessor#canCall(elementsLength#0, slot#0, k#0)
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && LitInt(0) <= k#0
           && 
          k#0 >= LitInt(0)
           && MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0))
       ==> MutableMapModel.__default.ValidSlot(elementsLength#0, 
          MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0))
         && $Is(MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0), 
          Tclass.MutableMapModel.Slot()));

function MutableMapModel.__default.KthSlotSuccessor#requires(LayerType, int, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.KthSlotSuccessor
axiom (forall $ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int :: 
  { MutableMapModel.__default.KthSlotSuccessor#requires($ly, elementsLength#0, slot#0, k#0) } 
  LitInt(0) <= elementsLength#0
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
       && LitInt(0) <= k#0
     ==> MutableMapModel.__default.KthSlotSuccessor#requires($ly, elementsLength#0, slot#0, k#0)
       == (k#0 >= LitInt(0)
         && MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0)));

// definition axiom for MutableMapModel.__default.KthSlotSuccessor(revealed)
axiom true
   ==> (forall $ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int :: 
    { MutableMapModel.__default.KthSlotSuccessor($LS($ly), elementsLength#0, slot#0, k#0) } 
    MutableMapModel.__default.KthSlotSuccessor#canCall(elementsLength#0, slot#0, k#0)
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && LitInt(0) <= k#0
           && 
          k#0 >= LitInt(0)
           && MutableMapModel.__default.ValidSlot(elementsLength#0, slot#0))
       ==> (k#0 != LitInt(0)
           ==> MutableMapModel.__default.KthSlotSuccessor#canCall(elementsLength#0, slot#0, k#0 - 1)
             && MutableMapModel.__default.SlotSuccessor#canCall(elementsLength#0, 
              MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0 - 1)))
         && MutableMapModel.__default.KthSlotSuccessor($LS($ly), elementsLength#0, slot#0, k#0)
           == (if k#0 == LitInt(0)
             then slot#0
             else MutableMapModel.__default.SlotSuccessor(elementsLength#0, 
              MutableMapModel.__default.KthSlotSuccessor($ly, elementsLength#0, slot#0, k#0 - 1))));

// definition axiom for MutableMapModel.__default.KthSlotSuccessor for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, elementsLength#0: int, slot#0: DatatypeType, k#0: int :: 
    {:weight 3} { MutableMapModel.__default.KthSlotSuccessor($LS($ly), LitInt(elementsLength#0), Lit(slot#0), LitInt(k#0)) } 
    MutableMapModel.__default.KthSlotSuccessor#canCall(LitInt(elementsLength#0), Lit(slot#0), LitInt(k#0))
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && LitInt(0) <= k#0
           && 
          LitInt(k#0) >= LitInt(0)
           && Lit(MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(slot#0))))
       ==> (LitInt(k#0) != LitInt(0)
           ==> MutableMapModel.__default.KthSlotSuccessor#canCall(LitInt(elementsLength#0), Lit(slot#0), LitInt(k#0 - 1))
             && MutableMapModel.__default.SlotSuccessor#canCall(LitInt(elementsLength#0), 
              Lit(MutableMapModel.__default.KthSlotSuccessor($LS($ly), LitInt(elementsLength#0), Lit(slot#0), LitInt(k#0 - 1)))))
         && MutableMapModel.__default.KthSlotSuccessor($LS($ly), LitInt(elementsLength#0), Lit(slot#0), LitInt(k#0))
           == (if LitInt(k#0) == LitInt(0)
             then slot#0
             else MutableMapModel.__default.SlotSuccessor(LitInt(elementsLength#0), 
              Lit(MutableMapModel.__default.KthSlotSuccessor($LS($ly), LitInt(elementsLength#0), Lit(slot#0), LitInt(k#0 - 1))))));

// function declaration for MutableMapModel._default.SlotIsEmpty
function MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.SlotIsEmpty$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType)
   : bool;

function MutableMapModel.__default.SlotIsEmpty#canCall(MutableMapModel._default.SlotIsEmpty$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.SlotIsEmpty
axiom true
   ==> (forall MutableMapModel._default.SlotIsEmpty$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0) } 
    MutableMapModel.__default.SlotIsEmpty#canCall(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEmpty$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> true);

function MutableMapModel.__default.SlotIsEmpty#requires(Ty, Seq Box, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SlotIsEmpty
axiom (forall MutableMapModel._default.SlotIsEmpty$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType :: 
  { MutableMapModel.__default.SlotIsEmpty#requires(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEmpty$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.SlotIsEmpty#requires(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0)
       == MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0));

// definition axiom for MutableMapModel.__default.SlotIsEmpty(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotIsEmpty$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0) } 
    MutableMapModel.__default.SlotIsEmpty#canCall(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEmpty$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> MutableMapModel.Slot.Slot_q(slot#0)
         && MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.SlotIsEmpty$V, elements#0, slot#0)
           == MutableMapModel.Item.Empty_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType));

// definition axiom for MutableMapModel.__default.SlotIsEmpty for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotIsEmpty$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.SlotIsEmpty$V, Lit(elements#0), Lit(slot#0)) } 
    MutableMapModel.__default.SlotIsEmpty#canCall(MutableMapModel._default.SlotIsEmpty$V, Lit(elements#0), Lit(slot#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEmpty$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0)))
       ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))
         && MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.SlotIsEmpty$V, Lit(elements#0), Lit(slot#0))
           == MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType));

// function declaration for MutableMapModel._default.SlotIsEntry
function MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SlotIsEntry$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType)
   : bool;

function MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SlotIsEntry$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.SlotIsEntry
axiom true
   ==> (forall MutableMapModel._default.SlotIsEntry$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0) } 
    MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEntry$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> true);

function MutableMapModel.__default.SlotIsEntry#requires(Ty, Seq Box, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SlotIsEntry
axiom (forall MutableMapModel._default.SlotIsEntry$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType :: 
  { MutableMapModel.__default.SlotIsEntry#requires(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEntry$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.SlotIsEntry#requires(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0)
       == MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0));

// definition axiom for MutableMapModel.__default.SlotIsEntry(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotIsEntry$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0) } 
    MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEntry$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> MutableMapModel.Slot.Slot_q(slot#0)
         && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SlotIsEntry$V, elements#0, slot#0)
           == MutableMapModel.Item.Entry_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType));

// definition axiom for MutableMapModel.__default.SlotIsEntry for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotIsEntry$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SlotIsEntry$V, Lit(elements#0), Lit(slot#0)) } 
    MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SlotIsEntry$V, Lit(elements#0), Lit(slot#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsEntry$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0)))
       ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))
         && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SlotIsEntry$V, Lit(elements#0), Lit(slot#0))
           == MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType));

// function declaration for MutableMapModel._default.SlotIsTombstone
function MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SlotIsTombstone$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType)
   : bool;

function MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SlotIsTombstone$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.SlotIsTombstone
axiom true
   ==> (forall MutableMapModel._default.SlotIsTombstone$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0) } 
    MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsTombstone$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> true);

function MutableMapModel.__default.SlotIsTombstone#requires(Ty, Seq Box, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SlotIsTombstone
axiom (forall MutableMapModel._default.SlotIsTombstone$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType :: 
  { MutableMapModel.__default.SlotIsTombstone#requires(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsTombstone$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.SlotIsTombstone#requires(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0)
       == MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0));

// definition axiom for MutableMapModel.__default.SlotIsTombstone(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotIsTombstone$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0) } 
    MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsTombstone$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> MutableMapModel.Slot.Slot_q(slot#0)
         && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SlotIsTombstone$V, elements#0, slot#0)
           == MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType));

// definition axiom for MutableMapModel.__default.SlotIsTombstone for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotIsTombstone$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SlotIsTombstone$V, Lit(elements#0), Lit(slot#0)) } 
    MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SlotIsTombstone$V, Lit(elements#0), Lit(slot#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotIsTombstone$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0)))
       ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))
         && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SlotIsTombstone$V, Lit(elements#0), Lit(slot#0))
           == MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType));

// function declaration for MutableMapModel._default.FilledWithOtherKey
function MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    excludingKey#0: int)
   : bool;

function MutableMapModel.__default.FilledWithOtherKey#canCall(MutableMapModel._default.FilledWithOtherKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    excludingKey#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.FilledWithOtherKey
axiom true
   ==> (forall MutableMapModel._default.FilledWithOtherKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      excludingKey#0: int :: 
    { MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKey$V, 
        elements#0, 
        slot#0, 
        excludingKey#0) } 
    MutableMapModel.__default.FilledWithOtherKey#canCall(MutableMapModel._default.FilledWithOtherKey$V, 
          elements#0, 
          slot#0, 
          excludingKey#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= excludingKey#0
           && excludingKey#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKey$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> true);

function MutableMapModel.__default.FilledWithOtherKey#requires(Ty, Seq Box, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.FilledWithOtherKey
axiom (forall MutableMapModel._default.FilledWithOtherKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    excludingKey#0: int :: 
  { MutableMapModel.__default.FilledWithOtherKey#requires(MutableMapModel._default.FilledWithOtherKey$V, 
      elements#0, 
      slot#0, 
      excludingKey#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKey$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
       && 
      LitInt(0) <= excludingKey#0
       && excludingKey#0 < 18446744073709551616
     ==> MutableMapModel.__default.FilledWithOtherKey#requires(MutableMapModel._default.FilledWithOtherKey$V, 
        elements#0, 
        slot#0, 
        excludingKey#0)
       == (MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKey$V, elements#0)
         && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)));

// definition axiom for MutableMapModel.__default.FilledWithOtherKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithOtherKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      excludingKey#0: int :: 
    { MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKey$V, 
        elements#0, 
        slot#0, 
        excludingKey#0) } 
    MutableMapModel.__default.FilledWithOtherKey#canCall(MutableMapModel._default.FilledWithOtherKey$V, 
          elements#0, 
          slot#0, 
          excludingKey#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= excludingKey#0
           && excludingKey#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKey$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.FilledWithOtherKey$V, elements#0, slot#0)
         && (MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithOtherKey$V, elements#0, slot#0)
           ==> MutableMapModel.Slot.Slot_q(slot#0))
         && (MutableMapModel.Slot.Slot_q(slot#0)
             && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType)
               == excludingKey#0
           ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.FilledWithOtherKey$V, elements#0, slot#0)
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithOtherKey$V, elements#0, slot#0)
               ==> MutableMapModel.Slot.Slot_q(slot#0)))
         && MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKey$V, 
            elements#0, 
            slot#0, 
            excludingKey#0)
           == ((MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithOtherKey$V, elements#0, slot#0)
               && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType)
                 != excludingKey#0)
             || (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithOtherKey$V, elements#0, slot#0)
               && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType)
                 != excludingKey#0)));

// definition axiom for MutableMapModel.__default.FilledWithOtherKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithOtherKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      excludingKey#0: int :: 
    {:weight 3} { MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKey$V, 
        Lit(elements#0), 
        Lit(slot#0), 
        LitInt(excludingKey#0)) } 
    MutableMapModel.__default.FilledWithOtherKey#canCall(MutableMapModel._default.FilledWithOtherKey$V, 
          Lit(elements#0), 
          Lit(slot#0), 
          LitInt(excludingKey#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= excludingKey#0
           && excludingKey#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0)))
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0)))
       ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0), Lit(slot#0))
         && (Lit(MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0), Lit(slot#0)))
           ==> MutableMapModel.Slot.Slot_q(Lit(slot#0)))
         && (MutableMapModel.Slot.Slot_q(Lit(slot#0))
             && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType)
               == excludingKey#0
           ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0), Lit(slot#0))
             && (Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0), Lit(slot#0)))
               ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))))
         && MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKey$V, 
            Lit(elements#0), 
            Lit(slot#0), 
            LitInt(excludingKey#0))
           == ((MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0), Lit(slot#0))
               && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType)
                 != excludingKey#0)
             || (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithOtherKey$V, Lit(elements#0), Lit(slot#0))
               && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType)
                 != excludingKey#0)));

// function declaration for MutableMapModel._default.FilledWithOtherKeys
function MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.FilledWithOtherKeys$V: Ty, 
    elements#0: Seq Box, 
    start#0: DatatypeType, 
    count#0: int, 
    excludingKey#0: int)
   : bool;

function MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.FilledWithOtherKeys$V: Ty, 
    elements#0: Seq Box, 
    start#0: DatatypeType, 
    count#0: int, 
    excludingKey#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.FilledWithOtherKeys
axiom true
   ==> (forall MutableMapModel._default.FilledWithOtherKeys$V: Ty, 
      elements#0: Seq Box, 
      start#0: DatatypeType, 
      count#0: int, 
      excludingKey#0: int :: 
    { MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.FilledWithOtherKeys$V, 
        elements#0, 
        start#0, 
        count#0, 
        excludingKey#0) } 
    MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.FilledWithOtherKeys$V, 
          elements#0, 
          start#0, 
          count#0, 
          excludingKey#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKeys$V)))
           && $Is(start#0, Tclass.MutableMapModel.Slot())
           && LitInt(0) <= count#0
           && 
          LitInt(0) <= excludingKey#0
           && excludingKey#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKeys$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), start#0))
       ==> true);

function MutableMapModel.__default.FilledWithOtherKeys#requires(Ty, Seq Box, DatatypeType, int, int) : bool;

// #requires axiom for MutableMapModel.__default.FilledWithOtherKeys
axiom (forall MutableMapModel._default.FilledWithOtherKeys$V: Ty, 
    elements#0: Seq Box, 
    start#0: DatatypeType, 
    count#0: int, 
    excludingKey#0: int :: 
  { MutableMapModel.__default.FilledWithOtherKeys#requires(MutableMapModel._default.FilledWithOtherKeys$V, 
      elements#0, 
      start#0, 
      count#0, 
      excludingKey#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKeys$V)))
       && $Is(start#0, Tclass.MutableMapModel.Slot())
       && LitInt(0) <= count#0
       && 
      LitInt(0) <= excludingKey#0
       && excludingKey#0 < 18446744073709551616
     ==> MutableMapModel.__default.FilledWithOtherKeys#requires(MutableMapModel._default.FilledWithOtherKeys$V, 
        elements#0, 
        start#0, 
        count#0, 
        excludingKey#0)
       == (MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKeys$V, elements#0)
         && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), start#0)));

// definition axiom for MutableMapModel.__default.FilledWithOtherKeys(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithOtherKeys$V: Ty, 
      elements#0: Seq Box, 
      start#0: DatatypeType, 
      count#0: int, 
      excludingKey#0: int :: 
    { MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.FilledWithOtherKeys$V, 
        elements#0, 
        start#0, 
        count#0, 
        excludingKey#0) } 
    MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.FilledWithOtherKeys$V, 
          elements#0, 
          start#0, 
          count#0, 
          excludingKey#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKeys$V)))
           && $Is(start#0, Tclass.MutableMapModel.Slot())
           && LitInt(0) <= count#0
           && 
          LitInt(0) <= excludingKey#0
           && excludingKey#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKeys$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), start#0))
       ==> (Lit(true)
           ==> (forall offset#0: int :: 
            { MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(elements#0), start#0, offset#0) } 
            LitInt(0) <= offset#0
               ==> 
              offset#0 < count#0
               ==> MutableMapModel.__default.KthSlotSuccessor#canCall(Seq#Length(elements#0), start#0, offset#0)
                 && MutableMapModel.__default.FilledWithOtherKey#canCall(MutableMapModel._default.FilledWithOtherKeys$V, 
                  elements#0, 
                  MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(elements#0), start#0, offset#0), 
                  excludingKey#0)))
         && MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.FilledWithOtherKeys$V, 
            elements#0, 
            start#0, 
            count#0, 
            excludingKey#0)
           == (true
             && (forall offset#0: int :: 
              {:_induction offset#0} { MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(elements#0), start#0, offset#0) } 
              LitInt(0) <= offset#0
                 ==> 
                offset#0 < count#0
                 ==> MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKeys$V, 
                  elements#0, 
                  MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(elements#0), start#0, offset#0), 
                  excludingKey#0))));

// definition axiom for MutableMapModel.__default.FilledWithOtherKeys for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithOtherKeys$V: Ty, 
      elements#0: Seq Box, 
      start#0: DatatypeType, 
      count#0: int, 
      excludingKey#0: int :: 
    {:weight 3} { MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.FilledWithOtherKeys$V, 
        Lit(elements#0), 
        Lit(start#0), 
        LitInt(count#0), 
        LitInt(excludingKey#0)) } 
    MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.FilledWithOtherKeys$V, 
          Lit(elements#0), 
          Lit(start#0), 
          LitInt(count#0), 
          LitInt(excludingKey#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithOtherKeys$V)))
           && $Is(start#0, Tclass.MutableMapModel.Slot())
           && LitInt(0) <= count#0
           && 
          LitInt(0) <= excludingKey#0
           && excludingKey#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithOtherKeys$V, Lit(elements#0)))
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(start#0)))
       ==> (Lit(true)
           ==> (forall offset#1: int :: 
            { MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(elements#0), start#0, offset#1) } 
            LitInt(0) <= offset#1
               ==> 
              offset#1 < count#0
               ==> MutableMapModel.__default.KthSlotSuccessor#canCall(Seq#Length(Lit(elements#0)), Lit(start#0), offset#1)
                 && MutableMapModel.__default.FilledWithOtherKey#canCall(MutableMapModel._default.FilledWithOtherKeys$V, 
                  Lit(elements#0), 
                  MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(Lit(elements#0)), Lit(start#0), offset#1), 
                  LitInt(excludingKey#0))))
         && MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.FilledWithOtherKeys$V, 
            Lit(elements#0), 
            Lit(start#0), 
            LitInt(count#0), 
            LitInt(excludingKey#0))
           == (true
             && (forall offset#1: int :: 
              {:_induction offset#1} { MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(elements#0), start#0, offset#1) } 
              LitInt(0) <= offset#1
                 ==> 
                offset#1 < count#0
                 ==> MutableMapModel.__default.FilledWithOtherKey(MutableMapModel._default.FilledWithOtherKeys$V, 
                  Lit(elements#0), 
                  MutableMapModel.__default.KthSlotSuccessor($LS($LZ), Seq#Length(Lit(elements#0)), Lit(start#0), offset#1), 
                  LitInt(excludingKey#0)))));

// function declaration for MutableMapModel._default.FilledWithKey
function MutableMapModel.__default.FilledWithKey(MutableMapModel._default.FilledWithKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    key#0: int)
   : bool;

function MutableMapModel.__default.FilledWithKey#canCall(MutableMapModel._default.FilledWithKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    key#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.FilledWithKey
axiom true
   ==> (forall MutableMapModel._default.FilledWithKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FilledWithKey(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0) } 
    MutableMapModel.__default.FilledWithKey#canCall(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithKey$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> true);

function MutableMapModel.__default.FilledWithKey#requires(Ty, Seq Box, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.FilledWithKey
axiom (forall MutableMapModel._default.FilledWithKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FilledWithKey#requires(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithKey$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.FilledWithKey#requires(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0)
       == (MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithKey$V, elements#0)
         && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)));

// definition axiom for MutableMapModel.__default.FilledWithKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FilledWithKey(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0) } 
    MutableMapModel.__default.FilledWithKey#canCall(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithKey$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0)
         && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0)
           ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0))
         && (MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0)
             && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0)
           ==> MutableMapModel.Slot.Slot_q(slot#0))
         && MutableMapModel.__default.FilledWithKey(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0, key#0)
           == ((MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0)
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithKey$V, elements#0, slot#0))
             && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType)
               == key#0));

// definition axiom for MutableMapModel.__default.FilledWithKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.FilledWithKey(MutableMapModel._default.FilledWithKey$V, 
        Lit(elements#0), 
        Lit(slot#0), 
        LitInt(key#0)) } 
    MutableMapModel.__default.FilledWithKey#canCall(MutableMapModel._default.FilledWithKey$V, 
          Lit(elements#0), 
          Lit(slot#0), 
          LitInt(key#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithKey$V, Lit(elements#0)))
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0)))
       ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0))
         && (!Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0)))
           ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0)))
         && (MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0))
             && Lit(MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0)))
           ==> MutableMapModel.Slot.Slot_q(Lit(slot#0)))
         && MutableMapModel.__default.FilledWithKey(MutableMapModel._default.FilledWithKey$V, 
            Lit(elements#0), 
            Lit(slot#0), 
            LitInt(key#0))
           == ((MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0))
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.FilledWithKey$V, Lit(elements#0), Lit(slot#0)))
             && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType)
               == LitInt(key#0)));

// function declaration for MutableMapModel._default.FilledWithEntryKey
function MutableMapModel.__default.FilledWithEntryKey(MutableMapModel._default.FilledWithEntryKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    key#0: int)
   : bool;

function MutableMapModel.__default.FilledWithEntryKey#canCall(MutableMapModel._default.FilledWithEntryKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    key#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.FilledWithEntryKey
axiom true
   ==> (forall MutableMapModel._default.FilledWithEntryKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FilledWithEntryKey(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0) } 
    MutableMapModel.__default.FilledWithEntryKey#canCall(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithEntryKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithEntryKey$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> true);

function MutableMapModel.__default.FilledWithEntryKey#requires(Ty, Seq Box, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.FilledWithEntryKey
axiom (forall MutableMapModel._default.FilledWithEntryKey$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FilledWithEntryKey#requires(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithEntryKey$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.FilledWithEntryKey#requires(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0)
       == (MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithEntryKey$V, elements#0)
         && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)));

// definition axiom for MutableMapModel.__default.FilledWithEntryKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithEntryKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FilledWithEntryKey(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0) } 
    MutableMapModel.__default.FilledWithEntryKey#canCall(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithEntryKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithEntryKey$V, elements#0)
           && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0))
       ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0)
         && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0)
           ==> MutableMapModel.Slot.Slot_q(slot#0))
         && MutableMapModel.__default.FilledWithEntryKey(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0, key#0)
           == (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithEntryKey$V, elements#0, slot#0)
             && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType)
               == key#0));

// definition axiom for MutableMapModel.__default.FilledWithEntryKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FilledWithEntryKey$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.FilledWithEntryKey(MutableMapModel._default.FilledWithEntryKey$V, 
        Lit(elements#0), 
        Lit(slot#0), 
        LitInt(key#0)) } 
    MutableMapModel.__default.FilledWithEntryKey#canCall(MutableMapModel._default.FilledWithEntryKey$V, 
          Lit(elements#0), 
          Lit(slot#0), 
          LitInt(key#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.FilledWithEntryKey$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.FilledWithEntryKey$V, Lit(elements#0)))
           && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0)))
       ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.FilledWithEntryKey$V, Lit(elements#0), Lit(slot#0))
         && (Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithEntryKey$V, Lit(elements#0), Lit(slot#0)))
           ==> MutableMapModel.Slot.Slot_q(Lit(slot#0)))
         && MutableMapModel.__default.FilledWithEntryKey(MutableMapModel._default.FilledWithEntryKey$V, 
            Lit(elements#0), 
            Lit(slot#0), 
            LitInt(key#0))
           == (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.FilledWithEntryKey$V, Lit(elements#0), Lit(slot#0))
             && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType)
               == LitInt(key#0)));

// function declaration for MutableMapModel._default.SlotExplainsKey
function MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SlotExplainsKey$V: Ty, 
    elements#0: Seq Box, 
    skips#0: int, 
    key#0: int)
   : bool;

function MutableMapModel.__default.SlotExplainsKey#canCall(MutableMapModel._default.SlotExplainsKey$V: Ty, 
    elements#0: Seq Box, 
    skips#0: int, 
    key#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.SlotExplainsKey
axiom true
   ==> (forall MutableMapModel._default.SlotExplainsKey$V: Ty, 
      elements#0: Seq Box, 
      skips#0: int, 
      key#0: int :: 
    { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0) } 
    MutableMapModel.__default.SlotExplainsKey#canCall(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotExplainsKey$V)))
           && LitInt(0) <= skips#0
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.SlotExplainsKey$V, elements#0))
       ==> true);

function MutableMapModel.__default.SlotExplainsKey#requires(Ty, Seq Box, int, int) : bool;

// #requires axiom for MutableMapModel.__default.SlotExplainsKey
axiom (forall MutableMapModel._default.SlotExplainsKey$V: Ty, 
    elements#0: Seq Box, 
    skips#0: int, 
    key#0: int :: 
  { MutableMapModel.__default.SlotExplainsKey#requires(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotExplainsKey$V)))
       && LitInt(0) <= skips#0
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.SlotExplainsKey#requires(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0)
       == MutableMapModel.__default.ValidElements(MutableMapModel._default.SlotExplainsKey$V, elements#0));

// definition axiom for MutableMapModel.__default.SlotExplainsKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotExplainsKey$V: Ty, 
      elements#0: Seq Box, 
      skips#0: int, 
      key#0: int :: 
    { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0) } 
    MutableMapModel.__default.SlotExplainsKey#canCall(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotExplainsKey$V)))
           && LitInt(0) <= skips#0
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.SlotExplainsKey$V, elements#0))
       ==> MutableMapModel.__default.SlotForKey#canCall(Seq#Length(elements#0), key#0)
         && MutableMapModel.__default.KthSlotSuccessor#canCall(Seq#Length(elements#0), 
          MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
          skips#0)
         && (var foundSlot#0 := MutableMapModel.__default.KthSlotSuccessor($LS($LZ), 
              Seq#Length(elements#0), 
              MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
              skips#0); 
          MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), foundSlot#0)
             && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), foundSlot#0)
               ==> MutableMapModel.__default.SlotForKey#canCall(Seq#Length(elements#0), key#0)
                 && MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.SlotExplainsKey$V, 
                  elements#0, 
                  MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
                  skips#0, 
                  key#0))
             && (MutableMapModel.__default.SlotForKey#canCall(Seq#Length(elements#0), key#0)
                 && MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.SlotExplainsKey$V, 
                  elements#0, 
                  MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
                  skips#0, 
                  key#0)
                 && MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.SlotExplainsKey$V, 
                  elements#0, 
                  MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
                  skips#0, 
                  key#0)
               ==> MutableMapModel.__default.FilledWithKey#canCall(MutableMapModel._default.SlotExplainsKey$V, elements#0, foundSlot#0, key#0)))
         && MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SlotExplainsKey$V, elements#0, skips#0, key#0)
           == (var foundSlot#0 := MutableMapModel.__default.KthSlotSuccessor($LS($LZ), 
                Seq#Length(elements#0), 
                MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
                skips#0); 
            MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), foundSlot#0)
               && MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.SlotExplainsKey$V, 
                elements#0, 
                MutableMapModel.__default.SlotForKey(Seq#Length(elements#0), key#0), 
                skips#0, 
                key#0)
               && MutableMapModel.__default.FilledWithKey(MutableMapModel._default.SlotExplainsKey$V, elements#0, foundSlot#0, key#0)));

// definition axiom for MutableMapModel.__default.SlotExplainsKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SlotExplainsKey$V: Ty, 
      elements#0: Seq Box, 
      skips#0: int, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SlotExplainsKey$V, 
        Lit(elements#0), 
        LitInt(skips#0), 
        LitInt(key#0)) } 
    MutableMapModel.__default.SlotExplainsKey#canCall(MutableMapModel._default.SlotExplainsKey$V, 
          Lit(elements#0), 
          LitInt(skips#0), 
          LitInt(key#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SlotExplainsKey$V)))
           && LitInt(0) <= skips#0
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.SlotExplainsKey$V, Lit(elements#0))))
       ==> MutableMapModel.__default.SlotForKey#canCall(Seq#Length(Lit(elements#0)), LitInt(key#0))
         && MutableMapModel.__default.KthSlotSuccessor#canCall(Seq#Length(Lit(elements#0)), 
          MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
          LitInt(skips#0))
         && (var foundSlot#1 := MutableMapModel.__default.KthSlotSuccessor($LS($LZ), 
              Seq#Length(Lit(elements#0)), 
              MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
              LitInt(skips#0)); 
          MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), foundSlot#1)
             && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), foundSlot#1)
               ==> MutableMapModel.__default.SlotForKey#canCall(Seq#Length(Lit(elements#0)), LitInt(key#0))
                 && MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.SlotExplainsKey$V, 
                  Lit(elements#0), 
                  MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
                  LitInt(skips#0), 
                  LitInt(key#0)))
             && (MutableMapModel.__default.SlotForKey#canCall(Seq#Length(Lit(elements#0)), LitInt(key#0))
                 && MutableMapModel.__default.FilledWithOtherKeys#canCall(MutableMapModel._default.SlotExplainsKey$V, 
                  Lit(elements#0), 
                  MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
                  LitInt(skips#0), 
                  LitInt(key#0))
                 && MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.SlotExplainsKey$V, 
                  Lit(elements#0), 
                  MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
                  LitInt(skips#0), 
                  LitInt(key#0))
               ==> MutableMapModel.__default.FilledWithKey#canCall(MutableMapModel._default.SlotExplainsKey$V, 
                Lit(elements#0), 
                foundSlot#1, 
                LitInt(key#0))))
         && MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SlotExplainsKey$V, 
            Lit(elements#0), 
            LitInt(skips#0), 
            LitInt(key#0))
           == (var foundSlot#1 := MutableMapModel.__default.KthSlotSuccessor($LS($LZ), 
                Seq#Length(Lit(elements#0)), 
                MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
                LitInt(skips#0)); 
            MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), foundSlot#1)
               && MutableMapModel.__default.FilledWithOtherKeys(MutableMapModel._default.SlotExplainsKey$V, 
                Lit(elements#0), 
                MutableMapModel.__default.SlotForKey(Seq#Length(Lit(elements#0)), LitInt(key#0)), 
                LitInt(skips#0), 
                LitInt(key#0))
               && MutableMapModel.__default.FilledWithKey(MutableMapModel._default.SlotExplainsKey$V, 
                Lit(elements#0), 
                foundSlot#1, 
                LitInt(key#0))));

// function declaration for MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey
function MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V: Ty, 
    elements#0: Seq Box, 
    slot1#0: DatatypeType, 
    slot2#0: DatatypeType)
   : bool;

function MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V: Ty, 
    elements#0: Seq Box, 
    slot1#0: DatatypeType, 
    slot2#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey
axiom true
   ==> (forall MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V: Ty, 
      elements#0: Seq Box, 
      slot1#0: DatatypeType, 
      slot2#0: DatatypeType :: 
    { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
        elements#0, 
        slot1#0, 
        slot2#0) } 
    MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
          elements#0, 
          slot1#0, 
          slot2#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V)))
           && $Is(slot1#0, Tclass.MutableMapModel.Slot())
           && $Is(slot2#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0))
       ==> true);

function MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#requires(Ty, Seq Box, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey
axiom (forall MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V: Ty, 
    elements#0: Seq Box, 
    slot1#0: DatatypeType, 
    slot2#0: DatatypeType :: 
  { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#requires(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
      elements#0, 
      slot1#0, 
      slot2#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V)))
       && $Is(slot1#0, Tclass.MutableMapModel.Slot())
       && $Is(slot2#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#requires(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
        elements#0, 
        slot1#0, 
        slot2#0)
       == MutableMapModel.__default.ValidElements(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0));

// definition axiom for MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V: Ty, 
      elements#0: Seq Box, 
      slot1#0: DatatypeType, 
      slot2#0: DatatypeType :: 
    { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
        elements#0, 
        slot1#0, 
        slot2#0) } 
    MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
          elements#0, 
          slot1#0, 
          slot2#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V)))
           && $Is(slot1#0, Tclass.MutableMapModel.Slot())
           && $Is(slot2#0, Tclass.MutableMapModel.Slot())
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0))
       ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot1#0)
         && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0)
           ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot2#0))
         && (MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot2#0)
             && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0)
           ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)
             && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)))
         && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)
             && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0))
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0))
           ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)
             && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)))
         && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)
             && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0))
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0))
           ==> MutableMapModel.Slot.Slot_q(slot1#0) && MutableMapModel.Slot.Slot_q(slot2#0))
         && MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
            elements#0, 
            slot1#0, 
            slot2#0)
           == (
            MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0)
             && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0)
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0)
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot1#0))
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0)
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, elements#0, slot2#0))
             && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot1#0))): DatatypeType)
               == MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot2#0))): DatatypeType)));

// definition axiom for MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V: Ty, 
      elements#0: Seq Box, 
      slot1#0: DatatypeType, 
      slot2#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
        Lit(elements#0), 
        Lit(slot1#0), 
        Lit(slot2#0)) } 
    MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
          Lit(elements#0), 
          Lit(slot1#0), 
          Lit(slot2#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V)))
           && $Is(slot1#0, Tclass.MutableMapModel.Slot())
           && $Is(slot2#0, Tclass.MutableMapModel.Slot())
           && Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, Lit(elements#0))))
       ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), Lit(slot1#0))
         && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot1#0))
           ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), Lit(slot2#0)))
         && (MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), Lit(slot2#0))
             && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot2#0))
           ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
              Lit(elements#0), 
              Lit(slot1#0))
             && (!Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot1#0)))
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot1#0))))
         && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
              Lit(elements#0), 
              Lit(slot1#0))
             && (!Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot1#0)))
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot1#0)))
             && Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot1#0))
                 || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot1#0)))
           ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
              Lit(elements#0), 
              Lit(slot2#0))
             && (!Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot2#0)))
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot2#0))))
         && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
              Lit(elements#0), 
              Lit(slot2#0))
             && (!Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot2#0)))
               ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot2#0)))
             && Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot2#0))
                 || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                  Lit(elements#0), 
                  Lit(slot2#0)))
           ==> MutableMapModel.Slot.Slot_q(Lit(slot1#0))
             && MutableMapModel.Slot.Slot_q(Lit(slot2#0)))
         && MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
            Lit(elements#0), 
            Lit(slot1#0), 
            Lit(slot2#0))
           == (
            MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot1#0))
             && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot2#0))
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot1#0))
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot1#0)))
             && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot2#0))
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TwoNonEmptyValidSlotsWithSameKey$V, 
                Lit(elements#0), 
                Lit(slot2#0)))
             && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot1#0))))): DatatypeType)
               == MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot2#0))))): DatatypeType)));

// function declaration for MutableMapModel._default.SameSlot
function MutableMapModel.__default.SameSlot(elementsLength#0: int, slot1#0: DatatypeType, slot2#0: DatatypeType) : bool;

function MutableMapModel.__default.SameSlot#canCall(elementsLength#0: int, slot1#0: DatatypeType, slot2#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.SameSlot
axiom true
   ==> (forall elementsLength#0: int, slot1#0: DatatypeType, slot2#0: DatatypeType :: 
    { MutableMapModel.__default.SameSlot(elementsLength#0, slot1#0, slot2#0) } 
    MutableMapModel.__default.SameSlot#canCall(elementsLength#0, slot1#0, slot2#0)
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot1#0, Tclass.MutableMapModel.Slot())
           && $Is(slot2#0, Tclass.MutableMapModel.Slot())
           && 
          MutableMapModel.__default.ValidSlot(elementsLength#0, slot1#0)
           && MutableMapModel.__default.ValidSlot(elementsLength#0, slot2#0))
       ==> true);

function MutableMapModel.__default.SameSlot#requires(int, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SameSlot
axiom (forall elementsLength#0: int, slot1#0: DatatypeType, slot2#0: DatatypeType :: 
  { MutableMapModel.__default.SameSlot#requires(elementsLength#0, slot1#0, slot2#0) } 
  LitInt(0) <= elementsLength#0
       && $Is(slot1#0, Tclass.MutableMapModel.Slot())
       && $Is(slot2#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.SameSlot#requires(elementsLength#0, slot1#0, slot2#0)
       == (MutableMapModel.__default.ValidSlot(elementsLength#0, slot1#0)
         && MutableMapModel.__default.ValidSlot(elementsLength#0, slot2#0)));

// definition axiom for MutableMapModel.__default.SameSlot(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot1#0: DatatypeType, slot2#0: DatatypeType :: 
    { MutableMapModel.__default.SameSlot(elementsLength#0, slot1#0, slot2#0) } 
    MutableMapModel.__default.SameSlot#canCall(elementsLength#0, slot1#0, slot2#0)
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot1#0, Tclass.MutableMapModel.Slot())
           && $Is(slot2#0, Tclass.MutableMapModel.Slot())
           && 
          MutableMapModel.__default.ValidSlot(elementsLength#0, slot1#0)
           && MutableMapModel.__default.ValidSlot(elementsLength#0, slot2#0))
       ==> $IsA#MutableMapModel.Slot(slot1#0)
         && $IsA#MutableMapModel.Slot(slot2#0)
         && MutableMapModel.__default.SameSlot(elementsLength#0, slot1#0, slot2#0)
           == MutableMapModel.Slot#Equal(slot1#0, slot2#0));

// definition axiom for MutableMapModel.__default.SameSlot for all literals(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot1#0: DatatypeType, slot2#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SameSlot(LitInt(elementsLength#0), Lit(slot1#0), Lit(slot2#0)) } 
    MutableMapModel.__default.SameSlot#canCall(LitInt(elementsLength#0), Lit(slot1#0), Lit(slot2#0))
         || (
          LitInt(0) <= elementsLength#0
           && $Is(slot1#0, Tclass.MutableMapModel.Slot())
           && $Is(slot2#0, Tclass.MutableMapModel.Slot())
           && 
          Lit(MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(slot1#0)))
           && Lit(MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(slot2#0))))
       ==> $IsA#MutableMapModel.Slot(Lit(slot1#0))
         && $IsA#MutableMapModel.Slot(Lit(slot2#0))
         && MutableMapModel.__default.SameSlot(LitInt(elementsLength#0), Lit(slot1#0), Lit(slot2#0))
           == MutableMapModel.Slot#Equal(slot1#0, slot2#0));

// function declaration for MutableMapModel._default.CantEquivocateStorageKey
function MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.CantEquivocateStorageKey$V: Ty, elements#0: Seq Box)
   : bool;

function MutableMapModel.__default.CantEquivocateStorageKey#canCall(MutableMapModel._default.CantEquivocateStorageKey$V: Ty, elements#0: Seq Box)
   : bool;

// consequence axiom for MutableMapModel.__default.CantEquivocateStorageKey
axiom true
   ==> (forall MutableMapModel._default.CantEquivocateStorageKey$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0) } 
    MutableMapModel.__default.CantEquivocateStorageKey#canCall(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0)
         || ($Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocateStorageKey$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0))
       ==> true);

function MutableMapModel.__default.CantEquivocateStorageKey#requires(Ty, Seq Box) : bool;

// #requires axiom for MutableMapModel.__default.CantEquivocateStorageKey
axiom (forall MutableMapModel._default.CantEquivocateStorageKey$V: Ty, elements#0: Seq Box :: 
  { MutableMapModel.__default.CantEquivocateStorageKey#requires(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0) } 
  $Is(elements#0, 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocateStorageKey$V)))
     ==> MutableMapModel.__default.CantEquivocateStorageKey#requires(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0)
       == MutableMapModel.__default.ValidElements(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0));

// definition axiom for MutableMapModel.__default.CantEquivocateStorageKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.CantEquivocateStorageKey$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0) } 
    MutableMapModel.__default.CantEquivocateStorageKey#canCall(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0)
         || ($Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocateStorageKey$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0))
       ==> (forall slot1#0: DatatypeType, slot2#0: DatatypeType :: 
          { MutableMapModel.__default.SameSlot(Seq#Length(elements#0), slot1#0, slot2#0) } 
            { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
              elements#0, 
              slot1#0, 
              slot2#0) } 
          $Is(slot1#0, Tclass.MutableMapModel.Slot())
               && $Is(slot2#0, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#canCall(MutableMapModel._default.CantEquivocateStorageKey$V, 
                elements#0, 
                slot1#0, 
                slot2#0)
               && (MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
                  elements#0, 
                  slot1#0, 
                  slot2#0)
                 ==> MutableMapModel.__default.SameSlot#canCall(Seq#Length(elements#0), slot1#0, slot2#0)))
         && MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.CantEquivocateStorageKey$V, elements#0)
           == (forall slot1#0: DatatypeType, slot2#0: DatatypeType :: 
            { MutableMapModel.__default.SameSlot(Seq#Length(elements#0), slot1#0, slot2#0) } 
              { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
                elements#0, 
                slot1#0, 
                slot2#0) } 
            $Is(slot1#0, Tclass.MutableMapModel.Slot())
                 && $Is(slot2#0, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
                elements#0, 
                slot1#0, 
                slot2#0)
               ==> MutableMapModel.__default.SameSlot(Seq#Length(elements#0), slot1#0, slot2#0)));

// definition axiom for MutableMapModel.__default.CantEquivocateStorageKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.CantEquivocateStorageKey$V: Ty, elements#0: Seq Box :: 
    {:weight 3} { MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.CantEquivocateStorageKey$V, Lit(elements#0)) } 
    MutableMapModel.__default.CantEquivocateStorageKey#canCall(MutableMapModel._default.CantEquivocateStorageKey$V, Lit(elements#0))
         || ($Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocateStorageKey$V)))
           && Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.CantEquivocateStorageKey$V, Lit(elements#0))))
       ==> (forall slot1#1: DatatypeType, slot2#1: DatatypeType :: 
          { MutableMapModel.__default.SameSlot(Seq#Length(elements#0), slot1#1, slot2#1) } 
            { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
              elements#0, 
              slot1#1, 
              slot2#1) } 
          $Is(slot1#1, Tclass.MutableMapModel.Slot())
               && $Is(slot2#1, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey#canCall(MutableMapModel._default.CantEquivocateStorageKey$V, 
                Lit(elements#0), 
                slot1#1, 
                slot2#1)
               && (MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
                  Lit(elements#0), 
                  slot1#1, 
                  slot2#1)
                 ==> MutableMapModel.__default.SameSlot#canCall(Seq#Length(Lit(elements#0)), slot1#1, slot2#1)))
         && MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.CantEquivocateStorageKey$V, Lit(elements#0))
           == (forall slot1#1: DatatypeType, slot2#1: DatatypeType :: 
            { MutableMapModel.__default.SameSlot(Seq#Length(elements#0), slot1#1, slot2#1) } 
              { MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
                elements#0, 
                slot1#1, 
                slot2#1) } 
            $Is(slot1#1, Tclass.MutableMapModel.Slot())
                 && $Is(slot2#1, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.TwoNonEmptyValidSlotsWithSameKey(MutableMapModel._default.CantEquivocateStorageKey$V, 
                Lit(elements#0), 
                slot1#1, 
                slot2#1)
               ==> MutableMapModel.__default.SameSlot(Seq#Length(Lit(elements#0)), slot1#1, slot2#1)));

// function declaration for MutableMapModel._default.KeyInSlotIsInContents
function MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.KeyInSlotIsInContents$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box, 
    slot#0: DatatypeType)
   : bool;

function MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.KeyInSlotIsInContents$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box, 
    slot#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.KeyInSlotIsInContents
axiom true
   ==> (forall MutableMapModel._default.KeyInSlotIsInContents$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0) } 
    MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.KeyInSlotIsInContents$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.KeyInSlotIsInContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
           && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, slot#0)
             || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, slot#0)))
       ==> true);

function MutableMapModel.__default.KeyInSlotIsInContents#requires(Ty, Seq Box, Map Box Box, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.KeyInSlotIsInContents
axiom (forall MutableMapModel._default.KeyInSlotIsInContents$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box, 
    slot#0: DatatypeType :: 
  { MutableMapModel.__default.KeyInSlotIsInContents#requires(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.KeyInSlotIsInContents$V)))
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel._default.KeyInSlotIsInContents$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
     ==> MutableMapModel.__default.KeyInSlotIsInContents#requires(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0)
       == (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
         && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, slot#0)
           || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, slot#0))));

// definition axiom for MutableMapModel.__default.KeyInSlotIsInContents(revealed)
axiom true
   ==> (forall MutableMapModel._default.KeyInSlotIsInContents$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box, 
      slot#0: DatatypeType :: 
    { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0) } 
    MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.KeyInSlotIsInContents$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.KeyInSlotIsInContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
           && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, slot#0)
             || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, slot#0)))
       ==> (Lit(true) ==> MutableMapModel.Slot.Slot_q(slot#0))
         && MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.KeyInSlotIsInContents$V, elements#0, contents#0, slot#0)
           == (true
             && (var key#0 := MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType); 
              true && Map#Domain(contents#0)[$Box(key#0)])));

// definition axiom for MutableMapModel.__default.KeyInSlotIsInContents for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.KeyInSlotIsInContents$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box, 
      slot#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.KeyInSlotIsInContents$V, 
        Lit(elements#0), 
        Lit(contents#0), 
        Lit(slot#0)) } 
    MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.KeyInSlotIsInContents$V, 
          Lit(elements#0), 
          Lit(contents#0), 
          Lit(slot#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.KeyInSlotIsInContents$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.KeyInSlotIsInContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0))
           && Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.KeyInSlotIsInContents$V, Lit(elements#0), Lit(slot#0))
               || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.KeyInSlotIsInContents$V, Lit(elements#0), Lit(slot#0))))
       ==> (Lit(true) ==> MutableMapModel.Slot.Slot_q(Lit(slot#0)))
         && MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.KeyInSlotIsInContents$V, 
            Lit(elements#0), 
            Lit(contents#0), 
            Lit(slot#0))
           == (true
             && (var key#1 := MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType); 
              true && Map#Domain(contents#0)[$Box(key#1)])));

// function declaration for MutableMapModel._default.SeqMatchesContentKeys
function MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.SeqMatchesContentKeys$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box)
   : bool;

function MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.SeqMatchesContentKeys$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box)
   : bool;

// consequence axiom for MutableMapModel.__default.SeqMatchesContentKeys
axiom true
   ==> (forall MutableMapModel._default.SeqMatchesContentKeys$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0) } 
    MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SeqMatchesContentKeys$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.SeqMatchesContentKeys$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0))
       ==> true);

function MutableMapModel.__default.SeqMatchesContentKeys#requires(Ty, Seq Box, Map Box Box) : bool;

// #requires axiom for MutableMapModel.__default.SeqMatchesContentKeys
axiom (forall MutableMapModel._default.SeqMatchesContentKeys$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box :: 
  { MutableMapModel.__default.SeqMatchesContentKeys#requires(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SeqMatchesContentKeys$V)))
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel._default.SeqMatchesContentKeys$V)))
     ==> MutableMapModel.__default.SeqMatchesContentKeys#requires(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0)
       == MutableMapModel.__default.ValidElements(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0));

// definition axiom for MutableMapModel.__default.SeqMatchesContentKeys(revealed)
axiom true
   ==> (forall MutableMapModel._default.SeqMatchesContentKeys$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0) } 
    MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SeqMatchesContentKeys$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.SeqMatchesContentKeys$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0))
       ==> (forall key#0: int :: 
          { Map#Domain(contents#0)[$Box(key#0)] } 
          LitInt(0) <= key#0 && key#0 < 18446744073709551616
             ==> 
            Map#Domain(contents#0)[$Box(key#0)]
             ==> (forall skips#0: int :: 
              { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#0, key#0) } 
              LitInt(0) <= skips#0
                 ==> MutableMapModel.__default.SlotExplainsKey#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#0, key#0)))
         && ((forall key#0: int :: 
            { Map#Domain(contents#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 18446744073709551616
               ==> 
              Map#Domain(contents#0)[$Box(key#0)]
               ==> (exists skips#0: int :: 
                { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#0, key#0) } 
                LitInt(0) <= skips#0
                   && MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#0, key#0)))
           ==> (forall slot#0: DatatypeType :: 
            { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0) } 
              { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
              { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
            $Is(slot#0, Tclass.MutableMapModel.Slot())
               ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot#0)
                 && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                   ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                     && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                       ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)))
                 && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                     && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                       ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0))
                     && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                       || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0))
                   ==> MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0))))
         && ((forall slot#0: DatatypeType :: 
              { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0) } 
                { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
                { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
                { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
              $Is(slot#0, Tclass.MutableMapModel.Slot())
                 ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot#0)
                   && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                     ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                       && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                         ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)))
                   && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                       && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                         ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0))
                       && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                         || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0))
                     ==> MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0)))
             && (forall slot#0: DatatypeType :: 
              { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0) } 
                { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
                { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
                { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
              $Is(slot#0, Tclass.MutableMapModel.Slot())
                 ==> 
                MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                   && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                     || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0))
                 ==> MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0))
           ==> MutableMapModel.__default.CantEquivocateStorageKey#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0))
         && MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0)
           == (
            (forall key#0: int :: 
              { Map#Domain(contents#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 18446744073709551616
                 ==> 
                Map#Domain(contents#0)[$Box(key#0)]
                 ==> (exists skips#0: int :: 
                  { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#0, key#0) } 
                  LitInt(0) <= skips#0
                     && MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#0, key#0)))
             && (forall slot#0: DatatypeType :: 
              { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0) } 
                { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
                { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0) } 
                { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
              $Is(slot#0, Tclass.MutableMapModel.Slot())
                 ==> 
                MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                   && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0)
                     || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#0))
                 ==> MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#0))
             && MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0)));

// definition axiom for MutableMapModel.__default.SeqMatchesContentKeys for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SeqMatchesContentKeys$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    {:weight 3} { MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.SeqMatchesContentKeys$V, 
        Lit(elements#0), 
        Lit(contents#0)) } 
    MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, 
          Lit(elements#0), 
          Lit(contents#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.SeqMatchesContentKeys$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.SeqMatchesContentKeys$V)))
           && Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0))))
       ==> (forall key#1: int :: 
          { Map#Domain(contents#0)[$Box(key#1)] } 
          LitInt(0) <= key#1 && key#1 < 18446744073709551616
             ==> 
            Map#Domain(contents#0)[$Box(key#1)]
             ==> (forall skips#1: int :: 
              { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#1, key#1) } 
              LitInt(0) <= skips#1
                 ==> MutableMapModel.__default.SlotExplainsKey#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, 
                  Lit(elements#0), 
                  skips#1, 
                  key#1)))
         && ((forall key#1: int :: 
            { Map#Domain(contents#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 18446744073709551616
               ==> 
              Map#Domain(contents#0)[$Box(key#1)]
               ==> (exists skips#1: int :: 
                { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#1, key#1) } 
                LitInt(0) <= skips#1
                   && MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, 
                    Lit(elements#0), 
                    skips#1, 
                    key#1)))
           ==> (forall slot#1: DatatypeType :: 
            { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#1) } 
              { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
              { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
            $Is(slot#1, Tclass.MutableMapModel.Slot())
               ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot#1)
                 && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                   ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                     && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                       ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)))
                 && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                     && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                       ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1))
                     && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                       || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1))
                   ==> MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, 
                    Lit(elements#0), 
                    Lit(contents#0), 
                    slot#1))))
         && ((forall slot#1: DatatypeType :: 
              { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#1) } 
                { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
                { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
                { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
              $Is(slot#1, Tclass.MutableMapModel.Slot())
                 ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot#1)
                   && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                     ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                       && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                         ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)))
                   && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                       && (!MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                         ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1))
                       && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                         || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1))
                     ==> MutableMapModel.__default.KeyInSlotIsInContents#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, 
                      Lit(elements#0), 
                      Lit(contents#0), 
                      slot#1)))
             && (forall slot#1: DatatypeType :: 
              { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#1) } 
                { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
                { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
                { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
              $Is(slot#1, Tclass.MutableMapModel.Slot())
                 ==> 
                MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                   && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                     || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1))
                 ==> MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, 
                  Lit(elements#0), 
                  Lit(contents#0), 
                  slot#1))
           ==> MutableMapModel.__default.CantEquivocateStorageKey#canCall(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0)))
         && MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.SeqMatchesContentKeys$V, 
            Lit(elements#0), 
            Lit(contents#0))
           == (
            (forall key#1: int :: 
              { Map#Domain(contents#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 18446744073709551616
                 ==> 
                Map#Domain(contents#0)[$Box(key#1)]
                 ==> (exists skips#1: int :: 
                  { MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, skips#1, key#1) } 
                  LitInt(0) <= skips#1
                     && MutableMapModel.__default.SlotExplainsKey(MutableMapModel._default.SeqMatchesContentKeys$V, 
                      Lit(elements#0), 
                      skips#1, 
                      key#1)))
             && (forall slot#1: DatatypeType :: 
              { MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, contents#0, slot#1) } 
                { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
                { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, elements#0, slot#1) } 
                { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
              $Is(slot#1, Tclass.MutableMapModel.Slot())
                 ==> 
                MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                   && (MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1)
                     || MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0), slot#1))
                 ==> MutableMapModel.__default.KeyInSlotIsInContents(MutableMapModel._default.SeqMatchesContentKeys$V, 
                  Lit(elements#0), 
                  Lit(contents#0), 
                  slot#1))
             && MutableMapModel.__default.CantEquivocateStorageKey(MutableMapModel._default.SeqMatchesContentKeys$V, Lit(elements#0))));

// function declaration for MutableMapModel._default.EntryInSlotMatchesContents
function MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntryInSlotMatchesContents$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    contents#0: Map Box Box)
   : bool;

function MutableMapModel.__default.EntryInSlotMatchesContents#canCall(MutableMapModel._default.EntryInSlotMatchesContents$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    contents#0: Map Box Box)
   : bool;

// consequence axiom for MutableMapModel.__default.EntryInSlotMatchesContents
axiom true
   ==> (forall MutableMapModel._default.EntryInSlotMatchesContents$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntryInSlotMatchesContents$V, 
        elements#0, 
        slot#0, 
        contents#0) } 
    MutableMapModel.__default.EntryInSlotMatchesContents#canCall(MutableMapModel._default.EntryInSlotMatchesContents$V, 
          elements#0, 
          slot#0, 
          contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntryInSlotMatchesContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.EntryInSlotMatchesContents$V)))
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
           && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntryInSlotMatchesContents$V, elements#0, slot#0))
       ==> true);

function MutableMapModel.__default.EntryInSlotMatchesContents#requires(Ty, Seq Box, DatatypeType, Map Box Box) : bool;

// #requires axiom for MutableMapModel.__default.EntryInSlotMatchesContents
axiom (forall MutableMapModel._default.EntryInSlotMatchesContents$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    contents#0: Map Box Box :: 
  { MutableMapModel.__default.EntryInSlotMatchesContents#requires(MutableMapModel._default.EntryInSlotMatchesContents$V, 
      elements#0, 
      slot#0, 
      contents#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntryInSlotMatchesContents$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel._default.EntryInSlotMatchesContents$V)))
     ==> MutableMapModel.__default.EntryInSlotMatchesContents#requires(MutableMapModel._default.EntryInSlotMatchesContents$V, 
        elements#0, 
        slot#0, 
        contents#0)
       == (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
         && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntryInSlotMatchesContents$V, elements#0, slot#0)));

// definition axiom for MutableMapModel.__default.EntryInSlotMatchesContents(revealed)
axiom true
   ==> (forall MutableMapModel._default.EntryInSlotMatchesContents$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntryInSlotMatchesContents$V, 
        elements#0, 
        slot#0, 
        contents#0) } 
    MutableMapModel.__default.EntryInSlotMatchesContents#canCall(MutableMapModel._default.EntryInSlotMatchesContents$V, 
          elements#0, 
          slot#0, 
          contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntryInSlotMatchesContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.EntryInSlotMatchesContents$V)))
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
           && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntryInSlotMatchesContents$V, elements#0, slot#0))
       ==> (Lit(true)
           ==> MutableMapModel.Slot.Slot_q(slot#0)
             && (var item#0 := $Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType; 
              Map#Domain(contents#0)[$Box(MutableMapModel.Item.key(item#0))]
                 ==> $IsA#Options.Option($Unbox(Map#Elements(contents#0)[$Box(MutableMapModel.Item.key(item#0))]): DatatypeType)))
         && MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntryInSlotMatchesContents$V, 
            elements#0, 
            slot#0, 
            contents#0)
           == (true
             && (var item#0 := $Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType; 
              Map#Domain(contents#0)[$Box(MutableMapModel.Item.key(item#0))]
                 && Options.Option#Equal($Unbox(Map#Elements(contents#0)[$Box(MutableMapModel.Item.key(item#0))]): DatatypeType, 
                  #Options.Option.Some(MutableMapModel.Item.value(item#0))))));

// definition axiom for MutableMapModel.__default.EntryInSlotMatchesContents for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.EntryInSlotMatchesContents$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      contents#0: Map Box Box :: 
    {:weight 3} { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntryInSlotMatchesContents$V, 
        Lit(elements#0), 
        Lit(slot#0), 
        Lit(contents#0)) } 
    MutableMapModel.__default.EntryInSlotMatchesContents#canCall(MutableMapModel._default.EntryInSlotMatchesContents$V, 
          Lit(elements#0), 
          Lit(slot#0), 
          Lit(contents#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntryInSlotMatchesContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.EntryInSlotMatchesContents$V)))
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0))
           && Lit(MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntryInSlotMatchesContents$V, 
              Lit(elements#0), 
              Lit(slot#0))))
       ==> (Lit(true)
           ==> MutableMapModel.Slot.Slot_q(Lit(slot#0))
             && (var item#1 := $Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType; 
              Map#Domain(contents#0)[$Box(MutableMapModel.Item.key(item#1))]
                 ==> $IsA#Options.Option($Unbox(Map#Elements(Lit(contents#0))[$Box(MutableMapModel.Item.key(item#1))]): DatatypeType)))
         && MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntryInSlotMatchesContents$V, 
            Lit(elements#0), 
            Lit(slot#0), 
            Lit(contents#0))
           == (true
             && (var item#1 := $Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType; 
              Map#Domain(contents#0)[$Box(MutableMapModel.Item.key(item#1))]
                 && Options.Option#Equal($Unbox(Map#Elements(Lit(contents#0))[$Box(MutableMapModel.Item.key(item#1))]): DatatypeType, 
                  #Options.Option.Some(MutableMapModel.Item.value(item#1))))));

// function declaration for MutableMapModel._default.TombstoneInSlotMatchesContents
function MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstoneInSlotMatchesContents$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    contents#0: Map Box Box)
   : bool;

function MutableMapModel.__default.TombstoneInSlotMatchesContents#canCall(MutableMapModel._default.TombstoneInSlotMatchesContents$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    contents#0: Map Box Box)
   : bool;

// consequence axiom for MutableMapModel.__default.TombstoneInSlotMatchesContents
axiom true
   ==> (forall MutableMapModel._default.TombstoneInSlotMatchesContents$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
        elements#0, 
        slot#0, 
        contents#0) } 
    MutableMapModel.__default.TombstoneInSlotMatchesContents#canCall(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
          elements#0, 
          slot#0, 
          contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
           && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstoneInSlotMatchesContents$V, elements#0, slot#0))
       ==> true);

function MutableMapModel.__default.TombstoneInSlotMatchesContents#requires(Ty, Seq Box, DatatypeType, Map Box Box) : bool;

// #requires axiom for MutableMapModel.__default.TombstoneInSlotMatchesContents
axiom (forall MutableMapModel._default.TombstoneInSlotMatchesContents$V: Ty, 
    elements#0: Seq Box, 
    slot#0: DatatypeType, 
    contents#0: Map Box Box :: 
  { MutableMapModel.__default.TombstoneInSlotMatchesContents#requires(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
      elements#0, 
      slot#0, 
      contents#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
       && $Is(slot#0, Tclass.MutableMapModel.Slot())
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
     ==> MutableMapModel.__default.TombstoneInSlotMatchesContents#requires(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
        elements#0, 
        slot#0, 
        contents#0)
       == (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
         && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstoneInSlotMatchesContents$V, elements#0, slot#0)));

// definition axiom for MutableMapModel.__default.TombstoneInSlotMatchesContents(revealed)
axiom true
   ==> (forall MutableMapModel._default.TombstoneInSlotMatchesContents$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
        elements#0, 
        slot#0, 
        contents#0) } 
    MutableMapModel.__default.TombstoneInSlotMatchesContents#canCall(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
          elements#0, 
          slot#0, 
          contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
           && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstoneInSlotMatchesContents$V, elements#0, slot#0))
       ==> (Lit(true) ==> MutableMapModel.Slot.Slot_q(slot#0))
         && MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
            elements#0, 
            slot#0, 
            contents#0)
           == (true
             && (var item#0 := $Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType; 
              Map#Domain(contents#0)[$Box(MutableMapModel.Item.key(item#0))]
                 && Options.Option.None_q($Unbox(Map#Elements(contents#0)[$Box(MutableMapModel.Item.key(item#0))]): DatatypeType))));

// definition axiom for MutableMapModel.__default.TombstoneInSlotMatchesContents for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.TombstoneInSlotMatchesContents$V: Ty, 
      elements#0: Seq Box, 
      slot#0: DatatypeType, 
      contents#0: Map Box Box :: 
    {:weight 3} { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
        Lit(elements#0), 
        Lit(slot#0), 
        Lit(contents#0)) } 
    MutableMapModel.__default.TombstoneInSlotMatchesContents#canCall(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
          Lit(elements#0), 
          Lit(slot#0), 
          Lit(contents#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
           && $Is(slot#0, Tclass.MutableMapModel.Slot())
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.TombstoneInSlotMatchesContents$V)))
           && 
          MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), Lit(slot#0))
           && Lit(MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
              Lit(elements#0), 
              Lit(slot#0))))
       ==> (Lit(true) ==> MutableMapModel.Slot.Slot_q(Lit(slot#0)))
         && MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstoneInSlotMatchesContents$V, 
            Lit(elements#0), 
            Lit(slot#0), 
            Lit(contents#0))
           == (true
             && (var item#1 := $Unbox(Seq#Index(Lit(elements#0), LitInt(MutableMapModel.Slot.slot(Lit(slot#0))))): DatatypeType; 
              Map#Domain(contents#0)[$Box(MutableMapModel.Item.key(item#1))]
                 && Options.Option.None_q($Unbox(Map#Elements(Lit(contents#0))[$Box(MutableMapModel.Item.key(item#1))]): DatatypeType))));

// function declaration for MutableMapModel._default.EntriesMatchContentValue
function MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.EntriesMatchContentValue$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box)
   : bool;

function MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.EntriesMatchContentValue$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box)
   : bool;

// consequence axiom for MutableMapModel.__default.EntriesMatchContentValue
axiom true
   ==> (forall MutableMapModel._default.EntriesMatchContentValue$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0) } 
    MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntriesMatchContentValue$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.EntriesMatchContentValue$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.EntriesMatchContentValue$V, elements#0))
       ==> true);

function MutableMapModel.__default.EntriesMatchContentValue#requires(Ty, Seq Box, Map Box Box) : bool;

// #requires axiom for MutableMapModel.__default.EntriesMatchContentValue
axiom (forall MutableMapModel._default.EntriesMatchContentValue$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box :: 
  { MutableMapModel.__default.EntriesMatchContentValue#requires(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntriesMatchContentValue$V)))
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel._default.EntriesMatchContentValue$V)))
     ==> MutableMapModel.__default.EntriesMatchContentValue#requires(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0)
       == MutableMapModel.__default.ValidElements(MutableMapModel._default.EntriesMatchContentValue$V, elements#0));

// definition axiom for MutableMapModel.__default.EntriesMatchContentValue(revealed)
axiom true
   ==> (forall MutableMapModel._default.EntriesMatchContentValue$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0) } 
    MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntriesMatchContentValue$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.EntriesMatchContentValue$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.EntriesMatchContentValue$V, elements#0))
       ==> (forall slot#0: DatatypeType :: 
          { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntriesMatchContentValue$V, 
              elements#0, 
              slot#0, 
              contents#0) } 
            { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#0) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
          $Is(slot#0, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot#0)
               && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                 ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#0))
               && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#0)
                   && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#0)
                 ==> MutableMapModel.__default.EntryInSlotMatchesContents#canCall(MutableMapModel._default.EntriesMatchContentValue$V, 
                  elements#0, 
                  slot#0, 
                  contents#0)))
         && MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, contents#0)
           == (forall slot#0: DatatypeType :: 
            { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntriesMatchContentValue$V, 
                elements#0, 
                slot#0, 
                contents#0) } 
              { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#0) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
            $Is(slot#0, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                 && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#0)
               ==> MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntriesMatchContentValue$V, 
                elements#0, 
                slot#0, 
                contents#0)));

// definition axiom for MutableMapModel.__default.EntriesMatchContentValue for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.EntriesMatchContentValue$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    {:weight 3} { MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.EntriesMatchContentValue$V, 
        Lit(elements#0), 
        Lit(contents#0)) } 
    MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.EntriesMatchContentValue$V, 
          Lit(elements#0), 
          Lit(contents#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.EntriesMatchContentValue$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.EntriesMatchContentValue$V)))
           && Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.EntriesMatchContentValue$V, Lit(elements#0))))
       ==> (forall slot#1: DatatypeType :: 
          { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntriesMatchContentValue$V, 
              elements#0, 
              slot#1, 
              contents#0) } 
            { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#1) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
          $Is(slot#1, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot#1)
               && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                 ==> MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.EntriesMatchContentValue$V, Lit(elements#0), slot#1))
               && (MutableMapModel.__default.SlotIsEntry#canCall(MutableMapModel._default.EntriesMatchContentValue$V, Lit(elements#0), slot#1)
                   && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, Lit(elements#0), slot#1)
                 ==> MutableMapModel.__default.EntryInSlotMatchesContents#canCall(MutableMapModel._default.EntriesMatchContentValue$V, 
                  Lit(elements#0), 
                  slot#1, 
                  Lit(contents#0))))
         && MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.EntriesMatchContentValue$V, 
            Lit(elements#0), 
            Lit(contents#0))
           == (forall slot#1: DatatypeType :: 
            { MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntriesMatchContentValue$V, 
                elements#0, 
                slot#1, 
                contents#0) } 
              { MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, elements#0, slot#1) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
            $Is(slot#1, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                 && MutableMapModel.__default.SlotIsEntry(MutableMapModel._default.EntriesMatchContentValue$V, Lit(elements#0), slot#1)
               ==> MutableMapModel.__default.EntryInSlotMatchesContents(MutableMapModel._default.EntriesMatchContentValue$V, 
                Lit(elements#0), 
                slot#1, 
                Lit(contents#0))));

// function declaration for MutableMapModel._default.TombstonesMatchContentValue
function MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.TombstonesMatchContentValue$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box)
   : bool;

function MutableMapModel.__default.TombstonesMatchContentValue#canCall(MutableMapModel._default.TombstonesMatchContentValue$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box)
   : bool;

// consequence axiom for MutableMapModel.__default.TombstonesMatchContentValue
axiom true
   ==> (forall MutableMapModel._default.TombstonesMatchContentValue$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0) } 
    MutableMapModel.__default.TombstonesMatchContentValue#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstonesMatchContentValue$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.TombstonesMatchContentValue$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0))
       ==> true);

function MutableMapModel.__default.TombstonesMatchContentValue#requires(Ty, Seq Box, Map Box Box) : bool;

// #requires axiom for MutableMapModel.__default.TombstonesMatchContentValue
axiom (forall MutableMapModel._default.TombstonesMatchContentValue$V: Ty, 
    elements#0: Seq Box, 
    contents#0: Map Box Box :: 
  { MutableMapModel.__default.TombstonesMatchContentValue#requires(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstonesMatchContentValue$V)))
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          Tclass.Options.Option(MutableMapModel._default.TombstonesMatchContentValue$V)))
     ==> MutableMapModel.__default.TombstonesMatchContentValue#requires(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0)
       == MutableMapModel.__default.ValidElements(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0));

// definition axiom for MutableMapModel.__default.TombstonesMatchContentValue(revealed)
axiom true
   ==> (forall MutableMapModel._default.TombstonesMatchContentValue$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0) } 
    MutableMapModel.__default.TombstonesMatchContentValue#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstonesMatchContentValue$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.TombstonesMatchContentValue$V)))
           && MutableMapModel.__default.ValidElements(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0))
       ==> (forall slot#0: DatatypeType :: 
          { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstonesMatchContentValue$V, 
              elements#0, 
              slot#0, 
              contents#0) } 
            { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#0) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
          $Is(slot#0, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot#0)
               && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                 ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#0))
               && (MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#0)
                   && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#0)
                 ==> MutableMapModel.__default.TombstoneInSlotMatchesContents#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, 
                  elements#0, 
                  slot#0, 
                  contents#0)))
         && MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, contents#0)
           == (forall slot#0: DatatypeType :: 
            { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstonesMatchContentValue$V, 
                elements#0, 
                slot#0, 
                contents#0) } 
              { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#0) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0) } 
            $Is(slot#0, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#0)
                 && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#0)
               ==> MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstonesMatchContentValue$V, 
                elements#0, 
                slot#0, 
                contents#0)));

// definition axiom for MutableMapModel.__default.TombstonesMatchContentValue for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.TombstonesMatchContentValue$V: Ty, 
      elements#0: Seq Box, 
      contents#0: Map Box Box :: 
    {:weight 3} { MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.TombstonesMatchContentValue$V, 
        Lit(elements#0), 
        Lit(contents#0)) } 
    MutableMapModel.__default.TombstonesMatchContentValue#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, 
          Lit(elements#0), 
          Lit(contents#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.TombstonesMatchContentValue$V)))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              Tclass.Options.Option(MutableMapModel._default.TombstonesMatchContentValue$V)))
           && Lit(MutableMapModel.__default.ValidElements(MutableMapModel._default.TombstonesMatchContentValue$V, Lit(elements#0))))
       ==> (forall slot#1: DatatypeType :: 
          { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstonesMatchContentValue$V, 
              elements#0, 
              slot#1, 
              contents#0) } 
            { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#1) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
          $Is(slot#1, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot#1)
               && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                 ==> MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, Lit(elements#0), slot#1))
               && (MutableMapModel.__default.SlotIsTombstone#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, Lit(elements#0), slot#1)
                   && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, Lit(elements#0), slot#1)
                 ==> MutableMapModel.__default.TombstoneInSlotMatchesContents#canCall(MutableMapModel._default.TombstonesMatchContentValue$V, 
                  Lit(elements#0), 
                  slot#1, 
                  Lit(contents#0))))
         && MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.TombstonesMatchContentValue$V, 
            Lit(elements#0), 
            Lit(contents#0))
           == (forall slot#1: DatatypeType :: 
            { MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstonesMatchContentValue$V, 
                elements#0, 
                slot#1, 
                contents#0) } 
              { MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, elements#0, slot#1) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot#1) } 
            $Is(slot#1, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot#1)
                 && MutableMapModel.__default.SlotIsTombstone(MutableMapModel._default.TombstonesMatchContentValue$V, Lit(elements#0), slot#1)
               ==> MutableMapModel.__default.TombstoneInSlotMatchesContents(MutableMapModel._default.TombstonesMatchContentValue$V, 
                Lit(elements#0), 
                slot#1, 
                Lit(contents#0))));

// function declaration for MutableMapModel._default.FixedSizeInv
function MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInv$V: Ty, self#0: DatatypeType) : bool;

function MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.FixedSizeInv$V: Ty, self#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.FixedSizeInv
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInv$V: Ty, self#0: DatatypeType :: 
    { MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInv$V, self#0) } 
    MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.FixedSizeInv$V, self#0)
         || $Is(self#0, 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInv$V))
       ==> true);

function MutableMapModel.__default.FixedSizeInv#requires(Ty, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.FixedSizeInv
axiom (forall MutableMapModel._default.FixedSizeInv$V: Ty, self#0: DatatypeType :: 
  { MutableMapModel.__default.FixedSizeInv#requires(MutableMapModel._default.FixedSizeInv$V, self#0) } 
  $Is(self#0, 
      Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInv$V))
     ==> MutableMapModel.__default.FixedSizeInv#requires(MutableMapModel._default.FixedSizeInv$V, self#0)
       == true);

// definition axiom for MutableMapModel.__default.FixedSizeInv(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInv$V: Ty, self#0: DatatypeType :: 
    { MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInv$V, self#0) } 
    MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.FixedSizeInv$V, self#0)
         || $Is(self#0, 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInv$V))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && (LitInt(128)
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
               < 18446744073709551616
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.count(self#0) < 18446744073709551616
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
               < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && Map#Card(MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
               == MutableMapModel.FixedSizeLinearHashMap.count(self#0)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0)))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
             && MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0)))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
             && MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.__default.TombstonesMatchContentValue#canCall(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0)))
         && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInv$V, self#0)
           == (
            LitInt(128)
               <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
             && Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
               < 18446744073709551616
             && MutableMapModel.FixedSizeLinearHashMap.count(self#0) < 18446744073709551616
             && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
               < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
             && Map#Card(MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
               == MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             && MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
             && MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))
             && MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.FixedSizeInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.FixedSizeLinearHashMap.contents(self#0))));

// definition axiom for MutableMapModel.__default.FixedSizeInv for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInv$V: Ty, self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInv$V, Lit(self#0)) } 
    MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.FixedSizeInv$V, Lit(self#0))
         || $Is(self#0, 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInv$V))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && (LitInt(128)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
               < 18446744073709551616
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && Lit(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0)) < 18446744073709551616)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))
               < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && Map#Card(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))
               == LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0)))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0)))))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.SeqMatchesContentKeys#canCall(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))
             && Lit(MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.FixedSizeInv$V, 
                Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0)))))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0)))))
         && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.EntriesMatchContentValue#canCall(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))
             && Lit(MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.FixedSizeInv$V, 
                Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0)))))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.TombstonesMatchContentValue#canCall(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0)))))
         && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInv$V, Lit(self#0))
           == (
            LitInt(128)
               <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
             && Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
               < 18446744073709551616
             && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0)) < 18446744073709551616
             && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))
               < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
             && Map#Card(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))
               == LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0)))
             && MutableMapModel.__default.SeqMatchesContentKeys(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))
             && MutableMapModel.__default.EntriesMatchContentValue(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))
             && MutableMapModel.__default.TombstonesMatchContentValue(MutableMapModel._default.FixedSizeInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
              Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))))));

// function declaration for MutableMapModel._default.IndexSetThrough
function MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V: Ty, 
    elements#0: Seq Box, 
    through#0: int)
   : Set Box;

function MutableMapModel.__default.IndexSetThrough#canCall(MutableMapModel._default.IndexSetThrough$V: Ty, 
    elements#0: Seq Box, 
    through#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.IndexSetThrough
axiom true
   ==> (forall MutableMapModel._default.IndexSetThrough$V: Ty, 
      elements#0: Seq Box, 
      through#0: int :: 
    { MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0) } 
    MutableMapModel.__default.IndexSetThrough#canCall(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSetThrough$V)))
           && LitInt(0) <= through#0
           && through#0 <= Seq#Length(elements#0))
       ==> $Is(MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0), 
        TSet(TInt)));

function MutableMapModel.__default.IndexSetThrough#requires(Ty, Seq Box, int) : bool;

// #requires axiom for MutableMapModel.__default.IndexSetThrough
axiom (forall MutableMapModel._default.IndexSetThrough$V: Ty, 
    elements#0: Seq Box, 
    through#0: int :: 
  { MutableMapModel.__default.IndexSetThrough#requires(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0) } 
  $Is(elements#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSetThrough$V)))
       && LitInt(0) <= through#0
     ==> MutableMapModel.__default.IndexSetThrough#requires(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0)
       == (through#0 <= Seq#Length(elements#0)));

// definition axiom for MutableMapModel.__default.IndexSetThrough(revealed)
axiom true
   ==> (forall MutableMapModel._default.IndexSetThrough$V: Ty, 
      elements#0: Seq Box, 
      through#0: int :: 
    { MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0) } 
    MutableMapModel.__default.IndexSetThrough#canCall(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0)
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSetThrough$V)))
           && LitInt(0) <= through#0
           && through#0 <= Seq#Length(elements#0))
       ==> MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V, elements#0, through#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, TInt)
             && 
            LitInt(0) <= $Unbox($y#0): int
             && $Unbox($y#0): int < through#0
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(elements#0, $Unbox($y#0): int)): DatatypeType)
               || MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(elements#0, $Unbox($y#0): int)): DatatypeType))));

// definition axiom for MutableMapModel.__default.IndexSetThrough for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.IndexSetThrough$V: Ty, 
      elements#0: Seq Box, 
      through#0: int :: 
    {:weight 3} { MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V, Lit(elements#0), LitInt(through#0)) } 
    MutableMapModel.__default.IndexSetThrough#canCall(MutableMapModel._default.IndexSetThrough$V, Lit(elements#0), LitInt(through#0))
         || (
          $Is(elements#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSetThrough$V)))
           && LitInt(0) <= through#0
           && LitInt(through#0) <= Seq#Length(Lit(elements#0)))
       ==> MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSetThrough$V, Lit(elements#0), LitInt(through#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, TInt)
             && 
            LitInt(0) <= $Unbox($y#1): int
             && $Unbox($y#1): int < through#0
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(elements#0), $Unbox($y#1): int)): DatatypeType)
               || MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(elements#0), $Unbox($y#1): int)): DatatypeType))));

// function declaration for MutableMapModel._default.IndexSet
function MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V: Ty, elements#0: Seq Box) : Set Box;

function MutableMapModel.__default.IndexSet#canCall(MutableMapModel._default.IndexSet$V: Ty, elements#0: Seq Box) : bool;

// consequence axiom for MutableMapModel.__default.IndexSet
axiom true
   ==> (forall MutableMapModel._default.IndexSet$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V, elements#0) } 
    MutableMapModel.__default.IndexSet#canCall(MutableMapModel._default.IndexSet$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSet$V)))
       ==> $Is(MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V, elements#0), 
        TSet(TInt)));

function MutableMapModel.__default.IndexSet#requires(Ty, Seq Box) : bool;

// #requires axiom for MutableMapModel.__default.IndexSet
axiom (forall MutableMapModel._default.IndexSet$V: Ty, elements#0: Seq Box :: 
  { MutableMapModel.__default.IndexSet#requires(MutableMapModel._default.IndexSet$V, elements#0) } 
  $Is(elements#0, 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSet$V)))
     ==> MutableMapModel.__default.IndexSet#requires(MutableMapModel._default.IndexSet$V, elements#0)
       == true);

// definition axiom for MutableMapModel.__default.IndexSet(revealed)
axiom true
   ==> (forall MutableMapModel._default.IndexSet$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V, elements#0) } 
    MutableMapModel.__default.IndexSet#canCall(MutableMapModel._default.IndexSet$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSet$V)))
       ==> MutableMapModel.__default.IndexSetThrough#canCall(MutableMapModel._default.IndexSet$V, elements#0, Seq#Length(elements#0))
         && MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V, elements#0)
           == MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSet$V, elements#0, Seq#Length(elements#0)));

// definition axiom for MutableMapModel.__default.IndexSet for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.IndexSet$V: Ty, elements#0: Seq Box :: 
    {:weight 3} { MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V, Lit(elements#0)) } 
    MutableMapModel.__default.IndexSet#canCall(MutableMapModel._default.IndexSet$V, Lit(elements#0))
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.IndexSet$V)))
       ==> MutableMapModel.__default.IndexSetThrough#canCall(MutableMapModel._default.IndexSet$V, 
          Lit(elements#0), 
          Seq#Length(Lit(elements#0)))
         && MutableMapModel.__default.IndexSet(MutableMapModel._default.IndexSet$V, Lit(elements#0))
           == MutableMapModel.__default.IndexSetThrough(MutableMapModel._default.IndexSet$V, 
            Lit(elements#0), 
            Seq#Length(Lit(elements#0))));

// function declaration for MutableMapModel._default.Count1
function MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V: Ty, item#0: DatatypeType) : int;

function MutableMapModel.__default.Count1#canCall(MutableMapModel._default.Count1$V: Ty, item#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.Count1
axiom true
   ==> (forall MutableMapModel._default.Count1$V: Ty, item#0: DatatypeType :: 
    { MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V, item#0) } 
    MutableMapModel.__default.Count1#canCall(MutableMapModel._default.Count1$V, item#0)
         || $Is(item#0, Tclass.MutableMapModel.Item(MutableMapModel._default.Count1$V))
       ==> LitInt(0)
         <= MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V, item#0));

function MutableMapModel.__default.Count1#requires(Ty, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.Count1
axiom (forall MutableMapModel._default.Count1$V: Ty, item#0: DatatypeType :: 
  { MutableMapModel.__default.Count1#requires(MutableMapModel._default.Count1$V, item#0) } 
  $Is(item#0, Tclass.MutableMapModel.Item(MutableMapModel._default.Count1$V))
     ==> MutableMapModel.__default.Count1#requires(MutableMapModel._default.Count1$V, item#0)
       == true);

// definition axiom for MutableMapModel.__default.Count1(revealed)
axiom true
   ==> (forall MutableMapModel._default.Count1$V: Ty, item#0: DatatypeType :: 
    { MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V, item#0) } 
    MutableMapModel.__default.Count1#canCall(MutableMapModel._default.Count1$V, item#0)
         || $Is(item#0, Tclass.MutableMapModel.Item(MutableMapModel._default.Count1$V))
       ==> MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V, item#0)
         == (if MutableMapModel.Item.Entry_q(item#0) || MutableMapModel.Item.Tombstone_q(item#0)
           then 1
           else 0));

// definition axiom for MutableMapModel.__default.Count1 for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Count1$V: Ty, item#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V, Lit(item#0)) } 
    MutableMapModel.__default.Count1#canCall(MutableMapModel._default.Count1$V, Lit(item#0))
         || $Is(item#0, Tclass.MutableMapModel.Item(MutableMapModel._default.Count1$V))
       ==> MutableMapModel.__default.Count1(MutableMapModel._default.Count1$V, Lit(item#0))
         == (if MutableMapModel.Item.Entry_q(Lit(item#0))
             || MutableMapModel.Item.Tombstone_q(Lit(item#0))
           then 1
           else 0));

// function declaration for MutableMapModel._default.CountFilled
function MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box)
   : int;

function MutableMapModel.__default.CountFilled#canCall(MutableMapModel._default.CountFilled$V: Ty, view#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box :: 
  { MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LS($ly), view#0) } 
  MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LS($ly), view#0)
     == MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $ly, view#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box :: 
  { MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, AsFuelBottom($ly), view#0) } 
  MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $ly, view#0)
     == MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LZ, view#0));

// consequence axiom for MutableMapModel.__default.CountFilled
axiom true
   ==> (forall MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box :: 
    { MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $ly, view#0) } 
    MutableMapModel.__default.CountFilled#canCall(MutableMapModel._default.CountFilled$V, view#0)
         || $Is(view#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CountFilled$V)))
       ==> LitInt(0)
         <= MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $ly, view#0));

function MutableMapModel.__default.CountFilled#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for MutableMapModel.__default.CountFilled
axiom (forall MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box :: 
  { MutableMapModel.__default.CountFilled#requires(MutableMapModel._default.CountFilled$V, $ly, view#0) } 
  $Is(view#0, 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CountFilled$V)))
     ==> MutableMapModel.__default.CountFilled#requires(MutableMapModel._default.CountFilled$V, $ly, view#0)
       == true);

// definition axiom for MutableMapModel.__default.CountFilled(revealed)
axiom true
   ==> (forall MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box :: 
    { MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LS($ly), view#0) } 
    MutableMapModel.__default.CountFilled#canCall(MutableMapModel._default.CountFilled$V, view#0)
         || $Is(view#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CountFilled$V)))
       ==> (Seq#Length(view#0) != LitInt(0)
           ==> MutableMapModel.__default.CountFilled#canCall(MutableMapModel._default.CountFilled$V, Seq#Drop(view#0, LitInt(1)))
             && MutableMapModel.__default.Count1#canCall(MutableMapModel._default.CountFilled$V, 
              $Unbox(Seq#Index(view#0, LitInt(0))): DatatypeType))
         && MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LS($ly), view#0)
           == (if Seq#Length(view#0) == LitInt(0)
             then 0
             else MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $ly, Seq#Drop(view#0, LitInt(1)))
               + MutableMapModel.__default.Count1(MutableMapModel._default.CountFilled$V, 
                $Unbox(Seq#Index(view#0, LitInt(0))): DatatypeType)));

// definition axiom for MutableMapModel.__default.CountFilled for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.CountFilled$V: Ty, $ly: LayerType, view#0: Seq Box :: 
    {:weight 3} { MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LS($ly), Lit(view#0)) } 
    MutableMapModel.__default.CountFilled#canCall(MutableMapModel._default.CountFilled$V, Lit(view#0))
         || $Is(view#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CountFilled$V)))
       ==> (Seq#Length(Lit(view#0)) != LitInt(0)
           ==> MutableMapModel.__default.CountFilled#canCall(MutableMapModel._default.CountFilled$V, Lit(Seq#Drop(Lit(view#0), LitInt(1))))
             && MutableMapModel.__default.Count1#canCall(MutableMapModel._default.CountFilled$V, 
              $Unbox(Seq#Index(Lit(view#0), LitInt(0))): DatatypeType))
         && MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, $LS($ly), Lit(view#0))
           == (if Seq#Length(Lit(view#0)) == LitInt(0)
             then 0
             else MutableMapModel.__default.CountFilled(MutableMapModel._default.CountFilled$V, 
                $LS($ly), 
                Lit(Seq#Drop(Lit(view#0), LitInt(1))))
               + MutableMapModel.__default.Count1(MutableMapModel._default.CountFilled$V, 
                $Unbox(Seq#Index(Lit(view#0), LitInt(0))): DatatypeType)));

// function declaration for MutableMapModel._default.ConstructorFromSize
function MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V: Ty, size#0: int) : DatatypeType;

function MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.ConstructorFromSize$V: Ty, size#0: int) : bool;

// consequence axiom for MutableMapModel.__default.ConstructorFromSize
axiom true
   ==> (forall MutableMapModel._default.ConstructorFromSize$V: Ty, size#0: int :: 
    { MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0) } 
    MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.ConstructorFromSize$V, size#0)
         || (LitInt(0) <= size#0 && size#0 < 18446744073709551616 && LitInt(128) <= size#0)
       ==> MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ConstructorFromSize$V, 
          MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0))
         && (forall slot#0: DatatypeType :: 
          { MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.ConstructorFromSize$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0)), 
              slot#0) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0))), 
              slot#0) } 
          $Is(slot#0, Tclass.MutableMapModel.Slot())
             ==> 
            MutableMapModel.__default.ValidSlot(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0))), 
              slot#0)
             ==> MutableMapModel.__default.SlotIsEmpty(MutableMapModel._default.ConstructorFromSize$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0)), 
              slot#0))
         && Map#Equal(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0)), 
          Map#Empty(): Map Box Box)
         && size#0
           == Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0)))
         && $Is(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0), 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ConstructorFromSize$V)));

function MutableMapModel.__default.ConstructorFromSize#requires(Ty, int) : bool;

// #requires axiom for MutableMapModel.__default.ConstructorFromSize
axiom (forall MutableMapModel._default.ConstructorFromSize$V: Ty, size#0: int :: 
  { MutableMapModel.__default.ConstructorFromSize#requires(MutableMapModel._default.ConstructorFromSize$V, size#0) } 
  LitInt(0) <= size#0 && size#0 < 18446744073709551616
     ==> MutableMapModel.__default.ConstructorFromSize#requires(MutableMapModel._default.ConstructorFromSize$V, size#0)
       == (LitInt(128) <= size#0));

// definition axiom for MutableMapModel.__default.ConstructorFromSize(revealed)
axiom true
   ==> (forall MutableMapModel._default.ConstructorFromSize$V: Ty, size#0: int :: 
    { MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0) } 
    MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.ConstructorFromSize$V, size#0)
         || (LitInt(0) <= size#0 && size#0 < 18446744073709551616 && LitInt(128) <= size#0)
       ==> Sequences.__default.SeqOfLength#canCall(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromSize$V), 
          size#0, 
          $Box(Lit(#MutableMapModel.Item.Empty())))
         && MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, size#0)
           == #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Sequences.__default.SeqOfLength(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromSize$V), 
              StartFuel_Sequences._default.SeqOfLength, 
              size#0, 
              $Box(Lit(#MutableMapModel.Item.Empty()))), 
            LitInt(0), 
            Lit(Map#Empty(): Map Box Box)));

// definition axiom for MutableMapModel.__default.ConstructorFromSize for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ConstructorFromSize$V: Ty, size#0: int :: 
    {:weight 3} { MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, LitInt(size#0)) } 
    MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.ConstructorFromSize$V, LitInt(size#0))
         || (
          LitInt(0) <= size#0
           && size#0 < 18446744073709551616
           && LitInt(128) <= LitInt(size#0))
       ==> Sequences.__default.SeqOfLength#canCall(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromSize$V), 
          LitInt(size#0), 
          $Box(Lit(#MutableMapModel.Item.Empty())))
         && MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ConstructorFromSize$V, LitInt(size#0))
           == #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Sequences.__default.SeqOfLength(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromSize$V), 
              StartFuel_Sequences._default.SeqOfLength, 
              LitInt(size#0), 
              $Box(Lit(#MutableMapModel.Item.Empty()))), 
            LitInt(0), 
            Lit(Map#Empty(): Map Box Box)));

// function declaration for MutableMapModel._default.ConstructorFromStorage
function MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V: Ty, 
    storage#0: Seq Box, 
    count#0: int)
   : DatatypeType;

function MutableMapModel.__default.ConstructorFromStorage#canCall(MutableMapModel._default.ConstructorFromStorage$V: Ty, 
    storage#0: Seq Box, 
    count#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.ConstructorFromStorage
axiom true
   ==> (forall MutableMapModel._default.ConstructorFromStorage$V: Ty, 
      storage#0: Seq Box, 
      count#0: int :: 
    { MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0) } 
    MutableMapModel.__default.ConstructorFromStorage#canCall(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)
         || (
          $Is(storage#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromStorage$V)))
           && 
          LitInt(0) <= count#0
           && count#0 < 18446744073709551616
           && LitInt(128) <= Seq#Length(storage#0))
       ==> Seq#Equal(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)), 
          storage#0)
         && (forall slot#0: DatatypeType :: 
          { MutableMapModel.Slot.slot(slot#0) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0))), 
              slot#0) } 
          $Is(slot#0, Tclass.MutableMapModel.Slot())
             ==> 
            MutableMapModel.__default.ValidSlot(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0))), 
              slot#0)
             ==> MutableMapModel.Item#Equal($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)), 
                  MutableMapModel.Slot.slot(slot#0))): DatatypeType, 
              $Unbox(Seq#Index(storage#0, MutableMapModel.Slot.slot(slot#0))): DatatypeType))
         && MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0))
           == count#0
         && Map#Equal(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)), 
          Map#Empty(): Map Box Box)
         && $Is(MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0), 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ConstructorFromStorage$V)));

function MutableMapModel.__default.ConstructorFromStorage#requires(Ty, Seq Box, int) : bool;

// #requires axiom for MutableMapModel.__default.ConstructorFromStorage
axiom (forall MutableMapModel._default.ConstructorFromStorage$V: Ty, 
    storage#0: Seq Box, 
    count#0: int :: 
  { MutableMapModel.__default.ConstructorFromStorage#requires(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0) } 
  $Is(storage#0, 
        TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromStorage$V)))
       && 
      LitInt(0) <= count#0
       && count#0 < 18446744073709551616
     ==> MutableMapModel.__default.ConstructorFromStorage#requires(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)
       == (LitInt(128) <= Seq#Length(storage#0)));

// definition axiom for MutableMapModel.__default.ConstructorFromStorage(revealed)
axiom true
   ==> (forall MutableMapModel._default.ConstructorFromStorage$V: Ty, 
      storage#0: Seq Box, 
      count#0: int :: 
    { MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0) } 
    MutableMapModel.__default.ConstructorFromStorage#canCall(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)
         || (
          $Is(storage#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromStorage$V)))
           && 
          LitInt(0) <= count#0
           && count#0 < 18446744073709551616
           && LitInt(128) <= Seq#Length(storage#0))
       ==> MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, storage#0, count#0)
         == #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#0, count#0, Lit(Map#Empty(): Map Box Box)));

// definition axiom for MutableMapModel.__default.ConstructorFromStorage for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ConstructorFromStorage$V: Ty, 
      storage#0: Seq Box, 
      count#0: int :: 
    {:weight 3} { MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, 
        Lit(storage#0), 
        LitInt(count#0)) } 
    MutableMapModel.__default.ConstructorFromStorage#canCall(MutableMapModel._default.ConstructorFromStorage$V, 
          Lit(storage#0), 
          LitInt(count#0))
         || (
          $Is(storage#0, 
            TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.ConstructorFromStorage$V)))
           && 
          LitInt(0) <= count#0
           && count#0 < 18446744073709551616
           && LitInt(128) <= Seq#Length(Lit(storage#0)))
       ==> MutableMapModel.__default.ConstructorFromStorage(MutableMapModel._default.ConstructorFromStorage$V, 
          Lit(storage#0), 
          LitInt(count#0))
         == Lit(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Lit(storage#0), LitInt(count#0), Lit(Map#Empty(): Map Box Box))));

// function declaration for MutableMapModel._default.View
function MutableMapModel.__default.View(MutableMapModel._default.View$V: Ty, elements#0: Seq Box, start#0: int)
   : Seq Box;

function MutableMapModel.__default.View#canCall(MutableMapModel._default.View$V: Ty, elements#0: Seq Box, start#0: int) : bool;

// consequence axiom for MutableMapModel.__default.View
axiom true
   ==> (forall MutableMapModel._default.View$V: Ty, elements#0: Seq Box, start#0: int :: 
    { MutableMapModel.__default.View(MutableMapModel._default.View$V, elements#0, start#0) } 
    MutableMapModel.__default.View#canCall(MutableMapModel._default.View$V, elements#0, start#0)
         || (
          $Is(elements#0, TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.View$V)))
           && LitInt(0) <= start#0
           && start#0 < Seq#Length(elements#0))
       ==> Seq#Length(MutableMapModel.__default.View(MutableMapModel._default.View$V, elements#0, start#0))
           == Seq#Length(elements#0)
         && $Is(MutableMapModel.__default.View(MutableMapModel._default.View$V, elements#0, start#0), 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.View$V))));

function MutableMapModel.__default.View#requires(Ty, Seq Box, int) : bool;

// #requires axiom for MutableMapModel.__default.View
axiom (forall MutableMapModel._default.View$V: Ty, elements#0: Seq Box, start#0: int :: 
  { MutableMapModel.__default.View#requires(MutableMapModel._default.View$V, elements#0, start#0) } 
  $Is(elements#0, TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.View$V)))
       && LitInt(0) <= start#0
     ==> MutableMapModel.__default.View#requires(MutableMapModel._default.View$V, elements#0, start#0)
       == (start#0 < Seq#Length(elements#0)));

// definition axiom for MutableMapModel.__default.View(revealed)
axiom true
   ==> (forall MutableMapModel._default.View$V: Ty, elements#0: Seq Box, start#0: int :: 
    { MutableMapModel.__default.View(MutableMapModel._default.View$V, elements#0, start#0) } 
    MutableMapModel.__default.View#canCall(MutableMapModel._default.View$V, elements#0, start#0)
         || (
          $Is(elements#0, TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.View$V)))
           && LitInt(0) <= start#0
           && start#0 < Seq#Length(elements#0))
       ==> MutableMapModel.__default.View(MutableMapModel._default.View$V, elements#0, start#0)
         == Seq#Append(Seq#Drop(elements#0, start#0), Seq#Take(elements#0, start#0)));

// definition axiom for MutableMapModel.__default.View for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.View$V: Ty, elements#0: Seq Box, start#0: int :: 
    {:weight 3} { MutableMapModel.__default.View(MutableMapModel._default.View$V, Lit(elements#0), LitInt(start#0)) } 
    MutableMapModel.__default.View#canCall(MutableMapModel._default.View$V, Lit(elements#0), LitInt(start#0))
         || (
          $Is(elements#0, TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.View$V)))
           && LitInt(0) <= start#0
           && start#0 < Seq#Length(Lit(elements#0)))
       ==> MutableMapModel.__default.View(MutableMapModel._default.View$V, Lit(elements#0), LitInt(start#0))
         == Seq#Append(Seq#Drop(Lit(elements#0), LitInt(start#0)), 
          Seq#Take(Lit(elements#0), LitInt(start#0))));

// function declaration for MutableMapModel._default.Uint64SlotSuccessor
function MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0: int, slot#0: int) : int;

function MutableMapModel.__default.Uint64SlotSuccessor#canCall(elementsLength#0: int, slot#0: int) : bool;

// consequence axiom for MutableMapModel.__default.Uint64SlotSuccessor
axiom true
   ==> (forall elementsLength#0: int, slot#0: int :: 
    { MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0) } 
    MutableMapModel.__default.Uint64SlotSuccessor#canCall(elementsLength#0, slot#0)
         || (
          LitInt(0) <= elementsLength#0
           && 
          LitInt(0) <= slot#0
           && slot#0 < 18446744073709551616
           && 
          elementsLength#0 < 18446744073709551616
           && MutableMapModel.__default.ValidSlot(elementsLength#0, #MutableMapModel.Slot.Slot(slot#0)))
       ==> MutableMapModel.__default.ValidSlot(elementsLength#0, 
          #MutableMapModel.Slot.Slot(MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0)))
         && MutableMapModel.Slot#Equal(#MutableMapModel.Slot.Slot(MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0)), 
          MutableMapModel.__default.SlotSuccessor(elementsLength#0, #MutableMapModel.Slot.Slot(slot#0)))
         && 
        LitInt(0)
           <= MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0)
         && MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0)
           < 18446744073709551616);

function MutableMapModel.__default.Uint64SlotSuccessor#requires(int, int) : bool;

// #requires axiom for MutableMapModel.__default.Uint64SlotSuccessor
axiom (forall elementsLength#0: int, slot#0: int :: 
  { MutableMapModel.__default.Uint64SlotSuccessor#requires(elementsLength#0, slot#0) } 
  LitInt(0) <= elementsLength#0
       && 
      LitInt(0) <= slot#0
       && slot#0 < 18446744073709551616
     ==> MutableMapModel.__default.Uint64SlotSuccessor#requires(elementsLength#0, slot#0)
       == (elementsLength#0 < 18446744073709551616
         && MutableMapModel.__default.ValidSlot(elementsLength#0, #MutableMapModel.Slot.Slot(slot#0))));

// definition axiom for MutableMapModel.__default.Uint64SlotSuccessor(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot#0: int :: 
    { MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0) } 
    MutableMapModel.__default.Uint64SlotSuccessor#canCall(elementsLength#0, slot#0)
         || (
          LitInt(0) <= elementsLength#0
           && 
          LitInt(0) <= slot#0
           && slot#0 < 18446744073709551616
           && 
          elementsLength#0 < 18446744073709551616
           && MutableMapModel.__default.ValidSlot(elementsLength#0, #MutableMapModel.Slot.Slot(slot#0)))
       ==> MutableMapModel.__default.Uint64SlotSuccessor(elementsLength#0, slot#0)
         == (if slot#0 == elementsLength#0 - 1 then 0 else slot#0 + 1));

// definition axiom for MutableMapModel.__default.Uint64SlotSuccessor for all literals(revealed)
axiom true
   ==> (forall elementsLength#0: int, slot#0: int :: 
    {:weight 3} { MutableMapModel.__default.Uint64SlotSuccessor(LitInt(elementsLength#0), LitInt(slot#0)) } 
    MutableMapModel.__default.Uint64SlotSuccessor#canCall(LitInt(elementsLength#0), LitInt(slot#0))
         || (
          LitInt(0) <= elementsLength#0
           && 
          LitInt(0) <= slot#0
           && slot#0 < 18446744073709551616
           && 
          Lit(elementsLength#0 < 18446744073709551616)
           && Lit(MutableMapModel.__default.ValidSlot(LitInt(elementsLength#0), Lit(#MutableMapModel.Slot.Slot(LitInt(slot#0))))))
       ==> MutableMapModel.__default.Uint64SlotSuccessor(LitInt(elementsLength#0), LitInt(slot#0))
         == (if LitInt(slot#0) == LitInt(elementsLength#0 - 1) then 0 else slot#0 + 1));

// function declaration for MutableMapModel._default.getEmptyWitness
function MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int)
   : int;

function MutableMapModel.__default.getEmptyWitness#canCall(MutableMapModel._default.getEmptyWitness$V: Ty, self#0: DatatypeType, i#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.getEmptyWitness$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LS($ly), self#0, i#0) } 
  MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LS($ly), self#0, i#0)
     == MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.getEmptyWitness$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, AsFuelBottom($ly), self#0, i#0) } 
  MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0)
     == MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LZ, self#0, i#0));

// consequence axiom for MutableMapModel.__default.getEmptyWitness
axiom true
   ==> (forall MutableMapModel._default.getEmptyWitness$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0) } 
    MutableMapModel.__default.getEmptyWitness#canCall(MutableMapModel._default.getEmptyWitness$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.getEmptyWitness$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.getEmptyWitness$V, self#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           && (forall j#0: int :: 
            { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#0)): DatatypeType } 
            LitInt(0) <= j#0 && j#0 < 18446744073709551616 && LitInt(0) <= j#0 && j#0 < i#0
               ==> !MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#0)): DatatypeType))
           && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))
       ==> LitInt(0)
           <= MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0)
         && MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
         && MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
              MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0))): DatatypeType)
         && 
        LitInt(0)
           <= MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0)
         && MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0)
           < 18446744073709551616);

function MutableMapModel.__default.getEmptyWitness#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.getEmptyWitness
axiom (forall MutableMapModel._default.getEmptyWitness$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.getEmptyWitness#requires(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.getEmptyWitness$V))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> MutableMapModel.__default.getEmptyWitness#requires(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0)
       == (
        MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.getEmptyWitness$V, self#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
         && (forall j#1: int :: 
          { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#1)): DatatypeType } 
          LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
             ==> !MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#1)): DatatypeType))
         && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))));

// definition axiom for MutableMapModel.__default.getEmptyWitness(revealed)
axiom true
   ==> (forall MutableMapModel._default.getEmptyWitness$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LS($ly), self#0, i#0) } 
    MutableMapModel.__default.getEmptyWitness#canCall(MutableMapModel._default.getEmptyWitness$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.getEmptyWitness$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.getEmptyWitness$V, self#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           && (forall j#1: int :: 
            { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#1)): DatatypeType } 
            LitInt(0) <= j#1 && j#1 < 18446744073709551616 && LitInt(0) <= j#1 && j#1 < i#0
               ==> !MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#1)): DatatypeType))
           && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), i#0)): DatatypeType)
           ==> MutableMapModel.__default.getEmptyWitness#canCall(MutableMapModel._default.getEmptyWitness$V, self#0, i#0 + 1))
         && MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LS($ly), self#0, i#0)
           == (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), i#0)): DatatypeType)
             then i#0
             else MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $ly, self#0, i#0 + 1)));

// definition axiom for MutableMapModel.__default.getEmptyWitness for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.getEmptyWitness$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    {:weight 3} { MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LS($ly), Lit(self#0), LitInt(i#0)) } 
    MutableMapModel.__default.getEmptyWitness#canCall(MutableMapModel._default.getEmptyWitness$V, Lit(self#0), LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.getEmptyWitness$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.getEmptyWitness$V, Lit(self#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
           && (forall j#2: int :: 
            { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), j#2)): DatatypeType } 
            LitInt(0) <= j#2 && j#2 < 18446744073709551616 && LitInt(0) <= j#2 && j#2 < i#0
               ==> !MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), j#2)): DatatypeType))
           && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), LitInt(i#0))): DatatypeType)
           ==> MutableMapModel.__default.getEmptyWitness#canCall(MutableMapModel._default.getEmptyWitness$V, Lit(self#0), LitInt(i#0 + 1)))
         && MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, $LS($ly), Lit(self#0), LitInt(i#0))
           == (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), LitInt(i#0))): DatatypeType)
             then i#0
             else MutableMapModel.__default.getEmptyWitness(MutableMapModel._default.getEmptyWitness$V, 
              $LS($ly), 
              Lit(self#0), 
              LitInt(i#0 + 1))));

// function declaration for MutableMapModel._default.ProbeIterate
function MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    slotIdx#0: int)
   : int;

function MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V: Ty, 
    self#0: DatatypeType, 
    key#0: int, 
    slotIdx#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.ProbeIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    slotIdx#0: int :: 
  { MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $LS($ly), self#0, key#0, slotIdx#0) } 
  MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $LS($ly), self#0, key#0, slotIdx#0)
     == MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.ProbeIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    slotIdx#0: int :: 
  { MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
      AsFuelBottom($ly), 
      self#0, 
      key#0, 
      slotIdx#0) } 
  MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0)
     == MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $LZ, self#0, key#0, slotIdx#0));

// consequence axiom for MutableMapModel.__default.ProbeIterate
axiom true
   ==> (forall MutableMapModel._default.ProbeIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      slotIdx#0: int :: 
    { MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0) } 
    MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, self#0, key#0, slotIdx#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ProbeIterate$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ProbeIterate$V, self#0)
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))
       ==> LitInt(0)
           <= MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0)
         && MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
         && 
        LitInt(0)
           <= MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0)
         && MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0)
           < 18446744073709551616);

function MutableMapModel.__default.ProbeIterate#requires(Ty, LayerType, DatatypeType, int, int) : bool;

// #requires axiom for MutableMapModel.__default.ProbeIterate
axiom (forall MutableMapModel._default.ProbeIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    slotIdx#0: int :: 
  { MutableMapModel.__default.ProbeIterate#requires(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ProbeIterate$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
       && 
      LitInt(0) <= slotIdx#0
       && slotIdx#0 < 18446744073709551616
     ==> MutableMapModel.__default.ProbeIterate#requires(MutableMapModel._default.ProbeIterate$V, $ly, self#0, key#0, slotIdx#0)
       == (MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ProbeIterate$V, self#0)
         && 
        LitInt(0) <= slotIdx#0
         && slotIdx#0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))));

// definition axiom for MutableMapModel.__default.ProbeIterate(revealed)
axiom true
   ==> (forall MutableMapModel._default.ProbeIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      slotIdx#0: int :: 
    { MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $LS($ly), self#0, key#0, slotIdx#0) } 
    MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, self#0, key#0, slotIdx#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ProbeIterate$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ProbeIterate$V, self#0)
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
         && (!(MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
             || MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               == key#0)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && MutableMapModel.__default.Uint64SlotSuccessor#canCall(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)), slotIdx#0)
             && MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, 
              self#0, 
              key#0, 
              MutableMapModel.__default.Uint64SlotSuccessor(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)), slotIdx#0)))
         && MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, $LS($ly), self#0, key#0, slotIdx#0)
           == (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               || MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
                 == key#0
             then slotIdx#0
             else MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
              $ly, 
              self#0, 
              key#0, 
              MutableMapModel.__default.Uint64SlotSuccessor(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)), slotIdx#0))));

// definition axiom for MutableMapModel.__default.ProbeIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ProbeIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      slotIdx#0: int :: 
    {:weight 3} { MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
        $LS($ly), 
        Lit(self#0), 
        key#0, 
        LitInt(slotIdx#0)) } 
    MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, Lit(self#0), key#0, LitInt(slotIdx#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ProbeIterate$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ProbeIterate$V, Lit(self#0)))
           && 
          LitInt(0) <= LitInt(slotIdx#0)
           && slotIdx#0
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                LitInt(slotIdx#0))): DatatypeType)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
         && (!(MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                  LitInt(slotIdx#0))): DatatypeType)
             || MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                    LitInt(slotIdx#0))): DatatypeType)
               == key#0)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.Uint64SlotSuccessor#canCall(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))), 
              LitInt(slotIdx#0))
             && MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, 
              Lit(self#0), 
              key#0, 
              MutableMapModel.__default.Uint64SlotSuccessor(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))), 
                LitInt(slotIdx#0))))
         && MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
            $LS($ly), 
            Lit(self#0), 
            key#0, 
            LitInt(slotIdx#0))
           == (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                    LitInt(slotIdx#0))): DatatypeType)
               || MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                      LitInt(slotIdx#0))): DatatypeType)
                 == key#0
             then slotIdx#0
             else MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
              $LS($ly), 
              Lit(self#0), 
              key#0, 
              MutableMapModel.__default.Uint64SlotSuccessor(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))), 
                LitInt(slotIdx#0)))));

// definition axiom for MutableMapModel.__default.ProbeIterate for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ProbeIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      slotIdx#0: int :: 
    {:weight 3} { MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
        $LS($ly), 
        Lit(self#0), 
        LitInt(key#0), 
        LitInt(slotIdx#0)) } 
    MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, 
          Lit(self#0), 
          LitInt(key#0), 
          LitInt(slotIdx#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ProbeIterate$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ProbeIterate$V, Lit(self#0)))
           && 
          LitInt(0) <= LitInt(slotIdx#0)
           && slotIdx#0
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                LitInt(slotIdx#0))): DatatypeType)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
         && (!(MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                  LitInt(slotIdx#0))): DatatypeType)
             || MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                    LitInt(slotIdx#0))): DatatypeType)
               == LitInt(key#0))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.Uint64SlotSuccessor#canCall(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))), 
              LitInt(slotIdx#0))
             && MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.ProbeIterate$V, 
              Lit(self#0), 
              LitInt(key#0), 
              MutableMapModel.__default.Uint64SlotSuccessor(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))), 
                LitInt(slotIdx#0))))
         && MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
            $LS($ly), 
            Lit(self#0), 
            LitInt(key#0), 
            LitInt(slotIdx#0))
           == (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                    LitInt(slotIdx#0))): DatatypeType)
               || MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                      LitInt(slotIdx#0))): DatatypeType)
                 == LitInt(key#0)
             then slotIdx#0
             else MutableMapModel.__default.ProbeIterate(MutableMapModel._default.ProbeIterate$V, 
              $LS($ly), 
              Lit(self#0), 
              LitInt(key#0), 
              MutableMapModel.__default.Uint64SlotSuccessor(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))), 
                LitInt(slotIdx#0)))));

// function declaration for MutableMapModel._default.Probe
function MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int)
   : int;

function MutableMapModel.__default.Probe#canCall(MutableMapModel._default.Probe$V: Ty, self#0: DatatypeType, key#0: int) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.Probe$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LS($ly), self#0, key#0) } 
  MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LS($ly), self#0, key#0)
     == MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.Probe$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, AsFuelBottom($ly), self#0, key#0) } 
  MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0)
     == MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LZ, self#0, key#0));

// consequence axiom for MutableMapModel.__default.Probe
axiom true
   ==> (forall MutableMapModel._default.Probe$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0) } 
    MutableMapModel.__default.Probe#canCall(MutableMapModel._default.Probe$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Probe$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.Probe$V, self#0)
           && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))
       ==> LitInt(0)
           <= MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0)
         && MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
         && 
        LitInt(0)
           <= MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0)
         && MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $ly, self#0, key#0)
           < 18446744073709551616);

function MutableMapModel.__default.Probe#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.Probe
axiom (forall MutableMapModel._default.Probe$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.Probe#requires(MutableMapModel._default.Probe$V, $ly, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Probe$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.Probe#requires(MutableMapModel._default.Probe$V, $ly, self#0, key#0)
       == (MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.Probe$V, self#0)
         && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))));

// definition axiom for MutableMapModel.__default.Probe(revealed)
axiom true
   ==> (forall MutableMapModel._default.Probe$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LS($ly), self#0, key#0) } 
    MutableMapModel.__default.Probe#canCall(MutableMapModel._default.Probe$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Probe$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.Probe$V, self#0)
           && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)))
       ==> MutableMapModel.__default.Uint64SlotForKey#canCall(MutableMapModel._default.Probe$V, self#0, key#0)
         && MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.Probe$V, 
          self#0, 
          key#0, 
          MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Probe$V, self#0, key#0))
         && MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LS($ly), self#0, key#0)
           == MutableMapModel.__default.ProbeIterate(MutableMapModel._default.Probe$V, 
            $LS($LZ), 
            self#0, 
            key#0, 
            MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Probe$V, self#0, key#0)));

// definition axiom for MutableMapModel.__default.Probe for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Probe$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LS($ly), Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.Probe#canCall(MutableMapModel._default.Probe$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.Probe$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.Probe$V, Lit(self#0)))
           && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))))
       ==> MutableMapModel.__default.Uint64SlotForKey#canCall(MutableMapModel._default.Probe$V, Lit(self#0), LitInt(key#0))
         && MutableMapModel.__default.ProbeIterate#canCall(MutableMapModel._default.Probe$V, 
          Lit(self#0), 
          LitInt(key#0), 
          LitInt(MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Probe$V, Lit(self#0), LitInt(key#0))))
         && MutableMapModel.__default.Probe(MutableMapModel._default.Probe$V, $LS($ly), Lit(self#0), LitInt(key#0))
           == LitInt(MutableMapModel.__default.ProbeIterate(MutableMapModel._default.Probe$V, 
              $LS($LZ), 
              Lit(self#0), 
              LitInt(key#0), 
              LitInt(MutableMapModel.__default.Uint64SlotForKey(MutableMapModel._default.Probe$V, Lit(self#0), LitInt(key#0))))));

// function declaration for MutableMapModel._default.FixedSizeInsert
function MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box)
   : DatatypeType;

function MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.FixedSizeInsert$V: Ty, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $LS($ly), self#0, key#0, value#0) } 
  MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $LS($ly), self#0, key#0, value#0)
     == MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $ly, self#0, key#0, value#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, 
      AsFuelBottom($ly), 
      self#0, 
      key#0, 
      value#0) } 
  MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $ly, self#0, key#0, value#0)
     == MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $LZ, self#0, key#0, value#0));

// consequence axiom for MutableMapModel.__default.FixedSizeInsert
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $ly, self#0, key#0, value#0) } 
    MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.FixedSizeInsert$V, self#0, key#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInsert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeInsert$V)
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInsert$V, self#0)
           && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)) - 1)
       ==> $Is(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $ly, self#0, key#0, value#0), 
        Tclass._System.Tuple2(Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInsert$V), 
          Tclass.Options.Option(MutableMapModel._default.FixedSizeInsert$V))));

function MutableMapModel.__default.FixedSizeInsert#requires(Ty, LayerType, DatatypeType, int, Box) : bool;

// #requires axiom for MutableMapModel.__default.FixedSizeInsert
axiom (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.FixedSizeInsert#requires(MutableMapModel._default.FixedSizeInsert$V, $ly, self#0, key#0, value#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInsert$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
       && $IsBox(value#0, MutableMapModel._default.FixedSizeInsert$V)
     ==> MutableMapModel.__default.FixedSizeInsert#requires(MutableMapModel._default.FixedSizeInsert$V, $ly, self#0, key#0, value#0)
       == (MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInsert$V, self#0)
         && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)) - 1));

// definition axiom for MutableMapModel.__default.FixedSizeInsert(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $LS($ly), self#0, key#0, value#0) } 
    MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.FixedSizeInsert$V, self#0, key#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInsert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeInsert$V)
           && 
          MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInsert$V, self#0)
           && MutableMapModel.FixedSizeLinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0)) - 1)
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeInsert$V, self#0, key#0)
         && (var slotIdx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeInsert$V, 
              StartFuel_MutableMapModel._default.Probe, 
              self#0, 
              key#0); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && 
            MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && 
            MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && (MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
             && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
                 && (MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))
                 && (!MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
                     && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0))))
         && MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, $LS($ly), self#0, key#0, value#0)
           == (var slotIdx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeInsert$V, 
                StartFuel_MutableMapModel._default.Probe, 
                self#0, 
                key#0); 
            (var storage#0 := Seq#Update(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
                  slotIdx#0, 
                  $Box(#MutableMapModel.Item.Entry(key#0, value#0))); 
              (var contents#0 := Map#Build(MutableMapModel.FixedSizeLinearHashMap.contents(self#0), 
                    $Box(key#0), 
                    $Box(#Options.Option.Some(value#0))); 
                (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
                   then #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#0, MutableMapModel.FixedSizeLinearHashMap.count(self#0) + 1, contents#0)), 
                    $Box(Lit(#Options.Option.None())))
                   else (if MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
                     then #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#0, MutableMapModel.FixedSizeLinearHashMap.count(self#0), contents#0)), 
                      $Box(Lit(#Options.Option.None())))
                     else (var replaced#0 := #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)); 
                      #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#0, MutableMapModel.FixedSizeLinearHashMap.count(self#0), contents#0)), 
                        $Box(replaced#0)))))))));

// definition axiom for MutableMapModel.__default.FixedSizeInsert for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, 
        $LS($ly), 
        Lit(self#0), 
        LitInt(key#0), 
        value#0) } 
    MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.FixedSizeInsert$V, Lit(self#0), LitInt(key#0), value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInsert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeInsert$V)
           && 
          Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInsert$V, Lit(self#0)))
           && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))) - 1)
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeInsert$V, Lit(self#0), LitInt(key#0))
         && (var slotIdx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeInsert$V, 
              StartFuel_MutableMapModel._default.Probe, 
              Lit(self#0), 
              LitInt(key#0)); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && 
            MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && 
            MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && (MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
             && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                 && (MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
                 && (!MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                     && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))))
         && MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, 
            $LS($ly), 
            Lit(self#0), 
            LitInt(key#0), 
            value#0)
           == (var slotIdx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeInsert$V, 
                StartFuel_MutableMapModel._default.Probe, 
                Lit(self#0), 
                LitInt(key#0)); 
            (var storage#1 := Seq#Update(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                  slotIdx#1, 
                  $Box(#MutableMapModel.Item.Entry(LitInt(key#0), value#0))); 
              (var contents#1 := Map#Build(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))), 
                    $Box(LitInt(key#0)), 
                    $Box(#Options.Option.Some(value#0))); 
                (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
                   then #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#1, 
                        LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0)) + 1), 
                        contents#1)), 
                    $Box(Lit(#Options.Option.None())))
                   else (if MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
                     then #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#1, 
                          LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                          contents#1)), 
                      $Box(Lit(#Options.Option.None())))
                     else (var replaced#1 := #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)); 
                      #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#1, 
                            LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                            contents#1)), 
                        $Box(replaced#1)))))))));

// definition axiom for MutableMapModel.__default.FixedSizeInsert for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeInsert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, 
        $LS($ly), 
        Lit(self#0), 
        LitInt(key#0), 
        Lit(value#0)) } 
    MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.FixedSizeInsert$V, 
          Lit(self#0), 
          LitInt(key#0), 
          Lit(value#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeInsert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeInsert$V)
           && 
          Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeInsert$V, Lit(self#0)))
           && MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0)))) - 1)
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeInsert$V, Lit(self#0), LitInt(key#0))
         && (var slotIdx#2 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeInsert$V, 
              StartFuel_MutableMapModel._default.Probe, 
              Lit(self#0), 
              LitInt(key#0)); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && 
            MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && 
            MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && (MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
             && (!MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                 && (MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))
                 && (!MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                     && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0)))))
         && MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.FixedSizeInsert$V, 
            $LS($ly), 
            Lit(self#0), 
            LitInt(key#0), 
            Lit(value#0))
           == (var slotIdx#2 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeInsert$V, 
                StartFuel_MutableMapModel._default.Probe, 
                Lit(self#0), 
                LitInt(key#0)); 
            (var storage#2 := Seq#Update(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                  slotIdx#2, 
                  $Box(Lit(#MutableMapModel.Item.Entry(LitInt(key#0), Lit(value#0))))); 
              (var contents#2 := Map#Build(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))), 
                    $Box(LitInt(key#0)), 
                    $Box(Lit(#Options.Option.Some(Lit(value#0))))); 
                (if MutableMapModel.Item.Empty_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)
                   then #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#2, 
                        LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0)) + 1), 
                        contents#2)), 
                    $Box(Lit(#Options.Option.None())))
                   else (if MutableMapModel.Item.Tombstone_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)
                     then #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#2, 
                          LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                          contents#2)), 
                      $Box(Lit(#Options.Option.None())))
                     else (var replaced#2 := #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#2)): DatatypeType)); 
                      #_System._tuple#2._#Make2($Box(#MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage#2, 
                            LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                            contents#2)), 
                        $Box(replaced#2)))))))));

// function declaration for MutableMapModel._default.FixedSizeUpdateBySlot
function MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
    self#0: DatatypeType, 
    slotIdx#0: int, 
    value#0: Box)
   : DatatypeType;

function MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
    self#0: DatatypeType, 
    slotIdx#0: int, 
    value#0: Box)
   : bool;

// consequence axiom for MutableMapModel.__default.FixedSizeUpdateBySlot
axiom true
   ==> (forall MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
      self#0: DatatypeType, 
      slotIdx#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0) } 
    MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeUpdateBySlot$V))
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeUpdateBySlot$V)
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType))
       ==> $Is(MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0), 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeUpdateBySlot$V)));

function MutableMapModel.__default.FixedSizeUpdateBySlot#requires(Ty, DatatypeType, int, Box) : bool;

// #requires axiom for MutableMapModel.__default.FixedSizeUpdateBySlot
axiom (forall MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
    self#0: DatatypeType, 
    slotIdx#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.FixedSizeUpdateBySlot#requires(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeUpdateBySlot$V))
       && 
      LitInt(0) <= slotIdx#0
       && slotIdx#0 < 18446744073709551616
       && $IsBox(value#0, MutableMapModel._default.FixedSizeUpdateBySlot$V)
     ==> MutableMapModel.__default.FixedSizeUpdateBySlot#requires(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0)
       == (
        LitInt(0) <= slotIdx#0
         && slotIdx#0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
         && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)));

// definition axiom for MutableMapModel.__default.FixedSizeUpdateBySlot(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
      self#0: DatatypeType, 
      slotIdx#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0) } 
    MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeUpdateBySlot$V))
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeUpdateBySlot$V)
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(self#0))
           && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && 
        MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
         && MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, self#0, slotIdx#0, value#0)
           == (var storage'#0 := Seq#Update(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
                slotIdx#0, 
                $Box((var dt_update_tmp#0#0 := $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType; 
                    (var dt_update#value#0#0 := value#0; 
                      #MutableMapModel.Item.Entry(MutableMapModel.Item.key(dt_update_tmp#0#0), dt_update#value#0#0))))); 
            (var contents'#0 := Map#Build(MutableMapModel.FixedSizeLinearHashMap.contents(self#0), 
                  $Box(MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)), 
                  $Box(#Options.Option.Some(value#0))); 
              #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage'#0, MutableMapModel.FixedSizeLinearHashMap.count(self#0), contents'#0))));

// definition axiom for MutableMapModel.__default.FixedSizeUpdateBySlot for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
      self#0: DatatypeType, 
      slotIdx#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, 
        Lit(self#0), 
        LitInt(slotIdx#0), 
        value#0) } 
    MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.FixedSizeUpdateBySlot$V, 
          Lit(self#0), 
          LitInt(slotIdx#0), 
          value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeUpdateBySlot$V))
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeUpdateBySlot$V)
           && 
          LitInt(0) <= LitInt(slotIdx#0)
           && slotIdx#0
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
           && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                LitInt(slotIdx#0))): DatatypeType))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && 
        MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, 
            Lit(self#0), 
            LitInt(slotIdx#0), 
            value#0)
           == (var storage'#1 := Seq#Update(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                LitInt(slotIdx#0), 
                $Box((var dt_update_tmp#0#1 := $Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                          LitInt(slotIdx#0))): DatatypeType; 
                    (var dt_update#value#0#1 := value#0; 
                      #MutableMapModel.Item.Entry(MutableMapModel.Item.key(dt_update_tmp#0#1), dt_update#value#0#1))))); 
            (var contents'#1 := Map#Build(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))), 
                  $Box(MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                          LitInt(slotIdx#0))): DatatypeType)), 
                  $Box(#Options.Option.Some(value#0))); 
              #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage'#1, 
                LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                contents'#1))));

// definition axiom for MutableMapModel.__default.FixedSizeUpdateBySlot for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeUpdateBySlot$V: Ty, 
      self#0: DatatypeType, 
      slotIdx#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, 
        Lit(self#0), 
        LitInt(slotIdx#0), 
        Lit(value#0)) } 
    MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.FixedSizeUpdateBySlot$V, 
          Lit(self#0), 
          LitInt(slotIdx#0), 
          Lit(value#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeUpdateBySlot$V))
           && 
          LitInt(0) <= slotIdx#0
           && slotIdx#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.FixedSizeUpdateBySlot$V)
           && 
          LitInt(0) <= LitInt(slotIdx#0)
           && slotIdx#0
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))))
           && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                LitInt(slotIdx#0))): DatatypeType))
       ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && 
        MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.FixedSizeUpdateBySlot$V, 
            Lit(self#0), 
            LitInt(slotIdx#0), 
            Lit(value#0))
           == (var storage'#2 := Seq#Update(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                LitInt(slotIdx#0), 
                $Box((var dt_update_tmp#0#2 := $Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                          LitInt(slotIdx#0))): DatatypeType; 
                    (var dt_update#value#0#2 := Lit(value#0); 
                      #MutableMapModel.Item.Entry(MutableMapModel.Item.key(dt_update_tmp#0#2), dt_update#value#0#2))))); 
            (var contents'#2 := Map#Build(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))), 
                  $Box(MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                          LitInt(slotIdx#0))): DatatypeType)), 
                  $Box(Lit(#Options.Option.Some(Lit(value#0))))); 
              #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(storage'#2, 
                LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                contents'#2))));

// function declaration for MutableMapModel._default.FixedSizeGet
function MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int)
   : DatatypeType;

function MutableMapModel.__default.FixedSizeGet#canCall(MutableMapModel._default.FixedSizeGet$V: Ty, self#0: DatatypeType, key#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.FixedSizeGet$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LS($ly), self#0, key#0) } 
  MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LS($ly), self#0, key#0)
     == MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $ly, self#0, key#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.FixedSizeGet$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, AsFuelBottom($ly), self#0, key#0) } 
  MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $ly, self#0, key#0)
     == MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LZ, self#0, key#0));

// consequence axiom for MutableMapModel.__default.FixedSizeGet
axiom true
   ==> (forall MutableMapModel._default.FixedSizeGet$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $ly, self#0, key#0) } 
    MutableMapModel.__default.FixedSizeGet#canCall(MutableMapModel._default.FixedSizeGet$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeGet$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeGet$V, self#0))
       ==> $Is(MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $ly, self#0, key#0), 
        Tclass.Options.Option(MutableMapModel._default.FixedSizeGet$V)));

function MutableMapModel.__default.FixedSizeGet#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.FixedSizeGet
axiom (forall MutableMapModel._default.FixedSizeGet$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FixedSizeGet#requires(MutableMapModel._default.FixedSizeGet$V, $ly, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeGet$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.FixedSizeGet#requires(MutableMapModel._default.FixedSizeGet$V, $ly, self#0, key#0)
       == MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeGet$V, self#0));

// definition axiom for MutableMapModel.__default.FixedSizeGet(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeGet$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LS($ly), self#0, key#0) } 
    MutableMapModel.__default.FixedSizeGet#canCall(MutableMapModel._default.FixedSizeGet$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeGet$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeGet$V, self#0))
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeGet$V, self#0, key#0)
         && (var slotIdx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeGet$V, 
              StartFuel_MutableMapModel._default.Probe, 
              self#0, 
              key#0); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)))
         && MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LS($ly), self#0, key#0)
           == (var slotIdx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeGet$V, 
                StartFuel_MutableMapModel._default.Probe, 
                self#0, 
                key#0); 
            (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               then #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType))
               else #Options.Option.None())));

// definition axiom for MutableMapModel.__default.FixedSizeGet for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeGet$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LS($ly), Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.FixedSizeGet#canCall(MutableMapModel._default.FixedSizeGet$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeGet$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeGet$V, Lit(self#0))))
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeGet$V, Lit(self#0), LitInt(key#0))
         && (var slotIdx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeGet$V, 
              StartFuel_MutableMapModel._default.Probe, 
              Lit(self#0), 
              LitInt(key#0)); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))))
         && MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.FixedSizeGet$V, $LS($ly), Lit(self#0), LitInt(key#0))
           == (var slotIdx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeGet$V, 
                StartFuel_MutableMapModel._default.Probe, 
                Lit(self#0), 
                LitInt(key#0)); 
            (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
               then #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType))
               else #Options.Option.None())));

// function declaration for MutableMapModel._default.FixedSizeRemove
function MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int)
   : DatatypeType;

function MutableMapModel.__default.FixedSizeRemove#canCall(MutableMapModel._default.FixedSizeRemove$V: Ty, self#0: DatatypeType, key#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.FixedSizeRemove$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LS($ly), self#0, key#0) } 
  MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LS($ly), self#0, key#0)
     == MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $ly, self#0, key#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.FixedSizeRemove$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, AsFuelBottom($ly), self#0, key#0) } 
  MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $ly, self#0, key#0)
     == MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LZ, self#0, key#0));

// consequence axiom for MutableMapModel.__default.FixedSizeRemove
axiom true
   ==> (forall MutableMapModel._default.FixedSizeRemove$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $ly, self#0, key#0) } 
    MutableMapModel.__default.FixedSizeRemove#canCall(MutableMapModel._default.FixedSizeRemove$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeRemove$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeRemove$V, self#0))
       ==> $Is(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $ly, self#0, key#0), 
        Tclass._System.Tuple2(Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeRemove$V), 
          Tclass.Options.Option(MutableMapModel._default.FixedSizeRemove$V))));

function MutableMapModel.__default.FixedSizeRemove#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.FixedSizeRemove
axiom (forall MutableMapModel._default.FixedSizeRemove$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FixedSizeRemove#requires(MutableMapModel._default.FixedSizeRemove$V, $ly, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeRemove$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.FixedSizeRemove#requires(MutableMapModel._default.FixedSizeRemove$V, $ly, self#0, key#0)
       == MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeRemove$V, self#0));

// definition axiom for MutableMapModel.__default.FixedSizeRemove(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeRemove$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LS($ly), self#0, key#0) } 
    MutableMapModel.__default.FixedSizeRemove#canCall(MutableMapModel._default.FixedSizeRemove$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeRemove$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeRemove$V, self#0))
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeRemove$V, self#0, key#0)
         && (var slotIdx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeRemove$V, 
              StartFuel_MutableMapModel._default.Probe, 
              self#0, 
              key#0); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
                 && 
                MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(self#0)))
         && MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LS($ly), self#0, key#0)
           == (var slotIdx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeRemove$V, 
                StartFuel_MutableMapModel._default.Probe, 
                self#0, 
                key#0); 
            (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)
               then (var removed#0 := #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), slotIdx#0)): DatatypeType)); 
                (var self'#0 := #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Seq#Update(MutableMapModel.FixedSizeLinearHashMap.storage(self#0), 
                        slotIdx#0, 
                        $Box(#MutableMapModel.Item.Tombstone(key#0))), 
                      MutableMapModel.FixedSizeLinearHashMap.count(self#0), 
                      Map#Build(MutableMapModel.FixedSizeLinearHashMap.contents(self#0), 
                        $Box(key#0), 
                        $Box(Lit(#Options.Option.None())))); 
                  #_System._tuple#2._#Make2($Box(self'#0), $Box(removed#0))))
               else #_System._tuple#2._#Make2($Box(self#0), $Box(Lit(#Options.Option.None()))))));

// definition axiom for MutableMapModel.__default.FixedSizeRemove for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FixedSizeRemove$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LS($ly), Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.FixedSizeRemove#canCall(MutableMapModel._default.FixedSizeRemove$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.FixedSizeRemove$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.FixedSizeRemove$V, Lit(self#0))))
       ==> MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FixedSizeRemove$V, Lit(self#0), LitInt(key#0))
         && (var slotIdx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeRemove$V, 
              StartFuel_MutableMapModel._default.Probe, 
              Lit(self#0), 
              LitInt(key#0)); 
          MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                 && 
                MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(self#0))))
         && MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.FixedSizeRemove$V, $LS($ly), Lit(self#0), LitInt(key#0))
           == (var slotIdx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FixedSizeRemove$V, 
                StartFuel_MutableMapModel._default.Probe, 
                Lit(self#0), 
                LitInt(key#0)); 
            (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)
               then (var removed#1 := #Options.Option.Some(MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), slotIdx#1)): DatatypeType)); 
                (var self'#1 := #MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap(Seq#Update(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(self#0))), 
                        slotIdx#1, 
                        $Box(Lit(#MutableMapModel.Item.Tombstone(LitInt(key#0))))), 
                      LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(self#0))), 
                      Map#Build(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(self#0))), 
                        $Box(LitInt(key#0)), 
                        $Box(Lit(#Options.Option.None())))); 
                  #_System._tuple#2._#Make2($Box(self'#1), $Box(removed#1))))
               else #_System._tuple#2._#Make2($Box(Lit(self#0)), $Box(Lit(#Options.Option.None()))))));

// function declaration for MutableMapModel._default.MapFromStorage
function MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V: Ty, 
    $ly: LayerType, 
    elements#0: Seq Box)
   : Map Box Box;

function MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.MapFromStorage$V: Ty, elements#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.MapFromStorage$V: Ty, 
    $ly: LayerType, 
    elements#0: Seq Box :: 
  { MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LS($ly), elements#0) } 
  MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LS($ly), elements#0)
     == MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $ly, elements#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.MapFromStorage$V: Ty, 
    $ly: LayerType, 
    elements#0: Seq Box :: 
  { MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, AsFuelBottom($ly), elements#0) } 
  MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $ly, elements#0)
     == MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LZ, elements#0));

// consequence axiom for MutableMapModel.__default.MapFromStorage
axiom true
   ==> (forall MutableMapModel._default.MapFromStorage$V: Ty, 
      $ly: LayerType, 
      elements#0: Seq Box :: 
    { MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $ly, elements#0) } 
    MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.MapFromStorage$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V)))
       ==> $Is(MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $ly, elements#0), 
        TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.MapFromStorage$V)));

function MutableMapModel.__default.MapFromStorage#requires(Ty, LayerType, Seq Box) : bool;

// #requires axiom for MutableMapModel.__default.MapFromStorage
axiom (forall MutableMapModel._default.MapFromStorage$V: Ty, 
    $ly: LayerType, 
    elements#0: Seq Box :: 
  { MutableMapModel.__default.MapFromStorage#requires(MutableMapModel._default.MapFromStorage$V, $ly, elements#0) } 
  $Is(elements#0, 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V)))
     ==> MutableMapModel.__default.MapFromStorage#requires(MutableMapModel._default.MapFromStorage$V, $ly, elements#0)
       == true);

// definition axiom for MutableMapModel.__default.MapFromStorage(revealed)
axiom true
   ==> (forall MutableMapModel._default.MapFromStorage$V: Ty, 
      $ly: LayerType, 
      elements#0: Seq Box :: 
    { MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LS($ly), elements#0) } 
    MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.MapFromStorage$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V)))
       ==> (Seq#Length(elements#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
              elements#0)
             && 
            Sequences.__default.DropLast#canCall(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
              elements#0)
             && MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.MapFromStorage$V, 
              Sequences.__default.DropLast(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
                elements#0)))
         && MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LS($ly), elements#0)
           == (if Seq#Length(elements#0) == LitInt(0)
             then Map#Empty(): Map Box Box
             else (var item#0 := $Unbox(Sequences.__default.Last(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
                    elements#0)): DatatypeType; 
              (var dropLastMap#0 := MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, 
                    $ly, 
                    Sequences.__default.DropLast(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
                      elements#0)); 
                (if MutableMapModel.Item.Entry_q(item#0)
                   then Map#Build(dropLastMap#0, 
                    $Box(MutableMapModel.Item.key(item#0)), 
                    MutableMapModel.Item.value(item#0))
                   else dropLastMap#0)))));

// definition axiom for MutableMapModel.__default.MapFromStorage for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.MapFromStorage$V: Ty, 
      $ly: LayerType, 
      elements#0: Seq Box :: 
    {:weight 3} { MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LS($ly), Lit(elements#0)) } 
    MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.MapFromStorage$V, Lit(elements#0))
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V)))
       ==> (Seq#Length(Lit(elements#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
              Lit(elements#0))
             && 
            Sequences.__default.DropLast#canCall(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
              Lit(elements#0))
             && MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.MapFromStorage$V, 
              Lit(Sequences.__default.DropLast(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
                  Lit(elements#0)))))
         && MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, $LS($ly), Lit(elements#0))
           == (if Seq#Length(Lit(elements#0)) == LitInt(0)
             then Map#Empty(): Map Box Box
             else (var item#1 := Lit($Unbox(Sequences.__default.Last(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
                      Lit(elements#0))): DatatypeType); 
              (var dropLastMap#1 := Lit(MutableMapModel.__default.MapFromStorage(MutableMapModel._default.MapFromStorage$V, 
                      $LS($ly), 
                      Lit(Sequences.__default.DropLast(Tclass.MutableMapModel.Item(MutableMapModel._default.MapFromStorage$V), 
                          Lit(elements#0))))); 
                (if MutableMapModel.Item.Entry_q(item#1)
                   then Map#Build(dropLastMap#1, 
                    $Box(LitInt(MutableMapModel.Item.key(item#1))), 
                    Lit(MutableMapModel.Item.value(item#1)))
                   else dropLastMap#1)))));

// function declaration for MutableMapModel._default.CantEquivocate
function MutableMapModel.__default.CantEquivocate(MutableMapModel._default.CantEquivocate$V: Ty, elements#0: Seq Box) : bool;

function MutableMapModel.__default.CantEquivocate#canCall(MutableMapModel._default.CantEquivocate$V: Ty, elements#0: Seq Box) : bool;

// consequence axiom for MutableMapModel.__default.CantEquivocate
axiom true
   ==> (forall MutableMapModel._default.CantEquivocate$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.CantEquivocate(MutableMapModel._default.CantEquivocate$V, elements#0) } 
    MutableMapModel.__default.CantEquivocate#canCall(MutableMapModel._default.CantEquivocate$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocate$V)))
       ==> true);

function MutableMapModel.__default.CantEquivocate#requires(Ty, Seq Box) : bool;

// #requires axiom for MutableMapModel.__default.CantEquivocate
axiom (forall MutableMapModel._default.CantEquivocate$V: Ty, elements#0: Seq Box :: 
  { MutableMapModel.__default.CantEquivocate#requires(MutableMapModel._default.CantEquivocate$V, elements#0) } 
  $Is(elements#0, 
      TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocate$V)))
     ==> MutableMapModel.__default.CantEquivocate#requires(MutableMapModel._default.CantEquivocate$V, elements#0)
       == true);

// definition axiom for MutableMapModel.__default.CantEquivocate(revealed)
axiom true
   ==> (forall MutableMapModel._default.CantEquivocate$V: Ty, elements#0: Seq Box :: 
    { MutableMapModel.__default.CantEquivocate(MutableMapModel._default.CantEquivocate$V, elements#0) } 
    MutableMapModel.__default.CantEquivocate#canCall(MutableMapModel._default.CantEquivocate$V, elements#0)
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocate$V)))
       ==> (forall slot1#0: DatatypeType, slot2#0: DatatypeType :: 
          { MutableMapModel.Slot.slot(slot2#0), MutableMapModel.Slot.slot(slot1#0) } 
            { MutableMapModel.Slot.slot(slot2#0), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0) } 
            { MutableMapModel.Slot.slot(slot1#0), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0) } 
          $Is(slot1#0, Tclass.MutableMapModel.Slot())
               && $Is(slot2#0, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot1#0)
               && (MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0)
                 ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot2#0))
               && (MutableMapModel.__default.ValidSlot#canCall(Seq#Length(elements#0), slot2#0)
                   && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0)
                 ==> MutableMapModel.Slot.Slot_q(slot1#0))
               && (MutableMapModel.Slot.Slot_q(slot1#0)
                   && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot1#0))): DatatypeType)
                 ==> MutableMapModel.Slot.Slot_q(slot2#0))
               && (MutableMapModel.Slot.Slot_q(slot2#0)
                   && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot2#0))): DatatypeType)
                 ==> MutableMapModel.Slot.Slot_q(slot1#0) && MutableMapModel.Slot.Slot_q(slot2#0))
               && (MutableMapModel.Slot.Slot_q(slot1#0)
                   && MutableMapModel.Slot.Slot_q(slot2#0)
                   && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot1#0))): DatatypeType)
                     == MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot2#0))): DatatypeType)
                 ==> $IsA#MutableMapModel.Slot(slot1#0) && $IsA#MutableMapModel.Slot(slot2#0)))
         && MutableMapModel.__default.CantEquivocate(MutableMapModel._default.CantEquivocate$V, elements#0)
           == (forall slot1#0: DatatypeType, slot2#0: DatatypeType :: 
            { MutableMapModel.Slot.slot(slot2#0), MutableMapModel.Slot.slot(slot1#0) } 
              { MutableMapModel.Slot.slot(slot2#0), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0) } 
              { MutableMapModel.Slot.slot(slot1#0), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0) } 
            $Is(slot1#0, Tclass.MutableMapModel.Slot())
                 && $Is(slot2#0, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#0)
                 && MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#0)
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot1#0))): DatatypeType)
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot2#0))): DatatypeType)
                 && MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot1#0))): DatatypeType)
                   == MutableMapModel.Item.key($Unbox(Seq#Index(elements#0, MutableMapModel.Slot.slot(slot2#0))): DatatypeType)
               ==> MutableMapModel.Slot#Equal(slot1#0, slot2#0)));

// definition axiom for MutableMapModel.__default.CantEquivocate for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.CantEquivocate$V: Ty, elements#0: Seq Box :: 
    {:weight 3} { MutableMapModel.__default.CantEquivocate(MutableMapModel._default.CantEquivocate$V, Lit(elements#0)) } 
    MutableMapModel.__default.CantEquivocate#canCall(MutableMapModel._default.CantEquivocate$V, Lit(elements#0))
         || $Is(elements#0, 
          TSeq(Tclass.MutableMapModel.Item(MutableMapModel._default.CantEquivocate$V)))
       ==> (forall slot1#1: DatatypeType, slot2#1: DatatypeType :: 
          { MutableMapModel.Slot.slot(slot2#1), MutableMapModel.Slot.slot(slot1#1) } 
            { MutableMapModel.Slot.slot(slot2#1), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#1) } 
            { MutableMapModel.Slot.slot(slot1#1), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#1) } 
            { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#1), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#1) } 
          $Is(slot1#1, Tclass.MutableMapModel.Slot())
               && $Is(slot2#1, Tclass.MutableMapModel.Slot())
             ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot1#1)
               && (MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot1#1)
                 ==> MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot2#1))
               && (MutableMapModel.__default.ValidSlot#canCall(Seq#Length(Lit(elements#0)), slot2#1)
                   && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot2#1)
                 ==> MutableMapModel.Slot.Slot_q(slot1#1))
               && (MutableMapModel.Slot.Slot_q(slot1#1)
                   && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot1#1))): DatatypeType)
                 ==> MutableMapModel.Slot.Slot_q(slot2#1))
               && (MutableMapModel.Slot.Slot_q(slot2#1)
                   && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot2#1))): DatatypeType)
                 ==> MutableMapModel.Slot.Slot_q(slot1#1) && MutableMapModel.Slot.Slot_q(slot2#1))
               && (MutableMapModel.Slot.Slot_q(slot1#1)
                   && MutableMapModel.Slot.Slot_q(slot2#1)
                   && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot1#1))): DatatypeType)
                     == MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot2#1))): DatatypeType)
                 ==> $IsA#MutableMapModel.Slot(slot1#1) && $IsA#MutableMapModel.Slot(slot2#1)))
         && MutableMapModel.__default.CantEquivocate(MutableMapModel._default.CantEquivocate$V, Lit(elements#0))
           == (forall slot1#1: DatatypeType, slot2#1: DatatypeType :: 
            { MutableMapModel.Slot.slot(slot2#1), MutableMapModel.Slot.slot(slot1#1) } 
              { MutableMapModel.Slot.slot(slot2#1), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#1) } 
              { MutableMapModel.Slot.slot(slot1#1), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#1) } 
              { MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot2#1), MutableMapModel.__default.ValidSlot(Seq#Length(elements#0), slot1#1) } 
            $Is(slot1#1, Tclass.MutableMapModel.Slot())
                 && $Is(slot2#1, Tclass.MutableMapModel.Slot())
               ==> 
              MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot1#1)
                 && MutableMapModel.__default.ValidSlot(Seq#Length(Lit(elements#0)), slot2#1)
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot1#1))): DatatypeType)
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot2#1))): DatatypeType)
                 && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot1#1))): DatatypeType)
                   == MutableMapModel.Item.key($Unbox(Seq#Index(Lit(elements#0), MutableMapModel.Slot.slot(slot2#1))): DatatypeType)
               ==> MutableMapModel.Slot#Equal(slot1#1, slot2#1)));

// function declaration for MutableMapModel._default.UnderlyingContentsMatchesContents
function MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingContentsMatchesContents$V: Ty, 
    underlying#0: DatatypeType, 
    contents#0: Map Box Box)
   : bool;

function MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingContentsMatchesContents$V: Ty, 
    underlying#0: DatatypeType, 
    contents#0: Map Box Box)
   : bool;

// consequence axiom for MutableMapModel.__default.UnderlyingContentsMatchesContents
axiom true
   ==> (forall MutableMapModel._default.UnderlyingContentsMatchesContents$V: Ty, 
      underlying#0: DatatypeType, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
        underlying#0, 
        contents#0) } 
    MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
          underlying#0, 
          contents#0)
         || ($Is(underlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingContentsMatchesContents$V))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              MutableMapModel._default.UnderlyingContentsMatchesContents$V)))
       ==> true);

function MutableMapModel.__default.UnderlyingContentsMatchesContents#requires(Ty, DatatypeType, Map Box Box) : bool;

// #requires axiom for MutableMapModel.__default.UnderlyingContentsMatchesContents
axiom (forall MutableMapModel._default.UnderlyingContentsMatchesContents$V: Ty, 
    underlying#0: DatatypeType, 
    contents#0: Map Box Box :: 
  { MutableMapModel.__default.UnderlyingContentsMatchesContents#requires(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
      underlying#0, 
      contents#0) } 
  $Is(underlying#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingContentsMatchesContents$V))
       && $Is(contents#0, 
        TMap(Tclass.NativeTypes.uint64(), 
          MutableMapModel._default.UnderlyingContentsMatchesContents$V))
     ==> MutableMapModel.__default.UnderlyingContentsMatchesContents#requires(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
        underlying#0, 
        contents#0)
       == true);

// definition axiom for MutableMapModel.__default.UnderlyingContentsMatchesContents(revealed)
axiom true
   ==> (forall MutableMapModel._default.UnderlyingContentsMatchesContents$V: Ty, 
      underlying#0: DatatypeType, 
      contents#0: Map Box Box :: 
    { MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
        underlying#0, 
        contents#0) } 
    MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
          underlying#0, 
          contents#0)
         || ($Is(underlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingContentsMatchesContents$V))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              MutableMapModel._default.UnderlyingContentsMatchesContents$V)))
       ==> (forall key#0: int :: 
          { Map#Elements(contents#0)[$Box(key#0)] } 
            { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)] } 
            { Map#Domain(contents#0)[$Box(key#0)] } 
          LitInt(0) <= key#0 && key#0 < 18446744073709551616
             ==> (Map#Domain(contents#0)[$Box(key#0)]
                 ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(underlying#0))
               && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(underlying#0)
                   && Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]
                 ==> 
                Map#Domain(contents#0)[$Box(key#0)]
                 ==> $IsA#Options.Option($Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]): DatatypeType)
                   && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(underlying#0)))
         && ((forall key#0: int :: 
            { Map#Elements(contents#0)[$Box(key#0)] } 
              { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]): DatatypeType } 
              { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)] } 
              { Map#Domain(contents#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 18446744073709551616
               ==> (Map#Domain(contents#0)[$Box(key#0)]
                   ==> Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)])
                 && (Map#Domain(contents#0)[$Box(key#0)]
                   ==> Options.Option#Equal($Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]): DatatypeType, 
                    #Options.Option.Some(Map#Elements(contents#0)[$Box(key#0)]))))
           ==> (forall key#1: int :: 
            { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)] } 
              { Map#Domain(contents#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 18446744073709551616
               ==> 
              !Map#Domain(contents#0)[$Box(key#1)]
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(underlying#0)
                 && (Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)]
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(underlying#0))))
         && MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
            underlying#0, 
            contents#0)
           == ((forall key#0: int :: 
              { Map#Elements(contents#0)[$Box(key#0)] } 
                { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]): DatatypeType } 
                { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)] } 
                { Map#Domain(contents#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 18446744073709551616
                 ==> (Map#Domain(contents#0)[$Box(key#0)]
                     ==> Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)])
                   && (Map#Domain(contents#0)[$Box(key#0)]
                     ==> Options.Option#Equal($Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#0)]): DatatypeType, 
                      #Options.Option.Some(Map#Elements(contents#0)[$Box(key#0)]))))
             && (forall key#1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)] } 
                { Map#Domain(contents#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 18446744073709551616
                 ==> 
                !Map#Domain(contents#0)[$Box(key#1)]
                 ==> !Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)]
                   || Options.Option.None_q($Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#1)]): DatatypeType))));

// definition axiom for MutableMapModel.__default.UnderlyingContentsMatchesContents for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.UnderlyingContentsMatchesContents$V: Ty, 
      underlying#0: DatatypeType, 
      contents#0: Map Box Box :: 
    {:weight 3} { MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
        Lit(underlying#0), 
        Lit(contents#0)) } 
    MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
          Lit(underlying#0), 
          Lit(contents#0))
         || ($Is(underlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingContentsMatchesContents$V))
           && $Is(contents#0, 
            TMap(Tclass.NativeTypes.uint64(), 
              MutableMapModel._default.UnderlyingContentsMatchesContents$V)))
       ==> (forall key#2: int :: 
          { Map#Elements(contents#0)[$Box(key#2)] } 
            { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#2)]): DatatypeType } 
            { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#2)] } 
            { Map#Domain(contents#0)[$Box(key#2)] } 
          LitInt(0) <= key#2 && key#2 < 18446744073709551616
             ==> (Map#Domain(contents#0)[$Box(key#2)]
                 ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(underlying#0)))
               && (MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(underlying#0))
                   && Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0)))[$Box(key#2)]
                 ==> 
                Map#Domain(contents#0)[$Box(key#2)]
                 ==> $IsA#Options.Option($Unbox(Map#Elements(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0))))[$Box(key#2)]): DatatypeType)
                   && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(underlying#0))))
         && ((forall key#2: int :: 
            { Map#Elements(contents#0)[$Box(key#2)] } 
              { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#2)]): DatatypeType } 
              { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#2)] } 
              { Map#Domain(contents#0)[$Box(key#2)] } 
            LitInt(0) <= key#2 && key#2 < 18446744073709551616
               ==> (Map#Domain(contents#0)[$Box(key#2)]
                   ==> Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0)))[$Box(key#2)])
                 && (Map#Domain(contents#0)[$Box(key#2)]
                   ==> Options.Option#Equal($Unbox(Map#Elements(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0))))[$Box(key#2)]): DatatypeType, 
                    #Options.Option.Some(Map#Elements(Lit(contents#0))[$Box(key#2)]))))
           ==> (forall key#3: int :: 
            { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#3)]): DatatypeType } 
              { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#3)] } 
              { Map#Domain(contents#0)[$Box(key#3)] } 
            LitInt(0) <= key#3 && key#3 < 18446744073709551616
               ==> 
              !Map#Domain(contents#0)[$Box(key#3)]
               ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(underlying#0))
                 && (Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0)))[$Box(key#3)]
                   ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(underlying#0)))))
         && MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingContentsMatchesContents$V, 
            Lit(underlying#0), 
            Lit(contents#0))
           == ((forall key#2: int :: 
              { Map#Elements(contents#0)[$Box(key#2)] } 
                { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#2)] } 
                { Map#Domain(contents#0)[$Box(key#2)] } 
              LitInt(0) <= key#2 && key#2 < 18446744073709551616
                 ==> (Map#Domain(contents#0)[$Box(key#2)]
                     ==> Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0)))[$Box(key#2)])
                   && (Map#Domain(contents#0)[$Box(key#2)]
                     ==> Options.Option#Equal($Unbox(Map#Elements(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0))))[$Box(key#2)]): DatatypeType, 
                      #Options.Option.Some(Map#Elements(Lit(contents#0))[$Box(key#2)]))))
             && (forall key#3: int :: 
              { $Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#3)]): DatatypeType } 
                { Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(underlying#0))[$Box(key#3)] } 
                { Map#Domain(contents#0)[$Box(key#3)] } 
              LitInt(0) <= key#3 && key#3 < 18446744073709551616
                 ==> 
                !Map#Domain(contents#0)[$Box(key#3)]
                 ==> !Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0)))[$Box(key#3)]
                   || Options.Option.None_q($Unbox(Map#Elements(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(underlying#0))))[$Box(key#3)]): DatatypeType))));

// function declaration for MutableMapModel._default.UnderlyingInv
function MutableMapModel.__default.UnderlyingInv(MutableMapModel._default.UnderlyingInv$V: Ty, 
    self#0: DatatypeType, 
    underlying#0: DatatypeType)
   : bool;

function MutableMapModel.__default.UnderlyingInv#canCall(MutableMapModel._default.UnderlyingInv$V: Ty, 
    self#0: DatatypeType, 
    underlying#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.UnderlyingInv
axiom true
   ==> (forall MutableMapModel._default.UnderlyingInv$V: Ty, 
      self#0: DatatypeType, 
      underlying#0: DatatypeType :: 
    { MutableMapModel.__default.UnderlyingInv(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0) } 
    MutableMapModel.__default.UnderlyingInv#canCall(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UnderlyingInv$V))
           && $Is(underlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingInv$V)))
       ==> true);

function MutableMapModel.__default.UnderlyingInv#requires(Ty, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.UnderlyingInv
axiom (forall MutableMapModel._default.UnderlyingInv$V: Ty, 
    self#0: DatatypeType, 
    underlying#0: DatatypeType :: 
  { MutableMapModel.__default.UnderlyingInv#requires(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UnderlyingInv$V))
       && $Is(underlying#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingInv$V))
     ==> MutableMapModel.__default.UnderlyingInv#requires(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0)
       == true);

// definition axiom for MutableMapModel.__default.UnderlyingInv(revealed)
axiom true
   ==> (forall MutableMapModel._default.UnderlyingInv$V: Ty, 
      self#0: DatatypeType, 
      underlying#0: DatatypeType :: 
    { MutableMapModel.__default.UnderlyingInv(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0) } 
    MutableMapModel.__default.UnderlyingInv#canCall(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UnderlyingInv$V))
           && $Is(underlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingInv$V)))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && (Map#Card(MutableMapModel.LinearHashMap.contents(self#0))
             == MutableMapModel.LinearHashMap.count(self#0)
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingInv$V, 
              underlying#0, 
              MutableMapModel.LinearHashMap.contents(self#0)))
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingInv$V, 
              underlying#0, 
              MutableMapModel.LinearHashMap.contents(self#0))
             && MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingInv$V, 
              underlying#0, 
              MutableMapModel.LinearHashMap.contents(self#0))
           ==> MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.UnderlyingInv$V, underlying#0))
         && (MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.UnderlyingInv$V, underlying#0)
             && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.UnderlyingInv$V, underlying#0)
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(underlying#0)
             && MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.UnderlyingInv$V, 
              MutableMapModel.FixedSizeLinearHashMap.storage(underlying#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(self#0))
         && MutableMapModel.__default.UnderlyingInv(MutableMapModel._default.UnderlyingInv$V, self#0, underlying#0)
           == (
            Map#Card(MutableMapModel.LinearHashMap.contents(self#0))
               == MutableMapModel.LinearHashMap.count(self#0)
             && MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingInv$V, 
              underlying#0, 
              MutableMapModel.LinearHashMap.contents(self#0))
             && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.UnderlyingInv$V, underlying#0)
             && Map#Equal(MutableMapModel.__default.MapFromStorage(MutableMapModel._default.UnderlyingInv$V, 
                $LS($LZ), 
                MutableMapModel.FixedSizeLinearHashMap.storage(underlying#0)), 
              MutableMapModel.LinearHashMap.contents(self#0))));

// definition axiom for MutableMapModel.__default.UnderlyingInv for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.UnderlyingInv$V: Ty, 
      self#0: DatatypeType, 
      underlying#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.UnderlyingInv(MutableMapModel._default.UnderlyingInv$V, Lit(self#0), Lit(underlying#0)) } 
    MutableMapModel.__default.UnderlyingInv#canCall(MutableMapModel._default.UnderlyingInv$V, Lit(self#0), Lit(underlying#0))
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UnderlyingInv$V))
           && $Is(underlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.UnderlyingInv$V)))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && (Map#Card(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))
             == LitInt(MutableMapModel.LinearHashMap.count(Lit(self#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingInv$V, 
              Lit(underlying#0), 
              Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0)))))
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.__default.UnderlyingContentsMatchesContents#canCall(MutableMapModel._default.UnderlyingInv$V, 
              Lit(underlying#0), 
              Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))
             && Lit(MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingInv$V, 
                Lit(underlying#0), 
                Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0)))))
           ==> MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.UnderlyingInv$V, Lit(underlying#0)))
         && (MutableMapModel.__default.FixedSizeInv#canCall(MutableMapModel._default.UnderlyingInv$V, Lit(underlying#0))
             && Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.UnderlyingInv$V, Lit(underlying#0)))
           ==> MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(underlying#0))
             && MutableMapModel.__default.MapFromStorage#canCall(MutableMapModel._default.UnderlyingInv$V, 
              Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(underlying#0))))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0)))
         && MutableMapModel.__default.UnderlyingInv(MutableMapModel._default.UnderlyingInv$V, Lit(self#0), Lit(underlying#0))
           == (
            Map#Card(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))
               == LitInt(MutableMapModel.LinearHashMap.count(Lit(self#0)))
             && MutableMapModel.__default.UnderlyingContentsMatchesContents(MutableMapModel._default.UnderlyingInv$V, 
              Lit(underlying#0), 
              Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))
             && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.UnderlyingInv$V, Lit(underlying#0))
             && Map#Equal(MutableMapModel.__default.MapFromStorage(MutableMapModel._default.UnderlyingInv$V, 
                $LS($LZ), 
                Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(underlying#0)))), 
              MutableMapModel.LinearHashMap.contents(Lit(self#0)))));

// function declaration for MutableMapModel._default.Inv
function MutableMapModel.__default.Inv(MutableMapModel._default.Inv$V: Ty, self#0: DatatypeType) : bool;

function MutableMapModel.__default.Inv#canCall(MutableMapModel._default.Inv$V: Ty, self#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.Inv
axiom true
   ==> (forall MutableMapModel._default.Inv$V: Ty, self#0: DatatypeType :: 
    { MutableMapModel.__default.Inv(MutableMapModel._default.Inv$V, self#0) } 
    MutableMapModel.__default.Inv#canCall(MutableMapModel._default.Inv$V, self#0)
         || $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Inv$V))
       ==> 
      MutableMapModel.__default.Inv(MutableMapModel._default.Inv$V, self#0)
       ==> Map#Card(MutableMapModel.LinearHashMap.contents(self#0))
         == MutableMapModel.LinearHashMap.count(self#0));

function MutableMapModel.__default.Inv#requires(Ty, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.Inv
axiom (forall MutableMapModel._default.Inv$V: Ty, self#0: DatatypeType :: 
  { MutableMapModel.__default.Inv#requires(MutableMapModel._default.Inv$V, self#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Inv$V))
     ==> MutableMapModel.__default.Inv#requires(MutableMapModel._default.Inv$V, self#0)
       == true);

// definition axiom for MutableMapModel.__default.Inv(revealed)
axiom true
   ==> (forall MutableMapModel._default.Inv$V: Ty, self#0: DatatypeType :: 
    { MutableMapModel.__default.Inv(MutableMapModel._default.Inv$V, self#0) } 
    MutableMapModel.__default.Inv#canCall(MutableMapModel._default.Inv$V, self#0)
         || $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Inv$V))
       ==> true);

// definition axiom for MutableMapModel.__default.Inv for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Inv$V: Ty, self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.Inv(MutableMapModel._default.Inv$V, Lit(self#0)) } 
    MutableMapModel.__default.Inv#canCall(MutableMapModel._default.Inv$V, Lit(self#0))
         || $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Inv$V))
       ==> true);

// function declaration for MutableMapModel._default.Constructor
function MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int)
   : DatatypeType;

function MutableMapModel.__default.Constructor#canCall(MutableMapModel._default.Constructor$V: Ty, size#0: int) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int :: 
  { MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LS($ly), size#0) } 
  MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LS($ly), size#0)
     == MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $ly, size#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int :: 
  { MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, AsFuelBottom($ly), size#0) } 
  MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $ly, size#0)
     == MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LZ, size#0));

// consequence axiom for MutableMapModel.__default.Constructor
axiom true
   ==> (forall MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int :: 
    { MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $ly, size#0) } 
    MutableMapModel.__default.Constructor#canCall(MutableMapModel._default.Constructor$V, size#0)
         || (LitInt(0) <= size#0 && size#0 < 18446744073709551616 && LitInt(128) <= size#0)
       ==> MutableMapModel.__default.Inv(MutableMapModel._default.Constructor$V, 
          MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $ly, size#0))
         && Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $ly, size#0)), 
          Map#Empty(): Map Box Box)
         && $Is(MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $ly, size#0), 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Constructor$V)));

function MutableMapModel.__default.Constructor#requires(Ty, LayerType, int) : bool;

// #requires axiom for MutableMapModel.__default.Constructor
axiom (forall MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int :: 
  { MutableMapModel.__default.Constructor#requires(MutableMapModel._default.Constructor$V, $ly, size#0) } 
  LitInt(0) <= size#0 && size#0 < 18446744073709551616
     ==> MutableMapModel.__default.Constructor#requires(MutableMapModel._default.Constructor$V, $ly, size#0)
       == (LitInt(128) <= size#0));

// definition axiom for MutableMapModel.__default.Constructor(revealed)
axiom true
   ==> (forall MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int :: 
    { MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LS($ly), size#0) } 
    MutableMapModel.__default.Constructor#canCall(MutableMapModel._default.Constructor$V, size#0)
         || (LitInt(0) <= size#0 && size#0 < 18446744073709551616 && LitInt(128) <= size#0)
       ==> MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.Constructor$V, size#0)
         && MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LS($ly), size#0)
           == (var self#0 := #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.Constructor$V, size#0), 
                LitInt(0), 
                Lit(Map#Empty(): Map Box Box)); 
            self#0));

// definition axiom for MutableMapModel.__default.Constructor for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Constructor$V: Ty, $ly: LayerType, size#0: int :: 
    {:weight 3} { MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LS($ly), LitInt(size#0)) } 
    MutableMapModel.__default.Constructor#canCall(MutableMapModel._default.Constructor$V, LitInt(size#0))
         || (
          LitInt(0) <= size#0
           && size#0 < 18446744073709551616
           && LitInt(128) <= LitInt(size#0))
       ==> MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.Constructor$V, LitInt(size#0))
         && MutableMapModel.__default.Constructor(MutableMapModel._default.Constructor$V, $LS($ly), LitInt(size#0))
           == (var self#1 := Lit(#MutableMapModel.LinearHashMap.LinearHashMap(Lit(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.Constructor$V, LitInt(size#0))), 
                  LitInt(0), 
                  Lit(Map#Empty(): Map Box Box))); 
            self#1));

// function declaration for MutableMapModel._default.ReallocIterate
function MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    newUnderlying#0: DatatypeType, 
    i#0: int)
   : DatatypeType;

function MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V: Ty, 
    self#0: DatatypeType, 
    newUnderlying#0: DatatypeType, 
    i#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.ReallocIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    newUnderlying#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
      $LS($ly), 
      self#0, 
      newUnderlying#0, 
      i#0) } 
  MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
      $LS($ly), 
      self#0, 
      newUnderlying#0, 
      i#0)
     == MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, $ly, self#0, newUnderlying#0, i#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.ReallocIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    newUnderlying#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
      AsFuelBottom($ly), 
      self#0, 
      newUnderlying#0, 
      i#0) } 
  MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, $ly, self#0, newUnderlying#0, i#0)
     == MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, $LZ, self#0, newUnderlying#0, i#0));

// consequence axiom for MutableMapModel.__default.ReallocIterate
axiom true
   ==> (forall MutableMapModel._default.ReallocIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      newUnderlying#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, $ly, self#0, newUnderlying#0, i#0) } 
    MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, self#0, newUnderlying#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && $Is(newUnderlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.ReallocIterate$V, self#0)
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ReallocIterate$V, newUnderlying#0)
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           && MutableMapModel.LinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(newUnderlying#0)) - 1
           && Set#Subset(Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(newUnderlying#0)), 
            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))))
       ==> $Is(MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, $ly, self#0, newUnderlying#0, i#0), 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ReallocIterate$V)));

function MutableMapModel.__default.ReallocIterate#requires(Ty, LayerType, DatatypeType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.ReallocIterate
axiom (forall MutableMapModel._default.ReallocIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    newUnderlying#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.ReallocIterate#requires(MutableMapModel._default.ReallocIterate$V, $ly, self#0, newUnderlying#0, i#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocIterate$V))
       && $Is(newUnderlying#0, 
        Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ReallocIterate$V))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> MutableMapModel.__default.ReallocIterate#requires(MutableMapModel._default.ReallocIterate$V, $ly, self#0, newUnderlying#0, i#0)
       == (
        MutableMapModel.__default.Inv(MutableMapModel._default.ReallocIterate$V, self#0)
         && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ReallocIterate$V, newUnderlying#0)
         && 
        LitInt(0) <= i#0
         && i#0
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
         && MutableMapModel.LinearHashMap.count(self#0)
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(newUnderlying#0)) - 1
         && Set#Subset(Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(newUnderlying#0)), 
          Map#Domain(MutableMapModel.LinearHashMap.contents(self#0)))));

// definition axiom for MutableMapModel.__default.ReallocIterate(revealed)
axiom true
   ==> (forall MutableMapModel._default.ReallocIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      newUnderlying#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
        $LS($ly), 
        self#0, 
        newUnderlying#0, 
        i#0) } 
    MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, self#0, newUnderlying#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && $Is(newUnderlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.ReallocIterate$V, self#0)
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ReallocIterate$V, newUnderlying#0)
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           && MutableMapModel.LinearHashMap.count(self#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(newUnderlying#0)) - 1
           && Set#Subset(Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(newUnderlying#0)), 
            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && (i#0
             != Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && (var item#0 := $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType; 
              (MutableMapModel.Item.Entry_q(item#0)
                   ==> MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.ReallocIterate$V, 
                      newUnderlying#0, 
                      MutableMapModel.Item.key(item#0), 
                      MutableMapModel.Item.value(item#0))
                     && _System.Tuple2.___hMake2_q(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                        StartFuel_MutableMapModel._default.FixedSizeInsert, 
                        newUnderlying#0, 
                        MutableMapModel.Item.key(item#0), 
                        MutableMapModel.Item.value(item#0))))
                 && (var newUnderlying'#0 := (if MutableMapModel.Item.Entry_q(item#0)
                       then $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                            StartFuel_MutableMapModel._default.FixedSizeInsert, 
                            newUnderlying#0, 
                            MutableMapModel.Item.key(item#0), 
                            MutableMapModel.Item.value(item#0)))): DatatypeType
                       else newUnderlying#0); 
                  MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, self#0, newUnderlying'#0, i#0 + 1))))
         && MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
            $LS($ly), 
            self#0, 
            newUnderlying#0, 
            i#0)
           == (if i#0
               == Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             then newUnderlying#0
             else (var item#0 := $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType; 
              (var newUnderlying'#0 := (if MutableMapModel.Item.Entry_q(item#0)
                     then $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                          StartFuel_MutableMapModel._default.FixedSizeInsert, 
                          newUnderlying#0, 
                          MutableMapModel.Item.key(item#0), 
                          MutableMapModel.Item.value(item#0)))): DatatypeType
                     else newUnderlying#0); 
                MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
                  $ly, 
                  self#0, 
                  newUnderlying'#0, 
                  i#0 + 1)))));

// definition axiom for MutableMapModel.__default.ReallocIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ReallocIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      newUnderlying#0: DatatypeType, 
      i#0: int :: 
    {:weight 3} { MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
        $LS($ly), 
        Lit(self#0), 
        newUnderlying#0, 
        LitInt(i#0)) } 
    MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, 
          Lit(self#0), 
          newUnderlying#0, 
          LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && $Is(newUnderlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.ReallocIterate$V, Lit(self#0)))
           && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ReallocIterate$V, newUnderlying#0)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           && MutableMapModel.LinearHashMap.count(Lit(self#0))
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(newUnderlying#0)) - 1
           && Set#Subset(Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(newUnderlying#0)), 
            Map#Domain(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (LitInt(i#0)
             != Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (var item#1 := $Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType; 
              (MutableMapModel.Item.Entry_q(item#1)
                   ==> MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.ReallocIterate$V, 
                      newUnderlying#0, 
                      MutableMapModel.Item.key(item#1), 
                      MutableMapModel.Item.value(item#1))
                     && _System.Tuple2.___hMake2_q(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                        StartFuel_MutableMapModel._default.FixedSizeInsert, 
                        newUnderlying#0, 
                        MutableMapModel.Item.key(item#1), 
                        MutableMapModel.Item.value(item#1))))
                 && (var newUnderlying'#1 := (if MutableMapModel.Item.Entry_q(item#1)
                       then $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                            StartFuel_MutableMapModel._default.FixedSizeInsert, 
                            newUnderlying#0, 
                            MutableMapModel.Item.key(item#1), 
                            MutableMapModel.Item.value(item#1)))): DatatypeType
                       else newUnderlying#0); 
                  MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, 
                    Lit(self#0), 
                    newUnderlying'#1, 
                    LitInt(i#0 + 1)))))
         && MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
            $LS($ly), 
            Lit(self#0), 
            newUnderlying#0, 
            LitInt(i#0))
           == (if LitInt(i#0)
               == Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             then newUnderlying#0
             else (var item#1 := $Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType; 
              (var newUnderlying'#1 := (if MutableMapModel.Item.Entry_q(item#1)
                     then $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                          StartFuel_MutableMapModel._default.FixedSizeInsert, 
                          newUnderlying#0, 
                          MutableMapModel.Item.key(item#1), 
                          MutableMapModel.Item.value(item#1)))): DatatypeType
                     else newUnderlying#0); 
                MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
                  $LS($ly), 
                  Lit(self#0), 
                  newUnderlying'#1, 
                  LitInt(i#0 + 1))))));

// definition axiom for MutableMapModel.__default.ReallocIterate for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ReallocIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      newUnderlying#0: DatatypeType, 
      i#0: int :: 
    {:weight 3} { MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
        $LS($ly), 
        Lit(self#0), 
        Lit(newUnderlying#0), 
        LitInt(i#0)) } 
    MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, 
          Lit(self#0), 
          Lit(newUnderlying#0), 
          LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && $Is(newUnderlying#0, 
            Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMapModel._default.ReallocIterate$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.ReallocIterate$V, Lit(self#0)))
           && Lit(MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.ReallocIterate$V, Lit(newUnderlying#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           && MutableMapModel.LinearHashMap.count(Lit(self#0))
             < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(newUnderlying#0))))
               - 1
           && Set#Subset(Map#Domain(Lit(MutableMapModel.FixedSizeLinearHashMap.contents(Lit(newUnderlying#0)))), 
            Map#Domain(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (LitInt(i#0)
             != Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (var item#2 := $Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType; 
              (MutableMapModel.Item.Entry_q(item#2)
                   ==> MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.ReallocIterate$V, 
                      Lit(newUnderlying#0), 
                      MutableMapModel.Item.key(item#2), 
                      MutableMapModel.Item.value(item#2))
                     && _System.Tuple2.___hMake2_q(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                        StartFuel_MutableMapModel._default.FixedSizeInsert, 
                        Lit(newUnderlying#0), 
                        MutableMapModel.Item.key(item#2), 
                        MutableMapModel.Item.value(item#2))))
                 && (var newUnderlying'#2 := (if MutableMapModel.Item.Entry_q(item#2)
                       then $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                            StartFuel_MutableMapModel._default.FixedSizeInsert, 
                            Lit(newUnderlying#0), 
                            MutableMapModel.Item.key(item#2), 
                            MutableMapModel.Item.value(item#2)))): DatatypeType
                       else newUnderlying#0); 
                  MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocIterate$V, 
                    Lit(self#0), 
                    newUnderlying'#2, 
                    LitInt(i#0 + 1)))))
         && MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
            $LS($ly), 
            Lit(self#0), 
            Lit(newUnderlying#0), 
            LitInt(i#0))
           == (if LitInt(i#0)
               == Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             then newUnderlying#0
             else (var item#2 := $Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType; 
              (var newUnderlying'#2 := (if MutableMapModel.Item.Entry_q(item#2)
                     then $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.ReallocIterate$V, 
                          StartFuel_MutableMapModel._default.FixedSizeInsert, 
                          Lit(newUnderlying#0), 
                          MutableMapModel.Item.key(item#2), 
                          MutableMapModel.Item.value(item#2)))): DatatypeType
                     else newUnderlying#0); 
                MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocIterate$V, 
                  $LS($ly), 
                  Lit(self#0), 
                  newUnderlying'#2, 
                  LitInt(i#0 + 1))))));

// function declaration for MutableMapModel._default.ReallocInternal
function MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType)
   : DatatypeType;

function MutableMapModel.__default.ReallocInternal#canCall(MutableMapModel._default.ReallocInternal$V: Ty, self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.ReallocInternal$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType :: 
  { MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LS($ly), self#0) } 
  MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LS($ly), self#0)
     == MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $ly, self#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.ReallocInternal$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType :: 
  { MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, AsFuelBottom($ly), self#0) } 
  MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $ly, self#0)
     == MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LZ, self#0));

// consequence axiom for MutableMapModel.__default.ReallocInternal
axiom true
   ==> (forall MutableMapModel._default.ReallocInternal$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType :: 
    { MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $ly, self#0) } 
    MutableMapModel.__default.ReallocInternal#canCall(MutableMapModel._default.ReallocInternal$V, self#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocInternal$V))
           && 
          MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8))
           && MutableMapModel.__default.Inv(MutableMapModel._default.ReallocInternal$V, self#0))
       ==> $Is(MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $ly, self#0), 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocInternal$V)));

function MutableMapModel.__default.ReallocInternal#requires(Ty, LayerType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.ReallocInternal
axiom (forall MutableMapModel._default.ReallocInternal$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType :: 
  { MutableMapModel.__default.ReallocInternal#requires(MutableMapModel._default.ReallocInternal$V, $ly, self#0) } 
  $Is(self#0, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocInternal$V))
     ==> MutableMapModel.__default.ReallocInternal#requires(MutableMapModel._default.ReallocInternal$V, $ly, self#0)
       == (MutableMapModel.LinearHashMap.count(self#0)
           < Div(18446744073709551616, LitInt(8))
         && MutableMapModel.__default.Inv(MutableMapModel._default.ReallocInternal$V, self#0)));

// definition axiom for MutableMapModel.__default.ReallocInternal(revealed)
axiom true
   ==> (forall MutableMapModel._default.ReallocInternal$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType :: 
    { MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LS($ly), self#0) } 
    MutableMapModel.__default.ReallocInternal#canCall(MutableMapModel._default.ReallocInternal$V, self#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocInternal$V))
           && 
          MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8))
           && MutableMapModel.__default.Inv(MutableMapModel._default.ReallocInternal$V, self#0))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && (var newSize#0 := Mul(128 + MutableMapModel.LinearHashMap.count(self#0), LitInt(4)); 
          MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.ReallocInternal$V, newSize#0)
             && MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocInternal$V, 
              self#0, 
              MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ReallocInternal$V, newSize#0), 
              LitInt(0))
             && (var dt_update_tmp#0#0 := self#0; 
              MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#0)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#0)))
         && MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LS($ly), self#0)
           == (var newSize#0 := Mul(128 + MutableMapModel.LinearHashMap.count(self#0), LitInt(4)); 
            (var newUnderlying#0 := MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocInternal$V, 
                  $LS($LZ), 
                  self#0, 
                  MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ReallocInternal$V, newSize#0), 
                  LitInt(0)); 
              (var dt_update_tmp#0#0 := self#0; 
                (var dt_update#underlying#0#0 := newUnderlying#0; 
                  #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                    MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                    MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))))));

// definition axiom for MutableMapModel.__default.ReallocInternal for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ReallocInternal$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LS($ly), Lit(self#0)) } 
    MutableMapModel.__default.ReallocInternal#canCall(MutableMapModel._default.ReallocInternal$V, Lit(self#0))
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ReallocInternal$V))
           && 
          Lit(MutableMapModel.LinearHashMap.count(Lit(self#0))
               < Div(18446744073709551616, LitInt(8)))
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.ReallocInternal$V, Lit(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && (var newSize#1 := LitInt(Mul(LitInt(128 + MutableMapModel.LinearHashMap.count(Lit(self#0))), LitInt(4))); 
          MutableMapModel.__default.ConstructorFromSize#canCall(MutableMapModel._default.ReallocInternal$V, newSize#1)
             && MutableMapModel.__default.ReallocIterate#canCall(MutableMapModel._default.ReallocInternal$V, 
              Lit(self#0), 
              MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ReallocInternal$V, newSize#1), 
              LitInt(0))
             && (var dt_update_tmp#0#1 := Lit(self#0); 
              MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#1)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#1)))
         && MutableMapModel.__default.ReallocInternal(MutableMapModel._default.ReallocInternal$V, $LS($ly), Lit(self#0))
           == (var newSize#1 := LitInt(Mul(LitInt(128 + MutableMapModel.LinearHashMap.count(Lit(self#0))), LitInt(4))); 
            (var newUnderlying#1 := Lit(MutableMapModel.__default.ReallocIterate(MutableMapModel._default.ReallocInternal$V, 
                    $LS($LZ), 
                    Lit(self#0), 
                    Lit(MutableMapModel.__default.ConstructorFromSize(MutableMapModel._default.ReallocInternal$V, newSize#1)), 
                    LitInt(0))); 
              (var dt_update_tmp#0#1 := Lit(self#0); 
                (var dt_update#underlying#0#1 := newUnderlying#1; 
                  Lit(#MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                      LitInt(MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1)), 
                      Lit(MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1)))))))));

// function declaration for MutableMapModel._default.Realloc
function MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V: Ty, self#0: DatatypeType) : DatatypeType;

function MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.Realloc$V: Ty, self#0: DatatypeType) : bool;

// consequence axiom for MutableMapModel.__default.Realloc
axiom true
   ==> (forall MutableMapModel._default.Realloc$V: Ty, self#0: DatatypeType :: 
    { MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0) } 
    MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.Realloc$V, self#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Realloc$V))
           && 
          MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8))
           && MutableMapModel.__default.Inv(MutableMapModel._default.Realloc$V, self#0))
       ==> MutableMapModel.__default.Inv(MutableMapModel._default.Realloc$V, 
          MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0))
         && Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0)), 
          MutableMapModel.LinearHashMap.contents(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.LinearHashMap.underlying(MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0)))
           < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0))))
             - 2
         && $Is(MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0), 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Realloc$V)));

function MutableMapModel.__default.Realloc#requires(Ty, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.Realloc
axiom (forall MutableMapModel._default.Realloc$V: Ty, self#0: DatatypeType :: 
  { MutableMapModel.__default.Realloc#requires(MutableMapModel._default.Realloc$V, self#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Realloc$V))
     ==> MutableMapModel.__default.Realloc#requires(MutableMapModel._default.Realloc$V, self#0)
       == (MutableMapModel.LinearHashMap.count(self#0)
           < Div(18446744073709551616, LitInt(8))
         && MutableMapModel.__default.Inv(MutableMapModel._default.Realloc$V, self#0)));

// definition axiom for MutableMapModel.__default.Realloc(revealed)
axiom true
   ==> (forall MutableMapModel._default.Realloc$V: Ty, self#0: DatatypeType :: 
    { MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0) } 
    MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.Realloc$V, self#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Realloc$V))
           && 
          MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8))
           && MutableMapModel.__default.Inv(MutableMapModel._default.Realloc$V, self#0))
       ==> MutableMapModel.__default.ReallocInternal#canCall(MutableMapModel._default.Realloc$V, self#0)
         && MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, self#0)
           == (var self'#0 := MutableMapModel.__default.ReallocInternal(MutableMapModel._default.Realloc$V, 
                StartFuel_MutableMapModel._default.ReallocInternal, 
                self#0); 
            self'#0));

// definition axiom for MutableMapModel.__default.Realloc for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Realloc$V: Ty, self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, Lit(self#0)) } 
    MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.Realloc$V, Lit(self#0))
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Realloc$V))
           && 
          Lit(MutableMapModel.LinearHashMap.count(Lit(self#0))
               < Div(18446744073709551616, LitInt(8)))
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.Realloc$V, Lit(self#0))))
       ==> MutableMapModel.__default.ReallocInternal#canCall(MutableMapModel._default.Realloc$V, Lit(self#0))
         && MutableMapModel.__default.Realloc(MutableMapModel._default.Realloc$V, Lit(self#0))
           == (var self'#1 := MutableMapModel.__default.ReallocInternal(MutableMapModel._default.Realloc$V, 
                StartFuel_MutableMapModel._default.ReallocInternal, 
                Lit(self#0)); 
            self'#1));

// function declaration for MutableMapModel._default.InsertAndGetOld
function MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box)
   : DatatypeType;

function MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.InsertAndGetOld$V: Ty, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $LS($ly), self#0, key#0, value#0) } 
  MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $LS($ly), self#0, key#0, value#0)
     == MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, 
      AsFuelBottom($ly), 
      self#0, 
      key#0, 
      value#0) } 
  MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0)
     == MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $LZ, self#0, key#0, value#0));

// consequence axiom for MutableMapModel.__default.InsertAndGetOld
axiom true
   ==> (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0) } 
    MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.InsertAndGetOld$V, self#0, key#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.InsertAndGetOld$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.InsertAndGetOld$V)
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.InsertAndGetOld$V, self#0)
           && MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8)))
       ==> (var self'#0, replaced#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0))): DatatypeType; 
          MutableMapModel.__default.Inv(MutableMapModel._default.InsertAndGetOld$V, self'#0)
             && Map#Equal(MutableMapModel.LinearHashMap.contents(self'#0), 
              Map#Build(MutableMapModel.LinearHashMap.contents(self#0), $Box(key#0), value#0))
             && MutableMapModel.LinearHashMap.count(self'#0)
               == MutableMapModel.LinearHashMap.count(self#0)
                 + (if Options.Option.Some_q(replaced#0) then 0 else 1)
             && (Options.Option.Some_q(replaced#0)
               ==> Maps.__default.MapsTo(Tclass.NativeTypes.uint64(), 
                MutableMapModel._default.InsertAndGetOld$V, 
                MutableMapModel.LinearHashMap.contents(self#0), 
                $Box(key#0), 
                Options.Option.value(replaced#0)))
             && (Options.Option.None_q(replaced#0)
               ==> !Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]))
         && $Is(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0), 
          Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.InsertAndGetOld$V), 
            Tclass.Options.Option(MutableMapModel._default.InsertAndGetOld$V))));

function MutableMapModel.__default.InsertAndGetOld#requires(Ty, LayerType, DatatypeType, int, Box) : bool;

// #requires axiom for MutableMapModel.__default.InsertAndGetOld
axiom (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.InsertAndGetOld#requires(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.InsertAndGetOld$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
       && $IsBox(value#0, MutableMapModel._default.InsertAndGetOld$V)
     ==> MutableMapModel.__default.InsertAndGetOld#requires(MutableMapModel._default.InsertAndGetOld$V, $ly, self#0, key#0, value#0)
       == (MutableMapModel.__default.Inv(MutableMapModel._default.InsertAndGetOld$V, self#0)
         && MutableMapModel.LinearHashMap.count(self#0)
           < Div(18446744073709551616, LitInt(8))));

// definition axiom for MutableMapModel.__default.InsertAndGetOld(revealed)
axiom true
   ==> (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $LS($ly), self#0, key#0, value#0) } 
    MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.InsertAndGetOld$V, self#0, key#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.InsertAndGetOld$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.InsertAndGetOld$V)
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.InsertAndGetOld$V, self#0)
           && MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8)))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && (Div(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))), 
              LitInt(2))
             <= MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.LinearHashMap.underlying(self#0))
           ==> MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.InsertAndGetOld$V, self#0))
         && (var self1#0 := (if Div(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))), 
                  LitInt(2))
                 <= MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.LinearHashMap.underlying(self#0))
               then MutableMapModel.__default.Realloc(MutableMapModel._default.InsertAndGetOld$V, self#0)
               else self#0); 
          MutableMapModel.LinearHashMap.LinearHashMap_q(self1#0)
             && MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.InsertAndGetOld$V, 
              MutableMapModel.LinearHashMap.underlying(self1#0), 
              key#0, 
              value#0)
             && (var underlying'#0, replaced#1 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#0), 
                      key#0, 
                      value#0))): DatatypeType, 
                $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#0), 
                      key#0, 
                      value#0))): DatatypeType; 
              (var dt_update_tmp#0#0 := self1#0; 
                  MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#0)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#0))
                 && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := self1#0; 
                      (var dt_update#underlying#0#0 := underlying'#0; 
                        #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                          MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))); 
                  MutableMapModel.LinearHashMap.LinearHashMap_q(self1#0)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#0)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#0))
                 && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := self1#0; 
                          (var dt_update#underlying#0#0 := underlying'#0; 
                            #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                              MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                              MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))); 
                      (var dt_update#contents#0#0 := Map#Build(MutableMapModel.LinearHashMap.contents(self1#0), $Box(key#0), value#0); 
                        #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#0), 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#1#0), 
                          dt_update#contents#0#0))); 
                  (Options.Option.None_q(replaced#1)
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self1#0))
                     && (!Options.Option.None_q(replaced#1)
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self1#0))
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#0)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#0))))
         && MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, $LS($ly), self#0, key#0, value#0)
           == (var self1#0 := (if Div(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))), 
                    LitInt(2))
                   <= MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.LinearHashMap.underlying(self#0))
                 then MutableMapModel.__default.Realloc(MutableMapModel._default.InsertAndGetOld$V, self#0)
                 else self#0); 
            (var underlying'#0, replaced#1 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#0), 
                      key#0, 
                      value#0))): DatatypeType, 
                $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#0), 
                      key#0, 
                      value#0))): DatatypeType; 
              (var self'#1 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := self1#0; 
                            (var dt_update#underlying#0#0 := underlying'#0; 
                              #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                                MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                                MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))); 
                        (var dt_update#contents#0#0 := Map#Build(MutableMapModel.LinearHashMap.contents(self1#0), $Box(key#0), value#0); 
                          #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#0), 
                            MutableMapModel.LinearHashMap.count(dt_update_tmp#1#0), 
                            dt_update#contents#0#0))); 
                    (var dt_update#count#0#0 := (if Options.Option.None_q(replaced#1)
                           then MutableMapModel.LinearHashMap.count(self1#0) + 1
                           else MutableMapModel.LinearHashMap.count(self1#0)); 
                      #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#2#0), 
                        dt_update#count#0#0, 
                        MutableMapModel.LinearHashMap.contents(dt_update_tmp#2#0)))); 
                #_System._tuple#2._#Make2($Box(self'#1), $Box(replaced#1))))));

// definition axiom for MutableMapModel.__default.InsertAndGetOld for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, 
        $LS($ly), 
        Lit(self#0), 
        LitInt(key#0), 
        value#0) } 
    MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0), LitInt(key#0), value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.InsertAndGetOld$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.InsertAndGetOld$V)
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0)))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(self#0))
               < Div(18446744073709551616, LitInt(8))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (Div(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))), 
              LitInt(2))
             <= LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
           ==> MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0)))
         && (var self1#1 := (if Div(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))), 
                  LitInt(2))
                 <= LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
               then MutableMapModel.__default.Realloc(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0))
               else self#0); 
          MutableMapModel.LinearHashMap.LinearHashMap_q(self1#1)
             && MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.InsertAndGetOld$V, 
              MutableMapModel.LinearHashMap.underlying(self1#1), 
              LitInt(key#0), 
              value#0)
             && (var underlying'#1, replaced#2 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#1), 
                      LitInt(key#0), 
                      value#0))): DatatypeType, 
                $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#1), 
                      LitInt(key#0), 
                      value#0))): DatatypeType; 
              (var dt_update_tmp#0#1 := self1#1; 
                  MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#1)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#1))
                 && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := self1#1; 
                      (var dt_update#underlying#0#1 := underlying'#1; 
                        #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1), 
                          MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1)))); 
                  MutableMapModel.LinearHashMap.LinearHashMap_q(self1#1)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#1)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#1))
                 && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := self1#1; 
                          (var dt_update#underlying#0#1 := underlying'#1; 
                            #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                              MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1), 
                              MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1)))); 
                      (var dt_update#contents#0#1 := Map#Build(MutableMapModel.LinearHashMap.contents(self1#1), $Box(LitInt(key#0)), value#0); 
                        #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#1), 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#1#1), 
                          dt_update#contents#0#1))); 
                  (Options.Option.None_q(replaced#2)
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self1#1))
                     && (!Options.Option.None_q(replaced#2)
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self1#1))
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#1)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#1))))
         && MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, 
            $LS($ly), 
            Lit(self#0), 
            LitInt(key#0), 
            value#0)
           == (var self1#1 := (if Div(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))), 
                    LitInt(2))
                   <= LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
                 then MutableMapModel.__default.Realloc(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0))
                 else self#0); 
            (var underlying'#1, replaced#2 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#1), 
                      LitInt(key#0), 
                      value#0))): DatatypeType, 
                $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#1), 
                      LitInt(key#0), 
                      value#0))): DatatypeType; 
              (var self'#2 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := self1#1; 
                            (var dt_update#underlying#0#1 := underlying'#1; 
                              #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                                MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1), 
                                MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1)))); 
                        (var dt_update#contents#0#1 := Map#Build(MutableMapModel.LinearHashMap.contents(self1#1), $Box(LitInt(key#0)), value#0); 
                          #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#1), 
                            MutableMapModel.LinearHashMap.count(dt_update_tmp#1#1), 
                            dt_update#contents#0#1))); 
                    (var dt_update#count#0#1 := (if Options.Option.None_q(replaced#2)
                           then MutableMapModel.LinearHashMap.count(self1#1) + 1
                           else MutableMapModel.LinearHashMap.count(self1#1)); 
                      #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#2#1), 
                        dt_update#count#0#1, 
                        MutableMapModel.LinearHashMap.contents(dt_update_tmp#2#1)))); 
                #_System._tuple#2._#Make2($Box(self'#2), $Box(replaced#2))))));

// definition axiom for MutableMapModel.__default.InsertAndGetOld for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.InsertAndGetOld$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, 
        $LS($ly), 
        Lit(self#0), 
        LitInt(key#0), 
        Lit(value#0)) } 
    MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.InsertAndGetOld$V, 
          Lit(self#0), 
          LitInt(key#0), 
          Lit(value#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.InsertAndGetOld$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.InsertAndGetOld$V)
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0)))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(self#0))
               < Div(18446744073709551616, LitInt(8))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (Div(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))), 
              LitInt(2))
             <= LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
           ==> MutableMapModel.__default.Realloc#canCall(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0)))
         && (var self1#2 := (if Div(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))), 
                  LitInt(2))
                 <= LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
               then MutableMapModel.__default.Realloc(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0))
               else self#0); 
          MutableMapModel.LinearHashMap.LinearHashMap_q(self1#2)
             && MutableMapModel.__default.FixedSizeInsert#canCall(MutableMapModel._default.InsertAndGetOld$V, 
              MutableMapModel.LinearHashMap.underlying(self1#2), 
              LitInt(key#0), 
              Lit(value#0))
             && (var underlying'#2, replaced#3 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#2), 
                      LitInt(key#0), 
                      Lit(value#0)))): DatatypeType, 
                $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#2), 
                      LitInt(key#0), 
                      Lit(value#0)))): DatatypeType; 
              (var dt_update_tmp#0#2 := self1#2; 
                  MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#2)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#2))
                 && (var dt_update_tmp#1#2 := (var dt_update_tmp#0#2 := self1#2; 
                      (var dt_update#underlying#0#2 := underlying'#2; 
                        #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#2, 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#0#2), 
                          MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#2)))); 
                  MutableMapModel.LinearHashMap.LinearHashMap_q(self1#2)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#2)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#2))
                 && (var dt_update_tmp#2#2 := (var dt_update_tmp#1#2 := (var dt_update_tmp#0#2 := self1#2; 
                          (var dt_update#underlying#0#2 := underlying'#2; 
                            #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#2, 
                              MutableMapModel.LinearHashMap.count(dt_update_tmp#0#2), 
                              MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#2)))); 
                      (var dt_update#contents#0#2 := Map#Build(MutableMapModel.LinearHashMap.contents(self1#2), 
                            $Box(LitInt(key#0)), 
                            Lit(value#0)); 
                        #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#2), 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#1#2), 
                          dt_update#contents#0#2))); 
                  (Options.Option.None_q(replaced#3)
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self1#2))
                     && (!Options.Option.None_q(replaced#3)
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self1#2))
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#2)
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#2))))
         && MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.InsertAndGetOld$V, 
            $LS($ly), 
            Lit(self#0), 
            LitInt(key#0), 
            Lit(value#0))
           == (var self1#2 := (if Div(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))), 
                    LitInt(2))
                   <= LitInt(MutableMapModel.FixedSizeLinearHashMap.count(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
                 then MutableMapModel.__default.Realloc(MutableMapModel._default.InsertAndGetOld$V, Lit(self#0))
                 else self#0); 
            (var underlying'#2, replaced#3 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#2), 
                      LitInt(key#0), 
                      Lit(value#0)))): DatatypeType, 
                $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeInsert(MutableMapModel._default.InsertAndGetOld$V, 
                      StartFuel_MutableMapModel._default.FixedSizeInsert, 
                      MutableMapModel.LinearHashMap.underlying(self1#2), 
                      LitInt(key#0), 
                      Lit(value#0)))): DatatypeType; 
              (var self'#3 := (var dt_update_tmp#2#2 := (var dt_update_tmp#1#2 := (var dt_update_tmp#0#2 := self1#2; 
                            (var dt_update#underlying#0#2 := underlying'#2; 
                              #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#2, 
                                MutableMapModel.LinearHashMap.count(dt_update_tmp#0#2), 
                                MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#2)))); 
                        (var dt_update#contents#0#2 := Map#Build(MutableMapModel.LinearHashMap.contents(self1#2), 
                              $Box(LitInt(key#0)), 
                              Lit(value#0)); 
                          #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#2), 
                            MutableMapModel.LinearHashMap.count(dt_update_tmp#1#2), 
                            dt_update#contents#0#2))); 
                    (var dt_update#count#0#2 := (if Options.Option.None_q(replaced#3)
                           then MutableMapModel.LinearHashMap.count(self1#2) + 1
                           else MutableMapModel.LinearHashMap.count(self1#2)); 
                      #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#2#2), 
                        dt_update#count#0#2, 
                        MutableMapModel.LinearHashMap.contents(dt_update_tmp#2#2)))); 
                #_System._tuple#2._#Make2($Box(self'#3), $Box(replaced#3))))));

// function declaration for MutableMapModel._default.Insert
function MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box)
   : DatatypeType;

function MutableMapModel.__default.Insert#canCall(MutableMapModel._default.Insert$V: Ty, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.Insert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LS($ly), self#0, key#0, value#0) } 
  MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LS($ly), self#0, key#0, value#0)
     == MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.Insert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, AsFuelBottom($ly), self#0, key#0, value#0) } 
  MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0)
     == MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LZ, self#0, key#0, value#0));

// consequence axiom for MutableMapModel.__default.Insert
axiom true
   ==> (forall MutableMapModel._default.Insert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0) } 
    MutableMapModel.__default.Insert#canCall(MutableMapModel._default.Insert$V, self#0, key#0, value#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Insert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.Insert$V)
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.Insert$V, self#0)
           && MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8)))
       ==> MutableMapModel.__default.Inv(MutableMapModel._default.Insert$V, 
          MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0))
         && Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0)), 
          Map#Build(MutableMapModel.LinearHashMap.contents(self#0), $Box(key#0), value#0))
         && (MutableMapModel.LinearHashMap.count(MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0))
             == MutableMapModel.LinearHashMap.count(self#0)
           || MutableMapModel.LinearHashMap.count(MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0))
             == MutableMapModel.LinearHashMap.count(self#0) + 1)
         && $Is(MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0), 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Insert$V)));

function MutableMapModel.__default.Insert#requires(Ty, LayerType, DatatypeType, int, Box) : bool;

// #requires axiom for MutableMapModel.__default.Insert
axiom (forall MutableMapModel._default.Insert$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int, 
    value#0: Box :: 
  { MutableMapModel.__default.Insert#requires(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Insert$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
       && $IsBox(value#0, MutableMapModel._default.Insert$V)
     ==> MutableMapModel.__default.Insert#requires(MutableMapModel._default.Insert$V, $ly, self#0, key#0, value#0)
       == (MutableMapModel.__default.Inv(MutableMapModel._default.Insert$V, self#0)
         && MutableMapModel.LinearHashMap.count(self#0)
           < Div(18446744073709551616, LitInt(8))));

// definition axiom for MutableMapModel.__default.Insert(revealed)
axiom true
   ==> (forall MutableMapModel._default.Insert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    { MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LS($ly), self#0, key#0, value#0) } 
    MutableMapModel.__default.Insert#canCall(MutableMapModel._default.Insert$V, self#0, key#0, value#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Insert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.Insert$V)
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.Insert$V, self#0)
           && MutableMapModel.LinearHashMap.count(self#0)
             < Div(18446744073709551616, LitInt(8)))
       ==> MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.Insert$V, self#0, key#0, value#0)
         && _System.Tuple2.___hMake2_q(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.Insert$V, 
            StartFuel_MutableMapModel._default.InsertAndGetOld, 
            self#0, 
            key#0, 
            value#0))
         && MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LS($ly), self#0, key#0, value#0)
           == $Unbox(_System.Tuple2._0(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.Insert$V, 
                StartFuel_MutableMapModel._default.InsertAndGetOld, 
                self#0, 
                key#0, 
                value#0))): DatatypeType);

// definition axiom for MutableMapModel.__default.Insert for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Insert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LS($ly), Lit(self#0), LitInt(key#0), value#0) } 
    MutableMapModel.__default.Insert#canCall(MutableMapModel._default.Insert$V, Lit(self#0), LitInt(key#0), value#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Insert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.Insert$V)
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.Insert$V, Lit(self#0)))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(self#0))
               < Div(18446744073709551616, LitInt(8))))
       ==> MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.Insert$V, Lit(self#0), LitInt(key#0), value#0)
         && _System.Tuple2.___hMake2_q(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.Insert$V, 
            StartFuel_MutableMapModel._default.InsertAndGetOld, 
            Lit(self#0), 
            LitInt(key#0), 
            value#0))
         && MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, $LS($ly), Lit(self#0), LitInt(key#0), value#0)
           == $Unbox(_System.Tuple2._0(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.Insert$V, 
                StartFuel_MutableMapModel._default.InsertAndGetOld, 
                Lit(self#0), 
                LitInt(key#0), 
                value#0))): DatatypeType);

// definition axiom for MutableMapModel.__default.Insert for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Insert$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, 
        $LS($ly), 
        Lit(self#0), 
        LitInt(key#0), 
        Lit(value#0)) } 
    MutableMapModel.__default.Insert#canCall(MutableMapModel._default.Insert$V, Lit(self#0), LitInt(key#0), Lit(value#0))
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Insert$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && $IsBox(value#0, MutableMapModel._default.Insert$V)
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.Insert$V, Lit(self#0)))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(self#0))
               < Div(18446744073709551616, LitInt(8))))
       ==> MutableMapModel.__default.InsertAndGetOld#canCall(MutableMapModel._default.Insert$V, Lit(self#0), LitInt(key#0), Lit(value#0))
         && _System.Tuple2.___hMake2_q(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.Insert$V, 
            StartFuel_MutableMapModel._default.InsertAndGetOld, 
            Lit(self#0), 
            LitInt(key#0), 
            Lit(value#0)))
         && MutableMapModel.__default.Insert(MutableMapModel._default.Insert$V, 
            $LS($ly), 
            Lit(self#0), 
            LitInt(key#0), 
            Lit(value#0))
           == $Unbox(_System.Tuple2._0(MutableMapModel.__default.InsertAndGetOld(MutableMapModel._default.Insert$V, 
                StartFuel_MutableMapModel._default.InsertAndGetOld, 
                Lit(self#0), 
                LitInt(key#0), 
                Lit(value#0)))): DatatypeType);

// function declaration for MutableMapModel._default.RemoveInternal
function MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V: Ty, self#0: DatatypeType, key#0: int)
   : DatatypeType;

function MutableMapModel.__default.RemoveInternal#canCall(MutableMapModel._default.RemoveInternal$V: Ty, self#0: DatatypeType, key#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.RemoveInternal
axiom true
   ==> (forall MutableMapModel._default.RemoveInternal$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, self#0, key#0) } 
    MutableMapModel.__default.RemoveInternal#canCall(MutableMapModel._default.RemoveInternal$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveInternal$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.RemoveInternal$V, self#0))
       ==> (var self'#0, removed#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, self#0, key#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, self#0, key#0))): DatatypeType; 
          _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMapModel.LinearHashMap.underlying(self'#0)), $Box(removed#0)), 
              MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                StartFuel_MutableMapModel._default.FixedSizeRemove, 
                MutableMapModel.LinearHashMap.underlying(self#0), 
                key#0))
             && MutableMapModel.__default.FixedSizeInv(MutableMapModel._default.RemoveInternal$V, 
              MutableMapModel.LinearHashMap.underlying(self'#0))
             && Map#Equal(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self'#0)), 
              (if Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self#0)))[$Box(key#0)]
                 then Map#Build(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self#0)), 
                  $Box(key#0), 
                  $Box(Lit(#Options.Option.None())))
                 else MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self#0))))
             && Options.Option#Equal(removed#0, 
              (if Map#Domain(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self#0)))[$Box(key#0)]
                   && Options.Option.Some_q($Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self#0)))[$Box(key#0)]): DatatypeType)
                 then #Options.Option.Some(Options.Option.value($Unbox(Map#Elements(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMapModel.LinearHashMap.underlying(self#0)))[$Box(key#0)]): DatatypeType))
                 else #Options.Option.None()))
             && MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.LinearHashMap.underlying(self'#0))
               == MutableMapModel.FixedSizeLinearHashMap.count(MutableMapModel.LinearHashMap.underlying(self#0)))
         && $Is(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, self#0, key#0), 
          Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveInternal$V), 
            Tclass.Options.Option(MutableMapModel._default.RemoveInternal$V))));

function MutableMapModel.__default.RemoveInternal#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.RemoveInternal
axiom (forall MutableMapModel._default.RemoveInternal$V: Ty, self#0: DatatypeType, key#0: int :: 
  { MutableMapModel.__default.RemoveInternal#requires(MutableMapModel._default.RemoveInternal$V, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveInternal$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.RemoveInternal#requires(MutableMapModel._default.RemoveInternal$V, self#0, key#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.RemoveInternal$V, self#0));

// definition axiom for MutableMapModel.__default.RemoveInternal(revealed)
axiom true
   ==> (forall MutableMapModel._default.RemoveInternal$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, self#0, key#0) } 
    MutableMapModel.__default.RemoveInternal#canCall(MutableMapModel._default.RemoveInternal$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveInternal$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.RemoveInternal$V, self#0))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.__default.FixedSizeRemove#canCall(MutableMapModel._default.RemoveInternal$V, 
          MutableMapModel.LinearHashMap.underlying(self#0), 
          key#0)
         && (var underlying'#0, removed#1 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                  StartFuel_MutableMapModel._default.FixedSizeRemove, 
                  MutableMapModel.LinearHashMap.underlying(self#0), 
                  key#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                  StartFuel_MutableMapModel._default.FixedSizeRemove, 
                  MutableMapModel.LinearHashMap.underlying(self#0), 
                  key#0))): DatatypeType; 
          (var dt_update_tmp#0#0 := self#0; 
              MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#0)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#0))
             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := self#0; 
                  (var dt_update#underlying#0#0 := underlying'#0; 
                    #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                      MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                      MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))); 
              (forall k#0: int :: 
                  { Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$Box(k#0)] } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(k#0)] } 
                  LitInt(0) <= k#0 && k#0 < 18446744073709551616
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(k#0)]
                           && k#0 != key#0
                         ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#0)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#0))
             && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := self#0; 
                      (var dt_update#underlying#0#0 := underlying'#0; 
                        #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                          MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))); 
                  (var dt_update#contents#0#0 := Map#Glue((lambda $w#1: Box :: 
                          LitInt(0) <= $Unbox($w#1): int
                             && $Unbox($w#1): int < 18446744073709551616
                             && 
                            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$w#1]
                             && $Unbox($w#1): int != key#0), 
                        (lambda $w#1: Box :: 
                          Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$w#1]), 
                        TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.RemoveInternal$V)); 
                    #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#0), 
                      MutableMapModel.LinearHashMap.count(dt_update_tmp#1#0), 
                      dt_update#contents#0#0))); 
              (Options.Option.Some_q(removed#1)
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0))
                 && (!Options.Option.Some_q(removed#1)
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#0)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#0)))
         && MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, self#0, key#0)
           == (var underlying'#0, removed#1 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                    StartFuel_MutableMapModel._default.FixedSizeRemove, 
                    MutableMapModel.LinearHashMap.underlying(self#0), 
                    key#0))): DatatypeType, 
              $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                    StartFuel_MutableMapModel._default.FixedSizeRemove, 
                    MutableMapModel.LinearHashMap.underlying(self#0), 
                    key#0))): DatatypeType; 
            (var self'#1 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := self#0; 
                          (var dt_update#underlying#0#0 := underlying'#0; 
                            #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#0, 
                              MutableMapModel.LinearHashMap.count(dt_update_tmp#0#0), 
                              MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#0)))); 
                      (var dt_update#contents#0#0 := Map#Glue((lambda $w#3: Box :: 
                              LitInt(0) <= $Unbox($w#3): int
                                 && $Unbox($w#3): int < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$w#3]
                                 && $Unbox($w#3): int != key#0), 
                            (lambda $w#3: Box :: 
                              Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$w#3]), 
                            TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.RemoveInternal$V)); 
                        #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#0), 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#1#0), 
                          dt_update#contents#0#0))); 
                  (var dt_update#count#0#0 := (if Options.Option.Some_q(removed#1)
                         then MutableMapModel.LinearHashMap.count(self#0) - 1
                         else MutableMapModel.LinearHashMap.count(self#0)); 
                    #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#2#0), 
                      dt_update#count#0#0, 
                      MutableMapModel.LinearHashMap.contents(dt_update_tmp#2#0)))); 
              #_System._tuple#2._#Make2($Box(self'#1), $Box(removed#1)))));

// definition axiom for MutableMapModel.__default.RemoveInternal for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.RemoveInternal$V: Ty, self#0: DatatypeType, key#0: int :: 
    {:weight 3} { MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.RemoveInternal#canCall(MutableMapModel._default.RemoveInternal$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveInternal$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.RemoveInternal$V, Lit(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.FixedSizeRemove#canCall(MutableMapModel._default.RemoveInternal$V, 
          Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
          LitInt(key#0))
         && (var underlying'#1, removed#2 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                  StartFuel_MutableMapModel._default.FixedSizeRemove, 
                  Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                  LitInt(key#0)))): DatatypeType, 
            $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                  StartFuel_MutableMapModel._default.FixedSizeRemove, 
                  Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                  LitInt(key#0)))): DatatypeType; 
          (var dt_update_tmp#0#1 := Lit(self#0); 
              MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#1)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#0#1))
             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(self#0); 
                  (var dt_update#underlying#0#1 := underlying'#1; 
                    #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                      LitInt(MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1)), 
                      Lit(MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1))))); 
              (forall k#0: int :: 
                  { Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$Box(k#0)] } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(k#0)] } 
                  LitInt(0) <= k#0 && k#0 < 18446744073709551616
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(self#0)))[$Box(k#0)]
                           && k#0 != key#0
                         ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#1)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#1#1))
             && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(self#0); 
                      (var dt_update#underlying#0#1 := underlying'#1; 
                        #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                          LitInt(MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1)), 
                          Lit(MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1))))); 
                  (var dt_update#contents#0#1 := Map#Glue((lambda $w#5: Box :: 
                          LitInt(0) <= $Unbox($w#5): int
                             && $Unbox($w#5): int < 18446744073709551616
                             && 
                            Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(self#0)))[$w#5]
                             && $Unbox($w#5): int != key#0), 
                        (lambda $w#5: Box :: 
                          Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))[$w#5]), 
                        TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.RemoveInternal$V)); 
                    #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#1), 
                      MutableMapModel.LinearHashMap.count(dt_update_tmp#1#1), 
                      dt_update#contents#0#1))); 
              (Options.Option.Some_q(removed#2)
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0)))
                 && (!Options.Option.Some_q(removed#2)
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0)))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#1)
                 && MutableMapModel.LinearHashMap.LinearHashMap_q(dt_update_tmp#2#1)))
         && MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveInternal$V, Lit(self#0), LitInt(key#0))
           == (var underlying'#1, removed#2 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                    StartFuel_MutableMapModel._default.FixedSizeRemove, 
                    Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                    LitInt(key#0)))): DatatypeType, 
              $Unbox(_System.Tuple2._1(MutableMapModel.__default.FixedSizeRemove(MutableMapModel._default.RemoveInternal$V, 
                    StartFuel_MutableMapModel._default.FixedSizeRemove, 
                    Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                    LitInt(key#0)))): DatatypeType; 
            (var self'#2 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(self#0); 
                          (var dt_update#underlying#0#1 := underlying'#1; 
                            #MutableMapModel.LinearHashMap.LinearHashMap(dt_update#underlying#0#1, 
                              LitInt(MutableMapModel.LinearHashMap.count(dt_update_tmp#0#1)), 
                              Lit(MutableMapModel.LinearHashMap.contents(dt_update_tmp#0#1))))); 
                      (var dt_update#contents#0#1 := Map#Glue((lambda $w#7: Box :: 
                              LitInt(0) <= $Unbox($w#7): int
                                 && $Unbox($w#7): int < 18446744073709551616
                                 && 
                                Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(self#0)))[$w#7]
                                 && $Unbox($w#7): int != key#0), 
                            (lambda $w#7: Box :: 
                              Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))))[$w#7]), 
                            TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.RemoveInternal$V)); 
                        #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#1#1), 
                          MutableMapModel.LinearHashMap.count(dt_update_tmp#1#1), 
                          dt_update#contents#0#1))); 
                  (var dt_update#count#0#1 := (if Options.Option.Some_q(removed#2)
                         then MutableMapModel.LinearHashMap.count(Lit(self#0)) - 1
                         else MutableMapModel.LinearHashMap.count(Lit(self#0))); 
                    #MutableMapModel.LinearHashMap.LinearHashMap(MutableMapModel.LinearHashMap.underlying(dt_update_tmp#2#1), 
                      dt_update#count#0#1, 
                      MutableMapModel.LinearHashMap.contents(dt_update_tmp#2#1)))); 
              #_System._tuple#2._#Make2($Box(self'#2), $Box(removed#2)))));

// function declaration for MutableMapModel._default.RemoveAndGet
function MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V: Ty, self#0: DatatypeType, key#0: int)
   : DatatypeType;

function MutableMapModel.__default.RemoveAndGet#canCall(MutableMapModel._default.RemoveAndGet$V: Ty, self#0: DatatypeType, key#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.RemoveAndGet
axiom true
   ==> (forall MutableMapModel._default.RemoveAndGet$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, self#0, key#0) } 
    MutableMapModel.__default.RemoveAndGet#canCall(MutableMapModel._default.RemoveAndGet$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveAndGet$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.RemoveAndGet$V, self#0))
       ==> (var self'#0, removed#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, self#0, key#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, self#0, key#0))): DatatypeType; 
          MutableMapModel.__default.Inv(MutableMapModel._default.RemoveAndGet$V, self'#0)
             && Map#Equal(MutableMapModel.LinearHashMap.contents(self'#0), 
              (if Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
                 then Map#Glue((lambda $w#0: Box :: 
                    LitInt(0) <= $Unbox($w#0): int
                       && $Unbox($w#0): int < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$w#0]
                       && $Unbox($w#0): int != key#0), 
                  (lambda $w#0: Box :: 
                    Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$w#0]), 
                  TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.RemoveAndGet$V))
                 else MutableMapModel.LinearHashMap.contents(self#0)))
             && Options.Option#Equal(removed#0, 
              (if Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
                 then #Options.Option.Some(Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)])
                 else #Options.Option.None())))
         && $Is(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, self#0, key#0), 
          Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveAndGet$V), 
            Tclass.Options.Option(MutableMapModel._default.RemoveAndGet$V))));

function MutableMapModel.__default.RemoveAndGet#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.RemoveAndGet
axiom (forall MutableMapModel._default.RemoveAndGet$V: Ty, self#0: DatatypeType, key#0: int :: 
  { MutableMapModel.__default.RemoveAndGet#requires(MutableMapModel._default.RemoveAndGet$V, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveAndGet$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.RemoveAndGet#requires(MutableMapModel._default.RemoveAndGet$V, self#0, key#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.RemoveAndGet$V, self#0));

// definition axiom for MutableMapModel.__default.RemoveAndGet(revealed)
axiom true
   ==> (forall MutableMapModel._default.RemoveAndGet$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, self#0, key#0) } 
    MutableMapModel.__default.RemoveAndGet#canCall(MutableMapModel._default.RemoveAndGet$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveAndGet$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.RemoveAndGet$V, self#0))
       ==> MutableMapModel.__default.RemoveInternal#canCall(MutableMapModel._default.RemoveAndGet$V, self#0, key#0)
         && MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, self#0, key#0)
           == (var self'#1, removed#1 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveAndGet$V, self#0, key#0))): DatatypeType, 
              $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveAndGet$V, self#0, key#0))): DatatypeType; 
            #_System._tuple#2._#Make2($Box(self'#1), $Box(removed#1))));

// definition axiom for MutableMapModel.__default.RemoveAndGet for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.RemoveAndGet$V: Ty, self#0: DatatypeType, key#0: int :: 
    {:weight 3} { MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.RemoveAndGet#canCall(MutableMapModel._default.RemoveAndGet$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.RemoveAndGet$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.RemoveAndGet$V, Lit(self#0))))
       ==> MutableMapModel.__default.RemoveInternal#canCall(MutableMapModel._default.RemoveAndGet$V, Lit(self#0), LitInt(key#0))
         && MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.RemoveAndGet$V, Lit(self#0), LitInt(key#0))
           == (var self'#2, removed#2 := $Unbox(_System.Tuple2._0(Lit(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveAndGet$V, Lit(self#0), LitInt(key#0))))): DatatypeType, 
              $Unbox(_System.Tuple2._1(Lit(MutableMapModel.__default.RemoveInternal(MutableMapModel._default.RemoveAndGet$V, Lit(self#0), LitInt(key#0))))): DatatypeType; 
            #_System._tuple#2._#Make2($Box(self'#2), $Box(removed#2))));

// function declaration for MutableMapModel._default.Remove
function MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V: Ty, self#0: DatatypeType, key#0: int)
   : DatatypeType;

function MutableMapModel.__default.Remove#canCall(MutableMapModel._default.Remove$V: Ty, self#0: DatatypeType, key#0: int) : bool;

// consequence axiom for MutableMapModel.__default.Remove
axiom true
   ==> (forall MutableMapModel._default.Remove$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, self#0, key#0) } 
    MutableMapModel.__default.Remove#canCall(MutableMapModel._default.Remove$V, self#0, key#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Remove$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.Remove$V, self#0))
       ==> MutableMapModel.__default.Inv(MutableMapModel._default.Remove$V, 
          MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, self#0, key#0))
         && Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, self#0, key#0)), 
          (if Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
             then Map#Glue((lambda $w#0: Box :: 
                LitInt(0) <= $Unbox($w#0): int
                   && $Unbox($w#0): int < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$w#0]
                   && $Unbox($w#0): int != key#0), 
              (lambda $w#0: Box :: 
                Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$w#0]), 
              TMap(Tclass.NativeTypes.uint64(), MutableMapModel._default.Remove$V))
             else MutableMapModel.LinearHashMap.contents(self#0)))
         && $Is(MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, self#0, key#0), 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Remove$V)));

function MutableMapModel.__default.Remove#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.Remove
axiom (forall MutableMapModel._default.Remove$V: Ty, self#0: DatatypeType, key#0: int :: 
  { MutableMapModel.__default.Remove#requires(MutableMapModel._default.Remove$V, self#0, key#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Remove$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.Remove#requires(MutableMapModel._default.Remove$V, self#0, key#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.Remove$V, self#0));

// definition axiom for MutableMapModel.__default.Remove(revealed)
axiom true
   ==> (forall MutableMapModel._default.Remove$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, self#0, key#0) } 
    MutableMapModel.__default.Remove#canCall(MutableMapModel._default.Remove$V, self#0, key#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Remove$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.Remove$V, self#0))
       ==> MutableMapModel.__default.RemoveAndGet#canCall(MutableMapModel._default.Remove$V, self#0, key#0)
         && _System.Tuple2.___hMake2_q(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.Remove$V, self#0, key#0))
         && MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, self#0, key#0)
           == $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.Remove$V, self#0, key#0))): DatatypeType);

// definition axiom for MutableMapModel.__default.Remove for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Remove$V: Ty, self#0: DatatypeType, key#0: int :: 
    {:weight 3} { MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.Remove#canCall(MutableMapModel._default.Remove$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Remove$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.Remove$V, Lit(self#0))))
       ==> MutableMapModel.__default.RemoveAndGet#canCall(MutableMapModel._default.Remove$V, Lit(self#0), LitInt(key#0))
         && _System.Tuple2.___hMake2_q(Lit(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.Remove$V, Lit(self#0), LitInt(key#0))))
         && MutableMapModel.__default.Remove(MutableMapModel._default.Remove$V, Lit(self#0), LitInt(key#0))
           == Lit($Unbox(_System.Tuple2._0(Lit(MutableMapModel.__default.RemoveAndGet(MutableMapModel._default.Remove$V, Lit(self#0), LitInt(key#0))))): DatatypeType));

// function declaration for MutableMapModel._default.Get
function MutableMapModel.__default.Get(MutableMapModel._default.Get$V: Ty, self#0: DatatypeType, key#0: int)
   : DatatypeType;

function MutableMapModel.__default.Get#canCall(MutableMapModel._default.Get$V: Ty, self#0: DatatypeType, key#0: int) : bool;

// consequence axiom for MutableMapModel.__default.Get
axiom true
   ==> (forall MutableMapModel._default.Get$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0) } 
    MutableMapModel.__default.Get#canCall(MutableMapModel._default.Get$V, self#0, key#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Get$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.Get$V, self#0))
       ==> (if Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
           then Options.Option#Equal(MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0), 
            #Options.Option.Some(Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]))
           else Options.Option.None_q(MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0)))
         && (Options.Option.Some_q(MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0))
           <==> Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)])
         && $Is(MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0), 
          Tclass.Options.Option(MutableMapModel._default.Get$V)));

function MutableMapModel.__default.Get#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.Get
axiom (forall MutableMapModel._default.Get$V: Ty, self#0: DatatypeType, key#0: int :: 
  { MutableMapModel.__default.Get#requires(MutableMapModel._default.Get$V, self#0, key#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Get$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.Get#requires(MutableMapModel._default.Get$V, self#0, key#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.Get$V, self#0));

// definition axiom for MutableMapModel.__default.Get(revealed)
axiom true
   ==> (forall MutableMapModel._default.Get$V: Ty, self#0: DatatypeType, key#0: int :: 
    { MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0) } 
    MutableMapModel.__default.Get#canCall(MutableMapModel._default.Get$V, self#0, key#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Get$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.Get$V, self#0))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.__default.FixedSizeGet#canCall(MutableMapModel._default.Get$V, 
          MutableMapModel.LinearHashMap.underlying(self#0), 
          key#0)
         && MutableMapModel.__default.Get(MutableMapModel._default.Get$V, self#0, key#0)
           == (var found#0 := MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.Get$V, 
                StartFuel_MutableMapModel._default.FixedSizeGet, 
                MutableMapModel.LinearHashMap.underlying(self#0), 
                key#0); 
            found#0));

// definition axiom for MutableMapModel.__default.Get for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.Get$V: Ty, self#0: DatatypeType, key#0: int :: 
    {:weight 3} { MutableMapModel.__default.Get(MutableMapModel._default.Get$V, Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.Get#canCall(MutableMapModel._default.Get$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.Get$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.Get$V, Lit(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.FixedSizeGet#canCall(MutableMapModel._default.Get$V, 
          Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
          LitInt(key#0))
         && MutableMapModel.__default.Get(MutableMapModel._default.Get$V, Lit(self#0), LitInt(key#0))
           == (var found#1 := MutableMapModel.__default.FixedSizeGet(MutableMapModel._default.Get$V, 
                StartFuel_MutableMapModel._default.FixedSizeGet, 
                Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                LitInt(key#0)); 
            found#1));

// function declaration for MutableMapModel._default.NextExplainedByI
function MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.NextExplainedByI$V: Ty, 
    self#0: DatatypeType, 
    i#0: int, 
    output#0: DatatypeType)
   : bool;

function MutableMapModel.__default.NextExplainedByI#canCall(MutableMapModel._default.NextExplainedByI$V: Ty, 
    self#0: DatatypeType, 
    i#0: int, 
    output#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.NextExplainedByI
axiom true
   ==> (forall MutableMapModel._default.NextExplainedByI$V: Ty, 
      self#0: DatatypeType, 
      i#0: int, 
      output#0: DatatypeType :: 
    { MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0) } 
    MutableMapModel.__default.NextExplainedByI#canCall(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.NextExplainedByI$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $Is(output#0, 
            Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.NextExplainedByI$V)))
       ==> true);

function MutableMapModel.__default.NextExplainedByI#requires(Ty, DatatypeType, int, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.NextExplainedByI
axiom (forall MutableMapModel._default.NextExplainedByI$V: Ty, 
    self#0: DatatypeType, 
    i#0: int, 
    output#0: DatatypeType :: 
  { MutableMapModel.__default.NextExplainedByI#requires(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.NextExplainedByI$V))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && $Is(output#0, 
        Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.NextExplainedByI$V))
     ==> MutableMapModel.__default.NextExplainedByI#requires(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0)
       == true);

// definition axiom for MutableMapModel.__default.NextExplainedByI(revealed)
axiom true
   ==> (forall MutableMapModel._default.NextExplainedByI$V: Ty, 
      self#0: DatatypeType, 
      i#0: int, 
      output#0: DatatypeType :: 
    { MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0) } 
    MutableMapModel.__default.NextExplainedByI#canCall(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.NextExplainedByI$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $Is(output#0, 
            Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.NextExplainedByI$V)))
       ==> (MutableMapModel.IteratorOutput.Next_q(output#0)
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && (i#0
                 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      i#0)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
                 && MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        i#0)): DatatypeType)
                   == MutableMapModel.IteratorOutput.key(output#0)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))))
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && (i#0
                 < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      i#0)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
                 && MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        i#0)): DatatypeType)
                   == MutableMapModel.IteratorOutput.key(output#0)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && 
            i#0
               < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                  i#0)): DatatypeType)
             && MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               == MutableMapModel.IteratorOutput.key(output#0)
             && MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               == MutableMapModel.IteratorOutput.value(output#0)
           ==> 
          MutableMapModel.IteratorOutput.Done_q(output#0)
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
         && MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.NextExplainedByI$V, self#0, i#0, output#0)
           == ((MutableMapModel.IteratorOutput.Next_q(output#0)
               ==> i#0
                   < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      i#0)): DatatypeType)
                 && MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        i#0)): DatatypeType)
                   == MutableMapModel.IteratorOutput.key(output#0)
                 && MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        i#0)): DatatypeType)
                   == MutableMapModel.IteratorOutput.value(output#0))
             && (MutableMapModel.IteratorOutput.Done_q(output#0)
               ==> i#0
                 == Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))));

// definition axiom for MutableMapModel.__default.NextExplainedByI for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.NextExplainedByI$V: Ty, 
      self#0: DatatypeType, 
      i#0: int, 
      output#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.NextExplainedByI$V, 
        Lit(self#0), 
        LitInt(i#0), 
        Lit(output#0)) } 
    MutableMapModel.__default.NextExplainedByI#canCall(MutableMapModel._default.NextExplainedByI$V, 
          Lit(self#0), 
          LitInt(i#0), 
          Lit(output#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.NextExplainedByI$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && $Is(output#0, 
            Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.NextExplainedByI$V)))
       ==> (Lit(MutableMapModel.IteratorOutput.Next_q(Lit(output#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (i#0
                 < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                      LitInt(i#0))): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
                 && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        LitInt(i#0))): DatatypeType)
                   == LitInt(MutableMapModel.IteratorOutput.key(Lit(output#0)))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (i#0
                 < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                      LitInt(i#0))): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
                 && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        LitInt(i#0))): DatatypeType)
                   == LitInt(MutableMapModel.IteratorOutput.key(Lit(output#0)))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && 
            i#0
               < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                  LitInt(i#0))): DatatypeType)
             && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               == LitInt(MutableMapModel.IteratorOutput.key(Lit(output#0)))
             && MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               == Lit(MutableMapModel.IteratorOutput.value(Lit(output#0)))
           ==> 
          Lit(MutableMapModel.IteratorOutput.Done_q(Lit(output#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
         && MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.NextExplainedByI$V, 
            Lit(self#0), 
            LitInt(i#0), 
            Lit(output#0))
           == ((MutableMapModel.IteratorOutput.Next_q(Lit(output#0))
               ==> i#0
                   < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                      LitInt(i#0))): DatatypeType)
                 && MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        LitInt(i#0))): DatatypeType)
                   == LitInt(MutableMapModel.IteratorOutput.key(Lit(output#0)))
                 && MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        LitInt(i#0))): DatatypeType)
                   == Lit(MutableMapModel.IteratorOutput.value(Lit(output#0))))
             && (MutableMapModel.IteratorOutput.Done_q(Lit(output#0))
               ==> LitInt(i#0)
                 == Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))))));

// function declaration for MutableMapModel._default.ValidI
function MutableMapModel.__default.ValidI(MutableMapModel._default.ValidI$V: Ty, self#0: DatatypeType, it#0: DatatypeType)
   : bool;

function MutableMapModel.__default.ValidI#canCall(MutableMapModel._default.ValidI$V: Ty, self#0: DatatypeType, it#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.ValidI
axiom true
   ==> (forall MutableMapModel._default.ValidI$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
    { MutableMapModel.__default.ValidI(MutableMapModel._default.ValidI$V, self#0, it#0) } 
    MutableMapModel.__default.ValidI#canCall(MutableMapModel._default.ValidI$V, self#0, it#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ValidI$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.ValidI$V)))
       ==> true);

function MutableMapModel.__default.ValidI#requires(Ty, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.ValidI
axiom (forall MutableMapModel._default.ValidI$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
  { MutableMapModel.__default.ValidI#requires(MutableMapModel._default.ValidI$V, self#0, it#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ValidI$V))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.ValidI$V))
     ==> MutableMapModel.__default.ValidI#requires(MutableMapModel._default.ValidI$V, self#0, it#0)
       == true);

// definition axiom for MutableMapModel.__default.ValidI(revealed)
axiom true
   ==> (forall MutableMapModel._default.ValidI$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
    { MutableMapModel.__default.ValidI(MutableMapModel._default.ValidI$V, self#0, it#0) } 
    MutableMapModel.__default.ValidI#canCall(MutableMapModel._default.ValidI$V, self#0, it#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ValidI$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.ValidI$V)))
       ==> (Lit(true)
           ==> MutableMapModel.Iterator.Iterator_q(it#0)
             && (LitInt(0) <= MutableMapModel.Iterator.i(it#0)
               ==> MutableMapModel.Iterator.Iterator_q(it#0)
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))))
         && MutableMapModel.__default.ValidI(MutableMapModel._default.ValidI$V, self#0, it#0)
           == (true
             && 
            LitInt(0) <= MutableMapModel.Iterator.i(it#0)
             && MutableMapModel.Iterator.i(it#0)
               <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))));

// definition axiom for MutableMapModel.__default.ValidI for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.ValidI$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.ValidI(MutableMapModel._default.ValidI$V, Lit(self#0), Lit(it#0)) } 
    MutableMapModel.__default.ValidI#canCall(MutableMapModel._default.ValidI$V, Lit(self#0), Lit(it#0))
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.ValidI$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.ValidI$V)))
       ==> (Lit(true)
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && (LitInt(0) <= LitInt(MutableMapModel.Iterator.i(Lit(it#0)))
               ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
         && MutableMapModel.__default.ValidI(MutableMapModel._default.ValidI$V, Lit(self#0), Lit(it#0))
           == (true
             && 
            LitInt(0) <= LitInt(MutableMapModel.Iterator.i(Lit(it#0)))
             && LitInt(MutableMapModel.Iterator.i(Lit(it#0)))
               <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))));

// function declaration for MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex
function MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V: Ty, 
    self#0: DatatypeType, 
    s#0: Set Box, 
    i#0: int)
   : bool;

function MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#canCall(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V: Ty, 
    self#0: DatatypeType, 
    s#0: Set Box, 
    i#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex
axiom true
   ==> (forall MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V: Ty, 
      self#0: DatatypeType, 
      s#0: Set Box, 
      i#0: int :: 
    { MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
        self#0, 
        s#0, 
        i#0) } 
    MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#canCall(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
          self#0, 
          s#0, 
          i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V))
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> true);

function MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#requires(Ty, DatatypeType, Set Box, int) : bool;

// #requires axiom for MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex
axiom (forall MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V: Ty, 
    self#0: DatatypeType, 
    s#0: Set Box, 
    i#0: int :: 
  { MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#requires(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
      self#0, 
      s#0, 
      i#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V))
       && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#requires(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
        self#0, 
        s#0, 
        i#0)
       == (LitInt(0) <= i#0
         && i#0
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))));

// definition axiom for MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(revealed)
axiom true
   ==> (forall MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V: Ty, 
      self#0: DatatypeType, 
      s#0: Set Box, 
      i#0: int :: 
    { MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
        self#0, 
        s#0, 
        i#0) } 
    MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#canCall(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
          self#0, 
          s#0, 
          i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V))
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> (forall key#0: int :: 
          { s#0[$Box(key#0)] } 
          LitInt(0) <= key#0 && key#0 < 18446744073709551616
             ==> 
            s#0[$Box(key#0)]
             ==> (forall j#0: int :: 
              { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    j#0)): DatatypeType } 
              LitInt(0) <= j#0 && j#0 < i#0
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                   && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
                   && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                          j#0)): DatatypeType)
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                       && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))))
         && MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
            self#0, 
            s#0, 
            i#0)
           == (forall key#0: int :: 
            { s#0[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 18446744073709551616 && s#0[$Box(key#0)]
               ==> (exists j#0: int :: 
                { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      j#0)): DatatypeType } 
                LitInt(0) <= j#0
                   && j#0 < i#0
                   && 
                  MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        j#0)): DatatypeType)
                   && key#0
                     == MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                          j#0)): DatatypeType))));

// definition axiom for MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V: Ty, 
      self#0: DatatypeType, 
      s#0: Set Box, 
      i#0: int :: 
    {:weight 3} { MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
        Lit(self#0), 
        Lit(s#0), 
        LitInt(i#0)) } 
    MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex#canCall(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
          Lit(self#0), 
          Lit(s#0), 
          LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V))
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))))
       ==> (forall key#1: int :: 
          { s#0[$Box(key#1)] } 
          LitInt(0) <= key#1 && key#1 < 18446744073709551616
             ==> 
            Lit(s#0)[$Box(key#1)]
             ==> (forall j#1: int :: 
              { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    j#1)): DatatypeType } 
              LitInt(0) <= j#1 && j#1 < i#0
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                   && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
                   && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                          j#1)): DatatypeType)
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                       && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))))
         && MutableMapModel.__default.EachReturnedKeyExplainedByPassedIndex(MutableMapModel._default.EachReturnedKeyExplainedByPassedIndex$V, 
            Lit(self#0), 
            Lit(s#0), 
            LitInt(i#0))
           == (forall key#1: int :: 
            { s#0[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 18446744073709551616 && Lit(s#0)[$Box(key#1)]
               ==> (exists j#1: int :: 
                { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      j#1)): DatatypeType } 
                LitInt(0) <= j#1
                   && j#1 < i#0
                   && 
                  MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        j#1)): DatatypeType)
                   && key#1
                     == MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                          j#1)): DatatypeType))));

// function declaration for MutableMapModel._default.WFIter
function MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V: Ty, self#0: DatatypeType, it#0: DatatypeType)
   : bool;

function MutableMapModel.__default.WFIter#canCall(MutableMapModel._default.WFIter$V: Ty, self#0: DatatypeType, it#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.WFIter
axiom true
   ==> (forall MutableMapModel._default.WFIter$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
    { MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, self#0, it#0) } 
    MutableMapModel.__default.WFIter#canCall(MutableMapModel._default.WFIter$V, self#0, it#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFIter$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.WFIter$V)))
       ==> (MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, self#0, it#0)
           ==> 
          MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
           ==> Set#Equal(MutableMapModel.Iterator.s(it#0), 
            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))))
         && (MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, self#0, it#0)
           ==> 
          MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
           ==> Maps.__default.MapsTo(Tclass.NativeTypes.uint64(), 
            MutableMapModel._default.WFIter$V, 
            MutableMapModel.LinearHashMap.contents(self#0), 
            $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))), 
            MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))))
         && (MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, self#0, it#0)
           ==> 
          MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
           ==> !MutableMapModel.Iterator.s(it#0)[$Box(MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0)))])
         && (MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, self#0, it#0)
           ==> Set#Subset(MutableMapModel.Iterator.s(it#0), 
            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0)))));

function MutableMapModel.__default.WFIter#requires(Ty, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.WFIter
axiom (forall MutableMapModel._default.WFIter$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
  { MutableMapModel.__default.WFIter#requires(MutableMapModel._default.WFIter$V, self#0, it#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFIter$V))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.WFIter$V))
     ==> MutableMapModel.__default.WFIter#requires(MutableMapModel._default.WFIter$V, self#0, it#0)
       == true);

// definition axiom for MutableMapModel.__default.WFIter(revealed)
axiom true
   ==> (forall MutableMapModel._default.WFIter$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
    { MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, self#0, it#0) } 
    MutableMapModel.__default.WFIter#canCall(MutableMapModel._default.WFIter$V, self#0, it#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFIter$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.WFIter$V)))
       ==> true);

// definition axiom for MutableMapModel.__default.WFIter for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.WFIter$V: Ty, self#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.WFIter(MutableMapModel._default.WFIter$V, Lit(self#0), Lit(it#0)) } 
    MutableMapModel.__default.WFIter#canCall(MutableMapModel._default.WFIter$V, Lit(self#0), Lit(it#0))
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFIter$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.WFIter$V)))
       ==> true);

// function declaration for MutableMapModel._default.WFSimpleIter
function MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.WFSimpleIter$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : bool;

function MutableMapModel.__default.WFSimpleIter#canCall(MutableMapModel._default.WFSimpleIter$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.WFSimpleIter
axiom true
   ==> (forall MutableMapModel._default.WFSimpleIter$V: Ty, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.WFSimpleIter$V, self#0, it#0) } 
    MutableMapModel.__default.WFSimpleIter#canCall(MutableMapModel._default.WFSimpleIter$V, self#0, it#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFSimpleIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator()))
       ==> 
      MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.WFSimpleIter$V, self#0, it#0)
       ==> Set#Subset(MutableMapModel.SimpleIterator.s(it#0), 
        Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))));

function MutableMapModel.__default.WFSimpleIter#requires(Ty, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.WFSimpleIter
axiom (forall MutableMapModel._default.WFSimpleIter$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.WFSimpleIter#requires(MutableMapModel._default.WFSimpleIter$V, self#0, it#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFSimpleIter$V))
       && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
     ==> MutableMapModel.__default.WFSimpleIter#requires(MutableMapModel._default.WFSimpleIter$V, self#0, it#0)
       == true);

// definition axiom for MutableMapModel.__default.WFSimpleIter(revealed)
axiom true
   ==> (forall MutableMapModel._default.WFSimpleIter$V: Ty, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.WFSimpleIter$V, self#0, it#0) } 
    MutableMapModel.__default.WFSimpleIter#canCall(MutableMapModel._default.WFSimpleIter$V, self#0, it#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFSimpleIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator()))
       ==> true);

// definition axiom for MutableMapModel.__default.WFSimpleIter for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.WFSimpleIter$V: Ty, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.WFSimpleIter$V, Lit(self#0), Lit(it#0)) } 
    MutableMapModel.__default.WFSimpleIter#canCall(MutableMapModel._default.WFSimpleIter$V, Lit(self#0), Lit(it#0))
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.WFSimpleIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator()))
       ==> true);

// function declaration for MutableMapModel._default.indexOutput
function MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V: Ty, self#0: DatatypeType, i#0: int)
   : DatatypeType;

function MutableMapModel.__default.indexOutput#canCall(MutableMapModel._default.indexOutput$V: Ty, self#0: DatatypeType, i#0: int)
   : bool;

// consequence axiom for MutableMapModel.__default.indexOutput
axiom true
   ==> (forall MutableMapModel._default.indexOutput$V: Ty, self#0: DatatypeType, i#0: int :: 
    { MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V, self#0, i#0) } 
    MutableMapModel.__default.indexOutput#canCall(MutableMapModel._default.indexOutput$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.indexOutput$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           && (i#0
               < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             ==> MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                  i#0)): DatatypeType)))
       ==> $Is(MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V, self#0, i#0), 
        Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.indexOutput$V)));

function MutableMapModel.__default.indexOutput#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.indexOutput
axiom (forall MutableMapModel._default.indexOutput$V: Ty, self#0: DatatypeType, i#0: int :: 
  { MutableMapModel.__default.indexOutput#requires(MutableMapModel._default.indexOutput$V, self#0, i#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.indexOutput$V))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> MutableMapModel.__default.indexOutput#requires(MutableMapModel._default.indexOutput$V, self#0, i#0)
       == (
        LitInt(0) <= i#0
         && i#0
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
         && (i#0
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           ==> MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                i#0)): DatatypeType))));

// definition axiom for MutableMapModel.__default.indexOutput(revealed)
axiom true
   ==> (forall MutableMapModel._default.indexOutput$V: Ty, self#0: DatatypeType, i#0: int :: 
    { MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V, self#0, i#0) } 
    MutableMapModel.__default.indexOutput#canCall(MutableMapModel._default.indexOutput$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.indexOutput$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           && (i#0
               < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             ==> MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                  i#0)): DatatypeType)))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && (i#0
             != Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && 
            MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
         && MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V, self#0, i#0)
           == (if i#0
               == Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             then #MutableMapModel.IteratorOutput.Done()
             else #MutableMapModel.IteratorOutput.Next(MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType), 
              MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType))));

// definition axiom for MutableMapModel.__default.indexOutput for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.indexOutput$V: Ty, self#0: DatatypeType, i#0: int :: 
    {:weight 3} { MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V, Lit(self#0), LitInt(i#0)) } 
    MutableMapModel.__default.indexOutput#canCall(MutableMapModel._default.indexOutput$V, Lit(self#0), LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.indexOutput$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           && (i#0
               < Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             ==> MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                  LitInt(i#0))): DatatypeType)))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (LitInt(i#0)
             != Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && 
            MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
         && MutableMapModel.__default.indexOutput(MutableMapModel._default.indexOutput$V, Lit(self#0), LitInt(i#0))
           == (if LitInt(i#0)
               == Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             then #MutableMapModel.IteratorOutput.Done()
             else #MutableMapModel.IteratorOutput.Next(MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType), 
              MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType))));

// function declaration for MutableMapModel._default.SimpleIterOutput
function MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : DatatypeType;

function MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.SimpleIterOutput$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : bool;

// consequence axiom for MutableMapModel.__default.SimpleIterOutput
axiom true
   ==> (forall MutableMapModel._default.SimpleIterOutput$V: Ty, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0) } 
    MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterOutput$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))
       ==> (MutableMapModel.IteratorOutput.Done_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))
           ==> Set#Equal(MutableMapModel.SimpleIterator.s(it#0), 
            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))))
         && (MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))
           ==> Maps.__default.MapsTo(Tclass.NativeTypes.uint64(), 
            MutableMapModel._default.SimpleIterOutput$V, 
            MutableMapModel.LinearHashMap.contents(self#0), 
            $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))), 
            MutableMapModel.IteratorOutput.value(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))))
         && (MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))
           ==> !MutableMapModel.SimpleIterator.s(it#0)[$Box(MutableMapModel.IteratorOutput.key(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0)))])
         && $Is(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0), 
          Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.SimpleIterOutput$V)));

function MutableMapModel.__default.SimpleIterOutput#requires(Ty, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SimpleIterOutput
axiom (forall MutableMapModel._default.SimpleIterOutput$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterOutput#requires(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterOutput$V))
       && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
     ==> MutableMapModel.__default.SimpleIterOutput#requires(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0)
       == MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0));

// definition axiom for MutableMapModel.__default.SimpleIterOutput(revealed)
axiom true
   ==> (forall MutableMapModel._default.SimpleIterOutput$V: Ty, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0) } 
    MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterOutput$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterOutput$V, self#0, it#0))
       ==> true);

// definition axiom for MutableMapModel.__default.SimpleIterOutput for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SimpleIterOutput$V: Ty, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterOutput$V, Lit(self#0), Lit(it#0)) } 
    MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.SimpleIterOutput$V, Lit(self#0), Lit(it#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterOutput$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && Lit(MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterOutput$V, Lit(self#0), Lit(it#0))))
       ==> true);

// function declaration for MutableMapModel._default.iterToNext
function MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int)
   : DatatypeType;

function MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.iterToNext$V: Ty, self#0: DatatypeType, i#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.iterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), self#0, i#0) } 
  MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), self#0, i#0)
     == MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.iterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, AsFuelBottom($ly), self#0, i#0) } 
  MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0)
     == MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LZ, self#0, i#0));

// consequence axiom for MutableMapModel.__default.iterToNext
axiom true
   ==> (forall MutableMapModel._default.iterToNext$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0) } 
    MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.iterToNext$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.iterToNext$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.iterToNext$V, self#0)
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> MutableMapModel.__default.NextExplainedByI(MutableMapModel._default.iterToNext$V, 
          self#0, 
          $Unbox(_System.Tuple2._0(MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0))): int, 
          $Unbox(_System.Tuple2._1(MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0))): DatatypeType)
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                j#0)): DatatypeType } 
          LitInt(0) <= j#0
               && j#0 < 18446744073709551616
               && 
              i#0 <= j#0
               && j#0
                 < $Unbox(_System.Tuple2._0(MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0))): int
             ==> !MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                  j#0)): DatatypeType))
         && i#0
           <= $Unbox(_System.Tuple2._0(MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0))): int
         && $Is(MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0), 
          Tclass._System.Tuple2(Tclass.NativeTypes.uint64(), 
            Tclass.MutableMapModel.IteratorOutput(MutableMapModel._default.iterToNext$V))));

function MutableMapModel.__default.iterToNext#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.iterToNext
axiom (forall MutableMapModel._default.iterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.iterToNext#requires(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.iterToNext$V))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> MutableMapModel.__default.iterToNext#requires(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0)
       == (MutableMapModel.__default.Inv(MutableMapModel._default.iterToNext$V, self#0)
         && 
        LitInt(0) <= i#0
         && i#0
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))));

// definition axiom for MutableMapModel.__default.iterToNext(revealed)
axiom true
   ==> (forall MutableMapModel._default.iterToNext$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), self#0, i#0) } 
    MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.iterToNext$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.iterToNext$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.iterToNext$V, self#0)
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && (i#0
             != Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (!MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               ==> MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.iterToNext$V, self#0, i#0 + 1)))
         && MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), self#0, i#0)
           == (if i#0
               == Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             then #_System._tuple#2._#Make2($Box(i#0), $Box(Lit(#MutableMapModel.IteratorOutput.Done())))
             else (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               then #_System._tuple#2._#Make2($Box(i#0), 
                $Box(#MutableMapModel.IteratorOutput.Next(MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                          i#0)): DatatypeType), 
                    MutableMapModel.Item.value($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                          i#0)): DatatypeType))))
               else MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $ly, self#0, i#0 + 1))));

// definition axiom for MutableMapModel.__default.iterToNext for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.iterToNext$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    {:weight 3} { MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), Lit(self#0), LitInt(i#0)) } 
    MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.iterToNext$V, Lit(self#0), LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.iterToNext$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.iterToNext$V, Lit(self#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (LitInt(i#0)
             != Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (!MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               ==> MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.iterToNext$V, Lit(self#0), LitInt(i#0 + 1))))
         && MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), Lit(self#0), LitInt(i#0))
           == (if LitInt(i#0)
               == Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             then #_System._tuple#2._#Make2($Box(LitInt(i#0)), $Box(Lit(#MutableMapModel.IteratorOutput.Done())))
             else (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               then #_System._tuple#2._#Make2($Box(LitInt(i#0)), 
                $Box(#MutableMapModel.IteratorOutput.Next(MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                          LitInt(i#0))): DatatypeType), 
                    MutableMapModel.Item.value($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                          LitInt(i#0))): DatatypeType))))
               else MutableMapModel.__default.iterToNext(MutableMapModel._default.iterToNext$V, $LS($ly), Lit(self#0), LitInt(i#0 + 1)))));

// function declaration for MutableMapModel._default.simpleIterToNext
function MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int)
   : int;

function MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.simpleIterToNext$V: Ty, self#0: DatatypeType, i#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.simpleIterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LS($ly), self#0, i#0) } 
  MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LS($ly), self#0, i#0)
     == MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.simpleIterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, AsFuelBottom($ly), self#0, i#0) } 
  MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
     == MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LZ, self#0, i#0));

// consequence axiom for MutableMapModel.__default.simpleIterToNext
axiom true
   ==> (forall MutableMapModel._default.simpleIterToNext$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0) } 
    MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.simpleIterToNext$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.simpleIterToNext$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.simpleIterToNext$V, self#0)
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> LitInt(0)
           <= MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
         && MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                j#0)): DatatypeType } 
          LitInt(0) <= j#0
               && j#0 < 18446744073709551616
               && 
              i#0 <= j#0
               && j#0
                 < MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
             ==> !MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                  j#0)): DatatypeType))
         && (MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
             < Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           ==> MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0))): DatatypeType))
         && i#0
           <= MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
         && 
        LitInt(0)
           <= MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
         && MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
           < 18446744073709551616);

function MutableMapModel.__default.simpleIterToNext#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.simpleIterToNext
axiom (forall MutableMapModel._default.simpleIterToNext$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    i#0: int :: 
  { MutableMapModel.__default.simpleIterToNext#requires(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.simpleIterToNext$V))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> MutableMapModel.__default.simpleIterToNext#requires(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0)
       == (MutableMapModel.__default.Inv(MutableMapModel._default.simpleIterToNext$V, self#0)
         && 
        LitInt(0) <= i#0
         && i#0
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))));

// definition axiom for MutableMapModel.__default.simpleIterToNext(revealed)
axiom true
   ==> (forall MutableMapModel._default.simpleIterToNext$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    { MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LS($ly), self#0, i#0) } 
    MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.simpleIterToNext$V, self#0, i#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.simpleIterToNext$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.simpleIterToNext$V, self#0)
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && (i#0
             != Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && (!MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               ==> MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.simpleIterToNext$V, self#0, i#0 + 1)))
         && MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LS($ly), self#0, i#0)
           == (if i#0
               == Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
             then i#0
             else (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    i#0)): DatatypeType)
               then i#0
               else MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $ly, self#0, i#0 + 1))));

// definition axiom for MutableMapModel.__default.simpleIterToNext for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.simpleIterToNext$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      i#0: int :: 
    {:weight 3} { MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LS($ly), Lit(self#0), LitInt(i#0)) } 
    MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.simpleIterToNext$V, Lit(self#0), LitInt(i#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.simpleIterToNext$V))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.simpleIterToNext$V, Lit(self#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && (LitInt(i#0)
             != Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (!MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               ==> MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.simpleIterToNext$V, Lit(self#0), LitInt(i#0 + 1))))
         && MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, $LS($ly), Lit(self#0), LitInt(i#0))
           == (if LitInt(i#0)
               == Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
             then i#0
             else (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    LitInt(i#0))): DatatypeType)
               then i#0
               else MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.simpleIterToNext$V, 
                $LS($ly), 
                Lit(self#0), 
                LitInt(i#0 + 1)))));

// function declaration for MutableMapModel._default.IterStart
function MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType)
   : DatatypeType;

function MutableMapModel.__default.IterStart#canCall(MutableMapModel._default.IterStart$V: Ty, self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
  { MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LS($ly), self#0) } 
  MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LS($ly), self#0)
     == MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $ly, self#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
  { MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, AsFuelBottom($ly), self#0) } 
  MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $ly, self#0)
     == MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LZ, self#0));

// consequence axiom for MutableMapModel.__default.IterStart
axiom true
   ==> (forall MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
    { MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $ly, self#0) } 
    MutableMapModel.__default.IterStart#canCall(MutableMapModel._default.IterStart$V, self#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterStart$V))
           && MutableMapModel.__default.Inv(MutableMapModel._default.IterStart$V, self#0))
       ==> MutableMapModel.__default.WFIter(MutableMapModel._default.IterStart$V, 
          self#0, 
          MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $ly, self#0))
         && Set#Equal(MutableMapModel.Iterator.s(MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $ly, self#0)), 
          Set#Empty(): Set Box)
         && $Is(MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $ly, self#0), 
          Tclass.MutableMapModel.Iterator(MutableMapModel._default.IterStart$V)));

function MutableMapModel.__default.IterStart#requires(Ty, LayerType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.IterStart
axiom (forall MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
  { MutableMapModel.__default.IterStart#requires(MutableMapModel._default.IterStart$V, $ly, self#0) } 
  $Is(self#0, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterStart$V))
     ==> MutableMapModel.__default.IterStart#requires(MutableMapModel._default.IterStart$V, $ly, self#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.IterStart$V, self#0));

// definition axiom for MutableMapModel.__default.IterStart(revealed)
axiom true
   ==> (forall MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
    { MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LS($ly), self#0) } 
    MutableMapModel.__default.IterStart#canCall(MutableMapModel._default.IterStart$V, self#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterStart$V))
           && MutableMapModel.__default.Inv(MutableMapModel._default.IterStart$V, self#0))
       ==> MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.IterStart$V, self#0, LitInt(0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LS($ly), self#0)
           == (var i#0, next#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterStart$V, $LS($LZ), self#0, LitInt(0)))): int, 
              $Unbox(_System.Tuple2._1(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterStart$V, $LS($LZ), self#0, LitInt(0)))): DatatypeType; 
            (var it'#0 := #MutableMapModel.Iterator.Iterator(i#0, 
                  Lit(Set#Empty(): Set Box), 
                  ORD#FromNat(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
                       - i#0), 
                  next#0); 
              it'#0)));

// definition axiom for MutableMapModel.__default.IterStart for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.IterStart$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LS($ly), Lit(self#0)) } 
    MutableMapModel.__default.IterStart#canCall(MutableMapModel._default.IterStart$V, Lit(self#0))
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterStart$V))
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.IterStart$V, Lit(self#0))))
       ==> MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.IterStart$V, Lit(self#0), LitInt(0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && MutableMapModel.__default.IterStart(MutableMapModel._default.IterStart$V, $LS($ly), Lit(self#0))
           == (var i#1, next#1 := $Unbox(_System.Tuple2._0(Lit(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterStart$V, $LS($LZ), Lit(self#0), LitInt(0))))): int, 
              $Unbox(_System.Tuple2._1(Lit(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterStart$V, $LS($LZ), Lit(self#0), LitInt(0))))): DatatypeType; 
            (var it'#1 := #MutableMapModel.Iterator.Iterator(i#1, 
                  Lit(Set#Empty(): Set Box), 
                  ORD#FromNat(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
                       - i#1), 
                  next#1); 
              it'#1)));

// function declaration for MutableMapModel._default.SimpleIterStart
function MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType)
   : DatatypeType;

function MutableMapModel.__default.SimpleIterStart#canCall(MutableMapModel._default.SimpleIterStart$V: Ty, self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.SimpleIterStart$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LS($ly), self#0) } 
  MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LS($ly), self#0)
     == MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $ly, self#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.SimpleIterStart$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, AsFuelBottom($ly), self#0) } 
  MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $ly, self#0)
     == MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LZ, self#0));

// consequence axiom for MutableMapModel.__default.SimpleIterStart
axiom true
   ==> (forall MutableMapModel._default.SimpleIterStart$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType :: 
    { MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $ly, self#0) } 
    MutableMapModel.__default.SimpleIterStart#canCall(MutableMapModel._default.SimpleIterStart$V, self#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterStart$V))
           && MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterStart$V, self#0))
       ==> MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterStart$V, 
          self#0, 
          MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $ly, self#0))
         && Set#Equal(MutableMapModel.SimpleIterator.s(MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $ly, self#0)), 
          Set#Empty(): Set Box)
         && $Is(MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $ly, self#0), 
          Tclass.MutableMapModel.SimpleIterator()));

function MutableMapModel.__default.SimpleIterStart#requires(Ty, LayerType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SimpleIterStart
axiom (forall MutableMapModel._default.SimpleIterStart$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterStart#requires(MutableMapModel._default.SimpleIterStart$V, $ly, self#0) } 
  $Is(self#0, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterStart$V))
     ==> MutableMapModel.__default.SimpleIterStart#requires(MutableMapModel._default.SimpleIterStart$V, $ly, self#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterStart$V, self#0));

// definition axiom for MutableMapModel.__default.SimpleIterStart(revealed)
axiom true
   ==> (forall MutableMapModel._default.SimpleIterStart$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType :: 
    { MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LS($ly), self#0) } 
    MutableMapModel.__default.SimpleIterStart#canCall(MutableMapModel._default.SimpleIterStart$V, self#0)
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterStart$V))
           && MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterStart$V, self#0))
       ==> MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.SimpleIterStart$V, self#0, LitInt(0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LS($ly), self#0)
           == (var i#0 := MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.SimpleIterStart$V, $LS($LZ), self#0, LitInt(0)); 
            (var it'#0 := #MutableMapModel.SimpleIterator.SimpleIterator(i#0, 
                  Lit(Set#Empty(): Set Box), 
                  ORD#FromNat(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
                       - i#0)); 
              it'#0)));

// definition axiom for MutableMapModel.__default.SimpleIterStart for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SimpleIterStart$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LS($ly), Lit(self#0)) } 
    MutableMapModel.__default.SimpleIterStart#canCall(MutableMapModel._default.SimpleIterStart$V, Lit(self#0))
         || ($Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterStart$V))
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterStart$V, Lit(self#0))))
       ==> MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.SimpleIterStart$V, Lit(self#0), LitInt(0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && MutableMapModel.__default.SimpleIterStart(MutableMapModel._default.SimpleIterStart$V, $LS($ly), Lit(self#0))
           == (var i#1 := LitInt(MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.SimpleIterStart$V, $LS($LZ), Lit(self#0), LitInt(0))); 
            (var it'#1 := #MutableMapModel.SimpleIterator.SimpleIterator(i#1, 
                  Lit(Set#Empty(): Set Box), 
                  ORD#FromNat(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
                       - i#1)); 
              it'#1)));

// function declaration for MutableMapModel._default.IterInc
function MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : DatatypeType;

function MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.IterInc$V: Ty, self#0: DatatypeType, it#0: DatatypeType)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.IterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LS($ly), self#0, it#0) } 
  MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LS($ly), self#0, it#0)
     == MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.IterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, AsFuelBottom($ly), self#0, it#0) } 
  MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0)
     == MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LZ, self#0, it#0));

// consequence axiom for MutableMapModel.__default.IterInc
axiom true
   ==> (forall MutableMapModel._default.IterInc$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0) } 
    MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.IterInc$V, self#0, it#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterInc$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.IterInc$V))
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.IterInc$V, self#0)
           && MutableMapModel.__default.WFIter(MutableMapModel._default.IterInc$V, self#0, it#0)
           && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
       ==> MutableMapModel.__default.WFIter(MutableMapModel._default.IterInc$V, 
          self#0, 
          MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0))
         && Set#Equal(MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0)), 
          Set#Union(MutableMapModel.Iterator.s(it#0), 
            Set#UnionOne(Set#Empty(): Set Box, 
              $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))))))
         && (MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0)))
           ==> Set#Equal(MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0)), 
            Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))))
         && ORD#Less(MutableMapModel.Iterator.decreaser(MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0)), 
          MutableMapModel.Iterator.decreaser(it#0))
         && $Is(MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $ly, self#0, it#0), 
          Tclass.MutableMapModel.Iterator(MutableMapModel._default.IterInc$V)));

function MutableMapModel.__default.IterInc#requires(Ty, LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.IterInc
axiom (forall MutableMapModel._default.IterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.IterInc#requires(MutableMapModel._default.IterInc$V, $ly, self#0, it#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterInc$V))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.IterInc$V))
     ==> MutableMapModel.__default.IterInc#requires(MutableMapModel._default.IterInc$V, $ly, self#0, it#0)
       == (
        MutableMapModel.__default.Inv(MutableMapModel._default.IterInc$V, self#0)
         && MutableMapModel.__default.WFIter(MutableMapModel._default.IterInc$V, self#0, it#0)
         && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))));

// definition axiom for MutableMapModel.__default.IterInc(revealed)
axiom true
   ==> (forall MutableMapModel._default.IterInc$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LS($ly), self#0, it#0) } 
    MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.IterInc$V, self#0, it#0)
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterInc$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.IterInc$V))
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.IterInc$V, self#0)
           && MutableMapModel.__default.WFIter(MutableMapModel._default.IterInc$V, self#0, it#0)
           && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0)))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.IterInc$V, self#0, MutableMapModel.Iterator.i(it#0) + 1)
         && 
        MutableMapModel.Iterator.Iterator_q(it#0)
         && MutableMapModel.Iterator.Iterator_q(it#0)
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LS($ly), self#0, it#0)
           == (var i#0, next#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterInc$V, 
                    $LS($LZ), 
                    self#0, 
                    MutableMapModel.Iterator.i(it#0) + 1))): int, 
              $Unbox(_System.Tuple2._1(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterInc$V, 
                    $LS($LZ), 
                    self#0, 
                    MutableMapModel.Iterator.i(it#0) + 1))): DatatypeType; 
            (var it'#0 := #MutableMapModel.Iterator.Iterator(i#0, 
                  Set#Union(MutableMapModel.Iterator.s(it#0), 
                    Set#UnionOne(Set#Empty(): Set Box, 
                      $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))))), 
                  ORD#FromNat(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
                       - i#0), 
                  next#0); 
              it'#0)));

// definition axiom for MutableMapModel.__default.IterInc for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.IterInc$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LS($ly), Lit(self#0), Lit(it#0)) } 
    MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.IterInc$V, Lit(self#0), Lit(it#0))
         || (
          $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.IterInc$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.IterInc$V))
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.IterInc$V, Lit(self#0)))
           && Lit(MutableMapModel.__default.WFIter(MutableMapModel._default.IterInc$V, Lit(self#0), Lit(it#0)))
           && Lit(MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && MutableMapModel.__default.iterToNext#canCall(MutableMapModel._default.IterInc$V, 
          Lit(self#0), 
          LitInt(MutableMapModel.Iterator.i(Lit(it#0)) + 1))
         && 
        MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && MutableMapModel.__default.IterInc(MutableMapModel._default.IterInc$V, $LS($ly), Lit(self#0), Lit(it#0))
           == (var i#1, next#1 := $Unbox(_System.Tuple2._0(Lit(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterInc$V, 
                      $LS($LZ), 
                      Lit(self#0), 
                      LitInt(MutableMapModel.Iterator.i(Lit(it#0)) + 1))))): int, 
              $Unbox(_System.Tuple2._1(Lit(MutableMapModel.__default.iterToNext(MutableMapModel._default.IterInc$V, 
                      $LS($LZ), 
                      Lit(self#0), 
                      LitInt(MutableMapModel.Iterator.i(Lit(it#0)) + 1))))): DatatypeType; 
            (var it'#1 := #MutableMapModel.Iterator.Iterator(i#1, 
                  Set#Union(MutableMapModel.Iterator.s(Lit(it#0)), 
                    Set#UnionOne(Set#Empty(): Set Box, 
                      $Box(LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))))), 
                  ORD#FromNat(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
                       - i#1), 
                  next#1); 
              it'#1)));

// function declaration for MutableMapModel._default.SimpleIterInc
function MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : DatatypeType;

function MutableMapModel.__default.SimpleIterInc#canCall(MutableMapModel._default.SimpleIterInc$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.SimpleIterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LS($ly), self#0, it#0) } 
  MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LS($ly), self#0, it#0)
     == MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.SimpleIterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, AsFuelBottom($ly), self#0, it#0) } 
  MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0)
     == MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LZ, self#0, it#0));

// consequence axiom for MutableMapModel.__default.SimpleIterInc
axiom true
   ==> (forall MutableMapModel._default.SimpleIterInc$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0) } 
    MutableMapModel.__default.SimpleIterInc#canCall(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterInc$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterInc$V, self#0)
           && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)
           && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)))
       ==> MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterInc$V, 
          self#0, 
          MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0))
         && Set#Equal(MutableMapModel.SimpleIterator.s(MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0)), 
          Set#Union(MutableMapModel.SimpleIterator.s(it#0), 
            Set#UnionOne(Set#Empty(): Set Box, 
              $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, self#0, it#0))))))
         && ORD#Less(MutableMapModel.SimpleIterator.decreaser(MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0)), 
          MutableMapModel.SimpleIterator.decreaser(it#0))
         && $Is(MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0), 
          Tclass.MutableMapModel.SimpleIterator()));

function MutableMapModel.__default.SimpleIterInc#requires(Ty, LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.SimpleIterInc
axiom (forall MutableMapModel._default.SimpleIterInc$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType :: 
  { MutableMapModel.__default.SimpleIterInc#requires(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterInc$V))
       && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
     ==> MutableMapModel.__default.SimpleIterInc#requires(MutableMapModel._default.SimpleIterInc$V, $ly, self#0, it#0)
       == (
        MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterInc$V, self#0)
         && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)
         && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, self#0, it#0))));

// definition axiom for MutableMapModel.__default.SimpleIterInc(revealed)
axiom true
   ==> (forall MutableMapModel._default.SimpleIterInc$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    { MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LS($ly), self#0, it#0) } 
    MutableMapModel.__default.SimpleIterInc#canCall(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterInc$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterInc$V, self#0)
           && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)
           && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)))
       ==> MutableMapModel.SimpleIterator.SimpleIterator_q(it#0)
         && MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.SimpleIterInc$V, 
          self#0, 
          MutableMapModel.SimpleIterator.i(it#0) + 1)
         && 
        MutableMapModel.SimpleIterator.SimpleIterator_q(it#0)
         && MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.SimpleIterInc$V, self#0, it#0)
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
         && MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LS($ly), self#0, it#0)
           == (var i#0 := MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.SimpleIterInc$V, 
                $LS($LZ), 
                self#0, 
                MutableMapModel.SimpleIterator.i(it#0) + 1); 
            (var it'#0 := #MutableMapModel.SimpleIterator.SimpleIterator(i#0, 
                  Set#Union(MutableMapModel.SimpleIterator.s(it#0), 
                    Set#UnionOne(Set#Empty(): Set Box, 
                      $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, self#0, it#0))))), 
                  ORD#FromNat(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
                       - i#0)); 
              it'#0)));

// definition axiom for MutableMapModel.__default.SimpleIterInc for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.SimpleIterInc$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LS($ly), Lit(self#0), Lit(it#0)) } 
    MutableMapModel.__default.SimpleIterInc#canCall(MutableMapModel._default.SimpleIterInc$V, Lit(self#0), Lit(it#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.SimpleIterInc$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.SimpleIterInc$V, Lit(self#0)))
           && Lit(MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.SimpleIterInc$V, Lit(self#0), Lit(it#0)))
           && Lit(MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, Lit(self#0), Lit(it#0))))))
       ==> MutableMapModel.SimpleIterator.SimpleIterator_q(Lit(it#0))
         && MutableMapModel.__default.simpleIterToNext#canCall(MutableMapModel._default.SimpleIterInc$V, 
          Lit(self#0), 
          LitInt(MutableMapModel.SimpleIterator.i(Lit(it#0)) + 1))
         && 
        MutableMapModel.SimpleIterator.SimpleIterator_q(Lit(it#0))
         && MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.SimpleIterInc$V, Lit(self#0), Lit(it#0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
         && MutableMapModel.__default.SimpleIterInc(MutableMapModel._default.SimpleIterInc$V, $LS($ly), Lit(self#0), Lit(it#0))
           == (var i#1 := LitInt(MutableMapModel.__default.simpleIterToNext(MutableMapModel._default.SimpleIterInc$V, 
                  $LS($LZ), 
                  Lit(self#0), 
                  LitInt(MutableMapModel.SimpleIterator.i(Lit(it#0)) + 1))); 
            (var it'#1 := #MutableMapModel.SimpleIterator.SimpleIterator(i#1, 
                  Set#Union(MutableMapModel.SimpleIterator.s(Lit(it#0)), 
                    Set#UnionOne(Set#Empty(): Set Box, 
                      $Box(LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.SimpleIterInc$V, Lit(self#0), Lit(it#0)))))))), 
                  ORD#FromNat(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
                       - i#1)); 
              it'#1)));

procedure CheckWellformed$$MutableMapModel.__default.LemmaIterIndexLtCount(MutableMapModel._default.LemmaIterIndexLtCount$V: Ty, 
    self#0: DatatypeType
       where $Is(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.LemmaIterIndexLtCount$V))
         && $IsAlloc(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.LemmaIterIndexLtCount$V), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(self#0), 
    it#0: DatatypeType
       where $Is(it#0, 
          Tclass.MutableMapModel.Iterator(MutableMapModel._default.LemmaIterIndexLtCount$V))
         && $IsAlloc(it#0, 
          Tclass.MutableMapModel.Iterator(MutableMapModel._default.LemmaIterIndexLtCount$V), 
          $Heap)
         && $IsA#MutableMapModel.Iterator(it#0));
  free requires 110 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMapModel.__default.LemmaIterIndexLtCount(MutableMapModel._default.LemmaIterIndexLtCount$V: Ty, 
    self#0: DatatypeType
       where $Is(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.LemmaIterIndexLtCount$V))
         && $IsAlloc(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.LemmaIterIndexLtCount$V), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(self#0), 
    it#0: DatatypeType
       where $Is(it#0, 
          Tclass.MutableMapModel.Iterator(MutableMapModel._default.LemmaIterIndexLtCount$V))
         && $IsAlloc(it#0, 
          Tclass.MutableMapModel.Iterator(MutableMapModel._default.LemmaIterIndexLtCount$V), 
          $Heap)
         && $IsA#MutableMapModel.Iterator(it#0));
  // user-defined preconditions
  requires MutableMapModel.__default.Inv(MutableMapModel._default.LemmaIterIndexLtCount$V, self#0);
  requires MutableMapModel.__default.WFIter(MutableMapModel._default.LemmaIterIndexLtCount$V, self#0, it#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMapModel.Iterator.Iterator_q(it#0)
     && (MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && MutableMapModel.LinearHashMap.LinearHashMap_q(self#0));
  ensures MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
     ==> Set#Card(MutableMapModel.Iterator.s(it#0))
       < MutableMapModel.LinearHashMap.count(self#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for MutableMapModel._default.MaxKeyIterate
function MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    m#0: int)
   : int;

function MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    m#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    m#0: int :: 
  { MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LS($ly), self#0, it#0, m#0) } 
  MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LS($ly), self#0, it#0, m#0)
     == MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    m#0: int :: 
  { MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, AsFuelBottom($ly), self#0, it#0, m#0) } 
  MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0)
     == MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LZ, self#0, it#0, m#0));

// consequence axiom for MutableMapModel.__default.MaxKeyIterate
axiom true
   ==> (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      m#0: int :: 
    { MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0) } 
    MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, self#0, it#0, m#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKeyIterate$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.MaxKeyIterate$V))
           && 
          LitInt(0) <= m#0
           && m#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.MaxKeyIterate$V, self#0)
           && MutableMapModel.__default.WFIter(MutableMapModel._default.MaxKeyIterate$V, self#0, it#0)
           && (forall key#0: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(key#0)] } 
            LitInt(0) <= key#0
                 && key#0 < 18446744073709551616
                 && MutableMapModel.Iterator.s(it#0)[$Box(key#0)]
               ==> key#0 <= m#0))
       ==> (forall key#1: int :: 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#1)] } 
          LitInt(0) <= key#1
               && key#1 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#1)]
             ==> key#1
               <= MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0))
         && 
        LitInt(0)
           <= MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0)
         && MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0)
           < 18446744073709551616);

function MutableMapModel.__default.MaxKeyIterate#requires(Ty, LayerType, DatatypeType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.MaxKeyIterate
axiom (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    m#0: int :: 
  { MutableMapModel.__default.MaxKeyIterate#requires(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKeyIterate$V))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.MaxKeyIterate$V))
       && 
      LitInt(0) <= m#0
       && m#0 < 18446744073709551616
     ==> MutableMapModel.__default.MaxKeyIterate#requires(MutableMapModel._default.MaxKeyIterate$V, $ly, self#0, it#0, m#0)
       == (
        MutableMapModel.__default.Inv(MutableMapModel._default.MaxKeyIterate$V, self#0)
         && MutableMapModel.__default.WFIter(MutableMapModel._default.MaxKeyIterate$V, self#0, it#0)
         && (forall key#2: int :: 
          { MutableMapModel.Iterator.s(it#0)[$Box(key#2)] } 
          LitInt(0) <= key#2
               && key#2 < 18446744073709551616
               && MutableMapModel.Iterator.s(it#0)[$Box(key#2)]
             ==> key#2 <= m#0)));

// definition axiom for MutableMapModel.__default.MaxKeyIterate(revealed)
axiom true
   ==> (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      m#0: int :: 
    { MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LS($ly), self#0, it#0, m#0) } 
    MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, self#0, it#0, m#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKeyIterate$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.MaxKeyIterate$V))
           && 
          LitInt(0) <= m#0
           && m#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.MaxKeyIterate$V, self#0)
           && MutableMapModel.__default.WFIter(MutableMapModel._default.MaxKeyIterate$V, self#0, it#0)
           && (forall key#2: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(key#2)] } 
            LitInt(0) <= key#2
                 && key#2 < 18446744073709551616
                 && MutableMapModel.Iterator.s(it#0)[$Box(key#2)]
               ==> key#2 <= m#0))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && (!MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
           ==> MutableMapModel.Iterator.Iterator_q(it#0)
             && (var key#3 := MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0)); 
              MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.MaxKeyIterate$V, self#0, it#0)
                 && MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, 
                  self#0, 
                  MutableMapModel.__default.IterInc(MutableMapModel._default.MaxKeyIterate$V, 
                    StartFuel_MutableMapModel._default.IterInc, 
                    self#0, 
                    it#0), 
                  (if m#0 < key#3 then key#3 else m#0))))
         && MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LS($ly), self#0, it#0, m#0)
           == (if MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
             then m#0
             else (var key#3 := MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0)); 
              MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, 
                $ly, 
                self#0, 
                MutableMapModel.__default.IterInc(MutableMapModel._default.MaxKeyIterate$V, 
                  StartFuel_MutableMapModel._default.IterInc, 
                  self#0, 
                  it#0), 
                (if m#0 < key#3 then key#3 else m#0)))));

// definition axiom for MutableMapModel.__default.MaxKeyIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      m#0: int :: 
    {:weight 3} { MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LS($ly), self#0, Lit(it#0), m#0) } 
    MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, self#0, Lit(it#0), m#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKeyIterate$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.MaxKeyIterate$V))
           && 
          LitInt(0) <= m#0
           && m#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.MaxKeyIterate$V, self#0)
           && MutableMapModel.__default.WFIter(MutableMapModel._default.MaxKeyIterate$V, self#0, Lit(it#0))
           && (forall key#4: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(key#4)] } 
            LitInt(0) <= key#4
                 && key#4 < 18446744073709551616
                 && Lit(MutableMapModel.Iterator.s(Lit(it#0)))[$Box(key#4)]
               ==> key#4 <= m#0))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && (var key#5 := LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))); 
              MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.MaxKeyIterate$V, self#0, Lit(it#0))
                 && MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, 
                  self#0, 
                  MutableMapModel.__default.IterInc(MutableMapModel._default.MaxKeyIterate$V, 
                    StartFuel_MutableMapModel._default.IterInc, 
                    self#0, 
                    Lit(it#0)), 
                  (if m#0 < key#5 then key#5 else m#0))))
         && MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, $LS($ly), self#0, Lit(it#0), m#0)
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then m#0
             else (var key#5 := LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))); 
              MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, 
                $LS($ly), 
                self#0, 
                MutableMapModel.__default.IterInc(MutableMapModel._default.MaxKeyIterate$V, 
                  StartFuel_MutableMapModel._default.IterInc, 
                  self#0, 
                  Lit(it#0)), 
                (if m#0 < key#5 then key#5 else m#0)))));

// definition axiom for MutableMapModel.__default.MaxKeyIterate for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.MaxKeyIterate$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      m#0: int :: 
    {:weight 3} { MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, 
        $LS($ly), 
        Lit(self#0), 
        Lit(it#0), 
        LitInt(m#0)) } 
    MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, Lit(self#0), Lit(it#0), LitInt(m#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKeyIterate$V))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMapModel._default.MaxKeyIterate$V))
           && 
          LitInt(0) <= m#0
           && m#0 < 18446744073709551616
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.MaxKeyIterate$V, Lit(self#0)))
           && Lit(MutableMapModel.__default.WFIter(MutableMapModel._default.MaxKeyIterate$V, Lit(self#0), Lit(it#0)))
           && (forall key#6: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(key#6)] } 
            LitInt(0) <= key#6
                 && key#6 < 18446744073709551616
                 && Lit(MutableMapModel.Iterator.s(Lit(it#0)))[$Box(key#6)]
               ==> key#6 <= LitInt(m#0)))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && (var key#7 := LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))); 
              MutableMapModel.__default.IterInc#canCall(MutableMapModel._default.MaxKeyIterate$V, Lit(self#0), Lit(it#0))
                 && MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKeyIterate$V, 
                  Lit(self#0), 
                  MutableMapModel.__default.IterInc(MutableMapModel._default.MaxKeyIterate$V, 
                    StartFuel_MutableMapModel._default.IterInc, 
                    Lit(self#0), 
                    Lit(it#0)), 
                  (if m#0 < key#7 then key#7 else m#0))))
         && MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, 
            $LS($ly), 
            Lit(self#0), 
            Lit(it#0), 
            LitInt(m#0))
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then m#0
             else (var key#7 := LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))); 
              MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKeyIterate$V, 
                $LS($ly), 
                Lit(self#0), 
                MutableMapModel.__default.IterInc(MutableMapModel._default.MaxKeyIterate$V, 
                  StartFuel_MutableMapModel._default.IterInc, 
                  Lit(self#0), 
                  Lit(it#0)), 
                (if m#0 < key#7 then key#7 else m#0)))));

// function declaration for MutableMapModel._default.MaxKey
function MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType)
   : int;

function MutableMapModel.__default.MaxKey#canCall(MutableMapModel._default.MaxKey$V: Ty, self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
  { MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LS($ly), self#0) } 
  MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LS($ly), self#0)
     == MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $ly, self#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
  { MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, AsFuelBottom($ly), self#0) } 
  MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $ly, self#0)
     == MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LZ, self#0));

// consequence axiom for MutableMapModel.__default.MaxKey
axiom true
   ==> (forall MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
    { MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $ly, self#0) } 
    MutableMapModel.__default.MaxKey#canCall(MutableMapModel._default.MaxKey$V, self#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKey$V))
           && MutableMapModel.__default.Inv(MutableMapModel._default.MaxKey$V, self#0))
       ==> (forall key#0: int :: 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)] } 
          LitInt(0) <= key#0
               && key#0 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
             ==> key#0
               <= MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $ly, self#0))
         && 
        LitInt(0)
           <= MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $ly, self#0)
         && MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $ly, self#0)
           < 18446744073709551616);

function MutableMapModel.__default.MaxKey#requires(Ty, LayerType, DatatypeType) : bool;

// #requires axiom for MutableMapModel.__default.MaxKey
axiom (forall MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
  { MutableMapModel.__default.MaxKey#requires(MutableMapModel._default.MaxKey$V, $ly, self#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKey$V))
     ==> MutableMapModel.__default.MaxKey#requires(MutableMapModel._default.MaxKey$V, $ly, self#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.MaxKey$V, self#0));

// definition axiom for MutableMapModel.__default.MaxKey(revealed)
axiom true
   ==> (forall MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
    { MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LS($ly), self#0) } 
    MutableMapModel.__default.MaxKey#canCall(MutableMapModel._default.MaxKey$V, self#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKey$V))
           && MutableMapModel.__default.Inv(MutableMapModel._default.MaxKey$V, self#0))
       ==> MutableMapModel.__default.IterStart#canCall(MutableMapModel._default.MaxKey$V, self#0)
         && MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKey$V, 
          self#0, 
          MutableMapModel.__default.IterStart(MutableMapModel._default.MaxKey$V, 
            StartFuel_MutableMapModel._default.IterStart, 
            self#0), 
          LitInt(0))
         && MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LS($ly), self#0)
           == MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKey$V, 
            $LS($LZ), 
            self#0, 
            MutableMapModel.__default.IterStart(MutableMapModel._default.MaxKey$V, 
              StartFuel_MutableMapModel._default.IterStart, 
              self#0), 
            LitInt(0)));

// definition axiom for MutableMapModel.__default.MaxKey for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.MaxKey$V: Ty, $ly: LayerType, self#0: DatatypeType :: 
    {:weight 3} { MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LS($ly), Lit(self#0)) } 
    MutableMapModel.__default.MaxKey#canCall(MutableMapModel._default.MaxKey$V, Lit(self#0))
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.MaxKey$V))
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.MaxKey$V, Lit(self#0))))
       ==> MutableMapModel.__default.IterStart#canCall(MutableMapModel._default.MaxKey$V, Lit(self#0))
         && MutableMapModel.__default.MaxKeyIterate#canCall(MutableMapModel._default.MaxKey$V, 
          Lit(self#0), 
          MutableMapModel.__default.IterStart(MutableMapModel._default.MaxKey$V, 
            StartFuel_MutableMapModel._default.IterStart, 
            Lit(self#0)), 
          LitInt(0))
         && MutableMapModel.__default.MaxKey(MutableMapModel._default.MaxKey$V, $LS($ly), Lit(self#0))
           == MutableMapModel.__default.MaxKeyIterate(MutableMapModel._default.MaxKey$V, 
            $LS($LZ), 
            Lit(self#0), 
            MutableMapModel.__default.IterStart(MutableMapModel._default.MaxKey$V, 
              StartFuel_MutableMapModel._default.IterStart, 
              Lit(self#0)), 
            LitInt(0)));

// function declaration for MutableMapModel._default.UpdateByIter
function MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    value#0: Box)
   : DatatypeType;

function MutableMapModel.__default.UpdateByIter#canCall(MutableMapModel._default.UpdateByIter$V: Ty, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    value#0: Box)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    value#0: Box :: 
  { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $LS($ly), self#0, it#0, value#0) } 
  MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $LS($ly), self#0, it#0, value#0)
     == MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    value#0: Box :: 
  { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, 
      AsFuelBottom($ly), 
      self#0, 
      it#0, 
      value#0) } 
  MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0)
     == MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $LZ, self#0, it#0, value#0));

// consequence axiom for MutableMapModel.__default.UpdateByIter
axiom true
   ==> (forall MutableMapModel._default.UpdateByIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      value#0: Box :: 
    { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0) } 
    MutableMapModel.__default.UpdateByIter#canCall(MutableMapModel._default.UpdateByIter$V, self#0, it#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && $IsBox(value#0, MutableMapModel._default.UpdateByIter$V)
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.UpdateByIter$V, self#0)
           && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdateByIter$V, self#0, it#0)
           && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, self#0, it#0)))
       ==> MutableMapModel.__default.Inv(MutableMapModel._default.UpdateByIter$V, 
          MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0))
         && Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0)), 
          Map#Build(MutableMapModel.LinearHashMap.contents(self#0), 
            $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, self#0, it#0))), 
            value#0))
         && MutableMapModel.LinearHashMap.count(MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0))
           == MutableMapModel.LinearHashMap.count(self#0)
         && $Is(MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0), 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V)));

function MutableMapModel.__default.UpdateByIter#requires(Ty, LayerType, DatatypeType, DatatypeType, Box) : bool;

// #requires axiom for MutableMapModel.__default.UpdateByIter
axiom (forall MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    it#0: DatatypeType, 
    value#0: Box :: 
  { MutableMapModel.__default.UpdateByIter#requires(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V))
       && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
       && $IsBox(value#0, MutableMapModel._default.UpdateByIter$V)
     ==> MutableMapModel.__default.UpdateByIter#requires(MutableMapModel._default.UpdateByIter$V, $ly, self#0, it#0, value#0)
       == (
        MutableMapModel.__default.Inv(MutableMapModel._default.UpdateByIter$V, self#0)
         && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdateByIter$V, self#0, it#0)
         && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, self#0, it#0))));

// definition axiom for MutableMapModel.__default.UpdateByIter(revealed)
axiom true
   ==> (forall MutableMapModel._default.UpdateByIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      value#0: Box :: 
    { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $LS($ly), self#0, it#0, value#0) } 
    MutableMapModel.__default.UpdateByIter#canCall(MutableMapModel._default.UpdateByIter$V, self#0, it#0, value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && $IsBox(value#0, MutableMapModel._default.UpdateByIter$V)
           && 
          MutableMapModel.__default.Inv(MutableMapModel._default.UpdateByIter$V, self#0)
           && MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdateByIter$V, self#0, it#0)
           && MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, self#0, it#0)))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.SimpleIterator.SimpleIterator_q(it#0)
         && MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.UpdateByIter$V, 
          MutableMapModel.LinearHashMap.underlying(self#0), 
          MutableMapModel.SimpleIterator.i(it#0), 
          value#0)
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.UpdateByIter$V, self#0, it#0)
         && MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $LS($ly), self#0, it#0, value#0)
           == (var underlying#0 := MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.UpdateByIter$V, 
                MutableMapModel.LinearHashMap.underlying(self#0), 
                MutableMapModel.SimpleIterator.i(it#0), 
                value#0); 
            (var self'#0 := #MutableMapModel.LinearHashMap.LinearHashMap(underlying#0, 
                  MutableMapModel.LinearHashMap.count(self#0), 
                  Map#Build(MutableMapModel.LinearHashMap.contents(self#0), 
                    $Box(MutableMapModel.IteratorOutput.key(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, self#0, it#0))), 
                    value#0)); 
              self'#0)));

// definition axiom for MutableMapModel.__default.UpdateByIter for decreasing-related literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.UpdateByIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, 
        $LS($ly), 
        Lit(self#0), 
        Lit(it#0), 
        value#0) } 
    MutableMapModel.__default.UpdateByIter#canCall(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0), value#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && $IsBox(value#0, MutableMapModel._default.UpdateByIter$V)
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.UpdateByIter$V, Lit(self#0)))
           && Lit(MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0)))
           && Lit(MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0))))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.SimpleIterator.SimpleIterator_q(Lit(it#0))
         && MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.UpdateByIter$V, 
          Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
          LitInt(MutableMapModel.SimpleIterator.i(Lit(it#0))), 
          value#0)
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0))
         && MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, 
            $LS($ly), 
            Lit(self#0), 
            Lit(it#0), 
            value#0)
           == (var underlying#1 := MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.UpdateByIter$V, 
                Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                LitInt(MutableMapModel.SimpleIterator.i(Lit(it#0))), 
                value#0); 
            (var self'#1 := #MutableMapModel.LinearHashMap.LinearHashMap(underlying#1, 
                  LitInt(MutableMapModel.LinearHashMap.count(Lit(self#0))), 
                  Map#Build(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))), 
                    $Box(LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0)))))), 
                    value#0)); 
              self'#1)));

// definition axiom for MutableMapModel.__default.UpdateByIter for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.UpdateByIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      it#0: DatatypeType, 
      value#0: Box :: 
    {:weight 3} { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, 
        $LS($ly), 
        Lit(self#0), 
        Lit(it#0), 
        Lit(value#0)) } 
    MutableMapModel.__default.UpdateByIter#canCall(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0), Lit(value#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V))
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && $IsBox(value#0, MutableMapModel._default.UpdateByIter$V)
           && 
          Lit(MutableMapModel.__default.Inv(MutableMapModel._default.UpdateByIter$V, Lit(self#0)))
           && Lit(MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0)))
           && Lit(MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0))))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.SimpleIterator.SimpleIterator_q(Lit(it#0))
         && MutableMapModel.__default.FixedSizeUpdateBySlot#canCall(MutableMapModel._default.UpdateByIter$V, 
          Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
          LitInt(MutableMapModel.SimpleIterator.i(Lit(it#0))), 
          Lit(value#0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && 
        MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.SimpleIterOutput#canCall(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0))
         && MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, 
            $LS($ly), 
            Lit(self#0), 
            Lit(it#0), 
            Lit(value#0))
           == (var underlying#2 := Lit(MutableMapModel.__default.FixedSizeUpdateBySlot(MutableMapModel._default.UpdateByIter$V, 
                  Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                  LitInt(MutableMapModel.SimpleIterator.i(Lit(it#0))), 
                  Lit(value#0))); 
            (var self'#2 := #MutableMapModel.LinearHashMap.LinearHashMap(underlying#2, 
                  LitInt(MutableMapModel.LinearHashMap.count(Lit(self#0))), 
                  Map#Build(Lit(MutableMapModel.LinearHashMap.contents(Lit(self#0))), 
                    $Box(LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.UpdateByIter$V, Lit(self#0), Lit(it#0)))))), 
                    Lit(value#0))); 
              self'#2)));

procedure CheckWellformed$$MutableMapModel.__default.UpdatePreservesSimpleIter(MutableMapModel._default.UpdatePreservesSimpleIter$V: Ty, 
    self#0: DatatypeType
       where $Is(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdatePreservesSimpleIter$V))
         && $IsAlloc(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdatePreservesSimpleIter$V), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(self#0), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0), 
    value#0: Box
       where $IsBox(value#0, MutableMapModel._default.UpdatePreservesSimpleIter$V)
         && $IsAllocBox(value#0, MutableMapModel._default.UpdatePreservesSimpleIter$V, $Heap), 
    preserved#0: DatatypeType
       where $Is(preserved#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(preserved#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(preserved#0));
  free requires 114 == $FunctionContextHeight;
  modifies $Heap, $Tick;



function MutableMapModel.__default.UpdateByIter#Handle(Ty, LayerType) : HandleType;

axiom (forall MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box :: 
  { Apply3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      Tclass.MutableMapModel.SimpleIterator(), 
      MutableMapModel._default.UpdateByIter$V, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      $heap, 
      MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2) } 
  Apply3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      Tclass.MutableMapModel.SimpleIterator(), 
      MutableMapModel._default.UpdateByIter$V, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      $heap, 
      MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2)
     == $Box(MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, 
        $ly, 
        $Unbox($fh$0x#0): DatatypeType, 
        $Unbox($fh$0x#1): DatatypeType, 
        $fh$0x#2)));

axiom (forall MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box :: 
  { Requires3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      Tclass.MutableMapModel.SimpleIterator(), 
      MutableMapModel._default.UpdateByIter$V, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      $heap, 
      MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2) } 
  Requires3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      Tclass.MutableMapModel.SimpleIterator(), 
      MutableMapModel._default.UpdateByIter$V, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      $heap, 
      MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2)
     == MutableMapModel.__default.UpdateByIter#requires(MutableMapModel._default.UpdateByIter$V, 
      $ly, 
      $Unbox($fh$0x#0): DatatypeType, 
      $Unbox($fh$0x#1): DatatypeType, 
      $fh$0x#2));

axiom (forall $bx: Box, 
    MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: Box, 
    $fh$0x#1: Box, 
    $fh$0x#2: Box :: 
  { Reads3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      Tclass.MutableMapModel.SimpleIterator(), 
      MutableMapModel._default.UpdateByIter$V, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      $heap, 
      MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2)[$bx] } 
  Reads3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      Tclass.MutableMapModel.SimpleIterator(), 
      MutableMapModel._default.UpdateByIter$V, 
      Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
      $heap, 
      MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
      $fh$0x#0, 
      $fh$0x#1, 
      $fh$0x#2)[$bx]
     == false);

axiom (forall MutableMapModel._default.UpdateByIter$V: Ty, 
    $ly: LayerType, 
    $heap: Heap, 
    $fh$0x#0: DatatypeType, 
    $fh$0x#1: DatatypeType, 
    $fh$0x#2: Box :: 
  { MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, $fh$0x#0, $fh$0x#1, $fh$0x#2), $IsGoodHeap($heap) } 
  MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdateByIter$V, $ly, $fh$0x#0, $fh$0x#1, $fh$0x#2)
     == $Unbox(Apply3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
        Tclass.MutableMapModel.SimpleIterator(), 
        MutableMapModel._default.UpdateByIter$V, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdateByIter$V), 
        $heap, 
        MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdateByIter$V, $ly), 
        $Box($fh$0x#0), 
        $Box($fh$0x#1), 
        $fh$0x#2)): DatatypeType);

procedure Call$$MutableMapModel.__default.UpdatePreservesSimpleIter(MutableMapModel._default.UpdatePreservesSimpleIter$V: Ty, 
    self#0: DatatypeType
       where $Is(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdatePreservesSimpleIter$V))
         && $IsAlloc(self#0, 
          Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdatePreservesSimpleIter$V), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(self#0), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0), 
    value#0: Box
       where $IsBox(value#0, MutableMapModel._default.UpdatePreservesSimpleIter$V)
         && $IsAllocBox(value#0, MutableMapModel._default.UpdatePreservesSimpleIter$V, $Heap), 
    preserved#0: DatatypeType
       where $Is(preserved#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(preserved#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(preserved#0));
  // user-defined preconditions
  requires Requires3(Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdatePreservesSimpleIter$V), 
    Tclass.MutableMapModel.SimpleIterator(), 
    MutableMapModel._default.UpdatePreservesSimpleIter$V, 
    Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.UpdatePreservesSimpleIter$V), 
    $Heap, 
    MutableMapModel.__default.UpdateByIter#Handle(MutableMapModel._default.UpdatePreservesSimpleIter$V, 
      StartFuelAssert_MutableMapModel._default.UpdateByIter), 
    $Box(self#0), 
    $Box(it#0), 
    value#0);
  requires MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdatePreservesSimpleIter$V, self#0, preserved#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMapModel.__default.UpdateByIter#canCall(MutableMapModel._default.UpdatePreservesSimpleIter$V, self#0, it#0, value#0)
     && MutableMapModel.__default.WFSimpleIter#canCall(MutableMapModel._default.UpdatePreservesSimpleIter$V, 
      MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdatePreservesSimpleIter$V, 
        StartFuel_MutableMapModel._default.UpdateByIter, 
        self#0, 
        it#0, 
        value#0), 
      preserved#0);
  ensures MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.UpdatePreservesSimpleIter$V, 
    MutableMapModel.__default.UpdateByIter(MutableMapModel._default.UpdatePreservesSimpleIter$V, 
      StartFuelAssert_MutableMapModel._default.UpdateByIter, 
      self#0, 
      it#0, 
      value#0), 
    preserved#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for MutableMapModel._default.setUpTo
function MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V: Ty, self#0: DatatypeType, i#0: int)
   : Set Box;

function MutableMapModel.__default.setUpTo#canCall(MutableMapModel._default.setUpTo$V: Ty, self#0: DatatypeType, i#0: int) : bool;

// consequence axiom for MutableMapModel.__default.setUpTo
axiom true
   ==> (forall MutableMapModel._default.setUpTo$V: Ty, self#0: DatatypeType, i#0: int :: 
    { MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V, self#0, i#0) } 
    MutableMapModel.__default.setUpTo#canCall(MutableMapModel._default.setUpTo$V, self#0, i#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.setUpTo$V))
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> $Is(MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V, self#0, i#0), 
        TSet(Tclass.NativeTypes.uint64())));

function MutableMapModel.__default.setUpTo#requires(Ty, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.setUpTo
axiom (forall MutableMapModel._default.setUpTo$V: Ty, self#0: DatatypeType, i#0: int :: 
  { MutableMapModel.__default.setUpTo#requires(MutableMapModel._default.setUpTo$V, self#0, i#0) } 
  $Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.setUpTo$V))
     ==> MutableMapModel.__default.setUpTo#requires(MutableMapModel._default.setUpTo$V, self#0, i#0)
       == (LitInt(0) <= i#0
         && i#0
           <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))));

// definition axiom for MutableMapModel.__default.setUpTo(revealed)
axiom true
   ==> (forall MutableMapModel._default.setUpTo$V: Ty, self#0: DatatypeType, i#0: int :: 
    { MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V, self#0, i#0) } 
    MutableMapModel.__default.setUpTo#canCall(MutableMapModel._default.setUpTo$V, self#0, i#0)
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.setUpTo$V))
           && 
          LitInt(0) <= i#0
           && i#0
             <= Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0))))
       ==> (forall j#0: int :: 
          { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                j#0)): DatatypeType } 
          (j#0 < i#0
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (LitInt(0) <= j#0
                 && j#0 < i#0
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      j#0)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))))
         && MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V, self#0, i#0)
           == (lambda $y#0: Box :: 
            (exists j#0: int :: 
              { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    j#0)): DatatypeType } 
              LitInt(0) <= j#0
                 && j#0 < i#0
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                      j#0)): DatatypeType)
                 && $y#0
                   == $Box(MutableMapModel.Item.key($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                          j#0)): DatatypeType)))));

// definition axiom for MutableMapModel.__default.setUpTo for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.setUpTo$V: Ty, self#0: DatatypeType, i#0: int :: 
    {:weight 3} { MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V, Lit(self#0), LitInt(i#0)) } 
    MutableMapModel.__default.setUpTo#canCall(MutableMapModel._default.setUpTo$V, Lit(self#0), LitInt(i#0))
         || ($Is(self#0, Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.setUpTo$V))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0)
             <= Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))))
       ==> (forall j#1: int :: 
          { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                j#1)): DatatypeType } 
          (j#1 < i#0
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (LitInt(0) <= j#1
                 && j#1 < i#0
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                      j#1)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
         && MutableMapModel.__default.setUpTo(MutableMapModel._default.setUpTo$V, Lit(self#0), LitInt(i#0))
           == (lambda $y#1: Box :: 
            (exists j#1: int :: 
              { $Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    j#1)): DatatypeType } 
              LitInt(0) <= j#1
                 && j#1 < i#0
                 && MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                      j#1)): DatatypeType)
                 && $y#1
                   == $Box(MutableMapModel.Item.key($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                          j#1)): DatatypeType)))));

// function declaration for MutableMapModel._default.FindSimpleIter
function MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int)
   : DatatypeType;

function MutableMapModel.__default.FindSimpleIter#canCall(MutableMapModel._default.FindSimpleIter$V: Ty, self#0: DatatypeType, key#0: int)
   : bool;

// layer synonym axiom
axiom (forall MutableMapModel._default.FindSimpleIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LS($ly), self#0, key#0) } 
  MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LS($ly), self#0, key#0)
     == MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0));

// fuel synonym axiom
axiom (forall MutableMapModel._default.FindSimpleIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, AsFuelBottom($ly), self#0, key#0) } 
  MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0)
     == MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LZ, self#0, key#0));

// consequence axiom for MutableMapModel.__default.FindSimpleIter
axiom true
   ==> (forall MutableMapModel._default.FindSimpleIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0) } 
    MutableMapModel.__default.FindSimpleIter#canCall(MutableMapModel._default.FindSimpleIter$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.FindSimpleIter$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.FindSimpleIter$V, self#0))
       ==> MutableMapModel.__default.WFSimpleIter(MutableMapModel._default.FindSimpleIter$V, 
          self#0, 
          MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0))
         && (Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
           ==> MutableMapModel.IteratorOutput#Equal(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.FindSimpleIter$V, 
              self#0, 
              MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0)), 
            #MutableMapModel.IteratorOutput.Next(key#0, Map#Elements(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)])))
         && (!Map#Domain(MutableMapModel.LinearHashMap.contents(self#0))[$Box(key#0)]
           ==> MutableMapModel.IteratorOutput#Equal(MutableMapModel.__default.SimpleIterOutput(MutableMapModel._default.FindSimpleIter$V, 
              self#0, 
              MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0)), 
            #MutableMapModel.IteratorOutput.Done()))
         && $Is(MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0), 
          Tclass.MutableMapModel.SimpleIterator()));

function MutableMapModel.__default.FindSimpleIter#requires(Ty, LayerType, DatatypeType, int) : bool;

// #requires axiom for MutableMapModel.__default.FindSimpleIter
axiom (forall MutableMapModel._default.FindSimpleIter$V: Ty, 
    $ly: LayerType, 
    self#0: DatatypeType, 
    key#0: int :: 
  { MutableMapModel.__default.FindSimpleIter#requires(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0) } 
  $Is(self#0, 
        Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.FindSimpleIter$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 18446744073709551616
     ==> MutableMapModel.__default.FindSimpleIter#requires(MutableMapModel._default.FindSimpleIter$V, $ly, self#0, key#0)
       == MutableMapModel.__default.Inv(MutableMapModel._default.FindSimpleIter$V, self#0));

// definition axiom for MutableMapModel.__default.FindSimpleIter(revealed)
axiom true
   ==> (forall MutableMapModel._default.FindSimpleIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    { MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LS($ly), self#0, key#0) } 
    MutableMapModel.__default.FindSimpleIter#canCall(MutableMapModel._default.FindSimpleIter$V, self#0, key#0)
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.FindSimpleIter$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && MutableMapModel.__default.Inv(MutableMapModel._default.FindSimpleIter$V, self#0))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
         && MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FindSimpleIter$V, 
          MutableMapModel.LinearHashMap.underlying(self#0), 
          key#0)
         && (var idx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FindSimpleIter$V, 
              StartFuel_MutableMapModel._default.Probe, 
              MutableMapModel.LinearHashMap.underlying(self#0), 
              key#0); 
          MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))
             && (!MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                    idx#0)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0)))
             && (var i#0 := (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        idx#0)): DatatypeType)
                   then idx#0
                   else Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))); 
              MutableMapModel.__default.setUpTo#canCall(MutableMapModel._default.FindSimpleIter$V, self#0, i#0)
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(self#0)
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(MutableMapModel.LinearHashMap.underlying(self#0))))
         && MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LS($ly), self#0, key#0)
           == (var idx#0 := MutableMapModel.__default.Probe(MutableMapModel._default.FindSimpleIter$V, 
                StartFuel_MutableMapModel._default.Probe, 
                MutableMapModel.LinearHashMap.underlying(self#0), 
                key#0); 
            (var i#0 := (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)), 
                        idx#0)): DatatypeType)
                   then idx#0
                   else Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))); 
              (var it#0 := #MutableMapModel.SimpleIterator.SimpleIterator(i#0, 
                    MutableMapModel.__default.setUpTo(MutableMapModel._default.FindSimpleIter$V, self#0, i#0), 
                    ORD#FromNat(Seq#Length(MutableMapModel.FixedSizeLinearHashMap.storage(MutableMapModel.LinearHashMap.underlying(self#0)))
                         - i#0)); 
                it#0))));

// definition axiom for MutableMapModel.__default.FindSimpleIter for all literals(revealed)
axiom true
   ==> (forall MutableMapModel._default.FindSimpleIter$V: Ty, 
      $ly: LayerType, 
      self#0: DatatypeType, 
      key#0: int :: 
    {:weight 3} { MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LS($ly), Lit(self#0), LitInt(key#0)) } 
    MutableMapModel.__default.FindSimpleIter#canCall(MutableMapModel._default.FindSimpleIter$V, Lit(self#0), LitInt(key#0))
         || (
          $Is(self#0, 
            Tclass.MutableMapModel.LinearHashMap(MutableMapModel._default.FindSimpleIter$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 18446744073709551616
           && Lit(MutableMapModel.__default.Inv(MutableMapModel._default.FindSimpleIter$V, Lit(self#0))))
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
         && MutableMapModel.__default.Probe#canCall(MutableMapModel._default.FindSimpleIter$V, 
          Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
          LitInt(key#0))
         && (var idx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FindSimpleIter$V, 
              StartFuel_MutableMapModel._default.Probe, 
              Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
              LitInt(key#0)); 
          MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
             && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))
             && (!MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                    idx#1)): DatatypeType)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0)))))
             && (var i#1 := (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        idx#1)): DatatypeType)
                   then idx#1
                   else Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))); 
              MutableMapModel.__default.setUpTo#canCall(MutableMapModel._default.FindSimpleIter$V, Lit(self#0), i#1)
                 && 
                MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(self#0))
                 && MutableMapModel.FixedSizeLinearHashMap.FixedSizeLinearHashMap_q(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
         && MutableMapModel.__default.FindSimpleIter(MutableMapModel._default.FindSimpleIter$V, $LS($ly), Lit(self#0), LitInt(key#0))
           == (var idx#1 := MutableMapModel.__default.Probe(MutableMapModel._default.FindSimpleIter$V, 
                StartFuel_MutableMapModel._default.Probe, 
                Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))), 
                LitInt(key#0)); 
            (var i#1 := (if MutableMapModel.Item.Entry_q($Unbox(Seq#Index(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))), 
                        idx#1)): DatatypeType)
                   then idx#1
                   else Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))); 
              (var it#1 := #MutableMapModel.SimpleIterator.SimpleIterator(i#1, 
                    MutableMapModel.__default.setUpTo(MutableMapModel._default.FindSimpleIter$V, Lit(self#0), i#1), 
                    ORD#FromNat(Seq#Length(Lit(MutableMapModel.FixedSizeLinearHashMap.storage(Lit(MutableMapModel.LinearHashMap.underlying(Lit(self#0))))))
                         - i#1)); 
                it#1))));

const unique class.MutableMap.FixedSizeHashMap?: ClassName;

function Tclass.MutableMap.FixedSizeHashMap?(Ty) : Ty;

// Tclass.MutableMap.FixedSizeHashMap? Tag
axiom (forall MutableMap.FixedSizeHashMap$V: Ty :: 
  { Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  Tag(Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V))
     == Tagclass.MutableMap.FixedSizeHashMap?);

const unique Tagclass.MutableMap.FixedSizeHashMap?: TyTag;

// Tclass.MutableMap.FixedSizeHashMap? injectivity 0
axiom (forall MutableMap.FixedSizeHashMap$V: Ty :: 
  { Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  Tclass.MutableMap.FixedSizeHashMap?_0(Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V))
     == MutableMap.FixedSizeHashMap$V);

function Tclass.MutableMap.FixedSizeHashMap?_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMap.FixedSizeHashMap?
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)) } 
  $IsBox(bx, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, 
        Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)));

// FixedSizeHashMap: Class $Is
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $o: ref :: 
  { $Is($o, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)) } 
  $Is($o, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V))
     <==> $o == null
       || dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V));

// FixedSizeHashMap: Class $IsAlloc
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V), $h) } 
  $IsAlloc($o, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(MutableMap.FixedSizeHashMap.Storage) == 0
   && FieldOfDecl(class.MutableMap.FixedSizeHashMap?, field$Storage)
     == MutableMap.FixedSizeHashMap.Storage
   && !$IsGhostField(MutableMap.FixedSizeHashMap.Storage);

const MutableMap.FixedSizeHashMap.Storage: Field ref;

// FixedSizeHashMap.Storage: Type axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Storage), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
     ==> $Is(read($h, $o, MutableMap.FixedSizeHashMap.Storage), 
      Tclass._System.array(Tclass.MutableMapModel.Item(MutableMap.FixedSizeHashMap$V))));

// FixedSizeHashMap.Storage: Allocation axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Storage), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.FixedSizeHashMap.Storage), 
      Tclass._System.array(Tclass.MutableMapModel.Item(MutableMap.FixedSizeHashMap$V)), 
      $h));

axiom FDim(MutableMap.FixedSizeHashMap.Count) == 0
   && FieldOfDecl(class.MutableMap.FixedSizeHashMap?, field$Count)
     == MutableMap.FixedSizeHashMap.Count
   && !$IsGhostField(MutableMap.FixedSizeHashMap.Count);

const MutableMap.FixedSizeHashMap.Count: Field int;

// FixedSizeHashMap.Count: Type axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Count), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
     ==> $Is(read($h, $o, MutableMap.FixedSizeHashMap.Count), Tclass.NativeTypes.uint64()));

// FixedSizeHashMap.Count: Allocation axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Count), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.FixedSizeHashMap.Count), Tclass.NativeTypes.uint64(), $h));

axiom FDim(MutableMap.FixedSizeHashMap.Contents) == 0
   && FieldOfDecl(class.MutableMap.FixedSizeHashMap?, field$Contents)
     == MutableMap.FixedSizeHashMap.Contents
   && $IsGhostField(MutableMap.FixedSizeHashMap.Contents);

const MutableMap.FixedSizeHashMap.Contents: Field (Map Box Box);

// FixedSizeHashMap.Contents: Type axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Contents), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
     ==> $Is(read($h, $o, MutableMap.FixedSizeHashMap.Contents), 
      TMap(Tclass.NativeTypes.uint64(), 
        Tclass.Options.Option(MutableMap.FixedSizeHashMap$V))));

// FixedSizeHashMap.Contents: Allocation axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Contents), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.FixedSizeHashMap.Contents), 
      TMap(Tclass.NativeTypes.uint64(), 
        Tclass.Options.Option(MutableMap.FixedSizeHashMap$V)), 
      $h));

axiom FDim(MutableMap.FixedSizeHashMap.Repr) == 0
   && FieldOfDecl(class.MutableMap.FixedSizeHashMap?, field$Repr)
     == MutableMap.FixedSizeHashMap.Repr
   && $IsGhostField(MutableMap.FixedSizeHashMap.Repr);

const MutableMap.FixedSizeHashMap.Repr: Field (Set Box);

// FixedSizeHashMap.Repr: Type axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Repr), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
     ==> $Is(read($h, $o, MutableMap.FixedSizeHashMap.Repr), TSet(Tclass._System.object())));

// FixedSizeHashMap.Repr: Allocation axiom
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.FixedSizeHashMap.Repr), Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.FixedSizeHashMap.Repr), 
      TSet(Tclass._System.object()), 
      $h));

// function declaration for MutableMap.FixedSizeHashMap.WF
function MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V: Ty, $heap: Heap, this: ref) : bool;

function MutableMap.FixedSizeHashMap.WF#canCall(MutableMap.FixedSizeHashMap$V: Ty, $heap: Heap, this: ref) : bool;

function Tclass.MutableMap.FixedSizeHashMap(Ty) : Ty;

// Tclass.MutableMap.FixedSizeHashMap Tag
axiom (forall MutableMap.FixedSizeHashMap$V: Ty :: 
  { Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V) } 
  Tag(Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
     == Tagclass.MutableMap.FixedSizeHashMap);

const unique Tagclass.MutableMap.FixedSizeHashMap: TyTag;

// Tclass.MutableMap.FixedSizeHashMap injectivity 0
axiom (forall MutableMap.FixedSizeHashMap$V: Ty :: 
  { Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V) } 
  Tclass.MutableMap.FixedSizeHashMap_0(Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
     == MutableMap.FixedSizeHashMap$V);

function Tclass.MutableMap.FixedSizeHashMap_0(Ty) : Ty;

// Box/unbox axiom for Tclass.MutableMap.FixedSizeHashMap
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, bx: Box :: 
  { $IsBox(bx, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V)) } 
  $IsBox(bx, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, 
        Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V)));

// frame axiom for MutableMap.FixedSizeHashMap.WF
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && $o == this ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $h0, this)
       == MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $h1, this));

// consequence axiom for MutableMap.FixedSizeHashMap.WF
axiom true
   ==> (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, this) } 
    MutableMap.FixedSizeHashMap.WF#canCall(MutableMap.FixedSizeHashMap$V, $Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $Heap))
       ==> true);

function MutableMap.FixedSizeHashMap.WF#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.FixedSizeHashMap.WF
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, this: ref :: 
  { MutableMap.FixedSizeHashMap.WF#requires(MutableMap.FixedSizeHashMap$V, $Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
       && $IsAlloc(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $Heap)
     ==> MutableMap.FixedSizeHashMap.WF#requires(MutableMap.FixedSizeHashMap$V, $Heap, this)
       == true);

// definition axiom for MutableMap.FixedSizeHashMap.WF(revealed)
axiom true
   ==> (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, this) } 
    MutableMap.FixedSizeHashMap.WF#canCall(MutableMap.FixedSizeHashMap$V, $Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $Heap))
       ==> MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, this)
         == (true
           && Set#Equal(read($Heap, this, MutableMap.FixedSizeHashMap.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, MutableMap.FixedSizeHashMap.Storage))))));

// function declaration for MutableMap.FixedSizeHashMap.ModelI
function MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V: Ty, $heap: Heap, self#0: ref) : DatatypeType;

function MutableMap.FixedSizeHashMap.ModelI#canCall(MutableMap.FixedSizeHashMap$V: Ty, $heap: Heap, self#0: ref) : bool;

// frame axiom for MutableMap.FixedSizeHashMap.ModelI
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h0: Heap, $h1: Heap, self#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $h1, self#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (MutableMap.FixedSizeHashMap.ModelI#canCall(MutableMap.FixedSizeHashMap$V, $h0, self#0)
         || $Is(self#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V)))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == self#0 || read($h0, self#0, MutableMap.FixedSizeHashMap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $h0, self#0)
       == MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $h1, self#0));

// consequence axiom for MutableMap.FixedSizeHashMap.ModelI
axiom true
   ==> (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, self#0: ref :: 
    { MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $Heap, self#0) } 
    MutableMap.FixedSizeHashMap.ModelI#canCall(MutableMap.FixedSizeHashMap$V, $Heap, self#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(self#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
           && MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, self#0))
       ==> Map#Equal(MutableMapModel.FixedSizeLinearHashMap.contents(MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $Heap, self#0)), 
          read($Heap, self#0, MutableMap.FixedSizeHashMap.Contents))
         && $Is(MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $Heap, self#0), 
          Tclass.MutableMapModel.FixedSizeLinearHashMap(MutableMap.FixedSizeHashMap$V)));

function MutableMap.FixedSizeHashMap.ModelI#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.FixedSizeHashMap.ModelI
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, self#0: ref :: 
  { MutableMap.FixedSizeHashMap.ModelI#requires(MutableMap.FixedSizeHashMap$V, $Heap, self#0) } 
  $IsGoodHeap($Heap)
       && $Is(self#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
     ==> MutableMap.FixedSizeHashMap.ModelI#requires(MutableMap.FixedSizeHashMap$V, $Heap, self#0)
       == MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, self#0));

// definition axiom for MutableMap.FixedSizeHashMap.ModelI(revealed)
axiom true
   ==> (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, self#0: ref :: 
    { MutableMap.FixedSizeHashMap.ModelI(MutableMap.FixedSizeHashMap$V, $Heap, self#0) } 
    MutableMap.FixedSizeHashMap.ModelI#canCall(MutableMap.FixedSizeHashMap$V, $Heap, self#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(self#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
           && MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, self#0))
       ==> true);

// function declaration for MutableMap.FixedSizeHashMap.Inv
function MutableMap.FixedSizeHashMap.Inv(MutableMap.FixedSizeHashMap$V: Ty, $heap: Heap, this: ref) : bool;

function MutableMap.FixedSizeHashMap.Inv#canCall(MutableMap.FixedSizeHashMap$V: Ty, $heap: Heap, this: ref) : bool;

// frame axiom for MutableMap.FixedSizeHashMap.Inv
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.FixedSizeHashMap.Inv(MutableMap.FixedSizeHashMap$V, $h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, MutableMap.FixedSizeHashMap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.FixedSizeHashMap.Inv(MutableMap.FixedSizeHashMap$V, $h0, this)
       == MutableMap.FixedSizeHashMap.Inv(MutableMap.FixedSizeHashMap$V, $h1, this));

// consequence axiom for MutableMap.FixedSizeHashMap.Inv
axiom true
   ==> (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.FixedSizeHashMap.Inv(MutableMap.FixedSizeHashMap$V, $Heap, this) } 
    MutableMap.FixedSizeHashMap.Inv#canCall(MutableMap.FixedSizeHashMap$V, $Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $Heap)
           && MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, this))
       ==> true);

function MutableMap.FixedSizeHashMap.Inv#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.FixedSizeHashMap.Inv
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, this: ref :: 
  { MutableMap.FixedSizeHashMap.Inv#requires(MutableMap.FixedSizeHashMap$V, $Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
       && $IsAlloc(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $Heap)
     ==> MutableMap.FixedSizeHashMap.Inv#requires(MutableMap.FixedSizeHashMap$V, $Heap, this)
       == MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, this));

// definition axiom for MutableMap.FixedSizeHashMap.Inv(revealed)
axiom true
   ==> (forall MutableMap.FixedSizeHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.FixedSizeHashMap.Inv(MutableMap.FixedSizeHashMap$V, $Heap, this) } 
    MutableMap.FixedSizeHashMap.Inv#canCall(MutableMap.FixedSizeHashMap$V, $Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $Heap)
           && MutableMap.FixedSizeHashMap.WF(MutableMap.FixedSizeHashMap$V, $Heap, this))
       ==> true);

// MutableMap.FixedSizeHashMap: subset type $Is
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, c#0: ref :: 
  { $Is(c#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V)) } 
  $Is(c#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V))
     <==> $Is(c#0, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V))
       && c#0 != null);

// MutableMap.FixedSizeHashMap: subset type $IsAlloc
axiom (forall MutableMap.FixedSizeHashMap$V: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $h) } 
  $IsAlloc(c#0, Tclass.MutableMap.FixedSizeHashMap(MutableMap.FixedSizeHashMap$V), $h)
     <==> $IsAlloc(c#0, Tclass.MutableMap.FixedSizeHashMap?(MutableMap.FixedSizeHashMap$V), $h));

const unique class.MutableMap.ResizingHashMap?: ClassName;

// ResizingHashMap: Class $Is
axiom (forall MutableMap.ResizingHashMap$V: Ty, $o: ref :: 
  { $Is($o, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)) } 
  $Is($o, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V))
     <==> $o == null
       || dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V));

// ResizingHashMap: Class $IsAlloc
axiom (forall MutableMap.ResizingHashMap$V: Ty, $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V), $h) } 
  $IsAlloc($o, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(MutableMap.ResizingHashMap.Underlying) == 0
   && FieldOfDecl(class.MutableMap.ResizingHashMap?, field$Underlying)
     == MutableMap.ResizingHashMap.Underlying
   && !$IsGhostField(MutableMap.ResizingHashMap.Underlying);

const MutableMap.ResizingHashMap.Underlying: Field ref;

// ResizingHashMap.Underlying: Type axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Underlying), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
     ==> $Is(read($h, $o, MutableMap.ResizingHashMap.Underlying), 
      Tclass.MutableMap.FixedSizeHashMap(MutableMap.ResizingHashMap$V)));

// ResizingHashMap.Underlying: Allocation axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Underlying), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.ResizingHashMap.Underlying), 
      Tclass.MutableMap.FixedSizeHashMap(MutableMap.ResizingHashMap$V), 
      $h));

const MutableMap.ResizingHashMap.Count: Field int;

// ResizingHashMap.Count: Type axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Count), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
     ==> $Is(read($h, $o, MutableMap.ResizingHashMap.Count), Tclass.NativeTypes.uint64()));

// ResizingHashMap.Count: Allocation axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Count), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.ResizingHashMap.Count), Tclass.NativeTypes.uint64(), $h));

axiom FDim(MutableMap.ResizingHashMap.Contents) == 0
   && FieldOfDecl(class.MutableMap.ResizingHashMap?, field$Contents)
     == MutableMap.ResizingHashMap.Contents
   && $IsGhostField(MutableMap.ResizingHashMap.Contents);

const MutableMap.ResizingHashMap.Contents: Field (Map Box Box);

// ResizingHashMap.Contents: Type axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Contents), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
     ==> $Is(read($h, $o, MutableMap.ResizingHashMap.Contents), 
      TMap(Tclass.NativeTypes.uint64(), MutableMap.ResizingHashMap$V)));

// ResizingHashMap.Contents: Allocation axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Contents), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.ResizingHashMap.Contents), 
      TMap(Tclass.NativeTypes.uint64(), MutableMap.ResizingHashMap$V), 
      $h));

const MutableMap.ResizingHashMap.Repr: Field (Set Box);

// ResizingHashMap.Repr: Type axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Repr), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
     ==> $Is(read($h, $o, MutableMap.ResizingHashMap.Repr), TSet(Tclass._System.object())));

// ResizingHashMap.Repr: Allocation axiom
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h: Heap, $o: ref :: 
  { read($h, $o, MutableMap.ResizingHashMap.Repr), Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V)
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, MutableMap.ResizingHashMap.Repr), TSet(Tclass._System.object()), $h));

// function declaration for MutableMap.ResizingHashMap.ReprInv
function MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, this: ref) : bool;

function MutableMap.ResizingHashMap.ReprInv#canCall(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, this: ref) : bool;

// frame axiom for MutableMap.ResizingHashMap.ReprInv
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, MutableMap.ResizingHashMap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $h0, this)
       == MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $h1, this));

// consequence axiom for MutableMap.ResizingHashMap.ReprInv
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $Heap, this) } 
    MutableMap.ResizingHashMap.ReprInv#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
       ==> true);

function MutableMap.ResizingHashMap.ReprInv#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.ResizingHashMap.ReprInv
axiom (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
  { MutableMap.ResizingHashMap.ReprInv#requires(MutableMap.ResizingHashMap$V, $Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
       && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap)
     ==> MutableMap.ResizingHashMap.ReprInv#requires(MutableMap.ResizingHashMap$V, $Heap, this)
       == true);

// definition axiom for MutableMap.ResizingHashMap.ReprInv(revealed)
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $Heap, this) } 
    MutableMap.ResizingHashMap.ReprInv#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
       ==> MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $Heap, this)
         == (
          Set#Subset(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, MutableMap.ResizingHashMap.Underlying))), 
            read($Heap, this, MutableMap.ResizingHashMap.Repr))
           && Set#Equal(Set#Union(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, MutableMap.ResizingHashMap.Underlying))), 
              read($Heap, 
                read($Heap, this, MutableMap.ResizingHashMap.Underlying), 
                MutableMap.FixedSizeHashMap.Repr)), 
            read($Heap, this, MutableMap.ResizingHashMap.Repr))
           && Set#Equal(read($Heap, 
              read($Heap, this, MutableMap.ResizingHashMap.Underlying), 
              MutableMap.FixedSizeHashMap.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, 
                $Box(read($Heap, this, MutableMap.ResizingHashMap.Underlying))), 
              $Box(read($Heap, 
                  read($Heap, this, MutableMap.ResizingHashMap.Underlying), 
                  MutableMap.FixedSizeHashMap.Storage))))));

// function declaration for MutableMap.ResizingHashMap.ModelI
function MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, self#0: ref) : DatatypeType;

function MutableMap.ResizingHashMap.ModelI#canCall(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, self#0: ref) : bool;

// frame axiom for MutableMap.ResizingHashMap.ModelI
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h0: Heap, $h1: Heap, self#0: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $h1, self#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && (MutableMap.ResizingHashMap.ModelI#canCall(MutableMap.ResizingHashMap$V, $h0, self#0)
         || $Is(self#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V)))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == self#0 || read($h0, self#0, MutableMap.ResizingHashMap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $h0, self#0)
       == MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $h1, self#0));

// consequence axiom for MutableMap.ResizingHashMap.ModelI
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, self#0: ref :: 
    { MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $Heap, self#0) } 
    MutableMap.ResizingHashMap.ModelI#canCall(MutableMap.ResizingHashMap$V, $Heap, self#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(self#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $Heap, self#0))
       ==> Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $Heap, self#0)), 
          read($Heap, self#0, MutableMap.ResizingHashMap.Contents))
         && $Is(MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $Heap, self#0), 
          Tclass.MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap$V)));

function MutableMap.ResizingHashMap.ModelI#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.ResizingHashMap.ModelI
axiom (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, self#0: ref :: 
  { MutableMap.ResizingHashMap.ModelI#requires(MutableMap.ResizingHashMap$V, $Heap, self#0) } 
  $IsGoodHeap($Heap)
       && $Is(self#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
     ==> MutableMap.ResizingHashMap.ModelI#requires(MutableMap.ResizingHashMap$V, $Heap, self#0)
       == MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $Heap, self#0));

// definition axiom for MutableMap.ResizingHashMap.ModelI(revealed)
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, self#0: ref :: 
    { MutableMap.ResizingHashMap.ModelI(MutableMap.ResizingHashMap$V, $Heap, self#0) } 
    MutableMap.ResizingHashMap.ModelI#canCall(MutableMap.ResizingHashMap$V, $Heap, self#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(self#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && MutableMap.ResizingHashMap.ReprInv(MutableMap.ResizingHashMap$V, $Heap, self#0))
       ==> true);

// function declaration for MutableMap.ResizingHashMap.Inv
function MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, this: ref) : bool;

function MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, this: ref) : bool;

// frame axiom for MutableMap.ResizingHashMap.Inv
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, MutableMap.ResizingHashMap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $h0, this)
       == MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $h1, this));

// consequence axiom for MutableMap.ResizingHashMap.Inv
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this) } 
    MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
       ==> (MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this)
           ==> read($Heap, this, MutableMap.ResizingHashMap.Repr)[$Box(this)])
         && (MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this)
           ==> Map#Card(read($Heap, this, MutableMap.ResizingHashMap.Contents))
             == read($Heap, this, MutableMap.ResizingHashMap.Count)));

function MutableMap.ResizingHashMap.Inv#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.ResizingHashMap.Inv
axiom (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
  { MutableMap.ResizingHashMap.Inv#requires(MutableMap.ResizingHashMap$V, $Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
       && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap)
     ==> MutableMap.ResizingHashMap.Inv#requires(MutableMap.ResizingHashMap$V, $Heap, this)
       == true);

// definition axiom for MutableMap.ResizingHashMap.Inv(revealed)
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this) } 
    MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
       ==> true);

// function declaration for MutableMap.ResizingHashMap.I
function MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, this: ref) : DatatypeType;

function MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V: Ty, $heap: Heap, this: ref) : bool;

// frame axiom for MutableMap.ResizingHashMap.I
axiom (forall MutableMap.ResizingHashMap$V: Ty, $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, MutableMap.ResizingHashMap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $h0, this)
       == MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $h1, this));

// consequence axiom for MutableMap.ResizingHashMap.I
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this) } 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap)
           && MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this))
       ==> MutableMapModel.__default.Inv(MutableMap.ResizingHashMap$V, 
          MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this))
         && MutableMapModel.LinearHashMap.count(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this))
           == read($Heap, this, MutableMap.ResizingHashMap.Count)
         && Map#Equal(MutableMapModel.LinearHashMap.contents(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this)), 
          read($Heap, this, MutableMap.ResizingHashMap.Contents))
         && $Is(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
          Tclass.MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap$V)));

function MutableMap.ResizingHashMap.I#requires(Ty, Heap, ref) : bool;

// #requires axiom for MutableMap.ResizingHashMap.I
axiom (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
  { MutableMap.ResizingHashMap.I#requires(MutableMap.ResizingHashMap$V, $Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
       && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap)
     ==> MutableMap.ResizingHashMap.I#requires(MutableMap.ResizingHashMap$V, $Heap, this)
       == MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this));

// definition axiom for MutableMap.ResizingHashMap.I(revealed)
axiom true
   ==> (forall MutableMap.ResizingHashMap$V: Ty, $Heap: Heap, this: ref :: 
    { MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this) } 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
           && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap)
           && MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this))
       ==> true);

procedure CheckWellformed$$MutableMap.ResizingHashMap.__ctor(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616);
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.__ctor(MutableMap.ResizingHashMap$V: Ty, 
    size#0: int where LitInt(0) <= size#0 && size#0 < 18446744073709551616)
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap));
  // user-defined preconditions
  requires LitInt(128) <= size#0;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this);
  ensures MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  free ensures $IsA#MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this))
     && $IsA#MutableMapModel.LinearHashMap(MutableMapModel.__default.Constructor(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.Constructor, 
        size#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.Constructor#canCall(MutableMap.ResizingHashMap$V, size#0);
  ensures MutableMapModel.LinearHashMap#Equal(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    MutableMapModel.__default.Constructor(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.Constructor, 
      size#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
    read($Heap, this, MutableMap.ResizingHashMap.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.Insert(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616, 
    value#0: Box
       where $IsBox(value#0, MutableMap.ResizingHashMap$V)
         && $IsAllocBox(value#0, MutableMap.ResizingHashMap$V, $Heap));
  free requires 30 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.Insert(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616, 
    value#0: Box
       where $IsBox(value#0, MutableMap.ResizingHashMap$V)
         && $IsAllocBox(value#0, MutableMap.ResizingHashMap$V, $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  requires read($Heap, this, MutableMap.ResizingHashMap.Count)
     < Div(18446744073709551616, LitInt(8));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this);
  ensures MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  free ensures $IsA#MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this))
     && $IsA#MutableMapModel.LinearHashMap(MutableMapModel.__default.Insert(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.Insert, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
        key#0, 
        value#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, old($Heap), this)
     && MutableMapModel.__default.Insert#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      key#0, 
      value#0);
  ensures MutableMapModel.LinearHashMap#Equal(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    MutableMapModel.__default.Insert(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.Insert, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      key#0, 
      value#0));
  free ensures true;
  ensures (forall r#0: ref :: 
    { read(old($Heap), this, MutableMap.ResizingHashMap.Repr)[$Box(r#0)] } 
      { read($Heap, this, MutableMap.ResizingHashMap.Repr)[$Box(r#0)] } 
    $Is(r#0, Tclass._System.object())
       ==> 
      read($Heap, this, MutableMap.ResizingHashMap.Repr)[$Box(r#0)]
       ==> read(old($Heap), this, MutableMap.ResizingHashMap.Repr)[$Box(r#0)]
         || (r#0 != null && !read(old($Heap), r#0, alloc)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, MutableMap.ResizingHashMap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.RemoveAndGet(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616)
   returns (removed#0: DatatypeType
       where $Is(removed#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V))
         && $IsAlloc(removed#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V), $Heap));
  free requires 31 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.RemoveAndGet(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616)
   returns (removed#0: DatatypeType
       where $Is(removed#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V))
         && $IsAlloc(removed#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this);
  ensures MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  free ensures $IsA#_System.Tuple2(MutableMapModel.__default.RemoveAndGet(MutableMap.ResizingHashMap$V, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
        key#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, old($Heap), this)
     && MutableMapModel.__default.RemoveAndGet#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      key#0);
  ensures _System.Tuple2#Equal(#_System._tuple#2._#Make2($Box(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this)), 
      $Box(removed#0)), 
    MutableMapModel.__default.RemoveAndGet(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      key#0));
  free ensures true;
  ensures Set#Equal(read($Heap, this, MutableMap.ResizingHashMap.Repr), 
    read(old($Heap), this, MutableMap.ResizingHashMap.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, MutableMap.ResizingHashMap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.Get(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616)
   returns (found#0: DatatypeType
       where $Is(found#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V))
         && $IsAlloc(found#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V), $Heap));
  free requires 33 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.Get(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616)
   returns (found#0: DatatypeType
       where $Is(found#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V))
         && $IsAlloc(found#0, Tclass.Options.Option(MutableMap.ResizingHashMap$V), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this);
  ensures MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  free ensures $IsA#Options.Option(found#0)
     && $IsA#Options.Option(MutableMapModel.__default.Get(MutableMap.ResizingHashMap$V, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
        key#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, old($Heap), this)
     && MutableMapModel.__default.Get#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      key#0);
  ensures Options.Option#Equal(found#0, 
    MutableMapModel.__default.Get(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      key#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.Clone(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
   returns (cloned#0: ref
       where $Is(cloned#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(cloned#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap));
  free requires 34 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.Clone(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
   returns (cloned#0: ref
       where $Is(cloned#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(cloned#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, cloned#0);
  ensures MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, cloned#0);
  free ensures $IsA#MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, cloned#0))
     && $IsA#MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, cloned#0)
     && MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, old($Heap), this);
  ensures MutableMapModel.LinearHashMap#Equal(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, cloned#0), 
    MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, cloned#0, MutableMap.ResizingHashMap.Repr)[$Box($o)] } 
    read($Heap, cloned#0, MutableMap.ResizingHashMap.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.IterStart(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V))
         && $IsAlloc(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V), $Heap));
  free requires 36 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.IterStart(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V))
         && $IsAlloc(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#MutableMapModel.Iterator(it'#0)
     && $IsA#MutableMapModel.Iterator(MutableMapModel.__default.IterStart(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.IterStart, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this)))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.IterStart#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this));
  ensures MutableMapModel.Iterator#Equal(it'#0, 
    MutableMapModel.__default.IterStart(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.IterStart, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.IterInc(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V))
         && $IsAlloc(it#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V), $Heap)
         && $IsA#MutableMapModel.Iterator(it#0))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V))
         && $IsAlloc(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V), $Heap));
  free requires 37 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.IterInc(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V))
         && $IsAlloc(it#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V), $Heap)
         && $IsA#MutableMapModel.Iterator(it#0))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V))
         && $IsAlloc(it'#0, Tclass.MutableMapModel.Iterator(MutableMap.ResizingHashMap$V), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  requires MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0));
  requires MutableMapModel.__default.WFIter(MutableMap.ResizingHashMap$V, 
    MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    it#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#MutableMapModel.Iterator(it'#0)
     && $IsA#MutableMapModel.Iterator(MutableMapModel.__default.IterInc(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.IterInc, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
        it#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.IterInc#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0);
  ensures MutableMapModel.Iterator#Equal(it'#0, 
    MutableMapModel.__default.IterInc(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.IterInc, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.SimpleIterOutput(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0))
   returns (next#0: DatatypeType
       where $Is(next#0, Tclass.MutableMapModel.IteratorOutput(MutableMap.ResizingHashMap$V))
         && $IsAlloc(next#0, 
          Tclass.MutableMapModel.IteratorOutput(MutableMap.ResizingHashMap$V), 
          $Heap));
  free requires 41 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.SimpleIterOutput(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0))
   returns (next#0: DatatypeType
       where $Is(next#0, Tclass.MutableMapModel.IteratorOutput(MutableMap.ResizingHashMap$V))
         && $IsAlloc(next#0, 
          Tclass.MutableMapModel.IteratorOutput(MutableMap.ResizingHashMap$V), 
          $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  requires MutableMapModel.__default.WFSimpleIter(MutableMap.ResizingHashMap$V, 
    MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    it#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#MutableMapModel.IteratorOutput(next#0)
     && $IsA#MutableMapModel.IteratorOutput(MutableMapModel.__default.SimpleIterOutput(MutableMap.ResizingHashMap$V, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
        it#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.SimpleIterOutput#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0);
  ensures MutableMapModel.IteratorOutput#Equal(next#0, 
    MutableMapModel.__default.SimpleIterOutput(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.SimpleIterStart(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it'#0, Tclass.MutableMapModel.SimpleIterator(), $Heap));
  free requires 42 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.SimpleIterStart(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it'#0, Tclass.MutableMapModel.SimpleIterator(), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#MutableMapModel.SimpleIterator(it'#0)
     && $IsA#MutableMapModel.SimpleIterator(MutableMapModel.__default.SimpleIterStart(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.SimpleIterStart, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this)))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.SimpleIterStart#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this));
  ensures MutableMapModel.SimpleIterator#Equal(it'#0, 
    MutableMapModel.__default.SimpleIterStart(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.SimpleIterStart, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.SimpleIterInc(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it'#0, Tclass.MutableMapModel.SimpleIterator(), $Heap));
  free requires 43 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.SimpleIterInc(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0))
   returns (it'#0: DatatypeType
       where $Is(it'#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it'#0, Tclass.MutableMapModel.SimpleIterator(), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  requires MutableMapModel.__default.WFSimpleIter(MutableMap.ResizingHashMap$V, 
    MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    it#0);
  requires MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#MutableMapModel.SimpleIterator(it'#0)
     && $IsA#MutableMapModel.SimpleIterator(MutableMapModel.__default.SimpleIterInc(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.SimpleIterInc, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
        it#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.SimpleIterInc#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0);
  ensures MutableMapModel.SimpleIterator#Equal(it'#0, 
    MutableMapModel.__default.SimpleIterInc(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.SimpleIterInc, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.UpdateByIter(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0), 
    value#0: Box
       where $IsBox(value#0, MutableMap.ResizingHashMap$V)
         && $IsAllocBox(value#0, MutableMap.ResizingHashMap$V, $Heap));
  free requires 44 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.UpdateByIter(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap)
         && $IsA#MutableMapModel.SimpleIterator(it#0), 
    value#0: Box
       where $IsBox(value#0, MutableMap.ResizingHashMap$V)
         && $IsAllocBox(value#0, MutableMap.ResizingHashMap$V, $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  requires MutableMapModel.__default.WFSimpleIter(MutableMap.ResizingHashMap$V, 
    MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    it#0);
  requires MutableMapModel.IteratorOutput.Next_q(MutableMapModel.__default.SimpleIterOutput(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      it#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMap.ResizingHashMap.Inv#canCall(MutableMap.ResizingHashMap$V, $Heap, this);
  ensures MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  free ensures true;
  ensures Set#Equal(read($Heap, this, MutableMap.ResizingHashMap.Repr), 
    read(old($Heap), this, MutableMap.ResizingHashMap.Repr));
  free ensures $IsA#MutableMapModel.LinearHashMap(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this))
     && $IsA#MutableMapModel.LinearHashMap(MutableMapModel.__default.UpdateByIter(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.UpdateByIter, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
        it#0, 
        value#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, old($Heap), this)
     && MutableMapModel.__default.UpdateByIter#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      it#0, 
      value#0);
  ensures MutableMapModel.LinearHashMap#Equal(MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
    MutableMapModel.__default.UpdateByIter(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.UpdateByIter, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, old($Heap), this), 
      it#0, 
      value#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || read(old($Heap), this, MutableMap.ResizingHashMap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$MutableMap.ResizingHashMap.FindSimpleIter(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616)
   returns (it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap));
  free requires 45 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$MutableMap.ResizingHashMap.FindSimpleIter(MutableMap.ResizingHashMap$V: Ty, 
    this: ref
       where this != null
         && 
        $Is(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
         && $IsAlloc(this, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $Heap), 
    key#0: int where LitInt(0) <= key#0 && key#0 < 18446744073709551616)
   returns (it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
         && $IsAlloc(it#0, Tclass.MutableMapModel.SimpleIterator(), $Heap));
  // user-defined preconditions
  requires MutableMap.ResizingHashMap.Inv(MutableMap.ResizingHashMap$V, $Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#MutableMapModel.SimpleIterator(it#0)
     && $IsA#MutableMapModel.SimpleIterator(MutableMapModel.__default.FindSimpleIter(MutableMap.ResizingHashMap$V, 
        StartFuel_MutableMapModel._default.FindSimpleIter, 
        MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
        key#0))
     && 
    MutableMap.ResizingHashMap.I#canCall(MutableMap.ResizingHashMap$V, $Heap, this)
     && MutableMapModel.__default.FindSimpleIter#canCall(MutableMap.ResizingHashMap$V, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      key#0);
  ensures MutableMapModel.SimpleIterator#Equal(it#0, 
    MutableMapModel.__default.FindSimpleIter(MutableMap.ResizingHashMap$V, 
      StartFuelAssert_MutableMapModel._default.FindSimpleIter, 
      MutableMap.ResizingHashMap.I(MutableMap.ResizingHashMap$V, $Heap, this), 
      key#0));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// MutableMap.ResizingHashMap: subset type $Is
axiom (forall MutableMap.ResizingHashMap$V: Ty, c#0: ref :: 
  { $Is(c#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V)) } 
  $Is(c#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V))
     <==> $Is(c#0, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V))
       && c#0 != null);

// MutableMap.ResizingHashMap: subset type $IsAlloc
axiom (forall MutableMap.ResizingHashMap$V: Ty, c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $h) } 
  $IsAlloc(c#0, Tclass.MutableMap.ResizingHashMap(MutableMap.ResizingHashMap$V), $h)
     <==> $IsAlloc(c#0, Tclass.MutableMap.ResizingHashMap?(MutableMap.ResizingHashMap$V), $h));

const unique class.MutableMap.__default: ClassName;

function Tclass.MutableMap.__default() : Ty;

// Tclass.MutableMap.__default Tag
axiom Tag(Tclass.MutableMap.__default()) == Tagclass.MutableMap.__default;

const unique Tagclass.MutableMap.__default: TyTag;

// Box/unbox axiom for Tclass.MutableMap.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MutableMap.__default()) } 
  $IsBox(bx, Tclass.MutableMap.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.MutableMap.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.MutableMap.__default()) } 
  $Is($o, Tclass.MutableMap.__default())
     <==> $o == null || dtype($o) == Tclass.MutableMap.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MutableMap.__default(), $h) } 
  $IsAlloc($o, Tclass.MutableMap.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// Constructor function declaration
function #GenericMarshalling.G.GUint32() : DatatypeType;

const unique ##GenericMarshalling.G.GUint32: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#GenericMarshalling.G.GUint32())
   == ##GenericMarshalling.G.GUint32;

function GenericMarshalling.G.GUint32_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint32_q(d) } 
  GenericMarshalling.G.GUint32_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GUint32);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint32_q(d) } 
  GenericMarshalling.G.GUint32_q(d) ==> d == #GenericMarshalling.G.GUint32());

// Constructor $Is
axiom $Is(#GenericMarshalling.G.GUint32(), Tclass.GenericMarshalling.G());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GUint32(), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#GenericMarshalling.G.GUint32(), Tclass.GenericMarshalling.G(), $h));

// Constructor literal
axiom #GenericMarshalling.G.GUint32() == Lit(#GenericMarshalling.G.GUint32());

// Constructor function declaration
function #GenericMarshalling.G.GUint64() : DatatypeType;

const unique ##GenericMarshalling.G.GUint64: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#GenericMarshalling.G.GUint64())
   == ##GenericMarshalling.G.GUint64;

function GenericMarshalling.G.GUint64_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint64_q(d) } 
  GenericMarshalling.G.GUint64_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GUint64);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint64_q(d) } 
  GenericMarshalling.G.GUint64_q(d) ==> d == #GenericMarshalling.G.GUint64());

// Constructor $Is
axiom $Is(#GenericMarshalling.G.GUint64(), Tclass.GenericMarshalling.G());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GUint64(), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#GenericMarshalling.G.GUint64(), Tclass.GenericMarshalling.G(), $h));

// Constructor literal
axiom #GenericMarshalling.G.GUint64() == Lit(#GenericMarshalling.G.GUint64());

// Constructor function declaration
function #GenericMarshalling.G.GArray(DatatypeType) : DatatypeType;

const unique ##GenericMarshalling.G.GArray: DtCtorId;

// Constructor identifier
axiom (forall a#10#0#0: DatatypeType :: 
  { #GenericMarshalling.G.GArray(a#10#0#0) } 
  DatatypeCtorId(#GenericMarshalling.G.GArray(a#10#0#0))
     == ##GenericMarshalling.G.GArray);

function GenericMarshalling.G.GArray_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GArray_q(d) } 
  GenericMarshalling.G.GArray_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GArray);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GArray_q(d) } 
  GenericMarshalling.G.GArray_q(d)
     ==> (exists a#11#0#0: DatatypeType :: d == #GenericMarshalling.G.GArray(a#11#0#0)));

// Constructor $Is
axiom (forall a#12#0#0: DatatypeType :: 
  { $Is(#GenericMarshalling.G.GArray(a#12#0#0), Tclass.GenericMarshalling.G()) } 
  $Is(#GenericMarshalling.G.GArray(a#12#0#0), Tclass.GenericMarshalling.G())
     <==> $Is(a#12#0#0, Tclass.GenericMarshalling.G()));

// Constructor $IsAlloc
axiom (forall a#13#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GArray(a#13#0#0), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.G.GArray(a#13#0#0), Tclass.GenericMarshalling.G(), $h)
       <==> $IsAlloc(a#13#0#0, Tclass.GenericMarshalling.G(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.G.elt(d), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.G.GArray_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.G(), $h)
     ==> $IsAlloc(GenericMarshalling.G.elt(d), Tclass.GenericMarshalling.G(), $h));

// Constructor literal
axiom (forall a#14#0#0: DatatypeType :: 
  { #GenericMarshalling.G.GArray(Lit(a#14#0#0)) } 
  #GenericMarshalling.G.GArray(Lit(a#14#0#0))
     == Lit(#GenericMarshalling.G.GArray(a#14#0#0)));

function GenericMarshalling.G.elt(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#15#0#0: DatatypeType :: 
  { #GenericMarshalling.G.GArray(a#15#0#0) } 
  GenericMarshalling.G.elt(#GenericMarshalling.G.GArray(a#15#0#0)) == a#15#0#0);

// Inductive rank
axiom (forall a#16#0#0: DatatypeType :: 
  { #GenericMarshalling.G.GArray(a#16#0#0) } 
  DtRank(a#16#0#0) < DtRank(#GenericMarshalling.G.GArray(a#16#0#0)));

// Constructor function declaration
function #GenericMarshalling.G.GTuple(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.G.GTuple: DtCtorId;

// Constructor identifier
axiom (forall a#17#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTuple(a#17#0#0) } 
  DatatypeCtorId(#GenericMarshalling.G.GTuple(a#17#0#0))
     == ##GenericMarshalling.G.GTuple);

function GenericMarshalling.G.GTuple_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GTuple_q(d) } 
  GenericMarshalling.G.GTuple_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GTuple);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GTuple_q(d) } 
  GenericMarshalling.G.GTuple_q(d)
     ==> (exists a#18#0#0: Seq Box :: d == #GenericMarshalling.G.GTuple(a#18#0#0)));

// Constructor $Is
axiom (forall a#19#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.G.GTuple(a#19#0#0), Tclass.GenericMarshalling.G()) } 
  $Is(#GenericMarshalling.G.GTuple(a#19#0#0), Tclass.GenericMarshalling.G())
     <==> $Is(a#19#0#0, TSeq(Tclass.GenericMarshalling.G())));

// Constructor $IsAlloc
axiom (forall a#20#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GTuple(a#20#0#0), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.G.GTuple(a#20#0#0), Tclass.GenericMarshalling.G(), $h)
       <==> $IsAlloc(a#20#0#0, TSeq(Tclass.GenericMarshalling.G()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.G.t(d), TSeq(Tclass.GenericMarshalling.G()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.G.GTuple_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.G(), $h)
     ==> $IsAlloc(GenericMarshalling.G.t(d), TSeq(Tclass.GenericMarshalling.G()), $h));

// Constructor literal
axiom (forall a#21#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTuple(Lit(a#21#0#0)) } 
  #GenericMarshalling.G.GTuple(Lit(a#21#0#0))
     == Lit(#GenericMarshalling.G.GTuple(a#21#0#0)));

function GenericMarshalling.G.t(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#22#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTuple(a#22#0#0) } 
  GenericMarshalling.G.t(#GenericMarshalling.G.GTuple(a#22#0#0)) == a#22#0#0);

// Inductive seq element rank
axiom (forall a#23#0#0: Seq Box, i: int :: 
  { Seq#Index(a#23#0#0, i), #GenericMarshalling.G.GTuple(a#23#0#0) } 
  0 <= i && i < Seq#Length(a#23#0#0)
     ==> DtRank($Unbox(Seq#Index(a#23#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.G.GTuple(a#23#0#0)));

// Inductive seq rank
axiom (forall a#24#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTuple(a#24#0#0) } 
  Seq#Rank(a#24#0#0) < DtRank(#GenericMarshalling.G.GTuple(a#24#0#0)));

// Constructor function declaration
function #GenericMarshalling.G.GByteArray() : DatatypeType;

const unique ##GenericMarshalling.G.GByteArray: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#GenericMarshalling.G.GByteArray())
   == ##GenericMarshalling.G.GByteArray;

function GenericMarshalling.G.GByteArray_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GByteArray_q(d) } 
  GenericMarshalling.G.GByteArray_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GByteArray);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GByteArray_q(d) } 
  GenericMarshalling.G.GByteArray_q(d) ==> d == #GenericMarshalling.G.GByteArray());

// Constructor $Is
axiom $Is(#GenericMarshalling.G.GByteArray(), Tclass.GenericMarshalling.G());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GByteArray(), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#GenericMarshalling.G.GByteArray(), Tclass.GenericMarshalling.G(), $h));

// Constructor literal
axiom #GenericMarshalling.G.GByteArray() == Lit(#GenericMarshalling.G.GByteArray());

// Constructor function declaration
function #GenericMarshalling.G.GUint32Array() : DatatypeType;

const unique ##GenericMarshalling.G.GUint32Array: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#GenericMarshalling.G.GUint32Array())
   == ##GenericMarshalling.G.GUint32Array;

function GenericMarshalling.G.GUint32Array_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint32Array_q(d) } 
  GenericMarshalling.G.GUint32Array_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GUint32Array);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint32Array_q(d) } 
  GenericMarshalling.G.GUint32Array_q(d)
     ==> d == #GenericMarshalling.G.GUint32Array());

// Constructor $Is
axiom $Is(#GenericMarshalling.G.GUint32Array(), Tclass.GenericMarshalling.G());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GUint32Array(), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#GenericMarshalling.G.GUint32Array(), Tclass.GenericMarshalling.G(), $h));

// Constructor literal
axiom #GenericMarshalling.G.GUint32Array()
   == Lit(#GenericMarshalling.G.GUint32Array());

// Constructor function declaration
function #GenericMarshalling.G.GUint64Array() : DatatypeType;

const unique ##GenericMarshalling.G.GUint64Array: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#GenericMarshalling.G.GUint64Array())
   == ##GenericMarshalling.G.GUint64Array;

function GenericMarshalling.G.GUint64Array_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint64Array_q(d) } 
  GenericMarshalling.G.GUint64Array_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GUint64Array);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GUint64Array_q(d) } 
  GenericMarshalling.G.GUint64Array_q(d)
     ==> d == #GenericMarshalling.G.GUint64Array());

// Constructor $Is
axiom $Is(#GenericMarshalling.G.GUint64Array(), Tclass.GenericMarshalling.G());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GUint64Array(), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#GenericMarshalling.G.GUint64Array(), Tclass.GenericMarshalling.G(), $h));

// Constructor literal
axiom #GenericMarshalling.G.GUint64Array()
   == Lit(#GenericMarshalling.G.GUint64Array());

// Constructor function declaration
function #GenericMarshalling.G.GTaggedUnion(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.G.GTaggedUnion: DtCtorId;

// Constructor identifier
axiom (forall a#40#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTaggedUnion(a#40#0#0) } 
  DatatypeCtorId(#GenericMarshalling.G.GTaggedUnion(a#40#0#0))
     == ##GenericMarshalling.G.GTaggedUnion);

function GenericMarshalling.G.GTaggedUnion_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GTaggedUnion_q(d) } 
  GenericMarshalling.G.GTaggedUnion_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.G.GTaggedUnion);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GTaggedUnion_q(d) } 
  GenericMarshalling.G.GTaggedUnion_q(d)
     ==> (exists a#41#0#0: Seq Box :: d == #GenericMarshalling.G.GTaggedUnion(a#41#0#0)));

// Constructor $Is
axiom (forall a#42#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.G.GTaggedUnion(a#42#0#0), Tclass.GenericMarshalling.G()) } 
  $Is(#GenericMarshalling.G.GTaggedUnion(a#42#0#0), Tclass.GenericMarshalling.G())
     <==> $Is(a#42#0#0, TSeq(Tclass.GenericMarshalling.G())));

// Constructor $IsAlloc
axiom (forall a#43#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.G.GTaggedUnion(a#43#0#0), Tclass.GenericMarshalling.G(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.G.GTaggedUnion(a#43#0#0), Tclass.GenericMarshalling.G(), $h)
       <==> $IsAlloc(a#43#0#0, TSeq(Tclass.GenericMarshalling.G()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.G.cases(d), TSeq(Tclass.GenericMarshalling.G()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.G.GTaggedUnion_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.G(), $h)
     ==> $IsAlloc(GenericMarshalling.G.cases(d), TSeq(Tclass.GenericMarshalling.G()), $h));

// Constructor literal
axiom (forall a#44#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTaggedUnion(Lit(a#44#0#0)) } 
  #GenericMarshalling.G.GTaggedUnion(Lit(a#44#0#0))
     == Lit(#GenericMarshalling.G.GTaggedUnion(a#44#0#0)));

function GenericMarshalling.G.cases(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#45#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTaggedUnion(a#45#0#0) } 
  GenericMarshalling.G.cases(#GenericMarshalling.G.GTaggedUnion(a#45#0#0))
     == a#45#0#0);

// Inductive seq element rank
axiom (forall a#46#0#0: Seq Box, i: int :: 
  { Seq#Index(a#46#0#0, i), #GenericMarshalling.G.GTaggedUnion(a#46#0#0) } 
  0 <= i && i < Seq#Length(a#46#0#0)
     ==> DtRank($Unbox(Seq#Index(a#46#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.G.GTaggedUnion(a#46#0#0)));

// Inductive seq rank
axiom (forall a#47#0#0: Seq Box :: 
  { #GenericMarshalling.G.GTaggedUnion(a#47#0#0) } 
  Seq#Rank(a#47#0#0) < DtRank(#GenericMarshalling.G.GTaggedUnion(a#47#0#0)));

// Depth-one case-split function
function $IsA#GenericMarshalling.G(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#GenericMarshalling.G(d) } 
  $IsA#GenericMarshalling.G(d)
     ==> GenericMarshalling.G.GUint32_q(d)
       || GenericMarshalling.G.GUint64_q(d)
       || GenericMarshalling.G.GArray_q(d)
       || GenericMarshalling.G.GTuple_q(d)
       || GenericMarshalling.G.GByteArray_q(d)
       || GenericMarshalling.G.GUint32Array_q(d)
       || GenericMarshalling.G.GUint64Array_q(d)
       || GenericMarshalling.G.GTaggedUnion_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.G.GTaggedUnion_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GUint64Array_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GUint32Array_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GByteArray_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GTuple_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GArray_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GUint64_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
    { GenericMarshalling.G.GUint32_q(d), $Is(d, Tclass.GenericMarshalling.G()) } 
  $Is(d, Tclass.GenericMarshalling.G())
     ==> GenericMarshalling.G.GUint32_q(d)
       || GenericMarshalling.G.GUint64_q(d)
       || GenericMarshalling.G.GArray_q(d)
       || GenericMarshalling.G.GTuple_q(d)
       || GenericMarshalling.G.GByteArray_q(d)
       || GenericMarshalling.G.GUint32Array_q(d)
       || GenericMarshalling.G.GUint64Array_q(d)
       || GenericMarshalling.G.GTaggedUnion_q(d));

// Datatype extensional equality declaration
function GenericMarshalling.G#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #GenericMarshalling.G.GUint32
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint32_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint32_q(b) } 
  GenericMarshalling.G.GUint32_q(a) && GenericMarshalling.G.GUint32_q(b)
     ==> (GenericMarshalling.G#Equal(a, b) <==> true));

// Datatype extensional equality definition: #GenericMarshalling.G.GUint64
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint64_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint64_q(b) } 
  GenericMarshalling.G.GUint64_q(a) && GenericMarshalling.G.GUint64_q(b)
     ==> (GenericMarshalling.G#Equal(a, b) <==> true));

// Datatype extensional equality definition: #GenericMarshalling.G.GArray
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GArray_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GArray_q(b) } 
  GenericMarshalling.G.GArray_q(a) && GenericMarshalling.G.GArray_q(b)
     ==> (GenericMarshalling.G#Equal(a, b)
       <==> GenericMarshalling.G#Equal(GenericMarshalling.G.elt(a), GenericMarshalling.G.elt(b))));

// Datatype extensional equality definition: #GenericMarshalling.G.GTuple
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GTuple_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GTuple_q(b) } 
  GenericMarshalling.G.GTuple_q(a) && GenericMarshalling.G.GTuple_q(b)
     ==> (GenericMarshalling.G#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.G.t(a), GenericMarshalling.G.t(b))));

// Datatype extensional equality definition: #GenericMarshalling.G.GByteArray
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GByteArray_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GByteArray_q(b) } 
  GenericMarshalling.G.GByteArray_q(a) && GenericMarshalling.G.GByteArray_q(b)
     ==> (GenericMarshalling.G#Equal(a, b) <==> true));

// Datatype extensional equality definition: #GenericMarshalling.G.GUint32Array
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint32Array_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint32Array_q(b) } 
  GenericMarshalling.G.GUint32Array_q(a) && GenericMarshalling.G.GUint32Array_q(b)
     ==> (GenericMarshalling.G#Equal(a, b) <==> true));

// Datatype extensional equality definition: #GenericMarshalling.G.GUint64Array
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint64Array_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GUint64Array_q(b) } 
  GenericMarshalling.G.GUint64Array_q(a) && GenericMarshalling.G.GUint64Array_q(b)
     ==> (GenericMarshalling.G#Equal(a, b) <==> true));

// Datatype extensional equality definition: #GenericMarshalling.G.GTaggedUnion
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GTaggedUnion_q(a) } 
    { GenericMarshalling.G#Equal(a, b), GenericMarshalling.G.GTaggedUnion_q(b) } 
  GenericMarshalling.G.GTaggedUnion_q(a) && GenericMarshalling.G.GTaggedUnion_q(b)
     ==> (GenericMarshalling.G#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.G.cases(a), GenericMarshalling.G.cases(b))));

// Datatype extensionality axiom: GenericMarshalling.G
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.G#Equal(a, b) } 
  GenericMarshalling.G#Equal(a, b) <==> a == b);

const unique class.GenericMarshalling.G: ClassName;

// Constructor function declaration
function #GenericMarshalling.V.VUint32(int) : DatatypeType;

const unique ##GenericMarshalling.V.VUint32: DtCtorId;

// Constructor identifier
axiom (forall a#48#0#0: int :: 
  { #GenericMarshalling.V.VUint32(a#48#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VUint32(a#48#0#0))
     == ##GenericMarshalling.V.VUint32);

function GenericMarshalling.V.VUint32_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint32_q(d) } 
  GenericMarshalling.V.VUint32_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VUint32);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint32_q(d) } 
  GenericMarshalling.V.VUint32_q(d)
     ==> (exists a#49#0#0: int :: d == #GenericMarshalling.V.VUint32(a#49#0#0)));

// Constructor $Is
axiom (forall a#50#0#0: int :: 
  { $Is(#GenericMarshalling.V.VUint32(a#50#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VUint32(a#50#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#50#0#0, Tclass.NativeTypes.uint32()));

// Constructor $IsAlloc
axiom (forall a#51#0#0: int, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VUint32(a#51#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VUint32(a#51#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#51#0#0, Tclass.NativeTypes.uint32(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.v(d), Tclass.NativeTypes.uint32(), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VUint32_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.v(d), Tclass.NativeTypes.uint32(), $h));

// Constructor literal
axiom (forall a#52#0#0: int :: 
  { #GenericMarshalling.V.VUint32(LitInt(a#52#0#0)) } 
  #GenericMarshalling.V.VUint32(LitInt(a#52#0#0))
     == Lit(#GenericMarshalling.V.VUint32(a#52#0#0)));

function GenericMarshalling.V.v(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#53#0#0: int :: 
  { #GenericMarshalling.V.VUint32(a#53#0#0) } 
  GenericMarshalling.V.v(#GenericMarshalling.V.VUint32(a#53#0#0)) == a#53#0#0);

// Constructor function declaration
function #GenericMarshalling.V.VUint64(int) : DatatypeType;

const unique ##GenericMarshalling.V.VUint64: DtCtorId;

// Constructor identifier
axiom (forall a#54#0#0: int :: 
  { #GenericMarshalling.V.VUint64(a#54#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VUint64(a#54#0#0))
     == ##GenericMarshalling.V.VUint64);

function GenericMarshalling.V.VUint64_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint64_q(d) } 
  GenericMarshalling.V.VUint64_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VUint64);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint64_q(d) } 
  GenericMarshalling.V.VUint64_q(d)
     ==> (exists a#55#0#0: int :: d == #GenericMarshalling.V.VUint64(a#55#0#0)));

// Constructor $Is
axiom (forall a#56#0#0: int :: 
  { $Is(#GenericMarshalling.V.VUint64(a#56#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VUint64(a#56#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#56#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#57#0#0: int, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VUint64(a#57#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VUint64(a#57#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#57#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.u(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VUint64_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.u(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#58#0#0: int :: 
  { #GenericMarshalling.V.VUint64(LitInt(a#58#0#0)) } 
  #GenericMarshalling.V.VUint64(LitInt(a#58#0#0))
     == Lit(#GenericMarshalling.V.VUint64(a#58#0#0)));

function GenericMarshalling.V.u(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#59#0#0: int :: 
  { #GenericMarshalling.V.VUint64(a#59#0#0) } 
  GenericMarshalling.V.u(#GenericMarshalling.V.VUint64(a#59#0#0)) == a#59#0#0);

// Constructor function declaration
function #GenericMarshalling.V.VArray(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.V.VArray: DtCtorId;

// Constructor identifier
axiom (forall a#60#0#0: Seq Box :: 
  { #GenericMarshalling.V.VArray(a#60#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VArray(a#60#0#0))
     == ##GenericMarshalling.V.VArray);

function GenericMarshalling.V.VArray_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VArray_q(d) } 
  GenericMarshalling.V.VArray_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VArray);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VArray_q(d) } 
  GenericMarshalling.V.VArray_q(d)
     ==> (exists a#61#0#0: Seq Box :: d == #GenericMarshalling.V.VArray(a#61#0#0)));

// Constructor $Is
axiom (forall a#62#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.V.VArray(a#62#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VArray(a#62#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#62#0#0, TSeq(Tclass.GenericMarshalling.V())));

// Constructor $IsAlloc
axiom (forall a#63#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VArray(a#63#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VArray(a#63#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#63#0#0, TSeq(Tclass.GenericMarshalling.V()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.a(d), TSeq(Tclass.GenericMarshalling.V()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VArray_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.a(d), TSeq(Tclass.GenericMarshalling.V()), $h));

// Constructor literal
axiom (forall a#64#0#0: Seq Box :: 
  { #GenericMarshalling.V.VArray(Lit(a#64#0#0)) } 
  #GenericMarshalling.V.VArray(Lit(a#64#0#0))
     == Lit(#GenericMarshalling.V.VArray(a#64#0#0)));

function GenericMarshalling.V.a(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#65#0#0: Seq Box :: 
  { #GenericMarshalling.V.VArray(a#65#0#0) } 
  GenericMarshalling.V.a(#GenericMarshalling.V.VArray(a#65#0#0)) == a#65#0#0);

// Inductive seq element rank
axiom (forall a#66#0#0: Seq Box, i: int :: 
  { Seq#Index(a#66#0#0, i), #GenericMarshalling.V.VArray(a#66#0#0) } 
  0 <= i && i < Seq#Length(a#66#0#0)
     ==> DtRank($Unbox(Seq#Index(a#66#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.V.VArray(a#66#0#0)));

// Inductive seq rank
axiom (forall a#67#0#0: Seq Box :: 
  { #GenericMarshalling.V.VArray(a#67#0#0) } 
  Seq#Rank(a#67#0#0) < DtRank(#GenericMarshalling.V.VArray(a#67#0#0)));

// Constructor function declaration
function #GenericMarshalling.V.VTuple(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.V.VTuple: DtCtorId;

// Constructor identifier
axiom (forall a#68#0#0: Seq Box :: 
  { #GenericMarshalling.V.VTuple(a#68#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VTuple(a#68#0#0))
     == ##GenericMarshalling.V.VTuple);

function GenericMarshalling.V.VTuple_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VTuple_q(d) } 
  GenericMarshalling.V.VTuple_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VTuple);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VTuple_q(d) } 
  GenericMarshalling.V.VTuple_q(d)
     ==> (exists a#69#0#0: Seq Box :: d == #GenericMarshalling.V.VTuple(a#69#0#0)));

// Constructor $Is
axiom (forall a#70#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.V.VTuple(a#70#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VTuple(a#70#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#70#0#0, TSeq(Tclass.GenericMarshalling.V())));

// Constructor $IsAlloc
axiom (forall a#71#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VTuple(a#71#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VTuple(a#71#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#71#0#0, TSeq(Tclass.GenericMarshalling.V()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.t(d), TSeq(Tclass.GenericMarshalling.V()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VTuple_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.t(d), TSeq(Tclass.GenericMarshalling.V()), $h));

// Constructor literal
axiom (forall a#72#0#0: Seq Box :: 
  { #GenericMarshalling.V.VTuple(Lit(a#72#0#0)) } 
  #GenericMarshalling.V.VTuple(Lit(a#72#0#0))
     == Lit(#GenericMarshalling.V.VTuple(a#72#0#0)));

function GenericMarshalling.V.t(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#73#0#0: Seq Box :: 
  { #GenericMarshalling.V.VTuple(a#73#0#0) } 
  GenericMarshalling.V.t(#GenericMarshalling.V.VTuple(a#73#0#0)) == a#73#0#0);

// Inductive seq element rank
axiom (forall a#74#0#0: Seq Box, i: int :: 
  { Seq#Index(a#74#0#0, i), #GenericMarshalling.V.VTuple(a#74#0#0) } 
  0 <= i && i < Seq#Length(a#74#0#0)
     ==> DtRank($Unbox(Seq#Index(a#74#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.V.VTuple(a#74#0#0)));

// Inductive seq rank
axiom (forall a#75#0#0: Seq Box :: 
  { #GenericMarshalling.V.VTuple(a#75#0#0) } 
  Seq#Rank(a#75#0#0) < DtRank(#GenericMarshalling.V.VTuple(a#75#0#0)));

// Constructor function declaration
function #GenericMarshalling.V.VByteArray(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.V.VByteArray: DtCtorId;

// Constructor identifier
axiom (forall a#76#0#0: Seq Box :: 
  { #GenericMarshalling.V.VByteArray(a#76#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VByteArray(a#76#0#0))
     == ##GenericMarshalling.V.VByteArray);

function GenericMarshalling.V.VByteArray_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VByteArray_q(d) } 
  GenericMarshalling.V.VByteArray_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VByteArray);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VByteArray_q(d) } 
  GenericMarshalling.V.VByteArray_q(d)
     ==> (exists a#77#0#0: Seq Box :: d == #GenericMarshalling.V.VByteArray(a#77#0#0)));

// Constructor $Is
axiom (forall a#78#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.V.VByteArray(a#78#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VByteArray(a#78#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#78#0#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#79#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VByteArray(a#79#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VByteArray(a#79#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#79#0#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.b(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VByteArray_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.b(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#80#0#0: Seq Box :: 
  { #GenericMarshalling.V.VByteArray(Lit(a#80#0#0)) } 
  #GenericMarshalling.V.VByteArray(Lit(a#80#0#0))
     == Lit(#GenericMarshalling.V.VByteArray(a#80#0#0)));

function GenericMarshalling.V.b(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#81#0#0: Seq Box :: 
  { #GenericMarshalling.V.VByteArray(a#81#0#0) } 
  GenericMarshalling.V.b(#GenericMarshalling.V.VByteArray(a#81#0#0)) == a#81#0#0);

// Inductive seq element rank
axiom (forall a#82#0#0: Seq Box, i: int :: 
  { Seq#Index(a#82#0#0, i), #GenericMarshalling.V.VByteArray(a#82#0#0) } 
  0 <= i && i < Seq#Length(a#82#0#0)
     ==> DtRank($Unbox(Seq#Index(a#82#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.V.VByteArray(a#82#0#0)));

// Inductive seq rank
axiom (forall a#83#0#0: Seq Box :: 
  { #GenericMarshalling.V.VByteArray(a#83#0#0) } 
  Seq#Rank(a#83#0#0) < DtRank(#GenericMarshalling.V.VByteArray(a#83#0#0)));

// Constructor function declaration
function #GenericMarshalling.V.VUint32Array(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.V.VUint32Array: DtCtorId;

// Constructor identifier
axiom (forall a#84#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint32Array(a#84#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VUint32Array(a#84#0#0))
     == ##GenericMarshalling.V.VUint32Array);

function GenericMarshalling.V.VUint32Array_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint32Array_q(d) } 
  GenericMarshalling.V.VUint32Array_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VUint32Array);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint32Array_q(d) } 
  GenericMarshalling.V.VUint32Array_q(d)
     ==> (exists a#85#0#0: Seq Box :: d == #GenericMarshalling.V.VUint32Array(a#85#0#0)));

// Constructor $Is
axiom (forall a#86#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.V.VUint32Array(a#86#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VUint32Array(a#86#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#86#0#0, TSeq(Tclass.NativeTypes.uint32())));

// Constructor $IsAlloc
axiom (forall a#87#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VUint32Array(a#87#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VUint32Array(a#87#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#87#0#0, TSeq(Tclass.NativeTypes.uint32()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.va(d), TSeq(Tclass.NativeTypes.uint32()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VUint32Array_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.va(d), TSeq(Tclass.NativeTypes.uint32()), $h));

// Constructor literal
axiom (forall a#88#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint32Array(Lit(a#88#0#0)) } 
  #GenericMarshalling.V.VUint32Array(Lit(a#88#0#0))
     == Lit(#GenericMarshalling.V.VUint32Array(a#88#0#0)));

function GenericMarshalling.V.va(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#89#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint32Array(a#89#0#0) } 
  GenericMarshalling.V.va(#GenericMarshalling.V.VUint32Array(a#89#0#0))
     == a#89#0#0);

// Inductive seq element rank
axiom (forall a#90#0#0: Seq Box, i: int :: 
  { Seq#Index(a#90#0#0, i), #GenericMarshalling.V.VUint32Array(a#90#0#0) } 
  0 <= i && i < Seq#Length(a#90#0#0)
     ==> DtRank($Unbox(Seq#Index(a#90#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.V.VUint32Array(a#90#0#0)));

// Inductive seq rank
axiom (forall a#91#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint32Array(a#91#0#0) } 
  Seq#Rank(a#91#0#0) < DtRank(#GenericMarshalling.V.VUint32Array(a#91#0#0)));

// Constructor function declaration
function #GenericMarshalling.V.VUint64Array(Seq Box) : DatatypeType;

const unique ##GenericMarshalling.V.VUint64Array: DtCtorId;

// Constructor identifier
axiom (forall a#92#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint64Array(a#92#0#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VUint64Array(a#92#0#0))
     == ##GenericMarshalling.V.VUint64Array);

function GenericMarshalling.V.VUint64Array_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint64Array_q(d) } 
  GenericMarshalling.V.VUint64Array_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VUint64Array);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VUint64Array_q(d) } 
  GenericMarshalling.V.VUint64Array_q(d)
     ==> (exists a#93#0#0: Seq Box :: d == #GenericMarshalling.V.VUint64Array(a#93#0#0)));

// Constructor $Is
axiom (forall a#94#0#0: Seq Box :: 
  { $Is(#GenericMarshalling.V.VUint64Array(a#94#0#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VUint64Array(a#94#0#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#94#0#0, TSeq(Tclass.NativeTypes.uint64())));

// Constructor $IsAlloc
axiom (forall a#95#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VUint64Array(a#95#0#0), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VUint64Array(a#95#0#0), Tclass.GenericMarshalling.V(), $h)
       <==> $IsAlloc(a#95#0#0, TSeq(Tclass.NativeTypes.uint64()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.ua(d), TSeq(Tclass.NativeTypes.uint64()), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VUint64Array_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.ua(d), TSeq(Tclass.NativeTypes.uint64()), $h));

// Constructor literal
axiom (forall a#96#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint64Array(Lit(a#96#0#0)) } 
  #GenericMarshalling.V.VUint64Array(Lit(a#96#0#0))
     == Lit(#GenericMarshalling.V.VUint64Array(a#96#0#0)));

function GenericMarshalling.V.ua(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#97#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint64Array(a#97#0#0) } 
  GenericMarshalling.V.ua(#GenericMarshalling.V.VUint64Array(a#97#0#0))
     == a#97#0#0);

// Inductive seq element rank
axiom (forall a#98#0#0: Seq Box, i: int :: 
  { Seq#Index(a#98#0#0, i), #GenericMarshalling.V.VUint64Array(a#98#0#0) } 
  0 <= i && i < Seq#Length(a#98#0#0)
     ==> DtRank($Unbox(Seq#Index(a#98#0#0, i)): DatatypeType)
       < DtRank(#GenericMarshalling.V.VUint64Array(a#98#0#0)));

// Inductive seq rank
axiom (forall a#99#0#0: Seq Box :: 
  { #GenericMarshalling.V.VUint64Array(a#99#0#0) } 
  Seq#Rank(a#99#0#0) < DtRank(#GenericMarshalling.V.VUint64Array(a#99#0#0)));

// Constructor function declaration
function #GenericMarshalling.V.VCase(int, DatatypeType) : DatatypeType;

const unique ##GenericMarshalling.V.VCase: DtCtorId;

// Constructor identifier
axiom (forall a#100#0#0: int, a#100#1#0: DatatypeType :: 
  { #GenericMarshalling.V.VCase(a#100#0#0, a#100#1#0) } 
  DatatypeCtorId(#GenericMarshalling.V.VCase(a#100#0#0, a#100#1#0))
     == ##GenericMarshalling.V.VCase);

function GenericMarshalling.V.VCase_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VCase_q(d) } 
  GenericMarshalling.V.VCase_q(d)
     <==> DatatypeCtorId(d) == ##GenericMarshalling.V.VCase);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VCase_q(d) } 
  GenericMarshalling.V.VCase_q(d)
     ==> (exists a#101#0#0: int, a#101#1#0: DatatypeType :: 
      d == #GenericMarshalling.V.VCase(a#101#0#0, a#101#1#0)));

// Constructor $Is
axiom (forall a#102#0#0: int, a#102#1#0: DatatypeType :: 
  { $Is(#GenericMarshalling.V.VCase(a#102#0#0, a#102#1#0), Tclass.GenericMarshalling.V()) } 
  $Is(#GenericMarshalling.V.VCase(a#102#0#0, a#102#1#0), Tclass.GenericMarshalling.V())
     <==> $Is(a#102#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#102#1#0, Tclass.GenericMarshalling.V()));

// Constructor $IsAlloc
axiom (forall a#103#0#0: int, a#103#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#GenericMarshalling.V.VCase(a#103#0#0, a#103#1#0), 
      Tclass.GenericMarshalling.V(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#GenericMarshalling.V.VCase(a#103#0#0, a#103#1#0), 
        Tclass.GenericMarshalling.V(), 
        $h)
       <==> $IsAlloc(a#103#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#103#1#0, Tclass.GenericMarshalling.V(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.c(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VCase_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.c(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(GenericMarshalling.V.val(d), Tclass.GenericMarshalling.V(), $h) } 
  $IsGoodHeap($h)
       && 
      GenericMarshalling.V.VCase_q(d)
       && $IsAlloc(d, Tclass.GenericMarshalling.V(), $h)
     ==> $IsAlloc(GenericMarshalling.V.val(d), Tclass.GenericMarshalling.V(), $h));

// Constructor literal
axiom (forall a#104#0#0: int, a#104#1#0: DatatypeType :: 
  { #GenericMarshalling.V.VCase(LitInt(a#104#0#0), Lit(a#104#1#0)) } 
  #GenericMarshalling.V.VCase(LitInt(a#104#0#0), Lit(a#104#1#0))
     == Lit(#GenericMarshalling.V.VCase(a#104#0#0, a#104#1#0)));

function GenericMarshalling.V.c(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#105#0#0: int, a#105#1#0: DatatypeType :: 
  { #GenericMarshalling.V.VCase(a#105#0#0, a#105#1#0) } 
  GenericMarshalling.V.c(#GenericMarshalling.V.VCase(a#105#0#0, a#105#1#0))
     == a#105#0#0);

function GenericMarshalling.V.val(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#106#0#0: int, a#106#1#0: DatatypeType :: 
  { #GenericMarshalling.V.VCase(a#106#0#0, a#106#1#0) } 
  GenericMarshalling.V.val(#GenericMarshalling.V.VCase(a#106#0#0, a#106#1#0))
     == a#106#1#0);

// Inductive rank
axiom (forall a#107#0#0: int, a#107#1#0: DatatypeType :: 
  { #GenericMarshalling.V.VCase(a#107#0#0, a#107#1#0) } 
  DtRank(a#107#1#0) < DtRank(#GenericMarshalling.V.VCase(a#107#0#0, a#107#1#0)));

// Depth-one case-split function
function $IsA#GenericMarshalling.V(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#GenericMarshalling.V(d) } 
  $IsA#GenericMarshalling.V(d)
     ==> GenericMarshalling.V.VUint32_q(d)
       || GenericMarshalling.V.VUint64_q(d)
       || GenericMarshalling.V.VArray_q(d)
       || GenericMarshalling.V.VTuple_q(d)
       || GenericMarshalling.V.VByteArray_q(d)
       || GenericMarshalling.V.VUint32Array_q(d)
       || GenericMarshalling.V.VUint64Array_q(d)
       || GenericMarshalling.V.VCase_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { GenericMarshalling.V.VCase_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VUint64Array_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VUint32Array_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VByteArray_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VTuple_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VArray_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VUint64_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
    { GenericMarshalling.V.VUint32_q(d), $Is(d, Tclass.GenericMarshalling.V()) } 
  $Is(d, Tclass.GenericMarshalling.V())
     ==> GenericMarshalling.V.VUint32_q(d)
       || GenericMarshalling.V.VUint64_q(d)
       || GenericMarshalling.V.VArray_q(d)
       || GenericMarshalling.V.VTuple_q(d)
       || GenericMarshalling.V.VByteArray_q(d)
       || GenericMarshalling.V.VUint32Array_q(d)
       || GenericMarshalling.V.VUint64Array_q(d)
       || GenericMarshalling.V.VCase_q(d));

// Datatype extensional equality declaration
function GenericMarshalling.V#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #GenericMarshalling.V.VUint32
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint32_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint32_q(b) } 
  GenericMarshalling.V.VUint32_q(a) && GenericMarshalling.V.VUint32_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> GenericMarshalling.V.v(a) == GenericMarshalling.V.v(b)));

// Datatype extensional equality definition: #GenericMarshalling.V.VUint64
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint64_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint64_q(b) } 
  GenericMarshalling.V.VUint64_q(a) && GenericMarshalling.V.VUint64_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> GenericMarshalling.V.u(a) == GenericMarshalling.V.u(b)));

// Datatype extensional equality definition: #GenericMarshalling.V.VArray
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VArray_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VArray_q(b) } 
  GenericMarshalling.V.VArray_q(a) && GenericMarshalling.V.VArray_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.V.a(a), GenericMarshalling.V.a(b))));

// Datatype extensional equality definition: #GenericMarshalling.V.VTuple
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VTuple_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VTuple_q(b) } 
  GenericMarshalling.V.VTuple_q(a) && GenericMarshalling.V.VTuple_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.V.t(a), GenericMarshalling.V.t(b))));

// Datatype extensional equality definition: #GenericMarshalling.V.VByteArray
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VByteArray_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VByteArray_q(b) } 
  GenericMarshalling.V.VByteArray_q(a) && GenericMarshalling.V.VByteArray_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.V.b(a), GenericMarshalling.V.b(b))));

// Datatype extensional equality definition: #GenericMarshalling.V.VUint32Array
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint32Array_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint32Array_q(b) } 
  GenericMarshalling.V.VUint32Array_q(a) && GenericMarshalling.V.VUint32Array_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.V.va(a), GenericMarshalling.V.va(b))));

// Datatype extensional equality definition: #GenericMarshalling.V.VUint64Array
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint64Array_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VUint64Array_q(b) } 
  GenericMarshalling.V.VUint64Array_q(a) && GenericMarshalling.V.VUint64Array_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> Seq#Equal(GenericMarshalling.V.ua(a), GenericMarshalling.V.ua(b))));

// Datatype extensional equality definition: #GenericMarshalling.V.VCase
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VCase_q(a) } 
    { GenericMarshalling.V#Equal(a, b), GenericMarshalling.V.VCase_q(b) } 
  GenericMarshalling.V.VCase_q(a) && GenericMarshalling.V.VCase_q(b)
     ==> (GenericMarshalling.V#Equal(a, b)
       <==> GenericMarshalling.V.c(a) == GenericMarshalling.V.c(b)
         && GenericMarshalling.V#Equal(GenericMarshalling.V.val(a), GenericMarshalling.V.val(b))));

// Datatype extensionality axiom: GenericMarshalling.V
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { GenericMarshalling.V#Equal(a, b) } 
  GenericMarshalling.V#Equal(a, b) <==> a == b);

const unique class.GenericMarshalling.V: ClassName;

const unique class.GenericMarshalling.__default: ClassName;

function Tclass.GenericMarshalling.__default() : Ty;

// Tclass.GenericMarshalling.__default Tag
axiom Tag(Tclass.GenericMarshalling.__default())
   == Tagclass.GenericMarshalling.__default;

const unique Tagclass.GenericMarshalling.__default: TyTag;

// Box/unbox axiom for Tclass.GenericMarshalling.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.GenericMarshalling.__default()) } 
  $IsBox(bx, Tclass.GenericMarshalling.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.GenericMarshalling.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.GenericMarshalling.__default()) } 
  $Is($o, Tclass.GenericMarshalling.__default())
     <==> $o == null || dtype($o) == Tclass.GenericMarshalling.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.GenericMarshalling.__default(), $h) } 
  $IsAlloc($o, Tclass.GenericMarshalling.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for GenericMarshalling._default.ValInGrammar
function GenericMarshalling.__default.ValInGrammar($ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType) : bool;

function GenericMarshalling.__default.ValInGrammar#canCall(val#0: DatatypeType, grammar#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.ValInGrammar($LS($ly), val#0, grammar#0) } 
  GenericMarshalling.__default.ValInGrammar($LS($ly), val#0, grammar#0)
     == GenericMarshalling.__default.ValInGrammar($ly, val#0, grammar#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.ValInGrammar(AsFuelBottom($ly), val#0, grammar#0) } 
  GenericMarshalling.__default.ValInGrammar($ly, val#0, grammar#0)
     == GenericMarshalling.__default.ValInGrammar($LZ, val#0, grammar#0));

// consequence axiom for GenericMarshalling.__default.ValInGrammar
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType :: 
    { GenericMarshalling.__default.ValInGrammar($ly, val#0, grammar#0) } 
    GenericMarshalling.__default.ValInGrammar#canCall(val#0, grammar#0)
         || ($Is(val#0, Tclass.GenericMarshalling.V())
           && $Is(grammar#0, Tclass.GenericMarshalling.G()))
       ==> true);

function GenericMarshalling.__default.ValInGrammar#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for GenericMarshalling.__default.ValInGrammar
axiom (forall $ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.ValInGrammar#requires($ly, val#0, grammar#0) } 
  $Is(val#0, Tclass.GenericMarshalling.V())
       && $Is(grammar#0, Tclass.GenericMarshalling.G())
     ==> GenericMarshalling.__default.ValInGrammar#requires($ly, val#0, grammar#0)
       == true);

// definition axiom for GenericMarshalling.__default.ValInGrammar(revealed)
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType :: 
    { GenericMarshalling.__default.ValInGrammar($LS($ly), val#0, grammar#0) } 
    GenericMarshalling.__default.ValInGrammar#canCall(val#0, grammar#0)
         || ($Is(val#0, Tclass.GenericMarshalling.V())
           && $Is(grammar#0, Tclass.GenericMarshalling.G()))
       ==> (!GenericMarshalling.V.VUint32_q(val#0)
           ==> 
          !GenericMarshalling.V.VUint64_q(val#0)
           ==> (GenericMarshalling.V.VArray_q(val#0)
               ==> (var a#0 := GenericMarshalling.V.a(val#0); 
                GenericMarshalling.G.GArray_q(grammar#0)
                   ==> (forall v#0: DatatypeType :: 
                    { GenericMarshalling.__default.ValInGrammar($ly, v#0, GenericMarshalling.G.elt(grammar#0)) } 
                      { Seq#Contains(a#0, $Box(v#0)) } 
                    $Is(v#0, Tclass.GenericMarshalling.V())
                       ==> 
                      Seq#Contains(a#0, $Box(v#0))
                       ==> GenericMarshalling.__default.ValInGrammar#canCall(v#0, GenericMarshalling.G.elt(grammar#0)))))
             && (!GenericMarshalling.V.VArray_q(val#0)
               ==> (GenericMarshalling.V.VTuple_q(val#0)
                   ==> (var t#0 := GenericMarshalling.V.t(val#0); 
                    Seq#Length(t#0) == Seq#Length(GenericMarshalling.G.t(grammar#0))
                       ==> (forall i#0: int :: 
                        { $Unbox(Seq#Index(GenericMarshalling.G.t(grammar#0), i#0)): DatatypeType } 
                          { $Unbox(Seq#Index(t#0, i#0)): DatatypeType } 
                        i#0 < Seq#Length(t#0)
                           ==> GenericMarshalling.__default.ValInGrammar#canCall($Unbox(Seq#Index(t#0, i#0)): DatatypeType, 
                            $Unbox(Seq#Index(GenericMarshalling.G.t(grammar#0), i#0)): DatatypeType))))
                 && (!GenericMarshalling.V.VTuple_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VByteArray_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VUint32Array_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VUint64Array_q(val#0)
                   ==> (var v#1 := GenericMarshalling.V.val(val#0); 
                    (var c#0 := GenericMarshalling.V.c(val#0); 
                      c#0 < Seq#Length(GenericMarshalling.G.cases(grammar#0))
                         ==> GenericMarshalling.__default.ValInGrammar#canCall(v#1, $Unbox(Seq#Index(GenericMarshalling.G.cases(grammar#0), c#0)): DatatypeType))))))
         && GenericMarshalling.__default.ValInGrammar($LS($ly), val#0, grammar#0)
           == (if GenericMarshalling.V.VUint32_q(val#0)
             then GenericMarshalling.G.GUint32_q(grammar#0)
             else (if GenericMarshalling.V.VUint64_q(val#0)
               then GenericMarshalling.G.GUint64_q(grammar#0)
               else (if GenericMarshalling.V.VArray_q(val#0)
                 then (var a#1 := GenericMarshalling.V.a(val#0); 
                  GenericMarshalling.G.GArray_q(grammar#0)
                     && (forall v#2: DatatypeType :: 
                      {:_induction v#2} { GenericMarshalling.__default.ValInGrammar($ly, v#2, GenericMarshalling.G.elt(grammar#0)) } 
                        { Seq#Contains(a#1, $Box(v#2)) } 
                      $Is(v#2, Tclass.GenericMarshalling.V())
                         ==> 
                        Seq#Contains(a#1, $Box(v#2))
                         ==> GenericMarshalling.__default.ValInGrammar($ly, v#2, GenericMarshalling.G.elt(grammar#0))))
                 else (if GenericMarshalling.V.VTuple_q(val#0)
                   then (var t#1 := GenericMarshalling.V.t(val#0); 
                    GenericMarshalling.G.GTuple_q(grammar#0)
                       && Seq#Length(t#1) == Seq#Length(GenericMarshalling.G.t(grammar#0))
                       && (forall i#1: int :: 
                        { $Unbox(Seq#Index(GenericMarshalling.G.t(grammar#0), i#1)): DatatypeType } 
                          { $Unbox(Seq#Index(t#1, i#1)): DatatypeType } 
                        true
                           ==> 
                          LitInt(0) <= i#1 && i#1 < Seq#Length(t#1)
                           ==> GenericMarshalling.__default.ValInGrammar($ly, 
                            $Unbox(Seq#Index(t#1, i#1)): DatatypeType, 
                            $Unbox(Seq#Index(GenericMarshalling.G.t(grammar#0), i#1)): DatatypeType)))
                   else (if GenericMarshalling.V.VByteArray_q(val#0)
                     then (var b#1 := GenericMarshalling.V.b(val#0); 
                      GenericMarshalling.G.GByteArray_q(grammar#0))
                     else (if GenericMarshalling.V.VUint32Array_q(val#0)
                       then (var va#1 := GenericMarshalling.V.va(val#0); 
                        GenericMarshalling.G.GUint32Array_q(grammar#0))
                       else (if GenericMarshalling.V.VUint64Array_q(val#0)
                         then (var ua#1 := GenericMarshalling.V.ua(val#0); 
                          GenericMarshalling.G.GUint64Array_q(grammar#0))
                         else (var v#3 := GenericMarshalling.V.val(val#0); 
                          (var c#1 := GenericMarshalling.V.c(val#0); 
                            GenericMarshalling.G.GTaggedUnion_q(grammar#0)
                               && c#1 < Seq#Length(GenericMarshalling.G.cases(grammar#0))
                               && GenericMarshalling.__default.ValInGrammar($ly, 
                                v#3, 
                                $Unbox(Seq#Index(GenericMarshalling.G.cases(grammar#0), c#1)): DatatypeType)))))))))));

// definition axiom for GenericMarshalling.__default.ValInGrammar for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType, grammar#0: DatatypeType :: 
    {:weight 3} { GenericMarshalling.__default.ValInGrammar($LS($ly), Lit(val#0), Lit(grammar#0)) } 
    GenericMarshalling.__default.ValInGrammar#canCall(Lit(val#0), Lit(grammar#0))
         || ($Is(val#0, Tclass.GenericMarshalling.V())
           && $Is(grammar#0, Tclass.GenericMarshalling.G()))
       ==> (!Lit(GenericMarshalling.V.VUint32_q(Lit(val#0)))
           ==> 
          !Lit(GenericMarshalling.V.VUint64_q(Lit(val#0)))
           ==> (Lit(GenericMarshalling.V.VArray_q(Lit(val#0)))
               ==> (var a#2 := Lit(GenericMarshalling.V.a(Lit(val#0))); 
                Lit(GenericMarshalling.G.GArray_q(Lit(grammar#0)))
                   ==> (forall v#4: DatatypeType :: 
                    { GenericMarshalling.__default.ValInGrammar($LS($ly), v#4, GenericMarshalling.G.elt(grammar#0)) } 
                      { Seq#Contains(a#2, $Box(v#4)) } 
                    $Is(v#4, Tclass.GenericMarshalling.V())
                       ==> 
                      Seq#Contains(a#2, $Box(v#4))
                       ==> GenericMarshalling.__default.ValInGrammar#canCall(v#4, Lit(GenericMarshalling.G.elt(Lit(grammar#0)))))))
             && (!Lit(GenericMarshalling.V.VArray_q(Lit(val#0)))
               ==> (Lit(GenericMarshalling.V.VTuple_q(Lit(val#0)))
                   ==> (var t#2 := Lit(GenericMarshalling.V.t(Lit(val#0))); 
                    Seq#Length(t#2) == Seq#Length(Lit(GenericMarshalling.G.t(Lit(grammar#0))))
                       ==> (forall i#2: int :: 
                        { $Unbox(Seq#Index(GenericMarshalling.G.t(grammar#0), i#2)): DatatypeType } 
                          { $Unbox(Seq#Index(t#2, i#2)): DatatypeType } 
                        i#2 < Seq#Length(t#2)
                           ==> GenericMarshalling.__default.ValInGrammar#canCall($Unbox(Seq#Index(t#2, i#2)): DatatypeType, 
                            $Unbox(Seq#Index(Lit(GenericMarshalling.G.t(Lit(grammar#0))), i#2)): DatatypeType))))
                 && (!Lit(GenericMarshalling.V.VTuple_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VByteArray_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VUint32Array_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VUint64Array_q(Lit(val#0)))
                   ==> (var v#5 := Lit(GenericMarshalling.V.val(Lit(val#0))); 
                    (var c#2 := LitInt(GenericMarshalling.V.c(Lit(val#0))); 
                      c#2 < Seq#Length(Lit(GenericMarshalling.G.cases(Lit(grammar#0))))
                         ==> GenericMarshalling.__default.ValInGrammar#canCall(v#5, 
                          $Unbox(Seq#Index(Lit(GenericMarshalling.G.cases(Lit(grammar#0))), c#2)): DatatypeType))))))
         && GenericMarshalling.__default.ValInGrammar($LS($ly), Lit(val#0), Lit(grammar#0))
           == (if GenericMarshalling.V.VUint32_q(Lit(val#0))
             then GenericMarshalling.G.GUint32_q(Lit(grammar#0))
             else (if GenericMarshalling.V.VUint64_q(Lit(val#0))
               then GenericMarshalling.G.GUint64_q(Lit(grammar#0))
               else (if GenericMarshalling.V.VArray_q(Lit(val#0))
                 then (var a#3 := Lit(GenericMarshalling.V.a(Lit(val#0))); 
                  GenericMarshalling.G.GArray_q(Lit(grammar#0))
                     && (forall v#6: DatatypeType :: 
                      {:_induction v#6} { GenericMarshalling.__default.ValInGrammar($LS($ly), v#6, GenericMarshalling.G.elt(grammar#0)) } 
                        { Seq#Contains(a#3, $Box(v#6)) } 
                      $Is(v#6, Tclass.GenericMarshalling.V())
                         ==> 
                        Seq#Contains(a#3, $Box(v#6))
                         ==> GenericMarshalling.__default.ValInGrammar($LS($ly), v#6, Lit(GenericMarshalling.G.elt(Lit(grammar#0))))))
                 else (if GenericMarshalling.V.VTuple_q(Lit(val#0))
                   then (var t#3 := Lit(GenericMarshalling.V.t(Lit(val#0))); 
                    GenericMarshalling.G.GTuple_q(Lit(grammar#0))
                       && Seq#Length(t#3) == Seq#Length(Lit(GenericMarshalling.G.t(Lit(grammar#0))))
                       && (forall i#3: int :: 
                        { $Unbox(Seq#Index(GenericMarshalling.G.t(grammar#0), i#3)): DatatypeType } 
                          { $Unbox(Seq#Index(t#3, i#3)): DatatypeType } 
                        true
                           ==> 
                          LitInt(0) <= i#3 && i#3 < Seq#Length(t#3)
                           ==> GenericMarshalling.__default.ValInGrammar($LS($ly), 
                            $Unbox(Seq#Index(t#3, i#3)): DatatypeType, 
                            $Unbox(Seq#Index(Lit(GenericMarshalling.G.t(Lit(grammar#0))), i#3)): DatatypeType)))
                   else (if GenericMarshalling.V.VByteArray_q(Lit(val#0))
                     then (var b#3 := Lit(GenericMarshalling.V.b(Lit(val#0))); 
                      Lit(GenericMarshalling.G.GByteArray_q(Lit(grammar#0))))
                     else (if GenericMarshalling.V.VUint32Array_q(Lit(val#0))
                       then (var va#3 := Lit(GenericMarshalling.V.va(Lit(val#0))); 
                        Lit(GenericMarshalling.G.GUint32Array_q(Lit(grammar#0))))
                       else (if GenericMarshalling.V.VUint64Array_q(Lit(val#0))
                         then (var ua#3 := Lit(GenericMarshalling.V.ua(Lit(val#0))); 
                          Lit(GenericMarshalling.G.GUint64Array_q(Lit(grammar#0))))
                         else (var v#7 := Lit(GenericMarshalling.V.val(Lit(val#0))); 
                          (var c#3 := LitInt(GenericMarshalling.V.c(Lit(val#0))); 
                            GenericMarshalling.G.GTaggedUnion_q(Lit(grammar#0))
                               && c#3 < Seq#Length(Lit(GenericMarshalling.G.cases(Lit(grammar#0))))
                               && GenericMarshalling.__default.ValInGrammar($LS($ly), 
                                v#7, 
                                $Unbox(Seq#Index(Lit(GenericMarshalling.G.cases(Lit(grammar#0))), c#3)): DatatypeType)))))))))));

// function declaration for GenericMarshalling._default.ValidGrammar
function GenericMarshalling.__default.ValidGrammar($ly: LayerType, grammar#0: DatatypeType) : bool;

function GenericMarshalling.__default.ValidGrammar#canCall(grammar#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.ValidGrammar($LS($ly), grammar#0) } 
  GenericMarshalling.__default.ValidGrammar($LS($ly), grammar#0)
     == GenericMarshalling.__default.ValidGrammar($ly, grammar#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.ValidGrammar(AsFuelBottom($ly), grammar#0) } 
  GenericMarshalling.__default.ValidGrammar($ly, grammar#0)
     == GenericMarshalling.__default.ValidGrammar($LZ, grammar#0));

// consequence axiom for GenericMarshalling.__default.ValidGrammar
axiom true
   ==> (forall $ly: LayerType, grammar#0: DatatypeType :: 
    { GenericMarshalling.__default.ValidGrammar($ly, grammar#0) } 
    GenericMarshalling.__default.ValidGrammar#canCall(grammar#0)
         || $Is(grammar#0, Tclass.GenericMarshalling.G())
       ==> true);

function GenericMarshalling.__default.ValidGrammar#requires(LayerType, DatatypeType) : bool;

// #requires axiom for GenericMarshalling.__default.ValidGrammar
axiom (forall $ly: LayerType, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.ValidGrammar#requires($ly, grammar#0) } 
  $Is(grammar#0, Tclass.GenericMarshalling.G())
     ==> GenericMarshalling.__default.ValidGrammar#requires($ly, grammar#0) == true);

// definition axiom for GenericMarshalling.__default.ValidGrammar(revealed)
axiom true
   ==> (forall $ly: LayerType, grammar#0: DatatypeType :: 
    { GenericMarshalling.__default.ValidGrammar($LS($ly), grammar#0) } 
    GenericMarshalling.__default.ValidGrammar#canCall(grammar#0)
         || $Is(grammar#0, Tclass.GenericMarshalling.G())
       ==> (!GenericMarshalling.G.GUint32_q(grammar#0)
           ==> 
          !GenericMarshalling.G.GUint64_q(grammar#0)
           ==> (GenericMarshalling.G.GArray_q(grammar#0)
               ==> (var elt#0 := GenericMarshalling.G.elt(grammar#0); 
                GenericMarshalling.__default.ValidGrammar#canCall(elt#0)))
             && (!GenericMarshalling.G.GArray_q(grammar#0)
               ==> (GenericMarshalling.G.GTuple_q(grammar#0)
                   ==> (var t#0 := GenericMarshalling.G.t(grammar#0); 
                    Seq#Length(t#0) < 18446744073709551616
                       ==> (forall g#0: DatatypeType :: 
                        { GenericMarshalling.__default.ValidGrammar($ly, g#0) } 
                          { Seq#Contains(t#0, $Box(g#0)) } 
                        $Is(g#0, Tclass.GenericMarshalling.G())
                           ==> 
                          Seq#Contains(t#0, $Box(g#0))
                           ==> GenericMarshalling.__default.ValidGrammar#canCall(g#0))))
                 && (!GenericMarshalling.G.GTuple_q(grammar#0)
                   ==> 
                  !GenericMarshalling.G.GByteArray_q(grammar#0)
                   ==> 
                  !GenericMarshalling.G.GUint32Array_q(grammar#0)
                   ==> 
                  !GenericMarshalling.G.GUint64Array_q(grammar#0)
                   ==> (var cases#0 := GenericMarshalling.G.cases(grammar#0); 
                    Seq#Length(cases#0) < 18446744073709551616
                       ==> (forall g#1: DatatypeType :: 
                        { GenericMarshalling.__default.ValidGrammar($ly, g#1) } 
                          { Seq#Contains(cases#0, $Box(g#1)) } 
                        $Is(g#1, Tclass.GenericMarshalling.G())
                           ==> 
                          Seq#Contains(cases#0, $Box(g#1))
                           ==> GenericMarshalling.__default.ValidGrammar#canCall(g#1))))))
         && GenericMarshalling.__default.ValidGrammar($LS($ly), grammar#0)
           == (if GenericMarshalling.G.GUint32_q(grammar#0)
             then true
             else (if GenericMarshalling.G.GUint64_q(grammar#0)
               then true
               else (if GenericMarshalling.G.GArray_q(grammar#0)
                 then (var elt#1 := GenericMarshalling.G.elt(grammar#0); 
                  GenericMarshalling.__default.ValidGrammar($ly, elt#1))
                 else (if GenericMarshalling.G.GTuple_q(grammar#0)
                   then (var t#1 := GenericMarshalling.G.t(grammar#0); 
                    Seq#Length(t#1) < 18446744073709551616
                       && (forall g#2: DatatypeType :: 
                        {:_induction g#2} { GenericMarshalling.__default.ValidGrammar($ly, g#2) } 
                          { Seq#Contains(t#1, $Box(g#2)) } 
                        $Is(g#2, Tclass.GenericMarshalling.G())
                           ==> 
                          Seq#Contains(t#1, $Box(g#2))
                           ==> GenericMarshalling.__default.ValidGrammar($ly, g#2)))
                   else (if GenericMarshalling.G.GByteArray_q(grammar#0)
                     then true
                     else (if GenericMarshalling.G.GUint32Array_q(grammar#0)
                       then true
                       else (if GenericMarshalling.G.GUint64Array_q(grammar#0)
                         then true
                         else (var cases#1 := GenericMarshalling.G.cases(grammar#0); 
                          Seq#Length(cases#1) < 18446744073709551616
                             && (forall g#3: DatatypeType :: 
                              {:_induction g#3} { GenericMarshalling.__default.ValidGrammar($ly, g#3) } 
                                { Seq#Contains(cases#1, $Box(g#3)) } 
                              $Is(g#3, Tclass.GenericMarshalling.G())
                                 ==> 
                                Seq#Contains(cases#1, $Box(g#3))
                                 ==> GenericMarshalling.__default.ValidGrammar($ly, g#3)))))))))));

// definition axiom for GenericMarshalling.__default.ValidGrammar for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, grammar#0: DatatypeType :: 
    {:weight 3} { GenericMarshalling.__default.ValidGrammar($LS($ly), Lit(grammar#0)) } 
    GenericMarshalling.__default.ValidGrammar#canCall(Lit(grammar#0))
         || $Is(grammar#0, Tclass.GenericMarshalling.G())
       ==> (!Lit(GenericMarshalling.G.GUint32_q(Lit(grammar#0)))
           ==> 
          !Lit(GenericMarshalling.G.GUint64_q(Lit(grammar#0)))
           ==> (Lit(GenericMarshalling.G.GArray_q(Lit(grammar#0)))
               ==> (var elt#2 := Lit(GenericMarshalling.G.elt(Lit(grammar#0))); 
                GenericMarshalling.__default.ValidGrammar#canCall(elt#2)))
             && (!Lit(GenericMarshalling.G.GArray_q(Lit(grammar#0)))
               ==> (Lit(GenericMarshalling.G.GTuple_q(Lit(grammar#0)))
                   ==> (var t#2 := Lit(GenericMarshalling.G.t(Lit(grammar#0))); 
                    Seq#Length(t#2) < 18446744073709551616
                       ==> (forall g#4: DatatypeType :: 
                        { GenericMarshalling.__default.ValidGrammar($LS($ly), g#4) } 
                          { Seq#Contains(t#2, $Box(g#4)) } 
                        $Is(g#4, Tclass.GenericMarshalling.G())
                           ==> 
                          Seq#Contains(t#2, $Box(g#4))
                           ==> GenericMarshalling.__default.ValidGrammar#canCall(g#4))))
                 && (!Lit(GenericMarshalling.G.GTuple_q(Lit(grammar#0)))
                   ==> 
                  !Lit(GenericMarshalling.G.GByteArray_q(Lit(grammar#0)))
                   ==> 
                  !Lit(GenericMarshalling.G.GUint32Array_q(Lit(grammar#0)))
                   ==> 
                  !Lit(GenericMarshalling.G.GUint64Array_q(Lit(grammar#0)))
                   ==> (var cases#2 := Lit(GenericMarshalling.G.cases(Lit(grammar#0))); 
                    Seq#Length(cases#2) < 18446744073709551616
                       ==> (forall g#5: DatatypeType :: 
                        { GenericMarshalling.__default.ValidGrammar($LS($ly), g#5) } 
                          { Seq#Contains(cases#2, $Box(g#5)) } 
                        $Is(g#5, Tclass.GenericMarshalling.G())
                           ==> 
                          Seq#Contains(cases#2, $Box(g#5))
                           ==> GenericMarshalling.__default.ValidGrammar#canCall(g#5))))))
         && GenericMarshalling.__default.ValidGrammar($LS($ly), Lit(grammar#0))
           == (if GenericMarshalling.G.GUint32_q(Lit(grammar#0))
             then true
             else (if GenericMarshalling.G.GUint64_q(Lit(grammar#0))
               then true
               else (if GenericMarshalling.G.GArray_q(Lit(grammar#0))
                 then (var elt#3 := Lit(GenericMarshalling.G.elt(Lit(grammar#0))); 
                  Lit(GenericMarshalling.__default.ValidGrammar($LS($ly), elt#3)))
                 else (if GenericMarshalling.G.GTuple_q(Lit(grammar#0))
                   then (var t#3 := Lit(GenericMarshalling.G.t(Lit(grammar#0))); 
                    Seq#Length(t#3) < 18446744073709551616
                       && (forall g#6: DatatypeType :: 
                        {:_induction g#6} { GenericMarshalling.__default.ValidGrammar($LS($ly), g#6) } 
                          { Seq#Contains(t#3, $Box(g#6)) } 
                        $Is(g#6, Tclass.GenericMarshalling.G())
                           ==> 
                          Seq#Contains(t#3, $Box(g#6))
                           ==> GenericMarshalling.__default.ValidGrammar($LS($ly), g#6)))
                   else (if GenericMarshalling.G.GByteArray_q(Lit(grammar#0))
                     then true
                     else (if GenericMarshalling.G.GUint32Array_q(Lit(grammar#0))
                       then true
                       else (if GenericMarshalling.G.GUint64Array_q(Lit(grammar#0))
                         then true
                         else (var cases#3 := Lit(GenericMarshalling.G.cases(Lit(grammar#0))); 
                          Seq#Length(cases#3) < 18446744073709551616
                             && (forall g#7: DatatypeType :: 
                              {:_induction g#7} { GenericMarshalling.__default.ValidGrammar($LS($ly), g#7) } 
                                { Seq#Contains(cases#3, $Box(g#7)) } 
                              $Is(g#7, Tclass.GenericMarshalling.G())
                                 ==> 
                                Seq#Contains(cases#3, $Box(g#7))
                                 ==> GenericMarshalling.__default.ValidGrammar($LS($ly), g#7)))))))))));

// function declaration for GenericMarshalling._default.ValidVal
function GenericMarshalling.__default.ValidVal($ly: LayerType, val#0: DatatypeType) : bool;

function GenericMarshalling.__default.ValidVal#canCall(val#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, val#0: DatatypeType :: 
  { GenericMarshalling.__default.ValidVal($LS($ly), val#0) } 
  GenericMarshalling.__default.ValidVal($LS($ly), val#0)
     == GenericMarshalling.__default.ValidVal($ly, val#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, val#0: DatatypeType :: 
  { GenericMarshalling.__default.ValidVal(AsFuelBottom($ly), val#0) } 
  GenericMarshalling.__default.ValidVal($ly, val#0)
     == GenericMarshalling.__default.ValidVal($LZ, val#0));

// consequence axiom for GenericMarshalling.__default.ValidVal
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType :: 
    { GenericMarshalling.__default.ValidVal($ly, val#0) } 
    GenericMarshalling.__default.ValidVal#canCall(val#0)
         || $Is(val#0, Tclass.GenericMarshalling.V())
       ==> true);

function GenericMarshalling.__default.ValidVal#requires(LayerType, DatatypeType) : bool;

// #requires axiom for GenericMarshalling.__default.ValidVal
axiom (forall $ly: LayerType, val#0: DatatypeType :: 
  { GenericMarshalling.__default.ValidVal#requires($ly, val#0) } 
  $Is(val#0, Tclass.GenericMarshalling.V())
     ==> GenericMarshalling.__default.ValidVal#requires($ly, val#0) == true);

// definition axiom for GenericMarshalling.__default.ValidVal(revealed)
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType :: 
    { GenericMarshalling.__default.ValidVal($LS($ly), val#0) } 
    GenericMarshalling.__default.ValidVal#canCall(val#0)
         || $Is(val#0, Tclass.GenericMarshalling.V())
       ==> (!GenericMarshalling.V.VUint32_q(val#0)
           ==> 
          !GenericMarshalling.V.VUint64_q(val#0)
           ==> (GenericMarshalling.V.VArray_q(val#0)
               ==> (var a#0 := GenericMarshalling.V.a(val#0); 
                Seq#Length(a#0) < 18446744073709551616
                   ==> (forall v#0: DatatypeType :: 
                    { GenericMarshalling.__default.ValidVal($ly, v#0) } 
                      { Seq#Contains(a#0, $Box(v#0)) } 
                    $Is(v#0, Tclass.GenericMarshalling.V())
                       ==> 
                      Seq#Contains(a#0, $Box(v#0))
                       ==> GenericMarshalling.__default.ValidVal#canCall(v#0))))
             && (!GenericMarshalling.V.VArray_q(val#0)
               ==> (GenericMarshalling.V.VTuple_q(val#0)
                   ==> (var t#0 := GenericMarshalling.V.t(val#0); 
                    Seq#Length(t#0) < 18446744073709551616
                       ==> (forall v#1: DatatypeType :: 
                        { GenericMarshalling.__default.ValidVal($ly, v#1) } 
                          { Seq#Contains(t#0, $Box(v#1)) } 
                        $Is(v#1, Tclass.GenericMarshalling.V())
                           ==> 
                          Seq#Contains(t#0, $Box(v#1))
                           ==> GenericMarshalling.__default.ValidVal#canCall(v#1))))
                 && (!GenericMarshalling.V.VTuple_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VByteArray_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VUint32Array_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VUint64Array_q(val#0)
                   ==> (var v#2 := GenericMarshalling.V.val(val#0); 
                    GenericMarshalling.__default.ValidVal#canCall(v#2)))))
         && GenericMarshalling.__default.ValidVal($LS($ly), val#0)
           == (if GenericMarshalling.V.VUint32_q(val#0)
             then true
             else (if GenericMarshalling.V.VUint64_q(val#0)
               then true
               else (if GenericMarshalling.V.VArray_q(val#0)
                 then (var a#1 := GenericMarshalling.V.a(val#0); 
                  Seq#Length(a#1) < 18446744073709551616
                     && (forall v#3: DatatypeType :: 
                      {:_induction v#3} { GenericMarshalling.__default.ValidVal($ly, v#3) } 
                        { Seq#Contains(a#1, $Box(v#3)) } 
                      $Is(v#3, Tclass.GenericMarshalling.V())
                         ==> 
                        Seq#Contains(a#1, $Box(v#3))
                         ==> GenericMarshalling.__default.ValidVal($ly, v#3)))
                 else (if GenericMarshalling.V.VTuple_q(val#0)
                   then (var t#1 := GenericMarshalling.V.t(val#0); 
                    Seq#Length(t#1) < 18446744073709551616
                       && (forall v#4: DatatypeType :: 
                        {:_induction v#4} { GenericMarshalling.__default.ValidVal($ly, v#4) } 
                          { Seq#Contains(t#1, $Box(v#4)) } 
                        $Is(v#4, Tclass.GenericMarshalling.V())
                           ==> 
                          Seq#Contains(t#1, $Box(v#4))
                           ==> GenericMarshalling.__default.ValidVal($ly, v#4)))
                   else (if GenericMarshalling.V.VByteArray_q(val#0)
                     then (var b#1 := GenericMarshalling.V.b(val#0); 
                      Seq#Length(b#1) < 18446744073709551616)
                     else (if GenericMarshalling.V.VUint32Array_q(val#0)
                       then (var va#1 := GenericMarshalling.V.va(val#0); 
                        Seq#Length(va#1) < 18446744073709551616)
                       else (if GenericMarshalling.V.VUint64Array_q(val#0)
                         then (var ua#1 := GenericMarshalling.V.ua(val#0); 
                          Seq#Length(ua#1) < 18446744073709551616)
                         else (var v#5 := GenericMarshalling.V.val(val#0); 
                          (var c#1 := GenericMarshalling.V.c(val#0); 
                            GenericMarshalling.__default.ValidVal($ly, v#5)))))))))));

// definition axiom for GenericMarshalling.__default.ValidVal for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType :: 
    {:weight 3} { GenericMarshalling.__default.ValidVal($LS($ly), Lit(val#0)) } 
    GenericMarshalling.__default.ValidVal#canCall(Lit(val#0))
         || $Is(val#0, Tclass.GenericMarshalling.V())
       ==> (!Lit(GenericMarshalling.V.VUint32_q(Lit(val#0)))
           ==> 
          !Lit(GenericMarshalling.V.VUint64_q(Lit(val#0)))
           ==> (Lit(GenericMarshalling.V.VArray_q(Lit(val#0)))
               ==> (var a#2 := Lit(GenericMarshalling.V.a(Lit(val#0))); 
                Seq#Length(a#2) < 18446744073709551616
                   ==> (forall v#6: DatatypeType :: 
                    { GenericMarshalling.__default.ValidVal($LS($ly), v#6) } 
                      { Seq#Contains(a#2, $Box(v#6)) } 
                    $Is(v#6, Tclass.GenericMarshalling.V())
                       ==> 
                      Seq#Contains(a#2, $Box(v#6))
                       ==> GenericMarshalling.__default.ValidVal#canCall(v#6))))
             && (!Lit(GenericMarshalling.V.VArray_q(Lit(val#0)))
               ==> (Lit(GenericMarshalling.V.VTuple_q(Lit(val#0)))
                   ==> (var t#2 := Lit(GenericMarshalling.V.t(Lit(val#0))); 
                    Seq#Length(t#2) < 18446744073709551616
                       ==> (forall v#7: DatatypeType :: 
                        { GenericMarshalling.__default.ValidVal($LS($ly), v#7) } 
                          { Seq#Contains(t#2, $Box(v#7)) } 
                        $Is(v#7, Tclass.GenericMarshalling.V())
                           ==> 
                          Seq#Contains(t#2, $Box(v#7))
                           ==> GenericMarshalling.__default.ValidVal#canCall(v#7))))
                 && (!Lit(GenericMarshalling.V.VTuple_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VByteArray_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VUint32Array_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VUint64Array_q(Lit(val#0)))
                   ==> (var v#8 := Lit(GenericMarshalling.V.val(Lit(val#0))); 
                    GenericMarshalling.__default.ValidVal#canCall(v#8)))))
         && GenericMarshalling.__default.ValidVal($LS($ly), Lit(val#0))
           == (if GenericMarshalling.V.VUint32_q(Lit(val#0))
             then true
             else (if GenericMarshalling.V.VUint64_q(Lit(val#0))
               then true
               else (if GenericMarshalling.V.VArray_q(Lit(val#0))
                 then (var a#3 := Lit(GenericMarshalling.V.a(Lit(val#0))); 
                  Seq#Length(a#3) < 18446744073709551616
                     && (forall v#9: DatatypeType :: 
                      {:_induction v#9} { GenericMarshalling.__default.ValidVal($LS($ly), v#9) } 
                        { Seq#Contains(a#3, $Box(v#9)) } 
                      $Is(v#9, Tclass.GenericMarshalling.V())
                         ==> 
                        Seq#Contains(a#3, $Box(v#9))
                         ==> GenericMarshalling.__default.ValidVal($LS($ly), v#9)))
                 else (if GenericMarshalling.V.VTuple_q(Lit(val#0))
                   then (var t#3 := Lit(GenericMarshalling.V.t(Lit(val#0))); 
                    Seq#Length(t#3) < 18446744073709551616
                       && (forall v#10: DatatypeType :: 
                        {:_induction v#10} { GenericMarshalling.__default.ValidVal($LS($ly), v#10) } 
                          { Seq#Contains(t#3, $Box(v#10)) } 
                        $Is(v#10, Tclass.GenericMarshalling.V())
                           ==> 
                          Seq#Contains(t#3, $Box(v#10))
                           ==> GenericMarshalling.__default.ValidVal($LS($ly), v#10)))
                   else (if GenericMarshalling.V.VByteArray_q(Lit(val#0))
                     then (var b#3 := Lit(GenericMarshalling.V.b(Lit(val#0))); 
                      Seq#Length(b#3) < 18446744073709551616)
                     else (if GenericMarshalling.V.VUint32Array_q(Lit(val#0))
                       then (var va#3 := Lit(GenericMarshalling.V.va(Lit(val#0))); 
                        Seq#Length(va#3) < 18446744073709551616)
                       else (if GenericMarshalling.V.VUint64Array_q(Lit(val#0))
                         then (var ua#3 := Lit(GenericMarshalling.V.ua(Lit(val#0))); 
                          Seq#Length(ua#3) < 18446744073709551616)
                         else (var v#11 := Lit(GenericMarshalling.V.val(Lit(val#0))); 
                          (var c#3 := LitInt(GenericMarshalling.V.c(Lit(val#0))); 
                            Lit(GenericMarshalling.__default.ValidVal($LS($ly), v#11))))))))))));

// function declaration for GenericMarshalling._default.SeqSum
function GenericMarshalling.__default.SeqSum($ly: LayerType, t#0: Seq Box) : int;

function GenericMarshalling.__default.SeqSum#canCall(t#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, t#0: Seq Box :: 
  { GenericMarshalling.__default.SeqSum($LS($ly), t#0) } 
  GenericMarshalling.__default.SeqSum($LS($ly), t#0)
     == GenericMarshalling.__default.SeqSum($ly, t#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, t#0: Seq Box :: 
  { GenericMarshalling.__default.SeqSum(AsFuelBottom($ly), t#0) } 
  GenericMarshalling.__default.SeqSum($ly, t#0)
     == GenericMarshalling.__default.SeqSum($LZ, t#0));

// consequence axiom for GenericMarshalling.__default.SeqSum
axiom true
   ==> (forall $ly: LayerType, t#0: Seq Box :: 
    { GenericMarshalling.__default.SeqSum($ly, t#0) } 
    GenericMarshalling.__default.SeqSum#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.GenericMarshalling.V()))
       ==> GenericMarshalling.__default.SeqSum($ly, t#0) >= LitInt(0));

function GenericMarshalling.__default.SeqSum#requires(LayerType, Seq Box) : bool;

// #requires axiom for GenericMarshalling.__default.SeqSum
axiom (forall $ly: LayerType, t#0: Seq Box :: 
  { GenericMarshalling.__default.SeqSum#requires($ly, t#0) } 
  $Is(t#0, TSeq(Tclass.GenericMarshalling.V()))
     ==> GenericMarshalling.__default.SeqSum#requires($ly, t#0) == true);

// definition axiom for GenericMarshalling.__default.SeqSum(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: Seq Box :: 
    { GenericMarshalling.__default.SeqSum($LS($ly), t#0) } 
    GenericMarshalling.__default.SeqSum#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.GenericMarshalling.V()))
       ==> (Seq#Length(t#0) != LitInt(0)
           ==> GenericMarshalling.__default.SizeOfV#canCall($Unbox(Seq#Index(t#0, LitInt(0))): DatatypeType)
             && GenericMarshalling.__default.SeqSum#canCall(Seq#Drop(t#0, LitInt(1))))
         && GenericMarshalling.__default.SeqSum($LS($ly), t#0)
           == (if Seq#Length(t#0) == LitInt(0)
             then 0
             else GenericMarshalling.__default.SizeOfV($ly, $Unbox(Seq#Index(t#0, LitInt(0))): DatatypeType)
               + GenericMarshalling.__default.SeqSum($ly, Seq#Drop(t#0, LitInt(1)))));

// definition axiom for GenericMarshalling.__default.SeqSum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: Seq Box :: 
    {:weight 3} { GenericMarshalling.__default.SeqSum($LS($ly), Lit(t#0)) } 
    GenericMarshalling.__default.SeqSum#canCall(Lit(t#0))
         || $Is(t#0, TSeq(Tclass.GenericMarshalling.V()))
       ==> (Seq#Length(Lit(t#0)) != LitInt(0)
           ==> GenericMarshalling.__default.SizeOfV#canCall($Unbox(Seq#Index(Lit(t#0), LitInt(0))): DatatypeType)
             && GenericMarshalling.__default.SeqSum#canCall(Lit(Seq#Drop(Lit(t#0), LitInt(1)))))
         && GenericMarshalling.__default.SeqSum($LS($ly), Lit(t#0))
           == (if Seq#Length(Lit(t#0)) == LitInt(0)
             then 0
             else GenericMarshalling.__default.SizeOfV($LS($ly), $Unbox(Seq#Index(Lit(t#0), LitInt(0))): DatatypeType)
               + GenericMarshalling.__default.SeqSum($LS($ly), Lit(Seq#Drop(Lit(t#0), LitInt(1))))));

// function declaration for GenericMarshalling._default.SizeOfV
function GenericMarshalling.__default.SizeOfV($ly: LayerType, val#0: DatatypeType) : int;

function GenericMarshalling.__default.SizeOfV#canCall(val#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, val#0: DatatypeType :: 
  { GenericMarshalling.__default.SizeOfV($LS($ly), val#0) } 
  GenericMarshalling.__default.SizeOfV($LS($ly), val#0)
     == GenericMarshalling.__default.SizeOfV($ly, val#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, val#0: DatatypeType :: 
  { GenericMarshalling.__default.SizeOfV(AsFuelBottom($ly), val#0) } 
  GenericMarshalling.__default.SizeOfV($ly, val#0)
     == GenericMarshalling.__default.SizeOfV($LZ, val#0));

// consequence axiom for GenericMarshalling.__default.SizeOfV
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType :: 
    { GenericMarshalling.__default.SizeOfV($ly, val#0) } 
    GenericMarshalling.__default.SizeOfV#canCall(val#0)
         || $Is(val#0, Tclass.GenericMarshalling.V())
       ==> GenericMarshalling.__default.SizeOfV($ly, val#0) >= LitInt(0));

function GenericMarshalling.__default.SizeOfV#requires(LayerType, DatatypeType) : bool;

// #requires axiom for GenericMarshalling.__default.SizeOfV
axiom (forall $ly: LayerType, val#0: DatatypeType :: 
  { GenericMarshalling.__default.SizeOfV#requires($ly, val#0) } 
  $Is(val#0, Tclass.GenericMarshalling.V())
     ==> GenericMarshalling.__default.SizeOfV#requires($ly, val#0) == true);

// definition axiom for GenericMarshalling.__default.SizeOfV(revealed)
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType :: 
    { GenericMarshalling.__default.SizeOfV($LS($ly), val#0) } 
    GenericMarshalling.__default.SizeOfV#canCall(val#0)
         || $Is(val#0, Tclass.GenericMarshalling.V())
       ==> (!GenericMarshalling.V.VUint32_q(val#0)
           ==> 
          !GenericMarshalling.V.VUint64_q(val#0)
           ==> (GenericMarshalling.V.VArray_q(val#0)
               ==> (var a#0 := GenericMarshalling.V.a(val#0); 
                GenericMarshalling.__default.SeqSum#canCall(a#0)))
             && (!GenericMarshalling.V.VArray_q(val#0)
               ==> (GenericMarshalling.V.VTuple_q(val#0)
                   ==> (var t#0 := GenericMarshalling.V.t(val#0); 
                    GenericMarshalling.__default.SeqSum#canCall(t#0)))
                 && (!GenericMarshalling.V.VTuple_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VByteArray_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VUint32Array_q(val#0)
                   ==> 
                  !GenericMarshalling.V.VUint64Array_q(val#0)
                   ==> (var v#0 := GenericMarshalling.V.val(val#0); 
                    GenericMarshalling.__default.SizeOfV#canCall(v#0)))))
         && GenericMarshalling.__default.SizeOfV($LS($ly), val#0)
           == (if GenericMarshalling.V.VUint32_q(val#0)
             then 4
             else (if GenericMarshalling.V.VUint64_q(val#0)
               then 8
               else (if GenericMarshalling.V.VArray_q(val#0)
                 then (var a#1 := GenericMarshalling.V.a(val#0); 
                  8 + GenericMarshalling.__default.SeqSum($ly, a#1))
                 else (if GenericMarshalling.V.VTuple_q(val#0)
                   then (var t#1 := GenericMarshalling.V.t(val#0); 
                    GenericMarshalling.__default.SeqSum($ly, t#1))
                   else (if GenericMarshalling.V.VByteArray_q(val#0)
                     then (var b#3 := GenericMarshalling.V.b(val#0); 8 + Seq#Length(b#3))
                     else (if GenericMarshalling.V.VUint32Array_q(val#0)
                       then (var b#4 := GenericMarshalling.V.va(val#0); 8 + Mul(LitInt(4), Seq#Length(b#4)))
                       else (if GenericMarshalling.V.VUint64Array_q(val#0)
                         then (var b#5 := GenericMarshalling.V.ua(val#0); 8 + Mul(LitInt(8), Seq#Length(b#5)))
                         else (var v#1 := GenericMarshalling.V.val(val#0); 
                          (var c#1 := GenericMarshalling.V.c(val#0); 
                            8 + GenericMarshalling.__default.SizeOfV($ly, v#1)))))))))));

// definition axiom for GenericMarshalling.__default.SizeOfV for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, val#0: DatatypeType :: 
    {:weight 3} { GenericMarshalling.__default.SizeOfV($LS($ly), Lit(val#0)) } 
    GenericMarshalling.__default.SizeOfV#canCall(Lit(val#0))
         || $Is(val#0, Tclass.GenericMarshalling.V())
       ==> (!Lit(GenericMarshalling.V.VUint32_q(Lit(val#0)))
           ==> 
          !Lit(GenericMarshalling.V.VUint64_q(Lit(val#0)))
           ==> (Lit(GenericMarshalling.V.VArray_q(Lit(val#0)))
               ==> (var a#2 := Lit(GenericMarshalling.V.a(Lit(val#0))); 
                GenericMarshalling.__default.SeqSum#canCall(a#2)))
             && (!Lit(GenericMarshalling.V.VArray_q(Lit(val#0)))
               ==> (Lit(GenericMarshalling.V.VTuple_q(Lit(val#0)))
                   ==> (var t#2 := Lit(GenericMarshalling.V.t(Lit(val#0))); 
                    GenericMarshalling.__default.SeqSum#canCall(t#2)))
                 && (!Lit(GenericMarshalling.V.VTuple_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VByteArray_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VUint32Array_q(Lit(val#0)))
                   ==> 
                  !Lit(GenericMarshalling.V.VUint64Array_q(Lit(val#0)))
                   ==> (var v#2 := Lit(GenericMarshalling.V.val(Lit(val#0))); 
                    GenericMarshalling.__default.SizeOfV#canCall(v#2)))))
         && GenericMarshalling.__default.SizeOfV($LS($ly), Lit(val#0))
           == (if GenericMarshalling.V.VUint32_q(Lit(val#0))
             then 4
             else (if GenericMarshalling.V.VUint64_q(Lit(val#0))
               then 8
               else (if GenericMarshalling.V.VArray_q(Lit(val#0))
                 then (var a#3 := Lit(GenericMarshalling.V.a(Lit(val#0))); 
                  8 + GenericMarshalling.__default.SeqSum($LS($ly), a#3))
                 else (if GenericMarshalling.V.VTuple_q(Lit(val#0))
                   then (var t#3 := Lit(GenericMarshalling.V.t(Lit(val#0))); 
                    GenericMarshalling.__default.SeqSum($LS($ly), t#3))
                   else (if GenericMarshalling.V.VByteArray_q(Lit(val#0))
                     then (var b#9 := Lit(GenericMarshalling.V.b(Lit(val#0))); 8 + Seq#Length(b#9))
                     else (if GenericMarshalling.V.VUint32Array_q(Lit(val#0))
                       then (var b#10 := Lit(GenericMarshalling.V.va(Lit(val#0))); 
                        8 + Mul(LitInt(4), Seq#Length(b#10)))
                       else (if GenericMarshalling.V.VUint64Array_q(Lit(val#0))
                         then (var b#11 := Lit(GenericMarshalling.V.ua(Lit(val#0))); 
                          8 + Mul(LitInt(8), Seq#Length(b#11)))
                         else (var v#3 := Lit(GenericMarshalling.V.val(Lit(val#0))); 
                          (var c#3 := LitInt(GenericMarshalling.V.c(Lit(val#0))); 
                            LitInt(8 + GenericMarshalling.__default.SizeOfV($LS($ly), v#3))))))))))));

// function declaration for GenericMarshalling._default.parse_Val
function GenericMarshalling.__default.parse__Val($ly: LayerType, data#0: Seq Box, grammar#0: DatatypeType) : DatatypeType;

function GenericMarshalling.__default.parse__Val#canCall(data#0: Seq Box, grammar#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, data#0: Seq Box, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.parse__Val($LS($ly), data#0, grammar#0) } 
  GenericMarshalling.__default.parse__Val($LS($ly), data#0, grammar#0)
     == GenericMarshalling.__default.parse__Val($ly, data#0, grammar#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, data#0: Seq Box, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.parse__Val(AsFuelBottom($ly), data#0, grammar#0) } 
  GenericMarshalling.__default.parse__Val($ly, data#0, grammar#0)
     == GenericMarshalling.__default.parse__Val($LZ, data#0, grammar#0));

// consequence axiom for GenericMarshalling.__default.parse__Val
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box, grammar#0: DatatypeType :: 
    { GenericMarshalling.__default.parse__Val($ly, data#0, grammar#0) } 
    GenericMarshalling.__default.parse__Val#canCall(data#0, grammar#0)
         || (
          $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(grammar#0, Tclass.GenericMarshalling.G())
           && 
          Seq#Length(data#0) < 18446744073709551616
           && GenericMarshalling.__default.ValidGrammar($LS($LZ), grammar#0))
       ==> (var val#0, rest#0 := $Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($ly, data#0, grammar#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(GenericMarshalling.__default.parse__Val($ly, data#0, grammar#0))): Seq Box; 
          Seq#Length(rest#0) <= Seq#Length(data#0)
             && (!Options.Option.None_q(val#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                  $Unbox(Options.Option.value(val#0)): DatatypeType)
                 && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                  $Unbox(Options.Option.value(val#0)): DatatypeType, 
                  grammar#0)))
         && $Is(GenericMarshalling.__default.parse__Val($ly, data#0, grammar#0), 
          Tclass._System.Tuple2(Tclass.Options.Option(Tclass.GenericMarshalling.V()), 
            TSeq(Tclass.NativeTypes.byte()))));

function GenericMarshalling.__default.parse__Val#requires(LayerType, Seq Box, DatatypeType) : bool;

// #requires axiom for GenericMarshalling.__default.parse__Val
axiom (forall $ly: LayerType, data#0: Seq Box, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.parse__Val#requires($ly, data#0, grammar#0) } 
  $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(grammar#0, Tclass.GenericMarshalling.G())
     ==> GenericMarshalling.__default.parse__Val#requires($ly, data#0, grammar#0)
       == (Seq#Length(data#0) < 18446744073709551616
         && GenericMarshalling.__default.ValidGrammar($LS($LZ), grammar#0)));

// function declaration for GenericMarshalling._default.Demarshallable
function GenericMarshalling.__default.Demarshallable(data#0: Seq Box, grammar#0: DatatypeType) : bool;

function GenericMarshalling.__default.Demarshallable#canCall(data#0: Seq Box, grammar#0: DatatypeType) : bool;

// consequence axiom for GenericMarshalling.__default.Demarshallable
axiom true
   ==> (forall data#0: Seq Box, grammar#0: DatatypeType :: 
    { GenericMarshalling.__default.Demarshallable(data#0, grammar#0) } 
    GenericMarshalling.__default.Demarshallable#canCall(data#0, grammar#0)
         || ($Is(data#0, TSeq(Tclass.NativeTypes.byte()))
           && $Is(grammar#0, Tclass.GenericMarshalling.G()))
       ==> true);

function GenericMarshalling.__default.Demarshallable#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for GenericMarshalling.__default.Demarshallable
axiom (forall data#0: Seq Box, grammar#0: DatatypeType :: 
  { GenericMarshalling.__default.Demarshallable#requires(data#0, grammar#0) } 
  $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       && $Is(grammar#0, Tclass.GenericMarshalling.G())
     ==> GenericMarshalling.__default.Demarshallable#requires(data#0, grammar#0) == true);

procedure {:_induction s#0, v#0} CheckWellformed$$GenericMarshalling.__default.lemma__SeqSum__prefix(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(s#0, TSeq(Tclass.GenericMarshalling.V()), $Heap), 
    v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap)
         && $IsA#GenericMarshalling.V(v#0));
  free requires 38 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction s#0, v#0} Call$$GenericMarshalling.__default.lemma__SeqSum__prefix(s#0: Seq Box
       where $Is(s#0, TSeq(Tclass.GenericMarshalling.V()))
         && $IsAlloc(s#0, TSeq(Tclass.GenericMarshalling.V()), $Heap), 
    v#0: DatatypeType
       where $Is(v#0, Tclass.GenericMarshalling.V())
         && $IsAlloc(v#0, Tclass.GenericMarshalling.V(), $Heap)
         && $IsA#GenericMarshalling.V(v#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures GenericMarshalling.__default.SeqSum#canCall(Seq#Append(s#0, Seq#Build(Seq#Empty(): Seq Box, $Box(v#0))))
     && 
    GenericMarshalling.__default.SeqSum#canCall(s#0)
     && GenericMarshalling.__default.SizeOfV#canCall(v#0);
  ensures GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, 
      Seq#Append(s#0, Seq#Build(Seq#Empty(): Seq Box, $Box(v#0))))
     == GenericMarshalling.__default.SeqSum(StartFuelAssert_GenericMarshalling._default.SeqSum, s#0)
       + GenericMarshalling.__default.SizeOfV(StartFuelAssert_GenericMarshalling._default.SizeOfV, v#0);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$GenericMarshalling.__default.reveal__SeqSum();
  free requires 49 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_GenericMarshalling._default.SeqSum0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$GenericMarshalling.__default.reveal__SeqSum();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_GenericMarshalling._default.SeqSum
     == $LS(MoreFuel_GenericMarshalling._default.SeqSum0);
  free ensures StartFuelAssert_GenericMarshalling._default.SeqSum
     == $LS($LS(MoreFuel_GenericMarshalling._default.SeqSum0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_GenericMarshalling._default.SeqSum0)
     == MoreFuel_GenericMarshalling._default.SeqSum0;



const unique class.MathAxioms.__default: ClassName;

function Tclass.MathAxioms.__default() : Ty;

// Tclass.MathAxioms.__default Tag
axiom Tag(Tclass.MathAxioms.__default()) == Tagclass.MathAxioms.__default;

const unique Tagclass.MathAxioms.__default: TyTag;

// Box/unbox axiom for Tclass.MathAxioms.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.MathAxioms.__default()) } 
  $IsBox(bx, Tclass.MathAxioms.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.MathAxioms.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.MathAxioms.__default()) } 
  $Is($o, Tclass.MathAxioms.__default())
     <==> $o == null || dtype($o) == Tclass.MathAxioms.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.MathAxioms.__default(), $h) } 
  $IsAlloc($o, Tclass.MathAxioms.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique class.BitsetLemmas.__default: ClassName;

function Tclass.BitsetLemmas.__default() : Ty;

// Tclass.BitsetLemmas.__default Tag
axiom Tag(Tclass.BitsetLemmas.__default()) == Tagclass.BitsetLemmas.__default;

const unique Tagclass.BitsetLemmas.__default: TyTag;

// Box/unbox axiom for Tclass.BitsetLemmas.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BitsetLemmas.__default()) } 
  $IsBox(bx, Tclass.BitsetLemmas.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BitsetLemmas.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BitsetLemmas.__default()) } 
  $Is($o, Tclass.BitsetLemmas.__default())
     <==> $o == null || dtype($o) == Tclass.BitsetLemmas.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BitsetLemmas.__default(), $h) } 
  $IsAlloc($o, Tclass.BitsetLemmas.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BitsetLemmas._default.bit
function BitsetLemmas.__default.bit($ly: LayerType, i#0: int) : bv64;

function BitsetLemmas.__default.bit#canCall(i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, i#0: int :: 
  { BitsetLemmas.__default.bit($LS($ly), i#0) } 
  BitsetLemmas.__default.bit($LS($ly), i#0)
     == BitsetLemmas.__default.bit($ly, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, i#0: int :: 
  { BitsetLemmas.__default.bit(AsFuelBottom($ly), i#0) } 
  BitsetLemmas.__default.bit($ly, i#0) == BitsetLemmas.__default.bit($LZ, i#0));

// consequence axiom for BitsetLemmas.__default.bit
axiom true
   ==> (forall $ly: LayerType, i#0: int :: 
    { BitsetLemmas.__default.bit($ly, i#0) } 
    BitsetLemmas.__default.bit#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> true);

function BitsetLemmas.__default.bit#requires(LayerType, int) : bool;

// #requires axiom for BitsetLemmas.__default.bit
axiom (forall $ly: LayerType, i#0: int :: 
  { BitsetLemmas.__default.bit#requires($ly, i#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> BitsetLemmas.__default.bit#requires($ly, i#0) == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.bit(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int :: 
    { BitsetLemmas.__default.bit($LS($ly), i#0) } 
    BitsetLemmas.__default.bit#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> BitsetLemmas.__default.bit($LS($ly), i#0)
         == LeftShift_bv64(1bv64, nat_to_bv64(i#0)));

// definition axiom for BitsetLemmas.__default.bit for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int :: 
    {:weight 3} { BitsetLemmas.__default.bit($LS($ly), LitInt(i#0)) } 
    BitsetLemmas.__default.bit#canCall(LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.bit($LS($ly), LitInt(i#0))
         == LeftShift_bv64(1bv64, nat_to_bv64(i#0)));

// function declaration for BitsetLemmas._default.bit_and
function BitsetLemmas.__default.bit__and($ly: LayerType, a#0: bv64, b#0: bv64) : bv64;

function BitsetLemmas.__default.bit__and#canCall(a#0: bv64, b#0: bv64) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
  { BitsetLemmas.__default.bit__and($LS($ly), a#0, b#0) } 
  BitsetLemmas.__default.bit__and($LS($ly), a#0, b#0)
     == BitsetLemmas.__default.bit__and($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
  { BitsetLemmas.__default.bit__and(AsFuelBottom($ly), a#0, b#0) } 
  BitsetLemmas.__default.bit__and($ly, a#0, b#0)
     == BitsetLemmas.__default.bit__and($LZ, a#0, b#0));

// consequence axiom for BitsetLemmas.__default.bit__and
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
    { BitsetLemmas.__default.bit__and($ly, a#0, b#0) } 
    true ==> true);

function BitsetLemmas.__default.bit__and#requires(LayerType, bv64, bv64) : bool;

// #requires axiom for BitsetLemmas.__default.bit__and
axiom (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
  { BitsetLemmas.__default.bit__and#requires($ly, a#0, b#0) } 
  BitsetLemmas.__default.bit__and#requires($ly, a#0, b#0) == true);

// definition axiom for BitsetLemmas.__default.bit__and(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
    { BitsetLemmas.__default.bit__and($LS($ly), a#0, b#0) } 
    true
       ==> BitsetLemmas.__default.bit__and($LS($ly), a#0, b#0) == and_bv64(a#0, b#0));

// definition axiom for BitsetLemmas.__default.bit__and for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
    {:weight 3} { BitsetLemmas.__default.bit__and($LS($ly), Lit(a#0), Lit(b#0)) } 
    true
       ==> BitsetLemmas.__default.bit__and($LS($ly), Lit(a#0), Lit(b#0))
         == Lit(and_bv64(a#0, b#0)));

// function declaration for BitsetLemmas._default.bit_or
function BitsetLemmas.__default.bit__or($ly: LayerType, a#0: bv64, b#0: bv64) : bv64;

function BitsetLemmas.__default.bit__or#canCall(a#0: bv64, b#0: bv64) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
  { BitsetLemmas.__default.bit__or($LS($ly), a#0, b#0) } 
  BitsetLemmas.__default.bit__or($LS($ly), a#0, b#0)
     == BitsetLemmas.__default.bit__or($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
  { BitsetLemmas.__default.bit__or(AsFuelBottom($ly), a#0, b#0) } 
  BitsetLemmas.__default.bit__or($ly, a#0, b#0)
     == BitsetLemmas.__default.bit__or($LZ, a#0, b#0));

// consequence axiom for BitsetLemmas.__default.bit__or
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
    { BitsetLemmas.__default.bit__or($ly, a#0, b#0) } 
    true ==> true);

function BitsetLemmas.__default.bit__or#requires(LayerType, bv64, bv64) : bool;

// #requires axiom for BitsetLemmas.__default.bit__or
axiom (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
  { BitsetLemmas.__default.bit__or#requires($ly, a#0, b#0) } 
  BitsetLemmas.__default.bit__or#requires($ly, a#0, b#0) == true);

// definition axiom for BitsetLemmas.__default.bit__or(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
    { BitsetLemmas.__default.bit__or($LS($ly), a#0, b#0) } 
    true ==> BitsetLemmas.__default.bit__or($LS($ly), a#0, b#0) == or_bv64(a#0, b#0));

// definition axiom for BitsetLemmas.__default.bit__or for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, b#0: bv64 :: 
    {:weight 3} { BitsetLemmas.__default.bit__or($LS($ly), Lit(a#0), Lit(b#0)) } 
    true
       ==> BitsetLemmas.__default.bit__or($LS($ly), Lit(a#0), Lit(b#0))
         == Lit(or_bv64(a#0, b#0)));

// function declaration for BitsetLemmas._default.bit_comp
function BitsetLemmas.__default.bit__comp($ly: LayerType, a#0: bv64) : bv64;

function BitsetLemmas.__default.bit__comp#canCall(a#0: bv64) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: bv64 :: 
  { BitsetLemmas.__default.bit__comp($LS($ly), a#0) } 
  BitsetLemmas.__default.bit__comp($LS($ly), a#0)
     == BitsetLemmas.__default.bit__comp($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: bv64 :: 
  { BitsetLemmas.__default.bit__comp(AsFuelBottom($ly), a#0) } 
  BitsetLemmas.__default.bit__comp($ly, a#0)
     == BitsetLemmas.__default.bit__comp($LZ, a#0));

// consequence axiom for BitsetLemmas.__default.bit__comp
axiom true
   ==> (forall $ly: LayerType, a#0: bv64 :: 
    { BitsetLemmas.__default.bit__comp($ly, a#0) } 
    true ==> true);

function BitsetLemmas.__default.bit__comp#requires(LayerType, bv64) : bool;

// #requires axiom for BitsetLemmas.__default.bit__comp
axiom (forall $ly: LayerType, a#0: bv64 :: 
  { BitsetLemmas.__default.bit__comp#requires($ly, a#0) } 
  BitsetLemmas.__default.bit__comp#requires($ly, a#0) == true);

// definition axiom for BitsetLemmas.__default.bit__comp(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64 :: 
    { BitsetLemmas.__default.bit__comp($LS($ly), a#0) } 
    true
       ==> BitsetLemmas.__default.bit__comp($LS($ly), a#0)
         == xor_bv64(18446744073709551615bv64, a#0));

// definition axiom for BitsetLemmas.__default.bit__comp for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64 :: 
    {:weight 3} { BitsetLemmas.__default.bit__comp($LS($ly), Lit(a#0)) } 
    true
       ==> BitsetLemmas.__default.bit__comp($LS($ly), Lit(a#0))
         == Lit(xor_bv64(18446744073709551615bv64, a#0)));

// function declaration for BitsetLemmas._default.in_set
function BitsetLemmas.__default.in__set($ly: LayerType, i#0: int, a#0: bv64) : bool;

function BitsetLemmas.__default.in__set#canCall(i#0: int, a#0: bv64) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, i#0: int, a#0: bv64 :: 
  { BitsetLemmas.__default.in__set($LS($ly), i#0, a#0) } 
  BitsetLemmas.__default.in__set($LS($ly), i#0, a#0)
     == BitsetLemmas.__default.in__set($ly, i#0, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, i#0: int, a#0: bv64 :: 
  { BitsetLemmas.__default.in__set(AsFuelBottom($ly), i#0, a#0) } 
  BitsetLemmas.__default.in__set($ly, i#0, a#0)
     == BitsetLemmas.__default.in__set($LZ, i#0, a#0));

// consequence axiom for BitsetLemmas.__default.in__set
axiom true
   ==> (forall $ly: LayerType, i#0: int, a#0: bv64 :: 
    { BitsetLemmas.__default.in__set($ly, i#0, a#0) } 
    BitsetLemmas.__default.in__set#canCall(i#0, a#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> true);

function BitsetLemmas.__default.in__set#requires(LayerType, int, bv64) : bool;

// #requires axiom for BitsetLemmas.__default.in__set
axiom (forall $ly: LayerType, i#0: int, a#0: bv64 :: 
  { BitsetLemmas.__default.in__set#requires($ly, i#0, a#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> BitsetLemmas.__default.in__set#requires($ly, i#0, a#0) == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.in__set(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int, a#0: bv64 :: 
    { BitsetLemmas.__default.in__set($LS($ly), i#0, a#0) } 
    BitsetLemmas.__default.in__set#canCall(i#0, a#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> BitsetLemmas.__default.bit#canCall(i#0)
         && BitsetLemmas.__default.bit__and#canCall(a#0, BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0))
         && BitsetLemmas.__default.in__set($LS($ly), i#0, a#0)
           == (BitsetLemmas.__default.bit__and(StartFuel_BitsetLemmas._default.bit_and, 
              a#0, 
              BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0))
             != 0bv64));

// definition axiom for BitsetLemmas.__default.in__set for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int, a#0: bv64 :: 
    {:weight 3} { BitsetLemmas.__default.in__set($LS($ly), LitInt(i#0), Lit(a#0)) } 
    BitsetLemmas.__default.in__set#canCall(LitInt(i#0), Lit(a#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.bit#canCall(LitInt(i#0))
         && BitsetLemmas.__default.bit__and#canCall(Lit(a#0), 
          BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0)))
         && BitsetLemmas.__default.in__set($LS($ly), LitInt(i#0), Lit(a#0))
           == (BitsetLemmas.__default.bit__and(StartFuel_BitsetLemmas._default.bit_and, 
              Lit(a#0), 
              BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0)))
             != 0bv64));

// function declaration for BitsetLemmas._default.set_bit_to_1
function BitsetLemmas.__default.set__bit__to__1($ly: LayerType, a#0: bv64, i#0: int) : bv64;

function BitsetLemmas.__default.set__bit__to__1#canCall(a#0: bv64, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__1($LS($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__1($LS($ly), a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__1($ly, a#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__1(AsFuelBottom($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__1($ly, a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__1($LZ, a#0, i#0));

// consequence axiom for BitsetLemmas.__default.set__bit__to__1
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__1($ly, a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__1#canCall(a#0, i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> true);

function BitsetLemmas.__default.set__bit__to__1#requires(LayerType, bv64, int) : bool;

// #requires axiom for BitsetLemmas.__default.set__bit__to__1
axiom (forall $ly: LayerType, a#0: bv64, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__1#requires($ly, a#0, i#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> BitsetLemmas.__default.set__bit__to__1#requires($ly, a#0, i#0) == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.set__bit__to__1(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__1($LS($ly), a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__1#canCall(a#0, i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> BitsetLemmas.__default.bit#canCall(i#0)
         && BitsetLemmas.__default.bit__or#canCall(a#0, BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0))
         && BitsetLemmas.__default.set__bit__to__1($LS($ly), a#0, i#0)
           == BitsetLemmas.__default.bit__or(StartFuel_BitsetLemmas._default.bit_or, 
            a#0, 
            BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0)));

// definition axiom for BitsetLemmas.__default.set__bit__to__1 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, i#0: int :: 
    {:weight 3} { BitsetLemmas.__default.set__bit__to__1($LS($ly), Lit(a#0), LitInt(i#0)) } 
    BitsetLemmas.__default.set__bit__to__1#canCall(Lit(a#0), LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.bit#canCall(LitInt(i#0))
         && BitsetLemmas.__default.bit__or#canCall(Lit(a#0), 
          BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0)))
         && BitsetLemmas.__default.set__bit__to__1($LS($ly), Lit(a#0), LitInt(i#0))
           == BitsetLemmas.__default.bit__or(StartFuel_BitsetLemmas._default.bit_or, 
            Lit(a#0), 
            BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0))));

// function declaration for BitsetLemmas._default.set_bit_to_0
function BitsetLemmas.__default.set__bit__to__0($ly: LayerType, a#0: bv64, i#0: int) : bv64;

function BitsetLemmas.__default.set__bit__to__0#canCall(a#0: bv64, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__0($LS($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__0($LS($ly), a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__0($ly, a#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: bv64, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__0(AsFuelBottom($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__0($ly, a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__0($LZ, a#0, i#0));

// consequence axiom for BitsetLemmas.__default.set__bit__to__0
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__0($ly, a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__0#canCall(a#0, i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> true);

function BitsetLemmas.__default.set__bit__to__0#requires(LayerType, bv64, int) : bool;

// #requires axiom for BitsetLemmas.__default.set__bit__to__0
axiom (forall $ly: LayerType, a#0: bv64, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__0#requires($ly, a#0, i#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> BitsetLemmas.__default.set__bit__to__0#requires($ly, a#0, i#0) == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.set__bit__to__0(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__0($LS($ly), a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__0#canCall(a#0, i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && i#0 < 64)
       ==> BitsetLemmas.__default.bit#canCall(i#0)
         && BitsetLemmas.__default.bit__comp#canCall(BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0))
         && BitsetLemmas.__default.bit__and#canCall(a#0, 
          BitsetLemmas.__default.bit__comp(StartFuel_BitsetLemmas._default.bit_comp, 
            BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0)))
         && BitsetLemmas.__default.set__bit__to__0($LS($ly), a#0, i#0)
           == BitsetLemmas.__default.bit__and(StartFuel_BitsetLemmas._default.bit_and, 
            a#0, 
            BitsetLemmas.__default.bit__comp(StartFuel_BitsetLemmas._default.bit_comp, 
              BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, i#0))));

// definition axiom for BitsetLemmas.__default.set__bit__to__0 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: bv64, i#0: int :: 
    {:weight 3} { BitsetLemmas.__default.set__bit__to__0($LS($ly), Lit(a#0), LitInt(i#0)) } 
    BitsetLemmas.__default.set__bit__to__0#canCall(Lit(a#0), LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616 && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.bit#canCall(LitInt(i#0))
         && BitsetLemmas.__default.bit__comp#canCall(BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0)))
         && BitsetLemmas.__default.bit__and#canCall(Lit(a#0), 
          BitsetLemmas.__default.bit__comp(StartFuel_BitsetLemmas._default.bit_comp, 
            BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0))))
         && BitsetLemmas.__default.set__bit__to__0($LS($ly), Lit(a#0), LitInt(i#0))
           == BitsetLemmas.__default.bit__and(StartFuel_BitsetLemmas._default.bit_and, 
            Lit(a#0), 
            BitsetLemmas.__default.bit__comp(StartFuel_BitsetLemmas._default.bit_comp, 
              BitsetLemmas.__default.bit(StartFuel_BitsetLemmas._default.bit, LitInt(i#0)))));

// function declaration for BitsetLemmas._default.bit_or_uint64
function BitsetLemmas.__default.bit__or__uint64($ly: LayerType, a#0: int, b#0: int) : int;

function BitsetLemmas.__default.bit__or__uint64#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { BitsetLemmas.__default.bit__or__uint64($LS($ly), a#0, b#0) } 
  BitsetLemmas.__default.bit__or__uint64($LS($ly), a#0, b#0)
     == BitsetLemmas.__default.bit__or__uint64($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { BitsetLemmas.__default.bit__or__uint64(AsFuelBottom($ly), a#0, b#0) } 
  BitsetLemmas.__default.bit__or__uint64($ly, a#0, b#0)
     == BitsetLemmas.__default.bit__or__uint64($LZ, a#0, b#0));

// consequence axiom for BitsetLemmas.__default.bit__or__uint64
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { BitsetLemmas.__default.bit__or__uint64($ly, a#0, b#0) } 
    BitsetLemmas.__default.bit__or__uint64#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> LitInt(0) <= BitsetLemmas.__default.bit__or__uint64($ly, a#0, b#0)
         && BitsetLemmas.__default.bit__or__uint64($ly, a#0, b#0) < 18446744073709551616);

function BitsetLemmas.__default.bit__or__uint64#requires(LayerType, int, int) : bool;

// #requires axiom for BitsetLemmas.__default.bit__or__uint64
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { BitsetLemmas.__default.bit__or__uint64#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> BitsetLemmas.__default.bit__or__uint64#requires($ly, a#0, b#0) == true);

// definition axiom for BitsetLemmas.__default.bit__or__uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { BitsetLemmas.__default.bit__or__uint64($LS($ly), a#0, b#0) } 
    BitsetLemmas.__default.bit__or__uint64#canCall(a#0, b#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> BitsetLemmas.__default.bit__or#canCall(nat_to_bv64(a#0), nat_to_bv64(b#0))
         && BitsetLemmas.__default.bit__or__uint64($LS($ly), a#0, b#0)
           == nat_from_bv64(BitsetLemmas.__default.bit__or(StartFuel_BitsetLemmas._default.bit_or, nat_to_bv64(a#0), nat_to_bv64(b#0))));

// definition axiom for BitsetLemmas.__default.bit__or__uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { BitsetLemmas.__default.bit__or__uint64($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    BitsetLemmas.__default.bit__or__uint64#canCall(LitInt(a#0), LitInt(b#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616)
       ==> BitsetLemmas.__default.bit__or#canCall(nat_to_bv64(LitInt(a#0)), nat_to_bv64(LitInt(b#0)))
         && BitsetLemmas.__default.bit__or__uint64($LS($ly), LitInt(a#0), LitInt(b#0))
           == nat_from_bv64(BitsetLemmas.__default.bit__or(StartFuel_BitsetLemmas._default.bit_or, 
              nat_to_bv64(LitInt(a#0)), 
              nat_to_bv64(LitInt(b#0)))));

// function declaration for BitsetLemmas._default.in_set_uint64
function BitsetLemmas.__default.in__set__uint64($ly: LayerType, i#0: int, a#0: int) : bool;

function BitsetLemmas.__default.in__set__uint64#canCall(i#0: int, a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, i#0: int, a#0: int :: 
  { BitsetLemmas.__default.in__set__uint64($LS($ly), i#0, a#0) } 
  BitsetLemmas.__default.in__set__uint64($LS($ly), i#0, a#0)
     == BitsetLemmas.__default.in__set__uint64($ly, i#0, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, i#0: int, a#0: int :: 
  { BitsetLemmas.__default.in__set__uint64(AsFuelBottom($ly), i#0, a#0) } 
  BitsetLemmas.__default.in__set__uint64($ly, i#0, a#0)
     == BitsetLemmas.__default.in__set__uint64($LZ, i#0, a#0));

// consequence axiom for BitsetLemmas.__default.in__set__uint64
axiom true
   ==> (forall $ly: LayerType, i#0: int, a#0: int :: 
    { BitsetLemmas.__default.in__set__uint64($ly, i#0, a#0) } 
    BitsetLemmas.__default.in__set__uint64#canCall(i#0, a#0)
         || (
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && i#0 < 64)
       ==> true);

function BitsetLemmas.__default.in__set__uint64#requires(LayerType, int, int) : bool;

// #requires axiom for BitsetLemmas.__default.in__set__uint64
axiom (forall $ly: LayerType, i#0: int, a#0: int :: 
  { BitsetLemmas.__default.in__set__uint64#requires($ly, i#0, a#0) } 
  LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && 
      LitInt(0) <= a#0
       && a#0 < 18446744073709551616
     ==> BitsetLemmas.__default.in__set__uint64#requires($ly, i#0, a#0) == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.in__set__uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int, a#0: int :: 
    { BitsetLemmas.__default.in__set__uint64($LS($ly), i#0, a#0) } 
    BitsetLemmas.__default.in__set__uint64#canCall(i#0, a#0)
         || (
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && i#0 < 64)
       ==> BitsetLemmas.__default.in__set#canCall(i#0, nat_to_bv64(a#0))
         && BitsetLemmas.__default.in__set__uint64($LS($ly), i#0, a#0)
           == BitsetLemmas.__default.in__set(StartFuel_BitsetLemmas._default.in_set, i#0, nat_to_bv64(a#0)));

// definition axiom for BitsetLemmas.__default.in__set__uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, i#0: int, a#0: int :: 
    {:weight 3} { BitsetLemmas.__default.in__set__uint64($LS($ly), LitInt(i#0), LitInt(a#0)) } 
    BitsetLemmas.__default.in__set__uint64#canCall(LitInt(i#0), LitInt(a#0))
         || (
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.in__set#canCall(LitInt(i#0), nat_to_bv64(LitInt(a#0)))
         && BitsetLemmas.__default.in__set__uint64($LS($ly), LitInt(i#0), LitInt(a#0))
           == BitsetLemmas.__default.in__set(StartFuel_BitsetLemmas._default.in_set, LitInt(i#0), nat_to_bv64(LitInt(a#0))));

// function declaration for BitsetLemmas._default.set_bit_to_1_uint64
function BitsetLemmas.__default.set__bit__to__1__uint64($ly: LayerType, a#0: int, i#0: int) : int;

function BitsetLemmas.__default.set__bit__to__1__uint64#canCall(a#0: int, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__1__uint64($LS($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__1__uint64($LS($ly), a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__1__uint64($ly, a#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__1__uint64(AsFuelBottom($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__1__uint64($ly, a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__1__uint64($LZ, a#0, i#0));

// consequence axiom for BitsetLemmas.__default.set__bit__to__1__uint64
axiom true
   ==> (forall $ly: LayerType, a#0: int, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__1__uint64($ly, a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__1__uint64#canCall(a#0, i#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && i#0 < 64)
       ==> LitInt(0) <= BitsetLemmas.__default.set__bit__to__1__uint64($ly, a#0, i#0)
         && BitsetLemmas.__default.set__bit__to__1__uint64($ly, a#0, i#0)
           < 18446744073709551616);

function BitsetLemmas.__default.set__bit__to__1__uint64#requires(LayerType, int, int) : bool;

// #requires axiom for BitsetLemmas.__default.set__bit__to__1__uint64
axiom (forall $ly: LayerType, a#0: int, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__1__uint64#requires($ly, a#0, i#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> BitsetLemmas.__default.set__bit__to__1__uint64#requires($ly, a#0, i#0)
       == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.set__bit__to__1__uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__1__uint64($LS($ly), a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__1__uint64#canCall(a#0, i#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && i#0 < 64)
       ==> BitsetLemmas.__default.set__bit__to__1#canCall(nat_to_bv64(a#0), i#0)
         && BitsetLemmas.__default.set__bit__to__1__uint64($LS($ly), a#0, i#0)
           == nat_from_bv64(BitsetLemmas.__default.set__bit__to__1(StartFuel_BitsetLemmas._default.set_bit_to_1, nat_to_bv64(a#0), i#0)));

// definition axiom for BitsetLemmas.__default.set__bit__to__1__uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, i#0: int :: 
    {:weight 3} { BitsetLemmas.__default.set__bit__to__1__uint64($LS($ly), LitInt(a#0), LitInt(i#0)) } 
    BitsetLemmas.__default.set__bit__to__1__uint64#canCall(LitInt(a#0), LitInt(i#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.set__bit__to__1#canCall(nat_to_bv64(LitInt(a#0)), LitInt(i#0))
         && BitsetLemmas.__default.set__bit__to__1__uint64($LS($ly), LitInt(a#0), LitInt(i#0))
           == nat_from_bv64(BitsetLemmas.__default.set__bit__to__1(StartFuel_BitsetLemmas._default.set_bit_to_1, 
              nat_to_bv64(LitInt(a#0)), 
              LitInt(i#0))));

// function declaration for BitsetLemmas._default.set_bit_to_0_uint64
function BitsetLemmas.__default.set__bit__to__0__uint64($ly: LayerType, a#0: int, i#0: int) : int;

function BitsetLemmas.__default.set__bit__to__0__uint64#canCall(a#0: int, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__0__uint64($LS($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__0__uint64($LS($ly), a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__0__uint64($ly, a#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__0__uint64(AsFuelBottom($ly), a#0, i#0) } 
  BitsetLemmas.__default.set__bit__to__0__uint64($ly, a#0, i#0)
     == BitsetLemmas.__default.set__bit__to__0__uint64($LZ, a#0, i#0));

// consequence axiom for BitsetLemmas.__default.set__bit__to__0__uint64
axiom true
   ==> (forall $ly: LayerType, a#0: int, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__0__uint64($ly, a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__0__uint64#canCall(a#0, i#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && i#0 < 64)
       ==> LitInt(0) <= BitsetLemmas.__default.set__bit__to__0__uint64($ly, a#0, i#0)
         && BitsetLemmas.__default.set__bit__to__0__uint64($ly, a#0, i#0)
           < 18446744073709551616);

function BitsetLemmas.__default.set__bit__to__0__uint64#requires(LayerType, int, int) : bool;

// #requires axiom for BitsetLemmas.__default.set__bit__to__0__uint64
axiom (forall $ly: LayerType, a#0: int, i#0: int :: 
  { BitsetLemmas.__default.set__bit__to__0__uint64#requires($ly, a#0, i#0) } 
  LitInt(0) <= a#0
       && a#0 < 18446744073709551616
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> BitsetLemmas.__default.set__bit__to__0__uint64#requires($ly, a#0, i#0)
       == (i#0 < 64));

// definition axiom for BitsetLemmas.__default.set__bit__to__0__uint64(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, i#0: int :: 
    { BitsetLemmas.__default.set__bit__to__0__uint64($LS($ly), a#0, i#0) } 
    BitsetLemmas.__default.set__bit__to__0__uint64#canCall(a#0, i#0)
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && i#0 < 64)
       ==> BitsetLemmas.__default.set__bit__to__0#canCall(nat_to_bv64(a#0), i#0)
         && BitsetLemmas.__default.set__bit__to__0__uint64($LS($ly), a#0, i#0)
           == nat_from_bv64(BitsetLemmas.__default.set__bit__to__0(StartFuel_BitsetLemmas._default.set_bit_to_0, nat_to_bv64(a#0), i#0)));

// definition axiom for BitsetLemmas.__default.set__bit__to__0__uint64 for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, i#0: int :: 
    {:weight 3} { BitsetLemmas.__default.set__bit__to__0__uint64($LS($ly), LitInt(a#0), LitInt(i#0)) } 
    BitsetLemmas.__default.set__bit__to__0__uint64#canCall(LitInt(a#0), LitInt(i#0))
         || (
          LitInt(0) <= a#0
           && a#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && Lit(i#0 < 64))
       ==> BitsetLemmas.__default.set__bit__to__0#canCall(nat_to_bv64(LitInt(a#0)), LitInt(i#0))
         && BitsetLemmas.__default.set__bit__to__0__uint64($LS($ly), LitInt(a#0), LitInt(i#0))
           == nat_from_bv64(BitsetLemmas.__default.set__bit__to__0(StartFuel_BitsetLemmas._default.set_bit_to_0, 
              nat_to_bv64(LitInt(a#0)), 
              LitInt(i#0))));

const unique class.BitmapModel.__default: ClassName;

function Tclass.BitmapModel.__default() : Ty;

// Tclass.BitmapModel.__default Tag
axiom Tag(Tclass.BitmapModel.__default()) == Tagclass.BitmapModel.__default;

const unique Tagclass.BitmapModel.__default: TyTag;

// Box/unbox axiom for Tclass.BitmapModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BitmapModel.__default()) } 
  $IsBox(bx, Tclass.BitmapModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BitmapModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BitmapModel.__default()) } 
  $Is($o, Tclass.BitmapModel.__default())
     <==> $o == null || dtype($o) == Tclass.BitmapModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BitmapModel.__default(), $h) } 
  $IsAlloc($o, Tclass.BitmapModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for BitmapModel._default.Len
function BitmapModel.__default.Len(bm#0: Seq Box) : int;

function BitmapModel.__default.Len#canCall(bm#0: Seq Box) : bool;

// consequence axiom for BitmapModel.__default.Len
axiom true
   ==> (forall bm#0: Seq Box :: 
    { BitmapModel.__default.Len(bm#0) } 
    BitmapModel.__default.Len#canCall(bm#0) || $Is(bm#0, TSeq(TBool)) ==> true);

function BitmapModel.__default.Len#requires(Seq Box) : bool;

// #requires axiom for BitmapModel.__default.Len
axiom (forall bm#0: Seq Box :: 
  { BitmapModel.__default.Len#requires(bm#0) } 
  $Is(bm#0, TSeq(TBool)) ==> BitmapModel.__default.Len#requires(bm#0) == true);

// definition axiom for BitmapModel.__default.Len(revealed)
axiom true
   ==> (forall bm#0: Seq Box :: 
    { BitmapModel.__default.Len(bm#0) } 
    BitmapModel.__default.Len#canCall(bm#0) || $Is(bm#0, TSeq(TBool))
       ==> BitmapModel.__default.Len(bm#0) == Seq#Length(bm#0));

// definition axiom for BitmapModel.__default.Len for all literals(revealed)
axiom true
   ==> (forall bm#0: Seq Box :: 
    {:weight 3} { BitmapModel.__default.Len(Lit(bm#0)) } 
    BitmapModel.__default.Len#canCall(Lit(bm#0)) || $Is(bm#0, TSeq(TBool))
       ==> BitmapModel.__default.Len(Lit(bm#0)) == Seq#Length(Lit(bm#0)));

// function declaration for BitmapModel._default.BitSet
function BitmapModel.__default.BitSet($ly: LayerType, bm#0: Seq Box, i#0: int) : Seq Box;

function BitmapModel.__default.BitSet#canCall(bm#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitSet($LS($ly), bm#0, i#0) } 
  BitmapModel.__default.BitSet($LS($ly), bm#0, i#0)
     == BitmapModel.__default.BitSet($ly, bm#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitSet(AsFuelBottom($ly), bm#0, i#0) } 
  BitmapModel.__default.BitSet($ly, bm#0, i#0)
     == BitmapModel.__default.BitSet($LZ, bm#0, i#0));

// consequence axiom for BitmapModel.__default.BitSet
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.BitSet($ly, bm#0, i#0) } 
    BitmapModel.__default.BitSet#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.Len(BitmapModel.__default.BitSet($ly, bm#0, i#0))
           == BitmapModel.__default.Len(bm#0)
         && $Is(BitmapModel.__default.BitSet($ly, bm#0, i#0), TSeq(TBool)));

function BitmapModel.__default.BitSet#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BitmapModel.__default.BitSet
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitSet#requires($ly, bm#0, i#0) } 
  $Is(bm#0, TSeq(TBool))
     ==> BitmapModel.__default.BitSet#requires($ly, bm#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < BitmapModel.__default.Len(bm#0)));

// definition axiom for BitmapModel.__default.BitSet(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.BitSet($LS($ly), bm#0, i#0) } 
    BitmapModel.__default.BitSet#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.BitSet($LS($ly), bm#0, i#0)
         == Seq#Update(bm#0, i#0, $Box(Lit(true))));

// definition axiom for BitmapModel.__default.BitSet for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    {:weight 3} { BitmapModel.__default.BitSet($LS($ly), Lit(bm#0), LitInt(i#0)) } 
    BitmapModel.__default.BitSet#canCall(Lit(bm#0), LitInt(i#0))
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < BitmapModel.__default.Len(Lit(bm#0)))
       ==> BitmapModel.__default.BitSet($LS($ly), Lit(bm#0), LitInt(i#0))
         == Seq#Update(Lit(bm#0), LitInt(i#0), $Box(Lit(true))));

// function declaration for BitmapModel._default.BitUnset
function BitmapModel.__default.BitUnset($ly: LayerType, bm#0: Seq Box, i#0: int) : Seq Box;

function BitmapModel.__default.BitUnset#canCall(bm#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitUnset($LS($ly), bm#0, i#0) } 
  BitmapModel.__default.BitUnset($LS($ly), bm#0, i#0)
     == BitmapModel.__default.BitUnset($ly, bm#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitUnset(AsFuelBottom($ly), bm#0, i#0) } 
  BitmapModel.__default.BitUnset($ly, bm#0, i#0)
     == BitmapModel.__default.BitUnset($LZ, bm#0, i#0));

// consequence axiom for BitmapModel.__default.BitUnset
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.BitUnset($ly, bm#0, i#0) } 
    BitmapModel.__default.BitUnset#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.Len(BitmapModel.__default.BitUnset($ly, bm#0, i#0))
           == BitmapModel.__default.Len(bm#0)
         && $Is(BitmapModel.__default.BitUnset($ly, bm#0, i#0), TSeq(TBool)));

function BitmapModel.__default.BitUnset#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BitmapModel.__default.BitUnset
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitUnset#requires($ly, bm#0, i#0) } 
  $Is(bm#0, TSeq(TBool))
     ==> BitmapModel.__default.BitUnset#requires($ly, bm#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < BitmapModel.__default.Len(bm#0)));

// definition axiom for BitmapModel.__default.BitUnset(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.BitUnset($LS($ly), bm#0, i#0) } 
    BitmapModel.__default.BitUnset#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.BitUnset($LS($ly), bm#0, i#0)
         == Seq#Update(bm#0, i#0, $Box(Lit(false))));

// definition axiom for BitmapModel.__default.BitUnset for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    {:weight 3} { BitmapModel.__default.BitUnset($LS($ly), Lit(bm#0), LitInt(i#0)) } 
    BitmapModel.__default.BitUnset#canCall(Lit(bm#0), LitInt(i#0))
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < BitmapModel.__default.Len(Lit(bm#0)))
       ==> BitmapModel.__default.BitUnset($LS($ly), Lit(bm#0), LitInt(i#0))
         == Seq#Update(Lit(bm#0), LitInt(i#0), $Box(Lit(false))));

// function declaration for BitmapModel._default.IsSet
function BitmapModel.__default.IsSet($ly: LayerType, bm#0: Seq Box, i#0: int) : bool;

function BitmapModel.__default.IsSet#canCall(bm#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.IsSet($LS($ly), bm#0, i#0) } 
  BitmapModel.__default.IsSet($LS($ly), bm#0, i#0)
     == BitmapModel.__default.IsSet($ly, bm#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.IsSet(AsFuelBottom($ly), bm#0, i#0) } 
  BitmapModel.__default.IsSet($ly, bm#0, i#0)
     == BitmapModel.__default.IsSet($LZ, bm#0, i#0));

// consequence axiom for BitmapModel.__default.IsSet
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.IsSet($ly, bm#0, i#0) } 
    BitmapModel.__default.IsSet#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < BitmapModel.__default.Len(bm#0))
       ==> true);

function BitmapModel.__default.IsSet#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BitmapModel.__default.IsSet
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.IsSet#requires($ly, bm#0, i#0) } 
  $Is(bm#0, TSeq(TBool))
     ==> BitmapModel.__default.IsSet#requires($ly, bm#0, i#0)
       == (LitInt(0) <= i#0 && i#0 < BitmapModel.__default.Len(bm#0)));

// definition axiom for BitmapModel.__default.IsSet(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.IsSet($LS($ly), bm#0, i#0) } 
    BitmapModel.__default.IsSet#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.IsSet($LS($ly), bm#0, i#0)
         == $Unbox(Seq#Index(bm#0, i#0)): bool);

// definition axiom for BitmapModel.__default.IsSet for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    {:weight 3} { BitmapModel.__default.IsSet($LS($ly), Lit(bm#0), LitInt(i#0)) } 
    BitmapModel.__default.IsSet#canCall(Lit(bm#0), LitInt(i#0))
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < BitmapModel.__default.Len(Lit(bm#0)))
       ==> BitmapModel.__default.IsSet($LS($ly), Lit(bm#0), LitInt(i#0))
         == $Unbox(Seq#Index(Lit(bm#0), LitInt(i#0))): bool);

// function declaration for BitmapModel._default.EmptyBitmap
function BitmapModel.__default.EmptyBitmap($ly: LayerType, n#0: int) : Seq Box;

function BitmapModel.__default.EmptyBitmap#canCall(n#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { BitmapModel.__default.EmptyBitmap($LS($ly), n#0) } 
  BitmapModel.__default.EmptyBitmap($LS($ly), n#0)
     == BitmapModel.__default.EmptyBitmap($ly, n#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, n#0: int :: 
  { BitmapModel.__default.EmptyBitmap(AsFuelBottom($ly), n#0) } 
  BitmapModel.__default.EmptyBitmap($ly, n#0)
     == BitmapModel.__default.EmptyBitmap($LZ, n#0));

// consequence axiom for BitmapModel.__default.EmptyBitmap
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { BitmapModel.__default.EmptyBitmap($ly, n#0) } 
    BitmapModel.__default.EmptyBitmap#canCall(n#0) || n#0 >= LitInt(0)
       ==> BitmapModel.__default.Len(BitmapModel.__default.EmptyBitmap($ly, n#0)) == n#0
         && (forall i#0: int :: 
          { BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, 
              BitmapModel.__default.EmptyBitmap($ly, n#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0 < BitmapModel.__default.Len(BitmapModel.__default.EmptyBitmap($ly, n#0))
             ==> !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, 
              BitmapModel.__default.EmptyBitmap($ly, n#0), 
              i#0))
         && $Is(BitmapModel.__default.EmptyBitmap($ly, n#0), TSeq(TBool)));

function BitmapModel.__default.EmptyBitmap#requires(LayerType, int) : bool;

// #requires axiom for BitmapModel.__default.EmptyBitmap
axiom (forall $ly: LayerType, n#0: int :: 
  { BitmapModel.__default.EmptyBitmap#requires($ly, n#0) } 
  BitmapModel.__default.EmptyBitmap#requires($ly, n#0) == (n#0 >= LitInt(0)));

// definition axiom for BitmapModel.__default.EmptyBitmap(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    { BitmapModel.__default.EmptyBitmap($LS($ly), n#0) } 
    BitmapModel.__default.EmptyBitmap#canCall(n#0) || n#0 >= LitInt(0)
       ==> (n#0 != LitInt(0) ==> BitmapModel.__default.EmptyBitmap#canCall(n#0 - 1))
         && BitmapModel.__default.EmptyBitmap($LS($ly), n#0)
           == (if n#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else (var bm#0 := Seq#Append(BitmapModel.__default.EmptyBitmap($ly, n#0 - 1), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(false)))); 
              bm#0)));

// definition axiom for BitmapModel.__default.EmptyBitmap for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, n#0: int :: 
    {:weight 3} { BitmapModel.__default.EmptyBitmap($LS($ly), LitInt(n#0)) } 
    BitmapModel.__default.EmptyBitmap#canCall(LitInt(n#0))
         || LitInt(n#0) >= LitInt(0)
       ==> (LitInt(n#0) != LitInt(0)
           ==> BitmapModel.__default.EmptyBitmap#canCall(LitInt(n#0 - 1)))
         && BitmapModel.__default.EmptyBitmap($LS($ly), LitInt(n#0))
           == (if LitInt(n#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else (var bm#1 := Seq#Append(BitmapModel.__default.EmptyBitmap($LS($ly), LitInt(n#0 - 1)), 
                  Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(false)))); 
              bm#1)));

// function declaration for BitmapModel._default.BitAllocIter
function BitmapModel.__default.BitAllocIter($ly: LayerType, bm#0: Seq Box, i#0: int) : DatatypeType;

function BitmapModel.__default.BitAllocIter#canCall(bm#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitAllocIter($LS($ly), bm#0, i#0) } 
  BitmapModel.__default.BitAllocIter($LS($ly), bm#0, i#0)
     == BitmapModel.__default.BitAllocIter($ly, bm#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitAllocIter(AsFuelBottom($ly), bm#0, i#0) } 
  BitmapModel.__default.BitAllocIter($ly, bm#0, i#0)
     == BitmapModel.__default.BitAllocIter($LZ, bm#0, i#0));

// consequence axiom for BitmapModel.__default.BitAllocIter
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.BitAllocIter($ly, bm#0, i#0) } 
    BitmapModel.__default.BitAllocIter#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool)) && LitInt(0) <= i#0 && i#0 <= Seq#Length(bm#0))
       ==> (Options.Option.Some_q(BitmapModel.__default.BitAllocIter($ly, bm#0, i#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(BitmapModel.__default.BitAllocIter($ly, bm#0, i#0))): int
             && $Unbox(Options.Option.value(BitmapModel.__default.BitAllocIter($ly, bm#0, i#0))): int
               < Seq#Length(bm#0))
         && $Is(BitmapModel.__default.BitAllocIter($ly, bm#0, i#0), Tclass.Options.Option(TInt)));

function BitmapModel.__default.BitAllocIter#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BitmapModel.__default.BitAllocIter
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
  { BitmapModel.__default.BitAllocIter#requires($ly, bm#0, i#0) } 
  $Is(bm#0, TSeq(TBool))
     ==> BitmapModel.__default.BitAllocIter#requires($ly, bm#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Seq#Length(bm#0)));

// definition axiom for BitmapModel.__default.BitAllocIter(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    { BitmapModel.__default.BitAllocIter($LS($ly), bm#0, i#0) } 
    BitmapModel.__default.BitAllocIter#canCall(bm#0, i#0)
         || ($Is(bm#0, TSeq(TBool)) && LitInt(0) <= i#0 && i#0 <= Seq#Length(bm#0))
       ==> (i#0 != Seq#Length(bm#0)
           ==> 
          $Unbox(Seq#Index(bm#0, i#0)): bool
           ==> BitmapModel.__default.BitAllocIter#canCall(bm#0, i#0 + 1))
         && BitmapModel.__default.BitAllocIter($LS($ly), bm#0, i#0)
           == (if i#0 == Seq#Length(bm#0)
             then #Options.Option.None()
             else (if !$Unbox(Seq#Index(bm#0, i#0)): bool
               then #Options.Option.Some($Box(i#0))
               else BitmapModel.__default.BitAllocIter($ly, bm#0, i#0 + 1))));

// definition axiom for BitmapModel.__default.BitAllocIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int :: 
    {:weight 3} { BitmapModel.__default.BitAllocIter($LS($ly), Lit(bm#0), LitInt(i#0)) } 
    BitmapModel.__default.BitAllocIter#canCall(Lit(bm#0), LitInt(i#0))
         || ($Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(bm#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(bm#0))
           ==> 
          $Unbox(Seq#Index(Lit(bm#0), LitInt(i#0))): bool
           ==> BitmapModel.__default.BitAllocIter#canCall(Lit(bm#0), LitInt(i#0 + 1)))
         && BitmapModel.__default.BitAllocIter($LS($ly), Lit(bm#0), LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(bm#0))
             then #Options.Option.None()
             else (if !$Unbox(Seq#Index(Lit(bm#0), LitInt(i#0))): bool
               then #Options.Option.Some($Box(LitInt(i#0)))
               else BitmapModel.__default.BitAllocIter($LS($ly), Lit(bm#0), LitInt(i#0 + 1)))));

// function declaration for BitmapModel._default.BitAlloc
function BitmapModel.__default.BitAlloc($ly: LayerType, bm#0: Seq Box) : DatatypeType;

function BitmapModel.__default.BitAlloc#canCall(bm#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box :: 
  { BitmapModel.__default.BitAlloc($LS($ly), bm#0) } 
  BitmapModel.__default.BitAlloc($LS($ly), bm#0)
     == BitmapModel.__default.BitAlloc($ly, bm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box :: 
  { BitmapModel.__default.BitAlloc(AsFuelBottom($ly), bm#0) } 
  BitmapModel.__default.BitAlloc($ly, bm#0)
     == BitmapModel.__default.BitAlloc($LZ, bm#0));

// consequence axiom for BitmapModel.__default.BitAlloc
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box :: 
    { BitmapModel.__default.BitAlloc($ly, bm#0) } 
    BitmapModel.__default.BitAlloc#canCall(bm#0) || $Is(bm#0, TSeq(TBool))
       ==> (Options.Option.Some_q(BitmapModel.__default.BitAlloc($ly, bm#0))
           ==> LitInt(0)
               <= $Unbox(Options.Option.value(BitmapModel.__default.BitAlloc($ly, bm#0))): int
             && $Unbox(Options.Option.value(BitmapModel.__default.BitAlloc($ly, bm#0))): int
               < BitmapModel.__default.Len(bm#0))
         && $Is(BitmapModel.__default.BitAlloc($ly, bm#0), Tclass.Options.Option(TInt)));

function BitmapModel.__default.BitAlloc#requires(LayerType, Seq Box) : bool;

// #requires axiom for BitmapModel.__default.BitAlloc
axiom (forall $ly: LayerType, bm#0: Seq Box :: 
  { BitmapModel.__default.BitAlloc#requires($ly, bm#0) } 
  $Is(bm#0, TSeq(TBool))
     ==> BitmapModel.__default.BitAlloc#requires($ly, bm#0) == true);

// definition axiom for BitmapModel.__default.BitAlloc(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box :: 
    { BitmapModel.__default.BitAlloc($LS($ly), bm#0) } 
    BitmapModel.__default.BitAlloc#canCall(bm#0) || $Is(bm#0, TSeq(TBool))
       ==> BitmapModel.__default.BitAllocIter#canCall(bm#0, LitInt(0))
         && BitmapModel.__default.BitAlloc($LS($ly), bm#0)
           == BitmapModel.__default.BitAllocIter($LS($LZ), bm#0, LitInt(0)));

// definition axiom for BitmapModel.__default.BitAlloc for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box :: 
    {:weight 3} { BitmapModel.__default.BitAlloc($LS($ly), Lit(bm#0)) } 
    BitmapModel.__default.BitAlloc#canCall(Lit(bm#0)) || $Is(bm#0, TSeq(TBool))
       ==> BitmapModel.__default.BitAllocIter#canCall(Lit(bm#0), LitInt(0))
         && BitmapModel.__default.BitAlloc($LS($ly), Lit(bm#0))
           == Lit(BitmapModel.__default.BitAllocIter($LS($LZ), Lit(bm#0), LitInt(0))));

// function declaration for BitmapModel._default.BitUnion
function BitmapModel.__default.BitUnion($ly: LayerType, a#0: Seq Box, b#0: Seq Box) : Seq Box;

function BitmapModel.__default.BitUnion#canCall(a#0: Seq Box, b#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { BitmapModel.__default.BitUnion($LS($ly), a#0, b#0) } 
  BitmapModel.__default.BitUnion($LS($ly), a#0, b#0)
     == BitmapModel.__default.BitUnion($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { BitmapModel.__default.BitUnion(AsFuelBottom($ly), a#0, b#0) } 
  BitmapModel.__default.BitUnion($ly, a#0, b#0)
     == BitmapModel.__default.BitUnion($LZ, a#0, b#0));

// consequence axiom for BitmapModel.__default.BitUnion
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { BitmapModel.__default.BitUnion($ly, a#0, b#0) } 
    BitmapModel.__default.BitUnion#canCall(a#0, b#0)
         || (
          $Is(a#0, TSeq(TBool))
           && $Is(b#0, TSeq(TBool))
           && BitmapModel.__default.Len(a#0) == BitmapModel.__default.Len(b#0))
       ==> BitmapModel.__default.Len(BitmapModel.__default.BitUnion($ly, a#0, b#0))
           == BitmapModel.__default.Len(a#0)
         && (forall i#0: int :: 
          { BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, b#0, i#0) } 
            { BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, a#0, i#0) } 
            { BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, 
              BitmapModel.__default.BitUnion($ly, a#0, b#0), 
              i#0) } 
          LitInt(0) <= i#0
               && i#0 < BitmapModel.__default.Len(BitmapModel.__default.BitUnion($ly, a#0, b#0))
             ==> BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, 
                BitmapModel.__default.BitUnion($ly, a#0, b#0), 
                i#0)
               == (BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, a#0, i#0)
                 || BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, b#0, i#0)))
         && $Is(BitmapModel.__default.BitUnion($ly, a#0, b#0), TSeq(TBool)));

function BitmapModel.__default.BitUnion#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for BitmapModel.__default.BitUnion
axiom (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
  { BitmapModel.__default.BitUnion#requires($ly, a#0, b#0) } 
  $Is(a#0, TSeq(TBool)) && $Is(b#0, TSeq(TBool))
     ==> BitmapModel.__default.BitUnion#requires($ly, a#0, b#0)
       == 
      (BitmapModel.__default.Len(a#0)
       == BitmapModel.__default.Len(b#0)));

const MoreFuel_BitmapModel._default.IsSet0: LayerType;

// definition axiom for BitmapModel.__default.BitUnion(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    { BitmapModel.__default.BitUnion($LS($ly), a#0, b#0) } 
    BitmapModel.__default.BitUnion#canCall(a#0, b#0)
         || (
          $Is(a#0, TSeq(TBool))
           && $Is(b#0, TSeq(TBool))
           && BitmapModel.__default.Len(a#0) == BitmapModel.__default.Len(b#0))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> BitmapModel.__default.BitUnion#canCall(Seq#Take(a#0, Seq#Length(a#0) - 1), Seq#Take(b#0, Seq#Length(b#0) - 1)))
         && 
        StartFuel_BitmapModel._default.IsSet
           == $LS(MoreFuel_BitmapModel._default.IsSet0)
         && StartFuelAssert_BitmapModel._default.IsSet
           == $LS($LS(MoreFuel_BitmapModel._default.IsSet0))
         && AsFuelBottom(MoreFuel_BitmapModel._default.IsSet0)
           == MoreFuel_BitmapModel._default.IsSet0
         && BitmapModel.__default.BitUnion($LS($ly), a#0, b#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else (var res#0 := Seq#Append(BitmapModel.__default.BitUnion($ly, Seq#Take(a#0, Seq#Length(a#0) - 1), Seq#Take(b#0, Seq#Length(b#0) - 1)), 
                  Seq#Build(Seq#Empty(): Seq Box, 
                    $Box($Unbox(Seq#Index(a#0, Seq#Length(a#0) - 1)): bool
                         || $Unbox(Seq#Index(b#0, Seq#Length(b#0) - 1)): bool))); 
              res#0)));

const MoreFuel_BitmapModel._default.IsSet1: LayerType;

// definition axiom for BitmapModel.__default.BitUnion for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, b#0: Seq Box :: 
    {:weight 3} { BitmapModel.__default.BitUnion($LS($ly), Lit(a#0), Lit(b#0)) } 
    BitmapModel.__default.BitUnion#canCall(Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, TSeq(TBool))
           && $Is(b#0, TSeq(TBool))
           && LitInt(BitmapModel.__default.Len(Lit(a#0)))
             == LitInt(BitmapModel.__default.Len(Lit(b#0))))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> BitmapModel.__default.BitUnion#canCall(Seq#Take(Lit(a#0), Seq#Length(Lit(a#0)) - 1), 
            Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 1)))
         && 
        StartFuel_BitmapModel._default.IsSet
           == $LS(MoreFuel_BitmapModel._default.IsSet1)
         && StartFuelAssert_BitmapModel._default.IsSet
           == $LS($LS(MoreFuel_BitmapModel._default.IsSet1))
         && AsFuelBottom(MoreFuel_BitmapModel._default.IsSet1)
           == MoreFuel_BitmapModel._default.IsSet1
         && BitmapModel.__default.BitUnion($LS($ly), Lit(a#0), Lit(b#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else (var res#1 := Seq#Append(BitmapModel.__default.BitUnion($LS($ly), 
                    Seq#Take(Lit(a#0), Seq#Length(Lit(a#0)) - 1), 
                    Seq#Take(Lit(b#0), Seq#Length(Lit(b#0)) - 1)), 
                  Seq#Build(Seq#Empty(): Seq Box, 
                    $Box($Unbox(Seq#Index(Lit(a#0), Seq#Length(Lit(a#0)) - 1)): bool
                         || $Unbox(Seq#Index(Lit(b#0), Seq#Length(Lit(b#0)) - 1)): bool))); 
              res#1)));

const unique class.BitmapImpl.Bitmap?: ClassName;

function Tclass.BitmapImpl.Bitmap?() : Ty;

// Tclass.BitmapImpl.Bitmap? Tag
axiom Tag(Tclass.BitmapImpl.Bitmap?()) == Tagclass.BitmapImpl.Bitmap?;

const unique Tagclass.BitmapImpl.Bitmap?: TyTag;

// Box/unbox axiom for Tclass.BitmapImpl.Bitmap?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BitmapImpl.Bitmap?()) } 
  $IsBox(bx, Tclass.BitmapImpl.Bitmap?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.BitmapImpl.Bitmap?()));

// Bitmap: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BitmapImpl.Bitmap?()) } 
  $Is($o, Tclass.BitmapImpl.Bitmap?())
     <==> $o == null || dtype($o) == Tclass.BitmapImpl.Bitmap?());

// Bitmap: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BitmapImpl.Bitmap?(), $h) } 
  $IsAlloc($o, Tclass.BitmapImpl.Bitmap?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(BitmapImpl.Bitmap.bits) == 0
   && FieldOfDecl(class.BitmapImpl.Bitmap?, field$bits) == BitmapImpl.Bitmap.bits
   && !$IsGhostField(BitmapImpl.Bitmap.bits);

const BitmapImpl.Bitmap.bits: Field ref;

// Bitmap.bits: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, BitmapImpl.Bitmap.bits) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.BitmapImpl.Bitmap?()
     ==> $Is(read($h, $o, BitmapImpl.Bitmap.bits), 
      Tclass._System.array(Tclass.NativeTypes.uint64())));

// Bitmap.bits: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, BitmapImpl.Bitmap.bits) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.BitmapImpl.Bitmap?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, BitmapImpl.Bitmap.bits), 
      Tclass._System.array(Tclass.NativeTypes.uint64()), 
      $h));

const BitmapImpl.Bitmap.Repr: Field (Set Box);

// Bitmap.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, BitmapImpl.Bitmap.Repr) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.BitmapImpl.Bitmap?()
     ==> $Is(read($h, $o, BitmapImpl.Bitmap.Repr), TSet(Tclass._System.object())));

// Bitmap.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, BitmapImpl.Bitmap.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.BitmapImpl.Bitmap?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, BitmapImpl.Bitmap.Repr), TSet(Tclass._System.object()), $h));

// function declaration for BitmapImpl.Bitmap.BitBSet
function BitmapImpl.Bitmap.BitBSet(word#0: int, b#0: int) : bool;

function BitmapImpl.Bitmap.BitBSet#canCall(word#0: int, b#0: int) : bool;

// consequence axiom for BitmapImpl.Bitmap.BitBSet
axiom true
   ==> (forall word#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.BitBSet(word#0, b#0) } 
    BitmapImpl.Bitmap.BitBSet#canCall(word#0, b#0)
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && b#0 < 64)
       ==> true);

function BitmapImpl.Bitmap.BitBSet#requires(int, int) : bool;

// #requires axiom for BitmapImpl.Bitmap.BitBSet
axiom (forall word#0: int, b#0: int :: 
  { BitmapImpl.Bitmap.BitBSet#requires(word#0, b#0) } 
  LitInt(0) <= word#0
       && word#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> BitmapImpl.Bitmap.BitBSet#requires(word#0, b#0) == (b#0 < 64));

// definition axiom for BitmapImpl.Bitmap.BitBSet(revealed)
axiom true
   ==> (forall word#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.BitBSet(word#0, b#0) } 
    BitmapImpl.Bitmap.BitBSet#canCall(word#0, b#0)
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && b#0 < 64)
       ==> BitsetLemmas.__default.in__set__uint64#canCall(b#0, word#0)
         && BitmapImpl.Bitmap.BitBSet(word#0, b#0)
           == BitsetLemmas.__default.in__set__uint64(StartFuel_BitsetLemmas._default.in_set_uint64, b#0, word#0));

// definition axiom for BitmapImpl.Bitmap.BitBSet for all literals(revealed)
axiom true
   ==> (forall word#0: int, b#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.BitBSet(LitInt(word#0), LitInt(b#0)) } 
    BitmapImpl.Bitmap.BitBSet#canCall(LitInt(word#0), LitInt(b#0))
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && Lit(b#0 < 64))
       ==> BitsetLemmas.__default.in__set__uint64#canCall(LitInt(b#0), LitInt(word#0))
         && BitmapImpl.Bitmap.BitBSet(LitInt(word#0), LitInt(b#0))
           == BitsetLemmas.__default.in__set__uint64(StartFuel_BitsetLemmas._default.in_set_uint64, LitInt(b#0), LitInt(word#0)));

// function declaration for BitmapImpl.Bitmap.BitsSetAtIB
function BitmapImpl.Bitmap.BitsSetAtIB(bitsSeq#0: Seq Box, i#0: int, b#0: int) : bool;

function BitmapImpl.Bitmap.BitsSetAtIB#canCall(bitsSeq#0: Seq Box, i#0: int, b#0: int) : bool;

// consequence axiom for BitmapImpl.Bitmap.BitsSetAtIB
axiom true
   ==> (forall bitsSeq#0: Seq Box, i#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.BitsSetAtIB(bitsSeq#0, i#0, b#0) } 
    BitmapImpl.Bitmap.BitsSetAtIB#canCall(bitsSeq#0, i#0, b#0)
         || (
          $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
           && LitInt(0) <= i#0
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && 
          i#0 < Seq#Length(bitsSeq#0)
           && b#0 < 64)
       ==> true);

function BitmapImpl.Bitmap.BitsSetAtIB#requires(Seq Box, int, int) : bool;

// #requires axiom for BitmapImpl.Bitmap.BitsSetAtIB
axiom (forall bitsSeq#0: Seq Box, i#0: int, b#0: int :: 
  { BitmapImpl.Bitmap.BitsSetAtIB#requires(bitsSeq#0, i#0, b#0) } 
  $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
       && LitInt(0) <= i#0
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> BitmapImpl.Bitmap.BitsSetAtIB#requires(bitsSeq#0, i#0, b#0)
       == (i#0 < Seq#Length(bitsSeq#0) && b#0 < 64));

// definition axiom for BitmapImpl.Bitmap.BitsSetAtIB(revealed)
axiom true
   ==> (forall bitsSeq#0: Seq Box, i#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.BitsSetAtIB(bitsSeq#0, i#0, b#0) } 
    BitmapImpl.Bitmap.BitsSetAtIB#canCall(bitsSeq#0, i#0, b#0)
         || (
          $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
           && LitInt(0) <= i#0
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && 
          i#0 < Seq#Length(bitsSeq#0)
           && b#0 < 64)
       ==> (Lit(true)
           ==> BitmapImpl.Bitmap.BitBSet#canCall($Unbox(Seq#Index(bitsSeq#0, i#0)): int, b#0))
         && BitmapImpl.Bitmap.BitsSetAtIB(bitsSeq#0, i#0, b#0)
           == (true && BitmapImpl.Bitmap.BitBSet($Unbox(Seq#Index(bitsSeq#0, i#0)): int, b#0)));

// definition axiom for BitmapImpl.Bitmap.BitsSetAtIB for all literals(revealed)
axiom true
   ==> (forall bitsSeq#0: Seq Box, i#0: int, b#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.BitsSetAtIB(Lit(bitsSeq#0), LitInt(i#0), LitInt(b#0)) } 
    BitmapImpl.Bitmap.BitsSetAtIB#canCall(Lit(bitsSeq#0), LitInt(i#0), LitInt(b#0))
         || (
          $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
           && LitInt(0) <= i#0
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && 
          i#0 < Seq#Length(Lit(bitsSeq#0))
           && Lit(b#0 < 64))
       ==> (Lit(true)
           ==> BitmapImpl.Bitmap.BitBSet#canCall($Unbox(Seq#Index(Lit(bitsSeq#0), LitInt(i#0))): int, LitInt(b#0)))
         && BitmapImpl.Bitmap.BitsSetAtIB(Lit(bitsSeq#0), LitInt(i#0), LitInt(b#0))
           == (true
             && BitmapImpl.Bitmap.BitBSet($Unbox(Seq#Index(Lit(bitsSeq#0), LitInt(i#0))): int, LitInt(b#0))));

// function declaration for BitmapImpl.Bitmap.BitsSetAtC
function BitmapImpl.Bitmap.BitsSetAtC(bitsSeq#0: Seq Box, c#0: int) : bool;

function BitmapImpl.Bitmap.BitsSetAtC#canCall(bitsSeq#0: Seq Box, c#0: int) : bool;

// consequence axiom for BitmapImpl.Bitmap.BitsSetAtC
axiom true
   ==> (forall bitsSeq#0: Seq Box, c#0: int :: 
    { BitmapImpl.Bitmap.BitsSetAtC(bitsSeq#0, c#0) } 
    BitmapImpl.Bitmap.BitsSetAtC#canCall(bitsSeq#0, c#0)
         || (
          $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
           && LitInt(0) <= c#0
           && c#0 < Mul(LitInt(64), Seq#Length(bitsSeq#0)))
       ==> true);

function BitmapImpl.Bitmap.BitsSetAtC#requires(Seq Box, int) : bool;

// #requires axiom for BitmapImpl.Bitmap.BitsSetAtC
axiom (forall bitsSeq#0: Seq Box, c#0: int :: 
  { BitmapImpl.Bitmap.BitsSetAtC#requires(bitsSeq#0, c#0) } 
  $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64())) && LitInt(0) <= c#0
     ==> BitmapImpl.Bitmap.BitsSetAtC#requires(bitsSeq#0, c#0)
       == (c#0 < Mul(LitInt(64), Seq#Length(bitsSeq#0))));

// definition axiom for BitmapImpl.Bitmap.BitsSetAtC(revealed)
axiom true
   ==> (forall bitsSeq#0: Seq Box, c#0: int :: 
    { BitmapImpl.Bitmap.BitsSetAtC(bitsSeq#0, c#0) } 
    BitmapImpl.Bitmap.BitsSetAtC#canCall(bitsSeq#0, c#0)
         || (
          $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
           && LitInt(0) <= c#0
           && c#0 < Mul(LitInt(64), Seq#Length(bitsSeq#0)))
       ==> (Lit(true)
           ==> BitmapImpl.Bitmap.BitsSetAtIB#canCall(bitsSeq#0, Div(c#0, LitInt(64)), Mod(c#0, LitInt(64))))
         && BitmapImpl.Bitmap.BitsSetAtC(bitsSeq#0, c#0)
           == (true
             && BitmapImpl.Bitmap.BitsSetAtIB(bitsSeq#0, Div(c#0, LitInt(64)), Mod(c#0, LitInt(64)))));

// definition axiom for BitmapImpl.Bitmap.BitsSetAtC for all literals(revealed)
axiom true
   ==> (forall bitsSeq#0: Seq Box, c#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.BitsSetAtC(Lit(bitsSeq#0), LitInt(c#0)) } 
    BitmapImpl.Bitmap.BitsSetAtC#canCall(Lit(bitsSeq#0), LitInt(c#0))
         || (
          $Is(bitsSeq#0, TSeq(Tclass.NativeTypes.uint64()))
           && LitInt(0) <= c#0
           && c#0 < Mul(LitInt(64), Seq#Length(Lit(bitsSeq#0))))
       ==> (Lit(true)
           ==> BitmapImpl.Bitmap.BitsSetAtIB#canCall(Lit(bitsSeq#0), LitInt(Div(c#0, LitInt(64))), LitInt(Mod(c#0, LitInt(64)))))
         && BitmapImpl.Bitmap.BitsSetAtC(Lit(bitsSeq#0), LitInt(c#0))
           == Lit(true
               && BitmapImpl.Bitmap.BitsSetAtIB(Lit(bitsSeq#0), LitInt(Div(c#0, LitInt(64))), LitInt(Mod(c#0, LitInt(64))))));

// function declaration for BitmapImpl.Bitmap.ITimes64WithinUint64
function BitmapImpl.Bitmap.ITimes64WithinUint64(i#0: int) : bool;

function BitmapImpl.Bitmap.ITimes64WithinUint64#canCall(i#0: int) : bool;

// consequence axiom for BitmapImpl.Bitmap.ITimes64WithinUint64
axiom true
   ==> (forall i#0: int :: 
    { BitmapImpl.Bitmap.ITimes64WithinUint64(i#0) } 
    BitmapImpl.Bitmap.ITimes64WithinUint64#canCall(i#0) || LitInt(0) <= i#0 ==> true);

function BitmapImpl.Bitmap.ITimes64WithinUint64#requires(int) : bool;

// #requires axiom for BitmapImpl.Bitmap.ITimes64WithinUint64
axiom (forall i#0: int :: 
  { BitmapImpl.Bitmap.ITimes64WithinUint64#requires(i#0) } 
  LitInt(0) <= i#0
     ==> BitmapImpl.Bitmap.ITimes64WithinUint64#requires(i#0) == true);

// definition axiom for BitmapImpl.Bitmap.ITimes64WithinUint64(revealed)
axiom true
   ==> (forall i#0: int :: 
    { BitmapImpl.Bitmap.ITimes64WithinUint64(i#0) } 
    BitmapImpl.Bitmap.ITimes64WithinUint64#canCall(i#0) || LitInt(0) <= i#0
       ==> BitmapImpl.Bitmap.ITimes64WithinUint64(i#0)
         == (true && Mul(i#0, LitInt(64)) < 18446744073709551616));

// definition axiom for BitmapImpl.Bitmap.ITimes64WithinUint64 for all literals(revealed)
axiom true
   ==> (forall i#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.ITimes64WithinUint64(LitInt(i#0)) } 
    BitmapImpl.Bitmap.ITimes64WithinUint64#canCall(LitInt(i#0)) || LitInt(0) <= i#0
       ==> BitmapImpl.Bitmap.ITimes64WithinUint64(LitInt(i#0))
         == Lit(true && Mul(LitInt(i#0), LitInt(64)) < 18446744073709551616));

// function declaration for BitmapImpl.Bitmap.ReprInv
function BitmapImpl.Bitmap.ReprInv($heap: Heap, this: ref) : bool;

function BitmapImpl.Bitmap.ReprInv#canCall($heap: Heap, this: ref) : bool;

// frame axiom for BitmapImpl.Bitmap.ReprInv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), BitmapImpl.Bitmap.ReprInv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.BitmapImpl.Bitmap())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && ($o == this || read($h0, this, BitmapImpl.Bitmap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> BitmapImpl.Bitmap.ReprInv($h0, this) == BitmapImpl.Bitmap.ReprInv($h1, this));

// consequence axiom for BitmapImpl.Bitmap.ReprInv
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { BitmapImpl.Bitmap.ReprInv($Heap, this) } 
    BitmapImpl.Bitmap.ReprInv#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.BitmapImpl.Bitmap())
           && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap))
       ==> true);

function BitmapImpl.Bitmap.ReprInv#requires(Heap, ref) : bool;

// #requires axiom for BitmapImpl.Bitmap.ReprInv
axiom (forall $Heap: Heap, this: ref :: 
  { BitmapImpl.Bitmap.ReprInv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.BitmapImpl.Bitmap())
       && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap)
     ==> BitmapImpl.Bitmap.ReprInv#requires($Heap, this) == true);

// definition axiom for BitmapImpl.Bitmap.ReprInv(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { BitmapImpl.Bitmap.ReprInv($Heap, this) } 
    BitmapImpl.Bitmap.ReprInv#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.BitmapImpl.Bitmap())
           && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap))
       ==> BitmapImpl.Bitmap.ReprInv($Heap, this)
         == (true
           && Set#Equal(read($Heap, this, BitmapImpl.Bitmap.Repr), 
            Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
              $Box(read($Heap, this, BitmapImpl.Bitmap.bits))))));

// function declaration for BitmapImpl.Bitmap.Inv
function BitmapImpl.Bitmap.Inv($heap: Heap, this: ref) : bool;

function BitmapImpl.Bitmap.Inv#canCall($heap: Heap, this: ref) : bool;

// frame axiom for BitmapImpl.Bitmap.Inv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), BitmapImpl.Bitmap.Inv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.BitmapImpl.Bitmap())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && ($o == this || read($h0, this, BitmapImpl.Bitmap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> BitmapImpl.Bitmap.Inv($h0, this) == BitmapImpl.Bitmap.Inv($h1, this));

// consequence axiom for BitmapImpl.Bitmap.Inv
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { BitmapImpl.Bitmap.Inv($Heap, this) } 
    BitmapImpl.Bitmap.Inv#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.BitmapImpl.Bitmap())
           && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap))
       ==> 
      BitmapImpl.Bitmap.Inv($Heap, this)
       ==> read($Heap, this, BitmapImpl.Bitmap.Repr)[$Box(this)]);

function BitmapImpl.Bitmap.Inv#requires(Heap, ref) : bool;

// #requires axiom for BitmapImpl.Bitmap.Inv
axiom (forall $Heap: Heap, this: ref :: 
  { BitmapImpl.Bitmap.Inv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.BitmapImpl.Bitmap())
       && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap)
     ==> BitmapImpl.Bitmap.Inv#requires($Heap, this) == true);

// definition axiom for BitmapImpl.Bitmap.Inv(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { BitmapImpl.Bitmap.Inv($Heap, this) } 
    BitmapImpl.Bitmap.Inv#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.BitmapImpl.Bitmap())
           && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap))
       ==> true);

// function declaration for BitmapImpl.Bitmap.IPrefix
function BitmapImpl.Bitmap.IPrefix($ly: LayerType, bits#0: Seq Box, i#0: int) : Seq Box;

function BitmapImpl.Bitmap.IPrefix#canCall(bits#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bits#0: Seq Box, i#0: int :: 
  { BitmapImpl.Bitmap.IPrefix($LS($ly), bits#0, i#0) } 
  BitmapImpl.Bitmap.IPrefix($LS($ly), bits#0, i#0)
     == BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bits#0: Seq Box, i#0: int :: 
  { BitmapImpl.Bitmap.IPrefix(AsFuelBottom($ly), bits#0, i#0) } 
  BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0)
     == BitmapImpl.Bitmap.IPrefix($LZ, bits#0, i#0));

// consequence axiom for BitmapImpl.Bitmap.IPrefix
axiom true
   ==> (forall $ly: LayerType, bits#0: Seq Box, i#0: int :: 
    { BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0) } 
    BitmapImpl.Bitmap.IPrefix#canCall(bits#0, i#0)
         || ($Is(bits#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 <= Mul(LitInt(64), Seq#Length(bits#0)))
       ==> Seq#Length(BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0)) == i#0
         && (forall j#0: int :: 
          { BitmapImpl.Bitmap.BitsSetAtC(bits#0, j#0) } 
            { $Unbox(Seq#Index(BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0), j#0)): bool } 
          LitInt(0) <= j#0 && j#0 < i#0
             ==> $Unbox(Seq#Index(BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0), j#0)): bool
               == BitmapImpl.Bitmap.BitsSetAtC(bits#0, j#0))
         && $Is(BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0), TSeq(TBool)));

function BitmapImpl.Bitmap.IPrefix#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for BitmapImpl.Bitmap.IPrefix
axiom (forall $ly: LayerType, bits#0: Seq Box, i#0: int :: 
  { BitmapImpl.Bitmap.IPrefix#requires($ly, bits#0, i#0) } 
  $Is(bits#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> BitmapImpl.Bitmap.IPrefix#requires($ly, bits#0, i#0)
       == (LitInt(0) <= i#0 && i#0 <= Mul(LitInt(64), Seq#Length(bits#0))));

// definition axiom for BitmapImpl.Bitmap.IPrefix(revealed)
axiom true
   ==> (forall $ly: LayerType, bits#0: Seq Box, i#0: int :: 
    { BitmapImpl.Bitmap.IPrefix($LS($ly), bits#0, i#0) } 
    BitmapImpl.Bitmap.IPrefix#canCall(bits#0, i#0)
         || ($Is(bits#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 <= Mul(LitInt(64), Seq#Length(bits#0)))
       ==> (i#0 != LitInt(0)
           ==> BitmapImpl.Bitmap.IPrefix#canCall(bits#0, i#0 - 1)
             && BitmapImpl.Bitmap.BitsSetAtC#canCall(bits#0, i#0 - 1))
         && BitmapImpl.Bitmap.IPrefix($LS($ly), bits#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BitmapImpl.Bitmap.IPrefix($ly, bits#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, $Box(BitmapImpl.Bitmap.BitsSetAtC(bits#0, i#0 - 1))))));

// definition axiom for BitmapImpl.Bitmap.IPrefix for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bits#0: Seq Box, i#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.IPrefix($LS($ly), Lit(bits#0), LitInt(i#0)) } 
    BitmapImpl.Bitmap.IPrefix#canCall(Lit(bits#0), LitInt(i#0))
         || ($Is(bits#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Mul(LitInt(64), Seq#Length(Lit(bits#0))))
       ==> (LitInt(i#0) != LitInt(0)
           ==> BitmapImpl.Bitmap.IPrefix#canCall(Lit(bits#0), LitInt(i#0 - 1))
             && BitmapImpl.Bitmap.BitsSetAtC#canCall(Lit(bits#0), LitInt(i#0 - 1)))
         && BitmapImpl.Bitmap.IPrefix($LS($ly), Lit(bits#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(BitmapImpl.Bitmap.IPrefix($LS($ly), Lit(bits#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(BitmapImpl.Bitmap.BitsSetAtC(Lit(bits#0), LitInt(i#0 - 1))))))));

// function declaration for BitmapImpl.Bitmap.I
function BitmapImpl.Bitmap.I($heap: Heap, this: ref) : Seq Box;

function BitmapImpl.Bitmap.I#canCall($heap: Heap, this: ref) : bool;

// frame axiom for BitmapImpl.Bitmap.I
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), BitmapImpl.Bitmap.I($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.BitmapImpl.Bitmap())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null && ($o == this || read($h0, this, BitmapImpl.Bitmap.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> BitmapImpl.Bitmap.I($h0, this) == BitmapImpl.Bitmap.I($h1, this));

// consequence axiom for BitmapImpl.Bitmap.I
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { BitmapImpl.Bitmap.I($Heap, this) } 
    BitmapImpl.Bitmap.I#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.BitmapImpl.Bitmap())
           && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap)
           && BitmapImpl.Bitmap.Inv($Heap, this))
       ==> $Is(BitmapImpl.Bitmap.I($Heap, this), TSeq(TBool)));

function BitmapImpl.Bitmap.I#requires(Heap, ref) : bool;

// #requires axiom for BitmapImpl.Bitmap.I
axiom (forall $Heap: Heap, this: ref :: 
  { BitmapImpl.Bitmap.I#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.BitmapImpl.Bitmap())
       && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap)
     ==> BitmapImpl.Bitmap.I#requires($Heap, this) == BitmapImpl.Bitmap.Inv($Heap, this));

// definition axiom for BitmapImpl.Bitmap.I(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { BitmapImpl.Bitmap.I($Heap, this) } 
    BitmapImpl.Bitmap.I#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.BitmapImpl.Bitmap())
           && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap)
           && BitmapImpl.Bitmap.Inv($Heap, this))
       ==> true);

procedure CheckWellformed$$BitmapImpl.Bitmap.__ctor(this: ref
       where this != null
         && 
        $Is(this, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap), 
    len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616);
  free requires 15 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BitmapImpl.Bitmap.__ctor(len#0: int where LitInt(0) <= len#0 && len#0 < 18446744073709551616)
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap));
  // user-defined preconditions
  requires len#0 < Div(18446744073709551616, LitInt(2));
  requires Mod(len#0, LitInt(64)) == LitInt(0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, this);
  ensures BitmapImpl.Bitmap.Inv($Heap, this);
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, this)
     && BitmapModel.__default.EmptyBitmap#canCall(len#0);
  ensures Seq#Equal(BitmapImpl.Bitmap.I($Heap, this), 
    BitmapModel.__default.EmptyBitmap(StartFuelAssert_BitmapModel._default.EmptyBitmap, len#0));
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, BitmapImpl.Bitmap.Repr)[$Box($o)] } 
    read($Heap, this, BitmapImpl.Bitmap.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// function declaration for BitmapImpl.Bitmap.SetBit
function BitmapImpl.Bitmap.SetBit(word#0: int, b#0: int) : int;

function BitmapImpl.Bitmap.SetBit#canCall(word#0: int, b#0: int) : bool;

// consequence axiom for BitmapImpl.Bitmap.SetBit
axiom true
   ==> (forall word#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.SetBit(word#0, b#0) } 
    BitmapImpl.Bitmap.SetBit#canCall(word#0, b#0)
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && b#0 < 64)
       ==> LitInt(0) <= BitmapImpl.Bitmap.SetBit(word#0, b#0)
         && BitmapImpl.Bitmap.SetBit(word#0, b#0) < 18446744073709551616);

function BitmapImpl.Bitmap.SetBit#requires(int, int) : bool;

// #requires axiom for BitmapImpl.Bitmap.SetBit
axiom (forall word#0: int, b#0: int :: 
  { BitmapImpl.Bitmap.SetBit#requires(word#0, b#0) } 
  LitInt(0) <= word#0
       && word#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> BitmapImpl.Bitmap.SetBit#requires(word#0, b#0) == (b#0 < 64));

// definition axiom for BitmapImpl.Bitmap.SetBit(revealed)
axiom true
   ==> (forall word#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.SetBit(word#0, b#0) } 
    BitmapImpl.Bitmap.SetBit#canCall(word#0, b#0)
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && b#0 < 64)
       ==> BitsetLemmas.__default.set__bit__to__1__uint64#canCall(word#0, b#0)
         && BitmapImpl.Bitmap.SetBit(word#0, b#0)
           == BitsetLemmas.__default.set__bit__to__1__uint64(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64, word#0, b#0));

// definition axiom for BitmapImpl.Bitmap.SetBit for all literals(revealed)
axiom true
   ==> (forall word#0: int, b#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.SetBit(LitInt(word#0), LitInt(b#0)) } 
    BitmapImpl.Bitmap.SetBit#canCall(LitInt(word#0), LitInt(b#0))
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && Lit(b#0 < 64))
       ==> BitsetLemmas.__default.set__bit__to__1__uint64#canCall(LitInt(word#0), LitInt(b#0))
         && BitmapImpl.Bitmap.SetBit(LitInt(word#0), LitInt(b#0))
           == BitsetLemmas.__default.set__bit__to__1__uint64(StartFuel_BitsetLemmas._default.set_bit_to_1_uint64, LitInt(word#0), LitInt(b#0)));

procedure CheckWellformed$$BitmapImpl.Bitmap.Set(this: ref
       where this != null
         && 
        $Is(this, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap), 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616);
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BitmapImpl.Bitmap.Set(this: ref
       where this != null
         && 
        $Is(this, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap), 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616);
  // user-defined preconditions
  requires BitmapImpl.Bitmap.Inv($Heap, this);
  requires c#0 < BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.Inv#canCall($Heap, this);
  ensures BitmapImpl.Bitmap.Inv($Heap, this);
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, this)
     && 
    BitmapImpl.Bitmap.I#canCall(old($Heap), this)
     && BitmapModel.__default.BitSet#canCall(BitmapImpl.Bitmap.I(old($Heap), this), c#0);
  ensures Seq#Equal(BitmapImpl.Bitmap.I($Heap, this), 
    BitmapModel.__default.BitSet(StartFuelAssert_BitmapModel._default.BitSet, 
      BitmapImpl.Bitmap.I(old($Heap), this), 
      c#0));
  free ensures true;
  ensures Set#Equal(read($Heap, this, BitmapImpl.Bitmap.Repr), 
    read(old($Heap), this, BitmapImpl.Bitmap.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, BitmapImpl.Bitmap.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// function declaration for BitmapImpl.Bitmap.UnsetBit
function BitmapImpl.Bitmap.UnsetBit(word#0: int, b#0: int) : int;

function BitmapImpl.Bitmap.UnsetBit#canCall(word#0: int, b#0: int) : bool;

// consequence axiom for BitmapImpl.Bitmap.UnsetBit
axiom true
   ==> (forall word#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.UnsetBit(word#0, b#0) } 
    BitmapImpl.Bitmap.UnsetBit#canCall(word#0, b#0)
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && b#0 < 64)
       ==> LitInt(0) <= BitmapImpl.Bitmap.UnsetBit(word#0, b#0)
         && BitmapImpl.Bitmap.UnsetBit(word#0, b#0) < 18446744073709551616);

function BitmapImpl.Bitmap.UnsetBit#requires(int, int) : bool;

// #requires axiom for BitmapImpl.Bitmap.UnsetBit
axiom (forall word#0: int, b#0: int :: 
  { BitmapImpl.Bitmap.UnsetBit#requires(word#0, b#0) } 
  LitInt(0) <= word#0
       && word#0 < 18446744073709551616
       && 
      LitInt(0) <= b#0
       && b#0 < 18446744073709551616
     ==> BitmapImpl.Bitmap.UnsetBit#requires(word#0, b#0) == (b#0 < 64));

// definition axiom for BitmapImpl.Bitmap.UnsetBit(revealed)
axiom true
   ==> (forall word#0: int, b#0: int :: 
    { BitmapImpl.Bitmap.UnsetBit(word#0, b#0) } 
    BitmapImpl.Bitmap.UnsetBit#canCall(word#0, b#0)
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && b#0 < 64)
       ==> BitsetLemmas.__default.set__bit__to__0__uint64#canCall(word#0, b#0)
         && BitmapImpl.Bitmap.UnsetBit(word#0, b#0)
           == BitsetLemmas.__default.set__bit__to__0__uint64(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64, word#0, b#0));

// definition axiom for BitmapImpl.Bitmap.UnsetBit for all literals(revealed)
axiom true
   ==> (forall word#0: int, b#0: int :: 
    {:weight 3} { BitmapImpl.Bitmap.UnsetBit(LitInt(word#0), LitInt(b#0)) } 
    BitmapImpl.Bitmap.UnsetBit#canCall(LitInt(word#0), LitInt(b#0))
         || (
          LitInt(0) <= word#0
           && word#0 < 18446744073709551616
           && 
          LitInt(0) <= b#0
           && b#0 < 18446744073709551616
           && Lit(b#0 < 64))
       ==> BitsetLemmas.__default.set__bit__to__0__uint64#canCall(LitInt(word#0), LitInt(b#0))
         && BitmapImpl.Bitmap.UnsetBit(LitInt(word#0), LitInt(b#0))
           == BitsetLemmas.__default.set__bit__to__0__uint64(StartFuel_BitsetLemmas._default.set_bit_to_0_uint64, LitInt(word#0), LitInt(b#0)));

procedure CheckWellformed$$BitmapImpl.Bitmap.GetIsSet(this: ref
       where this != null
         && 
        $Is(this, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap), 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616)
   returns (result#0: bool);
  free requires 20 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$BitmapImpl.Bitmap.GetIsSet(this: ref
       where this != null
         && 
        $Is(this, Tclass.BitmapImpl.Bitmap())
         && $IsAlloc(this, Tclass.BitmapImpl.Bitmap(), $Heap), 
    c#0: int where LitInt(0) <= c#0 && c#0 < 18446744073709551616)
   returns (result#0: bool);
  // user-defined preconditions
  requires BitmapImpl.Bitmap.Inv($Heap, this);
  requires c#0 < BitmapModel.__default.Len(BitmapImpl.Bitmap.I($Heap, this));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures BitmapImpl.Bitmap.I#canCall($Heap, this)
     && BitmapModel.__default.IsSet#canCall(BitmapImpl.Bitmap.I($Heap, this), c#0);
  ensures result#0
     == BitmapModel.__default.IsSet(StartFuelAssert_BitmapModel._default.IsSet, 
      BitmapImpl.Bitmap.I($Heap, this), 
      c#0);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// BitmapImpl.Bitmap: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.BitmapImpl.Bitmap()) } 
  $Is(c#0, Tclass.BitmapImpl.Bitmap())
     <==> $Is(c#0, Tclass.BitmapImpl.Bitmap?()) && c#0 != null);

// BitmapImpl.Bitmap: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.BitmapImpl.Bitmap(), $h) } 
  $IsAlloc(c#0, Tclass.BitmapImpl.Bitmap(), $h)
     <==> $IsAlloc(c#0, Tclass.BitmapImpl.Bitmap?(), $h));

const unique class.BitmapImpl.__default: ClassName;

function Tclass.BitmapImpl.__default() : Ty;

// Tclass.BitmapImpl.__default Tag
axiom Tag(Tclass.BitmapImpl.__default()) == Tagclass.BitmapImpl.__default;

const unique Tagclass.BitmapImpl.__default: TyTag;

// Box/unbox axiom for Tclass.BitmapImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.BitmapImpl.__default()) } 
  $IsBox(bx, Tclass.BitmapImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.BitmapImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.BitmapImpl.__default()) } 
  $Is($o, Tclass.BitmapImpl.__default())
     <==> $o == null || dtype($o) == Tclass.BitmapImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.BitmapImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.BitmapImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// Constructor function declaration
function #JournalIntervals.JournalInterval.JournalInterval(int, int) : DatatypeType;

const unique ##JournalIntervals.JournalInterval.JournalInterval: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: int, a#0#1#0: int :: 
  { #JournalIntervals.JournalInterval.JournalInterval(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#JournalIntervals.JournalInterval.JournalInterval(a#0#0#0, a#0#1#0))
     == ##JournalIntervals.JournalInterval.JournalInterval);

function JournalIntervals.JournalInterval.JournalInterval_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalIntervals.JournalInterval.JournalInterval_q(d) } 
  JournalIntervals.JournalInterval.JournalInterval_q(d)
     <==> DatatypeCtorId(d) == ##JournalIntervals.JournalInterval.JournalInterval);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalIntervals.JournalInterval.JournalInterval_q(d) } 
  JournalIntervals.JournalInterval.JournalInterval_q(d)
     ==> (exists a#1#0#0: int, a#1#1#0: int :: 
      d == #JournalIntervals.JournalInterval.JournalInterval(a#1#0#0, a#1#1#0)));

function Tclass.JournalIntervals.JournalInterval() : Ty;

// Tclass.JournalIntervals.JournalInterval Tag
axiom Tag(Tclass.JournalIntervals.JournalInterval())
   == Tagclass.JournalIntervals.JournalInterval;

const unique Tagclass.JournalIntervals.JournalInterval: TyTag;

// Box/unbox axiom for Tclass.JournalIntervals.JournalInterval
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalIntervals.JournalInterval()) } 
  $IsBox(bx, Tclass.JournalIntervals.JournalInterval())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalIntervals.JournalInterval()));

// Constructor $Is
axiom (forall a#2#0#0: int, a#2#1#0: int :: 
  { $Is(#JournalIntervals.JournalInterval.JournalInterval(a#2#0#0, a#2#1#0), 
      Tclass.JournalIntervals.JournalInterval()) } 
  $Is(#JournalIntervals.JournalInterval.JournalInterval(a#2#0#0, a#2#1#0), 
      Tclass.JournalIntervals.JournalInterval())
     <==> $Is(a#2#0#0, TInt) && $Is(a#2#1#0, TInt));

// Constructor $IsAlloc
axiom (forall a#3#0#0: int, a#3#1#0: int, $h: Heap :: 
  { $IsAlloc(#JournalIntervals.JournalInterval.JournalInterval(a#3#0#0, a#3#1#0), 
      Tclass.JournalIntervals.JournalInterval(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalIntervals.JournalInterval.JournalInterval(a#3#0#0, a#3#1#0), 
        Tclass.JournalIntervals.JournalInterval(), 
        $h)
       <==> $IsAlloc(a#3#0#0, TInt, $h) && $IsAlloc(a#3#1#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalIntervals.JournalInterval.start(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalIntervals.JournalInterval.JournalInterval_q(d)
       && $IsAlloc(d, Tclass.JournalIntervals.JournalInterval(), $h)
     ==> $IsAlloc(JournalIntervals.JournalInterval.start(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalIntervals.JournalInterval.len(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalIntervals.JournalInterval.JournalInterval_q(d)
       && $IsAlloc(d, Tclass.JournalIntervals.JournalInterval(), $h)
     ==> $IsAlloc(JournalIntervals.JournalInterval.len(d), TInt, $h));

// Constructor literal
axiom (forall a#4#0#0: int, a#4#1#0: int :: 
  { #JournalIntervals.JournalInterval.JournalInterval(LitInt(a#4#0#0), LitInt(a#4#1#0)) } 
  #JournalIntervals.JournalInterval.JournalInterval(LitInt(a#4#0#0), LitInt(a#4#1#0))
     == Lit(#JournalIntervals.JournalInterval.JournalInterval(a#4#0#0, a#4#1#0)));

function JournalIntervals.JournalInterval.start(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#5#0#0: int, a#5#1#0: int :: 
  { #JournalIntervals.JournalInterval.JournalInterval(a#5#0#0, a#5#1#0) } 
  JournalIntervals.JournalInterval.start(#JournalIntervals.JournalInterval.JournalInterval(a#5#0#0, a#5#1#0))
     == a#5#0#0);

function JournalIntervals.JournalInterval.len(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#6#0#0: int, a#6#1#0: int :: 
  { #JournalIntervals.JournalInterval.JournalInterval(a#6#0#0, a#6#1#0) } 
  JournalIntervals.JournalInterval.len(#JournalIntervals.JournalInterval.JournalInterval(a#6#0#0, a#6#1#0))
     == a#6#1#0);

// Depth-one case-split function
function $IsA#JournalIntervals.JournalInterval(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalIntervals.JournalInterval(d) } 
  $IsA#JournalIntervals.JournalInterval(d)
     ==> JournalIntervals.JournalInterval.JournalInterval_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalIntervals.JournalInterval.JournalInterval_q(d), $Is(d, Tclass.JournalIntervals.JournalInterval()) } 
  $Is(d, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.JournalInterval.JournalInterval_q(d));

// Datatype extensional equality declaration
function JournalIntervals.JournalInterval#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalIntervals.JournalInterval.JournalInterval
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalIntervals.JournalInterval#Equal(a, b) } 
  true
     ==> (JournalIntervals.JournalInterval#Equal(a, b)
       <==> JournalIntervals.JournalInterval.start(a)
           == JournalIntervals.JournalInterval.start(b)
         && JournalIntervals.JournalInterval.len(a)
           == JournalIntervals.JournalInterval.len(b)));

// Datatype extensionality axiom: JournalIntervals.JournalInterval
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalIntervals.JournalInterval#Equal(a, b) } 
  JournalIntervals.JournalInterval#Equal(a, b) <==> a == b);

const unique class.JournalIntervals.JournalInterval: ClassName;

const unique class.JournalIntervals.__default: ClassName;

function Tclass.JournalIntervals.__default() : Ty;

// Tclass.JournalIntervals.__default Tag
axiom Tag(Tclass.JournalIntervals.__default()) == Tagclass.JournalIntervals.__default;

const unique Tagclass.JournalIntervals.__default: TyTag;

// Box/unbox axiom for Tclass.JournalIntervals.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalIntervals.__default()) } 
  $IsBox(bx, Tclass.JournalIntervals.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalIntervals.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalIntervals.__default()) } 
  $Is($o, Tclass.JournalIntervals.__default())
     <==> $o == null || dtype($o) == Tclass.JournalIntervals.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalIntervals.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalIntervals.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalIntervals._default.ValidJournalInterval
function JournalIntervals.__default.ValidJournalInterval(indices#0: DatatypeType) : bool;

function JournalIntervals.__default.ValidJournalInterval#canCall(indices#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.ValidJournalInterval
axiom true
   ==> (forall indices#0: DatatypeType :: 
    { JournalIntervals.__default.ValidJournalInterval(indices#0) } 
    JournalIntervals.__default.ValidJournalInterval#canCall(indices#0)
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> true);

function JournalIntervals.__default.ValidJournalInterval#requires(DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.ValidJournalInterval
axiom (forall indices#0: DatatypeType :: 
  { JournalIntervals.__default.ValidJournalInterval#requires(indices#0) } 
  $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.ValidJournalInterval#requires(indices#0) == true);

// definition axiom for JournalIntervals.__default.ValidJournalInterval(revealed)
axiom true
   ==> (forall indices#0: DatatypeType :: 
    { JournalIntervals.__default.ValidJournalInterval(indices#0) } 
    JournalIntervals.__default.ValidJournalInterval#canCall(indices#0)
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
         && (LitInt(0) <= JournalIntervals.JournalInterval.start(indices#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && JournalIntervals.JournalInterval.start(indices#0)
               < DiskLayout.__default.NumJournalBlocks()
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && (LitInt(0) <= JournalIntervals.JournalInterval.len(indices#0)
               ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.ValidJournalInterval(indices#0)
           == (
            LitInt(0) <= JournalIntervals.JournalInterval.start(indices#0)
             && JournalIntervals.JournalInterval.start(indices#0)
               < DiskLayout.__default.NumJournalBlocks()
             && 
            LitInt(0) <= JournalIntervals.JournalInterval.len(indices#0)
             && JournalIntervals.JournalInterval.len(indices#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalIntervals.__default.ValidJournalInterval for all literals(revealed)
axiom true
   ==> (forall indices#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.ValidJournalInterval(Lit(indices#0)) } 
    JournalIntervals.__default.ValidJournalInterval#canCall(Lit(indices#0))
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
         && (LitInt(0) <= LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && Lit(JournalIntervals.JournalInterval.start(Lit(indices#0))
                 < DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && (LitInt(0) <= LitInt(JournalIntervals.JournalInterval.len(Lit(indices#0)))
               ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.ValidJournalInterval(Lit(indices#0))
           == (
            LitInt(0) <= LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
             && JournalIntervals.JournalInterval.start(Lit(indices#0))
               < DiskLayout.__default.NumJournalBlocks()
             && 
            LitInt(0) <= LitInt(JournalIntervals.JournalInterval.len(Lit(indices#0)))
             && LitInt(JournalIntervals.JournalInterval.len(Lit(indices#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// function declaration for JournalIntervals._default.ContiguousJournalInterval
function JournalIntervals.__default.ContiguousJournalInterval(indices#0: DatatypeType) : bool;

function JournalIntervals.__default.ContiguousJournalInterval#canCall(indices#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.ContiguousJournalInterval
axiom true
   ==> (forall indices#0: DatatypeType :: 
    { JournalIntervals.__default.ContiguousJournalInterval(indices#0) } 
    JournalIntervals.__default.ContiguousJournalInterval#canCall(indices#0)
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> true);

function JournalIntervals.__default.ContiguousJournalInterval#requires(DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.ContiguousJournalInterval
axiom (forall indices#0: DatatypeType :: 
  { JournalIntervals.__default.ContiguousJournalInterval#requires(indices#0) } 
  $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.ContiguousJournalInterval#requires(indices#0) == true);

// definition axiom for JournalIntervals.__default.ContiguousJournalInterval(revealed)
axiom true
   ==> (forall indices#0: DatatypeType :: 
    { JournalIntervals.__default.ContiguousJournalInterval(indices#0) } 
    JournalIntervals.__default.ContiguousJournalInterval#canCall(indices#0)
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.__default.ValidJournalInterval#canCall(indices#0)
         && (JournalIntervals.__default.ValidJournalInterval(indices#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && (LitInt(0)
                 <= JournalIntervals.JournalInterval.start(indices#0)
                   + JournalIntervals.JournalInterval.len(indices#0)
               ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
                 && JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.ContiguousJournalInterval(indices#0)
           == (JournalIntervals.__default.ValidJournalInterval(indices#0)
             && 
            LitInt(0)
               <= JournalIntervals.JournalInterval.start(indices#0)
                 + JournalIntervals.JournalInterval.len(indices#0)
             && JournalIntervals.JournalInterval.start(indices#0)
                 + JournalIntervals.JournalInterval.len(indices#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalIntervals.__default.ContiguousJournalInterval for all literals(revealed)
axiom true
   ==> (forall indices#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.ContiguousJournalInterval(Lit(indices#0)) } 
    JournalIntervals.__default.ContiguousJournalInterval#canCall(Lit(indices#0))
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.__default.ValidJournalInterval#canCall(Lit(indices#0))
         && (Lit(JournalIntervals.__default.ValidJournalInterval(Lit(indices#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && (LitInt(0)
                 <= LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))
                     + JournalIntervals.JournalInterval.len(Lit(indices#0)))
               ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.ContiguousJournalInterval(Lit(indices#0))
           == (JournalIntervals.__default.ValidJournalInterval(Lit(indices#0))
             && 
            LitInt(0)
               <= LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))
                   + JournalIntervals.JournalInterval.len(Lit(indices#0)))
             && LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))
                   + JournalIntervals.JournalInterval.len(Lit(indices#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// function declaration for JournalIntervals._default.ValidJournal
function JournalIntervals.__default.ValidJournal(journal#0: Seq Box) : bool;

function JournalIntervals.__default.ValidJournal#canCall(journal#0: Seq Box) : bool;

// consequence axiom for JournalIntervals.__default.ValidJournal
axiom true
   ==> (forall journal#0: Seq Box :: 
    { JournalIntervals.__default.ValidJournal(journal#0) } 
    JournalIntervals.__default.ValidJournal#canCall(journal#0)
         || $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       ==> true);

function JournalIntervals.__default.ValidJournal#requires(Seq Box) : bool;

// #requires axiom for JournalIntervals.__default.ValidJournal
axiom (forall journal#0: Seq Box :: 
  { JournalIntervals.__default.ValidJournal#requires(journal#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
     ==> JournalIntervals.__default.ValidJournal#requires(journal#0) == true);

// definition axiom for JournalIntervals.__default.ValidJournal(revealed)
axiom true
   ==> (forall journal#0: Seq Box :: 
    { JournalIntervals.__default.ValidJournal(journal#0) } 
    JournalIntervals.__default.ValidJournal#canCall(journal#0)
         || $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && JournalIntervals.__default.ValidJournal(journal#0)
           == 
          (Seq#Length(journal#0)
           == LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalIntervals.__default.ValidJournal for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box :: 
    {:weight 3} { JournalIntervals.__default.ValidJournal(Lit(journal#0)) } 
    JournalIntervals.__default.ValidJournal#canCall(Lit(journal#0))
         || $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       ==> DiskLayout.__default.NumJournalBlocks#canCall()
         && JournalIntervals.__default.ValidJournal(Lit(journal#0))
           == 
          (Seq#Length(Lit(journal#0))
           == LitInt(DiskLayout.__default.NumJournalBlocks())));

// function declaration for JournalIntervals._default.CyclicSpliceValue
function JournalIntervals.__default.CyclicSpliceValue(journal#0: Seq Box, indices#0: DatatypeType, newEntries#0: Seq Box, i#0: int)
   : DatatypeType;

function JournalIntervals.__default.CyclicSpliceValue#canCall(journal#0: Seq Box, indices#0: DatatypeType, newEntries#0: Seq Box, i#0: int)
   : bool;

// consequence axiom for JournalIntervals.__default.CyclicSpliceValue
axiom true
   ==> (forall journal#0: Seq Box, indices#0: DatatypeType, newEntries#0: Seq Box, i#0: int :: 
    { JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0) } 
    JournalIntervals.__default.CyclicSpliceValue#canCall(journal#0, indices#0, newEntries#0, i#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          JournalIntervals.__default.ValidJournal(journal#0)
           && JournalIntervals.__default.ValidJournalInterval(indices#0)
           && JournalIntervals.JournalInterval.len(indices#0) == Seq#Length(newEntries#0)
           && 
          LitInt(0) <= i#0
           && i#0 < DiskLayout.__default.NumJournalBlocks())
       ==> $Is(JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0), 
        Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())));

function JournalIntervals.__default.CyclicSpliceValue#requires(Seq Box, DatatypeType, Seq Box, int) : bool;

// #requires axiom for JournalIntervals.__default.CyclicSpliceValue
axiom (forall journal#0: Seq Box, indices#0: DatatypeType, newEntries#0: Seq Box, i#0: int :: 
  { JournalIntervals.__default.CyclicSpliceValue#requires(journal#0, indices#0, newEntries#0, i#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalIntervals.__default.CyclicSpliceValue#requires(journal#0, indices#0, newEntries#0, i#0)
       == (
        JournalIntervals.__default.ValidJournal(journal#0)
         && JournalIntervals.__default.ValidJournalInterval(indices#0)
         && JournalIntervals.JournalInterval.len(indices#0) == Seq#Length(newEntries#0)
         && 
        LitInt(0) <= i#0
         && i#0 < DiskLayout.__default.NumJournalBlocks()));

// definition axiom for JournalIntervals.__default.CyclicSpliceValue(revealed)
axiom true
   ==> (forall journal#0: Seq Box, indices#0: DatatypeType, newEntries#0: Seq Box, i#0: int :: 
    { JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0) } 
    JournalIntervals.__default.CyclicSpliceValue#canCall(journal#0, indices#0, newEntries#0, i#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          JournalIntervals.__default.ValidJournal(journal#0)
           && JournalIntervals.__default.ValidJournalInterval(indices#0)
           && JournalIntervals.JournalInterval.len(indices#0) == Seq#Length(newEntries#0)
           && 
          LitInt(0) <= i#0
           && i#0 < DiskLayout.__default.NumJournalBlocks())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
         && (JournalIntervals.JournalInterval.start(indices#0) <= i#0
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(indices#0))
         && (JournalIntervals.JournalInterval.start(indices#0) <= i#0
             && i#0
               < JournalIntervals.JournalInterval.start(indices#0)
                 + JournalIntervals.JournalInterval.len(indices#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0))
         && (!(JournalIntervals.JournalInterval.start(indices#0) <= i#0
             && i#0
               < JournalIntervals.JournalInterval.start(indices#0)
                 + JournalIntervals.JournalInterval.len(indices#0))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (JournalIntervals.JournalInterval.start(indices#0)
                 <= i#0 + DiskLayout.__default.NumJournalBlocks()
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && 
                JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
                 && JournalIntervals.JournalInterval.JournalInterval_q(indices#0))
             && (JournalIntervals.JournalInterval.start(indices#0)
                   <= i#0 + DiskLayout.__default.NumJournalBlocks()
                 && i#0 + DiskLayout.__default.NumJournalBlocks()
                   < JournalIntervals.JournalInterval.start(indices#0)
                     + JournalIntervals.JournalInterval.len(indices#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(indices#0)))
         && JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0)
           == (if JournalIntervals.JournalInterval.start(indices#0) <= i#0
               && i#0
                 < JournalIntervals.JournalInterval.start(indices#0)
                   + JournalIntervals.JournalInterval.len(indices#0)
             then #Options.Option.Some(Seq#Index(newEntries#0, i#0 - JournalIntervals.JournalInterval.start(indices#0)))
             else (if JournalIntervals.JournalInterval.start(indices#0)
                   <= i#0 + DiskLayout.__default.NumJournalBlocks()
                 && i#0 + DiskLayout.__default.NumJournalBlocks()
                   < JournalIntervals.JournalInterval.start(indices#0)
                     + JournalIntervals.JournalInterval.len(indices#0)
               then #Options.Option.Some(Seq#Index(newEntries#0, 
                  i#0 + DiskLayout.__default.NumJournalBlocks()
                     - JournalIntervals.JournalInterval.start(indices#0)))
               else $Unbox(Seq#Index(journal#0, i#0)): DatatypeType)));

// definition axiom for JournalIntervals.__default.CyclicSpliceValue for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box, indices#0: DatatypeType, newEntries#0: Seq Box, i#0: int :: 
    {:weight 3} { JournalIntervals.__default.CyclicSpliceValue(Lit(journal#0), Lit(indices#0), Lit(newEntries#0), LitInt(i#0)) } 
    JournalIntervals.__default.CyclicSpliceValue#canCall(Lit(journal#0), Lit(indices#0), Lit(newEntries#0), LitInt(i#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock()))
           && 
          Lit(JournalIntervals.__default.ValidJournal(Lit(journal#0)))
           && Lit(JournalIntervals.__default.ValidJournalInterval(Lit(indices#0)))
           && LitInt(JournalIntervals.JournalInterval.len(Lit(indices#0)))
             == Seq#Length(Lit(newEntries#0))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < DiskLayout.__default.NumJournalBlocks())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
         && (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))) <= LitInt(i#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0)))
         && (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))) <= LitInt(i#0)
             && i#0
               < JournalIntervals.JournalInterval.start(Lit(indices#0))
                 + JournalIntervals.JournalInterval.len(Lit(indices#0))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0)))
         && (!(LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))) <= LitInt(i#0)
             && i#0
               < JournalIntervals.JournalInterval.start(Lit(indices#0))
                 + JournalIntervals.JournalInterval.len(Lit(indices#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
                 <= LitInt(i#0 + DiskLayout.__default.NumJournalBlocks())
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && 
                JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0)))
             && (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
                   <= LitInt(i#0 + DiskLayout.__default.NumJournalBlocks())
                 && i#0 + DiskLayout.__default.NumJournalBlocks()
                   < JournalIntervals.JournalInterval.start(Lit(indices#0))
                     + JournalIntervals.JournalInterval.len(Lit(indices#0))
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))))
         && JournalIntervals.__default.CyclicSpliceValue(Lit(journal#0), Lit(indices#0), Lit(newEntries#0), LitInt(i#0))
           == (if LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))) <= LitInt(i#0)
               && i#0
                 < JournalIntervals.JournalInterval.start(Lit(indices#0))
                   + JournalIntervals.JournalInterval.len(Lit(indices#0))
             then #Options.Option.Some(Seq#Index(Lit(newEntries#0), 
                LitInt(i#0 - JournalIntervals.JournalInterval.start(Lit(indices#0)))))
             else (if LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
                   <= LitInt(i#0 + DiskLayout.__default.NumJournalBlocks())
                 && i#0 + DiskLayout.__default.NumJournalBlocks()
                   < JournalIntervals.JournalInterval.start(Lit(indices#0))
                     + JournalIntervals.JournalInterval.len(Lit(indices#0))
               then #Options.Option.Some(Seq#Index(Lit(newEntries#0), 
                  LitInt(i#0 + DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(Lit(indices#0)))))
               else $Unbox(Seq#Index(Lit(journal#0), LitInt(i#0))): DatatypeType)));

// function declaration for JournalIntervals._default.JournalUpdate
function JournalIntervals.__default.JournalUpdate($ly: LayerType, 
    journal#0: Seq Box, 
    journal'#0: Seq Box, 
    indices#0: DatatypeType, 
    newEntries#0: Seq Box)
   : bool;

function JournalIntervals.__default.JournalUpdate#canCall(journal#0: Seq Box, 
    journal'#0: Seq Box, 
    indices#0: DatatypeType, 
    newEntries#0: Seq Box)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    journal#0: Seq Box, 
    journal'#0: Seq Box, 
    indices#0: DatatypeType, 
    newEntries#0: Seq Box :: 
  { JournalIntervals.__default.JournalUpdate($LS($ly), journal#0, journal'#0, indices#0, newEntries#0) } 
  JournalIntervals.__default.JournalUpdate($LS($ly), journal#0, journal'#0, indices#0, newEntries#0)
     == JournalIntervals.__default.JournalUpdate($ly, journal#0, journal'#0, indices#0, newEntries#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    journal#0: Seq Box, 
    journal'#0: Seq Box, 
    indices#0: DatatypeType, 
    newEntries#0: Seq Box :: 
  { JournalIntervals.__default.JournalUpdate(AsFuelBottom($ly), journal#0, journal'#0, indices#0, newEntries#0) } 
  JournalIntervals.__default.JournalUpdate($ly, journal#0, journal'#0, indices#0, newEntries#0)
     == JournalIntervals.__default.JournalUpdate($LZ, journal#0, journal'#0, indices#0, newEntries#0));

// consequence axiom for JournalIntervals.__default.JournalUpdate
axiom true
   ==> (forall $ly: LayerType, 
      journal#0: Seq Box, 
      journal'#0: Seq Box, 
      indices#0: DatatypeType, 
      newEntries#0: Seq Box :: 
    { JournalIntervals.__default.JournalUpdate($ly, journal#0, journal'#0, indices#0, newEntries#0) } 
    JournalIntervals.__default.JournalUpdate#canCall(journal#0, journal'#0, indices#0, newEntries#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> 
      JournalIntervals.__default.JournalUpdate($ly, journal#0, journal'#0, indices#0, newEntries#0)
       ==> JournalIntervals.__default.ValidJournal(journal#0)
         && JournalIntervals.__default.ValidJournal(journal'#0)
         && JournalIntervals.__default.ValidJournalInterval(indices#0)
         && JournalIntervals.JournalInterval.len(indices#0) == Seq#Length(newEntries#0));

function JournalIntervals.__default.JournalUpdate#requires(LayerType, Seq Box, Seq Box, DatatypeType, Seq Box) : bool;

// #requires axiom for JournalIntervals.__default.JournalUpdate
axiom (forall $ly: LayerType, 
    journal#0: Seq Box, 
    journal'#0: Seq Box, 
    indices#0: DatatypeType, 
    newEntries#0: Seq Box :: 
  { JournalIntervals.__default.JournalUpdate#requires($ly, journal#0, journal'#0, indices#0, newEntries#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalIntervals.__default.JournalUpdate#requires($ly, journal#0, journal'#0, indices#0, newEntries#0)
       == true);

// definition axiom for JournalIntervals.__default.JournalUpdate(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      journal#0: Seq Box, 
      journal'#0: Seq Box, 
      indices#0: DatatypeType, 
      newEntries#0: Seq Box :: 
    { JournalIntervals.__default.JournalUpdate($LS($ly), journal#0, journal'#0, indices#0, newEntries#0) } 
    JournalIntervals.__default.JournalUpdate#canCall(journal#0, journal'#0, indices#0, newEntries#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> JournalIntervals.__default.ValidJournal#canCall(journal#0)
         && (JournalIntervals.__default.ValidJournal(journal#0)
           ==> JournalIntervals.__default.ValidJournal#canCall(journal'#0))
         && (JournalIntervals.__default.ValidJournal#canCall(journal'#0)
             && JournalIntervals.__default.ValidJournal(journal'#0)
           ==> JournalIntervals.__default.ValidJournalInterval#canCall(indices#0))
         && (JournalIntervals.__default.ValidJournalInterval#canCall(indices#0)
             && JournalIntervals.__default.ValidJournalInterval(indices#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0))
         && (JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && JournalIntervals.JournalInterval.len(indices#0) == Seq#Length(newEntries#0)
           ==> (forall i#0: int :: 
            { JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0) } 
              { $Unbox(Seq#Index(journal'#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(journal#0)
               ==> $IsA#Options.Option($Unbox(Seq#Index(journal'#0, i#0)): DatatypeType)
                 && $IsA#Options.Option(JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0))
                 && JournalIntervals.__default.CyclicSpliceValue#canCall(journal#0, indices#0, newEntries#0, i#0)))
         && JournalIntervals.__default.JournalUpdate($LS($ly), journal#0, journal'#0, indices#0, newEntries#0)
           == (
            JournalIntervals.__default.ValidJournal(journal#0)
             && JournalIntervals.__default.ValidJournal(journal'#0)
             && JournalIntervals.__default.ValidJournalInterval(indices#0)
             && JournalIntervals.JournalInterval.len(indices#0) == Seq#Length(newEntries#0)
             && (forall i#0: int :: 
              { JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0) } 
                { $Unbox(Seq#Index(journal'#0, i#0)): DatatypeType } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(journal#0)
                 ==> Options.Option#Equal($Unbox(Seq#Index(journal'#0, i#0)): DatatypeType, 
                  JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#0)))));

// definition axiom for JournalIntervals.__default.JournalUpdate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      journal#0: Seq Box, 
      journal'#0: Seq Box, 
      indices#0: DatatypeType, 
      newEntries#0: Seq Box :: 
    {:weight 3} { JournalIntervals.__default.JournalUpdate($LS($ly), Lit(journal#0), Lit(journal'#0), Lit(indices#0), Lit(newEntries#0)) } 
    JournalIntervals.__default.JournalUpdate#canCall(Lit(journal#0), Lit(journal'#0), Lit(indices#0), Lit(newEntries#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(newEntries#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> JournalIntervals.__default.ValidJournal#canCall(Lit(journal#0))
         && (Lit(JournalIntervals.__default.ValidJournal(Lit(journal#0)))
           ==> JournalIntervals.__default.ValidJournal#canCall(Lit(journal'#0)))
         && (JournalIntervals.__default.ValidJournal#canCall(Lit(journal'#0))
             && Lit(JournalIntervals.__default.ValidJournal(Lit(journal'#0)))
           ==> JournalIntervals.__default.ValidJournalInterval#canCall(Lit(indices#0)))
         && (JournalIntervals.__default.ValidJournalInterval#canCall(Lit(indices#0))
             && Lit(JournalIntervals.__default.ValidJournalInterval(Lit(indices#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0)))
         && (JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && LitInt(JournalIntervals.JournalInterval.len(Lit(indices#0)))
               == Seq#Length(Lit(newEntries#0))
           ==> (forall i#1: int :: 
            { JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#1) } 
              { $Unbox(Seq#Index(journal'#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(journal#0))
               ==> $IsA#Options.Option($Unbox(Seq#Index(Lit(journal'#0), i#1)): DatatypeType)
                 && $IsA#Options.Option(JournalIntervals.__default.CyclicSpliceValue(Lit(journal#0), Lit(indices#0), Lit(newEntries#0), i#1))
                 && JournalIntervals.__default.CyclicSpliceValue#canCall(Lit(journal#0), Lit(indices#0), Lit(newEntries#0), i#1)))
         && JournalIntervals.__default.JournalUpdate($LS($ly), Lit(journal#0), Lit(journal'#0), Lit(indices#0), Lit(newEntries#0))
           == (
            JournalIntervals.__default.ValidJournal(Lit(journal#0))
             && JournalIntervals.__default.ValidJournal(Lit(journal'#0))
             && JournalIntervals.__default.ValidJournalInterval(Lit(indices#0))
             && LitInt(JournalIntervals.JournalInterval.len(Lit(indices#0)))
               == Seq#Length(Lit(newEntries#0))
             && (forall i#1: int :: 
              { JournalIntervals.__default.CyclicSpliceValue(journal#0, indices#0, newEntries#0, i#1) } 
                { $Unbox(Seq#Index(journal'#0, i#1)): DatatypeType } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(journal#0))
                 ==> Options.Option#Equal($Unbox(Seq#Index(Lit(journal'#0), i#1)): DatatypeType, 
                  JournalIntervals.__default.CyclicSpliceValue(Lit(journal#0), Lit(indices#0), Lit(newEntries#0), i#1)))));

// function declaration for JournalIntervals._default.InCyclicRange
function JournalIntervals.__default.InCyclicRange(i#0: int, indices#0: DatatypeType) : bool;

function JournalIntervals.__default.InCyclicRange#canCall(i#0: int, indices#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.InCyclicRange
axiom true
   ==> (forall i#0: int, indices#0: DatatypeType :: 
    { JournalIntervals.__default.InCyclicRange(i#0, indices#0) } 
    JournalIntervals.__default.InCyclicRange#canCall(i#0, indices#0)
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> true);

function JournalIntervals.__default.InCyclicRange#requires(int, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.InCyclicRange
axiom (forall i#0: int, indices#0: DatatypeType :: 
  { JournalIntervals.__default.InCyclicRange#requires(i#0, indices#0) } 
  $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.InCyclicRange#requires(i#0, indices#0) == true);

// definition axiom for JournalIntervals.__default.InCyclicRange(revealed)
axiom true
   ==> (forall i#0: int, indices#0: DatatypeType :: 
    { JournalIntervals.__default.InCyclicRange(i#0, indices#0) } 
    JournalIntervals.__default.InCyclicRange#canCall(i#0, indices#0)
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
         && (JournalIntervals.JournalInterval.start(indices#0) <= i#0
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(indices#0))
         && (JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && JournalIntervals.JournalInterval.start(indices#0)
                 + JournalIntervals.JournalInterval.len(indices#0)
               <= i#0
           ==> JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (JournalIntervals.JournalInterval.start(indices#0)
                 <= i#0 + DiskLayout.__default.NumJournalBlocks()
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && 
                JournalIntervals.JournalInterval.JournalInterval_q(indices#0)
                 && JournalIntervals.JournalInterval.JournalInterval_q(indices#0)))
         && JournalIntervals.__default.InCyclicRange(i#0, indices#0)
           == ((JournalIntervals.JournalInterval.start(indices#0) <= i#0
               && i#0
                 < JournalIntervals.JournalInterval.start(indices#0)
                   + JournalIntervals.JournalInterval.len(indices#0))
             || (JournalIntervals.JournalInterval.start(indices#0)
                 <= i#0 + DiskLayout.__default.NumJournalBlocks()
               && i#0 + DiskLayout.__default.NumJournalBlocks()
                 < JournalIntervals.JournalInterval.start(indices#0)
                   + JournalIntervals.JournalInterval.len(indices#0))));

// definition axiom for JournalIntervals.__default.InCyclicRange for all literals(revealed)
axiom true
   ==> (forall i#0: int, indices#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.InCyclicRange(LitInt(i#0), Lit(indices#0)) } 
    JournalIntervals.__default.InCyclicRange#canCall(LitInt(i#0), Lit(indices#0))
         || $Is(indices#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
         && (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))) <= LitInt(i#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0)))
         && (JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && !Lit(i#0
                 < JournalIntervals.JournalInterval.start(Lit(indices#0))
                   + JournalIntervals.JournalInterval.len(Lit(indices#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
                 <= LitInt(i#0 + DiskLayout.__default.NumJournalBlocks())
               ==> DiskLayout.__default.NumJournalBlocks#canCall()
                 && 
                JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(indices#0))))
         && JournalIntervals.__default.InCyclicRange(LitInt(i#0), Lit(indices#0))
           == ((LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0))) <= LitInt(i#0)
               && i#0
                 < JournalIntervals.JournalInterval.start(Lit(indices#0))
                   + JournalIntervals.JournalInterval.len(Lit(indices#0)))
             || (LitInt(JournalIntervals.JournalInterval.start(Lit(indices#0)))
                 <= LitInt(i#0 + DiskLayout.__default.NumJournalBlocks())
               && i#0 + DiskLayout.__default.NumJournalBlocks()
                 < JournalIntervals.JournalInterval.start(Lit(indices#0))
                   + JournalIntervals.JournalInterval.len(Lit(indices#0)))));

// function declaration for JournalIntervals._default.JournalFrontInterval
function JournalIntervals.__default.JournalFrontInterval(start#0: int, len#0: int) : DatatypeType;

function JournalIntervals.__default.JournalFrontInterval#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for JournalIntervals.__default.JournalFrontInterval
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { JournalIntervals.__default.JournalFrontInterval(start#0, len#0) } 
    JournalIntervals.__default.JournalFrontInterval#canCall(start#0, len#0)
         || start#0 < DiskLayout.__default.NumJournalBlocks()
       ==> $Is(JournalIntervals.__default.JournalFrontInterval(start#0, len#0), 
        Tclass.Options.Option(Tclass.JournalIntervals.JournalInterval())));

function JournalIntervals.__default.JournalFrontInterval#requires(int, int) : bool;

// #requires axiom for JournalIntervals.__default.JournalFrontInterval
axiom (forall start#0: int, len#0: int :: 
  { JournalIntervals.__default.JournalFrontInterval#requires(start#0, len#0) } 
  JournalIntervals.__default.JournalFrontInterval#requires(start#0, len#0)
     == (start#0 < DiskLayout.__default.NumJournalBlocks()));

// definition axiom for JournalIntervals.__default.JournalFrontInterval(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { JournalIntervals.__default.JournalFrontInterval(start#0, len#0) } 
    JournalIntervals.__default.JournalFrontInterval#canCall(start#0, len#0)
         || start#0 < DiskLayout.__default.NumJournalBlocks()
       ==> (len#0 != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks() - start#0 < len#0
               ==> DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.JournalFrontInterval(start#0, len#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.None()
             else #Options.Option.Some($Box(#JournalIntervals.JournalInterval.JournalInterval(start#0, 
                  (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
                     then len#0
                     else DiskLayout.__default.NumJournalBlocks() - start#0))))));

// definition axiom for JournalIntervals.__default.JournalFrontInterval for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { JournalIntervals.__default.JournalFrontInterval(LitInt(start#0), LitInt(len#0)) } 
    JournalIntervals.__default.JournalFrontInterval#canCall(LitInt(start#0), LitInt(len#0))
         || Lit(start#0 < DiskLayout.__default.NumJournalBlocks())
       ==> (LitInt(len#0) != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(DiskLayout.__default.NumJournalBlocks() - start#0) < LitInt(len#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.JournalFrontInterval(LitInt(start#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.None()
             else #Options.Option.Some($Box(#JournalIntervals.JournalInterval.JournalInterval(LitInt(start#0), 
                  (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
                     then len#0
                     else DiskLayout.__default.NumJournalBlocks() - start#0))))));

// function declaration for JournalIntervals._default.JournalBackInterval
function JournalIntervals.__default.JournalBackInterval(start#0: int, len#0: int) : DatatypeType;

function JournalIntervals.__default.JournalBackInterval#canCall(start#0: int, len#0: int) : bool;

// consequence axiom for JournalIntervals.__default.JournalBackInterval
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { JournalIntervals.__default.JournalBackInterval(start#0, len#0) } 
    JournalIntervals.__default.JournalBackInterval#canCall(start#0, len#0)
         || (start#0 < DiskLayout.__default.NumJournalBlocks()
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> $Is(JournalIntervals.__default.JournalBackInterval(start#0, len#0), 
        Tclass.Options.Option(Tclass.JournalIntervals.JournalInterval())));

function JournalIntervals.__default.JournalBackInterval#requires(int, int) : bool;

// #requires axiom for JournalIntervals.__default.JournalBackInterval
axiom (forall start#0: int, len#0: int :: 
  { JournalIntervals.__default.JournalBackInterval#requires(start#0, len#0) } 
  JournalIntervals.__default.JournalBackInterval#requires(start#0, len#0)
     == (start#0 < DiskLayout.__default.NumJournalBlocks()
       && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalIntervals.__default.JournalBackInterval(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    { JournalIntervals.__default.JournalBackInterval(start#0, len#0) } 
    JournalIntervals.__default.JournalBackInterval#canCall(start#0, len#0)
         || (start#0 < DiskLayout.__default.NumJournalBlocks()
           && len#0 <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (len#0 != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks() - start#0 < len#0
               ==> DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.JournalBackInterval(start#0, len#0)
           == (if len#0 == LitInt(0)
             then #Options.Option.None()
             else (if len#0 <= DiskLayout.__default.NumJournalBlocks() - start#0
               then #Options.Option.None()
               else #Options.Option.Some($Box(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))));

// definition axiom for JournalIntervals.__default.JournalBackInterval for all literals(revealed)
axiom true
   ==> (forall start#0: int, len#0: int :: 
    {:weight 3} { JournalIntervals.__default.JournalBackInterval(LitInt(start#0), LitInt(len#0)) } 
    JournalIntervals.__default.JournalBackInterval#canCall(LitInt(start#0), LitInt(len#0))
         || (Lit(start#0 < DiskLayout.__default.NumJournalBlocks())
           && LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> (LitInt(len#0) != LitInt(0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall()
             && (LitInt(DiskLayout.__default.NumJournalBlocks() - start#0) < LitInt(len#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalIntervals.__default.JournalBackInterval(LitInt(start#0), LitInt(len#0))
           == (if LitInt(len#0) == LitInt(0)
             then #Options.Option.None()
             else (if LitInt(len#0) <= LitInt(DiskLayout.__default.NumJournalBlocks() - start#0)
               then #Options.Option.None()
               else #Options.Option.Some($Box(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), LitInt(len#0 - (DiskLayout.__default.NumJournalBlocks() - start#0)))))))));

// function declaration for JournalIntervals._default.subinterval
function JournalIntervals.__default.subinterval(a#0: DatatypeType, b#0: DatatypeType) : bool;

function JournalIntervals.__default.subinterval#canCall(a#0: DatatypeType, b#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.subinterval
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.subinterval(a#0, b#0) } 
    JournalIntervals.__default.subinterval#canCall(a#0, b#0)
         || ($Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval()))
       ==> true);

function JournalIntervals.__default.subinterval#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.subinterval
axiom (forall a#0: DatatypeType, b#0: DatatypeType :: 
  { JournalIntervals.__default.subinterval#requires(a#0, b#0) } 
  $Is(a#0, Tclass.JournalIntervals.JournalInterval())
       && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.subinterval#requires(a#0, b#0) == true);

// definition axiom for JournalIntervals.__default.subinterval(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.subinterval(a#0, b#0) } 
    JournalIntervals.__default.subinterval#canCall(a#0, b#0)
         || ($Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval()))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
         && (JournalIntervals.JournalInterval.start(a#0)
             >= JournalIntervals.JournalInterval.start(b#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(b#0))
         && (JournalIntervals.JournalInterval.JournalInterval_q(a#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.start(b#0)
                 + JournalIntervals.JournalInterval.len(b#0)
               < JournalIntervals.JournalInterval.start(a#0)
                 + JournalIntervals.JournalInterval.len(a#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && (JournalIntervals.JournalInterval.start(a#0)
                   + DiskLayout.__default.NumJournalBlocks()
                 >= JournalIntervals.JournalInterval.start(b#0)
               ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
                 && 
                JournalIntervals.JournalInterval.JournalInterval_q(b#0)
                 && JournalIntervals.JournalInterval.JournalInterval_q(b#0)))
         && JournalIntervals.__default.subinterval(a#0, b#0)
           == ((JournalIntervals.JournalInterval.start(a#0)
                 >= JournalIntervals.JournalInterval.start(b#0)
               && JournalIntervals.JournalInterval.start(a#0)
                   + JournalIntervals.JournalInterval.len(a#0)
                 <= JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0))
             || (JournalIntervals.JournalInterval.start(a#0)
                   + DiskLayout.__default.NumJournalBlocks()
                 >= JournalIntervals.JournalInterval.start(b#0)
               && JournalIntervals.JournalInterval.start(a#0)
                   + DiskLayout.__default.NumJournalBlocks()
                   + JournalIntervals.JournalInterval.len(a#0)
                 <= JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0))));

// definition axiom for JournalIntervals.__default.subinterval for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.subinterval(Lit(a#0), Lit(b#0)) } 
    JournalIntervals.__default.subinterval#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval()))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
         && (LitInt(JournalIntervals.JournalInterval.start(Lit(a#0)))
             >= LitInt(JournalIntervals.JournalInterval.start(Lit(b#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0)))
         && (JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))
                   + JournalIntervals.JournalInterval.len(Lit(b#0)))
               < LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))
                   + JournalIntervals.JournalInterval.len(Lit(a#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && (LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))
                     + DiskLayout.__default.NumJournalBlocks())
                 >= LitInt(JournalIntervals.JournalInterval.start(Lit(b#0)))
               ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
                 && 
                JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))))
         && JournalIntervals.__default.subinterval(Lit(a#0), Lit(b#0))
           == ((LitInt(JournalIntervals.JournalInterval.start(Lit(a#0)))
                 >= LitInt(JournalIntervals.JournalInterval.start(Lit(b#0)))
               && LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))
                     + JournalIntervals.JournalInterval.len(Lit(a#0)))
                 <= LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))
                     + JournalIntervals.JournalInterval.len(Lit(b#0))))
             || (LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))
                     + DiskLayout.__default.NumJournalBlocks())
                 >= LitInt(JournalIntervals.JournalInterval.start(Lit(b#0)))
               && LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))
                     + DiskLayout.__default.NumJournalBlocks()
                     + JournalIntervals.JournalInterval.len(Lit(a#0)))
                 <= LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))
                     + JournalIntervals.JournalInterval.len(Lit(b#0))))));

// function declaration for JournalIntervals._default.journalIntervalOverlap
function JournalIntervals.__default.journalIntervalOverlap(a#0: DatatypeType, b#0: DatatypeType) : bool;

function JournalIntervals.__default.journalIntervalOverlap#canCall(a#0: DatatypeType, b#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.journalIntervalOverlap
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.journalIntervalOverlap(a#0, b#0) } 
    JournalIntervals.__default.journalIntervalOverlap#canCall(a#0, b#0)
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ContiguousJournalInterval(a#0)
           && JournalIntervals.__default.ContiguousJournalInterval(b#0))
       ==> true);

function JournalIntervals.__default.journalIntervalOverlap#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.journalIntervalOverlap
axiom (forall a#0: DatatypeType, b#0: DatatypeType :: 
  { JournalIntervals.__default.journalIntervalOverlap#requires(a#0, b#0) } 
  $Is(a#0, Tclass.JournalIntervals.JournalInterval())
       && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.journalIntervalOverlap#requires(a#0, b#0)
       == (JournalIntervals.__default.ContiguousJournalInterval(a#0)
         && JournalIntervals.__default.ContiguousJournalInterval(b#0)));

// definition axiom for JournalIntervals.__default.journalIntervalOverlap(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.journalIntervalOverlap(a#0, b#0) } 
    JournalIntervals.__default.journalIntervalOverlap#canCall(a#0, b#0)
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ContiguousJournalInterval(a#0)
           && JournalIntervals.__default.ContiguousJournalInterval(b#0))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
         && (JournalIntervals.JournalInterval.start(a#0)
               + JournalIntervals.JournalInterval.len(a#0)
             > JournalIntervals.JournalInterval.start(b#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(a#0))
         && JournalIntervals.__default.journalIntervalOverlap(a#0, b#0)
           == (JournalIntervals.JournalInterval.start(a#0)
                 + JournalIntervals.JournalInterval.len(a#0)
               > JournalIntervals.JournalInterval.start(b#0)
             && JournalIntervals.JournalInterval.start(b#0)
                 + JournalIntervals.JournalInterval.len(b#0)
               > JournalIntervals.JournalInterval.start(a#0)));

// definition axiom for JournalIntervals.__default.journalIntervalOverlap for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.journalIntervalOverlap(Lit(a#0), Lit(b#0)) } 
    JournalIntervals.__default.journalIntervalOverlap#canCall(Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Lit(JournalIntervals.__default.ContiguousJournalInterval(Lit(a#0)))
           && Lit(JournalIntervals.__default.ContiguousJournalInterval(Lit(b#0))))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
         && (Lit(JournalIntervals.JournalInterval.start(Lit(a#0))
                 + JournalIntervals.JournalInterval.len(Lit(a#0))
               > JournalIntervals.JournalInterval.start(Lit(b#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0)))
         && JournalIntervals.__default.journalIntervalOverlap(Lit(a#0), Lit(b#0))
           == Lit(JournalIntervals.JournalInterval.start(Lit(a#0))
                   + JournalIntervals.JournalInterval.len(Lit(a#0))
                 > JournalIntervals.JournalInterval.start(Lit(b#0))
               && JournalIntervals.JournalInterval.start(Lit(b#0))
                   + JournalIntervals.JournalInterval.len(Lit(b#0))
                 > JournalIntervals.JournalInterval.start(Lit(a#0))));

// function declaration for JournalIntervals._default.journalCyclicIntervalOverlap
function JournalIntervals.__default.journalCyclicIntervalOverlap(a#0: DatatypeType, b#0: DatatypeType) : bool;

function JournalIntervals.__default.journalCyclicIntervalOverlap#canCall(a#0: DatatypeType, b#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.journalCyclicIntervalOverlap
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.journalCyclicIntervalOverlap(a#0, b#0) } 
    JournalIntervals.__default.journalCyclicIntervalOverlap#canCall(a#0, b#0)
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ValidJournalInterval(a#0)
           && JournalIntervals.__default.ValidJournalInterval(b#0))
       ==> true);

function JournalIntervals.__default.journalCyclicIntervalOverlap#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.journalCyclicIntervalOverlap
axiom (forall a#0: DatatypeType, b#0: DatatypeType :: 
  { JournalIntervals.__default.journalCyclicIntervalOverlap#requires(a#0, b#0) } 
  $Is(a#0, Tclass.JournalIntervals.JournalInterval())
       && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.journalCyclicIntervalOverlap#requires(a#0, b#0)
       == (JournalIntervals.__default.ValidJournalInterval(a#0)
         && JournalIntervals.__default.ValidJournalInterval(b#0)));

// definition axiom for JournalIntervals.__default.journalCyclicIntervalOverlap(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.journalCyclicIntervalOverlap(a#0, b#0) } 
    JournalIntervals.__default.journalCyclicIntervalOverlap#canCall(a#0, b#0)
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ValidJournalInterval(a#0)
           && JournalIntervals.__default.ValidJournalInterval(b#0))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (JournalIntervals.JournalInterval.start(a#0)
               + JournalIntervals.JournalInterval.len(a#0)
             > DiskLayout.__default.NumJournalBlocks()
           ==> JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (DiskLayout.__default.NumJournalBlocks()
                 >= JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0)
               ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
                 && JournalIntervals.__default.journalIntervalOverlap#canCall(#JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(a#0), 
                    DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(a#0)), 
                  b#0)
                 && (!JournalIntervals.__default.journalIntervalOverlap(#JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(a#0), 
                      DiskLayout.__default.NumJournalBlocks()
                         - JournalIntervals.JournalInterval.start(a#0)), 
                    b#0)
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.JournalInterval_q(a#0)
                     && JournalIntervals.__default.journalIntervalOverlap#canCall(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                        JournalIntervals.JournalInterval.len(a#0)
                           - 
                          (DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(a#0))), 
                      b#0))))
         && (DiskLayout.__default.NumJournalBlocks()
             >= JournalIntervals.JournalInterval.start(a#0)
               + JournalIntervals.JournalInterval.len(a#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0)
                 > DiskLayout.__default.NumJournalBlocks()
               ==> JournalIntervals.JournalInterval.JournalInterval_q(b#0)
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
                 && JournalIntervals.__default.journalIntervalOverlap#canCall(#JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(b#0), 
                    DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(b#0)), 
                  a#0)
                 && (!JournalIntervals.__default.journalIntervalOverlap(#JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(b#0), 
                      DiskLayout.__default.NumJournalBlocks()
                         - JournalIntervals.JournalInterval.start(b#0)), 
                    a#0)
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(b#0)
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
                     && JournalIntervals.__default.journalIntervalOverlap#canCall(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                        JournalIntervals.JournalInterval.len(b#0)
                           - 
                          (DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(b#0))), 
                      a#0)))
             && (DiskLayout.__default.NumJournalBlocks()
                 >= JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0)
               ==> JournalIntervals.__default.journalIntervalOverlap#canCall(a#0, b#0)))
         && JournalIntervals.__default.journalCyclicIntervalOverlap(a#0, b#0)
           == (if JournalIntervals.JournalInterval.start(a#0)
                 + JournalIntervals.JournalInterval.len(a#0)
               > DiskLayout.__default.NumJournalBlocks()
             then (if JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0)
                 > DiskLayout.__default.NumJournalBlocks()
               then true
               else JournalIntervals.__default.journalIntervalOverlap(#JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(a#0), 
                    DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(a#0)), 
                  b#0)
                 || JournalIntervals.__default.journalIntervalOverlap(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                    JournalIntervals.JournalInterval.len(a#0)
                       - 
                      (DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(a#0))), 
                  b#0))
             else (if JournalIntervals.JournalInterval.start(b#0)
                   + JournalIntervals.JournalInterval.len(b#0)
                 > DiskLayout.__default.NumJournalBlocks()
               then JournalIntervals.__default.journalIntervalOverlap(#JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(b#0), 
                    DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(b#0)), 
                  a#0)
                 || JournalIntervals.__default.journalIntervalOverlap(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                    JournalIntervals.JournalInterval.len(b#0)
                       - 
                      (DiskLayout.__default.NumJournalBlocks()
                       - JournalIntervals.JournalInterval.start(b#0))), 
                  a#0)
               else JournalIntervals.__default.journalIntervalOverlap(a#0, b#0))));

// definition axiom for JournalIntervals.__default.journalCyclicIntervalOverlap for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.journalCyclicIntervalOverlap(Lit(a#0), Lit(b#0)) } 
    JournalIntervals.__default.journalCyclicIntervalOverlap#canCall(Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Lit(JournalIntervals.__default.ValidJournalInterval(Lit(a#0)))
           && Lit(JournalIntervals.__default.ValidJournalInterval(Lit(b#0))))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (Lit(JournalIntervals.JournalInterval.start(Lit(a#0))
                 + JournalIntervals.JournalInterval.len(Lit(a#0))
               > DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (!Lit(JournalIntervals.JournalInterval.start(Lit(b#0))
                     + JournalIntervals.JournalInterval.len(Lit(b#0))
                   > DiskLayout.__default.NumJournalBlocks())
               ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
                 && JournalIntervals.__default.journalIntervalOverlap#canCall(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))), 
                      LitInt(DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(Lit(a#0))))), 
                  Lit(b#0))
                 && (!Lit(JournalIntervals.__default.journalIntervalOverlap(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))), 
                          LitInt(DiskLayout.__default.NumJournalBlocks()
                               - JournalIntervals.JournalInterval.start(Lit(a#0))))), 
                      Lit(b#0)))
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
                     && JournalIntervals.__default.journalIntervalOverlap#canCall(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                          LitInt(JournalIntervals.JournalInterval.len(Lit(a#0))
                               - 
                              (DiskLayout.__default.NumJournalBlocks()
                               - JournalIntervals.JournalInterval.start(Lit(a#0)))))), 
                      Lit(b#0)))))
         && (!Lit(JournalIntervals.JournalInterval.start(Lit(a#0))
                 + JournalIntervals.JournalInterval.len(Lit(a#0))
               > DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && (Lit(JournalIntervals.JournalInterval.start(Lit(b#0))
                     + JournalIntervals.JournalInterval.len(Lit(b#0))
                   > DiskLayout.__default.NumJournalBlocks())
               ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
                 && 
                DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
                 && JournalIntervals.__default.journalIntervalOverlap#canCall(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))), 
                      LitInt(DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(Lit(b#0))))), 
                  Lit(a#0))
                 && (!Lit(JournalIntervals.__default.journalIntervalOverlap(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))), 
                          LitInt(DiskLayout.__default.NumJournalBlocks()
                               - JournalIntervals.JournalInterval.start(Lit(b#0))))), 
                      Lit(a#0)))
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
                     && 
                    DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
                     && JournalIntervals.__default.journalIntervalOverlap#canCall(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                          LitInt(JournalIntervals.JournalInterval.len(Lit(b#0))
                               - 
                              (DiskLayout.__default.NumJournalBlocks()
                               - JournalIntervals.JournalInterval.start(Lit(b#0)))))), 
                      Lit(a#0))))
             && (!Lit(JournalIntervals.JournalInterval.start(Lit(b#0))
                     + JournalIntervals.JournalInterval.len(Lit(b#0))
                   > DiskLayout.__default.NumJournalBlocks())
               ==> JournalIntervals.__default.journalIntervalOverlap#canCall(Lit(a#0), Lit(b#0))))
         && JournalIntervals.__default.journalCyclicIntervalOverlap(Lit(a#0), Lit(b#0))
           == (if JournalIntervals.JournalInterval.start(Lit(a#0))
                 + JournalIntervals.JournalInterval.len(Lit(a#0))
               > DiskLayout.__default.NumJournalBlocks()
             then (if JournalIntervals.JournalInterval.start(Lit(b#0))
                   + JournalIntervals.JournalInterval.len(Lit(b#0))
                 > DiskLayout.__default.NumJournalBlocks()
               then true
               else JournalIntervals.__default.journalIntervalOverlap(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))), 
                      LitInt(DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(Lit(a#0))))), 
                  Lit(b#0))
                 || JournalIntervals.__default.journalIntervalOverlap(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                      LitInt(JournalIntervals.JournalInterval.len(Lit(a#0))
                           - 
                          (DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(Lit(a#0)))))), 
                  Lit(b#0)))
             else (if JournalIntervals.JournalInterval.start(Lit(b#0))
                   + JournalIntervals.JournalInterval.len(Lit(b#0))
                 > DiskLayout.__default.NumJournalBlocks()
               then JournalIntervals.__default.journalIntervalOverlap(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))), 
                      LitInt(DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(Lit(b#0))))), 
                  Lit(a#0))
                 || JournalIntervals.__default.journalIntervalOverlap(Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                      LitInt(JournalIntervals.JournalInterval.len(Lit(b#0))
                           - 
                          (DiskLayout.__default.NumJournalBlocks()
                           - JournalIntervals.JournalInterval.start(Lit(b#0)))))), 
                  Lit(a#0))
               else JournalIntervals.__default.journalIntervalOverlap(Lit(a#0), Lit(b#0)))));

// function declaration for JournalIntervals._default.CyclicSlice
function JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    interval#0: DatatypeType)
   : Seq Box;

function JournalIntervals.__default.CyclicSlice#canCall(JournalIntervals._default.CyclicSlice$T: Ty, 
    s#0: Seq Box, 
    interval#0: DatatypeType)
   : bool;

// layer synonym axiom
axiom (forall JournalIntervals._default.CyclicSlice$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    interval#0: DatatypeType :: 
  { JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LS($ly), s#0, interval#0) } 
  JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LS($ly), s#0, interval#0)
     == JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $ly, s#0, interval#0));

// fuel synonym axiom
axiom (forall JournalIntervals._default.CyclicSlice$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    interval#0: DatatypeType :: 
  { JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, AsFuelBottom($ly), s#0, interval#0) } 
  JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $ly, s#0, interval#0)
     == JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LZ, s#0, interval#0));

// consequence axiom for JournalIntervals.__default.CyclicSlice
axiom true
   ==> (forall JournalIntervals._default.CyclicSlice$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      interval#0: DatatypeType :: 
    { JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $ly, s#0, interval#0) } 
    JournalIntervals.__default.CyclicSlice#canCall(JournalIntervals._default.CyclicSlice$T, s#0, interval#0)
         || (
          $Is(s#0, TSeq(JournalIntervals._default.CyclicSlice$T))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Seq#Length(s#0) == LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= JournalIntervals.JournalInterval.start(interval#0)
           && JournalIntervals.JournalInterval.start(interval#0)
             < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= JournalIntervals.JournalInterval.len(interval#0)
           && JournalIntervals.JournalInterval.len(interval#0)
             <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> $Is(JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $ly, s#0, interval#0), 
        TSeq(JournalIntervals._default.CyclicSlice$T)));

function JournalIntervals.__default.CyclicSlice#requires(Ty, LayerType, Seq Box, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.CyclicSlice
axiom (forall JournalIntervals._default.CyclicSlice$T: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    interval#0: DatatypeType :: 
  { JournalIntervals.__default.CyclicSlice#requires(JournalIntervals._default.CyclicSlice$T, $ly, s#0, interval#0) } 
  $Is(s#0, TSeq(JournalIntervals._default.CyclicSlice$T))
       && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.CyclicSlice#requires(JournalIntervals._default.CyclicSlice$T, $ly, s#0, interval#0)
       == (
        Seq#Length(s#0) == LitInt(DiskLayout.__default.NumJournalBlocks())
         && 
        LitInt(0) <= JournalIntervals.JournalInterval.start(interval#0)
         && JournalIntervals.JournalInterval.start(interval#0)
           < DiskLayout.__default.NumJournalBlocks()
         && 
        LitInt(0) <= JournalIntervals.JournalInterval.len(interval#0)
         && JournalIntervals.JournalInterval.len(interval#0)
           <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalIntervals.__default.CyclicSlice(revealed)
axiom true
   ==> (forall JournalIntervals._default.CyclicSlice$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      interval#0: DatatypeType :: 
    { JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LS($ly), s#0, interval#0) } 
    JournalIntervals.__default.CyclicSlice#canCall(JournalIntervals._default.CyclicSlice$T, s#0, interval#0)
         || (
          $Is(s#0, TSeq(JournalIntervals._default.CyclicSlice$T))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Seq#Length(s#0) == LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= JournalIntervals.JournalInterval.start(interval#0)
           && JournalIntervals.JournalInterval.start(interval#0)
             < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= JournalIntervals.JournalInterval.len(interval#0)
           && JournalIntervals.JournalInterval.len(interval#0)
             <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (JournalIntervals.JournalInterval.start(interval#0)
               + JournalIntervals.JournalInterval.len(interval#0)
             <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(interval#0))
         && (LitInt(DiskLayout.__default.NumJournalBlocks())
             < JournalIntervals.JournalInterval.start(interval#0)
               + JournalIntervals.JournalInterval.len(interval#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LS($ly), s#0, interval#0)
           == (if JournalIntervals.JournalInterval.start(interval#0)
                 + JournalIntervals.JournalInterval.len(interval#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then Seq#Drop(Seq#Take(s#0, 
                JournalIntervals.JournalInterval.start(interval#0)
                   + JournalIntervals.JournalInterval.len(interval#0)), 
              JournalIntervals.JournalInterval.start(interval#0))
             else Seq#Append(Seq#Drop(s#0, JournalIntervals.JournalInterval.start(interval#0)), 
              Seq#Take(s#0, 
                JournalIntervals.JournalInterval.start(interval#0)
                     + JournalIntervals.JournalInterval.len(interval#0)
                   - DiskLayout.__default.NumJournalBlocks()))));

// definition axiom for JournalIntervals.__default.CyclicSlice for all literals(revealed)
axiom true
   ==> (forall JournalIntervals._default.CyclicSlice$T: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      interval#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LS($ly), Lit(s#0), Lit(interval#0)) } 
    JournalIntervals.__default.CyclicSlice#canCall(JournalIntervals._default.CyclicSlice$T, Lit(s#0), Lit(interval#0))
         || (
          $Is(s#0, TSeq(JournalIntervals._default.CyclicSlice$T))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Seq#Length(Lit(s#0)) == LitInt(DiskLayout.__default.NumJournalBlocks())
           && 
          LitInt(0) <= LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0)))
           && JournalIntervals.JournalInterval.start(Lit(interval#0))
             < DiskLayout.__default.NumJournalBlocks()
           && 
          LitInt(0) <= LitInt(JournalIntervals.JournalInterval.len(Lit(interval#0)))
           && LitInt(JournalIntervals.JournalInterval.len(Lit(interval#0)))
             <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0))
                 + JournalIntervals.JournalInterval.len(Lit(interval#0)))
             <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0)))
         && (LitInt(DiskLayout.__default.NumJournalBlocks())
             < LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0))
                 + JournalIntervals.JournalInterval.len(Lit(interval#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && 
            JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && JournalIntervals.__default.CyclicSlice(JournalIntervals._default.CyclicSlice$T, $LS($ly), Lit(s#0), Lit(interval#0))
           == (if LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0))
                   + JournalIntervals.JournalInterval.len(Lit(interval#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             then Seq#Drop(Seq#Take(Lit(s#0), 
                LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0))
                     + JournalIntervals.JournalInterval.len(Lit(interval#0)))), 
              LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0))))
             else Seq#Append(Seq#Drop(Lit(s#0), LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0)))), 
              Seq#Take(Lit(s#0), 
                LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0))
                       + JournalIntervals.JournalInterval.len(Lit(interval#0))
                     - DiskLayout.__default.NumJournalBlocks())))));

// function declaration for JournalIntervals._default.fullRange
function JournalIntervals.__default.fullRange(s#0: Seq Box) : bool;

function JournalIntervals.__default.fullRange#canCall(s#0: Seq Box) : bool;

// consequence axiom for JournalIntervals.__default.fullRange
axiom true
   ==> (forall s#0: Seq Box :: 
    { JournalIntervals.__default.fullRange(s#0) } 
    JournalIntervals.__default.fullRange#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       ==> true);

function JournalIntervals.__default.fullRange#requires(Seq Box) : bool;

// #requires axiom for JournalIntervals.__default.fullRange
axiom (forall s#0: Seq Box :: 
  { JournalIntervals.__default.fullRange#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
     ==> JournalIntervals.__default.fullRange#requires(s#0) == true);

// definition axiom for JournalIntervals.__default.fullRange(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { JournalIntervals.__default.fullRange(s#0) } 
    JournalIntervals.__default.fullRange#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       ==> JournalIntervals.__default.fullRange(s#0)
         == (forall i#0: int :: 
          { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
             ==> Options.Option.Some_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)));

// definition axiom for JournalIntervals.__default.fullRange for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { JournalIntervals.__default.fullRange(Lit(s#0)) } 
    JournalIntervals.__default.fullRange#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       ==> JournalIntervals.__default.fullRange(Lit(s#0))
         == (forall i#1: int :: 
          { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(s#0))
             ==> Options.Option.Some_q($Unbox(Seq#Index(Lit(s#0), i#1)): DatatypeType)));

// function declaration for JournalIntervals._default.concatFold
function JournalIntervals.__default.concatFold($ly: LayerType, s#0: Seq Box) : Seq Box;

function JournalIntervals.__default.concatFold#canCall(s#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalIntervals.__default.concatFold($LS($ly), s#0) } 
  JournalIntervals.__default.concatFold($LS($ly), s#0)
     == JournalIntervals.__default.concatFold($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalIntervals.__default.concatFold(AsFuelBottom($ly), s#0) } 
  JournalIntervals.__default.concatFold($ly, s#0)
     == JournalIntervals.__default.concatFold($LZ, s#0));

// consequence axiom for JournalIntervals.__default.concatFold
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalIntervals.__default.concatFold($ly, s#0) } 
    JournalIntervals.__default.concatFold#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && JournalIntervals.__default.fullRange(s#0))
       ==> Seq#Length(JournalIntervals.__default.concatFold($ly, s#0)) == Seq#Length(s#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            { Seq#Index(JournalIntervals.__default.concatFold($ly, s#0), i#0) } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
             ==> Options.Option#Equal(#Options.Option.Some(Seq#Index(JournalIntervals.__default.concatFold($ly, s#0), i#0)), 
              $Unbox(Seq#Index(s#0, i#0)): DatatypeType))
         && $Is(JournalIntervals.__default.concatFold($ly, s#0), 
          TSeq(Tclass.JournalRanges.JournalBlock())));

function JournalIntervals.__default.concatFold#requires(LayerType, Seq Box) : bool;

// #requires axiom for JournalIntervals.__default.concatFold
axiom (forall $ly: LayerType, s#0: Seq Box :: 
  { JournalIntervals.__default.concatFold#requires($ly, s#0) } 
  $Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
     ==> JournalIntervals.__default.concatFold#requires($ly, s#0)
       == JournalIntervals.__default.fullRange(s#0));

// definition axiom for JournalIntervals.__default.concatFold(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    { JournalIntervals.__default.concatFold($LS($ly), s#0) } 
    JournalIntervals.__default.concatFold#canCall(s#0)
         || ($Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && JournalIntervals.__default.fullRange(s#0))
       ==> (!Seq#Equal(s#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), s#0)
             && JournalIntervals.__default.concatFold#canCall(Sequences.__default.DropLast(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), s#0))
             && Sequences.__default.Last#canCall(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), s#0))
         && JournalIntervals.__default.concatFold($LS($ly), s#0)
           == (if Seq#Equal(s#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(JournalIntervals.__default.concatFold($ly, 
                Sequences.__default.DropLast(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), s#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                Options.Option.value($Unbox(Sequences.__default.Last(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), s#0)): DatatypeType)))));

// definition axiom for JournalIntervals.__default.concatFold for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box :: 
    {:weight 3} { JournalIntervals.__default.concatFold($LS($ly), Lit(s#0)) } 
    JournalIntervals.__default.concatFold#canCall(Lit(s#0))
         || ($Is(s#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && Lit(JournalIntervals.__default.fullRange(Lit(s#0))))
       ==> (!Seq#Equal(s#0, Seq#Empty(): Seq Box)
           ==> Sequences.__default.DropLast#canCall(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), Lit(s#0))
             && JournalIntervals.__default.concatFold#canCall(Lit(Sequences.__default.DropLast(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), Lit(s#0))))
             && Sequences.__default.Last#canCall(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), Lit(s#0)))
         && JournalIntervals.__default.concatFold($LS($ly), Lit(s#0))
           == (if Seq#Equal(s#0, Seq#Empty(): Seq Box)
             then Seq#Empty(): Seq Box
             else Seq#Append(JournalIntervals.__default.concatFold($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), Lit(s#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                Lit(Options.Option.value(Lit($Unbox(Sequences.__default.Last(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()), Lit(s#0))): DatatypeType)))))));

// function declaration for JournalIntervals._default.Disk_HasJournalRange
function JournalIntervals.__default.Disk__HasJournalRange(journal#0: Seq Box, interval#0: DatatypeType) : bool;

function JournalIntervals.__default.Disk__HasJournalRange#canCall(journal#0: Seq Box, interval#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.Disk__HasJournalRange
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__HasJournalRange(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__HasJournalRange#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && JournalIntervals.__default.ValidJournalInterval(interval#0))
       ==> true);

function JournalIntervals.__default.Disk__HasJournalRange#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.Disk__HasJournalRange
axiom (forall journal#0: Seq Box, interval#0: DatatypeType :: 
  { JournalIntervals.__default.Disk__HasJournalRange#requires(journal#0, interval#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.Disk__HasJournalRange#requires(journal#0, interval#0)
       == JournalIntervals.__default.ValidJournalInterval(interval#0));

// definition axiom for JournalIntervals.__default.Disk__HasJournalRange(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__HasJournalRange(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__HasJournalRange#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && JournalIntervals.__default.ValidJournalInterval(interval#0))
       ==> true);

// definition axiom for JournalIntervals.__default.Disk__HasJournalRange for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.Disk__HasJournalRange(Lit(journal#0), Lit(interval#0)) } 
    JournalIntervals.__default.Disk__HasJournalRange#canCall(Lit(journal#0), Lit(interval#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && Lit(JournalIntervals.__default.ValidJournalInterval(Lit(interval#0))))
       ==> true);

// function declaration for JournalIntervals._default.Disk_JournalRange
function JournalIntervals.__default.Disk__JournalRange(journal#0: Seq Box, interval#0: DatatypeType) : Seq Box;

function JournalIntervals.__default.Disk__JournalRange#canCall(journal#0: Seq Box, interval#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.Disk__JournalRange
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__JournalRange(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__JournalRange#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ValidJournalInterval(interval#0)
           && JournalIntervals.__default.Disk__HasJournalRange(journal#0, interval#0))
       ==> $Is(JournalIntervals.__default.Disk__JournalRange(journal#0, interval#0), 
        TSeq(Tclass.JournalRanges.JournalBlock())));

function JournalIntervals.__default.Disk__JournalRange#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.Disk__JournalRange
axiom (forall journal#0: Seq Box, interval#0: DatatypeType :: 
  { JournalIntervals.__default.Disk__JournalRange#requires(journal#0, interval#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.Disk__JournalRange#requires(journal#0, interval#0)
       == (JournalIntervals.__default.ValidJournalInterval(interval#0)
         && JournalIntervals.__default.Disk__HasJournalRange(journal#0, interval#0)));

// definition axiom for JournalIntervals.__default.Disk__JournalRange(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__JournalRange(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__JournalRange#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ValidJournalInterval(interval#0)
           && JournalIntervals.__default.Disk__HasJournalRange(journal#0, interval#0))
       ==> true);

// definition axiom for JournalIntervals.__default.Disk__JournalRange for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.Disk__JournalRange(Lit(journal#0), Lit(interval#0)) } 
    JournalIntervals.__default.Disk__JournalRange#canCall(Lit(journal#0), Lit(interval#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Lit(JournalIntervals.__default.ValidJournalInterval(Lit(interval#0)))
           && Lit(JournalIntervals.__default.Disk__HasJournalRange(Lit(journal#0), Lit(interval#0))))
       ==> true);

// function declaration for JournalIntervals._default.Disk_HasJournal
function JournalIntervals.__default.Disk__HasJournal(journal#0: Seq Box, interval#0: DatatypeType) : bool;

function JournalIntervals.__default.Disk__HasJournal#canCall(journal#0: Seq Box, interval#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.Disk__HasJournal
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__HasJournal(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__HasJournal#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && JournalIntervals.__default.ValidJournalInterval(interval#0))
       ==> true);

function JournalIntervals.__default.Disk__HasJournal#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.Disk__HasJournal
axiom (forall journal#0: Seq Box, interval#0: DatatypeType :: 
  { JournalIntervals.__default.Disk__HasJournal#requires(journal#0, interval#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.Disk__HasJournal#requires(journal#0, interval#0)
       == JournalIntervals.__default.ValidJournalInterval(interval#0));

// definition axiom for JournalIntervals.__default.Disk__HasJournal(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__HasJournal(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__HasJournal#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && JournalIntervals.__default.ValidJournalInterval(interval#0))
       ==> true);

// definition axiom for JournalIntervals.__default.Disk__HasJournal for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.Disk__HasJournal(Lit(journal#0), Lit(interval#0)) } 
    JournalIntervals.__default.Disk__HasJournal#canCall(Lit(journal#0), Lit(interval#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && Lit(JournalIntervals.__default.ValidJournalInterval(Lit(interval#0))))
       ==> true);

// function declaration for JournalIntervals._default.Disk_Journal
function JournalIntervals.__default.Disk__Journal(journal#0: Seq Box, interval#0: DatatypeType) : Seq Box;

function JournalIntervals.__default.Disk__Journal#canCall(journal#0: Seq Box, interval#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.Disk__Journal
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__Journal(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__Journal#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ValidJournalInterval(interval#0)
           && JournalIntervals.__default.Disk__HasJournal(journal#0, interval#0))
       ==> $Is(JournalIntervals.__default.Disk__Journal(journal#0, interval#0), 
        TSeq(Tclass.Journal.JournalEntry())));

function JournalIntervals.__default.Disk__Journal#requires(Seq Box, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.Disk__Journal
axiom (forall journal#0: Seq Box, interval#0: DatatypeType :: 
  { JournalIntervals.__default.Disk__Journal#requires(journal#0, interval#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.Disk__Journal#requires(journal#0, interval#0)
       == (JournalIntervals.__default.ValidJournalInterval(interval#0)
         && JournalIntervals.__default.Disk__HasJournal(journal#0, interval#0)));

// definition axiom for JournalIntervals.__default.Disk__Journal(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    { JournalIntervals.__default.Disk__Journal(journal#0, interval#0) } 
    JournalIntervals.__default.Disk__Journal#canCall(journal#0, interval#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          JournalIntervals.__default.ValidJournalInterval(interval#0)
           && JournalIntervals.__default.Disk__HasJournal(journal#0, interval#0))
       ==> true);

// definition axiom for JournalIntervals.__default.Disk__Journal for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box, interval#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.Disk__Journal(Lit(journal#0), Lit(interval#0)) } 
    JournalIntervals.__default.Disk__Journal#canCall(Lit(journal#0), Lit(interval#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
           && 
          Lit(JournalIntervals.__default.ValidJournalInterval(Lit(interval#0)))
           && Lit(JournalIntervals.__default.Disk__HasJournal(Lit(journal#0), Lit(interval#0))))
       ==> true);

// function declaration for JournalIntervals._default.NextStartPoint
function JournalIntervals.__default.NextStartPoint(interval#0: DatatypeType) : int;

function JournalIntervals.__default.NextStartPoint#canCall(interval#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.NextStartPoint
axiom true
   ==> (forall interval#0: DatatypeType :: 
    { JournalIntervals.__default.NextStartPoint(interval#0) } 
    JournalIntervals.__default.NextStartPoint#canCall(interval#0)
         || $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
       ==> true);

function JournalIntervals.__default.NextStartPoint#requires(DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.NextStartPoint
axiom (forall interval#0: DatatypeType :: 
  { JournalIntervals.__default.NextStartPoint#requires(interval#0) } 
  $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.NextStartPoint#requires(interval#0) == true);

// definition axiom for JournalIntervals.__default.NextStartPoint(revealed)
axiom true
   ==> (forall interval#0: DatatypeType :: 
    { JournalIntervals.__default.NextStartPoint(interval#0) } 
    JournalIntervals.__default.NextStartPoint#canCall(interval#0)
         || $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (JournalIntervals.JournalInterval.start(interval#0)
               + JournalIntervals.JournalInterval.len(interval#0)
             < DiskLayout.__default.NumJournalBlocks()
           ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(interval#0))
         && (DiskLayout.__default.NumJournalBlocks()
             <= JournalIntervals.JournalInterval.start(interval#0)
               + JournalIntervals.JournalInterval.len(interval#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && JournalIntervals.__default.NextStartPoint(interval#0)
           == (if JournalIntervals.JournalInterval.start(interval#0)
                 + JournalIntervals.JournalInterval.len(interval#0)
               < DiskLayout.__default.NumJournalBlocks()
             then JournalIntervals.JournalInterval.start(interval#0)
               + JournalIntervals.JournalInterval.len(interval#0)
             else JournalIntervals.JournalInterval.start(interval#0)
                 + JournalIntervals.JournalInterval.len(interval#0)
               - DiskLayout.__default.NumJournalBlocks()));

// definition axiom for JournalIntervals.__default.NextStartPoint for all literals(revealed)
axiom true
   ==> (forall interval#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.NextStartPoint(Lit(interval#0)) } 
    JournalIntervals.__default.NextStartPoint#canCall(Lit(interval#0))
         || $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (Lit(JournalIntervals.JournalInterval.start(Lit(interval#0))
                 + JournalIntervals.JournalInterval.len(Lit(interval#0))
               < DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0)))
         && (!Lit(JournalIntervals.JournalInterval.start(Lit(interval#0))
                 + JournalIntervals.JournalInterval.len(Lit(interval#0))
               < DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && JournalIntervals.__default.NextStartPoint(Lit(interval#0))
           == (if JournalIntervals.JournalInterval.start(Lit(interval#0))
                 + JournalIntervals.JournalInterval.len(Lit(interval#0))
               < DiskLayout.__default.NumJournalBlocks()
             then JournalIntervals.JournalInterval.start(Lit(interval#0))
               + JournalIntervals.JournalInterval.len(Lit(interval#0))
             else JournalIntervals.JournalInterval.start(Lit(interval#0))
                 + JournalIntervals.JournalInterval.len(Lit(interval#0))
               - DiskLayout.__default.NumJournalBlocks()));

// function declaration for JournalIntervals._default.concatIntervals
function JournalIntervals.__default.concatIntervals(a#0: DatatypeType, b#0: DatatypeType) : DatatypeType;

function JournalIntervals.__default.concatIntervals#canCall(a#0: DatatypeType, b#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.concatIntervals
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.concatIntervals(a#0, b#0) } 
    JournalIntervals.__default.concatIntervals#canCall(a#0, b#0)
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && JournalIntervals.__default.NextStartPoint(a#0)
             == JournalIntervals.JournalInterval.start(b#0))
       ==> $Is(JournalIntervals.__default.concatIntervals(a#0, b#0), 
        Tclass.JournalIntervals.JournalInterval()));

function JournalIntervals.__default.concatIntervals#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.concatIntervals
axiom (forall a#0: DatatypeType, b#0: DatatypeType :: 
  { JournalIntervals.__default.concatIntervals#requires(a#0, b#0) } 
  $Is(a#0, Tclass.JournalIntervals.JournalInterval())
       && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalIntervals.__default.concatIntervals#requires(a#0, b#0)
       == 
      (JournalIntervals.__default.NextStartPoint(a#0)
       == JournalIntervals.JournalInterval.start(b#0)));

// definition axiom for JournalIntervals.__default.concatIntervals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    { JournalIntervals.__default.concatIntervals(a#0, b#0) } 
    JournalIntervals.__default.concatIntervals#canCall(a#0, b#0)
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && JournalIntervals.__default.NextStartPoint(a#0)
             == JournalIntervals.JournalInterval.start(b#0))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && 
        JournalIntervals.JournalInterval.JournalInterval_q(a#0)
         && JournalIntervals.JournalInterval.JournalInterval_q(b#0)
         && JournalIntervals.__default.concatIntervals(a#0, b#0)
           == #JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(a#0), 
            JournalIntervals.JournalInterval.len(a#0)
               + JournalIntervals.JournalInterval.len(b#0)));

// definition axiom for JournalIntervals.__default.concatIntervals for all literals(revealed)
axiom true
   ==> (forall a#0: DatatypeType, b#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.concatIntervals(Lit(a#0), Lit(b#0)) } 
    JournalIntervals.__default.concatIntervals#canCall(Lit(a#0), Lit(b#0))
         || (
          $Is(a#0, Tclass.JournalIntervals.JournalInterval())
           && $Is(b#0, Tclass.JournalIntervals.JournalInterval())
           && LitInt(JournalIntervals.__default.NextStartPoint(Lit(a#0)))
             == LitInt(JournalIntervals.JournalInterval.start(Lit(b#0))))
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && 
        JournalIntervals.JournalInterval.JournalInterval_q(Lit(a#0))
         && JournalIntervals.JournalInterval.JournalInterval_q(Lit(b#0))
         && JournalIntervals.__default.concatIntervals(Lit(a#0), Lit(b#0))
           == Lit(#JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalIntervals.JournalInterval.start(Lit(a#0))), 
              LitInt(JournalIntervals.JournalInterval.len(Lit(a#0))
                   + JournalIntervals.JournalInterval.len(Lit(b#0))))));

// function declaration for JournalIntervals._default.JournalIntervalOfLocation
function JournalIntervals.__default.JournalIntervalOfLocation(loc#0: DatatypeType) : DatatypeType;

function JournalIntervals.__default.JournalIntervalOfLocation#canCall(loc#0: DatatypeType) : bool;

// consequence axiom for JournalIntervals.__default.JournalIntervalOfLocation
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { JournalIntervals.__default.JournalIntervalOfLocation(loc#0) } 
    JournalIntervals.__default.JournalIntervalOfLocation#canCall(loc#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
       ==> JournalIntervals.__default.ContiguousJournalInterval(JournalIntervals.__default.JournalIntervalOfLocation(loc#0))
         && DiskLayout.Location#Equal(DiskLayout.__default.JournalRangeLocation(JournalIntervals.JournalInterval.start(JournalIntervals.__default.JournalIntervalOfLocation(loc#0)), 
            JournalIntervals.JournalInterval.len(JournalIntervals.__default.JournalIntervalOfLocation(loc#0))), 
          loc#0)
         && $Is(JournalIntervals.__default.JournalIntervalOfLocation(loc#0), 
          Tclass.JournalIntervals.JournalInterval()));

function JournalIntervals.__default.JournalIntervalOfLocation#requires(DatatypeType) : bool;

// #requires axiom for JournalIntervals.__default.JournalIntervalOfLocation
axiom (forall loc#0: DatatypeType :: 
  { JournalIntervals.__default.JournalIntervalOfLocation#requires(loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> JournalIntervals.__default.JournalIntervalOfLocation#requires(loc#0)
       == DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0));

// definition axiom for JournalIntervals.__default.JournalIntervalOfLocation(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    { JournalIntervals.__default.JournalIntervalOfLocation(loc#0) } 
    JournalIntervals.__default.JournalIntervalOfLocation#canCall(loc#0)
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, loc#0))
       ==> true);

// definition axiom for JournalIntervals.__default.JournalIntervalOfLocation for all literals(revealed)
axiom true
   ==> (forall loc#0: DatatypeType :: 
    {:weight 3} { JournalIntervals.__default.JournalIntervalOfLocation(Lit(loc#0)) } 
    JournalIntervals.__default.JournalIntervalOfLocation#canCall(Lit(loc#0))
         || ($Is(loc#0, Tclass.DiskLayout.Location())
           && DiskLayout.__default.ValidJournalLocation(StartFuel_DiskLayout._default.ValidJournalLocation, Lit(loc#0)))
       ==> true);

// Constructor function declaration
function #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(DatatypeType) : DatatypeType;

const unique ##JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#0#0#0) } 
  DatatypeCtorId(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#0#0#0))
     == ##JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock);

function JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d) } 
  JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d) } 
  JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d)
     ==> (exists a#1#0#0: DatatypeType :: 
      d == #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#1#0#0)));

function Tclass.JournalDisk.ReqWriteSuperblock() : Ty;

// Tclass.JournalDisk.ReqWriteSuperblock Tag
axiom Tag(Tclass.JournalDisk.ReqWriteSuperblock())
   == Tagclass.JournalDisk.ReqWriteSuperblock;

const unique Tagclass.JournalDisk.ReqWriteSuperblock: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.ReqWriteSuperblock
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.ReqWriteSuperblock()) } 
  $IsBox(bx, Tclass.JournalDisk.ReqWriteSuperblock())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.ReqWriteSuperblock()));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType :: 
  { $Is(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#2#0#0), 
      Tclass.JournalDisk.ReqWriteSuperblock()) } 
  $Is(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#2#0#0), 
      Tclass.JournalDisk.ReqWriteSuperblock())
     <==> $Is(a#2#0#0, Tclass.SectorType.Superblock()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#3#0#0), 
      Tclass.JournalDisk.ReqWriteSuperblock(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#3#0#0), 
        Tclass.JournalDisk.ReqWriteSuperblock(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.SectorType.Superblock(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.ReqWriteSuperblock.superblock(d), Tclass.SectorType.Superblock(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.ReqWriteSuperblock(), $h)
     ==> $IsAlloc(JournalDisk.ReqWriteSuperblock.superblock(d), Tclass.SectorType.Superblock(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(Lit(a#4#0#0)) } 
  #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(Lit(a#4#0#0))
     == Lit(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#4#0#0)));

function JournalDisk.ReqWriteSuperblock.superblock(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#5#0#0) } 
  JournalDisk.ReqWriteSuperblock.superblock(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#5#0#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#6#0#0) } 
  DtRank(a#6#0#0)
     < DtRank(#JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock(a#6#0#0)));

// Depth-one case-split function
function $IsA#JournalDisk.ReqWriteSuperblock(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.ReqWriteSuperblock(d) } 
  $IsA#JournalDisk.ReqWriteSuperblock(d)
     ==> JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d), $Is(d, Tclass.JournalDisk.ReqWriteSuperblock()) } 
  $Is(d, Tclass.JournalDisk.ReqWriteSuperblock())
     ==> JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(d));

// Datatype extensional equality declaration
function JournalDisk.ReqWriteSuperblock#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblock#Equal(a, b) } 
  true
     ==> (JournalDisk.ReqWriteSuperblock#Equal(a, b)
       <==> SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(a), 
        JournalDisk.ReqWriteSuperblock.superblock(b))));

// Datatype extensionality axiom: JournalDisk.ReqWriteSuperblock
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblock#Equal(a, b) } 
  JournalDisk.ReqWriteSuperblock#Equal(a, b) <==> a == b);

const unique class.JournalDisk.ReqWriteSuperblock: ClassName;

// Constructor function declaration
function #JournalDisk.ReqWriteJournal.ReqWriteJournal(int, Seq Box) : DatatypeType;

const unique ##JournalDisk.ReqWriteJournal.ReqWriteJournal: DtCtorId;

// Constructor identifier
axiom (forall a#7#0#0: int, a#7#1#0: Seq Box :: 
  { #JournalDisk.ReqWriteJournal.ReqWriteJournal(a#7#0#0, a#7#1#0) } 
  DatatypeCtorId(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#7#0#0, a#7#1#0))
     == ##JournalDisk.ReqWriteJournal.ReqWriteJournal);

function JournalDisk.ReqWriteJournal.ReqWriteJournal_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d) } 
  JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.ReqWriteJournal.ReqWriteJournal);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d) } 
  JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d)
     ==> (exists a#8#0#0: int, a#8#1#0: Seq Box :: 
      d == #JournalDisk.ReqWriteJournal.ReqWriteJournal(a#8#0#0, a#8#1#0)));

function Tclass.JournalDisk.ReqWriteJournal() : Ty;

// Tclass.JournalDisk.ReqWriteJournal Tag
axiom Tag(Tclass.JournalDisk.ReqWriteJournal())
   == Tagclass.JournalDisk.ReqWriteJournal;

const unique Tagclass.JournalDisk.ReqWriteJournal: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.ReqWriteJournal
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.ReqWriteJournal()) } 
  $IsBox(bx, Tclass.JournalDisk.ReqWriteJournal())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.ReqWriteJournal()));

// Constructor $Is
axiom (forall a#9#0#0: int, a#9#1#0: Seq Box :: 
  { $Is(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#9#0#0, a#9#1#0), 
      Tclass.JournalDisk.ReqWriteJournal()) } 
  $Is(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#9#0#0, a#9#1#0), 
      Tclass.JournalDisk.ReqWriteJournal())
     <==> $Is(a#9#0#0, TInt) && $Is(a#9#1#0, TSeq(Tclass.JournalRanges.JournalBlock())));

// Constructor $IsAlloc
axiom (forall a#10#0#0: int, a#10#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#10#0#0, a#10#1#0), 
      Tclass.JournalDisk.ReqWriteJournal(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#10#0#0, a#10#1#0), 
        Tclass.JournalDisk.ReqWriteJournal(), 
        $h)
       <==> $IsAlloc(a#10#0#0, TInt, $h)
         && $IsAlloc(a#10#1#0, TSeq(Tclass.JournalRanges.JournalBlock()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.ReqWriteJournal.start(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.ReqWriteJournal(), $h)
     ==> $IsAlloc(JournalDisk.ReqWriteJournal.start(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.ReqWriteJournal.journal(d), 
      TSeq(Tclass.JournalRanges.JournalBlock()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.ReqWriteJournal(), $h)
     ==> $IsAlloc(JournalDisk.ReqWriteJournal.journal(d), 
      TSeq(Tclass.JournalRanges.JournalBlock()), 
      $h));

// Constructor literal
axiom (forall a#11#0#0: int, a#11#1#0: Seq Box :: 
  { #JournalDisk.ReqWriteJournal.ReqWriteJournal(LitInt(a#11#0#0), Lit(a#11#1#0)) } 
  #JournalDisk.ReqWriteJournal.ReqWriteJournal(LitInt(a#11#0#0), Lit(a#11#1#0))
     == Lit(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#11#0#0, a#11#1#0)));

function JournalDisk.ReqWriteJournal.start(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#12#0#0: int, a#12#1#0: Seq Box :: 
  { #JournalDisk.ReqWriteJournal.ReqWriteJournal(a#12#0#0, a#12#1#0) } 
  JournalDisk.ReqWriteJournal.start(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#12#0#0, a#12#1#0))
     == a#12#0#0);

function JournalDisk.ReqWriteJournal.journal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#13#0#0: int, a#13#1#0: Seq Box :: 
  { #JournalDisk.ReqWriteJournal.ReqWriteJournal(a#13#0#0, a#13#1#0) } 
  JournalDisk.ReqWriteJournal.journal(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#13#0#0, a#13#1#0))
     == a#13#1#0);

// Inductive seq element rank
axiom (forall a#14#0#0: int, a#14#1#0: Seq Box, i: int :: 
  { Seq#Index(a#14#1#0, i), #JournalDisk.ReqWriteJournal.ReqWriteJournal(a#14#0#0, a#14#1#0) } 
  0 <= i && i < Seq#Length(a#14#1#0)
     ==> DtRank($Unbox(Seq#Index(a#14#1#0, i)): DatatypeType)
       < DtRank(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#14#0#0, a#14#1#0)));

// Inductive seq rank
axiom (forall a#15#0#0: int, a#15#1#0: Seq Box :: 
  { #JournalDisk.ReqWriteJournal.ReqWriteJournal(a#15#0#0, a#15#1#0) } 
  Seq#Rank(a#15#1#0)
     < DtRank(#JournalDisk.ReqWriteJournal.ReqWriteJournal(a#15#0#0, a#15#1#0)));

// Depth-one case-split function
function $IsA#JournalDisk.ReqWriteJournal(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.ReqWriteJournal(d) } 
  $IsA#JournalDisk.ReqWriteJournal(d)
     ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d), $Is(d, Tclass.JournalDisk.ReqWriteJournal()) } 
  $Is(d, Tclass.JournalDisk.ReqWriteJournal())
     ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(d));

// Datatype extensional equality declaration
function JournalDisk.ReqWriteJournal#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.ReqWriteJournal.ReqWriteJournal
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.ReqWriteJournal#Equal(a, b) } 
  true
     ==> (JournalDisk.ReqWriteJournal#Equal(a, b)
       <==> JournalDisk.ReqWriteJournal.start(a) == JournalDisk.ReqWriteJournal.start(b)
         && Seq#Equal(JournalDisk.ReqWriteJournal.journal(a), JournalDisk.ReqWriteJournal.journal(b))));

// Datatype extensionality axiom: JournalDisk.ReqWriteJournal
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.ReqWriteJournal#Equal(a, b) } 
  JournalDisk.ReqWriteJournal#Equal(a, b) <==> a == b);

const unique class.JournalDisk.ReqWriteJournal: ClassName;

// Constructor function declaration
function #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(int, DatatypeType) : DatatypeType;

const unique ##JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId: DtCtorId;

// Constructor identifier
axiom (forall a#16#0#0: int, a#16#1#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#16#0#0, a#16#1#0) } 
  DatatypeCtorId(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#16#0#0, a#16#1#0))
     == ##JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId);

function JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d) } 
  JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d) } 
  JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d)
     ==> (exists a#17#0#0: int, a#17#1#0: DatatypeType :: 
      d == #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#17#0#0, a#17#1#0)));

function Tclass.JournalDisk.ReqWriteSuperblockId() : Ty;

// Tclass.JournalDisk.ReqWriteSuperblockId Tag
axiom Tag(Tclass.JournalDisk.ReqWriteSuperblockId())
   == Tagclass.JournalDisk.ReqWriteSuperblockId;

const unique Tagclass.JournalDisk.ReqWriteSuperblockId: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.ReqWriteSuperblockId
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.ReqWriteSuperblockId()) } 
  $IsBox(bx, Tclass.JournalDisk.ReqWriteSuperblockId())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.ReqWriteSuperblockId()));

// Constructor $Is
axiom (forall a#18#0#0: int, a#18#1#0: DatatypeType :: 
  { $Is(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#18#0#0, a#18#1#0), 
      Tclass.JournalDisk.ReqWriteSuperblockId()) } 
  $Is(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#18#0#0, a#18#1#0), 
      Tclass.JournalDisk.ReqWriteSuperblockId())
     <==> $Is(a#18#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#18#1#0, Tclass.JournalDisk.ReqWriteSuperblock()));

// Constructor $IsAlloc
axiom (forall a#19#0#0: int, a#19#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#19#0#0, a#19#1#0), 
      Tclass.JournalDisk.ReqWriteSuperblockId(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#19#0#0, a#19#1#0), 
        Tclass.JournalDisk.ReqWriteSuperblockId(), 
        $h)
       <==> $IsAlloc(a#19#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#19#1#0, Tclass.JournalDisk.ReqWriteSuperblock(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.ReqWriteSuperblockId.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.ReqWriteSuperblockId(), $h)
     ==> $IsAlloc(JournalDisk.ReqWriteSuperblockId.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.ReqWriteSuperblockId.req(d), 
      Tclass.JournalDisk.ReqWriteSuperblock(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.ReqWriteSuperblockId(), $h)
     ==> $IsAlloc(JournalDisk.ReqWriteSuperblockId.req(d), 
      Tclass.JournalDisk.ReqWriteSuperblock(), 
      $h));

// Constructor literal
axiom (forall a#20#0#0: int, a#20#1#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(a#20#0#0), Lit(a#20#1#0)) } 
  #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(a#20#0#0), Lit(a#20#1#0))
     == Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#20#0#0, a#20#1#0)));

function JournalDisk.ReqWriteSuperblockId.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#21#0#0: int, a#21#1#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#21#0#0, a#21#1#0) } 
  JournalDisk.ReqWriteSuperblockId.id(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#21#0#0, a#21#1#0))
     == a#21#0#0);

function JournalDisk.ReqWriteSuperblockId.req(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#22#0#0: int, a#22#1#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#22#0#0, a#22#1#0) } 
  JournalDisk.ReqWriteSuperblockId.req(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#22#0#0, a#22#1#0))
     == a#22#1#0);

// Inductive rank
axiom (forall a#23#0#0: int, a#23#1#0: DatatypeType :: 
  { #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#23#0#0, a#23#1#0) } 
  DtRank(a#23#1#0)
     < DtRank(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(a#23#0#0, a#23#1#0)));

// Depth-one case-split function
function $IsA#JournalDisk.ReqWriteSuperblockId(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.ReqWriteSuperblockId(d) } 
  $IsA#JournalDisk.ReqWriteSuperblockId(d)
     ==> JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d), $Is(d, Tclass.JournalDisk.ReqWriteSuperblockId()) } 
  $Is(d, Tclass.JournalDisk.ReqWriteSuperblockId())
     ==> JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(d));

// Datatype extensional equality declaration
function JournalDisk.ReqWriteSuperblockId#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblockId#Equal(a, b) } 
  true
     ==> (JournalDisk.ReqWriteSuperblockId#Equal(a, b)
       <==> JournalDisk.ReqWriteSuperblockId.id(a) == JournalDisk.ReqWriteSuperblockId.id(b)
         && JournalDisk.ReqWriteSuperblock#Equal(JournalDisk.ReqWriteSuperblockId.req(a), JournalDisk.ReqWriteSuperblockId.req(b))));

// Datatype extensionality axiom: JournalDisk.ReqWriteSuperblockId
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.ReqWriteSuperblockId#Equal(a, b) } 
  JournalDisk.ReqWriteSuperblockId#Equal(a, b) <==> a == b);

const unique class.JournalDisk.ReqWriteSuperblockId: ClassName;

// Constructor function declaration
function #JournalDisk.DiskOp.ReqReadSuperblockOp(int, int) : DatatypeType;

const unique ##JournalDisk.DiskOp.ReqReadSuperblockOp: DtCtorId;

// Constructor identifier
axiom (forall a#24#0#0: int, a#24#1#0: int :: 
  { #JournalDisk.DiskOp.ReqReadSuperblockOp(a#24#0#0, a#24#1#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#24#0#0, a#24#1#0))
     == ##JournalDisk.DiskOp.ReqReadSuperblockOp);

function JournalDisk.DiskOp.ReqReadSuperblockOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqReadSuperblockOp_q(d) } 
  JournalDisk.DiskOp.ReqReadSuperblockOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.ReqReadSuperblockOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqReadSuperblockOp_q(d) } 
  JournalDisk.DiskOp.ReqReadSuperblockOp_q(d)
     ==> (exists a#25#0#0: int, a#25#1#0: int :: 
      d == #JournalDisk.DiskOp.ReqReadSuperblockOp(a#25#0#0, a#25#1#0)));

function Tclass.JournalDisk.DiskOp() : Ty;

// Tclass.JournalDisk.DiskOp Tag
axiom Tag(Tclass.JournalDisk.DiskOp()) == Tagclass.JournalDisk.DiskOp;

const unique Tagclass.JournalDisk.DiskOp: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.DiskOp
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.DiskOp()) } 
  $IsBox(bx, Tclass.JournalDisk.DiskOp())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.DiskOp()));

// Constructor $Is
axiom (forall a#26#0#0: int, a#26#1#0: int :: 
  { $Is(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#26#0#0, a#26#1#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#26#0#0, a#26#1#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#26#0#0, Tclass.NativeTypes.uint64()) && $Is(a#26#1#0, TInt));

// Constructor $IsAlloc
axiom (forall a#27#0#0: int, a#27#1#0: int, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#27#0#0, a#27#1#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#27#0#0, a#27#1#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#27#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#27#1#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqReadSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqReadSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h));

// Constructor literal
axiom (forall a#28#0#0: int, a#28#1#0: int :: 
  { #JournalDisk.DiskOp.ReqReadSuperblockOp(LitInt(a#28#0#0), LitInt(a#28#1#0)) } 
  #JournalDisk.DiskOp.ReqReadSuperblockOp(LitInt(a#28#0#0), LitInt(a#28#1#0))
     == Lit(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#28#0#0, a#28#1#0)));

function JournalDisk.DiskOp.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#29#0#0: int, a#29#1#0: int :: 
  { #JournalDisk.DiskOp.ReqReadSuperblockOp(a#29#0#0, a#29#1#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#29#0#0, a#29#1#0))
     == a#29#0#0);

function JournalDisk.DiskOp.which(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#30#0#0: int, a#30#1#0: int :: 
  { #JournalDisk.DiskOp.ReqReadSuperblockOp(a#30#0#0, a#30#1#0) } 
  JournalDisk.DiskOp.which(#JournalDisk.DiskOp.ReqReadSuperblockOp(a#30#0#0, a#30#1#0))
     == a#30#1#0);

// Constructor function declaration
function #JournalDisk.DiskOp.ReqReadJournalOp(int, DatatypeType) : DatatypeType;

const unique ##JournalDisk.DiskOp.ReqReadJournalOp: DtCtorId;

// Constructor identifier
axiom (forall a#31#0#0: int, a#31#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqReadJournalOp(a#31#0#0, a#31#1#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.ReqReadJournalOp(a#31#0#0, a#31#1#0))
     == ##JournalDisk.DiskOp.ReqReadJournalOp);

function JournalDisk.DiskOp.ReqReadJournalOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqReadJournalOp_q(d) } 
  JournalDisk.DiskOp.ReqReadJournalOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.ReqReadJournalOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqReadJournalOp_q(d) } 
  JournalDisk.DiskOp.ReqReadJournalOp_q(d)
     ==> (exists a#32#0#0: int, a#32#1#0: DatatypeType :: 
      d == #JournalDisk.DiskOp.ReqReadJournalOp(a#32#0#0, a#32#1#0)));

// Constructor $Is
axiom (forall a#33#0#0: int, a#33#1#0: DatatypeType :: 
  { $Is(#JournalDisk.DiskOp.ReqReadJournalOp(a#33#0#0, a#33#1#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.ReqReadJournalOp(a#33#0#0, a#33#1#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#33#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#33#1#0, Tclass.JournalIntervals.JournalInterval()));

// Constructor $IsAlloc
axiom (forall a#34#0#0: int, a#34#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.ReqReadJournalOp(a#34#0#0, a#34#1#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.ReqReadJournalOp(a#34#0#0, a#34#1#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#34#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#34#1#0, Tclass.JournalIntervals.JournalInterval(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqReadJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.interval(d), Tclass.JournalIntervals.JournalInterval(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqReadJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.interval(d), Tclass.JournalIntervals.JournalInterval(), $h));

// Constructor literal
axiom (forall a#35#0#0: int, a#35#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqReadJournalOp(LitInt(a#35#0#0), Lit(a#35#1#0)) } 
  #JournalDisk.DiskOp.ReqReadJournalOp(LitInt(a#35#0#0), Lit(a#35#1#0))
     == Lit(#JournalDisk.DiskOp.ReqReadJournalOp(a#35#0#0, a#35#1#0)));

// Constructor injectivity
axiom (forall a#36#0#0: int, a#36#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqReadJournalOp(a#36#0#0, a#36#1#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.ReqReadJournalOp(a#36#0#0, a#36#1#0))
     == a#36#0#0);

function JournalDisk.DiskOp.interval(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#37#0#0: int, a#37#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqReadJournalOp(a#37#0#0, a#37#1#0) } 
  JournalDisk.DiskOp.interval(#JournalDisk.DiskOp.ReqReadJournalOp(a#37#0#0, a#37#1#0))
     == a#37#1#0);

// Inductive rank
axiom (forall a#38#0#0: int, a#38#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqReadJournalOp(a#38#0#0, a#38#1#0) } 
  DtRank(a#38#1#0)
     < DtRank(#JournalDisk.DiskOp.ReqReadJournalOp(a#38#0#0, a#38#1#0)));

// Constructor function declaration
function #JournalDisk.DiskOp.ReqWriteSuperblockOp(int, int, DatatypeType) : DatatypeType;

const unique ##JournalDisk.DiskOp.ReqWriteSuperblockOp: DtCtorId;

// Constructor identifier
axiom (forall a#39#0#0: int, a#39#1#0: int, a#39#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteSuperblockOp(a#39#0#0, a#39#1#0, a#39#2#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#39#0#0, a#39#1#0, a#39#2#0))
     == ##JournalDisk.DiskOp.ReqWriteSuperblockOp);

function JournalDisk.DiskOp.ReqWriteSuperblockOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d) } 
  JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.ReqWriteSuperblockOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d) } 
  JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
     ==> (exists a#40#0#0: int, a#40#1#0: int, a#40#2#0: DatatypeType :: 
      d == #JournalDisk.DiskOp.ReqWriteSuperblockOp(a#40#0#0, a#40#1#0, a#40#2#0)));

// Constructor $Is
axiom (forall a#41#0#0: int, a#41#1#0: int, a#41#2#0: DatatypeType :: 
  { $Is(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#41#0#0, a#41#1#0, a#41#2#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#41#0#0, a#41#1#0, a#41#2#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#41#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#41#1#0, TInt)
       && $Is(a#41#2#0, Tclass.JournalDisk.ReqWriteSuperblock()));

// Constructor $IsAlloc
axiom (forall a#42#0#0: int, a#42#1#0: int, a#42#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#42#0#0, a#42#1#0, a#42#2#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#42#0#0, a#42#1#0, a#42#2#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#42#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#42#1#0, TInt, $h)
         && $IsAlloc(a#42#2#0, Tclass.JournalDisk.ReqWriteSuperblock(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.reqWriteSuperblock(d), 
      Tclass.JournalDisk.ReqWriteSuperblock(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.reqWriteSuperblock(d), 
      Tclass.JournalDisk.ReqWriteSuperblock(), 
      $h));

// Constructor literal
axiom (forall a#43#0#0: int, a#43#1#0: int, a#43#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteSuperblockOp(LitInt(a#43#0#0), LitInt(a#43#1#0), Lit(a#43#2#0)) } 
  #JournalDisk.DiskOp.ReqWriteSuperblockOp(LitInt(a#43#0#0), LitInt(a#43#1#0), Lit(a#43#2#0))
     == Lit(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#43#0#0, a#43#1#0, a#43#2#0)));

// Constructor injectivity
axiom (forall a#44#0#0: int, a#44#1#0: int, a#44#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteSuperblockOp(a#44#0#0, a#44#1#0, a#44#2#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#44#0#0, a#44#1#0, a#44#2#0))
     == a#44#0#0);

// Constructor injectivity
axiom (forall a#45#0#0: int, a#45#1#0: int, a#45#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteSuperblockOp(a#45#0#0, a#45#1#0, a#45#2#0) } 
  JournalDisk.DiskOp.which(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#45#0#0, a#45#1#0, a#45#2#0))
     == a#45#1#0);

function JournalDisk.DiskOp.reqWriteSuperblock(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#46#0#0: int, a#46#1#0: int, a#46#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteSuperblockOp(a#46#0#0, a#46#1#0, a#46#2#0) } 
  JournalDisk.DiskOp.reqWriteSuperblock(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#46#0#0, a#46#1#0, a#46#2#0))
     == a#46#2#0);

// Inductive rank
axiom (forall a#47#0#0: int, a#47#1#0: int, a#47#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteSuperblockOp(a#47#0#0, a#47#1#0, a#47#2#0) } 
  DtRank(a#47#2#0)
     < DtRank(#JournalDisk.DiskOp.ReqWriteSuperblockOp(a#47#0#0, a#47#1#0, a#47#2#0)));

// Constructor function declaration
function #JournalDisk.DiskOp.ReqWriteJournalOp(int, DatatypeType, DatatypeType) : DatatypeType;

const unique ##JournalDisk.DiskOp.ReqWriteJournalOp: DtCtorId;

// Constructor identifier
axiom (forall a#48#0#0: int, a#48#1#0: DatatypeType, a#48#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(a#48#0#0, a#48#1#0, a#48#2#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.ReqWriteJournalOp(a#48#0#0, a#48#1#0, a#48#2#0))
     == ##JournalDisk.DiskOp.ReqWriteJournalOp);

function JournalDisk.DiskOp.ReqWriteJournalOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqWriteJournalOp_q(d) } 
  JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.ReqWriteJournalOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.ReqWriteJournalOp_q(d) } 
  JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
     ==> (exists a#49#0#0: int, a#49#1#0: DatatypeType, a#49#2#0: DatatypeType :: 
      d == #JournalDisk.DiskOp.ReqWriteJournalOp(a#49#0#0, a#49#1#0, a#49#2#0)));

// Constructor $Is
axiom (forall a#50#0#0: int, a#50#1#0: DatatypeType, a#50#2#0: DatatypeType :: 
  { $Is(#JournalDisk.DiskOp.ReqWriteJournalOp(a#50#0#0, a#50#1#0, a#50#2#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.ReqWriteJournalOp(a#50#0#0, a#50#1#0, a#50#2#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#50#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#50#1#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#50#2#0, Tclass.JournalDisk.ReqWriteJournal()));

// Constructor $IsAlloc
axiom (forall a#51#0#0: int, a#51#1#0: DatatypeType, a#51#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.ReqWriteJournalOp(a#51#0#0, a#51#1#0, a#51#2#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.ReqWriteJournalOp(a#51#0#0, a#51#1#0, a#51#2#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#51#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#51#1#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#51#2#0, Tclass.JournalDisk.ReqWriteJournal(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id1(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id1(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id2(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id2(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.reqWriteJournal(d), Tclass.JournalDisk.ReqWriteJournal(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.reqWriteJournal(d), Tclass.JournalDisk.ReqWriteJournal(), $h));

// Constructor literal
axiom (forall a#52#0#0: int, a#52#1#0: DatatypeType, a#52#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(LitInt(a#52#0#0), Lit(a#52#1#0), Lit(a#52#2#0)) } 
  #JournalDisk.DiskOp.ReqWriteJournalOp(LitInt(a#52#0#0), Lit(a#52#1#0), Lit(a#52#2#0))
     == Lit(#JournalDisk.DiskOp.ReqWriteJournalOp(a#52#0#0, a#52#1#0, a#52#2#0)));

function JournalDisk.DiskOp.id1(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#53#0#0: int, a#53#1#0: DatatypeType, a#53#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(a#53#0#0, a#53#1#0, a#53#2#0) } 
  JournalDisk.DiskOp.id1(#JournalDisk.DiskOp.ReqWriteJournalOp(a#53#0#0, a#53#1#0, a#53#2#0))
     == a#53#0#0);

function JournalDisk.DiskOp.id2(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#54#0#0: int, a#54#1#0: DatatypeType, a#54#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(a#54#0#0, a#54#1#0, a#54#2#0) } 
  JournalDisk.DiskOp.id2(#JournalDisk.DiskOp.ReqWriteJournalOp(a#54#0#0, a#54#1#0, a#54#2#0))
     == a#54#1#0);

// Inductive rank
axiom (forall a#55#0#0: int, a#55#1#0: DatatypeType, a#55#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(a#55#0#0, a#55#1#0, a#55#2#0) } 
  DtRank(a#55#1#0)
     < DtRank(#JournalDisk.DiskOp.ReqWriteJournalOp(a#55#0#0, a#55#1#0, a#55#2#0)));

function JournalDisk.DiskOp.reqWriteJournal(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#56#0#0: int, a#56#1#0: DatatypeType, a#56#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(a#56#0#0, a#56#1#0, a#56#2#0) } 
  JournalDisk.DiskOp.reqWriteJournal(#JournalDisk.DiskOp.ReqWriteJournalOp(a#56#0#0, a#56#1#0, a#56#2#0))
     == a#56#2#0);

// Inductive rank
axiom (forall a#57#0#0: int, a#57#1#0: DatatypeType, a#57#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.ReqWriteJournalOp(a#57#0#0, a#57#1#0, a#57#2#0) } 
  DtRank(a#57#2#0)
     < DtRank(#JournalDisk.DiskOp.ReqWriteJournalOp(a#57#0#0, a#57#1#0, a#57#2#0)));

// Constructor function declaration
function #JournalDisk.DiskOp.RespReadSuperblockOp(int, int, DatatypeType) : DatatypeType;

const unique ##JournalDisk.DiskOp.RespReadSuperblockOp: DtCtorId;

// Constructor identifier
axiom (forall a#58#0#0: int, a#58#1#0: int, a#58#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadSuperblockOp(a#58#0#0, a#58#1#0, a#58#2#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.RespReadSuperblockOp(a#58#0#0, a#58#1#0, a#58#2#0))
     == ##JournalDisk.DiskOp.RespReadSuperblockOp);

function JournalDisk.DiskOp.RespReadSuperblockOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespReadSuperblockOp_q(d) } 
  JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.RespReadSuperblockOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespReadSuperblockOp_q(d) } 
  JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
     ==> (exists a#59#0#0: int, a#59#1#0: int, a#59#2#0: DatatypeType :: 
      d == #JournalDisk.DiskOp.RespReadSuperblockOp(a#59#0#0, a#59#1#0, a#59#2#0)));

// Constructor $Is
axiom (forall a#60#0#0: int, a#60#1#0: int, a#60#2#0: DatatypeType :: 
  { $Is(#JournalDisk.DiskOp.RespReadSuperblockOp(a#60#0#0, a#60#1#0, a#60#2#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.RespReadSuperblockOp(a#60#0#0, a#60#1#0, a#60#2#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#60#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#60#1#0, TInt)
       && $Is(a#60#2#0, Tclass.Options.Option(Tclass.SectorType.Superblock())));

// Constructor $IsAlloc
axiom (forall a#61#0#0: int, a#61#1#0: int, a#61#2#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.RespReadSuperblockOp(a#61#0#0, a#61#1#0, a#61#2#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.RespReadSuperblockOp(a#61#0#0, a#61#1#0, a#61#2#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#61#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#61#1#0, TInt, $h)
         && $IsAlloc(a#61#2#0, Tclass.Options.Option(Tclass.SectorType.Superblock()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.superblock(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.superblock(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h));

// Constructor literal
axiom (forall a#62#0#0: int, a#62#1#0: int, a#62#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadSuperblockOp(LitInt(a#62#0#0), LitInt(a#62#1#0), Lit(a#62#2#0)) } 
  #JournalDisk.DiskOp.RespReadSuperblockOp(LitInt(a#62#0#0), LitInt(a#62#1#0), Lit(a#62#2#0))
     == Lit(#JournalDisk.DiskOp.RespReadSuperblockOp(a#62#0#0, a#62#1#0, a#62#2#0)));

// Constructor injectivity
axiom (forall a#63#0#0: int, a#63#1#0: int, a#63#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadSuperblockOp(a#63#0#0, a#63#1#0, a#63#2#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.RespReadSuperblockOp(a#63#0#0, a#63#1#0, a#63#2#0))
     == a#63#0#0);

// Constructor injectivity
axiom (forall a#64#0#0: int, a#64#1#0: int, a#64#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadSuperblockOp(a#64#0#0, a#64#1#0, a#64#2#0) } 
  JournalDisk.DiskOp.which(#JournalDisk.DiskOp.RespReadSuperblockOp(a#64#0#0, a#64#1#0, a#64#2#0))
     == a#64#1#0);

function JournalDisk.DiskOp.superblock(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#65#0#0: int, a#65#1#0: int, a#65#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadSuperblockOp(a#65#0#0, a#65#1#0, a#65#2#0) } 
  JournalDisk.DiskOp.superblock(#JournalDisk.DiskOp.RespReadSuperblockOp(a#65#0#0, a#65#1#0, a#65#2#0))
     == a#65#2#0);

// Inductive rank
axiom (forall a#66#0#0: int, a#66#1#0: int, a#66#2#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadSuperblockOp(a#66#0#0, a#66#1#0, a#66#2#0) } 
  DtRank(a#66#2#0)
     < DtRank(#JournalDisk.DiskOp.RespReadSuperblockOp(a#66#0#0, a#66#1#0, a#66#2#0)));

// Constructor function declaration
function #JournalDisk.DiskOp.RespReadJournalOp(int, DatatypeType) : DatatypeType;

const unique ##JournalDisk.DiskOp.RespReadJournalOp: DtCtorId;

// Constructor identifier
axiom (forall a#67#0#0: int, a#67#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadJournalOp(a#67#0#0, a#67#1#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.RespReadJournalOp(a#67#0#0, a#67#1#0))
     == ##JournalDisk.DiskOp.RespReadJournalOp);

function JournalDisk.DiskOp.RespReadJournalOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespReadJournalOp_q(d) } 
  JournalDisk.DiskOp.RespReadJournalOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.RespReadJournalOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespReadJournalOp_q(d) } 
  JournalDisk.DiskOp.RespReadJournalOp_q(d)
     ==> (exists a#68#0#0: int, a#68#1#0: DatatypeType :: 
      d == #JournalDisk.DiskOp.RespReadJournalOp(a#68#0#0, a#68#1#0)));

// Constructor $Is
axiom (forall a#69#0#0: int, a#69#1#0: DatatypeType :: 
  { $Is(#JournalDisk.DiskOp.RespReadJournalOp(a#69#0#0, a#69#1#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.RespReadJournalOp(a#69#0#0, a#69#1#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#69#0#0, Tclass.NativeTypes.uint64())
       && $Is(a#69#1#0, Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock()))));

// Constructor $IsAlloc
axiom (forall a#70#0#0: int, a#70#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.RespReadJournalOp(a#70#0#0, a#70#1#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.RespReadJournalOp(a#70#0#0, a#70#1#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#70#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#70#1#0, Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespReadJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.journal(d), 
      Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespReadJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.journal(d), 
      Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), 
      $h));

// Constructor literal
axiom (forall a#71#0#0: int, a#71#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadJournalOp(LitInt(a#71#0#0), Lit(a#71#1#0)) } 
  #JournalDisk.DiskOp.RespReadJournalOp(LitInt(a#71#0#0), Lit(a#71#1#0))
     == Lit(#JournalDisk.DiskOp.RespReadJournalOp(a#71#0#0, a#71#1#0)));

// Constructor injectivity
axiom (forall a#72#0#0: int, a#72#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadJournalOp(a#72#0#0, a#72#1#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.RespReadJournalOp(a#72#0#0, a#72#1#0))
     == a#72#0#0);

function JournalDisk.DiskOp.journal(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#73#0#0: int, a#73#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadJournalOp(a#73#0#0, a#73#1#0) } 
  JournalDisk.DiskOp.journal(#JournalDisk.DiskOp.RespReadJournalOp(a#73#0#0, a#73#1#0))
     == a#73#1#0);

// Inductive rank
axiom (forall a#74#0#0: int, a#74#1#0: DatatypeType :: 
  { #JournalDisk.DiskOp.RespReadJournalOp(a#74#0#0, a#74#1#0) } 
  DtRank(a#74#1#0)
     < DtRank(#JournalDisk.DiskOp.RespReadJournalOp(a#74#0#0, a#74#1#0)));

// Constructor function declaration
function #JournalDisk.DiskOp.RespWriteSuperblockOp(int, int) : DatatypeType;

const unique ##JournalDisk.DiskOp.RespWriteSuperblockOp: DtCtorId;

// Constructor identifier
axiom (forall a#75#0#0: int, a#75#1#0: int :: 
  { #JournalDisk.DiskOp.RespWriteSuperblockOp(a#75#0#0, a#75#1#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#75#0#0, a#75#1#0))
     == ##JournalDisk.DiskOp.RespWriteSuperblockOp);

function JournalDisk.DiskOp.RespWriteSuperblockOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespWriteSuperblockOp_q(d) } 
  JournalDisk.DiskOp.RespWriteSuperblockOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.RespWriteSuperblockOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespWriteSuperblockOp_q(d) } 
  JournalDisk.DiskOp.RespWriteSuperblockOp_q(d)
     ==> (exists a#76#0#0: int, a#76#1#0: int :: 
      d == #JournalDisk.DiskOp.RespWriteSuperblockOp(a#76#0#0, a#76#1#0)));

// Constructor $Is
axiom (forall a#77#0#0: int, a#77#1#0: int :: 
  { $Is(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#77#0#0, a#77#1#0), 
      Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#77#0#0, a#77#1#0), 
      Tclass.JournalDisk.DiskOp())
     <==> $Is(a#77#0#0, Tclass.NativeTypes.uint64()) && $Is(a#77#1#0, TInt));

// Constructor $IsAlloc
axiom (forall a#78#0#0: int, a#78#1#0: int, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#78#0#0, a#78#1#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#78#0#0, a#78#1#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#78#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#78#1#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespWriteSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespWriteSuperblockOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.which(d), TInt, $h));

// Constructor literal
axiom (forall a#79#0#0: int, a#79#1#0: int :: 
  { #JournalDisk.DiskOp.RespWriteSuperblockOp(LitInt(a#79#0#0), LitInt(a#79#1#0)) } 
  #JournalDisk.DiskOp.RespWriteSuperblockOp(LitInt(a#79#0#0), LitInt(a#79#1#0))
     == Lit(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#79#0#0, a#79#1#0)));

// Constructor injectivity
axiom (forall a#80#0#0: int, a#80#1#0: int :: 
  { #JournalDisk.DiskOp.RespWriteSuperblockOp(a#80#0#0, a#80#1#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#80#0#0, a#80#1#0))
     == a#80#0#0);

// Constructor injectivity
axiom (forall a#81#0#0: int, a#81#1#0: int :: 
  { #JournalDisk.DiskOp.RespWriteSuperblockOp(a#81#0#0, a#81#1#0) } 
  JournalDisk.DiskOp.which(#JournalDisk.DiskOp.RespWriteSuperblockOp(a#81#0#0, a#81#1#0))
     == a#81#1#0);

// Constructor function declaration
function #JournalDisk.DiskOp.RespWriteJournalOp(int) : DatatypeType;

const unique ##JournalDisk.DiskOp.RespWriteJournalOp: DtCtorId;

// Constructor identifier
axiom (forall a#82#0#0: int :: 
  { #JournalDisk.DiskOp.RespWriteJournalOp(a#82#0#0) } 
  DatatypeCtorId(#JournalDisk.DiskOp.RespWriteJournalOp(a#82#0#0))
     == ##JournalDisk.DiskOp.RespWriteJournalOp);

function JournalDisk.DiskOp.RespWriteJournalOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespWriteJournalOp_q(d) } 
  JournalDisk.DiskOp.RespWriteJournalOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.RespWriteJournalOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.RespWriteJournalOp_q(d) } 
  JournalDisk.DiskOp.RespWriteJournalOp_q(d)
     ==> (exists a#83#0#0: int :: d == #JournalDisk.DiskOp.RespWriteJournalOp(a#83#0#0)));

// Constructor $Is
axiom (forall a#84#0#0: int :: 
  { $Is(#JournalDisk.DiskOp.RespWriteJournalOp(a#84#0#0), Tclass.JournalDisk.DiskOp()) } 
  $Is(#JournalDisk.DiskOp.RespWriteJournalOp(a#84#0#0), Tclass.JournalDisk.DiskOp())
     <==> $Is(a#84#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#85#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.RespWriteJournalOp(a#85#0#0), 
      Tclass.JournalDisk.DiskOp(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.DiskOp.RespWriteJournalOp(a#85#0#0), 
        Tclass.JournalDisk.DiskOp(), 
        $h)
       <==> $IsAlloc(a#85#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.DiskOp.RespWriteJournalOp_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.DiskOp(), $h)
     ==> $IsAlloc(JournalDisk.DiskOp.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#86#0#0: int :: 
  { #JournalDisk.DiskOp.RespWriteJournalOp(LitInt(a#86#0#0)) } 
  #JournalDisk.DiskOp.RespWriteJournalOp(LitInt(a#86#0#0))
     == Lit(#JournalDisk.DiskOp.RespWriteJournalOp(a#86#0#0)));

// Constructor injectivity
axiom (forall a#87#0#0: int :: 
  { #JournalDisk.DiskOp.RespWriteJournalOp(a#87#0#0) } 
  JournalDisk.DiskOp.id(#JournalDisk.DiskOp.RespWriteJournalOp(a#87#0#0))
     == a#87#0#0);

// Constructor function declaration
function #JournalDisk.DiskOp.NoDiskOp() : DatatypeType;

const unique ##JournalDisk.DiskOp.NoDiskOp: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalDisk.DiskOp.NoDiskOp()) == ##JournalDisk.DiskOp.NoDiskOp;

function JournalDisk.DiskOp.NoDiskOp_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.NoDiskOp_q(d) } 
  JournalDisk.DiskOp.NoDiskOp_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.DiskOp.NoDiskOp);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.NoDiskOp_q(d) } 
  JournalDisk.DiskOp.NoDiskOp_q(d) ==> d == #JournalDisk.DiskOp.NoDiskOp());

// Constructor $Is
axiom $Is(#JournalDisk.DiskOp.NoDiskOp(), Tclass.JournalDisk.DiskOp());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalDisk.DiskOp.NoDiskOp(), Tclass.JournalDisk.DiskOp(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalDisk.DiskOp.NoDiskOp(), Tclass.JournalDisk.DiskOp(), $h));

// Constructor literal
axiom #JournalDisk.DiskOp.NoDiskOp() == Lit(#JournalDisk.DiskOp.NoDiskOp());

// Depth-one case-split function
function $IsA#JournalDisk.DiskOp(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.DiskOp(d) } 
  $IsA#JournalDisk.DiskOp(d)
     ==> JournalDisk.DiskOp.ReqReadSuperblockOp_q(d)
       || JournalDisk.DiskOp.ReqReadJournalOp_q(d)
       || JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
       || JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
       || JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
       || JournalDisk.DiskOp.RespReadJournalOp_q(d)
       || JournalDisk.DiskOp.RespWriteSuperblockOp_q(d)
       || JournalDisk.DiskOp.RespWriteJournalOp_q(d)
       || JournalDisk.DiskOp.NoDiskOp_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.DiskOp.NoDiskOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.RespWriteJournalOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.RespWriteSuperblockOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.RespReadJournalOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.RespReadSuperblockOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.ReqWriteJournalOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.ReqReadJournalOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
    { JournalDisk.DiskOp.ReqReadSuperblockOp_q(d), $Is(d, Tclass.JournalDisk.DiskOp()) } 
  $Is(d, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.DiskOp.ReqReadSuperblockOp_q(d)
       || JournalDisk.DiskOp.ReqReadJournalOp_q(d)
       || JournalDisk.DiskOp.ReqWriteSuperblockOp_q(d)
       || JournalDisk.DiskOp.ReqWriteJournalOp_q(d)
       || JournalDisk.DiskOp.RespReadSuperblockOp_q(d)
       || JournalDisk.DiskOp.RespReadJournalOp_q(d)
       || JournalDisk.DiskOp.RespWriteSuperblockOp_q(d)
       || JournalDisk.DiskOp.RespWriteJournalOp_q(d)
       || JournalDisk.DiskOp.NoDiskOp_q(d));

// Datatype extensional equality declaration
function JournalDisk.DiskOp#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.DiskOp.ReqReadSuperblockOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqReadSuperblockOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqReadSuperblockOp_q(b) } 
  JournalDisk.DiskOp.ReqReadSuperblockOp_q(a)
       && JournalDisk.DiskOp.ReqReadSuperblockOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)
         && JournalDisk.DiskOp.which(a) == JournalDisk.DiskOp.which(b)));

// Datatype extensional equality definition: #JournalDisk.DiskOp.ReqReadJournalOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqReadJournalOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqReadJournalOp_q(b) } 
  JournalDisk.DiskOp.ReqReadJournalOp_q(a)
       && JournalDisk.DiskOp.ReqReadJournalOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)
         && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(a), JournalDisk.DiskOp.interval(b))));

// Datatype extensional equality definition: #JournalDisk.DiskOp.ReqWriteSuperblockOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqWriteSuperblockOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqWriteSuperblockOp_q(b) } 
  JournalDisk.DiskOp.ReqWriteSuperblockOp_q(a)
       && JournalDisk.DiskOp.ReqWriteSuperblockOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)
         && JournalDisk.DiskOp.which(a) == JournalDisk.DiskOp.which(b)
         && JournalDisk.ReqWriteSuperblock#Equal(JournalDisk.DiskOp.reqWriteSuperblock(a), 
          JournalDisk.DiskOp.reqWriteSuperblock(b))));

// Datatype extensional equality definition: #JournalDisk.DiskOp.ReqWriteJournalOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqWriteJournalOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.ReqWriteJournalOp_q(b) } 
  JournalDisk.DiskOp.ReqWriteJournalOp_q(a)
       && JournalDisk.DiskOp.ReqWriteJournalOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id1(a) == JournalDisk.DiskOp.id1(b)
         && Options.Option#Equal(JournalDisk.DiskOp.id2(a), JournalDisk.DiskOp.id2(b))
         && JournalDisk.ReqWriteJournal#Equal(JournalDisk.DiskOp.reqWriteJournal(a), JournalDisk.DiskOp.reqWriteJournal(b))));

// Datatype extensional equality definition: #JournalDisk.DiskOp.RespReadSuperblockOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespReadSuperblockOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespReadSuperblockOp_q(b) } 
  JournalDisk.DiskOp.RespReadSuperblockOp_q(a)
       && JournalDisk.DiskOp.RespReadSuperblockOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)
         && JournalDisk.DiskOp.which(a) == JournalDisk.DiskOp.which(b)
         && Options.Option#Equal(JournalDisk.DiskOp.superblock(a), JournalDisk.DiskOp.superblock(b))));

// Datatype extensional equality definition: #JournalDisk.DiskOp.RespReadJournalOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespReadJournalOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespReadJournalOp_q(b) } 
  JournalDisk.DiskOp.RespReadJournalOp_q(a)
       && JournalDisk.DiskOp.RespReadJournalOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)
         && Options.Option#Equal(JournalDisk.DiskOp.journal(a), JournalDisk.DiskOp.journal(b))));

// Datatype extensional equality definition: #JournalDisk.DiskOp.RespWriteSuperblockOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespWriteSuperblockOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespWriteSuperblockOp_q(b) } 
  JournalDisk.DiskOp.RespWriteSuperblockOp_q(a)
       && JournalDisk.DiskOp.RespWriteSuperblockOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)
         && JournalDisk.DiskOp.which(a) == JournalDisk.DiskOp.which(b)));

// Datatype extensional equality definition: #JournalDisk.DiskOp.RespWriteJournalOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespWriteJournalOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.RespWriteJournalOp_q(b) } 
  JournalDisk.DiskOp.RespWriteJournalOp_q(a)
       && JournalDisk.DiskOp.RespWriteJournalOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b)
       <==> JournalDisk.DiskOp.id(a) == JournalDisk.DiskOp.id(b)));

// Datatype extensional equality definition: #JournalDisk.DiskOp.NoDiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.NoDiskOp_q(a) } 
    { JournalDisk.DiskOp#Equal(a, b), JournalDisk.DiskOp.NoDiskOp_q(b) } 
  JournalDisk.DiskOp.NoDiskOp_q(a) && JournalDisk.DiskOp.NoDiskOp_q(b)
     ==> (JournalDisk.DiskOp#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalDisk.DiskOp
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.DiskOp#Equal(a, b) } 
  JournalDisk.DiskOp#Equal(a, b) <==> a == b);

const unique class.JournalDisk.DiskOp: ClassName;

// Constructor function declaration
function #JournalDisk.Constants.Constants() : DatatypeType;

const unique ##JournalDisk.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalDisk.Constants.Constants())
   == ##JournalDisk.Constants.Constants;

function JournalDisk.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.Constants.Constants_q(d) } 
  JournalDisk.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.Constants.Constants_q(d) } 
  JournalDisk.Constants.Constants_q(d) ==> d == #JournalDisk.Constants.Constants());

function Tclass.JournalDisk.Constants() : Ty;

// Tclass.JournalDisk.Constants Tag
axiom Tag(Tclass.JournalDisk.Constants()) == Tagclass.JournalDisk.Constants;

const unique Tagclass.JournalDisk.Constants: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.Constants()) } 
  $IsBox(bx, Tclass.JournalDisk.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.Constants()));

// Constructor $Is
axiom $Is(#JournalDisk.Constants.Constants(), Tclass.JournalDisk.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalDisk.Constants.Constants(), Tclass.JournalDisk.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalDisk.Constants.Constants(), Tclass.JournalDisk.Constants(), $h));

// Constructor literal
axiom #JournalDisk.Constants.Constants() == Lit(#JournalDisk.Constants.Constants());

// Depth-one case-split function
function $IsA#JournalDisk.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.Constants(d) } 
  $IsA#JournalDisk.Constants(d) ==> JournalDisk.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.Constants.Constants_q(d), $Is(d, Tclass.JournalDisk.Constants()) } 
  $Is(d, Tclass.JournalDisk.Constants()) ==> JournalDisk.Constants.Constants_q(d));

// Datatype extensional equality declaration
function JournalDisk.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.Constants#Equal(a, b) } 
  true ==> (JournalDisk.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalDisk.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.Constants#Equal(a, b) } 
  JournalDisk.Constants#Equal(a, b) <==> a == b);

const unique class.JournalDisk.Constants: ClassName;

// Constructor function declaration
function #JournalDisk.Variables.Variables(Set Box, 
    Set Box, 
    Map Box Box, 
    DatatypeType, 
    DatatypeType, 
    Map Box Box, 
    DatatypeType, 
    DatatypeType, 
    Seq Box)
   : DatatypeType;

const unique ##JournalDisk.Variables.Variables: DtCtorId;

// Constructor identifier
axiom (forall a#98#0#0: Set Box, 
    a#98#1#0: Set Box, 
    a#98#2#0: Map Box Box, 
    a#98#3#0: DatatypeType, 
    a#98#4#0: DatatypeType, 
    a#98#5#0: Map Box Box, 
    a#98#6#0: DatatypeType, 
    a#98#7#0: DatatypeType, 
    a#98#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#98#0#0, 
      a#98#1#0, 
      a#98#2#0, 
      a#98#3#0, 
      a#98#4#0, 
      a#98#5#0, 
      a#98#6#0, 
      a#98#7#0, 
      a#98#8#0) } 
  DatatypeCtorId(#JournalDisk.Variables.Variables(a#98#0#0, 
        a#98#1#0, 
        a#98#2#0, 
        a#98#3#0, 
        a#98#4#0, 
        a#98#5#0, 
        a#98#6#0, 
        a#98#7#0, 
        a#98#8#0))
     == ##JournalDisk.Variables.Variables);

function JournalDisk.Variables.Variables_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.Variables.Variables_q(d) } 
  JournalDisk.Variables.Variables_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.Variables.Variables);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.Variables.Variables_q(d) } 
  JournalDisk.Variables.Variables_q(d)
     ==> (exists a#99#0#0: Set Box, 
        a#99#1#0: Set Box, 
        a#99#2#0: Map Box Box, 
        a#99#3#0: DatatypeType, 
        a#99#4#0: DatatypeType, 
        a#99#5#0: Map Box Box, 
        a#99#6#0: DatatypeType, 
        a#99#7#0: DatatypeType, 
        a#99#8#0: Seq Box :: 
      d
         == #JournalDisk.Variables.Variables(a#99#0#0, 
          a#99#1#0, 
          a#99#2#0, 
          a#99#3#0, 
          a#99#4#0, 
          a#99#5#0, 
          a#99#6#0, 
          a#99#7#0, 
          a#99#8#0)));

function Tclass.JournalDisk.Variables() : Ty;

// Tclass.JournalDisk.Variables Tag
axiom Tag(Tclass.JournalDisk.Variables()) == Tagclass.JournalDisk.Variables;

const unique Tagclass.JournalDisk.Variables: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.Variables()) } 
  $IsBox(bx, Tclass.JournalDisk.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.Variables()));

// Constructor $Is
axiom (forall a#100#0#0: Set Box, 
    a#100#1#0: Set Box, 
    a#100#2#0: Map Box Box, 
    a#100#3#0: DatatypeType, 
    a#100#4#0: DatatypeType, 
    a#100#5#0: Map Box Box, 
    a#100#6#0: DatatypeType, 
    a#100#7#0: DatatypeType, 
    a#100#8#0: Seq Box :: 
  { $Is(#JournalDisk.Variables.Variables(a#100#0#0, 
        a#100#1#0, 
        a#100#2#0, 
        a#100#3#0, 
        a#100#4#0, 
        a#100#5#0, 
        a#100#6#0, 
        a#100#7#0, 
        a#100#8#0), 
      Tclass.JournalDisk.Variables()) } 
  $Is(#JournalDisk.Variables.Variables(a#100#0#0, 
        a#100#1#0, 
        a#100#2#0, 
        a#100#3#0, 
        a#100#4#0, 
        a#100#5#0, 
        a#100#6#0, 
        a#100#7#0, 
        a#100#8#0), 
      Tclass.JournalDisk.Variables())
     <==> $Is(a#100#0#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(a#100#1#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(a#100#2#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
       && $Is(a#100#3#0, Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()))
       && $Is(a#100#4#0, Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()))
       && $Is(a#100#5#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
       && $Is(a#100#6#0, Tclass.Options.Option(Tclass.SectorType.Superblock()))
       && $Is(a#100#7#0, Tclass.Options.Option(Tclass.SectorType.Superblock()))
       && $Is(a#100#8#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock()))));

// Constructor $IsAlloc
axiom (forall a#101#0#0: Set Box, 
    a#101#1#0: Set Box, 
    a#101#2#0: Map Box Box, 
    a#101#3#0: DatatypeType, 
    a#101#4#0: DatatypeType, 
    a#101#5#0: Map Box Box, 
    a#101#6#0: DatatypeType, 
    a#101#7#0: DatatypeType, 
    a#101#8#0: Seq Box, 
    $h: Heap :: 
  { $IsAlloc(#JournalDisk.Variables.Variables(a#101#0#0, 
        a#101#1#0, 
        a#101#2#0, 
        a#101#3#0, 
        a#101#4#0, 
        a#101#5#0, 
        a#101#6#0, 
        a#101#7#0, 
        a#101#8#0), 
      Tclass.JournalDisk.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.Variables.Variables(a#101#0#0, 
          a#101#1#0, 
          a#101#2#0, 
          a#101#3#0, 
          a#101#4#0, 
          a#101#5#0, 
          a#101#6#0, 
          a#101#7#0, 
          a#101#8#0), 
        Tclass.JournalDisk.Variables(), 
        $h)
       <==> $IsAlloc(a#101#0#0, TSet(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#101#1#0, TSet(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#101#2#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()), 
          $h)
         && $IsAlloc(a#101#3#0, Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()), $h)
         && $IsAlloc(a#101#4#0, Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()), $h)
         && $IsAlloc(a#101#5#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()), 
          $h)
         && $IsAlloc(a#101#6#0, Tclass.Options.Option(Tclass.SectorType.Superblock()), $h)
         && $IsAlloc(a#101#7#0, Tclass.Options.Option(Tclass.SectorType.Superblock()), $h)
         && $IsAlloc(a#101#8#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.reqReadSuperblock1(d), 
      TSet(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.reqReadSuperblock1(d), 
      TSet(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.reqReadSuperblock2(d), 
      TSet(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.reqReadSuperblock2(d), 
      TSet(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.reqReadJournals(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.reqReadJournals(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.reqWriteSuperblock1(d), 
      Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.reqWriteSuperblock1(d), 
      Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.reqWriteSuperblock2(d), 
      Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.reqWriteSuperblock2(d), 
      Tclass.Options.Option(Tclass.JournalDisk.ReqWriteSuperblockId()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.reqWriteJournals(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.reqWriteJournals(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.superblock1(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.superblock1(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.superblock2(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.superblock2(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.Variables.journal(d), 
      TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.Variables.Variables_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.Variables(), $h)
     ==> $IsAlloc(JournalDisk.Variables.journal(d), 
      TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())), 
      $h));

// Constructor literal
axiom (forall a#102#0#0: Set Box, 
    a#102#1#0: Set Box, 
    a#102#2#0: Map Box Box, 
    a#102#3#0: DatatypeType, 
    a#102#4#0: DatatypeType, 
    a#102#5#0: Map Box Box, 
    a#102#6#0: DatatypeType, 
    a#102#7#0: DatatypeType, 
    a#102#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(Lit(a#102#0#0), 
      Lit(a#102#1#0), 
      Lit(a#102#2#0), 
      Lit(a#102#3#0), 
      Lit(a#102#4#0), 
      Lit(a#102#5#0), 
      Lit(a#102#6#0), 
      Lit(a#102#7#0), 
      Lit(a#102#8#0)) } 
  #JournalDisk.Variables.Variables(Lit(a#102#0#0), 
      Lit(a#102#1#0), 
      Lit(a#102#2#0), 
      Lit(a#102#3#0), 
      Lit(a#102#4#0), 
      Lit(a#102#5#0), 
      Lit(a#102#6#0), 
      Lit(a#102#7#0), 
      Lit(a#102#8#0))
     == Lit(#JournalDisk.Variables.Variables(a#102#0#0, 
        a#102#1#0, 
        a#102#2#0, 
        a#102#3#0, 
        a#102#4#0, 
        a#102#5#0, 
        a#102#6#0, 
        a#102#7#0, 
        a#102#8#0)));

function JournalDisk.Variables.reqReadSuperblock1(DatatypeType) : Set Box;

// Constructor injectivity
axiom (forall a#103#0#0: Set Box, 
    a#103#1#0: Set Box, 
    a#103#2#0: Map Box Box, 
    a#103#3#0: DatatypeType, 
    a#103#4#0: DatatypeType, 
    a#103#5#0: Map Box Box, 
    a#103#6#0: DatatypeType, 
    a#103#7#0: DatatypeType, 
    a#103#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#103#0#0, 
      a#103#1#0, 
      a#103#2#0, 
      a#103#3#0, 
      a#103#4#0, 
      a#103#5#0, 
      a#103#6#0, 
      a#103#7#0, 
      a#103#8#0) } 
  JournalDisk.Variables.reqReadSuperblock1(#JournalDisk.Variables.Variables(a#103#0#0, 
        a#103#1#0, 
        a#103#2#0, 
        a#103#3#0, 
        a#103#4#0, 
        a#103#5#0, 
        a#103#6#0, 
        a#103#7#0, 
        a#103#8#0))
     == a#103#0#0);

// Inductive set element rank
axiom (forall a#104#0#0: Set Box, 
    a#104#1#0: Set Box, 
    a#104#2#0: Map Box Box, 
    a#104#3#0: DatatypeType, 
    a#104#4#0: DatatypeType, 
    a#104#5#0: Map Box Box, 
    a#104#6#0: DatatypeType, 
    a#104#7#0: DatatypeType, 
    a#104#8#0: Seq Box, 
    d: DatatypeType :: 
  { a#104#0#0[$Box(d)], #JournalDisk.Variables.Variables(a#104#0#0, 
      a#104#1#0, 
      a#104#2#0, 
      a#104#3#0, 
      a#104#4#0, 
      a#104#5#0, 
      a#104#6#0, 
      a#104#7#0, 
      a#104#8#0) } 
  a#104#0#0[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalDisk.Variables.Variables(a#104#0#0, 
          a#104#1#0, 
          a#104#2#0, 
          a#104#3#0, 
          a#104#4#0, 
          a#104#5#0, 
          a#104#6#0, 
          a#104#7#0, 
          a#104#8#0)));

function JournalDisk.Variables.reqReadSuperblock2(DatatypeType) : Set Box;

// Constructor injectivity
axiom (forall a#105#0#0: Set Box, 
    a#105#1#0: Set Box, 
    a#105#2#0: Map Box Box, 
    a#105#3#0: DatatypeType, 
    a#105#4#0: DatatypeType, 
    a#105#5#0: Map Box Box, 
    a#105#6#0: DatatypeType, 
    a#105#7#0: DatatypeType, 
    a#105#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#105#0#0, 
      a#105#1#0, 
      a#105#2#0, 
      a#105#3#0, 
      a#105#4#0, 
      a#105#5#0, 
      a#105#6#0, 
      a#105#7#0, 
      a#105#8#0) } 
  JournalDisk.Variables.reqReadSuperblock2(#JournalDisk.Variables.Variables(a#105#0#0, 
        a#105#1#0, 
        a#105#2#0, 
        a#105#3#0, 
        a#105#4#0, 
        a#105#5#0, 
        a#105#6#0, 
        a#105#7#0, 
        a#105#8#0))
     == a#105#1#0);

// Inductive set element rank
axiom (forall a#106#0#0: Set Box, 
    a#106#1#0: Set Box, 
    a#106#2#0: Map Box Box, 
    a#106#3#0: DatatypeType, 
    a#106#4#0: DatatypeType, 
    a#106#5#0: Map Box Box, 
    a#106#6#0: DatatypeType, 
    a#106#7#0: DatatypeType, 
    a#106#8#0: Seq Box, 
    d: DatatypeType :: 
  { a#106#1#0[$Box(d)], #JournalDisk.Variables.Variables(a#106#0#0, 
      a#106#1#0, 
      a#106#2#0, 
      a#106#3#0, 
      a#106#4#0, 
      a#106#5#0, 
      a#106#6#0, 
      a#106#7#0, 
      a#106#8#0) } 
  a#106#1#0[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalDisk.Variables.Variables(a#106#0#0, 
          a#106#1#0, 
          a#106#2#0, 
          a#106#3#0, 
          a#106#4#0, 
          a#106#5#0, 
          a#106#6#0, 
          a#106#7#0, 
          a#106#8#0)));

function JournalDisk.Variables.reqReadJournals(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#107#0#0: Set Box, 
    a#107#1#0: Set Box, 
    a#107#2#0: Map Box Box, 
    a#107#3#0: DatatypeType, 
    a#107#4#0: DatatypeType, 
    a#107#5#0: Map Box Box, 
    a#107#6#0: DatatypeType, 
    a#107#7#0: DatatypeType, 
    a#107#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#107#0#0, 
      a#107#1#0, 
      a#107#2#0, 
      a#107#3#0, 
      a#107#4#0, 
      a#107#5#0, 
      a#107#6#0, 
      a#107#7#0, 
      a#107#8#0) } 
  JournalDisk.Variables.reqReadJournals(#JournalDisk.Variables.Variables(a#107#0#0, 
        a#107#1#0, 
        a#107#2#0, 
        a#107#3#0, 
        a#107#4#0, 
        a#107#5#0, 
        a#107#6#0, 
        a#107#7#0, 
        a#107#8#0))
     == a#107#2#0);

// Inductive map key rank
axiom (forall a#108#0#0: Set Box, 
    a#108#1#0: Set Box, 
    a#108#2#0: Map Box Box, 
    a#108#3#0: DatatypeType, 
    a#108#4#0: DatatypeType, 
    a#108#5#0: Map Box Box, 
    a#108#6#0: DatatypeType, 
    a#108#7#0: DatatypeType, 
    a#108#8#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#108#2#0)[$Box(d)], #JournalDisk.Variables.Variables(a#108#0#0, 
      a#108#1#0, 
      a#108#2#0, 
      a#108#3#0, 
      a#108#4#0, 
      a#108#5#0, 
      a#108#6#0, 
      a#108#7#0, 
      a#108#8#0) } 
  Map#Domain(a#108#2#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalDisk.Variables.Variables(a#108#0#0, 
          a#108#1#0, 
          a#108#2#0, 
          a#108#3#0, 
          a#108#4#0, 
          a#108#5#0, 
          a#108#6#0, 
          a#108#7#0, 
          a#108#8#0)));

// Inductive map value rank
axiom (forall a#109#0#0: Set Box, 
    a#109#1#0: Set Box, 
    a#109#2#0: Map Box Box, 
    a#109#3#0: DatatypeType, 
    a#109#4#0: DatatypeType, 
    a#109#5#0: Map Box Box, 
    a#109#6#0: DatatypeType, 
    a#109#7#0: DatatypeType, 
    a#109#8#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#109#2#0)[bx], #JournalDisk.Variables.Variables(a#109#0#0, 
      a#109#1#0, 
      a#109#2#0, 
      a#109#3#0, 
      a#109#4#0, 
      a#109#5#0, 
      a#109#6#0, 
      a#109#7#0, 
      a#109#8#0) } 
  Map#Domain(a#109#2#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#109#2#0)[bx]): DatatypeType)
       < DtRank(#JournalDisk.Variables.Variables(a#109#0#0, 
          a#109#1#0, 
          a#109#2#0, 
          a#109#3#0, 
          a#109#4#0, 
          a#109#5#0, 
          a#109#6#0, 
          a#109#7#0, 
          a#109#8#0)));

function JournalDisk.Variables.reqWriteSuperblock1(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#110#0#0: Set Box, 
    a#110#1#0: Set Box, 
    a#110#2#0: Map Box Box, 
    a#110#3#0: DatatypeType, 
    a#110#4#0: DatatypeType, 
    a#110#5#0: Map Box Box, 
    a#110#6#0: DatatypeType, 
    a#110#7#0: DatatypeType, 
    a#110#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#110#0#0, 
      a#110#1#0, 
      a#110#2#0, 
      a#110#3#0, 
      a#110#4#0, 
      a#110#5#0, 
      a#110#6#0, 
      a#110#7#0, 
      a#110#8#0) } 
  JournalDisk.Variables.reqWriteSuperblock1(#JournalDisk.Variables.Variables(a#110#0#0, 
        a#110#1#0, 
        a#110#2#0, 
        a#110#3#0, 
        a#110#4#0, 
        a#110#5#0, 
        a#110#6#0, 
        a#110#7#0, 
        a#110#8#0))
     == a#110#3#0);

// Inductive rank
axiom (forall a#111#0#0: Set Box, 
    a#111#1#0: Set Box, 
    a#111#2#0: Map Box Box, 
    a#111#3#0: DatatypeType, 
    a#111#4#0: DatatypeType, 
    a#111#5#0: Map Box Box, 
    a#111#6#0: DatatypeType, 
    a#111#7#0: DatatypeType, 
    a#111#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#111#0#0, 
      a#111#1#0, 
      a#111#2#0, 
      a#111#3#0, 
      a#111#4#0, 
      a#111#5#0, 
      a#111#6#0, 
      a#111#7#0, 
      a#111#8#0) } 
  DtRank(a#111#3#0)
     < DtRank(#JournalDisk.Variables.Variables(a#111#0#0, 
        a#111#1#0, 
        a#111#2#0, 
        a#111#3#0, 
        a#111#4#0, 
        a#111#5#0, 
        a#111#6#0, 
        a#111#7#0, 
        a#111#8#0)));

function JournalDisk.Variables.reqWriteSuperblock2(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#112#0#0: Set Box, 
    a#112#1#0: Set Box, 
    a#112#2#0: Map Box Box, 
    a#112#3#0: DatatypeType, 
    a#112#4#0: DatatypeType, 
    a#112#5#0: Map Box Box, 
    a#112#6#0: DatatypeType, 
    a#112#7#0: DatatypeType, 
    a#112#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#112#0#0, 
      a#112#1#0, 
      a#112#2#0, 
      a#112#3#0, 
      a#112#4#0, 
      a#112#5#0, 
      a#112#6#0, 
      a#112#7#0, 
      a#112#8#0) } 
  JournalDisk.Variables.reqWriteSuperblock2(#JournalDisk.Variables.Variables(a#112#0#0, 
        a#112#1#0, 
        a#112#2#0, 
        a#112#3#0, 
        a#112#4#0, 
        a#112#5#0, 
        a#112#6#0, 
        a#112#7#0, 
        a#112#8#0))
     == a#112#4#0);

// Inductive rank
axiom (forall a#113#0#0: Set Box, 
    a#113#1#0: Set Box, 
    a#113#2#0: Map Box Box, 
    a#113#3#0: DatatypeType, 
    a#113#4#0: DatatypeType, 
    a#113#5#0: Map Box Box, 
    a#113#6#0: DatatypeType, 
    a#113#7#0: DatatypeType, 
    a#113#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#113#0#0, 
      a#113#1#0, 
      a#113#2#0, 
      a#113#3#0, 
      a#113#4#0, 
      a#113#5#0, 
      a#113#6#0, 
      a#113#7#0, 
      a#113#8#0) } 
  DtRank(a#113#4#0)
     < DtRank(#JournalDisk.Variables.Variables(a#113#0#0, 
        a#113#1#0, 
        a#113#2#0, 
        a#113#3#0, 
        a#113#4#0, 
        a#113#5#0, 
        a#113#6#0, 
        a#113#7#0, 
        a#113#8#0)));

function JournalDisk.Variables.reqWriteJournals(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#114#0#0: Set Box, 
    a#114#1#0: Set Box, 
    a#114#2#0: Map Box Box, 
    a#114#3#0: DatatypeType, 
    a#114#4#0: DatatypeType, 
    a#114#5#0: Map Box Box, 
    a#114#6#0: DatatypeType, 
    a#114#7#0: DatatypeType, 
    a#114#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#114#0#0, 
      a#114#1#0, 
      a#114#2#0, 
      a#114#3#0, 
      a#114#4#0, 
      a#114#5#0, 
      a#114#6#0, 
      a#114#7#0, 
      a#114#8#0) } 
  JournalDisk.Variables.reqWriteJournals(#JournalDisk.Variables.Variables(a#114#0#0, 
        a#114#1#0, 
        a#114#2#0, 
        a#114#3#0, 
        a#114#4#0, 
        a#114#5#0, 
        a#114#6#0, 
        a#114#7#0, 
        a#114#8#0))
     == a#114#5#0);

// Inductive map key rank
axiom (forall a#115#0#0: Set Box, 
    a#115#1#0: Set Box, 
    a#115#2#0: Map Box Box, 
    a#115#3#0: DatatypeType, 
    a#115#4#0: DatatypeType, 
    a#115#5#0: Map Box Box, 
    a#115#6#0: DatatypeType, 
    a#115#7#0: DatatypeType, 
    a#115#8#0: Seq Box, 
    d: DatatypeType :: 
  { Map#Domain(a#115#5#0)[$Box(d)], #JournalDisk.Variables.Variables(a#115#0#0, 
      a#115#1#0, 
      a#115#2#0, 
      a#115#3#0, 
      a#115#4#0, 
      a#115#5#0, 
      a#115#6#0, 
      a#115#7#0, 
      a#115#8#0) } 
  Map#Domain(a#115#5#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalDisk.Variables.Variables(a#115#0#0, 
          a#115#1#0, 
          a#115#2#0, 
          a#115#3#0, 
          a#115#4#0, 
          a#115#5#0, 
          a#115#6#0, 
          a#115#7#0, 
          a#115#8#0)));

// Inductive map value rank
axiom (forall a#116#0#0: Set Box, 
    a#116#1#0: Set Box, 
    a#116#2#0: Map Box Box, 
    a#116#3#0: DatatypeType, 
    a#116#4#0: DatatypeType, 
    a#116#5#0: Map Box Box, 
    a#116#6#0: DatatypeType, 
    a#116#7#0: DatatypeType, 
    a#116#8#0: Seq Box, 
    bx: Box :: 
  { Map#Domain(a#116#5#0)[bx], #JournalDisk.Variables.Variables(a#116#0#0, 
      a#116#1#0, 
      a#116#2#0, 
      a#116#3#0, 
      a#116#4#0, 
      a#116#5#0, 
      a#116#6#0, 
      a#116#7#0, 
      a#116#8#0) } 
  Map#Domain(a#116#5#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#116#5#0)[bx]): DatatypeType)
       < DtRank(#JournalDisk.Variables.Variables(a#116#0#0, 
          a#116#1#0, 
          a#116#2#0, 
          a#116#3#0, 
          a#116#4#0, 
          a#116#5#0, 
          a#116#6#0, 
          a#116#7#0, 
          a#116#8#0)));

function JournalDisk.Variables.superblock1(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#117#0#0: Set Box, 
    a#117#1#0: Set Box, 
    a#117#2#0: Map Box Box, 
    a#117#3#0: DatatypeType, 
    a#117#4#0: DatatypeType, 
    a#117#5#0: Map Box Box, 
    a#117#6#0: DatatypeType, 
    a#117#7#0: DatatypeType, 
    a#117#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#117#0#0, 
      a#117#1#0, 
      a#117#2#0, 
      a#117#3#0, 
      a#117#4#0, 
      a#117#5#0, 
      a#117#6#0, 
      a#117#7#0, 
      a#117#8#0) } 
  JournalDisk.Variables.superblock1(#JournalDisk.Variables.Variables(a#117#0#0, 
        a#117#1#0, 
        a#117#2#0, 
        a#117#3#0, 
        a#117#4#0, 
        a#117#5#0, 
        a#117#6#0, 
        a#117#7#0, 
        a#117#8#0))
     == a#117#6#0);

// Inductive rank
axiom (forall a#118#0#0: Set Box, 
    a#118#1#0: Set Box, 
    a#118#2#0: Map Box Box, 
    a#118#3#0: DatatypeType, 
    a#118#4#0: DatatypeType, 
    a#118#5#0: Map Box Box, 
    a#118#6#0: DatatypeType, 
    a#118#7#0: DatatypeType, 
    a#118#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#118#0#0, 
      a#118#1#0, 
      a#118#2#0, 
      a#118#3#0, 
      a#118#4#0, 
      a#118#5#0, 
      a#118#6#0, 
      a#118#7#0, 
      a#118#8#0) } 
  DtRank(a#118#6#0)
     < DtRank(#JournalDisk.Variables.Variables(a#118#0#0, 
        a#118#1#0, 
        a#118#2#0, 
        a#118#3#0, 
        a#118#4#0, 
        a#118#5#0, 
        a#118#6#0, 
        a#118#7#0, 
        a#118#8#0)));

function JournalDisk.Variables.superblock2(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#119#0#0: Set Box, 
    a#119#1#0: Set Box, 
    a#119#2#0: Map Box Box, 
    a#119#3#0: DatatypeType, 
    a#119#4#0: DatatypeType, 
    a#119#5#0: Map Box Box, 
    a#119#6#0: DatatypeType, 
    a#119#7#0: DatatypeType, 
    a#119#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#119#0#0, 
      a#119#1#0, 
      a#119#2#0, 
      a#119#3#0, 
      a#119#4#0, 
      a#119#5#0, 
      a#119#6#0, 
      a#119#7#0, 
      a#119#8#0) } 
  JournalDisk.Variables.superblock2(#JournalDisk.Variables.Variables(a#119#0#0, 
        a#119#1#0, 
        a#119#2#0, 
        a#119#3#0, 
        a#119#4#0, 
        a#119#5#0, 
        a#119#6#0, 
        a#119#7#0, 
        a#119#8#0))
     == a#119#7#0);

// Inductive rank
axiom (forall a#120#0#0: Set Box, 
    a#120#1#0: Set Box, 
    a#120#2#0: Map Box Box, 
    a#120#3#0: DatatypeType, 
    a#120#4#0: DatatypeType, 
    a#120#5#0: Map Box Box, 
    a#120#6#0: DatatypeType, 
    a#120#7#0: DatatypeType, 
    a#120#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#120#0#0, 
      a#120#1#0, 
      a#120#2#0, 
      a#120#3#0, 
      a#120#4#0, 
      a#120#5#0, 
      a#120#6#0, 
      a#120#7#0, 
      a#120#8#0) } 
  DtRank(a#120#7#0)
     < DtRank(#JournalDisk.Variables.Variables(a#120#0#0, 
        a#120#1#0, 
        a#120#2#0, 
        a#120#3#0, 
        a#120#4#0, 
        a#120#5#0, 
        a#120#6#0, 
        a#120#7#0, 
        a#120#8#0)));

function JournalDisk.Variables.journal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#121#0#0: Set Box, 
    a#121#1#0: Set Box, 
    a#121#2#0: Map Box Box, 
    a#121#3#0: DatatypeType, 
    a#121#4#0: DatatypeType, 
    a#121#5#0: Map Box Box, 
    a#121#6#0: DatatypeType, 
    a#121#7#0: DatatypeType, 
    a#121#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#121#0#0, 
      a#121#1#0, 
      a#121#2#0, 
      a#121#3#0, 
      a#121#4#0, 
      a#121#5#0, 
      a#121#6#0, 
      a#121#7#0, 
      a#121#8#0) } 
  JournalDisk.Variables.journal(#JournalDisk.Variables.Variables(a#121#0#0, 
        a#121#1#0, 
        a#121#2#0, 
        a#121#3#0, 
        a#121#4#0, 
        a#121#5#0, 
        a#121#6#0, 
        a#121#7#0, 
        a#121#8#0))
     == a#121#8#0);

// Inductive seq element rank
axiom (forall a#122#0#0: Set Box, 
    a#122#1#0: Set Box, 
    a#122#2#0: Map Box Box, 
    a#122#3#0: DatatypeType, 
    a#122#4#0: DatatypeType, 
    a#122#5#0: Map Box Box, 
    a#122#6#0: DatatypeType, 
    a#122#7#0: DatatypeType, 
    a#122#8#0: Seq Box, 
    i: int :: 
  { Seq#Index(a#122#8#0, i), #JournalDisk.Variables.Variables(a#122#0#0, 
      a#122#1#0, 
      a#122#2#0, 
      a#122#3#0, 
      a#122#4#0, 
      a#122#5#0, 
      a#122#6#0, 
      a#122#7#0, 
      a#122#8#0) } 
  0 <= i && i < Seq#Length(a#122#8#0)
     ==> DtRank($Unbox(Seq#Index(a#122#8#0, i)): DatatypeType)
       < DtRank(#JournalDisk.Variables.Variables(a#122#0#0, 
          a#122#1#0, 
          a#122#2#0, 
          a#122#3#0, 
          a#122#4#0, 
          a#122#5#0, 
          a#122#6#0, 
          a#122#7#0, 
          a#122#8#0)));

// Inductive seq rank
axiom (forall a#123#0#0: Set Box, 
    a#123#1#0: Set Box, 
    a#123#2#0: Map Box Box, 
    a#123#3#0: DatatypeType, 
    a#123#4#0: DatatypeType, 
    a#123#5#0: Map Box Box, 
    a#123#6#0: DatatypeType, 
    a#123#7#0: DatatypeType, 
    a#123#8#0: Seq Box :: 
  { #JournalDisk.Variables.Variables(a#123#0#0, 
      a#123#1#0, 
      a#123#2#0, 
      a#123#3#0, 
      a#123#4#0, 
      a#123#5#0, 
      a#123#6#0, 
      a#123#7#0, 
      a#123#8#0) } 
  Seq#Rank(a#123#8#0)
     < DtRank(#JournalDisk.Variables.Variables(a#123#0#0, 
        a#123#1#0, 
        a#123#2#0, 
        a#123#3#0, 
        a#123#4#0, 
        a#123#5#0, 
        a#123#6#0, 
        a#123#7#0, 
        a#123#8#0)));

// Depth-one case-split function
function $IsA#JournalDisk.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.Variables(d) } 
  $IsA#JournalDisk.Variables(d) ==> JournalDisk.Variables.Variables_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.Variables.Variables_q(d), $Is(d, Tclass.JournalDisk.Variables()) } 
  $Is(d, Tclass.JournalDisk.Variables()) ==> JournalDisk.Variables.Variables_q(d));

// Datatype extensional equality declaration
function JournalDisk.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.Variables.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.Variables#Equal(a, b) } 
  true
     ==> (JournalDisk.Variables#Equal(a, b)
       <==> Set#Equal(JournalDisk.Variables.reqReadSuperblock1(a), 
          JournalDisk.Variables.reqReadSuperblock1(b))
         && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(a), 
          JournalDisk.Variables.reqReadSuperblock2(b))
         && Map#Equal(JournalDisk.Variables.reqReadJournals(a), 
          JournalDisk.Variables.reqReadJournals(b))
         && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(a), 
          JournalDisk.Variables.reqWriteSuperblock1(b))
         && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(a), 
          JournalDisk.Variables.reqWriteSuperblock2(b))
         && Map#Equal(JournalDisk.Variables.reqWriteJournals(a), 
          JournalDisk.Variables.reqWriteJournals(b))
         && Options.Option#Equal(JournalDisk.Variables.superblock1(a), JournalDisk.Variables.superblock1(b))
         && Options.Option#Equal(JournalDisk.Variables.superblock2(a), JournalDisk.Variables.superblock2(b))
         && Seq#Equal(JournalDisk.Variables.journal(a), JournalDisk.Variables.journal(b))));

// Datatype extensionality axiom: JournalDisk.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.Variables#Equal(a, b) } 
  JournalDisk.Variables#Equal(a, b) <==> a == b);

const unique class.JournalDisk.Variables: ClassName;

// Constructor function declaration
function #JournalDisk.InternalStep.ProcessWriteSuperblockStep(int) : DatatypeType;

const unique ##JournalDisk.InternalStep.ProcessWriteSuperblockStep: DtCtorId;

// Constructor identifier
axiom (forall a#124#0#0: int :: 
  { #JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#124#0#0) } 
  DatatypeCtorId(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#124#0#0))
     == ##JournalDisk.InternalStep.ProcessWriteSuperblockStep);

function JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d) } 
  JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalDisk.InternalStep.ProcessWriteSuperblockStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d) } 
  JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d)
     ==> (exists a#125#0#0: int :: 
      d == #JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#125#0#0)));

function Tclass.JournalDisk.InternalStep() : Ty;

// Tclass.JournalDisk.InternalStep Tag
axiom Tag(Tclass.JournalDisk.InternalStep()) == Tagclass.JournalDisk.InternalStep;

const unique Tagclass.JournalDisk.InternalStep: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.InternalStep
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.InternalStep()) } 
  $IsBox(bx, Tclass.JournalDisk.InternalStep())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalDisk.InternalStep()));

// Constructor $Is
axiom (forall a#126#0#0: int :: 
  { $Is(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#126#0#0), 
      Tclass.JournalDisk.InternalStep()) } 
  $Is(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#126#0#0), 
      Tclass.JournalDisk.InternalStep())
     <==> $Is(a#126#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#127#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#127#0#0), 
      Tclass.JournalDisk.InternalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#127#0#0), 
        Tclass.JournalDisk.InternalStep(), 
        $h)
       <==> $IsAlloc(a#127#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalDisk.InternalStep.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d)
       && $IsAlloc(d, Tclass.JournalDisk.InternalStep(), $h)
     ==> $IsAlloc(JournalDisk.InternalStep.which(d), TInt, $h));

// Constructor literal
axiom (forall a#128#0#0: int :: 
  { #JournalDisk.InternalStep.ProcessWriteSuperblockStep(LitInt(a#128#0#0)) } 
  #JournalDisk.InternalStep.ProcessWriteSuperblockStep(LitInt(a#128#0#0))
     == Lit(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#128#0#0)));

function JournalDisk.InternalStep.which(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#129#0#0: int :: 
  { #JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#129#0#0) } 
  JournalDisk.InternalStep.which(#JournalDisk.InternalStep.ProcessWriteSuperblockStep(a#129#0#0))
     == a#129#0#0);

// Depth-one case-split function
function $IsA#JournalDisk.InternalStep(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalDisk.InternalStep(d) } 
  $IsA#JournalDisk.InternalStep(d)
     ==> JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d), $Is(d, Tclass.JournalDisk.InternalStep()) } 
  $Is(d, Tclass.JournalDisk.InternalStep())
     ==> JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(d));

// Datatype extensional equality declaration
function JournalDisk.InternalStep#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalDisk.InternalStep.ProcessWriteSuperblockStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.InternalStep#Equal(a, b) } 
  true
     ==> (JournalDisk.InternalStep#Equal(a, b)
       <==> JournalDisk.InternalStep.which(a) == JournalDisk.InternalStep.which(b)));

// Datatype extensionality axiom: JournalDisk.InternalStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalDisk.InternalStep#Equal(a, b) } 
  JournalDisk.InternalStep#Equal(a, b) <==> a == b);

const unique class.JournalDisk.InternalStep: ClassName;

const unique class.JournalDisk.__default: ClassName;

function Tclass.JournalDisk.__default() : Ty;

// Tclass.JournalDisk.__default Tag
axiom Tag(Tclass.JournalDisk.__default()) == Tagclass.JournalDisk.__default;

const unique Tagclass.JournalDisk.__default: TyTag;

// Box/unbox axiom for Tclass.JournalDisk.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalDisk.__default()) } 
  $IsBox(bx, Tclass.JournalDisk.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalDisk.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalDisk.__default()) } 
  $Is($o, Tclass.JournalDisk.__default())
     <==> $o == null || dtype($o) == Tclass.JournalDisk.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalDisk.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalDisk.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalDisk._default.Init
function JournalDisk.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function JournalDisk.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for JournalDisk.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalDisk.__default.Init(k#0, s#0) } 
    JournalDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables()))
       ==> true);

function JournalDisk.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { JournalDisk.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
     ==> JournalDisk.__default.Init#requires(k#0, s#0) == true);

// definition axiom for JournalDisk.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalDisk.__default.Init(k#0, s#0) } 
    JournalDisk.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables()))
       ==> JournalDisk.Variables.Variables_q(s#0)
         && (Set#Equal(JournalDisk.Variables.reqReadSuperblock1(s#0), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(s#0), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && Map#Equal(JournalDisk.Variables.reqReadJournals(s#0), Map#Empty(): Map Box Box)
           ==> $IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock1(s#0))
             && JournalDisk.Variables.Variables_q(s#0))
         && ($IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock1(s#0))
             && JournalDisk.Variables.Variables_q(s#0)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(s#0), #Options.Option.None())
           ==> $IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock2(s#0))
             && JournalDisk.Variables.Variables_q(s#0))
         && ($IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock2(s#0))
             && JournalDisk.Variables.Variables_q(s#0)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(s#0), #Options.Option.None())
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(s#0), Map#Empty(): Map Box Box)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && JournalDisk.__default.Init(k#0, s#0)
           == (
            Set#Equal(JournalDisk.Variables.reqReadSuperblock1(s#0), Set#Empty(): Set Box)
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(s#0), Set#Empty(): Set Box)
             && Map#Equal(JournalDisk.Variables.reqReadJournals(s#0), Map#Empty(): Map Box Box)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(s#0), #Options.Option.None())
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(s#0), #Options.Option.None())
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(s#0), Map#Empty(): Map Box Box)
             && Seq#Length(JournalDisk.Variables.journal(s#0))
               == LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalDisk.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.Init(Lit(k#0), Lit(s#0)) } 
    JournalDisk.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables()))
       ==> JournalDisk.Variables.Variables_q(Lit(s#0))
         && (Set#Equal(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(JournalDisk.Variables.reqReadJournals(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> $IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
             && JournalDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
             && JournalDisk.Variables.Variables_q(Lit(s#0))
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)), #Options.Option.None())
           ==> $IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))
             && JournalDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))
             && JournalDisk.Variables.Variables_q(Lit(s#0))
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0)), #Options.Option.None())
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(Lit(s#0)), Map#Empty(): Map Box Box)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && JournalDisk.__default.Init(Lit(k#0), Lit(s#0))
           == (
            Set#Equal(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), Set#Empty(): Set Box)
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)), Set#Empty(): Set Box)
             && Map#Equal(JournalDisk.Variables.reqReadJournals(Lit(s#0)), Map#Empty(): Map Box Box)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)), #Options.Option.None())
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0)), #Options.Option.None())
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(Lit(s#0)), Map#Empty(): Map Box Box)
             && Seq#Length(Lit(JournalDisk.Variables.journal(Lit(s#0))))
               == LitInt(DiskLayout.__default.NumJournalBlocks())));

// function declaration for JournalDisk._default.RecvReadSuperblock
function JournalDisk.__default.RecvReadSuperblock(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.RecvReadSuperblock#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.RecvReadSuperblock
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvReadSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvReadSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.RecvReadSuperblock#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.RecvReadSuperblock
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.RecvReadSuperblock#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.RecvReadSuperblock#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.RecvReadSuperblock(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvReadSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvReadSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.ReqReadSuperblockOp_q(dop#0)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && !JournalDisk.Variables.reqReadSuperblock1(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
             || JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(0)
           ==> $IsA#JournalDisk.Variables(s'#0)
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && ((JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#0 := s#0; 
                  #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                    JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> $IsA#JournalDisk.Variables(s'#0)
             && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                  Set#Union(JournalDisk.Variables.reqReadSuperblock2(s#0), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#1#0))))
             && (var dt_update_tmp#1#0 := s#0; 
              JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)))
         && JournalDisk.__default.RecvReadSuperblock(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.ReqReadSuperblockOp_q(dop#0)
             && !JournalDisk.Variables.reqReadSuperblock1(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
             && !JournalDisk.Variables.reqReadSuperblock2(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               || JournalDisk.DiskOp.which(dop#0) == LitInt(1))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#0 := s#0; 
                  #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                    JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(1)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#1#0 := s#0; 
                  #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                    Set#Union(JournalDisk.Variables.reqReadSuperblock2(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                    JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                    JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                    JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                    JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                    JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                    JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                    JournalDisk.Variables.journal(dt_update_tmp#1#0)))))));

// definition axiom for JournalDisk.__default.RecvReadSuperblock for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.RecvReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.RecvReadSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.ReqReadSuperblockOp_q(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && !Lit(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
             || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
           ==> $IsA#JournalDisk.Variables(Lit(s'#0))
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && ((LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                    Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> $IsA#JournalDisk.Variables(Lit(s'#0))
             && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := Lit(s#0); 
                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                  Set#Union(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)), 
                    Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1)), 
                  Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                  Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1)))))
             && (var dt_update_tmp#1#1 := Lit(s#0); 
              JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)))
         && JournalDisk.__default.RecvReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.ReqReadSuperblockOp_q(Lit(dop#0))
             && !Lit(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
             && !Lit(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  #JournalDisk.Variables.Variables(Set#Union(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                    Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#1#1 := Lit(s#0); 
                  #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                    Set#Union(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                    Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1))))))));

// function declaration for JournalDisk._default.RecvReadJournal
function JournalDisk.__default.RecvReadJournal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.RecvReadJournal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.RecvReadJournal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvReadJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvReadJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.RecvReadJournal#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.RecvReadJournal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.RecvReadJournal#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.RecvReadJournal#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.RecvReadJournal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvReadJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvReadJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && !Map#Domain(JournalDisk.Variables.reqReadJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]
           ==> JournalIntervals.__default.ContiguousJournalInterval#canCall(JournalDisk.DiskOp.interval(dop#0)))
         && (JournalIntervals.__default.ContiguousJournalInterval#canCall(JournalDisk.DiskOp.interval(dop#0))
             && JournalIntervals.__default.ContiguousJournalInterval(JournalDisk.DiskOp.interval(dop#0))
           ==> $IsA#JournalDisk.Variables(s'#0)
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                  Map#Build(JournalDisk.Variables.reqReadJournals(s#0), 
                    $Box(JournalDisk.DiskOp.id(dop#0)), 
                    $Box(JournalDisk.DiskOp.interval(dop#0))), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && JournalDisk.__default.RecvReadJournal(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
             && !Map#Domain(JournalDisk.Variables.reqReadJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]
             && JournalIntervals.__default.ContiguousJournalInterval(JournalDisk.DiskOp.interval(dop#0))
             && JournalDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                  Map#Build(JournalDisk.Variables.reqReadJournals(s#0), 
                    $Box(JournalDisk.DiskOp.id(dop#0)), 
                    $Box(JournalDisk.DiskOp.interval(dop#0))), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#0#0))))));

// definition axiom for JournalDisk.__default.RecvReadJournal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.RecvReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.RecvReadJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && !Map#Domain(JournalDisk.Variables.reqReadJournals(Lit(s#0)))[$Box(JournalDisk.DiskOp.id(Lit(dop#0)))]
           ==> JournalIntervals.__default.ContiguousJournalInterval#canCall(Lit(JournalDisk.DiskOp.interval(Lit(dop#0)))))
         && (JournalIntervals.__default.ContiguousJournalInterval#canCall(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))
             && Lit(JournalIntervals.__default.ContiguousJournalInterval(Lit(JournalDisk.DiskOp.interval(Lit(dop#0)))))
           ==> $IsA#JournalDisk.Variables(Lit(s'#0))
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                  Map#Build(Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))), 
                    $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))), 
                    $Box(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && JournalDisk.__default.RecvReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0))
             && !Map#Domain(JournalDisk.Variables.reqReadJournals(Lit(s#0)))[$Box(JournalDisk.DiskOp.id(Lit(dop#0)))]
             && JournalIntervals.__default.ContiguousJournalInterval(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))
             && JournalDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                  Map#Build(Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))), 
                    $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))), 
                    $Box(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))));

// function declaration for JournalDisk._default.RecvWriteSuperblock
function JournalDisk.__default.RecvWriteSuperblock(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.RecvWriteSuperblock#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.RecvWriteSuperblock
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvWriteSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.RecvWriteSuperblock#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.RecvWriteSuperblock
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.RecvWriteSuperblock#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.RecvWriteSuperblock#requires(k#0, s#0, s'#0, dop#0)
       == true);

// definition axiom for JournalDisk.__default.RecvWriteSuperblock(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvWriteSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))
         && (JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
               ==> JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 != JournalDisk.DiskOp.id(dop#0))
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock2(s#0))
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)))
         && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
             || JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(0)
           ==> $IsA#JournalDisk.Variables(s'#0)
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                  #Options.Option.Some($Box(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(JournalDisk.DiskOp.id(dop#0), JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && ((JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      #Options.Option.Some($Box(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(JournalDisk.DiskOp.id(dop#0), JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#0 := s#0; 
                  #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                    #Options.Option.Some($Box(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(JournalDisk.DiskOp.id(dop#0), JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))), 
                    JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> $IsA#JournalDisk.Variables(s'#0)
             && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                  #Options.Option.Some($Box(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(JournalDisk.DiskOp.id(dop#0), JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))), 
                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#1#0))))
             && (var dt_update_tmp#1#0 := s#0; 
              JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)))
         && JournalDisk.__default.RecvWriteSuperblock(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
               ==> JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 != JournalDisk.DiskOp.id(dop#0))
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock2(s#0))
               ==> JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
                 != JournalDisk.DiskOp.id(dop#0))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               || JournalDisk.DiskOp.which(dop#0) == LitInt(1))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#0 := s#0; 
                  #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                    #Options.Option.Some($Box(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(JournalDisk.DiskOp.id(dop#0), JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))), 
                    JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                    JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                    JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(1)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#1#0 := s#0; 
                  #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                    JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                    JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                    JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                    #Options.Option.Some($Box(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(JournalDisk.DiskOp.id(dop#0), JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))), 
                    JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                    JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                    JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                    JournalDisk.Variables.journal(dt_update_tmp#1#0)))))));

// definition axiom for JournalDisk.__default.RecvWriteSuperblock for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.RecvWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.RecvWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)))))
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)))))
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
             && Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
                 ==> JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                   != JournalDisk.DiskOp.id(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0)))))
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))))
         && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
             || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
           ==> $IsA#JournalDisk.Variables(Lit(s'#0))
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                    Lit(#Options.Option.Some($Box(Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))), 
                              Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))))))), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                    Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && ((LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.Some($Box(Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))), 
                                  Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))))))), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                      Lit(#Options.Option.Some($Box(Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))), 
                                Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))))))), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))))
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> $IsA#JournalDisk.Variables(Lit(s'#0))
             && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := Lit(s#0); 
                Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                    Lit(#Options.Option.Some($Box(Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))), 
                              Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))))))), 
                    Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                    Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1))))))
             && (var dt_update_tmp#1#1 := Lit(s#0); 
              JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)))
         && JournalDisk.__default.RecvWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0))
             && (Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
               ==> JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                 != JournalDisk.DiskOp.id(Lit(dop#0)))
             && (Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))
               ==> JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))
                 != JournalDisk.DiskOp.id(Lit(dop#0)))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                      Lit(#Options.Option.Some($Box(Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))), 
                                Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))))))), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
               ==> JournalDisk.Variables#Equal(s'#0, 
                (var dt_update_tmp#1#1 := Lit(s#0); 
                  Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                      Lit(#Options.Option.Some($Box(Lit(#JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))), 
                                Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))))))), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1)))))))));

// function declaration for JournalDisk._default.ValidJournalInterval
function JournalDisk.__default.ValidJournalInterval(interval#0: DatatypeType) : bool;

function JournalDisk.__default.ValidJournalInterval#canCall(interval#0: DatatypeType) : bool;

// consequence axiom for JournalDisk.__default.ValidJournalInterval
axiom true
   ==> (forall interval#0: DatatypeType :: 
    { JournalDisk.__default.ValidJournalInterval(interval#0) } 
    JournalDisk.__default.ValidJournalInterval#canCall(interval#0)
         || $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
       ==> true);

function JournalDisk.__default.ValidJournalInterval#requires(DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.ValidJournalInterval
axiom (forall interval#0: DatatypeType :: 
  { JournalDisk.__default.ValidJournalInterval#requires(interval#0) } 
  $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
     ==> JournalDisk.__default.ValidJournalInterval#requires(interval#0) == true);

// definition axiom for JournalDisk.__default.ValidJournalInterval(revealed)
axiom true
   ==> (forall interval#0: DatatypeType :: 
    { JournalDisk.__default.ValidJournalInterval(interval#0) } 
    JournalDisk.__default.ValidJournalInterval#canCall(interval#0)
         || $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
         && (LitInt(0) <= JournalIntervals.JournalInterval.start(interval#0)
           ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && JournalIntervals.JournalInterval.start(interval#0)
               < DiskLayout.__default.NumJournalBlocks()
           ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
             && (LitInt(0) <= JournalIntervals.JournalInterval.len(interval#0)
               ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalDisk.__default.ValidJournalInterval(interval#0)
           == (
            LitInt(0) <= JournalIntervals.JournalInterval.start(interval#0)
             && JournalIntervals.JournalInterval.start(interval#0)
               < DiskLayout.__default.NumJournalBlocks()
             && 
            LitInt(0) <= JournalIntervals.JournalInterval.len(interval#0)
             && JournalIntervals.JournalInterval.len(interval#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalDisk.__default.ValidJournalInterval for all literals(revealed)
axiom true
   ==> (forall interval#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.ValidJournalInterval(Lit(interval#0)) } 
    JournalDisk.__default.ValidJournalInterval#canCall(Lit(interval#0))
         || $Is(interval#0, Tclass.JournalIntervals.JournalInterval())
       ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
         && (LitInt(0) <= LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0)))
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && Lit(JournalIntervals.JournalInterval.start(Lit(interval#0))
                 < DiskLayout.__default.NumJournalBlocks())
           ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
             && (LitInt(0) <= LitInt(JournalIntervals.JournalInterval.len(Lit(interval#0)))
               ==> JournalIntervals.JournalInterval.JournalInterval_q(Lit(interval#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && JournalDisk.__default.ValidJournalInterval(Lit(interval#0))
           == (
            LitInt(0) <= LitInt(JournalIntervals.JournalInterval.start(Lit(interval#0)))
             && JournalIntervals.JournalInterval.start(Lit(interval#0))
               < DiskLayout.__default.NumJournalBlocks()
             && 
            LitInt(0) <= LitInt(JournalIntervals.JournalInterval.len(Lit(interval#0)))
             && LitInt(JournalIntervals.JournalInterval.len(Lit(interval#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// function declaration for JournalDisk._default.RecvWriteJournal
function JournalDisk.__default.RecvWriteJournal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.RecvWriteJournal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.RecvWriteJournal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvWriteJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvWriteJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.RecvWriteJournal#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.RecvWriteJournal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.RecvWriteJournal#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.RecvWriteJournal#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.RecvWriteJournal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.RecvWriteJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.RecvWriteJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && !Map#Domain(JournalDisk.Variables.reqWriteJournals(s#0))[$Box(JournalDisk.DiskOp.id1(dop#0))]
           ==> 
          Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
           ==> JournalDisk.Variables.Variables_q(s#0))
         && ((Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
               ==> JournalDisk.Variables.Variables_q(s#0))
             && (Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
               ==> !Map#Domain(JournalDisk.Variables.reqWriteJournals(s#0))[Options.Option.value(JournalDisk.DiskOp.id2(dop#0))])
           ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0))
             && JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0))
             && (var interval#0 := #JournalIntervals.JournalInterval.JournalInterval(JournalDisk.ReqWriteJournal.start(JournalDisk.DiskOp.reqWriteJournal(dop#0)), 
                  Seq#Length(JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)))); 
              JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.Variables.Variables_q(s'#0)
                 && JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0))
                 && JournalIntervals.__default.JournalUpdate#canCall(JournalDisk.Variables.journal(s#0), 
                  JournalDisk.Variables.journal(s'#0), 
                  interval#0, 
                  JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)))
                 && (JournalIntervals.__default.JournalUpdate(StartFuel_JournalIntervals._default.JournalUpdate, 
                    JournalDisk.Variables.journal(s#0), 
                    JournalDisk.Variables.journal(s'#0), 
                    interval#0, 
                    JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)))
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && (JournalIntervals.JournalInterval.start(interval#0)
                           + JournalIntervals.JournalInterval.len(interval#0)
                         <= LitInt(DiskLayout.__default.NumJournalBlocks())
                       ==> 
                      Options.Option.None_q(JournalDisk.DiskOp.id2(dop#0))
                       ==> $IsA#JournalDisk.Variables(s'#0)
                         && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                                  Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                    $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                    $Box(interval#0)), 
                                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.journal(dt_update_tmp#0#0))); 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.journal(s'#0))))
                         && 
                        (var dt_update_tmp#0#0 := s#0; 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(s#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))
                         && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                                Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                  $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                  $Box(interval#0)), 
                                JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                                JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                                JournalDisk.Variables.journal(dt_update_tmp#0#0))); 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(s'#0))))
                 && (JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && (JournalIntervals.JournalInterval.start(interval#0)
                           + JournalIntervals.JournalInterval.len(interval#0)
                         <= LitInt(DiskLayout.__default.NumJournalBlocks())
                       ==> 
                      Options.Option.None_q(JournalDisk.DiskOp.id2(dop#0))
                       ==> $IsA#JournalDisk.Variables(s'#0)
                         && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                                  Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                    $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                    $Box(interval#0)), 
                                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.journal(dt_update_tmp#0#0))); 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.journal(s'#0))))
                         && 
                        (var dt_update_tmp#0#0 := s#0; 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(s#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))
                         && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                                JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                                Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                  $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                  $Box(interval#0)), 
                                JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                                JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                                JournalDisk.Variables.journal(dt_update_tmp#0#0))); 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                             && JournalDisk.Variables.Variables_q(s'#0)))
                     && (JournalIntervals.JournalInterval.start(interval#0)
                           + JournalIntervals.JournalInterval.len(interval#0)
                         <= LitInt(DiskLayout.__default.NumJournalBlocks())
                       ==> Options.Option.None_q(JournalDisk.DiskOp.id2(dop#0))
                         && JournalDisk.Variables#Equal(s'#0, 
                          (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                                  Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                    $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                    $Box(interval#0)), 
                                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                                  JournalDisk.Variables.journal(dt_update_tmp#0#0))); 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                              JournalDisk.Variables.journal(s'#0)))))
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && (JournalIntervals.JournalInterval.start(interval#0)
                           + JournalIntervals.JournalInterval.len(interval#0)
                         > DiskLayout.__default.NumJournalBlocks()
                       ==> 
                      $Unbox(Options.Option.value(JournalDisk.DiskOp.id2(dop#0))): int
                         != JournalDisk.DiskOp.id1(dop#0)
                       ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                         && 
                        DiskLayout.__default.NumJournalBlocks#canCall()
                         && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                         && (var interval1#0 := #JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(interval#0), 
                              DiskLayout.__default.NumJournalBlocks()
                                 - JournalIntervals.JournalInterval.start(interval#0)); 
                          Lit(true)
                             ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                               && 
                              DiskLayout.__default.NumJournalBlocks#canCall()
                               && JournalIntervals.JournalInterval.JournalInterval_q(interval#0)
                               && (var interval2#0 := #JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                                    JournalIntervals.JournalInterval.len(interval#0)
                                       - 
                                      (DiskLayout.__default.NumJournalBlocks()
                                       - JournalIntervals.JournalInterval.start(interval#0))); 
                                Lit(true)
                                   ==> $IsA#JournalDisk.Variables(s'#0)
                                     && $IsA#JournalDisk.Variables((var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#2#0), 
                                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#2#0), 
                                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#2#0), 
                                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#2#0), 
                                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#2#0), 
                                              Map#Build(Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                                  $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                                  $Box(interval1#0)), 
                                                Options.Option.value(JournalDisk.DiskOp.id2(dop#0)), 
                                                $Box(interval2#0)), 
                                              JournalDisk.Variables.superblock1(dt_update_tmp#2#0), 
                                              JournalDisk.Variables.superblock2(dt_update_tmp#2#0), 
                                              JournalDisk.Variables.journal(dt_update_tmp#2#0))); 
                                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.superblock1(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.superblock2(dt_update_tmp#3#0), 
                                          JournalDisk.Variables.journal(s'#0))))
                                     && 
                                    (var dt_update_tmp#2#0 := s#0; 
                                      JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(s#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#0))
                                     && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                                          #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#2#0), 
                                            JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#2#0), 
                                            JournalDisk.Variables.reqReadJournals(dt_update_tmp#2#0), 
                                            JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#2#0), 
                                            JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#2#0), 
                                            Map#Build(Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                                $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                                $Box(interval1#0)), 
                                              Options.Option.value(JournalDisk.DiskOp.id2(dop#0)), 
                                              $Box(interval2#0)), 
                                            JournalDisk.Variables.superblock1(dt_update_tmp#2#0), 
                                            JournalDisk.Variables.superblock2(dt_update_tmp#2#0), 
                                            JournalDisk.Variables.journal(dt_update_tmp#2#0))); 
                                      JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#0)
                                         && JournalDisk.Variables.Variables_q(s'#0))))))))
         && JournalDisk.__default.RecvWriteJournal(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
             && !Map#Domain(JournalDisk.Variables.reqWriteJournals(s#0))[$Box(JournalDisk.DiskOp.id1(dop#0))]
             && (Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
               ==> !Map#Domain(JournalDisk.Variables.reqWriteJournals(s#0))[Options.Option.value(JournalDisk.DiskOp.id2(dop#0))])
             && (var interval#0 := #JournalIntervals.JournalInterval.JournalInterval(JournalDisk.ReqWriteJournal.start(JournalDisk.DiskOp.reqWriteJournal(dop#0)), 
                  Seq#Length(JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)))); 
              JournalIntervals.__default.JournalUpdate(StartFuel_JournalIntervals._default.JournalUpdate, 
                  JournalDisk.Variables.journal(s#0), 
                  JournalDisk.Variables.journal(s'#0), 
                  interval#0, 
                  JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)))
                 && (JournalIntervals.JournalInterval.start(interval#0)
                       + JournalIntervals.JournalInterval.len(interval#0)
                     <= LitInt(DiskLayout.__default.NumJournalBlocks())
                   ==> Options.Option.None_q(JournalDisk.DiskOp.id2(dop#0))
                     && JournalDisk.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                              Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                $Box(interval#0)), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                              JournalDisk.Variables.journal(dt_update_tmp#0#0))); 
                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                          JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                          JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                          JournalDisk.Variables.journal(s'#0)))))
                 && (JournalIntervals.JournalInterval.start(interval#0)
                       + JournalIntervals.JournalInterval.len(interval#0)
                     > DiskLayout.__default.NumJournalBlocks()
                   ==> Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                     && $Unbox(Options.Option.value(JournalDisk.DiskOp.id2(dop#0))): int
                       != JournalDisk.DiskOp.id1(dop#0)
                     && (var interval1#0 := #JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(interval#0), 
                          DiskLayout.__default.NumJournalBlocks()
                             - JournalIntervals.JournalInterval.start(interval#0)); 
                      true
                         && (var interval2#0 := #JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                              JournalIntervals.JournalInterval.len(interval#0)
                                 - 
                                (DiskLayout.__default.NumJournalBlocks()
                                 - JournalIntervals.JournalInterval.start(interval#0))); 
                          true
                             && JournalDisk.Variables#Equal(s'#0, 
                              (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#2#0), 
                                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#2#0), 
                                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#2#0), 
                                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#2#0), 
                                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#2#0), 
                                      Map#Build(Map#Build(JournalDisk.Variables.reqWriteJournals(s#0), 
                                          $Box(JournalDisk.DiskOp.id1(dop#0)), 
                                          $Box(interval1#0)), 
                                        Options.Option.value(JournalDisk.DiskOp.id2(dop#0)), 
                                        $Box(interval2#0)), 
                                      JournalDisk.Variables.superblock1(dt_update_tmp#2#0), 
                                      JournalDisk.Variables.superblock2(dt_update_tmp#2#0), 
                                      JournalDisk.Variables.journal(dt_update_tmp#2#0))); 
                                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.superblock1(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.superblock2(dt_update_tmp#3#0), 
                                  JournalDisk.Variables.journal(s'#0))))))))));

// definition axiom for JournalDisk.__default.RecvWriteJournal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.RecvWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.RecvWriteJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && !Lit(Map#Domain(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))))[$Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))]
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0)))))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && ((Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0)))))
               ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
             && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
               ==> !Lit(Map#Domain(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))))[$Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int))])
           ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))
             && JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))
             && (var interval#1 := #JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalDisk.ReqWriteJournal.start(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))), 
                  Seq#Length(Lit(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))))); 
              JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.Variables.Variables_q(Lit(s'#0))
                 && JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))
                 && JournalIntervals.__default.JournalUpdate#canCall(Lit(JournalDisk.Variables.journal(Lit(s#0))), 
                  Lit(JournalDisk.Variables.journal(Lit(s'#0))), 
                  interval#1, 
                  Lit(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))))
                 && (JournalIntervals.__default.JournalUpdate(StartFuel_JournalIntervals._default.JournalUpdate, 
                    Lit(JournalDisk.Variables.journal(Lit(s#0))), 
                    Lit(JournalDisk.Variables.journal(Lit(s'#0))), 
                    interval#1, 
                    Lit(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))))
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && (JournalIntervals.JournalInterval.start(interval#1)
                           + JournalIntervals.JournalInterval.len(interval#1)
                         <= LitInt(DiskLayout.__default.NumJournalBlocks())
                       ==> 
                      Lit(Options.Option.None_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0)))))
                       ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                         && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                                  Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                    $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                    $Box(interval#1)), 
                                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))); 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#1#1), 
                              Lit(JournalDisk.Variables.journal(Lit(s'#0))))))
                         && 
                        (var dt_update_tmp#0#1 := Lit(s#0); 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(Lit(s#0))
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))
                         && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                                Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                  $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                  $Box(interval#1)), 
                                Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))); 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(Lit(s'#0)))))
                 && (JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && (JournalIntervals.JournalInterval.start(interval#1)
                           + JournalIntervals.JournalInterval.len(interval#1)
                         <= LitInt(DiskLayout.__default.NumJournalBlocks())
                       ==> 
                      Lit(Options.Option.None_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0)))))
                       ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                         && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                                  Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                    $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                    $Box(interval#1)), 
                                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))); 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#1#1), 
                              Lit(JournalDisk.Variables.journal(Lit(s'#0))))))
                         && 
                        (var dt_update_tmp#0#1 := Lit(s#0); 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(Lit(s#0))
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))
                         && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                                Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                  $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                  $Box(interval#1)), 
                                Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                                Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))); 
                          JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                             && JournalDisk.Variables.Variables_q(Lit(s'#0))))
                     && (JournalIntervals.JournalInterval.start(interval#1)
                           + JournalIntervals.JournalInterval.len(interval#1)
                         <= LitInt(DiskLayout.__default.NumJournalBlocks())
                       ==> Options.Option.None_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                         && JournalDisk.Variables#Equal(s'#0, 
                          (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                                  Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                    $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                    $Box(interval#1)), 
                                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))); 
                            #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1), 
                              JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1), 
                              JournalDisk.Variables.superblock1(dt_update_tmp#1#1), 
                              JournalDisk.Variables.superblock2(dt_update_tmp#1#1), 
                              Lit(JournalDisk.Variables.journal(Lit(s'#0)))))))
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && (JournalIntervals.JournalInterval.start(interval#1)
                           + JournalIntervals.JournalInterval.len(interval#1)
                         > DiskLayout.__default.NumJournalBlocks()
                       ==> 
                      Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int
                           != JournalDisk.DiskOp.id1(Lit(dop#0)))
                       ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                         && 
                        DiskLayout.__default.NumJournalBlocks#canCall()
                         && JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                         && (var interval1#1 := #JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(interval#1), 
                              DiskLayout.__default.NumJournalBlocks()
                                 - JournalIntervals.JournalInterval.start(interval#1)); 
                          Lit(true)
                             ==> JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                               && 
                              DiskLayout.__default.NumJournalBlocks#canCall()
                               && JournalIntervals.JournalInterval.JournalInterval_q(interval#1)
                               && (var interval2#1 := #JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                                    JournalIntervals.JournalInterval.len(interval#1)
                                       - 
                                      (DiskLayout.__default.NumJournalBlocks()
                                       - JournalIntervals.JournalInterval.start(interval#1))); 
                                Lit(true)
                                   ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                                     && $IsA#JournalDisk.Variables((var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                                            #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#2#1)), 
                                              Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#2#1)), 
                                              Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#2#1)), 
                                              Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#2#1)), 
                                              Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#2#1)), 
                                              Map#Build(Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                                  $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                                  $Box(interval1#1)), 
                                                $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)), 
                                                $Box(interval2#1)), 
                                              Lit(JournalDisk.Variables.superblock1(dt_update_tmp#2#1)), 
                                              Lit(JournalDisk.Variables.superblock2(dt_update_tmp#2#1)), 
                                              Lit(JournalDisk.Variables.journal(dt_update_tmp#2#1)))); 
                                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.superblock1(dt_update_tmp#3#1), 
                                          JournalDisk.Variables.superblock2(dt_update_tmp#3#1), 
                                          Lit(JournalDisk.Variables.journal(Lit(s'#0))))))
                                     && 
                                    (var dt_update_tmp#2#1 := Lit(s#0); 
                                      JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(Lit(s#0))
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#2#1))
                                     && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                                          #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#2#1)), 
                                            Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#2#1)), 
                                            Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#2#1)), 
                                            Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#2#1)), 
                                            Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#2#1)), 
                                            Map#Build(Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                                $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                                $Box(interval1#1)), 
                                              $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)), 
                                              $Box(interval2#1)), 
                                            Lit(JournalDisk.Variables.superblock1(dt_update_tmp#2#1)), 
                                            Lit(JournalDisk.Variables.superblock2(dt_update_tmp#2#1)), 
                                            Lit(JournalDisk.Variables.journal(dt_update_tmp#2#1)))); 
                                      JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(dt_update_tmp#3#1)
                                         && JournalDisk.Variables.Variables_q(Lit(s'#0)))))))))
         && JournalDisk.__default.RecvWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0))
             && !Lit(Map#Domain(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))))[$Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))]
             && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
               ==> !Lit(Map#Domain(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))))[$Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int))])
             && (var interval#1 := #JournalIntervals.JournalInterval.JournalInterval(LitInt(JournalDisk.ReqWriteJournal.start(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))), 
                  Seq#Length(Lit(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))))); 
              JournalIntervals.__default.JournalUpdate(StartFuel_JournalIntervals._default.JournalUpdate, 
                  Lit(JournalDisk.Variables.journal(Lit(s#0))), 
                  Lit(JournalDisk.Variables.journal(Lit(s'#0))), 
                  interval#1, 
                  Lit(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))))
                 && (JournalIntervals.JournalInterval.start(interval#1)
                       + JournalIntervals.JournalInterval.len(interval#1)
                     <= LitInt(DiskLayout.__default.NumJournalBlocks())
                   ==> Options.Option.None_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                     && JournalDisk.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                              Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                              Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                              Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                              Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                              Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                $Box(interval#1)), 
                              Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                              Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                              Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))); 
                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1), 
                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1), 
                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1), 
                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1), 
                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1), 
                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1), 
                          JournalDisk.Variables.superblock1(dt_update_tmp#1#1), 
                          JournalDisk.Variables.superblock2(dt_update_tmp#1#1), 
                          Lit(JournalDisk.Variables.journal(Lit(s'#0)))))))
                 && (JournalIntervals.JournalInterval.start(interval#1)
                       + JournalIntervals.JournalInterval.len(interval#1)
                     > DiskLayout.__default.NumJournalBlocks()
                   ==> Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                     && $Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int
                       != JournalDisk.DiskOp.id1(Lit(dop#0))
                     && (var interval1#1 := #JournalIntervals.JournalInterval.JournalInterval(JournalIntervals.JournalInterval.start(interval#1), 
                          DiskLayout.__default.NumJournalBlocks()
                             - JournalIntervals.JournalInterval.start(interval#1)); 
                      true
                         && (var interval2#1 := #JournalIntervals.JournalInterval.JournalInterval(LitInt(0), 
                              JournalIntervals.JournalInterval.len(interval#1)
                                 - 
                                (DiskLayout.__default.NumJournalBlocks()
                                 - JournalIntervals.JournalInterval.start(interval#1))); 
                          true
                             && JournalDisk.Variables#Equal(s'#0, 
                              (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                                    #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#2#1)), 
                                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#2#1)), 
                                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#2#1)), 
                                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#2#1)), 
                                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#2#1)), 
                                      Map#Build(Map#Build(Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                                          $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0)))), 
                                          $Box(interval1#1)), 
                                        $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)), 
                                        $Box(interval2#1)), 
                                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#2#1)), 
                                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#2#1)), 
                                      Lit(JournalDisk.Variables.journal(dt_update_tmp#2#1)))); 
                                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.reqWriteJournals(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.superblock1(dt_update_tmp#3#1), 
                                  JournalDisk.Variables.superblock2(dt_update_tmp#3#1), 
                                  Lit(JournalDisk.Variables.journal(Lit(s'#0))))))))))));

// function declaration for JournalDisk._default.AckReadSuperblock
function JournalDisk.__default.AckReadSuperblock(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.AckReadSuperblock#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.AckReadSuperblock
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckReadSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckReadSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.AckReadSuperblock#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.AckReadSuperblock
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.AckReadSuperblock#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.AckReadSuperblock#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.AckReadSuperblock(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckReadSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckReadSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
             || JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(0)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (JournalDisk.Variables.reqReadSuperblock1(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
               ==> 
              Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
               ==> $IsA#Options.Option(JournalDisk.DiskOp.superblock(dop#0))
                 && $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                 && JournalDisk.Variables.Variables_q(s#0))
             && ((Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> $IsA#Options.Option(JournalDisk.DiskOp.superblock(dop#0))
                     && $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                     && JournalDisk.Variables.Variables_q(s#0))
                 && (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(dop#0), JournalDisk.Variables.superblock1(s#0)))
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))))
         && ((JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && (JournalDisk.Variables.reqReadSuperblock1(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
                   ==> 
                  Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> $IsA#Options.Option(JournalDisk.DiskOp.superblock(dop#0))
                     && $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                     && JournalDisk.Variables.Variables_q(s#0))
                 && ((Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                       ==> $IsA#Options.Option(JournalDisk.DiskOp.superblock(dop#0))
                         && $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                         && JournalDisk.Variables.Variables_q(s#0))
                     && (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                       ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(dop#0), JournalDisk.Variables.superblock1(s#0)))
                   ==> $IsA#JournalDisk.Variables(s'#0)
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                        #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                            Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                          JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                     && (var dt_update_tmp#0#0 := s#0; 
                      JournalDisk.Variables.Variables_q(s#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables.reqReadSuperblock1(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
                 && (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(dop#0), JournalDisk.Variables.superblock1(s#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (JournalDisk.Variables.reqReadSuperblock2(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
               ==> 
              Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
               ==> $IsA#Options.Option(JournalDisk.DiskOp.superblock(dop#0))
                 && $IsA#Options.Option(JournalDisk.Variables.superblock2(s#0))
                 && JournalDisk.Variables.Variables_q(s#0))
             && ((Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> $IsA#Options.Option(JournalDisk.DiskOp.superblock(dop#0))
                     && $IsA#Options.Option(JournalDisk.Variables.superblock2(s#0))
                     && JournalDisk.Variables.Variables_q(s#0))
                 && (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(dop#0), JournalDisk.Variables.superblock2(s#0)))
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                      Set#Difference(JournalDisk.Variables.reqReadSuperblock2(s#0), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#1#0))))
                 && (var dt_update_tmp#1#0 := s#0; 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0))))
         && JournalDisk.__default.AckReadSuperblock(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0)
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               || JournalDisk.DiskOp.which(dop#0) == LitInt(1))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables.reqReadSuperblock1(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
                 && (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(dop#0), JournalDisk.Variables.superblock1(s#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(s#0), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(1)
               ==> JournalDisk.Variables.reqReadSuperblock2(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
                 && (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(dop#0), JournalDisk.Variables.superblock2(s#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                      Set#Difference(JournalDisk.Variables.reqReadSuperblock2(s#0), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#1#0)))))));

// definition axiom for JournalDisk.__default.AckReadSuperblock for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.AckReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.AckReadSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
             || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
               ==> 
              Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
               ==> $IsA#Options.Option(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                 && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                 && JournalDisk.Variables.Variables_q(Lit(s#0)))
             && ((Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
                   ==> $IsA#Options.Option(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                     && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                     && JournalDisk.Variables.Variables_q(Lit(s#0)))
                 && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(Lit(dop#0)), 
                    JournalDisk.Variables.superblock1(Lit(s#0))))
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))))
         && ((LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && (Lit(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
                   ==> 
                  Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
                   ==> $IsA#Options.Option(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                     && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                     && JournalDisk.Variables.Variables_q(Lit(s#0)))
                 && ((Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
                       ==> $IsA#Options.Option(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                         && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                         && JournalDisk.Variables.Variables_q(Lit(s#0)))
                     && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                       ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(Lit(dop#0)), 
                        JournalDisk.Variables.superblock1(Lit(s#0))))
                   ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                        #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                            Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                          Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
                     && (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalDisk.Variables.Variables_q(Lit(s#0))
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> Lit(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
                 && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(Lit(dop#0)), 
                    JournalDisk.Variables.superblock1(Lit(s#0))))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
               ==> 
              Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
               ==> $IsA#Options.Option(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                 && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s#0))))
                 && JournalDisk.Variables.Variables_q(Lit(s#0)))
             && ((Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
                   ==> $IsA#Options.Option(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                     && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s#0))))
                     && JournalDisk.Variables.Variables_q(Lit(s#0)))
                 && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(Lit(dop#0)), 
                    JournalDisk.Variables.superblock2(Lit(s#0))))
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                      Set#Difference(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1)))))
                 && (var dt_update_tmp#1#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1))))
         && JournalDisk.__default.AckReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> Lit(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
                 && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(Lit(dop#0)), 
                    JournalDisk.Variables.superblock1(Lit(s#0))))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Set#Difference(JournalDisk.Variables.reqReadSuperblock1(Lit(s#0)), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
               ==> Lit(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
                 && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                   ==> Options.Option#Equal(JournalDisk.DiskOp.superblock(Lit(dop#0)), 
                    JournalDisk.Variables.superblock2(Lit(s#0))))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                      Set#Difference(JournalDisk.Variables.reqReadSuperblock2(Lit(s#0)), 
                        Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))), 
                      Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1))))))));

// function declaration for JournalDisk._default.AckReadJournal
function JournalDisk.__default.AckReadJournal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.AckReadJournal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.AckReadJournal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckReadJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckReadJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.AckReadJournal#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.AckReadJournal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.AckReadJournal#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.AckReadJournal#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.AckReadJournal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckReadJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckReadJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && Map#Domain(JournalDisk.Variables.reqReadJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (var ind#0 := $Unbox(Map#Elements(JournalDisk.Variables.reqReadJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]): DatatypeType; 
              JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                 && (LitInt(0) <= JournalIntervals.JournalInterval.start(ind#0)
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && 
                    JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#0))
                 && (JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && 
                    JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && JournalIntervals.JournalInterval.start(ind#0)
                       <= JournalIntervals.JournalInterval.start(ind#0)
                         + JournalIntervals.JournalInterval.len(ind#0)
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall())
                 && (JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.start(ind#0)
                         + JournalIntervals.JournalInterval.len(ind#0)
                       <= LitInt(DiskLayout.__default.NumJournalBlocks())
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall())
                 && (JournalIntervals.JournalInterval.JournalInterval_q(ind#0)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.start(ind#0)
                       < DiskLayout.__default.NumJournalBlocks()
                   ==> 
                  Options.Option.Some_q(JournalDisk.DiskOp.journal(dop#0))
                   ==> JournalDisk.Variables.Variables_q(s#0)
                     && JournalIntervals.__default.Disk__HasJournalRange#canCall(JournalDisk.Variables.journal(s#0), ind#0)
                     && (JournalIntervals.__default.Disk__HasJournalRange(JournalDisk.Variables.journal(s#0), ind#0)
                       ==> JournalDisk.Variables.Variables_q(s#0)
                         && JournalIntervals.__default.Disk__JournalRange#canCall(JournalDisk.Variables.journal(s#0), ind#0)))
                 && ((Options.Option.Some_q(JournalDisk.DiskOp.journal(dop#0))
                       ==> JournalDisk.Variables.Variables_q(s#0)
                         && JournalIntervals.__default.Disk__HasJournalRange#canCall(JournalDisk.Variables.journal(s#0), ind#0)
                         && (JournalIntervals.__default.Disk__HasJournalRange(JournalDisk.Variables.journal(s#0), ind#0)
                           ==> JournalDisk.Variables.Variables_q(s#0)
                             && JournalIntervals.__default.Disk__JournalRange#canCall(JournalDisk.Variables.journal(s#0), ind#0)))
                     && (Options.Option.Some_q(JournalDisk.DiskOp.journal(dop#0))
                       ==> JournalIntervals.__default.Disk__HasJournalRange(JournalDisk.Variables.journal(s#0), ind#0)
                         && Seq#Equal($Unbox(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))): Seq Box, 
                          JournalIntervals.__default.Disk__JournalRange(JournalDisk.Variables.journal(s#0), ind#0)))
                   ==> $IsA#JournalDisk.Variables(s'#0)
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                          Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                            Tclass.JournalIntervals.JournalInterval(), 
                            StartFuel_Maps._default.MapRemove1, 
                            JournalDisk.Variables.reqReadJournals(s#0), 
                            $Box(JournalDisk.DiskOp.id(dop#0))), 
                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                          JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                     && (var dt_update_tmp#0#0 := s#0; 
                      JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && 
                        JournalDisk.Variables.Variables_q(s#0)
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.JournalIntervals.JournalInterval(), 
                          JournalDisk.Variables.reqReadJournals(s#0), 
                          $Box(JournalDisk.DiskOp.id(dop#0)))
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))))
         && JournalDisk.__default.AckReadJournal(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
             && Map#Domain(JournalDisk.Variables.reqReadJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]
             && (var ind#0 := $Unbox(Map#Elements(JournalDisk.Variables.reqReadJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]): DatatypeType; 
              LitInt(0) <= JournalIntervals.JournalInterval.start(ind#0)
                 && JournalIntervals.JournalInterval.start(ind#0)
                   <= JournalIntervals.JournalInterval.start(ind#0)
                     + JournalIntervals.JournalInterval.len(ind#0)
                 && JournalIntervals.JournalInterval.start(ind#0)
                     + JournalIntervals.JournalInterval.len(ind#0)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && JournalIntervals.JournalInterval.start(ind#0)
                   < DiskLayout.__default.NumJournalBlocks()
                 && (Options.Option.Some_q(JournalDisk.DiskOp.journal(dop#0))
                   ==> JournalIntervals.__default.Disk__HasJournalRange(JournalDisk.Variables.journal(s#0), ind#0)
                     && Seq#Equal($Unbox(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))): Seq Box, 
                      JournalIntervals.__default.Disk__JournalRange(JournalDisk.Variables.journal(s#0), ind#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                        Tclass.JournalIntervals.JournalInterval(), 
                        StartFuel_Maps._default.MapRemove1, 
                        JournalDisk.Variables.reqReadJournals(s#0), 
                        $Box(JournalDisk.DiskOp.id(dop#0))), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))));

// definition axiom for JournalDisk.__default.AckReadJournal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.AckReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.AckReadJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(JournalDisk.Variables.reqReadJournals(Lit(s#0)))[$Box(JournalDisk.DiskOp.id(Lit(dop#0)))]
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (var ind#1 := $Unbox(Map#Elements(Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType; 
              JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                 && (LitInt(0) <= JournalIntervals.JournalInterval.start(ind#1)
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && 
                    JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#1))
                 && (JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && 
                    JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && JournalIntervals.JournalInterval.start(ind#1)
                       <= JournalIntervals.JournalInterval.start(ind#1)
                         + JournalIntervals.JournalInterval.len(ind#1)
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall())
                 && (JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.start(ind#1)
                         + JournalIntervals.JournalInterval.len(ind#1)
                       <= LitInt(DiskLayout.__default.NumJournalBlocks())
                   ==> JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall())
                 && (JournalIntervals.JournalInterval.JournalInterval_q(ind#1)
                     && DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalIntervals.JournalInterval.start(ind#1)
                       < DiskLayout.__default.NumJournalBlocks()
                   ==> 
                  Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.journal(Lit(dop#0)))))
                   ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalIntervals.__default.Disk__HasJournalRange#canCall(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)
                     && (JournalIntervals.__default.Disk__HasJournalRange(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)
                       ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                         && JournalIntervals.__default.Disk__JournalRange#canCall(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)))
                 && ((Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.journal(Lit(dop#0)))))
                       ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                         && JournalIntervals.__default.Disk__HasJournalRange#canCall(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)
                         && (JournalIntervals.__default.Disk__HasJournalRange(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)
                           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                             && JournalIntervals.__default.Disk__JournalRange#canCall(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)))
                     && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))
                       ==> JournalIntervals.__default.Disk__HasJournalRange(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)
                         && Seq#Equal($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box, 
                          JournalIntervals.__default.Disk__JournalRange(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)))
                   ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                        #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                          Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                            Tclass.JournalIntervals.JournalInterval(), 
                            StartFuel_Maps._default.MapRemove1, 
                            Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))), 
                            $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))), 
                          Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                          Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
                     && (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && 
                        JournalDisk.Variables.Variables_q(Lit(s#0))
                         && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                          Tclass.JournalIntervals.JournalInterval(), 
                          Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))), 
                          $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))))
         && JournalDisk.__default.AckReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0))
             && Map#Domain(JournalDisk.Variables.reqReadJournals(Lit(s#0)))[$Box(JournalDisk.DiskOp.id(Lit(dop#0)))]
             && (var ind#1 := $Unbox(Map#Elements(Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]): DatatypeType; 
              LitInt(0) <= JournalIntervals.JournalInterval.start(ind#1)
                 && JournalIntervals.JournalInterval.start(ind#1)
                   <= JournalIntervals.JournalInterval.start(ind#1)
                     + JournalIntervals.JournalInterval.len(ind#1)
                 && JournalIntervals.JournalInterval.start(ind#1)
                     + JournalIntervals.JournalInterval.len(ind#1)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && JournalIntervals.JournalInterval.start(ind#1)
                   < DiskLayout.__default.NumJournalBlocks()
                 && (Options.Option.Some_q(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))
                   ==> JournalIntervals.__default.Disk__HasJournalRange(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)
                     && Seq#Equal($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box, 
                      JournalIntervals.__default.Disk__JournalRange(Lit(JournalDisk.Variables.journal(Lit(s#0))), ind#1)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                      Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                        Tclass.JournalIntervals.JournalInterval(), 
                        StartFuel_Maps._default.MapRemove1, 
                        Lit(JournalDisk.Variables.reqReadJournals(Lit(s#0))), 
                        $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))));

// function declaration for JournalDisk._default.AckWriteSuperblock
function JournalDisk.__default.AckWriteSuperblock(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.AckWriteSuperblock#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.AckWriteSuperblock
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckWriteSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.AckWriteSuperblock#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.AckWriteSuperblock
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.AckWriteSuperblock#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.AckWriteSuperblock#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.AckWriteSuperblock(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckWriteSuperblock(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
             || JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(0)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
             && (JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 && JournalDisk.DiskOp.id(dop#0)
                   == JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
               ==> $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                 && 
                JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                 && JournalDisk.Variables.Variables_q(s#0))
             && ($IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                 && 
                JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                 && JournalDisk.Variables.Variables_q(s#0)
                 && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                  JournalDisk.Variables.superblock1(s#0))
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      Lit(#Options.Option.None()), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))))
         && ((JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
                   ==> JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                 && (JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                     && JournalDisk.DiskOp.id(dop#0)
                       == JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                   ==> $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                     && 
                    JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                     && JournalDisk.Variables.Variables_q(s#0))
                 && ($IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
                     && 
                    JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                     && JournalDisk.Variables.Variables_q(s#0)
                     && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                      JournalDisk.Variables.superblock1(s#0))
                   ==> $IsA#JournalDisk.Variables(s'#0)
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                          Lit(#Options.Option.None()), 
                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                          JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                     && (var dt_update_tmp#0#0 := s#0; 
                      JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
                 && JournalDisk.DiskOp.id(dop#0)
                   == JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                  JournalDisk.Variables.superblock1(s#0))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      Lit(#Options.Option.None()), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
           ==> 
          JournalDisk.DiskOp.which(dop#0) == LitInt(1)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock2(s#0))
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType))
             && (JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
                 && JournalDisk.DiskOp.id(dop#0)
                   == JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
               ==> $IsA#Options.Option(JournalDisk.Variables.superblock2(s#0))
                 && 
                JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType))
                 && JournalDisk.Variables.Variables_q(s#0))
             && ($IsA#Options.Option(JournalDisk.Variables.superblock2(s#0))
                 && 
                JournalDisk.Variables.Variables_q(s#0)
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType))
                 && JournalDisk.Variables.Variables_q(s#0)
                 && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)))), 
                  JournalDisk.Variables.superblock2(s#0))
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                      Lit(#Options.Option.None()), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#1#0))))
                 && (var dt_update_tmp#1#0 := s#0; 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0))))
         && JournalDisk.__default.AckWriteSuperblock(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               || JournalDisk.DiskOp.which(dop#0) == LitInt(1))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(0)
               ==> Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
                 && JournalDisk.DiskOp.id(dop#0)
                   == JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                 && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                  JournalDisk.Variables.superblock1(s#0))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      Lit(#Options.Option.None()), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
             && (JournalDisk.DiskOp.which(dop#0) == LitInt(1)
               ==> Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock2(s#0))
                 && JournalDisk.DiskOp.id(dop#0)
                   == JournalDisk.ReqWriteSuperblockId.id($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
                 && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)))), 
                  JournalDisk.Variables.superblock2(s#0))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                      Lit(#Options.Option.None()), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#1#0)))))));

// definition axiom for JournalDisk.__default.AckWriteSuperblock for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.AckWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.AckWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
             || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)))))
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
             && (JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                 && LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))
                   == LitInt(JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
               ==> $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                 && 
                JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
                 && JournalDisk.Variables.Variables_q(Lit(s#0)))
             && ($IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                 && 
                JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
                 && JournalDisk.Variables.Variables_q(Lit(s#0))
                 && Options.Option#Equal(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))))), 
                  JournalDisk.Variables.superblock1(Lit(s#0)))
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.None()), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))))
         && ((LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)))))
                   ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
                 && (JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                     && LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))
                       == LitInt(JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
                   ==> $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                     && 
                    JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
                     && JournalDisk.Variables.Variables_q(Lit(s#0)))
                 && ($IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
                     && 
                    JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
                     && JournalDisk.Variables.Variables_q(Lit(s#0))
                     && Options.Option#Equal(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))))), 
                      JournalDisk.Variables.superblock1(Lit(s#0)))
                   ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                        Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                            Lit(#Options.Option.None()), 
                            Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
                     && (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
                 && LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))
                   == LitInt(JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
                 && Options.Option#Equal(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))))), 
                  JournalDisk.Variables.superblock1(Lit(s#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.None()), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))))
           ==> 
          LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0)))))
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType)))
             && (JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))
                 && LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))
                   == LitInt(JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType)))
               ==> $IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s#0))))
                 && 
                JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))))
                 && JournalDisk.Variables.Variables_q(Lit(s#0)))
             && ($IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s#0))))
                 && 
                JournalDisk.Variables.Variables_q(Lit(s#0))
                 && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))))
                 && JournalDisk.Variables.Variables_q(Lit(s#0))
                 && Options.Option#Equal(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))))))), 
                  JournalDisk.Variables.superblock2(Lit(s#0)))
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                        Lit(#Options.Option.None()), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1))))))
                 && (var dt_update_tmp#1#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1))))
         && JournalDisk.__default.AckWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               || LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(0)
               ==> Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
                 && LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))
                   == LitInt(JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))
                 && Options.Option#Equal(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))))), 
                  JournalDisk.Variables.superblock1(Lit(s#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.None()), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))))
             && (LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(1)
               ==> Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))
                 && LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))
                   == LitInt(JournalDisk.ReqWriteSuperblockId.id(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType)))
                 && Options.Option#Equal(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))))))), 
                  JournalDisk.Variables.superblock2(Lit(s#0)))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                        Lit(#Options.Option.None()), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1)))))))));

// function declaration for JournalDisk._default.AckWriteJournal
function JournalDisk.__default.AckWriteJournal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.AckWriteJournal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.AckWriteJournal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckWriteJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckWriteJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.AckWriteJournal#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.AckWriteJournal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.AckWriteJournal#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.AckWriteJournal#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.AckWriteJournal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.AckWriteJournal(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.AckWriteJournal#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
           ==> JournalDisk.Variables.Variables_q(s#0))
         && (JournalDisk.Variables.Variables_q(s#0)
             && Map#Domain(JournalDisk.Variables.reqWriteJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]
           ==> $IsA#JournalDisk.Variables(s'#0)
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.JournalIntervals.JournalInterval(), 
                    StartFuel_Maps._default.MapRemove1, 
                    JournalDisk.Variables.reqWriteJournals(s#0), 
                    $Box(JournalDisk.DiskOp.id(dop#0))), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#0#0))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && 
                JournalDisk.Variables.Variables_q(s#0)
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.JournalIntervals.JournalInterval(), 
                  JournalDisk.Variables.reqWriteJournals(s#0), 
                  $Box(JournalDisk.DiskOp.id(dop#0)))
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)))
         && JournalDisk.__default.AckWriteJournal(k#0, s#0, s'#0, dop#0)
           == (
            JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
             && Map#Domain(JournalDisk.Variables.reqWriteJournals(s#0))[$Box(JournalDisk.DiskOp.id(dop#0))]
             && JournalDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.JournalIntervals.JournalInterval(), 
                    StartFuel_Maps._default.MapRemove1, 
                    JournalDisk.Variables.reqWriteJournals(s#0), 
                    $Box(JournalDisk.DiskOp.id(dop#0))), 
                  JournalDisk.Variables.superblock1(dt_update_tmp#0#0), 
                  JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                  JournalDisk.Variables.journal(dt_update_tmp#0#0))))));

// definition axiom for JournalDisk.__default.AckWriteJournal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.AckWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.AckWriteJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s#0))
             && Map#Domain(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))[$Box(JournalDisk.DiskOp.id(Lit(dop#0)))]
           ==> $IsA#JournalDisk.Variables(Lit(s'#0))
             && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.JournalIntervals.JournalInterval(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                    $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))), 
                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && 
                JournalDisk.Variables.Variables_q(Lit(s#0))
                 && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
                  Tclass.JournalIntervals.JournalInterval(), 
                  Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                  $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                 && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)))
         && JournalDisk.__default.AckWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (
            JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0))
             && Map#Domain(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))[$Box(JournalDisk.DiskOp.id(Lit(dop#0)))]
             && JournalDisk.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                #JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                  Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                    Tclass.JournalIntervals.JournalInterval(), 
                    StartFuel_Maps._default.MapRemove1, 
                    Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))), 
                    $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))), 
                  Lit(JournalDisk.Variables.superblock1(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                  Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))));

// function declaration for JournalDisk._default.Stutter
function JournalDisk.__default.Stutter(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.Stutter#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.Stutter
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.Stutter#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.Stutter
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.Stutter#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.Stutter(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.Stutter(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> $IsA#JournalDisk.Variables(s'#0) && $IsA#JournalDisk.Variables(s#0))
         && JournalDisk.__default.Stutter(k#0, s#0, s'#0, dop#0)
           == (JournalDisk.DiskOp.NoDiskOp_q(dop#0) && JournalDisk.Variables#Equal(s'#0, s#0)));

// definition axiom for JournalDisk.__default.Stutter for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> $IsA#JournalDisk.Variables(Lit(s'#0)) && $IsA#JournalDisk.Variables(Lit(s#0)))
         && JournalDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == (JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && JournalDisk.Variables#Equal(s'#0, s#0)));

// function declaration for JournalDisk._default.Next
function JournalDisk.__default.Next(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

function JournalDisk.__default.Next#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> true);

function JournalDisk.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.Next
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
  { JournalDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
     ==> JournalDisk.__default.Next#requires(k#0, s#0, s'#0, dop#0) == true);

// definition axiom for JournalDisk.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    { JournalDisk.__default.Next(k#0, s#0, s'#0, dop#0) } 
    JournalDisk.__default.Next#canCall(k#0, s#0, s'#0, dop#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (JournalDisk.DiskOp.ReqReadSuperblockOp_q(dop#0)
           ==> JournalDisk.__default.RecvReadSuperblock#canCall(k#0, s#0, s'#0, dop#0))
         && (JournalDisk.__default.RecvReadSuperblock#canCall(k#0, s#0, s'#0, dop#0)
             && JournalDisk.__default.RecvReadSuperblock(k#0, s#0, s'#0, dop#0)
           ==> 
          JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
           ==> JournalDisk.__default.RecvReadJournal#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
               ==> JournalDisk.__default.RecvReadJournal#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
               ==> JournalDisk.__default.RecvReadJournal(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
           ==> JournalDisk.__default.RecvWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.RecvWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.RecvWriteSuperblock(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
           ==> JournalDisk.__default.RecvWriteJournal#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
               ==> JournalDisk.__default.RecvWriteJournal#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
               ==> JournalDisk.__default.RecvWriteJournal(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0)
           ==> JournalDisk.__default.AckReadSuperblock#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.AckReadSuperblock#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.AckReadSuperblock(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
           ==> JournalDisk.__default.AckReadJournal#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
               ==> JournalDisk.__default.AckReadJournal#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
               ==> JournalDisk.__default.AckReadJournal(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
           ==> JournalDisk.__default.AckWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.AckWriteSuperblock#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.AckWriteSuperblock(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
           ==> JournalDisk.__default.AckWriteJournal#canCall(k#0, s#0, s'#0, dop#0))
         && ((JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
               ==> JournalDisk.__default.AckWriteJournal#canCall(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
               ==> JournalDisk.__default.AckWriteJournal(k#0, s#0, s'#0, dop#0))
           ==> 
          JournalDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> JournalDisk.__default.Stutter#canCall(k#0, s#0, s'#0, dop#0))
         && JournalDisk.__default.Next(k#0, s#0, s'#0, dop#0)
           == (
            (JournalDisk.DiskOp.ReqReadSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.RecvReadSuperblock(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
               ==> JournalDisk.__default.RecvReadJournal(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.RecvWriteSuperblock(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
               ==> JournalDisk.__default.RecvWriteJournal(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.AckReadSuperblock(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
               ==> JournalDisk.__default.AckReadJournal(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
               ==> JournalDisk.__default.AckWriteSuperblock(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
               ==> JournalDisk.__default.AckWriteJournal(k#0, s#0, s'#0, dop#0))
             && (JournalDisk.DiskOp.NoDiskOp_q(dop#0)
               ==> JournalDisk.__default.Stutter(k#0, s#0, s'#0, dop#0))));

// definition axiom for JournalDisk.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, dop#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)) } 
    JournalDisk.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp()))
       ==> (Lit(JournalDisk.DiskOp.ReqReadSuperblockOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.RecvReadSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && (JournalDisk.__default.RecvReadSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
             && Lit(JournalDisk.__default.RecvReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.RecvReadJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.RecvReadJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.RecvWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.RecvWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.RecvWriteJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.RecvWriteJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.AckReadSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.AckReadSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.AckReadJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.AckReadJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.AckWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.AckWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.AckWriteJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && ((Lit(JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0)))
               ==> JournalDisk.__default.AckWriteJournal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
             && Lit(JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> JournalDisk.__default.Stutter#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
         && JournalDisk.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0))
           == Lit((JournalDisk.DiskOp.ReqReadSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.RecvWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckReadSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckReadJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.AckWriteJournal(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))
               && (JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
                 ==> JournalDisk.__default.Stutter(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0)))));

// function declaration for JournalDisk._default.ProcessWriteSuperblock
function JournalDisk.__default.ProcessWriteSuperblock(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, which#0: int) : bool;

function JournalDisk.__default.ProcessWriteSuperblock#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, which#0: int) : bool;

// consequence axiom for JournalDisk.__default.ProcessWriteSuperblock
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, which#0: int :: 
    { JournalDisk.__default.ProcessWriteSuperblock(k#0, s#0, s'#0, which#0) } 
    JournalDisk.__default.ProcessWriteSuperblock#canCall(k#0, s#0, s'#0, which#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> true);

function JournalDisk.__default.ProcessWriteSuperblock#requires(DatatypeType, DatatypeType, DatatypeType, int) : bool;

// #requires axiom for JournalDisk.__default.ProcessWriteSuperblock
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, which#0: int :: 
  { JournalDisk.__default.ProcessWriteSuperblock#requires(k#0, s#0, s'#0, which#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
     ==> JournalDisk.__default.ProcessWriteSuperblock#requires(k#0, s#0, s'#0, which#0)
       == true);

// definition axiom for JournalDisk.__default.ProcessWriteSuperblock(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, which#0: int :: 
    { JournalDisk.__default.ProcessWriteSuperblock(k#0, s#0, s'#0, which#0) } 
    JournalDisk.__default.ProcessWriteSuperblock#canCall(k#0, s#0, s'#0, which#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> (which#0 == LitInt(1)
           ==> 
          which#0 == LitInt(0)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      #Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && 
                    JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))))
         && ((which#0 == LitInt(0)
               ==> JournalDisk.Variables.Variables_q(s#0)
                 && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
                   ==> $IsA#JournalDisk.Variables(s'#0)
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#0 := s#0; 
                        #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                          #Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                          JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                          JournalDisk.Variables.journal(dt_update_tmp#0#0))))
                     && (var dt_update_tmp#0#0 := s#0; 
                      JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && 
                        JournalDisk.Variables.Variables_q(s#0)
                         && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)
                         && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType))
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#0))))
             && (which#0 == LitInt(0)
               ==> Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      #Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
           ==> 
          which#0 == LitInt(1)
           ==> JournalDisk.Variables.Variables_q(s#0)
             && (Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock2(s#0))
               ==> $IsA#JournalDisk.Variables(s'#0)
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#1#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                      #Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)))), 
                      JournalDisk.Variables.journal(dt_update_tmp#1#0))))
                 && (var dt_update_tmp#1#0 := s#0; 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0)
                     && 
                    JournalDisk.Variables.Variables_q(s#0)
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#0))))
         && JournalDisk.__default.ProcessWriteSuperblock(k#0, s#0, s'#0, which#0)
           == (
            (which#0 == LitInt(0) || which#0 == LitInt(1))
             && (which#0 == LitInt(0)
               ==> Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock1(s#0))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#0), 
                      #Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock1(s#0))): DatatypeType)))), 
                      JournalDisk.Variables.superblock2(dt_update_tmp#0#0), 
                      JournalDisk.Variables.journal(dt_update_tmp#0#0)))))
             && (which#0 == LitInt(1)
               ==> Options.Option.Some_q(JournalDisk.Variables.reqWriteSuperblock2(s#0))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := s#0; 
                    #JournalDisk.Variables.Variables(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#0), 
                      JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#0), 
                      JournalDisk.Variables.superblock1(dt_update_tmp#1#0), 
                      #Options.Option.Some($Box(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.ReqWriteSuperblockId.req($Unbox(Options.Option.value(JournalDisk.Variables.reqWriteSuperblock2(s#0))): DatatypeType)))), 
                      JournalDisk.Variables.journal(dt_update_tmp#1#0)))))));

// definition axiom for JournalDisk.__default.ProcessWriteSuperblock for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, which#0: int :: 
    {:weight 3} { JournalDisk.__default.ProcessWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(which#0)) } 
    JournalDisk.__default.ProcessWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(which#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> (LitInt(which#0) == LitInt(1)
           ==> 
          LitInt(which#0) == LitInt(0)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)))))
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))))))), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && 
                    JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))))
         && ((LitInt(which#0) == LitInt(0)
               ==> JournalDisk.Variables.Variables_q(Lit(s#0))
                 && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0)))))
                   ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                     && $IsA#JournalDisk.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                        Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                            Lit(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))))))), 
                            Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                            Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1))))))
                     && (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && 
                        JournalDisk.Variables.Variables_q(Lit(s#0))
                         && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))
                         && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType))))
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1)
                         && JournalDisk.Variables.Variables_q(dt_update_tmp#0#1))))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))))))), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))))
           ==> 
          LitInt(which#0) == LitInt(1)
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && (Lit(Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0)))))
               ==> $IsA#JournalDisk.Variables(Lit(s'#0))
                 && $IsA#JournalDisk.Variables((var dt_update_tmp#1#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                        Lit(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType)))))))), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1))))))
                 && (var dt_update_tmp#1#1 := Lit(s#0); 
                  JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1)
                     && 
                    JournalDisk.Variables.Variables_q(Lit(s#0))
                     && JournalDisk.ReqWriteSuperblockId.ReqWriteSuperblockId_q(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))
                     && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType))))
                     && JournalDisk.Variables.Variables_q(dt_update_tmp#1#1))))
         && JournalDisk.__default.ProcessWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), LitInt(which#0))
           == (
            (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#0#1)), 
                        Lit(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s#0))))): DatatypeType)))))))), 
                        Lit(JournalDisk.Variables.superblock2(dt_update_tmp#0#1)), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#0#1)))))))
             && (LitInt(which#0) == LitInt(1)
               ==> Options.Option.Some_q(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))
                 && JournalDisk.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := Lit(s#0); 
                    Lit(#JournalDisk.Variables.Variables(Lit(JournalDisk.Variables.reqReadSuperblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadSuperblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqReadJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock1(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteSuperblock2(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.reqWriteJournals(dt_update_tmp#1#1)), 
                        Lit(JournalDisk.Variables.superblock1(dt_update_tmp#1#1)), 
                        Lit(#Options.Option.Some($Box(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.ReqWriteSuperblockId.req(Lit($Unbox(Options.Option.value(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s#0))))): DatatypeType)))))))), 
                        Lit(JournalDisk.Variables.journal(dt_update_tmp#1#1)))))))));

// function declaration for JournalDisk._default.NextInternalStep
function JournalDisk.__default.NextInternalStep(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType)
   : bool;

function JournalDisk.__default.NextInternalStep#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType)
   : bool;

// consequence axiom for JournalDisk.__default.NextInternalStep
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    { JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
    JournalDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(step#0, Tclass.JournalDisk.InternalStep()))
       ==> true);

function JournalDisk.__default.NextInternalStep#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.NextInternalStep
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
  { JournalDisk.__default.NextInternalStep#requires(k#0, s#0, s'#0, step#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
       && $Is(step#0, Tclass.JournalDisk.InternalStep())
     ==> JournalDisk.__default.NextInternalStep#requires(k#0, s#0, s'#0, step#0) == true);

// definition axiom for JournalDisk.__default.NextInternalStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    { JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
    JournalDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(step#0, Tclass.JournalDisk.InternalStep()))
       ==> JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(step#0)
         && (var which#0 := JournalDisk.InternalStep.which(step#0); 
          JournalDisk.__default.ProcessWriteSuperblock#canCall(k#0, s#0, s'#0, which#0))
         && JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0)
           == (var which#1 := JournalDisk.InternalStep.which(step#0); 
            JournalDisk.__default.ProcessWriteSuperblock(k#0, s#0, s'#0, which#1)));

// definition axiom for JournalDisk.__default.NextInternalStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType, step#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0)) } 
    JournalDisk.__default.NextInternalStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables())
           && $Is(step#0, Tclass.JournalDisk.InternalStep()))
       ==> JournalDisk.InternalStep.ProcessWriteSuperblockStep_q(Lit(step#0))
         && (var which#2 := LitInt(JournalDisk.InternalStep.which(Lit(step#0))); 
          JournalDisk.__default.ProcessWriteSuperblock#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), which#2))
         && JournalDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(step#0))
           == (var which#3 := LitInt(JournalDisk.InternalStep.which(Lit(step#0))); 
            Lit(JournalDisk.__default.ProcessWriteSuperblock(Lit(k#0), Lit(s#0), Lit(s'#0), which#3))));

// function declaration for JournalDisk._default.NextInternal
function JournalDisk.__default.NextInternal(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function JournalDisk.__default.NextInternal#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for JournalDisk.__default.NextInternal
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { JournalDisk.__default.NextInternal(k#0, s#0, s'#0) } 
    JournalDisk.__default.NextInternal#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> true);

function JournalDisk.__default.NextInternal#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.NextInternal
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { JournalDisk.__default.NextInternal#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
     ==> JournalDisk.__default.NextInternal#requires(k#0, s#0, s'#0) == true);

// definition axiom for JournalDisk.__default.NextInternal(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { JournalDisk.__default.NextInternal(k#0, s#0, s'#0) } 
    JournalDisk.__default.NextInternal#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> (forall step#0: DatatypeType :: 
          { JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
          $Is(step#0, Tclass.JournalDisk.InternalStep())
             ==> JournalDisk.__default.NextInternalStep#canCall(k#0, s#0, s'#0, step#0))
         && JournalDisk.__default.NextInternal(k#0, s#0, s'#0)
           == (exists step#0: DatatypeType :: 
            { JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0) } 
            $Is(step#0, Tclass.JournalDisk.InternalStep())
               && JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#0)));

// definition axiom for JournalDisk.__default.NextInternal for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.NextInternal(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    JournalDisk.__default.NextInternal#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> (forall step#1: DatatypeType :: 
          { JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#1) } 
          $Is(step#1, Tclass.JournalDisk.InternalStep())
             ==> JournalDisk.__default.NextInternalStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), step#1))
         && JournalDisk.__default.NextInternal(Lit(k#0), Lit(s#0), Lit(s'#0))
           == (exists step#1: DatatypeType :: 
            { JournalDisk.__default.NextInternalStep(k#0, s#0, s'#0, step#1) } 
            $Is(step#1, Tclass.JournalDisk.InternalStep())
               && JournalDisk.__default.NextInternalStep(Lit(k#0), Lit(s#0), Lit(s'#0), step#1)));

// function declaration for JournalDisk._default.JournalUntouched
function JournalDisk.__default.JournalUntouched(i#0: int, reqWriteJournals#0: Map Box Box) : bool;

function JournalDisk.__default.JournalUntouched#canCall(i#0: int, reqWriteJournals#0: Map Box Box) : bool;

// consequence axiom for JournalDisk.__default.JournalUntouched
axiom true
   ==> (forall i#0: int, reqWriteJournals#0: Map Box Box :: 
    { JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0) } 
    JournalDisk.__default.JournalUntouched#canCall(i#0, reqWriteJournals#0)
         || $Is(reqWriteJournals#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
       ==> true);

function JournalDisk.__default.JournalUntouched#requires(int, Map Box Box) : bool;

// #requires axiom for JournalDisk.__default.JournalUntouched
axiom (forall i#0: int, reqWriteJournals#0: Map Box Box :: 
  { JournalDisk.__default.JournalUntouched#requires(i#0, reqWriteJournals#0) } 
  $Is(reqWriteJournals#0, 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
     ==> JournalDisk.__default.JournalUntouched#requires(i#0, reqWriteJournals#0) == true);

// definition axiom for JournalDisk.__default.JournalUntouched(revealed)
axiom true
   ==> (forall i#0: int, reqWriteJournals#0: Map Box Box :: 
    { JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0) } 
    JournalDisk.__default.JournalUntouched#canCall(i#0, reqWriteJournals#0)
         || $Is(reqWriteJournals#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(reqWriteJournals#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(reqWriteJournals#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(reqWriteJournals#0)[$Box(id#0)]
             ==> JournalIntervals.__default.InCyclicRange#canCall(i#0, $Unbox(Map#Elements(reqWriteJournals#0)[$Box(id#0)]): DatatypeType))
         && JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0)
           == (forall id#0: int :: 
            { $Unbox(Map#Elements(reqWriteJournals#0)[$Box(id#0)]): DatatypeType } 
              { Map#Domain(reqWriteJournals#0)[$Box(id#0)] } 
            LitInt(0) <= id#0
                 && id#0 < 18446744073709551616
                 && Map#Domain(reqWriteJournals#0)[$Box(id#0)]
               ==> !JournalIntervals.__default.InCyclicRange(i#0, $Unbox(Map#Elements(reqWriteJournals#0)[$Box(id#0)]): DatatypeType)));

// definition axiom for JournalDisk.__default.JournalUntouched for all literals(revealed)
axiom true
   ==> (forall i#0: int, reqWriteJournals#0: Map Box Box :: 
    {:weight 3} { JournalDisk.__default.JournalUntouched(LitInt(i#0), Lit(reqWriteJournals#0)) } 
    JournalDisk.__default.JournalUntouched#canCall(LitInt(i#0), Lit(reqWriteJournals#0))
         || $Is(reqWriteJournals#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
       ==> (forall id#1: int :: 
          { $Unbox(Map#Elements(reqWriteJournals#0)[$Box(id#1)]): DatatypeType } 
            { Map#Domain(reqWriteJournals#0)[$Box(id#1)] } 
          LitInt(0) <= id#1 && id#1 < 18446744073709551616
             ==> 
            Map#Domain(reqWriteJournals#0)[$Box(id#1)]
             ==> JournalIntervals.__default.InCyclicRange#canCall(LitInt(i#0), 
              $Unbox(Map#Elements(Lit(reqWriteJournals#0))[$Box(id#1)]): DatatypeType))
         && JournalDisk.__default.JournalUntouched(LitInt(i#0), Lit(reqWriteJournals#0))
           == (forall id#1: int :: 
            { $Unbox(Map#Elements(reqWriteJournals#0)[$Box(id#1)]): DatatypeType } 
              { Map#Domain(reqWriteJournals#0)[$Box(id#1)] } 
            LitInt(0) <= id#1
                 && id#1 < 18446744073709551616
                 && Map#Domain(reqWriteJournals#0)[$Box(id#1)]
               ==> !JournalIntervals.__default.InCyclicRange(LitInt(i#0), 
                $Unbox(Map#Elements(Lit(reqWriteJournals#0))[$Box(id#1)]): DatatypeType)));

// function declaration for JournalDisk._default.havocJournal
function JournalDisk.__default.havocJournal(journal#0: Seq Box, journal'#0: Seq Box, reqWriteJournals#0: Map Box Box) : bool;

function JournalDisk.__default.havocJournal#canCall(journal#0: Seq Box, journal'#0: Seq Box, reqWriteJournals#0: Map Box Box) : bool;

// consequence axiom for JournalDisk.__default.havocJournal
axiom true
   ==> (forall journal#0: Seq Box, journal'#0: Seq Box, reqWriteJournals#0: Map Box Box :: 
    { JournalDisk.__default.havocJournal(journal#0, journal'#0, reqWriteJournals#0) } 
    JournalDisk.__default.havocJournal#canCall(journal#0, journal'#0, reqWriteJournals#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(reqWriteJournals#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval())))
       ==> true);

function JournalDisk.__default.havocJournal#requires(Seq Box, Seq Box, Map Box Box) : bool;

// #requires axiom for JournalDisk.__default.havocJournal
axiom (forall journal#0: Seq Box, journal'#0: Seq Box, reqWriteJournals#0: Map Box Box :: 
  { JournalDisk.__default.havocJournal#requires(journal#0, journal'#0, reqWriteJournals#0) } 
  $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
       && $Is(reqWriteJournals#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval()))
     ==> JournalDisk.__default.havocJournal#requires(journal#0, journal'#0, reqWriteJournals#0)
       == true);

// definition axiom for JournalDisk.__default.havocJournal(revealed)
axiom true
   ==> (forall journal#0: Seq Box, journal'#0: Seq Box, reqWriteJournals#0: Map Box Box :: 
    { JournalDisk.__default.havocJournal(journal#0, journal'#0, reqWriteJournals#0) } 
    JournalDisk.__default.havocJournal#canCall(journal#0, journal'#0, reqWriteJournals#0)
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(reqWriteJournals#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval())))
       ==> (Seq#Length(journal'#0) == Seq#Length(journal#0)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(journal'#0, i#0)): DatatypeType } 
              { $Unbox(Seq#Index(journal#0, i#0)): DatatypeType } 
              { JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0) } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(journal#0)
               ==> JournalDisk.__default.JournalUntouched#canCall(i#0, reqWriteJournals#0)
                 && (JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0)
                   ==> $IsA#Options.Option($Unbox(Seq#Index(journal#0, i#0)): DatatypeType)
                     && $IsA#Options.Option($Unbox(Seq#Index(journal'#0, i#0)): DatatypeType))))
         && JournalDisk.__default.havocJournal(journal#0, journal'#0, reqWriteJournals#0)
           == (Seq#Length(journal'#0) == Seq#Length(journal#0)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(journal'#0, i#0)): DatatypeType } 
                { $Unbox(Seq#Index(journal#0, i#0)): DatatypeType } 
                { JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0) } 
              LitInt(0) <= i#0 && i#0 < Seq#Length(journal#0)
                 ==> 
                JournalDisk.__default.JournalUntouched(i#0, reqWriteJournals#0)
                 ==> Options.Option#Equal($Unbox(Seq#Index(journal#0, i#0)): DatatypeType, 
                  $Unbox(Seq#Index(journal'#0, i#0)): DatatypeType))));

// definition axiom for JournalDisk.__default.havocJournal for all literals(revealed)
axiom true
   ==> (forall journal#0: Seq Box, journal'#0: Seq Box, reqWriteJournals#0: Map Box Box :: 
    {:weight 3} { JournalDisk.__default.havocJournal(Lit(journal#0), Lit(journal'#0), Lit(reqWriteJournals#0)) } 
    JournalDisk.__default.havocJournal#canCall(Lit(journal#0), Lit(journal'#0), Lit(reqWriteJournals#0))
         || (
          $Is(journal#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(journal'#0, TSeq(Tclass.Options.Option(Tclass.JournalRanges.JournalBlock())))
           && $Is(reqWriteJournals#0, 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalIntervals.JournalInterval())))
       ==> (Seq#Length(Lit(journal'#0)) == Seq#Length(Lit(journal#0))
           ==> (forall i#1: int :: 
            { $Unbox(Seq#Index(journal'#0, i#1)): DatatypeType } 
              { $Unbox(Seq#Index(journal#0, i#1)): DatatypeType } 
              { JournalDisk.__default.JournalUntouched(i#1, reqWriteJournals#0) } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(journal#0))
               ==> JournalDisk.__default.JournalUntouched#canCall(i#1, Lit(reqWriteJournals#0))
                 && (JournalDisk.__default.JournalUntouched(i#1, Lit(reqWriteJournals#0))
                   ==> $IsA#Options.Option($Unbox(Seq#Index(Lit(journal#0), i#1)): DatatypeType)
                     && $IsA#Options.Option($Unbox(Seq#Index(Lit(journal'#0), i#1)): DatatypeType))))
         && JournalDisk.__default.havocJournal(Lit(journal#0), Lit(journal'#0), Lit(reqWriteJournals#0))
           == (Seq#Length(Lit(journal'#0)) == Seq#Length(Lit(journal#0))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index(journal'#0, i#1)): DatatypeType } 
                { $Unbox(Seq#Index(journal#0, i#1)): DatatypeType } 
                { JournalDisk.__default.JournalUntouched(i#1, reqWriteJournals#0) } 
              LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(journal#0))
                 ==> 
                JournalDisk.__default.JournalUntouched(i#1, Lit(reqWriteJournals#0))
                 ==> Options.Option#Equal($Unbox(Seq#Index(Lit(journal#0), i#1)): DatatypeType, 
                  $Unbox(Seq#Index(Lit(journal'#0), i#1)): DatatypeType))));

// function declaration for JournalDisk._default.Crash
function JournalDisk.__default.Crash(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

function JournalDisk.__default.Crash#canCall(k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType) : bool;

// consequence axiom for JournalDisk.__default.Crash
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { JournalDisk.__default.Crash(k#0, s#0, s'#0) } 
    JournalDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> true);

function JournalDisk.__default.Crash#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalDisk.__default.Crash
axiom (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
  { JournalDisk.__default.Crash#requires(k#0, s#0, s'#0) } 
  $Is(k#0, Tclass.JournalDisk.Constants())
       && $Is(s#0, Tclass.JournalDisk.Variables())
       && $Is(s'#0, Tclass.JournalDisk.Variables())
     ==> JournalDisk.__default.Crash#requires(k#0, s#0, s'#0) == true);

// definition axiom for JournalDisk.__default.Crash(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    { JournalDisk.__default.Crash(k#0, s#0, s'#0) } 
    JournalDisk.__default.Crash#canCall(k#0, s#0, s'#0)
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> JournalDisk.Variables.Variables_q(s'#0)
         && (Set#Equal(JournalDisk.Variables.reqReadSuperblock1(s'#0), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(s'#0))
         && (JournalDisk.Variables.Variables_q(s'#0)
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(s'#0), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(s'#0))
         && (JournalDisk.Variables.Variables_q(s'#0)
             && Map#Equal(JournalDisk.Variables.reqReadJournals(s'#0), Map#Empty(): Map Box Box)
           ==> $IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock1(s'#0))
             && JournalDisk.Variables.Variables_q(s'#0))
         && ($IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock1(s'#0))
             && JournalDisk.Variables.Variables_q(s'#0)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(s'#0), #Options.Option.None())
           ==> $IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock2(s'#0))
             && JournalDisk.Variables.Variables_q(s'#0))
         && ($IsA#Options.Option(JournalDisk.Variables.reqWriteSuperblock2(s'#0))
             && JournalDisk.Variables.Variables_q(s'#0)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(s'#0), #Options.Option.None())
           ==> JournalDisk.Variables.Variables_q(s'#0))
         && (JournalDisk.Variables.Variables_q(s'#0)
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(s'#0), Map#Empty(): Map Box Box)
           ==> $IsA#Options.Option(JournalDisk.Variables.superblock1(s'#0))
             && $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
             && 
            JournalDisk.Variables.Variables_q(s'#0)
             && JournalDisk.Variables.Variables_q(s#0))
         && ($IsA#Options.Option(JournalDisk.Variables.superblock1(s'#0))
             && $IsA#Options.Option(JournalDisk.Variables.superblock1(s#0))
             && 
            JournalDisk.Variables.Variables_q(s'#0)
             && JournalDisk.Variables.Variables_q(s#0)
             && Options.Option#Equal(JournalDisk.Variables.superblock1(s'#0), JournalDisk.Variables.superblock1(s#0))
           ==> $IsA#Options.Option(JournalDisk.Variables.superblock2(s'#0))
             && $IsA#Options.Option(JournalDisk.Variables.superblock2(s#0))
             && 
            JournalDisk.Variables.Variables_q(s'#0)
             && JournalDisk.Variables.Variables_q(s#0))
         && ($IsA#Options.Option(JournalDisk.Variables.superblock2(s'#0))
             && $IsA#Options.Option(JournalDisk.Variables.superblock2(s#0))
             && 
            JournalDisk.Variables.Variables_q(s'#0)
             && JournalDisk.Variables.Variables_q(s#0)
             && Options.Option#Equal(JournalDisk.Variables.superblock2(s'#0), JournalDisk.Variables.superblock2(s#0))
           ==> JournalDisk.Variables.Variables_q(s#0)
             && JournalDisk.Variables.Variables_q(s'#0)
             && JournalDisk.Variables.Variables_q(s#0)
             && JournalDisk.__default.havocJournal#canCall(JournalDisk.Variables.journal(s#0), 
              JournalDisk.Variables.journal(s'#0), 
              JournalDisk.Variables.reqWriteJournals(s#0)))
         && JournalDisk.__default.Crash(k#0, s#0, s'#0)
           == (
            Set#Equal(JournalDisk.Variables.reqReadSuperblock1(s'#0), Set#Empty(): Set Box)
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(s'#0), Set#Empty(): Set Box)
             && Map#Equal(JournalDisk.Variables.reqReadJournals(s'#0), Map#Empty(): Map Box Box)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(s'#0), #Options.Option.None())
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(s'#0), #Options.Option.None())
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(s'#0), Map#Empty(): Map Box Box)
             && Options.Option#Equal(JournalDisk.Variables.superblock1(s'#0), JournalDisk.Variables.superblock1(s#0))
             && Options.Option#Equal(JournalDisk.Variables.superblock2(s'#0), JournalDisk.Variables.superblock2(s#0))
             && JournalDisk.__default.havocJournal(JournalDisk.Variables.journal(s#0), 
              JournalDisk.Variables.journal(s'#0), 
              JournalDisk.Variables.reqWriteJournals(s#0))));

// definition axiom for JournalDisk.__default.Crash for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType, s'#0: DatatypeType :: 
    {:weight 3} { JournalDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0)) } 
    JournalDisk.__default.Crash#canCall(Lit(k#0), Lit(s#0), Lit(s'#0))
         || (
          $Is(k#0, Tclass.JournalDisk.Constants())
           && $Is(s#0, Tclass.JournalDisk.Variables())
           && $Is(s'#0, Tclass.JournalDisk.Variables()))
       ==> JournalDisk.Variables.Variables_q(Lit(s'#0))
         && (Set#Equal(JournalDisk.Variables.reqReadSuperblock1(Lit(s'#0)), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(Lit(s'#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s'#0))
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(Lit(s'#0)), Set#Empty(): Set Box)
           ==> JournalDisk.Variables.Variables_q(Lit(s'#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s'#0))
             && Map#Equal(JournalDisk.Variables.reqReadJournals(Lit(s'#0)), Map#Empty(): Map Box Box)
           ==> $IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s'#0))))
             && JournalDisk.Variables.Variables_q(Lit(s'#0)))
         && ($IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock1(Lit(s'#0))))
             && JournalDisk.Variables.Variables_q(Lit(s'#0))
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(Lit(s'#0)), #Options.Option.None())
           ==> $IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s'#0))))
             && JournalDisk.Variables.Variables_q(Lit(s'#0)))
         && ($IsA#Options.Option(Lit(JournalDisk.Variables.reqWriteSuperblock2(Lit(s'#0))))
             && JournalDisk.Variables.Variables_q(Lit(s'#0))
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(Lit(s'#0)), #Options.Option.None())
           ==> JournalDisk.Variables.Variables_q(Lit(s'#0)))
         && (JournalDisk.Variables.Variables_q(Lit(s'#0))
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(Lit(s'#0)), Map#Empty(): Map Box Box)
           ==> $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s'#0))))
             && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
             && 
            JournalDisk.Variables.Variables_q(Lit(s'#0))
             && JournalDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s'#0))))
             && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock1(Lit(s#0))))
             && 
            JournalDisk.Variables.Variables_q(Lit(s'#0))
             && JournalDisk.Variables.Variables_q(Lit(s#0))
             && Options.Option#Equal(JournalDisk.Variables.superblock1(Lit(s'#0)), 
              JournalDisk.Variables.superblock1(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s'#0))))
             && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s#0))))
             && 
            JournalDisk.Variables.Variables_q(Lit(s'#0))
             && JournalDisk.Variables.Variables_q(Lit(s#0)))
         && ($IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s'#0))))
             && $IsA#Options.Option(Lit(JournalDisk.Variables.superblock2(Lit(s#0))))
             && 
            JournalDisk.Variables.Variables_q(Lit(s'#0))
             && JournalDisk.Variables.Variables_q(Lit(s#0))
             && Options.Option#Equal(JournalDisk.Variables.superblock2(Lit(s'#0)), 
              JournalDisk.Variables.superblock2(Lit(s#0)))
           ==> JournalDisk.Variables.Variables_q(Lit(s#0))
             && JournalDisk.Variables.Variables_q(Lit(s'#0))
             && JournalDisk.Variables.Variables_q(Lit(s#0))
             && JournalDisk.__default.havocJournal#canCall(Lit(JournalDisk.Variables.journal(Lit(s#0))), 
              Lit(JournalDisk.Variables.journal(Lit(s'#0))), 
              Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0)))))
         && JournalDisk.__default.Crash(Lit(k#0), Lit(s#0), Lit(s'#0))
           == (
            Set#Equal(JournalDisk.Variables.reqReadSuperblock1(Lit(s'#0)), Set#Empty(): Set Box)
             && Set#Equal(JournalDisk.Variables.reqReadSuperblock2(Lit(s'#0)), Set#Empty(): Set Box)
             && Map#Equal(JournalDisk.Variables.reqReadJournals(Lit(s'#0)), Map#Empty(): Map Box Box)
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock1(Lit(s'#0)), #Options.Option.None())
             && Options.Option#Equal(JournalDisk.Variables.reqWriteSuperblock2(Lit(s'#0)), #Options.Option.None())
             && Map#Equal(JournalDisk.Variables.reqWriteJournals(Lit(s'#0)), Map#Empty(): Map Box Box)
             && Options.Option#Equal(JournalDisk.Variables.superblock1(Lit(s'#0)), 
              JournalDisk.Variables.superblock1(Lit(s#0)))
             && Options.Option#Equal(JournalDisk.Variables.superblock2(Lit(s'#0)), 
              JournalDisk.Variables.superblock2(Lit(s#0)))
             && JournalDisk.__default.havocJournal(Lit(JournalDisk.Variables.journal(Lit(s#0))), 
              Lit(JournalDisk.Variables.journal(Lit(s'#0))), 
              Lit(JournalDisk.Variables.reqWriteJournals(Lit(s#0))))));

// Constructor function declaration
function #JournalCache.Constants.Constants() : DatatypeType;

const unique ##JournalCache.Constants.Constants: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Constants.Constants())
   == ##JournalCache.Constants.Constants;

function JournalCache.Constants.Constants_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Constants.Constants_q(d) } 
  JournalCache.Constants.Constants_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Constants.Constants);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Constants.Constants_q(d) } 
  JournalCache.Constants.Constants_q(d)
     ==> d == #JournalCache.Constants.Constants());

function Tclass.JournalCache.Constants() : Ty;

// Tclass.JournalCache.Constants Tag
axiom Tag(Tclass.JournalCache.Constants()) == Tagclass.JournalCache.Constants;

const unique Tagclass.JournalCache.Constants: TyTag;

// Box/unbox axiom for Tclass.JournalCache.Constants
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.Constants()) } 
  $IsBox(bx, Tclass.JournalCache.Constants())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.Constants()));

// Constructor $Is
axiom $Is(#JournalCache.Constants.Constants(), Tclass.JournalCache.Constants());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Constants.Constants(), Tclass.JournalCache.Constants(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Constants.Constants(), Tclass.JournalCache.Constants(), $h));

// Constructor literal
axiom #JournalCache.Constants.Constants() == Lit(#JournalCache.Constants.Constants());

// Depth-one case-split function
function $IsA#JournalCache.Constants(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.Constants(d) } 
  $IsA#JournalCache.Constants(d) ==> JournalCache.Constants.Constants_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.Constants.Constants_q(d), $Is(d, Tclass.JournalCache.Constants()) } 
  $Is(d, Tclass.JournalCache.Constants())
     ==> JournalCache.Constants.Constants_q(d));

// Datatype extensional equality declaration
function JournalCache.Constants#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.Constants.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Constants#Equal(a, b) } 
  true ==> (JournalCache.Constants#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalCache.Constants
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Constants#Equal(a, b) } 
  JournalCache.Constants#Equal(a, b) <==> a == b);

const unique class.JournalCache.Constants: ClassName;

// Constructor function declaration
function #JournalCache.SyncReqStatus.State1() : DatatypeType;

const unique ##JournalCache.SyncReqStatus.State1: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.SyncReqStatus.State1())
   == ##JournalCache.SyncReqStatus.State1;

function JournalCache.SyncReqStatus.State1_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State1_q(d) } 
  JournalCache.SyncReqStatus.State1_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.SyncReqStatus.State1);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State1_q(d) } 
  JournalCache.SyncReqStatus.State1_q(d)
     ==> d == #JournalCache.SyncReqStatus.State1());

function Tclass.JournalCache.SyncReqStatus() : Ty;

// Tclass.JournalCache.SyncReqStatus Tag
axiom Tag(Tclass.JournalCache.SyncReqStatus()) == Tagclass.JournalCache.SyncReqStatus;

const unique Tagclass.JournalCache.SyncReqStatus: TyTag;

// Box/unbox axiom for Tclass.JournalCache.SyncReqStatus
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.SyncReqStatus()) } 
  $IsBox(bx, Tclass.JournalCache.SyncReqStatus())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.SyncReqStatus()));

// Constructor $Is
axiom $Is(#JournalCache.SyncReqStatus.State1(), Tclass.JournalCache.SyncReqStatus());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.SyncReqStatus.State1(), Tclass.JournalCache.SyncReqStatus(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.SyncReqStatus.State1(), Tclass.JournalCache.SyncReqStatus(), $h));

// Constructor literal
axiom #JournalCache.SyncReqStatus.State1()
   == Lit(#JournalCache.SyncReqStatus.State1());

// Constructor function declaration
function #JournalCache.SyncReqStatus.State2() : DatatypeType;

const unique ##JournalCache.SyncReqStatus.State2: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.SyncReqStatus.State2())
   == ##JournalCache.SyncReqStatus.State2;

function JournalCache.SyncReqStatus.State2_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State2_q(d) } 
  JournalCache.SyncReqStatus.State2_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.SyncReqStatus.State2);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State2_q(d) } 
  JournalCache.SyncReqStatus.State2_q(d)
     ==> d == #JournalCache.SyncReqStatus.State2());

// Constructor $Is
axiom $Is(#JournalCache.SyncReqStatus.State2(), Tclass.JournalCache.SyncReqStatus());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.SyncReqStatus.State2(), Tclass.JournalCache.SyncReqStatus(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.SyncReqStatus.State2(), Tclass.JournalCache.SyncReqStatus(), $h));

// Constructor literal
axiom #JournalCache.SyncReqStatus.State2()
   == Lit(#JournalCache.SyncReqStatus.State2());

// Constructor function declaration
function #JournalCache.SyncReqStatus.State3() : DatatypeType;

const unique ##JournalCache.SyncReqStatus.State3: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.SyncReqStatus.State3())
   == ##JournalCache.SyncReqStatus.State3;

function JournalCache.SyncReqStatus.State3_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State3_q(d) } 
  JournalCache.SyncReqStatus.State3_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.SyncReqStatus.State3);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State3_q(d) } 
  JournalCache.SyncReqStatus.State3_q(d)
     ==> d == #JournalCache.SyncReqStatus.State3());

// Constructor $Is
axiom $Is(#JournalCache.SyncReqStatus.State3(), Tclass.JournalCache.SyncReqStatus());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.SyncReqStatus.State3(), Tclass.JournalCache.SyncReqStatus(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.SyncReqStatus.State3(), Tclass.JournalCache.SyncReqStatus(), $h));

// Constructor literal
axiom #JournalCache.SyncReqStatus.State3()
   == Lit(#JournalCache.SyncReqStatus.State3());

// Depth-one case-split function
function $IsA#JournalCache.SyncReqStatus(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.SyncReqStatus(d) } 
  $IsA#JournalCache.SyncReqStatus(d)
     ==> JournalCache.SyncReqStatus.State1_q(d)
       || JournalCache.SyncReqStatus.State2_q(d)
       || JournalCache.SyncReqStatus.State3_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.SyncReqStatus.State3_q(d), $Is(d, Tclass.JournalCache.SyncReqStatus()) } 
    { JournalCache.SyncReqStatus.State2_q(d), $Is(d, Tclass.JournalCache.SyncReqStatus()) } 
    { JournalCache.SyncReqStatus.State1_q(d), $Is(d, Tclass.JournalCache.SyncReqStatus()) } 
  $Is(d, Tclass.JournalCache.SyncReqStatus())
     ==> JournalCache.SyncReqStatus.State1_q(d)
       || JournalCache.SyncReqStatus.State2_q(d)
       || JournalCache.SyncReqStatus.State3_q(d));

// Datatype extensional equality declaration
function JournalCache.SyncReqStatus#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.SyncReqStatus.State1
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SyncReqStatus#Equal(a, b), JournalCache.SyncReqStatus.State1_q(a) } 
    { JournalCache.SyncReqStatus#Equal(a, b), JournalCache.SyncReqStatus.State1_q(b) } 
  JournalCache.SyncReqStatus.State1_q(a) && JournalCache.SyncReqStatus.State1_q(b)
     ==> (JournalCache.SyncReqStatus#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.SyncReqStatus.State2
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SyncReqStatus#Equal(a, b), JournalCache.SyncReqStatus.State2_q(a) } 
    { JournalCache.SyncReqStatus#Equal(a, b), JournalCache.SyncReqStatus.State2_q(b) } 
  JournalCache.SyncReqStatus.State2_q(a) && JournalCache.SyncReqStatus.State2_q(b)
     ==> (JournalCache.SyncReqStatus#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.SyncReqStatus.State3
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SyncReqStatus#Equal(a, b), JournalCache.SyncReqStatus.State3_q(a) } 
    { JournalCache.SyncReqStatus#Equal(a, b), JournalCache.SyncReqStatus.State3_q(b) } 
  JournalCache.SyncReqStatus.State3_q(a) && JournalCache.SyncReqStatus.State3_q(b)
     ==> (JournalCache.SyncReqStatus#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalCache.SyncReqStatus
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SyncReqStatus#Equal(a, b) } 
  JournalCache.SyncReqStatus#Equal(a, b) <==> a == b);

const unique class.JournalCache.SyncReqStatus: ClassName;

// Constructor function declaration
function #JournalCache.SuperblockReadResult.SuperblockSuccess(DatatypeType) : DatatypeType;

const unique ##JournalCache.SuperblockReadResult.SuperblockSuccess: DtCtorId;

// Constructor identifier
axiom (forall a#20#0#0: DatatypeType :: 
  { #JournalCache.SuperblockReadResult.SuperblockSuccess(a#20#0#0) } 
  DatatypeCtorId(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#20#0#0))
     == ##JournalCache.SuperblockReadResult.SuperblockSuccess);

function JournalCache.SuperblockReadResult.SuperblockSuccess_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockSuccess_q(d) } 
  JournalCache.SuperblockReadResult.SuperblockSuccess_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.SuperblockReadResult.SuperblockSuccess);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockSuccess_q(d) } 
  JournalCache.SuperblockReadResult.SuperblockSuccess_q(d)
     ==> (exists a#21#0#0: DatatypeType :: 
      d == #JournalCache.SuperblockReadResult.SuperblockSuccess(a#21#0#0)));

function Tclass.JournalCache.SuperblockReadResult() : Ty;

// Tclass.JournalCache.SuperblockReadResult Tag
axiom Tag(Tclass.JournalCache.SuperblockReadResult())
   == Tagclass.JournalCache.SuperblockReadResult;

const unique Tagclass.JournalCache.SuperblockReadResult: TyTag;

// Box/unbox axiom for Tclass.JournalCache.SuperblockReadResult
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.SuperblockReadResult()) } 
  $IsBox(bx, Tclass.JournalCache.SuperblockReadResult())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.SuperblockReadResult()));

// Constructor $Is
axiom (forall a#22#0#0: DatatypeType :: 
  { $Is(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#22#0#0), 
      Tclass.JournalCache.SuperblockReadResult()) } 
  $Is(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#22#0#0), 
      Tclass.JournalCache.SuperblockReadResult())
     <==> $Is(a#22#0#0, Tclass.SectorType.Superblock()));

// Constructor $IsAlloc
axiom (forall a#23#0#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#23#0#0), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#23#0#0), 
        Tclass.JournalCache.SuperblockReadResult(), 
        $h)
       <==> $IsAlloc(a#23#0#0, Tclass.SectorType.Superblock(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.SuperblockReadResult.value(d), Tclass.SectorType.Superblock(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.SuperblockReadResult.SuperblockSuccess_q(d)
       && $IsAlloc(d, Tclass.JournalCache.SuperblockReadResult(), $h)
     ==> $IsAlloc(JournalCache.SuperblockReadResult.value(d), Tclass.SectorType.Superblock(), $h));

// Constructor literal
axiom (forall a#24#0#0: DatatypeType :: 
  { #JournalCache.SuperblockReadResult.SuperblockSuccess(Lit(a#24#0#0)) } 
  #JournalCache.SuperblockReadResult.SuperblockSuccess(Lit(a#24#0#0))
     == Lit(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#24#0#0)));

function JournalCache.SuperblockReadResult.value(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#25#0#0: DatatypeType :: 
  { #JournalCache.SuperblockReadResult.SuperblockSuccess(a#25#0#0) } 
  JournalCache.SuperblockReadResult.value(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#25#0#0))
     == a#25#0#0);

// Inductive rank
axiom (forall a#26#0#0: DatatypeType :: 
  { #JournalCache.SuperblockReadResult.SuperblockSuccess(a#26#0#0) } 
  DtRank(a#26#0#0)
     < DtRank(#JournalCache.SuperblockReadResult.SuperblockSuccess(a#26#0#0)));

// Constructor function declaration
function #JournalCache.SuperblockReadResult.SuperblockUnfinished() : DatatypeType;

const unique ##JournalCache.SuperblockReadResult.SuperblockUnfinished: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.SuperblockReadResult.SuperblockUnfinished())
   == ##JournalCache.SuperblockReadResult.SuperblockUnfinished;

function JournalCache.SuperblockReadResult.SuperblockUnfinished_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d) } 
  JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.SuperblockReadResult.SuperblockUnfinished);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d) } 
  JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d)
     ==> d == #JournalCache.SuperblockReadResult.SuperblockUnfinished());

// Constructor $Is
axiom $Is(#JournalCache.SuperblockReadResult.SuperblockUnfinished(), 
  Tclass.JournalCache.SuperblockReadResult());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.SuperblockReadResult.SuperblockUnfinished(), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.SuperblockReadResult.SuperblockUnfinished(), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h));

// Constructor literal
axiom #JournalCache.SuperblockReadResult.SuperblockUnfinished()
   == Lit(#JournalCache.SuperblockReadResult.SuperblockUnfinished());

// Constructor function declaration
function #JournalCache.SuperblockReadResult.SuperblockCorruption() : DatatypeType;

const unique ##JournalCache.SuperblockReadResult.SuperblockCorruption: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.SuperblockReadResult.SuperblockCorruption())
   == ##JournalCache.SuperblockReadResult.SuperblockCorruption;

function JournalCache.SuperblockReadResult.SuperblockCorruption_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockCorruption_q(d) } 
  JournalCache.SuperblockReadResult.SuperblockCorruption_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.SuperblockReadResult.SuperblockCorruption);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockCorruption_q(d) } 
  JournalCache.SuperblockReadResult.SuperblockCorruption_q(d)
     ==> d == #JournalCache.SuperblockReadResult.SuperblockCorruption());

// Constructor $Is
axiom $Is(#JournalCache.SuperblockReadResult.SuperblockCorruption(), 
  Tclass.JournalCache.SuperblockReadResult());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.SuperblockReadResult.SuperblockCorruption(), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.SuperblockReadResult.SuperblockCorruption(), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h));

// Constructor literal
axiom #JournalCache.SuperblockReadResult.SuperblockCorruption()
   == Lit(#JournalCache.SuperblockReadResult.SuperblockCorruption());

// Depth-one case-split function
function $IsA#JournalCache.SuperblockReadResult(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.SuperblockReadResult(d) } 
  $IsA#JournalCache.SuperblockReadResult(d)
     ==> JournalCache.SuperblockReadResult.SuperblockSuccess_q(d)
       || JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d)
       || JournalCache.SuperblockReadResult.SuperblockCorruption_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.SuperblockReadResult.SuperblockCorruption_q(d), $Is(d, Tclass.JournalCache.SuperblockReadResult()) } 
    { JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d), $Is(d, Tclass.JournalCache.SuperblockReadResult()) } 
    { JournalCache.SuperblockReadResult.SuperblockSuccess_q(d), $Is(d, Tclass.JournalCache.SuperblockReadResult()) } 
  $Is(d, Tclass.JournalCache.SuperblockReadResult())
     ==> JournalCache.SuperblockReadResult.SuperblockSuccess_q(d)
       || JournalCache.SuperblockReadResult.SuperblockUnfinished_q(d)
       || JournalCache.SuperblockReadResult.SuperblockCorruption_q(d));

// Datatype extensional equality declaration
function JournalCache.SuperblockReadResult#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.SuperblockReadResult.SuperblockSuccess
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SuperblockReadResult#Equal(a, b), JournalCache.SuperblockReadResult.SuperblockSuccess_q(a) } 
    { JournalCache.SuperblockReadResult#Equal(a, b), JournalCache.SuperblockReadResult.SuperblockSuccess_q(b) } 
  JournalCache.SuperblockReadResult.SuperblockSuccess_q(a)
       && JournalCache.SuperblockReadResult.SuperblockSuccess_q(b)
     ==> (JournalCache.SuperblockReadResult#Equal(a, b)
       <==> SectorType.Superblock#Equal(JournalCache.SuperblockReadResult.value(a), 
        JournalCache.SuperblockReadResult.value(b))));

// Datatype extensional equality definition: #JournalCache.SuperblockReadResult.SuperblockUnfinished
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SuperblockReadResult#Equal(a, b), JournalCache.SuperblockReadResult.SuperblockUnfinished_q(a) } 
    { JournalCache.SuperblockReadResult#Equal(a, b), JournalCache.SuperblockReadResult.SuperblockUnfinished_q(b) } 
  JournalCache.SuperblockReadResult.SuperblockUnfinished_q(a)
       && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(b)
     ==> (JournalCache.SuperblockReadResult#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.SuperblockReadResult.SuperblockCorruption
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SuperblockReadResult#Equal(a, b), JournalCache.SuperblockReadResult.SuperblockCorruption_q(a) } 
    { JournalCache.SuperblockReadResult#Equal(a, b), JournalCache.SuperblockReadResult.SuperblockCorruption_q(b) } 
  JournalCache.SuperblockReadResult.SuperblockCorruption_q(a)
       && JournalCache.SuperblockReadResult.SuperblockCorruption_q(b)
     ==> (JournalCache.SuperblockReadResult#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalCache.SuperblockReadResult
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.SuperblockReadResult#Equal(a, b) } 
  JournalCache.SuperblockReadResult#Equal(a, b) <==> a == b);

const unique class.JournalCache.SuperblockReadResult: ClassName;

// Constructor function declaration
function #JournalCache.CommitStatus.CommitNone() : DatatypeType;

const unique ##JournalCache.CommitStatus.CommitNone: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.CommitStatus.CommitNone())
   == ##JournalCache.CommitStatus.CommitNone;

function JournalCache.CommitStatus.CommitNone_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitNone_q(d) } 
  JournalCache.CommitStatus.CommitNone_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.CommitStatus.CommitNone);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitNone_q(d) } 
  JournalCache.CommitStatus.CommitNone_q(d)
     ==> d == #JournalCache.CommitStatus.CommitNone());

function Tclass.JournalCache.CommitStatus() : Ty;

// Tclass.JournalCache.CommitStatus Tag
axiom Tag(Tclass.JournalCache.CommitStatus()) == Tagclass.JournalCache.CommitStatus;

const unique Tagclass.JournalCache.CommitStatus: TyTag;

// Box/unbox axiom for Tclass.JournalCache.CommitStatus
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.CommitStatus()) } 
  $IsBox(bx, Tclass.JournalCache.CommitStatus())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.CommitStatus()));

// Constructor $Is
axiom $Is(#JournalCache.CommitStatus.CommitNone(), Tclass.JournalCache.CommitStatus());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.CommitStatus.CommitNone(), Tclass.JournalCache.CommitStatus(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.CommitStatus.CommitNone(), Tclass.JournalCache.CommitStatus(), $h));

// Constructor literal
axiom #JournalCache.CommitStatus.CommitNone()
   == Lit(#JournalCache.CommitStatus.CommitNone());

// Constructor function declaration
function #JournalCache.CommitStatus.CommitAdvanceLog() : DatatypeType;

const unique ##JournalCache.CommitStatus.CommitAdvanceLog: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.CommitStatus.CommitAdvanceLog())
   == ##JournalCache.CommitStatus.CommitAdvanceLog;

function JournalCache.CommitStatus.CommitAdvanceLog_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitAdvanceLog_q(d) } 
  JournalCache.CommitStatus.CommitAdvanceLog_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.CommitStatus.CommitAdvanceLog);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitAdvanceLog_q(d) } 
  JournalCache.CommitStatus.CommitAdvanceLog_q(d)
     ==> d == #JournalCache.CommitStatus.CommitAdvanceLog());

// Constructor $Is
axiom $Is(#JournalCache.CommitStatus.CommitAdvanceLog(), 
  Tclass.JournalCache.CommitStatus());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.CommitStatus.CommitAdvanceLog(), 
      Tclass.JournalCache.CommitStatus(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.CommitStatus.CommitAdvanceLog(), 
      Tclass.JournalCache.CommitStatus(), 
      $h));

// Constructor literal
axiom #JournalCache.CommitStatus.CommitAdvanceLog()
   == Lit(#JournalCache.CommitStatus.CommitAdvanceLog());

// Constructor function declaration
function #JournalCache.CommitStatus.CommitAdvanceLocation() : DatatypeType;

const unique ##JournalCache.CommitStatus.CommitAdvanceLocation: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.CommitStatus.CommitAdvanceLocation())
   == ##JournalCache.CommitStatus.CommitAdvanceLocation;

function JournalCache.CommitStatus.CommitAdvanceLocation_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitAdvanceLocation_q(d) } 
  JournalCache.CommitStatus.CommitAdvanceLocation_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.CommitStatus.CommitAdvanceLocation);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitAdvanceLocation_q(d) } 
  JournalCache.CommitStatus.CommitAdvanceLocation_q(d)
     ==> d == #JournalCache.CommitStatus.CommitAdvanceLocation());

// Constructor $Is
axiom $Is(#JournalCache.CommitStatus.CommitAdvanceLocation(), 
  Tclass.JournalCache.CommitStatus());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.CommitStatus.CommitAdvanceLocation(), 
      Tclass.JournalCache.CommitStatus(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.CommitStatus.CommitAdvanceLocation(), 
      Tclass.JournalCache.CommitStatus(), 
      $h));

// Constructor literal
axiom #JournalCache.CommitStatus.CommitAdvanceLocation()
   == Lit(#JournalCache.CommitStatus.CommitAdvanceLocation());

// Depth-one case-split function
function $IsA#JournalCache.CommitStatus(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.CommitStatus(d) } 
  $IsA#JournalCache.CommitStatus(d)
     ==> JournalCache.CommitStatus.CommitNone_q(d)
       || JournalCache.CommitStatus.CommitAdvanceLog_q(d)
       || JournalCache.CommitStatus.CommitAdvanceLocation_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.CommitStatus.CommitAdvanceLocation_q(d), $Is(d, Tclass.JournalCache.CommitStatus()) } 
    { JournalCache.CommitStatus.CommitAdvanceLog_q(d), $Is(d, Tclass.JournalCache.CommitStatus()) } 
    { JournalCache.CommitStatus.CommitNone_q(d), $Is(d, Tclass.JournalCache.CommitStatus()) } 
  $Is(d, Tclass.JournalCache.CommitStatus())
     ==> JournalCache.CommitStatus.CommitNone_q(d)
       || JournalCache.CommitStatus.CommitAdvanceLog_q(d)
       || JournalCache.CommitStatus.CommitAdvanceLocation_q(d));

// Datatype extensional equality declaration
function JournalCache.CommitStatus#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.CommitStatus.CommitNone
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.CommitStatus#Equal(a, b), JournalCache.CommitStatus.CommitNone_q(a) } 
    { JournalCache.CommitStatus#Equal(a, b), JournalCache.CommitStatus.CommitNone_q(b) } 
  JournalCache.CommitStatus.CommitNone_q(a)
       && JournalCache.CommitStatus.CommitNone_q(b)
     ==> (JournalCache.CommitStatus#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.CommitStatus.CommitAdvanceLog
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.CommitStatus#Equal(a, b), JournalCache.CommitStatus.CommitAdvanceLog_q(a) } 
    { JournalCache.CommitStatus#Equal(a, b), JournalCache.CommitStatus.CommitAdvanceLog_q(b) } 
  JournalCache.CommitStatus.CommitAdvanceLog_q(a)
       && JournalCache.CommitStatus.CommitAdvanceLog_q(b)
     ==> (JournalCache.CommitStatus#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.CommitStatus.CommitAdvanceLocation
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.CommitStatus#Equal(a, b), JournalCache.CommitStatus.CommitAdvanceLocation_q(a) } 
    { JournalCache.CommitStatus#Equal(a, b), JournalCache.CommitStatus.CommitAdvanceLocation_q(b) } 
  JournalCache.CommitStatus.CommitAdvanceLocation_q(a)
       && JournalCache.CommitStatus.CommitAdvanceLocation_q(b)
     ==> (JournalCache.CommitStatus#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalCache.CommitStatus
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.CommitStatus#Equal(a, b) } 
  JournalCache.CommitStatus#Equal(a, b) <==> a == b);

const unique class.JournalCache.CommitStatus: ClassName;

// Constructor function declaration
function #JournalCache.Variables.Ready(DatatypeType, 
    bool, 
    int, 
    DatatypeType, 
    Seq Box, 
    Seq Box, 
    Set Box, 
    int, 
    Seq Box, 
    DatatypeType, 
    int, 
    DatatypeType, 
    DatatypeType, 
    Map Box Box)
   : DatatypeType;

const unique ##JournalCache.Variables.Ready: DtCtorId;

// Constructor identifier
axiom (forall a#52#0#0: DatatypeType, 
    a#52#1#0: bool, 
    a#52#2#0: int, 
    a#52#3#0: DatatypeType, 
    a#52#4#0: Seq Box, 
    a#52#5#0: Seq Box, 
    a#52#6#0: Set Box, 
    a#52#7#0: int, 
    a#52#8#0: Seq Box, 
    a#52#9#0: DatatypeType, 
    a#52#10#0: int, 
    a#52#11#0: DatatypeType, 
    a#52#12#0: DatatypeType, 
    a#52#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#52#0#0, 
      a#52#1#0, 
      a#52#2#0, 
      a#52#3#0, 
      a#52#4#0, 
      a#52#5#0, 
      a#52#6#0, 
      a#52#7#0, 
      a#52#8#0, 
      a#52#9#0, 
      a#52#10#0, 
      a#52#11#0, 
      a#52#12#0, 
      a#52#13#0) } 
  DatatypeCtorId(#JournalCache.Variables.Ready(a#52#0#0, 
        a#52#1#0, 
        a#52#2#0, 
        a#52#3#0, 
        a#52#4#0, 
        a#52#5#0, 
        a#52#6#0, 
        a#52#7#0, 
        a#52#8#0, 
        a#52#9#0, 
        a#52#10#0, 
        a#52#11#0, 
        a#52#12#0, 
        a#52#13#0))
     == ##JournalCache.Variables.Ready);

function JournalCache.Variables.Ready_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.Ready_q(d) } 
  JournalCache.Variables.Ready_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Variables.Ready);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.Ready_q(d) } 
  JournalCache.Variables.Ready_q(d)
     ==> (exists a#53#0#0: DatatypeType, 
        a#53#1#0: bool, 
        a#53#2#0: int, 
        a#53#3#0: DatatypeType, 
        a#53#4#0: Seq Box, 
        a#53#5#0: Seq Box, 
        a#53#6#0: Set Box, 
        a#53#7#0: int, 
        a#53#8#0: Seq Box, 
        a#53#9#0: DatatypeType, 
        a#53#10#0: int, 
        a#53#11#0: DatatypeType, 
        a#53#12#0: DatatypeType, 
        a#53#13#0: Map Box Box :: 
      d
         == #JournalCache.Variables.Ready(a#53#0#0, 
          a#53#1#0, 
          a#53#2#0, 
          a#53#3#0, 
          a#53#4#0, 
          a#53#5#0, 
          a#53#6#0, 
          a#53#7#0, 
          a#53#8#0, 
          a#53#9#0, 
          a#53#10#0, 
          a#53#11#0, 
          a#53#12#0, 
          a#53#13#0)));

function Tclass.JournalCache.Variables() : Ty;

// Tclass.JournalCache.Variables Tag
axiom Tag(Tclass.JournalCache.Variables()) == Tagclass.JournalCache.Variables;

const unique Tagclass.JournalCache.Variables: TyTag;

// Box/unbox axiom for Tclass.JournalCache.Variables
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.Variables()) } 
  $IsBox(bx, Tclass.JournalCache.Variables())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.Variables()));

// Constructor $Is
axiom (forall a#54#0#0: DatatypeType, 
    a#54#1#0: bool, 
    a#54#2#0: int, 
    a#54#3#0: DatatypeType, 
    a#54#4#0: Seq Box, 
    a#54#5#0: Seq Box, 
    a#54#6#0: Set Box, 
    a#54#7#0: int, 
    a#54#8#0: Seq Box, 
    a#54#9#0: DatatypeType, 
    a#54#10#0: int, 
    a#54#11#0: DatatypeType, 
    a#54#12#0: DatatypeType, 
    a#54#13#0: Map Box Box :: 
  { $Is(#JournalCache.Variables.Ready(a#54#0#0, 
        a#54#1#0, 
        a#54#2#0, 
        a#54#3#0, 
        a#54#4#0, 
        a#54#5#0, 
        a#54#6#0, 
        a#54#7#0, 
        a#54#8#0, 
        a#54#9#0, 
        a#54#10#0, 
        a#54#11#0, 
        a#54#12#0, 
        a#54#13#0), 
      Tclass.JournalCache.Variables()) } 
  $Is(#JournalCache.Variables.Ready(a#54#0#0, 
        a#54#1#0, 
        a#54#2#0, 
        a#54#3#0, 
        a#54#4#0, 
        a#54#5#0, 
        a#54#6#0, 
        a#54#7#0, 
        a#54#8#0, 
        a#54#9#0, 
        a#54#10#0, 
        a#54#11#0, 
        a#54#12#0, 
        a#54#13#0), 
      Tclass.JournalCache.Variables())
     <==> $Is(a#54#0#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
       && $Is(a#54#1#0, TBool)
       && $Is(a#54#2#0, TInt)
       && $Is(a#54#3#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#54#4#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#54#5#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#54#6#0, TSet(Tclass.NativeTypes.uint64()))
       && $Is(a#54#7#0, TInt)
       && $Is(a#54#8#0, TSeq(Tclass.Journal.JournalEntry()))
       && $Is(a#54#9#0, Tclass.SectorType.Superblock())
       && $Is(a#54#10#0, TInt)
       && $Is(a#54#11#0, Tclass.JournalCache.CommitStatus())
       && $Is(a#54#12#0, Tclass.Options.Option(Tclass.SectorType.Superblock()))
       && $Is(a#54#13#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// Constructor $IsAlloc
axiom (forall a#55#0#0: DatatypeType, 
    a#55#1#0: bool, 
    a#55#2#0: int, 
    a#55#3#0: DatatypeType, 
    a#55#4#0: Seq Box, 
    a#55#5#0: Seq Box, 
    a#55#6#0: Set Box, 
    a#55#7#0: int, 
    a#55#8#0: Seq Box, 
    a#55#9#0: DatatypeType, 
    a#55#10#0: int, 
    a#55#11#0: DatatypeType, 
    a#55#12#0: DatatypeType, 
    a#55#13#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#JournalCache.Variables.Ready(a#55#0#0, 
        a#55#1#0, 
        a#55#2#0, 
        a#55#3#0, 
        a#55#4#0, 
        a#55#5#0, 
        a#55#6#0, 
        a#55#7#0, 
        a#55#8#0, 
        a#55#9#0, 
        a#55#10#0, 
        a#55#11#0, 
        a#55#12#0, 
        a#55#13#0), 
      Tclass.JournalCache.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Variables.Ready(a#55#0#0, 
          a#55#1#0, 
          a#55#2#0, 
          a#55#3#0, 
          a#55#4#0, 
          a#55#5#0, 
          a#55#6#0, 
          a#55#7#0, 
          a#55#8#0, 
          a#55#9#0, 
          a#55#10#0, 
          a#55#11#0, 
          a#55#12#0, 
          a#55#13#0), 
        Tclass.JournalCache.Variables(), 
        $h)
       <==> $IsAlloc(a#55#0#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#55#1#0, TBool, $h)
         && $IsAlloc(a#55#2#0, TInt, $h)
         && $IsAlloc(a#55#3#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#55#4#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#55#5#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#55#6#0, TSet(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#55#7#0, TInt, $h)
         && $IsAlloc(a#55#8#0, TSeq(Tclass.Journal.JournalEntry()), $h)
         && $IsAlloc(a#55#9#0, Tclass.SectorType.Superblock(), $h)
         && $IsAlloc(a#55#10#0, TInt, $h)
         && $IsAlloc(a#55#11#0, Tclass.JournalCache.CommitStatus(), $h)
         && $IsAlloc(a#55#12#0, Tclass.Options.Option(Tclass.SectorType.Superblock()), $h)
         && $IsAlloc(a#55#13#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
          $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.frozenLoc(d), 
      Tclass.Options.Option(Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.frozenLoc(d), 
      Tclass.Options.Option(Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.isFrozen(d), TBool, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.isFrozen(d), TBool, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.frozenJournalPosition(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.frozenJournalPosition(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.superblockWrite(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.superblockWrite(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.inMemoryJournalFrozen(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.inMemoryJournalFrozen(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.inMemoryJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.inMemoryJournal(d), 
      TSeq(Tclass.Journal.JournalEntry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.outstandingJournalWrites(d), 
      TSet(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.outstandingJournalWrites(d), 
      TSet(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.writtenJournalLen(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.writtenJournalLen(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.replayJournal(d), TSeq(Tclass.Journal.JournalEntry()), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.replayJournal(d), TSeq(Tclass.Journal.JournalEntry()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.superblock(d), Tclass.SectorType.Superblock(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.superblock(d), Tclass.SectorType.Superblock(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.whichSuperblock(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.whichSuperblock(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.commitStatus(d), Tclass.JournalCache.CommitStatus(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.commitStatus(d), Tclass.JournalCache.CommitStatus(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.newSuperblock(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.newSuperblock(d), 
      Tclass.Options.Option(Tclass.SectorType.Superblock()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.syncReqs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.Ready_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.syncReqs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
      $h));

// Constructor literal
axiom (forall a#56#0#0: DatatypeType, 
    a#56#1#0: bool, 
    a#56#2#0: int, 
    a#56#3#0: DatatypeType, 
    a#56#4#0: Seq Box, 
    a#56#5#0: Seq Box, 
    a#56#6#0: Set Box, 
    a#56#7#0: int, 
    a#56#8#0: Seq Box, 
    a#56#9#0: DatatypeType, 
    a#56#10#0: int, 
    a#56#11#0: DatatypeType, 
    a#56#12#0: DatatypeType, 
    a#56#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(Lit(a#56#0#0), 
      Lit(a#56#1#0), 
      LitInt(a#56#2#0), 
      Lit(a#56#3#0), 
      Lit(a#56#4#0), 
      Lit(a#56#5#0), 
      Lit(a#56#6#0), 
      LitInt(a#56#7#0), 
      Lit(a#56#8#0), 
      Lit(a#56#9#0), 
      LitInt(a#56#10#0), 
      Lit(a#56#11#0), 
      Lit(a#56#12#0), 
      Lit(a#56#13#0)) } 
  #JournalCache.Variables.Ready(Lit(a#56#0#0), 
      Lit(a#56#1#0), 
      LitInt(a#56#2#0), 
      Lit(a#56#3#0), 
      Lit(a#56#4#0), 
      Lit(a#56#5#0), 
      Lit(a#56#6#0), 
      LitInt(a#56#7#0), 
      Lit(a#56#8#0), 
      Lit(a#56#9#0), 
      LitInt(a#56#10#0), 
      Lit(a#56#11#0), 
      Lit(a#56#12#0), 
      Lit(a#56#13#0))
     == Lit(#JournalCache.Variables.Ready(a#56#0#0, 
        a#56#1#0, 
        a#56#2#0, 
        a#56#3#0, 
        a#56#4#0, 
        a#56#5#0, 
        a#56#6#0, 
        a#56#7#0, 
        a#56#8#0, 
        a#56#9#0, 
        a#56#10#0, 
        a#56#11#0, 
        a#56#12#0, 
        a#56#13#0)));

function JournalCache.Variables.frozenLoc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#57#0#0: DatatypeType, 
    a#57#1#0: bool, 
    a#57#2#0: int, 
    a#57#3#0: DatatypeType, 
    a#57#4#0: Seq Box, 
    a#57#5#0: Seq Box, 
    a#57#6#0: Set Box, 
    a#57#7#0: int, 
    a#57#8#0: Seq Box, 
    a#57#9#0: DatatypeType, 
    a#57#10#0: int, 
    a#57#11#0: DatatypeType, 
    a#57#12#0: DatatypeType, 
    a#57#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#57#0#0, 
      a#57#1#0, 
      a#57#2#0, 
      a#57#3#0, 
      a#57#4#0, 
      a#57#5#0, 
      a#57#6#0, 
      a#57#7#0, 
      a#57#8#0, 
      a#57#9#0, 
      a#57#10#0, 
      a#57#11#0, 
      a#57#12#0, 
      a#57#13#0) } 
  JournalCache.Variables.frozenLoc(#JournalCache.Variables.Ready(a#57#0#0, 
        a#57#1#0, 
        a#57#2#0, 
        a#57#3#0, 
        a#57#4#0, 
        a#57#5#0, 
        a#57#6#0, 
        a#57#7#0, 
        a#57#8#0, 
        a#57#9#0, 
        a#57#10#0, 
        a#57#11#0, 
        a#57#12#0, 
        a#57#13#0))
     == a#57#0#0);

// Inductive rank
axiom (forall a#58#0#0: DatatypeType, 
    a#58#1#0: bool, 
    a#58#2#0: int, 
    a#58#3#0: DatatypeType, 
    a#58#4#0: Seq Box, 
    a#58#5#0: Seq Box, 
    a#58#6#0: Set Box, 
    a#58#7#0: int, 
    a#58#8#0: Seq Box, 
    a#58#9#0: DatatypeType, 
    a#58#10#0: int, 
    a#58#11#0: DatatypeType, 
    a#58#12#0: DatatypeType, 
    a#58#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#58#0#0, 
      a#58#1#0, 
      a#58#2#0, 
      a#58#3#0, 
      a#58#4#0, 
      a#58#5#0, 
      a#58#6#0, 
      a#58#7#0, 
      a#58#8#0, 
      a#58#9#0, 
      a#58#10#0, 
      a#58#11#0, 
      a#58#12#0, 
      a#58#13#0) } 
  DtRank(a#58#0#0)
     < DtRank(#JournalCache.Variables.Ready(a#58#0#0, 
        a#58#1#0, 
        a#58#2#0, 
        a#58#3#0, 
        a#58#4#0, 
        a#58#5#0, 
        a#58#6#0, 
        a#58#7#0, 
        a#58#8#0, 
        a#58#9#0, 
        a#58#10#0, 
        a#58#11#0, 
        a#58#12#0, 
        a#58#13#0)));

function JournalCache.Variables.isFrozen(DatatypeType) : bool;

// Constructor injectivity
axiom (forall a#59#0#0: DatatypeType, 
    a#59#1#0: bool, 
    a#59#2#0: int, 
    a#59#3#0: DatatypeType, 
    a#59#4#0: Seq Box, 
    a#59#5#0: Seq Box, 
    a#59#6#0: Set Box, 
    a#59#7#0: int, 
    a#59#8#0: Seq Box, 
    a#59#9#0: DatatypeType, 
    a#59#10#0: int, 
    a#59#11#0: DatatypeType, 
    a#59#12#0: DatatypeType, 
    a#59#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#59#0#0, 
      a#59#1#0, 
      a#59#2#0, 
      a#59#3#0, 
      a#59#4#0, 
      a#59#5#0, 
      a#59#6#0, 
      a#59#7#0, 
      a#59#8#0, 
      a#59#9#0, 
      a#59#10#0, 
      a#59#11#0, 
      a#59#12#0, 
      a#59#13#0) } 
  JournalCache.Variables.isFrozen(#JournalCache.Variables.Ready(a#59#0#0, 
        a#59#1#0, 
        a#59#2#0, 
        a#59#3#0, 
        a#59#4#0, 
        a#59#5#0, 
        a#59#6#0, 
        a#59#7#0, 
        a#59#8#0, 
        a#59#9#0, 
        a#59#10#0, 
        a#59#11#0, 
        a#59#12#0, 
        a#59#13#0))
     == a#59#1#0);

function JournalCache.Variables.frozenJournalPosition(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#60#0#0: DatatypeType, 
    a#60#1#0: bool, 
    a#60#2#0: int, 
    a#60#3#0: DatatypeType, 
    a#60#4#0: Seq Box, 
    a#60#5#0: Seq Box, 
    a#60#6#0: Set Box, 
    a#60#7#0: int, 
    a#60#8#0: Seq Box, 
    a#60#9#0: DatatypeType, 
    a#60#10#0: int, 
    a#60#11#0: DatatypeType, 
    a#60#12#0: DatatypeType, 
    a#60#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#60#0#0, 
      a#60#1#0, 
      a#60#2#0, 
      a#60#3#0, 
      a#60#4#0, 
      a#60#5#0, 
      a#60#6#0, 
      a#60#7#0, 
      a#60#8#0, 
      a#60#9#0, 
      a#60#10#0, 
      a#60#11#0, 
      a#60#12#0, 
      a#60#13#0) } 
  JournalCache.Variables.frozenJournalPosition(#JournalCache.Variables.Ready(a#60#0#0, 
        a#60#1#0, 
        a#60#2#0, 
        a#60#3#0, 
        a#60#4#0, 
        a#60#5#0, 
        a#60#6#0, 
        a#60#7#0, 
        a#60#8#0, 
        a#60#9#0, 
        a#60#10#0, 
        a#60#11#0, 
        a#60#12#0, 
        a#60#13#0))
     == a#60#2#0);

function JournalCache.Variables.superblockWrite(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#61#0#0: DatatypeType, 
    a#61#1#0: bool, 
    a#61#2#0: int, 
    a#61#3#0: DatatypeType, 
    a#61#4#0: Seq Box, 
    a#61#5#0: Seq Box, 
    a#61#6#0: Set Box, 
    a#61#7#0: int, 
    a#61#8#0: Seq Box, 
    a#61#9#0: DatatypeType, 
    a#61#10#0: int, 
    a#61#11#0: DatatypeType, 
    a#61#12#0: DatatypeType, 
    a#61#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#61#0#0, 
      a#61#1#0, 
      a#61#2#0, 
      a#61#3#0, 
      a#61#4#0, 
      a#61#5#0, 
      a#61#6#0, 
      a#61#7#0, 
      a#61#8#0, 
      a#61#9#0, 
      a#61#10#0, 
      a#61#11#0, 
      a#61#12#0, 
      a#61#13#0) } 
  JournalCache.Variables.superblockWrite(#JournalCache.Variables.Ready(a#61#0#0, 
        a#61#1#0, 
        a#61#2#0, 
        a#61#3#0, 
        a#61#4#0, 
        a#61#5#0, 
        a#61#6#0, 
        a#61#7#0, 
        a#61#8#0, 
        a#61#9#0, 
        a#61#10#0, 
        a#61#11#0, 
        a#61#12#0, 
        a#61#13#0))
     == a#61#3#0);

// Inductive rank
axiom (forall a#62#0#0: DatatypeType, 
    a#62#1#0: bool, 
    a#62#2#0: int, 
    a#62#3#0: DatatypeType, 
    a#62#4#0: Seq Box, 
    a#62#5#0: Seq Box, 
    a#62#6#0: Set Box, 
    a#62#7#0: int, 
    a#62#8#0: Seq Box, 
    a#62#9#0: DatatypeType, 
    a#62#10#0: int, 
    a#62#11#0: DatatypeType, 
    a#62#12#0: DatatypeType, 
    a#62#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#62#0#0, 
      a#62#1#0, 
      a#62#2#0, 
      a#62#3#0, 
      a#62#4#0, 
      a#62#5#0, 
      a#62#6#0, 
      a#62#7#0, 
      a#62#8#0, 
      a#62#9#0, 
      a#62#10#0, 
      a#62#11#0, 
      a#62#12#0, 
      a#62#13#0) } 
  DtRank(a#62#3#0)
     < DtRank(#JournalCache.Variables.Ready(a#62#0#0, 
        a#62#1#0, 
        a#62#2#0, 
        a#62#3#0, 
        a#62#4#0, 
        a#62#5#0, 
        a#62#6#0, 
        a#62#7#0, 
        a#62#8#0, 
        a#62#9#0, 
        a#62#10#0, 
        a#62#11#0, 
        a#62#12#0, 
        a#62#13#0)));

function JournalCache.Variables.inMemoryJournalFrozen(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#63#0#0: DatatypeType, 
    a#63#1#0: bool, 
    a#63#2#0: int, 
    a#63#3#0: DatatypeType, 
    a#63#4#0: Seq Box, 
    a#63#5#0: Seq Box, 
    a#63#6#0: Set Box, 
    a#63#7#0: int, 
    a#63#8#0: Seq Box, 
    a#63#9#0: DatatypeType, 
    a#63#10#0: int, 
    a#63#11#0: DatatypeType, 
    a#63#12#0: DatatypeType, 
    a#63#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#63#0#0, 
      a#63#1#0, 
      a#63#2#0, 
      a#63#3#0, 
      a#63#4#0, 
      a#63#5#0, 
      a#63#6#0, 
      a#63#7#0, 
      a#63#8#0, 
      a#63#9#0, 
      a#63#10#0, 
      a#63#11#0, 
      a#63#12#0, 
      a#63#13#0) } 
  JournalCache.Variables.inMemoryJournalFrozen(#JournalCache.Variables.Ready(a#63#0#0, 
        a#63#1#0, 
        a#63#2#0, 
        a#63#3#0, 
        a#63#4#0, 
        a#63#5#0, 
        a#63#6#0, 
        a#63#7#0, 
        a#63#8#0, 
        a#63#9#0, 
        a#63#10#0, 
        a#63#11#0, 
        a#63#12#0, 
        a#63#13#0))
     == a#63#4#0);

// Inductive seq element rank
axiom (forall a#64#0#0: DatatypeType, 
    a#64#1#0: bool, 
    a#64#2#0: int, 
    a#64#3#0: DatatypeType, 
    a#64#4#0: Seq Box, 
    a#64#5#0: Seq Box, 
    a#64#6#0: Set Box, 
    a#64#7#0: int, 
    a#64#8#0: Seq Box, 
    a#64#9#0: DatatypeType, 
    a#64#10#0: int, 
    a#64#11#0: DatatypeType, 
    a#64#12#0: DatatypeType, 
    a#64#13#0: Map Box Box, 
    i: int :: 
  { Seq#Index(a#64#4#0, i), #JournalCache.Variables.Ready(a#64#0#0, 
      a#64#1#0, 
      a#64#2#0, 
      a#64#3#0, 
      a#64#4#0, 
      a#64#5#0, 
      a#64#6#0, 
      a#64#7#0, 
      a#64#8#0, 
      a#64#9#0, 
      a#64#10#0, 
      a#64#11#0, 
      a#64#12#0, 
      a#64#13#0) } 
  0 <= i && i < Seq#Length(a#64#4#0)
     ==> DtRank($Unbox(Seq#Index(a#64#4#0, i)): DatatypeType)
       < DtRank(#JournalCache.Variables.Ready(a#64#0#0, 
          a#64#1#0, 
          a#64#2#0, 
          a#64#3#0, 
          a#64#4#0, 
          a#64#5#0, 
          a#64#6#0, 
          a#64#7#0, 
          a#64#8#0, 
          a#64#9#0, 
          a#64#10#0, 
          a#64#11#0, 
          a#64#12#0, 
          a#64#13#0)));

// Inductive seq rank
axiom (forall a#65#0#0: DatatypeType, 
    a#65#1#0: bool, 
    a#65#2#0: int, 
    a#65#3#0: DatatypeType, 
    a#65#4#0: Seq Box, 
    a#65#5#0: Seq Box, 
    a#65#6#0: Set Box, 
    a#65#7#0: int, 
    a#65#8#0: Seq Box, 
    a#65#9#0: DatatypeType, 
    a#65#10#0: int, 
    a#65#11#0: DatatypeType, 
    a#65#12#0: DatatypeType, 
    a#65#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#65#0#0, 
      a#65#1#0, 
      a#65#2#0, 
      a#65#3#0, 
      a#65#4#0, 
      a#65#5#0, 
      a#65#6#0, 
      a#65#7#0, 
      a#65#8#0, 
      a#65#9#0, 
      a#65#10#0, 
      a#65#11#0, 
      a#65#12#0, 
      a#65#13#0) } 
  Seq#Rank(a#65#4#0)
     < DtRank(#JournalCache.Variables.Ready(a#65#0#0, 
        a#65#1#0, 
        a#65#2#0, 
        a#65#3#0, 
        a#65#4#0, 
        a#65#5#0, 
        a#65#6#0, 
        a#65#7#0, 
        a#65#8#0, 
        a#65#9#0, 
        a#65#10#0, 
        a#65#11#0, 
        a#65#12#0, 
        a#65#13#0)));

function JournalCache.Variables.inMemoryJournal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#66#0#0: DatatypeType, 
    a#66#1#0: bool, 
    a#66#2#0: int, 
    a#66#3#0: DatatypeType, 
    a#66#4#0: Seq Box, 
    a#66#5#0: Seq Box, 
    a#66#6#0: Set Box, 
    a#66#7#0: int, 
    a#66#8#0: Seq Box, 
    a#66#9#0: DatatypeType, 
    a#66#10#0: int, 
    a#66#11#0: DatatypeType, 
    a#66#12#0: DatatypeType, 
    a#66#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#66#0#0, 
      a#66#1#0, 
      a#66#2#0, 
      a#66#3#0, 
      a#66#4#0, 
      a#66#5#0, 
      a#66#6#0, 
      a#66#7#0, 
      a#66#8#0, 
      a#66#9#0, 
      a#66#10#0, 
      a#66#11#0, 
      a#66#12#0, 
      a#66#13#0) } 
  JournalCache.Variables.inMemoryJournal(#JournalCache.Variables.Ready(a#66#0#0, 
        a#66#1#0, 
        a#66#2#0, 
        a#66#3#0, 
        a#66#4#0, 
        a#66#5#0, 
        a#66#6#0, 
        a#66#7#0, 
        a#66#8#0, 
        a#66#9#0, 
        a#66#10#0, 
        a#66#11#0, 
        a#66#12#0, 
        a#66#13#0))
     == a#66#5#0);

// Inductive seq element rank
axiom (forall a#67#0#0: DatatypeType, 
    a#67#1#0: bool, 
    a#67#2#0: int, 
    a#67#3#0: DatatypeType, 
    a#67#4#0: Seq Box, 
    a#67#5#0: Seq Box, 
    a#67#6#0: Set Box, 
    a#67#7#0: int, 
    a#67#8#0: Seq Box, 
    a#67#9#0: DatatypeType, 
    a#67#10#0: int, 
    a#67#11#0: DatatypeType, 
    a#67#12#0: DatatypeType, 
    a#67#13#0: Map Box Box, 
    i: int :: 
  { Seq#Index(a#67#5#0, i), #JournalCache.Variables.Ready(a#67#0#0, 
      a#67#1#0, 
      a#67#2#0, 
      a#67#3#0, 
      a#67#4#0, 
      a#67#5#0, 
      a#67#6#0, 
      a#67#7#0, 
      a#67#8#0, 
      a#67#9#0, 
      a#67#10#0, 
      a#67#11#0, 
      a#67#12#0, 
      a#67#13#0) } 
  0 <= i && i < Seq#Length(a#67#5#0)
     ==> DtRank($Unbox(Seq#Index(a#67#5#0, i)): DatatypeType)
       < DtRank(#JournalCache.Variables.Ready(a#67#0#0, 
          a#67#1#0, 
          a#67#2#0, 
          a#67#3#0, 
          a#67#4#0, 
          a#67#5#0, 
          a#67#6#0, 
          a#67#7#0, 
          a#67#8#0, 
          a#67#9#0, 
          a#67#10#0, 
          a#67#11#0, 
          a#67#12#0, 
          a#67#13#0)));

// Inductive seq rank
axiom (forall a#68#0#0: DatatypeType, 
    a#68#1#0: bool, 
    a#68#2#0: int, 
    a#68#3#0: DatatypeType, 
    a#68#4#0: Seq Box, 
    a#68#5#0: Seq Box, 
    a#68#6#0: Set Box, 
    a#68#7#0: int, 
    a#68#8#0: Seq Box, 
    a#68#9#0: DatatypeType, 
    a#68#10#0: int, 
    a#68#11#0: DatatypeType, 
    a#68#12#0: DatatypeType, 
    a#68#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#68#0#0, 
      a#68#1#0, 
      a#68#2#0, 
      a#68#3#0, 
      a#68#4#0, 
      a#68#5#0, 
      a#68#6#0, 
      a#68#7#0, 
      a#68#8#0, 
      a#68#9#0, 
      a#68#10#0, 
      a#68#11#0, 
      a#68#12#0, 
      a#68#13#0) } 
  Seq#Rank(a#68#5#0)
     < DtRank(#JournalCache.Variables.Ready(a#68#0#0, 
        a#68#1#0, 
        a#68#2#0, 
        a#68#3#0, 
        a#68#4#0, 
        a#68#5#0, 
        a#68#6#0, 
        a#68#7#0, 
        a#68#8#0, 
        a#68#9#0, 
        a#68#10#0, 
        a#68#11#0, 
        a#68#12#0, 
        a#68#13#0)));

function JournalCache.Variables.outstandingJournalWrites(DatatypeType) : Set Box;

// Constructor injectivity
axiom (forall a#69#0#0: DatatypeType, 
    a#69#1#0: bool, 
    a#69#2#0: int, 
    a#69#3#0: DatatypeType, 
    a#69#4#0: Seq Box, 
    a#69#5#0: Seq Box, 
    a#69#6#0: Set Box, 
    a#69#7#0: int, 
    a#69#8#0: Seq Box, 
    a#69#9#0: DatatypeType, 
    a#69#10#0: int, 
    a#69#11#0: DatatypeType, 
    a#69#12#0: DatatypeType, 
    a#69#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#69#0#0, 
      a#69#1#0, 
      a#69#2#0, 
      a#69#3#0, 
      a#69#4#0, 
      a#69#5#0, 
      a#69#6#0, 
      a#69#7#0, 
      a#69#8#0, 
      a#69#9#0, 
      a#69#10#0, 
      a#69#11#0, 
      a#69#12#0, 
      a#69#13#0) } 
  JournalCache.Variables.outstandingJournalWrites(#JournalCache.Variables.Ready(a#69#0#0, 
        a#69#1#0, 
        a#69#2#0, 
        a#69#3#0, 
        a#69#4#0, 
        a#69#5#0, 
        a#69#6#0, 
        a#69#7#0, 
        a#69#8#0, 
        a#69#9#0, 
        a#69#10#0, 
        a#69#11#0, 
        a#69#12#0, 
        a#69#13#0))
     == a#69#6#0);

// Inductive set element rank
axiom (forall a#70#0#0: DatatypeType, 
    a#70#1#0: bool, 
    a#70#2#0: int, 
    a#70#3#0: DatatypeType, 
    a#70#4#0: Seq Box, 
    a#70#5#0: Seq Box, 
    a#70#6#0: Set Box, 
    a#70#7#0: int, 
    a#70#8#0: Seq Box, 
    a#70#9#0: DatatypeType, 
    a#70#10#0: int, 
    a#70#11#0: DatatypeType, 
    a#70#12#0: DatatypeType, 
    a#70#13#0: Map Box Box, 
    d: DatatypeType :: 
  { a#70#6#0[$Box(d)], #JournalCache.Variables.Ready(a#70#0#0, 
      a#70#1#0, 
      a#70#2#0, 
      a#70#3#0, 
      a#70#4#0, 
      a#70#5#0, 
      a#70#6#0, 
      a#70#7#0, 
      a#70#8#0, 
      a#70#9#0, 
      a#70#10#0, 
      a#70#11#0, 
      a#70#12#0, 
      a#70#13#0) } 
  a#70#6#0[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalCache.Variables.Ready(a#70#0#0, 
          a#70#1#0, 
          a#70#2#0, 
          a#70#3#0, 
          a#70#4#0, 
          a#70#5#0, 
          a#70#6#0, 
          a#70#7#0, 
          a#70#8#0, 
          a#70#9#0, 
          a#70#10#0, 
          a#70#11#0, 
          a#70#12#0, 
          a#70#13#0)));

function JournalCache.Variables.writtenJournalLen(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#71#0#0: DatatypeType, 
    a#71#1#0: bool, 
    a#71#2#0: int, 
    a#71#3#0: DatatypeType, 
    a#71#4#0: Seq Box, 
    a#71#5#0: Seq Box, 
    a#71#6#0: Set Box, 
    a#71#7#0: int, 
    a#71#8#0: Seq Box, 
    a#71#9#0: DatatypeType, 
    a#71#10#0: int, 
    a#71#11#0: DatatypeType, 
    a#71#12#0: DatatypeType, 
    a#71#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#71#0#0, 
      a#71#1#0, 
      a#71#2#0, 
      a#71#3#0, 
      a#71#4#0, 
      a#71#5#0, 
      a#71#6#0, 
      a#71#7#0, 
      a#71#8#0, 
      a#71#9#0, 
      a#71#10#0, 
      a#71#11#0, 
      a#71#12#0, 
      a#71#13#0) } 
  JournalCache.Variables.writtenJournalLen(#JournalCache.Variables.Ready(a#71#0#0, 
        a#71#1#0, 
        a#71#2#0, 
        a#71#3#0, 
        a#71#4#0, 
        a#71#5#0, 
        a#71#6#0, 
        a#71#7#0, 
        a#71#8#0, 
        a#71#9#0, 
        a#71#10#0, 
        a#71#11#0, 
        a#71#12#0, 
        a#71#13#0))
     == a#71#7#0);

function JournalCache.Variables.replayJournal(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#72#0#0: DatatypeType, 
    a#72#1#0: bool, 
    a#72#2#0: int, 
    a#72#3#0: DatatypeType, 
    a#72#4#0: Seq Box, 
    a#72#5#0: Seq Box, 
    a#72#6#0: Set Box, 
    a#72#7#0: int, 
    a#72#8#0: Seq Box, 
    a#72#9#0: DatatypeType, 
    a#72#10#0: int, 
    a#72#11#0: DatatypeType, 
    a#72#12#0: DatatypeType, 
    a#72#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#72#0#0, 
      a#72#1#0, 
      a#72#2#0, 
      a#72#3#0, 
      a#72#4#0, 
      a#72#5#0, 
      a#72#6#0, 
      a#72#7#0, 
      a#72#8#0, 
      a#72#9#0, 
      a#72#10#0, 
      a#72#11#0, 
      a#72#12#0, 
      a#72#13#0) } 
  JournalCache.Variables.replayJournal(#JournalCache.Variables.Ready(a#72#0#0, 
        a#72#1#0, 
        a#72#2#0, 
        a#72#3#0, 
        a#72#4#0, 
        a#72#5#0, 
        a#72#6#0, 
        a#72#7#0, 
        a#72#8#0, 
        a#72#9#0, 
        a#72#10#0, 
        a#72#11#0, 
        a#72#12#0, 
        a#72#13#0))
     == a#72#8#0);

// Inductive seq element rank
axiom (forall a#73#0#0: DatatypeType, 
    a#73#1#0: bool, 
    a#73#2#0: int, 
    a#73#3#0: DatatypeType, 
    a#73#4#0: Seq Box, 
    a#73#5#0: Seq Box, 
    a#73#6#0: Set Box, 
    a#73#7#0: int, 
    a#73#8#0: Seq Box, 
    a#73#9#0: DatatypeType, 
    a#73#10#0: int, 
    a#73#11#0: DatatypeType, 
    a#73#12#0: DatatypeType, 
    a#73#13#0: Map Box Box, 
    i: int :: 
  { Seq#Index(a#73#8#0, i), #JournalCache.Variables.Ready(a#73#0#0, 
      a#73#1#0, 
      a#73#2#0, 
      a#73#3#0, 
      a#73#4#0, 
      a#73#5#0, 
      a#73#6#0, 
      a#73#7#0, 
      a#73#8#0, 
      a#73#9#0, 
      a#73#10#0, 
      a#73#11#0, 
      a#73#12#0, 
      a#73#13#0) } 
  0 <= i && i < Seq#Length(a#73#8#0)
     ==> DtRank($Unbox(Seq#Index(a#73#8#0, i)): DatatypeType)
       < DtRank(#JournalCache.Variables.Ready(a#73#0#0, 
          a#73#1#0, 
          a#73#2#0, 
          a#73#3#0, 
          a#73#4#0, 
          a#73#5#0, 
          a#73#6#0, 
          a#73#7#0, 
          a#73#8#0, 
          a#73#9#0, 
          a#73#10#0, 
          a#73#11#0, 
          a#73#12#0, 
          a#73#13#0)));

// Inductive seq rank
axiom (forall a#74#0#0: DatatypeType, 
    a#74#1#0: bool, 
    a#74#2#0: int, 
    a#74#3#0: DatatypeType, 
    a#74#4#0: Seq Box, 
    a#74#5#0: Seq Box, 
    a#74#6#0: Set Box, 
    a#74#7#0: int, 
    a#74#8#0: Seq Box, 
    a#74#9#0: DatatypeType, 
    a#74#10#0: int, 
    a#74#11#0: DatatypeType, 
    a#74#12#0: DatatypeType, 
    a#74#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#74#0#0, 
      a#74#1#0, 
      a#74#2#0, 
      a#74#3#0, 
      a#74#4#0, 
      a#74#5#0, 
      a#74#6#0, 
      a#74#7#0, 
      a#74#8#0, 
      a#74#9#0, 
      a#74#10#0, 
      a#74#11#0, 
      a#74#12#0, 
      a#74#13#0) } 
  Seq#Rank(a#74#8#0)
     < DtRank(#JournalCache.Variables.Ready(a#74#0#0, 
        a#74#1#0, 
        a#74#2#0, 
        a#74#3#0, 
        a#74#4#0, 
        a#74#5#0, 
        a#74#6#0, 
        a#74#7#0, 
        a#74#8#0, 
        a#74#9#0, 
        a#74#10#0, 
        a#74#11#0, 
        a#74#12#0, 
        a#74#13#0)));

function JournalCache.Variables.superblock(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#75#0#0: DatatypeType, 
    a#75#1#0: bool, 
    a#75#2#0: int, 
    a#75#3#0: DatatypeType, 
    a#75#4#0: Seq Box, 
    a#75#5#0: Seq Box, 
    a#75#6#0: Set Box, 
    a#75#7#0: int, 
    a#75#8#0: Seq Box, 
    a#75#9#0: DatatypeType, 
    a#75#10#0: int, 
    a#75#11#0: DatatypeType, 
    a#75#12#0: DatatypeType, 
    a#75#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#75#0#0, 
      a#75#1#0, 
      a#75#2#0, 
      a#75#3#0, 
      a#75#4#0, 
      a#75#5#0, 
      a#75#6#0, 
      a#75#7#0, 
      a#75#8#0, 
      a#75#9#0, 
      a#75#10#0, 
      a#75#11#0, 
      a#75#12#0, 
      a#75#13#0) } 
  JournalCache.Variables.superblock(#JournalCache.Variables.Ready(a#75#0#0, 
        a#75#1#0, 
        a#75#2#0, 
        a#75#3#0, 
        a#75#4#0, 
        a#75#5#0, 
        a#75#6#0, 
        a#75#7#0, 
        a#75#8#0, 
        a#75#9#0, 
        a#75#10#0, 
        a#75#11#0, 
        a#75#12#0, 
        a#75#13#0))
     == a#75#9#0);

// Inductive rank
axiom (forall a#76#0#0: DatatypeType, 
    a#76#1#0: bool, 
    a#76#2#0: int, 
    a#76#3#0: DatatypeType, 
    a#76#4#0: Seq Box, 
    a#76#5#0: Seq Box, 
    a#76#6#0: Set Box, 
    a#76#7#0: int, 
    a#76#8#0: Seq Box, 
    a#76#9#0: DatatypeType, 
    a#76#10#0: int, 
    a#76#11#0: DatatypeType, 
    a#76#12#0: DatatypeType, 
    a#76#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#76#0#0, 
      a#76#1#0, 
      a#76#2#0, 
      a#76#3#0, 
      a#76#4#0, 
      a#76#5#0, 
      a#76#6#0, 
      a#76#7#0, 
      a#76#8#0, 
      a#76#9#0, 
      a#76#10#0, 
      a#76#11#0, 
      a#76#12#0, 
      a#76#13#0) } 
  DtRank(a#76#9#0)
     < DtRank(#JournalCache.Variables.Ready(a#76#0#0, 
        a#76#1#0, 
        a#76#2#0, 
        a#76#3#0, 
        a#76#4#0, 
        a#76#5#0, 
        a#76#6#0, 
        a#76#7#0, 
        a#76#8#0, 
        a#76#9#0, 
        a#76#10#0, 
        a#76#11#0, 
        a#76#12#0, 
        a#76#13#0)));

function JournalCache.Variables.whichSuperblock(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#77#0#0: DatatypeType, 
    a#77#1#0: bool, 
    a#77#2#0: int, 
    a#77#3#0: DatatypeType, 
    a#77#4#0: Seq Box, 
    a#77#5#0: Seq Box, 
    a#77#6#0: Set Box, 
    a#77#7#0: int, 
    a#77#8#0: Seq Box, 
    a#77#9#0: DatatypeType, 
    a#77#10#0: int, 
    a#77#11#0: DatatypeType, 
    a#77#12#0: DatatypeType, 
    a#77#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#77#0#0, 
      a#77#1#0, 
      a#77#2#0, 
      a#77#3#0, 
      a#77#4#0, 
      a#77#5#0, 
      a#77#6#0, 
      a#77#7#0, 
      a#77#8#0, 
      a#77#9#0, 
      a#77#10#0, 
      a#77#11#0, 
      a#77#12#0, 
      a#77#13#0) } 
  JournalCache.Variables.whichSuperblock(#JournalCache.Variables.Ready(a#77#0#0, 
        a#77#1#0, 
        a#77#2#0, 
        a#77#3#0, 
        a#77#4#0, 
        a#77#5#0, 
        a#77#6#0, 
        a#77#7#0, 
        a#77#8#0, 
        a#77#9#0, 
        a#77#10#0, 
        a#77#11#0, 
        a#77#12#0, 
        a#77#13#0))
     == a#77#10#0);

function JournalCache.Variables.commitStatus(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#78#0#0: DatatypeType, 
    a#78#1#0: bool, 
    a#78#2#0: int, 
    a#78#3#0: DatatypeType, 
    a#78#4#0: Seq Box, 
    a#78#5#0: Seq Box, 
    a#78#6#0: Set Box, 
    a#78#7#0: int, 
    a#78#8#0: Seq Box, 
    a#78#9#0: DatatypeType, 
    a#78#10#0: int, 
    a#78#11#0: DatatypeType, 
    a#78#12#0: DatatypeType, 
    a#78#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#78#0#0, 
      a#78#1#0, 
      a#78#2#0, 
      a#78#3#0, 
      a#78#4#0, 
      a#78#5#0, 
      a#78#6#0, 
      a#78#7#0, 
      a#78#8#0, 
      a#78#9#0, 
      a#78#10#0, 
      a#78#11#0, 
      a#78#12#0, 
      a#78#13#0) } 
  JournalCache.Variables.commitStatus(#JournalCache.Variables.Ready(a#78#0#0, 
        a#78#1#0, 
        a#78#2#0, 
        a#78#3#0, 
        a#78#4#0, 
        a#78#5#0, 
        a#78#6#0, 
        a#78#7#0, 
        a#78#8#0, 
        a#78#9#0, 
        a#78#10#0, 
        a#78#11#0, 
        a#78#12#0, 
        a#78#13#0))
     == a#78#11#0);

// Inductive rank
axiom (forall a#79#0#0: DatatypeType, 
    a#79#1#0: bool, 
    a#79#2#0: int, 
    a#79#3#0: DatatypeType, 
    a#79#4#0: Seq Box, 
    a#79#5#0: Seq Box, 
    a#79#6#0: Set Box, 
    a#79#7#0: int, 
    a#79#8#0: Seq Box, 
    a#79#9#0: DatatypeType, 
    a#79#10#0: int, 
    a#79#11#0: DatatypeType, 
    a#79#12#0: DatatypeType, 
    a#79#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#79#0#0, 
      a#79#1#0, 
      a#79#2#0, 
      a#79#3#0, 
      a#79#4#0, 
      a#79#5#0, 
      a#79#6#0, 
      a#79#7#0, 
      a#79#8#0, 
      a#79#9#0, 
      a#79#10#0, 
      a#79#11#0, 
      a#79#12#0, 
      a#79#13#0) } 
  DtRank(a#79#11#0)
     < DtRank(#JournalCache.Variables.Ready(a#79#0#0, 
        a#79#1#0, 
        a#79#2#0, 
        a#79#3#0, 
        a#79#4#0, 
        a#79#5#0, 
        a#79#6#0, 
        a#79#7#0, 
        a#79#8#0, 
        a#79#9#0, 
        a#79#10#0, 
        a#79#11#0, 
        a#79#12#0, 
        a#79#13#0)));

function JournalCache.Variables.newSuperblock(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#80#0#0: DatatypeType, 
    a#80#1#0: bool, 
    a#80#2#0: int, 
    a#80#3#0: DatatypeType, 
    a#80#4#0: Seq Box, 
    a#80#5#0: Seq Box, 
    a#80#6#0: Set Box, 
    a#80#7#0: int, 
    a#80#8#0: Seq Box, 
    a#80#9#0: DatatypeType, 
    a#80#10#0: int, 
    a#80#11#0: DatatypeType, 
    a#80#12#0: DatatypeType, 
    a#80#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#80#0#0, 
      a#80#1#0, 
      a#80#2#0, 
      a#80#3#0, 
      a#80#4#0, 
      a#80#5#0, 
      a#80#6#0, 
      a#80#7#0, 
      a#80#8#0, 
      a#80#9#0, 
      a#80#10#0, 
      a#80#11#0, 
      a#80#12#0, 
      a#80#13#0) } 
  JournalCache.Variables.newSuperblock(#JournalCache.Variables.Ready(a#80#0#0, 
        a#80#1#0, 
        a#80#2#0, 
        a#80#3#0, 
        a#80#4#0, 
        a#80#5#0, 
        a#80#6#0, 
        a#80#7#0, 
        a#80#8#0, 
        a#80#9#0, 
        a#80#10#0, 
        a#80#11#0, 
        a#80#12#0, 
        a#80#13#0))
     == a#80#12#0);

// Inductive rank
axiom (forall a#81#0#0: DatatypeType, 
    a#81#1#0: bool, 
    a#81#2#0: int, 
    a#81#3#0: DatatypeType, 
    a#81#4#0: Seq Box, 
    a#81#5#0: Seq Box, 
    a#81#6#0: Set Box, 
    a#81#7#0: int, 
    a#81#8#0: Seq Box, 
    a#81#9#0: DatatypeType, 
    a#81#10#0: int, 
    a#81#11#0: DatatypeType, 
    a#81#12#0: DatatypeType, 
    a#81#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#81#0#0, 
      a#81#1#0, 
      a#81#2#0, 
      a#81#3#0, 
      a#81#4#0, 
      a#81#5#0, 
      a#81#6#0, 
      a#81#7#0, 
      a#81#8#0, 
      a#81#9#0, 
      a#81#10#0, 
      a#81#11#0, 
      a#81#12#0, 
      a#81#13#0) } 
  DtRank(a#81#12#0)
     < DtRank(#JournalCache.Variables.Ready(a#81#0#0, 
        a#81#1#0, 
        a#81#2#0, 
        a#81#3#0, 
        a#81#4#0, 
        a#81#5#0, 
        a#81#6#0, 
        a#81#7#0, 
        a#81#8#0, 
        a#81#9#0, 
        a#81#10#0, 
        a#81#11#0, 
        a#81#12#0, 
        a#81#13#0)));

function JournalCache.Variables.syncReqs(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#82#0#0: DatatypeType, 
    a#82#1#0: bool, 
    a#82#2#0: int, 
    a#82#3#0: DatatypeType, 
    a#82#4#0: Seq Box, 
    a#82#5#0: Seq Box, 
    a#82#6#0: Set Box, 
    a#82#7#0: int, 
    a#82#8#0: Seq Box, 
    a#82#9#0: DatatypeType, 
    a#82#10#0: int, 
    a#82#11#0: DatatypeType, 
    a#82#12#0: DatatypeType, 
    a#82#13#0: Map Box Box :: 
  { #JournalCache.Variables.Ready(a#82#0#0, 
      a#82#1#0, 
      a#82#2#0, 
      a#82#3#0, 
      a#82#4#0, 
      a#82#5#0, 
      a#82#6#0, 
      a#82#7#0, 
      a#82#8#0, 
      a#82#9#0, 
      a#82#10#0, 
      a#82#11#0, 
      a#82#12#0, 
      a#82#13#0) } 
  JournalCache.Variables.syncReqs(#JournalCache.Variables.Ready(a#82#0#0, 
        a#82#1#0, 
        a#82#2#0, 
        a#82#3#0, 
        a#82#4#0, 
        a#82#5#0, 
        a#82#6#0, 
        a#82#7#0, 
        a#82#8#0, 
        a#82#9#0, 
        a#82#10#0, 
        a#82#11#0, 
        a#82#12#0, 
        a#82#13#0))
     == a#82#13#0);

// Inductive map key rank
axiom (forall a#83#0#0: DatatypeType, 
    a#83#1#0: bool, 
    a#83#2#0: int, 
    a#83#3#0: DatatypeType, 
    a#83#4#0: Seq Box, 
    a#83#5#0: Seq Box, 
    a#83#6#0: Set Box, 
    a#83#7#0: int, 
    a#83#8#0: Seq Box, 
    a#83#9#0: DatatypeType, 
    a#83#10#0: int, 
    a#83#11#0: DatatypeType, 
    a#83#12#0: DatatypeType, 
    a#83#13#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#83#13#0)[$Box(d)], #JournalCache.Variables.Ready(a#83#0#0, 
      a#83#1#0, 
      a#83#2#0, 
      a#83#3#0, 
      a#83#4#0, 
      a#83#5#0, 
      a#83#6#0, 
      a#83#7#0, 
      a#83#8#0, 
      a#83#9#0, 
      a#83#10#0, 
      a#83#11#0, 
      a#83#12#0, 
      a#83#13#0) } 
  Map#Domain(a#83#13#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalCache.Variables.Ready(a#83#0#0, 
          a#83#1#0, 
          a#83#2#0, 
          a#83#3#0, 
          a#83#4#0, 
          a#83#5#0, 
          a#83#6#0, 
          a#83#7#0, 
          a#83#8#0, 
          a#83#9#0, 
          a#83#10#0, 
          a#83#11#0, 
          a#83#12#0, 
          a#83#13#0)));

// Inductive map value rank
axiom (forall a#84#0#0: DatatypeType, 
    a#84#1#0: bool, 
    a#84#2#0: int, 
    a#84#3#0: DatatypeType, 
    a#84#4#0: Seq Box, 
    a#84#5#0: Seq Box, 
    a#84#6#0: Set Box, 
    a#84#7#0: int, 
    a#84#8#0: Seq Box, 
    a#84#9#0: DatatypeType, 
    a#84#10#0: int, 
    a#84#11#0: DatatypeType, 
    a#84#12#0: DatatypeType, 
    a#84#13#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#84#13#0)[bx], #JournalCache.Variables.Ready(a#84#0#0, 
      a#84#1#0, 
      a#84#2#0, 
      a#84#3#0, 
      a#84#4#0, 
      a#84#5#0, 
      a#84#6#0, 
      a#84#7#0, 
      a#84#8#0, 
      a#84#9#0, 
      a#84#10#0, 
      a#84#11#0, 
      a#84#12#0, 
      a#84#13#0) } 
  Map#Domain(a#84#13#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#84#13#0)[bx]): DatatypeType)
       < DtRank(#JournalCache.Variables.Ready(a#84#0#0, 
          a#84#1#0, 
          a#84#2#0, 
          a#84#3#0, 
          a#84#4#0, 
          a#84#5#0, 
          a#84#6#0, 
          a#84#7#0, 
          a#84#8#0, 
          a#84#9#0, 
          a#84#10#0, 
          a#84#11#0, 
          a#84#12#0, 
          a#84#13#0)));

// Constructor function declaration
function #JournalCache.Variables.LoadingOther(DatatypeType, 
    int, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    Map Box Box)
   : DatatypeType;

const unique ##JournalCache.Variables.LoadingOther: DtCtorId;

// Constructor identifier
axiom (forall a#85#0#0: DatatypeType, 
    a#85#1#0: int, 
    a#85#2#0: DatatypeType, 
    a#85#3#0: DatatypeType, 
    a#85#4#0: DatatypeType, 
    a#85#5#0: DatatypeType, 
    a#85#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0, a#85#4#0, a#85#5#0, a#85#6#0) } 
  DatatypeCtorId(#JournalCache.Variables.LoadingOther(a#85#0#0, a#85#1#0, a#85#2#0, a#85#3#0, a#85#4#0, a#85#5#0, a#85#6#0))
     == ##JournalCache.Variables.LoadingOther);

function JournalCache.Variables.LoadingOther_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.LoadingOther_q(d) } 
  JournalCache.Variables.LoadingOther_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Variables.LoadingOther);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.LoadingOther_q(d) } 
  JournalCache.Variables.LoadingOther_q(d)
     ==> (exists a#86#0#0: DatatypeType, 
        a#86#1#0: int, 
        a#86#2#0: DatatypeType, 
        a#86#3#0: DatatypeType, 
        a#86#4#0: DatatypeType, 
        a#86#5#0: DatatypeType, 
        a#86#6#0: Map Box Box :: 
      d
         == #JournalCache.Variables.LoadingOther(a#86#0#0, a#86#1#0, a#86#2#0, a#86#3#0, a#86#4#0, a#86#5#0, a#86#6#0)));

// Constructor $Is
axiom (forall a#87#0#0: DatatypeType, 
    a#87#1#0: int, 
    a#87#2#0: DatatypeType, 
    a#87#3#0: DatatypeType, 
    a#87#4#0: DatatypeType, 
    a#87#5#0: DatatypeType, 
    a#87#6#0: Map Box Box :: 
  { $Is(#JournalCache.Variables.LoadingOther(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0, a#87#4#0, a#87#5#0, a#87#6#0), 
      Tclass.JournalCache.Variables()) } 
  $Is(#JournalCache.Variables.LoadingOther(a#87#0#0, a#87#1#0, a#87#2#0, a#87#3#0, a#87#4#0, a#87#5#0, a#87#6#0), 
      Tclass.JournalCache.Variables())
     <==> $Is(a#87#0#0, Tclass.SectorType.Superblock())
       && $Is(a#87#1#0, TInt)
       && $Is(a#87#2#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#87#3#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#87#4#0, Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())))
       && $Is(a#87#5#0, Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())))
       && $Is(a#87#6#0, TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// Constructor $IsAlloc
axiom (forall a#88#0#0: DatatypeType, 
    a#88#1#0: int, 
    a#88#2#0: DatatypeType, 
    a#88#3#0: DatatypeType, 
    a#88#4#0: DatatypeType, 
    a#88#5#0: DatatypeType, 
    a#88#6#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#JournalCache.Variables.LoadingOther(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0, a#88#5#0, a#88#6#0), 
      Tclass.JournalCache.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Variables.LoadingOther(a#88#0#0, a#88#1#0, a#88#2#0, a#88#3#0, a#88#4#0, a#88#5#0, a#88#6#0), 
        Tclass.JournalCache.Variables(), 
        $h)
       <==> $IsAlloc(a#88#0#0, Tclass.SectorType.Superblock(), $h)
         && $IsAlloc(a#88#1#0, TInt, $h)
         && $IsAlloc(a#88#2#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#88#3#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#88#4#0, Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), $h)
         && $IsAlloc(a#88#5#0, Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), $h)
         && $IsAlloc(a#88#6#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
          $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.superblock(d), Tclass.SectorType.Superblock(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.superblock(d), Tclass.SectorType.Superblock(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.whichSuperblock(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.whichSuperblock(d), TInt, $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.journalFrontRead(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.journalFrontRead(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.journalBackRead(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.journalBackRead(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.journalFront(d), 
      Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.journalFront(d), 
      Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.journalBack(d), 
      Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.journalBack(d), 
      Tclass.Options.Option(TSeq(Tclass.JournalRanges.JournalBlock())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.syncReqs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingOther_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.syncReqs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
      $h));

// Constructor literal
axiom (forall a#89#0#0: DatatypeType, 
    a#89#1#0: int, 
    a#89#2#0: DatatypeType, 
    a#89#3#0: DatatypeType, 
    a#89#4#0: DatatypeType, 
    a#89#5#0: DatatypeType, 
    a#89#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(Lit(a#89#0#0), 
      LitInt(a#89#1#0), 
      Lit(a#89#2#0), 
      Lit(a#89#3#0), 
      Lit(a#89#4#0), 
      Lit(a#89#5#0), 
      Lit(a#89#6#0)) } 
  #JournalCache.Variables.LoadingOther(Lit(a#89#0#0), 
      LitInt(a#89#1#0), 
      Lit(a#89#2#0), 
      Lit(a#89#3#0), 
      Lit(a#89#4#0), 
      Lit(a#89#5#0), 
      Lit(a#89#6#0))
     == Lit(#JournalCache.Variables.LoadingOther(a#89#0#0, a#89#1#0, a#89#2#0, a#89#3#0, a#89#4#0, a#89#5#0, a#89#6#0)));

// Constructor injectivity
axiom (forall a#90#0#0: DatatypeType, 
    a#90#1#0: int, 
    a#90#2#0: DatatypeType, 
    a#90#3#0: DatatypeType, 
    a#90#4#0: DatatypeType, 
    a#90#5#0: DatatypeType, 
    a#90#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0, a#90#5#0, a#90#6#0) } 
  JournalCache.Variables.superblock(#JournalCache.Variables.LoadingOther(a#90#0#0, a#90#1#0, a#90#2#0, a#90#3#0, a#90#4#0, a#90#5#0, a#90#6#0))
     == a#90#0#0);

// Inductive rank
axiom (forall a#91#0#0: DatatypeType, 
    a#91#1#0: int, 
    a#91#2#0: DatatypeType, 
    a#91#3#0: DatatypeType, 
    a#91#4#0: DatatypeType, 
    a#91#5#0: DatatypeType, 
    a#91#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0, a#91#5#0, a#91#6#0) } 
  DtRank(a#91#0#0)
     < DtRank(#JournalCache.Variables.LoadingOther(a#91#0#0, a#91#1#0, a#91#2#0, a#91#3#0, a#91#4#0, a#91#5#0, a#91#6#0)));

// Constructor injectivity
axiom (forall a#92#0#0: DatatypeType, 
    a#92#1#0: int, 
    a#92#2#0: DatatypeType, 
    a#92#3#0: DatatypeType, 
    a#92#4#0: DatatypeType, 
    a#92#5#0: DatatypeType, 
    a#92#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0, a#92#5#0, a#92#6#0) } 
  JournalCache.Variables.whichSuperblock(#JournalCache.Variables.LoadingOther(a#92#0#0, a#92#1#0, a#92#2#0, a#92#3#0, a#92#4#0, a#92#5#0, a#92#6#0))
     == a#92#1#0);

function JournalCache.Variables.journalFrontRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#93#0#0: DatatypeType, 
    a#93#1#0: int, 
    a#93#2#0: DatatypeType, 
    a#93#3#0: DatatypeType, 
    a#93#4#0: DatatypeType, 
    a#93#5#0: DatatypeType, 
    a#93#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0, a#93#5#0, a#93#6#0) } 
  JournalCache.Variables.journalFrontRead(#JournalCache.Variables.LoadingOther(a#93#0#0, a#93#1#0, a#93#2#0, a#93#3#0, a#93#4#0, a#93#5#0, a#93#6#0))
     == a#93#2#0);

// Inductive rank
axiom (forall a#94#0#0: DatatypeType, 
    a#94#1#0: int, 
    a#94#2#0: DatatypeType, 
    a#94#3#0: DatatypeType, 
    a#94#4#0: DatatypeType, 
    a#94#5#0: DatatypeType, 
    a#94#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0, a#94#5#0, a#94#6#0) } 
  DtRank(a#94#2#0)
     < DtRank(#JournalCache.Variables.LoadingOther(a#94#0#0, a#94#1#0, a#94#2#0, a#94#3#0, a#94#4#0, a#94#5#0, a#94#6#0)));

function JournalCache.Variables.journalBackRead(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#95#0#0: DatatypeType, 
    a#95#1#0: int, 
    a#95#2#0: DatatypeType, 
    a#95#3#0: DatatypeType, 
    a#95#4#0: DatatypeType, 
    a#95#5#0: DatatypeType, 
    a#95#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0, a#95#5#0, a#95#6#0) } 
  JournalCache.Variables.journalBackRead(#JournalCache.Variables.LoadingOther(a#95#0#0, a#95#1#0, a#95#2#0, a#95#3#0, a#95#4#0, a#95#5#0, a#95#6#0))
     == a#95#3#0);

// Inductive rank
axiom (forall a#96#0#0: DatatypeType, 
    a#96#1#0: int, 
    a#96#2#0: DatatypeType, 
    a#96#3#0: DatatypeType, 
    a#96#4#0: DatatypeType, 
    a#96#5#0: DatatypeType, 
    a#96#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0, a#96#5#0, a#96#6#0) } 
  DtRank(a#96#3#0)
     < DtRank(#JournalCache.Variables.LoadingOther(a#96#0#0, a#96#1#0, a#96#2#0, a#96#3#0, a#96#4#0, a#96#5#0, a#96#6#0)));

function JournalCache.Variables.journalFront(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#97#0#0: DatatypeType, 
    a#97#1#0: int, 
    a#97#2#0: DatatypeType, 
    a#97#3#0: DatatypeType, 
    a#97#4#0: DatatypeType, 
    a#97#5#0: DatatypeType, 
    a#97#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0, a#97#5#0, a#97#6#0) } 
  JournalCache.Variables.journalFront(#JournalCache.Variables.LoadingOther(a#97#0#0, a#97#1#0, a#97#2#0, a#97#3#0, a#97#4#0, a#97#5#0, a#97#6#0))
     == a#97#4#0);

// Inductive rank
axiom (forall a#98#0#0: DatatypeType, 
    a#98#1#0: int, 
    a#98#2#0: DatatypeType, 
    a#98#3#0: DatatypeType, 
    a#98#4#0: DatatypeType, 
    a#98#5#0: DatatypeType, 
    a#98#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0, a#98#5#0, a#98#6#0) } 
  DtRank(a#98#4#0)
     < DtRank(#JournalCache.Variables.LoadingOther(a#98#0#0, a#98#1#0, a#98#2#0, a#98#3#0, a#98#4#0, a#98#5#0, a#98#6#0)));

function JournalCache.Variables.journalBack(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#99#0#0: DatatypeType, 
    a#99#1#0: int, 
    a#99#2#0: DatatypeType, 
    a#99#3#0: DatatypeType, 
    a#99#4#0: DatatypeType, 
    a#99#5#0: DatatypeType, 
    a#99#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0, a#99#5#0, a#99#6#0) } 
  JournalCache.Variables.journalBack(#JournalCache.Variables.LoadingOther(a#99#0#0, a#99#1#0, a#99#2#0, a#99#3#0, a#99#4#0, a#99#5#0, a#99#6#0))
     == a#99#5#0);

// Inductive rank
axiom (forall a#100#0#0: DatatypeType, 
    a#100#1#0: int, 
    a#100#2#0: DatatypeType, 
    a#100#3#0: DatatypeType, 
    a#100#4#0: DatatypeType, 
    a#100#5#0: DatatypeType, 
    a#100#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0, a#100#5#0, a#100#6#0) } 
  DtRank(a#100#5#0)
     < DtRank(#JournalCache.Variables.LoadingOther(a#100#0#0, a#100#1#0, a#100#2#0, a#100#3#0, a#100#4#0, a#100#5#0, a#100#6#0)));

// Constructor injectivity
axiom (forall a#101#0#0: DatatypeType, 
    a#101#1#0: int, 
    a#101#2#0: DatatypeType, 
    a#101#3#0: DatatypeType, 
    a#101#4#0: DatatypeType, 
    a#101#5#0: DatatypeType, 
    a#101#6#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingOther(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0, a#101#5#0, a#101#6#0) } 
  JournalCache.Variables.syncReqs(#JournalCache.Variables.LoadingOther(a#101#0#0, a#101#1#0, a#101#2#0, a#101#3#0, a#101#4#0, a#101#5#0, a#101#6#0))
     == a#101#6#0);

// Inductive map key rank
axiom (forall a#102#0#0: DatatypeType, 
    a#102#1#0: int, 
    a#102#2#0: DatatypeType, 
    a#102#3#0: DatatypeType, 
    a#102#4#0: DatatypeType, 
    a#102#5#0: DatatypeType, 
    a#102#6#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#102#6#0)[$Box(d)], #JournalCache.Variables.LoadingOther(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0, a#102#5#0, a#102#6#0) } 
  Map#Domain(a#102#6#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalCache.Variables.LoadingOther(a#102#0#0, a#102#1#0, a#102#2#0, a#102#3#0, a#102#4#0, a#102#5#0, a#102#6#0)));

// Inductive map value rank
axiom (forall a#103#0#0: DatatypeType, 
    a#103#1#0: int, 
    a#103#2#0: DatatypeType, 
    a#103#3#0: DatatypeType, 
    a#103#4#0: DatatypeType, 
    a#103#5#0: DatatypeType, 
    a#103#6#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#103#6#0)[bx], #JournalCache.Variables.LoadingOther(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0, a#103#5#0, a#103#6#0) } 
  Map#Domain(a#103#6#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#103#6#0)[bx]): DatatypeType)
       < DtRank(#JournalCache.Variables.LoadingOther(a#103#0#0, a#103#1#0, a#103#2#0, a#103#3#0, a#103#4#0, a#103#5#0, a#103#6#0)));

// Constructor function declaration
function #JournalCache.Variables.LoadingSuperblock(DatatypeType, DatatypeType, DatatypeType, DatatypeType, Map Box Box)
   : DatatypeType;

const unique ##JournalCache.Variables.LoadingSuperblock: DtCtorId;

// Constructor identifier
axiom (forall a#104#0#0: DatatypeType, 
    a#104#1#0: DatatypeType, 
    a#104#2#0: DatatypeType, 
    a#104#3#0: DatatypeType, 
    a#104#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0) } 
  DatatypeCtorId(#JournalCache.Variables.LoadingSuperblock(a#104#0#0, a#104#1#0, a#104#2#0, a#104#3#0, a#104#4#0))
     == ##JournalCache.Variables.LoadingSuperblock);

function JournalCache.Variables.LoadingSuperblock_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.LoadingSuperblock_q(d) } 
  JournalCache.Variables.LoadingSuperblock_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Variables.LoadingSuperblock);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.LoadingSuperblock_q(d) } 
  JournalCache.Variables.LoadingSuperblock_q(d)
     ==> (exists a#105#0#0: DatatypeType, 
        a#105#1#0: DatatypeType, 
        a#105#2#0: DatatypeType, 
        a#105#3#0: DatatypeType, 
        a#105#4#0: Map Box Box :: 
      d
         == #JournalCache.Variables.LoadingSuperblock(a#105#0#0, a#105#1#0, a#105#2#0, a#105#3#0, a#105#4#0)));

// Constructor $Is
axiom (forall a#106#0#0: DatatypeType, 
    a#106#1#0: DatatypeType, 
    a#106#2#0: DatatypeType, 
    a#106#3#0: DatatypeType, 
    a#106#4#0: Map Box Box :: 
  { $Is(#JournalCache.Variables.LoadingSuperblock(a#106#0#0, a#106#1#0, a#106#2#0, a#106#3#0, a#106#4#0), 
      Tclass.JournalCache.Variables()) } 
  $Is(#JournalCache.Variables.LoadingSuperblock(a#106#0#0, a#106#1#0, a#106#2#0, a#106#3#0, a#106#4#0), 
      Tclass.JournalCache.Variables())
     <==> $Is(a#106#0#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#106#1#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
       && $Is(a#106#2#0, Tclass.JournalCache.SuperblockReadResult())
       && $Is(a#106#3#0, Tclass.JournalCache.SuperblockReadResult())
       && $Is(a#106#4#0, 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// Constructor $IsAlloc
axiom (forall a#107#0#0: DatatypeType, 
    a#107#1#0: DatatypeType, 
    a#107#2#0: DatatypeType, 
    a#107#3#0: DatatypeType, 
    a#107#4#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#JournalCache.Variables.LoadingSuperblock(a#107#0#0, a#107#1#0, a#107#2#0, a#107#3#0, a#107#4#0), 
      Tclass.JournalCache.Variables(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Variables.LoadingSuperblock(a#107#0#0, a#107#1#0, a#107#2#0, a#107#3#0, a#107#4#0), 
        Tclass.JournalCache.Variables(), 
        $h)
       <==> $IsAlloc(a#107#0#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#107#1#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#107#2#0, Tclass.JournalCache.SuperblockReadResult(), $h)
         && $IsAlloc(a#107#3#0, Tclass.JournalCache.SuperblockReadResult(), $h)
         && $IsAlloc(a#107#4#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
          $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.outstandingSuperblock1Read(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingSuperblock_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.outstandingSuperblock1Read(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.outstandingSuperblock2Read(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingSuperblock_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.outstandingSuperblock2Read(d), 
      Tclass.Options.Option(Tclass.NativeTypes.uint64()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.superblock1(d), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingSuperblock_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.superblock1(d), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.superblock2(d), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingSuperblock_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.superblock2(d), 
      Tclass.JournalCache.SuperblockReadResult(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Variables.syncReqs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Variables.LoadingSuperblock_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Variables(), $h)
     ==> $IsAlloc(JournalCache.Variables.syncReqs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()), 
      $h));

// Constructor literal
axiom (forall a#108#0#0: DatatypeType, 
    a#108#1#0: DatatypeType, 
    a#108#2#0: DatatypeType, 
    a#108#3#0: DatatypeType, 
    a#108#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(Lit(a#108#0#0), Lit(a#108#1#0), Lit(a#108#2#0), Lit(a#108#3#0), Lit(a#108#4#0)) } 
  #JournalCache.Variables.LoadingSuperblock(Lit(a#108#0#0), Lit(a#108#1#0), Lit(a#108#2#0), Lit(a#108#3#0), Lit(a#108#4#0))
     == Lit(#JournalCache.Variables.LoadingSuperblock(a#108#0#0, a#108#1#0, a#108#2#0, a#108#3#0, a#108#4#0)));

function JournalCache.Variables.outstandingSuperblock1Read(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#109#0#0: DatatypeType, 
    a#109#1#0: DatatypeType, 
    a#109#2#0: DatatypeType, 
    a#109#3#0: DatatypeType, 
    a#109#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#109#0#0, a#109#1#0, a#109#2#0, a#109#3#0, a#109#4#0) } 
  JournalCache.Variables.outstandingSuperblock1Read(#JournalCache.Variables.LoadingSuperblock(a#109#0#0, a#109#1#0, a#109#2#0, a#109#3#0, a#109#4#0))
     == a#109#0#0);

// Inductive rank
axiom (forall a#110#0#0: DatatypeType, 
    a#110#1#0: DatatypeType, 
    a#110#2#0: DatatypeType, 
    a#110#3#0: DatatypeType, 
    a#110#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#110#0#0, a#110#1#0, a#110#2#0, a#110#3#0, a#110#4#0) } 
  DtRank(a#110#0#0)
     < DtRank(#JournalCache.Variables.LoadingSuperblock(a#110#0#0, a#110#1#0, a#110#2#0, a#110#3#0, a#110#4#0)));

function JournalCache.Variables.outstandingSuperblock2Read(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#111#0#0: DatatypeType, 
    a#111#1#0: DatatypeType, 
    a#111#2#0: DatatypeType, 
    a#111#3#0: DatatypeType, 
    a#111#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#111#0#0, a#111#1#0, a#111#2#0, a#111#3#0, a#111#4#0) } 
  JournalCache.Variables.outstandingSuperblock2Read(#JournalCache.Variables.LoadingSuperblock(a#111#0#0, a#111#1#0, a#111#2#0, a#111#3#0, a#111#4#0))
     == a#111#1#0);

// Inductive rank
axiom (forall a#112#0#0: DatatypeType, 
    a#112#1#0: DatatypeType, 
    a#112#2#0: DatatypeType, 
    a#112#3#0: DatatypeType, 
    a#112#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#112#0#0, a#112#1#0, a#112#2#0, a#112#3#0, a#112#4#0) } 
  DtRank(a#112#1#0)
     < DtRank(#JournalCache.Variables.LoadingSuperblock(a#112#0#0, a#112#1#0, a#112#2#0, a#112#3#0, a#112#4#0)));

function JournalCache.Variables.superblock1(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#113#0#0: DatatypeType, 
    a#113#1#0: DatatypeType, 
    a#113#2#0: DatatypeType, 
    a#113#3#0: DatatypeType, 
    a#113#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#113#0#0, a#113#1#0, a#113#2#0, a#113#3#0, a#113#4#0) } 
  JournalCache.Variables.superblock1(#JournalCache.Variables.LoadingSuperblock(a#113#0#0, a#113#1#0, a#113#2#0, a#113#3#0, a#113#4#0))
     == a#113#2#0);

// Inductive rank
axiom (forall a#114#0#0: DatatypeType, 
    a#114#1#0: DatatypeType, 
    a#114#2#0: DatatypeType, 
    a#114#3#0: DatatypeType, 
    a#114#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#114#0#0, a#114#1#0, a#114#2#0, a#114#3#0, a#114#4#0) } 
  DtRank(a#114#2#0)
     < DtRank(#JournalCache.Variables.LoadingSuperblock(a#114#0#0, a#114#1#0, a#114#2#0, a#114#3#0, a#114#4#0)));

function JournalCache.Variables.superblock2(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#115#0#0: DatatypeType, 
    a#115#1#0: DatatypeType, 
    a#115#2#0: DatatypeType, 
    a#115#3#0: DatatypeType, 
    a#115#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#115#0#0, a#115#1#0, a#115#2#0, a#115#3#0, a#115#4#0) } 
  JournalCache.Variables.superblock2(#JournalCache.Variables.LoadingSuperblock(a#115#0#0, a#115#1#0, a#115#2#0, a#115#3#0, a#115#4#0))
     == a#115#3#0);

// Inductive rank
axiom (forall a#116#0#0: DatatypeType, 
    a#116#1#0: DatatypeType, 
    a#116#2#0: DatatypeType, 
    a#116#3#0: DatatypeType, 
    a#116#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#116#0#0, a#116#1#0, a#116#2#0, a#116#3#0, a#116#4#0) } 
  DtRank(a#116#3#0)
     < DtRank(#JournalCache.Variables.LoadingSuperblock(a#116#0#0, a#116#1#0, a#116#2#0, a#116#3#0, a#116#4#0)));

// Constructor injectivity
axiom (forall a#117#0#0: DatatypeType, 
    a#117#1#0: DatatypeType, 
    a#117#2#0: DatatypeType, 
    a#117#3#0: DatatypeType, 
    a#117#4#0: Map Box Box :: 
  { #JournalCache.Variables.LoadingSuperblock(a#117#0#0, a#117#1#0, a#117#2#0, a#117#3#0, a#117#4#0) } 
  JournalCache.Variables.syncReqs(#JournalCache.Variables.LoadingSuperblock(a#117#0#0, a#117#1#0, a#117#2#0, a#117#3#0, a#117#4#0))
     == a#117#4#0);

// Inductive map key rank
axiom (forall a#118#0#0: DatatypeType, 
    a#118#1#0: DatatypeType, 
    a#118#2#0: DatatypeType, 
    a#118#3#0: DatatypeType, 
    a#118#4#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#118#4#0)[$Box(d)], #JournalCache.Variables.LoadingSuperblock(a#118#0#0, a#118#1#0, a#118#2#0, a#118#3#0, a#118#4#0) } 
  Map#Domain(a#118#4#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#JournalCache.Variables.LoadingSuperblock(a#118#0#0, a#118#1#0, a#118#2#0, a#118#3#0, a#118#4#0)));

// Inductive map value rank
axiom (forall a#119#0#0: DatatypeType, 
    a#119#1#0: DatatypeType, 
    a#119#2#0: DatatypeType, 
    a#119#3#0: DatatypeType, 
    a#119#4#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#119#4#0)[bx], #JournalCache.Variables.LoadingSuperblock(a#119#0#0, a#119#1#0, a#119#2#0, a#119#3#0, a#119#4#0) } 
  Map#Domain(a#119#4#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#119#4#0)[bx]): DatatypeType)
       < DtRank(#JournalCache.Variables.LoadingSuperblock(a#119#0#0, a#119#1#0, a#119#2#0, a#119#3#0, a#119#4#0)));

// Depth-one case-split function
function $IsA#JournalCache.Variables(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.Variables(d) } 
  $IsA#JournalCache.Variables(d)
     ==> JournalCache.Variables.Ready_q(d)
       || JournalCache.Variables.LoadingOther_q(d)
       || JournalCache.Variables.LoadingSuperblock_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.Variables.LoadingSuperblock_q(d), $Is(d, Tclass.JournalCache.Variables()) } 
    { JournalCache.Variables.LoadingOther_q(d), $Is(d, Tclass.JournalCache.Variables()) } 
    { JournalCache.Variables.Ready_q(d), $Is(d, Tclass.JournalCache.Variables()) } 
  $Is(d, Tclass.JournalCache.Variables())
     ==> JournalCache.Variables.Ready_q(d)
       || JournalCache.Variables.LoadingOther_q(d)
       || JournalCache.Variables.LoadingSuperblock_q(d));

// Datatype extensional equality declaration
function JournalCache.Variables#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.Variables.Ready
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Variables#Equal(a, b), JournalCache.Variables.Ready_q(a) } 
    { JournalCache.Variables#Equal(a, b), JournalCache.Variables.Ready_q(b) } 
  JournalCache.Variables.Ready_q(a) && JournalCache.Variables.Ready_q(b)
     ==> (JournalCache.Variables#Equal(a, b)
       <==> Options.Option#Equal(JournalCache.Variables.frozenLoc(a), JournalCache.Variables.frozenLoc(b))
         && JournalCache.Variables.isFrozen(a) == JournalCache.Variables.isFrozen(b)
         && JournalCache.Variables.frozenJournalPosition(a)
           == JournalCache.Variables.frozenJournalPosition(b)
         && Options.Option#Equal(JournalCache.Variables.superblockWrite(a), 
          JournalCache.Variables.superblockWrite(b))
         && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(a), 
          JournalCache.Variables.inMemoryJournalFrozen(b))
         && Seq#Equal(JournalCache.Variables.inMemoryJournal(a), 
          JournalCache.Variables.inMemoryJournal(b))
         && Set#Equal(JournalCache.Variables.outstandingJournalWrites(a), 
          JournalCache.Variables.outstandingJournalWrites(b))
         && JournalCache.Variables.writtenJournalLen(a)
           == JournalCache.Variables.writtenJournalLen(b)
         && Seq#Equal(JournalCache.Variables.replayJournal(a), JournalCache.Variables.replayJournal(b))
         && SectorType.Superblock#Equal(JournalCache.Variables.superblock(a), JournalCache.Variables.superblock(b))
         && JournalCache.Variables.whichSuperblock(a)
           == JournalCache.Variables.whichSuperblock(b)
         && JournalCache.CommitStatus#Equal(JournalCache.Variables.commitStatus(a), JournalCache.Variables.commitStatus(b))
         && Options.Option#Equal(JournalCache.Variables.newSuperblock(a), JournalCache.Variables.newSuperblock(b))
         && Map#Equal(JournalCache.Variables.syncReqs(a), JournalCache.Variables.syncReqs(b))));

// Datatype extensional equality definition: #JournalCache.Variables.LoadingOther
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Variables#Equal(a, b), JournalCache.Variables.LoadingOther_q(a) } 
    { JournalCache.Variables#Equal(a, b), JournalCache.Variables.LoadingOther_q(b) } 
  JournalCache.Variables.LoadingOther_q(a)
       && JournalCache.Variables.LoadingOther_q(b)
     ==> (JournalCache.Variables#Equal(a, b)
       <==> SectorType.Superblock#Equal(JournalCache.Variables.superblock(a), JournalCache.Variables.superblock(b))
         && JournalCache.Variables.whichSuperblock(a)
           == JournalCache.Variables.whichSuperblock(b)
         && Options.Option#Equal(JournalCache.Variables.journalFrontRead(a), 
          JournalCache.Variables.journalFrontRead(b))
         && Options.Option#Equal(JournalCache.Variables.journalBackRead(a), 
          JournalCache.Variables.journalBackRead(b))
         && Options.Option#Equal(JournalCache.Variables.journalFront(a), JournalCache.Variables.journalFront(b))
         && Options.Option#Equal(JournalCache.Variables.journalBack(a), JournalCache.Variables.journalBack(b))
         && Map#Equal(JournalCache.Variables.syncReqs(a), JournalCache.Variables.syncReqs(b))));

// Datatype extensional equality definition: #JournalCache.Variables.LoadingSuperblock
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Variables#Equal(a, b), JournalCache.Variables.LoadingSuperblock_q(a) } 
    { JournalCache.Variables#Equal(a, b), JournalCache.Variables.LoadingSuperblock_q(b) } 
  JournalCache.Variables.LoadingSuperblock_q(a)
       && JournalCache.Variables.LoadingSuperblock_q(b)
     ==> (JournalCache.Variables#Equal(a, b)
       <==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(a), 
          JournalCache.Variables.outstandingSuperblock1Read(b))
         && Options.Option#Equal(JournalCache.Variables.outstandingSuperblock2Read(a), 
          JournalCache.Variables.outstandingSuperblock2Read(b))
         && JournalCache.SuperblockReadResult#Equal(JournalCache.Variables.superblock1(a), JournalCache.Variables.superblock1(b))
         && JournalCache.SuperblockReadResult#Equal(JournalCache.Variables.superblock2(a), JournalCache.Variables.superblock2(b))
         && Map#Equal(JournalCache.Variables.syncReqs(a), JournalCache.Variables.syncReqs(b))));

// Datatype extensionality axiom: JournalCache.Variables
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Variables#Equal(a, b) } 
  JournalCache.Variables#Equal(a, b) <==> a == b);

const unique class.JournalCache.Variables: ClassName;

// Constructor function declaration
function #JournalCache.JournalStep.JSNew(Seq Box) : DatatypeType;

const unique ##JournalCache.JournalStep.JSNew: DtCtorId;

// Constructor identifier
axiom (forall a#120#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSNew(a#120#0#0) } 
  DatatypeCtorId(#JournalCache.JournalStep.JSNew(a#120#0#0))
     == ##JournalCache.JournalStep.JSNew);

function JournalCache.JournalStep.JSNew_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.JournalStep.JSNew_q(d) } 
  JournalCache.JournalStep.JSNew_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.JournalStep.JSNew);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.JournalStep.JSNew_q(d) } 
  JournalCache.JournalStep.JSNew_q(d)
     ==> (exists a#121#0#0: Seq Box :: d == #JournalCache.JournalStep.JSNew(a#121#0#0)));

function Tclass.JournalCache.JournalStep() : Ty;

// Tclass.JournalCache.JournalStep Tag
axiom Tag(Tclass.JournalCache.JournalStep()) == Tagclass.JournalCache.JournalStep;

const unique Tagclass.JournalCache.JournalStep: TyTag;

// Box/unbox axiom for Tclass.JournalCache.JournalStep
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.JournalStep()) } 
  $IsBox(bx, Tclass.JournalCache.JournalStep())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.JournalStep()));

// Constructor $Is
axiom (forall a#122#0#0: Seq Box :: 
  { $Is(#JournalCache.JournalStep.JSNew(a#122#0#0), Tclass.JournalCache.JournalStep()) } 
  $Is(#JournalCache.JournalStep.JSNew(a#122#0#0), Tclass.JournalCache.JournalStep())
     <==> $Is(a#122#0#0, TSeq(Tclass.Journal.JournalEntry())));

// Constructor $IsAlloc
axiom (forall a#123#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#JournalCache.JournalStep.JSNew(a#123#0#0), 
      Tclass.JournalCache.JournalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.JournalStep.JSNew(a#123#0#0), 
        Tclass.JournalCache.JournalStep(), 
        $h)
       <==> $IsAlloc(a#123#0#0, TSeq(Tclass.Journal.JournalEntry()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.JournalStep.entries(d), TSeq(Tclass.Journal.JournalEntry()), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.JournalStep.JSNew_q(d)
       && $IsAlloc(d, Tclass.JournalCache.JournalStep(), $h)
     ==> $IsAlloc(JournalCache.JournalStep.entries(d), TSeq(Tclass.Journal.JournalEntry()), $h));

// Constructor literal
axiom (forall a#124#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSNew(Lit(a#124#0#0)) } 
  #JournalCache.JournalStep.JSNew(Lit(a#124#0#0))
     == Lit(#JournalCache.JournalStep.JSNew(a#124#0#0)));

function JournalCache.JournalStep.entries(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#125#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSNew(a#125#0#0) } 
  JournalCache.JournalStep.entries(#JournalCache.JournalStep.JSNew(a#125#0#0))
     == a#125#0#0);

// Inductive seq element rank
axiom (forall a#126#0#0: Seq Box, i: int :: 
  { Seq#Index(a#126#0#0, i), #JournalCache.JournalStep.JSNew(a#126#0#0) } 
  0 <= i && i < Seq#Length(a#126#0#0)
     ==> DtRank($Unbox(Seq#Index(a#126#0#0, i)): DatatypeType)
       < DtRank(#JournalCache.JournalStep.JSNew(a#126#0#0)));

// Inductive seq rank
axiom (forall a#127#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSNew(a#127#0#0) } 
  Seq#Rank(a#127#0#0) < DtRank(#JournalCache.JournalStep.JSNew(a#127#0#0)));

// Constructor function declaration
function #JournalCache.JournalStep.JSReplay(Seq Box) : DatatypeType;

const unique ##JournalCache.JournalStep.JSReplay: DtCtorId;

// Constructor identifier
axiom (forall a#128#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSReplay(a#128#0#0) } 
  DatatypeCtorId(#JournalCache.JournalStep.JSReplay(a#128#0#0))
     == ##JournalCache.JournalStep.JSReplay);

function JournalCache.JournalStep.JSReplay_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.JournalStep.JSReplay_q(d) } 
  JournalCache.JournalStep.JSReplay_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.JournalStep.JSReplay);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.JournalStep.JSReplay_q(d) } 
  JournalCache.JournalStep.JSReplay_q(d)
     ==> (exists a#129#0#0: Seq Box :: 
      d == #JournalCache.JournalStep.JSReplay(a#129#0#0)));

// Constructor $Is
axiom (forall a#130#0#0: Seq Box :: 
  { $Is(#JournalCache.JournalStep.JSReplay(a#130#0#0), Tclass.JournalCache.JournalStep()) } 
  $Is(#JournalCache.JournalStep.JSReplay(a#130#0#0), Tclass.JournalCache.JournalStep())
     <==> $Is(a#130#0#0, TSeq(Tclass.Journal.JournalEntry())));

// Constructor $IsAlloc
axiom (forall a#131#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#JournalCache.JournalStep.JSReplay(a#131#0#0), 
      Tclass.JournalCache.JournalStep(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.JournalStep.JSReplay(a#131#0#0), 
        Tclass.JournalCache.JournalStep(), 
        $h)
       <==> $IsAlloc(a#131#0#0, TSeq(Tclass.Journal.JournalEntry()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.JournalStep.entries(d), TSeq(Tclass.Journal.JournalEntry()), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.JournalStep.JSReplay_q(d)
       && $IsAlloc(d, Tclass.JournalCache.JournalStep(), $h)
     ==> $IsAlloc(JournalCache.JournalStep.entries(d), TSeq(Tclass.Journal.JournalEntry()), $h));

// Constructor literal
axiom (forall a#132#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSReplay(Lit(a#132#0#0)) } 
  #JournalCache.JournalStep.JSReplay(Lit(a#132#0#0))
     == Lit(#JournalCache.JournalStep.JSReplay(a#132#0#0)));

// Constructor injectivity
axiom (forall a#133#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSReplay(a#133#0#0) } 
  JournalCache.JournalStep.entries(#JournalCache.JournalStep.JSReplay(a#133#0#0))
     == a#133#0#0);

// Inductive seq element rank
axiom (forall a#134#0#0: Seq Box, i: int :: 
  { Seq#Index(a#134#0#0, i), #JournalCache.JournalStep.JSReplay(a#134#0#0) } 
  0 <= i && i < Seq#Length(a#134#0#0)
     ==> DtRank($Unbox(Seq#Index(a#134#0#0, i)): DatatypeType)
       < DtRank(#JournalCache.JournalStep.JSReplay(a#134#0#0)));

// Inductive seq rank
axiom (forall a#135#0#0: Seq Box :: 
  { #JournalCache.JournalStep.JSReplay(a#135#0#0) } 
  Seq#Rank(a#135#0#0) < DtRank(#JournalCache.JournalStep.JSReplay(a#135#0#0)));

// Depth-one case-split function
function $IsA#JournalCache.JournalStep(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.JournalStep(d) } 
  $IsA#JournalCache.JournalStep(d)
     ==> JournalCache.JournalStep.JSNew_q(d) || JournalCache.JournalStep.JSReplay_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.JournalStep.JSReplay_q(d), $Is(d, Tclass.JournalCache.JournalStep()) } 
    { JournalCache.JournalStep.JSNew_q(d), $Is(d, Tclass.JournalCache.JournalStep()) } 
  $Is(d, Tclass.JournalCache.JournalStep())
     ==> JournalCache.JournalStep.JSNew_q(d) || JournalCache.JournalStep.JSReplay_q(d));

// Datatype extensional equality declaration
function JournalCache.JournalStep#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.JournalStep.JSNew
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.JournalStep#Equal(a, b), JournalCache.JournalStep.JSNew_q(a) } 
    { JournalCache.JournalStep#Equal(a, b), JournalCache.JournalStep.JSNew_q(b) } 
  JournalCache.JournalStep.JSNew_q(a) && JournalCache.JournalStep.JSNew_q(b)
     ==> (JournalCache.JournalStep#Equal(a, b)
       <==> Seq#Equal(JournalCache.JournalStep.entries(a), JournalCache.JournalStep.entries(b))));

// Datatype extensional equality definition: #JournalCache.JournalStep.JSReplay
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.JournalStep#Equal(a, b), JournalCache.JournalStep.JSReplay_q(a) } 
    { JournalCache.JournalStep#Equal(a, b), JournalCache.JournalStep.JSReplay_q(b) } 
  JournalCache.JournalStep.JSReplay_q(a) && JournalCache.JournalStep.JSReplay_q(b)
     ==> (JournalCache.JournalStep#Equal(a, b)
       <==> Seq#Equal(JournalCache.JournalStep.entries(a), JournalCache.JournalStep.entries(b))));

// Datatype extensionality axiom: JournalCache.JournalStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.JournalStep#Equal(a, b) } 
  JournalCache.JournalStep#Equal(a, b) <==> a == b);

const unique class.JournalCache.JournalStep: ClassName;

// Constructor function declaration
function #JournalCache.Step.WriteBackJournalReqStep(Seq Box) : DatatypeType;

const unique ##JournalCache.Step.WriteBackJournalReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#136#0#0: Seq Box :: 
  { #JournalCache.Step.WriteBackJournalReqStep(a#136#0#0) } 
  DatatypeCtorId(#JournalCache.Step.WriteBackJournalReqStep(a#136#0#0))
     == ##JournalCache.Step.WriteBackJournalReqStep);

function JournalCache.Step.WriteBackJournalReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackJournalReqStep_q(d) } 
  JournalCache.Step.WriteBackJournalReqStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.WriteBackJournalReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackJournalReqStep_q(d) } 
  JournalCache.Step.WriteBackJournalReqStep_q(d)
     ==> (exists a#137#0#0: Seq Box :: 
      d == #JournalCache.Step.WriteBackJournalReqStep(a#137#0#0)));

function Tclass.JournalCache.Step() : Ty;

// Tclass.JournalCache.Step Tag
axiom Tag(Tclass.JournalCache.Step()) == Tagclass.JournalCache.Step;

const unique Tagclass.JournalCache.Step: TyTag;

// Box/unbox axiom for Tclass.JournalCache.Step
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.Step()) } 
  $IsBox(bx, Tclass.JournalCache.Step())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.JournalCache.Step()));

// Constructor $Is
axiom (forall a#138#0#0: Seq Box :: 
  { $Is(#JournalCache.Step.WriteBackJournalReqStep(a#138#0#0), 
      Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.WriteBackJournalReqStep(a#138#0#0), 
      Tclass.JournalCache.Step())
     <==> $Is(a#138#0#0, TSeq(Tclass.JournalRanges.JournalBlock())));

// Constructor $IsAlloc
axiom (forall a#139#0#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.WriteBackJournalReqStep(a#139#0#0), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.WriteBackJournalReqStep(a#139#0#0), 
        Tclass.JournalCache.Step(), 
        $h)
       <==> $IsAlloc(a#139#0#0, TSeq(Tclass.JournalRanges.JournalBlock()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.jr(d), TSeq(Tclass.JournalRanges.JournalBlock()), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.WriteBackJournalReqStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.jr(d), TSeq(Tclass.JournalRanges.JournalBlock()), $h));

// Constructor literal
axiom (forall a#140#0#0: Seq Box :: 
  { #JournalCache.Step.WriteBackJournalReqStep(Lit(a#140#0#0)) } 
  #JournalCache.Step.WriteBackJournalReqStep(Lit(a#140#0#0))
     == Lit(#JournalCache.Step.WriteBackJournalReqStep(a#140#0#0)));

function JournalCache.Step.jr(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#141#0#0: Seq Box :: 
  { #JournalCache.Step.WriteBackJournalReqStep(a#141#0#0) } 
  JournalCache.Step.jr(#JournalCache.Step.WriteBackJournalReqStep(a#141#0#0))
     == a#141#0#0);

// Inductive seq element rank
axiom (forall a#142#0#0: Seq Box, i: int :: 
  { Seq#Index(a#142#0#0, i), #JournalCache.Step.WriteBackJournalReqStep(a#142#0#0) } 
  0 <= i && i < Seq#Length(a#142#0#0)
     ==> DtRank($Unbox(Seq#Index(a#142#0#0, i)): DatatypeType)
       < DtRank(#JournalCache.Step.WriteBackJournalReqStep(a#142#0#0)));

// Inductive seq rank
axiom (forall a#143#0#0: Seq Box :: 
  { #JournalCache.Step.WriteBackJournalReqStep(a#143#0#0) } 
  Seq#Rank(a#143#0#0)
     < DtRank(#JournalCache.Step.WriteBackJournalReqStep(a#143#0#0)));

// Constructor function declaration
function #JournalCache.Step.WriteBackJournalRespStep() : DatatypeType;

const unique ##JournalCache.Step.WriteBackJournalRespStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.WriteBackJournalRespStep())
   == ##JournalCache.Step.WriteBackJournalRespStep;

function JournalCache.Step.WriteBackJournalRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackJournalRespStep_q(d) } 
  JournalCache.Step.WriteBackJournalRespStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.WriteBackJournalRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackJournalRespStep_q(d) } 
  JournalCache.Step.WriteBackJournalRespStep_q(d)
     ==> d == #JournalCache.Step.WriteBackJournalRespStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.WriteBackJournalRespStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.WriteBackJournalRespStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.WriteBackJournalRespStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.WriteBackJournalRespStep()
   == Lit(#JournalCache.Step.WriteBackJournalRespStep());

// Constructor function declaration
function #JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step() : DatatypeType;

const unique ##JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step())
   == ##JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step;

function JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d) } 
  JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d) } 
  JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d)
     ==> d == #JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step());

// Constructor $Is
axiom $Is(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step(), 
  Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step(), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step(), 
      Tclass.JournalCache.Step(), 
      $h));

// Constructor literal
axiom #JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step()
   == Lit(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step());

// Constructor function declaration
function #JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step() : DatatypeType;

const unique ##JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step())
   == ##JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step;

function JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d) } 
  JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d)
     <==> DatatypeCtorId(d)
       == ##JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d) } 
  JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d)
     ==> d == #JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step());

// Constructor $Is
axiom $Is(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step(), 
  Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step(), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step(), 
      Tclass.JournalCache.Step(), 
      $h));

// Constructor literal
axiom #JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step()
   == Lit(#JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step());

// Constructor function declaration
function #JournalCache.Step.WriteBackSuperblockRespStep() : DatatypeType;

const unique ##JournalCache.Step.WriteBackSuperblockRespStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.WriteBackSuperblockRespStep())
   == ##JournalCache.Step.WriteBackSuperblockRespStep;

function JournalCache.Step.WriteBackSuperblockRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackSuperblockRespStep_q(d) } 
  JournalCache.Step.WriteBackSuperblockRespStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.WriteBackSuperblockRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.WriteBackSuperblockRespStep_q(d) } 
  JournalCache.Step.WriteBackSuperblockRespStep_q(d)
     ==> d == #JournalCache.Step.WriteBackSuperblockRespStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.WriteBackSuperblockRespStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.WriteBackSuperblockRespStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.WriteBackSuperblockRespStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.WriteBackSuperblockRespStep()
   == Lit(#JournalCache.Step.WriteBackSuperblockRespStep());

// Constructor function declaration
function #JournalCache.Step.PageInJournalReqStep(int) : DatatypeType;

const unique ##JournalCache.Step.PageInJournalReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#164#0#0: int :: 
  { #JournalCache.Step.PageInJournalReqStep(a#164#0#0) } 
  DatatypeCtorId(#JournalCache.Step.PageInJournalReqStep(a#164#0#0))
     == ##JournalCache.Step.PageInJournalReqStep);

function JournalCache.Step.PageInJournalReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInJournalReqStep_q(d) } 
  JournalCache.Step.PageInJournalReqStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.PageInJournalReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInJournalReqStep_q(d) } 
  JournalCache.Step.PageInJournalReqStep_q(d)
     ==> (exists a#165#0#0: int :: 
      d == #JournalCache.Step.PageInJournalReqStep(a#165#0#0)));

// Constructor $Is
axiom (forall a#166#0#0: int :: 
  { $Is(#JournalCache.Step.PageInJournalReqStep(a#166#0#0), Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.PageInJournalReqStep(a#166#0#0), Tclass.JournalCache.Step())
     <==> $Is(a#166#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#167#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.PageInJournalReqStep(a#167#0#0), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.PageInJournalReqStep(a#167#0#0), 
        Tclass.JournalCache.Step(), 
        $h)
       <==> $IsAlloc(a#167#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.PageInJournalReqStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.which(d), TInt, $h));

// Constructor literal
axiom (forall a#168#0#0: int :: 
  { #JournalCache.Step.PageInJournalReqStep(LitInt(a#168#0#0)) } 
  #JournalCache.Step.PageInJournalReqStep(LitInt(a#168#0#0))
     == Lit(#JournalCache.Step.PageInJournalReqStep(a#168#0#0)));

function JournalCache.Step.which(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#169#0#0: int :: 
  { #JournalCache.Step.PageInJournalReqStep(a#169#0#0) } 
  JournalCache.Step.which(#JournalCache.Step.PageInJournalReqStep(a#169#0#0))
     == a#169#0#0);

// Constructor function declaration
function #JournalCache.Step.PageInJournalRespStep(int) : DatatypeType;

const unique ##JournalCache.Step.PageInJournalRespStep: DtCtorId;

// Constructor identifier
axiom (forall a#170#0#0: int :: 
  { #JournalCache.Step.PageInJournalRespStep(a#170#0#0) } 
  DatatypeCtorId(#JournalCache.Step.PageInJournalRespStep(a#170#0#0))
     == ##JournalCache.Step.PageInJournalRespStep);

function JournalCache.Step.PageInJournalRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInJournalRespStep_q(d) } 
  JournalCache.Step.PageInJournalRespStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.PageInJournalRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInJournalRespStep_q(d) } 
  JournalCache.Step.PageInJournalRespStep_q(d)
     ==> (exists a#171#0#0: int :: 
      d == #JournalCache.Step.PageInJournalRespStep(a#171#0#0)));

// Constructor $Is
axiom (forall a#172#0#0: int :: 
  { $Is(#JournalCache.Step.PageInJournalRespStep(a#172#0#0), Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.PageInJournalRespStep(a#172#0#0), Tclass.JournalCache.Step())
     <==> $Is(a#172#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#173#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.PageInJournalRespStep(a#173#0#0), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.PageInJournalRespStep(a#173#0#0), 
        Tclass.JournalCache.Step(), 
        $h)
       <==> $IsAlloc(a#173#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.PageInJournalRespStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.which(d), TInt, $h));

// Constructor literal
axiom (forall a#174#0#0: int :: 
  { #JournalCache.Step.PageInJournalRespStep(LitInt(a#174#0#0)) } 
  #JournalCache.Step.PageInJournalRespStep(LitInt(a#174#0#0))
     == Lit(#JournalCache.Step.PageInJournalRespStep(a#174#0#0)));

// Constructor injectivity
axiom (forall a#175#0#0: int :: 
  { #JournalCache.Step.PageInJournalRespStep(a#175#0#0) } 
  JournalCache.Step.which(#JournalCache.Step.PageInJournalRespStep(a#175#0#0))
     == a#175#0#0);

// Constructor function declaration
function #JournalCache.Step.PageInSuperblockReqStep(int) : DatatypeType;

const unique ##JournalCache.Step.PageInSuperblockReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#176#0#0: int :: 
  { #JournalCache.Step.PageInSuperblockReqStep(a#176#0#0) } 
  DatatypeCtorId(#JournalCache.Step.PageInSuperblockReqStep(a#176#0#0))
     == ##JournalCache.Step.PageInSuperblockReqStep);

function JournalCache.Step.PageInSuperblockReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInSuperblockReqStep_q(d) } 
  JournalCache.Step.PageInSuperblockReqStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.PageInSuperblockReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInSuperblockReqStep_q(d) } 
  JournalCache.Step.PageInSuperblockReqStep_q(d)
     ==> (exists a#177#0#0: int :: 
      d == #JournalCache.Step.PageInSuperblockReqStep(a#177#0#0)));

// Constructor $Is
axiom (forall a#178#0#0: int :: 
  { $Is(#JournalCache.Step.PageInSuperblockReqStep(a#178#0#0), 
      Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.PageInSuperblockReqStep(a#178#0#0), 
      Tclass.JournalCache.Step())
     <==> $Is(a#178#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#179#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.PageInSuperblockReqStep(a#179#0#0), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.PageInSuperblockReqStep(a#179#0#0), 
        Tclass.JournalCache.Step(), 
        $h)
       <==> $IsAlloc(a#179#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.PageInSuperblockReqStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.which(d), TInt, $h));

// Constructor literal
axiom (forall a#180#0#0: int :: 
  { #JournalCache.Step.PageInSuperblockReqStep(LitInt(a#180#0#0)) } 
  #JournalCache.Step.PageInSuperblockReqStep(LitInt(a#180#0#0))
     == Lit(#JournalCache.Step.PageInSuperblockReqStep(a#180#0#0)));

// Constructor injectivity
axiom (forall a#181#0#0: int :: 
  { #JournalCache.Step.PageInSuperblockReqStep(a#181#0#0) } 
  JournalCache.Step.which(#JournalCache.Step.PageInSuperblockReqStep(a#181#0#0))
     == a#181#0#0);

// Constructor function declaration
function #JournalCache.Step.PageInSuperblockRespStep(int) : DatatypeType;

const unique ##JournalCache.Step.PageInSuperblockRespStep: DtCtorId;

// Constructor identifier
axiom (forall a#182#0#0: int :: 
  { #JournalCache.Step.PageInSuperblockRespStep(a#182#0#0) } 
  DatatypeCtorId(#JournalCache.Step.PageInSuperblockRespStep(a#182#0#0))
     == ##JournalCache.Step.PageInSuperblockRespStep);

function JournalCache.Step.PageInSuperblockRespStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInSuperblockRespStep_q(d) } 
  JournalCache.Step.PageInSuperblockRespStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.PageInSuperblockRespStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PageInSuperblockRespStep_q(d) } 
  JournalCache.Step.PageInSuperblockRespStep_q(d)
     ==> (exists a#183#0#0: int :: 
      d == #JournalCache.Step.PageInSuperblockRespStep(a#183#0#0)));

// Constructor $Is
axiom (forall a#184#0#0: int :: 
  { $Is(#JournalCache.Step.PageInSuperblockRespStep(a#184#0#0), 
      Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.PageInSuperblockRespStep(a#184#0#0), 
      Tclass.JournalCache.Step())
     <==> $Is(a#184#0#0, TInt));

// Constructor $IsAlloc
axiom (forall a#185#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.PageInSuperblockRespStep(a#185#0#0), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.PageInSuperblockRespStep(a#185#0#0), 
        Tclass.JournalCache.Step(), 
        $h)
       <==> $IsAlloc(a#185#0#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.which(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.PageInSuperblockRespStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.which(d), TInt, $h));

// Constructor literal
axiom (forall a#186#0#0: int :: 
  { #JournalCache.Step.PageInSuperblockRespStep(LitInt(a#186#0#0)) } 
  #JournalCache.Step.PageInSuperblockRespStep(LitInt(a#186#0#0))
     == Lit(#JournalCache.Step.PageInSuperblockRespStep(a#186#0#0)));

// Constructor injectivity
axiom (forall a#187#0#0: int :: 
  { #JournalCache.Step.PageInSuperblockRespStep(a#187#0#0) } 
  JournalCache.Step.which(#JournalCache.Step.PageInSuperblockRespStep(a#187#0#0))
     == a#187#0#0);

// Constructor function declaration
function #JournalCache.Step.FinishLoadingSuperblockPhaseStep() : DatatypeType;

const unique ##JournalCache.Step.FinishLoadingSuperblockPhaseStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.FinishLoadingSuperblockPhaseStep())
   == ##JournalCache.Step.FinishLoadingSuperblockPhaseStep;

function JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d) } 
  JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.FinishLoadingSuperblockPhaseStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d) } 
  JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d)
     ==> d == #JournalCache.Step.FinishLoadingSuperblockPhaseStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.FinishLoadingSuperblockPhaseStep(), 
  Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.FinishLoadingSuperblockPhaseStep(), 
      Tclass.JournalCache.Step(), 
      $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.FinishLoadingSuperblockPhaseStep(), 
      Tclass.JournalCache.Step(), 
      $h));

// Constructor literal
axiom #JournalCache.Step.FinishLoadingSuperblockPhaseStep()
   == Lit(#JournalCache.Step.FinishLoadingSuperblockPhaseStep());

// Constructor function declaration
function #JournalCache.Step.FinishLoadingOtherPhaseStep() : DatatypeType;

const unique ##JournalCache.Step.FinishLoadingOtherPhaseStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.FinishLoadingOtherPhaseStep())
   == ##JournalCache.Step.FinishLoadingOtherPhaseStep;

function JournalCache.Step.FinishLoadingOtherPhaseStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.FinishLoadingOtherPhaseStep_q(d) } 
  JournalCache.Step.FinishLoadingOtherPhaseStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.FinishLoadingOtherPhaseStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.FinishLoadingOtherPhaseStep_q(d) } 
  JournalCache.Step.FinishLoadingOtherPhaseStep_q(d)
     ==> d == #JournalCache.Step.FinishLoadingOtherPhaseStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.FinishLoadingOtherPhaseStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.FinishLoadingOtherPhaseStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.FinishLoadingOtherPhaseStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.FinishLoadingOtherPhaseStep()
   == Lit(#JournalCache.Step.FinishLoadingOtherPhaseStep());

// Constructor function declaration
function #JournalCache.Step.FreezeStep() : DatatypeType;

const unique ##JournalCache.Step.FreezeStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.FreezeStep())
   == ##JournalCache.Step.FreezeStep;

function JournalCache.Step.FreezeStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.FreezeStep_q(d) } 
  JournalCache.Step.FreezeStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.FreezeStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.FreezeStep_q(d) } 
  JournalCache.Step.FreezeStep_q(d) ==> d == #JournalCache.Step.FreezeStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.FreezeStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.FreezeStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.FreezeStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.FreezeStep() == Lit(#JournalCache.Step.FreezeStep());

// Constructor function declaration
function #JournalCache.Step.ReceiveFrozenLocStep() : DatatypeType;

const unique ##JournalCache.Step.ReceiveFrozenLocStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.ReceiveFrozenLocStep())
   == ##JournalCache.Step.ReceiveFrozenLocStep;

function JournalCache.Step.ReceiveFrozenLocStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.ReceiveFrozenLocStep_q(d) } 
  JournalCache.Step.ReceiveFrozenLocStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.ReceiveFrozenLocStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.ReceiveFrozenLocStep_q(d) } 
  JournalCache.Step.ReceiveFrozenLocStep_q(d)
     ==> d == #JournalCache.Step.ReceiveFrozenLocStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.ReceiveFrozenLocStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.ReceiveFrozenLocStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.ReceiveFrozenLocStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.ReceiveFrozenLocStep()
   == Lit(#JournalCache.Step.ReceiveFrozenLocStep());

// Constructor function declaration
function #JournalCache.Step.AdvanceStep() : DatatypeType;

const unique ##JournalCache.Step.AdvanceStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.AdvanceStep())
   == ##JournalCache.Step.AdvanceStep;

function JournalCache.Step.AdvanceStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.AdvanceStep_q(d) } 
  JournalCache.Step.AdvanceStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.AdvanceStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.AdvanceStep_q(d) } 
  JournalCache.Step.AdvanceStep_q(d) ==> d == #JournalCache.Step.AdvanceStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.AdvanceStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.AdvanceStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.AdvanceStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.AdvanceStep() == Lit(#JournalCache.Step.AdvanceStep());

// Constructor function declaration
function #JournalCache.Step.ReplayStep() : DatatypeType;

const unique ##JournalCache.Step.ReplayStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.ReplayStep())
   == ##JournalCache.Step.ReplayStep;

function JournalCache.Step.ReplayStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.ReplayStep_q(d) } 
  JournalCache.Step.ReplayStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.ReplayStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.ReplayStep_q(d) } 
  JournalCache.Step.ReplayStep_q(d) ==> d == #JournalCache.Step.ReplayStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.ReplayStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.ReplayStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.ReplayStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.ReplayStep() == Lit(#JournalCache.Step.ReplayStep());

// Constructor function declaration
function #JournalCache.Step.PushSyncReqStep(int) : DatatypeType;

const unique ##JournalCache.Step.PushSyncReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#218#0#0: int :: 
  { #JournalCache.Step.PushSyncReqStep(a#218#0#0) } 
  DatatypeCtorId(#JournalCache.Step.PushSyncReqStep(a#218#0#0))
     == ##JournalCache.Step.PushSyncReqStep);

function JournalCache.Step.PushSyncReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PushSyncReqStep_q(d) } 
  JournalCache.Step.PushSyncReqStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.PushSyncReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PushSyncReqStep_q(d) } 
  JournalCache.Step.PushSyncReqStep_q(d)
     ==> (exists a#219#0#0: int :: d == #JournalCache.Step.PushSyncReqStep(a#219#0#0)));

// Constructor $Is
axiom (forall a#220#0#0: int :: 
  { $Is(#JournalCache.Step.PushSyncReqStep(a#220#0#0), Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.PushSyncReqStep(a#220#0#0), Tclass.JournalCache.Step())
     <==> $Is(a#220#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#221#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.PushSyncReqStep(a#221#0#0), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.PushSyncReqStep(a#221#0#0), Tclass.JournalCache.Step(), $h)
       <==> $IsAlloc(a#221#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.PushSyncReqStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#222#0#0: int :: 
  { #JournalCache.Step.PushSyncReqStep(LitInt(a#222#0#0)) } 
  #JournalCache.Step.PushSyncReqStep(LitInt(a#222#0#0))
     == Lit(#JournalCache.Step.PushSyncReqStep(a#222#0#0)));

function JournalCache.Step.id(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#223#0#0: int :: 
  { #JournalCache.Step.PushSyncReqStep(a#223#0#0) } 
  JournalCache.Step.id(#JournalCache.Step.PushSyncReqStep(a#223#0#0)) == a#223#0#0);

// Constructor function declaration
function #JournalCache.Step.PopSyncReqStep(int) : DatatypeType;

const unique ##JournalCache.Step.PopSyncReqStep: DtCtorId;

// Constructor identifier
axiom (forall a#224#0#0: int :: 
  { #JournalCache.Step.PopSyncReqStep(a#224#0#0) } 
  DatatypeCtorId(#JournalCache.Step.PopSyncReqStep(a#224#0#0))
     == ##JournalCache.Step.PopSyncReqStep);

function JournalCache.Step.PopSyncReqStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PopSyncReqStep_q(d) } 
  JournalCache.Step.PopSyncReqStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.PopSyncReqStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.PopSyncReqStep_q(d) } 
  JournalCache.Step.PopSyncReqStep_q(d)
     ==> (exists a#225#0#0: int :: d == #JournalCache.Step.PopSyncReqStep(a#225#0#0)));

// Constructor $Is
axiom (forall a#226#0#0: int :: 
  { $Is(#JournalCache.Step.PopSyncReqStep(a#226#0#0), Tclass.JournalCache.Step()) } 
  $Is(#JournalCache.Step.PopSyncReqStep(a#226#0#0), Tclass.JournalCache.Step())
     <==> $Is(a#226#0#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#227#0#0: int, $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.PopSyncReqStep(a#227#0#0), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#JournalCache.Step.PopSyncReqStep(a#227#0#0), Tclass.JournalCache.Step(), $h)
       <==> $IsAlloc(a#227#0#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(JournalCache.Step.id(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      JournalCache.Step.PopSyncReqStep_q(d)
       && $IsAlloc(d, Tclass.JournalCache.Step(), $h)
     ==> $IsAlloc(JournalCache.Step.id(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#228#0#0: int :: 
  { #JournalCache.Step.PopSyncReqStep(LitInt(a#228#0#0)) } 
  #JournalCache.Step.PopSyncReqStep(LitInt(a#228#0#0))
     == Lit(#JournalCache.Step.PopSyncReqStep(a#228#0#0)));

// Constructor injectivity
axiom (forall a#229#0#0: int :: 
  { #JournalCache.Step.PopSyncReqStep(a#229#0#0) } 
  JournalCache.Step.id(#JournalCache.Step.PopSyncReqStep(a#229#0#0)) == a#229#0#0);

// Constructor function declaration
function #JournalCache.Step.NoOpStep() : DatatypeType;

const unique ##JournalCache.Step.NoOpStep: DtCtorId;

// Constructor identifier
axiom DatatypeCtorId(#JournalCache.Step.NoOpStep()) == ##JournalCache.Step.NoOpStep;

function JournalCache.Step.NoOpStep_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.NoOpStep_q(d) } 
  JournalCache.Step.NoOpStep_q(d)
     <==> DatatypeCtorId(d) == ##JournalCache.Step.NoOpStep);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.NoOpStep_q(d) } 
  JournalCache.Step.NoOpStep_q(d) ==> d == #JournalCache.Step.NoOpStep());

// Constructor $Is
axiom $Is(#JournalCache.Step.NoOpStep(), Tclass.JournalCache.Step());

// Constructor $IsAlloc
axiom (forall $h: Heap :: 
  { $IsAlloc(#JournalCache.Step.NoOpStep(), Tclass.JournalCache.Step(), $h) } 
  $IsGoodHeap($h)
     ==> $IsAlloc(#JournalCache.Step.NoOpStep(), Tclass.JournalCache.Step(), $h));

// Constructor literal
axiom #JournalCache.Step.NoOpStep() == Lit(#JournalCache.Step.NoOpStep());

// Depth-one case-split function
function $IsA#JournalCache.Step(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#JournalCache.Step(d) } 
  $IsA#JournalCache.Step(d)
     ==> JournalCache.Step.WriteBackJournalReqStep_q(d)
       || JournalCache.Step.WriteBackJournalRespStep_q(d)
       || JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d)
       || JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d)
       || JournalCache.Step.WriteBackSuperblockRespStep_q(d)
       || JournalCache.Step.PageInJournalReqStep_q(d)
       || JournalCache.Step.PageInJournalRespStep_q(d)
       || JournalCache.Step.PageInSuperblockReqStep_q(d)
       || JournalCache.Step.PageInSuperblockRespStep_q(d)
       || JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d)
       || JournalCache.Step.FinishLoadingOtherPhaseStep_q(d)
       || JournalCache.Step.FreezeStep_q(d)
       || JournalCache.Step.ReceiveFrozenLocStep_q(d)
       || JournalCache.Step.AdvanceStep_q(d)
       || JournalCache.Step.ReplayStep_q(d)
       || JournalCache.Step.PushSyncReqStep_q(d)
       || JournalCache.Step.PopSyncReqStep_q(d)
       || JournalCache.Step.NoOpStep_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { JournalCache.Step.NoOpStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.PopSyncReqStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.PushSyncReqStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.ReplayStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.AdvanceStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.ReceiveFrozenLocStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.FreezeStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.FinishLoadingOtherPhaseStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.PageInSuperblockRespStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.PageInSuperblockReqStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.PageInJournalRespStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.PageInJournalReqStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.WriteBackSuperblockRespStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.WriteBackJournalRespStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
    { JournalCache.Step.WriteBackJournalReqStep_q(d), $Is(d, Tclass.JournalCache.Step()) } 
  $Is(d, Tclass.JournalCache.Step())
     ==> JournalCache.Step.WriteBackJournalReqStep_q(d)
       || JournalCache.Step.WriteBackJournalRespStep_q(d)
       || JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(d)
       || JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(d)
       || JournalCache.Step.WriteBackSuperblockRespStep_q(d)
       || JournalCache.Step.PageInJournalReqStep_q(d)
       || JournalCache.Step.PageInJournalRespStep_q(d)
       || JournalCache.Step.PageInSuperblockReqStep_q(d)
       || JournalCache.Step.PageInSuperblockRespStep_q(d)
       || JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(d)
       || JournalCache.Step.FinishLoadingOtherPhaseStep_q(d)
       || JournalCache.Step.FreezeStep_q(d)
       || JournalCache.Step.ReceiveFrozenLocStep_q(d)
       || JournalCache.Step.AdvanceStep_q(d)
       || JournalCache.Step.ReplayStep_q(d)
       || JournalCache.Step.PushSyncReqStep_q(d)
       || JournalCache.Step.PopSyncReqStep_q(d)
       || JournalCache.Step.NoOpStep_q(d));

// Datatype extensional equality declaration
function JournalCache.Step#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #JournalCache.Step.WriteBackJournalReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackJournalReqStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackJournalReqStep_q(b) } 
  JournalCache.Step.WriteBackJournalReqStep_q(a)
       && JournalCache.Step.WriteBackJournalReqStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> Seq#Equal(JournalCache.Step.jr(a), JournalCache.Step.jr(b))));

// Datatype extensional equality definition: #JournalCache.Step.WriteBackJournalRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackJournalRespStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackJournalRespStep_q(b) } 
  JournalCache.Step.WriteBackJournalRespStep_q(a)
       && JournalCache.Step.WriteBackJournalRespStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.WriteBackSuperblockReq_AdvanceLog_Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(b) } 
  JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(a)
       && JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.WriteBackSuperblockReq_AdvanceLocation_Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(b) } 
  JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(a)
       && JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.WriteBackSuperblockRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackSuperblockRespStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.WriteBackSuperblockRespStep_q(b) } 
  JournalCache.Step.WriteBackSuperblockRespStep_q(a)
       && JournalCache.Step.WriteBackSuperblockRespStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.PageInJournalReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInJournalReqStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInJournalReqStep_q(b) } 
  JournalCache.Step.PageInJournalReqStep_q(a)
       && JournalCache.Step.PageInJournalReqStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> JournalCache.Step.which(a) == JournalCache.Step.which(b)));

// Datatype extensional equality definition: #JournalCache.Step.PageInJournalRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInJournalRespStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInJournalRespStep_q(b) } 
  JournalCache.Step.PageInJournalRespStep_q(a)
       && JournalCache.Step.PageInJournalRespStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> JournalCache.Step.which(a) == JournalCache.Step.which(b)));

// Datatype extensional equality definition: #JournalCache.Step.PageInSuperblockReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInSuperblockReqStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInSuperblockReqStep_q(b) } 
  JournalCache.Step.PageInSuperblockReqStep_q(a)
       && JournalCache.Step.PageInSuperblockReqStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> JournalCache.Step.which(a) == JournalCache.Step.which(b)));

// Datatype extensional equality definition: #JournalCache.Step.PageInSuperblockRespStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInSuperblockRespStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.PageInSuperblockRespStep_q(b) } 
  JournalCache.Step.PageInSuperblockRespStep_q(a)
       && JournalCache.Step.PageInSuperblockRespStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> JournalCache.Step.which(a) == JournalCache.Step.which(b)));

// Datatype extensional equality definition: #JournalCache.Step.FinishLoadingSuperblockPhaseStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(b) } 
  JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(a)
       && JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.FinishLoadingOtherPhaseStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.FinishLoadingOtherPhaseStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.FinishLoadingOtherPhaseStep_q(b) } 
  JournalCache.Step.FinishLoadingOtherPhaseStep_q(a)
       && JournalCache.Step.FinishLoadingOtherPhaseStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.FreezeStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.FreezeStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.FreezeStep_q(b) } 
  JournalCache.Step.FreezeStep_q(a) && JournalCache.Step.FreezeStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.ReceiveFrozenLocStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.ReceiveFrozenLocStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.ReceiveFrozenLocStep_q(b) } 
  JournalCache.Step.ReceiveFrozenLocStep_q(a)
       && JournalCache.Step.ReceiveFrozenLocStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.AdvanceStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.AdvanceStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.AdvanceStep_q(b) } 
  JournalCache.Step.AdvanceStep_q(a) && JournalCache.Step.AdvanceStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.ReplayStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.ReplayStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.ReplayStep_q(b) } 
  JournalCache.Step.ReplayStep_q(a) && JournalCache.Step.ReplayStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensional equality definition: #JournalCache.Step.PushSyncReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.PushSyncReqStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.PushSyncReqStep_q(b) } 
  JournalCache.Step.PushSyncReqStep_q(a) && JournalCache.Step.PushSyncReqStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> JournalCache.Step.id(a) == JournalCache.Step.id(b)));

// Datatype extensional equality definition: #JournalCache.Step.PopSyncReqStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.PopSyncReqStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.PopSyncReqStep_q(b) } 
  JournalCache.Step.PopSyncReqStep_q(a) && JournalCache.Step.PopSyncReqStep_q(b)
     ==> (JournalCache.Step#Equal(a, b)
       <==> JournalCache.Step.id(a) == JournalCache.Step.id(b)));

// Datatype extensional equality definition: #JournalCache.Step.NoOpStep
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b), JournalCache.Step.NoOpStep_q(a) } 
    { JournalCache.Step#Equal(a, b), JournalCache.Step.NoOpStep_q(b) } 
  JournalCache.Step.NoOpStep_q(a) && JournalCache.Step.NoOpStep_q(b)
     ==> (JournalCache.Step#Equal(a, b) <==> true));

// Datatype extensionality axiom: JournalCache.Step
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { JournalCache.Step#Equal(a, b) } 
  JournalCache.Step#Equal(a, b) <==> a == b);

const unique class.JournalCache.Step: ClassName;

const unique class.JournalCache.__default: ClassName;

function Tclass.JournalCache.__default() : Ty;

// Tclass.JournalCache.__default Tag
axiom Tag(Tclass.JournalCache.__default()) == Tagclass.JournalCache.__default;

const unique Tagclass.JournalCache.__default: TyTag;

// Box/unbox axiom for Tclass.JournalCache.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.JournalCache.__default()) } 
  $IsBox(bx, Tclass.JournalCache.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.JournalCache.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.JournalCache.__default()) } 
  $Is($o, Tclass.JournalCache.__default())
     <==> $o == null || dtype($o) == Tclass.JournalCache.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.JournalCache.__default(), $h) } 
  $IsAlloc($o, Tclass.JournalCache.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for JournalCache._default.IncrementSuperblockCounter
function JournalCache.__default.IncrementSuperblockCounter(i#0: int) : int;

function JournalCache.__default.IncrementSuperblockCounter#canCall(i#0: int) : bool;

// consequence axiom for JournalCache.__default.IncrementSuperblockCounter
axiom true
   ==> (forall i#0: int :: 
    { JournalCache.__default.IncrementSuperblockCounter(i#0) } 
    JournalCache.__default.IncrementSuperblockCounter#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> LitInt(0) <= JournalCache.__default.IncrementSuperblockCounter(i#0)
         && JournalCache.__default.IncrementSuperblockCounter(i#0) < 18446744073709551616);

function JournalCache.__default.IncrementSuperblockCounter#requires(int) : bool;

// #requires axiom for JournalCache.__default.IncrementSuperblockCounter
axiom (forall i#0: int :: 
  { JournalCache.__default.IncrementSuperblockCounter#requires(i#0) } 
  LitInt(0) <= i#0 && i#0 < 18446744073709551616
     ==> JournalCache.__default.IncrementSuperblockCounter#requires(i#0) == true);

// definition axiom for JournalCache.__default.IncrementSuperblockCounter(revealed)
axiom true
   ==> (forall i#0: int :: 
    { JournalCache.__default.IncrementSuperblockCounter(i#0) } 
    JournalCache.__default.IncrementSuperblockCounter#canCall(i#0)
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> JournalCache.__default.IncrementSuperblockCounter(i#0)
         == (if i#0 == LitInt(18446744073709551615) then 0 else i#0 + 1));

// definition axiom for JournalCache.__default.IncrementSuperblockCounter for all literals(revealed)
axiom true
   ==> (forall i#0: int :: 
    {:weight 3} { JournalCache.__default.IncrementSuperblockCounter(LitInt(i#0)) } 
    JournalCache.__default.IncrementSuperblockCounter#canCall(LitInt(i#0))
         || (LitInt(0) <= i#0 && i#0 < 18446744073709551616)
       ==> JournalCache.__default.IncrementSuperblockCounter(LitInt(i#0))
         == (if LitInt(i#0) == LitInt(18446744073709551615) then 0 else i#0 + 1));

// function declaration for JournalCache._default.increments1
function JournalCache.__default.increments1(i#0: int, j#0: int) : bool;

function JournalCache.__default.increments1#canCall(i#0: int, j#0: int) : bool;

// consequence axiom for JournalCache.__default.increments1
axiom true
   ==> (forall i#0: int, j#0: int :: 
    { JournalCache.__default.increments1(i#0, j#0) } 
    JournalCache.__default.increments1#canCall(i#0, j#0)
         || (
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= j#0
           && j#0 < 18446744073709551616)
       ==> true);

function JournalCache.__default.increments1#requires(int, int) : bool;

// #requires axiom for JournalCache.__default.increments1
axiom (forall i#0: int, j#0: int :: 
  { JournalCache.__default.increments1#requires(i#0, j#0) } 
  LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && 
      LitInt(0) <= j#0
       && j#0 < 18446744073709551616
     ==> JournalCache.__default.increments1#requires(i#0, j#0) == true);

// definition axiom for JournalCache.__default.increments1(revealed)
axiom true
   ==> (forall i#0: int, j#0: int :: 
    { JournalCache.__default.increments1(i#0, j#0) } 
    JournalCache.__default.increments1#canCall(i#0, j#0)
         || (
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= j#0
           && j#0 < 18446744073709551616)
       ==> JournalCache.__default.IncrementSuperblockCounter#canCall(i#0)
         && JournalCache.__default.increments1(i#0, j#0)
           == 
          (j#0
           == JournalCache.__default.IncrementSuperblockCounter(i#0)));

// definition axiom for JournalCache.__default.increments1 for all literals(revealed)
axiom true
   ==> (forall i#0: int, j#0: int :: 
    {:weight 3} { JournalCache.__default.increments1(LitInt(i#0), LitInt(j#0)) } 
    JournalCache.__default.increments1#canCall(LitInt(i#0), LitInt(j#0))
         || (
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= j#0
           && j#0 < 18446744073709551616)
       ==> JournalCache.__default.IncrementSuperblockCounter#canCall(LitInt(i#0))
         && JournalCache.__default.increments1(LitInt(i#0), LitInt(j#0))
           == 
          (LitInt(j#0)
           == LitInt(JournalCache.__default.IncrementSuperblockCounter(LitInt(i#0)))));

// function declaration for JournalCache._default.SelectSuperblockIndex
function JournalCache.__default.SelectSuperblockIndex(superblock1#0: DatatypeType, superblock2#0: DatatypeType) : int;

function JournalCache.__default.SelectSuperblockIndex#canCall(superblock1#0: DatatypeType, superblock2#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.SelectSuperblockIndex
axiom true
   ==> (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
    { JournalCache.__default.SelectSuperblockIndex(superblock1#0, superblock2#0) } 
    JournalCache.__default.SelectSuperblockIndex#canCall(superblock1#0, superblock2#0)
         || ($Is(superblock1#0, Tclass.SectorType.Superblock())
           && $Is(superblock2#0, Tclass.SectorType.Superblock()))
       ==> true);

function JournalCache.__default.SelectSuperblockIndex#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.SelectSuperblockIndex
axiom (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
  { JournalCache.__default.SelectSuperblockIndex#requires(superblock1#0, superblock2#0) } 
  $Is(superblock1#0, Tclass.SectorType.Superblock())
       && $Is(superblock2#0, Tclass.SectorType.Superblock())
     ==> JournalCache.__default.SelectSuperblockIndex#requires(superblock1#0, superblock2#0)
       == true);

// definition axiom for JournalCache.__default.SelectSuperblockIndex(revealed)
axiom true
   ==> (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
    { JournalCache.__default.SelectSuperblockIndex(superblock1#0, superblock2#0) } 
    JournalCache.__default.SelectSuperblockIndex#canCall(superblock1#0, superblock2#0)
         || ($Is(superblock1#0, Tclass.SectorType.Superblock())
           && $Is(superblock2#0, Tclass.SectorType.Superblock()))
       ==> SectorType.Superblock.Superblock_q(superblock1#0)
         && SectorType.Superblock.Superblock_q(superblock2#0)
         && JournalCache.__default.increments1#canCall(SectorType.Superblock.counter(superblock1#0), 
          SectorType.Superblock.counter(superblock2#0))
         && JournalCache.__default.SelectSuperblockIndex(superblock1#0, superblock2#0)
           == (if JournalCache.__default.increments1(SectorType.Superblock.counter(superblock1#0), 
              SectorType.Superblock.counter(superblock2#0))
             then 1
             else 0));

// definition axiom for JournalCache.__default.SelectSuperblockIndex for all literals(revealed)
axiom true
   ==> (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.SelectSuperblockIndex(Lit(superblock1#0), Lit(superblock2#0)) } 
    JournalCache.__default.SelectSuperblockIndex#canCall(Lit(superblock1#0), Lit(superblock2#0))
         || ($Is(superblock1#0, Tclass.SectorType.Superblock())
           && $Is(superblock2#0, Tclass.SectorType.Superblock()))
       ==> SectorType.Superblock.Superblock_q(Lit(superblock1#0))
         && SectorType.Superblock.Superblock_q(Lit(superblock2#0))
         && JournalCache.__default.increments1#canCall(LitInt(SectorType.Superblock.counter(Lit(superblock1#0))), 
          LitInt(SectorType.Superblock.counter(Lit(superblock2#0))))
         && JournalCache.__default.SelectSuperblockIndex(Lit(superblock1#0), Lit(superblock2#0))
           == (if JournalCache.__default.increments1(LitInt(SectorType.Superblock.counter(Lit(superblock1#0))), 
              LitInt(SectorType.Superblock.counter(Lit(superblock2#0))))
             then 1
             else 0));

// function declaration for JournalCache._default.SelectSuperblock
function JournalCache.__default.SelectSuperblock(superblock1#0: DatatypeType, superblock2#0: DatatypeType) : DatatypeType;

function JournalCache.__default.SelectSuperblock#canCall(superblock1#0: DatatypeType, superblock2#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.SelectSuperblock
axiom true
   ==> (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
    { JournalCache.__default.SelectSuperblock(superblock1#0, superblock2#0) } 
    JournalCache.__default.SelectSuperblock#canCall(superblock1#0, superblock2#0)
         || ($Is(superblock1#0, Tclass.SectorType.Superblock())
           && $Is(superblock2#0, Tclass.SectorType.Superblock()))
       ==> $Is(JournalCache.__default.SelectSuperblock(superblock1#0, superblock2#0), 
        Tclass.SectorType.Superblock()));

function JournalCache.__default.SelectSuperblock#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.SelectSuperblock
axiom (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
  { JournalCache.__default.SelectSuperblock#requires(superblock1#0, superblock2#0) } 
  $Is(superblock1#0, Tclass.SectorType.Superblock())
       && $Is(superblock2#0, Tclass.SectorType.Superblock())
     ==> JournalCache.__default.SelectSuperblock#requires(superblock1#0, superblock2#0)
       == true);

// definition axiom for JournalCache.__default.SelectSuperblock(revealed)
axiom true
   ==> (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
    { JournalCache.__default.SelectSuperblock(superblock1#0, superblock2#0) } 
    JournalCache.__default.SelectSuperblock#canCall(superblock1#0, superblock2#0)
         || ($Is(superblock1#0, Tclass.SectorType.Superblock())
           && $Is(superblock2#0, Tclass.SectorType.Superblock()))
       ==> JournalCache.__default.SelectSuperblockIndex#canCall(superblock1#0, superblock2#0)
         && JournalCache.__default.SelectSuperblock(superblock1#0, superblock2#0)
           == (if JournalCache.__default.SelectSuperblockIndex(superblock1#0, superblock2#0)
               == LitInt(1)
             then superblock2#0
             else superblock1#0));

// definition axiom for JournalCache.__default.SelectSuperblock for all literals(revealed)
axiom true
   ==> (forall superblock1#0: DatatypeType, superblock2#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.SelectSuperblock(Lit(superblock1#0), Lit(superblock2#0)) } 
    JournalCache.__default.SelectSuperblock#canCall(Lit(superblock1#0), Lit(superblock2#0))
         || ($Is(superblock1#0, Tclass.SectorType.Superblock())
           && $Is(superblock2#0, Tclass.SectorType.Superblock()))
       ==> JournalCache.__default.SelectSuperblockIndex#canCall(Lit(superblock1#0), Lit(superblock2#0))
         && JournalCache.__default.SelectSuperblock(Lit(superblock1#0), Lit(superblock2#0))
           == (if LitInt(JournalCache.__default.SelectSuperblockIndex(Lit(superblock1#0), Lit(superblock2#0)))
               == LitInt(1)
             then superblock2#0
             else superblock1#0));

// function declaration for JournalCache._default.syncReqs3to2
function JournalCache.__default.syncReqs3to2(syncReqs#0: Map Box Box) : Map Box Box;

function JournalCache.__default.syncReqs3to2#canCall(syncReqs#0: Map Box Box) : bool;

// consequence axiom for JournalCache.__default.syncReqs3to2
axiom true
   ==> (forall syncReqs#0: Map Box Box :: 
    { JournalCache.__default.syncReqs3to2(syncReqs#0) } 
    JournalCache.__default.syncReqs3to2#canCall(syncReqs#0)
         || $Is(syncReqs#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
       ==> $Is(JournalCache.__default.syncReqs3to2(syncReqs#0), 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

function JournalCache.__default.syncReqs3to2#requires(Map Box Box) : bool;

// #requires axiom for JournalCache.__default.syncReqs3to2
axiom (forall syncReqs#0: Map Box Box :: 
  { JournalCache.__default.syncReqs3to2#requires(syncReqs#0) } 
  $Is(syncReqs#0, 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
     ==> JournalCache.__default.syncReqs3to2#requires(syncReqs#0) == true);

// definition axiom for JournalCache.__default.syncReqs3to2(revealed)
axiom true
   ==> (forall syncReqs#0: Map Box Box :: 
    { JournalCache.__default.syncReqs3to2(syncReqs#0) } 
    JournalCache.__default.syncReqs3to2#canCall(syncReqs#0)
         || $Is(syncReqs#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(syncReqs#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(syncReqs#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(syncReqs#0)[$Box(id#0)]
             ==> $IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(syncReqs#0)[$Box(id#0)]): DatatypeType))
         && JournalCache.__default.syncReqs3to2(syncReqs#0)
           == Map#Glue((lambda $w#0: Box :: 
              LitInt(0) <= $Unbox($w#0): int
                 && $Unbox($w#0): int < 18446744073709551616
                 && Map#Domain(syncReqs#0)[$w#0]), 
            (lambda $w#0: Box :: 
              $Box((if JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(syncReqs#0)[$w#0]): DatatypeType, 
                    #JournalCache.SyncReqStatus.State3())
                   then #JournalCache.SyncReqStatus.State2()
                   else $Unbox(Map#Elements(syncReqs#0)[$w#0]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// definition axiom for JournalCache.__default.syncReqs3to2 for all literals(revealed)
axiom true
   ==> (forall syncReqs#0: Map Box Box :: 
    {:weight 3} { JournalCache.__default.syncReqs3to2(Lit(syncReqs#0)) } 
    JournalCache.__default.syncReqs3to2#canCall(Lit(syncReqs#0))
         || $Is(syncReqs#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(syncReqs#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(syncReqs#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(syncReqs#0)[$Box(id#0)]
             ==> $IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(Lit(syncReqs#0))[$Box(id#0)]): DatatypeType))
         && JournalCache.__default.syncReqs3to2(Lit(syncReqs#0))
           == Map#Glue((lambda $w#1: Box :: 
              LitInt(0) <= $Unbox($w#1): int
                 && $Unbox($w#1): int < 18446744073709551616
                 && Map#Domain(syncReqs#0)[$w#1]), 
            (lambda $w#1: Box :: 
              $Box((if JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(Lit(syncReqs#0))[$w#1]): DatatypeType, 
                    #JournalCache.SyncReqStatus.State3())
                   then #JournalCache.SyncReqStatus.State2()
                   else $Unbox(Map#Elements(Lit(syncReqs#0))[$w#1]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// function declaration for JournalCache._default.syncReqs2to1
function JournalCache.__default.syncReqs2to1(syncReqs#0: Map Box Box) : Map Box Box;

function JournalCache.__default.syncReqs2to1#canCall(syncReqs#0: Map Box Box) : bool;

// consequence axiom for JournalCache.__default.syncReqs2to1
axiom true
   ==> (forall syncReqs#0: Map Box Box :: 
    { JournalCache.__default.syncReqs2to1(syncReqs#0) } 
    JournalCache.__default.syncReqs2to1#canCall(syncReqs#0)
         || $Is(syncReqs#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
       ==> $Is(JournalCache.__default.syncReqs2to1(syncReqs#0), 
        TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

function JournalCache.__default.syncReqs2to1#requires(Map Box Box) : bool;

// #requires axiom for JournalCache.__default.syncReqs2to1
axiom (forall syncReqs#0: Map Box Box :: 
  { JournalCache.__default.syncReqs2to1#requires(syncReqs#0) } 
  $Is(syncReqs#0, 
      TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
     ==> JournalCache.__default.syncReqs2to1#requires(syncReqs#0) == true);

// definition axiom for JournalCache.__default.syncReqs2to1(revealed)
axiom true
   ==> (forall syncReqs#0: Map Box Box :: 
    { JournalCache.__default.syncReqs2to1(syncReqs#0) } 
    JournalCache.__default.syncReqs2to1#canCall(syncReqs#0)
         || $Is(syncReqs#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(syncReqs#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(syncReqs#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(syncReqs#0)[$Box(id#0)]
             ==> $IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(syncReqs#0)[$Box(id#0)]): DatatypeType))
         && JournalCache.__default.syncReqs2to1(syncReqs#0)
           == Map#Glue((lambda $w#0: Box :: 
              LitInt(0) <= $Unbox($w#0): int
                 && $Unbox($w#0): int < 18446744073709551616
                 && Map#Domain(syncReqs#0)[$w#0]), 
            (lambda $w#0: Box :: 
              $Box((if JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(syncReqs#0)[$w#0]): DatatypeType, 
                    #JournalCache.SyncReqStatus.State2())
                   then #JournalCache.SyncReqStatus.State1()
                   else $Unbox(Map#Elements(syncReqs#0)[$w#0]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// definition axiom for JournalCache.__default.syncReqs2to1 for all literals(revealed)
axiom true
   ==> (forall syncReqs#0: Map Box Box :: 
    {:weight 3} { JournalCache.__default.syncReqs2to1(Lit(syncReqs#0)) } 
    JournalCache.__default.syncReqs2to1#canCall(Lit(syncReqs#0))
         || $Is(syncReqs#0, 
          TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus()))
       ==> (forall id#0: int :: 
          { $Unbox(Map#Elements(syncReqs#0)[$Box(id#0)]): DatatypeType } 
            { Map#Domain(syncReqs#0)[$Box(id#0)] } 
          LitInt(0) <= id#0 && id#0 < 18446744073709551616
             ==> 
            Map#Domain(syncReqs#0)[$Box(id#0)]
             ==> $IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(Lit(syncReqs#0))[$Box(id#0)]): DatatypeType))
         && JournalCache.__default.syncReqs2to1(Lit(syncReqs#0))
           == Map#Glue((lambda $w#1: Box :: 
              LitInt(0) <= $Unbox($w#1): int
                 && $Unbox($w#1): int < 18446744073709551616
                 && Map#Domain(syncReqs#0)[$w#1]), 
            (lambda $w#1: Box :: 
              $Box((if JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(Lit(syncReqs#0))[$w#1]): DatatypeType, 
                    #JournalCache.SyncReqStatus.State2())
                   then #JournalCache.SyncReqStatus.State1()
                   else $Unbox(Map#Elements(Lit(syncReqs#0))[$w#1]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), Tclass.JournalCache.SyncReqStatus())));

// function declaration for JournalCache._default.JournalFrontIntervalOfSuperblock
function JournalCache.__default.JournalFrontIntervalOfSuperblock(superblock#0: DatatypeType) : DatatypeType;

function JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(superblock#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.JournalFrontIntervalOfSuperblock
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    { JournalCache.__default.JournalFrontIntervalOfSuperblock(superblock#0) } 
    JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(superblock#0)
         || ($Is(superblock#0, Tclass.SectorType.Superblock())
           && SectorType.Superblock.journalStart(superblock#0)
             < DiskLayout.__default.NumJournalBlocks())
       ==> $Is(JournalCache.__default.JournalFrontIntervalOfSuperblock(superblock#0), 
        Tclass.Options.Option(Tclass.JournalIntervals.JournalInterval())));

function JournalCache.__default.JournalFrontIntervalOfSuperblock#requires(DatatypeType) : bool;

// #requires axiom for JournalCache.__default.JournalFrontIntervalOfSuperblock
axiom (forall superblock#0: DatatypeType :: 
  { JournalCache.__default.JournalFrontIntervalOfSuperblock#requires(superblock#0) } 
  $Is(superblock#0, Tclass.SectorType.Superblock())
     ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#requires(superblock#0)
       == (SectorType.Superblock.journalStart(superblock#0)
         < DiskLayout.__default.NumJournalBlocks()));

// definition axiom for JournalCache.__default.JournalFrontIntervalOfSuperblock(revealed)
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    { JournalCache.__default.JournalFrontIntervalOfSuperblock(superblock#0) } 
    JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(superblock#0)
         || ($Is(superblock#0, Tclass.SectorType.Superblock())
           && SectorType.Superblock.journalStart(superblock#0)
             < DiskLayout.__default.NumJournalBlocks())
       ==> SectorType.Superblock.Superblock_q(superblock#0)
         && SectorType.Superblock.Superblock_q(superblock#0)
         && JournalIntervals.__default.JournalFrontInterval#canCall(SectorType.Superblock.journalStart(superblock#0), 
          SectorType.Superblock.journalLen(superblock#0))
         && JournalCache.__default.JournalFrontIntervalOfSuperblock(superblock#0)
           == JournalIntervals.__default.JournalFrontInterval(SectorType.Superblock.journalStart(superblock#0), 
            SectorType.Superblock.journalLen(superblock#0)));

// definition axiom for JournalCache.__default.JournalFrontIntervalOfSuperblock for all literals(revealed)
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(superblock#0)) } 
    JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(superblock#0))
         || ($Is(superblock#0, Tclass.SectorType.Superblock())
           && Lit(SectorType.Superblock.journalStart(Lit(superblock#0))
               < DiskLayout.__default.NumJournalBlocks()))
       ==> SectorType.Superblock.Superblock_q(Lit(superblock#0))
         && SectorType.Superblock.Superblock_q(Lit(superblock#0))
         && JournalIntervals.__default.JournalFrontInterval#canCall(LitInt(SectorType.Superblock.journalStart(Lit(superblock#0))), 
          LitInt(SectorType.Superblock.journalLen(Lit(superblock#0))))
         && JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(superblock#0))
           == Lit(JournalIntervals.__default.JournalFrontInterval(LitInt(SectorType.Superblock.journalStart(Lit(superblock#0))), 
              LitInt(SectorType.Superblock.journalLen(Lit(superblock#0))))));

// function declaration for JournalCache._default.JournalBackIntervalOfSuperblock
function JournalCache.__default.JournalBackIntervalOfSuperblock(superblock#0: DatatypeType) : DatatypeType;

function JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(superblock#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.JournalBackIntervalOfSuperblock
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    { JournalCache.__default.JournalBackIntervalOfSuperblock(superblock#0) } 
    JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(superblock#0)
         || ($Is(superblock#0, Tclass.SectorType.Superblock())
           && 
          SectorType.Superblock.journalStart(superblock#0)
             < DiskLayout.__default.NumJournalBlocks()
           && SectorType.Superblock.journalLen(superblock#0)
             <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> $Is(JournalCache.__default.JournalBackIntervalOfSuperblock(superblock#0), 
        Tclass.Options.Option(Tclass.JournalIntervals.JournalInterval())));

function JournalCache.__default.JournalBackIntervalOfSuperblock#requires(DatatypeType) : bool;

// #requires axiom for JournalCache.__default.JournalBackIntervalOfSuperblock
axiom (forall superblock#0: DatatypeType :: 
  { JournalCache.__default.JournalBackIntervalOfSuperblock#requires(superblock#0) } 
  $Is(superblock#0, Tclass.SectorType.Superblock())
     ==> JournalCache.__default.JournalBackIntervalOfSuperblock#requires(superblock#0)
       == (SectorType.Superblock.journalStart(superblock#0)
           < DiskLayout.__default.NumJournalBlocks()
         && SectorType.Superblock.journalLen(superblock#0)
           <= LitInt(DiskLayout.__default.NumJournalBlocks())));

// definition axiom for JournalCache.__default.JournalBackIntervalOfSuperblock(revealed)
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    { JournalCache.__default.JournalBackIntervalOfSuperblock(superblock#0) } 
    JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(superblock#0)
         || ($Is(superblock#0, Tclass.SectorType.Superblock())
           && 
          SectorType.Superblock.journalStart(superblock#0)
             < DiskLayout.__default.NumJournalBlocks()
           && SectorType.Superblock.journalLen(superblock#0)
             <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> SectorType.Superblock.Superblock_q(superblock#0)
         && SectorType.Superblock.Superblock_q(superblock#0)
         && JournalIntervals.__default.JournalBackInterval#canCall(SectorType.Superblock.journalStart(superblock#0), 
          SectorType.Superblock.journalLen(superblock#0))
         && JournalCache.__default.JournalBackIntervalOfSuperblock(superblock#0)
           == JournalIntervals.__default.JournalBackInterval(SectorType.Superblock.journalStart(superblock#0), 
            SectorType.Superblock.journalLen(superblock#0)));

// definition axiom for JournalCache.__default.JournalBackIntervalOfSuperblock for all literals(revealed)
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(superblock#0)) } 
    JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(superblock#0))
         || ($Is(superblock#0, Tclass.SectorType.Superblock())
           && 
          Lit(SectorType.Superblock.journalStart(Lit(superblock#0))
               < DiskLayout.__default.NumJournalBlocks())
           && LitInt(SectorType.Superblock.journalLen(Lit(superblock#0)))
             <= LitInt(DiskLayout.__default.NumJournalBlocks()))
       ==> SectorType.Superblock.Superblock_q(Lit(superblock#0))
         && SectorType.Superblock.Superblock_q(Lit(superblock#0))
         && JournalIntervals.__default.JournalBackInterval#canCall(LitInt(SectorType.Superblock.journalStart(Lit(superblock#0))), 
          LitInt(SectorType.Superblock.journalLen(Lit(superblock#0))))
         && JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(superblock#0))
           == Lit(JournalIntervals.__default.JournalBackInterval(LitInt(SectorType.Superblock.journalStart(Lit(superblock#0))), 
              LitInt(SectorType.Superblock.journalLen(Lit(superblock#0))))));

// function declaration for JournalCache._default.WFSuperblock
function JournalCache.__default.WFSuperblock(superblock#0: DatatypeType) : bool;

function JournalCache.__default.WFSuperblock#canCall(superblock#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.WFSuperblock
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    { JournalCache.__default.WFSuperblock(superblock#0) } 
    JournalCache.__default.WFSuperblock#canCall(superblock#0)
         || $Is(superblock#0, Tclass.SectorType.Superblock())
       ==> true);

function JournalCache.__default.WFSuperblock#requires(DatatypeType) : bool;

// #requires axiom for JournalCache.__default.WFSuperblock
axiom (forall superblock#0: DatatypeType :: 
  { JournalCache.__default.WFSuperblock#requires(superblock#0) } 
  $Is(superblock#0, Tclass.SectorType.Superblock())
     ==> JournalCache.__default.WFSuperblock#requires(superblock#0) == true);

// definition axiom for JournalCache.__default.WFSuperblock(revealed)
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    { JournalCache.__default.WFSuperblock(superblock#0) } 
    JournalCache.__default.WFSuperblock#canCall(superblock#0)
         || $Is(superblock#0, Tclass.SectorType.Superblock())
       ==> SectorType.Superblock.Superblock_q(superblock#0)
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (SectorType.Superblock.journalStart(superblock#0)
             < DiskLayout.__default.NumJournalBlocks()
           ==> SectorType.Superblock.Superblock_q(superblock#0)
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(superblock#0)
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && SectorType.Superblock.journalLen(superblock#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(superblock#0)
             && DiskLayout.__default.ValidIndirectionTableLocation#canCall(SectorType.Superblock.indirectionTableLoc(superblock#0)))
         && JournalCache.__default.WFSuperblock(superblock#0)
           == (
            SectorType.Superblock.journalStart(superblock#0)
               < DiskLayout.__default.NumJournalBlocks()
             && SectorType.Superblock.journalLen(superblock#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && DiskLayout.__default.ValidIndirectionTableLocation(SectorType.Superblock.indirectionTableLoc(superblock#0))));

// definition axiom for JournalCache.__default.WFSuperblock for all literals(revealed)
axiom true
   ==> (forall superblock#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.WFSuperblock(Lit(superblock#0)) } 
    JournalCache.__default.WFSuperblock#canCall(Lit(superblock#0))
         || $Is(superblock#0, Tclass.SectorType.Superblock())
       ==> SectorType.Superblock.Superblock_q(Lit(superblock#0))
         && DiskLayout.__default.NumJournalBlocks#canCall()
         && (Lit(SectorType.Superblock.journalStart(Lit(superblock#0))
               < DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(superblock#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(Lit(superblock#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && LitInt(SectorType.Superblock.journalLen(Lit(superblock#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(superblock#0))
             && DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(SectorType.Superblock.indirectionTableLoc(Lit(superblock#0)))))
         && JournalCache.__default.WFSuperblock(Lit(superblock#0))
           == (
            SectorType.Superblock.journalStart(Lit(superblock#0))
               < DiskLayout.__default.NumJournalBlocks()
             && LitInt(SectorType.Superblock.journalLen(Lit(superblock#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && DiskLayout.__default.ValidIndirectionTableLocation(Lit(SectorType.Superblock.indirectionTableLoc(Lit(superblock#0))))));

// function declaration for JournalCache._default.WriteBackJournalReq
function JournalCache.__default.WriteBackJournalReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    jr#0: Seq Box)
   : bool;

function JournalCache.__default.WriteBackJournalReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    jr#0: Seq Box)
   : bool;

// consequence axiom for JournalCache.__default.WriteBackJournalReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      jr#0: Seq Box :: 
    { JournalCache.__default.WriteBackJournalReq(k#0, s#0, s'#0, dop#0, vop#0, jr#0) } 
    JournalCache.__default.WriteBackJournalReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, jr#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> true);

function JournalCache.__default.WriteBackJournalReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, Seq Box)
   : bool;

// #requires axiom for JournalCache.__default.WriteBackJournalReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    jr#0: Seq Box :: 
  { JournalCache.__default.WriteBackJournalReq#requires(k#0, s#0, s'#0, dop#0, vop#0, jr#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock()))
     ==> JournalCache.__default.WriteBackJournalReq#requires(k#0, s#0, s'#0, dop#0, vop#0, jr#0)
       == true);

// definition axiom for JournalCache.__default.WriteBackJournalReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      jr#0: Seq Box :: 
    { JournalCache.__default.WriteBackJournalReq(k#0, s#0, s'#0, dop#0, vop#0, jr#0) } 
    JournalCache.__default.WriteBackJournalReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, jr#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> (JournalCache.Variables.Ready_q(s#0)
           ==> (var j#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                 then JournalCache.Variables.inMemoryJournal(s#0)
                 else JournalCache.Variables.inMemoryJournalFrozen(s#0)); 
            JournalRanges.__default.JournalRangeParses#canCall(jr#0, j#0)
               && (JournalRanges.__default.JournalRangeParses(jr#0, j#0)
                 ==> JournalRanges.__default.JournalRangeLen#canCall(jr#0)
                   && DiskLayout.__default.NumJournalBlocks#canCall())
               && (JournalRanges.__default.JournalRangeLen#canCall(jr#0)
                   && DiskLayout.__default.NumJournalBlocks#canCall()
                   && JournalRanges.__default.JournalRangeLen(jr#0)
                       + JournalCache.Variables.writtenJournalLen(s#0)
                     <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 ==> JournalRanges.__default.JournalRangeLen#canCall(jr#0))
               && (Options.Option.None_q(JournalCache.Variables.superblockWrite(s#0))
                 ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                   && DiskLayout.__default.NumJournalBlocks#canCall())
               && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                   && DiskLayout.__default.NumJournalBlocks#canCall()
                   && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
                     < DiskLayout.__default.NumJournalBlocks()
                 ==> 
                LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
                 ==> DiskLayout.__default.NumJournalBlocks#canCall())
               && ((LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
                     ==> DiskLayout.__default.NumJournalBlocks#canCall())
                   && 
                  LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
                   && JournalCache.Variables.writtenJournalLen(s#0)
                     <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                   && DiskLayout.__default.JournalPosAdd#canCall(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                    JournalCache.Variables.writtenJournalLen(s#0))
                   && (var startPos#0 := DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                        JournalCache.Variables.writtenJournalLen(s#0)); 
                    Lit(true)
                       ==> JournalRanges.__default.JournalRangeLen#canCall(jr#0)
                         && (var writtenJournalLen'#0 := JournalCache.Variables.writtenJournalLen(s#0)
                               + JournalRanges.__default.JournalRangeLen(jr#0); 
                          Lit(true)
                             ==> (var frozenJournalPosition'#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                   then JournalCache.Variables.frozenJournalPosition(s#0)
                                   else writtenJournalLen'#0); 
                              Lit(true)
                                 ==> (var inMemoryJournal'#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                       then Seq#Empty(): Seq Box
                                       else JournalCache.Variables.inMemoryJournal(s#0)); 
                                  Lit(true)
                                     ==> (Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                         ==> (
                                            JournalCache.Variables.Ready_q(s#0)
                                             || JournalCache.Variables.LoadingOther_q(s#0)
                                             || JournalCache.Variables.LoadingSuperblock_q(s#0))
                                           && JournalCache.__default.syncReqs3to2#canCall(JournalCache.Variables.syncReqs(s#0)))
                                       && (!Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                         ==> JournalCache.Variables.Ready_q(s#0)
                                           || JournalCache.Variables.LoadingOther_q(s#0)
                                           || JournalCache.Variables.LoadingSuperblock_q(s#0))
                                       && (var syncReqs'#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                             then JournalCache.__default.syncReqs3to2(JournalCache.Variables.syncReqs(s#0))
                                             else JournalCache.Variables.syncReqs(s#0)); 
                                        Lit(true)
                                           ==> (var inMemoryJournalFrozen'#0 := Lit(Seq#Empty(): Seq Box); 
                                            (JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
                                                 ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0)))
                                               && (JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0))
                                                   && Seq#Equal(JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)), 
                                                    jr#0)
                                                 ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0)))
                                               && (JournalDisk.ReqWriteJournal.ReqWriteJournal_q(JournalDisk.DiskOp.reqWriteJournal(dop#0))
                                                   && JournalDisk.ReqWriteJournal.start(JournalDisk.DiskOp.reqWriteJournal(dop#0))
                                                     == startPos#0
                                                 ==> $IsA#JournalCache.Variables(s'#0)
                                                   && $IsA#JournalCache.Variables((var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                                          (var dt_update#outstandingJournalWrites#0#0 := Set#Union(JournalCache.Variables.outstandingJournalWrites(s#0), 
                                                                                (if Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                                                                                   then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))), 
                                                                                    Options.Option.value(JournalDisk.DiskOp.id2(dop#0)))
                                                                                   else Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))))); 
                                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                                              dt_update#outstandingJournalWrites#0#0, 
                                                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                                        writtenJournalLen'#0, 
                                                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))); 
                                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                                    frozenJournalPosition'#0, 
                                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#0))); 
                                                              (var dt_update#inMemoryJournal#0#0 := inMemoryJournal'#0; 
                                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                                                  dt_update#inMemoryJournal#0#0, 
                                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                                          (var dt_update#inMemoryJournalFrozen#0#0 := inMemoryJournalFrozen'#0; 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                                              dt_update#inMemoryJournalFrozen#0#0, 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#4#0)))); 
                                                      (var dt_update#syncReqs#0#0 := syncReqs'#0; 
                                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#5#0)
                                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                                            dt_update#syncReqs#0#0)
                                                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#0)
                                                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.journalFrontRead(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.journalBackRead(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.journalFront(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.journalBack(dt_update_tmp#5#0), 
                                                              dt_update#syncReqs#0#0)
                                                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.superblock1(dt_update_tmp#5#0), 
                                                              JournalCache.Variables.superblock2(dt_update_tmp#5#0), 
                                                              dt_update#syncReqs#0#0))))))
                                                   && 
                                                  (var dt_update_tmp#0#0 := s#0; 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                                                   && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                        (var dt_update#outstandingJournalWrites#0#0 := Set#Union(JournalCache.Variables.outstandingJournalWrites(s#0), 
                                                              (if Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                                                                 then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))), 
                                                                  Options.Option.value(JournalDisk.DiskOp.id2(dop#0)))
                                                                 else Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))))); 
                                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                            dt_update#outstandingJournalWrites#0#0, 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))
                                                   && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                            (var dt_update#outstandingJournalWrites#0#0 := Set#Union(JournalCache.Variables.outstandingJournalWrites(s#0), 
                                                                  (if Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                                                                     then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))), 
                                                                      Options.Option.value(JournalDisk.DiskOp.id2(dop#0)))
                                                                     else Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))))); 
                                                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                                dt_update#outstandingJournalWrites#0#0, 
                                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                                JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                          writtenJournalLen'#0, 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
                                                   && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                                (var dt_update#outstandingJournalWrites#0#0 := Set#Union(JournalCache.Variables.outstandingJournalWrites(s#0), 
                                                                      (if Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                                                                         then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))), 
                                                                          Options.Option.value(JournalDisk.DiskOp.id2(dop#0)))
                                                                         else Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))))); 
                                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                                    dt_update#outstandingJournalWrites#0#0, 
                                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                              writtenJournalLen'#0, 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#1#0))); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                          frozenJournalPosition'#0, 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0))
                                                   && (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                                    (var dt_update#outstandingJournalWrites#0#0 := Set#Union(JournalCache.Variables.outstandingJournalWrites(s#0), 
                                                                          (if Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                                                                             then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))), 
                                                                              Options.Option.value(JournalDisk.DiskOp.id2(dop#0)))
                                                                             else Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))))); 
                                                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                                        dt_update#outstandingJournalWrites#0#0, 
                                                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                                  writtenJournalLen'#0, 
                                                                  JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                                  JournalCache.Variables.syncReqs(dt_update_tmp#1#0))); 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                              frozenJournalPosition'#0, 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#2#0))); 
                                                        (var dt_update#inMemoryJournal#0#0 := inMemoryJournal'#0; 
                                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                                            dt_update#inMemoryJournal#0#0, 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                                            JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#4#0))))))))))))
         && JournalCache.__default.WriteBackJournalReq(k#0, s#0, s'#0, dop#0, vop#0, jr#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalCache.Variables.Ready_q(s#0)
             && (var j#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                   then JournalCache.Variables.inMemoryJournal(s#0)
                   else JournalCache.Variables.inMemoryJournalFrozen(s#0)); 
              JournalRanges.__default.JournalRangeParses(jr#0, j#0)
                 && JournalRanges.__default.JournalRangeLen(jr#0)
                     + JournalCache.Variables.writtenJournalLen(s#0)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && JournalRanges.__default.JournalRangeLen(jr#0) > 0
                 && Options.Option.None_q(JournalCache.Variables.superblockWrite(s#0))
                 && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
                   < DiskLayout.__default.NumJournalBlocks()
                 && 
                LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
                 && JournalCache.Variables.writtenJournalLen(s#0)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && (var startPos#0 := DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                      JournalCache.Variables.writtenJournalLen(s#0)); 
                  true
                     && (var writtenJournalLen'#0 := JournalCache.Variables.writtenJournalLen(s#0)
                           + JournalRanges.__default.JournalRangeLen(jr#0); 
                      true
                         && (var frozenJournalPosition'#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                               then JournalCache.Variables.frozenJournalPosition(s#0)
                               else writtenJournalLen'#0); 
                          true
                             && (var inMemoryJournal'#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                   then Seq#Empty(): Seq Box
                                   else JournalCache.Variables.inMemoryJournal(s#0)); 
                              true
                                 && (var syncReqs'#0 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
                                       then JournalCache.__default.syncReqs3to2(JournalCache.Variables.syncReqs(s#0))
                                       else JournalCache.Variables.syncReqs(s#0)); 
                                  true
                                     && (var inMemoryJournalFrozen'#0 := Lit(Seq#Empty(): Seq Box); 
                                      JournalDisk.DiskOp.ReqWriteJournalOp_q(dop#0)
                                         && Seq#Equal(JournalDisk.ReqWriteJournal.journal(JournalDisk.DiskOp.reqWriteJournal(dop#0)), 
                                          jr#0)
                                         && JournalDisk.ReqWriteJournal.start(JournalDisk.DiskOp.reqWriteJournal(dop#0))
                                           == startPos#0
                                         && JournalCache.Variables#Equal(s'#0, 
                                          (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                                (var dt_update#outstandingJournalWrites#0#0 := Set#Union(JournalCache.Variables.outstandingJournalWrites(s#0), 
                                                                      (if Options.Option.Some_q(JournalDisk.DiskOp.id2(dop#0))
                                                                         then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))), 
                                                                          Options.Option.value(JournalDisk.DiskOp.id2(dop#0)))
                                                                         else Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id1(dop#0))))); 
                                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                                    dt_update#outstandingJournalWrites#0#0, 
                                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                              writtenJournalLen'#0, 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#1#0))); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                          frozenJournalPosition'#0, 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0))); 
                                                    (var dt_update#inMemoryJournal#0#0 := inMemoryJournal'#0; 
                                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                                        dt_update#inMemoryJournal#0#0, 
                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                                (var dt_update#inMemoryJournalFrozen#0#0 := inMemoryJournalFrozen'#0; 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                                    dt_update#inMemoryJournalFrozen#0#0, 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#4#0)))); 
                                            (var dt_update#syncReqs#0#0 := syncReqs'#0; 
                                              (if JournalCache.Variables.Ready_q(dt_update_tmp#5#0)
                                                 then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                                  dt_update#syncReqs#0#0)
                                                 else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#0)
                                                   then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.journalBackRead(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.journalFront(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.journalBack(dt_update_tmp#5#0), 
                                                    dt_update#syncReqs#0#0)
                                                   else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.superblock1(dt_update_tmp#5#0), 
                                                    JournalCache.Variables.superblock2(dt_update_tmp#5#0), 
                                                    dt_update#syncReqs#0#0)))))))))))))));

// definition axiom for JournalCache.__default.WriteBackJournalReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      jr#0: Seq Box :: 
    {:weight 3} { JournalCache.__default.WriteBackJournalReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(jr#0)) } 
    JournalCache.__default.WriteBackJournalReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(jr#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(jr#0, TSeq(Tclass.JournalRanges.JournalBlock())))
       ==> (Lit(JournalCache.Variables.Ready_q(Lit(s#0)))
           ==> (var j#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                 then JournalCache.Variables.inMemoryJournal(Lit(s#0))
                 else JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0))); 
            JournalRanges.__default.JournalRangeParses#canCall(Lit(jr#0), j#1)
               && (JournalRanges.__default.JournalRangeParses(Lit(jr#0), j#1)
                 ==> JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0))
                   && DiskLayout.__default.NumJournalBlocks#canCall())
               && (JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0))
                   && DiskLayout.__default.NumJournalBlocks#canCall()
                   && LitInt(JournalRanges.__default.JournalRangeLen(Lit(jr#0))
                         + JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                     <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 ==> JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0)))
               && (Lit(Options.Option.None_q(Lit(JournalCache.Variables.superblockWrite(Lit(s#0)))))
                 ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                   && DiskLayout.__default.NumJournalBlocks#canCall())
               && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                   && DiskLayout.__default.NumJournalBlocks#canCall()
                   && Lit(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                       < DiskLayout.__default.NumJournalBlocks())
                 ==> 
                LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                 ==> DiskLayout.__default.NumJournalBlocks#canCall())
               && ((LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                     ==> DiskLayout.__default.NumJournalBlocks#canCall())
                   && 
                  LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                   && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                     <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                   && DiskLayout.__default.JournalPosAdd#canCall(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
                   && (var startPos#1 := LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                          LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))); 
                    Lit(true)
                       ==> JournalRanges.__default.JournalRangeLen#canCall(Lit(jr#0))
                         && (var writtenJournalLen'#1 := LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                 + JournalRanges.__default.JournalRangeLen(Lit(jr#0))); 
                          Lit(true)
                             ==> (var frozenJournalPosition'#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                   then JournalCache.Variables.frozenJournalPosition(Lit(s#0))
                                   else writtenJournalLen'#1); 
                              Lit(true)
                                 ==> (var inMemoryJournal'#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                       then Seq#Empty(): Seq Box
                                       else JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                                  Lit(true)
                                     ==> (Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                         ==> (
                                            JournalCache.Variables.Ready_q(Lit(s#0))
                                             || JournalCache.Variables.LoadingOther_q(Lit(s#0))
                                             || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
                                           && JournalCache.__default.syncReqs3to2#canCall(Lit(JournalCache.Variables.syncReqs(Lit(s#0)))))
                                       && (!Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                         ==> JournalCache.Variables.Ready_q(Lit(s#0))
                                           || JournalCache.Variables.LoadingOther_q(Lit(s#0))
                                           || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
                                       && (var syncReqs'#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                             then JournalCache.__default.syncReqs3to2(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))
                                             else JournalCache.Variables.syncReqs(Lit(s#0))); 
                                        Lit(true)
                                           ==> (var inMemoryJournalFrozen'#1 := Lit(Seq#Empty(): Seq Box); 
                                            (Lit(JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0)))
                                                 ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0)))))
                                               && (JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))
                                                   && Seq#Equal(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0)))), 
                                                    jr#0)
                                                 ==> JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0)))))
                                               && (JournalDisk.ReqWriteJournal.ReqWriteJournal_q(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0))))
                                                   && LitInt(JournalDisk.ReqWriteJournal.start(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0)))))
                                                     == startPos#1
                                                 ==> $IsA#JournalCache.Variables(Lit(s'#0))
                                                   && $IsA#JournalCache.Variables((var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                                          (var dt_update#outstandingJournalWrites#0#1 := Set#Union(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                                                                                (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                                                                                   then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))), 
                                                                                    $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)))
                                                                                   else Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))))); 
                                                                            #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                                              dt_update#outstandingJournalWrites#0#1, 
                                                                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                                                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                                        writtenJournalLen'#1, 
                                                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))); 
                                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                                    frozenJournalPosition'#1, 
                                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#1))); 
                                                              (var dt_update#inMemoryJournal#0#1 := inMemoryJournal'#1; 
                                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                                                  dt_update#inMemoryJournal#0#1, 
                                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                                          (var dt_update#inMemoryJournalFrozen#0#1 := inMemoryJournalFrozen'#1; 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                                              dt_update#inMemoryJournalFrozen#0#1, 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#4#1)))); 
                                                      (var dt_update#syncReqs#0#1 := syncReqs'#1; 
                                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#5#1)
                                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                                            dt_update#syncReqs#0#1)
                                                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#1)
                                                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.journalFrontRead(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.journalBackRead(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.journalFront(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.journalBack(dt_update_tmp#5#1), 
                                                              dt_update#syncReqs#0#1)
                                                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.superblock1(dt_update_tmp#5#1), 
                                                              JournalCache.Variables.superblock2(dt_update_tmp#5#1), 
                                                              dt_update#syncReqs#0#1))))))
                                                   && 
                                                  (var dt_update_tmp#0#1 := Lit(s#0); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                                                   && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                        (var dt_update#outstandingJournalWrites#0#1 := Set#Union(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                                                              (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                                                                 then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))), 
                                                                  $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)))
                                                                 else Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))))); 
                                                          #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                            dt_update#outstandingJournalWrites#0#1, 
                                                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))
                                                   && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                            (var dt_update#outstandingJournalWrites#0#1 := Set#Union(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                                                                  (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                                                                     then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))), 
                                                                      $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)))
                                                                     else Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))))); 
                                                              #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                                dt_update#outstandingJournalWrites#0#1, 
                                                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                          writtenJournalLen'#1, 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
                                                   && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                                (var dt_update#outstandingJournalWrites#0#1 := Set#Union(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                                                                      (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                                                                         then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))), 
                                                                          $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)))
                                                                         else Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))))); 
                                                                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                                    dt_update#outstandingJournalWrites#0#1, 
                                                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                              writtenJournalLen'#1, 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#1#1))); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                          frozenJournalPosition'#1, 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#1))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1))
                                                   && (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                                    (var dt_update#outstandingJournalWrites#0#1 := Set#Union(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                                                                          (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                                                                             then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))), 
                                                                              $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)))
                                                                             else Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))))); 
                                                                      #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                                        dt_update#outstandingJournalWrites#0#1, 
                                                                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                                  writtenJournalLen'#1, 
                                                                  JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                                  JournalCache.Variables.syncReqs(dt_update_tmp#1#1))); 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                              frozenJournalPosition'#1, 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#2#1))); 
                                                        (var dt_update#inMemoryJournal#0#1 := inMemoryJournal'#1; 
                                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                                            dt_update#inMemoryJournal#0#1, 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                                            JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                                    JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#4#1))))))))))))
         && JournalCache.__default.WriteBackJournalReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(jr#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalCache.Variables.Ready_q(Lit(s#0))
             && (var j#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                   then JournalCache.Variables.inMemoryJournal(Lit(s#0))
                   else JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0))); 
              JournalRanges.__default.JournalRangeParses(Lit(jr#0), j#1)
                 && LitInt(JournalRanges.__default.JournalRangeLen(Lit(jr#0))
                       + JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && JournalRanges.__default.JournalRangeLen(Lit(jr#0)) > 0
                 && Options.Option.None_q(Lit(JournalCache.Variables.superblockWrite(Lit(s#0))))
                 && SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                   < DiskLayout.__default.NumJournalBlocks()
                 && 
                LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                 && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && (var startPos#1 := LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                        LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))); 
                  true
                     && (var writtenJournalLen'#1 := LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                             + JournalRanges.__default.JournalRangeLen(Lit(jr#0))); 
                      true
                         && (var frozenJournalPosition'#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                               then JournalCache.Variables.frozenJournalPosition(Lit(s#0))
                               else writtenJournalLen'#1); 
                          true
                             && (var inMemoryJournal'#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                   then Seq#Empty(): Seq Box
                                   else JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                              true
                                 && (var syncReqs'#1 := (if Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
                                       then JournalCache.__default.syncReqs3to2(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))
                                       else JournalCache.Variables.syncReqs(Lit(s#0))); 
                                  true
                                     && (var inMemoryJournalFrozen'#1 := Lit(Seq#Empty(): Seq Box); 
                                      JournalDisk.DiskOp.ReqWriteJournalOp_q(Lit(dop#0))
                                         && Seq#Equal(JournalDisk.ReqWriteJournal.journal(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0)))), 
                                          jr#0)
                                         && LitInt(JournalDisk.ReqWriteJournal.start(Lit(JournalDisk.DiskOp.reqWriteJournal(Lit(dop#0)))))
                                           == startPos#1
                                         && JournalCache.Variables#Equal(s'#0, 
                                          (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                                (var dt_update#outstandingJournalWrites#0#1 := Set#Union(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                                                                      (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))
                                                                         then Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))), 
                                                                          $Box(LitInt($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.id2(Lit(dop#0))))): int)))
                                                                         else Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id1(Lit(dop#0))))))); 
                                                                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                                    dt_update#outstandingJournalWrites#0#1, 
                                                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                              writtenJournalLen'#1, 
                                                              JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                              JournalCache.Variables.syncReqs(dt_update_tmp#1#1))); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                          frozenJournalPosition'#1, 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#1))); 
                                                    (var dt_update#inMemoryJournal#0#1 := inMemoryJournal'#1; 
                                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                                        dt_update#inMemoryJournal#0#1, 
                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                                (var dt_update#inMemoryJournalFrozen#0#1 := inMemoryJournalFrozen'#1; 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                                    dt_update#inMemoryJournalFrozen#0#1, 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#4#1)))); 
                                            (var dt_update#syncReqs#0#1 := syncReqs'#1; 
                                              (if JournalCache.Variables.Ready_q(dt_update_tmp#5#1)
                                                 then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                                  dt_update#syncReqs#0#1)
                                                 else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#1)
                                                   then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.journalBackRead(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.journalFront(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.journalBack(dt_update_tmp#5#1), 
                                                    dt_update#syncReqs#0#1)
                                                   else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.superblock1(dt_update_tmp#5#1), 
                                                    JournalCache.Variables.superblock2(dt_update_tmp#5#1), 
                                                    dt_update#syncReqs#0#1)))))))))))))));

// function declaration for JournalCache._default.WriteBackJournalResp
function JournalCache.__default.WriteBackJournalResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.WriteBackJournalResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.WriteBackJournalResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackJournalResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackJournalResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.WriteBackJournalResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.WriteBackJournalResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.WriteBackJournalResp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.WriteBackJournalResp#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.WriteBackJournalResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackJournalResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackJournalResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalCache.Variables.outstandingJournalWrites(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingJournalWrites#0#0 := Set#Difference(JournalCache.Variables.outstandingJournalWrites(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                    dt_update#outstandingJournalWrites#0#0, 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0)))
         && JournalCache.__default.WriteBackJournalResp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalCache.Variables.Ready_q(s#0)
             && JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
             && JournalCache.Variables.outstandingJournalWrites(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))]
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingJournalWrites#0#0 := Set#Difference(JournalCache.Variables.outstandingJournalWrites(s#0), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(JournalDisk.DiskOp.id(dop#0)))); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                    dt_update#outstandingJournalWrites#0#0, 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))));

// definition axiom for JournalCache.__default.WriteBackJournalResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.WriteBackJournalResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.WriteBackJournalResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingJournalWrites#0#1 := Set#Difference(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                    dt_update#outstandingJournalWrites#0#1, 
                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1)))
         && JournalCache.__default.WriteBackJournalResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalCache.Variables.Ready_q(Lit(s#0))
             && JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0))
             && Lit(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))]
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingJournalWrites#0#1 := Set#Difference(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), 
                      Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                    dt_update#outstandingJournalWrites#0#1, 
                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))))));

// function declaration for JournalCache._default.WriteBackSuperblockReq_AdvanceLog
function JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLog
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLog
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalDisk.DiskOp.which(dop#0)
             == (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0)
           ==> 
          LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && ((LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
             && JournalCache.Variables.writtenJournalLen(s#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && JournalCache.__default.IncrementSuperblockCounter#canCall(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0)))
             && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && (var newSuperblock#0 := #SectorType.Superblock.Superblock(JournalCache.__default.IncrementSuperblockCounter(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0))), 
                  SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                  JournalCache.Variables.writtenJournalLen(s#0), 
                  SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0))); 
              $IsA#SectorType.Superblock(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))
                 && $IsA#SectorType.Superblock(newSuperblock#0)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.DiskOp.reqWriteSuperblock(dop#0))
                 && (SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.DiskOp.reqWriteSuperblock(dop#0)), 
                    newSuperblock#0)
                   ==> $IsA#JournalCache.Variables(s'#0)
                     && $IsA#JournalCache.Variables((var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                    dt_update#newSuperblock#0#0, 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                            (var dt_update#superblockWrite#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                dt_update#superblockWrite#0#0, 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                        (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitAdvanceLog()); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                            dt_update#commitStatus#0#0, 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))))
                     && 
                    (var dt_update_tmp#0#0 := s#0; 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                     && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                              dt_update#newSuperblock#0#0, 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))
                     && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                  dt_update#newSuperblock#0#0, 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                          (var dt_update#superblockWrite#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                              dt_update#superblockWrite#0#0, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0)))))
         && JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalCache.Variables.Ready_q(s#0)
             && JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
             && JournalCache.CommitStatus.CommitNone_q(JournalCache.Variables.commitStatus(s#0))
             && Set#Equal(JournalCache.Variables.outstandingJournalWrites(s#0), Set#Empty(): Set Box)
             && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
             && JournalDisk.DiskOp.which(dop#0)
               == (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0)
             && 
            LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
             && JournalCache.Variables.writtenJournalLen(s#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (var newSuperblock#0 := #SectorType.Superblock.Superblock(JournalCache.__default.IncrementSuperblockCounter(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0))), 
                  SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                  JournalCache.Variables.writtenJournalLen(s#0), 
                  SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0))); 
              SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.DiskOp.reqWriteSuperblock(dop#0)), 
                  newSuperblock#0)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                dt_update#newSuperblock#0#0, 
                                JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                        (var dt_update#superblockWrite#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                            dt_update#superblockWrite#0#0, 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                    (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitAdvanceLog()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                        dt_update#commitStatus#0#0, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#2#0))))))));

// definition axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLog for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (LitInt(JournalDisk.DiskOp.which(Lit(dop#0)))
             == (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
               then 1
               else 0)
           ==> 
          LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && ((LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && JournalCache.__default.IncrementSuperblockCounter#canCall(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
             && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (var newSuperblock#1 := Lit(#SectorType.Superblock.Superblock(LitInt(JournalCache.__default.IncrementSuperblockCounter(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))), 
                    LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))), 
                    Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))); 
              $IsA#SectorType.Superblock(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0))))))
                 && $IsA#SectorType.Superblock(newSuperblock#1)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0))))
                 && (SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))), 
                    newSuperblock#1)
                   ==> $IsA#JournalCache.Variables(Lit(s'#0))
                     && $IsA#JournalCache.Variables((var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#newSuperblock#0#1 := #Options.Option.Some($Box(newSuperblock#1)); 
                                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                    dt_update#newSuperblock#0#1, 
                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                            (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                dt_update#superblockWrite#0#1, 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                        (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitAdvanceLog()); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                            dt_update#commitStatus#0#1, 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))
                     && 
                    (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                     && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#newSuperblock#0#1 := #Options.Option.Some($Box(newSuperblock#1)); 
                            #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                              dt_update#newSuperblock#0#1, 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))
                     && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              (var dt_update#newSuperblock#0#1 := #Options.Option.Some($Box(newSuperblock#1)); 
                                #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                  dt_update#newSuperblock#0#1, 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                          (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                              dt_update#superblockWrite#0#1, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1)))))
         && JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalCache.Variables.Ready_q(Lit(s#0))
             && JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0))
             && JournalCache.CommitStatus.CommitNone_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
             && Set#Equal(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), Set#Empty(): Set Box)
             && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
             && LitInt(JournalDisk.DiskOp.which(Lit(dop#0)))
               == (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                 then 1
                 else 0)
             && 
            LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (var newSuperblock#1 := Lit(#SectorType.Superblock.Superblock(LitInt(JournalCache.__default.IncrementSuperblockCounter(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))), 
                    LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))), 
                    Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))); 
              SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))), 
                  newSuperblock#1)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.Some($Box(newSuperblock#1))); 
                              Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                  dt_update#newSuperblock#0#1, 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                        (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                            dt_update#superblockWrite#0#1, 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                    (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitAdvanceLog()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                        dt_update#commitStatus#0#1, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#2#1))))))));

// function declaration for JournalCache._default.WriteBackSuperblockReq_AdvanceLocation
function JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalDisk.DiskOp.which(dop#0)
             == (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0)
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && (LitInt(0)
                 <= SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && (LitInt(0)
                 <= SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
             && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               < DiskLayout.__default.NumJournalBlocks()
           ==> 
          JournalCache.Variables.frozenJournalPosition(s#0)
             <= JournalCache.Variables.writtenJournalLen(s#0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && ((JournalCache.Variables.frozenJournalPosition(s#0)
                 <= JournalCache.Variables.writtenJournalLen(s#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= JournalCache.Variables.frozenJournalPosition(s#0)
             && JournalCache.Variables.frozenJournalPosition(s#0)
               <= JournalCache.Variables.writtenJournalLen(s#0)
             && JournalCache.Variables.writtenJournalLen(s#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && JournalCache.__default.IncrementSuperblockCounter#canCall(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0)))
             && 
            SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.JournalPosAdd#canCall(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
              JournalCache.Variables.frozenJournalPosition(s#0))
             && (var newSuperblock#0 := #SectorType.Superblock.Superblock(JournalCache.__default.IncrementSuperblockCounter(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0))), 
                  DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                    JournalCache.Variables.frozenJournalPosition(s#0)), 
                  JournalCache.Variables.writtenJournalLen(s#0)
                     - JournalCache.Variables.frozenJournalPosition(s#0), 
                  $Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType); 
              $IsA#SectorType.Superblock(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.DiskOp.reqWriteSuperblock(dop#0)))
                 && $IsA#SectorType.Superblock(newSuperblock#0)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(JournalDisk.DiskOp.reqWriteSuperblock(dop#0))
                 && (SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.DiskOp.reqWriteSuperblock(dop#0)), 
                    newSuperblock#0)
                   ==> $IsA#JournalCache.Variables(s'#0)
                     && $IsA#JournalCache.Variables((var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                    dt_update#newSuperblock#0#0, 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                            (var dt_update#superblockWrite#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                dt_update#superblockWrite#0#0, 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                        (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitAdvanceLocation()); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                            dt_update#commitStatus#0#0, 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))))
                     && 
                    (var dt_update_tmp#0#0 := s#0; 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                     && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                              dt_update#newSuperblock#0#0, 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))
                     && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                  dt_update#newSuperblock#0#0, 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                          (var dt_update#superblockWrite#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                              dt_update#superblockWrite#0#0, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0)))))
         && JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalCache.Variables.Ready_q(s#0)
             && JournalDisk.DiskOp.ReqWriteSuperblockOp_q(dop#0)
             && Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
             && JournalCache.CommitStatus.CommitNone_q(JournalCache.Variables.commitStatus(s#0))
             && Set#Equal(JournalCache.Variables.outstandingJournalWrites(s#0), Set#Empty(): Set Box)
             && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
             && JournalDisk.DiskOp.which(dop#0)
               == (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0)
             && 
            LitInt(0)
               <= SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
             && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               < DiskLayout.__default.NumJournalBlocks()
             && 
            LitInt(0) <= JournalCache.Variables.frozenJournalPosition(s#0)
             && JournalCache.Variables.frozenJournalPosition(s#0)
               <= JournalCache.Variables.writtenJournalLen(s#0)
             && JournalCache.Variables.writtenJournalLen(s#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (var newSuperblock#0 := #SectorType.Superblock.Superblock(JournalCache.__default.IncrementSuperblockCounter(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0))), 
                  DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                    JournalCache.Variables.frozenJournalPosition(s#0)), 
                  JournalCache.Variables.writtenJournalLen(s#0)
                     - JournalCache.Variables.frozenJournalPosition(s#0), 
                  $Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType); 
              SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(JournalDisk.DiskOp.reqWriteSuperblock(dop#0)), 
                  newSuperblock#0)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#newSuperblock#0#0 := #Options.Option.Some($Box(newSuperblock#0)); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                dt_update#newSuperblock#0#0, 
                                JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                        (var dt_update#superblockWrite#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                            dt_update#superblockWrite#0#0, 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                    (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitAdvanceLocation()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                        dt_update#commitStatus#0#0, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#2#0))))))));

// definition axiom for JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (LitInt(JournalDisk.DiskOp.which(Lit(dop#0)))
             == (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
               then 1
               else 0)
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (LitInt(0)
                 <= LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && DiskLayout.__default.NumJournalBlocks#canCall()))
         && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (LitInt(0)
                 <= LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0)
               <= LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
               < DiskLayout.__default.NumJournalBlocks()
           ==> 
          LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
             <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && ((LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                 <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
             && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
               <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && JournalCache.__default.IncrementSuperblockCounter#canCall(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
             && 
            SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.JournalPosAdd#canCall(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
              LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))))
             && (var newSuperblock#1 := Lit(#SectorType.Superblock.Superblock(LitInt(JournalCache.__default.IncrementSuperblockCounter(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))), 
                    LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                        LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))))), 
                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                         - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                    Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType))); 
              $IsA#SectorType.Superblock(Lit(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0))))))
                 && $IsA#SectorType.Superblock(newSuperblock#1)
                 && JournalDisk.ReqWriteSuperblock.ReqWriteSuperblock_q(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0))))
                 && (SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))), 
                    newSuperblock#1)
                   ==> $IsA#JournalCache.Variables(Lit(s'#0))
                     && $IsA#JournalCache.Variables((var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#newSuperblock#0#1 := #Options.Option.Some($Box(newSuperblock#1)); 
                                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                    dt_update#newSuperblock#0#1, 
                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                            (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                dt_update#superblockWrite#0#1, 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                        (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitAdvanceLocation()); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                            dt_update#commitStatus#0#1, 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))
                     && 
                    (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                     && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#newSuperblock#0#1 := #Options.Option.Some($Box(newSuperblock#1)); 
                            #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                              dt_update#newSuperblock#0#1, 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))
                     && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              (var dt_update#newSuperblock#0#1 := #Options.Option.Some($Box(newSuperblock#1)); 
                                #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                  dt_update#newSuperblock#0#1, 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))); 
                          (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                              dt_update#superblockWrite#0#1, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1)))))
         && JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalCache.Variables.Ready_q(Lit(s#0))
             && JournalDisk.DiskOp.ReqWriteSuperblockOp_q(Lit(dop#0))
             && Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
             && JournalCache.CommitStatus.CommitNone_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
             && Set#Equal(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), Set#Empty(): Set Box)
             && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
             && LitInt(JournalDisk.DiskOp.which(Lit(dop#0)))
               == (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                 then 1
                 else 0)
             && 
            LitInt(0)
               <= LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
               < DiskLayout.__default.NumJournalBlocks()
             && 
            LitInt(0) <= LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
             && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
               <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (var newSuperblock#1 := Lit(#SectorType.Superblock.Superblock(LitInt(JournalCache.__default.IncrementSuperblockCounter(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))), 
                    LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                        LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))))), 
                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                         - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                    Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType))); 
              SectorType.Superblock#Equal(JournalDisk.ReqWriteSuperblock.superblock(Lit(JournalDisk.DiskOp.reqWriteSuperblock(Lit(dop#0)))), 
                  newSuperblock#1)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.Some($Box(newSuperblock#1))); 
                              Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                  dt_update#newSuperblock#0#1, 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                        (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                            dt_update#superblockWrite#0#1, 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                    (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitAdvanceLocation()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                        dt_update#commitStatus#0#1, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#2#1))))))));

// function declaration for JournalCache._default.WriteBackSuperblockResp
function JournalCache.__default.WriteBackSuperblockResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.WriteBackSuperblockResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.WriteBackSuperblockResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackSuperblockResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.WriteBackSuperblockResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.WriteBackSuperblockResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.WriteBackSuperblockResp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.WriteBackSuperblockResp#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.WriteBackSuperblockResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.WriteBackSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.WriteBackSuperblockResp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
           ==> $IsA#Options.Option(JournalCache.Variables.superblockWrite(s#0)))
         && (JournalCache.Variables.Ready_q(s'#0)
           ==> 
          JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
           ==> 
          ViewOp.VOp.CleanUpOp_q(vop#0)
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#9#0 := (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                    (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                        dt_update#superblockWrite#0#0, 
                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                      dt_update#superblock#0#0, 
                                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                     else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                      JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                            (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                dt_update#newSuperblock#0#0, 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                            JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                            (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                           else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                            (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                    (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                          dt_update#syncReqs#0#0)
                                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                            dt_update#syncReqs#0#0)
                                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                            JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                            JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                            dt_update#syncReqs#0#0))))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                  JournalCache.Variables.writtenJournalLen(s#0)
                                     - JournalCache.Variables.frozenJournalPosition(s#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                              LitInt(0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                        (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                            JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                    (var dt_update#isFrozen#0#0 := Lit(false); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#0), 
                        dt_update#isFrozen#0#0, 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#8#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#8#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#8#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#8#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#8#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#8#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#8#0)))); 
                (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#0), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#9#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#9#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#9#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#9#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#9#0), 
                    dt_update#commitStatus#0#0, 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#9#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#9#0)))))
             && 
            (var dt_update_tmp#0#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                  (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                      dt_update#superblockWrite#0#0, 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0)))
             && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                      (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                          dt_update#superblockWrite#0#0, 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                  (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                        dt_update#superblock#0#0, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
             && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                              dt_update#superblockWrite#0#0, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                            dt_update#superblock#0#0, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                  (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                      dt_update#newSuperblock#0#0, 
                      JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0)))
             && 
            (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && JournalCache.__default.syncReqs2to1#canCall(JournalCache.Variables.syncReqs(s#0))
             && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                  (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                      dt_update#superblockWrite#0#0, 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                              (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                    dt_update#superblock#0#0, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                    JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                    JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                    JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                          (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                              dt_update#newSuperblock#0#0, 
                              JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                  (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                        dt_update#syncReqs#0#0)
                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                          dt_update#syncReqs#0#0)
                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                          dt_update#syncReqs#0#0))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#5#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#5#0))
             && (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                      (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                          dt_update#superblockWrite#0#0, 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                  (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                        dt_update#superblock#0#0, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                              (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                  dt_update#newSuperblock#0#0, 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                          (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                              (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                             else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                              (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                              JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                              JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                      (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                            dt_update#syncReqs#0#0)
                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                              dt_update#syncReqs#0#0)
                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                              JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                              JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                              dt_update#syncReqs#0#0))))); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                    JournalCache.Variables.writtenJournalLen(s#0)
                       - JournalCache.Variables.frozenJournalPosition(s#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#6#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#6#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#6#0))
             && (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                          (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                              dt_update#superblockWrite#0#0, 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                      (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                            dt_update#superblock#0#0, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                  (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                      dt_update#newSuperblock#0#0, 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                              (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                 then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                  (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                 else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                  (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                          (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                dt_update#syncReqs#0#0)
                               else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                 then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                  dt_update#syncReqs#0#0)
                                 else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                  JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                  JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                  JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                  dt_update#syncReqs#0#0))))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                        JournalCache.Variables.writtenJournalLen(s#0)
                           - JournalCache.Variables.frozenJournalPosition(s#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                    LitInt(0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#7#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#7#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#7#0))
             && (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                              (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                  dt_update#superblockWrite#0#0, 
                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                          (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                dt_update#superblock#0#0, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                               else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                      (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                          dt_update#newSuperblock#0#0, 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                      (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                     else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                      (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                              (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                    dt_update#syncReqs#0#0)
                                   else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                     then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                      dt_update#syncReqs#0#0)
                                     else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                      JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                      JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                      JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                      dt_update#syncReqs#0#0))))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                            JournalCache.Variables.writtenJournalLen(s#0)
                               - JournalCache.Variables.frozenJournalPosition(s#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                        LitInt(0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                  (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                      JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#8#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#8#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#8#0))
             && (var dt_update_tmp#9#0 := (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                  (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                      dt_update#superblockWrite#0#0, 
                                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                              (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                    dt_update#superblock#0#0, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                          (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                              dt_update#newSuperblock#0#0, 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                  (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                        JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                        dt_update#syncReqs#0#0)
                                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                          dt_update#syncReqs#0#0)
                                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                          JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                          JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                          dt_update#syncReqs#0#0))))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                JournalCache.Variables.writtenJournalLen(s#0)
                                   - JournalCache.Variables.frozenJournalPosition(s#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                            LitInt(0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                      (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                          JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                  (var dt_update#isFrozen#0#0 := Lit(false); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#0), 
                      dt_update#isFrozen#0#0, 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#8#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#8#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#8#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#8#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#8#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#8#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#8#0)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#9#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#9#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#9#0)))
         && ((JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> 
              ViewOp.VOp.CleanUpOp_q(vop#0)
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#9#0 := (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                        (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                            dt_update#superblockWrite#0#0, 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                    (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                          dt_update#superblock#0#0, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                                (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                    dt_update#newSuperblock#0#0, 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                                JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                        (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                              dt_update#syncReqs#0#0)
                                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                                dt_update#syncReqs#0#0)
                                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                                JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                                JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                                dt_update#syncReqs#0#0))))); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                      JournalCache.Variables.writtenJournalLen(s#0)
                                         - JournalCache.Variables.frozenJournalPosition(s#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                                  LitInt(0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                            (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                                JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                        (var dt_update#isFrozen#0#0 := Lit(false); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#0), 
                            dt_update#isFrozen#0#0, 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#8#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#8#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#8#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#8#0)))); 
                    (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#9#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#9#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#9#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#9#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#9#0), 
                        dt_update#commitStatus#0#0, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#9#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#9#0)))))
                 && 
                (var dt_update_tmp#0#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                 && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                      (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                          dt_update#superblockWrite#0#0, 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                  (JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))
                     && (!JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0)))
                 && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                              dt_update#superblockWrite#0#0, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                            dt_update#superblock#0#0, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
                 && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                  dt_update#superblockWrite#0#0, 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                          (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                dt_update#superblock#0#0, 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                               else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                      (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                          dt_update#newSuperblock#0#0, 
                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                  (JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0))
                     && (!JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0)))
                 && 
                (
                  JournalCache.Variables.Ready_q(s#0)
                   || JournalCache.Variables.LoadingOther_q(s#0)
                   || JournalCache.Variables.LoadingSuperblock_q(s#0))
                 && JournalCache.__default.syncReqs2to1#canCall(JournalCache.Variables.syncReqs(s#0))
                 && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                      (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                          dt_update#superblockWrite#0#0, 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                  (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                        dt_update#superblock#0#0, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                              (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                  dt_update#newSuperblock#0#0, 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                          (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                              (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                             else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                              (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                              JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                              JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                      (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                            dt_update#syncReqs#0#0)
                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                              JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                              dt_update#syncReqs#0#0)
                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                              JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                              JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                              dt_update#syncReqs#0#0))))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#5#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#5#0))
                 && (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                          (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                              dt_update#superblockWrite#0#0, 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                      (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                            dt_update#superblock#0#0, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                  (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                      dt_update#newSuperblock#0#0, 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                              (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                 then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                  (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                 else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                  (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                          (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                dt_update#syncReqs#0#0)
                               else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                 then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                  dt_update#syncReqs#0#0)
                                 else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                  JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                  JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                  JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                  dt_update#syncReqs#0#0))))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                        JournalCache.Variables.writtenJournalLen(s#0)
                           - JournalCache.Variables.frozenJournalPosition(s#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#6#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#6#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#6#0))
                 && (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                              (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                  dt_update#superblockWrite#0#0, 
                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                  JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                          (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                dt_update#superblock#0#0, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                               else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                      (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                          dt_update#newSuperblock#0#0, 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                      (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                     else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                      (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                              (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                    dt_update#syncReqs#0#0)
                                   else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                     then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                      dt_update#syncReqs#0#0)
                                     else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                      JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                      JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                      JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                      dt_update#syncReqs#0#0))))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                            JournalCache.Variables.writtenJournalLen(s#0)
                               - JournalCache.Variables.frozenJournalPosition(s#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                        LitInt(0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#7#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#7#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#7#0))
                 && (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                  (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                      dt_update#superblockWrite#0#0, 
                                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                              (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                    dt_update#superblock#0#0, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                          (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                              dt_update#newSuperblock#0#0, 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                          JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                  (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                        JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                        dt_update#syncReqs#0#0)
                                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                          dt_update#syncReqs#0#0)
                                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                          JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                          JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                          dt_update#syncReqs#0#0))))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                JournalCache.Variables.writtenJournalLen(s#0)
                                   - JournalCache.Variables.frozenJournalPosition(s#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                            LitInt(0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                      (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                          JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#8#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#8#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#8#0))
                 && (var dt_update_tmp#9#0 := (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                      (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                          dt_update#superblockWrite#0#0, 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                  (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                        dt_update#superblock#0#0, 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                              (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                  JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                  dt_update#newSuperblock#0#0, 
                                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                              (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                             else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                              (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                              JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                              JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                              JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                              JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                      (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                            JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                            dt_update#syncReqs#0#0)
                                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                              JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                              JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                              JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                              dt_update#syncReqs#0#0)
                                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                              dt_update#syncReqs#0#0))))); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                    JournalCache.Variables.writtenJournalLen(s#0)
                                       - JournalCache.Variables.frozenJournalPosition(s#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                                LitInt(0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                          (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                              JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                      (var dt_update#isFrozen#0#0 := Lit(false); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#0), 
                          dt_update#isFrozen#0#0, 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#8#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#8#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#8#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#8#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#8#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#8#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#8#0)))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#9#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#9#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#9#0)))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> ViewOp.VOp.CleanUpOp_q(vop#0)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#9#0 := (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                        (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                            dt_update#superblockWrite#0#0, 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                    (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                          dt_update#superblock#0#0, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                                (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                    dt_update#newSuperblock#0#0, 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                                JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                        (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                              dt_update#syncReqs#0#0)
                                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                                dt_update#syncReqs#0#0)
                                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                                JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                                JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                                dt_update#syncReqs#0#0))))); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                      JournalCache.Variables.writtenJournalLen(s#0)
                                         - JournalCache.Variables.frozenJournalPosition(s#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                                  LitInt(0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                            (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                                JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                        (var dt_update#isFrozen#0#0 := Lit(false); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#0), 
                            dt_update#isFrozen#0#0, 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#8#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#8#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#8#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#8#0)))); 
                    (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#9#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#9#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#9#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#9#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#9#0), 
                        dt_update#commitStatus#0#0, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#9#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#9#0))))))
           ==> 
          JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
           ==> 
          ViewOp.VOp.JournalInternalOp_q(vop#0)
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#15#0 := (var dt_update_tmp#14#0 := (var dt_update_tmp#13#0 := (var dt_update_tmp#12#0 := (var dt_update_tmp#11#0 := (var dt_update_tmp#10#0 := s#0; 
                                    (var dt_update#superblockWrite#1#0 := Lit(#Options.Option.None()); 
                                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#10#0), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#10#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#0), 
                                        dt_update#superblockWrite#1#0, 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#10#0), 
                                        JournalCache.Variables.superblock(dt_update_tmp#10#0), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#10#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#10#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#10#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#10#0)))); 
                                (var dt_update#superblock#1#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#11#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#11#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#11#0), 
                                      dt_update#superblock#1#0, 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#11#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#11#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#11#0))
                                     else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#0, 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#11#0), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#11#0), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#11#0), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#11#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#11#0))))); 
                            (var dt_update#newSuperblock#1#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#12#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#12#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#12#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#12#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#12#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#12#0), 
                                dt_update#newSuperblock#1#0, 
                                JournalCache.Variables.syncReqs(dt_update_tmp#12#0)))); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#13#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#13#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#13#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#13#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#13#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#13#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#13#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#13#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#13#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#13#0), 
                            (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#13#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#13#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#13#0))
                           else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#13#0), 
                            (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#13#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#13#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#13#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#13#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#13#0)))); 
                    (var dt_update#syncReqs#1#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#14#0)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#14#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#14#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#14#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#14#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#14#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#14#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#14#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#14#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#14#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#14#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#14#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#14#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#14#0), 
                          dt_update#syncReqs#1#0)
                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#14#0)
                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#14#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#14#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#14#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#14#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#14#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#14#0), 
                            dt_update#syncReqs#1#0)
                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#14#0), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#14#0), 
                            JournalCache.Variables.superblock1(dt_update_tmp#14#0), 
                            JournalCache.Variables.superblock2(dt_update_tmp#14#0), 
                            dt_update#syncReqs#1#0))))); 
                (var dt_update#commitStatus#1#0 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#15#0), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#15#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#15#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#15#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#15#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#15#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#15#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#15#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#15#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#15#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#15#0), 
                    dt_update#commitStatus#1#0, 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#15#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#15#0)))))
             && 
            (var dt_update_tmp#10#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#10#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#10#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#10#0))
             && (var dt_update_tmp#11#0 := (var dt_update_tmp#10#0 := s#0; 
                  (var dt_update#superblockWrite#1#0 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#10#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#10#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#0), 
                      dt_update#superblockWrite#1#0, 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#10#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#10#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#10#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#10#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#10#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#10#0)))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#11#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#11#0))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#11#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#11#0)))
             && (var dt_update_tmp#12#0 := (var dt_update_tmp#11#0 := (var dt_update_tmp#10#0 := s#0; 
                      (var dt_update#superblockWrite#1#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#10#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#10#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#0), 
                          dt_update#superblockWrite#1#0, 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#10#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#10#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#10#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#10#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#10#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#10#0)))); 
                  (var dt_update#superblock#1#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#11#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#11#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#11#0), 
                        dt_update#superblock#1#0, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#11#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#11#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#11#0))
                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#0, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#11#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#11#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#11#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#11#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#11#0))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#12#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#12#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#12#0))
             && (var dt_update_tmp#13#0 := (var dt_update_tmp#12#0 := (var dt_update_tmp#11#0 := (var dt_update_tmp#10#0 := s#0; 
                          (var dt_update#superblockWrite#1#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#10#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#10#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#0), 
                              dt_update#superblockWrite#1#0, 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#10#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#10#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#10#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#10#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#10#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#10#0)))); 
                      (var dt_update#superblock#1#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#0), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#11#0), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#11#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#11#0), 
                            dt_update#superblock#1#0, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#11#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#11#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#11#0))
                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#0, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#11#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#11#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#11#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#11#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#11#0))))); 
                  (var dt_update#newSuperblock#1#0 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#12#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#12#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#12#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#12#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#12#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#12#0), 
                      dt_update#newSuperblock#1#0, 
                      JournalCache.Variables.syncReqs(dt_update_tmp#12#0)))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#13#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#13#0))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#13#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#13#0)))
             && 
            (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && JournalCache.__default.syncReqs2to1#canCall(JournalCache.Variables.syncReqs(s#0))
             && (var dt_update_tmp#15#0 := (var dt_update_tmp#14#0 := (var dt_update_tmp#13#0 := (var dt_update_tmp#12#0 := (var dt_update_tmp#11#0 := (var dt_update_tmp#10#0 := s#0; 
                                  (var dt_update#superblockWrite#1#0 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#10#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#10#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#0), 
                                      dt_update#superblockWrite#1#0, 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#10#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#10#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#10#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#10#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#10#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#10#0)))); 
                              (var dt_update#superblock#1#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#11#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#11#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#11#0), 
                                    dt_update#superblock#1#0, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#11#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#11#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#11#0))
                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#0, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#11#0), 
                                    JournalCache.Variables.journalBackRead(dt_update_tmp#11#0), 
                                    JournalCache.Variables.journalFront(dt_update_tmp#11#0), 
                                    JournalCache.Variables.journalBack(dt_update_tmp#11#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#11#0))))); 
                          (var dt_update#newSuperblock#1#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#12#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#12#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#12#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#12#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#12#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#12#0), 
                              dt_update#newSuperblock#1#0, 
                              JournalCache.Variables.syncReqs(dt_update_tmp#12#0)))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#13#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#13#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#13#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#13#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#13#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#13#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#13#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#13#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#13#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#13#0), 
                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#13#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#13#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#13#0))
                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#13#0), 
                          (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#13#0), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#13#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#13#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#13#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#13#0)))); 
                  (var dt_update#syncReqs#1#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#14#0)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#14#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#14#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#14#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#14#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#14#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#14#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#14#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#14#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#14#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#14#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#14#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#14#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#14#0), 
                        dt_update#syncReqs#1#0)
                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#14#0)
                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#14#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#14#0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#14#0), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#14#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#14#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#14#0), 
                          dt_update#syncReqs#1#0)
                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#14#0), 
                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#14#0), 
                          JournalCache.Variables.superblock1(dt_update_tmp#14#0), 
                          JournalCache.Variables.superblock2(dt_update_tmp#14#0), 
                          dt_update#syncReqs#1#0))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#15#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#15#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#15#0)))
         && JournalCache.__default.WriteBackSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            JournalCache.Variables.Ready_q(s#0)
             && JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
             && Options.Option#Equal(#Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))), 
              JournalCache.Variables.superblockWrite(s#0))
             && Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
             && JournalCache.Variables.Ready_q(s'#0)
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> ViewOp.VOp.CleanUpOp_q(vop#0)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#9#0 := (var dt_update_tmp#8#0 := (var dt_update_tmp#7#0 := (var dt_update_tmp#6#0 := (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                                        (var dt_update#superblockWrite#0#0 := Lit(#Options.Option.None()); 
                                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                                            dt_update#superblockWrite#0#0, 
                                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                                    (var dt_update#superblock#0#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                                          dt_update#superblock#0#0, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))
                                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#0, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))); 
                                                (var dt_update#newSuperblock#0#0 := Lit(#Options.Option.None()); 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                                    dt_update#newSuperblock#0#0, 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#0), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                                                JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0))
                                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))); 
                                        (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                                              JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                                              dt_update#syncReqs#0#0)
                                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                                                dt_update#syncReqs#0#0)
                                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                                                JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                                                JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                                                dt_update#syncReqs#0#0))))); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#5#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                                      JournalCache.Variables.writtenJournalLen(s#0)
                                         - JournalCache.Variables.frozenJournalPosition(s#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#5#0))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#6#0), 
                                  LitInt(0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#6#0), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#0), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#6#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#6#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#6#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#6#0))); 
                            (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                                JournalCache.Variables.isFrozen(dt_update_tmp#7#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#7#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#7#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#7#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#7#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#7#0)))); 
                        (var dt_update#isFrozen#0#0 := Lit(false); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#0), 
                            dt_update#isFrozen#0#0, 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#8#0), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#0), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#0), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#0), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#0), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#8#0), 
                            JournalCache.Variables.superblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#8#0), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#8#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#8#0)))); 
                    (var dt_update#commitStatus#0#0 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#9#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#9#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#9#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#9#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#9#0), 
                        dt_update#commitStatus#0#0, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#9#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#9#0))))))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
               ==> ViewOp.VOp.JournalInternalOp_q(vop#0)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#15#0 := (var dt_update_tmp#14#0 := (var dt_update_tmp#13#0 := (var dt_update_tmp#12#0 := (var dt_update_tmp#11#0 := (var dt_update_tmp#10#0 := s#0; 
                                        (var dt_update#superblockWrite#1#0 := Lit(#Options.Option.None()); 
                                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#10#0), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#10#0), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#0), 
                                            dt_update#superblockWrite#1#0, 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#0), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#0), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#0), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#0), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#10#0), 
                                            JournalCache.Variables.superblock(dt_update_tmp#10#0), 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#10#0), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#10#0), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#10#0), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#10#0)))); 
                                    (var dt_update#superblock#1#0 := $Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType; 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#11#0)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#0), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#11#0), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#0), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#11#0), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#0), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#0), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#0), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#0), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#11#0), 
                                          dt_update#superblock#1#0, 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#11#0), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#11#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#11#0))
                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#0, 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#11#0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#11#0), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#11#0), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#11#0), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#11#0), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#11#0))))); 
                                (var dt_update#newSuperblock#1#0 := Lit(#Options.Option.None()); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#12#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#12#0), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#0), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#12#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#12#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#12#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#12#0), 
                                    dt_update#newSuperblock#1#0, 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#12#0)))); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#13#0)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#13#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#13#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#13#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#13#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#13#0), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#13#0), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#13#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#13#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#13#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#13#0), 
                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#13#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#13#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#13#0))
                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#13#0), 
                                (if JournalCache.Variables.whichSuperblock(s#0) == LitInt(0) then 1 else 0), 
                                JournalCache.Variables.journalFrontRead(dt_update_tmp#13#0), 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#13#0), 
                                JournalCache.Variables.journalFront(dt_update_tmp#13#0), 
                                JournalCache.Variables.journalBack(dt_update_tmp#13#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#13#0)))); 
                        (var dt_update#syncReqs#1#0 := JournalCache.__default.syncReqs2to1(JournalCache.Variables.syncReqs(s#0)); 
                          (if JournalCache.Variables.Ready_q(dt_update_tmp#14#0)
                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#14#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#14#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#14#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#14#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#14#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#14#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#14#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#14#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#14#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#14#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#14#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#14#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#14#0), 
                              dt_update#syncReqs#1#0)
                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#14#0)
                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#14#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#14#0), 
                                JournalCache.Variables.journalFrontRead(dt_update_tmp#14#0), 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#14#0), 
                                JournalCache.Variables.journalFront(dt_update_tmp#14#0), 
                                JournalCache.Variables.journalBack(dt_update_tmp#14#0), 
                                dt_update#syncReqs#1#0)
                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#14#0), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#14#0), 
                                JournalCache.Variables.superblock1(dt_update_tmp#14#0), 
                                JournalCache.Variables.superblock2(dt_update_tmp#14#0), 
                                dt_update#syncReqs#1#0))))); 
                    (var dt_update#commitStatus#1#0 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#15#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#15#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#15#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#15#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#15#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#15#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#15#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#15#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#15#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#15#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#15#0), 
                        dt_update#commitStatus#1#0, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#15#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#15#0))))))));

// definition axiom for JournalCache.__default.WriteBackSuperblockResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.WriteBackSuperblockResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.WriteBackSuperblockResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0)))
           ==> $IsA#Options.Option(Lit(JournalCache.Variables.superblockWrite(Lit(s#0)))))
         && (Lit(JournalCache.Variables.Ready_q(Lit(s'#0)))
           ==> 
          Lit(JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
           ==> 
          Lit(ViewOp.VOp.CleanUpOp_q(Lit(vop#0)))
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#9#1 := (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                    (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                      Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                          dt_update#superblockWrite#0#1, 
                                                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                                (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                      dt_update#superblock#0#1, 
                                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                     else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                      JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                            (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                dt_update#newSuperblock#0#1, 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                            JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                            (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                               then 1
                                               else 0), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                           else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                            (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                               then 1
                                               else 0), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                    (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                          JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                          dt_update#syncReqs#0#1)
                                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                            dt_update#syncReqs#0#1)
                                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                            JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                            JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                            dt_update#syncReqs#0#1))))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                  LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                       - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                              LitInt(0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                        (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                            JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                    (var dt_update#isFrozen#0#1 := Lit(false); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#1), 
                        dt_update#isFrozen#0#1, 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#8#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#8#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#8#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#8#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#8#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#8#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#8#1)))); 
                (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#1), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#9#1), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#9#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#1), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#9#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#9#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#9#1), 
                    dt_update#commitStatus#0#1, 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#9#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#9#1)))))
             && 
            (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                  (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                    Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                        dt_update#superblockWrite#0#1, 
                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1)))
             && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                      (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                        Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                            dt_update#superblockWrite#0#1, 
                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                  (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                        dt_update#superblock#0#1, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
             && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                            Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                dt_update#superblockWrite#0#1, 
                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                      (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                            dt_update#superblock#0#1, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                  (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                      JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                      dt_update#newSuperblock#0#1, 
                      JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1)))
             && 
            (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && JournalCache.__default.syncReqs2to1#canCall(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))
             && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                  (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                    Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                        dt_update#superblockWrite#0#1, 
                                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                              (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                    dt_update#superblock#0#1, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                    JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                    JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                    JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                          (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                              dt_update#newSuperblock#0#1, 
                              JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                             then 1
                             else 0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                             then 1
                             else 0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                          JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                          JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                  (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                        dt_update#syncReqs#0#1)
                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                          dt_update#syncReqs#0#1)
                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                          dt_update#syncReqs#0#1))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#5#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#5#1))
             && (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                      (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                        Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                            dt_update#superblockWrite#0#1, 
                                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                  (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                        dt_update#superblock#0#1, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                              (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                  dt_update#newSuperblock#0#1, 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                          (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                              (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                 then 1
                                 else 0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                             else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                              (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                 then 1
                                 else 0), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                              JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                              JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                      (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                            dt_update#syncReqs#0#1)
                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                              dt_update#syncReqs#0#1)
                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                              JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                              JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                              dt_update#syncReqs#0#1))))); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                         - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#6#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#6#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#6#1))
             && (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                          (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                            Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                dt_update#superblockWrite#0#1, 
                                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                      (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                            dt_update#superblock#0#1, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                  (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                      dt_update#newSuperblock#0#1, 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                              (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                 then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                  (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                     then 1
                                     else 0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                 else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                  (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                     then 1
                                     else 0), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                          (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                dt_update#syncReqs#0#1)
                               else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                 then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                  dt_update#syncReqs#0#1)
                                 else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                  JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                  JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                  JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                  dt_update#syncReqs#0#1))))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                        LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                             - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                    LitInt(0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#7#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#7#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#7#1))
             && (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                              (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                    dt_update#superblockWrite#0#1, 
                                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                          (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                dt_update#superblock#0#1, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                               else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                      (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                          JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                          dt_update#newSuperblock#0#1, 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                      (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                         then 1
                                         else 0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                     else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                      (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                         then 1
                                         else 0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                              (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                    JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                    dt_update#syncReqs#0#1)
                                   else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                     then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                      dt_update#syncReqs#0#1)
                                     else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                      JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                      JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                      JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                      dt_update#syncReqs#0#1))))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                            LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                 - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                        LitInt(0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                  (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                      JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                      JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#8#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#8#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#8#1))
             && (var dt_update_tmp#9#1 := (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                  (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                    Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                        dt_update#superblockWrite#0#1, 
                                                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                              (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                    dt_update#superblock#0#1, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                          (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                              JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                              dt_update#newSuperblock#0#1, 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                          JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                             then 1
                                             else 0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                             then 1
                                             else 0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                  (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                        JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                        dt_update#syncReqs#0#1)
                                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                          dt_update#syncReqs#0#1)
                                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                          JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                          JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                          dt_update#syncReqs#0#1))))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                     - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                            LitInt(0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                      (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                          JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                  (var dt_update#isFrozen#0#1 := Lit(false); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#1), 
                      dt_update#isFrozen#0#1, 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#1), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#8#1), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#1), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#1), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#1), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#1), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#8#1), 
                      JournalCache.Variables.superblock(dt_update_tmp#8#1), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#8#1), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#8#1), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#8#1), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#8#1)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#9#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#9#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#9#1)))
         && ((Lit(JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
               ==> 
              Lit(ViewOp.VOp.CleanUpOp_q(Lit(vop#0)))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#9#1 := (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                        (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                          Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                              dt_update#superblockWrite#0#1, 
                                                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                                    (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                          dt_update#superblock#0#1, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                                (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                    dt_update#newSuperblock#0#1, 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                                JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                   then 1
                                                   else 0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                   then 1
                                                   else 0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                        (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                              dt_update#syncReqs#0#1)
                                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                                dt_update#syncReqs#0#1)
                                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                                JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                                JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                                dt_update#syncReqs#0#1))))); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                      LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                           - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                                  LitInt(0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                            (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                        (var dt_update#isFrozen#0#1 := Lit(false); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#1), 
                            dt_update#isFrozen#0#1, 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#8#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#8#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#8#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#8#1)))); 
                    (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#9#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#9#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#9#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#9#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#9#1), 
                        dt_update#commitStatus#0#1, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#9#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#9#1)))))
                 && 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                 && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                      (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                        Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                            dt_update#superblockWrite#0#1, 
                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                  (JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))
                     && (!JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1)))
                 && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                            Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                dt_update#superblockWrite#0#1, 
                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                      (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                            dt_update#superblock#0#1, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
                 && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                    dt_update#superblockWrite#0#1, 
                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                          (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                dt_update#superblock#0#1, 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                               else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                      (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                          dt_update#newSuperblock#0#1, 
                          JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                  (JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1))
                     && (!JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                       ==> JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1)))
                 && 
                (
                  JournalCache.Variables.Ready_q(Lit(s#0))
                   || JournalCache.Variables.LoadingOther_q(Lit(s#0))
                   || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
                 && JournalCache.__default.syncReqs2to1#canCall(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))
                 && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                      (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                        Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                            dt_update#superblockWrite#0#1, 
                                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                  (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                        dt_update#superblock#0#1, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                              (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                  dt_update#newSuperblock#0#1, 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                          (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                              (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                 then 1
                                 else 0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                             else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                              (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                 then 1
                                 else 0), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                              JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                              JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                      (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                            dt_update#syncReqs#0#1)
                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                              JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                              dt_update#syncReqs#0#1)
                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                              JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                              JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                              dt_update#syncReqs#0#1))))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#5#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#5#1))
                 && (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                          (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                            Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                dt_update#superblockWrite#0#1, 
                                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                      (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                            dt_update#superblock#0#1, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                            JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                  (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                      dt_update#newSuperblock#0#1, 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                              (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                 then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                  (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                     then 1
                                     else 0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                 else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                  (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                     then 1
                                     else 0), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                          (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                dt_update#syncReqs#0#1)
                               else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                 then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                  JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                  dt_update#syncReqs#0#1)
                                 else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                  JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                  JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                  JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                  dt_update#syncReqs#0#1))))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                        LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                             - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#6#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#6#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#6#1))
                 && (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                              (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                    dt_update#superblockWrite#0#1, 
                                                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                          (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                dt_update#superblock#0#1, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                               else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                      (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                          JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                          dt_update#newSuperblock#0#1, 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                      (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                         then 1
                                         else 0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                     else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                      (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                         then 1
                                         else 0), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                              (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                    JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                    dt_update#syncReqs#0#1)
                                   else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                     then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                      dt_update#syncReqs#0#1)
                                     else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                      JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                      JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                      JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                      dt_update#syncReqs#0#1))))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                            LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                 - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                        LitInt(0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#7#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#7#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#7#1))
                 && (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                  (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                    Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                        dt_update#superblockWrite#0#1, 
                                                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                              (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                    dt_update#superblock#0#1, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                          (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                              JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                              dt_update#newSuperblock#0#1, 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                          JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                             then 1
                                             else 0), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                             then 1
                                             else 0), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                  (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                        JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                        dt_update#syncReqs#0#1)
                                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                          dt_update#syncReqs#0#1)
                                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                          JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                          JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                          dt_update#syncReqs#0#1))))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                     - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                            LitInt(0), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                      (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                          JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#8#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#8#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#8#1))
                 && (var dt_update_tmp#9#1 := (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                      (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                        Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                            dt_update#superblockWrite#0#1, 
                                                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                                  (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                    (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                        dt_update#superblock#0#1, 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                              (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                  JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                  dt_update#newSuperblock#0#1, 
                                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                              JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                              (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                 then 1
                                                 else 0), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                             else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                              (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                 then 1
                                                 else 0), 
                                              JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                              JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                              JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                              JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                              JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                      (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                        (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                            JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                            JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                            JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                            JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                            JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                            JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                            dt_update#syncReqs#0#1)
                                           else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                             then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                              JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                              JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                              JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                              dt_update#syncReqs#0#1)
                                             else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                              JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                              dt_update#syncReqs#0#1))))); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                    LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                         - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                    JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                                LitInt(0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                          (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                              JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                      (var dt_update#isFrozen#0#1 := Lit(false); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#1), 
                          dt_update#isFrozen#0#1, 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#8#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#8#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#8#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#8#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#8#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#8#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#8#1)))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#9#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#9#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#9#1)))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> ViewOp.VOp.CleanUpOp_q(Lit(vop#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#9#1 := (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                        (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                          Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                              dt_update#superblockWrite#0#1, 
                                                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                                    (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                          dt_update#superblock#0#1, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                                (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                    dt_update#newSuperblock#0#1, 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                                JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                   then 1
                                                   else 0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                   then 1
                                                   else 0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                        (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                              dt_update#syncReqs#0#1)
                                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                                dt_update#syncReqs#0#1)
                                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                                JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                                JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                                dt_update#syncReqs#0#1))))); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                      LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                           - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                                  LitInt(0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                            (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                        (var dt_update#isFrozen#0#1 := Lit(false); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#1), 
                            dt_update#isFrozen#0#1, 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#8#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#8#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#8#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#8#1)))); 
                    (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#9#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#9#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#9#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#9#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#9#1), 
                        dt_update#commitStatus#0#1, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#9#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#9#1))))))
           ==> 
          Lit(JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
           ==> 
          Lit(ViewOp.VOp.JournalInternalOp_q(Lit(vop#0)))
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#15#1 := (var dt_update_tmp#14#1 := (var dt_update_tmp#13#1 := (var dt_update_tmp#12#1 := (var dt_update_tmp#11#1 := (var dt_update_tmp#10#1 := Lit(s#0); 
                                    (var dt_update#superblockWrite#1#1 := Lit(#Options.Option.None()); 
                                      Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#10#1)), 
                                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#1)), 
                                          dt_update#superblockWrite#1#1, 
                                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#1)), 
                                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.replayJournal(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.superblock(dt_update_tmp#10#1)), 
                                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#10#1)), 
                                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#10#1)))))); 
                                (var dt_update#superblock#1#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                  (if JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#11#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#11#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#1), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#1), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#11#1), 
                                      dt_update#superblock#1#1, 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#11#1), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#11#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#11#1))
                                     else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#1, 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                                      JournalCache.Variables.journalFrontRead(dt_update_tmp#11#1), 
                                      JournalCache.Variables.journalBackRead(dt_update_tmp#11#1), 
                                      JournalCache.Variables.journalFront(dt_update_tmp#11#1), 
                                      JournalCache.Variables.journalBack(dt_update_tmp#11#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#11#1))))); 
                            (var dt_update#newSuperblock#1#1 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#12#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#12#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#12#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#12#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#12#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#12#1), 
                                dt_update#newSuperblock#1#1, 
                                JournalCache.Variables.syncReqs(dt_update_tmp#12#1)))); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#13#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#13#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#13#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#13#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#13#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#13#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#13#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#13#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#13#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#13#1), 
                            (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                               then 1
                               else 0), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#13#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#13#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#13#1))
                           else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#13#1), 
                            (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                               then 1
                               else 0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#13#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#13#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#13#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#13#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#13#1)))); 
                    (var dt_update#syncReqs#1#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#14#1)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#14#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#14#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#14#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#14#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#14#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#14#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#14#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#14#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#14#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#14#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#14#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#14#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#14#1), 
                          dt_update#syncReqs#1#1)
                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#14#1)
                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#14#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#14#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#14#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#14#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#14#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#14#1), 
                            dt_update#syncReqs#1#1)
                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#14#1), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#14#1), 
                            JournalCache.Variables.superblock1(dt_update_tmp#14#1), 
                            JournalCache.Variables.superblock2(dt_update_tmp#14#1), 
                            dt_update#syncReqs#1#1))))); 
                (var dt_update#commitStatus#1#1 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#15#1), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#15#1), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#15#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#15#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#15#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#15#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#15#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#15#1), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#15#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#15#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#15#1), 
                    dt_update#commitStatus#1#1, 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#15#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#15#1)))))
             && 
            (var dt_update_tmp#10#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#10#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#10#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#10#1))
             && (var dt_update_tmp#11#1 := (var dt_update_tmp#10#1 := Lit(s#0); 
                  (var dt_update#superblockWrite#1#1 := Lit(#Options.Option.None()); 
                    Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#10#1)), 
                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#1)), 
                        dt_update#superblockWrite#1#1, 
                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#1)), 
                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.superblock(dt_update_tmp#10#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#10#1)), 
                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#10#1)))))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#11#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#11#1))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#11#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#11#1)))
             && (var dt_update_tmp#12#1 := (var dt_update_tmp#11#1 := (var dt_update_tmp#10#1 := Lit(s#0); 
                      (var dt_update#superblockWrite#1#1 := Lit(#Options.Option.None()); 
                        Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#10#1)), 
                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#1)), 
                            dt_update#superblockWrite#1#1, 
                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#1)), 
                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.superblock(dt_update_tmp#10#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#10#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#10#1)))))); 
                  (var dt_update#superblock#1#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#11#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#11#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#11#1), 
                        dt_update#superblock#1#1, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#11#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#11#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#11#1))
                       else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#1, 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#11#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#11#1), 
                        JournalCache.Variables.journalFront(dt_update_tmp#11#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#11#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#11#1))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#12#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#12#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#12#1))
             && (var dt_update_tmp#13#1 := (var dt_update_tmp#12#1 := (var dt_update_tmp#11#1 := (var dt_update_tmp#10#1 := Lit(s#0); 
                          (var dt_update#superblockWrite#1#1 := Lit(#Options.Option.None()); 
                            Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#10#1)), 
                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#1)), 
                                dt_update#superblockWrite#1#1, 
                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#1)), 
                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.superblock(dt_update_tmp#10#1)), 
                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#10#1)), 
                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#10#1)))))); 
                      (var dt_update#superblock#1#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                        (if JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                           then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#1), 
                            JournalCache.Variables.isFrozen(dt_update_tmp#11#1), 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#11#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#11#1), 
                            dt_update#superblock#1#1, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#11#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#11#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#11#1))
                           else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#1, 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#11#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#11#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#11#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#11#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#11#1))))); 
                  (var dt_update#newSuperblock#1#1 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#1), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#12#1), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#1), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#12#1), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#1), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#1), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#1), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#1), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#12#1), 
                      JournalCache.Variables.superblock(dt_update_tmp#12#1), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#12#1), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#12#1), 
                      dt_update#newSuperblock#1#1, 
                      JournalCache.Variables.syncReqs(dt_update_tmp#12#1)))); 
              (JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#13#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#13#1))
                 && (!JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                   ==> JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#13#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#13#1)))
             && 
            (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && JournalCache.__default.syncReqs2to1#canCall(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))
             && (var dt_update_tmp#15#1 := (var dt_update_tmp#14#1 := (var dt_update_tmp#13#1 := (var dt_update_tmp#12#1 := (var dt_update_tmp#11#1 := (var dt_update_tmp#10#1 := Lit(s#0); 
                                  (var dt_update#superblockWrite#1#1 := Lit(#Options.Option.None()); 
                                    Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#10#1)), 
                                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#1)), 
                                        dt_update#superblockWrite#1#1, 
                                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#1)), 
                                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.superblock(dt_update_tmp#10#1)), 
                                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#10#1)), 
                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#10#1)))))); 
                              (var dt_update#superblock#1#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                (if JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                                   then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#11#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#11#1), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#1), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#11#1), 
                                    dt_update#superblock#1#1, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#11#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#11#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#11#1))
                                   else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#1, 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                                    JournalCache.Variables.journalFrontRead(dt_update_tmp#11#1), 
                                    JournalCache.Variables.journalBackRead(dt_update_tmp#11#1), 
                                    JournalCache.Variables.journalFront(dt_update_tmp#11#1), 
                                    JournalCache.Variables.journalBack(dt_update_tmp#11#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#11#1))))); 
                          (var dt_update#newSuperblock#1#1 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#12#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#12#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#12#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#12#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#12#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#12#1), 
                              dt_update#newSuperblock#1#1, 
                              JournalCache.Variables.syncReqs(dt_update_tmp#12#1)))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#13#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#13#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#13#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#13#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#13#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#13#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#13#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#13#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#13#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#13#1), 
                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                             then 1
                             else 0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#13#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#13#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#13#1))
                         else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#13#1), 
                          (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                             then 1
                             else 0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#13#1), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#13#1), 
                          JournalCache.Variables.journalFront(dt_update_tmp#13#1), 
                          JournalCache.Variables.journalBack(dt_update_tmp#13#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#13#1)))); 
                  (var dt_update#syncReqs#1#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#14#1)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#14#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#14#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#14#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#14#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#14#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#14#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#14#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#14#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#14#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#14#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#14#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#14#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#14#1), 
                        dt_update#syncReqs#1#1)
                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#14#1)
                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#14#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#14#1), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#14#1), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#14#1), 
                          JournalCache.Variables.journalFront(dt_update_tmp#14#1), 
                          JournalCache.Variables.journalBack(dt_update_tmp#14#1), 
                          dt_update#syncReqs#1#1)
                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#14#1), 
                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#14#1), 
                          JournalCache.Variables.superblock1(dt_update_tmp#14#1), 
                          JournalCache.Variables.superblock2(dt_update_tmp#14#1), 
                          dt_update#syncReqs#1#1))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#15#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#15#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#15#1)))
         && JournalCache.__default.WriteBackSuperblockResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            JournalCache.Variables.Ready_q(Lit(s#0))
             && JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0))
             && Options.Option#Equal(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))), 
              JournalCache.Variables.superblockWrite(Lit(s#0)))
             && Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))
             && JournalCache.Variables.Ready_q(Lit(s'#0))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> ViewOp.VOp.CleanUpOp_q(Lit(vop#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#9#1 := (var dt_update_tmp#8#1 := (var dt_update_tmp#7#1 := (var dt_update_tmp#6#1 := (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                                        (var dt_update#superblockWrite#0#1 := Lit(#Options.Option.None()); 
                                                          Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                                              dt_update#superblockWrite#0#1, 
                                                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                                    (var dt_update#superblock#0#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                                          dt_update#superblock#0#1, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))
                                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#0#1, 
                                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                                                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))); 
                                                (var dt_update#newSuperblock#0#1 := Lit(#Options.Option.None()); 
                                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                                    JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                                    dt_update#newSuperblock#0#1, 
                                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                                            (if JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                                                JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#3#1), 
                                                JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                                                JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                                                JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                   then 1
                                                   else 0), 
                                                JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                                                JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1))
                                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                                   then 1
                                                   else 0), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))); 
                                        (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                                          (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                                              JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                                              JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                                              JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                              JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                                              JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                                              dt_update#syncReqs#0#1)
                                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                                                JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                                                JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                                                dt_update#syncReqs#0#1)
                                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                                                JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                                                JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                                                dt_update#syncReqs#0#1))))); 
                                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#5#1), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                                      LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                                           - JournalCache.Variables.frozenJournalPosition(Lit(s#0))), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                                      JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#5#1))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#6#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#6#1), 
                                  LitInt(0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#6#1), 
                                  JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#6#1), 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#6#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#6#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#6#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#6#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#6#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#6#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#6#1))); 
                            (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                JournalCache.Variables.isFrozen(dt_update_tmp#7#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#7#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#7#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#7#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#7#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#7#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#7#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#7#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#7#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#7#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#7#1)))); 
                        (var dt_update#isFrozen#0#1 := Lit(false); 
                          #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#8#1), 
                            dt_update#isFrozen#0#1, 
                            JournalCache.Variables.frozenJournalPosition(dt_update_tmp#8#1), 
                            JournalCache.Variables.superblockWrite(dt_update_tmp#8#1), 
                            JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#8#1), 
                            JournalCache.Variables.inMemoryJournal(dt_update_tmp#8#1), 
                            JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#8#1), 
                            JournalCache.Variables.writtenJournalLen(dt_update_tmp#8#1), 
                            JournalCache.Variables.replayJournal(dt_update_tmp#8#1), 
                            JournalCache.Variables.superblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.commitStatus(dt_update_tmp#8#1), 
                            JournalCache.Variables.newSuperblock(dt_update_tmp#8#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#8#1)))); 
                    (var dt_update#commitStatus#0#1 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#9#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#9#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#9#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#9#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#9#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#9#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#9#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#9#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#9#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#9#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#9#1), 
                        dt_update#commitStatus#0#1, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#9#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#9#1))))))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#15#1 := (var dt_update_tmp#14#1 := (var dt_update_tmp#13#1 := (var dt_update_tmp#12#1 := (var dt_update_tmp#11#1 := (var dt_update_tmp#10#1 := Lit(s#0); 
                                        (var dt_update#superblockWrite#1#1 := Lit(#Options.Option.None()); 
                                          Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.isFrozen(dt_update_tmp#10#1)), 
                                              LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#10#1)), 
                                              dt_update#superblockWrite#1#1, 
                                              Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#10#1)), 
                                              LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.replayJournal(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.superblock(dt_update_tmp#10#1)), 
                                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.commitStatus(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#10#1)), 
                                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#10#1)))))); 
                                    (var dt_update#superblock#1#1 := Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType); 
                                      (if JournalCache.Variables.Ready_q(dt_update_tmp#11#1)
                                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#11#1), 
                                          JournalCache.Variables.isFrozen(dt_update_tmp#11#1), 
                                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#11#1), 
                                          JournalCache.Variables.superblockWrite(dt_update_tmp#11#1), 
                                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#11#1), 
                                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#11#1), 
                                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#11#1), 
                                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#11#1), 
                                          JournalCache.Variables.replayJournal(dt_update_tmp#11#1), 
                                          dt_update#superblock#1#1, 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                                          JournalCache.Variables.commitStatus(dt_update_tmp#11#1), 
                                          JournalCache.Variables.newSuperblock(dt_update_tmp#11#1), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#11#1))
                                         else #JournalCache.Variables.LoadingOther(dt_update#superblock#1#1, 
                                          JournalCache.Variables.whichSuperblock(dt_update_tmp#11#1), 
                                          JournalCache.Variables.journalFrontRead(dt_update_tmp#11#1), 
                                          JournalCache.Variables.journalBackRead(dt_update_tmp#11#1), 
                                          JournalCache.Variables.journalFront(dt_update_tmp#11#1), 
                                          JournalCache.Variables.journalBack(dt_update_tmp#11#1), 
                                          JournalCache.Variables.syncReqs(dt_update_tmp#11#1))))); 
                                (var dt_update#newSuperblock#1#1 := Lit(#Options.Option.None()); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#12#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#12#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#12#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#12#1), 
                                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#12#1), 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#12#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#12#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#12#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#12#1), 
                                    JournalCache.Variables.superblock(dt_update_tmp#12#1), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#12#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#12#1), 
                                    dt_update#newSuperblock#1#1, 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#12#1)))); 
                            (if JournalCache.Variables.Ready_q(dt_update_tmp#13#1)
                               then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#13#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#13#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#13#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#13#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#13#1), 
                                JournalCache.Variables.inMemoryJournal(dt_update_tmp#13#1), 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#13#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#13#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#13#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#13#1), 
                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                   then 1
                                   else 0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#13#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#13#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#13#1))
                               else #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#13#1), 
                                (if LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
                                   then 1
                                   else 0), 
                                JournalCache.Variables.journalFrontRead(dt_update_tmp#13#1), 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#13#1), 
                                JournalCache.Variables.journalFront(dt_update_tmp#13#1), 
                                JournalCache.Variables.journalBack(dt_update_tmp#13#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#13#1)))); 
                        (var dt_update#syncReqs#1#1 := Lit(JournalCache.__default.syncReqs2to1(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                          (if JournalCache.Variables.Ready_q(dt_update_tmp#14#1)
                             then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#14#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#14#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#14#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#14#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#14#1), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#14#1), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#14#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#14#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#14#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#14#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#14#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#14#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#14#1), 
                              dt_update#syncReqs#1#1)
                             else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#14#1)
                               then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#14#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#14#1), 
                                JournalCache.Variables.journalFrontRead(dt_update_tmp#14#1), 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#14#1), 
                                JournalCache.Variables.journalFront(dt_update_tmp#14#1), 
                                JournalCache.Variables.journalBack(dt_update_tmp#14#1), 
                                dt_update#syncReqs#1#1)
                               else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#14#1), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#14#1), 
                                JournalCache.Variables.superblock1(dt_update_tmp#14#1), 
                                JournalCache.Variables.superblock2(dt_update_tmp#14#1), 
                                dt_update#syncReqs#1#1))))); 
                    (var dt_update#commitStatus#1#1 := Lit(#JournalCache.CommitStatus.CommitNone()); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#15#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#15#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#15#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#15#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#15#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#15#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#15#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#15#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#15#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#15#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#15#1), 
                        dt_update#commitStatus#1#1, 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#15#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#15#1))))))));

// function declaration for JournalCache._default.PageInJournalReq
function JournalCache.__default.PageInJournalReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

function JournalCache.__default.PageInJournalReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

// consequence axiom for JournalCache.__default.PageInJournalReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInJournalReq(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInJournalReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.PageInJournalReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for JournalCache.__default.PageInJournalReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int :: 
  { JournalCache.__default.PageInJournalReq#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.PageInJournalReq#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0)
       == true);

// definition axiom for JournalCache.__default.PageInJournalReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInJournalReq(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInJournalReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (which#0 == LitInt(0) || which#0 == LitInt(1)
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               < DiskLayout.__default.NumJournalBlocks()
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> 
          which#0 == LitInt(0)
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
             && (Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> $IsA#JournalIntervals.JournalInterval(JournalDisk.DiskOp.interval(dop#0))
                 && $IsA#JournalIntervals.JournalInterval($Unbox(Options.Option.value(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))): DatatypeType)
                 && JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
             && (Options.Option.None_q(JournalCache.Variables.journalFront(s#0))
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#journalFrontRead#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                            dt_update#journalFrontRead#0#0, 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                    (var dt_update#journalBackRead#0#0 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(s#0), 
                            #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalBackRead(s#0)); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        dt_update#journalBackRead#0#0, 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
                 && 
                (var dt_update_tmp#0#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                 && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                      (var dt_update#journalFrontRead#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                        #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                          dt_update#journalFrontRead#0#0, 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                  $IsA#Options.Option(JournalCache.Variables.journalBackRead(s#0))
                     && (
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0)))))
         && ((which#0 == LitInt(0)
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
                 && (Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                   ==> $IsA#JournalIntervals.JournalInterval(JournalDisk.DiskOp.interval(dop#0))
                     && $IsA#JournalIntervals.JournalInterval($Unbox(Options.Option.value(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))): DatatypeType)
                     && JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
                 && (Options.Option.None_q(JournalCache.Variables.journalFront(s#0))
                   ==> $IsA#JournalCache.Variables(s'#0)
                     && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#journalFrontRead#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                              #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                dt_update#journalFrontRead#0#0, 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                                JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                                JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                        (var dt_update#journalBackRead#0#0 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(s#0), 
                                #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                               then #Options.Option.None()
                               else JournalCache.Variables.journalBackRead(s#0)); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                            dt_update#journalBackRead#0#0, 
                            JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
                     && 
                    (var dt_update_tmp#0#0 := s#0; 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                     && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#journalFrontRead#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                            #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              dt_update#journalFrontRead#0#0, 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                              JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                              JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      $IsA#Options.Option(JournalCache.Variables.journalBackRead(s#0))
                         && (
                          JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                           || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                           || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0)))))
             && (which#0 == LitInt(0)
               ==> Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                 && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(dop#0), 
                  $Unbox(Options.Option.value(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))): DatatypeType)
                 && Options.Option.None_q(JournalCache.Variables.journalFrontRead(s#0))
                 && Options.Option.None_q(JournalCache.Variables.journalFront(s#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#journalFrontRead#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                            dt_update#journalFrontRead#0#0, 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                    (var dt_update#journalBackRead#0#0 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(s#0), 
                            #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalBackRead(s#0)); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        dt_update#journalBackRead#0#0, 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))
           ==> 
          which#0 == LitInt(1)
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
             && (Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> $IsA#JournalIntervals.JournalInterval(JournalDisk.DiskOp.interval(dop#0))
                 && $IsA#JournalIntervals.JournalInterval($Unbox(Options.Option.value(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))): DatatypeType)
                 && JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
             && (Options.Option.None_q(JournalCache.Variables.journalBack(s#0))
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                        (var dt_update#journalBackRead#1#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#2#0), 
                            dt_update#journalBackRead#1#0, 
                            JournalCache.Variables.journalFront(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#2#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                    (var dt_update#journalFrontRead#1#0 := (if Options.Option#Equal(JournalCache.Variables.journalFrontRead(s#0), 
                            #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalFrontRead(s#0)); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                        dt_update#journalFrontRead#1#0, 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))))
                 && 
                (var dt_update_tmp#2#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
                 && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                      (var dt_update#journalBackRead#1#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                        #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#2#0), 
                          dt_update#journalBackRead#1#0, 
                          JournalCache.Variables.journalFront(dt_update_tmp#2#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#2#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                  $IsA#Options.Option(JournalCache.Variables.journalFrontRead(s#0))
                     && (
                      JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0)))))
         && JournalCache.__default.PageInJournalReq(k#0, s#0, s'#0, dop#0, vop#0, which#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalDisk.DiskOp.ReqReadJournalOp_q(dop#0)
             && JournalCache.Variables.LoadingOther_q(s#0)
             && (which#0 == LitInt(0) || which#0 == LitInt(1))
             && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               < DiskLayout.__default.NumJournalBlocks()
             && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (which#0 == LitInt(0)
               ==> Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                 && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(dop#0), 
                  $Unbox(Options.Option.value(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))): DatatypeType)
                 && Options.Option.None_q(JournalCache.Variables.journalFrontRead(s#0))
                 && Options.Option.None_q(JournalCache.Variables.journalFront(s#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#journalFrontRead#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                            dt_update#journalFrontRead#0#0, 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                    (var dt_update#journalBackRead#0#0 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(s#0), 
                            #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalBackRead(s#0)); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        dt_update#journalBackRead#0#0, 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))
             && (which#0 == LitInt(1)
               ==> Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                 && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(dop#0), 
                  $Unbox(Options.Option.value(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))): DatatypeType)
                 && Options.Option.None_q(JournalCache.Variables.journalBackRead(s#0))
                 && Options.Option.None_q(JournalCache.Variables.journalBack(s#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                        (var dt_update#journalBackRead#1#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#2#0), 
                            dt_update#journalBackRead#1#0, 
                            JournalCache.Variables.journalFront(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#2#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                    (var dt_update#journalFrontRead#1#0 := (if Options.Option#Equal(JournalCache.Variables.journalFrontRead(s#0), 
                            #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalFrontRead(s#0)); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                        dt_update#journalFrontRead#1#0, 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#3#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#0))))))));

// definition axiom for JournalCache.__default.PageInJournalReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    {:weight 3} { JournalCache.__default.PageInJournalReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0)) } 
    JournalCache.__default.PageInJournalReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1)
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && Lit(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 < DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> 
          LitInt(which#0) == LitInt(0)
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
               ==> $IsA#JournalIntervals.JournalInterval(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))
                 && $IsA#JournalIntervals.JournalInterval(Lit($Unbox(Options.Option.value(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))): DatatypeType))
                 && JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && (Lit(Options.Option.None_q(Lit(JournalCache.Variables.journalFront(Lit(s#0)))))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              dt_update#journalFrontRead#0#1, 
                              Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                    (var dt_update#journalBackRead#0#1 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(Lit(s#0)), 
                            #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalBackRead(Lit(s#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        dt_update#journalBackRead#0#1, 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))
                 && 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                 && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                      (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                        Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                            dt_update#journalFrontRead#0#1, 
                            Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                  $IsA#Options.Option(Lit(JournalCache.Variables.journalBackRead(Lit(s#0))))
                     && (
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1)))))
         && ((LitInt(which#0) == LitInt(0)
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && (Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
                   ==> $IsA#JournalIntervals.JournalInterval(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))
                     && $IsA#JournalIntervals.JournalInterval(Lit($Unbox(Options.Option.value(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))): DatatypeType))
                     && JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && (Lit(Options.Option.None_q(Lit(JournalCache.Variables.journalFront(Lit(s#0)))))
                   ==> $IsA#JournalCache.Variables(Lit(s'#0))
                     && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                              Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                  dt_update#journalFrontRead#0#1, 
                                  Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                        (var dt_update#journalBackRead#0#1 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(Lit(s#0)), 
                                #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                               then #Options.Option.None()
                               else JournalCache.Variables.journalBackRead(Lit(s#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                            dt_update#journalBackRead#0#1, 
                            JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))
                     && 
                    (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                     && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                            Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                dt_update#journalFrontRead#0#1, 
                                Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                      $IsA#Options.Option(Lit(JournalCache.Variables.journalBackRead(Lit(s#0))))
                         && (
                          JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                           || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                           || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1)))))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(Lit(dop#0)), 
                  $Unbox(Options.Option.value(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))): DatatypeType)
                 && Options.Option.None_q(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
                 && Options.Option.None_q(Lit(JournalCache.Variables.journalFront(Lit(s#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              dt_update#journalFrontRead#0#1, 
                              Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                    (var dt_update#journalBackRead#0#1 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(Lit(s#0)), 
                            #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalBackRead(Lit(s#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        dt_update#journalBackRead#0#1, 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))
           ==> 
          LitInt(which#0) == LitInt(1)
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
               ==> $IsA#JournalIntervals.JournalInterval(Lit(JournalDisk.DiskOp.interval(Lit(dop#0))))
                 && $IsA#JournalIntervals.JournalInterval(Lit($Unbox(Options.Option.value(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))): DatatypeType))
                 && JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && (Lit(Options.Option.None_q(Lit(JournalCache.Variables.journalBack(Lit(s#0)))))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                        (var dt_update#journalBackRead#1#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#2#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#2#1)), 
                              dt_update#journalBackRead#1#1, 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                    (var dt_update#journalFrontRead#1#1 := (if Options.Option#Equal(JournalCache.Variables.journalFrontRead(Lit(s#0)), 
                            #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalFrontRead(Lit(s#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                        dt_update#journalFrontRead#1#1, 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))))
                 && 
                (var dt_update_tmp#2#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
                 && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                      (var dt_update#journalBackRead#1#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                        Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#2#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1)), 
                            Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#2#1)), 
                            dt_update#journalBackRead#1#1, 
                            Lit(JournalCache.Variables.journalFront(dt_update_tmp#2#1)), 
                            Lit(JournalCache.Variables.journalBack(dt_update_tmp#2#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                  $IsA#Options.Option(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
                     && (
                      JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1)))))
         && JournalCache.__default.PageInJournalReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.ReqReadJournalOp_q(Lit(dop#0))
             && JournalCache.Variables.LoadingOther_q(Lit(s#0))
             && (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1))
             && SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
               < DiskLayout.__default.NumJournalBlocks()
             && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(Lit(dop#0)), 
                  $Unbox(Options.Option.value(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))): DatatypeType)
                 && Options.Option.None_q(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
                 && Options.Option.None_q(Lit(JournalCache.Variables.journalFront(Lit(s#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              dt_update#journalFrontRead#0#1, 
                              Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                    (var dt_update#journalBackRead#0#1 := (if Options.Option#Equal(JournalCache.Variables.journalBackRead(Lit(s#0)), 
                            #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalBackRead(Lit(s#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        dt_update#journalBackRead#0#1, 
                        JournalCache.Variables.journalFront(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))
             && (LitInt(which#0) == LitInt(1)
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 && JournalIntervals.JournalInterval#Equal(JournalDisk.DiskOp.interval(Lit(dop#0)), 
                  $Unbox(Options.Option.value(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))): DatatypeType)
                 && Options.Option.None_q(Lit(JournalCache.Variables.journalBackRead(Lit(s#0))))
                 && Options.Option.None_q(Lit(JournalCache.Variables.journalBack(Lit(s#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                        (var dt_update#journalBackRead#1#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#2#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#2#1)), 
                              dt_update#journalBackRead#1#1, 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                    (var dt_update#journalFrontRead#1#1 := (if Options.Option#Equal(JournalCache.Variables.journalFrontRead(Lit(s#0)), 
                            #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                           then #Options.Option.None()
                           else JournalCache.Variables.journalFrontRead(Lit(s#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                        dt_update#journalFrontRead#1#1, 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalBack(dt_update_tmp#3#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#1))))))));

// function declaration for JournalCache._default.PageInJournalResp
function JournalCache.__default.PageInJournalResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

function JournalCache.__default.PageInJournalResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

// consequence axiom for JournalCache.__default.PageInJournalResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInJournalResp(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInJournalResp#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.PageInJournalResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for JournalCache.__default.PageInJournalResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int :: 
  { JournalCache.__default.PageInJournalResp#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.PageInJournalResp#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0)
       == true);

// definition axiom for JournalCache.__default.PageInJournalResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInJournalResp(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInJournalResp#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (which#0 == LitInt(0) || which#0 == LitInt(1)
           ==> 
          which#0 == LitInt(0)
           ==> $IsA#Options.Option(JournalCache.Variables.journalFrontRead(s#0))
             && (Options.Option#Equal(JournalCache.Variables.journalFrontRead(s#0), 
                #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#journalFrontRead#0#0 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                            dt_update#journalFrontRead#0#0, 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                    (var dt_update#journalFront#0#0 := #Options.Option.Some(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                        dt_update#journalFront#0#0, 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
                 && 
                (var dt_update_tmp#0#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                 && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                      (var dt_update#journalFrontRead#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                          dt_update#journalFrontRead#0#0, 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))))
         && ((which#0 == LitInt(0)
               ==> $IsA#Options.Option(JournalCache.Variables.journalFrontRead(s#0))
                 && (Options.Option#Equal(JournalCache.Variables.journalFrontRead(s#0), 
                    #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                   ==> $IsA#JournalCache.Variables(s'#0)
                     && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#journalFrontRead#0#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                dt_update#journalFrontRead#0#0, 
                                JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                                JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                                JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                        (var dt_update#journalFront#0#0 := #Options.Option.Some(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                            dt_update#journalFront#0#0, 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
                     && 
                    (var dt_update_tmp#0#0 := s#0; 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                     && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#journalFrontRead#0#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              dt_update#journalFrontRead#0#0, 
                              JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                              JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                              JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))))
             && (which#0 == LitInt(0)
               ==> Options.Option#Equal(JournalCache.Variables.journalFrontRead(s#0), 
                  #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#journalFrontRead#0#0 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                            dt_update#journalFrontRead#0#0, 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                    (var dt_update#journalFront#0#0 := #Options.Option.Some(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                        dt_update#journalFront#0#0, 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))
           ==> 
          which#0 == LitInt(1)
           ==> $IsA#Options.Option(JournalCache.Variables.journalBackRead(s#0))
             && (Options.Option#Equal(JournalCache.Variables.journalBackRead(s#0), 
                #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                        (var dt_update#journalBackRead#0#0 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#2#0), 
                            dt_update#journalBackRead#0#0, 
                            JournalCache.Variables.journalFront(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#2#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                    (var dt_update#journalBack#0#0 := #Options.Option.Some(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                        dt_update#journalBack#0#0, 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))))
                 && 
                (var dt_update_tmp#2#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
                 && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                      (var dt_update#journalBackRead#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#2#0), 
                          dt_update#journalBackRead#0#0, 
                          JournalCache.Variables.journalFront(dt_update_tmp#2#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#2#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0))))
         && JournalCache.__default.PageInJournalResp(k#0, s#0, s'#0, dop#0, vop#0, which#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalDisk.DiskOp.RespReadJournalOp_q(dop#0)
             && JournalCache.Variables.LoadingOther_q(s#0)
             && Options.Option.Some_q(JournalDisk.DiskOp.journal(dop#0))
             && (which#0 == LitInt(0) || which#0 == LitInt(1))
             && (which#0 == LitInt(0)
               ==> Options.Option#Equal(JournalCache.Variables.journalFrontRead(s#0), 
                  #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                        (var dt_update#journalFrontRead#0#0 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                            dt_update#journalFrontRead#0#0, 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                    (var dt_update#journalFront#0#0 := #Options.Option.Some(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#0), 
                        dt_update#journalFront#0#0, 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))
             && (which#0 == LitInt(1)
               ==> Options.Option#Equal(JournalCache.Variables.journalBackRead(s#0), 
                  #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                        (var dt_update#journalBackRead#0#0 := Lit(#Options.Option.None()); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#2#0), 
                            dt_update#journalBackRead#0#0, 
                            JournalCache.Variables.journalFront(dt_update_tmp#2#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#2#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                    (var dt_update#journalBack#0#0 := #Options.Option.Some(Options.Option.value(JournalDisk.DiskOp.journal(dop#0))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#0), 
                        dt_update#journalBack#0#0, 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#0))))))));

// definition axiom for JournalCache.__default.PageInJournalResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    {:weight 3} { JournalCache.__default.PageInJournalResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0)) } 
    JournalCache.__default.PageInJournalResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1)
           ==> 
          LitInt(which#0) == LitInt(0)
           ==> $IsA#Options.Option(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
             && (Options.Option#Equal(JournalCache.Variables.journalFrontRead(Lit(s#0)), 
                #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.None()); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              dt_update#journalFrontRead#0#1, 
                              Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                    (var dt_update#journalFront#0#1 := Lit(#Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box)))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                        dt_update#journalFront#0#1, 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))
                 && 
                (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                 && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                      (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.None()); 
                        Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                            dt_update#journalFrontRead#0#1, 
                            Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))))
         && ((LitInt(which#0) == LitInt(0)
               ==> $IsA#Options.Option(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
                 && (Options.Option#Equal(JournalCache.Variables.journalFrontRead(Lit(s#0)), 
                    #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                   ==> $IsA#JournalCache.Variables(Lit(s'#0))
                     && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.None()); 
                              Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                  LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                  dt_update#journalFrontRead#0#1, 
                                  Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                        (var dt_update#journalFront#0#1 := Lit(#Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box)))); 
                          #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                            dt_update#journalFront#0#1, 
                            JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))
                     && 
                    (var dt_update_tmp#0#1 := Lit(s#0); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                     && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.None()); 
                            Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                dt_update#journalFrontRead#0#1, 
                                Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                      JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                         || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option#Equal(JournalCache.Variables.journalFrontRead(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.None()); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              dt_update#journalFrontRead#0#1, 
                              Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                    (var dt_update#journalFront#0#1 := Lit(#Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box)))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                        dt_update#journalFront#0#1, 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))
           ==> 
          LitInt(which#0) == LitInt(1)
           ==> $IsA#Options.Option(Lit(JournalCache.Variables.journalBackRead(Lit(s#0))))
             && (Options.Option#Equal(JournalCache.Variables.journalBackRead(Lit(s#0)), 
                #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                        (var dt_update#journalBackRead#0#1 := Lit(#Options.Option.None()); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#2#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#2#1)), 
                              dt_update#journalBackRead#0#1, 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                    (var dt_update#journalBack#0#1 := Lit(#Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box)))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                        dt_update#journalBack#0#1, 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))))
                 && 
                (var dt_update_tmp#2#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
                 && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                      (var dt_update#journalBackRead#0#1 := Lit(#Options.Option.None()); 
                        Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#2#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1)), 
                            Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#2#1)), 
                            dt_update#journalBackRead#0#1, 
                            Lit(JournalCache.Variables.journalFront(dt_update_tmp#2#1)), 
                            Lit(JournalCache.Variables.journalBack(dt_update_tmp#2#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1))))
         && JournalCache.__default.PageInJournalResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0))
             && JournalCache.Variables.LoadingOther_q(Lit(s#0))
             && Options.Option.Some_q(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))
             && (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option#Equal(JournalCache.Variables.journalFrontRead(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                        (var dt_update#journalFrontRead#0#1 := Lit(#Options.Option.None()); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                              dt_update#journalFrontRead#0#1, 
                              Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                    (var dt_update#journalFront#0#1 := Lit(#Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box)))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#1#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#1#1), 
                        dt_update#journalFront#0#1, 
                        JournalCache.Variables.journalBack(dt_update_tmp#1#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))
             && (LitInt(which#0) == LitInt(1)
               ==> Options.Option#Equal(JournalCache.Variables.journalBackRead(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                        (var dt_update#journalBackRead#0#1 := Lit(#Options.Option.None()); 
                          Lit(#JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#2#1)), 
                              LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#2#1)), 
                              dt_update#journalBackRead#0#1, 
                              Lit(JournalCache.Variables.journalFront(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.journalBack(dt_update_tmp#2#1)), 
                              Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                    (var dt_update#journalBack#0#1 := Lit(#Options.Option.Some($Box(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.journal(Lit(dop#0))))): Seq Box)))); 
                      #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#3#1), 
                        JournalCache.Variables.journalFront(dt_update_tmp#3#1), 
                        dt_update#journalBack#0#1, 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#1))))))));

// function declaration for JournalCache._default.PageInSuperblockReq
function JournalCache.__default.PageInSuperblockReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

function JournalCache.__default.PageInSuperblockReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

// consequence axiom for JournalCache.__default.PageInSuperblockReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInSuperblockReq(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInSuperblockReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.PageInSuperblockReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for JournalCache.__default.PageInSuperblockReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int :: 
  { JournalCache.__default.PageInSuperblockReq#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.PageInSuperblockReq#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0)
       == true);

// definition axiom for JournalCache.__default.PageInSuperblockReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInSuperblockReq(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInSuperblockReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (which#0 == LitInt(0) || which#0 == LitInt(1)
           ==> 
          which#0 == LitInt(0)
           ==> 
          JournalCache.SuperblockReadResult.SuperblockUnfinished_q(JournalCache.Variables.superblock1(s#0))
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#outstandingSuperblock1Read#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                  #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0)))
         && ((which#0 == LitInt(0)
               ==> 
              JournalCache.SuperblockReadResult.SuperblockUnfinished_q(JournalCache.Variables.superblock1(s#0))
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#outstandingSuperblock1Read#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                      #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0)))
             && (which#0 == LitInt(0)
               ==> Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0))
                 && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(JournalCache.Variables.superblock1(s#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#outstandingSuperblock1Read#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                      #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0))))))
           ==> 
          which#0 == LitInt(1)
           ==> 
          JournalCache.SuperblockReadResult.SuperblockUnfinished_q(JournalCache.Variables.superblock2(s#0))
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := s#0; 
                (var dt_update#outstandingSuperblock2Read#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                  #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#0), 
                    dt_update#outstandingSuperblock2Read#0#0, 
                    JournalCache.Variables.superblock1(dt_update_tmp#1#0), 
                    JournalCache.Variables.superblock2(dt_update_tmp#1#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
             && (var dt_update_tmp#1#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0)))
         && JournalCache.__default.PageInSuperblockReq(k#0, s#0, s'#0, dop#0, vop#0, which#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalDisk.DiskOp.ReqReadSuperblockOp_q(dop#0)
             && JournalCache.Variables.LoadingSuperblock_q(s#0)
             && JournalDisk.DiskOp.which(dop#0) == which#0
             && (which#0 == LitInt(0) || which#0 == LitInt(1))
             && (which#0 == LitInt(0)
               ==> Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0))
                 && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(JournalCache.Variables.superblock1(s#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#outstandingSuperblock1Read#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                      #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0))))))
             && (which#0 == LitInt(1)
               ==> Options.Option.None_q(JournalCache.Variables.outstandingSuperblock2Read(s#0))
                 && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(JournalCache.Variables.superblock2(s#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#0 := s#0; 
                    (var dt_update#outstandingSuperblock2Read#0#0 := #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))); 
                      #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#0), 
                        dt_update#outstandingSuperblock2Read#0#0, 
                        JournalCache.Variables.superblock1(dt_update_tmp#1#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#1#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))));

// definition axiom for JournalCache.__default.PageInSuperblockReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    {:weight 3} { JournalCache.__default.PageInSuperblockReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0)) } 
    JournalCache.__default.PageInSuperblockReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1)
           ==> 
          LitInt(which#0) == LitInt(0)
           ==> 
          Lit(JournalCache.SuperblockReadResult.SuperblockUnfinished_q(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                  Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                      Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1)))
         && ((LitInt(which#0) == LitInt(0)
               ==> 
              Lit(JournalCache.SuperblockReadResult.SuperblockUnfinished_q(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                      Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                          Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1)))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0))))
                 && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                      Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                          Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))))))
           ==> 
          LitInt(which#0) == LitInt(1)
           ==> 
          Lit(JournalCache.SuperblockReadResult.SuperblockUnfinished_q(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := Lit(s#0); 
                (var dt_update#outstandingSuperblock2Read#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                  Lit(#JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#1)), 
                      dt_update#outstandingSuperblock2Read#0#1, 
                      Lit(JournalCache.Variables.superblock1(dt_update_tmp#1#1)), 
                      Lit(JournalCache.Variables.superblock2(dt_update_tmp#1#1)), 
                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))))
             && (var dt_update_tmp#1#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1)))
         && JournalCache.__default.PageInSuperblockReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.ReqReadSuperblockOp_q(Lit(dop#0))
             && JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))
             && LitInt(JournalDisk.DiskOp.which(Lit(dop#0))) == LitInt(which#0)
             && (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1))
             && (LitInt(which#0) == LitInt(0)
               ==> Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0))))
                 && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                      Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                          Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))))))
             && (LitInt(which#0) == LitInt(1)
               ==> Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0))))
                 && JournalCache.SuperblockReadResult.SuperblockUnfinished_q(Lit(JournalCache.Variables.superblock2(Lit(s#0))))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#1#1 := Lit(s#0); 
                    (var dt_update#outstandingSuperblock2Read#0#1 := Lit(#Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0)))))); 
                      Lit(#JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#1)), 
                          dt_update#outstandingSuperblock2Read#0#1, 
                          Lit(JournalCache.Variables.superblock1(dt_update_tmp#1#1)), 
                          Lit(JournalCache.Variables.superblock2(dt_update_tmp#1#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))))));

// function declaration for JournalCache._default.PageInSuperblockResp
function JournalCache.__default.PageInSuperblockResp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

function JournalCache.__default.PageInSuperblockResp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int)
   : bool;

// consequence axiom for JournalCache.__default.PageInSuperblockResp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInSuperblockResp#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.PageInSuperblockResp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for JournalCache.__default.PageInSuperblockResp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    which#0: int :: 
  { JournalCache.__default.PageInSuperblockResp#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.PageInSuperblockResp#requires(k#0, s#0, s'#0, dop#0, vop#0, which#0)
       == true);

// definition axiom for JournalCache.__default.PageInSuperblockResp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    { JournalCache.__default.PageInSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0, which#0) } 
    JournalCache.__default.PageInSuperblockResp#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalCache.Variables.LoadingSuperblock_q(s#0)
           ==> (Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
               ==> JournalCache.__default.WFSuperblock#canCall($Unbox(Options.Option.value(JournalDisk.DiskOp.superblock(dop#0))): DatatypeType))
             && (var sup#0 := (if Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                     && JournalCache.__default.WFSuperblock($Unbox(Options.Option.value(JournalDisk.DiskOp.superblock(dop#0))): DatatypeType)
                   then #JournalCache.SuperblockReadResult.SuperblockSuccess($Unbox(Options.Option.value(JournalDisk.DiskOp.superblock(dop#0))): DatatypeType)
                   else #JournalCache.SuperblockReadResult.SuperblockCorruption()); 
              (which#0 == LitInt(0) || which#0 == LitInt(1)
                   ==> 
                  which#0 == LitInt(0)
                   ==> $IsA#Options.Option(JournalCache.Variables.outstandingSuperblock1Read(s#0))
                     && (Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(s#0), 
                        #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                       ==> $IsA#JournalCache.Variables(s'#0)
                         && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#outstandingSuperblock1Read#0#0 := Lit(#Options.Option.None()); 
                                  #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                            (var dt_update#superblock1#0#0 := sup#0; 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#0), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#0), 
                                dt_update#superblock1#0#0, 
                                JournalCache.Variables.superblock2(dt_update_tmp#1#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
                         && 
                        (var dt_update_tmp#0#0 := s#0; 
                          JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                         && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                              (var dt_update#outstandingSuperblock1Read#0#0 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                                  JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                                  JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                          JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))))
                 && ((which#0 == LitInt(0)
                       ==> $IsA#Options.Option(JournalCache.Variables.outstandingSuperblock1Read(s#0))
                         && (Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(s#0), 
                            #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                           ==> $IsA#JournalCache.Variables(s'#0)
                             && $IsA#JournalCache.Variables((var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                    (var dt_update#outstandingSuperblock1Read#0#0 := Lit(#Options.Option.None()); 
                                      #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                (var dt_update#superblock1#0#0 := sup#0; 
                                  #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#0), 
                                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#0), 
                                    dt_update#superblock1#0#0, 
                                    JournalCache.Variables.superblock2(dt_update_tmp#1#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))))
                             && 
                            (var dt_update_tmp#0#0 := s#0; 
                              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
                             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                  (var dt_update#outstandingSuperblock1Read#0#0 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                                      JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                                      JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                                      JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                              JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))))
                     && (which#0 == LitInt(0)
                       ==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(s#0), 
                          #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                         && JournalCache.Variables#Equal(s'#0, 
                          (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                (var dt_update#outstandingSuperblock1Read#0#0 := Lit(#Options.Option.None()); 
                                  #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                                    JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                            (var dt_update#superblock1#0#0 := sup#0; 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#0), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#0), 
                                dt_update#superblock1#0#0, 
                                JournalCache.Variables.superblock2(dt_update_tmp#1#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))
                   ==> 
                  which#0 == LitInt(1)
                   ==> $IsA#Options.Option(JournalCache.Variables.outstandingSuperblock2Read(s#0))
                     && (Options.Option#Equal(JournalCache.Variables.outstandingSuperblock2Read(s#0), 
                        #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                       ==> $IsA#JournalCache.Variables(s'#0)
                         && $IsA#JournalCache.Variables((var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                                (var dt_update#outstandingSuperblock2Read#0#0 := Lit(#Options.Option.None()); 
                                  #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#2#0), 
                                    dt_update#outstandingSuperblock2Read#0#0, 
                                    JournalCache.Variables.superblock1(dt_update_tmp#2#0), 
                                    JournalCache.Variables.superblock2(dt_update_tmp#2#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                            (var dt_update#superblock2#0#0 := sup#0; 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#3#0), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#3#0), 
                                JournalCache.Variables.superblock1(dt_update_tmp#3#0), 
                                dt_update#superblock2#0#0, 
                                JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))))
                         && 
                        (var dt_update_tmp#2#0 := s#0; 
                          JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
                         && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                              (var dt_update#outstandingSuperblock2Read#0#0 := Lit(#Options.Option.None()); 
                                #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#2#0), 
                                  dt_update#outstandingSuperblock2Read#0#0, 
                                  JournalCache.Variables.superblock1(dt_update_tmp#2#0), 
                                  JournalCache.Variables.superblock2(dt_update_tmp#2#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                          JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0))))))
         && JournalCache.__default.PageInSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0, which#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0)
             && JournalCache.Variables.LoadingSuperblock_q(s#0)
             && (var sup#0 := (if Options.Option.Some_q(JournalDisk.DiskOp.superblock(dop#0))
                     && JournalCache.__default.WFSuperblock($Unbox(Options.Option.value(JournalDisk.DiskOp.superblock(dop#0))): DatatypeType)
                   then #JournalCache.SuperblockReadResult.SuperblockSuccess($Unbox(Options.Option.value(JournalDisk.DiskOp.superblock(dop#0))): DatatypeType)
                   else #JournalCache.SuperblockReadResult.SuperblockCorruption()); 
              which#0 == JournalDisk.DiskOp.which(dop#0)
                 && (which#0 == LitInt(0) || which#0 == LitInt(1))
                 && (which#0 == LitInt(0)
                   ==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(s#0), 
                      #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                     && JournalCache.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                            (var dt_update#outstandingSuperblock1Read#0#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#0, 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                                JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                                JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                        (var dt_update#superblock1#0#0 := sup#0; 
                          #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#0), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#0), 
                            dt_update#superblock1#0#0, 
                            JournalCache.Variables.superblock2(dt_update_tmp#1#0), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#0))))))
                 && (which#0 == LitInt(1)
                   ==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock2Read(s#0), 
                      #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))
                     && JournalCache.Variables#Equal(s'#0, 
                      (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := s#0; 
                            (var dt_update#outstandingSuperblock2Read#0#0 := Lit(#Options.Option.None()); 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#2#0), 
                                dt_update#outstandingSuperblock2Read#0#0, 
                                JournalCache.Variables.superblock1(dt_update_tmp#2#0), 
                                JournalCache.Variables.superblock2(dt_update_tmp#2#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                        (var dt_update#superblock2#0#0 := sup#0; 
                          #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#3#0), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#3#0), 
                            JournalCache.Variables.superblock1(dt_update_tmp#3#0), 
                            dt_update#superblock2#0#0, 
                            JournalCache.Variables.syncReqs(dt_update_tmp#3#0)))))))));

// definition axiom for JournalCache.__default.PageInSuperblockResp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      which#0: int :: 
    {:weight 3} { JournalCache.__default.PageInSuperblockResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0)) } 
    JournalCache.__default.PageInSuperblockResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
           ==> (Lit(Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0)))))
               ==> JournalCache.__default.WFSuperblock#canCall(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))): DatatypeType)))
             && (var sup#1 := (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                     && JournalCache.__default.WFSuperblock(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))): DatatypeType))
                   then #JournalCache.SuperblockReadResult.SuperblockSuccess(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))): DatatypeType))
                   else #JournalCache.SuperblockReadResult.SuperblockCorruption()); 
              (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1)
                   ==> 
                  LitInt(which#0) == LitInt(0)
                   ==> $IsA#Options.Option(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0))))
                     && (Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)), 
                        #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                       ==> $IsA#JournalCache.Variables(Lit(s'#0))
                         && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.None()); 
                                  Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                                      Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                                      Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                                      Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                            (var dt_update#superblock1#0#1 := sup#1; 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#1), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#1), 
                                dt_update#superblock1#0#1, 
                                JournalCache.Variables.superblock2(dt_update_tmp#1#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))
                         && 
                        (var dt_update_tmp#0#1 := Lit(s#0); 
                          JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                         && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                              (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.None()); 
                                Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                                    Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                          JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))))
                 && ((LitInt(which#0) == LitInt(0)
                       ==> $IsA#Options.Option(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0))))
                         && (Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)), 
                            #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                           ==> $IsA#JournalCache.Variables(Lit(s'#0))
                             && $IsA#JournalCache.Variables((var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                    (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.None()); 
                                      Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                                          Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                (var dt_update#superblock1#0#1 := sup#1; 
                                  #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#1), 
                                    JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#1), 
                                    dt_update#superblock1#0#1, 
                                    JournalCache.Variables.superblock2(dt_update_tmp#1#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))
                             && 
                            (var dt_update_tmp#0#1 := Lit(s#0); 
                              JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
                             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                  (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.None()); 
                                    Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                                        Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                              JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))))
                     && (LitInt(which#0) == LitInt(0)
                       ==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)), 
                          #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                         && JournalCache.Variables#Equal(s'#0, 
                          (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.None()); 
                                  Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                                      Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                                      Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                                      Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                            (var dt_update#superblock1#0#1 := sup#1; 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#1), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#1), 
                                dt_update#superblock1#0#1, 
                                JournalCache.Variables.superblock2(dt_update_tmp#1#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))
                   ==> 
                  LitInt(which#0) == LitInt(1)
                   ==> $IsA#Options.Option(Lit(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0))))
                     && (Options.Option#Equal(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0)), 
                        #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                       ==> $IsA#JournalCache.Variables(Lit(s'#0))
                         && $IsA#JournalCache.Variables((var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                                (var dt_update#outstandingSuperblock2Read#0#1 := Lit(#Options.Option.None()); 
                                  Lit(#JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#2#1)), 
                                      dt_update#outstandingSuperblock2Read#0#1, 
                                      Lit(JournalCache.Variables.superblock1(dt_update_tmp#2#1)), 
                                      Lit(JournalCache.Variables.superblock2(dt_update_tmp#2#1)), 
                                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                            (var dt_update#superblock2#0#1 := sup#1; 
                              #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#3#1), 
                                JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#3#1), 
                                JournalCache.Variables.superblock1(dt_update_tmp#3#1), 
                                dt_update#superblock2#0#1, 
                                JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))))
                         && 
                        (var dt_update_tmp#2#1 := Lit(s#0); 
                          JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
                         && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                              (var dt_update#outstandingSuperblock2Read#0#1 := Lit(#Options.Option.None()); 
                                Lit(#JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#2#1)), 
                                    dt_update#outstandingSuperblock2Read#0#1, 
                                    Lit(JournalCache.Variables.superblock1(dt_update_tmp#2#1)), 
                                    Lit(JournalCache.Variables.superblock2(dt_update_tmp#2#1)), 
                                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                          JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                             || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                             || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1))))))
         && JournalCache.__default.PageInSuperblockResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(which#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0))
             && JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))
             && (var sup#1 := (if Options.Option.Some_q(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))
                     && JournalCache.__default.WFSuperblock(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))): DatatypeType))
                   then #JournalCache.SuperblockReadResult.SuperblockSuccess(Lit($Unbox(Options.Option.value(Lit(JournalDisk.DiskOp.superblock(Lit(dop#0))))): DatatypeType))
                   else #JournalCache.SuperblockReadResult.SuperblockCorruption()); 
              LitInt(which#0) == LitInt(JournalDisk.DiskOp.which(Lit(dop#0)))
                 && (LitInt(which#0) == LitInt(0) || LitInt(which#0) == LitInt(1))
                 && (LitInt(which#0) == LitInt(0)
                   ==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)), 
                      #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                     && JournalCache.Variables#Equal(s'#0, 
                      (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                            (var dt_update#outstandingSuperblock1Read#0#1 := Lit(#Options.Option.None()); 
                              Lit(#JournalCache.Variables.LoadingSuperblock(dt_update#outstandingSuperblock1Read#0#1, 
                                  Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                        (var dt_update#superblock1#0#1 := sup#1; 
                          #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#1#1), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#1#1), 
                            dt_update#superblock1#0#1, 
                            JournalCache.Variables.superblock2(dt_update_tmp#1#1), 
                            JournalCache.Variables.syncReqs(dt_update_tmp#1#1))))))
                 && (LitInt(which#0) == LitInt(1)
                   ==> Options.Option#Equal(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0)), 
                      #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))
                     && JournalCache.Variables#Equal(s'#0, 
                      (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := Lit(s#0); 
                            (var dt_update#outstandingSuperblock2Read#0#1 := Lit(#Options.Option.None()); 
                              Lit(#JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#2#1)), 
                                  dt_update#outstandingSuperblock2Read#0#1, 
                                  Lit(JournalCache.Variables.superblock1(dt_update_tmp#2#1)), 
                                  Lit(JournalCache.Variables.superblock2(dt_update_tmp#2#1)), 
                                  Lit(JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))))); 
                        (var dt_update#superblock2#0#1 := sup#1; 
                          #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#3#1), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#3#1), 
                            JournalCache.Variables.superblock1(dt_update_tmp#3#1), 
                            dt_update#superblock2#0#1, 
                            JournalCache.Variables.syncReqs(dt_update_tmp#3#1)))))))));

// function declaration for JournalCache._default.FinishLoadingSuperblockPhase
function JournalCache.__default.FinishLoadingSuperblockPhase(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.FinishLoadingSuperblockPhase#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.FinishLoadingSuperblockPhase
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.FinishLoadingSuperblockPhase(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.FinishLoadingSuperblockPhase#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.FinishLoadingSuperblockPhase#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.FinishLoadingSuperblockPhase
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.FinishLoadingSuperblockPhase#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.FinishLoadingSuperblockPhase#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.FinishLoadingSuperblockPhase(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.FinishLoadingSuperblockPhase(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.FinishLoadingSuperblockPhase#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock1(s#0))
             || JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock2(s#0))
           ==> $IsA#JournalCache.Variables(s'#0)
             && 
            JournalCache.__default.SelectSuperblock#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
              JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))
             && JournalCache.__default.SelectSuperblockIndex#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
              JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))
             && (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0)))
         && ($IsA#JournalCache.Variables(s'#0)
             && 
            JournalCache.__default.SelectSuperblock#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
              JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))
             && JournalCache.__default.SelectSuperblockIndex#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
              JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))
             && (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && JournalCache.Variables#Equal(s'#0, 
              #JournalCache.Variables.LoadingOther(JournalCache.__default.SelectSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                  JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0))), 
                JournalCache.__default.SelectSuperblockIndex(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                  JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0))), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                JournalCache.Variables.syncReqs(s#0)))
           ==> $IsA#DiskLayout.Location(ViewOp.VOp.loc(vop#0))
             && $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc(JournalCache.__default.SelectSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                  JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))))
             && 
            JournalCache.__default.SelectSuperblock#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
              JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))
             && SectorType.Superblock.Superblock_q(JournalCache.__default.SelectSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))))
         && JournalCache.__default.FinishLoadingSuperblockPhase(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.SendPersistentLocOp_q(vop#0)
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && JournalCache.Variables.LoadingSuperblock_q(s#0)
             && JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock1(s#0))
             && JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock2(s#0))
             && (JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock1(s#0))
               || JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock2(s#0)))
             && JournalCache.Variables#Equal(s'#0, 
              #JournalCache.Variables.LoadingOther(JournalCache.__default.SelectSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                  JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0))), 
                JournalCache.__default.SelectSuperblockIndex(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                  JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0))), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                JournalCache.Variables.syncReqs(s#0)))
             && DiskLayout.Location#Equal(ViewOp.VOp.loc(vop#0), 
              SectorType.Superblock.indirectionTableLoc(JournalCache.__default.SelectSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)), 
                  JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0)))))));

// definition axiom for JournalCache.__default.FinishLoadingSuperblockPhase for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.FinishLoadingSuperblockPhase(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.FinishLoadingSuperblockPhase#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
               || JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && 
            JournalCache.__default.SelectSuperblock#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
              Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))
             && JournalCache.__default.SelectSuperblockIndex#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
              Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))
             && (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))))
         && ($IsA#JournalCache.Variables(Lit(s'#0))
             && 
            JournalCache.__default.SelectSuperblock#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
              Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))
             && JournalCache.__default.SelectSuperblockIndex#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
              Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))
             && (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && JournalCache.Variables#Equal(s'#0, 
              #JournalCache.Variables.LoadingOther(Lit(JournalCache.__default.SelectSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                    Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))), 
                LitInt(JournalCache.__default.SelectSuperblockIndex(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                    Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(JournalCache.Variables.syncReqs(Lit(s#0)))))
           ==> $IsA#DiskLayout.Location(Lit(ViewOp.VOp.loc(Lit(vop#0))))
             && $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.__default.SelectSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                      Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))))))
             && 
            JournalCache.__default.SelectSuperblock#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
              Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))
             && SectorType.Superblock.Superblock_q(Lit(JournalCache.__default.SelectSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                  Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))))))
         && JournalCache.__default.FinishLoadingSuperblockPhase(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.SendPersistentLocOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))
             && JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
             && JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock2(Lit(s#0))))
             && (JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
               || JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))
             && JournalCache.Variables#Equal(s'#0, 
              #JournalCache.Variables.LoadingOther(Lit(JournalCache.__default.SelectSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                    Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))), 
                LitInt(JournalCache.__default.SelectSuperblockIndex(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                    Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0))))))), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(#Options.Option.None()), 
                Lit(JournalCache.Variables.syncReqs(Lit(s#0)))))
             && DiskLayout.Location#Equal(ViewOp.VOp.loc(Lit(vop#0)), 
              SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.__default.SelectSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0))))), 
                    Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))))))));

// function declaration for JournalCache._default.FinishLoadingOtherPhase
function JournalCache.__default.FinishLoadingOtherPhase(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.FinishLoadingOtherPhase#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.FinishLoadingOtherPhase
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.FinishLoadingOtherPhase(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.FinishLoadingOtherPhase#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.FinishLoadingOtherPhase#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.FinishLoadingOtherPhase
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.FinishLoadingOtherPhase#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.FinishLoadingOtherPhase#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.FinishLoadingOtherPhase(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.FinishLoadingOtherPhase(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.FinishLoadingOtherPhase#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalCache.Variables.LoadingOther_q(s#0)
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               < DiskLayout.__default.NumJournalBlocks()
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && (JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
             && (Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> Options.Option.Some_q(JournalCache.Variables.journalFront(s#0)))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && (JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
             && (Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> Options.Option.Some_q(JournalCache.Variables.journalBack(s#0)))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
             && (Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> JournalRanges.__default.JournalRangeConcat#canCall($Unbox(Options.Option.value(JournalCache.Variables.journalFront(s#0))): Seq Box, 
                $Unbox(Options.Option.value(JournalCache.Variables.journalBack(s#0))): Seq Box))
             && (!Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0))
                 && (!Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                   ==> JournalRanges.__default.JournalRangeEmpty#canCall()))
             && (var fullRange#0 := (if Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                   then JournalRanges.__default.JournalRangeConcat($Unbox(Options.Option.value(JournalCache.Variables.journalFront(s#0))): Seq Box, 
                    $Unbox(Options.Option.value(JournalCache.Variables.journalBack(s#0))): Seq Box)
                   else (if Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                     then $Unbox(Options.Option.value(JournalCache.Variables.journalFront(s#0))): Seq Box
                     else JournalRanges.__default.JournalRangeEmpty())); 
              (JournalCache.Variables.Ready_q(s'#0)
                   ==> $IsA#Options.Option(JournalCache.Variables.superblockWrite(s'#0)))
                 && (Set#Equal(JournalCache.Variables.outstandingJournalWrites(s'#0), Set#Empty(): Set Box)
                   ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
                 && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                     && JournalCache.Variables.writtenJournalLen(s'#0)
                       == SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
                   ==> JournalRanges.__default.JournalRangeParses#canCall(fullRange#0, JournalCache.Variables.replayJournal(s'#0)))
                 && (JournalRanges.__default.JournalRangeParses#canCall(fullRange#0, JournalCache.Variables.replayJournal(s'#0))
                     && JournalRanges.__default.JournalRangeParses(fullRange#0, JournalCache.Variables.replayJournal(s'#0))
                   ==> $IsA#SectorType.Superblock(JournalCache.Variables.superblock(s'#0))
                     && $IsA#SectorType.Superblock(JournalCache.Variables.superblock(s#0)))
                 && (JournalCache.Variables.whichSuperblock(s'#0)
                     == JournalCache.Variables.whichSuperblock(s#0)
                   ==> $IsA#Options.Option(JournalCache.Variables.newSuperblock(s'#0)))
                 && ($IsA#Options.Option(JournalCache.Variables.newSuperblock(s'#0))
                     && Options.Option#Equal(JournalCache.Variables.newSuperblock(s'#0), #Options.Option.None())
                   ==> (
                      JournalCache.Variables.Ready_q(s'#0)
                       || JournalCache.Variables.LoadingOther_q(s'#0)
                       || JournalCache.Variables.LoadingSuperblock_q(s'#0))
                     && (
                      JournalCache.Variables.Ready_q(s#0)
                       || JournalCache.Variables.LoadingOther_q(s#0)
                       || JournalCache.Variables.LoadingSuperblock_q(s#0)))
                 && (JournalCache.Variables.isFrozen(s'#0) == Lit(false)
                   ==> $IsA#Options.Option(JournalCache.Variables.frozenLoc(s'#0)))
                 && ($IsA#Options.Option(JournalCache.Variables.frozenLoc(s'#0))
                     && Options.Option#Equal(JournalCache.Variables.frozenLoc(s'#0), #Options.Option.None())
                   ==> $IsA#JournalCache.CommitStatus(JournalCache.Variables.commitStatus(s'#0)))))
         && JournalCache.__default.FinishLoadingOtherPhase(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.JournalInternalOp_q(vop#0)
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && JournalCache.Variables.LoadingOther_q(s#0)
             && SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               < DiskLayout.__default.NumJournalBlocks()
             && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> Options.Option.Some_q(JournalCache.Variables.journalFront(s#0)))
             && (Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
               ==> Options.Option.Some_q(JournalCache.Variables.journalBack(s#0)))
             && (var fullRange#0 := (if Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                   then JournalRanges.__default.JournalRangeConcat($Unbox(Options.Option.value(JournalCache.Variables.journalFront(s#0))): Seq Box, 
                    $Unbox(Options.Option.value(JournalCache.Variables.journalBack(s#0))): Seq Box)
                   else (if Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0)))
                     then $Unbox(Options.Option.value(JournalCache.Variables.journalFront(s#0))): Seq Box
                     else JournalRanges.__default.JournalRangeEmpty())); 
              JournalCache.Variables.Ready_q(s'#0)
                 && Options.Option#Equal(JournalCache.Variables.superblockWrite(s'#0), #Options.Option.None())
                 && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s'#0), Seq#Empty(): Seq Box)
                 && Seq#Equal(JournalCache.Variables.inMemoryJournal(s'#0), Seq#Empty(): Seq Box)
                 && Set#Equal(JournalCache.Variables.outstandingJournalWrites(s'#0), Set#Empty(): Set Box)
                 && JournalCache.Variables.writtenJournalLen(s'#0)
                   == SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
                 && JournalRanges.__default.JournalRangeParses(fullRange#0, JournalCache.Variables.replayJournal(s'#0))
                 && SectorType.Superblock#Equal(JournalCache.Variables.superblock(s'#0), JournalCache.Variables.superblock(s#0))
                 && JournalCache.Variables.whichSuperblock(s'#0)
                   == JournalCache.Variables.whichSuperblock(s#0)
                 && Options.Option#Equal(JournalCache.Variables.newSuperblock(s'#0), #Options.Option.None())
                 && Map#Equal(JournalCache.Variables.syncReqs(s'#0), JournalCache.Variables.syncReqs(s#0))
                 && JournalCache.Variables.isFrozen(s'#0) == Lit(false)
                 && Options.Option#Equal(JournalCache.Variables.frozenLoc(s'#0), #Options.Option.None())
                 && JournalCache.CommitStatus#Equal(JournalCache.Variables.commitStatus(s'#0), 
                  #JournalCache.CommitStatus.CommitNone()))));

// definition axiom for JournalCache.__default.FinishLoadingOtherPhase for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.FinishLoadingOtherPhase(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.FinishLoadingOtherPhase#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalCache.Variables.LoadingOther_q(Lit(s#0)))
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && Lit(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 < DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall())
         && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && DiskLayout.__default.NumJournalBlocks#canCall()
             && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && (JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 ==> Options.Option.Some_q(Lit(JournalCache.Variables.journalFront(Lit(s#0)))))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && (JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 ==> Options.Option.Some_q(Lit(JournalCache.Variables.journalBack(Lit(s#0)))))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
               ==> JournalRanges.__default.JournalRangeConcat#canCall(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.journalFront(Lit(s#0))))): Seq Box), 
                Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.journalBack(Lit(s#0))))): Seq Box)))
             && (!Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && (!Lit(Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
                   ==> JournalRanges.__default.JournalRangeEmpty#canCall()))
             && (var fullRange#1 := (if Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                   then JournalRanges.__default.JournalRangeConcat(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.journalFront(Lit(s#0))))): Seq Box), 
                    Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.journalBack(Lit(s#0))))): Seq Box))
                   else (if Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                     then $Unbox(Options.Option.value(Lit(JournalCache.Variables.journalFront(Lit(s#0))))): Seq Box
                     else JournalRanges.__default.JournalRangeEmpty())); 
              (Lit(JournalCache.Variables.Ready_q(Lit(s'#0)))
                   ==> $IsA#Options.Option(Lit(JournalCache.Variables.superblockWrite(Lit(s'#0)))))
                 && (Set#Equal(JournalCache.Variables.outstandingJournalWrites(Lit(s'#0)), Set#Empty(): Set Box)
                   ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                     && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s'#0)))
                       == LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   ==> JournalRanges.__default.JournalRangeParses#canCall(fullRange#1, Lit(JournalCache.Variables.replayJournal(Lit(s'#0)))))
                 && (JournalRanges.__default.JournalRangeParses#canCall(fullRange#1, Lit(JournalCache.Variables.replayJournal(Lit(s'#0))))
                     && JournalRanges.__default.JournalRangeParses(fullRange#1, Lit(JournalCache.Variables.replayJournal(Lit(s'#0))))
                   ==> $IsA#SectorType.Superblock(Lit(JournalCache.Variables.superblock(Lit(s'#0))))
                     && $IsA#SectorType.Superblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && (LitInt(JournalCache.Variables.whichSuperblock(Lit(s'#0)))
                     == LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0)))
                   ==> $IsA#Options.Option(Lit(JournalCache.Variables.newSuperblock(Lit(s'#0)))))
                 && ($IsA#Options.Option(Lit(JournalCache.Variables.newSuperblock(Lit(s'#0))))
                     && Options.Option#Equal(JournalCache.Variables.newSuperblock(Lit(s'#0)), #Options.Option.None())
                   ==> (
                      JournalCache.Variables.Ready_q(Lit(s'#0))
                       || JournalCache.Variables.LoadingOther_q(Lit(s'#0))
                       || JournalCache.Variables.LoadingSuperblock_q(Lit(s'#0)))
                     && (
                      JournalCache.Variables.Ready_q(Lit(s#0))
                       || JournalCache.Variables.LoadingOther_q(Lit(s#0))
                       || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))))
                 && (Lit(JournalCache.Variables.isFrozen(Lit(s'#0))) == Lit(false)
                   ==> $IsA#Options.Option(Lit(JournalCache.Variables.frozenLoc(Lit(s'#0)))))
                 && ($IsA#Options.Option(Lit(JournalCache.Variables.frozenLoc(Lit(s'#0))))
                     && Options.Option#Equal(JournalCache.Variables.frozenLoc(Lit(s'#0)), #Options.Option.None())
                   ==> $IsA#JournalCache.CommitStatus(Lit(JournalCache.Variables.commitStatus(Lit(s'#0)))))))
         && JournalCache.__default.FinishLoadingOtherPhase(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && JournalCache.Variables.LoadingOther_q(Lit(s#0))
             && SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))
               < DiskLayout.__default.NumJournalBlocks()
             && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && (Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
               ==> Options.Option.Some_q(Lit(JournalCache.Variables.journalFront(Lit(s#0)))))
             && (Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
               ==> Options.Option.Some_q(Lit(JournalCache.Variables.journalBack(Lit(s#0)))))
             && (var fullRange#1 := (if Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                   then JournalRanges.__default.JournalRangeConcat(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.journalFront(Lit(s#0))))): Seq Box), 
                    Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.journalBack(Lit(s#0))))): Seq Box))
                   else (if Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                     then $Unbox(Options.Option.value(Lit(JournalCache.Variables.journalFront(Lit(s#0))))): Seq Box
                     else JournalRanges.__default.JournalRangeEmpty())); 
              JournalCache.Variables.Ready_q(Lit(s'#0))
                 && Options.Option#Equal(JournalCache.Variables.superblockWrite(Lit(s'#0)), #Options.Option.None())
                 && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s'#0)), Seq#Empty(): Seq Box)
                 && Seq#Equal(JournalCache.Variables.inMemoryJournal(Lit(s'#0)), Seq#Empty(): Seq Box)
                 && Set#Equal(JournalCache.Variables.outstandingJournalWrites(Lit(s'#0)), Set#Empty(): Set Box)
                 && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s'#0)))
                   == LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && JournalRanges.__default.JournalRangeParses(fullRange#1, Lit(JournalCache.Variables.replayJournal(Lit(s'#0))))
                 && SectorType.Superblock#Equal(JournalCache.Variables.superblock(Lit(s'#0)), 
                  JournalCache.Variables.superblock(Lit(s#0)))
                 && LitInt(JournalCache.Variables.whichSuperblock(Lit(s'#0)))
                   == LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0)))
                 && Options.Option#Equal(JournalCache.Variables.newSuperblock(Lit(s'#0)), #Options.Option.None())
                 && Map#Equal(JournalCache.Variables.syncReqs(Lit(s'#0)), 
                  JournalCache.Variables.syncReqs(Lit(s#0)))
                 && Lit(JournalCache.Variables.isFrozen(Lit(s'#0))) == Lit(false)
                 && Options.Option#Equal(JournalCache.Variables.frozenLoc(Lit(s'#0)), #Options.Option.None())
                 && JournalCache.CommitStatus#Equal(JournalCache.Variables.commitStatus(Lit(s'#0)), 
                  #JournalCache.CommitStatus.CommitNone()))));

// function declaration for JournalCache._default.Freeze
function JournalCache.__default.Freeze(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.Freeze#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.Freeze
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Freeze#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.Freeze#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.Freeze
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.Freeze#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.Freeze#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for JournalCache.__default.Freeze(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Freeze#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Options.Option.None_q(JournalCache.Variables.superblockWrite(s#0))
           ==> $IsA#Options.Option(JournalCache.Variables.frozenLoc(s#0))
             && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
         && (Seq#Equal(JournalCache.Variables.replayJournal(s#0), Seq#Empty(): Seq Box)
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                    (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                                      #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                (var dt_update#inMemoryJournalFrozen#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(s#0), 
                                      JournalCache.Variables.inMemoryJournal(s#0)); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                    dt_update#inMemoryJournalFrozen#0#0, 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                            (var dt_update#inMemoryJournal#0#0 := Lit(Seq#Empty(): Seq Box); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                dt_update#inMemoryJournal#0#0, 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                          JournalCache.Variables.writtenJournalLen(s#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0))); 
                    (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs3to2(JournalCache.Variables.syncReqs(s#0)); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                          dt_update#syncReqs#0#0)
                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                            dt_update#syncReqs#0#0)
                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                            dt_update#syncReqs#0#0))))); 
                (var dt_update#isFrozen#0#0 := Lit(true); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                    dt_update#isFrozen#0#0, 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#5#0)))))
             && 
            (var dt_update_tmp#0#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))
             && (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                  (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                    #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0))
             && (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                      (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                        #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                  (var dt_update#inMemoryJournalFrozen#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(s#0), 
                        JournalCache.Variables.inMemoryJournal(s#0)); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                      dt_update#inMemoryJournalFrozen#0#0, 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#2#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#0))
             && (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                          (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                            #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                              JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                              JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                      (var dt_update#inMemoryJournalFrozen#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(s#0), 
                            JournalCache.Variables.inMemoryJournal(s#0)); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                          dt_update#inMemoryJournalFrozen#0#0, 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                  (var dt_update#inMemoryJournal#0#0 := Lit(Seq#Empty(): Seq Box); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                      dt_update#inMemoryJournal#0#0, 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#3#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#0))
             && 
            (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && JournalCache.__default.syncReqs3to2#canCall(JournalCache.Variables.syncReqs(s#0))
             && (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                  (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                                    #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                      JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                      JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                              (var dt_update#inMemoryJournalFrozen#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(s#0), 
                                    JournalCache.Variables.inMemoryJournal(s#0)); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                  dt_update#inMemoryJournalFrozen#0#0, 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                  JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                          (var dt_update#inMemoryJournal#0#0 := Lit(Seq#Empty(): Seq Box); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                              dt_update#inMemoryJournal#0#0, 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                              JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                        JournalCache.Variables.writtenJournalLen(s#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#0))); 
                  (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs3to2(JournalCache.Variables.syncReqs(s#0)); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                        dt_update#syncReqs#0#0)
                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                          JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                          dt_update#syncReqs#0#0)
                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                          dt_update#syncReqs#0#0))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#5#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#5#0)))
         && JournalCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.FreezeOp_q(vop#0)
             && JournalCache.Variables.Ready_q(s#0)
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && Options.Option.None_q(JournalCache.Variables.superblockWrite(s#0))
             && !Options.Option#Equal(JournalCache.Variables.frozenLoc(s#0), 
              #Options.Option.Some($Box(SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))))
             && Seq#Equal(JournalCache.Variables.replayJournal(s#0), Seq#Empty(): Seq Box)
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#5#0 := (var dt_update_tmp#4#0 := (var dt_update_tmp#3#0 := (var dt_update_tmp#2#0 := (var dt_update_tmp#1#0 := (var dt_update_tmp#0#0 := s#0; 
                                    (var dt_update#frozenLoc#0#0 := Lit(#Options.Option.None()); 
                                      #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                                        JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                                        JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))); 
                                (var dt_update#inMemoryJournalFrozen#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(s#0), 
                                      JournalCache.Variables.inMemoryJournal(s#0)); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#0), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#0), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#0), 
                                    dt_update#inMemoryJournalFrozen#0#0, 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#0), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#0), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#0), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#0), 
                                    JournalCache.Variables.superblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#0), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#0), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#0)))); 
                            (var dt_update#inMemoryJournal#0#0 := Lit(Seq#Empty(): Seq Box); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#0), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#2#0), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#0), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#2#0), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#0), 
                                dt_update#inMemoryJournal#0#0, 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#0), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#0), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#2#0), 
                                JournalCache.Variables.superblock(dt_update_tmp#2#0), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#2#0), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#2#0), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#2#0), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#2#0)))); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#3#0), 
                          JournalCache.Variables.writtenJournalLen(s#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#3#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#3#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#0))); 
                    (var dt_update#syncReqs#0#0 := JournalCache.__default.syncReqs3to2(JournalCache.Variables.syncReqs(s#0)); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#4#0)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#4#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#4#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#0), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#0), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#4#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#4#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#4#0), 
                          dt_update#syncReqs#0#0)
                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#0)
                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalFront(dt_update_tmp#4#0), 
                            JournalCache.Variables.journalBack(dt_update_tmp#4#0), 
                            dt_update#syncReqs#0#0)
                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#0), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblock1(dt_update_tmp#4#0), 
                            JournalCache.Variables.superblock2(dt_update_tmp#4#0), 
                            dt_update#syncReqs#0#0))))); 
                (var dt_update#isFrozen#0#0 := Lit(true); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#0), 
                    dt_update#isFrozen#0#0, 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#5#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#5#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#5#0)))))));

// definition axiom for JournalCache.__default.Freeze for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.Freeze(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.Freeze#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(Options.Option.None_q(Lit(JournalCache.Variables.superblockWrite(Lit(s#0)))))
           ==> $IsA#Options.Option(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
             && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && (Seq#Equal(JournalCache.Variables.replayJournal(Lit(s#0)), Seq#Empty(): Seq Box)
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                    (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                                      Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                (var dt_update#inMemoryJournalFrozen#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), 
                                      JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                    dt_update#inMemoryJournalFrozen#0#1, 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                    JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                            (var dt_update#inMemoryJournal#0#1 := Lit(Seq#Empty(): Seq Box); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                dt_update#inMemoryJournal#0#1, 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                          LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1))); 
                    (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs3to2(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                          dt_update#syncReqs#0#1)
                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                            dt_update#syncReqs#0#1)
                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                            dt_update#syncReqs#0#1))))); 
                (var dt_update#isFrozen#0#1 := Lit(true); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                    dt_update#isFrozen#0#1, 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#1), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#5#1)))))
             && 
            (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))
             && (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                  (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                    Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#1#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#1))
             && (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                      (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                        Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                            Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                            LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                            Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                  (var dt_update#inMemoryJournalFrozen#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), 
                        JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                      dt_update#inMemoryJournalFrozen#0#1, 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                      JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#2#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#2#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#2#1))
             && (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                          (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                            Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                      (var dt_update#inMemoryJournalFrozen#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), 
                            JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                          dt_update#inMemoryJournalFrozen#0#1, 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                  (var dt_update#inMemoryJournal#0#1 := Lit(Seq#Empty(): Seq Box); 
                    #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                      dt_update#inMemoryJournal#0#1, 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                      JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                      JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#3#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#3#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#3#1))
             && 
            (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && JournalCache.__default.syncReqs3to2#canCall(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))
             && (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                  (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                                    Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                              (var dt_update#inMemoryJournalFrozen#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), 
                                    JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                                #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                  JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                  JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                  JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                  dt_update#inMemoryJournalFrozen#0#1, 
                                  JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                  JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                  JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                  JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                  JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                  JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                  JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                  JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                  JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                          (var dt_update#inMemoryJournal#0#1 := Lit(Seq#Empty(): Seq Box); 
                            #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                              JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                              JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                              JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                              JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                              dt_update#inMemoryJournal#0#1, 
                              JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                              JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                              JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                              JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                              JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                              JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                              JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                              JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                        LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#3#1))); 
                  (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs3to2(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                    (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                       then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                        JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                        dt_update#syncReqs#0#1)
                       else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                         then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                          JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                          dt_update#syncReqs#0#1)
                         else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                          JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                          dt_update#syncReqs#0#1))))); 
              JournalCache.Variables.Ready_q(dt_update_tmp#5#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#5#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#5#1)))
         && JournalCache.__default.Freeze(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.FreezeOp_q(Lit(vop#0))
             && JournalCache.Variables.Ready_q(Lit(s#0))
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && Options.Option.None_q(Lit(JournalCache.Variables.superblockWrite(Lit(s#0))))
             && !Options.Option#Equal(JournalCache.Variables.frozenLoc(Lit(s#0)), 
              #Options.Option.Some($Box(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))))
             && Seq#Equal(JournalCache.Variables.replayJournal(Lit(s#0)), Seq#Empty(): Seq Box)
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#5#1 := (var dt_update_tmp#4#1 := (var dt_update_tmp#3#1 := (var dt_update_tmp#2#1 := (var dt_update_tmp#1#1 := (var dt_update_tmp#0#1 := Lit(s#0); 
                                    (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.None()); 
                                      Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))); 
                                (var dt_update#inMemoryJournalFrozen#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), 
                                      JournalCache.Variables.inMemoryJournal(Lit(s#0))); 
                                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                                    JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                                    dt_update#inMemoryJournalFrozen#0#1, 
                                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                                    JournalCache.Variables.replayJournal(dt_update_tmp#1#1), 
                                    JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))); 
                            (var dt_update#inMemoryJournal#0#1 := Lit(Seq#Empty(): Seq Box); 
                              #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#2#1), 
                                JournalCache.Variables.isFrozen(dt_update_tmp#2#1), 
                                JournalCache.Variables.frozenJournalPosition(dt_update_tmp#2#1), 
                                JournalCache.Variables.superblockWrite(dt_update_tmp#2#1), 
                                JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#2#1), 
                                dt_update#inMemoryJournal#0#1, 
                                JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#2#1), 
                                JournalCache.Variables.writtenJournalLen(dt_update_tmp#2#1), 
                                JournalCache.Variables.replayJournal(dt_update_tmp#2#1), 
                                JournalCache.Variables.superblock(dt_update_tmp#2#1), 
                                JournalCache.Variables.whichSuperblock(dt_update_tmp#2#1), 
                                JournalCache.Variables.commitStatus(dt_update_tmp#2#1), 
                                JournalCache.Variables.newSuperblock(dt_update_tmp#2#1), 
                                JournalCache.Variables.syncReqs(dt_update_tmp#2#1)))); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#3#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#3#1), 
                          LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#3#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#3#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#3#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#3#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#3#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#3#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#3#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#3#1), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#3#1))); 
                    (var dt_update#syncReqs#0#1 := Lit(JournalCache.__default.syncReqs3to2(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))); 
                      (if JournalCache.Variables.Ready_q(dt_update_tmp#4#1)
                         then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#4#1), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#4#1), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#4#1), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#4#1), 
                          JournalCache.Variables.inMemoryJournal(dt_update_tmp#4#1), 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#4#1), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#4#1), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#4#1), 
                          JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#4#1), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#4#1), 
                          dt_update#syncReqs#0#1)
                         else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#4#1)
                           then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.whichSuperblock(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalFrontRead(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalBackRead(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalFront(dt_update_tmp#4#1), 
                            JournalCache.Variables.journalBack(dt_update_tmp#4#1), 
                            dt_update#syncReqs#0#1)
                           else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#4#1), 
                            JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblock1(dt_update_tmp#4#1), 
                            JournalCache.Variables.superblock2(dt_update_tmp#4#1), 
                            dt_update#syncReqs#0#1))))); 
                (var dt_update#isFrozen#0#1 := Lit(true); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#5#1), 
                    dt_update#isFrozen#0#1, 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#5#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#5#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#5#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#5#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#5#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#5#1), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#5#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#5#1), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#5#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#5#1)))))));

// function declaration for JournalCache._default.ReceiveFrozenLoc
function JournalCache.__default.ReceiveFrozenLoc(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.ReceiveFrozenLoc#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.ReceiveFrozenLoc
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.ReceiveFrozenLoc(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.ReceiveFrozenLoc#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.ReceiveFrozenLoc#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.ReceiveFrozenLoc
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.ReceiveFrozenLoc#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.ReceiveFrozenLoc#requires(k#0, s#0, s'#0, dop#0, vop#0)
       == true);

// definition axiom for JournalCache.__default.ReceiveFrozenLoc(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.ReceiveFrozenLoc(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.ReceiveFrozenLoc#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (!Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(ViewOp.VOp.loc(vop#0)))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(ViewOp.VOp.loc(vop#0))
             && DiskLayout.__default.ValidIndirectionTableLocation(ViewOp.VOp.loc(vop#0))
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#frozenLoc#0#0 := #Options.Option.Some($Box(ViewOp.VOp.loc(vop#0))); 
                  #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0)))
         && JournalCache.__default.ReceiveFrozenLoc(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.SendFrozenLocOp_q(vop#0)
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && JournalCache.Variables.Ready_q(s#0)
             && JournalCache.Variables.isFrozen(s#0)
             && !Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
             && DiskLayout.__default.ValidIndirectionTableLocation(ViewOp.VOp.loc(vop#0))
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#frozenLoc#0#0 := #Options.Option.Some($Box(ViewOp.VOp.loc(vop#0))); 
                  #JournalCache.Variables.Ready(dt_update#frozenLoc#0#0, 
                    JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                    JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))));

// definition axiom for JournalCache.__default.ReceiveFrozenLoc for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.ReceiveFrozenLoc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.ReceiveFrozenLoc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (!Lit(Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0)))))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(ViewOp.VOp.loc(Lit(vop#0)))))
         && (DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit(ViewOp.VOp.loc(Lit(vop#0))))
             && Lit(DiskLayout.__default.ValidIndirectionTableLocation(Lit(ViewOp.VOp.loc(Lit(vop#0)))))
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.Some($Box(Lit(ViewOp.VOp.loc(Lit(vop#0)))))); 
                  Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                      Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))
             && (var dt_update_tmp#0#1 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1)))
         && JournalCache.__default.ReceiveFrozenLoc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.SendFrozenLocOp_q(Lit(vop#0))
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && JournalCache.Variables.Ready_q(Lit(s#0))
             && JournalCache.Variables.isFrozen(Lit(s#0))
             && !Lit(Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0)))))
             && DiskLayout.__default.ValidIndirectionTableLocation(Lit(ViewOp.VOp.loc(Lit(vop#0))))
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#frozenLoc#0#1 := Lit(#Options.Option.Some($Box(Lit(ViewOp.VOp.loc(Lit(vop#0)))))); 
                  Lit(#JournalCache.Variables.Ready(dt_update#frozenLoc#0#1, 
                      Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))));

// function declaration for JournalCache._default.Advance
function JournalCache.__default.Advance(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.Advance#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.Advance
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Advance(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Advance#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.Advance#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.Advance
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.Advance#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.Advance#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for JournalCache.__default.Advance(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Advance(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Advance#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> Journal.__default.JournalEntriesForUIOp#canCall(ViewOp.VOp.uiop(vop#0))
             && (var new_je#0 := Journal.__default.JournalEntriesForUIOp(ViewOp.VOp.uiop(vop#0)); 
              Seq#Equal(JournalCache.Variables.replayJournal(s#0), Seq#Empty(): Seq Box)
                 ==> $IsA#JournalCache.Variables(s'#0)
                   && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                      (var dt_update#inMemoryJournal#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournal(s#0), new_je#0); 
                        #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                          JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                          JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                          JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                          JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                          dt_update#inMemoryJournal#0#0, 
                          JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                          JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                          JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                          JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                          JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                          JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
                   && (var dt_update_tmp#0#0 := s#0; 
                    JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))))
         && JournalCache.__default.Advance(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.AdvanceOp_q(vop#0)
             && !ViewOp.VOp.replay(vop#0)
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && (var new_je#0 := Journal.__default.JournalEntriesForUIOp(ViewOp.VOp.uiop(vop#0)); 
              JournalCache.Variables.Ready_q(s#0)
                 && Seq#Equal(JournalCache.Variables.replayJournal(s#0), Seq#Empty(): Seq Box)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#inMemoryJournal#0#0 := Seq#Append(JournalCache.Variables.inMemoryJournal(s#0), new_je#0); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                        dt_update#inMemoryJournal#0#0, 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                        JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0))))))));

// definition axiom for JournalCache.__default.Advance for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.Advance(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.Advance#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> Journal.__default.JournalEntriesForUIOp#canCall(Lit(ViewOp.VOp.uiop(Lit(vop#0))))
             && (var new_je#1 := Lit(Journal.__default.JournalEntriesForUIOp(Lit(ViewOp.VOp.uiop(Lit(vop#0))))); 
              Seq#Equal(JournalCache.Variables.replayJournal(Lit(s#0)), Seq#Empty(): Seq Box)
                 ==> $IsA#JournalCache.Variables(Lit(s'#0))
                   && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                      (var dt_update#inMemoryJournal#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournal(Lit(s#0)), new_je#1); 
                        #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                          dt_update#inMemoryJournal#0#1, 
                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1))))))
                   && (var dt_update_tmp#0#1 := Lit(s#0); 
                    JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                       || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                       || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))))
         && JournalCache.__default.Advance(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.AdvanceOp_q(Lit(vop#0))
             && !Lit(ViewOp.VOp.replay(Lit(vop#0)))
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && (var new_je#1 := Lit(Journal.__default.JournalEntriesForUIOp(Lit(ViewOp.VOp.uiop(Lit(vop#0))))); 
              JournalCache.Variables.Ready_q(Lit(s#0))
                 && Seq#Equal(JournalCache.Variables.replayJournal(Lit(s#0)), Seq#Empty(): Seq Box)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#inMemoryJournal#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournal(Lit(s#0)), new_je#1); 
                      #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                        dt_update#inMemoryJournal#0#1, 
                        Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))));

// function declaration for JournalCache._default.Replay
function JournalCache.__default.Replay(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.Replay#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.Replay
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Replay(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Replay#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.Replay#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.Replay
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.Replay#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.Replay#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for JournalCache.__default.Replay(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Replay(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Replay#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (JournalDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> Journal.__default.JournalEntriesForUIOp#canCall(ViewOp.VOp.uiop(vop#0))
             && (JournalCache.Variables.Ready_q(s'#0)
               ==> $IsA#JournalCache.Variables(s'#0)
                 && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#replayJournal#0#0 := JournalCache.Variables.replayJournal(s'#0); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                        dt_update#replayJournal#0#0, 
                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
                 && (var dt_update_tmp#0#0 := s#0; 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0))))
         && JournalCache.__default.Replay(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            ViewOp.VOp.AdvanceOp_q(vop#0)
             && ViewOp.VOp.replay(vop#0)
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && (var replayed_je#0 := Journal.__default.JournalEntriesForUIOp(ViewOp.VOp.uiop(vop#0)); 
              JournalCache.Variables.Ready_q(s#0)
                 && JournalCache.Variables.Ready_q(s'#0)
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#0 := s#0; 
                    (var dt_update#replayJournal#0#0 := JournalCache.Variables.replayJournal(s'#0); 
                      #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                        JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                        JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                        JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                        JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                        JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                        JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                        dt_update#replayJournal#0#0, 
                        JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                        JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.syncReqs(dt_update_tmp#0#0)))))
                 && Seq#Equal(JournalCache.Variables.replayJournal(s#0), 
                  Seq#Append(replayed_je#0, JournalCache.Variables.replayJournal(s'#0))))));

// definition axiom for JournalCache.__default.Replay for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.Replay(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.Replay#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> Journal.__default.JournalEntriesForUIOp#canCall(Lit(ViewOp.VOp.uiop(Lit(vop#0))))
             && (Lit(JournalCache.Variables.Ready_q(Lit(s'#0)))
               ==> $IsA#JournalCache.Variables(Lit(s'#0))
                 && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#replayJournal#0#1 := Lit(JournalCache.Variables.replayJournal(Lit(s'#0))); 
                      Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                          dt_update#replayJournal#0#1, 
                          Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))
                 && (var dt_update_tmp#0#1 := Lit(s#0); 
                  JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                     || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#1))))
         && JournalCache.__default.Replay(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            ViewOp.VOp.AdvanceOp_q(Lit(vop#0))
             && ViewOp.VOp.replay(Lit(vop#0))
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && (var replayed_je#1 := Lit(Journal.__default.JournalEntriesForUIOp(Lit(ViewOp.VOp.uiop(Lit(vop#0))))); 
              JournalCache.Variables.Ready_q(Lit(s#0))
                 && JournalCache.Variables.Ready_q(Lit(s'#0))
                 && JournalCache.Variables#Equal(s'#0, 
                  (var dt_update_tmp#0#1 := Lit(s#0); 
                    (var dt_update#replayJournal#0#1 := Lit(JournalCache.Variables.replayJournal(Lit(s'#0))); 
                      Lit(#JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                          dt_update#replayJournal#0#1, 
                          Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                          LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                          Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))))
                 && Seq#Equal(JournalCache.Variables.replayJournal(Lit(s#0)), 
                  Seq#Append(replayed_je#1, JournalCache.Variables.replayJournal(Lit(s'#0)))))));

// function declaration for JournalCache._default.PushSyncReq
function JournalCache.__default.PushSyncReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    id#0: int)
   : bool;

function JournalCache.__default.PushSyncReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    id#0: int)
   : bool;

// consequence axiom for JournalCache.__default.PushSyncReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      id#0: int :: 
    { JournalCache.__default.PushSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#0) } 
    JournalCache.__default.PushSyncReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, id#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> true);

function JournalCache.__default.PushSyncReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for JournalCache.__default.PushSyncReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    id#0: int :: 
  { JournalCache.__default.PushSyncReq#requires(k#0, s#0, s'#0, dop#0, vop#0, id#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
     ==> JournalCache.__default.PushSyncReq#requires(k#0, s#0, s'#0, dop#0, vop#0, id#0)
       == true);

// definition axiom for JournalCache.__default.PushSyncReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      id#0: int :: 
    { JournalCache.__default.PushSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#0) } 
    JournalCache.__default.PushSyncReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, id#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> (JournalDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> JournalCache.Variables.Ready_q(s#0)
             || JournalCache.Variables.LoadingOther_q(s#0)
             || JournalCache.Variables.LoadingSuperblock_q(s#0))
         && ((
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && !Map#Domain(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#syncReqs#0#0 := Map#Build(JournalCache.Variables.syncReqs(s#0), 
                      $Box(id#0), 
                      $Box(Lit(#JournalCache.SyncReqStatus.State3()))); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                      dt_update#syncReqs#0#0)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                       then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0)
                       else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0))))))
             && (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0)))
         && JournalCache.__default.PushSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#0)
           == (
            ViewOp.VOp.PushSyncOp_q(vop#0)
             && ViewOp.VOp.id(vop#0) == id#0
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && !Map#Domain(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#syncReqs#0#0 := Map#Build(JournalCache.Variables.syncReqs(s#0), 
                      $Box(id#0), 
                      $Box(Lit(#JournalCache.SyncReqStatus.State3()))); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                      dt_update#syncReqs#0#0)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                       then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0)
                       else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0))))))));

// definition axiom for JournalCache.__default.PushSyncReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      id#0: int :: 
    {:weight 3} { JournalCache.__default.PushSyncReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(id#0)) } 
    JournalCache.__default.PushSyncReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(id#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> (Lit(JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> JournalCache.Variables.Ready_q(Lit(s#0))
             || JournalCache.Variables.LoadingOther_q(Lit(s#0))
             || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
         && ((
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && !Map#Domain(JournalCache.Variables.syncReqs(Lit(s#0)))[$Box(id#0)]
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#syncReqs#0#1 := Map#Build(Lit(JournalCache.Variables.syncReqs(Lit(s#0))), 
                      $Box(LitInt(id#0)), 
                      $Box(Lit(#JournalCache.SyncReqStatus.State3()))); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     then #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                      dt_update#syncReqs#0#1)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                       then #JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1)
                       else #JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1))))))
             && (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))))
         && JournalCache.__default.PushSyncReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(id#0))
           == (
            ViewOp.VOp.PushSyncOp_q(Lit(vop#0))
             && LitInt(ViewOp.VOp.id(Lit(vop#0))) == LitInt(id#0)
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && !Map#Domain(JournalCache.Variables.syncReqs(Lit(s#0)))[$Box(id#0)]
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#syncReqs#0#1 := Map#Build(Lit(JournalCache.Variables.syncReqs(Lit(s#0))), 
                      $Box(LitInt(id#0)), 
                      $Box(Lit(#JournalCache.SyncReqStatus.State3()))); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     then #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                      dt_update#syncReqs#0#1)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                       then #JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1)
                       else #JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1))))))));

// function declaration for JournalCache._default.PopSyncReq
function JournalCache.__default.PopSyncReq(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    id#0: int)
   : bool;

function JournalCache.__default.PopSyncReq#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    id#0: int)
   : bool;

// consequence axiom for JournalCache.__default.PopSyncReq
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      id#0: int :: 
    { JournalCache.__default.PopSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#0) } 
    JournalCache.__default.PopSyncReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, id#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> true);

function JournalCache.__default.PopSyncReq#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType, int)
   : bool;

// #requires axiom for JournalCache.__default.PopSyncReq
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    id#0: int :: 
  { JournalCache.__default.PopSyncReq#requires(k#0, s#0, s'#0, dop#0, vop#0, id#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && 
      LitInt(0) <= id#0
       && id#0 < 18446744073709551616
     ==> JournalCache.__default.PopSyncReq#requires(k#0, s#0, s'#0, dop#0, vop#0, id#0)
       == true);

// definition axiom for JournalCache.__default.PopSyncReq(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      id#0: int :: 
    { JournalCache.__default.PopSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#0) } 
    JournalCache.__default.PopSyncReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, id#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> (JournalDisk.DiskOp.NoDiskOp_q(dop#0)
           ==> JournalCache.Variables.Ready_q(s#0)
             || JournalCache.Variables.LoadingOther_q(s#0)
             || JournalCache.Variables.LoadingSuperblock_q(s#0))
         && ((
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && Map#Domain(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]
           ==> $IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]): DatatypeType)
             && (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0)))
         && ($IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]): DatatypeType)
             && (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]): DatatypeType, 
              #JournalCache.SyncReqStatus.State1())
           ==> $IsA#JournalCache.Variables(s'#0)
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#0 := s#0; 
                (var dt_update#syncReqs#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.JournalCache.SyncReqStatus(), 
                      StartFuel_Maps._default.MapRemove1, 
                      JournalCache.Variables.syncReqs(s#0), 
                      $Box(id#0)); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                      dt_update#syncReqs#0#0)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                       then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0)
                       else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0))))))
             && 
            (
              JournalCache.Variables.Ready_q(s#0)
               || JournalCache.Variables.LoadingOther_q(s#0)
               || JournalCache.Variables.LoadingSuperblock_q(s#0))
             && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.JournalCache.SyncReqStatus(), 
              JournalCache.Variables.syncReqs(s#0), 
              $Box(id#0)))
         && JournalCache.__default.PopSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#0)
           == (
            ViewOp.VOp.PopSyncOp_q(vop#0)
             && ViewOp.VOp.id(vop#0) == id#0
             && JournalDisk.DiskOp.NoDiskOp_q(dop#0)
             && Map#Domain(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]
             && JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(JournalCache.Variables.syncReqs(s#0))[$Box(id#0)]): DatatypeType, 
              #JournalCache.SyncReqStatus.State1())
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#0 := s#0; 
                (var dt_update#syncReqs#0#0 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.JournalCache.SyncReqStatus(), 
                      StartFuel_Maps._default.MapRemove1, 
                      JournalCache.Variables.syncReqs(s#0), 
                      $Box(id#0)); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                     then #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#0), 
                      JournalCache.Variables.isFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblockWrite(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#0), 
                      JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#0), 
                      JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#0), 
                      JournalCache.Variables.replayJournal(dt_update_tmp#0#0), 
                      JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                      JournalCache.Variables.commitStatus(dt_update_tmp#0#0), 
                      JournalCache.Variables.newSuperblock(dt_update_tmp#0#0), 
                      dt_update#syncReqs#0#0)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                       then #JournalCache.Variables.LoadingOther(JournalCache.Variables.superblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.whichSuperblock(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFrontRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBackRead(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalFront(dt_update_tmp#0#0), 
                        JournalCache.Variables.journalBack(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0)
                       else #JournalCache.Variables.LoadingSuperblock(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock1(dt_update_tmp#0#0), 
                        JournalCache.Variables.superblock2(dt_update_tmp#0#0), 
                        dt_update#syncReqs#0#0))))))));

// definition axiom for JournalCache.__default.PopSyncReq for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      id#0: int :: 
    {:weight 3} { JournalCache.__default.PopSyncReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(id#0)) } 
    JournalCache.__default.PopSyncReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(id#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && 
          LitInt(0) <= id#0
           && id#0 < 18446744073709551616)
       ==> (Lit(JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0)))
           ==> JournalCache.Variables.Ready_q(Lit(s#0))
             || JournalCache.Variables.LoadingOther_q(Lit(s#0))
             || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
         && ((
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && Map#Domain(JournalCache.Variables.syncReqs(Lit(s#0)))[$Box(id#0)]
           ==> $IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))))
         && ($IsA#JournalCache.SyncReqStatus($Unbox(Map#Elements(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType)
             && (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType, 
              #JournalCache.SyncReqStatus.State1())
           ==> $IsA#JournalCache.Variables(Lit(s'#0))
             && $IsA#JournalCache.Variables((var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#syncReqs#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.JournalCache.SyncReqStatus(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(JournalCache.Variables.syncReqs(Lit(s#0))), 
                      $Box(LitInt(id#0))); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     then #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                      dt_update#syncReqs#0#1)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                       then #JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1)
                       else #JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1))))))
             && 
            (
              JournalCache.Variables.Ready_q(Lit(s#0))
               || JournalCache.Variables.LoadingOther_q(Lit(s#0))
               || JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
             && Maps.__default.MapRemove1#canCall(Tclass.NativeTypes.uint64(), 
              Tclass.JournalCache.SyncReqStatus(), 
              Lit(JournalCache.Variables.syncReqs(Lit(s#0))), 
              $Box(LitInt(id#0))))
         && JournalCache.__default.PopSyncReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), LitInt(id#0))
           == (
            ViewOp.VOp.PopSyncOp_q(Lit(vop#0))
             && LitInt(ViewOp.VOp.id(Lit(vop#0))) == LitInt(id#0)
             && JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
             && Map#Domain(JournalCache.Variables.syncReqs(Lit(s#0)))[$Box(id#0)]
             && JournalCache.SyncReqStatus#Equal($Unbox(Map#Elements(Lit(JournalCache.Variables.syncReqs(Lit(s#0))))[$Box(LitInt(id#0))]): DatatypeType, 
              #JournalCache.SyncReqStatus.State1())
             && JournalCache.Variables#Equal(s'#0, 
              (var dt_update_tmp#0#1 := Lit(s#0); 
                (var dt_update#syncReqs#0#1 := Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                      Tclass.JournalCache.SyncReqStatus(), 
                      StartFuel_Maps._default.MapRemove1, 
                      Lit(JournalCache.Variables.syncReqs(Lit(s#0))), 
                      $Box(LitInt(id#0))); 
                  (if JournalCache.Variables.Ready_q(dt_update_tmp#0#1)
                     then #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                      LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#1)), 
                      Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#1)), 
                      dt_update#syncReqs#0#1)
                     else (if JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#1)
                       then #JournalCache.Variables.LoadingOther(Lit(JournalCache.Variables.superblock(dt_update_tmp#0#1)), 
                        LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFrontRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBackRead(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalFront(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.journalBack(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1)
                       else #JournalCache.Variables.LoadingSuperblock(Lit(JournalCache.Variables.outstandingSuperblock1Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.outstandingSuperblock2Read(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock1(dt_update_tmp#0#1)), 
                        Lit(JournalCache.Variables.superblock2(dt_update_tmp#0#1)), 
                        dt_update#syncReqs#0#1))))))));

// function declaration for JournalCache._default.NoOp
function JournalCache.__default.NoOp(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.NoOp#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.NoOp
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.NoOp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.NoOp#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.NoOp
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.NoOp#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.NoOp#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for JournalCache.__default.NoOp(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.NoOp#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (ViewOp.VOp.StatesInternalOp_q(vop#0)
           ==> 
          !(true && JournalDisk.DiskOp.RespReadJournalOp_q(dop#0))
           ==> 
          JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
           ==> 
          JournalCache.Variables.Ready_q(s#0)
           ==> $IsA#Options.Option(JournalCache.Variables.superblockWrite(s#0)))
         && ((!(true && JournalDisk.DiskOp.RespReadJournalOp_q(dop#0))
               ==> 
              JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
               ==> 
              JournalCache.Variables.Ready_q(s#0)
               ==> $IsA#Options.Option(JournalCache.Variables.superblockWrite(s#0)))
             && (
              JournalDisk.DiskOp.NoDiskOp_q(dop#0)
               || (true && JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0))
               || (true && JournalDisk.DiskOp.RespReadJournalOp_q(dop#0))
               || (JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
                 && !
                (JournalCache.Variables.Ready_q(s#0)
                 && Options.Option#Equal(JournalCache.Variables.superblockWrite(s#0), 
                  #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))))
               || (JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
                 && !
                (JournalCache.Variables.Ready_q(s#0)
                 && JournalCache.Variables.outstandingJournalWrites(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))])))
           ==> $IsA#JournalCache.Variables(s'#0) && $IsA#JournalCache.Variables(s#0))
         && JournalCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0)
           == (
            (ViewOp.VOp.JournalInternalOp_q(vop#0) || ViewOp.VOp.StatesInternalOp_q(vop#0))
             && (
              JournalDisk.DiskOp.NoDiskOp_q(dop#0)
               || (true && JournalDisk.DiskOp.RespReadSuperblockOp_q(dop#0))
               || (true && JournalDisk.DiskOp.RespReadJournalOp_q(dop#0))
               || (JournalDisk.DiskOp.RespWriteSuperblockOp_q(dop#0)
                 && !
                (JournalCache.Variables.Ready_q(s#0)
                 && Options.Option#Equal(JournalCache.Variables.superblockWrite(s#0), 
                  #Options.Option.Some($Box(JournalDisk.DiskOp.id(dop#0))))))
               || (JournalDisk.DiskOp.RespWriteJournalOp_q(dop#0)
                 && !
                (JournalCache.Variables.Ready_q(s#0)
                 && JournalCache.Variables.outstandingJournalWrites(s#0)[$Box(JournalDisk.DiskOp.id(dop#0))])))
             && JournalCache.Variables#Equal(s'#0, s#0)));

// definition axiom for JournalCache.__default.NoOp for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.NoOp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.NoOp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (Lit(ViewOp.VOp.StatesInternalOp_q(Lit(vop#0)))
           ==> 
          !Lit(true && JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
           ==> 
          Lit(JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0)))
           ==> 
          Lit(JournalCache.Variables.Ready_q(Lit(s#0)))
           ==> $IsA#Options.Option(Lit(JournalCache.Variables.superblockWrite(Lit(s#0)))))
         && ((!Lit(true && JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
               ==> 
              Lit(JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0)))
               ==> 
              Lit(JournalCache.Variables.Ready_q(Lit(s#0)))
               ==> $IsA#Options.Option(Lit(JournalCache.Variables.superblockWrite(Lit(s#0)))))
             && (
              JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
               || (true && JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0)))
               || (true && JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
               || (JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0))
                 && !
                (JournalCache.Variables.Ready_q(Lit(s#0))
                 && Options.Option#Equal(JournalCache.Variables.superblockWrite(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))))
               || (JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0))
                 && !
                (JournalCache.Variables.Ready_q(Lit(s#0))
                 && Lit(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))])))
           ==> $IsA#JournalCache.Variables(Lit(s'#0)) && $IsA#JournalCache.Variables(Lit(s#0)))
         && JournalCache.__default.NoOp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (
            (ViewOp.VOp.JournalInternalOp_q(Lit(vop#0))
               || ViewOp.VOp.StatesInternalOp_q(Lit(vop#0)))
             && (
              JournalDisk.DiskOp.NoDiskOp_q(Lit(dop#0))
               || (true && JournalDisk.DiskOp.RespReadSuperblockOp_q(Lit(dop#0)))
               || (true && JournalDisk.DiskOp.RespReadJournalOp_q(Lit(dop#0)))
               || (JournalDisk.DiskOp.RespWriteSuperblockOp_q(Lit(dop#0))
                 && !
                (JournalCache.Variables.Ready_q(Lit(s#0))
                 && Options.Option#Equal(JournalCache.Variables.superblockWrite(Lit(s#0)), 
                  #Options.Option.Some($Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))))))
               || (JournalDisk.DiskOp.RespWriteJournalOp_q(Lit(dop#0))
                 && !
                (JournalCache.Variables.Ready_q(Lit(s#0))
                 && Lit(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)))[$Box(LitInt(JournalDisk.DiskOp.id(Lit(dop#0))))])))
             && JournalCache.Variables#Equal(s'#0, s#0)));

// function declaration for JournalCache._default.ValidJournalStep
function JournalCache.__default.ValidJournalStep(s#0: DatatypeType, js#0: DatatypeType) : bool;

function JournalCache.__default.ValidJournalStep#canCall(s#0: DatatypeType, js#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.ValidJournalStep
axiom true
   ==> (forall s#0: DatatypeType, js#0: DatatypeType :: 
    { JournalCache.__default.ValidJournalStep(s#0, js#0) } 
    JournalCache.__default.ValidJournalStep#canCall(s#0, js#0)
         || ($Is(s#0, Tclass.JournalCache.Variables())
           && $Is(js#0, Tclass.JournalCache.JournalStep()))
       ==> true);

function JournalCache.__default.ValidJournalStep#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.ValidJournalStep
axiom (forall s#0: DatatypeType, js#0: DatatypeType :: 
  { JournalCache.__default.ValidJournalStep#requires(s#0, js#0) } 
  $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(js#0, Tclass.JournalCache.JournalStep())
     ==> JournalCache.__default.ValidJournalStep#requires(s#0, js#0) == true);

// definition axiom for JournalCache.__default.ValidJournalStep(revealed)
axiom true
   ==> (forall s#0: DatatypeType, js#0: DatatypeType :: 
    { JournalCache.__default.ValidJournalStep(s#0, js#0) } 
    JournalCache.__default.ValidJournalStep#canCall(s#0, js#0)
         || ($Is(s#0, Tclass.JournalCache.Variables())
           && $Is(js#0, Tclass.JournalCache.JournalStep()))
       ==> (JournalCache.Variables.Ready_q(s#0)
           ==> 
          JournalCache.JournalStep.JSReplay_q(js#0)
           ==> 
          Lit(true)
           ==> (JournalCache.JournalStep.JSNew_q(js#0)
               || JournalCache.JournalStep.JSReplay_q(js#0))
             && Sequences.__default.IsPrefix#canCall(Tclass.Journal.JournalEntry(), 
              JournalCache.JournalStep.entries(js#0), 
              JournalCache.Variables.replayJournal(s#0)))
         && JournalCache.__default.ValidJournalStep(s#0, js#0)
           == (
            JournalCache.Variables.Ready_q(s#0)
             && (JournalCache.JournalStep.JSReplay_q(js#0)
               ==> true
                 && Sequences.__default.IsPrefix(Tclass.Journal.JournalEntry(), 
                  StartFuel_Sequences._default.IsPrefix, 
                  JournalCache.JournalStep.entries(js#0), 
                  JournalCache.Variables.replayJournal(s#0)))
             && (JournalCache.JournalStep.JSNew_q(js#0)
               ==> true
                 && Seq#Equal(JournalCache.Variables.replayJournal(s#0), Seq#Empty(): Seq Box))));

// definition axiom for JournalCache.__default.ValidJournalStep for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType, js#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.ValidJournalStep(Lit(s#0), Lit(js#0)) } 
    JournalCache.__default.ValidJournalStep#canCall(Lit(s#0), Lit(js#0))
         || ($Is(s#0, Tclass.JournalCache.Variables())
           && $Is(js#0, Tclass.JournalCache.JournalStep()))
       ==> (Lit(JournalCache.Variables.Ready_q(Lit(s#0)))
           ==> 
          Lit(JournalCache.JournalStep.JSReplay_q(Lit(js#0)))
           ==> 
          Lit(true)
           ==> (JournalCache.JournalStep.JSNew_q(Lit(js#0))
               || JournalCache.JournalStep.JSReplay_q(Lit(js#0)))
             && Sequences.__default.IsPrefix#canCall(Tclass.Journal.JournalEntry(), 
              Lit(JournalCache.JournalStep.entries(Lit(js#0))), 
              Lit(JournalCache.Variables.replayJournal(Lit(s#0)))))
         && JournalCache.__default.ValidJournalStep(Lit(s#0), Lit(js#0))
           == (
            JournalCache.Variables.Ready_q(Lit(s#0))
             && (JournalCache.JournalStep.JSReplay_q(Lit(js#0))
               ==> true
                 && Sequences.__default.IsPrefix(Tclass.Journal.JournalEntry(), 
                  StartFuel_Sequences._default.IsPrefix, 
                  Lit(JournalCache.JournalStep.entries(Lit(js#0))), 
                  Lit(JournalCache.Variables.replayJournal(Lit(s#0)))))
             && (JournalCache.JournalStep.JSNew_q(Lit(js#0))
               ==> true
                 && Seq#Equal(JournalCache.Variables.replayJournal(Lit(s#0)), Seq#Empty(): Seq Box))));

// function declaration for JournalCache._default.DoJournalStep
function JournalCache.__default.DoJournalStep(s#0: DatatypeType, js#0: DatatypeType) : DatatypeType;

function JournalCache.__default.DoJournalStep#canCall(s#0: DatatypeType, js#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.DoJournalStep
axiom true
   ==> (forall s#0: DatatypeType, js#0: DatatypeType :: 
    { JournalCache.__default.DoJournalStep(s#0, js#0) } 
    JournalCache.__default.DoJournalStep#canCall(s#0, js#0)
         || (
          $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(js#0, Tclass.JournalCache.JournalStep())
           && 
          JournalCache.__default.ValidJournalStep(s#0, js#0)
           && JournalCache.Variables.Ready_q(s#0))
       ==> $Is(JournalCache.__default.DoJournalStep(s#0, js#0), Tclass.JournalCache.Variables()));

function JournalCache.__default.DoJournalStep#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.DoJournalStep
axiom (forall s#0: DatatypeType, js#0: DatatypeType :: 
  { JournalCache.__default.DoJournalStep#requires(s#0, js#0) } 
  $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(js#0, Tclass.JournalCache.JournalStep())
     ==> JournalCache.__default.DoJournalStep#requires(s#0, js#0)
       == (JournalCache.__default.ValidJournalStep(s#0, js#0)
         && JournalCache.Variables.Ready_q(s#0)));

// definition axiom for JournalCache.__default.DoJournalStep(revealed)
axiom true
   ==> (forall s#0: DatatypeType, js#0: DatatypeType :: 
    { JournalCache.__default.DoJournalStep(s#0, js#0) } 
    JournalCache.__default.DoJournalStep#canCall(s#0, js#0)
         || (
          $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(js#0, Tclass.JournalCache.JournalStep())
           && 
          JournalCache.__default.ValidJournalStep(s#0, js#0)
           && JournalCache.Variables.Ready_q(s#0))
       ==> (JournalCache.JournalStep.JSNew_q(js#0)
           ==> (JournalCache.JournalStep.JSNew_q(js#0)
               || JournalCache.JournalStep.JSReplay_q(js#0))
             && (var dt_update_tmp#0#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#0)))
         && (!JournalCache.JournalStep.JSNew_q(js#0)
           ==> (JournalCache.JournalStep.JSNew_q(js#0)
               || JournalCache.JournalStep.JSReplay_q(js#0))
             && (var dt_update_tmp#1#0 := s#0; 
              JournalCache.Variables.Ready_q(dt_update_tmp#1#0)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#0)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#0)))
         && JournalCache.__default.DoJournalStep(s#0, js#0)
           == (if JournalCache.JournalStep.JSNew_q(js#0)
             then (var entries#2 := JournalCache.JournalStep.entries(js#0); 
              (var dt_update_tmp#0#1 := s#0; 
                (var dt_update#inMemoryJournal#0#1 := Seq#Append(JournalCache.Variables.inMemoryJournal(s#0), entries#2); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#0#1), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#0#1), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#0#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#1), 
                    dt_update#inMemoryJournal#0#1, 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#1), 
                    JournalCache.Variables.replayJournal(dt_update_tmp#0#1), 
                    JournalCache.Variables.superblock(dt_update_tmp#0#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#0#1), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#0#1), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#0#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#0#1)))))
             else (var entries#3 := JournalCache.JournalStep.entries(js#0); 
              (var dt_update_tmp#1#1 := s#0; 
                (var dt_update#replayJournal#0#1 := Seq#Drop(JournalCache.Variables.replayJournal(s#0), Seq#Length(entries#3)); 
                  #JournalCache.Variables.Ready(JournalCache.Variables.frozenLoc(dt_update_tmp#1#1), 
                    JournalCache.Variables.isFrozen(dt_update_tmp#1#1), 
                    JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#1), 
                    JournalCache.Variables.superblockWrite(dt_update_tmp#1#1), 
                    JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#1), 
                    JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#1), 
                    JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#1), 
                    JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#1), 
                    dt_update#replayJournal#0#1, 
                    JournalCache.Variables.superblock(dt_update_tmp#1#1), 
                    JournalCache.Variables.whichSuperblock(dt_update_tmp#1#1), 
                    JournalCache.Variables.commitStatus(dt_update_tmp#1#1), 
                    JournalCache.Variables.newSuperblock(dt_update_tmp#1#1), 
                    JournalCache.Variables.syncReqs(dt_update_tmp#1#1)))))));

// definition axiom for JournalCache.__default.DoJournalStep for all literals(revealed)
axiom true
   ==> (forall s#0: DatatypeType, js#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.DoJournalStep(Lit(s#0), Lit(js#0)) } 
    JournalCache.__default.DoJournalStep#canCall(Lit(s#0), Lit(js#0))
         || (
          $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(js#0, Tclass.JournalCache.JournalStep())
           && 
          Lit(JournalCache.__default.ValidJournalStep(Lit(s#0), Lit(js#0)))
           && Lit(JournalCache.Variables.Ready_q(Lit(s#0))))
       ==> (Lit(JournalCache.JournalStep.JSNew_q(Lit(js#0)))
           ==> (JournalCache.JournalStep.JSNew_q(Lit(js#0))
               || JournalCache.JournalStep.JSReplay_q(Lit(js#0)))
             && (var dt_update_tmp#0#2 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#0#2)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#0#2)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#0#2)))
         && (!Lit(JournalCache.JournalStep.JSNew_q(Lit(js#0)))
           ==> (JournalCache.JournalStep.JSNew_q(Lit(js#0))
               || JournalCache.JournalStep.JSReplay_q(Lit(js#0)))
             && (var dt_update_tmp#1#2 := Lit(s#0); 
              JournalCache.Variables.Ready_q(dt_update_tmp#1#2)
                 || JournalCache.Variables.LoadingOther_q(dt_update_tmp#1#2)
                 || JournalCache.Variables.LoadingSuperblock_q(dt_update_tmp#1#2)))
         && JournalCache.__default.DoJournalStep(Lit(s#0), Lit(js#0))
           == (if JournalCache.JournalStep.JSNew_q(Lit(js#0))
             then (var entries#6 := Lit(JournalCache.JournalStep.entries(Lit(js#0))); 
              (var dt_update_tmp#0#3 := Lit(s#0); 
                (var dt_update#inMemoryJournal#0#3 := Seq#Append(JournalCache.Variables.inMemoryJournal(Lit(s#0)), entries#6); 
                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#0#3)), 
                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#0#3)), 
                    dt_update#inMemoryJournal#0#3, 
                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#0#3)), 
                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.replayJournal(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.superblock(dt_update_tmp#0#3)), 
                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#0#3)), 
                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#0#3))))))
             else (var entries#7 := Lit(JournalCache.JournalStep.entries(Lit(js#0))); 
              (var dt_update_tmp#1#3 := Lit(s#0); 
                (var dt_update#replayJournal#0#3 := Seq#Drop(Lit(JournalCache.Variables.replayJournal(Lit(s#0))), Seq#Length(entries#7)); 
                  #JournalCache.Variables.Ready(Lit(JournalCache.Variables.frozenLoc(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.isFrozen(dt_update_tmp#1#3)), 
                    LitInt(JournalCache.Variables.frozenJournalPosition(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.superblockWrite(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.inMemoryJournalFrozen(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.inMemoryJournal(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.outstandingJournalWrites(dt_update_tmp#1#3)), 
                    LitInt(JournalCache.Variables.writtenJournalLen(dt_update_tmp#1#3)), 
                    dt_update#replayJournal#0#3, 
                    Lit(JournalCache.Variables.superblock(dt_update_tmp#1#3)), 
                    LitInt(JournalCache.Variables.whichSuperblock(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.commitStatus(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.newSuperblock(dt_update_tmp#1#3)), 
                    Lit(JournalCache.Variables.syncReqs(dt_update_tmp#1#3))))))));

// function declaration for JournalCache._default.Init
function JournalCache.__default.Init(k#0: DatatypeType, s#0: DatatypeType) : bool;

function JournalCache.__default.Init#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.Init
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.Init(k#0, s#0) } 
    JournalCache.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables()))
       ==> true);

function JournalCache.__default.Init#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.Init
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { JournalCache.__default.Init#requires(k#0, s#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
     ==> JournalCache.__default.Init#requires(k#0, s#0) == true);

// definition axiom for JournalCache.__default.Init(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.Init(k#0, s#0) } 
    JournalCache.__default.Init#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables()))
       ==> $IsA#JournalCache.Variables(s#0)
         && JournalCache.__default.Init(k#0, s#0)
           == JournalCache.Variables#Equal(s#0, 
            #JournalCache.Variables.LoadingSuperblock(Lit(#Options.Option.None()), 
              Lit(#Options.Option.None()), 
              Lit(#JournalCache.SuperblockReadResult.SuperblockUnfinished()), 
              Lit(#JournalCache.SuperblockReadResult.SuperblockUnfinished()), 
              Lit(Map#Empty(): Map Box Box))));

// definition axiom for JournalCache.__default.Init for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.Init(Lit(k#0), Lit(s#0)) } 
    JournalCache.__default.Init#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables()))
       ==> $IsA#JournalCache.Variables(Lit(s#0))
         && JournalCache.__default.Init(Lit(k#0), Lit(s#0))
           == JournalCache.Variables#Equal(s#0, 
            #JournalCache.Variables.LoadingSuperblock(Lit(#Options.Option.None()), 
              Lit(#Options.Option.None()), 
              Lit(#JournalCache.SuperblockReadResult.SuperblockUnfinished()), 
              Lit(#JournalCache.SuperblockReadResult.SuperblockUnfinished()), 
              Lit(Map#Empty(): Map Box Box))));

// function declaration for JournalCache._default.NextStep
function JournalCache.__default.NextStep(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

function JournalCache.__default.NextStep#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    step#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.NextStep
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
    JournalCache.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, vop#0, step#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(step#0, Tclass.JournalCache.Step()))
       ==> true);

function JournalCache.__default.NextStep#requires(DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType, 
    DatatypeType)
   : bool;

// #requires axiom for JournalCache.__default.NextStep
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType, 
    step#0: DatatypeType :: 
  { JournalCache.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
       && $Is(step#0, Tclass.JournalCache.Step())
     ==> JournalCache.__default.NextStep#requires(k#0, s#0, s'#0, dop#0, vop#0, step#0)
       == true);

// definition axiom for JournalCache.__default.NextStep(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      step#0: DatatypeType :: 
    { JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
    JournalCache.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, vop#0, step#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(step#0, Tclass.JournalCache.Step()))
       ==> (JournalCache.Step.WriteBackJournalReqStep_q(step#0)
           ==> (var jr#0 := JournalCache.Step.jr(step#0); 
            JournalCache.__default.WriteBackJournalReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, jr#0)))
         && (!JournalCache.Step.WriteBackJournalReqStep_q(step#0)
           ==> (JournalCache.Step.WriteBackJournalRespStep_q(step#0)
               ==> JournalCache.__default.WriteBackJournalResp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
             && (!JournalCache.Step.WriteBackJournalRespStep_q(step#0)
               ==> (JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(step#0)
                   ==> JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                 && (!JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(step#0)
                   ==> (JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(step#0)
                       ==> JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                     && (!JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(step#0)
                       ==> (JournalCache.Step.WriteBackSuperblockRespStep_q(step#0)
                           ==> JournalCache.__default.WriteBackSuperblockResp#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                         && (!JournalCache.Step.WriteBackSuperblockRespStep_q(step#0)
                           ==> (JournalCache.Step.PageInJournalReqStep_q(step#0)
                               ==> (var which#0 := JournalCache.Step.which(step#0); 
                                JournalCache.__default.PageInJournalReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#0)))
                             && (!JournalCache.Step.PageInJournalReqStep_q(step#0)
                               ==> (JournalCache.Step.PageInJournalRespStep_q(step#0)
                                   ==> (var which#1 := JournalCache.Step.which(step#0); 
                                    JournalCache.__default.PageInJournalResp#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#1)))
                                 && (!JournalCache.Step.PageInJournalRespStep_q(step#0)
                                   ==> (JournalCache.Step.PageInSuperblockReqStep_q(step#0)
                                       ==> (var which#2 := JournalCache.Step.which(step#0); 
                                        JournalCache.__default.PageInSuperblockReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#2)))
                                     && (!JournalCache.Step.PageInSuperblockReqStep_q(step#0)
                                       ==> (JournalCache.Step.PageInSuperblockRespStep_q(step#0)
                                           ==> (var which#3 := JournalCache.Step.which(step#0); 
                                            JournalCache.__default.PageInSuperblockResp#canCall(k#0, s#0, s'#0, dop#0, vop#0, which#3)))
                                         && (!JournalCache.Step.PageInSuperblockRespStep_q(step#0)
                                           ==> (JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(step#0)
                                               ==> JournalCache.__default.FinishLoadingSuperblockPhase#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                             && (!JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(step#0)
                                               ==> (JournalCache.Step.FinishLoadingOtherPhaseStep_q(step#0)
                                                   ==> JournalCache.__default.FinishLoadingOtherPhase#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                 && (!JournalCache.Step.FinishLoadingOtherPhaseStep_q(step#0)
                                                   ==> (JournalCache.Step.FreezeStep_q(step#0)
                                                       ==> JournalCache.__default.Freeze#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                     && (!JournalCache.Step.FreezeStep_q(step#0)
                                                       ==> (JournalCache.Step.ReceiveFrozenLocStep_q(step#0)
                                                           ==> JournalCache.__default.ReceiveFrozenLoc#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                         && (!JournalCache.Step.ReceiveFrozenLocStep_q(step#0)
                                                           ==> (JournalCache.Step.AdvanceStep_q(step#0)
                                                               ==> JournalCache.__default.Advance#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                             && (!JournalCache.Step.AdvanceStep_q(step#0)
                                                               ==> (JournalCache.Step.ReplayStep_q(step#0)
                                                                   ==> JournalCache.__default.Replay#canCall(k#0, s#0, s'#0, dop#0, vop#0))
                                                                 && (!JournalCache.Step.ReplayStep_q(step#0)
                                                                   ==> (JournalCache.Step.PushSyncReqStep_q(step#0)
                                                                       ==> (var id#0 := JournalCache.Step.id(step#0); 
                                                                        JournalCache.__default.PushSyncReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, id#0)))
                                                                     && (!JournalCache.Step.PushSyncReqStep_q(step#0)
                                                                       ==> (JournalCache.Step.PopSyncReqStep_q(step#0)
                                                                           ==> (var id#1 := JournalCache.Step.id(step#0); 
                                                                            JournalCache.__default.PopSyncReq#canCall(k#0, s#0, s'#0, dop#0, vop#0, id#1)))
                                                                         && (!JournalCache.Step.PopSyncReqStep_q(step#0)
                                                                           ==> JournalCache.__default.NoOp#canCall(k#0, s#0, s'#0, dop#0, vop#0))))))))))))))))))
         && JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0)
           == (if JournalCache.Step.WriteBackJournalReqStep_q(step#0)
             then (var jr#1 := JournalCache.Step.jr(step#0); 
              JournalCache.__default.WriteBackJournalReq(k#0, s#0, s'#0, dop#0, vop#0, jr#1))
             else (if JournalCache.Step.WriteBackJournalRespStep_q(step#0)
               then JournalCache.__default.WriteBackJournalResp(k#0, s#0, s'#0, dop#0, vop#0)
               else (if JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(step#0)
                 then JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(k#0, s#0, s'#0, dop#0, vop#0)
                 else (if JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(step#0)
                   then JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(k#0, s#0, s'#0, dop#0, vop#0)
                   else (if JournalCache.Step.WriteBackSuperblockRespStep_q(step#0)
                     then JournalCache.__default.WriteBackSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0)
                     else (if JournalCache.Step.PageInJournalReqStep_q(step#0)
                       then (var which#4 := JournalCache.Step.which(step#0); 
                        JournalCache.__default.PageInJournalReq(k#0, s#0, s'#0, dop#0, vop#0, which#4))
                       else (if JournalCache.Step.PageInJournalRespStep_q(step#0)
                         then (var which#5 := JournalCache.Step.which(step#0); 
                          JournalCache.__default.PageInJournalResp(k#0, s#0, s'#0, dop#0, vop#0, which#5))
                         else (if JournalCache.Step.PageInSuperblockReqStep_q(step#0)
                           then (var which#6 := JournalCache.Step.which(step#0); 
                            JournalCache.__default.PageInSuperblockReq(k#0, s#0, s'#0, dop#0, vop#0, which#6))
                           else (if JournalCache.Step.PageInSuperblockRespStep_q(step#0)
                             then (var which#7 := JournalCache.Step.which(step#0); 
                              JournalCache.__default.PageInSuperblockResp(k#0, s#0, s'#0, dop#0, vop#0, which#7))
                             else (if JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(step#0)
                               then JournalCache.__default.FinishLoadingSuperblockPhase(k#0, s#0, s'#0, dop#0, vop#0)
                               else (if JournalCache.Step.FinishLoadingOtherPhaseStep_q(step#0)
                                 then JournalCache.__default.FinishLoadingOtherPhase(k#0, s#0, s'#0, dop#0, vop#0)
                                 else (if JournalCache.Step.FreezeStep_q(step#0)
                                   then JournalCache.__default.Freeze(k#0, s#0, s'#0, dop#0, vop#0)
                                   else (if JournalCache.Step.ReceiveFrozenLocStep_q(step#0)
                                     then JournalCache.__default.ReceiveFrozenLoc(k#0, s#0, s'#0, dop#0, vop#0)
                                     else (if JournalCache.Step.AdvanceStep_q(step#0)
                                       then JournalCache.__default.Advance(k#0, s#0, s'#0, dop#0, vop#0)
                                       else (if JournalCache.Step.ReplayStep_q(step#0)
                                         then JournalCache.__default.Replay(k#0, s#0, s'#0, dop#0, vop#0)
                                         else (if JournalCache.Step.PushSyncReqStep_q(step#0)
                                           then (var id#2 := JournalCache.Step.id(step#0); 
                                            JournalCache.__default.PushSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#2))
                                           else (if JournalCache.Step.PopSyncReqStep_q(step#0)
                                             then (var id#3 := JournalCache.Step.id(step#0); 
                                              JournalCache.__default.PopSyncReq(k#0, s#0, s'#0, dop#0, vop#0, id#3))
                                             else JournalCache.__default.NoOp(k#0, s#0, s'#0, dop#0, vop#0)))))))))))))))))));

// definition axiom for JournalCache.__default.NextStep for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType, 
      step#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(step#0)) } 
    JournalCache.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(step#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp())
           && $Is(step#0, Tclass.JournalCache.Step()))
       ==> (Lit(JournalCache.Step.WriteBackJournalReqStep_q(Lit(step#0)))
           ==> (var jr#2 := Lit(JournalCache.Step.jr(Lit(step#0))); 
            JournalCache.__default.WriteBackJournalReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), jr#2)))
         && (!Lit(JournalCache.Step.WriteBackJournalReqStep_q(Lit(step#0)))
           ==> (Lit(JournalCache.Step.WriteBackJournalRespStep_q(Lit(step#0)))
               ==> JournalCache.__default.WriteBackJournalResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
             && (!Lit(JournalCache.Step.WriteBackJournalRespStep_q(Lit(step#0)))
               ==> (Lit(JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(Lit(step#0)))
                   ==> JournalCache.__default.WriteBackSuperblockReq__AdvanceLog#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                 && (!Lit(JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(Lit(step#0)))
                   ==> (Lit(JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(Lit(step#0)))
                       ==> JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                     && (!Lit(JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(Lit(step#0)))
                       ==> (Lit(JournalCache.Step.WriteBackSuperblockRespStep_q(Lit(step#0)))
                           ==> JournalCache.__default.WriteBackSuperblockResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                         && (!Lit(JournalCache.Step.WriteBackSuperblockRespStep_q(Lit(step#0)))
                           ==> (Lit(JournalCache.Step.PageInJournalReqStep_q(Lit(step#0)))
                               ==> (var which#8 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                                JournalCache.__default.PageInJournalReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#8)))
                             && (!Lit(JournalCache.Step.PageInJournalReqStep_q(Lit(step#0)))
                               ==> (Lit(JournalCache.Step.PageInJournalRespStep_q(Lit(step#0)))
                                   ==> (var which#9 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                                    JournalCache.__default.PageInJournalResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#9)))
                                 && (!Lit(JournalCache.Step.PageInJournalRespStep_q(Lit(step#0)))
                                   ==> (Lit(JournalCache.Step.PageInSuperblockReqStep_q(Lit(step#0)))
                                       ==> (var which#10 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                                        JournalCache.__default.PageInSuperblockReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#10)))
                                     && (!Lit(JournalCache.Step.PageInSuperblockReqStep_q(Lit(step#0)))
                                       ==> (Lit(JournalCache.Step.PageInSuperblockRespStep_q(Lit(step#0)))
                                           ==> (var which#11 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                                            JournalCache.__default.PageInSuperblockResp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#11)))
                                         && (!Lit(JournalCache.Step.PageInSuperblockRespStep_q(Lit(step#0)))
                                           ==> (Lit(JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(Lit(step#0)))
                                               ==> JournalCache.__default.FinishLoadingSuperblockPhase#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                             && (!Lit(JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(Lit(step#0)))
                                               ==> (Lit(JournalCache.Step.FinishLoadingOtherPhaseStep_q(Lit(step#0)))
                                                   ==> JournalCache.__default.FinishLoadingOtherPhase#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                 && (!Lit(JournalCache.Step.FinishLoadingOtherPhaseStep_q(Lit(step#0)))
                                                   ==> (Lit(JournalCache.Step.FreezeStep_q(Lit(step#0)))
                                                       ==> JournalCache.__default.Freeze#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                     && (!Lit(JournalCache.Step.FreezeStep_q(Lit(step#0)))
                                                       ==> (Lit(JournalCache.Step.ReceiveFrozenLocStep_q(Lit(step#0)))
                                                           ==> JournalCache.__default.ReceiveFrozenLoc#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                         && (!Lit(JournalCache.Step.ReceiveFrozenLocStep_q(Lit(step#0)))
                                                           ==> (Lit(JournalCache.Step.AdvanceStep_q(Lit(step#0)))
                                                               ==> JournalCache.__default.Advance#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                             && (!Lit(JournalCache.Step.AdvanceStep_q(Lit(step#0)))
                                                               ==> (Lit(JournalCache.Step.ReplayStep_q(Lit(step#0)))
                                                                   ==> JournalCache.__default.Replay#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))
                                                                 && (!Lit(JournalCache.Step.ReplayStep_q(Lit(step#0)))
                                                                   ==> (Lit(JournalCache.Step.PushSyncReqStep_q(Lit(step#0)))
                                                                       ==> (var id#4 := LitInt(JournalCache.Step.id(Lit(step#0))); 
                                                                        JournalCache.__default.PushSyncReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), id#4)))
                                                                     && (!Lit(JournalCache.Step.PushSyncReqStep_q(Lit(step#0)))
                                                                       ==> (Lit(JournalCache.Step.PopSyncReqStep_q(Lit(step#0)))
                                                                           ==> (var id#5 := LitInt(JournalCache.Step.id(Lit(step#0))); 
                                                                            JournalCache.__default.PopSyncReq#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), id#5)))
                                                                         && (!Lit(JournalCache.Step.PopSyncReqStep_q(Lit(step#0)))
                                                                           ==> JournalCache.__default.NoOp#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)))))))))))))))))))
         && JournalCache.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), Lit(step#0))
           == (if JournalCache.Step.WriteBackJournalReqStep_q(Lit(step#0))
             then (var jr#3 := Lit(JournalCache.Step.jr(Lit(step#0))); 
              Lit(JournalCache.__default.WriteBackJournalReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), jr#3)))
             else (if JournalCache.Step.WriteBackJournalRespStep_q(Lit(step#0))
               then JournalCache.__default.WriteBackJournalResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
               else (if JournalCache.Step.WriteBackSuperblockReq__AdvanceLog__Step_q(Lit(step#0))
                 then JournalCache.__default.WriteBackSuperblockReq__AdvanceLog(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                 else (if JournalCache.Step.WriteBackSuperblockReq__AdvanceLocation__Step_q(Lit(step#0))
                   then JournalCache.__default.WriteBackSuperblockReq__AdvanceLocation(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                   else (if JournalCache.Step.WriteBackSuperblockRespStep_q(Lit(step#0))
                     then JournalCache.__default.WriteBackSuperblockResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                     else (if JournalCache.Step.PageInJournalReqStep_q(Lit(step#0))
                       then (var which#12 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                        Lit(JournalCache.__default.PageInJournalReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#12)))
                       else (if JournalCache.Step.PageInJournalRespStep_q(Lit(step#0))
                         then (var which#13 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                          Lit(JournalCache.__default.PageInJournalResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#13)))
                         else (if JournalCache.Step.PageInSuperblockReqStep_q(Lit(step#0))
                           then (var which#14 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                            Lit(JournalCache.__default.PageInSuperblockReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#14)))
                           else (if JournalCache.Step.PageInSuperblockRespStep_q(Lit(step#0))
                             then (var which#15 := LitInt(JournalCache.Step.which(Lit(step#0))); 
                              Lit(JournalCache.__default.PageInSuperblockResp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), which#15)))
                             else (if JournalCache.Step.FinishLoadingSuperblockPhaseStep_q(Lit(step#0))
                               then JournalCache.__default.FinishLoadingSuperblockPhase(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                               else (if JournalCache.Step.FinishLoadingOtherPhaseStep_q(Lit(step#0))
                                 then JournalCache.__default.FinishLoadingOtherPhase(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                 else (if JournalCache.Step.FreezeStep_q(Lit(step#0))
                                   then JournalCache.__default.Freeze(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                   else (if JournalCache.Step.ReceiveFrozenLocStep_q(Lit(step#0))
                                     then JournalCache.__default.ReceiveFrozenLoc(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                     else (if JournalCache.Step.AdvanceStep_q(Lit(step#0))
                                       then JournalCache.__default.Advance(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                       else (if JournalCache.Step.ReplayStep_q(Lit(step#0))
                                         then JournalCache.__default.Replay(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
                                         else (if JournalCache.Step.PushSyncReqStep_q(Lit(step#0))
                                           then (var id#6 := LitInt(JournalCache.Step.id(Lit(step#0))); 
                                            Lit(JournalCache.__default.PushSyncReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), id#6)))
                                           else (if JournalCache.Step.PopSyncReqStep_q(Lit(step#0))
                                             then (var id#7 := LitInt(JournalCache.Step.id(Lit(step#0))); 
                                              Lit(JournalCache.__default.PopSyncReq(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), id#7)))
                                             else JournalCache.__default.NoOp(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))))))))))))))))))));

// function declaration for JournalCache._default.Next
function JournalCache.__default.Next(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

function JournalCache.__default.Next#canCall(k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType)
   : bool;

// consequence axiom for JournalCache.__default.Next
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Next(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Next#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> true);

function JournalCache.__default.Next#requires(DatatypeType, DatatypeType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.Next
axiom (forall k#0: DatatypeType, 
    s#0: DatatypeType, 
    s'#0: DatatypeType, 
    dop#0: DatatypeType, 
    vop#0: DatatypeType :: 
  { JournalCache.__default.Next#requires(k#0, s#0, s'#0, dop#0, vop#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
       && $Is(s'#0, Tclass.JournalCache.Variables())
       && $Is(dop#0, Tclass.JournalDisk.DiskOp())
       && $Is(vop#0, Tclass.ViewOp.VOp())
     ==> JournalCache.__default.Next#requires(k#0, s#0, s'#0, dop#0, vop#0) == true);

// definition axiom for JournalCache.__default.Next(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    { JournalCache.__default.Next(k#0, s#0, s'#0, dop#0, vop#0) } 
    JournalCache.__default.Next#canCall(k#0, s#0, s'#0, dop#0, vop#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (forall step#0: DatatypeType :: 
          { JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
          $Is(step#0, Tclass.JournalCache.Step())
             ==> JournalCache.__default.NextStep#canCall(k#0, s#0, s'#0, dop#0, vop#0, step#0))
         && JournalCache.__default.Next(k#0, s#0, s'#0, dop#0, vop#0)
           == (exists step#0: DatatypeType :: 
            { JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0) } 
            $Is(step#0, Tclass.JournalCache.Step())
               && JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#0)));

// definition axiom for JournalCache.__default.Next for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, 
      s#0: DatatypeType, 
      s'#0: DatatypeType, 
      dop#0: DatatypeType, 
      vop#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0)) } 
    JournalCache.__default.Next#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && $Is(s'#0, Tclass.JournalCache.Variables())
           && $Is(dop#0, Tclass.JournalDisk.DiskOp())
           && $Is(vop#0, Tclass.ViewOp.VOp()))
       ==> (forall step#1: DatatypeType :: 
          { JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#1) } 
          $Is(step#1, Tclass.JournalCache.Step())
             ==> JournalCache.__default.NextStep#canCall(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), step#1))
         && JournalCache.__default.Next(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0))
           == (exists step#1: DatatypeType :: 
            { JournalCache.__default.NextStep(k#0, s#0, s'#0, dop#0, vop#0, step#1) } 
            $Is(step#1, Tclass.JournalCache.Step())
               && JournalCache.__default.NextStep(Lit(k#0), Lit(s#0), Lit(s'#0), Lit(dop#0), Lit(vop#0), step#1)));

// function declaration for JournalCache._default.InvLoadingSuperblock
function JournalCache.__default.InvLoadingSuperblock(k#0: DatatypeType, s#0: DatatypeType) : bool;

function JournalCache.__default.InvLoadingSuperblock#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.InvLoadingSuperblock
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.InvLoadingSuperblock(k#0, s#0) } 
    JournalCache.__default.InvLoadingSuperblock#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && JournalCache.Variables.LoadingSuperblock_q(s#0))
       ==> true);

function JournalCache.__default.InvLoadingSuperblock#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.InvLoadingSuperblock
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { JournalCache.__default.InvLoadingSuperblock#requires(k#0, s#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
     ==> JournalCache.__default.InvLoadingSuperblock#requires(k#0, s#0)
       == JournalCache.Variables.LoadingSuperblock_q(s#0));

// definition axiom for JournalCache.__default.InvLoadingSuperblock(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.InvLoadingSuperblock(k#0, s#0) } 
    JournalCache.__default.InvLoadingSuperblock#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && JournalCache.Variables.LoadingSuperblock_q(s#0))
       ==> (JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock1(s#0))
           ==> 
          Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0))
           ==> JournalCache.__default.WFSuperblock#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0))))
         && ((Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0))
               ==> JournalCache.__default.WFSuperblock#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0))))
             && 
            Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0))
             && JournalCache.__default.WFSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0)))
           ==> 
          JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock2(s#0))
           ==> 
          Options.Option.None_q(JournalCache.Variables.outstandingSuperblock2Read(s#0))
           ==> JournalCache.__default.WFSuperblock#canCall(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0))))
         && JournalCache.__default.InvLoadingSuperblock(k#0, s#0)
           == (
            (JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock1(s#0))
               ==> Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0))
                 && JournalCache.__default.WFSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock1(s#0))))
             && (JournalCache.SuperblockReadResult.SuperblockSuccess_q(JournalCache.Variables.superblock2(s#0))
               ==> Options.Option.None_q(JournalCache.Variables.outstandingSuperblock2Read(s#0))
                 && JournalCache.__default.WFSuperblock(JournalCache.SuperblockReadResult.value(JournalCache.Variables.superblock2(s#0))))
             && (JournalCache.SuperblockReadResult.SuperblockCorruption_q(JournalCache.Variables.superblock1(s#0))
               ==> true
                 && Options.Option.None_q(JournalCache.Variables.outstandingSuperblock1Read(s#0)))
             && (JournalCache.SuperblockReadResult.SuperblockCorruption_q(JournalCache.Variables.superblock2(s#0))
               ==> true
                 && Options.Option.None_q(JournalCache.Variables.outstandingSuperblock2Read(s#0)))));

// definition axiom for JournalCache.__default.InvLoadingSuperblock for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.InvLoadingSuperblock(Lit(k#0), Lit(s#0)) } 
    JournalCache.__default.InvLoadingSuperblock#canCall(Lit(k#0), Lit(s#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && Lit(JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))))
       ==> (Lit(JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))
           ==> 
          Lit(Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)))))
           ==> JournalCache.__default.WFSuperblock#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))))
         && ((Lit(Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)))))
               ==> JournalCache.__default.WFSuperblock#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))))
             && Lit(Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0))))
                 && JournalCache.__default.WFSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))))
           ==> 
          Lit(JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))
           ==> 
          Lit(Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0)))))
           ==> JournalCache.__default.WFSuperblock#canCall(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))))
         && JournalCache.__default.InvLoadingSuperblock(Lit(k#0), Lit(s#0))
           == Lit((JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
                 ==> Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0))))
                   && JournalCache.__default.WFSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock1(Lit(s#0)))))))
               && (JournalCache.SuperblockReadResult.SuperblockSuccess_q(Lit(JournalCache.Variables.superblock2(Lit(s#0))))
                 ==> Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0))))
                   && JournalCache.__default.WFSuperblock(Lit(JournalCache.SuperblockReadResult.value(Lit(JournalCache.Variables.superblock2(Lit(s#0)))))))
               && (JournalCache.SuperblockReadResult.SuperblockCorruption_q(Lit(JournalCache.Variables.superblock1(Lit(s#0))))
                 ==> true
                   && Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock1Read(Lit(s#0)))))
               && (JournalCache.SuperblockReadResult.SuperblockCorruption_q(Lit(JournalCache.Variables.superblock2(Lit(s#0))))
                 ==> true
                   && Options.Option.None_q(Lit(JournalCache.Variables.outstandingSuperblock2Read(Lit(s#0)))))));

// function declaration for JournalCache._default.InvLoadingOther
function JournalCache.__default.InvLoadingOther(k#0: DatatypeType, s#0: DatatypeType) : bool;

function JournalCache.__default.InvLoadingOther#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.InvLoadingOther
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.InvLoadingOther(k#0, s#0) } 
    JournalCache.__default.InvLoadingOther#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && JournalCache.Variables.LoadingOther_q(s#0))
       ==> true);

function JournalCache.__default.InvLoadingOther#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.InvLoadingOther
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { JournalCache.__default.InvLoadingOther#requires(k#0, s#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
     ==> JournalCache.__default.InvLoadingOther#requires(k#0, s#0)
       == JournalCache.Variables.LoadingOther_q(s#0));

// definition axiom for JournalCache.__default.InvLoadingOther(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.InvLoadingOther(k#0, s#0) } 
    JournalCache.__default.InvLoadingOther#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && JournalCache.Variables.LoadingOther_q(s#0))
       ==> JournalCache.__default.WFSuperblock#canCall(JournalCache.Variables.superblock(s#0))
         && (JournalCache.Variables.whichSuperblock(s#0) == LitInt(0)
             || JournalCache.Variables.whichSuperblock(s#0) == LitInt(1)
           ==> 
          Options.Option.Some_q(JournalCache.Variables.journalFrontRead(s#0))
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && ((Options.Option.Some_q(JournalCache.Variables.journalFrontRead(s#0))
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
             && (Options.Option.Some_q(JournalCache.Variables.journalFrontRead(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))
           ==> 
          Options.Option.Some_q(JournalCache.Variables.journalFront(s#0))
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && ((Options.Option.Some_q(JournalCache.Variables.journalFront(s#0))
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
             && (Options.Option.Some_q(JournalCache.Variables.journalFront(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))
           ==> 
          Options.Option.Some_q(JournalCache.Variables.journalBackRead(s#0))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && ((Options.Option.Some_q(JournalCache.Variables.journalBackRead(s#0))
               ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
             && (Options.Option.Some_q(JournalCache.Variables.journalBackRead(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))
           ==> 
          Options.Option.Some_q(JournalCache.Variables.journalBack(s#0))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && JournalCache.__default.InvLoadingOther(k#0, s#0)
           == (
            JournalCache.__default.WFSuperblock(JournalCache.Variables.superblock(s#0))
             && (JournalCache.Variables.whichSuperblock(s#0) == LitInt(0)
               || JournalCache.Variables.whichSuperblock(s#0) == LitInt(1))
             && (Options.Option.Some_q(JournalCache.Variables.journalFrontRead(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))
             && (Options.Option.Some_q(JournalCache.Variables.journalFront(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalFrontIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))
             && (Options.Option.Some_q(JournalCache.Variables.journalBackRead(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))
             && (Options.Option.Some_q(JournalCache.Variables.journalBack(s#0))
               ==> Options.Option.Some_q(JournalCache.__default.JournalBackIntervalOfSuperblock(JournalCache.Variables.superblock(s#0))))));

// definition axiom for JournalCache.__default.InvLoadingOther for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.InvLoadingOther(Lit(k#0), Lit(s#0)) } 
    JournalCache.__default.InvLoadingOther#canCall(Lit(k#0), Lit(s#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && Lit(JournalCache.Variables.LoadingOther_q(Lit(s#0))))
       ==> JournalCache.__default.WFSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
         && (LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
             || LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(1)
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0)))))
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && ((Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0)))))
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
                 ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalFront(Lit(s#0)))))
           ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && ((Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalFront(Lit(s#0)))))
               ==> JournalCache.__default.JournalFrontIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalFront(Lit(s#0))))
                 ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalBackRead(Lit(s#0)))))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && ((Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalBackRead(Lit(s#0)))))
               ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalBackRead(Lit(s#0))))
                 ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalCache.Variables.journalBack(Lit(s#0)))))
           ==> JournalCache.__default.JournalBackIntervalOfSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && JournalCache.__default.InvLoadingOther(Lit(k#0), Lit(s#0))
           == (
            JournalCache.__default.WFSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
               || LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(1))
             && (Options.Option.Some_q(Lit(JournalCache.Variables.journalFrontRead(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
             && (Options.Option.Some_q(Lit(JournalCache.Variables.journalFront(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalFrontIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
             && (Options.Option.Some_q(Lit(JournalCache.Variables.journalBackRead(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
             && (Options.Option.Some_q(Lit(JournalCache.Variables.journalBack(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(JournalCache.__default.JournalBackIntervalOfSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))));

// function declaration for JournalCache._default.InvReady
function JournalCache.__default.InvReady(k#0: DatatypeType, s#0: DatatypeType) : bool;

function JournalCache.__default.InvReady#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.InvReady
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.InvReady(k#0, s#0) } 
    JournalCache.__default.InvReady#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && JournalCache.Variables.Ready_q(s#0))
       ==> true);

function JournalCache.__default.InvReady#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.InvReady
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { JournalCache.__default.InvReady#requires(k#0, s#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
     ==> JournalCache.__default.InvReady#requires(k#0, s#0)
       == JournalCache.Variables.Ready_q(s#0));

// definition axiom for JournalCache.__default.InvReady(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.InvReady(k#0, s#0) } 
    JournalCache.__default.InvReady#canCall(k#0, s#0)
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && JournalCache.Variables.Ready_q(s#0))
       ==> (JournalCache.Variables.whichSuperblock(s#0) == LitInt(0)
             || JournalCache.Variables.whichSuperblock(s#0) == LitInt(1)
           ==> 
          LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && ((LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
             && JournalCache.Variables.writtenJournalLen(s#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && (LitInt(0)
                 <= SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))))
         && (SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
             && (LitInt(0)
                 <= SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
             && 
            LitInt(0)
               <= SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
             && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               <= JournalCache.Variables.writtenJournalLen(s#0)
           ==> 
          JournalCache.Variables.isFrozen(s#0)
           ==> (LitInt(0) <= JournalCache.Variables.frozenJournalPosition(s#0)
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && (DiskLayout.__default.NumJournalBlocks#canCall()
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
               ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))))
         && ((JournalCache.Variables.isFrozen(s#0)
               ==> (LitInt(0) <= JournalCache.Variables.frozenJournalPosition(s#0)
                   ==> DiskLayout.__default.NumJournalBlocks#canCall())
                 && (DiskLayout.__default.NumJournalBlocks#canCall()
                     && JournalCache.Variables.frozenJournalPosition(s#0)
                       <= LitInt(DiskLayout.__default.NumJournalBlocks())
                   ==> SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))))
             && (JournalCache.Variables.isFrozen(s#0)
               ==> LitInt(0) <= JournalCache.Variables.frozenJournalPosition(s#0)
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
                   <= JournalCache.Variables.writtenJournalLen(s#0)
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                   <= JournalCache.Variables.writtenJournalLen(s#0))
           ==> 
          Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall($Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType))
         && ((Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
               ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall($Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType))
             && (Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
               ==> DiskLayout.__default.ValidIndirectionTableLocation($Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType)
                 && JournalCache.Variables.isFrozen(s#0))
           ==> JournalCache.__default.WFSuperblock#canCall(JournalCache.Variables.superblock(s#0)))
         && (JournalCache.__default.WFSuperblock#canCall(JournalCache.Variables.superblock(s#0))
             && JournalCache.__default.WFSuperblock(JournalCache.Variables.superblock(s#0))
           ==> 
          JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
           ==> (Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
               ==> $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                 && $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                 && 
                SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
             && ($IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                 && $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                 && 
                SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                  SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
               ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
             && (SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
               ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)))
         && ((JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
               ==> (Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
                   ==> $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                     && $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                     && 
                    SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
                 && ($IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                     && $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                     && 
                    SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                     && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                      SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                   ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0)))
                 && (SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                     && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                       == SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
                   ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
               ==> Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
                 && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                  SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                 && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
                 && SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == JournalCache.Variables.writtenJournalLen(s#0))
           ==> 
          JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
           ==> (Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
               ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && 
                SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && DiskLayout.__default.JournalPosAdd#canCall(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                  JournalCache.Variables.frozenJournalPosition(s#0)))
             && (SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && 
                SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && DiskLayout.__default.JournalPosAdd#canCall(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                  JournalCache.Variables.frozenJournalPosition(s#0))
                 && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                    JournalCache.Variables.frozenJournalPosition(s#0))
               ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
             && (SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == JournalCache.Variables.writtenJournalLen(s#0)
                     - JournalCache.Variables.frozenJournalPosition(s#0)
               ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)))
         && ((JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> (Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
                   ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && 
                    SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                     && DiskLayout.__default.JournalPosAdd#canCall(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                      JournalCache.Variables.frozenJournalPosition(s#0)))
                 && (SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && 
                    SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                     && DiskLayout.__default.JournalPosAdd#canCall(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                      JournalCache.Variables.frozenJournalPosition(s#0))
                     && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                       == DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                        JournalCache.Variables.frozenJournalPosition(s#0))
                   ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                 && (SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                     && SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                       == JournalCache.Variables.writtenJournalLen(s#0)
                         - JournalCache.Variables.frozenJournalPosition(s#0)
                   ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> JournalCache.Variables.isFrozen(s#0)
                 && Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
                 && Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
                 && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                    JournalCache.Variables.frozenJournalPosition(s#0))
                 && SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == JournalCache.Variables.writtenJournalLen(s#0)
                     - JournalCache.Variables.frozenJournalPosition(s#0)
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                     + SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   <= JournalCache.Variables.writtenJournalLen(s#0))
           ==> 
          Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
           ==> (Set#Equal(JournalCache.Variables.outstandingJournalWrites(s#0), Set#Empty(): Set Box)
               ==> $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                 && $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                 && 
                SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && (!DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                    SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                   ==> 
                  Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
                   ==> $IsA#DiskLayout.Location(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
                     && $IsA#DiskLayout.Location($Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType)
                     && SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
                 || JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> JournalCache.__default.WFSuperblock#canCall($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType))
             && (JournalCache.__default.WFSuperblock#canCall($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && JournalCache.__default.WFSuperblock($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
               ==> SectorType.Superblock.Superblock_q($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && 
                SectorType.Superblock.Superblock_q(JournalCache.Variables.superblock(s#0))
                 && JournalCache.__default.IncrementSuperblockCounter#canCall(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0)))))
         && JournalCache.__default.InvReady(k#0, s#0)
           == (
            (Options.Option.Some_q(JournalCache.Variables.superblockWrite(s#0))
               <==> Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0)))
             && (Options.Option.None_q(JournalCache.Variables.superblockWrite(s#0))
               <==> JournalCache.CommitStatus.CommitNone_q(JournalCache.Variables.commitStatus(s#0)))
             && (JournalCache.Variables.whichSuperblock(s#0) == LitInt(0)
               || JournalCache.Variables.whichSuperblock(s#0) == LitInt(1))
             && 
            LitInt(0) <= JournalCache.Variables.writtenJournalLen(s#0)
             && JournalCache.Variables.writtenJournalLen(s#0)
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && 
            LitInt(0)
               <= SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
             && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
               <= JournalCache.Variables.writtenJournalLen(s#0)
             && (JournalCache.Variables.isFrozen(s#0)
               ==> LitInt(0) <= JournalCache.Variables.frozenJournalPosition(s#0)
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && SectorType.Superblock.journalLen(JournalCache.Variables.superblock(s#0))
                   <= JournalCache.Variables.writtenJournalLen(s#0)
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                   <= JournalCache.Variables.writtenJournalLen(s#0))
             && (Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
               ==> DiskLayout.__default.ValidIndirectionTableLocation($Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType)
                 && JournalCache.Variables.isFrozen(s#0))
             && JournalCache.__default.WFSuperblock(JournalCache.Variables.superblock(s#0))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
               ==> Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
                 && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                  SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                 && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0))
                 && SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == JournalCache.Variables.writtenJournalLen(s#0))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0))
               ==> JournalCache.Variables.isFrozen(s#0)
                 && Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
                 && Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
                 && SectorType.Superblock.journalStart($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == DiskLayout.__default.JournalPosAdd(SectorType.Superblock.journalStart(JournalCache.Variables.superblock(s#0)), 
                    JournalCache.Variables.frozenJournalPosition(s#0))
                 && SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == JournalCache.Variables.writtenJournalLen(s#0)
                     - JournalCache.Variables.frozenJournalPosition(s#0)
                 && JournalCache.Variables.frozenJournalPosition(s#0)
                     + SectorType.Superblock.journalLen($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   <= JournalCache.Variables.writtenJournalLen(s#0))
             && (Options.Option.Some_q(JournalCache.Variables.newSuperblock(s#0))
               ==> Set#Equal(JournalCache.Variables.outstandingJournalWrites(s#0), Set#Empty(): Set Box)
                 && (DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                    SectorType.Superblock.indirectionTableLoc(JournalCache.Variables.superblock(s#0)))
                   || (Options.Option.Some_q(JournalCache.Variables.frozenLoc(s#0))
                     && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType), 
                      $Unbox(Options.Option.value(JournalCache.Variables.frozenLoc(s#0))): DatatypeType)))
                 && (JournalCache.CommitStatus.CommitAdvanceLog_q(JournalCache.Variables.commitStatus(s#0))
                   || JournalCache.CommitStatus.CommitAdvanceLocation_q(JournalCache.Variables.commitStatus(s#0)))
                 && JournalCache.__default.WFSuperblock($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                 && SectorType.Superblock.counter($Unbox(Options.Option.value(JournalCache.Variables.newSuperblock(s#0))): DatatypeType)
                   == JournalCache.__default.IncrementSuperblockCounter(SectorType.Superblock.counter(JournalCache.Variables.superblock(s#0)))
                 && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box))
             && (!Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(s#0), Seq#Empty(): Seq Box)
               ==> JournalCache.Variables.frozenJournalPosition(s#0)
                   == JournalCache.Variables.writtenJournalLen(s#0)
                 && JournalCache.Variables.isFrozen(s#0))));

// definition axiom for JournalCache.__default.InvReady for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.InvReady(Lit(k#0), Lit(s#0)) } 
    JournalCache.__default.InvReady#canCall(Lit(k#0), Lit(s#0))
         || (
          $Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables())
           && Lit(JournalCache.Variables.Ready_q(Lit(s#0))))
       ==> (LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
             || LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(1)
           ==> 
          LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
           ==> DiskLayout.__default.NumJournalBlocks#canCall())
         && ((LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && 
            LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
           ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (LitInt(0)
                 <= LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
         && (SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (LitInt(0)
                 <= LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && 
            LitInt(0)
               <= LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
           ==> 
          Lit(JournalCache.Variables.isFrozen(Lit(s#0)))
           ==> (LitInt(0) <= LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
               ==> DiskLayout.__default.NumJournalBlocks#canCall())
             && (DiskLayout.__default.NumJournalBlocks#canCall()
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
               ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
         && ((Lit(JournalCache.Variables.isFrozen(Lit(s#0)))
               ==> (LitInt(0) <= LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   ==> DiskLayout.__default.NumJournalBlocks#canCall())
                 && (DiskLayout.__default.NumJournalBlocks#canCall()
                     && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                       <= LitInt(DiskLayout.__default.NumJournalBlocks())
                   ==> SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
             && (JournalCache.Variables.isFrozen(Lit(s#0))
               ==> LitInt(0) <= LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0)))))
           ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType)))
         && ((Lit(Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0)))))
               ==> DiskLayout.__default.ValidIndirectionTableLocation#canCall(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType)))
             && Lit(Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
                 ==> DiskLayout.__default.ValidIndirectionTableLocation(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType))
                   && JournalCache.Variables.isFrozen(Lit(s#0)))
           ==> JournalCache.__default.WFSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
         && (JournalCache.__default.WFSuperblock#canCall(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && Lit(JournalCache.__default.WFSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
           ==> 
          Lit(JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
           ==> (Lit(Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0)))))
               ==> $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
                 && $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 && 
                SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && ($IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
                 && $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 && 
                SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                  SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && (SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
         && ((Lit(JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
               ==> (Lit(Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0)))))
                   ==> $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
                     && $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                     && 
                    SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && ($IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
                     && $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                     && 
                    SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                     && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                      SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && (SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                     && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                       == LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))
                 && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                  SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && LitInt(SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
           ==> 
          Lit(JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
           ==> (Lit(Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && 
                SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && DiskLayout.__default.JournalPosAdd#canCall(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                  LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))))
             && (SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && 
                SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && DiskLayout.__default.JournalPosAdd#canCall(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                  LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))))
                 && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))))
               ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
             && (SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && LitInt(SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                       - JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
               ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
         && ((Lit(JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
               ==> (Lit(Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0)))))
                   ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && 
                    SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                     && DiskLayout.__default.JournalPosAdd#canCall(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))))
                 && (SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && 
                    SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                     && DiskLayout.__default.JournalPosAdd#canCall(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))))
                     && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                       == LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                          LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))))
                   ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                 && (SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                     && LitInt(SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                       == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                           - JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> JournalCache.Variables.isFrozen(Lit(s#0))
                 && Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
                 && Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))
                 && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))))
                 && LitInt(SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                       - JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))
                       + SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
           ==> 
          Lit(Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0)))))
           ==> (Set#Equal(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), Set#Empty(): Set Box)
               ==> $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
                 && $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0))))))
                 && 
                SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && (!DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                    SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   ==> 
                  Lit(Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0)))))
                   ==> $IsA#DiskLayout.Location(Lit(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
                     && $IsA#DiskLayout.Location(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType))
                     && SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))))
             && (Lit(JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
                   || JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
               ==> JournalCache.__default.WFSuperblock#canCall(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
             && (JournalCache.__default.WFSuperblock#canCall(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && Lit(JournalCache.__default.WFSuperblock(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
               ==> SectorType.Superblock.Superblock_q(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && 
                SectorType.Superblock.Superblock_q(Lit(JournalCache.Variables.superblock(Lit(s#0))))
                 && JournalCache.__default.IncrementSuperblockCounter#canCall(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0))))))))
         && JournalCache.__default.InvReady(Lit(k#0), Lit(s#0))
           == (
            (Options.Option.Some_q(Lit(JournalCache.Variables.superblockWrite(Lit(s#0))))
               <==> Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0)))))
             && (Options.Option.None_q(Lit(JournalCache.Variables.superblockWrite(Lit(s#0))))
               <==> JournalCache.CommitStatus.CommitNone_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
             && (LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(0)
               || LitInt(JournalCache.Variables.whichSuperblock(Lit(s#0))) == LitInt(1))
             && 
            LitInt(0) <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
               <= LitInt(DiskLayout.__default.NumJournalBlocks())
             && 
            LitInt(0)
               <= LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
             && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
               <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
             && (JournalCache.Variables.isFrozen(Lit(s#0))
               ==> LitInt(0) <= LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   <= LitInt(DiskLayout.__default.NumJournalBlocks())
                 && LitInt(SectorType.Superblock.journalLen(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
             && (Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
               ==> DiskLayout.__default.ValidIndirectionTableLocation(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType))
                 && JournalCache.Variables.isFrozen(Lit(s#0)))
             && JournalCache.__default.WFSuperblock(Lit(JournalCache.Variables.superblock(Lit(s#0))))
             && (JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))
                 && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                  SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                 && LitInt(SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
             && (JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
               ==> JournalCache.Variables.isFrozen(Lit(s#0))
                 && Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
                 && Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))
                 && LitInt(SectorType.Superblock.journalStart(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(DiskLayout.__default.JournalPosAdd(LitInt(SectorType.Superblock.journalStart(Lit(JournalCache.Variables.superblock(Lit(s#0))))), 
                      LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))))
                 && LitInt(SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))
                       - JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                 && LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0))
                       + SectorType.Superblock.journalLen(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   <= LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0))))
             && (Options.Option.Some_q(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))
               ==> Set#Equal(JournalCache.Variables.outstandingJournalWrites(Lit(s#0)), Set#Empty(): Set Box)
                 && (DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                    SectorType.Superblock.indirectionTableLoc(Lit(JournalCache.Variables.superblock(Lit(s#0)))))
                   || (Options.Option.Some_q(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))
                     && DiskLayout.Location#Equal(SectorType.Superblock.indirectionTableLoc(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)), 
                      $Unbox(Options.Option.value(Lit(JournalCache.Variables.frozenLoc(Lit(s#0))))): DatatypeType)))
                 && (JournalCache.CommitStatus.CommitAdvanceLog_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0))))
                   || JournalCache.CommitStatus.CommitAdvanceLocation_q(Lit(JournalCache.Variables.commitStatus(Lit(s#0)))))
                 && JournalCache.__default.WFSuperblock(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType))
                 && LitInt(SectorType.Superblock.counter(Lit($Unbox(Options.Option.value(Lit(JournalCache.Variables.newSuperblock(Lit(s#0))))): DatatypeType)))
                   == LitInt(JournalCache.__default.IncrementSuperblockCounter(LitInt(SectorType.Superblock.counter(Lit(JournalCache.Variables.superblock(Lit(s#0)))))))
                 && Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box))
             && (!Seq#Equal(JournalCache.Variables.inMemoryJournalFrozen(Lit(s#0)), Seq#Empty(): Seq Box)
               ==> LitInt(JournalCache.Variables.frozenJournalPosition(Lit(s#0)))
                   == LitInt(JournalCache.Variables.writtenJournalLen(Lit(s#0)))
                 && JournalCache.Variables.isFrozen(Lit(s#0)))));

// function declaration for JournalCache._default.Inv
function JournalCache.__default.Inv(k#0: DatatypeType, s#0: DatatypeType) : bool;

function JournalCache.__default.Inv#canCall(k#0: DatatypeType, s#0: DatatypeType) : bool;

// consequence axiom for JournalCache.__default.Inv
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.Inv(k#0, s#0) } 
    JournalCache.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables()))
       ==> true);

function JournalCache.__default.Inv#requires(DatatypeType, DatatypeType) : bool;

// #requires axiom for JournalCache.__default.Inv
axiom (forall k#0: DatatypeType, s#0: DatatypeType :: 
  { JournalCache.__default.Inv#requires(k#0, s#0) } 
  $Is(k#0, Tclass.JournalCache.Constants())
       && $Is(s#0, Tclass.JournalCache.Variables())
     ==> JournalCache.__default.Inv#requires(k#0, s#0) == true);

// definition axiom for JournalCache.__default.Inv(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    { JournalCache.__default.Inv(k#0, s#0) } 
    JournalCache.__default.Inv#canCall(k#0, s#0)
         || ($Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables()))
       ==> (JournalCache.Variables.LoadingSuperblock_q(s#0)
           ==> JournalCache.__default.InvLoadingSuperblock#canCall(k#0, s#0))
         && (JournalCache.__default.InvLoadingSuperblock#canCall(k#0, s#0)
             && JournalCache.__default.InvLoadingSuperblock(k#0, s#0)
           ==> 
          JournalCache.Variables.LoadingOther_q(s#0)
           ==> JournalCache.__default.InvLoadingOther#canCall(k#0, s#0))
         && ((JournalCache.Variables.LoadingOther_q(s#0)
               ==> JournalCache.__default.InvLoadingOther#canCall(k#0, s#0))
             && (JournalCache.Variables.LoadingOther_q(s#0)
               ==> JournalCache.__default.InvLoadingOther(k#0, s#0))
           ==> 
          JournalCache.Variables.Ready_q(s#0)
           ==> JournalCache.__default.InvReady#canCall(k#0, s#0))
         && JournalCache.__default.Inv(k#0, s#0)
           == (
            (JournalCache.Variables.LoadingSuperblock_q(s#0)
               ==> JournalCache.__default.InvLoadingSuperblock(k#0, s#0))
             && (JournalCache.Variables.LoadingOther_q(s#0)
               ==> JournalCache.__default.InvLoadingOther(k#0, s#0))
             && (JournalCache.Variables.Ready_q(s#0)
               ==> JournalCache.__default.InvReady(k#0, s#0))));

// definition axiom for JournalCache.__default.Inv for all literals(revealed)
axiom true
   ==> (forall k#0: DatatypeType, s#0: DatatypeType :: 
    {:weight 3} { JournalCache.__default.Inv(Lit(k#0), Lit(s#0)) } 
    JournalCache.__default.Inv#canCall(Lit(k#0), Lit(s#0))
         || ($Is(k#0, Tclass.JournalCache.Constants())
           && $Is(s#0, Tclass.JournalCache.Variables()))
       ==> (Lit(JournalCache.Variables.LoadingSuperblock_q(Lit(s#0)))
           ==> JournalCache.__default.InvLoadingSuperblock#canCall(Lit(k#0), Lit(s#0)))
         && (JournalCache.__default.InvLoadingSuperblock#canCall(Lit(k#0), Lit(s#0))
             && Lit(JournalCache.__default.InvLoadingSuperblock(Lit(k#0), Lit(s#0)))
           ==> 
          Lit(JournalCache.Variables.LoadingOther_q(Lit(s#0)))
           ==> JournalCache.__default.InvLoadingOther#canCall(Lit(k#0), Lit(s#0)))
         && ((Lit(JournalCache.Variables.LoadingOther_q(Lit(s#0)))
               ==> JournalCache.__default.InvLoadingOther#canCall(Lit(k#0), Lit(s#0)))
             && Lit(JournalCache.Variables.LoadingOther_q(Lit(s#0))
                 ==> JournalCache.__default.InvLoadingOther(Lit(k#0), Lit(s#0)))
           ==> 
          Lit(JournalCache.Variables.Ready_q(Lit(s#0)))
           ==> JournalCache.__default.InvReady#canCall(Lit(k#0), Lit(s#0)))
         && JournalCache.__default.Inv(Lit(k#0), Lit(s#0))
           == Lit((JournalCache.Variables.LoadingSuperblock_q(Lit(s#0))
                 ==> JournalCache.__default.InvLoadingSuperblock(Lit(k#0), Lit(s#0)))
               && (JournalCache.Variables.LoadingOther_q(Lit(s#0))
                 ==> JournalCache.__default.InvLoadingOther(Lit(k#0), Lit(s#0)))
               && (JournalCache.Variables.Ready_q(Lit(s#0))
                 ==> JournalCache.__default.InvReady(Lit(k#0), Lit(s#0)))));

const unique class.Crypto.__default: ClassName;

function Tclass.Crypto.__default() : Ty;

// Tclass.Crypto.__default Tag
axiom Tag(Tclass.Crypto.__default()) == Tagclass.Crypto.__default;

const unique Tagclass.Crypto.__default: TyTag;

// Box/unbox axiom for Tclass.Crypto.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Crypto.__default()) } 
  $IsBox(bx, Tclass.Crypto.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.Crypto.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Crypto.__default()) } 
  $Is($o, Tclass.Crypto.__default())
     <==> $o == null || dtype($o) == Tclass.Crypto.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Crypto.__default(), $h) } 
  $IsAlloc($o, Tclass.Crypto.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Crypto._default.Sha256
function Crypto.__default.Sha256(t#0: Seq Box) : Seq Box;

function Crypto.__default.Sha256#canCall(t#0: Seq Box) : bool;

// consequence axiom for Crypto.__default.Sha256
axiom true
   ==> (forall t#0: Seq Box :: 
    { Crypto.__default.Sha256(t#0) } 
    Crypto.__default.Sha256#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Seq#Length(Crypto.__default.Sha256(t#0)) == LitInt(32)
         && $Is(Crypto.__default.Sha256(t#0), TSeq(Tclass.NativeTypes.byte())));

function Crypto.__default.Sha256#requires(Seq Box) : bool;

// #requires axiom for Crypto.__default.Sha256
axiom (forall t#0: Seq Box :: 
  { Crypto.__default.Sha256#requires(t#0) } 
  $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Crypto.__default.Sha256#requires(t#0) == true);

// function declaration for Crypto._default.Crc32C
function Crypto.__default.Crc32C(t#0: Seq Box) : Seq Box;

function Crypto.__default.Crc32C#canCall(t#0: Seq Box) : bool;

// consequence axiom for Crypto.__default.Crc32C
axiom true
   ==> (forall t#0: Seq Box :: 
    { Crypto.__default.Crc32C(t#0) } 
    Crypto.__default.Crc32C#canCall(t#0)
         || $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
       ==> Seq#Length(Crypto.__default.Crc32C(t#0)) == LitInt(32)
         && $Is(Crypto.__default.Crc32C(t#0), TSeq(Tclass.NativeTypes.byte())));

function Crypto.__default.Crc32C#requires(Seq Box) : bool;

// #requires axiom for Crypto.__default.Crc32C
axiom (forall t#0: Seq Box :: 
  { Crypto.__default.Crc32C#requires(t#0) } 
  $Is(t#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Crypto.__default.Crc32C#requires(t#0) == true);

const unique class.Uint32__Order.__default: ClassName;

function Tclass.Uint32__Order.__default() : Ty;

// Tclass.Uint32__Order.__default Tag
axiom Tag(Tclass.Uint32__Order.__default()) == Tagclass.Uint32__Order.__default;

const unique Tagclass.Uint32__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Uint32__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Uint32__Order.__default()) } 
  $IsBox(bx, Tclass.Uint32__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Uint32__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Uint32__Order.__default()) } 
  $Is($o, Tclass.Uint32__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Uint32__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Uint32__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Uint32__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Uint32_Order._default.SomeElement
function Uint32__Order.__default.SomeElement() : int;

function Uint32__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Uint32__Order.__default.SomeElement
axiom true
   ==> 
  true
   ==> LitInt(0) <= Uint32__Order.__default.SomeElement()
     && Uint32__Order.__default.SomeElement() < 4294967296;

function Uint32__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Uint32__Order.__default.SomeElement
axiom Uint32__Order.__default.SomeElement#requires() == true;

// definition axiom for Uint32__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Uint32__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Uint32__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Uint32__Order.__default.SomeElement() == LitInt(0);

// function declaration for Uint32_Order._default.lte
function Uint32__Order.__default.lte(a#0: int, b#0: int) : bool;

function Uint32__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lte(a#0, b#0) } 
    Uint32__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
           || Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0))
         && (forall a#1: int, b#1: int, c#0: int :: 
          { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, c#0), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#1, c#0) } 
            { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#1, c#0), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, b#1) } 
          LitInt(0) <= a#1
               && a#1 < 4294967296
               && 
              LitInt(0) <= b#1
               && b#1 < 4294967296
               && 
              LitInt(0) <= c#0
               && c#0 < 4294967296
             ==> 
            Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, b#1)
               && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#1, c#0)
             ==> Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#1, c#0))
         && Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
           || Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0))
         && (Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0)
             && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#2: int, b#2: int, c#1: int :: 
          { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, c#1), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#2, c#1) } 
            { Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#2, c#1), Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, b#2) } 
          LitInt(0) <= a#2
               && a#2 < 4294967296
               && 
              LitInt(0) <= b#2
               && b#2 < 4294967296
               && 
              LitInt(0) <= c#1
               && c#1 < 4294967296
             ==> 
            Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, b#2)
               && Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, b#2, c#1)
             ==> Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#2, c#1)));

function Uint32__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.lte#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Uint32_Order._default.ltedef0: LayerType;

// definition axiom for Uint32__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lte(a#0, b#0) } 
    Uint32__Order.__default.lte#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Uint32_Order._default.ltedef
           == $LS(MoreFuel_Uint32_Order._default.ltedef0)
         && StartFuelAssert_Uint32_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint32_Order._default.ltedef0))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.ltedef0)
           == MoreFuel_Uint32_Order._default.ltedef0
         && Uint32__Order.__default.lte(a#0, b#0)
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, a#0, b#0));

const MoreFuel_Uint32_Order._default.ltedef1: LayerType;

// definition axiom for Uint32__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Uint32_Order._default.ltedef
           == $LS(MoreFuel_Uint32_Order._default.ltedef1)
         && StartFuelAssert_Uint32_Order._default.ltedef
           == $LS($LS(MoreFuel_Uint32_Order._default.ltedef1))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.ltedef1)
           == MoreFuel_Uint32_Order._default.ltedef1
         && Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Uint32__Order.__default.ltedef(StartFuel_Uint32_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Uint32_Order._default.ltedef
function Uint32__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Uint32__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Uint32__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Uint32__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Uint32__Order.__default.ltedef($ly, a#0, b#0)
     == Uint32__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Uint32__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint32__Order.__default.ltedef($ly, a#0, b#0) } 
    Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Uint32__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Uint32__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    Uint32__Order.__default.ltedef#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Uint32__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Uint32_Order._default.LargestLte
function Uint32__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
     == Uint32__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Uint32__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
         && Uint32__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Uint32__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Uint32__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Uint32__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Uint32__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted0: LayerType;

// definition axiom for Uint32__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.LargestLte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint32__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted0)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted0)
           == MoreFuel_Uint32_Order._default.IsSorted0
         && Uint32__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint32_Order._default.IsSorted1: LayerType;

// definition axiom for Uint32__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint32__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint32__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted1)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted1)
           == MoreFuel_Uint32_Order._default.IsSorted1
         && Uint32__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint32__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint32_Order._default.LargestLt
function Uint32__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
     == Uint32__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Uint32__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
         && Uint32__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Uint32__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Uint32__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Uint32__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Uint32__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Uint32__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted2: LayerType;

// definition axiom for Uint32__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.LargestLt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Uint32__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted2)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted2)
           == MoreFuel_Uint32_Order._default.IsSorted2
         && Uint32__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1 + Uint32__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Uint32_Order._default.IsSorted3: LayerType;

// definition axiom for Uint32__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Uint32__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Uint32__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Uint32__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted3)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted3)
           == MoreFuel_Uint32_Order._default.IsSorted3
         && Uint32__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Uint32__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Uint32__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Uint32_Order._default.IndexOfFirstGte
function Uint32__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Uint32__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Uint32__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted4: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), run#0)
             && Uint32__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
              needle#0)
             && (!Uint32__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), run#0)
                 && Uint32__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted4)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted4)
           == MoreFuel_Uint32_Order._default.IsSorted4
         && Uint32__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint32__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0))));

const MoreFuel_Uint32_Order._default.IsSorted5: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
             && Uint32__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint32__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
                 && Uint32__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted5)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted5)
           == MoreFuel_Uint32_Order._default.IsSorted5
         && Uint32__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint32__Order.__default.IndexOfFirstGte($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGteIter
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint32__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGte
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Uint32__Order.__default.lt($Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint32_Order._default.IndexOfFirstGt
function Uint32__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Uint32__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Uint32__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Uint32__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Uint32__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Uint32__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Uint32__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= needle#0
       && needle#0 < 4294967296
     ==> Uint32__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0));

const MoreFuel_Uint32_Order._default.IsSorted6: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), run#0)
             && Uint32__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
              needle#0)
             && (!Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), run#0)
                 && Uint32__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0)))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted6)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted6)
           == MoreFuel_Uint32_Order._default.IsSorted6
         && Uint32__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lte($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), run#0)): int, 
                needle#0)
               then Seq#Length(run#0)
               else Uint32__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), run#0), needle#0))));

const MoreFuel_Uint32_Order._default.IsSorted7: LayerType;

// definition axiom for Uint32__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Uint32__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Uint32__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || (
          $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= needle#0
           && needle#0 < 4294967296
           && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
             && Uint32__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Uint32__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(run#0))
                 && Uint32__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                  LitInt(needle#0))))
         && 
        StartFuel_Uint32_Order._default.IsSorted
           == $LS(MoreFuel_Uint32_Order._default.IsSorted7)
         && StartFuelAssert_Uint32_Order._default.IsSorted
           == $LS($LS(MoreFuel_Uint32_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Uint32_Order._default.IsSorted7)
           == MoreFuel_Uint32_Order._default.IsSorted7
         && Uint32__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Uint32__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Uint32__Order.__default.IndexOfFirstGt($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(run#0))), 
                LitInt(needle#0)))));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGtIter
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Uint32__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Uint32__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Uint32_Order._default.binarySearchIndexOfFirstKeyGt
function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> LitInt(0)
           <= Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Uint32__Order.__default.lte($Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Uint32__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Uint32__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Uint32__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || ($Is(s#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Uint32__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Uint32__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Uint32_Order._default.SetAllLte
function Uint32__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Uint32__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint32__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLte(a#0, b#0) } 
    Uint32__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> true);

function Uint32__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint32__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint32()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLte(a#0, b#0) } 
    Uint32__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#0: int, y#0: int :: 
          { Uint32__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
             ==> 
            b#0[$Box(y#0)]
             ==> Uint32__Order.__default.lte#canCall(x#0, y#0))
         && Uint32__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Uint32__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Uint32__Order.__default.lte(x#0, y#0)));

// definition axiom for Uint32__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Uint32__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#1: int, y#1: int :: 
          { Uint32__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Uint32__Order.__default.lte#canCall(x#1, y#1))
         && Uint32__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Uint32__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Uint32__Order.__default.lte(x#1, y#1)));

// function declaration for Uint32_Order._default.SetAllLt
function Uint32__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Uint32__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Uint32__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLt(a#0, b#0) } 
    Uint32__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> true);

function Uint32__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Uint32__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(Tclass.NativeTypes.uint32()))
       && $Is(b#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Uint32__Order.__default.SetAllLt(a#0, b#0) } 
    Uint32__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#0: int, y#0: int :: 
          { Uint32__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
             ==> 
            b#0[$Box(y#0)]
             ==> Uint32__Order.__default.lt#canCall(x#0, y#0))
         && Uint32__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Uint32__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            LitInt(0) <= x#0 && x#0 < 4294967296 && LitInt(0) <= y#0 && y#0 < 4294967296
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Uint32__Order.__default.lt(x#0, y#0)));

// definition axiom for Uint32__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Uint32__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(Tclass.NativeTypes.uint32()))
           && $Is(b#0, TSet(Tclass.NativeTypes.uint32())))
       ==> (forall x#1: int, y#1: int :: 
          { Uint32__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
             ==> 
            Lit(b#0)[$Box(y#1)]
             ==> Uint32__Order.__default.lt#canCall(x#1, y#1))
         && Uint32__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Uint32__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            LitInt(0) <= x#1 && x#1 < 4294967296 && LitInt(0) <= y#1 && y#1 < 4294967296
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Uint32__Order.__default.lt(x#1, y#1)));

// function declaration for Uint32_Order._default.NotMinimum
function Uint32__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Uint32__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum($LS($ly), a#0) } 
  Uint32__Order.__default.NotMinimum($LS($ly), a#0)
     == Uint32__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Uint32__Order.__default.NotMinimum($ly, a#0)
     == Uint32__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Uint32__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint32__Order.__default.NotMinimum($ly, a#0) } 
    Uint32__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Uint32__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Uint32__Order.__default.NotMinimum#requires($ly, a#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296
     ==> Uint32__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Uint32__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Uint32__Order.__default.NotMinimum($LS($ly), a#0) } 
    Uint32__Order.__default.NotMinimum#canCall(a#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> (forall b#0: int :: 
          { Uint32__Order.__default.lt(b#0, a#0) } 
          LitInt(0) <= b#0 && b#0 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(b#0, a#0))
         && Uint32__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: int :: 
            { Uint32__Order.__default.lt(b#0, a#0) } 
            LitInt(0) <= b#0 && b#0 < 4294967296 && Uint32__Order.__default.lt(b#0, a#0)));

// definition axiom for Uint32__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Uint32__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    Uint32__Order.__default.NotMinimum#canCall(LitInt(a#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296)
       ==> (forall b#1: int :: 
          { Uint32__Order.__default.lt(b#1, a#0) } 
          LitInt(0) <= b#1 && b#1 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(b#1, LitInt(a#0)))
         && Uint32__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#1: int :: 
            { Uint32__Order.__default.lt(b#1, a#0) } 
            LitInt(0) <= b#1
               && b#1 < 4294967296
               && Uint32__Order.__default.lt(b#1, LitInt(a#0))));

// function declaration for Uint32_Order._default.MapPivotedUnion
function Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Uint32__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)));

function Uint32__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Uint32__Order.__default.MapPivotedUnion
axiom (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Uint32__Order.__default.MapPivotedUnion#requires(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
       && 
      LitInt(0) <= pivot#0
       && pivot#0 < 4294967296
       && $Is(right#0, 
        TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
     ==> Uint32__Order.__default.MapPivotedUnion#requires(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Uint32__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: int :: 
          { Uint32__Order.__default.lt(k#0, pivot#0) } 
          LitInt(0) <= k#0 && k#0 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
          Uint32_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.uint32())
               && Uint32__Order.__default.lt($Unbox($y#0): int, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lt($Unbox($y#3): int, pivot#0))); 
          (forall k#1: int :: 
              { Uint32__Order.__default.lte(pivot#0, k#1) } 
              LitInt(0) <= k#1 && k#1 < 4294967296
                 ==> Uint32__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lte(pivot#0, $Unbox($y#1): int)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(pivot#0, $Unbox($y#2): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, Tclass.NativeTypes.uint32())
                     && Uint32__Order.__default.lt($Unbox($y#4): int, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(pivot#0, $Unbox($y#5): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Uint32__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Uint32__Order.__default.MapPivotedUnion#canCall(Uint32_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || (
          $Is(left#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value))
           && 
          LitInt(0) <= pivot#0
           && pivot#0 < 4294967296
           && $Is(right#0, 
            TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: int :: 
          { Uint32__Order.__default.lt(k#2, pivot#0) } 
          LitInt(0) <= k#2 && k#2 < 4294967296
             ==> Uint32__Order.__default.lt#canCall(k#2, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
          Uint32_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, Tclass.NativeTypes.uint32())
               && Uint32__Order.__default.lt($Unbox($y#6): int, LitInt(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lt($Unbox($y#9): int, LitInt(pivot#0)))); 
          (forall k#3: int :: 
              { Uint32__Order.__default.lte(pivot#0, k#3) } 
              LitInt(0) <= k#3 && k#3 < 4294967296
                 ==> Uint32__Order.__default.lte#canCall(LitInt(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(Tclass.NativeTypes.uint32(), 
              Uint32_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, Tclass.NativeTypes.uint32())
                   && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#7): int)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#8): int))); 
              Maps.__default.MapDisjointUnion#canCall(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Uint32__Order.__default.MapPivotedUnion(Uint32_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, Tclass.NativeTypes.uint32())
                     && Uint32__Order.__default.lt($Unbox($y#10): int, LitInt(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, Tclass.NativeTypes.uint32())
                       && Uint32__Order.__default.lte(LitInt(pivot#0), $Unbox($y#11): int))); 
              Maps.__default.MapDisjointUnion(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Uint32_Order._default.SetSuccessor
function Uint32__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Uint32__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Uint32__Order.__default.SetSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.SetSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Uint32__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Uint32__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap)
       && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#33_next(m: Set Box, key: int) : int;

function $let#33$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#33_next(m, key) } 
  $let#33$canCall(m, key)
     ==> LitInt(0) <= $let#33_next(m, key)
       && $let#33_next(m, key) < 4294967296
       && 
      m[$Box($let#33_next(m, key))]
       && Uint32__Order.__default.lt(key, $let#33_next(m, key))
       && (forall other#1: int :: 
        { Uint32__Order.__default.lt($let#33_next(m, key), other#1) } 
          { Uint32__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        LitInt(0) <= other#1 && other#1 < 4294967296
           ==> 
          m[$Box(other#1)]
             && other#1 != $let#33_next(m, key)
             && Uint32__Order.__default.lt(key, other#1)
           ==> Uint32__Order.__default.lt($let#33_next(m, key), other#1)));

// definition axiom for Uint32__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Uint32__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> (forall next#0: int :: 
          { Uint32__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
          LitInt(0) <= next#0 && next#0 < 4294967296
             ==> (m#0[$Box(next#0)] ==> Uint32__Order.__default.lt#canCall(key#0, next#0))
               && (Uint32__Order.__default.lt#canCall(key#0, next#0)
                   && Uint32__Order.__default.lt(key#0, next#0)
                 ==> (forall other#0: int :: 
                  { Uint32__Order.__default.lt(next#0, other#0) } 
                    { Uint32__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 4294967296
                     ==> (other#0 != next#0 ==> Uint32__Order.__default.lt#canCall(key#0, other#0))
                       && (Uint32__Order.__default.lt#canCall(key#0, other#0)
                           && Uint32__Order.__default.lt(key#0, other#0)
                         ==> Uint32__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: int :: 
            { Uint32__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
            LitInt(0) <= next#0
               && next#0 < 4294967296
               && 
              m#0[$Box(next#0)]
               && Uint32__Order.__default.lt(key#0, next#0)
               && (forall other#0: int :: 
                { Uint32__Order.__default.lt(next#0, other#0) } 
                  { Uint32__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                LitInt(0) <= other#0 && other#0 < 4294967296
                   ==> 
                  m#0[$Box(other#0)]
                     && other#0 != next#0
                     && Uint32__Order.__default.lt(key#0, other#0)
                   ==> Uint32__Order.__default.lt(next#0, other#0)))
           ==> $let#33$canCall(m#0, key#0))
         && Uint32__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: int :: 
              { Uint32__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
              LitInt(0) <= next#0
                 && next#0 < 4294967296
                 && 
                m#0[$Box(next#0)]
                 && Uint32__Order.__default.lt(key#0, next#0)
                 && (forall other#0: int :: 
                  { Uint32__Order.__default.lt(next#0, other#0) } 
                    { Uint32__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  LitInt(0) <= other#0 && other#0 < 4294967296
                     ==> 
                    m#0[$Box(other#0)]
                       && other#0 != next#0
                       && Uint32__Order.__default.lt(key#0, other#0)
                     ==> Uint32__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#33_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Uint32__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(m#0, TSet(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> (forall next#2: int :: 
          { Uint32__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
          LitInt(0) <= next#2 && next#2 < 4294967296
             ==> (Lit(m#0)[$Box(next#2)]
                 ==> Uint32__Order.__default.lt#canCall(LitInt(key#0), next#2))
               && (Uint32__Order.__default.lt#canCall(LitInt(key#0), next#2)
                   && Uint32__Order.__default.lt(LitInt(key#0), next#2)
                 ==> (forall other#2: int :: 
                  { Uint32__Order.__default.lt(next#2, other#2) } 
                    { Uint32__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 4294967296
                     ==> (other#2 != next#2
                         ==> Uint32__Order.__default.lt#canCall(LitInt(key#0), other#2))
                       && (Uint32__Order.__default.lt#canCall(LitInt(key#0), other#2)
                           && Uint32__Order.__default.lt(LitInt(key#0), other#2)
                         ==> Uint32__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: int :: 
            { Uint32__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
            LitInt(0) <= next#2
               && next#2 < 4294967296
               && 
              Lit(m#0)[$Box(next#2)]
               && Uint32__Order.__default.lt(LitInt(key#0), next#2)
               && (forall other#2: int :: 
                { Uint32__Order.__default.lt(next#2, other#2) } 
                  { Uint32__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                LitInt(0) <= other#2 && other#2 < 4294967296
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && other#2 != next#2
                     && Uint32__Order.__default.lt(LitInt(key#0), other#2)
                   ==> Uint32__Order.__default.lt(next#2, other#2)))
           ==> $let#33$canCall(Lit(m#0), LitInt(key#0)))
         && Uint32__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#2: int :: 
              { Uint32__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
              LitInt(0) <= next#2
                 && next#2 < 4294967296
                 && 
                Lit(m#0)[$Box(next#2)]
                 && Uint32__Order.__default.lt(LitInt(key#0), next#2)
                 && (forall other#2: int :: 
                  { Uint32__Order.__default.lt(next#2, other#2) } 
                    { Uint32__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  LitInt(0) <= other#2 && other#2 < 4294967296
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && other#2 != next#2
                       && Uint32__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Uint32__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#33_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Uint32_Order._default.MapSuccessor
function Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.MapSuccessor
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Uint32__Order.__default.MapSuccessor
axiom (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Uint32__Order.__default.MapSuccessor#requires(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.MapSuccessor#requires(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Uint32__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, m#0, key#0)
           == Uint32__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Uint32__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Uint32__Order.__default.MapSuccessor#canCall(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.MapSuccessor$V))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Uint32__Order.__default.MapSuccessor(Uint32_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Uint32__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Uint32_Order._default.SeqSuccessor
function Uint32__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Uint32__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Uint32__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> $Is(Uint32__Order.__default.SeqSuccessor(m#0, key#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Uint32__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Uint32__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= key#0
       && key#0 < 4294967296
     ==> Uint32__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Uint32__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Uint32__Order.__default.SeqSuccessor(m#0, key#0) } 
    Uint32__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: 
            $IsBox($y#0, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#0)), 
          key#0)
         && Uint32__Order.__default.SeqSuccessor(m#0, key#0)
           == Uint32__Order.__default.SetSuccessor((lambda $y#1: Box :: 
              $IsBox($y#1, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#1)), 
            key#0));

// definition axiom for Uint32__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Uint32__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Uint32__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($Is(m#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= key#0
           && key#0 < 4294967296)
       ==> Uint32__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: 
            $IsBox($y#2, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#2)), 
          LitInt(key#0))
         && Uint32__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Uint32__Order.__default.SetSuccessor((lambda $y#3: Box :: 
              $IsBox($y#3, Tclass.NativeTypes.uint32()) && Seq#Contains(m#0, $y#3)), 
            LitInt(key#0)));

// function declaration for Uint32_Order._default.SortedSeqForMap
function Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Uint32__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> true);

function Uint32__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Uint32__Order.__default.SortedSeqForMap
axiom (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Uint32__Order.__default.SortedSeqForMap#requires(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, 
        TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V))
     ==> Uint32__Order.__default.SortedSeqForMap#requires(Uint32_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Uint32__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
            Uint32_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Uint32__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: int :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            LitInt(0) <= key#0 && key#0 < 4294967296
               ==> 
              Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                         == key#0
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                    Uint32_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: int :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              LitInt(0) <= key#0 && key#0 < 4294967296
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                       == key#0
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Uint32__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Uint32_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Uint32__Order.__default.SortedSeqForMap#canCall(Uint32_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, 
            TSeq(Tclass._System.Tuple2(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(Tclass.NativeTypes.uint32(), Uint32_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
            Uint32_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Uint32__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                Uint32_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                  Uint32_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: int :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            LitInt(0) <= key#1 && key#1 < 4294967296
               ==> 
              Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                         == key#1
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Uint32__Order.__default.SortedSeqForMap(Uint32_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Uint32__Order.__default.IsStrictlySorted(StartFuel_Uint32_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(Tclass.NativeTypes.uint32(), 
                    Uint32_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: int :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              LitInt(0) <= key#1 && key#1 < 4294967296
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                       == key#1
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Uint32_Order._default.minimum
function Uint32__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Uint32__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimum($LS($ly), s#0) } 
  Uint32__Order.__default.minimum($LS($ly), s#0)
     == Uint32__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.minimum($ly, s#0)
     == Uint32__Order.__default.minimum($LZ, s#0));

// consequence axiom for Uint32__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimum($ly, s#0) } 
    Uint32__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint32())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint32__Order.__default.minimum($ly, s#0))]
         && (forall y#0: int :: 
          { Uint32__Order.__default.lte(Uint32__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
             ==> Uint32__Order.__default.lte(Uint32__Order.__default.minimum($ly, s#0), y#0))
         && 
        LitInt(0) <= Uint32__Order.__default.minimum($ly, s#0)
         && Uint32__Order.__default.minimum($ly, s#0) < 4294967296);

function Uint32__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint32__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#36_a(s: Set Box) : int;

function $let#36$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#36_a(s) } 
  $let#36$canCall(s)
     ==> LitInt(0) <= $let#36_a(s) && $let#36_a(s) < 4294967296 && s[$Box($let#36_a(s))]);

// definition axiom for Uint32__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint32__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.minimum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#36$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#36_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Uint32__Order.__default.minimum($ly, s'#0); 
                Uint32__Order.__default.lt#canCall($let#36_a(s#0), m'#0)))
         && Uint32__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#36_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Uint32__Order.__default.minimum($ly, s'#1); 
                  (if Uint32__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Uint32__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.minimum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#36$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#36_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Uint32__Order.__default.minimum($LS($ly), s'#2); 
                Uint32__Order.__default.lt#canCall($let#36_a(Lit(s#0)), m'#2)))
         && Uint32__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#36_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Uint32__Order.__default.minimum($LS($ly), s'#3); 
                  (if Uint32__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Uint32_Order._default.minimumOpt
function Uint32__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint32__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt($LS($ly), s#0) } 
  Uint32__Order.__default.minimumOpt($LS($ly), s#0)
     == Uint32__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.minimumOpt($ly, s#0)
     == Uint32__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Uint32__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimumOpt($ly, s#0) } 
    Uint32__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (Options.Option.Some_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Uint32__Order.__default.lte($Unbox(Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
               ==> Uint32__Order.__default.lte($Unbox(Options.Option.value(Uint32__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0)))
         && (Options.Option.None_q(Uint32__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint32__Order.__default.minimumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Uint32__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.minimumOpt($LS($ly), s#0) } 
    Uint32__Order.__default.minimumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.minimum#canCall(s#0))
         && Uint32__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.minimum(StartFuel_Uint32_Order._default.minimum, s#0)))));

// definition axiom for Uint32__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Uint32__Order.__default.minimumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.minimum#canCall(Lit(s#0)))
         && Uint32__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.minimum(StartFuel_Uint32_Order._default.minimum, Lit(s#0))))));

// function declaration for Uint32_Order._default.maximum
function Uint32__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Uint32__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximum($LS($ly), s#0) } 
  Uint32__Order.__default.maximum($LS($ly), s#0)
     == Uint32__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.maximum($ly, s#0)
     == Uint32__Order.__default.maximum($LZ, s#0));

// consequence axiom for Uint32__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximum($ly, s#0) } 
    Uint32__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(Tclass.NativeTypes.uint32())) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Uint32__Order.__default.maximum($ly, s#0))]
         && (forall y#0: int :: 
          { Uint32__Order.__default.lte(y#0, Uint32__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
             ==> Uint32__Order.__default.lte(y#0, Uint32__Order.__default.maximum($ly, s#0)))
         && 
        LitInt(0) <= Uint32__Order.__default.maximum($ly, s#0)
         && Uint32__Order.__default.maximum($ly, s#0) < 4294967296);

function Uint32__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Uint32__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#39_a(s: Set Box) : int;

function $let#39$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#39_a(s) } 
  $let#39$canCall(s)
     ==> LitInt(0) <= $let#39_a(s) && $let#39_a(s) < 4294967296 && s[$Box($let#39_a(s))]);

// definition axiom for Uint32__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Uint32__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.maximum#canCall(s#0)
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(s#0) >= LitInt(1))
       ==> $let#39$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#39_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Uint32__Order.__default.maximum($ly, s'#0); 
                Uint32__Order.__default.lt#canCall(m'#0, $let#39_a(s#0))))
         && Uint32__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#39_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Uint32__Order.__default.maximum($ly, s'#1); 
                  (if Uint32__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Uint32__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Uint32__Order.__default.maximum#canCall(Lit(s#0))
         || (
          $IsGoodHeap($Heap)
           && $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
           && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#39$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#39_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Uint32__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Uint32__Order.__default.maximum($LS($ly), s'#2); 
                Uint32__Order.__default.lt#canCall(m'#2, $let#39_a(Lit(s#0)))))
         && Uint32__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#39_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Uint32__Order.__default.maximum($LS($ly), s'#3); 
                  (if Uint32__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Uint32_Order._default.maximumOpt
function Uint32__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Uint32__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt($LS($ly), s#0) } 
  Uint32__Order.__default.maximumOpt($LS($ly), s#0)
     == Uint32__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Uint32__Order.__default.maximumOpt($ly, s#0)
     == Uint32__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Uint32__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximumOpt($ly, s#0) } 
    Uint32__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (Options.Option.Some_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Uint32__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#0)] } 
            LitInt(0) <= y#0 && y#0 < 4294967296 && s#0[$Box(y#0)]
               ==> Uint32__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Uint32__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Uint32__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Uint32__Order.__default.maximumOpt($ly, s#0), 
          Tclass.Options.Option(Tclass.NativeTypes.uint32())));

function Uint32__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Uint32__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Uint32__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Uint32__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Uint32__Order.__default.maximumOpt($LS($ly), s#0) } 
    Uint32__Order.__default.maximumOpt#canCall(s#0)
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.maximum#canCall(s#0))
         && Uint32__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.maximum(StartFuel_Uint32_Order._default.maximum, s#0)))));

// definition axiom for Uint32__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Uint32__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Uint32__Order.__default.maximumOpt#canCall(Lit(s#0))
         || $Is(s#0, TSet(Tclass.NativeTypes.uint32()))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Uint32__Order.__default.maximum#canCall(Lit(s#0)))
         && Uint32__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Uint32__Order.__default.maximum(StartFuel_Uint32_Order._default.maximum, Lit(s#0))))));

// function declaration for Uint32_Order._default.lt
function Uint32__Order.__default.lt(a#0: int, b#0: int) : bool;

function Uint32__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lt(a#0, b#0) } 
    Uint32__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> true);

function Uint32__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.lt#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.lt(a#0, b#0) } 
    Uint32__Order.__default.lt#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.lt(a#0, b#0)
           == (Uint32__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Uint32__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.lt#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Uint32_Order._default.Min
function Uint32__Order.__default.Min(a#0: int, b#0: int) : int;

function Uint32__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Min(a#0, b#0) } 
    Uint32__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> LitInt(0) <= Uint32__Order.__default.Min(a#0, b#0)
         && Uint32__Order.__default.Min(a#0, b#0) < 4294967296);

function Uint32__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.Min#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Min(a#0, b#0) } 
    Uint32__Order.__default.Min#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.Min(a#0, b#0)
           == (if Uint32__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Uint32__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.Min#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Uint32_Order._default.Max
function Uint32__Order.__default.Max(a#0: int, b#0: int) : int;

function Uint32__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Uint32__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Max(a#0, b#0) } 
    Uint32__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> LitInt(0) <= Uint32__Order.__default.Max(a#0, b#0)
         && Uint32__Order.__default.Max(a#0, b#0) < 4294967296);

function Uint32__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Uint32__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Uint32__Order.__default.Max#requires(a#0, b#0) } 
  LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296
     ==> Uint32__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Uint32__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Uint32__Order.__default.Max(a#0, b#0) } 
    Uint32__Order.__default.Max#canCall(a#0, b#0)
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(a#0, b#0)
         && Uint32__Order.__default.Max(a#0, b#0)
           == (if Uint32__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Uint32__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Uint32__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    Uint32__Order.__default.Max#canCall(LitInt(a#0), LitInt(b#0))
         || (LitInt(0) <= a#0 && a#0 < 4294967296 && LitInt(0) <= b#0 && b#0 < 4294967296)
       ==> Uint32__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Uint32__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Uint32__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Uint32_Order._default.IsSorted
function Uint32__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint32__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted($LS($ly), run#0) } 
  Uint32__Order.__default.IsSorted($LS($ly), run#0)
     == Uint32__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Uint32__Order.__default.IsSorted($ly, run#0)
     == Uint32__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Uint32__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsSorted($ly, run#0) } 
    Uint32__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint32__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint32__Order.__default.IsSorted($ly, run#0)));

function Uint32__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Uint32__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsSorted($LS($ly), run#0) } 
    Uint32__Order.__default.IsSorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Uint32__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Uint32__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Uint32__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Uint32__Order.__default.IsSorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Uint32__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Uint32__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Uint32__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Uint32_Order._default.IsStrictlySortedInternal
function Uint32__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Uint32__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> true);

function Uint32__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Uint32__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySortedInternal(run#0) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Uint32__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Uint32__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Uint32__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Uint32__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Uint32__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Uint32__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Uint32_Order._default.IsStrictlySorted
function Uint32__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Uint32__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Uint32__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Uint32__Order.__default.IsStrictlySorted($ly, run#0)
     == Uint32__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Uint32__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySorted($ly, run#0) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Uint32__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Uint32__Order.__default.IsStrictlySorted($ly, run#0))
         && (Uint32__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, run#0)));

function Uint32__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Uint32__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Uint32__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
     ==> Uint32__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Uint32__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> Uint32__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Uint32__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Uint32__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Uint32__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Uint32__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Uint32__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(Tclass.NativeTypes.uint32()))
       ==> Uint32__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Uint32__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Uint32__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

// Constructor function declaration
function #PackedStringArray.Psa.Psa(Seq Box, Seq Box) : DatatypeType;

const unique ##PackedStringArray.Psa.Psa: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: Seq Box, a#0#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#PackedStringArray.Psa.Psa(a#0#0#0, a#0#1#0))
     == ##PackedStringArray.Psa.Psa);

function PackedStringArray.Psa.Psa_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d) } 
  PackedStringArray.Psa.Psa_q(d)
     <==> DatatypeCtorId(d) == ##PackedStringArray.Psa.Psa);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d) } 
  PackedStringArray.Psa.Psa_q(d)
     ==> (exists a#1#0#0: Seq Box, a#1#1#0: Seq Box :: 
      d == #PackedStringArray.Psa.Psa(a#1#0#0, a#1#1#0)));

function Tclass.PackedStringArray.Psa() : Ty;

// Tclass.PackedStringArray.Psa Tag
axiom Tag(Tclass.PackedStringArray.Psa()) == Tagclass.PackedStringArray.Psa;

const unique Tagclass.PackedStringArray.Psa: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.Psa
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.Psa()) } 
  $IsBox(bx, Tclass.PackedStringArray.Psa())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PackedStringArray.Psa()));

// Constructor $Is
axiom (forall a#2#0#0: Seq Box, a#2#1#0: Seq Box :: 
  { $Is(#PackedStringArray.Psa.Psa(a#2#0#0, a#2#1#0), Tclass.PackedStringArray.Psa()) } 
  $Is(#PackedStringArray.Psa.Psa(a#2#0#0, a#2#1#0), Tclass.PackedStringArray.Psa())
     <==> $Is(a#2#0#0, TSeq(Tclass.NativeTypes.uint32()))
       && $Is(a#2#1#0, TSeq(Tclass.NativeTypes.byte())));

// Constructor $IsAlloc
axiom (forall a#3#0#0: Seq Box, a#3#1#0: Seq Box, $h: Heap :: 
  { $IsAlloc(#PackedStringArray.Psa.Psa(a#3#0#0, a#3#1#0), Tclass.PackedStringArray.Psa(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PackedStringArray.Psa.Psa(a#3#0#0, a#3#1#0), Tclass.PackedStringArray.Psa(), $h)
       <==> $IsAlloc(a#3#0#0, TSeq(Tclass.NativeTypes.uint32()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.NativeTypes.byte()), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedStringArray.Psa.offsets(d), TSeq(Tclass.NativeTypes.uint32()), $h) } 
  $IsGoodHeap($h)
       && 
      PackedStringArray.Psa.Psa_q(d)
       && $IsAlloc(d, Tclass.PackedStringArray.Psa(), $h)
     ==> $IsAlloc(PackedStringArray.Psa.offsets(d), TSeq(Tclass.NativeTypes.uint32()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedStringArray.Psa.data(d), TSeq(Tclass.NativeTypes.byte()), $h) } 
  $IsGoodHeap($h)
       && 
      PackedStringArray.Psa.Psa_q(d)
       && $IsAlloc(d, Tclass.PackedStringArray.Psa(), $h)
     ==> $IsAlloc(PackedStringArray.Psa.data(d), TSeq(Tclass.NativeTypes.byte()), $h));

// Constructor literal
axiom (forall a#4#0#0: Seq Box, a#4#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #PackedStringArray.Psa.Psa(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#PackedStringArray.Psa.Psa(a#4#0#0, a#4#1#0)));

function PackedStringArray.Psa.offsets(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#5#0#0: Seq Box, a#5#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#5#0#0, a#5#1#0) } 
  PackedStringArray.Psa.offsets(#PackedStringArray.Psa.Psa(a#5#0#0, a#5#1#0))
     == a#5#0#0);

// Inductive seq element rank
axiom (forall a#6#0#0: Seq Box, a#6#1#0: Seq Box, i: int :: 
  { Seq#Index(a#6#0#0, i), #PackedStringArray.Psa.Psa(a#6#0#0, a#6#1#0) } 
  0 <= i && i < Seq#Length(a#6#0#0)
     ==> DtRank($Unbox(Seq#Index(a#6#0#0, i)): DatatypeType)
       < DtRank(#PackedStringArray.Psa.Psa(a#6#0#0, a#6#1#0)));

// Inductive seq rank
axiom (forall a#7#0#0: Seq Box, a#7#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#7#0#0, a#7#1#0) } 
  Seq#Rank(a#7#0#0) < DtRank(#PackedStringArray.Psa.Psa(a#7#0#0, a#7#1#0)));

function PackedStringArray.Psa.data(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#8#0#0: Seq Box, a#8#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#8#0#0, a#8#1#0) } 
  PackedStringArray.Psa.data(#PackedStringArray.Psa.Psa(a#8#0#0, a#8#1#0))
     == a#8#1#0);

// Inductive seq element rank
axiom (forall a#9#0#0: Seq Box, a#9#1#0: Seq Box, i: int :: 
  { Seq#Index(a#9#1#0, i), #PackedStringArray.Psa.Psa(a#9#0#0, a#9#1#0) } 
  0 <= i && i < Seq#Length(a#9#1#0)
     ==> DtRank($Unbox(Seq#Index(a#9#1#0, i)): DatatypeType)
       < DtRank(#PackedStringArray.Psa.Psa(a#9#0#0, a#9#1#0)));

// Inductive seq rank
axiom (forall a#10#0#0: Seq Box, a#10#1#0: Seq Box :: 
  { #PackedStringArray.Psa.Psa(a#10#0#0, a#10#1#0) } 
  Seq#Rank(a#10#1#0) < DtRank(#PackedStringArray.Psa.Psa(a#10#0#0, a#10#1#0)));

// Depth-one case-split function
function $IsA#PackedStringArray.Psa(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PackedStringArray.Psa(d) } 
  $IsA#PackedStringArray.Psa(d) ==> PackedStringArray.Psa.Psa_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PackedStringArray.Psa.Psa_q(d), $Is(d, Tclass.PackedStringArray.Psa()) } 
  $Is(d, Tclass.PackedStringArray.Psa()) ==> PackedStringArray.Psa.Psa_q(d));

// Datatype extensional equality declaration
function PackedStringArray.Psa#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PackedStringArray.Psa.Psa
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedStringArray.Psa#Equal(a, b) } 
  true
     ==> (PackedStringArray.Psa#Equal(a, b)
       <==> Seq#Equal(PackedStringArray.Psa.offsets(a), PackedStringArray.Psa.offsets(b))
         && Seq#Equal(PackedStringArray.Psa.data(a), PackedStringArray.Psa.data(b))));

// Datatype extensionality axiom: PackedStringArray.Psa
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedStringArray.Psa#Equal(a, b) } 
  PackedStringArray.Psa#Equal(a, b) <==> a == b);

const unique class.PackedStringArray.Psa: ClassName;

const unique class.PackedStringArray.DynamicPsa?: ClassName;

function Tclass.PackedStringArray.DynamicPsa?() : Ty;

// Tclass.PackedStringArray.DynamicPsa? Tag
axiom Tag(Tclass.PackedStringArray.DynamicPsa?())
   == Tagclass.PackedStringArray.DynamicPsa?;

const unique Tagclass.PackedStringArray.DynamicPsa?: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.DynamicPsa?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.DynamicPsa?()) } 
  $IsBox(bx, Tclass.PackedStringArray.DynamicPsa?())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.DynamicPsa?()));

// DynamicPsa: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArray.DynamicPsa?()) } 
  $Is($o, Tclass.PackedStringArray.DynamicPsa?())
     <==> $o == null || dtype($o) == Tclass.PackedStringArray.DynamicPsa?());

// DynamicPsa: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArray.DynamicPsa?(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArray.DynamicPsa?(), $h)
     <==> $o == null || read($h, $o, alloc));

axiom FDim(PackedStringArray.DynamicPsa.nstrings) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$nstrings)
     == PackedStringArray.DynamicPsa.nstrings
   && !$IsGhostField(PackedStringArray.DynamicPsa.nstrings);

const PackedStringArray.DynamicPsa.nstrings: Field int;

// DynamicPsa.nstrings: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.nstrings) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.nstrings), Tclass.NativeTypes.uint64()));

// DynamicPsa.nstrings: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.nstrings) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.nstrings), 
      Tclass.NativeTypes.uint64(), 
      $h));

axiom FDim(PackedStringArray.DynamicPsa.offsets) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$offsets)
     == PackedStringArray.DynamicPsa.offsets
   && !$IsGhostField(PackedStringArray.DynamicPsa.offsets);

const PackedStringArray.DynamicPsa.offsets: Field ref;

// DynamicPsa.offsets: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.offsets) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.offsets), 
      Tclass._System.array(Tclass.NativeTypes.uint32())));

// DynamicPsa.offsets: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.offsets) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.offsets), 
      Tclass._System.array(Tclass.NativeTypes.uint32()), 
      $h));

axiom FDim(PackedStringArray.DynamicPsa.data) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$data)
     == PackedStringArray.DynamicPsa.data
   && !$IsGhostField(PackedStringArray.DynamicPsa.data);

const PackedStringArray.DynamicPsa.data: Field ref;

// DynamicPsa.data: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.data) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.data), 
      Tclass._System.array(Tclass.NativeTypes.byte())));

// DynamicPsa.data: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.data) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.data), 
      Tclass._System.array(Tclass.NativeTypes.byte()), 
      $h));

axiom FDim(PackedStringArray.DynamicPsa.Repr) == 0
   && FieldOfDecl(class.PackedStringArray.DynamicPsa?, field$Repr)
     == PackedStringArray.DynamicPsa.Repr
   && $IsGhostField(PackedStringArray.DynamicPsa.Repr);

const PackedStringArray.DynamicPsa.Repr: Field (Set Box);

// DynamicPsa.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
     ==> $Is(read($h, $o, PackedStringArray.DynamicPsa.Repr), TSet(Tclass._System.object())));

// DynamicPsa.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, PackedStringArray.DynamicPsa.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.PackedStringArray.DynamicPsa?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, PackedStringArray.DynamicPsa.Repr), 
      TSet(Tclass._System.object()), 
      $h));

// function declaration for PackedStringArray.DynamicPsa.WF
function PackedStringArray.DynamicPsa.WF($heap: Heap, this: ref) : bool;

function PackedStringArray.DynamicPsa.WF#canCall($heap: Heap, this: ref) : bool;

function Tclass.PackedStringArray.DynamicPsa() : Ty;

// Tclass.PackedStringArray.DynamicPsa Tag
axiom Tag(Tclass.PackedStringArray.DynamicPsa())
   == Tagclass.PackedStringArray.DynamicPsa;

const unique Tagclass.PackedStringArray.DynamicPsa: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.DynamicPsa
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.DynamicPsa()) } 
  $IsBox(bx, Tclass.PackedStringArray.DynamicPsa())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.DynamicPsa()));

// frame axiom for PackedStringArray.DynamicPsa.WF
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.WF($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.WF($h0, this)
       == PackedStringArray.DynamicPsa.WF($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.WF
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.WF($Heap, this) } 
    PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
       ==> true);

function PackedStringArray.DynamicPsa.WF#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.WF
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.WF#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.WF#requires($Heap, this) == true);

// definition axiom for PackedStringArray.DynamicPsa.WF(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.WF($Heap, this) } 
    PackedStringArray.DynamicPsa.WF#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap))
       ==> (Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
            Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
              $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
           ==> NativeTypes.__default.Uint64UpperBound#canCall())
         && (
          (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
             <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
           ==> Uint32__Order.__default.IsSorted#canCall(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
              read($Heap, this, PackedStringArray.DynamicPsa.nstrings))))
         && PackedStringArray.DynamicPsa.WF($Heap, this)
           == (
            Set#Equal(read($Heap, this, PackedStringArray.DynamicPsa.Repr), 
              Set#UnionOne(Set#UnionOne(Set#UnionOne(Set#Empty(): Set Box, $Box(this)), 
                  $Box(read($Heap, this, PackedStringArray.DynamicPsa.offsets))), 
                $Box(read($Heap, this, PackedStringArray.DynamicPsa.data))))
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
               < NativeTypes.__default.Uint64UpperBound()
             && _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))
               < 4294967296
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings) < 4294967296
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 < 4294967296)
             && (0 < read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               ==> $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int
                 <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data)))
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)))));

// function declaration for PackedStringArray.DynamicPsa.toPsa
function PackedStringArray.DynamicPsa.toPsa($heap: Heap, this: ref) : DatatypeType;

function PackedStringArray.DynamicPsa.toPsa#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.toPsa
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.toPsa($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.toPsa($h0, this)
       == PackedStringArray.DynamicPsa.toPsa($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.toPsa
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.toPsa($Heap, this) } 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> $Is(PackedStringArray.DynamicPsa.toPsa($Heap, this), Tclass.PackedStringArray.Psa()));

function PackedStringArray.DynamicPsa.toPsa#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.toPsa
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.toPsa#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.toPsa#requires($Heap, this)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.toPsa(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.toPsa($Heap, this) } 
    PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> (LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
           ==> PackedStringArray.__default.EmptyPsa#canCall())
         && PackedStringArray.DynamicPsa.toPsa($Heap, this)
           == (if LitInt(0) == read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             then PackedStringArray.__default.EmptyPsa()
             else #PackedStringArray.Psa.Psa(Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.offsets)), 
                read($Heap, this, PackedStringArray.DynamicPsa.nstrings)), 
              Seq#Take(Seq#FromArray($Heap, read($Heap, this, PackedStringArray.DynamicPsa.data)), 
                $Unbox(read($Heap, 
                    read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                    IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int))));

// function declaration for PackedStringArray.DynamicPsa.weight
function PackedStringArray.DynamicPsa.weight($heap: Heap, this: ref) : int;

function PackedStringArray.DynamicPsa.weight#canCall($heap: Heap, this: ref) : bool;

// frame axiom for PackedStringArray.DynamicPsa.weight
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.weight($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.weight($h0, this)
       == PackedStringArray.DynamicPsa.weight($h1, this));

// consequence axiom for PackedStringArray.DynamicPsa.weight
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.weight($Heap, this) } 
    PackedStringArray.DynamicPsa.weight#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> LitInt(0) <= PackedStringArray.DynamicPsa.weight($Heap, this)
         && PackedStringArray.DynamicPsa.weight($Heap, this) < 18446744073709551616);

function PackedStringArray.DynamicPsa.weight#requires(Heap, ref) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.weight
axiom (forall $Heap: Heap, this: ref :: 
  { PackedStringArray.DynamicPsa.weight#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
     ==> PackedStringArray.DynamicPsa.weight#requires($Heap, this)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.weight(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { PackedStringArray.DynamicPsa.weight($Heap, this) } 
    PackedStringArray.DynamicPsa.weight#canCall($Heap, this)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.weight($Heap, this)
         == Mul(LitInt(4), read($Heap, this, PackedStringArray.DynamicPsa.nstrings))
           + (if read($Heap, this, PackedStringArray.DynamicPsa.nstrings) == LitInt(0)
             then 0
             else $Unbox(read($Heap, 
                read($Heap, this, PackedStringArray.DynamicPsa.offsets), 
                IndexField(read($Heap, this, PackedStringArray.DynamicPsa.nstrings) - 1))): int));

// function declaration for PackedStringArray.DynamicPsa.canAppend
function PackedStringArray.DynamicPsa.canAppend($heap: Heap, this: ref, str#0: Seq Box) : bool;

function PackedStringArray.DynamicPsa.canAppend#canCall($heap: Heap, this: ref, str#0: Seq Box) : bool;

// frame axiom for PackedStringArray.DynamicPsa.canAppend
axiom (forall $h0: Heap, $h1: Heap, this: ref, str#0: Seq Box :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), PackedStringArray.DynamicPsa.canAppend($h1, this, str#0) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && (PackedStringArray.DynamicPsa.canAppend#canCall($h0, this, str#0)
         || $Is(str#0, TSeq(Tclass.NativeTypes.byte())))
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, PackedStringArray.DynamicPsa.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> PackedStringArray.DynamicPsa.canAppend($h0, this, str#0)
       == PackedStringArray.DynamicPsa.canAppend($h1, this, str#0));

// consequence axiom for PackedStringArray.DynamicPsa.canAppend
axiom true
   ==> (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
    { PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0) } 
    PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> true);

function PackedStringArray.DynamicPsa.canAppend#requires(Heap, ref, Seq Box) : bool;

// #requires axiom for PackedStringArray.DynamicPsa.canAppend
axiom (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
  { PackedStringArray.DynamicPsa.canAppend#requires($Heap, this, str#0) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.PackedStringArray.DynamicPsa())
       && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
       && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.DynamicPsa.canAppend#requires($Heap, this, str#0)
       == PackedStringArray.DynamicPsa.WF($Heap, this));

// definition axiom for PackedStringArray.DynamicPsa.canAppend(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref, str#0: Seq Box :: 
    { PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0) } 
    PackedStringArray.DynamicPsa.canAppend#canCall($Heap, this, str#0)
         || (
          $IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.PackedStringArray.DynamicPsa())
           && $IsAlloc(this, Tclass.PackedStringArray.DynamicPsa(), $Heap)
           && $Is(str#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedStringArray.DynamicPsa.WF($Heap, this))
       ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
         && PackedStringArray.__default.psaCanAppend#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
         && (read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
             < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
           ==> PackedStringArray.DynamicPsa.toPsa#canCall($Heap, this)
             && PackedStringArray.__default.psaTotalLength#canCall(PackedStringArray.DynamicPsa.toPsa($Heap, this)))
         && PackedStringArray.DynamicPsa.canAppend($Heap, this, str#0)
           == (
            PackedStringArray.__default.psaCanAppend(PackedStringArray.DynamicPsa.toPsa($Heap, this), str#0)
             && read($Heap, this, PackedStringArray.DynamicPsa.nstrings)
               < _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.offsets))
             && PackedStringArray.__default.psaTotalLength(PackedStringArray.DynamicPsa.toPsa($Heap, this))
                 + Seq#Length(str#0)
               <= _System.array.Length(read($Heap, this, PackedStringArray.DynamicPsa.data))));

// PackedStringArray.DynamicPsa: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.PackedStringArray.DynamicPsa()) } 
  $Is(c#0, Tclass.PackedStringArray.DynamicPsa())
     <==> $Is(c#0, Tclass.PackedStringArray.DynamicPsa?()) && c#0 != null);

// PackedStringArray.DynamicPsa: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa(), $h) } 
  $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa(), $h)
     <==> $IsAlloc(c#0, Tclass.PackedStringArray.DynamicPsa?(), $h));

const unique class.PackedStringArray.__default: ClassName;

function Tclass.PackedStringArray.__default() : Ty;

// Tclass.PackedStringArray.__default Tag
axiom Tag(Tclass.PackedStringArray.__default())
   == Tagclass.PackedStringArray.__default;

const unique Tagclass.PackedStringArray.__default: TyTag;

// Box/unbox axiom for Tclass.PackedStringArray.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArray.__default()) } 
  $IsBox(bx, Tclass.PackedStringArray.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArray.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArray.__default()) } 
  $Is($o, Tclass.PackedStringArray.__default())
     <==> $o == null || dtype($o) == Tclass.PackedStringArray.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArray.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArray.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedStringArray._default.WF
function PackedStringArray.__default.WF(psa#0: DatatypeType) : bool;

function PackedStringArray.__default.WF#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.WF
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.WF(psa#0) } 
    PackedStringArray.__default.WF#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> true);

function PackedStringArray.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.WF
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.WF#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.WF#requires(psa#0) == true);

// definition axiom for PackedStringArray.__default.WF(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.WF(psa#0) } 
    PackedStringArray.__default.WF#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(psa#0)))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(psa#0))
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> PackedStringArray.Psa.Psa_q(psa#0)
                 && 
                PackedStringArray.Psa.Psa_q(psa#0)
                 && PackedStringArray.Psa.Psa_q(psa#0)))
         && (PackedStringArray.Psa.Psa_q(psa#0)
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> PackedStringArray.Psa.Psa_q(psa#0)
                 && 
                PackedStringArray.Psa.Psa_q(psa#0)
                 && PackedStringArray.Psa.Psa_q(psa#0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && Uint32__Order.__default.IsSorted#canCall(PackedStringArray.Psa.offsets(psa#0)))
         && PackedStringArray.__default.WF(psa#0)
           == (
            Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) < 4294967296
             && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) == LitInt(0)
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0)) == LitInt(0))
             && (0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))
               ==> Seq#Length(PackedStringArray.Psa.data(psa#0))
                 == $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), 
                    Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.WF for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.WF(Lit(psa#0)) } 
    PackedStringArray.__default.WF#canCall(Lit(psa#0))
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) == LitInt(0))
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && 
                PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && PackedStringArray.Psa.Psa_q(Lit(psa#0))))
         && (PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && 
                PackedStringArray.Psa.Psa_q(Lit(psa#0))
                 && PackedStringArray.Psa.Psa_q(Lit(psa#0)))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 == $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), 
                    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)): int)
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && Uint32__Order.__default.IsSorted#canCall(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedStringArray.__default.WF(Lit(psa#0))
           == (
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) < 4294967296
             && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) == LitInt(0)
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) == LitInt(0))
             && (0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               ==> Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 == $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), 
                    Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)): int)
             && Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, 
              Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

// function declaration for PackedStringArray._default.psaNumStrings
function PackedStringArray.__default.psaNumStrings(psa#0: DatatypeType) : int;

function PackedStringArray.__default.psaNumStrings#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaNumStrings
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaNumStrings(psa#0) } 
    PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> LitInt(0) <= PackedStringArray.__default.psaNumStrings(psa#0)
         && PackedStringArray.__default.psaNumStrings(psa#0) < 18446744073709551616);

function PackedStringArray.__default.psaNumStrings#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaNumStrings
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaNumStrings#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaNumStrings#requires(psa#0)
       == (Seq#Length(PackedStringArray.Psa.offsets(psa#0))
         < NativeTypes.__default.Uint64UpperBound()));

// definition axiom for PackedStringArray.__default.psaNumStrings(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaNumStrings(psa#0) } 
    PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaNumStrings(psa#0)
           == Seq#Length(PackedStringArray.Psa.offsets(psa#0)));

// definition axiom for PackedStringArray.__default.psaNumStrings for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaNumStrings(Lit(psa#0)) } 
    PackedStringArray.__default.psaNumStrings#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaNumStrings(Lit(psa#0))
           == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))));

// function declaration for PackedStringArray._default.psaTotalLength
function PackedStringArray.__default.psaTotalLength(psa#0: DatatypeType) : int;

function PackedStringArray.__default.psaTotalLength#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaTotalLength
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaTotalLength(psa#0) } 
    PackedStringArray.__default.psaTotalLength#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.data(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> LitInt(0) <= PackedStringArray.__default.psaTotalLength(psa#0)
         && PackedStringArray.__default.psaTotalLength(psa#0) < 18446744073709551616);

function PackedStringArray.__default.psaTotalLength#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaTotalLength
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaTotalLength#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaTotalLength#requires(psa#0)
       == (Seq#Length(PackedStringArray.Psa.data(psa#0))
         < NativeTypes.__default.Uint64UpperBound()));

// definition axiom for PackedStringArray.__default.psaTotalLength(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaTotalLength(psa#0) } 
    PackedStringArray.__default.psaTotalLength#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(PackedStringArray.Psa.data(psa#0))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaTotalLength(psa#0)
           == Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.psaTotalLength for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaTotalLength(Lit(psa#0)) } 
    PackedStringArray.__default.psaTotalLength#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
             < NativeTypes.__default.Uint64UpperBound())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaTotalLength(Lit(psa#0))
           == Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

// function declaration for PackedStringArray._default.psaStart
function PackedStringArray.__default.psaStart(psa#0: DatatypeType, i#0: int) : int;

function PackedStringArray.__default.psaStart#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaStart
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaStart(psa#0, i#0) } 
    PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
         && PackedStringArray.__default.psaStart(psa#0, i#0)
           <= Seq#Length(PackedStringArray.Psa.data(psa#0))
         && 
        LitInt(0) <= PackedStringArray.__default.psaStart(psa#0, i#0)
         && PackedStringArray.__default.psaStart(psa#0, i#0) < 4294967296);

function PackedStringArray.__default.psaStart#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaStart
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaStart#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaStart#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaStart(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaStart(psa#0, i#0) } 
    PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0) ==> PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaStart(psa#0, i#0)
           == (if i#0 == LitInt(0)
             then 0
             else $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0 - 1)): int));

// definition axiom for PackedStringArray.__default.psaStart for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(i#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0) ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then 0
             else $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(i#0 - 1))): int));

// function declaration for PackedStringArray._default.psaEnd
function PackedStringArray.__default.psaEnd(psa#0: DatatypeType, i#0: int) : int;

function PackedStringArray.__default.psaEnd#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaEnd
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaEnd(psa#0, i#0) } 
    PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.__default.psaStart(psa#0, i#0)
           <= PackedStringArray.__default.psaEnd(psa#0, i#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0)
           <= Seq#Length(PackedStringArray.Psa.data(psa#0))
         && 
        LitInt(0) <= PackedStringArray.__default.psaEnd(psa#0, i#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0) < 4294967296);

function PackedStringArray.__default.psaEnd#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaEnd
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaEnd#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaEnd#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaEnd(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaEnd(psa#0, i#0) } 
    PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaEnd(psa#0, i#0)
           == (var _v0#0 := (if i#0 > 0 then false else false); 
            $Unbox(Seq#Index(PackedStringArray.Psa.offsets(psa#0), i#0)): int));

// definition axiom for PackedStringArray.__default.psaEnd for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(i#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0))
           == (var _v0#1 := (if i#0 > 0 then false else false); 
            $Unbox(Seq#Index(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(i#0))): int));

// function declaration for PackedStringArray._default.psaElement
function PackedStringArray.__default.psaElement(psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedStringArray.__default.psaElement#canCall(psa#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaElement
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaElement(psa#0, i#0) } 
    PackedStringArray.__default.psaElement#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> $Is(PackedStringArray.__default.psaElement(psa#0, i#0), 
        TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.psaElement#requires(DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaElement
axiom (forall psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaElement#requires(psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaElement#requires(psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaElement(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaElement(psa#0, i#0) } 
    PackedStringArray.__default.psaElement#canCall(psa#0, i#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaStart#canCall(psa#0, i#0)
         && PackedStringArray.__default.psaEnd#canCall(psa#0, i#0)
         && PackedStringArray.__default.psaElement(psa#0, i#0)
           == Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), 
              PackedStringArray.__default.psaEnd(psa#0, i#0)), 
            PackedStringArray.__default.psaStart(psa#0, i#0)));

// definition axiom for PackedStringArray.__default.psaElement for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0 < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(i#0))
         && PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(i#0))
         && PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0))
           == Lit(Seq#Drop(Seq#Take(Lit(PackedStringArray.Psa.data(Lit(psa#0))), 
                LitInt(PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(i#0)))), 
              LitInt(PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(i#0))))));

// function declaration for PackedStringArray._default.psaSeq
function PackedStringArray.__default.psaSeq($ly: LayerType, psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedStringArray.__default.psaSeq#canCall(psa#0: DatatypeType, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0) } 
  PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0)
     == PackedStringArray.__default.psaSeq($ly, psa#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq(AsFuelBottom($ly), psa#0, i#0) } 
  PackedStringArray.__default.psaSeq($ly, psa#0, i#0)
     == PackedStringArray.__default.psaSeq($LZ, psa#0, i#0));

// consequence axiom for PackedStringArray.__default.psaSeq
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaSeq($ly, psa#0, i#0) } 
    PackedStringArray.__default.psaSeq#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> Seq#Length(PackedStringArray.__default.psaSeq($ly, psa#0, i#0)) == i#0
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), j#0)): Seq Box } 
          LitInt(0) <= j#0 && j#0 < i#0
             ==> Seq#Equal($Unbox(Seq#Index(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), j#0)): Seq Box, 
              PackedStringArray.__default.psaElement(psa#0, j#0)))
         && $Is(PackedStringArray.__default.psaSeq($ly, psa#0, i#0), 
          TSeq(TSeq(Tclass.NativeTypes.byte()))));

function PackedStringArray.__default.psaSeq#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSeq
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedStringArray.__default.psaSeq#requires($ly, psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaSeq#requires($ly, psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.psaSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0) } 
    PackedStringArray.__default.psaSeq#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0)
           ==> PackedStringArray.__default.psaSeq#canCall(psa#0, i#0 - 1)
             && PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1))
         && PackedStringArray.__default.psaSeq($LS($ly), psa#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.psaSeq($ly, psa#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(PackedStringArray.__default.psaElement(psa#0, i#0 - 1))))));

// definition axiom for PackedStringArray.__default.psaSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0)) } 
    PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), LitInt(i#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0)
           ==> PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0 - 1)))
         && PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.psaSeq($LS($ly), Lit(psa#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1))))))));

// function declaration for PackedStringArray._default.I
function PackedStringArray.__default.I(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.I#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.I
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.I(psa#0) } 
    PackedStringArray.__default.I#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> $Is(PackedStringArray.__default.I(psa#0), TSeq(TSeq(Tclass.NativeTypes.byte()))));

function PackedStringArray.__default.I#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.I
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.I#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.I#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.I(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.I(psa#0) } 
    PackedStringArray.__default.I#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaSeq#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
         && PackedStringArray.__default.I(psa#0)
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            psa#0, 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedStringArray.__default.I for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.I(Lit(psa#0)) } 
    PackedStringArray.__default.I#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaSeq#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedStringArray.__default.I(Lit(psa#0))
           == PackedStringArray.__default.psaSeq(StartFuel_PackedStringArray._default.psaSeq, 
            Lit(psa#0), 
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

// function declaration for PackedStringArray._default.EmptyPsa
function PackedStringArray.__default.EmptyPsa() : DatatypeType;

function PackedStringArray.__default.EmptyPsa#canCall() : bool;

// consequence axiom for PackedStringArray.__default.EmptyPsa
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.WF(PackedStringArray.__default.EmptyPsa())
     && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.EmptyPsa()), 
      Seq#Empty(): Seq Box)
     && $Is(PackedStringArray.__default.EmptyPsa(), Tclass.PackedStringArray.Psa());

function PackedStringArray.__default.EmptyPsa#requires() : bool;

// #requires axiom for PackedStringArray.__default.EmptyPsa
axiom PackedStringArray.__default.EmptyPsa#requires() == true;

// definition axiom for PackedStringArray.__default.EmptyPsa(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa()
     == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));

// definition axiom for PackedStringArray.__default.EmptyPsa for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa()
     == Lit(#PackedStringArray.Psa.Psa(Lit(Seq#Empty(): Seq Box), Lit(Seq#Empty(): Seq Box)));

// function declaration for PackedStringArray._default.SizeOfPsa
function PackedStringArray.__default.SizeOfPsa(psa#0: DatatypeType) : int;

function PackedStringArray.__default.SizeOfPsa#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.SizeOfPsa
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsa(psa#0) } 
    PackedStringArray.__default.SizeOfPsa#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> true);

function PackedStringArray.__default.SizeOfPsa#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.SizeOfPsa
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.SizeOfPsa#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.SizeOfPsa#requires(psa#0) == true);

// definition axiom for PackedStringArray.__default.SizeOfPsa(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsa(psa#0) } 
    PackedStringArray.__default.SizeOfPsa#canCall(psa#0)
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.SizeOfPsa(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.SizeOfPsa for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.SizeOfPsa(Lit(psa#0)) } 
    PackedStringArray.__default.SizeOfPsa#canCall(Lit(psa#0))
         || $Is(psa#0, Tclass.PackedStringArray.Psa())
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.SizeOfPsa(Lit(psa#0))
           == 4
             + Mul(LitInt(4), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

// function declaration for PackedStringArray._default.SizeOfPsaUint64
function PackedStringArray.__default.SizeOfPsaUint64(psa#0: DatatypeType) : int;

function PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.SizeOfPsaUint64
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsaUint64(psa#0) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> LitInt(0) <= PackedStringArray.__default.SizeOfPsaUint64(psa#0)
         && PackedStringArray.__default.SizeOfPsaUint64(psa#0) < 18446744073709551616);

function PackedStringArray.__default.SizeOfPsaUint64#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.SizeOfPsaUint64
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.SizeOfPsaUint64#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.SizeOfPsaUint64#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.SizeOfPsaUint64(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.SizeOfPsaUint64(psa#0) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.SizeOfPsaUint64(psa#0)
           == 4
             + Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
             + Seq#Length(PackedStringArray.Psa.data(psa#0)));

// definition axiom for PackedStringArray.__default.SizeOfPsaUint64 for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.SizeOfPsaUint64(Lit(psa#0)) } 
    PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.SizeOfPsaUint64(Lit(psa#0))
           == 4
             + Mul(LitInt(4), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))));

// function declaration for PackedStringArray._default.FirstElement
function PackedStringArray.__default.FirstElement(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.FirstElement#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.FirstElement
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.FirstElement(psa#0) } 
    PackedStringArray.__default.FirstElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> $Is(PackedStringArray.__default.FirstElement(psa#0), TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.FirstElement#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.FirstElement
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.FirstElement#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.FirstElement#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0));

// definition axiom for PackedStringArray.__default.FirstElement(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.FirstElement(psa#0) } 
    PackedStringArray.__default.FirstElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> PackedStringArray.__default.psaElement#canCall(psa#0, LitInt(0))
         && PackedStringArray.__default.FirstElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, LitInt(0)));

// definition axiom for PackedStringArray.__default.FirstElement for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.FirstElement(Lit(psa#0)) } 
    PackedStringArray.__default.FirstElement#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) > 0)
       ==> PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(0))
         && PackedStringArray.__default.FirstElement(Lit(psa#0))
           == Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(0))));

// function declaration for PackedStringArray._default.LastElement
function PackedStringArray.__default.LastElement(psa#0: DatatypeType) : Seq Box;

function PackedStringArray.__default.LastElement#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.LastElement
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.LastElement(psa#0) } 
    PackedStringArray.__default.LastElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> $Is(PackedStringArray.__default.LastElement(psa#0), TSeq(Tclass.NativeTypes.byte())));

function PackedStringArray.__default.LastElement#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.LastElement
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.LastElement#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.LastElement#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0));

// definition axiom for PackedStringArray.__default.LastElement(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.LastElement(psa#0) } 
    PackedStringArray.__default.LastElement#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && Seq#Length(PackedStringArray.Psa.offsets(psa#0)) > 0)
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaElement#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1)
         && PackedStringArray.__default.LastElement(psa#0)
           == PackedStringArray.__default.psaElement(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)) - 1));

// definition axiom for PackedStringArray.__default.LastElement for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.LastElement(Lit(psa#0)) } 
    PackedStringArray.__default.LastElement#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) > 0)
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1)
         && PackedStringArray.__default.LastElement(Lit(psa#0))
           == PackedStringArray.__default.psaElement(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) - 1));

// function declaration for PackedStringArray._default.subtractConstant
function PackedStringArray.__default.subtractConstant($ly: LayerType, nums#0: Seq Box, subtrahend#0: int) : Seq Box;

function PackedStringArray.__default.subtractConstant#canCall(nums#0: Seq Box, subtrahend#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0) } 
  PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0)
     == PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant(AsFuelBottom($ly), nums#0, subtrahend#0) } 
  PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0)
     == PackedStringArray.__default.subtractConstant($LZ, nums#0, subtrahend#0));

// consequence axiom for PackedStringArray.__default.subtractConstant
axiom true
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    { PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0) } 
    PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0)
         || (
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(nums#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < Seq#Length(nums#0)
               ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#0)): int))
       ==> Seq#Length(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0))
           == Seq#Length(nums#0)
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(nums#0, i#1)): int } 
            { $Unbox(Seq#Index(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), i#1)): int } 
          true
             ==> 
            LitInt(0) <= i#1
               && i#1
                 < Seq#Length(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0))
             ==> $Unbox(Seq#Index(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), i#1)): int
               == $Unbox(Seq#Index(nums#0, i#1)): int - subtrahend#0)
         && $Is(PackedStringArray.__default.subtractConstant($ly, nums#0, subtrahend#0), 
          TSeq(Tclass.NativeTypes.uint32())));

function PackedStringArray.__default.subtractConstant#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for PackedStringArray.__default.subtractConstant
axiom (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
  { PackedStringArray.__default.subtractConstant#requires($ly, nums#0, subtrahend#0) } 
  $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= subtrahend#0
       && subtrahend#0 < 4294967296
     ==> PackedStringArray.__default.subtractConstant#requires($ly, nums#0, subtrahend#0)
       == (forall i#2: int :: 
        { $Unbox(Seq#Index(nums#0, i#2)): int } 
        true
           ==> 
          LitInt(0) <= i#2 && i#2 < Seq#Length(nums#0)
           ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#2)): int));

// definition axiom for PackedStringArray.__default.subtractConstant(revealed)
axiom true
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    { PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0) } 
    PackedStringArray.__default.subtractConstant#canCall(nums#0, subtrahend#0)
         || (
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(nums#0, i#2)): int } 
            true
               ==> 
              LitInt(0) <= i#2 && i#2 < Seq#Length(nums#0)
               ==> subtrahend#0 <= $Unbox(Seq#Index(nums#0, i#2)): int))
       ==> (Seq#Length(nums#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), nums#0)
             && PackedStringArray.__default.subtractConstant#canCall(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), subtrahend#0)
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), nums#0))
         && PackedStringArray.__default.subtractConstant($LS($ly), nums#0, subtrahend#0)
           == (if Seq#Length(nums#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.subtractConstant($ly, 
                Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), nums#0), 
                subtrahend#0), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), nums#0)): int
                     - subtrahend#0)))));

// definition axiom for PackedStringArray.__default.subtractConstant for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, nums#0: Seq Box, subtrahend#0: int :: 
    {:weight 3} { PackedStringArray.__default.subtractConstant($LS($ly), Lit(nums#0), LitInt(subtrahend#0)) } 
    PackedStringArray.__default.subtractConstant#canCall(Lit(nums#0), LitInt(subtrahend#0))
         || (
          $Is(nums#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= subtrahend#0
           && subtrahend#0 < 4294967296
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(nums#0, i#3)): int } 
            true
               ==> 
              LitInt(0) <= i#3 && i#3 < Seq#Length(Lit(nums#0))
               ==> LitInt(subtrahend#0) <= $Unbox(Seq#Index(Lit(nums#0), i#3)): int))
       ==> (Seq#Length(Lit(nums#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.NativeTypes.uint32(), Lit(nums#0))
             && PackedStringArray.__default.subtractConstant#canCall(Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(nums#0))), 
              LitInt(subtrahend#0))
             && Sequences.__default.Last#canCall(Tclass.NativeTypes.uint32(), Lit(nums#0)))
         && PackedStringArray.__default.subtractConstant($LS($ly), Lit(nums#0), LitInt(subtrahend#0))
           == (if Seq#Length(Lit(nums#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedStringArray.__default.subtractConstant($LS($ly), 
                Lit(Sequences.__default.DropLast(Tclass.NativeTypes.uint32(), Lit(nums#0))), 
                LitInt(subtrahend#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(LitInt($Unbox(Sequences.__default.Last(Tclass.NativeTypes.uint32(), Lit(nums#0))): int
                       - subtrahend#0))))));

// function declaration for PackedStringArray._default.subOffsets
function PackedStringArray.__default.subOffsets(offsets#0: Seq Box, from#0: int, to#0: int) : Seq Box;

function PackedStringArray.__default.subOffsets#canCall(offsets#0: Seq Box, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.subOffsets
axiom true
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    { PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) } 
    PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0)
         || (
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(offsets#0))
       ==> $Is(PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0), 
        TSeq(Tclass.NativeTypes.uint32())));

function PackedStringArray.__default.subOffsets#requires(Seq Box, int, int) : bool;

// #requires axiom for PackedStringArray.__default.subOffsets
axiom (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
  { PackedStringArray.__default.subOffsets#requires(offsets#0, from#0, to#0) } 
  $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.subOffsets#requires(offsets#0, from#0, to#0)
       == (Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= Seq#Length(offsets#0)));

// definition axiom for PackedStringArray.__default.subOffsets(revealed)
axiom true
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    { PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0) } 
    PackedStringArray.__default.subOffsets#canCall(offsets#0, from#0, to#0)
         || (
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, offsets#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= Seq#Length(offsets#0))
       ==> (var suboffsets#0 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0); 
          from#0 != LitInt(0)
             ==> PackedStringArray.__default.subtractConstant#canCall(suboffsets#0, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int))
         && PackedStringArray.__default.subOffsets(offsets#0, from#0, to#0)
           == (var suboffsets#0 := Seq#Drop(Seq#Take(offsets#0, to#0), from#0); 
            (if from#0 == LitInt(0)
               then suboffsets#0
               else PackedStringArray.__default.subtractConstant($LS($LZ), suboffsets#0, $Unbox(Seq#Index(offsets#0, from#0 - 1)): int))));

// definition axiom for PackedStringArray.__default.subOffsets for all literals(revealed)
axiom true
   ==> (forall offsets#0: Seq Box, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.subOffsets(Lit(offsets#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.subOffsets#canCall(Lit(offsets#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(offsets#0, TSeq(Tclass.NativeTypes.uint32()))
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Uint32__Order.__default.IsSorted(StartFuel_Uint32_Order._default.IsSorted, Lit(offsets#0))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= Seq#Length(Lit(offsets#0)))
       ==> (var suboffsets#1 := Lit(Seq#Drop(Seq#Take(Lit(offsets#0), LitInt(to#0)), LitInt(from#0))); 
          LitInt(from#0) != LitInt(0)
             ==> PackedStringArray.__default.subtractConstant#canCall(suboffsets#1, $Unbox(Seq#Index(Lit(offsets#0), LitInt(from#0 - 1))): int))
         && PackedStringArray.__default.subOffsets(Lit(offsets#0), LitInt(from#0), LitInt(to#0))
           == (var suboffsets#1 := Lit(Seq#Drop(Seq#Take(Lit(offsets#0), LitInt(to#0)), LitInt(from#0))); 
            (if LitInt(from#0) == LitInt(0)
               then suboffsets#1
               else PackedStringArray.__default.subtractConstant($LS($LZ), 
                suboffsets#1, 
                $Unbox(Seq#Index(Lit(offsets#0), LitInt(from#0 - 1))): int))));

// function declaration for PackedStringArray._default.psaSubSeqInternal
function PackedStringArray.__default.psaSubSeqInternal(psa#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaSubSeqInternal
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> $Is(PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0), 
        Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaSubSeqInternal#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSubSeqInternal
axiom (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedStringArray.__default.psaSubSeqInternal#requires(psa#0, from#0, to#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaSubSeqInternal#requires(psa#0, from#0, to#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaSubSeqInternal(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> (from#0 == to#0 ==> PackedStringArray.__default.EmptyPsa#canCall())
         && (from#0 != to#0
           ==> PackedStringArray.__default.psaStart#canCall(psa#0, from#0)
             && 
            PackedStringArray.__default.psaEnd#canCall(psa#0, to#0 - 1)
             && 
            PackedStringArray.Psa.Psa_q(psa#0)
             && PackedStringArray.__default.subOffsets#canCall(PackedStringArray.Psa.offsets(psa#0), from#0, to#0)
             && PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0)
           == (if from#0 == to#0
             then PackedStringArray.__default.EmptyPsa()
             else (var dataStart#0 := PackedStringArray.__default.psaStart(psa#0, from#0); 
              (var dataEnd#0 := PackedStringArray.__default.psaEnd(psa#0, to#0 - 1); 
                #PackedStringArray.Psa.Psa(PackedStringArray.__default.subOffsets(PackedStringArray.Psa.offsets(psa#0), from#0, to#0), 
                  Seq#Drop(Seq#Take(PackedStringArray.Psa.data(psa#0), dataEnd#0), dataStart#0))))));

// definition axiom for PackedStringArray.__default.psaSubSeqInternal for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.psaSubSeqInternal#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> (LitInt(from#0) == LitInt(to#0)
           ==> PackedStringArray.__default.EmptyPsa#canCall())
         && (LitInt(from#0) != LitInt(to#0)
           ==> PackedStringArray.__default.psaStart#canCall(Lit(psa#0), LitInt(from#0))
             && 
            PackedStringArray.__default.psaEnd#canCall(Lit(psa#0), LitInt(to#0 - 1))
             && 
            PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && PackedStringArray.__default.subOffsets#canCall(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(from#0), LitInt(to#0))
             && PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0))
           == (if LitInt(from#0) == LitInt(to#0)
             then PackedStringArray.__default.EmptyPsa()
             else (var dataStart#1 := LitInt(PackedStringArray.__default.psaStart(Lit(psa#0), LitInt(from#0))); 
              (var dataEnd#1 := LitInt(PackedStringArray.__default.psaEnd(Lit(psa#0), LitInt(to#0 - 1))); 
                Lit(#PackedStringArray.Psa.Psa(Lit(PackedStringArray.__default.subOffsets(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))), LitInt(from#0), LitInt(to#0))), 
                    Lit(Seq#Drop(Seq#Take(Lit(PackedStringArray.Psa.data(Lit(psa#0))), dataEnd#1), dataStart#1))))))));

// function declaration for PackedStringArray._default.psaSubSeq
function PackedStringArray.__default.psaSubSeq(psa#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedStringArray.__default.psaSubSeq#canCall(psa#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedStringArray.__default.psaSubSeq
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)), 
          Seq#Drop(Seq#Take(PackedStringArray.__default.I(psa#0), to#0), from#0))
         && $Is(PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaSubSeq#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedStringArray.__default.psaSubSeq
axiom (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedStringArray.__default.psaSubSeq#requires(psa#0, from#0, to#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedStringArray.__default.psaSubSeq#requires(psa#0, from#0, to#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaSubSeq(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0) } 
    PackedStringArray.__default.psaSubSeq#canCall(psa#0, from#0, to#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.psaSubSeqInternal#canCall(psa#0, from#0, to#0)
         && PackedStringArray.__default.psaSubSeq(psa#0, from#0, to#0)
           == PackedStringArray.__default.psaSubSeqInternal(psa#0, from#0, to#0));

// definition axiom for PackedStringArray.__default.psaSubSeq for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedStringArray.__default.psaSubSeq(Lit(psa#0), LitInt(from#0), LitInt(to#0)) } 
    PackedStringArray.__default.psaSubSeq#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0) <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> PackedStringArray.__default.psaSubSeqInternal#canCall(Lit(psa#0), LitInt(from#0), LitInt(to#0))
         && PackedStringArray.__default.psaSubSeq(Lit(psa#0), LitInt(from#0), LitInt(to#0))
           == Lit(PackedStringArray.__default.psaSubSeqInternal(Lit(psa#0), LitInt(from#0), LitInt(to#0))));

// function declaration for PackedStringArray._default.psaDropLast
function PackedStringArray.__default.psaDropLast(psa#0: DatatypeType) : DatatypeType;

function PackedStringArray.__default.psaDropLast#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArray.__default.psaDropLast
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaDropLast(psa#0) } 
    PackedStringArray.__default.psaDropLast#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 0 < PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaDropLast(psa#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaDropLast(psa#0)), 
          Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), PackedStringArray.__default.I(psa#0)))
         && $Is(PackedStringArray.__default.psaDropLast(psa#0), Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaDropLast#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArray.__default.psaDropLast
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArray.__default.psaDropLast#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArray.__default.psaDropLast#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 0 < PackedStringArray.__default.psaNumStrings(psa#0)));

// definition axiom for PackedStringArray.__default.psaDropLast(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArray.__default.psaDropLast(psa#0) } 
    PackedStringArray.__default.psaDropLast#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 0 < PackedStringArray.__default.psaNumStrings(psa#0))
       ==> PackedStringArray.__default.psaNumStrings#canCall(psa#0)
         && PackedStringArray.__default.psaSubSeq#canCall(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1)
         && PackedStringArray.__default.psaDropLast(psa#0)
           == PackedStringArray.__default.psaSubSeq(psa#0, LitInt(0), PackedStringArray.__default.psaNumStrings(psa#0) - 1));

// definition axiom for PackedStringArray.__default.psaDropLast for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArray.__default.psaDropLast(Lit(psa#0)) } 
    PackedStringArray.__default.psaDropLast#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(0 < PackedStringArray.__default.psaNumStrings(Lit(psa#0))))
       ==> PackedStringArray.__default.psaNumStrings#canCall(Lit(psa#0))
         && PackedStringArray.__default.psaSubSeq#canCall(Lit(psa#0), 
          LitInt(0), 
          LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0)) - 1))
         && PackedStringArray.__default.psaDropLast(Lit(psa#0))
           == Lit(PackedStringArray.__default.psaSubSeq(Lit(psa#0), 
              LitInt(0), 
              LitInt(PackedStringArray.__default.psaNumStrings(Lit(psa#0)) - 1))));

// function declaration for PackedStringArray._default.psaCanAppend
function PackedStringArray.__default.psaCanAppend(psa#0: DatatypeType, key#0: Seq Box) : bool;

function PackedStringArray.__default.psaCanAppend#canCall(psa#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaCanAppend
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> true);

function PackedStringArray.__default.psaCanAppend#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaCanAppend
axiom (forall psa#0: DatatypeType, key#0: Seq Box :: 
  { PackedStringArray.__default.psaCanAppend#requires(psa#0, key#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.__default.psaCanAppend#requires(psa#0, key#0) == true);

// definition axiom for PackedStringArray.__default.psaCanAppend(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaCanAppend#canCall(psa#0, key#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
           ==> PackedStringArray.Psa.Psa_q(psa#0))
         && PackedStringArray.__default.psaCanAppend(psa#0, key#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) < 4294967296 - 1
             && Seq#Length(PackedStringArray.Psa.data(psa#0)) + Seq#Length(key#0) < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppend for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0)) } 
    PackedStringArray.__default.psaCanAppend#canCall(Lit(psa#0), Lit(key#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte())))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296 - 1
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0)))
         && PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0))
           == (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))) < 4294967296 - 1
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0)))) + Seq#Length(Lit(key#0))
               < 4294967296));

// function declaration for PackedStringArray._default.psaAppend
function PackedStringArray.__default.psaAppend(psa#0: DatatypeType, key#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaAppend#canCall(psa#0: DatatypeType, key#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaAppend
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppend(psa#0, key#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaAppend(psa#0, key#0))
         && $Is(PackedStringArray.__default.psaAppend(psa#0, key#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaAppend#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaAppend
axiom (forall psa#0: DatatypeType, key#0: Seq Box :: 
  { PackedStringArray.__default.psaAppend#requires(psa#0, key#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedStringArray.__default.psaAppend#requires(psa#0, key#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedStringArray.__default.psaCanAppend(psa#0, key#0)));

// definition axiom for PackedStringArray.__default.psaAppend(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    { PackedStringArray.__default.psaAppend(psa#0, key#0) } 
    PackedStringArray.__default.psaAppend#canCall(psa#0, key#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppend(psa#0, key#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.__default.psaAppend(psa#0, key#0)
           == (var newdata#0 := Seq#Append(PackedStringArray.Psa.data(psa#0), key#0); 
            #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(psa#0), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#0)))), 
              newdata#0)));

// definition axiom for PackedStringArray.__default.psaAppend for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, key#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppend(Lit(psa#0), Lit(key#0)) } 
    PackedStringArray.__default.psaAppend#canCall(Lit(psa#0), Lit(key#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(key#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedStringArray.__default.psaCanAppend(Lit(psa#0), Lit(key#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.__default.psaAppend(Lit(psa#0), Lit(key#0))
           == (var newdata#1 := Seq#Append(PackedStringArray.Psa.data(Lit(psa#0)), key#0); 
            #PackedStringArray.Psa.Psa(Seq#Append(PackedStringArray.Psa.offsets(Lit(psa#0)), 
                Seq#Build(Seq#Empty(): Seq Box, $Box(Seq#Length(newdata#1)))), 
              newdata#1)));

// function declaration for PackedStringArray._default.psaCanAppendSeq
function PackedStringArray.__default.psaCanAppendSeq(psa#0: DatatypeType, strs#0: Seq Box) : bool;

function PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0: DatatypeType, strs#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaCanAppendSeq
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> true);

function PackedStringArray.__default.psaCanAppendSeq#requires(DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaCanAppendSeq
axiom (forall psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaCanAppendSeq#requires(psa#0, strs#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaCanAppendSeq#requires(psa#0, strs#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), strs#0)
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0)))
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(strs#0)
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
               < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq for decreasing-related literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0)) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(psa#0, Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(Lit(strs#0))
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(psa#0)
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), Lit(strs#0))
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Lit(strs#0))))
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0))
           == (Seq#Length(PackedStringArray.Psa.offsets(psa#0)) + Seq#Length(Lit(strs#0))
               < 4294967296
             && Seq#Length(PackedStringArray.Psa.data(psa#0))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuel_Sequences._default.FlattenShape, 
                    Lit(strs#0)))
               < 4294967296));

// definition axiom for PackedStringArray.__default.psaCanAppendSeq for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0)) } 
    PackedStringArray.__default.psaCanAppendSeq#canCall(Lit(psa#0), Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
               + Seq#Length(Lit(strs#0))
             < 4294967296
           ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
             && 
            Sequences.__default.FlattenShape#canCall(Tclass.NativeTypes.byte(), Lit(strs#0))
             && Sequences.__default.FlattenLength#canCall(Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                StartFuel_Sequences._default.FlattenShape, 
                Lit(strs#0))))
         && PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0))
           == (Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))
                 + Seq#Length(Lit(strs#0))
               < 4294967296
             && Seq#Length(Lit(PackedStringArray.Psa.data(Lit(psa#0))))
                 + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
                  Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), 
                    StartFuel_Sequences._default.FlattenShape, 
                    Lit(strs#0)))
               < 4294967296));

// function declaration for PackedStringArray._default.psaAppendSeq
function PackedStringArray.__default.psaAppendSeq($ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaAppendSeq#canCall(psa#0: DatatypeType, strs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0) } 
  PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0)
     == PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq(AsFuelBottom($ly), psa#0, strs#0) } 
  PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0)
     == PackedStringArray.__default.psaAppendSeq($LZ, psa#0, strs#0));

// consequence axiom for PackedStringArray.__default.psaAppendSeq
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0)), 
          Seq#Append(PackedStringArray.__default.I(psa#0), strs#0))
         && PackedStringArray.__default.psaTotalLength(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0))
           == PackedStringArray.__default.psaTotalLength(psa#0)
             + Sequences.__default.FlattenLength(StartFuel_Sequences._default.FlattenLength, 
              Sequences.__default.FlattenShape(Tclass.NativeTypes.byte(), StartFuel_Sequences._default.FlattenShape, strs#0))
         && $Is(PackedStringArray.__default.psaAppendSeq($ly, psa#0, strs#0), 
          Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaAppendSeq#requires(LayerType, DatatypeType, Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaAppendSeq
axiom (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
  { PackedStringArray.__default.psaAppendSeq#requires($ly, psa#0, strs#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
       && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaAppendSeq#requires($ly, psa#0, strs#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0)));

// definition axiom for PackedStringArray.__default.psaAppendSeq(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, strs#0)
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, strs#0))
       ==> (Seq#Length(strs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
             && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), strs#0)
             && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($ly, 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, strs#0)
           == (if Seq#Length(strs#0) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($ly, 
                psa#0, 
                Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), strs#0)), 
              $Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), strs#0)): Seq Box)));

// definition axiom for PackedStringArray.__default.psaAppendSeq for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, Lit(strs#0)) } 
    PackedStringArray.__default.psaAppendSeq#canCall(psa#0, Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedStringArray.__default.psaCanAppendSeq(psa#0, Lit(strs#0)))
       ==> (Seq#Length(Lit(strs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppendSeq#canCall(psa#0, 
              Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppend#canCall(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                psa#0, 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0)))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box)))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), psa#0, Lit(strs#0))
           == (if Seq#Length(Lit(strs#0)) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                psa#0, 
                Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0)))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box))));

// definition axiom for PackedStringArray.__default.psaAppendSeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaAppendSeq($LS($ly), Lit(psa#0), Lit(strs#0)) } 
    PackedStringArray.__default.psaAppendSeq#canCall(Lit(psa#0), Lit(strs#0))
         || (
          $Is(psa#0, Tclass.PackedStringArray.Psa())
           && $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedStringArray.__default.psaCanAppendSeq(Lit(psa#0), Lit(strs#0))))
       ==> (Seq#Length(Lit(strs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppendSeq#canCall(Lit(psa#0), 
              Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))
             && Sequences.__default.Last#canCall(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))
             && PackedStringArray.__default.psaAppend#canCall(Lit(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                  Lit(psa#0), 
                  Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box)))
         && PackedStringArray.__default.psaAppendSeq($LS($ly), Lit(psa#0), Lit(strs#0))
           == (if Seq#Length(Lit(strs#0)) == LitInt(0)
             then psa#0
             else PackedStringArray.__default.psaAppend(Lit(PackedStringArray.__default.psaAppendSeq($LS($ly), 
                  Lit(psa#0), 
                  Lit(Sequences.__default.DropLast(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))))), 
              Lit($Unbox(Sequences.__default.Last(TSeq(Tclass.NativeTypes.byte()), Lit(strs#0))): Seq Box))));

// function declaration for PackedStringArray._default.psaFromSeq
function PackedStringArray.__default.psaFromSeq(strs#0: Seq Box) : DatatypeType;

function PackedStringArray.__default.psaFromSeq#canCall(strs#0: Seq Box) : bool;

// consequence axiom for PackedStringArray.__default.psaFromSeq
axiom true
   ==> (forall strs#0: Seq Box :: 
    { PackedStringArray.__default.psaFromSeq(strs#0) } 
    PackedStringArray.__default.psaFromSeq#canCall(strs#0)
         || ($Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0))
       ==> PackedStringArray.__default.WF(PackedStringArray.__default.psaFromSeq(strs#0))
         && Seq#Equal(PackedStringArray.__default.I(PackedStringArray.__default.psaFromSeq(strs#0)), 
          strs#0)
         && $Is(PackedStringArray.__default.psaFromSeq(strs#0), Tclass.PackedStringArray.Psa()));

function PackedStringArray.__default.psaFromSeq#requires(Seq Box) : bool;

// #requires axiom for PackedStringArray.__default.psaFromSeq
axiom (forall strs#0: Seq Box :: 
  { PackedStringArray.__default.psaFromSeq#requires(strs#0) } 
  $Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
     ==> PackedStringArray.__default.psaFromSeq#requires(strs#0)
       == PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0));

// definition axiom for PackedStringArray.__default.psaFromSeq(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    { PackedStringArray.__default.psaFromSeq(strs#0) } 
    PackedStringArray.__default.psaFromSeq#canCall(strs#0)
         || ($Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), strs#0))
       ==> PackedStringArray.__default.EmptyPsa#canCall()
         && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), strs#0)
         && PackedStringArray.__default.psaFromSeq(strs#0)
           == PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), strs#0));

// definition axiom for PackedStringArray.__default.psaFromSeq for all literals(revealed)
axiom true
   ==> (forall strs#0: Seq Box :: 
    {:weight 3} { PackedStringArray.__default.psaFromSeq(Lit(strs#0)) } 
    PackedStringArray.__default.psaFromSeq#canCall(Lit(strs#0))
         || ($Is(strs#0, TSeq(TSeq(Tclass.NativeTypes.byte())))
           && Lit(PackedStringArray.__default.psaCanAppendSeq(Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))))
       ==> PackedStringArray.__default.EmptyPsa#canCall()
         && PackedStringArray.__default.psaAppendSeq#canCall(Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))
         && PackedStringArray.__default.psaFromSeq(Lit(strs#0))
           == Lit(PackedStringArray.__default.psaAppendSeq($LS($LZ), Lit(PackedStringArray.__default.EmptyPsa()), Lit(strs#0))));

const unique class.Integer__Order.__default: ClassName;

function Tclass.Integer__Order.__default() : Ty;

// Tclass.Integer__Order.__default Tag
axiom Tag(Tclass.Integer__Order.__default()) == Tagclass.Integer__Order.__default;

const unique Tagclass.Integer__Order.__default: TyTag;

// Box/unbox axiom for Tclass.Integer__Order.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Integer__Order.__default()) } 
  $IsBox(bx, Tclass.Integer__Order.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Integer__Order.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Integer__Order.__default()) } 
  $Is($o, Tclass.Integer__Order.__default())
     <==> $o == null || dtype($o) == Tclass.Integer__Order.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Integer__Order.__default(), $h) } 
  $IsAlloc($o, Tclass.Integer__Order.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Integer_Order._default.SomeElement
function Integer__Order.__default.SomeElement() : int;

function Integer__Order.__default.SomeElement#canCall() : bool;

// consequence axiom for Integer__Order.__default.SomeElement
axiom true ==> true ==> true;

function Integer__Order.__default.SomeElement#requires() : bool;

// #requires axiom for Integer__Order.__default.SomeElement
axiom Integer__Order.__default.SomeElement#requires() == true;

// definition axiom for Integer__Order.__default.SomeElement(revealed)
axiom true ==> true ==> Integer__Order.__default.SomeElement() == LitInt(0);

// definition axiom for Integer__Order.__default.SomeElement for all literals(revealed)
axiom true ==> true ==> Integer__Order.__default.SomeElement() == LitInt(0);

// function declaration for Integer_Order._default.lte
function Integer__Order.__default.lte(a#0: int, b#0: int) : bool;

function Integer__Order.__default.lte#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.lte
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lte(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
           || Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0))
         && (forall a#1: int, b#1: int, c#0: int :: 
          { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#1, c#0), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#1, c#0) } 
            { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#1, c#0), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#1, b#1) } 
          true
             ==> 
            Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#1, b#1)
               && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#1, c#0)
             ==> Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#1, c#0))
         && Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
           || Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0))
         && (Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0)
             && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#0, a#0)
           ==> a#0 == b#0)
         && (forall a#2: int, b#2: int, c#1: int :: 
          { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#2, c#1), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#2, c#1) } 
            { Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#2, c#1), Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#2, b#2) } 
          true
             ==> 
            Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#2, b#2)
               && Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, b#2, c#1)
             ==> Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#2, c#1)));

function Integer__Order.__default.lte#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.lte
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.lte#requires(a#0, b#0) } 
  Integer__Order.__default.lte#requires(a#0, b#0) == true);

const MoreFuel_Integer_Order._default.ltedef0: LayerType;

// definition axiom for Integer__Order.__default.lte(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lte(a#0, b#0) } 
    true
       ==> Integer__Order.__default.ltedef#canCall(a#0, b#0)
         && 
        StartFuel_Integer_Order._default.ltedef
           == $LS(MoreFuel_Integer_Order._default.ltedef0)
         && StartFuelAssert_Integer_Order._default.ltedef
           == $LS($LS(MoreFuel_Integer_Order._default.ltedef0))
         && AsFuelBottom(MoreFuel_Integer_Order._default.ltedef0)
           == MoreFuel_Integer_Order._default.ltedef0
         && Integer__Order.__default.lte(a#0, b#0)
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, a#0, b#0));

const MoreFuel_Integer_Order._default.ltedef1: LayerType;

// definition axiom for Integer__Order.__default.lte for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.ltedef#canCall(LitInt(a#0), LitInt(b#0))
         && 
        StartFuel_Integer_Order._default.ltedef
           == $LS(MoreFuel_Integer_Order._default.ltedef1)
         && StartFuelAssert_Integer_Order._default.ltedef
           == $LS($LS(MoreFuel_Integer_Order._default.ltedef1))
         && AsFuelBottom(MoreFuel_Integer_Order._default.ltedef1)
           == MoreFuel_Integer_Order._default.ltedef1
         && Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0))
           == Integer__Order.__default.ltedef(StartFuel_Integer_Order._default.ltedef, LitInt(a#0), LitInt(b#0)));

// function declaration for Integer_Order._default.ltedef
function Integer__Order.__default.ltedef($ly: LayerType, a#0: int, b#0: int) : bool;

function Integer__Order.__default.ltedef#canCall(a#0: int, b#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef($LS($ly), a#0, b#0) } 
  Integer__Order.__default.ltedef($LS($ly), a#0, b#0)
     == Integer__Order.__default.ltedef($ly, a#0, b#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef(AsFuelBottom($ly), a#0, b#0) } 
  Integer__Order.__default.ltedef($ly, a#0, b#0)
     == Integer__Order.__default.ltedef($LZ, a#0, b#0));

// consequence axiom for Integer__Order.__default.ltedef
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Integer__Order.__default.ltedef($ly, a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.ltedef#requires(LayerType, int, int) : bool;

// #requires axiom for Integer__Order.__default.ltedef
axiom (forall $ly: LayerType, a#0: int, b#0: int :: 
  { Integer__Order.__default.ltedef#requires($ly, a#0, b#0) } 
  Integer__Order.__default.ltedef#requires($ly, a#0, b#0) == true);

// definition axiom for Integer__Order.__default.ltedef(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    { Integer__Order.__default.ltedef($LS($ly), a#0, b#0) } 
    true ==> Integer__Order.__default.ltedef($LS($ly), a#0, b#0) == (a#0 <= b#0));

// definition axiom for Integer__Order.__default.ltedef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.ltedef($LS($ly), LitInt(a#0), LitInt(b#0))
         == (LitInt(a#0) <= LitInt(b#0)));

// function declaration for Integer_Order._default.LargestLte
function Integer__Order.__default.LargestLte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.LargestLte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0)
     == Integer__Order.__default.LargestLte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLte($ly, run#0, needle#0)
     == Integer__Order.__default.LargestLte($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.LargestLte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLte($ly, run#0, needle#0) } 
    Integer__Order.__default.LargestLte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
         && Integer__Order.__default.LargestLte($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Integer__Order.__default.LargestLte($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> LitInt(0) <= Integer__Order.__default.LargestLte($ly, run#0, needle#0)
             && $Unbox(Seq#Index(run#0, Integer__Order.__default.LargestLte($ly, run#0, needle#0))): int
               == needle#0));

function Integer__Order.__default.LargestLte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.LargestLte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.LargestLte#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted0: LayerType;

// definition axiom for Integer__Order.__default.LargestLte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.LargestLte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Integer__Order.__default.lt#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Integer__Order.__default.LargestLte#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted0)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted0))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted0)
           == MoreFuel_Integer_Order._default.IsSorted0
         && Integer__Order.__default.LargestLte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLte($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Integer_Order._default.IsSorted1: LayerType;

// definition axiom for Integer__Order.__default.LargestLte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.LargestLte#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Integer__Order.__default.lt#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Integer__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Integer__Order.__default.LargestLte#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted1)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted1))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted1)
           == MoreFuel_Integer_Order._default.IsSorted1
         && Integer__Order.__default.LargestLte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Integer__Order.__default.lt(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLte($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Integer_Order._default.LargestLt
function Integer__Order.__default.LargestLt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.LargestLt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0)
     == Integer__Order.__default.LargestLt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.LargestLt($ly, run#0, needle#0)
     == Integer__Order.__default.LargestLt($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.LargestLt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLt($ly, run#0, needle#0) } 
    Integer__Order.__default.LargestLt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> LitInt(0 - 1) <= Integer__Order.__default.LargestLt($ly, run#0, needle#0)
         && Integer__Order.__default.LargestLt($ly, run#0, needle#0) < Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          true
             ==> 
            LitInt(0) <= i#0
               && i#0 <= Integer__Order.__default.LargestLt($ly, run#0, needle#0)
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          true
             ==> 
            Integer__Order.__default.LargestLt($ly, run#0, needle#0) < i#1
               && i#1 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && (Seq#Contains(run#0, $Box(needle#0))
           ==> Integer__Order.__default.LargestLt($ly, run#0, needle#0) + 1 < Seq#Length(run#0)
             && $Unbox(Seq#Index(run#0, Integer__Order.__default.LargestLt($ly, run#0, needle#0) + 1)): int
               == needle#0));

function Integer__Order.__default.LargestLt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.LargestLt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.LargestLt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.LargestLt#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted2: LayerType;

// definition axiom for Integer__Order.__default.LargestLt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.LargestLt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Integer__Order.__default.lte#canCall(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
         && (!(Seq#Length(run#0) == LitInt(0)
             || Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int))
           ==> Integer__Order.__default.LargestLt#canCall(Seq#Drop(run#0, LitInt(1)), needle#0))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted2)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted2))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted2)
           == MoreFuel_Integer_Order._default.IsSorted2
         && Integer__Order.__default.LargestLt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
               || Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLt($ly, Seq#Drop(run#0, LitInt(1)), needle#0)));

const MoreFuel_Integer_Order._default.IsSorted3: LayerType;

// definition axiom for Integer__Order.__default.LargestLt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.LargestLt#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Integer__Order.__default.lte#canCall(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
         && (!(Seq#Length(Lit(run#0)) == LitInt(0)
             || Integer__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int))
           ==> Integer__Order.__default.LargestLt#canCall(Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted3)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted3))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted3)
           == MoreFuel_Integer_Order._default.IsSorted3
         && Integer__Order.__default.LargestLt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
               || Integer__Order.__default.lte(LitInt(needle#0), $Unbox(Seq#Index(Lit(run#0), LitInt(0))): int)
             then 0 - 1
             else 1
               + Integer__Order.__default.LargestLt($LS($ly), Lit(Seq#Drop(Lit(run#0), LitInt(1))), LitInt(needle#0))));

// function declaration for Integer_Order._default.IndexOfFirstGte
function Integer__Order.__default.IndexOfFirstGte($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.IndexOfFirstGte#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGte($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.IndexOfFirstGte
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0)
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Integer__Order.__default.IndexOfFirstGte($ly, run#0, needle#0));

function Integer__Order.__default.IndexOfFirstGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.IndexOfFirstGte
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IndexOfFirstGte#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted4: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGte(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, run#0)
             && Integer__Order.__default.lt#canCall($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
             && (!Integer__Order.__default.lt($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               ==> Sequences.__default.DropLast#canCall(TInt, run#0)
                 && Integer__Order.__default.IndexOfFirstGte#canCall(Sequences.__default.DropLast(TInt, run#0), needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted4)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted4))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted4)
           == MoreFuel_Integer_Order._default.IsSorted4
         && Integer__Order.__default.IndexOfFirstGte($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lt($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               then Seq#Length(run#0)
               else Integer__Order.__default.IndexOfFirstGte($ly, Sequences.__default.DropLast(TInt, run#0), needle#0))));

const MoreFuel_Integer_Order._default.IsSorted5: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.IndexOfFirstGte#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, Lit(run#0))
             && Integer__Order.__default.lt#canCall(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Integer__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TInt, Lit(run#0))
                 && Integer__Order.__default.IndexOfFirstGte#canCall(Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0))))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted5)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted5))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted5)
           == MoreFuel_Integer_Order._default.IsSorted5
         && Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lt(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Integer__Order.__default.IndexOfFirstGte($LS($ly), Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0)))));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGteIter
function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, mid#0, hi#0)
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Integer__Order.__default.lte(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Integer__Order.__default.lte(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lt($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGte
function Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte(AsFuelBottom($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LZ, s#0, key#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) > 0
           ==> Integer__Order.__default.lt($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lte(key#0, 
            $Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGte($ly, s#0, key#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGte#requires($ly, s#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), s#0, key#0)
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGte for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGte#canCall(Lit(s#0), LitInt(key#0))
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGte($LS($ly), Lit(s#0), LitInt(key#0))
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGteIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Integer_Order._default.IndexOfFirstGt
function Integer__Order.__default.IndexOfFirstGt($ly: LayerType, run#0: Seq Box, needle#0: int) : int;

function Integer__Order.__default.IndexOfFirstGt#canCall(run#0: Seq Box, needle#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt(AsFuelBottom($ly), run#0, needle#0) } 
  Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
     == Integer__Order.__default.IndexOfFirstGt($LZ, run#0, needle#0));

// consequence axiom for Integer__Order.__default.IndexOfFirstGt
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
           <= Seq#Length(run#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(run#0, i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0)
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, needle#0))
         && (forall i#1: int :: 
          { $Unbox(Seq#Index(run#0, i#1)): int } 
          Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0) <= i#1
               && i#1 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt(needle#0, $Unbox(Seq#Index(run#0, i#1)): int))
         && LitInt(0) <= Integer__Order.__default.IndexOfFirstGt($ly, run#0, needle#0));

function Integer__Order.__default.IndexOfFirstGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.IndexOfFirstGt
axiom (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
  { Integer__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IndexOfFirstGt#requires($ly, run#0, needle#0)
       == Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0));

const MoreFuel_Integer_Order._default.IsSorted6: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGt(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    { Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(run#0, needle#0)
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0))
       ==> (Seq#Length(run#0) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, run#0)
             && Integer__Order.__default.lte#canCall($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
             && (!Integer__Order.__default.lte($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               ==> Sequences.__default.DropLast#canCall(TInt, run#0)
                 && Integer__Order.__default.IndexOfFirstGt#canCall(Sequences.__default.DropLast(TInt, run#0), needle#0)))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted6)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted6))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted6)
           == MoreFuel_Integer_Order._default.IsSorted6
         && Integer__Order.__default.IndexOfFirstGt($LS($ly), run#0, needle#0)
           == (if Seq#Length(run#0) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lte($Unbox(Sequences.__default.Last(TInt, run#0)): int, needle#0)
               then Seq#Length(run#0)
               else Integer__Order.__default.IndexOfFirstGt($ly, Sequences.__default.DropLast(TInt, run#0), needle#0))));

const MoreFuel_Integer_Order._default.IsSorted7: LayerType;

// definition axiom for Integer__Order.__default.IndexOfFirstGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box, needle#0: int :: 
    {:weight 3} { Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0)) } 
    Integer__Order.__default.IndexOfFirstGt#canCall(Lit(run#0), LitInt(needle#0))
         || ($Is(run#0, TSeq(TInt))
           && Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, Lit(run#0)))
       ==> (Seq#Length(Lit(run#0)) != LitInt(0)
           ==> Sequences.__default.Last#canCall(TInt, Lit(run#0))
             && Integer__Order.__default.lte#canCall(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
              LitInt(needle#0))
             && (!Lit(Integer__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                  LitInt(needle#0)))
               ==> Sequences.__default.DropLast#canCall(TInt, Lit(run#0))
                 && Integer__Order.__default.IndexOfFirstGt#canCall(Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0))))
         && 
        StartFuel_Integer_Order._default.IsSorted
           == $LS(MoreFuel_Integer_Order._default.IsSorted7)
         && StartFuelAssert_Integer_Order._default.IsSorted
           == $LS($LS(MoreFuel_Integer_Order._default.IsSorted7))
         && AsFuelBottom(MoreFuel_Integer_Order._default.IsSorted7)
           == MoreFuel_Integer_Order._default.IsSorted7
         && Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(run#0), LitInt(needle#0))
           == (if Seq#Length(Lit(run#0)) == LitInt(0)
             then 0
             else (if Integer__Order.__default.lte(LitInt($Unbox(Sequences.__default.Last(TInt, Lit(run#0))): int), 
                LitInt(needle#0))
               then Seq#Length(Lit(run#0))
               else Integer__Order.__default.IndexOfFirstGt($LS($ly), Lit(Sequences.__default.DropLast(TInt, Lit(run#0))), LitInt(needle#0)))));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGtIter
function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0: Seq Box, key#0: int, lo#0: int, hi#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter(AsFuelBottom($ly), s#0, key#0, lo#0, hi#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LZ, s#0, key#0, lo#0, hi#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
                   - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, 
                Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, hi#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires(LayerType, Seq Box, int, int, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#requires($ly, s#0, key#0, lo#0, hi#0)
       == (
        LitInt(0) <= lo#0
         && lo#0 < hi#0
         && hi#0 <= Seq#Length(s#0) + 1
         && (lo#0 > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
         && (hi#0 <= Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int))));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, hi#0)
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= lo#0
           && lo#0 < hi#0
           && hi#0 <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, lo#0 - 1)): int, key#0))
           && (hi#0 <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, hi#0 - 1)): int)))
       ==> (lo#0 + 1 < hi#0
           ==> (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
               && (Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#0, hi#0))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, lo#0, mid#0))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, lo#0, hi#0)
           == (if lo#0 + 1 < hi#0
             then (var mid#0 := Div(lo#0 + hi#0, LitInt(2)); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#0 - 1)): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, mid#0, hi#0)
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($ly, s#0, key#0, lo#0, mid#0)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(s#0) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(lo#0 - 1))): int, key#0))
           && (LitInt(hi#0) <= Seq#Length(s#0)
             ==> Integer__Order.__default.lt(key#0, $Unbox(Seq#Index(s#0, LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
               && (Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, mid#1, LitInt(hi#0)))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(s#0, mid#1 - 1)): int, key#0)
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(lo#0), mid#1))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#1 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(s#0, LitInt(mid#1 - 1))): int, key#0)
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, mid#1, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), s#0, key#0, LitInt(lo#0), mid#1)))
             else lo#0));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int, lo#0: int, hi#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
         || ($Is(s#0, TSeq(TInt))
           && 
          LitInt(0) <= LitInt(lo#0)
           && lo#0 < hi#0
           && LitInt(hi#0) <= Seq#Length(Lit(s#0)) + 1
           && (lo#0 > 0
             ==> Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(lo#0 - 1))): int, LitInt(key#0)))
           && (LitInt(hi#0) <= Seq#Length(Lit(s#0))
             ==> Integer__Order.__default.lt(LitInt(key#0), $Unbox(Seq#Index(Lit(s#0), LitInt(hi#0 - 1))): int)))
       ==> (Lit(lo#0 + 1 < hi#0)
           ==> (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
            Integer__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
               && (Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0)))
               && (!Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), mid#2 - 1)): int, LitInt(key#0))
                 ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2))))
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), LitInt(hi#0))
           == (if lo#0 + 1 < hi#0
             then (var mid#2 := LitInt(Div(lo#0 + hi#0, LitInt(2))); 
              (if Integer__Order.__default.lte($Unbox(Seq#Index(Lit(s#0), LitInt(mid#2 - 1))): int, LitInt(key#0))
                 then Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), mid#2, LitInt(hi#0))
                 else Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($ly), Lit(s#0), LitInt(key#0), LitInt(lo#0), mid#2)))
             else lo#0));

// function declaration for Integer_Order._default.binarySearchIndexOfFirstKeyGt
function Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly: LayerType, s#0: Seq Box, key#0: int) : int;

function Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0: Seq Box, key#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt(AsFuelBottom($ly), s#0, key#0) } 
  Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
     == Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LZ, s#0, key#0));

// consequence axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> LitInt(0)
           <= Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
           <= Seq#Length(s#0)
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) > 0
           ==> Integer__Order.__default.lte($Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0) - 1)): int, 
            key#0))
         && (Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0)
             < Seq#Length(s#0)
           ==> Integer__Order.__default.lt(key#0, 
            $Unbox(Seq#Index(s#0, Integer__Order.__default.binarySearchIndexOfFirstKeyGt($ly, s#0, key#0))): int)));

function Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt
axiom (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0) } 
  $Is(s#0, TSeq(TInt))
     ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGt#requires($ly, s#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(s#0, key#0)
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(s#0, key#0, LitInt(0), Seq#Length(s#0) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), s#0, key#0)
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), s#0, key#0, LitInt(0), Seq#Length(s#0) + 1));

// definition axiom for Integer__Order.__default.binarySearchIndexOfFirstKeyGt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0)) } 
    Integer__Order.__default.binarySearchIndexOfFirstKeyGt#canCall(Lit(s#0), LitInt(key#0))
         || $Is(s#0, TSeq(TInt))
       ==> Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter#canCall(Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1)
         && Integer__Order.__default.binarySearchIndexOfFirstKeyGt($LS($ly), Lit(s#0), LitInt(key#0))
           == Integer__Order.__default.binarySearchIndexOfFirstKeyGtIter($LS($LZ), Lit(s#0), LitInt(key#0), LitInt(0), Seq#Length(Lit(s#0)) + 1));

// function declaration for Integer_Order._default.SetAllLte
function Integer__Order.__default.SetAllLte(a#0: Set Box, b#0: Set Box) : bool;

function Integer__Order.__default.SetAllLte#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Integer__Order.__default.SetAllLte
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLte(a#0, b#0) } 
    Integer__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> true);

function Integer__Order.__default.SetAllLte#requires(Set Box, Set Box) : bool;

// #requires axiom for Integer__Order.__default.SetAllLte
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Integer__Order.__default.SetAllLte#requires(a#0, b#0) } 
  $Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt))
     ==> Integer__Order.__default.SetAllLte#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.SetAllLte(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLte(a#0, b#0) } 
    Integer__Order.__default.SetAllLte#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#0: int, y#0: int :: 
          { Integer__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          b#0[$Box(y#0)] ==> Integer__Order.__default.lte#canCall(x#0, y#0))
         && Integer__Order.__default.SetAllLte(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Integer__Order.__default.lte(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            true
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Integer__Order.__default.lte(x#0, y#0)));

// definition axiom for Integer__Order.__default.SetAllLte for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.SetAllLte(Lit(a#0), Lit(b#0)) } 
    Integer__Order.__default.SetAllLte#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#1: int, y#1: int :: 
          { Integer__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          Lit(b#0)[$Box(y#1)] ==> Integer__Order.__default.lte#canCall(x#1, y#1))
         && Integer__Order.__default.SetAllLte(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Integer__Order.__default.lte(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            true
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Integer__Order.__default.lte(x#1, y#1)));

// function declaration for Integer_Order._default.SetAllLt
function Integer__Order.__default.SetAllLt(a#0: Set Box, b#0: Set Box) : bool;

function Integer__Order.__default.SetAllLt#canCall(a#0: Set Box, b#0: Set Box) : bool;

// consequence axiom for Integer__Order.__default.SetAllLt
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLt(a#0, b#0) } 
    Integer__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> true);

function Integer__Order.__default.SetAllLt#requires(Set Box, Set Box) : bool;

// #requires axiom for Integer__Order.__default.SetAllLt
axiom (forall a#0: Set Box, b#0: Set Box :: 
  { Integer__Order.__default.SetAllLt#requires(a#0, b#0) } 
  $Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt))
     ==> Integer__Order.__default.SetAllLt#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.SetAllLt(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    { Integer__Order.__default.SetAllLt(a#0, b#0) } 
    Integer__Order.__default.SetAllLt#canCall(a#0, b#0)
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#0: int, y#0: int :: 
          { Integer__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
          b#0[$Box(y#0)] ==> Integer__Order.__default.lt#canCall(x#0, y#0))
         && Integer__Order.__default.SetAllLt(a#0, b#0)
           == (forall x#0: int, y#0: int :: 
            { Integer__Order.__default.lt(x#0, y#0) } { b#0[$Box(y#0)], a#0[$Box(x#0)] } 
            true
               ==> 
              a#0[$Box(x#0)] && b#0[$Box(y#0)]
               ==> Integer__Order.__default.lt(x#0, y#0)));

// definition axiom for Integer__Order.__default.SetAllLt for all literals(revealed)
axiom true
   ==> (forall a#0: Set Box, b#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.SetAllLt(Lit(a#0), Lit(b#0)) } 
    Integer__Order.__default.SetAllLt#canCall(Lit(a#0), Lit(b#0))
         || ($Is(a#0, TSet(TInt)) && $Is(b#0, TSet(TInt)))
       ==> (forall x#1: int, y#1: int :: 
          { Integer__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
          Lit(b#0)[$Box(y#1)] ==> Integer__Order.__default.lt#canCall(x#1, y#1))
         && Integer__Order.__default.SetAllLt(Lit(a#0), Lit(b#0))
           == (forall x#1: int, y#1: int :: 
            { Integer__Order.__default.lt(x#1, y#1) } { b#0[$Box(y#1)], a#0[$Box(x#1)] } 
            true
               ==> 
              Lit(a#0)[$Box(x#1)] && Lit(b#0)[$Box(y#1)]
               ==> Integer__Order.__default.lt(x#1, y#1)));

// function declaration for Integer_Order._default.NotMinimum
function Integer__Order.__default.NotMinimum($ly: LayerType, a#0: int) : bool;

function Integer__Order.__default.NotMinimum#canCall(a#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum($LS($ly), a#0) } 
  Integer__Order.__default.NotMinimum($LS($ly), a#0)
     == Integer__Order.__default.NotMinimum($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum(AsFuelBottom($ly), a#0) } 
  Integer__Order.__default.NotMinimum($ly, a#0)
     == Integer__Order.__default.NotMinimum($LZ, a#0));

// consequence axiom for Integer__Order.__default.NotMinimum
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Integer__Order.__default.NotMinimum($ly, a#0) } 
    true ==> true);

function Integer__Order.__default.NotMinimum#requires(LayerType, int) : bool;

// #requires axiom for Integer__Order.__default.NotMinimum
axiom (forall $ly: LayerType, a#0: int :: 
  { Integer__Order.__default.NotMinimum#requires($ly, a#0) } 
  Integer__Order.__default.NotMinimum#requires($ly, a#0) == true);

// definition axiom for Integer__Order.__default.NotMinimum(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    { Integer__Order.__default.NotMinimum($LS($ly), a#0) } 
    true
       ==> (forall b#0: int :: 
          { Integer__Order.__default.lt(b#0, a#0) } 
          Integer__Order.__default.lt#canCall(b#0, a#0))
         && Integer__Order.__default.NotMinimum($LS($ly), a#0)
           == (exists b#0: int :: 
            { Integer__Order.__default.lt(b#0, a#0) } 
            Integer__Order.__default.lt(b#0, a#0)));

// definition axiom for Integer__Order.__default.NotMinimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: int :: 
    {:weight 3} { Integer__Order.__default.NotMinimum($LS($ly), LitInt(a#0)) } 
    true
       ==> (forall b#1: int :: 
          { Integer__Order.__default.lt(b#1, a#0) } 
          Integer__Order.__default.lt#canCall(b#1, LitInt(a#0)))
         && Integer__Order.__default.NotMinimum($LS($ly), LitInt(a#0))
           == (exists b#1: int :: 
            { Integer__Order.__default.lt(b#1, a#0) } 
            Integer__Order.__default.lt(b#1, LitInt(a#0))));

// function declaration for Integer_Order._default.MapPivotedUnion
function Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : Map Box Box;

function Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box)
   : bool;

// consequence axiom for Integer__Order.__default.MapPivotedUnion
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> $Is(Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0), 
        TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)));

function Integer__Order.__default.MapPivotedUnion#requires(Ty, Map Box Box, int, Map Box Box) : bool;

// #requires axiom for Integer__Order.__default.MapPivotedUnion
axiom (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
    left#0: Map Box Box, 
    pivot#0: int, 
    right#0: Map Box Box :: 
  { Integer__Order.__default.MapPivotedUnion#requires(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
  $Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
       && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
     ==> Integer__Order.__default.MapPivotedUnion#requires(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
       == true);

// definition axiom for Integer__Order.__default.MapPivotedUnion(revealed)
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#0: int :: 
          { Integer__Order.__default.lt(k#0, pivot#0) } 
          Integer__Order.__default.lt#canCall(k#0, pivot#0))
         && Maps.__default.MapIRestrict#canCall(TInt, 
          Integer_Order._default.MapPivotedUnion$Value, 
          left#0, 
          (lambda $y#0: Box :: 
            $IsBox($y#0, TInt) && Integer__Order.__default.lt($Unbox($y#0): int, pivot#0)))
         && (var restricted_left#0 := Maps.__default.MapIRestrict(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              left#0, 
              (lambda $y#3: Box :: 
                $IsBox($y#3, TInt) && Integer__Order.__default.lt($Unbox($y#3): int, pivot#0))); 
          (forall k#1: int :: 
              { Integer__Order.__default.lte(pivot#0, k#1) } 
              Integer__Order.__default.lte#canCall(pivot#0, k#1))
             && Maps.__default.MapIRestrict#canCall(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              right#0, 
              (lambda $y#1: Box :: 
                $IsBox($y#1, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#1): int)))
             && (var restricted_right#0 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#2: Box :: 
                    $IsBox($y#2, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#2): int))); 
              Maps.__default.MapDisjointUnion#canCall(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                restricted_left#0, 
                restricted_right#0)))
         && Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, left#0, pivot#0, right#0)
           == (var restricted_left#0 := Maps.__default.MapIRestrict(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                left#0, 
                (lambda $y#4: Box :: 
                  $IsBox($y#4, TInt) && Integer__Order.__default.lt($Unbox($y#4): int, pivot#0))); 
            (var restricted_right#0 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  right#0, 
                  (lambda $y#5: Box :: 
                    $IsBox($y#5, TInt) && Integer__Order.__default.lte(pivot#0, $Unbox($y#5): int))); 
              Maps.__default.MapDisjointUnion(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#0, 
                restricted_right#0))));

// definition axiom for Integer__Order.__default.MapPivotedUnion for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.MapPivotedUnion$Value: Ty, 
      left#0: Map Box Box, 
      pivot#0: int, 
      right#0: Map Box Box :: 
    {:weight 3} { Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, 
        Lit(left#0), 
        LitInt(pivot#0), 
        Lit(right#0)) } 
    Integer__Order.__default.MapPivotedUnion#canCall(Integer_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          LitInt(pivot#0), 
          Lit(right#0))
         || ($Is(left#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value))
           && $Is(right#0, TMap(TInt, Integer_Order._default.MapPivotedUnion$Value)))
       ==> (forall k#2: int :: 
          { Integer__Order.__default.lt(k#2, pivot#0) } 
          Integer__Order.__default.lt#canCall(k#2, LitInt(pivot#0)))
         && Maps.__default.MapIRestrict#canCall(TInt, 
          Integer_Order._default.MapPivotedUnion$Value, 
          Lit(left#0), 
          (lambda $y#6: Box :: 
            $IsBox($y#6, TInt)
               && Integer__Order.__default.lt($Unbox($y#6): int, LitInt(pivot#0))))
         && (var restricted_left#1 := Maps.__default.MapIRestrict(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              Lit(left#0), 
              (lambda $y#9: Box :: 
                $IsBox($y#9, TInt)
                   && Integer__Order.__default.lt($Unbox($y#9): int, LitInt(pivot#0)))); 
          (forall k#3: int :: 
              { Integer__Order.__default.lte(pivot#0, k#3) } 
              Integer__Order.__default.lte#canCall(LitInt(pivot#0), k#3))
             && Maps.__default.MapIRestrict#canCall(TInt, 
              Integer_Order._default.MapPivotedUnion$Value, 
              Lit(right#0), 
              (lambda $y#7: Box :: 
                $IsBox($y#7, TInt)
                   && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#7): int)))
             && (var restricted_right#1 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#8: Box :: 
                    $IsBox($y#8, TInt)
                       && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#8): int))); 
              Maps.__default.MapDisjointUnion#canCall(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                restricted_left#1, 
                restricted_right#1)))
         && Integer__Order.__default.MapPivotedUnion(Integer_Order._default.MapPivotedUnion$Value, 
            Lit(left#0), 
            LitInt(pivot#0), 
            Lit(right#0))
           == (var restricted_left#1 := Maps.__default.MapIRestrict(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                Lit(left#0), 
                (lambda $y#10: Box :: 
                  $IsBox($y#10, TInt)
                     && Integer__Order.__default.lt($Unbox($y#10): int, LitInt(pivot#0)))); 
            (var restricted_right#1 := Maps.__default.MapIRestrict(TInt, 
                  Integer_Order._default.MapPivotedUnion$Value, 
                  Lit(right#0), 
                  (lambda $y#11: Box :: 
                    $IsBox($y#11, TInt)
                       && Integer__Order.__default.lte(LitInt(pivot#0), $Unbox($y#11): int))); 
              Maps.__default.MapDisjointUnion(TInt, 
                Integer_Order._default.MapPivotedUnion$Value, 
                StartFuel_Maps._default.MapDisjointUnion, 
                restricted_left#1, 
                restricted_right#1))));

// function declaration for Integer_Order._default.SetSuccessor
function Integer__Order.__default.SetSuccessor(m#0: Set Box, key#0: int) : DatatypeType;

function Integer__Order.__default.SetSuccessor#canCall(m#0: Set Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.SetSuccessor
axiom true
   ==> (forall m#0: Set Box, key#0: int :: 
    { Integer__Order.__default.SetSuccessor(m#0, key#0) } 
    Integer__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSet(TInt))
       ==> $Is(Integer__Order.__default.SetSuccessor(m#0, key#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.SetSuccessor#requires(Set Box, int) : bool;

// #requires axiom for Integer__Order.__default.SetSuccessor
axiom (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
  { Integer__Order.__default.SetSuccessor#requires(m#0, key#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(m#0, TSet(TInt))
     ==> Integer__Order.__default.SetSuccessor#requires(m#0, key#0) == true);

function $let#42_next(m: Set Box, key: int) : int;

function $let#42$canCall(m: Set Box, key: int) : bool;

axiom (forall m: Set Box, key: int :: 
  { $let#42_next(m, key) } 
  $let#42$canCall(m, key)
     ==> m[$Box($let#42_next(m, key))]
       && Integer__Order.__default.lt(key, $let#42_next(m, key))
       && (forall other#1: int :: 
        { Integer__Order.__default.lt($let#42_next(m, key), other#1) } 
          { Integer__Order.__default.lt(key, other#1) } 
          { m[$Box(other#1)] } 
        true
           ==> 
          m[$Box(other#1)]
             && other#1 != $let#42_next(m, key)
             && Integer__Order.__default.lt(key, other#1)
           ==> Integer__Order.__default.lt($let#42_next(m, key), other#1)));

// definition axiom for Integer__Order.__default.SetSuccessor(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    { Integer__Order.__default.SetSuccessor(m#0, key#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.SetSuccessor#canCall(m#0, key#0)
         || ($IsGoodHeap($Heap) && $Is(m#0, TSet(TInt)))
       ==> (forall next#0: int :: 
          { Integer__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
          (m#0[$Box(next#0)] ==> Integer__Order.__default.lt#canCall(key#0, next#0))
             && (Integer__Order.__default.lt#canCall(key#0, next#0)
                 && Integer__Order.__default.lt(key#0, next#0)
               ==> (forall other#0: int :: 
                { Integer__Order.__default.lt(next#0, other#0) } 
                  { Integer__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                (other#0 != next#0 ==> Integer__Order.__default.lt#canCall(key#0, other#0))
                   && (Integer__Order.__default.lt#canCall(key#0, other#0)
                       && Integer__Order.__default.lt(key#0, other#0)
                     ==> Integer__Order.__default.lt#canCall(next#0, other#0)))))
         && ((exists next#0: int :: 
            { Integer__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
            m#0[$Box(next#0)]
               && Integer__Order.__default.lt(key#0, next#0)
               && (forall other#0: int :: 
                { Integer__Order.__default.lt(next#0, other#0) } 
                  { Integer__Order.__default.lt(key#0, other#0) } 
                  { m#0[$Box(other#0)] } 
                true
                   ==> 
                  m#0[$Box(other#0)]
                     && other#0 != next#0
                     && Integer__Order.__default.lt(key#0, other#0)
                   ==> Integer__Order.__default.lt(next#0, other#0)))
           ==> $let#42$canCall(m#0, key#0))
         && Integer__Order.__default.SetSuccessor(m#0, key#0)
           == (if (exists next#0: int :: 
              { Integer__Order.__default.lt(key#0, next#0) } { m#0[$Box(next#0)] } 
              m#0[$Box(next#0)]
                 && Integer__Order.__default.lt(key#0, next#0)
                 && (forall other#0: int :: 
                  { Integer__Order.__default.lt(next#0, other#0) } 
                    { Integer__Order.__default.lt(key#0, other#0) } 
                    { m#0[$Box(other#0)] } 
                  true
                     ==> 
                    m#0[$Box(other#0)]
                       && other#0 != next#0
                       && Integer__Order.__default.lt(key#0, other#0)
                     ==> Integer__Order.__default.lt(next#0, other#0)))
             then (var next#1 := $let#42_next(m#0, key#0); #Options.Option.Some($Box(next#1)))
             else #Options.Option.None()));

// definition axiom for Integer__Order.__default.SetSuccessor for all literals(revealed)
axiom true
   ==> (forall $Heap: Heap, m#0: Set Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.SetSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || ($IsGoodHeap($Heap) && $Is(m#0, TSet(TInt)))
       ==> (forall next#2: int :: 
          { Integer__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
          (Lit(m#0)[$Box(next#2)]
               ==> Integer__Order.__default.lt#canCall(LitInt(key#0), next#2))
             && (Integer__Order.__default.lt#canCall(LitInt(key#0), next#2)
                 && Integer__Order.__default.lt(LitInt(key#0), next#2)
               ==> (forall other#2: int :: 
                { Integer__Order.__default.lt(next#2, other#2) } 
                  { Integer__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                (other#2 != next#2
                     ==> Integer__Order.__default.lt#canCall(LitInt(key#0), other#2))
                   && (Integer__Order.__default.lt#canCall(LitInt(key#0), other#2)
                       && Integer__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Integer__Order.__default.lt#canCall(next#2, other#2)))))
         && ((exists next#2: int :: 
            { Integer__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
            Lit(m#0)[$Box(next#2)]
               && Integer__Order.__default.lt(LitInt(key#0), next#2)
               && (forall other#2: int :: 
                { Integer__Order.__default.lt(next#2, other#2) } 
                  { Integer__Order.__default.lt(key#0, other#2) } 
                  { m#0[$Box(other#2)] } 
                true
                   ==> 
                  Lit(m#0)[$Box(other#2)]
                     && other#2 != next#2
                     && Integer__Order.__default.lt(LitInt(key#0), other#2)
                   ==> Integer__Order.__default.lt(next#2, other#2)))
           ==> $let#42$canCall(Lit(m#0), LitInt(key#0)))
         && Integer__Order.__default.SetSuccessor(Lit(m#0), LitInt(key#0))
           == (if (exists next#2: int :: 
              { Integer__Order.__default.lt(key#0, next#2) } { m#0[$Box(next#2)] } 
              Lit(m#0)[$Box(next#2)]
                 && Integer__Order.__default.lt(LitInt(key#0), next#2)
                 && (forall other#2: int :: 
                  { Integer__Order.__default.lt(next#2, other#2) } 
                    { Integer__Order.__default.lt(key#0, other#2) } 
                    { m#0[$Box(other#2)] } 
                  true
                     ==> 
                    Lit(m#0)[$Box(other#2)]
                       && other#2 != next#2
                       && Integer__Order.__default.lt(LitInt(key#0), other#2)
                     ==> Integer__Order.__default.lt(next#2, other#2)))
             then (var next#3 := $let#42_next(Lit(m#0), LitInt(key#0)); 
              #Options.Option.Some($Box(next#3)))
             else #Options.Option.None()));

// function declaration for Integer_Order._default.MapSuccessor
function Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int)
   : DatatypeType;

function Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.MapSuccessor
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, m#0, key#0)
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> $Is(Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0), 
        Tclass.Options.Option(TInt)));

function Integer__Order.__default.MapSuccessor#requires(Ty, Map Box Box, int) : bool;

// #requires axiom for Integer__Order.__default.MapSuccessor
axiom (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
  { Integer__Order.__default.MapSuccessor#requires(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
  $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
     ==> Integer__Order.__default.MapSuccessor#requires(Integer_Order._default.MapSuccessor$V, m#0, key#0)
       == true);

// definition axiom for Integer__Order.__default.MapSuccessor(revealed)
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, m#0, key#0)
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> Integer__Order.__default.SetSuccessor#canCall(Map#Domain(m#0), key#0)
         && Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, m#0, key#0)
           == Integer__Order.__default.SetSuccessor(Map#Domain(m#0), key#0));

// definition axiom for Integer__Order.__default.MapSuccessor for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.MapSuccessor$V: Ty, m#0: Map Box Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0)) } 
    Integer__Order.__default.MapSuccessor#canCall(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
         || $Is(m#0, TMap(TInt, Integer_Order._default.MapSuccessor$V))
       ==> Integer__Order.__default.SetSuccessor#canCall(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))
         && Integer__Order.__default.MapSuccessor(Integer_Order._default.MapSuccessor$V, Lit(m#0), LitInt(key#0))
           == Lit(Integer__Order.__default.SetSuccessor(Lit(Map#Domain(Lit(m#0))), LitInt(key#0))));

// function declaration for Integer_Order._default.SeqSuccessor
function Integer__Order.__default.SeqSuccessor(m#0: Seq Box, key#0: int) : DatatypeType;

function Integer__Order.__default.SeqSuccessor#canCall(m#0: Seq Box, key#0: int) : bool;

// consequence axiom for Integer__Order.__default.SeqSuccessor
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.SeqSuccessor(m#0, key#0) } 
    Integer__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSeq(TInt))
       ==> $Is(Integer__Order.__default.SeqSuccessor(m#0, key#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.SeqSuccessor#requires(Seq Box, int) : bool;

// #requires axiom for Integer__Order.__default.SeqSuccessor
axiom (forall m#0: Seq Box, key#0: int :: 
  { Integer__Order.__default.SeqSuccessor#requires(m#0, key#0) } 
  $Is(m#0, TSeq(TInt))
     ==> Integer__Order.__default.SeqSuccessor#requires(m#0, key#0) == true);

// definition axiom for Integer__Order.__default.SeqSuccessor(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    { Integer__Order.__default.SeqSuccessor(m#0, key#0) } 
    Integer__Order.__default.SeqSuccessor#canCall(m#0, key#0)
         || $Is(m#0, TSeq(TInt))
       ==> Integer__Order.__default.SetSuccessor#canCall((lambda $y#0: Box :: $IsBox($y#0, TInt) && Seq#Contains(m#0, $y#0)), key#0)
         && Integer__Order.__default.SeqSuccessor(m#0, key#0)
           == Integer__Order.__default.SetSuccessor((lambda $y#1: Box :: $IsBox($y#1, TInt) && Seq#Contains(m#0, $y#1)), key#0));

// definition axiom for Integer__Order.__default.SeqSuccessor for all literals(revealed)
axiom true
   ==> (forall m#0: Seq Box, key#0: int :: 
    {:weight 3} { Integer__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0)) } 
    Integer__Order.__default.SeqSuccessor#canCall(Lit(m#0), LitInt(key#0))
         || $Is(m#0, TSeq(TInt))
       ==> Integer__Order.__default.SetSuccessor#canCall((lambda $y#2: Box :: $IsBox($y#2, TInt) && Seq#Contains(m#0, $y#2)), 
          LitInt(key#0))
         && Integer__Order.__default.SeqSuccessor(Lit(m#0), LitInt(key#0))
           == Integer__Order.__default.SetSuccessor((lambda $y#3: Box :: $IsBox($y#3, TInt) && Seq#Contains(m#0, $y#3)), 
            LitInt(key#0)));

// function declaration for Integer_Order._default.SortedSeqForMap
function Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box)
   : bool;

function Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V: Ty, s#0: Seq Box, m#0: Map Box Box)
   : bool;

// layer synonym axiom
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
  Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
     == Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0));

// fuel synonym axiom
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, AsFuelBottom($ly), s#0, m#0) } 
  Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
     == Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LZ, s#0, m#0));

// consequence axiom for Integer__Order.__default.SortedSeqForMap
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> true);

function Integer__Order.__default.SortedSeqForMap#requires(Ty, LayerType, Seq Box, Map Box Box) : bool;

// #requires axiom for Integer__Order.__default.SortedSeqForMap
axiom (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
    $ly: LayerType, 
    s#0: Seq Box, 
    m#0: Map Box Box :: 
  { Integer__Order.__default.SortedSeqForMap#requires(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0) } 
  $Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
       && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V))
     ==> Integer__Order.__default.SortedSeqForMap#requires(Integer_Order._default.SortedSeqForMap$V, $ly, s#0, m#0)
       == true);

// definition axiom for Integer__Order.__default.SortedSeqForMap(revealed)
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, s#0, m#0)
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TInt, Integer_Order._default.SortedSeqForMap$V, s#0)
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TInt, 
            Integer_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            s#0))
         && Integer__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                Integer_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                s#0))): Seq Box)
         && (Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                  Integer_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  s#0))): Seq Box)
           ==> (forall i#0: int :: 
            { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
            (i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                 ==> 
                i#0 < Seq#Length(s#0)
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))))
         && ((forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              (i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                   ==> 
                  i#0 < Seq#Length(s#0)
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
           ==> (forall key#0: int :: 
            { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
            Map#Domain(m#0)[$Box(key#0)]
               ==> (forall i#1: int :: 
                { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                (i#1 < Seq#Length(s#0)
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                         == key#0
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(s#0, i#1)): DatatypeType)))))
         && Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), s#0, m#0)
           == (
            Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                    Integer_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    s#0))): Seq Box)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index(s#0, i#0)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)])
                   && (LitInt(0) <= i#0 && i#0 < Seq#Length(s#0)
                     ==> Map#Elements(m#0)[_System.Tuple2._0($Unbox(Seq#Index(s#0, i#0)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(s#0, i#0)): DatatypeType)))
             && (forall key#0: int :: 
              { Map#Elements(m#0)[$Box(key#0)] } { Map#Domain(m#0)[$Box(key#0)] } 
              true
                 ==> 
                Map#Domain(m#0)[$Box(key#0)]
                 ==> (exists i#1: int :: 
                  { $Unbox(Seq#Index(s#0, i#1)): DatatypeType } 
                  LitInt(0) <= i#1
                     && i#1 < Seq#Length(s#0)
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(s#0, i#1)): DatatypeType)): int
                       == key#0
                     && _System.Tuple2._1($Unbox(Seq#Index(s#0, i#1)): DatatypeType)
                       == Map#Elements(m#0)[$Box(key#0)]))));

// definition axiom for Integer__Order.__default.SortedSeqForMap for all literals(revealed)
axiom true
   ==> (forall Integer_Order._default.SortedSeqForMap$V: Ty, 
      $ly: LayerType, 
      s#0: Seq Box, 
      m#0: Map Box Box :: 
    {:weight 3} { Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0)) } 
    Integer__Order.__default.SortedSeqForMap#canCall(Integer_Order._default.SortedSeqForMap$V, Lit(s#0), Lit(m#0))
         || ($Is(s#0, TSeq(Tclass._System.Tuple2(TInt, Integer_Order._default.SortedSeqForMap$V)))
           && $Is(m#0, TMap(TInt, Integer_Order._default.SortedSeqForMap$V)))
       ==> Sequences.__default.Unzip#canCall(TInt, Integer_Order._default.SortedSeqForMap$V, Lit(s#0))
         && _System.Tuple2.___hMake2_q(Sequences.__default.Unzip(TInt, 
            Integer_Order._default.SortedSeqForMap$V, 
            StartFuel_Sequences._default.Unzip, 
            Lit(s#0)))
         && Integer__Order.__default.IsStrictlySorted#canCall($Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                Integer_Order._default.SortedSeqForMap$V, 
                StartFuel_Sequences._default.Unzip, 
                Lit(s#0)))): Seq Box)
         && (Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
            $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                  Integer_Order._default.SortedSeqForMap$V, 
                  StartFuel_Sequences._default.Unzip, 
                  Lit(s#0)))): Seq Box)
           ==> (forall i#2: int :: 
            { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
            (i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
               && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                 ==> 
                i#2 < Seq#Length(Lit(s#0))
                 ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                   && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))))
         && ((forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              (i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType))
                 && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                   ==> 
                  i#2 < Seq#Length(Lit(s#0))
                   ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)
                     && _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
           ==> (forall key#1: int :: 
            { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
            Map#Domain(m#0)[$Box(key#1)]
               ==> (forall i#3: int :: 
                { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                (i#3 < Seq#Length(Lit(s#0))
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType))
                   && (_System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                         == key#1
                     ==> _System.Tuple2.___hMake2_q($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)))))
         && Integer__Order.__default.SortedSeqForMap(Integer_Order._default.SortedSeqForMap$V, $LS($ly), Lit(s#0), Lit(m#0))
           == (
            Integer__Order.__default.IsStrictlySorted(StartFuel_Integer_Order._default.IsStrictlySorted, 
              $Unbox(_System.Tuple2._0(Sequences.__default.Unzip(TInt, 
                    Integer_Order._default.SortedSeqForMap$V, 
                    StartFuel_Sequences._default.Unzip, 
                    Lit(s#0)))): Seq Box)
             && (forall i#2: int :: 
              { $Unbox(Seq#Index(s#0, i#2)): DatatypeType } 
              true
                 ==> (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Domain(m#0)[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)])
                   && (LitInt(0) <= i#2 && i#2 < Seq#Length(Lit(s#0))
                     ==> Map#Elements(Lit(m#0))[_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)]
                       == _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#2)): DatatypeType)))
             && (forall key#1: int :: 
              { Map#Elements(m#0)[$Box(key#1)] } { Map#Domain(m#0)[$Box(key#1)] } 
              true
                 ==> 
                Map#Domain(m#0)[$Box(key#1)]
                 ==> (exists i#3: int :: 
                  { $Unbox(Seq#Index(s#0, i#3)): DatatypeType } 
                  LitInt(0) <= i#3
                     && i#3 < Seq#Length(Lit(s#0))
                     && $Unbox(_System.Tuple2._0($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)): int
                       == key#1
                     && _System.Tuple2._1($Unbox(Seq#Index(Lit(s#0), i#3)): DatatypeType)
                       == Map#Elements(Lit(m#0))[$Box(key#1)]))));

// function declaration for Integer_Order._default.minimum
function Integer__Order.__default.minimum($ly: LayerType, s#0: Set Box) : int;

function Integer__Order.__default.minimum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimum($LS($ly), s#0) } 
  Integer__Order.__default.minimum($LS($ly), s#0)
     == Integer__Order.__default.minimum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimum(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.minimum($ly, s#0)
     == Integer__Order.__default.minimum($LZ, s#0));

// consequence axiom for Integer__Order.__default.minimum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimum($ly, s#0) } 
    Integer__Order.__default.minimum#canCall(s#0)
         || ($Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Integer__Order.__default.minimum($ly, s#0))]
         && (forall y#0: int :: 
          { Integer__Order.__default.lte(Integer__Order.__default.minimum($ly, s#0), y#0) } 
            { s#0[$Box(y#0)] } 
          s#0[$Box(y#0)]
             ==> Integer__Order.__default.lte(Integer__Order.__default.minimum($ly, s#0), y#0)));

function Integer__Order.__default.minimum#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.minimum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Integer__Order.__default.minimum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.minimum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#45_a(s: Set Box) : int;

function $let#45$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#45_a(s) } 
  $let#45$canCall(s) ==> s[$Box($let#45_a(s))]);

// definition axiom for Integer__Order.__default.minimum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Integer__Order.__default.minimum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.minimum#canCall(s#0)
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> $let#45$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#45_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Integer__Order.__default.minimum#canCall(s'#0)
               && (var m'#0 := Integer__Order.__default.minimum($ly, s'#0); 
                Integer__Order.__default.lt#canCall($let#45_a(s#0), m'#0)))
         && Integer__Order.__default.minimum($LS($ly), s#0)
           == (var a#0 := $let#45_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Integer__Order.__default.minimum($ly, s'#1); 
                  (if Integer__Order.__default.lt(a#0, m'#1) then a#0 else m'#1))))));

// definition axiom for Integer__Order.__default.minimum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.minimum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.minimum#canCall(Lit(s#0))
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#45$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#45_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Integer__Order.__default.minimum#canCall(s'#2)
               && (var m'#2 := Integer__Order.__default.minimum($LS($ly), s'#2); 
                Integer__Order.__default.lt#canCall($let#45_a(Lit(s#0)), m'#2)))
         && Integer__Order.__default.minimum($LS($ly), Lit(s#0))
           == (var a#1 := $let#45_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Integer__Order.__default.minimum($LS($ly), s'#3); 
                  (if Integer__Order.__default.lt(a#1, m'#3) then a#1 else m'#3))))));

// function declaration for Integer_Order._default.minimumOpt
function Integer__Order.__default.minimumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Integer__Order.__default.minimumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt($LS($ly), s#0) } 
  Integer__Order.__default.minimumOpt($LS($ly), s#0)
     == Integer__Order.__default.minimumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.minimumOpt($ly, s#0)
     == Integer__Order.__default.minimumOpt($LZ, s#0));

// consequence axiom for Integer__Order.__default.minimumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimumOpt($ly, s#0) } 
    Integer__Order.__default.minimumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (Options.Option.Some_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))])
         && (Options.Option.Some_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Integer__Order.__default.lte($Unbox(Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0) } 
              { s#0[$Box(y#0)] } 
            s#0[$Box(y#0)]
               ==> Integer__Order.__default.lte($Unbox(Options.Option.value(Integer__Order.__default.minimumOpt($ly, s#0))): int, 
                y#0)))
         && (Options.Option.None_q(Integer__Order.__default.minimumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Integer__Order.__default.minimumOpt($ly, s#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.minimumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.minimumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.minimumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.minimumOpt#requires($ly, s#0) == true);

// definition axiom for Integer__Order.__default.minimumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.minimumOpt($LS($ly), s#0) } 
    Integer__Order.__default.minimumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.minimum#canCall(s#0))
         && Integer__Order.__default.minimumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.minimum(StartFuel_Integer_Order._default.minimum, s#0)))));

// definition axiom for Integer__Order.__default.minimumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.minimumOpt($LS($ly), Lit(s#0)) } 
    Integer__Order.__default.minimumOpt#canCall(Lit(s#0)) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.minimum#canCall(Lit(s#0)))
         && Integer__Order.__default.minimumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.minimum(StartFuel_Integer_Order._default.minimum, Lit(s#0))))));

// function declaration for Integer_Order._default.maximum
function Integer__Order.__default.maximum($ly: LayerType, s#0: Set Box) : int;

function Integer__Order.__default.maximum#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximum($LS($ly), s#0) } 
  Integer__Order.__default.maximum($LS($ly), s#0)
     == Integer__Order.__default.maximum($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximum(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.maximum($ly, s#0)
     == Integer__Order.__default.maximum($LZ, s#0));

// consequence axiom for Integer__Order.__default.maximum
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximum($ly, s#0) } 
    Integer__Order.__default.maximum#canCall(s#0)
         || ($Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> s#0[$Box(Integer__Order.__default.maximum($ly, s#0))]
         && (forall y#0: int :: 
          { Integer__Order.__default.lte(y#0, Integer__Order.__default.maximum($ly, s#0)) } 
            { s#0[$Box(y#0)] } 
          s#0[$Box(y#0)]
             ==> Integer__Order.__default.lte(y#0, Integer__Order.__default.maximum($ly, s#0))));

function Integer__Order.__default.maximum#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.maximum
axiom (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
  { Integer__Order.__default.maximum#requires($ly, s#0), $IsGoodHeap($Heap) } 
  $IsGoodHeap($Heap) && $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.maximum#requires($ly, s#0)
       == (Set#Card(s#0) >= LitInt(1)));

function $let#48_a(s: Set Box) : int;

function $let#48$canCall(s: Set Box) : bool;

axiom (forall s: Set Box :: 
  { $let#48_a(s) } 
  $let#48$canCall(s) ==> s[$Box($let#48_a(s))]);

// definition axiom for Integer__Order.__default.maximum(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    { Integer__Order.__default.maximum($LS($ly), s#0), $IsGoodHeap($Heap) } 
    Integer__Order.__default.maximum#canCall(s#0)
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(s#0) >= LitInt(1))
       ==> $let#48$canCall(s#0)
         && (var s'#0 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#48_a(s#0)))); 
          !Set#Equal(s'#0, Set#Empty(): Set Box)
             ==> Integer__Order.__default.maximum#canCall(s'#0)
               && (var m'#0 := Integer__Order.__default.maximum($ly, s'#0); 
                Integer__Order.__default.lt#canCall(m'#0, $let#48_a(s#0))))
         && Integer__Order.__default.maximum($LS($ly), s#0)
           == (var a#0 := $let#48_a(s#0); 
            (var s'#1 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#0))); 
              (if Set#Equal(s'#1, Set#Empty(): Set Box)
                 then a#0
                 else (var m'#1 := Integer__Order.__default.maximum($ly, s'#1); 
                  (if Integer__Order.__default.lt(m'#1, a#0) then a#0 else m'#1))))));

// definition axiom for Integer__Order.__default.maximum for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, $Heap: Heap, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.maximum($LS($ly), Lit(s#0)), $IsGoodHeap($Heap) } 
    Integer__Order.__default.maximum#canCall(Lit(s#0))
         || ($IsGoodHeap($Heap) && $Is(s#0, TSet(TInt)) && Set#Card(Lit(s#0)) >= LitInt(1))
       ==> $let#48$canCall(Lit(s#0))
         && (var s'#2 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box($let#48_a(Lit(s#0))))); 
          !Set#Equal(s'#2, Set#Empty(): Set Box)
             ==> Integer__Order.__default.maximum#canCall(s'#2)
               && (var m'#2 := Integer__Order.__default.maximum($LS($ly), s'#2); 
                Integer__Order.__default.lt#canCall(m'#2, $let#48_a(Lit(s#0)))))
         && Integer__Order.__default.maximum($LS($ly), Lit(s#0))
           == (var a#1 := $let#48_a(Lit(s#0)); 
            (var s'#3 := Set#Difference(s#0, Set#UnionOne(Set#Empty(): Set Box, $Box(a#1))); 
              (if Set#Equal(s'#3, Set#Empty(): Set Box)
                 then a#1
                 else (var m'#3 := Integer__Order.__default.maximum($LS($ly), s'#3); 
                  (if Integer__Order.__default.lt(m'#3, a#1) then a#1 else m'#3))))));

// function declaration for Integer_Order._default.maximumOpt
function Integer__Order.__default.maximumOpt($ly: LayerType, s#0: Set Box) : DatatypeType;

function Integer__Order.__default.maximumOpt#canCall(s#0: Set Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt($LS($ly), s#0) } 
  Integer__Order.__default.maximumOpt($LS($ly), s#0)
     == Integer__Order.__default.maximumOpt($ly, s#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt(AsFuelBottom($ly), s#0) } 
  Integer__Order.__default.maximumOpt($ly, s#0)
     == Integer__Order.__default.maximumOpt($LZ, s#0));

// consequence axiom for Integer__Order.__default.maximumOpt
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximumOpt($ly, s#0) } 
    Integer__Order.__default.maximumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (Options.Option.Some_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> s#0[Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))])
         && (Options.Option.Some_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> (forall y#0: int :: 
            { Integer__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))): int) } 
              { s#0[$Box(y#0)] } 
            s#0[$Box(y#0)]
               ==> Integer__Order.__default.lte(y#0, 
                $Unbox(Options.Option.value(Integer__Order.__default.maximumOpt($ly, s#0))): int)))
         && (Options.Option.None_q(Integer__Order.__default.maximumOpt($ly, s#0))
           ==> Set#Equal(s#0, Set#Empty(): Set Box))
         && $Is(Integer__Order.__default.maximumOpt($ly, s#0), Tclass.Options.Option(TInt)));

function Integer__Order.__default.maximumOpt#requires(LayerType, Set Box) : bool;

// #requires axiom for Integer__Order.__default.maximumOpt
axiom (forall $ly: LayerType, s#0: Set Box :: 
  { Integer__Order.__default.maximumOpt#requires($ly, s#0) } 
  $Is(s#0, TSet(TInt))
     ==> Integer__Order.__default.maximumOpt#requires($ly, s#0) == true);

// definition axiom for Integer__Order.__default.maximumOpt(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    { Integer__Order.__default.maximumOpt($LS($ly), s#0) } 
    Integer__Order.__default.maximumOpt#canCall(s#0) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.maximum#canCall(s#0))
         && Integer__Order.__default.maximumOpt($LS($ly), s#0)
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.maximum(StartFuel_Integer_Order._default.maximum, s#0)))));

// definition axiom for Integer__Order.__default.maximumOpt for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, s#0: Set Box :: 
    {:weight 3} { Integer__Order.__default.maximumOpt($LS($ly), Lit(s#0)) } 
    Integer__Order.__default.maximumOpt#canCall(Lit(s#0)) || $Is(s#0, TSet(TInt))
       ==> (!Set#Equal(s#0, Set#Empty(): Set Box)
           ==> Integer__Order.__default.maximum#canCall(Lit(s#0)))
         && Integer__Order.__default.maximumOpt($LS($ly), Lit(s#0))
           == (if Set#Equal(s#0, Set#Empty(): Set Box)
             then #Options.Option.None()
             else #Options.Option.Some($Box(Integer__Order.__default.maximum(StartFuel_Integer_Order._default.maximum, Lit(s#0))))));

// function declaration for Integer_Order._default.lt
function Integer__Order.__default.lt(a#0: int, b#0: int) : bool;

function Integer__Order.__default.lt#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.lt
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lt(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.lt#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.lt
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.lt#requires(a#0, b#0) } 
  Integer__Order.__default.lt#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.lt(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.lt(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.lt(a#0, b#0)
           == (Integer__Order.__default.lte(a#0, b#0) && a#0 != b#0));

// definition axiom for Integer__Order.__default.lt for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.lt(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.lt(LitInt(a#0), LitInt(b#0))
           == Lit(Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) && a#0 != b#0));

// function declaration for Integer_Order._default.Min
function Integer__Order.__default.Min(a#0: int, b#0: int) : int;

function Integer__Order.__default.Min#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.Min
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Min(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.Min#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.Min
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.Min#requires(a#0, b#0) } 
  Integer__Order.__default.Min#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.Min(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Min(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.Min(a#0, b#0)
           == (if Integer__Order.__default.lte(a#0, b#0) then a#0 else b#0));

// definition axiom for Integer__Order.__default.Min for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.Min(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.Min(LitInt(a#0), LitInt(b#0))
           == (if Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then a#0 else b#0));

// function declaration for Integer_Order._default.Max
function Integer__Order.__default.Max(a#0: int, b#0: int) : int;

function Integer__Order.__default.Max#canCall(a#0: int, b#0: int) : bool;

// consequence axiom for Integer__Order.__default.Max
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Max(a#0, b#0) } 
    true ==> true);

function Integer__Order.__default.Max#requires(int, int) : bool;

// #requires axiom for Integer__Order.__default.Max
axiom (forall a#0: int, b#0: int :: 
  { Integer__Order.__default.Max#requires(a#0, b#0) } 
  Integer__Order.__default.Max#requires(a#0, b#0) == true);

// definition axiom for Integer__Order.__default.Max(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    { Integer__Order.__default.Max(a#0, b#0) } 
    true
       ==> Integer__Order.__default.lte#canCall(a#0, b#0)
         && Integer__Order.__default.Max(a#0, b#0)
           == (if Integer__Order.__default.lte(a#0, b#0) then b#0 else a#0));

// definition axiom for Integer__Order.__default.Max for all literals(revealed)
axiom true
   ==> (forall a#0: int, b#0: int :: 
    {:weight 3} { Integer__Order.__default.Max(LitInt(a#0), LitInt(b#0)) } 
    true
       ==> Integer__Order.__default.lte#canCall(LitInt(a#0), LitInt(b#0))
         && Integer__Order.__default.Max(LitInt(a#0), LitInt(b#0))
           == (if Integer__Order.__default.lte(LitInt(a#0), LitInt(b#0)) then b#0 else a#0));

// function declaration for Integer_Order._default.IsSorted
function Integer__Order.__default.IsSorted($ly: LayerType, run#0: Seq Box) : bool;

function Integer__Order.__default.IsSorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted($LS($ly), run#0) } 
  Integer__Order.__default.IsSorted($LS($ly), run#0)
     == Integer__Order.__default.IsSorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted(AsFuelBottom($ly), run#0) } 
  Integer__Order.__default.IsSorted($ly, run#0)
     == Integer__Order.__default.IsSorted($LZ, run#0));

// consequence axiom for Integer__Order.__default.IsSorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsSorted($ly, run#0) } 
    Integer__Order.__default.IsSorted#canCall(run#0) || $Is(run#0, TSeq(TInt))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Integer__Order.__default.IsSorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Integer__Order.__default.IsSorted($ly, run#0)));

function Integer__Order.__default.IsSorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsSorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsSorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsSorted#requires($ly, run#0) == true);

// definition axiom for Integer__Order.__default.IsSorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsSorted($LS($ly), run#0) } 
    Integer__Order.__default.IsSorted#canCall(run#0) || $Is(run#0, TSeq(TInt))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Integer__Order.__default.lte#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Integer__Order.__default.IsSorted($LS($ly), run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 <= j#0 && j#0 < Seq#Length(run#0)
               ==> Integer__Order.__default.lte($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Integer__Order.__default.IsSorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsSorted($LS($ly), Lit(run#0)) } 
    Integer__Order.__default.IsSorted#canCall(Lit(run#0)) || $Is(run#0, TSeq(TInt))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Integer__Order.__default.lte#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Integer__Order.__default.IsSorted($LS($ly), Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 <= j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Integer__Order.__default.lte($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Integer_Order._default.IsStrictlySortedInternal
function Integer__Order.__default.IsStrictlySortedInternal(run#0: Seq Box) : bool;

function Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0: Seq Box) : bool;

// consequence axiom for Integer__Order.__default.IsStrictlySortedInternal
axiom true
   ==> (forall run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySortedInternal(run#0) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> true);

function Integer__Order.__default.IsStrictlySortedInternal#requires(Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsStrictlySortedInternal
axiom (forall run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySortedInternal#requires(run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsStrictlySortedInternal#requires(run#0) == true);

// definition axiom for Integer__Order.__default.IsStrictlySortedInternal(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySortedInternal(run#0) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> (forall i#0: int, j#0: int :: 
          { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
          j#0 < Seq#Length(run#0)
             ==> Integer__Order.__default.lt#canCall($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int))
         && Integer__Order.__default.IsStrictlySortedInternal(run#0)
           == (forall i#0: int, j#0: int :: 
            { $Unbox(Seq#Index(run#0, j#0)): int, $Unbox(Seq#Index(run#0, i#0)): int } 
            true
               ==> 
              LitInt(0) <= i#0 && i#0 < j#0 && j#0 < Seq#Length(run#0)
               ==> Integer__Order.__default.lt($Unbox(Seq#Index(run#0, i#0)): int, $Unbox(Seq#Index(run#0, j#0)): int)));

// definition axiom for Integer__Order.__default.IsStrictlySortedInternal for all literals(revealed)
axiom true
   ==> (forall run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0)) } 
    Integer__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TInt))
       ==> (forall i#1: int, j#1: int :: 
          { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
          j#1 < Seq#Length(Lit(run#0))
             ==> Integer__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int))
         && Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0))
           == (forall i#1: int, j#1: int :: 
            { $Unbox(Seq#Index(run#0, j#1)): int, $Unbox(Seq#Index(run#0, i#1)): int } 
            true
               ==> 
              LitInt(0) <= i#1 && i#1 < j#1 && j#1 < Seq#Length(Lit(run#0))
               ==> Integer__Order.__default.lt($Unbox(Seq#Index(Lit(run#0), i#1)): int, $Unbox(Seq#Index(Lit(run#0), j#1)): int)));

// function declaration for Integer_Order._default.IsStrictlySorted
function Integer__Order.__default.IsStrictlySorted($ly: LayerType, run#0: Seq Box) : bool;

function Integer__Order.__default.IsStrictlySorted#canCall(run#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
  Integer__Order.__default.IsStrictlySorted($LS($ly), run#0)
     == Integer__Order.__default.IsStrictlySorted($ly, run#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted(AsFuelBottom($ly), run#0) } 
  Integer__Order.__default.IsStrictlySorted($ly, run#0)
     == Integer__Order.__default.IsStrictlySorted($LZ, run#0));

// consequence axiom for Integer__Order.__default.IsStrictlySorted
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySorted($ly, run#0) } 
    Integer__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> (Seq#Length(run#0) == LitInt(0)
           ==> Integer__Order.__default.IsStrictlySorted($ly, run#0))
         && (Seq#Length(run#0) == LitInt(1)
           ==> Integer__Order.__default.IsStrictlySorted($ly, run#0))
         && (Integer__Order.__default.IsStrictlySorted($ly, run#0)
           ==> Integer__Order.__default.IsSorted(StartFuel_Integer_Order._default.IsSorted, run#0)));

function Integer__Order.__default.IsStrictlySorted#requires(LayerType, Seq Box) : bool;

// #requires axiom for Integer__Order.__default.IsStrictlySorted
axiom (forall $ly: LayerType, run#0: Seq Box :: 
  { Integer__Order.__default.IsStrictlySorted#requires($ly, run#0) } 
  $Is(run#0, TSeq(TInt))
     ==> Integer__Order.__default.IsStrictlySorted#requires($ly, run#0) == true);

// definition axiom for Integer__Order.__default.IsStrictlySorted(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    { Integer__Order.__default.IsStrictlySorted($LS($ly), run#0) } 
    Integer__Order.__default.IsStrictlySorted#canCall(run#0)
         || $Is(run#0, TSeq(TInt))
       ==> Integer__Order.__default.IsStrictlySortedInternal#canCall(run#0)
         && Integer__Order.__default.IsStrictlySorted($LS($ly), run#0)
           == (var b#0 := Integer__Order.__default.IsStrictlySortedInternal(run#0); 
            (if b#0 then b#0 else b#0)));

// definition axiom for Integer__Order.__default.IsStrictlySorted for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, run#0: Seq Box :: 
    {:weight 3} { Integer__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0)) } 
    Integer__Order.__default.IsStrictlySorted#canCall(Lit(run#0))
         || $Is(run#0, TSeq(TInt))
       ==> Integer__Order.__default.IsStrictlySortedInternal#canCall(Lit(run#0))
         && Integer__Order.__default.IsStrictlySorted($LS($ly), Lit(run#0))
           == (var b#1 := Lit(Integer__Order.__default.IsStrictlySortedInternal(Lit(run#0))); 
            (if b#1 then b#1 else b#1)));

// Constructor function declaration
function #PackedKV.Pkv.Pkv(DatatypeType, DatatypeType) : DatatypeType;

const unique ##PackedKV.Pkv.Pkv: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#0#0#0, a#0#1#0) } 
  DatatypeCtorId(#PackedKV.Pkv.Pkv(a#0#0#0, a#0#1#0)) == ##PackedKV.Pkv.Pkv);

function PackedKV.Pkv.Pkv_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { PackedKV.Pkv.Pkv_q(d) } 
  PackedKV.Pkv.Pkv_q(d) <==> DatatypeCtorId(d) == ##PackedKV.Pkv.Pkv);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { PackedKV.Pkv.Pkv_q(d) } 
  PackedKV.Pkv.Pkv_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: DatatypeType :: 
      d == #PackedKV.Pkv.Pkv(a#1#0#0, a#1#1#0)));

function Tclass.PackedKV.Pkv() : Ty;

// Tclass.PackedKV.Pkv Tag
axiom Tag(Tclass.PackedKV.Pkv()) == Tagclass.PackedKV.Pkv;

const unique Tagclass.PackedKV.Pkv: TyTag;

// Box/unbox axiom for Tclass.PackedKV.Pkv
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedKV.Pkv()) } 
  $IsBox(bx, Tclass.PackedKV.Pkv())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.PackedKV.Pkv()));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: DatatypeType :: 
  { $Is(#PackedKV.Pkv.Pkv(a#2#0#0, a#2#1#0), Tclass.PackedKV.Pkv()) } 
  $Is(#PackedKV.Pkv.Pkv(a#2#0#0, a#2#1#0), Tclass.PackedKV.Pkv())
     <==> $Is(a#2#0#0, Tclass.PackedStringArray.Psa())
       && $Is(a#2#1#0, Tclass.PackedStringArray.Psa()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: DatatypeType, $h: Heap :: 
  { $IsAlloc(#PackedKV.Pkv.Pkv(a#3#0#0, a#3#1#0), Tclass.PackedKV.Pkv(), $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#PackedKV.Pkv.Pkv(a#3#0#0, a#3#1#0), Tclass.PackedKV.Pkv(), $h)
       <==> $IsAlloc(a#3#0#0, Tclass.PackedStringArray.Psa(), $h)
         && $IsAlloc(a#3#1#0, Tclass.PackedStringArray.Psa(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedKV.Pkv.keys(d), Tclass.PackedStringArray.Psa(), $h) } 
  $IsGoodHeap($h)
       && 
      PackedKV.Pkv.Pkv_q(d)
       && $IsAlloc(d, Tclass.PackedKV.Pkv(), $h)
     ==> $IsAlloc(PackedKV.Pkv.keys(d), Tclass.PackedStringArray.Psa(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(PackedKV.Pkv.messages(d), Tclass.PackedStringArray.Psa(), $h) } 
  $IsGoodHeap($h)
       && 
      PackedKV.Pkv.Pkv_q(d)
       && $IsAlloc(d, Tclass.PackedKV.Pkv(), $h)
     ==> $IsAlloc(PackedKV.Pkv.messages(d), Tclass.PackedStringArray.Psa(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(Lit(a#4#0#0), Lit(a#4#1#0)) } 
  #PackedKV.Pkv.Pkv(Lit(a#4#0#0), Lit(a#4#1#0))
     == Lit(#PackedKV.Pkv.Pkv(a#4#0#0, a#4#1#0)));

function PackedKV.Pkv.keys(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#5#0#0, a#5#1#0) } 
  PackedKV.Pkv.keys(#PackedKV.Pkv.Pkv(a#5#0#0, a#5#1#0)) == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#6#0#0, a#6#1#0) } 
  DtRank(a#6#0#0) < DtRank(#PackedKV.Pkv.Pkv(a#6#0#0, a#6#1#0)));

function PackedKV.Pkv.messages(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#7#0#0, a#7#1#0) } 
  PackedKV.Pkv.messages(#PackedKV.Pkv.Pkv(a#7#0#0, a#7#1#0)) == a#7#1#0);

// Inductive rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: DatatypeType :: 
  { #PackedKV.Pkv.Pkv(a#8#0#0, a#8#1#0) } 
  DtRank(a#8#1#0) < DtRank(#PackedKV.Pkv.Pkv(a#8#0#0, a#8#1#0)));

// Depth-one case-split function
function $IsA#PackedKV.Pkv(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#PackedKV.Pkv(d) } 
  $IsA#PackedKV.Pkv(d) ==> PackedKV.Pkv.Pkv_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { PackedKV.Pkv.Pkv_q(d), $Is(d, Tclass.PackedKV.Pkv()) } 
  $Is(d, Tclass.PackedKV.Pkv()) ==> PackedKV.Pkv.Pkv_q(d));

// Datatype extensional equality declaration
function PackedKV.Pkv#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #PackedKV.Pkv.Pkv
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedKV.Pkv#Equal(a, b) } 
  true
     ==> (PackedKV.Pkv#Equal(a, b)
       <==> PackedStringArray.Psa#Equal(PackedKV.Pkv.keys(a), PackedKV.Pkv.keys(b))
         && PackedStringArray.Psa#Equal(PackedKV.Pkv.messages(a), PackedKV.Pkv.messages(b))));

// Datatype extensionality axiom: PackedKV.Pkv
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { PackedKV.Pkv#Equal(a, b) } 
  PackedKV.Pkv#Equal(a, b) <==> a == b);

const unique class.PackedKV.Pkv: ClassName;

const unique class.PackedKV.__default: ClassName;

function Tclass.PackedKV.__default() : Ty;

// Tclass.PackedKV.__default Tag
axiom Tag(Tclass.PackedKV.__default()) == Tagclass.PackedKV.__default;

const unique Tagclass.PackedKV.__default: TyTag;

// Box/unbox axiom for Tclass.PackedKV.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedKV.__default()) } 
  $IsBox(bx, Tclass.PackedKV.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.PackedKV.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedKV.__default()) } 
  $Is($o, Tclass.PackedKV.__default())
     <==> $o == null || dtype($o) == Tclass.PackedKV.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedKV.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedKV.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedKV._default.ValidKeyByteString
function PackedKV.__default.ValidKeyByteString(s#0: Seq Box) : bool;

function PackedKV.__default.ValidKeyByteString#canCall(s#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.ValidKeyByteString
axiom true
   ==> (forall s#0: Seq Box :: 
    { PackedKV.__default.ValidKeyByteString(s#0) } 
    PackedKV.__default.ValidKeyByteString#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> true);

function PackedKV.__default.ValidKeyByteString#requires(Seq Box) : bool;

// #requires axiom for PackedKV.__default.ValidKeyByteString
axiom (forall s#0: Seq Box :: 
  { PackedKV.__default.ValidKeyByteString#requires(s#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedKV.__default.ValidKeyByteString#requires(s#0) == true);

// definition axiom for PackedKV.__default.ValidKeyByteString(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    { PackedKV.__default.ValidKeyByteString(s#0) } 
    PackedKV.__default.ValidKeyByteString#canCall(s#0)
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidKeyByteString(s#0)
           == (Seq#Length(s#0) <= LitInt(KeyType.__default.MaxLen())));

// definition axiom for PackedKV.__default.ValidKeyByteString for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.ValidKeyByteString(Lit(s#0)) } 
    PackedKV.__default.ValidKeyByteString#canCall(Lit(s#0))
         || $Is(s#0, TSeq(Tclass.NativeTypes.byte()))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidKeyByteString(Lit(s#0))
           == (Seq#Length(Lit(s#0)) <= LitInt(KeyType.__default.MaxLen())));

// function declaration for PackedKV._default.ValidStringLens
function PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int)
   : bool;

function PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int)
   : bool;

// consequence axiom for PackedKV.__default.ValidStringLens
axiom true
   ==> (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
    { PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0) } 
    PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
         || ($Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
           && LitInt(0) <= upper_bound#0)
       ==> true);

function PackedKV.__default.ValidStringLens#requires(Ty, Seq Box, int) : bool;

// #requires axiom for PackedKV.__default.ValidStringLens
axiom (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
  { PackedKV.__default.ValidStringLens#requires(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0) } 
  $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
       && LitInt(0) <= upper_bound#0
     ==> PackedKV.__default.ValidStringLens#requires(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
       == true);

// definition axiom for PackedKV.__default.ValidStringLens(revealed)
axiom true
   ==> (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
    { PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0) } 
    PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
         || ($Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
           && LitInt(0) <= upper_bound#0)
       ==> PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, strs#0, upper_bound#0)
         == (forall i#0: int :: 
          { $Unbox(Seq#Index(strs#0, i#0)): Seq Box } 
          LitInt(0) <= i#0 && i#0 < Seq#Length(strs#0)
             ==> Seq#Length($Unbox(Seq#Index(strs#0, i#0)): Seq Box) <= upper_bound#0));

// definition axiom for PackedKV.__default.ValidStringLens for all literals(revealed)
axiom true
   ==> (forall PackedKV._default.ValidStringLens$A: Ty, strs#0: Seq Box, upper_bound#0: int :: 
    {:weight 3} { PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, Lit(strs#0), LitInt(upper_bound#0)) } 
    PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidStringLens$A, Lit(strs#0), LitInt(upper_bound#0))
         || ($Is(strs#0, TSeq(TSeq(PackedKV._default.ValidStringLens$A)))
           && LitInt(0) <= upper_bound#0)
       ==> PackedKV.__default.ValidStringLens(PackedKV._default.ValidStringLens$A, Lit(strs#0), LitInt(upper_bound#0))
         == (forall i#1: int :: 
          { $Unbox(Seq#Index(strs#0, i#1)): Seq Box } 
          LitInt(0) <= i#1 && i#1 < Seq#Length(Lit(strs#0))
             ==> Seq#Length($Unbox(Seq#Index(Lit(strs#0), i#1)): Seq Box)
               <= LitInt(upper_bound#0)));

// function declaration for PackedKV._default.ValidKeyLens
function PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box) : bool;

function PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.ValidKeyLens
axiom true
   ==> (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
    { PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, strs#0) } 
    PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A, strs#0)
         || $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
       ==> true);

function PackedKV.__default.ValidKeyLens#requires(Ty, Seq Box) : bool;

// #requires axiom for PackedKV.__default.ValidKeyLens
axiom (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
  { PackedKV.__default.ValidKeyLens#requires(PackedKV._default.ValidKeyLens$A, strs#0) } 
  $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
     ==> PackedKV.__default.ValidKeyLens#requires(PackedKV._default.ValidKeyLens$A, strs#0)
       == true);

// definition axiom for PackedKV.__default.ValidKeyLens(revealed)
axiom true
   ==> (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
    { PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, strs#0) } 
    PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A, strs#0)
         || $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidKeyLens$A, strs#0, LitInt(KeyType.__default.MaxLen()))
         && PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, strs#0)
           == PackedKV.__default.ValidStringLens(PackedKV._default.ValidKeyLens$A, strs#0, LitInt(KeyType.__default.MaxLen())));

// definition axiom for PackedKV.__default.ValidKeyLens for all literals(revealed)
axiom true
   ==> (forall PackedKV._default.ValidKeyLens$A: Ty, strs#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, Lit(strs#0)) } 
    PackedKV.__default.ValidKeyLens#canCall(PackedKV._default.ValidKeyLens$A, Lit(strs#0))
         || $Is(strs#0, TSeq(TSeq(PackedKV._default.ValidKeyLens$A)))
       ==> KeyType.__default.MaxLen#canCall()
         && PackedKV.__default.ValidStringLens#canCall(PackedKV._default.ValidKeyLens$A, 
          Lit(strs#0), 
          LitInt(KeyType.__default.MaxLen()))
         && PackedKV.__default.ValidKeyLens(PackedKV._default.ValidKeyLens$A, Lit(strs#0))
           == Lit(PackedKV.__default.ValidStringLens(PackedKV._default.ValidKeyLens$A, 
              Lit(strs#0), 
              LitInt(KeyType.__default.MaxLen()))));

// function declaration for PackedKV._default.IKeys
function PackedKV.__default.IKeys(psa#0: DatatypeType) : Seq Box;

function PackedKV.__default.IKeys#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.IKeys
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IKeys(psa#0) } 
    PackedKV.__default.IKeys#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(psa#0), 
            LitInt(KeyType.__default.MaxLen())))
       ==> $Is(PackedKV.__default.IKeys(psa#0), TSeq(Tclass.KeyType.Key())));

function PackedKV.__default.IKeys#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.IKeys
axiom (forall psa#0: DatatypeType :: 
  { PackedKV.__default.IKeys#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedKV.__default.IKeys#requires(psa#0)
       == (PackedStringArray.__default.WF(psa#0)
         && PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
          PackedStringArray.__default.I(psa#0), 
          LitInt(KeyType.__default.MaxLen()))));

// definition axiom for PackedKV.__default.IKeys(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IKeys(psa#0) } 
    PackedKV.__default.IKeys#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
            PackedStringArray.__default.I(psa#0), 
            LitInt(KeyType.__default.MaxLen())))
       ==> PackedStringArray.__default.I#canCall(psa#0)
         && PackedKV.__default.IKeys(psa#0) == PackedStringArray.__default.I(psa#0));

// definition axiom for PackedKV.__default.IKeys for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.IKeys(Lit(psa#0)) } 
    PackedKV.__default.IKeys#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && Lit(PackedKV.__default.ValidStringLens(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(psa#0))), 
              LitInt(KeyType.__default.MaxLen()))))
       ==> PackedStringArray.__default.I#canCall(Lit(psa#0))
         && PackedKV.__default.IKeys(Lit(psa#0))
           == Lit(PackedStringArray.__default.I(Lit(psa#0))));

// function declaration for PackedKV._default.psaSeq_Messages
function PackedKV.__default.psaSeq__Messages($ly: LayerType, psa#0: DatatypeType, i#0: int) : Seq Box;

function PackedKV.__default.psaSeq__Messages#canCall(psa#0: DatatypeType, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0) } 
  PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0)
     == PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.psaSeq__Messages(AsFuelBottom($ly), psa#0, i#0) } 
  PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0)
     == PackedKV.__default.psaSeq__Messages($LZ, psa#0, i#0));

// consequence axiom for PackedKV.__default.psaSeq__Messages
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0) } 
    PackedKV.__default.psaSeq__Messages#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> Seq#Length(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0)) == i#0
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0), j#0)): DatatypeType } 
          LitInt(0) <= j#0 && j#0 < i#0
             ==> ValueMessage.Message#Equal($Unbox(Seq#Index(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0), j#0)): DatatypeType, 
              ValueMessage.__default.bytestring__to__Message(PackedStringArray.__default.psaElement(psa#0, j#0))))
         && $Is(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0), 
          TSeq(Tclass.ValueMessage.Message())));

function PackedKV.__default.psaSeq__Messages#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for PackedKV.__default.psaSeq__Messages
axiom (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.psaSeq__Messages#requires($ly, psa#0, i#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedKV.__default.psaSeq__Messages#requires($ly, psa#0, i#0)
       == (PackedStringArray.__default.WF(psa#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedKV.__default.psaSeq__Messages(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0) } 
    PackedKV.__default.psaSeq__Messages#canCall(psa#0, i#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          PackedStringArray.__default.WF(psa#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
       ==> (i#0 != LitInt(0)
           ==> PackedKV.__default.psaSeq__Messages#canCall(psa#0, i#0 - 1)
             && 
            PackedStringArray.__default.psaElement#canCall(psa#0, i#0 - 1)
             && ValueMessage.__default.bytestring__to__Message#canCall(PackedStringArray.__default.psaElement(psa#0, i#0 - 1)))
         && PackedKV.__default.psaSeq__Messages($LS($ly), psa#0, i#0)
           == (if i#0 == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.psaSeq__Messages($ly, psa#0, i#0 - 1), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(ValueMessage.__default.bytestring__to__Message(PackedStringArray.__default.psaElement(psa#0, i#0 - 1)))))));

// definition axiom for PackedKV.__default.psaSeq__Messages for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, psa#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedKV.__default.psaSeq__Messages($LS($ly), Lit(psa#0), LitInt(i#0)) } 
    PackedKV.__default.psaSeq__Messages#canCall(Lit(psa#0), LitInt(i#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && 
          Lit(PackedStringArray.__default.WF(Lit(psa#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
       ==> (LitInt(i#0) != LitInt(0)
           ==> PackedKV.__default.psaSeq__Messages#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && 
            PackedStringArray.__default.psaElement#canCall(Lit(psa#0), LitInt(i#0 - 1))
             && ValueMessage.__default.bytestring__to__Message#canCall(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1)))))
         && PackedKV.__default.psaSeq__Messages($LS($ly), Lit(psa#0), LitInt(i#0))
           == (if LitInt(i#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.psaSeq__Messages($LS($ly), Lit(psa#0), LitInt(i#0 - 1)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(ValueMessage.__default.bytestring__to__Message(Lit(PackedStringArray.__default.psaElement(Lit(psa#0), LitInt(i#0 - 1))))))))));

// function declaration for PackedKV._default.IMessages
function PackedKV.__default.IMessages(psa#0: DatatypeType) : Seq Box;

function PackedKV.__default.IMessages#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.IMessages
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IMessages(psa#0) } 
    PackedKV.__default.IMessages#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> $Is(PackedKV.__default.IMessages(psa#0), TSeq(Tclass.ValueMessage.Message())));

function PackedKV.__default.IMessages#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.IMessages
axiom (forall psa#0: DatatypeType :: 
  { PackedKV.__default.IMessages#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedKV.__default.IMessages#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedKV.__default.IMessages(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedKV.__default.IMessages(psa#0) } 
    PackedKV.__default.IMessages#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedKV.__default.psaSeq__Messages#canCall(psa#0, Seq#Length(PackedStringArray.Psa.offsets(psa#0)))
         && PackedKV.__default.IMessages(psa#0)
           == PackedKV.__default.psaSeq__Messages(StartFuel_PackedKV._default.psaSeq_Messages, 
            psa#0, 
            Seq#Length(PackedStringArray.Psa.offsets(psa#0))));

// definition axiom for PackedKV.__default.IMessages for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.IMessages(Lit(psa#0)) } 
    PackedKV.__default.IMessages#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedKV.__default.psaSeq__Messages#canCall(Lit(psa#0), Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0)))))
         && PackedKV.__default.IMessages(Lit(psa#0))
           == PackedKV.__default.psaSeq__Messages(StartFuel_PackedKV._default.psaSeq_Messages, 
            Lit(psa#0), 
            Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))));

// function declaration for PackedKV._default.WF
function PackedKV.__default.WF(pkv#0: DatatypeType) : bool;

function PackedKV.__default.WF#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.WF
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WF(pkv#0) } 
    PackedKV.__default.WF#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> true);

function PackedKV.__default.WF#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.WF
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.WF#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.WF#requires(pkv#0) == true);

// definition axiom for PackedKV.__default.WF(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WF(pkv#0) } 
    PackedKV.__default.WF#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.WF#canCall(PackedKV.Pkv.keys(pkv#0))
         && (PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0)))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.WF#canCall(PackedKV.Pkv.messages(pkv#0))
             && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0)))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0))
             && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0))))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.keys(pkv#0))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
             && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
             && ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0))))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.I#canCall(PackedKV.Pkv.messages(pkv#0))
             && ValueType.__default.ValidMessageBytestrings#canCall(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
             && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
           ==> ValueMessage.__default.IdentityMessage#canCall()
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0)))
         && PackedKV.__default.WF(pkv#0)
           == (
            PackedStringArray.__default.WF(PackedKV.Pkv.keys(pkv#0))
             && PackedStringArray.__default.WF(PackedKV.Pkv.messages(pkv#0))
             && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))
               == Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))
             && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              PackedStringArray.__default.I(PackedKV.Pkv.keys(pkv#0)))
             && ValueType.__default.ValidMessageBytestrings(PackedStringArray.__default.I(PackedKV.Pkv.messages(pkv#0)))
             && !Seq#Contains(PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)), 
              $Box(ValueMessage.__default.IdentityMessage()))));

// definition axiom for PackedKV.__default.WF for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.WF(Lit(pkv#0)) } 
    PackedKV.__default.WF#canCall(Lit(pkv#0)) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.WF#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && (Lit(PackedStringArray.__default.WF(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.WF#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.WF#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && Lit(PackedStringArray.__default.WF(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
               == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && PackedKV.__default.ValidKeyLens#canCall(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             && Lit(PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
                Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && ValueType.__default.ValidMessageBytestrings#canCall(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.I#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && ValueType.__default.ValidMessageBytestrings#canCall(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
             && Lit(ValueType.__default.ValidMessageBytestrings(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
           ==> ValueMessage.__default.IdentityMessage#canCall()
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))
         && PackedKV.__default.WF(Lit(pkv#0))
           == (
            PackedStringArray.__default.WF(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
             && PackedStringArray.__default.WF(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
             && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
               == Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
             && PackedKV.__default.ValidKeyLens(Tclass.NativeTypes.byte(), 
              Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             && ValueType.__default.ValidMessageBytestrings(Lit(PackedStringArray.__default.I(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
             && !Seq#Contains(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))), 
              $Box(ValueMessage.__default.IdentityMessage()))));

// function declaration for PackedKV._default.IMap
function PackedKV.__default.IMap(pkv#0: DatatypeType) : Map Box Box;

function PackedKV.__default.IMap#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.IMap
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.IMap(pkv#0) } 
    PackedKV.__default.IMap#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> BucketsLib.__default.WFBucketMap(PackedKV.__default.IMap(pkv#0))
         && $Is(PackedKV.__default.IMap(pkv#0), 
          TMap(Tclass.KeyType.Key(), Tclass.ValueMessage.Message())));

function PackedKV.__default.IMap#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.IMap
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.IMap#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.IMap#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.IMap(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.IMap(pkv#0) } 
    PackedKV.__default.IMap#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
         && BucketsLib.__default.BucketMapOfSeq#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
          PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0)))
         && PackedKV.__default.IMap(pkv#0)
           == BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
            PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for PackedKV.__default.IMap for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.IMap(Lit(pkv#0)) } 
    PackedKV.__default.IMap#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IKeys#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && BucketsLib.__default.BucketMapOfSeq#canCall(Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))), 
          Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))
         && PackedKV.__default.IMap(Lit(pkv#0))
           == BucketsLib.__default.BucketMapOfSeq(StartFuel_BucketsLib._default.BucketMapOfSeq, 
            Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))), 
            Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))));

// function declaration for PackedKV._default.SortedKeys
function PackedKV.__default.SortedKeys(pkv#0: DatatypeType) : bool;

function PackedKV.__default.SortedKeys#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.SortedKeys
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SortedKeys(pkv#0) } 
    PackedKV.__default.SortedKeys#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> true);

function PackedKV.__default.SortedKeys#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.SortedKeys
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.SortedKeys#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.SortedKeys#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.SortedKeys(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SortedKeys(pkv#0) } 
    PackedKV.__default.SortedKeys#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)))
         && PackedKV.__default.SortedKeys(pkv#0)
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0))));

// definition axiom for PackedKV.__default.SortedKeys for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.SortedKeys(Lit(pkv#0)) } 
    PackedKV.__default.SortedKeys#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IKeys#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && Lexicographic__Byte__Order.__default.IsStrictlySorted#canCall(Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
         && PackedKV.__default.SortedKeys(Lit(pkv#0))
           == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))));

// function declaration for PackedKV._default.I
function PackedKV.__default.I(pkv#0: DatatypeType) : DatatypeType;

function PackedKV.__default.I#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.I
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.I(pkv#0) } 
    PackedKV.__default.I#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> BucketsLib.__default.WFBucket(PackedKV.__default.I(pkv#0))
         && $Is(PackedKV.__default.I(pkv#0), Tclass.BucketsLib.Bucket()));

function PackedKV.__default.I#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.I
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.I#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.I#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.I(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.I(pkv#0) } 
    PackedKV.__default.I#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.__default.IMap#canCall(pkv#0)
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IKeys#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedKV.__default.IMessages#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.I(pkv#0)
           == #BucketsLib.Bucket.BucketMapWithSeq(PackedKV.__default.IMap(pkv#0), 
            PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
            PackedKV.__default.IMessages(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for PackedKV.__default.I for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.I(Lit(pkv#0)) } 
    PackedKV.__default.I#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.__default.IMap#canCall(Lit(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IKeys#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedKV.__default.IMessages#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.I(Lit(pkv#0))
           == Lit(#BucketsLib.Bucket.BucketMapWithSeq(Lit(PackedKV.__default.IMap(Lit(pkv#0))), 
              Lit(PackedKV.__default.IKeys(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))), 
              Lit(PackedKV.__default.IMessages(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))))));

// function declaration for PackedKV._default.EmptyPkv
function PackedKV.__default.EmptyPkv() : DatatypeType;

function PackedKV.__default.EmptyPkv#canCall() : bool;

// consequence axiom for PackedKV.__default.EmptyPkv
axiom true
   ==> 
  true
   ==> PackedKV.__default.WF(PackedKV.__default.EmptyPkv())
     && Map#Equal(PackedKV.__default.IMap(PackedKV.__default.EmptyPkv()), Map#Empty(): Map Box Box)
     && $Is(PackedKV.__default.EmptyPkv(), Tclass.PackedKV.Pkv());

function PackedKV.__default.EmptyPkv#requires() : bool;

// #requires axiom for PackedKV.__default.EmptyPkv
axiom PackedKV.__default.EmptyPkv#requires() == true;

// definition axiom for PackedKV.__default.EmptyPkv(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.EmptyPsa#canCall()
     && PackedKV.__default.EmptyPkv()
       == Lit(#PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.EmptyPsa()), 
          Lit(PackedStringArray.__default.EmptyPsa())));

// definition axiom for PackedKV.__default.EmptyPkv for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArray.__default.EmptyPsa#canCall()
     && PackedStringArray.__default.EmptyPsa#canCall()
     && PackedKV.__default.EmptyPkv()
       == Lit(#PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.EmptyPsa()), 
          Lit(PackedStringArray.__default.EmptyPsa())));

// function declaration for PackedKV._default.NumKVPairs
function PackedKV.__default.NumKVPairs(pkv#0: DatatypeType) : int;

function PackedKV.__default.NumKVPairs#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.NumKVPairs
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.NumKVPairs(pkv#0) } 
    PackedKV.__default.NumKVPairs#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> LitInt(0) <= PackedKV.__default.NumKVPairs(pkv#0)
         && PackedKV.__default.NumKVPairs(pkv#0) < 18446744073709551616);

function PackedKV.__default.NumKVPairs#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.NumKVPairs
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.NumKVPairs#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.NumKVPairs#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.NumKVPairs(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.NumKVPairs(pkv#0) } 
    PackedKV.__default.NumKVPairs#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaNumStrings#canCall(PackedKV.Pkv.keys(pkv#0))
         && PackedKV.__default.NumKVPairs(pkv#0)
           == PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0)));

// definition axiom for PackedKV.__default.NumKVPairs for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.NumKVPairs(Lit(pkv#0)) } 
    PackedKV.__default.NumKVPairs#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaNumStrings#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && PackedKV.__default.NumKVPairs(Lit(pkv#0))
           == LitInt(PackedStringArray.__default.psaNumStrings(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))));

// function declaration for PackedKV._default.SizeOfPkv
function PackedKV.__default.SizeOfPkv(pkv#0: DatatypeType) : int;

function PackedKV.__default.SizeOfPkv#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.SizeOfPkv
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkv(pkv#0) } 
    PackedKV.__default.SizeOfPkv#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> true);

function PackedKV.__default.SizeOfPkv#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.SizeOfPkv
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.SizeOfPkv#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.SizeOfPkv#requires(pkv#0) == true);

// definition axiom for PackedKV.__default.SizeOfPkv(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkv(pkv#0) } 
    PackedKV.__default.SizeOfPkv#canCall(pkv#0) || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsa#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsa#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.SizeOfPkv(pkv#0)
           == PackedStringArray.__default.SizeOfPsa(PackedKV.Pkv.keys(pkv#0))
             + PackedStringArray.__default.SizeOfPsa(PackedKV.Pkv.messages(pkv#0)));

// definition axiom for PackedKV.__default.SizeOfPkv for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.SizeOfPkv(Lit(pkv#0)) } 
    PackedKV.__default.SizeOfPkv#canCall(Lit(pkv#0))
         || $Is(pkv#0, Tclass.PackedKV.Pkv())
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsa#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsa#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.SizeOfPkv(Lit(pkv#0))
           == LitInt(PackedStringArray.__default.SizeOfPsa(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
               + PackedStringArray.__default.SizeOfPsa(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))));

// function declaration for PackedKV._default.SizeOfPkvUint64
function PackedKV.__default.SizeOfPkvUint64(pkv#0: DatatypeType) : int;

function PackedKV.__default.SizeOfPkvUint64#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.SizeOfPkvUint64
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkvUint64(pkv#0) } 
    PackedKV.__default.SizeOfPkvUint64#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> LitInt(0) <= PackedKV.__default.SizeOfPkvUint64(pkv#0)
         && PackedKV.__default.SizeOfPkvUint64(pkv#0) < 18446744073709551616);

function PackedKV.__default.SizeOfPkvUint64#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.SizeOfPkvUint64
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.SizeOfPkvUint64#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.SizeOfPkvUint64#requires(pkv#0)
       == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.SizeOfPkvUint64(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.SizeOfPkvUint64(pkv#0) } 
    PackedKV.__default.SizeOfPkvUint64#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.SizeOfPkvUint64(pkv#0)
           == PackedStringArray.__default.SizeOfPsaUint64(PackedKV.Pkv.keys(pkv#0))
             + PackedStringArray.__default.SizeOfPsaUint64(PackedKV.Pkv.messages(pkv#0)));

// definition axiom for PackedKV.__default.SizeOfPkvUint64 for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.SizeOfPkvUint64(Lit(pkv#0)) } 
    PackedKV.__default.SizeOfPkvUint64#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.SizeOfPsaUint64#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.SizeOfPkvUint64(Lit(pkv#0))
           == LitInt(PackedStringArray.__default.SizeOfPsaUint64(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
               + PackedStringArray.__default.SizeOfPsaUint64(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))));

// function declaration for PackedKV._default.WeightPkv
function PackedKV.__default.WeightPkv(pkv#0: DatatypeType) : int;

function PackedKV.__default.WeightPkv#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.WeightPkv
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WeightPkv(pkv#0) } 
    PackedKV.__default.WeightPkv#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> LitInt(0) <= PackedKV.__default.WeightPkv(pkv#0)
         && PackedKV.__default.WeightPkv(pkv#0) < 18446744073709551616);

function PackedKV.__default.WeightPkv#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.WeightPkv
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.WeightPkv#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.WeightPkv#requires(pkv#0) == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.WeightPkv(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.WeightPkv(pkv#0) } 
    PackedKV.__default.WeightPkv#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.Psa.Psa_q(PackedKV.Pkv.messages(pkv#0))
         && PackedKV.__default.WeightPkv(pkv#0)
           == Mul(LitInt(4), Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))))
             + Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.keys(pkv#0)))
             + Mul(LitInt(4), 
              Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))))
             + Seq#Length(PackedStringArray.Psa.data(PackedKV.Pkv.messages(pkv#0))));

// definition axiom for PackedKV.__default.WeightPkv for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.WeightPkv(Lit(pkv#0)) } 
    PackedKV.__default.WeightPkv#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.Psa.Psa_q(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKV.__default.WeightPkv(Lit(pkv#0))
           == Mul(LitInt(4), 
              Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             + Mul(LitInt(4), 
              Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
             + Seq#Length(Lit(PackedStringArray.Psa.data(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))));

// function declaration for PackedKV._default.FirstKey
function PackedKV.__default.FirstKey(pkv#0: DatatypeType) : Seq Box;

function PackedKV.__default.FirstKey#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.FirstKey
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.FirstKey(pkv#0) } 
    PackedKV.__default.FirstKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> $Is(PackedKV.__default.FirstKey(pkv#0), Tclass.KeyType.Key()));

function PackedKV.__default.FirstKey#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.FirstKey
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.FirstKey#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.FirstKey#requires(pkv#0)
       == (PackedKV.__default.WF(pkv#0)
         && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0));

// definition axiom for PackedKV.__default.FirstKey(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.FirstKey(pkv#0) } 
    PackedKV.__default.FirstKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.FirstElement#canCall(PackedKV.Pkv.keys(pkv#0))
         && PackedKV.__default.FirstKey(pkv#0)
           == PackedStringArray.__default.FirstElement(PackedKV.Pkv.keys(pkv#0)));

// definition axiom for PackedKV.__default.FirstKey for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.FirstKey(Lit(pkv#0)) } 
    PackedKV.__default.FirstKey#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             > 0)
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.FirstElement#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && PackedKV.__default.FirstKey(Lit(pkv#0))
           == Lit(PackedStringArray.__default.FirstElement(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))));

// function declaration for PackedKV._default.LastKey
function PackedKV.__default.LastKey(pkv#0: DatatypeType) : Seq Box;

function PackedKV.__default.LastKey#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.LastKey
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.LastKey(pkv#0) } 
    PackedKV.__default.LastKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> $Is(PackedKV.__default.LastKey(pkv#0), Tclass.KeyType.Key()));

function PackedKV.__default.LastKey#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.LastKey
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.LastKey#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.LastKey#requires(pkv#0)
       == (PackedKV.__default.WF(pkv#0)
         && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0));

// definition axiom for PackedKV.__default.LastKey(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.LastKey(pkv#0) } 
    PackedKV.__default.LastKey#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))) > 0)
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.LastElement#canCall(PackedKV.Pkv.keys(pkv#0))
         && PackedKV.__default.LastKey(pkv#0)
           == PackedStringArray.__default.LastElement(PackedKV.Pkv.keys(pkv#0)));

// definition axiom for PackedKV.__default.LastKey for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.LastKey(Lit(pkv#0)) } 
    PackedKV.__default.LastKey#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
             > 0)
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.LastElement#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && PackedKV.__default.LastKey(Lit(pkv#0))
           == Lit(PackedStringArray.__default.LastElement(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))));

// function declaration for PackedKV._default.GetKey
function PackedKV.__default.GetKey(pkv#0: DatatypeType, i#0: int) : Seq Box;

function PackedKV.__default.GetKey#canCall(pkv#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedKV.__default.GetKey
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetKey(pkv#0, i#0) } 
    PackedKV.__default.GetKey#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))))
       ==> $Is(PackedKV.__default.GetKey(pkv#0, i#0), Tclass.KeyType.Key()));

function PackedKV.__default.GetKey#requires(DatatypeType, int) : bool;

// #requires axiom for PackedKV.__default.GetKey
axiom (forall pkv#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.GetKey#requires(pkv#0, i#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedKV.__default.GetKey#requires(pkv#0, i#0)
       == (PackedKV.__default.WF(pkv#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0)))));

// definition axiom for PackedKV.__default.GetKey(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetKey(pkv#0, i#0) } 
    PackedKV.__default.GetKey#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.keys(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.keys(pkv#0), i#0)
         && PackedKV.__default.GetKey(pkv#0, i#0)
           == PackedStringArray.__default.psaElement(PackedKV.Pkv.keys(pkv#0), i#0));

// definition axiom for PackedKV.__default.GetKey for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedKV.__default.GetKey(Lit(pkv#0), LitInt(i#0)) } 
    PackedKV.__default.GetKey#canCall(Lit(pkv#0), LitInt(i#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0
             < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.keys(Lit(pkv#0)))))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(i#0))
         && PackedKV.__default.GetKey(Lit(pkv#0), LitInt(i#0))
           == Lit(PackedStringArray.__default.psaElement(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(i#0))));

// function declaration for PackedKV._default.GetMessage
function PackedKV.__default.GetMessage(pkv#0: DatatypeType, i#0: int) : DatatypeType;

function PackedKV.__default.GetMessage#canCall(pkv#0: DatatypeType, i#0: int) : bool;

// consequence axiom for PackedKV.__default.GetMessage
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetMessage(pkv#0, i#0) } 
    PackedKV.__default.GetMessage#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))))
       ==> $Is(PackedKV.__default.GetMessage(pkv#0, i#0), Tclass.ValueMessage.Message()));

function PackedKV.__default.GetMessage#requires(DatatypeType, int) : bool;

// #requires axiom for PackedKV.__default.GetMessage
axiom (forall pkv#0: DatatypeType, i#0: int :: 
  { PackedKV.__default.GetMessage#requires(pkv#0, i#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> PackedKV.__default.GetMessage#requires(pkv#0, i#0)
       == (PackedKV.__default.WF(pkv#0)
         && 
        LitInt(0) <= i#0
         && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0)))));

// definition axiom for PackedKV.__default.GetMessage(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    { PackedKV.__default.GetMessage(pkv#0, i#0) } 
    PackedKV.__default.GetMessage#canCall(pkv#0, i#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= i#0
           && i#0 < Seq#Length(PackedStringArray.Psa.offsets(PackedKV.Pkv.messages(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaElement#canCall(PackedKV.Pkv.messages(pkv#0), i#0)
         && ValueMessage.__default.bytestring__to__Message#canCall(PackedStringArray.__default.psaElement(PackedKV.Pkv.messages(pkv#0), i#0))
         && PackedKV.__default.GetMessage(pkv#0, i#0)
           == ValueMessage.__default.bytestring__to__Message(PackedStringArray.__default.psaElement(PackedKV.Pkv.messages(pkv#0), i#0)));

// definition axiom for PackedKV.__default.GetMessage for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, i#0: int :: 
    {:weight 3} { PackedKV.__default.GetMessage(Lit(pkv#0), LitInt(i#0)) } 
    PackedKV.__default.GetMessage#canCall(Lit(pkv#0), LitInt(i#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && 
          LitInt(0) <= LitInt(i#0)
           && i#0
             < Seq#Length(Lit(PackedStringArray.Psa.offsets(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaElement#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(i#0))
         && ValueMessage.__default.bytestring__to__Message#canCall(Lit(PackedStringArray.__default.psaElement(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(i#0))))
         && PackedKV.__default.GetMessage(Lit(pkv#0), LitInt(i#0))
           == Lit(ValueMessage.__default.bytestring__to__Message(Lit(PackedStringArray.__default.psaElement(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(i#0))))));

// function declaration for PackedKV._default.binarySearchPostProc
function PackedKV.__default.binarySearchPostProc(lo#0: int, sub#0: DatatypeType) : DatatypeType;

function PackedKV.__default.binarySearchPostProc#canCall(lo#0: int, sub#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.binarySearchPostProc
axiom true
   ==> (forall lo#0: int, sub#0: DatatypeType :: 
    { PackedKV.__default.binarySearchPostProc(lo#0, sub#0) } 
    PackedKV.__default.binarySearchPostProc#canCall(lo#0, sub#0)
         || (LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat())))
       ==> $Is(PackedKV.__default.binarySearchPostProc(lo#0, sub#0), 
        Tclass.Options.Option(Tclass._System.nat())));

function PackedKV.__default.binarySearchPostProc#requires(int, DatatypeType) : bool;

// #requires axiom for PackedKV.__default.binarySearchPostProc
axiom (forall lo#0: int, sub#0: DatatypeType :: 
  { PackedKV.__default.binarySearchPostProc#requires(lo#0, sub#0) } 
  LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat()))
     ==> PackedKV.__default.binarySearchPostProc#requires(lo#0, sub#0) == true);

// definition axiom for PackedKV.__default.binarySearchPostProc(revealed)
axiom true
   ==> (forall lo#0: int, sub#0: DatatypeType :: 
    { PackedKV.__default.binarySearchPostProc(lo#0, sub#0) } 
    PackedKV.__default.binarySearchPostProc#canCall(lo#0, sub#0)
         || (LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat())))
       ==> PackedKV.__default.binarySearchPostProc(lo#0, sub#0)
         == (if Options.Option.Some_q(sub#0)
           then #Options.Option.Some($Box(lo#0 + $Unbox(Options.Option.value(sub#0)): int))
           else #Options.Option.None()));

// definition axiom for PackedKV.__default.binarySearchPostProc for all literals(revealed)
axiom true
   ==> (forall lo#0: int, sub#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.binarySearchPostProc(LitInt(lo#0), Lit(sub#0)) } 
    PackedKV.__default.binarySearchPostProc#canCall(LitInt(lo#0), Lit(sub#0))
         || (LitInt(0) <= lo#0 && $Is(sub#0, Tclass.Options.Option(Tclass._System.nat())))
       ==> PackedKV.__default.binarySearchPostProc(LitInt(lo#0), Lit(sub#0))
         == (if Options.Option.Some_q(Lit(sub#0))
           then #Options.Option.Some($Box(LitInt(lo#0 + $Unbox(Options.Option.value(Lit(sub#0))): int)))
           else #Options.Option.None()));

// function declaration for PackedKV._default.canAppend
function PackedKV.__default.canAppend(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : bool;

function PackedKV.__default.canAppend#canCall(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.canAppend
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.canAppend(pkv#0, key#0, msg#0) } 
    PackedKV.__default.canAppend#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedKV.__default.WF(pkv#0))
       ==> true);

function PackedKV.__default.canAppend#requires(DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for PackedKV.__default.canAppend
axiom (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
  { PackedKV.__default.canAppend#requires(pkv#0, key#0, msg#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedKV.__default.canAppend#requires(pkv#0, key#0, msg#0)
       == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKV.__default.canAppend(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.canAppend(pkv#0, key#0, msg#0) } 
    PackedKV.__default.canAppend#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.keys(pkv#0), key#0)
         && (PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(pkv#0), key#0)
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(pkv#0), msg#0))
         && (PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaCanAppend#canCall(PackedKV.Pkv.messages(pkv#0), msg#0)
             && PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(pkv#0), msg#0)
           ==> ValueType.__default.ValidMessageBytestring#canCall(msg#0))
         && PackedKV.__default.canAppend(pkv#0, key#0, msg#0)
           == (
            PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.keys(pkv#0), key#0)
             && PackedStringArray.__default.psaCanAppend(PackedKV.Pkv.messages(pkv#0), msg#0)
             && ValueType.__default.ValidMessageBytestring(msg#0)));

// definition axiom for PackedKV.__default.canAppend for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.canAppend(Lit(pkv#0), Lit(key#0), Lit(msg#0)) } 
    PackedKV.__default.canAppend#canCall(Lit(pkv#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaCanAppend#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))
         && (Lit(PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0)))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaCanAppend#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0)))
         && (PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaCanAppend#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))
             && Lit(PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0)))
           ==> ValueType.__default.ValidMessageBytestring#canCall(Lit(msg#0)))
         && PackedKV.__default.canAppend(Lit(pkv#0), Lit(key#0), Lit(msg#0))
           == Lit(PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))
               && PackedStringArray.__default.psaCanAppend(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))
               && ValueType.__default.ValidMessageBytestring(Lit(msg#0))));

// function declaration for PackedKV._default.AppendEncodedMessage
function PackedKV.__default.AppendEncodedMessage(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : DatatypeType;

function PackedKV.__default.AppendEncodedMessage#canCall(pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box) : bool;

// consequence axiom for PackedKV.__default.AppendEncodedMessage
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0) } 
    PackedKV.__default.AppendEncodedMessage#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedKV.__default.WF(pkv#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, msg#0))
       ==> PackedKV.__default.WF(PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0))
         && Seq#Equal(PackedKV.__default.IKeys(PackedKV.Pkv.keys(PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0))), 
          Seq#Append(PackedKV.__default.IKeys(PackedKV.Pkv.keys(pkv#0)), 
            Seq#Build(Seq#Empty(): Seq Box, $Box(key#0))))
         && $Is(PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0), 
          Tclass.PackedKV.Pkv()));

function PackedKV.__default.AppendEncodedMessage#requires(DatatypeType, Seq Box, Seq Box) : bool;

// #requires axiom for PackedKV.__default.AppendEncodedMessage
axiom (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
  { PackedKV.__default.AppendEncodedMessage#requires(pkv#0, key#0, msg#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
     ==> PackedKV.__default.AppendEncodedMessage#requires(pkv#0, key#0, msg#0)
       == (PackedKV.__default.WF(pkv#0)
         && PackedKV.__default.canAppend(pkv#0, key#0, msg#0)));

// definition axiom for PackedKV.__default.AppendEncodedMessage(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    { PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0) } 
    PackedKV.__default.AppendEncodedMessage#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          PackedKV.__default.WF(pkv#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, msg#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaAppend#canCall(PackedKV.Pkv.keys(pkv#0), key#0)
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArray.__default.psaAppend#canCall(PackedKV.Pkv.messages(pkv#0), msg#0)
         && PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, msg#0)
           == #PackedKV.Pkv.Pkv(PackedStringArray.__default.psaAppend(PackedKV.Pkv.keys(pkv#0), key#0), 
            PackedStringArray.__default.psaAppend(PackedKV.Pkv.messages(pkv#0), msg#0)));

// definition axiom for PackedKV.__default.AppendEncodedMessage for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.AppendEncodedMessage(Lit(pkv#0), Lit(key#0), Lit(msg#0)) } 
    PackedKV.__default.AppendEncodedMessage#canCall(Lit(pkv#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, TSeq(Tclass.NativeTypes.byte()))
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Lit(PackedKV.__default.canAppend(Lit(pkv#0), Lit(key#0), Lit(msg#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaAppend#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArray.__default.psaAppend#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))
         && PackedKV.__default.AppendEncodedMessage(Lit(pkv#0), Lit(key#0), Lit(msg#0))
           == Lit(#PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.psaAppend(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), Lit(key#0))), 
              Lit(PackedStringArray.__default.psaAppend(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), Lit(msg#0))))));

// function declaration for PackedKV._default.Append
function PackedKV.__default.Append(pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : DatatypeType;

function PackedKV.__default.Append#canCall(pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.Append
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { PackedKV.__default.Append(pkv#0, key#0, msg#0) } 
    PackedKV.__default.Append#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && 
          PackedKV.__default.WF(pkv#0)
           && ValueMessage.Message.Define_q(msg#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0)))
       ==> PackedKV.__default.WF(PackedKV.__default.Append(pkv#0, key#0, msg#0))
         && $Is(PackedKV.__default.Append(pkv#0, key#0, msg#0), Tclass.PackedKV.Pkv()));

function PackedKV.__default.Append#requires(DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for PackedKV.__default.Append
axiom (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
  { PackedKV.__default.Append#requires(pkv#0, key#0, msg#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && $Is(key#0, Tclass.KeyType.Key())
       && $Is(msg#0, Tclass.ValueMessage.Message())
     ==> PackedKV.__default.Append#requires(pkv#0, key#0, msg#0)
       == (
        PackedKV.__default.WF(pkv#0)
         && ValueMessage.Message.Define_q(msg#0)
         && PackedKV.__default.canAppend(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0))));

// definition axiom for PackedKV.__default.Append(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    { PackedKV.__default.Append(pkv#0, key#0, msg#0) } 
    PackedKV.__default.Append#canCall(pkv#0, key#0, msg#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && 
          PackedKV.__default.WF(pkv#0)
           && ValueMessage.Message.Define_q(msg#0)
           && PackedKV.__default.canAppend(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0)))
       ==> ValueMessage.__default.Message__to__bytestring#canCall(msg#0)
         && PackedKV.__default.AppendEncodedMessage#canCall(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0))
         && PackedKV.__default.Append(pkv#0, key#0, msg#0)
           == PackedKV.__default.AppendEncodedMessage(pkv#0, key#0, ValueMessage.__default.Message__to__bytestring(msg#0)));

// definition axiom for PackedKV.__default.Append for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, key#0: Seq Box, msg#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.Append(Lit(pkv#0), Lit(key#0), Lit(msg#0)) } 
    PackedKV.__default.Append#canCall(Lit(pkv#0), Lit(key#0), Lit(msg#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && $Is(key#0, Tclass.KeyType.Key())
           && $Is(msg#0, Tclass.ValueMessage.Message())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Lit(ValueMessage.Message.Define_q(Lit(msg#0)))
           && Lit(PackedKV.__default.canAppend(Lit(pkv#0), 
              Lit(key#0), 
              Lit(ValueMessage.__default.Message__to__bytestring(Lit(msg#0))))))
       ==> ValueMessage.__default.Message__to__bytestring#canCall(Lit(msg#0))
         && PackedKV.__default.AppendEncodedMessage#canCall(Lit(pkv#0), 
          Lit(key#0), 
          Lit(ValueMessage.__default.Message__to__bytestring(Lit(msg#0))))
         && PackedKV.__default.Append(Lit(pkv#0), Lit(key#0), Lit(msg#0))
           == Lit(PackedKV.__default.AppendEncodedMessage(Lit(pkv#0), 
              Lit(key#0), 
              Lit(ValueMessage.__default.Message__to__bytestring(Lit(msg#0))))));

// function declaration for PackedKV._default.subPkv
function PackedKV.__default.subPkv(pkv#0: DatatypeType, from#0: int, to#0: int) : DatatypeType;

function PackedKV.__default.subPkv#canCall(pkv#0: DatatypeType, from#0: int, to#0: int) : bool;

// consequence axiom for PackedKV.__default.subPkv
axiom true
   ==> (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedKV.__default.subPkv(pkv#0, from#0, to#0) } 
    PackedKV.__default.subPkv#canCall(pkv#0, from#0, to#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0)))
       ==> PackedKV.__default.WF(PackedKV.__default.subPkv(pkv#0, from#0, to#0))
         && (BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
           ==> BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(PackedKV.__default.subPkv(pkv#0, from#0, to#0))))
         && $Is(PackedKV.__default.subPkv(pkv#0, from#0, to#0), Tclass.PackedKV.Pkv()));

function PackedKV.__default.subPkv#requires(DatatypeType, int, int) : bool;

// #requires axiom for PackedKV.__default.subPkv
axiom (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
  { PackedKV.__default.subPkv#requires(pkv#0, from#0, to#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
       && 
      LitInt(0) <= from#0
       && from#0 < 18446744073709551616
       && 
      LitInt(0) <= to#0
       && to#0 < 18446744073709551616
     ==> PackedKV.__default.subPkv#requires(pkv#0, from#0, to#0)
       == (PackedKV.__default.WF(pkv#0)
         && 
        LitInt(0) <= from#0
         && from#0 <= to#0
         && to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0))));

// definition axiom for PackedKV.__default.subPkv(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
    { PackedKV.__default.subPkv(pkv#0, from#0, to#0) } 
    PackedKV.__default.subPkv#canCall(pkv#0, from#0, to#0)
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          PackedKV.__default.WF(pkv#0)
           && 
          LitInt(0) <= from#0
           && from#0 <= to#0
           && to#0 <= PackedStringArray.__default.psaNumStrings(PackedKV.Pkv.keys(pkv#0)))
       ==> PackedKV.__default.I#canCall(pkv#0)
         && BucketsLib.__default.BucketWellMarshalled#canCall(PackedKV.__default.I(pkv#0))
         && (BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.keys(pkv#0), from#0, to#0)
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.messages(pkv#0), from#0, to#0))
         && (!BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
           ==> PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.keys(pkv#0), from#0, to#0)
             && 
            PackedKV.Pkv.Pkv_q(pkv#0)
             && PackedStringArray.__default.psaSubSeq#canCall(PackedKV.Pkv.messages(pkv#0), from#0, to#0))
         && PackedKV.__default.subPkv(pkv#0, from#0, to#0)
           == (if BucketsLib.__default.BucketWellMarshalled(PackedKV.__default.I(pkv#0))
             then #PackedKV.Pkv.Pkv(PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.keys(pkv#0), from#0, to#0), 
              PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.messages(pkv#0), from#0, to#0))
             else #PackedKV.Pkv.Pkv(PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.keys(pkv#0), from#0, to#0), 
              PackedStringArray.__default.psaSubSeq(PackedKV.Pkv.messages(pkv#0), from#0, to#0))));

// definition axiom for PackedKV.__default.subPkv for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType, from#0: int, to#0: int :: 
    {:weight 3} { PackedKV.__default.subPkv(Lit(pkv#0), LitInt(from#0), LitInt(to#0)) } 
    PackedKV.__default.subPkv#canCall(Lit(pkv#0), LitInt(from#0), LitInt(to#0))
         || (
          $Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          LitInt(0) <= from#0
           && from#0 < 18446744073709551616
           && 
          LitInt(0) <= to#0
           && to#0 < 18446744073709551616
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && 
          LitInt(0) <= LitInt(from#0)
           && LitInt(from#0) <= LitInt(to#0)
           && LitInt(to#0)
             <= LitInt(PackedStringArray.__default.psaNumStrings(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))
       ==> PackedKV.__default.I#canCall(Lit(pkv#0))
         && BucketsLib.__default.BucketWellMarshalled#canCall(Lit(PackedKV.__default.I(Lit(pkv#0))))
         && (Lit(BucketsLib.__default.BucketWellMarshalled(Lit(PackedKV.__default.I(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0)))
         && (!Lit(BucketsLib.__default.BucketWellMarshalled(Lit(PackedKV.__default.I(Lit(pkv#0)))))
           ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))
             && 
            PackedKV.Pkv.Pkv_q(Lit(pkv#0))
             && PackedStringArray.__default.psaSubSeq#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0)))
         && PackedKV.__default.subPkv(Lit(pkv#0), LitInt(from#0), LitInt(to#0))
           == (if BucketsLib.__default.BucketWellMarshalled(Lit(PackedKV.__default.I(Lit(pkv#0))))
             then #PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))), 
              Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))))
             else #PackedKV.Pkv.Pkv(Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.keys(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))), 
              Lit(PackedStringArray.__default.psaSubSeq(Lit(PackedKV.Pkv.messages(Lit(pkv#0))), LitInt(from#0), LitInt(to#0))))));

// function declaration for PackedKV._default.DropLast
function PackedKV.__default.DropLast(pkv#0: DatatypeType) : DatatypeType;

function PackedKV.__default.DropLast#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKV.__default.DropLast
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.DropLast(pkv#0) } 
    PackedKV.__default.DropLast#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && 0 < PackedKV.__default.NumKVPairs(pkv#0))
       ==> PackedKV.__default.WF(PackedKV.__default.DropLast(pkv#0))
         && $Is(PackedKV.__default.DropLast(pkv#0), Tclass.PackedKV.Pkv()));

function PackedKV.__default.DropLast#requires(DatatypeType) : bool;

// #requires axiom for PackedKV.__default.DropLast
axiom (forall pkv#0: DatatypeType :: 
  { PackedKV.__default.DropLast#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKV.__default.DropLast#requires(pkv#0)
       == (PackedKV.__default.WF(pkv#0) && 0 < PackedKV.__default.NumKVPairs(pkv#0)));

// definition axiom for PackedKV.__default.DropLast(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKV.__default.DropLast(pkv#0) } 
    PackedKV.__default.DropLast#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          PackedKV.__default.WF(pkv#0)
           && 0 < PackedKV.__default.NumKVPairs(pkv#0))
       ==> PackedKV.__default.NumKVPairs#canCall(pkv#0)
         && PackedKV.__default.subPkv#canCall(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1)
         && PackedKV.__default.DropLast(pkv#0)
           == PackedKV.__default.subPkv(pkv#0, LitInt(0), PackedKV.__default.NumKVPairs(pkv#0) - 1));

// definition axiom for PackedKV.__default.DropLast for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKV.__default.DropLast(Lit(pkv#0)) } 
    PackedKV.__default.DropLast#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv())
           && 
          Lit(PackedKV.__default.WF(Lit(pkv#0)))
           && Lit(0 < PackedKV.__default.NumKVPairs(Lit(pkv#0))))
       ==> PackedKV.__default.NumKVPairs#canCall(Lit(pkv#0))
         && PackedKV.__default.subPkv#canCall(Lit(pkv#0), LitInt(0), LitInt(PackedKV.__default.NumKVPairs(Lit(pkv#0)) - 1))
         && PackedKV.__default.DropLast(Lit(pkv#0))
           == Lit(PackedKV.__default.subPkv(Lit(pkv#0), LitInt(0), LitInt(PackedKV.__default.NumKVPairs(Lit(pkv#0)) - 1))));

// function declaration for PackedKV._default.pivotIndexes
function PackedKV.__default.pivotIndexes($ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box) : Seq Box;

function PackedKV.__default.pivotIndexes#canCall(keys#0: Seq Box, pivots#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
  { PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0) } 
  PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0)
     == PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
  { PackedKV.__default.pivotIndexes(AsFuelBottom($ly), keys#0, pivots#0) } 
  PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0)
     == PackedKV.__default.pivotIndexes($LZ, keys#0, pivots#0));

// consequence axiom for PackedKV.__default.pivotIndexes
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
    { PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0) } 
    PackedKV.__default.pivotIndexes#canCall(keys#0, pivots#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0))
       ==> Seq#Length(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0))
           == Seq#Length(pivots#0)
         && (forall i#0: int :: 
          { $Unbox(Seq#Index(pivots#0, i#0)): Seq Box } 
            { $Unbox(Seq#Index(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0), i#0)): int } 
          LitInt(0) <= i#0
               && i#0 < Seq#Length(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0))
             ==> $Unbox(Seq#Index(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0), i#0)): int
               == Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), keys#0, $Unbox(Seq#Index(pivots#0, i#0)): Seq Box))
         && $Is(PackedKV.__default.pivotIndexes($ly, keys#0, pivots#0), 
          TSeq(Tclass._System.nat())));

function PackedKV.__default.pivotIndexes#requires(LayerType, Seq Box, Seq Box) : bool;

// #requires axiom for PackedKV.__default.pivotIndexes
axiom (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
  { PackedKV.__default.pivotIndexes#requires($ly, keys#0, pivots#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
     ==> PackedKV.__default.pivotIndexes#requires($ly, keys#0, pivots#0)
       == Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0));

// definition axiom for PackedKV.__default.pivotIndexes(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
    { PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0) } 
    PackedKV.__default.pivotIndexes#canCall(keys#0, pivots#0)
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, keys#0))
       ==> (Seq#Length(pivots#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), pivots#0)
             && PackedKV.__default.pivotIndexes#canCall(keys#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), pivots#0)
             && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(keys#0, 
              $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))
         && PackedKV.__default.pivotIndexes($LS($ly), keys#0, pivots#0)
           == (if Seq#Length(pivots#0) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.pivotIndexes($ly, keys#0, Sequences.__default.DropLast(Tclass.KeyType.Key(), pivots#0)), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
                    keys#0, 
                    $Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), pivots#0)): Seq Box))))));

// definition axiom for PackedKV.__default.pivotIndexes for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box, pivots#0: Seq Box :: 
    {:weight 3} { PackedKV.__default.pivotIndexes($LS($ly), Lit(keys#0), Lit(pivots#0)) } 
    PackedKV.__default.pivotIndexes#canCall(Lit(keys#0), Lit(pivots#0))
         || (
          $Is(keys#0, TSeq(Tclass.KeyType.Key()))
           && $Is(pivots#0, TSeq(Tclass.KeyType.Key()))
           && Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, Lit(keys#0)))
       ==> (Seq#Length(Lit(pivots#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
             && PackedKV.__default.pivotIndexes#canCall(Lit(keys#0), 
              Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(pivots#0))
             && Lexicographic__Byte__Order.__default.IndexOfFirstGte#canCall(Lit(keys#0), 
              Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box)))
         && PackedKV.__default.pivotIndexes($LS($ly), Lit(keys#0), Lit(pivots#0))
           == (if Seq#Length(Lit(pivots#0)) == LitInt(0)
             then Seq#Empty(): Seq Box
             else Seq#Append(PackedKV.__default.pivotIndexes($LS($ly), 
                Lit(keys#0), 
                Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(pivots#0)))), 
              Seq#Build(Seq#Empty(): Seq Box, 
                $Box(LitInt(Lexicographic__Byte__Order.__default.IndexOfFirstGte($LS($LZ), 
                      Lit(keys#0), 
                      Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(pivots#0))): Seq Box))))))));

const unique class.Uint32__Order__Impl.__default: ClassName;

function Tclass.Uint32__Order__Impl.__default() : Ty;

// Tclass.Uint32__Order__Impl.__default Tag
axiom Tag(Tclass.Uint32__Order__Impl.__default())
   == Tagclass.Uint32__Order__Impl.__default;

const unique Tagclass.Uint32__Order__Impl.__default: TyTag;

// Box/unbox axiom for Tclass.Uint32__Order__Impl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Uint32__Order__Impl.__default()) } 
  $IsBox(bx, Tclass.Uint32__Order__Impl.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Uint32__Order__Impl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Uint32__Order__Impl.__default()) } 
  $Is($o, Tclass.Uint32__Order__Impl.__default())
     <==> $o == null || dtype($o) == Tclass.Uint32__Order__Impl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Uint32__Order__Impl.__default(), $h) } 
  $IsAlloc($o, Tclass.Uint32__Order__Impl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique class.PackedStringArrayMarshalling.__default: ClassName;

function Tclass.PackedStringArrayMarshalling.__default() : Ty;

// Tclass.PackedStringArrayMarshalling.__default Tag
axiom Tag(Tclass.PackedStringArrayMarshalling.__default())
   == Tagclass.PackedStringArrayMarshalling.__default;

const unique Tagclass.PackedStringArrayMarshalling.__default: TyTag;

// Box/unbox axiom for Tclass.PackedStringArrayMarshalling.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedStringArrayMarshalling.__default()) } 
  $IsBox(bx, Tclass.PackedStringArrayMarshalling.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedStringArrayMarshalling.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedStringArrayMarshalling.__default()) } 
  $Is($o, Tclass.PackedStringArrayMarshalling.__default())
     <==> $o == null || dtype($o) == Tclass.PackedStringArrayMarshalling.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedStringArrayMarshalling.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedStringArrayMarshalling.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedStringArrayMarshalling._default.grammar
function PackedStringArrayMarshalling.__default.grammar() : DatatypeType;

function PackedStringArrayMarshalling.__default.grammar#canCall() : bool;

// consequence axiom for PackedStringArrayMarshalling.__default.grammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(PackedStringArrayMarshalling.__default.grammar())))
     && $Is(PackedStringArrayMarshalling.__default.grammar(), Tclass.GenericMarshalling.G());

function PackedStringArrayMarshalling.__default.grammar#requires() : bool;

// #requires axiom for PackedStringArrayMarshalling.__default.grammar
axiom PackedStringArrayMarshalling.__default.grammar#requires() == true;

// definition axiom for PackedStringArrayMarshalling.__default.grammar(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArrayMarshalling.__default.grammar()
     == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint32Array()))), 
            $Box(Lit(#GenericMarshalling.G.GByteArray()))))));

// definition axiom for PackedStringArrayMarshalling.__default.grammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArrayMarshalling.__default.grammar()
     == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint32Array()))), 
            $Box(Lit(#GenericMarshalling.G.GByteArray()))))));

// function declaration for PackedStringArrayMarshalling._default.fromVal
function PackedStringArrayMarshalling.__default.fromVal(v#0: DatatypeType) : DatatypeType;

function PackedStringArrayMarshalling.__default.fromVal#canCall(v#0: DatatypeType) : bool;

// consequence axiom for PackedStringArrayMarshalling.__default.fromVal
axiom true
   ==> (forall v#0: DatatypeType :: 
    { PackedStringArrayMarshalling.__default.fromVal(v#0) } 
    PackedStringArrayMarshalling.__default.fromVal#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(PackedStringArrayMarshalling.__default.grammar())))
       ==> (Options.Option.Some_q(PackedStringArrayMarshalling.__default.fromVal(v#0))
           ==> PackedStringArray.__default.WF($Unbox(Options.Option.value(PackedStringArrayMarshalling.__default.fromVal(v#0))): DatatypeType))
         && $Is(PackedStringArrayMarshalling.__default.fromVal(v#0), 
          Tclass.Options.Option(Tclass.PackedStringArray.Psa())));

function PackedStringArrayMarshalling.__default.fromVal#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArrayMarshalling.__default.fromVal
axiom (forall v#0: DatatypeType :: 
  { PackedStringArrayMarshalling.__default.fromVal#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> PackedStringArrayMarshalling.__default.fromVal#requires(v#0)
       == GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
        v#0, 
        Lit(PackedStringArrayMarshalling.__default.grammar())));

// definition axiom for PackedStringArrayMarshalling.__default.fromVal(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { PackedStringArrayMarshalling.__default.fromVal(v#0) } 
    PackedStringArrayMarshalling.__default.fromVal#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(PackedStringArrayMarshalling.__default.grammar())))
       ==> (var offsets#0 := GenericMarshalling.V.va($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType); 
          (var data#0 := GenericMarshalling.V.b($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType); 
            (var psa#0 := #PackedStringArray.Psa.Psa(offsets#0, data#0); 
              PackedStringArray.__default.WF#canCall(psa#0))))
         && PackedStringArrayMarshalling.__default.fromVal(v#0)
           == (var offsets#0 := GenericMarshalling.V.va($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType); 
            (var data#0 := GenericMarshalling.V.b($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType); 
              (var psa#0 := #PackedStringArray.Psa.Psa(offsets#0, data#0); 
                (if PackedStringArray.__default.WF(psa#0)
                   then #Options.Option.Some($Box(psa#0))
                   else #Options.Option.None())))));

// definition axiom for PackedStringArrayMarshalling.__default.fromVal for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { PackedStringArrayMarshalling.__default.fromVal(Lit(v#0)) } 
    PackedStringArrayMarshalling.__default.fromVal#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(PackedStringArrayMarshalling.__default.grammar()))))
       ==> (var offsets#1 := GenericMarshalling.V.va($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType); 
          (var data#1 := GenericMarshalling.V.b($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType); 
            (var psa#1 := #PackedStringArray.Psa.Psa(offsets#1, data#1); 
              PackedStringArray.__default.WF#canCall(psa#1))))
         && PackedStringArrayMarshalling.__default.fromVal(Lit(v#0))
           == (var offsets#1 := GenericMarshalling.V.va($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType); 
            (var data#1 := GenericMarshalling.V.b($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType); 
              (var psa#1 := #PackedStringArray.Psa.Psa(offsets#1, data#1); 
                (if PackedStringArray.__default.WF(psa#1)
                   then #Options.Option.Some($Box(psa#1))
                   else #Options.Option.None())))));

// function declaration for PackedStringArrayMarshalling._default.toVal
function PackedStringArrayMarshalling.__default.toVal(psa#0: DatatypeType) : DatatypeType;

function PackedStringArrayMarshalling.__default.toVal#canCall(psa#0: DatatypeType) : bool;

// consequence axiom for PackedStringArrayMarshalling.__default.toVal
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArrayMarshalling.__default.toVal(psa#0) } 
    PackedStringArrayMarshalling.__default.toVal#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          PackedStringArrayMarshalling.__default.toVal(psa#0), 
          Lit(PackedStringArrayMarshalling.__default.grammar()))
         && $Is(PackedStringArrayMarshalling.__default.toVal(psa#0), 
          Tclass.GenericMarshalling.V()));

function PackedStringArrayMarshalling.__default.toVal#requires(DatatypeType) : bool;

// #requires axiom for PackedStringArrayMarshalling.__default.toVal
axiom (forall psa#0: DatatypeType :: 
  { PackedStringArrayMarshalling.__default.toVal#requires(psa#0) } 
  $Is(psa#0, Tclass.PackedStringArray.Psa())
     ==> PackedStringArrayMarshalling.__default.toVal#requires(psa#0)
       == PackedStringArray.__default.WF(psa#0));

// definition axiom for PackedStringArrayMarshalling.__default.toVal(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    { PackedStringArrayMarshalling.__default.toVal(psa#0) } 
    PackedStringArrayMarshalling.__default.toVal#canCall(psa#0)
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && PackedStringArray.__default.WF(psa#0))
       ==> PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArray.Psa.Psa_q(psa#0)
         && PackedStringArrayMarshalling.__default.toVal(psa#0)
           == #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(#GenericMarshalling.V.VUint32Array(PackedStringArray.Psa.offsets(psa#0)))), 
              $Box(#GenericMarshalling.V.VByteArray(PackedStringArray.Psa.data(psa#0))))));

// definition axiom for PackedStringArrayMarshalling.__default.toVal for all literals(revealed)
axiom true
   ==> (forall psa#0: DatatypeType :: 
    {:weight 3} { PackedStringArrayMarshalling.__default.toVal(Lit(psa#0)) } 
    PackedStringArrayMarshalling.__default.toVal#canCall(Lit(psa#0))
         || ($Is(psa#0, Tclass.PackedStringArray.Psa())
           && Lit(PackedStringArray.__default.WF(Lit(psa#0))))
       ==> PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArray.Psa.Psa_q(Lit(psa#0))
         && PackedStringArrayMarshalling.__default.toVal(Lit(psa#0))
           == Lit(#GenericMarshalling.V.VTuple(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                    $Box(Lit(#GenericMarshalling.V.VUint32Array(Lit(PackedStringArray.Psa.offsets(Lit(psa#0))))))), 
                  $Box(Lit(#GenericMarshalling.V.VByteArray(Lit(PackedStringArray.Psa.data(Lit(psa#0)))))))))));

const unique class.PackedKVMarshalling.__default: ClassName;

function Tclass.PackedKVMarshalling.__default() : Ty;

// Tclass.PackedKVMarshalling.__default Tag
axiom Tag(Tclass.PackedKVMarshalling.__default())
   == Tagclass.PackedKVMarshalling.__default;

const unique Tagclass.PackedKVMarshalling.__default: TyTag;

// Box/unbox axiom for Tclass.PackedKVMarshalling.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.PackedKVMarshalling.__default()) } 
  $IsBox(bx, Tclass.PackedKVMarshalling.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.PackedKVMarshalling.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.PackedKVMarshalling.__default()) } 
  $Is($o, Tclass.PackedKVMarshalling.__default())
     <==> $o == null || dtype($o) == Tclass.PackedKVMarshalling.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.PackedKVMarshalling.__default(), $h) } 
  $IsAlloc($o, Tclass.PackedKVMarshalling.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for PackedKVMarshalling._default.grammar
function PackedKVMarshalling.__default.grammar() : DatatypeType;

function PackedKVMarshalling.__default.grammar#canCall() : bool;

// consequence axiom for PackedKVMarshalling.__default.grammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(PackedKVMarshalling.__default.grammar())))
     && $Is(PackedKVMarshalling.__default.grammar(), Tclass.GenericMarshalling.G());

function PackedKVMarshalling.__default.grammar#requires() : bool;

// #requires axiom for PackedKVMarshalling.__default.grammar
axiom PackedKVMarshalling.__default.grammar#requires() == true;

// definition axiom for PackedKVMarshalling.__default.grammar(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArrayMarshalling.__default.grammar#canCall()
     && PackedStringArrayMarshalling.__default.grammar#canCall()
     && PackedKVMarshalling.__default.grammar()
       == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(PackedStringArrayMarshalling.__default.grammar()))), 
              $Box(Lit(PackedStringArrayMarshalling.__default.grammar()))))));

// definition axiom for PackedKVMarshalling.__default.grammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedStringArrayMarshalling.__default.grammar#canCall()
     && PackedStringArrayMarshalling.__default.grammar#canCall()
     && PackedKVMarshalling.__default.grammar()
       == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(Lit(PackedStringArrayMarshalling.__default.grammar()))), 
              $Box(Lit(PackedStringArrayMarshalling.__default.grammar()))))));

// function declaration for PackedKVMarshalling._default.fromVal
function PackedKVMarshalling.__default.fromVal(v#0: DatatypeType) : DatatypeType;

function PackedKVMarshalling.__default.fromVal#canCall(v#0: DatatypeType) : bool;

// consequence axiom for PackedKVMarshalling.__default.fromVal
axiom true
   ==> (forall v#0: DatatypeType :: 
    { PackedKVMarshalling.__default.fromVal(v#0) } 
    PackedKVMarshalling.__default.fromVal#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(PackedKVMarshalling.__default.grammar())))
       ==> (Options.Option.Some_q(PackedKVMarshalling.__default.fromVal(v#0))
           ==> PackedKV.__default.WF($Unbox(Options.Option.value(PackedKVMarshalling.__default.fromVal(v#0))): DatatypeType))
         && $Is(PackedKVMarshalling.__default.fromVal(v#0), 
          Tclass.Options.Option(Tclass.PackedKV.Pkv())));

function PackedKVMarshalling.__default.fromVal#requires(DatatypeType) : bool;

// #requires axiom for PackedKVMarshalling.__default.fromVal
axiom (forall v#0: DatatypeType :: 
  { PackedKVMarshalling.__default.fromVal#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> PackedKVMarshalling.__default.fromVal#requires(v#0)
       == GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
        v#0, 
        Lit(PackedKVMarshalling.__default.grammar())));

// definition axiom for PackedKVMarshalling.__default.fromVal(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { PackedKVMarshalling.__default.fromVal(v#0) } 
    PackedKVMarshalling.__default.fromVal#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(PackedKVMarshalling.__default.grammar())))
       ==> PackedStringArrayMarshalling.__default.fromVal#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType)
         && (var okeys#0 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType); 
          PackedStringArrayMarshalling.__default.fromVal#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType)
             && (var omsgs#0 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType); 
              Options.Option.Some_q(okeys#0) && Options.Option.Some_q(omsgs#0)
                 ==> (var pkv#0 := #PackedKV.Pkv.Pkv($Unbox(Options.Option.value(okeys#0)): DatatypeType, 
                      $Unbox(Options.Option.value(omsgs#0)): DatatypeType); 
                  PackedKV.__default.WF#canCall(pkv#0))))
         && PackedKVMarshalling.__default.fromVal(v#0)
           == (var okeys#0 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType); 
            (var omsgs#0 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType); 
              (if Options.Option.Some_q(okeys#0) && Options.Option.Some_q(omsgs#0)
                 then (var pkv#0 := #PackedKV.Pkv.Pkv($Unbox(Options.Option.value(okeys#0)): DatatypeType, 
                      $Unbox(Options.Option.value(omsgs#0)): DatatypeType); 
                  (if PackedKV.__default.WF(pkv#0)
                     then #Options.Option.Some($Box(pkv#0))
                     else #Options.Option.None()))
                 else #Options.Option.None()))));

// definition axiom for PackedKVMarshalling.__default.fromVal for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { PackedKVMarshalling.__default.fromVal(Lit(v#0)) } 
    PackedKVMarshalling.__default.fromVal#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(PackedKVMarshalling.__default.grammar()))))
       ==> PackedStringArrayMarshalling.__default.fromVal#canCall($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType)
         && (var okeys#1 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType); 
          PackedStringArrayMarshalling.__default.fromVal#canCall($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType)
             && (var omsgs#1 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType); 
              Options.Option.Some_q(okeys#1) && Options.Option.Some_q(omsgs#1)
                 ==> (var pkv#1 := #PackedKV.Pkv.Pkv($Unbox(Options.Option.value(okeys#1)): DatatypeType, 
                      $Unbox(Options.Option.value(omsgs#1)): DatatypeType); 
                  PackedKV.__default.WF#canCall(pkv#1))))
         && PackedKVMarshalling.__default.fromVal(Lit(v#0))
           == (var okeys#1 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType); 
            (var omsgs#1 := PackedStringArrayMarshalling.__default.fromVal($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType); 
              (if Options.Option.Some_q(okeys#1) && Options.Option.Some_q(omsgs#1)
                 then (var pkv#1 := #PackedKV.Pkv.Pkv($Unbox(Options.Option.value(okeys#1)): DatatypeType, 
                      $Unbox(Options.Option.value(omsgs#1)): DatatypeType); 
                  (if PackedKV.__default.WF(pkv#1)
                     then #Options.Option.Some($Box(pkv#1))
                     else #Options.Option.None()))
                 else #Options.Option.None()))));

// function declaration for PackedKVMarshalling._default.toVal
function PackedKVMarshalling.__default.toVal(pkv#0: DatatypeType) : DatatypeType;

function PackedKVMarshalling.__default.toVal#canCall(pkv#0: DatatypeType) : bool;

// consequence axiom for PackedKVMarshalling.__default.toVal
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKVMarshalling.__default.toVal(pkv#0) } 
    PackedKVMarshalling.__default.toVal#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          PackedKVMarshalling.__default.toVal(pkv#0), 
          Lit(PackedKVMarshalling.__default.grammar()))
         && $Is(PackedKVMarshalling.__default.toVal(pkv#0), Tclass.GenericMarshalling.V()));

function PackedKVMarshalling.__default.toVal#requires(DatatypeType) : bool;

// #requires axiom for PackedKVMarshalling.__default.toVal
axiom (forall pkv#0: DatatypeType :: 
  { PackedKVMarshalling.__default.toVal#requires(pkv#0) } 
  $Is(pkv#0, Tclass.PackedKV.Pkv())
     ==> PackedKVMarshalling.__default.toVal#requires(pkv#0)
       == PackedKV.__default.WF(pkv#0));

// definition axiom for PackedKVMarshalling.__default.toVal(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    { PackedKVMarshalling.__default.toVal(pkv#0) } 
    PackedKVMarshalling.__default.toVal#canCall(pkv#0)
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && PackedKV.__default.WF(pkv#0))
       ==> PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArrayMarshalling.__default.toVal#canCall(PackedKV.Pkv.keys(pkv#0))
         && 
        PackedKV.Pkv.Pkv_q(pkv#0)
         && PackedStringArrayMarshalling.__default.toVal#canCall(PackedKV.Pkv.messages(pkv#0))
         && PackedKVMarshalling.__default.toVal(pkv#0)
           == #GenericMarshalling.V.VTuple(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                $Box(PackedStringArrayMarshalling.__default.toVal(PackedKV.Pkv.keys(pkv#0)))), 
              $Box(PackedStringArrayMarshalling.__default.toVal(PackedKV.Pkv.messages(pkv#0))))));

// definition axiom for PackedKVMarshalling.__default.toVal for all literals(revealed)
axiom true
   ==> (forall pkv#0: DatatypeType :: 
    {:weight 3} { PackedKVMarshalling.__default.toVal(Lit(pkv#0)) } 
    PackedKVMarshalling.__default.toVal#canCall(Lit(pkv#0))
         || ($Is(pkv#0, Tclass.PackedKV.Pkv()) && Lit(PackedKV.__default.WF(Lit(pkv#0))))
       ==> PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArrayMarshalling.__default.toVal#canCall(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))
         && 
        PackedKV.Pkv.Pkv_q(Lit(pkv#0))
         && PackedStringArrayMarshalling.__default.toVal#canCall(Lit(PackedKV.Pkv.messages(Lit(pkv#0))))
         && PackedKVMarshalling.__default.toVal(Lit(pkv#0))
           == Lit(#GenericMarshalling.V.VTuple(Lit(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, 
                    $Box(Lit(PackedStringArrayMarshalling.__default.toVal(Lit(PackedKV.Pkv.keys(Lit(pkv#0))))))), 
                  $Box(Lit(PackedStringArrayMarshalling.__default.toVal(Lit(PackedKV.Pkv.messages(Lit(pkv#0)))))))))));

const unique class.Marshalling.__default: ClassName;

function Tclass.Marshalling.__default() : Ty;

// Tclass.Marshalling.__default Tag
axiom Tag(Tclass.Marshalling.__default()) == Tagclass.Marshalling.__default;

const unique Tagclass.Marshalling.__default: TyTag;

// Box/unbox axiom for Tclass.Marshalling.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.Marshalling.__default()) } 
  $IsBox(bx, Tclass.Marshalling.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.Marshalling.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.Marshalling.__default()) } 
  $Is($o, Tclass.Marshalling.__default())
     <==> $o == null || dtype($o) == Tclass.Marshalling.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.Marshalling.__default(), $h) } 
  $IsAlloc($o, Tclass.Marshalling.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for Marshalling._default.BucketGrammar
function Marshalling.__default.BucketGrammar() : DatatypeType;

function Marshalling.__default.BucketGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.BucketGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(Marshalling.__default.BucketGrammar())))
     && $Is(Marshalling.__default.BucketGrammar(), Tclass.GenericMarshalling.G());

function Marshalling.__default.BucketGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.BucketGrammar
axiom Marshalling.__default.BucketGrammar#requires() == true;

// definition axiom for Marshalling.__default.BucketGrammar(revealed)
axiom true
   ==> 
  true
   ==> PackedKVMarshalling.__default.grammar#canCall()
     && Marshalling.__default.BucketGrammar()
       == Lit(PackedKVMarshalling.__default.grammar());

// definition axiom for Marshalling.__default.BucketGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> PackedKVMarshalling.__default.grammar#canCall()
     && Marshalling.__default.BucketGrammar()
       == Lit(PackedKVMarshalling.__default.grammar());

// function declaration for Marshalling._default.PivotTableGrammar
function Marshalling.__default.PivotTableGrammar() : DatatypeType;

function Marshalling.__default.PivotTableGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.PivotTableGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(Marshalling.__default.PivotTableGrammar())))
     && $Is(Marshalling.__default.PivotTableGrammar(), Tclass.GenericMarshalling.G());

function Marshalling.__default.PivotTableGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.PivotTableGrammar
axiom Marshalling.__default.PivotTableGrammar#requires() == true;

// definition axiom for Marshalling.__default.PivotTableGrammar(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.PivotTableGrammar()
     == Lit(#GenericMarshalling.G.GArray(Lit(#GenericMarshalling.G.GByteArray())));

// definition axiom for Marshalling.__default.PivotTableGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.PivotTableGrammar()
     == Lit(#GenericMarshalling.G.GArray(Lit(#GenericMarshalling.G.GByteArray())));

// function declaration for Marshalling._default.PivotNodeGrammar
function Marshalling.__default.PivotNodeGrammar() : DatatypeType;

function Marshalling.__default.PivotNodeGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.PivotNodeGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(Marshalling.__default.PivotNodeGrammar())))
     && $Is(Marshalling.__default.PivotNodeGrammar(), Tclass.GenericMarshalling.G());

function Marshalling.__default.PivotNodeGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.PivotNodeGrammar
axiom Marshalling.__default.PivotNodeGrammar#requires() == true;

// definition axiom for Marshalling.__default.PivotNodeGrammar(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.PivotTableGrammar#canCall()
     && Marshalling.__default.BucketGrammar#canCall()
     && Marshalling.__default.PivotNodeGrammar()
       == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(Marshalling.__default.PivotTableGrammar()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64Array()))), 
              $Box(Lit(#GenericMarshalling.G.GArray(Lit(Marshalling.__default.BucketGrammar()))))))));

// definition axiom for Marshalling.__default.PivotNodeGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.PivotTableGrammar#canCall()
     && Marshalling.__default.BucketGrammar#canCall()
     && Marshalling.__default.PivotNodeGrammar()
       == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(Marshalling.__default.PivotTableGrammar()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64Array()))), 
              $Box(Lit(#GenericMarshalling.G.GArray(Lit(Marshalling.__default.BucketGrammar()))))))));

// function declaration for Marshalling._default.IndirectionTableRowGrammar
function Marshalling.__default.IndirectionTableRowGrammar() : DatatypeType;

function Marshalling.__default.IndirectionTableRowGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.IndirectionTableRowGrammar
axiom true
   ==> 
  true
   ==> $Is(Marshalling.__default.IndirectionTableRowGrammar(), 
    Tclass.GenericMarshalling.G());

function Marshalling.__default.IndirectionTableRowGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.IndirectionTableRowGrammar
axiom Marshalling.__default.IndirectionTableRowGrammar#requires() == true;

// definition axiom for Marshalling.__default.IndirectionTableRowGrammar(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.IndirectionTableRowGrammar()
     == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64()))), 
              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
            $Box(Lit(#GenericMarshalling.G.GUint64Array()))))));

// definition axiom for Marshalling.__default.IndirectionTableRowGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.IndirectionTableRowGrammar()
     == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64()))), 
              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
            $Box(Lit(#GenericMarshalling.G.GUint64Array()))))));

// function declaration for Marshalling._default.IndirectionTableGrammar
function Marshalling.__default.IndirectionTableGrammar() : DatatypeType;

function Marshalling.__default.IndirectionTableGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.IndirectionTableGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(Marshalling.__default.IndirectionTableGrammar())))
     && $Is(Marshalling.__default.IndirectionTableGrammar(), Tclass.GenericMarshalling.G());

function Marshalling.__default.IndirectionTableGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.IndirectionTableGrammar
axiom Marshalling.__default.IndirectionTableGrammar#requires() == true;

// definition axiom for Marshalling.__default.IndirectionTableGrammar(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.IndirectionTableRowGrammar#canCall()
     && Marshalling.__default.IndirectionTableGrammar()
       == Lit(#GenericMarshalling.G.GArray(Lit(Marshalling.__default.IndirectionTableRowGrammar())));

// definition axiom for Marshalling.__default.IndirectionTableGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.IndirectionTableRowGrammar#canCall()
     && Marshalling.__default.IndirectionTableGrammar()
       == Lit(#GenericMarshalling.G.GArray(Lit(Marshalling.__default.IndirectionTableRowGrammar())));

// function declaration for Marshalling._default.SuperblockGrammar
function Marshalling.__default.SuperblockGrammar() : DatatypeType;

function Marshalling.__default.SuperblockGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.SuperblockGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(Marshalling.__default.SuperblockGrammar())))
     && $Is(Marshalling.__default.SuperblockGrammar(), Tclass.GenericMarshalling.G());

function Marshalling.__default.SuperblockGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.SuperblockGrammar
axiom Marshalling.__default.SuperblockGrammar#requires() == true;

// definition axiom for Marshalling.__default.SuperblockGrammar(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.SuperblockGrammar()
     == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64()))), 
              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
            $Box(Lit(#GenericMarshalling.G.GUint64()))))));

// definition axiom for Marshalling.__default.SuperblockGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.SuperblockGrammar()
     == Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64()))), 
              $Box(Lit(#GenericMarshalling.G.GUint64()))), 
            $Box(Lit(#GenericMarshalling.G.GUint64()))))));

// function declaration for Marshalling._default.SectorGrammar
function Marshalling.__default.SectorGrammar() : DatatypeType;

function Marshalling.__default.SectorGrammar#canCall() : bool;

// consequence axiom for Marshalling.__default.SectorGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(Marshalling.__default.SectorGrammar())))
     && $Is(Marshalling.__default.SectorGrammar(), Tclass.GenericMarshalling.G());

function Marshalling.__default.SectorGrammar#requires() : bool;

// #requires axiom for Marshalling.__default.SectorGrammar
axiom Marshalling.__default.SectorGrammar#requires() == true;

// definition axiom for Marshalling.__default.SectorGrammar(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.SuperblockGrammar#canCall()
     && Marshalling.__default.IndirectionTableGrammar#canCall()
     && Marshalling.__default.PivotNodeGrammar#canCall()
     && Marshalling.__default.SectorGrammar()
       == Lit(#GenericMarshalling.G.GTaggedUnion(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(Marshalling.__default.SuperblockGrammar()))), 
                $Box(Lit(Marshalling.__default.IndirectionTableGrammar()))), 
              $Box(Lit(Marshalling.__default.PivotNodeGrammar()))))));

// definition axiom for Marshalling.__default.SectorGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> Marshalling.__default.SuperblockGrammar#canCall()
     && Marshalling.__default.IndirectionTableGrammar#canCall()
     && Marshalling.__default.PivotNodeGrammar#canCall()
     && Marshalling.__default.SectorGrammar()
       == Lit(#GenericMarshalling.G.GTaggedUnion(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(Marshalling.__default.SuperblockGrammar()))), 
                $Box(Lit(Marshalling.__default.IndirectionTableGrammar()))), 
              $Box(Lit(Marshalling.__default.PivotNodeGrammar()))))));

// function declaration for Marshalling._default.pivotTableWeight
function Marshalling.__default.pivotTableWeight($ly: LayerType, keys#0: Seq Box) : int;

function Marshalling.__default.pivotTableWeight#canCall(keys#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { Marshalling.__default.pivotTableWeight($LS($ly), keys#0) } 
  Marshalling.__default.pivotTableWeight($LS($ly), keys#0)
     == Marshalling.__default.pivotTableWeight($ly, keys#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { Marshalling.__default.pivotTableWeight(AsFuelBottom($ly), keys#0) } 
  Marshalling.__default.pivotTableWeight($ly, keys#0)
     == Marshalling.__default.pivotTableWeight($LZ, keys#0));

// consequence axiom for Marshalling.__default.pivotTableWeight
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box :: 
    { Marshalling.__default.pivotTableWeight($ly, keys#0) } 
    Marshalling.__default.pivotTableWeight#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> LitInt(0) <= Marshalling.__default.pivotTableWeight($ly, keys#0));

function Marshalling.__default.pivotTableWeight#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.pivotTableWeight
axiom (forall $ly: LayerType, keys#0: Seq Box :: 
  { Marshalling.__default.pivotTableWeight#requires($ly, keys#0) } 
  $Is(keys#0, TSeq(Tclass.KeyType.Key()))
     ==> Marshalling.__default.pivotTableWeight#requires($ly, keys#0) == true);

// definition axiom for Marshalling.__default.pivotTableWeight(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box :: 
    { Marshalling.__default.pivotTableWeight($LS($ly), keys#0) } 
    Marshalling.__default.pivotTableWeight#canCall(keys#0)
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> (Seq#Length(keys#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), keys#0)
             && Marshalling.__default.pivotTableWeight#canCall(Sequences.__default.DropLast(Tclass.KeyType.Key(), keys#0))
             && GenericMarshalling.__default.SizeOfV#canCall(Lit(#GenericMarshalling.V.VUint64(LitInt(0))))
             && Sequences.__default.Last#canCall(Tclass.KeyType.Key(), keys#0))
         && Marshalling.__default.pivotTableWeight($LS($ly), keys#0)
           == (if Seq#Length(keys#0) == LitInt(0)
             then 0
             else Marshalling.__default.pivotTableWeight($ly, Sequences.__default.DropLast(Tclass.KeyType.Key(), keys#0))
               + GenericMarshalling.__default.SizeOfV(StartFuel_GenericMarshalling._default.SizeOfV, 
                Lit(#GenericMarshalling.V.VUint64(LitInt(0))))
               + Seq#Length($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), keys#0)): Seq Box)));

// definition axiom for Marshalling.__default.pivotTableWeight for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, keys#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.pivotTableWeight($LS($ly), Lit(keys#0)) } 
    Marshalling.__default.pivotTableWeight#canCall(Lit(keys#0))
         || $Is(keys#0, TSeq(Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(keys#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.KeyType.Key(), Lit(keys#0))
             && Marshalling.__default.pivotTableWeight#canCall(Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(keys#0))))
             && GenericMarshalling.__default.SizeOfV#canCall(Lit(#GenericMarshalling.V.VUint64(LitInt(0))))
             && Sequences.__default.Last#canCall(Tclass.KeyType.Key(), Lit(keys#0)))
         && Marshalling.__default.pivotTableWeight($LS($ly), Lit(keys#0))
           == (if Seq#Length(Lit(keys#0)) == LitInt(0)
             then 0
             else Marshalling.__default.pivotTableWeight($LS($ly), Lit(Sequences.__default.DropLast(Tclass.KeyType.Key(), Lit(keys#0))))
               + GenericMarshalling.__default.SizeOfV(StartFuel_GenericMarshalling._default.SizeOfV, 
                Lit(#GenericMarshalling.V.VUint64(LitInt(0))))
               + Seq#Length(Lit($Unbox(Sequences.__default.Last(Tclass.KeyType.Key(), Lit(keys#0))): Seq Box))));

// function declaration for Marshalling._default.isStrictlySortedKeySeqIterate
function Marshalling.__default.isStrictlySortedKeySeqIterate($ly: LayerType, a#0: Seq Box, i#0: int) : bool;

function Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(a#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, i#0: int :: 
  { Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), a#0, i#0) } 
  Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), a#0, i#0)
     == Marshalling.__default.isStrictlySortedKeySeqIterate($ly, a#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box, i#0: int :: 
  { Marshalling.__default.isStrictlySortedKeySeqIterate(AsFuelBottom($ly), a#0, i#0) } 
  Marshalling.__default.isStrictlySortedKeySeqIterate($ly, a#0, i#0)
     == Marshalling.__default.isStrictlySortedKeySeqIterate($LZ, a#0, i#0));

// consequence axiom for Marshalling.__default.isStrictlySortedKeySeqIterate
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, i#0: int :: 
    { Marshalling.__default.isStrictlySortedKeySeqIterate($ly, a#0, i#0) } 
    Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(a#0, i#0)
         || ($Is(a#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(1) <= i#0
           && i#0 <= Seq#Length(a#0))
       ==> (Marshalling.__default.isStrictlySortedKeySeqIterate($ly, a#0, i#0)
         <==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
          Seq#Drop(a#0, i#0 - 1))));

function Marshalling.__default.isStrictlySortedKeySeqIterate#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for Marshalling.__default.isStrictlySortedKeySeqIterate
axiom (forall $ly: LayerType, a#0: Seq Box, i#0: int :: 
  { Marshalling.__default.isStrictlySortedKeySeqIterate#requires($ly, a#0, i#0) } 
  $Is(a#0, TSeq(Tclass.KeyType.Key()))
     ==> Marshalling.__default.isStrictlySortedKeySeqIterate#requires($ly, a#0, i#0)
       == (LitInt(1) <= i#0 && i#0 <= Seq#Length(a#0)));

const MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted0: LayerType;

// definition axiom for Marshalling.__default.isStrictlySortedKeySeqIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, i#0: int :: 
    { Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), a#0, i#0) } 
    Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(a#0, i#0)
         || ($Is(a#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(1) <= i#0
           && i#0 <= Seq#Length(a#0))
       ==> (i#0 != Seq#Length(a#0)
           ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(a#0, i#0 - 1)): Seq Box, $Unbox(Seq#Index(a#0, i#0)): Seq Box)
             && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(a#0, i#0 - 1)): Seq Box, $Unbox(Seq#Index(a#0, i#0)): Seq Box)
               ==> Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(a#0, i#0 + 1)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted0)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted0))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted0)
           == MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted0
         && Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), a#0, i#0)
           == (if i#0 == Seq#Length(a#0)
             then true
             else (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(a#0, i#0 - 1)): Seq Box, $Unbox(Seq#Index(a#0, i#0)): Seq Box)
               then Marshalling.__default.isStrictlySortedKeySeqIterate($ly, a#0, i#0 + 1)
               else false)));

const MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1: LayerType;

// definition axiom for Marshalling.__default.isStrictlySortedKeySeqIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box, i#0: int :: 
    {:weight 3} { Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), Lit(a#0), LitInt(i#0)) } 
    Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(Lit(a#0), LitInt(i#0))
         || ($Is(a#0, TSeq(Tclass.KeyType.Key()))
           && 
          LitInt(1) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(a#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(a#0))
           ==> Lexicographic__Byte__Order.__default.lt#canCall($Unbox(Seq#Index(Lit(a#0), LitInt(i#0 - 1))): Seq Box, 
              $Unbox(Seq#Index(Lit(a#0), LitInt(i#0))): Seq Box)
             && (Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(a#0), LitInt(i#0 - 1))): Seq Box, 
                $Unbox(Seq#Index(Lit(a#0), LitInt(i#0))): Seq Box)
               ==> Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(Lit(a#0), LitInt(i#0 + 1))))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1)
           == MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted1
         && Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), Lit(a#0), LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(a#0))
             then true
             else (if Lexicographic__Byte__Order.__default.lt($Unbox(Seq#Index(Lit(a#0), LitInt(i#0 - 1))): Seq Box, 
                $Unbox(Seq#Index(Lit(a#0), LitInt(i#0))): Seq Box)
               then Marshalling.__default.isStrictlySortedKeySeqIterate($LS($ly), Lit(a#0), LitInt(i#0 + 1))
               else false)));

// function declaration for Marshalling._default.isStrictlySortedKeySeq
function Marshalling.__default.isStrictlySortedKeySeq($ly: LayerType, a#0: Seq Box) : bool;

function Marshalling.__default.isStrictlySortedKeySeq#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.isStrictlySortedKeySeq($LS($ly), a#0) } 
  Marshalling.__default.isStrictlySortedKeySeq($LS($ly), a#0)
     == Marshalling.__default.isStrictlySortedKeySeq($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.isStrictlySortedKeySeq(AsFuelBottom($ly), a#0) } 
  Marshalling.__default.isStrictlySortedKeySeq($ly, a#0)
     == Marshalling.__default.isStrictlySortedKeySeq($LZ, a#0));

// consequence axiom for Marshalling.__default.isStrictlySortedKeySeq
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Marshalling.__default.isStrictlySortedKeySeq($ly, a#0) } 
    Marshalling.__default.isStrictlySortedKeySeq#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.KeyType.Key()))
       ==> (Marshalling.__default.isStrictlySortedKeySeq($ly, a#0)
         <==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, a#0)));

function Marshalling.__default.isStrictlySortedKeySeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.isStrictlySortedKeySeq
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.isStrictlySortedKeySeq#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.KeyType.Key()))
     ==> Marshalling.__default.isStrictlySortedKeySeq#requires($ly, a#0) == true);

const MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted2: LayerType;

// definition axiom for Marshalling.__default.isStrictlySortedKeySeq(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Marshalling.__default.isStrictlySortedKeySeq($LS($ly), a#0) } 
    Marshalling.__default.isStrictlySortedKeySeq#canCall(a#0)
         || $Is(a#0, TSeq(Tclass.KeyType.Key()))
       ==> (Seq#Length(a#0) >= LitInt(2)
           ==> Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(a#0, LitInt(1)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted2)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted2))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted2)
           == MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted2
         && Marshalling.__default.isStrictlySortedKeySeq($LS($ly), a#0)
           == (if Seq#Length(a#0) >= LitInt(2)
             then Marshalling.__default.isStrictlySortedKeySeqIterate($LS($LZ), a#0, LitInt(1))
             else true));

const MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted3: LayerType;

// definition axiom for Marshalling.__default.isStrictlySortedKeySeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.isStrictlySortedKeySeq($LS($ly), Lit(a#0)) } 
    Marshalling.__default.isStrictlySortedKeySeq#canCall(Lit(a#0))
         || $Is(a#0, TSeq(Tclass.KeyType.Key()))
       ==> (Seq#Length(Lit(a#0)) >= LitInt(2)
           ==> Marshalling.__default.isStrictlySortedKeySeqIterate#canCall(Lit(a#0), LitInt(1)))
         && 
        StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted3)
         && StartFuelAssert_Lexicographic_Byte_Order._default.IsStrictlySorted
           == $LS($LS(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted3))
         && AsFuelBottom(MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted3)
           == MoreFuel_Lexicographic_Byte_Order._default.IsStrictlySorted3
         && Marshalling.__default.isStrictlySortedKeySeq($LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) >= LitInt(2)
             then Marshalling.__default.isStrictlySortedKeySeqIterate($LS($LZ), Lit(a#0), LitInt(1))
             else true));

// function declaration for Marshalling._default.keyValSeqToKeySeq
function Marshalling.__default.keyValSeqToKeySeq($ly: LayerType, vs#0: Seq Box) : DatatypeType;

function Marshalling.__default.keyValSeqToKeySeq#canCall(vs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, vs#0: Seq Box :: 
  { Marshalling.__default.keyValSeqToKeySeq($LS($ly), vs#0) } 
  Marshalling.__default.keyValSeqToKeySeq($LS($ly), vs#0)
     == Marshalling.__default.keyValSeqToKeySeq($ly, vs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, vs#0: Seq Box :: 
  { Marshalling.__default.keyValSeqToKeySeq(AsFuelBottom($ly), vs#0) } 
  Marshalling.__default.keyValSeqToKeySeq($ly, vs#0)
     == Marshalling.__default.keyValSeqToKeySeq($LZ, vs#0));

// consequence axiom for Marshalling.__default.keyValSeqToKeySeq
axiom true
   ==> (forall $ly: LayerType, vs#0: Seq Box :: 
    { Marshalling.__default.keyValSeqToKeySeq($ly, vs#0) } 
    Marshalling.__default.keyValSeqToKeySeq#canCall(vs#0)
         || ($Is(vs#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          (forall i#0: int :: 
            { $Unbox(Seq#Index(vs#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(vs#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(vs#0, i#0)): DatatypeType))
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(vs#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(vs#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(vs#0, i#1)): DatatypeType, 
                Lit(#GenericMarshalling.G.GByteArray()))))
       ==> (Options.Option.Some_q(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0))
           <==> (forall i#2: int :: 
            { $Unbox(Seq#Index(vs#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(vs#0)
               ==> Seq#Length(GenericMarshalling.V.b($Unbox(Seq#Index(vs#0, i#2)): DatatypeType))
                 <= LitInt(KeyType.__default.MaxLen())))
         && (Options.Option.Some_q(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0))
           ==> Seq#Length($Unbox(Options.Option.value(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0))): Seq Box)
             == Seq#Length(vs#0))
         && (Options.Option.Some_q(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0))
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index(vs#0, i#3)): DatatypeType } 
              { $Unbox(Seq#Index($Unbox(Options.Option.value(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0))): Seq Box, 
                  i#3)): Seq Box } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(vs#0)
               ==> Seq#Equal($Unbox(Seq#Index($Unbox(Options.Option.value(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0))): Seq Box, 
                    i#3)): Seq Box, 
                GenericMarshalling.V.b($Unbox(Seq#Index(vs#0, i#3)): DatatypeType))))
         && $Is(Marshalling.__default.keyValSeqToKeySeq($ly, vs#0), 
          Tclass.Options.Option(TSeq(Tclass.KeyType.Key()))));

function Marshalling.__default.keyValSeqToKeySeq#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.keyValSeqToKeySeq
axiom (forall $ly: LayerType, vs#0: Seq Box :: 
  { Marshalling.__default.keyValSeqToKeySeq#requires($ly, vs#0) } 
  $Is(vs#0, TSeq(Tclass.GenericMarshalling.V()))
     ==> Marshalling.__default.keyValSeqToKeySeq#requires($ly, vs#0)
       == ((forall i#4: int :: 
          { $Unbox(Seq#Index(vs#0, i#4)): DatatypeType } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(vs#0)
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(vs#0, i#4)): DatatypeType))
         && (forall i#5: int :: 
          { $Unbox(Seq#Index(vs#0, i#5)): DatatypeType } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(vs#0)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(vs#0, i#5)): DatatypeType, 
              Lit(#GenericMarshalling.G.GByteArray())))));

// definition axiom for Marshalling.__default.keyValSeqToKeySeq(revealed)
axiom true
   ==> (forall $ly: LayerType, vs#0: Seq Box :: 
    { Marshalling.__default.keyValSeqToKeySeq($LS($ly), vs#0) } 
    Marshalling.__default.keyValSeqToKeySeq#canCall(vs#0)
         || ($Is(vs#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          (forall i#4: int :: 
            { $Unbox(Seq#Index(vs#0, i#4)): DatatypeType } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(vs#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(vs#0, i#4)): DatatypeType))
           && (forall i#5: int :: 
            { $Unbox(Seq#Index(vs#0, i#5)): DatatypeType } 
            LitInt(0) <= i#5 && i#5 < Seq#Length(vs#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(vs#0, i#5)): DatatypeType, 
                Lit(#GenericMarshalling.G.GByteArray()))))
       ==> (Seq#Length(vs#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), vs#0)
             && Marshalling.__default.keyValSeqToKeySeq#canCall(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), vs#0))
             && (var prefix#0 := Marshalling.__default.keyValSeqToKeySeq($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), vs#0)); 
              Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), vs#0)
                 && (Options.Option.Some_q(prefix#0) ==> KeyType.__default.MaxLen#canCall())))
         && Marshalling.__default.keyValSeqToKeySeq($LS($ly), vs#0)
           == (if Seq#Length(vs#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (var prefix#0 := Marshalling.__default.keyValSeqToKeySeq($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), vs#0)); 
              (var last#0 := GenericMarshalling.V.b($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), vs#0)): DatatypeType); 
                (if Options.Option.Some_q(prefix#0)
                     && Seq#Length(last#0) <= LitInt(KeyType.__default.MaxLen())
                   then (var klast#0 := last#0; 
                    #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(prefix#0)): Seq Box, 
                          Seq#Build(Seq#Empty(): Seq Box, $Box(klast#0))))))
                   else #Options.Option.None())))));

// definition axiom for Marshalling.__default.keyValSeqToKeySeq for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, vs#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.keyValSeqToKeySeq($LS($ly), Lit(vs#0)) } 
    Marshalling.__default.keyValSeqToKeySeq#canCall(Lit(vs#0))
         || ($Is(vs#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          (forall i#6: int :: 
            { $Unbox(Seq#Index(vs#0, i#6)): DatatypeType } 
            LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(vs#0))
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(Lit(vs#0), i#6)): DatatypeType))
           && (forall i#7: int :: 
            { $Unbox(Seq#Index(vs#0, i#7)): DatatypeType } 
            LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(vs#0))
               ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(Lit(vs#0), i#7)): DatatypeType, 
                Lit(#GenericMarshalling.G.GByteArray()))))
       ==> (Seq#Length(Lit(vs#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Lit(vs#0))
             && Marshalling.__default.keyValSeqToKeySeq#canCall(Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(vs#0))))
             && (var prefix#1 := Lit(Marshalling.__default.keyValSeqToKeySeq($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(vs#0))))); 
              Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Lit(vs#0))
                 && (Options.Option.Some_q(prefix#1) ==> KeyType.__default.MaxLen#canCall())))
         && Marshalling.__default.keyValSeqToKeySeq($LS($ly), Lit(vs#0))
           == (if Seq#Length(Lit(vs#0)) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (var prefix#1 := Lit(Marshalling.__default.keyValSeqToKeySeq($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(vs#0))))); 
              (var last#1 := Lit(GenericMarshalling.V.b(Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(vs#0))): DatatypeType))); 
                (if Options.Option.Some_q(prefix#1)
                     && Seq#Length(last#1) <= LitInt(KeyType.__default.MaxLen())
                   then (var klast#1 := last#1; 
                    #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(prefix#1)): Seq Box, 
                          Seq#Build(Seq#Empty(): Seq Box, $Box(klast#1))))))
                   else #Options.Option.None())))));

// function declaration for Marshalling._default.valToStrictlySortedKeySeq
function Marshalling.__default.valToStrictlySortedKeySeq(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToStrictlySortedKeySeq#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToStrictlySortedKeySeq
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToStrictlySortedKeySeq(v#0) } 
    Marshalling.__default.valToStrictlySortedKeySeq#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.PivotTableGrammar())))
       ==> (Options.Option.Some_q(Marshalling.__default.valToStrictlySortedKeySeq(v#0))
           ==> Lexicographic__Byte__Order.__default.IsStrictlySorted(StartFuel_Lexicographic_Byte_Order._default.IsStrictlySorted, 
            $Unbox(Options.Option.value(Marshalling.__default.valToStrictlySortedKeySeq(v#0))): Seq Box))
         && (Options.Option.Some_q(Marshalling.__default.valToStrictlySortedKeySeq(v#0))
           ==> Seq#Length($Unbox(Options.Option.value(Marshalling.__default.valToStrictlySortedKeySeq(v#0))): Seq Box)
             == Seq#Length(GenericMarshalling.V.a(v#0)))
         && $Is(Marshalling.__default.valToStrictlySortedKeySeq(v#0), 
          Tclass.Options.Option(TSeq(Tclass.KeyType.Key()))));

function Marshalling.__default.valToStrictlySortedKeySeq#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToStrictlySortedKeySeq
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToStrictlySortedKeySeq#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToStrictlySortedKeySeq#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.PivotTableGrammar()))));

// definition axiom for Marshalling.__default.valToStrictlySortedKeySeq(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToStrictlySortedKeySeq(v#0) } 
    Marshalling.__default.valToStrictlySortedKeySeq#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.PivotTableGrammar())))
       ==> Marshalling.__default.keyValSeqToKeySeq#canCall(GenericMarshalling.V.a(v#0))
         && (var keys#0 := Marshalling.__default.keyValSeqToKeySeq($LS($LZ), GenericMarshalling.V.a(v#0)); 
          Options.Option.Some_q(keys#0)
             ==> Marshalling.__default.isStrictlySortedKeySeq#canCall($Unbox(Options.Option.value(keys#0)): Seq Box))
         && Marshalling.__default.valToStrictlySortedKeySeq(v#0)
           == (var keys#0 := Marshalling.__default.keyValSeqToKeySeq($LS($LZ), GenericMarshalling.V.a(v#0)); 
            (if Options.Option.Some_q(keys#0)
                 && Marshalling.__default.isStrictlySortedKeySeq(StartFuel_Marshalling._default.isStrictlySortedKeySeq, 
                  $Unbox(Options.Option.value(keys#0)): Seq Box)
               then keys#0
               else #Options.Option.None())));

// definition axiom for Marshalling.__default.valToStrictlySortedKeySeq for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToStrictlySortedKeySeq(Lit(v#0)) } 
    Marshalling.__default.valToStrictlySortedKeySeq#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.PivotTableGrammar()))))
       ==> Marshalling.__default.keyValSeqToKeySeq#canCall(Lit(GenericMarshalling.V.a(Lit(v#0))))
         && (var keys#1 := Lit(Marshalling.__default.keyValSeqToKeySeq($LS($LZ), Lit(GenericMarshalling.V.a(Lit(v#0))))); 
          Options.Option.Some_q(keys#1)
             ==> Marshalling.__default.isStrictlySortedKeySeq#canCall($Unbox(Options.Option.value(keys#1)): Seq Box))
         && Marshalling.__default.valToStrictlySortedKeySeq(Lit(v#0))
           == (var keys#1 := Lit(Marshalling.__default.keyValSeqToKeySeq($LS($LZ), Lit(GenericMarshalling.V.a(Lit(v#0))))); 
            (if Options.Option.Some_q(keys#1)
                 && Marshalling.__default.isStrictlySortedKeySeq(StartFuel_Marshalling._default.isStrictlySortedKeySeq, 
                  Lit($Unbox(Options.Option.value(keys#1)): Seq Box))
               then keys#1
               else #Options.Option.None())));

// function declaration for Marshalling._default.valToPivots
function Marshalling.__default.valToPivots(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToPivots#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToPivots
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToPivots(v#0) } 
    Marshalling.__default.valToPivots#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.PivotTableGrammar())))
       ==> (Options.Option.Some_q(Marshalling.__default.valToPivots(v#0))
           ==> PivotsLib.__default.WFPivots($Unbox(Options.Option.value(Marshalling.__default.valToPivots(v#0))): Seq Box))
         && (Options.Option.Some_q(Marshalling.__default.valToPivots(v#0))
           ==> Seq#Length($Unbox(Options.Option.value(Marshalling.__default.valToPivots(v#0))): Seq Box)
             == Seq#Length(GenericMarshalling.V.a(v#0)))
         && $Is(Marshalling.__default.valToPivots(v#0), 
          Tclass.Options.Option(TSeq(Tclass.KeyType.Key()))));

function Marshalling.__default.valToPivots#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToPivots
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToPivots#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToPivots#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.PivotTableGrammar()))));

// definition axiom for Marshalling.__default.valToPivots(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToPivots(v#0) } 
    Marshalling.__default.valToPivots#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.PivotTableGrammar())))
       ==> Marshalling.__default.valToStrictlySortedKeySeq#canCall(v#0)
         && Marshalling.__default.valToPivots(v#0)
           == (var s#0 := Marshalling.__default.valToStrictlySortedKeySeq(v#0); 
            (if Options.Option.Some_q(s#0)
                 && (Seq#Length($Unbox(Options.Option.value(s#0)): Seq Box) > 0
                   ==> Seq#Length($Unbox(Seq#Index($Unbox(Options.Option.value(s#0)): Seq Box, LitInt(0))): Seq Box)
                     != 0)
               then (if Seq#Length($Unbox(Options.Option.value(s#0)): Seq Box) > 0
                 then s#0
                 else s#0)
               else #Options.Option.None())));

// definition axiom for Marshalling.__default.valToPivots for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToPivots(Lit(v#0)) } 
    Marshalling.__default.valToPivots#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.PivotTableGrammar()))))
       ==> Marshalling.__default.valToStrictlySortedKeySeq#canCall(Lit(v#0))
         && Marshalling.__default.valToPivots(Lit(v#0))
           == (var s#1 := Lit(Marshalling.__default.valToStrictlySortedKeySeq(Lit(v#0))); 
            (if Options.Option.Some_q(s#1)
                 && (Seq#Length(Lit($Unbox(Options.Option.value(s#1)): Seq Box)) > 0
                   ==> Seq#Length($Unbox(Seq#Index(Lit($Unbox(Options.Option.value(s#1)): Seq Box), LitInt(0))): Seq Box)
                     != 0)
               then (if Seq#Length(Lit($Unbox(Options.Option.value(s#1)): Seq Box)) > 0
                 then s#1
                 else s#1)
               else #Options.Option.None())));

// function declaration for Marshalling._default.valToBucket
function Marshalling.__default.valToBucket(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToBucket#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToBucket
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToBucket(v#0) } 
    Marshalling.__default.valToBucket#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.BucketGrammar())))
       ==> $Is(Marshalling.__default.valToBucket(v#0), 
        Tclass.Options.Option(Tclass.BucketsLib.Bucket())));

function Marshalling.__default.valToBucket#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToBucket
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToBucket#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToBucket#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.BucketGrammar()))));

// definition axiom for Marshalling.__default.valToBucket(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToBucket(v#0) } 
    Marshalling.__default.valToBucket#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.BucketGrammar())))
       ==> PackedKVMarshalling.__default.fromVal#canCall(v#0)
         && (var pkv#0 := PackedKVMarshalling.__default.fromVal(v#0); 
          (Options.Option.Some_q(pkv#0)
               ==> PackedKV.__default.WeightPkv#canCall($Unbox(Options.Option.value(pkv#0)): DatatypeType)
                 && NativeTypes.__default.Uint32UpperBound#canCall())
             && (Options.Option.Some_q(pkv#0)
                 && PackedKV.__default.WeightPkv($Unbox(Options.Option.value(pkv#0)): DatatypeType)
                   < NativeTypes.__default.Uint32UpperBound()
               ==> PackedKV.__default.I#canCall($Unbox(Options.Option.value(pkv#0)): DatatypeType)))
         && Marshalling.__default.valToBucket(v#0)
           == (var pkv#0 := PackedKVMarshalling.__default.fromVal(v#0); 
            (if Options.Option.Some_q(pkv#0)
                 && PackedKV.__default.WeightPkv($Unbox(Options.Option.value(pkv#0)): DatatypeType)
                   < NativeTypes.__default.Uint32UpperBound()
               then #Options.Option.Some($Box(PackedKV.__default.I($Unbox(Options.Option.value(pkv#0)): DatatypeType)))
               else #Options.Option.None())));

// definition axiom for Marshalling.__default.valToBucket for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToBucket(Lit(v#0)) } 
    Marshalling.__default.valToBucket#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.BucketGrammar()))))
       ==> PackedKVMarshalling.__default.fromVal#canCall(Lit(v#0))
         && (var pkv#1 := Lit(PackedKVMarshalling.__default.fromVal(Lit(v#0))); 
          (Options.Option.Some_q(pkv#1)
               ==> PackedKV.__default.WeightPkv#canCall($Unbox(Options.Option.value(pkv#1)): DatatypeType)
                 && NativeTypes.__default.Uint32UpperBound#canCall())
             && (Options.Option.Some_q(pkv#1)
                 && PackedKV.__default.WeightPkv($Unbox(Options.Option.value(pkv#1)): DatatypeType)
                   < NativeTypes.__default.Uint32UpperBound()
               ==> PackedKV.__default.I#canCall($Unbox(Options.Option.value(pkv#1)): DatatypeType)))
         && Marshalling.__default.valToBucket(Lit(v#0))
           == (var pkv#1 := Lit(PackedKVMarshalling.__default.fromVal(Lit(v#0))); 
            (if Options.Option.Some_q(pkv#1)
                 && PackedKV.__default.WeightPkv(Lit($Unbox(Options.Option.value(pkv#1)): DatatypeType))
                   < NativeTypes.__default.Uint32UpperBound()
               then #Options.Option.Some($Box(Lit(PackedKV.__default.I(Lit($Unbox(Options.Option.value(pkv#1)): DatatypeType)))))
               else #Options.Option.None())));

// function declaration for Marshalling._default.valToBuckets
function Marshalling.__default.valToBuckets($ly: LayerType, a#0: Seq Box) : DatatypeType;

function Marshalling.__default.valToBuckets#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.valToBuckets($LS($ly), a#0) } 
  Marshalling.__default.valToBuckets($LS($ly), a#0)
     == Marshalling.__default.valToBuckets($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.valToBuckets(AsFuelBottom($ly), a#0) } 
  Marshalling.__default.valToBuckets($ly, a#0)
     == Marshalling.__default.valToBuckets($LZ, a#0));

// consequence axiom for Marshalling.__default.valToBuckets
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Marshalling.__default.valToBuckets($ly, a#0) } 
    Marshalling.__default.valToBuckets#canCall(a#0)
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          (forall i#0: int :: 
            { $Unbox(Seq#Index(a#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(a#0, i#0)): DatatypeType))
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(a#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(a#0, i#1)): DatatypeType, 
                Lit(Marshalling.__default.BucketGrammar()))))
       ==> (Options.Option.Some_q(Marshalling.__default.valToBuckets($ly, a#0))
           <==> (forall i#2: int :: 
            { $Unbox(Seq#Index(a#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
               ==> Options.Option.Some_q(Marshalling.__default.valToBucket($Unbox(Seq#Index(a#0, i#2)): DatatypeType))))
         && (Options.Option.Some_q(Marshalling.__default.valToBuckets($ly, a#0))
           ==> Seq#Length($Unbox(Options.Option.value(Marshalling.__default.valToBuckets($ly, a#0))): Seq Box)
             == Seq#Length(a#0))
         && (Options.Option.Some_q(Marshalling.__default.valToBuckets($ly, a#0))
           ==> (forall i#3: int :: 
            { $Unbox(Seq#Index($Unbox(Options.Option.value(Marshalling.__default.valToBuckets($ly, a#0))): Seq Box, 
                  i#3)): DatatypeType } 
            LitInt(0) <= i#3
                 && i#3
                   < Seq#Length($Unbox(Options.Option.value(Marshalling.__default.valToBuckets($ly, a#0))): Seq Box)
               ==> BucketsLib.__default.WFBucket($Unbox(Seq#Index($Unbox(Options.Option.value(Marshalling.__default.valToBuckets($ly, a#0))): Seq Box, 
                    i#3)): DatatypeType)))
         && $Is(Marshalling.__default.valToBuckets($ly, a#0), 
          Tclass.Options.Option(TSeq(Tclass.BucketsLib.Bucket()))));

function Marshalling.__default.valToBuckets#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.valToBuckets
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.valToBuckets#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
     ==> Marshalling.__default.valToBuckets#requires($ly, a#0)
       == ((forall i#4: int :: 
          { $Unbox(Seq#Index(a#0, i#4)): DatatypeType } 
          LitInt(0) <= i#4 && i#4 < Seq#Length(a#0)
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(a#0, i#4)): DatatypeType))
         && (forall i#5: int :: 
          { $Unbox(Seq#Index(a#0, i#5)): DatatypeType } 
          LitInt(0) <= i#5 && i#5 < Seq#Length(a#0)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(a#0, i#5)): DatatypeType, 
              Lit(Marshalling.__default.BucketGrammar())))));

// definition axiom for Marshalling.__default.valToBuckets(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Marshalling.__default.valToBuckets($LS($ly), a#0) } 
    Marshalling.__default.valToBuckets#canCall(a#0)
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          (forall i#4: int :: 
            { $Unbox(Seq#Index(a#0, i#4)): DatatypeType } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(a#0, i#4)): DatatypeType))
           && (forall i#5: int :: 
            { $Unbox(Seq#Index(a#0, i#5)): DatatypeType } 
            LitInt(0) <= i#5 && i#5 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(a#0, i#5)): DatatypeType, 
                Lit(Marshalling.__default.BucketGrammar()))))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), a#0)
             && Marshalling.__default.valToBuckets#canCall(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0))
             && 
            Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), a#0)
             && Marshalling.__default.valToBucket#canCall($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), a#0)): DatatypeType))
         && Marshalling.__default.valToBuckets($LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (var pref#0 := Marshalling.__default.valToBuckets($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0)); 
              (var bucket#0 := Marshalling.__default.valToBucket($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), a#0)): DatatypeType); 
                (if Options.Option.Some_q(pref#0) && Options.Option.Some_q(bucket#0)
                   then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(pref#0)): Seq Box, 
                        Seq#Build(Seq#Empty(): Seq Box, Options.Option.value(bucket#0)))))
                   else #Options.Option.None())))));

// definition axiom for Marshalling.__default.valToBuckets for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.valToBuckets($LS($ly), Lit(a#0)) } 
    Marshalling.__default.valToBuckets#canCall(Lit(a#0))
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          (forall i#6: int :: 
            { $Unbox(Seq#Index(a#0, i#6)): DatatypeType } 
            LitInt(0) <= i#6 && i#6 < Seq#Length(Lit(a#0))
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(Lit(a#0), i#6)): DatatypeType))
           && (forall i#7: int :: 
            { $Unbox(Seq#Index(a#0, i#7)): DatatypeType } 
            LitInt(0) <= i#7 && i#7 < Seq#Length(Lit(a#0))
               ==> GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(Lit(a#0), i#7)): DatatypeType, 
                Lit(Marshalling.__default.BucketGrammar()))))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Lit(a#0))
             && Marshalling.__default.valToBuckets#canCall(Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))
             && 
            Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Lit(a#0))
             && Marshalling.__default.valToBucket#canCall(Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(a#0))): DatatypeType)))
         && Marshalling.__default.valToBuckets($LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then #Options.Option.Some($Box(Lit(Seq#Empty(): Seq Box)))
             else (var pref#1 := Lit(Marshalling.__default.valToBuckets($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))); 
              (var bucket#1 := Lit(Marshalling.__default.valToBucket(Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(a#0))): DatatypeType))); 
                (if Options.Option.Some_q(pref#1) && Options.Option.Some_q(bucket#1)
                   then #Options.Option.Some($Box(Seq#Append($Unbox(Options.Option.value(pref#1)): Seq Box, 
                        Seq#Build(Seq#Empty(): Seq Box, 
                          $Box(Lit($Unbox(Options.Option.value(bucket#1)): DatatypeType))))))
                   else #Options.Option.None())))));

// function declaration for Marshalling._default.valToChildren
function Marshalling.__default.valToChildren(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToChildren#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToChildren
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToChildren(v#0) } 
    Marshalling.__default.valToChildren#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(#GenericMarshalling.G.GUint64Array())))
       ==> $Is(Marshalling.__default.valToChildren(v#0), 
        Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64()))));

function Marshalling.__default.valToChildren#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToChildren
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToChildren#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToChildren#requires(v#0)
       == GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
        v#0, 
        Lit(#GenericMarshalling.G.GUint64Array())));

// definition axiom for Marshalling.__default.valToChildren(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToChildren(v#0) } 
    Marshalling.__default.valToChildren#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(#GenericMarshalling.G.GUint64Array())))
       ==> Marshalling.__default.valToChildren(v#0)
         == #Options.Option.Some($Box(GenericMarshalling.V.ua(v#0))));

// definition axiom for Marshalling.__default.valToChildren for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToChildren(Lit(v#0)) } 
    Marshalling.__default.valToChildren#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(#GenericMarshalling.G.GUint64Array()))))
       ==> Marshalling.__default.valToChildren(Lit(v#0))
         == Lit(#Options.Option.Some($Box(Lit(GenericMarshalling.V.ua(Lit(v#0)))))));

// function declaration for Marshalling._default.valToNode
function Marshalling.__default.valToNode(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToNode#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToNode
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToNode(v#0) } 
    Marshalling.__default.valToNode#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.PivotNodeGrammar())))
       ==> (Options.Option.Some_q(Marshalling.__default.valToNode(v#0))
           ==> PivotBetreeSpec.__default.WFNode($Unbox(Options.Option.value(Marshalling.__default.valToNode(v#0))): DatatypeType))
         && $Is(Marshalling.__default.valToNode(v#0), 
          Tclass.Options.Option(Tclass.PivotBetreeGraph.Node())));

function Marshalling.__default.valToNode#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToNode
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToNode#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToNode#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.PivotNodeGrammar()))));

// definition axiom for Marshalling.__default.valToNode(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToNode(v#0) } 
    Marshalling.__default.valToNode#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.PivotNodeGrammar())))
       ==> (var pivots_len#0 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType)); 
          (var children_len#0 := Seq#Length(GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType)); 
            (var buckets_len#0 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType)); 
              Bounds.__default.MaxNumChildrenUint64#canCall()
                 && (pivots_len#0 <= LitInt(Bounds.__default.MaxNumChildrenUint64() - 1)
                     && (children_len#0 == LitInt(0) || children_len#0 == pivots_len#0 + 1)
                     && buckets_len#0 == pivots_len#0 + 1
                   ==> Marshalling.__default.valToPivots#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType)
                     && (!Options.Option.None_q(Marshalling.__default.valToPivots($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType))
                       ==> Marshalling.__default.valToPivots#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType)
                         && 
                        Marshalling.__default.valToChildren#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType)
                         && (!Options.Option.None_q(Marshalling.__default.valToChildren($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType))
                           ==> Marshalling.__default.valToChildren#canCall($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType)
                             && 
                            Marshalling.__default.valToBuckets#canCall(GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType))
                             && (var buckets#0 := Marshalling.__default.valToBuckets($LS($LZ), 
                                  GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType)); 
                              Options.Option.Some_q(buckets#0)
                                 ==> BucketWeights.__default.WeightBucketList#canCall($Unbox(Options.Option.value(buckets#0)): Seq Box)
                                   && Bounds.__default.MaxTotalBucketWeight#canCall())))))))
         && Marshalling.__default.valToNode(v#0)
           == (var pivots_len#0 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType)); 
            (var children_len#0 := Seq#Length(GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType)); 
              (var buckets_len#0 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType)); 
                (if pivots_len#0 <= LitInt(Bounds.__default.MaxNumChildrenUint64() - 1)
                     && (children_len#0 == LitInt(0) || children_len#0 == pivots_len#0 + 1)
                     && buckets_len#0 == pivots_len#0 + 1
                   then (if Options.Option.None_q(Marshalling.__default.valToPivots($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType))
                     then #Options.Option.None()
                     else (var pivots#1 := $Unbox(Options.Option.value(Marshalling.__default.valToPivots($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType))): Seq Box; 
                      (if Options.Option.None_q(Marshalling.__default.valToChildren($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType))
                         then #Options.Option.None()
                         else (var children#1 := $Unbox(Options.Option.value(Marshalling.__default.valToChildren($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType))): Seq Box; 
                          (var buckets#1 := Marshalling.__default.valToBuckets($LS($LZ), 
                                GenericMarshalling.V.a($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType)); 
                            (if Options.Option.Some_q(buckets#1)
                                 && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                                    $Unbox(Options.Option.value(buckets#1)): Seq Box)
                                   <= LitInt(Bounds.__default.MaxTotalBucketWeight())
                               then (var node#1 := #PivotBetreeGraph.Node.Node(pivots#1, 
                                    (if Seq#Length(children#1) == LitInt(0)
                                       then #Options.Option.None()
                                       else #Options.Option.Some($Box(children#1))), 
                                    $Unbox(Options.Option.value(buckets#1)): Seq Box); 
                                #Options.Option.Some($Box(node#1)))
                               else #Options.Option.None()))))))
                   else #Options.Option.None())))));

// definition axiom for Marshalling.__default.valToNode for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToNode(Lit(v#0)) } 
    Marshalling.__default.valToNode#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.PivotNodeGrammar()))))
       ==> (var pivots_len#1 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType)); 
          (var children_len#1 := Seq#Length(GenericMarshalling.V.ua($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType)); 
            (var buckets_len#1 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType)); 
              Bounds.__default.MaxNumChildrenUint64#canCall()
                 && (pivots_len#1 <= LitInt(Bounds.__default.MaxNumChildrenUint64() - 1)
                     && (children_len#1 == LitInt(0) || children_len#1 == pivots_len#1 + 1)
                     && buckets_len#1 == pivots_len#1 + 1
                   ==> Marshalling.__default.valToPivots#canCall($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType)
                     && (!Options.Option.None_q(Marshalling.__default.valToPivots($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType))
                       ==> Marshalling.__default.valToPivots#canCall($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType)
                         && 
                        Marshalling.__default.valToChildren#canCall($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType)
                         && (!Options.Option.None_q(Marshalling.__default.valToChildren($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType))
                           ==> Marshalling.__default.valToChildren#canCall($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType)
                             && 
                            Marshalling.__default.valToBuckets#canCall(GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType))
                             && (var buckets#2 := Marshalling.__default.valToBuckets($LS($LZ), 
                                  GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType)); 
                              Options.Option.Some_q(buckets#2)
                                 ==> BucketWeights.__default.WeightBucketList#canCall($Unbox(Options.Option.value(buckets#2)): Seq Box)
                                   && Bounds.__default.MaxTotalBucketWeight#canCall())))))))
         && Marshalling.__default.valToNode(Lit(v#0))
           == (var pivots_len#1 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType)); 
            (var children_len#1 := Seq#Length(GenericMarshalling.V.ua($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType)); 
              (var buckets_len#1 := Seq#Length(GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType)); 
                (if pivots_len#1 <= LitInt(Bounds.__default.MaxNumChildrenUint64() - 1)
                     && (children_len#1 == LitInt(0) || children_len#1 == pivots_len#1 + 1)
                     && buckets_len#1 == pivots_len#1 + 1
                   then (if Options.Option.None_q(Marshalling.__default.valToPivots($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType))
                     then #Options.Option.None()
                     else (var pivots#3 := $Unbox(Options.Option.value(Marshalling.__default.valToPivots($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType))): Seq Box; 
                      (if Options.Option.None_q(Marshalling.__default.valToChildren($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType))
                         then #Options.Option.None()
                         else (var children#3 := $Unbox(Options.Option.value(Marshalling.__default.valToChildren($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType))): Seq Box; 
                          (var buckets#3 := Marshalling.__default.valToBuckets($LS($LZ), 
                                GenericMarshalling.V.a($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType)); 
                            (if Options.Option.Some_q(buckets#3)
                                 && BucketWeights.__default.WeightBucketList(StartFuel_BucketWeights._default.WeightBucketList, 
                                    $Unbox(Options.Option.value(buckets#3)): Seq Box)
                                   <= LitInt(Bounds.__default.MaxTotalBucketWeight())
                               then (var node#3 := #PivotBetreeGraph.Node.Node(pivots#3, 
                                    (if Seq#Length(children#3) == LitInt(0)
                                       then #Options.Option.None()
                                       else #Options.Option.Some($Box(children#3))), 
                                    $Unbox(Options.Option.value(buckets#3)): Seq Box); 
                                #Options.Option.Some($Box(node#3)))
                               else #Options.Option.None()))))))
                   else #Options.Option.None())))));

// function declaration for Marshalling._default.valToIndirectionTableMaps
function Marshalling.__default.valToIndirectionTableMaps($ly: LayerType, a#0: Seq Box) : DatatypeType;

function Marshalling.__default.valToIndirectionTableMaps#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.valToIndirectionTableMaps($LS($ly), a#0) } 
  Marshalling.__default.valToIndirectionTableMaps($LS($ly), a#0)
     == Marshalling.__default.valToIndirectionTableMaps($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.valToIndirectionTableMaps(AsFuelBottom($ly), a#0) } 
  Marshalling.__default.valToIndirectionTableMaps($ly, a#0)
     == Marshalling.__default.valToIndirectionTableMaps($LZ, a#0));

// consequence axiom for Marshalling.__default.valToIndirectionTableMaps
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Marshalling.__default.valToIndirectionTableMaps($ly, a#0) } 
    Marshalling.__default.valToIndirectionTableMaps#canCall(a#0)
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Seq#Length(a#0) <= LitInt(Bounds.__default.IndirectionTableMaxSize())
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(a#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(a#0, i#0)): DatatypeType))
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(a#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(a#0, i#1)): DatatypeType, 
                Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array())))))))))
       ==> (Options.Option.Some_q(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))
           ==> Map#Card(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))
             == Seq#Length(a#0))
         && (Options.Option.Some_q(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))
           ==> Set#Equal(Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType)), 
            Map#Domain(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))))
         && (Options.Option.Some_q(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))
           ==> (forall v#0: DatatypeType :: 
            { DiskLayout.__default.ValidNodeLocation(v#0) } 
              { Map#Values(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))[$Box(v#0)] } 
            $Is(v#0, Tclass.DiskLayout.Location())
                 && Map#Values(SectorType.IndirectionTable.locs($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))[$Box(v#0)]
               ==> DiskLayout.__default.ValidNodeLocation(v#0)))
         && (Options.Option.Some_q(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))
           ==> (forall ref#0: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))[$Box(ref#0)]): Seq Box } 
              { Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))[$Box(ref#0)]
               ==> Seq#Length($Unbox(Map#Elements(SectorType.IndirectionTable.graph($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTableMaps($ly, a#0))): DatatypeType))[$Box(ref#0)]): Seq Box)
                 <= LitInt(Bounds.__default.MaxNumChildren())))
         && $Is(Marshalling.__default.valToIndirectionTableMaps($ly, a#0), 
          Tclass.Options.Option(Tclass.SectorType.IndirectionTable())));

function Marshalling.__default.valToIndirectionTableMaps#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.valToIndirectionTableMaps
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { Marshalling.__default.valToIndirectionTableMaps#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
     ==> Marshalling.__default.valToIndirectionTableMaps#requires($ly, a#0)
       == (
        Seq#Length(a#0) <= LitInt(Bounds.__default.IndirectionTableMaxSize())
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(a#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(a#0, i#2)): DatatypeType))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(a#0, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(a#0)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(a#0, i#3)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))))));

// definition axiom for Marshalling.__default.valToIndirectionTableMaps(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { Marshalling.__default.valToIndirectionTableMaps($LS($ly), a#0) } 
    Marshalling.__default.valToIndirectionTableMaps#canCall(a#0)
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Seq#Length(a#0) <= LitInt(Bounds.__default.IndirectionTableMaxSize())
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(a#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(a#0, i#2)): DatatypeType))
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(a#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(a#0, i#3)): DatatypeType, 
                Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array())))))))))
       ==> (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), a#0)
             && Marshalling.__default.valToIndirectionTableMaps#canCall(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0))
             && (var res#0 := Marshalling.__default.valToIndirectionTableMaps($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0)); 
              !Options.Option.None_q(res#0)
                 ==> (var table#0 := $Unbox(Options.Option.value(res#0)): DatatypeType; 
                  Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), a#0)
                     && (var tuple#0 := $Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), a#0)): DatatypeType; 
                      (var ref#1 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(0))): DatatypeType); 
                        (var addr#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(1))): DatatypeType); 
                          (var len#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(2))): DatatypeType); 
                            (var succs#0 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(3))): DatatypeType); 
                              (var loc#0 := #DiskLayout.Location.Location(addr#0, len#0); 
                                SectorType.IndirectionTable.IndirectionTable_q(table#0)
                                   && (!Map#Domain(SectorType.IndirectionTable.graph(table#0))[$Box(ref#1)]
                                     ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0))
                                   && (DiskLayout.__default.ValidNodeLocation#canCall(loc#0)
                                       && DiskLayout.__default.ValidNodeLocation(loc#0)
                                     ==> Bounds.__default.MaxNumChildren#canCall())
                                   && (!(
                                      Map#Domain(SectorType.IndirectionTable.graph(table#0))[$Box(ref#1)]
                                       || !DiskLayout.__default.ValidNodeLocation(loc#0)
                                       || Seq#Length(succs#0) > Bounds.__default.MaxNumChildren())
                                     ==> SectorType.IndirectionTable.IndirectionTable_q(table#0)
                                       && SectorType.IndirectionTable.IndirectionTable_q(table#0)))))))))))
         && Marshalling.__default.valToIndirectionTableMaps($LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then #Options.Option.Some($Box(Lit(#SectorType.IndirectionTable.IndirectionTable(Lit(Map#Empty(): Map Box Box), Lit(Map#Empty(): Map Box Box)))))
             else (var res#0 := Marshalling.__default.valToIndirectionTableMaps($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0)); 
              (if Options.Option.None_q(res#0)
                 then #Options.Option.None()
                 else (var table#1 := $Unbox(Options.Option.value(res#0)): DatatypeType; 
                  (var tuple#1 := $Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), a#0)): DatatypeType; 
                    (var ref#2 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(0))): DatatypeType); 
                      (var addr#1 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(1))): DatatypeType); 
                        (var len#1 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(2))): DatatypeType); 
                          (var succs#1 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(3))): DatatypeType); 
                            (var loc#1 := #DiskLayout.Location.Location(addr#1, len#1); 
                              (if Map#Domain(SectorType.IndirectionTable.graph(table#1))[$Box(ref#2)]
                                   || !DiskLayout.__default.ValidNodeLocation(loc#1)
                                   || Seq#Length(succs#1) > Bounds.__default.MaxNumChildren()
                                 then #Options.Option.None()
                                 else #Options.Option.Some($Box(#SectorType.IndirectionTable.IndirectionTable(Map#Build(SectorType.IndirectionTable.locs(table#1), $Box(ref#2), $Box(loc#1)), 
                                      Map#Build(SectorType.IndirectionTable.graph(table#1), $Box(ref#2), $Box(succs#1)))))))))))))))));

// definition axiom for Marshalling.__default.valToIndirectionTableMaps for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.valToIndirectionTableMaps($LS($ly), Lit(a#0)) } 
    Marshalling.__default.valToIndirectionTableMaps#canCall(Lit(a#0))
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Seq#Length(Lit(a#0)) <= LitInt(Bounds.__default.IndirectionTableMaxSize())
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(a#0, i#4)): DatatypeType } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(Lit(a#0))
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(Lit(a#0), i#4)): DatatypeType))
           && (forall i#5: int :: 
            { $Unbox(Seq#Index(a#0, i#5)): DatatypeType } 
            LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(a#0))
               ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(Lit(a#0), i#5)): DatatypeType, 
                Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array())))))))))
       ==> (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Lit(a#0))
             && Marshalling.__default.valToIndirectionTableMaps#canCall(Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))
             && (var res#1 := Lit(Marshalling.__default.valToIndirectionTableMaps($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))); 
              !Options.Option.None_q(res#1)
                 ==> (var table#2 := $Unbox(Options.Option.value(res#1)): DatatypeType; 
                  Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Lit(a#0))
                     && (var tuple#2 := Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(a#0))): DatatypeType); 
                      (var ref#3 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(0))): DatatypeType); 
                        (var addr#2 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(1))): DatatypeType); 
                          (var len#2 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(2))): DatatypeType); 
                            (var succs#2 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(3))): DatatypeType); 
                              (var loc#2 := #DiskLayout.Location.Location(addr#2, len#2); 
                                SectorType.IndirectionTable.IndirectionTable_q(table#2)
                                   && (!Map#Domain(SectorType.IndirectionTable.graph(table#2))[$Box(ref#3)]
                                     ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#2))
                                   && (DiskLayout.__default.ValidNodeLocation#canCall(loc#2)
                                       && DiskLayout.__default.ValidNodeLocation(loc#2)
                                     ==> Bounds.__default.MaxNumChildren#canCall())
                                   && (!(
                                      Map#Domain(SectorType.IndirectionTable.graph(table#2))[$Box(ref#3)]
                                       || !DiskLayout.__default.ValidNodeLocation(loc#2)
                                       || Seq#Length(succs#2) > Bounds.__default.MaxNumChildren())
                                     ==> SectorType.IndirectionTable.IndirectionTable_q(table#2)
                                       && SectorType.IndirectionTable.IndirectionTable_q(table#2)))))))))))
         && Marshalling.__default.valToIndirectionTableMaps($LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then #Options.Option.Some($Box(Lit(#SectorType.IndirectionTable.IndirectionTable(Lit(Map#Empty(): Map Box Box), Lit(Map#Empty(): Map Box Box)))))
             else (var res#1 := Lit(Marshalling.__default.valToIndirectionTableMaps($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))); 
              (if Options.Option.None_q(res#1)
                 then #Options.Option.None()
                 else (var table#3 := Lit($Unbox(Options.Option.value(res#1)): DatatypeType); 
                  (var tuple#3 := Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(a#0))): DatatypeType); 
                    (var ref#4 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(0))): DatatypeType); 
                      (var addr#3 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(1))): DatatypeType); 
                        (var len#3 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(2))): DatatypeType); 
                          (var succs#3 := GenericMarshalling.V.ua($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(3))): DatatypeType); 
                            (var loc#3 := #DiskLayout.Location.Location(addr#3, len#3); 
                              (if Map#Domain(SectorType.IndirectionTable.graph(table#3))[$Box(ref#4)]
                                   || !DiskLayout.__default.ValidNodeLocation(loc#3)
                                   || Seq#Length(succs#3) > Bounds.__default.MaxNumChildren()
                                 then #Options.Option.None()
                                 else #Options.Option.Some($Box(#SectorType.IndirectionTable.IndirectionTable(Map#Build(Lit(SectorType.IndirectionTable.locs(table#3)), $Box(ref#4), $Box(loc#3)), 
                                      Map#Build(Lit(SectorType.IndirectionTable.graph(table#3)), $Box(ref#4), $Box(succs#3)))))))))))))))));

// function declaration for Marshalling._default.valToIndirectionTable
function Marshalling.__default.valToIndirectionTable(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToIndirectionTable#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToIndirectionTable
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToIndirectionTable(v#0) } 
    Marshalling.__default.valToIndirectionTable#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.IndirectionTableGrammar())))
       ==> (Options.Option.Some_q(Marshalling.__default.valToIndirectionTable(v#0))
           ==> BlockCache.__default.WFCompleteIndirectionTable($Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTable(v#0))): DatatypeType))
         && $Is(Marshalling.__default.valToIndirectionTable(v#0), 
          Tclass.Options.Option(Tclass.SectorType.IndirectionTable())));

function Marshalling.__default.valToIndirectionTable#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToIndirectionTable
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToIndirectionTable#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToIndirectionTable#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.IndirectionTableGrammar()))));

// definition axiom for Marshalling.__default.valToIndirectionTable(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToIndirectionTable(v#0) } 
    Marshalling.__default.valToIndirectionTable#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.IndirectionTableGrammar())))
       ==> Bounds.__default.IndirectionTableMaxSize#canCall()
         && (Seq#Length(GenericMarshalling.V.a(v#0))
             <= LitInt(Bounds.__default.IndirectionTableMaxSize())
           ==> Marshalling.__default.valToIndirectionTableMaps#canCall(GenericMarshalling.V.a(v#0))
             && (var t#0 := Marshalling.__default.valToIndirectionTableMaps(StartFuel_Marshalling._default.valToIndirectionTableMaps, 
                  GenericMarshalling.V.a(v#0)); 
              !Options.Option.None_q(t#0)
                 ==> (var res#0 := $Unbox(Options.Option.value(t#0)): DatatypeType; 
                  PivotBetreeGraph.__default.Root#canCall()
                     && SectorType.IndirectionTable.IndirectionTable_q(res#0)
                     && (Map#Domain(SectorType.IndirectionTable.graph(res#0))[$Box(PivotBetreeGraph.__default.Root())]
                       ==> SectorType.IndirectionTable.IndirectionTable_q(res#0)
                         && BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(res#0))))))
         && Marshalling.__default.valToIndirectionTable(v#0)
           == (if Seq#Length(GenericMarshalling.V.a(v#0))
               <= LitInt(Bounds.__default.IndirectionTableMaxSize())
             then (var t#0 := Marshalling.__default.valToIndirectionTableMaps(StartFuel_Marshalling._default.valToIndirectionTableMaps, 
                  GenericMarshalling.V.a(v#0)); 
              (if Options.Option.None_q(t#0)
                 then #Options.Option.None()
                 else (var res#1 := $Unbox(Options.Option.value(t#0)): DatatypeType; 
                  (if Map#Domain(SectorType.IndirectionTable.graph(res#1))[$Box(PivotBetreeGraph.__default.Root())]
                       && BlockCache.__default.GraphClosed(SectorType.IndirectionTable.graph(res#1))
                     then #Options.Option.Some($Box(res#1))
                     else #Options.Option.None()))))
             else #Options.Option.None()));

// definition axiom for Marshalling.__default.valToIndirectionTable for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToIndirectionTable(Lit(v#0)) } 
    Marshalling.__default.valToIndirectionTable#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.IndirectionTableGrammar()))))
       ==> Bounds.__default.IndirectionTableMaxSize#canCall()
         && (Seq#Length(Lit(GenericMarshalling.V.a(Lit(v#0))))
             <= LitInt(Bounds.__default.IndirectionTableMaxSize())
           ==> Marshalling.__default.valToIndirectionTableMaps#canCall(Lit(GenericMarshalling.V.a(Lit(v#0))))
             && (var t#1 := Lit(Marshalling.__default.valToIndirectionTableMaps(StartFuel_Marshalling._default.valToIndirectionTableMaps, 
                    Lit(GenericMarshalling.V.a(Lit(v#0))))); 
              !Options.Option.None_q(t#1)
                 ==> (var res#2 := $Unbox(Options.Option.value(t#1)): DatatypeType; 
                  PivotBetreeGraph.__default.Root#canCall()
                     && SectorType.IndirectionTable.IndirectionTable_q(res#2)
                     && (Map#Domain(SectorType.IndirectionTable.graph(res#2))[$Box(PivotBetreeGraph.__default.Root())]
                       ==> SectorType.IndirectionTable.IndirectionTable_q(res#2)
                         && BlockCache.__default.GraphClosed#canCall(SectorType.IndirectionTable.graph(res#2))))))
         && Marshalling.__default.valToIndirectionTable(Lit(v#0))
           == (if Seq#Length(Lit(GenericMarshalling.V.a(Lit(v#0))))
               <= LitInt(Bounds.__default.IndirectionTableMaxSize())
             then (var t#1 := Lit(Marshalling.__default.valToIndirectionTableMaps(StartFuel_Marshalling._default.valToIndirectionTableMaps, 
                    Lit(GenericMarshalling.V.a(Lit(v#0))))); 
              (if Options.Option.None_q(t#1)
                 then #Options.Option.None()
                 else (var res#3 := Lit($Unbox(Options.Option.value(t#1)): DatatypeType); 
                  (if Map#Domain(SectorType.IndirectionTable.graph(res#3))[$Box(PivotBetreeGraph.__default.Root())]
                       && BlockCache.__default.GraphClosed(Lit(SectorType.IndirectionTable.graph(res#3)))
                     then #Options.Option.Some($Box(res#3))
                     else #Options.Option.None()))))
             else #Options.Option.None()));

// function declaration for Marshalling._default.valToSuperblock
function Marshalling.__default.valToSuperblock(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToSuperblock#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToSuperblock
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToSuperblock(v#0) } 
    Marshalling.__default.valToSuperblock#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.SuperblockGrammar())))
       ==> $Is(Marshalling.__default.valToSuperblock(v#0), 
        Tclass.Options.Option(Tclass.SectorType.Superblock())));

function Marshalling.__default.valToSuperblock#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToSuperblock
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToSuperblock#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToSuperblock#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.SuperblockGrammar()))));

// definition axiom for Marshalling.__default.valToSuperblock(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToSuperblock(v#0) } 
    Marshalling.__default.valToSuperblock#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.SuperblockGrammar())))
       ==> (var counter#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType); 
          (var journalStart#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType); 
            (var journalLen#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType); 
              (var itlocAddr#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(3))): DatatypeType); 
                (var itlocLen#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(4))): DatatypeType); 
                  (var sup#0 := #SectorType.Superblock.Superblock(counter#0, 
                        journalStart#0, 
                        journalLen#0, 
                        #DiskLayout.Location.Location(itlocAddr#0, itlocLen#0)); 
                    JournalCache.__default.WFSuperblock#canCall(sup#0)))))))
         && Marshalling.__default.valToSuperblock(v#0)
           == (var counter#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(0))): DatatypeType); 
            (var journalStart#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(1))): DatatypeType); 
              (var journalLen#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(2))): DatatypeType); 
                (var itlocAddr#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(3))): DatatypeType); 
                  (var itlocLen#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(v#0), LitInt(4))): DatatypeType); 
                    (var sup#0 := #SectorType.Superblock.Superblock(counter#0, 
                          journalStart#0, 
                          journalLen#0, 
                          #DiskLayout.Location.Location(itlocAddr#0, itlocLen#0)); 
                      (if JournalCache.__default.WFSuperblock(sup#0)
                         then #Options.Option.Some($Box(sup#0))
                         else #Options.Option.None()))))))));

// definition axiom for Marshalling.__default.valToSuperblock for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToSuperblock(Lit(v#0)) } 
    Marshalling.__default.valToSuperblock#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.SuperblockGrammar()))))
       ==> (var counter#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType); 
          (var journalStart#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType); 
            (var journalLen#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType); 
              (var itlocAddr#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(3))): DatatypeType); 
                (var itlocLen#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(4))): DatatypeType); 
                  (var sup#1 := #SectorType.Superblock.Superblock(counter#1, 
                        journalStart#1, 
                        journalLen#1, 
                        #DiskLayout.Location.Location(itlocAddr#1, itlocLen#1)); 
                    JournalCache.__default.WFSuperblock#canCall(sup#1)))))))
         && Marshalling.__default.valToSuperblock(Lit(v#0))
           == (var counter#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(0))): DatatypeType); 
            (var journalStart#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(1))): DatatypeType); 
              (var journalLen#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(2))): DatatypeType); 
                (var itlocAddr#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(3))): DatatypeType); 
                  (var itlocLen#1 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(Lit(v#0))), LitInt(4))): DatatypeType); 
                    (var sup#1 := #SectorType.Superblock.Superblock(counter#1, 
                          journalStart#1, 
                          journalLen#1, 
                          #DiskLayout.Location.Location(itlocAddr#1, itlocLen#1)); 
                      (if JournalCache.__default.WFSuperblock(sup#1)
                         then #Options.Option.Some($Box(sup#1))
                         else #Options.Option.None()))))))));

// function declaration for Marshalling._default.valToSector
function Marshalling.__default.valToSector(v#0: DatatypeType) : DatatypeType;

function Marshalling.__default.valToSector#canCall(v#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.valToSector
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToSector(v#0) } 
    Marshalling.__default.valToSector#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.SectorGrammar())))
       ==> $Is(Marshalling.__default.valToSector(v#0), 
        Tclass.Options.Option(Tclass.SectorType.Sector())));

function Marshalling.__default.valToSector#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.valToSector
axiom (forall v#0: DatatypeType :: 
  { Marshalling.__default.valToSector#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> Marshalling.__default.valToSector#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(Marshalling.__default.SectorGrammar()))));

// definition axiom for Marshalling.__default.valToSector(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { Marshalling.__default.valToSector(v#0) } 
    Marshalling.__default.valToSector#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(Marshalling.__default.SectorGrammar())))
       ==> (GenericMarshalling.V.c(v#0) == LitInt(0)
           ==> Marshalling.__default.valToSuperblock#canCall(GenericMarshalling.V.val(v#0))
             && (!Options.Option.None_q(Marshalling.__default.valToSuperblock(GenericMarshalling.V.val(v#0)))
               ==> Marshalling.__default.valToSuperblock#canCall(GenericMarshalling.V.val(v#0))))
         && (GenericMarshalling.V.c(v#0) != LitInt(0)
           ==> (GenericMarshalling.V.c(v#0) == LitInt(1)
               ==> Marshalling.__default.valToIndirectionTable#canCall(GenericMarshalling.V.val(v#0))
                 && (!Options.Option.None_q(Marshalling.__default.valToIndirectionTable(GenericMarshalling.V.val(v#0)))
                   ==> Marshalling.__default.valToIndirectionTable#canCall(GenericMarshalling.V.val(v#0))))
             && (GenericMarshalling.V.c(v#0) != LitInt(1)
               ==> Marshalling.__default.valToNode#canCall(GenericMarshalling.V.val(v#0))
                 && (!Options.Option.None_q(Marshalling.__default.valToNode(GenericMarshalling.V.val(v#0)))
                   ==> Marshalling.__default.valToNode#canCall(GenericMarshalling.V.val(v#0)))))
         && Marshalling.__default.valToSector(v#0)
           == (if GenericMarshalling.V.c(v#0) == LitInt(0)
             then (if Options.Option.None_q(Marshalling.__default.valToSuperblock(GenericMarshalling.V.val(v#0)))
               then #Options.Option.None()
               else (var s#3 := $Unbox(Options.Option.value(Marshalling.__default.valToSuperblock(GenericMarshalling.V.val(v#0)))): DatatypeType; 
                #Options.Option.Some($Box(#SectorType.Sector.SectorSuperblock(s#3)))))
             else (if GenericMarshalling.V.c(v#0) == LitInt(1)
               then (if Options.Option.None_q(Marshalling.__default.valToIndirectionTable(GenericMarshalling.V.val(v#0)))
                 then #Options.Option.None()
                 else (var s#4 := $Unbox(Options.Option.value(Marshalling.__default.valToIndirectionTable(GenericMarshalling.V.val(v#0)))): DatatypeType; 
                  #Options.Option.Some($Box(#SectorType.Sector.SectorIndirectionTable(s#4)))))
               else (if Options.Option.None_q(Marshalling.__default.valToNode(GenericMarshalling.V.val(v#0)))
                 then #Options.Option.None()
                 else (var s#5 := $Unbox(Options.Option.value(Marshalling.__default.valToNode(GenericMarshalling.V.val(v#0)))): DatatypeType; 
                  #Options.Option.Some($Box(#SectorType.Sector.SectorNode(s#5))))))));

// definition axiom for Marshalling.__default.valToSector for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.valToSector(Lit(v#0)) } 
    Marshalling.__default.valToSector#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(Marshalling.__default.SectorGrammar()))))
       ==> (LitInt(GenericMarshalling.V.c(Lit(v#0))) == LitInt(0)
           ==> Marshalling.__default.valToSuperblock#canCall(Lit(GenericMarshalling.V.val(Lit(v#0))))
             && (!Lit(Options.Option.None_q(Lit(Marshalling.__default.valToSuperblock(Lit(GenericMarshalling.V.val(Lit(v#0)))))))
               ==> Marshalling.__default.valToSuperblock#canCall(Lit(GenericMarshalling.V.val(Lit(v#0))))))
         && (LitInt(GenericMarshalling.V.c(Lit(v#0))) != LitInt(0)
           ==> (LitInt(GenericMarshalling.V.c(Lit(v#0))) == LitInt(1)
               ==> Marshalling.__default.valToIndirectionTable#canCall(Lit(GenericMarshalling.V.val(Lit(v#0))))
                 && (!Lit(Options.Option.None_q(Lit(Marshalling.__default.valToIndirectionTable(Lit(GenericMarshalling.V.val(Lit(v#0)))))))
                   ==> Marshalling.__default.valToIndirectionTable#canCall(Lit(GenericMarshalling.V.val(Lit(v#0))))))
             && (LitInt(GenericMarshalling.V.c(Lit(v#0))) != LitInt(1)
               ==> Marshalling.__default.valToNode#canCall(Lit(GenericMarshalling.V.val(Lit(v#0))))
                 && (!Lit(Options.Option.None_q(Lit(Marshalling.__default.valToNode(Lit(GenericMarshalling.V.val(Lit(v#0)))))))
                   ==> Marshalling.__default.valToNode#canCall(Lit(GenericMarshalling.V.val(Lit(v#0)))))))
         && Marshalling.__default.valToSector(Lit(v#0))
           == (if LitInt(GenericMarshalling.V.c(Lit(v#0))) == LitInt(0)
             then (if Options.Option.None_q(Lit(Marshalling.__default.valToSuperblock(Lit(GenericMarshalling.V.val(Lit(v#0))))))
               then #Options.Option.None()
               else (var s#9 := Lit($Unbox(Options.Option.value(Lit(Marshalling.__default.valToSuperblock(Lit(GenericMarshalling.V.val(Lit(v#0))))))): DatatypeType); 
                Lit(#Options.Option.Some($Box(Lit(#SectorType.Sector.SectorSuperblock(s#9)))))))
             else (if LitInt(GenericMarshalling.V.c(Lit(v#0))) == LitInt(1)
               then (if Options.Option.None_q(Lit(Marshalling.__default.valToIndirectionTable(Lit(GenericMarshalling.V.val(Lit(v#0))))))
                 then #Options.Option.None()
                 else (var s#10 := Lit($Unbox(Options.Option.value(Lit(Marshalling.__default.valToIndirectionTable(Lit(GenericMarshalling.V.val(Lit(v#0))))))): DatatypeType); 
                  Lit(#Options.Option.Some($Box(Lit(#SectorType.Sector.SectorIndirectionTable(s#10)))))))
               else (if Options.Option.None_q(Lit(Marshalling.__default.valToNode(Lit(GenericMarshalling.V.val(Lit(v#0))))))
                 then #Options.Option.None()
                 else (var s#11 := Lit($Unbox(Options.Option.value(Lit(Marshalling.__default.valToNode(Lit(GenericMarshalling.V.val(Lit(v#0))))))): DatatypeType); 
                  Lit(#Options.Option.Some($Box(Lit(#SectorType.Sector.SectorNode(s#11))))))))));

// function declaration for Marshalling._default.parseSector
function Marshalling.__default.parseSector($ly: LayerType, data#0: Seq Box) : DatatypeType;

function Marshalling.__default.parseSector#canCall(data#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, data#0: Seq Box :: 
  { Marshalling.__default.parseSector($LS($ly), data#0) } 
  Marshalling.__default.parseSector($LS($ly), data#0)
     == Marshalling.__default.parseSector($ly, data#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, data#0: Seq Box :: 
  { Marshalling.__default.parseSector(AsFuelBottom($ly), data#0) } 
  Marshalling.__default.parseSector($ly, data#0)
     == Marshalling.__default.parseSector($LZ, data#0));

// consequence axiom for Marshalling.__default.parseSector
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box :: 
    { Marshalling.__default.parseSector($ly, data#0) } 
    Marshalling.__default.parseSector#canCall(data#0)
         || $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       ==> $Is(Marshalling.__default.parseSector($ly, data#0), 
        Tclass.Options.Option(Tclass.SectorType.Sector())));

function Marshalling.__default.parseSector#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.parseSector
axiom (forall $ly: LayerType, data#0: Seq Box :: 
  { Marshalling.__default.parseSector#requires($ly, data#0) } 
  $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Marshalling.__default.parseSector#requires($ly, data#0) == true);

// definition axiom for Marshalling.__default.parseSector(revealed)
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box :: 
    { Marshalling.__default.parseSector($LS($ly), data#0) } 
    Marshalling.__default.parseSector#canCall(data#0)
         || $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(data#0) < 18446744073709551616
           ==> Marshalling.__default.SectorGrammar#canCall()
             && GenericMarshalling.__default.parse__Val#canCall(data#0, Lit(Marshalling.__default.SectorGrammar()))
             && _System.Tuple2.___hMake2_q(GenericMarshalling.__default.parse__Val($LS($LZ), data#0, Lit(Marshalling.__default.SectorGrammar())))
             && (!Options.Option.None_q($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), data#0, Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)
               ==> Marshalling.__default.SectorGrammar#canCall()
                 && GenericMarshalling.__default.parse__Val#canCall(data#0, Lit(Marshalling.__default.SectorGrammar()))
                 && _System.Tuple2.___hMake2_q(GenericMarshalling.__default.parse__Val($LS($LZ), data#0, Lit(Marshalling.__default.SectorGrammar())))
                 && (var v#0 := $Unbox(Options.Option.value($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), data#0, Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)): DatatypeType; 
                  Marshalling.__default.valToSector#canCall(v#0))))
         && Marshalling.__default.parseSector($LS($ly), data#0)
           == (if Seq#Length(data#0) < 18446744073709551616
             then (if Options.Option.None_q($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), data#0, Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)
               then #Options.Option.None()
               else (var v#1 := $Unbox(Options.Option.value($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), data#0, Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)): DatatypeType; 
                Marshalling.__default.valToSector(v#1)))
             else #Options.Option.None()));

// definition axiom for Marshalling.__default.parseSector for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.parseSector($LS($ly), Lit(data#0)) } 
    Marshalling.__default.parseSector#canCall(Lit(data#0))
         || $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(Lit(data#0)) < 18446744073709551616
           ==> Marshalling.__default.SectorGrammar#canCall()
             && GenericMarshalling.__default.parse__Val#canCall(Lit(data#0), Lit(Marshalling.__default.SectorGrammar()))
             && _System.Tuple2.___hMake2_q(GenericMarshalling.__default.parse__Val($LS($LZ), Lit(data#0), Lit(Marshalling.__default.SectorGrammar())))
             && (!Options.Option.None_q($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), Lit(data#0), Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)
               ==> Marshalling.__default.SectorGrammar#canCall()
                 && GenericMarshalling.__default.parse__Val#canCall(Lit(data#0), Lit(Marshalling.__default.SectorGrammar()))
                 && _System.Tuple2.___hMake2_q(GenericMarshalling.__default.parse__Val($LS($LZ), Lit(data#0), Lit(Marshalling.__default.SectorGrammar())))
                 && (var v#2 := $Unbox(Options.Option.value($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), Lit(data#0), Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)): DatatypeType; 
                  Marshalling.__default.valToSector#canCall(v#2))))
         && Marshalling.__default.parseSector($LS($ly), Lit(data#0))
           == (if Seq#Length(Lit(data#0)) < 18446744073709551616
             then (if Options.Option.None_q($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), Lit(data#0), Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)
               then #Options.Option.None()
               else (var v#3 := $Unbox(Options.Option.value($Unbox(_System.Tuple2._0(GenericMarshalling.__default.parse__Val($LS($LZ), Lit(data#0), Lit(Marshalling.__default.SectorGrammar())))): DatatypeType)): DatatypeType; 
                Marshalling.__default.valToSector(v#3)))
             else #Options.Option.None()));

// function declaration for Marshalling._default.parseCheckedSector
function Marshalling.__default.parseCheckedSector($ly: LayerType, data#0: Seq Box) : DatatypeType;

function Marshalling.__default.parseCheckedSector#canCall(data#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, data#0: Seq Box :: 
  { Marshalling.__default.parseCheckedSector($LS($ly), data#0) } 
  Marshalling.__default.parseCheckedSector($LS($ly), data#0)
     == Marshalling.__default.parseCheckedSector($ly, data#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, data#0: Seq Box :: 
  { Marshalling.__default.parseCheckedSector(AsFuelBottom($ly), data#0) } 
  Marshalling.__default.parseCheckedSector($ly, data#0)
     == Marshalling.__default.parseCheckedSector($LZ, data#0));

// consequence axiom for Marshalling.__default.parseCheckedSector
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box :: 
    { Marshalling.__default.parseCheckedSector($ly, data#0) } 
    Marshalling.__default.parseCheckedSector#canCall(data#0)
         || $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       ==> $Is(Marshalling.__default.parseCheckedSector($ly, data#0), 
        Tclass.Options.Option(Tclass.SectorType.Sector())));

function Marshalling.__default.parseCheckedSector#requires(LayerType, Seq Box) : bool;

// #requires axiom for Marshalling.__default.parseCheckedSector
axiom (forall $ly: LayerType, data#0: Seq Box :: 
  { Marshalling.__default.parseCheckedSector#requires($ly, data#0) } 
  $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
     ==> Marshalling.__default.parseCheckedSector#requires($ly, data#0) == true);

// definition axiom for Marshalling.__default.parseCheckedSector(revealed)
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box :: 
    { Marshalling.__default.parseCheckedSector($LS($ly), data#0) } 
    Marshalling.__default.parseCheckedSector#canCall(data#0)
         || $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(data#0) >= LitInt(32)
           ==> Crypto.__default.Crc32C#canCall(Seq#Drop(data#0, LitInt(32))))
         && (Seq#Length(data#0) >= LitInt(32)
             && Seq#Equal(Crypto.__default.Crc32C(Seq#Drop(data#0, LitInt(32))), 
              Seq#Take(data#0, LitInt(32)))
           ==> Marshalling.__default.parseSector#canCall(Seq#Drop(data#0, LitInt(32))))
         && Marshalling.__default.parseCheckedSector($LS($ly), data#0)
           == (if Seq#Length(data#0) >= LitInt(32)
               && Seq#Equal(Crypto.__default.Crc32C(Seq#Drop(data#0, LitInt(32))), 
                Seq#Take(data#0, LitInt(32)))
             then Marshalling.__default.parseSector(StartFuel_Marshalling._default.parseSector, Seq#Drop(data#0, LitInt(32)))
             else #Options.Option.None()));

// definition axiom for Marshalling.__default.parseCheckedSector for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, data#0: Seq Box :: 
    {:weight 3} { Marshalling.__default.parseCheckedSector($LS($ly), Lit(data#0)) } 
    Marshalling.__default.parseCheckedSector#canCall(Lit(data#0))
         || $Is(data#0, TSeq(Tclass.NativeTypes.byte()))
       ==> (Seq#Length(Lit(data#0)) >= LitInt(32)
           ==> Crypto.__default.Crc32C#canCall(Lit(Seq#Drop(Lit(data#0), LitInt(32)))))
         && (Seq#Length(Lit(data#0)) >= LitInt(32)
             && Seq#Equal(Crypto.__default.Crc32C(Lit(Seq#Drop(Lit(data#0), LitInt(32)))), 
              Seq#Take(Lit(data#0), LitInt(32)))
           ==> Marshalling.__default.parseSector#canCall(Lit(Seq#Drop(Lit(data#0), LitInt(32)))))
         && Marshalling.__default.parseCheckedSector($LS($ly), Lit(data#0))
           == (if Seq#Length(Lit(data#0)) >= LitInt(32)
               && Seq#Equal(Crypto.__default.Crc32C(Lit(Seq#Drop(Lit(data#0), LitInt(32)))), 
                Seq#Take(Lit(data#0), LitInt(32)))
             then Marshalling.__default.parseSector(StartFuel_Marshalling._default.parseSector, 
              Lit(Seq#Drop(Lit(data#0), LitInt(32))))
             else #Options.Option.None()));

// function declaration for Marshalling._default.IsInitIndirectionTable
function Marshalling.__default.IsInitIndirectionTable(table#0: DatatypeType) : bool;

function Marshalling.__default.IsInitIndirectionTable#canCall(table#0: DatatypeType) : bool;

// consequence axiom for Marshalling.__default.IsInitIndirectionTable
axiom true
   ==> (forall table#0: DatatypeType :: 
    { Marshalling.__default.IsInitIndirectionTable(table#0) } 
    Marshalling.__default.IsInitIndirectionTable#canCall(table#0)
         || $Is(table#0, Tclass.SectorType.IndirectionTable())
       ==> true);

function Marshalling.__default.IsInitIndirectionTable#requires(DatatypeType) : bool;

// #requires axiom for Marshalling.__default.IsInitIndirectionTable
axiom (forall table#0: DatatypeType :: 
  { Marshalling.__default.IsInitIndirectionTable#requires(table#0) } 
  $Is(table#0, Tclass.SectorType.IndirectionTable())
     ==> Marshalling.__default.IsInitIndirectionTable#requires(table#0) == true);

// definition axiom for Marshalling.__default.IsInitIndirectionTable(revealed)
axiom true
   ==> (forall table#0: DatatypeType :: 
    { Marshalling.__default.IsInitIndirectionTable(table#0) } 
    Marshalling.__default.IsInitIndirectionTable#canCall(table#0)
         || $Is(table#0, Tclass.SectorType.IndirectionTable())
       ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(table#0)
         && (BlockCache.__default.WFCompleteIndirectionTable(table#0)
           ==> SectorType.IndirectionTable.IndirectionTable_q(table#0)
             && PivotBetreeGraph.__default.Root#canCall())
         && (SectorType.IndirectionTable.IndirectionTable_q(table#0)
             && PivotBetreeGraph.__default.Root#canCall()
             && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(table#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(PivotBetreeGraph.__default.Root()))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(table#0)
             && PivotBetreeGraph.__default.Root#canCall())
         && Marshalling.__default.IsInitIndirectionTable(table#0)
           == (
            BlockCache.__default.WFCompleteIndirectionTable(table#0)
             && Set#Equal(Map#Domain(SectorType.IndirectionTable.graph(table#0)), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(PivotBetreeGraph.__default.Root()))))
             && Seq#Equal($Unbox(Map#Elements(SectorType.IndirectionTable.graph(table#0))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): Seq Box, 
              Seq#Empty(): Seq Box)));

// definition axiom for Marshalling.__default.IsInitIndirectionTable for all literals(revealed)
axiom true
   ==> (forall table#0: DatatypeType :: 
    {:weight 3} { Marshalling.__default.IsInitIndirectionTable(Lit(table#0)) } 
    Marshalling.__default.IsInitIndirectionTable#canCall(Lit(table#0))
         || $Is(table#0, Tclass.SectorType.IndirectionTable())
       ==> BlockCache.__default.WFCompleteIndirectionTable#canCall(Lit(table#0))
         && (Lit(BlockCache.__default.WFCompleteIndirectionTable(Lit(table#0)))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(table#0))
             && PivotBetreeGraph.__default.Root#canCall())
         && (SectorType.IndirectionTable.IndirectionTable_q(Lit(table#0))
             && PivotBetreeGraph.__default.Root#canCall()
             && Set#Equal(Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(table#0)))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(PivotBetreeGraph.__default.Root()))))
           ==> SectorType.IndirectionTable.IndirectionTable_q(Lit(table#0))
             && PivotBetreeGraph.__default.Root#canCall())
         && Marshalling.__default.IsInitIndirectionTable(Lit(table#0))
           == (
            BlockCache.__default.WFCompleteIndirectionTable(Lit(table#0))
             && Set#Equal(Map#Domain(Lit(SectorType.IndirectionTable.graph(Lit(table#0)))), 
              Set#UnionOne(Set#Empty(): Set Box, $Box(LitInt(PivotBetreeGraph.__default.Root()))))
             && Seq#Equal($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(table#0))))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): Seq Box, 
              Seq#Empty(): Seq Box)));

// Constructor function declaration
function #IndirectionTableModel.Entry.Entry(DatatypeType, Seq Box, int) : DatatypeType;

const unique ##IndirectionTableModel.Entry.Entry: DtCtorId;

// Constructor identifier
axiom (forall a#0#0#0: DatatypeType, a#0#1#0: Seq Box, a#0#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(a#0#0#0, a#0#1#0, a#0#2#0) } 
  DatatypeCtorId(#IndirectionTableModel.Entry.Entry(a#0#0#0, a#0#1#0, a#0#2#0))
     == ##IndirectionTableModel.Entry.Entry);

function IndirectionTableModel.Entry.Entry_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.Entry.Entry_q(d) } 
  IndirectionTableModel.Entry.Entry_q(d)
     <==> DatatypeCtorId(d) == ##IndirectionTableModel.Entry.Entry);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.Entry.Entry_q(d) } 
  IndirectionTableModel.Entry.Entry_q(d)
     ==> (exists a#1#0#0: DatatypeType, a#1#1#0: Seq Box, a#1#2#0: int :: 
      d == #IndirectionTableModel.Entry.Entry(a#1#0#0, a#1#1#0, a#1#2#0)));

// Constructor $Is
axiom (forall a#2#0#0: DatatypeType, a#2#1#0: Seq Box, a#2#2#0: int :: 
  { $Is(#IndirectionTableModel.Entry.Entry(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.IndirectionTableModel.Entry()) } 
  $Is(#IndirectionTableModel.Entry.Entry(a#2#0#0, a#2#1#0, a#2#2#0), 
      Tclass.IndirectionTableModel.Entry())
     <==> $Is(a#2#0#0, Tclass.Options.Option(Tclass.DiskLayout.Location()))
       && $Is(a#2#1#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(a#2#2#0, Tclass.NativeTypes.uint64()));

// Constructor $IsAlloc
axiom (forall a#3#0#0: DatatypeType, a#3#1#0: Seq Box, a#3#2#0: int, $h: Heap :: 
  { $IsAlloc(#IndirectionTableModel.Entry.Entry(a#3#0#0, a#3#1#0, a#3#2#0), 
      Tclass.IndirectionTableModel.Entry(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#IndirectionTableModel.Entry.Entry(a#3#0#0, a#3#1#0, a#3#2#0), 
        Tclass.IndirectionTableModel.Entry(), 
        $h)
       <==> $IsAlloc(a#3#0#0, Tclass.Options.Option(Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#3#1#0, TSeq(Tclass.NativeTypes.uint64()), $h)
         && $IsAlloc(a#3#2#0, Tclass.NativeTypes.uint64(), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.Entry.loc(d), 
      Tclass.Options.Option(Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.Entry.Entry_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.Entry(), $h)
     ==> $IsAlloc(IndirectionTableModel.Entry.loc(d), 
      Tclass.Options.Option(Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.Entry.succs(d), TSeq(Tclass.NativeTypes.uint64()), $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.Entry.Entry_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.Entry(), $h)
     ==> $IsAlloc(IndirectionTableModel.Entry.succs(d), TSeq(Tclass.NativeTypes.uint64()), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.Entry.predCount(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.Entry.Entry_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.Entry(), $h)
     ==> $IsAlloc(IndirectionTableModel.Entry.predCount(d), Tclass.NativeTypes.uint64(), $h));

// Constructor literal
axiom (forall a#4#0#0: DatatypeType, a#4#1#0: Seq Box, a#4#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0)) } 
  #IndirectionTableModel.Entry.Entry(Lit(a#4#0#0), Lit(a#4#1#0), LitInt(a#4#2#0))
     == Lit(#IndirectionTableModel.Entry.Entry(a#4#0#0, a#4#1#0, a#4#2#0)));

function IndirectionTableModel.Entry.loc(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#5#0#0: DatatypeType, a#5#1#0: Seq Box, a#5#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(a#5#0#0, a#5#1#0, a#5#2#0) } 
  IndirectionTableModel.Entry.loc(#IndirectionTableModel.Entry.Entry(a#5#0#0, a#5#1#0, a#5#2#0))
     == a#5#0#0);

// Inductive rank
axiom (forall a#6#0#0: DatatypeType, a#6#1#0: Seq Box, a#6#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(a#6#0#0, a#6#1#0, a#6#2#0) } 
  DtRank(a#6#0#0)
     < DtRank(#IndirectionTableModel.Entry.Entry(a#6#0#0, a#6#1#0, a#6#2#0)));

function IndirectionTableModel.Entry.succs(DatatypeType) : Seq Box;

// Constructor injectivity
axiom (forall a#7#0#0: DatatypeType, a#7#1#0: Seq Box, a#7#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(a#7#0#0, a#7#1#0, a#7#2#0) } 
  IndirectionTableModel.Entry.succs(#IndirectionTableModel.Entry.Entry(a#7#0#0, a#7#1#0, a#7#2#0))
     == a#7#1#0);

// Inductive seq element rank
axiom (forall a#8#0#0: DatatypeType, a#8#1#0: Seq Box, a#8#2#0: int, i: int :: 
  { Seq#Index(a#8#1#0, i), #IndirectionTableModel.Entry.Entry(a#8#0#0, a#8#1#0, a#8#2#0) } 
  0 <= i && i < Seq#Length(a#8#1#0)
     ==> DtRank($Unbox(Seq#Index(a#8#1#0, i)): DatatypeType)
       < DtRank(#IndirectionTableModel.Entry.Entry(a#8#0#0, a#8#1#0, a#8#2#0)));

// Inductive seq rank
axiom (forall a#9#0#0: DatatypeType, a#9#1#0: Seq Box, a#9#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(a#9#0#0, a#9#1#0, a#9#2#0) } 
  Seq#Rank(a#9#1#0)
     < DtRank(#IndirectionTableModel.Entry.Entry(a#9#0#0, a#9#1#0, a#9#2#0)));

function IndirectionTableModel.Entry.predCount(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#10#0#0: DatatypeType, a#10#1#0: Seq Box, a#10#2#0: int :: 
  { #IndirectionTableModel.Entry.Entry(a#10#0#0, a#10#1#0, a#10#2#0) } 
  IndirectionTableModel.Entry.predCount(#IndirectionTableModel.Entry.Entry(a#10#0#0, a#10#1#0, a#10#2#0))
     == a#10#2#0);

// Depth-one case-split function
function $IsA#IndirectionTableModel.Entry(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#IndirectionTableModel.Entry(d) } 
  $IsA#IndirectionTableModel.Entry(d) ==> IndirectionTableModel.Entry.Entry_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.Entry.Entry_q(d), $Is(d, Tclass.IndirectionTableModel.Entry()) } 
  $Is(d, Tclass.IndirectionTableModel.Entry())
     ==> IndirectionTableModel.Entry.Entry_q(d));

// Datatype extensional equality declaration
function IndirectionTableModel.Entry#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #IndirectionTableModel.Entry.Entry
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { IndirectionTableModel.Entry#Equal(a, b) } 
  true
     ==> (IndirectionTableModel.Entry#Equal(a, b)
       <==> Options.Option#Equal(IndirectionTableModel.Entry.loc(a), IndirectionTableModel.Entry.loc(b))
         && Seq#Equal(IndirectionTableModel.Entry.succs(a), IndirectionTableModel.Entry.succs(b))
         && IndirectionTableModel.Entry.predCount(a)
           == IndirectionTableModel.Entry.predCount(b)));

// Datatype extensionality axiom: IndirectionTableModel.Entry
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { IndirectionTableModel.Entry#Equal(a, b) } 
  IndirectionTableModel.Entry#Equal(a, b) <==> a == b);

const unique class.IndirectionTableModel.Entry: ClassName;

// Constructor function declaration
function #IndirectionTableModel.IndirectionTable.IndirectionTable(DatatypeType, 
    DatatypeType, 
    int, 
    DatatypeType, 
    Map Box Box, 
    Map Box Box, 
    Map Box Box)
   : DatatypeType;

const unique ##IndirectionTableModel.IndirectionTable.IndirectionTable: DtCtorId;

// Constructor identifier
axiom (forall a#11#0#0: DatatypeType, 
    a#11#1#0: DatatypeType, 
    a#11#2#0: int, 
    a#11#3#0: DatatypeType, 
    a#11#4#0: Map Box Box, 
    a#11#5#0: Map Box Box, 
    a#11#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0, a#11#6#0) } 
  DatatypeCtorId(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#11#0#0, a#11#1#0, a#11#2#0, a#11#3#0, a#11#4#0, a#11#5#0, a#11#6#0))
     == ##IndirectionTableModel.IndirectionTable.IndirectionTable);

function IndirectionTableModel.IndirectionTable.IndirectionTable_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.IndirectionTable.IndirectionTable_q(d) } 
  IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
     <==> DatatypeCtorId(d) == ##IndirectionTableModel.IndirectionTable.IndirectionTable);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.IndirectionTable.IndirectionTable_q(d) } 
  IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
     ==> (exists a#12#0#0: DatatypeType, 
        a#12#1#0: DatatypeType, 
        a#12#2#0: int, 
        a#12#3#0: DatatypeType, 
        a#12#4#0: Map Box Box, 
        a#12#5#0: Map Box Box, 
        a#12#6#0: Map Box Box :: 
      d
         == #IndirectionTableModel.IndirectionTable.IndirectionTable(a#12#0#0, a#12#1#0, a#12#2#0, a#12#3#0, a#12#4#0, a#12#5#0, a#12#6#0)));

// Constructor $Is
axiom (forall a#13#0#0: DatatypeType, 
    a#13#1#0: DatatypeType, 
    a#13#2#0: int, 
    a#13#3#0: DatatypeType, 
    a#13#4#0: Map Box Box, 
    a#13#5#0: Map Box Box, 
    a#13#6#0: Map Box Box :: 
  { $Is(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0, a#13#6#0), 
      Tclass.IndirectionTableModel.IndirectionTable()) } 
  $Is(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#13#0#0, a#13#1#0, a#13#2#0, a#13#3#0, a#13#4#0, a#13#5#0, a#13#6#0), 
      Tclass.IndirectionTableModel.IndirectionTable())
     <==> $Is(a#13#0#0, 
        Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(a#13#1#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())))
       && $Is(a#13#2#0, Tclass.NativeTypes.uint64())
       && $Is(a#13#3#0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()))
       && $Is(a#13#4#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()))
       && $Is(a#13#5#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && $Is(a#13#6#0, TMap(Tclass.NativeTypes.uint64(), TInt)));

// Constructor $IsAlloc
axiom (forall a#14#0#0: DatatypeType, 
    a#14#1#0: DatatypeType, 
    a#14#2#0: int, 
    a#14#3#0: DatatypeType, 
    a#14#4#0: Map Box Box, 
    a#14#5#0: Map Box Box, 
    a#14#6#0: Map Box Box, 
    $h: Heap :: 
  { $IsAlloc(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0, a#14#6#0), 
      Tclass.IndirectionTableModel.IndirectionTable(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#14#0#0, a#14#1#0, a#14#2#0, a#14#3#0, a#14#4#0, a#14#5#0, a#14#6#0), 
        Tclass.IndirectionTableModel.IndirectionTable(), 
        $h)
       <==> $IsAlloc(a#14#0#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $h)
         && $IsAlloc(a#14#1#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), $h)
         && $IsAlloc(a#14#2#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#14#3#0, Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()), $h)
         && $IsAlloc(a#14#4#0, TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), $h)
         && $IsAlloc(a#14#5#0, 
          TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
          $h)
         && $IsAlloc(a#14#6#0, TMap(Tclass.NativeTypes.uint64(), TInt), $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.t(d), 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.t(d), 
      Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.garbageQueue(d), 
      Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.garbageQueue(d), 
      Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.refUpperBound(d), 
      Tclass.NativeTypes.uint64(), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.refUpperBound(d), 
      Tclass.NativeTypes.uint64(), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.findLoclessIterator(d), 
      Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.findLoclessIterator(d), 
      Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.locs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.locs(d), 
      TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location()), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.graph(d), 
      TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.graph(d), 
      TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())), 
      $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.IndirectionTable.predCounts(d), 
      TMap(Tclass.NativeTypes.uint64(), TInt), 
      $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.IndirectionTable(), $h)
     ==> $IsAlloc(IndirectionTableModel.IndirectionTable.predCounts(d), 
      TMap(Tclass.NativeTypes.uint64(), TInt), 
      $h));

// Constructor literal
axiom (forall a#15#0#0: DatatypeType, 
    a#15#1#0: DatatypeType, 
    a#15#2#0: int, 
    a#15#3#0: DatatypeType, 
    a#15#4#0: Map Box Box, 
    a#15#5#0: Map Box Box, 
    a#15#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(Lit(a#15#0#0), 
      Lit(a#15#1#0), 
      LitInt(a#15#2#0), 
      Lit(a#15#3#0), 
      Lit(a#15#4#0), 
      Lit(a#15#5#0), 
      Lit(a#15#6#0)) } 
  #IndirectionTableModel.IndirectionTable.IndirectionTable(Lit(a#15#0#0), 
      Lit(a#15#1#0), 
      LitInt(a#15#2#0), 
      Lit(a#15#3#0), 
      Lit(a#15#4#0), 
      Lit(a#15#5#0), 
      Lit(a#15#6#0))
     == Lit(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#15#0#0, a#15#1#0, a#15#2#0, a#15#3#0, a#15#4#0, a#15#5#0, a#15#6#0)));

function IndirectionTableModel.IndirectionTable.t(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#16#0#0: DatatypeType, 
    a#16#1#0: DatatypeType, 
    a#16#2#0: int, 
    a#16#3#0: DatatypeType, 
    a#16#4#0: Map Box Box, 
    a#16#5#0: Map Box Box, 
    a#16#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0, a#16#6#0) } 
  IndirectionTableModel.IndirectionTable.t(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#16#0#0, a#16#1#0, a#16#2#0, a#16#3#0, a#16#4#0, a#16#5#0, a#16#6#0))
     == a#16#0#0);

// Inductive rank
axiom (forall a#17#0#0: DatatypeType, 
    a#17#1#0: DatatypeType, 
    a#17#2#0: int, 
    a#17#3#0: DatatypeType, 
    a#17#4#0: Map Box Box, 
    a#17#5#0: Map Box Box, 
    a#17#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0, a#17#6#0) } 
  DtRank(a#17#0#0)
     < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#17#0#0, a#17#1#0, a#17#2#0, a#17#3#0, a#17#4#0, a#17#5#0, a#17#6#0)));

function IndirectionTableModel.IndirectionTable.garbageQueue(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#18#0#0: DatatypeType, 
    a#18#1#0: DatatypeType, 
    a#18#2#0: int, 
    a#18#3#0: DatatypeType, 
    a#18#4#0: Map Box Box, 
    a#18#5#0: Map Box Box, 
    a#18#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0, a#18#6#0) } 
  IndirectionTableModel.IndirectionTable.garbageQueue(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#18#0#0, a#18#1#0, a#18#2#0, a#18#3#0, a#18#4#0, a#18#5#0, a#18#6#0))
     == a#18#1#0);

// Inductive rank
axiom (forall a#19#0#0: DatatypeType, 
    a#19#1#0: DatatypeType, 
    a#19#2#0: int, 
    a#19#3#0: DatatypeType, 
    a#19#4#0: Map Box Box, 
    a#19#5#0: Map Box Box, 
    a#19#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0, a#19#5#0, a#19#6#0) } 
  DtRank(a#19#1#0)
     < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#19#0#0, a#19#1#0, a#19#2#0, a#19#3#0, a#19#4#0, a#19#5#0, a#19#6#0)));

function IndirectionTableModel.IndirectionTable.refUpperBound(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#20#0#0: DatatypeType, 
    a#20#1#0: DatatypeType, 
    a#20#2#0: int, 
    a#20#3#0: DatatypeType, 
    a#20#4#0: Map Box Box, 
    a#20#5#0: Map Box Box, 
    a#20#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0, a#20#4#0, a#20#5#0, a#20#6#0) } 
  IndirectionTableModel.IndirectionTable.refUpperBound(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#20#0#0, a#20#1#0, a#20#2#0, a#20#3#0, a#20#4#0, a#20#5#0, a#20#6#0))
     == a#20#2#0);

function IndirectionTableModel.IndirectionTable.findLoclessIterator(DatatypeType) : DatatypeType;

// Constructor injectivity
axiom (forall a#21#0#0: DatatypeType, 
    a#21#1#0: DatatypeType, 
    a#21#2#0: int, 
    a#21#3#0: DatatypeType, 
    a#21#4#0: Map Box Box, 
    a#21#5#0: Map Box Box, 
    a#21#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0, a#21#5#0, a#21#6#0) } 
  IndirectionTableModel.IndirectionTable.findLoclessIterator(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#21#0#0, a#21#1#0, a#21#2#0, a#21#3#0, a#21#4#0, a#21#5#0, a#21#6#0))
     == a#21#3#0);

// Inductive rank
axiom (forall a#22#0#0: DatatypeType, 
    a#22#1#0: DatatypeType, 
    a#22#2#0: int, 
    a#22#3#0: DatatypeType, 
    a#22#4#0: Map Box Box, 
    a#22#5#0: Map Box Box, 
    a#22#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0, a#22#5#0, a#22#6#0) } 
  DtRank(a#22#3#0)
     < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#22#0#0, a#22#1#0, a#22#2#0, a#22#3#0, a#22#4#0, a#22#5#0, a#22#6#0)));

function IndirectionTableModel.IndirectionTable.locs(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#23#0#0: DatatypeType, 
    a#23#1#0: DatatypeType, 
    a#23#2#0: int, 
    a#23#3#0: DatatypeType, 
    a#23#4#0: Map Box Box, 
    a#23#5#0: Map Box Box, 
    a#23#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0, a#23#5#0, a#23#6#0) } 
  IndirectionTableModel.IndirectionTable.locs(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#23#0#0, a#23#1#0, a#23#2#0, a#23#3#0, a#23#4#0, a#23#5#0, a#23#6#0))
     == a#23#4#0);

// Inductive map key rank
axiom (forall a#24#0#0: DatatypeType, 
    a#24#1#0: DatatypeType, 
    a#24#2#0: int, 
    a#24#3#0: DatatypeType, 
    a#24#4#0: Map Box Box, 
    a#24#5#0: Map Box Box, 
    a#24#6#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#24#4#0)[$Box(d)], #IndirectionTableModel.IndirectionTable.IndirectionTable(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0, a#24#5#0, a#24#6#0) } 
  Map#Domain(a#24#4#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#24#0#0, a#24#1#0, a#24#2#0, a#24#3#0, a#24#4#0, a#24#5#0, a#24#6#0)));

// Inductive map value rank
axiom (forall a#25#0#0: DatatypeType, 
    a#25#1#0: DatatypeType, 
    a#25#2#0: int, 
    a#25#3#0: DatatypeType, 
    a#25#4#0: Map Box Box, 
    a#25#5#0: Map Box Box, 
    a#25#6#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#25#4#0)[bx], #IndirectionTableModel.IndirectionTable.IndirectionTable(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0, a#25#5#0, a#25#6#0) } 
  Map#Domain(a#25#4#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#25#4#0)[bx]): DatatypeType)
       < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#25#0#0, a#25#1#0, a#25#2#0, a#25#3#0, a#25#4#0, a#25#5#0, a#25#6#0)));

function IndirectionTableModel.IndirectionTable.graph(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#26#0#0: DatatypeType, 
    a#26#1#0: DatatypeType, 
    a#26#2#0: int, 
    a#26#3#0: DatatypeType, 
    a#26#4#0: Map Box Box, 
    a#26#5#0: Map Box Box, 
    a#26#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0, a#26#5#0, a#26#6#0) } 
  IndirectionTableModel.IndirectionTable.graph(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#26#0#0, a#26#1#0, a#26#2#0, a#26#3#0, a#26#4#0, a#26#5#0, a#26#6#0))
     == a#26#5#0);

// Inductive map key rank
axiom (forall a#27#0#0: DatatypeType, 
    a#27#1#0: DatatypeType, 
    a#27#2#0: int, 
    a#27#3#0: DatatypeType, 
    a#27#4#0: Map Box Box, 
    a#27#5#0: Map Box Box, 
    a#27#6#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#27#5#0)[$Box(d)], #IndirectionTableModel.IndirectionTable.IndirectionTable(a#27#0#0, a#27#1#0, a#27#2#0, a#27#3#0, a#27#4#0, a#27#5#0, a#27#6#0) } 
  Map#Domain(a#27#5#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#27#0#0, a#27#1#0, a#27#2#0, a#27#3#0, a#27#4#0, a#27#5#0, a#27#6#0)));

// Inductive map value rank
axiom (forall a#28#0#0: DatatypeType, 
    a#28#1#0: DatatypeType, 
    a#28#2#0: int, 
    a#28#3#0: DatatypeType, 
    a#28#4#0: Map Box Box, 
    a#28#5#0: Map Box Box, 
    a#28#6#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#28#5#0)[bx], #IndirectionTableModel.IndirectionTable.IndirectionTable(a#28#0#0, a#28#1#0, a#28#2#0, a#28#3#0, a#28#4#0, a#28#5#0, a#28#6#0) } 
  Map#Domain(a#28#5#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#28#5#0)[bx]): DatatypeType)
       < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#28#0#0, a#28#1#0, a#28#2#0, a#28#3#0, a#28#4#0, a#28#5#0, a#28#6#0)));

function IndirectionTableModel.IndirectionTable.predCounts(DatatypeType) : Map Box Box;

// Constructor injectivity
axiom (forall a#29#0#0: DatatypeType, 
    a#29#1#0: DatatypeType, 
    a#29#2#0: int, 
    a#29#3#0: DatatypeType, 
    a#29#4#0: Map Box Box, 
    a#29#5#0: Map Box Box, 
    a#29#6#0: Map Box Box :: 
  { #IndirectionTableModel.IndirectionTable.IndirectionTable(a#29#0#0, a#29#1#0, a#29#2#0, a#29#3#0, a#29#4#0, a#29#5#0, a#29#6#0) } 
  IndirectionTableModel.IndirectionTable.predCounts(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#29#0#0, a#29#1#0, a#29#2#0, a#29#3#0, a#29#4#0, a#29#5#0, a#29#6#0))
     == a#29#6#0);

// Inductive map key rank
axiom (forall a#30#0#0: DatatypeType, 
    a#30#1#0: DatatypeType, 
    a#30#2#0: int, 
    a#30#3#0: DatatypeType, 
    a#30#4#0: Map Box Box, 
    a#30#5#0: Map Box Box, 
    a#30#6#0: Map Box Box, 
    d: DatatypeType :: 
  { Map#Domain(a#30#6#0)[$Box(d)], #IndirectionTableModel.IndirectionTable.IndirectionTable(a#30#0#0, a#30#1#0, a#30#2#0, a#30#3#0, a#30#4#0, a#30#5#0, a#30#6#0) } 
  Map#Domain(a#30#6#0)[$Box(d)]
     ==> DtRank(d)
       < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#30#0#0, a#30#1#0, a#30#2#0, a#30#3#0, a#30#4#0, a#30#5#0, a#30#6#0)));

// Inductive map value rank
axiom (forall a#31#0#0: DatatypeType, 
    a#31#1#0: DatatypeType, 
    a#31#2#0: int, 
    a#31#3#0: DatatypeType, 
    a#31#4#0: Map Box Box, 
    a#31#5#0: Map Box Box, 
    a#31#6#0: Map Box Box, 
    bx: Box :: 
  { Map#Domain(a#31#6#0)[bx], #IndirectionTableModel.IndirectionTable.IndirectionTable(a#31#0#0, a#31#1#0, a#31#2#0, a#31#3#0, a#31#4#0, a#31#5#0, a#31#6#0) } 
  Map#Domain(a#31#6#0)[bx]
     ==> DtRank($Unbox(Map#Elements(a#31#6#0)[bx]): DatatypeType)
       < DtRank(#IndirectionTableModel.IndirectionTable.IndirectionTable(a#31#0#0, a#31#1#0, a#31#2#0, a#31#3#0, a#31#4#0, a#31#5#0, a#31#6#0)));

// Depth-one case-split function
function $IsA#IndirectionTableModel.IndirectionTable(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#IndirectionTableModel.IndirectionTable(d) } 
  $IsA#IndirectionTableModel.IndirectionTable(d)
     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.IndirectionTable.IndirectionTable_q(d), $Is(d, Tclass.IndirectionTableModel.IndirectionTable()) } 
  $Is(d, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(d));

// Datatype extensional equality declaration
function IndirectionTableModel.IndirectionTable#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #IndirectionTableModel.IndirectionTable.IndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { IndirectionTableModel.IndirectionTable#Equal(a, b) } 
  true
     ==> (IndirectionTableModel.IndirectionTable#Equal(a, b)
       <==> MutableMapModel.LinearHashMap#Equal(IndirectionTableModel.IndirectionTable.t(a), 
          IndirectionTableModel.IndirectionTable.t(b))
         && Options.Option#Equal(IndirectionTableModel.IndirectionTable.garbageQueue(a), 
          IndirectionTableModel.IndirectionTable.garbageQueue(b))
         && IndirectionTableModel.IndirectionTable.refUpperBound(a)
           == IndirectionTableModel.IndirectionTable.refUpperBound(b)
         && Options.Option#Equal(IndirectionTableModel.IndirectionTable.findLoclessIterator(a), 
          IndirectionTableModel.IndirectionTable.findLoclessIterator(b))
         && Map#Equal(IndirectionTableModel.IndirectionTable.locs(a), 
          IndirectionTableModel.IndirectionTable.locs(b))
         && Map#Equal(IndirectionTableModel.IndirectionTable.graph(a), 
          IndirectionTableModel.IndirectionTable.graph(b))
         && Map#Equal(IndirectionTableModel.IndirectionTable.predCounts(a), 
          IndirectionTableModel.IndirectionTable.predCounts(b))));

// Datatype extensionality axiom: IndirectionTableModel.IndirectionTable
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { IndirectionTableModel.IndirectionTable#Equal(a, b) } 
  IndirectionTableModel.IndirectionTable#Equal(a, b) <==> a == b);

const unique class.IndirectionTableModel.IndirectionTable: ClassName;

// Constructor function declaration
function #IndirectionTableModel.PredecessorEdge.PredecessorEdge(int, int) : DatatypeType;

const unique ##IndirectionTableModel.PredecessorEdge.PredecessorEdge: DtCtorId;

// Constructor identifier
axiom (forall a#32#0#0: int, a#32#1#0: int :: 
  { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#32#0#0, a#32#1#0) } 
  DatatypeCtorId(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#32#0#0, a#32#1#0))
     == ##IndirectionTableModel.PredecessorEdge.PredecessorEdge);

function IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(DatatypeType) : bool;

// Questionmark and identifier
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d) } 
  IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d)
     <==> DatatypeCtorId(d) == ##IndirectionTableModel.PredecessorEdge.PredecessorEdge);

// Constructor questionmark has arguments
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d) } 
  IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d)
     ==> (exists a#33#0#0: int, a#33#1#0: int :: 
      d == #IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#33#0#0, a#33#1#0)));

function Tclass.IndirectionTableModel.PredecessorEdge() : Ty;

// Tclass.IndirectionTableModel.PredecessorEdge Tag
axiom Tag(Tclass.IndirectionTableModel.PredecessorEdge())
   == Tagclass.IndirectionTableModel.PredecessorEdge;

const unique Tagclass.IndirectionTableModel.PredecessorEdge: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableModel.PredecessorEdge
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableModel.PredecessorEdge()) } 
  $IsBox(bx, Tclass.IndirectionTableModel.PredecessorEdge())
     ==> $Box($Unbox(bx): DatatypeType) == bx
       && $Is($Unbox(bx): DatatypeType, Tclass.IndirectionTableModel.PredecessorEdge()));

// Constructor $Is
axiom (forall a#34#0#0: int, a#34#1#0: int :: 
  { $Is(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#34#0#0, a#34#1#0), 
      Tclass.IndirectionTableModel.PredecessorEdge()) } 
  $Is(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#34#0#0, a#34#1#0), 
      Tclass.IndirectionTableModel.PredecessorEdge())
     <==> $Is(a#34#0#0, Tclass.NativeTypes.uint64()) && $Is(a#34#1#0, TInt));

// Constructor $IsAlloc
axiom (forall a#35#0#0: int, a#35#1#0: int, $h: Heap :: 
  { $IsAlloc(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#35#0#0, a#35#1#0), 
      Tclass.IndirectionTableModel.PredecessorEdge(), 
      $h) } 
  $IsGoodHeap($h)
     ==> ($IsAlloc(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#35#0#0, a#35#1#0), 
        Tclass.IndirectionTableModel.PredecessorEdge(), 
        $h)
       <==> $IsAlloc(a#35#0#0, Tclass.NativeTypes.uint64(), $h)
         && $IsAlloc(a#35#1#0, TInt, $h)));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.PredecessorEdge.src(d), Tclass.NativeTypes.uint64(), $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.PredecessorEdge(), $h)
     ==> $IsAlloc(IndirectionTableModel.PredecessorEdge.src(d), Tclass.NativeTypes.uint64(), $h));

// Destructor $IsAlloc
axiom (forall d: DatatypeType, $h: Heap :: 
  { $IsAlloc(IndirectionTableModel.PredecessorEdge.idx(d), TInt, $h) } 
  $IsGoodHeap($h)
       && 
      IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d)
       && $IsAlloc(d, Tclass.IndirectionTableModel.PredecessorEdge(), $h)
     ==> $IsAlloc(IndirectionTableModel.PredecessorEdge.idx(d), TInt, $h));

// Constructor literal
axiom (forall a#36#0#0: int, a#36#1#0: int :: 
  { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(LitInt(a#36#0#0), LitInt(a#36#1#0)) } 
  #IndirectionTableModel.PredecessorEdge.PredecessorEdge(LitInt(a#36#0#0), LitInt(a#36#1#0))
     == Lit(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#36#0#0, a#36#1#0)));

function IndirectionTableModel.PredecessorEdge.src(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#37#0#0: int, a#37#1#0: int :: 
  { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#37#0#0, a#37#1#0) } 
  IndirectionTableModel.PredecessorEdge.src(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#37#0#0, a#37#1#0))
     == a#37#0#0);

function IndirectionTableModel.PredecessorEdge.idx(DatatypeType) : int;

// Constructor injectivity
axiom (forall a#38#0#0: int, a#38#1#0: int :: 
  { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#38#0#0, a#38#1#0) } 
  IndirectionTableModel.PredecessorEdge.idx(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(a#38#0#0, a#38#1#0))
     == a#38#1#0);

// Depth-one case-split function
function $IsA#IndirectionTableModel.PredecessorEdge(DatatypeType) : bool;

// Depth-one case-split axiom
axiom (forall d: DatatypeType :: 
  { $IsA#IndirectionTableModel.PredecessorEdge(d) } 
  $IsA#IndirectionTableModel.PredecessorEdge(d)
     ==> IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d));

// Questionmark data type disjunctivity
axiom (forall d: DatatypeType :: 
  { IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d), $Is(d, Tclass.IndirectionTableModel.PredecessorEdge()) } 
  $Is(d, Tclass.IndirectionTableModel.PredecessorEdge())
     ==> IndirectionTableModel.PredecessorEdge.PredecessorEdge_q(d));

// Datatype extensional equality declaration
function IndirectionTableModel.PredecessorEdge#Equal(DatatypeType, DatatypeType) : bool;

// Datatype extensional equality definition: #IndirectionTableModel.PredecessorEdge.PredecessorEdge
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { IndirectionTableModel.PredecessorEdge#Equal(a, b) } 
  true
     ==> (IndirectionTableModel.PredecessorEdge#Equal(a, b)
       <==> IndirectionTableModel.PredecessorEdge.src(a)
           == IndirectionTableModel.PredecessorEdge.src(b)
         && IndirectionTableModel.PredecessorEdge.idx(a)
           == IndirectionTableModel.PredecessorEdge.idx(b)));

// Datatype extensionality axiom: IndirectionTableModel.PredecessorEdge
axiom (forall a: DatatypeType, b: DatatypeType :: 
  { IndirectionTableModel.PredecessorEdge#Equal(a, b) } 
  IndirectionTableModel.PredecessorEdge#Equal(a, b) <==> a == b);

const unique class.IndirectionTableModel.PredecessorEdge: ClassName;

const unique class.IndirectionTableModel.__default: ClassName;

function Tclass.IndirectionTableModel.__default() : Ty;

// Tclass.IndirectionTableModel.__default Tag
axiom Tag(Tclass.IndirectionTableModel.__default())
   == Tagclass.IndirectionTableModel.__default;

const unique Tagclass.IndirectionTableModel.__default: TyTag;

// Box/unbox axiom for Tclass.IndirectionTableModel.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.IndirectionTableModel.__default()) } 
  $IsBox(bx, Tclass.IndirectionTableModel.__default())
     ==> $Box($Unbox(bx): ref) == bx
       && $Is($Unbox(bx): ref, Tclass.IndirectionTableModel.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.IndirectionTableModel.__default()) } 
  $Is($o, Tclass.IndirectionTableModel.__default())
     <==> $o == null || dtype($o) == Tclass.IndirectionTableModel.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.IndirectionTableModel.__default(), $h) } 
  $IsAlloc($o, Tclass.IndirectionTableModel.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

// function declaration for IndirectionTableModel._default.Locs
function IndirectionTableModel.__default.Locs(t#0: DatatypeType) : Map Box Box;

function IndirectionTableModel.__default.Locs#canCall(t#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.Locs
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.Locs(t#0) } 
    IndirectionTableModel.__default.Locs#canCall(t#0)
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> $Is(IndirectionTableModel.__default.Locs(t#0), 
        TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())));

function IndirectionTableModel.__default.Locs#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.Locs
axiom (forall t#0: DatatypeType :: 
  { IndirectionTableModel.__default.Locs#requires(t#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.Locs#requires(t#0) == true);

// definition axiom for IndirectionTableModel.__default.Locs(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.Locs(t#0) } 
    IndirectionTableModel.__default.Locs#canCall(t#0)
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                   && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType))
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)))
         && IndirectionTableModel.__default.Locs(t#0)
           == Map#Glue((lambda $w#0: Box :: 
              LitInt(0) <= $Unbox($w#0): int
                 && $Unbox($w#0): int < 18446744073709551616
                 && 
                Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]
                 && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]): DatatypeType))), 
            (lambda $w#0: Box :: 
              Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())));

// definition axiom for IndirectionTableModel.__default.Locs for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.Locs(Lit(t#0)) } 
    IndirectionTableModel.__default.Locs#canCall(Lit(t#0))
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#0)]): DatatypeType))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
                   && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#0)]): DatatypeType))
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#0)]): DatatypeType)))
         && IndirectionTableModel.__default.Locs(Lit(t#0))
           == Map#Glue((lambda $w#1: Box :: 
              LitInt(0) <= $Unbox($w#1): int
                 && $Unbox($w#1): int < 18446744073709551616
                 && 
                Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$w#1]
                 && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$w#1]): DatatypeType))), 
            (lambda $w#1: Box :: 
              Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$w#1]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), Tclass.DiskLayout.Location())));

// function declaration for IndirectionTableModel._default.Graph
function IndirectionTableModel.__default.Graph(t#0: DatatypeType) : Map Box Box;

function IndirectionTableModel.__default.Graph#canCall(t#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.Graph
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.Graph(t#0) } 
    IndirectionTableModel.__default.Graph#canCall(t#0)
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> $Is(IndirectionTableModel.__default.Graph(t#0), 
        TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.Graph#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.Graph
axiom (forall t#0: DatatypeType :: 
  { IndirectionTableModel.__default.Graph#requires(t#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.Graph#requires(t#0) == true);

// definition axiom for IndirectionTableModel.__default.Graph(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.Graph(t#0) } 
    IndirectionTableModel.__default.Graph#canCall(t#0)
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)))
         && IndirectionTableModel.__default.Graph(t#0)
           == Map#Glue((lambda $w#0: Box :: 
              LitInt(0) <= $Unbox($w#0): int
                 && $Unbox($w#0): int < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]), 
            (lambda $w#0: Box :: 
              $Box(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))));

// definition axiom for IndirectionTableModel.__default.Graph for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.Graph(Lit(t#0)) } 
    IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#0)]): DatatypeType)))
         && IndirectionTableModel.__default.Graph(Lit(t#0))
           == Map#Glue((lambda $w#1: Box :: 
              LitInt(0) <= $Unbox($w#1): int
                 && $Unbox($w#1): int < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$w#1]), 
            (lambda $w#1: Box :: 
              $Box(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$w#1]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))));

// function declaration for IndirectionTableModel._default.PredCounts
function IndirectionTableModel.__default.PredCounts(t#0: DatatypeType) : Map Box Box;

function IndirectionTableModel.__default.PredCounts#canCall(t#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.PredCounts
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.PredCounts(t#0) } 
    IndirectionTableModel.__default.PredCounts#canCall(t#0)
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> $Is(IndirectionTableModel.__default.PredCounts(t#0), 
        TMap(Tclass.NativeTypes.uint64(), TInt)));

function IndirectionTableModel.__default.PredCounts#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.PredCounts
axiom (forall t#0: DatatypeType :: 
  { IndirectionTableModel.__default.PredCounts#requires(t#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.PredCounts#requires(t#0) == true);

// definition axiom for IndirectionTableModel.__default.PredCounts(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.PredCounts(t#0) } 
    IndirectionTableModel.__default.PredCounts#canCall(t#0)
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)))
         && IndirectionTableModel.__default.PredCounts(t#0)
           == Map#Glue((lambda $w#0: Box :: 
              LitInt(0) <= $Unbox($w#0): int
                 && $Unbox($w#0): int < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]), 
            (lambda $w#0: Box :: 
              $Box(IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$w#0]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), TInt)));

// definition axiom for IndirectionTableModel.__default.PredCounts for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.PredCounts(Lit(t#0)) } 
    IndirectionTableModel.__default.PredCounts#canCall(Lit(t#0))
         || $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> (forall ref#0: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
               && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#0)]): DatatypeType)))
         && IndirectionTableModel.__default.PredCounts(Lit(t#0))
           == Map#Glue((lambda $w#1: Box :: 
              LitInt(0) <= $Unbox($w#1): int
                 && $Unbox($w#1): int < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$w#1]), 
            (lambda $w#1: Box :: 
              $Box(IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$w#1]): DatatypeType))), 
            TMap(Tclass.NativeTypes.uint64(), TInt)));

// function declaration for IndirectionTableModel._default.PredecessorSet
function IndirectionTableModel.__default.PredecessorSet(graph#0: Map Box Box, dest#0: int) : Set Box;

function IndirectionTableModel.__default.PredecessorSet#canCall(graph#0: Map Box Box, dest#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.PredecessorSet
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int :: 
    { IndirectionTableModel.__default.PredecessorSet(graph#0, dest#0) } 
    IndirectionTableModel.__default.PredecessorSet#canCall(graph#0, dest#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616)
       ==> $Is(IndirectionTableModel.__default.PredecessorSet(graph#0, dest#0), 
        TSet(Tclass.IndirectionTableModel.PredecessorEdge())));

function IndirectionTableModel.__default.PredecessorSet#requires(Map Box Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.PredecessorSet
axiom (forall graph#0: Map Box Box, dest#0: int :: 
  { IndirectionTableModel.__default.PredecessorSet#requires(graph#0, dest#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && 
      LitInt(0) <= dest#0
       && dest#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.PredecessorSet#requires(graph#0, dest#0) == true);

// definition axiom for IndirectionTableModel.__default.PredecessorSet(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int :: 
    { IndirectionTableModel.__default.PredecessorSet(graph#0, dest#0) } 
    IndirectionTableModel.__default.PredecessorSet#canCall(graph#0, dest#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.PredecessorSet(graph#0, dest#0)
         == (lambda $y#0: Box :: 
          (exists src#0: int, idx#0: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int } 
            LitInt(0) <= src#0
               && src#0 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#0)]
               && 
              LitInt(0) <= idx#0
               && idx#0 < Seq#Length($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int
                 == dest#0
               && $y#0
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0)))));

// definition axiom for IndirectionTableModel.__default.PredecessorSet for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredecessorSet(Lit(graph#0), LitInt(dest#0)) } 
    IndirectionTableModel.__default.PredecessorSet#canCall(Lit(graph#0), LitInt(dest#0))
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.PredecessorSet(Lit(graph#0), LitInt(dest#0))
         == (lambda $y#1: Box :: 
          (exists src#1: int, idx#1: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#1)]): Seq Box, idx#1)): int } 
            LitInt(0) <= src#1
               && src#1 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#1)]
               && 
              LitInt(0) <= idx#1
               && idx#1 < Seq#Length($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box, idx#1)): int
                 == LitInt(dest#0)
               && $y#1
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1)))));

// function declaration for IndirectionTableModel._default.PredecessorSetRestricted
function IndirectionTableModel.__default.PredecessorSetRestricted(graph#0: Map Box Box, dest#0: int, domain#0: Set Box) : Set Box;

function IndirectionTableModel.__default.PredecessorSetRestricted#canCall(graph#0: Map Box Box, dest#0: int, domain#0: Set Box) : bool;

// consequence axiom for IndirectionTableModel.__default.PredecessorSetRestricted
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box :: 
    { IndirectionTableModel.__default.PredecessorSetRestricted(graph#0, dest#0, domain#0) } 
    IndirectionTableModel.__default.PredecessorSetRestricted#canCall(graph#0, dest#0, domain#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64())))
       ==> $Is(IndirectionTableModel.__default.PredecessorSetRestricted(graph#0, dest#0, domain#0), 
        TSet(Tclass.IndirectionTableModel.PredecessorEdge())));

function IndirectionTableModel.__default.PredecessorSetRestricted#requires(Map Box Box, int, Set Box) : bool;

// #requires axiom for IndirectionTableModel.__default.PredecessorSetRestricted
axiom (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box :: 
  { IndirectionTableModel.__default.PredecessorSetRestricted#requires(graph#0, dest#0, domain#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && 
      LitInt(0) <= dest#0
       && dest#0 < 18446744073709551616
       && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
     ==> IndirectionTableModel.__default.PredecessorSetRestricted#requires(graph#0, dest#0, domain#0)
       == true);

// definition axiom for IndirectionTableModel.__default.PredecessorSetRestricted(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box :: 
    { IndirectionTableModel.__default.PredecessorSetRestricted(graph#0, dest#0, domain#0) } 
    IndirectionTableModel.__default.PredecessorSetRestricted#canCall(graph#0, dest#0, domain#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64())))
       ==> IndirectionTableModel.__default.PredecessorSetRestricted(graph#0, dest#0, domain#0)
         == (lambda $y#0: Box :: 
          (exists src#0: int, idx#0: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int } 
            LitInt(0) <= src#0
               && src#0 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#0)]
               && 
              LitInt(0) <= idx#0
               && idx#0 < Seq#Length($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int
                 == dest#0
               && domain#0[$Box(src#0)]
               && $y#0
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0)))));

// definition axiom for IndirectionTableModel.__default.PredecessorSetRestricted for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box :: 
    {:weight 3} { IndirectionTableModel.__default.PredecessorSetRestricted(Lit(graph#0), LitInt(dest#0), Lit(domain#0)) } 
    IndirectionTableModel.__default.PredecessorSetRestricted#canCall(Lit(graph#0), LitInt(dest#0), Lit(domain#0))
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64())))
       ==> IndirectionTableModel.__default.PredecessorSetRestricted(Lit(graph#0), LitInt(dest#0), Lit(domain#0))
         == (lambda $y#1: Box :: 
          (exists src#1: int, idx#1: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#1)]): Seq Box, idx#1)): int } 
            LitInt(0) <= src#1
               && src#1 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#1)]
               && 
              LitInt(0) <= idx#1
               && idx#1 < Seq#Length($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box, idx#1)): int
                 == LitInt(dest#0)
               && Lit(domain#0)[$Box(src#1)]
               && $y#1
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1)))));

// function declaration for IndirectionTableModel._default.PredecessorSetRestrictedPartial
function IndirectionTableModel.__default.PredecessorSetRestrictedPartial(graph#0: Map Box Box, dest#0: int, domain#0: Set Box, next#0: int, j#0: int)
   : Set Box;

function IndirectionTableModel.__default.PredecessorSetRestrictedPartial#canCall(graph#0: Map Box Box, dest#0: int, domain#0: Set Box, next#0: int, j#0: int)
   : bool;

// consequence axiom for IndirectionTableModel.__default.PredecessorSetRestrictedPartial
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box, next#0: int, j#0: int :: 
    { IndirectionTableModel.__default.PredecessorSetRestrictedPartial(graph#0, dest#0, domain#0, next#0, j#0) } 
    IndirectionTableModel.__default.PredecessorSetRestrictedPartial#canCall(graph#0, dest#0, domain#0, next#0, j#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= next#0
           && next#0 < 18446744073709551616)
       ==> $Is(IndirectionTableModel.__default.PredecessorSetRestrictedPartial(graph#0, dest#0, domain#0, next#0, j#0), 
        TSet(Tclass.IndirectionTableModel.PredecessorEdge())));

function IndirectionTableModel.__default.PredecessorSetRestrictedPartial#requires(Map Box Box, int, Set Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.PredecessorSetRestrictedPartial
axiom (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box, next#0: int, j#0: int :: 
  { IndirectionTableModel.__default.PredecessorSetRestrictedPartial#requires(graph#0, dest#0, domain#0, next#0, j#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && 
      LitInt(0) <= dest#0
       && dest#0 < 18446744073709551616
       && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= next#0
       && next#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.PredecessorSetRestrictedPartial#requires(graph#0, dest#0, domain#0, next#0, j#0)
       == true);

// definition axiom for IndirectionTableModel.__default.PredecessorSetRestrictedPartial(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box, next#0: int, j#0: int :: 
    { IndirectionTableModel.__default.PredecessorSetRestrictedPartial(graph#0, dest#0, domain#0, next#0, j#0) } 
    IndirectionTableModel.__default.PredecessorSetRestrictedPartial#canCall(graph#0, dest#0, domain#0, next#0, j#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= next#0
           && next#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.PredecessorSetRestrictedPartial(graph#0, dest#0, domain#0, next#0, j#0)
         == (lambda $y#0: Box :: 
          (exists src#0: int, idx#0: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int } 
            LitInt(0) <= src#0
               && src#0 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#0)]
               && 
              LitInt(0) <= idx#0
               && idx#0 < Seq#Length($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int
                 == dest#0
               && (domain#0[$Box(src#0)] || (src#0 == next#0 && idx#0 < j#0))
               && $y#0
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0)))));

// definition axiom for IndirectionTableModel.__default.PredecessorSetRestrictedPartial for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, domain#0: Set Box, next#0: int, j#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredecessorSetRestrictedPartial(Lit(graph#0), LitInt(dest#0), Lit(domain#0), LitInt(next#0), LitInt(j#0)) } 
    IndirectionTableModel.__default.PredecessorSetRestrictedPartial#canCall(Lit(graph#0), LitInt(dest#0), Lit(domain#0), LitInt(next#0), LitInt(j#0))
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= next#0
           && next#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.PredecessorSetRestrictedPartial(Lit(graph#0), LitInt(dest#0), Lit(domain#0), LitInt(next#0), LitInt(j#0))
         == (lambda $y#1: Box :: 
          (exists src#1: int, idx#1: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#1)]): Seq Box, idx#1)): int } 
            LitInt(0) <= src#1
               && src#1 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#1)]
               && 
              LitInt(0) <= idx#1
               && idx#1 < Seq#Length($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box, idx#1)): int
                 == LitInt(dest#0)
               && (Lit(domain#0)[$Box(src#1)] || (src#1 == LitInt(next#0) && idx#1 < j#0))
               && $y#1
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1)))));

// function declaration for IndirectionTableModel._default.GraphClosedRestricted
function IndirectionTableModel.__default.GraphClosedRestricted(graph#0: Map Box Box, domain#0: Set Box) : bool;

function IndirectionTableModel.__default.GraphClosedRestricted#canCall(graph#0: Map Box Box, domain#0: Set Box) : bool;

// consequence axiom for IndirectionTableModel.__default.GraphClosedRestricted
axiom true
   ==> (forall graph#0: Map Box Box, domain#0: Set Box :: 
    { IndirectionTableModel.__default.GraphClosedRestricted(graph#0, domain#0) } 
    IndirectionTableModel.__default.GraphClosedRestricted#canCall(graph#0, domain#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64())))
       ==> true);

function IndirectionTableModel.__default.GraphClosedRestricted#requires(Map Box Box, Set Box) : bool;

// #requires axiom for IndirectionTableModel.__default.GraphClosedRestricted
axiom (forall graph#0: Map Box Box, domain#0: Set Box :: 
  { IndirectionTableModel.__default.GraphClosedRestricted#requires(graph#0, domain#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
     ==> IndirectionTableModel.__default.GraphClosedRestricted#requires(graph#0, domain#0)
       == true);

// definition axiom for IndirectionTableModel.__default.GraphClosedRestricted(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, domain#0: Set Box :: 
    { IndirectionTableModel.__default.GraphClosedRestricted(graph#0, domain#0) } 
    IndirectionTableModel.__default.GraphClosedRestricted#canCall(graph#0, domain#0)
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64())))
       ==> IndirectionTableModel.__default.GraphClosedRestricted(graph#0, domain#0)
         == (forall ref#0: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box } 
            { domain#0[$Box(ref#0)] } 
          LitInt(0) <= ref#0
               && ref#0 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(ref#0)]
               && domain#0[$Box(ref#0)]
             ==> (forall i#0: int :: 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box, i#0)): int } 
              LitInt(0) <= i#0
                   && i#0 < Seq#Length($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box)
                 ==> Map#Domain(graph#0)[Seq#Index($Unbox(Map#Elements(graph#0)[$Box(ref#0)]): Seq Box, i#0)])));

// definition axiom for IndirectionTableModel.__default.GraphClosedRestricted for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, domain#0: Set Box :: 
    {:weight 3} { IndirectionTableModel.__default.GraphClosedRestricted(Lit(graph#0), Lit(domain#0)) } 
    IndirectionTableModel.__default.GraphClosedRestricted#canCall(Lit(graph#0), Lit(domain#0))
         || ($Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64())))
       ==> IndirectionTableModel.__default.GraphClosedRestricted(Lit(graph#0), Lit(domain#0))
         == (forall ref#1: int :: 
          { $Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box } 
            { domain#0[$Box(ref#1)] } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(ref#1)]
               && Lit(domain#0)[$Box(ref#1)]
             ==> (forall i#1: int :: 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(ref#1)]): Seq Box, i#1)): int } 
              LitInt(0) <= i#1
                   && i#1 < Seq#Length($Unbox(Map#Elements(Lit(graph#0))[$Box(ref#1)]): Seq Box)
                 ==> Map#Domain(graph#0)[Seq#Index($Unbox(Map#Elements(Lit(graph#0))[$Box(ref#1)]): Seq Box, i#1)])));

// function declaration for IndirectionTableModel._default.GraphClosedRestrictedPartial
function IndirectionTableModel.__default.GraphClosedRestrictedPartial(graph#0: Map Box Box, domain#0: Set Box, next#0: int, j#0: int) : bool;

function IndirectionTableModel.__default.GraphClosedRestrictedPartial#canCall(graph#0: Map Box Box, domain#0: Set Box, next#0: int, j#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.GraphClosedRestrictedPartial
axiom true
   ==> (forall graph#0: Map Box Box, domain#0: Set Box, next#0: int, j#0: int :: 
    { IndirectionTableModel.__default.GraphClosedRestrictedPartial(graph#0, domain#0, next#0, j#0) } 
    IndirectionTableModel.__default.GraphClosedRestrictedPartial#canCall(graph#0, domain#0, next#0, j#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= next#0
           && next#0 < 18446744073709551616
           && 
          Map#Domain(graph#0)[$Box(next#0)]
           && 
          LitInt(0) <= j#0
           && j#0 <= Seq#Length($Unbox(Map#Elements(graph#0)[$Box(next#0)]): Seq Box))
       ==> true);

function IndirectionTableModel.__default.GraphClosedRestrictedPartial#requires(Map Box Box, Set Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.GraphClosedRestrictedPartial
axiom (forall graph#0: Map Box Box, domain#0: Set Box, next#0: int, j#0: int :: 
  { IndirectionTableModel.__default.GraphClosedRestrictedPartial#requires(graph#0, domain#0, next#0, j#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= next#0
       && next#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.GraphClosedRestrictedPartial#requires(graph#0, domain#0, next#0, j#0)
       == (Map#Domain(graph#0)[$Box(next#0)]
         && 
        LitInt(0) <= j#0
         && j#0 <= Seq#Length($Unbox(Map#Elements(graph#0)[$Box(next#0)]): Seq Box)));

// definition axiom for IndirectionTableModel.__default.GraphClosedRestrictedPartial(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, domain#0: Set Box, next#0: int, j#0: int :: 
    { IndirectionTableModel.__default.GraphClosedRestrictedPartial(graph#0, domain#0, next#0, j#0) } 
    IndirectionTableModel.__default.GraphClosedRestrictedPartial#canCall(graph#0, domain#0, next#0, j#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= next#0
           && next#0 < 18446744073709551616
           && 
          Map#Domain(graph#0)[$Box(next#0)]
           && 
          LitInt(0) <= j#0
           && j#0 <= Seq#Length($Unbox(Map#Elements(graph#0)[$Box(next#0)]): Seq Box))
       ==> IndirectionTableModel.__default.GraphClosedRestricted#canCall(graph#0, domain#0)
         && IndirectionTableModel.__default.GraphClosedRestrictedPartial(graph#0, domain#0, next#0, j#0)
           == (IndirectionTableModel.__default.GraphClosedRestricted(graph#0, domain#0)
             && (forall i#0: int :: 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(next#0)]): Seq Box, i#0)): int } 
              LitInt(0) <= i#0 && i#0 < j#0
                 ==> Map#Domain(graph#0)[Seq#Index($Unbox(Map#Elements(graph#0)[$Box(next#0)]): Seq Box, i#0)])));

// definition axiom for IndirectionTableModel.__default.GraphClosedRestrictedPartial for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, domain#0: Set Box, next#0: int, j#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.GraphClosedRestrictedPartial(Lit(graph#0), Lit(domain#0), LitInt(next#0), LitInt(j#0)) } 
    IndirectionTableModel.__default.GraphClosedRestrictedPartial#canCall(Lit(graph#0), Lit(domain#0), LitInt(next#0), LitInt(j#0))
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(domain#0, TSet(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= next#0
           && next#0 < 18446744073709551616
           && 
          Map#Domain(graph#0)[$Box(next#0)]
           && 
          LitInt(0) <= LitInt(j#0)
           && LitInt(j#0)
             <= Seq#Length($Unbox(Map#Elements(Lit(graph#0))[$Box(LitInt(next#0))]): Seq Box))
       ==> IndirectionTableModel.__default.GraphClosedRestricted#canCall(Lit(graph#0), Lit(domain#0))
         && IndirectionTableModel.__default.GraphClosedRestrictedPartial(Lit(graph#0), Lit(domain#0), LitInt(next#0), LitInt(j#0))
           == (IndirectionTableModel.__default.GraphClosedRestricted(Lit(graph#0), Lit(domain#0))
             && (forall i#1: int :: 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(next#0)]): Seq Box, i#1)): int } 
              LitInt(0) <= i#1 && i#1 < j#0
                 ==> Map#Domain(graph#0)[Seq#Index($Unbox(Map#Elements(Lit(graph#0))[$Box(LitInt(next#0))]): Seq Box, i#1)])));

// function declaration for IndirectionTableModel._default.IsRoot
function IndirectionTableModel.__default.IsRoot(ref#0: int) : int;

function IndirectionTableModel.__default.IsRoot#canCall(ref#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.IsRoot
axiom true
   ==> (forall ref#0: int :: 
    { IndirectionTableModel.__default.IsRoot(ref#0) } 
    IndirectionTableModel.__default.IsRoot#canCall(ref#0)
         || (LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
       ==> true);

function IndirectionTableModel.__default.IsRoot#requires(int) : bool;

// #requires axiom for IndirectionTableModel.__default.IsRoot
axiom (forall ref#0: int :: 
  { IndirectionTableModel.__default.IsRoot#requires(ref#0) } 
  LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.IsRoot#requires(ref#0) == true);

// definition axiom for IndirectionTableModel.__default.IsRoot(revealed)
axiom true
   ==> (forall ref#0: int :: 
    { IndirectionTableModel.__default.IsRoot(ref#0) } 
    IndirectionTableModel.__default.IsRoot#canCall(ref#0)
         || (LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
       ==> PivotBetreeGraph.__default.Root#canCall()
         && IndirectionTableModel.__default.IsRoot(ref#0)
           == (if ref#0 == LitInt(PivotBetreeGraph.__default.Root()) then 1 else 0));

// definition axiom for IndirectionTableModel.__default.IsRoot for all literals(revealed)
axiom true
   ==> (forall ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.IsRoot(LitInt(ref#0)) } 
    IndirectionTableModel.__default.IsRoot#canCall(LitInt(ref#0))
         || (LitInt(0) <= ref#0 && ref#0 < 18446744073709551616)
       ==> PivotBetreeGraph.__default.Root#canCall()
         && IndirectionTableModel.__default.IsRoot(LitInt(ref#0))
           == (if LitInt(ref#0) == LitInt(PivotBetreeGraph.__default.Root()) then 1 else 0));

// function declaration for IndirectionTableModel._default.ValidPredCounts
function IndirectionTableModel.__default.ValidPredCounts(predCounts#0: Map Box Box, graph#0: Map Box Box) : bool;

function IndirectionTableModel.__default.ValidPredCounts#canCall(predCounts#0: Map Box Box, graph#0: Map Box Box) : bool;

// consequence axiom for IndirectionTableModel.__default.ValidPredCounts
axiom true
   ==> (forall predCounts#0: Map Box Box, graph#0: Map Box Box :: 
    { IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0) } 
    IndirectionTableModel.__default.ValidPredCounts#canCall(predCounts#0, graph#0)
         || ($Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> true);

function IndirectionTableModel.__default.ValidPredCounts#requires(Map Box Box, Map Box Box) : bool;

// #requires axiom for IndirectionTableModel.__default.ValidPredCounts
axiom (forall predCounts#0: Map Box Box, graph#0: Map Box Box :: 
  { IndirectionTableModel.__default.ValidPredCounts#requires(predCounts#0, graph#0) } 
  $Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
       && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
     ==> IndirectionTableModel.__default.ValidPredCounts#requires(predCounts#0, graph#0)
       == true);

// definition axiom for IndirectionTableModel.__default.ValidPredCounts(revealed)
axiom true
   ==> (forall predCounts#0: Map Box Box, graph#0: Map Box Box :: 
    { IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0) } 
    IndirectionTableModel.__default.ValidPredCounts#canCall(predCounts#0, graph#0)
         || ($Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> (forall ref#0: int :: 
          { IndirectionTableModel.__default.IsRoot(ref#0) } 
            { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#0) } 
            { $Unbox(Map#Elements(predCounts#0)[$Box(ref#0)]): int } 
            { Map#Domain(predCounts#0)[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            Map#Domain(predCounts#0)[$Box(ref#0)]
             ==> IndirectionTableModel.__default.PredecessorSet#canCall(graph#0, ref#0)
               && IndirectionTableModel.__default.IsRoot#canCall(ref#0))
         && IndirectionTableModel.__default.ValidPredCounts(predCounts#0, graph#0)
           == (forall ref#0: int :: 
            { IndirectionTableModel.__default.IsRoot(ref#0) } 
              { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#0) } 
              { $Unbox(Map#Elements(predCounts#0)[$Box(ref#0)]): int } 
              { Map#Domain(predCounts#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(predCounts#0)[$Box(ref#0)]
               ==> $Unbox(Map#Elements(predCounts#0)[$Box(ref#0)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(graph#0, ref#0))
                   + IndirectionTableModel.__default.IsRoot(ref#0)));

// definition axiom for IndirectionTableModel.__default.ValidPredCounts for all literals(revealed)
axiom true
   ==> (forall predCounts#0: Map Box Box, graph#0: Map Box Box :: 
    {:weight 3} { IndirectionTableModel.__default.ValidPredCounts(Lit(predCounts#0), Lit(graph#0)) } 
    IndirectionTableModel.__default.ValidPredCounts#canCall(Lit(predCounts#0), Lit(graph#0))
         || ($Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> (forall ref#1: int :: 
          { IndirectionTableModel.__default.IsRoot(ref#1) } 
            { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#1) } 
            { $Unbox(Map#Elements(predCounts#0)[$Box(ref#1)]): int } 
            { Map#Domain(predCounts#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            Map#Domain(predCounts#0)[$Box(ref#1)]
             ==> IndirectionTableModel.__default.PredecessorSet#canCall(Lit(graph#0), ref#1)
               && IndirectionTableModel.__default.IsRoot#canCall(ref#1))
         && IndirectionTableModel.__default.ValidPredCounts(Lit(predCounts#0), Lit(graph#0))
           == (forall ref#1: int :: 
            { IndirectionTableModel.__default.IsRoot(ref#1) } 
              { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#1) } 
              { $Unbox(Map#Elements(predCounts#0)[$Box(ref#1)]): int } 
              { Map#Domain(predCounts#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(predCounts#0)[$Box(ref#1)]
               ==> $Unbox(Map#Elements(Lit(predCounts#0))[$Box(ref#1)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(Lit(graph#0), ref#1))
                   + IndirectionTableModel.__default.IsRoot(ref#1)));

// function declaration for IndirectionTableModel._default.MaxSize
function IndirectionTableModel.__default.MaxSize() : int;

function IndirectionTableModel.__default.MaxSize#canCall() : bool;

// consequence axiom for IndirectionTableModel.__default.MaxSize
axiom true ==> true ==> true;

function IndirectionTableModel.__default.MaxSize#requires() : bool;

// #requires axiom for IndirectionTableModel.__default.MaxSize
axiom IndirectionTableModel.__default.MaxSize#requires() == true;

// definition axiom for IndirectionTableModel.__default.MaxSize(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSize#canCall()
     && IndirectionTableModel.__default.MaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSize());

// definition axiom for IndirectionTableModel.__default.MaxSize for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSize#canCall()
     && IndirectionTableModel.__default.MaxSize()
       == LitInt(Bounds.__default.IndirectionTableMaxSize());

// function declaration for IndirectionTableModel._default.MaxSizeUint64
function IndirectionTableModel.__default.MaxSizeUint64() : int;

function IndirectionTableModel.__default.MaxSizeUint64#canCall() : bool;

// consequence axiom for IndirectionTableModel.__default.MaxSizeUint64
axiom true
   ==> 
  true
   ==> LitInt(0) <= IndirectionTableModel.__default.MaxSizeUint64()
     && IndirectionTableModel.__default.MaxSizeUint64() < 18446744073709551616;

function IndirectionTableModel.__default.MaxSizeUint64#requires() : bool;

// #requires axiom for IndirectionTableModel.__default.MaxSizeUint64
axiom IndirectionTableModel.__default.MaxSizeUint64#requires() == true;

// definition axiom for IndirectionTableModel.__default.MaxSizeUint64(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && IndirectionTableModel.__default.MaxSizeUint64()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// definition axiom for IndirectionTableModel.__default.MaxSizeUint64 for all literals(revealed)
axiom true
   ==> 
  true
   ==> Bounds.__default.IndirectionTableMaxSizeUint64#canCall()
     && IndirectionTableModel.__default.MaxSizeUint64()
       == LitInt(Bounds.__default.IndirectionTableMaxSizeUint64());

// function declaration for IndirectionTableModel._default.Inv
function IndirectionTableModel.__default.Inv(self#0: DatatypeType) : bool;

function IndirectionTableModel.__default.Inv#canCall(self#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.Inv
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.Inv(self#0) } 
    IndirectionTableModel.__default.Inv#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> 
      IndirectionTableModel.__default.Inv(self#0)
       ==> (forall ref#0: int :: 
        { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)] } 
          { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)] } 
        LitInt(0) <= ref#0
             && ref#0 < 18446744073709551616
             && Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
           ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]));

function IndirectionTableModel.__default.Inv#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.Inv
axiom (forall self#0: DatatypeType :: 
  { IndirectionTableModel.__default.Inv#requires(self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.Inv#requires(self#0) == true);

// definition axiom for IndirectionTableModel.__default.Inv(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.Inv(self#0) } 
    IndirectionTableModel.__default.Inv#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> true);

// definition axiom for IndirectionTableModel.__default.Inv for all literals(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.Inv(Lit(self#0)) } 
    IndirectionTableModel.__default.Inv#canCall(Lit(self#0))
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> true);

// function declaration for IndirectionTableModel._default.TrackingGarbage
function IndirectionTableModel.__default.TrackingGarbage(self#0: DatatypeType) : bool;

function IndirectionTableModel.__default.TrackingGarbage#canCall(self#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.TrackingGarbage
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.TrackingGarbage(self#0) } 
    IndirectionTableModel.__default.TrackingGarbage#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> true);

function IndirectionTableModel.__default.TrackingGarbage#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.TrackingGarbage
axiom (forall self#0: DatatypeType :: 
  { IndirectionTableModel.__default.TrackingGarbage#requires(self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.TrackingGarbage#requires(self#0) == true);

// definition axiom for IndirectionTableModel.__default.TrackingGarbage(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.TrackingGarbage(self#0) } 
    IndirectionTableModel.__default.TrackingGarbage#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && IndirectionTableModel.__default.TrackingGarbage(self#0)
           == Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0)));

// definition axiom for IndirectionTableModel.__default.TrackingGarbage for all literals(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.TrackingGarbage(Lit(self#0)) } 
    IndirectionTableModel.__default.TrackingGarbage#canCall(Lit(self#0))
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && IndirectionTableModel.__default.TrackingGarbage(Lit(self#0))
           == Lit(Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))));

// function declaration for IndirectionTableModel._default.Inv1
function IndirectionTableModel.__default.Inv1(self#0: DatatypeType) : bool;

function IndirectionTableModel.__default.Inv1#canCall(self#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.Inv1
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.Inv1(self#0) } 
    IndirectionTableModel.__default.Inv1#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> true);

function IndirectionTableModel.__default.Inv1#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.Inv1
axiom (forall self#0: DatatypeType :: 
  { IndirectionTableModel.__default.Inv1#requires(self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.Inv1#requires(self#0) == true);

// definition axiom for IndirectionTableModel.__default.Inv1(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.Inv1(self#0) } 
    IndirectionTableModel.__default.Inv1#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0))
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.Locs#canCall(IndirectionTableModel.IndirectionTable.t(self#0)))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.Locs#canCall(IndirectionTableModel.IndirectionTable.t(self#0))
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self#0), 
              IndirectionTableModel.__default.Locs(IndirectionTableModel.IndirectionTable.t(self#0)))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.Graph#canCall(IndirectionTableModel.IndirectionTable.t(self#0)))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.Graph#canCall(IndirectionTableModel.IndirectionTable.t(self#0))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self#0), 
              IndirectionTableModel.__default.Graph(IndirectionTableModel.IndirectionTable.t(self#0)))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.PredCounts#canCall(IndirectionTableModel.IndirectionTable.t(self#0)))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.PredCounts#canCall(IndirectionTableModel.IndirectionTable.t(self#0))
             && Map#Equal(IndirectionTableModel.IndirectionTable.predCounts(self#0), 
              IndirectionTableModel.__default.PredCounts(IndirectionTableModel.IndirectionTable.t(self#0)))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.ValidPredCounts#canCall(IndirectionTableModel.IndirectionTable.predCounts(self#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0)))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && IndirectionTableModel.__default.ValidPredCounts#canCall(IndirectionTableModel.IndirectionTable.predCounts(self#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
             && IndirectionTableModel.__default.ValidPredCounts(IndirectionTableModel.IndirectionTable.predCounts(self#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.IndirectionTable.graph(self#0)))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.IndirectionTable.graph(self#0))
             && BlockCache.__default.GraphClosed(IndirectionTableModel.IndirectionTable.graph(self#0))
           ==> (forall ref#0: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && Bounds.__default.MaxNumChildren#canCall())))
         && ((forall ref#0: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                 ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                   && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
                     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                       && Bounds.__default.MaxNumChildren#canCall()))
             && (forall ref#0: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
                 ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                 && LruModel.__default.WF#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                 && (LruModel.__default.WF($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                   ==> (forall ref#1: int :: 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                    LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                         && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                               == LitInt(0)
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box))))
                 && ((forall ref#1: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                      LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                         ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                           && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                               && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                               && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                                 == LitInt(0)
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                               && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)))
                     && (forall ref#1: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                      LitInt(0) <= ref#1
                           && ref#1 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)])
                   ==> (forall ref#2: int :: 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)] } 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)] } 
                    LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                         && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                         && (LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                             && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]
                               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                                 && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                                 && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType)))))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                 && LruModel.__default.WF#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                 && (LruModel.__default.WF($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                   ==> (forall ref#1: int :: 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                    LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                         && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                               == LitInt(0)
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box))))
                 && ((forall ref#1: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                      LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                         ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                           && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                               && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                               && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                                 == LitInt(0)
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                               && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)))
                     && (forall ref#1: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                      LitInt(0) <= ref#1
                           && ref#1 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                             == LitInt(0)
                         ==> LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)])
                   ==> (forall ref#2: int :: 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)] } 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)] } 
                    LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                         && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                         && (LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                             && (Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]
                               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                                 && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
                                 && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType))))))
             && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))
               ==> LruModel.__default.WF($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                 && (forall ref#1: int :: 
                  { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)])
                 && (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)] } 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0)))
         && (PivotBetreeGraph.__default.Root#canCall()
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(PivotBetreeGraph.__default.Root())]
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
             && IndirectionTableModel.__default.MaxSize#canCall())
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.LinearHashMap.LinearHashMap_q(IndirectionTableModel.IndirectionTable.t(self#0))
             && IndirectionTableModel.__default.MaxSize#canCall()
             && MutableMapModel.LinearHashMap.count(IndirectionTableModel.IndirectionTable.t(self#0))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> (forall ref#3: int :: 
            { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)] } 
            LitInt(0) <= ref#3 && ref#3 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0))))
         && ((forall ref#3: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3 && ref#3 < 18446744073709551616
                 ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                   && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)]
                     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)))
             && (forall ref#3: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)]
                 ==> ref#3 <= IndirectionTableModel.IndirectionTable.refUpperBound(self#0))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                 && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                 && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)
                 && (MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                    IndirectionTableModel.IndirectionTable.t(self#0), 
                    $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)
                   ==> (forall r#0: int :: 
                    { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)] } 
                      { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)[$Box(r#0)] } 
                    LitInt(0) <= r#0 && r#0 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                         && MutableMapModel.SimpleIterator.SimpleIterator_q($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)
                         && (MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)[$Box(r#0)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0))))))
         && IndirectionTableModel.__default.Inv1(self#0)
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0))
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self#0), 
              IndirectionTableModel.__default.Locs(IndirectionTableModel.IndirectionTable.t(self#0)))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self#0), 
              IndirectionTableModel.__default.Graph(IndirectionTableModel.IndirectionTable.t(self#0)))
             && Map#Equal(IndirectionTableModel.IndirectionTable.predCounts(self#0), 
              IndirectionTableModel.__default.PredCounts(IndirectionTableModel.IndirectionTable.t(self#0)))
             && IndirectionTableModel.__default.ValidPredCounts(IndirectionTableModel.IndirectionTable.predCounts(self#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
             && BlockCache.__default.GraphClosed(IndirectionTableModel.IndirectionTable.graph(self#0))
             && (forall ref#0: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
                 ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))
               ==> LruModel.__default.WF($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
                 && (forall ref#1: int :: 
                  { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)] } 
                  LitInt(0) <= ref#1
                       && ref#1 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#1)])
                 && (forall ref#2: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)] } 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)] } 
                  LitInt(0) <= ref#2
                       && ref#2 < 18446744073709551616
                       && LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#2)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#2)]): DatatypeType)
                         == LitInt(0)))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(PivotBetreeGraph.__default.Root())]
             && MutableMapModel.LinearHashMap.count(IndirectionTableModel.IndirectionTable.t(self#0))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             && (forall ref#3: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#3)]
                 ==> ref#3 <= IndirectionTableModel.IndirectionTable.refUpperBound(self#0))
             && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)
                 && (forall r#0: int :: 
                  { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)[$Box(r#0)] } 
                  LitInt(0) <= r#0
                       && r#0 < 18446744073709551616
                       && MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)[$Box(r#0)]
                     ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)]))));

// definition axiom for IndirectionTableModel.__default.Inv1 for all literals(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.Inv1(Lit(self#0)) } 
    IndirectionTableModel.__default.Inv1#canCall(Lit(self#0))
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.Locs#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.Locs#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(Lit(self#0)), 
              IndirectionTableModel.__default.Locs(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.Graph#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.Graph#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)), 
              IndirectionTableModel.__default.Graph(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.PredCounts#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.PredCounts#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && Map#Equal(IndirectionTableModel.IndirectionTable.predCounts(Lit(self#0)), 
              IndirectionTableModel.__default.PredCounts(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.ValidPredCounts#canCall(Lit(IndirectionTableModel.IndirectionTable.predCounts(Lit(self#0))), 
              Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && IndirectionTableModel.__default.ValidPredCounts#canCall(Lit(IndirectionTableModel.IndirectionTable.predCounts(Lit(self#0))), 
              Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))
             && Lit(IndirectionTableModel.__default.ValidPredCounts(Lit(IndirectionTableModel.IndirectionTable.predCounts(Lit(self#0))), 
                Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))
             && Lit(BlockCache.__default.GraphClosed(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))))
           ==> (forall ref#4: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)] } 
            LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#4)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                     && Bounds.__default.MaxNumChildren#canCall())))
         && ((forall ref#4: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
                 ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                   && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#4)]
                     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                       && Bounds.__default.MaxNumChildren#canCall()))
             && (forall ref#4: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#4)]
                 ==> Seq#Length($Unbox(Map#Elements(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))[$Box(ref#4)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && (Lit(Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0)))))
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                 && LruModel.__default.WF#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
                 && (Lit(LruModel.__default.WF(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))
                   ==> (forall ref#5: int :: 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                    LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                         && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                               == LitInt(0)
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && LruModel.__default.I#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))))
                 && ((forall ref#5: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                      LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                         ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                           && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                               && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                               && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                                 == LitInt(0)
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                               && LruModel.__default.I#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))))
                     && (forall ref#5: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                      LitInt(0) <= ref#5
                           && ref#5 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                             == LitInt(0)
                         ==> Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#5)])
                   ==> (forall ref#6: int :: 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)] } 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#6)] } 
                    LitInt(0) <= ref#6 && ref#6 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                         && LruModel.__default.I#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
                         && (Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#6)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                             && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#6)]
                               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                                 && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                                 && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#6)]): DatatypeType)))))))
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && (Lit(Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0)))))
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                 && LruModel.__default.WF#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
                 && (Lit(LruModel.__default.WF(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))
                   ==> (forall ref#5: int :: 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                    LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                         && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType))
                         && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                               == LitInt(0)
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && LruModel.__default.I#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))))
                 && ((forall ref#5: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                      LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                         ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                           && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                               && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                               && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType))
                           && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                                 == LitInt(0)
                             ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                               && LruModel.__default.I#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))))
                     && (forall ref#5: int :: 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                        { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                      LitInt(0) <= ref#5
                           && ref#5 < 18446744073709551616
                           && 
                          Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                             == LitInt(0)
                         ==> Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#5)])
                   ==> (forall ref#6: int :: 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)]): DatatypeType } 
                      { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)] } 
                      { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#6)] } 
                    LitInt(0) <= ref#6 && ref#6 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                         && LruModel.__default.I#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
                         && (Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#6)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                             && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#6)]
                               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                                 && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
                                 && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#6)]): DatatypeType))))))
             && (Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))
               ==> LruModel.__default.WF(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
                 && (forall ref#5: int :: 
                  { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                         == LitInt(0)
                     ==> Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#5)])
                 && (forall ref#6: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)] } 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#6)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
         && (PivotBetreeGraph.__default.Root#canCall()
             && 
            IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(PivotBetreeGraph.__default.Root())]
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && IndirectionTableModel.__default.MaxSize#canCall())
         && (IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && IndirectionTableModel.__default.MaxSize#canCall()
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> (forall ref#7: int :: 
            { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#7)] } 
            LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#7)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0)))))
         && ((forall ref#7: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
                 ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                   && (Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#7)]
                     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))))
             && (forall ref#7: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#7)]
                 ==> ref#7
                   <= LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && (Lit(Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0)))))
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                 && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                 && MutableMapModel.__default.WFSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType))
                 && (MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                    Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                    Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType))
                   ==> (forall r#1: int :: 
                    { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#1)] } 
                      { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)[$Box(r#1)] } 
                    LitInt(0) <= r#1 && r#1 < 18446744073709551616
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                         && MutableMapModel.SimpleIterator.SimpleIterator_q(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType))
                         && (Lit(MutableMapModel.SimpleIterator.s(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType)))[$Box(r#1)]
                           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0)))))))
         && IndirectionTableModel.__default.Inv1(Lit(self#0))
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(Lit(self#0)), 
              IndirectionTableModel.__default.Locs(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)), 
              IndirectionTableModel.__default.Graph(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
             && Map#Equal(IndirectionTableModel.IndirectionTable.predCounts(Lit(self#0)), 
              IndirectionTableModel.__default.PredCounts(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
             && IndirectionTableModel.__default.ValidPredCounts(Lit(IndirectionTableModel.IndirectionTable.predCounts(Lit(self#0))), 
              Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))
             && BlockCache.__default.GraphClosed(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))
             && (forall ref#4: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#4)]
                 ==> Seq#Length($Unbox(Map#Elements(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))[$Box(ref#4)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && (Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))
               ==> LruModel.__default.WF(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
                 && (forall ref#5: int :: 
                  { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#5)] } 
                    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#5)] } 
                  LitInt(0) <= ref#5
                       && ref#5 < 18446744073709551616
                       && 
                      Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#5)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#5)]): DatatypeType)
                         == LitInt(0)
                     ==> Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#5)])
                 && (forall ref#6: int :: 
                  { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)]): DatatypeType } 
                    { Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#6)] } 
                    { LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)[$Box(ref#6)] } 
                  LitInt(0) <= ref#6
                       && ref#6 < 18446744073709551616
                       && Lit(LruModel.__default.I(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)))[$Box(ref#6)]
                     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(ref#6)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))))[$Box(ref#6)]): DatatypeType)
                         == LitInt(0)))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))[$Box(PivotBetreeGraph.__default.Root())]
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             && (forall ref#7: int :: 
              { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#7)]
                 ==> ref#7
                   <= LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))))
             && (Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))
               ==> MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType))
                 && (forall r#1: int :: 
                  { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#1)] } 
                    { MutableMapModel.SimpleIterator.s($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType)[$Box(r#1)] } 
                  LitInt(0) <= r#1
                       && r#1 < 18446744073709551616
                       && Lit(MutableMapModel.SimpleIterator.s(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType)))[$Box(r#1)]
                     ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(Lit(self#0)))[$Box(r#1)]))));

procedure CheckWellformed$$IndirectionTableModel.__default.reveal__Inv(self#0: DatatypeType
       where $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
         && $IsAlloc(self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap)
         && $IsA#IndirectionTableModel.IndirectionTable(self#0));
  free requires 26 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.reveal__Inv(self#0: DatatypeType
       where $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
         && $IsAlloc(self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap)
         && $IsA#IndirectionTableModel.IndirectionTable(self#0));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.__default.Inv#canCall(self#0)
     && IndirectionTableModel.__default.Inv1#canCall(self#0);
  ensures IndirectionTableModel.__default.Inv(self#0)
     == IndirectionTableModel.__default.Inv1(self#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.IHashMap
function IndirectionTableModel.__default.IHashMap(m#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.IHashMap#canCall(m#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.IHashMap
axiom true
   ==> (forall m#0: DatatypeType :: 
    { IndirectionTableModel.__default.IHashMap(m#0) } 
    IndirectionTableModel.__default.IHashMap#canCall(m#0)
         || $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> $Is(IndirectionTableModel.__default.IHashMap(m#0), 
        Tclass.SectorType.IndirectionTable()));

function IndirectionTableModel.__default.IHashMap#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.IHashMap
axiom (forall m#0: DatatypeType :: 
  { IndirectionTableModel.__default.IHashMap#requires(m#0) } 
  $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.IHashMap#requires(m#0) == true);

// definition axiom for IndirectionTableModel.__default.IHashMap(revealed)
axiom true
   ==> (forall m#0: DatatypeType :: 
    { IndirectionTableModel.__default.IHashMap(m#0) } 
    IndirectionTableModel.__default.IHashMap#canCall(m#0)
         || $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> IndirectionTableModel.__default.Locs#canCall(m#0)
         && IndirectionTableModel.__default.Graph#canCall(m#0)
         && IndirectionTableModel.__default.IHashMap(m#0)
           == #SectorType.IndirectionTable.IndirectionTable(IndirectionTableModel.__default.Locs(m#0), 
            IndirectionTableModel.__default.Graph(m#0)));

// definition axiom for IndirectionTableModel.__default.IHashMap for all literals(revealed)
axiom true
   ==> (forall m#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.IHashMap(Lit(m#0)) } 
    IndirectionTableModel.__default.IHashMap#canCall(Lit(m#0))
         || $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       ==> IndirectionTableModel.__default.Locs#canCall(Lit(m#0))
         && IndirectionTableModel.__default.Graph#canCall(Lit(m#0))
         && IndirectionTableModel.__default.IHashMap(Lit(m#0))
           == Lit(#SectorType.IndirectionTable.IndirectionTable(Lit(IndirectionTableModel.__default.Locs(Lit(m#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(m#0))))));

// function declaration for IndirectionTableModel._default.I
function IndirectionTableModel.__default.I(self#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.I#canCall(self#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.I
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.I(self#0) } 
    IndirectionTableModel.__default.I#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> $Is(IndirectionTableModel.__default.I(self#0), Tclass.SectorType.IndirectionTable()));

function IndirectionTableModel.__default.I#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.I
axiom (forall self#0: DatatypeType :: 
  { IndirectionTableModel.__default.I#requires(self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.I#requires(self#0) == true);

// definition axiom for IndirectionTableModel.__default.I(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    { IndirectionTableModel.__default.I(self#0) } 
    IndirectionTableModel.__default.I#canCall(self#0)
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && IndirectionTableModel.__default.I(self#0)
           == #SectorType.IndirectionTable.IndirectionTable(IndirectionTableModel.IndirectionTable.locs(self#0), 
            IndirectionTableModel.IndirectionTable.graph(self#0)));

// definition axiom for IndirectionTableModel.__default.I for all literals(revealed)
axiom true
   ==> (forall self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.I(Lit(self#0)) } 
    IndirectionTableModel.__default.I#canCall(Lit(self#0))
         || $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && IndirectionTableModel.__default.I(Lit(self#0))
           == Lit(#SectorType.IndirectionTable.IndirectionTable(Lit(IndirectionTableModel.IndirectionTable.locs(Lit(self#0))), 
              Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))));

// function declaration for IndirectionTableModel._default.FromHashMap
function IndirectionTableModel.__default.FromHashMap(m#0: DatatypeType, 
    q#0: DatatypeType, 
    refUpperBound#0: int, 
    findLoclessIterator#0: DatatypeType)
   : DatatypeType;

function IndirectionTableModel.__default.FromHashMap#canCall(m#0: DatatypeType, 
    q#0: DatatypeType, 
    refUpperBound#0: int, 
    findLoclessIterator#0: DatatypeType)
   : bool;

// consequence axiom for IndirectionTableModel.__default.FromHashMap
axiom true
   ==> (forall m#0: DatatypeType, 
      q#0: DatatypeType, 
      refUpperBound#0: int, 
      findLoclessIterator#0: DatatypeType :: 
    { IndirectionTableModel.__default.FromHashMap(m#0, q#0, refUpperBound#0, findLoclessIterator#0) } 
    IndirectionTableModel.__default.FromHashMap#canCall(m#0, q#0, refUpperBound#0, findLoclessIterator#0)
         || (
          $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && $Is(findLoclessIterator#0, 
            Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator())))
       ==> $Is(IndirectionTableModel.__default.FromHashMap(m#0, q#0, refUpperBound#0, findLoclessIterator#0), 
        Tclass.IndirectionTableModel.IndirectionTable()));

function IndirectionTableModel.__default.FromHashMap#requires(DatatypeType, DatatypeType, int, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.FromHashMap
axiom (forall m#0: DatatypeType, 
    q#0: DatatypeType, 
    refUpperBound#0: int, 
    findLoclessIterator#0: DatatypeType :: 
  { IndirectionTableModel.__default.FromHashMap#requires(m#0, q#0, refUpperBound#0, findLoclessIterator#0) } 
  $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())))
       && 
      LitInt(0) <= refUpperBound#0
       && refUpperBound#0 < 18446744073709551616
       && $Is(findLoclessIterator#0, 
        Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator()))
     ==> IndirectionTableModel.__default.FromHashMap#requires(m#0, q#0, refUpperBound#0, findLoclessIterator#0)
       == true);

// definition axiom for IndirectionTableModel.__default.FromHashMap(revealed)
axiom true
   ==> (forall m#0: DatatypeType, 
      q#0: DatatypeType, 
      refUpperBound#0: int, 
      findLoclessIterator#0: DatatypeType :: 
    { IndirectionTableModel.__default.FromHashMap(m#0, q#0, refUpperBound#0, findLoclessIterator#0) } 
    IndirectionTableModel.__default.FromHashMap#canCall(m#0, q#0, refUpperBound#0, findLoclessIterator#0)
         || (
          $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && $Is(findLoclessIterator#0, 
            Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator())))
       ==> IndirectionTableModel.__default.Locs#canCall(m#0)
         && IndirectionTableModel.__default.Graph#canCall(m#0)
         && IndirectionTableModel.__default.PredCounts#canCall(m#0)
         && IndirectionTableModel.__default.FromHashMap(m#0, q#0, refUpperBound#0, findLoclessIterator#0)
           == #IndirectionTableModel.IndirectionTable.IndirectionTable(m#0, 
            q#0, 
            refUpperBound#0, 
            findLoclessIterator#0, 
            IndirectionTableModel.__default.Locs(m#0), 
            IndirectionTableModel.__default.Graph(m#0), 
            IndirectionTableModel.__default.PredCounts(m#0)));

// definition axiom for IndirectionTableModel.__default.FromHashMap for all literals(revealed)
axiom true
   ==> (forall m#0: DatatypeType, 
      q#0: DatatypeType, 
      refUpperBound#0: int, 
      findLoclessIterator#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.FromHashMap(Lit(m#0), Lit(q#0), LitInt(refUpperBound#0), Lit(findLoclessIterator#0)) } 
    IndirectionTableModel.__default.FromHashMap#canCall(Lit(m#0), Lit(q#0), LitInt(refUpperBound#0), Lit(findLoclessIterator#0))
         || (
          $Is(m#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, Tclass.Options.Option(TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && $Is(findLoclessIterator#0, 
            Tclass.Options.Option(Tclass.MutableMapModel.SimpleIterator())))
       ==> IndirectionTableModel.__default.Locs#canCall(Lit(m#0))
         && IndirectionTableModel.__default.Graph#canCall(Lit(m#0))
         && IndirectionTableModel.__default.PredCounts#canCall(Lit(m#0))
         && IndirectionTableModel.__default.FromHashMap(Lit(m#0), Lit(q#0), LitInt(refUpperBound#0), Lit(findLoclessIterator#0))
           == Lit(#IndirectionTableModel.IndirectionTable.IndirectionTable(Lit(m#0), 
              Lit(q#0), 
              LitInt(refUpperBound#0), 
              Lit(findLoclessIterator#0), 
              Lit(IndirectionTableModel.__default.Locs(Lit(m#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(m#0))), 
              Lit(IndirectionTableModel.__default.PredCounts(Lit(m#0))))));

// function declaration for IndirectionTableModel._default.GetEntry
function IndirectionTableModel.__default.GetEntry($ly: LayerType, self#0: DatatypeType, ref#0: int) : DatatypeType;

function IndirectionTableModel.__default.GetEntry#canCall(self#0: DatatypeType, ref#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.GetEntry($LS($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.GetEntry($LS($ly), self#0, ref#0)
     == IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.GetEntry(AsFuelBottom($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0)
     == IndirectionTableModel.__default.GetEntry($LZ, self#0, ref#0));

// consequence axiom for IndirectionTableModel.__default.GetEntry
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0) } 
    IndirectionTableModel.__default.GetEntry#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && IndirectionTableModel.__default.Inv(self#0))
       ==> (Options.Option.None_q(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))
           ==> !Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)])
         && (Options.Option.Some_q(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))
           ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)])
         && (Options.Option.Some_q(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))
           ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]): Seq Box, 
            IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))
             && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))): DatatypeType))
           ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
             && DiskLayout.Location#Equal($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]): DatatypeType, 
              $Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))): DatatypeType))): DatatypeType))
         && (Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
           ==> Options.Option.Some_q(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))
             && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0))): DatatypeType)))
         && $Is(IndirectionTableModel.__default.GetEntry($ly, self#0, ref#0), 
          Tclass.Options.Option(Tclass.IndirectionTableModel.Entry())));

function IndirectionTableModel.__default.GetEntry#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.GetEntry
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.GetEntry#requires($ly, self#0, ref#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.GetEntry#requires($ly, self#0, ref#0)
       == IndirectionTableModel.__default.Inv(self#0));

// definition axiom for IndirectionTableModel.__default.GetEntry(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.GetEntry($LS($ly), self#0, ref#0) } 
    IndirectionTableModel.__default.GetEntry#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0)
         && IndirectionTableModel.__default.GetEntry($LS($ly), self#0, ref#0)
           == MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            ref#0));

// definition axiom for IndirectionTableModel.__default.GetEntry for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.GetEntry($LS($ly), Lit(self#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.GetEntry#canCall(Lit(self#0), LitInt(ref#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && Lit(IndirectionTableModel.__default.Inv(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          LitInt(ref#0))
         && IndirectionTableModel.__default.GetEntry($LS($ly), Lit(self#0), LitInt(ref#0))
           == Lit(MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              LitInt(ref#0))));

// function declaration for IndirectionTableModel._default.HasEmptyLoc
function IndirectionTableModel.__default.HasEmptyLoc($ly: LayerType, self#0: DatatypeType, ref#0: int) : bool;

function IndirectionTableModel.__default.HasEmptyLoc#canCall(self#0: DatatypeType, ref#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.HasEmptyLoc($LS($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.HasEmptyLoc($LS($ly), self#0, ref#0)
     == IndirectionTableModel.__default.HasEmptyLoc($ly, self#0, ref#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.HasEmptyLoc(AsFuelBottom($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.HasEmptyLoc($ly, self#0, ref#0)
     == IndirectionTableModel.__default.HasEmptyLoc($LZ, self#0, ref#0));

// consequence axiom for IndirectionTableModel.__default.HasEmptyLoc
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.HasEmptyLoc($ly, self#0, ref#0) } 
    IndirectionTableModel.__default.HasEmptyLoc#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.__default.HasEmptyLoc($ly, self#0, ref#0)
         == (Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
           && !Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]));

function IndirectionTableModel.__default.HasEmptyLoc#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.HasEmptyLoc
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.HasEmptyLoc#requires($ly, self#0, ref#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.HasEmptyLoc#requires($ly, self#0, ref#0)
       == IndirectionTableModel.__default.Inv(self#0));

// definition axiom for IndirectionTableModel.__default.HasEmptyLoc(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.HasEmptyLoc($LS($ly), self#0, ref#0) } 
    IndirectionTableModel.__default.HasEmptyLoc#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0)
         && (var entry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0); 
          Options.Option.Some_q(entry#0)
             ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(entry#0)): DatatypeType))
         && IndirectionTableModel.__default.HasEmptyLoc($LS($ly), self#0, ref#0)
           == (var entry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
                IndirectionTableModel.IndirectionTable.t(self#0), 
                ref#0); 
            Options.Option.Some_q(entry#0)
               && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(entry#0)): DatatypeType))));

// definition axiom for IndirectionTableModel.__default.HasEmptyLoc for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.HasEmptyLoc($LS($ly), Lit(self#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.HasEmptyLoc#canCall(Lit(self#0), LitInt(ref#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && Lit(IndirectionTableModel.__default.Inv(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          LitInt(ref#0))
         && (var entry#1 := Lit(MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
                Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                LitInt(ref#0))); 
          Options.Option.Some_q(entry#1)
             ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(entry#1)): DatatypeType))
         && IndirectionTableModel.__default.HasEmptyLoc($LS($ly), Lit(self#0), LitInt(ref#0))
           == (var entry#1 := Lit(MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  LitInt(ref#0))); 
            Lit(Options.Option.Some_q(entry#1)
                 && Options.Option.None_q(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(Options.Option.value(entry#1)): DatatypeType)))))));

// function declaration for IndirectionTableModel._default.AddLocIfPresent
function IndirectionTableModel.__default.AddLocIfPresent($ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType)
   : DatatypeType;

function IndirectionTableModel.__default.AddLocIfPresent#canCall(self#0: DatatypeType, ref#0: int, loc#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
  { IndirectionTableModel.__default.AddLocIfPresent($LS($ly), self#0, ref#0, loc#0) } 
  IndirectionTableModel.__default.AddLocIfPresent($LS($ly), self#0, ref#0, loc#0)
     == IndirectionTableModel.__default.AddLocIfPresent($ly, self#0, ref#0, loc#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
  { IndirectionTableModel.__default.AddLocIfPresent(AsFuelBottom($ly), self#0, ref#0, loc#0) } 
  IndirectionTableModel.__default.AddLocIfPresent($ly, self#0, ref#0, loc#0)
     == IndirectionTableModel.__default.AddLocIfPresent($LZ, self#0, ref#0, loc#0));

// consequence axiom for IndirectionTableModel.__default.AddLocIfPresent
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    { IndirectionTableModel.__default.AddLocIfPresent($ly, self#0, ref#0, loc#0) } 
    IndirectionTableModel.__default.AddLocIfPresent#canCall(self#0, ref#0, loc#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> (var self'#0, added#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.AddLocIfPresent($ly, self#0, ref#0, loc#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.AddLocIfPresent($ly, self#0, ref#0, loc#0))): bool; 
          IndirectionTableModel.__default.Inv(self'#0)
             && added#0
               == (Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
                 && !Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)])
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self'#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
             && (added#0
               ==> Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
                Map#Build(IndirectionTableModel.IndirectionTable.locs(self#0), $Box(ref#0), $Box(loc#0))))
             && (!added#0
               ==> Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
                IndirectionTableModel.IndirectionTable.locs(self#0)))
             && (IndirectionTableModel.__default.TrackingGarbage(self#0)
               ==> IndirectionTableModel.__default.TrackingGarbage(self'#0)))
         && $Is(IndirectionTableModel.__default.AddLocIfPresent($ly, self#0, ref#0, loc#0), 
          Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), TBool)));

function IndirectionTableModel.__default.AddLocIfPresent#requires(LayerType, DatatypeType, int, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.AddLocIfPresent
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
  { IndirectionTableModel.__default.AddLocIfPresent#requires($ly, self#0, ref#0, loc#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
       && $Is(loc#0, Tclass.DiskLayout.Location())
     ==> IndirectionTableModel.__default.AddLocIfPresent#requires($ly, self#0, ref#0, loc#0)
       == IndirectionTableModel.__default.Inv(self#0));

// definition axiom for IndirectionTableModel.__default.AddLocIfPresent(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    { IndirectionTableModel.__default.AddLocIfPresent($LS($ly), self#0, ref#0, loc#0) } 
    IndirectionTableModel.__default.AddLocIfPresent#canCall(self#0, ref#0, loc#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.FindSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0)
         && (var it#0 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.FindSimpleIter, 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0); 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              it#0)
             && (var oldEntry#0 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  it#0); 
              (MutableMapModel.IteratorOutput.Next_q(oldEntry#0)
                   ==> IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType))
                 && (var added#1 := MutableMapModel.IteratorOutput.Next_q(oldEntry#0)
                       && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)); 
                  added#1
                     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                       && 
                      IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)
                       && MutableMapModel.__default.UpdateByIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                        IndirectionTableModel.IndirectionTable.t(self#0), 
                        it#0, 
                        $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), 
                            IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType), 
                            IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType))))
                       && (var t#0 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                            StartFuel_MutableMapModel._default.UpdateByIter, 
                            IndirectionTableModel.IndirectionTable.t(self#0), 
                            it#0, 
                            $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), 
                                IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType), 
                                IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)))); 
                        IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                           && 
                          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                           && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                           && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                           && IndirectionTableModel.__default.FromHashMap#canCall(t#0, 
                            IndirectionTableModel.IndirectionTable.garbageQueue(self#0), 
                            IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
                            IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))))))
         && IndirectionTableModel.__default.AddLocIfPresent($LS($ly), self#0, ref#0, loc#0)
           == (var it#0 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.FindSimpleIter, 
                IndirectionTableModel.IndirectionTable.t(self#0), 
                ref#0); 
            (var oldEntry#0 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  it#0); 
              (var added#1 := MutableMapModel.IteratorOutput.Next_q(oldEntry#0)
                     && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)); 
                (if added#1
                   then (var t#0 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.UpdateByIter, 
                        IndirectionTableModel.IndirectionTable.t(self#0), 
                        it#0, 
                        $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), 
                            IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType), 
                            IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)))); 
                    (var _v0#0 := (if Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
                           then 0
                           else 0); 
                      #_System._tuple#2._#Make2($Box(IndirectionTableModel.__default.FromHashMap(t#0, 
                            IndirectionTableModel.IndirectionTable.garbageQueue(self#0), 
                            IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
                            IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))), 
                        $Box(Lit(true)))))
                   else #_System._tuple#2._#Make2($Box(self#0), $Box(Lit(false))))))));

// definition axiom for IndirectionTableModel.__default.AddLocIfPresent for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, loc#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.AddLocIfPresent($LS($ly), Lit(self#0), LitInt(ref#0), Lit(loc#0)) } 
    IndirectionTableModel.__default.AddLocIfPresent#canCall(Lit(self#0), LitInt(ref#0), Lit(loc#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(loc#0, Tclass.DiskLayout.Location())
           && Lit(IndirectionTableModel.__default.Inv(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.FindSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          LitInt(ref#0))
         && (var it#1 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.FindSimpleIter, 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              LitInt(ref#0)); 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              it#1)
             && (var oldEntry#1 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  it#1); 
              (MutableMapModel.IteratorOutput.Next_q(oldEntry#1)
                   ==> IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType))
                 && (var added#2 := MutableMapModel.IteratorOutput.Next_q(oldEntry#1)
                       && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)); 
                  added#2
                     ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                       && 
                      IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)
                       && MutableMapModel.__default.UpdateByIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                        Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                        it#1, 
                        $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.Some($Box(Lit(loc#0)))), 
                            IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType), 
                            IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType))))
                       && (var t#1 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                            StartFuel_MutableMapModel._default.UpdateByIter, 
                            Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                            it#1, 
                            $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.Some($Box(Lit(loc#0)))), 
                                IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType), 
                                IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)))); 
                        IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                           && 
                          IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                           && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                           && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                           && IndirectionTableModel.__default.FromHashMap#canCall(t#1, 
                            Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))), 
                            LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
                            Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))))))
         && IndirectionTableModel.__default.AddLocIfPresent($LS($ly), Lit(self#0), LitInt(ref#0), Lit(loc#0))
           == (var it#1 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.FindSimpleIter, 
                Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                LitInt(ref#0)); 
            (var oldEntry#1 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  it#1); 
              (var added#2 := MutableMapModel.IteratorOutput.Next_q(oldEntry#1)
                     && Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)); 
                (if added#2
                   then (var t#1 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.UpdateByIter, 
                        Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                        it#1, 
                        $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.Some($Box(Lit(loc#0)))), 
                            IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType), 
                            IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)))); 
                    (var _v0#1 := (if Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))
                           then 0
                           else 0); 
                      #_System._tuple#2._#Make2($Box(IndirectionTableModel.__default.FromHashMap(t#1, 
                            Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))), 
                            LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
                            Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))), 
                        $Box(Lit(true)))))
                   else #_System._tuple#2._#Make2($Box(Lit(self#0)), $Box(Lit(false))))))));

// function declaration for IndirectionTableModel._default.SeqCountSet
function IndirectionTableModel.__default.SeqCountSet(s#0: Seq Box, ref#0: int, lb#0: int) : Set Box;

function IndirectionTableModel.__default.SeqCountSet#canCall(s#0: Seq Box, ref#0: int, lb#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.SeqCountSet
axiom true
   ==> (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
    { IndirectionTableModel.__default.SeqCountSet(s#0, ref#0, lb#0) } 
    IndirectionTableModel.__default.SeqCountSet#canCall(s#0, ref#0, lb#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          LitInt(0) <= lb#0
           && lb#0 <= Seq#Length(s#0))
       ==> $Is(IndirectionTableModel.__default.SeqCountSet(s#0, ref#0, lb#0), TSet(TInt)));

function IndirectionTableModel.__default.SeqCountSet#requires(Seq Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.SeqCountSet
axiom (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
  { IndirectionTableModel.__default.SeqCountSet#requires(s#0, ref#0, lb#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.SeqCountSet#requires(s#0, ref#0, lb#0)
       == (LitInt(0) <= lb#0 && lb#0 <= Seq#Length(s#0)));

// definition axiom for IndirectionTableModel.__default.SeqCountSet(revealed)
axiom true
   ==> (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
    { IndirectionTableModel.__default.SeqCountSet(s#0, ref#0, lb#0) } 
    IndirectionTableModel.__default.SeqCountSet#canCall(s#0, ref#0, lb#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          LitInt(0) <= lb#0
           && lb#0 <= Seq#Length(s#0))
       ==> IndirectionTableModel.__default.SeqCountSet(s#0, ref#0, lb#0)
         == (lambda $y#0: Box :: 
          $IsBox($y#0, TInt)
             && 
            lb#0 <= $Unbox($y#0): int
             && $Unbox($y#0): int < Seq#Length(s#0)
             && $Unbox(Seq#Index(s#0, $Unbox($y#0): int)): int == ref#0));

// definition axiom for IndirectionTableModel.__default.SeqCountSet for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.SeqCountSet(Lit(s#0), LitInt(ref#0), LitInt(lb#0)) } 
    IndirectionTableModel.__default.SeqCountSet#canCall(Lit(s#0), LitInt(ref#0), LitInt(lb#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(lb#0)
           && LitInt(lb#0) <= Seq#Length(Lit(s#0)))
       ==> IndirectionTableModel.__default.SeqCountSet(Lit(s#0), LitInt(ref#0), LitInt(lb#0))
         == (lambda $y#1: Box :: 
          $IsBox($y#1, TInt)
             && 
            LitInt(lb#0) <= $Unbox($y#1): int
             && $Unbox($y#1): int < Seq#Length(Lit(s#0))
             && $Unbox(Seq#Index(Lit(s#0), $Unbox($y#1): int)): int == LitInt(ref#0)));

// function declaration for IndirectionTableModel._default.SeqCount
function IndirectionTableModel.__default.SeqCount(s#0: Seq Box, ref#0: int, lb#0: int) : int;

function IndirectionTableModel.__default.SeqCount#canCall(s#0: Seq Box, ref#0: int, lb#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.SeqCount
axiom true
   ==> (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
    { IndirectionTableModel.__default.SeqCount(s#0, ref#0, lb#0) } 
    IndirectionTableModel.__default.SeqCount#canCall(s#0, ref#0, lb#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          LitInt(0) <= lb#0
           && lb#0 <= Seq#Length(s#0))
       ==> true);

function IndirectionTableModel.__default.SeqCount#requires(Seq Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.SeqCount
axiom (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
  { IndirectionTableModel.__default.SeqCount#requires(s#0, ref#0, lb#0) } 
  $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.SeqCount#requires(s#0, ref#0, lb#0)
       == (LitInt(0) <= lb#0 && lb#0 <= Seq#Length(s#0)));

// definition axiom for IndirectionTableModel.__default.SeqCount(revealed)
axiom true
   ==> (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
    { IndirectionTableModel.__default.SeqCount(s#0, ref#0, lb#0) } 
    IndirectionTableModel.__default.SeqCount#canCall(s#0, ref#0, lb#0)
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          LitInt(0) <= lb#0
           && lb#0 <= Seq#Length(s#0))
       ==> IndirectionTableModel.__default.SeqCountSet#canCall(s#0, ref#0, lb#0)
         && IndirectionTableModel.__default.SeqCount(s#0, ref#0, lb#0)
           == Set#Card(IndirectionTableModel.__default.SeqCountSet(s#0, ref#0, lb#0)));

// definition axiom for IndirectionTableModel.__default.SeqCount for all literals(revealed)
axiom true
   ==> (forall s#0: Seq Box, ref#0: int, lb#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.SeqCount(Lit(s#0), LitInt(ref#0), LitInt(lb#0)) } 
    IndirectionTableModel.__default.SeqCount#canCall(Lit(s#0), LitInt(ref#0), LitInt(lb#0))
         || (
          $Is(s#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(lb#0)
           && LitInt(lb#0) <= Seq#Length(Lit(s#0)))
       ==> IndirectionTableModel.__default.SeqCountSet#canCall(Lit(s#0), LitInt(ref#0), LitInt(lb#0))
         && IndirectionTableModel.__default.SeqCount(Lit(s#0), LitInt(ref#0), LitInt(lb#0))
           == Set#Card(Lit(IndirectionTableModel.__default.SeqCountSet(Lit(s#0), LitInt(ref#0), LitInt(lb#0)))));

// function declaration for IndirectionTableModel._default.PredecessorSetExcept
function IndirectionTableModel.__default.PredecessorSetExcept(graph#0: Map Box Box, dest#0: int, except#0: int) : Set Box;

function IndirectionTableModel.__default.PredecessorSetExcept#canCall(graph#0: Map Box Box, dest#0: int, except#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.PredecessorSetExcept
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, except#0: int :: 
    { IndirectionTableModel.__default.PredecessorSetExcept(graph#0, dest#0, except#0) } 
    IndirectionTableModel.__default.PredecessorSetExcept#canCall(graph#0, dest#0, except#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && 
          LitInt(0) <= except#0
           && except#0 < 18446744073709551616)
       ==> $Is(IndirectionTableModel.__default.PredecessorSetExcept(graph#0, dest#0, except#0), 
        TSet(Tclass.IndirectionTableModel.PredecessorEdge())));

function IndirectionTableModel.__default.PredecessorSetExcept#requires(Map Box Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.PredecessorSetExcept
axiom (forall graph#0: Map Box Box, dest#0: int, except#0: int :: 
  { IndirectionTableModel.__default.PredecessorSetExcept#requires(graph#0, dest#0, except#0) } 
  $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && 
      LitInt(0) <= dest#0
       && dest#0 < 18446744073709551616
       && 
      LitInt(0) <= except#0
       && except#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.PredecessorSetExcept#requires(graph#0, dest#0, except#0)
       == true);

// definition axiom for IndirectionTableModel.__default.PredecessorSetExcept(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, except#0: int :: 
    { IndirectionTableModel.__default.PredecessorSetExcept(graph#0, dest#0, except#0) } 
    IndirectionTableModel.__default.PredecessorSetExcept#canCall(graph#0, dest#0, except#0)
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && 
          LitInt(0) <= except#0
           && except#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.PredecessorSetExcept(graph#0, dest#0, except#0)
         == (lambda $y#0: Box :: 
          (exists src#0: int, idx#0: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int } 
            LitInt(0) <= src#0
               && src#0 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#0)]
               && 
              LitInt(0) <= idx#0
               && idx#0 < Seq#Length($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#0)]): Seq Box, idx#0)): int
                 == dest#0
               && src#0 != except#0
               && $y#0
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#0, idx#0)))));

// definition axiom for IndirectionTableModel.__default.PredecessorSetExcept for all literals(revealed)
axiom true
   ==> (forall graph#0: Map Box Box, dest#0: int, except#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredecessorSetExcept(Lit(graph#0), LitInt(dest#0), LitInt(except#0)) } 
    IndirectionTableModel.__default.PredecessorSetExcept#canCall(Lit(graph#0), LitInt(dest#0), LitInt(except#0))
         || (
          $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && 
          LitInt(0) <= dest#0
           && dest#0 < 18446744073709551616
           && 
          LitInt(0) <= except#0
           && except#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.PredecessorSetExcept(Lit(graph#0), LitInt(dest#0), LitInt(except#0))
         == (lambda $y#1: Box :: 
          (exists src#1: int, idx#1: int :: 
            { #IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1) } 
              { $Unbox(Seq#Index($Unbox(Map#Elements(graph#0)[$Box(src#1)]): Seq Box, idx#1)): int } 
            LitInt(0) <= src#1
               && src#1 < 18446744073709551616
               && 
              Map#Domain(graph#0)[$Box(src#1)]
               && 
              LitInt(0) <= idx#1
               && idx#1 < Seq#Length($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box)
               && $Unbox(Seq#Index($Unbox(Map#Elements(Lit(graph#0))[$Box(src#1)]): Seq Box, idx#1)): int
                 == LitInt(dest#0)
               && src#1 != except#0
               && $y#1
                 == $Box(#IndirectionTableModel.PredecessorEdge.PredecessorEdge(src#1, idx#1)))));

// function declaration for IndirectionTableModel._default.ValidPredCountsIntermediate
function IndirectionTableModel.__default.ValidPredCountsIntermediate(predCounts#0: Map Box Box, 
    graph#0: Map Box Box, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int)
   : bool;

function IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(predCounts#0: Map Box Box, 
    graph#0: Map Box Box, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int)
   : bool;

// consequence axiom for IndirectionTableModel.__default.ValidPredCountsIntermediate
axiom true
   ==> (forall predCounts#0: Map Box Box, 
      graph#0: Map Box Box, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    { IndirectionTableModel.__default.ValidPredCountsIntermediate(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
    IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
         || (
          $Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= newIdx#0
           && newIdx#0 <= Seq#Length(newSuccs#0)
           && 
          LitInt(0) <= oldIdx#0
           && oldIdx#0 <= Seq#Length(oldSuccs#0))
       ==> true);

function IndirectionTableModel.__default.ValidPredCountsIntermediate#requires(Map Box Box, Map Box Box, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.ValidPredCountsIntermediate
axiom (forall predCounts#0: Map Box Box, 
    graph#0: Map Box Box, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int :: 
  { IndirectionTableModel.__default.ValidPredCountsIntermediate#requires(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
  $Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
       && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
       && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> IndirectionTableModel.__default.ValidPredCountsIntermediate#requires(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
       == (
        LitInt(0) <= newIdx#0
         && newIdx#0 <= Seq#Length(newSuccs#0)
         && 
        LitInt(0) <= oldIdx#0
         && oldIdx#0 <= Seq#Length(oldSuccs#0)));

// definition axiom for IndirectionTableModel.__default.ValidPredCountsIntermediate(revealed)
axiom true
   ==> (forall predCounts#0: Map Box Box, 
      graph#0: Map Box Box, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    { IndirectionTableModel.__default.ValidPredCountsIntermediate(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
    IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
         || (
          $Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= newIdx#0
           && newIdx#0 <= Seq#Length(newSuccs#0)
           && 
          LitInt(0) <= oldIdx#0
           && oldIdx#0 <= Seq#Length(oldSuccs#0))
       ==> (forall ref#0: int :: 
          { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#0, oldIdx#0) } 
            { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#0, newIdx#0) } 
            { IndirectionTableModel.__default.IsRoot(ref#0) } 
            { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#0) } 
            { $Unbox(Map#Elements(predCounts#0)[$Box(ref#0)]): int } 
            { Map#Domain(predCounts#0)[$Box(ref#0)] } 
          LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
             ==> 
            Map#Domain(predCounts#0)[$Box(ref#0)]
             ==> IndirectionTableModel.__default.PredecessorSet#canCall(graph#0, ref#0)
               && IndirectionTableModel.__default.IsRoot#canCall(ref#0)
               && IndirectionTableModel.__default.SeqCount#canCall(newSuccs#0, ref#0, newIdx#0)
               && IndirectionTableModel.__default.SeqCount#canCall(oldSuccs#0, ref#0, oldIdx#0))
         && IndirectionTableModel.__default.ValidPredCountsIntermediate(predCounts#0, graph#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
           == (forall ref#0: int :: 
            { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#0, oldIdx#0) } 
              { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#0, newIdx#0) } 
              { IndirectionTableModel.__default.IsRoot(ref#0) } 
              { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#0) } 
              { $Unbox(Map#Elements(predCounts#0)[$Box(ref#0)]): int } 
              { Map#Domain(predCounts#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(predCounts#0)[$Box(ref#0)]
               ==> $Unbox(Map#Elements(predCounts#0)[$Box(ref#0)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(graph#0, ref#0))
                       + IndirectionTableModel.__default.IsRoot(ref#0)
                     - IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#0, newIdx#0)
                   + IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#0, oldIdx#0)));

// definition axiom for IndirectionTableModel.__default.ValidPredCountsIntermediate for all literals(revealed)
axiom true
   ==> (forall predCounts#0: Map Box Box, 
      graph#0: Map Box Box, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.ValidPredCountsIntermediate(Lit(predCounts#0), 
        Lit(graph#0), 
        Lit(newSuccs#0), 
        Lit(oldSuccs#0), 
        LitInt(newIdx#0), 
        LitInt(oldIdx#0)) } 
    IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(Lit(predCounts#0), 
          Lit(graph#0), 
          Lit(newSuccs#0), 
          Lit(oldSuccs#0), 
          LitInt(newIdx#0), 
          LitInt(oldIdx#0))
         || (
          $Is(predCounts#0, TMap(Tclass.NativeTypes.uint64(), TInt))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= LitInt(newIdx#0)
           && LitInt(newIdx#0) <= Seq#Length(Lit(newSuccs#0))
           && 
          LitInt(0) <= LitInt(oldIdx#0)
           && LitInt(oldIdx#0) <= Seq#Length(Lit(oldSuccs#0)))
       ==> (forall ref#1: int :: 
          { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#1, oldIdx#0) } 
            { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#1, newIdx#0) } 
            { IndirectionTableModel.__default.IsRoot(ref#1) } 
            { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#1) } 
            { $Unbox(Map#Elements(predCounts#0)[$Box(ref#1)]): int } 
            { Map#Domain(predCounts#0)[$Box(ref#1)] } 
          LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
             ==> 
            Map#Domain(predCounts#0)[$Box(ref#1)]
             ==> IndirectionTableModel.__default.PredecessorSet#canCall(Lit(graph#0), ref#1)
               && IndirectionTableModel.__default.IsRoot#canCall(ref#1)
               && IndirectionTableModel.__default.SeqCount#canCall(Lit(newSuccs#0), ref#1, LitInt(newIdx#0))
               && IndirectionTableModel.__default.SeqCount#canCall(Lit(oldSuccs#0), ref#1, LitInt(oldIdx#0)))
         && IndirectionTableModel.__default.ValidPredCountsIntermediate(Lit(predCounts#0), 
            Lit(graph#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            LitInt(newIdx#0), 
            LitInt(oldIdx#0))
           == (forall ref#1: int :: 
            { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#1, oldIdx#0) } 
              { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#1, newIdx#0) } 
              { IndirectionTableModel.__default.IsRoot(ref#1) } 
              { IndirectionTableModel.__default.PredecessorSet(graph#0, ref#1) } 
              { $Unbox(Map#Elements(predCounts#0)[$Box(ref#1)]): int } 
              { Map#Domain(predCounts#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(predCounts#0)[$Box(ref#1)]
               ==> $Unbox(Map#Elements(Lit(predCounts#0))[$Box(ref#1)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(Lit(graph#0), ref#1))
                       + IndirectionTableModel.__default.IsRoot(ref#1)
                     - IndirectionTableModel.__default.SeqCount(Lit(newSuccs#0), ref#1, LitInt(newIdx#0))
                   + IndirectionTableModel.__default.SeqCount(Lit(oldSuccs#0), ref#1, LitInt(oldIdx#0))));

// function declaration for IndirectionTableModel._default.RefcountUpdateInv
function IndirectionTableModel.__default.RefcountUpdateInv($ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int)
   : bool;

function IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int :: 
  { IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
  IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
     == IndirectionTableModel.__default.RefcountUpdateInv($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int :: 
  { IndirectionTableModel.__default.RefcountUpdateInv(AsFuelBottom($ly), 
      t#0, 
      q#0, 
      changingRef#0, 
      newSuccs#0, 
      oldSuccs#0, 
      newIdx#0, 
      oldIdx#0) } 
  IndirectionTableModel.__default.RefcountUpdateInv($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
     == IndirectionTableModel.__default.RefcountUpdateInv($LZ, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0));

// consequence axiom for IndirectionTableModel.__default.RefcountUpdateInv
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    { IndirectionTableModel.__default.RefcountUpdateInv($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
    IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> true);

function IndirectionTableModel.__default.RefcountUpdateInv#requires(LayerType, DatatypeType, Seq Box, int, Seq Box, Seq Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.RefcountUpdateInv
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    newIdx#0: int, 
    oldIdx#0: int :: 
  { IndirectionTableModel.__default.RefcountUpdateInv#requires($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= changingRef#0
       && changingRef#0 < 18446744073709551616
       && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> IndirectionTableModel.__default.RefcountUpdateInv#requires($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
       == true);

// definition axiom for IndirectionTableModel.__default.RefcountUpdateInv(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    { IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0) } 
    IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), t#0)
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           ==> LruModel.__default.WF#canCall(q#0))
         && (LruModel.__default.WF#canCall(q#0) && LruModel.__default.WF(q#0)
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
             && IndirectionTableModel.__default.MaxSize#canCall())
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
             && IndirectionTableModel.__default.MaxSize#canCall()
             && MutableMapModel.LinearHashMap.count(t#0)
               <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> Bounds.__default.MaxNumChildren#canCall())
         && (Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           ==> Bounds.__default.MaxNumChildren#canCall())
         && (Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           ==> (forall ref#0: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> IndirectionTableModel.__default.Graph#canCall(t#0)
                 && (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]
                   ==> IndirectionTableModel.__default.Graph#canCall(t#0)
                     && Bounds.__default.MaxNumChildren#canCall())))
         && (LitInt(0) <= oldIdx#0 && oldIdx#0 <= Seq#Length(oldSuccs#0)
           ==> IndirectionTableModel.__default.Graph#canCall(t#0)
             && (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
               ==> IndirectionTableModel.__default.Graph#canCall(t#0)))
         && (IndirectionTableModel.__default.Graph#canCall(t#0)
             && (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
               ==> IndirectionTableModel.__default.Graph#canCall(t#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
               ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]): Seq Box, 
                newSuccs#0))
           ==> IndirectionTableModel.__default.Graph#canCall(t#0))
         && (IndirectionTableModel.__default.Graph#canCall(t#0)
             && (!Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
               ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
           ==> IndirectionTableModel.__default.PredCounts#canCall(t#0)
             && IndirectionTableModel.__default.Graph#canCall(t#0)
             && IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(t#0), 
              IndirectionTableModel.__default.Graph(t#0), 
              newSuccs#0, 
              oldSuccs#0, 
              newIdx#0, 
              oldIdx#0))
         && (IndirectionTableModel.__default.PredCounts#canCall(t#0)
             && IndirectionTableModel.__default.Graph#canCall(t#0)
             && IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(t#0), 
              IndirectionTableModel.__default.Graph(t#0), 
              newSuccs#0, 
              oldSuccs#0, 
              newIdx#0, 
              oldIdx#0)
             && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t#0), 
              IndirectionTableModel.__default.Graph(t#0), 
              newSuccs#0, 
              oldSuccs#0, 
              newIdx#0, 
              oldIdx#0)
           ==> (forall j#0: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#0)): int } 
            LitInt(0) <= j#0 && j#0 < Seq#Length(oldSuccs#0)
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)))
         && ((forall j#0: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#0)): int } 
              LitInt(0) <= j#0 && j#0 < Seq#Length(oldSuccs#0)
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0))
             && (forall j#0: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#0)): int } 
              LitInt(0) <= j#0 && j#0 < Seq#Length(oldSuccs#0)
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, j#0)])
           ==> IndirectionTableModel.__default.Graph#canCall(t#0)
             && BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(t#0)))
         && (IndirectionTableModel.__default.Graph#canCall(t#0)
             && BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(t#0))
             && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t#0))
           ==> (forall ref#1: int :: 
            { LruModel.__default.I(q#0)[$Box(ref#1)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I#canCall(q#0))))
         && ((forall ref#1: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#1)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I#canCall(q#0)))
             && (forall ref#1: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#1)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                     == LitInt(0)
                 ==> LruModel.__default.I(q#0)[$Box(ref#1)])
           ==> (forall ref#2: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
              { LruModel.__default.I(q#0)[$Box(ref#2)] } 
            LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
               ==> LruModel.__default.I#canCall(q#0)
                 && (LruModel.__default.I(q#0)[$Box(ref#2)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                         && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)))))
         && ((forall ref#2: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
                { LruModel.__default.I(q#0)[$Box(ref#2)] } 
              LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                 ==> LruModel.__default.I#canCall(q#0)
                   && (LruModel.__default.I(q#0)[$Box(ref#2)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
                         ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                           && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType))))
             && (forall ref#2: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
                { LruModel.__default.I(q#0)[$Box(ref#2)] } 
              LitInt(0) <= ref#2
                   && ref#2 < 18446744073709551616
                   && LruModel.__default.I(q#0)[$Box(ref#2)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)
                     == LitInt(0))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && MutableMapModel.LinearHashMap.LinearHashMap_q(t#0))
         && IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, newIdx#0, oldIdx#0)
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
             && LruModel.__default.WF(q#0)
             && MutableMapModel.LinearHashMap.count(t#0)
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
             && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
             && (forall ref#0: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]
                 ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && 
            LitInt(0) <= newIdx#0
             && newIdx#0 <= Seq#Length(newSuccs#0)
             && 
            LitInt(0) <= oldIdx#0
             && oldIdx#0 <= Seq#Length(oldSuccs#0)
             && (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
               ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]): Seq Box, 
                newSuccs#0))
             && (!Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
               ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t#0), 
              IndirectionTableModel.__default.Graph(t#0), 
              newSuccs#0, 
              oldSuccs#0, 
              newIdx#0, 
              oldIdx#0)
             && (forall j#0: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#0)): int } 
              LitInt(0) <= j#0 && j#0 < Seq#Length(oldSuccs#0)
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, j#0)])
             && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t#0))
             && (forall ref#1: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#1)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                     == LitInt(0)
                 ==> LruModel.__default.I(q#0)[$Box(ref#1)])
             && (forall ref#2: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
                { LruModel.__default.I(q#0)[$Box(ref#2)] } 
              LitInt(0) <= ref#2
                   && ref#2 < 18446744073709551616
                   && LruModel.__default.I(q#0)[$Box(ref#2)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)
                     == LitInt(0))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())]));

// definition axiom for IndirectionTableModel.__default.RefcountUpdateInv for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), 
        Lit(t#0), 
        q#0, 
        LitInt(changingRef#0), 
        Lit(newSuccs#0), 
        Lit(oldSuccs#0), 
        LitInt(newIdx#0), 
        LitInt(oldIdx#0)) } 
    IndirectionTableModel.__default.RefcountUpdateInv#canCall(Lit(t#0), 
          q#0, 
          LitInt(changingRef#0), 
          Lit(newSuccs#0), 
          Lit(oldSuccs#0), 
          LitInt(newIdx#0), 
          LitInt(oldIdx#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           ==> LruModel.__default.WF#canCall(q#0))
         && (LruModel.__default.WF#canCall(q#0) && LruModel.__default.WF(q#0)
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && IndirectionTableModel.__default.MaxSize#canCall())
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && IndirectionTableModel.__default.MaxSize#canCall()
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> Bounds.__default.MaxNumChildren#canCall())
         && (Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(Lit(oldSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           ==> Bounds.__default.MaxNumChildren#canCall())
         && (Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(Lit(newSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           ==> (forall ref#3: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#3)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#3)] } 
            LitInt(0) <= ref#3 && ref#3 < 18446744073709551616
               ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
                 && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(ref#3)]
                   ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
                     && Bounds.__default.MaxNumChildren#canCall())))
         && (LitInt(0) <= LitInt(oldIdx#0) && LitInt(oldIdx#0) <= Seq#Length(Lit(oldSuccs#0))
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0)))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal($Unbox(Map#Elements(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))[$Box(LitInt(changingRef#0))]): Seq Box, 
                newSuccs#0))
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0)))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && (!Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
           ==> IndirectionTableModel.__default.PredCounts#canCall(Lit(t#0))
             && IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(newIdx#0), 
              LitInt(oldIdx#0)))
         && (IndirectionTableModel.__default.PredCounts#canCall(Lit(t#0))
             && IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(newIdx#0), 
              LitInt(oldIdx#0))
             && Lit(IndirectionTableModel.__default.ValidPredCountsIntermediate(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
                Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
                Lit(newSuccs#0), 
                Lit(oldSuccs#0), 
                LitInt(newIdx#0), 
                LitInt(oldIdx#0)))
           ==> (forall j#1: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
            LitInt(0) <= j#1 && j#1 < Seq#Length(Lit(oldSuccs#0))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))))
         && ((forall j#1: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
              LitInt(0) <= j#1 && j#1 < Seq#Length(Lit(oldSuccs#0))
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0)))
             && (forall j#1: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
              LitInt(0) <= j#1 && j#1 < Seq#Length(Lit(oldSuccs#0))
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[Seq#Index(Lit(oldSuccs#0), j#1)])
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(t#0)))))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))
             && Lit(BlockCache.__default.GraphClosed(Lit(IndirectionTableModel.__default.Graph(Lit(t#0)))))
           ==> (forall ref#4: int :: 
            { LruModel.__default.I(q#0)[$Box(ref#4)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
            LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I#canCall(q#0))))
         && ((forall ref#4: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#4)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I#canCall(q#0)))
             && (forall ref#4: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#4)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType)
                     == LitInt(0)
                 ==> LruModel.__default.I(q#0)[$Box(ref#4)])
           ==> (forall ref#5: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
              { LruModel.__default.I(q#0)[$Box(ref#5)] } 
            LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
               ==> LruModel.__default.I#canCall(q#0)
                 && (LruModel.__default.I(q#0)[$Box(ref#5)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#5)]
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                         && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#5)]): DatatypeType)))))
         && ((forall ref#5: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
                { LruModel.__default.I(q#0)[$Box(ref#5)] } 
              LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                 ==> LruModel.__default.I#canCall(q#0)
                   && (LruModel.__default.I(q#0)[$Box(ref#5)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#5)]
                         ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                           && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#5)]): DatatypeType))))
             && (forall ref#5: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
                { LruModel.__default.I(q#0)[$Box(ref#5)] } 
              LitInt(0) <= ref#5
                   && ref#5 < 18446744073709551616
                   && LruModel.__default.I(q#0)[$Box(ref#5)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#5)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#5)]): DatatypeType)
                     == LitInt(0))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0)))
         && IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), 
            Lit(t#0), 
            q#0, 
            LitInt(changingRef#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            LitInt(newIdx#0), 
            LitInt(oldIdx#0))
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
             && LruModel.__default.WF(q#0)
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             && Seq#Length(Lit(oldSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
             && Seq#Length(Lit(newSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
             && (forall ref#3: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#3)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(ref#3)]
                 ==> Seq#Length($Unbox(Map#Elements(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))[$Box(ref#3)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && 
            LitInt(0) <= LitInt(newIdx#0)
             && LitInt(newIdx#0) <= Seq#Length(Lit(newSuccs#0))
             && 
            LitInt(0) <= LitInt(oldIdx#0)
             && LitInt(oldIdx#0) <= Seq#Length(Lit(oldSuccs#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal($Unbox(Map#Elements(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))[$Box(LitInt(changingRef#0))]): Seq Box, 
                newSuccs#0))
             && (!Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(newIdx#0), 
              LitInt(oldIdx#0))
             && (forall j#1: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
              LitInt(0) <= j#1 && j#1 < Seq#Length(Lit(oldSuccs#0))
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[Seq#Index(Lit(oldSuccs#0), j#1)])
             && BlockCache.__default.GraphClosed(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))
             && (forall ref#4: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#4)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType)
                     == LitInt(0)
                 ==> LruModel.__default.I(q#0)[$Box(ref#4)])
             && (forall ref#5: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
                { LruModel.__default.I(q#0)[$Box(ref#5)] } 
              LitInt(0) <= ref#5
                   && ref#5 < 18446744073709551616
                   && LruModel.__default.I(q#0)[$Box(ref#5)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#5)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#5)]): DatatypeType)
                     == LitInt(0))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(PivotBetreeGraph.__default.Root())]));

// definition axiom for IndirectionTableModel.__default.RefcountUpdateInv for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      newIdx#0: int, 
      oldIdx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), 
        Lit(t#0), 
        Lit(q#0), 
        LitInt(changingRef#0), 
        Lit(newSuccs#0), 
        Lit(oldSuccs#0), 
        LitInt(newIdx#0), 
        LitInt(oldIdx#0)) } 
    IndirectionTableModel.__default.RefcountUpdateInv#canCall(Lit(t#0), 
          Lit(q#0), 
          LitInt(changingRef#0), 
          Lit(newSuccs#0), 
          Lit(oldSuccs#0), 
          LitInt(newIdx#0), 
          LitInt(oldIdx#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64())))
       ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           ==> LruModel.__default.WF#canCall(Lit(q#0)))
         && (LruModel.__default.WF#canCall(Lit(q#0)) && Lit(LruModel.__default.WF(Lit(q#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && IndirectionTableModel.__default.MaxSize#canCall())
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && IndirectionTableModel.__default.MaxSize#canCall()
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> Bounds.__default.MaxNumChildren#canCall())
         && (Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(Lit(oldSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           ==> Bounds.__default.MaxNumChildren#canCall())
         && (Bounds.__default.MaxNumChildren#canCall()
             && Seq#Length(Lit(newSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           ==> (forall ref#6: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#6)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#6)] } 
            LitInt(0) <= ref#6 && ref#6 < 18446744073709551616
               ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
                 && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(ref#6)]
                   ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
                     && Bounds.__default.MaxNumChildren#canCall())))
         && (LitInt(0) <= LitInt(oldIdx#0) && LitInt(oldIdx#0) <= Seq#Length(Lit(oldSuccs#0))
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0)))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal($Unbox(Map#Elements(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))[$Box(LitInt(changingRef#0))]): Seq Box, 
                newSuccs#0))
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0)))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && (!Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
           ==> IndirectionTableModel.__default.PredCounts#canCall(Lit(t#0))
             && IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(newIdx#0), 
              LitInt(oldIdx#0)))
         && (IndirectionTableModel.__default.PredCounts#canCall(Lit(t#0))
             && IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(newIdx#0), 
              LitInt(oldIdx#0))
             && Lit(IndirectionTableModel.__default.ValidPredCountsIntermediate(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
                Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
                Lit(newSuccs#0), 
                Lit(oldSuccs#0), 
                LitInt(newIdx#0), 
                LitInt(oldIdx#0)))
           ==> (forall j#2: int :: 
            { $Unbox(Seq#Index(oldSuccs#0, j#2)): int } 
            LitInt(0) <= j#2 && j#2 < Seq#Length(Lit(oldSuccs#0))
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))))
         && ((forall j#2: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#2)): int } 
              LitInt(0) <= j#2 && j#2 < Seq#Length(Lit(oldSuccs#0))
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0)))
             && (forall j#2: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#2)): int } 
              LitInt(0) <= j#2 && j#2 < Seq#Length(Lit(oldSuccs#0))
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[Seq#Index(Lit(oldSuccs#0), j#2)])
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(t#0)))))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(t#0))
             && BlockCache.__default.GraphClosed#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))
             && Lit(BlockCache.__default.GraphClosed(Lit(IndirectionTableModel.__default.Graph(Lit(t#0)))))
           ==> (forall ref#7: int :: 
            { LruModel.__default.I(q#0)[$Box(ref#7)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
            LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#7)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#7)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I#canCall(Lit(q#0)))))
         && ((forall ref#7: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#7)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#7)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#7)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I#canCall(Lit(q#0))))
             && (forall ref#7: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#7)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#7)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType)
                     == LitInt(0)
                 ==> Lit(LruModel.__default.I(Lit(q#0)))[$Box(ref#7)])
           ==> (forall ref#8: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)] } 
              { LruModel.__default.I(q#0)[$Box(ref#8)] } 
            LitInt(0) <= ref#8 && ref#8 < 18446744073709551616
               ==> LruModel.__default.I#canCall(Lit(q#0))
                 && (Lit(LruModel.__default.I(Lit(q#0)))[$Box(ref#8)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#8)]
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                         && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType)))))
         && ((forall ref#8: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)] } 
                { LruModel.__default.I(q#0)[$Box(ref#8)] } 
              LitInt(0) <= ref#8 && ref#8 < 18446744073709551616
                 ==> LruModel.__default.I#canCall(Lit(q#0))
                   && (Lit(LruModel.__default.I(Lit(q#0)))[$Box(ref#8)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#8)]
                         ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                           && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType))))
             && (forall ref#8: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)] } 
                { LruModel.__default.I(q#0)[$Box(ref#8)] } 
              LitInt(0) <= ref#8
                   && ref#8 < 18446744073709551616
                   && Lit(LruModel.__default.I(Lit(q#0)))[$Box(ref#8)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#8)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType)
                     == LitInt(0))
           ==> PivotBetreeGraph.__default.Root#canCall()
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0)))
         && IndirectionTableModel.__default.RefcountUpdateInv($LS($ly), 
            Lit(t#0), 
            Lit(q#0), 
            LitInt(changingRef#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            LitInt(newIdx#0), 
            LitInt(oldIdx#0))
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
             && LruModel.__default.WF(Lit(q#0))
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             && Seq#Length(Lit(oldSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
             && Seq#Length(Lit(newSuccs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
             && (forall ref#6: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#6)]): Seq Box } 
                { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#6)] } 
              LitInt(0) <= ref#6
                   && ref#6 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(ref#6)]
                 ==> Seq#Length($Unbox(Map#Elements(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))[$Box(ref#6)]): Seq Box)
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && 
            LitInt(0) <= LitInt(newIdx#0)
             && LitInt(newIdx#0) <= Seq#Length(Lit(newSuccs#0))
             && 
            LitInt(0) <= LitInt(oldIdx#0)
             && LitInt(oldIdx#0) <= Seq#Length(Lit(oldSuccs#0))
             && (Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal($Unbox(Map#Elements(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))[$Box(LitInt(changingRef#0))]): Seq Box, 
                newSuccs#0))
             && (!Map#Domain(IndirectionTableModel.__default.Graph(Lit(t#0)))[$Box(changingRef#0)]
               ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
             && IndirectionTableModel.__default.ValidPredCountsIntermediate(Lit(IndirectionTableModel.__default.PredCounts(Lit(t#0))), 
              Lit(IndirectionTableModel.__default.Graph(Lit(t#0))), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(newIdx#0), 
              LitInt(oldIdx#0))
             && (forall j#2: int :: 
              { $Unbox(Seq#Index(oldSuccs#0, j#2)): int } 
              LitInt(0) <= j#2 && j#2 < Seq#Length(Lit(oldSuccs#0))
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[Seq#Index(Lit(oldSuccs#0), j#2)])
             && BlockCache.__default.GraphClosed(Lit(IndirectionTableModel.__default.Graph(Lit(t#0))))
             && (forall ref#7: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#7)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#7)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType)
                     == LitInt(0)
                 ==> Lit(LruModel.__default.I(Lit(q#0)))[$Box(ref#7)])
             && (forall ref#8: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)] } 
                { LruModel.__default.I(q#0)[$Box(ref#8)] } 
              LitInt(0) <= ref#8
                   && ref#8 < 18446744073709551616
                   && Lit(LruModel.__default.I(Lit(q#0)))[$Box(ref#8)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#8)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType)
                     == LitInt(0))
             && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(PivotBetreeGraph.__default.Root())]));

procedure CheckWellformed$$IndirectionTableModel.__default.LemmaUpdatePredCountsDecStuff(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    q#0: Seq Box
       where $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    idx#0: int);
  free requires 46 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.LemmaUpdatePredCountsDecStuff(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    q#0: Seq Box
       where $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    idx#0: int);
  // user-defined preconditions
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (LruModel.__default.WF#canCall(q#0)
         ==> LruModel.__default.WF(q#0)
           || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, q#0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || MutableMapModel.LinearHashMap.count(t#0)
         <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (forall ref#0: int :: 
        { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box } 
          { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)] } 
        LitInt(0) <= ref#0
             && ref#0 < 18446744073709551616
             && Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]
           ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box)
             <= LitInt(Bounds.__default.MaxNumChildren()));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || LitInt(0) <= Seq#Length(newSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || Seq#Length(newSuccs#0) <= Seq#Length(newSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || LitInt(0) <= idx#0;
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || idx#0 <= Seq#Length(oldSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
         ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]): Seq Box, 
          newSuccs#0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (!Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
         ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(t#0), 
          IndirectionTableModel.__default.Graph(t#0), 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx#0)
         ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t#0), 
            IndirectionTableModel.__default.Graph(t#0), 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx#0)
           || (forall ref#1: int :: 
            { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#1, idx#0) } 
              { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#1, Seq#Length(newSuccs#0)) } 
              { IndirectionTableModel.__default.IsRoot(ref#1) } 
              { IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(t#0), ref#1) } 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)]): int } 
              { Map#Domain(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)]
               ==> $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(t#0), ref#1))
                       + IndirectionTableModel.__default.IsRoot(ref#1)
                     - IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#1, Seq#Length(newSuccs#0))
                   + IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#1, idx#0)));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (forall j#0: int :: 
        { $Unbox(Seq#Index(oldSuccs#0, j#0)): int } 
        LitInt(0) <= j#0 && j#0 < Seq#Length(oldSuccs#0)
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, j#0)]);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(t#0))
         ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t#0))
           || (forall ref#2: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)] } 
            LitInt(0) <= ref#2
                 && ref#2 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]
               ==> (forall succ#0: int :: 
                { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(succ#0)] } 
                  { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]): Seq Box, 
                    $Box(succ#0)) } 
                LitInt(0) <= succ#0
                     && succ#0 < 18446744073709551616
                     && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]): Seq Box, 
                      $Box(succ#0))
                   ==> Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(succ#0)])));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (forall ref#3: int :: 
        { LruModel.__default.I(q#0)[$Box(ref#3)] } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)] } 
        LitInt(0) <= ref#3
             && ref#3 < 18446744073709551616
             && 
            Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]
             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
               == LitInt(0)
           ==> LruModel.__default.I(q#0)[$Box(ref#3)]);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || (forall ref#4: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
          { LruModel.__default.I(q#0)[$Box(ref#4)] } 
        LitInt(0) <= ref#4
             && ref#4 < 18446744073709551616
             && LruModel.__default.I(q#0)[$Box(ref#4)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]
             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType)
               == LitInt(0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, Seq#Length(newSuccs#0), idx#0)
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0)
       || Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures idx#0 < Seq#Length(oldSuccs#0)
     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0);
  ensures idx#0 < Seq#Length(oldSuccs#0)
     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, idx#0)];
  free ensures idx#0 < Seq#Length(oldSuccs#0)
     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, idx#0)]): DatatypeType);
  ensures idx#0 < Seq#Length(oldSuccs#0)
     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, idx#0)]): DatatypeType)
       > 0;
  free ensures idx#0 < Seq#Length(oldSuccs#0)
     ==> IndirectionTableModel.__default.PredDec#canCall(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int)
       && (var t'#0, q'#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): DatatypeType, 
          $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): Seq Box; 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(t'#0, 
          q'#0, 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx#0 + 1));
  free ensures idx#0 < Seq#Length(oldSuccs#0)
     ==> (var t'#0, q'#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): DatatypeType, 
        $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): Seq Box; 
      IndirectionTableModel.__default.RefcountUpdateInv#canCall(t'#0, 
          q'#0, 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx#0 + 1)
         && 
        IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          t'#0, 
          q'#0, 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx#0 + 1)
         && 
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t'#0)
         && LruModel.__default.WF(q'#0)
         && MutableMapModel.LinearHashMap.count(t'#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize())
         && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
         && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
         && (forall ref#5: int :: 
          { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)]): Seq Box } 
            { Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)] } 
          LitInt(0) <= ref#5
               && ref#5 < 18446744073709551616
               && Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)]
             ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)]): Seq Box)
               <= LitInt(Bounds.__default.MaxNumChildren()))
         && 
        LitInt(0) <= Seq#Length(newSuccs#0)
         && Seq#Length(newSuccs#0) <= Seq#Length(newSuccs#0)
         && 
        LitInt(0) <= idx#0 + 1
         && idx#0 + 1 <= Seq#Length(oldSuccs#0)
         && (Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(changingRef#0)]
           ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t'#0))[$Box(changingRef#0)]): Seq Box, 
            newSuccs#0))
         && (!Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(changingRef#0)]
           ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
         && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t'#0), 
          IndirectionTableModel.__default.Graph(t'#0), 
          newSuccs#0, 
          oldSuccs#0, 
          Seq#Length(newSuccs#0), 
          idx#0 + 1)
         && (forall j#1: int :: 
          { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
          LitInt(0) <= j#1 && j#1 < Seq#Length(oldSuccs#0)
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[Seq#Index(oldSuccs#0, j#1)])
         && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t'#0))
         && (forall ref#7: int :: 
          { LruModel.__default.I(q'#0)[$Box(ref#7)] } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)] } 
          LitInt(0) <= ref#7
               && ref#7 < 18446744073709551616
               && 
              Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)]): DatatypeType)
                 == LitInt(0)
             ==> LruModel.__default.I(q'#0)[$Box(ref#7)])
         && (forall ref#8: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)] } 
            { LruModel.__default.I(q'#0)[$Box(ref#8)] } 
          LitInt(0) <= ref#8
               && ref#8 < 18446744073709551616
               && LruModel.__default.I(q'#0)[$Box(ref#8)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)]): DatatypeType)
                 == LitInt(0))
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(PivotBetreeGraph.__default.Root())]);
  free ensures LruModel.__default.I#canCall(q#0);
  ensures Set#Card(LruModel.__default.I(q#0)) <= LitInt(4294967296);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$IndirectionTableModel.__default.LemmaUpdatePredCountsIncStuff(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    q#0: Seq Box
       where $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    idx#0: int);
  free requires 51 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.LemmaUpdatePredCountsIncStuff(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    q#0: Seq Box
       where $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(q#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    changingRef#0: int
       where LitInt(0) <= changingRef#0 && changingRef#0 < 18446744073709551616, 
    newSuccs#0: Seq Box
       where $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    oldSuccs#0: Seq Box
       where $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap), 
    idx#0: int);
  // user-defined preconditions
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (LruModel.__default.WF#canCall(q#0)
         ==> LruModel.__default.WF(q#0)
           || LruModel.__default.distinct(StartFuelAssert_LruModel._default.distinct, q#0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || MutableMapModel.LinearHashMap.count(t#0)
         <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (forall ref#0: int :: 
        { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box } 
          { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)] } 
        LitInt(0) <= ref#0
             && ref#0 < 18446744073709551616
             && Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]
           ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box)
             <= LitInt(Bounds.__default.MaxNumChildren()));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || LitInt(0) <= idx#0;
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || idx#0 <= Seq#Length(newSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || LitInt(0) <= LitInt(0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || LitInt(0) <= Seq#Length(oldSuccs#0);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
         ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]): Seq Box, 
          newSuccs#0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (!Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(changingRef#0)]
         ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (IndirectionTableModel.__default.ValidPredCountsIntermediate#canCall(IndirectionTableModel.__default.PredCounts(t#0), 
          IndirectionTableModel.__default.Graph(t#0), 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0, 
          LitInt(0))
         ==> IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t#0), 
            IndirectionTableModel.__default.Graph(t#0), 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0))
           || (forall ref#1: int :: 
            { IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#1, 0) } 
              { IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#1, idx#0) } 
              { IndirectionTableModel.__default.IsRoot(ref#1) } 
              { IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(t#0), ref#1) } 
              { $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)]): int } 
              { Map#Domain(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)]
               ==> $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#1)]): int
                 == Set#Card(IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(t#0), ref#1))
                       + IndirectionTableModel.__default.IsRoot(ref#1)
                     - IndirectionTableModel.__default.SeqCount(newSuccs#0, ref#1, idx#0)
                   + IndirectionTableModel.__default.SeqCount(oldSuccs#0, ref#1, LitInt(0))));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (forall j#0: int :: 
        { $Unbox(Seq#Index(oldSuccs#0, j#0)): int } 
        LitInt(0) <= j#0 && j#0 < Seq#Length(oldSuccs#0)
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(oldSuccs#0, j#0)]);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(t#0))
         ==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t#0))
           || (forall ref#2: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]): Seq Box } 
              { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)] } 
            LitInt(0) <= ref#2
                 && ref#2 < 18446744073709551616
                 && Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]
               ==> (forall succ#0: int :: 
                { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(succ#0)] } 
                  { Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]): Seq Box, 
                    $Box(succ#0)) } 
                LitInt(0) <= succ#0
                     && succ#0 < 18446744073709551616
                     && Seq#Contains($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#2)]): Seq Box, 
                      $Box(succ#0))
                   ==> Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(succ#0)])));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (forall ref#3: int :: 
        { LruModel.__default.I(q#0)[$Box(ref#3)] } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)] } 
        LitInt(0) <= ref#3
             && ref#3 < 18446744073709551616
             && 
            Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]
             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
               == LitInt(0)
           ==> LruModel.__default.I(q#0)[$Box(ref#3)]);
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || (forall ref#4: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
          { LruModel.__default.I(q#0)[$Box(ref#4)] } 
        LitInt(0) <= ref#4
             && ref#4 < 18446744073709551616
             && LruModel.__default.I(q#0)[$Box(ref#4)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]
             && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType)
               == LitInt(0));
  requires IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0, LitInt(0))
     ==> IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0))
       || Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures idx#0 < Seq#Length(newSuccs#0)
     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0);
  ensures idx#0 < Seq#Length(newSuccs#0)
     ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(newSuccs#0, idx#0)];
  free ensures idx#0 < Seq#Length(newSuccs#0)
     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(newSuccs#0, idx#0)]): DatatypeType);
  ensures idx#0 < Seq#Length(newSuccs#0)
     ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(newSuccs#0, idx#0)]): DatatypeType)
       < 18446744073709551615;
  free ensures idx#0 < Seq#Length(newSuccs#0)
     ==> IndirectionTableModel.__default.PredInc#canCall(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int)
       && (var t'#0, q'#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): DatatypeType, 
          $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): Seq Box; 
        IndirectionTableModel.__default.RefcountUpdateInv#canCall(t'#0, q'#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0 + 1, LitInt(0)));
  free ensures idx#0 < Seq#Length(newSuccs#0)
     ==> (var t'#0, q'#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): DatatypeType, 
        $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): Seq Box; 
      IndirectionTableModel.__default.RefcountUpdateInv#canCall(t'#0, q'#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0 + 1, LitInt(0))
         && 
        IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          t'#0, 
          q'#0, 
          changingRef#0, 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0 + 1, 
          LitInt(0))
         && 
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t'#0)
         && LruModel.__default.WF(q'#0)
         && MutableMapModel.LinearHashMap.count(t'#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize())
         && Seq#Length(oldSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
         && Seq#Length(newSuccs#0) <= LitInt(Bounds.__default.MaxNumChildren())
         && (forall ref#5: int :: 
          { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)]): Seq Box } 
            { Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)] } 
          LitInt(0) <= ref#5
               && ref#5 < 18446744073709551616
               && Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)]
             ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t'#0))[$Box(ref#5)]): Seq Box)
               <= LitInt(Bounds.__default.MaxNumChildren()))
         && 
        LitInt(0) <= idx#0 + 1
         && idx#0 + 1 <= Seq#Length(newSuccs#0)
         && 
        LitInt(0) <= LitInt(0)
         && LitInt(0) <= Seq#Length(oldSuccs#0)
         && (Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(changingRef#0)]
           ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t'#0))[$Box(changingRef#0)]): Seq Box, 
            newSuccs#0))
         && (!Map#Domain(IndirectionTableModel.__default.Graph(t'#0))[$Box(changingRef#0)]
           ==> Seq#Equal(newSuccs#0, Seq#Empty(): Seq Box))
         && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t'#0), 
          IndirectionTableModel.__default.Graph(t'#0), 
          newSuccs#0, 
          oldSuccs#0, 
          idx#0 + 1, 
          LitInt(0))
         && (forall j#1: int :: 
          { $Unbox(Seq#Index(oldSuccs#0, j#1)): int } 
          LitInt(0) <= j#1 && j#1 < Seq#Length(oldSuccs#0)
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[Seq#Index(oldSuccs#0, j#1)])
         && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t'#0))
         && (forall ref#7: int :: 
          { LruModel.__default.I(q'#0)[$Box(ref#7)] } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)] } 
          LitInt(0) <= ref#7
               && ref#7 < 18446744073709551616
               && 
              Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#7)]): DatatypeType)
                 == LitInt(0)
             ==> LruModel.__default.I(q'#0)[$Box(ref#7)])
         && (forall ref#8: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)] } 
            { LruModel.__default.I(q'#0)[$Box(ref#8)] } 
          LitInt(0) <= ref#8
               && ref#8 < 18446744073709551616
               && LruModel.__default.I(q'#0)[$Box(ref#8)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(ref#8)]): DatatypeType)
                 == LitInt(0))
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t'#0))[$Box(PivotBetreeGraph.__default.Root())]);
  free ensures MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), t#0);
  ensures MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  free ensures true;
  ensures LitInt(0) <= idx#0;
  ensures idx#0 <= Seq#Length(newSuccs#0);
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.PredInc
function IndirectionTableModel.__default.PredInc(t#0: DatatypeType, q#0: Seq Box, ref#0: int) : DatatypeType;

function IndirectionTableModel.__default.PredInc#canCall(t#0: DatatypeType, q#0: Seq Box, ref#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.PredInc
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    { IndirectionTableModel.__default.PredInc(t#0, q#0, ref#0) } 
    IndirectionTableModel.__default.PredInc#canCall(t#0, q#0, ref#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.LinearHashMap.count(t#0) < Div(18446744073709551616, LitInt(8))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
             < 18446744073709551615)
       ==> $Is(IndirectionTableModel.__default.PredInc(t#0, q#0, ref#0), 
        Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          TSeq(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.PredInc#requires(DatatypeType, Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.PredInc
axiom (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
  { IndirectionTableModel.__default.PredInc#requires(t#0, q#0, ref#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.PredInc#requires(t#0, q#0, ref#0)
       == (
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && MutableMapModel.LinearHashMap.count(t#0) < Div(18446744073709551616, LitInt(8))
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
           < 18446744073709551615));

// definition axiom for IndirectionTableModel.__default.PredInc(revealed)
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    { IndirectionTableModel.__default.PredInc(t#0, q#0, ref#0) } 
    IndirectionTableModel.__default.PredInc#canCall(t#0, q#0, ref#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.LinearHashMap.count(t#0) < Div(18446744073709551616, LitInt(8))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
             < 18446744073709551615)
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
         && (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType; 
          (var dt_update_tmp#0#0 := oldEntry#0; 
              IndirectionTableModel.Entry.Entry_q(oldEntry#0)
                 && 
                IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0))
             && (var newEntry#0 := (var dt_update_tmp#0#0 := oldEntry#0; 
                  (var dt_update#predCount#0#0 := IndirectionTableModel.Entry.predCount(oldEntry#0) + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                      dt_update#predCount#0#0))); 
              MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), t#0, ref#0, $Box(newEntry#0))
                 && 
                IndirectionTableModel.Entry.Entry_q(oldEntry#0)
                 && (IndirectionTableModel.Entry.predCount(oldEntry#0) == LitInt(0)
                   ==> LruModel.__default.Remove#canCall(q#0, ref#0))))
         && IndirectionTableModel.__default.PredInc(t#0, q#0, ref#0)
           == (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType; 
            (var newEntry#0 := (var dt_update_tmp#0#0 := oldEntry#0; 
                  (var dt_update#predCount#0#0 := IndirectionTableModel.Entry.predCount(oldEntry#0) + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                      dt_update#predCount#0#0))); 
              (var t'#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.Insert, 
                    t#0, 
                    ref#0, 
                    $Box(newEntry#0)); 
                (var q'#0 := (if IndirectionTableModel.Entry.predCount(oldEntry#0) == LitInt(0)
                       then LruModel.__default.Remove($LS($LZ), q#0, ref#0)
                       else q#0); 
                  #_System._tuple#2._#Make2($Box(t'#0), $Box(q'#0)))))));

// definition axiom for IndirectionTableModel.__default.PredInc for decreasing-related literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredInc(Lit(t#0), q#0, LitInt(ref#0)) } 
    IndirectionTableModel.__default.PredInc#canCall(Lit(t#0), q#0, LitInt(ref#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(t#0))
               < Div(18446744073709551616, LitInt(8)))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType)
             < 18446744073709551615)
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
         && (var oldEntry#1 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
          (var dt_update_tmp#0#1 := oldEntry#1; 
              IndirectionTableModel.Entry.Entry_q(oldEntry#1)
                 && 
                IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1))
             && (var newEntry#1 := (var dt_update_tmp#0#1 := oldEntry#1; 
                  (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount(oldEntry#1) + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                      dt_update#predCount#0#1))); 
              MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), LitInt(ref#0), $Box(newEntry#1))
                 && 
                IndirectionTableModel.Entry.Entry_q(oldEntry#1)
                 && (IndirectionTableModel.Entry.predCount(oldEntry#1) == LitInt(0)
                   ==> LruModel.__default.Remove#canCall(q#0, LitInt(ref#0)))))
         && IndirectionTableModel.__default.PredInc(Lit(t#0), q#0, LitInt(ref#0))
           == (var oldEntry#1 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
            (var newEntry#1 := (var dt_update_tmp#0#1 := oldEntry#1; 
                  (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount(oldEntry#1) + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                      dt_update#predCount#0#1))); 
              (var t'#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.Insert, 
                    Lit(t#0), 
                    LitInt(ref#0), 
                    $Box(newEntry#1)); 
                (var q'#1 := (if IndirectionTableModel.Entry.predCount(oldEntry#1) == LitInt(0)
                       then LruModel.__default.Remove($LS($LZ), q#0, LitInt(ref#0))
                       else q#0); 
                  #_System._tuple#2._#Make2($Box(t'#1), $Box(q'#1)))))));

// definition axiom for IndirectionTableModel.__default.PredInc for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredInc(Lit(t#0), Lit(q#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.PredInc#canCall(Lit(t#0), Lit(q#0), LitInt(ref#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(t#0))
               < Div(18446744073709551616, LitInt(8)))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType)
             < 18446744073709551615)
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
         && (var oldEntry#2 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
          (var dt_update_tmp#0#2 := oldEntry#2; 
              IndirectionTableModel.Entry.Entry_q(oldEntry#2)
                 && 
                IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#2)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#2))
             && (var newEntry#2 := (var dt_update_tmp#0#2 := oldEntry#2; 
                  (var dt_update#predCount#0#2 := IndirectionTableModel.Entry.predCount(oldEntry#2) + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#2), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#2), 
                      dt_update#predCount#0#2))); 
              MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), LitInt(ref#0), $Box(newEntry#2))
                 && 
                IndirectionTableModel.Entry.Entry_q(oldEntry#2)
                 && (IndirectionTableModel.Entry.predCount(oldEntry#2) == LitInt(0)
                   ==> LruModel.__default.Remove#canCall(Lit(q#0), LitInt(ref#0)))))
         && IndirectionTableModel.__default.PredInc(Lit(t#0), Lit(q#0), LitInt(ref#0))
           == (var oldEntry#2 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
            (var newEntry#2 := (var dt_update_tmp#0#2 := oldEntry#2; 
                  (var dt_update#predCount#0#2 := IndirectionTableModel.Entry.predCount(oldEntry#2) + 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#2), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#2), 
                      dt_update#predCount#0#2))); 
              (var t'#2 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.Insert, 
                    Lit(t#0), 
                    LitInt(ref#0), 
                    $Box(newEntry#2)); 
                (var q'#2 := (if IndirectionTableModel.Entry.predCount(oldEntry#2) == LitInt(0)
                       then LruModel.__default.Remove($LS($LZ), Lit(q#0), LitInt(ref#0))
                       else q#0); 
                  #_System._tuple#2._#Make2($Box(t'#2), $Box(q'#2)))))));

// function declaration for IndirectionTableModel._default.PredDec
function IndirectionTableModel.__default.PredDec(t#0: DatatypeType, q#0: Seq Box, ref#0: int) : DatatypeType;

function IndirectionTableModel.__default.PredDec#canCall(t#0: DatatypeType, q#0: Seq Box, ref#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.PredDec
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    { IndirectionTableModel.__default.PredDec(t#0, q#0, ref#0) } 
    IndirectionTableModel.__default.PredDec#canCall(t#0, q#0, ref#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.LinearHashMap.count(t#0) < Div(18446744073709551616, LitInt(8))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
             > 0)
       ==> $Is(IndirectionTableModel.__default.PredDec(t#0, q#0, ref#0), 
        Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          TSeq(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.PredDec#requires(DatatypeType, Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.PredDec
axiom (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
  { IndirectionTableModel.__default.PredDec#requires(t#0, q#0, ref#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.PredDec#requires(t#0, q#0, ref#0)
       == (
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && MutableMapModel.LinearHashMap.count(t#0) < Div(18446744073709551616, LitInt(8))
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
         && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
           > 0));

// definition axiom for IndirectionTableModel.__default.PredDec(revealed)
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    { IndirectionTableModel.__default.PredDec(t#0, q#0, ref#0) } 
    IndirectionTableModel.__default.PredDec#canCall(t#0, q#0, ref#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.LinearHashMap.count(t#0) < Div(18446744073709551616, LitInt(8))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
             > 0)
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
         && (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType; 
          (var dt_update_tmp#0#0 := oldEntry#0; 
              IndirectionTableModel.Entry.Entry_q(oldEntry#0)
                 && 
                IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0))
             && (var newEntry#0 := (var dt_update_tmp#0#0 := oldEntry#0; 
                  (var dt_update#predCount#0#0 := IndirectionTableModel.Entry.predCount(oldEntry#0) - 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                      dt_update#predCount#0#0))); 
              MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), t#0, ref#0, $Box(newEntry#0))
                 && 
                IndirectionTableModel.Entry.Entry_q(oldEntry#0)
                 && (IndirectionTableModel.Entry.predCount(oldEntry#0) == LitInt(1)
                   ==> LruModel.__default.Use#canCall(q#0, ref#0))))
         && IndirectionTableModel.__default.PredDec(t#0, q#0, ref#0)
           == (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType; 
            (var newEntry#0 := (var dt_update_tmp#0#0 := oldEntry#0; 
                  (var dt_update#predCount#0#0 := IndirectionTableModel.Entry.predCount(oldEntry#0) - 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                      dt_update#predCount#0#0))); 
              (var t'#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.Insert, 
                    t#0, 
                    ref#0, 
                    $Box(newEntry#0)); 
                (var q'#0 := (if IndirectionTableModel.Entry.predCount(oldEntry#0) == LitInt(1)
                       then LruModel.__default.Use(q#0, ref#0)
                       else q#0); 
                  #_System._tuple#2._#Make2($Box(t'#0), $Box(q'#0)))))));

// definition axiom for IndirectionTableModel.__default.PredDec for decreasing-related literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredDec(Lit(t#0), q#0, LitInt(ref#0)) } 
    IndirectionTableModel.__default.PredDec#canCall(Lit(t#0), q#0, LitInt(ref#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(t#0))
               < Div(18446744073709551616, LitInt(8)))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType)
             > 0)
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
         && (var oldEntry#1 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
          (var dt_update_tmp#0#1 := oldEntry#1; 
              IndirectionTableModel.Entry.Entry_q(oldEntry#1)
                 && 
                IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1))
             && (var newEntry#1 := (var dt_update_tmp#0#1 := oldEntry#1; 
                  (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount(oldEntry#1) - 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                      dt_update#predCount#0#1))); 
              MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), LitInt(ref#0), $Box(newEntry#1))
                 && 
                IndirectionTableModel.Entry.Entry_q(oldEntry#1)
                 && (IndirectionTableModel.Entry.predCount(oldEntry#1) == LitInt(1)
                   ==> LruModel.__default.Use#canCall(q#0, LitInt(ref#0)))))
         && IndirectionTableModel.__default.PredDec(Lit(t#0), q#0, LitInt(ref#0))
           == (var oldEntry#1 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
            (var newEntry#1 := (var dt_update_tmp#0#1 := oldEntry#1; 
                  (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount(oldEntry#1) - 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                      dt_update#predCount#0#1))); 
              (var t'#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.Insert, 
                    Lit(t#0), 
                    LitInt(ref#0), 
                    $Box(newEntry#1)); 
                (var q'#1 := (if IndirectionTableModel.Entry.predCount(oldEntry#1) == LitInt(1)
                       then LruModel.__default.Use(q#0, LitInt(ref#0))
                       else q#0); 
                  #_System._tuple#2._#Make2($Box(t'#1), $Box(q'#1)))))));

// definition axiom for IndirectionTableModel.__default.PredDec for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType, q#0: Seq Box, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.PredDec(Lit(t#0), Lit(q#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.PredDec#canCall(Lit(t#0), Lit(q#0), LitInt(ref#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && Lit(MutableMapModel.LinearHashMap.count(Lit(t#0))
               < Div(18446744073709551616, LitInt(8)))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType)
             > 0)
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
         && (var oldEntry#2 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
          (var dt_update_tmp#0#2 := oldEntry#2; 
              IndirectionTableModel.Entry.Entry_q(oldEntry#2)
                 && 
                IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#2)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#2))
             && (var newEntry#2 := (var dt_update_tmp#0#2 := oldEntry#2; 
                  (var dt_update#predCount#0#2 := IndirectionTableModel.Entry.predCount(oldEntry#2) - 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#2), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#2), 
                      dt_update#predCount#0#2))); 
              MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), LitInt(ref#0), $Box(newEntry#2))
                 && 
                IndirectionTableModel.Entry.Entry_q(oldEntry#2)
                 && (IndirectionTableModel.Entry.predCount(oldEntry#2) == LitInt(1)
                   ==> LruModel.__default.Use#canCall(Lit(q#0), LitInt(ref#0)))))
         && IndirectionTableModel.__default.PredDec(Lit(t#0), Lit(q#0), LitInt(ref#0))
           == (var oldEntry#2 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(ref#0))]): DatatypeType; 
            (var newEntry#2 := (var dt_update_tmp#0#2 := oldEntry#2; 
                  (var dt_update#predCount#0#2 := IndirectionTableModel.Entry.predCount(oldEntry#2) - 1; 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#2), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#2), 
                      dt_update#predCount#0#2))); 
              (var t'#2 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.Insert, 
                    Lit(t#0), 
                    LitInt(ref#0), 
                    $Box(newEntry#2)); 
                (var q'#2 := (if IndirectionTableModel.Entry.predCount(oldEntry#2) == LitInt(1)
                       then LruModel.__default.Use(Lit(q#0), LitInt(ref#0))
                       else q#0); 
                  #_System._tuple#2._#Make2($Box(t'#2), $Box(q'#2)))))));

// function declaration for IndirectionTableModel._default.UpdatePredCountsDec
function IndirectionTableModel.__default.UpdatePredCountsDec($ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int)
   : DatatypeType;

function IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int :: 
  { IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
  IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
     == IndirectionTableModel.__default.UpdatePredCountsDec($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int :: 
  { IndirectionTableModel.__default.UpdatePredCountsDec(AsFuelBottom($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
  IndirectionTableModel.__default.UpdatePredCountsDec($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
     == IndirectionTableModel.__default.UpdatePredCountsDec($LZ, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0));

// consequence axiom for IndirectionTableModel.__default.UpdatePredCountsDec
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    { IndirectionTableModel.__default.UpdatePredCountsDec($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
    IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            t#0, 
            q#0, 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx#0))
       ==> (var t'#0, q'#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsDec($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsDec($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0))): Seq Box; 
          IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
              t'#0, 
              q'#0, 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              Seq#Length(newSuccs#0), 
              Seq#Length(oldSuccs#0))
             && Map#Equal(IndirectionTableModel.__default.Graph(t#0), 
              IndirectionTableModel.__default.Graph(t'#0))
             && Map#Equal(IndirectionTableModel.__default.Locs(t#0), 
              IndirectionTableModel.__default.Locs(t'#0)))
         && $Is(IndirectionTableModel.__default.UpdatePredCountsDec($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0), 
          Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
            TSeq(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.UpdatePredCountsDec#requires(LayerType, DatatypeType, Seq Box, int, Seq Box, Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.UpdatePredCountsDec
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int :: 
  { IndirectionTableModel.__default.UpdatePredCountsDec#requires($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= changingRef#0
       && changingRef#0 < 18446744073709551616
       && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= idx#0
       && idx#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.UpdatePredCountsDec#requires($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
       == IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        Seq#Length(newSuccs#0), 
        idx#0));

// definition axiom for IndirectionTableModel.__default.UpdatePredCountsDec(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    { IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
    IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            t#0, 
            q#0, 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            Seq#Length(newSuccs#0), 
            idx#0))
       ==> (idx#0 != Seq#Length(oldSuccs#0)
           ==> IndirectionTableModel.__default.PredDec#canCall(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int)
             && (var t'#1, q'#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t'#1, q'#1, changingRef#0, newSuccs#0, oldSuccs#0, idx#0 + 1)))
         && IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
           == (if idx#0 == Seq#Length(oldSuccs#0)
             then #_System._tuple#2._#Make2($Box(t#0), $Box(q#0))
             else (var t'#1, q'#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(oldSuccs#0, idx#0)): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsDec($ly, t'#1, q'#1, changingRef#0, newSuccs#0, oldSuccs#0, idx#0 + 1))));

// definition axiom for IndirectionTableModel.__default.UpdatePredCountsDec for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, Lit(oldSuccs#0), LitInt(idx#0)) } 
    IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t#0, q#0, changingRef#0, newSuccs#0, Lit(oldSuccs#0), LitInt(idx#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            t#0, 
            q#0, 
            changingRef#0, 
            newSuccs#0, 
            Lit(oldSuccs#0), 
            Seq#Length(newSuccs#0), 
            LitInt(idx#0)))
       ==> (LitInt(idx#0) != Seq#Length(Lit(oldSuccs#0))
           ==> IndirectionTableModel.__default.PredDec#canCall(t#0, q#0, $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int)
             && (var t'#2, q'#2 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t'#2, q'#2, changingRef#0, newSuccs#0, Lit(oldSuccs#0), LitInt(idx#0 + 1))))
         && IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, Lit(oldSuccs#0), LitInt(idx#0))
           == (if LitInt(idx#0) == Seq#Length(Lit(oldSuccs#0))
             then #_System._tuple#2._#Make2($Box(t#0), $Box(q#0))
             else (var t'#2, q'#2 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(t#0, q#0, $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), 
                t'#2, 
                q'#2, 
                changingRef#0, 
                newSuccs#0, 
                Lit(oldSuccs#0), 
                LitInt(idx#0 + 1)))));

// definition axiom for IndirectionTableModel.__default.UpdatePredCountsDec for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), 
        Lit(t#0), 
        Lit(q#0), 
        LitInt(changingRef#0), 
        Lit(newSuccs#0), 
        Lit(oldSuccs#0), 
        LitInt(idx#0)) } 
    IndirectionTableModel.__default.UpdatePredCountsDec#canCall(Lit(t#0), 
          Lit(q#0), 
          LitInt(changingRef#0), 
          Lit(newSuccs#0), 
          Lit(oldSuccs#0), 
          LitInt(idx#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            Lit(t#0), 
            Lit(q#0), 
            LitInt(changingRef#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            Seq#Length(Lit(newSuccs#0)), 
            LitInt(idx#0)))
       ==> (LitInt(idx#0) != Seq#Length(Lit(oldSuccs#0))
           ==> IndirectionTableModel.__default.PredDec#canCall(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int)
             && (var t'#3, q'#3 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t'#3, 
                q'#3, 
                LitInt(changingRef#0), 
                Lit(newSuccs#0), 
                Lit(oldSuccs#0), 
                LitInt(idx#0 + 1))))
         && IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), 
            Lit(t#0), 
            Lit(q#0), 
            LitInt(changingRef#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            LitInt(idx#0))
           == (if LitInt(idx#0) == Seq#Length(Lit(oldSuccs#0))
             then #_System._tuple#2._#Make2($Box(Lit(t#0)), $Box(Lit(q#0)))
             else (var t'#3, q'#3 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredDec(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredDec(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(oldSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsDec($LS($ly), 
                t'#3, 
                q'#3, 
                LitInt(changingRef#0), 
                Lit(newSuccs#0), 
                Lit(oldSuccs#0), 
                LitInt(idx#0 + 1)))));

// function declaration for IndirectionTableModel._default.UpdatePredCountsInc
function IndirectionTableModel.__default.UpdatePredCountsInc($ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int)
   : DatatypeType;

function IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int)
   : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int :: 
  { IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
  IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
     == IndirectionTableModel.__default.UpdatePredCountsInc($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int :: 
  { IndirectionTableModel.__default.UpdatePredCountsInc(AsFuelBottom($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
  IndirectionTableModel.__default.UpdatePredCountsInc($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
     == IndirectionTableModel.__default.UpdatePredCountsInc($LZ, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0));

// consequence axiom for IndirectionTableModel.__default.UpdatePredCountsInc
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    { IndirectionTableModel.__default.UpdatePredCountsInc($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
    IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            t#0, 
            q#0, 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0)))
       ==> (var t'#0, q'#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0))): Seq Box; 
          IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
              t'#0, 
              q'#0, 
              changingRef#0, 
              newSuccs#0, 
              oldSuccs#0, 
              Seq#Length(newSuccs#0), 
              Seq#Length(oldSuccs#0))
             && Map#Equal(IndirectionTableModel.__default.Graph(t#0), 
              IndirectionTableModel.__default.Graph(t'#0))
             && Map#Equal(IndirectionTableModel.__default.Locs(t#0), 
              IndirectionTableModel.__default.Locs(t'#0)))
         && $Is(IndirectionTableModel.__default.UpdatePredCountsInc($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0), 
          Tclass._System.Tuple2(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
            TSeq(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.UpdatePredCountsInc#requires(LayerType, DatatypeType, Seq Box, int, Seq Box, Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.UpdatePredCountsInc
axiom (forall $ly: LayerType, 
    t#0: DatatypeType, 
    q#0: Seq Box, 
    changingRef#0: int, 
    newSuccs#0: Seq Box, 
    oldSuccs#0: Seq Box, 
    idx#0: int :: 
  { IndirectionTableModel.__default.UpdatePredCountsInc#requires($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= changingRef#0
       && changingRef#0 < 18446744073709551616
       && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= idx#0
       && idx#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.UpdatePredCountsInc#requires($ly, t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
       == IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
        t#0, 
        q#0, 
        changingRef#0, 
        newSuccs#0, 
        oldSuccs#0, 
        idx#0, 
        LitInt(0)));

// definition axiom for IndirectionTableModel.__default.UpdatePredCountsInc(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    { IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0) } 
    IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            t#0, 
            q#0, 
            changingRef#0, 
            newSuccs#0, 
            oldSuccs#0, 
            idx#0, 
            LitInt(0)))
       ==> (idx#0 == Seq#Length(newSuccs#0)
           ==> IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, LitInt(0)))
         && (idx#0 != Seq#Length(newSuccs#0)
           ==> IndirectionTableModel.__default.PredInc#canCall(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int)
             && (var t'#1, q'#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t'#1, q'#1, changingRef#0, newSuccs#0, oldSuccs#0, idx#0 + 1)))
         && IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, idx#0)
           == (if idx#0 == Seq#Length(newSuccs#0)
             then IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), t#0, q#0, changingRef#0, newSuccs#0, oldSuccs#0, LitInt(0))
             else (var t'#1, q'#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(newSuccs#0, idx#0)): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsInc($ly, t'#1, q'#1, changingRef#0, newSuccs#0, oldSuccs#0, idx#0 + 1))));

// definition axiom for IndirectionTableModel.__default.UpdatePredCountsInc for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), t#0, q#0, changingRef#0, Lit(newSuccs#0), oldSuccs#0, LitInt(idx#0)) } 
    IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#0, q#0, changingRef#0, Lit(newSuccs#0), oldSuccs#0, LitInt(idx#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
            t#0, 
            q#0, 
            changingRef#0, 
            Lit(newSuccs#0), 
            oldSuccs#0, 
            LitInt(idx#0), 
            LitInt(0)))
       ==> (LitInt(idx#0) == Seq#Length(Lit(newSuccs#0))
           ==> IndirectionTableModel.__default.UpdatePredCountsDec#canCall(t#0, q#0, changingRef#0, Lit(newSuccs#0), oldSuccs#0, LitInt(0)))
         && (LitInt(idx#0) != Seq#Length(Lit(newSuccs#0))
           ==> IndirectionTableModel.__default.PredInc#canCall(t#0, q#0, $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int)
             && (var t'#2, q'#2 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t'#2, q'#2, changingRef#0, Lit(newSuccs#0), oldSuccs#0, LitInt(idx#0 + 1))))
         && IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), t#0, q#0, changingRef#0, Lit(newSuccs#0), oldSuccs#0, LitInt(idx#0))
           == (if LitInt(idx#0) == Seq#Length(Lit(newSuccs#0))
             then IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), t#0, q#0, changingRef#0, Lit(newSuccs#0), oldSuccs#0, LitInt(0))
             else (var t'#2, q'#2 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(t#0, q#0, $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), 
                t'#2, 
                q'#2, 
                changingRef#0, 
                Lit(newSuccs#0), 
                oldSuccs#0, 
                LitInt(idx#0 + 1)))));

// definition axiom for IndirectionTableModel.__default.UpdatePredCountsInc for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      t#0: DatatypeType, 
      q#0: Seq Box, 
      changingRef#0: int, 
      newSuccs#0: Seq Box, 
      oldSuccs#0: Seq Box, 
      idx#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), 
        Lit(t#0), 
        Lit(q#0), 
        LitInt(changingRef#0), 
        Lit(newSuccs#0), 
        Lit(oldSuccs#0), 
        LitInt(idx#0)) } 
    IndirectionTableModel.__default.UpdatePredCountsInc#canCall(Lit(t#0), 
          Lit(q#0), 
          LitInt(changingRef#0), 
          Lit(newSuccs#0), 
          Lit(oldSuccs#0), 
          LitInt(idx#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= changingRef#0
           && changingRef#0 < 18446744073709551616
           && $Is(newSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(oldSuccs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= idx#0
           && idx#0 < 18446744073709551616
           && Lit(IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
              Lit(t#0), 
              Lit(q#0), 
              LitInt(changingRef#0), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(idx#0), 
              LitInt(0))))
       ==> (LitInt(idx#0) == Seq#Length(Lit(newSuccs#0))
           ==> IndirectionTableModel.__default.UpdatePredCountsDec#canCall(Lit(t#0), 
            Lit(q#0), 
            LitInt(changingRef#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            LitInt(0)))
         && (LitInt(idx#0) != Seq#Length(Lit(newSuccs#0))
           ==> IndirectionTableModel.__default.PredInc#canCall(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int)
             && (var t'#3, q'#3 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t'#3, 
                q'#3, 
                LitInt(changingRef#0), 
                Lit(newSuccs#0), 
                Lit(oldSuccs#0), 
                LitInt(idx#0 + 1))))
         && IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), 
            Lit(t#0), 
            Lit(q#0), 
            LitInt(changingRef#0), 
            Lit(newSuccs#0), 
            Lit(oldSuccs#0), 
            LitInt(idx#0))
           == (if LitInt(idx#0) == Seq#Length(Lit(newSuccs#0))
             then IndirectionTableModel.__default.UpdatePredCountsDec($LS($LZ), 
              Lit(t#0), 
              Lit(q#0), 
              LitInt(changingRef#0), 
              Lit(newSuccs#0), 
              Lit(oldSuccs#0), 
              LitInt(0))
             else (var t'#3, q'#3 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.PredInc(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): DatatypeType, 
                $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.PredInc(Lit(t#0), Lit(q#0), $Unbox(Seq#Index(Lit(newSuccs#0), LitInt(idx#0))): int))): Seq Box; 
              IndirectionTableModel.__default.UpdatePredCountsInc($LS($ly), 
                t'#3, 
                q'#3, 
                LitInt(changingRef#0), 
                Lit(newSuccs#0), 
                Lit(oldSuccs#0), 
                LitInt(idx#0 + 1)))));

// function declaration for IndirectionTableModel._default.SuccsValid
function IndirectionTableModel.__default.SuccsValid(succs#0: Seq Box, graph#0: Map Box Box) : bool;

function IndirectionTableModel.__default.SuccsValid#canCall(succs#0: Seq Box, graph#0: Map Box Box) : bool;

// consequence axiom for IndirectionTableModel.__default.SuccsValid
axiom true
   ==> (forall succs#0: Seq Box, graph#0: Map Box Box :: 
    { IndirectionTableModel.__default.SuccsValid(succs#0, graph#0) } 
    IndirectionTableModel.__default.SuccsValid#canCall(succs#0, graph#0)
         || ($Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> true);

function IndirectionTableModel.__default.SuccsValid#requires(Seq Box, Map Box Box) : bool;

// #requires axiom for IndirectionTableModel.__default.SuccsValid
axiom (forall succs#0: Seq Box, graph#0: Map Box Box :: 
  { IndirectionTableModel.__default.SuccsValid#requires(succs#0, graph#0) } 
  $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64())))
     ==> IndirectionTableModel.__default.SuccsValid#requires(succs#0, graph#0) == true);

// definition axiom for IndirectionTableModel.__default.SuccsValid(revealed)
axiom true
   ==> (forall succs#0: Seq Box, graph#0: Map Box Box :: 
    { IndirectionTableModel.__default.SuccsValid(succs#0, graph#0) } 
    IndirectionTableModel.__default.SuccsValid#canCall(succs#0, graph#0)
         || ($Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> IndirectionTableModel.__default.SuccsValid(succs#0, graph#0)
         == (forall ref#0: int :: 
          { Map#Domain(graph#0)[$Box(ref#0)] } { Seq#Contains(succs#0, $Box(ref#0)) } 
          LitInt(0) <= ref#0
               && ref#0 < 18446744073709551616
               && Seq#Contains(succs#0, $Box(ref#0))
             ==> Map#Domain(graph#0)[$Box(ref#0)]));

// definition axiom for IndirectionTableModel.__default.SuccsValid for all literals(revealed)
axiom true
   ==> (forall succs#0: Seq Box, graph#0: Map Box Box :: 
    {:weight 3} { IndirectionTableModel.__default.SuccsValid(Lit(succs#0), Lit(graph#0)) } 
    IndirectionTableModel.__default.SuccsValid#canCall(Lit(succs#0), Lit(graph#0))
         || ($Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(graph#0, TMap(Tclass.NativeTypes.uint64(), TSeq(Tclass.NativeTypes.uint64()))))
       ==> IndirectionTableModel.__default.SuccsValid(Lit(succs#0), Lit(graph#0))
         == (forall ref#1: int :: 
          { Map#Domain(graph#0)[$Box(ref#1)] } { Seq#Contains(succs#0, $Box(ref#1)) } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && Seq#Contains(succs#0, $Box(ref#1))
             ==> Map#Domain(graph#0)[$Box(ref#1)]));

procedure CheckWellformed$$IndirectionTableModel.__default.LemmaUpdateAndRemoveLocStuff(self#0: DatatypeType
       where $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
         && $IsAlloc(self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap)
         && $IsA#IndirectionTableModel.IndirectionTable(self#0), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  free requires 56 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.LemmaUpdateAndRemoveLocStuff(self#0: DatatypeType
       where $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
         && $IsAlloc(self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap)
         && $IsA#IndirectionTableModel.IndirectionTable(self#0), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616, 
    succs#0: Seq Box
       where $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
         && $IsAlloc(succs#0, TSeq(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires IndirectionTableModel.__default.Inv(self#0);
  requires IndirectionTableModel.__default.TrackingGarbage#canCall(self#0)
     ==> IndirectionTableModel.__default.TrackingGarbage(self#0)
       || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0));
  requires Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren());
  requires IndirectionTableModel.__default.SuccsValid#canCall(succs#0, IndirectionTableModel.IndirectionTable.graph(self#0))
     ==> IndirectionTableModel.__default.SuccsValid(succs#0, IndirectionTableModel.IndirectionTable.graph(self#0))
       || (forall ref#1: int :: 
        { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#1)] } 
          { Seq#Contains(succs#0, $Box(ref#1)) } 
        LitInt(0) <= ref#1
             && ref#1 < 18446744073709551616
             && Seq#Contains(succs#0, $Box(ref#1))
           ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#1)]);
  requires MutableMapModel.LinearHashMap.count(IndirectionTableModel.IndirectionTable.t(self#0))
     <= LitInt(IndirectionTableModel.__default.MaxSize() - 1);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
     && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
      IndirectionTableModel.IndirectionTable.t(self#0), 
      ref#0)
     && (var oldEntry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0); 
      (Options.Option.Some_q(oldEntry#0)
           ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
         && (var predCount#0 := (if Options.Option.Some_q(oldEntry#0)
               then IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
               else 0); 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0, 
              $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0)))
             && (var t#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  ref#0, 
                  $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0))); 
              (Options.Option.Some_q(oldEntry#0)
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0))
                 && (!Options.Option.Some_q(oldEntry#0)
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && LruModel.__default.Use#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                      ref#0))
                 && (var q#0 := (if Options.Option.Some_q(oldEntry#0)
                       then $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box
                       else LruModel.__default.Use($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                        ref#0)); 
                  (Options.Option.Some_q(oldEntry#0)
                       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
                     && IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, 
                      q#0, 
                      ref#0, 
                      succs#0, 
                      (if Options.Option.Some_q(oldEntry#0)
                         then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                         else Seq#Empty(): Seq Box), 
                      LitInt(0), 
                      LitInt(0))))));
  free ensures (var oldEntry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
        IndirectionTableModel.IndirectionTable.t(self#0), 
        ref#0); 
    (var predCount#0 := (if Options.Option.Some_q(oldEntry#0)
           then IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
           else 0); 
      (var t#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
            StartFuelAssert_MutableMapModel._default.Insert, 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            ref#0, 
            $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0))); 
        (var q#0 := (if Options.Option.Some_q(oldEntry#0)
               then $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box
               else LruModel.__default.Use($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                ref#0)); 
          IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, 
              q#0, 
              ref#0, 
              succs#0, 
              (if Options.Option.Some_q(oldEntry#0)
                 then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                 else Seq#Empty(): Seq Box), 
              LitInt(0), 
              LitInt(0))
             && IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
              t#0, 
              q#0, 
              ref#0, 
              succs#0, 
              (if Options.Option.Some_q(oldEntry#0)
                 then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                 else Seq#Empty(): Seq Box), 
              LitInt(0), 
              LitInt(0))))));
  free ensures IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
     && LruModel.__default.I#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box);
  ensures Set#Card(LruModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box))
     <= LitInt(4294967296);
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0));
  free requires 58 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.lemma__count__eq__graph__size(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0));
  // user-defined preconditions
  requires MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
     && IndirectionTableModel.__default.Graph#canCall(t#0);
  ensures MutableMapModel.LinearHashMap.count(t#0)
     == Map#Card(IndirectionTableModel.__default.Graph(t#0));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.UpdateAndRemoveLoc
function IndirectionTableModel.__default.UpdateAndRemoveLoc($ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box)
   : DatatypeType;

function IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(self#0: DatatypeType, ref#0: int, succs#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box :: 
  { IndirectionTableModel.__default.UpdateAndRemoveLoc($LS($ly), self#0, ref#0, succs#0) } 
  IndirectionTableModel.__default.UpdateAndRemoveLoc($LS($ly), self#0, ref#0, succs#0)
     == IndirectionTableModel.__default.UpdateAndRemoveLoc($ly, self#0, ref#0, succs#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box :: 
  { IndirectionTableModel.__default.UpdateAndRemoveLoc(AsFuelBottom($ly), self#0, ref#0, succs#0) } 
  IndirectionTableModel.__default.UpdateAndRemoveLoc($ly, self#0, ref#0, succs#0)
     == IndirectionTableModel.__default.UpdateAndRemoveLoc($LZ, self#0, ref#0, succs#0));

// consequence axiom for IndirectionTableModel.__default.UpdateAndRemoveLoc
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box :: 
    { IndirectionTableModel.__default.UpdateAndRemoveLoc($ly, self#0, ref#0, succs#0) } 
    IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(self#0, ref#0, succs#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0)
           && Map#Card(IndirectionTableModel.IndirectionTable.graph(self#0))
             < IndirectionTableModel.__default.MaxSize()
           && Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && IndirectionTableModel.__default.SuccsValid(succs#0, IndirectionTableModel.IndirectionTable.graph(self#0)))
       ==> (var self'#0, oldLoc#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdateAndRemoveLoc($ly, self#0, ref#0, succs#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdateAndRemoveLoc($ly, self#0, ref#0, succs#0))): DatatypeType; 
          IndirectionTableModel.__default.Inv(self'#0)
             && IndirectionTableModel.__default.TrackingGarbage(self'#0)
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
              Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove1, 
                IndirectionTableModel.IndirectionTable.locs(self#0), 
                $Box(ref#0)))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self'#0), 
              Map#Build(IndirectionTableModel.IndirectionTable.graph(self#0), $Box(ref#0), $Box(succs#0)))
             && (Options.Option.None_q(oldLoc#0)
               ==> !Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)])
             && (Options.Option.Some_q(oldLoc#0)
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
                 && DiskLayout.Location#Equal($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]): DatatypeType, 
                  $Unbox(Options.Option.value(oldLoc#0)): DatatypeType)))
         && $Is(IndirectionTableModel.__default.UpdateAndRemoveLoc($ly, self#0, ref#0, succs#0), 
          Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
            Tclass.Options.Option(Tclass.DiskLayout.Location()))));

function IndirectionTableModel.__default.UpdateAndRemoveLoc#requires(LayerType, DatatypeType, int, Seq Box) : bool;

// #requires axiom for IndirectionTableModel.__default.UpdateAndRemoveLoc
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box :: 
  { IndirectionTableModel.__default.UpdateAndRemoveLoc#requires($ly, self#0, ref#0, succs#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
       && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
     ==> IndirectionTableModel.__default.UpdateAndRemoveLoc#requires($ly, self#0, ref#0, succs#0)
       == (
        IndirectionTableModel.__default.Inv(self#0)
         && IndirectionTableModel.__default.TrackingGarbage(self#0)
         && Map#Card(IndirectionTableModel.IndirectionTable.graph(self#0))
           < IndirectionTableModel.__default.MaxSize()
         && Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren())
         && IndirectionTableModel.__default.SuccsValid(succs#0, IndirectionTableModel.IndirectionTable.graph(self#0))));

// definition axiom for IndirectionTableModel.__default.UpdateAndRemoveLoc(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box :: 
    { IndirectionTableModel.__default.UpdateAndRemoveLoc($LS($ly), self#0, ref#0, succs#0) } 
    IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(self#0, ref#0, succs#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0)
           && Map#Card(IndirectionTableModel.IndirectionTable.graph(self#0))
             < IndirectionTableModel.__default.MaxSize()
           && Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && IndirectionTableModel.__default.SuccsValid(succs#0, IndirectionTableModel.IndirectionTable.graph(self#0)))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0)
         && (var oldEntry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0); 
          (Options.Option.Some_q(oldEntry#0)
               ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
             && (var predCount#0 := (if Options.Option.Some_q(oldEntry#0)
                   then IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                   else 0); 
              (Options.Option.Some_q(oldEntry#0)
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0))
                 && (!Options.Option.Some_q(oldEntry#0)
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && LruModel.__default.Use#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                      ref#0))
                 && (var q#0 := (if Options.Option.Some_q(oldEntry#0)
                       then $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box
                       else LruModel.__default.Use($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                        ref#0)); 
                  IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
                      IndirectionTableModel.IndirectionTable.t(self#0), 
                      ref#0, 
                      $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0)))
                     && (var t#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.Insert, 
                          IndirectionTableModel.IndirectionTable.t(self#0), 
                          ref#0, 
                          $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0))); 
                      (Options.Option.Some_q(oldEntry#0)
                           ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
                         && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#0, 
                          q#0, 
                          ref#0, 
                          succs#0, 
                          (if Options.Option.Some_q(oldEntry#0)
                             then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                             else Seq#Empty(): Seq Box), 
                          LitInt(0))
                         && (var t1#0, garbageQueue1#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                                  t#0, 
                                  q#0, 
                                  ref#0, 
                                  succs#0, 
                                  (if Options.Option.Some_q(oldEntry#0)
                                     then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                                     else Seq#Empty(): Seq Box), 
                                  LitInt(0)))): DatatypeType, 
                            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                                  t#0, 
                                  q#0, 
                                  ref#0, 
                                  succs#0, 
                                  (if Options.Option.Some_q(oldEntry#0)
                                     then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                                     else Seq#Empty(): Seq Box), 
                                  LitInt(0)))): Seq Box; 
                          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && (IndirectionTableModel.IndirectionTable.refUpperBound(self#0) > ref#0
                               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0))
                             && (var refUpperBound'#0 := (if IndirectionTableModel.IndirectionTable.refUpperBound(self#0) > ref#0
                                   then IndirectionTableModel.IndirectionTable.refUpperBound(self#0)
                                   else ref#0); 
                              IndirectionTableModel.__default.FromHashMap#canCall(t1#0, 
                                  #Options.Option.Some($Box(garbageQueue1#0)), 
                                  refUpperBound'#0, 
                                  Lit(#Options.Option.None()))
                                 && 
                                (Options.Option.Some_q(oldEntry#0)
                                   ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
                                 && (Options.Option.Some_q(oldEntry#0)
                                     && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
                                   ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))))))))
         && IndirectionTableModel.__default.UpdateAndRemoveLoc($LS($ly), self#0, ref#0, succs#0)
           == (var oldEntry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
                IndirectionTableModel.IndirectionTable.t(self#0), 
                ref#0); 
            (var predCount#0 := (if Options.Option.Some_q(oldEntry#0)
                   then IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                   else 0); 
              (var q#0 := (if Options.Option.Some_q(oldEntry#0)
                     then $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box
                     else LruModel.__default.Use($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                      ref#0)); 
                (var t#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.Insert, 
                      IndirectionTableModel.IndirectionTable.t(self#0), 
                      ref#0, 
                      $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0))); 
                  (var t1#0, garbageQueue1#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                            t#0, 
                            q#0, 
                            ref#0, 
                            succs#0, 
                            (if Options.Option.Some_q(oldEntry#0)
                               then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                               else Seq#Empty(): Seq Box), 
                            LitInt(0)))): DatatypeType, 
                      $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                            t#0, 
                            q#0, 
                            ref#0, 
                            succs#0, 
                            (if Options.Option.Some_q(oldEntry#0)
                               then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                               else Seq#Empty(): Seq Box), 
                            LitInt(0)))): Seq Box; 
                    (var refUpperBound'#0 := (if IndirectionTableModel.IndirectionTable.refUpperBound(self#0) > ref#0
                           then IndirectionTableModel.IndirectionTable.refUpperBound(self#0)
                           else ref#0); 
                      (var self'#1 := IndirectionTableModel.__default.FromHashMap(t1#0, 
                            #Options.Option.Some($Box(garbageQueue1#0)), 
                            refUpperBound'#0, 
                            Lit(#Options.Option.None())); 
                        (var oldLoc#1 := (if Options.Option.Some_q(oldEntry#0)
                                 && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
                               then IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                               else #Options.Option.None()); 
                          #_System._tuple#2._#Make2($Box(self'#1), $Box(oldLoc#1)))))))))));

// definition axiom for IndirectionTableModel.__default.UpdateAndRemoveLoc for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int, succs#0: Seq Box :: 
    {:weight 3} { IndirectionTableModel.__default.UpdateAndRemoveLoc($LS($ly), Lit(self#0), LitInt(ref#0), Lit(succs#0)) } 
    IndirectionTableModel.__default.UpdateAndRemoveLoc#canCall(Lit(self#0), LitInt(ref#0), Lit(succs#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(self#0)))
           && Lit(IndirectionTableModel.__default.TrackingGarbage(Lit(self#0)))
           && Map#Card(Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))
             < IndirectionTableModel.__default.MaxSize()
           && Seq#Length(Lit(succs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           && Lit(IndirectionTableModel.__default.SuccsValid(Lit(succs#0), Lit(IndirectionTableModel.IndirectionTable.graph(Lit(self#0))))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          LitInt(ref#0))
         && (var oldEntry#1 := Lit(MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
                Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                LitInt(ref#0))); 
          (Options.Option.Some_q(oldEntry#1)
               ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
             && (var predCount#1 := (if Options.Option.Some_q(oldEntry#1)
                   then IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                   else 0); 
              (Options.Option.Some_q(oldEntry#1)
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0)))
                 && (!Options.Option.Some_q(oldEntry#1)
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                     && LruModel.__default.Use#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box), 
                      LitInt(ref#0)))
                 && (var q#1 := (if Options.Option.Some_q(oldEntry#1)
                       then $Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box
                       else LruModel.__default.Use(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box), 
                        LitInt(ref#0))); 
                  IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                     && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
                      Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                      LitInt(ref#0), 
                      $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), Lit(succs#0), predCount#1)))
                     && (var t#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.Insert, 
                          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                          LitInt(ref#0), 
                          $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), Lit(succs#0), predCount#1))); 
                      (Options.Option.Some_q(oldEntry#1)
                           ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                         && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#1, 
                          q#1, 
                          LitInt(ref#0), 
                          Lit(succs#0), 
                          (if Options.Option.Some_q(oldEntry#1)
                             then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                             else Seq#Empty(): Seq Box), 
                          LitInt(0))
                         && (var t1#1, garbageQueue1#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                                  t#1, 
                                  q#1, 
                                  LitInt(ref#0), 
                                  Lit(succs#0), 
                                  (if Options.Option.Some_q(oldEntry#1)
                                     then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                                     else Seq#Empty(): Seq Box), 
                                  LitInt(0)))): DatatypeType, 
                            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                                  t#1, 
                                  q#1, 
                                  LitInt(ref#0), 
                                  Lit(succs#0), 
                                  (if Options.Option.Some_q(oldEntry#1)
                                     then IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                                     else Seq#Empty(): Seq Box), 
                                  LitInt(0)))): Seq Box; 
                          IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && (Lit(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0)) > ref#0)
                               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0)))
                             && (var refUpperBound'#1 := (if IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0)) > ref#0
                                   then IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))
                                   else ref#0); 
                              IndirectionTableModel.__default.FromHashMap#canCall(t1#1, 
                                  #Options.Option.Some($Box(garbageQueue1#1)), 
                                  refUpperBound'#1, 
                                  Lit(#Options.Option.None()))
                                 && 
                                (Options.Option.Some_q(oldEntry#1)
                                   ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                                 && (Options.Option.Some_q(oldEntry#1)
                                     && Options.Option.Some_q(IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                                   ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))))))))
         && IndirectionTableModel.__default.UpdateAndRemoveLoc($LS($ly), Lit(self#0), LitInt(ref#0), Lit(succs#0))
           == (var oldEntry#1 := Lit(MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  LitInt(ref#0))); 
            (var predCount#1 := (if Options.Option.Some_q(oldEntry#1)
                   then IndirectionTableModel.Entry.predCount(Lit($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                   else 0); 
              (var q#1 := (if Options.Option.Some_q(oldEntry#1)
                     then $Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box
                     else LruModel.__default.Use(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box), 
                      LitInt(ref#0))); 
                (var t#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.Insert, 
                      Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                      LitInt(ref#0), 
                      $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), Lit(succs#0), predCount#1))); 
                  (var t1#1, garbageQueue1#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                            t#1, 
                            q#1, 
                            LitInt(ref#0), 
                            Lit(succs#0), 
                            (if Options.Option.Some_q(oldEntry#1)
                               then IndirectionTableModel.Entry.succs(Lit($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                               else Seq#Empty(): Seq Box), 
                            LitInt(0)))): DatatypeType, 
                      $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                            t#1, 
                            q#1, 
                            LitInt(ref#0), 
                            Lit(succs#0), 
                            (if Options.Option.Some_q(oldEntry#1)
                               then IndirectionTableModel.Entry.succs(Lit($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                               else Seq#Empty(): Seq Box), 
                            LitInt(0)))): Seq Box; 
                    (var refUpperBound'#1 := (if IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0)) > ref#0
                           then IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))
                           else ref#0); 
                      (var self'#2 := IndirectionTableModel.__default.FromHashMap(t1#1, 
                            #Options.Option.Some($Box(garbageQueue1#1)), 
                            refUpperBound'#1, 
                            Lit(#Options.Option.None())); 
                        (var oldLoc#2 := (if Options.Option.Some_q(oldEntry#1)
                                 && Options.Option.Some_q(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))))
                               then IndirectionTableModel.Entry.loc(Lit($Unbox(Options.Option.value(oldEntry#1)): DatatypeType))
                               else #Options.Option.None()); 
                          #_System._tuple#2._#Make2($Box(self'#2), $Box(oldLoc#2)))))))))));

// function declaration for IndirectionTableModel._default.RemoveLoc
function IndirectionTableModel.__default.RemoveLoc($ly: LayerType, self#0: DatatypeType, ref#0: int) : DatatypeType;

function IndirectionTableModel.__default.RemoveLoc#canCall(self#0: DatatypeType, ref#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.RemoveLoc($LS($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.RemoveLoc($LS($ly), self#0, ref#0)
     == IndirectionTableModel.__default.RemoveLoc($ly, self#0, ref#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.RemoveLoc(AsFuelBottom($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.RemoveLoc($ly, self#0, ref#0)
     == IndirectionTableModel.__default.RemoveLoc($LZ, self#0, ref#0));

// consequence axiom for IndirectionTableModel.__default.RemoveLoc
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.RemoveLoc($ly, self#0, ref#0) } 
    IndirectionTableModel.__default.RemoveLoc#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0)
           && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)])
       ==> (var self'#0, oldLoc#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.RemoveLoc($ly, self#0, ref#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.RemoveLoc($ly, self#0, ref#0))): DatatypeType; 
          IndirectionTableModel.__default.Inv(self'#0)
             && IndirectionTableModel.__default.TrackingGarbage(self'#0)
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
              Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove1, 
                IndirectionTableModel.IndirectionTable.locs(self#0), 
                $Box(ref#0)))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self'#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
             && (Options.Option.None_q(oldLoc#0)
               ==> !Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)])
             && (Options.Option.Some_q(oldLoc#0)
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
                 && DiskLayout.Location#Equal($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]): DatatypeType, 
                  $Unbox(Options.Option.value(oldLoc#0)): DatatypeType)))
         && $Is(IndirectionTableModel.__default.RemoveLoc($ly, self#0, ref#0), 
          Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
            Tclass.Options.Option(Tclass.DiskLayout.Location()))));

function IndirectionTableModel.__default.RemoveLoc#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.RemoveLoc
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.RemoveLoc#requires($ly, self#0, ref#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.RemoveLoc#requires($ly, self#0, ref#0)
       == (
        IndirectionTableModel.__default.Inv(self#0)
         && IndirectionTableModel.__default.TrackingGarbage(self#0)
         && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]));

// definition axiom for IndirectionTableModel.__default.RemoveLoc(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.RemoveLoc($LS($ly), self#0, ref#0) } 
    IndirectionTableModel.__default.RemoveLoc#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0)
           && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)])
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.FindSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0)
         && (var it#0 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.FindSimpleIter, 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0); 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              it#0)
             && (var oldEntry#0 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  it#0); 
              IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)
                 && (var predCount#0 := IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType); 
                  IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType)
                     && (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType); 
                      IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                         && MutableMapModel.__default.UpdateByIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                          IndirectionTableModel.IndirectionTable.t(self#0), 
                          it#0, 
                          $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0)))
                         && (var t#0 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                              StartFuel_MutableMapModel._default.UpdateByIter, 
                              IndirectionTableModel.IndirectionTable.t(self#0), 
                              it#0, 
                              $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0))); 
                          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                             && IndirectionTableModel.__default.FromHashMap#canCall(t#0, 
                              IndirectionTableModel.IndirectionTable.garbageQueue(self#0), 
                              IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
                              Lit(#Options.Option.None()))
                             && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType))))))
         && IndirectionTableModel.__default.RemoveLoc($LS($ly), self#0, ref#0)
           == (var it#0 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.FindSimpleIter, 
                IndirectionTableModel.IndirectionTable.t(self#0), 
                ref#0); 
            (var oldEntry#0 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  it#0); 
              (var predCount#0 := IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType); 
                (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType); 
                  (var t#0 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.UpdateByIter, 
                        IndirectionTableModel.IndirectionTable.t(self#0), 
                        it#0, 
                        $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#0, predCount#0))); 
                    (var self'#1 := IndirectionTableModel.__default.FromHashMap(t#0, 
                          IndirectionTableModel.IndirectionTable.garbageQueue(self#0), 
                          IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
                          Lit(#Options.Option.None())); 
                      (var oldLoc#1 := IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#0)): DatatypeType); 
                        #_System._tuple#2._#Make2($Box(self'#1), $Box(oldLoc#1))))))))));

// definition axiom for IndirectionTableModel.__default.RemoveLoc for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.RemoveLoc($LS($ly), Lit(self#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.RemoveLoc#canCall(Lit(self#0), LitInt(ref#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(self#0)))
           && Lit(IndirectionTableModel.__default.TrackingGarbage(Lit(self#0)))
           && Map#Domain(IndirectionTableModel.IndirectionTable.graph(Lit(self#0)))[$Box(ref#0)])
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.FindSimpleIter#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          LitInt(ref#0))
         && (var it#1 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.FindSimpleIter, 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              LitInt(ref#0)); 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              it#1)
             && (var oldEntry#1 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  it#1); 
              IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)
                 && (var predCount#1 := IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType); 
                  IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType)
                     && (var succs#1 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType); 
                      IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                         && MutableMapModel.__default.UpdateByIter#canCall(Tclass.IndirectionTableModel.Entry(), 
                          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                          it#1, 
                          $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#1, predCount#1)))
                         && (var t#1 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                              StartFuel_MutableMapModel._default.UpdateByIter, 
                              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                              it#1, 
                              $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#1, predCount#1))); 
                          IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                             && IndirectionTableModel.__default.FromHashMap#canCall(t#1, 
                              Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))), 
                              LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
                              Lit(#Options.Option.None()))
                             && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType))))))
         && IndirectionTableModel.__default.RemoveLoc($LS($ly), Lit(self#0), LitInt(ref#0))
           == (var it#1 := MutableMapModel.__default.FindSimpleIter(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.FindSimpleIter, 
                Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                LitInt(ref#0)); 
            (var oldEntry#1 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                  it#1); 
              (var predCount#1 := IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType); 
                (var succs#1 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType); 
                  (var t#1 := MutableMapModel.__default.UpdateByIter(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.UpdateByIter, 
                        Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                        it#1, 
                        $Box(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.None()), succs#1, predCount#1))); 
                    (var self'#2 := IndirectionTableModel.__default.FromHashMap(t#1, 
                          Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))), 
                          LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
                          Lit(#Options.Option.None())); 
                      (var oldLoc#2 := IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(oldEntry#1)): DatatypeType); 
                        #_System._tuple#2._#Make2($Box(self'#2), $Box(oldLoc#2))))))))));

// function declaration for IndirectionTableModel._default.ComputeRefCountsEntryIterate
function IndirectionTableModel.__default.ComputeRefCountsEntryIterate($ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int) : DatatypeType;

function IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0: DatatypeType, succs#0: Seq Box, i#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
  { IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t#0, succs#0, i#0) } 
  IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t#0, succs#0, i#0)
     == IndirectionTableModel.__default.ComputeRefCountsEntryIterate($ly, t#0, succs#0, i#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
  { IndirectionTableModel.__default.ComputeRefCountsEntryIterate(AsFuelBottom($ly), t#0, succs#0, i#0) } 
  IndirectionTableModel.__default.ComputeRefCountsEntryIterate($ly, t#0, succs#0, i#0)
     == IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LZ, t#0, succs#0, i#0));

// consequence axiom for IndirectionTableModel.__default.ComputeRefCountsEntryIterate
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
    { IndirectionTableModel.__default.ComputeRefCountsEntryIterate($ly, t#0, succs#0, i#0) } 
    IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0, succs#0, i#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(succs#0)
           && Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && MutableMapModel.LinearHashMap.count(t#0)
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall ref#0: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
                 <= 281474976710656 + i#0))
       ==> $Is(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($ly, t#0, succs#0, i#0), 
        Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))));

function IndirectionTableModel.__default.ComputeRefCountsEntryIterate#requires(LayerType, DatatypeType, Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.ComputeRefCountsEntryIterate
axiom (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
  { IndirectionTableModel.__default.ComputeRefCountsEntryIterate#requires($ly, t#0, succs#0, i#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.ComputeRefCountsEntryIterate#requires($ly, t#0, succs#0, i#0)
       == (
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && 
        LitInt(0) <= i#0
         && i#0 <= Seq#Length(succs#0)
         && Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren())
         && MutableMapModel.LinearHashMap.count(t#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize())
         && (forall ref#1: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
               <= 281474976710656 + i#0)));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsEntryIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
    { IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t#0, succs#0, i#0) } 
    IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0, succs#0, i#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && 
          LitInt(0) <= i#0
           && i#0 <= Seq#Length(succs#0)
           && Seq#Length(succs#0) <= LitInt(Bounds.__default.MaxNumChildren())
           && MutableMapModel.LinearHashMap.count(t#0)
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall ref#1: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                 <= 281474976710656 + i#0))
       ==> (i#0 != Seq#Length(succs#0)
           ==> (var ref#2 := $Unbox(Seq#Index(succs#0, i#0)): int; 
            MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), t#0, ref#2)
               && (var oldEntry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), t#0, ref#2); 
                Options.Option.Some_q(oldEntry#0)
                   ==> (var dt_update_tmp#0#0 := $Unbox(Options.Option.value(oldEntry#0)): DatatypeType; 
                      IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                         && 
                        IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0)
                         && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0))
                     && (var newEntry#0 := (var dt_update_tmp#0#0 := $Unbox(Options.Option.value(oldEntry#0)): DatatypeType; 
                          (var dt_update#predCount#0#0 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                                 + 1; 
                            #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                              IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                              dt_update#predCount#0#0))); 
                      MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), t#0, ref#2, $Box(newEntry#0))
                         && (var t0#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                              StartFuel_MutableMapModel._default.Insert, 
                              t#0, 
                              ref#2, 
                              $Box(newEntry#0)); 
                          IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#0, succs#0, i#0 + 1))))))
         && IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t#0, succs#0, i#0)
           == (if i#0 == Seq#Length(succs#0)
             then #Options.Option.Some($Box(t#0))
             else (var ref#2 := $Unbox(Seq#Index(succs#0, i#0)): int; 
              (var oldEntry#0 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), t#0, ref#2); 
                (if Options.Option.Some_q(oldEntry#0)
                   then (var newEntry#0 := (var dt_update_tmp#0#0 := $Unbox(Options.Option.value(oldEntry#0)): DatatypeType; 
                        (var dt_update#predCount#0#0 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                               + 1; 
                          #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                            IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                            dt_update#predCount#0#0))); 
                    (var t0#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.Insert, 
                          t#0, 
                          ref#2, 
                          $Box(newEntry#0)); 
                      IndirectionTableModel.__default.ComputeRefCountsEntryIterate($ly, t0#0, succs#0, i#0 + 1)))
                   else #Options.Option.None())))));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsEntryIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t#0, Lit(succs#0), LitInt(i#0)) } 
    IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0, Lit(succs#0), LitInt(i#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(succs#0))
           && Seq#Length(Lit(succs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           && MutableMapModel.LinearHashMap.count(t#0)
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall ref#3: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)] } 
            LitInt(0) <= ref#3
                 && ref#3 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
                 <= LitInt(281474976710656 + i#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(succs#0))
           ==> (var ref#4 := $Unbox(Seq#Index(Lit(succs#0), LitInt(i#0))): int; 
            MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), t#0, ref#4)
               && (var oldEntry#1 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), t#0, ref#4); 
                Options.Option.Some_q(oldEntry#1)
                   ==> (var dt_update_tmp#0#1 := $Unbox(Options.Option.value(oldEntry#1)): DatatypeType; 
                      IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                         && 
                        IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
                         && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1))
                     && (var newEntry#1 := (var dt_update_tmp#0#1 := $Unbox(Options.Option.value(oldEntry#1)): DatatypeType; 
                          (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                                 + 1; 
                            #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                              IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                              dt_update#predCount#0#1))); 
                      MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), t#0, ref#4, $Box(newEntry#1))
                         && (var t0#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                              StartFuel_MutableMapModel._default.Insert, 
                              t#0, 
                              ref#4, 
                              $Box(newEntry#1)); 
                          IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#1, Lit(succs#0), LitInt(i#0 + 1)))))))
         && IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t#0, Lit(succs#0), LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(succs#0))
             then #Options.Option.Some($Box(t#0))
             else (var ref#4 := $Unbox(Seq#Index(Lit(succs#0), LitInt(i#0))): int; 
              (var oldEntry#1 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), t#0, ref#4); 
                (if Options.Option.Some_q(oldEntry#1)
                   then (var newEntry#1 := (var dt_update_tmp#0#1 := $Unbox(Options.Option.value(oldEntry#1)): DatatypeType; 
                        (var dt_update#predCount#0#1 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                               + 1; 
                          #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                            IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                            dt_update#predCount#0#1))); 
                    (var t0#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.Insert, 
                          t#0, 
                          ref#4, 
                          $Box(newEntry#1)); 
                      IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t0#1, Lit(succs#0), LitInt(i#0 + 1))))
                   else #Options.Option.None())))));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsEntryIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, succs#0: Seq Box, i#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), Lit(t#0), Lit(succs#0), LitInt(i#0)) } 
    IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(Lit(t#0), Lit(succs#0), LitInt(i#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(succs#0, TSeq(Tclass.NativeTypes.uint64()))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= Seq#Length(Lit(succs#0))
           && Seq#Length(Lit(succs#0)) <= LitInt(Bounds.__default.MaxNumChildren())
           && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall ref#5: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
            LitInt(0) <= ref#5
                 && ref#5 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#5)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#5)]): DatatypeType)
                 <= LitInt(281474976710656 + i#0)))
       ==> (LitInt(i#0) != Seq#Length(Lit(succs#0))
           ==> (var ref#6 := $Unbox(Seq#Index(Lit(succs#0), LitInt(i#0))): int; 
            MutableMapModel.__default.Get#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), ref#6)
               && (var oldEntry#2 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), Lit(t#0), ref#6); 
                Options.Option.Some_q(oldEntry#2)
                   ==> (var dt_update_tmp#0#2 := $Unbox(Options.Option.value(oldEntry#2)): DatatypeType; 
                      IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#2)): DatatypeType)
                         && 
                        IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#2)
                         && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#2))
                     && (var newEntry#2 := (var dt_update_tmp#0#2 := $Unbox(Options.Option.value(oldEntry#2)): DatatypeType; 
                          (var dt_update#predCount#0#2 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#2)): DatatypeType)
                                 + 1; 
                            #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#2), 
                              IndirectionTableModel.Entry.succs(dt_update_tmp#0#2), 
                              dt_update#predCount#0#2))); 
                      MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), ref#6, $Box(newEntry#2))
                         && (var t0#2 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                              StartFuel_MutableMapModel._default.Insert, 
                              Lit(t#0), 
                              ref#6, 
                              $Box(newEntry#2)); 
                          IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t0#2, Lit(succs#0), LitInt(i#0 + 1)))))))
         && IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), Lit(t#0), Lit(succs#0), LitInt(i#0))
           == (if LitInt(i#0) == Seq#Length(Lit(succs#0))
             then #Options.Option.Some($Box(Lit(t#0)))
             else (var ref#6 := $Unbox(Seq#Index(Lit(succs#0), LitInt(i#0))): int; 
              (var oldEntry#2 := MutableMapModel.__default.Get(Tclass.IndirectionTableModel.Entry(), Lit(t#0), ref#6); 
                (if Options.Option.Some_q(oldEntry#2)
                   then (var newEntry#2 := (var dt_update_tmp#0#2 := $Unbox(Options.Option.value(oldEntry#2)): DatatypeType; 
                        (var dt_update#predCount#0#2 := IndirectionTableModel.Entry.predCount($Unbox(Options.Option.value(oldEntry#2)): DatatypeType)
                               + 1; 
                          #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#2), 
                            IndirectionTableModel.Entry.succs(dt_update_tmp#0#2), 
                            dt_update#predCount#0#2))); 
                    (var t0#2 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.Insert, 
                          Lit(t#0), 
                          ref#6, 
                          $Box(newEntry#2)); 
                      IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($ly), t0#2, Lit(succs#0), LitInt(i#0 + 1))))
                   else #Options.Option.None())))));

// function declaration for IndirectionTableModel._default.ComputeRefCountsIterateInv
function IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType) : bool;

function IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.ComputeRefCountsIterateInv
axiom true
   ==> (forall t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0) } 
    IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry())))
       ==> true);

function IndirectionTableModel.__default.ComputeRefCountsIterateInv#requires(DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.ComputeRefCountsIterateInv
axiom (forall t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.ComputeRefCountsIterateInv#requires(t#0, copy#0, it#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(copy#0, 
        Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv#requires(t#0, copy#0, it#0)
       == true);

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsIterateInv(revealed)
axiom true
   ==> (forall t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0) } 
    IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry())))
       ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), t#0)
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), copy#0))
         && (MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), copy#0)
             && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), copy#0)
           ==> MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), copy#0, it#0))
         && (MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), copy#0, it#0)
             && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), copy#0, it#0)
           ==> (forall ref#0: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0))))
         && ((forall ref#0: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)))
             && (forall ref#0: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)])
           ==> (forall ref#1: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]
                   ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))
                     && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType))
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType))))
         && ((forall ref#1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]
                     ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))
                       && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType))
                       && 
                      MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
                       && 
                      MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType)))
             && (forall ref#1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]
                 ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType), 
                  IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType)))
           ==> (forall ref#2: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)] } 
            LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType))))
         && ((forall ref#2: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)] } 
              LitInt(0) <= ref#2 && ref#2 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)
                       && 
                      MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType)))
             && (forall ref#2: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)] } 
              LitInt(0) <= ref#2
                   && ref#2 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]
                 ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType), 
                  IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType)))
           ==> (forall ref#3: int :: 
            { IndirectionTableModel.__default.IsRoot(ref#3) } 
              { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                ref#3, 
                MutableMapModel.Iterator.s(it#0)) } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)] } 
            LitInt(0) <= ref#3 && ref#3 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
                     && 
                    IndirectionTableModel.__default.Graph#canCall(copy#0)
                     && MutableMapModel.Iterator.Iterator_q(it#0)
                     && IndirectionTableModel.__default.PredecessorSetRestricted#canCall(IndirectionTableModel.__default.Graph(copy#0), 
                      ref#3, 
                      MutableMapModel.Iterator.s(it#0))
                     && IndirectionTableModel.__default.IsRoot#canCall(ref#3))))
         && ((forall ref#3: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#3) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#3, 
                  MutableMapModel.Iterator.s(it#0)) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3 && ref#3 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
                       && 
                      IndirectionTableModel.__default.Graph#canCall(copy#0)
                       && MutableMapModel.Iterator.Iterator_q(it#0)
                       && IndirectionTableModel.__default.PredecessorSetRestricted#canCall(IndirectionTableModel.__default.Graph(copy#0), 
                        ref#3, 
                        MutableMapModel.Iterator.s(it#0))
                       && IndirectionTableModel.__default.IsRoot#canCall(ref#3)))
             && (forall ref#3: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#3) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#3, 
                  MutableMapModel.Iterator.s(it#0)) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
                   == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                        ref#3, 
                        MutableMapModel.Iterator.s(it#0)))
                     + IndirectionTableModel.__default.IsRoot(ref#3))
           ==> (forall ref#4: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)] } 
            LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType)
                     && Bounds.__default.MaxNumChildren#canCall())))
         && ((forall ref#4: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4 && ref#4 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType)
                       && Bounds.__default.MaxNumChildren#canCall()))
             && (forall ref#4: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]
                 ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType))
                   <= LitInt(Bounds.__default.MaxNumChildren()))
           ==> (forall ref#5: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
            LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0))))
         && ((forall ref#5: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
              LitInt(0) <= ref#5 && ref#5 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)))
             && (forall ref#5: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
              LitInt(0) <= ref#5
                   && ref#5 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)])
           ==> IndirectionTableModel.__default.Graph#canCall(copy#0)
             && MutableMapModel.Iterator.Iterator_q(it#0)
             && IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0)))
         && (IndirectionTableModel.__default.Graph#canCall(copy#0)
             && MutableMapModel.Iterator.Iterator_q(it#0)
             && IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
             && IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
             && MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0))
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
             && MutableMapModel.LinearHashMap.LinearHashMap_q(copy#0)
             && MutableMapModel.LinearHashMap.count(t#0)
               == MutableMapModel.LinearHashMap.count(copy#0)
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
             && IndirectionTableModel.__default.MaxSize#canCall())
         && IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
             && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), copy#0)
             && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), copy#0, it#0)
             && (forall ref#0: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)])
             && (forall ref#1: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]
                 ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType), 
                  IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType)))
             && (forall ref#2: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)] } 
              LitInt(0) <= ref#2
                   && ref#2 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]
                 ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType), 
                  IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType)))
             && (forall ref#3: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#3) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#3, 
                  MutableMapModel.Iterator.s(it#0)) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)] } 
              LitInt(0) <= ref#3
                   && ref#3 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
                   == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                        ref#3, 
                        MutableMapModel.Iterator.s(it#0)))
                     + IndirectionTableModel.__default.IsRoot(ref#3))
             && (forall ref#4: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)] } 
              LitInt(0) <= ref#4
                   && ref#4 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]
                 ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType))
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && (forall ref#5: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
              LitInt(0) <= ref#5
                   && ref#5 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)])
             && IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
             && MutableMapModel.LinearHashMap.count(t#0)
               == MutableMapModel.LinearHashMap.count(copy#0)
             && MutableMapModel.LinearHashMap.count(t#0)
               <= LitInt(IndirectionTableModel.__default.MaxSize())));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsIterateInv for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.ComputeRefCountsIterateInv(Lit(t#0), Lit(copy#0), Lit(it#0)) } 
    IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(Lit(t#0), Lit(copy#0), Lit(it#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry())))
       ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
         && (MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           ==> MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), Lit(copy#0)))
         && (MutableMapModel.__default.Inv#canCall(Tclass.IndirectionTableModel.Entry(), Lit(copy#0))
             && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(copy#0))
           ==> MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), Lit(copy#0), Lit(it#0)))
         && (MutableMapModel.__default.WFIter#canCall(Tclass.IndirectionTableModel.Entry(), Lit(copy#0), Lit(it#0))
             && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), Lit(copy#0), Lit(it#0))
           ==> (forall ref#6: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#6)] } 
            LitInt(0) <= ref#6 && ref#6 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#6)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0)))))
         && ((forall ref#6: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#6)] } 
              LitInt(0) <= ref#6 && ref#6 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#6)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))))
             && (forall ref#6: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#6)] } 
              LitInt(0) <= ref#6
                   && ref#6 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#6)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#6)])
           ==> (forall ref#7: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)] } 
            LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#7)]
                   ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType))
                     && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#7)]): DatatypeType))
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#7)]): DatatypeType))))
         && ((forall ref#7: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#7)]
                     ==> $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType))
                       && $IsA#Options.Option(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#7)]): DatatypeType))
                       && 
                      MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType)
                       && 
                      MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#7)]): DatatypeType)))
             && (forall ref#7: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#7)]
                 ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType), 
                  IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#7)]): DatatypeType)))
           ==> (forall ref#8: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)]): DatatypeType } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)] } 
            LitInt(0) <= ref#8 && ref#8 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#8)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType)
                     && 
                    MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#8)]): DatatypeType))))
         && ((forall ref#8: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)] } 
              LitInt(0) <= ref#8 && ref#8 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#8)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType)
                       && 
                      MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#8)]): DatatypeType)))
             && (forall ref#8: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)] } 
              LitInt(0) <= ref#8
                   && ref#8 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#8)]
                 ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType), 
                  IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#8)]): DatatypeType)))
           ==> (forall ref#9: int :: 
            { IndirectionTableModel.__default.IsRoot(ref#9) } 
              { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                ref#9, 
                MutableMapModel.Iterator.s(it#0)) } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#9)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)] } 
            LitInt(0) <= ref#9 && ref#9 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#9)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#9)]): DatatypeType)
                     && 
                    IndirectionTableModel.__default.Graph#canCall(Lit(copy#0))
                     && MutableMapModel.Iterator.Iterator_q(Lit(it#0))
                     && IndirectionTableModel.__default.PredecessorSetRestricted#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
                      ref#9, 
                      Lit(MutableMapModel.Iterator.s(Lit(it#0))))
                     && IndirectionTableModel.__default.IsRoot#canCall(ref#9))))
         && ((forall ref#9: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#9) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#9, 
                  MutableMapModel.Iterator.s(it#0)) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#9)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)] } 
              LitInt(0) <= ref#9 && ref#9 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#9)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#9)]): DatatypeType)
                       && 
                      IndirectionTableModel.__default.Graph#canCall(Lit(copy#0))
                       && MutableMapModel.Iterator.Iterator_q(Lit(it#0))
                       && IndirectionTableModel.__default.PredecessorSetRestricted#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
                        ref#9, 
                        Lit(MutableMapModel.Iterator.s(Lit(it#0))))
                       && IndirectionTableModel.__default.IsRoot#canCall(ref#9)))
             && (forall ref#9: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#9) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#9, 
                  MutableMapModel.Iterator.s(it#0)) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#9)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)] } 
              LitInt(0) <= ref#9
                   && ref#9 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#9)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#9)]): DatatypeType)
                   == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
                        ref#9, 
                        Lit(MutableMapModel.Iterator.s(Lit(it#0)))))
                     + IndirectionTableModel.__default.IsRoot(ref#9))
           ==> (forall ref#10: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)] } 
            LitInt(0) <= ref#10 && ref#10 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#10)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#10)]): DatatypeType)
                     && Bounds.__default.MaxNumChildren#canCall())))
         && ((forall ref#10: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)] } 
              LitInt(0) <= ref#10 && ref#10 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#10)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#10)]): DatatypeType)
                       && Bounds.__default.MaxNumChildren#canCall()))
             && (forall ref#10: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)] } 
              LitInt(0) <= ref#10
                   && ref#10 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#10)]
                 ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#10)]): DatatypeType))
                   <= LitInt(Bounds.__default.MaxNumChildren()))
           ==> (forall ref#11: int :: 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#11)] } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#11)] } 
            LitInt(0) <= ref#11 && ref#11 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#11)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0)))))
         && ((forall ref#11: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#11)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#11)] } 
              LitInt(0) <= ref#11 && ref#11 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#11)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))))
             && (forall ref#11: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#11)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#11)] } 
              LitInt(0) <= ref#11
                   && ref#11 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#11)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#11)])
           ==> IndirectionTableModel.__default.Graph#canCall(Lit(copy#0))
             && MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.__default.GraphClosedRestricted#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
              Lit(MutableMapModel.Iterator.s(Lit(it#0)))))
         && (IndirectionTableModel.__default.Graph#canCall(Lit(copy#0))
             && MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.__default.GraphClosedRestricted#canCall(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
              Lit(MutableMapModel.Iterator.s(Lit(it#0))))
             && Lit(IndirectionTableModel.__default.GraphClosedRestricted(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
                Lit(MutableMapModel.Iterator.s(Lit(it#0)))))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0)))
         && (MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(copy#0))
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               == LitInt(MutableMapModel.LinearHashMap.count(Lit(copy#0)))
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
             && IndirectionTableModel.__default.MaxSize#canCall())
         && IndirectionTableModel.__default.ComputeRefCountsIterateInv(Lit(t#0), Lit(copy#0), Lit(it#0))
           == (
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
             && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(copy#0))
             && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), Lit(copy#0), Lit(it#0))
             && (forall ref#6: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#6)] } 
              LitInt(0) <= ref#6
                   && ref#6 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#6)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#6)])
             && (forall ref#7: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#7)] } 
              LitInt(0) <= ref#7
                   && ref#7 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#7)]
                 ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#7)]): DatatypeType), 
                  IndirectionTableModel.Entry.loc($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#7)]): DatatypeType)))
             && (forall ref#8: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#8)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)] } 
              LitInt(0) <= ref#8
                   && ref#8 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#8)]
                 ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#8)]): DatatypeType), 
                  IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#8)]): DatatypeType)))
             && (forall ref#9: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#9) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#9, 
                  MutableMapModel.Iterator.s(it#0)) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#9)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)] } 
              LitInt(0) <= ref#9
                   && ref#9 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#9)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#9)]): DatatypeType)
                   == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
                        ref#9, 
                        Lit(MutableMapModel.Iterator.s(Lit(it#0)))))
                     + IndirectionTableModel.__default.IsRoot(ref#9))
             && (forall ref#10: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)] } 
              LitInt(0) <= ref#10
                   && ref#10 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#10)]
                 ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(copy#0))))[$Box(ref#10)]): DatatypeType))
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && (forall ref#11: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#11)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#11)] } 
              LitInt(0) <= ref#11
                   && ref#11 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#11)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(copy#0)))[$Box(ref#11)])
             && IndirectionTableModel.__default.GraphClosedRestricted(Lit(IndirectionTableModel.__default.Graph(Lit(copy#0))), 
              Lit(MutableMapModel.Iterator.s(Lit(it#0))))
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               == LitInt(MutableMapModel.LinearHashMap.count(Lit(copy#0)))
             && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
               <= LitInt(IndirectionTableModel.__default.MaxSize())));

procedure {:_induction t#0} CheckWellformed$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateStuff(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    copy#0: DatatypeType
       where $Is(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(copy#0), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(it#0, 
          Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.Iterator(it#0));
  free requires 69 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction t#0} Call$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateStuff(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    copy#0: DatatypeType
       where $Is(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(copy#0), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(it#0, 
          Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.Iterator(it#0));
  // user-defined preconditions
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), copy#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), copy#0, it#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#0: int :: 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)] } 
        LitInt(0) <= ref#0
             && ref#0 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#1: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)] } 
        LitInt(0) <= ref#1
             && ref#1 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]
           ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType), 
            IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType)));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#2: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)] } 
        LitInt(0) <= ref#2
             && ref#2 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]
           ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType), 
            IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType)));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#3: int :: 
        { IndirectionTableModel.__default.IsRoot(ref#3) } 
          { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
            ref#3, 
            MutableMapModel.Iterator.s(it#0)) } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)] } 
        LitInt(0) <= ref#3
             && ref#3 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)]
           ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
             == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#3, 
                  MutableMapModel.Iterator.s(it#0)))
               + IndirectionTableModel.__default.IsRoot(ref#3));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#4: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)] } 
        LitInt(0) <= ref#4
             && ref#4 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]
           ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType))
             <= LitInt(Bounds.__default.MaxNumChildren()));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#5: int :: 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)] } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
        LitInt(0) <= ref#5
             && ref#5 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)]);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
         ==> IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
           || (forall ref#6: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box } 
              { MutableMapModel.Iterator.s(it#0)[$Box(ref#6)] } 
            LitInt(0) <= ref#6
                 && ref#6 < 18446744073709551616
                 && 
                Map#Domain(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]
                 && MutableMapModel.Iterator.s(it#0)[$Box(ref#6)]
               ==> (forall i#0: int :: 
                { $Unbox(Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box, 
                      i#0)): int } 
                LitInt(0) <= i#0
                     && i#0
                       < Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box)
                   ==> Map#Domain(IndirectionTableModel.__default.Graph(copy#0))[Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box, 
                    i#0)])));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.LinearHashMap.count(t#0)
         == MutableMapModel.LinearHashMap.count(copy#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.LinearHashMap.count(t#0)
         <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures (forall ref#7: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
    LitInt(0) <= ref#7 && ref#7 < 18446744073709551616
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
         && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]
           ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
             && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType)));
  ensures (forall ref#7: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
    LitInt(0) <= ref#7
         && ref#7 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]
       ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)]): DatatypeType)
         <= LitInt(281474976710656));
  free ensures MutableMapModel.Iterator.Iterator_q(it#0)
     && (MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
         && (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType); 
          IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0, succs#0, LitInt(0))
             && (var t0#0 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t#0, succs#0, LitInt(0)); 
              (Options.Option.Some_q(t0#0)
                   ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), copy#0, it#0)
                     && IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall($Unbox(Options.Option.value(t0#0)): DatatypeType, 
                      copy#0, 
                      MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.IterInc, 
                        copy#0, 
                        it#0)))
                 && (
                  (Options.Option.Some_q(t0#0)
                   ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv($Unbox(Options.Option.value(t0#0)): DatatypeType, 
                    copy#0, 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      copy#0, 
                      it#0)))
                   ==> 
                  Options.Option.None_q(t0#0)
                   ==> IndirectionTableModel.__default.Graph#canCall(copy#0)
                     && BlockCache.__default.GraphClosed#canCall(IndirectionTableModel.__default.Graph(copy#0))))));
  free ensures MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
     ==> (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType); 
      (var t0#0 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LS($LZ)), t#0, succs#0, LitInt(0)); 
        Options.Option.Some_q(t0#0)
           ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall($Unbox(Options.Option.value(t0#0)): DatatypeType, 
              copy#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                copy#0, 
                it#0))
             && 
            IndirectionTableModel.__default.ComputeRefCountsIterateInv($Unbox(Options.Option.value(t0#0)): DatatypeType, 
              copy#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                copy#0, 
                it#0))
             && 
            MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
              $Unbox(Options.Option.value(t0#0)): DatatypeType)
             && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), copy#0)
             && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
              copy#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                copy#0, 
                it#0))
             && (forall ref#8: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#8)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)] } 
              LitInt(0) <= ref#8
                   && ref#8 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#8)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#8)])
             && (forall ref#9: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#9)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)] } 
              LitInt(0) <= ref#9
                   && ref#9 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)]
                 ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#9)]): DatatypeType), 
                  IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#9)]): DatatypeType)))
             && (forall ref#10: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]): DatatypeType } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#10)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)] } 
              LitInt(0) <= ref#10
                   && ref#10 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]
                 ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#10)]): DatatypeType), 
                  IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#10)]): DatatypeType)))
             && (forall ref#11: int :: 
              { IndirectionTableModel.__default.IsRoot(ref#11) } 
                { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#11, 
                  MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      copy#0, 
                      it#0))) } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#11)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#11)] } 
              LitInt(0) <= ref#11
                   && ref#11 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#11)]
                 ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#11)]): DatatypeType)
                   == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                        ref#11, 
                        MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                            StartFuel_MutableMapModel._default.IterInc, 
                            copy#0, 
                            it#0))))
                     + IndirectionTableModel.__default.IsRoot(ref#11))
             && (forall ref#12: int :: 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#12)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#12)] } 
              LitInt(0) <= ref#12
                   && ref#12 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#12)]
                 ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#12)]): DatatypeType))
                   <= LitInt(Bounds.__default.MaxNumChildren()))
             && (forall ref#13: int :: 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#13)] } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#13)] } 
              LitInt(0) <= ref#13
                   && ref#13 < 18446744073709551616
                   && Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(t0#0)): DatatypeType))[$Box(ref#13)]
                 ==> Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#13)])
             && IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(copy#0), 
              MutableMapModel.Iterator.s(MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.IterInc, 
                  copy#0, 
                  it#0)))
             && MutableMapModel.LinearHashMap.count($Unbox(Options.Option.value(t0#0)): DatatypeType)
               == MutableMapModel.LinearHashMap.count(copy#0)
             && MutableMapModel.LinearHashMap.count($Unbox(Options.Option.value(t0#0)): DatatypeType)
               <= LitInt(IndirectionTableModel.__default.MaxSize())));
  ensures MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
     ==> (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType); 
      (var t0#0 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LS($LZ)), t#0, succs#0, LitInt(0)); 
        Options.Option.None_q(t0#0)
           ==> !BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(copy#0))));
  // frame condition
  free ensures old($Heap) == $Heap;



procedure CheckWellformed$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateValidPredCounts(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    copy#0: DatatypeType
       where $Is(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(copy#0), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(it#0, 
          Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.Iterator(it#0));
  free requires 70 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateValidPredCounts(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0), 
    copy#0: DatatypeType
       where $Is(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(copy#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(copy#0), 
    it#0: DatatypeType
       where $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(it#0, 
          Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.Iterator(it#0));
  // user-defined preconditions
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), copy#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), copy#0, it#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#0: int :: 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)] } 
        LitInt(0) <= ref#0
             && ref#0 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#0)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#1: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)] } 
        LitInt(0) <= ref#1
             && ref#1 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]
           ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType), 
            IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#1)]): DatatypeType)));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#2: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)] } 
        LitInt(0) <= ref#2
             && ref#2 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]
           ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType), 
            IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#2)]): DatatypeType)));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#3: int :: 
        { IndirectionTableModel.__default.IsRoot(ref#3) } 
          { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
            ref#3, 
            MutableMapModel.Iterator.s(it#0)) } 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)] } 
        LitInt(0) <= ref#3
             && ref#3 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#3)]
           ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)
             == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(copy#0), 
                  ref#3, 
                  MutableMapModel.Iterator.s(it#0)))
               + IndirectionTableModel.__default.IsRoot(ref#3));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#4: int :: 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)] } 
        LitInt(0) <= ref#4
             && ref#4 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]
           ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#4)]): DatatypeType))
             <= LitInt(Bounds.__default.MaxNumChildren()));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (forall ref#5: int :: 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)] } 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
        LitInt(0) <= ref#5
             && ref#5 < 18446744073709551616
             && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents(copy#0))[$Box(ref#5)]);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || (IndirectionTableModel.__default.GraphClosedRestricted#canCall(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
         ==> IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(copy#0), MutableMapModel.Iterator.s(it#0))
           || (forall ref#6: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box } 
              { MutableMapModel.Iterator.s(it#0)[$Box(ref#6)] } 
            LitInt(0) <= ref#6
                 && ref#6 < 18446744073709551616
                 && 
                Map#Domain(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]
                 && MutableMapModel.Iterator.s(it#0)[$Box(ref#6)]
               ==> (forall i#0: int :: 
                { $Unbox(Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box, 
                      i#0)): int } 
                LitInt(0) <= i#0
                     && i#0
                       < Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box)
                   ==> Map#Domain(IndirectionTableModel.__default.Graph(copy#0))[Seq#Index($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(copy#0))[$Box(ref#6)]): Seq Box, 
                    i#0)])));
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.LinearHashMap.count(t#0)
         == MutableMapModel.LinearHashMap.count(copy#0);
  requires IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t#0, copy#0, it#0)
     ==> IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
       || MutableMapModel.LinearHashMap.count(t#0)
         <= LitInt(IndirectionTableModel.__default.MaxSize());
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMapModel.Iterator.Iterator_q(it#0)
     && (MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
       ==> IndirectionTableModel.__default.PredCounts#canCall(t#0)
         && IndirectionTableModel.__default.Graph#canCall(t#0)
         && IndirectionTableModel.__default.ValidPredCounts#canCall(IndirectionTableModel.__default.PredCounts(t#0), 
          IndirectionTableModel.__default.Graph(t#0)));
  free ensures MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
     ==> IndirectionTableModel.__default.ValidPredCounts#canCall(IndirectionTableModel.__default.PredCounts(t#0), 
        IndirectionTableModel.__default.Graph(t#0))
       && 
      IndirectionTableModel.__default.ValidPredCounts(IndirectionTableModel.__default.PredCounts(t#0), 
        IndirectionTableModel.__default.Graph(t#0))
       && (forall ref#7: int :: 
        { IndirectionTableModel.__default.IsRoot(ref#7) } 
          { IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(t#0), ref#7) } 
          { $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#7)]): int } 
          { Map#Domain(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#7)] } 
        LitInt(0) <= ref#7
             && ref#7 < 18446744073709551616
             && Map#Domain(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#7)]
           ==> $Unbox(Map#Elements(IndirectionTableModel.__default.PredCounts(t#0))[$Box(ref#7)]): int
             == Set#Card(IndirectionTableModel.__default.PredecessorSet(IndirectionTableModel.__default.Graph(t#0), ref#7))
               + IndirectionTableModel.__default.IsRoot(ref#7));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.ComputeRefCountsIterate
function IndirectionTableModel.__default.ComputeRefCountsIterate($ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType)
   : DatatypeType;

function IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), t#0, copy#0, it#0) } 
  IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), t#0, copy#0, it#0)
     == IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.ComputeRefCountsIterate(AsFuelBottom($ly), t#0, copy#0, it#0) } 
  IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0)
     == IndirectionTableModel.__default.ComputeRefCountsIterate($LZ, t#0, copy#0, it#0));

// consequence axiom for IndirectionTableModel.__default.ComputeRefCountsIterate
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0) } 
    IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t#0, copy#0, it#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())])
       ==> (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))
           ==> MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), 
            $Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))): DatatypeType))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))
           <==> BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(copy#0)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))
           ==> Map#Equal(IndirectionTableModel.__default.Graph(copy#0), 
            IndirectionTableModel.__default.Graph($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))
           ==> Map#Equal(IndirectionTableModel.__default.Locs(copy#0), 
            IndirectionTableModel.__default.Locs($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))
           ==> IndirectionTableModel.__default.ValidPredCounts(IndirectionTableModel.__default.PredCounts($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))): DatatypeType), 
            IndirectionTableModel.__default.Graph($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0))): DatatypeType))[$Box(PivotBetreeGraph.__default.Root())])
         && $Is(IndirectionTableModel.__default.ComputeRefCountsIterate($ly, t#0, copy#0, it#0), 
          Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))));

function IndirectionTableModel.__default.ComputeRefCountsIterate#requires(LayerType, DatatypeType, DatatypeType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.ComputeRefCountsIterate
axiom (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.ComputeRefCountsIterate#requires($ly, t#0, copy#0, it#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(copy#0, 
        Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.ComputeRefCountsIterate#requires($ly, t#0, copy#0, it#0)
       == (IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())]));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), t#0, copy#0, it#0) } 
    IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t#0, copy#0, it#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, it#0)
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())])
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && (!MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
           ==> MutableMapModel.Iterator.Iterator_q(it#0)
             && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
             && (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType); 
              IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0, succs#0, LitInt(0))
                 && (var t0#0 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t#0, succs#0, LitInt(0)); 
                  Options.Option.Some_q(t0#0)
                     ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), copy#0, it#0)
                       && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall($Unbox(Options.Option.value(t0#0)): DatatypeType, 
                        copy#0, 
                        MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.IterInc, 
                          copy#0, 
                          it#0)))))
         && IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), t#0, copy#0, it#0)
           == (if MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
             then #Options.Option.Some($Box(t#0))
             else (var succs#0 := IndirectionTableModel.Entry.succs($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType); 
              (var t0#0 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t#0, succs#0, LitInt(0)); 
                (if Options.Option.Some_q(t0#0)
                   then IndirectionTableModel.__default.ComputeRefCountsIterate($ly, 
                    $Unbox(Options.Option.value(t0#0)): DatatypeType, 
                    copy#0, 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      copy#0, 
                      it#0))
                   else #Options.Option.None())))));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), t#0, copy#0, Lit(it#0)) } 
    IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t#0, copy#0, Lit(it#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          IndirectionTableModel.__default.ComputeRefCountsIterateInv(t#0, copy#0, Lit(it#0))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())])
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.Entry.Entry_q(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))
             && (var succs#1 := Lit(IndirectionTableModel.Entry.succs(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))); 
              IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(t#0, succs#1, LitInt(0))
                 && (var t0#1 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t#0, succs#1, LitInt(0)); 
                  Options.Option.Some_q(t0#1)
                     ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), copy#0, Lit(it#0))
                       && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall($Unbox(Options.Option.value(t0#1)): DatatypeType, 
                        copy#0, 
                        MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.IterInc, 
                          copy#0, 
                          Lit(it#0))))))
         && IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), t#0, copy#0, Lit(it#0))
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then #Options.Option.Some($Box(t#0))
             else (var succs#1 := Lit(IndirectionTableModel.Entry.succs(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))); 
              (var t0#1 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), t#0, succs#1, LitInt(0)); 
                (if Options.Option.Some_q(t0#1)
                   then IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), 
                    $Unbox(Options.Option.value(t0#1)): DatatypeType, 
                    copy#0, 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      copy#0, 
                      Lit(it#0)))
                   else #Options.Option.None())))));

// definition axiom for IndirectionTableModel.__default.ComputeRefCountsIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, copy#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), Lit(t#0), Lit(copy#0), Lit(it#0)) } 
    IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(Lit(t#0), Lit(copy#0), Lit(it#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(copy#0, 
            Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          Lit(IndirectionTableModel.__default.ComputeRefCountsIterateInv(Lit(t#0), Lit(copy#0), Lit(it#0)))
           && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(PivotBetreeGraph.__default.Root())])
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.Entry.Entry_q(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))
             && (var succs#2 := Lit(IndirectionTableModel.Entry.succs(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))); 
              IndirectionTableModel.__default.ComputeRefCountsEntryIterate#canCall(Lit(t#0), succs#2, LitInt(0))
                 && (var t0#2 := IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), Lit(t#0), succs#2, LitInt(0)); 
                  Options.Option.Some_q(t0#2)
                     ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), Lit(copy#0), Lit(it#0))
                       && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall($Unbox(Options.Option.value(t0#2)): DatatypeType, 
                        Lit(copy#0), 
                        MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                          StartFuel_MutableMapModel._default.IterInc, 
                          Lit(copy#0), 
                          Lit(it#0))))))
         && IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), Lit(t#0), Lit(copy#0), Lit(it#0))
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then #Options.Option.Some($Box(Lit(t#0)))
             else (var succs#2 := Lit(IndirectionTableModel.Entry.succs(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))); 
              (var t0#2 := Lit(IndirectionTableModel.__default.ComputeRefCountsEntryIterate($LS($LZ), Lit(t#0), succs#2, LitInt(0))); 
                (if Options.Option.Some_q(t0#2)
                   then IndirectionTableModel.__default.ComputeRefCountsIterate($LS($ly), 
                    Lit($Unbox(Options.Option.value(t0#2)): DatatypeType), 
                    Lit(copy#0), 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      Lit(copy#0), 
                      Lit(it#0)))
                   else #Options.Option.None())))));

procedure CheckWellformed$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateInvInit(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0));
  free requires 72 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.LemmaComputeRefCountsIterateInvInit(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0));
  // user-defined preconditions
  requires MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  requires (forall ref#0: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
    LitInt(0) <= ref#0
         && ref#0 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
       ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
         == LitInt(0));
  requires (forall ref#1: int :: 
    { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
      { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
    LitInt(0) <= ref#1
         && ref#1 < 18446744073709551616
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
       ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))
         <= LitInt(Bounds.__default.MaxNumChildren()));
  requires MutableMapModel.LinearHashMap.count(t#0)
     <= LitInt(IndirectionTableModel.__default.MaxSize());
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())];
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
     && PivotBetreeGraph.__default.Root#canCall()
     && (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): DatatypeType; 
      PivotBetreeGraph.__default.Root#canCall()
         && (var dt_update_tmp#0#0 := oldEntry#0; 
          IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0)
             && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0))
         && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
          t#0, 
          LitInt(PivotBetreeGraph.__default.Root()), 
          $Box((var dt_update_tmp#0#0 := oldEntry#0; 
              (var dt_update#predCount#0#0 := LitInt(1); 
                #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                  IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                  dt_update#predCount#0#0)))))
         && (var t0#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.Insert, 
              t#0, 
              LitInt(PivotBetreeGraph.__default.Root()), 
              $Box((var dt_update_tmp#0#0 := oldEntry#0; 
                  (var dt_update#predCount#0#0 := LitInt(1); 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                      dt_update#predCount#0#0))))); 
          MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), t#0)
             && IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t0#0, 
              t#0, 
              MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterStart, 
                t#0))));
  free ensures (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): DatatypeType; 
    (var t0#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
          StartFuelAssert_MutableMapModel._default.Insert, 
          t#0, 
          LitInt(PivotBetreeGraph.__default.Root()), 
          $Box((var dt_update_tmp#0#0 := oldEntry#0; 
              (var dt_update#predCount#0#0 := LitInt(1); 
                #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                  IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                  dt_update#predCount#0#0))))); 
      IndirectionTableModel.__default.ComputeRefCountsIterateInv#canCall(t0#0, 
          t#0, 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            t#0))
         && 
        IndirectionTableModel.__default.ComputeRefCountsIterateInv(t0#0, 
          t#0, 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            t#0))
         && 
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t0#0)
         && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
          t#0, 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            t#0))
         && (forall ref#2: int :: 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#2)] } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
          LitInt(0) <= ref#2
               && ref#2 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#2)])
         && (forall ref#3: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#3)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)] } 
          LitInt(0) <= ref#3
               && ref#3 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]
             ==> Options.Option#Equal(IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#3)]): DatatypeType), 
              IndirectionTableModel.Entry.loc($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType)))
         && (forall ref#4: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#4)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
          LitInt(0) <= ref#4
               && ref#4 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]
             ==> Seq#Equal(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#4)]): DatatypeType), 
              IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType)))
         && (forall ref#5: int :: 
          { IndirectionTableModel.__default.IsRoot(ref#5) } 
            { IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(t#0), 
              ref#5, 
              MutableMapModel.Iterator.s(MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.IterStart, 
                  t#0))) } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#5)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
          LitInt(0) <= ref#5
               && ref#5 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#5)]): DatatypeType)
               == Set#Card(IndirectionTableModel.__default.PredecessorSetRestricted(IndirectionTableModel.__default.Graph(t#0), 
                    ref#5, 
                    MutableMapModel.Iterator.s(MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.IterStart, 
                        t#0))))
                 + IndirectionTableModel.__default.IsRoot(ref#5))
         && (forall ref#6: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)] } 
          LitInt(0) <= ref#6
               && ref#6 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)]
             ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#6)]): DatatypeType))
               <= LitInt(Bounds.__default.MaxNumChildren()))
         && (forall ref#7: int :: 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)] } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#7)] } 
          LitInt(0) <= ref#7
               && ref#7 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t0#0))[$Box(ref#7)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#7)])
         && IndirectionTableModel.__default.GraphClosedRestricted(IndirectionTableModel.__default.Graph(t#0), 
          MutableMapModel.Iterator.s(MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.IterStart, 
              t#0)))
         && MutableMapModel.LinearHashMap.count(t0#0)
           == MutableMapModel.LinearHashMap.count(t#0)
         && MutableMapModel.LinearHashMap.count(t0#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize())));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.ComputeRefCounts
function IndirectionTableModel.__default.ComputeRefCounts(t#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.ComputeRefCounts#canCall(t#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.ComputeRefCounts
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.ComputeRefCounts(t#0) } 
    IndirectionTableModel.__default.ComputeRefCounts#canCall(t#0)
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && (forall ref#0: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
                 == LitInt(0))
           && (forall ref#1: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
               ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))
                 <= LitInt(Bounds.__default.MaxNumChildren()))
           && MutableMapModel.LinearHashMap.count(t#0)
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())])
       ==> (BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t#0))
           <==> Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCounts(t#0)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCounts(t#0))
           ==> Map#Equal(IndirectionTableModel.__default.Graph(t#0), 
            IndirectionTableModel.__default.Graph($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCounts(t#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCounts(t#0))
           ==> Map#Equal(IndirectionTableModel.__default.Locs(t#0), 
            IndirectionTableModel.__default.Locs($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCounts(t#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCounts(t#0))
           ==> IndirectionTableModel.__default.ValidPredCounts(IndirectionTableModel.__default.PredCounts($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCounts(t#0))): DatatypeType), 
            IndirectionTableModel.__default.Graph($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCounts(t#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.ComputeRefCounts(t#0))
           ==> Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.ComputeRefCounts(t#0))): DatatypeType))[$Box(PivotBetreeGraph.__default.Root())])
         && $Is(IndirectionTableModel.__default.ComputeRefCounts(t#0), 
          Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))));

function IndirectionTableModel.__default.ComputeRefCounts#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.ComputeRefCounts
axiom (forall t#0: DatatypeType :: 
  { IndirectionTableModel.__default.ComputeRefCounts#requires(t#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.ComputeRefCounts#requires(t#0)
       == (
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && (forall ref#2: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
          LitInt(0) <= ref#2
               && ref#2 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
             ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)
               == LitInt(0))
         && (forall ref#3: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)] } 
          LitInt(0) <= ref#3
               && ref#3 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]
             ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType))
               <= LitInt(Bounds.__default.MaxNumChildren()))
         && MutableMapModel.LinearHashMap.count(t#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize())
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())]));

// definition axiom for IndirectionTableModel.__default.ComputeRefCounts(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.ComputeRefCounts(t#0) } 
    IndirectionTableModel.__default.ComputeRefCounts#canCall(t#0)
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && (forall ref#2: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)] } 
            LitInt(0) <= ref#2
                 && ref#2 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#2)]): DatatypeType)
                 == LitInt(0))
           && (forall ref#3: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)] } 
            LitInt(0) <= ref#3
                 && ref#3 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]
               ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#3)]): DatatypeType))
                 <= LitInt(Bounds.__default.MaxNumChildren()))
           && MutableMapModel.LinearHashMap.count(t#0)
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())])
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
         && PivotBetreeGraph.__default.Root#canCall()
         && (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): DatatypeType; 
          PivotBetreeGraph.__default.Root#canCall()
             && (var dt_update_tmp#0#0 := oldEntry#0; 
              IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#0))
             && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
              t#0, 
              LitInt(PivotBetreeGraph.__default.Root()), 
              $Box((var dt_update_tmp#0#0 := oldEntry#0; 
                  (var dt_update#predCount#0#0 := LitInt(1); 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                      dt_update#predCount#0#0)))))
             && (var t0#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  t#0, 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box((var dt_update_tmp#0#0 := oldEntry#0; 
                      (var dt_update#predCount#0#0 := LitInt(1); 
                        #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                          IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                          dt_update#predCount#0#0))))); 
              MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), t#0)
                 && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t0#0, 
                  t#0, 
                  MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterStart, 
                    t#0))))
         && IndirectionTableModel.__default.ComputeRefCounts(t#0)
           == (var oldEntry#0 := $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): DatatypeType; 
            (var t0#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  t#0, 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box((var dt_update_tmp#0#0 := oldEntry#0; 
                      (var dt_update#predCount#0#0 := LitInt(1); 
                        #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#0), 
                          IndirectionTableModel.Entry.succs(dt_update_tmp#0#0), 
                          dt_update#predCount#0#0))))); 
              IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                t0#0, 
                t#0, 
                MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.IterStart, 
                  t#0)))));

// definition axiom for IndirectionTableModel.__default.ComputeRefCounts for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.ComputeRefCounts(Lit(t#0)) } 
    IndirectionTableModel.__default.ComputeRefCounts#canCall(Lit(t#0))
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && (forall ref#4: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
            LitInt(0) <= ref#4
                 && ref#4 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#4)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#4)]): DatatypeType)
                 == LitInt(0))
           && (forall ref#5: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
            LitInt(0) <= ref#5
                 && ref#5 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(ref#5)]
               ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(ref#5)]): DatatypeType))
                 <= LitInt(Bounds.__default.MaxNumChildren()))
           && LitInt(MutableMapModel.LinearHashMap.count(Lit(t#0)))
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           && Map#Domain(MutableMapModel.LinearHashMap.contents(Lit(t#0)))[$Box(PivotBetreeGraph.__default.Root())])
       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(Lit(t#0))
         && PivotBetreeGraph.__default.Root#canCall()
         && (var oldEntry#1 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): DatatypeType; 
          PivotBetreeGraph.__default.Root#canCall()
             && (var dt_update_tmp#0#1 := oldEntry#1; 
              IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1)
                 && IndirectionTableModel.Entry.Entry_q(dt_update_tmp#0#1))
             && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
              Lit(t#0), 
              LitInt(PivotBetreeGraph.__default.Root()), 
              $Box((var dt_update_tmp#0#1 := oldEntry#1; 
                  (var dt_update#predCount#0#1 := LitInt(1); 
                    #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                      IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                      dt_update#predCount#0#1)))))
             && (var t0#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  Lit(t#0), 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box((var dt_update_tmp#0#1 := oldEntry#1; 
                      (var dt_update#predCount#0#1 := LitInt(1); 
                        #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                          IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                          dt_update#predCount#0#1))))); 
              MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
                 && IndirectionTableModel.__default.ComputeRefCountsIterate#canCall(t0#1, 
                  Lit(t#0), 
                  MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterStart, 
                    Lit(t#0)))))
         && IndirectionTableModel.__default.ComputeRefCounts(Lit(t#0))
           == (var oldEntry#1 := $Unbox(Map#Elements(Lit(MutableMapModel.LinearHashMap.contents(Lit(t#0))))[$Box(LitInt(PivotBetreeGraph.__default.Root()))]): DatatypeType; 
            (var t0#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  Lit(t#0), 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box((var dt_update_tmp#0#1 := oldEntry#1; 
                      (var dt_update#predCount#0#1 := LitInt(1); 
                        #IndirectionTableModel.Entry.Entry(IndirectionTableModel.Entry.loc(dt_update_tmp#0#1), 
                          IndirectionTableModel.Entry.succs(dt_update_tmp#0#1), 
                          dt_update#predCount#0#1))))); 
              IndirectionTableModel.__default.ComputeRefCountsIterate($LS($LZ), 
                t0#1, 
                Lit(t#0), 
                MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.IterStart, 
                  Lit(t#0))))));

// function declaration for IndirectionTableModel._default.valToHashMap
function IndirectionTableModel.__default.valToHashMap($ly: LayerType, a#0: Seq Box) : DatatypeType;

function IndirectionTableModel.__default.valToHashMap#canCall(a#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { IndirectionTableModel.__default.valToHashMap($LS($ly), a#0) } 
  IndirectionTableModel.__default.valToHashMap($LS($ly), a#0)
     == IndirectionTableModel.__default.valToHashMap($ly, a#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { IndirectionTableModel.__default.valToHashMap(AsFuelBottom($ly), a#0) } 
  IndirectionTableModel.__default.valToHashMap($ly, a#0)
     == IndirectionTableModel.__default.valToHashMap($LZ, a#0));

// consequence axiom for IndirectionTableModel.__default.valToHashMap
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { IndirectionTableModel.__default.valToHashMap($ly, a#0) } 
    IndirectionTableModel.__default.valToHashMap#canCall(a#0)
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Seq#Length(a#0) <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall i#0: int :: 
            { $Unbox(Seq#Index(a#0, i#0)): DatatypeType } 
            LitInt(0) <= i#0 && i#0 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(a#0, i#0)): DatatypeType))
           && (forall i#1: int :: 
            { $Unbox(Seq#Index(a#0, i#1)): DatatypeType } 
            LitInt(0) <= i#1 && i#1 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(a#0, i#1)): DatatypeType, 
                Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array())))))))))
       ==> (Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($ly, a#0))
           ==> MutableMapModel.LinearHashMap.count($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType)
             == Seq#Length(a#0))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($ly, a#0))
           ==> (forall v#0: DatatypeType :: 
            { IndirectionTableModel.Entry.loc(v#0) } 
              { Map#Values(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(v#0)] } 
            $Is(v#0, Tclass.IndirectionTableModel.Entry())
                 && Map#Values(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(v#0)]
               ==> Options.Option.Some_q(IndirectionTableModel.Entry.loc(v#0))
                 && DiskLayout.__default.ValidNodeLocation($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc(v#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($ly, a#0))
           ==> (forall ref#0: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#0)]
               ==> IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#0)]): DatatypeType)
                 == LitInt(0)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($ly, a#0))
           ==> (forall ref#1: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#1)] } 
            LitInt(0) <= ref#1
                 && ref#1 < 18446744073709551616
                 && Map#Domain(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#1)]
               ==> Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType))[$Box(ref#1)]): DatatypeType))
                 <= LitInt(Bounds.__default.MaxNumChildren())))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToHashMap($ly, a#0))
           ==> Options.Option#Equal(Marshalling.__default.valToIndirectionTableMaps(StartFuel_Marshalling._default.valToIndirectionTableMaps, a#0), 
            #Options.Option.Some($Box(IndirectionTableModel.__default.IHashMap($Unbox(Options.Option.value(IndirectionTableModel.__default.valToHashMap($ly, a#0))): DatatypeType)))))
         && (Options.Option.None_q(IndirectionTableModel.__default.valToHashMap($ly, a#0))
           ==> Options.Option.None_q(Marshalling.__default.valToIndirectionTableMaps(StartFuel_Marshalling._default.valToIndirectionTableMaps, a#0)))
         && $Is(IndirectionTableModel.__default.valToHashMap($ly, a#0), 
          Tclass.Options.Option(Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))));

function IndirectionTableModel.__default.valToHashMap#requires(LayerType, Seq Box) : bool;

// #requires axiom for IndirectionTableModel.__default.valToHashMap
axiom (forall $ly: LayerType, a#0: Seq Box :: 
  { IndirectionTableModel.__default.valToHashMap#requires($ly, a#0) } 
  $Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
     ==> IndirectionTableModel.__default.valToHashMap#requires($ly, a#0)
       == (
        Seq#Length(a#0) <= LitInt(IndirectionTableModel.__default.MaxSize())
         && (forall i#2: int :: 
          { $Unbox(Seq#Index(a#0, i#2)): DatatypeType } 
          LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
             ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
              $Unbox(Seq#Index(a#0, i#2)): DatatypeType))
         && (forall i#3: int :: 
          { $Unbox(Seq#Index(a#0, i#3)): DatatypeType } 
          LitInt(0) <= i#3 && i#3 < Seq#Length(a#0)
             ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
              $Unbox(Seq#Index(a#0, i#3)): DatatypeType, 
              Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                      $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))))));

// definition axiom for IndirectionTableModel.__default.valToHashMap(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    { IndirectionTableModel.__default.valToHashMap($LS($ly), a#0) } 
    IndirectionTableModel.__default.valToHashMap#canCall(a#0)
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Seq#Length(a#0) <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall i#2: int :: 
            { $Unbox(Seq#Index(a#0, i#2)): DatatypeType } 
            LitInt(0) <= i#2 && i#2 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(a#0, i#2)): DatatypeType))
           && (forall i#3: int :: 
            { $Unbox(Seq#Index(a#0, i#3)): DatatypeType } 
            LitInt(0) <= i#3 && i#3 < Seq#Length(a#0)
               ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(a#0, i#3)): DatatypeType, 
                Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array())))))))))
       ==> (Seq#Length(a#0) == LitInt(0)
           ==> MutableMapModel.__default.Constructor#canCall(Tclass.IndirectionTableModel.Entry(), LitInt(1024)))
         && (Seq#Length(a#0) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), a#0)
             && IndirectionTableModel.__default.valToHashMap#canCall(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0))
             && (var res#0 := IndirectionTableModel.__default.valToHashMap($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0)); 
              !Options.Option.None_q(res#0)
                 ==> (var table#0 := $Unbox(Options.Option.value(res#0)): DatatypeType; 
                  Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), a#0)
                     && (var tuple#0 := $Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), a#0)): DatatypeType; 
                      (var ref#2 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(0))): DatatypeType); 
                        (var lba#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(1))): DatatypeType); 
                          (var len#0 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(2))): DatatypeType); 
                            (var succs#0 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#0), LitInt(3))): DatatypeType); 
                              (var loc#0 := #DiskLayout.Location.Location(lba#0, len#0); 
                                MutableMapModel.LinearHashMap.LinearHashMap_q(table#0)
                                   && (!Map#Domain(MutableMapModel.LinearHashMap.contents(table#0))[$Box(ref#2)]
                                     ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#0))
                                   && (DiskLayout.__default.ValidNodeLocation#canCall(loc#0)
                                       && DiskLayout.__default.ValidNodeLocation(loc#0)
                                     ==> Bounds.__default.MaxNumChildren#canCall())
                                   && (!(
                                      Map#Domain(MutableMapModel.LinearHashMap.contents(table#0))[$Box(ref#2)]
                                       || !DiskLayout.__default.ValidNodeLocation(loc#0)
                                       || Seq#Length(succs#0) > Bounds.__default.MaxNumChildren())
                                     ==> MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
                                      table#0, 
                                      ref#2, 
                                      $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), succs#0, LitInt(0))))))))))))))
         && IndirectionTableModel.__default.valToHashMap($LS($ly), a#0)
           == (if Seq#Length(a#0) == LitInt(0)
             then (var s#0 := #Options.Option.Some($Box(MutableMapModel.__default.Constructor(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.Constructor, 
                      LitInt(1024)))); 
              s#0)
             else (var res#0 := IndirectionTableModel.__default.valToHashMap($ly, Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), a#0)); 
              (if Options.Option.None_q(res#0)
                 then #Options.Option.None()
                 else (var table#1 := $Unbox(Options.Option.value(res#0)): DatatypeType; 
                  (var tuple#1 := $Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), a#0)): DatatypeType; 
                    (var ref#3 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(0))): DatatypeType); 
                      (var lba#1 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(1))): DatatypeType); 
                        (var len#1 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(2))): DatatypeType); 
                          (var succs#1 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#1), LitInt(3))): DatatypeType); 
                            (var loc#1 := #DiskLayout.Location.Location(lba#1, len#1); 
                              (if Map#Domain(MutableMapModel.LinearHashMap.contents(table#1))[$Box(ref#3)]
                                   || !DiskLayout.__default.ValidNodeLocation(loc#1)
                                   || Seq#Length(succs#1) > Bounds.__default.MaxNumChildren()
                                 then #Options.Option.None()
                                 else (var res#2 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                                      StartFuel_MutableMapModel._default.Insert, 
                                      table#1, 
                                      ref#3, 
                                      $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#1)), succs#1, LitInt(0)))); 
                                  #Options.Option.Some($Box(res#2)))))))))))))));

// definition axiom for IndirectionTableModel.__default.valToHashMap for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, a#0: Seq Box :: 
    {:weight 3} { IndirectionTableModel.__default.valToHashMap($LS($ly), Lit(a#0)) } 
    IndirectionTableModel.__default.valToHashMap#canCall(Lit(a#0))
         || ($Is(a#0, TSeq(Tclass.GenericMarshalling.V()))
           && 
          Seq#Length(Lit(a#0)) <= LitInt(IndirectionTableModel.__default.MaxSize())
           && (forall i#4: int :: 
            { $Unbox(Seq#Index(a#0, i#4)): DatatypeType } 
            LitInt(0) <= i#4 && i#4 < Seq#Length(Lit(a#0))
               ==> GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, 
                $Unbox(Seq#Index(Lit(a#0), i#4)): DatatypeType))
           && (forall i#5: int :: 
            { $Unbox(Seq#Index(a#0, i#5)): DatatypeType } 
            LitInt(0) <= i#5 && i#5 < Seq#Length(Lit(a#0))
               ==> GenericMarshalling.__default.ValInGrammar(StartFuelAssert_GenericMarshalling._default.ValInGrammar, 
                $Unbox(Seq#Index(Lit(a#0), i#5)): DatatypeType, 
                Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                            $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                          $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                        $Box(Lit(#GenericMarshalling.G.GUint64Array())))))))))
       ==> (Seq#Length(Lit(a#0)) == LitInt(0)
           ==> MutableMapModel.__default.Constructor#canCall(Tclass.IndirectionTableModel.Entry(), LitInt(1024)))
         && (Seq#Length(Lit(a#0)) != LitInt(0)
           ==> Sequences.__default.DropLast#canCall(Tclass.GenericMarshalling.V(), Lit(a#0))
             && IndirectionTableModel.__default.valToHashMap#canCall(Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))
             && (var res#3 := Lit(IndirectionTableModel.__default.valToHashMap($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))); 
              !Options.Option.None_q(res#3)
                 ==> (var table#2 := $Unbox(Options.Option.value(res#3)): DatatypeType; 
                  Sequences.__default.Last#canCall(Tclass.GenericMarshalling.V(), Lit(a#0))
                     && (var tuple#2 := Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(a#0))): DatatypeType); 
                      (var ref#4 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(0))): DatatypeType); 
                        (var lba#2 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(1))): DatatypeType); 
                          (var len#2 := GenericMarshalling.V.u($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(2))): DatatypeType); 
                            (var succs#2 := GenericMarshalling.V.ua($Unbox(Seq#Index(GenericMarshalling.V.t(tuple#2), LitInt(3))): DatatypeType); 
                              (var loc#2 := #DiskLayout.Location.Location(lba#2, len#2); 
                                MutableMapModel.LinearHashMap.LinearHashMap_q(table#2)
                                   && (!Map#Domain(MutableMapModel.LinearHashMap.contents(table#2))[$Box(ref#4)]
                                     ==> DiskLayout.__default.ValidNodeLocation#canCall(loc#2))
                                   && (DiskLayout.__default.ValidNodeLocation#canCall(loc#2)
                                       && DiskLayout.__default.ValidNodeLocation(loc#2)
                                     ==> Bounds.__default.MaxNumChildren#canCall())
                                   && (!(
                                      Map#Domain(MutableMapModel.LinearHashMap.contents(table#2))[$Box(ref#4)]
                                       || !DiskLayout.__default.ValidNodeLocation(loc#2)
                                       || Seq#Length(succs#2) > Bounds.__default.MaxNumChildren())
                                     ==> MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
                                      table#2, 
                                      ref#4, 
                                      $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#2)), succs#2, LitInt(0))))))))))))))
         && IndirectionTableModel.__default.valToHashMap($LS($ly), Lit(a#0))
           == (if Seq#Length(Lit(a#0)) == LitInt(0)
             then (var s#1 := #Options.Option.Some($Box(MutableMapModel.__default.Constructor(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.Constructor, 
                      LitInt(1024)))); 
              s#1)
             else (var res#3 := Lit(IndirectionTableModel.__default.valToHashMap($LS($ly), 
                    Lit(Sequences.__default.DropLast(Tclass.GenericMarshalling.V(), Lit(a#0))))); 
              (if Options.Option.None_q(res#3)
                 then #Options.Option.None()
                 else (var table#3 := Lit($Unbox(Options.Option.value(res#3)): DatatypeType); 
                  (var tuple#3 := Lit($Unbox(Sequences.__default.Last(Tclass.GenericMarshalling.V(), Lit(a#0))): DatatypeType); 
                    (var ref#5 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(0))): DatatypeType); 
                      (var lba#3 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(1))): DatatypeType); 
                        (var len#3 := GenericMarshalling.V.u($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(2))): DatatypeType); 
                          (var succs#3 := GenericMarshalling.V.ua($Unbox(Seq#Index(Lit(GenericMarshalling.V.t(tuple#3)), LitInt(3))): DatatypeType); 
                            (var loc#3 := #DiskLayout.Location.Location(lba#3, len#3); 
                              (if Map#Domain(MutableMapModel.LinearHashMap.contents(table#3))[$Box(ref#5)]
                                   || !DiskLayout.__default.ValidNodeLocation(loc#3)
                                   || Seq#Length(succs#3) > Bounds.__default.MaxNumChildren()
                                 then #Options.Option.None()
                                 else (var res#5 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                                      StartFuel_MutableMapModel._default.Insert, 
                                      table#3, 
                                      ref#5, 
                                      $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#3)), succs#3, LitInt(0)))); 
                                  #Options.Option.Some($Box(res#5)))))))))))))));

// function declaration for IndirectionTableModel._default.IndirectionTableGrammar
function IndirectionTableModel.__default.IndirectionTableGrammar() : DatatypeType;

function IndirectionTableModel.__default.IndirectionTableGrammar#canCall() : bool;

// consequence axiom for IndirectionTableModel.__default.IndirectionTableGrammar
axiom true
   ==> 
  true
   ==> Lit(GenericMarshalling.__default.ValidGrammar($LS($LZ), Lit(IndirectionTableModel.__default.IndirectionTableGrammar())))
     && $Is(IndirectionTableModel.__default.IndirectionTableGrammar(), 
      Tclass.GenericMarshalling.G());

function IndirectionTableModel.__default.IndirectionTableGrammar#requires() : bool;

// #requires axiom for IndirectionTableModel.__default.IndirectionTableGrammar
axiom IndirectionTableModel.__default.IndirectionTableGrammar#requires() == true;

// definition axiom for IndirectionTableModel.__default.IndirectionTableGrammar(revealed)
axiom true
   ==> 
  true
   ==> IndirectionTableModel.__default.IndirectionTableGrammar()
     == Lit(#GenericMarshalling.G.GArray(Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                    $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));

// definition axiom for IndirectionTableModel.__default.IndirectionTableGrammar for all literals(revealed)
axiom true
   ==> 
  true
   ==> IndirectionTableModel.__default.IndirectionTableGrammar()
     == Lit(#GenericMarshalling.G.GArray(Lit(#GenericMarshalling.G.GTuple(Lit(Seq#Build(Seq#Build(Seq#Build(Seq#Build(Seq#Empty(): Seq Box, $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                    $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                  $Box(Lit(#GenericMarshalling.G.GUint64()))), 
                $Box(Lit(#GenericMarshalling.G.GUint64Array()))))))));

// function declaration for IndirectionTableModel._default.makeGarbageQueueIterate
function IndirectionTableModel.__default.makeGarbageQueueIterate($ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType) : Seq Box;

function IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q#0, it#0) } 
  IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q#0, it#0)
     == IndirectionTableModel.__default.makeGarbageQueueIterate($ly, t#0, q#0, it#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.makeGarbageQueueIterate(AsFuelBottom($ly), t#0, q#0, it#0) } 
  IndirectionTableModel.__default.makeGarbageQueueIterate($ly, t#0, q#0, it#0)
     == IndirectionTableModel.__default.makeGarbageQueueIterate($LZ, t#0, q#0, it#0));

// consequence axiom for IndirectionTableModel.__default.makeGarbageQueueIterate
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.makeGarbageQueueIterate($ly, t#0, q#0, it#0) } 
    IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0, q#0, it#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
           && LruModel.__default.WF(q#0))
       ==> $Is(IndirectionTableModel.__default.makeGarbageQueueIterate($ly, t#0, q#0, it#0), 
        TSeq(Tclass.NativeTypes.uint64())));

function IndirectionTableModel.__default.makeGarbageQueueIterate#requires(LayerType, DatatypeType, Seq Box, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.makeGarbageQueueIterate
axiom (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.makeGarbageQueueIterate#requires($ly, t#0, q#0, it#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.makeGarbageQueueIterate#requires($ly, t#0, q#0, it#0)
       == (
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
         && LruModel.__default.WF(q#0)));

// definition axiom for IndirectionTableModel.__default.makeGarbageQueueIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q#0, it#0) } 
    IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0, q#0, it#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
           && LruModel.__default.WF(q#0))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && (!MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
           ==> MutableMapModel.Iterator.Iterator_q(it#0)
             && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
             && (IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
                 == LitInt(0)
               ==> MutableMapModel.Iterator.Iterator_q(it#0)
                 && LruModel.__default.Use#canCall(q#0, MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))))
             && (var q'#0 := (if IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
                     == LitInt(0)
                   then LruModel.__default.Use(q#0, MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0)))
                   else q#0); 
              MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
                 && (var it'#0 := MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      t#0, 
                      it#0); 
                  IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0, q'#0, it'#0))))
         && IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q#0, it#0)
           == (if MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
             then q#0
             else (var q'#0 := (if IndirectionTableModel.Entry.predCount($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
                     == LitInt(0)
                   then LruModel.__default.Use(q#0, MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0)))
                   else q#0); 
              (var it'#0 := MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterInc, 
                    t#0, 
                    it#0); 
                IndirectionTableModel.__default.makeGarbageQueueIterate($ly, t#0, q'#0, it'#0)))));

// definition axiom for IndirectionTableModel.__default.makeGarbageQueueIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q#0, Lit(it#0)) } 
    IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0, q#0, Lit(it#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, Lit(it#0))
           && LruModel.__default.WF(q#0))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.Entry.Entry_q(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))
             && (LitInt(IndirectionTableModel.Entry.predCount(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType)))
                 == LitInt(0)
               ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
                 && LruModel.__default.Use#canCall(q#0, 
                  LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))))
             && (var q'#1 := (if LitInt(IndirectionTableModel.Entry.predCount(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType)))
                     == LitInt(0)
                   then LruModel.__default.Use(q#0, 
                    LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))))
                   else q#0); 
              MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), t#0, Lit(it#0))
                 && (var it'#1 := MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      t#0, 
                      Lit(it#0)); 
                  IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0, q'#1, it'#1))))
         && IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q#0, Lit(it#0))
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then q#0
             else (var q'#1 := (if LitInt(IndirectionTableModel.Entry.predCount(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType)))
                     == LitInt(0)
                   then LruModel.__default.Use(q#0, 
                    LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))))
                   else q#0); 
              (var it'#1 := MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterInc, 
                    t#0, 
                    Lit(it#0)); 
                IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), t#0, q'#1, it'#1)))));

// definition axiom for IndirectionTableModel.__default.makeGarbageQueueIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, q#0: Seq Box, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), Lit(t#0), Lit(q#0), Lit(it#0)) } 
    IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(Lit(t#0), Lit(q#0), Lit(it#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), Lit(t#0), Lit(it#0))
           && Lit(LruModel.__default.WF(Lit(q#0))))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.Entry.Entry_q(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))
             && (LitInt(IndirectionTableModel.Entry.predCount(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType)))
                 == LitInt(0)
               ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
                 && LruModel.__default.Use#canCall(Lit(q#0), 
                  LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))))
             && (var q'#2 := (if LitInt(IndirectionTableModel.Entry.predCount(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType)))
                     == LitInt(0)
                   then LruModel.__default.Use(Lit(q#0), 
                    LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))))
                   else q#0); 
              MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), Lit(it#0))
                 && (var it'#2 := MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      Lit(t#0), 
                      Lit(it#0)); 
                  IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(Lit(t#0), q'#2, it'#2))))
         && IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), Lit(t#0), Lit(q#0), Lit(it#0))
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then q#0
             else (var q'#2 := (if LitInt(IndirectionTableModel.Entry.predCount(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType)))
                     == LitInt(0)
                   then LruModel.__default.Use(Lit(q#0), 
                    LitInt(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))))
                   else q#0); 
              (var it'#2 := MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterInc, 
                    Lit(t#0), 
                    Lit(it#0)); 
                IndirectionTableModel.__default.makeGarbageQueueIterate($LS($ly), Lit(t#0), q'#2, it'#2)))));

// function declaration for IndirectionTableModel._default.makeGarbageQueue
function IndirectionTableModel.__default.makeGarbageQueue($ly: LayerType, t#0: DatatypeType) : Seq Box;

function IndirectionTableModel.__default.makeGarbageQueue#canCall(t#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType :: 
  { IndirectionTableModel.__default.makeGarbageQueue($LS($ly), t#0) } 
  IndirectionTableModel.__default.makeGarbageQueue($LS($ly), t#0)
     == IndirectionTableModel.__default.makeGarbageQueue($ly, t#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType :: 
  { IndirectionTableModel.__default.makeGarbageQueue(AsFuelBottom($ly), t#0) } 
  IndirectionTableModel.__default.makeGarbageQueue($ly, t#0)
     == IndirectionTableModel.__default.makeGarbageQueue($LZ, t#0));

// consequence axiom for IndirectionTableModel.__default.makeGarbageQueue
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType :: 
    { IndirectionTableModel.__default.makeGarbageQueue($ly, t#0) } 
    IndirectionTableModel.__default.makeGarbageQueue#canCall(t#0)
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0))
       ==> $Is(IndirectionTableModel.__default.makeGarbageQueue($ly, t#0), 
        TSeq(Tclass.NativeTypes.uint64())));

function IndirectionTableModel.__default.makeGarbageQueue#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.makeGarbageQueue
axiom (forall $ly: LayerType, t#0: DatatypeType :: 
  { IndirectionTableModel.__default.makeGarbageQueue#requires($ly, t#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.makeGarbageQueue#requires($ly, t#0)
       == MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0));

// definition axiom for IndirectionTableModel.__default.makeGarbageQueue(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType :: 
    { IndirectionTableModel.__default.makeGarbageQueue($LS($ly), t#0) } 
    IndirectionTableModel.__default.makeGarbageQueue#canCall(t#0)
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0))
       ==> LruModel.__default.Empty#canCall()
         && MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), t#0)
         && IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(t#0, 
          Lit(LruModel.__default.Empty()), 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            t#0))
         && IndirectionTableModel.__default.makeGarbageQueue($LS($ly), t#0)
           == IndirectionTableModel.__default.makeGarbageQueueIterate($LS($LZ), 
            t#0, 
            Lit(LruModel.__default.Empty()), 
            MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.IterStart, 
              t#0)));

// definition axiom for IndirectionTableModel.__default.makeGarbageQueue for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.makeGarbageQueue($LS($ly), Lit(t#0)) } 
    IndirectionTableModel.__default.makeGarbageQueue#canCall(Lit(t#0))
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0)))
       ==> LruModel.__default.Empty#canCall()
         && MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
         && IndirectionTableModel.__default.makeGarbageQueueIterate#canCall(Lit(t#0), 
          Lit(LruModel.__default.Empty()), 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            Lit(t#0)))
         && IndirectionTableModel.__default.makeGarbageQueue($LS($ly), Lit(t#0))
           == IndirectionTableModel.__default.makeGarbageQueueIterate($LS($LZ), 
            Lit(t#0), 
            Lit(LruModel.__default.Empty()), 
            MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.IterStart, 
              Lit(t#0))));

procedure CheckWellformed$$IndirectionTableModel.__default.lemmaMakeGarbageQueueCorrect(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0));
  free requires 81 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$IndirectionTableModel.__default.lemmaMakeGarbageQueueCorrect(t#0: DatatypeType
       where $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
         && $IsAlloc(t#0, 
          Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()), 
          $Heap)
         && $IsA#MutableMapModel.LinearHashMap(t#0));
  // user-defined preconditions
  requires MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.__default.makeGarbageQueue#canCall(t#0)
     && (var q#0 := IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, t#0); 
      LruModel.__default.WF#canCall(q#0)
         && (LruModel.__default.WF(q#0)
           ==> (forall ref#0: int :: 
            { LruModel.__default.I(q#0)[$Box(ref#0)] } 
              { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType))
                 && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                     && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
                       == LitInt(0)
                   ==> LruModel.__default.I#canCall(q#0))))
         && ((forall ref#0: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#0)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
                 ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                     ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                       && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType))
                   && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                       && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
                         == LitInt(0)
                     ==> LruModel.__default.I#canCall(q#0)))
             && (forall ref#0: int :: 
              { LruModel.__default.I(q#0)[$Box(ref#0)] } 
                { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
                { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && 
                  Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
                   && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
                     == LitInt(0)
                 ==> LruModel.__default.I(q#0)[$Box(ref#0)])
           ==> (forall ref#1: int :: 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
              { LruModel.__default.I(q#0)[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> LruModel.__default.I#canCall(q#0)
                 && (LruModel.__default.I(q#0)[$Box(ref#1)]
                   ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
                       ==> MutableMapModel.LinearHashMap.LinearHashMap_q(t#0)
                         && IndirectionTableModel.Entry.Entry_q($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType))))));
  free ensures (var q#0 := IndirectionTableModel.__default.makeGarbageQueue(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue, t#0); 
    LruModel.__default.WF#canCall(q#0)
       && 
      LruModel.__default.WF(q#0)
       && $Is(q#0, TSeq(Tclass.NativeTypes.uint64()))
       && LruModel.__default.distinct(StartFuel_LruModel._default.distinct, q#0));
  ensures (var q#0 := IndirectionTableModel.__default.makeGarbageQueue(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue, t#0); 
    (forall ref#0: int :: 
      { LruModel.__default.I(q#0)[$Box(ref#0)] } 
        { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType } 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
      LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]): DatatypeType)
             == LitInt(0)
         ==> LruModel.__default.I(q#0)[$Box(ref#0)]));
  ensures (var q#0 := IndirectionTableModel.__default.makeGarbageQueue(StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue, t#0); 
    (forall ref#1: int :: 
      { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType } 
        { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
        { LruModel.__default.I(q#0)[$Box(ref#1)] } 
      LitInt(0) <= ref#1
           && ref#1 < 18446744073709551616
           && LruModel.__default.I(q#0)[$Box(ref#1)]
         ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
           && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]): DatatypeType)
             == LitInt(0)));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.computeRefUpperBoundIterate
function IndirectionTableModel.__default.computeRefUpperBoundIterate($ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int)
   : int;

function IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
  { IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), t#0, it#0, refUpperBound#0) } 
  IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), t#0, it#0, refUpperBound#0)
     == IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, t#0, it#0, refUpperBound#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
  { IndirectionTableModel.__default.computeRefUpperBoundIterate(AsFuelBottom($ly), t#0, it#0, refUpperBound#0) } 
  IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, t#0, it#0, refUpperBound#0)
     == IndirectionTableModel.__default.computeRefUpperBoundIterate($LZ, t#0, it#0, refUpperBound#0));

// consequence axiom for IndirectionTableModel.__default.computeRefUpperBoundIterate
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
    { IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, t#0, it#0, refUpperBound#0) } 
    IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0, it#0, refUpperBound#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
           && (forall ref#0: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(ref#0)] } 
            LitInt(0) <= ref#0
                 && ref#0 < 18446744073709551616
                 && MutableMapModel.Iterator.s(it#0)[$Box(ref#0)]
               ==> ref#0 <= refUpperBound#0))
       ==> (forall ref#1: int :: 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)] } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#1)]
             ==> ref#1
               <= IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, t#0, it#0, refUpperBound#0))
         && 
        LitInt(0)
           <= IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, t#0, it#0, refUpperBound#0)
         && IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, t#0, it#0, refUpperBound#0)
           < 18446744073709551616);

function IndirectionTableModel.__default.computeRefUpperBoundIterate#requires(LayerType, DatatypeType, DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.computeRefUpperBoundIterate
axiom (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
  { IndirectionTableModel.__default.computeRefUpperBoundIterate#requires($ly, t#0, it#0, refUpperBound#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
       && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && 
      LitInt(0) <= refUpperBound#0
       && refUpperBound#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.computeRefUpperBoundIterate#requires($ly, t#0, it#0, refUpperBound#0)
       == (
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
         && (forall ref#2: int :: 
          { MutableMapModel.Iterator.s(it#0)[$Box(ref#2)] } 
          LitInt(0) <= ref#2
               && ref#2 < 18446744073709551616
               && MutableMapModel.Iterator.s(it#0)[$Box(ref#2)]
             ==> ref#2 <= refUpperBound#0)));

// definition axiom for IndirectionTableModel.__default.computeRefUpperBoundIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
    { IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), t#0, it#0, refUpperBound#0) } 
    IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0, it#0, refUpperBound#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
           && (forall ref#2: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(ref#2)] } 
            LitInt(0) <= ref#2
                 && ref#2 < 18446744073709551616
                 && MutableMapModel.Iterator.s(it#0)[$Box(ref#2)]
               ==> ref#2 <= refUpperBound#0))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && (MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
           ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), t#0, it#0)
             && 
            MutableMapModel.Iterator.Iterator_q(it#0)
             && (MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))
                 > refUpperBound#0
               ==> MutableMapModel.Iterator.Iterator_q(it#0))
             && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                t#0, 
                it#0), 
              (if MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))
                   > refUpperBound#0
                 then MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))
                 else refUpperBound#0)))
         && IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), t#0, it#0, refUpperBound#0)
           == (if MutableMapModel.IteratorOutput.Next_q(MutableMapModel.Iterator.next(it#0))
             then IndirectionTableModel.__default.computeRefUpperBoundIterate($ly, 
              t#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                t#0, 
                it#0), 
              (if MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))
                   > refUpperBound#0
                 then MutableMapModel.IteratorOutput.key(MutableMapModel.Iterator.next(it#0))
                 else refUpperBound#0))
             else refUpperBound#0));

// definition axiom for IndirectionTableModel.__default.computeRefUpperBoundIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), t#0, Lit(it#0), refUpperBound#0) } 
    IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0, Lit(it#0), refUpperBound#0)
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), t#0, Lit(it#0))
           && (forall ref#3: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(ref#3)] } 
            LitInt(0) <= ref#3
                 && ref#3 < 18446744073709551616
                 && Lit(MutableMapModel.Iterator.s(Lit(it#0)))[$Box(ref#3)]
               ==> ref#3 <= refUpperBound#0))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (Lit(MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), t#0, Lit(it#0))
             && 
            MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && (MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                 > refUpperBound#0
               ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0)))
             && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                t#0, 
                Lit(it#0)), 
              (if MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                   > refUpperBound#0
                 then MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                 else refUpperBound#0)))
         && IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), t#0, Lit(it#0), refUpperBound#0)
           == (if MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), 
              t#0, 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                t#0, 
                Lit(it#0)), 
              (if MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                   > refUpperBound#0
                 then MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                 else refUpperBound#0))
             else refUpperBound#0));

// definition axiom for IndirectionTableModel.__default.computeRefUpperBoundIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, t#0: DatatypeType, it#0: DatatypeType, refUpperBound#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), Lit(t#0), Lit(it#0), LitInt(refUpperBound#0)) } 
    IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(Lit(t#0), Lit(it#0), LitInt(refUpperBound#0))
         || (
          $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && 
          LitInt(0) <= refUpperBound#0
           && refUpperBound#0 < 18446744073709551616
           && 
          MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), Lit(t#0), Lit(it#0))
           && (forall ref#4: int :: 
            { MutableMapModel.Iterator.s(it#0)[$Box(ref#4)] } 
            LitInt(0) <= ref#4
                 && ref#4 < 18446744073709551616
                 && Lit(MutableMapModel.Iterator.s(Lit(it#0)))[$Box(ref#4)]
               ==> ref#4 <= LitInt(refUpperBound#0)))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (Lit(MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0), Lit(it#0))
             && 
            MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && (Lit(MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                   > refUpperBound#0)
               ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0)))
             && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(Lit(t#0), 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                Lit(t#0), 
                Lit(it#0)), 
              (if MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                   > refUpperBound#0
                 then MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                 else refUpperBound#0)))
         && IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), Lit(t#0), Lit(it#0), LitInt(refUpperBound#0))
           == (if MutableMapModel.IteratorOutput.Next_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($ly), 
              Lit(t#0), 
              MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.IterInc, 
                Lit(t#0), 
                Lit(it#0)), 
              (if MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                   > refUpperBound#0
                 then MutableMapModel.IteratorOutput.key(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
                 else refUpperBound#0))
             else refUpperBound#0));

// function declaration for IndirectionTableModel._default.computeRefUpperBound
function IndirectionTableModel.__default.computeRefUpperBound(t#0: DatatypeType) : int;

function IndirectionTableModel.__default.computeRefUpperBound#canCall(t#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.computeRefUpperBound
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.computeRefUpperBound(t#0) } 
    IndirectionTableModel.__default.computeRefUpperBound#canCall(t#0)
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0))
       ==> (forall ref#0: int :: 
          { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0
               && ref#0 < 18446744073709551616
               && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#0)]
             ==> ref#0 <= IndirectionTableModel.__default.computeRefUpperBound(t#0))
         && 
        LitInt(0) <= IndirectionTableModel.__default.computeRefUpperBound(t#0)
         && IndirectionTableModel.__default.computeRefUpperBound(t#0) < 18446744073709551616);

function IndirectionTableModel.__default.computeRefUpperBound#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.computeRefUpperBound
axiom (forall t#0: DatatypeType :: 
  { IndirectionTableModel.__default.computeRefUpperBound#requires(t#0) } 
  $Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
     ==> IndirectionTableModel.__default.computeRefUpperBound#requires(t#0)
       == MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0));

// definition axiom for IndirectionTableModel.__default.computeRefUpperBound(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    { IndirectionTableModel.__default.computeRefUpperBound(t#0) } 
    IndirectionTableModel.__default.computeRefUpperBound#canCall(t#0)
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0))
       ==> MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), t#0)
         && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(t#0, 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            t#0), 
          LitInt(0))
         && IndirectionTableModel.__default.computeRefUpperBound(t#0)
           == IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($LZ), 
            t#0, 
            MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.IterStart, 
              t#0), 
            LitInt(0)));

// definition axiom for IndirectionTableModel.__default.computeRefUpperBound for all literals(revealed)
axiom true
   ==> (forall t#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.computeRefUpperBound(Lit(t#0)) } 
    IndirectionTableModel.__default.computeRefUpperBound#canCall(Lit(t#0))
         || ($Is(t#0, Tclass.MutableMapModel.LinearHashMap(Tclass.IndirectionTableModel.Entry()))
           && MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), Lit(t#0)))
       ==> MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), Lit(t#0))
         && IndirectionTableModel.__default.computeRefUpperBoundIterate#canCall(Lit(t#0), 
          MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
            StartFuel_MutableMapModel._default.IterStart, 
            Lit(t#0)), 
          LitInt(0))
         && IndirectionTableModel.__default.computeRefUpperBound(Lit(t#0))
           == IndirectionTableModel.__default.computeRefUpperBoundIterate($LS($LZ), 
            Lit(t#0), 
            MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.IterStart, 
              Lit(t#0)), 
            LitInt(0)));

// function declaration for IndirectionTableModel._default.valToIndirectionTable
function IndirectionTableModel.__default.valToIndirectionTable(v#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0: DatatypeType) : bool;

// consequence axiom for IndirectionTableModel.__default.valToIndirectionTable
axiom true
   ==> (forall v#0: DatatypeType :: 
    { IndirectionTableModel.__default.valToIndirectionTable(v#0) } 
    IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(IndirectionTableModel.__default.IndirectionTableGrammar())))
       ==> (Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0))
           ==> IndirectionTableModel.__default.Inv($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0))
           ==> IndirectionTableModel.__default.TrackingGarbage($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0))
           ==> BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType)))
         && (Options.Option.Some_q(IndirectionTableModel.__default.valToIndirectionTable(v#0))
           ==> Options.Option#Equal(Marshalling.__default.valToIndirectionTable(v#0), 
            #Options.Option.Some($Box(IndirectionTableModel.__default.I($Unbox(Options.Option.value(IndirectionTableModel.__default.valToIndirectionTable(v#0))): DatatypeType)))))
         && (Options.Option.None_q(IndirectionTableModel.__default.valToIndirectionTable(v#0))
           ==> Options.Option.None_q(Marshalling.__default.valToIndirectionTable(v#0)))
         && $Is(IndirectionTableModel.__default.valToIndirectionTable(v#0), 
          Tclass.Options.Option(Tclass.IndirectionTableModel.IndirectionTable())));

function IndirectionTableModel.__default.valToIndirectionTable#requires(DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.valToIndirectionTable
axiom (forall v#0: DatatypeType :: 
  { IndirectionTableModel.__default.valToIndirectionTable#requires(v#0) } 
  $Is(v#0, Tclass.GenericMarshalling.V())
     ==> IndirectionTableModel.__default.valToIndirectionTable#requires(v#0)
       == (GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
         && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
          v#0, 
          Lit(IndirectionTableModel.__default.IndirectionTableGrammar()))));

// definition axiom for IndirectionTableModel.__default.valToIndirectionTable(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    { IndirectionTableModel.__default.valToIndirectionTable(v#0) } 
    IndirectionTableModel.__default.valToIndirectionTable#canCall(v#0)
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, v#0)
           && GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
            v#0, 
            Lit(IndirectionTableModel.__default.IndirectionTableGrammar())))
       ==> IndirectionTableModel.__default.MaxSize#canCall()
         && (Seq#Length(GenericMarshalling.V.a(v#0))
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> IndirectionTableModel.__default.valToHashMap#canCall(GenericMarshalling.V.a(v#0))
             && (var t#0 := IndirectionTableModel.__default.valToHashMap($LS($LZ), GenericMarshalling.V.a(v#0)); 
              !Options.Option.None_q(t#0)
                 ==> (var t#1 := $Unbox(Options.Option.value(t#0)): DatatypeType; 
                  PivotBetreeGraph.__default.Root#canCall()
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(t#1)
                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#1))[$Box(PivotBetreeGraph.__default.Root())]
                       ==> IndirectionTableModel.__default.ComputeRefCounts#canCall(t#1)
                         && (var t1#0 := IndirectionTableModel.__default.ComputeRefCounts(t#1); 
                          Options.Option.Some_q(t1#0)
                             ==> IndirectionTableModel.__default.computeRefUpperBound#canCall($Unbox(Options.Option.value(t1#0)): DatatypeType)
                               && (var refUpperBound#0 := IndirectionTableModel.__default.computeRefUpperBound($Unbox(Options.Option.value(t1#0)): DatatypeType); 
                                IndirectionTableModel.__default.makeGarbageQueue#canCall($Unbox(Options.Option.value(t1#0)): DatatypeType)
                                   && IndirectionTableModel.__default.FromHashMap#canCall($Unbox(Options.Option.value(t1#0)): DatatypeType, 
                                    #Options.Option.Some($Box(IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, 
                                          $Unbox(Options.Option.value(t1#0)): DatatypeType))), 
                                    refUpperBound#0, 
                                    Lit(#Options.Option.None()))))))))
         && IndirectionTableModel.__default.valToIndirectionTable(v#0)
           == (if Seq#Length(GenericMarshalling.V.a(v#0))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             then (var t#0 := IndirectionTableModel.__default.valToHashMap($LS($LZ), GenericMarshalling.V.a(v#0)); 
              (if Options.Option.None_q(t#0)
                 then #Options.Option.None()
                 else (var t#2 := $Unbox(Options.Option.value(t#0)): DatatypeType; 
                  (if Map#Domain(MutableMapModel.LinearHashMap.contents(t#2))[$Box(PivotBetreeGraph.__default.Root())]
                     then (var t1#1 := IndirectionTableModel.__default.ComputeRefCounts(t#2); 
                      (if Options.Option.Some_q(t1#1)
                         then (var refUpperBound#1 := IndirectionTableModel.__default.computeRefUpperBound($Unbox(Options.Option.value(t1#1)): DatatypeType); 
                          (var res#1 := IndirectionTableModel.__default.FromHashMap($Unbox(Options.Option.value(t1#1)): DatatypeType, 
                                #Options.Option.Some($Box(IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, 
                                      $Unbox(Options.Option.value(t1#1)): DatatypeType))), 
                                refUpperBound#1, 
                                Lit(#Options.Option.None())); 
                            #Options.Option.Some($Box(res#1))))
                         else #Options.Option.None()))
                     else #Options.Option.None()))))
             else #Options.Option.None()));

// definition axiom for IndirectionTableModel.__default.valToIndirectionTable for all literals(revealed)
axiom true
   ==> (forall v#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.valToIndirectionTable(Lit(v#0)) } 
    IndirectionTableModel.__default.valToIndirectionTable#canCall(Lit(v#0))
         || ($Is(v#0, Tclass.GenericMarshalling.V())
           && 
          Lit(GenericMarshalling.__default.ValidVal(StartFuel_GenericMarshalling._default.ValidVal, Lit(v#0)))
           && Lit(GenericMarshalling.__default.ValInGrammar(StartFuel_GenericMarshalling._default.ValInGrammar, 
              Lit(v#0), 
              Lit(IndirectionTableModel.__default.IndirectionTableGrammar()))))
       ==> IndirectionTableModel.__default.MaxSize#canCall()
         && (Seq#Length(Lit(GenericMarshalling.V.a(Lit(v#0))))
             <= LitInt(IndirectionTableModel.__default.MaxSize())
           ==> IndirectionTableModel.__default.valToHashMap#canCall(Lit(GenericMarshalling.V.a(Lit(v#0))))
             && (var t#3 := Lit(IndirectionTableModel.__default.valToHashMap($LS($LZ), Lit(GenericMarshalling.V.a(Lit(v#0))))); 
              !Options.Option.None_q(t#3)
                 ==> (var t#4 := $Unbox(Options.Option.value(t#3)): DatatypeType; 
                  PivotBetreeGraph.__default.Root#canCall()
                     && MutableMapModel.LinearHashMap.LinearHashMap_q(t#4)
                     && (Map#Domain(MutableMapModel.LinearHashMap.contents(t#4))[$Box(PivotBetreeGraph.__default.Root())]
                       ==> IndirectionTableModel.__default.ComputeRefCounts#canCall(t#4)
                         && (var t1#2 := IndirectionTableModel.__default.ComputeRefCounts(t#4); 
                          Options.Option.Some_q(t1#2)
                             ==> IndirectionTableModel.__default.computeRefUpperBound#canCall($Unbox(Options.Option.value(t1#2)): DatatypeType)
                               && (var refUpperBound#2 := IndirectionTableModel.__default.computeRefUpperBound($Unbox(Options.Option.value(t1#2)): DatatypeType); 
                                IndirectionTableModel.__default.makeGarbageQueue#canCall($Unbox(Options.Option.value(t1#2)): DatatypeType)
                                   && IndirectionTableModel.__default.FromHashMap#canCall($Unbox(Options.Option.value(t1#2)): DatatypeType, 
                                    #Options.Option.Some($Box(IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, 
                                          $Unbox(Options.Option.value(t1#2)): DatatypeType))), 
                                    refUpperBound#2, 
                                    Lit(#Options.Option.None()))))))))
         && IndirectionTableModel.__default.valToIndirectionTable(Lit(v#0))
           == (if Seq#Length(Lit(GenericMarshalling.V.a(Lit(v#0))))
               <= LitInt(IndirectionTableModel.__default.MaxSize())
             then (var t#3 := Lit(IndirectionTableModel.__default.valToHashMap($LS($LZ), Lit(GenericMarshalling.V.a(Lit(v#0))))); 
              (if Options.Option.None_q(t#3)
                 then #Options.Option.None()
                 else (var t#5 := Lit($Unbox(Options.Option.value(t#3)): DatatypeType); 
                  (if Map#Domain(MutableMapModel.LinearHashMap.contents(t#5))[$Box(PivotBetreeGraph.__default.Root())]
                     then (var t1#3 := Lit(IndirectionTableModel.__default.ComputeRefCounts(t#5)); 
                      (if Options.Option.Some_q(t1#3)
                         then (var refUpperBound#3 := LitInt(IndirectionTableModel.__default.computeRefUpperBound(Lit($Unbox(Options.Option.value(t1#3)): DatatypeType))); 
                          (var res#3 := IndirectionTableModel.__default.FromHashMap(Lit($Unbox(Options.Option.value(t1#3)): DatatypeType), 
                                #Options.Option.Some($Box(IndirectionTableModel.__default.makeGarbageQueue(StartFuel_IndirectionTableModel._default.makeGarbageQueue, 
                                      Lit($Unbox(Options.Option.value(t1#3)): DatatypeType)))), 
                                refUpperBound#3, 
                                Lit(#Options.Option.None())); 
                            #Options.Option.Some($Box(res#3))))
                         else #Options.Option.None()))
                     else #Options.Option.None()))))
             else #Options.Option.None()));

// function declaration for IndirectionTableModel._default.IsLocAllocIndirectionTable
function IndirectionTableModel.__default.IsLocAllocIndirectionTable(indirectionTable#0: DatatypeType, i#0: int) : bool;

function IndirectionTableModel.__default.IsLocAllocIndirectionTable#canCall(indirectionTable#0: DatatypeType, i#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTable
axiom true
   ==> (forall indirectionTable#0: DatatypeType, i#0: int :: 
    { IndirectionTableModel.__default.IsLocAllocIndirectionTable(indirectionTable#0, i#0) } 
    IndirectionTableModel.__default.IsLocAllocIndirectionTable#canCall(indirectionTable#0, i#0)
         || $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> true);

function IndirectionTableModel.__default.IsLocAllocIndirectionTable#requires(DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTable
axiom (forall indirectionTable#0: DatatypeType, i#0: int :: 
  { IndirectionTableModel.__default.IsLocAllocIndirectionTable#requires(indirectionTable#0, i#0) } 
  $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.IsLocAllocIndirectionTable#requires(indirectionTable#0, i#0)
       == true);

// definition axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTable(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, i#0: int :: 
    { IndirectionTableModel.__default.IsLocAllocIndirectionTable(indirectionTable#0, i#0) } 
    IndirectionTableModel.__default.IsLocAllocIndirectionTable#canCall(indirectionTable#0, i#0)
         || $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> (LitInt(0) <= i#0 ==> Bounds.__default.MinNodeBlockIndex#canCall())
         && (Bounds.__default.MinNodeBlockIndex#canCall()
             && Bounds.__default.MinNodeBlockIndex() <= i#0
           ==> (forall ref#0: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType } 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType)
                     && Bounds.__default.NodeBlockSize#canCall())))
         && IndirectionTableModel.__default.IsLocAllocIndirectionTable(indirectionTable#0, i#0)
           == ((LitInt(0) <= i#0 && i#0 < Bounds.__default.MinNodeBlockIndex())
             || !(forall ref#0: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType)
                   != Mul(i#0, LitInt(Bounds.__default.NodeBlockSize())))));

// definition axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTable for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, i#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.IsLocAllocIndirectionTable(Lit(indirectionTable#0), LitInt(i#0)) } 
    IndirectionTableModel.__default.IsLocAllocIndirectionTable#canCall(Lit(indirectionTable#0), LitInt(i#0))
         || $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
       ==> (LitInt(0) <= LitInt(i#0) ==> Bounds.__default.MinNodeBlockIndex#canCall())
         && (Bounds.__default.MinNodeBlockIndex#canCall()
             && !Lit(i#0 < Bounds.__default.MinNodeBlockIndex())
           ==> (forall ref#1: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)]): DatatypeType } 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#1)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(ref#1)]): DatatypeType)
                     && Bounds.__default.NodeBlockSize#canCall())))
         && IndirectionTableModel.__default.IsLocAllocIndirectionTable(Lit(indirectionTable#0), LitInt(i#0))
           == ((LitInt(0) <= LitInt(i#0) && i#0 < Bounds.__default.MinNodeBlockIndex())
             || !(forall ref#1: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)]): DatatypeType } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && Map#Domain(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#1)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(ref#1)]): DatatypeType)
                   != Mul(LitInt(i#0), LitInt(Bounds.__default.NodeBlockSize())))));

// function declaration for IndirectionTableModel._default.IsLocAllocBitmap
function IndirectionTableModel.__default.IsLocAllocBitmap(bm#0: Seq Box, i#0: int) : bool;

function IndirectionTableModel.__default.IsLocAllocBitmap#canCall(bm#0: Seq Box, i#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.IsLocAllocBitmap
axiom true
   ==> (forall bm#0: Seq Box, i#0: int :: 
    { IndirectionTableModel.__default.IsLocAllocBitmap(bm#0, i#0) } 
    IndirectionTableModel.__default.IsLocAllocBitmap#canCall(bm#0, i#0)
         || $Is(bm#0, TSeq(TBool))
       ==> true);

function IndirectionTableModel.__default.IsLocAllocBitmap#requires(Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.IsLocAllocBitmap
axiom (forall bm#0: Seq Box, i#0: int :: 
  { IndirectionTableModel.__default.IsLocAllocBitmap#requires(bm#0, i#0) } 
  $Is(bm#0, TSeq(TBool))
     ==> IndirectionTableModel.__default.IsLocAllocBitmap#requires(bm#0, i#0) == true);

// definition axiom for IndirectionTableModel.__default.IsLocAllocBitmap(revealed)
axiom true
   ==> (forall bm#0: Seq Box, i#0: int :: 
    { IndirectionTableModel.__default.IsLocAllocBitmap(bm#0, i#0) } 
    IndirectionTableModel.__default.IsLocAllocBitmap#canCall(bm#0, i#0)
         || $Is(bm#0, TSeq(TBool))
       ==> (LitInt(0) <= i#0 ==> BitmapModel.__default.Len#canCall(bm#0))
         && (BitmapModel.__default.Len#canCall(bm#0) && i#0 < BitmapModel.__default.Len(bm#0)
           ==> BitmapModel.__default.IsSet#canCall(bm#0, i#0))
         && IndirectionTableModel.__default.IsLocAllocBitmap(bm#0, i#0)
           == (
            LitInt(0) <= i#0
             && i#0 < BitmapModel.__default.Len(bm#0)
             && BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, bm#0, i#0)));

// definition axiom for IndirectionTableModel.__default.IsLocAllocBitmap for all literals(revealed)
axiom true
   ==> (forall bm#0: Seq Box, i#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.IsLocAllocBitmap(Lit(bm#0), LitInt(i#0)) } 
    IndirectionTableModel.__default.IsLocAllocBitmap#canCall(Lit(bm#0), LitInt(i#0))
         || $Is(bm#0, TSeq(TBool))
       ==> (LitInt(0) <= LitInt(i#0) ==> BitmapModel.__default.Len#canCall(Lit(bm#0)))
         && (BitmapModel.__default.Len#canCall(Lit(bm#0))
             && Lit(i#0 < BitmapModel.__default.Len(Lit(bm#0)))
           ==> BitmapModel.__default.IsSet#canCall(Lit(bm#0), LitInt(i#0)))
         && IndirectionTableModel.__default.IsLocAllocBitmap(Lit(bm#0), LitInt(i#0))
           == (
            LitInt(0) <= LitInt(i#0)
             && i#0 < BitmapModel.__default.Len(Lit(bm#0))
             && BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, Lit(bm#0), LitInt(i#0))));

// function declaration for IndirectionTableModel._default.BitmapInitUpToIterate
function IndirectionTableModel.__default.BitmapInitUpToIterate($ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int) : Seq Box;

function IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(bm#0: Seq Box, i#0: int, upTo#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
  { IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), bm#0, i#0, upTo#0) } 
  IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), bm#0, i#0, upTo#0)
     == IndirectionTableModel.__default.BitmapInitUpToIterate($ly, bm#0, i#0, upTo#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
  { IndirectionTableModel.__default.BitmapInitUpToIterate(AsFuelBottom($ly), bm#0, i#0, upTo#0) } 
  IndirectionTableModel.__default.BitmapInitUpToIterate($ly, bm#0, i#0, upTo#0)
     == IndirectionTableModel.__default.BitmapInitUpToIterate($LZ, bm#0, i#0, upTo#0));

// consequence axiom for IndirectionTableModel.__default.BitmapInitUpToIterate
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
    { IndirectionTableModel.__default.BitmapInitUpToIterate($ly, bm#0, i#0, upTo#0) } 
    IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(bm#0, i#0, upTo#0)
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 <= upTo#0
           && upTo#0 <= BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.Len(IndirectionTableModel.__default.BitmapInitUpToIterate($ly, bm#0, i#0, upTo#0))
           == BitmapModel.__default.Len(bm#0)
         && $Is(IndirectionTableModel.__default.BitmapInitUpToIterate($ly, bm#0, i#0, upTo#0), 
          TSeq(TBool)));

function IndirectionTableModel.__default.BitmapInitUpToIterate#requires(LayerType, Seq Box, int, int) : bool;

// #requires axiom for IndirectionTableModel.__default.BitmapInitUpToIterate
axiom (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
  { IndirectionTableModel.__default.BitmapInitUpToIterate#requires($ly, bm#0, i#0, upTo#0) } 
  $Is(bm#0, TSeq(TBool))
       && 
      LitInt(0) <= i#0
       && i#0 < 18446744073709551616
       && 
      LitInt(0) <= upTo#0
       && upTo#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.BitmapInitUpToIterate#requires($ly, bm#0, i#0, upTo#0)
       == (LitInt(0) <= i#0 && i#0 <= upTo#0 && upTo#0 <= BitmapModel.__default.Len(bm#0)));

// definition axiom for IndirectionTableModel.__default.BitmapInitUpToIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
    { IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), bm#0, i#0, upTo#0) } 
    IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(bm#0, i#0, upTo#0)
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && 
          LitInt(0) <= i#0
           && i#0 <= upTo#0
           && upTo#0 <= BitmapModel.__default.Len(bm#0))
       ==> (i#0 != upTo#0
           ==> BitmapModel.__default.BitSet#canCall(bm#0, i#0)
             && IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, i#0), 
              i#0 + 1, 
              upTo#0))
         && IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), bm#0, i#0, upTo#0)
           == (if i#0 == upTo#0
             then bm#0
             else IndirectionTableModel.__default.BitmapInitUpToIterate($ly, 
              BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, i#0), 
              i#0 + 1, 
              upTo#0)));

// definition axiom for IndirectionTableModel.__default.BitmapInitUpToIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), bm#0, LitInt(i#0), LitInt(upTo#0)) } 
    IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(bm#0, LitInt(i#0), LitInt(upTo#0))
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(upTo#0)
           && LitInt(upTo#0) <= BitmapModel.__default.Len(bm#0))
       ==> (LitInt(i#0) != LitInt(upTo#0)
           ==> BitmapModel.__default.BitSet#canCall(bm#0, LitInt(i#0))
             && IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, LitInt(i#0)), 
              LitInt(i#0 + 1), 
              LitInt(upTo#0)))
         && IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), bm#0, LitInt(i#0), LitInt(upTo#0))
           == (if LitInt(i#0) == LitInt(upTo#0)
             then bm#0
             else IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), 
              BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, LitInt(i#0)), 
              LitInt(i#0 + 1), 
              LitInt(upTo#0))));

// definition axiom for IndirectionTableModel.__default.BitmapInitUpToIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, i#0: int, upTo#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), Lit(bm#0), LitInt(i#0), LitInt(upTo#0)) } 
    IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(Lit(bm#0), LitInt(i#0), LitInt(upTo#0))
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= i#0
           && i#0 < 18446744073709551616
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && 
          LitInt(0) <= LitInt(i#0)
           && LitInt(i#0) <= LitInt(upTo#0)
           && LitInt(upTo#0) <= LitInt(BitmapModel.__default.Len(Lit(bm#0))))
       ==> (LitInt(i#0) != LitInt(upTo#0)
           ==> BitmapModel.__default.BitSet#canCall(Lit(bm#0), LitInt(i#0))
             && IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, Lit(bm#0), LitInt(i#0)), 
              LitInt(i#0 + 1), 
              LitInt(upTo#0)))
         && IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), Lit(bm#0), LitInt(i#0), LitInt(upTo#0))
           == (if LitInt(i#0) == LitInt(upTo#0)
             then bm#0
             else IndirectionTableModel.__default.BitmapInitUpToIterate($LS($ly), 
              BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, Lit(bm#0), LitInt(i#0)), 
              LitInt(i#0 + 1), 
              LitInt(upTo#0))));

// function declaration for IndirectionTableModel._default.BitmapInitUpTo
function IndirectionTableModel.__default.BitmapInitUpTo($ly: LayerType, bm#0: Seq Box, upTo#0: int) : Seq Box;

function IndirectionTableModel.__default.BitmapInitUpTo#canCall(bm#0: Seq Box, upTo#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, upTo#0: int :: 
  { IndirectionTableModel.__default.BitmapInitUpTo($LS($ly), bm#0, upTo#0) } 
  IndirectionTableModel.__default.BitmapInitUpTo($LS($ly), bm#0, upTo#0)
     == IndirectionTableModel.__default.BitmapInitUpTo($ly, bm#0, upTo#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, bm#0: Seq Box, upTo#0: int :: 
  { IndirectionTableModel.__default.BitmapInitUpTo(AsFuelBottom($ly), bm#0, upTo#0) } 
  IndirectionTableModel.__default.BitmapInitUpTo($ly, bm#0, upTo#0)
     == IndirectionTableModel.__default.BitmapInitUpTo($LZ, bm#0, upTo#0));

// consequence axiom for IndirectionTableModel.__default.BitmapInitUpTo
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, upTo#0: int :: 
    { IndirectionTableModel.__default.BitmapInitUpTo($ly, bm#0, upTo#0) } 
    IndirectionTableModel.__default.BitmapInitUpTo#canCall(bm#0, upTo#0)
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && upTo#0 <= BitmapModel.__default.Len(bm#0))
       ==> BitmapModel.__default.Len(IndirectionTableModel.__default.BitmapInitUpTo($ly, bm#0, upTo#0))
           == BitmapModel.__default.Len(bm#0)
         && $Is(IndirectionTableModel.__default.BitmapInitUpTo($ly, bm#0, upTo#0), TSeq(TBool)));

function IndirectionTableModel.__default.BitmapInitUpTo#requires(LayerType, Seq Box, int) : bool;

// #requires axiom for IndirectionTableModel.__default.BitmapInitUpTo
axiom (forall $ly: LayerType, bm#0: Seq Box, upTo#0: int :: 
  { IndirectionTableModel.__default.BitmapInitUpTo#requires($ly, bm#0, upTo#0) } 
  $Is(bm#0, TSeq(TBool)) && LitInt(0) <= upTo#0 && upTo#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.BitmapInitUpTo#requires($ly, bm#0, upTo#0)
       == (upTo#0 <= BitmapModel.__default.Len(bm#0)));

// definition axiom for IndirectionTableModel.__default.BitmapInitUpTo(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, upTo#0: int :: 
    { IndirectionTableModel.__default.BitmapInitUpTo($LS($ly), bm#0, upTo#0) } 
    IndirectionTableModel.__default.BitmapInitUpTo#canCall(bm#0, upTo#0)
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && upTo#0 <= BitmapModel.__default.Len(bm#0))
       ==> IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(bm#0, LitInt(0), upTo#0)
         && IndirectionTableModel.__default.BitmapInitUpTo($LS($ly), bm#0, upTo#0)
           == IndirectionTableModel.__default.BitmapInitUpToIterate($LS($LZ), bm#0, LitInt(0), upTo#0));

// definition axiom for IndirectionTableModel.__default.BitmapInitUpTo for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, bm#0: Seq Box, upTo#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.BitmapInitUpTo($LS($ly), Lit(bm#0), LitInt(upTo#0)) } 
    IndirectionTableModel.__default.BitmapInitUpTo#canCall(Lit(bm#0), LitInt(upTo#0))
         || (
          $Is(bm#0, TSeq(TBool))
           && 
          LitInt(0) <= upTo#0
           && upTo#0 < 18446744073709551616
           && LitInt(upTo#0) <= LitInt(BitmapModel.__default.Len(Lit(bm#0))))
       ==> IndirectionTableModel.__default.BitmapInitUpToIterate#canCall(Lit(bm#0), LitInt(0), LitInt(upTo#0))
         && IndirectionTableModel.__default.BitmapInitUpTo($LS($ly), Lit(bm#0), LitInt(upTo#0))
           == Lit(IndirectionTableModel.__default.BitmapInitUpToIterate($LS($LZ), Lit(bm#0), LitInt(0), LitInt(upTo#0))));

// function declaration for IndirectionTableModel._default.InitLocBitmapIterate
function IndirectionTableModel.__default.InitLocBitmapIterate($ly: LayerType, 
    indirectionTable#0: DatatypeType, 
    it#0: DatatypeType, 
    bm#0: Seq Box)
   : DatatypeType;

function IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0: DatatypeType, it#0: DatatypeType, bm#0: Seq Box) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, 
    indirectionTable#0: DatatypeType, 
    it#0: DatatypeType, 
    bm#0: Seq Box :: 
  { IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), indirectionTable#0, it#0, bm#0) } 
  IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), indirectionTable#0, it#0, bm#0)
     == IndirectionTableModel.__default.InitLocBitmapIterate($ly, indirectionTable#0, it#0, bm#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, 
    indirectionTable#0: DatatypeType, 
    it#0: DatatypeType, 
    bm#0: Seq Box :: 
  { IndirectionTableModel.__default.InitLocBitmapIterate(AsFuelBottom($ly), indirectionTable#0, it#0, bm#0) } 
  IndirectionTableModel.__default.InitLocBitmapIterate($ly, indirectionTable#0, it#0, bm#0)
     == IndirectionTableModel.__default.InitLocBitmapIterate($LZ, indirectionTable#0, it#0, bm#0));

// consequence axiom for IndirectionTableModel.__default.InitLocBitmapIterate
axiom true
   ==> (forall $ly: LayerType, 
      indirectionTable#0: DatatypeType, 
      it#0: DatatypeType, 
      bm#0: Seq Box :: 
    { IndirectionTableModel.__default.InitLocBitmapIterate($ly, indirectionTable#0, it#0, bm#0) } 
    IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0, it#0, bm#0)
         || (
          $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && $Is(bm#0, TSeq(TBool))
           && 
          IndirectionTableModel.__default.Inv(indirectionTable#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
            it#0)
           && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0))
           && BitmapModel.__default.Len(bm#0) == LitInt(Bounds.__default.NumBlocks()))
       ==> BitmapModel.__default.Len($Unbox(_System.Tuple2._1(IndirectionTableModel.__default.InitLocBitmapIterate($ly, indirectionTable#0, it#0, bm#0))): Seq Box)
           == LitInt(Bounds.__default.NumBlocks())
         && $Is(IndirectionTableModel.__default.InitLocBitmapIterate($ly, indirectionTable#0, it#0, bm#0), 
          Tclass._System.Tuple2(TBool, TSeq(TBool))));

function IndirectionTableModel.__default.InitLocBitmapIterate#requires(LayerType, DatatypeType, DatatypeType, Seq Box) : bool;

// #requires axiom for IndirectionTableModel.__default.InitLocBitmapIterate
axiom (forall $ly: LayerType, 
    indirectionTable#0: DatatypeType, 
    it#0: DatatypeType, 
    bm#0: Seq Box :: 
  { IndirectionTableModel.__default.InitLocBitmapIterate#requires($ly, indirectionTable#0, it#0, bm#0) } 
  $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
       && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
       && $Is(bm#0, TSeq(TBool))
     ==> IndirectionTableModel.__default.InitLocBitmapIterate#requires($ly, indirectionTable#0, it#0, bm#0)
       == (
        IndirectionTableModel.__default.Inv(indirectionTable#0)
         && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
          it#0)
         && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0))
         && BitmapModel.__default.Len(bm#0) == LitInt(Bounds.__default.NumBlocks())));

// definition axiom for IndirectionTableModel.__default.InitLocBitmapIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      indirectionTable#0: DatatypeType, 
      it#0: DatatypeType, 
      bm#0: Seq Box :: 
    { IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), indirectionTable#0, it#0, bm#0) } 
    IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0, it#0, bm#0)
         || (
          $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && $Is(bm#0, TSeq(TBool))
           && 
          IndirectionTableModel.__default.Inv(indirectionTable#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
            it#0)
           && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0))
           && BitmapModel.__default.Len(bm#0) == LitInt(Bounds.__default.NumBlocks()))
       ==> MutableMapModel.Iterator.Iterator_q(it#0)
         && (!MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
           ==> MutableMapModel.Iterator.Iterator_q(it#0)
             && IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType)
             && DiskLayout.Location.Location_q($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType))): DatatypeType)
             && (var loc#0 := DiskLayout.Location.addr($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType))): DatatypeType); 
              Bounds.__default.NodeBlockSize#canCall()
                 && (var locIndex#0 := Div(loc#0, LitInt(Bounds.__default.NodeBlockSize())); 
                  Bounds.__default.NumBlocks#canCall()
                     && (locIndex#0 < Bounds.__default.NumBlocks()
                       ==> BitmapModel.__default.IsSet#canCall(bm#0, locIndex#0))
                     && (locIndex#0 < Bounds.__default.NumBlocks()
                         && !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, bm#0, locIndex#0)
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                         && MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
                          IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
                          it#0)
                         && BitmapModel.__default.BitSet#canCall(bm#0, locIndex#0)
                         && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0, 
                          MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                            StartFuel_MutableMapModel._default.IterInc, 
                            IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
                            it#0), 
                          BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, locIndex#0))))))
         && IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), indirectionTable#0, it#0, bm#0)
           == (if MutableMapModel.IteratorOutput.Done_q(MutableMapModel.Iterator.next(it#0))
             then #_System._tuple#2._#Make2($Box(Lit(true)), $Box(bm#0))
             else (var loc#0 := DiskLayout.Location.addr($Unbox(Options.Option.value(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(MutableMapModel.Iterator.next(it#0))): DatatypeType))): DatatypeType); 
              (var locIndex#0 := Div(loc#0, LitInt(Bounds.__default.NodeBlockSize())); 
                (if locIndex#0 < Bounds.__default.NumBlocks()
                     && !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, bm#0, locIndex#0)
                   then IndirectionTableModel.__default.InitLocBitmapIterate($ly, 
                    indirectionTable#0, 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
                      it#0), 
                    BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, locIndex#0))
                   else #_System._tuple#2._#Make2($Box(Lit(false)), $Box(bm#0)))))));

// definition axiom for IndirectionTableModel.__default.InitLocBitmapIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      indirectionTable#0: DatatypeType, 
      it#0: DatatypeType, 
      bm#0: Seq Box :: 
    {:weight 3} { IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), indirectionTable#0, Lit(it#0), bm#0) } 
    IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0, Lit(it#0), bm#0)
         || (
          $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && $Is(bm#0, TSeq(TBool))
           && 
          IndirectionTableModel.__default.Inv(indirectionTable#0)
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
            Lit(it#0))
           && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0))
           && BitmapModel.__default.Len(bm#0) == LitInt(Bounds.__default.NumBlocks()))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.Entry.Entry_q(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))
             && DiskLayout.Location.Location_q(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))))): DatatypeType))
             && (var loc#1 := LitInt(DiskLayout.Location.addr(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))))): DatatypeType))); 
              Bounds.__default.NodeBlockSize#canCall()
                 && (var locIndex#1 := Div(loc#1, LitInt(Bounds.__default.NodeBlockSize())); 
                  Bounds.__default.NumBlocks#canCall()
                     && (locIndex#1 < Bounds.__default.NumBlocks()
                       ==> BitmapModel.__default.IsSet#canCall(bm#0, locIndex#1))
                     && (locIndex#1 < Bounds.__default.NumBlocks()
                         && !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, bm#0, locIndex#1)
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                         && MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
                          IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
                          Lit(it#0))
                         && BitmapModel.__default.BitSet#canCall(bm#0, locIndex#1)
                         && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0, 
                          MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                            StartFuel_MutableMapModel._default.IterInc, 
                            IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
                            Lit(it#0)), 
                          BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, locIndex#1))))))
         && IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), indirectionTable#0, Lit(it#0), bm#0)
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then #_System._tuple#2._#Make2($Box(Lit(true)), $Box(bm#0))
             else (var loc#1 := LitInt(DiskLayout.Location.addr(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))))): DatatypeType))); 
              (var locIndex#1 := LitInt(Div(loc#1, LitInt(Bounds.__default.NodeBlockSize()))); 
                (if locIndex#1 < Bounds.__default.NumBlocks()
                     && !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, bm#0, locIndex#1)
                   then IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), 
                    indirectionTable#0, 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      IndirectionTableModel.IndirectionTable.t(indirectionTable#0), 
                      Lit(it#0)), 
                    BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, bm#0, locIndex#1))
                   else #_System._tuple#2._#Make2($Box(Lit(false)), $Box(bm#0)))))));

// definition axiom for IndirectionTableModel.__default.InitLocBitmapIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, 
      indirectionTable#0: DatatypeType, 
      it#0: DatatypeType, 
      bm#0: Seq Box :: 
    {:weight 3} { IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), Lit(indirectionTable#0), Lit(it#0), Lit(bm#0)) } 
    IndirectionTableModel.__default.InitLocBitmapIterate#canCall(Lit(indirectionTable#0), Lit(it#0), Lit(bm#0))
         || (
          $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.Iterator(Tclass.IndirectionTableModel.Entry()))
           && $Is(bm#0, TSeq(TBool))
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(indirectionTable#0)))
           && MutableMapModel.__default.WFIter(Tclass.IndirectionTableModel.Entry(), 
            Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0))), 
            Lit(it#0))
           && Lit(BlockCache.__default.WFCompleteIndirectionTable(Lit(IndirectionTableModel.__default.I(Lit(indirectionTable#0)))))
           && LitInt(BitmapModel.__default.Len(Lit(bm#0)))
             == LitInt(Bounds.__default.NumBlocks()))
       ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
         && (!Lit(MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0)))))
           ==> MutableMapModel.Iterator.Iterator_q(Lit(it#0))
             && IndirectionTableModel.Entry.Entry_q(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))
             && DiskLayout.Location.Location_q(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))))): DatatypeType))
             && (var loc#2 := LitInt(DiskLayout.Location.addr(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))))): DatatypeType))); 
              Bounds.__default.NodeBlockSize#canCall()
                 && (var locIndex#2 := Div(loc#2, LitInt(Bounds.__default.NodeBlockSize())); 
                  Bounds.__default.NumBlocks#canCall()
                     && (locIndex#2 < Bounds.__default.NumBlocks()
                       ==> BitmapModel.__default.IsSet#canCall(Lit(bm#0), locIndex#2))
                     && (locIndex#2 < Bounds.__default.NumBlocks()
                         && !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, Lit(bm#0), locIndex#2)
                       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                         && MutableMapModel.__default.IterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
                          Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0))), 
                          Lit(it#0))
                         && BitmapModel.__default.BitSet#canCall(Lit(bm#0), locIndex#2)
                         && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(Lit(indirectionTable#0), 
                          MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                            StartFuel_MutableMapModel._default.IterInc, 
                            Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0))), 
                            Lit(it#0)), 
                          BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, Lit(bm#0), locIndex#2))))))
         && IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), Lit(indirectionTable#0), Lit(it#0), Lit(bm#0))
           == (if MutableMapModel.IteratorOutput.Done_q(Lit(MutableMapModel.Iterator.next(Lit(it#0))))
             then #_System._tuple#2._#Make2($Box(Lit(true)), $Box(Lit(bm#0)))
             else (var loc#2 := LitInt(DiskLayout.Location.addr(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.Entry.loc(Lit($Unbox(MutableMapModel.IteratorOutput.value(Lit(MutableMapModel.Iterator.next(Lit(it#0))))): DatatypeType))))): DatatypeType))); 
              (var locIndex#2 := LitInt(Div(loc#2, LitInt(Bounds.__default.NodeBlockSize()))); 
                (if locIndex#2 < Bounds.__default.NumBlocks()
                     && !BitmapModel.__default.IsSet(StartFuel_BitmapModel._default.IsSet, Lit(bm#0), locIndex#2)
                   then IndirectionTableModel.__default.InitLocBitmapIterate($LS($ly), 
                    Lit(indirectionTable#0), 
                    MutableMapModel.__default.IterInc(Tclass.IndirectionTableModel.Entry(), 
                      StartFuel_MutableMapModel._default.IterInc, 
                      Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0))), 
                      Lit(it#0)), 
                    BitmapModel.__default.BitSet(StartFuel_BitmapModel._default.BitSet, Lit(bm#0), locIndex#2))
                   else #_System._tuple#2._#Make2($Box(Lit(false)), $Box(Lit(bm#0))))))));

// function declaration for IndirectionTableModel._default.InitLocBitmap
function IndirectionTableModel.__default.InitLocBitmap($ly: LayerType, indirectionTable#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.InitLocBitmap#canCall(indirectionTable#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, indirectionTable#0: DatatypeType :: 
  { IndirectionTableModel.__default.InitLocBitmap($LS($ly), indirectionTable#0) } 
  IndirectionTableModel.__default.InitLocBitmap($LS($ly), indirectionTable#0)
     == IndirectionTableModel.__default.InitLocBitmap($ly, indirectionTable#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, indirectionTable#0: DatatypeType :: 
  { IndirectionTableModel.__default.InitLocBitmap(AsFuelBottom($ly), indirectionTable#0) } 
  IndirectionTableModel.__default.InitLocBitmap($ly, indirectionTable#0)
     == IndirectionTableModel.__default.InitLocBitmap($LZ, indirectionTable#0));

// consequence axiom for IndirectionTableModel.__default.InitLocBitmap
axiom true
   ==> (forall $ly: LayerType, indirectionTable#0: DatatypeType :: 
    { IndirectionTableModel.__default.InitLocBitmap($ly, indirectionTable#0) } 
    IndirectionTableModel.__default.InitLocBitmap#canCall(indirectionTable#0)
         || ($Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          IndirectionTableModel.__default.Inv(indirectionTable#0)
           && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0)))
       ==> BitmapModel.__default.Len($Unbox(_System.Tuple2._1(IndirectionTableModel.__default.InitLocBitmap($ly, indirectionTable#0))): Seq Box)
           == LitInt(Bounds.__default.NumBlocks())
         && $Is(IndirectionTableModel.__default.InitLocBitmap($ly, indirectionTable#0), 
          Tclass._System.Tuple2(TBool, TSeq(TBool))));

function IndirectionTableModel.__default.InitLocBitmap#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.InitLocBitmap
axiom (forall $ly: LayerType, indirectionTable#0: DatatypeType :: 
  { IndirectionTableModel.__default.InitLocBitmap#requires($ly, indirectionTable#0) } 
  $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.InitLocBitmap#requires($ly, indirectionTable#0)
       == (IndirectionTableModel.__default.Inv(indirectionTable#0)
         && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0))));

// definition axiom for IndirectionTableModel.__default.InitLocBitmap(revealed)
axiom true
   ==> (forall $ly: LayerType, indirectionTable#0: DatatypeType :: 
    { IndirectionTableModel.__default.InitLocBitmap($LS($ly), indirectionTable#0) } 
    IndirectionTableModel.__default.InitLocBitmap#canCall(indirectionTable#0)
         || ($Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          IndirectionTableModel.__default.Inv(indirectionTable#0)
           && BlockCache.__default.WFCompleteIndirectionTable(IndirectionTableModel.__default.I(indirectionTable#0)))
       ==> Bounds.__default.NumBlocks#canCall()
         && BitmapModel.__default.EmptyBitmap#canCall(LitInt(Bounds.__default.NumBlocks()))
         && (var bm#0 := BitmapModel.__default.EmptyBitmap(StartFuel_BitmapModel._default.EmptyBitmap, LitInt(Bounds.__default.NumBlocks())); 
          Bounds.__default.MinNodeBlockIndexUint64#canCall()
             && IndirectionTableModel.__default.BitmapInitUpTo#canCall(bm#0, LitInt(Bounds.__default.MinNodeBlockIndexUint64()))
             && (var bm'#0 := IndirectionTableModel.__default.BitmapInitUpTo(StartFuel_IndirectionTableModel._default.BitmapInitUpTo, 
                  bm#0, 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())); 
              IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                 && MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(indirectionTable#0))
                 && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(indirectionTable#0, 
                  MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterStart, 
                    IndirectionTableModel.IndirectionTable.t(indirectionTable#0)), 
                  bm'#0)))
         && IndirectionTableModel.__default.InitLocBitmap($LS($ly), indirectionTable#0)
           == (var bm#0 := BitmapModel.__default.EmptyBitmap(StartFuel_BitmapModel._default.EmptyBitmap, LitInt(Bounds.__default.NumBlocks())); 
            (var bm'#0 := IndirectionTableModel.__default.BitmapInitUpTo(StartFuel_IndirectionTableModel._default.BitmapInitUpTo, 
                  bm#0, 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())); 
              IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
                indirectionTable#0, 
                MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.IterStart, 
                  IndirectionTableModel.IndirectionTable.t(indirectionTable#0)), 
                bm'#0))));

// definition axiom for IndirectionTableModel.__default.InitLocBitmap for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, indirectionTable#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.InitLocBitmap($LS($ly), Lit(indirectionTable#0)) } 
    IndirectionTableModel.__default.InitLocBitmap#canCall(Lit(indirectionTable#0))
         || ($Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(indirectionTable#0)))
           && Lit(BlockCache.__default.WFCompleteIndirectionTable(Lit(IndirectionTableModel.__default.I(Lit(indirectionTable#0))))))
       ==> Bounds.__default.NumBlocks#canCall()
         && BitmapModel.__default.EmptyBitmap#canCall(LitInt(Bounds.__default.NumBlocks()))
         && (var bm#1 := BitmapModel.__default.EmptyBitmap(StartFuel_BitmapModel._default.EmptyBitmap, LitInt(Bounds.__default.NumBlocks())); 
          Bounds.__default.MinNodeBlockIndexUint64#canCall()
             && IndirectionTableModel.__default.BitmapInitUpTo#canCall(bm#1, LitInt(Bounds.__default.MinNodeBlockIndexUint64()))
             && (var bm'#1 := IndirectionTableModel.__default.BitmapInitUpTo(StartFuel_IndirectionTableModel._default.BitmapInitUpTo, 
                  bm#1, 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())); 
              IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                 && MutableMapModel.__default.IterStart#canCall(Tclass.IndirectionTableModel.Entry(), 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0))))
                 && IndirectionTableModel.__default.InitLocBitmapIterate#canCall(Lit(indirectionTable#0), 
                  MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.IterStart, 
                    Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0)))), 
                  bm'#1)))
         && IndirectionTableModel.__default.InitLocBitmap($LS($ly), Lit(indirectionTable#0))
           == (var bm#1 := BitmapModel.__default.EmptyBitmap(StartFuel_BitmapModel._default.EmptyBitmap, LitInt(Bounds.__default.NumBlocks())); 
            (var bm'#1 := IndirectionTableModel.__default.BitmapInitUpTo(StartFuel_IndirectionTableModel._default.BitmapInitUpTo, 
                  bm#1, 
                  LitInt(Bounds.__default.MinNodeBlockIndexUint64())); 
              IndirectionTableModel.__default.InitLocBitmapIterate($LS($LZ), 
                Lit(indirectionTable#0), 
                MutableMapModel.__default.IterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.IterStart, 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(indirectionTable#0)))), 
                bm'#1))));

// function declaration for IndirectionTableModel._default.IsLocAllocIndirectionTablePartial
function IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(indirectionTable#0: DatatypeType, i#0: int, s#0: Set Box) : bool;

function IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#canCall(indirectionTable#0: DatatypeType, i#0: int, s#0: Set Box) : bool;

// consequence axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial
axiom true
   ==> (forall indirectionTable#0: DatatypeType, i#0: int, s#0: Set Box :: 
    { IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(indirectionTable#0, i#0, s#0) } 
    IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#canCall(indirectionTable#0, i#0, s#0)
         || ($Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64())))
       ==> true);

function IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#requires(DatatypeType, int, Set Box) : bool;

// #requires axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial
axiom (forall indirectionTable#0: DatatypeType, i#0: int, s#0: Set Box :: 
  { IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#requires(indirectionTable#0, i#0, s#0) } 
  $Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
       && $Is(s#0, TSet(Tclass.NativeTypes.uint64()))
     ==> IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#requires(indirectionTable#0, i#0, s#0)
       == true);

// definition axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, i#0: int, s#0: Set Box :: 
    { IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(indirectionTable#0, i#0, s#0) } 
    IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#canCall(indirectionTable#0, i#0, s#0)
         || ($Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64())))
       ==> (LitInt(0) <= i#0 ==> Bounds.__default.MinNodeBlockIndex#canCall())
         && (Bounds.__default.MinNodeBlockIndex#canCall()
             && Bounds.__default.MinNodeBlockIndex() <= i#0
           ==> (forall ref#0: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType } 
              { s#0[$Box(ref#0)] } 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)] } 
            LitInt(0) <= ref#0 && ref#0 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
                     && s#0[$Box(ref#0)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(indirectionTable#0)
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType)
                     && Bounds.__default.NodeBlockSize#canCall())))
         && IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(indirectionTable#0, i#0, s#0)
           == ((LitInt(0) <= i#0 && i#0 < Bounds.__default.MinNodeBlockIndex())
             || !(forall ref#0: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType } 
                { s#0[$Box(ref#0)] } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)] } 
              LitInt(0) <= ref#0
                   && ref#0 < 18446744073709551616
                   && 
                  Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]
                   && s#0[$Box(ref#0)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#0)]): DatatypeType)
                   != Mul(i#0, LitInt(Bounds.__default.NodeBlockSize())))));

// definition axiom for IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial for all literals(revealed)
axiom true
   ==> (forall indirectionTable#0: DatatypeType, i#0: int, s#0: Set Box :: 
    {:weight 3} { IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(Lit(indirectionTable#0), LitInt(i#0), Lit(s#0)) } 
    IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial#canCall(Lit(indirectionTable#0), LitInt(i#0), Lit(s#0))
         || ($Is(indirectionTable#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(s#0, TSet(Tclass.NativeTypes.uint64())))
       ==> (LitInt(0) <= LitInt(i#0) ==> Bounds.__default.MinNodeBlockIndex#canCall())
         && (Bounds.__default.MinNodeBlockIndex#canCall()
             && !Lit(i#0 < Bounds.__default.MinNodeBlockIndex())
           ==> (forall ref#1: int :: 
            { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)]): DatatypeType } 
              { s#0[$Box(ref#1)] } 
              { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)] } 
            LitInt(0) <= ref#1 && ref#1 < 18446744073709551616
               ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                 && (Map#Domain(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#1)]
                     && Lit(s#0)[$Box(ref#1)]
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(indirectionTable#0))
                     && DiskLayout.Location.Location_q($Unbox(Map#Elements(Lit(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(ref#1)]): DatatypeType)
                     && Bounds.__default.NodeBlockSize#canCall())))
         && IndirectionTableModel.__default.IsLocAllocIndirectionTablePartial(Lit(indirectionTable#0), LitInt(i#0), Lit(s#0))
           == ((LitInt(0) <= LitInt(i#0) && i#0 < Bounds.__default.MinNodeBlockIndex())
             || !(forall ref#1: int :: 
              { $Unbox(Map#Elements(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)]): DatatypeType } 
                { s#0[$Box(ref#1)] } 
                { Map#Domain(IndirectionTableModel.IndirectionTable.locs(indirectionTable#0))[$Box(ref#1)] } 
              LitInt(0) <= ref#1
                   && ref#1 < 18446744073709551616
                   && 
                  Map#Domain(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0)))[$Box(ref#1)]
                   && Lit(s#0)[$Box(ref#1)]
                 ==> DiskLayout.Location.addr($Unbox(Map#Elements(Lit(IndirectionTableModel.IndirectionTable.locs(Lit(indirectionTable#0))))[$Box(ref#1)]): DatatypeType)
                   != Mul(LitInt(i#0), LitInt(Bounds.__default.NodeBlockSize())))));

// function declaration for IndirectionTableModel._default.deallocable
function IndirectionTableModel.__default.deallocable(self#0: DatatypeType, ref#0: int) : bool;

function IndirectionTableModel.__default.deallocable#canCall(self#0: DatatypeType, ref#0: int) : bool;

// consequence axiom for IndirectionTableModel.__default.deallocable
axiom true
   ==> (forall self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.deallocable(self#0, ref#0) } 
    IndirectionTableModel.__default.deallocable#canCall(self#0, ref#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> true);

function IndirectionTableModel.__default.deallocable#requires(DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.deallocable
axiom (forall self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.deallocable#requires(self#0, ref#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.deallocable#requires(self#0, ref#0) == true);

// definition axiom for IndirectionTableModel.__default.deallocable(revealed)
axiom true
   ==> (forall self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.deallocable(self#0, ref#0) } 
    IndirectionTableModel.__default.deallocable#canCall(self#0, ref#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.I#canCall(self#0)
         && SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(self#0))
         && (Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(ref#0)]
           ==> PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.__default.Root#canCall()
             && ref#0 != PivotBetreeGraph.__default.Root()
           ==> (forall r#0: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]): Seq Box } 
              { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)] } 
            LitInt(0) <= r#0 && r#0 < 18446744073709551616
               ==> IndirectionTableModel.__default.I#canCall(self#0)
                 && SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(self#0))
                 && (Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]
                   ==> IndirectionTableModel.__default.I#canCall(self#0)
                     && SectorType.IndirectionTable.IndirectionTable_q(IndirectionTableModel.__default.I(self#0)))))
         && IndirectionTableModel.__default.deallocable(self#0, ref#0)
           == (
            Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(ref#0)]
             && ref#0 != PivotBetreeGraph.__default.Root()
             && (forall r#0: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]): Seq Box } 
                { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)] } 
              LitInt(0) <= r#0
                   && r#0 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]
                 ==> !Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]): Seq Box, 
                  $Box(ref#0)))));

// definition axiom for IndirectionTableModel.__default.deallocable for all literals(revealed)
axiom true
   ==> (forall self#0: DatatypeType, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.deallocable(Lit(self#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.deallocable#canCall(Lit(self#0), LitInt(ref#0))
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616)
       ==> IndirectionTableModel.__default.I#canCall(Lit(self#0))
         && SectorType.IndirectionTable.IndirectionTable_q(Lit(IndirectionTableModel.__default.I(Lit(self#0))))
         && (Map#Domain(SectorType.IndirectionTable.graph(Lit(IndirectionTableModel.__default.I(Lit(self#0)))))[$Box(ref#0)]
           ==> PivotBetreeGraph.__default.Root#canCall())
         && (PivotBetreeGraph.__default.Root#canCall()
             && Lit(ref#0 != PivotBetreeGraph.__default.Root())
           ==> (forall r#1: int :: 
            { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#1)]): Seq Box } 
              { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#1)] } 
            LitInt(0) <= r#1 && r#1 < 18446744073709551616
               ==> IndirectionTableModel.__default.I#canCall(Lit(self#0))
                 && SectorType.IndirectionTable.IndirectionTable_q(Lit(IndirectionTableModel.__default.I(Lit(self#0))))
                 && (Map#Domain(SectorType.IndirectionTable.graph(Lit(IndirectionTableModel.__default.I(Lit(self#0)))))[$Box(r#1)]
                   ==> IndirectionTableModel.__default.I#canCall(Lit(self#0))
                     && SectorType.IndirectionTable.IndirectionTable_q(Lit(IndirectionTableModel.__default.I(Lit(self#0)))))))
         && IndirectionTableModel.__default.deallocable(Lit(self#0), LitInt(ref#0))
           == (
            Map#Domain(SectorType.IndirectionTable.graph(Lit(IndirectionTableModel.__default.I(Lit(self#0)))))[$Box(ref#0)]
             && ref#0 != PivotBetreeGraph.__default.Root()
             && (forall r#1: int :: 
              { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#1)]): Seq Box } 
                { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#1)] } 
              LitInt(0) <= r#1
                   && r#1 < 18446744073709551616
                   && Map#Domain(SectorType.IndirectionTable.graph(Lit(IndirectionTableModel.__default.I(Lit(self#0)))))[$Box(r#1)]
                 ==> !Seq#Contains($Unbox(Map#Elements(Lit(SectorType.IndirectionTable.graph(Lit(IndirectionTableModel.__default.I(Lit(self#0))))))[$Box(r#1)]): Seq Box, 
                  $Box(ref#0)))));

// function declaration for IndirectionTableModel._default.FindDeallocable
function IndirectionTableModel.__default.FindDeallocable($ly: LayerType, self#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.FindDeallocable#canCall(self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindDeallocable($LS($ly), self#0) } 
  IndirectionTableModel.__default.FindDeallocable($LS($ly), self#0)
     == IndirectionTableModel.__default.FindDeallocable($ly, self#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindDeallocable(AsFuelBottom($ly), self#0) } 
  IndirectionTableModel.__default.FindDeallocable($ly, self#0)
     == IndirectionTableModel.__default.FindDeallocable($LZ, self#0));

// consequence axiom for IndirectionTableModel.__default.FindDeallocable
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.FindDeallocable($ly, self#0) } 
    IndirectionTableModel.__default.FindDeallocable#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0))
       ==> $Is(IndirectionTableModel.__default.FindDeallocable($ly, self#0), 
        Tclass.Options.Option(Tclass.NativeTypes.uint64())));

function IndirectionTableModel.__default.FindDeallocable#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.FindDeallocable
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindDeallocable#requires($ly, self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.FindDeallocable#requires($ly, self#0)
       == (IndirectionTableModel.__default.Inv(self#0)
         && IndirectionTableModel.__default.TrackingGarbage(self#0)));

// definition axiom for IndirectionTableModel.__default.FindDeallocable(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.FindDeallocable($LS($ly), self#0) } 
    IndirectionTableModel.__default.FindDeallocable#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && LruModel.__default.NextOpt#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box)
         && IndirectionTableModel.__default.FindDeallocable($LS($ly), self#0)
           == LruModel.__default.NextOpt(StartFuel_LruModel._default.NextOpt, 
            $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box));

// definition axiom for IndirectionTableModel.__default.FindDeallocable for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.FindDeallocable($LS($ly), Lit(self#0)) } 
    IndirectionTableModel.__default.FindDeallocable#canCall(Lit(self#0))
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(self#0)))
           && Lit(IndirectionTableModel.__default.TrackingGarbage(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && LruModel.__default.NextOpt#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box))
         && IndirectionTableModel.__default.FindDeallocable($LS($ly), Lit(self#0))
           == LruModel.__default.NextOpt(StartFuel_LruModel._default.NextOpt, 
            Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box)));

procedure {:_induction ref#0} CheckWellformed$$IndirectionTableModel.__default.LemmaRemoveRefStuff(self#0: DatatypeType
       where $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
         && $IsAlloc(self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap)
         && $IsA#IndirectionTableModel.IndirectionTable(self#0), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616);
  free requires 100 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure {:_induction ref#0} Call$$IndirectionTableModel.__default.LemmaRemoveRefStuff(self#0: DatatypeType
       where $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
         && $IsAlloc(self#0, Tclass.IndirectionTableModel.IndirectionTable(), $Heap)
         && $IsA#IndirectionTableModel.IndirectionTable(self#0), 
    ref#0: int where LitInt(0) <= ref#0 && ref#0 < 18446744073709551616);
  // user-defined preconditions
  requires IndirectionTableModel.__default.Inv(self#0);
  requires IndirectionTableModel.__default.TrackingGarbage#canCall(self#0)
     ==> IndirectionTableModel.__default.TrackingGarbage(self#0)
       || Options.Option.Some_q(IndirectionTableModel.IndirectionTable.garbageQueue(self#0));
  requires Map#Domain(MutableMapModel.LinearHashMap.contents(IndirectionTableModel.IndirectionTable.t(self#0)))[$Box(ref#0)];
  requires IndirectionTableModel.__default.deallocable#canCall(self#0, ref#0)
     ==> IndirectionTableModel.__default.deallocable(self#0, ref#0)
       || Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(ref#0)];
  requires IndirectionTableModel.__default.deallocable#canCall(self#0, ref#0)
     ==> IndirectionTableModel.__default.deallocable(self#0, ref#0)
       || ref#0 != PivotBetreeGraph.__default.Root();
  requires IndirectionTableModel.__default.deallocable#canCall(self#0, ref#0)
     ==> IndirectionTableModel.__default.deallocable(self#0, ref#0)
       || (forall r#0: int :: 
        { $Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]): Seq Box } 
          { Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)] } 
        LitInt(0) <= r#0
             && r#0 < 18446744073709551616
             && Map#Domain(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]
           ==> !Seq#Contains($Unbox(Map#Elements(SectorType.IndirectionTable.graph(IndirectionTableModel.__default.I(self#0)))[$Box(r#0)]): Seq Box, 
            $Box(ref#0)));
  requires MutableMapModel.LinearHashMap.count(IndirectionTableModel.IndirectionTable.t(self#0))
     < Div(18446744073709551616, LitInt(8)) - 1;
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
     && MutableMapModel.__default.RemoveAndGet#canCall(Tclass.IndirectionTableModel.Entry(), 
      IndirectionTableModel.IndirectionTable.t(self#0), 
      ref#0)
     && (var t#0, oldEntry#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0))): DatatypeType, 
        $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              ref#0))): DatatypeType; 
      IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && LruModel.__default.Remove#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
          ref#0)
         && (var q#0 := LruModel.__default.Remove($LS($LZ), 
              $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
              ref#0); 
          IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
             && IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, 
              q#0, 
              ref#0, 
              Lit(Seq#Empty(): Seq Box), 
              IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
              LitInt(0), 
              LitInt(0))));
  free ensures (var t#0, oldEntry#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            ref#0))): DatatypeType, 
      $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            ref#0))): DatatypeType; 
    (var q#0 := LruModel.__default.Remove($LS($LS($LZ)), 
          $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
          ref#0); 
      IndirectionTableModel.__default.RefcountUpdateInv#canCall(t#0, 
          q#0, 
          ref#0, 
          Lit(Seq#Empty(): Seq Box), 
          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
          LitInt(0), 
          LitInt(0))
         && 
        IndirectionTableModel.__default.RefcountUpdateInv(StartFuel_IndirectionTableModel._default.RefcountUpdateInv, 
          t#0, 
          q#0, 
          ref#0, 
          Lit(Seq#Empty(): Seq Box), 
          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
          LitInt(0), 
          LitInt(0))
         && 
        MutableMapModel.__default.Inv(Tclass.IndirectionTableModel.Entry(), t#0)
         && LruModel.__default.WF(q#0)
         && MutableMapModel.LinearHashMap.count(t#0)
           <= LitInt(IndirectionTableModel.__default.MaxSize())
         && Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
           <= LitInt(Bounds.__default.MaxNumChildren())
         && Seq#Length(Lit(Seq#Empty(): Seq Box))
           <= LitInt(Bounds.__default.MaxNumChildren())
         && (forall ref#1: int :: 
          { $Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#1)]): Seq Box } 
            { Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#1)] } 
          LitInt(0) <= ref#1
               && ref#1 < 18446744073709551616
               && Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#1)]
             ==> Seq#Length($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#1)]): Seq Box)
               <= LitInt(Bounds.__default.MaxNumChildren()))
         && 
        LitInt(0) <= LitInt(0)
         && LitInt(0) <= Seq#Length(Lit(Seq#Empty(): Seq Box))
         && 
        LitInt(0) <= LitInt(0)
         && LitInt(0)
           <= Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
         && (Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]
           ==> Seq#Equal($Unbox(Map#Elements(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]): Seq Box, 
            Seq#Empty(): Seq Box))
         && (!Map#Domain(IndirectionTableModel.__default.Graph(t#0))[$Box(ref#0)]
           ==> Seq#Equal(Seq#Empty(): Seq Box, Seq#Empty(): Seq Box))
         && IndirectionTableModel.__default.ValidPredCountsIntermediate(IndirectionTableModel.__default.PredCounts(t#0), 
          IndirectionTableModel.__default.Graph(t#0), 
          Lit(Seq#Empty(): Seq Box), 
          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
          LitInt(0), 
          LitInt(0))
         && (forall j#0: int :: 
          { $Unbox(Seq#Index(IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
                j#0)): int } 
          LitInt(0) <= j#0
               && j#0
                 < Seq#Length(IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType))
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[Seq#Index(IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
              j#0)])
         && BlockCache.__default.GraphClosed(IndirectionTableModel.__default.Graph(t#0))
         && (forall ref#4: int :: 
          { LruModel.__default.I(q#0)[$Box(ref#4)] } 
            { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)] } 
          LitInt(0) <= ref#4
               && ref#4 < 18446744073709551616
               && 
              Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#4)]): DatatypeType)
                 == LitInt(0)
             ==> LruModel.__default.I(q#0)[$Box(ref#4)])
         && (forall ref#5: int :: 
          { $Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType } 
            { Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)] } 
            { LruModel.__default.I(q#0)[$Box(ref#5)] } 
          LitInt(0) <= ref#5
               && ref#5 < 18446744073709551616
               && LruModel.__default.I(q#0)[$Box(ref#5)]
             ==> Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]
               && IndirectionTableModel.Entry.predCount($Unbox(Map#Elements(MutableMapModel.LinearHashMap.contents(t#0))[$Box(ref#5)]): DatatypeType)
                 == LitInt(0))
         && Map#Domain(MutableMapModel.LinearHashMap.contents(t#0))[$Box(PivotBetreeGraph.__default.Root())]));
  // frame condition
  free ensures old($Heap) == $Heap;



// function declaration for IndirectionTableModel._default.RemoveRef
function IndirectionTableModel.__default.RemoveRef($ly: LayerType, self#0: DatatypeType, ref#0: int) : DatatypeType;

function IndirectionTableModel.__default.RemoveRef#canCall(self#0: DatatypeType, ref#0: int) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.RemoveRef($LS($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.RemoveRef($LS($ly), self#0, ref#0)
     == IndirectionTableModel.__default.RemoveRef($ly, self#0, ref#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.RemoveRef(AsFuelBottom($ly), self#0, ref#0) } 
  IndirectionTableModel.__default.RemoveRef($ly, self#0, ref#0)
     == IndirectionTableModel.__default.RemoveRef($LZ, self#0, ref#0));

// consequence axiom for IndirectionTableModel.__default.RemoveRef
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.RemoveRef($ly, self#0, ref#0) } 
    IndirectionTableModel.__default.RemoveRef#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0)
           && IndirectionTableModel.__default.deallocable(self#0, ref#0))
       ==> (var self'#0, oldLoc#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.RemoveRef($ly, self#0, ref#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.RemoveRef($ly, self#0, ref#0))): DatatypeType; 
          IndirectionTableModel.__default.Inv(self'#0)
             && IndirectionTableModel.__default.TrackingGarbage(self'#0)
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self'#0), 
              Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                TSeq(Tclass.NativeTypes.uint64()), 
                StartFuel_Maps._default.MapRemove1, 
                IndirectionTableModel.IndirectionTable.graph(self#0), 
                $Box(ref#0)))
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
              Maps.__default.MapRemove1(Tclass.NativeTypes.uint64(), 
                Tclass.DiskLayout.Location(), 
                StartFuel_Maps._default.MapRemove1, 
                IndirectionTableModel.IndirectionTable.locs(self#0), 
                $Box(ref#0)))
             && (Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
               ==> Options.Option#Equal(oldLoc#0, 
                #Options.Option.Some(Map#Elements(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)])))
             && (!Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(ref#0)]
               ==> Options.Option#Equal(oldLoc#0, #Options.Option.None())))
         && $Is(IndirectionTableModel.__default.RemoveRef($ly, self#0, ref#0), 
          Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
            Tclass.Options.Option(Tclass.DiskLayout.Location()))));

function IndirectionTableModel.__default.RemoveRef#requires(LayerType, DatatypeType, int) : bool;

// #requires axiom for IndirectionTableModel.__default.RemoveRef
axiom (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
  { IndirectionTableModel.__default.RemoveRef#requires($ly, self#0, ref#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && 
      LitInt(0) <= ref#0
       && ref#0 < 18446744073709551616
     ==> IndirectionTableModel.__default.RemoveRef#requires($ly, self#0, ref#0)
       == (
        IndirectionTableModel.__default.Inv(self#0)
         && IndirectionTableModel.__default.TrackingGarbage(self#0)
         && IndirectionTableModel.__default.deallocable(self#0, ref#0)));

// definition axiom for IndirectionTableModel.__default.RemoveRef(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    { IndirectionTableModel.__default.RemoveRef($LS($ly), self#0, ref#0) } 
    IndirectionTableModel.__default.RemoveRef#canCall(self#0, ref#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && IndirectionTableModel.__default.TrackingGarbage(self#0)
           && IndirectionTableModel.__default.deallocable(self#0, ref#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.RemoveAndGet#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          ref#0)
         && (var t#0, oldEntry#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  ref#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                  IndirectionTableModel.IndirectionTable.t(self#0), 
                  ref#0))): DatatypeType; 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && LruModel.__default.Remove#canCall($Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
              ref#0)
             && (var q#0 := LruModel.__default.Remove($LS($LZ), 
                  $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                  ref#0); 
              IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                 && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#0, 
                  q#0, 
                  ref#0, 
                  Lit(Seq#Empty(): Seq Box), 
                  IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
                  LitInt(0))
                 && (var t1#0, q1#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                          t#0, 
                          q#0, 
                          ref#0, 
                          Lit(Seq#Empty(): Seq Box), 
                          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
                          LitInt(0)))): DatatypeType, 
                    $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                          t#0, 
                          q#0, 
                          ref#0, 
                          Lit(Seq#Empty(): Seq Box), 
                          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
                          LitInt(0)))): Seq Box; 
                  IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && IndirectionTableModel.__default.FromHashMap#canCall(t1#0, 
                      #Options.Option.Some($Box(q1#0)), 
                      IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
                      Lit(#Options.Option.None()))
                     && (Options.Option.Some_q(oldEntry#0)
                       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)))))
         && IndirectionTableModel.__default.RemoveRef($LS($ly), self#0, ref#0)
           == (var t#0, oldEntry#0 := $Unbox(_System.Tuple2._0(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                    IndirectionTableModel.IndirectionTable.t(self#0), 
                    ref#0))): DatatypeType, 
              $Unbox(_System.Tuple2._1(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                    IndirectionTableModel.IndirectionTable.t(self#0), 
                    ref#0))): DatatypeType; 
            (var q#0 := LruModel.__default.Remove($LS($LZ), 
                  $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.garbageQueue(self#0))): Seq Box, 
                  ref#0); 
              (var t1#0, q1#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                        t#0, 
                        q#0, 
                        ref#0, 
                        Lit(Seq#Empty(): Seq Box), 
                        IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
                        LitInt(0)))): DatatypeType, 
                  $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                        t#0, 
                        q#0, 
                        ref#0, 
                        Lit(Seq#Empty(): Seq Box), 
                        IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#0)): DatatypeType), 
                        LitInt(0)))): Seq Box; 
                (var self'#1 := IndirectionTableModel.__default.FromHashMap(t1#0, 
                      #Options.Option.Some($Box(q1#0)), 
                      IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
                      Lit(#Options.Option.None())); 
                  (var oldLoc#1 := (if Options.Option.Some_q(oldEntry#0)
                         then IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#0)): DatatypeType)
                         else #Options.Option.None()); 
                    #_System._tuple#2._#Make2($Box(self'#1), $Box(oldLoc#1))))))));

// definition axiom for IndirectionTableModel.__default.RemoveRef for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, ref#0: int :: 
    {:weight 3} { IndirectionTableModel.__default.RemoveRef($LS($ly), Lit(self#0), LitInt(ref#0)) } 
    IndirectionTableModel.__default.RemoveRef#canCall(Lit(self#0), LitInt(ref#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && 
          LitInt(0) <= ref#0
           && ref#0 < 18446744073709551616
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(self#0)))
           && Lit(IndirectionTableModel.__default.TrackingGarbage(Lit(self#0)))
           && Lit(IndirectionTableModel.__default.deallocable(Lit(self#0), LitInt(ref#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.RemoveAndGet#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          LitInt(ref#0))
         && (var t#1, oldEntry#1 := $Unbox(_System.Tuple2._0(Lit(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                    Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                    LitInt(ref#0))))): DatatypeType, 
            $Unbox(_System.Tuple2._1(Lit(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                    Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                    LitInt(ref#0))))): DatatypeType; 
          IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && LruModel.__default.Remove#canCall(Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box), 
              LitInt(ref#0))
             && (var q#1 := Lit(LruModel.__default.Remove($LS($LZ), 
                    Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box), 
                    LitInt(ref#0))); 
              IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                 && IndirectionTableModel.__default.UpdatePredCountsInc#canCall(t#1, 
                  q#1, 
                  LitInt(ref#0), 
                  Lit(Seq#Empty(): Seq Box), 
                  IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType), 
                  LitInt(0))
                 && (var t1#1, q1#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                          t#1, 
                          q#1, 
                          LitInt(ref#0), 
                          Lit(Seq#Empty(): Seq Box), 
                          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType), 
                          LitInt(0)))): DatatypeType, 
                    $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                          t#1, 
                          q#1, 
                          LitInt(ref#0), 
                          Lit(Seq#Empty(): Seq Box), 
                          IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType), 
                          LitInt(0)))): Seq Box; 
                  IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                     && IndirectionTableModel.__default.FromHashMap#canCall(t1#1, 
                      #Options.Option.Some($Box(q1#1)), 
                      LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
                      Lit(#Options.Option.None()))
                     && (Options.Option.Some_q(oldEntry#1)
                       ==> IndirectionTableModel.Entry.Entry_q($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)))))
         && IndirectionTableModel.__default.RemoveRef($LS($ly), Lit(self#0), LitInt(ref#0))
           == (var t#1, oldEntry#1 := $Unbox(_System.Tuple2._0(Lit(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                      Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                      LitInt(ref#0))))): DatatypeType, 
              $Unbox(_System.Tuple2._1(Lit(MutableMapModel.__default.RemoveAndGet(Tclass.IndirectionTableModel.Entry(), 
                      Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                      LitInt(ref#0))))): DatatypeType; 
            (var q#1 := Lit(LruModel.__default.Remove($LS($LZ), 
                    Lit($Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.garbageQueue(Lit(self#0))))): Seq Box), 
                    LitInt(ref#0))); 
              (var t1#1, q1#1 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                        t#1, 
                        q#1, 
                        LitInt(ref#0), 
                        Lit(Seq#Empty(): Seq Box), 
                        IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType), 
                        LitInt(0)))): DatatypeType, 
                  $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.UpdatePredCountsInc($LS($LZ), 
                        t#1, 
                        q#1, 
                        LitInt(ref#0), 
                        Lit(Seq#Empty(): Seq Box), 
                        IndirectionTableModel.Entry.succs($Unbox(Options.Option.value(oldEntry#1)): DatatypeType), 
                        LitInt(0)))): Seq Box; 
                (var self'#2 := IndirectionTableModel.__default.FromHashMap(t1#1, 
                      #Options.Option.Some($Box(q1#1)), 
                      LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
                      Lit(#Options.Option.None())); 
                  (var oldLoc#2 := (if Options.Option.Some_q(oldEntry#1)
                         then IndirectionTableModel.Entry.loc($Unbox(Options.Option.value(oldEntry#1)): DatatypeType)
                         else #Options.Option.None()); 
                    #_System._tuple#2._#Make2($Box(self'#2), $Box(oldLoc#2))))))));

// function declaration for IndirectionTableModel._default.clone
function IndirectionTableModel.__default.clone($ly: LayerType, self#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.clone#canCall(self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.clone($LS($ly), self#0) } 
  IndirectionTableModel.__default.clone($LS($ly), self#0)
     == IndirectionTableModel.__default.clone($ly, self#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.clone(AsFuelBottom($ly), self#0) } 
  IndirectionTableModel.__default.clone($ly, self#0)
     == IndirectionTableModel.__default.clone($LZ, self#0));

// consequence axiom for IndirectionTableModel.__default.clone
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.clone($ly, self#0) } 
    IndirectionTableModel.__default.clone#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.__default.Inv(IndirectionTableModel.__default.clone($ly, self#0))
         && Map#Equal(IndirectionTableModel.IndirectionTable.graph(IndirectionTableModel.__default.clone($ly, self#0)), 
          IndirectionTableModel.IndirectionTable.graph(self#0))
         && Map#Equal(IndirectionTableModel.IndirectionTable.locs(IndirectionTableModel.__default.clone($ly, self#0)), 
          IndirectionTableModel.IndirectionTable.locs(self#0))
         && $Is(IndirectionTableModel.__default.clone($ly, self#0), 
          Tclass.IndirectionTableModel.IndirectionTable()));

function IndirectionTableModel.__default.clone#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.clone
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.clone#requires($ly, self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.clone#requires($ly, self#0)
       == IndirectionTableModel.__default.Inv(self#0));

// definition axiom for IndirectionTableModel.__default.clone(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.clone($LS($ly), self#0) } 
    IndirectionTableModel.__default.clone#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && IndirectionTableModel.__default.FromHashMap#canCall(IndirectionTableModel.IndirectionTable.t(self#0), 
          Lit(#Options.Option.None()), 
          IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
          Lit(#Options.Option.None()))
         && IndirectionTableModel.__default.clone($LS($ly), self#0)
           == IndirectionTableModel.__default.FromHashMap(IndirectionTableModel.IndirectionTable.t(self#0), 
            Lit(#Options.Option.None()), 
            IndirectionTableModel.IndirectionTable.refUpperBound(self#0), 
            Lit(#Options.Option.None())));

// definition axiom for IndirectionTableModel.__default.clone for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.clone($LS($ly), Lit(self#0)) } 
    IndirectionTableModel.__default.clone#canCall(Lit(self#0))
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && Lit(IndirectionTableModel.__default.Inv(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && IndirectionTableModel.__default.FromHashMap#canCall(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          Lit(#Options.Option.None()), 
          LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
          Lit(#Options.Option.None()))
         && IndirectionTableModel.__default.clone($LS($ly), Lit(self#0))
           == Lit(IndirectionTableModel.__default.FromHashMap(Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              Lit(#Options.Option.None()), 
              LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))), 
              Lit(#Options.Option.None()))));

// function declaration for IndirectionTableModel._default.FindRefWithNoLocIterate
function IndirectionTableModel.__default.FindRefWithNoLocIterate($ly: LayerType, self#0: DatatypeType, it#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0: DatatypeType, it#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), self#0, it#0) } 
  IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), self#0, it#0)
     == IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, self#0, it#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindRefWithNoLocIterate(AsFuelBottom($ly), self#0, it#0) } 
  IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, self#0, it#0)
     == IndirectionTableModel.__default.FindRefWithNoLocIterate($LZ, self#0, it#0));

// consequence axiom for IndirectionTableModel.__default.FindRefWithNoLocIterate
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, self#0, it#0) } 
    IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0, it#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            it#0)
           && (forall r#0: int :: 
            { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)] } 
              { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#0)] } 
            LitInt(0) <= r#0
                 && r#0 < 18446744073709551616
                 && MutableMapModel.SimpleIterator.s(it#0)[$Box(r#0)]
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)]))
       ==> (var self'#0, ref#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, self#0, it#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, self#0, it#0))): DatatypeType; 
          IndirectionTableModel.__default.Inv(self'#0)
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
              IndirectionTableModel.IndirectionTable.locs(self#0))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self'#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
             && (Options.Option.Some_q(ref#0)
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[Options.Option.value(ref#0)])
             && (Options.Option.Some_q(ref#0)
               ==> !Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[Options.Option.value(ref#0)])
             && (Options.Option.None_q(ref#0)
               ==> (forall r#1: int :: 
                { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#1)] } 
                  { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#1)] } 
                  { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(r#1)] } 
                LitInt(0) <= r#1
                     && r#1 < 18446744073709551616
                     && 
                    Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(r#1)]
                     && !MutableMapModel.SimpleIterator.s(it#0)[$Box(r#1)]
                   ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#1)])))
         && $Is(IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, self#0, it#0), 
          Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
            Tclass.Options.Option(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.FindRefWithNoLocIterate#requires(LayerType, DatatypeType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.FindRefWithNoLocIterate
axiom (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindRefWithNoLocIterate#requires($ly, self#0, it#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
       && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
     ==> IndirectionTableModel.__default.FindRefWithNoLocIterate#requires($ly, self#0, it#0)
       == (
        IndirectionTableModel.__default.Inv(self#0)
         && MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          it#0)
         && (forall r#2: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#2)] } 
            { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#2)] } 
          LitInt(0) <= r#2
               && r#2 < 18446744073709551616
               && MutableMapModel.SimpleIterator.s(it#0)[$Box(r#2)]
             ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#2)])));

// definition axiom for IndirectionTableModel.__default.FindRefWithNoLocIterate(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
    { IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), self#0, it#0) } 
    IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0, it#0)
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            it#0)
           && (forall r#2: int :: 
            { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#2)] } 
              { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#2)] } 
            LitInt(0) <= r#2
                 && r#2 < 18446744073709551616
                 && MutableMapModel.SimpleIterator.s(it#0)[$Box(r#2)]
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#2)]))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          it#0)
         && (var next#0 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              it#0); 
          (MutableMapModel.IteratorOutput.Next_q(next#0)
               ==> IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(next#0)): DatatypeType)
                 && (Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#0)): DatatypeType))
                   ==> (var dt_update_tmp#0#0 := self#0; 
                    IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#0)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#0)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#0)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#0)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#0)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#0)))
                 && (!Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#0)): DatatypeType))
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && MutableMapModel.__default.SimpleIterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
                      IndirectionTableModel.IndirectionTable.t(self#0), 
                      it#0)
                     && IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0, 
                      MutableMapModel.__default.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.SimpleIterInc, 
                        IndirectionTableModel.IndirectionTable.t(self#0), 
                        it#0))))
             && (!MutableMapModel.IteratorOutput.Next_q(next#0)
               ==> (var dt_update_tmp#1#0 := self#0; 
                IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#0)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#0)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#0)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#0)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#0)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#0))))
         && IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), self#0, it#0)
           == (var next#0 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                IndirectionTableModel.IndirectionTable.t(self#0), 
                it#0); 
            (if MutableMapModel.IteratorOutput.Next_q(next#0)
               then (if Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#0)): DatatypeType))
                 then (var self'#1 := (var dt_update_tmp#0#0 := self#0; 
                      (var dt_update#findLoclessIterator#0#0 := #Options.Option.Some($Box(it#0)); 
                        #IndirectionTableModel.IndirectionTable.IndirectionTable(IndirectionTableModel.IndirectionTable.t(dt_update_tmp#0#0), 
                          IndirectionTableModel.IndirectionTable.garbageQueue(dt_update_tmp#0#0), 
                          IndirectionTableModel.IndirectionTable.refUpperBound(dt_update_tmp#0#0), 
                          dt_update#findLoclessIterator#0#0, 
                          IndirectionTableModel.IndirectionTable.locs(dt_update_tmp#0#0), 
                          IndirectionTableModel.IndirectionTable.graph(dt_update_tmp#0#0), 
                          IndirectionTableModel.IndirectionTable.predCounts(dt_update_tmp#0#0)))); 
                  #_System._tuple#2._#Make2($Box(self'#1), 
                    $Box(#Options.Option.Some($Box(MutableMapModel.IteratorOutput.key(next#0))))))
                 else IndirectionTableModel.__default.FindRefWithNoLocIterate($ly, 
                  self#0, 
                  MutableMapModel.__default.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.SimpleIterInc, 
                    IndirectionTableModel.IndirectionTable.t(self#0), 
                    it#0)))
               else (var self'#2 := (var dt_update_tmp#1#0 := self#0; 
                    (var dt_update#findLoclessIterator#1#0 := #Options.Option.Some($Box(it#0)); 
                      #IndirectionTableModel.IndirectionTable.IndirectionTable(IndirectionTableModel.IndirectionTable.t(dt_update_tmp#1#0), 
                        IndirectionTableModel.IndirectionTable.garbageQueue(dt_update_tmp#1#0), 
                        IndirectionTableModel.IndirectionTable.refUpperBound(dt_update_tmp#1#0), 
                        dt_update#findLoclessIterator#1#0, 
                        IndirectionTableModel.IndirectionTable.locs(dt_update_tmp#1#0), 
                        IndirectionTableModel.IndirectionTable.graph(dt_update_tmp#1#0), 
                        IndirectionTableModel.IndirectionTable.predCounts(dt_update_tmp#1#0)))); 
                #_System._tuple#2._#Make2($Box(self'#2), $Box(Lit(#Options.Option.None())))))));

// definition axiom for IndirectionTableModel.__default.FindRefWithNoLocIterate for decreasing-related literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), self#0, Lit(it#0)) } 
    IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0, Lit(it#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          IndirectionTableModel.__default.Inv(self#0)
           && MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
            IndirectionTableModel.IndirectionTable.t(self#0), 
            Lit(it#0))
           && (forall r#3: int :: 
            { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#3)] } 
              { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#3)] } 
            LitInt(0) <= r#3
                 && r#3 < 18446744073709551616
                 && Lit(MutableMapModel.SimpleIterator.s(Lit(it#0)))[$Box(r#3)]
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#3)]))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
          IndirectionTableModel.IndirectionTable.t(self#0), 
          Lit(it#0))
         && (var next#1 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0), 
              Lit(it#0)); 
          (MutableMapModel.IteratorOutput.Next_q(next#1)
               ==> IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(next#1)): DatatypeType)
                 && (Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#1)): DatatypeType))
                   ==> (var dt_update_tmp#0#1 := self#0; 
                    IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#1)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#1)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#1)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#1)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#1)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#1)))
                 && (!Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#1)): DatatypeType))
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
                     && MutableMapModel.__default.SimpleIterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
                      IndirectionTableModel.IndirectionTable.t(self#0), 
                      Lit(it#0))
                     && IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0, 
                      MutableMapModel.__default.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.SimpleIterInc, 
                        IndirectionTableModel.IndirectionTable.t(self#0), 
                        Lit(it#0)))))
             && (!MutableMapModel.IteratorOutput.Next_q(next#1)
               ==> (var dt_update_tmp#1#1 := self#0; 
                IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#1)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#1)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#1)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#1)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#1)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#1))))
         && IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), self#0, Lit(it#0))
           == (var next#1 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                IndirectionTableModel.IndirectionTable.t(self#0), 
                Lit(it#0)); 
            (if MutableMapModel.IteratorOutput.Next_q(next#1)
               then (if Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#1)): DatatypeType))
                 then (var self'#3 := (var dt_update_tmp#0#1 := self#0; 
                      (var dt_update#findLoclessIterator#0#1 := Lit(#Options.Option.Some($Box(Lit(it#0)))); 
                        #IndirectionTableModel.IndirectionTable.IndirectionTable(IndirectionTableModel.IndirectionTable.t(dt_update_tmp#0#1), 
                          IndirectionTableModel.IndirectionTable.garbageQueue(dt_update_tmp#0#1), 
                          IndirectionTableModel.IndirectionTable.refUpperBound(dt_update_tmp#0#1), 
                          dt_update#findLoclessIterator#0#1, 
                          IndirectionTableModel.IndirectionTable.locs(dt_update_tmp#0#1), 
                          IndirectionTableModel.IndirectionTable.graph(dt_update_tmp#0#1), 
                          IndirectionTableModel.IndirectionTable.predCounts(dt_update_tmp#0#1)))); 
                  #_System._tuple#2._#Make2($Box(self'#3), 
                    $Box(#Options.Option.Some($Box(MutableMapModel.IteratorOutput.key(next#1))))))
                 else IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), 
                  self#0, 
                  MutableMapModel.__default.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.SimpleIterInc, 
                    IndirectionTableModel.IndirectionTable.t(self#0), 
                    Lit(it#0))))
               else (var self'#4 := (var dt_update_tmp#1#1 := self#0; 
                    (var dt_update#findLoclessIterator#1#1 := Lit(#Options.Option.Some($Box(Lit(it#0)))); 
                      #IndirectionTableModel.IndirectionTable.IndirectionTable(IndirectionTableModel.IndirectionTable.t(dt_update_tmp#1#1), 
                        IndirectionTableModel.IndirectionTable.garbageQueue(dt_update_tmp#1#1), 
                        IndirectionTableModel.IndirectionTable.refUpperBound(dt_update_tmp#1#1), 
                        dt_update#findLoclessIterator#1#1, 
                        IndirectionTableModel.IndirectionTable.locs(dt_update_tmp#1#1), 
                        IndirectionTableModel.IndirectionTable.graph(dt_update_tmp#1#1), 
                        IndirectionTableModel.IndirectionTable.predCounts(dt_update_tmp#1#1)))); 
                #_System._tuple#2._#Make2($Box(self'#4), $Box(Lit(#Options.Option.None())))))));

// definition axiom for IndirectionTableModel.__default.FindRefWithNoLocIterate for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType, it#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), Lit(self#0), Lit(it#0)) } 
    IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(Lit(self#0), Lit(it#0))
         || (
          $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && $Is(it#0, Tclass.MutableMapModel.SimpleIterator())
           && 
          Lit(IndirectionTableModel.__default.Inv(Lit(self#0)))
           && MutableMapModel.__default.WFSimpleIter(Tclass.IndirectionTableModel.Entry(), 
            Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
            Lit(it#0))
           && (forall r#4: int :: 
            { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#4)] } 
              { MutableMapModel.SimpleIterator.s(it#0)[$Box(r#4)] } 
            LitInt(0) <= r#4
                 && r#4 < 18446744073709551616
                 && Lit(MutableMapModel.SimpleIterator.s(Lit(it#0)))[$Box(r#4)]
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(Lit(self#0)))[$Box(r#4)]))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && MutableMapModel.__default.SimpleIterOutput#canCall(Tclass.IndirectionTableModel.Entry(), 
          Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
          Lit(it#0))
         && (var next#2 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
              Lit(it#0)); 
          (MutableMapModel.IteratorOutput.Next_q(next#2)
               ==> IndirectionTableModel.Entry.Entry_q($Unbox(MutableMapModel.IteratorOutput.value(next#2)): DatatypeType)
                 && (Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#2)): DatatypeType))
                   ==> (var dt_update_tmp#0#2 := Lit(self#0); 
                    IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#2)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#2)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#2)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#2)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#2)
                       && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#0#2)))
                 && (!Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#2)): DatatypeType))
                   ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
                     && MutableMapModel.__default.SimpleIterInc#canCall(Tclass.IndirectionTableModel.Entry(), 
                      Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                      Lit(it#0))
                     && IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(Lit(self#0), 
                      MutableMapModel.__default.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), 
                        StartFuel_MutableMapModel._default.SimpleIterInc, 
                        Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                        Lit(it#0)))))
             && (!MutableMapModel.IteratorOutput.Next_q(next#2)
               ==> (var dt_update_tmp#1#2 := Lit(self#0); 
                IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#2)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#2)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#2)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#2)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#2)
                   && IndirectionTableModel.IndirectionTable.IndirectionTable_q(dt_update_tmp#1#2))))
         && IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), Lit(self#0), Lit(it#0))
           == (var next#2 := MutableMapModel.__default.SimpleIterOutput(Tclass.IndirectionTableModel.Entry(), 
                Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                Lit(it#0)); 
            (if MutableMapModel.IteratorOutput.Next_q(next#2)
               then (if Options.Option.None_q(IndirectionTableModel.Entry.loc($Unbox(MutableMapModel.IteratorOutput.value(next#2)): DatatypeType))
                 then (var self'#5 := (var dt_update_tmp#0#2 := Lit(self#0); 
                      (var dt_update#findLoclessIterator#0#2 := Lit(#Options.Option.Some($Box(Lit(it#0)))); 
                        Lit(#IndirectionTableModel.IndirectionTable.IndirectionTable(Lit(IndirectionTableModel.IndirectionTable.t(dt_update_tmp#0#2)), 
                            Lit(IndirectionTableModel.IndirectionTable.garbageQueue(dt_update_tmp#0#2)), 
                            LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(dt_update_tmp#0#2)), 
                            dt_update#findLoclessIterator#0#2, 
                            Lit(IndirectionTableModel.IndirectionTable.locs(dt_update_tmp#0#2)), 
                            Lit(IndirectionTableModel.IndirectionTable.graph(dt_update_tmp#0#2)), 
                            Lit(IndirectionTableModel.IndirectionTable.predCounts(dt_update_tmp#0#2)))))); 
                  #_System._tuple#2._#Make2($Box(self'#5), 
                    $Box(#Options.Option.Some($Box(MutableMapModel.IteratorOutput.key(next#2))))))
                 else IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($ly), 
                  Lit(self#0), 
                  MutableMapModel.__default.SimpleIterInc(Tclass.IndirectionTableModel.Entry(), 
                    StartFuel_MutableMapModel._default.SimpleIterInc, 
                    Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))), 
                    Lit(it#0))))
               else (var self'#6 := (var dt_update_tmp#1#2 := Lit(self#0); 
                    (var dt_update#findLoclessIterator#1#2 := Lit(#Options.Option.Some($Box(Lit(it#0)))); 
                      Lit(#IndirectionTableModel.IndirectionTable.IndirectionTable(Lit(IndirectionTableModel.IndirectionTable.t(dt_update_tmp#1#2)), 
                          Lit(IndirectionTableModel.IndirectionTable.garbageQueue(dt_update_tmp#1#2)), 
                          LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(dt_update_tmp#1#2)), 
                          dt_update#findLoclessIterator#1#2, 
                          Lit(IndirectionTableModel.IndirectionTable.locs(dt_update_tmp#1#2)), 
                          Lit(IndirectionTableModel.IndirectionTable.graph(dt_update_tmp#1#2)), 
                          Lit(IndirectionTableModel.IndirectionTable.predCounts(dt_update_tmp#1#2)))))); 
                #_System._tuple#2._#Make2($Box(self'#6), $Box(Lit(#Options.Option.None())))))));

// function declaration for IndirectionTableModel._default.FindRefWithNoLoc
function IndirectionTableModel.__default.FindRefWithNoLoc($ly: LayerType, self#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.FindRefWithNoLoc#canCall(self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindRefWithNoLoc($LS($ly), self#0) } 
  IndirectionTableModel.__default.FindRefWithNoLoc($LS($ly), self#0)
     == IndirectionTableModel.__default.FindRefWithNoLoc($ly, self#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindRefWithNoLoc(AsFuelBottom($ly), self#0) } 
  IndirectionTableModel.__default.FindRefWithNoLoc($ly, self#0)
     == IndirectionTableModel.__default.FindRefWithNoLoc($LZ, self#0));

// consequence axiom for IndirectionTableModel.__default.FindRefWithNoLoc
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.FindRefWithNoLoc($ly, self#0) } 
    IndirectionTableModel.__default.FindRefWithNoLoc#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> (var self'#0, ref#0 := $Unbox(_System.Tuple2._0(IndirectionTableModel.__default.FindRefWithNoLoc($ly, self#0))): DatatypeType, 
            $Unbox(_System.Tuple2._1(IndirectionTableModel.__default.FindRefWithNoLoc($ly, self#0))): DatatypeType; 
          IndirectionTableModel.__default.Inv(self'#0)
             && Map#Equal(IndirectionTableModel.IndirectionTable.locs(self'#0), 
              IndirectionTableModel.IndirectionTable.locs(self#0))
             && Map#Equal(IndirectionTableModel.IndirectionTable.graph(self'#0), 
              IndirectionTableModel.IndirectionTable.graph(self#0))
             && (Options.Option.Some_q(ref#0)
               ==> Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[Options.Option.value(ref#0)])
             && (Options.Option.Some_q(ref#0)
               ==> !Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[Options.Option.value(ref#0)])
             && (Options.Option.None_q(ref#0)
               ==> (forall r#0: int :: 
                { Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)] } 
                  { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(r#0)] } 
                LitInt(0) <= r#0
                     && r#0 < 18446744073709551616
                     && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(r#0)]
                   ==> Map#Domain(IndirectionTableModel.IndirectionTable.locs(self#0))[$Box(r#0)])))
         && $Is(IndirectionTableModel.__default.FindRefWithNoLoc($ly, self#0), 
          Tclass._System.Tuple2(Tclass.IndirectionTableModel.IndirectionTable(), 
            Tclass.Options.Option(Tclass.NativeTypes.uint64()))));

function IndirectionTableModel.__default.FindRefWithNoLoc#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.FindRefWithNoLoc
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.FindRefWithNoLoc#requires($ly, self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.FindRefWithNoLoc#requires($ly, self#0)
       == IndirectionTableModel.__default.Inv(self#0));

// definition axiom for IndirectionTableModel.__default.FindRefWithNoLoc(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.FindRefWithNoLoc($LS($ly), self#0) } 
    IndirectionTableModel.__default.FindRefWithNoLoc#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && (Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0))
         && (!Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
             && MutableMapModel.__default.SimpleIterStart#canCall(Tclass.IndirectionTableModel.Entry(), 
              IndirectionTableModel.IndirectionTable.t(self#0)))
         && (var it#0 := (if Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
               then $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType
               else MutableMapModel.__default.SimpleIterStart(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.SimpleIterStart, 
                IndirectionTableModel.IndirectionTable.t(self#0))); 
          IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(self#0, it#0))
         && IndirectionTableModel.__default.FindRefWithNoLoc($LS($ly), self#0)
           == (var it#0 := (if Options.Option.Some_q(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))
                 then $Unbox(Options.Option.value(IndirectionTableModel.IndirectionTable.findLoclessIterator(self#0))): DatatypeType
                 else MutableMapModel.__default.SimpleIterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.SimpleIterStart, 
                  IndirectionTableModel.IndirectionTable.t(self#0))); 
            IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), self#0, it#0)));

// definition axiom for IndirectionTableModel.__default.FindRefWithNoLoc for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.FindRefWithNoLoc($LS($ly), Lit(self#0)) } 
    IndirectionTableModel.__default.FindRefWithNoLoc#canCall(Lit(self#0))
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && Lit(IndirectionTableModel.__default.Inv(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && (Lit(Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0)))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0)))
         && (!Lit(Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0)))))
           ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
             && MutableMapModel.__default.SimpleIterStart#canCall(Tclass.IndirectionTableModel.Entry(), 
              Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0)))))
         && (var it#1 := (if Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))
               then $Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType
               else MutableMapModel.__default.SimpleIterStart(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.SimpleIterStart, 
                Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))); 
          IndirectionTableModel.__default.FindRefWithNoLocIterate#canCall(Lit(self#0), it#1))
         && IndirectionTableModel.__default.FindRefWithNoLoc($LS($ly), Lit(self#0))
           == (var it#1 := (if Options.Option.Some_q(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))
                 then $Unbox(Options.Option.value(Lit(IndirectionTableModel.IndirectionTable.findLoclessIterator(Lit(self#0))))): DatatypeType
                 else MutableMapModel.__default.SimpleIterStart(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.SimpleIterStart, 
                  Lit(IndirectionTableModel.IndirectionTable.t(Lit(self#0))))); 
            IndirectionTableModel.__default.FindRefWithNoLocIterate($LS($LZ), Lit(self#0), it#1)));

// function declaration for IndirectionTableModel._default.ConstructorRootOnly
function IndirectionTableModel.__default.ConstructorRootOnly($ly: LayerType, loc#0: DatatypeType) : DatatypeType;

function IndirectionTableModel.__default.ConstructorRootOnly#canCall(loc#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { IndirectionTableModel.__default.ConstructorRootOnly($LS($ly), loc#0) } 
  IndirectionTableModel.__default.ConstructorRootOnly($LS($ly), loc#0)
     == IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { IndirectionTableModel.__default.ConstructorRootOnly(AsFuelBottom($ly), loc#0) } 
  IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0)
     == IndirectionTableModel.__default.ConstructorRootOnly($LZ, loc#0));

// consequence axiom for IndirectionTableModel.__default.ConstructorRootOnly
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0) } 
    IndirectionTableModel.__default.ConstructorRootOnly#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> IndirectionTableModel.__default.Inv(IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0))
         && Map#Equal(IndirectionTableModel.IndirectionTable.graph(IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0)), 
          Map#Build(Map#Empty(): Map Box Box, 
            $Box(LitInt(PivotBetreeGraph.__default.Root())), 
            $Box(Lit(Seq#Empty(): Seq Box))))
         && Map#Equal(IndirectionTableModel.IndirectionTable.locs(IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0)), 
          Map#Build(Map#Empty(): Map Box Box, 
            $Box(LitInt(PivotBetreeGraph.__default.Root())), 
            $Box(loc#0)))
         && $Is(IndirectionTableModel.__default.ConstructorRootOnly($ly, loc#0), 
          Tclass.IndirectionTableModel.IndirectionTable()));

function IndirectionTableModel.__default.ConstructorRootOnly#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.ConstructorRootOnly
axiom (forall $ly: LayerType, loc#0: DatatypeType :: 
  { IndirectionTableModel.__default.ConstructorRootOnly#requires($ly, loc#0) } 
  $Is(loc#0, Tclass.DiskLayout.Location())
     ==> IndirectionTableModel.__default.ConstructorRootOnly#requires($ly, loc#0) == true);

// definition axiom for IndirectionTableModel.__default.ConstructorRootOnly(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    { IndirectionTableModel.__default.ConstructorRootOnly($LS($ly), loc#0) } 
    IndirectionTableModel.__default.ConstructorRootOnly#canCall(loc#0)
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> MutableMapModel.__default.Constructor#canCall(Tclass.IndirectionTableModel.Entry(), LitInt(128))
         && (var t0#0 := MutableMapModel.__default.Constructor(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.Constructor, 
              LitInt(128)); 
          PivotBetreeGraph.__default.Root#canCall()
             && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
              t0#0, 
              LitInt(PivotBetreeGraph.__default.Root()), 
              $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), Lit(Seq#Empty(): Seq Box), LitInt(1))))
             && (var t1#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  t0#0, 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), Lit(Seq#Empty(): Seq Box), LitInt(1)))); 
              PivotBetreeGraph.__default.Root#canCall()
                 && IndirectionTableModel.__default.FromHashMap#canCall(t1#0, 
                  Lit(#Options.Option.None()), 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  Lit(#Options.Option.None()))))
         && IndirectionTableModel.__default.ConstructorRootOnly($LS($ly), loc#0)
           == (var t0#0 := MutableMapModel.__default.Constructor(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.Constructor, 
                LitInt(128)); 
            (var t1#0 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  t0#0, 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box(#IndirectionTableModel.Entry.Entry(#Options.Option.Some($Box(loc#0)), Lit(Seq#Empty(): Seq Box), LitInt(1)))); 
              (var self'#0 := IndirectionTableModel.__default.FromHashMap(t1#0, 
                    Lit(#Options.Option.None()), 
                    LitInt(PivotBetreeGraph.__default.Root()), 
                    Lit(#Options.Option.None())); 
                self'#0))));

// definition axiom for IndirectionTableModel.__default.ConstructorRootOnly for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, loc#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.ConstructorRootOnly($LS($ly), Lit(loc#0)) } 
    IndirectionTableModel.__default.ConstructorRootOnly#canCall(Lit(loc#0))
         || $Is(loc#0, Tclass.DiskLayout.Location())
       ==> MutableMapModel.__default.Constructor#canCall(Tclass.IndirectionTableModel.Entry(), LitInt(128))
         && (var t0#1 := MutableMapModel.__default.Constructor(Tclass.IndirectionTableModel.Entry(), 
              StartFuel_MutableMapModel._default.Constructor, 
              LitInt(128)); 
          PivotBetreeGraph.__default.Root#canCall()
             && MutableMapModel.__default.Insert#canCall(Tclass.IndirectionTableModel.Entry(), 
              t0#1, 
              LitInt(PivotBetreeGraph.__default.Root()), 
              $Box(Lit(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.Some($Box(Lit(loc#0)))), 
                    Lit(Seq#Empty(): Seq Box), 
                    LitInt(1)))))
             && (var t1#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  t0#1, 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box(Lit(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.Some($Box(Lit(loc#0)))), 
                        Lit(Seq#Empty(): Seq Box), 
                        LitInt(1))))); 
              PivotBetreeGraph.__default.Root#canCall()
                 && IndirectionTableModel.__default.FromHashMap#canCall(t1#1, 
                  Lit(#Options.Option.None()), 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  Lit(#Options.Option.None()))))
         && IndirectionTableModel.__default.ConstructorRootOnly($LS($ly), Lit(loc#0))
           == (var t0#1 := MutableMapModel.__default.Constructor(Tclass.IndirectionTableModel.Entry(), 
                StartFuel_MutableMapModel._default.Constructor, 
                LitInt(128)); 
            (var t1#1 := MutableMapModel.__default.Insert(Tclass.IndirectionTableModel.Entry(), 
                  StartFuel_MutableMapModel._default.Insert, 
                  t0#1, 
                  LitInt(PivotBetreeGraph.__default.Root()), 
                  $Box(Lit(#IndirectionTableModel.Entry.Entry(Lit(#Options.Option.Some($Box(Lit(loc#0)))), 
                        Lit(Seq#Empty(): Seq Box), 
                        LitInt(1))))); 
              (var self'#1 := IndirectionTableModel.__default.FromHashMap(t1#1, 
                    Lit(#Options.Option.None()), 
                    LitInt(PivotBetreeGraph.__default.Root()), 
                    Lit(#Options.Option.None())); 
                self'#1))));

// function declaration for IndirectionTableModel._default.getRefUpperBound
function IndirectionTableModel.__default.getRefUpperBound($ly: LayerType, self#0: DatatypeType) : int;

function IndirectionTableModel.__default.getRefUpperBound#canCall(self#0: DatatypeType) : bool;

// layer synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.getRefUpperBound($LS($ly), self#0) } 
  IndirectionTableModel.__default.getRefUpperBound($LS($ly), self#0)
     == IndirectionTableModel.__default.getRefUpperBound($ly, self#0));

// fuel synonym axiom
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.getRefUpperBound(AsFuelBottom($ly), self#0) } 
  IndirectionTableModel.__default.getRefUpperBound($ly, self#0)
     == IndirectionTableModel.__default.getRefUpperBound($LZ, self#0));

// consequence axiom for IndirectionTableModel.__default.getRefUpperBound
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.getRefUpperBound($ly, self#0) } 
    IndirectionTableModel.__default.getRefUpperBound#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> (forall ref#0: int :: 
          { Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)] } 
          LitInt(0) <= ref#0
               && ref#0 < 18446744073709551616
               && Map#Domain(IndirectionTableModel.IndirectionTable.graph(self#0))[$Box(ref#0)]
             ==> ref#0 <= IndirectionTableModel.__default.getRefUpperBound($ly, self#0))
         && 
        LitInt(0) <= IndirectionTableModel.__default.getRefUpperBound($ly, self#0)
         && IndirectionTableModel.__default.getRefUpperBound($ly, self#0)
           < 18446744073709551616);

function IndirectionTableModel.__default.getRefUpperBound#requires(LayerType, DatatypeType) : bool;

// #requires axiom for IndirectionTableModel.__default.getRefUpperBound
axiom (forall $ly: LayerType, self#0: DatatypeType :: 
  { IndirectionTableModel.__default.getRefUpperBound#requires($ly, self#0) } 
  $Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
     ==> IndirectionTableModel.__default.getRefUpperBound#requires($ly, self#0)
       == IndirectionTableModel.__default.Inv(self#0));

// definition axiom for IndirectionTableModel.__default.getRefUpperBound(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    { IndirectionTableModel.__default.getRefUpperBound($LS($ly), self#0) } 
    IndirectionTableModel.__default.getRefUpperBound#canCall(self#0)
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && IndirectionTableModel.__default.Inv(self#0))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(self#0)
         && IndirectionTableModel.__default.getRefUpperBound($LS($ly), self#0)
           == IndirectionTableModel.IndirectionTable.refUpperBound(self#0));

// definition axiom for IndirectionTableModel.__default.getRefUpperBound for all literals(revealed)
axiom true
   ==> (forall $ly: LayerType, self#0: DatatypeType :: 
    {:weight 3} { IndirectionTableModel.__default.getRefUpperBound($LS($ly), Lit(self#0)) } 
    IndirectionTableModel.__default.getRefUpperBound#canCall(Lit(self#0))
         || ($Is(self#0, Tclass.IndirectionTableModel.IndirectionTable())
           && Lit(IndirectionTableModel.__default.Inv(Lit(self#0))))
       ==> IndirectionTableModel.IndirectionTable.IndirectionTable_q(Lit(self#0))
         && IndirectionTableModel.__default.getRefUpperBound($LS($ly), Lit(self#0))
           == LitInt(IndirectionTableModel.IndirectionTable.refUpperBound(Lit(self#0))));

procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__GetEntry();
  free requires 107 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.GetEntry0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__GetEntry();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.GetEntry
     == $LS(MoreFuel_IndirectionTableModel._default.GetEntry0);
  free ensures StartFuelAssert_IndirectionTableModel._default.GetEntry
     == $LS($LS(MoreFuel_IndirectionTableModel._default.GetEntry0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.GetEntry0)
     == MoreFuel_IndirectionTableModel._default.GetEntry0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__AddLocIfPresent();
  free requires 109 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.AddLocIfPresent0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__AddLocIfPresent();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.AddLocIfPresent
     == $LS(MoreFuel_IndirectionTableModel._default.AddLocIfPresent0);
  free ensures StartFuelAssert_IndirectionTableModel._default.AddLocIfPresent
     == $LS($LS(MoreFuel_IndirectionTableModel._default.AddLocIfPresent0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.AddLocIfPresent0)
     == MoreFuel_IndirectionTableModel._default.AddLocIfPresent0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__UpdateAndRemoveLoc();
  free requires 110 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.UpdateAndRemoveLoc0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__UpdateAndRemoveLoc();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.UpdateAndRemoveLoc
     == $LS(MoreFuel_IndirectionTableModel._default.UpdateAndRemoveLoc0);
  free ensures StartFuelAssert_IndirectionTableModel._default.UpdateAndRemoveLoc
     == $LS($LS(MoreFuel_IndirectionTableModel._default.UpdateAndRemoveLoc0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.UpdateAndRemoveLoc0)
     == MoreFuel_IndirectionTableModel._default.UpdateAndRemoveLoc0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__RemoveLoc();
  free requires 111 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.RemoveLoc0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__RemoveLoc();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.RemoveLoc
     == $LS(MoreFuel_IndirectionTableModel._default.RemoveLoc0);
  free ensures StartFuelAssert_IndirectionTableModel._default.RemoveLoc
     == $LS($LS(MoreFuel_IndirectionTableModel._default.RemoveLoc0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.RemoveLoc0)
     == MoreFuel_IndirectionTableModel._default.RemoveLoc0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__makeGarbageQueue();
  free requires 112 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.makeGarbageQueue0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__makeGarbageQueue();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.makeGarbageQueue
     == $LS(MoreFuel_IndirectionTableModel._default.makeGarbageQueue0);
  free ensures StartFuelAssert_IndirectionTableModel._default.makeGarbageQueue
     == $LS($LS(MoreFuel_IndirectionTableModel._default.makeGarbageQueue0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.makeGarbageQueue0)
     == MoreFuel_IndirectionTableModel._default.makeGarbageQueue0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__BitmapInitUpTo();
  free requires 113 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.BitmapInitUpTo0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__BitmapInitUpTo();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.BitmapInitUpTo
     == $LS(MoreFuel_IndirectionTableModel._default.BitmapInitUpTo0);
  free ensures StartFuelAssert_IndirectionTableModel._default.BitmapInitUpTo
     == $LS($LS(MoreFuel_IndirectionTableModel._default.BitmapInitUpTo0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.BitmapInitUpTo0)
     == MoreFuel_IndirectionTableModel._default.BitmapInitUpTo0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__InitLocBitmap();
  free requires 114 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.InitLocBitmap0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__InitLocBitmap();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.InitLocBitmap
     == $LS(MoreFuel_IndirectionTableModel._default.InitLocBitmap0);
  free ensures StartFuelAssert_IndirectionTableModel._default.InitLocBitmap
     == $LS($LS(MoreFuel_IndirectionTableModel._default.InitLocBitmap0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.InitLocBitmap0)
     == MoreFuel_IndirectionTableModel._default.InitLocBitmap0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__FindDeallocable();
  free requires 115 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.FindDeallocable0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__FindDeallocable();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.FindDeallocable
     == $LS(MoreFuel_IndirectionTableModel._default.FindDeallocable0);
  free ensures StartFuelAssert_IndirectionTableModel._default.FindDeallocable
     == $LS($LS(MoreFuel_IndirectionTableModel._default.FindDeallocable0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.FindDeallocable0)
     == MoreFuel_IndirectionTableModel._default.FindDeallocable0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__RemoveRef();
  free requires 116 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.RemoveRef0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__RemoveRef();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.RemoveRef
     == $LS(MoreFuel_IndirectionTableModel._default.RemoveRef0);
  free ensures StartFuelAssert_IndirectionTableModel._default.RemoveRef
     == $LS($LS(MoreFuel_IndirectionTableModel._default.RemoveRef0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.RemoveRef0)
     == MoreFuel_IndirectionTableModel._default.RemoveRef0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__clone();
  free requires 117 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.clone0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__clone();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.clone
     == $LS(MoreFuel_IndirectionTableModel._default.clone0);
  free ensures StartFuelAssert_IndirectionTableModel._default.clone
     == $LS($LS(MoreFuel_IndirectionTableModel._default.clone0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.clone0)
     == MoreFuel_IndirectionTableModel._default.clone0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__FindRefWithNoLoc();
  free requires 118 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.FindRefWithNoLoc0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__FindRefWithNoLoc();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.FindRefWithNoLoc
     == $LS(MoreFuel_IndirectionTableModel._default.FindRefWithNoLoc0);
  free ensures StartFuelAssert_IndirectionTableModel._default.FindRefWithNoLoc
     == $LS($LS(MoreFuel_IndirectionTableModel._default.FindRefWithNoLoc0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.FindRefWithNoLoc0)
     == MoreFuel_IndirectionTableModel._default.FindRefWithNoLoc0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__ConstructorRootOnly();
  free requires 119 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.ConstructorRootOnly0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__ConstructorRootOnly();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.ConstructorRootOnly
     == $LS(MoreFuel_IndirectionTableModel._default.ConstructorRootOnly0);
  free ensures StartFuelAssert_IndirectionTableModel._default.ConstructorRootOnly
     == $LS($LS(MoreFuel_IndirectionTableModel._default.ConstructorRootOnly0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.ConstructorRootOnly0)
     == MoreFuel_IndirectionTableModel._default.ConstructorRootOnly0;



procedure {:auto_generated} {:opaque_reveal} {:verify false} CheckWellformed$$IndirectionTableModel.__default.reveal__getRefUpperBound();
  free requires 120 == $FunctionContextHeight;
  modifies $Heap, $Tick;



const MoreFuel_IndirectionTableModel._default.getRefUpperBound0: LayerType;

procedure {:auto_generated} {:opaque_reveal} {:verify false} Call$$IndirectionTableModel.__default.reveal__getRefUpperBound();
  modifies $Heap, $Tick;
  // frame condition
  free ensures old($Heap) == $Heap;
  free ensures StartFuel_IndirectionTableModel._default.getRefUpperBound
     == $LS(MoreFuel_IndirectionTableModel._default.getRefUpperBound0);
  free ensures StartFuelAssert_IndirectionTableModel._default.getRefUpperBound
     == $LS($LS(MoreFuel_IndirectionTableModel._default.getRefUpperBound0));
  // Shortcut to LZ
  free ensures AsFuelBottom(MoreFuel_IndirectionTableModel._default.getRefUpperBound0)
     == MoreFuel_IndirectionTableModel._default.getRefUpperBound0;



const unique class.LruImpl.Node?: ClassName;

function Tclass.LruImpl.Node?() : Ty;

// Tclass.LruImpl.Node? Tag
axiom Tag(Tclass.LruImpl.Node?()) == Tagclass.LruImpl.Node?;

const unique Tagclass.LruImpl.Node?: TyTag;

// Box/unbox axiom for Tclass.LruImpl.Node?
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.LruImpl.Node?()) } 
  $IsBox(bx, Tclass.LruImpl.Node?())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.LruImpl.Node?()));

// Node: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.LruImpl.Node?()) } 
  $Is($o, Tclass.LruImpl.Node?())
     <==> $o == null || dtype($o) == Tclass.LruImpl.Node?());

// Node: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.LruImpl.Node?(), $h) } 
  $IsAlloc($o, Tclass.LruImpl.Node?(), $h) <==> $o == null || read($h, $o, alloc));

axiom FDim(LruImpl.Node.prev) == 0
   && FieldOfDecl(class.LruImpl.Node?, field$prev) == LruImpl.Node.prev
   && !$IsGhostField(LruImpl.Node.prev);

const LruImpl.Node.prev: Field ref;

// Node.prev: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.Node.prev) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.Node?()
     ==> $Is(read($h, $o, LruImpl.Node.prev), Tclass.LruImpl.Node?()));

// Node.prev: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.Node.prev) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.Node?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.Node.prev), Tclass.LruImpl.Node?(), $h));

axiom FDim(LruImpl.Node.next) == 0
   && FieldOfDecl(class.LruImpl.Node?, field$next) == LruImpl.Node.next
   && !$IsGhostField(LruImpl.Node.next);

const LruImpl.Node.next: Field ref;

// Node.next: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.Node.next) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.Node?()
     ==> $Is(read($h, $o, LruImpl.Node.next), Tclass.LruImpl.Node?()));

// Node.next: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.Node.next) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.Node?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.Node.next), Tclass.LruImpl.Node?(), $h));

axiom FDim(LruImpl.Node.value) == 0
   && FieldOfDecl(class.LruImpl.Node?, field$value) == LruImpl.Node.value
   && !$IsGhostField(LruImpl.Node.value);

const LruImpl.Node.value: Field int;

// Node.value: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.Node.value) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.Node?()
     ==> $Is(read($h, $o, LruImpl.Node.value), Tclass.NativeTypes.uint64()));

// Node.value: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.Node.value) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.Node?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.Node.value), Tclass.NativeTypes.uint64(), $h));

function Tclass.LruImpl.Node() : Ty;

// Tclass.LruImpl.Node Tag
axiom Tag(Tclass.LruImpl.Node()) == Tagclass.LruImpl.Node;

const unique Tagclass.LruImpl.Node: TyTag;

// Box/unbox axiom for Tclass.LruImpl.Node
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.LruImpl.Node()) } 
  $IsBox(bx, Tclass.LruImpl.Node())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.LruImpl.Node()));

// LruImpl.Node: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.LruImpl.Node()) } 
  $Is(c#0, Tclass.LruImpl.Node())
     <==> $Is(c#0, Tclass.LruImpl.Node?()) && c#0 != null);

// LruImpl.Node: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.LruImpl.Node(), $h) } 
  $IsAlloc(c#0, Tclass.LruImpl.Node(), $h)
     <==> $IsAlloc(c#0, Tclass.LruImpl.Node?(), $h));

const unique class.LruImpl.LruImplQueue?: ClassName;

// LruImplQueue: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.LruImpl.LruImplQueue?()) } 
  $Is($o, Tclass.LruImpl.LruImplQueue?())
     <==> $o == null || dtype($o) == Tclass.LruImpl.LruImplQueue?());

// LruImplQueue: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.LruImpl.LruImplQueue?(), $h) } 
  $IsAlloc($o, Tclass.LruImpl.LruImplQueue?(), $h)
     <==> $o == null || read($h, $o, alloc));

const LruImpl.LruImplQueue.Queue: Field (Seq Box);

// LruImplQueue.Queue: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.Queue) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.LruImplQueue?()
     ==> $Is(read($h, $o, LruImpl.LruImplQueue.Queue), TSeq(Tclass.NativeTypes.uint64())));

// LruImplQueue.Queue: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.Queue) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.LruImplQueue?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.LruImplQueue.Queue), TSeq(Tclass.NativeTypes.uint64()), $h));

const LruImpl.LruImplQueue.Repr: Field (Set Box);

// LruImplQueue.Repr: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.Repr) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.LruImplQueue?()
     ==> $Is(read($h, $o, LruImpl.LruImplQueue.Repr), TSet(Tclass._System.object())));

// LruImplQueue.Repr: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.Repr) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.LruImplQueue?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.LruImplQueue.Repr), TSet(Tclass._System.object()), $h));

axiom FDim(LruImpl.LruImplQueue.nodemap) == 0
   && FieldOfDecl(class.LruImpl.LruImplQueue?, field$nodemap)
     == LruImpl.LruImplQueue.nodemap
   && !$IsGhostField(LruImpl.LruImplQueue.nodemap);

const LruImpl.LruImplQueue.nodemap: Field ref;

// LruImplQueue.nodemap: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.nodemap) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.LruImplQueue?()
     ==> $Is(read($h, $o, LruImpl.LruImplQueue.nodemap), 
      Tclass.MutableMap.ResizingHashMap(Tclass.LruImpl.Node())));

// LruImplQueue.nodemap: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.nodemap) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.LruImplQueue?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.LruImplQueue.nodemap), 
      Tclass.MutableMap.ResizingHashMap(Tclass.LruImpl.Node()), 
      $h));

axiom FDim(LruImpl.LruImplQueue.head__node) == 0
   && FieldOfDecl(class.LruImpl.LruImplQueue?, field$head_node)
     == LruImpl.LruImplQueue.head__node
   && !$IsGhostField(LruImpl.LruImplQueue.head__node);

const LruImpl.LruImplQueue.head__node: Field ref;

// LruImplQueue.head_node: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.head__node) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.LruImplQueue?()
     ==> $Is(read($h, $o, LruImpl.LruImplQueue.head__node), Tclass.LruImpl.Node?()));

// LruImplQueue.head_node: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.head__node) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.LruImplQueue?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.LruImplQueue.head__node), Tclass.LruImpl.Node?(), $h));

axiom FDim(LruImpl.LruImplQueue.tail__node) == 0
   && FieldOfDecl(class.LruImpl.LruImplQueue?, field$tail_node)
     == LruImpl.LruImplQueue.tail__node
   && !$IsGhostField(LruImpl.LruImplQueue.tail__node);

const LruImpl.LruImplQueue.tail__node: Field ref;

// LruImplQueue.tail_node: Type axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.tail__node) } 
  $IsGoodHeap($h) && $o != null && dtype($o) == Tclass.LruImpl.LruImplQueue?()
     ==> $Is(read($h, $o, LruImpl.LruImplQueue.tail__node), Tclass.LruImpl.Node?()));

// LruImplQueue.tail_node: Allocation axiom
axiom (forall $h: Heap, $o: ref :: 
  { read($h, $o, LruImpl.LruImplQueue.tail__node) } 
  $IsGoodHeap($h)
       && 
      $o != null
       && dtype($o) == Tclass.LruImpl.LruImplQueue?()
       && read($h, $o, alloc)
     ==> $IsAlloc(read($h, $o, LruImpl.LruImplQueue.tail__node), Tclass.LruImpl.Node?(), $h));

// function declaration for LruImpl.LruImplQueue.Inv
function LruImpl.LruImplQueue.Inv($heap: Heap, this: ref) : bool;

function LruImpl.LruImplQueue.Inv#canCall($heap: Heap, this: ref) : bool;

// frame axiom for LruImpl.LruImplQueue.Inv
axiom (forall $h0: Heap, $h1: Heap, this: ref :: 
  { $IsHeapAnchor($h0), $HeapSucc($h0, $h1), LruImpl.LruImplQueue.Inv($h1, this) } 
  $IsGoodHeap($h0)
       && $IsGoodHeap($h1)
       && 
      this != null
       && $Is(this, Tclass.LruImpl.LruImplQueue())
       && 
      $IsHeapAnchor($h0)
       && $HeapSucc($h0, $h1)
     ==> 
    (forall<alpha> $o: ref, $f: Field alpha :: 
      $o != null
           && ($o == this || read($h0, this, LruImpl.LruImplQueue.Repr)[$Box($o)])
         ==> read($h0, $o, $f) == read($h1, $o, $f))
     ==> LruImpl.LruImplQueue.Inv($h0, this) == LruImpl.LruImplQueue.Inv($h1, this));

// consequence axiom for LruImpl.LruImplQueue.Inv
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { LruImpl.LruImplQueue.Inv($Heap, this) } 
    LruImpl.LruImplQueue.Inv#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.LruImpl.LruImplQueue())
           && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap))
       ==> (LruImpl.LruImplQueue.Inv($Heap, this)
           ==> read($Heap, this, LruImpl.LruImplQueue.Repr)[$Box(this)])
         && (LruImpl.LruImplQueue.Inv($Heap, this)
           ==> LruModel.__default.WF(read($Heap, this, LruImpl.LruImplQueue.Queue))));

function LruImpl.LruImplQueue.Inv#requires(Heap, ref) : bool;

// #requires axiom for LruImpl.LruImplQueue.Inv
axiom (forall $Heap: Heap, this: ref :: 
  { LruImpl.LruImplQueue.Inv#requires($Heap, this) } 
  $IsGoodHeap($Heap)
       && 
      this != null
       && 
      $Is(this, Tclass.LruImpl.LruImplQueue())
       && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap)
     ==> LruImpl.LruImplQueue.Inv#requires($Heap, this) == true);

// definition axiom for LruImpl.LruImplQueue.Inv(revealed)
axiom true
   ==> (forall $Heap: Heap, this: ref :: 
    { LruImpl.LruImplQueue.Inv($Heap, this) } 
    LruImpl.LruImplQueue.Inv#canCall($Heap, this)
         || ($IsGoodHeap($Heap)
           && 
          this != null
           && 
          $Is(this, Tclass.LruImpl.LruImplQueue())
           && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap))
       ==> true);

procedure CheckWellformed$$LruImpl.LruImplQueue.__ctor(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap));
  free requires 19 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$LruImpl.LruImplQueue.__ctor()
   returns (this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap));
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, this);
  ensures LruImpl.LruImplQueue.Inv($Heap, this);
  free ensures LruModel.__default.Empty#canCall();
  ensures Seq#Equal(read($Heap, this, LruImpl.LruImplQueue.Queue), LruModel.__default.Empty());
  free ensures true;
  ensures (forall $o: ref :: 
    { read($Heap, this, LruImpl.LruImplQueue.Repr)[$Box($o)] } 
    read($Heap, this, LruImpl.LruImplQueue.Repr)[$Box($o)]
       ==> $o != null && !read(old($Heap), $o, alloc));
  // constructor allocates the object
  ensures !read(old($Heap), this, alloc);
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$LruImpl.LruImplQueue.Remove(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap), 
    x#0: int where LitInt(0) <= x#0 && x#0 < 18446744073709551616);
  free requires 6 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$LruImpl.LruImplQueue.Remove(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap), 
    x#0: int where LitInt(0) <= x#0 && x#0 < 18446744073709551616);
  // user-defined preconditions
  requires LruImpl.LruImplQueue.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, this);
  ensures LruImpl.LruImplQueue.Inv($Heap, this);
  free ensures LruModel.__default.Remove#canCall(read(old($Heap), this, LruImpl.LruImplQueue.Queue), x#0);
  ensures Seq#Equal(read($Heap, this, LruImpl.LruImplQueue.Queue), 
    LruModel.__default.Remove($LS($LS($LZ)), read(old($Heap), this, LruImpl.LruImplQueue.Queue), x#0));
  free ensures true;
  ensures Set#Subset(read($Heap, this, LruImpl.LruImplQueue.Repr), 
    read(old($Heap), this, LruImpl.LruImplQueue.Repr));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$LruImpl.LruImplQueue.Use(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap), 
    x#0: int where LitInt(0) <= x#0 && x#0 < 18446744073709551616);
  free requires 9 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$LruImpl.LruImplQueue.Use(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap), 
    x#0: int where LitInt(0) <= x#0 && x#0 < 18446744073709551616);
  // user-defined preconditions
  requires LruImpl.LruImplQueue.Inv($Heap, this);
  requires Set#Card(LruModel.__default.I(read($Heap, this, LruImpl.LruImplQueue.Queue)))
     <= LitInt(4294967296);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures LruImpl.LruImplQueue.Inv#canCall($Heap, this);
  ensures LruImpl.LruImplQueue.Inv($Heap, this);
  free ensures LruModel.__default.Use#canCall(read(old($Heap), this, LruImpl.LruImplQueue.Queue), x#0);
  ensures Seq#Equal(read($Heap, this, LruImpl.LruImplQueue.Queue), 
    LruModel.__default.Use(read(old($Heap), this, LruImpl.LruImplQueue.Queue), x#0));
  free ensures true;
  ensures (forall x#1: ref :: 
    { read(old($Heap), this, LruImpl.LruImplQueue.Repr)[$Box(x#1)] } 
      { read($Heap, this, LruImpl.LruImplQueue.Repr)[$Box(x#1)] } 
    $Is(x#1, Tclass._System.object())
         && read($Heap, this, LruImpl.LruImplQueue.Repr)[$Box(x#1)]
       ==> read(old($Heap), this, LruImpl.LruImplQueue.Repr)[$Box(x#1)]
         || (x#1 != null && !read(old($Heap), x#1, alloc)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc)
       ==> $Heap[$o] == old($Heap)[$o]
         || 
        $o == this
         || read(old($Heap), this, LruImpl.LruImplQueue.Repr)[$Box($o)]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$LruImpl.LruImplQueue.NextOpt(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap))
   returns (x#0: DatatypeType
       where $Is(x#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(x#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap));
  free requires 13 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$LruImpl.LruImplQueue.NextOpt(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap))
   returns (x#0: DatatypeType
       where $Is(x#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()))
         && $IsAlloc(x#0, Tclass.Options.Option(Tclass.NativeTypes.uint64()), $Heap));
  // user-defined preconditions
  requires LruImpl.LruImplQueue.Inv($Heap, this);
  modifies $Heap, $Tick;
  // user-defined postconditions
  free ensures $IsA#Options.Option(x#0)
     && $IsA#Options.Option(LruModel.__default.NextOpt(StartFuel_LruModel._default.NextOpt, 
        read($Heap, this, LruImpl.LruImplQueue.Queue)))
     && LruModel.__default.NextOpt#canCall(read($Heap, this, LruImpl.LruImplQueue.Queue));
  ensures Options.Option#Equal(x#0, 
    LruModel.__default.NextOpt(StartFuelAssert_LruModel._default.NextOpt, 
      read($Heap, this, LruImpl.LruImplQueue.Queue)));
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



procedure CheckWellformed$$LruImpl.LruImplQueue.DebugAccumulate(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap))
   returns (acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  free requires 17 == $FunctionContextHeight;
  modifies $Heap, $Tick;



procedure Call$$LruImpl.LruImplQueue.DebugAccumulate(this: ref
       where this != null
         && 
        $Is(this, Tclass.LruImpl.LruImplQueue())
         && $IsAlloc(this, Tclass.LruImpl.LruImplQueue(), $Heap))
   returns (acc#0: Seq Box
       where $Is(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()))
         && $IsAlloc(acc#0, TSeq(Tclass.DebugAccumulator.AccRec()), $Heap));
  // user-defined preconditions
  requires Lit(false);
  modifies $Heap, $Tick;
  // frame condition: object granularity
  free ensures (forall $o: ref :: 
    { $Heap[$o] } 
    $o != null && read(old($Heap), $o, alloc) ==> $Heap[$o] == old($Heap)[$o]);
  // boilerplate
  free ensures $HeapSucc(old($Heap), $Heap);



// LruImpl.LruImplQueue: subset type $Is
axiom (forall c#0: ref :: 
  { $Is(c#0, Tclass.LruImpl.LruImplQueue()) } 
  $Is(c#0, Tclass.LruImpl.LruImplQueue())
     <==> $Is(c#0, Tclass.LruImpl.LruImplQueue?()) && c#0 != null);

// LruImpl.LruImplQueue: subset type $IsAlloc
axiom (forall c#0: ref, $h: Heap :: 
  { $IsAlloc(c#0, Tclass.LruImpl.LruImplQueue(), $h) } 
  $IsAlloc(c#0, Tclass.LruImpl.LruImplQueue(), $h)
     <==> $IsAlloc(c#0, Tclass.LruImpl.LruImplQueue?(), $h));

const unique class.LruImpl.__default: ClassName;

function Tclass.LruImpl.__default() : Ty;

// Tclass.LruImpl.__default Tag
axiom Tag(Tclass.LruImpl.__default()) == Tagclass.LruImpl.__default;

const unique Tagclass.LruImpl.__default: TyTag;

// Box/unbox axiom for Tclass.LruImpl.__default
axiom (forall bx: Box :: 
  { $IsBox(bx, Tclass.LruImpl.__default()) } 
  $IsBox(bx, Tclass.LruImpl.__default())
     ==> $Box($Unbox(bx): ref) == bx && $Is($Unbox(bx): ref, Tclass.LruImpl.__default()));

// _default: Class $Is
axiom (forall $o: ref :: 
  { $Is($o, Tclass.LruImpl.__default()) } 
  $Is($o, Tclass.LruImpl.__default())
     <==> $o == null || dtype($o) == Tclass.LruImpl.__default());

// _default: Class $IsAlloc
axiom (forall $o: ref, $h: Heap :: 
  { $IsAlloc($o, Tclass.LruImpl.__default(), $h) } 
  $IsAlloc($o, Tclass.LruImpl.__default(), $h)
     <==> $o == null || read($h, $o, alloc));

const unique field$t: NameFamily;

const unique field$garbageQueue: NameFamily;

const unique field$refUpperBound: NameFamily;

const unique field$findLoclessIterator: NameFamily;

const unique field$Repr: NameFamily;

const unique field$Count: NameFamily;

const unique field$Queue: NameFamily;

const unique field$key: NameFamily;

const unique field$count: NameFamily;

const unique field$unit: NameFamily;

const unique field$index: NameFamily;

const unique field$Storage: NameFamily;

const unique field$Contents: NameFamily;

const unique field$Underlying: NameFamily;

const unique field$bits: NameFamily;

const unique field$nstrings: NameFamily;

const unique field$offsets: NameFamily;

const unique field$data: NameFamily;

const unique field$prev: NameFamily;

const unique field$next: NameFamily;

const unique field$value: NameFamily;

const unique field$nodemap: NameFamily;

const unique field$head_node: NameFamily;

const unique field$tail_node: NameFamily;
